'use strict';

var React = require('react');
var styled$3 = require('@emotion/styled');
var react = require('@emotion/react');
var libCommon = require('@revved/lib-common');
var ReactDOM = require('react-dom');
var material = require('@mui/material');
var draftJs = require('draft-js');
var draftJsExportMarkdown = require('draft-js-export-markdown');
var draftJsImportMarkdown = require('draft-js-import-markdown');
var reactDraftWysiwyg = require('react-draft-wysiwyg');
var ReactPlayer = require('react-player');
var reactPdf = require('react-pdf');
var reactRouterDom = require('react-router-dom');
var notistack = require('notistack');
var uuid = require('uuid');
var queryString = require('query-string');
var isPropValid = require('@emotion/is-prop-valid');
var AutoSizer = require('react-virtualized-auto-sizer');
var reactWindow = require('react-window');
var yup = require('yup');
var resolvers = require('@hookform/resolvers');
var reactHookForm = require('react-hook-form');
var urlRegex = require('url-regex-safe');
require('yup-phone-lite');
var Measure = require('react-measure');
var SignatureCanvasOg = require('react-signature-canvas');
var reactBeautifulDnd = require('react-beautiful-dnd');
var AutosizeInput = require('react-input-autosize');
var ReactMarkdown = require('react-markdown');
var remarkBreaks = require('remark-breaks');
var remarkGfm = require('remark-gfm');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespace(React);
var styled__default = /*#__PURE__*/_interopDefault(styled$3);
var ReactDOM__namespace = /*#__PURE__*/_interopNamespace(ReactDOM);
var ReactPlayer__default = /*#__PURE__*/_interopDefault(ReactPlayer);
var queryString__default = /*#__PURE__*/_interopDefault(queryString);
var isPropValid__default = /*#__PURE__*/_interopDefault(isPropValid);
var AutoSizer__default = /*#__PURE__*/_interopDefault(AutoSizer);
var yup__namespace = /*#__PURE__*/_interopNamespace(yup);
var urlRegex__default = /*#__PURE__*/_interopDefault(urlRegex);
var Measure__default = /*#__PURE__*/_interopDefault(Measure);
var SignatureCanvasOg__default = /*#__PURE__*/_interopDefault(SignatureCanvasOg);
var AutosizeInput__default = /*#__PURE__*/_interopDefault(AutosizeInput);
var ReactMarkdown__default = /*#__PURE__*/_interopDefault(ReactMarkdown);
var remarkBreaks__default = /*#__PURE__*/_interopDefault(remarkBreaks);
var remarkGfm__default = /*#__PURE__*/_interopDefault(remarkGfm);

function _iterableToArrayLimit(arr, i) {
  var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
  if (null != _i) {
    var _s,
      _e,
      _x,
      _r,
      _arr = [],
      _n = !0,
      _d = !1;
    try {
      if (_x = (_i = _i.call(arr)).next, 0 === i) {
        if (Object(_i) !== _i) return;
        _n = !1;
      } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0);
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return;
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}
function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return exports;
  };
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    defineProperty = Object.defineProperty || function (obj, key, desc) {
      obj[key] = desc.value;
    },
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return defineProperty(generator, "_invoke", {
      value: makeInvokeMethod(innerFn, self, context)
    }), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    defineProperty(this, "_invoke", {
      value: function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(innerFn, self, context) {
    var state = "suspendedStart";
    return function (method, arg) {
      if ("executing" === state) throw new Error("Generator is already running");
      if ("completed" === state) {
        if ("throw" === method) throw arg;
        return doneResult();
      }
      for (context.method = method, context.arg = arg;;) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }
        if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
          if ("suspendedStart" === state) throw state = "completed", context.arg;
          context.dispatchException(context.arg);
        } else "return" === context.method && context.abrupt("return", context.arg);
        state = "executing";
        var record = tryCatch(innerFn, self, context);
        if ("normal" === record.type) {
          if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
          return {
            value: record.arg,
            done: context.done
          };
        }
        "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
      }
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var methodName = context.method,
      method = delegate.iterator[methodName];
    if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), defineProperty(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (val) {
    var object = Object(val),
      keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _extends$2() {
  _extends$2 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$2.apply(this, arguments);
}
function _objectDestructuringEmpty(obj) {
  if (obj == null) throw new TypeError("Cannot destructure " + obj);
}
function _objectWithoutPropertiesLoose$1(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}
function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};
  var target = _objectWithoutPropertiesLoose$1(source, excluded);
  var key, i;
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }
  return target;
}
function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _toPrimitive(input, hint) {
  if (typeof input !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}

var global$1 = (typeof global !== "undefined" ? global :
  typeof self !== "undefined" ? self :
  typeof window !== "undefined" ? window : {});

// shim for using process in browser
// based off https://github.com/defunctzombie/node-process/blob/master/browser.js

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
var cachedSetTimeout = defaultSetTimout;
var cachedClearTimeout = defaultClearTimeout;
if (typeof global$1.setTimeout === 'function') {
    cachedSetTimeout = setTimeout;
}
if (typeof global$1.clearTimeout === 'function') {
    cachedClearTimeout = clearTimeout;
}

function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}
function nextTick(fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
}
// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
var title = 'browser';
var platform = 'browser';
var browser = true;
var env = {};
var argv = [];
var version = ''; // empty string to avoid regexp issues
var versions = {};
var release = {};
var config$1 = {};

function noop$2() {}

var on = noop$2;
var addListener = noop$2;
var once = noop$2;
var off = noop$2;
var removeListener = noop$2;
var removeAllListeners = noop$2;
var emit = noop$2;

function binding(name) {
    throw new Error('process.binding is not supported');
}

function cwd () { return '/' }
function chdir (dir) {
    throw new Error('process.chdir is not supported');
}function umask() { return 0; }

// from https://github.com/kumavis/browser-process-hrtime/blob/master/index.js
var performance$1 = global$1.performance || {};
var performanceNow =
  performance$1.now        ||
  performance$1.mozNow     ||
  performance$1.msNow      ||
  performance$1.oNow       ||
  performance$1.webkitNow  ||
  function(){ return (new Date()).getTime() };

// generate timestamp or delta
// see http://nodejs.org/api/process.html#process_process_hrtime
function hrtime(previousTimestamp){
  var clocktime = performanceNow.call(performance$1)*1e-3;
  var seconds = Math.floor(clocktime);
  var nanoseconds = Math.floor((clocktime%1)*1e9);
  if (previousTimestamp) {
    seconds = seconds - previousTimestamp[0];
    nanoseconds = nanoseconds - previousTimestamp[1];
    if (nanoseconds<0) {
      seconds--;
      nanoseconds += 1e9;
    }
  }
  return [seconds,nanoseconds]
}

var startTime = new Date();
function uptime() {
  var currentTime = new Date();
  var dif = currentTime - startTime;
  return dif / 1000;
}

var browser$1 = {
  nextTick: nextTick,
  title: title,
  browser: browser,
  env: env,
  argv: argv,
  version: version,
  versions: versions,
  on: on,
  addListener: addListener,
  once: once,
  off: off,
  removeListener: removeListener,
  removeAllListeners: removeAllListeners,
  emit: emit,
  binding: binding,
  cwd: cwd,
  chdir: chdir,
  umask: umask,
  hrtime: hrtime,
  platform: platform,
  release: release,
  config: config$1,
  uptime: uptime
};

function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var f = n.default;
	if (typeof f == "function") {
		var a = function a () {
			if (this instanceof a) {
				var args = [null];
				args.push.apply(args, arguments);
				var Ctor = Function.bind.apply(f, args);
				return new Ctor();
			}
			return f.apply(this, arguments);
		};
		a.prototype = f.prototype;
  } else a = {};
  Object.defineProperty(a, '__esModule', {value: true});
	Object.keys(n).forEach(function (k) {
		var d = Object.getOwnPropertyDescriptor(n, k);
		Object.defineProperty(a, k, d.get ? d : {
			enumerable: true,
			get: function () {
				return n[k];
			}
		});
	});
	return a;
}

var propTypesExports = {};
var propTypes = {
  get exports(){ return propTypesExports; },
  set exports(v){ propTypesExports = v; },
};

var reactIsExports$1 = {};
var reactIs$1 = {
  get exports(){ return reactIsExports$1; },
  set exports(v){ reactIsExports$1 = v; },
};

var reactIs_production_min$1 = {};

/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredReactIs_production_min$1;

function requireReactIs_production_min$1 () {
	if (hasRequiredReactIs_production_min$1) return reactIs_production_min$1;
	hasRequiredReactIs_production_min$1 = 1;
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
	Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
	function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}reactIs_production_min$1.AsyncMode=l;reactIs_production_min$1.ConcurrentMode=m;reactIs_production_min$1.ContextConsumer=k;reactIs_production_min$1.ContextProvider=h;reactIs_production_min$1.Element=c;reactIs_production_min$1.ForwardRef=n;reactIs_production_min$1.Fragment=e;reactIs_production_min$1.Lazy=t;reactIs_production_min$1.Memo=r;reactIs_production_min$1.Portal=d;
	reactIs_production_min$1.Profiler=g;reactIs_production_min$1.StrictMode=f;reactIs_production_min$1.Suspense=p;reactIs_production_min$1.isAsyncMode=function(a){return A(a)||z(a)===l};reactIs_production_min$1.isConcurrentMode=A;reactIs_production_min$1.isContextConsumer=function(a){return z(a)===k};reactIs_production_min$1.isContextProvider=function(a){return z(a)===h};reactIs_production_min$1.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};reactIs_production_min$1.isForwardRef=function(a){return z(a)===n};reactIs_production_min$1.isFragment=function(a){return z(a)===e};reactIs_production_min$1.isLazy=function(a){return z(a)===t};
	reactIs_production_min$1.isMemo=function(a){return z(a)===r};reactIs_production_min$1.isPortal=function(a){return z(a)===d};reactIs_production_min$1.isProfiler=function(a){return z(a)===g};reactIs_production_min$1.isStrictMode=function(a){return z(a)===f};reactIs_production_min$1.isSuspense=function(a){return z(a)===p};
	reactIs_production_min$1.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};reactIs_production_min$1.typeOf=z;
	return reactIs_production_min$1;
}

var reactIs_development$1 = {};

var hasRequiredReactIs_development$1;

function requireReactIs_development$1 () {
	if (hasRequiredReactIs_development$1) return reactIs_development$1;
	hasRequiredReactIs_development$1 = 1;



	if (browser$1.env.NODE_ENV !== "production") {
	  (function() {

	// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
	// nor polyfill, then a plain number is used for performance.
	var hasSymbol = typeof Symbol === 'function' && Symbol.for;
	var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
	var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
	var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
	var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
	var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
	var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
	var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
	// (unstable) APIs that have been removed. Can we remove the symbols?

	var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
	var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
	var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
	var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
	var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
	var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
	var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
	var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
	var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
	var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
	var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

	function isValidElementType(type) {
	  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
	  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
	}

	function typeOf(object) {
	  if (typeof object === 'object' && object !== null) {
	    var $$typeof = object.$$typeof;

	    switch ($$typeof) {
	      case REACT_ELEMENT_TYPE:
	        var type = object.type;

	        switch (type) {
	          case REACT_ASYNC_MODE_TYPE:
	          case REACT_CONCURRENT_MODE_TYPE:
	          case REACT_FRAGMENT_TYPE:
	          case REACT_PROFILER_TYPE:
	          case REACT_STRICT_MODE_TYPE:
	          case REACT_SUSPENSE_TYPE:
	            return type;

	          default:
	            var $$typeofType = type && type.$$typeof;

	            switch ($$typeofType) {
	              case REACT_CONTEXT_TYPE:
	              case REACT_FORWARD_REF_TYPE:
	              case REACT_LAZY_TYPE:
	              case REACT_MEMO_TYPE:
	              case REACT_PROVIDER_TYPE:
	                return $$typeofType;

	              default:
	                return $$typeof;
	            }

	        }

	      case REACT_PORTAL_TYPE:
	        return $$typeof;
	    }
	  }

	  return undefined;
	} // AsyncMode is deprecated along with isAsyncMode

	var AsyncMode = REACT_ASYNC_MODE_TYPE;
	var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
	var ContextConsumer = REACT_CONTEXT_TYPE;
	var ContextProvider = REACT_PROVIDER_TYPE;
	var Element = REACT_ELEMENT_TYPE;
	var ForwardRef = REACT_FORWARD_REF_TYPE;
	var Fragment = REACT_FRAGMENT_TYPE;
	var Lazy = REACT_LAZY_TYPE;
	var Memo = REACT_MEMO_TYPE;
	var Portal = REACT_PORTAL_TYPE;
	var Profiler = REACT_PROFILER_TYPE;
	var StrictMode = REACT_STRICT_MODE_TYPE;
	var Suspense = REACT_SUSPENSE_TYPE;
	var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

	function isAsyncMode(object) {
	  {
	    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
	      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

	      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
	    }
	  }

	  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
	}
	function isConcurrentMode(object) {
	  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
	}
	function isContextConsumer(object) {
	  return typeOf(object) === REACT_CONTEXT_TYPE;
	}
	function isContextProvider(object) {
	  return typeOf(object) === REACT_PROVIDER_TYPE;
	}
	function isElement(object) {
	  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
	}
	function isForwardRef(object) {
	  return typeOf(object) === REACT_FORWARD_REF_TYPE;
	}
	function isFragment(object) {
	  return typeOf(object) === REACT_FRAGMENT_TYPE;
	}
	function isLazy(object) {
	  return typeOf(object) === REACT_LAZY_TYPE;
	}
	function isMemo(object) {
	  return typeOf(object) === REACT_MEMO_TYPE;
	}
	function isPortal(object) {
	  return typeOf(object) === REACT_PORTAL_TYPE;
	}
	function isProfiler(object) {
	  return typeOf(object) === REACT_PROFILER_TYPE;
	}
	function isStrictMode(object) {
	  return typeOf(object) === REACT_STRICT_MODE_TYPE;
	}
	function isSuspense(object) {
	  return typeOf(object) === REACT_SUSPENSE_TYPE;
	}

	reactIs_development$1.AsyncMode = AsyncMode;
	reactIs_development$1.ConcurrentMode = ConcurrentMode;
	reactIs_development$1.ContextConsumer = ContextConsumer;
	reactIs_development$1.ContextProvider = ContextProvider;
	reactIs_development$1.Element = Element;
	reactIs_development$1.ForwardRef = ForwardRef;
	reactIs_development$1.Fragment = Fragment;
	reactIs_development$1.Lazy = Lazy;
	reactIs_development$1.Memo = Memo;
	reactIs_development$1.Portal = Portal;
	reactIs_development$1.Profiler = Profiler;
	reactIs_development$1.StrictMode = StrictMode;
	reactIs_development$1.Suspense = Suspense;
	reactIs_development$1.isAsyncMode = isAsyncMode;
	reactIs_development$1.isConcurrentMode = isConcurrentMode;
	reactIs_development$1.isContextConsumer = isContextConsumer;
	reactIs_development$1.isContextProvider = isContextProvider;
	reactIs_development$1.isElement = isElement;
	reactIs_development$1.isForwardRef = isForwardRef;
	reactIs_development$1.isFragment = isFragment;
	reactIs_development$1.isLazy = isLazy;
	reactIs_development$1.isMemo = isMemo;
	reactIs_development$1.isPortal = isPortal;
	reactIs_development$1.isProfiler = isProfiler;
	reactIs_development$1.isStrictMode = isStrictMode;
	reactIs_development$1.isSuspense = isSuspense;
	reactIs_development$1.isValidElementType = isValidElementType;
	reactIs_development$1.typeOf = typeOf;
	  })();
	}
	return reactIs_development$1;
}

var hasRequiredReactIs;

function requireReactIs () {
	if (hasRequiredReactIs) return reactIsExports$1;
	hasRequiredReactIs = 1;
	(function (module) {

		if (browser$1.env.NODE_ENV === 'production') {
		  module.exports = requireReactIs_production_min$1();
		} else {
		  module.exports = requireReactIs_development$1();
		}
} (reactIs$1));
	return reactIsExports$1;
}

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/

var objectAssign;
var hasRequiredObjectAssign;

function requireObjectAssign () {
	if (hasRequiredObjectAssign) return objectAssign;
	hasRequiredObjectAssign = 1;
	/* eslint-disable no-unused-vars */
	var getOwnPropertySymbols = Object.getOwnPropertySymbols;
	var hasOwnProperty = Object.prototype.hasOwnProperty;
	var propIsEnumerable = Object.prototype.propertyIsEnumerable;

	function toObject(val) {
		if (val === null || val === undefined) {
			throw new TypeError('Object.assign cannot be called with null or undefined');
		}

		return Object(val);
	}

	function shouldUseNative() {
		try {
			if (!Object.assign) {
				return false;
			}

			// Detect buggy property enumeration order in older V8 versions.

			// https://bugs.chromium.org/p/v8/issues/detail?id=4118
			var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
			test1[5] = 'de';
			if (Object.getOwnPropertyNames(test1)[0] === '5') {
				return false;
			}

			// https://bugs.chromium.org/p/v8/issues/detail?id=3056
			var test2 = {};
			for (var i = 0; i < 10; i++) {
				test2['_' + String.fromCharCode(i)] = i;
			}
			var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
				return test2[n];
			});
			if (order2.join('') !== '0123456789') {
				return false;
			}

			// https://bugs.chromium.org/p/v8/issues/detail?id=3056
			var test3 = {};
			'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
				test3[letter] = letter;
			});
			if (Object.keys(Object.assign({}, test3)).join('') !==
					'abcdefghijklmnopqrst') {
				return false;
			}

			return true;
		} catch (err) {
			// We don't expect any of the above to throw, but better to be safe.
			return false;
		}
	}

	objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
		var from;
		var to = toObject(target);
		var symbols;

		for (var s = 1; s < arguments.length; s++) {
			from = Object(arguments[s]);

			for (var key in from) {
				if (hasOwnProperty.call(from, key)) {
					to[key] = from[key];
				}
			}

			if (getOwnPropertySymbols) {
				symbols = getOwnPropertySymbols(from);
				for (var i = 0; i < symbols.length; i++) {
					if (propIsEnumerable.call(from, symbols[i])) {
						to[symbols[i]] = from[symbols[i]];
					}
				}
			}
		}

		return to;
	};
	return objectAssign;
}

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret_1;
var hasRequiredReactPropTypesSecret;

function requireReactPropTypesSecret () {
	if (hasRequiredReactPropTypesSecret) return ReactPropTypesSecret_1;
	hasRequiredReactPropTypesSecret = 1;

	var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

	ReactPropTypesSecret_1 = ReactPropTypesSecret;
	return ReactPropTypesSecret_1;
}

var has;
var hasRequiredHas;

function requireHas () {
	if (hasRequiredHas) return has;
	hasRequiredHas = 1;
	has = Function.call.bind(Object.prototype.hasOwnProperty);
	return has;
}

var checkPropTypes_1;
var hasRequiredCheckPropTypes;

function requireCheckPropTypes () {
	if (hasRequiredCheckPropTypes) return checkPropTypes_1;
	hasRequiredCheckPropTypes = 1;

	var printWarning = function() {};

	if (browser$1.env.NODE_ENV !== 'production') {
	  var ReactPropTypesSecret = requireReactPropTypesSecret();
	  var loggedTypeFailures = {};
	  var has = requireHas();

	  printWarning = function(text) {
	    var message = 'Warning: ' + text;
	    if (typeof console !== 'undefined') {
	      console.error(message);
	    }
	    try {
	      // --- Welcome to debugging React ---
	      // This error was thrown as a convenience so that you can use this stack
	      // to find the callsite that caused this warning to fire.
	      throw new Error(message);
	    } catch (x) { /**/ }
	  };
	}

	/**
	 * Assert that the values match with the type specs.
	 * Error messages are memorized and will only be shown once.
	 *
	 * @param {object} typeSpecs Map of name to a ReactPropType
	 * @param {object} values Runtime values that need to be type-checked
	 * @param {string} location e.g. "prop", "context", "child context"
	 * @param {string} componentName Name of the component for error messages.
	 * @param {?Function} getStack Returns the component stack.
	 * @private
	 */
	function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
	  if (browser$1.env.NODE_ENV !== 'production') {
	    for (var typeSpecName in typeSpecs) {
	      if (has(typeSpecs, typeSpecName)) {
	        var error;
	        // Prop type validation may throw. In case they do, we don't want to
	        // fail the render phase where it didn't fail before. So we log it.
	        // After these have been cleaned up, we'll let them throw.
	        try {
	          // This is intentionally an invariant that gets caught. It's the same
	          // behavior as without this statement except with a better message.
	          if (typeof typeSpecs[typeSpecName] !== 'function') {
	            var err = Error(
	              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
	              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.' +
	              'This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.'
	            );
	            err.name = 'Invariant Violation';
	            throw err;
	          }
	          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret);
	        } catch (ex) {
	          error = ex;
	        }
	        if (error && !(error instanceof Error)) {
	          printWarning(
	            (componentName || 'React class') + ': type specification of ' +
	            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
	            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
	            'You may have forgotten to pass an argument to the type checker ' +
	            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
	            'shape all require an argument).'
	          );
	        }
	        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
	          // Only monitor this failure once because there tends to be a lot of the
	          // same error.
	          loggedTypeFailures[error.message] = true;

	          var stack = getStack ? getStack() : '';

	          printWarning(
	            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
	          );
	        }
	      }
	    }
	  }
	}

	/**
	 * Resets warning cache when testing.
	 *
	 * @private
	 */
	checkPropTypes.resetWarningCache = function() {
	  if (browser$1.env.NODE_ENV !== 'production') {
	    loggedTypeFailures = {};
	  }
	};

	checkPropTypes_1 = checkPropTypes;
	return checkPropTypes_1;
}

var factoryWithTypeCheckers;
var hasRequiredFactoryWithTypeCheckers;

function requireFactoryWithTypeCheckers () {
	if (hasRequiredFactoryWithTypeCheckers) return factoryWithTypeCheckers;
	hasRequiredFactoryWithTypeCheckers = 1;

	var ReactIs = requireReactIs();
	var assign = requireObjectAssign();

	var ReactPropTypesSecret = requireReactPropTypesSecret();
	var has = requireHas();
	var checkPropTypes = requireCheckPropTypes();

	var printWarning = function() {};

	if (browser$1.env.NODE_ENV !== 'production') {
	  printWarning = function(text) {
	    var message = 'Warning: ' + text;
	    if (typeof console !== 'undefined') {
	      console.error(message);
	    }
	    try {
	      // --- Welcome to debugging React ---
	      // This error was thrown as a convenience so that you can use this stack
	      // to find the callsite that caused this warning to fire.
	      throw new Error(message);
	    } catch (x) {}
	  };
	}

	function emptyFunctionThatReturnsNull() {
	  return null;
	}

	factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
	  /* global Symbol */
	  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
	  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

	  /**
	   * Returns the iterator method function contained on the iterable object.
	   *
	   * Be sure to invoke the function with the iterable as context:
	   *
	   *     var iteratorFn = getIteratorFn(myIterable);
	   *     if (iteratorFn) {
	   *       var iterator = iteratorFn.call(myIterable);
	   *       ...
	   *     }
	   *
	   * @param {?object} maybeIterable
	   * @return {?function}
	   */
	  function getIteratorFn(maybeIterable) {
	    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
	    if (typeof iteratorFn === 'function') {
	      return iteratorFn;
	    }
	  }

	  /**
	   * Collection of methods that allow declaration and validation of props that are
	   * supplied to React components. Example usage:
	   *
	   *   var Props = require('ReactPropTypes');
	   *   var MyArticle = React.createClass({
	   *     propTypes: {
	   *       // An optional string prop named "description".
	   *       description: Props.string,
	   *
	   *       // A required enum prop named "category".
	   *       category: Props.oneOf(['News','Photos']).isRequired,
	   *
	   *       // A prop named "dialog" that requires an instance of Dialog.
	   *       dialog: Props.instanceOf(Dialog).isRequired
	   *     },
	   *     render: function() { ... }
	   *   });
	   *
	   * A more formal specification of how these methods are used:
	   *
	   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
	   *   decl := ReactPropTypes.{type}(.isRequired)?
	   *
	   * Each and every declaration produces a function with the same signature. This
	   * allows the creation of custom validation functions. For example:
	   *
	   *  var MyLink = React.createClass({
	   *    propTypes: {
	   *      // An optional string or URI prop named "href".
	   *      href: function(props, propName, componentName) {
	   *        var propValue = props[propName];
	   *        if (propValue != null && typeof propValue !== 'string' &&
	   *            !(propValue instanceof URI)) {
	   *          return new Error(
	   *            'Expected a string or an URI for ' + propName + ' in ' +
	   *            componentName
	   *          );
	   *        }
	   *      }
	   *    },
	   *    render: function() {...}
	   *  });
	   *
	   * @internal
	   */

	  var ANONYMOUS = '<<anonymous>>';

	  // Important!
	  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
	  var ReactPropTypes = {
	    array: createPrimitiveTypeChecker('array'),
	    bigint: createPrimitiveTypeChecker('bigint'),
	    bool: createPrimitiveTypeChecker('boolean'),
	    func: createPrimitiveTypeChecker('function'),
	    number: createPrimitiveTypeChecker('number'),
	    object: createPrimitiveTypeChecker('object'),
	    string: createPrimitiveTypeChecker('string'),
	    symbol: createPrimitiveTypeChecker('symbol'),

	    any: createAnyTypeChecker(),
	    arrayOf: createArrayOfTypeChecker,
	    element: createElementTypeChecker(),
	    elementType: createElementTypeTypeChecker(),
	    instanceOf: createInstanceTypeChecker,
	    node: createNodeChecker(),
	    objectOf: createObjectOfTypeChecker,
	    oneOf: createEnumTypeChecker,
	    oneOfType: createUnionTypeChecker,
	    shape: createShapeTypeChecker,
	    exact: createStrictShapeTypeChecker,
	  };

	  /**
	   * inlined Object.is polyfill to avoid requiring consumers ship their own
	   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
	   */
	  /*eslint-disable no-self-compare*/
	  function is(x, y) {
	    // SameValue algorithm
	    if (x === y) {
	      // Steps 1-5, 7-10
	      // Steps 6.b-6.e: +0 != -0
	      return x !== 0 || 1 / x === 1 / y;
	    } else {
	      // Step 6.a: NaN == NaN
	      return x !== x && y !== y;
	    }
	  }
	  /*eslint-enable no-self-compare*/

	  /**
	   * We use an Error-like object for backward compatibility as people may call
	   * PropTypes directly and inspect their output. However, we don't use real
	   * Errors anymore. We don't inspect their stack anyway, and creating them
	   * is prohibitively expensive if they are created too often, such as what
	   * happens in oneOfType() for any type before the one that matched.
	   */
	  function PropTypeError(message, data) {
	    this.message = message;
	    this.data = data && typeof data === 'object' ? data: {};
	    this.stack = '';
	  }
	  // Make `instanceof Error` still work for returned errors.
	  PropTypeError.prototype = Error.prototype;

	  function createChainableTypeChecker(validate) {
	    if (browser$1.env.NODE_ENV !== 'production') {
	      var manualPropTypeCallCache = {};
	      var manualPropTypeWarningCount = 0;
	    }
	    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
	      componentName = componentName || ANONYMOUS;
	      propFullName = propFullName || propName;

	      if (secret !== ReactPropTypesSecret) {
	        if (throwOnDirectAccess) {
	          // New behavior only for users of `prop-types` package
	          var err = new Error(
	            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
	            'Use `PropTypes.checkPropTypes()` to call them. ' +
	            'Read more at http://fb.me/use-check-prop-types'
	          );
	          err.name = 'Invariant Violation';
	          throw err;
	        } else if (browser$1.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
	          // Old behavior for people using React.PropTypes
	          var cacheKey = componentName + ':' + propName;
	          if (
	            !manualPropTypeCallCache[cacheKey] &&
	            // Avoid spamming the console because they are often not actionable except for lib authors
	            manualPropTypeWarningCount < 3
	          ) {
	            printWarning(
	              'You are manually calling a React.PropTypes validation ' +
	              'function for the `' + propFullName + '` prop on `' + componentName + '`. This is deprecated ' +
	              'and will throw in the standalone `prop-types` package. ' +
	              'You may be seeing this warning due to a third-party PropTypes ' +
	              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
	            );
	            manualPropTypeCallCache[cacheKey] = true;
	            manualPropTypeWarningCount++;
	          }
	        }
	      }
	      if (props[propName] == null) {
	        if (isRequired) {
	          if (props[propName] === null) {
	            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
	          }
	          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
	        }
	        return null;
	      } else {
	        return validate(props, propName, componentName, location, propFullName);
	      }
	    }

	    var chainedCheckType = checkType.bind(null, false);
	    chainedCheckType.isRequired = checkType.bind(null, true);

	    return chainedCheckType;
	  }

	  function createPrimitiveTypeChecker(expectedType) {
	    function validate(props, propName, componentName, location, propFullName, secret) {
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== expectedType) {
	        // `propValue` being instance of, say, date/regexp, pass the 'object'
	        // check, but we can offer a more precise error message here rather than
	        // 'of type `object`'.
	        var preciseType = getPreciseType(propValue);

	        return new PropTypeError(
	          'Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'),
	          {expectedType: expectedType}
	        );
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createAnyTypeChecker() {
	    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
	  }

	  function createArrayOfTypeChecker(typeChecker) {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (typeof typeChecker !== 'function') {
	        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
	      }
	      var propValue = props[propName];
	      if (!Array.isArray(propValue)) {
	        var propType = getPropType(propValue);
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
	      }
	      for (var i = 0; i < propValue.length; i++) {
	        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret);
	        if (error instanceof Error) {
	          return error;
	        }
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createElementTypeChecker() {
	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      if (!isValidElement(propValue)) {
	        var propType = getPropType(propValue);
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createElementTypeTypeChecker() {
	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      if (!ReactIs.isValidElementType(propValue)) {
	        var propType = getPropType(propValue);
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createInstanceTypeChecker(expectedClass) {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (!(props[propName] instanceof expectedClass)) {
	        var expectedClassName = expectedClass.name || ANONYMOUS;
	        var actualClassName = getClassName(props[propName]);
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createEnumTypeChecker(expectedValues) {
	    if (!Array.isArray(expectedValues)) {
	      if (browser$1.env.NODE_ENV !== 'production') {
	        if (arguments.length > 1) {
	          printWarning(
	            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
	            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
	          );
	        } else {
	          printWarning('Invalid argument supplied to oneOf, expected an array.');
	        }
	      }
	      return emptyFunctionThatReturnsNull;
	    }

	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      for (var i = 0; i < expectedValues.length; i++) {
	        if (is(propValue, expectedValues[i])) {
	          return null;
	        }
	      }

	      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
	        var type = getPreciseType(value);
	        if (type === 'symbol') {
	          return String(value);
	        }
	        return value;
	      });
	      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createObjectOfTypeChecker(typeChecker) {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (typeof typeChecker !== 'function') {
	        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
	      }
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== 'object') {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
	      }
	      for (var key in propValue) {
	        if (has(propValue, key)) {
	          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
	          if (error instanceof Error) {
	            return error;
	          }
	        }
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createUnionTypeChecker(arrayOfTypeCheckers) {
	    if (!Array.isArray(arrayOfTypeCheckers)) {
	      browser$1.env.NODE_ENV !== 'production' ? printWarning('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
	      return emptyFunctionThatReturnsNull;
	    }

	    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
	      var checker = arrayOfTypeCheckers[i];
	      if (typeof checker !== 'function') {
	        printWarning(
	          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
	          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
	        );
	        return emptyFunctionThatReturnsNull;
	      }
	    }

	    function validate(props, propName, componentName, location, propFullName) {
	      var expectedTypes = [];
	      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
	        var checker = arrayOfTypeCheckers[i];
	        var checkerResult = checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret);
	        if (checkerResult == null) {
	          return null;
	        }
	        if (checkerResult.data && has(checkerResult.data, 'expectedType')) {
	          expectedTypes.push(checkerResult.data.expectedType);
	        }
	      }
	      var expectedTypesMessage = (expectedTypes.length > 0) ? ', expected one of type [' + expectedTypes.join(', ') + ']': '';
	      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`' + expectedTypesMessage + '.'));
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createNodeChecker() {
	    function validate(props, propName, componentName, location, propFullName) {
	      if (!isNode(props[propName])) {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function invalidValidatorError(componentName, location, propFullName, key, type) {
	    return new PropTypeError(
	      (componentName || 'React class') + ': ' + location + ' type `' + propFullName + '.' + key + '` is invalid; ' +
	      'it must be a function, usually from the `prop-types` package, but received `' + type + '`.'
	    );
	  }

	  function createShapeTypeChecker(shapeTypes) {
	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== 'object') {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
	      }
	      for (var key in shapeTypes) {
	        var checker = shapeTypes[key];
	        if (typeof checker !== 'function') {
	          return invalidValidatorError(componentName, location, propFullName, key, getPreciseType(checker));
	        }
	        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
	        if (error) {
	          return error;
	        }
	      }
	      return null;
	    }
	    return createChainableTypeChecker(validate);
	  }

	  function createStrictShapeTypeChecker(shapeTypes) {
	    function validate(props, propName, componentName, location, propFullName) {
	      var propValue = props[propName];
	      var propType = getPropType(propValue);
	      if (propType !== 'object') {
	        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
	      }
	      // We need to check all keys in case some are required but missing from props.
	      var allKeys = assign({}, props[propName], shapeTypes);
	      for (var key in allKeys) {
	        var checker = shapeTypes[key];
	        if (has(shapeTypes, key) && typeof checker !== 'function') {
	          return invalidValidatorError(componentName, location, propFullName, key, getPreciseType(checker));
	        }
	        if (!checker) {
	          return new PropTypeError(
	            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
	            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
	            '\nValid keys: ' + JSON.stringify(Object.keys(shapeTypes), null, '  ')
	          );
	        }
	        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret);
	        if (error) {
	          return error;
	        }
	      }
	      return null;
	    }

	    return createChainableTypeChecker(validate);
	  }

	  function isNode(propValue) {
	    switch (typeof propValue) {
	      case 'number':
	      case 'string':
	      case 'undefined':
	        return true;
	      case 'boolean':
	        return !propValue;
	      case 'object':
	        if (Array.isArray(propValue)) {
	          return propValue.every(isNode);
	        }
	        if (propValue === null || isValidElement(propValue)) {
	          return true;
	        }

	        var iteratorFn = getIteratorFn(propValue);
	        if (iteratorFn) {
	          var iterator = iteratorFn.call(propValue);
	          var step;
	          if (iteratorFn !== propValue.entries) {
	            while (!(step = iterator.next()).done) {
	              if (!isNode(step.value)) {
	                return false;
	              }
	            }
	          } else {
	            // Iterator will provide entry [k,v] tuples rather than values.
	            while (!(step = iterator.next()).done) {
	              var entry = step.value;
	              if (entry) {
	                if (!isNode(entry[1])) {
	                  return false;
	                }
	              }
	            }
	          }
	        } else {
	          return false;
	        }

	        return true;
	      default:
	        return false;
	    }
	  }

	  function isSymbol(propType, propValue) {
	    // Native Symbol.
	    if (propType === 'symbol') {
	      return true;
	    }

	    // falsy value can't be a Symbol
	    if (!propValue) {
	      return false;
	    }

	    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
	    if (propValue['@@toStringTag'] === 'Symbol') {
	      return true;
	    }

	    // Fallback for non-spec compliant Symbols which are polyfilled.
	    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
	      return true;
	    }

	    return false;
	  }

	  // Equivalent of `typeof` but with special handling for array and regexp.
	  function getPropType(propValue) {
	    var propType = typeof propValue;
	    if (Array.isArray(propValue)) {
	      return 'array';
	    }
	    if (propValue instanceof RegExp) {
	      // Old webkits (at least until Android 4.0) return 'function' rather than
	      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
	      // passes PropTypes.object.
	      return 'object';
	    }
	    if (isSymbol(propType, propValue)) {
	      return 'symbol';
	    }
	    return propType;
	  }

	  // This handles more types than `getPropType`. Only used for error messages.
	  // See `createPrimitiveTypeChecker`.
	  function getPreciseType(propValue) {
	    if (typeof propValue === 'undefined' || propValue === null) {
	      return '' + propValue;
	    }
	    var propType = getPropType(propValue);
	    if (propType === 'object') {
	      if (propValue instanceof Date) {
	        return 'date';
	      } else if (propValue instanceof RegExp) {
	        return 'regexp';
	      }
	    }
	    return propType;
	  }

	  // Returns a string that is postfixed to a warning about an invalid type.
	  // For example, "undefined" or "of type array"
	  function getPostfixForTypeWarning(value) {
	    var type = getPreciseType(value);
	    switch (type) {
	      case 'array':
	      case 'object':
	        return 'an ' + type;
	      case 'boolean':
	      case 'date':
	      case 'regexp':
	        return 'a ' + type;
	      default:
	        return type;
	    }
	  }

	  // Returns class name of the object, if any.
	  function getClassName(propValue) {
	    if (!propValue.constructor || !propValue.constructor.name) {
	      return ANONYMOUS;
	    }
	    return propValue.constructor.name;
	  }

	  ReactPropTypes.checkPropTypes = checkPropTypes;
	  ReactPropTypes.resetWarningCache = checkPropTypes.resetWarningCache;
	  ReactPropTypes.PropTypes = ReactPropTypes;

	  return ReactPropTypes;
	};
	return factoryWithTypeCheckers;
}

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var factoryWithThrowingShims;
var hasRequiredFactoryWithThrowingShims;

function requireFactoryWithThrowingShims () {
	if (hasRequiredFactoryWithThrowingShims) return factoryWithThrowingShims;
	hasRequiredFactoryWithThrowingShims = 1;

	var ReactPropTypesSecret = requireReactPropTypesSecret();

	function emptyFunction() {}
	function emptyFunctionWithReset() {}
	emptyFunctionWithReset.resetWarningCache = emptyFunction;

	factoryWithThrowingShims = function() {
	  function shim(props, propName, componentName, location, propFullName, secret) {
	    if (secret === ReactPropTypesSecret) {
	      // It is still safe when called from React.
	      return;
	    }
	    var err = new Error(
	      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
	      'Use PropTypes.checkPropTypes() to call them. ' +
	      'Read more at http://fb.me/use-check-prop-types'
	    );
	    err.name = 'Invariant Violation';
	    throw err;
	  }	  shim.isRequired = shim;
	  function getShim() {
	    return shim;
	  }	  // Important!
	  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
	  var ReactPropTypes = {
	    array: shim,
	    bigint: shim,
	    bool: shim,
	    func: shim,
	    number: shim,
	    object: shim,
	    string: shim,
	    symbol: shim,

	    any: shim,
	    arrayOf: getShim,
	    element: shim,
	    elementType: shim,
	    instanceOf: getShim,
	    node: shim,
	    objectOf: getShim,
	    oneOf: getShim,
	    oneOfType: getShim,
	    shape: getShim,
	    exact: getShim,

	    checkPropTypes: emptyFunctionWithReset,
	    resetWarningCache: emptyFunction
	  };

	  ReactPropTypes.PropTypes = ReactPropTypes;

	  return ReactPropTypes;
	};
	return factoryWithThrowingShims;
}

if (browser$1.env.NODE_ENV !== 'production') {
  var ReactIs = requireReactIs();

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  propTypes.exports = requireFactoryWithTypeCheckers()(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  propTypes.exports = requireFactoryWithThrowingShims()();
}

function _extends$1() {
  _extends$1 = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends$1.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;
  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }
  return target;
}

var reactIsExports = {};
var reactIs = {
  get exports(){ return reactIsExports; },
  set exports(v){ reactIsExports = v; },
};

var reactIs_production_min = {};

/**
 * @license React
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredReactIs_production_min;

function requireReactIs_production_min () {
	if (hasRequiredReactIs_production_min) return reactIs_production_min;
	hasRequiredReactIs_production_min = 1;
var b=Symbol.for("react.element"),c=Symbol.for("react.portal"),d=Symbol.for("react.fragment"),e=Symbol.for("react.strict_mode"),f=Symbol.for("react.profiler"),g=Symbol.for("react.provider"),h=Symbol.for("react.context"),k=Symbol.for("react.server_context"),l=Symbol.for("react.forward_ref"),m=Symbol.for("react.suspense"),n=Symbol.for("react.suspense_list"),p=Symbol.for("react.memo"),q=Symbol.for("react.lazy"),t=Symbol.for("react.offscreen"),u;u=Symbol.for("react.module.reference");
	function v(a){if("object"===typeof a&&null!==a){var r=a.$$typeof;switch(r){case b:switch(a=a.type,a){case d:case f:case e:case m:case n:return a;default:switch(a=a&&a.$$typeof,a){case k:case h:case l:case q:case p:case g:return a;default:return r}}case c:return r}}}reactIs_production_min.ContextConsumer=h;reactIs_production_min.ContextProvider=g;reactIs_production_min.Element=b;reactIs_production_min.ForwardRef=l;reactIs_production_min.Fragment=d;reactIs_production_min.Lazy=q;reactIs_production_min.Memo=p;reactIs_production_min.Portal=c;reactIs_production_min.Profiler=f;reactIs_production_min.StrictMode=e;reactIs_production_min.Suspense=m;
	reactIs_production_min.SuspenseList=n;reactIs_production_min.isAsyncMode=function(){return !1};reactIs_production_min.isConcurrentMode=function(){return !1};reactIs_production_min.isContextConsumer=function(a){return v(a)===h};reactIs_production_min.isContextProvider=function(a){return v(a)===g};reactIs_production_min.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===b};reactIs_production_min.isForwardRef=function(a){return v(a)===l};reactIs_production_min.isFragment=function(a){return v(a)===d};reactIs_production_min.isLazy=function(a){return v(a)===q};reactIs_production_min.isMemo=function(a){return v(a)===p};
	reactIs_production_min.isPortal=function(a){return v(a)===c};reactIs_production_min.isProfiler=function(a){return v(a)===f};reactIs_production_min.isStrictMode=function(a){return v(a)===e};reactIs_production_min.isSuspense=function(a){return v(a)===m};reactIs_production_min.isSuspenseList=function(a){return v(a)===n};
	reactIs_production_min.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===d||a===f||a===e||a===m||a===n||a===t||"object"===typeof a&&null!==a&&(a.$$typeof===q||a.$$typeof===p||a.$$typeof===g||a.$$typeof===h||a.$$typeof===l||a.$$typeof===u||void 0!==a.getModuleId)?!0:!1};reactIs_production_min.typeOf=v;
	return reactIs_production_min;
}

var reactIs_development = {};

var hasRequiredReactIs_development;

function requireReactIs_development () {
	if (hasRequiredReactIs_development) return reactIs_development;
	hasRequiredReactIs_development = 1;

	if (browser$1.env.NODE_ENV !== "production") {
	  (function() {

	// ATTENTION
	// When adding new symbols to this file,
	// Please consider also adding to 'react-devtools-shared/src/backend/ReactSymbols'
	// The Symbol used to tag the ReactElement-like types.
	var REACT_ELEMENT_TYPE = Symbol.for('react.element');
	var REACT_PORTAL_TYPE = Symbol.for('react.portal');
	var REACT_FRAGMENT_TYPE = Symbol.for('react.fragment');
	var REACT_STRICT_MODE_TYPE = Symbol.for('react.strict_mode');
	var REACT_PROFILER_TYPE = Symbol.for('react.profiler');
	var REACT_PROVIDER_TYPE = Symbol.for('react.provider');
	var REACT_CONTEXT_TYPE = Symbol.for('react.context');
	var REACT_SERVER_CONTEXT_TYPE = Symbol.for('react.server_context');
	var REACT_FORWARD_REF_TYPE = Symbol.for('react.forward_ref');
	var REACT_SUSPENSE_TYPE = Symbol.for('react.suspense');
	var REACT_SUSPENSE_LIST_TYPE = Symbol.for('react.suspense_list');
	var REACT_MEMO_TYPE = Symbol.for('react.memo');
	var REACT_LAZY_TYPE = Symbol.for('react.lazy');
	var REACT_OFFSCREEN_TYPE = Symbol.for('react.offscreen');

	// -----------------------------------------------------------------------------

	var enableScopeAPI = false; // Experimental Create Event Handle API.
	var enableCacheElement = false;
	var enableTransitionTracing = false; // No known bugs, but needs performance testing

	var enableLegacyHidden = false; // Enables unstable_avoidThisFallback feature in Fiber
	// stuff. Intended to enable React core members to more easily debug scheduling
	// issues in DEV builds.

	var enableDebugTracing = false; // Track which Fiber(s) schedule render work.

	var REACT_MODULE_REFERENCE;

	{
	  REACT_MODULE_REFERENCE = Symbol.for('react.module.reference');
	}

	function isValidElementType(type) {
	  if (typeof type === 'string' || typeof type === 'function') {
	    return true;
	  } // Note: typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).


	  if (type === REACT_FRAGMENT_TYPE || type === REACT_PROFILER_TYPE || enableDebugTracing  || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || enableLegacyHidden  || type === REACT_OFFSCREEN_TYPE || enableScopeAPI  || enableCacheElement  || enableTransitionTracing ) {
	    return true;
	  }

	  if (typeof type === 'object' && type !== null) {
	    if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || // This needs to include all possible module reference object
	    // types supported by any Flight configuration anywhere since
	    // we don't know which Flight build this will end up being used
	    // with.
	    type.$$typeof === REACT_MODULE_REFERENCE || type.getModuleId !== undefined) {
	      return true;
	    }
	  }

	  return false;
	}

	function typeOf(object) {
	  if (typeof object === 'object' && object !== null) {
	    var $$typeof = object.$$typeof;

	    switch ($$typeof) {
	      case REACT_ELEMENT_TYPE:
	        var type = object.type;

	        switch (type) {
	          case REACT_FRAGMENT_TYPE:
	          case REACT_PROFILER_TYPE:
	          case REACT_STRICT_MODE_TYPE:
	          case REACT_SUSPENSE_TYPE:
	          case REACT_SUSPENSE_LIST_TYPE:
	            return type;

	          default:
	            var $$typeofType = type && type.$$typeof;

	            switch ($$typeofType) {
	              case REACT_SERVER_CONTEXT_TYPE:
	              case REACT_CONTEXT_TYPE:
	              case REACT_FORWARD_REF_TYPE:
	              case REACT_LAZY_TYPE:
	              case REACT_MEMO_TYPE:
	              case REACT_PROVIDER_TYPE:
	                return $$typeofType;

	              default:
	                return $$typeof;
	            }

	        }

	      case REACT_PORTAL_TYPE:
	        return $$typeof;
	    }
	  }

	  return undefined;
	}
	var ContextConsumer = REACT_CONTEXT_TYPE;
	var ContextProvider = REACT_PROVIDER_TYPE;
	var Element = REACT_ELEMENT_TYPE;
	var ForwardRef = REACT_FORWARD_REF_TYPE;
	var Fragment = REACT_FRAGMENT_TYPE;
	var Lazy = REACT_LAZY_TYPE;
	var Memo = REACT_MEMO_TYPE;
	var Portal = REACT_PORTAL_TYPE;
	var Profiler = REACT_PROFILER_TYPE;
	var StrictMode = REACT_STRICT_MODE_TYPE;
	var Suspense = REACT_SUSPENSE_TYPE;
	var SuspenseList = REACT_SUSPENSE_LIST_TYPE;
	var hasWarnedAboutDeprecatedIsAsyncMode = false;
	var hasWarnedAboutDeprecatedIsConcurrentMode = false; // AsyncMode should be deprecated

	function isAsyncMode(object) {
	  {
	    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
	      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

	      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 18+.');
	    }
	  }

	  return false;
	}
	function isConcurrentMode(object) {
	  {
	    if (!hasWarnedAboutDeprecatedIsConcurrentMode) {
	      hasWarnedAboutDeprecatedIsConcurrentMode = true; // Using console['warn'] to evade Babel and ESLint

	      console['warn']('The ReactIs.isConcurrentMode() alias has been deprecated, ' + 'and will be removed in React 18+.');
	    }
	  }

	  return false;
	}
	function isContextConsumer(object) {
	  return typeOf(object) === REACT_CONTEXT_TYPE;
	}
	function isContextProvider(object) {
	  return typeOf(object) === REACT_PROVIDER_TYPE;
	}
	function isElement(object) {
	  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
	}
	function isForwardRef(object) {
	  return typeOf(object) === REACT_FORWARD_REF_TYPE;
	}
	function isFragment(object) {
	  return typeOf(object) === REACT_FRAGMENT_TYPE;
	}
	function isLazy(object) {
	  return typeOf(object) === REACT_LAZY_TYPE;
	}
	function isMemo(object) {
	  return typeOf(object) === REACT_MEMO_TYPE;
	}
	function isPortal(object) {
	  return typeOf(object) === REACT_PORTAL_TYPE;
	}
	function isProfiler(object) {
	  return typeOf(object) === REACT_PROFILER_TYPE;
	}
	function isStrictMode(object) {
	  return typeOf(object) === REACT_STRICT_MODE_TYPE;
	}
	function isSuspense(object) {
	  return typeOf(object) === REACT_SUSPENSE_TYPE;
	}
	function isSuspenseList(object) {
	  return typeOf(object) === REACT_SUSPENSE_LIST_TYPE;
	}

	reactIs_development.ContextConsumer = ContextConsumer;
	reactIs_development.ContextProvider = ContextProvider;
	reactIs_development.Element = Element;
	reactIs_development.ForwardRef = ForwardRef;
	reactIs_development.Fragment = Fragment;
	reactIs_development.Lazy = Lazy;
	reactIs_development.Memo = Memo;
	reactIs_development.Portal = Portal;
	reactIs_development.Profiler = Profiler;
	reactIs_development.StrictMode = StrictMode;
	reactIs_development.Suspense = Suspense;
	reactIs_development.SuspenseList = SuspenseList;
	reactIs_development.isAsyncMode = isAsyncMode;
	reactIs_development.isConcurrentMode = isConcurrentMode;
	reactIs_development.isContextConsumer = isContextConsumer;
	reactIs_development.isContextProvider = isContextProvider;
	reactIs_development.isElement = isElement;
	reactIs_development.isForwardRef = isForwardRef;
	reactIs_development.isFragment = isFragment;
	reactIs_development.isLazy = isLazy;
	reactIs_development.isMemo = isMemo;
	reactIs_development.isPortal = isPortal;
	reactIs_development.isProfiler = isProfiler;
	reactIs_development.isStrictMode = isStrictMode;
	reactIs_development.isSuspense = isSuspense;
	reactIs_development.isSuspenseList = isSuspenseList;
	reactIs_development.isValidElementType = isValidElementType;
	reactIs_development.typeOf = typeOf;
	  })();
	}
	return reactIs_development;
}

(function (module) {

	if (browser$1.env.NODE_ENV === 'production') {
	  module.exports = requireReactIs_production_min();
	} else {
	  module.exports = requireReactIs_development();
	}
} (reactIs));

function chainPropTypes(propType1, propType2) {
  if (browser$1.env.NODE_ENV === 'production') {
    return () => null;
  }
  return function validate(...args) {
    return propType1(...args) || propType2(...args);
  };
}

function isPlainObject(item) {
  return item !== null && typeof item === 'object' && item.constructor === Object;
}
function deepClone(source) {
  if (!isPlainObject(source)) {
    return source;
  }
  const output = {};
  Object.keys(source).forEach(key => {
    output[key] = deepClone(source[key]);
  });
  return output;
}
function deepmerge(target, source, options = {
  clone: true
}) {
  const output = options.clone ? _extends$1({}, target) : target;
  if (isPlainObject(target) && isPlainObject(source)) {
    Object.keys(source).forEach(key => {
      // Avoid prototype pollution
      if (key === '__proto__') {
        return;
      }
      if (isPlainObject(source[key]) && key in target && isPlainObject(target[key])) {
        // Since `output` is a clone of `target` and we have narrowed `target` in this block we can cast to the same type.
        output[key] = deepmerge(target[key], source[key], options);
      } else if (options.clone) {
        output[key] = isPlainObject(source[key]) ? deepClone(source[key]) : source[key];
      } else {
        output[key] = source[key];
      }
    });
  }
  return output;
}

function isClassComponent$1(elementType) {
  // elementType.prototype?.isReactComponent
  const {
    prototype = {}
  } = elementType;
  return Boolean(prototype.isReactComponent);
}
function acceptingRef(props, propName, componentName, location, propFullName) {
  const element = props[propName];
  const safePropName = propFullName || propName;
  if (element == null ||
  // When server-side rendering React doesn't warn either.
  // This is not an accurate check for SSR.
  // This is only in place for Emotion compat.
  // TODO: Revisit once https://github.com/facebook/react/issues/20047 is resolved.
  typeof window === 'undefined') {
    return null;
  }
  let warningHint;
  const elementType = element.type;
  /**
   * Blacklisting instead of whitelisting
   *
   * Blacklisting will miss some components, such as React.Fragment. Those will at least
   * trigger a warning in React.
   * We can't whitelist because there is no safe way to detect React.forwardRef
   * or class components. "Safe" means there's no public API.
   *
   */
  if (typeof elementType === 'function' && !isClassComponent$1(elementType)) {
    warningHint = 'Did you accidentally use a plain function component for an element instead?';
  }
  if (warningHint !== undefined) {
    return new Error(`Invalid ${location} \`${safePropName}\` supplied to \`${componentName}\`. ` + `Expected an element that can hold a ref. ${warningHint} ` + 'For more information see https://mui.com/r/caveat-with-refs-guide');
  }
  return null;
}
const elementAcceptingRef = chainPropTypes(propTypesExports.element, acceptingRef);
elementAcceptingRef.isRequired = chainPropTypes(propTypesExports.element.isRequired, acceptingRef);
var elementAcceptingRef$1 = elementAcceptingRef;

function isClassComponent(elementType) {
  // elementType.prototype?.isReactComponent
  const {
    prototype = {}
  } = elementType;
  return Boolean(prototype.isReactComponent);
}
function elementTypeAcceptingRef(props, propName, componentName, location, propFullName) {
  const propValue = props[propName];
  const safePropName = propFullName || propName;
  if (propValue == null ||
  // When server-side rendering React doesn't warn either.
  // This is not an accurate check for SSR.
  // This is only in place for emotion compat.
  // TODO: Revisit once https://github.com/facebook/react/issues/20047 is resolved.
  typeof window === 'undefined') {
    return null;
  }
  let warningHint;

  /**
   * Blacklisting instead of whitelisting
   *
   * Blacklisting will miss some components, such as React.Fragment. Those will at least
   * trigger a warning in React.
   * We can't whitelist because there is no safe way to detect React.forwardRef
   * or class components. "Safe" means there's no public API.
   *
   */
  if (typeof propValue === 'function' && !isClassComponent(propValue)) {
    warningHint = 'Did you accidentally provide a plain function component instead?';
  }
  if (warningHint !== undefined) {
    return new Error(`Invalid ${location} \`${safePropName}\` supplied to \`${componentName}\`. ` + `Expected an element type that can hold a ref. ${warningHint} ` + 'For more information see https://mui.com/r/caveat-with-refs-guide');
  }
  return null;
}
var elementTypeAcceptingRef$1 = chainPropTypes(propTypesExports.elementType, elementTypeAcceptingRef);

// This module is based on https://github.com/airbnb/prop-types-exact repository.
// However, in order to reduce the number of dependencies and to remove some extra safe checks
// the module was forked.

const specialProperty = 'exact-prop: \u200b';
function exactProp(propTypes) {
  if (browser$1.env.NODE_ENV === 'production') {
    return propTypes;
  }
  return _extends$1({}, propTypes, {
    [specialProperty]: props => {
      const unsupportedProps = Object.keys(props).filter(prop => !propTypes.hasOwnProperty(prop));
      if (unsupportedProps.length > 0) {
        return new Error(`The following props are not supported: ${unsupportedProps.map(prop => `\`${prop}\``).join(', ')}. Please remove them.`);
      }
      return null;
    }
  });
}

/**
 * WARNING: Don't import this directly.
 * Use `MuiError` from `@mui/utils/macros/MuiError.macro` instead.
 * @param {number} code
 */
function formatMuiErrorMessage(code) {
  // Apply babel-plugin-transform-template-literals in loose mode
  // loose mode is safe iff we're concatenating primitives
  // see https://babeljs.io/docs/en/babel-plugin-transform-template-literals#loose
  /* eslint-disable prefer-template */
  let url = 'https://mui.com/production-error/?code=' + code;
  for (let i = 1; i < arguments.length; i += 1) {
    // rest params over-transpile for this case
    // eslint-disable-next-line prefer-rest-params
    url += '&args[]=' + encodeURIComponent(arguments[i]);
  }
  return 'Minified MUI error #' + code + '; visit ' + url + ' for the full message.';
  /* eslint-enable prefer-template */
}

// Simplified polyfill for IE11 support
// https://github.com/JamesMGreene/Function.name/blob/58b314d4a983110c3682f1228f845d39ccca1817/Function.name.js#L3
const fnNameMatchRegex = /^\s*function(?:\s|\s*\/\*.*\*\/\s*)+([^(\s/]*)\s*/;
function getFunctionName(fn) {
  const match = `${fn}`.match(fnNameMatchRegex);
  const name = match && match[1];
  return name || '';
}
function getFunctionComponentName(Component, fallback = '') {
  return Component.displayName || Component.name || getFunctionName(Component) || fallback;
}
function getWrappedName(outerType, innerType, wrapperName) {
  const functionName = getFunctionComponentName(innerType);
  return outerType.displayName || (functionName !== '' ? `${wrapperName}(${functionName})` : wrapperName);
}

/**
 * cherry-pick from
 * https://github.com/facebook/react/blob/769b1f270e1251d9dbdce0fcbd9e92e502d059b8/packages/shared/getComponentName.js
 * originally forked from recompose/getDisplayName with added IE11 support
 */
function getDisplayName(Component) {
  if (Component == null) {
    return undefined;
  }
  if (typeof Component === 'string') {
    return Component;
  }
  if (typeof Component === 'function') {
    return getFunctionComponentName(Component, 'Component');
  }

  // TypeScript can't have components as objects but they exist in the form of `memo` or `Suspense`
  if (typeof Component === 'object') {
    switch (Component.$$typeof) {
      case reactIsExports.ForwardRef:
        return getWrappedName(Component, Component.render, 'ForwardRef');
      case reactIsExports.Memo:
        return getWrappedName(Component, Component.type, 'memo');
      default:
        return undefined;
    }
  }
  return undefined;
}

function HTMLElementType(props, propName, componentName, location, propFullName) {
  if (browser$1.env.NODE_ENV === 'production') {
    return null;
  }
  const propValue = props[propName];
  const safePropName = propFullName || propName;
  if (propValue == null) {
    return null;
  }
  if (propValue && propValue.nodeType !== 1) {
    return new Error(`Invalid ${location} \`${safePropName}\` supplied to \`${componentName}\`. ` + `Expected an HTMLElement.`);
  }
  return null;
}

const refType = propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object]);
var refType$1 = refType;

// It should to be noted that this function isn't equivalent to `text-transform: capitalize`.
//
// A strict capitalization should uppercase the first letter of each word in the sentence.
// We only handle the first word.
function capitalize(string) {
  if (typeof string !== 'string') {
    throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: \`capitalize(string)\` expects a string argument.` : formatMuiErrorMessage(7));
  }
  return string.charAt(0).toUpperCase() + string.slice(1);
}

/**
 * Safe chained function.
 *
 * Will only create a new function if needed,
 * otherwise will pass back existing functions or null.
 */
function createChainedFunction(...funcs) {
  return funcs.reduce((acc, func) => {
    if (func == null) {
      return acc;
    }
    return function chainedFunction(...args) {
      acc.apply(this, args);
      func.apply(this, args);
    };
  }, () => {});
}

// Corresponds to 10 frames at 60 Hz.
// A few bytes payload overhead when lodash/debounce is ~3 kB and debounce ~300 B.
function debounce$1(func, wait = 166) {
  let timeout;
  function debounced(...args) {
    const later = () => {
      func.apply(this, args);
    };
    clearTimeout(timeout);
    timeout = setTimeout(later, wait);
  }
  debounced.clear = () => {
    clearTimeout(timeout);
  };
  return debounced;
}

function deprecatedPropType(validator, reason) {
  if (browser$1.env.NODE_ENV === 'production') {
    return () => null;
  }
  return (props, propName, componentName, location, propFullName) => {
    const componentNameSafe = componentName || '<<anonymous>>';
    const propFullNameSafe = propFullName || propName;
    if (typeof props[propName] !== 'undefined') {
      return new Error(`The ${location} \`${propFullNameSafe}\` of ` + `\`${componentNameSafe}\` is deprecated. ${reason}`);
    }
    return null;
  };
}

function isMuiElement(element, muiNames) {
  return /*#__PURE__*/React__namespace.isValidElement(element) && muiNames.indexOf(element.type.muiName) !== -1;
}

function ownerDocument(node) {
  return node && node.ownerDocument || document;
}

function ownerWindow(node) {
  const doc = ownerDocument(node);
  return doc.defaultView || window;
}

function requirePropFactory(componentNameInError, Component) {
  if (browser$1.env.NODE_ENV === 'production') {
    return () => null;
  }

  // eslint-disable-next-line react/forbid-foreign-prop-types
  const prevPropTypes = Component ? _extends$1({}, Component.propTypes) : null;
  const requireProp = requiredProp => (props, propName, componentName, location, propFullName, ...args) => {
    const propFullNameSafe = propFullName || propName;
    const defaultTypeChecker = prevPropTypes == null ? void 0 : prevPropTypes[propFullNameSafe];
    if (defaultTypeChecker) {
      const typeCheckerResult = defaultTypeChecker(props, propName, componentName, location, propFullName, ...args);
      if (typeCheckerResult) {
        return typeCheckerResult;
      }
    }
    if (typeof props[propName] !== 'undefined' && !props[requiredProp]) {
      return new Error(`The prop \`${propFullNameSafe}\` of ` + `\`${componentNameInError}\` can only be used together with the \`${requiredProp}\` prop.`);
    }
    return null;
  };
  return requireProp;
}

/**
 * TODO v5: consider making it private
 *
 * passes {value} to {ref}
 *
 * WARNING: Be sure to only call this inside a callback that is passed as a ref.
 * Otherwise, make sure to cleanup the previous {ref} if it changes. See
 * https://github.com/mui/material-ui/issues/13539
 *
 * Useful if you want to expose the ref of an inner component to the public API
 * while still using it inside the component.
 * @param ref A ref callback or ref object. If anything falsy, this is a no-op.
 */
function setRef(ref, value) {
  if (typeof ref === 'function') {
    ref(value);
  } else if (ref) {
    ref.current = value;
  }
}

const useEnhancedEffect = typeof window !== 'undefined' ? React__namespace.useLayoutEffect : React__namespace.useEffect;
var useEnhancedEffect$1 = useEnhancedEffect;

let globalId = 0;
function useGlobalId(idOverride) {
  const [defaultId, setDefaultId] = React__namespace.useState(idOverride);
  const id = idOverride || defaultId;
  React__namespace.useEffect(() => {
    if (defaultId == null) {
      // Fallback to this default id when possible.
      // Use the incrementing value for client-side rendering only.
      // We can't use it server-side.
      // If you want to use random values please consider the Birthday Problem: https://en.wikipedia.org/wiki/Birthday_problem
      globalId += 1;
      setDefaultId(`mui-${globalId}`);
    }
  }, [defaultId]);
  return id;
}

// eslint-disable-next-line no-useless-concat -- Workaround for https://github.com/webpack/webpack/issues/14814
const maybeReactUseId = React__namespace['useId' + ''];
/**
 *
 * @example <div id={useId()} />
 * @param idOverride
 * @returns {string}
 */
function useId(idOverride) {
  if (maybeReactUseId !== undefined) {
    const reactId = maybeReactUseId();
    return idOverride != null ? idOverride : reactId;
  }
  // eslint-disable-next-line react-hooks/rules-of-hooks -- `React.useId` is invariant at runtime.
  return useGlobalId(idOverride);
}

function unsupportedProp(props, propName, componentName, location, propFullName) {
  if (browser$1.env.NODE_ENV === 'production') {
    return null;
  }
  const propFullNameSafe = propFullName || propName;
  if (typeof props[propName] !== 'undefined') {
    return new Error(`The prop \`${propFullNameSafe}\` is not supported. Please remove it.`);
  }
  return null;
}

function useControlled({
  controlled,
  default: defaultProp,
  name,
  state = 'value'
}) {
  // isControlled is ignored in the hook dependency lists as it should never change.
  const {
    current: isControlled
  } = React__namespace.useRef(controlled !== undefined);
  const [valueState, setValue] = React__namespace.useState(defaultProp);
  const value = isControlled ? controlled : valueState;
  if (browser$1.env.NODE_ENV !== 'production') {
    React__namespace.useEffect(() => {
      if (isControlled !== (controlled !== undefined)) {
        console.error([`MUI: A component is changing the ${isControlled ? '' : 'un'}controlled ${state} state of ${name} to be ${isControlled ? 'un' : ''}controlled.`, 'Elements should not switch from uncontrolled to controlled (or vice versa).', `Decide between using a controlled or uncontrolled ${name} ` + 'element for the lifetime of the component.', "The nature of the state is determined during the first render. It's considered controlled if the value is not `undefined`.", 'More info: https://fb.me/react-controlled-components'].join('\n'));
      }
    }, [state, name, controlled]);
    const {
      current: defaultValue
    } = React__namespace.useRef(defaultProp);
    React__namespace.useEffect(() => {
      if (!isControlled && defaultValue !== defaultProp) {
        console.error([`MUI: A component is changing the default ${state} state of an uncontrolled ${name} after being initialized. ` + `To suppress this warning opt to use a controlled ${name}.`].join('\n'));
      }
    }, [JSON.stringify(defaultProp)]);
  }
  const setValueIfUncontrolled = React__namespace.useCallback(newValue => {
    if (!isControlled) {
      setValue(newValue);
    }
  }, []);
  return [value, setValueIfUncontrolled];
}

/**
 * https://github.com/facebook/react/issues/14099#issuecomment-440013892
 */
function useEventCallback(fn) {
  const ref = React__namespace.useRef(fn);
  useEnhancedEffect$1(() => {
    ref.current = fn;
  });
  return React__namespace.useCallback((...args) =>
  // @ts-expect-error hide `this`
  // tslint:disable-next-line:ban-comma-operator
  (0, ref.current)(...args), []);
}

function useForkRef(...refs) {
  /**
   * This will create a new function if the refs passed to this hook change and are all defined.
   * This means react will call the old forkRef with `null` and the new forkRef
   * with the ref. Cleanup naturally emerges from this behavior.
   */
  return React__namespace.useMemo(() => {
    if (refs.every(ref => ref == null)) {
      return null;
    }
    return instance => {
      refs.forEach(ref => {
        setRef(ref, instance);
      });
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, refs);
}

// based on https://github.com/WICG/focus-visible/blob/v4.1.5/src/focus-visible.js
let hadKeyboardEvent = true;
let hadFocusVisibleRecently = false;
let hadFocusVisibleRecentlyTimeout;
const inputTypesWhitelist = {
  text: true,
  search: true,
  url: true,
  tel: true,
  email: true,
  password: true,
  number: true,
  date: true,
  month: true,
  week: true,
  time: true,
  datetime: true,
  'datetime-local': true
};

/**
 * Computes whether the given element should automatically trigger the
 * `focus-visible` class being added, i.e. whether it should always match
 * `:focus-visible` when focused.
 * @param {Element} node
 * @returns {boolean}
 */
function focusTriggersKeyboardModality(node) {
  const {
    type,
    tagName
  } = node;
  if (tagName === 'INPUT' && inputTypesWhitelist[type] && !node.readOnly) {
    return true;
  }
  if (tagName === 'TEXTAREA' && !node.readOnly) {
    return true;
  }
  if (node.isContentEditable) {
    return true;
  }
  return false;
}

/**
 * Keep track of our keyboard modality state with `hadKeyboardEvent`.
 * If the most recent user interaction was via the keyboard;
 * and the key press did not include a meta, alt/option, or control key;
 * then the modality is keyboard. Otherwise, the modality is not keyboard.
 * @param {KeyboardEvent} event
 */
function handleKeyDown(event) {
  if (event.metaKey || event.altKey || event.ctrlKey) {
    return;
  }
  hadKeyboardEvent = true;
}

/**
 * If at any point a user clicks with a pointing device, ensure that we change
 * the modality away from keyboard.
 * This avoids the situation where a user presses a key on an already focused
 * element, and then clicks on a different element, focusing it with a
 * pointing device, while we still think we're in keyboard modality.
 */
function handlePointerDown() {
  hadKeyboardEvent = false;
}
function handleVisibilityChange() {
  if (this.visibilityState === 'hidden') {
    // If the tab becomes active again, the browser will handle calling focus
    // on the element (Safari actually calls it twice).
    // If this tab change caused a blur on an element with focus-visible,
    // re-apply the class when the user switches back to the tab.
    if (hadFocusVisibleRecently) {
      hadKeyboardEvent = true;
    }
  }
}
function prepare(doc) {
  doc.addEventListener('keydown', handleKeyDown, true);
  doc.addEventListener('mousedown', handlePointerDown, true);
  doc.addEventListener('pointerdown', handlePointerDown, true);
  doc.addEventListener('touchstart', handlePointerDown, true);
  doc.addEventListener('visibilitychange', handleVisibilityChange, true);
}
function isFocusVisible(event) {
  const {
    target
  } = event;
  try {
    return target.matches(':focus-visible');
  } catch (error) {
    // Browsers not implementing :focus-visible will throw a SyntaxError.
    // We use our own heuristic for those browsers.
    // Rethrow might be better if it's not the expected error but do we really
    // want to crash if focus-visible malfunctioned?
  }

  // No need for validFocusTarget check. The user does that by attaching it to
  // focusable events only.
  return hadKeyboardEvent || focusTriggersKeyboardModality(target);
}
function useIsFocusVisible() {
  const ref = React__namespace.useCallback(node => {
    if (node != null) {
      prepare(node.ownerDocument);
    }
  }, []);
  const isFocusVisibleRef = React__namespace.useRef(false);

  /**
   * Should be called if a blur event is fired
   */
  function handleBlurVisible() {
    // checking against potential state variable does not suffice if we focus and blur synchronously.
    // React wouldn't have time to trigger a re-render so `focusVisible` would be stale.
    // Ideally we would adjust `isFocusVisible(event)` to look at `relatedTarget` for blur events.
    // This doesn't work in IE11 due to https://github.com/facebook/react/issues/3751
    // TODO: check again if React releases their internal changes to focus event handling (https://github.com/facebook/react/pull/19186).
    if (isFocusVisibleRef.current) {
      // To detect a tab/window switch, we look for a blur event followed
      // rapidly by a visibility change.
      // If we don't see a visibility change within 100ms, it's probably a
      // regular focus change.
      hadFocusVisibleRecently = true;
      window.clearTimeout(hadFocusVisibleRecentlyTimeout);
      hadFocusVisibleRecentlyTimeout = window.setTimeout(() => {
        hadFocusVisibleRecently = false;
      }, 100);
      isFocusVisibleRef.current = false;
      return true;
    }
    return false;
  }

  /**
   * Should be called if a blur event is fired
   */
  function handleFocusVisible(event) {
    if (isFocusVisible(event)) {
      isFocusVisibleRef.current = true;
      return true;
    }
    return false;
  }
  return {
    isFocusVisibleRef,
    onFocus: handleFocusVisible,
    onBlur: handleBlurVisible,
    ref
  };
}

// A change of the browser zoom change the scrollbar size.
// Credit https://github.com/twbs/bootstrap/blob/488fd8afc535ca3a6ad4dc581f5e89217b6a36ac/js/src/util/scrollbar.js#L14-L18
function getScrollbarSize(doc) {
  // https://developer.mozilla.org/en-US/docs/Web/API/Window/innerWidth#usage_notes
  const documentWidth = doc.documentElement.clientWidth;
  return Math.abs(window.innerWidth - documentWidth);
}

// Source from https://github.com/alitaheri/normalize-scroll-left
let cachedType;

/**
 * Based on the jquery plugin https://github.com/othree/jquery.rtl-scroll-type
 *
 * Types of scrollLeft, assuming scrollWidth=100 and direction is rtl.
 *
 * Type             | <- Most Left | Most Right -> | Initial
 * ---------------- | ------------ | ------------- | -------
 * default          | 0            | 100           | 100
 * negative (spec*) | -100         | 0             | 0
 * reverse          | 100          | 0             | 0
 *
 * Edge 85: default
 * Safari 14: negative
 * Chrome 85: negative
 * Firefox 81: negative
 * IE11: reverse
 *
 * spec* https://drafts.csswg.org/cssom-view/#dom-window-scroll
 */
function detectScrollType() {
  if (cachedType) {
    return cachedType;
  }
  const dummy = document.createElement('div');
  const container = document.createElement('div');
  container.style.width = '10px';
  container.style.height = '1px';
  dummy.appendChild(container);
  dummy.dir = 'rtl';
  dummy.style.fontSize = '14px';
  dummy.style.width = '4px';
  dummy.style.height = '1px';
  dummy.style.position = 'absolute';
  dummy.style.top = '-1000px';
  dummy.style.overflow = 'scroll';
  document.body.appendChild(dummy);
  cachedType = 'reverse';
  if (dummy.scrollLeft > 0) {
    cachedType = 'default';
  } else {
    dummy.scrollLeft = 1;
    if (dummy.scrollLeft === 0) {
      cachedType = 'negative';
    }
  }
  document.body.removeChild(dummy);
  return cachedType;
}

// Based on https://stackoverflow.com/a/24394376
function getNormalizedScrollLeft(element, direction) {
  const scrollLeft = element.scrollLeft;

  // Perform the calculations only when direction is rtl to avoid messing up the ltr behavior
  if (direction !== 'rtl') {
    return scrollLeft;
  }
  const type = detectScrollType();
  switch (type) {
    case 'negative':
      return element.scrollWidth - element.clientWidth + scrollLeft;
    case 'reverse':
      return element.scrollWidth - element.clientWidth - scrollLeft;
    default:
      return scrollLeft;
  }
}

const visuallyHidden = {
  border: 0,
  clip: 'rect(0 0 0 0)',
  height: '1px',
  margin: -1,
  overflow: 'hidden',
  padding: 0,
  position: 'absolute',
  whiteSpace: 'nowrap',
  width: '1px'
};
var visuallyHidden$1 = visuallyHidden;

function getTypeByValue(value) {
  const valueType = typeof value;
  switch (valueType) {
    case 'number':
      if (Number.isNaN(value)) {
        return 'NaN';
      }
      if (!Number.isFinite(value)) {
        return 'Infinity';
      }
      if (value !== Math.floor(value)) {
        return 'float';
      }
      return 'number';
    case 'object':
      if (value === null) {
        return 'null';
      }
      return value.constructor.name;
    default:
      return valueType;
  }
}

// IE 11 support
function ponyfillIsInteger(x) {
  // eslint-disable-next-line no-restricted-globals
  return typeof x === 'number' && isFinite(x) && Math.floor(x) === x;
}
const isInteger = Number.isInteger || ponyfillIsInteger;
function requiredInteger(props, propName, componentName, location) {
  const propValue = props[propName];
  if (propValue == null || !isInteger(propValue)) {
    const propType = getTypeByValue(propValue);
    return new RangeError(`Invalid ${location} \`${propName}\` of type \`${propType}\` supplied to \`${componentName}\`, expected \`integer\`.`);
  }
  return null;
}
function validator(props, propName, ...other) {
  const propValue = props[propName];
  if (propValue === undefined) {
    return null;
  }
  return requiredInteger(props, propName, ...other);
}
function validatorNoop() {
  return null;
}
validator.isRequired = requiredInteger;
validatorNoop.isRequired = validatorNoop;
var integerPropType = browser$1.env.NODE_ENV === 'production' ? validatorNoop : validator;

/**
 * Add keys, values of `defaultProps` that does not exist in `props`
 * @param {object} defaultProps
 * @param {object} props
 * @returns {object} resolved props
 */
function resolveProps(defaultProps, props) {
  const output = _extends$1({}, props);
  Object.keys(defaultProps).forEach(propName => {
    if (propName.toString().match(/^(components|slots)$/)) {
      output[propName] = _extends$1({}, defaultProps[propName], output[propName]);
    } else if (propName.toString().match(/^(componentsProps|slotProps)$/)) {
      const defaultSlotProps = defaultProps[propName] || {};
      const slotProps = props[propName];
      output[propName] = {};
      if (!slotProps || !Object.keys(slotProps)) {
        // Reduce the iteration if the slot props is empty
        output[propName] = defaultSlotProps;
      } else if (!defaultSlotProps || !Object.keys(defaultSlotProps)) {
        // Reduce the iteration if the default slot props is empty
        output[propName] = slotProps;
      } else {
        output[propName] = _extends$1({}, slotProps);
        Object.keys(defaultSlotProps).forEach(slotPropName => {
          output[propName][slotPropName] = resolveProps(defaultSlotProps[slotPropName], slotProps[slotPropName]);
        });
      }
    } else if (output[propName] === undefined) {
      output[propName] = defaultProps[propName];
    }
  });
  return output;
}

function composeClasses(slots, getUtilityClass, classes = undefined) {
  const output = {};
  Object.keys(slots).forEach(
  // `Objet.keys(slots)` can't be wider than `T` because we infer `T` from `slots`.
  // @ts-expect-error https://github.com/microsoft/TypeScript/pull/12253#issuecomment-263132208
  slot => {
    output[slot] = slots[slot].reduce((acc, key) => {
      if (key) {
        const utilityClass = getUtilityClass(key);
        if (utilityClass !== '') {
          acc.push(utilityClass);
        }
        if (classes && classes[key]) {
          acc.push(classes[key]);
        }
      }
      return acc;
    }, []).join(' ');
  });
  return output;
}

const defaultGenerator = componentName => componentName;
const createClassNameGenerator = () => {
  let generate = defaultGenerator;
  return {
    configure(generator) {
      generate = generator;
    },
    generate(componentName) {
      return generate(componentName);
    },
    reset() {
      generate = defaultGenerator;
    }
  };
};
const ClassNameGenerator = createClassNameGenerator();
var ClassNameGenerator$1 = ClassNameGenerator;

const globalStateClassesMapping = {
  active: 'active',
  checked: 'checked',
  completed: 'completed',
  disabled: 'disabled',
  readOnly: 'readOnly',
  error: 'error',
  expanded: 'expanded',
  focused: 'focused',
  focusVisible: 'focusVisible',
  required: 'required',
  selected: 'selected'
};
function generateUtilityClass(componentName, slot, globalStatePrefix = 'Mui') {
  const globalStateClass = globalStateClassesMapping[slot];
  return globalStateClass ? `${globalStatePrefix}-${globalStateClass}` : `${ClassNameGenerator$1.generate(componentName)}-${slot}`;
}

function generateUtilityClasses(componentName, slots, globalStatePrefix = 'Mui') {
  const result = {};
  slots.forEach(slot => {
    result[slot] = generateUtilityClass(componentName, slot, globalStatePrefix);
  });
  return result;
}

function r(e){var t,f,n="";if("string"==typeof e||"number"==typeof e)n+=e;else if("object"==typeof e)if(Array.isArray(e))for(t=0;t<e.length;t++)e[t]&&(f=r(e[t]))&&(n&&(n+=" "),n+=f);else for(t in e)e[t]&&(n&&(n+=" "),n+=t);return n}function clsx(){for(var e,t,f=0,n="";f<arguments.length;)(e=arguments[f++])&&(t=r(e))&&(n&&(n+=" "),n+=t);return n}

/**
 * Determines if a given element is a DOM element name (i.e. not a React component).
 */
function isHostComponent(element) {
  return typeof element === 'string';
}

/**
 * Type of the ownerState based on the type of an element it applies to.
 * This resolves to the provided OwnerState for React components and `undefined` for host components.
 * Falls back to `OwnerState | undefined` when the exact type can't be determined in development time.
 */

/**
 * Appends the ownerState object to the props, merging with the existing one if necessary.
 *
 * @param elementType Type of the element that owns the `existingProps`. If the element is a DOM node or undefined, `ownerState` is not applied.
 * @param otherProps Props of the element.
 * @param ownerState
 */
function appendOwnerState(elementType, otherProps, ownerState) {
  if (elementType === undefined || isHostComponent(elementType)) {
    return otherProps;
  }
  return _extends$1({}, otherProps, {
    ownerState: _extends$1({}, otherProps.ownerState, ownerState)
  });
}

var jsxRuntimeExports$1 = {};
var jsxRuntime = {
  get exports(){ return jsxRuntimeExports$1; },
  set exports(v){ jsxRuntimeExports$1 = v; },
};

var reactJsxRuntime_production_min = {};

/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var hasRequiredReactJsxRuntime_production_min;

function requireReactJsxRuntime_production_min () {
	if (hasRequiredReactJsxRuntime_production_min) return reactJsxRuntime_production_min;
	hasRequiredReactJsxRuntime_production_min = 1;
requireObjectAssign();var f=React__namespace.default,g=60103;reactJsxRuntime_production_min.Fragment=60107;if("function"===typeof Symbol&&Symbol.for){var h=Symbol.for;g=h("react.element");reactJsxRuntime_production_min.Fragment=h("react.fragment");}var m=f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,n=Object.prototype.hasOwnProperty,p={key:!0,ref:!0,__self:!0,__source:!0};
	function q(c,a,k){var b,d={},e=null,l=null;void 0!==k&&(e=""+k);void 0!==a.key&&(e=""+a.key);void 0!==a.ref&&(l=a.ref);for(b in a)n.call(a,b)&&!p.hasOwnProperty(b)&&(d[b]=a[b]);if(c&&c.defaultProps)for(b in a=c.defaultProps,a)void 0===d[b]&&(d[b]=a[b]);return {$$typeof:g,type:c,key:e,ref:l,props:d,_owner:m.current}}reactJsxRuntime_production_min.jsx=q;reactJsxRuntime_production_min.jsxs=q;
	return reactJsxRuntime_production_min;
}

var reactJsxRuntime_development = {};

var hasRequiredReactJsxRuntime_development;

function requireReactJsxRuntime_development () {
	if (hasRequiredReactJsxRuntime_development) return reactJsxRuntime_development;
	hasRequiredReactJsxRuntime_development = 1;
	(function (exports) {

		if (browser$1.env.NODE_ENV !== "production") {
		  (function() {

		var React = React__namespace.default;
		var _assign = requireObjectAssign();

		// ATTENTION
		// When adding new symbols to this file,
		// Please consider also adding to 'react-devtools-shared/src/backend/ReactSymbols'
		// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
		// nor polyfill, then a plain number is used for performance.
		var REACT_ELEMENT_TYPE = 0xeac7;
		var REACT_PORTAL_TYPE = 0xeaca;
		exports.Fragment = 0xeacb;
		var REACT_STRICT_MODE_TYPE = 0xeacc;
		var REACT_PROFILER_TYPE = 0xead2;
		var REACT_PROVIDER_TYPE = 0xeacd;
		var REACT_CONTEXT_TYPE = 0xeace;
		var REACT_FORWARD_REF_TYPE = 0xead0;
		var REACT_SUSPENSE_TYPE = 0xead1;
		var REACT_SUSPENSE_LIST_TYPE = 0xead8;
		var REACT_MEMO_TYPE = 0xead3;
		var REACT_LAZY_TYPE = 0xead4;
		var REACT_BLOCK_TYPE = 0xead9;
		var REACT_SERVER_BLOCK_TYPE = 0xeada;
		var REACT_FUNDAMENTAL_TYPE = 0xead5;
		var REACT_DEBUG_TRACING_MODE_TYPE = 0xeae1;
		var REACT_LEGACY_HIDDEN_TYPE = 0xeae3;

		if (typeof Symbol === 'function' && Symbol.for) {
		  var symbolFor = Symbol.for;
		  REACT_ELEMENT_TYPE = symbolFor('react.element');
		  REACT_PORTAL_TYPE = symbolFor('react.portal');
		  exports.Fragment = symbolFor('react.fragment');
		  REACT_STRICT_MODE_TYPE = symbolFor('react.strict_mode');
		  REACT_PROFILER_TYPE = symbolFor('react.profiler');
		  REACT_PROVIDER_TYPE = symbolFor('react.provider');
		  REACT_CONTEXT_TYPE = symbolFor('react.context');
		  REACT_FORWARD_REF_TYPE = symbolFor('react.forward_ref');
		  REACT_SUSPENSE_TYPE = symbolFor('react.suspense');
		  REACT_SUSPENSE_LIST_TYPE = symbolFor('react.suspense_list');
		  REACT_MEMO_TYPE = symbolFor('react.memo');
		  REACT_LAZY_TYPE = symbolFor('react.lazy');
		  REACT_BLOCK_TYPE = symbolFor('react.block');
		  REACT_SERVER_BLOCK_TYPE = symbolFor('react.server.block');
		  REACT_FUNDAMENTAL_TYPE = symbolFor('react.fundamental');
		  symbolFor('react.scope');
		  symbolFor('react.opaque.id');
		  REACT_DEBUG_TRACING_MODE_TYPE = symbolFor('react.debug_trace_mode');
		  symbolFor('react.offscreen');
		  REACT_LEGACY_HIDDEN_TYPE = symbolFor('react.legacy_hidden');
		}

		var MAYBE_ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
		var FAUX_ITERATOR_SYMBOL = '@@iterator';
		function getIteratorFn(maybeIterable) {
		  if (maybeIterable === null || typeof maybeIterable !== 'object') {
		    return null;
		  }

		  var maybeIterator = MAYBE_ITERATOR_SYMBOL && maybeIterable[MAYBE_ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL];

		  if (typeof maybeIterator === 'function') {
		    return maybeIterator;
		  }

		  return null;
		}

		var ReactSharedInternals = React.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;

		function error(format) {
		  {
		    for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
		      args[_key2 - 1] = arguments[_key2];
		    }

		    printWarning('error', format, args);
		  }
		}

		function printWarning(level, format, args) {
		  // When changing this logic, you might want to also
		  // update consoleWithStackDev.www.js as well.
		  {
		    var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;
		    var stack = ReactDebugCurrentFrame.getStackAddendum();

		    if (stack !== '') {
		      format += '%s';
		      args = args.concat([stack]);
		    }

		    var argsWithFormat = args.map(function (item) {
		      return '' + item;
		    }); // Careful: RN currently depends on this prefix

		    argsWithFormat.unshift('Warning: ' + format); // We intentionally don't use spread (or .apply) directly because it
		    // breaks IE9: https://github.com/facebook/react/issues/13610
		    // eslint-disable-next-line react-internal/no-production-logging

		    Function.prototype.apply.call(console[level], console, argsWithFormat);
		  }
		}

		// Filter certain DOM attributes (e.g. src, href) if their values are empty strings.

		var enableScopeAPI = false; // Experimental Create Event Handle API.

		function isValidElementType(type) {
		  if (typeof type === 'string' || typeof type === 'function') {
		    return true;
		  } // Note: typeof might be other than 'symbol' or 'number' (e.g. if it's a polyfill).


		  if (type === exports.Fragment || type === REACT_PROFILER_TYPE || type === REACT_DEBUG_TRACING_MODE_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || type === REACT_LEGACY_HIDDEN_TYPE || enableScopeAPI ) {
		    return true;
		  }

		  if (typeof type === 'object' && type !== null) {
		    if (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_BLOCK_TYPE || type[0] === REACT_SERVER_BLOCK_TYPE) {
		      return true;
		    }
		  }

		  return false;
		}

		function getWrappedName(outerType, innerType, wrapperName) {
		  var functionName = innerType.displayName || innerType.name || '';
		  return outerType.displayName || (functionName !== '' ? wrapperName + "(" + functionName + ")" : wrapperName);
		}

		function getContextName(type) {
		  return type.displayName || 'Context';
		}

		function getComponentName(type) {
		  if (type == null) {
		    // Host root, text node or just invalid type.
		    return null;
		  }

		  {
		    if (typeof type.tag === 'number') {
		      error('Received an unexpected object in getComponentName(). ' + 'This is likely a bug in React. Please file an issue.');
		    }
		  }

		  if (typeof type === 'function') {
		    return type.displayName || type.name || null;
		  }

		  if (typeof type === 'string') {
		    return type;
		  }

		  switch (type) {
		    case exports.Fragment:
		      return 'Fragment';

		    case REACT_PORTAL_TYPE:
		      return 'Portal';

		    case REACT_PROFILER_TYPE:
		      return 'Profiler';

		    case REACT_STRICT_MODE_TYPE:
		      return 'StrictMode';

		    case REACT_SUSPENSE_TYPE:
		      return 'Suspense';

		    case REACT_SUSPENSE_LIST_TYPE:
		      return 'SuspenseList';
		  }

		  if (typeof type === 'object') {
		    switch (type.$$typeof) {
		      case REACT_CONTEXT_TYPE:
		        var context = type;
		        return getContextName(context) + '.Consumer';

		      case REACT_PROVIDER_TYPE:
		        var provider = type;
		        return getContextName(provider._context) + '.Provider';

		      case REACT_FORWARD_REF_TYPE:
		        return getWrappedName(type, type.render, 'ForwardRef');

		      case REACT_MEMO_TYPE:
		        return getComponentName(type.type);

		      case REACT_BLOCK_TYPE:
		        return getComponentName(type._render);

		      case REACT_LAZY_TYPE:
		        {
		          var lazyComponent = type;
		          var payload = lazyComponent._payload;
		          var init = lazyComponent._init;

		          try {
		            return getComponentName(init(payload));
		          } catch (x) {
		            return null;
		          }
		        }
		    }
		  }

		  return null;
		}

		// Helpers to patch console.logs to avoid logging during side-effect free
		// replaying on render function. This currently only patches the object
		// lazily which won't cover if the log function was extracted eagerly.
		// We could also eagerly patch the method.
		var disabledDepth = 0;
		var prevLog;
		var prevInfo;
		var prevWarn;
		var prevError;
		var prevGroup;
		var prevGroupCollapsed;
		var prevGroupEnd;

		function disabledLog() {}

		disabledLog.__reactDisabledLog = true;
		function disableLogs() {
		  {
		    if (disabledDepth === 0) {
		      /* eslint-disable react-internal/no-production-logging */
		      prevLog = console.log;
		      prevInfo = console.info;
		      prevWarn = console.warn;
		      prevError = console.error;
		      prevGroup = console.group;
		      prevGroupCollapsed = console.groupCollapsed;
		      prevGroupEnd = console.groupEnd; // https://github.com/facebook/react/issues/19099

		      var props = {
		        configurable: true,
		        enumerable: true,
		        value: disabledLog,
		        writable: true
		      }; // $FlowFixMe Flow thinks console is immutable.

		      Object.defineProperties(console, {
		        info: props,
		        log: props,
		        warn: props,
		        error: props,
		        group: props,
		        groupCollapsed: props,
		        groupEnd: props
		      });
		      /* eslint-enable react-internal/no-production-logging */
		    }

		    disabledDepth++;
		  }
		}
		function reenableLogs() {
		  {
		    disabledDepth--;

		    if (disabledDepth === 0) {
		      /* eslint-disable react-internal/no-production-logging */
		      var props = {
		        configurable: true,
		        enumerable: true,
		        writable: true
		      }; // $FlowFixMe Flow thinks console is immutable.

		      Object.defineProperties(console, {
		        log: _assign({}, props, {
		          value: prevLog
		        }),
		        info: _assign({}, props, {
		          value: prevInfo
		        }),
		        warn: _assign({}, props, {
		          value: prevWarn
		        }),
		        error: _assign({}, props, {
		          value: prevError
		        }),
		        group: _assign({}, props, {
		          value: prevGroup
		        }),
		        groupCollapsed: _assign({}, props, {
		          value: prevGroupCollapsed
		        }),
		        groupEnd: _assign({}, props, {
		          value: prevGroupEnd
		        })
		      });
		      /* eslint-enable react-internal/no-production-logging */
		    }

		    if (disabledDepth < 0) {
		      error('disabledDepth fell below zero. ' + 'This is a bug in React. Please file an issue.');
		    }
		  }
		}

		var ReactCurrentDispatcher = ReactSharedInternals.ReactCurrentDispatcher;
		var prefix;
		function describeBuiltInComponentFrame(name, source, ownerFn) {
		  {
		    if (prefix === undefined) {
		      // Extract the VM specific prefix used by each line.
		      try {
		        throw Error();
		      } catch (x) {
		        var match = x.stack.trim().match(/\n( *(at )?)/);
		        prefix = match && match[1] || '';
		      }
		    } // We use the prefix to ensure our stacks line up with native stack frames.


		    return '\n' + prefix + name;
		  }
		}
		var reentry = false;
		var componentFrameCache;

		{
		  var PossiblyWeakMap = typeof WeakMap === 'function' ? WeakMap : Map;
		  componentFrameCache = new PossiblyWeakMap();
		}

		function describeNativeComponentFrame(fn, construct) {
		  // If something asked for a stack inside a fake render, it should get ignored.
		  if (!fn || reentry) {
		    return '';
		  }

		  {
		    var frame = componentFrameCache.get(fn);

		    if (frame !== undefined) {
		      return frame;
		    }
		  }

		  var control;
		  reentry = true;
		  var previousPrepareStackTrace = Error.prepareStackTrace; // $FlowFixMe It does accept undefined.

		  Error.prepareStackTrace = undefined;
		  var previousDispatcher;

		  {
		    previousDispatcher = ReactCurrentDispatcher.current; // Set the dispatcher in DEV because this might be call in the render function
		    // for warnings.

		    ReactCurrentDispatcher.current = null;
		    disableLogs();
		  }

		  try {
		    // This should throw.
		    if (construct) {
		      // Something should be setting the props in the constructor.
		      var Fake = function () {
		        throw Error();
		      }; // $FlowFixMe


		      Object.defineProperty(Fake.prototype, 'props', {
		        set: function () {
		          // We use a throwing setter instead of frozen or non-writable props
		          // because that won't throw in a non-strict mode function.
		          throw Error();
		        }
		      });

		      if (typeof Reflect === 'object' && Reflect.construct) {
		        // We construct a different control for this case to include any extra
		        // frames added by the construct call.
		        try {
		          Reflect.construct(Fake, []);
		        } catch (x) {
		          control = x;
		        }

		        Reflect.construct(fn, [], Fake);
		      } else {
		        try {
		          Fake.call();
		        } catch (x) {
		          control = x;
		        }

		        fn.call(Fake.prototype);
		      }
		    } else {
		      try {
		        throw Error();
		      } catch (x) {
		        control = x;
		      }

		      fn();
		    }
		  } catch (sample) {
		    // This is inlined manually because closure doesn't do it for us.
		    if (sample && control && typeof sample.stack === 'string') {
		      // This extracts the first frame from the sample that isn't also in the control.
		      // Skipping one frame that we assume is the frame that calls the two.
		      var sampleLines = sample.stack.split('\n');
		      var controlLines = control.stack.split('\n');
		      var s = sampleLines.length - 1;
		      var c = controlLines.length - 1;

		      while (s >= 1 && c >= 0 && sampleLines[s] !== controlLines[c]) {
		        // We expect at least one stack frame to be shared.
		        // Typically this will be the root most one. However, stack frames may be
		        // cut off due to maximum stack limits. In this case, one maybe cut off
		        // earlier than the other. We assume that the sample is longer or the same
		        // and there for cut off earlier. So we should find the root most frame in
		        // the sample somewhere in the control.
		        c--;
		      }

		      for (; s >= 1 && c >= 0; s--, c--) {
		        // Next we find the first one that isn't the same which should be the
		        // frame that called our sample function and the control.
		        if (sampleLines[s] !== controlLines[c]) {
		          // In V8, the first line is describing the message but other VMs don't.
		          // If we're about to return the first line, and the control is also on the same
		          // line, that's a pretty good indicator that our sample threw at same line as
		          // the control. I.e. before we entered the sample frame. So we ignore this result.
		          // This can happen if you passed a class to function component, or non-function.
		          if (s !== 1 || c !== 1) {
		            do {
		              s--;
		              c--; // We may still have similar intermediate frames from the construct call.
		              // The next one that isn't the same should be our match though.

		              if (c < 0 || sampleLines[s] !== controlLines[c]) {
		                // V8 adds a "new" prefix for native classes. Let's remove it to make it prettier.
		                var _frame = '\n' + sampleLines[s].replace(' at new ', ' at ');

		                {
		                  if (typeof fn === 'function') {
		                    componentFrameCache.set(fn, _frame);
		                  }
		                } // Return the line we found.


		                return _frame;
		              }
		            } while (s >= 1 && c >= 0);
		          }

		          break;
		        }
		      }
		    }
		  } finally {
		    reentry = false;

		    {
		      ReactCurrentDispatcher.current = previousDispatcher;
		      reenableLogs();
		    }

		    Error.prepareStackTrace = previousPrepareStackTrace;
		  } // Fallback to just using the name if we couldn't make it throw.


		  var name = fn ? fn.displayName || fn.name : '';
		  var syntheticFrame = name ? describeBuiltInComponentFrame(name) : '';

		  {
		    if (typeof fn === 'function') {
		      componentFrameCache.set(fn, syntheticFrame);
		    }
		  }

		  return syntheticFrame;
		}
		function describeFunctionComponentFrame(fn, source, ownerFn) {
		  {
		    return describeNativeComponentFrame(fn, false);
		  }
		}

		function shouldConstruct(Component) {
		  var prototype = Component.prototype;
		  return !!(prototype && prototype.isReactComponent);
		}

		function describeUnknownElementTypeFrameInDEV(type, source, ownerFn) {

		  if (type == null) {
		    return '';
		  }

		  if (typeof type === 'function') {
		    {
		      return describeNativeComponentFrame(type, shouldConstruct(type));
		    }
		  }

		  if (typeof type === 'string') {
		    return describeBuiltInComponentFrame(type);
		  }

		  switch (type) {
		    case REACT_SUSPENSE_TYPE:
		      return describeBuiltInComponentFrame('Suspense');

		    case REACT_SUSPENSE_LIST_TYPE:
		      return describeBuiltInComponentFrame('SuspenseList');
		  }

		  if (typeof type === 'object') {
		    switch (type.$$typeof) {
		      case REACT_FORWARD_REF_TYPE:
		        return describeFunctionComponentFrame(type.render);

		      case REACT_MEMO_TYPE:
		        // Memo may contain any component type so we recursively resolve it.
		        return describeUnknownElementTypeFrameInDEV(type.type, source, ownerFn);

		      case REACT_BLOCK_TYPE:
		        return describeFunctionComponentFrame(type._render);

		      case REACT_LAZY_TYPE:
		        {
		          var lazyComponent = type;
		          var payload = lazyComponent._payload;
		          var init = lazyComponent._init;

		          try {
		            // Lazy may contain any component type so we recursively resolve it.
		            return describeUnknownElementTypeFrameInDEV(init(payload), source, ownerFn);
		          } catch (x) {}
		        }
		    }
		  }

		  return '';
		}

		var loggedTypeFailures = {};
		var ReactDebugCurrentFrame = ReactSharedInternals.ReactDebugCurrentFrame;

		function setCurrentlyValidatingElement(element) {
		  {
		    if (element) {
		      var owner = element._owner;
		      var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
		      ReactDebugCurrentFrame.setExtraStackFrame(stack);
		    } else {
		      ReactDebugCurrentFrame.setExtraStackFrame(null);
		    }
		  }
		}

		function checkPropTypes(typeSpecs, values, location, componentName, element) {
		  {
		    // $FlowFixMe This is okay but Flow doesn't know it.
		    var has = Function.call.bind(Object.prototype.hasOwnProperty);

		    for (var typeSpecName in typeSpecs) {
		      if (has(typeSpecs, typeSpecName)) {
		        var error$1 = void 0; // Prop type validation may throw. In case they do, we don't want to
		        // fail the render phase where it didn't fail before. So we log it.
		        // After these have been cleaned up, we'll let them throw.

		        try {
		          // This is intentionally an invariant that gets caught. It's the same
		          // behavior as without this statement except with a better message.
		          if (typeof typeSpecs[typeSpecName] !== 'function') {
		            var err = Error((componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' + 'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.' + 'This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.');
		            err.name = 'Invariant Violation';
		            throw err;
		          }

		          error$1 = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED');
		        } catch (ex) {
		          error$1 = ex;
		        }

		        if (error$1 && !(error$1 instanceof Error)) {
		          setCurrentlyValidatingElement(element);

		          error('%s: type specification of %s' + ' `%s` is invalid; the type checker ' + 'function must return `null` or an `Error` but returned a %s. ' + 'You may have forgotten to pass an argument to the type checker ' + 'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' + 'shape all require an argument).', componentName || 'React class', location, typeSpecName, typeof error$1);

		          setCurrentlyValidatingElement(null);
		        }

		        if (error$1 instanceof Error && !(error$1.message in loggedTypeFailures)) {
		          // Only monitor this failure once because there tends to be a lot of the
		          // same error.
		          loggedTypeFailures[error$1.message] = true;
		          setCurrentlyValidatingElement(element);

		          error('Failed %s type: %s', location, error$1.message);

		          setCurrentlyValidatingElement(null);
		        }
		      }
		    }
		  }
		}

		var ReactCurrentOwner = ReactSharedInternals.ReactCurrentOwner;
		var hasOwnProperty = Object.prototype.hasOwnProperty;
		var RESERVED_PROPS = {
		  key: true,
		  ref: true,
		  __self: true,
		  __source: true
		};
		var specialPropKeyWarningShown;
		var specialPropRefWarningShown;
		var didWarnAboutStringRefs;

		{
		  didWarnAboutStringRefs = {};
		}

		function hasValidRef(config) {
		  {
		    if (hasOwnProperty.call(config, 'ref')) {
		      var getter = Object.getOwnPropertyDescriptor(config, 'ref').get;

		      if (getter && getter.isReactWarning) {
		        return false;
		      }
		    }
		  }

		  return config.ref !== undefined;
		}

		function hasValidKey(config) {
		  {
		    if (hasOwnProperty.call(config, 'key')) {
		      var getter = Object.getOwnPropertyDescriptor(config, 'key').get;

		      if (getter && getter.isReactWarning) {
		        return false;
		      }
		    }
		  }

		  return config.key !== undefined;
		}

		function warnIfStringRefCannotBeAutoConverted(config, self) {
		  {
		    if (typeof config.ref === 'string' && ReactCurrentOwner.current && self && ReactCurrentOwner.current.stateNode !== self) {
		      var componentName = getComponentName(ReactCurrentOwner.current.type);

		      if (!didWarnAboutStringRefs[componentName]) {
		        error('Component "%s" contains the string ref "%s". ' + 'Support for string refs will be removed in a future major release. ' + 'This case cannot be automatically converted to an arrow function. ' + 'We ask you to manually fix this case by using useRef() or createRef() instead. ' + 'Learn more about using refs safely here: ' + 'https://reactjs.org/link/strict-mode-string-ref', getComponentName(ReactCurrentOwner.current.type), config.ref);

		        didWarnAboutStringRefs[componentName] = true;
		      }
		    }
		  }
		}

		function defineKeyPropWarningGetter(props, displayName) {
		  {
		    var warnAboutAccessingKey = function () {
		      if (!specialPropKeyWarningShown) {
		        specialPropKeyWarningShown = true;

		        error('%s: `key` is not a prop. Trying to access it will result ' + 'in `undefined` being returned. If you need to access the same ' + 'value within the child component, you should pass it as a different ' + 'prop. (https://reactjs.org/link/special-props)', displayName);
		      }
		    };

		    warnAboutAccessingKey.isReactWarning = true;
		    Object.defineProperty(props, 'key', {
		      get: warnAboutAccessingKey,
		      configurable: true
		    });
		  }
		}

		function defineRefPropWarningGetter(props, displayName) {
		  {
		    var warnAboutAccessingRef = function () {
		      if (!specialPropRefWarningShown) {
		        specialPropRefWarningShown = true;

		        error('%s: `ref` is not a prop. Trying to access it will result ' + 'in `undefined` being returned. If you need to access the same ' + 'value within the child component, you should pass it as a different ' + 'prop. (https://reactjs.org/link/special-props)', displayName);
		      }
		    };

		    warnAboutAccessingRef.isReactWarning = true;
		    Object.defineProperty(props, 'ref', {
		      get: warnAboutAccessingRef,
		      configurable: true
		    });
		  }
		}
		/**
		 * Factory method to create a new React element. This no longer adheres to
		 * the class pattern, so do not use new to call it. Also, instanceof check
		 * will not work. Instead test $$typeof field against Symbol.for('react.element') to check
		 * if something is a React Element.
		 *
		 * @param {*} type
		 * @param {*} props
		 * @param {*} key
		 * @param {string|object} ref
		 * @param {*} owner
		 * @param {*} self A *temporary* helper to detect places where `this` is
		 * different from the `owner` when React.createElement is called, so that we
		 * can warn. We want to get rid of owner and replace string `ref`s with arrow
		 * functions, and as long as `this` and owner are the same, there will be no
		 * change in behavior.
		 * @param {*} source An annotation object (added by a transpiler or otherwise)
		 * indicating filename, line number, and/or other information.
		 * @internal
		 */


		var ReactElement = function (type, key, ref, self, source, owner, props) {
		  var element = {
		    // This tag allows us to uniquely identify this as a React Element
		    $$typeof: REACT_ELEMENT_TYPE,
		    // Built-in properties that belong on the element
		    type: type,
		    key: key,
		    ref: ref,
		    props: props,
		    // Record the component responsible for creating this element.
		    _owner: owner
		  };

		  {
		    // The validation flag is currently mutative. We put it on
		    // an external backing store so that we can freeze the whole object.
		    // This can be replaced with a WeakMap once they are implemented in
		    // commonly used development environments.
		    element._store = {}; // To make comparing ReactElements easier for testing purposes, we make
		    // the validation flag non-enumerable (where possible, which should
		    // include every environment we run tests in), so the test framework
		    // ignores it.

		    Object.defineProperty(element._store, 'validated', {
		      configurable: false,
		      enumerable: false,
		      writable: true,
		      value: false
		    }); // self and source are DEV only properties.

		    Object.defineProperty(element, '_self', {
		      configurable: false,
		      enumerable: false,
		      writable: false,
		      value: self
		    }); // Two elements created in two different places should be considered
		    // equal for testing purposes and therefore we hide it from enumeration.

		    Object.defineProperty(element, '_source', {
		      configurable: false,
		      enumerable: false,
		      writable: false,
		      value: source
		    });

		    if (Object.freeze) {
		      Object.freeze(element.props);
		      Object.freeze(element);
		    }
		  }

		  return element;
		};
		/**
		 * https://github.com/reactjs/rfcs/pull/107
		 * @param {*} type
		 * @param {object} props
		 * @param {string} key
		 */

		function jsxDEV(type, config, maybeKey, source, self) {
		  {
		    var propName; // Reserved names are extracted

		    var props = {};
		    var key = null;
		    var ref = null; // Currently, key can be spread in as a prop. This causes a potential
		    // issue if key is also explicitly declared (ie. <div {...props} key="Hi" />
		    // or <div key="Hi" {...props} /> ). We want to deprecate key spread,
		    // but as an intermediary step, we will use jsxDEV for everything except
		    // <div {...props} key="Hi" />, because we aren't currently able to tell if
		    // key is explicitly declared to be undefined or not.

		    if (maybeKey !== undefined) {
		      key = '' + maybeKey;
		    }

		    if (hasValidKey(config)) {
		      key = '' + config.key;
		    }

		    if (hasValidRef(config)) {
		      ref = config.ref;
		      warnIfStringRefCannotBeAutoConverted(config, self);
		    } // Remaining properties are added to a new props object


		    for (propName in config) {
		      if (hasOwnProperty.call(config, propName) && !RESERVED_PROPS.hasOwnProperty(propName)) {
		        props[propName] = config[propName];
		      }
		    } // Resolve default props


		    if (type && type.defaultProps) {
		      var defaultProps = type.defaultProps;

		      for (propName in defaultProps) {
		        if (props[propName] === undefined) {
		          props[propName] = defaultProps[propName];
		        }
		      }
		    }

		    if (key || ref) {
		      var displayName = typeof type === 'function' ? type.displayName || type.name || 'Unknown' : type;

		      if (key) {
		        defineKeyPropWarningGetter(props, displayName);
		      }

		      if (ref) {
		        defineRefPropWarningGetter(props, displayName);
		      }
		    }

		    return ReactElement(type, key, ref, self, source, ReactCurrentOwner.current, props);
		  }
		}

		var ReactCurrentOwner$1 = ReactSharedInternals.ReactCurrentOwner;
		var ReactDebugCurrentFrame$1 = ReactSharedInternals.ReactDebugCurrentFrame;

		function setCurrentlyValidatingElement$1(element) {
		  {
		    if (element) {
		      var owner = element._owner;
		      var stack = describeUnknownElementTypeFrameInDEV(element.type, element._source, owner ? owner.type : null);
		      ReactDebugCurrentFrame$1.setExtraStackFrame(stack);
		    } else {
		      ReactDebugCurrentFrame$1.setExtraStackFrame(null);
		    }
		  }
		}

		var propTypesMisspellWarningShown;

		{
		  propTypesMisspellWarningShown = false;
		}
		/**
		 * Verifies the object is a ReactElement.
		 * See https://reactjs.org/docs/react-api.html#isvalidelement
		 * @param {?object} object
		 * @return {boolean} True if `object` is a ReactElement.
		 * @final
		 */

		function isValidElement(object) {
		  {
		    return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
		  }
		}

		function getDeclarationErrorAddendum() {
		  {
		    if (ReactCurrentOwner$1.current) {
		      var name = getComponentName(ReactCurrentOwner$1.current.type);

		      if (name) {
		        return '\n\nCheck the render method of `' + name + '`.';
		      }
		    }

		    return '';
		  }
		}

		function getSourceInfoErrorAddendum(source) {
		  {
		    if (source !== undefined) {
		      var fileName = source.fileName.replace(/^.*[\\\/]/, '');
		      var lineNumber = source.lineNumber;
		      return '\n\nCheck your code at ' + fileName + ':' + lineNumber + '.';
		    }

		    return '';
		  }
		}
		/**
		 * Warn if there's no key explicitly set on dynamic arrays of children or
		 * object keys are not valid. This allows us to keep track of children between
		 * updates.
		 */


		var ownerHasKeyUseWarning = {};

		function getCurrentComponentErrorInfo(parentType) {
		  {
		    var info = getDeclarationErrorAddendum();

		    if (!info) {
		      var parentName = typeof parentType === 'string' ? parentType : parentType.displayName || parentType.name;

		      if (parentName) {
		        info = "\n\nCheck the top-level render call using <" + parentName + ">.";
		      }
		    }

		    return info;
		  }
		}
		/**
		 * Warn if the element doesn't have an explicit key assigned to it.
		 * This element is in an array. The array could grow and shrink or be
		 * reordered. All children that haven't already been validated are required to
		 * have a "key" property assigned to it. Error statuses are cached so a warning
		 * will only be shown once.
		 *
		 * @internal
		 * @param {ReactElement} element Element that requires a key.
		 * @param {*} parentType element's parent's type.
		 */


		function validateExplicitKey(element, parentType) {
		  {
		    if (!element._store || element._store.validated || element.key != null) {
		      return;
		    }

		    element._store.validated = true;
		    var currentComponentErrorInfo = getCurrentComponentErrorInfo(parentType);

		    if (ownerHasKeyUseWarning[currentComponentErrorInfo]) {
		      return;
		    }

		    ownerHasKeyUseWarning[currentComponentErrorInfo] = true; // Usually the current owner is the offender, but if it accepts children as a
		    // property, it may be the creator of the child that's responsible for
		    // assigning it a key.

		    var childOwner = '';

		    if (element && element._owner && element._owner !== ReactCurrentOwner$1.current) {
		      // Give the component that originally created this child.
		      childOwner = " It was passed a child from " + getComponentName(element._owner.type) + ".";
		    }

		    setCurrentlyValidatingElement$1(element);

		    error('Each child in a list should have a unique "key" prop.' + '%s%s See https://reactjs.org/link/warning-keys for more information.', currentComponentErrorInfo, childOwner);

		    setCurrentlyValidatingElement$1(null);
		  }
		}
		/**
		 * Ensure that every element either is passed in a static location, in an
		 * array with an explicit keys property defined, or in an object literal
		 * with valid key property.
		 *
		 * @internal
		 * @param {ReactNode} node Statically passed child of any type.
		 * @param {*} parentType node's parent's type.
		 */


		function validateChildKeys(node, parentType) {
		  {
		    if (typeof node !== 'object') {
		      return;
		    }

		    if (Array.isArray(node)) {
		      for (var i = 0; i < node.length; i++) {
		        var child = node[i];

		        if (isValidElement(child)) {
		          validateExplicitKey(child, parentType);
		        }
		      }
		    } else if (isValidElement(node)) {
		      // This element was passed in a valid location.
		      if (node._store) {
		        node._store.validated = true;
		      }
		    } else if (node) {
		      var iteratorFn = getIteratorFn(node);

		      if (typeof iteratorFn === 'function') {
		        // Entry iterators used to provide implicit keys,
		        // but now we print a separate warning for them later.
		        if (iteratorFn !== node.entries) {
		          var iterator = iteratorFn.call(node);
		          var step;

		          while (!(step = iterator.next()).done) {
		            if (isValidElement(step.value)) {
		              validateExplicitKey(step.value, parentType);
		            }
		          }
		        }
		      }
		    }
		  }
		}
		/**
		 * Given an element, validate that its props follow the propTypes definition,
		 * provided by the type.
		 *
		 * @param {ReactElement} element
		 */


		function validatePropTypes(element) {
		  {
		    var type = element.type;

		    if (type === null || type === undefined || typeof type === 'string') {
		      return;
		    }

		    var propTypes;

		    if (typeof type === 'function') {
		      propTypes = type.propTypes;
		    } else if (typeof type === 'object' && (type.$$typeof === REACT_FORWARD_REF_TYPE || // Note: Memo only checks outer props here.
		    // Inner props are checked in the reconciler.
		    type.$$typeof === REACT_MEMO_TYPE)) {
		      propTypes = type.propTypes;
		    } else {
		      return;
		    }

		    if (propTypes) {
		      // Intentionally inside to avoid triggering lazy initializers:
		      var name = getComponentName(type);
		      checkPropTypes(propTypes, element.props, 'prop', name, element);
		    } else if (type.PropTypes !== undefined && !propTypesMisspellWarningShown) {
		      propTypesMisspellWarningShown = true; // Intentionally inside to avoid triggering lazy initializers:

		      var _name = getComponentName(type);

		      error('Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?', _name || 'Unknown');
		    }

		    if (typeof type.getDefaultProps === 'function' && !type.getDefaultProps.isReactClassApproved) {
		      error('getDefaultProps is only used on classic React.createClass ' + 'definitions. Use a static property named `defaultProps` instead.');
		    }
		  }
		}
		/**
		 * Given a fragment, validate that it can only be provided with fragment props
		 * @param {ReactElement} fragment
		 */


		function validateFragmentProps(fragment) {
		  {
		    var keys = Object.keys(fragment.props);

		    for (var i = 0; i < keys.length; i++) {
		      var key = keys[i];

		      if (key !== 'children' && key !== 'key') {
		        setCurrentlyValidatingElement$1(fragment);

		        error('Invalid prop `%s` supplied to `React.Fragment`. ' + 'React.Fragment can only have `key` and `children` props.', key);

		        setCurrentlyValidatingElement$1(null);
		        break;
		      }
		    }

		    if (fragment.ref !== null) {
		      setCurrentlyValidatingElement$1(fragment);

		      error('Invalid attribute `ref` supplied to `React.Fragment`.');

		      setCurrentlyValidatingElement$1(null);
		    }
		  }
		}

		function jsxWithValidation(type, props, key, isStaticChildren, source, self) {
		  {
		    var validType = isValidElementType(type); // We warn in this case but don't throw. We expect the element creation to
		    // succeed and there will likely be errors in render.

		    if (!validType) {
		      var info = '';

		      if (type === undefined || typeof type === 'object' && type !== null && Object.keys(type).length === 0) {
		        info += ' You likely forgot to export your component from the file ' + "it's defined in, or you might have mixed up default and named imports.";
		      }

		      var sourceInfo = getSourceInfoErrorAddendum(source);

		      if (sourceInfo) {
		        info += sourceInfo;
		      } else {
		        info += getDeclarationErrorAddendum();
		      }

		      var typeString;

		      if (type === null) {
		        typeString = 'null';
		      } else if (Array.isArray(type)) {
		        typeString = 'array';
		      } else if (type !== undefined && type.$$typeof === REACT_ELEMENT_TYPE) {
		        typeString = "<" + (getComponentName(type.type) || 'Unknown') + " />";
		        info = ' Did you accidentally export a JSX literal instead of a component?';
		      } else {
		        typeString = typeof type;
		      }

		      error('React.jsx: type is invalid -- expected a string (for ' + 'built-in components) or a class/function (for composite ' + 'components) but got: %s.%s', typeString, info);
		    }

		    var element = jsxDEV(type, props, key, source, self); // The result can be nullish if a mock or a custom function is used.
		    // TODO: Drop this when these are no longer allowed as the type argument.

		    if (element == null) {
		      return element;
		    } // Skip key warning if the type isn't valid since our key validation logic
		    // doesn't expect a non-string/function type and can throw confusing errors.
		    // We don't want exception behavior to differ between dev and prod.
		    // (Rendering will throw with a helpful message and as soon as the type is
		    // fixed, the key warnings will appear.)


		    if (validType) {
		      var children = props.children;

		      if (children !== undefined) {
		        if (isStaticChildren) {
		          if (Array.isArray(children)) {
		            for (var i = 0; i < children.length; i++) {
		              validateChildKeys(children[i], type);
		            }

		            if (Object.freeze) {
		              Object.freeze(children);
		            }
		          } else {
		            error('React.jsx: Static children should always be an array. ' + 'You are likely explicitly calling React.jsxs or React.jsxDEV. ' + 'Use the Babel transform instead.');
		          }
		        } else {
		          validateChildKeys(children, type);
		        }
		      }
		    }

		    if (type === exports.Fragment) {
		      validateFragmentProps(element);
		    } else {
		      validatePropTypes(element);
		    }

		    return element;
		  }
		} // These two functions exist to still get child warnings in dev
		// even with the prod transform. This means that jsxDEV is purely
		// opt-in behavior for better messages but that we won't stop
		// giving you warnings if you use production apis.

		function jsxWithValidationStatic(type, props, key) {
		  {
		    return jsxWithValidation(type, props, key, true);
		  }
		}
		function jsxWithValidationDynamic(type, props, key) {
		  {
		    return jsxWithValidation(type, props, key, false);
		  }
		}

		var jsx =  jsxWithValidationDynamic ; // we may want to special case jsxs internally to take advantage of static children.
		// for now we can ship identical prod functions

		var jsxs =  jsxWithValidationStatic ;

		exports.jsx = jsx;
		exports.jsxs = jsxs;
		  })();
		}
} (reactJsxRuntime_development));
	return reactJsxRuntime_development;
}

var hasRequiredJsxRuntime;

function requireJsxRuntime () {
	if (hasRequiredJsxRuntime) return jsxRuntimeExports$1;
	hasRequiredJsxRuntime = 1;
	(function (module) {

		if (browser$1.env.NODE_ENV === 'production') {
		  module.exports = requireReactJsxRuntime_production_min();
		} else {
		  module.exports = requireReactJsxRuntime_development();
		}
} (jsxRuntime));
	return jsxRuntimeExports$1;
}

var jsxRuntimeExports = requireJsxRuntime();

const defaultContextValue = {
  disableDefaultClasses: false
};
const ClassNameConfiguratorContext = /*#__PURE__*/React__namespace.createContext(defaultContextValue);
/**
 * @ignore - internal hook.
 *
 * Wraps the `generateUtilityClass` function and controls how the classes are generated.
 * Currently it only affects whether the classes are applied or not.
 *
 * @returns Function to be called with the `generateUtilityClass` function specific to a component to generate the classes.
 */
function useClassNamesOverride(generateUtilityClass) {
  const {
    disableDefaultClasses
  } = React__namespace.useContext(ClassNameConfiguratorContext);
  return slot => {
    if (disableDefaultClasses) {
      return '';
    }
    return generateUtilityClass(slot);
  };
}

/**
 * Extracts event handlers from a given object.
 * A prop is considered an event handler if it is a function and its name starts with `on`.
 *
 * @param object An object to extract event handlers from.
 * @param excludeKeys An array of keys to exclude from the returned object.
 */
function extractEventHandlers(object, excludeKeys = []) {
  if (object === undefined) {
    return {};
  }
  const result = {};
  Object.keys(object).filter(prop => prop.match(/^on[A-Z]/) && typeof object[prop] === 'function' && !excludeKeys.includes(prop)).forEach(prop => {
    result[prop] = object[prop];
  });
  return result;
}

/**
 * If `componentProps` is a function, calls it with the provided `ownerState`.
 * Otherwise, just returns `componentProps`.
 */
function resolveComponentProps(componentProps, ownerState) {
  if (typeof componentProps === 'function') {
    return componentProps(ownerState);
  }
  return componentProps;
}

/**
 * Removes event handlers from the given object.
 * A field is considered an event handler if it is a function with a name beginning with `on`.
 *
 * @param object Object to remove event handlers from.
 * @returns Object with event handlers removed.
 */
function omitEventHandlers(object) {
  if (object === undefined) {
    return {};
  }
  const result = {};
  Object.keys(object).filter(prop => !(prop.match(/^on[A-Z]/) && typeof object[prop] === 'function')).forEach(prop => {
    result[prop] = object[prop];
  });
  return result;
}

/**
 * Merges the slot component internal props (usually coming from a hook)
 * with the externally provided ones.
 *
 * The merge order is (the latter overrides the former):
 * 1. The internal props (specified as a getter function to work with get*Props hook result)
 * 2. Additional props (specified internally on an unstyled component)
 * 3. External props specified on the owner component. These should only be used on a root slot.
 * 4. External props specified in the `slotProps.*` prop.
 * 5. The `className` prop - combined from all the above.
 * @param parameters
 * @returns
 */
function mergeSlotProps(parameters) {
  const {
    getSlotProps,
    additionalProps,
    externalSlotProps,
    externalForwardedProps,
    className
  } = parameters;
  if (!getSlotProps) {
    // The simpler case - getSlotProps is not defined, so no internal event handlers are defined,
    // so we can simply merge all the props without having to worry about extracting event handlers.
    const joinedClasses = clsx(externalForwardedProps == null ? void 0 : externalForwardedProps.className, externalSlotProps == null ? void 0 : externalSlotProps.className, className, additionalProps == null ? void 0 : additionalProps.className);
    const mergedStyle = _extends$1({}, additionalProps == null ? void 0 : additionalProps.style, externalForwardedProps == null ? void 0 : externalForwardedProps.style, externalSlotProps == null ? void 0 : externalSlotProps.style);
    const props = _extends$1({}, additionalProps, externalForwardedProps, externalSlotProps);
    if (joinedClasses.length > 0) {
      props.className = joinedClasses;
    }
    if (Object.keys(mergedStyle).length > 0) {
      props.style = mergedStyle;
    }
    return {
      props,
      internalRef: undefined
    };
  }

  // In this case, getSlotProps is responsible for calling the external event handlers.
  // We don't need to include them in the merged props because of this.

  const eventHandlers = extractEventHandlers(_extends$1({}, externalForwardedProps, externalSlotProps));
  const componentsPropsWithoutEventHandlers = omitEventHandlers(externalSlotProps);
  const otherPropsWithoutEventHandlers = omitEventHandlers(externalForwardedProps);
  const internalSlotProps = getSlotProps(eventHandlers);

  // The order of classes is important here.
  // Emotion (that we use in libraries consuming MUI Base) depends on this order
  // to properly override style. It requires the most important classes to be last
  // (see https://github.com/mui/material-ui/pull/33205) for the related discussion.
  const joinedClasses = clsx(internalSlotProps == null ? void 0 : internalSlotProps.className, additionalProps == null ? void 0 : additionalProps.className, className, externalForwardedProps == null ? void 0 : externalForwardedProps.className, externalSlotProps == null ? void 0 : externalSlotProps.className);
  const mergedStyle = _extends$1({}, internalSlotProps == null ? void 0 : internalSlotProps.style, additionalProps == null ? void 0 : additionalProps.style, externalForwardedProps == null ? void 0 : externalForwardedProps.style, externalSlotProps == null ? void 0 : externalSlotProps.style);
  const props = _extends$1({}, internalSlotProps, additionalProps, otherPropsWithoutEventHandlers, componentsPropsWithoutEventHandlers);
  if (joinedClasses.length > 0) {
    props.className = joinedClasses;
  }
  if (Object.keys(mergedStyle).length > 0) {
    props.style = mergedStyle;
  }
  return {
    props,
    internalRef: internalSlotProps.ref
  };
}

const _excluded$1B = ["elementType", "externalSlotProps", "ownerState"];
/**
 * @ignore - do not document.
 * Builds the props to be passed into the slot of an unstyled component.
 * It merges the internal props of the component with the ones supplied by the user, allowing to customize the behavior.
 * If the slot component is not a host component, it also merges in the `ownerState`.
 *
 * @param parameters.getSlotProps - A function that returns the props to be passed to the slot component.
 */
function useSlotProps(parameters) {
  var _parameters$additiona;
  const {
      elementType,
      externalSlotProps,
      ownerState
    } = parameters,
    rest = _objectWithoutPropertiesLoose(parameters, _excluded$1B);
  const resolvedComponentsProps = resolveComponentProps(externalSlotProps, ownerState);
  const {
    props: mergedProps,
    internalRef
  } = mergeSlotProps(_extends$1({}, rest, {
    externalSlotProps: resolvedComponentsProps
  }));
  const ref = useForkRef(internalRef, resolvedComponentsProps == null ? void 0 : resolvedComponentsProps.ref, (_parameters$additiona = parameters.additionalProps) == null ? void 0 : _parameters$additiona.ref);
  const props = appendOwnerState(elementType, _extends$1({}, mergedProps, {
    ref
  }), ownerState);
  return props;
}

// Inspired by https://github.com/focus-trap/tabbable
const candidatesSelector = ['input', 'select', 'textarea', 'a[href]', 'button', '[tabindex]', 'audio[controls]', 'video[controls]', '[contenteditable]:not([contenteditable="false"])'].join(',');
function getTabIndex(node) {
  const tabindexAttr = parseInt(node.getAttribute('tabindex') || '', 10);
  if (!Number.isNaN(tabindexAttr)) {
    return tabindexAttr;
  }

  // Browsers do not return `tabIndex` correctly for contentEditable nodes;
  // https://bugs.chromium.org/p/chromium/issues/detail?id=661108&q=contenteditable%20tabindex&can=2
  // so if they don't have a tabindex attribute specifically set, assume it's 0.
  // in Chrome, <details/>, <audio controls/> and <video controls/> elements get a default
  //  `tabIndex` of -1 when the 'tabindex' attribute isn't specified in the DOM,
  //  yet they are still part of the regular tab order; in FF, they get a default
  //  `tabIndex` of 0; since Chrome still puts those elements in the regular tab
  //  order, consider their tab index to be 0.
  if (node.contentEditable === 'true' || (node.nodeName === 'AUDIO' || node.nodeName === 'VIDEO' || node.nodeName === 'DETAILS') && node.getAttribute('tabindex') === null) {
    return 0;
  }
  return node.tabIndex;
}
function isNonTabbableRadio(node) {
  if (node.tagName !== 'INPUT' || node.type !== 'radio') {
    return false;
  }
  if (!node.name) {
    return false;
  }
  const getRadio = selector => node.ownerDocument.querySelector(`input[type="radio"]${selector}`);
  let roving = getRadio(`[name="${node.name}"]:checked`);
  if (!roving) {
    roving = getRadio(`[name="${node.name}"]`);
  }
  return roving !== node;
}
function isNodeMatchingSelectorFocusable(node) {
  if (node.disabled || node.tagName === 'INPUT' && node.type === 'hidden' || isNonTabbableRadio(node)) {
    return false;
  }
  return true;
}
function defaultGetTabbable(root) {
  const regularTabNodes = [];
  const orderedTabNodes = [];
  Array.from(root.querySelectorAll(candidatesSelector)).forEach((node, i) => {
    const nodeTabIndex = getTabIndex(node);
    if (nodeTabIndex === -1 || !isNodeMatchingSelectorFocusable(node)) {
      return;
    }
    if (nodeTabIndex === 0) {
      regularTabNodes.push(node);
    } else {
      orderedTabNodes.push({
        documentOrder: i,
        tabIndex: nodeTabIndex,
        node: node
      });
    }
  });
  return orderedTabNodes.sort((a, b) => a.tabIndex === b.tabIndex ? a.documentOrder - b.documentOrder : a.tabIndex - b.tabIndex).map(a => a.node).concat(regularTabNodes);
}
function defaultIsEnabled() {
  return true;
}

/**
 * Utility component that locks focus inside the component.
 *
 * Demos:
 *
 * - [Focus Trap](https://mui.com/base/react-focus-trap/)
 *
 * API:
 *
 * - [FocusTrap API](https://mui.com/base/api/focus-trap/)
 */
function FocusTrap(props) {
  const {
    children,
    disableAutoFocus = false,
    disableEnforceFocus = false,
    disableRestoreFocus = false,
    getTabbable = defaultGetTabbable,
    isEnabled = defaultIsEnabled,
    open
  } = props;
  const ignoreNextEnforceFocus = React__namespace.useRef(false);
  const sentinelStart = React__namespace.useRef(null);
  const sentinelEnd = React__namespace.useRef(null);
  const nodeToRestore = React__namespace.useRef(null);
  const reactFocusEventTarget = React__namespace.useRef(null);
  // This variable is useful when disableAutoFocus is true.
  // It waits for the active element to move into the component to activate.
  const activated = React__namespace.useRef(false);
  const rootRef = React__namespace.useRef(null);
  // @ts-expect-error TODO upstream fix
  const handleRef = useForkRef(children.ref, rootRef);
  const lastKeydown = React__namespace.useRef(null);
  React__namespace.useEffect(() => {
    // We might render an empty child.
    if (!open || !rootRef.current) {
      return;
    }
    activated.current = !disableAutoFocus;
  }, [disableAutoFocus, open]);
  React__namespace.useEffect(() => {
    // We might render an empty child.
    if (!open || !rootRef.current) {
      return;
    }
    const doc = ownerDocument(rootRef.current);
    if (!rootRef.current.contains(doc.activeElement)) {
      if (!rootRef.current.hasAttribute('tabIndex')) {
        if (browser$1.env.NODE_ENV !== 'production') {
          console.error(['MUI: The modal content node does not accept focus.', 'For the benefit of assistive technologies, ' + 'the tabIndex of the node is being set to "-1".'].join('\n'));
        }
        rootRef.current.setAttribute('tabIndex', '-1');
      }
      if (activated.current) {
        rootRef.current.focus();
      }
    }
    return () => {
      // restoreLastFocus()
      if (!disableRestoreFocus) {
        // In IE11 it is possible for document.activeElement to be null resulting
        // in nodeToRestore.current being null.
        // Not all elements in IE11 have a focus method.
        // Once IE11 support is dropped the focus() call can be unconditional.
        if (nodeToRestore.current && nodeToRestore.current.focus) {
          ignoreNextEnforceFocus.current = true;
          nodeToRestore.current.focus();
        }
        nodeToRestore.current = null;
      }
    };
    // Missing `disableRestoreFocus` which is fine.
    // We don't support changing that prop on an open FocusTrap
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [open]);
  React__namespace.useEffect(() => {
    // We might render an empty child.
    if (!open || !rootRef.current) {
      return;
    }
    const doc = ownerDocument(rootRef.current);
    const contain = nativeEvent => {
      const {
        current: rootElement
      } = rootRef;

      // Cleanup functions are executed lazily in React 17.
      // Contain can be called between the component being unmounted and its cleanup function being run.
      if (rootElement === null) {
        return;
      }
      if (!doc.hasFocus() || disableEnforceFocus || !isEnabled() || ignoreNextEnforceFocus.current) {
        ignoreNextEnforceFocus.current = false;
        return;
      }
      if (!rootElement.contains(doc.activeElement)) {
        // if the focus event is not coming from inside the children's react tree, reset the refs
        if (nativeEvent && reactFocusEventTarget.current !== nativeEvent.target || doc.activeElement !== reactFocusEventTarget.current) {
          reactFocusEventTarget.current = null;
        } else if (reactFocusEventTarget.current !== null) {
          return;
        }
        if (!activated.current) {
          return;
        }
        let tabbable = [];
        if (doc.activeElement === sentinelStart.current || doc.activeElement === sentinelEnd.current) {
          tabbable = getTabbable(rootRef.current);
        }
        if (tabbable.length > 0) {
          var _lastKeydown$current, _lastKeydown$current2;
          const isShiftTab = Boolean(((_lastKeydown$current = lastKeydown.current) == null ? void 0 : _lastKeydown$current.shiftKey) && ((_lastKeydown$current2 = lastKeydown.current) == null ? void 0 : _lastKeydown$current2.key) === 'Tab');
          const focusNext = tabbable[0];
          const focusPrevious = tabbable[tabbable.length - 1];
          if (typeof focusNext !== 'string' && typeof focusPrevious !== 'string') {
            if (isShiftTab) {
              focusPrevious.focus();
            } else {
              focusNext.focus();
            }
          }
        } else {
          rootElement.focus();
        }
      }
    };
    const loopFocus = nativeEvent => {
      lastKeydown.current = nativeEvent;
      if (disableEnforceFocus || !isEnabled() || nativeEvent.key !== 'Tab') {
        return;
      }

      // Make sure the next tab starts from the right place.
      // doc.activeElement refers to the origin.
      if (doc.activeElement === rootRef.current && nativeEvent.shiftKey) {
        // We need to ignore the next contain as
        // it will try to move the focus back to the rootRef element.
        ignoreNextEnforceFocus.current = true;
        if (sentinelEnd.current) {
          sentinelEnd.current.focus();
        }
      }
    };
    doc.addEventListener('focusin', contain);
    doc.addEventListener('keydown', loopFocus, true);

    // With Edge, Safari and Firefox, no focus related events are fired when the focused area stops being a focused area.
    // e.g. https://bugzilla.mozilla.org/show_bug.cgi?id=559561.
    // Instead, we can look if the active element was restored on the BODY element.
    //
    // The whatwg spec defines how the browser should behave but does not explicitly mention any events:
    // https://html.spec.whatwg.org/multipage/interaction.html#focus-fixup-rule.
    const interval = setInterval(() => {
      if (doc.activeElement && doc.activeElement.tagName === 'BODY') {
        contain(null);
      }
    }, 50);
    return () => {
      clearInterval(interval);
      doc.removeEventListener('focusin', contain);
      doc.removeEventListener('keydown', loopFocus, true);
    };
  }, [disableAutoFocus, disableEnforceFocus, disableRestoreFocus, isEnabled, open, getTabbable]);
  const onFocus = event => {
    if (nodeToRestore.current === null) {
      nodeToRestore.current = event.relatedTarget;
    }
    activated.current = true;
    reactFocusEventTarget.current = event.target;
    const childrenPropsHandler = children.props.onFocus;
    if (childrenPropsHandler) {
      childrenPropsHandler(event);
    }
  };
  const handleFocusSentinel = event => {
    if (nodeToRestore.current === null) {
      nodeToRestore.current = event.relatedTarget;
    }
    activated.current = true;
  };
  return /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
    children: [/*#__PURE__*/jsxRuntimeExports.jsx("div", {
      tabIndex: open ? 0 : -1,
      onFocus: handleFocusSentinel,
      ref: sentinelStart,
      "data-testid": "sentinelStart"
    }), /*#__PURE__*/React__namespace.cloneElement(children, {
      ref: handleRef,
      onFocus
    }), /*#__PURE__*/jsxRuntimeExports.jsx("div", {
      tabIndex: open ? 0 : -1,
      onFocus: handleFocusSentinel,
      ref: sentinelEnd,
      "data-testid": "sentinelEnd"
    })]
  });
}
browser$1.env.NODE_ENV !== "production" ? FocusTrap.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------
  /**
   * A single child content element.
   */
  children: elementAcceptingRef$1,
  /**
   * If `true`, the focus trap will not automatically shift focus to itself when it opens, and
   * replace it to the last focused element when it closes.
   * This also works correctly with any focus trap children that have the `disableAutoFocus` prop.
   *
   * Generally this should never be set to `true` as it makes the focus trap less
   * accessible to assistive technologies, like screen readers.
   * @default false
   */
  disableAutoFocus: propTypesExports.bool,
  /**
   * If `true`, the focus trap will not prevent focus from leaving the focus trap while open.
   *
   * Generally this should never be set to `true` as it makes the focus trap less
   * accessible to assistive technologies, like screen readers.
   * @default false
   */
  disableEnforceFocus: propTypesExports.bool,
  /**
   * If `true`, the focus trap will not restore focus to previously focused element once
   * focus trap is hidden or unmounted.
   * @default false
   */
  disableRestoreFocus: propTypesExports.bool,
  /**
   * Returns an array of ordered tabbable nodes (i.e. in tab order) within the root.
   * For instance, you can provide the "tabbable" npm dependency.
   * @param {HTMLElement} root
   */
  getTabbable: propTypesExports.func,
  /**
   * This prop extends the `open` prop.
   * It allows to toggle the open state without having to wait for a rerender when changing the `open` prop.
   * This prop should be memoized.
   * It can be used to support multiple focus trap mounted at the same time.
   * @default function defaultIsEnabled(): boolean {
   *   return true;
   * }
   */
  isEnabled: propTypesExports.func,
  /**
   * If `true`, focus is locked.
   */
  open: propTypesExports.bool.isRequired
} : void 0;
if (browser$1.env.NODE_ENV !== 'production') {
  // eslint-disable-next-line
  FocusTrap['propTypes' + ''] = exactProp(FocusTrap.propTypes);
}

var top = 'top';
var bottom = 'bottom';
var right = 'right';
var left = 'left';
var auto = 'auto';
var basePlacements = [top, bottom, right, left];
var start = 'start';
var end = 'end';
var clippingParents = 'clippingParents';
var viewport = 'viewport';
var popper = 'popper';
var reference = 'reference';
var variationPlacements = /*#__PURE__*/basePlacements.reduce(function (acc, placement) {
  return acc.concat([placement + "-" + start, placement + "-" + end]);
}, []);
var placements = /*#__PURE__*/[].concat(basePlacements, [auto]).reduce(function (acc, placement) {
  return acc.concat([placement, placement + "-" + start, placement + "-" + end]);
}, []); // modifiers that need to read the DOM

var beforeRead = 'beforeRead';
var read = 'read';
var afterRead = 'afterRead'; // pure-logic modifiers

var beforeMain = 'beforeMain';
var main = 'main';
var afterMain = 'afterMain'; // modifier with the purpose to write to the DOM (or write into a framework state)

var beforeWrite = 'beforeWrite';
var write = 'write';
var afterWrite = 'afterWrite';
var modifierPhases = [beforeRead, read, afterRead, beforeMain, main, afterMain, beforeWrite, write, afterWrite];

function getNodeName(element) {
  return element ? (element.nodeName || '').toLowerCase() : null;
}

function getWindow(node) {
  if (node == null) {
    return window;
  }

  if (node.toString() !== '[object Window]') {
    var ownerDocument = node.ownerDocument;
    return ownerDocument ? ownerDocument.defaultView || window : window;
  }

  return node;
}

function isElement(node) {
  var OwnElement = getWindow(node).Element;
  return node instanceof OwnElement || node instanceof Element;
}

function isHTMLElement$1(node) {
  var OwnElement = getWindow(node).HTMLElement;
  return node instanceof OwnElement || node instanceof HTMLElement;
}

function isShadowRoot(node) {
  // IE 11 has no ShadowRoot
  if (typeof ShadowRoot === 'undefined') {
    return false;
  }

  var OwnElement = getWindow(node).ShadowRoot;
  return node instanceof OwnElement || node instanceof ShadowRoot;
}

// and applies them to the HTMLElements such as popper and arrow

function applyStyles(_ref) {
  var state = _ref.state;
  Object.keys(state.elements).forEach(function (name) {
    var style = state.styles[name] || {};
    var attributes = state.attributes[name] || {};
    var element = state.elements[name]; // arrow is optional + virtual elements

    if (!isHTMLElement$1(element) || !getNodeName(element)) {
      return;
    } // Flow doesn't support to extend this property, but it's the most
    // effective way to apply styles to an HTMLElement
    // $FlowFixMe[cannot-write]


    Object.assign(element.style, style);
    Object.keys(attributes).forEach(function (name) {
      var value = attributes[name];

      if (value === false) {
        element.removeAttribute(name);
      } else {
        element.setAttribute(name, value === true ? '' : value);
      }
    });
  });
}

function effect$2(_ref2) {
  var state = _ref2.state;
  var initialStyles = {
    popper: {
      position: state.options.strategy,
      left: '0',
      top: '0',
      margin: '0'
    },
    arrow: {
      position: 'absolute'
    },
    reference: {}
  };
  Object.assign(state.elements.popper.style, initialStyles.popper);
  state.styles = initialStyles;

  if (state.elements.arrow) {
    Object.assign(state.elements.arrow.style, initialStyles.arrow);
  }

  return function () {
    Object.keys(state.elements).forEach(function (name) {
      var element = state.elements[name];
      var attributes = state.attributes[name] || {};
      var styleProperties = Object.keys(state.styles.hasOwnProperty(name) ? state.styles[name] : initialStyles[name]); // Set all values to an empty string to unset them

      var style = styleProperties.reduce(function (style, property) {
        style[property] = '';
        return style;
      }, {}); // arrow is optional + virtual elements

      if (!isHTMLElement$1(element) || !getNodeName(element)) {
        return;
      }

      Object.assign(element.style, style);
      Object.keys(attributes).forEach(function (attribute) {
        element.removeAttribute(attribute);
      });
    });
  };
} // eslint-disable-next-line import/no-unused-modules


var applyStyles$1 = {
  name: 'applyStyles',
  enabled: true,
  phase: 'write',
  fn: applyStyles,
  effect: effect$2,
  requires: ['computeStyles']
};

function getBasePlacement(placement) {
  return placement.split('-')[0];
}

var max = Math.max;
var min = Math.min;
var round$2 = Math.round;

function getUAString() {
  var uaData = navigator.userAgentData;

  if (uaData != null && uaData.brands) {
    return uaData.brands.map(function (item) {
      return item.brand + "/" + item.version;
    }).join(' ');
  }

  return navigator.userAgent;
}

function isLayoutViewport() {
  return !/^((?!chrome|android).)*safari/i.test(getUAString());
}

function getBoundingClientRect(element, includeScale, isFixedStrategy) {
  if (includeScale === void 0) {
    includeScale = false;
  }

  if (isFixedStrategy === void 0) {
    isFixedStrategy = false;
  }

  var clientRect = element.getBoundingClientRect();
  var scaleX = 1;
  var scaleY = 1;

  if (includeScale && isHTMLElement$1(element)) {
    scaleX = element.offsetWidth > 0 ? round$2(clientRect.width) / element.offsetWidth || 1 : 1;
    scaleY = element.offsetHeight > 0 ? round$2(clientRect.height) / element.offsetHeight || 1 : 1;
  }

  var _ref = isElement(element) ? getWindow(element) : window,
      visualViewport = _ref.visualViewport;

  var addVisualOffsets = !isLayoutViewport() && isFixedStrategy;
  var x = (clientRect.left + (addVisualOffsets && visualViewport ? visualViewport.offsetLeft : 0)) / scaleX;
  var y = (clientRect.top + (addVisualOffsets && visualViewport ? visualViewport.offsetTop : 0)) / scaleY;
  var width = clientRect.width / scaleX;
  var height = clientRect.height / scaleY;
  return {
    width: width,
    height: height,
    top: y,
    right: x + width,
    bottom: y + height,
    left: x,
    x: x,
    y: y
  };
}

// means it doesn't take into account transforms.

function getLayoutRect(element) {
  var clientRect = getBoundingClientRect(element); // Use the clientRect sizes if it's not been transformed.
  // Fixes https://github.com/popperjs/popper-core/issues/1223

  var width = element.offsetWidth;
  var height = element.offsetHeight;

  if (Math.abs(clientRect.width - width) <= 1) {
    width = clientRect.width;
  }

  if (Math.abs(clientRect.height - height) <= 1) {
    height = clientRect.height;
  }

  return {
    x: element.offsetLeft,
    y: element.offsetTop,
    width: width,
    height: height
  };
}

function contains(parent, child) {
  var rootNode = child.getRootNode && child.getRootNode(); // First, attempt with faster native method

  if (parent.contains(child)) {
    return true;
  } // then fallback to custom implementation with Shadow DOM support
  else if (rootNode && isShadowRoot(rootNode)) {
      var next = child;

      do {
        if (next && parent.isSameNode(next)) {
          return true;
        } // $FlowFixMe[prop-missing]: need a better way to handle this...


        next = next.parentNode || next.host;
      } while (next);
    } // Give up, the result is false


  return false;
}

function getComputedStyle(element) {
  return getWindow(element).getComputedStyle(element);
}

function isTableElement(element) {
  return ['table', 'td', 'th'].indexOf(getNodeName(element)) >= 0;
}

function getDocumentElement(element) {
  // $FlowFixMe[incompatible-return]: assume body is always available
  return ((isElement(element) ? element.ownerDocument : // $FlowFixMe[prop-missing]
  element.document) || window.document).documentElement;
}

function getParentNode(element) {
  if (getNodeName(element) === 'html') {
    return element;
  }

  return (// this is a quicker (but less type safe) way to save quite some bytes from the bundle
    // $FlowFixMe[incompatible-return]
    // $FlowFixMe[prop-missing]
    element.assignedSlot || // step into the shadow DOM of the parent of a slotted node
    element.parentNode || ( // DOM Element detected
    isShadowRoot(element) ? element.host : null) || // ShadowRoot detected
    // $FlowFixMe[incompatible-call]: HTMLElement is a Node
    getDocumentElement(element) // fallback

  );
}

function getTrueOffsetParent(element) {
  if (!isHTMLElement$1(element) || // https://github.com/popperjs/popper-core/issues/837
  getComputedStyle(element).position === 'fixed') {
    return null;
  }

  return element.offsetParent;
} // `.offsetParent` reports `null` for fixed elements, while absolute elements
// return the containing block


function getContainingBlock(element) {
  var isFirefox = /firefox/i.test(getUAString());
  var isIE = /Trident/i.test(getUAString());

  if (isIE && isHTMLElement$1(element)) {
    // In IE 9, 10 and 11 fixed elements containing block is always established by the viewport
    var elementCss = getComputedStyle(element);

    if (elementCss.position === 'fixed') {
      return null;
    }
  }

  var currentNode = getParentNode(element);

  if (isShadowRoot(currentNode)) {
    currentNode = currentNode.host;
  }

  while (isHTMLElement$1(currentNode) && ['html', 'body'].indexOf(getNodeName(currentNode)) < 0) {
    var css = getComputedStyle(currentNode); // This is non-exhaustive but covers the most common CSS properties that
    // create a containing block.
    // https://developer.mozilla.org/en-US/docs/Web/CSS/Containing_block#identifying_the_containing_block

    if (css.transform !== 'none' || css.perspective !== 'none' || css.contain === 'paint' || ['transform', 'perspective'].indexOf(css.willChange) !== -1 || isFirefox && css.willChange === 'filter' || isFirefox && css.filter && css.filter !== 'none') {
      return currentNode;
    } else {
      currentNode = currentNode.parentNode;
    }
  }

  return null;
} // Gets the closest ancestor positioned element. Handles some edge cases,
// such as table ancestors and cross browser bugs.


function getOffsetParent(element) {
  var window = getWindow(element);
  var offsetParent = getTrueOffsetParent(element);

  while (offsetParent && isTableElement(offsetParent) && getComputedStyle(offsetParent).position === 'static') {
    offsetParent = getTrueOffsetParent(offsetParent);
  }

  if (offsetParent && (getNodeName(offsetParent) === 'html' || getNodeName(offsetParent) === 'body' && getComputedStyle(offsetParent).position === 'static')) {
    return window;
  }

  return offsetParent || getContainingBlock(element) || window;
}

function getMainAxisFromPlacement(placement) {
  return ['top', 'bottom'].indexOf(placement) >= 0 ? 'x' : 'y';
}

function within(min$1, value, max$1) {
  return max(min$1, min(value, max$1));
}
function withinMaxClamp(min, value, max) {
  var v = within(min, value, max);
  return v > max ? max : v;
}

function getFreshSideObject() {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0
  };
}

function mergePaddingObject(paddingObject) {
  return Object.assign({}, getFreshSideObject(), paddingObject);
}

function expandToHashMap(value, keys) {
  return keys.reduce(function (hashMap, key) {
    hashMap[key] = value;
    return hashMap;
  }, {});
}

var toPaddingObject = function toPaddingObject(padding, state) {
  padding = typeof padding === 'function' ? padding(Object.assign({}, state.rects, {
    placement: state.placement
  })) : padding;
  return mergePaddingObject(typeof padding !== 'number' ? padding : expandToHashMap(padding, basePlacements));
};

function arrow(_ref) {
  var _state$modifiersData$;

  var state = _ref.state,
      name = _ref.name,
      options = _ref.options;
  var arrowElement = state.elements.arrow;
  var popperOffsets = state.modifiersData.popperOffsets;
  var basePlacement = getBasePlacement(state.placement);
  var axis = getMainAxisFromPlacement(basePlacement);
  var isVertical = [left, right].indexOf(basePlacement) >= 0;
  var len = isVertical ? 'height' : 'width';

  if (!arrowElement || !popperOffsets) {
    return;
  }

  var paddingObject = toPaddingObject(options.padding, state);
  var arrowRect = getLayoutRect(arrowElement);
  var minProp = axis === 'y' ? top : left;
  var maxProp = axis === 'y' ? bottom : right;
  var endDiff = state.rects.reference[len] + state.rects.reference[axis] - popperOffsets[axis] - state.rects.popper[len];
  var startDiff = popperOffsets[axis] - state.rects.reference[axis];
  var arrowOffsetParent = getOffsetParent(arrowElement);
  var clientSize = arrowOffsetParent ? axis === 'y' ? arrowOffsetParent.clientHeight || 0 : arrowOffsetParent.clientWidth || 0 : 0;
  var centerToReference = endDiff / 2 - startDiff / 2; // Make sure the arrow doesn't overflow the popper if the center point is
  // outside of the popper bounds

  var min = paddingObject[minProp];
  var max = clientSize - arrowRect[len] - paddingObject[maxProp];
  var center = clientSize / 2 - arrowRect[len] / 2 + centerToReference;
  var offset = within(min, center, max); // Prevents breaking syntax highlighting...

  var axisProp = axis;
  state.modifiersData[name] = (_state$modifiersData$ = {}, _state$modifiersData$[axisProp] = offset, _state$modifiersData$.centerOffset = offset - center, _state$modifiersData$);
}

function effect$1(_ref2) {
  var state = _ref2.state,
      options = _ref2.options;
  var _options$element = options.element,
      arrowElement = _options$element === void 0 ? '[data-popper-arrow]' : _options$element;

  if (arrowElement == null) {
    return;
  } // CSS selector


  if (typeof arrowElement === 'string') {
    arrowElement = state.elements.popper.querySelector(arrowElement);

    if (!arrowElement) {
      return;
    }
  }

  if (browser$1.env.NODE_ENV !== "production") {
    if (!isHTMLElement$1(arrowElement)) {
      console.error(['Popper: "arrow" element must be an HTMLElement (not an SVGElement).', 'To use an SVG arrow, wrap it in an HTMLElement that will be used as', 'the arrow.'].join(' '));
    }
  }

  if (!contains(state.elements.popper, arrowElement)) {
    if (browser$1.env.NODE_ENV !== "production") {
      console.error(['Popper: "arrow" modifier\'s `element` must be a child of the popper', 'element.'].join(' '));
    }

    return;
  }

  state.elements.arrow = arrowElement;
} // eslint-disable-next-line import/no-unused-modules


var arrow$1 = {
  name: 'arrow',
  enabled: true,
  phase: 'main',
  fn: arrow,
  effect: effect$1,
  requires: ['popperOffsets'],
  requiresIfExists: ['preventOverflow']
};

function getVariation(placement) {
  return placement.split('-')[1];
}

var unsetSides = {
  top: 'auto',
  right: 'auto',
  bottom: 'auto',
  left: 'auto'
}; // Round the offsets to the nearest suitable subpixel based on the DPR.
// Zooming can change the DPR, but it seems to report a value that will
// cleanly divide the values into the appropriate subpixels.

function roundOffsetsByDPR(_ref) {
  var x = _ref.x,
      y = _ref.y;
  var win = window;
  var dpr = win.devicePixelRatio || 1;
  return {
    x: round$2(x * dpr) / dpr || 0,
    y: round$2(y * dpr) / dpr || 0
  };
}

function mapToStyles(_ref2) {
  var _Object$assign2;

  var popper = _ref2.popper,
      popperRect = _ref2.popperRect,
      placement = _ref2.placement,
      variation = _ref2.variation,
      offsets = _ref2.offsets,
      position = _ref2.position,
      gpuAcceleration = _ref2.gpuAcceleration,
      adaptive = _ref2.adaptive,
      roundOffsets = _ref2.roundOffsets,
      isFixed = _ref2.isFixed;
  var _offsets$x = offsets.x,
      x = _offsets$x === void 0 ? 0 : _offsets$x,
      _offsets$y = offsets.y,
      y = _offsets$y === void 0 ? 0 : _offsets$y;

  var _ref3 = typeof roundOffsets === 'function' ? roundOffsets({
    x: x,
    y: y
  }) : {
    x: x,
    y: y
  };

  x = _ref3.x;
  y = _ref3.y;
  var hasX = offsets.hasOwnProperty('x');
  var hasY = offsets.hasOwnProperty('y');
  var sideX = left;
  var sideY = top;
  var win = window;

  if (adaptive) {
    var offsetParent = getOffsetParent(popper);
    var heightProp = 'clientHeight';
    var widthProp = 'clientWidth';

    if (offsetParent === getWindow(popper)) {
      offsetParent = getDocumentElement(popper);

      if (getComputedStyle(offsetParent).position !== 'static' && position === 'absolute') {
        heightProp = 'scrollHeight';
        widthProp = 'scrollWidth';
      }
    } // $FlowFixMe[incompatible-cast]: force type refinement, we compare offsetParent with window above, but Flow doesn't detect it


    offsetParent = offsetParent;

    if (placement === top || (placement === left || placement === right) && variation === end) {
      sideY = bottom;
      var offsetY = isFixed && offsetParent === win && win.visualViewport ? win.visualViewport.height : // $FlowFixMe[prop-missing]
      offsetParent[heightProp];
      y -= offsetY - popperRect.height;
      y *= gpuAcceleration ? 1 : -1;
    }

    if (placement === left || (placement === top || placement === bottom) && variation === end) {
      sideX = right;
      var offsetX = isFixed && offsetParent === win && win.visualViewport ? win.visualViewport.width : // $FlowFixMe[prop-missing]
      offsetParent[widthProp];
      x -= offsetX - popperRect.width;
      x *= gpuAcceleration ? 1 : -1;
    }
  }

  var commonStyles = Object.assign({
    position: position
  }, adaptive && unsetSides);

  var _ref4 = roundOffsets === true ? roundOffsetsByDPR({
    x: x,
    y: y
  }) : {
    x: x,
    y: y
  };

  x = _ref4.x;
  y = _ref4.y;

  if (gpuAcceleration) {
    var _Object$assign;

    return Object.assign({}, commonStyles, (_Object$assign = {}, _Object$assign[sideY] = hasY ? '0' : '', _Object$assign[sideX] = hasX ? '0' : '', _Object$assign.transform = (win.devicePixelRatio || 1) <= 1 ? "translate(" + x + "px, " + y + "px)" : "translate3d(" + x + "px, " + y + "px, 0)", _Object$assign));
  }

  return Object.assign({}, commonStyles, (_Object$assign2 = {}, _Object$assign2[sideY] = hasY ? y + "px" : '', _Object$assign2[sideX] = hasX ? x + "px" : '', _Object$assign2.transform = '', _Object$assign2));
}

function computeStyles(_ref5) {
  var state = _ref5.state,
      options = _ref5.options;
  var _options$gpuAccelerat = options.gpuAcceleration,
      gpuAcceleration = _options$gpuAccelerat === void 0 ? true : _options$gpuAccelerat,
      _options$adaptive = options.adaptive,
      adaptive = _options$adaptive === void 0 ? true : _options$adaptive,
      _options$roundOffsets = options.roundOffsets,
      roundOffsets = _options$roundOffsets === void 0 ? true : _options$roundOffsets;

  if (browser$1.env.NODE_ENV !== "production") {
    var transitionProperty = getComputedStyle(state.elements.popper).transitionProperty || '';

    if (adaptive && ['transform', 'top', 'right', 'bottom', 'left'].some(function (property) {
      return transitionProperty.indexOf(property) >= 0;
    })) {
      console.warn(['Popper: Detected CSS transitions on at least one of the following', 'CSS properties: "transform", "top", "right", "bottom", "left".', '\n\n', 'Disable the "computeStyles" modifier\'s `adaptive` option to allow', 'for smooth transitions, or remove these properties from the CSS', 'transition declaration on the popper element if only transitioning', 'opacity or background-color for example.', '\n\n', 'We recommend using the popper element as a wrapper around an inner', 'element that can have any CSS property transitioned for animations.'].join(' '));
    }
  }

  var commonStyles = {
    placement: getBasePlacement(state.placement),
    variation: getVariation(state.placement),
    popper: state.elements.popper,
    popperRect: state.rects.popper,
    gpuAcceleration: gpuAcceleration,
    isFixed: state.options.strategy === 'fixed'
  };

  if (state.modifiersData.popperOffsets != null) {
    state.styles.popper = Object.assign({}, state.styles.popper, mapToStyles(Object.assign({}, commonStyles, {
      offsets: state.modifiersData.popperOffsets,
      position: state.options.strategy,
      adaptive: adaptive,
      roundOffsets: roundOffsets
    })));
  }

  if (state.modifiersData.arrow != null) {
    state.styles.arrow = Object.assign({}, state.styles.arrow, mapToStyles(Object.assign({}, commonStyles, {
      offsets: state.modifiersData.arrow,
      position: 'absolute',
      adaptive: false,
      roundOffsets: roundOffsets
    })));
  }

  state.attributes.popper = Object.assign({}, state.attributes.popper, {
    'data-popper-placement': state.placement
  });
} // eslint-disable-next-line import/no-unused-modules


var computeStyles$1 = {
  name: 'computeStyles',
  enabled: true,
  phase: 'beforeWrite',
  fn: computeStyles,
  data: {}
};

var passive = {
  passive: true
};

function effect(_ref) {
  var state = _ref.state,
      instance = _ref.instance,
      options = _ref.options;
  var _options$scroll = options.scroll,
      scroll = _options$scroll === void 0 ? true : _options$scroll,
      _options$resize = options.resize,
      resize = _options$resize === void 0 ? true : _options$resize;
  var window = getWindow(state.elements.popper);
  var scrollParents = [].concat(state.scrollParents.reference, state.scrollParents.popper);

  if (scroll) {
    scrollParents.forEach(function (scrollParent) {
      scrollParent.addEventListener('scroll', instance.update, passive);
    });
  }

  if (resize) {
    window.addEventListener('resize', instance.update, passive);
  }

  return function () {
    if (scroll) {
      scrollParents.forEach(function (scrollParent) {
        scrollParent.removeEventListener('scroll', instance.update, passive);
      });
    }

    if (resize) {
      window.removeEventListener('resize', instance.update, passive);
    }
  };
} // eslint-disable-next-line import/no-unused-modules


var eventListeners = {
  name: 'eventListeners',
  enabled: true,
  phase: 'write',
  fn: function fn() {},
  effect: effect,
  data: {}
};

var hash$1 = {
  left: 'right',
  right: 'left',
  bottom: 'top',
  top: 'bottom'
};
function getOppositePlacement(placement) {
  return placement.replace(/left|right|bottom|top/g, function (matched) {
    return hash$1[matched];
  });
}

var hash = {
  start: 'end',
  end: 'start'
};
function getOppositeVariationPlacement(placement) {
  return placement.replace(/start|end/g, function (matched) {
    return hash[matched];
  });
}

function getWindowScroll(node) {
  var win = getWindow(node);
  var scrollLeft = win.pageXOffset;
  var scrollTop = win.pageYOffset;
  return {
    scrollLeft: scrollLeft,
    scrollTop: scrollTop
  };
}

function getWindowScrollBarX(element) {
  // If <html> has a CSS width greater than the viewport, then this will be
  // incorrect for RTL.
  // Popper 1 is broken in this case and never had a bug report so let's assume
  // it's not an issue. I don't think anyone ever specifies width on <html>
  // anyway.
  // Browsers where the left scrollbar doesn't cause an issue report `0` for
  // this (e.g. Edge 2019, IE11, Safari)
  return getBoundingClientRect(getDocumentElement(element)).left + getWindowScroll(element).scrollLeft;
}

function getViewportRect(element, strategy) {
  var win = getWindow(element);
  var html = getDocumentElement(element);
  var visualViewport = win.visualViewport;
  var width = html.clientWidth;
  var height = html.clientHeight;
  var x = 0;
  var y = 0;

  if (visualViewport) {
    width = visualViewport.width;
    height = visualViewport.height;
    var layoutViewport = isLayoutViewport();

    if (layoutViewport || !layoutViewport && strategy === 'fixed') {
      x = visualViewport.offsetLeft;
      y = visualViewport.offsetTop;
    }
  }

  return {
    width: width,
    height: height,
    x: x + getWindowScrollBarX(element),
    y: y
  };
}

// of the `<html>` and `<body>` rect bounds if horizontally scrollable

function getDocumentRect(element) {
  var _element$ownerDocumen;

  var html = getDocumentElement(element);
  var winScroll = getWindowScroll(element);
  var body = (_element$ownerDocumen = element.ownerDocument) == null ? void 0 : _element$ownerDocumen.body;
  var width = max(html.scrollWidth, html.clientWidth, body ? body.scrollWidth : 0, body ? body.clientWidth : 0);
  var height = max(html.scrollHeight, html.clientHeight, body ? body.scrollHeight : 0, body ? body.clientHeight : 0);
  var x = -winScroll.scrollLeft + getWindowScrollBarX(element);
  var y = -winScroll.scrollTop;

  if (getComputedStyle(body || html).direction === 'rtl') {
    x += max(html.clientWidth, body ? body.clientWidth : 0) - width;
  }

  return {
    width: width,
    height: height,
    x: x,
    y: y
  };
}

function isScrollParent(element) {
  // Firefox wants us to check `-x` and `-y` variations as well
  var _getComputedStyle = getComputedStyle(element),
      overflow = _getComputedStyle.overflow,
      overflowX = _getComputedStyle.overflowX,
      overflowY = _getComputedStyle.overflowY;

  return /auto|scroll|overlay|hidden/.test(overflow + overflowY + overflowX);
}

function getScrollParent(node) {
  if (['html', 'body', '#document'].indexOf(getNodeName(node)) >= 0) {
    // $FlowFixMe[incompatible-return]: assume body is always available
    return node.ownerDocument.body;
  }

  if (isHTMLElement$1(node) && isScrollParent(node)) {
    return node;
  }

  return getScrollParent(getParentNode(node));
}

/*
given a DOM element, return the list of all scroll parents, up the list of ancesors
until we get to the top window object. This list is what we attach scroll listeners
to, because if any of these parent elements scroll, we'll need to re-calculate the
reference element's position.
*/

function listScrollParents(element, list) {
  var _element$ownerDocumen;

  if (list === void 0) {
    list = [];
  }

  var scrollParent = getScrollParent(element);
  var isBody = scrollParent === ((_element$ownerDocumen = element.ownerDocument) == null ? void 0 : _element$ownerDocumen.body);
  var win = getWindow(scrollParent);
  var target = isBody ? [win].concat(win.visualViewport || [], isScrollParent(scrollParent) ? scrollParent : []) : scrollParent;
  var updatedList = list.concat(target);
  return isBody ? updatedList : // $FlowFixMe[incompatible-call]: isBody tells us target will be an HTMLElement here
  updatedList.concat(listScrollParents(getParentNode(target)));
}

function rectToClientRect(rect) {
  return Object.assign({}, rect, {
    left: rect.x,
    top: rect.y,
    right: rect.x + rect.width,
    bottom: rect.y + rect.height
  });
}

function getInnerBoundingClientRect(element, strategy) {
  var rect = getBoundingClientRect(element, false, strategy === 'fixed');
  rect.top = rect.top + element.clientTop;
  rect.left = rect.left + element.clientLeft;
  rect.bottom = rect.top + element.clientHeight;
  rect.right = rect.left + element.clientWidth;
  rect.width = element.clientWidth;
  rect.height = element.clientHeight;
  rect.x = rect.left;
  rect.y = rect.top;
  return rect;
}

function getClientRectFromMixedType(element, clippingParent, strategy) {
  return clippingParent === viewport ? rectToClientRect(getViewportRect(element, strategy)) : isElement(clippingParent) ? getInnerBoundingClientRect(clippingParent, strategy) : rectToClientRect(getDocumentRect(getDocumentElement(element)));
} // A "clipping parent" is an overflowable container with the characteristic of
// clipping (or hiding) overflowing elements with a position different from
// `initial`


function getClippingParents(element) {
  var clippingParents = listScrollParents(getParentNode(element));
  var canEscapeClipping = ['absolute', 'fixed'].indexOf(getComputedStyle(element).position) >= 0;
  var clipperElement = canEscapeClipping && isHTMLElement$1(element) ? getOffsetParent(element) : element;

  if (!isElement(clipperElement)) {
    return [];
  } // $FlowFixMe[incompatible-return]: https://github.com/facebook/flow/issues/1414


  return clippingParents.filter(function (clippingParent) {
    return isElement(clippingParent) && contains(clippingParent, clipperElement) && getNodeName(clippingParent) !== 'body';
  });
} // Gets the maximum area that the element is visible in due to any number of
// clipping parents


function getClippingRect(element, boundary, rootBoundary, strategy) {
  var mainClippingParents = boundary === 'clippingParents' ? getClippingParents(element) : [].concat(boundary);
  var clippingParents = [].concat(mainClippingParents, [rootBoundary]);
  var firstClippingParent = clippingParents[0];
  var clippingRect = clippingParents.reduce(function (accRect, clippingParent) {
    var rect = getClientRectFromMixedType(element, clippingParent, strategy);
    accRect.top = max(rect.top, accRect.top);
    accRect.right = min(rect.right, accRect.right);
    accRect.bottom = min(rect.bottom, accRect.bottom);
    accRect.left = max(rect.left, accRect.left);
    return accRect;
  }, getClientRectFromMixedType(element, firstClippingParent, strategy));
  clippingRect.width = clippingRect.right - clippingRect.left;
  clippingRect.height = clippingRect.bottom - clippingRect.top;
  clippingRect.x = clippingRect.left;
  clippingRect.y = clippingRect.top;
  return clippingRect;
}

function computeOffsets(_ref) {
  var reference = _ref.reference,
      element = _ref.element,
      placement = _ref.placement;
  var basePlacement = placement ? getBasePlacement(placement) : null;
  var variation = placement ? getVariation(placement) : null;
  var commonX = reference.x + reference.width / 2 - element.width / 2;
  var commonY = reference.y + reference.height / 2 - element.height / 2;
  var offsets;

  switch (basePlacement) {
    case top:
      offsets = {
        x: commonX,
        y: reference.y - element.height
      };
      break;

    case bottom:
      offsets = {
        x: commonX,
        y: reference.y + reference.height
      };
      break;

    case right:
      offsets = {
        x: reference.x + reference.width,
        y: commonY
      };
      break;

    case left:
      offsets = {
        x: reference.x - element.width,
        y: commonY
      };
      break;

    default:
      offsets = {
        x: reference.x,
        y: reference.y
      };
  }

  var mainAxis = basePlacement ? getMainAxisFromPlacement(basePlacement) : null;

  if (mainAxis != null) {
    var len = mainAxis === 'y' ? 'height' : 'width';

    switch (variation) {
      case start:
        offsets[mainAxis] = offsets[mainAxis] - (reference[len] / 2 - element[len] / 2);
        break;

      case end:
        offsets[mainAxis] = offsets[mainAxis] + (reference[len] / 2 - element[len] / 2);
        break;
    }
  }

  return offsets;
}

function detectOverflow(state, options) {
  if (options === void 0) {
    options = {};
  }

  var _options = options,
      _options$placement = _options.placement,
      placement = _options$placement === void 0 ? state.placement : _options$placement,
      _options$strategy = _options.strategy,
      strategy = _options$strategy === void 0 ? state.strategy : _options$strategy,
      _options$boundary = _options.boundary,
      boundary = _options$boundary === void 0 ? clippingParents : _options$boundary,
      _options$rootBoundary = _options.rootBoundary,
      rootBoundary = _options$rootBoundary === void 0 ? viewport : _options$rootBoundary,
      _options$elementConte = _options.elementContext,
      elementContext = _options$elementConte === void 0 ? popper : _options$elementConte,
      _options$altBoundary = _options.altBoundary,
      altBoundary = _options$altBoundary === void 0 ? false : _options$altBoundary,
      _options$padding = _options.padding,
      padding = _options$padding === void 0 ? 0 : _options$padding;
  var paddingObject = mergePaddingObject(typeof padding !== 'number' ? padding : expandToHashMap(padding, basePlacements));
  var altContext = elementContext === popper ? reference : popper;
  var popperRect = state.rects.popper;
  var element = state.elements[altBoundary ? altContext : elementContext];
  var clippingClientRect = getClippingRect(isElement(element) ? element : element.contextElement || getDocumentElement(state.elements.popper), boundary, rootBoundary, strategy);
  var referenceClientRect = getBoundingClientRect(state.elements.reference);
  var popperOffsets = computeOffsets({
    reference: referenceClientRect,
    element: popperRect,
    strategy: 'absolute',
    placement: placement
  });
  var popperClientRect = rectToClientRect(Object.assign({}, popperRect, popperOffsets));
  var elementClientRect = elementContext === popper ? popperClientRect : referenceClientRect; // positive = overflowing the clipping rect
  // 0 or negative = within the clipping rect

  var overflowOffsets = {
    top: clippingClientRect.top - elementClientRect.top + paddingObject.top,
    bottom: elementClientRect.bottom - clippingClientRect.bottom + paddingObject.bottom,
    left: clippingClientRect.left - elementClientRect.left + paddingObject.left,
    right: elementClientRect.right - clippingClientRect.right + paddingObject.right
  };
  var offsetData = state.modifiersData.offset; // Offsets can be applied only to the popper element

  if (elementContext === popper && offsetData) {
    var offset = offsetData[placement];
    Object.keys(overflowOffsets).forEach(function (key) {
      var multiply = [right, bottom].indexOf(key) >= 0 ? 1 : -1;
      var axis = [top, bottom].indexOf(key) >= 0 ? 'y' : 'x';
      overflowOffsets[key] += offset[axis] * multiply;
    });
  }

  return overflowOffsets;
}

function computeAutoPlacement(state, options) {
  if (options === void 0) {
    options = {};
  }

  var _options = options,
      placement = _options.placement,
      boundary = _options.boundary,
      rootBoundary = _options.rootBoundary,
      padding = _options.padding,
      flipVariations = _options.flipVariations,
      _options$allowedAutoP = _options.allowedAutoPlacements,
      allowedAutoPlacements = _options$allowedAutoP === void 0 ? placements : _options$allowedAutoP;
  var variation = getVariation(placement);
  var placements$1 = variation ? flipVariations ? variationPlacements : variationPlacements.filter(function (placement) {
    return getVariation(placement) === variation;
  }) : basePlacements;
  var allowedPlacements = placements$1.filter(function (placement) {
    return allowedAutoPlacements.indexOf(placement) >= 0;
  });

  if (allowedPlacements.length === 0) {
    allowedPlacements = placements$1;

    if (browser$1.env.NODE_ENV !== "production") {
      console.error(['Popper: The `allowedAutoPlacements` option did not allow any', 'placements. Ensure the `placement` option matches the variation', 'of the allowed placements.', 'For example, "auto" cannot be used to allow "bottom-start".', 'Use "auto-start" instead.'].join(' '));
    }
  } // $FlowFixMe[incompatible-type]: Flow seems to have problems with two array unions...


  var overflows = allowedPlacements.reduce(function (acc, placement) {
    acc[placement] = detectOverflow(state, {
      placement: placement,
      boundary: boundary,
      rootBoundary: rootBoundary,
      padding: padding
    })[getBasePlacement(placement)];
    return acc;
  }, {});
  return Object.keys(overflows).sort(function (a, b) {
    return overflows[a] - overflows[b];
  });
}

function getExpandedFallbackPlacements(placement) {
  if (getBasePlacement(placement) === auto) {
    return [];
  }

  var oppositePlacement = getOppositePlacement(placement);
  return [getOppositeVariationPlacement(placement), oppositePlacement, getOppositeVariationPlacement(oppositePlacement)];
}

function flip(_ref) {
  var state = _ref.state,
      options = _ref.options,
      name = _ref.name;

  if (state.modifiersData[name]._skip) {
    return;
  }

  var _options$mainAxis = options.mainAxis,
      checkMainAxis = _options$mainAxis === void 0 ? true : _options$mainAxis,
      _options$altAxis = options.altAxis,
      checkAltAxis = _options$altAxis === void 0 ? true : _options$altAxis,
      specifiedFallbackPlacements = options.fallbackPlacements,
      padding = options.padding,
      boundary = options.boundary,
      rootBoundary = options.rootBoundary,
      altBoundary = options.altBoundary,
      _options$flipVariatio = options.flipVariations,
      flipVariations = _options$flipVariatio === void 0 ? true : _options$flipVariatio,
      allowedAutoPlacements = options.allowedAutoPlacements;
  var preferredPlacement = state.options.placement;
  var basePlacement = getBasePlacement(preferredPlacement);
  var isBasePlacement = basePlacement === preferredPlacement;
  var fallbackPlacements = specifiedFallbackPlacements || (isBasePlacement || !flipVariations ? [getOppositePlacement(preferredPlacement)] : getExpandedFallbackPlacements(preferredPlacement));
  var placements = [preferredPlacement].concat(fallbackPlacements).reduce(function (acc, placement) {
    return acc.concat(getBasePlacement(placement) === auto ? computeAutoPlacement(state, {
      placement: placement,
      boundary: boundary,
      rootBoundary: rootBoundary,
      padding: padding,
      flipVariations: flipVariations,
      allowedAutoPlacements: allowedAutoPlacements
    }) : placement);
  }, []);
  var referenceRect = state.rects.reference;
  var popperRect = state.rects.popper;
  var checksMap = new Map();
  var makeFallbackChecks = true;
  var firstFittingPlacement = placements[0];

  for (var i = 0; i < placements.length; i++) {
    var placement = placements[i];

    var _basePlacement = getBasePlacement(placement);

    var isStartVariation = getVariation(placement) === start;
    var isVertical = [top, bottom].indexOf(_basePlacement) >= 0;
    var len = isVertical ? 'width' : 'height';
    var overflow = detectOverflow(state, {
      placement: placement,
      boundary: boundary,
      rootBoundary: rootBoundary,
      altBoundary: altBoundary,
      padding: padding
    });
    var mainVariationSide = isVertical ? isStartVariation ? right : left : isStartVariation ? bottom : top;

    if (referenceRect[len] > popperRect[len]) {
      mainVariationSide = getOppositePlacement(mainVariationSide);
    }

    var altVariationSide = getOppositePlacement(mainVariationSide);
    var checks = [];

    if (checkMainAxis) {
      checks.push(overflow[_basePlacement] <= 0);
    }

    if (checkAltAxis) {
      checks.push(overflow[mainVariationSide] <= 0, overflow[altVariationSide] <= 0);
    }

    if (checks.every(function (check) {
      return check;
    })) {
      firstFittingPlacement = placement;
      makeFallbackChecks = false;
      break;
    }

    checksMap.set(placement, checks);
  }

  if (makeFallbackChecks) {
    // `2` may be desired in some cases – research later
    var numberOfChecks = flipVariations ? 3 : 1;

    var _loop = function _loop(_i) {
      var fittingPlacement = placements.find(function (placement) {
        var checks = checksMap.get(placement);

        if (checks) {
          return checks.slice(0, _i).every(function (check) {
            return check;
          });
        }
      });

      if (fittingPlacement) {
        firstFittingPlacement = fittingPlacement;
        return "break";
      }
    };

    for (var _i = numberOfChecks; _i > 0; _i--) {
      var _ret = _loop(_i);

      if (_ret === "break") break;
    }
  }

  if (state.placement !== firstFittingPlacement) {
    state.modifiersData[name]._skip = true;
    state.placement = firstFittingPlacement;
    state.reset = true;
  }
} // eslint-disable-next-line import/no-unused-modules


var flip$1 = {
  name: 'flip',
  enabled: true,
  phase: 'main',
  fn: flip,
  requiresIfExists: ['offset'],
  data: {
    _skip: false
  }
};

function getSideOffsets(overflow, rect, preventedOffsets) {
  if (preventedOffsets === void 0) {
    preventedOffsets = {
      x: 0,
      y: 0
    };
  }

  return {
    top: overflow.top - rect.height - preventedOffsets.y,
    right: overflow.right - rect.width + preventedOffsets.x,
    bottom: overflow.bottom - rect.height + preventedOffsets.y,
    left: overflow.left - rect.width - preventedOffsets.x
  };
}

function isAnySideFullyClipped(overflow) {
  return [top, right, bottom, left].some(function (side) {
    return overflow[side] >= 0;
  });
}

function hide(_ref) {
  var state = _ref.state,
      name = _ref.name;
  var referenceRect = state.rects.reference;
  var popperRect = state.rects.popper;
  var preventedOffsets = state.modifiersData.preventOverflow;
  var referenceOverflow = detectOverflow(state, {
    elementContext: 'reference'
  });
  var popperAltOverflow = detectOverflow(state, {
    altBoundary: true
  });
  var referenceClippingOffsets = getSideOffsets(referenceOverflow, referenceRect);
  var popperEscapeOffsets = getSideOffsets(popperAltOverflow, popperRect, preventedOffsets);
  var isReferenceHidden = isAnySideFullyClipped(referenceClippingOffsets);
  var hasPopperEscaped = isAnySideFullyClipped(popperEscapeOffsets);
  state.modifiersData[name] = {
    referenceClippingOffsets: referenceClippingOffsets,
    popperEscapeOffsets: popperEscapeOffsets,
    isReferenceHidden: isReferenceHidden,
    hasPopperEscaped: hasPopperEscaped
  };
  state.attributes.popper = Object.assign({}, state.attributes.popper, {
    'data-popper-reference-hidden': isReferenceHidden,
    'data-popper-escaped': hasPopperEscaped
  });
} // eslint-disable-next-line import/no-unused-modules


var hide$1 = {
  name: 'hide',
  enabled: true,
  phase: 'main',
  requiresIfExists: ['preventOverflow'],
  fn: hide
};

function distanceAndSkiddingToXY(placement, rects, offset) {
  var basePlacement = getBasePlacement(placement);
  var invertDistance = [left, top].indexOf(basePlacement) >= 0 ? -1 : 1;

  var _ref = typeof offset === 'function' ? offset(Object.assign({}, rects, {
    placement: placement
  })) : offset,
      skidding = _ref[0],
      distance = _ref[1];

  skidding = skidding || 0;
  distance = (distance || 0) * invertDistance;
  return [left, right].indexOf(basePlacement) >= 0 ? {
    x: distance,
    y: skidding
  } : {
    x: skidding,
    y: distance
  };
}

function offset(_ref2) {
  var state = _ref2.state,
      options = _ref2.options,
      name = _ref2.name;
  var _options$offset = options.offset,
      offset = _options$offset === void 0 ? [0, 0] : _options$offset;
  var data = placements.reduce(function (acc, placement) {
    acc[placement] = distanceAndSkiddingToXY(placement, state.rects, offset);
    return acc;
  }, {});
  var _data$state$placement = data[state.placement],
      x = _data$state$placement.x,
      y = _data$state$placement.y;

  if (state.modifiersData.popperOffsets != null) {
    state.modifiersData.popperOffsets.x += x;
    state.modifiersData.popperOffsets.y += y;
  }

  state.modifiersData[name] = data;
} // eslint-disable-next-line import/no-unused-modules


var offset$1 = {
  name: 'offset',
  enabled: true,
  phase: 'main',
  requires: ['popperOffsets'],
  fn: offset
};

function popperOffsets(_ref) {
  var state = _ref.state,
      name = _ref.name;
  // Offsets are the actual position the popper needs to have to be
  // properly positioned near its reference element
  // This is the most basic placement, and will be adjusted by
  // the modifiers in the next step
  state.modifiersData[name] = computeOffsets({
    reference: state.rects.reference,
    element: state.rects.popper,
    strategy: 'absolute',
    placement: state.placement
  });
} // eslint-disable-next-line import/no-unused-modules


var popperOffsets$1 = {
  name: 'popperOffsets',
  enabled: true,
  phase: 'read',
  fn: popperOffsets,
  data: {}
};

function getAltAxis(axis) {
  return axis === 'x' ? 'y' : 'x';
}

function preventOverflow(_ref) {
  var state = _ref.state,
      options = _ref.options,
      name = _ref.name;
  var _options$mainAxis = options.mainAxis,
      checkMainAxis = _options$mainAxis === void 0 ? true : _options$mainAxis,
      _options$altAxis = options.altAxis,
      checkAltAxis = _options$altAxis === void 0 ? false : _options$altAxis,
      boundary = options.boundary,
      rootBoundary = options.rootBoundary,
      altBoundary = options.altBoundary,
      padding = options.padding,
      _options$tether = options.tether,
      tether = _options$tether === void 0 ? true : _options$tether,
      _options$tetherOffset = options.tetherOffset,
      tetherOffset = _options$tetherOffset === void 0 ? 0 : _options$tetherOffset;
  var overflow = detectOverflow(state, {
    boundary: boundary,
    rootBoundary: rootBoundary,
    padding: padding,
    altBoundary: altBoundary
  });
  var basePlacement = getBasePlacement(state.placement);
  var variation = getVariation(state.placement);
  var isBasePlacement = !variation;
  var mainAxis = getMainAxisFromPlacement(basePlacement);
  var altAxis = getAltAxis(mainAxis);
  var popperOffsets = state.modifiersData.popperOffsets;
  var referenceRect = state.rects.reference;
  var popperRect = state.rects.popper;
  var tetherOffsetValue = typeof tetherOffset === 'function' ? tetherOffset(Object.assign({}, state.rects, {
    placement: state.placement
  })) : tetherOffset;
  var normalizedTetherOffsetValue = typeof tetherOffsetValue === 'number' ? {
    mainAxis: tetherOffsetValue,
    altAxis: tetherOffsetValue
  } : Object.assign({
    mainAxis: 0,
    altAxis: 0
  }, tetherOffsetValue);
  var offsetModifierState = state.modifiersData.offset ? state.modifiersData.offset[state.placement] : null;
  var data = {
    x: 0,
    y: 0
  };

  if (!popperOffsets) {
    return;
  }

  if (checkMainAxis) {
    var _offsetModifierState$;

    var mainSide = mainAxis === 'y' ? top : left;
    var altSide = mainAxis === 'y' ? bottom : right;
    var len = mainAxis === 'y' ? 'height' : 'width';
    var offset = popperOffsets[mainAxis];
    var min$1 = offset + overflow[mainSide];
    var max$1 = offset - overflow[altSide];
    var additive = tether ? -popperRect[len] / 2 : 0;
    var minLen = variation === start ? referenceRect[len] : popperRect[len];
    var maxLen = variation === start ? -popperRect[len] : -referenceRect[len]; // We need to include the arrow in the calculation so the arrow doesn't go
    // outside the reference bounds

    var arrowElement = state.elements.arrow;
    var arrowRect = tether && arrowElement ? getLayoutRect(arrowElement) : {
      width: 0,
      height: 0
    };
    var arrowPaddingObject = state.modifiersData['arrow#persistent'] ? state.modifiersData['arrow#persistent'].padding : getFreshSideObject();
    var arrowPaddingMin = arrowPaddingObject[mainSide];
    var arrowPaddingMax = arrowPaddingObject[altSide]; // If the reference length is smaller than the arrow length, we don't want
    // to include its full size in the calculation. If the reference is small
    // and near the edge of a boundary, the popper can overflow even if the
    // reference is not overflowing as well (e.g. virtual elements with no
    // width or height)

    var arrowLen = within(0, referenceRect[len], arrowRect[len]);
    var minOffset = isBasePlacement ? referenceRect[len] / 2 - additive - arrowLen - arrowPaddingMin - normalizedTetherOffsetValue.mainAxis : minLen - arrowLen - arrowPaddingMin - normalizedTetherOffsetValue.mainAxis;
    var maxOffset = isBasePlacement ? -referenceRect[len] / 2 + additive + arrowLen + arrowPaddingMax + normalizedTetherOffsetValue.mainAxis : maxLen + arrowLen + arrowPaddingMax + normalizedTetherOffsetValue.mainAxis;
    var arrowOffsetParent = state.elements.arrow && getOffsetParent(state.elements.arrow);
    var clientOffset = arrowOffsetParent ? mainAxis === 'y' ? arrowOffsetParent.clientTop || 0 : arrowOffsetParent.clientLeft || 0 : 0;
    var offsetModifierValue = (_offsetModifierState$ = offsetModifierState == null ? void 0 : offsetModifierState[mainAxis]) != null ? _offsetModifierState$ : 0;
    var tetherMin = offset + minOffset - offsetModifierValue - clientOffset;
    var tetherMax = offset + maxOffset - offsetModifierValue;
    var preventedOffset = within(tether ? min(min$1, tetherMin) : min$1, offset, tether ? max(max$1, tetherMax) : max$1);
    popperOffsets[mainAxis] = preventedOffset;
    data[mainAxis] = preventedOffset - offset;
  }

  if (checkAltAxis) {
    var _offsetModifierState$2;

    var _mainSide = mainAxis === 'x' ? top : left;

    var _altSide = mainAxis === 'x' ? bottom : right;

    var _offset = popperOffsets[altAxis];

    var _len = altAxis === 'y' ? 'height' : 'width';

    var _min = _offset + overflow[_mainSide];

    var _max = _offset - overflow[_altSide];

    var isOriginSide = [top, left].indexOf(basePlacement) !== -1;

    var _offsetModifierValue = (_offsetModifierState$2 = offsetModifierState == null ? void 0 : offsetModifierState[altAxis]) != null ? _offsetModifierState$2 : 0;

    var _tetherMin = isOriginSide ? _min : _offset - referenceRect[_len] - popperRect[_len] - _offsetModifierValue + normalizedTetherOffsetValue.altAxis;

    var _tetherMax = isOriginSide ? _offset + referenceRect[_len] + popperRect[_len] - _offsetModifierValue - normalizedTetherOffsetValue.altAxis : _max;

    var _preventedOffset = tether && isOriginSide ? withinMaxClamp(_tetherMin, _offset, _tetherMax) : within(tether ? _tetherMin : _min, _offset, tether ? _tetherMax : _max);

    popperOffsets[altAxis] = _preventedOffset;
    data[altAxis] = _preventedOffset - _offset;
  }

  state.modifiersData[name] = data;
} // eslint-disable-next-line import/no-unused-modules


var preventOverflow$1 = {
  name: 'preventOverflow',
  enabled: true,
  phase: 'main',
  fn: preventOverflow,
  requiresIfExists: ['offset']
};

function getHTMLElementScroll(element) {
  return {
    scrollLeft: element.scrollLeft,
    scrollTop: element.scrollTop
  };
}

function getNodeScroll(node) {
  if (node === getWindow(node) || !isHTMLElement$1(node)) {
    return getWindowScroll(node);
  } else {
    return getHTMLElementScroll(node);
  }
}

function isElementScaled(element) {
  var rect = element.getBoundingClientRect();
  var scaleX = round$2(rect.width) / element.offsetWidth || 1;
  var scaleY = round$2(rect.height) / element.offsetHeight || 1;
  return scaleX !== 1 || scaleY !== 1;
} // Returns the composite rect of an element relative to its offsetParent.
// Composite means it takes into account transforms as well as layout.


function getCompositeRect(elementOrVirtualElement, offsetParent, isFixed) {
  if (isFixed === void 0) {
    isFixed = false;
  }

  var isOffsetParentAnElement = isHTMLElement$1(offsetParent);
  var offsetParentIsScaled = isHTMLElement$1(offsetParent) && isElementScaled(offsetParent);
  var documentElement = getDocumentElement(offsetParent);
  var rect = getBoundingClientRect(elementOrVirtualElement, offsetParentIsScaled, isFixed);
  var scroll = {
    scrollLeft: 0,
    scrollTop: 0
  };
  var offsets = {
    x: 0,
    y: 0
  };

  if (isOffsetParentAnElement || !isOffsetParentAnElement && !isFixed) {
    if (getNodeName(offsetParent) !== 'body' || // https://github.com/popperjs/popper-core/issues/1078
    isScrollParent(documentElement)) {
      scroll = getNodeScroll(offsetParent);
    }

    if (isHTMLElement$1(offsetParent)) {
      offsets = getBoundingClientRect(offsetParent, true);
      offsets.x += offsetParent.clientLeft;
      offsets.y += offsetParent.clientTop;
    } else if (documentElement) {
      offsets.x = getWindowScrollBarX(documentElement);
    }
  }

  return {
    x: rect.left + scroll.scrollLeft - offsets.x,
    y: rect.top + scroll.scrollTop - offsets.y,
    width: rect.width,
    height: rect.height
  };
}

function order(modifiers) {
  var map = new Map();
  var visited = new Set();
  var result = [];
  modifiers.forEach(function (modifier) {
    map.set(modifier.name, modifier);
  }); // On visiting object, check for its dependencies and visit them recursively

  function sort(modifier) {
    visited.add(modifier.name);
    var requires = [].concat(modifier.requires || [], modifier.requiresIfExists || []);
    requires.forEach(function (dep) {
      if (!visited.has(dep)) {
        var depModifier = map.get(dep);

        if (depModifier) {
          sort(depModifier);
        }
      }
    });
    result.push(modifier);
  }

  modifiers.forEach(function (modifier) {
    if (!visited.has(modifier.name)) {
      // check for visited object
      sort(modifier);
    }
  });
  return result;
}

function orderModifiers(modifiers) {
  // order based on dependencies
  var orderedModifiers = order(modifiers); // order based on phase

  return modifierPhases.reduce(function (acc, phase) {
    return acc.concat(orderedModifiers.filter(function (modifier) {
      return modifier.phase === phase;
    }));
  }, []);
}

function debounce(fn) {
  var pending;
  return function () {
    if (!pending) {
      pending = new Promise(function (resolve) {
        Promise.resolve().then(function () {
          pending = undefined;
          resolve(fn());
        });
      });
    }

    return pending;
  };
}

function format$1(str) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return [].concat(args).reduce(function (p, c) {
    return p.replace(/%s/, c);
  }, str);
}

var INVALID_MODIFIER_ERROR = 'Popper: modifier "%s" provided an invalid %s property, expected %s but got %s';
var MISSING_DEPENDENCY_ERROR = 'Popper: modifier "%s" requires "%s", but "%s" modifier is not available';
var VALID_PROPERTIES = ['name', 'enabled', 'phase', 'fn', 'effect', 'requires', 'options'];
function validateModifiers(modifiers) {
  modifiers.forEach(function (modifier) {
    [].concat(Object.keys(modifier), VALID_PROPERTIES) // IE11-compatible replacement for `new Set(iterable)`
    .filter(function (value, index, self) {
      return self.indexOf(value) === index;
    }).forEach(function (key) {
      switch (key) {
        case 'name':
          if (typeof modifier.name !== 'string') {
            console.error(format$1(INVALID_MODIFIER_ERROR, String(modifier.name), '"name"', '"string"', "\"" + String(modifier.name) + "\""));
          }

          break;

        case 'enabled':
          if (typeof modifier.enabled !== 'boolean') {
            console.error(format$1(INVALID_MODIFIER_ERROR, modifier.name, '"enabled"', '"boolean"', "\"" + String(modifier.enabled) + "\""));
          }

          break;

        case 'phase':
          if (modifierPhases.indexOf(modifier.phase) < 0) {
            console.error(format$1(INVALID_MODIFIER_ERROR, modifier.name, '"phase"', "either " + modifierPhases.join(', '), "\"" + String(modifier.phase) + "\""));
          }

          break;

        case 'fn':
          if (typeof modifier.fn !== 'function') {
            console.error(format$1(INVALID_MODIFIER_ERROR, modifier.name, '"fn"', '"function"', "\"" + String(modifier.fn) + "\""));
          }

          break;

        case 'effect':
          if (modifier.effect != null && typeof modifier.effect !== 'function') {
            console.error(format$1(INVALID_MODIFIER_ERROR, modifier.name, '"effect"', '"function"', "\"" + String(modifier.fn) + "\""));
          }

          break;

        case 'requires':
          if (modifier.requires != null && !Array.isArray(modifier.requires)) {
            console.error(format$1(INVALID_MODIFIER_ERROR, modifier.name, '"requires"', '"array"', "\"" + String(modifier.requires) + "\""));
          }

          break;

        case 'requiresIfExists':
          if (!Array.isArray(modifier.requiresIfExists)) {
            console.error(format$1(INVALID_MODIFIER_ERROR, modifier.name, '"requiresIfExists"', '"array"', "\"" + String(modifier.requiresIfExists) + "\""));
          }

          break;

        case 'options':
        case 'data':
          break;

        default:
          console.error("PopperJS: an invalid property has been provided to the \"" + modifier.name + "\" modifier, valid properties are " + VALID_PROPERTIES.map(function (s) {
            return "\"" + s + "\"";
          }).join(', ') + "; but \"" + key + "\" was provided.");
      }

      modifier.requires && modifier.requires.forEach(function (requirement) {
        if (modifiers.find(function (mod) {
          return mod.name === requirement;
        }) == null) {
          console.error(format$1(MISSING_DEPENDENCY_ERROR, String(modifier.name), requirement, requirement));
        }
      });
    });
  });
}

function uniqueBy(arr, fn) {
  var identifiers = new Set();
  return arr.filter(function (item) {
    var identifier = fn(item);

    if (!identifiers.has(identifier)) {
      identifiers.add(identifier);
      return true;
    }
  });
}

function mergeByName(modifiers) {
  var merged = modifiers.reduce(function (merged, current) {
    var existing = merged[current.name];
    merged[current.name] = existing ? Object.assign({}, existing, current, {
      options: Object.assign({}, existing.options, current.options),
      data: Object.assign({}, existing.data, current.data)
    }) : current;
    return merged;
  }, {}); // IE11 does not support Object.values

  return Object.keys(merged).map(function (key) {
    return merged[key];
  });
}

var INVALID_ELEMENT_ERROR = 'Popper: Invalid reference or popper argument provided. They must be either a DOM element or virtual element.';
var INFINITE_LOOP_ERROR = 'Popper: An infinite loop in the modifiers cycle has been detected! The cycle has been interrupted to prevent a browser crash.';
var DEFAULT_OPTIONS = {
  placement: 'bottom',
  modifiers: [],
  strategy: 'absolute'
};

function areValidElements() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return !args.some(function (element) {
    return !(element && typeof element.getBoundingClientRect === 'function');
  });
}

function popperGenerator(generatorOptions) {
  if (generatorOptions === void 0) {
    generatorOptions = {};
  }

  var _generatorOptions = generatorOptions,
      _generatorOptions$def = _generatorOptions.defaultModifiers,
      defaultModifiers = _generatorOptions$def === void 0 ? [] : _generatorOptions$def,
      _generatorOptions$def2 = _generatorOptions.defaultOptions,
      defaultOptions = _generatorOptions$def2 === void 0 ? DEFAULT_OPTIONS : _generatorOptions$def2;
  return function createPopper(reference, popper, options) {
    if (options === void 0) {
      options = defaultOptions;
    }

    var state = {
      placement: 'bottom',
      orderedModifiers: [],
      options: Object.assign({}, DEFAULT_OPTIONS, defaultOptions),
      modifiersData: {},
      elements: {
        reference: reference,
        popper: popper
      },
      attributes: {},
      styles: {}
    };
    var effectCleanupFns = [];
    var isDestroyed = false;
    var instance = {
      state: state,
      setOptions: function setOptions(setOptionsAction) {
        var options = typeof setOptionsAction === 'function' ? setOptionsAction(state.options) : setOptionsAction;
        cleanupModifierEffects();
        state.options = Object.assign({}, defaultOptions, state.options, options);
        state.scrollParents = {
          reference: isElement(reference) ? listScrollParents(reference) : reference.contextElement ? listScrollParents(reference.contextElement) : [],
          popper: listScrollParents(popper)
        }; // Orders the modifiers based on their dependencies and `phase`
        // properties

        var orderedModifiers = orderModifiers(mergeByName([].concat(defaultModifiers, state.options.modifiers))); // Strip out disabled modifiers

        state.orderedModifiers = orderedModifiers.filter(function (m) {
          return m.enabled;
        }); // Validate the provided modifiers so that the consumer will get warned
        // if one of the modifiers is invalid for any reason

        if (browser$1.env.NODE_ENV !== "production") {
          var modifiers = uniqueBy([].concat(orderedModifiers, state.options.modifiers), function (_ref) {
            var name = _ref.name;
            return name;
          });
          validateModifiers(modifiers);

          if (getBasePlacement(state.options.placement) === auto) {
            var flipModifier = state.orderedModifiers.find(function (_ref2) {
              var name = _ref2.name;
              return name === 'flip';
            });

            if (!flipModifier) {
              console.error(['Popper: "auto" placements require the "flip" modifier be', 'present and enabled to work.'].join(' '));
            }
          }

          var _getComputedStyle = getComputedStyle(popper),
              marginTop = _getComputedStyle.marginTop,
              marginRight = _getComputedStyle.marginRight,
              marginBottom = _getComputedStyle.marginBottom,
              marginLeft = _getComputedStyle.marginLeft; // We no longer take into account `margins` on the popper, and it can
          // cause bugs with positioning, so we'll warn the consumer


          if ([marginTop, marginRight, marginBottom, marginLeft].some(function (margin) {
            return parseFloat(margin);
          })) {
            console.warn(['Popper: CSS "margin" styles cannot be used to apply padding', 'between the popper and its reference element or boundary.', 'To replicate margin, use the `offset` modifier, as well as', 'the `padding` option in the `preventOverflow` and `flip`', 'modifiers.'].join(' '));
          }
        }

        runModifierEffects();
        return instance.update();
      },
      // Sync update – it will always be executed, even if not necessary. This
      // is useful for low frequency updates where sync behavior simplifies the
      // logic.
      // For high frequency updates (e.g. `resize` and `scroll` events), always
      // prefer the async Popper#update method
      forceUpdate: function forceUpdate() {
        if (isDestroyed) {
          return;
        }

        var _state$elements = state.elements,
            reference = _state$elements.reference,
            popper = _state$elements.popper; // Don't proceed if `reference` or `popper` are not valid elements
        // anymore

        if (!areValidElements(reference, popper)) {
          if (browser$1.env.NODE_ENV !== "production") {
            console.error(INVALID_ELEMENT_ERROR);
          }

          return;
        } // Store the reference and popper rects to be read by modifiers


        state.rects = {
          reference: getCompositeRect(reference, getOffsetParent(popper), state.options.strategy === 'fixed'),
          popper: getLayoutRect(popper)
        }; // Modifiers have the ability to reset the current update cycle. The
        // most common use case for this is the `flip` modifier changing the
        // placement, which then needs to re-run all the modifiers, because the
        // logic was previously ran for the previous placement and is therefore
        // stale/incorrect

        state.reset = false;
        state.placement = state.options.placement; // On each update cycle, the `modifiersData` property for each modifier
        // is filled with the initial data specified by the modifier. This means
        // it doesn't persist and is fresh on each update.
        // To ensure persistent data, use `${name}#persistent`

        state.orderedModifiers.forEach(function (modifier) {
          return state.modifiersData[modifier.name] = Object.assign({}, modifier.data);
        });
        var __debug_loops__ = 0;

        for (var index = 0; index < state.orderedModifiers.length; index++) {
          if (browser$1.env.NODE_ENV !== "production") {
            __debug_loops__ += 1;

            if (__debug_loops__ > 100) {
              console.error(INFINITE_LOOP_ERROR);
              break;
            }
          }

          if (state.reset === true) {
            state.reset = false;
            index = -1;
            continue;
          }

          var _state$orderedModifie = state.orderedModifiers[index],
              fn = _state$orderedModifie.fn,
              _state$orderedModifie2 = _state$orderedModifie.options,
              _options = _state$orderedModifie2 === void 0 ? {} : _state$orderedModifie2,
              name = _state$orderedModifie.name;

          if (typeof fn === 'function') {
            state = fn({
              state: state,
              options: _options,
              name: name,
              instance: instance
            }) || state;
          }
        }
      },
      // Async and optimistically optimized update – it will not be executed if
      // not necessary (debounced to run at most once-per-tick)
      update: debounce(function () {
        return new Promise(function (resolve) {
          instance.forceUpdate();
          resolve(state);
        });
      }),
      destroy: function destroy() {
        cleanupModifierEffects();
        isDestroyed = true;
      }
    };

    if (!areValidElements(reference, popper)) {
      if (browser$1.env.NODE_ENV !== "production") {
        console.error(INVALID_ELEMENT_ERROR);
      }

      return instance;
    }

    instance.setOptions(options).then(function (state) {
      if (!isDestroyed && options.onFirstUpdate) {
        options.onFirstUpdate(state);
      }
    }); // Modifiers have the ability to execute arbitrary code before the first
    // update cycle runs. They will be executed in the same order as the update
    // cycle. This is useful when a modifier adds some persistent data that
    // other modifiers need to use, but the modifier is run after the dependent
    // one.

    function runModifierEffects() {
      state.orderedModifiers.forEach(function (_ref3) {
        var name = _ref3.name,
            _ref3$options = _ref3.options,
            options = _ref3$options === void 0 ? {} : _ref3$options,
            effect = _ref3.effect;

        if (typeof effect === 'function') {
          var cleanupFn = effect({
            state: state,
            name: name,
            instance: instance,
            options: options
          });

          var noopFn = function noopFn() {};

          effectCleanupFns.push(cleanupFn || noopFn);
        }
      });
    }

    function cleanupModifierEffects() {
      effectCleanupFns.forEach(function (fn) {
        return fn();
      });
      effectCleanupFns = [];
    }

    return instance;
  };
}

var defaultModifiers = [eventListeners, popperOffsets$1, computeStyles$1, applyStyles$1, offset$1, flip$1, preventOverflow$1, arrow$1, hide$1];
var createPopper = /*#__PURE__*/popperGenerator({
  defaultModifiers: defaultModifiers
}); // eslint-disable-next-line import/no-unused-modules

function getContainer$1(container) {
  return typeof container === 'function' ? container() : container;
}

/**
 * Portals provide a first-class way to render children into a DOM node
 * that exists outside the DOM hierarchy of the parent component.
 *
 * Demos:
 *
 * - [Portal](https://mui.com/base/react-portal/)
 *
 * API:
 *
 * - [Portal API](https://mui.com/base/api/portal/)
 */
const Portal = /*#__PURE__*/React__namespace.forwardRef(function Portal(props, ref) {
  const {
    children,
    container,
    disablePortal = false
  } = props;
  const [mountNode, setMountNode] = React__namespace.useState(null);
  // @ts-expect-error TODO upstream fix
  const handleRef = useForkRef( /*#__PURE__*/React__namespace.isValidElement(children) ? children.ref : null, ref);
  useEnhancedEffect$1(() => {
    if (!disablePortal) {
      setMountNode(getContainer$1(container) || document.body);
    }
  }, [container, disablePortal]);
  useEnhancedEffect$1(() => {
    if (mountNode && !disablePortal) {
      setRef(ref, mountNode);
      return () => {
        setRef(ref, null);
      };
    }
    return undefined;
  }, [ref, mountNode, disablePortal]);
  if (disablePortal) {
    if ( /*#__PURE__*/React__namespace.isValidElement(children)) {
      const newProps = {
        ref: handleRef
      };
      return /*#__PURE__*/React__namespace.cloneElement(children, newProps);
    }
    return /*#__PURE__*/jsxRuntimeExports.jsx(React__namespace.Fragment, {
      children: children
    });
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(React__namespace.Fragment, {
    children: mountNode ? /*#__PURE__*/ReactDOM__namespace.createPortal(children, mountNode) : mountNode
  });
});
browser$1.env.NODE_ENV !== "production" ? Portal.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------
  /**
   * The children to render into the `container`.
   */
  children: propTypesExports.node,
  /**
   * An HTML element or function that returns one.
   * The `container` will have the portal children appended to it.
   *
   * By default, it uses the body of the top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.func]),
  /**
   * The `children` will be under the DOM hierarchy of the parent component.
   * @default false
   */
  disablePortal: propTypesExports.bool
} : void 0;
if (browser$1.env.NODE_ENV !== 'production') {
  // eslint-disable-next-line
  Portal['propTypes' + ''] = exactProp(Portal.propTypes);
}
var Portal$1 = Portal;

function getPopperUnstyledUtilityClass(slot) {
  return generateUtilityClass('MuiPopper', slot);
}
generateUtilityClasses('MuiPopper', ['root']);

const _excluded$1A = ["anchorEl", "children", "component", "direction", "disablePortal", "modifiers", "open", "ownerState", "placement", "popperOptions", "popperRef", "slotProps", "slots", "TransitionProps"],
  _excluded2$3 = ["anchorEl", "children", "container", "direction", "disablePortal", "keepMounted", "modifiers", "open", "placement", "popperOptions", "popperRef", "style", "transition", "slotProps", "slots"];
function flipPlacement(placement, direction) {
  if (direction === 'ltr') {
    return placement;
  }
  switch (placement) {
    case 'bottom-end':
      return 'bottom-start';
    case 'bottom-start':
      return 'bottom-end';
    case 'top-end':
      return 'top-start';
    case 'top-start':
      return 'top-end';
    default:
      return placement;
  }
}
function resolveAnchorEl$1(anchorEl) {
  return typeof anchorEl === 'function' ? anchorEl() : anchorEl;
}
function isHTMLElement(element) {
  return element.nodeType !== undefined;
}
function isVirtualElement(element) {
  return !isHTMLElement(element);
}
const useUtilityClasses$Q = () => {
  const slots = {
    root: ['root']
  };
  return composeClasses(slots, useClassNamesOverride(getPopperUnstyledUtilityClass));
};
const defaultPopperOptions = {};
const PopperTooltip = /*#__PURE__*/React__namespace.forwardRef(function PopperTooltip(props, ref) {
  var _ref;
  const {
      anchorEl,
      children,
      component,
      direction,
      disablePortal,
      modifiers,
      open,
      ownerState,
      placement: initialPlacement,
      popperOptions,
      popperRef: popperRefProp,
      slotProps = {},
      slots = {},
      TransitionProps
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1A);
  const tooltipRef = React__namespace.useRef(null);
  const ownRef = useForkRef(tooltipRef, ref);
  const popperRef = React__namespace.useRef(null);
  const handlePopperRef = useForkRef(popperRef, popperRefProp);
  const handlePopperRefRef = React__namespace.useRef(handlePopperRef);
  useEnhancedEffect$1(() => {
    handlePopperRefRef.current = handlePopperRef;
  }, [handlePopperRef]);
  React__namespace.useImperativeHandle(popperRefProp, () => popperRef.current, []);
  const rtlPlacement = flipPlacement(initialPlacement, direction);
  /**
   * placement initialized from prop but can change during lifetime if modifiers.flip.
   * modifiers.flip is essentially a flip for controlled/uncontrolled behavior
   */
  const [placement, setPlacement] = React__namespace.useState(rtlPlacement);
  const [resolvedAnchorElement, setResolvedAnchorElement] = React__namespace.useState(resolveAnchorEl$1(anchorEl));
  React__namespace.useEffect(() => {
    if (popperRef.current) {
      popperRef.current.forceUpdate();
    }
  });
  React__namespace.useEffect(() => {
    if (anchorEl) {
      setResolvedAnchorElement(resolveAnchorEl$1(anchorEl));
    }
  }, [anchorEl]);
  useEnhancedEffect$1(() => {
    if (!resolvedAnchorElement || !open) {
      return undefined;
    }
    const handlePopperUpdate = data => {
      setPlacement(data.placement);
    };
    if (browser$1.env.NODE_ENV !== 'production') {
      if (resolvedAnchorElement && isHTMLElement(resolvedAnchorElement) && resolvedAnchorElement.nodeType === 1) {
        const box = resolvedAnchorElement.getBoundingClientRect();
        if (browser$1.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
          console.warn(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
        }
      }
    }
    let popperModifiers = [{
      name: 'preventOverflow',
      options: {
        altBoundary: disablePortal
      }
    }, {
      name: 'flip',
      options: {
        altBoundary: disablePortal
      }
    }, {
      name: 'onUpdate',
      enabled: true,
      phase: 'afterWrite',
      fn: ({
        state
      }) => {
        handlePopperUpdate(state);
      }
    }];
    if (modifiers != null) {
      popperModifiers = popperModifiers.concat(modifiers);
    }
    if (popperOptions && popperOptions.modifiers != null) {
      popperModifiers = popperModifiers.concat(popperOptions.modifiers);
    }
    const popper = createPopper(resolvedAnchorElement, tooltipRef.current, _extends$1({
      placement: rtlPlacement
    }, popperOptions, {
      modifiers: popperModifiers
    }));
    handlePopperRefRef.current(popper);
    return () => {
      popper.destroy();
      handlePopperRefRef.current(null);
    };
  }, [resolvedAnchorElement, disablePortal, modifiers, open, popperOptions, rtlPlacement]);
  const childProps = {
    placement: placement
  };
  if (TransitionProps !== null) {
    childProps.TransitionProps = TransitionProps;
  }
  const classes = useUtilityClasses$Q();
  const Root = (_ref = component != null ? component : slots.root) != null ? _ref : 'div';
  const rootProps = useSlotProps({
    elementType: Root,
    externalSlotProps: slotProps.root,
    externalForwardedProps: other,
    additionalProps: {
      role: 'tooltip',
      ref: ownRef
    },
    ownerState: _extends$1({}, props, ownerState),
    className: classes.root
  });
  return /*#__PURE__*/jsxRuntimeExports.jsx(Root, _extends$1({}, rootProps, {
    children: typeof children === 'function' ? children(childProps) : children
  }));
});

/**
 * Poppers rely on the 3rd party library [Popper.js](https://popper.js.org/docs/v2/) for positioning.
 *
 * Demos:
 *
 * - [Unstyled Popper](https://mui.com/base/react-popper/)
 *
 * API:
 *
 * - [PopperUnstyled API](https://mui.com/base/api/popper-unstyled/)
 */
const PopperUnstyled = /*#__PURE__*/React__namespace.forwardRef(function PopperUnstyled(props, ref) {
  const {
      anchorEl,
      children,
      container: containerProp,
      direction = 'ltr',
      disablePortal = false,
      keepMounted = false,
      modifiers,
      open,
      placement = 'bottom',
      popperOptions = defaultPopperOptions,
      popperRef,
      style,
      transition = false,
      slotProps = {},
      slots = {}
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded2$3);
  const [exited, setExited] = React__namespace.useState(true);
  const handleEnter = () => {
    setExited(false);
  };
  const handleExited = () => {
    setExited(true);
  };
  if (!keepMounted && !open && (!transition || exited)) {
    return null;
  }

  // If the container prop is provided, use that
  // If the anchorEl prop is provided, use its parent body element as the container
  // If neither are provided let the Modal take care of choosing the container
  let container;
  if (containerProp) {
    container = containerProp;
  } else if (anchorEl) {
    const resolvedAnchorEl = resolveAnchorEl$1(anchorEl);
    container = resolvedAnchorEl && isHTMLElement(resolvedAnchorEl) ? ownerDocument(resolvedAnchorEl).body : ownerDocument(null).body;
  }
  const display = !open && keepMounted && (!transition || exited) ? 'none' : undefined;
  const transitionProps = transition ? {
    in: open,
    onEnter: handleEnter,
    onExited: handleExited
  } : undefined;
  return /*#__PURE__*/jsxRuntimeExports.jsx(Portal$1, {
    disablePortal: disablePortal,
    container: container,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(PopperTooltip, _extends$1({
      anchorEl: anchorEl,
      direction: direction,
      disablePortal: disablePortal,
      modifiers: modifiers,
      ref: ref,
      open: transition ? !exited : open,
      placement: placement,
      popperOptions: popperOptions,
      popperRef: popperRef,
      slotProps: slotProps,
      slots: slots
    }, other, {
      style: _extends$1({
        // Prevents scroll issue, waiting for Popper.js to add this style once initiated.
        position: 'fixed',
        // Fix Popper.js display issue
        top: 0,
        left: 0,
        display
      }, style),
      TransitionProps: transitionProps,
      children: children
    }))
  });
});
browser$1.env.NODE_ENV !== "production" ? PopperUnstyled.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------
  /**
   * An HTML element, [virtualElement](https://popper.js.org/docs/v2/virtual-elements/),
   * or a function that returns either.
   * It's used to set the position of the popper.
   * The return value will passed as the reference object of the Popper instance.
   */
  anchorEl: chainPropTypes(propTypesExports.oneOfType([HTMLElementType, propTypesExports.object, propTypesExports.func]), props => {
    if (props.open) {
      const resolvedAnchorEl = resolveAnchorEl$1(props.anchorEl);
      if (resolvedAnchorEl && isHTMLElement(resolvedAnchorEl) && resolvedAnchorEl.nodeType === 1) {
        const box = resolvedAnchorEl.getBoundingClientRect();
        if (browser$1.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
          return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
        }
      } else if (!resolvedAnchorEl || typeof resolvedAnchorEl.getBoundingClientRect !== 'function' || isVirtualElement(resolvedAnchorEl) && resolvedAnchorEl.contextElement != null && resolvedAnchorEl.contextElement.nodeType !== 1) {
        return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', 'It should be an HTML element instance or a virtualElement ', '(https://popper.js.org/docs/v2/virtual-elements/).'].join('\n'));
      }
    }
    return null;
  }),
  /**
   * Popper render function or node.
   */
  children: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.node, propTypesExports.func]),
  /**
   * An HTML element or function that returns one.
   * The `container` will have the portal children appended to it.
   *
   * By default, it uses the body of the top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.func]),
  /**
   * Direction of the text.
   * @default 'ltr'
   */
  direction: propTypesExports.oneOf(['ltr', 'rtl']),
  /**
   * The `children` will be under the DOM hierarchy of the parent component.
   * @default false
   */
  disablePortal: propTypesExports.bool,
  /**
   * Always keep the children in the DOM.
   * This prop can be useful in SEO situation or
   * when you want to maximize the responsiveness of the Popper.
   * @default false
   */
  keepMounted: propTypesExports.bool,
  /**
   * Popper.js is based on a "plugin-like" architecture,
   * most of its features are fully encapsulated "modifiers".
   *
   * A modifier is a function that is called each time Popper.js needs to
   * compute the position of the popper.
   * For this reason, modifiers should be very performant to avoid bottlenecks.
   * To learn how to create a modifier, [read the modifiers documentation](https://popper.js.org/docs/v2/modifiers/).
   */
  modifiers: propTypesExports.arrayOf(propTypesExports.shape({
    data: propTypesExports.object,
    effect: propTypesExports.func,
    enabled: propTypesExports.bool,
    fn: propTypesExports.func,
    name: propTypesExports.any,
    options: propTypesExports.object,
    phase: propTypesExports.oneOf(['afterMain', 'afterRead', 'afterWrite', 'beforeMain', 'beforeRead', 'beforeWrite', 'main', 'read', 'write']),
    requires: propTypesExports.arrayOf(propTypesExports.string),
    requiresIfExists: propTypesExports.arrayOf(propTypesExports.string)
  })),
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool.isRequired,
  /**
   * Popper placement.
   * @default 'bottom'
   */
  placement: propTypesExports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),
  /**
   * Options provided to the [`Popper.js`](https://popper.js.org/docs/v2/constructors/#options) instance.
   * @default {}
   */
  popperOptions: propTypesExports.shape({
    modifiers: propTypesExports.array,
    onFirstUpdate: propTypesExports.func,
    placement: propTypesExports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),
    strategy: propTypesExports.oneOf(['absolute', 'fixed'])
  }),
  /**
   * A ref that points to the used popper instance.
   */
  popperRef: refType$1,
  /**
   * The props used for each slot inside the Popper.
   * @default {}
   */
  slotProps: propTypesExports.shape({
    root: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object])
  }),
  /**
   * The components used for each slot inside the Popper.
   * Either a string to use a HTML element or a component.
   * @default {}
   */
  slots: propTypesExports.shape({
    root: propTypesExports.elementType
  }),
  /**
   * @ignore
   */
  style: propTypesExports.object,
  /**
   * Help supporting a react-transition-group/Transition component.
   * @default false
   */
  transition: propTypesExports.bool
} : void 0;
var PopperUnstyled$1 = PopperUnstyled;

// Is a vertical scrollbar displayed?
function isOverflowing(container) {
  const doc = ownerDocument(container);
  if (doc.body === container) {
    return ownerWindow(container).innerWidth > doc.documentElement.clientWidth;
  }
  return container.scrollHeight > container.clientHeight;
}
function ariaHidden(element, show) {
  if (show) {
    element.setAttribute('aria-hidden', 'true');
  } else {
    element.removeAttribute('aria-hidden');
  }
}
function getPaddingRight(element) {
  return parseInt(ownerWindow(element).getComputedStyle(element).paddingRight, 10) || 0;
}
function isAriaHiddenForbiddenOnElement(element) {
  // The forbidden HTML tags are the ones from ARIA specification that
  // can be children of body and can't have aria-hidden attribute.
  // cf. https://www.w3.org/TR/html-aria/#docconformance
  const forbiddenTagNames = ['TEMPLATE', 'SCRIPT', 'STYLE', 'LINK', 'MAP', 'META', 'NOSCRIPT', 'PICTURE', 'COL', 'COLGROUP', 'PARAM', 'SLOT', 'SOURCE', 'TRACK'];
  const isForbiddenTagName = forbiddenTagNames.indexOf(element.tagName) !== -1;
  const isInputHidden = element.tagName === 'INPUT' && element.getAttribute('type') === 'hidden';
  return isForbiddenTagName || isInputHidden;
}
function ariaHiddenSiblings(container, mountElement, currentElement, elementsToExclude, show) {
  const blacklist = [mountElement, currentElement, ...elementsToExclude];
  [].forEach.call(container.children, element => {
    const isNotExcludedElement = blacklist.indexOf(element) === -1;
    const isNotForbiddenElement = !isAriaHiddenForbiddenOnElement(element);
    if (isNotExcludedElement && isNotForbiddenElement) {
      ariaHidden(element, show);
    }
  });
}
function findIndexOf(items, callback) {
  let idx = -1;
  items.some((item, index) => {
    if (callback(item)) {
      idx = index;
      return true;
    }
    return false;
  });
  return idx;
}
function handleContainer(containerInfo, props) {
  const restoreStyle = [];
  const container = containerInfo.container;
  if (!props.disableScrollLock) {
    if (isOverflowing(container)) {
      // Compute the size before applying overflow hidden to avoid any scroll jumps.
      const scrollbarSize = getScrollbarSize(ownerDocument(container));
      restoreStyle.push({
        value: container.style.paddingRight,
        property: 'padding-right',
        el: container
      });
      // Use computed style, here to get the real padding to add our scrollbar width.
      container.style.paddingRight = `${getPaddingRight(container) + scrollbarSize}px`;

      // .mui-fixed is a global helper.
      const fixedElements = ownerDocument(container).querySelectorAll('.mui-fixed');
      [].forEach.call(fixedElements, element => {
        restoreStyle.push({
          value: element.style.paddingRight,
          property: 'padding-right',
          el: element
        });
        element.style.paddingRight = `${getPaddingRight(element) + scrollbarSize}px`;
      });
    }
    let scrollContainer;
    if (container.parentNode instanceof DocumentFragment) {
      scrollContainer = ownerDocument(container).body;
    } else {
      // Improve Gatsby support
      // https://css-tricks.com/snippets/css/force-vertical-scrollbar/
      const parent = container.parentElement;
      const containerWindow = ownerWindow(container);
      scrollContainer = (parent == null ? void 0 : parent.nodeName) === 'HTML' && containerWindow.getComputedStyle(parent).overflowY === 'scroll' ? parent : container;
    }

    // Block the scroll even if no scrollbar is visible to account for mobile keyboard
    // screensize shrink.
    restoreStyle.push({
      value: scrollContainer.style.overflow,
      property: 'overflow',
      el: scrollContainer
    }, {
      value: scrollContainer.style.overflowX,
      property: 'overflow-x',
      el: scrollContainer
    }, {
      value: scrollContainer.style.overflowY,
      property: 'overflow-y',
      el: scrollContainer
    });
    scrollContainer.style.overflow = 'hidden';
  }
  const restore = () => {
    restoreStyle.forEach(({
      value,
      el,
      property
    }) => {
      if (value) {
        el.style.setProperty(property, value);
      } else {
        el.style.removeProperty(property);
      }
    });
  };
  return restore;
}
function getHiddenSiblings(container) {
  const hiddenSiblings = [];
  [].forEach.call(container.children, element => {
    if (element.getAttribute('aria-hidden') === 'true') {
      hiddenSiblings.push(element);
    }
  });
  return hiddenSiblings;
}
/**
 * @ignore - do not document.
 *
 * Proper state management for containers and the modals in those containers.
 * Simplified, but inspired by react-overlay's ModalManager class.
 * Used by the Modal to ensure proper styling of containers.
 */
class ModalManager {
  constructor() {
    this.containers = void 0;
    this.modals = void 0;
    this.modals = [];
    this.containers = [];
  }
  add(modal, container) {
    let modalIndex = this.modals.indexOf(modal);
    if (modalIndex !== -1) {
      return modalIndex;
    }
    modalIndex = this.modals.length;
    this.modals.push(modal);

    // If the modal we are adding is already in the DOM.
    if (modal.modalRef) {
      ariaHidden(modal.modalRef, false);
    }
    const hiddenSiblings = getHiddenSiblings(container);
    ariaHiddenSiblings(container, modal.mount, modal.modalRef, hiddenSiblings, true);
    const containerIndex = findIndexOf(this.containers, item => item.container === container);
    if (containerIndex !== -1) {
      this.containers[containerIndex].modals.push(modal);
      return modalIndex;
    }
    this.containers.push({
      modals: [modal],
      container,
      restore: null,
      hiddenSiblings
    });
    return modalIndex;
  }
  mount(modal, props) {
    const containerIndex = findIndexOf(this.containers, item => item.modals.indexOf(modal) !== -1);
    const containerInfo = this.containers[containerIndex];
    if (!containerInfo.restore) {
      containerInfo.restore = handleContainer(containerInfo, props);
    }
  }
  remove(modal, ariaHiddenState = true) {
    const modalIndex = this.modals.indexOf(modal);
    if (modalIndex === -1) {
      return modalIndex;
    }
    const containerIndex = findIndexOf(this.containers, item => item.modals.indexOf(modal) !== -1);
    const containerInfo = this.containers[containerIndex];
    containerInfo.modals.splice(containerInfo.modals.indexOf(modal), 1);
    this.modals.splice(modalIndex, 1);

    // If that was the last modal in a container, clean up the container.
    if (containerInfo.modals.length === 0) {
      // The modal might be closed before it had the chance to be mounted in the DOM.
      if (containerInfo.restore) {
        containerInfo.restore();
      }
      if (modal.modalRef) {
        // In case the modal wasn't in the DOM yet.
        ariaHidden(modal.modalRef, ariaHiddenState);
      }
      ariaHiddenSiblings(containerInfo.container, modal.mount, modal.modalRef, containerInfo.hiddenSiblings, false);
      this.containers.splice(containerIndex, 1);
    } else {
      // Otherwise make sure the next top modal is visible to a screen reader.
      const nextTop = containerInfo.modals[containerInfo.modals.length - 1];
      // as soon as a modal is adding its modalRef is undefined. it can't set
      // aria-hidden because the dom element doesn't exist either
      // when modal was unmounted before modalRef gets null
      if (nextTop.modalRef) {
        ariaHidden(nextTop.modalRef, false);
      }
    }
    return modalIndex;
  }
  isTopModal(modal) {
    return this.modals.length > 0 && this.modals[this.modals.length - 1] === modal;
  }
}

function getModalUtilityClass(slot) {
  return generateUtilityClass('MuiModal', slot);
}
generateUtilityClasses('MuiModal', ['root', 'hidden', 'backdrop']);

const _excluded$1z = ["children", "closeAfterTransition", "component", "container", "disableAutoFocus", "disableEnforceFocus", "disableEscapeKeyDown", "disablePortal", "disableRestoreFocus", "disableScrollLock", "hideBackdrop", "keepMounted", "manager", "onBackdropClick", "onClose", "onKeyDown", "open", "onTransitionEnter", "onTransitionExited", "slotProps", "slots"];
const useUtilityClasses$P = ownerState => {
  const {
    open,
    exited
  } = ownerState;
  const slots = {
    root: ['root', !open && exited && 'hidden'],
    backdrop: ['backdrop']
  };
  return composeClasses(slots, useClassNamesOverride(getModalUtilityClass));
};
function getContainer(container) {
  return typeof container === 'function' ? container() : container;
}
function getHasTransition(children) {
  return children ? children.props.hasOwnProperty('in') : false;
}

// A modal manager used to track and manage the state of open Modals.
// Modals don't open on the server so this won't conflict with concurrent requests.
const defaultManager = new ModalManager();

/**
 * Modal is a lower-level construct that is leveraged by the following components:
 *
 * *   [Dialog](https://mui.com/material-ui/api/dialog/)
 * *   [Drawer](https://mui.com/material-ui/api/drawer/)
 * *   [Menu](https://mui.com/material-ui/api/menu/)
 * *   [Popover](https://mui.com/material-ui/api/popover/)
 *
 * If you are creating a modal dialog, you probably want to use the [Dialog](https://mui.com/material-ui/api/dialog/) component
 * rather than directly using Modal.
 *
 * This component shares many concepts with [react-overlays](https://react-bootstrap.github.io/react-overlays/#modals).
 *
 * Demos:
 *
 * - [Unstyled Modal](https://mui.com/base/react-modal/)
 *
 * API:
 *
 * - [ModalUnstyled API](https://mui.com/base/api/modal-unstyled/)
 */
const ModalUnstyled = /*#__PURE__*/React__namespace.forwardRef(function ModalUnstyled(props, forwardedRef) {
  var _props$ariaHidden, _ref;
  const {
      children,
      closeAfterTransition = false,
      component,
      container,
      disableAutoFocus = false,
      disableEnforceFocus = false,
      disableEscapeKeyDown = false,
      disablePortal = false,
      disableRestoreFocus = false,
      disableScrollLock = false,
      hideBackdrop = false,
      keepMounted = false,
      // private
      manager = defaultManager,
      onBackdropClick,
      onClose,
      onKeyDown,
      open,
      onTransitionEnter,
      onTransitionExited,
      slotProps = {},
      slots = {}
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1z);
  const [exited, setExited] = React__namespace.useState(!open);
  const modal = React__namespace.useRef({});
  const mountNodeRef = React__namespace.useRef(null);
  const modalRef = React__namespace.useRef(null);
  const handleRef = useForkRef(modalRef, forwardedRef);
  const hasTransition = getHasTransition(children);
  const ariaHiddenProp = (_props$ariaHidden = props['aria-hidden']) != null ? _props$ariaHidden : true;
  const getDoc = () => ownerDocument(mountNodeRef.current);
  const getModal = () => {
    modal.current.modalRef = modalRef.current;
    modal.current.mountNode = mountNodeRef.current;
    return modal.current;
  };
  const handleMounted = () => {
    manager.mount(getModal(), {
      disableScrollLock
    });

    // Fix a bug on Chrome where the scroll isn't initially 0.
    if (modalRef.current) {
      modalRef.current.scrollTop = 0;
    }
  };
  const handleOpen = useEventCallback(() => {
    const resolvedContainer = getContainer(container) || getDoc().body;
    manager.add(getModal(), resolvedContainer);

    // The element was already mounted.
    if (modalRef.current) {
      handleMounted();
    }
  });
  const isTopModal = React__namespace.useCallback(() => manager.isTopModal(getModal()), [manager]);
  const handlePortalRef = useEventCallback(node => {
    mountNodeRef.current = node;
    if (!node || !modalRef.current) {
      return;
    }
    if (open && isTopModal()) {
      handleMounted();
    } else {
      ariaHidden(modalRef.current, ariaHiddenProp);
    }
  });
  const handleClose = React__namespace.useCallback(() => {
    manager.remove(getModal(), ariaHiddenProp);
  }, [manager, ariaHiddenProp]);
  React__namespace.useEffect(() => {
    return () => {
      handleClose();
    };
  }, [handleClose]);
  React__namespace.useEffect(() => {
    if (open) {
      handleOpen();
    } else if (!hasTransition || !closeAfterTransition) {
      handleClose();
    }
  }, [open, handleClose, hasTransition, closeAfterTransition, handleOpen]);
  const ownerState = _extends$1({}, props, {
    closeAfterTransition,
    disableAutoFocus,
    disableEnforceFocus,
    disableEscapeKeyDown,
    disablePortal,
    disableRestoreFocus,
    disableScrollLock,
    exited,
    hideBackdrop,
    keepMounted
  });
  const classes = useUtilityClasses$P(ownerState);
  const handleEnter = () => {
    setExited(false);
    if (onTransitionEnter) {
      onTransitionEnter();
    }
  };
  const handleExited = () => {
    setExited(true);
    if (onTransitionExited) {
      onTransitionExited();
    }
    if (closeAfterTransition) {
      handleClose();
    }
  };
  const handleBackdropClick = event => {
    if (event.target !== event.currentTarget) {
      return;
    }
    if (onBackdropClick) {
      onBackdropClick(event);
    }
    if (onClose) {
      onClose(event, 'backdropClick');
    }
  };
  const handleKeyDown = event => {
    if (onKeyDown) {
      onKeyDown(event);
    }

    // The handler doesn't take event.defaultPrevented into account:
    //
    // event.preventDefault() is meant to stop default behaviors like
    // clicking a checkbox to check it, hitting a button to submit a form,
    // and hitting left arrow to move the cursor in a text input etc.
    // Only special HTML elements have these default behaviors.
    if (event.key !== 'Escape' || !isTopModal()) {
      return;
    }
    if (!disableEscapeKeyDown) {
      // Swallow the event, in case someone is listening for the escape key on the body.
      event.stopPropagation();
      if (onClose) {
        onClose(event, 'escapeKeyDown');
      }
    }
  };
  const childProps = {};
  if (children.props.tabIndex === undefined) {
    childProps.tabIndex = '-1';
  }

  // It's a Transition like component
  if (hasTransition) {
    childProps.onEnter = createChainedFunction(handleEnter, children.props.onEnter);
    childProps.onExited = createChainedFunction(handleExited, children.props.onExited);
  }
  const Root = (_ref = component != null ? component : slots.root) != null ? _ref : 'div';
  const rootProps = useSlotProps({
    elementType: Root,
    externalSlotProps: slotProps.root,
    externalForwardedProps: other,
    additionalProps: {
      ref: handleRef,
      role: 'presentation',
      onKeyDown: handleKeyDown
    },
    className: classes.root,
    ownerState
  });
  const BackdropComponent = slots.backdrop;
  const backdropProps = useSlotProps({
    elementType: BackdropComponent,
    externalSlotProps: slotProps.backdrop,
    additionalProps: {
      'aria-hidden': true,
      onClick: handleBackdropClick,
      open
    },
    className: classes.backdrop,
    ownerState
  });
  if (!keepMounted && !open && (!hasTransition || exited)) {
    return null;
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(Portal$1
  // @ts-expect-error TODO: include ref to MUI Base Portal props
  , {
    ref: handlePortalRef,
    container: container,
    disablePortal: disablePortal,
    children: /*#__PURE__*/jsxRuntimeExports.jsxs(Root, _extends$1({}, rootProps, {
      children: [!hideBackdrop && BackdropComponent ? /*#__PURE__*/jsxRuntimeExports.jsx(BackdropComponent, _extends$1({}, backdropProps)) : null, /*#__PURE__*/jsxRuntimeExports.jsx(FocusTrap, {
        disableEnforceFocus: disableEnforceFocus,
        disableAutoFocus: disableAutoFocus,
        disableRestoreFocus: disableRestoreFocus,
        isEnabled: isTopModal,
        open: open,
        children: /*#__PURE__*/React__namespace.cloneElement(children, childProps)
      })]
    }))
  });
});
browser$1.env.NODE_ENV !== "production" ? ModalUnstyled.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------
  /**
   * A single child content element.
   */
  children: elementAcceptingRef$1.isRequired,
  /**
   * When set to true the Modal waits until a nested Transition is completed before closing.
   * @default false
   */
  closeAfterTransition: propTypesExports.bool,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * An HTML element or function that returns one.
   * The `container` will have the portal children appended to it.
   *
   * By default, it uses the body of the top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.func]),
  /**
   * If `true`, the modal will not automatically shift focus to itself when it opens, and
   * replace it to the last focused element when it closes.
   * This also works correctly with any modal children that have the `disableAutoFocus` prop.
   *
   * Generally this should never be set to `true` as it makes the modal less
   * accessible to assistive technologies, like screen readers.
   * @default false
   */
  disableAutoFocus: propTypesExports.bool,
  /**
   * If `true`, the modal will not prevent focus from leaving the modal while open.
   *
   * Generally this should never be set to `true` as it makes the modal less
   * accessible to assistive technologies, like screen readers.
   * @default false
   */
  disableEnforceFocus: propTypesExports.bool,
  /**
   * If `true`, hitting escape will not fire the `onClose` callback.
   * @default false
   */
  disableEscapeKeyDown: propTypesExports.bool,
  /**
   * The `children` will be under the DOM hierarchy of the parent component.
   * @default false
   */
  disablePortal: propTypesExports.bool,
  /**
   * If `true`, the modal will not restore focus to previously focused element once
   * modal is hidden or unmounted.
   * @default false
   */
  disableRestoreFocus: propTypesExports.bool,
  /**
   * Disable the scroll lock behavior.
   * @default false
   */
  disableScrollLock: propTypesExports.bool,
  /**
   * If `true`, the backdrop is not rendered.
   * @default false
   */
  hideBackdrop: propTypesExports.bool,
  /**
   * Always keep the children in the DOM.
   * This prop can be useful in SEO situation or
   * when you want to maximize the responsiveness of the Modal.
   * @default false
   */
  keepMounted: propTypesExports.bool,
  /**
   * Callback fired when the backdrop is clicked.
   * @deprecated Use the `onClose` prop with the `reason` argument to handle the `backdropClick` events.
   */
  onBackdropClick: propTypesExports.func,
  /**
   * Callback fired when the component requests to be closed.
   * The `reason` parameter can optionally be used to control the response to `onClose`.
   *
   * @param {object} event The event source of the callback.
   * @param {string} reason Can be: `"escapeKeyDown"`, `"backdropClick"`.
   */
  onClose: propTypesExports.func,
  /**
   * @ignore
   */
  onKeyDown: propTypesExports.func,
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool.isRequired,
  /**
   * The props used for each slot inside the Modal.
   * @default {}
   */
  slotProps: propTypesExports.shape({
    backdrop: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object]),
    root: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object])
  }),
  /**
   * The components used for each slot inside the Modal.
   * Either a string to use a HTML element or a component.
   * @default {}
   */
  slots: propTypesExports.shape({
    backdrop: propTypesExports.elementType,
    root: propTypesExports.elementType
  })
} : void 0;
var ModalUnstyled$1 = ModalUnstyled;

const _excluded$1y = ["onChange", "maxRows", "minRows", "style", "value"];
function getStyleValue$1(value) {
  return parseInt(value, 10) || 0;
}
const styles$4 = {
  shadow: {
    // Visibility needed to hide the extra text area on iPads
    visibility: 'hidden',
    // Remove from the content flow
    position: 'absolute',
    // Ignore the scrollbar width
    overflow: 'hidden',
    height: 0,
    top: 0,
    left: 0,
    // Create a new layer, increase the isolation of the computed values
    transform: 'translateZ(0)'
  }
};
function isEmpty$4(obj) {
  return obj === undefined || obj === null || Object.keys(obj).length === 0 || obj.outerHeightStyle === 0 && !obj.overflow;
}

/**
 *
 * Demos:
 *
 * - [Textarea Autosize](https://mui.com/base/react-textarea-autosize/)
 * - [Textarea Autosize](https://mui.com/material-ui/react-textarea-autosize/)
 *
 * API:
 *
 * - [TextareaAutosize API](https://mui.com/base/api/textarea-autosize/)
 */
const TextareaAutosize = /*#__PURE__*/React__namespace.forwardRef(function TextareaAutosize(props, ref) {
  const {
      onChange,
      maxRows,
      minRows = 1,
      style,
      value
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1y);
  const {
    current: isControlled
  } = React__namespace.useRef(value != null);
  const inputRef = React__namespace.useRef(null);
  const handleRef = useForkRef(ref, inputRef);
  const shadowRef = React__namespace.useRef(null);
  const renders = React__namespace.useRef(0);
  const [state, setState] = React__namespace.useState({
    outerHeightStyle: 0
  });
  const getUpdatedState = React__namespace.useCallback(() => {
    const input = inputRef.current;
    const containerWindow = ownerWindow(input);
    const computedStyle = containerWindow.getComputedStyle(input);

    // If input's width is shrunk and it's not visible, don't sync height.
    if (computedStyle.width === '0px') {
      return {
        outerHeightStyle: 0
      };
    }
    const inputShallow = shadowRef.current;
    inputShallow.style.width = computedStyle.width;
    inputShallow.value = input.value || props.placeholder || 'x';
    if (inputShallow.value.slice(-1) === '\n') {
      // Certain fonts which overflow the line height will cause the textarea
      // to report a different scrollHeight depending on whether the last line
      // is empty. Make it non-empty to avoid this issue.
      inputShallow.value += ' ';
    }
    const boxSizing = computedStyle.boxSizing;
    const padding = getStyleValue$1(computedStyle.paddingBottom) + getStyleValue$1(computedStyle.paddingTop);
    const border = getStyleValue$1(computedStyle.borderBottomWidth) + getStyleValue$1(computedStyle.borderTopWidth);

    // The height of the inner content
    const innerHeight = inputShallow.scrollHeight;

    // Measure height of a textarea with a single row
    inputShallow.value = 'x';
    const singleRowHeight = inputShallow.scrollHeight;

    // The height of the outer content
    let outerHeight = innerHeight;
    if (minRows) {
      outerHeight = Math.max(Number(minRows) * singleRowHeight, outerHeight);
    }
    if (maxRows) {
      outerHeight = Math.min(Number(maxRows) * singleRowHeight, outerHeight);
    }
    outerHeight = Math.max(outerHeight, singleRowHeight);

    // Take the box sizing into account for applying this value as a style.
    const outerHeightStyle = outerHeight + (boxSizing === 'border-box' ? padding + border : 0);
    const overflow = Math.abs(outerHeight - innerHeight) <= 1;
    return {
      outerHeightStyle,
      overflow
    };
  }, [maxRows, minRows, props.placeholder]);
  const updateState = (prevState, newState) => {
    const {
      outerHeightStyle,
      overflow
    } = newState;
    // Need a large enough difference to update the height.
    // This prevents infinite rendering loop.
    if (renders.current < 20 && (outerHeightStyle > 0 && Math.abs((prevState.outerHeightStyle || 0) - outerHeightStyle) > 1 || prevState.overflow !== overflow)) {
      renders.current += 1;
      return {
        overflow,
        outerHeightStyle
      };
    }
    if (browser$1.env.NODE_ENV !== 'production') {
      if (renders.current === 20) {
        console.error(['MUI: Too many re-renders. The layout is unstable.', 'TextareaAutosize limits the number of renders to prevent an infinite loop.'].join('\n'));
      }
    }
    return prevState;
  };
  const syncHeight = React__namespace.useCallback(() => {
    const newState = getUpdatedState();
    if (isEmpty$4(newState)) {
      return;
    }
    setState(prevState => {
      return updateState(prevState, newState);
    });
  }, [getUpdatedState]);
  const syncHeightWithFlushSycn = () => {
    const newState = getUpdatedState();
    if (isEmpty$4(newState)) {
      return;
    }

    // In React 18, state updates in a ResizeObserver's callback are happening after the paint which causes flickering
    // when doing some visual updates in it. Using flushSync ensures that the dom will be painted after the states updates happen
    // Related issue - https://github.com/facebook/react/issues/24331
    ReactDOM__namespace.flushSync(() => {
      setState(prevState => {
        return updateState(prevState, newState);
      });
    });
  };
  React__namespace.useEffect(() => {
    const handleResize = debounce$1(() => {
      renders.current = 0;

      // If the TextareaAutosize component is replaced by Suspense with a fallback, the last
      // ResizeObserver's handler that runs because of the change in the layout is trying to
      // access a dom node that is no longer there (as the fallback component is being shown instead).
      // See https://github.com/mui/material-ui/issues/32640
      if (inputRef.current) {
        syncHeightWithFlushSycn();
      }
    });
    let resizeObserver;
    const input = inputRef.current;
    const containerWindow = ownerWindow(input);
    containerWindow.addEventListener('resize', handleResize);
    if (typeof ResizeObserver !== 'undefined') {
      resizeObserver = new ResizeObserver(handleResize);
      resizeObserver.observe(input);
    }
    return () => {
      handleResize.clear();
      containerWindow.removeEventListener('resize', handleResize);
      if (resizeObserver) {
        resizeObserver.disconnect();
      }
    };
  });
  useEnhancedEffect$1(() => {
    syncHeight();
  });
  React__namespace.useEffect(() => {
    renders.current = 0;
  }, [value]);
  const handleChange = event => {
    renders.current = 0;
    if (!isControlled) {
      syncHeight();
    }
    if (onChange) {
      onChange(event);
    }
  };
  return /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
    children: [/*#__PURE__*/jsxRuntimeExports.jsx("textarea", _extends$1({
      value: value,
      onChange: handleChange,
      ref: handleRef
      // Apply the rows prop to get a "correct" first SSR paint
      ,
      rows: minRows,
      style: _extends$1({
        height: state.outerHeightStyle,
        // Need a large enough difference to allow scrolling.
        // This prevents infinite rendering loop.
        overflow: state.overflow ? 'hidden' : undefined
      }, style)
    }, other)), /*#__PURE__*/jsxRuntimeExports.jsx("textarea", {
      "aria-hidden": true,
      className: props.className,
      readOnly: true,
      ref: shadowRef,
      tabIndex: -1,
      style: _extends$1({}, styles$4.shadow, style, {
        padding: 0
      })
    })]
  });
});
browser$1.env.NODE_ENV !== "production" ? TextareaAutosize.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * Maximum number of rows to display.
   */
  maxRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * Minimum number of rows to display.
   * @default 1
   */
  minRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * @ignore
   */
  onChange: propTypesExports.func,
  /**
   * @ignore
   */
  placeholder: propTypesExports.string,
  /**
   * @ignore
   */
  style: propTypesExports.object,
  /**
   * @ignore
   */
  value: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.string), propTypesExports.number, propTypesExports.string])
} : void 0;
var TextareaAutosize$1 = TextareaAutosize;

function isEmpty$3(obj) {
  return obj === undefined || obj === null || Object.keys(obj).length === 0;
}
function GlobalStyles$1(props) {
  const {
    styles,
    defaultTheme = {}
  } = props;
  const globalStyles = typeof styles === 'function' ? themeInput => styles(isEmpty$3(themeInput) ? defaultTheme : themeInput) : styles;
  return /*#__PURE__*/jsxRuntimeExports.jsx(react.Global, {
    styles: globalStyles
  });
}
browser$1.env.NODE_ENV !== "production" ? GlobalStyles$1.propTypes = {
  defaultTheme: propTypesExports.object,
  styles: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.object, propTypesExports.func])
} : void 0;

function styled$2(tag, options) {
  const stylesFactory = styled__default.default(tag, options);
  if (browser$1.env.NODE_ENV !== 'production') {
    return (...styles) => {
      const component = typeof tag === 'string' ? `"${tag}"` : 'component';
      if (styles.length === 0) {
        console.error([`MUI: Seems like you called \`styled(${component})()\` without a \`style\` argument.`, 'You must provide a `styles` argument: `styled("div")(styleYouForgotToPass)`.'].join('\n'));
      } else if (styles.some(style => style === undefined)) {
        console.error(`MUI: the styled(${component})(...args) API requires all its args to be defined.`);
      }
      return stylesFactory(...styles);
    };
  }
  return stylesFactory;
}

// eslint-disable-next-line @typescript-eslint/naming-convention
const internal_processStyles = (tag, processor) => {
  // Emotion attaches all the styles as `__emotion_styles`.
  // Ref: https://github.com/emotion-js/emotion/blob/16d971d0da229596d6bcc39d282ba9753c9ee7cf/packages/styled/src/base.js#L186
  if (Array.isArray(tag.__emotion_styles)) {
    tag.__emotion_styles = processor(tag.__emotion_styles);
  }
};

const responsivePropType = browser$1.env.NODE_ENV !== 'production' ? propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string, propTypesExports.object, propTypesExports.array]) : {};
var responsivePropType$1 = responsivePropType;

function merge(acc, item) {
  if (!item) {
    return acc;
  }
  return deepmerge(acc, item, {
    clone: false // No need to clone deep, it's way faster.
  });
}

// The breakpoint **start** at this value.
// For instance with the first breakpoint xs: [xs, sm[.
const values$1 = {
  xs: 0,
  // phone
  sm: 600,
  // tablet
  md: 900,
  // small laptop
  lg: 1200,
  // desktop
  xl: 1536 // large screen
};

const defaultBreakpoints = {
  // Sorted ASC by size. That's important.
  // It can't be configured as it's used statically for propTypes.
  keys: ['xs', 'sm', 'md', 'lg', 'xl'],
  up: key => `@media (min-width:${values$1[key]}px)`
};
function handleBreakpoints(props, propValue, styleFromPropValue) {
  const theme = props.theme || {};
  if (Array.isArray(propValue)) {
    const themeBreakpoints = theme.breakpoints || defaultBreakpoints;
    return propValue.reduce((acc, item, index) => {
      acc[themeBreakpoints.up(themeBreakpoints.keys[index])] = styleFromPropValue(propValue[index]);
      return acc;
    }, {});
  }
  if (typeof propValue === 'object') {
    const themeBreakpoints = theme.breakpoints || defaultBreakpoints;
    return Object.keys(propValue).reduce((acc, breakpoint) => {
      // key is breakpoint
      if (Object.keys(themeBreakpoints.values || values$1).indexOf(breakpoint) !== -1) {
        const mediaKey = themeBreakpoints.up(breakpoint);
        acc[mediaKey] = styleFromPropValue(propValue[breakpoint], breakpoint);
      } else {
        const cssKey = breakpoint;
        acc[cssKey] = propValue[cssKey];
      }
      return acc;
    }, {});
  }
  const output = styleFromPropValue(propValue);
  return output;
}
function createEmptyBreakpointObject(breakpointsInput = {}) {
  var _breakpointsInput$key;
  const breakpointsInOrder = (_breakpointsInput$key = breakpointsInput.keys) == null ? void 0 : _breakpointsInput$key.reduce((acc, key) => {
    const breakpointStyleKey = breakpointsInput.up(key);
    acc[breakpointStyleKey] = {};
    return acc;
  }, {});
  return breakpointsInOrder || {};
}
function removeUnusedBreakpoints(breakpointKeys, style) {
  return breakpointKeys.reduce((acc, key) => {
    const breakpointOutput = acc[key];
    const isBreakpointUnused = !breakpointOutput || Object.keys(breakpointOutput).length === 0;
    if (isBreakpointUnused) {
      delete acc[key];
    }
    return acc;
  }, style);
}

// compute base for responsive values; e.g.,
// [1,2,3] => {xs: true, sm: true, md: true}
// {xs: 1, sm: 2, md: 3} => {xs: true, sm: true, md: true}
function computeBreakpointsBase(breakpointValues, themeBreakpoints) {
  // fixed value
  if (typeof breakpointValues !== 'object') {
    return {};
  }
  const base = {};
  const breakpointsKeys = Object.keys(themeBreakpoints);
  if (Array.isArray(breakpointValues)) {
    breakpointsKeys.forEach((breakpoint, i) => {
      if (i < breakpointValues.length) {
        base[breakpoint] = true;
      }
    });
  } else {
    breakpointsKeys.forEach(breakpoint => {
      if (breakpointValues[breakpoint] != null) {
        base[breakpoint] = true;
      }
    });
  }
  return base;
}
function resolveBreakpointValues({
  values: breakpointValues,
  breakpoints: themeBreakpoints,
  base: customBase
}) {
  const base = customBase || computeBreakpointsBase(breakpointValues, themeBreakpoints);
  const keys = Object.keys(base);
  if (keys.length === 0) {
    return breakpointValues;
  }
  let previous;
  return keys.reduce((acc, breakpoint, i) => {
    if (Array.isArray(breakpointValues)) {
      acc[breakpoint] = breakpointValues[i] != null ? breakpointValues[i] : breakpointValues[previous];
      previous = i;
    } else if (typeof breakpointValues === 'object') {
      acc[breakpoint] = breakpointValues[breakpoint] != null ? breakpointValues[breakpoint] : breakpointValues[previous];
      previous = breakpoint;
    } else {
      acc[breakpoint] = breakpointValues;
    }
    return acc;
  }, {});
}

function getPath(obj, path, checkVars = true) {
  if (!path || typeof path !== 'string') {
    return null;
  }

  // Check if CSS variables are used
  if (obj && obj.vars && checkVars) {
    const val = `vars.${path}`.split('.').reduce((acc, item) => acc && acc[item] ? acc[item] : null, obj);
    if (val != null) {
      return val;
    }
  }
  return path.split('.').reduce((acc, item) => {
    if (acc && acc[item] != null) {
      return acc[item];
    }
    return null;
  }, obj);
}
function getStyleValue(themeMapping, transform, propValueFinal, userValue = propValueFinal) {
  let value;
  if (typeof themeMapping === 'function') {
    value = themeMapping(propValueFinal);
  } else if (Array.isArray(themeMapping)) {
    value = themeMapping[propValueFinal] || userValue;
  } else {
    value = getPath(themeMapping, propValueFinal) || userValue;
  }
  if (transform) {
    value = transform(value, userValue, themeMapping);
  }
  return value;
}
function style$1(options) {
  const {
    prop,
    cssProperty = options.prop,
    themeKey,
    transform
  } = options;

  // false positive
  // eslint-disable-next-line react/function-component-definition
  const fn = props => {
    if (props[prop] == null) {
      return null;
    }
    const propValue = props[prop];
    const theme = props.theme;
    const themeMapping = getPath(theme, themeKey) || {};
    const styleFromPropValue = propValueFinal => {
      let value = getStyleValue(themeMapping, transform, propValueFinal);
      if (propValueFinal === value && typeof propValueFinal === 'string') {
        // Haven't found value
        value = getStyleValue(themeMapping, transform, `${prop}${propValueFinal === 'default' ? '' : capitalize(propValueFinal)}`, propValueFinal);
      }
      if (cssProperty === false) {
        return value;
      }
      return {
        [cssProperty]: value
      };
    };
    return handleBreakpoints(props, propValue, styleFromPropValue);
  };
  fn.propTypes = browser$1.env.NODE_ENV !== 'production' ? {
    [prop]: responsivePropType$1
  } : {};
  fn.filterProps = [prop];
  return fn;
}

function compose(...styles) {
  const handlers = styles.reduce((acc, style) => {
    style.filterProps.forEach(prop => {
      acc[prop] = style;
    });
    return acc;
  }, {});

  // false positive
  // eslint-disable-next-line react/function-component-definition
  const fn = props => {
    return Object.keys(props).reduce((acc, prop) => {
      if (handlers[prop]) {
        return merge(acc, handlers[prop](props));
      }
      return acc;
    }, {});
  };
  fn.propTypes = browser$1.env.NODE_ENV !== 'production' ? styles.reduce((acc, style) => Object.assign(acc, style.propTypes), {}) : {};
  fn.filterProps = styles.reduce((acc, style) => acc.concat(style.filterProps), []);
  return fn;
}

function memoize(fn) {
  const cache = {};
  return arg => {
    if (cache[arg] === undefined) {
      cache[arg] = fn(arg);
    }
    return cache[arg];
  };
}

const properties = {
  m: 'margin',
  p: 'padding'
};
const directions = {
  t: 'Top',
  r: 'Right',
  b: 'Bottom',
  l: 'Left',
  x: ['Left', 'Right'],
  y: ['Top', 'Bottom']
};
const aliases = {
  marginX: 'mx',
  marginY: 'my',
  paddingX: 'px',
  paddingY: 'py'
};

// memoize() impact:
// From 300,000 ops/sec
// To 350,000 ops/sec
const getCssProperties = memoize(prop => {
  // It's not a shorthand notation.
  if (prop.length > 2) {
    if (aliases[prop]) {
      prop = aliases[prop];
    } else {
      return [prop];
    }
  }
  const [a, b] = prop.split('');
  const property = properties[a];
  const direction = directions[b] || '';
  return Array.isArray(direction) ? direction.map(dir => property + dir) : [property + direction];
});
const marginKeys = ['m', 'mt', 'mr', 'mb', 'ml', 'mx', 'my', 'margin', 'marginTop', 'marginRight', 'marginBottom', 'marginLeft', 'marginX', 'marginY', 'marginInline', 'marginInlineStart', 'marginInlineEnd', 'marginBlock', 'marginBlockStart', 'marginBlockEnd'];
const paddingKeys = ['p', 'pt', 'pr', 'pb', 'pl', 'px', 'py', 'padding', 'paddingTop', 'paddingRight', 'paddingBottom', 'paddingLeft', 'paddingX', 'paddingY', 'paddingInline', 'paddingInlineStart', 'paddingInlineEnd', 'paddingBlock', 'paddingBlockStart', 'paddingBlockEnd'];
const spacingKeys = [...marginKeys, ...paddingKeys];
function createUnaryUnit(theme, themeKey, defaultValue, propName) {
  var _getPath;
  const themeSpacing = (_getPath = getPath(theme, themeKey, false)) != null ? _getPath : defaultValue;
  if (typeof themeSpacing === 'number') {
    return abs => {
      if (typeof abs === 'string') {
        return abs;
      }
      if (browser$1.env.NODE_ENV !== 'production') {
        if (typeof abs !== 'number') {
          console.error(`MUI: Expected ${propName} argument to be a number or a string, got ${abs}.`);
        }
      }
      return themeSpacing * abs;
    };
  }
  if (Array.isArray(themeSpacing)) {
    return abs => {
      if (typeof abs === 'string') {
        return abs;
      }
      if (browser$1.env.NODE_ENV !== 'production') {
        if (!Number.isInteger(abs)) {
          console.error([`MUI: The \`theme.${themeKey}\` array type cannot be combined with non integer values.` + `You should either use an integer value that can be used as index, or define the \`theme.${themeKey}\` as a number.`].join('\n'));
        } else if (abs > themeSpacing.length - 1) {
          console.error([`MUI: The value provided (${abs}) overflows.`, `The supported values are: ${JSON.stringify(themeSpacing)}.`, `${abs} > ${themeSpacing.length - 1}, you need to add the missing values.`].join('\n'));
        }
      }
      return themeSpacing[abs];
    };
  }
  if (typeof themeSpacing === 'function') {
    return themeSpacing;
  }
  if (browser$1.env.NODE_ENV !== 'production') {
    console.error([`MUI: The \`theme.${themeKey}\` value (${themeSpacing}) is invalid.`, 'It should be a number, an array or a function.'].join('\n'));
  }
  return () => undefined;
}
function createUnarySpacing(theme) {
  return createUnaryUnit(theme, 'spacing', 8, 'spacing');
}
function getValue(transformer, propValue) {
  if (typeof propValue === 'string' || propValue == null) {
    return propValue;
  }
  const abs = Math.abs(propValue);
  const transformed = transformer(abs);
  if (propValue >= 0) {
    return transformed;
  }
  if (typeof transformed === 'number') {
    return -transformed;
  }
  return `-${transformed}`;
}
function getStyleFromPropValue(cssProperties, transformer) {
  return propValue => cssProperties.reduce((acc, cssProperty) => {
    acc[cssProperty] = getValue(transformer, propValue);
    return acc;
  }, {});
}
function resolveCssProperty(props, keys, prop, transformer) {
  // Using a hash computation over an array iteration could be faster, but with only 28 items,
  // it's doesn't worth the bundle size.
  if (keys.indexOf(prop) === -1) {
    return null;
  }
  const cssProperties = getCssProperties(prop);
  const styleFromPropValue = getStyleFromPropValue(cssProperties, transformer);
  const propValue = props[prop];
  return handleBreakpoints(props, propValue, styleFromPropValue);
}
function style(props, keys) {
  const transformer = createUnarySpacing(props.theme);
  return Object.keys(props).map(prop => resolveCssProperty(props, keys, prop, transformer)).reduce(merge, {});
}
function margin(props) {
  return style(props, marginKeys);
}
margin.propTypes = browser$1.env.NODE_ENV !== 'production' ? marginKeys.reduce((obj, key) => {
  obj[key] = responsivePropType$1;
  return obj;
}, {}) : {};
margin.filterProps = marginKeys;
function padding(props) {
  return style(props, paddingKeys);
}
padding.propTypes = browser$1.env.NODE_ENV !== 'production' ? paddingKeys.reduce((obj, key) => {
  obj[key] = responsivePropType$1;
  return obj;
}, {}) : {};
padding.filterProps = paddingKeys;
browser$1.env.NODE_ENV !== 'production' ? spacingKeys.reduce((obj, key) => {
  obj[key] = responsivePropType$1;
  return obj;
}, {}) : {};

function borderTransform(value) {
  if (typeof value !== 'number') {
    return value;
  }
  return `${value}px solid`;
}
const border = style$1({
  prop: 'border',
  themeKey: 'borders',
  transform: borderTransform
});
const borderTop = style$1({
  prop: 'borderTop',
  themeKey: 'borders',
  transform: borderTransform
});
const borderRight = style$1({
  prop: 'borderRight',
  themeKey: 'borders',
  transform: borderTransform
});
const borderBottom = style$1({
  prop: 'borderBottom',
  themeKey: 'borders',
  transform: borderTransform
});
const borderLeft = style$1({
  prop: 'borderLeft',
  themeKey: 'borders',
  transform: borderTransform
});
const borderColor = style$1({
  prop: 'borderColor',
  themeKey: 'palette'
});
const borderTopColor = style$1({
  prop: 'borderTopColor',
  themeKey: 'palette'
});
const borderRightColor = style$1({
  prop: 'borderRightColor',
  themeKey: 'palette'
});
const borderBottomColor = style$1({
  prop: 'borderBottomColor',
  themeKey: 'palette'
});
const borderLeftColor = style$1({
  prop: 'borderLeftColor',
  themeKey: 'palette'
});

// false positive
// eslint-disable-next-line react/function-component-definition
const borderRadius = props => {
  if (props.borderRadius !== undefined && props.borderRadius !== null) {
    const transformer = createUnaryUnit(props.theme, 'shape.borderRadius', 4, 'borderRadius');
    const styleFromPropValue = propValue => ({
      borderRadius: getValue(transformer, propValue)
    });
    return handleBreakpoints(props, props.borderRadius, styleFromPropValue);
  }
  return null;
};
borderRadius.propTypes = browser$1.env.NODE_ENV !== 'production' ? {
  borderRadius: responsivePropType$1
} : {};
borderRadius.filterProps = ['borderRadius'];
compose(border, borderTop, borderRight, borderBottom, borderLeft, borderColor, borderTopColor, borderRightColor, borderBottomColor, borderLeftColor, borderRadius);

// false positive
// eslint-disable-next-line react/function-component-definition
const gap = props => {
  if (props.gap !== undefined && props.gap !== null) {
    const transformer = createUnaryUnit(props.theme, 'spacing', 8, 'gap');
    const styleFromPropValue = propValue => ({
      gap: getValue(transformer, propValue)
    });
    return handleBreakpoints(props, props.gap, styleFromPropValue);
  }
  return null;
};
gap.propTypes = browser$1.env.NODE_ENV !== 'production' ? {
  gap: responsivePropType$1
} : {};
gap.filterProps = ['gap'];

// false positive
// eslint-disable-next-line react/function-component-definition
const columnGap = props => {
  if (props.columnGap !== undefined && props.columnGap !== null) {
    const transformer = createUnaryUnit(props.theme, 'spacing', 8, 'columnGap');
    const styleFromPropValue = propValue => ({
      columnGap: getValue(transformer, propValue)
    });
    return handleBreakpoints(props, props.columnGap, styleFromPropValue);
  }
  return null;
};
columnGap.propTypes = browser$1.env.NODE_ENV !== 'production' ? {
  columnGap: responsivePropType$1
} : {};
columnGap.filterProps = ['columnGap'];

// false positive
// eslint-disable-next-line react/function-component-definition
const rowGap = props => {
  if (props.rowGap !== undefined && props.rowGap !== null) {
    const transformer = createUnaryUnit(props.theme, 'spacing', 8, 'rowGap');
    const styleFromPropValue = propValue => ({
      rowGap: getValue(transformer, propValue)
    });
    return handleBreakpoints(props, props.rowGap, styleFromPropValue);
  }
  return null;
};
rowGap.propTypes = browser$1.env.NODE_ENV !== 'production' ? {
  rowGap: responsivePropType$1
} : {};
rowGap.filterProps = ['rowGap'];
const gridColumn = style$1({
  prop: 'gridColumn'
});
const gridRow = style$1({
  prop: 'gridRow'
});
const gridAutoFlow = style$1({
  prop: 'gridAutoFlow'
});
const gridAutoColumns = style$1({
  prop: 'gridAutoColumns'
});
const gridAutoRows = style$1({
  prop: 'gridAutoRows'
});
const gridTemplateColumns = style$1({
  prop: 'gridTemplateColumns'
});
const gridTemplateRows = style$1({
  prop: 'gridTemplateRows'
});
const gridTemplateAreas = style$1({
  prop: 'gridTemplateAreas'
});
const gridArea = style$1({
  prop: 'gridArea'
});
compose(gap, columnGap, rowGap, gridColumn, gridRow, gridAutoFlow, gridAutoColumns, gridAutoRows, gridTemplateColumns, gridTemplateRows, gridTemplateAreas, gridArea);

function paletteTransform(value, userValue) {
  if (userValue === 'grey') {
    return userValue;
  }
  return value;
}
const color = style$1({
  prop: 'color',
  themeKey: 'palette',
  transform: paletteTransform
});
const bgcolor = style$1({
  prop: 'bgcolor',
  cssProperty: 'backgroundColor',
  themeKey: 'palette',
  transform: paletteTransform
});
const backgroundColor = style$1({
  prop: 'backgroundColor',
  themeKey: 'palette',
  transform: paletteTransform
});
compose(color, bgcolor, backgroundColor);

function sizingTransform(value) {
  return value <= 1 && value !== 0 ? `${value * 100}%` : value;
}
const width = style$1({
  prop: 'width',
  transform: sizingTransform
});
const maxWidth = props => {
  if (props.maxWidth !== undefined && props.maxWidth !== null) {
    const styleFromPropValue = propValue => {
      var _props$theme, _props$theme$breakpoi, _props$theme$breakpoi2;
      const breakpoint = ((_props$theme = props.theme) == null ? void 0 : (_props$theme$breakpoi = _props$theme.breakpoints) == null ? void 0 : (_props$theme$breakpoi2 = _props$theme$breakpoi.values) == null ? void 0 : _props$theme$breakpoi2[propValue]) || values$1[propValue];
      return {
        maxWidth: breakpoint || sizingTransform(propValue)
      };
    };
    return handleBreakpoints(props, props.maxWidth, styleFromPropValue);
  }
  return null;
};
maxWidth.filterProps = ['maxWidth'];
const minWidth = style$1({
  prop: 'minWidth',
  transform: sizingTransform
});
const height = style$1({
  prop: 'height',
  transform: sizingTransform
});
const maxHeight = style$1({
  prop: 'maxHeight',
  transform: sizingTransform
});
const minHeight = style$1({
  prop: 'minHeight',
  transform: sizingTransform
});
style$1({
  prop: 'size',
  cssProperty: 'width',
  transform: sizingTransform
});
style$1({
  prop: 'size',
  cssProperty: 'height',
  transform: sizingTransform
});
const boxSizing = style$1({
  prop: 'boxSizing'
});
compose(width, maxWidth, minWidth, height, maxHeight, minHeight, boxSizing);

const defaultSxConfig = {
  // borders
  border: {
    themeKey: 'borders',
    transform: borderTransform
  },
  borderTop: {
    themeKey: 'borders',
    transform: borderTransform
  },
  borderRight: {
    themeKey: 'borders',
    transform: borderTransform
  },
  borderBottom: {
    themeKey: 'borders',
    transform: borderTransform
  },
  borderLeft: {
    themeKey: 'borders',
    transform: borderTransform
  },
  borderColor: {
    themeKey: 'palette'
  },
  borderTopColor: {
    themeKey: 'palette'
  },
  borderRightColor: {
    themeKey: 'palette'
  },
  borderBottomColor: {
    themeKey: 'palette'
  },
  borderLeftColor: {
    themeKey: 'palette'
  },
  borderRadius: {
    themeKey: 'shape.borderRadius',
    style: borderRadius
  },
  // palette
  color: {
    themeKey: 'palette',
    transform: paletteTransform
  },
  bgcolor: {
    themeKey: 'palette',
    cssProperty: 'backgroundColor',
    transform: paletteTransform
  },
  backgroundColor: {
    themeKey: 'palette',
    transform: paletteTransform
  },
  // spacing
  p: {
    style: padding
  },
  pt: {
    style: padding
  },
  pr: {
    style: padding
  },
  pb: {
    style: padding
  },
  pl: {
    style: padding
  },
  px: {
    style: padding
  },
  py: {
    style: padding
  },
  padding: {
    style: padding
  },
  paddingTop: {
    style: padding
  },
  paddingRight: {
    style: padding
  },
  paddingBottom: {
    style: padding
  },
  paddingLeft: {
    style: padding
  },
  paddingX: {
    style: padding
  },
  paddingY: {
    style: padding
  },
  paddingInline: {
    style: padding
  },
  paddingInlineStart: {
    style: padding
  },
  paddingInlineEnd: {
    style: padding
  },
  paddingBlock: {
    style: padding
  },
  paddingBlockStart: {
    style: padding
  },
  paddingBlockEnd: {
    style: padding
  },
  m: {
    style: margin
  },
  mt: {
    style: margin
  },
  mr: {
    style: margin
  },
  mb: {
    style: margin
  },
  ml: {
    style: margin
  },
  mx: {
    style: margin
  },
  my: {
    style: margin
  },
  margin: {
    style: margin
  },
  marginTop: {
    style: margin
  },
  marginRight: {
    style: margin
  },
  marginBottom: {
    style: margin
  },
  marginLeft: {
    style: margin
  },
  marginX: {
    style: margin
  },
  marginY: {
    style: margin
  },
  marginInline: {
    style: margin
  },
  marginInlineStart: {
    style: margin
  },
  marginInlineEnd: {
    style: margin
  },
  marginBlock: {
    style: margin
  },
  marginBlockStart: {
    style: margin
  },
  marginBlockEnd: {
    style: margin
  },
  // display
  displayPrint: {
    cssProperty: false,
    transform: value => ({
      '@media print': {
        display: value
      }
    })
  },
  display: {},
  overflow: {},
  textOverflow: {},
  visibility: {},
  whiteSpace: {},
  // flexbox
  flexBasis: {},
  flexDirection: {},
  flexWrap: {},
  justifyContent: {},
  alignItems: {},
  alignContent: {},
  order: {},
  flex: {},
  flexGrow: {},
  flexShrink: {},
  alignSelf: {},
  justifyItems: {},
  justifySelf: {},
  // grid
  gap: {
    style: gap
  },
  rowGap: {
    style: rowGap
  },
  columnGap: {
    style: columnGap
  },
  gridColumn: {},
  gridRow: {},
  gridAutoFlow: {},
  gridAutoColumns: {},
  gridAutoRows: {},
  gridTemplateColumns: {},
  gridTemplateRows: {},
  gridTemplateAreas: {},
  gridArea: {},
  // positions
  position: {},
  zIndex: {
    themeKey: 'zIndex'
  },
  top: {},
  right: {},
  bottom: {},
  left: {},
  // shadows
  boxShadow: {
    themeKey: 'shadows'
  },
  // sizing
  width: {
    transform: sizingTransform
  },
  maxWidth: {
    style: maxWidth
  },
  minWidth: {
    transform: sizingTransform
  },
  height: {
    transform: sizingTransform
  },
  maxHeight: {
    transform: sizingTransform
  },
  minHeight: {
    transform: sizingTransform
  },
  boxSizing: {},
  // typography
  fontFamily: {
    themeKey: 'typography'
  },
  fontSize: {
    themeKey: 'typography'
  },
  fontStyle: {
    themeKey: 'typography'
  },
  fontWeight: {
    themeKey: 'typography'
  },
  letterSpacing: {},
  textTransform: {},
  lineHeight: {},
  textAlign: {},
  typography: {
    cssProperty: false,
    themeKey: 'typography'
  }
};
var defaultSxConfig$1 = defaultSxConfig;

function objectsHaveSameKeys(...objects) {
  const allKeys = objects.reduce((keys, object) => keys.concat(Object.keys(object)), []);
  const union = new Set(allKeys);
  return objects.every(object => union.size === Object.keys(object).length);
}
function callIfFn(maybeFn, arg) {
  return typeof maybeFn === 'function' ? maybeFn(arg) : maybeFn;
}

// eslint-disable-next-line @typescript-eslint/naming-convention
function unstable_createStyleFunctionSx() {
  function getThemeValue(prop, val, theme, config) {
    const props = {
      [prop]: val,
      theme
    };
    const options = config[prop];
    if (!options) {
      return {
        [prop]: val
      };
    }
    const {
      cssProperty = prop,
      themeKey,
      transform,
      style
    } = options;
    if (val == null) {
      return null;
    }
    if (themeKey === 'typography' && val === 'inherit') {
      return {
        [prop]: val
      };
    }
    const themeMapping = getPath(theme, themeKey) || {};
    if (style) {
      return style(props);
    }
    const styleFromPropValue = propValueFinal => {
      let value = getStyleValue(themeMapping, transform, propValueFinal);
      if (propValueFinal === value && typeof propValueFinal === 'string') {
        // Haven't found value
        value = getStyleValue(themeMapping, transform, `${prop}${propValueFinal === 'default' ? '' : capitalize(propValueFinal)}`, propValueFinal);
      }
      if (cssProperty === false) {
        return value;
      }
      return {
        [cssProperty]: value
      };
    };
    return handleBreakpoints(props, val, styleFromPropValue);
  }
  function styleFunctionSx(props) {
    var _theme$unstable_sxCon;
    const {
      sx,
      theme = {}
    } = props || {};
    if (!sx) {
      return null; // Emotion & styled-components will neglect null
    }

    const config = (_theme$unstable_sxCon = theme.unstable_sxConfig) != null ? _theme$unstable_sxCon : defaultSxConfig$1;

    /*
     * Receive `sxInput` as object or callback
     * and then recursively check keys & values to create media query object styles.
     * (the result will be used in `styled`)
     */
    function traverse(sxInput) {
      let sxObject = sxInput;
      if (typeof sxInput === 'function') {
        sxObject = sxInput(theme);
      } else if (typeof sxInput !== 'object') {
        // value
        return sxInput;
      }
      if (!sxObject) {
        return null;
      }
      const emptyBreakpoints = createEmptyBreakpointObject(theme.breakpoints);
      const breakpointsKeys = Object.keys(emptyBreakpoints);
      let css = emptyBreakpoints;
      Object.keys(sxObject).forEach(styleKey => {
        const value = callIfFn(sxObject[styleKey], theme);
        if (value !== null && value !== undefined) {
          if (typeof value === 'object') {
            if (config[styleKey]) {
              css = merge(css, getThemeValue(styleKey, value, theme, config));
            } else {
              const breakpointsValues = handleBreakpoints({
                theme
              }, value, x => ({
                [styleKey]: x
              }));
              if (objectsHaveSameKeys(breakpointsValues, value)) {
                css[styleKey] = styleFunctionSx({
                  sx: value,
                  theme
                });
              } else {
                css = merge(css, breakpointsValues);
              }
            }
          } else {
            css = merge(css, getThemeValue(styleKey, value, theme, config));
          }
        }
      });
      return removeUnusedBreakpoints(breakpointsKeys, css);
    }
    return Array.isArray(sx) ? sx.map(traverse) : traverse(sx);
  }
  return styleFunctionSx;
}
const styleFunctionSx = unstable_createStyleFunctionSx();
styleFunctionSx.filterProps = ['sx'];
var styleFunctionSx$1 = styleFunctionSx;

const _excluded$1x = ["sx"];
const splitProps = props => {
  var _props$theme$unstable, _props$theme;
  const result = {
    systemProps: {},
    otherProps: {}
  };
  const config = (_props$theme$unstable = props == null ? void 0 : (_props$theme = props.theme) == null ? void 0 : _props$theme.unstable_sxConfig) != null ? _props$theme$unstable : defaultSxConfig$1;
  Object.keys(props).forEach(prop => {
    if (config[prop]) {
      result.systemProps[prop] = props[prop];
    } else {
      result.otherProps[prop] = props[prop];
    }
  });
  return result;
};
function extendSxProp(props) {
  const {
      sx: inSx
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1x);
  const {
    systemProps,
    otherProps
  } = splitProps(other);
  let finalSx;
  if (Array.isArray(inSx)) {
    finalSx = [systemProps, ...inSx];
  } else if (typeof inSx === 'function') {
    finalSx = (...args) => {
      const result = inSx(...args);
      if (!isPlainObject(result)) {
        return systemProps;
      }
      return _extends$1({}, systemProps, result);
    };
  } else {
    finalSx = _extends$1({}, systemProps, inSx);
  }
  return _extends$1({}, otherProps, {
    sx: finalSx
  });
}

const _excluded$1w = ["values", "unit", "step"];
const sortBreakpointsValues = values => {
  const breakpointsAsArray = Object.keys(values).map(key => ({
    key,
    val: values[key]
  })) || [];
  // Sort in ascending order
  breakpointsAsArray.sort((breakpoint1, breakpoint2) => breakpoint1.val - breakpoint2.val);
  return breakpointsAsArray.reduce((acc, obj) => {
    return _extends$1({}, acc, {
      [obj.key]: obj.val
    });
  }, {});
};

// Keep in mind that @media is inclusive by the CSS specification.
function createBreakpoints(breakpoints) {
  const {
      // The breakpoint **start** at this value.
      // For instance with the first breakpoint xs: [xs, sm).
      values = {
        xs: 0,
        // phone
        sm: 600,
        // tablet
        md: 900,
        // small laptop
        lg: 1200,
        // desktop
        xl: 1536 // large screen
      },

      unit = 'px',
      step = 5
    } = breakpoints,
    other = _objectWithoutPropertiesLoose(breakpoints, _excluded$1w);
  const sortedValues = sortBreakpointsValues(values);
  const keys = Object.keys(sortedValues);
  function up(key) {
    const value = typeof values[key] === 'number' ? values[key] : key;
    return `@media (min-width:${value}${unit})`;
  }
  function down(key) {
    const value = typeof values[key] === 'number' ? values[key] : key;
    return `@media (max-width:${value - step / 100}${unit})`;
  }
  function between(start, end) {
    const endIndex = keys.indexOf(end);
    return `@media (min-width:${typeof values[start] === 'number' ? values[start] : start}${unit}) and ` + `(max-width:${(endIndex !== -1 && typeof values[keys[endIndex]] === 'number' ? values[keys[endIndex]] : end) - step / 100}${unit})`;
  }
  function only(key) {
    if (keys.indexOf(key) + 1 < keys.length) {
      return between(key, keys[keys.indexOf(key) + 1]);
    }
    return up(key);
  }
  function not(key) {
    // handle first and last key separately, for better readability
    const keyIndex = keys.indexOf(key);
    if (keyIndex === 0) {
      return up(keys[1]);
    }
    if (keyIndex === keys.length - 1) {
      return down(keys[keyIndex]);
    }
    return between(key, keys[keys.indexOf(key) + 1]).replace('@media', '@media not all and');
  }
  return _extends$1({
    keys,
    values: sortedValues,
    up,
    down,
    between,
    only,
    not,
    unit
  }, other);
}

const shape = {
  borderRadius: 4
};
var shape$1 = shape;

/* tslint:enable:unified-signatures */

function createSpacing(spacingInput = 8) {
  // Already transformed.
  if (spacingInput.mui) {
    return spacingInput;
  }

  // Material Design layouts are visually balanced. Most measurements align to an 8dp grid, which aligns both spacing and the overall layout.
  // Smaller components, such as icons, can align to a 4dp grid.
  // https://m2.material.io/design/layout/understanding-layout.html
  const transform = createUnarySpacing({
    spacing: spacingInput
  });
  const spacing = (...argsInput) => {
    if (browser$1.env.NODE_ENV !== 'production') {
      if (!(argsInput.length <= 4)) {
        console.error(`MUI: Too many arguments provided, expected between 0 and 4, got ${argsInput.length}`);
      }
    }
    const args = argsInput.length === 0 ? [1] : argsInput;
    return args.map(argument => {
      const output = transform(argument);
      return typeof output === 'number' ? `${output}px` : output;
    }).join(' ');
  };
  spacing.mui = true;
  return spacing;
}

const _excluded$1v = ["breakpoints", "palette", "spacing", "shape"];
function createTheme$1(options = {}, ...args) {
  const {
      breakpoints: breakpointsInput = {},
      palette: paletteInput = {},
      spacing: spacingInput,
      shape: shapeInput = {}
    } = options,
    other = _objectWithoutPropertiesLoose(options, _excluded$1v);
  const breakpoints = createBreakpoints(breakpointsInput);
  const spacing = createSpacing(spacingInput);
  let muiTheme = deepmerge({
    breakpoints,
    direction: 'ltr',
    components: {},
    // Inject component definitions.
    palette: _extends$1({
      mode: 'light'
    }, paletteInput),
    spacing,
    shape: _extends$1({}, shape$1, shapeInput)
  }, other);
  muiTheme = args.reduce((acc, argument) => deepmerge(acc, argument), muiTheme);
  muiTheme.unstable_sxConfig = _extends$1({}, defaultSxConfig$1, other == null ? void 0 : other.unstable_sxConfig);
  muiTheme.unstable_sx = function sx(props) {
    return styleFunctionSx$1({
      sx: props,
      theme: this
    });
  };
  return muiTheme;
}

const ThemeContext = /*#__PURE__*/React__namespace.createContext(null);
if (browser$1.env.NODE_ENV !== 'production') {
  ThemeContext.displayName = 'ThemeContext';
}
var ThemeContext$1 = ThemeContext;

function useTheme$4() {
  const theme = React__namespace.useContext(ThemeContext$1);
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useDebugValue(theme);
  }
  return theme;
}

const hasSymbol = typeof Symbol === 'function' && Symbol.for;
var nested = hasSymbol ? Symbol.for('mui.nested') : '__THEME_NESTED__';

function mergeOuterLocalTheme(outerTheme, localTheme) {
  if (typeof localTheme === 'function') {
    const mergedTheme = localTheme(outerTheme);
    if (browser$1.env.NODE_ENV !== 'production') {
      if (!mergedTheme) {
        console.error(['MUI: You should return an object from your theme function, i.e.', '<ThemeProvider theme={() => ({})} />'].join('\n'));
      }
    }
    return mergedTheme;
  }
  return _extends$1({}, outerTheme, localTheme);
}

/**
 * This component takes a `theme` prop.
 * It makes the `theme` available down the React tree thanks to React context.
 * This component should preferably be used at **the root of your component tree**.
 */
function ThemeProvider$2(props) {
  const {
    children,
    theme: localTheme
  } = props;
  const outerTheme = useTheme$4();
  if (browser$1.env.NODE_ENV !== 'production') {
    if (outerTheme === null && typeof localTheme === 'function') {
      console.error(['MUI: You are providing a theme function prop to the ThemeProvider component:', '<ThemeProvider theme={outerTheme => outerTheme} />', '', 'However, no outer theme is present.', 'Make sure a theme is already injected higher in the React tree ' + 'or provide a theme object.'].join('\n'));
    }
  }
  const theme = React__namespace.useMemo(() => {
    const output = outerTheme === null ? localTheme : mergeOuterLocalTheme(outerTheme, localTheme);
    if (output != null) {
      output[nested] = outerTheme !== null;
    }
    return output;
  }, [localTheme, outerTheme]);
  return /*#__PURE__*/jsxRuntimeExports.jsx(ThemeContext$1.Provider, {
    value: theme,
    children: children
  });
}
browser$1.env.NODE_ENV !== "production" ? ThemeProvider$2.propTypes = {
  /**
   * Your component tree.
   */
  children: propTypesExports.node,
  /**
   * A theme object. You can provide a function to extend the outer theme.
   */
  theme: propTypesExports.oneOfType([propTypesExports.object, propTypesExports.func]).isRequired
} : void 0;
if (browser$1.env.NODE_ENV !== 'production') {
  browser$1.env.NODE_ENV !== "production" ? ThemeProvider$2.propTypes = exactProp(ThemeProvider$2.propTypes) : void 0;
}

function isObjectEmpty(obj) {
  return Object.keys(obj).length === 0;
}
function useTheme$3(defaultTheme = null) {
  const contextTheme = useTheme$4();
  return !contextTheme || isObjectEmpty(contextTheme) ? defaultTheme : contextTheme;
}

const systemDefaultTheme$1 = createTheme$1();
function useTheme$2(defaultTheme = systemDefaultTheme$1) {
  return useTheme$3(defaultTheme);
}

const _excluded$1u = ["className", "component"];
function createBox(options = {}) {
  const {
    defaultTheme,
    defaultClassName = 'MuiBox-root',
    generateClassName
  } = options;
  const BoxRoot = styled$2('div', {
    shouldForwardProp: prop => prop !== 'theme' && prop !== 'sx' && prop !== 'as'
  })(styleFunctionSx$1);
  const Box = /*#__PURE__*/React__namespace.forwardRef(function Box(inProps, ref) {
    const theme = useTheme$2(defaultTheme);
    const _extendSxProp = extendSxProp(inProps),
      {
        className,
        component = 'div'
      } = _extendSxProp,
      other = _objectWithoutPropertiesLoose(_extendSxProp, _excluded$1u);
    return /*#__PURE__*/jsxRuntimeExports.jsx(BoxRoot, _extends$1({
      as: component,
      ref: ref,
      className: clsx(className, generateClassName ? generateClassName(defaultClassName) : defaultClassName),
      theme: theme
    }, other));
  });
  return Box;
}

const Box$2 = createBox();
browser$1.env.NODE_ENV !== "production" ? Box$2.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * @ignore
   */
  children: propTypesExports.node,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var Box$3 = Box$2;

const _excluded$1t = ["variant"];
function isEmpty$2(string) {
  return string.length === 0;
}

/**
 * Generates string classKey based on the properties provided. It starts with the
 * variant if defined, and then it appends all other properties in alphabetical order.
 * @param {object} props - the properties for which the classKey should be created.
 */
function propsToClassKey(props) {
  const {
      variant
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1t);
  let classKey = variant || '';
  Object.keys(other).sort().forEach(key => {
    if (key === 'color') {
      classKey += isEmpty$2(classKey) ? props[key] : capitalize(props[key]);
    } else {
      classKey += `${isEmpty$2(classKey) ? key : capitalize(key)}${capitalize(props[key].toString())}`;
    }
  });
  return classKey;
}

const _excluded$1s = ["name", "slot", "skipVariantsResolver", "skipSx", "overridesResolver"],
  _excluded2$2 = ["theme"],
  _excluded3 = ["theme"];
function isEmpty$1(obj) {
  return Object.keys(obj).length === 0;
}

// https://github.com/emotion-js/emotion/blob/26ded6109fcd8ca9875cc2ce4564fee678a3f3c5/packages/styled/src/utils.js#L40
function isStringTag(tag) {
  return typeof tag === 'string' &&
  // 96 is one less than the char code
  // for "a" so this is checking that
  // it's a lowercase character
  tag.charCodeAt(0) > 96;
}
const getStyleOverrides = (name, theme) => {
  if (theme.components && theme.components[name] && theme.components[name].styleOverrides) {
    return theme.components[name].styleOverrides;
  }
  return null;
};
const getVariantStyles = (name, theme) => {
  let variants = [];
  if (theme && theme.components && theme.components[name] && theme.components[name].variants) {
    variants = theme.components[name].variants;
  }
  const variantsStyles = {};
  variants.forEach(definition => {
    const key = propsToClassKey(definition.props);
    variantsStyles[key] = definition.style;
  });
  return variantsStyles;
};
const variantsResolver = (props, styles, theme, name) => {
  var _theme$components, _theme$components$nam;
  const {
    ownerState = {}
  } = props;
  const variantsStyles = [];
  const themeVariants = theme == null ? void 0 : (_theme$components = theme.components) == null ? void 0 : (_theme$components$nam = _theme$components[name]) == null ? void 0 : _theme$components$nam.variants;
  if (themeVariants) {
    themeVariants.forEach(themeVariant => {
      let isMatch = true;
      Object.keys(themeVariant.props).forEach(key => {
        if (ownerState[key] !== themeVariant.props[key] && props[key] !== themeVariant.props[key]) {
          isMatch = false;
        }
      });
      if (isMatch) {
        variantsStyles.push(styles[propsToClassKey(themeVariant.props)]);
      }
    });
  }
  return variantsStyles;
};

// Update /system/styled/#api in case if this changes
function shouldForwardProp$4(prop) {
  return prop !== 'ownerState' && prop !== 'theme' && prop !== 'sx' && prop !== 'as';
}
const systemDefaultTheme = createTheme$1();
const lowercaseFirstLetter = string => {
  return string.charAt(0).toLowerCase() + string.slice(1);
};
function createStyled(input = {}) {
  const {
    defaultTheme = systemDefaultTheme,
    rootShouldForwardProp = shouldForwardProp$4,
    slotShouldForwardProp = shouldForwardProp$4
  } = input;
  const systemSx = props => {
    const theme = isEmpty$1(props.theme) ? defaultTheme : props.theme;
    return styleFunctionSx$1(_extends$1({}, props, {
      theme
    }));
  };
  systemSx.__mui_systemSx = true;
  return (tag, inputOptions = {}) => {
    // Filter out the `sx` style function from the previous styled component to prevent unnecessary styles generated by the composite components.
    internal_processStyles(tag, styles => styles.filter(style => !(style != null && style.__mui_systemSx)));
    const {
        name: componentName,
        slot: componentSlot,
        skipVariantsResolver: inputSkipVariantsResolver,
        skipSx: inputSkipSx,
        overridesResolver
      } = inputOptions,
      options = _objectWithoutPropertiesLoose(inputOptions, _excluded$1s);

    // if skipVariantsResolver option is defined, take the value, otherwise, true for root and false for other slots.
    const skipVariantsResolver = inputSkipVariantsResolver !== undefined ? inputSkipVariantsResolver : componentSlot && componentSlot !== 'Root' || false;
    const skipSx = inputSkipSx || false;
    let label;
    if (browser$1.env.NODE_ENV !== 'production') {
      if (componentName) {
        label = `${componentName}-${lowercaseFirstLetter(componentSlot || 'Root')}`;
      }
    }
    let shouldForwardPropOption = shouldForwardProp$4;
    if (componentSlot === 'Root') {
      shouldForwardPropOption = rootShouldForwardProp;
    } else if (componentSlot) {
      // any other slot specified
      shouldForwardPropOption = slotShouldForwardProp;
    } else if (isStringTag(tag)) {
      // for string (html) tag, preserve the behavior in emotion & styled-components.
      shouldForwardPropOption = undefined;
    }
    const defaultStyledResolver = styled$2(tag, _extends$1({
      shouldForwardProp: shouldForwardPropOption,
      label
    }, options));
    const muiStyledResolver = (styleArg, ...expressions) => {
      const expressionsWithDefaultTheme = expressions ? expressions.map(stylesArg => {
        // On the server Emotion doesn't use React.forwardRef for creating components, so the created
        // component stays as a function. This condition makes sure that we do not interpolate functions
        // which are basically components used as a selectors.
        return typeof stylesArg === 'function' && stylesArg.__emotion_real !== stylesArg ? _ref => {
          let {
              theme: themeInput
            } = _ref,
            other = _objectWithoutPropertiesLoose(_ref, _excluded2$2);
          return stylesArg(_extends$1({
            theme: isEmpty$1(themeInput) ? defaultTheme : themeInput
          }, other));
        } : stylesArg;
      }) : [];
      let transformedStyleArg = styleArg;
      if (componentName && overridesResolver) {
        expressionsWithDefaultTheme.push(props => {
          const theme = isEmpty$1(props.theme) ? defaultTheme : props.theme;
          const styleOverrides = getStyleOverrides(componentName, theme);
          if (styleOverrides) {
            const resolvedStyleOverrides = {};
            Object.entries(styleOverrides).forEach(([slotKey, slotStyle]) => {
              resolvedStyleOverrides[slotKey] = typeof slotStyle === 'function' ? slotStyle(_extends$1({}, props, {
                theme
              })) : slotStyle;
            });
            return overridesResolver(props, resolvedStyleOverrides);
          }
          return null;
        });
      }
      if (componentName && !skipVariantsResolver) {
        expressionsWithDefaultTheme.push(props => {
          const theme = isEmpty$1(props.theme) ? defaultTheme : props.theme;
          return variantsResolver(props, getVariantStyles(componentName, theme), theme, componentName);
        });
      }
      if (!skipSx) {
        expressionsWithDefaultTheme.push(systemSx);
      }
      const numOfCustomFnsApplied = expressionsWithDefaultTheme.length - expressions.length;
      if (Array.isArray(styleArg) && numOfCustomFnsApplied > 0) {
        const placeholders = new Array(numOfCustomFnsApplied).fill('');
        // If the type is array, than we need to add placeholders in the template for the overrides, variants and the sx styles.
        transformedStyleArg = [...styleArg, ...placeholders];
        transformedStyleArg.raw = [...styleArg.raw, ...placeholders];
      } else if (typeof styleArg === 'function' &&
      // On the server Emotion doesn't use React.forwardRef for creating components, so the created
      // component stays as a function. This condition makes sure that we do not interpolate functions
      // which are basically components used as a selectors.
      styleArg.__emotion_real !== styleArg) {
        // If the type is function, we need to define the default theme.
        transformedStyleArg = _ref2 => {
          let {
              theme: themeInput
            } = _ref2,
            other = _objectWithoutPropertiesLoose(_ref2, _excluded3);
          return styleArg(_extends$1({
            theme: isEmpty$1(themeInput) ? defaultTheme : themeInput
          }, other));
        };
      }
      const Component = defaultStyledResolver(transformedStyleArg, ...expressionsWithDefaultTheme);
      if (browser$1.env.NODE_ENV !== 'production') {
        let displayName;
        if (componentName) {
          displayName = `${componentName}${componentSlot || ''}`;
        }
        if (displayName === undefined) {
          displayName = `Styled(${getDisplayName(tag)})`;
        }
        Component.displayName = displayName;
      }
      return Component;
    };
    if (defaultStyledResolver.withConfig) {
      muiStyledResolver.withConfig = defaultStyledResolver.withConfig;
    }
    return muiStyledResolver;
  };
}

function getThemeProps(params) {
  const {
    theme,
    name,
    props
  } = params;
  if (!theme || !theme.components || !theme.components[name] || !theme.components[name].defaultProps) {
    return props;
  }
  return resolveProps(theme.components[name].defaultProps, props);
}

function useThemeProps$1({
  props,
  name,
  defaultTheme
}) {
  const theme = useTheme$2(defaultTheme);
  const mergedProps = getThemeProps({
    theme,
    name,
    props
  });
  return mergedProps;
}

/**
 * Returns a number whose value is limited to the given range.
 * @param {number} value The value to be clamped
 * @param {number} min The lower boundary of the output range
 * @param {number} max The upper boundary of the output range
 * @returns {number} A number in the range [min, max]
 */
function clamp(value, min = 0, max = 1) {
  if (browser$1.env.NODE_ENV !== 'production') {
    if (value < min || value > max) {
      console.error(`MUI: The value provided ${value} is out of range [${min}, ${max}].`);
    }
  }
  return Math.min(Math.max(min, value), max);
}

/**
 * Converts a color from CSS hex format to CSS rgb format.
 * @param {string} color - Hex color, i.e. #nnn or #nnnnnn
 * @returns {string} A CSS rgb color string
 */
function hexToRgb(color) {
  color = color.slice(1);
  const re = new RegExp(`.{1,${color.length >= 6 ? 2 : 1}}`, 'g');
  let colors = color.match(re);
  if (colors && colors[0].length === 1) {
    colors = colors.map(n => n + n);
  }
  return colors ? `rgb${colors.length === 4 ? 'a' : ''}(${colors.map((n, index) => {
    return index < 3 ? parseInt(n, 16) : Math.round(parseInt(n, 16) / 255 * 1000) / 1000;
  }).join(', ')})` : '';
}

/**
 * Returns an object with the type and values of a color.
 *
 * Note: Does not support rgb % values.
 * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
 * @returns {object} - A MUI color object: {type: string, values: number[]}
 */
function decomposeColor(color) {
  // Idempotent
  if (color.type) {
    return color;
  }
  if (color.charAt(0) === '#') {
    return decomposeColor(hexToRgb(color));
  }
  const marker = color.indexOf('(');
  const type = color.substring(0, marker);
  if (['rgb', 'rgba', 'hsl', 'hsla', 'color'].indexOf(type) === -1) {
    throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: Unsupported \`${color}\` color.
The following formats are supported: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color().` : formatMuiErrorMessage(9, color));
  }
  let values = color.substring(marker + 1, color.length - 1);
  let colorSpace;
  if (type === 'color') {
    values = values.split(' ');
    colorSpace = values.shift();
    if (values.length === 4 && values[3].charAt(0) === '/') {
      values[3] = values[3].slice(1);
    }
    if (['srgb', 'display-p3', 'a98-rgb', 'prophoto-rgb', 'rec-2020'].indexOf(colorSpace) === -1) {
      throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: unsupported \`${colorSpace}\` color space.
The following color spaces are supported: srgb, display-p3, a98-rgb, prophoto-rgb, rec-2020.` : formatMuiErrorMessage(10, colorSpace));
    }
  } else {
    values = values.split(',');
  }
  values = values.map(value => parseFloat(value));
  return {
    type,
    values,
    colorSpace
  };
}

/**
 * Converts a color object with type and values to a string.
 * @param {object} color - Decomposed color
 * @param {string} color.type - One of: 'rgb', 'rgba', 'hsl', 'hsla', 'color'
 * @param {array} color.values - [n,n,n] or [n,n,n,n]
 * @returns {string} A CSS color string
 */
function recomposeColor(color) {
  const {
    type,
    colorSpace
  } = color;
  let {
    values
  } = color;
  if (type.indexOf('rgb') !== -1) {
    // Only convert the first 3 values to int (i.e. not alpha)
    values = values.map((n, i) => i < 3 ? parseInt(n, 10) : n);
  } else if (type.indexOf('hsl') !== -1) {
    values[1] = `${values[1]}%`;
    values[2] = `${values[2]}%`;
  }
  if (type.indexOf('color') !== -1) {
    values = `${colorSpace} ${values.join(' ')}`;
  } else {
    values = `${values.join(', ')}`;
  }
  return `${type}(${values})`;
}

/**
 * Converts a color from hsl format to rgb format.
 * @param {string} color - HSL color values
 * @returns {string} rgb color values
 */
function hslToRgb(color) {
  color = decomposeColor(color);
  const {
    values
  } = color;
  const h = values[0];
  const s = values[1] / 100;
  const l = values[2] / 100;
  const a = s * Math.min(l, 1 - l);
  const f = (n, k = (n + h / 30) % 12) => l - a * Math.max(Math.min(k - 3, 9 - k, 1), -1);
  let type = 'rgb';
  const rgb = [Math.round(f(0) * 255), Math.round(f(8) * 255), Math.round(f(4) * 255)];
  if (color.type === 'hsla') {
    type += 'a';
    rgb.push(values[3]);
  }
  return recomposeColor({
    type,
    values: rgb
  });
}
/**
 * The relative brightness of any point in a color space,
 * normalized to 0 for darkest black and 1 for lightest white.
 *
 * Formula: https://www.w3.org/TR/WCAG20-TECHS/G17.html#G17-tests
 * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
 * @returns {number} The relative brightness of the color in the range 0 - 1
 */
function getLuminance(color) {
  color = decomposeColor(color);
  let rgb = color.type === 'hsl' || color.type === 'hsla' ? decomposeColor(hslToRgb(color)).values : color.values;
  rgb = rgb.map(val => {
    if (color.type !== 'color') {
      val /= 255; // normalized
    }

    return val <= 0.03928 ? val / 12.92 : ((val + 0.055) / 1.055) ** 2.4;
  });

  // Truncate at 3 digits
  return Number((0.2126 * rgb[0] + 0.7152 * rgb[1] + 0.0722 * rgb[2]).toFixed(3));
}

/**
 * Calculates the contrast ratio between two colors.
 *
 * Formula: https://www.w3.org/TR/WCAG20-TECHS/G17.html#G17-tests
 * @param {string} foreground - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
 * @param {string} background - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla()
 * @returns {number} A contrast ratio value in the range 0 - 21.
 */
function getContrastRatio(foreground, background) {
  const lumA = getLuminance(foreground);
  const lumB = getLuminance(background);
  return (Math.max(lumA, lumB) + 0.05) / (Math.min(lumA, lumB) + 0.05);
}

/**
 * Sets the absolute transparency of a color.
 * Any existing alpha values are overwritten.
 * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
 * @param {number} value - value to set the alpha channel to in the range 0 - 1
 * @returns {string} A CSS color string. Hex input values are returned as rgb
 */
function alpha(color, value) {
  color = decomposeColor(color);
  value = clamp(value);
  if (color.type === 'rgb' || color.type === 'hsl') {
    color.type += 'a';
  }
  if (color.type === 'color') {
    color.values[3] = `/${value}`;
  } else {
    color.values[3] = value;
  }
  return recomposeColor(color);
}

/**
 * Darkens a color.
 * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
 * @param {number} coefficient - multiplier in the range 0 - 1
 * @returns {string} A CSS color string. Hex input values are returned as rgb
 */
function darken(color, coefficient) {
  color = decomposeColor(color);
  coefficient = clamp(coefficient);
  if (color.type.indexOf('hsl') !== -1) {
    color.values[2] *= 1 - coefficient;
  } else if (color.type.indexOf('rgb') !== -1 || color.type.indexOf('color') !== -1) {
    for (let i = 0; i < 3; i += 1) {
      color.values[i] *= 1 - coefficient;
    }
  }
  return recomposeColor(color);
}

/**
 * Lightens a color.
 * @param {string} color - CSS color, i.e. one of: #nnn, #nnnnnn, rgb(), rgba(), hsl(), hsla(), color()
 * @param {number} coefficient - multiplier in the range 0 - 1
 * @returns {string} A CSS color string. Hex input values are returned as rgb
 */
function lighten(color, coefficient) {
  color = decomposeColor(color);
  coefficient = clamp(coefficient);
  if (color.type.indexOf('hsl') !== -1) {
    color.values[2] += (100 - color.values[2]) * coefficient;
  } else if (color.type.indexOf('rgb') !== -1) {
    for (let i = 0; i < 3; i += 1) {
      color.values[i] += (255 - color.values[i]) * coefficient;
    }
  } else if (color.type.indexOf('color') !== -1) {
    for (let i = 0; i < 3; i += 1) {
      color.values[i] += (1 - color.values[i]) * coefficient;
    }
  }
  return recomposeColor(color);
}

const EMPTY_THEME = {};
function InnerThemeProvider(props) {
  const theme = useTheme$2();
  return /*#__PURE__*/jsxRuntimeExports.jsx(react.ThemeContext.Provider, {
    value: typeof theme === 'object' ? theme : EMPTY_THEME,
    children: props.children
  });
}
browser$1.env.NODE_ENV !== "production" ? InnerThemeProvider.propTypes = {
  /**
   * Your component tree.
   */
  children: propTypesExports.node
} : void 0;

/**
 * This component makes the `theme` available down the React tree.
 * It should preferably be used at **the root of your component tree**.
 */
function ThemeProvider$1(props) {
  const {
    children,
    theme: localTheme
  } = props;
  return /*#__PURE__*/jsxRuntimeExports.jsx(ThemeProvider$2, {
    theme: localTheme,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(InnerThemeProvider, {
      children: children
    })
  });
}
browser$1.env.NODE_ENV !== "production" ? ThemeProvider$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Your component tree.
   */
  children: propTypesExports.node,
  /**
   * A theme object. You can provide a function to extend the outer theme.
   */
  theme: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object]).isRequired
} : void 0;
if (browser$1.env.NODE_ENV !== 'production') {
  browser$1.env.NODE_ENV !== "production" ? ThemeProvider$1.propTypes = exactProp(ThemeProvider$1.propTypes) : void 0;
}

function createMixins(breakpoints, mixins) {
  return _extends$1({
    toolbar: {
      minHeight: 56,
      [breakpoints.up('xs')]: {
        '@media (orientation: landscape)': {
          minHeight: 48
        }
      },
      [breakpoints.up('sm')]: {
        minHeight: 64
      }
    }
  }, mixins);
}

const common = {
  black: '#000',
  white: '#fff'
};
var common$1 = common;

const grey = {
  50: '#fafafa',
  100: '#f5f5f5',
  200: '#eeeeee',
  300: '#e0e0e0',
  400: '#bdbdbd',
  500: '#9e9e9e',
  600: '#757575',
  700: '#616161',
  800: '#424242',
  900: '#212121',
  A100: '#f5f5f5',
  A200: '#eeeeee',
  A400: '#bdbdbd',
  A700: '#616161'
};
var grey$1 = grey;

const purple = {
  50: '#f3e5f5',
  100: '#e1bee7',
  200: '#ce93d8',
  300: '#ba68c8',
  400: '#ab47bc',
  500: '#9c27b0',
  600: '#8e24aa',
  700: '#7b1fa2',
  800: '#6a1b9a',
  900: '#4a148c',
  A100: '#ea80fc',
  A200: '#e040fb',
  A400: '#d500f9',
  A700: '#aa00ff'
};
var purple$1 = purple;

const red = {
  50: '#ffebee',
  100: '#ffcdd2',
  200: '#ef9a9a',
  300: '#e57373',
  400: '#ef5350',
  500: '#f44336',
  600: '#e53935',
  700: '#d32f2f',
  800: '#c62828',
  900: '#b71c1c',
  A100: '#ff8a80',
  A200: '#ff5252',
  A400: '#ff1744',
  A700: '#d50000'
};
var red$1 = red;

const orange = {
  50: '#fff3e0',
  100: '#ffe0b2',
  200: '#ffcc80',
  300: '#ffb74d',
  400: '#ffa726',
  500: '#ff9800',
  600: '#fb8c00',
  700: '#f57c00',
  800: '#ef6c00',
  900: '#e65100',
  A100: '#ffd180',
  A200: '#ffab40',
  A400: '#ff9100',
  A700: '#ff6d00'
};
var orange$1 = orange;

const blue = {
  50: '#e3f2fd',
  100: '#bbdefb',
  200: '#90caf9',
  300: '#64b5f6',
  400: '#42a5f5',
  500: '#2196f3',
  600: '#1e88e5',
  700: '#1976d2',
  800: '#1565c0',
  900: '#0d47a1',
  A100: '#82b1ff',
  A200: '#448aff',
  A400: '#2979ff',
  A700: '#2962ff'
};
var blue$1 = blue;

const lightBlue = {
  50: '#e1f5fe',
  100: '#b3e5fc',
  200: '#81d4fa',
  300: '#4fc3f7',
  400: '#29b6f6',
  500: '#03a9f4',
  600: '#039be5',
  700: '#0288d1',
  800: '#0277bd',
  900: '#01579b',
  A100: '#80d8ff',
  A200: '#40c4ff',
  A400: '#00b0ff',
  A700: '#0091ea'
};
var lightBlue$1 = lightBlue;

const green = {
  50: '#e8f5e9',
  100: '#c8e6c9',
  200: '#a5d6a7',
  300: '#81c784',
  400: '#66bb6a',
  500: '#4caf50',
  600: '#43a047',
  700: '#388e3c',
  800: '#2e7d32',
  900: '#1b5e20',
  A100: '#b9f6ca',
  A200: '#69f0ae',
  A400: '#00e676',
  A700: '#00c853'
};
var green$1 = green;

const _excluded$1r = ["mode", "contrastThreshold", "tonalOffset"];
const light = {
  // The colors used to style the text.
  text: {
    // The most important text.
    primary: 'rgba(0, 0, 0, 0.87)',
    // Secondary text.
    secondary: 'rgba(0, 0, 0, 0.6)',
    // Disabled text have even lower visual prominence.
    disabled: 'rgba(0, 0, 0, 0.38)'
  },
  // The color used to divide different elements.
  divider: 'rgba(0, 0, 0, 0.12)',
  // The background colors used to style the surfaces.
  // Consistency between these values is important.
  background: {
    paper: common$1.white,
    default: common$1.white
  },
  // The colors used to style the action elements.
  action: {
    // The color of an active action like an icon button.
    active: 'rgba(0, 0, 0, 0.54)',
    // The color of an hovered action.
    hover: 'rgba(0, 0, 0, 0.04)',
    hoverOpacity: 0.04,
    // The color of a selected action.
    selected: 'rgba(0, 0, 0, 0.08)',
    selectedOpacity: 0.08,
    // The color of a disabled action.
    disabled: 'rgba(0, 0, 0, 0.26)',
    // The background color of a disabled action.
    disabledBackground: 'rgba(0, 0, 0, 0.12)',
    disabledOpacity: 0.38,
    focus: 'rgba(0, 0, 0, 0.12)',
    focusOpacity: 0.12,
    activatedOpacity: 0.12
  }
};
const dark = {
  text: {
    primary: common$1.white,
    secondary: 'rgba(255, 255, 255, 0.7)',
    disabled: 'rgba(255, 255, 255, 0.5)',
    icon: 'rgba(255, 255, 255, 0.5)'
  },
  divider: 'rgba(255, 255, 255, 0.12)',
  background: {
    paper: '#121212',
    default: '#121212'
  },
  action: {
    active: common$1.white,
    hover: 'rgba(255, 255, 255, 0.08)',
    hoverOpacity: 0.08,
    selected: 'rgba(255, 255, 255, 0.16)',
    selectedOpacity: 0.16,
    disabled: 'rgba(255, 255, 255, 0.3)',
    disabledBackground: 'rgba(255, 255, 255, 0.12)',
    disabledOpacity: 0.38,
    focus: 'rgba(255, 255, 255, 0.12)',
    focusOpacity: 0.12,
    activatedOpacity: 0.24
  }
};
function addLightOrDark(intent, direction, shade, tonalOffset) {
  const tonalOffsetLight = tonalOffset.light || tonalOffset;
  const tonalOffsetDark = tonalOffset.dark || tonalOffset * 1.5;
  if (!intent[direction]) {
    if (intent.hasOwnProperty(shade)) {
      intent[direction] = intent[shade];
    } else if (direction === 'light') {
      intent.light = lighten(intent.main, tonalOffsetLight);
    } else if (direction === 'dark') {
      intent.dark = darken(intent.main, tonalOffsetDark);
    }
  }
}
function getDefaultPrimary(mode = 'light') {
  if (mode === 'dark') {
    return {
      main: blue$1[200],
      light: blue$1[50],
      dark: blue$1[400]
    };
  }
  return {
    main: blue$1[700],
    light: blue$1[400],
    dark: blue$1[800]
  };
}
function getDefaultSecondary(mode = 'light') {
  if (mode === 'dark') {
    return {
      main: purple$1[200],
      light: purple$1[50],
      dark: purple$1[400]
    };
  }
  return {
    main: purple$1[500],
    light: purple$1[300],
    dark: purple$1[700]
  };
}
function getDefaultError(mode = 'light') {
  if (mode === 'dark') {
    return {
      main: red$1[500],
      light: red$1[300],
      dark: red$1[700]
    };
  }
  return {
    main: red$1[700],
    light: red$1[400],
    dark: red$1[800]
  };
}
function getDefaultInfo(mode = 'light') {
  if (mode === 'dark') {
    return {
      main: lightBlue$1[400],
      light: lightBlue$1[300],
      dark: lightBlue$1[700]
    };
  }
  return {
    main: lightBlue$1[700],
    light: lightBlue$1[500],
    dark: lightBlue$1[900]
  };
}
function getDefaultSuccess(mode = 'light') {
  if (mode === 'dark') {
    return {
      main: green$1[400],
      light: green$1[300],
      dark: green$1[700]
    };
  }
  return {
    main: green$1[800],
    light: green$1[500],
    dark: green$1[900]
  };
}
function getDefaultWarning(mode = 'light') {
  if (mode === 'dark') {
    return {
      main: orange$1[400],
      light: orange$1[300],
      dark: orange$1[700]
    };
  }
  return {
    main: '#ed6c02',
    // closest to orange[800] that pass 3:1.
    light: orange$1[500],
    dark: orange$1[900]
  };
}
function createPalette(palette) {
  const {
      mode = 'light',
      contrastThreshold = 3,
      tonalOffset = 0.2
    } = palette,
    other = _objectWithoutPropertiesLoose(palette, _excluded$1r);
  const primary = palette.primary || getDefaultPrimary(mode);
  const secondary = palette.secondary || getDefaultSecondary(mode);
  const error = palette.error || getDefaultError(mode);
  const info = palette.info || getDefaultInfo(mode);
  const success = palette.success || getDefaultSuccess(mode);
  const warning = palette.warning || getDefaultWarning(mode);

  // Use the same logic as
  // Bootstrap: https://github.com/twbs/bootstrap/blob/1d6e3710dd447de1a200f29e8fa521f8a0908f70/scss/_functions.scss#L59
  // and material-components-web https://github.com/material-components/material-components-web/blob/ac46b8863c4dab9fc22c4c662dc6bd1b65dd652f/packages/mdc-theme/_functions.scss#L54
  function getContrastText(background) {
    const contrastText = getContrastRatio(background, dark.text.primary) >= contrastThreshold ? dark.text.primary : light.text.primary;
    if (browser$1.env.NODE_ENV !== 'production') {
      const contrast = getContrastRatio(background, contrastText);
      if (contrast < 3) {
        console.error([`MUI: The contrast ratio of ${contrast}:1 for ${contrastText} on ${background}`, 'falls below the WCAG recommended absolute minimum contrast ratio of 3:1.', 'https://www.w3.org/TR/2008/REC-WCAG20-20081211/#visual-audio-contrast-contrast'].join('\n'));
      }
    }
    return contrastText;
  }
  const augmentColor = ({
    color,
    name,
    mainShade = 500,
    lightShade = 300,
    darkShade = 700
  }) => {
    color = _extends$1({}, color);
    if (!color.main && color[mainShade]) {
      color.main = color[mainShade];
    }
    if (!color.hasOwnProperty('main')) {
      throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: The color${name ? ` (${name})` : ''} provided to augmentColor(color) is invalid.
The color object needs to have a \`main\` property or a \`${mainShade}\` property.` : formatMuiErrorMessage(11, name ? ` (${name})` : '', mainShade));
    }
    if (typeof color.main !== 'string') {
      throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: The color${name ? ` (${name})` : ''} provided to augmentColor(color) is invalid.
\`color.main\` should be a string, but \`${JSON.stringify(color.main)}\` was provided instead.

Did you intend to use one of the following approaches?

import { green } from "@mui/material/colors";

const theme1 = createTheme({ palette: {
  primary: green,
} });

const theme2 = createTheme({ palette: {
  primary: { main: green[500] },
} });` : formatMuiErrorMessage(12, name ? ` (${name})` : '', JSON.stringify(color.main)));
    }
    addLightOrDark(color, 'light', lightShade, tonalOffset);
    addLightOrDark(color, 'dark', darkShade, tonalOffset);
    if (!color.contrastText) {
      color.contrastText = getContrastText(color.main);
    }
    return color;
  };
  const modes = {
    dark,
    light
  };
  if (browser$1.env.NODE_ENV !== 'production') {
    if (!modes[mode]) {
      console.error(`MUI: The palette mode \`${mode}\` is not supported.`);
    }
  }
  const paletteOutput = deepmerge(_extends$1({
    // A collection of common colors.
    common: _extends$1({}, common$1),
    // prevent mutable object.
    // The palette mode, can be light or dark.
    mode,
    // The colors used to represent primary interface elements for a user.
    primary: augmentColor({
      color: primary,
      name: 'primary'
    }),
    // The colors used to represent secondary interface elements for a user.
    secondary: augmentColor({
      color: secondary,
      name: 'secondary',
      mainShade: 'A400',
      lightShade: 'A200',
      darkShade: 'A700'
    }),
    // The colors used to represent interface elements that the user should be made aware of.
    error: augmentColor({
      color: error,
      name: 'error'
    }),
    // The colors used to represent potentially dangerous actions or important messages.
    warning: augmentColor({
      color: warning,
      name: 'warning'
    }),
    // The colors used to present information to the user that is neutral and not necessarily important.
    info: augmentColor({
      color: info,
      name: 'info'
    }),
    // The colors used to indicate the successful completion of an action that user triggered.
    success: augmentColor({
      color: success,
      name: 'success'
    }),
    // The grey colors.
    grey: grey$1,
    // Used by `getContrastText()` to maximize the contrast between
    // the background and the text.
    contrastThreshold,
    // Takes a background color and returns the text color that maximizes the contrast.
    getContrastText,
    // Generate a rich color object.
    augmentColor,
    // Used by the functions below to shift a color's luminance by approximately
    // two indexes within its tonal palette.
    // E.g., shift from Red 500 to Red 300 or Red 700.
    tonalOffset
  }, modes[mode]), other);
  return paletteOutput;
}

const _excluded$1q = ["fontFamily", "fontSize", "fontWeightLight", "fontWeightRegular", "fontWeightMedium", "fontWeightBold", "htmlFontSize", "allVariants", "pxToRem"];
function round$1(value) {
  return Math.round(value * 1e5) / 1e5;
}
const caseAllCaps = {
  textTransform: 'uppercase'
};
const defaultFontFamily = '"Roboto", "Helvetica", "Arial", sans-serif';

/**
 * @see @link{https://m2.material.io/design/typography/the-type-system.html}
 * @see @link{https://m2.material.io/design/typography/understanding-typography.html}
 */
function createTypography(palette, typography) {
  const _ref = typeof typography === 'function' ? typography(palette) : typography,
    {
      fontFamily = defaultFontFamily,
      // The default font size of the Material Specification.
      fontSize = 14,
      // px
      fontWeightLight = 300,
      fontWeightRegular = 400,
      fontWeightMedium = 500,
      fontWeightBold = 700,
      // Tell MUI what's the font-size on the html element.
      // 16px is the default font-size used by browsers.
      htmlFontSize = 16,
      // Apply the CSS properties to all the variants.
      allVariants,
      pxToRem: pxToRem2
    } = _ref,
    other = _objectWithoutPropertiesLoose(_ref, _excluded$1q);
  if (browser$1.env.NODE_ENV !== 'production') {
    if (typeof fontSize !== 'number') {
      console.error('MUI: `fontSize` is required to be a number.');
    }
    if (typeof htmlFontSize !== 'number') {
      console.error('MUI: `htmlFontSize` is required to be a number.');
    }
  }
  const coef = fontSize / 14;
  const pxToRem = pxToRem2 || (size => `${size / htmlFontSize * coef}rem`);
  const buildVariant = (fontWeight, size, lineHeight, letterSpacing, casing) => _extends$1({
    fontFamily,
    fontWeight,
    fontSize: pxToRem(size),
    // Unitless following https://meyerweb.com/eric/thoughts/2006/02/08/unitless-line-heights/
    lineHeight
  }, fontFamily === defaultFontFamily ? {
    letterSpacing: `${round$1(letterSpacing / size)}em`
  } : {}, casing, allVariants);
  const variants = {
    h1: buildVariant(fontWeightLight, 96, 1.167, -1.5),
    h2: buildVariant(fontWeightLight, 60, 1.2, -0.5),
    h3: buildVariant(fontWeightRegular, 48, 1.167, 0),
    h4: buildVariant(fontWeightRegular, 34, 1.235, 0.25),
    h5: buildVariant(fontWeightRegular, 24, 1.334, 0),
    h6: buildVariant(fontWeightMedium, 20, 1.6, 0.15),
    subtitle1: buildVariant(fontWeightRegular, 16, 1.75, 0.15),
    subtitle2: buildVariant(fontWeightMedium, 14, 1.57, 0.1),
    body1: buildVariant(fontWeightRegular, 16, 1.5, 0.15),
    body2: buildVariant(fontWeightRegular, 14, 1.43, 0.15),
    button: buildVariant(fontWeightMedium, 14, 1.75, 0.4, caseAllCaps),
    caption: buildVariant(fontWeightRegular, 12, 1.66, 0.4),
    overline: buildVariant(fontWeightRegular, 12, 2.66, 1, caseAllCaps),
    inherit: {
      fontFamily: 'inherit',
      fontWeight: 'inherit',
      fontSize: 'inherit',
      lineHeight: 'inherit',
      letterSpacing: 'inherit'
    }
  };
  return deepmerge(_extends$1({
    htmlFontSize,
    pxToRem,
    fontFamily,
    fontSize,
    fontWeightLight,
    fontWeightRegular,
    fontWeightMedium,
    fontWeightBold
  }, variants), other, {
    clone: false // No need to clone deep
  });
}

const shadowKeyUmbraOpacity = 0.2;
const shadowKeyPenumbraOpacity = 0.14;
const shadowAmbientShadowOpacity = 0.12;
function createShadow(...px) {
  return [`${px[0]}px ${px[1]}px ${px[2]}px ${px[3]}px rgba(0,0,0,${shadowKeyUmbraOpacity})`, `${px[4]}px ${px[5]}px ${px[6]}px ${px[7]}px rgba(0,0,0,${shadowKeyPenumbraOpacity})`, `${px[8]}px ${px[9]}px ${px[10]}px ${px[11]}px rgba(0,0,0,${shadowAmbientShadowOpacity})`].join(',');
}

// Values from https://github.com/material-components/material-components-web/blob/be8747f94574669cb5e7add1a7c54fa41a89cec7/packages/mdc-elevation/_variables.scss
const shadows = ['none', createShadow(0, 2, 1, -1, 0, 1, 1, 0, 0, 1, 3, 0), createShadow(0, 3, 1, -2, 0, 2, 2, 0, 0, 1, 5, 0), createShadow(0, 3, 3, -2, 0, 3, 4, 0, 0, 1, 8, 0), createShadow(0, 2, 4, -1, 0, 4, 5, 0, 0, 1, 10, 0), createShadow(0, 3, 5, -1, 0, 5, 8, 0, 0, 1, 14, 0), createShadow(0, 3, 5, -1, 0, 6, 10, 0, 0, 1, 18, 0), createShadow(0, 4, 5, -2, 0, 7, 10, 1, 0, 2, 16, 1), createShadow(0, 5, 5, -3, 0, 8, 10, 1, 0, 3, 14, 2), createShadow(0, 5, 6, -3, 0, 9, 12, 1, 0, 3, 16, 2), createShadow(0, 6, 6, -3, 0, 10, 14, 1, 0, 4, 18, 3), createShadow(0, 6, 7, -4, 0, 11, 15, 1, 0, 4, 20, 3), createShadow(0, 7, 8, -4, 0, 12, 17, 2, 0, 5, 22, 4), createShadow(0, 7, 8, -4, 0, 13, 19, 2, 0, 5, 24, 4), createShadow(0, 7, 9, -4, 0, 14, 21, 2, 0, 5, 26, 4), createShadow(0, 8, 9, -5, 0, 15, 22, 2, 0, 6, 28, 5), createShadow(0, 8, 10, -5, 0, 16, 24, 2, 0, 6, 30, 5), createShadow(0, 8, 11, -5, 0, 17, 26, 2, 0, 6, 32, 5), createShadow(0, 9, 11, -5, 0, 18, 28, 2, 0, 7, 34, 6), createShadow(0, 9, 12, -6, 0, 19, 29, 2, 0, 7, 36, 6), createShadow(0, 10, 13, -6, 0, 20, 31, 3, 0, 8, 38, 7), createShadow(0, 10, 13, -6, 0, 21, 33, 3, 0, 8, 40, 7), createShadow(0, 10, 14, -6, 0, 22, 35, 3, 0, 8, 42, 7), createShadow(0, 11, 14, -7, 0, 23, 36, 3, 0, 9, 44, 8), createShadow(0, 11, 15, -7, 0, 24, 38, 3, 0, 9, 46, 8)];
var shadows$1 = shadows;

const _excluded$1p = ["duration", "easing", "delay"];
// Follow https://material.google.com/motion/duration-easing.html#duration-easing-natural-easing-curves
// to learn the context in which each easing should be used.
const easing = {
  // This is the most common easing curve.
  easeInOut: 'cubic-bezier(0.4, 0, 0.2, 1)',
  // Objects enter the screen at full velocity from off-screen and
  // slowly decelerate to a resting point.
  easeOut: 'cubic-bezier(0.0, 0, 0.2, 1)',
  // Objects leave the screen at full velocity. They do not decelerate when off-screen.
  easeIn: 'cubic-bezier(0.4, 0, 1, 1)',
  // The sharp curve is used by objects that may return to the screen at any time.
  sharp: 'cubic-bezier(0.4, 0, 0.6, 1)'
};

// Follow https://m2.material.io/guidelines/motion/duration-easing.html#duration-easing-common-durations
// to learn when use what timing
const duration = {
  shortest: 150,
  shorter: 200,
  short: 250,
  // most basic recommended timing
  standard: 300,
  // this is to be used in complex animations
  complex: 375,
  // recommended when something is entering screen
  enteringScreen: 225,
  // recommended when something is leaving screen
  leavingScreen: 195
};
function formatMs(milliseconds) {
  return `${Math.round(milliseconds)}ms`;
}
function getAutoHeightDuration(height) {
  if (!height) {
    return 0;
  }
  const constant = height / 36;

  // https://www.wolframalpha.com/input/?i=(4+%2B+15+*+(x+%2F+36+)+**+0.25+%2B+(x+%2F+36)+%2F+5)+*+10
  return Math.round((4 + 15 * constant ** 0.25 + constant / 5) * 10);
}
function createTransitions(inputTransitions) {
  const mergedEasing = _extends$1({}, easing, inputTransitions.easing);
  const mergedDuration = _extends$1({}, duration, inputTransitions.duration);
  const create = (props = ['all'], options = {}) => {
    const {
        duration: durationOption = mergedDuration.standard,
        easing: easingOption = mergedEasing.easeInOut,
        delay = 0
      } = options,
      other = _objectWithoutPropertiesLoose(options, _excluded$1p);
    if (browser$1.env.NODE_ENV !== 'production') {
      const isString = value => typeof value === 'string';
      // IE11 support, replace with Number.isNaN
      // eslint-disable-next-line no-restricted-globals
      const isNumber = value => !isNaN(parseFloat(value));
      if (!isString(props) && !Array.isArray(props)) {
        console.error('MUI: Argument "props" must be a string or Array.');
      }
      if (!isNumber(durationOption) && !isString(durationOption)) {
        console.error(`MUI: Argument "duration" must be a number or a string but found ${durationOption}.`);
      }
      if (!isString(easingOption)) {
        console.error('MUI: Argument "easing" must be a string.');
      }
      if (!isNumber(delay) && !isString(delay)) {
        console.error('MUI: Argument "delay" must be a number or a string.');
      }
      if (Object.keys(other).length !== 0) {
        console.error(`MUI: Unrecognized argument(s) [${Object.keys(other).join(',')}].`);
      }
    }
    return (Array.isArray(props) ? props : [props]).map(animatedProp => `${animatedProp} ${typeof durationOption === 'string' ? durationOption : formatMs(durationOption)} ${easingOption} ${typeof delay === 'string' ? delay : formatMs(delay)}`).join(',');
  };
  return _extends$1({
    getAutoHeightDuration,
    create
  }, inputTransitions, {
    easing: mergedEasing,
    duration: mergedDuration
  });
}

// We need to centralize the zIndex definitions as they work
// like global values in the browser.
const zIndex = {
  mobileStepper: 1000,
  fab: 1050,
  speedDial: 1050,
  appBar: 1100,
  drawer: 1200,
  modal: 1300,
  snackbar: 1400,
  tooltip: 1500
};
var zIndex$1 = zIndex;

const _excluded$1o = ["breakpoints", "mixins", "spacing", "palette", "transitions", "typography", "shape"];
function createTheme(options = {}, ...args) {
  const {
      mixins: mixinsInput = {},
      palette: paletteInput = {},
      transitions: transitionsInput = {},
      typography: typographyInput = {}
    } = options,
    other = _objectWithoutPropertiesLoose(options, _excluded$1o);
  if (options.vars) {
    throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: \`vars\` is a private field used for CSS variables support.
Please use another name.` : formatMuiErrorMessage(18));
  }
  const palette = createPalette(paletteInput);
  const systemTheme = createTheme$1(options);
  let muiTheme = deepmerge(systemTheme, {
    mixins: createMixins(systemTheme.breakpoints, mixinsInput),
    palette,
    // Don't use [...shadows] until you've verified its transpiled code is not invoking the iterator protocol.
    shadows: shadows$1.slice(),
    typography: createTypography(palette, typographyInput),
    transitions: createTransitions(transitionsInput),
    zIndex: _extends$1({}, zIndex$1)
  });
  muiTheme = deepmerge(muiTheme, other);
  muiTheme = args.reduce((acc, argument) => deepmerge(acc, argument), muiTheme);
  if (browser$1.env.NODE_ENV !== 'production') {
    // TODO v6: Refactor to use globalStateClassesMapping from @mui/utils once `readOnly` state class is used in Rating component.
    const stateClasses = ['active', 'checked', 'completed', 'disabled', 'error', 'expanded', 'focused', 'focusVisible', 'required', 'selected'];
    const traverse = (node, component) => {
      let key;

      // eslint-disable-next-line guard-for-in, no-restricted-syntax
      for (key in node) {
        const child = node[key];
        if (stateClasses.indexOf(key) !== -1 && Object.keys(child).length > 0) {
          if (browser$1.env.NODE_ENV !== 'production') {
            const stateClass = generateUtilityClass('', key);
            console.error([`MUI: The \`${component}\` component increases ` + `the CSS specificity of the \`${key}\` internal state.`, 'You can not override it like this: ', JSON.stringify(node, null, 2), '', `Instead, you need to use the '&.${stateClass}' syntax:`, JSON.stringify({
              root: {
                [`&.${stateClass}`]: child
              }
            }, null, 2), '', 'https://mui.com/r/state-classes-guide'].join('\n'));
          }
          // Remove the style to prevent global conflicts.
          node[key] = {};
        }
      }
    };
    Object.keys(muiTheme.components).forEach(component => {
      const styleOverrides = muiTheme.components[component].styleOverrides;
      if (styleOverrides && component.indexOf('Mui') === 0) {
        traverse(styleOverrides, component);
      }
    });
  }
  muiTheme.unstable_sxConfig = _extends$1({}, defaultSxConfig$1, other == null ? void 0 : other.unstable_sxConfig);
  muiTheme.unstable_sx = function sx(props) {
    return styleFunctionSx$1({
      sx: props,
      theme: this
    });
  };
  return muiTheme;
}

const defaultTheme$1 = createTheme();
var defaultTheme$2 = defaultTheme$1;

const rootShouldForwardProp$1 = prop => shouldForwardProp$4(prop) && prop !== 'classes';
const slotShouldForwardProp = shouldForwardProp$4;
const styled = createStyled({
  defaultTheme: defaultTheme$2,
  rootShouldForwardProp: rootShouldForwardProp$1
});
var styled$1 = styled;

function useThemeProps({
  props,
  name
}) {
  return useThemeProps$1({
    props,
    name,
    defaultTheme: defaultTheme$2
  });
}

/**
 * @ignore - internal component.
 */
const ListContext = /*#__PURE__*/React__namespace.createContext({});
if (browser$1.env.NODE_ENV !== 'production') {
  ListContext.displayName = 'ListContext';
}
var ListContext$1 = ListContext;

function getListUtilityClass(slot) {
  return generateUtilityClass('MuiList', slot);
}
generateUtilityClasses('MuiList', ['root', 'padding', 'dense', 'subheader']);

const _excluded$1n = ["children", "className", "component", "dense", "disablePadding", "subheader"];
const useUtilityClasses$O = ownerState => {
  const {
    classes,
    disablePadding,
    dense,
    subheader
  } = ownerState;
  const slots = {
    root: ['root', !disablePadding && 'padding', dense && 'dense', subheader && 'subheader']
  };
  return composeClasses(slots, getListUtilityClass, classes);
};
const ListRoot = styled$1('ul', {
  name: 'MuiList',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, !ownerState.disablePadding && styles.padding, ownerState.dense && styles.dense, ownerState.subheader && styles.subheader];
  }
})(({
  ownerState
}) => _extends$1({
  listStyle: 'none',
  margin: 0,
  padding: 0,
  position: 'relative'
}, !ownerState.disablePadding && {
  paddingTop: 8,
  paddingBottom: 8
}, ownerState.subheader && {
  paddingTop: 0
}));
const List = /*#__PURE__*/React__namespace.forwardRef(function List(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiList'
  });
  const {
      children,
      className,
      component = 'ul',
      dense = false,
      disablePadding = false,
      subheader
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1n);
  const context = React__namespace.useMemo(() => ({
    dense
  }), [dense]);
  const ownerState = _extends$1({}, props, {
    component,
    dense,
    disablePadding
  });
  const classes = useUtilityClasses$O(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(ListContext$1.Provider, {
    value: context,
    children: /*#__PURE__*/jsxRuntimeExports.jsxs(ListRoot, _extends$1({
      as: component,
      className: clsx(classes.root, className),
      ref: ref,
      ownerState: ownerState
    }, other, {
      children: [subheader, children]
    }))
  });
});
browser$1.env.NODE_ENV !== "production" ? List.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, compact vertical padding designed for keyboard and mouse input is used for
   * the list and list items.
   * The prop is available to descendant components as the `dense` context.
   * @default false
   */
  dense: propTypesExports.bool,
  /**
   * If `true`, vertical padding is removed from the list.
   * @default false
   */
  disablePadding: propTypesExports.bool,
  /**
   * The content of the subheader, normally `ListSubheader`.
   */
  subheader: propTypesExports.node,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var List$1 = List;

const _excluded$1m = ["actions", "autoFocus", "autoFocusItem", "children", "className", "disabledItemsFocusable", "disableListWrap", "onKeyDown", "variant"];
function nextItem$1(list, item, disableListWrap) {
  if (list === item) {
    return list.firstChild;
  }
  if (item && item.nextElementSibling) {
    return item.nextElementSibling;
  }
  return disableListWrap ? null : list.firstChild;
}
function previousItem$1(list, item, disableListWrap) {
  if (list === item) {
    return disableListWrap ? list.firstChild : list.lastChild;
  }
  if (item && item.previousElementSibling) {
    return item.previousElementSibling;
  }
  return disableListWrap ? null : list.lastChild;
}
function textCriteriaMatches(nextFocus, textCriteria) {
  if (textCriteria === undefined) {
    return true;
  }
  let text = nextFocus.innerText;
  if (text === undefined) {
    // jsdom doesn't support innerText
    text = nextFocus.textContent;
  }
  text = text.trim().toLowerCase();
  if (text.length === 0) {
    return false;
  }
  if (textCriteria.repeating) {
    return text[0] === textCriteria.keys[0];
  }
  return text.indexOf(textCriteria.keys.join('')) === 0;
}
function moveFocus$1(list, currentFocus, disableListWrap, disabledItemsFocusable, traversalFunction, textCriteria) {
  let wrappedOnce = false;
  let nextFocus = traversalFunction(list, currentFocus, currentFocus ? disableListWrap : false);
  while (nextFocus) {
    // Prevent infinite loop.
    if (nextFocus === list.firstChild) {
      if (wrappedOnce) {
        return false;
      }
      wrappedOnce = true;
    }

    // Same logic as useAutocomplete.js
    const nextFocusDisabled = disabledItemsFocusable ? false : nextFocus.disabled || nextFocus.getAttribute('aria-disabled') === 'true';
    if (!nextFocus.hasAttribute('tabindex') || !textCriteriaMatches(nextFocus, textCriteria) || nextFocusDisabled) {
      // Move to the next element.
      nextFocus = traversalFunction(list, nextFocus, disableListWrap);
    } else {
      nextFocus.focus();
      return true;
    }
  }
  return false;
}

/**
 * A permanently displayed menu following https://www.w3.org/WAI/ARIA/apg/patterns/menu-button/.
 * It's exposed to help customization of the [`Menu`](/material-ui/api/menu/) component if you
 * use it separately you need to move focus into the component manually. Once
 * the focus is placed inside the component it is fully keyboard accessible.
 */
const MenuList = /*#__PURE__*/React__namespace.forwardRef(function MenuList(props, ref) {
  const {
      // private
      // eslint-disable-next-line react/prop-types
      actions,
      autoFocus = false,
      autoFocusItem = false,
      children,
      className,
      disabledItemsFocusable = false,
      disableListWrap = false,
      onKeyDown,
      variant = 'selectedMenu'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1m);
  const listRef = React__namespace.useRef(null);
  const textCriteriaRef = React__namespace.useRef({
    keys: [],
    repeating: true,
    previousKeyMatched: true,
    lastTime: null
  });
  useEnhancedEffect$1(() => {
    if (autoFocus) {
      listRef.current.focus();
    }
  }, [autoFocus]);
  React__namespace.useImperativeHandle(actions, () => ({
    adjustStyleForScrollbar: (containerElement, theme) => {
      // Let's ignore that piece of logic if users are already overriding the width
      // of the menu.
      const noExplicitWidth = !listRef.current.style.width;
      if (containerElement.clientHeight < listRef.current.clientHeight && noExplicitWidth) {
        const scrollbarSize = `${getScrollbarSize(ownerDocument(containerElement))}px`;
        listRef.current.style[theme.direction === 'rtl' ? 'paddingLeft' : 'paddingRight'] = scrollbarSize;
        listRef.current.style.width = `calc(100% + ${scrollbarSize})`;
      }
      return listRef.current;
    }
  }), []);
  const handleKeyDown = event => {
    const list = listRef.current;
    const key = event.key;
    /**
     * @type {Element} - will always be defined since we are in a keydown handler
     * attached to an element. A keydown event is either dispatched to the activeElement
     * or document.body or document.documentElement. Only the first case will
     * trigger this specific handler.
     */
    const currentFocus = ownerDocument(list).activeElement;
    if (key === 'ArrowDown') {
      // Prevent scroll of the page
      event.preventDefault();
      moveFocus$1(list, currentFocus, disableListWrap, disabledItemsFocusable, nextItem$1);
    } else if (key === 'ArrowUp') {
      event.preventDefault();
      moveFocus$1(list, currentFocus, disableListWrap, disabledItemsFocusable, previousItem$1);
    } else if (key === 'Home') {
      event.preventDefault();
      moveFocus$1(list, null, disableListWrap, disabledItemsFocusable, nextItem$1);
    } else if (key === 'End') {
      event.preventDefault();
      moveFocus$1(list, null, disableListWrap, disabledItemsFocusable, previousItem$1);
    } else if (key.length === 1) {
      const criteria = textCriteriaRef.current;
      const lowerKey = key.toLowerCase();
      const currTime = performance.now();
      if (criteria.keys.length > 0) {
        // Reset
        if (currTime - criteria.lastTime > 500) {
          criteria.keys = [];
          criteria.repeating = true;
          criteria.previousKeyMatched = true;
        } else if (criteria.repeating && lowerKey !== criteria.keys[0]) {
          criteria.repeating = false;
        }
      }
      criteria.lastTime = currTime;
      criteria.keys.push(lowerKey);
      const keepFocusOnCurrent = currentFocus && !criteria.repeating && textCriteriaMatches(currentFocus, criteria);
      if (criteria.previousKeyMatched && (keepFocusOnCurrent || moveFocus$1(list, currentFocus, false, disabledItemsFocusable, nextItem$1, criteria))) {
        event.preventDefault();
      } else {
        criteria.previousKeyMatched = false;
      }
    }
    if (onKeyDown) {
      onKeyDown(event);
    }
  };
  const handleRef = useForkRef(listRef, ref);

  /**
   * the index of the item should receive focus
   * in a `variant="selectedMenu"` it's the first `selected` item
   * otherwise it's the very first item.
   */
  let activeItemIndex = -1;
  // since we inject focus related props into children we have to do a lookahead
  // to check if there is a `selected` item. We're looking for the last `selected`
  // item and use the first valid item as a fallback
  React__namespace.Children.forEach(children, (child, index) => {
    if (! /*#__PURE__*/React__namespace.isValidElement(child)) {
      return;
    }
    if (browser$1.env.NODE_ENV !== 'production') {
      if (reactIsExports.isFragment(child)) {
        console.error(["MUI: The Menu component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
      }
    }
    if (!child.props.disabled) {
      if (variant === 'selectedMenu' && child.props.selected) {
        activeItemIndex = index;
      } else if (activeItemIndex === -1) {
        activeItemIndex = index;
      }
    }
    if (activeItemIndex === index && (child.props.disabled || child.props.muiSkipListHighlight || child.type.muiSkipListHighlight)) {
      activeItemIndex += 1;
      if (activeItemIndex >= children.length) {
        // there are no focusable items within the list.
        activeItemIndex = -1;
      }
    }
  });
  const items = React__namespace.Children.map(children, (child, index) => {
    if (index === activeItemIndex) {
      const newChildProps = {};
      if (autoFocusItem) {
        newChildProps.autoFocus = true;
      }
      if (child.props.tabIndex === undefined && variant === 'selectedMenu') {
        newChildProps.tabIndex = 0;
      }
      return /*#__PURE__*/React__namespace.cloneElement(child, newChildProps);
    }
    return child;
  });
  return /*#__PURE__*/jsxRuntimeExports.jsx(List$1, _extends$1({
    role: "menu",
    ref: handleRef,
    className: className,
    onKeyDown: handleKeyDown,
    tabIndex: autoFocus ? 0 : -1
  }, other, {
    children: items
  }));
});
browser$1.env.NODE_ENV !== "production" ? MenuList.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, will focus the `[role="menu"]` container and move into tab order.
   * @default false
   */
  autoFocus: propTypesExports.bool,
  /**
   * If `true`, will focus the first menuitem if `variant="menu"` or selected item
   * if `variant="selectedMenu"`.
   * @default false
   */
  autoFocusItem: propTypesExports.bool,
  /**
   * MenuList contents, normally `MenuItem`s.
   */
  children: propTypesExports.node,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * If `true`, will allow focus on disabled items.
   * @default false
   */
  disabledItemsFocusable: propTypesExports.bool,
  /**
   * If `true`, the menu items will not wrap focus.
   * @default false
   */
  disableListWrap: propTypesExports.bool,
  /**
   * @ignore
   */
  onKeyDown: propTypesExports.func,
  /**
   * The variant to use. Use `menu` to prevent selected items from impacting the initial focus
   * and the vertical alignment relative to the anchor element.
   * @default 'selectedMenu'
   */
  variant: propTypesExports.oneOf(['menu', 'selectedMenu'])
} : void 0;
var MenuList$1 = MenuList;

// Inspired by https://github.com/material-components/material-components-ios/blob/bca36107405594d5b7b16265a5b0ed698f85a5ee/components/Elevation/src/UIColor%2BMaterialElevation.m#L61
const getOverlayAlpha = elevation => {
  let alphaValue;
  if (elevation < 1) {
    alphaValue = 5.11916 * elevation ** 2;
  } else {
    alphaValue = 4.5 * Math.log(elevation + 1) + 2;
  }
  return (alphaValue / 100).toFixed(2);
};
var getOverlayAlpha$1 = getOverlayAlpha;

function useTheme$1() {
  const theme = useTheme$2(defaultTheme$2);
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useDebugValue(theme);
  }
  return theme;
}

function getPaperUtilityClass(slot) {
  return generateUtilityClass('MuiPaper', slot);
}
generateUtilityClasses('MuiPaper', ['root', 'rounded', 'outlined', 'elevation', 'elevation0', 'elevation1', 'elevation2', 'elevation3', 'elevation4', 'elevation5', 'elevation6', 'elevation7', 'elevation8', 'elevation9', 'elevation10', 'elevation11', 'elevation12', 'elevation13', 'elevation14', 'elevation15', 'elevation16', 'elevation17', 'elevation18', 'elevation19', 'elevation20', 'elevation21', 'elevation22', 'elevation23', 'elevation24']);

const _excluded$1l = ["className", "component", "elevation", "square", "variant"];
const useUtilityClasses$N = ownerState => {
  const {
    square,
    elevation,
    variant,
    classes
  } = ownerState;
  const slots = {
    root: ['root', variant, !square && 'rounded', variant === 'elevation' && `elevation${elevation}`]
  };
  return composeClasses(slots, getPaperUtilityClass, classes);
};
const PaperRoot = styled$1('div', {
  name: 'MuiPaper',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[ownerState.variant], !ownerState.square && styles.rounded, ownerState.variant === 'elevation' && styles[`elevation${ownerState.elevation}`]];
  }
})(({
  theme,
  ownerState
}) => {
  var _theme$vars$overlays;
  return _extends$1({
    backgroundColor: (theme.vars || theme).palette.background.paper,
    color: (theme.vars || theme).palette.text.primary,
    transition: theme.transitions.create('box-shadow')
  }, !ownerState.square && {
    borderRadius: theme.shape.borderRadius
  }, ownerState.variant === 'outlined' && {
    border: `1px solid ${(theme.vars || theme).palette.divider}`
  }, ownerState.variant === 'elevation' && _extends$1({
    boxShadow: (theme.vars || theme).shadows[ownerState.elevation]
  }, !theme.vars && theme.palette.mode === 'dark' && {
    backgroundImage: `linear-gradient(${alpha('#fff', getOverlayAlpha$1(ownerState.elevation))}, ${alpha('#fff', getOverlayAlpha$1(ownerState.elevation))})`
  }, theme.vars && {
    backgroundImage: (_theme$vars$overlays = theme.vars.overlays) == null ? void 0 : _theme$vars$overlays[ownerState.elevation]
  }));
});
const Paper = /*#__PURE__*/React__namespace.forwardRef(function Paper(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiPaper'
  });
  const {
      className,
      component = 'div',
      elevation = 1,
      square = false,
      variant = 'elevation'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1l);
  const ownerState = _extends$1({}, props, {
    component,
    elevation,
    square,
    variant
  });
  const classes = useUtilityClasses$N(ownerState);
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    const theme = useTheme$1();
    if (theme.shadows[elevation] === undefined) {
      console.error([`MUI: The elevation provided <Paper elevation={${elevation}}> is not available in the theme.`, `Please make sure that \`theme.shadows[${elevation}]\` is defined.`].join('\n'));
    }
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(PaperRoot, _extends$1({
    as: component,
    ownerState: ownerState,
    className: clsx(classes.root, className),
    ref: ref
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? Paper.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * Shadow depth, corresponds to `dp` in the spec.
   * It accepts values between 0 and 24 inclusive.
   * @default 1
   */
  elevation: chainPropTypes(integerPropType, props => {
    const {
      elevation,
      variant
    } = props;
    if (elevation > 0 && variant === 'outlined') {
      return new Error(`MUI: Combining \`elevation={${elevation}}\` with \`variant="${variant}"\` has no effect. Either use \`elevation={0}\` or use a different \`variant\`.`);
    }
    return null;
  }),
  /**
   * If `true`, rounded corners are disabled.
   * @default false
   */
  square: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The variant to use.
   * @default 'elevation'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['elevation', 'outlined']), propTypesExports.string])
} : void 0;
var Paper$1 = Paper;

function getTypographyUtilityClass(slot) {
  return generateUtilityClass('MuiTypography', slot);
}
generateUtilityClasses('MuiTypography', ['root', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'subtitle1', 'subtitle2', 'body1', 'body2', 'inherit', 'button', 'caption', 'overline', 'alignLeft', 'alignRight', 'alignCenter', 'alignJustify', 'noWrap', 'gutterBottom', 'paragraph']);

const _excluded$1k = ["align", "className", "component", "gutterBottom", "noWrap", "paragraph", "variant", "variantMapping"];
const useUtilityClasses$M = ownerState => {
  const {
    align,
    gutterBottom,
    noWrap,
    paragraph,
    variant,
    classes
  } = ownerState;
  const slots = {
    root: ['root', variant, ownerState.align !== 'inherit' && `align${capitalize(align)}`, gutterBottom && 'gutterBottom', noWrap && 'noWrap', paragraph && 'paragraph']
  };
  return composeClasses(slots, getTypographyUtilityClass, classes);
};
const TypographyRoot = styled$1('span', {
  name: 'MuiTypography',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.variant && styles[ownerState.variant], ownerState.align !== 'inherit' && styles[`align${capitalize(ownerState.align)}`], ownerState.noWrap && styles.noWrap, ownerState.gutterBottom && styles.gutterBottom, ownerState.paragraph && styles.paragraph];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  margin: 0
}, ownerState.variant && theme.typography[ownerState.variant], ownerState.align !== 'inherit' && {
  textAlign: ownerState.align
}, ownerState.noWrap && {
  overflow: 'hidden',
  textOverflow: 'ellipsis',
  whiteSpace: 'nowrap'
}, ownerState.gutterBottom && {
  marginBottom: '0.35em'
}, ownerState.paragraph && {
  marginBottom: 16
}));
const defaultVariantMapping = {
  h1: 'h1',
  h2: 'h2',
  h3: 'h3',
  h4: 'h4',
  h5: 'h5',
  h6: 'h6',
  subtitle1: 'h6',
  subtitle2: 'h6',
  body1: 'p',
  body2: 'p',
  inherit: 'p'
};

// TODO v6: deprecate these color values in v5.x and remove the transformation in v6
const colorTransformations = {
  primary: 'primary.main',
  textPrimary: 'text.primary',
  secondary: 'secondary.main',
  textSecondary: 'text.secondary',
  error: 'error.main'
};
const transformDeprecatedColors = color => {
  return colorTransformations[color] || color;
};
const Typography = /*#__PURE__*/React__namespace.forwardRef(function Typography(inProps, ref) {
  const themeProps = useThemeProps({
    props: inProps,
    name: 'MuiTypography'
  });
  const color = transformDeprecatedColors(themeProps.color);
  const props = extendSxProp(_extends$1({}, themeProps, {
    color
  }));
  const {
      align = 'inherit',
      className,
      component,
      gutterBottom = false,
      noWrap = false,
      paragraph = false,
      variant = 'body1',
      variantMapping = defaultVariantMapping
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1k);
  const ownerState = _extends$1({}, props, {
    align,
    color,
    className,
    component,
    gutterBottom,
    noWrap,
    paragraph,
    variant,
    variantMapping
  });
  const Component = component || (paragraph ? 'p' : variantMapping[variant] || defaultVariantMapping[variant]) || 'span';
  const classes = useUtilityClasses$M(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(TypographyRoot, _extends$1({
    as: Component,
    ref: ref,
    ownerState: ownerState,
    className: clsx(classes.root, className)
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? Typography.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Set the text-align on the component.
   * @default 'inherit'
   */
  align: propTypesExports.oneOf(['center', 'inherit', 'justify', 'left', 'right']),
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, the text will have a bottom margin.
   * @default false
   */
  gutterBottom: propTypesExports.bool,
  /**
   * If `true`, the text will not wrap, but instead will truncate with a text overflow ellipsis.
   *
   * Note that text overflow can only happen with block or inline-block level elements
   * (the element needs to have a width in order to overflow).
   * @default false
   */
  noWrap: propTypesExports.bool,
  /**
   * If `true`, the element will be a paragraph element.
   * @default false
   */
  paragraph: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Applies the theme typography styles.
   * @default 'body1'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['body1', 'body2', 'button', 'caption', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'inherit', 'overline', 'subtitle1', 'subtitle2']), propTypesExports.string]),
  /**
   * The component maps the variant prop to a range of different HTML element types.
   * For instance, subtitle1 to `<h6>`.
   * If you wish to change that mapping, you can provide your own.
   * Alternatively, you can use the `component` prop.
   * @default {
   *   h1: 'h1',
   *   h2: 'h2',
   *   h3: 'h3',
   *   h4: 'h4',
   *   h5: 'h5',
   *   h6: 'h6',
   *   subtitle1: 'h6',
   *   subtitle2: 'h6',
   *   body1: 'p',
   *   body2: 'p',
   *   inherit: 'p',
   * }
   */
  variantMapping: propTypesExports /* @typescript-to-proptypes-ignore */.object
} : void 0;
var Typography$1 = Typography;

function getListItemTextUtilityClass(slot) {
  return generateUtilityClass('MuiListItemText', slot);
}
const listItemTextClasses = generateUtilityClasses('MuiListItemText', ['root', 'multiline', 'dense', 'inset', 'primary', 'secondary']);
var listItemTextClasses$1 = listItemTextClasses;

const _excluded$1j = ["children", "className", "disableTypography", "inset", "primary", "primaryTypographyProps", "secondary", "secondaryTypographyProps"];
const useUtilityClasses$L = ownerState => {
  const {
    classes,
    inset,
    primary,
    secondary,
    dense
  } = ownerState;
  const slots = {
    root: ['root', inset && 'inset', dense && 'dense', primary && secondary && 'multiline'],
    primary: ['primary'],
    secondary: ['secondary']
  };
  return composeClasses(slots, getListItemTextUtilityClass, classes);
};
const ListItemTextRoot = styled$1('div', {
  name: 'MuiListItemText',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [{
      [`& .${listItemTextClasses$1.primary}`]: styles.primary
    }, {
      [`& .${listItemTextClasses$1.secondary}`]: styles.secondary
    }, styles.root, ownerState.inset && styles.inset, ownerState.primary && ownerState.secondary && styles.multiline, ownerState.dense && styles.dense];
  }
})(({
  ownerState
}) => _extends$1({
  flex: '1 1 auto',
  minWidth: 0,
  marginTop: 4,
  marginBottom: 4
}, ownerState.primary && ownerState.secondary && {
  marginTop: 6,
  marginBottom: 6
}, ownerState.inset && {
  paddingLeft: 56
}));
const ListItemText = /*#__PURE__*/React__namespace.forwardRef(function ListItemText(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiListItemText'
  });
  const {
      children,
      className,
      disableTypography = false,
      inset = false,
      primary: primaryProp,
      primaryTypographyProps,
      secondary: secondaryProp,
      secondaryTypographyProps
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1j);
  const {
    dense
  } = React__namespace.useContext(ListContext$1);
  let primary = primaryProp != null ? primaryProp : children;
  let secondary = secondaryProp;
  const ownerState = _extends$1({}, props, {
    disableTypography,
    inset,
    primary: !!primary,
    secondary: !!secondary,
    dense
  });
  const classes = useUtilityClasses$L(ownerState);
  if (primary != null && primary.type !== Typography$1 && !disableTypography) {
    primary = /*#__PURE__*/jsxRuntimeExports.jsx(Typography$1, _extends$1({
      variant: dense ? 'body2' : 'body1',
      className: classes.primary,
      component: primaryTypographyProps != null && primaryTypographyProps.variant ? undefined : 'span',
      display: "block"
    }, primaryTypographyProps, {
      children: primary
    }));
  }
  if (secondary != null && secondary.type !== Typography$1 && !disableTypography) {
    secondary = /*#__PURE__*/jsxRuntimeExports.jsx(Typography$1, _extends$1({
      variant: "body2",
      className: classes.secondary,
      color: "text.secondary",
      display: "block"
    }, secondaryTypographyProps, {
      children: secondary
    }));
  }
  return /*#__PURE__*/jsxRuntimeExports.jsxs(ListItemTextRoot, _extends$1({
    className: clsx(classes.root, className),
    ownerState: ownerState,
    ref: ref
  }, other, {
    children: [primary, secondary]
  }));
});
browser$1.env.NODE_ENV !== "production" ? ListItemText.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Alias for the `primary` prop.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * If `true`, the children won't be wrapped by a Typography component.
   * This can be useful to render an alternative Typography variant by wrapping
   * the `children` (or `primary`) text, and optional `secondary` text
   * with the Typography component.
   * @default false
   */
  disableTypography: propTypesExports.bool,
  /**
   * If `true`, the children are indented.
   * This should be used if there is no left avatar or left icon.
   * @default false
   */
  inset: propTypesExports.bool,
  /**
   * The main content element.
   */
  primary: propTypesExports.node,
  /**
   * These props will be forwarded to the primary typography component
   * (as long as disableTypography is not `true`).
   */
  primaryTypographyProps: propTypesExports.object,
  /**
   * The secondary content element.
   */
  secondary: propTypesExports.node,
  /**
   * These props will be forwarded to the secondary typography component
   * (as long as disableTypography is not `true`).
   */
  secondaryTypographyProps: propTypesExports.object,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var ListItemText$1 = ListItemText;

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;
  _setPrototypeOf(subClass, superClass);
}

var config = {
  disabled: false
};

var timeoutsShape = browser$1.env.NODE_ENV !== 'production' ? propTypesExports.oneOfType([propTypesExports.number, propTypesExports.shape({
  enter: propTypesExports.number,
  exit: propTypesExports.number,
  appear: propTypesExports.number
}).isRequired]) : null;
browser$1.env.NODE_ENV !== 'production' ? propTypesExports.oneOfType([propTypesExports.string, propTypesExports.shape({
  enter: propTypesExports.string,
  exit: propTypesExports.string,
  active: propTypesExports.string
}), propTypesExports.shape({
  enter: propTypesExports.string,
  enterDone: propTypesExports.string,
  enterActive: propTypesExports.string,
  exit: propTypesExports.string,
  exitDone: propTypesExports.string,
  exitActive: propTypesExports.string
})]) : null;

var TransitionGroupContext = React__namespace.default.createContext(null);

var forceReflow = function forceReflow(node) {
  return node.scrollTop;
};

var UNMOUNTED = 'unmounted';
var EXITED = 'exited';
var ENTERING = 'entering';
var ENTERED = 'entered';
var EXITING = 'exiting';
/**
 * The Transition component lets you describe a transition from one component
 * state to another _over time_ with a simple declarative API. Most commonly
 * it's used to animate the mounting and unmounting of a component, but can also
 * be used to describe in-place transition states as well.
 *
 * ---
 *
 * **Note**: `Transition` is a platform-agnostic base component. If you're using
 * transitions in CSS, you'll probably want to use
 * [`CSSTransition`](https://reactcommunity.org/react-transition-group/css-transition)
 * instead. It inherits all the features of `Transition`, but contains
 * additional features necessary to play nice with CSS transitions (hence the
 * name of the component).
 *
 * ---
 *
 * By default the `Transition` component does not alter the behavior of the
 * component it renders, it only tracks "enter" and "exit" states for the
 * components. It's up to you to give meaning and effect to those states. For
 * example we can add styles to a component when it enters or exits:
 *
 * ```jsx
 * import { Transition } from 'react-transition-group';
 *
 * const duration = 300;
 *
 * const defaultStyle = {
 *   transition: `opacity ${duration}ms ease-in-out`,
 *   opacity: 0,
 * }
 *
 * const transitionStyles = {
 *   entering: { opacity: 1 },
 *   entered:  { opacity: 1 },
 *   exiting:  { opacity: 0 },
 *   exited:  { opacity: 0 },
 * };
 *
 * const Fade = ({ in: inProp }) => (
 *   <Transition in={inProp} timeout={duration}>
 *     {state => (
 *       <div style={{
 *         ...defaultStyle,
 *         ...transitionStyles[state]
 *       }}>
 *         I'm a fade Transition!
 *       </div>
 *     )}
 *   </Transition>
 * );
 * ```
 *
 * There are 4 main states a Transition can be in:
 *  - `'entering'`
 *  - `'entered'`
 *  - `'exiting'`
 *  - `'exited'`
 *
 * Transition state is toggled via the `in` prop. When `true` the component
 * begins the "Enter" stage. During this stage, the component will shift from
 * its current transition state, to `'entering'` for the duration of the
 * transition and then to the `'entered'` stage once it's complete. Let's take
 * the following example (we'll use the
 * [useState](https://reactjs.org/docs/hooks-reference.html#usestate) hook):
 *
 * ```jsx
 * function App() {
 *   const [inProp, setInProp] = useState(false);
 *   return (
 *     <div>
 *       <Transition in={inProp} timeout={500}>
 *         {state => (
 *           // ...
 *         )}
 *       </Transition>
 *       <button onClick={() => setInProp(true)}>
 *         Click to Enter
 *       </button>
 *     </div>
 *   );
 * }
 * ```
 *
 * When the button is clicked the component will shift to the `'entering'` state
 * and stay there for 500ms (the value of `timeout`) before it finally switches
 * to `'entered'`.
 *
 * When `in` is `false` the same thing happens except the state moves from
 * `'exiting'` to `'exited'`.
 */

var Transition = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Transition, _React$Component);

  function Transition(props, context) {
    var _this;

    _this = _React$Component.call(this, props, context) || this;
    var parentGroup = context; // In the context of a TransitionGroup all enters are really appears

    var appear = parentGroup && !parentGroup.isMounting ? props.enter : props.appear;
    var initialStatus;
    _this.appearStatus = null;

    if (props.in) {
      if (appear) {
        initialStatus = EXITED;
        _this.appearStatus = ENTERING;
      } else {
        initialStatus = ENTERED;
      }
    } else {
      if (props.unmountOnExit || props.mountOnEnter) {
        initialStatus = UNMOUNTED;
      } else {
        initialStatus = EXITED;
      }
    }

    _this.state = {
      status: initialStatus
    };
    _this.nextCallback = null;
    return _this;
  }

  Transition.getDerivedStateFromProps = function getDerivedStateFromProps(_ref, prevState) {
    var nextIn = _ref.in;

    if (nextIn && prevState.status === UNMOUNTED) {
      return {
        status: EXITED
      };
    }

    return null;
  } // getSnapshotBeforeUpdate(prevProps) {
  //   let nextStatus = null
  //   if (prevProps !== this.props) {
  //     const { status } = this.state
  //     if (this.props.in) {
  //       if (status !== ENTERING && status !== ENTERED) {
  //         nextStatus = ENTERING
  //       }
  //     } else {
  //       if (status === ENTERING || status === ENTERED) {
  //         nextStatus = EXITING
  //       }
  //     }
  //   }
  //   return { nextStatus }
  // }
  ;

  var _proto = Transition.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.updateStatus(true, this.appearStatus);
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var nextStatus = null;

    if (prevProps !== this.props) {
      var status = this.state.status;

      if (this.props.in) {
        if (status !== ENTERING && status !== ENTERED) {
          nextStatus = ENTERING;
        }
      } else {
        if (status === ENTERING || status === ENTERED) {
          nextStatus = EXITING;
        }
      }
    }

    this.updateStatus(false, nextStatus);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.cancelNextCallback();
  };

  _proto.getTimeouts = function getTimeouts() {
    var timeout = this.props.timeout;
    var exit, enter, appear;
    exit = enter = appear = timeout;

    if (timeout != null && typeof timeout !== 'number') {
      exit = timeout.exit;
      enter = timeout.enter; // TODO: remove fallback for next major

      appear = timeout.appear !== undefined ? timeout.appear : enter;
    }

    return {
      exit: exit,
      enter: enter,
      appear: appear
    };
  };

  _proto.updateStatus = function updateStatus(mounting, nextStatus) {
    if (mounting === void 0) {
      mounting = false;
    }

    if (nextStatus !== null) {
      // nextStatus will always be ENTERING or EXITING.
      this.cancelNextCallback();

      if (nextStatus === ENTERING) {
        if (this.props.unmountOnExit || this.props.mountOnEnter) {
          var node = this.props.nodeRef ? this.props.nodeRef.current : ReactDOM__namespace.default.findDOMNode(this); // https://github.com/reactjs/react-transition-group/pull/749
          // With unmountOnExit or mountOnEnter, the enter animation should happen at the transition between `exited` and `entering`.
          // To make the animation happen,  we have to separate each rendering and avoid being processed as batched.

          if (node) forceReflow(node);
        }

        this.performEnter(mounting);
      } else {
        this.performExit();
      }
    } else if (this.props.unmountOnExit && this.state.status === EXITED) {
      this.setState({
        status: UNMOUNTED
      });
    }
  };

  _proto.performEnter = function performEnter(mounting) {
    var _this2 = this;

    var enter = this.props.enter;
    var appearing = this.context ? this.context.isMounting : mounting;

    var _ref2 = this.props.nodeRef ? [appearing] : [ReactDOM__namespace.default.findDOMNode(this), appearing],
        maybeNode = _ref2[0],
        maybeAppearing = _ref2[1];

    var timeouts = this.getTimeouts();
    var enterTimeout = appearing ? timeouts.appear : timeouts.enter; // no enter animation skip right to ENTERED
    // if we are mounting and running this it means appear _must_ be set

    if (!mounting && !enter || config.disabled) {
      this.safeSetState({
        status: ENTERED
      }, function () {
        _this2.props.onEntered(maybeNode);
      });
      return;
    }

    this.props.onEnter(maybeNode, maybeAppearing);
    this.safeSetState({
      status: ENTERING
    }, function () {
      _this2.props.onEntering(maybeNode, maybeAppearing);

      _this2.onTransitionEnd(enterTimeout, function () {
        _this2.safeSetState({
          status: ENTERED
        }, function () {
          _this2.props.onEntered(maybeNode, maybeAppearing);
        });
      });
    });
  };

  _proto.performExit = function performExit() {
    var _this3 = this;

    var exit = this.props.exit;
    var timeouts = this.getTimeouts();
    var maybeNode = this.props.nodeRef ? undefined : ReactDOM__namespace.default.findDOMNode(this); // no exit animation skip right to EXITED

    if (!exit || config.disabled) {
      this.safeSetState({
        status: EXITED
      }, function () {
        _this3.props.onExited(maybeNode);
      });
      return;
    }

    this.props.onExit(maybeNode);
    this.safeSetState({
      status: EXITING
    }, function () {
      _this3.props.onExiting(maybeNode);

      _this3.onTransitionEnd(timeouts.exit, function () {
        _this3.safeSetState({
          status: EXITED
        }, function () {
          _this3.props.onExited(maybeNode);
        });
      });
    });
  };

  _proto.cancelNextCallback = function cancelNextCallback() {
    if (this.nextCallback !== null) {
      this.nextCallback.cancel();
      this.nextCallback = null;
    }
  };

  _proto.safeSetState = function safeSetState(nextState, callback) {
    // This shouldn't be necessary, but there are weird race conditions with
    // setState callbacks and unmounting in testing, so always make sure that
    // we can cancel any pending setState callbacks after we unmount.
    callback = this.setNextCallback(callback);
    this.setState(nextState, callback);
  };

  _proto.setNextCallback = function setNextCallback(callback) {
    var _this4 = this;

    var active = true;

    this.nextCallback = function (event) {
      if (active) {
        active = false;
        _this4.nextCallback = null;
        callback(event);
      }
    };

    this.nextCallback.cancel = function () {
      active = false;
    };

    return this.nextCallback;
  };

  _proto.onTransitionEnd = function onTransitionEnd(timeout, handler) {
    this.setNextCallback(handler);
    var node = this.props.nodeRef ? this.props.nodeRef.current : ReactDOM__namespace.default.findDOMNode(this);
    var doesNotHaveTimeoutOrListener = timeout == null && !this.props.addEndListener;

    if (!node || doesNotHaveTimeoutOrListener) {
      setTimeout(this.nextCallback, 0);
      return;
    }

    if (this.props.addEndListener) {
      var _ref3 = this.props.nodeRef ? [this.nextCallback] : [node, this.nextCallback],
          maybeNode = _ref3[0],
          maybeNextCallback = _ref3[1];

      this.props.addEndListener(maybeNode, maybeNextCallback);
    }

    if (timeout != null) {
      setTimeout(this.nextCallback, timeout);
    }
  };

  _proto.render = function render() {
    var status = this.state.status;

    if (status === UNMOUNTED) {
      return null;
    }

    var _this$props = this.props,
        children = _this$props.children;
        _this$props.in;
        _this$props.mountOnEnter;
        _this$props.unmountOnExit;
        _this$props.appear;
        _this$props.enter;
        _this$props.exit;
        _this$props.timeout;
        _this$props.addEndListener;
        _this$props.onEnter;
        _this$props.onEntering;
        _this$props.onEntered;
        _this$props.onExit;
        _this$props.onExiting;
        _this$props.onExited;
        _this$props.nodeRef;
        var childProps = _objectWithoutPropertiesLoose(_this$props, ["children", "in", "mountOnEnter", "unmountOnExit", "appear", "enter", "exit", "timeout", "addEndListener", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited", "nodeRef"]);

    return (
      /*#__PURE__*/
      // allows for nested Transitions
      React__namespace.default.createElement(TransitionGroupContext.Provider, {
        value: null
      }, typeof children === 'function' ? children(status, childProps) : React__namespace.default.cloneElement(React__namespace.default.Children.only(children), childProps))
    );
  };

  return Transition;
}(React__namespace.default.Component);

Transition.contextType = TransitionGroupContext;
Transition.propTypes = browser$1.env.NODE_ENV !== "production" ? {
  /**
   * A React reference to DOM element that need to transition:
   * https://stackoverflow.com/a/51127130/4671932
   *
   *   - When `nodeRef` prop is used, `node` is not passed to callback functions
   *      (e.g. `onEnter`) because user already has direct access to the node.
   *   - When changing `key` prop of `Transition` in a `TransitionGroup` a new
   *     `nodeRef` need to be provided to `Transition` with changed `key` prop
   *     (see
   *     [test/CSSTransition-test.js](https://github.com/reactjs/react-transition-group/blob/13435f897b3ab71f6e19d724f145596f5910581c/test/CSSTransition-test.js#L362-L437)).
   */
  nodeRef: propTypesExports.shape({
    current: typeof Element === 'undefined' ? propTypesExports.any : function (propValue, key, componentName, location, propFullName, secret) {
      var value = propValue[key];
      return propTypesExports.instanceOf(value && 'ownerDocument' in value ? value.ownerDocument.defaultView.Element : Element)(propValue, key, componentName, location, propFullName, secret);
    }
  }),

  /**
   * A `function` child can be used instead of a React element. This function is
   * called with the current transition status (`'entering'`, `'entered'`,
   * `'exiting'`, `'exited'`), which can be used to apply context
   * specific props to a component.
   *
   * ```jsx
   * <Transition in={this.state.in} timeout={150}>
   *   {state => (
   *     <MyComponent className={`fade fade-${state}`} />
   *   )}
   * </Transition>
   * ```
   */
  children: propTypesExports.oneOfType([propTypesExports.func.isRequired, propTypesExports.element.isRequired]).isRequired,

  /**
   * Show the component; triggers the enter or exit states
   */
  in: propTypesExports.bool,

  /**
   * By default the child component is mounted immediately along with
   * the parent `Transition` component. If you want to "lazy mount" the component on the
   * first `in={true}` you can set `mountOnEnter`. After the first enter transition the component will stay
   * mounted, even on "exited", unless you also specify `unmountOnExit`.
   */
  mountOnEnter: propTypesExports.bool,

  /**
   * By default the child component stays mounted after it reaches the `'exited'` state.
   * Set `unmountOnExit` if you'd prefer to unmount the component after it finishes exiting.
   */
  unmountOnExit: propTypesExports.bool,

  /**
   * By default the child component does not perform the enter transition when
   * it first mounts, regardless of the value of `in`. If you want this
   * behavior, set both `appear` and `in` to `true`.
   *
   * > **Note**: there are no special appear states like `appearing`/`appeared`, this prop
   * > only adds an additional enter transition. However, in the
   * > `<CSSTransition>` component that first enter transition does result in
   * > additional `.appear-*` classes, that way you can choose to style it
   * > differently.
   */
  appear: propTypesExports.bool,

  /**
   * Enable or disable enter transitions.
   */
  enter: propTypesExports.bool,

  /**
   * Enable or disable exit transitions.
   */
  exit: propTypesExports.bool,

  /**
   * The duration of the transition, in milliseconds.
   * Required unless `addEndListener` is provided.
   *
   * You may specify a single timeout for all transitions:
   *
   * ```jsx
   * timeout={500}
   * ```
   *
   * or individually:
   *
   * ```jsx
   * timeout={{
   *  appear: 500,
   *  enter: 300,
   *  exit: 500,
   * }}
   * ```
   *
   * - `appear` defaults to the value of `enter`
   * - `enter` defaults to `0`
   * - `exit` defaults to `0`
   *
   * @type {number | { enter?: number, exit?: number, appear?: number }}
   */
  timeout: function timeout(props) {
    var pt = timeoutsShape;
    if (!props.addEndListener) pt = pt.isRequired;

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return pt.apply(void 0, [props].concat(args));
  },

  /**
   * Add a custom transition end trigger. Called with the transitioning
   * DOM node and a `done` callback. Allows for more fine grained transition end
   * logic. Timeouts are still used as a fallback if provided.
   *
   * **Note**: when `nodeRef` prop is passed, `node` is not passed.
   *
   * ```jsx
   * addEndListener={(node, done) => {
   *   // use the css transitionend event to mark the finish of a transition
   *   node.addEventListener('transitionend', done, false);
   * }}
   * ```
   */
  addEndListener: propTypesExports.func,

  /**
   * Callback fired before the "entering" status is applied. An extra parameter
   * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
   *
   * **Note**: when `nodeRef` prop is passed, `node` is not passed.
   *
   * @type Function(node: HtmlElement, isAppearing: bool) -> void
   */
  onEnter: propTypesExports.func,

  /**
   * Callback fired after the "entering" status is applied. An extra parameter
   * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
   *
   * **Note**: when `nodeRef` prop is passed, `node` is not passed.
   *
   * @type Function(node: HtmlElement, isAppearing: bool)
   */
  onEntering: propTypesExports.func,

  /**
   * Callback fired after the "entered" status is applied. An extra parameter
   * `isAppearing` is supplied to indicate if the enter stage is occurring on the initial mount
   *
   * **Note**: when `nodeRef` prop is passed, `node` is not passed.
   *
   * @type Function(node: HtmlElement, isAppearing: bool) -> void
   */
  onEntered: propTypesExports.func,

  /**
   * Callback fired before the "exiting" status is applied.
   *
   * **Note**: when `nodeRef` prop is passed, `node` is not passed.
   *
   * @type Function(node: HtmlElement) -> void
   */
  onExit: propTypesExports.func,

  /**
   * Callback fired after the "exiting" status is applied.
   *
   * **Note**: when `nodeRef` prop is passed, `node` is not passed.
   *
   * @type Function(node: HtmlElement) -> void
   */
  onExiting: propTypesExports.func,

  /**
   * Callback fired after the "exited" status is applied.
   *
   * **Note**: when `nodeRef` prop is passed, `node` is not passed
   *
   * @type Function(node: HtmlElement) -> void
   */
  onExited: propTypesExports.func
} : {}; // Name the function so it is clearer in the documentation

function noop$1() {}

Transition.defaultProps = {
  in: false,
  mountOnEnter: false,
  unmountOnExit: false,
  appear: false,
  enter: true,
  exit: true,
  onEnter: noop$1,
  onEntering: noop$1,
  onEntered: noop$1,
  onExit: noop$1,
  onExiting: noop$1,
  onExited: noop$1
};
Transition.UNMOUNTED = UNMOUNTED;
Transition.EXITED = EXITED;
Transition.ENTERING = ENTERING;
Transition.ENTERED = ENTERED;
Transition.EXITING = EXITING;
var Transition$1 = Transition;

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}

/**
 * Given `this.props.children`, return an object mapping key to child.
 *
 * @param {*} children `this.props.children`
 * @return {object} Mapping of key to child
 */

function getChildMapping(children, mapFn) {
  var mapper = function mapper(child) {
    return mapFn && React.isValidElement(child) ? mapFn(child) : child;
  };

  var result = Object.create(null);
  if (children) React.Children.map(children, function (c) {
    return c;
  }).forEach(function (child) {
    // run the map function here instead so that the key is the computed one
    result[child.key] = mapper(child);
  });
  return result;
}
/**
 * When you're adding or removing children some may be added or removed in the
 * same render pass. We want to show *both* since we want to simultaneously
 * animate elements in and out. This function takes a previous set of keys
 * and a new set of keys and merges them with its best guess of the correct
 * ordering. In the future we may expose some of the utilities in
 * ReactMultiChild to make this easy, but for now React itself does not
 * directly have this concept of the union of prevChildren and nextChildren
 * so we implement it here.
 *
 * @param {object} prev prev children as returned from
 * `ReactTransitionChildMapping.getChildMapping()`.
 * @param {object} next next children as returned from
 * `ReactTransitionChildMapping.getChildMapping()`.
 * @return {object} a key set that contains all keys in `prev` and all keys
 * in `next` in a reasonable order.
 */

function mergeChildMappings(prev, next) {
  prev = prev || {};
  next = next || {};

  function getValueForKey(key) {
    return key in next ? next[key] : prev[key];
  } // For each key of `next`, the list of keys to insert before that key in
  // the combined list


  var nextKeysPending = Object.create(null);
  var pendingKeys = [];

  for (var prevKey in prev) {
    if (prevKey in next) {
      if (pendingKeys.length) {
        nextKeysPending[prevKey] = pendingKeys;
        pendingKeys = [];
      }
    } else {
      pendingKeys.push(prevKey);
    }
  }

  var i;
  var childMapping = {};

  for (var nextKey in next) {
    if (nextKeysPending[nextKey]) {
      for (i = 0; i < nextKeysPending[nextKey].length; i++) {
        var pendingNextKey = nextKeysPending[nextKey][i];
        childMapping[nextKeysPending[nextKey][i]] = getValueForKey(pendingNextKey);
      }
    }

    childMapping[nextKey] = getValueForKey(nextKey);
  } // Finally, add the keys which didn't appear before any key in `next`


  for (i = 0; i < pendingKeys.length; i++) {
    childMapping[pendingKeys[i]] = getValueForKey(pendingKeys[i]);
  }

  return childMapping;
}

function getProp(child, prop, props) {
  return props[prop] != null ? props[prop] : child.props[prop];
}

function getInitialChildMapping(props, onExited) {
  return getChildMapping(props.children, function (child) {
    return React.cloneElement(child, {
      onExited: onExited.bind(null, child),
      in: true,
      appear: getProp(child, 'appear', props),
      enter: getProp(child, 'enter', props),
      exit: getProp(child, 'exit', props)
    });
  });
}
function getNextChildMapping(nextProps, prevChildMapping, onExited) {
  var nextChildMapping = getChildMapping(nextProps.children);
  var children = mergeChildMappings(prevChildMapping, nextChildMapping);
  Object.keys(children).forEach(function (key) {
    var child = children[key];
    if (!React.isValidElement(child)) return;
    var hasPrev = (key in prevChildMapping);
    var hasNext = (key in nextChildMapping);
    var prevChild = prevChildMapping[key];
    var isLeaving = React.isValidElement(prevChild) && !prevChild.props.in; // item is new (entering)

    if (hasNext && (!hasPrev || isLeaving)) {
      // console.log('entering', key)
      children[key] = React.cloneElement(child, {
        onExited: onExited.bind(null, child),
        in: true,
        exit: getProp(child, 'exit', nextProps),
        enter: getProp(child, 'enter', nextProps)
      });
    } else if (!hasNext && hasPrev && !isLeaving) {
      // item is old (exiting)
      // console.log('leaving', key)
      children[key] = React.cloneElement(child, {
        in: false
      });
    } else if (hasNext && hasPrev && React.isValidElement(prevChild)) {
      // item hasn't changed transition states
      // copy over the last transition props;
      // console.log('unchanged', key)
      children[key] = React.cloneElement(child, {
        onExited: onExited.bind(null, child),
        in: prevChild.props.in,
        exit: getProp(child, 'exit', nextProps),
        enter: getProp(child, 'enter', nextProps)
      });
    }
  });
  return children;
}

var values = Object.values || function (obj) {
  return Object.keys(obj).map(function (k) {
    return obj[k];
  });
};

var defaultProps = {
  component: 'div',
  childFactory: function childFactory(child) {
    return child;
  }
};
/**
 * The `<TransitionGroup>` component manages a set of transition components
 * (`<Transition>` and `<CSSTransition>`) in a list. Like with the transition
 * components, `<TransitionGroup>` is a state machine for managing the mounting
 * and unmounting of components over time.
 *
 * Consider the example below. As items are removed or added to the TodoList the
 * `in` prop is toggled automatically by the `<TransitionGroup>`.
 *
 * Note that `<TransitionGroup>`  does not define any animation behavior!
 * Exactly _how_ a list item animates is up to the individual transition
 * component. This means you can mix and match animations across different list
 * items.
 */

var TransitionGroup = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(TransitionGroup, _React$Component);

  function TransitionGroup(props, context) {
    var _this;

    _this = _React$Component.call(this, props, context) || this;

    var handleExited = _this.handleExited.bind(_assertThisInitialized(_this)); // Initial children should all be entering, dependent on appear


    _this.state = {
      contextValue: {
        isMounting: true
      },
      handleExited: handleExited,
      firstRender: true
    };
    return _this;
  }

  var _proto = TransitionGroup.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.mounted = true;
    this.setState({
      contextValue: {
        isMounting: false
      }
    });
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.mounted = false;
  };

  TransitionGroup.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, _ref) {
    var prevChildMapping = _ref.children,
        handleExited = _ref.handleExited,
        firstRender = _ref.firstRender;
    return {
      children: firstRender ? getInitialChildMapping(nextProps, handleExited) : getNextChildMapping(nextProps, prevChildMapping, handleExited),
      firstRender: false
    };
  } // node is `undefined` when user provided `nodeRef` prop
  ;

  _proto.handleExited = function handleExited(child, node) {
    var currentChildMapping = getChildMapping(this.props.children);
    if (child.key in currentChildMapping) return;

    if (child.props.onExited) {
      child.props.onExited(node);
    }

    if (this.mounted) {
      this.setState(function (state) {
        var children = _extends$1({}, state.children);

        delete children[child.key];
        return {
          children: children
        };
      });
    }
  };

  _proto.render = function render() {
    var _this$props = this.props,
        Component = _this$props.component,
        childFactory = _this$props.childFactory,
        props = _objectWithoutPropertiesLoose(_this$props, ["component", "childFactory"]);

    var contextValue = this.state.contextValue;
    var children = values(this.state.children).map(childFactory);
    delete props.appear;
    delete props.enter;
    delete props.exit;

    if (Component === null) {
      return /*#__PURE__*/React__namespace.default.createElement(TransitionGroupContext.Provider, {
        value: contextValue
      }, children);
    }

    return /*#__PURE__*/React__namespace.default.createElement(TransitionGroupContext.Provider, {
      value: contextValue
    }, /*#__PURE__*/React__namespace.default.createElement(Component, props, children));
  };

  return TransitionGroup;
}(React__namespace.default.Component);

TransitionGroup.propTypes = browser$1.env.NODE_ENV !== "production" ? {
  /**
   * `<TransitionGroup>` renders a `<div>` by default. You can change this
   * behavior by providing a `component` prop.
   * If you use React v16+ and would like to avoid a wrapping `<div>` element
   * you can pass in `component={null}`. This is useful if the wrapping div
   * borks your css styles.
   */
  component: propTypesExports.any,

  /**
   * A set of `<Transition>` components, that are toggled `in` and out as they
   * leave. the `<TransitionGroup>` will inject specific transition props, so
   * remember to spread them through if you are wrapping the `<Transition>` as
   * with our `<Fade>` example.
   *
   * While this component is meant for multiple `Transition` or `CSSTransition`
   * children, sometimes you may want to have a single transition child with
   * content that you want to be transitioned out and in when you change it
   * (e.g. routes, images etc.) In that case you can change the `key` prop of
   * the transition child as you change its content, this will cause
   * `TransitionGroup` to transition the child out and back in.
   */
  children: propTypesExports.node,

  /**
   * A convenience prop that enables or disables appear animations
   * for all children. Note that specifying this will override any defaults set
   * on individual children Transitions.
   */
  appear: propTypesExports.bool,

  /**
   * A convenience prop that enables or disables enter animations
   * for all children. Note that specifying this will override any defaults set
   * on individual children Transitions.
   */
  enter: propTypesExports.bool,

  /**
   * A convenience prop that enables or disables exit animations
   * for all children. Note that specifying this will override any defaults set
   * on individual children Transitions.
   */
  exit: propTypesExports.bool,

  /**
   * You may need to apply reactive updates to a child as it is exiting.
   * This is generally done by using `cloneElement` however in the case of an exiting
   * child the element has already been removed and not accessible to the consumer.
   *
   * If you do need to update a child as it leaves you can provide a `childFactory`
   * to wrap every child, even the ones that are leaving.
   *
   * @type Function(child: ReactElement) -> ReactElement
   */
  childFactory: propTypesExports.func
} : {};
TransitionGroup.defaultProps = defaultProps;
var TransitionGroup$1 = TransitionGroup;

function Ripple(props) {
  const {
    className,
    classes,
    pulsate = false,
    rippleX,
    rippleY,
    rippleSize,
    in: inProp,
    onExited,
    timeout
  } = props;
  const [leaving, setLeaving] = React__namespace.useState(false);
  const rippleClassName = clsx(className, classes.ripple, classes.rippleVisible, pulsate && classes.ripplePulsate);
  const rippleStyles = {
    width: rippleSize,
    height: rippleSize,
    top: -(rippleSize / 2) + rippleY,
    left: -(rippleSize / 2) + rippleX
  };
  const childClassName = clsx(classes.child, leaving && classes.childLeaving, pulsate && classes.childPulsate);
  if (!inProp && !leaving) {
    setLeaving(true);
  }
  React__namespace.useEffect(() => {
    if (!inProp && onExited != null) {
      // react-transition-group#onExited
      const timeoutId = setTimeout(onExited, timeout);
      return () => {
        clearTimeout(timeoutId);
      };
    }
    return undefined;
  }, [onExited, inProp, timeout]);
  return /*#__PURE__*/jsxRuntimeExports.jsx("span", {
    className: rippleClassName,
    style: rippleStyles,
    children: /*#__PURE__*/jsxRuntimeExports.jsx("span", {
      className: childClassName
    })
  });
}
browser$1.env.NODE_ENV !== "production" ? Ripple.propTypes = {
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypesExports.object.isRequired,
  className: propTypesExports.string,
  /**
   * @ignore - injected from TransitionGroup
   */
  in: propTypesExports.bool,
  /**
   * @ignore - injected from TransitionGroup
   */
  onExited: propTypesExports.func,
  /**
   * If `true`, the ripple pulsates, typically indicating the keyboard focus state of an element.
   */
  pulsate: propTypesExports.bool,
  /**
   * Diameter of the ripple.
   */
  rippleSize: propTypesExports.number,
  /**
   * Horizontal position of the ripple center.
   */
  rippleX: propTypesExports.number,
  /**
   * Vertical position of the ripple center.
   */
  rippleY: propTypesExports.number,
  /**
   * exit delay
   */
  timeout: propTypesExports.number.isRequired
} : void 0;

const touchRippleClasses = generateUtilityClasses('MuiTouchRipple', ['root', 'ripple', 'rippleVisible', 'ripplePulsate', 'child', 'childLeaving', 'childPulsate']);
var touchRippleClasses$1 = touchRippleClasses;

const _excluded$1i = ["center", "classes", "className"];
let _$2 = t => t,
  _t$2,
  _t2$2,
  _t3$2,
  _t4$2;
const DURATION = 550;
const DELAY_RIPPLE = 80;
const enterKeyframe = react.keyframes(_t$2 || (_t$2 = _$2`
  0% {
    transform: scale(0);
    opacity: 0.1;
  }

  100% {
    transform: scale(1);
    opacity: 0.3;
  }
`));
const exitKeyframe = react.keyframes(_t2$2 || (_t2$2 = _$2`
  0% {
    opacity: 1;
  }

  100% {
    opacity: 0;
  }
`));
const pulsateKeyframe = react.keyframes(_t3$2 || (_t3$2 = _$2`
  0% {
    transform: scale(1);
  }

  50% {
    transform: scale(0.92);
  }

  100% {
    transform: scale(1);
  }
`));
const TouchRippleRoot = styled$1('span', {
  name: 'MuiTouchRipple',
  slot: 'Root'
})({
  overflow: 'hidden',
  pointerEvents: 'none',
  position: 'absolute',
  zIndex: 0,
  top: 0,
  right: 0,
  bottom: 0,
  left: 0,
  borderRadius: 'inherit'
});

// This `styled()` function invokes keyframes. `styled-components` only supports keyframes
// in string templates. Do not convert these styles in JS object as it will break.
const TouchRippleRipple = styled$1(Ripple, {
  name: 'MuiTouchRipple',
  slot: 'Ripple'
})(_t4$2 || (_t4$2 = _$2`
  opacity: 0;
  position: absolute;

  &.${0} {
    opacity: 0.3;
    transform: scale(1);
    animation-name: ${0};
    animation-duration: ${0}ms;
    animation-timing-function: ${0};
  }

  &.${0} {
    animation-duration: ${0}ms;
  }

  & .${0} {
    opacity: 1;
    display: block;
    width: 100%;
    height: 100%;
    border-radius: 50%;
    background-color: currentColor;
  }

  & .${0} {
    opacity: 0;
    animation-name: ${0};
    animation-duration: ${0}ms;
    animation-timing-function: ${0};
  }

  & .${0} {
    position: absolute;
    /* @noflip */
    left: 0px;
    top: 0;
    animation-name: ${0};
    animation-duration: 2500ms;
    animation-timing-function: ${0};
    animation-iteration-count: infinite;
    animation-delay: 200ms;
  }
`), touchRippleClasses$1.rippleVisible, enterKeyframe, DURATION, ({
  theme
}) => theme.transitions.easing.easeInOut, touchRippleClasses$1.ripplePulsate, ({
  theme
}) => theme.transitions.duration.shorter, touchRippleClasses$1.child, touchRippleClasses$1.childLeaving, exitKeyframe, DURATION, ({
  theme
}) => theme.transitions.easing.easeInOut, touchRippleClasses$1.childPulsate, pulsateKeyframe, ({
  theme
}) => theme.transitions.easing.easeInOut);

/**
 * @ignore - internal component.
 *
 * TODO v5: Make private
 */
const TouchRipple = /*#__PURE__*/React__namespace.forwardRef(function TouchRipple(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTouchRipple'
  });
  const {
      center: centerProp = false,
      classes = {},
      className
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1i);
  const [ripples, setRipples] = React__namespace.useState([]);
  const nextKey = React__namespace.useRef(0);
  const rippleCallback = React__namespace.useRef(null);
  React__namespace.useEffect(() => {
    if (rippleCallback.current) {
      rippleCallback.current();
      rippleCallback.current = null;
    }
  }, [ripples]);

  // Used to filter out mouse emulated events on mobile.
  const ignoringMouseDown = React__namespace.useRef(false);
  // We use a timer in order to only show the ripples for touch "click" like events.
  // We don't want to display the ripple for touch scroll events.
  const startTimer = React__namespace.useRef(null);

  // This is the hook called once the previous timeout is ready.
  const startTimerCommit = React__namespace.useRef(null);
  const container = React__namespace.useRef(null);
  React__namespace.useEffect(() => {
    return () => {
      clearTimeout(startTimer.current);
    };
  }, []);
  const startCommit = React__namespace.useCallback(params => {
    const {
      pulsate,
      rippleX,
      rippleY,
      rippleSize,
      cb
    } = params;
    setRipples(oldRipples => [...oldRipples, /*#__PURE__*/jsxRuntimeExports.jsx(TouchRippleRipple, {
      classes: {
        ripple: clsx(classes.ripple, touchRippleClasses$1.ripple),
        rippleVisible: clsx(classes.rippleVisible, touchRippleClasses$1.rippleVisible),
        ripplePulsate: clsx(classes.ripplePulsate, touchRippleClasses$1.ripplePulsate),
        child: clsx(classes.child, touchRippleClasses$1.child),
        childLeaving: clsx(classes.childLeaving, touchRippleClasses$1.childLeaving),
        childPulsate: clsx(classes.childPulsate, touchRippleClasses$1.childPulsate)
      },
      timeout: DURATION,
      pulsate: pulsate,
      rippleX: rippleX,
      rippleY: rippleY,
      rippleSize: rippleSize
    }, nextKey.current)]);
    nextKey.current += 1;
    rippleCallback.current = cb;
  }, [classes]);
  const start = React__namespace.useCallback((event = {}, options = {}, cb = () => {}) => {
    const {
      pulsate = false,
      center = centerProp || options.pulsate,
      fakeElement = false // For test purposes
    } = options;
    if ((event == null ? void 0 : event.type) === 'mousedown' && ignoringMouseDown.current) {
      ignoringMouseDown.current = false;
      return;
    }
    if ((event == null ? void 0 : event.type) === 'touchstart') {
      ignoringMouseDown.current = true;
    }
    const element = fakeElement ? null : container.current;
    const rect = element ? element.getBoundingClientRect() : {
      width: 0,
      height: 0,
      left: 0,
      top: 0
    };

    // Get the size of the ripple
    let rippleX;
    let rippleY;
    let rippleSize;
    if (center || event === undefined || event.clientX === 0 && event.clientY === 0 || !event.clientX && !event.touches) {
      rippleX = Math.round(rect.width / 2);
      rippleY = Math.round(rect.height / 2);
    } else {
      const {
        clientX,
        clientY
      } = event.touches && event.touches.length > 0 ? event.touches[0] : event;
      rippleX = Math.round(clientX - rect.left);
      rippleY = Math.round(clientY - rect.top);
    }
    if (center) {
      rippleSize = Math.sqrt((2 * rect.width ** 2 + rect.height ** 2) / 3);

      // For some reason the animation is broken on Mobile Chrome if the size is even.
      if (rippleSize % 2 === 0) {
        rippleSize += 1;
      }
    } else {
      const sizeX = Math.max(Math.abs((element ? element.clientWidth : 0) - rippleX), rippleX) * 2 + 2;
      const sizeY = Math.max(Math.abs((element ? element.clientHeight : 0) - rippleY), rippleY) * 2 + 2;
      rippleSize = Math.sqrt(sizeX ** 2 + sizeY ** 2);
    }

    // Touche devices
    if (event != null && event.touches) {
      // check that this isn't another touchstart due to multitouch
      // otherwise we will only clear a single timer when unmounting while two
      // are running
      if (startTimerCommit.current === null) {
        // Prepare the ripple effect.
        startTimerCommit.current = () => {
          startCommit({
            pulsate,
            rippleX,
            rippleY,
            rippleSize,
            cb
          });
        };
        // Delay the execution of the ripple effect.
        startTimer.current = setTimeout(() => {
          if (startTimerCommit.current) {
            startTimerCommit.current();
            startTimerCommit.current = null;
          }
        }, DELAY_RIPPLE); // We have to make a tradeoff with this value.
      }
    } else {
      startCommit({
        pulsate,
        rippleX,
        rippleY,
        rippleSize,
        cb
      });
    }
  }, [centerProp, startCommit]);
  const pulsate = React__namespace.useCallback(() => {
    start({}, {
      pulsate: true
    });
  }, [start]);
  const stop = React__namespace.useCallback((event, cb) => {
    clearTimeout(startTimer.current);

    // The touch interaction occurs too quickly.
    // We still want to show ripple effect.
    if ((event == null ? void 0 : event.type) === 'touchend' && startTimerCommit.current) {
      startTimerCommit.current();
      startTimerCommit.current = null;
      startTimer.current = setTimeout(() => {
        stop(event, cb);
      });
      return;
    }
    startTimerCommit.current = null;
    setRipples(oldRipples => {
      if (oldRipples.length > 0) {
        return oldRipples.slice(1);
      }
      return oldRipples;
    });
    rippleCallback.current = cb;
  }, []);
  React__namespace.useImperativeHandle(ref, () => ({
    pulsate,
    start,
    stop
  }), [pulsate, start, stop]);
  return /*#__PURE__*/jsxRuntimeExports.jsx(TouchRippleRoot, _extends$1({
    className: clsx(touchRippleClasses$1.root, classes.root, className),
    ref: container
  }, other, {
    children: /*#__PURE__*/jsxRuntimeExports.jsx(TransitionGroup$1, {
      component: null,
      exit: true,
      children: ripples
    })
  }));
});
browser$1.env.NODE_ENV !== "production" ? TouchRipple.propTypes = {
  /**
   * If `true`, the ripple starts at the center of the component
   * rather than at the point of interaction.
   */
  center: propTypesExports.bool,
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string
} : void 0;
var TouchRipple$1 = TouchRipple;

function getButtonBaseUtilityClass(slot) {
  return generateUtilityClass('MuiButtonBase', slot);
}
const buttonBaseClasses = generateUtilityClasses('MuiButtonBase', ['root', 'disabled', 'focusVisible']);
var buttonBaseClasses$1 = buttonBaseClasses;

const _excluded$1h = ["action", "centerRipple", "children", "className", "component", "disabled", "disableRipple", "disableTouchRipple", "focusRipple", "focusVisibleClassName", "LinkComponent", "onBlur", "onClick", "onContextMenu", "onDragLeave", "onFocus", "onFocusVisible", "onKeyDown", "onKeyUp", "onMouseDown", "onMouseLeave", "onMouseUp", "onTouchEnd", "onTouchMove", "onTouchStart", "tabIndex", "TouchRippleProps", "touchRippleRef", "type"];
const useUtilityClasses$K = ownerState => {
  const {
    disabled,
    focusVisible,
    focusVisibleClassName,
    classes
  } = ownerState;
  const slots = {
    root: ['root', disabled && 'disabled', focusVisible && 'focusVisible']
  };
  const composedClasses = composeClasses(slots, getButtonBaseUtilityClass, classes);
  if (focusVisible && focusVisibleClassName) {
    composedClasses.root += ` ${focusVisibleClassName}`;
  }
  return composedClasses;
};
const ButtonBaseRoot = styled$1('button', {
  name: 'MuiButtonBase',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({
  display: 'inline-flex',
  alignItems: 'center',
  justifyContent: 'center',
  position: 'relative',
  boxSizing: 'border-box',
  WebkitTapHighlightColor: 'transparent',
  backgroundColor: 'transparent',
  // Reset default value
  // We disable the focus ring for mouse, touch and keyboard users.
  outline: 0,
  border: 0,
  margin: 0,
  // Remove the margin in Safari
  borderRadius: 0,
  padding: 0,
  // Remove the padding in Firefox
  cursor: 'pointer',
  userSelect: 'none',
  verticalAlign: 'middle',
  MozAppearance: 'none',
  // Reset
  WebkitAppearance: 'none',
  // Reset
  textDecoration: 'none',
  // So we take precedent over the style of a native <a /> element.
  color: 'inherit',
  '&::-moz-focus-inner': {
    borderStyle: 'none' // Remove Firefox dotted outline.
  },

  [`&.${buttonBaseClasses$1.disabled}`]: {
    pointerEvents: 'none',
    // Disable link interactions
    cursor: 'default'
  },
  '@media print': {
    colorAdjust: 'exact'
  }
});

/**
 * `ButtonBase` contains as few styles as possible.
 * It aims to be a simple building block for creating a button.
 * It contains a load of style reset and some focus/ripple logic.
 */
const ButtonBase = /*#__PURE__*/React__namespace.forwardRef(function ButtonBase(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiButtonBase'
  });
  const {
      action,
      centerRipple = false,
      children,
      className,
      component = 'button',
      disabled = false,
      disableRipple = false,
      disableTouchRipple = false,
      focusRipple = false,
      LinkComponent = 'a',
      onBlur,
      onClick,
      onContextMenu,
      onDragLeave,
      onFocus,
      onFocusVisible,
      onKeyDown,
      onKeyUp,
      onMouseDown,
      onMouseLeave,
      onMouseUp,
      onTouchEnd,
      onTouchMove,
      onTouchStart,
      tabIndex = 0,
      TouchRippleProps,
      touchRippleRef,
      type
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1h);
  const buttonRef = React__namespace.useRef(null);
  const rippleRef = React__namespace.useRef(null);
  const handleRippleRef = useForkRef(rippleRef, touchRippleRef);
  const {
    isFocusVisibleRef,
    onFocus: handleFocusVisible,
    onBlur: handleBlurVisible,
    ref: focusVisibleRef
  } = useIsFocusVisible();
  const [focusVisible, setFocusVisible] = React__namespace.useState(false);
  if (disabled && focusVisible) {
    setFocusVisible(false);
  }
  React__namespace.useImperativeHandle(action, () => ({
    focusVisible: () => {
      setFocusVisible(true);
      buttonRef.current.focus();
    }
  }), []);
  const [mountedState, setMountedState] = React__namespace.useState(false);
  React__namespace.useEffect(() => {
    setMountedState(true);
  }, []);
  const enableTouchRipple = mountedState && !disableRipple && !disabled;
  React__namespace.useEffect(() => {
    if (focusVisible && focusRipple && !disableRipple && mountedState) {
      rippleRef.current.pulsate();
    }
  }, [disableRipple, focusRipple, focusVisible, mountedState]);
  function useRippleHandler(rippleAction, eventCallback, skipRippleAction = disableTouchRipple) {
    return useEventCallback(event => {
      if (eventCallback) {
        eventCallback(event);
      }
      const ignore = skipRippleAction;
      if (!ignore && rippleRef.current) {
        rippleRef.current[rippleAction](event);
      }
      return true;
    });
  }
  const handleMouseDown = useRippleHandler('start', onMouseDown);
  const handleContextMenu = useRippleHandler('stop', onContextMenu);
  const handleDragLeave = useRippleHandler('stop', onDragLeave);
  const handleMouseUp = useRippleHandler('stop', onMouseUp);
  const handleMouseLeave = useRippleHandler('stop', event => {
    if (focusVisible) {
      event.preventDefault();
    }
    if (onMouseLeave) {
      onMouseLeave(event);
    }
  });
  const handleTouchStart = useRippleHandler('start', onTouchStart);
  const handleTouchEnd = useRippleHandler('stop', onTouchEnd);
  const handleTouchMove = useRippleHandler('stop', onTouchMove);
  const handleBlur = useRippleHandler('stop', event => {
    handleBlurVisible(event);
    if (isFocusVisibleRef.current === false) {
      setFocusVisible(false);
    }
    if (onBlur) {
      onBlur(event);
    }
  }, false);
  const handleFocus = useEventCallback(event => {
    // Fix for https://github.com/facebook/react/issues/7769
    if (!buttonRef.current) {
      buttonRef.current = event.currentTarget;
    }
    handleFocusVisible(event);
    if (isFocusVisibleRef.current === true) {
      setFocusVisible(true);
      if (onFocusVisible) {
        onFocusVisible(event);
      }
    }
    if (onFocus) {
      onFocus(event);
    }
  });
  const isNonNativeButton = () => {
    const button = buttonRef.current;
    return component && component !== 'button' && !(button.tagName === 'A' && button.href);
  };

  /**
   * IE11 shim for https://developer.mozilla.org/en-US/docs/Web/API/KeyboardEvent/repeat
   */
  const keydownRef = React__namespace.useRef(false);
  const handleKeyDown = useEventCallback(event => {
    // Check if key is already down to avoid repeats being counted as multiple activations
    if (focusRipple && !keydownRef.current && focusVisible && rippleRef.current && event.key === ' ') {
      keydownRef.current = true;
      rippleRef.current.stop(event, () => {
        rippleRef.current.start(event);
      });
    }
    if (event.target === event.currentTarget && isNonNativeButton() && event.key === ' ') {
      event.preventDefault();
    }
    if (onKeyDown) {
      onKeyDown(event);
    }

    // Keyboard accessibility for non interactive elements
    if (event.target === event.currentTarget && isNonNativeButton() && event.key === 'Enter' && !disabled) {
      event.preventDefault();
      if (onClick) {
        onClick(event);
      }
    }
  });
  const handleKeyUp = useEventCallback(event => {
    // calling preventDefault in keyUp on a <button> will not dispatch a click event if Space is pressed
    // https://codesandbox.io/s/button-keyup-preventdefault-dn7f0
    if (focusRipple && event.key === ' ' && rippleRef.current && focusVisible && !event.defaultPrevented) {
      keydownRef.current = false;
      rippleRef.current.stop(event, () => {
        rippleRef.current.pulsate(event);
      });
    }
    if (onKeyUp) {
      onKeyUp(event);
    }

    // Keyboard accessibility for non interactive elements
    if (onClick && event.target === event.currentTarget && isNonNativeButton() && event.key === ' ' && !event.defaultPrevented) {
      onClick(event);
    }
  });
  let ComponentProp = component;
  if (ComponentProp === 'button' && (other.href || other.to)) {
    ComponentProp = LinkComponent;
  }
  const buttonProps = {};
  if (ComponentProp === 'button') {
    buttonProps.type = type === undefined ? 'button' : type;
    buttonProps.disabled = disabled;
  } else {
    if (!other.href && !other.to) {
      buttonProps.role = 'button';
    }
    if (disabled) {
      buttonProps['aria-disabled'] = disabled;
    }
  }
  const handleRef = useForkRef(ref, focusVisibleRef, buttonRef);
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useEffect(() => {
      if (enableTouchRipple && !rippleRef.current) {
        console.error(['MUI: The `component` prop provided to ButtonBase is invalid.', 'Please make sure the children prop is rendered in this custom component.'].join('\n'));
      }
    }, [enableTouchRipple]);
  }
  const ownerState = _extends$1({}, props, {
    centerRipple,
    component,
    disabled,
    disableRipple,
    disableTouchRipple,
    focusRipple,
    tabIndex,
    focusVisible
  });
  const classes = useUtilityClasses$K(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(ButtonBaseRoot, _extends$1({
    as: ComponentProp,
    className: clsx(classes.root, className),
    ownerState: ownerState,
    onBlur: handleBlur,
    onClick: onClick,
    onContextMenu: handleContextMenu,
    onFocus: handleFocus,
    onKeyDown: handleKeyDown,
    onKeyUp: handleKeyUp,
    onMouseDown: handleMouseDown,
    onMouseLeave: handleMouseLeave,
    onMouseUp: handleMouseUp,
    onDragLeave: handleDragLeave,
    onTouchEnd: handleTouchEnd,
    onTouchMove: handleTouchMove,
    onTouchStart: handleTouchStart,
    ref: handleRef,
    tabIndex: disabled ? -1 : tabIndex,
    type: type
  }, buttonProps, other, {
    children: [children, enableTouchRipple ?
    /*#__PURE__*/
    /* TouchRipple is only needed client-side, x2 boost on the server. */
    jsxRuntimeExports.jsx(TouchRipple$1, _extends$1({
      ref: handleRippleRef,
      center: centerRipple
    }, TouchRippleProps)) : null]
  }));
});
browser$1.env.NODE_ENV !== "production" ? ButtonBase.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * A ref for imperative actions.
   * It currently only supports `focusVisible()` action.
   */
  action: refType$1,
  /**
   * If `true`, the ripples are centered.
   * They won't start at the cursor interaction position.
   * @default false
   */
  centerRipple: propTypesExports.bool,
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: elementTypeAcceptingRef$1,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the ripple effect is disabled.
   *
   * ⚠️ Without a ripple there is no styling for :focus-visible by default. Be sure
   * to highlight the element by applying separate styles with the `.Mui-focusVisible` class.
   * @default false
   */
  disableRipple: propTypesExports.bool,
  /**
   * If `true`, the touch ripple effect is disabled.
   * @default false
   */
  disableTouchRipple: propTypesExports.bool,
  /**
   * If `true`, the base button will have a keyboard focus ripple.
   * @default false
   */
  focusRipple: propTypesExports.bool,
  /**
   * This prop can help identify which element has keyboard focus.
   * The class name will be applied when the element gains the focus through keyboard interaction.
   * It's a polyfill for the [CSS :focus-visible selector](https://drafts.csswg.org/selectors-4/#the-focus-visible-pseudo).
   * The rationale for using this feature [is explained here](https://github.com/WICG/focus-visible/blob/HEAD/explainer.md).
   * A [polyfill can be used](https://github.com/WICG/focus-visible) to apply a `focus-visible` class to other components
   * if needed.
   */
  focusVisibleClassName: propTypesExports.string,
  /**
   * @ignore
   */
  href: propTypesExports /* @typescript-to-proptypes-ignore */.any,
  /**
   * The component used to render a link when the `href` prop is provided.
   * @default 'a'
   */
  LinkComponent: propTypesExports.elementType,
  /**
   * @ignore
   */
  onBlur: propTypesExports.func,
  /**
   * @ignore
   */
  onClick: propTypesExports.func,
  /**
   * @ignore
   */
  onContextMenu: propTypesExports.func,
  /**
   * @ignore
   */
  onDragLeave: propTypesExports.func,
  /**
   * @ignore
   */
  onFocus: propTypesExports.func,
  /**
   * Callback fired when the component is focused with a keyboard.
   * We trigger a `onFocus` callback too.
   */
  onFocusVisible: propTypesExports.func,
  /**
   * @ignore
   */
  onKeyDown: propTypesExports.func,
  /**
   * @ignore
   */
  onKeyUp: propTypesExports.func,
  /**
   * @ignore
   */
  onMouseDown: propTypesExports.func,
  /**
   * @ignore
   */
  onMouseLeave: propTypesExports.func,
  /**
   * @ignore
   */
  onMouseUp: propTypesExports.func,
  /**
   * @ignore
   */
  onTouchEnd: propTypesExports.func,
  /**
   * @ignore
   */
  onTouchMove: propTypesExports.func,
  /**
   * @ignore
   */
  onTouchStart: propTypesExports.func,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * @default 0
   */
  tabIndex: propTypesExports.number,
  /**
   * Props applied to the `TouchRipple` element.
   */
  TouchRippleProps: propTypesExports.object,
  /**
   * A ref that points to the `TouchRipple` element.
   */
  touchRippleRef: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.shape({
    current: propTypesExports.shape({
      pulsate: propTypesExports.func.isRequired,
      start: propTypesExports.func.isRequired,
      stop: propTypesExports.func.isRequired
    })
  })]),
  /**
   * @ignore
   */
  type: propTypesExports.oneOfType([propTypesExports.oneOf(['button', 'reset', 'submit']), propTypesExports.string])
} : void 0;
var ButtonBase$1 = ButtonBase;

const dividerClasses = generateUtilityClasses('MuiDivider', ['root', 'absolute', 'fullWidth', 'inset', 'middle', 'flexItem', 'light', 'vertical', 'withChildren', 'withChildrenVertical', 'textAlignRight', 'textAlignLeft', 'wrapper', 'wrapperVertical']);
var dividerClasses$1 = dividerClasses;

const listItemIconClasses = generateUtilityClasses('MuiListItemIcon', ['root', 'alignItemsFlexStart']);
var listItemIconClasses$1 = listItemIconClasses;

function getMenuItemUtilityClass(slot) {
  return generateUtilityClass('MuiMenuItem', slot);
}
const menuItemClasses = generateUtilityClasses('MuiMenuItem', ['root', 'focusVisible', 'dense', 'disabled', 'divider', 'gutters', 'selected']);
var menuItemClasses$1 = menuItemClasses;

const _excluded$1g = ["autoFocus", "component", "dense", "divider", "disableGutters", "focusVisibleClassName", "role", "tabIndex", "className"];
const overridesResolver = (props, styles) => {
  const {
    ownerState
  } = props;
  return [styles.root, ownerState.dense && styles.dense, ownerState.divider && styles.divider, !ownerState.disableGutters && styles.gutters];
};
const useUtilityClasses$J = ownerState => {
  const {
    disabled,
    dense,
    divider,
    disableGutters,
    selected,
    classes
  } = ownerState;
  const slots = {
    root: ['root', dense && 'dense', disabled && 'disabled', !disableGutters && 'gutters', divider && 'divider', selected && 'selected']
  };
  const composedClasses = composeClasses(slots, getMenuItemUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};
const MenuItemRoot = styled$1(ButtonBase$1, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiMenuItem',
  slot: 'Root',
  overridesResolver
})(({
  theme,
  ownerState
}) => _extends$1({}, theme.typography.body1, {
  display: 'flex',
  justifyContent: 'flex-start',
  alignItems: 'center',
  position: 'relative',
  textDecoration: 'none',
  minHeight: 48,
  paddingTop: 6,
  paddingBottom: 6,
  boxSizing: 'border-box',
  whiteSpace: 'nowrap'
}, !ownerState.disableGutters && {
  paddingLeft: 16,
  paddingRight: 16
}, ownerState.divider && {
  borderBottom: `1px solid ${(theme.vars || theme).palette.divider}`,
  backgroundClip: 'padding-box'
}, {
  '&:hover': {
    textDecoration: 'none',
    backgroundColor: (theme.vars || theme).palette.action.hover,
    // Reset on touch devices, it doesn't add specificity
    '@media (hover: none)': {
      backgroundColor: 'transparent'
    }
  },
  [`&.${menuItemClasses$1.selected}`]: {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette.primary.mainChannel} / ${theme.vars.palette.action.selectedOpacity})` : alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity),
    [`&.${menuItemClasses$1.focusVisible}`]: {
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette.primary.mainChannel} / calc(${theme.vars.palette.action.selectedOpacity} + ${theme.vars.palette.action.focusOpacity}))` : alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
    }
  },
  [`&.${menuItemClasses$1.selected}:hover`]: {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette.primary.mainChannel} / calc(${theme.vars.palette.action.selectedOpacity} + ${theme.vars.palette.action.hoverOpacity}))` : alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.hoverOpacity),
    // Reset on touch devices, it doesn't add specificity
    '@media (hover: none)': {
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette.primary.mainChannel} / ${theme.vars.palette.action.selectedOpacity})` : alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity)
    }
  },
  [`&.${menuItemClasses$1.focusVisible}`]: {
    backgroundColor: (theme.vars || theme).palette.action.focus
  },
  [`&.${menuItemClasses$1.disabled}`]: {
    opacity: (theme.vars || theme).palette.action.disabledOpacity
  },
  [`& + .${dividerClasses$1.root}`]: {
    marginTop: theme.spacing(1),
    marginBottom: theme.spacing(1)
  },
  [`& + .${dividerClasses$1.inset}`]: {
    marginLeft: 52
  },
  [`& .${listItemTextClasses$1.root}`]: {
    marginTop: 0,
    marginBottom: 0
  },
  [`& .${listItemTextClasses$1.inset}`]: {
    paddingLeft: 36
  },
  [`& .${listItemIconClasses$1.root}`]: {
    minWidth: 36
  }
}, !ownerState.dense && {
  [theme.breakpoints.up('sm')]: {
    minHeight: 'auto'
  }
}, ownerState.dense && _extends$1({
  minHeight: 32,
  // https://m2.material.io/components/menus#specs > Dense
  paddingTop: 4,
  paddingBottom: 4
}, theme.typography.body2, {
  [`& .${listItemIconClasses$1.root} svg`]: {
    fontSize: '1.25rem'
  }
})));
const MenuItem = /*#__PURE__*/React__namespace.forwardRef(function MenuItem(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiMenuItem'
  });
  const {
      autoFocus = false,
      component = 'li',
      dense = false,
      divider = false,
      disableGutters = false,
      focusVisibleClassName,
      role = 'menuitem',
      tabIndex: tabIndexProp,
      className
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1g);
  const context = React__namespace.useContext(ListContext$1);
  const childContext = React__namespace.useMemo(() => ({
    dense: dense || context.dense || false,
    disableGutters
  }), [context.dense, dense, disableGutters]);
  const menuItemRef = React__namespace.useRef(null);
  useEnhancedEffect$1(() => {
    if (autoFocus) {
      if (menuItemRef.current) {
        menuItemRef.current.focus();
      } else if (browser$1.env.NODE_ENV !== 'production') {
        console.error('MUI: Unable to set focus to a MenuItem whose component has not been rendered.');
      }
    }
  }, [autoFocus]);
  const ownerState = _extends$1({}, props, {
    dense: childContext.dense,
    divider,
    disableGutters
  });
  const classes = useUtilityClasses$J(props);
  const handleRef = useForkRef(menuItemRef, ref);
  let tabIndex;
  if (!props.disabled) {
    tabIndex = tabIndexProp !== undefined ? tabIndexProp : -1;
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(ListContext$1.Provider, {
    value: childContext,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(MenuItemRoot, _extends$1({
      ref: handleRef,
      role: role,
      tabIndex: tabIndex,
      component: component,
      focusVisibleClassName: clsx(classes.focusVisible, focusVisibleClassName),
      className: clsx(classes.root, className)
    }, other, {
      ownerState: ownerState,
      classes: classes
    }))
  });
});
browser$1.env.NODE_ENV !== "production" ? MenuItem.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, the list item is focused during the first mount.
   * Focus will also be triggered if the value changes from false to true.
   * @default false
   */
  autoFocus: propTypesExports.bool,
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, compact vertical padding designed for keyboard and mouse input is used.
   * The prop defaults to the value inherited from the parent Menu component.
   * @default false
   */
  dense: propTypesExports.bool,
  /**
   * @ignore
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the left and right padding is removed.
   * @default false
   */
  disableGutters: propTypesExports.bool,
  /**
   * If `true`, a 1px light border is added to the bottom of the menu item.
   * @default false
   */
  divider: propTypesExports.bool,
  /**
   * This prop can help identify which element has keyboard focus.
   * The class name will be applied when the element gains the focus through keyboard interaction.
   * It's a polyfill for the [CSS :focus-visible selector](https://drafts.csswg.org/selectors-4/#the-focus-visible-pseudo).
   * The rationale for using this feature [is explained here](https://github.com/WICG/focus-visible/blob/HEAD/explainer.md).
   * A [polyfill can be used](https://github.com/WICG/focus-visible) to apply a `focus-visible` class to other components
   * if needed.
   */
  focusVisibleClassName: propTypesExports.string,
  /**
   * @ignore
   */
  role: propTypesExports /* @typescript-to-proptypes-ignore */.string,
  /**
   * If `true`, the component is selected.
   * @default false
   */
  selected: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * @default 0
   */
  tabIndex: propTypesExports.number
} : void 0;
var MenuItem$1 = MenuItem;

/* eslint max-lines: ["error", {"max": 450}] */
var TEST_IDS = {
  BANNER: "BANNER",
  TEXT: "TEXT",
  URL: "URL",
  VIDEO: "VIDEO",
  PILLS: "PILLS",
  URL_ICON: "URL_ICON",
  VIDEO_PREVIEW: "VIDEO_PREVIEW",
  ADD_BUTTON: "ADD_BUTTON",
  COLOR_PICKER_BUTTON: "COLOR_PICKER_BUTTON",
  COLOR_PICKER_ITEM_BUTTON: "COLOR_PICKER_ITEM_BUTTON",
  TAG_INPUT_PILL: "TAG_INPUT_PILL",
  PILL_INPUT_PILL: "PILL_INPUT_PILL",
  BUTTON: "BUTTON",
  REMOVE_BUTTON: "REMOVE_BUTTON",
  ERROR_MESSAGE: "ERROR_MESSAGE",
  ACTIONABLE_BUTTON: "ACTIONABLE_BUTTON",
  COLLAPSIBLE_TEXT_CONTAINER: "COLLAPSIBLE_TEXT_CONTAINER",
  COLLAPSIBLE_TEXT_TOGGLE_BUTTON: "COLLAPSIBLE_TEXT_TOGGLE_BUTTON",
  SECTION_HEADER: "SECTION_HEADER",
  SKELETON: "SKELETON",
  FORM: "FORM",
  ATTACHMENT_PREVIEW: "ATTACHMENT_PREVIEW",
  IMAGE_UPLOAD_INPUT: "IMAGE_UPLOAD_INPUT",
  PDF_UPLOAD_INPUT: "PDF_UPLOAD_INPUT",
  PDF_INPUT_PREVIEW: "PDF_INPUT_PREVIEW",
  PDF_CONTENT_BLOCK: "PDF_CONTENT_BLOCK",
  PDF_DOCUMENT: "PDF_DOCUMENT",
  CONTENT_BLOCK_NAME_INPUT: "CONTENT_BLOCK_NAME_INPUT",
  BULLETIN_POSTS_HEADER_SKELETON: "BULLETIN_POSTS_HEADER_SKELETON",
  BULLETIN_POSTS_LIST_SKELETON: "BULLETIN_POSTS_LIST_SKELETON",
  CONTENT_BLOCK_FORM_SUBMIT_BUTTON: "CONTENT_BLOCK_FORM_SUBMIT_BUTTON",
  ADD_SECTION_BUTTON: "ADD_SECTION_BUTTON",
  CONTENT_BLOCK_FORM_VALUES: "CONTENT_BLOCK_FORM_VALUES",
  CONTENT_BLOCK_SECTION_TITLE: "CONTENT_BLOCK_SECTION_TITLE",
  MODAL: "MODAL",
  MODAL_CONTENT: "MODAL_CONTENT",
  CLOSE_BUTTON: "CLOSE_BUTTON",
  CONFIRMATION_MODAL: "CONFIRMATION_MODAL",
  BULLETIN_POST_MODAL: "BULLETIN_POST_MODAL",
  BULLETIN_POST_MODAL_BUTTON: "BULLETIN_POST_MODAL_BUTTON",
  CONFIRMATION_MODAL_BUTTON: "CONFIRMATION_MODAL_BUTTON",
  PAGE_SECTION_HEADER_DEFAULT_BUTTON: "PAGE_SECTION_HEADER_DEFAULT_BUTTON",
  SNACKBAR_CLOSE_BUTTON: "SNACKBAR_CLOSE_BUTTON",
  SEARCH: "SEARCH",
  DOWNLOAD_BUTTON: "DOWNLOAD_BUTTON",
  CONTENT_SECTIONS_SKELETON: "CONTENT_SECTIONS_SKELETON",
  CHECKBOX: "CHECKBOX",
  SWITCH: "SWITCH",
  TABLE_SKELETON: "TABLE_SKELETON",
  EMPTY_ROW_TABLE_CELL: "EMPTY_ROW_TABLE_CELL",
  ERROR_MESSAGE_DEFAULT_BUTTON: "ERROR_MESSAGE_DEFAULT_BUTTON",
  CIRCLED_BUTTON_ICON: "CIRCLED_BUTTON_ICON",
  ADDRESS_INPUT_OPTION: "ADDRESS_INPUT_OPTION",
  PILL_BUTTON: "PILL_BUTTON",
  EXPAND_ICON: "EXPAND_ICON",
  CONTENT_SECTIONS_DRAG_HANDLE: "CONTENT_SECTIONS_DRAG_HANDLE",
  TABLE_BULK_ACTIONS_HEADER: "TABLE_BULK_ACTIONS_HEADER",
  TABLE_SELECT_ROW: "TABLE_SELECT_ROW",
  TABLE_SELECT_ALL_ROWS: "TABLE_SELECT_ALL_ROWS",
  TABLE_BULK_ACTION_BUTTON: "TABLE_BULK_ACTION_BUTTON",
  TABLE_BULK_ACTION_APPLY: "TABLE_BULK_ACTION_APPLY",
  TABLE_ROWS_PER_PAGE_SELECT: "TABLE_ROWS_PER_PAGE_SELECT",
  USER_AVATAR_SKELETON: "USER_AVATAR_SKELETON",
  BLOCK_DRAG_HANDLE: "BLOCK_DRAG_HANDLE",
  SECTION_INPUT_DRAG_HANDLE: "SECTION_INPUT_DRAG_HANDLE",
  IMAGE_INPUT_PREVIEW: "IMAGE_INPUT_PREVIEW",
  BULLETIN_POST_VIEWS: "BULLETIN_POST_VIEWS",
  BULLETIN_POST_SPINNER_CONTAINER: "BULLETIN_POST_SPINNER_CONTAINER",
  ADD_FIELD_BUTTON: "ADD_FIELD_BUTTON",
  INPUT_ERROR_MESSAGE: "INPUT_ERROR_MESSAGE",
  FORM_SUBMISSION_VIEW: "FORM_SUBMISSION_VIEW",
  SIGNATURE_CONTAINER: "SIGNATURE_CONTAINER",
  FORM_CONTENT_BLOCK_VIEW: "FORM_CONTENT_BLOCK_VIEW",
  RESEND_BUTTON: "RESEND_BUTTON",
  SEARCH_INPUT: "SEARCH_INPUT",
  EDIT_FORM_WARNING: "EDIT_FORM_WARNING",
  BACK_BUTTON: "BACK_BUTTON"
};
var FORM_INPUTS = {
  BUTTON: "form-button",
  SECONDARY_BUTTON: "secondary-form-button",
  NAME: "name",
  ADDRESS: "address",
  PHONE: "phone",
  WEBSITE: "website",
  TRADE: "trade",
  ADDITIONAL_DETAILS: "additional_details",
  INDUSTRIES: "industries",
  FIRST_NAME: "first-name",
  LAST_NAME: "last-name",
  EMAIL: "email",
  BIO: "bio",
  COMPANY_NAME: "company-name",
  TYPE_OF_COMPANY: "type-of-company",
  LOCATION: "location",
  COMPANY_PHONE: "company-phone",
  COMPANY_PROFILE_IMAGE: "company-profile-image",
  COMPANY_COVER_IMAGE: "company-cover-image"
};
var LIMITS = {
  MAX_CONTENT_LENGTH: 1000
};
var PINNED_POST_LABEL = "Pinned Post";
var ADDRESS_PILL_URL_NAME = "Google Maps link";
var CONTACT_PILL_URL_NAME = "Phone Number";
var FORM_ERROR = {
  FULL_ADDRESS: "Please enter full address",
  GOOGLE_PLACES: "An error occurred when trying to get addresses. Please try again.",
  PHONE: "Please enter a valid phone number",
  URL: "Please enter a valid url",
  REQUIRED: "Required",
  MIN_ONE: "Requires at least 1 selection",
  MAX_TEN_THOUSAND: "Please keep description under 10000 characters",
  MAX_TWO_HUNDRED: "Please keep questions under 200 characters",
  MAX_CONTENT_LENGTH: "Content must be less than ".concat(LIMITS.MAX_CONTENT_LENGTH, " characters"),
  NUMERIC_TYPE_ERROR: "Amount must be a number",
  NUMERIC_TYPE_ERROR_PLURAL: "Amounts must be numbers",
  EMAIL: "Please enter a valid email",
  JOB_DESCRIPTION: "Please provide a job description",
  JOB_POST_EXPIRATION: "Please select when this post will expire",
  JOB_POST_AGREEMENT: "Please read and accept Job Posting Agreement"
};
var CONTENT_BLOCK_VALIDATION_LIMITS = {
  NAME: {
    MAX: 200
  },
  URL: {
    MAX: 300
  },
  URL_LIST: {
    MAX: 30
  },
  PILL_CONTENT: {
    MAX: 50
  },
  TAG_CONTENT: {
    MAX: 50
  },
  BLOCK_TITLE: {
    MAX: 200
  },
  BLOCK_CONTENT: {
    MAX: LIMITS.MAX_CONTENT_LENGTH
  },
  UUID: {
    MAX: 36
  },
  SECTION_TITLE: {
    MAX: 200
  }
};
var CONTENT_BLOCK_VALIDATION_MESSAGES = {
  NAME: {
    MAX: "Card Title must be at most ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.NAME.MAX, " characters"),
    REQUIRED: "Card Title is required"
  },
  URL: {
    MATCHES: "Please enter a valid url",
    MAX: "Url must be at most ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.URL.MAX, " characters")
  },
  URL_LIST: {
    MAX: "Cannot have more than ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.URL_LIST.MAX, " urls")
  },
  PILL_CONTENT: {
    MAX: "Name must be at most ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.PILL_CONTENT.MAX, " characters"),
    REQUIRED: "Name is required"
  },
  PILL_URL: {
    REQUIRED: "".concat(ADDRESS_PILL_URL_NAME, " is required")
  },
  PHONE: {
    MATCHES: "Please enter a valid phone number",
    REQUIRED: "".concat(CONTACT_PILL_URL_NAME, " is required")
  },
  TAG_CONTENT: {
    MAX: "Text must be at most ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.TAG_CONTENT.MAX, " characters"),
    REQUIRED: "Text is required"
  },
  TYPE: {
    REQUIRED: "Type is required"
  },
  BLOCK_TITLE: {
    MAX: "Subject must be at most ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.BLOCK_TITLE.MAX, " characters")
  },
  BLOCK_CONTENT: {
    MAX: "Content must be at most ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.BLOCK_CONTENT.MAX, " characters")
  },
  SECTION_TITLE: {
    MAX: "Title must be at most ".concat(CONTENT_BLOCK_VALIDATION_LIMITS.SECTION_TITLE.MAX, " characters")
  }
};
var FORM_BUILDER_VALIDATION_LIMITS = {
  TITLE: {
    MAX: 200
  },
  FIELD_TITLE: {
    MAX: 200
  },
  FIELD_OPTION: {
    MAX: 100
  },
  FIELD_OPTIONS: {
    MIN: 1
  }
};
var FORM_BUILDER_VALIDATION_MESSAGES = {
  TITLE: {
    MAX: "Title must be at most ".concat(FORM_BUILDER_VALIDATION_LIMITS.TITLE.MAX, " characters"),
    REQUIRED: "Title is required"
  },
  FIELD_TITLE: {
    MAX: "Question must be at most ".concat(FORM_BUILDER_VALIDATION_LIMITS.FIELD_TITLE.MAX, " characters"),
    REQUIRED: "Question is required"
  },
  FIELD_TYPE: {
    REQUIRED: "Type is required"
  },
  FIELD_OPTION: {
    MAX: "Option must be at most ".concat(FORM_BUILDER_VALIDATION_LIMITS.FIELD_OPTION.MAX, " characters"),
    REQUIRED: "Option is required"
  },
  FIELD_OPTIONS: {
    MIN: "At least one option is required"
  }
};
var FORM_BUILDER_FIELD_TYPES = {
  SHORT_ANSWER: "SHORT_ANSWER",
  PARAGRAPH: "PARAGRAPH",
  DROPDOWN: "DROPDOWN",
  MULTIPLE_CHOICE: "MULTIPLE_CHOICE",
  CHECKBOXES: "CHECKBOXES",
  SIGNATURE: "SIGNATURE"
};
var FORM_BUILDER_FIELD_TYPES_WITH_OPTIONS = [FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE, FORM_BUILDER_FIELD_TYPES.CHECKBOXES, FORM_BUILDER_FIELD_TYPES.DROPDOWN];
var FORM_BUILDER_FIELD_TYPES_WITH_ARRAY_VALUES = [FORM_BUILDER_FIELD_TYPES.CHECKBOXES];
var FORM_BUILDER_MODAL_STEP_NAMES = {
  SELECT_OPTION: "SELECT_OPTION",
  FORM_BUILDER: "FORM_BUILDER",
  SELECT_FORM: "SELECT_FORM"
};
var CONTENT_BLOCK_ICONS = {
  PHONE: "phone",
  CAR: "car"
};
var IMAGE_VARIANTS = {
  THUMBNAIL: "thumbnail",
  SMALL: "small",
  MEDIUM: "medium",
  LARGE: "large"
};
var CONTENT_BLOCK_TYPES = {
  ADDRESS: "ADDRESS",
  BANNER: "BANNER",
  CONTACT: "CONTACT",
  IMAGE: "IMAGE",
  TAGS: "TAGS",
  TEXT: "TEXT",
  VIDEO: "VIDEO",
  PDF: "PDF",
  FORM: "FORM"
};
var CONTENT_BLOCK_ATTACHMENT_LABELS = {
  IMAGE_TITLE: "Image Title",
  VIDEO_TITLE: "Video Title",
  IMAGE_CAPTION: "Image Caption",
  VIDEO_CAPTION: "Video Caption"
};
var CONTENT_BLOCK_INPUT_PATH_PROPS = {
  CONTENT: "content",
  URL: "url",
  TITLE: "title",
  PILLS: "pills",
  URL_LIST: "url_list"
};
var ATTACHMENT_CONTENT_BLOCK_TYPES = [CONTENT_BLOCK_TYPES.IMAGE, CONTENT_BLOCK_TYPES.PDF];
var CONTENT_BLOCKS_WITH_ID_IN_URL = [].concat(ATTACHMENT_CONTENT_BLOCK_TYPES, [CONTENT_BLOCK_TYPES.FORM]);
var FORM_CHAR_LIMIT = {
  JOB_DESCRIPTION: 10000,
  MARKDOWN_INPUT: 10000
};
var USER_INPUT = {
  CLICKAWAY: "clickaway",
  ENTER: "Enter"
};
var IMAGE_URL =
// Image Link leads to boomnation logo from the App store.
// eslint-disable-next-line no-secrets/no-secrets
"https://is2-ssl.mzstatic.com/image/thumb/Purple113/v4/c7/37/81/c73781fd-c7fc-87f1-8f2d-60a5c8e62662/AppIcon-0-0-1x_U007emarketing-0-0-0-7-0-0-sRGB-0-0-0-GLES2_U002c0-512MB-85-220-0-0.png/1200x600wa.png";
var CONTENT_BLOCK_INPUT_VARIANT = "standard";
var SECTIONS_DROPPABLE_ID = "SECTIONS_DROPPABLE_ID";
var CONTENT_SECTIONS_DROPPABLE_ID = "CONTENT_SECTIONS_DROPPABLE_ID";
var BLOCKS_DROPPABLE_ID = "BLOCK_DROPPABLE_ID";
var FIELDS_DROPPABLE_ID = "FIELDS_DROPPABLE_ID";
var INVALID_INPUT_PATH = "Cannot make a path with blockIndex and no sectionIndex";
var TABLES = {
  EMPTY_ROWS: "EMPTY_ROWS",
  FIRST_CELL: "FIRST_CELL",
  TABLE_ROW: "TABLE_ROW",
  SORT: "SORT",
  BASIC: "BASIC",
  ERROR: "ERROR",
  ADD_ENTRY: "ADD_ENTRY"
};
var SORT = {
  DESC: "desc",
  ASC: "asc"
};
var DEFAULT_SORT = {
  by: "created_at",
  order: SORT.DESC
};
var BULLETIN_NOTIFICATION_CHECKBOX_LABEL = "Send SMS notifications";
var BULLETIN_NOTIFICATION_CHECKBOX_TOOLTIP = "If checked an text will be sent notifying all workers with access to this post";
var HEIGHT = {
  FORM_INPUT: 48
};
var ARIA_LABELS = {
  ADDRESS_ERROR: "address"
};
var IMG = {
  GOOGLE: {
    SRC: "https://developers.google.com/places/documentation/images/powered-by-google-on-white.png",
    ALT: "Powered by Google"
  }
};
var OK = "OK";
var SAVE = "Save";
var ADD = "Add";
var SHOW_MORE = "Show More";
var SHOW_LESS = "Show Less";
var BULLETIN_DETAIL_USER_ITEM_HEIGHT = 40;
var ENTITY_TYPES = {
  BULLETIN_POSTS: "bulletin_posts",
  COMPANIES: "companies",
  PROJECTS: "projects"
};
var MUI_LABEL_PLACEMENT = {
  START: "start",
  END: "end",
  BOTTOM: "bottom",
  TOP: "top"
};
var FORM_BUILDER_MODAL_HEIGHT_OFFSET = "120px";
var DOWNLOAD_FILE_TYPES = {
  IMAGE: "image",
  PDF: "pdf",
  MULTI_IMAGE: "multi_image"
};
var CDN_ACCESS_TYPES = {
  READ: "read",
  DELETE: "delete"
};
var CDN_GRANTED_ENTITY_TYPES = {
  USER: "user",
  COMPANY: "company",
  ROLE: "role",
  EVERYONE: "everyone"
};
var SIGNATURE_UPLOAD_ERROR = "There was an error uploading your signature. Please try again.";
var FORM_BUILDER_TAB_NAMES = {
  QUESTIONS: "Questions",
  SETTINGS: "Settings"
};
var TAB_PREFIXES = {
  FORM_BUILDER: "form_builder_",
  SUBMISSION_EDITOR: "submission_editor_"
};
var TABS_DEFAULT_PREFIX = "";
var BULLETIN_POST_VIEWS_EMPTY_STATE = {
  VIEWED: "None of your workers have viewed this bulletin post.",
  UNVIEWED: "All workers have viewed this bulletin post!",
  NO_USERS_FOUND: "No results found."
};

var paperOverrides = {
  minWidth: "100%",
  zIndex: 100,
  position: "absolute",
  marginTop: 4,
  top: HEIGHT.FORM_INPUT
};
var menuListOverrides = {
  display: "flex",
  flexDirection: "column"
};
var AddressText = styled__default.default(Typography$1)({
  display: "inline-flex",
  fontWeight: 600
});
var AddressText2 = styled__default.default(Typography$1)({
  display: "inline-flex",
  marginLeft: 5
});
var GoogleLogo = styled__default.default.img({
  alignSelf: "flex-end",
  marginRight: 10
});

function AddressPlacesSuggestions(_ref) {
  var data = _ref.data,
    handleSelect = _ref.handleSelect;
  return data.map(function (suggestion) {
    var placeId = suggestion.place_id,
      _suggestion$structure = suggestion.structured_formatting,
      street = _suggestion$structure.main_text,
      city = _suggestion$structure.secondary_text;
    return /*#__PURE__*/React__namespace.default.createElement(MenuItem$1, {
      "data-testid": TEST_IDS.ADDRESS_INPUT_OPTION,
      onMouseDown: function onMouseDown(event) {
        return event.preventDefault();
      },
      key: placeId,
      onClick: handleSelect(suggestion)
    }, /*#__PURE__*/React__namespace.default.createElement(ListItemText$1, null, /*#__PURE__*/React__namespace.default.createElement(AddressText, {
      variant: "body2"
    }, street), /*#__PURE__*/React__namespace.default.createElement(AddressText2, {
      variant: "caption"
    }, " ", city)));
  });
}

function InputErrorMessage(_ref) {
  var id = _ref.id,
    validationMessage = _ref.validationMessage;
  if (!validationMessage) return null;
  return /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    "data-testid": TEST_IDS.INPUT_ERROR_MESSAGE,
    "aria-label": "error-".concat(id),
    variant: "caption",
    color: "error.main"
  },
  /* validationMessage can be an object that holds multiple errors or string
  show first error if object of errors else just the string */
  libCommon.isString(validationMessage) ? validationMessage : Object.values(validationMessage)[0].message);
}
InputErrorMessage.propTypes = {
  id: propTypesExports.string,
  validationMessage: propTypesExports.oneOfType([propTypesExports.object, propTypesExports.string])
};

function InputSubtitle(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "caption",
    m: 1
  }, children);
}
InputSubtitle.propTypes = {
  children: propTypesExports.string
};

function InputTitle(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "h6",
    m: 1
  }, children);
}
InputTitle.propTypes = {
  children: propTypesExports.string
};

var OpenInFullOutlined = {};

var interopRequireDefaultExports = {};
var interopRequireDefault = {
  get exports(){ return interopRequireDefaultExports; },
  set exports(v){ interopRequireDefaultExports = v; },
};

(function (module) {
	function _interopRequireDefault(obj) {
	  return obj && obj.__esModule ? obj : {
	    "default": obj
	  };
	}
	module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;
} (interopRequireDefault));

var createSvgIcon$1 = {};

function getSvgIconUtilityClass(slot) {
  return generateUtilityClass('MuiSvgIcon', slot);
}
generateUtilityClasses('MuiSvgIcon', ['root', 'colorPrimary', 'colorSecondary', 'colorAction', 'colorError', 'colorDisabled', 'fontSizeInherit', 'fontSizeSmall', 'fontSizeMedium', 'fontSizeLarge']);

const _excluded$1f = ["children", "className", "color", "component", "fontSize", "htmlColor", "inheritViewBox", "titleAccess", "viewBox"];
const useUtilityClasses$I = ownerState => {
  const {
    color,
    fontSize,
    classes
  } = ownerState;
  const slots = {
    root: ['root', color !== 'inherit' && `color${capitalize(color)}`, `fontSize${capitalize(fontSize)}`]
  };
  return composeClasses(slots, getSvgIconUtilityClass, classes);
};
const SvgIconRoot = styled$1('svg', {
  name: 'MuiSvgIcon',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.color !== 'inherit' && styles[`color${capitalize(ownerState.color)}`], styles[`fontSize${capitalize(ownerState.fontSize)}`]];
  }
})(({
  theme,
  ownerState
}) => {
  var _theme$transitions, _theme$transitions$cr, _theme$transitions2, _theme$transitions2$d, _theme$typography, _theme$typography$pxT, _theme$typography2, _theme$typography2$px, _theme$typography3, _theme$typography3$px, _palette$ownerState$c, _palette, _palette$ownerState$c2, _palette2, _palette2$action, _palette3, _palette3$action;
  return {
    userSelect: 'none',
    width: '1em',
    height: '1em',
    display: 'inline-block',
    fill: 'currentColor',
    flexShrink: 0,
    transition: (_theme$transitions = theme.transitions) == null ? void 0 : (_theme$transitions$cr = _theme$transitions.create) == null ? void 0 : _theme$transitions$cr.call(_theme$transitions, 'fill', {
      duration: (_theme$transitions2 = theme.transitions) == null ? void 0 : (_theme$transitions2$d = _theme$transitions2.duration) == null ? void 0 : _theme$transitions2$d.shorter
    }),
    fontSize: {
      inherit: 'inherit',
      small: ((_theme$typography = theme.typography) == null ? void 0 : (_theme$typography$pxT = _theme$typography.pxToRem) == null ? void 0 : _theme$typography$pxT.call(_theme$typography, 20)) || '1.25rem',
      medium: ((_theme$typography2 = theme.typography) == null ? void 0 : (_theme$typography2$px = _theme$typography2.pxToRem) == null ? void 0 : _theme$typography2$px.call(_theme$typography2, 24)) || '1.5rem',
      large: ((_theme$typography3 = theme.typography) == null ? void 0 : (_theme$typography3$px = _theme$typography3.pxToRem) == null ? void 0 : _theme$typography3$px.call(_theme$typography3, 35)) || '2.1875rem'
    }[ownerState.fontSize],
    // TODO v5 deprecate, v6 remove for sx
    color: (_palette$ownerState$c = (_palette = (theme.vars || theme).palette) == null ? void 0 : (_palette$ownerState$c2 = _palette[ownerState.color]) == null ? void 0 : _palette$ownerState$c2.main) != null ? _palette$ownerState$c : {
      action: (_palette2 = (theme.vars || theme).palette) == null ? void 0 : (_palette2$action = _palette2.action) == null ? void 0 : _palette2$action.active,
      disabled: (_palette3 = (theme.vars || theme).palette) == null ? void 0 : (_palette3$action = _palette3.action) == null ? void 0 : _palette3$action.disabled,
      inherit: undefined
    }[ownerState.color]
  };
});
const SvgIcon = /*#__PURE__*/React__namespace.forwardRef(function SvgIcon(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiSvgIcon'
  });
  const {
      children,
      className,
      color = 'inherit',
      component = 'svg',
      fontSize = 'medium',
      htmlColor,
      inheritViewBox = false,
      titleAccess,
      viewBox = '0 0 24 24'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1f);
  const ownerState = _extends$1({}, props, {
    color,
    component,
    fontSize,
    instanceFontSize: inProps.fontSize,
    inheritViewBox,
    viewBox
  });
  const more = {};
  if (!inheritViewBox) {
    more.viewBox = viewBox;
  }
  const classes = useUtilityClasses$I(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(SvgIconRoot, _extends$1({
    as: component,
    className: clsx(classes.root, className),
    focusable: "false",
    color: htmlColor,
    "aria-hidden": titleAccess ? undefined : true,
    role: titleAccess ? 'img' : undefined,
    ref: ref
  }, more, other, {
    ownerState: ownerState,
    children: [children, titleAccess ? /*#__PURE__*/jsxRuntimeExports.jsx("title", {
      children: titleAccess
    }) : null]
  }));
});
browser$1.env.NODE_ENV !== "production" ? SvgIcon.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Node passed into the SVG element.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * You can use the `htmlColor` prop to apply a color attribute to the SVG element.
   * @default 'inherit'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['inherit', 'action', 'disabled', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The fontSize applied to the icon. Defaults to 24px, but can be configure to inherit font size.
   * @default 'medium'
   */
  fontSize: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['inherit', 'large', 'medium', 'small']), propTypesExports.string]),
  /**
   * Applies a color attribute to the SVG element.
   */
  htmlColor: propTypesExports.string,
  /**
   * If `true`, the root node will inherit the custom `component`'s viewBox and the `viewBox`
   * prop will be ignored.
   * Useful when you want to reference a custom `component` and have `SvgIcon` pass that
   * `component`'s viewBox to the root node.
   * @default false
   */
  inheritViewBox: propTypesExports.bool,
  /**
   * The shape-rendering attribute. The behavior of the different options is described on the
   * [MDN Web Docs](https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute/shape-rendering).
   * If you are having issues with blurry icons you should investigate this prop.
   */
  shapeRendering: propTypesExports.string,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Provides a human-readable title for the element that contains it.
   * https://www.w3.org/TR/SVG-access/#Equivalent
   */
  titleAccess: propTypesExports.string,
  /**
   * Allows you to redefine what the coordinates without units mean inside an SVG element.
   * For example, if the SVG element is 500 (width) by 200 (height),
   * and you pass viewBox="0 0 50 20",
   * this means that the coordinates inside the SVG will go from the top left corner (0,0)
   * to bottom right (50,20) and each unit will be worth 10px.
   * @default '0 0 24 24'
   */
  viewBox: propTypesExports.string
} : void 0;
SvgIcon.muiName = 'SvgIcon';
var SvgIcon$1 = SvgIcon;

function createSvgIcon(path, displayName) {
  function Component(props, ref) {
    return /*#__PURE__*/jsxRuntimeExports.jsx(SvgIcon$1, _extends$1({
      "data-testid": `${displayName}Icon`,
      ref: ref
    }, props, {
      children: path
    }));
  }
  if (browser$1.env.NODE_ENV !== 'production') {
    // Need to set `displayName` on the inner component for React.memo.
    // React prior to 16.14 ignores `displayName` on the wrapper.
    Component.displayName = `${displayName}Icon`;
  }
  Component.muiName = SvgIcon$1.muiName;
  return /*#__PURE__*/React__namespace.memo( /*#__PURE__*/React__namespace.forwardRef(Component));
}

// TODO: remove this export once ClassNameGenerator is stable
// eslint-disable-next-line @typescript-eslint/naming-convention
const unstable_ClassNameGenerator = {
  configure: generator => {
    if (browser$1.env.NODE_ENV !== 'production') {
      console.warn(['MUI: `ClassNameGenerator` import from `@mui/material/utils` is outdated and might cause unexpected issues.', '', "You should use `import { unstable_ClassNameGenerator } from '@mui/material/className'` instead", '', 'The detail of the issue: https://github.com/mui/material-ui/issues/30011#issuecomment-1024993401', '', 'The updated documentation: https://mui.com/guides/classname-generator/'].join('\n'));
    }
    ClassNameGenerator$1.configure(generator);
  }
};

var utils = /*#__PURE__*/Object.freeze({
  __proto__: null,
  capitalize: capitalize,
  createChainedFunction: createChainedFunction,
  createSvgIcon: createSvgIcon,
  debounce: debounce$1,
  deprecatedPropType: deprecatedPropType,
  isMuiElement: isMuiElement,
  ownerDocument: ownerDocument,
  ownerWindow: ownerWindow,
  requirePropFactory: requirePropFactory,
  setRef: setRef,
  unstable_ClassNameGenerator: unstable_ClassNameGenerator,
  unstable_useEnhancedEffect: useEnhancedEffect$1,
  unstable_useId: useId,
  unsupportedProp: unsupportedProp,
  useControlled: useControlled,
  useEventCallback: useEventCallback,
  useForkRef: useForkRef,
  useIsFocusVisible: useIsFocusVisible
});

var require$$0 = /*@__PURE__*/getAugmentedNamespace(utils);

var hasRequiredCreateSvgIcon;

function requireCreateSvgIcon () {
	if (hasRequiredCreateSvgIcon) return createSvgIcon$1;
	hasRequiredCreateSvgIcon = 1;
	(function (exports) {

		Object.defineProperty(exports, "__esModule", {
		  value: true
		});
		Object.defineProperty(exports, "default", {
		  enumerable: true,
		  get: function () {
		    return _utils.createSvgIcon;
		  }
		});
		var _utils = require$$0;
} (createSvgIcon$1));
	return createSvgIcon$1;
}

var _interopRequireDefault$K = interopRequireDefaultExports;
Object.defineProperty(OpenInFullOutlined, "__esModule", {
  value: true
});
var default_1$K = OpenInFullOutlined.default = void 0;
var _createSvgIcon$K = _interopRequireDefault$K(requireCreateSvgIcon());
var _jsxRuntime$K = requireJsxRuntime();
var _default$K = (0, _createSvgIcon$K.default)( /*#__PURE__*/(0, _jsxRuntime$K.jsx)("path", {
  d: "M21 11V3h-8l3.29 3.29-10 10L3 13v8h8l-3.29-3.29 10-10z"
}), 'OpenInFullOutlined');
default_1$K = OpenInFullOutlined.default = _default$K;

// Supports determination of isControlled().
// Controlled input accepts its current value as a prop.
//
// @see https://facebook.github.io/react/docs/forms.html#controlled-components
// @param value
// @returns {boolean} true if string (including '') or number (including zero)
function hasValue(value) {
  return value != null && !(Array.isArray(value) && value.length === 0);
}

// Determine if field is empty or filled.
// Response determines if label is presented above field or as placeholder.
//
// @param obj
// @param SSR
// @returns {boolean} False when not present or empty string.
//                    True when any number or string with length.
function isFilled(obj, SSR = false) {
  return obj && (hasValue(obj.value) && obj.value !== '' || SSR && hasValue(obj.defaultValue) && obj.defaultValue !== '');
}

// Determine if an Input is adorned on start.
// It's corresponding to the left with LTR.
//
// @param obj
// @returns {boolean} False when no adornments.
//                    True when adorned at the start.
function isAdornedStart(obj) {
  return obj.startAdornment;
}

/**
 * @ignore - internal component.
 */
const FormControlContext = /*#__PURE__*/React__namespace.createContext(undefined);
if (browser$1.env.NODE_ENV !== 'production') {
  FormControlContext.displayName = 'FormControlContext';
}
var FormControlContext$1 = FormControlContext;

function getFormControlUtilityClasses(slot) {
  return generateUtilityClass('MuiFormControl', slot);
}
generateUtilityClasses('MuiFormControl', ['root', 'marginNone', 'marginNormal', 'marginDense', 'fullWidth', 'disabled']);

const _excluded$1e = ["children", "className", "color", "component", "disabled", "error", "focused", "fullWidth", "hiddenLabel", "margin", "required", "size", "variant"];
const useUtilityClasses$H = ownerState => {
  const {
    classes,
    margin,
    fullWidth
  } = ownerState;
  const slots = {
    root: ['root', margin !== 'none' && `margin${capitalize(margin)}`, fullWidth && 'fullWidth']
  };
  return composeClasses(slots, getFormControlUtilityClasses, classes);
};
const FormControlRoot = styled$1('div', {
  name: 'MuiFormControl',
  slot: 'Root',
  overridesResolver: ({
    ownerState
  }, styles) => {
    return _extends$1({}, styles.root, styles[`margin${capitalize(ownerState.margin)}`], ownerState.fullWidth && styles.fullWidth);
  }
})(({
  ownerState
}) => _extends$1({
  display: 'inline-flex',
  flexDirection: 'column',
  position: 'relative',
  // Reset fieldset default style.
  minWidth: 0,
  padding: 0,
  margin: 0,
  border: 0,
  verticalAlign: 'top'
}, ownerState.margin === 'normal' && {
  marginTop: 16,
  marginBottom: 8
}, ownerState.margin === 'dense' && {
  marginTop: 8,
  marginBottom: 4
}, ownerState.fullWidth && {
  width: '100%'
}));

/**
 * Provides context such as filled/focused/error/required for form inputs.
 * Relying on the context provides high flexibility and ensures that the state always stays
 * consistent across the children of the `FormControl`.
 * This context is used by the following components:
 *
 *  - FormLabel
 *  - FormHelperText
 *  - Input
 *  - InputLabel
 *
 * You can find one composition example below and more going to [the demos](/material-ui/react-text-field/#components).
 *
 * ```jsx
 * <FormControl>
 *   <InputLabel htmlFor="my-input">Email address</InputLabel>
 *   <Input id="my-input" aria-describedby="my-helper-text" />
 *   <FormHelperText id="my-helper-text">We'll never share your email.</FormHelperText>
 * </FormControl>
 * ```
 *
 * ⚠️ Only one `InputBase` can be used within a FormControl because it creates visual inconsistencies.
 * For instance, only one input can be focused at the same time, the state shouldn't be shared.
 */
const FormControl = /*#__PURE__*/React__namespace.forwardRef(function FormControl(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiFormControl'
  });
  const {
      children,
      className,
      color = 'primary',
      component = 'div',
      disabled = false,
      error = false,
      focused: visuallyFocused,
      fullWidth = false,
      hiddenLabel = false,
      margin = 'none',
      required = false,
      size = 'medium',
      variant = 'outlined'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1e);
  const ownerState = _extends$1({}, props, {
    color,
    component,
    disabled,
    error,
    fullWidth,
    hiddenLabel,
    margin,
    required,
    size,
    variant
  });
  const classes = useUtilityClasses$H(ownerState);
  const [adornedStart, setAdornedStart] = React__namespace.useState(() => {
    // We need to iterate through the children and find the Input in order
    // to fully support server-side rendering.
    let initialAdornedStart = false;
    if (children) {
      React__namespace.Children.forEach(children, child => {
        if (!isMuiElement(child, ['Input', 'Select'])) {
          return;
        }
        const input = isMuiElement(child, ['Select']) ? child.props.input : child;
        if (input && isAdornedStart(input.props)) {
          initialAdornedStart = true;
        }
      });
    }
    return initialAdornedStart;
  });
  const [filled, setFilled] = React__namespace.useState(() => {
    // We need to iterate through the children and find the Input in order
    // to fully support server-side rendering.
    let initialFilled = false;
    if (children) {
      React__namespace.Children.forEach(children, child => {
        if (!isMuiElement(child, ['Input', 'Select'])) {
          return;
        }
        if (isFilled(child.props, true)) {
          initialFilled = true;
        }
      });
    }
    return initialFilled;
  });
  const [focusedState, setFocused] = React__namespace.useState(false);
  if (disabled && focusedState) {
    setFocused(false);
  }
  const focused = visuallyFocused !== undefined && !disabled ? visuallyFocused : focusedState;
  let registerEffect;
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    const registeredInput = React__namespace.useRef(false);
    registerEffect = () => {
      if (registeredInput.current) {
        console.error(['MUI: There are multiple `InputBase` components inside a FormControl.', 'This creates visual inconsistencies, only use one `InputBase`.'].join('\n'));
      }
      registeredInput.current = true;
      return () => {
        registeredInput.current = false;
      };
    };
  }
  const childContext = React__namespace.useMemo(() => {
    return {
      adornedStart,
      setAdornedStart,
      color,
      disabled,
      error,
      filled,
      focused,
      fullWidth,
      hiddenLabel,
      size,
      onBlur: () => {
        setFocused(false);
      },
      onEmpty: () => {
        setFilled(false);
      },
      onFilled: () => {
        setFilled(true);
      },
      onFocus: () => {
        setFocused(true);
      },
      registerEffect,
      required,
      variant
    };
  }, [adornedStart, color, disabled, error, filled, focused, fullWidth, hiddenLabel, registerEffect, required, size, variant]);
  return /*#__PURE__*/jsxRuntimeExports.jsx(FormControlContext$1.Provider, {
    value: childContext,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(FormControlRoot, _extends$1({
      as: component,
      ownerState: ownerState,
      className: clsx(classes.root, className),
      ref: ref
    }, other, {
      children: children
    }))
  });
});
browser$1.env.NODE_ENV !== "production" ? FormControl.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'primary'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, the label, input and helper text should be displayed in a disabled state.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the label is displayed in an error state.
   * @default false
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the component is displayed in focused state.
   */
  focused: propTypesExports.bool,
  /**
   * If `true`, the component will take up the full width of its container.
   * @default false
   */
  fullWidth: propTypesExports.bool,
  /**
   * If `true`, the label is hidden.
   * This is used to increase density for a `FilledInput`.
   * Be sure to add `aria-label` to the `input` element.
   * @default false
   */
  hiddenLabel: propTypesExports.bool,
  /**
   * If `dense` or `normal`, will adjust vertical spacing of this and contained components.
   * @default 'none'
   */
  margin: propTypesExports.oneOf(['dense', 'none', 'normal']),
  /**
   * If `true`, the label will indicate that the `input` is required.
   * @default false
   */
  required: propTypesExports.bool,
  /**
   * The size of the component.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The variant to use.
   * @default 'outlined'
   */
  variant: propTypesExports.oneOf(['filled', 'outlined', 'standard'])
} : void 0;
var FormControl$1 = FormControl;

function useFormControl() {
  return React__namespace.useContext(FormControlContext$1);
}

function formControlState({
  props,
  states,
  muiFormControl
}) {
  return states.reduce((acc, state) => {
    acc[state] = props[state];
    if (muiFormControl) {
      if (typeof props[state] === 'undefined') {
        acc[state] = muiFormControl[state];
      }
    }
    return acc;
  }, {});
}

function GlobalStyles(props) {
  return /*#__PURE__*/jsxRuntimeExports.jsx(GlobalStyles$1, _extends$1({}, props, {
    defaultTheme: defaultTheme$2
  }));
}
browser$1.env.NODE_ENV !== "production" ? GlobalStyles.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The styles you want to apply globally.
   */
  styles: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.number, propTypesExports.object, propTypesExports.shape({
    __emotion_styles: propTypesExports.any.isRequired
  }), propTypesExports.string, propTypesExports.bool])
} : void 0;

function getInputBaseUtilityClass(slot) {
  return generateUtilityClass('MuiInputBase', slot);
}
const inputBaseClasses = generateUtilityClasses('MuiInputBase', ['root', 'formControl', 'focused', 'disabled', 'adornedStart', 'adornedEnd', 'error', 'sizeSmall', 'multiline', 'colorSecondary', 'fullWidth', 'hiddenLabel', 'readOnly', 'input', 'inputSizeSmall', 'inputMultiline', 'inputTypeSearch', 'inputAdornedStart', 'inputAdornedEnd', 'inputHiddenLabel']);
var inputBaseClasses$1 = inputBaseClasses;

const _excluded$1d = ["aria-describedby", "autoComplete", "autoFocus", "className", "color", "components", "componentsProps", "defaultValue", "disabled", "disableInjectingGlobalStyles", "endAdornment", "error", "fullWidth", "id", "inputComponent", "inputProps", "inputRef", "margin", "maxRows", "minRows", "multiline", "name", "onBlur", "onChange", "onClick", "onFocus", "onKeyDown", "onKeyUp", "placeholder", "readOnly", "renderSuffix", "rows", "size", "slotProps", "slots", "startAdornment", "type", "value"];
const rootOverridesResolver = (props, styles) => {
  const {
    ownerState
  } = props;
  return [styles.root, ownerState.formControl && styles.formControl, ownerState.startAdornment && styles.adornedStart, ownerState.endAdornment && styles.adornedEnd, ownerState.error && styles.error, ownerState.size === 'small' && styles.sizeSmall, ownerState.multiline && styles.multiline, ownerState.color && styles[`color${capitalize(ownerState.color)}`], ownerState.fullWidth && styles.fullWidth, ownerState.hiddenLabel && styles.hiddenLabel];
};
const inputOverridesResolver = (props, styles) => {
  const {
    ownerState
  } = props;
  return [styles.input, ownerState.size === 'small' && styles.inputSizeSmall, ownerState.multiline && styles.inputMultiline, ownerState.type === 'search' && styles.inputTypeSearch, ownerState.startAdornment && styles.inputAdornedStart, ownerState.endAdornment && styles.inputAdornedEnd, ownerState.hiddenLabel && styles.inputHiddenLabel];
};
const useUtilityClasses$G = ownerState => {
  const {
    classes,
    color,
    disabled,
    error,
    endAdornment,
    focused,
    formControl,
    fullWidth,
    hiddenLabel,
    multiline,
    readOnly,
    size,
    startAdornment,
    type
  } = ownerState;
  const slots = {
    root: ['root', `color${capitalize(color)}`, disabled && 'disabled', error && 'error', fullWidth && 'fullWidth', focused && 'focused', formControl && 'formControl', size === 'small' && 'sizeSmall', multiline && 'multiline', startAdornment && 'adornedStart', endAdornment && 'adornedEnd', hiddenLabel && 'hiddenLabel', readOnly && 'readOnly'],
    input: ['input', disabled && 'disabled', type === 'search' && 'inputTypeSearch', multiline && 'inputMultiline', size === 'small' && 'inputSizeSmall', hiddenLabel && 'inputHiddenLabel', startAdornment && 'inputAdornedStart', endAdornment && 'inputAdornedEnd', readOnly && 'readOnly']
  };
  return composeClasses(slots, getInputBaseUtilityClass, classes);
};
const InputBaseRoot = styled$1('div', {
  name: 'MuiInputBase',
  slot: 'Root',
  overridesResolver: rootOverridesResolver
})(({
  theme,
  ownerState
}) => _extends$1({}, theme.typography.body1, {
  color: (theme.vars || theme).palette.text.primary,
  lineHeight: '1.4375em',
  // 23px
  boxSizing: 'border-box',
  // Prevent padding issue with fullWidth.
  position: 'relative',
  cursor: 'text',
  display: 'inline-flex',
  alignItems: 'center',
  [`&.${inputBaseClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.text.disabled,
    cursor: 'default'
  }
}, ownerState.multiline && _extends$1({
  padding: '4px 0 5px'
}, ownerState.size === 'small' && {
  paddingTop: 1
}), ownerState.fullWidth && {
  width: '100%'
}));
const InputBaseComponent = styled$1('input', {
  name: 'MuiInputBase',
  slot: 'Input',
  overridesResolver: inputOverridesResolver
})(({
  theme,
  ownerState
}) => {
  const light = theme.palette.mode === 'light';
  const placeholder = _extends$1({
    color: 'currentColor'
  }, theme.vars ? {
    opacity: theme.vars.opacity.inputPlaceholder
  } : {
    opacity: light ? 0.42 : 0.5
  }, {
    transition: theme.transitions.create('opacity', {
      duration: theme.transitions.duration.shorter
    })
  });
  const placeholderHidden = {
    opacity: '0 !important'
  };
  const placeholderVisible = theme.vars ? {
    opacity: theme.vars.opacity.inputPlaceholder
  } : {
    opacity: light ? 0.42 : 0.5
  };
  return _extends$1({
    font: 'inherit',
    letterSpacing: 'inherit',
    color: 'currentColor',
    padding: '4px 0 5px',
    border: 0,
    boxSizing: 'content-box',
    background: 'none',
    height: '1.4375em',
    // Reset 23pxthe native input line-height
    margin: 0,
    // Reset for Safari
    WebkitTapHighlightColor: 'transparent',
    display: 'block',
    // Make the flex item shrink with Firefox
    minWidth: 0,
    width: '100%',
    // Fix IE11 width issue
    animationName: 'mui-auto-fill-cancel',
    animationDuration: '10ms',
    '&::-webkit-input-placeholder': placeholder,
    '&::-moz-placeholder': placeholder,
    // Firefox 19+
    '&:-ms-input-placeholder': placeholder,
    // IE11
    '&::-ms-input-placeholder': placeholder,
    // Edge
    '&:focus': {
      outline: 0
    },
    // Reset Firefox invalid required input style
    '&:invalid': {
      boxShadow: 'none'
    },
    '&::-webkit-search-decoration': {
      // Remove the padding when type=search.
      WebkitAppearance: 'none'
    },
    // Show and hide the placeholder logic
    [`label[data-shrink=false] + .${inputBaseClasses$1.formControl} &`]: {
      '&::-webkit-input-placeholder': placeholderHidden,
      '&::-moz-placeholder': placeholderHidden,
      // Firefox 19+
      '&:-ms-input-placeholder': placeholderHidden,
      // IE11
      '&::-ms-input-placeholder': placeholderHidden,
      // Edge
      '&:focus::-webkit-input-placeholder': placeholderVisible,
      '&:focus::-moz-placeholder': placeholderVisible,
      // Firefox 19+
      '&:focus:-ms-input-placeholder': placeholderVisible,
      // IE11
      '&:focus::-ms-input-placeholder': placeholderVisible // Edge
    },

    [`&.${inputBaseClasses$1.disabled}`]: {
      opacity: 1,
      // Reset iOS opacity
      WebkitTextFillColor: (theme.vars || theme).palette.text.disabled // Fix opacity Safari bug
    },

    '&:-webkit-autofill': {
      animationDuration: '5000s',
      animationName: 'mui-auto-fill'
    }
  }, ownerState.size === 'small' && {
    paddingTop: 1
  }, ownerState.multiline && {
    height: 'auto',
    resize: 'none',
    padding: 0,
    paddingTop: 0
  }, ownerState.type === 'search' && {
    // Improve type search style.
    MozAppearance: 'textfield'
  });
});
const inputGlobalStyles = /*#__PURE__*/jsxRuntimeExports.jsx(GlobalStyles, {
  styles: {
    '@keyframes mui-auto-fill': {
      from: {
        display: 'block'
      }
    },
    '@keyframes mui-auto-fill-cancel': {
      from: {
        display: 'block'
      }
    }
  }
});

/**
 * `InputBase` contains as few styles as possible.
 * It aims to be a simple building block for creating an input.
 * It contains a load of style reset and some state logic.
 */
const InputBase = /*#__PURE__*/React__namespace.forwardRef(function InputBase(inProps, ref) {
  var _slotProps$input;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiInputBase'
  });
  const {
      'aria-describedby': ariaDescribedby,
      autoComplete,
      autoFocus,
      className,
      components = {},
      componentsProps = {},
      defaultValue,
      disabled,
      disableInjectingGlobalStyles,
      endAdornment,
      fullWidth = false,
      id,
      inputComponent = 'input',
      inputProps: inputPropsProp = {},
      inputRef: inputRefProp,
      maxRows,
      minRows,
      multiline = false,
      name,
      onBlur,
      onChange,
      onClick,
      onFocus,
      onKeyDown,
      onKeyUp,
      placeholder,
      readOnly,
      renderSuffix,
      rows,
      slotProps = {},
      slots = {},
      startAdornment,
      type = 'text',
      value: valueProp
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1d);
  const value = inputPropsProp.value != null ? inputPropsProp.value : valueProp;
  const {
    current: isControlled
  } = React__namespace.useRef(value != null);
  const inputRef = React__namespace.useRef();
  const handleInputRefWarning = React__namespace.useCallback(instance => {
    if (browser$1.env.NODE_ENV !== 'production') {
      if (instance && instance.nodeName !== 'INPUT' && !instance.focus) {
        console.error(['MUI: You have provided a `inputComponent` to the input component', 'that does not correctly handle the `ref` prop.', 'Make sure the `ref` prop is called with a HTMLInputElement.'].join('\n'));
      }
    }
  }, []);
  const handleInputRef = useForkRef(inputRef, inputRefProp, inputPropsProp.ref, handleInputRefWarning);
  const [focused, setFocused] = React__namespace.useState(false);
  const muiFormControl = useFormControl();
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useEffect(() => {
      if (muiFormControl) {
        return muiFormControl.registerEffect();
      }
      return undefined;
    }, [muiFormControl]);
  }
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['color', 'disabled', 'error', 'hiddenLabel', 'size', 'required', 'filled']
  });
  fcs.focused = muiFormControl ? muiFormControl.focused : focused;

  // The blur won't fire when the disabled state is set on a focused input.
  // We need to book keep the focused state manually.
  React__namespace.useEffect(() => {
    if (!muiFormControl && disabled && focused) {
      setFocused(false);
      if (onBlur) {
        onBlur();
      }
    }
  }, [muiFormControl, disabled, focused, onBlur]);
  const onFilled = muiFormControl && muiFormControl.onFilled;
  const onEmpty = muiFormControl && muiFormControl.onEmpty;
  const checkDirty = React__namespace.useCallback(obj => {
    if (isFilled(obj)) {
      if (onFilled) {
        onFilled();
      }
    } else if (onEmpty) {
      onEmpty();
    }
  }, [onFilled, onEmpty]);
  useEnhancedEffect$1(() => {
    if (isControlled) {
      checkDirty({
        value
      });
    }
  }, [value, checkDirty, isControlled]);
  const handleFocus = event => {
    // Fix a bug with IE11 where the focus/blur events are triggered
    // while the component is disabled.
    if (fcs.disabled) {
      event.stopPropagation();
      return;
    }
    if (onFocus) {
      onFocus(event);
    }
    if (inputPropsProp.onFocus) {
      inputPropsProp.onFocus(event);
    }
    if (muiFormControl && muiFormControl.onFocus) {
      muiFormControl.onFocus(event);
    } else {
      setFocused(true);
    }
  };
  const handleBlur = event => {
    if (onBlur) {
      onBlur(event);
    }
    if (inputPropsProp.onBlur) {
      inputPropsProp.onBlur(event);
    }
    if (muiFormControl && muiFormControl.onBlur) {
      muiFormControl.onBlur(event);
    } else {
      setFocused(false);
    }
  };
  const handleChange = (event, ...args) => {
    if (!isControlled) {
      const element = event.target || inputRef.current;
      if (element == null) {
        throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: Expected valid input target. Did you use a custom \`inputComponent\` and forget to forward refs? See https://mui.com/r/input-component-ref-interface for more info.` : formatMuiErrorMessage(1));
      }
      checkDirty({
        value: element.value
      });
    }
    if (inputPropsProp.onChange) {
      inputPropsProp.onChange(event, ...args);
    }

    // Perform in the willUpdate
    if (onChange) {
      onChange(event, ...args);
    }
  };

  // Check the input state on mount, in case it was filled by the user
  // or auto filled by the browser before the hydration (for SSR).
  React__namespace.useEffect(() => {
    checkDirty(inputRef.current);
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  const handleClick = event => {
    if (inputRef.current && event.currentTarget === event.target) {
      inputRef.current.focus();
    }
    if (onClick) {
      onClick(event);
    }
  };
  let InputComponent = inputComponent;
  let inputProps = inputPropsProp;
  if (multiline && InputComponent === 'input') {
    if (rows) {
      if (browser$1.env.NODE_ENV !== 'production') {
        if (minRows || maxRows) {
          console.warn('MUI: You can not use the `minRows` or `maxRows` props when the input `rows` prop is set.');
        }
      }
      inputProps = _extends$1({
        type: undefined,
        minRows: rows,
        maxRows: rows
      }, inputProps);
    } else {
      inputProps = _extends$1({
        type: undefined,
        maxRows,
        minRows
      }, inputProps);
    }
    InputComponent = TextareaAutosize$1;
  }
  const handleAutoFill = event => {
    // Provide a fake value as Chrome might not let you access it for security reasons.
    checkDirty(event.animationName === 'mui-auto-fill-cancel' ? inputRef.current : {
      value: 'x'
    });
  };
  React__namespace.useEffect(() => {
    if (muiFormControl) {
      muiFormControl.setAdornedStart(Boolean(startAdornment));
    }
  }, [muiFormControl, startAdornment]);
  const ownerState = _extends$1({}, props, {
    color: fcs.color || 'primary',
    disabled: fcs.disabled,
    endAdornment,
    error: fcs.error,
    focused: fcs.focused,
    formControl: muiFormControl,
    fullWidth,
    hiddenLabel: fcs.hiddenLabel,
    multiline,
    size: fcs.size,
    startAdornment,
    type
  });
  const classes = useUtilityClasses$G(ownerState);
  const Root = slots.root || components.Root || InputBaseRoot;
  const rootProps = slotProps.root || componentsProps.root || {};
  const Input = slots.input || components.Input || InputBaseComponent;
  inputProps = _extends$1({}, inputProps, (_slotProps$input = slotProps.input) != null ? _slotProps$input : componentsProps.input);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
    children: [!disableInjectingGlobalStyles && inputGlobalStyles, /*#__PURE__*/jsxRuntimeExports.jsxs(Root, _extends$1({}, rootProps, !isHostComponent(Root) && {
      ownerState: _extends$1({}, ownerState, rootProps.ownerState)
    }, {
      ref: ref,
      onClick: handleClick
    }, other, {
      className: clsx(classes.root, rootProps.className, className, readOnly && 'MuiInputBase-readOnly'),
      children: [startAdornment, /*#__PURE__*/jsxRuntimeExports.jsx(FormControlContext$1.Provider, {
        value: null,
        children: /*#__PURE__*/jsxRuntimeExports.jsx(Input, _extends$1({
          ownerState: ownerState,
          "aria-invalid": fcs.error,
          "aria-describedby": ariaDescribedby,
          autoComplete: autoComplete,
          autoFocus: autoFocus,
          defaultValue: defaultValue,
          disabled: fcs.disabled,
          id: id,
          onAnimationStart: handleAutoFill,
          name: name,
          placeholder: placeholder,
          readOnly: readOnly,
          required: fcs.required,
          rows: rows,
          value: value,
          onKeyDown: onKeyDown,
          onKeyUp: onKeyUp,
          type: type
        }, inputProps, !isHostComponent(Input) && {
          as: InputComponent,
          ownerState: _extends$1({}, ownerState, inputProps.ownerState)
        }, {
          ref: handleInputRef,
          className: clsx(classes.input, inputProps.className, readOnly && 'MuiInputBase-readOnly'),
          onBlur: handleBlur,
          onChange: handleChange,
          onFocus: handleFocus
        }))
      }), endAdornment, renderSuffix ? renderSuffix(_extends$1({}, fcs, {
        startAdornment
      })) : null]
    }))]
  });
});
browser$1.env.NODE_ENV !== "production" ? InputBase.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * @ignore
   */
  'aria-describedby': propTypesExports.string,
  /**
   * This prop helps users to fill forms faster, especially on mobile devices.
   * The name can be confusing, as it's more like an autofill.
   * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
   */
  autoComplete: propTypesExports.string,
  /**
   * If `true`, the `input` element is focused during the first mount.
   */
  autoFocus: propTypesExports.bool,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `slots` prop.
   * It's recommended to use the `slots` prop instead.
   *
   * @default {}
   */
  components: propTypesExports.shape({
    Input: propTypesExports.elementType,
    Root: propTypesExports.elementType
  }),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `slotProps` prop.
   * It's recommended to use the `slotProps` prop instead, as `componentsProps` will be deprecated in the future.
   *
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    input: propTypesExports.object,
    root: propTypesExports.object
  }),
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * If `true`, the component is disabled.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, GlobalStyles for the auto-fill keyframes will not be injected/removed on mount/unmount. Make sure to inject them at the top of your application.
   * This option is intended to help with boosting the initial rendering performance if you are loading a big amount of Input components at once.
   * @default false
   */
  disableInjectingGlobalStyles: propTypesExports.bool,
  /**
   * End `InputAdornment` for this component.
   */
  endAdornment: propTypesExports.node,
  /**
   * If `true`, the `input` will indicate an error.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the `input` will take up the full width of its container.
   * @default false
   */
  fullWidth: propTypesExports.bool,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * The component used for the `input` element.
   * Either a string to use a HTML element or a component.
   * @default 'input'
   */
  inputComponent: elementTypeAcceptingRef$1,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   * @default {}
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * If `dense`, will adjust vertical spacing. This is normally obtained via context from
   * FormControl.
   * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
   */
  margin: propTypesExports.oneOf(['dense', 'none']),
  /**
   * Maximum number of rows to display when multiline option is set to true.
   */
  maxRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * Minimum number of rows to display when multiline option is set to true.
   */
  minRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * If `true`, a [TextareaAutosize](/material-ui/react-textarea-autosize/) element is rendered.
   * @default false
   */
  multiline: propTypesExports.bool,
  /**
   * Name attribute of the `input` element.
   */
  name: propTypesExports.string,
  /**
   * Callback fired when the `input` is blurred.
   *
   * Notice that the first argument (event) might be undefined.
   */
  onBlur: propTypesExports.func,
  /**
   * Callback fired when the value is changed.
   *
   * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypesExports.func,
  /**
   * @ignore
   */
  onClick: propTypesExports.func,
  /**
   * @ignore
   */
  onFocus: propTypesExports.func,
  /**
   * Callback fired when the `input` doesn't satisfy its constraints.
   */
  onInvalid: propTypesExports.func,
  /**
   * @ignore
   */
  onKeyDown: propTypesExports.func,
  /**
   * @ignore
   */
  onKeyUp: propTypesExports.func,
  /**
   * The short hint displayed in the `input` before the user enters a value.
   */
  placeholder: propTypesExports.string,
  /**
   * It prevents the user from changing the value of the field
   * (not from interacting with the field).
   */
  readOnly: propTypesExports.bool,
  /**
   * @ignore
   */
  renderSuffix: propTypesExports.func,
  /**
   * If `true`, the `input` element is required.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  required: propTypesExports.bool,
  /**
   * Number of rows to display when multiline option is set to true.
   */
  rows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * The size of the component.
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `componentsProps` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slotProps: propTypesExports.shape({
    input: propTypesExports.object,
    root: propTypesExports.object
  }),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `components` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slots: propTypesExports.shape({
    input: propTypesExports.elementType,
    root: propTypesExports.elementType
  }),
  /**
   * Start `InputAdornment` for this component.
   */
  startAdornment: propTypesExports.node,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
   * @default 'text'
   */
  type: propTypesExports.string,
  /**
   * The value of the `input` element, required for a controlled component.
   */
  value: propTypesExports.any
} : void 0;
var InputBase$1 = InputBase;

function getInputUtilityClass(slot) {
  return generateUtilityClass('MuiInput', slot);
}
const inputClasses = _extends$1({}, inputBaseClasses$1, generateUtilityClasses('MuiInput', ['root', 'underline', 'input']));
var inputClasses$1 = inputClasses;

const _excluded$1c = ["disableUnderline", "components", "componentsProps", "fullWidth", "inputComponent", "multiline", "slotProps", "slots", "type"];
const useUtilityClasses$F = ownerState => {
  const {
    classes,
    disableUnderline
  } = ownerState;
  const slots = {
    root: ['root', !disableUnderline && 'underline'],
    input: ['input']
  };
  const composedClasses = composeClasses(slots, getInputUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};
const InputRoot = styled$1(InputBaseRoot, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiInput',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [...rootOverridesResolver(props, styles), !ownerState.disableUnderline && styles.underline];
  }
})(({
  theme,
  ownerState
}) => {
  const light = theme.palette.mode === 'light';
  let bottomLineColor = light ? 'rgba(0, 0, 0, 0.42)' : 'rgba(255, 255, 255, 0.7)';
  if (theme.vars) {
    bottomLineColor = `rgba(${theme.vars.palette.common.onBackgroundChannel} / ${theme.vars.opacity.inputUnderline})`;
  }
  return _extends$1({
    position: 'relative'
  }, ownerState.formControl && {
    'label + &': {
      marginTop: 16
    }
  }, !ownerState.disableUnderline && {
    '&:after': {
      borderBottom: `2px solid ${(theme.vars || theme).palette[ownerState.color].main}`,
      left: 0,
      bottom: 0,
      // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
      content: '""',
      position: 'absolute',
      right: 0,
      transform: 'scaleX(0)',
      transition: theme.transitions.create('transform', {
        duration: theme.transitions.duration.shorter,
        easing: theme.transitions.easing.easeOut
      }),
      pointerEvents: 'none' // Transparent to the hover style.
    },

    [`&.${inputClasses$1.focused}:after`]: {
      // translateX(0) is a workaround for Safari transform scale bug
      // See https://github.com/mui/material-ui/issues/31766
      transform: 'scaleX(1) translateX(0)'
    },
    [`&.${inputClasses$1.error}`]: {
      '&:before, &:after': {
        borderBottomColor: (theme.vars || theme).palette.error.main
      }
    },
    '&:before': {
      borderBottom: `1px solid ${bottomLineColor}`,
      left: 0,
      bottom: 0,
      // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
      content: '"\\00a0"',
      position: 'absolute',
      right: 0,
      transition: theme.transitions.create('border-bottom-color', {
        duration: theme.transitions.duration.shorter
      }),
      pointerEvents: 'none' // Transparent to the hover style.
    },

    [`&:hover:not(.${inputClasses$1.disabled}, .${inputClasses$1.error}):before`]: {
      borderBottom: `2px solid ${(theme.vars || theme).palette.text.primary}`,
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        borderBottom: `1px solid ${bottomLineColor}`
      }
    },
    [`&.${inputClasses$1.disabled}:before`]: {
      borderBottomStyle: 'dotted'
    }
  });
});
const InputInput = styled$1(InputBaseComponent, {
  name: 'MuiInput',
  slot: 'Input',
  overridesResolver: inputOverridesResolver
})({});
const Input = /*#__PURE__*/React__namespace.forwardRef(function Input(inProps, ref) {
  var _ref, _slots$root, _ref2, _slots$input;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiInput'
  });
  const {
      disableUnderline,
      components = {},
      componentsProps: componentsPropsProp,
      fullWidth = false,
      inputComponent = 'input',
      multiline = false,
      slotProps,
      slots = {},
      type = 'text'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1c);
  const classes = useUtilityClasses$F(props);
  const ownerState = {
    disableUnderline
  };
  const inputComponentsProps = {
    root: {
      ownerState
    }
  };
  const componentsProps = (slotProps != null ? slotProps : componentsPropsProp) ? deepmerge(slotProps != null ? slotProps : componentsPropsProp, inputComponentsProps) : inputComponentsProps;
  const RootSlot = (_ref = (_slots$root = slots.root) != null ? _slots$root : components.Root) != null ? _ref : InputRoot;
  const InputSlot = (_ref2 = (_slots$input = slots.input) != null ? _slots$input : components.Input) != null ? _ref2 : InputInput;
  return /*#__PURE__*/jsxRuntimeExports.jsx(InputBase$1, _extends$1({
    slots: {
      root: RootSlot,
      input: InputSlot
    },
    slotProps: componentsProps,
    fullWidth: fullWidth,
    inputComponent: inputComponent,
    multiline: multiline,
    ref: ref,
    type: type
  }, other, {
    classes: classes
  }));
});
browser$1.env.NODE_ENV !== "production" ? Input.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * This prop helps users to fill forms faster, especially on mobile devices.
   * The name can be confusing, as it's more like an autofill.
   * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
   */
  autoComplete: propTypesExports.string,
  /**
   * If `true`, the `input` element is focused during the first mount.
   */
  autoFocus: propTypesExports.bool,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['primary', 'secondary']), propTypesExports.string]),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `slots` prop.
   * It's recommended to use the `slots` prop instead.
   *
   * @default {}
   */
  components: propTypesExports.shape({
    Input: propTypesExports.elementType,
    Root: propTypesExports.elementType
  }),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `slotProps` prop.
   * It's recommended to use the `slotProps` prop instead, as `componentsProps` will be deprecated in the future.
   *
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    input: propTypesExports.object,
    root: propTypesExports.object
  }),
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * If `true`, the component is disabled.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the `input` will not have an underline.
   */
  disableUnderline: propTypesExports.bool,
  /**
   * End `InputAdornment` for this component.
   */
  endAdornment: propTypesExports.node,
  /**
   * If `true`, the `input` will indicate an error.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the `input` will take up the full width of its container.
   * @default false
   */
  fullWidth: propTypesExports.bool,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * The component used for the `input` element.
   * Either a string to use a HTML element or a component.
   * @default 'input'
   */
  inputComponent: propTypesExports.elementType,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   * @default {}
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * If `dense`, will adjust vertical spacing. This is normally obtained via context from
   * FormControl.
   * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
   */
  margin: propTypesExports.oneOf(['dense', 'none']),
  /**
   * Maximum number of rows to display when multiline option is set to true.
   */
  maxRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * Minimum number of rows to display when multiline option is set to true.
   */
  minRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * If `true`, a [TextareaAutosize](/material-ui/react-textarea-autosize/) element is rendered.
   * @default false
   */
  multiline: propTypesExports.bool,
  /**
   * Name attribute of the `input` element.
   */
  name: propTypesExports.string,
  /**
   * Callback fired when the value is changed.
   *
   * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypesExports.func,
  /**
   * The short hint displayed in the `input` before the user enters a value.
   */
  placeholder: propTypesExports.string,
  /**
   * It prevents the user from changing the value of the field
   * (not from interacting with the field).
   */
  readOnly: propTypesExports.bool,
  /**
   * If `true`, the `input` element is required.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  required: propTypesExports.bool,
  /**
   * Number of rows to display when multiline option is set to true.
   */
  rows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `componentsProps` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slotProps: propTypesExports.shape({
    input: propTypesExports.object,
    root: propTypesExports.object
  }),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `components` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slots: propTypesExports.shape({
    input: propTypesExports.elementType,
    root: propTypesExports.elementType
  }),
  /**
   * Start `InputAdornment` for this component.
   */
  startAdornment: propTypesExports.node,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
   * @default 'text'
   */
  type: propTypesExports.string,
  /**
   * The value of the `input` element, required for a controlled component.
   */
  value: propTypesExports.any
} : void 0;
Input.muiName = 'Input';
var Input$1 = Input;

function getFilledInputUtilityClass(slot) {
  return generateUtilityClass('MuiFilledInput', slot);
}
const filledInputClasses = _extends$1({}, inputBaseClasses$1, generateUtilityClasses('MuiFilledInput', ['root', 'underline', 'input']));
var filledInputClasses$1 = filledInputClasses;

const _excluded$1b = ["disableUnderline", "components", "componentsProps", "fullWidth", "hiddenLabel", "inputComponent", "multiline", "slotProps", "slots", "type"];
const useUtilityClasses$E = ownerState => {
  const {
    classes,
    disableUnderline
  } = ownerState;
  const slots = {
    root: ['root', !disableUnderline && 'underline'],
    input: ['input']
  };
  const composedClasses = composeClasses(slots, getFilledInputUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};
const FilledInputRoot = styled$1(InputBaseRoot, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiFilledInput',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [...rootOverridesResolver(props, styles), !ownerState.disableUnderline && styles.underline];
  }
})(({
  theme,
  ownerState
}) => {
  var _palette;
  const light = theme.palette.mode === 'light';
  const bottomLineColor = light ? 'rgba(0, 0, 0, 0.42)' : 'rgba(255, 255, 255, 0.7)';
  const backgroundColor = light ? 'rgba(0, 0, 0, 0.06)' : 'rgba(255, 255, 255, 0.09)';
  const hoverBackground = light ? 'rgba(0, 0, 0, 0.09)' : 'rgba(255, 255, 255, 0.13)';
  const disabledBackground = light ? 'rgba(0, 0, 0, 0.12)' : 'rgba(255, 255, 255, 0.12)';
  return _extends$1({
    position: 'relative',
    backgroundColor: theme.vars ? theme.vars.palette.FilledInput.bg : backgroundColor,
    borderTopLeftRadius: (theme.vars || theme).shape.borderRadius,
    borderTopRightRadius: (theme.vars || theme).shape.borderRadius,
    transition: theme.transitions.create('background-color', {
      duration: theme.transitions.duration.shorter,
      easing: theme.transitions.easing.easeOut
    }),
    '&:hover': {
      backgroundColor: theme.vars ? theme.vars.palette.FilledInput.hoverBg : hoverBackground,
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        backgroundColor: theme.vars ? theme.vars.palette.FilledInput.bg : backgroundColor
      }
    },
    [`&.${filledInputClasses$1.focused}`]: {
      backgroundColor: theme.vars ? theme.vars.palette.FilledInput.bg : backgroundColor
    },
    [`&.${filledInputClasses$1.disabled}`]: {
      backgroundColor: theme.vars ? theme.vars.palette.FilledInput.disabledBg : disabledBackground
    }
  }, !ownerState.disableUnderline && {
    '&:after': {
      borderBottom: `2px solid ${(_palette = (theme.vars || theme).palette[ownerState.color || 'primary']) == null ? void 0 : _palette.main}`,
      left: 0,
      bottom: 0,
      // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
      content: '""',
      position: 'absolute',
      right: 0,
      transform: 'scaleX(0)',
      transition: theme.transitions.create('transform', {
        duration: theme.transitions.duration.shorter,
        easing: theme.transitions.easing.easeOut
      }),
      pointerEvents: 'none' // Transparent to the hover style.
    },

    [`&.${filledInputClasses$1.focused}:after`]: {
      // translateX(0) is a workaround for Safari transform scale bug
      // See https://github.com/mui/material-ui/issues/31766
      transform: 'scaleX(1) translateX(0)'
    },
    [`&.${filledInputClasses$1.error}`]: {
      '&:before, &:after': {
        borderBottomColor: (theme.vars || theme).palette.error.main
      }
    },
    '&:before': {
      borderBottom: `1px solid ${theme.vars ? `rgba(${theme.vars.palette.common.onBackgroundChannel} / ${theme.vars.opacity.inputUnderline})` : bottomLineColor}`,
      left: 0,
      bottom: 0,
      // Doing the other way around crash on IE11 "''" https://github.com/cssinjs/jss/issues/242
      content: '"\\00a0"',
      position: 'absolute',
      right: 0,
      transition: theme.transitions.create('border-bottom-color', {
        duration: theme.transitions.duration.shorter
      }),
      pointerEvents: 'none' // Transparent to the hover style.
    },

    [`&:hover:not(.${filledInputClasses$1.disabled}, .${filledInputClasses$1.error}):before`]: {
      borderBottom: `1px solid ${(theme.vars || theme).palette.text.primary}`
    },
    [`&.${filledInputClasses$1.disabled}:before`]: {
      borderBottomStyle: 'dotted'
    }
  }, ownerState.startAdornment && {
    paddingLeft: 12
  }, ownerState.endAdornment && {
    paddingRight: 12
  }, ownerState.multiline && _extends$1({
    padding: '25px 12px 8px'
  }, ownerState.size === 'small' && {
    paddingTop: 21,
    paddingBottom: 4
  }, ownerState.hiddenLabel && {
    paddingTop: 16,
    paddingBottom: 17
  }));
});
const FilledInputInput = styled$1(InputBaseComponent, {
  name: 'MuiFilledInput',
  slot: 'Input',
  overridesResolver: inputOverridesResolver
})(({
  theme,
  ownerState
}) => _extends$1({
  paddingTop: 25,
  paddingRight: 12,
  paddingBottom: 8,
  paddingLeft: 12
}, !theme.vars && {
  '&:-webkit-autofill': {
    WebkitBoxShadow: theme.palette.mode === 'light' ? null : '0 0 0 100px #266798 inset',
    WebkitTextFillColor: theme.palette.mode === 'light' ? null : '#fff',
    caretColor: theme.palette.mode === 'light' ? null : '#fff',
    borderTopLeftRadius: 'inherit',
    borderTopRightRadius: 'inherit'
  }
}, theme.vars && {
  '&:-webkit-autofill': {
    borderTopLeftRadius: 'inherit',
    borderTopRightRadius: 'inherit'
  },
  [theme.getColorSchemeSelector('dark')]: {
    '&:-webkit-autofill': {
      WebkitBoxShadow: '0 0 0 100px #266798 inset',
      WebkitTextFillColor: '#fff',
      caretColor: '#fff'
    }
  }
}, ownerState.size === 'small' && {
  paddingTop: 21,
  paddingBottom: 4
}, ownerState.hiddenLabel && {
  paddingTop: 16,
  paddingBottom: 17
}, ownerState.multiline && {
  paddingTop: 0,
  paddingBottom: 0,
  paddingLeft: 0,
  paddingRight: 0
}, ownerState.startAdornment && {
  paddingLeft: 0
}, ownerState.endAdornment && {
  paddingRight: 0
}, ownerState.hiddenLabel && ownerState.size === 'small' && {
  paddingTop: 8,
  paddingBottom: 9
}));
const FilledInput = /*#__PURE__*/React__namespace.forwardRef(function FilledInput(inProps, ref) {
  var _ref, _slots$root, _ref2, _slots$input;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiFilledInput'
  });
  const {
      components = {},
      componentsProps: componentsPropsProp,
      fullWidth = false,
      // declare here to prevent spreading to DOM
      inputComponent = 'input',
      multiline = false,
      slotProps,
      slots = {},
      type = 'text'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1b);
  const ownerState = _extends$1({}, props, {
    fullWidth,
    inputComponent,
    multiline,
    type
  });
  const classes = useUtilityClasses$E(props);
  const filledInputComponentsProps = {
    root: {
      ownerState
    },
    input: {
      ownerState
    }
  };
  const componentsProps = (slotProps != null ? slotProps : componentsPropsProp) ? deepmerge(slotProps != null ? slotProps : componentsPropsProp, filledInputComponentsProps) : filledInputComponentsProps;
  const RootSlot = (_ref = (_slots$root = slots.root) != null ? _slots$root : components.Root) != null ? _ref : FilledInputRoot;
  const InputSlot = (_ref2 = (_slots$input = slots.input) != null ? _slots$input : components.Input) != null ? _ref2 : FilledInputInput;
  return /*#__PURE__*/jsxRuntimeExports.jsx(InputBase$1, _extends$1({
    slots: {
      root: RootSlot,
      input: InputSlot
    },
    componentsProps: componentsProps,
    fullWidth: fullWidth,
    inputComponent: inputComponent,
    multiline: multiline,
    ref: ref,
    type: type
  }, other, {
    classes: classes
  }));
});
browser$1.env.NODE_ENV !== "production" ? FilledInput.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * This prop helps users to fill forms faster, especially on mobile devices.
   * The name can be confusing, as it's more like an autofill.
   * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
   */
  autoComplete: propTypesExports.string,
  /**
   * If `true`, the `input` element is focused during the first mount.
   */
  autoFocus: propTypesExports.bool,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['primary', 'secondary']), propTypesExports.string]),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `slots` prop.
   * It's recommended to use the `slots` prop instead.
   *
   * @default {}
   */
  components: propTypesExports.shape({
    Input: propTypesExports.elementType,
    Root: propTypesExports.elementType
  }),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `slotProps` prop.
   * It's recommended to use the `slotProps` prop instead, as `componentsProps` will be deprecated in the future.
   *
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    input: propTypesExports.object,
    root: propTypesExports.object
  }),
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * If `true`, the component is disabled.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the input will not have an underline.
   */
  disableUnderline: propTypesExports.bool,
  /**
   * End `InputAdornment` for this component.
   */
  endAdornment: propTypesExports.node,
  /**
   * If `true`, the `input` will indicate an error.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the `input` will take up the full width of its container.
   * @default false
   */
  fullWidth: propTypesExports.bool,
  /**
   * If `true`, the label is hidden.
   * This is used to increase density for a `FilledInput`.
   * Be sure to add `aria-label` to the `input` element.
   * @default false
   */
  hiddenLabel: propTypesExports.bool,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * The component used for the `input` element.
   * Either a string to use a HTML element or a component.
   * @default 'input'
   */
  inputComponent: propTypesExports.elementType,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   * @default {}
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * If `dense`, will adjust vertical spacing. This is normally obtained via context from
   * FormControl.
   * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
   */
  margin: propTypesExports.oneOf(['dense', 'none']),
  /**
   * Maximum number of rows to display when multiline option is set to true.
   */
  maxRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * Minimum number of rows to display when multiline option is set to true.
   */
  minRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * If `true`, a [TextareaAutosize](/material-ui/react-textarea-autosize/) element is rendered.
   * @default false
   */
  multiline: propTypesExports.bool,
  /**
   * Name attribute of the `input` element.
   */
  name: propTypesExports.string,
  /**
   * Callback fired when the value is changed.
   *
   * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypesExports.func,
  /**
   * The short hint displayed in the `input` before the user enters a value.
   */
  placeholder: propTypesExports.string,
  /**
   * It prevents the user from changing the value of the field
   * (not from interacting with the field).
   */
  readOnly: propTypesExports.bool,
  /**
   * If `true`, the `input` element is required.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  required: propTypesExports.bool,
  /**
   * Number of rows to display when multiline option is set to true.
   */
  rows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `componentsProps` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slotProps: propTypesExports.shape({
    input: propTypesExports.object,
    root: propTypesExports.object
  }),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `components` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slots: propTypesExports.shape({
    input: propTypesExports.elementType,
    root: propTypesExports.elementType
  }),
  /**
   * Start `InputAdornment` for this component.
   */
  startAdornment: propTypesExports.node,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
   * @default 'text'
   */
  type: propTypesExports.string,
  /**
   * The value of the `input` element, required for a controlled component.
   */
  value: propTypesExports.any
} : void 0;
FilledInput.muiName = 'Input';
var FilledInput$1 = FilledInput;

var _span$2;
const _excluded$1a = ["children", "classes", "className", "label", "notched"];
const NotchedOutlineRoot$1 = styled$1('fieldset')({
  textAlign: 'left',
  position: 'absolute',
  bottom: 0,
  right: 0,
  top: -5,
  left: 0,
  margin: 0,
  padding: '0 8px',
  pointerEvents: 'none',
  borderRadius: 'inherit',
  borderStyle: 'solid',
  borderWidth: 1,
  overflow: 'hidden',
  minWidth: '0%'
});
const NotchedOutlineLegend = styled$1('legend')(({
  ownerState,
  theme
}) => _extends$1({
  float: 'unset',
  // Fix conflict with bootstrap
  width: 'auto',
  // Fix conflict with bootstrap
  overflow: 'hidden'
}, !ownerState.withLabel && {
  padding: 0,
  lineHeight: '11px',
  // sync with `height` in `legend` styles
  transition: theme.transitions.create('width', {
    duration: 150,
    easing: theme.transitions.easing.easeOut
  })
}, ownerState.withLabel && _extends$1({
  display: 'block',
  // Fix conflict with normalize.css and sanitize.css
  padding: 0,
  height: 11,
  // sync with `lineHeight` in `legend` styles
  fontSize: '0.75em',
  visibility: 'hidden',
  maxWidth: 0.01,
  transition: theme.transitions.create('max-width', {
    duration: 50,
    easing: theme.transitions.easing.easeOut
  }),
  whiteSpace: 'nowrap',
  '& > span': {
    paddingLeft: 5,
    paddingRight: 5,
    display: 'inline-block',
    opacity: 0,
    visibility: 'visible'
  }
}, ownerState.notched && {
  maxWidth: '100%',
  transition: theme.transitions.create('max-width', {
    duration: 100,
    easing: theme.transitions.easing.easeOut,
    delay: 50
  })
})));

/**
 * @ignore - internal component.
 */
function NotchedOutline(props) {
  const {
      className,
      label,
      notched
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$1a);
  const withLabel = label != null && label !== '';
  const ownerState = _extends$1({}, props, {
    notched,
    withLabel
  });
  return /*#__PURE__*/jsxRuntimeExports.jsx(NotchedOutlineRoot$1, _extends$1({
    "aria-hidden": true,
    className: className,
    ownerState: ownerState
  }, other, {
    children: /*#__PURE__*/jsxRuntimeExports.jsx(NotchedOutlineLegend, {
      ownerState: ownerState,
      children: withLabel ? /*#__PURE__*/jsxRuntimeExports.jsx("span", {
        children: label
      }) : // notranslate needed while Google Translate will not fix zero-width space issue
      _span$2 || (_span$2 = /*#__PURE__*/jsxRuntimeExports.jsx("span", {
        className: "notranslate",
        children: "\u200B"
      }))
    })
  }));
}
browser$1.env.NODE_ENV !== "production" ? NotchedOutline.propTypes = {
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The label.
   */
  label: propTypesExports.node,
  /**
   * If `true`, the outline is notched to accommodate the label.
   */
  notched: propTypesExports.bool.isRequired,
  /**
   * @ignore
   */
  style: propTypesExports.object
} : void 0;

function getOutlinedInputUtilityClass(slot) {
  return generateUtilityClass('MuiOutlinedInput', slot);
}
const outlinedInputClasses = _extends$1({}, inputBaseClasses$1, generateUtilityClasses('MuiOutlinedInput', ['root', 'notchedOutline', 'input']));
var outlinedInputClasses$1 = outlinedInputClasses;

const _excluded$19 = ["components", "fullWidth", "inputComponent", "label", "multiline", "notched", "slots", "type"];
const useUtilityClasses$D = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root'],
    notchedOutline: ['notchedOutline'],
    input: ['input']
  };
  const composedClasses = composeClasses(slots, getOutlinedInputUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};
const OutlinedInputRoot = styled$1(InputBaseRoot, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiOutlinedInput',
  slot: 'Root',
  overridesResolver: rootOverridesResolver
})(({
  theme,
  ownerState
}) => {
  const borderColor = theme.palette.mode === 'light' ? 'rgba(0, 0, 0, 0.23)' : 'rgba(255, 255, 255, 0.23)';
  return _extends$1({
    position: 'relative',
    borderRadius: (theme.vars || theme).shape.borderRadius,
    [`&:hover .${outlinedInputClasses$1.notchedOutline}`]: {
      borderColor: (theme.vars || theme).palette.text.primary
    },
    // Reset on touch devices, it doesn't add specificity
    '@media (hover: none)': {
      [`&:hover .${outlinedInputClasses$1.notchedOutline}`]: {
        borderColor: theme.vars ? `rgba(${theme.vars.palette.common.onBackgroundChannel} / 0.23)` : borderColor
      }
    },
    [`&.${outlinedInputClasses$1.focused} .${outlinedInputClasses$1.notchedOutline}`]: {
      borderColor: (theme.vars || theme).palette[ownerState.color].main,
      borderWidth: 2
    },
    [`&.${outlinedInputClasses$1.error} .${outlinedInputClasses$1.notchedOutline}`]: {
      borderColor: (theme.vars || theme).palette.error.main
    },
    [`&.${outlinedInputClasses$1.disabled} .${outlinedInputClasses$1.notchedOutline}`]: {
      borderColor: (theme.vars || theme).palette.action.disabled
    }
  }, ownerState.startAdornment && {
    paddingLeft: 14
  }, ownerState.endAdornment && {
    paddingRight: 14
  }, ownerState.multiline && _extends$1({
    padding: '16.5px 14px'
  }, ownerState.size === 'small' && {
    padding: '8.5px 14px'
  }));
});
const NotchedOutlineRoot = styled$1(NotchedOutline, {
  name: 'MuiOutlinedInput',
  slot: 'NotchedOutline',
  overridesResolver: (props, styles) => styles.notchedOutline
})(({
  theme
}) => {
  const borderColor = theme.palette.mode === 'light' ? 'rgba(0, 0, 0, 0.23)' : 'rgba(255, 255, 255, 0.23)';
  return {
    borderColor: theme.vars ? `rgba(${theme.vars.palette.common.onBackgroundChannel} / 0.23)` : borderColor
  };
});
const OutlinedInputInput = styled$1(InputBaseComponent, {
  name: 'MuiOutlinedInput',
  slot: 'Input',
  overridesResolver: inputOverridesResolver
})(({
  theme,
  ownerState
}) => _extends$1({
  padding: '16.5px 14px'
}, !theme.vars && {
  '&:-webkit-autofill': {
    WebkitBoxShadow: theme.palette.mode === 'light' ? null : '0 0 0 100px #266798 inset',
    WebkitTextFillColor: theme.palette.mode === 'light' ? null : '#fff',
    caretColor: theme.palette.mode === 'light' ? null : '#fff',
    borderRadius: 'inherit'
  }
}, theme.vars && {
  '&:-webkit-autofill': {
    borderRadius: 'inherit'
  },
  [theme.getColorSchemeSelector('dark')]: {
    '&:-webkit-autofill': {
      WebkitBoxShadow: '0 0 0 100px #266798 inset',
      WebkitTextFillColor: '#fff',
      caretColor: '#fff'
    }
  }
}, ownerState.size === 'small' && {
  padding: '8.5px 14px'
}, ownerState.multiline && {
  padding: 0
}, ownerState.startAdornment && {
  paddingLeft: 0
}, ownerState.endAdornment && {
  paddingRight: 0
}));
const OutlinedInput = /*#__PURE__*/React__namespace.forwardRef(function OutlinedInput(inProps, ref) {
  var _ref, _slots$root, _ref2, _slots$input, _React$Fragment;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiOutlinedInput'
  });
  const {
      components = {},
      fullWidth = false,
      inputComponent = 'input',
      label,
      multiline = false,
      notched,
      slots = {},
      type = 'text'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$19);
  const classes = useUtilityClasses$D(props);
  const muiFormControl = useFormControl();
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['required']
  });
  const ownerState = _extends$1({}, props, {
    color: fcs.color || 'primary',
    disabled: fcs.disabled,
    error: fcs.error,
    focused: fcs.focused,
    formControl: muiFormControl,
    fullWidth,
    hiddenLabel: fcs.hiddenLabel,
    multiline,
    size: fcs.size,
    type
  });
  const RootSlot = (_ref = (_slots$root = slots.root) != null ? _slots$root : components.Root) != null ? _ref : OutlinedInputRoot;
  const InputSlot = (_ref2 = (_slots$input = slots.input) != null ? _slots$input : components.Input) != null ? _ref2 : OutlinedInputInput;
  return /*#__PURE__*/jsxRuntimeExports.jsx(InputBase$1, _extends$1({
    slots: {
      root: RootSlot,
      input: InputSlot
    },
    renderSuffix: state => /*#__PURE__*/jsxRuntimeExports.jsx(NotchedOutlineRoot, {
      ownerState: ownerState,
      className: classes.notchedOutline,
      label: label != null && label !== '' && fcs.required ? _React$Fragment || (_React$Fragment = /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
        children: [label, "\u2009", '*']
      })) : label,
      notched: typeof notched !== 'undefined' ? notched : Boolean(state.startAdornment || state.filled || state.focused)
    }),
    fullWidth: fullWidth,
    inputComponent: inputComponent,
    multiline: multiline,
    ref: ref,
    type: type
  }, other, {
    classes: _extends$1({}, classes, {
      notchedOutline: null
    })
  }));
});
browser$1.env.NODE_ENV !== "production" ? OutlinedInput.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * This prop helps users to fill forms faster, especially on mobile devices.
   * The name can be confusing, as it's more like an autofill.
   * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
   */
  autoComplete: propTypesExports.string,
  /**
   * If `true`, the `input` element is focused during the first mount.
   */
  autoFocus: propTypesExports.bool,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * The prop defaults to the value (`'primary'`) inherited from the parent FormControl component.
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['primary', 'secondary']), propTypesExports.string]),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `slots` prop.
   * It's recommended to use the `slots` prop instead.
   *
   * @default {}
   */
  components: propTypesExports.shape({
    Input: propTypesExports.elementType,
    Root: propTypesExports.elementType
  }),
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * If `true`, the component is disabled.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  disabled: propTypesExports.bool,
  /**
   * End `InputAdornment` for this component.
   */
  endAdornment: propTypesExports.node,
  /**
   * If `true`, the `input` will indicate an error.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the `input` will take up the full width of its container.
   * @default false
   */
  fullWidth: propTypesExports.bool,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * The component used for the `input` element.
   * Either a string to use a HTML element or a component.
   * @default 'input'
   */
  inputComponent: propTypesExports.elementType,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   * @default {}
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * The label of the `input`. It is only used for layout. The actual labelling
   * is handled by `InputLabel`.
   */
  label: propTypesExports.node,
  /**
   * If `dense`, will adjust vertical spacing. This is normally obtained via context from
   * FormControl.
   * The prop defaults to the value (`'none'`) inherited from the parent FormControl component.
   */
  margin: propTypesExports.oneOf(['dense', 'none']),
  /**
   * Maximum number of rows to display when multiline option is set to true.
   */
  maxRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * Minimum number of rows to display when multiline option is set to true.
   */
  minRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * If `true`, a [TextareaAutosize](/material-ui/react-textarea-autosize/) element is rendered.
   * @default false
   */
  multiline: propTypesExports.bool,
  /**
   * Name attribute of the `input` element.
   */
  name: propTypesExports.string,
  /**
   * If `true`, the outline is notched to accommodate the label.
   */
  notched: propTypesExports.bool,
  /**
   * Callback fired when the value is changed.
   *
   * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypesExports.func,
  /**
   * The short hint displayed in the `input` before the user enters a value.
   */
  placeholder: propTypesExports.string,
  /**
   * It prevents the user from changing the value of the field
   * (not from interacting with the field).
   */
  readOnly: propTypesExports.bool,
  /**
   * If `true`, the `input` element is required.
   * The prop defaults to the value (`false`) inherited from the parent FormControl component.
   */
  required: propTypesExports.bool,
  /**
   * Number of rows to display when multiline option is set to true.
   */
  rows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `components` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slots: propTypesExports.shape({
    input: propTypesExports.elementType,
    root: propTypesExports.elementType
  }),
  /**
   * Start `InputAdornment` for this component.
   */
  startAdornment: propTypesExports.node,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
   * @default 'text'
   */
  type: propTypesExports.string,
  /**
   * The value of the `input` element, required for a controlled component.
   */
  value: propTypesExports.any
} : void 0;
OutlinedInput.muiName = 'Input';
var OutlinedInput$1 = OutlinedInput;

function getFormLabelUtilityClasses(slot) {
  return generateUtilityClass('MuiFormLabel', slot);
}
const formLabelClasses = generateUtilityClasses('MuiFormLabel', ['root', 'colorSecondary', 'focused', 'disabled', 'error', 'filled', 'required', 'asterisk']);
var formLabelClasses$1 = formLabelClasses;

const _excluded$18 = ["children", "className", "color", "component", "disabled", "error", "filled", "focused", "required"];
const useUtilityClasses$C = ownerState => {
  const {
    classes,
    color,
    focused,
    disabled,
    error,
    filled,
    required
  } = ownerState;
  const slots = {
    root: ['root', `color${capitalize(color)}`, disabled && 'disabled', error && 'error', filled && 'filled', focused && 'focused', required && 'required'],
    asterisk: ['asterisk', error && 'error']
  };
  return composeClasses(slots, getFormLabelUtilityClasses, classes);
};
const FormLabelRoot = styled$1('label', {
  name: 'MuiFormLabel',
  slot: 'Root',
  overridesResolver: ({
    ownerState
  }, styles) => {
    return _extends$1({}, styles.root, ownerState.color === 'secondary' && styles.colorSecondary, ownerState.filled && styles.filled);
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  color: (theme.vars || theme).palette.text.secondary
}, theme.typography.body1, {
  lineHeight: '1.4375em',
  padding: 0,
  position: 'relative',
  [`&.${formLabelClasses$1.focused}`]: {
    color: (theme.vars || theme).palette[ownerState.color].main
  },
  [`&.${formLabelClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.text.disabled
  },
  [`&.${formLabelClasses$1.error}`]: {
    color: (theme.vars || theme).palette.error.main
  }
}));
const AsteriskComponent = styled$1('span', {
  name: 'MuiFormLabel',
  slot: 'Asterisk',
  overridesResolver: (props, styles) => styles.asterisk
})(({
  theme
}) => ({
  [`&.${formLabelClasses$1.error}`]: {
    color: (theme.vars || theme).palette.error.main
  }
}));
const FormLabel = /*#__PURE__*/React__namespace.forwardRef(function FormLabel(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiFormLabel'
  });
  const {
      children,
      className,
      component = 'label'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$18);
  const muiFormControl = useFormControl();
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['color', 'required', 'focused', 'disabled', 'error', 'filled']
  });
  const ownerState = _extends$1({}, props, {
    color: fcs.color || 'primary',
    component,
    disabled: fcs.disabled,
    error: fcs.error,
    filled: fcs.filled,
    focused: fcs.focused,
    required: fcs.required
  });
  const classes = useUtilityClasses$C(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(FormLabelRoot, _extends$1({
    as: component,
    ownerState: ownerState,
    className: clsx(classes.root, className),
    ref: ref
  }, other, {
    children: [children, fcs.required && /*#__PURE__*/jsxRuntimeExports.jsxs(AsteriskComponent, {
      ownerState: ownerState,
      "aria-hidden": true,
      className: classes.asterisk,
      children: ["\u2009", '*']
    })]
  }));
});
browser$1.env.NODE_ENV !== "production" ? FormLabel.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['error', 'info', 'primary', 'secondary', 'success', 'warning']), propTypesExports.string]),
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, the label should be displayed in a disabled state.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the label is displayed in an error state.
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the label should use filled classes key.
   */
  filled: propTypesExports.bool,
  /**
   * If `true`, the input of this label is focused (used by `FormGroup` components).
   */
  focused: propTypesExports.bool,
  /**
   * If `true`, the label will indicate that the `input` is required.
   */
  required: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var FormLabel$1 = FormLabel;

function getInputLabelUtilityClasses(slot) {
  return generateUtilityClass('MuiInputLabel', slot);
}
generateUtilityClasses('MuiInputLabel', ['root', 'focused', 'disabled', 'error', 'required', 'asterisk', 'formControl', 'sizeSmall', 'shrink', 'animated', 'standard', 'filled', 'outlined']);

const _excluded$17 = ["disableAnimation", "margin", "shrink", "variant", "className"];
const useUtilityClasses$B = ownerState => {
  const {
    classes,
    formControl,
    size,
    shrink,
    disableAnimation,
    variant,
    required
  } = ownerState;
  const slots = {
    root: ['root', formControl && 'formControl', !disableAnimation && 'animated', shrink && 'shrink', size === 'small' && 'sizeSmall', variant],
    asterisk: [required && 'asterisk']
  };
  const composedClasses = composeClasses(slots, getInputLabelUtilityClasses, classes);
  return _extends$1({}, classes, composedClasses);
};
const InputLabelRoot = styled$1(FormLabel$1, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiInputLabel',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [{
      [`& .${formLabelClasses$1.asterisk}`]: styles.asterisk
    }, styles.root, ownerState.formControl && styles.formControl, ownerState.size === 'small' && styles.sizeSmall, ownerState.shrink && styles.shrink, !ownerState.disableAnimation && styles.animated, styles[ownerState.variant]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  display: 'block',
  transformOrigin: 'top left',
  whiteSpace: 'nowrap',
  overflow: 'hidden',
  textOverflow: 'ellipsis',
  maxWidth: '100%'
}, ownerState.formControl && {
  position: 'absolute',
  left: 0,
  top: 0,
  // slight alteration to spec spacing to match visual spec result
  transform: 'translate(0, 20px) scale(1)'
}, ownerState.size === 'small' && {
  // Compensation for the `Input.inputSizeSmall` style.
  transform: 'translate(0, 17px) scale(1)'
}, ownerState.shrink && {
  transform: 'translate(0, -1.5px) scale(0.75)',
  transformOrigin: 'top left',
  maxWidth: '133%'
}, !ownerState.disableAnimation && {
  transition: theme.transitions.create(['color', 'transform', 'max-width'], {
    duration: theme.transitions.duration.shorter,
    easing: theme.transitions.easing.easeOut
  })
}, ownerState.variant === 'filled' && _extends$1({
  // Chrome's autofill feature gives the input field a yellow background.
  // Since the input field is behind the label in the HTML tree,
  // the input field is drawn last and hides the label with an opaque background color.
  // zIndex: 1 will raise the label above opaque background-colors of input.
  zIndex: 1,
  pointerEvents: 'none',
  transform: 'translate(12px, 16px) scale(1)',
  maxWidth: 'calc(100% - 24px)'
}, ownerState.size === 'small' && {
  transform: 'translate(12px, 13px) scale(1)'
}, ownerState.shrink && _extends$1({
  userSelect: 'none',
  pointerEvents: 'auto',
  transform: 'translate(12px, 7px) scale(0.75)',
  maxWidth: 'calc(133% - 24px)'
}, ownerState.size === 'small' && {
  transform: 'translate(12px, 4px) scale(0.75)'
})), ownerState.variant === 'outlined' && _extends$1({
  // see comment above on filled.zIndex
  zIndex: 1,
  pointerEvents: 'none',
  transform: 'translate(14px, 16px) scale(1)',
  maxWidth: 'calc(100% - 24px)'
}, ownerState.size === 'small' && {
  transform: 'translate(14px, 9px) scale(1)'
}, ownerState.shrink && {
  userSelect: 'none',
  pointerEvents: 'auto',
  // Theoretically, we should have (8+5)*2/0.75 = 34px
  // but it feels a better when it bleeds a bit on the left, so 32px.
  maxWidth: 'calc(133% - 32px)',
  transform: 'translate(14px, -9px) scale(0.75)'
})));
const InputLabel = /*#__PURE__*/React__namespace.forwardRef(function InputLabel(inProps, ref) {
  const props = useThemeProps({
    name: 'MuiInputLabel',
    props: inProps
  });
  const {
      disableAnimation = false,
      shrink: shrinkProp,
      className
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$17);
  const muiFormControl = useFormControl();
  let shrink = shrinkProp;
  if (typeof shrink === 'undefined' && muiFormControl) {
    shrink = muiFormControl.filled || muiFormControl.focused || muiFormControl.adornedStart;
  }
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['size', 'variant', 'required']
  });
  const ownerState = _extends$1({}, props, {
    disableAnimation,
    formControl: muiFormControl,
    shrink,
    size: fcs.size,
    variant: fcs.variant,
    required: fcs.required
  });
  const classes = useUtilityClasses$B(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(InputLabelRoot, _extends$1({
    "data-shrink": shrink,
    ownerState: ownerState,
    ref: ref,
    className: clsx(classes.root, className)
  }, other, {
    classes: classes
  }));
});
browser$1.env.NODE_ENV !== "production" ? InputLabel.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['error', 'info', 'primary', 'secondary', 'success', 'warning']), propTypesExports.string]),
  /**
   * If `true`, the transition animation is disabled.
   * @default false
   */
  disableAnimation: propTypesExports.bool,
  /**
   * If `true`, the component is disabled.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the label is displayed in an error state.
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the `input` of this label is focused.
   */
  focused: propTypesExports.bool,
  /**
   * If `dense`, will adjust vertical spacing. This is normally obtained via context from
   * FormControl.
   */
  margin: propTypesExports.oneOf(['dense']),
  /**
   * if `true`, the label will indicate that the `input` is required.
   */
  required: propTypesExports.bool,
  /**
   * If `true`, the label is shrunk.
   */
  shrink: propTypesExports.bool,
  /**
   * The size of the component.
   * @default 'normal'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['normal', 'small']), propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The variant to use.
   */
  variant: propTypesExports.oneOf(['filled', 'outlined', 'standard'])
} : void 0;
var InputLabel$1 = InputLabel;

function getFormHelperTextUtilityClasses(slot) {
  return generateUtilityClass('MuiFormHelperText', slot);
}
const formHelperTextClasses = generateUtilityClasses('MuiFormHelperText', ['root', 'error', 'disabled', 'sizeSmall', 'sizeMedium', 'contained', 'focused', 'filled', 'required']);
var formHelperTextClasses$1 = formHelperTextClasses;

var _span$1;
const _excluded$16 = ["children", "className", "component", "disabled", "error", "filled", "focused", "margin", "required", "variant"];
const useUtilityClasses$A = ownerState => {
  const {
    classes,
    contained,
    size,
    disabled,
    error,
    filled,
    focused,
    required
  } = ownerState;
  const slots = {
    root: ['root', disabled && 'disabled', error && 'error', size && `size${capitalize(size)}`, contained && 'contained', focused && 'focused', filled && 'filled', required && 'required']
  };
  return composeClasses(slots, getFormHelperTextUtilityClasses, classes);
};
const FormHelperTextRoot = styled$1('p', {
  name: 'MuiFormHelperText',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.size && styles[`size${capitalize(ownerState.size)}`], ownerState.contained && styles.contained, ownerState.filled && styles.filled];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  color: (theme.vars || theme).palette.text.secondary
}, theme.typography.caption, {
  textAlign: 'left',
  marginTop: 3,
  marginRight: 0,
  marginBottom: 0,
  marginLeft: 0,
  [`&.${formHelperTextClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.text.disabled
  },
  [`&.${formHelperTextClasses$1.error}`]: {
    color: (theme.vars || theme).palette.error.main
  }
}, ownerState.size === 'small' && {
  marginTop: 4
}, ownerState.contained && {
  marginLeft: 14,
  marginRight: 14
}));
const FormHelperText = /*#__PURE__*/React__namespace.forwardRef(function FormHelperText(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiFormHelperText'
  });
  const {
      children,
      className,
      component = 'p'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$16);
  const muiFormControl = useFormControl();
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['variant', 'size', 'disabled', 'error', 'filled', 'focused', 'required']
  });
  const ownerState = _extends$1({}, props, {
    component,
    contained: fcs.variant === 'filled' || fcs.variant === 'outlined',
    variant: fcs.variant,
    size: fcs.size,
    disabled: fcs.disabled,
    error: fcs.error,
    filled: fcs.filled,
    focused: fcs.focused,
    required: fcs.required
  });
  const classes = useUtilityClasses$A(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(FormHelperTextRoot, _extends$1({
    as: component,
    ownerState: ownerState,
    className: clsx(classes.root, className),
    ref: ref
  }, other, {
    children: children === ' ' ? // notranslate needed while Google Translate will not fix zero-width space issue
    _span$1 || (_span$1 = /*#__PURE__*/jsxRuntimeExports.jsx("span", {
      className: "notranslate",
      children: "\u200B"
    })) : children
  }));
});
browser$1.env.NODE_ENV !== "production" ? FormHelperText.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   *
   * If `' '` is provided, the component reserves one line height for displaying a future message.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, the helper text should be displayed in a disabled state.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, helper text should be displayed in an error state.
   */
  error: propTypesExports.bool,
  /**
   * If `true`, the helper text should use filled classes key.
   */
  filled: propTypesExports.bool,
  /**
   * If `true`, the helper text should use focused classes key.
   */
  focused: propTypesExports.bool,
  /**
   * If `dense`, will adjust vertical spacing. This is normally obtained via context from
   * FormControl.
   */
  margin: propTypesExports.oneOf(['dense']),
  /**
   * If `true`, the helper text should use required classes key.
   */
  required: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The variant to use.
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['filled', 'outlined', 'standard']), propTypesExports.string])
} : void 0;
var FormHelperText$1 = FormHelperText;

const reflow = node => node.scrollTop;
function getTransitionProps(props, options) {
  var _style$transitionDura, _style$transitionTimi;
  const {
    timeout,
    easing,
    style = {}
  } = props;
  return {
    duration: (_style$transitionDura = style.transitionDuration) != null ? _style$transitionDura : typeof timeout === 'number' ? timeout : timeout[options.mode] || 0,
    easing: (_style$transitionTimi = style.transitionTimingFunction) != null ? _style$transitionTimi : typeof easing === 'object' ? easing[options.mode] : easing,
    delay: style.transitionDelay
  };
}

const _excluded$15 = ["addEndListener", "appear", "children", "easing", "in", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "style", "timeout", "TransitionComponent"];
function getScale(value) {
  return `scale(${value}, ${value ** 2})`;
}
const styles$3 = {
  entering: {
    opacity: 1,
    transform: getScale(1)
  },
  entered: {
    opacity: 1,
    transform: 'none'
  }
};

/*
 TODO v6: remove
 Conditionally apply a workaround for the CSS transition bug in Safari 15.4 / WebKit browsers.
 */
const isWebKit154 = typeof navigator !== 'undefined' && /^((?!chrome|android).)*(safari|mobile)/i.test(navigator.userAgent) && /(os |version\/)15(.|_)4/i.test(navigator.userAgent);

/**
 * The Grow transition is used by the [Tooltip](/material-ui/react-tooltip/) and
 * [Popover](/material-ui/react-popover/) components.
 * It uses [react-transition-group](https://github.com/reactjs/react-transition-group) internally.
 */
const Grow = /*#__PURE__*/React__namespace.forwardRef(function Grow(props, ref) {
  const {
      addEndListener,
      appear = true,
      children,
      easing,
      in: inProp,
      onEnter,
      onEntered,
      onEntering,
      onExit,
      onExited,
      onExiting,
      style,
      timeout = 'auto',
      // eslint-disable-next-line react/prop-types
      TransitionComponent = Transition$1
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$15);
  const timer = React__namespace.useRef();
  const autoTimeout = React__namespace.useRef();
  const theme = useTheme$1();
  const nodeRef = React__namespace.useRef(null);
  const handleRef = useForkRef(nodeRef, children.ref, ref);
  const normalizedTransitionCallback = callback => maybeIsAppearing => {
    if (callback) {
      const node = nodeRef.current;

      // onEnterXxx and onExitXxx callbacks have a different arguments.length value.
      if (maybeIsAppearing === undefined) {
        callback(node);
      } else {
        callback(node, maybeIsAppearing);
      }
    }
  };
  const handleEntering = normalizedTransitionCallback(onEntering);
  const handleEnter = normalizedTransitionCallback((node, isAppearing) => {
    reflow(node); // So the animation always start from the start.

    const {
      duration: transitionDuration,
      delay,
      easing: transitionTimingFunction
    } = getTransitionProps({
      style,
      timeout,
      easing
    }, {
      mode: 'enter'
    });
    let duration;
    if (timeout === 'auto') {
      duration = theme.transitions.getAutoHeightDuration(node.clientHeight);
      autoTimeout.current = duration;
    } else {
      duration = transitionDuration;
    }
    node.style.transition = [theme.transitions.create('opacity', {
      duration,
      delay
    }), theme.transitions.create('transform', {
      duration: isWebKit154 ? duration : duration * 0.666,
      delay,
      easing: transitionTimingFunction
    })].join(',');
    if (onEnter) {
      onEnter(node, isAppearing);
    }
  });
  const handleEntered = normalizedTransitionCallback(onEntered);
  const handleExiting = normalizedTransitionCallback(onExiting);
  const handleExit = normalizedTransitionCallback(node => {
    const {
      duration: transitionDuration,
      delay,
      easing: transitionTimingFunction
    } = getTransitionProps({
      style,
      timeout,
      easing
    }, {
      mode: 'exit'
    });
    let duration;
    if (timeout === 'auto') {
      duration = theme.transitions.getAutoHeightDuration(node.clientHeight);
      autoTimeout.current = duration;
    } else {
      duration = transitionDuration;
    }
    node.style.transition = [theme.transitions.create('opacity', {
      duration,
      delay
    }), theme.transitions.create('transform', {
      duration: isWebKit154 ? duration : duration * 0.666,
      delay: isWebKit154 ? delay : delay || duration * 0.333,
      easing: transitionTimingFunction
    })].join(',');
    node.style.opacity = 0;
    node.style.transform = getScale(0.75);
    if (onExit) {
      onExit(node);
    }
  });
  const handleExited = normalizedTransitionCallback(onExited);
  const handleAddEndListener = next => {
    if (timeout === 'auto') {
      timer.current = setTimeout(next, autoTimeout.current || 0);
    }
    if (addEndListener) {
      // Old call signature before `react-transition-group` implemented `nodeRef`
      addEndListener(nodeRef.current, next);
    }
  };
  React__namespace.useEffect(() => {
    return () => {
      clearTimeout(timer.current);
    };
  }, []);
  return /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
    appear: appear,
    in: inProp,
    nodeRef: nodeRef,
    onEnter: handleEnter,
    onEntered: handleEntered,
    onEntering: handleEntering,
    onExit: handleExit,
    onExited: handleExited,
    onExiting: handleExiting,
    addEndListener: handleAddEndListener,
    timeout: timeout === 'auto' ? null : timeout
  }, other, {
    children: (state, childProps) => {
      return /*#__PURE__*/React__namespace.cloneElement(children, _extends$1({
        style: _extends$1({
          opacity: 0,
          transform: getScale(0.75),
          visibility: state === 'exited' && !inProp ? 'hidden' : undefined
        }, styles$3[state], style, children.props.style),
        ref: handleRef
      }, childProps));
    }
  }));
});
browser$1.env.NODE_ENV !== "production" ? Grow.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Add a custom transition end trigger. Called with the transitioning DOM
   * node and a done callback. Allows for more fine grained transition end
   * logic. Note: Timeouts are still used as a fallback if provided.
   */
  addEndListener: propTypesExports.func,
  /**
   * Perform the enter transition when it first mounts if `in` is also `true`.
   * Set this to `false` to disable this behavior.
   * @default true
   */
  appear: propTypesExports.bool,
  /**
   * A single child content element.
   */
  children: elementAcceptingRef$1.isRequired,
  /**
   * The transition timing function.
   * You may specify a single easing or a object containing enter and exit values.
   */
  easing: propTypesExports.oneOfType([propTypesExports.shape({
    enter: propTypesExports.string,
    exit: propTypesExports.string
  }), propTypesExports.string]),
  /**
   * If `true`, the component will transition in.
   */
  in: propTypesExports.bool,
  /**
   * @ignore
   */
  onEnter: propTypesExports.func,
  /**
   * @ignore
   */
  onEntered: propTypesExports.func,
  /**
   * @ignore
   */
  onEntering: propTypesExports.func,
  /**
   * @ignore
   */
  onExit: propTypesExports.func,
  /**
   * @ignore
   */
  onExited: propTypesExports.func,
  /**
   * @ignore
   */
  onExiting: propTypesExports.func,
  /**
   * @ignore
   */
  style: propTypesExports.object,
  /**
   * The duration for the transition, in milliseconds.
   * You may specify a single timeout for all transitions, or individually with an object.
   *
   * Set to 'auto' to automatically calculate transition time based on height.
   * @default 'auto'
   */
  timeout: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.shape({
    appear: propTypesExports.number,
    enter: propTypesExports.number,
    exit: propTypesExports.number
  })])
} : void 0;
Grow.muiSupportAuto = true;
var Grow$1 = Grow;

const _excluded$14 = ["addEndListener", "appear", "children", "easing", "in", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "style", "timeout", "TransitionComponent"];
const styles$2 = {
  entering: {
    opacity: 1
  },
  entered: {
    opacity: 1
  }
};

/**
 * The Fade transition is used by the [Modal](/material-ui/react-modal/) component.
 * It uses [react-transition-group](https://github.com/reactjs/react-transition-group) internally.
 */
const Fade = /*#__PURE__*/React__namespace.forwardRef(function Fade(props, ref) {
  const theme = useTheme$1();
  const defaultTimeout = {
    enter: theme.transitions.duration.enteringScreen,
    exit: theme.transitions.duration.leavingScreen
  };
  const {
      addEndListener,
      appear = true,
      children,
      easing,
      in: inProp,
      onEnter,
      onEntered,
      onEntering,
      onExit,
      onExited,
      onExiting,
      style,
      timeout = defaultTimeout,
      // eslint-disable-next-line react/prop-types
      TransitionComponent = Transition$1
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$14);
  const nodeRef = React__namespace.useRef(null);
  const handleRef = useForkRef(nodeRef, children.ref, ref);
  const normalizedTransitionCallback = callback => maybeIsAppearing => {
    if (callback) {
      const node = nodeRef.current;

      // onEnterXxx and onExitXxx callbacks have a different arguments.length value.
      if (maybeIsAppearing === undefined) {
        callback(node);
      } else {
        callback(node, maybeIsAppearing);
      }
    }
  };
  const handleEntering = normalizedTransitionCallback(onEntering);
  const handleEnter = normalizedTransitionCallback((node, isAppearing) => {
    reflow(node); // So the animation always start from the start.

    const transitionProps = getTransitionProps({
      style,
      timeout,
      easing
    }, {
      mode: 'enter'
    });
    node.style.webkitTransition = theme.transitions.create('opacity', transitionProps);
    node.style.transition = theme.transitions.create('opacity', transitionProps);
    if (onEnter) {
      onEnter(node, isAppearing);
    }
  });
  const handleEntered = normalizedTransitionCallback(onEntered);
  const handleExiting = normalizedTransitionCallback(onExiting);
  const handleExit = normalizedTransitionCallback(node => {
    const transitionProps = getTransitionProps({
      style,
      timeout,
      easing
    }, {
      mode: 'exit'
    });
    node.style.webkitTransition = theme.transitions.create('opacity', transitionProps);
    node.style.transition = theme.transitions.create('opacity', transitionProps);
    if (onExit) {
      onExit(node);
    }
  });
  const handleExited = normalizedTransitionCallback(onExited);
  const handleAddEndListener = next => {
    if (addEndListener) {
      // Old call signature before `react-transition-group` implemented `nodeRef`
      addEndListener(nodeRef.current, next);
    }
  };
  return /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
    appear: appear,
    in: inProp,
    nodeRef: nodeRef ,
    onEnter: handleEnter,
    onEntered: handleEntered,
    onEntering: handleEntering,
    onExit: handleExit,
    onExited: handleExited,
    onExiting: handleExiting,
    addEndListener: handleAddEndListener,
    timeout: timeout
  }, other, {
    children: (state, childProps) => {
      return /*#__PURE__*/React__namespace.cloneElement(children, _extends$1({
        style: _extends$1({
          opacity: 0,
          visibility: state === 'exited' && !inProp ? 'hidden' : undefined
        }, styles$2[state], style, children.props.style),
        ref: handleRef
      }, childProps));
    }
  }));
});
browser$1.env.NODE_ENV !== "production" ? Fade.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Add a custom transition end trigger. Called with the transitioning DOM
   * node and a done callback. Allows for more fine grained transition end
   * logic. Note: Timeouts are still used as a fallback if provided.
   */
  addEndListener: propTypesExports.func,
  /**
   * Perform the enter transition when it first mounts if `in` is also `true`.
   * Set this to `false` to disable this behavior.
   * @default true
   */
  appear: propTypesExports.bool,
  /**
   * A single child content element.
   */
  children: elementAcceptingRef$1.isRequired,
  /**
   * The transition timing function.
   * You may specify a single easing or a object containing enter and exit values.
   */
  easing: propTypesExports.oneOfType([propTypesExports.shape({
    enter: propTypesExports.string,
    exit: propTypesExports.string
  }), propTypesExports.string]),
  /**
   * If `true`, the component will transition in.
   */
  in: propTypesExports.bool,
  /**
   * @ignore
   */
  onEnter: propTypesExports.func,
  /**
   * @ignore
   */
  onEntered: propTypesExports.func,
  /**
   * @ignore
   */
  onEntering: propTypesExports.func,
  /**
   * @ignore
   */
  onExit: propTypesExports.func,
  /**
   * @ignore
   */
  onExited: propTypesExports.func,
  /**
   * @ignore
   */
  onExiting: propTypesExports.func,
  /**
   * @ignore
   */
  style: propTypesExports.object,
  /**
   * The duration for the transition, in milliseconds.
   * You may specify a single timeout for all transitions, or individually with an object.
   * @default {
   *   enter: theme.transitions.duration.enteringScreen,
   *   exit: theme.transitions.duration.leavingScreen,
   * }
   */
  timeout: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.shape({
    appear: propTypesExports.number,
    enter: propTypesExports.number,
    exit: propTypesExports.number
  })])
} : void 0;
var Fade$1 = Fade;

function getBackdropUtilityClass(slot) {
  return generateUtilityClass('MuiBackdrop', slot);
}
generateUtilityClasses('MuiBackdrop', ['root', 'invisible']);

const _excluded$13 = ["children", "className", "component", "components", "componentsProps", "invisible", "open", "slotProps", "slots", "TransitionComponent", "transitionDuration"];
const useUtilityClasses$z = ownerState => {
  const {
    classes,
    invisible
  } = ownerState;
  const slots = {
    root: ['root', invisible && 'invisible']
  };
  return composeClasses(slots, getBackdropUtilityClass, classes);
};
const BackdropRoot = styled$1('div', {
  name: 'MuiBackdrop',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.invisible && styles.invisible];
  }
})(({
  ownerState
}) => _extends$1({
  position: 'fixed',
  display: 'flex',
  alignItems: 'center',
  justifyContent: 'center',
  right: 0,
  bottom: 0,
  top: 0,
  left: 0,
  backgroundColor: 'rgba(0, 0, 0, 0.5)',
  WebkitTapHighlightColor: 'transparent'
}, ownerState.invisible && {
  backgroundColor: 'transparent'
}));
const Backdrop = /*#__PURE__*/React__namespace.forwardRef(function Backdrop(inProps, ref) {
  var _slotProps$root, _ref, _slots$root;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiBackdrop'
  });
  const {
      children,
      className,
      component = 'div',
      components = {},
      componentsProps = {},
      invisible = false,
      open,
      slotProps = {},
      slots = {},
      TransitionComponent = Fade$1,
      transitionDuration
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$13);
  const ownerState = _extends$1({}, props, {
    component,
    invisible
  });
  const classes = useUtilityClasses$z(ownerState);
  const rootSlotProps = (_slotProps$root = slotProps.root) != null ? _slotProps$root : componentsProps.root;
  return /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
    in: open,
    timeout: transitionDuration
  }, other, {
    children: /*#__PURE__*/jsxRuntimeExports.jsx(BackdropRoot, _extends$1({
      "aria-hidden": true
    }, rootSlotProps, {
      as: (_ref = (_slots$root = slots.root) != null ? _slots$root : components.Root) != null ? _ref : component,
      className: clsx(classes.root, className, rootSlotProps == null ? void 0 : rootSlotProps.className),
      ownerState: _extends$1({}, ownerState, rootSlotProps == null ? void 0 : rootSlotProps.ownerState),
      classes: classes,
      ref: ref,
      children: children
    }))
  }));
});
browser$1.env.NODE_ENV !== "production" ? Backdrop.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `slots` prop.
   * It's recommended to use the `slots` prop instead.
   *
   * @default {}
   */
  components: propTypesExports.shape({
    Root: propTypesExports.elementType
  }),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `slotProps` prop.
   * It's recommended to use the `slotProps` prop instead, as `componentsProps` will be deprecated in the future.
   *
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    root: propTypesExports.object
  }),
  /**
   * If `true`, the backdrop is invisible.
   * It can be used when rendering a popover or a custom select component.
   * @default false
   */
  invisible: propTypesExports.bool,
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool.isRequired,
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `componentsProps` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slotProps: propTypesExports.shape({
    root: propTypesExports.object
  }),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `components` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slots: propTypesExports.shape({
    root: propTypesExports.elementType
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The component used for the transition.
   * [Follow this guide](/material-ui/transitions/#transitioncomponent-prop) to learn more about the requirements for this component.
   * @default Fade
   */
  TransitionComponent: propTypesExports.elementType,
  /**
   * The duration for the transition, in milliseconds.
   * You may specify a single timeout for all transitions, or individually with an object.
   */
  transitionDuration: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.shape({
    appear: propTypesExports.number,
    enter: propTypesExports.number,
    exit: propTypesExports.number
  })])
} : void 0;
var Backdrop$1 = Backdrop;

const _excluded$12 = ["BackdropComponent", "BackdropProps", "classes", "className", "closeAfterTransition", "children", "component", "components", "componentsProps", "disableAutoFocus", "disableEnforceFocus", "disableEscapeKeyDown", "disablePortal", "disableRestoreFocus", "disableScrollLock", "hideBackdrop", "keepMounted", "slotProps", "slots", "theme"];
const ModalRoot = styled$1('div', {
  name: 'MuiModal',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, !ownerState.open && ownerState.exited && styles.hidden];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  position: 'fixed',
  zIndex: (theme.vars || theme).zIndex.modal,
  right: 0,
  bottom: 0,
  top: 0,
  left: 0
}, !ownerState.open && ownerState.exited && {
  visibility: 'hidden'
}));
const ModalBackdrop = styled$1(Backdrop$1, {
  name: 'MuiModal',
  slot: 'Backdrop',
  overridesResolver: (props, styles) => {
    return styles.backdrop;
  }
})({
  zIndex: -1
});

/**
 * Modal is a lower-level construct that is leveraged by the following components:
 *
 * - [Dialog](/material-ui/api/dialog/)
 * - [Drawer](/material-ui/api/drawer/)
 * - [Menu](/material-ui/api/menu/)
 * - [Popover](/material-ui/api/popover/)
 *
 * If you are creating a modal dialog, you probably want to use the [Dialog](/material-ui/api/dialog/) component
 * rather than directly using Modal.
 *
 * This component shares many concepts with [react-overlays](https://react-bootstrap.github.io/react-overlays/#modals).
 */
const Modal$1 = /*#__PURE__*/React__namespace.forwardRef(function Modal(inProps, ref) {
  var _ref, _slots$root, _ref2, _slots$backdrop, _slotProps$root, _slotProps$backdrop;
  const props = useThemeProps({
    name: 'MuiModal',
    props: inProps
  });
  const {
      BackdropComponent = ModalBackdrop,
      BackdropProps,
      classes,
      className,
      closeAfterTransition = false,
      children,
      component,
      components = {},
      componentsProps = {},
      disableAutoFocus = false,
      disableEnforceFocus = false,
      disableEscapeKeyDown = false,
      disablePortal = false,
      disableRestoreFocus = false,
      disableScrollLock = false,
      hideBackdrop = false,
      keepMounted = false,
      slotProps,
      slots,
      // eslint-disable-next-line react/prop-types
      theme
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$12);
  const [exited, setExited] = React__namespace.useState(true);
  const commonProps = {
    closeAfterTransition,
    disableAutoFocus,
    disableEnforceFocus,
    disableEscapeKeyDown,
    disablePortal,
    disableRestoreFocus,
    disableScrollLock,
    hideBackdrop,
    keepMounted
  };
  const ownerState = _extends$1({}, props, commonProps, {
    exited
  });
  const RootSlot = (_ref = (_slots$root = slots == null ? void 0 : slots.root) != null ? _slots$root : components.Root) != null ? _ref : ModalRoot;
  const BackdropSlot = (_ref2 = (_slots$backdrop = slots == null ? void 0 : slots.backdrop) != null ? _slots$backdrop : components.Backdrop) != null ? _ref2 : BackdropComponent;
  const rootSlotProps = (_slotProps$root = slotProps == null ? void 0 : slotProps.root) != null ? _slotProps$root : componentsProps.root;
  const backdropSlotProps = (_slotProps$backdrop = slotProps == null ? void 0 : slotProps.backdrop) != null ? _slotProps$backdrop : componentsProps.backdrop;
  return /*#__PURE__*/jsxRuntimeExports.jsx(ModalUnstyled$1, _extends$1({
    slots: {
      root: RootSlot,
      backdrop: BackdropSlot
    },
    slotProps: {
      root: () => _extends$1({}, resolveComponentProps(rootSlotProps, ownerState), !isHostComponent(RootSlot) && {
        as: component,
        theme
      }, {
        className: clsx(className, rootSlotProps == null ? void 0 : rootSlotProps.className, classes == null ? void 0 : classes.root, !ownerState.open && ownerState.exited && (classes == null ? void 0 : classes.hidden))
      }),
      backdrop: () => _extends$1({}, BackdropProps, resolveComponentProps(backdropSlotProps, ownerState), {
        className: clsx(backdropSlotProps == null ? void 0 : backdropSlotProps.className, classes == null ? void 0 : classes.backdrop)
      })
    },
    onTransitionEnter: () => setExited(false),
    onTransitionExited: () => setExited(true),
    ref: ref
  }, other, commonProps, {
    children: children
  }));
});
browser$1.env.NODE_ENV !== "production" ? Modal$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * A backdrop component. This prop enables custom backdrop rendering.
   * @deprecated Use `slots.backdrop` instead. While this prop currently works, it will be removed in the next major version.
   * Use the `slots.backdrop` prop to make your application ready for the next version of Material UI.
   * @default styled(Backdrop, {
   *   name: 'MuiModal',
   *   slot: 'Backdrop',
   *   overridesResolver: (props, styles) => {
   *     return styles.backdrop;
   *   },
   * })({
   *   zIndex: -1,
   * })
   */
  BackdropComponent: propTypesExports.elementType,
  /**
   * Props applied to the [`Backdrop`](/material-ui/api/backdrop/) element.
   * @deprecated Use `slotProps.backdrop` instead.
   */
  BackdropProps: propTypesExports.object,
  /**
   * A single child content element.
   */
  children: elementAcceptingRef$1.isRequired,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * When set to true the Modal waits until a nested Transition is completed before closing.
   * @default false
   */
  closeAfterTransition: propTypesExports.bool,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `slots` prop.
   * It's recommended to use the `slots` prop instead.
   *
   * @default {}
   */
  components: propTypesExports.shape({
    Backdrop: propTypesExports.elementType,
    Root: propTypesExports.elementType
  }),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `slotProps` prop.
   * It's recommended to use the `slotProps` prop instead, as `componentsProps` will be deprecated in the future.
   *
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    backdrop: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object]),
    root: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object])
  }),
  /**
   * An HTML element or function that returns one.
   * The `container` will have the portal children appended to it.
   *
   * By default, it uses the body of the top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.func]),
  /**
   * If `true`, the modal will not automatically shift focus to itself when it opens, and
   * replace it to the last focused element when it closes.
   * This also works correctly with any modal children that have the `disableAutoFocus` prop.
   *
   * Generally this should never be set to `true` as it makes the modal less
   * accessible to assistive technologies, like screen readers.
   * @default false
   */
  disableAutoFocus: propTypesExports.bool,
  /**
   * If `true`, the modal will not prevent focus from leaving the modal while open.
   *
   * Generally this should never be set to `true` as it makes the modal less
   * accessible to assistive technologies, like screen readers.
   * @default false
   */
  disableEnforceFocus: propTypesExports.bool,
  /**
   * If `true`, hitting escape will not fire the `onClose` callback.
   * @default false
   */
  disableEscapeKeyDown: propTypesExports.bool,
  /**
   * The `children` will be under the DOM hierarchy of the parent component.
   * @default false
   */
  disablePortal: propTypesExports.bool,
  /**
   * If `true`, the modal will not restore focus to previously focused element once
   * modal is hidden or unmounted.
   * @default false
   */
  disableRestoreFocus: propTypesExports.bool,
  /**
   * Disable the scroll lock behavior.
   * @default false
   */
  disableScrollLock: propTypesExports.bool,
  /**
   * If `true`, the backdrop is not rendered.
   * @default false
   */
  hideBackdrop: propTypesExports.bool,
  /**
   * Always keep the children in the DOM.
   * This prop can be useful in SEO situation or
   * when you want to maximize the responsiveness of the Modal.
   * @default false
   */
  keepMounted: propTypesExports.bool,
  /**
   * Callback fired when the backdrop is clicked.
   * @deprecated Use the `onClose` prop with the `reason` argument to handle the `backdropClick` events.
   */
  onBackdropClick: propTypesExports.func,
  /**
   * Callback fired when the component requests to be closed.
   * The `reason` parameter can optionally be used to control the response to `onClose`.
   *
   * @param {object} event The event source of the callback.
   * @param {string} reason Can be: `"escapeKeyDown"`, `"backdropClick"`.
   */
  onClose: propTypesExports.func,
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool.isRequired,
  /**
   * The props used for each slot inside the Modal.
   * @default {}
   */
  slotProps: propTypesExports.shape({
    backdrop: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object]),
    root: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object])
  }),
  /**
   * The components used for each slot inside the Modal.
   * Either a string to use a HTML element or a component.
   * @default {}
   */
  slots: propTypesExports.shape({
    backdrop: propTypesExports.elementType,
    root: propTypesExports.elementType
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var ModalOG = Modal$1;

function getPopoverUtilityClass(slot) {
  return generateUtilityClass('MuiPopover', slot);
}
generateUtilityClasses('MuiPopover', ['root', 'paper']);

const _excluded$11 = ["onEntering"],
  _excluded2$1 = ["action", "anchorEl", "anchorOrigin", "anchorPosition", "anchorReference", "children", "className", "container", "elevation", "marginThreshold", "open", "PaperProps", "transformOrigin", "TransitionComponent", "transitionDuration", "TransitionProps"];
function getOffsetTop(rect, vertical) {
  let offset = 0;
  if (typeof vertical === 'number') {
    offset = vertical;
  } else if (vertical === 'center') {
    offset = rect.height / 2;
  } else if (vertical === 'bottom') {
    offset = rect.height;
  }
  return offset;
}
function getOffsetLeft(rect, horizontal) {
  let offset = 0;
  if (typeof horizontal === 'number') {
    offset = horizontal;
  } else if (horizontal === 'center') {
    offset = rect.width / 2;
  } else if (horizontal === 'right') {
    offset = rect.width;
  }
  return offset;
}
function getTransformOriginValue(transformOrigin) {
  return [transformOrigin.horizontal, transformOrigin.vertical].map(n => typeof n === 'number' ? `${n}px` : n).join(' ');
}
function resolveAnchorEl(anchorEl) {
  return typeof anchorEl === 'function' ? anchorEl() : anchorEl;
}
const useUtilityClasses$y = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root'],
    paper: ['paper']
  };
  return composeClasses(slots, getPopoverUtilityClass, classes);
};
const PopoverRoot = styled$1(ModalOG, {
  name: 'MuiPopover',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({});
const PopoverPaper = styled$1(Paper$1, {
  name: 'MuiPopover',
  slot: 'Paper',
  overridesResolver: (props, styles) => styles.paper
})({
  position: 'absolute',
  overflowY: 'auto',
  overflowX: 'hidden',
  // So we see the popover when it's empty.
  // It's most likely on issue on userland.
  minWidth: 16,
  minHeight: 16,
  maxWidth: 'calc(100% - 32px)',
  maxHeight: 'calc(100% - 32px)',
  // We disable the focus ring for mouse, touch and keyboard users.
  outline: 0
});
const Popover = /*#__PURE__*/React__namespace.forwardRef(function Popover(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiPopover'
  });
  const {
      action,
      anchorEl,
      anchorOrigin = {
        vertical: 'top',
        horizontal: 'left'
      },
      anchorPosition,
      anchorReference = 'anchorEl',
      children,
      className,
      container: containerProp,
      elevation = 8,
      marginThreshold = 16,
      open,
      PaperProps = {},
      transformOrigin = {
        vertical: 'top',
        horizontal: 'left'
      },
      TransitionComponent = Grow$1,
      transitionDuration: transitionDurationProp = 'auto',
      TransitionProps: {
        onEntering
      } = {}
    } = props,
    TransitionProps = _objectWithoutPropertiesLoose(props.TransitionProps, _excluded$11),
    other = _objectWithoutPropertiesLoose(props, _excluded2$1);
  const paperRef = React__namespace.useRef();
  const handlePaperRef = useForkRef(paperRef, PaperProps.ref);
  const ownerState = _extends$1({}, props, {
    anchorOrigin,
    anchorReference,
    elevation,
    marginThreshold,
    PaperProps,
    transformOrigin,
    TransitionComponent,
    transitionDuration: transitionDurationProp,
    TransitionProps
  });
  const classes = useUtilityClasses$y(ownerState);

  // Returns the top/left offset of the position
  // to attach to on the anchor element (or body if none is provided)
  const getAnchorOffset = React__namespace.useCallback(() => {
    if (anchorReference === 'anchorPosition') {
      if (browser$1.env.NODE_ENV !== 'production') {
        if (!anchorPosition) {
          console.error('MUI: You need to provide a `anchorPosition` prop when using ' + '<Popover anchorReference="anchorPosition" />.');
        }
      }
      return anchorPosition;
    }
    const resolvedAnchorEl = resolveAnchorEl(anchorEl);

    // If an anchor element wasn't provided, just use the parent body element of this Popover
    const anchorElement = resolvedAnchorEl && resolvedAnchorEl.nodeType === 1 ? resolvedAnchorEl : ownerDocument(paperRef.current).body;
    const anchorRect = anchorElement.getBoundingClientRect();
    if (browser$1.env.NODE_ENV !== 'production') {
      const box = anchorElement.getBoundingClientRect();
      if (browser$1.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
        console.warn(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
      }
    }
    return {
      top: anchorRect.top + getOffsetTop(anchorRect, anchorOrigin.vertical),
      left: anchorRect.left + getOffsetLeft(anchorRect, anchorOrigin.horizontal)
    };
  }, [anchorEl, anchorOrigin.horizontal, anchorOrigin.vertical, anchorPosition, anchorReference]);

  // Returns the base transform origin using the element
  const getTransformOrigin = React__namespace.useCallback(elemRect => {
    return {
      vertical: getOffsetTop(elemRect, transformOrigin.vertical),
      horizontal: getOffsetLeft(elemRect, transformOrigin.horizontal)
    };
  }, [transformOrigin.horizontal, transformOrigin.vertical]);
  const getPositioningStyle = React__namespace.useCallback(element => {
    const elemRect = {
      width: element.offsetWidth,
      height: element.offsetHeight
    };

    // Get the transform origin point on the element itself
    const elemTransformOrigin = getTransformOrigin(elemRect);
    if (anchorReference === 'none') {
      return {
        top: null,
        left: null,
        transformOrigin: getTransformOriginValue(elemTransformOrigin)
      };
    }

    // Get the offset of the anchoring element
    const anchorOffset = getAnchorOffset();

    // Calculate element positioning
    let top = anchorOffset.top - elemTransformOrigin.vertical;
    let left = anchorOffset.left - elemTransformOrigin.horizontal;
    const bottom = top + elemRect.height;
    const right = left + elemRect.width;

    // Use the parent window of the anchorEl if provided
    const containerWindow = ownerWindow(resolveAnchorEl(anchorEl));

    // Window thresholds taking required margin into account
    const heightThreshold = containerWindow.innerHeight - marginThreshold;
    const widthThreshold = containerWindow.innerWidth - marginThreshold;

    // Check if the vertical axis needs shifting
    if (top < marginThreshold) {
      const diff = top - marginThreshold;
      top -= diff;
      elemTransformOrigin.vertical += diff;
    } else if (bottom > heightThreshold) {
      const diff = bottom - heightThreshold;
      top -= diff;
      elemTransformOrigin.vertical += diff;
    }
    if (browser$1.env.NODE_ENV !== 'production') {
      if (elemRect.height > heightThreshold && elemRect.height && heightThreshold) {
        console.error(['MUI: The popover component is too tall.', `Some part of it can not be seen on the screen (${elemRect.height - heightThreshold}px).`, 'Please consider adding a `max-height` to improve the user-experience.'].join('\n'));
      }
    }

    // Check if the horizontal axis needs shifting
    if (left < marginThreshold) {
      const diff = left - marginThreshold;
      left -= diff;
      elemTransformOrigin.horizontal += diff;
    } else if (right > widthThreshold) {
      const diff = right - widthThreshold;
      left -= diff;
      elemTransformOrigin.horizontal += diff;
    }
    return {
      top: `${Math.round(top)}px`,
      left: `${Math.round(left)}px`,
      transformOrigin: getTransformOriginValue(elemTransformOrigin)
    };
  }, [anchorEl, anchorReference, getAnchorOffset, getTransformOrigin, marginThreshold]);
  const [isPositioned, setIsPositioned] = React__namespace.useState(open);
  const setPositioningStyles = React__namespace.useCallback(() => {
    const element = paperRef.current;
    if (!element) {
      return;
    }
    const positioning = getPositioningStyle(element);
    if (positioning.top !== null) {
      element.style.top = positioning.top;
    }
    if (positioning.left !== null) {
      element.style.left = positioning.left;
    }
    element.style.transformOrigin = positioning.transformOrigin;
    setIsPositioned(true);
  }, [getPositioningStyle]);
  const handleEntering = (element, isAppearing) => {
    if (onEntering) {
      onEntering(element, isAppearing);
    }
    setPositioningStyles();
  };
  const handleExited = () => {
    setIsPositioned(false);
  };
  React__namespace.useEffect(() => {
    if (open) {
      setPositioningStyles();
    }
  });
  React__namespace.useImperativeHandle(action, () => open ? {
    updatePosition: () => {
      setPositioningStyles();
    }
  } : null, [open, setPositioningStyles]);
  React__namespace.useEffect(() => {
    if (!open) {
      return undefined;
    }
    const handleResize = debounce$1(() => {
      setPositioningStyles();
    });
    const containerWindow = ownerWindow(anchorEl);
    containerWindow.addEventListener('resize', handleResize);
    return () => {
      handleResize.clear();
      containerWindow.removeEventListener('resize', handleResize);
    };
  }, [anchorEl, open, setPositioningStyles]);
  let transitionDuration = transitionDurationProp;
  if (transitionDurationProp === 'auto' && !TransitionComponent.muiSupportAuto) {
    transitionDuration = undefined;
  }

  // If the container prop is provided, use that
  // If the anchorEl prop is provided, use its parent body element as the container
  // If neither are provided let the Modal take care of choosing the container
  const container = containerProp || (anchorEl ? ownerDocument(resolveAnchorEl(anchorEl)).body : undefined);
  return /*#__PURE__*/jsxRuntimeExports.jsx(PopoverRoot, _extends$1({
    BackdropProps: {
      invisible: true
    },
    className: clsx(classes.root, className),
    container: container,
    open: open,
    ref: ref,
    ownerState: ownerState
  }, other, {
    children: /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
      appear: true,
      in: open,
      onEntering: handleEntering,
      onExited: handleExited,
      timeout: transitionDuration
    }, TransitionProps, {
      children: /*#__PURE__*/jsxRuntimeExports.jsx(PopoverPaper, _extends$1({
        elevation: elevation
      }, PaperProps, {
        ref: handlePaperRef,
        className: clsx(classes.paper, PaperProps.className)
      }, isPositioned ? undefined : {
        style: _extends$1({}, PaperProps.style, {
          opacity: 0
        })
      }, {
        ownerState: ownerState,
        children: children
      }))
    }))
  }));
});
browser$1.env.NODE_ENV !== "production" ? Popover.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * A ref for imperative actions.
   * It currently only supports updatePosition() action.
   */
  action: refType$1,
  /**
   * An HTML element, or a function that returns one.
   * It's used to set the position of the popover.
   */
  anchorEl: chainPropTypes(propTypesExports.oneOfType([HTMLElementType, propTypesExports.func]), props => {
    if (props.open && (!props.anchorReference || props.anchorReference === 'anchorEl')) {
      const resolvedAnchorEl = resolveAnchorEl(props.anchorEl);
      if (resolvedAnchorEl && resolvedAnchorEl.nodeType === 1) {
        const box = resolvedAnchorEl.getBoundingClientRect();
        if (browser$1.env.NODE_ENV !== 'test' && box.top === 0 && box.left === 0 && box.right === 0 && box.bottom === 0) {
          return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', 'The anchor element should be part of the document layout.', "Make sure the element is present in the document or that it's not display none."].join('\n'));
        }
      } else {
        return new Error(['MUI: The `anchorEl` prop provided to the component is invalid.', `It should be an Element instance but it's \`${resolvedAnchorEl}\` instead.`].join('\n'));
      }
    }
    return null;
  }),
  /**
   * This is the point on the anchor where the popover's
   * `anchorEl` will attach to. This is not used when the
   * anchorReference is 'anchorPosition'.
   *
   * Options:
   * vertical: [top, center, bottom];
   * horizontal: [left, center, right].
   * @default {
   *   vertical: 'top',
   *   horizontal: 'left',
   * }
   */
  anchorOrigin: propTypesExports.shape({
    horizontal: propTypesExports.oneOfType([propTypesExports.oneOf(['center', 'left', 'right']), propTypesExports.number]).isRequired,
    vertical: propTypesExports.oneOfType([propTypesExports.oneOf(['bottom', 'center', 'top']), propTypesExports.number]).isRequired
  }),
  /**
   * This is the position that may be used to set the position of the popover.
   * The coordinates are relative to the application's client area.
   */
  anchorPosition: propTypesExports.shape({
    left: propTypesExports.number.isRequired,
    top: propTypesExports.number.isRequired
  }),
  /**
   * This determines which anchor prop to refer to when setting
   * the position of the popover.
   * @default 'anchorEl'
   */
  anchorReference: propTypesExports.oneOf(['anchorEl', 'anchorPosition', 'none']),
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * An HTML element, component instance, or function that returns either.
   * The `container` will passed to the Modal component.
   *
   * By default, it uses the body of the anchorEl's top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.func]),
  /**
   * The elevation of the popover.
   * @default 8
   */
  elevation: integerPropType,
  /**
   * Specifies how close to the edge of the window the popover can appear.
   * @default 16
   */
  marginThreshold: propTypesExports.number,
  /**
   * Callback fired when the component requests to be closed.
   * The `reason` parameter can optionally be used to control the response to `onClose`.
   */
  onClose: propTypesExports.func,
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool.isRequired,
  /**
   * Props applied to the [`Paper`](/material-ui/api/paper/) element.
   * @default {}
   */
  PaperProps: propTypesExports /* @typescript-to-proptypes-ignore */.shape({
    component: elementTypeAcceptingRef$1
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * This is the point on the popover which
   * will attach to the anchor's origin.
   *
   * Options:
   * vertical: [top, center, bottom, x(px)];
   * horizontal: [left, center, right, x(px)].
   * @default {
   *   vertical: 'top',
   *   horizontal: 'left',
   * }
   */
  transformOrigin: propTypesExports.shape({
    horizontal: propTypesExports.oneOfType([propTypesExports.oneOf(['center', 'left', 'right']), propTypesExports.number]).isRequired,
    vertical: propTypesExports.oneOfType([propTypesExports.oneOf(['bottom', 'center', 'top']), propTypesExports.number]).isRequired
  }),
  /**
   * The component used for the transition.
   * [Follow this guide](/material-ui/transitions/#transitioncomponent-prop) to learn more about the requirements for this component.
   * @default Grow
   */
  TransitionComponent: propTypesExports.elementType,
  /**
   * Set to 'auto' to automatically calculate transition time based on height.
   * @default 'auto'
   */
  transitionDuration: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.shape({
    appear: propTypesExports.number,
    enter: propTypesExports.number,
    exit: propTypesExports.number
  })]),
  /**
   * Props applied to the transition element.
   * By default, the element is based on this [`Transition`](http://reactcommunity.org/react-transition-group/transition/) component.
   * @default {}
   */
  TransitionProps: propTypesExports.object
} : void 0;
var Popover$1 = Popover;

function getMenuUtilityClass(slot) {
  return generateUtilityClass('MuiMenu', slot);
}
generateUtilityClasses('MuiMenu', ['root', 'paper', 'list']);

const _excluded$10 = ["onEntering"],
  _excluded2 = ["autoFocus", "children", "disableAutoFocusItem", "MenuListProps", "onClose", "open", "PaperProps", "PopoverClasses", "transitionDuration", "TransitionProps", "variant"];
const RTL_ORIGIN = {
  vertical: 'top',
  horizontal: 'right'
};
const LTR_ORIGIN = {
  vertical: 'top',
  horizontal: 'left'
};
const useUtilityClasses$x = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root'],
    paper: ['paper'],
    list: ['list']
  };
  return composeClasses(slots, getMenuUtilityClass, classes);
};
const MenuRoot = styled$1(Popover$1, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiMenu',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({});
const MenuPaper = styled$1(Paper$1, {
  name: 'MuiMenu',
  slot: 'Paper',
  overridesResolver: (props, styles) => styles.paper
})({
  // specZ: The maximum height of a simple menu should be one or more rows less than the view
  // height. This ensures a tapable area outside of the simple menu with which to dismiss
  // the menu.
  maxHeight: 'calc(100% - 96px)',
  // Add iOS momentum scrolling for iOS < 13.0
  WebkitOverflowScrolling: 'touch'
});
const MenuMenuList = styled$1(MenuList$1, {
  name: 'MuiMenu',
  slot: 'List',
  overridesResolver: (props, styles) => styles.list
})({
  // We disable the focus ring for mouse, touch and keyboard users.
  outline: 0
});
const Menu = /*#__PURE__*/React__namespace.forwardRef(function Menu(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiMenu'
  });
  const {
      autoFocus = true,
      children,
      disableAutoFocusItem = false,
      MenuListProps = {},
      onClose,
      open,
      PaperProps = {},
      PopoverClasses,
      transitionDuration = 'auto',
      TransitionProps: {
        onEntering
      } = {},
      variant = 'selectedMenu'
    } = props,
    TransitionProps = _objectWithoutPropertiesLoose(props.TransitionProps, _excluded$10),
    other = _objectWithoutPropertiesLoose(props, _excluded2);
  const theme = useTheme$1();
  const isRtl = theme.direction === 'rtl';
  const ownerState = _extends$1({}, props, {
    autoFocus,
    disableAutoFocusItem,
    MenuListProps,
    onEntering,
    PaperProps,
    transitionDuration,
    TransitionProps,
    variant
  });
  const classes = useUtilityClasses$x(ownerState);
  const autoFocusItem = autoFocus && !disableAutoFocusItem && open;
  const menuListActionsRef = React__namespace.useRef(null);
  const handleEntering = (element, isAppearing) => {
    if (menuListActionsRef.current) {
      menuListActionsRef.current.adjustStyleForScrollbar(element, theme);
    }
    if (onEntering) {
      onEntering(element, isAppearing);
    }
  };
  const handleListKeyDown = event => {
    if (event.key === 'Tab') {
      event.preventDefault();
      if (onClose) {
        onClose(event, 'tabKeyDown');
      }
    }
  };

  /**
   * the index of the item should receive focus
   * in a `variant="selectedMenu"` it's the first `selected` item
   * otherwise it's the very first item.
   */
  let activeItemIndex = -1;
  // since we inject focus related props into children we have to do a lookahead
  // to check if there is a `selected` item. We're looking for the last `selected`
  // item and use the first valid item as a fallback
  React__namespace.Children.map(children, (child, index) => {
    if (! /*#__PURE__*/React__namespace.isValidElement(child)) {
      return;
    }
    if (browser$1.env.NODE_ENV !== 'production') {
      if (reactIsExports.isFragment(child)) {
        console.error(["MUI: The Menu component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
      }
    }
    if (!child.props.disabled) {
      if (variant === 'selectedMenu' && child.props.selected) {
        activeItemIndex = index;
      } else if (activeItemIndex === -1) {
        activeItemIndex = index;
      }
    }
  });
  return /*#__PURE__*/jsxRuntimeExports.jsx(MenuRoot, _extends$1({
    onClose: onClose,
    anchorOrigin: {
      vertical: 'bottom',
      horizontal: isRtl ? 'right' : 'left'
    },
    transformOrigin: isRtl ? RTL_ORIGIN : LTR_ORIGIN,
    PaperProps: _extends$1({
      as: MenuPaper
    }, PaperProps, {
      classes: _extends$1({}, PaperProps.classes, {
        root: classes.paper
      })
    }),
    className: classes.root,
    open: open,
    ref: ref,
    transitionDuration: transitionDuration,
    TransitionProps: _extends$1({
      onEntering: handleEntering
    }, TransitionProps),
    ownerState: ownerState
  }, other, {
    classes: PopoverClasses,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(MenuMenuList, _extends$1({
      onKeyDown: handleListKeyDown,
      actions: menuListActionsRef,
      autoFocus: autoFocus && (activeItemIndex === -1 || disableAutoFocusItem),
      autoFocusItem: autoFocusItem,
      variant: variant
    }, MenuListProps, {
      className: clsx(classes.list, MenuListProps.className),
      children: children
    }))
  }));
});
browser$1.env.NODE_ENV !== "production" ? Menu.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * An HTML element, or a function that returns one.
   * It's used to set the position of the menu.
   */
  anchorEl: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.func]),
  /**
   * If `true` (Default) will focus the `[role="menu"]` if no focusable child is found. Disabled
   * children are not focusable. If you set this prop to `false` focus will be placed
   * on the parent modal container. This has severe accessibility implications
   * and should only be considered if you manage focus otherwise.
   * @default true
   */
  autoFocus: propTypesExports.bool,
  /**
   * Menu contents, normally `MenuItem`s.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * When opening the menu will not focus the active item but the `[role="menu"]`
   * unless `autoFocus` is also set to `false`. Not using the default means not
   * following WAI-ARIA authoring practices. Please be considerate about possible
   * accessibility implications.
   * @default false
   */
  disableAutoFocusItem: propTypesExports.bool,
  /**
   * Props applied to the [`MenuList`](/material-ui/api/menu-list/) element.
   * @default {}
   */
  MenuListProps: propTypesExports.object,
  /**
   * Callback fired when the component requests to be closed.
   *
   * @param {object} event The event source of the callback.
   * @param {string} reason Can be: `"escapeKeyDown"`, `"backdropClick"`, `"tabKeyDown"`.
   */
  onClose: propTypesExports.func,
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool.isRequired,
  /**
   * @ignore
   */
  PaperProps: propTypesExports.object,
  /**
   * `classes` prop applied to the [`Popover`](/material-ui/api/popover/) element.
   */
  PopoverClasses: propTypesExports.object,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The length of the transition in `ms`, or 'auto'
   * @default 'auto'
   */
  transitionDuration: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.shape({
    appear: propTypesExports.number,
    enter: propTypesExports.number,
    exit: propTypesExports.number
  })]),
  /**
   * Props applied to the transition element.
   * By default, the element is based on this [`Transition`](http://reactcommunity.org/react-transition-group/transition/) component.
   * @default {}
   */
  TransitionProps: propTypesExports.object,
  /**
   * The variant to use. Use `menu` to prevent selected items from impacting the initial focus.
   * @default 'selectedMenu'
   */
  variant: propTypesExports.oneOf(['menu', 'selectedMenu'])
} : void 0;
var Menu$1 = Menu;

function getNativeSelectUtilityClasses(slot) {
  return generateUtilityClass('MuiNativeSelect', slot);
}
const nativeSelectClasses = generateUtilityClasses('MuiNativeSelect', ['root', 'select', 'multiple', 'filled', 'outlined', 'standard', 'disabled', 'icon', 'iconOpen', 'iconFilled', 'iconOutlined', 'iconStandard', 'nativeInput']);
var nativeSelectClasses$1 = nativeSelectClasses;

const _excluded$$ = ["className", "disabled", "IconComponent", "inputRef", "variant"];
const useUtilityClasses$w = ownerState => {
  const {
    classes,
    variant,
    disabled,
    multiple,
    open
  } = ownerState;
  const slots = {
    select: ['select', variant, disabled && 'disabled', multiple && 'multiple'],
    icon: ['icon', `icon${capitalize(variant)}`, open && 'iconOpen', disabled && 'disabled']
  };
  return composeClasses(slots, getNativeSelectUtilityClasses, classes);
};
const nativeSelectSelectStyles = ({
  ownerState,
  theme
}) => _extends$1({
  MozAppearance: 'none',
  // Reset
  WebkitAppearance: 'none',
  // Reset
  // When interacting quickly, the text can end up selected.
  // Native select can't be selected either.
  userSelect: 'none',
  borderRadius: 0,
  // Reset
  cursor: 'pointer',
  '&:focus': _extends$1({}, theme.vars ? {
    backgroundColor: `rgba(${theme.vars.palette.common.onBackgroundChannel} / 0.05)`
  } : {
    backgroundColor: theme.palette.mode === 'light' ? 'rgba(0, 0, 0, 0.05)' : 'rgba(255, 255, 255, 0.05)'
  }, {
    borderRadius: 0 // Reset Chrome style
  }),

  // Remove IE11 arrow
  '&::-ms-expand': {
    display: 'none'
  },
  [`&.${nativeSelectClasses$1.disabled}`]: {
    cursor: 'default'
  },
  '&[multiple]': {
    height: 'auto'
  },
  '&:not([multiple]) option, &:not([multiple]) optgroup': {
    backgroundColor: (theme.vars || theme).palette.background.paper
  },
  // Bump specificity to allow extending custom inputs
  '&&&': {
    paddingRight: 24,
    minWidth: 16 // So it doesn't collapse.
  }
}, ownerState.variant === 'filled' && {
  '&&&': {
    paddingRight: 32
  }
}, ownerState.variant === 'outlined' && {
  borderRadius: (theme.vars || theme).shape.borderRadius,
  '&:focus': {
    borderRadius: (theme.vars || theme).shape.borderRadius // Reset the reset for Chrome style
  },

  '&&&': {
    paddingRight: 32
  }
});
const NativeSelectSelect = styled$1('select', {
  name: 'MuiNativeSelect',
  slot: 'Select',
  shouldForwardProp: rootShouldForwardProp$1,
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.select, styles[ownerState.variant], {
      [`&.${nativeSelectClasses$1.multiple}`]: styles.multiple
    }];
  }
})(nativeSelectSelectStyles);
const nativeSelectIconStyles = ({
  ownerState,
  theme
}) => _extends$1({
  // We use a position absolute over a flexbox in order to forward the pointer events
  // to the input and to support wrapping tags..
  position: 'absolute',
  right: 0,
  top: 'calc(50% - .5em)',
  // Center vertically, height is 1em
  pointerEvents: 'none',
  // Don't block pointer events on the select under the icon.
  color: (theme.vars || theme).palette.action.active,
  [`&.${nativeSelectClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.action.disabled
  }
}, ownerState.open && {
  transform: 'rotate(180deg)'
}, ownerState.variant === 'filled' && {
  right: 7
}, ownerState.variant === 'outlined' && {
  right: 7
});
const NativeSelectIcon = styled$1('svg', {
  name: 'MuiNativeSelect',
  slot: 'Icon',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.icon, ownerState.variant && styles[`icon${capitalize(ownerState.variant)}`], ownerState.open && styles.iconOpen];
  }
})(nativeSelectIconStyles);

/**
 * @ignore - internal component.
 */
const NativeSelectInput = /*#__PURE__*/React__namespace.forwardRef(function NativeSelectInput(props, ref) {
  const {
      className,
      disabled,
      IconComponent,
      inputRef,
      variant = 'standard'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$$);
  const ownerState = _extends$1({}, props, {
    disabled,
    variant
  });
  const classes = useUtilityClasses$w(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
    children: [/*#__PURE__*/jsxRuntimeExports.jsx(NativeSelectSelect, _extends$1({
      ownerState: ownerState,
      className: clsx(classes.select, className),
      disabled: disabled,
      ref: inputRef || ref
    }, other)), props.multiple ? null : /*#__PURE__*/jsxRuntimeExports.jsx(NativeSelectIcon, {
      as: IconComponent,
      ownerState: ownerState,
      className: classes.icon
    })]
  });
});
browser$1.env.NODE_ENV !== "production" ? NativeSelectInput.propTypes = {
  /**
   * The option elements to populate the select with.
   * Can be some `<option>` elements.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypesExports.object,
  /**
   * The CSS class name of the select element.
   */
  className: propTypesExports.string,
  /**
   * If `true`, the select is disabled.
   */
  disabled: propTypesExports.bool,
  /**
   * The icon that displays the arrow.
   */
  IconComponent: propTypesExports.elementType.isRequired,
  /**
   * Use that prop to pass a ref to the native select element.
   * @deprecated
   */
  inputRef: refType$1,
  /**
   * @ignore
   */
  multiple: propTypesExports.bool,
  /**
   * Name attribute of the `select` or hidden `input` element.
   */
  name: propTypesExports.string,
  /**
   * Callback fired when a menu item is selected.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypesExports.func,
  /**
   * The input value.
   */
  value: propTypesExports.any,
  /**
   * The variant to use.
   */
  variant: propTypesExports.oneOf(['standard', 'outlined', 'filled'])
} : void 0;
var NativeSelectInput$1 = NativeSelectInput;

function getSelectUtilityClasses(slot) {
  return generateUtilityClass('MuiSelect', slot);
}
const selectClasses = generateUtilityClasses('MuiSelect', ['select', 'multiple', 'filled', 'outlined', 'standard', 'disabled', 'focused', 'icon', 'iconOpen', 'iconFilled', 'iconOutlined', 'iconStandard', 'nativeInput']);
var selectClasses$1 = selectClasses;

var _span;
const _excluded$_ = ["aria-describedby", "aria-label", "autoFocus", "autoWidth", "children", "className", "defaultOpen", "defaultValue", "disabled", "displayEmpty", "IconComponent", "inputRef", "labelId", "MenuProps", "multiple", "name", "onBlur", "onChange", "onClose", "onFocus", "onOpen", "open", "readOnly", "renderValue", "SelectDisplayProps", "tabIndex", "type", "value", "variant"];
const SelectSelect = styled$1('div', {
  name: 'MuiSelect',
  slot: 'Select',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [
    // Win specificity over the input base
    {
      [`&.${selectClasses$1.select}`]: styles.select
    }, {
      [`&.${selectClasses$1.select}`]: styles[ownerState.variant]
    }, {
      [`&.${selectClasses$1.multiple}`]: styles.multiple
    }];
  }
})(nativeSelectSelectStyles, {
  // Win specificity over the input base
  [`&.${selectClasses$1.select}`]: {
    height: 'auto',
    // Resets for multiple select with chips
    minHeight: '1.4375em',
    // Required for select\text-field height consistency
    textOverflow: 'ellipsis',
    whiteSpace: 'nowrap',
    overflow: 'hidden'
  }
});
const SelectIcon = styled$1('svg', {
  name: 'MuiSelect',
  slot: 'Icon',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.icon, ownerState.variant && styles[`icon${capitalize(ownerState.variant)}`], ownerState.open && styles.iconOpen];
  }
})(nativeSelectIconStyles);
const SelectNativeInput = styled$1('input', {
  shouldForwardProp: prop => slotShouldForwardProp(prop) && prop !== 'classes',
  name: 'MuiSelect',
  slot: 'NativeInput',
  overridesResolver: (props, styles) => styles.nativeInput
})({
  bottom: 0,
  left: 0,
  position: 'absolute',
  opacity: 0,
  pointerEvents: 'none',
  width: '100%',
  boxSizing: 'border-box'
});
function areEqualValues$1(a, b) {
  if (typeof b === 'object' && b !== null) {
    return a === b;
  }

  // The value could be a number, the DOM will stringify it anyway.
  return String(a) === String(b);
}
function isEmpty(display) {
  return display == null || typeof display === 'string' && !display.trim();
}
const useUtilityClasses$v = ownerState => {
  const {
    classes,
    variant,
    disabled,
    multiple,
    open
  } = ownerState;
  const slots = {
    select: ['select', variant, disabled && 'disabled', multiple && 'multiple'],
    icon: ['icon', `icon${capitalize(variant)}`, open && 'iconOpen', disabled && 'disabled'],
    nativeInput: ['nativeInput']
  };
  return composeClasses(slots, getSelectUtilityClasses, classes);
};

/**
 * @ignore - internal component.
 */
const SelectInput = /*#__PURE__*/React__namespace.forwardRef(function SelectInput(props, ref) {
  const {
      'aria-describedby': ariaDescribedby,
      'aria-label': ariaLabel,
      autoFocus,
      autoWidth,
      children,
      className,
      defaultOpen,
      defaultValue,
      disabled,
      displayEmpty,
      IconComponent,
      inputRef: inputRefProp,
      labelId,
      MenuProps = {},
      multiple,
      name,
      onBlur,
      onChange,
      onClose,
      onFocus,
      onOpen,
      open: openProp,
      readOnly,
      renderValue,
      SelectDisplayProps = {},
      tabIndex: tabIndexProp,
      value: valueProp,
      variant = 'standard'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$_);
  const [value, setValueState] = useControlled({
    controlled: valueProp,
    default: defaultValue,
    name: 'Select'
  });
  const [openState, setOpenState] = useControlled({
    controlled: openProp,
    default: defaultOpen,
    name: 'Select'
  });
  const inputRef = React__namespace.useRef(null);
  const displayRef = React__namespace.useRef(null);
  const [displayNode, setDisplayNode] = React__namespace.useState(null);
  const {
    current: isOpenControlled
  } = React__namespace.useRef(openProp != null);
  const [menuMinWidthState, setMenuMinWidthState] = React__namespace.useState();
  const handleRef = useForkRef(ref, inputRefProp);
  const handleDisplayRef = React__namespace.useCallback(node => {
    displayRef.current = node;
    if (node) {
      setDisplayNode(node);
    }
  }, []);
  const anchorElement = displayNode == null ? void 0 : displayNode.parentNode;
  React__namespace.useImperativeHandle(handleRef, () => ({
    focus: () => {
      displayRef.current.focus();
    },
    node: inputRef.current,
    value
  }), [value]);

  // Resize menu on `defaultOpen` automatic toggle.
  React__namespace.useEffect(() => {
    if (defaultOpen && openState && displayNode && !isOpenControlled) {
      setMenuMinWidthState(autoWidth ? null : anchorElement.clientWidth);
      displayRef.current.focus();
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [displayNode, autoWidth]);
  // `isOpenControlled` is ignored because the component should never switch between controlled and uncontrolled modes.
  // `defaultOpen` and `openState` are ignored to avoid unnecessary callbacks.
  React__namespace.useEffect(() => {
    if (autoFocus) {
      displayRef.current.focus();
    }
  }, [autoFocus]);
  React__namespace.useEffect(() => {
    if (!labelId) {
      return undefined;
    }
    const label = ownerDocument(displayRef.current).getElementById(labelId);
    if (label) {
      const handler = () => {
        if (getSelection().isCollapsed) {
          displayRef.current.focus();
        }
      };
      label.addEventListener('click', handler);
      return () => {
        label.removeEventListener('click', handler);
      };
    }
    return undefined;
  }, [labelId]);
  const update = (open, event) => {
    if (open) {
      if (onOpen) {
        onOpen(event);
      }
    } else if (onClose) {
      onClose(event);
    }
    if (!isOpenControlled) {
      setMenuMinWidthState(autoWidth ? null : anchorElement.clientWidth);
      setOpenState(open);
    }
  };
  const handleMouseDown = event => {
    // Ignore everything but left-click
    if (event.button !== 0) {
      return;
    }
    // Hijack the default focus behavior.
    event.preventDefault();
    displayRef.current.focus();
    update(true, event);
  };
  const handleClose = event => {
    update(false, event);
  };
  const childrenArray = React__namespace.Children.toArray(children);

  // Support autofill.
  const handleChange = event => {
    const index = childrenArray.map(child => child.props.value).indexOf(event.target.value);
    if (index === -1) {
      return;
    }
    const child = childrenArray[index];
    setValueState(child.props.value);
    if (onChange) {
      onChange(event, child);
    }
  };
  const handleItemClick = child => event => {
    let newValue;

    // We use the tabindex attribute to signal the available options.
    if (!event.currentTarget.hasAttribute('tabindex')) {
      return;
    }
    if (multiple) {
      newValue = Array.isArray(value) ? value.slice() : [];
      const itemIndex = value.indexOf(child.props.value);
      if (itemIndex === -1) {
        newValue.push(child.props.value);
      } else {
        newValue.splice(itemIndex, 1);
      }
    } else {
      newValue = child.props.value;
    }
    if (child.props.onClick) {
      child.props.onClick(event);
    }
    if (value !== newValue) {
      setValueState(newValue);
      if (onChange) {
        // Redefine target to allow name and value to be read.
        // This allows seamless integration with the most popular form libraries.
        // https://github.com/mui/material-ui/issues/13485#issuecomment-676048492
        // Clone the event to not override `target` of the original event.
        const nativeEvent = event.nativeEvent || event;
        const clonedEvent = new nativeEvent.constructor(nativeEvent.type, nativeEvent);
        Object.defineProperty(clonedEvent, 'target', {
          writable: true,
          value: {
            value: newValue,
            name
          }
        });
        onChange(clonedEvent, child);
      }
    }
    if (!multiple) {
      update(false, event);
    }
  };
  const handleKeyDown = event => {
    if (!readOnly) {
      const validKeys = [' ', 'ArrowUp', 'ArrowDown',
      // The native select doesn't respond to enter on macOS, but it's recommended by
      // https://www.w3.org/WAI/ARIA/apg/patterns/combobox/examples/combobox-select-only/
      'Enter'];
      if (validKeys.indexOf(event.key) !== -1) {
        event.preventDefault();
        update(true, event);
      }
    }
  };
  const open = displayNode !== null && openState;
  const handleBlur = event => {
    // if open event.stopImmediatePropagation
    if (!open && onBlur) {
      // Preact support, target is read only property on a native event.
      Object.defineProperty(event, 'target', {
        writable: true,
        value: {
          value,
          name
        }
      });
      onBlur(event);
    }
  };
  delete other['aria-invalid'];
  let display;
  let displaySingle;
  const displayMultiple = [];
  let computeDisplay = false;
  let foundMatch = false;

  // No need to display any value if the field is empty.
  if (isFilled({
    value
  }) || displayEmpty) {
    if (renderValue) {
      display = renderValue(value);
    } else {
      computeDisplay = true;
    }
  }
  const items = childrenArray.map(child => {
    if (! /*#__PURE__*/React__namespace.isValidElement(child)) {
      return null;
    }
    if (browser$1.env.NODE_ENV !== 'production') {
      if (reactIsExports.isFragment(child)) {
        console.error(["MUI: The Select component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
      }
    }
    let selected;
    if (multiple) {
      if (!Array.isArray(value)) {
        throw new Error(browser$1.env.NODE_ENV !== "production" ? `MUI: The \`value\` prop must be an array when using the \`Select\` component with \`multiple\`.` : formatMuiErrorMessage(2));
      }
      selected = value.some(v => areEqualValues$1(v, child.props.value));
      if (selected && computeDisplay) {
        displayMultiple.push(child.props.children);
      }
    } else {
      selected = areEqualValues$1(value, child.props.value);
      if (selected && computeDisplay) {
        displaySingle = child.props.children;
      }
    }
    if (selected) {
      foundMatch = true;
    }
    return /*#__PURE__*/React__namespace.cloneElement(child, {
      'aria-selected': selected ? 'true' : 'false',
      onClick: handleItemClick(child),
      onKeyUp: event => {
        if (event.key === ' ') {
          // otherwise our MenuItems dispatches a click event
          // it's not behavior of the native <option> and causes
          // the select to close immediately since we open on space keydown
          event.preventDefault();
        }
        if (child.props.onKeyUp) {
          child.props.onKeyUp(event);
        }
      },
      role: 'option',
      selected,
      value: undefined,
      // The value is most likely not a valid HTML attribute.
      'data-value': child.props.value // Instead, we provide it as a data attribute.
    });
  });

  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useEffect(() => {
      if (!foundMatch && !multiple && value !== '') {
        const values = childrenArray.map(child => child.props.value);
        console.warn([`MUI: You have provided an out-of-range value \`${value}\` for the select ${name ? `(name="${name}") ` : ''}component.`, "Consider providing a value that matches one of the available options or ''.", `The available values are ${values.filter(x => x != null).map(x => `\`${x}\``).join(', ') || '""'}.`].join('\n'));
      }
    }, [foundMatch, childrenArray, multiple, name, value]);
  }
  if (computeDisplay) {
    if (multiple) {
      if (displayMultiple.length === 0) {
        display = null;
      } else {
        display = displayMultiple.reduce((output, child, index) => {
          output.push(child);
          if (index < displayMultiple.length - 1) {
            output.push(', ');
          }
          return output;
        }, []);
      }
    } else {
      display = displaySingle;
    }
  }

  // Avoid performing a layout computation in the render method.
  let menuMinWidth = menuMinWidthState;
  if (!autoWidth && isOpenControlled && displayNode) {
    menuMinWidth = anchorElement.clientWidth;
  }
  let tabIndex;
  if (typeof tabIndexProp !== 'undefined') {
    tabIndex = tabIndexProp;
  } else {
    tabIndex = disabled ? null : 0;
  }
  const buttonId = SelectDisplayProps.id || (name ? `mui-component-select-${name}` : undefined);
  const ownerState = _extends$1({}, props, {
    variant,
    value,
    open
  });
  const classes = useUtilityClasses$v(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
    children: [/*#__PURE__*/jsxRuntimeExports.jsx(SelectSelect, _extends$1({
      ref: handleDisplayRef,
      tabIndex: tabIndex,
      role: "button",
      "aria-disabled": disabled ? 'true' : undefined,
      "aria-expanded": open ? 'true' : 'false',
      "aria-haspopup": "listbox",
      "aria-label": ariaLabel,
      "aria-labelledby": [labelId, buttonId].filter(Boolean).join(' ') || undefined,
      "aria-describedby": ariaDescribedby,
      onKeyDown: handleKeyDown,
      onMouseDown: disabled || readOnly ? null : handleMouseDown,
      onBlur: handleBlur,
      onFocus: onFocus
    }, SelectDisplayProps, {
      ownerState: ownerState,
      className: clsx(SelectDisplayProps.className, classes.select, className)
      // The id is required for proper a11y
      ,
      id: buttonId,
      children: isEmpty(display) ? // notranslate needed while Google Translate will not fix zero-width space issue
      _span || (_span = /*#__PURE__*/jsxRuntimeExports.jsx("span", {
        className: "notranslate",
        children: "\u200B"
      })) : display
    })), /*#__PURE__*/jsxRuntimeExports.jsx(SelectNativeInput, _extends$1({
      value: Array.isArray(value) ? value.join(',') : value,
      name: name,
      ref: inputRef,
      "aria-hidden": true,
      onChange: handleChange,
      tabIndex: -1,
      disabled: disabled,
      className: classes.nativeInput,
      autoFocus: autoFocus,
      ownerState: ownerState
    }, other)), /*#__PURE__*/jsxRuntimeExports.jsx(SelectIcon, {
      as: IconComponent,
      className: classes.icon,
      ownerState: ownerState
    }), /*#__PURE__*/jsxRuntimeExports.jsx(Menu$1, _extends$1({
      id: `menu-${name || ''}`,
      anchorEl: anchorElement,
      open: open,
      onClose: handleClose,
      anchorOrigin: {
        vertical: 'bottom',
        horizontal: 'center'
      },
      transformOrigin: {
        vertical: 'top',
        horizontal: 'center'
      }
    }, MenuProps, {
      MenuListProps: _extends$1({
        'aria-labelledby': labelId,
        role: 'listbox',
        disableListWrap: true
      }, MenuProps.MenuListProps),
      PaperProps: _extends$1({}, MenuProps.PaperProps, {
        style: _extends$1({
          minWidth: menuMinWidth
        }, MenuProps.PaperProps != null ? MenuProps.PaperProps.style : null)
      }),
      children: items
    }))]
  });
});
browser$1.env.NODE_ENV !== "production" ? SelectInput.propTypes = {
  /**
   * @ignore
   */
  'aria-describedby': propTypesExports.string,
  /**
   * @ignore
   */
  'aria-label': propTypesExports.string,
  /**
   * @ignore
   */
  autoFocus: propTypesExports.bool,
  /**
   * If `true`, the width of the popover will automatically be set according to the items inside the
   * menu, otherwise it will be at least the width of the select input.
   */
  autoWidth: propTypesExports.bool,
  /**
   * The option elements to populate the select with.
   * Can be some `<MenuItem>` elements.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypesExports.object,
  /**
   * The CSS class name of the select element.
   */
  className: propTypesExports.string,
  /**
   * If `true`, the component is toggled on mount. Use when the component open state is not controlled.
   * You can only use it when the `native` prop is `false` (default).
   */
  defaultOpen: propTypesExports.bool,
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * If `true`, the select is disabled.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the selected item is displayed even if its value is empty.
   */
  displayEmpty: propTypesExports.bool,
  /**
   * The icon that displays the arrow.
   */
  IconComponent: propTypesExports.elementType.isRequired,
  /**
   * Imperative handle implementing `{ value: T, node: HTMLElement, focus(): void }`
   * Equivalent to `ref`
   */
  inputRef: refType$1,
  /**
   * The ID of an element that acts as an additional label. The Select will
   * be labelled by the additional label and the selected value.
   */
  labelId: propTypesExports.string,
  /**
   * Props applied to the [`Menu`](/material-ui/api/menu/) element.
   */
  MenuProps: propTypesExports.object,
  /**
   * If `true`, `value` must be an array and the menu will support multiple selections.
   */
  multiple: propTypesExports.bool,
  /**
   * Name attribute of the `select` or hidden `input` element.
   */
  name: propTypesExports.string,
  /**
   * @ignore
   */
  onBlur: propTypesExports.func,
  /**
   * Callback fired when a menu item is selected.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (any).
   * @param {object} [child] The react element that was selected.
   */
  onChange: propTypesExports.func,
  /**
   * Callback fired when the component requests to be closed.
   * Use in controlled mode (see open).
   *
   * @param {object} event The event source of the callback.
   */
  onClose: propTypesExports.func,
  /**
   * @ignore
   */
  onFocus: propTypesExports.func,
  /**
   * Callback fired when the component requests to be opened.
   * Use in controlled mode (see open).
   *
   * @param {object} event The event source of the callback.
   */
  onOpen: propTypesExports.func,
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool,
  /**
   * @ignore
   */
  readOnly: propTypesExports.bool,
  /**
   * Render the selected value.
   *
   * @param {any} value The `value` provided to the component.
   * @returns {ReactNode}
   */
  renderValue: propTypesExports.func,
  /**
   * Props applied to the clickable div element.
   */
  SelectDisplayProps: propTypesExports.object,
  /**
   * @ignore
   */
  tabIndex: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * @ignore
   */
  type: propTypesExports.any,
  /**
   * The input value.
   */
  value: propTypesExports.any,
  /**
   * The variant to use.
   */
  variant: propTypesExports.oneOf(['standard', 'outlined', 'filled'])
} : void 0;
var SelectInput$1 = SelectInput;

var ArrowDropDownIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M7 10l5 5 5-5z"
}), 'ArrowDropDown');

var _StyledInput, _StyledFilledInput;
const _excluded$Z = ["autoWidth", "children", "classes", "className", "defaultOpen", "displayEmpty", "IconComponent", "id", "input", "inputProps", "label", "labelId", "MenuProps", "multiple", "native", "onClose", "onOpen", "open", "renderValue", "SelectDisplayProps", "variant"];
const useUtilityClasses$u = ownerState => {
  const {
    classes
  } = ownerState;
  return classes;
};
const styledRootConfig = {
  name: 'MuiSelect',
  overridesResolver: (props, styles) => styles.root,
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) && prop !== 'variant',
  slot: 'Root'
};
const StyledInput = styled$1(Input$1, styledRootConfig)('');
const StyledOutlinedInput = styled$1(OutlinedInput$1, styledRootConfig)('');
const StyledFilledInput = styled$1(FilledInput$1, styledRootConfig)('');
const Select = /*#__PURE__*/React__namespace.forwardRef(function Select(inProps, ref) {
  const props = useThemeProps({
    name: 'MuiSelect',
    props: inProps
  });
  const {
      autoWidth = false,
      children,
      classes: classesProp = {},
      className,
      defaultOpen = false,
      displayEmpty = false,
      IconComponent = ArrowDropDownIcon,
      id,
      input,
      inputProps,
      label,
      labelId,
      MenuProps,
      multiple = false,
      native = false,
      onClose,
      onOpen,
      open,
      renderValue,
      SelectDisplayProps,
      variant: variantProp = 'outlined'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$Z);
  const inputComponent = native ? NativeSelectInput$1 : SelectInput$1;
  const muiFormControl = useFormControl();
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['variant']
  });
  const variant = fcs.variant || variantProp;
  const InputComponent = input || {
    standard: _StyledInput || (_StyledInput = /*#__PURE__*/jsxRuntimeExports.jsx(StyledInput, {})),
    outlined: /*#__PURE__*/jsxRuntimeExports.jsx(StyledOutlinedInput, {
      label: label
    }),
    filled: _StyledFilledInput || (_StyledFilledInput = /*#__PURE__*/jsxRuntimeExports.jsx(StyledFilledInput, {}))
  }[variant];
  const ownerState = _extends$1({}, props, {
    variant,
    classes: classesProp
  });
  const classes = useUtilityClasses$u(ownerState);
  const inputComponentRef = useForkRef(ref, InputComponent.ref);
  return /*#__PURE__*/jsxRuntimeExports.jsx(React__namespace.Fragment, {
    children: /*#__PURE__*/React__namespace.cloneElement(InputComponent, _extends$1({
      // Most of the logic is implemented in `SelectInput`.
      // The `Select` component is a simple API wrapper to expose something better to play with.
      inputComponent,
      inputProps: _extends$1({
        children,
        IconComponent,
        variant,
        type: undefined,
        // We render a select. We can ignore the type provided by the `Input`.
        multiple
      }, native ? {
        id
      } : {
        autoWidth,
        defaultOpen,
        displayEmpty,
        labelId,
        MenuProps,
        onClose,
        onOpen,
        open,
        renderValue,
        SelectDisplayProps: _extends$1({
          id
        }, SelectDisplayProps)
      }, inputProps, {
        classes: inputProps ? deepmerge(classes, inputProps.classes) : classes
      }, input ? input.props.inputProps : {})
    }, multiple && native && variant === 'outlined' ? {
      notched: true
    } : {}, {
      ref: inputComponentRef,
      className: clsx(InputComponent.props.className, className)
    }, !input && {
      variant
    }, other))
  });
});
browser$1.env.NODE_ENV !== "production" ? Select.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, the width of the popover will automatically be set according to the items inside the
   * menu, otherwise it will be at least the width of the select input.
   * @default false
   */
  autoWidth: propTypesExports.bool,
  /**
   * The option elements to populate the select with.
   * Can be some `MenuItem` when `native` is false and `option` when `native` is true.
   *
   * ⚠️The `MenuItem` elements **must** be direct descendants when `native` is false.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   * @default {}
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * If `true`, the component is initially open. Use when the component open state is not controlled (i.e. the `open` prop is not defined).
   * You can only use it when the `native` prop is `false` (default).
   * @default false
   */
  defaultOpen: propTypesExports.bool,
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * If `true`, a value is displayed even if no items are selected.
   *
   * In order to display a meaningful value, a function can be passed to the `renderValue` prop which
   * returns the value to be displayed when no items are selected.
   *
   * ⚠️ When using this prop, make sure the label doesn't overlap with the empty displayed value.
   * The label should either be hidden or forced to a shrunk state.
   * @default false
   */
  displayEmpty: propTypesExports.bool,
  /**
   * The icon that displays the arrow.
   * @default ArrowDropDownIcon
   */
  IconComponent: propTypesExports.elementType,
  /**
   * The `id` of the wrapper element or the `select` element when `native`.
   */
  id: propTypesExports.string,
  /**
   * An `Input` element; does not have to be a material-ui specific `Input`.
   */
  input: propTypesExports.element,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   * When `native` is `true`, the attributes are applied on the `select` element.
   */
  inputProps: propTypesExports.object,
  /**
   * See [OutlinedInput#label](/material-ui/api/outlined-input/#props)
   */
  label: propTypesExports.node,
  /**
   * The ID of an element that acts as an additional label. The Select will
   * be labelled by the additional label and the selected value.
   */
  labelId: propTypesExports.string,
  /**
   * Props applied to the [`Menu`](/material-ui/api/menu/) element.
   */
  MenuProps: propTypesExports.object,
  /**
   * If `true`, `value` must be an array and the menu will support multiple selections.
   * @default false
   */
  multiple: propTypesExports.bool,
  /**
   * If `true`, the component uses a native `select` element.
   * @default false
   */
  native: propTypesExports.bool,
  /**
   * Callback fired when a menu item is selected.
   *
   * @param {SelectChangeEvent<T>} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (any).
   * **Warning**: This is a generic event, not a change event, unless the change event is caused by browser autofill.
   * @param {object} [child] The react element that was selected when `native` is `false` (default).
   */
  onChange: propTypesExports.func,
  /**
   * Callback fired when the component requests to be closed.
   * Use it in either controlled (see the `open` prop), or uncontrolled mode (to detect when the Select collapes).
   *
   * @param {object} event The event source of the callback.
   */
  onClose: propTypesExports.func,
  /**
   * Callback fired when the component requests to be opened.
   * Use it in either controlled (see the `open` prop), or uncontrolled mode (to detect when the Select expands).
   *
   * @param {object} event The event source of the callback.
   */
  onOpen: propTypesExports.func,
  /**
   * If `true`, the component is shown.
   * You can only use it when the `native` prop is `false` (default).
   */
  open: propTypesExports.bool,
  /**
   * Render the selected value.
   * You can only use it when the `native` prop is `false` (default).
   *
   * @param {any} value The `value` provided to the component.
   * @returns {ReactNode}
   */
  renderValue: propTypesExports.func,
  /**
   * Props applied to the clickable div element.
   */
  SelectDisplayProps: propTypesExports.object,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The `input` value. Providing an empty string will select no options.
   * Set to an empty string `''` if you don't want any of the available options to be selected.
   *
   * If the value is an object it must have reference equality with the option in order to be selected.
   * If the value is not an object, the string representation must match with the string representation of the option in order to be selected.
   */
  value: propTypesExports.oneOfType([propTypesExports.oneOf(['']), propTypesExports.any]),
  /**
   * The variant to use.
   * @default 'outlined'
   */
  variant: propTypesExports.oneOf(['filled', 'outlined', 'standard'])
} : void 0;
Select.muiName = 'Select';
var Select$1 = Select;

function getTextFieldUtilityClass(slot) {
  return generateUtilityClass('MuiTextField', slot);
}
generateUtilityClasses('MuiTextField', ['root']);

const _excluded$Y = ["autoComplete", "autoFocus", "children", "className", "color", "defaultValue", "disabled", "error", "FormHelperTextProps", "fullWidth", "helperText", "id", "InputLabelProps", "inputProps", "InputProps", "inputRef", "label", "maxRows", "minRows", "multiline", "name", "onBlur", "onChange", "onFocus", "placeholder", "required", "rows", "select", "SelectProps", "type", "value", "variant"];
const variantComponent = {
  standard: Input$1,
  filled: FilledInput$1,
  outlined: OutlinedInput$1
};
const useUtilityClasses$t = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root']
  };
  return composeClasses(slots, getTextFieldUtilityClass, classes);
};
const TextFieldRoot = styled$1(FormControl$1, {
  name: 'MuiTextField',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({});

/**
 * The `TextField` is a convenience wrapper for the most common cases (80%).
 * It cannot be all things to all people, otherwise the API would grow out of control.
 *
 * ## Advanced Configuration
 *
 * It's important to understand that the text field is a simple abstraction
 * on top of the following components:
 *
 * - [FormControl](/material-ui/api/form-control/)
 * - [InputLabel](/material-ui/api/input-label/)
 * - [FilledInput](/material-ui/api/filled-input/)
 * - [OutlinedInput](/material-ui/api/outlined-input/)
 * - [Input](/material-ui/api/input/)
 * - [FormHelperText](/material-ui/api/form-helper-text/)
 *
 * If you wish to alter the props applied to the `input` element, you can do so as follows:
 *
 * ```jsx
 * const inputProps = {
 *   step: 300,
 * };
 *
 * return <TextField id="time" type="time" inputProps={inputProps} />;
 * ```
 *
 * For advanced cases, please look at the source of TextField by clicking on the
 * "Edit this page" button above. Consider either:
 *
 * - using the upper case props for passing values directly to the components
 * - using the underlying components directly as shown in the demos
 */
const TextField = /*#__PURE__*/React__namespace.forwardRef(function TextField(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTextField'
  });
  const {
      autoComplete,
      autoFocus = false,
      children,
      className,
      color = 'primary',
      defaultValue,
      disabled = false,
      error = false,
      FormHelperTextProps,
      fullWidth = false,
      helperText,
      id: idOverride,
      InputLabelProps,
      inputProps,
      InputProps,
      inputRef,
      label,
      maxRows,
      minRows,
      multiline = false,
      name,
      onBlur,
      onChange,
      onFocus,
      placeholder,
      required = false,
      rows,
      select = false,
      SelectProps,
      type,
      value,
      variant = 'outlined'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$Y);
  const ownerState = _extends$1({}, props, {
    autoFocus,
    color,
    disabled,
    error,
    fullWidth,
    multiline,
    required,
    select,
    variant
  });
  const classes = useUtilityClasses$t(ownerState);
  if (browser$1.env.NODE_ENV !== 'production') {
    if (select && !children) {
      console.error('MUI: `children` must be passed when using the `TextField` component with `select`.');
    }
  }
  const InputMore = {};
  if (variant === 'outlined') {
    if (InputLabelProps && typeof InputLabelProps.shrink !== 'undefined') {
      InputMore.notched = InputLabelProps.shrink;
    }
    InputMore.label = label;
  }
  if (select) {
    // unset defaults from textbox inputs
    if (!SelectProps || !SelectProps.native) {
      InputMore.id = undefined;
    }
    InputMore['aria-describedby'] = undefined;
  }
  const id = useId(idOverride);
  const helperTextId = helperText && id ? `${id}-helper-text` : undefined;
  const inputLabelId = label && id ? `${id}-label` : undefined;
  const InputComponent = variantComponent[variant];
  const InputElement = /*#__PURE__*/jsxRuntimeExports.jsx(InputComponent, _extends$1({
    "aria-describedby": helperTextId,
    autoComplete: autoComplete,
    autoFocus: autoFocus,
    defaultValue: defaultValue,
    fullWidth: fullWidth,
    multiline: multiline,
    name: name,
    rows: rows,
    maxRows: maxRows,
    minRows: minRows,
    type: type,
    value: value,
    id: id,
    inputRef: inputRef,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    placeholder: placeholder,
    inputProps: inputProps
  }, InputMore, InputProps));
  return /*#__PURE__*/jsxRuntimeExports.jsxs(TextFieldRoot, _extends$1({
    className: clsx(classes.root, className),
    disabled: disabled,
    error: error,
    fullWidth: fullWidth,
    ref: ref,
    required: required,
    color: color,
    variant: variant,
    ownerState: ownerState
  }, other, {
    children: [label != null && label !== '' && /*#__PURE__*/jsxRuntimeExports.jsx(InputLabel$1, _extends$1({
      htmlFor: id,
      id: inputLabelId
    }, InputLabelProps, {
      children: label
    })), select ? /*#__PURE__*/jsxRuntimeExports.jsx(Select$1, _extends$1({
      "aria-describedby": helperTextId,
      id: id,
      labelId: inputLabelId,
      value: value,
      input: InputElement
    }, SelectProps, {
      children: children
    })) : InputElement, helperText && /*#__PURE__*/jsxRuntimeExports.jsx(FormHelperText$1, _extends$1({
      id: helperTextId
    }, FormHelperTextProps, {
      children: helperText
    }))]
  }));
});
browser$1.env.NODE_ENV !== "production" ? TextField.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * This prop helps users to fill forms faster, especially on mobile devices.
   * The name can be confusing, as it's more like an autofill.
   * You can learn more about it [following the specification](https://html.spec.whatwg.org/multipage/form-control-infrastructure.html#autofill).
   */
  autoComplete: propTypesExports.string,
  /**
   * If `true`, the `input` element is focused during the first mount.
   * @default false
   */
  autoFocus: propTypesExports.bool,
  /**
   * @ignore
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'primary'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the label is displayed in an error state.
   * @default false
   */
  error: propTypesExports.bool,
  /**
   * Props applied to the [`FormHelperText`](/material-ui/api/form-helper-text/) element.
   */
  FormHelperTextProps: propTypesExports.object,
  /**
   * If `true`, the input will take up the full width of its container.
   * @default false
   */
  fullWidth: propTypesExports.bool,
  /**
   * The helper text content.
   */
  helperText: propTypesExports.node,
  /**
   * The id of the `input` element.
   * Use this prop to make `label` and `helperText` accessible for screen readers.
   */
  id: propTypesExports.string,
  /**
   * Props applied to the [`InputLabel`](/material-ui/api/input-label/) element.
   * Pointer events like `onClick` are enabled if and only if `shrink` is `true`.
   */
  InputLabelProps: propTypesExports.object,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   */
  inputProps: propTypesExports.object,
  /**
   * Props applied to the Input element.
   * It will be a [`FilledInput`](/material-ui/api/filled-input/),
   * [`OutlinedInput`](/material-ui/api/outlined-input/) or [`Input`](/material-ui/api/input/)
   * component depending on the `variant` prop value.
   */
  InputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * The label content.
   */
  label: propTypesExports.node,
  /**
   * If `dense` or `normal`, will adjust vertical spacing of this and contained components.
   * @default 'none'
   */
  margin: propTypesExports.oneOf(['dense', 'none', 'normal']),
  /**
   * Maximum number of rows to display when multiline option is set to true.
   */
  maxRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * Minimum number of rows to display when multiline option is set to true.
   */
  minRows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * If `true`, a `textarea` element is rendered instead of an input.
   * @default false
   */
  multiline: propTypesExports.bool,
  /**
   * Name attribute of the `input` element.
   */
  name: propTypesExports.string,
  /**
   * @ignore
   */
  onBlur: propTypesExports.func,
  /**
   * Callback fired when the value is changed.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypesExports.func,
  /**
   * @ignore
   */
  onFocus: propTypesExports.func,
  /**
   * The short hint displayed in the `input` before the user enters a value.
   */
  placeholder: propTypesExports.string,
  /**
   * If `true`, the label is displayed as required and the `input` element is required.
   * @default false
   */
  required: propTypesExports.bool,
  /**
   * Number of rows to display when multiline option is set to true.
   */
  rows: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * Render a [`Select`](/material-ui/api/select/) element while passing the Input element to `Select` as `input` parameter.
   * If this option is set you must pass the options of the select as children.
   * @default false
   */
  select: propTypesExports.bool,
  /**
   * Props applied to the [`Select`](/material-ui/api/select/) element.
   */
  SelectProps: propTypesExports.object,
  /**
   * The size of the component.
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Type of the `input` element. It should be [a valid HTML5 input type](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Form_%3Cinput%3E_types).
   */
  type: propTypesExports /* @typescript-to-proptypes-ignore */.string,
  /**
   * The value of the `input` element, required for a controlled component.
   */
  value: propTypesExports.any,
  /**
   * The variant to use.
   * @default 'outlined'
   */
  variant: propTypesExports.oneOf(['filled', 'outlined', 'standard'])
} : void 0;
var TextField$1 = TextField;

function StyledTextField(_ref) {
  var props = _extends$2({}, (_objectDestructuringEmpty(_ref), _ref));
  return /*#__PURE__*/React__namespace.default.createElement(CustomTextField, props);
}
var FullWidthFormControl = styled__default.default(FormControl$1)({
  width: "100%"
});
var CustomTextField = styled__default.default(TextField$1)(function (_ref2) {
  var theme = _ref2.theme,
    backgroundColor = _ref2.backgroundColor;
  return {
    backgroundColor: backgroundColor || theme.palette.background["default"],
    margin: "2px",
    "& input:autofill": {
      WebkitTextFillColor: theme.palette.text.dark
    }
  };
});
var ExpandIcon = styled__default.default(default_1$K)({
  cursor: "zoom-in"
});

var _excluded$X = ["label", "inputLabel", "id", "value", "onChange", "isDisabled", "variant", "title", "validationMessage", "subtitle", "size"];
function FormTextInput(_ref) {
  var label = _ref.label,
    inputLabel = _ref.inputLabel,
    id = _ref.id,
    value = _ref.value,
    _onChange = _ref.onChange,
    isDisabled = _ref.isDisabled,
    _ref$variant = _ref.variant,
    variant = _ref$variant === void 0 ? "outlined" : _ref$variant,
    title = _ref.title,
    validationMessage = _ref.validationMessage,
    subtitle = _ref.subtitle,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? "small" : _ref$size,
    props = _objectWithoutProperties(_ref, _excluded$X);
  return /*#__PURE__*/React__namespace.default.createElement(FullWidthFormControl, null, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), subtitle && /*#__PURE__*/React__namespace.default.createElement(InputSubtitle, null, subtitle), /*#__PURE__*/React__namespace.default.createElement(StyledTextField, _extends$2({}, props, {
    label: inputLabel,
    id: id,
    variant: variant,
    placeholder: label,
    size: size,
    "aria-label": id || label,
    onChange: function onChange(event) {
      return _onChange(event.target.value);
    },
    value: value || "",
    disabled: isDisabled
  })), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    id: id,
    validationMessage: validationMessage
  }));
}
FormTextInput.propTypes = {
  title: propTypesExports.string,
  subtitle: propTypesExports.string,
  label: propTypesExports.string,
  id: propTypesExports.string,
  onChange: propTypesExports.func,
  value: propTypesExports.string,
  validationMessage: propTypesExports.string,
  isDisabled: propTypesExports.bool,
  size: propTypesExports.string,
  variant: propTypesExports.string,
  inputLabel: propTypesExports.string
};

var _excluded$W = ["value", "title", "label", "validationMessage", "shouldShowMenu", "inputRef", "data", "ready", "handleSelect", "handleInput", "TextComponent"];
function AddressInputContent(_ref) {
  var value = _ref.value,
    title = _ref.title,
    label = _ref.label,
    validationMessage = _ref.validationMessage,
    shouldShowMenu = _ref.shouldShowMenu,
    inputRef = _ref.inputRef,
    data = _ref.data,
    ready = _ref.ready,
    handleSelect = _ref.handleSelect,
    handleInput = _ref.handleInput,
    _ref$TextComponent = _ref.TextComponent,
    TextComponent = _ref$TextComponent === void 0 ? FormTextInput : _ref$TextComponent,
    props = _objectWithoutProperties(_ref, _excluded$W);
  return /*#__PURE__*/React__namespace.default.createElement(StyledFullWidthFormControl, null, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), /*#__PURE__*/React__namespace.default.createElement(TextComponent, _extends$2({}, props, {
    label: label,
    inputRef: inputRef,
    name: "".concat(FORM_INPUTS.ADDRESS, "-search"),
    placeholder: label,
    autoComplete: "off",
    id: FORM_INPUTS.ADDRESS,
    "aria-label": FORM_INPUTS.ADDRESS,
    value: value,
    onChange: handleInput,
    disabled: !ready,
    size: "small",
    error: !!validationMessage
  })), shouldShowMenu && /*#__PURE__*/React__namespace.default.createElement(Paper$1, {
    sx: paperOverrides
  }, /*#__PURE__*/React__namespace.default.createElement(MenuList$1, {
    dense: true,
    sx: menuListOverrides
  }, /*#__PURE__*/React__namespace.default.createElement(AddressPlacesSuggestions, {
    data: data,
    handleSelect: handleSelect
  }), /*#__PURE__*/React__namespace.default.createElement(GoogleLogo, {
    src: IMG.GOOGLE.SRC,
    alt: IMG.GOOGLE.ALT
  }))), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    id: ARIA_LABELS.ADDRESS_ERROR,
    validationMessage: validationMessage && FORM_ERROR.FULL_ADDRESS
  }));
}
AddressInputContent.propTypes = {
  value: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.object]),
  title: propTypesExports.string,
  label: propTypesExports.string,
  validationMessage: propTypesExports.any,
  shouldShowMenu: propTypesExports.bool,
  inputRef: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object]).isRequired,
  data: propTypesExports.array,
  ready: propTypesExports.bool,
  handleSelect: propTypesExports.func.isRequired,
  handleInput: propTypesExports.func.isRequired,
  TextComponent: propTypesExports.node
};
var StyledFullWidthFormControl = styled__default.default(FullWidthFormControl)({
  height: "inherit"
});

var ContentBlockFormContext$1 = /*#__PURE__*/React.createContext();
var useUtils = function useUtils() {
  return React.useContext(ContentBlockFormContext$1);
};
function UtilProvider(_ref) {
  var children = _ref.children,
    logError = _ref.logError,
    useAttachmentImage = _ref.useAttachmentImage,
    useDownloadAttachmentsZip = _ref.useDownloadAttachmentsZip,
    usePlacesAutocomplete = _ref.usePlacesAutocomplete,
    getAddress = _ref.getAddress,
    useCurrentUser = _ref.useCurrentUser;
  var values = React.useMemo(function () {
    return {
      logError: logError,
      useAttachmentImage: useAttachmentImage,
      useDownloadAttachmentsZip: useDownloadAttachmentsZip,
      usePlacesAutocomplete: usePlacesAutocomplete,
      getAddress: getAddress,
      useCurrentUser: useCurrentUser
    };
  }, [logError, useAttachmentImage, useDownloadAttachmentsZip, usePlacesAutocomplete, getAddress, useCurrentUser]);
  return /*#__PURE__*/React__namespace.default.createElement(ContentBlockFormContext$1.Provider, {
    value: values
  }, children);
}
UtilProvider.propTypes = {
  children: propTypesExports.any,
  logError: propTypesExports.func.isRequired,
  useAttachmentImage: propTypesExports.func.isRequired,
  usePlacesAutocomplete: propTypesExports.func,
  getAddress: propTypesExports.func,
  useCurrentUser: propTypesExports.func.isRequired,
  useDownloadAttachmentsZip: propTypesExports.func.isRequired
};

var _excluded$V = ["value", "title", "label", "validationMessage", "onChange"];
function AddressFormTextInput(_ref) {
  var formVal = _ref.value,
    title = _ref.title,
    label = _ref.label,
    validationMessage = _ref.validationMessage,
    onChange = _ref.onChange,
    props = _objectWithoutProperties(_ref, _excluded$V);
  var _useUtils = useUtils(),
    usePlacesAutocomplete = _useUtils.usePlacesAutocomplete,
    getAddress = _useUtils.getAddress;
  var inputRef = React.useRef();
  var initVal = getInitialValue(formVal);
  var addressId = formVal === null || formVal === void 0 ? void 0 : formVal.id;
  var _usePlacesAutocomplet = usePlacesAutocomplete(),
    ready = _usePlacesAutocomplet.ready,
    value = _usePlacesAutocomplet.value,
    _usePlacesAutocomplet2 = _usePlacesAutocomplet.suggestions,
    status = _usePlacesAutocomplet2.status,
    data = _usePlacesAutocomplet2.data,
    setValue = _usePlacesAutocomplet.setValue,
    clearSuggestions = _usePlacesAutocomplet.clearSuggestions;
  var shouldShowMenu = status === OK && value !== initVal;
  var handleInput = function handleInput(newValue) {
    // if user clears input, reset form value
    if (newValue.length === 0) {
      onChange({
        id: addressId
      });
    }
    setValue(newValue);
  };

  // if existing value exists, set value equal to it
  React.useEffect(function () {
    if (formVal) {
      setValue(initVal);
    }
  }, []);
  var handleSelect = function handleSelect(googleData) {
    return function () {
      // focus on input so onBlur error will show once user clicks away from input
      inputRef.current.focus();
      addAddress({
        addressId: addressId,
        googleData: googleData,
        setValue: setValue,
        clearSuggestions: clearSuggestions,
        onChange: onChange,
        getAddress: getAddress
      });
    };
  };
  return /*#__PURE__*/React__namespace.default.createElement(AddressInputContent, _extends$2({
    value: value,
    title: title,
    label: label,
    validationMessage: validationMessage,
    shouldShowMenu: shouldShowMenu,
    inputRef: inputRef,
    data: data,
    ready: ready,
    handleSelect: handleSelect,
    handleInput: handleInput
  }, props));
}
function addAddress(_x) {
  return _addAddress.apply(this, arguments);
}
function _addAddress() {
  _addAddress = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref2) {
    var addressId, googleData, setValue, clearSuggestions, onChange, getAddress, description, placeId, address;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          addressId = _ref2.addressId, googleData = _ref2.googleData, setValue = _ref2.setValue, clearSuggestions = _ref2.clearSuggestions, onChange = _ref2.onChange, getAddress = _ref2.getAddress;
          setValue(googleData.description, false);
          clearSuggestions();
          _context.prev = 3;
          description = googleData.description, placeId = googleData.place_id;
          _context.next = 7;
          return getAddress({
            description: description,
            placeId: placeId
          });
        case 7:
          address = _context.sent;
          if (addressId) {
            address.id = addressId;
          }
          onChange(address);
          _context.next = 15;
          break;
        case 12:
          _context.prev = 12;
          _context.t0 = _context["catch"](3);
          onChange({
            id: addressId
          });
        case 15:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[3, 12]]);
  }));
  return _addAddress.apply(this, arguments);
}
function getInitialValue(address) {
  if (!(address !== null && address !== void 0 && address.city)) return "";
  var lineOneOrEmpty = address.line_1 ? "".concat(address.line_1, ", ") : "";
  return "".concat(lineOneOrEmpty).concat(address === null || address === void 0 ? void 0 : address.city, ", ").concat(address === null || address === void 0 ? void 0 : address.state);
}
AddressFormTextInput.propTypes = {
  value: propTypesExports.object,
  title: propTypesExports.string,
  label: propTypesExports.string,
  onChange: propTypesExports.func,
  validationMessage: propTypesExports.any
};

function FileUploadInput(_ref) {
  var id = _ref.id,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    _onChange = _ref.onChange,
    title = _ref.title,
    accept = _ref.accept,
    _ref$ContainerCompone = _ref.ContainerComponent,
    ContainerComponent = _ref$ContainerCompone === void 0 ? FullWidthFormControl : _ref$ContainerCompone,
    EmptyComponent = _ref.EmptyComponent,
    testId = _ref.testId,
    isMultiple = _ref.isMultiple;
  return /*#__PURE__*/React__namespace.default.createElement(ContainerComponent, null, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), /*#__PURE__*/React__namespace.default.createElement(EmptyComponent, {
    id: id,
    value: value,
    onChange: _onChange
  }), /*#__PURE__*/React__namespace.default.createElement(UploadInput, {
    id: id,
    "aria-label": id,
    onChange: function onChange(event) {
      return handleOnChange$4({
        onChange: _onChange,
        isMultiple: isMultiple,
        value: value,
        event: event
      });
    },
    inputProps: {
      accept: accept,
      multiple: isMultiple,
      "data-testid": testId
    },
    error: !!validationMessage,
    type: "file"
  }));
}
FileUploadInput.propTypes = {
  id: propTypesExports.string.isRequired,
  value: propTypesExports.any,
  onChange: propTypesExports.func.isRequired,
  validationMessage: propTypesExports.string,
  title: propTypesExports.string,
  accept: propTypesExports.string,
  ContainerComponent: propTypesExports.elementType,
  EmptyComponent: propTypesExports.elementType.isRequired,
  testId: propTypesExports.string,
  isMultiple: propTypesExports.bool
};
var UploadInput = styled__default.default(material.Input)(function () {
  return {
    display: "none"
  };
});

// The file from the picker will be undefined if user cancels.
function handleOnChange$4(_ref2) {
  var onChange = _ref2.onChange,
    event = _ref2.event,
    isMultiple = _ref2.isMultiple,
    _ref2$value = _ref2.value,
    value = _ref2$value === void 0 ? [] : _ref2$value;
  var newFiles = event.target.files;
  if (!(newFiles !== null && newFiles !== void 0 && newFiles.length)) return;
  if (!isMultiple) {
    onChange(newFiles[0]);
    return;
  }

  // newFiles is a FileList so we need to convert it to an array
  var newFileArray = Array.from(newFiles);
  onChange([].concat(_toConsumableArray(value), newFileArray));

  // this is to allow for the same file to be uploaded multiple times
  // by default if the value is the file it wont let the same file get uploaded again
  event.target.value = "";
}

var Backup = {};

var _interopRequireDefault$J = interopRequireDefaultExports;
Object.defineProperty(Backup, "__esModule", {
  value: true
});
var default_1$J = Backup.default = void 0;
var _createSvgIcon$J = _interopRequireDefault$J(requireCreateSvgIcon());
var _jsxRuntime$J = requireJsxRuntime();
var _default$J = (0, _createSvgIcon$J.default)( /*#__PURE__*/(0, _jsxRuntime$J.jsx)("path", {
  d: "M19.35 10.04C18.67 6.59 15.64 4 12 4 9.11 4 6.6 5.64 5.35 8.04 2.34 8.36 0 10.91 0 14c0 3.31 2.69 6 6 6h13c2.76 0 5-2.24 5-5 0-2.64-2.05-4.78-4.65-4.96zM14 13v4h-4v-4H7l5-5 5 5h-3z"
}), 'Backup');
default_1$J = Backup.default = _default$J;

// Ported from Compass
// https://github.com/Compass/compass/blob/master/core/stylesheets/compass/typography/_units.scss
// Emulate the sass function "unit"
function getUnit(input) {
  return String(input).match(/[\d.\-+]*\s*(.*)/)[1] || '';
}

// Emulate the sass function "unitless"
function toUnitless(length) {
  return parseFloat(length);
}

const defaultTheme = createTheme();
const Box = createBox({
  defaultTheme,
  defaultClassName: 'MuiBox-root',
  generateClassName: ClassNameGenerator$1.generate
});
browser$1.env.NODE_ENV !== "production" ? Box.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * @ignore
   */
  children: propTypesExports.node,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var Box$1 = Box;

var _Error = {};

var _interopRequireDefault$I = interopRequireDefaultExports;
Object.defineProperty(_Error, "__esModule", {
  value: true
});
var default_1$I = _Error.default = void 0;
var _createSvgIcon$I = _interopRequireDefault$I(requireCreateSvgIcon());
var _jsxRuntime$I = requireJsxRuntime();
var _default$I = (0, _createSvgIcon$I.default)( /*#__PURE__*/(0, _jsxRuntime$I.jsx)("path", {
  d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm1 15h-2v-2h2v2zm0-4h-2V7h2v6z"
}), 'Error');
default_1$I = _Error.default = _default$I;

function getButtonUtilityClass(slot) {
  return generateUtilityClass('MuiButton', slot);
}
const buttonClasses = generateUtilityClasses('MuiButton', ['root', 'text', 'textInherit', 'textPrimary', 'textSecondary', 'textSuccess', 'textError', 'textInfo', 'textWarning', 'outlined', 'outlinedInherit', 'outlinedPrimary', 'outlinedSecondary', 'outlinedSuccess', 'outlinedError', 'outlinedInfo', 'outlinedWarning', 'contained', 'containedInherit', 'containedPrimary', 'containedSecondary', 'containedSuccess', 'containedError', 'containedInfo', 'containedWarning', 'disableElevation', 'focusVisible', 'disabled', 'colorInherit', 'textSizeSmall', 'textSizeMedium', 'textSizeLarge', 'outlinedSizeSmall', 'outlinedSizeMedium', 'outlinedSizeLarge', 'containedSizeSmall', 'containedSizeMedium', 'containedSizeLarge', 'sizeMedium', 'sizeSmall', 'sizeLarge', 'fullWidth', 'startIcon', 'endIcon', 'iconSizeSmall', 'iconSizeMedium', 'iconSizeLarge']);
var buttonClasses$1 = buttonClasses;

/**
 * @ignore - internal component.
 */
const ButtonGroupContext = /*#__PURE__*/React__namespace.createContext({});
if (browser$1.env.NODE_ENV !== 'production') {
  ButtonGroupContext.displayName = 'ButtonGroupContext';
}
var ButtonGroupContext$1 = ButtonGroupContext;

const _excluded$U = ["children", "color", "component", "className", "disabled", "disableElevation", "disableFocusRipple", "endIcon", "focusVisibleClassName", "fullWidth", "size", "startIcon", "type", "variant"];
const useUtilityClasses$s = ownerState => {
  const {
    color,
    disableElevation,
    fullWidth,
    size,
    variant,
    classes
  } = ownerState;
  const slots = {
    root: ['root', variant, `${variant}${capitalize(color)}`, `size${capitalize(size)}`, `${variant}Size${capitalize(size)}`, color === 'inherit' && 'colorInherit', disableElevation && 'disableElevation', fullWidth && 'fullWidth'],
    label: ['label'],
    startIcon: ['startIcon', `iconSize${capitalize(size)}`],
    endIcon: ['endIcon', `iconSize${capitalize(size)}`]
  };
  const composedClasses = composeClasses(slots, getButtonUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};
const commonIconStyles = ownerState => _extends$1({}, ownerState.size === 'small' && {
  '& > *:nth-of-type(1)': {
    fontSize: 18
  }
}, ownerState.size === 'medium' && {
  '& > *:nth-of-type(1)': {
    fontSize: 20
  }
}, ownerState.size === 'large' && {
  '& > *:nth-of-type(1)': {
    fontSize: 22
  }
});
const ButtonRoot = styled$1(ButtonBase$1, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiButton',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[ownerState.variant], styles[`${ownerState.variant}${capitalize(ownerState.color)}`], styles[`size${capitalize(ownerState.size)}`], styles[`${ownerState.variant}Size${capitalize(ownerState.size)}`], ownerState.color === 'inherit' && styles.colorInherit, ownerState.disableElevation && styles.disableElevation, ownerState.fullWidth && styles.fullWidth];
  }
})(({
  theme,
  ownerState
}) => {
  var _theme$palette$getCon, _theme$palette;
  return _extends$1({}, theme.typography.button, {
    minWidth: 64,
    padding: '6px 16px',
    borderRadius: (theme.vars || theme).shape.borderRadius,
    transition: theme.transitions.create(['background-color', 'box-shadow', 'border-color', 'color'], {
      duration: theme.transitions.duration.short
    }),
    '&:hover': _extends$1({
      textDecoration: 'none',
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette.text.primaryChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(theme.palette.text.primary, theme.palette.action.hoverOpacity),
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        backgroundColor: 'transparent'
      }
    }, ownerState.variant === 'text' && ownerState.color !== 'inherit' && {
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette[ownerState.color].mainChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        backgroundColor: 'transparent'
      }
    }, ownerState.variant === 'outlined' && ownerState.color !== 'inherit' && {
      border: `1px solid ${(theme.vars || theme).palette[ownerState.color].main}`,
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette[ownerState.color].mainChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        backgroundColor: 'transparent'
      }
    }, ownerState.variant === 'contained' && {
      backgroundColor: (theme.vars || theme).palette.grey.A100,
      boxShadow: (theme.vars || theme).shadows[4],
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        boxShadow: (theme.vars || theme).shadows[2],
        backgroundColor: (theme.vars || theme).palette.grey[300]
      }
    }, ownerState.variant === 'contained' && ownerState.color !== 'inherit' && {
      backgroundColor: (theme.vars || theme).palette[ownerState.color].dark,
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        backgroundColor: (theme.vars || theme).palette[ownerState.color].main
      }
    }),
    '&:active': _extends$1({}, ownerState.variant === 'contained' && {
      boxShadow: (theme.vars || theme).shadows[8]
    }),
    [`&.${buttonClasses$1.focusVisible}`]: _extends$1({}, ownerState.variant === 'contained' && {
      boxShadow: (theme.vars || theme).shadows[6]
    }),
    [`&.${buttonClasses$1.disabled}`]: _extends$1({
      color: (theme.vars || theme).palette.action.disabled
    }, ownerState.variant === 'outlined' && {
      border: `1px solid ${(theme.vars || theme).palette.action.disabledBackground}`
    }, ownerState.variant === 'contained' && {
      color: (theme.vars || theme).palette.action.disabled,
      boxShadow: (theme.vars || theme).shadows[0],
      backgroundColor: (theme.vars || theme).palette.action.disabledBackground
    })
  }, ownerState.variant === 'text' && {
    padding: '6px 8px'
  }, ownerState.variant === 'text' && ownerState.color !== 'inherit' && {
    color: (theme.vars || theme).palette[ownerState.color].main
  }, ownerState.variant === 'outlined' && {
    padding: '5px 15px',
    border: '1px solid currentColor'
  }, ownerState.variant === 'outlined' && ownerState.color !== 'inherit' && {
    color: (theme.vars || theme).palette[ownerState.color].main,
    border: theme.vars ? `1px solid rgba(${theme.vars.palette[ownerState.color].mainChannel} / 0.5)` : `1px solid ${alpha(theme.palette[ownerState.color].main, 0.5)}`
  }, ownerState.variant === 'contained' && {
    color: theme.vars ?
    // this is safe because grey does not change between default light/dark mode
    theme.vars.palette.text.primary : (_theme$palette$getCon = (_theme$palette = theme.palette).getContrastText) == null ? void 0 : _theme$palette$getCon.call(_theme$palette, theme.palette.grey[300]),
    backgroundColor: (theme.vars || theme).palette.grey[300],
    boxShadow: (theme.vars || theme).shadows[2]
  }, ownerState.variant === 'contained' && ownerState.color !== 'inherit' && {
    color: (theme.vars || theme).palette[ownerState.color].contrastText,
    backgroundColor: (theme.vars || theme).palette[ownerState.color].main
  }, ownerState.color === 'inherit' && {
    color: 'inherit',
    borderColor: 'currentColor'
  }, ownerState.size === 'small' && ownerState.variant === 'text' && {
    padding: '4px 5px',
    fontSize: theme.typography.pxToRem(13)
  }, ownerState.size === 'large' && ownerState.variant === 'text' && {
    padding: '8px 11px',
    fontSize: theme.typography.pxToRem(15)
  }, ownerState.size === 'small' && ownerState.variant === 'outlined' && {
    padding: '3px 9px',
    fontSize: theme.typography.pxToRem(13)
  }, ownerState.size === 'large' && ownerState.variant === 'outlined' && {
    padding: '7px 21px',
    fontSize: theme.typography.pxToRem(15)
  }, ownerState.size === 'small' && ownerState.variant === 'contained' && {
    padding: '4px 10px',
    fontSize: theme.typography.pxToRem(13)
  }, ownerState.size === 'large' && ownerState.variant === 'contained' && {
    padding: '8px 22px',
    fontSize: theme.typography.pxToRem(15)
  }, ownerState.fullWidth && {
    width: '100%'
  });
}, ({
  ownerState
}) => ownerState.disableElevation && {
  boxShadow: 'none',
  '&:hover': {
    boxShadow: 'none'
  },
  [`&.${buttonClasses$1.focusVisible}`]: {
    boxShadow: 'none'
  },
  '&:active': {
    boxShadow: 'none'
  },
  [`&.${buttonClasses$1.disabled}`]: {
    boxShadow: 'none'
  }
});
const ButtonStartIcon = styled$1('span', {
  name: 'MuiButton',
  slot: 'StartIcon',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.startIcon, styles[`iconSize${capitalize(ownerState.size)}`]];
  }
})(({
  ownerState
}) => _extends$1({
  display: 'inherit',
  marginRight: 8,
  marginLeft: -4
}, ownerState.size === 'small' && {
  marginLeft: -2
}, commonIconStyles(ownerState)));
const ButtonEndIcon = styled$1('span', {
  name: 'MuiButton',
  slot: 'EndIcon',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.endIcon, styles[`iconSize${capitalize(ownerState.size)}`]];
  }
})(({
  ownerState
}) => _extends$1({
  display: 'inherit',
  marginRight: -4,
  marginLeft: 8
}, ownerState.size === 'small' && {
  marginRight: -2
}, commonIconStyles(ownerState)));
const Button$1 = /*#__PURE__*/React__namespace.forwardRef(function Button(inProps, ref) {
  // props priority: `inProps` > `contextProps` > `themeDefaultProps`
  const contextProps = React__namespace.useContext(ButtonGroupContext$1);
  const resolvedProps = resolveProps(contextProps, inProps);
  const props = useThemeProps({
    props: resolvedProps,
    name: 'MuiButton'
  });
  const {
      children,
      color = 'primary',
      component = 'button',
      className,
      disabled = false,
      disableElevation = false,
      disableFocusRipple = false,
      endIcon: endIconProp,
      focusVisibleClassName,
      fullWidth = false,
      size = 'medium',
      startIcon: startIconProp,
      type,
      variant = 'text'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$U);
  const ownerState = _extends$1({}, props, {
    color,
    component,
    disabled,
    disableElevation,
    disableFocusRipple,
    fullWidth,
    size,
    type,
    variant
  });
  const classes = useUtilityClasses$s(ownerState);
  const startIcon = startIconProp && /*#__PURE__*/jsxRuntimeExports.jsx(ButtonStartIcon, {
    className: classes.startIcon,
    ownerState: ownerState,
    children: startIconProp
  });
  const endIcon = endIconProp && /*#__PURE__*/jsxRuntimeExports.jsx(ButtonEndIcon, {
    className: classes.endIcon,
    ownerState: ownerState,
    children: endIconProp
  });
  return /*#__PURE__*/jsxRuntimeExports.jsxs(ButtonRoot, _extends$1({
    ownerState: ownerState,
    className: clsx(contextProps.className, classes.root, className),
    component: component,
    disabled: disabled,
    focusRipple: !disableFocusRipple,
    focusVisibleClassName: clsx(classes.focusVisible, focusVisibleClassName),
    ref: ref,
    type: type
  }, other, {
    classes: classes,
    children: [startIcon, children, endIcon]
  }));
});
browser$1.env.NODE_ENV !== "production" ? Button$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'primary'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['inherit', 'primary', 'secondary', 'success', 'error', 'info', 'warning']), propTypesExports.string]),
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, no elevation is used.
   * @default false
   */
  disableElevation: propTypesExports.bool,
  /**
   * If `true`, the  keyboard focus ripple is disabled.
   * @default false
   */
  disableFocusRipple: propTypesExports.bool,
  /**
   * If `true`, the ripple effect is disabled.
   *
   * ⚠️ Without a ripple there is no styling for :focus-visible by default. Be sure
   * to highlight the element by applying separate styles with the `.Mui-focusVisible` class.
   * @default false
   */
  disableRipple: propTypesExports.bool,
  /**
   * Element placed after the children.
   */
  endIcon: propTypesExports.node,
  /**
   * @ignore
   */
  focusVisibleClassName: propTypesExports.string,
  /**
   * If `true`, the button will take up the full width of its container.
   * @default false
   */
  fullWidth: propTypesExports.bool,
  /**
   * The URL to link to when the button is clicked.
   * If defined, an `a` element will be used as the root node.
   */
  href: propTypesExports.string,
  /**
   * The size of the component.
   * `small` is equivalent to the dense button styling.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['small', 'medium', 'large']), propTypesExports.string]),
  /**
   * Element placed before the children.
   */
  startIcon: propTypesExports.node,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * @ignore
   */
  type: propTypesExports.oneOfType([propTypesExports.oneOf(['button', 'reset', 'submit']), propTypesExports.string]),
  /**
   * The variant to use.
   * @default 'text'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['contained', 'outlined', 'text']), propTypesExports.string])
} : void 0;
var Button$2 = Button$1;

var _excluded$T = ["error", "onButtonClick", "ButtonComponent", "buttonLabel"];
function ErrorMessage(_ref) {
  var error = _ref.error,
    onButtonClick = _ref.onButtonClick,
    ButtonComponent = _ref.ButtonComponent,
    _ref$buttonLabel = _ref.buttonLabel,
    buttonLabel = _ref$buttonLabel === void 0 ? "Retry" : _ref$buttonLabel,
    props = _objectWithoutProperties(_ref, _excluded$T);
  if (!error) return null;
  var message = error.message ? error.message : "Oops! Something went wrong...";
  var shouldShowDefaultButton = !ButtonComponent && onButtonClick;
  return /*#__PURE__*/React__namespace.default.createElement(ErrorBox, _extends$2({
    "data-testid": TEST_IDS.ERROR_MESSAGE
  }, props), /*#__PURE__*/React__namespace.default.createElement(StyledErrorIcon, null), /*#__PURE__*/React__namespace.default.createElement(Message, null, message), ButtonComponent && /*#__PURE__*/React__namespace.default.createElement(ButtonComponent, null), shouldShowDefaultButton && /*#__PURE__*/React__namespace.default.createElement(Button$2, {
    color: "secondary",
    variant: "contained",
    onClick: function onClick() {
      return onButtonClick();
    },
    "data-testid": TEST_IDS.ERROR_MESSAGE_DEFAULT_BUTTON
  }, buttonLabel));
}
ErrorMessage.propTypes = {
  error: propTypesExports.object,
  onButtonClick: propTypesExports.func,
  ButtonComponent: propTypesExports.elementType,
  buttonLabel: propTypesExports.string
};
var StyledErrorIcon = styled__default.default(default_1$I)({
  fontSize: "70px"
});
var ErrorBox = styled__default.default(Box$1)({
  display: "flex",
  flexDirection: "column",
  alignItems: "center",
  justifyContent: "center",
  margin: 50
});
var Message = styled__default.default(Typography$1)({
  marginBottom: 15,
  marginTop: 15
});

function getSkeletonUtilityClass(slot) {
  return generateUtilityClass('MuiSkeleton', slot);
}
generateUtilityClasses('MuiSkeleton', ['root', 'text', 'rectangular', 'rounded', 'circular', 'pulse', 'wave', 'withChildren', 'fitContent', 'heightAuto']);

const _excluded$S = ["animation", "className", "component", "height", "style", "variant", "width"];
let _$1 = t => t,
  _t$1,
  _t2$1,
  _t3$1,
  _t4$1;
const useUtilityClasses$r = ownerState => {
  const {
    classes,
    variant,
    animation,
    hasChildren,
    width,
    height
  } = ownerState;
  const slots = {
    root: ['root', variant, animation, hasChildren && 'withChildren', hasChildren && !width && 'fitContent', hasChildren && !height && 'heightAuto']
  };
  return composeClasses(slots, getSkeletonUtilityClass, classes);
};
const pulseKeyframe = react.keyframes(_t$1 || (_t$1 = _$1`
  0% {
    opacity: 1;
  }

  50% {
    opacity: 0.4;
  }

  100% {
    opacity: 1;
  }
`));
const waveKeyframe = react.keyframes(_t2$1 || (_t2$1 = _$1`
  0% {
    transform: translateX(-100%);
  }

  50% {
    /* +0.5s of delay between each loop */
    transform: translateX(100%);
  }

  100% {
    transform: translateX(100%);
  }
`));
const SkeletonRoot = styled$1('span', {
  name: 'MuiSkeleton',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[ownerState.variant], ownerState.animation !== false && styles[ownerState.animation], ownerState.hasChildren && styles.withChildren, ownerState.hasChildren && !ownerState.width && styles.fitContent, ownerState.hasChildren && !ownerState.height && styles.heightAuto];
  }
})(({
  theme,
  ownerState
}) => {
  const radiusUnit = getUnit(theme.shape.borderRadius) || 'px';
  const radiusValue = toUnitless(theme.shape.borderRadius);
  return _extends$1({
    display: 'block',
    // Create a "on paper" color with sufficient contrast retaining the color
    backgroundColor: theme.vars ? theme.vars.palette.Skeleton.bg : alpha(theme.palette.text.primary, theme.palette.mode === 'light' ? 0.11 : 0.13),
    height: '1.2em'
  }, ownerState.variant === 'text' && {
    marginTop: 0,
    marginBottom: 0,
    height: 'auto',
    transformOrigin: '0 55%',
    transform: 'scale(1, 0.60)',
    borderRadius: `${radiusValue}${radiusUnit}/${Math.round(radiusValue / 0.6 * 10) / 10}${radiusUnit}`,
    '&:empty:before': {
      content: '"\\00a0"'
    }
  }, ownerState.variant === 'circular' && {
    borderRadius: '50%'
  }, ownerState.variant === 'rounded' && {
    borderRadius: (theme.vars || theme).shape.borderRadius
  }, ownerState.hasChildren && {
    '& > *': {
      visibility: 'hidden'
    }
  }, ownerState.hasChildren && !ownerState.width && {
    maxWidth: 'fit-content'
  }, ownerState.hasChildren && !ownerState.height && {
    height: 'auto'
  });
}, ({
  ownerState
}) => ownerState.animation === 'pulse' && react.css(_t3$1 || (_t3$1 = _$1`
      animation: ${0} 1.5s ease-in-out 0.5s infinite;
    `), pulseKeyframe), ({
  ownerState,
  theme
}) => ownerState.animation === 'wave' && react.css(_t4$1 || (_t4$1 = _$1`
      position: relative;
      overflow: hidden;

      /* Fix bug in Safari https://bugs.webkit.org/show_bug.cgi?id=68196 */
      -webkit-mask-image: -webkit-radial-gradient(white, black);

      &::after {
        animation: ${0} 1.6s linear 0.5s infinite;
        background: linear-gradient(
          90deg,
          transparent,
          ${0},
          transparent
        );
        content: '';
        position: absolute;
        transform: translateX(-100%); /* Avoid flash during server-side hydration */
        bottom: 0;
        left: 0;
        right: 0;
        top: 0;
      }
    `), waveKeyframe, (theme.vars || theme).palette.action.hover));
const Skeleton$1 = /*#__PURE__*/React__namespace.forwardRef(function Skeleton(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiSkeleton'
  });
  const {
      animation = 'pulse',
      className,
      component = 'span',
      height,
      style,
      variant = 'text',
      width
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$S);
  const ownerState = _extends$1({}, props, {
    animation,
    component,
    variant,
    hasChildren: Boolean(other.children)
  });
  const classes = useUtilityClasses$r(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(SkeletonRoot, _extends$1({
    as: component,
    ref: ref,
    className: clsx(classes.root, className),
    ownerState: ownerState
  }, other, {
    style: _extends$1({
      width,
      height
    }, style)
  }));
});
browser$1.env.NODE_ENV !== "production" ? Skeleton$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The animation.
   * If `false` the animation effect is disabled.
   * @default 'pulse'
   */
  animation: propTypesExports.oneOf(['pulse', 'wave', false]),
  /**
   * Optional children to infer width and height from.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * Height of the skeleton.
   * Useful when you don't want to adapt the skeleton to a text element but for instance a card.
   */
  height: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * @ignore
   */
  style: propTypesExports.object,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The type of content that will be rendered.
   * @default 'text'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['circular', 'rectangular', 'rounded', 'text']), propTypesExports.string]),
  /**
   * Width of the skeleton.
   * Useful when the skeleton is inside an inline element with no width of its own.
   */
  width: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string])
} : void 0;
var SkeletonOG = Skeleton$1;

var _excluded$R = ["isRounded", "testId", "style"];
function Skeleton(_ref) {
  var isRounded = _ref.isRounded,
    _ref$testId = _ref.testId,
    testId = _ref$testId === void 0 ? TEST_IDS.SKELETON : _ref$testId,
    _ref$style = _ref.style,
    style = _ref$style === void 0 ? {} : _ref$style,
    props = _objectWithoutProperties(_ref, _excluded$R);
  var theme = useTheme$1();
  return /*#__PURE__*/React__namespace.default.createElement(SkeletonOG, _extends$2({}, props, {
    "data-testid": testId,
    sx: getOverrides({
      theme: theme,
      isRounded: isRounded,
      style: style
    })
  }));
}
// Had to overwrite skeletons original styles using the sx prop
function getOverrides(_ref2) {
  var theme = _ref2.theme,
    isRounded = _ref2.isRounded,
    style = _ref2.style;
  return _objectSpread2({
    borderRadius: isRounded ? theme.borderRadius.sm : 0
  }, style);
}
Skeleton.propTypes = {
  testId: propTypesExports.string,
  isRounded: propTypesExports.bool,
  style: propTypesExports.object
};

var DEFAULT_STYLE$1 = {
  maxWidth: "100%",
  maxHeight: 200,
  borderRadius: 2
};
var DEFAULT_SKELETON_PROPS = {
  width: 200,
  height: DEFAULT_STYLE$1.maxHeight
};
function AttachmentPreview(_ref) {
  var className = _ref.className,
    _ref$style = _ref.style,
    style = _ref$style === void 0 ? DEFAULT_STYLE$1 : _ref$style,
    _ref$skeletonProps = _ref.skeletonProps,
    skeletonProps = _ref$skeletonProps === void 0 ? DEFAULT_SKELETON_PROPS : _ref$skeletonProps,
    attachmentId = _ref.attachmentId,
    url = _ref.url,
    validationMessage = _ref.validationMessage,
    onLoad = _ref.onLoad,
    _ref$containerStyle = _ref.containerStyle,
    containerStyle = _ref$containerStyle === void 0 ? {} : _ref$containerStyle,
    localUrl = _ref.localUrl,
    PreviewIcon = _ref.PreviewIcon,
    onClick = _ref.onClick,
    iconProps = _ref.iconProps;
  var theme = useTheme$1();
  var _useUtils = useUtils(),
    useAttachmentImage = _useUtils.useAttachmentImage;
  var _useAttachmentImage = useAttachmentImage({
      attachmentId: attachmentId,
      url: url,
      onLoad: onLoad
    }),
    remoteUrl = _useAttachmentImage.remoteUrl,
    isLoading = _useAttachmentImage.isLoading,
    didFailLoadingImage = _useAttachmentImage.didFailLoadingImage,
    refetch = _useAttachmentImage.refetch;
  if (didFailLoadingImage) {
    var loadError = {
      message: validationMessage
    };
    return /*#__PURE__*/React__namespace.default.createElement(ErrorMessage, {
      error: loadError,
      onButtonClick: refetch
    });
  }
  if (isLoading) {
    return /*#__PURE__*/React__namespace.default.createElement(Container$w, {
      containerStyle: containerStyle
    }, /*#__PURE__*/React__namespace.default.createElement(Skeleton, skeletonProps));
  }
  if (!remoteUrl && !localUrl) return null;
  return /*#__PURE__*/React__namespace.default.createElement(Container$w, {
    containerStyle: containerStyle,
    onClick: onClick
  }, PreviewIcon && /*#__PURE__*/React__namespace.default.createElement(PreviewIcon, _extends$2({
    style: getDefaultIconStyle(theme)
  }, iconProps)), /*#__PURE__*/React__namespace.default.createElement(Box$1, {
    "data-testid": TEST_IDS.ATTACHMENT_PREVIEW,
    className: className,
    component: "img",
    sx: style,
    alt: "attachment_".concat(attachmentId),
    src: localUrl || remoteUrl
  }));
}
var Container$w = styled__default.default(Box$1, {
  shouldForwardProp: shouldForwardProp$3
})(function (_ref2) {
  var containerStyle = _ref2.containerStyle;
  return _objectSpread2({
    width: "fit-content",
    position: "relative",
    height: "100%",
    display: "flex"
  }, containerStyle);
});
function shouldForwardProp$3(prop) {
  return prop !== "containerStyle";
}
function getDefaultIconStyle(theme) {
  return {
    position: "absolute",
    fontSize: 25,
    padding: 5,
    width: 30,
    height: 30,
    right: 10,
    top: 10,
    borderRadius: "50%",
    color: theme.palette.colors.icon.neutral,
    backgroundColor: "".concat(theme.palette.colors.icon.neutralContrast, "50")
  };
}
AttachmentPreview.propTypes = {
  className: propTypesExports.string,
  style: propTypesExports.object,
  skeletonProps: propTypesExports.object,
  attachmentId: propTypesExports.string,
  url: propTypesExports.string,
  validationMessage: propTypesExports.string,
  PreviewIcon: propTypesExports.elementType,
  onLoad: propTypesExports.func,
  containerStyle: propTypesExports.object,
  localUrl: propTypesExports.string,
  iconProps: propTypesExports.object,
  onClick: propTypesExports.func
};

function convertMarkdownToEditorState(text) {
  if (!text) return null;
  var contentState = draftJsImportMarkdown.stateFromMarkdown(text);
  return draftJs.EditorState.createWithContent(contentState);
}
function convertEditorStateToMarkDown(editorState) {
  return draftJsExportMarkdown.stateToMarkdown(editorState.getCurrentContent());
}
function cleanMarkdownString(string) {
  var _string$replace;
  return string === null || string === void 0 ? void 0 : (_string$replace = string.replace(/\n|\*|__|~~/g, "")) === null || _string$replace === void 0 ? void 0 : _string$replace.replace(/&nbsp;/g, " ");
}
function getLocalUrlOrAttachmentId(file) {
  if (file instanceof File) return {
    localUrl: URL.createObjectURL(file)
  };
  if (!libCommon.isString(file)) return {};

  // checks if the file is a local url
  if (file.startsWith("blob:")) return {
    localUrl: file
  };
  return {
    attachmentId: file
  };
}

var DEFAULT_CONTAINER_STYLE = {
  marginBottom: "1rem"
};
function ImageInputPreview(_ref) {
  var image = _ref.image,
    DescriptionComponent = _ref.DescriptionComponent,
    className = _ref.className,
    _ref$style = _ref.style,
    style = _ref$style === void 0 ? DEFAULT_CONTAINER_STYLE : _ref$style;
  var _getLocalUrlOrAttachm = getLocalUrlOrAttachmentId(image),
    attachmentId = _getLocalUrlOrAttachm.attachmentId,
    localUrl = _getLocalUrlOrAttachm.localUrl;
  return /*#__PURE__*/React__namespace.default.createElement(UploadInputContainer, {
    variant: "none",
    className: className,
    style: style,
    "data-testid": TEST_IDS.IMAGE_INPUT_PREVIEW
  }, attachmentId || localUrl ? /*#__PURE__*/React__namespace.default.createElement(AttachmentPreview, {
    attachmentId: attachmentId,
    localUrl: localUrl,
    PreviewIcon: default_1$J
  }) : /*#__PURE__*/React__namespace.default.createElement(DescriptionComponent, null));
}
ImageInputPreview.propTypes = {
  image: propTypesExports.string,
  DescriptionComponent: propTypesExports.elementType,
  className: propTypesExports.string,
  style: propTypesExports.object
};
var UploadInputContainer = styled__default.default(material.Card)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    position: "relative",
    display: "flex",
    flexDirection: "column",
    justifyContent: "center",
    height: "7rem",
    backgroundColor: theme.palette.background["default"],
    border: "none",
    borderRadius: theme.borderRadius.sm
  };
});

var Upload = {};

var _interopRequireDefault$H = interopRequireDefaultExports;
Object.defineProperty(Upload, "__esModule", {
  value: true
});
var default_1$H = Upload.default = void 0;
var _createSvgIcon$H = _interopRequireDefault$H(requireCreateSvgIcon());
var _jsxRuntime$H = requireJsxRuntime();
var _default$H = (0, _createSvgIcon$H.default)( /*#__PURE__*/(0, _jsxRuntime$H.jsx)("path", {
  d: "M5 20h14v-2H5v2zm0-10h4v6h6v-6h4l-7-7-7 7z"
}), 'Upload');
default_1$H = Upload.default = _default$H;

function UploadFilePreviewDescription(_ref) {
  var description = _ref.description;
  return /*#__PURE__*/React__namespace.default.createElement(DescriptionContainer$1, null, /*#__PURE__*/React__namespace.default.createElement(AddIcon$1, null), /*#__PURE__*/React__namespace.default.createElement(TextDescription$1, null, description));
}
UploadFilePreviewDescription.propTypes = {
  description: propTypesExports.string
};
var AddIcon$1 = styled__default.default(default_1$H)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    fontSize: "24px",
    color: theme.palette.primary.main
  };
});
var TextDescription$1 = styled__default.default(material.Typography)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    alignSelf: "center",
    color: theme.palette.primary.main,
    fontSize: "16px"
  };
});
var DescriptionContainer$1 = styled__default.default(material.Box)(function () {
  return {
    display: "flex",
    flexDirection: "row",
    gap: "1rem",
    marginLeft: "2rem"
  };
});

function UploadImagePreviewDescription() {
  return /*#__PURE__*/React__namespace.default.createElement(UploadFilePreviewDescription, {
    description: "Upload Image"
  });
}

function UploadImagePreview(_ref) {
  var value = _ref.value,
    id = _ref.id,
    className = _ref.className;
  return /*#__PURE__*/React__namespace.default.createElement("label", {
    htmlFor: id
  }, /*#__PURE__*/React__namespace.default.createElement(ImageInputPreview, {
    className: className,
    image: value,
    DescriptionComponent: UploadImagePreviewDescription
  }));
}
UploadImagePreview.propTypes = {
  value: propTypesExports.string,
  className: propTypesExports.string,
  id: propTypesExports.string
};

function ImageUploadInput(_ref) {
  var id = _ref.id,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    onChange = _ref.onChange,
    title = _ref.title,
    ContainerComponent = _ref.ContainerComponent,
    _ref$EmptyComponent = _ref.EmptyComponent,
    EmptyComponent = _ref$EmptyComponent === void 0 ? UploadImagePreview : _ref$EmptyComponent;
  return /*#__PURE__*/React__namespace.default.createElement(FileUploadInput, {
    id: id,
    title: title,
    value: value,
    validationMessage: validationMessage,
    onChange: onChange,
    accept: "image/*",
    ContainerComponent: ContainerComponent,
    EmptyComponent: EmptyComponent,
    testId: TEST_IDS.IMAGE_UPLOAD_INPUT
  });
}
ImageUploadInput.propTypes = {
  id: propTypesExports.string.isRequired,
  value: propTypesExports.any,
  onChange: propTypesExports.func.isRequired,
  validationMessage: propTypesExports.string,
  title: propTypesExports.string,
  ContainerComponent: propTypesExports.elementType,
  EmptyComponent: propTypesExports.elementType
};

var e=[],t=[];function n(n,r){if(n&&"undefined"!=typeof document){var a,s=!0===r.prepend?"prepend":"append",d=!0===r.singleTag,i="string"==typeof r.container?document.querySelector(r.container):document.getElementsByTagName("head")[0];if(d){var u=e.indexOf(i);-1===u&&(u=e.push(i)-1,t[u]={}),a=t[u]&&t[u][s]?t[u][s]:t[u][s]=c();}else a=c();65279===n.charCodeAt(0)&&(n=n.substring(1)),a.styleSheet?a.styleSheet.cssText+=n:a.appendChild(document.createTextNode(n));}function c(){var e=document.createElement("style");if(e.setAttribute("type","text/css"),r.attributes)for(var t=Object.keys(r.attributes),n=0;n<t.length;n++)e.setAttribute(t[n],r.attributes[t[n]]);var a="prepend"===s?"afterbegin":"beforeend";return i.insertAdjacentElement(a,e),e}}

var css = ".rdw-option-wrapper {\n  border: 1px solid #F1F1F1;\n  padding: 5px;\n  min-width: 25px;\n  height: 20px;\n  border-radius: 2px;\n  margin: 0 4px;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  cursor: pointer;\n  background: white;\n  text-transform: capitalize;\n}\n.rdw-option-wrapper:hover {\n  box-shadow: 1px 1px 0px #BFBDBD;\n}\n.rdw-option-wrapper:active {\n  box-shadow: 1px 1px 0px #BFBDBD inset;\n}\n.rdw-option-active {\n  box-shadow: 1px 1px 0px #BFBDBD inset;\n}\n.rdw-option-disabled {\n  opacity: 0.3;\n  cursor: default;\n}\n\n.rdw-dropdown-wrapper {\n  height: 30px;\n  background: white;\n  cursor: pointer;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  margin: 0 3px;\n  text-transform: capitalize;\n  background: white;\n}\n.rdw-dropdown-wrapper:focus {\n  outline: none;\n}\n.rdw-dropdown-wrapper:hover {\n  box-shadow: 1px 1px 0px #BFBDBD;\n  background-color: #FFFFFF;\n}\n.rdw-dropdown-wrapper:active {\n  box-shadow: 1px 1px 0px #BFBDBD inset;\n}\n.rdw-dropdown-carettoopen {\n  height: 0px;\n  width: 0px;\n  position: absolute;\n  top: 35%;\n  right: 10%;\n  border-top: 6px solid black;\n  border-left: 5px solid transparent;\n  border-right: 5px solid transparent;\n}\n.rdw-dropdown-carettoclose {\n  height: 0px;\n  width: 0px;\n  position: absolute;\n  top: 35%;\n  right: 10%;\n  border-bottom: 6px solid black;\n  border-left: 5px solid transparent;\n  border-right: 5px solid transparent;\n}\n.rdw-dropdown-selectedtext {\n  display: flex;\n  position: relative;\n  height: 100%;\n  align-items: center;\n  padding: 0 5px;\n}\n.rdw-dropdown-optionwrapper {\n  z-index: 100;\n  position: relative;\n  border: 1px solid #F1F1F1;\n  width: 98%;\n  background: white;\n  border-radius: 2px;\n  margin: 0;\n  padding: 0;\n  max-height: 250px;\n  overflow-y: scroll;\n}\n.rdw-dropdown-optionwrapper:hover {\n  box-shadow: 1px 1px 0px #BFBDBD;\n  background-color: #FFFFFF;\n}\n\n.rdw-dropdownoption-default {\n  min-height: 25px;\n  display: flex;\n  align-items: center;\n  padding: 0 5px;\n}\n.rdw-dropdownoption-highlighted {\n  background: #F1F1F1;\n}\n.rdw-dropdownoption-active {\n  background: #f5f5f5;\n}\n.rdw-dropdownoption-disabled {\n  opacity: 0.3;\n  cursor: default;\n}\n\n.rdw-inline-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  flex-wrap: wrap\n}\n.rdw-inline-dropdown {\n  width: 50px;\n}\n.rdw-inline-dropdownoption {\n  height: 40px;\n  display: flex;\n  justify-content: center;\n}\n\n.rdw-block-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  flex-wrap: wrap\n}\n.rdw-block-dropdown {\n  width: 110px;\n}\n\n.rdw-fontsize-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  flex-wrap: wrap\n}\n.rdw-fontsize-dropdown {\n  min-width: 40px;\n}\n.rdw-fontsize-option {\n  display: flex;\n  justify-content: center;\n}\n\n.rdw-fontfamily-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  flex-wrap: wrap\n}\n.rdw-fontfamily-dropdown {\n  width: 115px;\n}\n.rdw-fontfamily-placeholder {\n  white-space: nowrap;\n  max-width: 90px;\n  overflow: hidden;\n  text-overflow: ellipsis;\n}\n.rdw-fontfamily-optionwrapper {\n  width: 140px;\n}\n\n.rdw-list-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  flex-wrap: wrap\n}\n.rdw-list-dropdown {\n  width: 50px;\n  z-index: 90;\n}\n.rdw-list-dropdownOption {\n  height: 40px;\n  display: flex;\n  justify-content: center;\n}\n\n.rdw-text-align-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  flex-wrap: wrap\n}\n.rdw-text-align-dropdown {\n  width: 50px;\n  z-index: 90;\n}\n.rdw-text-align-dropdownOption {\n  height: 40px;\n  display: flex;\n  justify-content: center;\n}\n.rdw-right-aligned-block {\n  text-align: right;\n}\n.rdw-left-aligned-block {\n  text-align: left !important;\n}\n.rdw-center-aligned-block {\n  text-align: center !important;\n}\n.rdw-justify-aligned-block {\n  text-align: justify !important;\n}\n.rdw-right-aligned-block > div {\n  display: inline-block;\n}\n.rdw-left-aligned-block > div {\n  display: inline-block;\n}\n.rdw-center-aligned-block > div {\n  display: inline-block;\n}\n.rdw-justify-aligned-block > div {\n  display: inline-block;\n}\n\n.rdw-colorpicker-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  position: relative;\n  flex-wrap: wrap\n}\n.rdw-colorpicker-modal {\n  position: absolute;\n  top: 35px;\n  left: 5px;\n  display: flex;\n  flex-direction: column;\n  width: 175px;\n  height: 175px;\n  border: 1px solid #F1F1F1;\n  padding: 15px;\n  border-radius: 2px;\n  z-index: 100;\n  background: white;\n  box-shadow: 3px 3px 5px #BFBDBD;\n}\n.rdw-colorpicker-modal-header {\n  display: flex;\n  padding-bottom: 5px;\n}\n.rdw-colorpicker-modal-style-label {\n  font-size: 15px;\n  width: 50%;\n  text-align: center;\n  cursor: pointer;\n  padding: 0 10px 5px;\n}\n.rdw-colorpicker-modal-style-label-active {\n  border-bottom: 2px solid #0a66b7;\n}\n.rdw-colorpicker-modal-options {\n  margin: 5px auto;\n  display: flex;\n  width: 100%;\n  height: 100%;\n  flex-wrap: wrap;\n  overflow: scroll;\n}\n.rdw-colorpicker-cube {\n  width: 22px;\n  height: 22px;\n  border: 1px solid #F1F1F1;\n}\n.rdw-colorpicker-option {\n  margin: 3px;\n  padding: 0;\n  min-height: 20px;\n  border: none;\n  width: 22px;\n  height: 22px;\n  min-width: 22px;\n  box-shadow: 1px 2px 1px #BFBDBD inset;\n}\n.rdw-colorpicker-option:hover {\n  box-shadow: 1px 2px 1px #BFBDBD;\n}\n.rdw-colorpicker-option:active {\n  box-shadow: -1px -2px 1px #BFBDBD;\n}\n.rdw-colorpicker-option-active {\n  box-shadow: 0px 0px 2px 2px #BFBDBD;\n}\n\n.rdw-link-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  position: relative;\n  flex-wrap: wrap\n}\n.rdw-link-dropdown {\n  width: 50px;\n}\n.rdw-link-dropdownOption {\n  height: 40px;\n  display: flex;\n  justify-content: center;\n}\n.rdw-link-dropdownPlaceholder {\n  margin-left: 8px;\n}\n.rdw-link-modal {\n  position: absolute;\n  top: 35px;\n  left: 5px;\n  display: flex;\n  flex-direction: column;\n  width: 235px;\n  height: 205px;\n  border: 1px solid #F1F1F1;\n  padding: 15px;\n  border-radius: 2px;\n  z-index: 100;\n  background: white;\n  box-shadow: 3px 3px 5px #BFBDBD;\n}\n.rdw-link-modal-label {\n  font-size: 15px;\n}\n.rdw-link-modal-input {\n  margin-top: 5px;\n  border-radius: 2px;\n  border: 1px solid #F1F1F1;\n  height: 25px;\n  margin-bottom: 15px;\n  padding: 0 5px;\n}\n.rdw-link-modal-input:focus {\n  outline: none;\n}\n.rdw-link-modal-buttonsection {\n  margin: 0 auto;\n}\n.rdw-link-modal-target-option {\n  margin-bottom: 20px;\n}\n.rdw-link-modal-target-option > span {\n  margin-left: 5px;\n}\n.rdw-link-modal-btn {\n  margin-left: 10px;\n  width: 75px;\n  height: 30px;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  cursor: pointer;\n  background: white;\n  text-transform: capitalize;\n}\n.rdw-link-modal-btn:hover {\n  box-shadow: 1px 1px 0px #BFBDBD;\n}\n.rdw-link-modal-btn:active {\n  box-shadow: 1px 1px 0px #BFBDBD inset;\n}\n.rdw-link-modal-btn:focus {\n  outline: none !important;\n}\n.rdw-link-modal-btn:disabled {\n  background: #ece9e9;\n}\n.rdw-link-dropdownoption {\n  height: 40px;\n  display: flex;\n  justify-content: center;\n}\n.rdw-history-dropdown {\n  width: 50px;\n}\n\n.rdw-embedded-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  position: relative;\n  flex-wrap: wrap\n}\n.rdw-embedded-modal {\n  position: absolute;\n  top: 35px;\n  left: 5px;\n  display: flex;\n  flex-direction: column;\n  width: 235px;\n  height: 180px;\n  border: 1px solid #F1F1F1;\n  padding: 15px;\n  border-radius: 2px;\n  z-index: 100;\n  background: white;\n  justify-content: space-between;\n  box-shadow: 3px 3px 5px #BFBDBD;\n}\n.rdw-embedded-modal-header {\n  font-size: 15px;\n  display: flex;\n}\n.rdw-embedded-modal-header-option {\n  width: 50%;\n  cursor: pointer;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  flex-direction: column;\n}\n.rdw-embedded-modal-header-label {\n  width: 95px;\n  border: 1px solid #f1f1f1;\n  margin-top: 5px;\n  background: #6EB8D4;\n  border-bottom: 2px solid #0a66b7;\n}\n.rdw-embedded-modal-link-section {\n  display: flex;\n  flex-direction: column;\n}\n.rdw-embedded-modal-link-input {\n  width: 88%;\n  height: 35px;\n  margin: 10px 0;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  font-size: 15px;\n  padding: 0 5px;\n}\n.rdw-embedded-modal-link-input-wrapper {\n  display: flex;\n  align-items: center;\n}\n.rdw-embedded-modal-link-input:focus {\n  outline: none;\n}\n.rdw-embedded-modal-btn-section {\n  display: flex;\n  justify-content: center;\n}\n.rdw-embedded-modal-btn {\n  margin: 0 3px;\n  width: 75px;\n  height: 30px;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  cursor: pointer;\n  background: white;\n  text-transform: capitalize;\n}\n.rdw-embedded-modal-btn:hover {\n  box-shadow: 1px 1px 0px #BFBDBD;\n}\n.rdw-embedded-modal-btn:active {\n  box-shadow: 1px 1px 0px #BFBDBD inset;\n}\n.rdw-embedded-modal-btn:focus {\n  outline: none !important;\n}\n.rdw-embedded-modal-btn:disabled {\n  background: #ece9e9;\n}\n.rdw-embedded-modal-size {\n  align-items: center;\n  display: flex;\n  margin: 8px 0;\n  justify-content: space-between;\n}\n.rdw-embedded-modal-size-input {\n  width: 80%;\n  height: 20px;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  font-size: 12px;\n}\n.rdw-embedded-modal-size-input:focus {\n  outline: none;\n}\n\n.rdw-emoji-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  position: relative;\n  flex-wrap: wrap\n}\n.rdw-emoji-modal {\n  overflow: auto;\n  position: absolute;\n  top: 35px;\n  left: 5px;\n  display: flex;\n  flex-wrap: wrap;\n  width: 235px;\n  height: 180px;\n  border: 1px solid #F1F1F1;\n  padding: 15px;\n  border-radius: 2px;\n  z-index: 100;\n  background: white;\n  box-shadow: 3px 3px 5px #BFBDBD;\n}\n.rdw-emoji-icon {\n  margin: 2.5px;\n  height: 24px;\n  width: 24px;\n  cursor: pointer;\n  font-size: 22px;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n}\n\n.rdw-spinner {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  height: 100%;\n  width: 100%;\n}\n.rdw-spinner > div {\n  width: 12px;\n  height: 12px;\n  background-color: #333;\n\n  border-radius: 100%;\n  display: inline-block;\n  -webkit-animation: sk-bouncedelay 1.4s infinite ease-in-out both;\n  animation: sk-bouncedelay 1.4s infinite ease-in-out both;\n}\n.rdw-spinner .rdw-bounce1 {\n  -webkit-animation-delay: -0.32s;\n  animation-delay: -0.32s;\n}\n.rdw-spinner .rdw-bounce2 {\n  -webkit-animation-delay: -0.16s;\n  animation-delay: -0.16s;\n}\n@-webkit-keyframes sk-bouncedelay {\n  0%, 80%, 100% { -webkit-transform: scale(0) }\n  40% { -webkit-transform: scale(1.0) }\n}\n@keyframes sk-bouncedelay {\n  0%, 80%, 100% {\n    -webkit-transform: scale(0);\n    transform: scale(0);\n  } 40% {\n    -webkit-transform: scale(1.0);\n    transform: scale(1.0);\n  }\n}\n\n.rdw-image-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  position: relative;\n  flex-wrap: wrap\n}\n.rdw-image-modal {\n  position: absolute;\n  top: 35px;\n  left: 5px;\n  display: flex;\n  flex-direction: column;\n  width: 235px;\n  border: 1px solid #F1F1F1;\n  padding: 15px;\n  border-radius: 2px;\n  z-index: 100;\n  background: white;\n  box-shadow: 3px 3px 5px #BFBDBD;\n}\n.rdw-image-modal-header {\n  font-size: 15px;\n  margin: 10px 0;\n  display: flex;\n}\n.rdw-image-modal-header-option {\n  width: 50%;\n  cursor: pointer;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  flex-direction: column;\n}\n.rdw-image-modal-header-label {\n  width: 80px;\n  background: #f1f1f1;\n  border: 1px solid #f1f1f1;\n  margin-top: 5px;\n}\n.rdw-image-modal-header-label-highlighted {\n  background: #6EB8D4;\n  border-bottom: 2px solid #0a66b7;\n}\n.rdw-image-modal-upload-option {\n  width: 100%;\n  color: gray;\n  cursor: pointer;\n  display: flex;\n  border: none;\n  font-size: 15px;\n  align-items: center;\n  justify-content: center;\n  background-color: #f1f1f1;\n  outline: 2px dashed gray;\n  outline-offset: -10px;\n  margin: 10px 0;\n  padding: 9px 0;\n}\n.rdw-image-modal-upload-option-highlighted {\n  outline: 2px dashed #0a66b7;\n}\n.rdw-image-modal-upload-option-label {\n  cursor: pointer;\n  height: 100%;\n  width: 100%;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  padding: 15px;\n}\n.rdw-image-modal-upload-option-label span{\n  padding: 0 20px;\n}\n.rdw-image-modal-upload-option-image-preview {\n  max-width: 100%;\n  max-height: 200px;\n}\n.rdw-image-modal-upload-option-input {\n\twidth: 0.1px;\n\theight: 0.1px;\n\topacity: 0;\n\toverflow: hidden;\n\tposition: absolute;\n\tz-index: -1;\n}\n.rdw-image-modal-url-section {\n  display: flex;\n  align-items: center;\n}\n.rdw-image-modal-url-input {\n  width: 90%;\n  height: 35px;\n  margin: 15px 0 12px;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  font-size: 15px;\n  padding: 0 5px;\n}\n.rdw-image-modal-btn-section {\n  margin: 10px auto 0;\n}\n.rdw-image-modal-url-input:focus {\n  outline: none;\n}\n.rdw-image-modal-btn {\n  margin: 0 5px;\n  width: 75px;\n  height: 30px;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  cursor: pointer;\n  background: white;\n  text-transform: capitalize;\n}\n.rdw-image-modal-btn:hover {\n  box-shadow: 1px 1px 0px #BFBDBD;\n}\n.rdw-image-modal-btn:active {\n  box-shadow: 1px 1px 0px #BFBDBD inset;\n}\n.rdw-image-modal-btn:focus {\n  outline: none !important;\n}\n.rdw-image-modal-btn:disabled {\n  background: #ece9e9;\n}\n.rdw-image-modal-spinner {\n  position: absolute;\n  top: -3px;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  opacity: 0.5;\n}\n.rdw-image-modal-alt-input {\n  width: 70%;\n  height: 20px;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  font-size: 12px;\n  margin-left: 5px;\n}\n.rdw-image-modal-alt-input:focus {\n  outline: none;\n}\n.rdw-image-modal-alt-lbl {\n  font-size: 12px;\n}\n.rdw-image-modal-size {\n  align-items: center;\n  display: flex;\n  margin: 8px 0;\n  justify-content: space-between;\n}\n.rdw-image-modal-size-input {\n  width: 40%;\n  height: 20px;\n  border: 1px solid #F1F1F1;\n  border-radius: 2px;\n  font-size: 12px;\n}\n.rdw-image-modal-size-input:focus {\n  outline: none;\n}\n.rdw-image-mandatory-sign {\n  color: red;\n  margin-left: 3px;\n  margin-right: 3px;\n}\n\n.rdw-remove-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  position: relative;\n  flex-wrap: wrap\n}\n\n.rdw-history-wrapper {\n  display: flex;\n  align-items: center;\n  margin-bottom: 6px;\n  flex-wrap: wrap\n}\n.rdw-history-dropdownoption {\n  height: 40px;\n  display: flex;\n  justify-content: center;\n}\n.rdw-history-dropdown {\n  width: 50px;\n}\n\n.rdw-link-decorator-wrapper {\n  position: relative;\n}\n.rdw-link-decorator-icon {\n  position: absolute;\n  left: 40%;\n  top: 0;\n  cursor: pointer;\n  background-color: white;\n}\n\n.rdw-mention-link {\n  text-decoration: none;\n  color: #1236ff;\n  background-color: #f0fbff;\n  padding: 1px 2px;\n  border-radius: 2px;\n}\n\n.rdw-suggestion-wrapper {\n  position: relative;\n}\n.rdw-suggestion-dropdown {\n  position: absolute;\n  display: flex;\n  flex-direction: column;\n  border: 1px solid #F1F1F1;\n  min-width: 100px;\n  max-height: 150px;\n  overflow: auto;\n  background: white;\n  z-index: 100;\n}\n.rdw-suggestion-option {\n  padding: 7px 5px;\n  border-bottom: 1px solid #f1f1f1;\n}\n.rdw-suggestion-option-active {\n  background-color: #F1F1F1;\n}\n\n.rdw-hashtag-link {\n  text-decoration: none;\n  color: #1236ff;\n  background-color: #f0fbff;\n  padding: 1px 2px;\n  border-radius: 2px;\n}\n\n.rdw-image-alignment-options-popup {\n  position: absolute;\n  background: white;\n  display: flex;\n  padding: 5px 2px;\n  border-radius: 2px;\n  border: 1px solid #F1F1F1;\n  width: 105px;\n  cursor: pointer;\n  z-index: 100;\n}\n.rdw-alignment-option-left {\n  justify-content: flex-start;\n}\n.rdw-image-alignment-option {\n  height: 15px;\n  width: 15px;\n  min-width: 15px;\n}\n.rdw-image-alignment {\n  position: relative;\n}\n.rdw-image-imagewrapper {\n  position: relative;\n}\n.rdw-image-center {\n  display: flex;\n  justify-content: center;\n}\n.rdw-image-left {\n  display: flex;\n}\n.rdw-image-right {\n  display: flex;\n  justify-content: flex-end;\n}\n.rdw-image-alignment-options-popup-right {\n  right: 0;\n}\n\n.rdw-editor-main {\n  height: 100%;\n  overflow: auto;\n  box-sizing: border-box;\n}\n.rdw-editor-toolbar {\n  padding: 6px 5px 0;\n  border-radius: 2px;\n  border: 1px solid #F1F1F1;\n  display: flex;\n  justify-content: flex-start;\n  background: white;\n  flex-wrap: wrap;\n  font-size: 15px;\n  margin-bottom: 5px;\n  user-select: none;\n}\n.public-DraftStyleDefault-block {\n  margin: 1em 0;\n}\n.rdw-editor-wrapper:focus {\n  outline: none;\n}\n.rdw-editor-wrapper {\n  box-sizing: content-box;\n}\n.rdw-editor-main blockquote {\n  border-left: 5px solid #f1f1f1;\n  padding-left: 5px;\n}\n.rdw-editor-main pre {\n  background: #f1f1f1;\n  border-radius: 3px;\n  padding: 1px 10px;\n}\n/**\n * Draft v0.9.1\n *\n * Copyright (c) 2013-present, Facebook, Inc.\n * All rights reserved.\n *\n * This source code is licensed under the BSD-style license found in the\n * LICENSE file in the root directory of this source tree. An additional grant\n * of patent rights can be found in the PATENTS file in the same directory.\n */\n.DraftEditor-editorContainer,.DraftEditor-root,.public-DraftEditor-content{height:inherit;text-align:initial}.public-DraftEditor-content[contenteditable=true]{-webkit-user-modify:read-write-plaintext-only}.DraftEditor-root{position:relative}.DraftEditor-editorContainer{background-color:rgba(255,255,255,0);border-left:.1px solid transparent;position:relative;z-index:1}.public-DraftEditor-block{position:relative}.DraftEditor-alignLeft .public-DraftStyleDefault-block{text-align:left}.DraftEditor-alignLeft .public-DraftEditorPlaceholder-root{left:0;text-align:left}.DraftEditor-alignCenter .public-DraftStyleDefault-block{text-align:center}.DraftEditor-alignCenter .public-DraftEditorPlaceholder-root{margin:0 auto;text-align:center;width:100%}.DraftEditor-alignRight .public-DraftStyleDefault-block{text-align:right}.DraftEditor-alignRight .public-DraftEditorPlaceholder-root{right:0;text-align:right}.public-DraftEditorPlaceholder-root{color:#9197a3;position:absolute;z-index:0}.public-DraftEditorPlaceholder-hasFocus{color:#bdc1c9}.DraftEditorPlaceholder-hidden{display:none}.public-DraftStyleDefault-block{position:relative;white-space:pre-wrap}.public-DraftStyleDefault-ltr{direction:ltr;text-align:left}.public-DraftStyleDefault-rtl{direction:rtl;text-align:right}.public-DraftStyleDefault-listLTR{direction:ltr}.public-DraftStyleDefault-listRTL{direction:rtl}.public-DraftStyleDefault-ol,.public-DraftStyleDefault-ul{margin:16px 0;padding:0}.public-DraftStyleDefault-depth0.public-DraftStyleDefault-listLTR{margin-left:1.5em}.public-DraftStyleDefault-depth0.public-DraftStyleDefault-listRTL{margin-right:1.5em}.public-DraftStyleDefault-depth1.public-DraftStyleDefault-listLTR{margin-left:3em}.public-DraftStyleDefault-depth1.public-DraftStyleDefault-listRTL{margin-right:3em}.public-DraftStyleDefault-depth2.public-DraftStyleDefault-listLTR{margin-left:4.5em}.public-DraftStyleDefault-depth2.public-DraftStyleDefault-listRTL{margin-right:4.5em}.public-DraftStyleDefault-depth3.public-DraftStyleDefault-listLTR{margin-left:6em}.public-DraftStyleDefault-depth3.public-DraftStyleDefault-listRTL{margin-right:6em}.public-DraftStyleDefault-depth4.public-DraftStyleDefault-listLTR{margin-left:7.5em}.public-DraftStyleDefault-depth4.public-DraftStyleDefault-listRTL{margin-right:7.5em}.public-DraftStyleDefault-unorderedListItem{list-style-type:square;position:relative}.public-DraftStyleDefault-unorderedListItem.public-DraftStyleDefault-depth0{list-style-type:disc}.public-DraftStyleDefault-unorderedListItem.public-DraftStyleDefault-depth1{list-style-type:circle}.public-DraftStyleDefault-orderedListItem{list-style-type:none;position:relative}.public-DraftStyleDefault-orderedListItem.public-DraftStyleDefault-listLTR:before{left:-36px;position:absolute;text-align:right;width:30px}.public-DraftStyleDefault-orderedListItem.public-DraftStyleDefault-listRTL:before{position:absolute;right:-36px;text-align:left;width:30px}.public-DraftStyleDefault-orderedListItem:before{content:counter(ol0) \". \";counter-increment:ol0}.public-DraftStyleDefault-orderedListItem.public-DraftStyleDefault-depth1:before{content:counter(ol1) \". \";counter-increment:ol1}.public-DraftStyleDefault-orderedListItem.public-DraftStyleDefault-depth2:before{content:counter(ol2) \". \";counter-increment:ol2}.public-DraftStyleDefault-orderedListItem.public-DraftStyleDefault-depth3:before{content:counter(ol3) \". \";counter-increment:ol3}.public-DraftStyleDefault-orderedListItem.public-DraftStyleDefault-depth4:before{content:counter(ol4) \". \";counter-increment:ol4}.public-DraftStyleDefault-depth0.public-DraftStyleDefault-reset{counter-reset:ol0}.public-DraftStyleDefault-depth1.public-DraftStyleDefault-reset{counter-reset:ol1}.public-DraftStyleDefault-depth2.public-DraftStyleDefault-reset{counter-reset:ol2}.public-DraftStyleDefault-depth3.public-DraftStyleDefault-reset{counter-reset:ol3}.public-DraftStyleDefault-depth4.public-DraftStyleDefault-reset{counter-reset:ol4}\n\n";
n(css,{});

function CharacterCounter(_ref) {
  var charLimit = _ref.charLimit,
    value = _ref.value;
  var charCount = (value === null || value === void 0 ? void 0 : value.length) || 0;
  var isOverLimit = charCount > charLimit;
  return /*#__PURE__*/React__namespace.default.createElement(Counter, {
    isOverLimit: isOverLimit
  }, "".concat(charCount, "/").concat(charLimit));
}
CharacterCounter.propTypes = {
  charLimit: propTypesExports.number,
  value: propTypesExports.string
};
var Counter = styled__default.default(Typography$1)(function (_ref2) {
  var isOverLimit = _ref2.isOverLimit,
    theme = _ref2.theme;
  return {
    paddingBottom: "10px",
    color: isOverLimit ? theme.palette.error.main : undefined
  };
});

var RETURN_KEY = 13;
function MarkdownEditorInput(_ref) {
  var id = _ref.id,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    isCompact = _ref.isCompact,
    onChange = _ref.onChange,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? "Text" : _ref$placeholder,
    _ref$charLimit = _ref.charLimit,
    charLimit = _ref$charLimit === void 0 ? FORM_CHAR_LIMIT.MARKDOWN_INPUT : _ref$charLimit,
    _ref$showToolbarOnFoc = _ref.showToolbarOnFocus,
    showToolbarOnFocus = _ref$showToolbarOnFoc === void 0 ? false : _ref$showToolbarOnFoc,
    onBlur = _ref.onBlur;
  var _useState = React.useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    editorStateValue = _useState2[0],
    setEditorStateValue = _useState2[1];
  var theme = useTheme$1();
  var styles = getStyles$c();
  var editorRef = React.useRef();
  var onEditorStateChange = function onEditorStateChange(editorValue) {
    setEditorStateValue(editorValue);
    var convertedValue = convertEditorStateToMarkDown(editorValue);
    onChange(convertedValue);
  };

  // if existing value, set state to editorState
  React.useEffect(function () {
    if (value) {
      var convertedValue = convertMarkdownToEditorState(value);
      setEditorStateValue(convertedValue);
    }
  }, []);
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(react.ClassNames, null, function (_ref2) {
    var css = _ref2.css;
    return /*#__PURE__*/React__namespace.default.createElement(reactDraftWysiwyg.Editor, {
      toolbarOnFocus: showToolbarOnFocus,
      placeholder: placeholder,
      ref: editorRef,
      onBlur: onBlur,
      editorState: editorStateValue,
      wrapperClassName: getWrapperClass({
        css: css,
        isCompact: isCompact
      }),
      editorClassName: getEditorClass({
        css: css,
        theme: theme,
        isCompact: isCompact
      }),
      toolbarClassName: getToolbarClass({
        css: css,
        theme: theme,
        isCompact: isCompact
      }),
      toolbar: getToolbarOptions(),
      onEditorStateChange: onEditorStateChange,
      handlePastedText: handlePastedText,
      handleReturn: function handleReturn() {
        // Disables soft return (shift+return) by creating and passing
        // on a new event without modifiers. This prevents "/s/s" from
        // being added, which isn't supported by the Markdown component.
        editorRef.current.handleReturn(new Event("keypress", {
          which: RETURN_KEY
        }));
      }
    });
  }), /*#__PURE__*/React__namespace.default.createElement(Box$1, {
    style: styles.error
  }, !isCompact && /*#__PURE__*/React__namespace.default.createElement(CharacterCounter, {
    charLimit: charLimit,
    value: cleanMarkdownString(value)
  }), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    id: id,
    validationMessage: validationMessage
  })));
}
MarkdownEditorInput.propTypes = {
  id: propTypesExports.string,
  onChange: propTypesExports.func,
  value: propTypesExports.string,
  validationMessage: propTypesExports.string,
  isCompact: propTypesExports.bool,
  showToolbarOnFocus: propTypesExports.bool,
  placeholder: propTypesExports.string,
  charLimit: propTypesExports.number,
  onBlur: propTypesExports.func
};
function getToolbarOptions() {
  return {
    options: ["inline", "list", "link"],
    inline: {
      options: ["bold", "italic", "strikethrough"]
    }
  };
}
function getEditorClass(_ref3) {
  var css = _ref3.css,
    theme = _ref3.theme,
    isCompact = _ref3.isCompact;
  return css({
    backgroundColor: "transparent !important",
    margin: "0px 15px",
    minHeight: isCompact ? 20 : 220,
    maxHeight: 220,
    borderBottomRightRadius: theme.borderRadius.lg,
    borderBottomLeftRadius: theme.borderRadius.lg,
    "& a": {
      color: theme.palette.primary.main
    }
  });
}
function getWrapperClass(_ref4) {
  var css = _ref4.css,
    isCompact = _ref4.isCompact;
  if (!isCompact) return null;
  return css({
    display: "flex",
    flexDirection: "column-reverse",
    // Override the option to set whether the link shows on a new page. We do this by default.
    "& .rdw-link-modal-target-option": {
      display: "none"
    }
  });
}

// use of !important needed to override some styling
function getToolbarClass(_ref5) {
  var _css;
  var css = _ref5.css,
    theme = _ref5.theme,
    isCompact = _ref5.isCompact;
  var borderType = isCompact ? "borderTop" : "borderBottom";
  return css((_css = {
    color: theme.palette.text.dark,
    background: "transparent !important",
    border: "none !important"
  }, _defineProperty(_css, borderType, "1px solid ".concat(theme.palette.card.divider, " !important")), _defineProperty(_css, "marginBottom", "0px !important"), _defineProperty(_css, "padding", "10px !important"), _css));
}
function getStyles$c() {
  return {
    error: {
      paddingLeft: 15
    }
  };
}

// Removes any character that is not ascii code 32-255 or \n or \r\n.
function handlePastedText(text, html, editorState, onChange) {
  var cleanText = text.replace(/[^ -ÿ|\n|\r\n]+/g, "");
  var newContent = draftJs.Modifier.replaceText(editorState.getCurrentContent(), editorState.getSelection(), cleanText, editorState.getCurrentInlineStyle());
  onChange(draftJs.EditorState.push(editorState, newContent));

  // Dont return to keep bullets and spacing of pasted content
}

var CameraAlt = {};

var _interopRequireDefault$G = interopRequireDefaultExports;
Object.defineProperty(CameraAlt, "__esModule", {
  value: true
});
var default_1$G = CameraAlt.default = void 0;
var _createSvgIcon$G = _interopRequireDefault$G(requireCreateSvgIcon());
var _jsxRuntime$G = requireJsxRuntime();
var _default$G = (0, _createSvgIcon$G.default)([/*#__PURE__*/(0, _jsxRuntime$G.jsx)("circle", {
  cx: "12",
  cy: "12",
  r: "3.2"
}, "0"), /*#__PURE__*/(0, _jsxRuntime$G.jsx)("path", {
  d: "M9 2 7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2h-3.17L15 2H9zm3 15c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5z"
}, "1")], 'CameraAlt');
default_1$G = CameraAlt.default = _default$G;

var _excluded$Q = ["Icon"];
function OverlayIcon(_ref) {
  var Icon = _ref.Icon,
    props = _objectWithoutProperties(_ref, _excluded$Q);
  return /*#__PURE__*/React__namespace.default.createElement(Container$v, {
    display: "flex",
    justifyContent: "center",
    alignItems: "center"
  }, /*#__PURE__*/React__namespace.default.createElement(Icon, props));
}
OverlayIcon.propTypes = {
  Icon: propTypesExports.elementType
};
var Container$v = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    position: "absolute",
    backgroundColor: theme.palette.colors.icon.neutralContrast,
    opacity: 0.8,
    borderRadius: "100%",
    padding: 5,
    width: "40px",
    height: "40px",
    top: "5px",
    right: "5px"
  };
});

function UploadCameraIcon(props) {
  return /*#__PURE__*/React__namespace.default.createElement(CameraIcon, _extends$2({
    Icon: default_1$G
  }, props));
}
var CameraIcon = styled__default.default(OverlayIcon)(function (_ref) {
  var theme = _ref.theme;
  return {
    top: "10px",
    right: "10px",
    fontSize: "25px",
    color: theme.palette.colors.icon.neutral,
    backgroundColor: theme.palette.colors.icon.neutralContrast
  };
});

function UploadIcon(props) {
  return /*#__PURE__*/React__namespace.default.createElement(StyledOverlayIcon, _extends$2({
    Icon: default_1$J
  }, props));
}
var StyledOverlayIcon = styled__default.default(OverlayIcon)(function (_ref) {
  var theme = _ref.theme;
  return {
    top: "10px",
    right: "10px",
    fontSize: "25px",
    color: theme.palette.colors.icon.neutral,
    backgroundColor: theme.palette.colors.icon.neutralContrast
  };
});

var pdf_worker_entry = {};

var pdf_workerExports = {};
var pdf_worker = {
  get exports(){ return pdf_workerExports; },
  set exports(v){ pdf_workerExports = v; },
};

(function (module, exports) {
	(function webpackUniversalModuleDefinition(root, factory) {
		module.exports = factory();
	})(globalThis, () => {
	return /******/ (() => { // webpackBootstrap
	/******/ 	var __webpack_modules__ = ([
	/* 0 */,
	/* 1 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.WorkerTask = exports.WorkerMessageHandler = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _core_utils = __w_pdfjs_require__(6);

	var _pdf_manager = __w_pdfjs_require__(8);

	var _cleanup_helper = __w_pdfjs_require__(71);

	var _writer = __w_pdfjs_require__(65);

	var _is_node = __w_pdfjs_require__(4);

	var _message_handler = __w_pdfjs_require__(102);

	var _worker_stream = __w_pdfjs_require__(103);

	class WorkerTask {
	  constructor(name) {
	    this.name = name;
	    this.terminated = false;
	    this._capability = (0, _util.createPromiseCapability)();
	  }

	  get finished() {
	    return this._capability.promise;
	  }

	  finish() {
	    this._capability.resolve();
	  }

	  terminate() {
	    this.terminated = true;
	  }

	  ensureNotTerminated() {
	    if (this.terminated) {
	      throw new Error("Worker task was terminated");
	    }
	  }

	}

	exports.WorkerTask = WorkerTask;

	class WorkerMessageHandler {
	  static setup(handler, port) {
	    let testMessageProcessed = false;
	    handler.on("test", function wphSetupTest(data) {
	      if (testMessageProcessed) {
	        return;
	      }

	      testMessageProcessed = true;
	      handler.send("test", data instanceof Uint8Array);
	    });
	    handler.on("configure", function wphConfigure(data) {
	      (0, _util.setVerbosityLevel)(data.verbosity);
	    });
	    handler.on("GetDocRequest", function wphSetupDoc(data) {
	      return WorkerMessageHandler.createDocumentHandler(data, port);
	    });
	  }

	  static createDocumentHandler(docParams, port) {
	    let pdfManager;
	    let terminated = false;
	    let cancelXHRs = null;
	    const WorkerTasks = [];
	    const verbosity = (0, _util.getVerbosityLevel)();
	    const apiVersion = docParams.apiVersion;
	    const workerVersion = '2.16.105';

	    if (apiVersion !== workerVersion) {
	      throw new Error(`The API version "${apiVersion}" does not match ` + `the Worker version "${workerVersion}".`);
	    }

	    const enumerableProperties = [];

	    for (const property in []) {
	      enumerableProperties.push(property);
	    }

	    if (enumerableProperties.length) {
	      throw new Error("The `Array.prototype` contains unexpected enumerable properties: " + enumerableProperties.join(", ") + "; thus breaking e.g. `for...in` iteration of `Array`s.");
	    }

	    if (typeof ReadableStream === "undefined") {
	      const partialMsg = "The browser/environment lacks native support for critical " + "functionality used by the PDF.js library (e.g. `ReadableStream`); ";

	      if (_is_node.isNodeJS) {
	        throw new Error(partialMsg + "please use a `legacy`-build instead.");
	      }

	      throw new Error(partialMsg + "please update to a supported browser.");
	    }

	    const docId = docParams.docId;
	    const docBaseUrl = docParams.docBaseUrl;
	    const workerHandlerName = docParams.docId + "_worker";
	    let handler = new _message_handler.MessageHandler(workerHandlerName, docId, port);

	    function ensureNotTerminated() {
	      if (terminated) {
	        throw new Error("Worker was terminated");
	      }
	    }

	    function startWorkerTask(task) {
	      WorkerTasks.push(task);
	    }

	    function finishWorkerTask(task) {
	      task.finish();
	      const i = WorkerTasks.indexOf(task);
	      WorkerTasks.splice(i, 1);
	    }

	    async function loadDocument(recoveryMode) {
	      await pdfManager.ensureDoc("checkHeader");
	      await pdfManager.ensureDoc("parseStartXRef");
	      await pdfManager.ensureDoc("parse", [recoveryMode]);
	      await pdfManager.ensureDoc("checkFirstPage", [recoveryMode]);
	      await pdfManager.ensureDoc("checkLastPage", [recoveryMode]);
	      const isPureXfa = await pdfManager.ensureDoc("isPureXfa");

	      if (isPureXfa) {
	        const task = new WorkerTask("loadXfaFonts");
	        startWorkerTask(task);
	        await Promise.all([pdfManager.loadXfaFonts(handler, task).catch(reason => {}).then(() => finishWorkerTask(task)), pdfManager.loadXfaImages()]);
	      }

	      const [numPages, fingerprints] = await Promise.all([pdfManager.ensureDoc("numPages"), pdfManager.ensureDoc("fingerprints")]);
	      const htmlForXfa = isPureXfa ? await pdfManager.ensureDoc("htmlForXfa") : null;
	      return {
	        numPages,
	        fingerprints,
	        htmlForXfa
	      };
	    }

	    function getPdfManager(data, evaluatorOptions, enableXfa) {
	      const pdfManagerCapability = (0, _util.createPromiseCapability)();
	      let newPdfManager;
	      const source = data.source;

	      if (source.data) {
	        try {
	          newPdfManager = new _pdf_manager.LocalPdfManager(docId, source.data, source.password, handler, evaluatorOptions, enableXfa, docBaseUrl);
	          pdfManagerCapability.resolve(newPdfManager);
	        } catch (ex) {
	          pdfManagerCapability.reject(ex);
	        }

	        return pdfManagerCapability.promise;
	      }

	      let pdfStream,
	          cachedChunks = [];

	      try {
	        pdfStream = new _worker_stream.PDFWorkerStream(handler);
	      } catch (ex) {
	        pdfManagerCapability.reject(ex);
	        return pdfManagerCapability.promise;
	      }

	      const fullRequest = pdfStream.getFullReader();
	      fullRequest.headersReady.then(function () {
	        if (!fullRequest.isRangeSupported) {
	          return;
	        }

	        const disableAutoFetch = source.disableAutoFetch || fullRequest.isStreamingSupported;
	        newPdfManager = new _pdf_manager.NetworkPdfManager(docId, pdfStream, {
	          msgHandler: handler,
	          password: source.password,
	          length: fullRequest.contentLength,
	          disableAutoFetch,
	          rangeChunkSize: source.rangeChunkSize
	        }, evaluatorOptions, enableXfa, docBaseUrl);

	        for (const chunk of cachedChunks) {
	          newPdfManager.sendProgressiveData(chunk);
	        }

	        cachedChunks = [];
	        pdfManagerCapability.resolve(newPdfManager);
	        cancelXHRs = null;
	      }).catch(function (reason) {
	        pdfManagerCapability.reject(reason);
	        cancelXHRs = null;
	      });
	      let loaded = 0;

	      const flushChunks = function () {
	        const pdfFile = (0, _util.arraysToBytes)(cachedChunks);

	        if (source.length && pdfFile.length !== source.length) {
	          (0, _util.warn)("reported HTTP length is different from actual");
	        }

	        try {
	          newPdfManager = new _pdf_manager.LocalPdfManager(docId, pdfFile, source.password, handler, evaluatorOptions, enableXfa, docBaseUrl);
	          pdfManagerCapability.resolve(newPdfManager);
	        } catch (ex) {
	          pdfManagerCapability.reject(ex);
	        }

	        cachedChunks = [];
	      };

	      const readPromise = new Promise(function (resolve, reject) {
	        const readChunk = function ({
	          value,
	          done
	        }) {
	          try {
	            ensureNotTerminated();

	            if (done) {
	              if (!newPdfManager) {
	                flushChunks();
	              }

	              cancelXHRs = null;
	              return;
	            }

	            loaded += (0, _util.arrayByteLength)(value);

	            if (!fullRequest.isStreamingSupported) {
	              handler.send("DocProgress", {
	                loaded,
	                total: Math.max(loaded, fullRequest.contentLength || 0)
	              });
	            }

	            if (newPdfManager) {
	              newPdfManager.sendProgressiveData(value);
	            } else {
	              cachedChunks.push(value);
	            }

	            fullRequest.read().then(readChunk, reject);
	          } catch (e) {
	            reject(e);
	          }
	        };

	        fullRequest.read().then(readChunk, reject);
	      });
	      readPromise.catch(function (e) {
	        pdfManagerCapability.reject(e);
	        cancelXHRs = null;
	      });

	      cancelXHRs = function (reason) {
	        pdfStream.cancelAllRequests(reason);
	      };

	      return pdfManagerCapability.promise;
	    }

	    function setupDoc(data) {
	      function onSuccess(doc) {
	        ensureNotTerminated();
	        handler.send("GetDoc", {
	          pdfInfo: doc
	        });
	      }

	      function onFailure(ex) {
	        ensureNotTerminated();

	        if (ex instanceof _util.PasswordException) {
	          const task = new WorkerTask(`PasswordException: response ${ex.code}`);
	          startWorkerTask(task);
	          handler.sendWithPromise("PasswordRequest", ex).then(function ({
	            password
	          }) {
	            finishWorkerTask(task);
	            pdfManager.updatePassword(password);
	            pdfManagerReady();
	          }).catch(function () {
	            finishWorkerTask(task);
	            handler.send("DocException", ex);
	          });
	        } else if (ex instanceof _util.InvalidPDFException || ex instanceof _util.MissingPDFException || ex instanceof _util.UnexpectedResponseException || ex instanceof _util.UnknownErrorException) {
	          handler.send("DocException", ex);
	        } else {
	          handler.send("DocException", new _util.UnknownErrorException(ex.message, ex.toString()));
	        }
	      }

	      function pdfManagerReady() {
	        ensureNotTerminated();
	        loadDocument(false).then(onSuccess, function (reason) {
	          ensureNotTerminated();

	          if (!(reason instanceof _core_utils.XRefParseException)) {
	            onFailure(reason);
	            return;
	          }

	          pdfManager.requestLoadedStream();
	          pdfManager.onLoadedStream().then(function () {
	            ensureNotTerminated();
	            loadDocument(true).then(onSuccess, onFailure);
	          });
	        });
	      }

	      ensureNotTerminated();
	      const evaluatorOptions = {
	        maxImageSize: data.maxImageSize,
	        disableFontFace: data.disableFontFace,
	        ignoreErrors: data.ignoreErrors,
	        isEvalSupported: data.isEvalSupported,
	        fontExtraProperties: data.fontExtraProperties,
	        useSystemFonts: data.useSystemFonts,
	        cMapUrl: data.cMapUrl,
	        standardFontDataUrl: data.standardFontDataUrl
	      };
	      getPdfManager(data, evaluatorOptions, data.enableXfa).then(function (newPdfManager) {
	        if (terminated) {
	          newPdfManager.terminate(new _util.AbortException("Worker was terminated."));
	          throw new Error("Worker was terminated");
	        }

	        pdfManager = newPdfManager;
	        pdfManager.onLoadedStream().then(function (stream) {
	          handler.send("DataLoaded", {
	            length: stream.bytes.byteLength
	          });
	        });
	      }).then(pdfManagerReady, onFailure);
	    }

	    handler.on("GetPage", function wphSetupGetPage(data) {
	      return pdfManager.getPage(data.pageIndex).then(function (page) {
	        return Promise.all([pdfManager.ensure(page, "rotate"), pdfManager.ensure(page, "ref"), pdfManager.ensure(page, "userUnit"), pdfManager.ensure(page, "view")]).then(function ([rotate, ref, userUnit, view]) {
	          return {
	            rotate,
	            ref,
	            userUnit,
	            view
	          };
	        });
	      });
	    });
	    handler.on("GetPageIndex", function wphSetupGetPageIndex(data) {
	      const pageRef = _primitives.Ref.get(data.num, data.gen);

	      return pdfManager.ensureCatalog("getPageIndex", [pageRef]);
	    });
	    handler.on("GetDestinations", function wphSetupGetDestinations(data) {
	      return pdfManager.ensureCatalog("destinations");
	    });
	    handler.on("GetDestination", function wphSetupGetDestination(data) {
	      return pdfManager.ensureCatalog("getDestination", [data.id]);
	    });
	    handler.on("GetPageLabels", function wphSetupGetPageLabels(data) {
	      return pdfManager.ensureCatalog("pageLabels");
	    });
	    handler.on("GetPageLayout", function wphSetupGetPageLayout(data) {
	      return pdfManager.ensureCatalog("pageLayout");
	    });
	    handler.on("GetPageMode", function wphSetupGetPageMode(data) {
	      return pdfManager.ensureCatalog("pageMode");
	    });
	    handler.on("GetViewerPreferences", function (data) {
	      return pdfManager.ensureCatalog("viewerPreferences");
	    });
	    handler.on("GetOpenAction", function (data) {
	      return pdfManager.ensureCatalog("openAction");
	    });
	    handler.on("GetAttachments", function wphSetupGetAttachments(data) {
	      return pdfManager.ensureCatalog("attachments");
	    });
	    handler.on("GetJavaScript", function wphSetupGetJavaScript(data) {
	      return pdfManager.ensureCatalog("javaScript");
	    });
	    handler.on("GetDocJSActions", function wphSetupGetDocJSActions(data) {
	      return pdfManager.ensureCatalog("jsActions");
	    });
	    handler.on("GetPageJSActions", function ({
	      pageIndex
	    }) {
	      return pdfManager.getPage(pageIndex).then(function (page) {
	        return pdfManager.ensure(page, "jsActions");
	      });
	    });
	    handler.on("GetOutline", function wphSetupGetOutline(data) {
	      return pdfManager.ensureCatalog("documentOutline");
	    });
	    handler.on("GetOptionalContentConfig", function (data) {
	      return pdfManager.ensureCatalog("optionalContentConfig");
	    });
	    handler.on("GetPermissions", function (data) {
	      return pdfManager.ensureCatalog("permissions");
	    });
	    handler.on("GetMetadata", function wphSetupGetMetadata(data) {
	      return Promise.all([pdfManager.ensureDoc("documentInfo"), pdfManager.ensureCatalog("metadata")]);
	    });
	    handler.on("GetMarkInfo", function wphSetupGetMarkInfo(data) {
	      return pdfManager.ensureCatalog("markInfo");
	    });
	    handler.on("GetData", function wphSetupGetData(data) {
	      pdfManager.requestLoadedStream();
	      return pdfManager.onLoadedStream().then(function (stream) {
	        return stream.bytes;
	      });
	    });
	    handler.on("GetAnnotations", function ({
	      pageIndex,
	      intent
	    }) {
	      return pdfManager.getPage(pageIndex).then(function (page) {
	        const task = new WorkerTask(`GetAnnotations: page ${pageIndex}`);
	        startWorkerTask(task);
	        return page.getAnnotationsData(handler, task, intent).then(data => {
	          finishWorkerTask(task);
	          return data;
	        }, reason => {
	          finishWorkerTask(task);
	        });
	      });
	    });
	    handler.on("GetFieldObjects", function (data) {
	      return pdfManager.ensureDoc("fieldObjects");
	    });
	    handler.on("HasJSActions", function (data) {
	      return pdfManager.ensureDoc("hasJSActions");
	    });
	    handler.on("GetCalculationOrderIds", function (data) {
	      return pdfManager.ensureDoc("calculationOrderIds");
	    });
	    handler.on("SaveDocument", function ({
	      isPureXfa,
	      numPages,
	      annotationStorage,
	      filename
	    }) {
	      pdfManager.requestLoadedStream();
	      const newAnnotationsByPage = !isPureXfa ? (0, _core_utils.getNewAnnotationsMap)(annotationStorage) : null;
	      const promises = [pdfManager.onLoadedStream(), pdfManager.ensureCatalog("acroForm"), pdfManager.ensureCatalog("acroFormRef"), pdfManager.ensureDoc("xref"), pdfManager.ensureDoc("startXRef")];

	      if (newAnnotationsByPage) {
	        for (const [pageIndex, annotations] of newAnnotationsByPage) {
	          promises.push(pdfManager.getPage(pageIndex).then(page => {
	            const task = new WorkerTask(`Save (editor): page ${pageIndex}`);
	            return page.saveNewAnnotations(handler, task, annotations).finally(function () {
	              finishWorkerTask(task);
	            });
	          }));
	        }
	      }

	      if (isPureXfa) {
	        promises.push(pdfManager.serializeXfaData(annotationStorage));
	      } else {
	        for (let pageIndex = 0; pageIndex < numPages; pageIndex++) {
	          promises.push(pdfManager.getPage(pageIndex).then(function (page) {
	            const task = new WorkerTask(`Save: page ${pageIndex}`);
	            return page.save(handler, task, annotationStorage).finally(function () {
	              finishWorkerTask(task);
	            });
	          }));
	        }
	      }

	      return Promise.all(promises).then(function ([stream, acroForm, acroFormRef, xref, startXRef, ...refs]) {
	        let newRefs = [];
	        let xfaData = null;

	        if (isPureXfa) {
	          xfaData = refs[0];

	          if (!xfaData) {
	            return stream.bytes;
	          }
	        } else {
	          newRefs = refs.flat(2);

	          if (newRefs.length === 0) {
	            return stream.bytes;
	          }
	        }

	        const xfa = acroForm instanceof _primitives.Dict && acroForm.get("XFA") || null;
	        let xfaDatasetsRef = null;
	        let hasXfaDatasetsEntry = false;

	        if (Array.isArray(xfa)) {
	          for (let i = 0, ii = xfa.length; i < ii; i += 2) {
	            if (xfa[i] === "datasets") {
	              xfaDatasetsRef = xfa[i + 1];
	              acroFormRef = null;
	              hasXfaDatasetsEntry = true;
	            }
	          }

	          if (xfaDatasetsRef === null) {
	            xfaDatasetsRef = xref.getNewRef();
	          }
	        } else if (xfa) {
	          acroFormRef = null;
	          (0, _util.warn)("Unsupported XFA type.");
	        }

	        let newXrefInfo = Object.create(null);

	        if (xref.trailer) {
	          const infoObj = Object.create(null);
	          const xrefInfo = xref.trailer.get("Info") || null;

	          if (xrefInfo instanceof _primitives.Dict) {
	            xrefInfo.forEach((key, value) => {
	              if (typeof value === "string") {
	                infoObj[key] = (0, _util.stringToPDFString)(value);
	              }
	            });
	          }

	          newXrefInfo = {
	            rootRef: xref.trailer.getRaw("Root") || null,
	            encryptRef: xref.trailer.getRaw("Encrypt") || null,
	            newRef: xref.getNewRef(),
	            infoRef: xref.trailer.getRaw("Info") || null,
	            info: infoObj,
	            fileIds: xref.trailer.get("ID") || null,
	            startXRef,
	            filename
	          };
	        }

	        xref.resetNewRef();
	        return (0, _writer.incrementalUpdate)({
	          originalData: stream.bytes,
	          xrefInfo: newXrefInfo,
	          newRefs,
	          xref,
	          hasXfa: !!xfa,
	          xfaDatasetsRef,
	          hasXfaDatasetsEntry,
	          acroFormRef,
	          acroForm,
	          xfaData
	        });
	      });
	    });
	    handler.on("GetOperatorList", function wphSetupRenderPage(data, sink) {
	      const pageIndex = data.pageIndex;
	      pdfManager.getPage(pageIndex).then(function (page) {
	        const task = new WorkerTask(`GetOperatorList: page ${pageIndex}`);
	        startWorkerTask(task);
	        const start = verbosity >= _util.VerbosityLevel.INFOS ? Date.now() : 0;
	        page.getOperatorList({
	          handler,
	          sink,
	          task,
	          intent: data.intent,
	          cacheKey: data.cacheKey,
	          annotationStorage: data.annotationStorage
	        }).then(function (operatorListInfo) {
	          finishWorkerTask(task);

	          if (start) {
	            (0, _util.info)(`page=${pageIndex + 1} - getOperatorList: time=` + `${Date.now() - start}ms, len=${operatorListInfo.length}`);
	          }

	          sink.close();
	        }, function (reason) {
	          finishWorkerTask(task);

	          if (task.terminated) {
	            return;
	          }

	          handler.send("UnsupportedFeature", {
	            featureId: _util.UNSUPPORTED_FEATURES.errorOperatorList
	          });
	          sink.error(reason);
	        });
	      });
	    });
	    handler.on("GetTextContent", function wphExtractText(data, sink) {
	      const pageIndex = data.pageIndex;
	      pdfManager.getPage(pageIndex).then(function (page) {
	        const task = new WorkerTask("GetTextContent: page " + pageIndex);
	        startWorkerTask(task);
	        const start = verbosity >= _util.VerbosityLevel.INFOS ? Date.now() : 0;
	        page.extractTextContent({
	          handler,
	          task,
	          sink,
	          includeMarkedContent: data.includeMarkedContent,
	          combineTextItems: data.combineTextItems
	        }).then(function () {
	          finishWorkerTask(task);

	          if (start) {
	            (0, _util.info)(`page=${pageIndex + 1} - getTextContent: time=` + `${Date.now() - start}ms`);
	          }

	          sink.close();
	        }, function (reason) {
	          finishWorkerTask(task);

	          if (task.terminated) {
	            return;
	          }

	          sink.error(reason);
	        });
	      });
	    });
	    handler.on("GetStructTree", function wphGetStructTree(data) {
	      return pdfManager.getPage(data.pageIndex).then(function (page) {
	        return pdfManager.ensure(page, "getStructTree");
	      });
	    });
	    handler.on("FontFallback", function (data) {
	      return pdfManager.fontFallback(data.id, handler);
	    });
	    handler.on("Cleanup", function wphCleanup(data) {
	      return pdfManager.cleanup(true);
	    });
	    handler.on("Terminate", function wphTerminate(data) {
	      terminated = true;
	      const waitOn = [];

	      if (pdfManager) {
	        pdfManager.terminate(new _util.AbortException("Worker was terminated."));
	        const cleanupPromise = pdfManager.cleanup();
	        waitOn.push(cleanupPromise);
	        pdfManager = null;
	      } else {
	        (0, _cleanup_helper.clearGlobalCaches)();
	      }

	      if (cancelXHRs) {
	        cancelXHRs(new _util.AbortException("Worker was terminated."));
	      }

	      for (const task of WorkerTasks) {
	        waitOn.push(task.finished);
	        task.terminate();
	      }

	      return Promise.all(waitOn).then(function () {
	        handler.destroy();
	        handler = null;
	      });
	    });
	    handler.on("Ready", function wphReady(data) {
	      setupDoc(docParams);
	      docParams = null;
	    });
	    return workerHandlerName;
	  }

	  static initializeFromPort(port) {
	    const handler = new _message_handler.MessageHandler("worker", "main", port);
	    WorkerMessageHandler.setup(handler, port);
	    handler.send("ready", null);
	  }

	}

	exports.WorkerMessageHandler = WorkerMessageHandler;

	function isMessagePort(maybePort) {
	  return typeof maybePort.postMessage === "function" && "onmessage" in maybePort;
	}

	if (typeof window === "undefined" && !_is_node.isNodeJS && typeof self !== "undefined" && isMessagePort(self)) {
	  WorkerMessageHandler.initializeFromPort(self);
	}

	/***/ }),
	/* 2 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.VerbosityLevel = exports.Util = exports.UnknownErrorException = exports.UnexpectedResponseException = exports.UNSUPPORTED_FEATURES = exports.TextRenderingMode = exports.StreamType = exports.RenderingIntentFlag = exports.PermissionFlag = exports.PasswordResponses = exports.PasswordException = exports.PageActionEventType = exports.OPS = exports.MissingPDFException = exports.LINE_FACTOR = exports.LINE_DESCENT_FACTOR = exports.InvalidPDFException = exports.ImageKind = exports.IDENTITY_MATRIX = exports.FormatError = exports.FontType = exports.FeatureTest = exports.FONT_IDENTITY_MATRIX = exports.DocumentActionEventType = exports.CMapCompressionType = exports.BaseException = exports.AnnotationType = exports.AnnotationStateModelType = exports.AnnotationReviewState = exports.AnnotationReplyType = exports.AnnotationMode = exports.AnnotationMarkedState = exports.AnnotationFlag = exports.AnnotationFieldFlag = exports.AnnotationEditorType = exports.AnnotationEditorPrefix = exports.AnnotationEditorParamsType = exports.AnnotationBorderStyleType = exports.AnnotationActionEventType = exports.AbortException = void 0;
	exports.arrayByteLength = arrayByteLength;
	exports.arraysToBytes = arraysToBytes;
	exports.assert = assert;
	exports.bytesToString = bytesToString;
	exports.createPromiseCapability = createPromiseCapability;
	exports.createValidAbsoluteUrl = createValidAbsoluteUrl;
	exports.escapeString = escapeString;
	exports.getModificationDate = getModificationDate;
	exports.getVerbosityLevel = getVerbosityLevel;
	exports.info = info;
	exports.isArrayBuffer = isArrayBuffer;
	exports.isArrayEqual = isArrayEqual;
	exports.isAscii = isAscii;
	exports.objectFromMap = objectFromMap;
	exports.objectSize = objectSize;
	exports.setVerbosityLevel = setVerbosityLevel;
	exports.shadow = shadow;
	exports.string32 = string32;
	exports.stringToBytes = stringToBytes;
	exports.stringToPDFString = stringToPDFString;
	exports.stringToUTF16BEString = stringToUTF16BEString;
	exports.stringToUTF8String = stringToUTF8String;
	exports.unreachable = unreachable;
	exports.utf8StringToString = utf8StringToString;
	exports.warn = warn;

	__w_pdfjs_require__(3);

	const IDENTITY_MATRIX = [1, 0, 0, 1, 0, 0];
	exports.IDENTITY_MATRIX = IDENTITY_MATRIX;
	const FONT_IDENTITY_MATRIX = [0.001, 0, 0, 0.001, 0, 0];
	exports.FONT_IDENTITY_MATRIX = FONT_IDENTITY_MATRIX;
	const LINE_FACTOR = 1.35;
	exports.LINE_FACTOR = LINE_FACTOR;
	const LINE_DESCENT_FACTOR = 0.35;
	exports.LINE_DESCENT_FACTOR = LINE_DESCENT_FACTOR;
	const RenderingIntentFlag = {
	  ANY: 0x01,
	  DISPLAY: 0x02,
	  PRINT: 0x04,
	  ANNOTATIONS_FORMS: 0x10,
	  ANNOTATIONS_STORAGE: 0x20,
	  ANNOTATIONS_DISABLE: 0x40,
	  OPLIST: 0x100
	};
	exports.RenderingIntentFlag = RenderingIntentFlag;
	const AnnotationMode = {
	  DISABLE: 0,
	  ENABLE: 1,
	  ENABLE_FORMS: 2,
	  ENABLE_STORAGE: 3
	};
	exports.AnnotationMode = AnnotationMode;
	const AnnotationEditorPrefix = "pdfjs_internal_editor_";
	exports.AnnotationEditorPrefix = AnnotationEditorPrefix;
	const AnnotationEditorType = {
	  DISABLE: -1,
	  NONE: 0,
	  FREETEXT: 3,
	  INK: 15
	};
	exports.AnnotationEditorType = AnnotationEditorType;
	const AnnotationEditorParamsType = {
	  FREETEXT_SIZE: 1,
	  FREETEXT_COLOR: 2,
	  FREETEXT_OPACITY: 3,
	  INK_COLOR: 11,
	  INK_THICKNESS: 12,
	  INK_OPACITY: 13
	};
	exports.AnnotationEditorParamsType = AnnotationEditorParamsType;
	const PermissionFlag = {
	  PRINT: 0x04,
	  MODIFY_CONTENTS: 0x08,
	  COPY: 0x10,
	  MODIFY_ANNOTATIONS: 0x20,
	  FILL_INTERACTIVE_FORMS: 0x100,
	  COPY_FOR_ACCESSIBILITY: 0x200,
	  ASSEMBLE: 0x400,
	  PRINT_HIGH_QUALITY: 0x800
	};
	exports.PermissionFlag = PermissionFlag;
	const TextRenderingMode = {
	  FILL: 0,
	  STROKE: 1,
	  FILL_STROKE: 2,
	  INVISIBLE: 3,
	  FILL_ADD_TO_PATH: 4,
	  STROKE_ADD_TO_PATH: 5,
	  FILL_STROKE_ADD_TO_PATH: 6,
	  ADD_TO_PATH: 7,
	  FILL_STROKE_MASK: 3,
	  ADD_TO_PATH_FLAG: 4
	};
	exports.TextRenderingMode = TextRenderingMode;
	const ImageKind = {
	  GRAYSCALE_1BPP: 1,
	  RGB_24BPP: 2,
	  RGBA_32BPP: 3
	};
	exports.ImageKind = ImageKind;
	const AnnotationType = {
	  TEXT: 1,
	  LINK: 2,
	  FREETEXT: 3,
	  LINE: 4,
	  SQUARE: 5,
	  CIRCLE: 6,
	  POLYGON: 7,
	  POLYLINE: 8,
	  HIGHLIGHT: 9,
	  UNDERLINE: 10,
	  SQUIGGLY: 11,
	  STRIKEOUT: 12,
	  STAMP: 13,
	  CARET: 14,
	  INK: 15,
	  POPUP: 16,
	  FILEATTACHMENT: 17,
	  SOUND: 18,
	  MOVIE: 19,
	  WIDGET: 20,
	  SCREEN: 21,
	  PRINTERMARK: 22,
	  TRAPNET: 23,
	  WATERMARK: 24,
	  THREED: 25,
	  REDACT: 26
	};
	exports.AnnotationType = AnnotationType;
	const AnnotationStateModelType = {
	  MARKED: "Marked",
	  REVIEW: "Review"
	};
	exports.AnnotationStateModelType = AnnotationStateModelType;
	const AnnotationMarkedState = {
	  MARKED: "Marked",
	  UNMARKED: "Unmarked"
	};
	exports.AnnotationMarkedState = AnnotationMarkedState;
	const AnnotationReviewState = {
	  ACCEPTED: "Accepted",
	  REJECTED: "Rejected",
	  CANCELLED: "Cancelled",
	  COMPLETED: "Completed",
	  NONE: "None"
	};
	exports.AnnotationReviewState = AnnotationReviewState;
	const AnnotationReplyType = {
	  GROUP: "Group",
	  REPLY: "R"
	};
	exports.AnnotationReplyType = AnnotationReplyType;
	const AnnotationFlag = {
	  INVISIBLE: 0x01,
	  HIDDEN: 0x02,
	  PRINT: 0x04,
	  NOZOOM: 0x08,
	  NOROTATE: 0x10,
	  NOVIEW: 0x20,
	  READONLY: 0x40,
	  LOCKED: 0x80,
	  TOGGLENOVIEW: 0x100,
	  LOCKEDCONTENTS: 0x200
	};
	exports.AnnotationFlag = AnnotationFlag;
	const AnnotationFieldFlag = {
	  READONLY: 0x0000001,
	  REQUIRED: 0x0000002,
	  NOEXPORT: 0x0000004,
	  MULTILINE: 0x0001000,
	  PASSWORD: 0x0002000,
	  NOTOGGLETOOFF: 0x0004000,
	  RADIO: 0x0008000,
	  PUSHBUTTON: 0x0010000,
	  COMBO: 0x0020000,
	  EDIT: 0x0040000,
	  SORT: 0x0080000,
	  FILESELECT: 0x0100000,
	  MULTISELECT: 0x0200000,
	  DONOTSPELLCHECK: 0x0400000,
	  DONOTSCROLL: 0x0800000,
	  COMB: 0x1000000,
	  RICHTEXT: 0x2000000,
	  RADIOSINUNISON: 0x2000000,
	  COMMITONSELCHANGE: 0x4000000
	};
	exports.AnnotationFieldFlag = AnnotationFieldFlag;
	const AnnotationBorderStyleType = {
	  SOLID: 1,
	  DASHED: 2,
	  BEVELED: 3,
	  INSET: 4,
	  UNDERLINE: 5
	};
	exports.AnnotationBorderStyleType = AnnotationBorderStyleType;
	const AnnotationActionEventType = {
	  E: "Mouse Enter",
	  X: "Mouse Exit",
	  D: "Mouse Down",
	  U: "Mouse Up",
	  Fo: "Focus",
	  Bl: "Blur",
	  PO: "PageOpen",
	  PC: "PageClose",
	  PV: "PageVisible",
	  PI: "PageInvisible",
	  K: "Keystroke",
	  F: "Format",
	  V: "Validate",
	  C: "Calculate"
	};
	exports.AnnotationActionEventType = AnnotationActionEventType;
	const DocumentActionEventType = {
	  WC: "WillClose",
	  WS: "WillSave",
	  DS: "DidSave",
	  WP: "WillPrint",
	  DP: "DidPrint"
	};
	exports.DocumentActionEventType = DocumentActionEventType;
	const PageActionEventType = {
	  O: "PageOpen",
	  C: "PageClose"
	};
	exports.PageActionEventType = PageActionEventType;
	const StreamType = {
	  UNKNOWN: "UNKNOWN",
	  FLATE: "FLATE",
	  LZW: "LZW",
	  DCT: "DCT",
	  JPX: "JPX",
	  JBIG: "JBIG",
	  A85: "A85",
	  AHX: "AHX",
	  CCF: "CCF",
	  RLX: "RLX"
	};
	exports.StreamType = StreamType;
	const FontType = {
	  UNKNOWN: "UNKNOWN",
	  TYPE1: "TYPE1",
	  TYPE1STANDARD: "TYPE1STANDARD",
	  TYPE1C: "TYPE1C",
	  CIDFONTTYPE0: "CIDFONTTYPE0",
	  CIDFONTTYPE0C: "CIDFONTTYPE0C",
	  TRUETYPE: "TRUETYPE",
	  CIDFONTTYPE2: "CIDFONTTYPE2",
	  TYPE3: "TYPE3",
	  OPENTYPE: "OPENTYPE",
	  TYPE0: "TYPE0",
	  MMTYPE1: "MMTYPE1"
	};
	exports.FontType = FontType;
	const VerbosityLevel = {
	  ERRORS: 0,
	  WARNINGS: 1,
	  INFOS: 5
	};
	exports.VerbosityLevel = VerbosityLevel;
	const CMapCompressionType = {
	  NONE: 0,
	  BINARY: 1,
	  STREAM: 2
	};
	exports.CMapCompressionType = CMapCompressionType;
	const OPS = {
	  dependency: 1,
	  setLineWidth: 2,
	  setLineCap: 3,
	  setLineJoin: 4,
	  setMiterLimit: 5,
	  setDash: 6,
	  setRenderingIntent: 7,
	  setFlatness: 8,
	  setGState: 9,
	  save: 10,
	  restore: 11,
	  transform: 12,
	  moveTo: 13,
	  lineTo: 14,
	  curveTo: 15,
	  curveTo2: 16,
	  curveTo3: 17,
	  closePath: 18,
	  rectangle: 19,
	  stroke: 20,
	  closeStroke: 21,
	  fill: 22,
	  eoFill: 23,
	  fillStroke: 24,
	  eoFillStroke: 25,
	  closeFillStroke: 26,
	  closeEOFillStroke: 27,
	  endPath: 28,
	  clip: 29,
	  eoClip: 30,
	  beginText: 31,
	  endText: 32,
	  setCharSpacing: 33,
	  setWordSpacing: 34,
	  setHScale: 35,
	  setLeading: 36,
	  setFont: 37,
	  setTextRenderingMode: 38,
	  setTextRise: 39,
	  moveText: 40,
	  setLeadingMoveText: 41,
	  setTextMatrix: 42,
	  nextLine: 43,
	  showText: 44,
	  showSpacedText: 45,
	  nextLineShowText: 46,
	  nextLineSetSpacingShowText: 47,
	  setCharWidth: 48,
	  setCharWidthAndBounds: 49,
	  setStrokeColorSpace: 50,
	  setFillColorSpace: 51,
	  setStrokeColor: 52,
	  setStrokeColorN: 53,
	  setFillColor: 54,
	  setFillColorN: 55,
	  setStrokeGray: 56,
	  setFillGray: 57,
	  setStrokeRGBColor: 58,
	  setFillRGBColor: 59,
	  setStrokeCMYKColor: 60,
	  setFillCMYKColor: 61,
	  shadingFill: 62,
	  beginInlineImage: 63,
	  beginImageData: 64,
	  endInlineImage: 65,
	  paintXObject: 66,
	  markPoint: 67,
	  markPointProps: 68,
	  beginMarkedContent: 69,
	  beginMarkedContentProps: 70,
	  endMarkedContent: 71,
	  beginCompat: 72,
	  endCompat: 73,
	  paintFormXObjectBegin: 74,
	  paintFormXObjectEnd: 75,
	  beginGroup: 76,
	  endGroup: 77,
	  beginAnnotations: 78,
	  endAnnotations: 79,
	  beginAnnotation: 80,
	  endAnnotation: 81,
	  paintJpegXObject: 82,
	  paintImageMaskXObject: 83,
	  paintImageMaskXObjectGroup: 84,
	  paintImageXObject: 85,
	  paintInlineImageXObject: 86,
	  paintInlineImageXObjectGroup: 87,
	  paintImageXObjectRepeat: 88,
	  paintImageMaskXObjectRepeat: 89,
	  paintSolidColorImageMask: 90,
	  constructPath: 91
	};
	exports.OPS = OPS;
	const UNSUPPORTED_FEATURES = {
	  unknown: "unknown",
	  forms: "forms",
	  javaScript: "javaScript",
	  signatures: "signatures",
	  smask: "smask",
	  shadingPattern: "shadingPattern",
	  font: "font",
	  errorTilingPattern: "errorTilingPattern",
	  errorExtGState: "errorExtGState",
	  errorXObject: "errorXObject",
	  errorFontLoadType3: "errorFontLoadType3",
	  errorFontState: "errorFontState",
	  errorFontMissing: "errorFontMissing",
	  errorFontTranslate: "errorFontTranslate",
	  errorColorSpace: "errorColorSpace",
	  errorOperatorList: "errorOperatorList",
	  errorFontToUnicode: "errorFontToUnicode",
	  errorFontLoadNative: "errorFontLoadNative",
	  errorFontBuildPath: "errorFontBuildPath",
	  errorFontGetPath: "errorFontGetPath",
	  errorMarkedContent: "errorMarkedContent",
	  errorContentSubStream: "errorContentSubStream"
	};
	exports.UNSUPPORTED_FEATURES = UNSUPPORTED_FEATURES;
	const PasswordResponses = {
	  NEED_PASSWORD: 1,
	  INCORRECT_PASSWORD: 2
	};
	exports.PasswordResponses = PasswordResponses;
	let verbosity = VerbosityLevel.WARNINGS;

	function setVerbosityLevel(level) {
	  if (Number.isInteger(level)) {
	    verbosity = level;
	  }
	}

	function getVerbosityLevel() {
	  return verbosity;
	}

	function info(msg) {
	  if (verbosity >= VerbosityLevel.INFOS) {
	    console.log(`Info: ${msg}`);
	  }
	}

	function warn(msg) {
	  if (verbosity >= VerbosityLevel.WARNINGS) {
	    console.log(`Warning: ${msg}`);
	  }
	}

	function unreachable(msg) {
	  throw new Error(msg);
	}

	function assert(cond, msg) {
	  if (!cond) {
	    unreachable(msg);
	  }
	}

	function _isValidProtocol(url) {
	  if (!url) {
	    return false;
	  }

	  switch (url.protocol) {
	    case "http:":
	    case "https:":
	    case "ftp:":
	    case "mailto:":
	    case "tel:":
	      return true;

	    default:
	      return false;
	  }
	}

	function createValidAbsoluteUrl(url, baseUrl = null, options = null) {
	  if (!url) {
	    return null;
	  }

	  try {
	    if (options && typeof url === "string") {
	      if (options.addDefaultProtocol && url.startsWith("www.")) {
	        const dots = url.match(/\./g);

	        if (dots && dots.length >= 2) {
	          url = `http://${url}`;
	        }
	      }

	      if (options.tryConvertEncoding) {
	        try {
	          url = stringToUTF8String(url);
	        } catch (ex) {}
	      }
	    }

	    const absoluteUrl = baseUrl ? new URL(url, baseUrl) : new URL(url);

	    if (_isValidProtocol(absoluteUrl)) {
	      return absoluteUrl;
	    }
	  } catch (ex) {}

	  return null;
	}

	function shadow(obj, prop, value) {
	  Object.defineProperty(obj, prop, {
	    value,
	    enumerable: true,
	    configurable: true,
	    writable: false
	  });
	  return value;
	}

	const BaseException = function BaseExceptionClosure() {
	  function BaseException(message, name) {
	    if (this.constructor === BaseException) {
	      unreachable("Cannot initialize BaseException.");
	    }

	    this.message = message;
	    this.name = name;
	  }

	  BaseException.prototype = new Error();
	  BaseException.constructor = BaseException;
	  return BaseException;
	}();

	exports.BaseException = BaseException;

	class PasswordException extends BaseException {
	  constructor(msg, code) {
	    super(msg, "PasswordException");
	    this.code = code;
	  }

	}

	exports.PasswordException = PasswordException;

	class UnknownErrorException extends BaseException {
	  constructor(msg, details) {
	    super(msg, "UnknownErrorException");
	    this.details = details;
	  }

	}

	exports.UnknownErrorException = UnknownErrorException;

	class InvalidPDFException extends BaseException {
	  constructor(msg) {
	    super(msg, "InvalidPDFException");
	  }

	}

	exports.InvalidPDFException = InvalidPDFException;

	class MissingPDFException extends BaseException {
	  constructor(msg) {
	    super(msg, "MissingPDFException");
	  }

	}

	exports.MissingPDFException = MissingPDFException;

	class UnexpectedResponseException extends BaseException {
	  constructor(msg, status) {
	    super(msg, "UnexpectedResponseException");
	    this.status = status;
	  }

	}

	exports.UnexpectedResponseException = UnexpectedResponseException;

	class FormatError extends BaseException {
	  constructor(msg) {
	    super(msg, "FormatError");
	  }

	}

	exports.FormatError = FormatError;

	class AbortException extends BaseException {
	  constructor(msg) {
	    super(msg, "AbortException");
	  }

	}

	exports.AbortException = AbortException;

	function bytesToString(bytes) {
	  if (typeof bytes !== "object" || bytes === null || bytes.length === undefined) {
	    unreachable("Invalid argument for bytesToString");
	  }

	  const length = bytes.length;
	  const MAX_ARGUMENT_COUNT = 8192;

	  if (length < MAX_ARGUMENT_COUNT) {
	    return String.fromCharCode.apply(null, bytes);
	  }

	  const strBuf = [];

	  for (let i = 0; i < length; i += MAX_ARGUMENT_COUNT) {
	    const chunkEnd = Math.min(i + MAX_ARGUMENT_COUNT, length);
	    const chunk = bytes.subarray(i, chunkEnd);
	    strBuf.push(String.fromCharCode.apply(null, chunk));
	  }

	  return strBuf.join("");
	}

	function stringToBytes(str) {
	  if (typeof str !== "string") {
	    unreachable("Invalid argument for stringToBytes");
	  }

	  const length = str.length;
	  const bytes = new Uint8Array(length);

	  for (let i = 0; i < length; ++i) {
	    bytes[i] = str.charCodeAt(i) & 0xff;
	  }

	  return bytes;
	}

	function arrayByteLength(arr) {
	  if (arr.length !== undefined) {
	    return arr.length;
	  }

	  if (arr.byteLength !== undefined) {
	    return arr.byteLength;
	  }

	  unreachable("Invalid argument for arrayByteLength");
	}

	function arraysToBytes(arr) {
	  const length = arr.length;

	  if (length === 1 && arr[0] instanceof Uint8Array) {
	    return arr[0];
	  }

	  let resultLength = 0;

	  for (let i = 0; i < length; i++) {
	    resultLength += arrayByteLength(arr[i]);
	  }

	  let pos = 0;
	  const data = new Uint8Array(resultLength);

	  for (let i = 0; i < length; i++) {
	    let item = arr[i];

	    if (!(item instanceof Uint8Array)) {
	      if (typeof item === "string") {
	        item = stringToBytes(item);
	      } else {
	        item = new Uint8Array(item);
	      }
	    }

	    const itemLength = item.byteLength;
	    data.set(item, pos);
	    pos += itemLength;
	  }

	  return data;
	}

	function string32(value) {
	  return String.fromCharCode(value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff);
	}

	function objectSize(obj) {
	  return Object.keys(obj).length;
	}

	function objectFromMap(map) {
	  const obj = Object.create(null);

	  for (const [key, value] of map) {
	    obj[key] = value;
	  }

	  return obj;
	}

	function isLittleEndian() {
	  const buffer8 = new Uint8Array(4);
	  buffer8[0] = 1;
	  const view32 = new Uint32Array(buffer8.buffer, 0, 1);
	  return view32[0] === 1;
	}

	function isEvalSupported() {
	  try {
	    new Function("");
	    return true;
	  } catch (e) {
	    return false;
	  }
	}

	class FeatureTest {
	  static get isLittleEndian() {
	    return shadow(this, "isLittleEndian", isLittleEndian());
	  }

	  static get isEvalSupported() {
	    return shadow(this, "isEvalSupported", isEvalSupported());
	  }

	  static get isOffscreenCanvasSupported() {
	    return shadow(this, "isOffscreenCanvasSupported", typeof OffscreenCanvas !== "undefined");
	  }

	}

	exports.FeatureTest = FeatureTest;
	const hexNumbers = [...Array(256).keys()].map(n => n.toString(16).padStart(2, "0"));

	class Util {
	  static makeHexColor(r, g, b) {
	    return `#${hexNumbers[r]}${hexNumbers[g]}${hexNumbers[b]}`;
	  }

	  static scaleMinMax(transform, minMax) {
	    let temp;

	    if (transform[0]) {
	      if (transform[0] < 0) {
	        temp = minMax[0];
	        minMax[0] = minMax[1];
	        minMax[1] = temp;
	      }

	      minMax[0] *= transform[0];
	      minMax[1] *= transform[0];

	      if (transform[3] < 0) {
	        temp = minMax[2];
	        minMax[2] = minMax[3];
	        minMax[3] = temp;
	      }

	      minMax[2] *= transform[3];
	      minMax[3] *= transform[3];
	    } else {
	      temp = minMax[0];
	      minMax[0] = minMax[2];
	      minMax[2] = temp;
	      temp = minMax[1];
	      minMax[1] = minMax[3];
	      minMax[3] = temp;

	      if (transform[1] < 0) {
	        temp = minMax[2];
	        minMax[2] = minMax[3];
	        minMax[3] = temp;
	      }

	      minMax[2] *= transform[1];
	      minMax[3] *= transform[1];

	      if (transform[2] < 0) {
	        temp = minMax[0];
	        minMax[0] = minMax[1];
	        minMax[1] = temp;
	      }

	      minMax[0] *= transform[2];
	      minMax[1] *= transform[2];
	    }

	    minMax[0] += transform[4];
	    minMax[1] += transform[4];
	    minMax[2] += transform[5];
	    minMax[3] += transform[5];
	  }

	  static transform(m1, m2) {
	    return [m1[0] * m2[0] + m1[2] * m2[1], m1[1] * m2[0] + m1[3] * m2[1], m1[0] * m2[2] + m1[2] * m2[3], m1[1] * m2[2] + m1[3] * m2[3], m1[0] * m2[4] + m1[2] * m2[5] + m1[4], m1[1] * m2[4] + m1[3] * m2[5] + m1[5]];
	  }

	  static applyTransform(p, m) {
	    const xt = p[0] * m[0] + p[1] * m[2] + m[4];
	    const yt = p[0] * m[1] + p[1] * m[3] + m[5];
	    return [xt, yt];
	  }

	  static applyInverseTransform(p, m) {
	    const d = m[0] * m[3] - m[1] * m[2];
	    const xt = (p[0] * m[3] - p[1] * m[2] + m[2] * m[5] - m[4] * m[3]) / d;
	    const yt = (-p[0] * m[1] + p[1] * m[0] + m[4] * m[1] - m[5] * m[0]) / d;
	    return [xt, yt];
	  }

	  static getAxialAlignedBoundingBox(r, m) {
	    const p1 = Util.applyTransform(r, m);
	    const p2 = Util.applyTransform(r.slice(2, 4), m);
	    const p3 = Util.applyTransform([r[0], r[3]], m);
	    const p4 = Util.applyTransform([r[2], r[1]], m);
	    return [Math.min(p1[0], p2[0], p3[0], p4[0]), Math.min(p1[1], p2[1], p3[1], p4[1]), Math.max(p1[0], p2[0], p3[0], p4[0]), Math.max(p1[1], p2[1], p3[1], p4[1])];
	  }

	  static inverseTransform(m) {
	    const d = m[0] * m[3] - m[1] * m[2];
	    return [m[3] / d, -m[1] / d, -m[2] / d, m[0] / d, (m[2] * m[5] - m[4] * m[3]) / d, (m[4] * m[1] - m[5] * m[0]) / d];
	  }

	  static apply3dTransform(m, v) {
	    return [m[0] * v[0] + m[1] * v[1] + m[2] * v[2], m[3] * v[0] + m[4] * v[1] + m[5] * v[2], m[6] * v[0] + m[7] * v[1] + m[8] * v[2]];
	  }

	  static singularValueDecompose2dScale(m) {
	    const transpose = [m[0], m[2], m[1], m[3]];
	    const a = m[0] * transpose[0] + m[1] * transpose[2];
	    const b = m[0] * transpose[1] + m[1] * transpose[3];
	    const c = m[2] * transpose[0] + m[3] * transpose[2];
	    const d = m[2] * transpose[1] + m[3] * transpose[3];
	    const first = (a + d) / 2;
	    const second = Math.sqrt((a + d) ** 2 - 4 * (a * d - c * b)) / 2;
	    const sx = first + second || 1;
	    const sy = first - second || 1;
	    return [Math.sqrt(sx), Math.sqrt(sy)];
	  }

	  static normalizeRect(rect) {
	    const r = rect.slice(0);

	    if (rect[0] > rect[2]) {
	      r[0] = rect[2];
	      r[2] = rect[0];
	    }

	    if (rect[1] > rect[3]) {
	      r[1] = rect[3];
	      r[3] = rect[1];
	    }

	    return r;
	  }

	  static intersect(rect1, rect2) {
	    const xLow = Math.max(Math.min(rect1[0], rect1[2]), Math.min(rect2[0], rect2[2]));
	    const xHigh = Math.min(Math.max(rect1[0], rect1[2]), Math.max(rect2[0], rect2[2]));

	    if (xLow > xHigh) {
	      return null;
	    }

	    const yLow = Math.max(Math.min(rect1[1], rect1[3]), Math.min(rect2[1], rect2[3]));
	    const yHigh = Math.min(Math.max(rect1[1], rect1[3]), Math.max(rect2[1], rect2[3]));

	    if (yLow > yHigh) {
	      return null;
	    }

	    return [xLow, yLow, xHigh, yHigh];
	  }

	  static bezierBoundingBox(x0, y0, x1, y1, x2, y2, x3, y3) {
	    const tvalues = [],
	          bounds = [[], []];
	    let a, b, c, t, t1, t2, b2ac, sqrtb2ac;

	    for (let i = 0; i < 2; ++i) {
	      if (i === 0) {
	        b = 6 * x0 - 12 * x1 + 6 * x2;
	        a = -3 * x0 + 9 * x1 - 9 * x2 + 3 * x3;
	        c = 3 * x1 - 3 * x0;
	      } else {
	        b = 6 * y0 - 12 * y1 + 6 * y2;
	        a = -3 * y0 + 9 * y1 - 9 * y2 + 3 * y3;
	        c = 3 * y1 - 3 * y0;
	      }

	      if (Math.abs(a) < 1e-12) {
	        if (Math.abs(b) < 1e-12) {
	          continue;
	        }

	        t = -c / b;

	        if (0 < t && t < 1) {
	          tvalues.push(t);
	        }

	        continue;
	      }

	      b2ac = b * b - 4 * c * a;
	      sqrtb2ac = Math.sqrt(b2ac);

	      if (b2ac < 0) {
	        continue;
	      }

	      t1 = (-b + sqrtb2ac) / (2 * a);

	      if (0 < t1 && t1 < 1) {
	        tvalues.push(t1);
	      }

	      t2 = (-b - sqrtb2ac) / (2 * a);

	      if (0 < t2 && t2 < 1) {
	        tvalues.push(t2);
	      }
	    }

	    let j = tvalues.length,
	        mt;
	    const jlen = j;

	    while (j--) {
	      t = tvalues[j];
	      mt = 1 - t;
	      bounds[0][j] = mt * mt * mt * x0 + 3 * mt * mt * t * x1 + 3 * mt * t * t * x2 + t * t * t * x3;
	      bounds[1][j] = mt * mt * mt * y0 + 3 * mt * mt * t * y1 + 3 * mt * t * t * y2 + t * t * t * y3;
	    }

	    bounds[0][jlen] = x0;
	    bounds[1][jlen] = y0;
	    bounds[0][jlen + 1] = x3;
	    bounds[1][jlen + 1] = y3;
	    bounds[0].length = bounds[1].length = jlen + 2;
	    return [Math.min(...bounds[0]), Math.min(...bounds[1]), Math.max(...bounds[0]), Math.max(...bounds[1])];
	  }

	}

	exports.Util = Util;
	const PDFStringTranslateTable = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2d8, 0x2c7, 0x2c6, 0x2d9, 0x2dd, 0x2db, 0x2da, 0x2dc, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0x2022, 0x2020, 0x2021, 0x2026, 0x2014, 0x2013, 0x192, 0x2044, 0x2039, 0x203a, 0x2212, 0x2030, 0x201e, 0x201c, 0x201d, 0x2018, 0x2019, 0x201a, 0x2122, 0xfb01, 0xfb02, 0x141, 0x152, 0x160, 0x178, 0x17d, 0x131, 0x142, 0x153, 0x161, 0x17e, 0, 0x20ac];

	function stringToPDFString(str) {
	  if (str[0] >= "\xEF") {
	    let encoding;

	    if (str[0] === "\xFE" && str[1] === "\xFF") {
	      encoding = "utf-16be";
	    } else if (str[0] === "\xFF" && str[1] === "\xFE") {
	      encoding = "utf-16le";
	    } else if (str[0] === "\xEF" && str[1] === "\xBB" && str[2] === "\xBF") {
	      encoding = "utf-8";
	    }

	    if (encoding) {
	      try {
	        const decoder = new TextDecoder(encoding, {
	          fatal: true
	        });
	        const buffer = stringToBytes(str);
	        return decoder.decode(buffer);
	      } catch (ex) {
	        warn(`stringToPDFString: "${ex}".`);
	      }
	    }
	  }

	  const strBuf = [];

	  for (let i = 0, ii = str.length; i < ii; i++) {
	    const code = PDFStringTranslateTable[str.charCodeAt(i)];
	    strBuf.push(code ? String.fromCharCode(code) : str.charAt(i));
	  }

	  return strBuf.join("");
	}

	function escapeString(str) {
	  return str.replace(/([()\\\n\r])/g, match => {
	    if (match === "\n") {
	      return "\\n";
	    } else if (match === "\r") {
	      return "\\r";
	    }

	    return `\\${match}`;
	  });
	}

	function isAscii(str) {
	  return /^[\x00-\x7F]*$/.test(str);
	}

	function stringToUTF16BEString(str) {
	  const buf = ["\xFE\xFF"];

	  for (let i = 0, ii = str.length; i < ii; i++) {
	    const char = str.charCodeAt(i);
	    buf.push(String.fromCharCode(char >> 8 & 0xff), String.fromCharCode(char & 0xff));
	  }

	  return buf.join("");
	}

	function stringToUTF8String(str) {
	  return decodeURIComponent(escape(str));
	}

	function utf8StringToString(str) {
	  return unescape(encodeURIComponent(str));
	}

	function isArrayBuffer(v) {
	  return typeof v === "object" && v !== null && v.byteLength !== undefined;
	}

	function isArrayEqual(arr1, arr2) {
	  if (arr1.length !== arr2.length) {
	    return false;
	  }

	  for (let i = 0, ii = arr1.length; i < ii; i++) {
	    if (arr1[i] !== arr2[i]) {
	      return false;
	    }
	  }

	  return true;
	}

	function getModificationDate(date = new Date()) {
	  const buffer = [date.getUTCFullYear().toString(), (date.getUTCMonth() + 1).toString().padStart(2, "0"), date.getUTCDate().toString().padStart(2, "0"), date.getUTCHours().toString().padStart(2, "0"), date.getUTCMinutes().toString().padStart(2, "0"), date.getUTCSeconds().toString().padStart(2, "0")];
	  return buffer.join("");
	}

	function createPromiseCapability() {
	  const capability = Object.create(null);
	  let isSettled = false;
	  Object.defineProperty(capability, "settled", {
	    get() {
	      return isSettled;
	    }

	  });
	  capability.promise = new Promise(function (resolve, reject) {
	    capability.resolve = function (data) {
	      isSettled = true;
	      resolve(data);
	    };

	    capability.reject = function (reason) {
	      isSettled = true;
	      reject(reason);
	    };
	  });
	  return capability;
	}

	/***/ }),
	/* 3 */
	/***/ ((__unused_webpack_module, __unused_webpack_exports, __w_pdfjs_require__) => {



	__w_pdfjs_require__(4);

	/***/ }),
	/* 4 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.isNodeJS = void 0;
	const isNodeJS = typeof browser$1 === "object" && browser$1 + "" === "[object process]" && !browser$1.versions.nw && !(browser$1.versions.electron && browser$1.type && browser$1.type !== "browser");
	exports.isNodeJS = isNodeJS;

	/***/ }),
	/* 5 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.RefSetCache = exports.RefSet = exports.Ref = exports.Name = exports.EOF = exports.Dict = exports.Cmd = exports.CIRCULAR_REF = void 0;
	exports.clearPrimitiveCaches = clearPrimitiveCaches;
	exports.isCmd = isCmd;
	exports.isDict = isDict;
	exports.isName = isName;
	exports.isRefsEqual = isRefsEqual;

	var _util = __w_pdfjs_require__(2);

	const CIRCULAR_REF = Symbol("CIRCULAR_REF");
	exports.CIRCULAR_REF = CIRCULAR_REF;
	const EOF = Symbol("EOF");
	exports.EOF = EOF;

	const Name = function NameClosure() {
	  let nameCache = Object.create(null);

	  class Name {
	    constructor(name) {
	      this.name = name;
	    }

	    static get(name) {
	      return nameCache[name] || (nameCache[name] = new Name(name));
	    }

	    static _clearCache() {
	      nameCache = Object.create(null);
	    }

	  }

	  return Name;
	}();

	exports.Name = Name;

	const Cmd = function CmdClosure() {
	  let cmdCache = Object.create(null);

	  class Cmd {
	    constructor(cmd) {
	      this.cmd = cmd;
	    }

	    static get(cmd) {
	      return cmdCache[cmd] || (cmdCache[cmd] = new Cmd(cmd));
	    }

	    static _clearCache() {
	      cmdCache = Object.create(null);
	    }

	  }

	  return Cmd;
	}();

	exports.Cmd = Cmd;

	const nonSerializable = function nonSerializableClosure() {
	  return nonSerializable;
	};

	class Dict {
	  constructor(xref = null) {
	    this._map = Object.create(null);
	    this.xref = xref;
	    this.objId = null;
	    this.suppressEncryption = false;
	    this.__nonSerializable__ = nonSerializable;
	  }

	  assignXref(newXref) {
	    this.xref = newXref;
	  }

	  get size() {
	    return Object.keys(this._map).length;
	  }

	  get(key1, key2, key3) {
	    let value = this._map[key1];

	    if (value === undefined && key2 !== undefined) {
	      value = this._map[key2];

	      if (value === undefined && key3 !== undefined) {
	        value = this._map[key3];
	      }
	    }

	    if (value instanceof Ref && this.xref) {
	      return this.xref.fetch(value, this.suppressEncryption);
	    }

	    return value;
	  }

	  async getAsync(key1, key2, key3) {
	    let value = this._map[key1];

	    if (value === undefined && key2 !== undefined) {
	      value = this._map[key2];

	      if (value === undefined && key3 !== undefined) {
	        value = this._map[key3];
	      }
	    }

	    if (value instanceof Ref && this.xref) {
	      return this.xref.fetchAsync(value, this.suppressEncryption);
	    }

	    return value;
	  }

	  getArray(key1, key2, key3) {
	    let value = this._map[key1];

	    if (value === undefined && key2 !== undefined) {
	      value = this._map[key2];

	      if (value === undefined && key3 !== undefined) {
	        value = this._map[key3];
	      }
	    }

	    if (value instanceof Ref && this.xref) {
	      value = this.xref.fetch(value, this.suppressEncryption);
	    }

	    if (Array.isArray(value)) {
	      value = value.slice();

	      for (let i = 0, ii = value.length; i < ii; i++) {
	        if (value[i] instanceof Ref && this.xref) {
	          value[i] = this.xref.fetch(value[i], this.suppressEncryption);
	        }
	      }
	    }

	    return value;
	  }

	  getRaw(key) {
	    return this._map[key];
	  }

	  getKeys() {
	    return Object.keys(this._map);
	  }

	  getRawValues() {
	    return Object.values(this._map);
	  }

	  set(key, value) {
	    this._map[key] = value;
	  }

	  has(key) {
	    return this._map[key] !== undefined;
	  }

	  forEach(callback) {
	    for (const key in this._map) {
	      callback(key, this.get(key));
	    }
	  }

	  static get empty() {
	    const emptyDict = new Dict(null);

	    emptyDict.set = (key, value) => {
	      (0, _util.unreachable)("Should not call `set` on the empty dictionary.");
	    };

	    return (0, _util.shadow)(this, "empty", emptyDict);
	  }

	  static merge({
	    xref,
	    dictArray,
	    mergeSubDicts = false
	  }) {
	    const mergedDict = new Dict(xref),
	          properties = new Map();

	    for (const dict of dictArray) {
	      if (!(dict instanceof Dict)) {
	        continue;
	      }

	      for (const [key, value] of Object.entries(dict._map)) {
	        let property = properties.get(key);

	        if (property === undefined) {
	          property = [];
	          properties.set(key, property);
	        } else if (!mergeSubDicts || !(value instanceof Dict)) {
	          continue;
	        }

	        property.push(value);
	      }
	    }

	    for (const [name, values] of properties) {
	      if (values.length === 1 || !(values[0] instanceof Dict)) {
	        mergedDict._map[name] = values[0];
	        continue;
	      }

	      const subDict = new Dict(xref);

	      for (const dict of values) {
	        for (const [key, value] of Object.entries(dict._map)) {
	          if (subDict._map[key] === undefined) {
	            subDict._map[key] = value;
	          }
	        }
	      }

	      if (subDict.size > 0) {
	        mergedDict._map[name] = subDict;
	      }
	    }

	    properties.clear();
	    return mergedDict.size > 0 ? mergedDict : Dict.empty;
	  }

	}

	exports.Dict = Dict;

	const Ref = function RefClosure() {
	  let refCache = Object.create(null);

	  class Ref {
	    constructor(num, gen) {
	      this.num = num;
	      this.gen = gen;
	    }

	    toString() {
	      if (this.gen === 0) {
	        return `${this.num}R`;
	      }

	      return `${this.num}R${this.gen}`;
	    }

	    static get(num, gen) {
	      const key = gen === 0 ? `${num}R` : `${num}R${gen}`;
	      return refCache[key] || (refCache[key] = new Ref(num, gen));
	    }

	    static _clearCache() {
	      refCache = Object.create(null);
	    }

	  }

	  return Ref;
	}();

	exports.Ref = Ref;

	class RefSet {
	  constructor(parent = null) {
	    this._set = new Set(parent && parent._set);
	  }

	  has(ref) {
	    return this._set.has(ref.toString());
	  }

	  put(ref) {
	    this._set.add(ref.toString());
	  }

	  remove(ref) {
	    this._set.delete(ref.toString());
	  }

	  [Symbol.iterator]() {
	    return this._set.values();
	  }

	  clear() {
	    this._set.clear();
	  }

	}

	exports.RefSet = RefSet;

	class RefSetCache {
	  constructor() {
	    this._map = new Map();
	  }

	  get size() {
	    return this._map.size;
	  }

	  get(ref) {
	    return this._map.get(ref.toString());
	  }

	  has(ref) {
	    return this._map.has(ref.toString());
	  }

	  put(ref, obj) {
	    this._map.set(ref.toString(), obj);
	  }

	  putAlias(ref, aliasRef) {
	    this._map.set(ref.toString(), this.get(aliasRef));
	  }

	  [Symbol.iterator]() {
	    return this._map.values();
	  }

	  clear() {
	    this._map.clear();
	  }

	}

	exports.RefSetCache = RefSetCache;

	function isName(v, name) {
	  return v instanceof Name && (name === undefined || v.name === name);
	}

	function isCmd(v, cmd) {
	  return v instanceof Cmd && (cmd === undefined || v.cmd === cmd);
	}

	function isDict(v, type) {
	  return v instanceof Dict && (type === undefined || isName(v.get("Type"), type));
	}

	function isRefsEqual(v1, v2) {
	  return v1.num === v2.num && v1.gen === v2.gen;
	}

	function clearPrimitiveCaches() {
	  Cmd._clearCache();

	  Name._clearCache();

	  Ref._clearCache();
	}

	/***/ }),
	/* 6 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XRefParseException = exports.XRefEntryException = exports.ParserEOFException = exports.MissingDataException = exports.DocStats = void 0;
	exports.collectActions = collectActions;
	exports.encodeToXmlString = encodeToXmlString;
	exports.escapePDFName = escapePDFName;
	exports.getArrayLookupTableFactory = getArrayLookupTableFactory;
	exports.getInheritableProperty = getInheritableProperty;
	exports.getLookupTableFactory = getLookupTableFactory;
	exports.getNewAnnotationsMap = getNewAnnotationsMap;
	exports.isWhiteSpace = isWhiteSpace;
	exports.log2 = log2;
	exports.numberToString = numberToString;
	exports.parseXFAPath = parseXFAPath;
	exports.readInt8 = readInt8;
	exports.readUint16 = readUint16;
	exports.readUint32 = readUint32;
	exports.recoverJsURL = recoverJsURL;
	exports.toRomanNumerals = toRomanNumerals;
	exports.validateCSSFont = validateCSSFont;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _base_stream = __w_pdfjs_require__(7);

	function getLookupTableFactory(initializer) {
	  let lookup;
	  return function () {
	    if (initializer) {
	      lookup = Object.create(null);
	      initializer(lookup);
	      initializer = null;
	    }

	    return lookup;
	  };
	}

	function getArrayLookupTableFactory(initializer) {
	  let lookup;
	  return function () {
	    if (initializer) {
	      let arr = initializer();
	      initializer = null;
	      lookup = Object.create(null);

	      for (let i = 0, ii = arr.length; i < ii; i += 2) {
	        lookup[arr[i]] = arr[i + 1];
	      }

	      arr = null;
	    }

	    return lookup;
	  };
	}

	class MissingDataException extends _util.BaseException {
	  constructor(begin, end) {
	    super(`Missing data [${begin}, ${end})`, "MissingDataException");
	    this.begin = begin;
	    this.end = end;
	  }

	}

	exports.MissingDataException = MissingDataException;

	class ParserEOFException extends _util.BaseException {
	  constructor(msg) {
	    super(msg, "ParserEOFException");
	  }

	}

	exports.ParserEOFException = ParserEOFException;

	class XRefEntryException extends _util.BaseException {
	  constructor(msg) {
	    super(msg, "XRefEntryException");
	  }

	}

	exports.XRefEntryException = XRefEntryException;

	class XRefParseException extends _util.BaseException {
	  constructor(msg) {
	    super(msg, "XRefParseException");
	  }

	}

	exports.XRefParseException = XRefParseException;

	class DocStats {
	  constructor(handler) {
	    this._handler = handler;
	    this._streamTypes = new Set();
	    this._fontTypes = new Set();
	  }

	  _send() {
	    const streamTypes = Object.create(null),
	          fontTypes = Object.create(null);

	    for (const type of this._streamTypes) {
	      streamTypes[type] = true;
	    }

	    for (const type of this._fontTypes) {
	      fontTypes[type] = true;
	    }

	    this._handler.send("DocStats", {
	      streamTypes,
	      fontTypes
	    });
	  }

	  addStreamType(type) {
	    if (this._streamTypes.has(type)) {
	      return;
	    }

	    this._streamTypes.add(type);

	    this._send();
	  }

	  addFontType(type) {
	    if (this._fontTypes.has(type)) {
	      return;
	    }

	    this._fontTypes.add(type);

	    this._send();
	  }

	}

	exports.DocStats = DocStats;

	function getInheritableProperty({
	  dict,
	  key,
	  getArray = false,
	  stopWhenFound = true
	}) {
	  let values;
	  const visited = new _primitives.RefSet();

	  while (dict instanceof _primitives.Dict && !(dict.objId && visited.has(dict.objId))) {
	    if (dict.objId) {
	      visited.put(dict.objId);
	    }

	    const value = getArray ? dict.getArray(key) : dict.get(key);

	    if (value !== undefined) {
	      if (stopWhenFound) {
	        return value;
	      }

	      if (!values) {
	        values = [];
	      }

	      values.push(value);
	    }

	    dict = dict.get("Parent");
	  }

	  return values;
	}

	const ROMAN_NUMBER_MAP = ["", "C", "CC", "CCC", "CD", "D", "DC", "DCC", "DCCC", "CM", "", "X", "XX", "XXX", "XL", "L", "LX", "LXX", "LXXX", "XC", "", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX"];

	function toRomanNumerals(number, lowerCase = false) {
	  (0, _util.assert)(Number.isInteger(number) && number > 0, "The number should be a positive integer.");
	  const romanBuf = [];
	  let pos;

	  while (number >= 1000) {
	    number -= 1000;
	    romanBuf.push("M");
	  }

	  pos = number / 100 | 0;
	  number %= 100;
	  romanBuf.push(ROMAN_NUMBER_MAP[pos]);
	  pos = number / 10 | 0;
	  number %= 10;
	  romanBuf.push(ROMAN_NUMBER_MAP[10 + pos]);
	  romanBuf.push(ROMAN_NUMBER_MAP[20 + number]);
	  const romanStr = romanBuf.join("");
	  return lowerCase ? romanStr.toLowerCase() : romanStr;
	}

	function log2(x) {
	  if (x <= 0) {
	    return 0;
	  }

	  return Math.ceil(Math.log2(x));
	}

	function readInt8(data, offset) {
	  return data[offset] << 24 >> 24;
	}

	function readUint16(data, offset) {
	  return data[offset] << 8 | data[offset + 1];
	}

	function readUint32(data, offset) {
	  return (data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3]) >>> 0;
	}

	function isWhiteSpace(ch) {
	  return ch === 0x20 || ch === 0x09 || ch === 0x0d || ch === 0x0a;
	}

	function parseXFAPath(path) {
	  const positionPattern = /(.+)\[(\d+)\]$/;
	  return path.split(".").map(component => {
	    const m = component.match(positionPattern);

	    if (m) {
	      return {
	        name: m[1],
	        pos: parseInt(m[2], 10)
	      };
	    }

	    return {
	      name: component,
	      pos: 0
	    };
	  });
	}

	function escapePDFName(str) {
	  const buffer = [];
	  let start = 0;

	  for (let i = 0, ii = str.length; i < ii; i++) {
	    const char = str.charCodeAt(i);

	    if (char < 0x21 || char > 0x7e || char === 0x23 || char === 0x28 || char === 0x29 || char === 0x3c || char === 0x3e || char === 0x5b || char === 0x5d || char === 0x7b || char === 0x7d || char === 0x2f || char === 0x25) {
	      if (start < i) {
	        buffer.push(str.substring(start, i));
	      }

	      buffer.push(`#${char.toString(16)}`);
	      start = i + 1;
	    }
	  }

	  if (buffer.length === 0) {
	    return str;
	  }

	  if (start < str.length) {
	    buffer.push(str.substring(start, str.length));
	  }

	  return buffer.join("");
	}

	function _collectJS(entry, xref, list, parents) {
	  if (!entry) {
	    return;
	  }

	  let parent = null;

	  if (entry instanceof _primitives.Ref) {
	    if (parents.has(entry)) {
	      return;
	    }

	    parent = entry;
	    parents.put(parent);
	    entry = xref.fetch(entry);
	  }

	  if (Array.isArray(entry)) {
	    for (const element of entry) {
	      _collectJS(element, xref, list, parents);
	    }
	  } else if (entry instanceof _primitives.Dict) {
	    if ((0, _primitives.isName)(entry.get("S"), "JavaScript")) {
	      const js = entry.get("JS");
	      let code;

	      if (js instanceof _base_stream.BaseStream) {
	        code = js.getString();
	      } else if (typeof js === "string") {
	        code = js;
	      }

	      code = code && (0, _util.stringToPDFString)(code).replace(/\u0000/g, "");

	      if (code) {
	        list.push(code);
	      }
	    }

	    _collectJS(entry.getRaw("Next"), xref, list, parents);
	  }

	  if (parent) {
	    parents.remove(parent);
	  }
	}

	function collectActions(xref, dict, eventType) {
	  const actions = Object.create(null);
	  const additionalActionsDicts = getInheritableProperty({
	    dict,
	    key: "AA",
	    stopWhenFound: false
	  });

	  if (additionalActionsDicts) {
	    for (let i = additionalActionsDicts.length - 1; i >= 0; i--) {
	      const additionalActions = additionalActionsDicts[i];

	      if (!(additionalActions instanceof _primitives.Dict)) {
	        continue;
	      }

	      for (const key of additionalActions.getKeys()) {
	        const action = eventType[key];

	        if (!action) {
	          continue;
	        }

	        const actionDict = additionalActions.getRaw(key);
	        const parents = new _primitives.RefSet();
	        const list = [];

	        _collectJS(actionDict, xref, list, parents);

	        if (list.length > 0) {
	          actions[action] = list;
	        }
	      }
	    }
	  }

	  if (dict.has("A")) {
	    const actionDict = dict.get("A");
	    const parents = new _primitives.RefSet();
	    const list = [];

	    _collectJS(actionDict, xref, list, parents);

	    if (list.length > 0) {
	      actions.Action = list;
	    }
	  }

	  return (0, _util.objectSize)(actions) > 0 ? actions : null;
	}

	const XMLEntities = {
	  0x3c: "&lt;",
	  0x3e: "&gt;",
	  0x26: "&amp;",
	  0x22: "&quot;",
	  0x27: "&apos;"
	};

	function encodeToXmlString(str) {
	  const buffer = [];
	  let start = 0;

	  for (let i = 0, ii = str.length; i < ii; i++) {
	    const char = str.codePointAt(i);

	    if (0x20 <= char && char <= 0x7e) {
	      const entity = XMLEntities[char];

	      if (entity) {
	        if (start < i) {
	          buffer.push(str.substring(start, i));
	        }

	        buffer.push(entity);
	        start = i + 1;
	      }
	    } else {
	      if (start < i) {
	        buffer.push(str.substring(start, i));
	      }

	      buffer.push(`&#x${char.toString(16).toUpperCase()};`);

	      if (char > 0xd7ff && (char < 0xe000 || char > 0xfffd)) {
	        i++;
	      }

	      start = i + 1;
	    }
	  }

	  if (buffer.length === 0) {
	    return str;
	  }

	  if (start < str.length) {
	    buffer.push(str.substring(start, str.length));
	  }

	  return buffer.join("");
	}

	function validateCSSFont(cssFontInfo) {
	  const DEFAULT_CSS_FONT_OBLIQUE = "14";
	  const DEFAULT_CSS_FONT_WEIGHT = "400";
	  const CSS_FONT_WEIGHT_VALUES = new Set(["100", "200", "300", "400", "500", "600", "700", "800", "900", "1000", "normal", "bold", "bolder", "lighter"]);
	  const {
	    fontFamily,
	    fontWeight,
	    italicAngle
	  } = cssFontInfo;

	  if (/^".*"$/.test(fontFamily)) {
	    if (/[^\\]"/.test(fontFamily.slice(1, fontFamily.length - 1))) {
	      (0, _util.warn)(`XFA - FontFamily contains some unescaped ": ${fontFamily}.`);
	      return false;
	    }
	  } else if (/^'.*'$/.test(fontFamily)) {
	    if (/[^\\]'/.test(fontFamily.slice(1, fontFamily.length - 1))) {
	      (0, _util.warn)(`XFA - FontFamily contains some unescaped ': ${fontFamily}.`);
	      return false;
	    }
	  } else {
	    for (const ident of fontFamily.split(/[ \t]+/)) {
	      if (/^(\d|(-(\d|-)))/.test(ident) || !/^[\w-\\]+$/.test(ident)) {
	        (0, _util.warn)(`XFA - FontFamily contains some invalid <custom-ident>: ${fontFamily}.`);
	        return false;
	      }
	    }
	  }

	  const weight = fontWeight ? fontWeight.toString() : "";
	  cssFontInfo.fontWeight = CSS_FONT_WEIGHT_VALUES.has(weight) ? weight : DEFAULT_CSS_FONT_WEIGHT;
	  const angle = parseFloat(italicAngle);
	  cssFontInfo.italicAngle = isNaN(angle) || angle < -90 || angle > 90 ? DEFAULT_CSS_FONT_OBLIQUE : italicAngle.toString();
	  return true;
	}

	function recoverJsURL(str) {
	  const URL_OPEN_METHODS = ["app.launchURL", "window.open", "xfa.host.gotoURL"];
	  const regex = new RegExp("^\\s*(" + URL_OPEN_METHODS.join("|").split(".").join("\\.") + ")\\((?:'|\")([^'\"]*)(?:'|\")(?:,\\s*(\\w+)\\)|\\))", "i");
	  const jsUrl = regex.exec(str);

	  if (jsUrl && jsUrl[2]) {
	    const url = jsUrl[2];
	    let newWindow = false;

	    if (jsUrl[3] === "true" && jsUrl[1] === "app.launchURL") {
	      newWindow = true;
	    }

	    return {
	      url,
	      newWindow
	    };
	  }

	  return null;
	}

	function numberToString(value) {
	  if (Number.isInteger(value)) {
	    return value.toString();
	  }

	  const roundedValue = Math.round(value * 100);

	  if (roundedValue % 100 === 0) {
	    return (roundedValue / 100).toString();
	  }

	  if (roundedValue % 10 === 0) {
	    return value.toFixed(1);
	  }

	  return value.toFixed(2);
	}

	function getNewAnnotationsMap(annotationStorage) {
	  if (!annotationStorage) {
	    return null;
	  }

	  const newAnnotationsByPage = new Map();

	  for (const [key, value] of annotationStorage) {
	    if (!key.startsWith(_util.AnnotationEditorPrefix)) {
	      continue;
	    }

	    let annotations = newAnnotationsByPage.get(value.pageIndex);

	    if (!annotations) {
	      annotations = [];
	      newAnnotationsByPage.set(value.pageIndex, annotations);
	    }

	    annotations.push(value);
	  }

	  return newAnnotationsByPage.size > 0 ? newAnnotationsByPage : null;
	}

	/***/ }),
	/* 7 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.BaseStream = void 0;

	var _util = __w_pdfjs_require__(2);

	class BaseStream {
	  constructor() {
	    if (this.constructor === BaseStream) {
	      (0, _util.unreachable)("Cannot initialize BaseStream.");
	    }
	  }

	  get length() {
	    (0, _util.unreachable)("Abstract getter `length` accessed");
	  }

	  get isEmpty() {
	    (0, _util.unreachable)("Abstract getter `isEmpty` accessed");
	  }

	  get isDataLoaded() {
	    return (0, _util.shadow)(this, "isDataLoaded", true);
	  }

	  getByte() {
	    (0, _util.unreachable)("Abstract method `getByte` called");
	  }

	  getBytes(length) {
	    (0, _util.unreachable)("Abstract method `getBytes` called");
	  }

	  peekByte() {
	    const peekedByte = this.getByte();

	    if (peekedByte !== -1) {
	      this.pos--;
	    }

	    return peekedByte;
	  }

	  peekBytes(length) {
	    const bytes = this.getBytes(length);
	    this.pos -= bytes.length;
	    return bytes;
	  }

	  getUint16() {
	    const b0 = this.getByte();
	    const b1 = this.getByte();

	    if (b0 === -1 || b1 === -1) {
	      return -1;
	    }

	    return (b0 << 8) + b1;
	  }

	  getInt32() {
	    const b0 = this.getByte();
	    const b1 = this.getByte();
	    const b2 = this.getByte();
	    const b3 = this.getByte();
	    return (b0 << 24) + (b1 << 16) + (b2 << 8) + b3;
	  }

	  getByteRange(begin, end) {
	    (0, _util.unreachable)("Abstract method `getByteRange` called");
	  }

	  getString(length) {
	    return (0, _util.bytesToString)(this.getBytes(length));
	  }

	  skip(n) {
	    this.pos += n || 1;
	  }

	  reset() {
	    (0, _util.unreachable)("Abstract method `reset` called");
	  }

	  moveStart() {
	    (0, _util.unreachable)("Abstract method `moveStart` called");
	  }

	  makeSubStream(start, length, dict = null) {
	    (0, _util.unreachable)("Abstract method `makeSubStream` called");
	  }

	  getBaseStreams() {
	    return null;
	  }

	}

	exports.BaseStream = BaseStream;

	/***/ }),
	/* 8 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.NetworkPdfManager = exports.LocalPdfManager = void 0;

	var _util = __w_pdfjs_require__(2);

	var _chunked_stream = __w_pdfjs_require__(9);

	var _core_utils = __w_pdfjs_require__(6);

	var _document = __w_pdfjs_require__(11);

	var _stream = __w_pdfjs_require__(10);

	function parseDocBaseUrl(url) {
	  if (url) {
	    const absoluteUrl = (0, _util.createValidAbsoluteUrl)(url);

	    if (absoluteUrl) {
	      return absoluteUrl.href;
	    }

	    (0, _util.warn)(`Invalid absolute docBaseUrl: "${url}".`);
	  }

	  return null;
	}

	class BasePdfManager {
	  constructor() {
	    if (this.constructor === BasePdfManager) {
	      (0, _util.unreachable)("Cannot initialize BasePdfManager.");
	    }
	  }

	  get docId() {
	    return this._docId;
	  }

	  get password() {
	    return this._password;
	  }

	  get docBaseUrl() {
	    const catalog = this.pdfDocument.catalog;
	    return (0, _util.shadow)(this, "docBaseUrl", catalog.baseUrl || this._docBaseUrl);
	  }

	  onLoadedStream() {
	    (0, _util.unreachable)("Abstract method `onLoadedStream` called");
	  }

	  ensureDoc(prop, args) {
	    return this.ensure(this.pdfDocument, prop, args);
	  }

	  ensureXRef(prop, args) {
	    return this.ensure(this.pdfDocument.xref, prop, args);
	  }

	  ensureCatalog(prop, args) {
	    return this.ensure(this.pdfDocument.catalog, prop, args);
	  }

	  getPage(pageIndex) {
	    return this.pdfDocument.getPage(pageIndex);
	  }

	  fontFallback(id, handler) {
	    return this.pdfDocument.fontFallback(id, handler);
	  }

	  loadXfaFonts(handler, task) {
	    return this.pdfDocument.loadXfaFonts(handler, task);
	  }

	  loadXfaImages() {
	    return this.pdfDocument.loadXfaImages();
	  }

	  serializeXfaData(annotationStorage) {
	    return this.pdfDocument.serializeXfaData(annotationStorage);
	  }

	  cleanup(manuallyTriggered = false) {
	    return this.pdfDocument.cleanup(manuallyTriggered);
	  }

	  async ensure(obj, prop, args) {
	    (0, _util.unreachable)("Abstract method `ensure` called");
	  }

	  requestRange(begin, end) {
	    (0, _util.unreachable)("Abstract method `requestRange` called");
	  }

	  requestLoadedStream() {
	    (0, _util.unreachable)("Abstract method `requestLoadedStream` called");
	  }

	  sendProgressiveData(chunk) {
	    (0, _util.unreachable)("Abstract method `sendProgressiveData` called");
	  }

	  updatePassword(password) {
	    this._password = password;
	  }

	  terminate(reason) {
	    (0, _util.unreachable)("Abstract method `terminate` called");
	  }

	}

	class LocalPdfManager extends BasePdfManager {
	  constructor(docId, data, password, msgHandler, evaluatorOptions, enableXfa, docBaseUrl) {
	    super();
	    this._docId = docId;
	    this._password = password;
	    this._docBaseUrl = parseDocBaseUrl(docBaseUrl);
	    this.msgHandler = msgHandler;
	    this.evaluatorOptions = evaluatorOptions;
	    this.enableXfa = enableXfa;
	    const stream = new _stream.Stream(data);
	    this.pdfDocument = new _document.PDFDocument(this, stream);
	    this._loadedStreamPromise = Promise.resolve(stream);
	  }

	  async ensure(obj, prop, args) {
	    const value = obj[prop];

	    if (typeof value === "function") {
	      return value.apply(obj, args);
	    }

	    return value;
	  }

	  requestRange(begin, end) {
	    return Promise.resolve();
	  }

	  requestLoadedStream() {}

	  onLoadedStream() {
	    return this._loadedStreamPromise;
	  }

	  terminate(reason) {}

	}

	exports.LocalPdfManager = LocalPdfManager;

	class NetworkPdfManager extends BasePdfManager {
	  constructor(docId, pdfNetworkStream, args, evaluatorOptions, enableXfa, docBaseUrl) {
	    super();
	    this._docId = docId;
	    this._password = args.password;
	    this._docBaseUrl = parseDocBaseUrl(docBaseUrl);
	    this.msgHandler = args.msgHandler;
	    this.evaluatorOptions = evaluatorOptions;
	    this.enableXfa = enableXfa;
	    this.streamManager = new _chunked_stream.ChunkedStreamManager(pdfNetworkStream, {
	      msgHandler: args.msgHandler,
	      length: args.length,
	      disableAutoFetch: args.disableAutoFetch,
	      rangeChunkSize: args.rangeChunkSize
	    });
	    this.pdfDocument = new _document.PDFDocument(this, this.streamManager.getStream());
	  }

	  async ensure(obj, prop, args) {
	    try {
	      const value = obj[prop];

	      if (typeof value === "function") {
	        return value.apply(obj, args);
	      }

	      return value;
	    } catch (ex) {
	      if (!(ex instanceof _core_utils.MissingDataException)) {
	        throw ex;
	      }

	      await this.requestRange(ex.begin, ex.end);
	      return this.ensure(obj, prop, args);
	    }
	  }

	  requestRange(begin, end) {
	    return this.streamManager.requestRange(begin, end);
	  }

	  requestLoadedStream() {
	    this.streamManager.requestAllChunks();
	  }

	  sendProgressiveData(chunk) {
	    this.streamManager.onReceiveData({
	      chunk
	    });
	  }

	  onLoadedStream() {
	    return this.streamManager.onLoadedStream();
	  }

	  terminate(reason) {
	    this.streamManager.abort(reason);
	  }

	}

	exports.NetworkPdfManager = NetworkPdfManager;

	/***/ }),
	/* 9 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ChunkedStreamManager = exports.ChunkedStream = void 0;

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	var _stream = __w_pdfjs_require__(10);

	class ChunkedStream extends _stream.Stream {
	  constructor(length, chunkSize, manager) {
	    super(new Uint8Array(length), 0, length, null);
	    this.chunkSize = chunkSize;
	    this._loadedChunks = new Set();
	    this.numChunks = Math.ceil(length / chunkSize);
	    this.manager = manager;
	    this.progressiveDataLength = 0;
	    this.lastSuccessfulEnsureByteChunk = -1;
	  }

	  getMissingChunks() {
	    const chunks = [];

	    for (let chunk = 0, n = this.numChunks; chunk < n; ++chunk) {
	      if (!this._loadedChunks.has(chunk)) {
	        chunks.push(chunk);
	      }
	    }

	    return chunks;
	  }

	  get numChunksLoaded() {
	    return this._loadedChunks.size;
	  }

	  get isDataLoaded() {
	    return this.numChunksLoaded === this.numChunks;
	  }

	  onReceiveData(begin, chunk) {
	    const chunkSize = this.chunkSize;

	    if (begin % chunkSize !== 0) {
	      throw new Error(`Bad begin offset: ${begin}`);
	    }

	    const end = begin + chunk.byteLength;

	    if (end % chunkSize !== 0 && end !== this.bytes.length) {
	      throw new Error(`Bad end offset: ${end}`);
	    }

	    this.bytes.set(new Uint8Array(chunk), begin);
	    const beginChunk = Math.floor(begin / chunkSize);
	    const endChunk = Math.floor((end - 1) / chunkSize) + 1;

	    for (let curChunk = beginChunk; curChunk < endChunk; ++curChunk) {
	      this._loadedChunks.add(curChunk);
	    }
	  }

	  onReceiveProgressiveData(data) {
	    let position = this.progressiveDataLength;
	    const beginChunk = Math.floor(position / this.chunkSize);
	    this.bytes.set(new Uint8Array(data), position);
	    position += data.byteLength;
	    this.progressiveDataLength = position;
	    const endChunk = position >= this.end ? this.numChunks : Math.floor(position / this.chunkSize);

	    for (let curChunk = beginChunk; curChunk < endChunk; ++curChunk) {
	      this._loadedChunks.add(curChunk);
	    }
	  }

	  ensureByte(pos) {
	    if (pos < this.progressiveDataLength) {
	      return;
	    }

	    const chunk = Math.floor(pos / this.chunkSize);

	    if (chunk > this.numChunks) {
	      return;
	    }

	    if (chunk === this.lastSuccessfulEnsureByteChunk) {
	      return;
	    }

	    if (!this._loadedChunks.has(chunk)) {
	      throw new _core_utils.MissingDataException(pos, pos + 1);
	    }

	    this.lastSuccessfulEnsureByteChunk = chunk;
	  }

	  ensureRange(begin, end) {
	    if (begin >= end) {
	      return;
	    }

	    if (end <= this.progressiveDataLength) {
	      return;
	    }

	    const beginChunk = Math.floor(begin / this.chunkSize);

	    if (beginChunk > this.numChunks) {
	      return;
	    }

	    const endChunk = Math.min(Math.floor((end - 1) / this.chunkSize) + 1, this.numChunks);

	    for (let chunk = beginChunk; chunk < endChunk; ++chunk) {
	      if (!this._loadedChunks.has(chunk)) {
	        throw new _core_utils.MissingDataException(begin, end);
	      }
	    }
	  }

	  nextEmptyChunk(beginChunk) {
	    const numChunks = this.numChunks;

	    for (let i = 0; i < numChunks; ++i) {
	      const chunk = (beginChunk + i) % numChunks;

	      if (!this._loadedChunks.has(chunk)) {
	        return chunk;
	      }
	    }

	    return null;
	  }

	  hasChunk(chunk) {
	    return this._loadedChunks.has(chunk);
	  }

	  getByte() {
	    const pos = this.pos;

	    if (pos >= this.end) {
	      return -1;
	    }

	    if (pos >= this.progressiveDataLength) {
	      this.ensureByte(pos);
	    }

	    return this.bytes[this.pos++];
	  }

	  getBytes(length) {
	    const bytes = this.bytes;
	    const pos = this.pos;
	    const strEnd = this.end;

	    if (!length) {
	      if (strEnd > this.progressiveDataLength) {
	        this.ensureRange(pos, strEnd);
	      }

	      return bytes.subarray(pos, strEnd);
	    }

	    let end = pos + length;

	    if (end > strEnd) {
	      end = strEnd;
	    }

	    if (end > this.progressiveDataLength) {
	      this.ensureRange(pos, end);
	    }

	    this.pos = end;
	    return bytes.subarray(pos, end);
	  }

	  getByteRange(begin, end) {
	    if (begin < 0) {
	      begin = 0;
	    }

	    if (end > this.end) {
	      end = this.end;
	    }

	    if (end > this.progressiveDataLength) {
	      this.ensureRange(begin, end);
	    }

	    return this.bytes.subarray(begin, end);
	  }

	  makeSubStream(start, length, dict = null) {
	    if (length) {
	      if (start + length > this.progressiveDataLength) {
	        this.ensureRange(start, start + length);
	      }
	    } else {
	      if (start >= this.progressiveDataLength) {
	        this.ensureByte(start);
	      }
	    }

	    function ChunkedStreamSubstream() {}

	    ChunkedStreamSubstream.prototype = Object.create(this);

	    ChunkedStreamSubstream.prototype.getMissingChunks = function () {
	      const chunkSize = this.chunkSize;
	      const beginChunk = Math.floor(this.start / chunkSize);
	      const endChunk = Math.floor((this.end - 1) / chunkSize) + 1;
	      const missingChunks = [];

	      for (let chunk = beginChunk; chunk < endChunk; ++chunk) {
	        if (!this._loadedChunks.has(chunk)) {
	          missingChunks.push(chunk);
	        }
	      }

	      return missingChunks;
	    };

	    Object.defineProperty(ChunkedStreamSubstream.prototype, "isDataLoaded", {
	      get() {
	        if (this.numChunksLoaded === this.numChunks) {
	          return true;
	        }

	        return this.getMissingChunks().length === 0;
	      },

	      configurable: true
	    });
	    const subStream = new ChunkedStreamSubstream();
	    subStream.pos = subStream.start = start;
	    subStream.end = start + length || this.end;
	    subStream.dict = dict;
	    return subStream;
	  }

	  getBaseStreams() {
	    return [this];
	  }

	}

	exports.ChunkedStream = ChunkedStream;

	class ChunkedStreamManager {
	  constructor(pdfNetworkStream, args) {
	    this.length = args.length;
	    this.chunkSize = args.rangeChunkSize;
	    this.stream = new ChunkedStream(this.length, this.chunkSize, this);
	    this.pdfNetworkStream = pdfNetworkStream;
	    this.disableAutoFetch = args.disableAutoFetch;
	    this.msgHandler = args.msgHandler;
	    this.currRequestId = 0;
	    this._chunksNeededByRequest = new Map();
	    this._requestsByChunk = new Map();
	    this._promisesByRequest = new Map();
	    this.progressiveDataLength = 0;
	    this.aborted = false;
	    this._loadedStreamCapability = (0, _util.createPromiseCapability)();
	  }

	  onLoadedStream() {
	    return this._loadedStreamCapability.promise;
	  }

	  sendRequest(begin, end) {
	    const rangeReader = this.pdfNetworkStream.getRangeReader(begin, end);

	    if (!rangeReader.isStreamingSupported) {
	      rangeReader.onProgress = this.onProgress.bind(this);
	    }

	    let chunks = [],
	        loaded = 0;
	    return new Promise((resolve, reject) => {
	      const readChunk = chunk => {
	        try {
	          if (!chunk.done) {
	            const data = chunk.value;
	            chunks.push(data);
	            loaded += (0, _util.arrayByteLength)(data);

	            if (rangeReader.isStreamingSupported) {
	              this.onProgress({
	                loaded
	              });
	            }

	            rangeReader.read().then(readChunk, reject);
	            return;
	          }

	          const chunkData = (0, _util.arraysToBytes)(chunks);
	          chunks = null;
	          resolve(chunkData);
	        } catch (e) {
	          reject(e);
	        }
	      };

	      rangeReader.read().then(readChunk, reject);
	    }).then(data => {
	      if (this.aborted) {
	        return;
	      }

	      this.onReceiveData({
	        chunk: data,
	        begin
	      });
	    });
	  }

	  requestAllChunks() {
	    const missingChunks = this.stream.getMissingChunks();

	    this._requestChunks(missingChunks);

	    return this._loadedStreamCapability.promise;
	  }

	  _requestChunks(chunks) {
	    const requestId = this.currRequestId++;
	    const chunksNeeded = new Set();

	    this._chunksNeededByRequest.set(requestId, chunksNeeded);

	    for (const chunk of chunks) {
	      if (!this.stream.hasChunk(chunk)) {
	        chunksNeeded.add(chunk);
	      }
	    }

	    if (chunksNeeded.size === 0) {
	      return Promise.resolve();
	    }

	    const capability = (0, _util.createPromiseCapability)();

	    this._promisesByRequest.set(requestId, capability);

	    const chunksToRequest = [];

	    for (const chunk of chunksNeeded) {
	      let requestIds = this._requestsByChunk.get(chunk);

	      if (!requestIds) {
	        requestIds = [];

	        this._requestsByChunk.set(chunk, requestIds);

	        chunksToRequest.push(chunk);
	      }

	      requestIds.push(requestId);
	    }

	    if (chunksToRequest.length > 0) {
	      const groupedChunksToRequest = this.groupChunks(chunksToRequest);

	      for (const groupedChunk of groupedChunksToRequest) {
	        const begin = groupedChunk.beginChunk * this.chunkSize;
	        const end = Math.min(groupedChunk.endChunk * this.chunkSize, this.length);
	        this.sendRequest(begin, end).catch(capability.reject);
	      }
	    }

	    return capability.promise.catch(reason => {
	      if (this.aborted) {
	        return;
	      }

	      throw reason;
	    });
	  }

	  getStream() {
	    return this.stream;
	  }

	  requestRange(begin, end) {
	    end = Math.min(end, this.length);
	    const beginChunk = this.getBeginChunk(begin);
	    const endChunk = this.getEndChunk(end);
	    const chunks = [];

	    for (let chunk = beginChunk; chunk < endChunk; ++chunk) {
	      chunks.push(chunk);
	    }

	    return this._requestChunks(chunks);
	  }

	  requestRanges(ranges = []) {
	    const chunksToRequest = [];

	    for (const range of ranges) {
	      const beginChunk = this.getBeginChunk(range.begin);
	      const endChunk = this.getEndChunk(range.end);

	      for (let chunk = beginChunk; chunk < endChunk; ++chunk) {
	        if (!chunksToRequest.includes(chunk)) {
	          chunksToRequest.push(chunk);
	        }
	      }
	    }

	    chunksToRequest.sort(function (a, b) {
	      return a - b;
	    });
	    return this._requestChunks(chunksToRequest);
	  }

	  groupChunks(chunks) {
	    const groupedChunks = [];
	    let beginChunk = -1;
	    let prevChunk = -1;

	    for (let i = 0, ii = chunks.length; i < ii; ++i) {
	      const chunk = chunks[i];

	      if (beginChunk < 0) {
	        beginChunk = chunk;
	      }

	      if (prevChunk >= 0 && prevChunk + 1 !== chunk) {
	        groupedChunks.push({
	          beginChunk,
	          endChunk: prevChunk + 1
	        });
	        beginChunk = chunk;
	      }

	      if (i + 1 === chunks.length) {
	        groupedChunks.push({
	          beginChunk,
	          endChunk: chunk + 1
	        });
	      }

	      prevChunk = chunk;
	    }

	    return groupedChunks;
	  }

	  onProgress(args) {
	    this.msgHandler.send("DocProgress", {
	      loaded: this.stream.numChunksLoaded * this.chunkSize + args.loaded,
	      total: this.length
	    });
	  }

	  onReceiveData(args) {
	    const chunk = args.chunk;
	    const isProgressive = args.begin === undefined;
	    const begin = isProgressive ? this.progressiveDataLength : args.begin;
	    const end = begin + chunk.byteLength;
	    const beginChunk = Math.floor(begin / this.chunkSize);
	    const endChunk = end < this.length ? Math.floor(end / this.chunkSize) : Math.ceil(end / this.chunkSize);

	    if (isProgressive) {
	      this.stream.onReceiveProgressiveData(chunk);
	      this.progressiveDataLength = end;
	    } else {
	      this.stream.onReceiveData(begin, chunk);
	    }

	    if (this.stream.isDataLoaded) {
	      this._loadedStreamCapability.resolve(this.stream);
	    }

	    const loadedRequests = [];

	    for (let curChunk = beginChunk; curChunk < endChunk; ++curChunk) {
	      const requestIds = this._requestsByChunk.get(curChunk);

	      if (!requestIds) {
	        continue;
	      }

	      this._requestsByChunk.delete(curChunk);

	      for (const requestId of requestIds) {
	        const chunksNeeded = this._chunksNeededByRequest.get(requestId);

	        if (chunksNeeded.has(curChunk)) {
	          chunksNeeded.delete(curChunk);
	        }

	        if (chunksNeeded.size > 0) {
	          continue;
	        }

	        loadedRequests.push(requestId);
	      }
	    }

	    if (!this.disableAutoFetch && this._requestsByChunk.size === 0) {
	      let nextEmptyChunk;

	      if (this.stream.numChunksLoaded === 1) {
	        const lastChunk = this.stream.numChunks - 1;

	        if (!this.stream.hasChunk(lastChunk)) {
	          nextEmptyChunk = lastChunk;
	        }
	      } else {
	        nextEmptyChunk = this.stream.nextEmptyChunk(endChunk);
	      }

	      if (Number.isInteger(nextEmptyChunk)) {
	        this._requestChunks([nextEmptyChunk]);
	      }
	    }

	    for (const requestId of loadedRequests) {
	      const capability = this._promisesByRequest.get(requestId);

	      this._promisesByRequest.delete(requestId);

	      capability.resolve();
	    }

	    this.msgHandler.send("DocProgress", {
	      loaded: this.stream.numChunksLoaded * this.chunkSize,
	      total: this.length
	    });
	  }

	  onError(err) {
	    this._loadedStreamCapability.reject(err);
	  }

	  getBeginChunk(begin) {
	    return Math.floor(begin / this.chunkSize);
	  }

	  getEndChunk(end) {
	    return Math.floor((end - 1) / this.chunkSize) + 1;
	  }

	  abort(reason) {
	    this.aborted = true;

	    if (this.pdfNetworkStream) {
	      this.pdfNetworkStream.cancelAllRequests(reason);
	    }

	    for (const capability of this._promisesByRequest.values()) {
	      capability.reject(reason);
	    }
	  }

	}

	exports.ChunkedStreamManager = ChunkedStreamManager;

	/***/ }),
	/* 10 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.StringStream = exports.Stream = exports.NullStream = void 0;

	var _base_stream = __w_pdfjs_require__(7);

	var _util = __w_pdfjs_require__(2);

	class Stream extends _base_stream.BaseStream {
	  constructor(arrayBuffer, start, length, dict) {
	    super();
	    this.bytes = arrayBuffer instanceof Uint8Array ? arrayBuffer : new Uint8Array(arrayBuffer);
	    this.start = start || 0;
	    this.pos = this.start;
	    this.end = start + length || this.bytes.length;
	    this.dict = dict;
	  }

	  get length() {
	    return this.end - this.start;
	  }

	  get isEmpty() {
	    return this.length === 0;
	  }

	  getByte() {
	    if (this.pos >= this.end) {
	      return -1;
	    }

	    return this.bytes[this.pos++];
	  }

	  getBytes(length) {
	    const bytes = this.bytes;
	    const pos = this.pos;
	    const strEnd = this.end;

	    if (!length) {
	      return bytes.subarray(pos, strEnd);
	    }

	    let end = pos + length;

	    if (end > strEnd) {
	      end = strEnd;
	    }

	    this.pos = end;
	    return bytes.subarray(pos, end);
	  }

	  getByteRange(begin, end) {
	    if (begin < 0) {
	      begin = 0;
	    }

	    if (end > this.end) {
	      end = this.end;
	    }

	    return this.bytes.subarray(begin, end);
	  }

	  reset() {
	    this.pos = this.start;
	  }

	  moveStart() {
	    this.start = this.pos;
	  }

	  makeSubStream(start, length, dict = null) {
	    return new Stream(this.bytes.buffer, start, length, dict);
	  }

	}

	exports.Stream = Stream;

	class StringStream extends Stream {
	  constructor(str) {
	    super((0, _util.stringToBytes)(str));
	  }

	}

	exports.StringStream = StringStream;

	class NullStream extends Stream {
	  constructor() {
	    super(new Uint8Array(0));
	  }

	}

	exports.NullStream = NullStream;

	/***/ }),
	/* 11 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Page = exports.PDFDocument = void 0;

	var _annotation = __w_pdfjs_require__(12);

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	var _primitives = __w_pdfjs_require__(5);

	var _xfa_fonts = __w_pdfjs_require__(51);

	var _base_stream = __w_pdfjs_require__(7);

	var _crypto = __w_pdfjs_require__(67);

	var _catalog = __w_pdfjs_require__(69);

	var _cleanup_helper = __w_pdfjs_require__(71);

	var _dataset_reader = __w_pdfjs_require__(100);

	var _parser = __w_pdfjs_require__(17);

	var _stream = __w_pdfjs_require__(10);

	var _object_loader = __w_pdfjs_require__(75);

	var _operator_list = __w_pdfjs_require__(62);

	var _evaluator = __w_pdfjs_require__(15);

	var _decode_stream = __w_pdfjs_require__(19);

	var _struct_tree = __w_pdfjs_require__(74);

	var _writer = __w_pdfjs_require__(65);

	var _factory = __w_pdfjs_require__(76);

	var _xref = __w_pdfjs_require__(101);

	const DEFAULT_USER_UNIT = 1.0;
	const LETTER_SIZE_MEDIABOX = [0, 0, 612, 792];

	class Page {
	  constructor({
	    pdfManager,
	    xref,
	    pageIndex,
	    pageDict,
	    ref,
	    globalIdFactory,
	    fontCache,
	    builtInCMapCache,
	    standardFontDataCache,
	    globalImageCache,
	    nonBlendModesSet,
	    xfaFactory
	  }) {
	    this.pdfManager = pdfManager;
	    this.pageIndex = pageIndex;
	    this.pageDict = pageDict;
	    this.xref = xref;
	    this.ref = ref;
	    this.fontCache = fontCache;
	    this.builtInCMapCache = builtInCMapCache;
	    this.standardFontDataCache = standardFontDataCache;
	    this.globalImageCache = globalImageCache;
	    this.nonBlendModesSet = nonBlendModesSet;
	    this.evaluatorOptions = pdfManager.evaluatorOptions;
	    this.resourcesPromise = null;
	    this.xfaFactory = xfaFactory;
	    const idCounters = {
	      obj: 0
	    };
	    this._localIdFactory = class extends globalIdFactory {
	      static createObjId() {
	        return `p${pageIndex}_${++idCounters.obj}`;
	      }

	      static getPageObjId() {
	        return `page${ref.toString()}`;
	      }

	    };
	  }

	  _getInheritableProperty(key, getArray = false) {
	    const value = (0, _core_utils.getInheritableProperty)({
	      dict: this.pageDict,
	      key,
	      getArray,
	      stopWhenFound: false
	    });

	    if (!Array.isArray(value)) {
	      return value;
	    }

	    if (value.length === 1 || !(value[0] instanceof _primitives.Dict)) {
	      return value[0];
	    }

	    return _primitives.Dict.merge({
	      xref: this.xref,
	      dictArray: value
	    });
	  }

	  get content() {
	    return this.pageDict.getArray("Contents");
	  }

	  get resources() {
	    const resources = this._getInheritableProperty("Resources");

	    return (0, _util.shadow)(this, "resources", resources instanceof _primitives.Dict ? resources : _primitives.Dict.empty);
	  }

	  _getBoundingBox(name) {
	    if (this.xfaData) {
	      return this.xfaData.bbox;
	    }

	    const box = this._getInheritableProperty(name, true);

	    if (Array.isArray(box) && box.length === 4) {
	      if (box[2] - box[0] !== 0 && box[3] - box[1] !== 0) {
	        return box;
	      }

	      (0, _util.warn)(`Empty /${name} entry.`);
	    }

	    return null;
	  }

	  get mediaBox() {
	    return (0, _util.shadow)(this, "mediaBox", this._getBoundingBox("MediaBox") || LETTER_SIZE_MEDIABOX);
	  }

	  get cropBox() {
	    return (0, _util.shadow)(this, "cropBox", this._getBoundingBox("CropBox") || this.mediaBox);
	  }

	  get userUnit() {
	    let obj = this.pageDict.get("UserUnit");

	    if (typeof obj !== "number" || obj <= 0) {
	      obj = DEFAULT_USER_UNIT;
	    }

	    return (0, _util.shadow)(this, "userUnit", obj);
	  }

	  get view() {
	    const {
	      cropBox,
	      mediaBox
	    } = this;
	    let view;

	    if (cropBox === mediaBox || (0, _util.isArrayEqual)(cropBox, mediaBox)) {
	      view = mediaBox;
	    } else {
	      const box = _util.Util.intersect(cropBox, mediaBox);

	      if (box && box[2] - box[0] !== 0 && box[3] - box[1] !== 0) {
	        view = box;
	      } else {
	        (0, _util.warn)("Empty /CropBox and /MediaBox intersection.");
	      }
	    }

	    return (0, _util.shadow)(this, "view", view || mediaBox);
	  }

	  get rotate() {
	    let rotate = this._getInheritableProperty("Rotate") || 0;

	    if (rotate % 90 !== 0) {
	      rotate = 0;
	    } else if (rotate >= 360) {
	      rotate %= 360;
	    } else if (rotate < 0) {
	      rotate = (rotate % 360 + 360) % 360;
	    }

	    return (0, _util.shadow)(this, "rotate", rotate);
	  }

	  _onSubStreamError(handler, reason, objId) {
	    if (this.evaluatorOptions.ignoreErrors) {
	      handler.send("UnsupportedFeature", {
	        featureId: _util.UNSUPPORTED_FEATURES.errorContentSubStream
	      });
	      (0, _util.warn)(`getContentStream - ignoring sub-stream (${objId}): "${reason}".`);
	      return;
	    }

	    throw reason;
	  }

	  getContentStream(handler) {
	    return this.pdfManager.ensure(this, "content").then(content => {
	      if (content instanceof _base_stream.BaseStream) {
	        return content;
	      }

	      if (Array.isArray(content)) {
	        return new _decode_stream.StreamsSequenceStream(content, this._onSubStreamError.bind(this, handler));
	      }

	      return new _stream.NullStream();
	    });
	  }

	  get xfaData() {
	    return (0, _util.shadow)(this, "xfaData", this.xfaFactory ? {
	      bbox: this.xfaFactory.getBoundingBox(this.pageIndex)
	    } : null);
	  }

	  async saveNewAnnotations(handler, task, annotations) {
	    if (this.xfaFactory) {
	      throw new Error("XFA: Cannot save new annotations.");
	    }

	    const partialEvaluator = new _evaluator.PartialEvaluator({
	      xref: this.xref,
	      handler,
	      pageIndex: this.pageIndex,
	      idFactory: this._localIdFactory,
	      fontCache: this.fontCache,
	      builtInCMapCache: this.builtInCMapCache,
	      standardFontDataCache: this.standardFontDataCache,
	      globalImageCache: this.globalImageCache,
	      options: this.evaluatorOptions
	    });
	    const pageDict = this.pageDict;
	    const annotationsArray = this.annotations.slice();
	    const newData = await _annotation.AnnotationFactory.saveNewAnnotations(partialEvaluator, task, annotations);

	    for (const {
	      ref
	    } of newData.annotations) {
	      annotationsArray.push(ref);
	    }

	    const savedDict = pageDict.get("Annots");
	    pageDict.set("Annots", annotationsArray);
	    const buffer = [];
	    let transform = null;

	    if (this.xref.encrypt) {
	      transform = this.xref.encrypt.createCipherTransform(this.ref.num, this.ref.gen);
	    }

	    (0, _writer.writeObject)(this.ref, pageDict, buffer, transform);

	    if (savedDict) {
	      pageDict.set("Annots", savedDict);
	    }

	    const objects = newData.dependencies;
	    objects.push({
	      ref: this.ref,
	      data: buffer.join("")
	    }, ...newData.annotations);
	    return objects;
	  }

	  save(handler, task, annotationStorage) {
	    const partialEvaluator = new _evaluator.PartialEvaluator({
	      xref: this.xref,
	      handler,
	      pageIndex: this.pageIndex,
	      idFactory: this._localIdFactory,
	      fontCache: this.fontCache,
	      builtInCMapCache: this.builtInCMapCache,
	      standardFontDataCache: this.standardFontDataCache,
	      globalImageCache: this.globalImageCache,
	      options: this.evaluatorOptions
	    });
	    return this._parsedAnnotations.then(function (annotations) {
	      const newRefsPromises = [];

	      for (const annotation of annotations) {
	        if (!annotation.mustBePrinted(annotationStorage)) {
	          continue;
	        }

	        newRefsPromises.push(annotation.save(partialEvaluator, task, annotationStorage).catch(function (reason) {
	          (0, _util.warn)("save - ignoring annotation data during " + `"${task.name}" task: "${reason}".`);
	          return null;
	        }));
	      }

	      return Promise.all(newRefsPromises).then(function (newRefs) {
	        return newRefs.filter(newRef => !!newRef);
	      });
	    });
	  }

	  loadResources(keys) {
	    if (!this.resourcesPromise) {
	      this.resourcesPromise = this.pdfManager.ensure(this, "resources");
	    }

	    return this.resourcesPromise.then(() => {
	      const objectLoader = new _object_loader.ObjectLoader(this.resources, keys, this.xref);
	      return objectLoader.load();
	    });
	  }

	  getOperatorList({
	    handler,
	    sink,
	    task,
	    intent,
	    cacheKey,
	    annotationStorage = null
	  }) {
	    const contentStreamPromise = this.getContentStream(handler);
	    const resourcesPromise = this.loadResources(["ColorSpace", "ExtGState", "Font", "Pattern", "Properties", "Shading", "XObject"]);
	    const partialEvaluator = new _evaluator.PartialEvaluator({
	      xref: this.xref,
	      handler,
	      pageIndex: this.pageIndex,
	      idFactory: this._localIdFactory,
	      fontCache: this.fontCache,
	      builtInCMapCache: this.builtInCMapCache,
	      standardFontDataCache: this.standardFontDataCache,
	      globalImageCache: this.globalImageCache,
	      options: this.evaluatorOptions
	    });
	    const newAnnotationsByPage = !this.xfaFactory ? (0, _core_utils.getNewAnnotationsMap)(annotationStorage) : null;
	    let newAnnotationsPromise = Promise.resolve(null);

	    if (newAnnotationsByPage) {
	      const newAnnotations = newAnnotationsByPage.get(this.pageIndex);

	      if (newAnnotations) {
	        newAnnotationsPromise = _annotation.AnnotationFactory.printNewAnnotations(partialEvaluator, task, newAnnotations);
	      }
	    }

	    const dataPromises = Promise.all([contentStreamPromise, resourcesPromise]);
	    const pageListPromise = dataPromises.then(([contentStream]) => {
	      const opList = new _operator_list.OperatorList(intent, sink);
	      handler.send("StartRenderPage", {
	        transparency: partialEvaluator.hasBlendModes(this.resources, this.nonBlendModesSet),
	        pageIndex: this.pageIndex,
	        cacheKey
	      });
	      return partialEvaluator.getOperatorList({
	        stream: contentStream,
	        task,
	        resources: this.resources,
	        operatorList: opList
	      }).then(function () {
	        return opList;
	      });
	    });
	    return Promise.all([pageListPromise, this._parsedAnnotations, newAnnotationsPromise]).then(function ([pageOpList, annotations, newAnnotations]) {
	      if (newAnnotations) {
	        annotations = annotations.concat(newAnnotations);
	      }

	      if (annotations.length === 0 || intent & _util.RenderingIntentFlag.ANNOTATIONS_DISABLE) {
	        pageOpList.flush(true);
	        return {
	          length: pageOpList.totalLength
	        };
	      }

	      const renderForms = !!(intent & _util.RenderingIntentFlag.ANNOTATIONS_FORMS),
	            intentAny = !!(intent & _util.RenderingIntentFlag.ANY),
	            intentDisplay = !!(intent & _util.RenderingIntentFlag.DISPLAY),
	            intentPrint = !!(intent & _util.RenderingIntentFlag.PRINT);
	      const opListPromises = [];

	      for (const annotation of annotations) {
	        if (intentAny || intentDisplay && annotation.mustBeViewed(annotationStorage) || intentPrint && annotation.mustBePrinted(annotationStorage)) {
	          opListPromises.push(annotation.getOperatorList(partialEvaluator, task, intent, renderForms, annotationStorage).catch(function (reason) {
	            (0, _util.warn)("getOperatorList - ignoring annotation data during " + `"${task.name}" task: "${reason}".`);
	            return null;
	          }));
	        }
	      }

	      return Promise.all(opListPromises).then(function (opLists) {
	        let form = false,
	            canvas = false;

	        for (const {
	          opList,
	          separateForm,
	          separateCanvas
	        } of opLists) {
	          pageOpList.addOpList(opList);

	          if (separateForm) {
	            form = separateForm;
	          }

	          if (separateCanvas) {
	            canvas = separateCanvas;
	          }
	        }

	        pageOpList.flush(true, {
	          form,
	          canvas
	        });
	        return {
	          length: pageOpList.totalLength
	        };
	      });
	    });
	  }

	  extractTextContent({
	    handler,
	    task,
	    includeMarkedContent,
	    sink,
	    combineTextItems
	  }) {
	    const contentStreamPromise = this.getContentStream(handler);
	    const resourcesPromise = this.loadResources(["ExtGState", "Font", "Properties", "XObject"]);
	    const dataPromises = Promise.all([contentStreamPromise, resourcesPromise]);
	    return dataPromises.then(([contentStream]) => {
	      const partialEvaluator = new _evaluator.PartialEvaluator({
	        xref: this.xref,
	        handler,
	        pageIndex: this.pageIndex,
	        idFactory: this._localIdFactory,
	        fontCache: this.fontCache,
	        builtInCMapCache: this.builtInCMapCache,
	        standardFontDataCache: this.standardFontDataCache,
	        globalImageCache: this.globalImageCache,
	        options: this.evaluatorOptions
	      });
	      return partialEvaluator.getTextContent({
	        stream: contentStream,
	        task,
	        resources: this.resources,
	        includeMarkedContent,
	        combineTextItems,
	        sink,
	        viewBox: this.view
	      });
	    });
	  }

	  async getStructTree() {
	    const structTreeRoot = await this.pdfManager.ensureCatalog("structTreeRoot");

	    if (!structTreeRoot) {
	      return null;
	    }

	    const structTree = await this.pdfManager.ensure(this, "_parseStructTree", [structTreeRoot]);
	    return structTree.serializable;
	  }

	  _parseStructTree(structTreeRoot) {
	    const tree = new _struct_tree.StructTreePage(structTreeRoot, this.pageDict);
	    tree.parse();
	    return tree;
	  }

	  async getAnnotationsData(handler, task, intent) {
	    const annotations = await this._parsedAnnotations;

	    if (annotations.length === 0) {
	      return [];
	    }

	    const textContentPromises = [];
	    const annotationsData = [];
	    let partialEvaluator;
	    const intentAny = !!(intent & _util.RenderingIntentFlag.ANY),
	          intentDisplay = !!(intent & _util.RenderingIntentFlag.DISPLAY),
	          intentPrint = !!(intent & _util.RenderingIntentFlag.PRINT);

	    for (const annotation of annotations) {
	      const isVisible = intentAny || intentDisplay && annotation.viewable;

	      if (isVisible || intentPrint && annotation.printable) {
	        annotationsData.push(annotation.data);
	      }

	      if (annotation.hasTextContent && isVisible) {
	        if (!partialEvaluator) {
	          partialEvaluator = new _evaluator.PartialEvaluator({
	            xref: this.xref,
	            handler,
	            pageIndex: this.pageIndex,
	            idFactory: this._localIdFactory,
	            fontCache: this.fontCache,
	            builtInCMapCache: this.builtInCMapCache,
	            standardFontDataCache: this.standardFontDataCache,
	            globalImageCache: this.globalImageCache,
	            options: this.evaluatorOptions
	          });
	        }

	        textContentPromises.push(annotation.extractTextContent(partialEvaluator, task, this.view).catch(function (reason) {
	          (0, _util.warn)(`getAnnotationsData - ignoring textContent during "${task.name}" task: "${reason}".`);
	        }));
	      }
	    }

	    await Promise.all(textContentPromises);
	    return annotationsData;
	  }

	  get annotations() {
	    const annots = this._getInheritableProperty("Annots");

	    return (0, _util.shadow)(this, "annotations", Array.isArray(annots) ? annots : []);
	  }

	  get _parsedAnnotations() {
	    const parsedAnnotations = this.pdfManager.ensure(this, "annotations").then(() => {
	      const annotationPromises = [];

	      for (const annotationRef of this.annotations) {
	        annotationPromises.push(_annotation.AnnotationFactory.create(this.xref, annotationRef, this.pdfManager, this._localIdFactory, false).catch(function (reason) {
	          (0, _util.warn)(`_parsedAnnotations: "${reason}".`);
	          return null;
	        }));
	      }

	      return Promise.all(annotationPromises).then(function (annotations) {
	        if (annotations.length === 0) {
	          return annotations;
	        }

	        const sortedAnnotations = [];
	        let popupAnnotations;

	        for (const annotation of annotations) {
	          if (!annotation) {
	            continue;
	          }

	          if (annotation instanceof _annotation.PopupAnnotation) {
	            if (!popupAnnotations) {
	              popupAnnotations = [];
	            }

	            popupAnnotations.push(annotation);
	            continue;
	          }

	          sortedAnnotations.push(annotation);
	        }

	        if (popupAnnotations) {
	          sortedAnnotations.push(...popupAnnotations);
	        }

	        return sortedAnnotations;
	      });
	    });
	    return (0, _util.shadow)(this, "_parsedAnnotations", parsedAnnotations);
	  }

	  get jsActions() {
	    const actions = (0, _core_utils.collectActions)(this.xref, this.pageDict, _util.PageActionEventType);
	    return (0, _util.shadow)(this, "jsActions", actions);
	  }

	}

	exports.Page = Page;
	const PDF_HEADER_SIGNATURE = new Uint8Array([0x25, 0x50, 0x44, 0x46, 0x2d]);
	const STARTXREF_SIGNATURE = new Uint8Array([0x73, 0x74, 0x61, 0x72, 0x74, 0x78, 0x72, 0x65, 0x66]);
	const ENDOBJ_SIGNATURE = new Uint8Array([0x65, 0x6e, 0x64, 0x6f, 0x62, 0x6a]);
	const FINGERPRINT_FIRST_BYTES = 1024;
	const EMPTY_FINGERPRINT = "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00";
	const PDF_HEADER_VERSION_REGEXP = /^[1-9]\.\d$/;

	function find(stream, signature, limit = 1024, backwards = false) {
	  const signatureLength = signature.length;
	  const scanBytes = stream.peekBytes(limit);
	  const scanLength = scanBytes.length - signatureLength;

	  if (scanLength <= 0) {
	    return false;
	  }

	  if (backwards) {
	    const signatureEnd = signatureLength - 1;
	    let pos = scanBytes.length - 1;

	    while (pos >= signatureEnd) {
	      let j = 0;

	      while (j < signatureLength && scanBytes[pos - j] === signature[signatureEnd - j]) {
	        j++;
	      }

	      if (j >= signatureLength) {
	        stream.pos += pos - signatureEnd;
	        return true;
	      }

	      pos--;
	    }
	  } else {
	    let pos = 0;

	    while (pos <= scanLength) {
	      let j = 0;

	      while (j < signatureLength && scanBytes[pos + j] === signature[j]) {
	        j++;
	      }

	      if (j >= signatureLength) {
	        stream.pos += pos;
	        return true;
	      }

	      pos++;
	    }
	  }

	  return false;
	}

	class PDFDocument {
	  constructor(pdfManager, stream) {
	    if (stream.length <= 0) {
	      throw new _util.InvalidPDFException("The PDF file is empty, i.e. its size is zero bytes.");
	    }

	    this.pdfManager = pdfManager;
	    this.stream = stream;
	    this.xref = new _xref.XRef(stream, pdfManager);
	    this._pagePromises = new Map();
	    this._version = null;
	    const idCounters = {
	      font: 0
	    };
	    this._globalIdFactory = class {
	      static getDocId() {
	        return `g_${pdfManager.docId}`;
	      }

	      static createFontId() {
	        return `f${++idCounters.font}`;
	      }

	      static createObjId() {
	        (0, _util.unreachable)("Abstract method `createObjId` called.");
	      }

	      static getPageObjId() {
	        (0, _util.unreachable)("Abstract method `getPageObjId` called.");
	      }

	    };
	  }

	  parse(recoveryMode) {
	    this.xref.parse(recoveryMode);
	    this.catalog = new _catalog.Catalog(this.pdfManager, this.xref);

	    if (this.catalog.version) {
	      this._version = this.catalog.version;
	    }
	  }

	  get linearization() {
	    let linearization = null;

	    try {
	      linearization = _parser.Linearization.create(this.stream);
	    } catch (err) {
	      if (err instanceof _core_utils.MissingDataException) {
	        throw err;
	      }

	      (0, _util.info)(err);
	    }

	    return (0, _util.shadow)(this, "linearization", linearization);
	  }

	  get startXRef() {
	    const stream = this.stream;
	    let startXRef = 0;

	    if (this.linearization) {
	      stream.reset();

	      if (find(stream, ENDOBJ_SIGNATURE)) {
	        startXRef = stream.pos + 6 - stream.start;
	      }
	    } else {
	      const step = 1024;
	      const startXRefLength = STARTXREF_SIGNATURE.length;
	      let found = false,
	          pos = stream.end;

	      while (!found && pos > 0) {
	        pos -= step - startXRefLength;

	        if (pos < 0) {
	          pos = 0;
	        }

	        stream.pos = pos;
	        found = find(stream, STARTXREF_SIGNATURE, step, true);
	      }

	      if (found) {
	        stream.skip(9);
	        let ch;

	        do {
	          ch = stream.getByte();
	        } while ((0, _core_utils.isWhiteSpace)(ch));

	        let str = "";

	        while (ch >= 0x20 && ch <= 0x39) {
	          str += String.fromCharCode(ch);
	          ch = stream.getByte();
	        }

	        startXRef = parseInt(str, 10);

	        if (isNaN(startXRef)) {
	          startXRef = 0;
	        }
	      }
	    }

	    return (0, _util.shadow)(this, "startXRef", startXRef);
	  }

	  checkHeader() {
	    const stream = this.stream;
	    stream.reset();

	    if (!find(stream, PDF_HEADER_SIGNATURE)) {
	      return;
	    }

	    stream.moveStart();
	    const MAX_PDF_VERSION_LENGTH = 12;
	    let version = "",
	        ch;

	    while ((ch = stream.getByte()) > 0x20) {
	      if (version.length >= MAX_PDF_VERSION_LENGTH) {
	        break;
	      }

	      version += String.fromCharCode(ch);
	    }

	    if (!this._version) {
	      this._version = version.substring(5);
	    }
	  }

	  parseStartXRef() {
	    this.xref.setStartXRef(this.startXRef);
	  }

	  get numPages() {
	    let num = 0;

	    if (this.catalog.hasActualNumPages) {
	      num = this.catalog.numPages;
	    } else if (this.xfaFactory) {
	      num = this.xfaFactory.getNumPages();
	    } else if (this.linearization) {
	      num = this.linearization.numPages;
	    } else {
	      num = this.catalog.numPages;
	    }

	    return (0, _util.shadow)(this, "numPages", num);
	  }

	  _hasOnlyDocumentSignatures(fields, recursionDepth = 0) {
	    const RECURSION_LIMIT = 10;

	    if (!Array.isArray(fields)) {
	      return false;
	    }

	    return fields.every(field => {
	      field = this.xref.fetchIfRef(field);

	      if (!(field instanceof _primitives.Dict)) {
	        return false;
	      }

	      if (field.has("Kids")) {
	        if (++recursionDepth > RECURSION_LIMIT) {
	          (0, _util.warn)("_hasOnlyDocumentSignatures: maximum recursion depth reached");
	          return false;
	        }

	        return this._hasOnlyDocumentSignatures(field.get("Kids"), recursionDepth);
	      }

	      const isSignature = (0, _primitives.isName)(field.get("FT"), "Sig");
	      const rectangle = field.get("Rect");
	      const isInvisible = Array.isArray(rectangle) && rectangle.every(value => value === 0);
	      return isSignature && isInvisible;
	    });
	  }

	  get _xfaStreams() {
	    const acroForm = this.catalog.acroForm;

	    if (!acroForm) {
	      return null;
	    }

	    const xfa = acroForm.get("XFA");
	    const entries = {
	      "xdp:xdp": "",
	      template: "",
	      datasets: "",
	      config: "",
	      connectionSet: "",
	      localeSet: "",
	      stylesheet: "",
	      "/xdp:xdp": ""
	    };

	    if (xfa instanceof _base_stream.BaseStream && !xfa.isEmpty) {
	      entries["xdp:xdp"] = xfa;
	      return entries;
	    }

	    if (!Array.isArray(xfa) || xfa.length === 0) {
	      return null;
	    }

	    for (let i = 0, ii = xfa.length; i < ii; i += 2) {
	      let name;

	      if (i === 0) {
	        name = "xdp:xdp";
	      } else if (i === ii - 2) {
	        name = "/xdp:xdp";
	      } else {
	        name = xfa[i];
	      }

	      if (!entries.hasOwnProperty(name)) {
	        continue;
	      }

	      const data = this.xref.fetchIfRef(xfa[i + 1]);

	      if (!(data instanceof _base_stream.BaseStream) || data.isEmpty) {
	        continue;
	      }

	      entries[name] = data;
	    }

	    return entries;
	  }

	  get xfaDatasets() {
	    const streams = this._xfaStreams;

	    if (!streams) {
	      return (0, _util.shadow)(this, "xfaDatasets", null);
	    }

	    for (const key of ["datasets", "xdp:xdp"]) {
	      const stream = streams[key];

	      if (!stream) {
	        continue;
	      }

	      try {
	        const str = (0, _util.stringToUTF8String)(stream.getString());
	        const data = {
	          [key]: str
	        };
	        return (0, _util.shadow)(this, "xfaDatasets", new _dataset_reader.DatasetReader(data));
	      } catch (_) {
	        (0, _util.warn)("XFA - Invalid utf-8 string.");
	        break;
	      }
	    }

	    return (0, _util.shadow)(this, "xfaDatasets", null);
	  }

	  get xfaData() {
	    const streams = this._xfaStreams;

	    if (!streams) {
	      return null;
	    }

	    const data = Object.create(null);

	    for (const [key, stream] of Object.entries(streams)) {
	      if (!stream) {
	        continue;
	      }

	      try {
	        data[key] = (0, _util.stringToUTF8String)(stream.getString());
	      } catch (_) {
	        (0, _util.warn)("XFA - Invalid utf-8 string.");
	        return null;
	      }
	    }

	    return data;
	  }

	  get xfaFactory() {
	    let data;

	    if (this.pdfManager.enableXfa && this.catalog.needsRendering && this.formInfo.hasXfa && !this.formInfo.hasAcroForm) {
	      data = this.xfaData;
	    }

	    return (0, _util.shadow)(this, "xfaFactory", data ? new _factory.XFAFactory(data) : null);
	  }

	  get isPureXfa() {
	    return this.xfaFactory ? this.xfaFactory.isValid() : false;
	  }

	  get htmlForXfa() {
	    return this.xfaFactory ? this.xfaFactory.getPages() : null;
	  }

	  async loadXfaImages() {
	    const xfaImagesDict = await this.pdfManager.ensureCatalog("xfaImages");

	    if (!xfaImagesDict) {
	      return;
	    }

	    const keys = xfaImagesDict.getKeys();
	    const objectLoader = new _object_loader.ObjectLoader(xfaImagesDict, keys, this.xref);
	    await objectLoader.load();
	    const xfaImages = new Map();

	    for (const key of keys) {
	      const stream = xfaImagesDict.get(key);

	      if (stream instanceof _base_stream.BaseStream) {
	        xfaImages.set(key, stream.getBytes());
	      }
	    }

	    this.xfaFactory.setImages(xfaImages);
	  }

	  async loadXfaFonts(handler, task) {
	    const acroForm = await this.pdfManager.ensureCatalog("acroForm");

	    if (!acroForm) {
	      return;
	    }

	    const resources = await acroForm.getAsync("DR");

	    if (!(resources instanceof _primitives.Dict)) {
	      return;
	    }

	    const objectLoader = new _object_loader.ObjectLoader(resources, ["Font"], this.xref);
	    await objectLoader.load();
	    const fontRes = resources.get("Font");

	    if (!(fontRes instanceof _primitives.Dict)) {
	      return;
	    }

	    const options = Object.assign(Object.create(null), this.pdfManager.evaluatorOptions);
	    options.useSystemFonts = false;
	    const partialEvaluator = new _evaluator.PartialEvaluator({
	      xref: this.xref,
	      handler,
	      pageIndex: -1,
	      idFactory: this._globalIdFactory,
	      fontCache: this.catalog.fontCache,
	      builtInCMapCache: this.catalog.builtInCMapCache,
	      standardFontDataCache: this.catalog.standardFontDataCache,
	      options
	    });
	    const operatorList = new _operator_list.OperatorList();
	    const pdfFonts = [];
	    const initialState = {
	      get font() {
	        return pdfFonts.at(-1);
	      },

	      set font(font) {
	        pdfFonts.push(font);
	      },

	      clone() {
	        return this;
	      }

	    };
	    const fonts = new Map();
	    fontRes.forEach((fontName, font) => {
	      fonts.set(fontName, font);
	    });
	    const promises = [];

	    for (const [fontName, font] of fonts) {
	      const descriptor = font.get("FontDescriptor");

	      if (!(descriptor instanceof _primitives.Dict)) {
	        continue;
	      }

	      let fontFamily = descriptor.get("FontFamily");
	      fontFamily = fontFamily.replace(/[ ]+(\d)/g, "$1");
	      const fontWeight = descriptor.get("FontWeight");
	      const italicAngle = -descriptor.get("ItalicAngle");
	      const cssFontInfo = {
	        fontFamily,
	        fontWeight,
	        italicAngle
	      };

	      if (!(0, _core_utils.validateCSSFont)(cssFontInfo)) {
	        continue;
	      }

	      promises.push(partialEvaluator.handleSetFont(resources, [_primitives.Name.get(fontName), 1], null, operatorList, task, initialState, null, cssFontInfo).catch(function (reason) {
	        (0, _util.warn)(`loadXfaFonts: "${reason}".`);
	        return null;
	      }));
	    }

	    await Promise.all(promises);
	    const missingFonts = this.xfaFactory.setFonts(pdfFonts);

	    if (!missingFonts) {
	      return;
	    }

	    options.ignoreErrors = true;
	    promises.length = 0;
	    pdfFonts.length = 0;
	    const reallyMissingFonts = new Set();

	    for (const missing of missingFonts) {
	      if (!(0, _xfa_fonts.getXfaFontName)(`${missing}-Regular`)) {
	        reallyMissingFonts.add(missing);
	      }
	    }

	    if (reallyMissingFonts.size) {
	      missingFonts.push("PdfJS-Fallback");
	    }

	    for (const missing of missingFonts) {
	      if (reallyMissingFonts.has(missing)) {
	        continue;
	      }

	      for (const fontInfo of [{
	        name: "Regular",
	        fontWeight: 400,
	        italicAngle: 0
	      }, {
	        name: "Bold",
	        fontWeight: 700,
	        italicAngle: 0
	      }, {
	        name: "Italic",
	        fontWeight: 400,
	        italicAngle: 12
	      }, {
	        name: "BoldItalic",
	        fontWeight: 700,
	        italicAngle: 12
	      }]) {
	        const name = `${missing}-${fontInfo.name}`;
	        const dict = (0, _xfa_fonts.getXfaFontDict)(name);
	        promises.push(partialEvaluator.handleSetFont(resources, [_primitives.Name.get(name), 1], null, operatorList, task, initialState, dict, {
	          fontFamily: missing,
	          fontWeight: fontInfo.fontWeight,
	          italicAngle: fontInfo.italicAngle
	        }).catch(function (reason) {
	          (0, _util.warn)(`loadXfaFonts: "${reason}".`);
	          return null;
	        }));
	      }
	    }

	    await Promise.all(promises);
	    this.xfaFactory.appendFonts(pdfFonts, reallyMissingFonts);
	  }

	  async serializeXfaData(annotationStorage) {
	    return this.xfaFactory ? this.xfaFactory.serializeData(annotationStorage) : null;
	  }

	  get formInfo() {
	    const formInfo = {
	      hasFields: false,
	      hasAcroForm: false,
	      hasXfa: false,
	      hasSignatures: false
	    };
	    const acroForm = this.catalog.acroForm;

	    if (!acroForm) {
	      return (0, _util.shadow)(this, "formInfo", formInfo);
	    }

	    try {
	      const fields = acroForm.get("Fields");
	      const hasFields = Array.isArray(fields) && fields.length > 0;
	      formInfo.hasFields = hasFields;
	      const xfa = acroForm.get("XFA");
	      formInfo.hasXfa = Array.isArray(xfa) && xfa.length > 0 || xfa instanceof _base_stream.BaseStream && !xfa.isEmpty;
	      const sigFlags = acroForm.get("SigFlags");
	      const hasSignatures = !!(sigFlags & 0x1);

	      const hasOnlyDocumentSignatures = hasSignatures && this._hasOnlyDocumentSignatures(fields);

	      formInfo.hasAcroForm = hasFields && !hasOnlyDocumentSignatures;
	      formInfo.hasSignatures = hasSignatures;
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)(`Cannot fetch form information: "${ex}".`);
	    }

	    return (0, _util.shadow)(this, "formInfo", formInfo);
	  }

	  get documentInfo() {
	    let version = this._version;

	    if (typeof version !== "string" || !PDF_HEADER_VERSION_REGEXP.test(version)) {
	      (0, _util.warn)(`Invalid PDF header version number: ${version}`);
	      version = null;
	    }

	    const docInfo = {
	      PDFFormatVersion: version,
	      Language: this.catalog.lang,
	      EncryptFilterName: this.xref.encrypt ? this.xref.encrypt.filterName : null,
	      IsLinearized: !!this.linearization,
	      IsAcroFormPresent: this.formInfo.hasAcroForm,
	      IsXFAPresent: this.formInfo.hasXfa,
	      IsCollectionPresent: !!this.catalog.collection,
	      IsSignaturesPresent: this.formInfo.hasSignatures
	    };
	    let infoDict;

	    try {
	      infoDict = this.xref.trailer.get("Info");
	    } catch (err) {
	      if (err instanceof _core_utils.MissingDataException) {
	        throw err;
	      }

	      (0, _util.info)("The document information dictionary is invalid.");
	    }

	    if (!(infoDict instanceof _primitives.Dict)) {
	      return (0, _util.shadow)(this, "documentInfo", docInfo);
	    }

	    for (const key of infoDict.getKeys()) {
	      const value = infoDict.get(key);

	      switch (key) {
	        case "Title":
	        case "Author":
	        case "Subject":
	        case "Keywords":
	        case "Creator":
	        case "Producer":
	        case "CreationDate":
	        case "ModDate":
	          if (typeof value === "string") {
	            docInfo[key] = (0, _util.stringToPDFString)(value);
	            continue;
	          }

	          break;

	        case "Trapped":
	          if (value instanceof _primitives.Name) {
	            docInfo[key] = value;
	            continue;
	          }

	          break;

	        default:
	          let customValue;

	          switch (typeof value) {
	            case "string":
	              customValue = (0, _util.stringToPDFString)(value);
	              break;

	            case "number":
	            case "boolean":
	              customValue = value;
	              break;

	            default:
	              if (value instanceof _primitives.Name) {
	                customValue = value;
	              }

	              break;
	          }

	          if (customValue === undefined) {
	            (0, _util.warn)(`Bad value, for custom key "${key}", in Info: ${value}.`);
	            continue;
	          }

	          if (!docInfo.Custom) {
	            docInfo.Custom = Object.create(null);
	          }

	          docInfo.Custom[key] = customValue;
	          continue;
	      }

	      (0, _util.warn)(`Bad value, for key "${key}", in Info: ${value}.`);
	    }

	    return (0, _util.shadow)(this, "documentInfo", docInfo);
	  }

	  get fingerprints() {
	    function validate(data) {
	      return typeof data === "string" && data.length > 0 && data !== EMPTY_FINGERPRINT;
	    }

	    function hexString(hash) {
	      const buf = [];

	      for (let i = 0, ii = hash.length; i < ii; i++) {
	        const hex = hash[i].toString(16);
	        buf.push(hex.padStart(2, "0"));
	      }

	      return buf.join("");
	    }

	    const idArray = this.xref.trailer.get("ID");
	    let hashOriginal, hashModified;

	    if (Array.isArray(idArray) && validate(idArray[0])) {
	      hashOriginal = (0, _util.stringToBytes)(idArray[0]);

	      if (idArray[1] !== idArray[0] && validate(idArray[1])) {
	        hashModified = (0, _util.stringToBytes)(idArray[1]);
	      }
	    } else {
	      hashOriginal = (0, _crypto.calculateMD5)(this.stream.getByteRange(0, FINGERPRINT_FIRST_BYTES), 0, FINGERPRINT_FIRST_BYTES);
	    }

	    return (0, _util.shadow)(this, "fingerprints", [hexString(hashOriginal), hashModified ? hexString(hashModified) : null]);
	  }

	  async _getLinearizationPage(pageIndex) {
	    const {
	      catalog,
	      linearization,
	      xref
	    } = this;

	    const ref = _primitives.Ref.get(linearization.objectNumberFirst, 0);

	    try {
	      const obj = await xref.fetchAsync(ref);

	      if (obj instanceof _primitives.Dict) {
	        let type = obj.getRaw("Type");

	        if (type instanceof _primitives.Ref) {
	          type = await xref.fetchAsync(type);
	        }

	        if ((0, _primitives.isName)(type, "Page") || !obj.has("Type") && !obj.has("Kids")) {
	          if (!catalog.pageKidsCountCache.has(ref)) {
	            catalog.pageKidsCountCache.put(ref, 1);
	          }

	          if (!catalog.pageIndexCache.has(ref)) {
	            catalog.pageIndexCache.put(ref, 0);
	          }

	          return [obj, ref];
	        }
	      }

	      throw new _util.FormatError("The Linearization dictionary doesn't point to a valid Page dictionary.");
	    } catch (reason) {
	      (0, _util.warn)(`_getLinearizationPage: "${reason.message}".`);
	      return catalog.getPageDict(pageIndex);
	    }
	  }

	  getPage(pageIndex) {
	    const cachedPromise = this._pagePromises.get(pageIndex);

	    if (cachedPromise) {
	      return cachedPromise;
	    }

	    const {
	      catalog,
	      linearization,
	      xfaFactory
	    } = this;
	    let promise;

	    if (xfaFactory) {
	      promise = Promise.resolve([_primitives.Dict.empty, null]);
	    } else if (linearization && linearization.pageFirst === pageIndex) {
	      promise = this._getLinearizationPage(pageIndex);
	    } else {
	      promise = catalog.getPageDict(pageIndex);
	    }

	    promise = promise.then(([pageDict, ref]) => {
	      return new Page({
	        pdfManager: this.pdfManager,
	        xref: this.xref,
	        pageIndex,
	        pageDict,
	        ref,
	        globalIdFactory: this._globalIdFactory,
	        fontCache: catalog.fontCache,
	        builtInCMapCache: catalog.builtInCMapCache,
	        standardFontDataCache: catalog.standardFontDataCache,
	        globalImageCache: catalog.globalImageCache,
	        nonBlendModesSet: catalog.nonBlendModesSet,
	        xfaFactory
	      });
	    });

	    this._pagePromises.set(pageIndex, promise);

	    return promise;
	  }

	  async checkFirstPage(recoveryMode = false) {
	    if (recoveryMode) {
	      return;
	    }

	    try {
	      await this.getPage(0);
	    } catch (reason) {
	      if (reason instanceof _core_utils.XRefEntryException) {
	        this._pagePromises.delete(0);

	        await this.cleanup();
	        throw new _core_utils.XRefParseException();
	      }
	    }
	  }

	  async checkLastPage(recoveryMode = false) {
	    const {
	      catalog,
	      pdfManager
	    } = this;
	    catalog.setActualNumPages();
	    let numPages;

	    try {
	      await Promise.all([pdfManager.ensureDoc("xfaFactory"), pdfManager.ensureDoc("linearization"), pdfManager.ensureCatalog("numPages")]);

	      if (this.xfaFactory) {
	        return;
	      } else if (this.linearization) {
	        numPages = this.linearization.numPages;
	      } else {
	        numPages = catalog.numPages;
	      }

	      if (!Number.isInteger(numPages)) {
	        throw new _util.FormatError("Page count is not an integer.");
	      } else if (numPages <= 1) {
	        return;
	      }

	      await this.getPage(numPages - 1);
	    } catch (reason) {
	      this._pagePromises.delete(numPages - 1);

	      await this.cleanup();

	      if (reason instanceof _core_utils.XRefEntryException && !recoveryMode) {
	        throw new _core_utils.XRefParseException();
	      }

	      (0, _util.warn)(`checkLastPage - invalid /Pages tree /Count: ${numPages}.`);
	      let pagesTree;

	      try {
	        pagesTree = await catalog.getAllPageDicts(recoveryMode);
	      } catch (reasonAll) {
	        if (reasonAll instanceof _core_utils.XRefEntryException && !recoveryMode) {
	          throw new _core_utils.XRefParseException();
	        }

	        catalog.setActualNumPages(1);
	        return;
	      }

	      for (const [pageIndex, [pageDict, ref]] of pagesTree) {
	        let promise;

	        if (pageDict instanceof Error) {
	          promise = Promise.reject(pageDict);
	          promise.catch(() => {});
	        } else {
	          promise = Promise.resolve(new Page({
	            pdfManager,
	            xref: this.xref,
	            pageIndex,
	            pageDict,
	            ref,
	            globalIdFactory: this._globalIdFactory,
	            fontCache: catalog.fontCache,
	            builtInCMapCache: catalog.builtInCMapCache,
	            standardFontDataCache: catalog.standardFontDataCache,
	            globalImageCache: catalog.globalImageCache,
	            nonBlendModesSet: catalog.nonBlendModesSet,
	            xfaFactory: null
	          }));
	        }

	        this._pagePromises.set(pageIndex, promise);
	      }

	      catalog.setActualNumPages(pagesTree.size);
	    }
	  }

	  fontFallback(id, handler) {
	    return this.catalog.fontFallback(id, handler);
	  }

	  async cleanup(manuallyTriggered = false) {
	    return this.catalog ? this.catalog.cleanup(manuallyTriggered) : (0, _cleanup_helper.clearGlobalCaches)();
	  }

	  _collectFieldObjects(name, fieldRef, promises) {
	    const field = this.xref.fetchIfRef(fieldRef);

	    if (field.has("T")) {
	      const partName = (0, _util.stringToPDFString)(field.get("T"));

	      if (name === "") {
	        name = partName;
	      } else {
	        name = `${name}.${partName}`;
	      }
	    }

	    if (!promises.has(name)) {
	      promises.set(name, []);
	    }

	    promises.get(name).push(_annotation.AnnotationFactory.create(this.xref, fieldRef, this.pdfManager, this._localIdFactory, true).then(annotation => annotation && annotation.getFieldObject()).catch(function (reason) {
	      (0, _util.warn)(`_collectFieldObjects: "${reason}".`);
	      return null;
	    }));

	    if (field.has("Kids")) {
	      const kids = field.get("Kids");

	      for (const kid of kids) {
	        this._collectFieldObjects(name, kid, promises);
	      }
	    }
	  }

	  get fieldObjects() {
	    if (!this.formInfo.hasFields) {
	      return (0, _util.shadow)(this, "fieldObjects", Promise.resolve(null));
	    }

	    const allFields = Object.create(null);
	    const fieldPromises = new Map();

	    for (const fieldRef of this.catalog.acroForm.get("Fields")) {
	      this._collectFieldObjects("", fieldRef, fieldPromises);
	    }

	    const allPromises = [];

	    for (const [name, promises] of fieldPromises) {
	      allPromises.push(Promise.all(promises).then(fields => {
	        fields = fields.filter(field => !!field);

	        if (fields.length > 0) {
	          allFields[name] = fields;
	        }
	      }));
	    }

	    return (0, _util.shadow)(this, "fieldObjects", Promise.all(allPromises).then(() => allFields));
	  }

	  get hasJSActions() {
	    const promise = this.pdfManager.ensureDoc("_parseHasJSActions");
	    return (0, _util.shadow)(this, "hasJSActions", promise);
	  }

	  async _parseHasJSActions() {
	    const [catalogJsActions, fieldObjects] = await Promise.all([this.pdfManager.ensureCatalog("jsActions"), this.pdfManager.ensureDoc("fieldObjects")]);

	    if (catalogJsActions) {
	      return true;
	    }

	    if (fieldObjects) {
	      return Object.values(fieldObjects).some(fieldObject => fieldObject.some(object => object.actions !== null));
	    }

	    return false;
	  }

	  get calculationOrderIds() {
	    const acroForm = this.catalog.acroForm;

	    if (!acroForm || !acroForm.has("CO")) {
	      return (0, _util.shadow)(this, "calculationOrderIds", null);
	    }

	    const calculationOrder = acroForm.get("CO");

	    if (!Array.isArray(calculationOrder) || calculationOrder.length === 0) {
	      return (0, _util.shadow)(this, "calculationOrderIds", null);
	    }

	    const ids = [];

	    for (const id of calculationOrder) {
	      if (id instanceof _primitives.Ref) {
	        ids.push(id.toString());
	      }
	    }

	    if (ids.length === 0) {
	      return (0, _util.shadow)(this, "calculationOrderIds", null);
	    }

	    return (0, _util.shadow)(this, "calculationOrderIds", ids);
	  }

	}

	exports.PDFDocument = PDFDocument;

	/***/ }),
	/* 12 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.PopupAnnotation = exports.MarkupAnnotation = exports.AnnotationFactory = exports.AnnotationBorderStyle = exports.Annotation = void 0;
	exports.getQuadPoints = getQuadPoints;

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	var _default_appearance = __w_pdfjs_require__(13);

	var _primitives = __w_pdfjs_require__(5);

	var _writer = __w_pdfjs_require__(65);

	var _base_stream = __w_pdfjs_require__(7);

	var _bidi = __w_pdfjs_require__(60);

	var _catalog = __w_pdfjs_require__(69);

	var _colorspace = __w_pdfjs_require__(14);

	var _file_spec = __w_pdfjs_require__(72);

	var _object_loader = __w_pdfjs_require__(75);

	var _operator_list = __w_pdfjs_require__(62);

	var _stream = __w_pdfjs_require__(10);

	var _factory = __w_pdfjs_require__(76);

	class AnnotationFactory {
	  static create(xref, ref, pdfManager, idFactory, collectFields) {
	    return Promise.all([pdfManager.ensureCatalog("acroForm"), pdfManager.ensureCatalog("baseUrl"), pdfManager.ensureDoc("xfaDatasets"), collectFields ? this._getPageIndex(xref, ref, pdfManager) : -1]).then(([acroForm, baseUrl, xfaDatasets, pageIndex]) => pdfManager.ensure(this, "_create", [xref, ref, pdfManager, idFactory, acroForm, xfaDatasets, collectFields, pageIndex]));
	  }

	  static _create(xref, ref, pdfManager, idFactory, acroForm, xfaDatasets, collectFields, pageIndex = -1) {
	    const dict = xref.fetchIfRef(ref);

	    if (!(dict instanceof _primitives.Dict)) {
	      return undefined;
	    }

	    const id = ref instanceof _primitives.Ref ? ref.toString() : `annot_${idFactory.createObjId()}`;
	    let subtype = dict.get("Subtype");
	    subtype = subtype instanceof _primitives.Name ? subtype.name : null;
	    const parameters = {
	      xref,
	      ref,
	      dict,
	      subtype,
	      id,
	      pdfManager,
	      acroForm: acroForm instanceof _primitives.Dict ? acroForm : _primitives.Dict.empty,
	      xfaDatasets,
	      collectFields,
	      pageIndex
	    };

	    switch (subtype) {
	      case "Link":
	        return new LinkAnnotation(parameters);

	      case "Text":
	        return new TextAnnotation(parameters);

	      case "Widget":
	        let fieldType = (0, _core_utils.getInheritableProperty)({
	          dict,
	          key: "FT"
	        });
	        fieldType = fieldType instanceof _primitives.Name ? fieldType.name : null;

	        switch (fieldType) {
	          case "Tx":
	            return new TextWidgetAnnotation(parameters);

	          case "Btn":
	            return new ButtonWidgetAnnotation(parameters);

	          case "Ch":
	            return new ChoiceWidgetAnnotation(parameters);

	          case "Sig":
	            return new SignatureWidgetAnnotation(parameters);
	        }

	        (0, _util.warn)(`Unimplemented widget field type "${fieldType}", ` + "falling back to base field type.");
	        return new WidgetAnnotation(parameters);

	      case "Popup":
	        return new PopupAnnotation(parameters);

	      case "FreeText":
	        return new FreeTextAnnotation(parameters);

	      case "Line":
	        return new LineAnnotation(parameters);

	      case "Square":
	        return new SquareAnnotation(parameters);

	      case "Circle":
	        return new CircleAnnotation(parameters);

	      case "PolyLine":
	        return new PolylineAnnotation(parameters);

	      case "Polygon":
	        return new PolygonAnnotation(parameters);

	      case "Caret":
	        return new CaretAnnotation(parameters);

	      case "Ink":
	        return new InkAnnotation(parameters);

	      case "Highlight":
	        return new HighlightAnnotation(parameters);

	      case "Underline":
	        return new UnderlineAnnotation(parameters);

	      case "Squiggly":
	        return new SquigglyAnnotation(parameters);

	      case "StrikeOut":
	        return new StrikeOutAnnotation(parameters);

	      case "Stamp":
	        return new StampAnnotation(parameters);

	      case "FileAttachment":
	        return new FileAttachmentAnnotation(parameters);

	      default:
	        if (!collectFields) {
	          if (!subtype) {
	            (0, _util.warn)("Annotation is missing the required /Subtype.");
	          } else {
	            (0, _util.warn)(`Unimplemented annotation type "${subtype}", ` + "falling back to base annotation.");
	          }
	        }

	        return new Annotation(parameters);
	    }
	  }

	  static async _getPageIndex(xref, ref, pdfManager) {
	    try {
	      const annotDict = await xref.fetchIfRefAsync(ref);

	      if (!(annotDict instanceof _primitives.Dict)) {
	        return -1;
	      }

	      const pageRef = annotDict.getRaw("P");

	      if (!(pageRef instanceof _primitives.Ref)) {
	        return -1;
	      }

	      const pageIndex = await pdfManager.ensureCatalog("getPageIndex", [pageRef]);
	      return pageIndex;
	    } catch (ex) {
	      (0, _util.warn)(`_getPageIndex: "${ex}".`);
	      return -1;
	    }
	  }

	  static async saveNewAnnotations(evaluator, task, annotations) {
	    const xref = evaluator.xref;
	    let baseFontRef;
	    const dependencies = [];
	    const promises = [];

	    for (const annotation of annotations) {
	      switch (annotation.annotationType) {
	        case _util.AnnotationEditorType.FREETEXT:
	          if (!baseFontRef) {
	            const baseFont = new _primitives.Dict(xref);
	            baseFont.set("BaseFont", _primitives.Name.get("Helvetica"));
	            baseFont.set("Type", _primitives.Name.get("Font"));
	            baseFont.set("Subtype", _primitives.Name.get("Type1"));
	            baseFont.set("Encoding", _primitives.Name.get("WinAnsiEncoding"));
	            const buffer = [];
	            baseFontRef = xref.getNewRef();
	            (0, _writer.writeObject)(baseFontRef, baseFont, buffer, null);
	            dependencies.push({
	              ref: baseFontRef,
	              data: buffer.join("")
	            });
	          }

	          promises.push(FreeTextAnnotation.createNewAnnotation(xref, annotation, dependencies, {
	            evaluator,
	            task,
	            baseFontRef
	          }));
	          break;

	        case _util.AnnotationEditorType.INK:
	          promises.push(InkAnnotation.createNewAnnotation(xref, annotation, dependencies));
	      }
	    }

	    return {
	      annotations: await Promise.all(promises),
	      dependencies
	    };
	  }

	  static async printNewAnnotations(evaluator, task, annotations) {
	    if (!annotations) {
	      return null;
	    }

	    const xref = evaluator.xref;
	    const promises = [];

	    for (const annotation of annotations) {
	      switch (annotation.annotationType) {
	        case _util.AnnotationEditorType.FREETEXT:
	          promises.push(FreeTextAnnotation.createNewPrintAnnotation(xref, annotation, {
	            evaluator,
	            task
	          }));
	          break;

	        case _util.AnnotationEditorType.INK:
	          promises.push(InkAnnotation.createNewPrintAnnotation(xref, annotation));
	          break;
	      }
	    }

	    return Promise.all(promises);
	  }

	}

	exports.AnnotationFactory = AnnotationFactory;

	function getRgbColor(color, defaultColor = new Uint8ClampedArray(3)) {
	  if (!Array.isArray(color)) {
	    return defaultColor;
	  }

	  const rgbColor = defaultColor || new Uint8ClampedArray(3);

	  switch (color.length) {
	    case 0:
	      return null;

	    case 1:
	      _colorspace.ColorSpace.singletons.gray.getRgbItem(color, 0, rgbColor, 0);

	      return rgbColor;

	    case 3:
	      _colorspace.ColorSpace.singletons.rgb.getRgbItem(color, 0, rgbColor, 0);

	      return rgbColor;

	    case 4:
	      _colorspace.ColorSpace.singletons.cmyk.getRgbItem(color, 0, rgbColor, 0);

	      return rgbColor;

	    default:
	      return defaultColor;
	  }
	}

	function getQuadPoints(dict, rect) {
	  if (!dict.has("QuadPoints")) {
	    return null;
	  }

	  const quadPoints = dict.getArray("QuadPoints");

	  if (!Array.isArray(quadPoints) || quadPoints.length === 0 || quadPoints.length % 8 > 0) {
	    return null;
	  }

	  const quadPointsLists = [];

	  for (let i = 0, ii = quadPoints.length / 8; i < ii; i++) {
	    quadPointsLists.push([]);

	    for (let j = i * 8, jj = i * 8 + 8; j < jj; j += 2) {
	      const x = quadPoints[j];
	      const y = quadPoints[j + 1];

	      if (rect !== null && (x < rect[0] || x > rect[2] || y < rect[1] || y > rect[3])) {
	        return null;
	      }

	      quadPointsLists[i].push({
	        x,
	        y
	      });
	    }
	  }

	  return quadPointsLists.map(quadPointsList => {
	    const [minX, maxX, minY, maxY] = quadPointsList.reduce(([mX, MX, mY, MY], quadPoint) => [Math.min(mX, quadPoint.x), Math.max(MX, quadPoint.x), Math.min(mY, quadPoint.y), Math.max(MY, quadPoint.y)], [Number.MAX_VALUE, Number.MIN_VALUE, Number.MAX_VALUE, Number.MIN_VALUE]);
	    return [{
	      x: minX,
	      y: maxY
	    }, {
	      x: maxX,
	      y: maxY
	    }, {
	      x: minX,
	      y: minY
	    }, {
	      x: maxX,
	      y: minY
	    }];
	  });
	}

	function getTransformMatrix(rect, bbox, matrix) {
	  const [minX, minY, maxX, maxY] = _util.Util.getAxialAlignedBoundingBox(bbox, matrix);

	  if (minX === maxX || minY === maxY) {
	    return [1, 0, 0, 1, rect[0], rect[1]];
	  }

	  const xRatio = (rect[2] - rect[0]) / (maxX - minX);
	  const yRatio = (rect[3] - rect[1]) / (maxY - minY);
	  return [xRatio, 0, 0, yRatio, rect[0] - minX * xRatio, rect[1] - minY * yRatio];
	}

	class Annotation {
	  constructor(params) {
	    const dict = params.dict;
	    this.setTitle(dict.get("T"));
	    this.setContents(dict.get("Contents"));
	    this.setModificationDate(dict.get("M"));
	    this.setFlags(dict.get("F"));
	    this.setRectangle(dict.getArray("Rect"));
	    this.setColor(dict.getArray("C"));
	    this.setBorderStyle(dict);
	    this.setAppearance(dict);
	    this.setOptionalContent(dict);
	    const MK = dict.get("MK");
	    this.setBorderAndBackgroundColors(MK);
	    this.setRotation(MK);
	    this._streams = [];

	    if (this.appearance) {
	      this._streams.push(this.appearance);
	    }

	    this.data = {
	      annotationFlags: this.flags,
	      borderStyle: this.borderStyle,
	      color: this.color,
	      backgroundColor: this.backgroundColor,
	      borderColor: this.borderColor,
	      rotation: this.rotation,
	      contentsObj: this._contents,
	      hasAppearance: !!this.appearance,
	      id: params.id,
	      modificationDate: this.modificationDate,
	      rect: this.rectangle,
	      subtype: params.subtype,
	      hasOwnCanvas: false
	    };

	    if (params.collectFields) {
	      const kids = dict.get("Kids");

	      if (Array.isArray(kids)) {
	        const kidIds = [];

	        for (const kid of kids) {
	          if (kid instanceof _primitives.Ref) {
	            kidIds.push(kid.toString());
	          }
	        }

	        if (kidIds.length !== 0) {
	          this.data.kidIds = kidIds;
	        }
	      }

	      this.data.actions = (0, _core_utils.collectActions)(params.xref, dict, _util.AnnotationActionEventType);
	      this.data.fieldName = this._constructFieldName(dict);
	      this.data.pageIndex = params.pageIndex;
	    }

	    this._fallbackFontDict = null;
	  }

	  _hasFlag(flags, flag) {
	    return !!(flags & flag);
	  }

	  _isViewable(flags) {
	    return !this._hasFlag(flags, _util.AnnotationFlag.INVISIBLE) && !this._hasFlag(flags, _util.AnnotationFlag.NOVIEW);
	  }

	  _isPrintable(flags) {
	    return this._hasFlag(flags, _util.AnnotationFlag.PRINT) && !this._hasFlag(flags, _util.AnnotationFlag.INVISIBLE);
	  }

	  mustBeViewed(annotationStorage) {
	    const storageEntry = annotationStorage && annotationStorage.get(this.data.id);

	    if (storageEntry && storageEntry.hidden !== undefined) {
	      return !storageEntry.hidden;
	    }

	    return this.viewable && !this._hasFlag(this.flags, _util.AnnotationFlag.HIDDEN);
	  }

	  mustBePrinted(annotationStorage) {
	    const storageEntry = annotationStorage && annotationStorage.get(this.data.id);

	    if (storageEntry && storageEntry.print !== undefined) {
	      return storageEntry.print;
	    }

	    return this.printable;
	  }

	  get viewable() {
	    if (this.data.quadPoints === null) {
	      return false;
	    }

	    if (this.flags === 0) {
	      return true;
	    }

	    return this._isViewable(this.flags);
	  }

	  get printable() {
	    if (this.data.quadPoints === null) {
	      return false;
	    }

	    if (this.flags === 0) {
	      return false;
	    }

	    return this._isPrintable(this.flags);
	  }

	  _parseStringHelper(data) {
	    const str = typeof data === "string" ? (0, _util.stringToPDFString)(data) : "";
	    const dir = str && (0, _bidi.bidi)(str).dir === "rtl" ? "rtl" : "ltr";
	    return {
	      str,
	      dir
	    };
	  }

	  setTitle(title) {
	    this._title = this._parseStringHelper(title);
	  }

	  setContents(contents) {
	    this._contents = this._parseStringHelper(contents);
	  }

	  setModificationDate(modificationDate) {
	    this.modificationDate = typeof modificationDate === "string" ? modificationDate : null;
	  }

	  setFlags(flags) {
	    this.flags = Number.isInteger(flags) && flags > 0 ? flags : 0;
	  }

	  hasFlag(flag) {
	    return this._hasFlag(this.flags, flag);
	  }

	  setRectangle(rectangle) {
	    if (Array.isArray(rectangle) && rectangle.length === 4) {
	      this.rectangle = _util.Util.normalizeRect(rectangle);
	    } else {
	      this.rectangle = [0, 0, 0, 0];
	    }
	  }

	  setColor(color) {
	    this.color = getRgbColor(color);
	  }

	  setLineEndings(lineEndings) {
	    this.lineEndings = ["None", "None"];

	    if (Array.isArray(lineEndings) && lineEndings.length === 2) {
	      for (let i = 0; i < 2; i++) {
	        const obj = lineEndings[i];

	        if (obj instanceof _primitives.Name) {
	          switch (obj.name) {
	            case "None":
	              continue;

	            case "Square":
	            case "Circle":
	            case "Diamond":
	            case "OpenArrow":
	            case "ClosedArrow":
	            case "Butt":
	            case "ROpenArrow":
	            case "RClosedArrow":
	            case "Slash":
	              this.lineEndings[i] = obj.name;
	              continue;
	          }
	        }

	        (0, _util.warn)(`Ignoring invalid lineEnding: ${obj}`);
	      }
	    }
	  }

	  setRotation(mk) {
	    this.rotation = 0;

	    if (mk instanceof _primitives.Dict) {
	      let angle = mk.get("R") || 0;

	      if (Number.isInteger(angle) && angle !== 0) {
	        angle %= 360;

	        if (angle < 0) {
	          angle += 360;
	        }

	        if (angle % 90 === 0) {
	          this.rotation = angle;
	        }
	      }
	    }
	  }

	  setBorderAndBackgroundColors(mk) {
	    if (mk instanceof _primitives.Dict) {
	      this.borderColor = getRgbColor(mk.getArray("BC"), null);
	      this.backgroundColor = getRgbColor(mk.getArray("BG"), null);
	    } else {
	      this.borderColor = this.backgroundColor = null;
	    }
	  }

	  setBorderStyle(borderStyle) {
	    this.borderStyle = new AnnotationBorderStyle();

	    if (!(borderStyle instanceof _primitives.Dict)) {
	      return;
	    }

	    if (borderStyle.has("BS")) {
	      const dict = borderStyle.get("BS");
	      const dictType = dict.get("Type");

	      if (!dictType || (0, _primitives.isName)(dictType, "Border")) {
	        this.borderStyle.setWidth(dict.get("W"), this.rectangle);
	        this.borderStyle.setStyle(dict.get("S"));
	        this.borderStyle.setDashArray(dict.getArray("D"));
	      }
	    } else if (borderStyle.has("Border")) {
	      const array = borderStyle.getArray("Border");

	      if (Array.isArray(array) && array.length >= 3) {
	        this.borderStyle.setHorizontalCornerRadius(array[0]);
	        this.borderStyle.setVerticalCornerRadius(array[1]);
	        this.borderStyle.setWidth(array[2], this.rectangle);

	        if (array.length === 4) {
	          this.borderStyle.setDashArray(array[3], true);
	        }
	      }
	    } else {
	      this.borderStyle.setWidth(0);
	    }
	  }

	  setAppearance(dict) {
	    this.appearance = null;
	    const appearanceStates = dict.get("AP");

	    if (!(appearanceStates instanceof _primitives.Dict)) {
	      return;
	    }

	    const normalAppearanceState = appearanceStates.get("N");

	    if (normalAppearanceState instanceof _base_stream.BaseStream) {
	      this.appearance = normalAppearanceState;
	      return;
	    }

	    if (!(normalAppearanceState instanceof _primitives.Dict)) {
	      return;
	    }

	    const as = dict.get("AS");

	    if (!(as instanceof _primitives.Name) || !normalAppearanceState.has(as.name)) {
	      return;
	    }

	    this.appearance = normalAppearanceState.get(as.name);
	  }

	  setOptionalContent(dict) {
	    this.oc = null;
	    const oc = dict.get("OC");

	    if (oc instanceof _primitives.Name) {
	      (0, _util.warn)("setOptionalContent: Support for /Name-entry is not implemented.");
	    } else if (oc instanceof _primitives.Dict) {
	      this.oc = oc;
	    }
	  }

	  loadResources(keys, appearance) {
	    return appearance.dict.getAsync("Resources").then(resources => {
	      if (!resources) {
	        return undefined;
	      }

	      const objectLoader = new _object_loader.ObjectLoader(resources, keys, resources.xref);
	      return objectLoader.load().then(function () {
	        return resources;
	      });
	    });
	  }

	  async getOperatorList(evaluator, task, intent, renderForms, annotationStorage) {
	    const data = this.data;
	    let appearance = this.appearance;
	    const isUsingOwnCanvas = !!(this.data.hasOwnCanvas && intent & _util.RenderingIntentFlag.DISPLAY);

	    if (!appearance) {
	      if (!isUsingOwnCanvas) {
	        return {
	          opList: new _operator_list.OperatorList(),
	          separateForm: false,
	          separateCanvas: false
	        };
	      }

	      appearance = new _stream.StringStream("");
	      appearance.dict = new _primitives.Dict();
	    }

	    const appearanceDict = appearance.dict;
	    const resources = await this.loadResources(["ExtGState", "ColorSpace", "Pattern", "Shading", "XObject", "Font"], appearance);
	    const bbox = appearanceDict.getArray("BBox") || [0, 0, 1, 1];
	    const matrix = appearanceDict.getArray("Matrix") || [1, 0, 0, 1, 0, 0];
	    const transform = getTransformMatrix(data.rect, bbox, matrix);
	    const opList = new _operator_list.OperatorList();
	    let optionalContent;

	    if (this.oc) {
	      optionalContent = await evaluator.parseMarkedContentProps(this.oc, null);
	    }

	    if (optionalContent !== undefined) {
	      opList.addOp(_util.OPS.beginMarkedContentProps, ["OC", optionalContent]);
	    }

	    opList.addOp(_util.OPS.beginAnnotation, [data.id, data.rect, transform, matrix, isUsingOwnCanvas]);
	    await evaluator.getOperatorList({
	      stream: appearance,
	      task,
	      resources,
	      operatorList: opList,
	      fallbackFontDict: this._fallbackFontDict
	    });
	    opList.addOp(_util.OPS.endAnnotation, []);

	    if (optionalContent !== undefined) {
	      opList.addOp(_util.OPS.endMarkedContent, []);
	    }

	    this.reset();
	    return {
	      opList,
	      separateForm: false,
	      separateCanvas: isUsingOwnCanvas
	    };
	  }

	  async save(evaluator, task, annotationStorage) {
	    return null;
	  }

	  get hasTextContent() {
	    return false;
	  }

	  async extractTextContent(evaluator, task, viewBox) {
	    if (!this.appearance) {
	      return;
	    }

	    const resources = await this.loadResources(["ExtGState", "Font", "Properties", "XObject"], this.appearance);
	    const text = [];
	    const buffer = [];
	    const sink = {
	      desiredSize: Math.Infinity,
	      ready: true,

	      enqueue(chunk, size) {
	        for (const item of chunk.items) {
	          buffer.push(item.str);

	          if (item.hasEOL) {
	            text.push(buffer.join(""));
	            buffer.length = 0;
	          }
	        }
	      }

	    };
	    await evaluator.getTextContent({
	      stream: this.appearance,
	      task,
	      resources,
	      includeMarkedContent: true,
	      combineTextItems: true,
	      sink,
	      viewBox
	    });
	    this.reset();

	    if (buffer.length) {
	      text.push(buffer.join(""));
	    }

	    if (text.length > 0) {
	      this.data.textContent = text;
	    }
	  }

	  getFieldObject() {
	    if (this.data.kidIds) {
	      return {
	        id: this.data.id,
	        actions: this.data.actions,
	        name: this.data.fieldName,
	        strokeColor: this.data.borderColor,
	        fillColor: this.data.backgroundColor,
	        type: "",
	        kidIds: this.data.kidIds,
	        page: this.data.pageIndex,
	        rotation: this.rotation
	      };
	    }

	    return null;
	  }

	  reset() {
	    for (const stream of this._streams) {
	      stream.reset();
	    }
	  }

	  _constructFieldName(dict) {
	    if (!dict.has("T") && !dict.has("Parent")) {
	      (0, _util.warn)("Unknown field name, falling back to empty field name.");
	      return "";
	    }

	    if (!dict.has("Parent")) {
	      return (0, _util.stringToPDFString)(dict.get("T"));
	    }

	    const fieldName = [];

	    if (dict.has("T")) {
	      fieldName.unshift((0, _util.stringToPDFString)(dict.get("T")));
	    }

	    let loopDict = dict;
	    const visited = new _primitives.RefSet();

	    if (dict.objId) {
	      visited.put(dict.objId);
	    }

	    while (loopDict.has("Parent")) {
	      loopDict = loopDict.get("Parent");

	      if (!(loopDict instanceof _primitives.Dict) || loopDict.objId && visited.has(loopDict.objId)) {
	        break;
	      }

	      if (loopDict.objId) {
	        visited.put(loopDict.objId);
	      }

	      if (loopDict.has("T")) {
	        fieldName.unshift((0, _util.stringToPDFString)(loopDict.get("T")));
	      }
	    }

	    return fieldName.join(".");
	  }

	}

	exports.Annotation = Annotation;

	class AnnotationBorderStyle {
	  constructor() {
	    this.width = 1;
	    this.style = _util.AnnotationBorderStyleType.SOLID;
	    this.dashArray = [3];
	    this.horizontalCornerRadius = 0;
	    this.verticalCornerRadius = 0;
	  }

	  setWidth(width, rect = [0, 0, 0, 0]) {
	    if (width instanceof _primitives.Name) {
	      this.width = 0;
	      return;
	    }

	    if (typeof width === "number") {
	      if (width > 0) {
	        const maxWidth = (rect[2] - rect[0]) / 2;
	        const maxHeight = (rect[3] - rect[1]) / 2;

	        if (maxWidth > 0 && maxHeight > 0 && (width > maxWidth || width > maxHeight)) {
	          (0, _util.warn)(`AnnotationBorderStyle.setWidth - ignoring width: ${width}`);
	          width = 1;
	        }
	      }

	      this.width = width;
	    }
	  }

	  setStyle(style) {
	    if (!(style instanceof _primitives.Name)) {
	      return;
	    }

	    switch (style.name) {
	      case "S":
	        this.style = _util.AnnotationBorderStyleType.SOLID;
	        break;

	      case "D":
	        this.style = _util.AnnotationBorderStyleType.DASHED;
	        break;

	      case "B":
	        this.style = _util.AnnotationBorderStyleType.BEVELED;
	        break;

	      case "I":
	        this.style = _util.AnnotationBorderStyleType.INSET;
	        break;

	      case "U":
	        this.style = _util.AnnotationBorderStyleType.UNDERLINE;
	        break;
	    }
	  }

	  setDashArray(dashArray, forceStyle = false) {
	    if (Array.isArray(dashArray) && dashArray.length > 0) {
	      let isValid = true;
	      let allZeros = true;

	      for (const element of dashArray) {
	        const validNumber = +element >= 0;

	        if (!validNumber) {
	          isValid = false;
	          break;
	        } else if (element > 0) {
	          allZeros = false;
	        }
	      }

	      if (isValid && !allZeros) {
	        this.dashArray = dashArray;

	        if (forceStyle) {
	          this.setStyle(_primitives.Name.get("D"));
	        }
	      } else {
	        this.width = 0;
	      }
	    } else if (dashArray) {
	      this.width = 0;
	    }
	  }

	  setHorizontalCornerRadius(radius) {
	    if (Number.isInteger(radius)) {
	      this.horizontalCornerRadius = radius;
	    }
	  }

	  setVerticalCornerRadius(radius) {
	    if (Number.isInteger(radius)) {
	      this.verticalCornerRadius = radius;
	    }
	  }

	}

	exports.AnnotationBorderStyle = AnnotationBorderStyle;

	class MarkupAnnotation extends Annotation {
	  constructor(parameters) {
	    super(parameters);
	    const dict = parameters.dict;

	    if (dict.has("IRT")) {
	      const rawIRT = dict.getRaw("IRT");
	      this.data.inReplyTo = rawIRT instanceof _primitives.Ref ? rawIRT.toString() : null;
	      const rt = dict.get("RT");
	      this.data.replyType = rt instanceof _primitives.Name ? rt.name : _util.AnnotationReplyType.REPLY;
	    }

	    if (this.data.replyType === _util.AnnotationReplyType.GROUP) {
	      const parent = dict.get("IRT");
	      this.setTitle(parent.get("T"));
	      this.data.titleObj = this._title;
	      this.setContents(parent.get("Contents"));
	      this.data.contentsObj = this._contents;

	      if (!parent.has("CreationDate")) {
	        this.data.creationDate = null;
	      } else {
	        this.setCreationDate(parent.get("CreationDate"));
	        this.data.creationDate = this.creationDate;
	      }

	      if (!parent.has("M")) {
	        this.data.modificationDate = null;
	      } else {
	        this.setModificationDate(parent.get("M"));
	        this.data.modificationDate = this.modificationDate;
	      }

	      this.data.hasPopup = parent.has("Popup");

	      if (!parent.has("C")) {
	        this.data.color = null;
	      } else {
	        this.setColor(parent.getArray("C"));
	        this.data.color = this.color;
	      }
	    } else {
	      this.data.titleObj = this._title;
	      this.setCreationDate(dict.get("CreationDate"));
	      this.data.creationDate = this.creationDate;
	      this.data.hasPopup = dict.has("Popup");

	      if (!dict.has("C")) {
	        this.data.color = null;
	      }
	    }

	    if (dict.has("RC")) {
	      this.data.richText = _factory.XFAFactory.getRichTextAsHtml(dict.get("RC"));
	    }
	  }

	  setCreationDate(creationDate) {
	    this.creationDate = typeof creationDate === "string" ? creationDate : null;
	  }

	  _setDefaultAppearance({
	    xref,
	    extra,
	    strokeColor,
	    fillColor,
	    blendMode,
	    strokeAlpha,
	    fillAlpha,
	    pointsCallback
	  }) {
	    let minX = Number.MAX_VALUE;
	    let minY = Number.MAX_VALUE;
	    let maxX = Number.MIN_VALUE;
	    let maxY = Number.MIN_VALUE;
	    const buffer = ["q"];

	    if (extra) {
	      buffer.push(extra);
	    }

	    if (strokeColor) {
	      buffer.push(`${strokeColor[0]} ${strokeColor[1]} ${strokeColor[2]} RG`);
	    }

	    if (fillColor) {
	      buffer.push(`${fillColor[0]} ${fillColor[1]} ${fillColor[2]} rg`);
	    }

	    let pointsArray = this.data.quadPoints;

	    if (!pointsArray) {
	      pointsArray = [[{
	        x: this.rectangle[0],
	        y: this.rectangle[3]
	      }, {
	        x: this.rectangle[2],
	        y: this.rectangle[3]
	      }, {
	        x: this.rectangle[0],
	        y: this.rectangle[1]
	      }, {
	        x: this.rectangle[2],
	        y: this.rectangle[1]
	      }]];
	    }

	    for (const points of pointsArray) {
	      const [mX, MX, mY, MY] = pointsCallback(buffer, points);
	      minX = Math.min(minX, mX);
	      maxX = Math.max(maxX, MX);
	      minY = Math.min(minY, mY);
	      maxY = Math.max(maxY, MY);
	    }

	    buffer.push("Q");
	    const formDict = new _primitives.Dict(xref);
	    const appearanceStreamDict = new _primitives.Dict(xref);
	    appearanceStreamDict.set("Subtype", _primitives.Name.get("Form"));
	    const appearanceStream = new _stream.StringStream(buffer.join(" "));
	    appearanceStream.dict = appearanceStreamDict;
	    formDict.set("Fm0", appearanceStream);
	    const gsDict = new _primitives.Dict(xref);

	    if (blendMode) {
	      gsDict.set("BM", _primitives.Name.get(blendMode));
	    }

	    if (typeof strokeAlpha === "number") {
	      gsDict.set("CA", strokeAlpha);
	    }

	    if (typeof fillAlpha === "number") {
	      gsDict.set("ca", fillAlpha);
	    }

	    const stateDict = new _primitives.Dict(xref);
	    stateDict.set("GS0", gsDict);
	    const resources = new _primitives.Dict(xref);
	    resources.set("ExtGState", stateDict);
	    resources.set("XObject", formDict);
	    const appearanceDict = new _primitives.Dict(xref);
	    appearanceDict.set("Resources", resources);
	    const bbox = this.data.rect = [minX, minY, maxX, maxY];
	    appearanceDict.set("BBox", bbox);
	    this.appearance = new _stream.StringStream("/GS0 gs /Fm0 Do");
	    this.appearance.dict = appearanceDict;

	    this._streams.push(this.appearance, appearanceStream);
	  }

	  static async createNewAnnotation(xref, annotation, dependencies, params) {
	    const annotationRef = xref.getNewRef();
	    const apRef = xref.getNewRef();
	    const annotationDict = this.createNewDict(annotation, xref, {
	      apRef
	    });
	    const ap = await this.createNewAppearanceStream(annotation, xref, params);
	    const buffer = [];
	    let transform = xref.encrypt ? xref.encrypt.createCipherTransform(apRef.num, apRef.gen) : null;
	    (0, _writer.writeObject)(apRef, ap, buffer, transform);
	    dependencies.push({
	      ref: apRef,
	      data: buffer.join("")
	    });
	    buffer.length = 0;
	    transform = xref.encrypt ? xref.encrypt.createCipherTransform(annotationRef.num, annotationRef.gen) : null;
	    (0, _writer.writeObject)(annotationRef, annotationDict, buffer, transform);
	    return {
	      ref: annotationRef,
	      data: buffer.join("")
	    };
	  }

	  static async createNewPrintAnnotation(xref, annotation, params) {
	    const ap = await this.createNewAppearanceStream(annotation, xref, params);
	    const annotationDict = this.createNewDict(annotation, xref, {
	      ap
	    });
	    return new this.prototype.constructor({
	      dict: annotationDict,
	      xref
	    });
	  }

	}

	exports.MarkupAnnotation = MarkupAnnotation;

	class WidgetAnnotation extends Annotation {
	  constructor(params) {
	    super(params);
	    const dict = params.dict;
	    const data = this.data;
	    this.ref = params.ref;
	    data.annotationType = _util.AnnotationType.WIDGET;

	    if (data.fieldName === undefined) {
	      data.fieldName = this._constructFieldName(dict);
	    }

	    if (data.actions === undefined) {
	      data.actions = (0, _core_utils.collectActions)(params.xref, dict, _util.AnnotationActionEventType);
	    }

	    let fieldValue = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "V",
	      getArray: true
	    });
	    data.fieldValue = this._decodeFormValue(fieldValue);
	    const defaultFieldValue = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "DV",
	      getArray: true
	    });
	    data.defaultFieldValue = this._decodeFormValue(defaultFieldValue);

	    if (fieldValue === undefined && params.xfaDatasets) {
	      const path = this._title.str;

	      if (path) {
	        this._hasValueFromXFA = true;
	        data.fieldValue = fieldValue = params.xfaDatasets.getValue(path);
	      }
	    }

	    if (fieldValue === undefined && data.defaultFieldValue !== null) {
	      data.fieldValue = data.defaultFieldValue;
	    }

	    data.alternativeText = (0, _util.stringToPDFString)(dict.get("TU") || "");
	    const defaultAppearance = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "DA"
	    }) || params.acroForm.get("DA");
	    this._defaultAppearance = typeof defaultAppearance === "string" ? defaultAppearance : "";
	    data.defaultAppearanceData = (0, _default_appearance.parseDefaultAppearance)(this._defaultAppearance);
	    const fieldType = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "FT"
	    });
	    data.fieldType = fieldType instanceof _primitives.Name ? fieldType.name : null;
	    const localResources = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "DR"
	    });
	    const acroFormResources = params.acroForm.get("DR");
	    const appearanceResources = this.appearance && this.appearance.dict.get("Resources");
	    this._fieldResources = {
	      localResources,
	      acroFormResources,
	      appearanceResources,
	      mergedResources: _primitives.Dict.merge({
	        xref: params.xref,
	        dictArray: [localResources, appearanceResources, acroFormResources],
	        mergeSubDicts: true
	      })
	    };
	    data.fieldFlags = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "Ff"
	    });

	    if (!Number.isInteger(data.fieldFlags) || data.fieldFlags < 0) {
	      data.fieldFlags = 0;
	    }

	    data.readOnly = this.hasFieldFlag(_util.AnnotationFieldFlag.READONLY);
	    data.required = this.hasFieldFlag(_util.AnnotationFieldFlag.REQUIRED);
	    data.hidden = this._hasFlag(data.annotationFlags, _util.AnnotationFlag.HIDDEN);
	  }

	  _decodeFormValue(formValue) {
	    if (Array.isArray(formValue)) {
	      return formValue.filter(item => typeof item === "string").map(item => (0, _util.stringToPDFString)(item));
	    } else if (formValue instanceof _primitives.Name) {
	      return (0, _util.stringToPDFString)(formValue.name);
	    } else if (typeof formValue === "string") {
	      return (0, _util.stringToPDFString)(formValue);
	    }

	    return null;
	  }

	  hasFieldFlag(flag) {
	    return !!(this.data.fieldFlags & flag);
	  }

	  static _getRotationMatrix(rotation, width, height) {
	    switch (rotation) {
	      case 90:
	        return [0, 1, -1, 0, width, 0];

	      case 180:
	        return [-1, 0, 0, -1, width, height];

	      case 270:
	        return [0, -1, 1, 0, 0, height];

	      default:
	        throw new Error("Invalid rotation");
	    }
	  }

	  getRotationMatrix(annotationStorage) {
	    const storageEntry = annotationStorage ? annotationStorage.get(this.data.id) : undefined;
	    let rotation = storageEntry && storageEntry.rotation;

	    if (rotation === undefined) {
	      rotation = this.rotation;
	    }

	    if (rotation === 0) {
	      return _util.IDENTITY_MATRIX;
	    }

	    const width = this.data.rect[2] - this.data.rect[0];
	    const height = this.data.rect[3] - this.data.rect[1];
	    return WidgetAnnotation._getRotationMatrix(rotation, width, height);
	  }

	  getBorderAndBackgroundAppearances(annotationStorage) {
	    const storageEntry = annotationStorage ? annotationStorage.get(this.data.id) : undefined;
	    let rotation = storageEntry && storageEntry.rotation;

	    if (rotation === undefined) {
	      rotation = this.rotation;
	    }

	    if (!this.backgroundColor && !this.borderColor) {
	      return "";
	    }

	    const width = this.data.rect[2] - this.data.rect[0];
	    const height = this.data.rect[3] - this.data.rect[1];
	    const rect = rotation === 0 || rotation === 180 ? `0 0 ${width} ${height} re` : `0 0 ${height} ${width} re`;
	    let str = "";

	    if (this.backgroundColor) {
	      str = `${(0, _default_appearance.getPdfColor)(this.backgroundColor, true)} ${rect} f `;
	    }

	    if (this.borderColor) {
	      const borderWidth = this.borderStyle.width || 1;
	      str += `${borderWidth} w ${(0, _default_appearance.getPdfColor)(this.borderColor, false)} ${rect} S `;
	    }

	    return str;
	  }

	  async getOperatorList(evaluator, task, intent, renderForms, annotationStorage) {
	    if (renderForms && !(this instanceof SignatureWidgetAnnotation)) {
	      return {
	        opList: new _operator_list.OperatorList(),
	        separateForm: true,
	        separateCanvas: false
	      };
	    }

	    if (!this._hasText) {
	      return super.getOperatorList(evaluator, task, intent, renderForms, annotationStorage);
	    }

	    const content = await this._getAppearance(evaluator, task, annotationStorage);

	    if (this.appearance && content === null) {
	      return super.getOperatorList(evaluator, task, intent, renderForms, annotationStorage);
	    }

	    const opList = new _operator_list.OperatorList();

	    if (!this._defaultAppearance || content === null) {
	      return {
	        opList,
	        separateForm: false,
	        separateCanvas: false
	      };
	    }

	    const matrix = [1, 0, 0, 1, 0, 0];
	    const bbox = [0, 0, this.data.rect[2] - this.data.rect[0], this.data.rect[3] - this.data.rect[1]];
	    const transform = getTransformMatrix(this.data.rect, bbox, matrix);
	    let optionalContent;

	    if (this.oc) {
	      optionalContent = await evaluator.parseMarkedContentProps(this.oc, null);
	    }

	    if (optionalContent !== undefined) {
	      opList.addOp(_util.OPS.beginMarkedContentProps, ["OC", optionalContent]);
	    }

	    opList.addOp(_util.OPS.beginAnnotation, [this.data.id, this.data.rect, transform, this.getRotationMatrix(annotationStorage), false]);
	    const stream = new _stream.StringStream(content);
	    await evaluator.getOperatorList({
	      stream,
	      task,
	      resources: this._fieldResources.mergedResources,
	      operatorList: opList
	    });
	    opList.addOp(_util.OPS.endAnnotation, []);

	    if (optionalContent !== undefined) {
	      opList.addOp(_util.OPS.endMarkedContent, []);
	    }

	    return {
	      opList,
	      separateForm: false,
	      separateCanvas: false
	    };
	  }

	  _getMKDict(rotation) {
	    const mk = new _primitives.Dict(null);

	    if (rotation) {
	      mk.set("R", rotation);
	    }

	    if (this.borderColor) {
	      mk.set("BC", Array.from(this.borderColor).map(c => c / 255));
	    }

	    if (this.backgroundColor) {
	      mk.set("BG", Array.from(this.backgroundColor).map(c => c / 255));
	    }

	    return mk.size > 0 ? mk : null;
	  }

	  async save(evaluator, task, annotationStorage) {
	    const storageEntry = annotationStorage ? annotationStorage.get(this.data.id) : undefined;
	    let value = storageEntry && storageEntry.value;
	    let rotation = storageEntry && storageEntry.rotation;

	    if (value === this.data.fieldValue || value === undefined) {
	      if (!this._hasValueFromXFA && rotation === undefined) {
	        return null;
	      }

	      value = value || this.data.fieldValue;
	    }

	    if (rotation === undefined && !this._hasValueFromXFA && Array.isArray(value) && Array.isArray(this.data.fieldValue) && value.length === this.data.fieldValue.length && value.every((x, i) => x === this.data.fieldValue[i])) {
	      return null;
	    }

	    if (rotation === undefined) {
	      rotation = this.rotation;
	    }

	    let appearance = await this._getAppearance(evaluator, task, annotationStorage);

	    if (appearance === null) {
	      return null;
	    }

	    const {
	      xref
	    } = evaluator;
	    const dict = xref.fetchIfRef(this.ref);

	    if (!(dict instanceof _primitives.Dict)) {
	      return null;
	    }

	    const bbox = [0, 0, this.data.rect[2] - this.data.rect[0], this.data.rect[3] - this.data.rect[1]];
	    const xfa = {
	      path: (0, _util.stringToPDFString)(dict.get("T") || ""),
	      value
	    };
	    const newRef = xref.getNewRef();
	    const AP = new _primitives.Dict(xref);
	    AP.set("N", newRef);
	    const encrypt = xref.encrypt;
	    let originalTransform = null;
	    let newTransform = null;

	    if (encrypt) {
	      originalTransform = encrypt.createCipherTransform(this.ref.num, this.ref.gen);
	      newTransform = encrypt.createCipherTransform(newRef.num, newRef.gen);
	      appearance = newTransform.encryptString(appearance);
	    }

	    const encoder = val => (0, _util.isAscii)(val) ? val : (0, _util.stringToUTF16BEString)(val);

	    dict.set("V", Array.isArray(value) ? value.map(encoder) : encoder(value));
	    dict.set("AP", AP);
	    dict.set("M", `D:${(0, _util.getModificationDate)()}`);

	    const maybeMK = this._getMKDict(rotation);

	    if (maybeMK) {
	      dict.set("MK", maybeMK);
	    }

	    const appearanceDict = new _primitives.Dict(xref);
	    appearanceDict.set("Length", appearance.length);
	    appearanceDict.set("Subtype", _primitives.Name.get("Form"));
	    appearanceDict.set("Resources", this._getSaveFieldResources(xref));
	    appearanceDict.set("BBox", bbox);
	    const rotationMatrix = this.getRotationMatrix(annotationStorage);

	    if (rotationMatrix !== _util.IDENTITY_MATRIX) {
	      appearanceDict.set("Matrix", rotationMatrix);
	    }

	    const bufferOriginal = [`${this.ref.num} ${this.ref.gen} obj\n`];
	    (0, _writer.writeDict)(dict, bufferOriginal, originalTransform);
	    bufferOriginal.push("\nendobj\n");
	    const bufferNew = [`${newRef.num} ${newRef.gen} obj\n`];
	    (0, _writer.writeDict)(appearanceDict, bufferNew, newTransform);
	    bufferNew.push(" stream\n", appearance, "\nendstream\nendobj\n");
	    return [{
	      ref: this.ref,
	      data: bufferOriginal.join(""),
	      xfa
	    }, {
	      ref: newRef,
	      data: bufferNew.join(""),
	      xfa: null
	    }];
	  }

	  async _getAppearance(evaluator, task, annotationStorage) {
	    const isPassword = this.hasFieldFlag(_util.AnnotationFieldFlag.PASSWORD);

	    if (isPassword) {
	      return null;
	    }

	    const storageEntry = annotationStorage ? annotationStorage.get(this.data.id) : undefined;
	    let value, rotation;

	    if (storageEntry) {
	      value = storageEntry.formattedValue || storageEntry.value;
	      rotation = storageEntry.rotation;
	    }

	    if (rotation === undefined && value === undefined) {
	      if (!this._hasValueFromXFA || this.appearance) {
	        return null;
	      }
	    }

	    if (value === undefined) {
	      value = this.data.fieldValue;

	      if (!value) {
	        return "";
	      }
	    }

	    if (Array.isArray(value) && value.length === 1) {
	      value = value[0];
	    }

	    (0, _util.assert)(typeof value === "string", "Expected `value` to be a string.");
	    value = value.trim();

	    if (value === "") {
	      return "";
	    }

	    if (rotation === undefined) {
	      rotation = this.rotation;
	    }

	    let lineCount = -1;

	    if (this.data.multiLine) {
	      lineCount = value.split(/\r\n|\r|\n/).length;
	    }

	    const defaultPadding = 2;
	    const hPadding = defaultPadding;
	    let totalHeight = this.data.rect[3] - this.data.rect[1];
	    let totalWidth = this.data.rect[2] - this.data.rect[0];

	    if (rotation === 90 || rotation === 270) {
	      [totalWidth, totalHeight] = [totalHeight, totalWidth];
	    }

	    if (!this._defaultAppearance) {
	      this.data.defaultAppearanceData = (0, _default_appearance.parseDefaultAppearance)(this._defaultAppearance = "/Helvetica 0 Tf 0 g");
	    }

	    const font = await WidgetAnnotation._getFontData(evaluator, task, this.data.defaultAppearanceData, this._fieldResources.mergedResources);

	    const [defaultAppearance, fontSize] = this._computeFontSize(totalHeight - defaultPadding, totalWidth - 2 * hPadding, value, font, lineCount);

	    let descent = font.descent;

	    if (isNaN(descent)) {
	      descent = 0;
	    }

	    const defaultVPadding = Math.min(Math.floor((totalHeight - fontSize) / 2), defaultPadding);
	    const vPadding = defaultVPadding + Math.abs(descent) * fontSize;
	    const alignment = this.data.textAlignment;

	    if (this.data.multiLine) {
	      return this._getMultilineAppearance(defaultAppearance, value, font, fontSize, totalWidth, totalHeight, alignment, hPadding, vPadding, annotationStorage);
	    }

	    const encodedString = font.encodeString(value).join("");

	    if (this.data.comb) {
	      return this._getCombAppearance(defaultAppearance, font, encodedString, totalWidth, hPadding, vPadding, annotationStorage);
	    }

	    const colors = this.getBorderAndBackgroundAppearances(annotationStorage);

	    if (alignment === 0 || alignment > 2) {
	      return `/Tx BMC q ${colors}BT ` + defaultAppearance + ` 1 0 0 1 ${hPadding} ${vPadding} Tm (${(0, _util.escapeString)(encodedString)}) Tj` + " ET Q EMC";
	    }

	    const renderedText = this._renderText(encodedString, font, fontSize, totalWidth, alignment, hPadding, vPadding);

	    return `/Tx BMC q ${colors}BT ` + defaultAppearance + ` 1 0 0 1 0 0 Tm ${renderedText}` + " ET Q EMC";
	  }

	  static async _getFontData(evaluator, task, appearanceData, resources) {
	    const operatorList = new _operator_list.OperatorList();
	    const initialState = {
	      font: null,

	      clone() {
	        return this;
	      }

	    };
	    const {
	      fontName,
	      fontSize
	    } = appearanceData;
	    await evaluator.handleSetFont(resources, [fontName && _primitives.Name.get(fontName), fontSize], null, operatorList, task, initialState, null);
	    return initialState.font;
	  }

	  _getTextWidth(text, font) {
	    return font.charsToGlyphs(text).reduce((width, glyph) => width + glyph.width, 0) / 1000;
	  }

	  _computeFontSize(height, width, text, font, lineCount) {
	    let {
	      fontSize
	    } = this.data.defaultAppearanceData;

	    if (!fontSize) {
	      const roundWithTwoDigits = x => Math.floor(x * 100) / 100;

	      if (lineCount === -1) {
	        const textWidth = this._getTextWidth(text, font);

	        fontSize = roundWithTwoDigits(Math.min(height / _util.LINE_FACTOR, width / textWidth));
	      } else {
	        const lines = text.split(/\r\n?|\n/);
	        const cachedLines = [];

	        for (const line of lines) {
	          const encoded = font.encodeString(line).join("");
	          const glyphs = font.charsToGlyphs(encoded);
	          const positions = font.getCharPositions(encoded);
	          cachedLines.push({
	            line: encoded,
	            glyphs,
	            positions
	          });
	        }

	        const isTooBig = fsize => {
	          let totalHeight = 0;

	          for (const cache of cachedLines) {
	            const chunks = this._splitLine(null, font, fsize, width, cache);

	            totalHeight += chunks.length * fsize;

	            if (totalHeight > height) {
	              return true;
	            }
	          }

	          return false;
	        };

	        fontSize = 12;
	        let lineHeight = fontSize * _util.LINE_FACTOR;
	        let numberOfLines = Math.round(height / lineHeight);
	        numberOfLines = Math.max(numberOfLines, lineCount);

	        while (true) {
	          lineHeight = height / numberOfLines;
	          fontSize = roundWithTwoDigits(lineHeight / _util.LINE_FACTOR);

	          if (isTooBig(fontSize)) {
	            numberOfLines++;
	            continue;
	          }

	          break;
	        }
	      }

	      const {
	        fontName,
	        fontColor
	      } = this.data.defaultAppearanceData;
	      this._defaultAppearance = (0, _default_appearance.createDefaultAppearance)({
	        fontSize,
	        fontName,
	        fontColor
	      });
	    }

	    return [this._defaultAppearance, fontSize];
	  }

	  _renderText(text, font, fontSize, totalWidth, alignment, hPadding, vPadding) {
	    let shift;

	    if (alignment === 1) {
	      const width = this._getTextWidth(text, font) * fontSize;
	      shift = (totalWidth - width) / 2;
	    } else if (alignment === 2) {
	      const width = this._getTextWidth(text, font) * fontSize;
	      shift = totalWidth - width - hPadding;
	    } else {
	      shift = hPadding;
	    }

	    shift = (0, _core_utils.numberToString)(shift);
	    vPadding = (0, _core_utils.numberToString)(vPadding);
	    return `${shift} ${vPadding} Td (${(0, _util.escapeString)(text)}) Tj`;
	  }

	  _getSaveFieldResources(xref) {
	    const {
	      localResources,
	      appearanceResources,
	      acroFormResources
	    } = this._fieldResources;
	    const fontName = this.data.defaultAppearanceData && this.data.defaultAppearanceData.fontName;

	    if (!fontName) {
	      return localResources || _primitives.Dict.empty;
	    }

	    for (const resources of [localResources, appearanceResources]) {
	      if (resources instanceof _primitives.Dict) {
	        const localFont = resources.get("Font");

	        if (localFont instanceof _primitives.Dict && localFont.has(fontName)) {
	          return resources;
	        }
	      }
	    }

	    if (acroFormResources instanceof _primitives.Dict) {
	      const acroFormFont = acroFormResources.get("Font");

	      if (acroFormFont instanceof _primitives.Dict && acroFormFont.has(fontName)) {
	        const subFontDict = new _primitives.Dict(xref);
	        subFontDict.set(fontName, acroFormFont.getRaw(fontName));
	        const subResourcesDict = new _primitives.Dict(xref);
	        subResourcesDict.set("Font", subFontDict);
	        return _primitives.Dict.merge({
	          xref,
	          dictArray: [subResourcesDict, localResources],
	          mergeSubDicts: true
	        });
	      }
	    }

	    return localResources || _primitives.Dict.empty;
	  }

	  getFieldObject() {
	    return null;
	  }

	}

	class TextWidgetAnnotation extends WidgetAnnotation {
	  constructor(params) {
	    super(params);
	    this._hasText = true;
	    const dict = params.dict;

	    if (typeof this.data.fieldValue !== "string") {
	      this.data.fieldValue = "";
	    }

	    let alignment = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "Q"
	    });

	    if (!Number.isInteger(alignment) || alignment < 0 || alignment > 2) {
	      alignment = null;
	    }

	    this.data.textAlignment = alignment;
	    let maximumLength = (0, _core_utils.getInheritableProperty)({
	      dict,
	      key: "MaxLen"
	    });

	    if (!Number.isInteger(maximumLength) || maximumLength < 0) {
	      maximumLength = 0;
	    }

	    this.data.maxLen = maximumLength;
	    this.data.multiLine = this.hasFieldFlag(_util.AnnotationFieldFlag.MULTILINE);
	    this.data.comb = this.hasFieldFlag(_util.AnnotationFieldFlag.COMB) && !this.hasFieldFlag(_util.AnnotationFieldFlag.MULTILINE) && !this.hasFieldFlag(_util.AnnotationFieldFlag.PASSWORD) && !this.hasFieldFlag(_util.AnnotationFieldFlag.FILESELECT) && this.data.maxLen !== 0;
	    this.data.doNotScroll = this.hasFieldFlag(_util.AnnotationFieldFlag.DONOTSCROLL);
	  }

	  _getCombAppearance(defaultAppearance, font, text, width, hPadding, vPadding, annotationStorage) {
	    const combWidth = (0, _core_utils.numberToString)(width / this.data.maxLen);
	    const buf = [];
	    const positions = font.getCharPositions(text);

	    for (const [start, end] of positions) {
	      buf.push(`(${(0, _util.escapeString)(text.substring(start, end))}) Tj`);
	    }

	    const colors = this.getBorderAndBackgroundAppearances(annotationStorage);
	    const renderedComb = buf.join(` ${combWidth} 0 Td `);
	    return `/Tx BMC q ${colors}BT ` + defaultAppearance + ` 1 0 0 1 ${hPadding} ${vPadding} Tm ${renderedComb}` + " ET Q EMC";
	  }

	  _getMultilineAppearance(defaultAppearance, text, font, fontSize, width, height, alignment, hPadding, vPadding, annotationStorage) {
	    const lines = text.split(/\r\n?|\n/);
	    const buf = [];
	    const totalWidth = width - 2 * hPadding;

	    for (const line of lines) {
	      const chunks = this._splitLine(line, font, fontSize, totalWidth);

	      for (const chunk of chunks) {
	        const padding = buf.length === 0 ? hPadding : 0;
	        buf.push(this._renderText(chunk, font, fontSize, width, alignment, padding, -fontSize));
	      }
	    }

	    const renderedText = buf.join("\n");
	    const colors = this.getBorderAndBackgroundAppearances(annotationStorage);
	    return `/Tx BMC q ${colors}BT ` + defaultAppearance + ` 1 0 0 1 0 ${height} Tm ${renderedText}` + " ET Q EMC";
	  }

	  _splitLine(line, font, fontSize, width, cache = {}) {
	    line = cache.line || font.encodeString(line).join("");
	    const glyphs = cache.glyphs || font.charsToGlyphs(line);

	    if (glyphs.length <= 1) {
	      return [line];
	    }

	    const positions = cache.positions || font.getCharPositions(line);
	    const scale = fontSize / 1000;
	    const chunks = [];
	    let lastSpacePosInStringStart = -1,
	        lastSpacePosInStringEnd = -1,
	        lastSpacePos = -1,
	        startChunk = 0,
	        currentWidth = 0;

	    for (let i = 0, ii = glyphs.length; i < ii; i++) {
	      const [start, end] = positions[i];
	      const glyph = glyphs[i];
	      const glyphWidth = glyph.width * scale;

	      if (glyph.unicode === " ") {
	        if (currentWidth + glyphWidth > width) {
	          chunks.push(line.substring(startChunk, start));
	          startChunk = start;
	          currentWidth = glyphWidth;
	          lastSpacePosInStringStart = -1;
	          lastSpacePos = -1;
	        } else {
	          currentWidth += glyphWidth;
	          lastSpacePosInStringStart = start;
	          lastSpacePosInStringEnd = end;
	          lastSpacePos = i;
	        }
	      } else {
	        if (currentWidth + glyphWidth > width) {
	          if (lastSpacePosInStringStart !== -1) {
	            chunks.push(line.substring(startChunk, lastSpacePosInStringEnd));
	            startChunk = lastSpacePosInStringEnd;
	            i = lastSpacePos + 1;
	            lastSpacePosInStringStart = -1;
	            currentWidth = 0;
	          } else {
	            chunks.push(line.substring(startChunk, start));
	            startChunk = start;
	            currentWidth = glyphWidth;
	          }
	        } else {
	          currentWidth += glyphWidth;
	        }
	      }
	    }

	    if (startChunk < line.length) {
	      chunks.push(line.substring(startChunk, line.length));
	    }

	    return chunks;
	  }

	  getFieldObject() {
	    return {
	      id: this.data.id,
	      value: this.data.fieldValue,
	      defaultValue: this.data.defaultFieldValue || "",
	      multiline: this.data.multiLine,
	      password: this.hasFieldFlag(_util.AnnotationFieldFlag.PASSWORD),
	      charLimit: this.data.maxLen,
	      comb: this.data.comb,
	      editable: !this.data.readOnly,
	      hidden: this.data.hidden,
	      name: this.data.fieldName,
	      rect: this.data.rect,
	      actions: this.data.actions,
	      page: this.data.pageIndex,
	      strokeColor: this.data.borderColor,
	      fillColor: this.data.backgroundColor,
	      rotation: this.rotation,
	      type: "text"
	    };
	  }

	}

	class ButtonWidgetAnnotation extends WidgetAnnotation {
	  constructor(params) {
	    super(params);
	    this.checkedAppearance = null;
	    this.uncheckedAppearance = null;
	    this.data.checkBox = !this.hasFieldFlag(_util.AnnotationFieldFlag.RADIO) && !this.hasFieldFlag(_util.AnnotationFieldFlag.PUSHBUTTON);
	    this.data.radioButton = this.hasFieldFlag(_util.AnnotationFieldFlag.RADIO) && !this.hasFieldFlag(_util.AnnotationFieldFlag.PUSHBUTTON);
	    this.data.pushButton = this.hasFieldFlag(_util.AnnotationFieldFlag.PUSHBUTTON);
	    this.data.isTooltipOnly = false;

	    if (this.data.checkBox) {
	      this._processCheckBox(params);
	    } else if (this.data.radioButton) {
	      this._processRadioButton(params);
	    } else if (this.data.pushButton) {
	      this.data.hasOwnCanvas = true;

	      this._processPushButton(params);
	    } else {
	      (0, _util.warn)("Invalid field flags for button widget annotation");
	    }
	  }

	  async getOperatorList(evaluator, task, intent, renderForms, annotationStorage) {
	    if (this.data.pushButton) {
	      return super.getOperatorList(evaluator, task, intent, false, annotationStorage);
	    }

	    let value = null;
	    let rotation = null;

	    if (annotationStorage) {
	      const storageEntry = annotationStorage.get(this.data.id);
	      value = storageEntry ? storageEntry.value : null;
	      rotation = storageEntry ? storageEntry.rotation : null;
	    }

	    if (value === null && this.appearance) {
	      return super.getOperatorList(evaluator, task, intent, renderForms, annotationStorage);
	    }

	    if (value === null || value === undefined) {
	      if (this.data.checkBox) {
	        value = this.data.fieldValue === this.data.exportValue;
	      } else {
	        value = this.data.fieldValue === this.data.buttonValue;
	      }
	    }

	    const appearance = value ? this.checkedAppearance : this.uncheckedAppearance;

	    if (appearance) {
	      const savedAppearance = this.appearance;

	      const savedMatrix = appearance.dict.getArray("Matrix") || _util.IDENTITY_MATRIX;

	      if (rotation) {
	        appearance.dict.set("Matrix", this.getRotationMatrix(annotationStorage));
	      }

	      this.appearance = appearance;
	      const operatorList = super.getOperatorList(evaluator, task, intent, renderForms, annotationStorage);
	      this.appearance = savedAppearance;
	      appearance.dict.set("Matrix", savedMatrix);
	      return operatorList;
	    }

	    return {
	      opList: new _operator_list.OperatorList(),
	      separateForm: false,
	      separateCanvas: false
	    };
	  }

	  async save(evaluator, task, annotationStorage) {
	    if (this.data.checkBox) {
	      return this._saveCheckbox(evaluator, task, annotationStorage);
	    }

	    if (this.data.radioButton) {
	      return this._saveRadioButton(evaluator, task, annotationStorage);
	    }

	    return null;
	  }

	  async _saveCheckbox(evaluator, task, annotationStorage) {
	    if (!annotationStorage) {
	      return null;
	    }

	    const storageEntry = annotationStorage.get(this.data.id);
	    let rotation = storageEntry && storageEntry.rotation;
	    let value = storageEntry && storageEntry.value;

	    if (rotation === undefined) {
	      if (value === undefined) {
	        return null;
	      }

	      const defaultValue = this.data.fieldValue === this.data.exportValue;

	      if (defaultValue === value) {
	        return null;
	      }
	    }

	    const dict = evaluator.xref.fetchIfRef(this.ref);

	    if (!(dict instanceof _primitives.Dict)) {
	      return null;
	    }

	    if (rotation === undefined) {
	      rotation = this.rotation;
	    }

	    if (value === undefined) {
	      value = this.data.fieldValue === this.data.exportValue;
	    }

	    const xfa = {
	      path: (0, _util.stringToPDFString)(dict.get("T") || ""),
	      value: value ? this.data.exportValue : ""
	    };

	    const name = _primitives.Name.get(value ? this.data.exportValue : "Off");

	    dict.set("V", name);
	    dict.set("AS", name);
	    dict.set("M", `D:${(0, _util.getModificationDate)()}`);

	    const maybeMK = this._getMKDict(rotation);

	    if (maybeMK) {
	      dict.set("MK", maybeMK);
	    }

	    const encrypt = evaluator.xref.encrypt;
	    let originalTransform = null;

	    if (encrypt) {
	      originalTransform = encrypt.createCipherTransform(this.ref.num, this.ref.gen);
	    }

	    const buffer = [`${this.ref.num} ${this.ref.gen} obj\n`];
	    (0, _writer.writeDict)(dict, buffer, originalTransform);
	    buffer.push("\nendobj\n");
	    return [{
	      ref: this.ref,
	      data: buffer.join(""),
	      xfa
	    }];
	  }

	  async _saveRadioButton(evaluator, task, annotationStorage) {
	    if (!annotationStorage) {
	      return null;
	    }

	    const storageEntry = annotationStorage.get(this.data.id);
	    let rotation = storageEntry && storageEntry.rotation;
	    let value = storageEntry && storageEntry.value;

	    if (rotation === undefined) {
	      if (value === undefined) {
	        return null;
	      }

	      const defaultValue = this.data.fieldValue === this.data.buttonValue;

	      if (defaultValue === value) {
	        return null;
	      }
	    }

	    const dict = evaluator.xref.fetchIfRef(this.ref);

	    if (!(dict instanceof _primitives.Dict)) {
	      return null;
	    }

	    if (value === undefined) {
	      value = this.data.fieldValue === this.data.buttonValue;
	    }

	    if (rotation === undefined) {
	      rotation = this.rotation;
	    }

	    const xfa = {
	      path: (0, _util.stringToPDFString)(dict.get("T") || ""),
	      value: value ? this.data.buttonValue : ""
	    };

	    const name = _primitives.Name.get(value ? this.data.buttonValue : "Off");

	    let parentBuffer = null;
	    const encrypt = evaluator.xref.encrypt;

	    if (value) {
	      if (this.parent instanceof _primitives.Ref) {
	        const parent = evaluator.xref.fetch(this.parent);
	        let parentTransform = null;

	        if (encrypt) {
	          parentTransform = encrypt.createCipherTransform(this.parent.num, this.parent.gen);
	        }

	        parent.set("V", name);
	        parentBuffer = [`${this.parent.num} ${this.parent.gen} obj\n`];
	        (0, _writer.writeDict)(parent, parentBuffer, parentTransform);
	        parentBuffer.push("\nendobj\n");
	      } else if (this.parent instanceof _primitives.Dict) {
	        this.parent.set("V", name);
	      }
	    }

	    dict.set("AS", name);
	    dict.set("M", `D:${(0, _util.getModificationDate)()}`);

	    const maybeMK = this._getMKDict(rotation);

	    if (maybeMK) {
	      dict.set("MK", maybeMK);
	    }

	    let originalTransform = null;

	    if (encrypt) {
	      originalTransform = encrypt.createCipherTransform(this.ref.num, this.ref.gen);
	    }

	    const buffer = [`${this.ref.num} ${this.ref.gen} obj\n`];
	    (0, _writer.writeDict)(dict, buffer, originalTransform);
	    buffer.push("\nendobj\n");
	    const newRefs = [{
	      ref: this.ref,
	      data: buffer.join(""),
	      xfa
	    }];

	    if (parentBuffer !== null) {
	      newRefs.push({
	        ref: this.parent,
	        data: parentBuffer.join(""),
	        xfa: null
	      });
	    }

	    return newRefs;
	  }

	  _getDefaultCheckedAppearance(params, type) {
	    const width = this.data.rect[2] - this.data.rect[0];
	    const height = this.data.rect[3] - this.data.rect[1];
	    const bbox = [0, 0, width, height];
	    const FONT_RATIO = 0.8;
	    const fontSize = Math.min(width, height) * FONT_RATIO;
	    let metrics, char;

	    if (type === "check") {
	      metrics = {
	        width: 0.755 * fontSize,
	        height: 0.705 * fontSize
	      };
	      char = "\x33";
	    } else if (type === "disc") {
	      metrics = {
	        width: 0.791 * fontSize,
	        height: 0.705 * fontSize
	      };
	      char = "\x6C";
	    } else {
	      (0, _util.unreachable)(`_getDefaultCheckedAppearance - unsupported type: ${type}`);
	    }

	    const xShift = (0, _core_utils.numberToString)((width - metrics.width) / 2);
	    const yShift = (0, _core_utils.numberToString)((height - metrics.height) / 2);
	    const appearance = `q BT /PdfJsZaDb ${fontSize} Tf 0 g ${xShift} ${yShift} Td (${char}) Tj ET Q`;
	    const appearanceStreamDict = new _primitives.Dict(params.xref);
	    appearanceStreamDict.set("FormType", 1);
	    appearanceStreamDict.set("Subtype", _primitives.Name.get("Form"));
	    appearanceStreamDict.set("Type", _primitives.Name.get("XObject"));
	    appearanceStreamDict.set("BBox", bbox);
	    appearanceStreamDict.set("Matrix", [1, 0, 0, 1, 0, 0]);
	    appearanceStreamDict.set("Length", appearance.length);
	    const resources = new _primitives.Dict(params.xref);
	    const font = new _primitives.Dict(params.xref);
	    font.set("PdfJsZaDb", this.fallbackFontDict);
	    resources.set("Font", font);
	    appearanceStreamDict.set("Resources", resources);
	    this.checkedAppearance = new _stream.StringStream(appearance);
	    this.checkedAppearance.dict = appearanceStreamDict;

	    this._streams.push(this.checkedAppearance);
	  }

	  _processCheckBox(params) {
	    const customAppearance = params.dict.get("AP");

	    if (!(customAppearance instanceof _primitives.Dict)) {
	      return;
	    }

	    const normalAppearance = customAppearance.get("N");

	    if (!(normalAppearance instanceof _primitives.Dict)) {
	      return;
	    }

	    const asValue = this._decodeFormValue(params.dict.get("AS"));

	    if (typeof asValue === "string") {
	      this.data.fieldValue = asValue;
	    }

	    const yes = this.data.fieldValue !== null && this.data.fieldValue !== "Off" ? this.data.fieldValue : "Yes";
	    const exportValues = normalAppearance.getKeys();

	    if (exportValues.length === 0) {
	      exportValues.push("Off", yes);
	    } else if (exportValues.length === 1) {
	      if (exportValues[0] === "Off") {
	        exportValues.push(yes);
	      } else {
	        exportValues.unshift("Off");
	      }
	    } else if (exportValues.includes(yes)) {
	      exportValues.length = 0;
	      exportValues.push("Off", yes);
	    } else {
	      const otherYes = exportValues.find(v => v !== "Off");
	      exportValues.length = 0;
	      exportValues.push("Off", otherYes);
	    }

	    if (!exportValues.includes(this.data.fieldValue)) {
	      this.data.fieldValue = "Off";
	    }

	    this.data.exportValue = exportValues[1];
	    this.checkedAppearance = normalAppearance.get(this.data.exportValue) || null;
	    this.uncheckedAppearance = normalAppearance.get("Off") || null;

	    if (this.checkedAppearance) {
	      this._streams.push(this.checkedAppearance);
	    } else {
	      this._getDefaultCheckedAppearance(params, "check");
	    }

	    if (this.uncheckedAppearance) {
	      this._streams.push(this.uncheckedAppearance);
	    }

	    this._fallbackFontDict = this.fallbackFontDict;
	  }

	  _processRadioButton(params) {
	    this.data.fieldValue = this.data.buttonValue = null;
	    const fieldParent = params.dict.get("Parent");

	    if (fieldParent instanceof _primitives.Dict) {
	      this.parent = params.dict.getRaw("Parent");
	      const fieldParentValue = fieldParent.get("V");

	      if (fieldParentValue instanceof _primitives.Name) {
	        this.data.fieldValue = this._decodeFormValue(fieldParentValue);
	      }
	    }

	    const appearanceStates = params.dict.get("AP");

	    if (!(appearanceStates instanceof _primitives.Dict)) {
	      return;
	    }

	    const normalAppearance = appearanceStates.get("N");

	    if (!(normalAppearance instanceof _primitives.Dict)) {
	      return;
	    }

	    for (const key of normalAppearance.getKeys()) {
	      if (key !== "Off") {
	        this.data.buttonValue = this._decodeFormValue(key);
	        break;
	      }
	    }

	    this.checkedAppearance = normalAppearance.get(this.data.buttonValue) || null;
	    this.uncheckedAppearance = normalAppearance.get("Off") || null;

	    if (this.checkedAppearance) {
	      this._streams.push(this.checkedAppearance);
	    } else {
	      this._getDefaultCheckedAppearance(params, "disc");
	    }

	    if (this.uncheckedAppearance) {
	      this._streams.push(this.uncheckedAppearance);
	    }

	    this._fallbackFontDict = this.fallbackFontDict;
	  }

	  _processPushButton(params) {
	    if (!params.dict.has("A") && !params.dict.has("AA") && !this.data.alternativeText) {
	      (0, _util.warn)("Push buttons without action dictionaries are not supported");
	      return;
	    }

	    this.data.isTooltipOnly = !params.dict.has("A") && !params.dict.has("AA");

	    _catalog.Catalog.parseDestDictionary({
	      destDict: params.dict,
	      resultObj: this.data,
	      docBaseUrl: params.pdfManager.docBaseUrl
	    });
	  }

	  getFieldObject() {
	    let type = "button";
	    let exportValues;

	    if (this.data.checkBox) {
	      type = "checkbox";
	      exportValues = this.data.exportValue;
	    } else if (this.data.radioButton) {
	      type = "radiobutton";
	      exportValues = this.data.buttonValue;
	    }

	    return {
	      id: this.data.id,
	      value: this.data.fieldValue || "Off",
	      defaultValue: this.data.defaultFieldValue,
	      exportValues,
	      editable: !this.data.readOnly,
	      name: this.data.fieldName,
	      rect: this.data.rect,
	      hidden: this.data.hidden,
	      actions: this.data.actions,
	      page: this.data.pageIndex,
	      strokeColor: this.data.borderColor,
	      fillColor: this.data.backgroundColor,
	      rotation: this.rotation,
	      type
	    };
	  }

	  get fallbackFontDict() {
	    const dict = new _primitives.Dict();
	    dict.set("BaseFont", _primitives.Name.get("ZapfDingbats"));
	    dict.set("Type", _primitives.Name.get("FallbackType"));
	    dict.set("Subtype", _primitives.Name.get("FallbackType"));
	    dict.set("Encoding", _primitives.Name.get("ZapfDingbatsEncoding"));
	    return (0, _util.shadow)(this, "fallbackFontDict", dict);
	  }

	}

	class ChoiceWidgetAnnotation extends WidgetAnnotation {
	  constructor(params) {
	    super(params);
	    this.data.options = [];
	    const options = (0, _core_utils.getInheritableProperty)({
	      dict: params.dict,
	      key: "Opt"
	    });

	    if (Array.isArray(options)) {
	      const xref = params.xref;

	      for (let i = 0, ii = options.length; i < ii; i++) {
	        const option = xref.fetchIfRef(options[i]);
	        const isOptionArray = Array.isArray(option);
	        this.data.options[i] = {
	          exportValue: this._decodeFormValue(isOptionArray ? xref.fetchIfRef(option[0]) : option),
	          displayValue: this._decodeFormValue(isOptionArray ? xref.fetchIfRef(option[1]) : option)
	        };
	      }
	    }

	    if (typeof this.data.fieldValue === "string") {
	      this.data.fieldValue = [this.data.fieldValue];
	    } else if (!this.data.fieldValue) {
	      this.data.fieldValue = [];
	    }

	    this.data.combo = this.hasFieldFlag(_util.AnnotationFieldFlag.COMBO);
	    this.data.multiSelect = this.hasFieldFlag(_util.AnnotationFieldFlag.MULTISELECT);
	    this._hasText = true;
	  }

	  getFieldObject() {
	    const type = this.data.combo ? "combobox" : "listbox";
	    const value = this.data.fieldValue.length > 0 ? this.data.fieldValue[0] : null;
	    return {
	      id: this.data.id,
	      value,
	      defaultValue: this.data.defaultFieldValue,
	      editable: !this.data.readOnly,
	      name: this.data.fieldName,
	      rect: this.data.rect,
	      numItems: this.data.fieldValue.length,
	      multipleSelection: this.data.multiSelect,
	      hidden: this.data.hidden,
	      actions: this.data.actions,
	      items: this.data.options,
	      page: this.data.pageIndex,
	      strokeColor: this.data.borderColor,
	      fillColor: this.data.backgroundColor,
	      rotation: this.rotation,
	      type
	    };
	  }

	  async _getAppearance(evaluator, task, annotationStorage) {
	    if (this.data.combo) {
	      return super._getAppearance(evaluator, task, annotationStorage);
	    }

	    if (!annotationStorage) {
	      return null;
	    }

	    const storageEntry = annotationStorage.get(this.data.id);

	    if (!storageEntry) {
	      return null;
	    }

	    const rotation = storageEntry.rotation;
	    let exportedValue = storageEntry.value;

	    if (rotation === undefined && exportedValue === undefined) {
	      return null;
	    }

	    if (exportedValue === undefined) {
	      exportedValue = this.data.fieldValue;
	    } else if (!Array.isArray(exportedValue)) {
	      exportedValue = [exportedValue];
	    }

	    const defaultPadding = 2;
	    const hPadding = defaultPadding;
	    let totalHeight = this.data.rect[3] - this.data.rect[1];
	    let totalWidth = this.data.rect[2] - this.data.rect[0];

	    if (rotation === 90 || rotation === 270) {
	      [totalWidth, totalHeight] = [totalHeight, totalWidth];
	    }

	    const lineCount = this.data.options.length;
	    const valueIndices = [];

	    for (let i = 0; i < lineCount; i++) {
	      const {
	        exportValue
	      } = this.data.options[i];

	      if (exportedValue.includes(exportValue)) {
	        valueIndices.push(i);
	      }
	    }

	    if (!this._defaultAppearance) {
	      this.data.defaultAppearanceData = (0, _default_appearance.parseDefaultAppearance)(this._defaultAppearance = "/Helvetica 0 Tf 0 g");
	    }

	    const font = await WidgetAnnotation._getFontData(evaluator, task, this.data.defaultAppearanceData, this._fieldResources.mergedResources);
	    let defaultAppearance;
	    let {
	      fontSize
	    } = this.data.defaultAppearanceData;

	    if (!fontSize) {
	      const lineHeight = (totalHeight - defaultPadding) / lineCount;
	      let lineWidth = -1;
	      let value;

	      for (const {
	        displayValue
	      } of this.data.options) {
	        const width = this._getTextWidth(displayValue, font);

	        if (width > lineWidth) {
	          lineWidth = width;
	          value = displayValue;
	        }
	      }

	      [defaultAppearance, fontSize] = this._computeFontSize(lineHeight, totalWidth - 2 * hPadding, value, font, -1);
	    } else {
	      defaultAppearance = this._defaultAppearance;
	    }

	    const lineHeight = fontSize * _util.LINE_FACTOR;
	    const vPadding = (lineHeight - fontSize) / 2;
	    const numberOfVisibleLines = Math.floor(totalHeight / lineHeight);
	    let firstIndex;

	    if (valueIndices.length === 1) {
	      const valuePosition = valueIndices[0];
	      const indexInPage = valuePosition % numberOfVisibleLines;
	      firstIndex = valuePosition - indexInPage;
	    } else {
	      firstIndex = valueIndices.length ? valueIndices[0] : 0;
	    }

	    const end = Math.min(firstIndex + numberOfVisibleLines + 1, lineCount);
	    const buf = ["/Tx BMC q", `1 1 ${totalWidth} ${totalHeight} re W n`];

	    if (valueIndices.length) {
	      buf.push("0.600006 0.756866 0.854904 rg");

	      for (const index of valueIndices) {
	        if (firstIndex <= index && index < end) {
	          buf.push(`1 ${totalHeight - (index - firstIndex + 1) * lineHeight} ${totalWidth} ${lineHeight} re f`);
	        }
	      }
	    }

	    buf.push("BT", defaultAppearance, `1 0 0 1 0 ${totalHeight} Tm`);

	    for (let i = firstIndex; i < end; i++) {
	      const {
	        displayValue
	      } = this.data.options[i];
	      const hpadding = i === firstIndex ? hPadding : 0;
	      const vpadding = i === firstIndex ? vPadding : 0;
	      buf.push(this._renderText(displayValue, font, fontSize, totalWidth, 0, hpadding, -lineHeight + vpadding));
	    }

	    buf.push("ET Q EMC");
	    return buf.join("\n");
	  }

	}

	class SignatureWidgetAnnotation extends WidgetAnnotation {
	  constructor(params) {
	    super(params);
	    this.data.fieldValue = null;
	  }

	  getFieldObject() {
	    return {
	      id: this.data.id,
	      value: null,
	      page: this.data.pageIndex,
	      type: "signature"
	    };
	  }

	}

	class TextAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    const DEFAULT_ICON_SIZE = 22;
	    super(parameters);
	    const dict = parameters.dict;
	    this.data.annotationType = _util.AnnotationType.TEXT;

	    if (this.data.hasAppearance) {
	      this.data.name = "NoIcon";
	    } else {
	      this.data.rect[1] = this.data.rect[3] - DEFAULT_ICON_SIZE;
	      this.data.rect[2] = this.data.rect[0] + DEFAULT_ICON_SIZE;
	      this.data.name = dict.has("Name") ? dict.get("Name").name : "Note";
	    }

	    if (dict.has("State")) {
	      this.data.state = dict.get("State") || null;
	      this.data.stateModel = dict.get("StateModel") || null;
	    } else {
	      this.data.state = null;
	      this.data.stateModel = null;
	    }
	  }

	}

	class LinkAnnotation extends Annotation {
	  constructor(params) {
	    super(params);
	    this.data.annotationType = _util.AnnotationType.LINK;
	    const quadPoints = getQuadPoints(params.dict, this.rectangle);

	    if (quadPoints) {
	      this.data.quadPoints = quadPoints;
	    }

	    this.data.borderColor = this.data.borderColor || this.data.color;

	    _catalog.Catalog.parseDestDictionary({
	      destDict: params.dict,
	      resultObj: this.data,
	      docBaseUrl: params.pdfManager.docBaseUrl
	    });
	  }

	}

	class PopupAnnotation extends Annotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.POPUP;
	    let parentItem = parameters.dict.get("Parent");

	    if (!parentItem) {
	      (0, _util.warn)("Popup annotation has a missing or invalid parent annotation.");
	      return;
	    }

	    const parentSubtype = parentItem.get("Subtype");
	    this.data.parentType = parentSubtype instanceof _primitives.Name ? parentSubtype.name : null;
	    const rawParent = parameters.dict.getRaw("Parent");
	    this.data.parentId = rawParent instanceof _primitives.Ref ? rawParent.toString() : null;
	    const parentRect = parentItem.getArray("Rect");

	    if (Array.isArray(parentRect) && parentRect.length === 4) {
	      this.data.parentRect = _util.Util.normalizeRect(parentRect);
	    } else {
	      this.data.parentRect = [0, 0, 0, 0];
	    }

	    const rt = parentItem.get("RT");

	    if ((0, _primitives.isName)(rt, _util.AnnotationReplyType.GROUP)) {
	      parentItem = parentItem.get("IRT");
	    }

	    if (!parentItem.has("M")) {
	      this.data.modificationDate = null;
	    } else {
	      this.setModificationDate(parentItem.get("M"));
	      this.data.modificationDate = this.modificationDate;
	    }

	    if (!parentItem.has("C")) {
	      this.data.color = null;
	    } else {
	      this.setColor(parentItem.getArray("C"));
	      this.data.color = this.color;
	    }

	    if (!this.viewable) {
	      const parentFlags = parentItem.get("F");

	      if (this._isViewable(parentFlags)) {
	        this.setFlags(parentFlags);
	      }
	    }

	    this.setTitle(parentItem.get("T"));
	    this.data.titleObj = this._title;
	    this.setContents(parentItem.get("Contents"));
	    this.data.contentsObj = this._contents;

	    if (parentItem.has("RC")) {
	      this.data.richText = _factory.XFAFactory.getRichTextAsHtml(parentItem.get("RC"));
	    }
	  }

	}

	exports.PopupAnnotation = PopupAnnotation;

	class FreeTextAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.FREETEXT;
	  }

	  get hasTextContent() {
	    return !!this.appearance;
	  }

	  static createNewDict(annotation, xref, {
	    apRef,
	    ap
	  }) {
	    const {
	      color,
	      fontSize,
	      rect,
	      rotation,
	      user,
	      value
	    } = annotation;
	    const freetext = new _primitives.Dict(xref);
	    freetext.set("Type", _primitives.Name.get("Annot"));
	    freetext.set("Subtype", _primitives.Name.get("FreeText"));
	    freetext.set("CreationDate", `D:${(0, _util.getModificationDate)()}`);
	    freetext.set("Rect", rect);
	    const da = `/Helv ${fontSize} Tf ${(0, _default_appearance.getPdfColor)(color, true)}`;
	    freetext.set("DA", da);
	    freetext.set("Contents", value);
	    freetext.set("F", 4);
	    freetext.set("Border", [0, 0, 0]);
	    freetext.set("Rotate", rotation);

	    if (user) {
	      freetext.set("T", (0, _util.stringToUTF8String)(user));
	    }

	    const n = new _primitives.Dict(xref);
	    freetext.set("AP", n);

	    if (apRef) {
	      n.set("N", apRef);
	    } else {
	      n.set("N", ap);
	    }

	    return freetext;
	  }

	  static async createNewAppearanceStream(annotation, xref, params) {
	    const {
	      baseFontRef,
	      evaluator,
	      task
	    } = params;
	    const {
	      color,
	      fontSize,
	      rect,
	      rotation,
	      value
	    } = annotation;
	    const resources = new _primitives.Dict(xref);
	    const font = new _primitives.Dict(xref);

	    if (baseFontRef) {
	      font.set("Helv", baseFontRef);
	    } else {
	      const baseFont = new _primitives.Dict(xref);
	      baseFont.set("BaseFont", _primitives.Name.get("Helvetica"));
	      baseFont.set("Type", _primitives.Name.get("Font"));
	      baseFont.set("Subtype", _primitives.Name.get("Type1"));
	      baseFont.set("Encoding", _primitives.Name.get("WinAnsiEncoding"));
	      font.set("Helv", baseFont);
	    }

	    resources.set("Font", font);
	    const helv = await WidgetAnnotation._getFontData(evaluator, task, {
	      fontName: "Helvetica",
	      fontSize
	    }, resources);
	    const [x1, y1, x2, y2] = rect;
	    let w = x2 - x1;
	    let h = y2 - y1;

	    if (rotation % 180 !== 0) {
	      [w, h] = [h, w];
	    }

	    const lines = value.split("\n");
	    const scale = fontSize / 1000;
	    let totalWidth = -Infinity;
	    const encodedLines = [];

	    for (let line of lines) {
	      line = helv.encodeString(line).join("");
	      encodedLines.push(line);
	      let lineWidth = 0;
	      const glyphs = helv.charsToGlyphs(line);

	      for (const glyph of glyphs) {
	        lineWidth += glyph.width * scale;
	      }

	      totalWidth = Math.max(totalWidth, lineWidth);
	    }

	    let hscale = 1;

	    if (totalWidth > w) {
	      hscale = w / totalWidth;
	    }

	    let vscale = 1;
	    const lineHeight = _util.LINE_FACTOR * fontSize;
	    const lineDescent = _util.LINE_DESCENT_FACTOR * fontSize;
	    const totalHeight = lineHeight * lines.length;

	    if (totalHeight > h) {
	      vscale = h / totalHeight;
	    }

	    const fscale = Math.min(hscale, vscale);
	    const newFontSize = fontSize * fscale;
	    const buffer = ["q", `0 0 ${(0, _core_utils.numberToString)(w)} ${(0, _core_utils.numberToString)(h)} re W n`, `BT`, `1 0 0 1 0 ${(0, _core_utils.numberToString)(h + lineDescent)} Tm 0 Tc ${(0, _default_appearance.getPdfColor)(color, true)}`, `/Helv ${(0, _core_utils.numberToString)(newFontSize)} Tf`];
	    const vShift = (0, _core_utils.numberToString)(lineHeight);

	    for (const line of encodedLines) {
	      buffer.push(`0 -${vShift} Td (${(0, _util.escapeString)(line)}) Tj`);
	    }

	    buffer.push("ET", "Q");
	    const appearance = buffer.join("\n");
	    const appearanceStreamDict = new _primitives.Dict(xref);
	    appearanceStreamDict.set("FormType", 1);
	    appearanceStreamDict.set("Subtype", _primitives.Name.get("Form"));
	    appearanceStreamDict.set("Type", _primitives.Name.get("XObject"));
	    appearanceStreamDict.set("BBox", [0, 0, w, h]);
	    appearanceStreamDict.set("Length", appearance.length);
	    appearanceStreamDict.set("Resources", resources);

	    if (rotation) {
	      const matrix = WidgetAnnotation._getRotationMatrix(rotation, w, h);

	      appearanceStreamDict.set("Matrix", matrix);
	    }

	    const ap = new _stream.StringStream(appearance);
	    ap.dict = appearanceStreamDict;
	    return ap;
	  }

	}

	class LineAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    const {
	      dict
	    } = parameters;
	    this.data.annotationType = _util.AnnotationType.LINE;
	    const lineCoordinates = dict.getArray("L");
	    this.data.lineCoordinates = _util.Util.normalizeRect(lineCoordinates);
	    this.setLineEndings(dict.getArray("LE"));
	    this.data.lineEndings = this.lineEndings;

	    if (!this.appearance) {
	      const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	      const strokeAlpha = dict.get("CA");
	      let fillColor = null,
	          interiorColor = dict.getArray("IC");

	      if (interiorColor) {
	        interiorColor = getRgbColor(interiorColor, null);
	        fillColor = interiorColor ? Array.from(interiorColor).map(c => c / 255) : null;
	      }

	      const fillAlpha = fillColor ? strokeAlpha : null;
	      const borderWidth = this.borderStyle.width || 1,
	            borderAdjust = 2 * borderWidth;
	      const bbox = [this.data.lineCoordinates[0] - borderAdjust, this.data.lineCoordinates[1] - borderAdjust, this.data.lineCoordinates[2] + borderAdjust, this.data.lineCoordinates[3] + borderAdjust];

	      if (!_util.Util.intersect(this.rectangle, bbox)) {
	        this.rectangle = bbox;
	      }

	      this._setDefaultAppearance({
	        xref: parameters.xref,
	        extra: `${borderWidth} w`,
	        strokeColor,
	        fillColor,
	        strokeAlpha,
	        fillAlpha,
	        pointsCallback: (buffer, points) => {
	          buffer.push(`${lineCoordinates[0]} ${lineCoordinates[1]} m`, `${lineCoordinates[2]} ${lineCoordinates[3]} l`, "S");
	          return [points[0].x - borderWidth, points[1].x + borderWidth, points[3].y - borderWidth, points[1].y + borderWidth];
	        }
	      });
	    }
	  }

	}

	class SquareAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.SQUARE;

	    if (!this.appearance) {
	      const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	      const strokeAlpha = parameters.dict.get("CA");
	      let fillColor = null,
	          interiorColor = parameters.dict.getArray("IC");

	      if (interiorColor) {
	        interiorColor = getRgbColor(interiorColor, null);
	        fillColor = interiorColor ? Array.from(interiorColor).map(c => c / 255) : null;
	      }

	      const fillAlpha = fillColor ? strokeAlpha : null;

	      if (this.borderStyle.width === 0 && !fillColor) {
	        return;
	      }

	      this._setDefaultAppearance({
	        xref: parameters.xref,
	        extra: `${this.borderStyle.width} w`,
	        strokeColor,
	        fillColor,
	        strokeAlpha,
	        fillAlpha,
	        pointsCallback: (buffer, points) => {
	          const x = points[2].x + this.borderStyle.width / 2;
	          const y = points[2].y + this.borderStyle.width / 2;
	          const width = points[3].x - points[2].x - this.borderStyle.width;
	          const height = points[1].y - points[3].y - this.borderStyle.width;
	          buffer.push(`${x} ${y} ${width} ${height} re`);

	          if (fillColor) {
	            buffer.push("B");
	          } else {
	            buffer.push("S");
	          }

	          return [points[0].x, points[1].x, points[3].y, points[1].y];
	        }
	      });
	    }
	  }

	}

	class CircleAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.CIRCLE;

	    if (!this.appearance) {
	      const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	      const strokeAlpha = parameters.dict.get("CA");
	      let fillColor = null;
	      let interiorColor = parameters.dict.getArray("IC");

	      if (interiorColor) {
	        interiorColor = getRgbColor(interiorColor, null);
	        fillColor = interiorColor ? Array.from(interiorColor).map(c => c / 255) : null;
	      }

	      const fillAlpha = fillColor ? strokeAlpha : null;

	      if (this.borderStyle.width === 0 && !fillColor) {
	        return;
	      }

	      const controlPointsDistance = 4 / 3 * Math.tan(Math.PI / (2 * 4));

	      this._setDefaultAppearance({
	        xref: parameters.xref,
	        extra: `${this.borderStyle.width} w`,
	        strokeColor,
	        fillColor,
	        strokeAlpha,
	        fillAlpha,
	        pointsCallback: (buffer, points) => {
	          const x0 = points[0].x + this.borderStyle.width / 2;
	          const y0 = points[0].y - this.borderStyle.width / 2;
	          const x1 = points[3].x - this.borderStyle.width / 2;
	          const y1 = points[3].y + this.borderStyle.width / 2;
	          const xMid = x0 + (x1 - x0) / 2;
	          const yMid = y0 + (y1 - y0) / 2;
	          const xOffset = (x1 - x0) / 2 * controlPointsDistance;
	          const yOffset = (y1 - y0) / 2 * controlPointsDistance;
	          buffer.push(`${xMid} ${y1} m`, `${xMid + xOffset} ${y1} ${x1} ${yMid + yOffset} ${x1} ${yMid} c`, `${x1} ${yMid - yOffset} ${xMid + xOffset} ${y0} ${xMid} ${y0} c`, `${xMid - xOffset} ${y0} ${x0} ${yMid - yOffset} ${x0} ${yMid} c`, `${x0} ${yMid + yOffset} ${xMid - xOffset} ${y1} ${xMid} ${y1} c`, "h");

	          if (fillColor) {
	            buffer.push("B");
	          } else {
	            buffer.push("S");
	          }

	          return [points[0].x, points[1].x, points[3].y, points[1].y];
	        }
	      });
	    }
	  }

	}

	class PolylineAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    const {
	      dict
	    } = parameters;
	    this.data.annotationType = _util.AnnotationType.POLYLINE;
	    this.data.vertices = [];

	    if (!(this instanceof PolygonAnnotation)) {
	      this.setLineEndings(dict.getArray("LE"));
	      this.data.lineEndings = this.lineEndings;
	    }

	    const rawVertices = dict.getArray("Vertices");

	    if (!Array.isArray(rawVertices)) {
	      return;
	    }

	    for (let i = 0, ii = rawVertices.length; i < ii; i += 2) {
	      this.data.vertices.push({
	        x: rawVertices[i],
	        y: rawVertices[i + 1]
	      });
	    }

	    if (!this.appearance) {
	      const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	      const strokeAlpha = dict.get("CA");
	      const borderWidth = this.borderStyle.width || 1,
	            borderAdjust = 2 * borderWidth;
	      const bbox = [Infinity, Infinity, -Infinity, -Infinity];

	      for (const vertex of this.data.vertices) {
	        bbox[0] = Math.min(bbox[0], vertex.x - borderAdjust);
	        bbox[1] = Math.min(bbox[1], vertex.y - borderAdjust);
	        bbox[2] = Math.max(bbox[2], vertex.x + borderAdjust);
	        bbox[3] = Math.max(bbox[3], vertex.y + borderAdjust);
	      }

	      if (!_util.Util.intersect(this.rectangle, bbox)) {
	        this.rectangle = bbox;
	      }

	      this._setDefaultAppearance({
	        xref: parameters.xref,
	        extra: `${borderWidth} w`,
	        strokeColor,
	        strokeAlpha,
	        pointsCallback: (buffer, points) => {
	          const vertices = this.data.vertices;

	          for (let i = 0, ii = vertices.length; i < ii; i++) {
	            buffer.push(`${vertices[i].x} ${vertices[i].y} ${i === 0 ? "m" : "l"}`);
	          }

	          buffer.push("S");
	          return [points[0].x, points[1].x, points[3].y, points[1].y];
	        }
	      });
	    }
	  }

	}

	class PolygonAnnotation extends PolylineAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.POLYGON;
	  }

	}

	class CaretAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.CARET;
	  }

	}

	class InkAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.INK;
	    this.data.inkLists = [];
	    const rawInkLists = parameters.dict.getArray("InkList");

	    if (!Array.isArray(rawInkLists)) {
	      return;
	    }

	    const xref = parameters.xref;

	    for (let i = 0, ii = rawInkLists.length; i < ii; ++i) {
	      this.data.inkLists.push([]);

	      for (let j = 0, jj = rawInkLists[i].length; j < jj; j += 2) {
	        this.data.inkLists[i].push({
	          x: xref.fetchIfRef(rawInkLists[i][j]),
	          y: xref.fetchIfRef(rawInkLists[i][j + 1])
	        });
	      }
	    }

	    if (!this.appearance) {
	      const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	      const strokeAlpha = parameters.dict.get("CA");
	      const borderWidth = this.borderStyle.width || 1,
	            borderAdjust = 2 * borderWidth;
	      const bbox = [Infinity, Infinity, -Infinity, -Infinity];

	      for (const inkLists of this.data.inkLists) {
	        for (const vertex of inkLists) {
	          bbox[0] = Math.min(bbox[0], vertex.x - borderAdjust);
	          bbox[1] = Math.min(bbox[1], vertex.y - borderAdjust);
	          bbox[2] = Math.max(bbox[2], vertex.x + borderAdjust);
	          bbox[3] = Math.max(bbox[3], vertex.y + borderAdjust);
	        }
	      }

	      if (!_util.Util.intersect(this.rectangle, bbox)) {
	        this.rectangle = bbox;
	      }

	      this._setDefaultAppearance({
	        xref: parameters.xref,
	        extra: `${borderWidth} w`,
	        strokeColor,
	        strokeAlpha,
	        pointsCallback: (buffer, points) => {
	          for (const inkList of this.data.inkLists) {
	            for (let i = 0, ii = inkList.length; i < ii; i++) {
	              buffer.push(`${inkList[i].x} ${inkList[i].y} ${i === 0 ? "m" : "l"}`);
	            }

	            buffer.push("S");
	          }

	          return [points[0].x, points[1].x, points[3].y, points[1].y];
	        }
	      });
	    }
	  }

	  static createNewDict(annotation, xref, {
	    apRef,
	    ap
	  }) {
	    const {
	      paths,
	      rect,
	      rotation
	    } = annotation;
	    const ink = new _primitives.Dict(xref);
	    ink.set("Type", _primitives.Name.get("Annot"));
	    ink.set("Subtype", _primitives.Name.get("Ink"));
	    ink.set("CreationDate", `D:${(0, _util.getModificationDate)()}`);
	    ink.set("Rect", rect);
	    ink.set("InkList", paths.map(p => p.points));
	    ink.set("F", 4);
	    ink.set("Border", [0, 0, 0]);
	    ink.set("Rotate", rotation);
	    const n = new _primitives.Dict(xref);
	    ink.set("AP", n);

	    if (apRef) {
	      n.set("N", apRef);
	    } else {
	      n.set("N", ap);
	    }

	    return ink;
	  }

	  static async createNewAppearanceStream(annotation, xref, params) {
	    const {
	      color,
	      rect,
	      rotation,
	      paths,
	      thickness,
	      opacity
	    } = annotation;
	    const [x1, y1, x2, y2] = rect;
	    let w = x2 - x1;
	    let h = y2 - y1;

	    if (rotation % 180 !== 0) {
	      [w, h] = [h, w];
	    }

	    const appearanceBuffer = [`${thickness} w 1 J 1 j`, `${(0, _default_appearance.getPdfColor)(color, false)}`];

	    if (opacity !== 1) {
	      appearanceBuffer.push("/R0 gs");
	    }

	    const buffer = [];

	    for (const {
	      bezier
	    } of paths) {
	      buffer.length = 0;
	      buffer.push(`${(0, _core_utils.numberToString)(bezier[0])} ${(0, _core_utils.numberToString)(bezier[1])} m`);

	      for (let i = 2, ii = bezier.length; i < ii; i += 6) {
	        const curve = bezier.slice(i, i + 6).map(_core_utils.numberToString).join(" ");
	        buffer.push(`${curve} c`);
	      }

	      buffer.push("S");
	      appearanceBuffer.push(buffer.join("\n"));
	    }

	    const appearance = appearanceBuffer.join("\n");
	    const appearanceStreamDict = new _primitives.Dict(xref);
	    appearanceStreamDict.set("FormType", 1);
	    appearanceStreamDict.set("Subtype", _primitives.Name.get("Form"));
	    appearanceStreamDict.set("Type", _primitives.Name.get("XObject"));
	    appearanceStreamDict.set("BBox", [0, 0, w, h]);
	    appearanceStreamDict.set("Length", appearance.length);

	    if (rotation) {
	      const matrix = WidgetAnnotation._getRotationMatrix(rotation, w, h);

	      appearanceStreamDict.set("Matrix", matrix);
	    }

	    if (opacity !== 1) {
	      const resources = new _primitives.Dict(xref);
	      const extGState = new _primitives.Dict(xref);
	      const r0 = new _primitives.Dict(xref);
	      r0.set("CA", opacity);
	      r0.set("Type", _primitives.Name.get("ExtGState"));
	      extGState.set("R0", r0);
	      resources.set("ExtGState", extGState);
	      appearanceStreamDict.set("Resources", resources);
	    }

	    const ap = new _stream.StringStream(appearance);
	    ap.dict = appearanceStreamDict;
	    return ap;
	  }

	}

	class HighlightAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.HIGHLIGHT;
	    const quadPoints = this.data.quadPoints = getQuadPoints(parameters.dict, null);

	    if (quadPoints) {
	      const resources = this.appearance && this.appearance.dict.get("Resources");

	      if (!this.appearance || !(resources && resources.has("ExtGState"))) {
	        if (this.appearance) {
	          (0, _util.warn)("HighlightAnnotation - ignoring built-in appearance stream.");
	        }

	        const fillColor = this.color ? Array.from(this.color).map(c => c / 255) : [1, 1, 0];
	        const fillAlpha = parameters.dict.get("CA");

	        this._setDefaultAppearance({
	          xref: parameters.xref,
	          fillColor,
	          blendMode: "Multiply",
	          fillAlpha,
	          pointsCallback: (buffer, points) => {
	            buffer.push(`${points[0].x} ${points[0].y} m`, `${points[1].x} ${points[1].y} l`, `${points[3].x} ${points[3].y} l`, `${points[2].x} ${points[2].y} l`, "f");
	            return [points[0].x, points[1].x, points[3].y, points[1].y];
	          }
	        });
	      }
	    } else {
	      this.data.hasPopup = false;
	    }
	  }

	}

	class UnderlineAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.UNDERLINE;
	    const quadPoints = this.data.quadPoints = getQuadPoints(parameters.dict, null);

	    if (quadPoints) {
	      if (!this.appearance) {
	        const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	        const strokeAlpha = parameters.dict.get("CA");

	        this._setDefaultAppearance({
	          xref: parameters.xref,
	          extra: "[] 0 d 1 w",
	          strokeColor,
	          strokeAlpha,
	          pointsCallback: (buffer, points) => {
	            buffer.push(`${points[2].x} ${points[2].y} m`, `${points[3].x} ${points[3].y} l`, "S");
	            return [points[0].x, points[1].x, points[3].y, points[1].y];
	          }
	        });
	      }
	    } else {
	      this.data.hasPopup = false;
	    }
	  }

	}

	class SquigglyAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.SQUIGGLY;
	    const quadPoints = this.data.quadPoints = getQuadPoints(parameters.dict, null);

	    if (quadPoints) {
	      if (!this.appearance) {
	        const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	        const strokeAlpha = parameters.dict.get("CA");

	        this._setDefaultAppearance({
	          xref: parameters.xref,
	          extra: "[] 0 d 1 w",
	          strokeColor,
	          strokeAlpha,
	          pointsCallback: (buffer, points) => {
	            const dy = (points[0].y - points[2].y) / 6;
	            let shift = dy;
	            let x = points[2].x;
	            const y = points[2].y;
	            const xEnd = points[3].x;
	            buffer.push(`${x} ${y + shift} m`);

	            do {
	              x += 2;
	              shift = shift === 0 ? dy : 0;
	              buffer.push(`${x} ${y + shift} l`);
	            } while (x < xEnd);

	            buffer.push("S");
	            return [points[2].x, xEnd, y - 2 * dy, y + 2 * dy];
	          }
	        });
	      }
	    } else {
	      this.data.hasPopup = false;
	    }
	  }

	}

	class StrikeOutAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.STRIKEOUT;
	    const quadPoints = this.data.quadPoints = getQuadPoints(parameters.dict, null);

	    if (quadPoints) {
	      if (!this.appearance) {
	        const strokeColor = this.color ? Array.from(this.color).map(c => c / 255) : [0, 0, 0];
	        const strokeAlpha = parameters.dict.get("CA");

	        this._setDefaultAppearance({
	          xref: parameters.xref,
	          extra: "[] 0 d 1 w",
	          strokeColor,
	          strokeAlpha,
	          pointsCallback: (buffer, points) => {
	            buffer.push(`${(points[0].x + points[2].x) / 2} ` + `${(points[0].y + points[2].y) / 2} m`, `${(points[1].x + points[3].x) / 2} ` + `${(points[1].y + points[3].y) / 2} l`, "S");
	            return [points[0].x, points[1].x, points[3].y, points[1].y];
	          }
	        });
	      }
	    } else {
	      this.data.hasPopup = false;
	    }
	  }

	}

	class StampAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    this.data.annotationType = _util.AnnotationType.STAMP;
	  }

	}

	class FileAttachmentAnnotation extends MarkupAnnotation {
	  constructor(parameters) {
	    super(parameters);
	    const file = new _file_spec.FileSpec(parameters.dict.get("FS"), parameters.xref);
	    this.data.annotationType = _util.AnnotationType.FILEATTACHMENT;
	    this.data.file = file.serializable;
	  }

	}

	/***/ }),
	/* 13 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.createDefaultAppearance = createDefaultAppearance;
	exports.getPdfColor = getPdfColor;
	exports.parseDefaultAppearance = parseDefaultAppearance;

	var _core_utils = __w_pdfjs_require__(6);

	var _util = __w_pdfjs_require__(2);

	var _colorspace = __w_pdfjs_require__(14);

	var _evaluator = __w_pdfjs_require__(15);

	var _primitives = __w_pdfjs_require__(5);

	var _stream = __w_pdfjs_require__(10);

	class DefaultAppearanceEvaluator extends _evaluator.EvaluatorPreprocessor {
	  constructor(str) {
	    super(new _stream.StringStream(str));
	  }

	  parse() {
	    const operation = {
	      fn: 0,
	      args: []
	    };
	    const result = {
	      fontSize: 0,
	      fontName: "",
	      fontColor: new Uint8ClampedArray(3)
	    };

	    try {
	      while (true) {
	        operation.args.length = 0;

	        if (!this.read(operation)) {
	          break;
	        }

	        if (this.savedStatesDepth !== 0) {
	          continue;
	        }

	        const {
	          fn,
	          args
	        } = operation;

	        switch (fn | 0) {
	          case _util.OPS.setFont:
	            const [fontName, fontSize] = args;

	            if (fontName instanceof _primitives.Name) {
	              result.fontName = fontName.name;
	            }

	            if (typeof fontSize === "number" && fontSize > 0) {
	              result.fontSize = fontSize;
	            }

	            break;

	          case _util.OPS.setFillRGBColor:
	            _colorspace.ColorSpace.singletons.rgb.getRgbItem(args, 0, result.fontColor, 0);

	            break;

	          case _util.OPS.setFillGray:
	            _colorspace.ColorSpace.singletons.gray.getRgbItem(args, 0, result.fontColor, 0);

	            break;

	          case _util.OPS.setFillColorSpace:
	            _colorspace.ColorSpace.singletons.cmyk.getRgbItem(args, 0, result.fontColor, 0);

	            break;
	        }
	      }
	    } catch (reason) {
	      (0, _util.warn)(`parseDefaultAppearance - ignoring errors: "${reason}".`);
	    }

	    return result;
	  }

	}

	function parseDefaultAppearance(str) {
	  return new DefaultAppearanceEvaluator(str).parse();
	}

	function getPdfColor(color, isFill) {
	  if (color[0] === color[1] && color[1] === color[2]) {
	    const gray = color[0] / 255;
	    return `${(0, _core_utils.numberToString)(gray)} ${isFill ? "g" : "G"}`;
	  }

	  return Array.from(color).map(c => (0, _core_utils.numberToString)(c / 255)).join(" ") + ` ${isFill ? "rg" : "RG"}`;
	}

	function createDefaultAppearance({
	  fontSize,
	  fontName,
	  fontColor
	}) {
	  return `/${(0, _core_utils.escapePDFName)(fontName)} ${fontSize} Tf ${getPdfColor(fontColor, true)}`;
	}

	/***/ }),
	/* 14 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ColorSpace = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _base_stream = __w_pdfjs_require__(7);

	var _core_utils = __w_pdfjs_require__(6);

	function resizeRgbImage(src, dest, w1, h1, w2, h2, alpha01) {
	  const COMPONENTS = 3;
	  alpha01 = alpha01 !== 1 ? 0 : alpha01;
	  const xRatio = w1 / w2;
	  const yRatio = h1 / h2;
	  let newIndex = 0,
	      oldIndex;
	  const xScaled = new Uint16Array(w2);
	  const w1Scanline = w1 * COMPONENTS;

	  for (let i = 0; i < w2; i++) {
	    xScaled[i] = Math.floor(i * xRatio) * COMPONENTS;
	  }

	  for (let i = 0; i < h2; i++) {
	    const py = Math.floor(i * yRatio) * w1Scanline;

	    for (let j = 0; j < w2; j++) {
	      oldIndex = py + xScaled[j];
	      dest[newIndex++] = src[oldIndex++];
	      dest[newIndex++] = src[oldIndex++];
	      dest[newIndex++] = src[oldIndex++];
	      newIndex += alpha01;
	    }
	  }
	}

	class ColorSpace {
	  constructor(name, numComps) {
	    if (this.constructor === ColorSpace) {
	      (0, _util.unreachable)("Cannot initialize ColorSpace.");
	    }

	    this.name = name;
	    this.numComps = numComps;
	  }

	  getRgb(src, srcOffset) {
	    const rgb = new Uint8ClampedArray(3);
	    this.getRgbItem(src, srcOffset, rgb, 0);
	    return rgb;
	  }

	  getRgbItem(src, srcOffset, dest, destOffset) {
	    (0, _util.unreachable)("Should not call ColorSpace.getRgbItem");
	  }

	  getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	    (0, _util.unreachable)("Should not call ColorSpace.getRgbBuffer");
	  }

	  getOutputLength(inputLength, alpha01) {
	    (0, _util.unreachable)("Should not call ColorSpace.getOutputLength");
	  }

	  isPassthrough(bits) {
	    return false;
	  }

	  isDefaultDecode(decodeMap, bpc) {
	    return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
	  }

	  fillRgb(dest, originalWidth, originalHeight, width, height, actualHeight, bpc, comps, alpha01) {
	    const count = originalWidth * originalHeight;
	    let rgbBuf = null;
	    const numComponentColors = 1 << bpc;
	    const needsResizing = originalHeight !== height || originalWidth !== width;

	    if (this.isPassthrough(bpc)) {
	      rgbBuf = comps;
	    } else if (this.numComps === 1 && count > numComponentColors && this.name !== "DeviceGray" && this.name !== "DeviceRGB") {
	      const allColors = bpc <= 8 ? new Uint8Array(numComponentColors) : new Uint16Array(numComponentColors);

	      for (let i = 0; i < numComponentColors; i++) {
	        allColors[i] = i;
	      }

	      const colorMap = new Uint8ClampedArray(numComponentColors * 3);
	      this.getRgbBuffer(allColors, 0, numComponentColors, colorMap, 0, bpc, 0);

	      if (!needsResizing) {
	        let destPos = 0;

	        for (let i = 0; i < count; ++i) {
	          const key = comps[i] * 3;
	          dest[destPos++] = colorMap[key];
	          dest[destPos++] = colorMap[key + 1];
	          dest[destPos++] = colorMap[key + 2];
	          destPos += alpha01;
	        }
	      } else {
	        rgbBuf = new Uint8Array(count * 3);
	        let rgbPos = 0;

	        for (let i = 0; i < count; ++i) {
	          const key = comps[i] * 3;
	          rgbBuf[rgbPos++] = colorMap[key];
	          rgbBuf[rgbPos++] = colorMap[key + 1];
	          rgbBuf[rgbPos++] = colorMap[key + 2];
	        }
	      }
	    } else {
	      if (!needsResizing) {
	        this.getRgbBuffer(comps, 0, width * actualHeight, dest, 0, bpc, alpha01);
	      } else {
	        rgbBuf = new Uint8ClampedArray(count * 3);
	        this.getRgbBuffer(comps, 0, count, rgbBuf, 0, bpc, 0);
	      }
	    }

	    if (rgbBuf) {
	      if (needsResizing) {
	        resizeRgbImage(rgbBuf, dest, originalWidth, originalHeight, width, height, alpha01);
	      } else {
	        let destPos = 0,
	            rgbPos = 0;

	        for (let i = 0, ii = width * actualHeight; i < ii; i++) {
	          dest[destPos++] = rgbBuf[rgbPos++];
	          dest[destPos++] = rgbBuf[rgbPos++];
	          dest[destPos++] = rgbBuf[rgbPos++];
	          destPos += alpha01;
	        }
	      }
	    }
	  }

	  get usesZeroToOneRange() {
	    return (0, _util.shadow)(this, "usesZeroToOneRange", true);
	  }

	  static _cache(cacheKey, xref, localColorSpaceCache, parsedColorSpace) {
	    if (!localColorSpaceCache) {
	      throw new Error('ColorSpace._cache - expected "localColorSpaceCache" argument.');
	    }

	    if (!parsedColorSpace) {
	      throw new Error('ColorSpace._cache - expected "parsedColorSpace" argument.');
	    }

	    let csName, csRef;

	    if (cacheKey instanceof _primitives.Ref) {
	      csRef = cacheKey;
	      cacheKey = xref.fetch(cacheKey);
	    }

	    if (cacheKey instanceof _primitives.Name) {
	      csName = cacheKey.name;
	    }

	    if (csName || csRef) {
	      localColorSpaceCache.set(csName, csRef, parsedColorSpace);
	    }
	  }

	  static getCached(cacheKey, xref, localColorSpaceCache) {
	    if (!localColorSpaceCache) {
	      throw new Error('ColorSpace.getCached - expected "localColorSpaceCache" argument.');
	    }

	    if (cacheKey instanceof _primitives.Ref) {
	      const localColorSpace = localColorSpaceCache.getByRef(cacheKey);

	      if (localColorSpace) {
	        return localColorSpace;
	      }

	      try {
	        cacheKey = xref.fetch(cacheKey);
	      } catch (ex) {
	        if (ex instanceof _core_utils.MissingDataException) {
	          throw ex;
	        }
	      }
	    }

	    if (cacheKey instanceof _primitives.Name) {
	      const localColorSpace = localColorSpaceCache.getByName(cacheKey.name);

	      if (localColorSpace) {
	        return localColorSpace;
	      }
	    }

	    return null;
	  }

	  static async parseAsync({
	    cs,
	    xref,
	    resources = null,
	    pdfFunctionFactory,
	    localColorSpaceCache
	  }) {
	    const parsedColorSpace = this._parse(cs, xref, resources, pdfFunctionFactory);

	    this._cache(cs, xref, localColorSpaceCache, parsedColorSpace);

	    return parsedColorSpace;
	  }

	  static parse({
	    cs,
	    xref,
	    resources = null,
	    pdfFunctionFactory,
	    localColorSpaceCache
	  }) {
	    const cachedColorSpace = this.getCached(cs, xref, localColorSpaceCache);

	    if (cachedColorSpace) {
	      return cachedColorSpace;
	    }

	    const parsedColorSpace = this._parse(cs, xref, resources, pdfFunctionFactory);

	    this._cache(cs, xref, localColorSpaceCache, parsedColorSpace);

	    return parsedColorSpace;
	  }

	  static _parse(cs, xref, resources = null, pdfFunctionFactory) {
	    cs = xref.fetchIfRef(cs);

	    if (cs instanceof _primitives.Name) {
	      switch (cs.name) {
	        case "G":
	        case "DeviceGray":
	          return this.singletons.gray;

	        case "RGB":
	        case "DeviceRGB":
	          return this.singletons.rgb;

	        case "CMYK":
	        case "DeviceCMYK":
	          return this.singletons.cmyk;

	        case "Pattern":
	          return new PatternCS(null);

	        default:
	          if (resources instanceof _primitives.Dict) {
	            const colorSpaces = resources.get("ColorSpace");

	            if (colorSpaces instanceof _primitives.Dict) {
	              const resourcesCS = colorSpaces.get(cs.name);

	              if (resourcesCS) {
	                if (resourcesCS instanceof _primitives.Name) {
	                  return this._parse(resourcesCS, xref, resources, pdfFunctionFactory);
	                }

	                cs = resourcesCS;
	                break;
	              }
	            }
	          }

	          throw new _util.FormatError(`Unrecognized ColorSpace: ${cs.name}`);
	      }
	    }

	    if (Array.isArray(cs)) {
	      const mode = xref.fetchIfRef(cs[0]).name;
	      let params, numComps, baseCS, whitePoint, blackPoint, gamma;

	      switch (mode) {
	        case "G":
	        case "DeviceGray":
	          return this.singletons.gray;

	        case "RGB":
	        case "DeviceRGB":
	          return this.singletons.rgb;

	        case "CMYK":
	        case "DeviceCMYK":
	          return this.singletons.cmyk;

	        case "CalGray":
	          params = xref.fetchIfRef(cs[1]);
	          whitePoint = params.getArray("WhitePoint");
	          blackPoint = params.getArray("BlackPoint");
	          gamma = params.get("Gamma");
	          return new CalGrayCS(whitePoint, blackPoint, gamma);

	        case "CalRGB":
	          params = xref.fetchIfRef(cs[1]);
	          whitePoint = params.getArray("WhitePoint");
	          blackPoint = params.getArray("BlackPoint");
	          gamma = params.getArray("Gamma");
	          const matrix = params.getArray("Matrix");
	          return new CalRGBCS(whitePoint, blackPoint, gamma, matrix);

	        case "ICCBased":
	          const stream = xref.fetchIfRef(cs[1]);
	          const dict = stream.dict;
	          numComps = dict.get("N");
	          const alt = dict.get("Alternate");

	          if (alt) {
	            const altCS = this._parse(alt, xref, resources, pdfFunctionFactory);

	            if (altCS.numComps === numComps) {
	              return altCS;
	            }

	            (0, _util.warn)("ICCBased color space: Ignoring incorrect /Alternate entry.");
	          }

	          if (numComps === 1) {
	            return this.singletons.gray;
	          } else if (numComps === 3) {
	            return this.singletons.rgb;
	          } else if (numComps === 4) {
	            return this.singletons.cmyk;
	          }

	          break;

	        case "Pattern":
	          baseCS = cs[1] || null;

	          if (baseCS) {
	            baseCS = this._parse(baseCS, xref, resources, pdfFunctionFactory);
	          }

	          return new PatternCS(baseCS);

	        case "I":
	        case "Indexed":
	          baseCS = this._parse(cs[1], xref, resources, pdfFunctionFactory);
	          const hiVal = xref.fetchIfRef(cs[2]) + 1;
	          const lookup = xref.fetchIfRef(cs[3]);
	          return new IndexedCS(baseCS, hiVal, lookup);

	        case "Separation":
	        case "DeviceN":
	          const name = xref.fetchIfRef(cs[1]);
	          numComps = Array.isArray(name) ? name.length : 1;
	          baseCS = this._parse(cs[2], xref, resources, pdfFunctionFactory);
	          const tintFn = pdfFunctionFactory.create(cs[3]);
	          return new AlternateCS(numComps, baseCS, tintFn);

	        case "Lab":
	          params = xref.fetchIfRef(cs[1]);
	          whitePoint = params.getArray("WhitePoint");
	          blackPoint = params.getArray("BlackPoint");
	          const range = params.getArray("Range");
	          return new LabCS(whitePoint, blackPoint, range);

	        default:
	          throw new _util.FormatError(`Unimplemented ColorSpace object: ${mode}`);
	      }
	    }

	    throw new _util.FormatError(`Unrecognized ColorSpace object: ${cs}`);
	  }

	  static isDefaultDecode(decode, numComps) {
	    if (!Array.isArray(decode)) {
	      return true;
	    }

	    if (numComps * 2 !== decode.length) {
	      (0, _util.warn)("The decode map is not the correct length");
	      return true;
	    }

	    for (let i = 0, ii = decode.length; i < ii; i += 2) {
	      if (decode[i] !== 0 || decode[i + 1] !== 1) {
	        return false;
	      }
	    }

	    return true;
	  }

	  static get singletons() {
	    return (0, _util.shadow)(this, "singletons", {
	      get gray() {
	        return (0, _util.shadow)(this, "gray", new DeviceGrayCS());
	      },

	      get rgb() {
	        return (0, _util.shadow)(this, "rgb", new DeviceRgbCS());
	      },

	      get cmyk() {
	        return (0, _util.shadow)(this, "cmyk", new DeviceCmykCS());
	      }

	    });
	  }

	}

	exports.ColorSpace = ColorSpace;

	class AlternateCS extends ColorSpace {
	  constructor(numComps, base, tintFn) {
	    super("Alternate", numComps);
	    this.base = base;
	    this.tintFn = tintFn;
	    this.tmpBuf = new Float32Array(base.numComps);
	  }

	  getRgbItem(src, srcOffset, dest, destOffset) {
	    const tmpBuf = this.tmpBuf;
	    this.tintFn(src, srcOffset, tmpBuf, 0);
	    this.base.getRgbItem(tmpBuf, 0, dest, destOffset);
	  }

	  getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	    const tintFn = this.tintFn;
	    const base = this.base;
	    const scale = 1 / ((1 << bits) - 1);
	    const baseNumComps = base.numComps;
	    const usesZeroToOneRange = base.usesZeroToOneRange;
	    const isPassthrough = (base.isPassthrough(8) || !usesZeroToOneRange) && alpha01 === 0;
	    let pos = isPassthrough ? destOffset : 0;
	    const baseBuf = isPassthrough ? dest : new Uint8ClampedArray(baseNumComps * count);
	    const numComps = this.numComps;
	    const scaled = new Float32Array(numComps);
	    const tinted = new Float32Array(baseNumComps);
	    let i, j;

	    for (i = 0; i < count; i++) {
	      for (j = 0; j < numComps; j++) {
	        scaled[j] = src[srcOffset++] * scale;
	      }

	      tintFn(scaled, 0, tinted, 0);

	      if (usesZeroToOneRange) {
	        for (j = 0; j < baseNumComps; j++) {
	          baseBuf[pos++] = tinted[j] * 255;
	        }
	      } else {
	        base.getRgbItem(tinted, 0, baseBuf, pos);
	        pos += baseNumComps;
	      }
	    }

	    if (!isPassthrough) {
	      base.getRgbBuffer(baseBuf, 0, count, dest, destOffset, 8, alpha01);
	    }
	  }

	  getOutputLength(inputLength, alpha01) {
	    return this.base.getOutputLength(inputLength * this.base.numComps / this.numComps, alpha01);
	  }

	}

	class PatternCS extends ColorSpace {
	  constructor(baseCS) {
	    super("Pattern", null);
	    this.base = baseCS;
	  }

	  isDefaultDecode(decodeMap, bpc) {
	    (0, _util.unreachable)("Should not call PatternCS.isDefaultDecode");
	  }

	}

	class IndexedCS extends ColorSpace {
	  constructor(base, highVal, lookup) {
	    super("Indexed", 1);
	    this.base = base;
	    this.highVal = highVal;
	    const length = base.numComps * highVal;
	    this.lookup = new Uint8Array(length);

	    if (lookup instanceof _base_stream.BaseStream) {
	      const bytes = lookup.getBytes(length);
	      this.lookup.set(bytes);
	    } else if (typeof lookup === "string") {
	      for (let i = 0; i < length; ++i) {
	        this.lookup[i] = lookup.charCodeAt(i) & 0xff;
	      }
	    } else {
	      throw new _util.FormatError(`IndexedCS - unrecognized lookup table: ${lookup}`);
	    }
	  }

	  getRgbItem(src, srcOffset, dest, destOffset) {
	    const numComps = this.base.numComps;
	    const start = src[srcOffset] * numComps;
	    this.base.getRgbBuffer(this.lookup, start, 1, dest, destOffset, 8, 0);
	  }

	  getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	    const base = this.base;
	    const numComps = base.numComps;
	    const outputDelta = base.getOutputLength(numComps, alpha01);
	    const lookup = this.lookup;

	    for (let i = 0; i < count; ++i) {
	      const lookupPos = src[srcOffset++] * numComps;
	      base.getRgbBuffer(lookup, lookupPos, 1, dest, destOffset, 8, alpha01);
	      destOffset += outputDelta;
	    }
	  }

	  getOutputLength(inputLength, alpha01) {
	    return this.base.getOutputLength(inputLength * this.base.numComps, alpha01);
	  }

	  isDefaultDecode(decodeMap, bpc) {
	    if (!Array.isArray(decodeMap)) {
	      return true;
	    }

	    if (decodeMap.length !== 2) {
	      (0, _util.warn)("Decode map length is not correct");
	      return true;
	    }

	    if (!Number.isInteger(bpc) || bpc < 1) {
	      (0, _util.warn)("Bits per component is not correct");
	      return true;
	    }

	    return decodeMap[0] === 0 && decodeMap[1] === (1 << bpc) - 1;
	  }

	}

	class DeviceGrayCS extends ColorSpace {
	  constructor() {
	    super("DeviceGray", 1);
	  }

	  getRgbItem(src, srcOffset, dest, destOffset) {
	    const c = src[srcOffset] * 255;
	    dest[destOffset] = dest[destOffset + 1] = dest[destOffset + 2] = c;
	  }

	  getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	    const scale = 255 / ((1 << bits) - 1);
	    let j = srcOffset,
	        q = destOffset;

	    for (let i = 0; i < count; ++i) {
	      const c = scale * src[j++];
	      dest[q++] = c;
	      dest[q++] = c;
	      dest[q++] = c;
	      q += alpha01;
	    }
	  }

	  getOutputLength(inputLength, alpha01) {
	    return inputLength * (3 + alpha01);
	  }

	}

	class DeviceRgbCS extends ColorSpace {
	  constructor() {
	    super("DeviceRGB", 3);
	  }

	  getRgbItem(src, srcOffset, dest, destOffset) {
	    dest[destOffset] = src[srcOffset] * 255;
	    dest[destOffset + 1] = src[srcOffset + 1] * 255;
	    dest[destOffset + 2] = src[srcOffset + 2] * 255;
	  }

	  getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	    if (bits === 8 && alpha01 === 0) {
	      dest.set(src.subarray(srcOffset, srcOffset + count * 3), destOffset);
	      return;
	    }

	    const scale = 255 / ((1 << bits) - 1);
	    let j = srcOffset,
	        q = destOffset;

	    for (let i = 0; i < count; ++i) {
	      dest[q++] = scale * src[j++];
	      dest[q++] = scale * src[j++];
	      dest[q++] = scale * src[j++];
	      q += alpha01;
	    }
	  }

	  getOutputLength(inputLength, alpha01) {
	    return inputLength * (3 + alpha01) / 3 | 0;
	  }

	  isPassthrough(bits) {
	    return bits === 8;
	  }

	}

	const DeviceCmykCS = function DeviceCmykCSClosure() {
	  function convertToRgb(src, srcOffset, srcScale, dest, destOffset) {
	    const c = src[srcOffset] * srcScale;
	    const m = src[srcOffset + 1] * srcScale;
	    const y = src[srcOffset + 2] * srcScale;
	    const k = src[srcOffset + 3] * srcScale;
	    dest[destOffset] = 255 + c * (-4.387332384609988 * c + 54.48615194189176 * m + 18.82290502165302 * y + 212.25662451639585 * k + -285.2331026137004) + m * (1.7149763477362134 * m - 5.6096736904047315 * y + -17.873870861415444 * k - 5.497006427196366) + y * (-2.5217340131683033 * y - 21.248923337353073 * k + 17.5119270841813) + k * (-21.86122147463605 * k - 189.48180835922747);
	    dest[destOffset + 1] = 255 + c * (8.841041422036149 * c + 60.118027045597366 * m + 6.871425592049007 * y + 31.159100130055922 * k + -79.2970844816548) + m * (-15.310361306967817 * m + 17.575251261109482 * y + 131.35250912493976 * k - 190.9453302588951) + y * (4.444339102852739 * y + 9.8632861493405 * k - 24.86741582555878) + k * (-20.737325471181034 * k - 187.80453709719578);
	    dest[destOffset + 2] = 255 + c * (0.8842522430003296 * c + 8.078677503112928 * m + 30.89978309703729 * y - 0.23883238689178934 * k + -14.183576799673286) + m * (10.49593273432072 * m + 63.02378494754052 * y + 50.606957656360734 * k - 112.23884253719248) + y * (0.03296041114873217 * y + 115.60384449646641 * k + -193.58209356861505) + k * (-22.33816807309886 * k - 180.12613974708367);
	  }

	  class DeviceCmykCS extends ColorSpace {
	    constructor() {
	      super("DeviceCMYK", 4);
	    }

	    getRgbItem(src, srcOffset, dest, destOffset) {
	      convertToRgb(src, srcOffset, 1, dest, destOffset);
	    }

	    getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	      const scale = 1 / ((1 << bits) - 1);

	      for (let i = 0; i < count; i++) {
	        convertToRgb(src, srcOffset, scale, dest, destOffset);
	        srcOffset += 4;
	        destOffset += 3 + alpha01;
	      }
	    }

	    getOutputLength(inputLength, alpha01) {
	      return inputLength / 4 * (3 + alpha01) | 0;
	    }

	  }

	  return DeviceCmykCS;
	}();

	const CalGrayCS = function CalGrayCSClosure() {
	  function convertToRgb(cs, src, srcOffset, dest, destOffset, scale) {
	    const A = src[srcOffset] * scale;
	    const AG = A ** cs.G;
	    const L = cs.YW * AG;
	    const val = Math.max(295.8 * L ** 0.3333333333333333 - 40.8, 0);
	    dest[destOffset] = val;
	    dest[destOffset + 1] = val;
	    dest[destOffset + 2] = val;
	  }

	  class CalGrayCS extends ColorSpace {
	    constructor(whitePoint, blackPoint, gamma) {
	      super("CalGray", 1);

	      if (!whitePoint) {
	        throw new _util.FormatError("WhitePoint missing - required for color space CalGray");
	      }

	      blackPoint = blackPoint || [0, 0, 0];
	      gamma = gamma || 1;
	      this.XW = whitePoint[0];
	      this.YW = whitePoint[1];
	      this.ZW = whitePoint[2];
	      this.XB = blackPoint[0];
	      this.YB = blackPoint[1];
	      this.ZB = blackPoint[2];
	      this.G = gamma;

	      if (this.XW < 0 || this.ZW < 0 || this.YW !== 1) {
	        throw new _util.FormatError(`Invalid WhitePoint components for ${this.name}` + ", no fallback available");
	      }

	      if (this.XB < 0 || this.YB < 0 || this.ZB < 0) {
	        (0, _util.info)(`Invalid BlackPoint for ${this.name}, falling back to default.`);
	        this.XB = this.YB = this.ZB = 0;
	      }

	      if (this.XB !== 0 || this.YB !== 0 || this.ZB !== 0) {
	        (0, _util.warn)(`${this.name}, BlackPoint: XB: ${this.XB}, YB: ${this.YB}, ` + `ZB: ${this.ZB}, only default values are supported.`);
	      }

	      if (this.G < 1) {
	        (0, _util.info)(`Invalid Gamma: ${this.G} for ${this.name}, ` + "falling back to default.");
	        this.G = 1;
	      }
	    }

	    getRgbItem(src, srcOffset, dest, destOffset) {
	      convertToRgb(this, src, srcOffset, dest, destOffset, 1);
	    }

	    getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	      const scale = 1 / ((1 << bits) - 1);

	      for (let i = 0; i < count; ++i) {
	        convertToRgb(this, src, srcOffset, dest, destOffset, scale);
	        srcOffset += 1;
	        destOffset += 3 + alpha01;
	      }
	    }

	    getOutputLength(inputLength, alpha01) {
	      return inputLength * (3 + alpha01);
	    }

	  }

	  return CalGrayCS;
	}();

	const CalRGBCS = function CalRGBCSClosure() {
	  const BRADFORD_SCALE_MATRIX = new Float32Array([0.8951, 0.2664, -0.1614, -0.7502, 1.7135, 0.0367, 0.0389, -0.0685, 1.0296]);
	  const BRADFORD_SCALE_INVERSE_MATRIX = new Float32Array([0.9869929, -0.1470543, 0.1599627, 0.4323053, 0.5183603, 0.0492912, -0.0085287, 0.0400428, 0.9684867]);
	  const SRGB_D65_XYZ_TO_RGB_MATRIX = new Float32Array([3.2404542, -1.5371385, -0.4985314, -0.9692660, 1.8760108, 0.0415560, 0.0556434, -0.2040259, 1.0572252]);
	  const FLAT_WHITEPOINT_MATRIX = new Float32Array([1, 1, 1]);
	  const tempNormalizeMatrix = new Float32Array(3);
	  const tempConvertMatrix1 = new Float32Array(3);
	  const tempConvertMatrix2 = new Float32Array(3);
	  const DECODE_L_CONSTANT = ((8 + 16) / 116) ** 3 / 8.0;

	  function matrixProduct(a, b, result) {
	    result[0] = a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
	    result[1] = a[3] * b[0] + a[4] * b[1] + a[5] * b[2];
	    result[2] = a[6] * b[0] + a[7] * b[1] + a[8] * b[2];
	  }

	  function convertToFlat(sourceWhitePoint, LMS, result) {
	    result[0] = LMS[0] * 1 / sourceWhitePoint[0];
	    result[1] = LMS[1] * 1 / sourceWhitePoint[1];
	    result[2] = LMS[2] * 1 / sourceWhitePoint[2];
	  }

	  function convertToD65(sourceWhitePoint, LMS, result) {
	    const D65X = 0.95047;
	    const D65Y = 1;
	    const D65Z = 1.08883;
	    result[0] = LMS[0] * D65X / sourceWhitePoint[0];
	    result[1] = LMS[1] * D65Y / sourceWhitePoint[1];
	    result[2] = LMS[2] * D65Z / sourceWhitePoint[2];
	  }

	  function sRGBTransferFunction(color) {
	    if (color <= 0.0031308) {
	      return adjustToRange(0, 1, 12.92 * color);
	    }

	    if (color >= 0.99554525) {
	      return 1;
	    }

	    return adjustToRange(0, 1, (1 + 0.055) * color ** (1 / 2.4) - 0.055);
	  }

	  function adjustToRange(min, max, value) {
	    return Math.max(min, Math.min(max, value));
	  }

	  function decodeL(L) {
	    if (L < 0) {
	      return -decodeL(-L);
	    }

	    if (L > 8.0) {
	      return ((L + 16) / 116) ** 3;
	    }

	    return L * DECODE_L_CONSTANT;
	  }

	  function compensateBlackPoint(sourceBlackPoint, XYZ_Flat, result) {
	    if (sourceBlackPoint[0] === 0 && sourceBlackPoint[1] === 0 && sourceBlackPoint[2] === 0) {
	      result[0] = XYZ_Flat[0];
	      result[1] = XYZ_Flat[1];
	      result[2] = XYZ_Flat[2];
	      return;
	    }

	    const zeroDecodeL = decodeL(0);
	    const X_DST = zeroDecodeL;
	    const X_SRC = decodeL(sourceBlackPoint[0]);
	    const Y_DST = zeroDecodeL;
	    const Y_SRC = decodeL(sourceBlackPoint[1]);
	    const Z_DST = zeroDecodeL;
	    const Z_SRC = decodeL(sourceBlackPoint[2]);
	    const X_Scale = (1 - X_DST) / (1 - X_SRC);
	    const X_Offset = 1 - X_Scale;
	    const Y_Scale = (1 - Y_DST) / (1 - Y_SRC);
	    const Y_Offset = 1 - Y_Scale;
	    const Z_Scale = (1 - Z_DST) / (1 - Z_SRC);
	    const Z_Offset = 1 - Z_Scale;
	    result[0] = XYZ_Flat[0] * X_Scale + X_Offset;
	    result[1] = XYZ_Flat[1] * Y_Scale + Y_Offset;
	    result[2] = XYZ_Flat[2] * Z_Scale + Z_Offset;
	  }

	  function normalizeWhitePointToFlat(sourceWhitePoint, XYZ_In, result) {
	    if (sourceWhitePoint[0] === 1 && sourceWhitePoint[2] === 1) {
	      result[0] = XYZ_In[0];
	      result[1] = XYZ_In[1];
	      result[2] = XYZ_In[2];
	      return;
	    }

	    const LMS = result;
	    matrixProduct(BRADFORD_SCALE_MATRIX, XYZ_In, LMS);
	    const LMS_Flat = tempNormalizeMatrix;
	    convertToFlat(sourceWhitePoint, LMS, LMS_Flat);
	    matrixProduct(BRADFORD_SCALE_INVERSE_MATRIX, LMS_Flat, result);
	  }

	  function normalizeWhitePointToD65(sourceWhitePoint, XYZ_In, result) {
	    const LMS = result;
	    matrixProduct(BRADFORD_SCALE_MATRIX, XYZ_In, LMS);
	    const LMS_D65 = tempNormalizeMatrix;
	    convertToD65(sourceWhitePoint, LMS, LMS_D65);
	    matrixProduct(BRADFORD_SCALE_INVERSE_MATRIX, LMS_D65, result);
	  }

	  function convertToRgb(cs, src, srcOffset, dest, destOffset, scale) {
	    const A = adjustToRange(0, 1, src[srcOffset] * scale);
	    const B = adjustToRange(0, 1, src[srcOffset + 1] * scale);
	    const C = adjustToRange(0, 1, src[srcOffset + 2] * scale);
	    const AGR = A === 1 ? 1 : A ** cs.GR;
	    const BGG = B === 1 ? 1 : B ** cs.GG;
	    const CGB = C === 1 ? 1 : C ** cs.GB;
	    const X = cs.MXA * AGR + cs.MXB * BGG + cs.MXC * CGB;
	    const Y = cs.MYA * AGR + cs.MYB * BGG + cs.MYC * CGB;
	    const Z = cs.MZA * AGR + cs.MZB * BGG + cs.MZC * CGB;
	    const XYZ = tempConvertMatrix1;
	    XYZ[0] = X;
	    XYZ[1] = Y;
	    XYZ[2] = Z;
	    const XYZ_Flat = tempConvertMatrix2;
	    normalizeWhitePointToFlat(cs.whitePoint, XYZ, XYZ_Flat);
	    const XYZ_Black = tempConvertMatrix1;
	    compensateBlackPoint(cs.blackPoint, XYZ_Flat, XYZ_Black);
	    const XYZ_D65 = tempConvertMatrix2;
	    normalizeWhitePointToD65(FLAT_WHITEPOINT_MATRIX, XYZ_Black, XYZ_D65);
	    const SRGB = tempConvertMatrix1;
	    matrixProduct(SRGB_D65_XYZ_TO_RGB_MATRIX, XYZ_D65, SRGB);
	    dest[destOffset] = sRGBTransferFunction(SRGB[0]) * 255;
	    dest[destOffset + 1] = sRGBTransferFunction(SRGB[1]) * 255;
	    dest[destOffset + 2] = sRGBTransferFunction(SRGB[2]) * 255;
	  }

	  class CalRGBCS extends ColorSpace {
	    constructor(whitePoint, blackPoint, gamma, matrix) {
	      super("CalRGB", 3);

	      if (!whitePoint) {
	        throw new _util.FormatError("WhitePoint missing - required for color space CalRGB");
	      }

	      blackPoint = blackPoint || new Float32Array(3);
	      gamma = gamma || new Float32Array([1, 1, 1]);
	      matrix = matrix || new Float32Array([1, 0, 0, 0, 1, 0, 0, 0, 1]);
	      const XW = whitePoint[0];
	      const YW = whitePoint[1];
	      const ZW = whitePoint[2];
	      this.whitePoint = whitePoint;
	      const XB = blackPoint[0];
	      const YB = blackPoint[1];
	      const ZB = blackPoint[2];
	      this.blackPoint = blackPoint;
	      this.GR = gamma[0];
	      this.GG = gamma[1];
	      this.GB = gamma[2];
	      this.MXA = matrix[0];
	      this.MYA = matrix[1];
	      this.MZA = matrix[2];
	      this.MXB = matrix[3];
	      this.MYB = matrix[4];
	      this.MZB = matrix[5];
	      this.MXC = matrix[6];
	      this.MYC = matrix[7];
	      this.MZC = matrix[8];

	      if (XW < 0 || ZW < 0 || YW !== 1) {
	        throw new _util.FormatError(`Invalid WhitePoint components for ${this.name}` + ", no fallback available");
	      }

	      if (XB < 0 || YB < 0 || ZB < 0) {
	        (0, _util.info)(`Invalid BlackPoint for ${this.name} [${XB}, ${YB}, ${ZB}], ` + "falling back to default.");
	        this.blackPoint = new Float32Array(3);
	      }

	      if (this.GR < 0 || this.GG < 0 || this.GB < 0) {
	        (0, _util.info)(`Invalid Gamma [${this.GR}, ${this.GG}, ${this.GB}] for ` + `${this.name}, falling back to default.`);
	        this.GR = this.GG = this.GB = 1;
	      }
	    }

	    getRgbItem(src, srcOffset, dest, destOffset) {
	      convertToRgb(this, src, srcOffset, dest, destOffset, 1);
	    }

	    getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	      const scale = 1 / ((1 << bits) - 1);

	      for (let i = 0; i < count; ++i) {
	        convertToRgb(this, src, srcOffset, dest, destOffset, scale);
	        srcOffset += 3;
	        destOffset += 3 + alpha01;
	      }
	    }

	    getOutputLength(inputLength, alpha01) {
	      return inputLength * (3 + alpha01) / 3 | 0;
	    }

	  }

	  return CalRGBCS;
	}();

	const LabCS = function LabCSClosure() {
	  function fn_g(x) {
	    let result;

	    if (x >= 6 / 29) {
	      result = x ** 3;
	    } else {
	      result = 108 / 841 * (x - 4 / 29);
	    }

	    return result;
	  }

	  function decode(value, high1, low2, high2) {
	    return low2 + value * (high2 - low2) / high1;
	  }

	  function convertToRgb(cs, src, srcOffset, maxVal, dest, destOffset) {
	    let Ls = src[srcOffset];
	    let as = src[srcOffset + 1];
	    let bs = src[srcOffset + 2];

	    if (maxVal !== false) {
	      Ls = decode(Ls, maxVal, 0, 100);
	      as = decode(as, maxVal, cs.amin, cs.amax);
	      bs = decode(bs, maxVal, cs.bmin, cs.bmax);
	    }

	    if (as > cs.amax) {
	      as = cs.amax;
	    } else if (as < cs.amin) {
	      as = cs.amin;
	    }

	    if (bs > cs.bmax) {
	      bs = cs.bmax;
	    } else if (bs < cs.bmin) {
	      bs = cs.bmin;
	    }

	    const M = (Ls + 16) / 116;
	    const L = M + as / 500;
	    const N = M - bs / 200;
	    const X = cs.XW * fn_g(L);
	    const Y = cs.YW * fn_g(M);
	    const Z = cs.ZW * fn_g(N);
	    let r, g, b;

	    if (cs.ZW < 1) {
	      r = X * 3.1339 + Y * -1.617 + Z * -0.4906;
	      g = X * -0.9785 + Y * 1.916 + Z * 0.0333;
	      b = X * 0.072 + Y * -0.229 + Z * 1.4057;
	    } else {
	      r = X * 3.2406 + Y * -1.5372 + Z * -0.4986;
	      g = X * -0.9689 + Y * 1.8758 + Z * 0.0415;
	      b = X * 0.0557 + Y * -0.204 + Z * 1.057;
	    }

	    dest[destOffset] = Math.sqrt(r) * 255;
	    dest[destOffset + 1] = Math.sqrt(g) * 255;
	    dest[destOffset + 2] = Math.sqrt(b) * 255;
	  }

	  class LabCS extends ColorSpace {
	    constructor(whitePoint, blackPoint, range) {
	      super("Lab", 3);

	      if (!whitePoint) {
	        throw new _util.FormatError("WhitePoint missing - required for color space Lab");
	      }

	      blackPoint = blackPoint || [0, 0, 0];
	      range = range || [-100, 100, -100, 100];
	      this.XW = whitePoint[0];
	      this.YW = whitePoint[1];
	      this.ZW = whitePoint[2];
	      this.amin = range[0];
	      this.amax = range[1];
	      this.bmin = range[2];
	      this.bmax = range[3];
	      this.XB = blackPoint[0];
	      this.YB = blackPoint[1];
	      this.ZB = blackPoint[2];

	      if (this.XW < 0 || this.ZW < 0 || this.YW !== 1) {
	        throw new _util.FormatError("Invalid WhitePoint components, no fallback available");
	      }

	      if (this.XB < 0 || this.YB < 0 || this.ZB < 0) {
	        (0, _util.info)("Invalid BlackPoint, falling back to default");
	        this.XB = this.YB = this.ZB = 0;
	      }

	      if (this.amin > this.amax || this.bmin > this.bmax) {
	        (0, _util.info)("Invalid Range, falling back to defaults");
	        this.amin = -100;
	        this.amax = 100;
	        this.bmin = -100;
	        this.bmax = 100;
	      }
	    }

	    getRgbItem(src, srcOffset, dest, destOffset) {
	      convertToRgb(this, src, srcOffset, false, dest, destOffset);
	    }

	    getRgbBuffer(src, srcOffset, count, dest, destOffset, bits, alpha01) {
	      const maxVal = (1 << bits) - 1;

	      for (let i = 0; i < count; i++) {
	        convertToRgb(this, src, srcOffset, maxVal, dest, destOffset);
	        srcOffset += 3;
	        destOffset += 3 + alpha01;
	      }
	    }

	    getOutputLength(inputLength, alpha01) {
	      return inputLength * (3 + alpha01) / 3 | 0;
	    }

	    isDefaultDecode(decodeMap, bpc) {
	      return true;
	    }

	    get usesZeroToOneRange() {
	      return (0, _util.shadow)(this, "usesZeroToOneRange", false);
	    }

	  }

	  return LabCS;
	}();

	/***/ }),
	/* 15 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.PartialEvaluator = exports.EvaluatorPreprocessor = void 0;

	var _util = __w_pdfjs_require__(2);

	var _cmap = __w_pdfjs_require__(16);

	var _primitives = __w_pdfjs_require__(5);

	var _fonts = __w_pdfjs_require__(34);

	var _fonts_utils = __w_pdfjs_require__(38);

	var _encodings = __w_pdfjs_require__(37);

	var _standard_fonts = __w_pdfjs_require__(41);

	var _unicode = __w_pdfjs_require__(40);

	var _pattern = __w_pdfjs_require__(50);

	var _xfa_fonts = __w_pdfjs_require__(51);

	var _to_unicode_map = __w_pdfjs_require__(42);

	var _function = __w_pdfjs_require__(57);

	var _parser = __w_pdfjs_require__(17);

	var _image_utils = __w_pdfjs_require__(59);

	var _stream = __w_pdfjs_require__(10);

	var _base_stream = __w_pdfjs_require__(7);

	var _bidi = __w_pdfjs_require__(60);

	var _colorspace = __w_pdfjs_require__(14);

	var _decode_stream = __w_pdfjs_require__(19);

	var _glyphlist = __w_pdfjs_require__(39);

	var _core_utils = __w_pdfjs_require__(6);

	var _metrics = __w_pdfjs_require__(45);

	var _murmurhash = __w_pdfjs_require__(61);

	var _operator_list = __w_pdfjs_require__(62);

	var _image = __w_pdfjs_require__(63);

	const DefaultPartialEvaluatorOptions = Object.freeze({
	  maxImageSize: -1,
	  disableFontFace: false,
	  ignoreErrors: false,
	  isEvalSupported: true,
	  fontExtraProperties: false,
	  useSystemFonts: true,
	  cMapUrl: null,
	  standardFontDataUrl: null
	});
	const PatternType = {
	  TILING: 1,
	  SHADING: 2
	};
	const TEXT_CHUNK_BATCH_SIZE = 10;
	const deferred = Promise.resolve();

	function normalizeBlendMode(value, parsingArray = false) {
	  if (Array.isArray(value)) {
	    for (let i = 0, ii = value.length; i < ii; i++) {
	      const maybeBM = normalizeBlendMode(value[i], true);

	      if (maybeBM) {
	        return maybeBM;
	      }
	    }

	    (0, _util.warn)(`Unsupported blend mode Array: ${value}`);
	    return "source-over";
	  }

	  if (!(value instanceof _primitives.Name)) {
	    if (parsingArray) {
	      return null;
	    }

	    return "source-over";
	  }

	  switch (value.name) {
	    case "Normal":
	    case "Compatible":
	      return "source-over";

	    case "Multiply":
	      return "multiply";

	    case "Screen":
	      return "screen";

	    case "Overlay":
	      return "overlay";

	    case "Darken":
	      return "darken";

	    case "Lighten":
	      return "lighten";

	    case "ColorDodge":
	      return "color-dodge";

	    case "ColorBurn":
	      return "color-burn";

	    case "HardLight":
	      return "hard-light";

	    case "SoftLight":
	      return "soft-light";

	    case "Difference":
	      return "difference";

	    case "Exclusion":
	      return "exclusion";

	    case "Hue":
	      return "hue";

	    case "Saturation":
	      return "saturation";

	    case "Color":
	      return "color";

	    case "Luminosity":
	      return "luminosity";
	  }

	  if (parsingArray) {
	    return null;
	  }

	  (0, _util.warn)(`Unsupported blend mode: ${value.name}`);
	  return "source-over";
	}

	function incrementCachedImageMaskCount(data) {
	  if (data.fn === _util.OPS.paintImageMaskXObject && data.args[0] && data.args[0].count > 0) {
	    data.args[0].count++;
	  }
	}

	class TimeSlotManager {
	  static get TIME_SLOT_DURATION_MS() {
	    return (0, _util.shadow)(this, "TIME_SLOT_DURATION_MS", 20);
	  }

	  static get CHECK_TIME_EVERY() {
	    return (0, _util.shadow)(this, "CHECK_TIME_EVERY", 100);
	  }

	  constructor() {
	    this.reset();
	  }

	  check() {
	    if (++this.checked < TimeSlotManager.CHECK_TIME_EVERY) {
	      return false;
	    }

	    this.checked = 0;
	    return this.endTime <= Date.now();
	  }

	  reset() {
	    this.endTime = Date.now() + TimeSlotManager.TIME_SLOT_DURATION_MS;
	    this.checked = 0;
	  }

	}

	class PartialEvaluator {
	  constructor({
	    xref,
	    handler,
	    pageIndex,
	    idFactory,
	    fontCache,
	    builtInCMapCache,
	    standardFontDataCache,
	    globalImageCache,
	    options = null
	  }) {
	    this.xref = xref;
	    this.handler = handler;
	    this.pageIndex = pageIndex;
	    this.idFactory = idFactory;
	    this.fontCache = fontCache;
	    this.builtInCMapCache = builtInCMapCache;
	    this.standardFontDataCache = standardFontDataCache;
	    this.globalImageCache = globalImageCache;
	    this.options = options || DefaultPartialEvaluatorOptions;
	    this.parsingType3Font = false;
	    this._fetchBuiltInCMapBound = this.fetchBuiltInCMap.bind(this);
	  }

	  get _pdfFunctionFactory() {
	    const pdfFunctionFactory = new _function.PDFFunctionFactory({
	      xref: this.xref,
	      isEvalSupported: this.options.isEvalSupported
	    });
	    return (0, _util.shadow)(this, "_pdfFunctionFactory", pdfFunctionFactory);
	  }

	  clone(newOptions = null) {
	    const newEvaluator = Object.create(this);
	    newEvaluator.options = Object.assign(Object.create(null), this.options, newOptions);
	    return newEvaluator;
	  }

	  hasBlendModes(resources, nonBlendModesSet) {
	    if (!(resources instanceof _primitives.Dict)) {
	      return false;
	    }

	    if (resources.objId && nonBlendModesSet.has(resources.objId)) {
	      return false;
	    }

	    const processed = new _primitives.RefSet(nonBlendModesSet);

	    if (resources.objId) {
	      processed.put(resources.objId);
	    }

	    const nodes = [resources],
	          xref = this.xref;

	    while (nodes.length) {
	      const node = nodes.shift();
	      const graphicStates = node.get("ExtGState");

	      if (graphicStates instanceof _primitives.Dict) {
	        for (let graphicState of graphicStates.getRawValues()) {
	          if (graphicState instanceof _primitives.Ref) {
	            if (processed.has(graphicState)) {
	              continue;
	            }

	            try {
	              graphicState = xref.fetch(graphicState);
	            } catch (ex) {
	              processed.put(graphicState);
	              (0, _util.info)(`hasBlendModes - ignoring ExtGState: "${ex}".`);
	              continue;
	            }
	          }

	          if (!(graphicState instanceof _primitives.Dict)) {
	            continue;
	          }

	          if (graphicState.objId) {
	            processed.put(graphicState.objId);
	          }

	          const bm = graphicState.get("BM");

	          if (bm instanceof _primitives.Name) {
	            if (bm.name !== "Normal") {
	              return true;
	            }

	            continue;
	          }

	          if (bm !== undefined && Array.isArray(bm)) {
	            for (const element of bm) {
	              if (element instanceof _primitives.Name && element.name !== "Normal") {
	                return true;
	              }
	            }
	          }
	        }
	      }

	      const xObjects = node.get("XObject");

	      if (!(xObjects instanceof _primitives.Dict)) {
	        continue;
	      }

	      for (let xObject of xObjects.getRawValues()) {
	        if (xObject instanceof _primitives.Ref) {
	          if (processed.has(xObject)) {
	            continue;
	          }

	          try {
	            xObject = xref.fetch(xObject);
	          } catch (ex) {
	            processed.put(xObject);
	            (0, _util.info)(`hasBlendModes - ignoring XObject: "${ex}".`);
	            continue;
	          }
	        }

	        if (!(xObject instanceof _base_stream.BaseStream)) {
	          continue;
	        }

	        if (xObject.dict.objId) {
	          processed.put(xObject.dict.objId);
	        }

	        const xResources = xObject.dict.get("Resources");

	        if (!(xResources instanceof _primitives.Dict)) {
	          continue;
	        }

	        if (xResources.objId && processed.has(xResources.objId)) {
	          continue;
	        }

	        nodes.push(xResources);

	        if (xResources.objId) {
	          processed.put(xResources.objId);
	        }
	      }
	    }

	    for (const ref of processed) {
	      nonBlendModesSet.put(ref);
	    }

	    return false;
	  }

	  async fetchBuiltInCMap(name) {
	    const cachedData = this.builtInCMapCache.get(name);

	    if (cachedData) {
	      return cachedData;
	    }

	    let data;

	    if (this.options.cMapUrl !== null) {
	      const url = `${this.options.cMapUrl}${name}.bcmap`;
	      const response = await fetch(url);

	      if (!response.ok) {
	        throw new Error(`fetchBuiltInCMap: failed to fetch file "${url}" with "${response.statusText}".`);
	      }

	      data = {
	        cMapData: new Uint8Array(await response.arrayBuffer()),
	        compressionType: _util.CMapCompressionType.BINARY
	      };
	    } else {
	      data = await this.handler.sendWithPromise("FetchBuiltInCMap", {
	        name
	      });
	    }

	    if (data.compressionType !== _util.CMapCompressionType.NONE) {
	      this.builtInCMapCache.set(name, data);
	    }

	    return data;
	  }

	  async fetchStandardFontData(name) {
	    const cachedData = this.standardFontDataCache.get(name);

	    if (cachedData) {
	      return new _stream.Stream(cachedData);
	    }

	    if (this.options.useSystemFonts && name !== "Symbol" && name !== "ZapfDingbats") {
	      return null;
	    }

	    const standardFontNameToFileName = (0, _standard_fonts.getFontNameToFileMap)(),
	          filename = standardFontNameToFileName[name];
	    let data;

	    if (this.options.standardFontDataUrl !== null) {
	      const url = `${this.options.standardFontDataUrl}${filename}`;
	      const response = await fetch(url);

	      if (!response.ok) {
	        (0, _util.warn)(`fetchStandardFontData: failed to fetch file "${url}" with "${response.statusText}".`);
	      } else {
	        data = await response.arrayBuffer();
	      }
	    } else {
	      try {
	        data = await this.handler.sendWithPromise("FetchStandardFontData", {
	          filename
	        });
	      } catch (e) {
	        (0, _util.warn)(`fetchStandardFontData: failed to fetch file "${filename}" with "${e}".`);
	      }
	    }

	    if (!data) {
	      return null;
	    }

	    this.standardFontDataCache.set(name, data);
	    return new _stream.Stream(data);
	  }

	  async buildFormXObject(resources, xobj, smask, operatorList, task, initialState, localColorSpaceCache) {
	    const dict = xobj.dict;
	    const matrix = dict.getArray("Matrix");
	    let bbox = dict.getArray("BBox");

	    if (Array.isArray(bbox) && bbox.length === 4) {
	      bbox = _util.Util.normalizeRect(bbox);
	    } else {
	      bbox = null;
	    }

	    let optionalContent, groupOptions;

	    if (dict.has("OC")) {
	      optionalContent = await this.parseMarkedContentProps(dict.get("OC"), resources);
	    }

	    if (optionalContent !== undefined) {
	      operatorList.addOp(_util.OPS.beginMarkedContentProps, ["OC", optionalContent]);
	    }

	    const group = dict.get("Group");

	    if (group) {
	      groupOptions = {
	        matrix,
	        bbox,
	        smask,
	        isolated: false,
	        knockout: false
	      };
	      const groupSubtype = group.get("S");
	      let colorSpace = null;

	      if ((0, _primitives.isName)(groupSubtype, "Transparency")) {
	        groupOptions.isolated = group.get("I") || false;
	        groupOptions.knockout = group.get("K") || false;

	        if (group.has("CS")) {
	          const cs = group.getRaw("CS");

	          const cachedColorSpace = _colorspace.ColorSpace.getCached(cs, this.xref, localColorSpaceCache);

	          if (cachedColorSpace) {
	            colorSpace = cachedColorSpace;
	          } else {
	            colorSpace = await this.parseColorSpace({
	              cs,
	              resources,
	              localColorSpaceCache
	            });
	          }
	        }
	      }

	      if (smask && smask.backdrop) {
	        colorSpace = colorSpace || _colorspace.ColorSpace.singletons.rgb;
	        smask.backdrop = colorSpace.getRgb(smask.backdrop, 0);
	      }

	      operatorList.addOp(_util.OPS.beginGroup, [groupOptions]);
	    }

	    const args = group ? [matrix, null] : [matrix, bbox];
	    operatorList.addOp(_util.OPS.paintFormXObjectBegin, args);
	    return this.getOperatorList({
	      stream: xobj,
	      task,
	      resources: dict.get("Resources") || resources,
	      operatorList,
	      initialState
	    }).then(function () {
	      operatorList.addOp(_util.OPS.paintFormXObjectEnd, []);

	      if (group) {
	        operatorList.addOp(_util.OPS.endGroup, [groupOptions]);
	      }

	      if (optionalContent !== undefined) {
	        operatorList.addOp(_util.OPS.endMarkedContent, []);
	      }
	    });
	  }

	  _sendImgData(objId, imgData, cacheGlobally = false) {
	    const transfers = imgData ? [imgData.bitmap || imgData.data.buffer] : null;

	    if (this.parsingType3Font || cacheGlobally) {
	      return this.handler.send("commonobj", [objId, "Image", imgData], transfers);
	    }

	    return this.handler.send("obj", [objId, this.pageIndex, "Image", imgData], transfers);
	  }

	  async buildPaintImageXObject({
	    resources,
	    image,
	    isInline = false,
	    operatorList,
	    cacheKey,
	    localImageCache,
	    localColorSpaceCache
	  }) {
	    const dict = image.dict;
	    const imageRef = dict.objId;
	    const w = dict.get("W", "Width");
	    const h = dict.get("H", "Height");

	    if (!(w && typeof w === "number") || !(h && typeof h === "number")) {
	      (0, _util.warn)("Image dimensions are missing, or not numbers.");
	      return;
	    }

	    const maxImageSize = this.options.maxImageSize;

	    if (maxImageSize !== -1 && w * h > maxImageSize) {
	      const msg = "Image exceeded maximum allowed size and was removed.";

	      if (this.options.ignoreErrors) {
	        (0, _util.warn)(msg);
	        return;
	      }

	      throw new Error(msg);
	    }

	    let optionalContent;

	    if (dict.has("OC")) {
	      optionalContent = await this.parseMarkedContentProps(dict.get("OC"), resources);
	    }

	    const imageMask = dict.get("IM", "ImageMask") || false;
	    let imgData, args;

	    if (imageMask) {
	      const interpolate = dict.get("I", "Interpolate");
	      const bitStrideLength = w + 7 >> 3;
	      const imgArray = image.getBytes(bitStrideLength * h);
	      const decode = dict.getArray("D", "Decode");

	      if (this.parsingType3Font) {
	        imgData = _image.PDFImage.createRawMask({
	          imgArray,
	          width: w,
	          height: h,
	          imageIsFromDecodeStream: image instanceof _decode_stream.DecodeStream,
	          inverseDecode: !!decode && decode[0] > 0,
	          interpolate
	        });
	        imgData.cached = !!cacheKey;
	        args = [imgData];
	        operatorList.addImageOps(_util.OPS.paintImageMaskXObject, args, optionalContent);

	        if (cacheKey) {
	          localImageCache.set(cacheKey, imageRef, {
	            fn: _util.OPS.paintImageMaskXObject,
	            args,
	            optionalContent
	          });
	        }

	        return;
	      }

	      imgData = _image.PDFImage.createMask({
	        imgArray,
	        width: w,
	        height: h,
	        imageIsFromDecodeStream: image instanceof _decode_stream.DecodeStream,
	        inverseDecode: !!decode && decode[0] > 0,
	        interpolate
	      });

	      if (imgData.isSingleOpaquePixel) {
	        operatorList.addImageOps(_util.OPS.paintSolidColorImageMask, [], optionalContent);

	        if (cacheKey) {
	          localImageCache.set(cacheKey, imageRef, {
	            fn: _util.OPS.paintSolidColorImageMask,
	            args: [],
	            optionalContent
	          });
	        }

	        return;
	      }

	      const objId = `mask_${this.idFactory.createObjId()}`;
	      operatorList.addDependency(objId);

	      this._sendImgData(objId, imgData);

	      args = [{
	        data: objId,
	        width: imgData.width,
	        height: imgData.height,
	        interpolate: imgData.interpolate,
	        count: 1
	      }];
	      operatorList.addImageOps(_util.OPS.paintImageMaskXObject, args, optionalContent);

	      if (cacheKey) {
	        localImageCache.set(cacheKey, imageRef, {
	          fn: _util.OPS.paintImageMaskXObject,
	          args,
	          optionalContent
	        });
	      }

	      return;
	    }

	    const softMask = dict.get("SM", "SMask") || false;
	    const mask = dict.get("Mask") || false;
	    const SMALL_IMAGE_DIMENSIONS = 200;

	    if (isInline && !softMask && !mask && w + h < SMALL_IMAGE_DIMENSIONS) {
	      const imageObj = new _image.PDFImage({
	        xref: this.xref,
	        res: resources,
	        image,
	        isInline,
	        pdfFunctionFactory: this._pdfFunctionFactory,
	        localColorSpaceCache
	      });
	      imgData = imageObj.createImageData(true);
	      operatorList.addImageOps(_util.OPS.paintInlineImageXObject, [imgData], optionalContent);
	      return;
	    }

	    let objId = `img_${this.idFactory.createObjId()}`,
	        cacheGlobally = false;

	    if (this.parsingType3Font) {
	      objId = `${this.idFactory.getDocId()}_type3_${objId}`;
	    } else if (imageRef) {
	      cacheGlobally = this.globalImageCache.shouldCache(imageRef, this.pageIndex);

	      if (cacheGlobally) {
	        objId = `${this.idFactory.getDocId()}_${objId}`;
	      }
	    }

	    operatorList.addDependency(objId);
	    args = [objId, w, h];

	    _image.PDFImage.buildImage({
	      xref: this.xref,
	      res: resources,
	      image,
	      isInline,
	      pdfFunctionFactory: this._pdfFunctionFactory,
	      localColorSpaceCache
	    }).then(imageObj => {
	      imgData = imageObj.createImageData(false);

	      if (cacheKey && imageRef && cacheGlobally) {
	        this.globalImageCache.addByteSize(imageRef, imgData.data.length);
	      }

	      return this._sendImgData(objId, imgData, cacheGlobally);
	    }).catch(reason => {
	      (0, _util.warn)(`Unable to decode image "${objId}": "${reason}".`);
	      return this._sendImgData(objId, null, cacheGlobally);
	    });

	    operatorList.addImageOps(_util.OPS.paintImageXObject, args, optionalContent);

	    if (cacheKey) {
	      localImageCache.set(cacheKey, imageRef, {
	        fn: _util.OPS.paintImageXObject,
	        args,
	        optionalContent
	      });

	      if (imageRef) {
	        (0, _util.assert)(!isInline, "Cannot cache an inline image globally.");
	        this.globalImageCache.addPageIndex(imageRef, this.pageIndex);

	        if (cacheGlobally) {
	          this.globalImageCache.setData(imageRef, {
	            objId,
	            fn: _util.OPS.paintImageXObject,
	            args,
	            optionalContent,
	            byteSize: 0
	          });
	        }
	      }
	    }
	  }

	  handleSMask(smask, resources, operatorList, task, stateManager, localColorSpaceCache) {
	    const smaskContent = smask.get("G");
	    const smaskOptions = {
	      subtype: smask.get("S").name,
	      backdrop: smask.get("BC")
	    };
	    const transferObj = smask.get("TR");

	    if ((0, _function.isPDFFunction)(transferObj)) {
	      const transferFn = this._pdfFunctionFactory.create(transferObj);

	      const transferMap = new Uint8Array(256);
	      const tmp = new Float32Array(1);

	      for (let i = 0; i < 256; i++) {
	        tmp[0] = i / 255;
	        transferFn(tmp, 0, tmp, 0);
	        transferMap[i] = tmp[0] * 255 | 0;
	      }

	      smaskOptions.transferMap = transferMap;
	    }

	    return this.buildFormXObject(resources, smaskContent, smaskOptions, operatorList, task, stateManager.state.clone(), localColorSpaceCache);
	  }

	  handleTransferFunction(tr) {
	    let transferArray;

	    if (Array.isArray(tr)) {
	      transferArray = tr;
	    } else if ((0, _function.isPDFFunction)(tr)) {
	      transferArray = [tr];
	    } else {
	      return null;
	    }

	    const transferMaps = [];
	    let numFns = 0,
	        numEffectfulFns = 0;

	    for (const entry of transferArray) {
	      const transferObj = this.xref.fetchIfRef(entry);
	      numFns++;

	      if ((0, _primitives.isName)(transferObj, "Identity")) {
	        transferMaps.push(null);
	        continue;
	      } else if (!(0, _function.isPDFFunction)(transferObj)) {
	        return null;
	      }

	      const transferFn = this._pdfFunctionFactory.create(transferObj);

	      const transferMap = new Uint8Array(256),
	            tmp = new Float32Array(1);

	      for (let j = 0; j < 256; j++) {
	        tmp[0] = j / 255;
	        transferFn(tmp, 0, tmp, 0);
	        transferMap[j] = tmp[0] * 255 | 0;
	      }

	      transferMaps.push(transferMap);
	      numEffectfulFns++;
	    }

	    if (!(numFns === 1 || numFns === 4)) {
	      return null;
	    }

	    if (numEffectfulFns === 0) {
	      return null;
	    }

	    return transferMaps;
	  }

	  handleTilingType(fn, color, resources, pattern, patternDict, operatorList, task, localTilingPatternCache) {
	    const tilingOpList = new _operator_list.OperatorList();

	    const patternResources = _primitives.Dict.merge({
	      xref: this.xref,
	      dictArray: [patternDict.get("Resources"), resources]
	    });

	    return this.getOperatorList({
	      stream: pattern,
	      task,
	      resources: patternResources,
	      operatorList: tilingOpList
	    }).then(function () {
	      const operatorListIR = tilingOpList.getIR();
	      const tilingPatternIR = (0, _pattern.getTilingPatternIR)(operatorListIR, patternDict, color);
	      operatorList.addDependencies(tilingOpList.dependencies);
	      operatorList.addOp(fn, tilingPatternIR);

	      if (patternDict.objId) {
	        localTilingPatternCache.set(null, patternDict.objId, {
	          operatorListIR,
	          dict: patternDict
	        });
	      }
	    }).catch(reason => {
	      if (reason instanceof _util.AbortException) {
	        return;
	      }

	      if (this.options.ignoreErrors) {
	        this.handler.send("UnsupportedFeature", {
	          featureId: _util.UNSUPPORTED_FEATURES.errorTilingPattern
	        });
	        (0, _util.warn)(`handleTilingType - ignoring pattern: "${reason}".`);
	        return;
	      }

	      throw reason;
	    });
	  }

	  handleSetFont(resources, fontArgs, fontRef, operatorList, task, state, fallbackFontDict = null, cssFontInfo = null) {
	    const fontName = fontArgs && fontArgs[0] instanceof _primitives.Name ? fontArgs[0].name : null;
	    return this.loadFont(fontName, fontRef, resources, fallbackFontDict, cssFontInfo).then(translated => {
	      if (!translated.font.isType3Font) {
	        return translated;
	      }

	      return translated.loadType3Data(this, resources, task).then(function () {
	        operatorList.addDependencies(translated.type3Dependencies);
	        return translated;
	      }).catch(reason => {
	        this.handler.send("UnsupportedFeature", {
	          featureId: _util.UNSUPPORTED_FEATURES.errorFontLoadType3
	        });
	        return new TranslatedFont({
	          loadedName: "g_font_error",
	          font: new _fonts.ErrorFont(`Type3 font load error: ${reason}`),
	          dict: translated.font,
	          evaluatorOptions: this.options
	        });
	      });
	    }).then(translated => {
	      state.font = translated.font;
	      translated.send(this.handler);
	      return translated.loadedName;
	    });
	  }

	  handleText(chars, state) {
	    const font = state.font;
	    const glyphs = font.charsToGlyphs(chars);

	    if (font.data) {
	      const isAddToPathSet = !!(state.textRenderingMode & _util.TextRenderingMode.ADD_TO_PATH_FLAG);

	      if (isAddToPathSet || state.fillColorSpace.name === "Pattern" || font.disableFontFace || this.options.disableFontFace) {
	        PartialEvaluator.buildFontPaths(font, glyphs, this.handler, this.options);
	      }
	    }

	    return glyphs;
	  }

	  ensureStateFont(state) {
	    if (state.font) {
	      return;
	    }

	    const reason = new _util.FormatError("Missing setFont (Tf) operator before text rendering operator.");

	    if (this.options.ignoreErrors) {
	      this.handler.send("UnsupportedFeature", {
	        featureId: _util.UNSUPPORTED_FEATURES.errorFontState
	      });
	      (0, _util.warn)(`ensureStateFont: "${reason}".`);
	      return;
	    }

	    throw reason;
	  }

	  async setGState({
	    resources,
	    gState,
	    operatorList,
	    cacheKey,
	    task,
	    stateManager,
	    localGStateCache,
	    localColorSpaceCache
	  }) {
	    const gStateRef = gState.objId;
	    let isSimpleGState = true;
	    const gStateObj = [];
	    const gStateKeys = gState.getKeys();
	    let promise = Promise.resolve();

	    for (let i = 0, ii = gStateKeys.length; i < ii; i++) {
	      const key = gStateKeys[i];
	      const value = gState.get(key);

	      switch (key) {
	        case "Type":
	          break;

	        case "LW":
	        case "LC":
	        case "LJ":
	        case "ML":
	        case "D":
	        case "RI":
	        case "FL":
	        case "CA":
	        case "ca":
	          gStateObj.push([key, value]);
	          break;

	        case "Font":
	          isSimpleGState = false;
	          promise = promise.then(() => {
	            return this.handleSetFont(resources, null, value[0], operatorList, task, stateManager.state).then(function (loadedName) {
	              operatorList.addDependency(loadedName);
	              gStateObj.push([key, [loadedName, value[1]]]);
	            });
	          });
	          break;

	        case "BM":
	          gStateObj.push([key, normalizeBlendMode(value)]);
	          break;

	        case "SMask":
	          if ((0, _primitives.isName)(value, "None")) {
	            gStateObj.push([key, false]);
	            break;
	          }

	          if (value instanceof _primitives.Dict) {
	            isSimpleGState = false;
	            promise = promise.then(() => {
	              return this.handleSMask(value, resources, operatorList, task, stateManager, localColorSpaceCache);
	            });
	            gStateObj.push([key, true]);
	          } else {
	            (0, _util.warn)("Unsupported SMask type");
	          }

	          break;

	        case "TR":
	          const transferMaps = this.handleTransferFunction(value);
	          gStateObj.push([key, transferMaps]);
	          break;

	        case "OP":
	        case "op":
	        case "OPM":
	        case "BG":
	        case "BG2":
	        case "UCR":
	        case "UCR2":
	        case "TR2":
	        case "HT":
	        case "SM":
	        case "SA":
	        case "AIS":
	        case "TK":
	          (0, _util.info)("graphic state operator " + key);
	          break;

	        default:
	          (0, _util.info)("Unknown graphic state operator " + key);
	          break;
	      }
	    }

	    return promise.then(function () {
	      if (gStateObj.length > 0) {
	        operatorList.addOp(_util.OPS.setGState, [gStateObj]);
	      }

	      if (isSimpleGState) {
	        localGStateCache.set(cacheKey, gStateRef, gStateObj);
	      }
	    });
	  }

	  loadFont(fontName, font, resources, fallbackFontDict = null, cssFontInfo = null) {
	    const errorFont = async () => {
	      return new TranslatedFont({
	        loadedName: "g_font_error",
	        font: new _fonts.ErrorFont(`Font "${fontName}" is not available.`),
	        dict: font,
	        evaluatorOptions: this.options
	      });
	    };

	    const xref = this.xref;
	    let fontRef;

	    if (font) {
	      if (font instanceof _primitives.Ref) {
	        fontRef = font;
	      }
	    } else {
	      const fontRes = resources.get("Font");

	      if (fontRes) {
	        fontRef = fontRes.getRaw(fontName);
	      }
	    }

	    if (!fontRef) {
	      const partialMsg = `Font "${fontName || font && font.toString()}" is not available`;

	      if (!this.options.ignoreErrors && !this.parsingType3Font) {
	        (0, _util.warn)(`${partialMsg}.`);
	        return errorFont();
	      }

	      this.handler.send("UnsupportedFeature", {
	        featureId: _util.UNSUPPORTED_FEATURES.errorFontMissing
	      });
	      (0, _util.warn)(`${partialMsg} -- attempting to fallback to a default font.`);

	      if (fallbackFontDict) {
	        fontRef = fallbackFontDict;
	      } else {
	        fontRef = PartialEvaluator.fallbackFontDict;
	      }
	    }

	    if (this.parsingType3Font && this.type3FontRefs.has(fontRef)) {
	      return errorFont();
	    }

	    if (this.fontCache.has(fontRef)) {
	      return this.fontCache.get(fontRef);
	    }

	    font = xref.fetchIfRef(fontRef);

	    if (!(font instanceof _primitives.Dict)) {
	      return errorFont();
	    }

	    if (font.cacheKey && this.fontCache.has(font.cacheKey)) {
	      return this.fontCache.get(font.cacheKey);
	    }

	    const fontCapability = (0, _util.createPromiseCapability)();
	    let preEvaluatedFont;

	    try {
	      preEvaluatedFont = this.preEvaluateFont(font);
	      preEvaluatedFont.cssFontInfo = cssFontInfo;
	    } catch (reason) {
	      (0, _util.warn)(`loadFont - preEvaluateFont failed: "${reason}".`);
	      return errorFont();
	    }

	    const {
	      descriptor,
	      hash
	    } = preEvaluatedFont;
	    const fontRefIsRef = fontRef instanceof _primitives.Ref;
	    let fontID;

	    if (fontRefIsRef) {
	      fontID = `f${fontRef.toString()}`;
	    }

	    if (hash && descriptor instanceof _primitives.Dict) {
	      if (!descriptor.fontAliases) {
	        descriptor.fontAliases = Object.create(null);
	      }

	      const fontAliases = descriptor.fontAliases;

	      if (fontAliases[hash]) {
	        const aliasFontRef = fontAliases[hash].aliasRef;

	        if (fontRefIsRef && aliasFontRef && this.fontCache.has(aliasFontRef)) {
	          this.fontCache.putAlias(fontRef, aliasFontRef);
	          return this.fontCache.get(fontRef);
	        }
	      } else {
	        fontAliases[hash] = {
	          fontID: this.idFactory.createFontId()
	        };
	      }

	      if (fontRefIsRef) {
	        fontAliases[hash].aliasRef = fontRef;
	      }

	      fontID = fontAliases[hash].fontID;
	    }

	    if (fontRefIsRef) {
	      this.fontCache.put(fontRef, fontCapability.promise);
	    } else {
	      if (!fontID) {
	        fontID = this.idFactory.createFontId();
	      }

	      font.cacheKey = `cacheKey_${fontID}`;
	      this.fontCache.put(font.cacheKey, fontCapability.promise);
	    }

	    (0, _util.assert)(fontID && fontID.startsWith("f"), 'The "fontID" must be (correctly) defined.');
	    font.loadedName = `${this.idFactory.getDocId()}_${fontID}`;
	    this.translateFont(preEvaluatedFont).then(translatedFont => {
	      if (translatedFont.fontType !== undefined) {
	        xref.stats.addFontType(translatedFont.fontType);
	      }

	      fontCapability.resolve(new TranslatedFont({
	        loadedName: font.loadedName,
	        font: translatedFont,
	        dict: font,
	        evaluatorOptions: this.options
	      }));
	    }).catch(reason => {
	      this.handler.send("UnsupportedFeature", {
	        featureId: _util.UNSUPPORTED_FEATURES.errorFontTranslate
	      });
	      (0, _util.warn)(`loadFont - translateFont failed: "${reason}".`);

	      try {
	        const fontFile3 = descriptor && descriptor.get("FontFile3");
	        const subtype = fontFile3 && fontFile3.get("Subtype");
	        const fontType = (0, _fonts_utils.getFontType)(preEvaluatedFont.type, subtype && subtype.name);

	        if (fontType !== undefined) {
	          xref.stats.addFontType(fontType);
	        }
	      } catch (ex) {}

	      fontCapability.resolve(new TranslatedFont({
	        loadedName: font.loadedName,
	        font: new _fonts.ErrorFont(reason instanceof Error ? reason.message : reason),
	        dict: font,
	        evaluatorOptions: this.options
	      }));
	    });
	    return fontCapability.promise;
	  }

	  buildPath(operatorList, fn, args, parsingText = false) {
	    const lastIndex = operatorList.length - 1;

	    if (!args) {
	      args = [];
	    }

	    let minMax;

	    if (lastIndex < 0 || operatorList.fnArray[lastIndex] !== _util.OPS.constructPath) {
	      if (parsingText) {
	        (0, _util.warn)(`Encountered path operator "${fn}" inside of a text object.`);
	        operatorList.addOp(_util.OPS.save, null);
	      }

	      minMax = [Infinity, -Infinity, Infinity, -Infinity];
	      operatorList.addOp(_util.OPS.constructPath, [[fn], args, minMax]);

	      if (parsingText) {
	        operatorList.addOp(_util.OPS.restore, null);
	      }
	    } else {
	      const opArgs = operatorList.argsArray[lastIndex];
	      opArgs[0].push(fn);
	      Array.prototype.push.apply(opArgs[1], args);
	      minMax = opArgs[2];
	    }

	    switch (fn) {
	      case _util.OPS.rectangle:
	        minMax[0] = Math.min(minMax[0], args[0], args[0] + args[2]);
	        minMax[1] = Math.max(minMax[1], args[0], args[0] + args[2]);
	        minMax[2] = Math.min(minMax[2], args[1], args[1] + args[3]);
	        minMax[3] = Math.max(minMax[3], args[1], args[1] + args[3]);
	        break;

	      case _util.OPS.moveTo:
	      case _util.OPS.lineTo:
	        minMax[0] = Math.min(minMax[0], args[0]);
	        minMax[1] = Math.max(minMax[1], args[0]);
	        minMax[2] = Math.min(minMax[2], args[1]);
	        minMax[3] = Math.max(minMax[3], args[1]);
	        break;
	    }
	  }

	  parseColorSpace({
	    cs,
	    resources,
	    localColorSpaceCache
	  }) {
	    return _colorspace.ColorSpace.parseAsync({
	      cs,
	      xref: this.xref,
	      resources,
	      pdfFunctionFactory: this._pdfFunctionFactory,
	      localColorSpaceCache
	    }).catch(reason => {
	      if (reason instanceof _util.AbortException) {
	        return null;
	      }

	      if (this.options.ignoreErrors) {
	        this.handler.send("UnsupportedFeature", {
	          featureId: _util.UNSUPPORTED_FEATURES.errorColorSpace
	        });
	        (0, _util.warn)(`parseColorSpace - ignoring ColorSpace: "${reason}".`);
	        return null;
	      }

	      throw reason;
	    });
	  }

	  parseShading({
	    shading,
	    resources,
	    localColorSpaceCache,
	    localShadingPatternCache
	  }) {
	    let id = localShadingPatternCache.get(shading);

	    if (!id) {
	      var shadingFill = _pattern.Pattern.parseShading(shading, this.xref, resources, this.handler, this._pdfFunctionFactory, localColorSpaceCache);

	      const patternIR = shadingFill.getIR();
	      id = `pattern_${this.idFactory.createObjId()}`;
	      localShadingPatternCache.set(shading, id);
	      this.handler.send("obj", [id, this.pageIndex, "Pattern", patternIR]);
	    }

	    return id;
	  }

	  handleColorN(operatorList, fn, args, cs, patterns, resources, task, localColorSpaceCache, localTilingPatternCache, localShadingPatternCache) {
	    const patternName = args.pop();

	    if (patternName instanceof _primitives.Name) {
	      const rawPattern = patterns.getRaw(patternName.name);
	      const localTilingPattern = rawPattern instanceof _primitives.Ref && localTilingPatternCache.getByRef(rawPattern);

	      if (localTilingPattern) {
	        try {
	          const color = cs.base ? cs.base.getRgb(args, 0) : null;
	          const tilingPatternIR = (0, _pattern.getTilingPatternIR)(localTilingPattern.operatorListIR, localTilingPattern.dict, color);
	          operatorList.addOp(fn, tilingPatternIR);
	          return undefined;
	        } catch (ex) {}
	      }

	      const pattern = this.xref.fetchIfRef(rawPattern);

	      if (pattern) {
	        const dict = pattern instanceof _base_stream.BaseStream ? pattern.dict : pattern;
	        const typeNum = dict.get("PatternType");

	        if (typeNum === PatternType.TILING) {
	          const color = cs.base ? cs.base.getRgb(args, 0) : null;
	          return this.handleTilingType(fn, color, resources, pattern, dict, operatorList, task, localTilingPatternCache);
	        } else if (typeNum === PatternType.SHADING) {
	          const shading = dict.get("Shading");
	          const matrix = dict.getArray("Matrix");
	          const objId = this.parseShading({
	            shading,
	            resources,
	            localColorSpaceCache,
	            localShadingPatternCache
	          });
	          operatorList.addOp(fn, ["Shading", objId, matrix]);
	          return undefined;
	        }

	        throw new _util.FormatError(`Unknown PatternType: ${typeNum}`);
	      }
	    }

	    throw new _util.FormatError(`Unknown PatternName: ${patternName}`);
	  }

	  _parseVisibilityExpression(array, nestingCounter, currentResult) {
	    const MAX_NESTING = 10;

	    if (++nestingCounter > MAX_NESTING) {
	      (0, _util.warn)("Visibility expression is too deeply nested");
	      return;
	    }

	    const length = array.length;
	    const operator = this.xref.fetchIfRef(array[0]);

	    if (length < 2 || !(operator instanceof _primitives.Name)) {
	      (0, _util.warn)("Invalid visibility expression");
	      return;
	    }

	    switch (operator.name) {
	      case "And":
	      case "Or":
	      case "Not":
	        currentResult.push(operator.name);
	        break;

	      default:
	        (0, _util.warn)(`Invalid operator ${operator.name} in visibility expression`);
	        return;
	    }

	    for (let i = 1; i < length; i++) {
	      const raw = array[i];
	      const object = this.xref.fetchIfRef(raw);

	      if (Array.isArray(object)) {
	        const nestedResult = [];
	        currentResult.push(nestedResult);

	        this._parseVisibilityExpression(object, nestingCounter, nestedResult);
	      } else if (raw instanceof _primitives.Ref) {
	        currentResult.push(raw.toString());
	      }
	    }
	  }

	  async parseMarkedContentProps(contentProperties, resources) {
	    let optionalContent;

	    if (contentProperties instanceof _primitives.Name) {
	      const properties = resources.get("Properties");
	      optionalContent = properties.get(contentProperties.name);
	    } else if (contentProperties instanceof _primitives.Dict) {
	      optionalContent = contentProperties;
	    } else {
	      throw new _util.FormatError("Optional content properties malformed.");
	    }

	    const optionalContentType = optionalContent.get("Type").name;

	    if (optionalContentType === "OCG") {
	      return {
	        type: optionalContentType,
	        id: optionalContent.objId
	      };
	    } else if (optionalContentType === "OCMD") {
	      const expression = optionalContent.get("VE");

	      if (Array.isArray(expression)) {
	        const result = [];

	        this._parseVisibilityExpression(expression, 0, result);

	        if (result.length > 0) {
	          return {
	            type: "OCMD",
	            expression: result
	          };
	        }
	      }

	      const optionalContentGroups = optionalContent.get("OCGs");

	      if (Array.isArray(optionalContentGroups) || optionalContentGroups instanceof _primitives.Dict) {
	        const groupIds = [];

	        if (Array.isArray(optionalContentGroups)) {
	          for (const ocg of optionalContentGroups) {
	            groupIds.push(ocg.toString());
	          }
	        } else {
	          groupIds.push(optionalContentGroups.objId);
	        }

	        return {
	          type: optionalContentType,
	          ids: groupIds,
	          policy: optionalContent.get("P") instanceof _primitives.Name ? optionalContent.get("P").name : null,
	          expression: null
	        };
	      } else if (optionalContentGroups instanceof _primitives.Ref) {
	        return {
	          type: optionalContentType,
	          id: optionalContentGroups.toString()
	        };
	      }
	    }

	    return null;
	  }

	  getOperatorList({
	    stream,
	    task,
	    resources,
	    operatorList,
	    initialState = null,
	    fallbackFontDict = null
	  }) {
	    resources = resources || _primitives.Dict.empty;
	    initialState = initialState || new EvalState();

	    if (!operatorList) {
	      throw new Error('getOperatorList: missing "operatorList" parameter');
	    }

	    const self = this;
	    const xref = this.xref;
	    let parsingText = false;
	    const localImageCache = new _image_utils.LocalImageCache();
	    const localColorSpaceCache = new _image_utils.LocalColorSpaceCache();
	    const localGStateCache = new _image_utils.LocalGStateCache();
	    const localTilingPatternCache = new _image_utils.LocalTilingPatternCache();
	    const localShadingPatternCache = new Map();

	    const xobjs = resources.get("XObject") || _primitives.Dict.empty;

	    const patterns = resources.get("Pattern") || _primitives.Dict.empty;

	    const stateManager = new StateManager(initialState);
	    const preprocessor = new EvaluatorPreprocessor(stream, xref, stateManager);
	    const timeSlotManager = new TimeSlotManager();

	    function closePendingRestoreOPS(argument) {
	      for (let i = 0, ii = preprocessor.savedStatesDepth; i < ii; i++) {
	        operatorList.addOp(_util.OPS.restore, []);
	      }
	    }

	    return new Promise(function promiseBody(resolve, reject) {
	      const next = function (promise) {
	        Promise.all([promise, operatorList.ready]).then(function () {
	          try {
	            promiseBody(resolve, reject);
	          } catch (ex) {
	            reject(ex);
	          }
	        }, reject);
	      };

	      task.ensureNotTerminated();
	      timeSlotManager.reset();
	      const operation = {};
	      let stop, i, ii, cs, name, isValidName;

	      while (!(stop = timeSlotManager.check())) {
	        operation.args = null;

	        if (!preprocessor.read(operation)) {
	          break;
	        }

	        let args = operation.args;
	        let fn = operation.fn;

	        switch (fn | 0) {
	          case _util.OPS.paintXObject:
	            isValidName = args[0] instanceof _primitives.Name;
	            name = args[0].name;

	            if (isValidName) {
	              const localImage = localImageCache.getByName(name);

	              if (localImage) {
	                operatorList.addImageOps(localImage.fn, localImage.args, localImage.optionalContent);
	                incrementCachedImageMaskCount(localImage);
	                args = null;
	                continue;
	              }
	            }

	            next(new Promise(function (resolveXObject, rejectXObject) {
	              if (!isValidName) {
	                throw new _util.FormatError("XObject must be referred to by name.");
	              }

	              let xobj = xobjs.getRaw(name);

	              if (xobj instanceof _primitives.Ref) {
	                const localImage = localImageCache.getByRef(xobj);

	                if (localImage) {
	                  operatorList.addImageOps(localImage.fn, localImage.args, localImage.optionalContent);
	                  incrementCachedImageMaskCount(localImage);
	                  resolveXObject();
	                  return;
	                }

	                const globalImage = self.globalImageCache.getData(xobj, self.pageIndex);

	                if (globalImage) {
	                  operatorList.addDependency(globalImage.objId);
	                  operatorList.addImageOps(globalImage.fn, globalImage.args, globalImage.optionalContent);
	                  resolveXObject();
	                  return;
	                }

	                xobj = xref.fetch(xobj);
	              }

	              if (!(xobj instanceof _base_stream.BaseStream)) {
	                throw new _util.FormatError("XObject should be a stream");
	              }

	              const type = xobj.dict.get("Subtype");

	              if (!(type instanceof _primitives.Name)) {
	                throw new _util.FormatError("XObject should have a Name subtype");
	              }

	              if (type.name === "Form") {
	                stateManager.save();
	                self.buildFormXObject(resources, xobj, null, operatorList, task, stateManager.state.clone(), localColorSpaceCache).then(function () {
	                  stateManager.restore();
	                  resolveXObject();
	                }, rejectXObject);
	                return;
	              } else if (type.name === "Image") {
	                self.buildPaintImageXObject({
	                  resources,
	                  image: xobj,
	                  operatorList,
	                  cacheKey: name,
	                  localImageCache,
	                  localColorSpaceCache
	                }).then(resolveXObject, rejectXObject);
	                return;
	              } else if (type.name === "PS") {
	                (0, _util.info)("Ignored XObject subtype PS");
	              } else {
	                throw new _util.FormatError(`Unhandled XObject subtype ${type.name}`);
	              }

	              resolveXObject();
	            }).catch(function (reason) {
	              if (reason instanceof _util.AbortException) {
	                return;
	              }

	              if (self.options.ignoreErrors) {
	                self.handler.send("UnsupportedFeature", {
	                  featureId: _util.UNSUPPORTED_FEATURES.errorXObject
	                });
	                (0, _util.warn)(`getOperatorList - ignoring XObject: "${reason}".`);
	                return;
	              }

	              throw reason;
	            }));
	            return;

	          case _util.OPS.setFont:
	            var fontSize = args[1];
	            next(self.handleSetFont(resources, args, null, operatorList, task, stateManager.state, fallbackFontDict).then(function (loadedName) {
	              operatorList.addDependency(loadedName);
	              operatorList.addOp(_util.OPS.setFont, [loadedName, fontSize]);
	            }));
	            return;

	          case _util.OPS.beginText:
	            parsingText = true;
	            break;

	          case _util.OPS.endText:
	            parsingText = false;
	            break;

	          case _util.OPS.endInlineImage:
	            var cacheKey = args[0].cacheKey;

	            if (cacheKey) {
	              const localImage = localImageCache.getByName(cacheKey);

	              if (localImage) {
	                operatorList.addImageOps(localImage.fn, localImage.args, localImage.optionalContent);
	                incrementCachedImageMaskCount(localImage);
	                args = null;
	                continue;
	              }
	            }

	            next(self.buildPaintImageXObject({
	              resources,
	              image: args[0],
	              isInline: true,
	              operatorList,
	              cacheKey,
	              localImageCache,
	              localColorSpaceCache
	            }));
	            return;

	          case _util.OPS.showText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            args[0] = self.handleText(args[0], stateManager.state);
	            break;

	          case _util.OPS.showSpacedText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            var arr = args[0];
	            var combinedGlyphs = [];
	            var arrLength = arr.length;
	            var state = stateManager.state;

	            for (i = 0; i < arrLength; ++i) {
	              const arrItem = arr[i];

	              if (typeof arrItem === "string") {
	                Array.prototype.push.apply(combinedGlyphs, self.handleText(arrItem, state));
	              } else if (typeof arrItem === "number") {
	                combinedGlyphs.push(arrItem);
	              }
	            }

	            args[0] = combinedGlyphs;
	            fn = _util.OPS.showText;
	            break;

	          case _util.OPS.nextLineShowText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            operatorList.addOp(_util.OPS.nextLine);
	            args[0] = self.handleText(args[0], stateManager.state);
	            fn = _util.OPS.showText;
	            break;

	          case _util.OPS.nextLineSetSpacingShowText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            operatorList.addOp(_util.OPS.nextLine);
	            operatorList.addOp(_util.OPS.setWordSpacing, [args.shift()]);
	            operatorList.addOp(_util.OPS.setCharSpacing, [args.shift()]);
	            args[0] = self.handleText(args[0], stateManager.state);
	            fn = _util.OPS.showText;
	            break;

	          case _util.OPS.setTextRenderingMode:
	            stateManager.state.textRenderingMode = args[0];
	            break;

	          case _util.OPS.setFillColorSpace:
	            {
	              const cachedColorSpace = _colorspace.ColorSpace.getCached(args[0], xref, localColorSpaceCache);

	              if (cachedColorSpace) {
	                stateManager.state.fillColorSpace = cachedColorSpace;
	                continue;
	              }

	              next(self.parseColorSpace({
	                cs: args[0],
	                resources,
	                localColorSpaceCache
	              }).then(function (colorSpace) {
	                if (colorSpace) {
	                  stateManager.state.fillColorSpace = colorSpace;
	                }
	              }));
	              return;
	            }

	          case _util.OPS.setStrokeColorSpace:
	            {
	              const cachedColorSpace = _colorspace.ColorSpace.getCached(args[0], xref, localColorSpaceCache);

	              if (cachedColorSpace) {
	                stateManager.state.strokeColorSpace = cachedColorSpace;
	                continue;
	              }

	              next(self.parseColorSpace({
	                cs: args[0],
	                resources,
	                localColorSpaceCache
	              }).then(function (colorSpace) {
	                if (colorSpace) {
	                  stateManager.state.strokeColorSpace = colorSpace;
	                }
	              }));
	              return;
	            }

	          case _util.OPS.setFillColor:
	            cs = stateManager.state.fillColorSpace;
	            args = cs.getRgb(args, 0);
	            fn = _util.OPS.setFillRGBColor;
	            break;

	          case _util.OPS.setStrokeColor:
	            cs = stateManager.state.strokeColorSpace;
	            args = cs.getRgb(args, 0);
	            fn = _util.OPS.setStrokeRGBColor;
	            break;

	          case _util.OPS.setFillGray:
	            stateManager.state.fillColorSpace = _colorspace.ColorSpace.singletons.gray;
	            args = _colorspace.ColorSpace.singletons.gray.getRgb(args, 0);
	            fn = _util.OPS.setFillRGBColor;
	            break;

	          case _util.OPS.setStrokeGray:
	            stateManager.state.strokeColorSpace = _colorspace.ColorSpace.singletons.gray;
	            args = _colorspace.ColorSpace.singletons.gray.getRgb(args, 0);
	            fn = _util.OPS.setStrokeRGBColor;
	            break;

	          case _util.OPS.setFillCMYKColor:
	            stateManager.state.fillColorSpace = _colorspace.ColorSpace.singletons.cmyk;
	            args = _colorspace.ColorSpace.singletons.cmyk.getRgb(args, 0);
	            fn = _util.OPS.setFillRGBColor;
	            break;

	          case _util.OPS.setStrokeCMYKColor:
	            stateManager.state.strokeColorSpace = _colorspace.ColorSpace.singletons.cmyk;
	            args = _colorspace.ColorSpace.singletons.cmyk.getRgb(args, 0);
	            fn = _util.OPS.setStrokeRGBColor;
	            break;

	          case _util.OPS.setFillRGBColor:
	            stateManager.state.fillColorSpace = _colorspace.ColorSpace.singletons.rgb;
	            args = _colorspace.ColorSpace.singletons.rgb.getRgb(args, 0);
	            break;

	          case _util.OPS.setStrokeRGBColor:
	            stateManager.state.strokeColorSpace = _colorspace.ColorSpace.singletons.rgb;
	            args = _colorspace.ColorSpace.singletons.rgb.getRgb(args, 0);
	            break;

	          case _util.OPS.setFillColorN:
	            cs = stateManager.state.fillColorSpace;

	            if (cs.name === "Pattern") {
	              next(self.handleColorN(operatorList, _util.OPS.setFillColorN, args, cs, patterns, resources, task, localColorSpaceCache, localTilingPatternCache, localShadingPatternCache));
	              return;
	            }

	            args = cs.getRgb(args, 0);
	            fn = _util.OPS.setFillRGBColor;
	            break;

	          case _util.OPS.setStrokeColorN:
	            cs = stateManager.state.strokeColorSpace;

	            if (cs.name === "Pattern") {
	              next(self.handleColorN(operatorList, _util.OPS.setStrokeColorN, args, cs, patterns, resources, task, localColorSpaceCache, localTilingPatternCache, localShadingPatternCache));
	              return;
	            }

	            args = cs.getRgb(args, 0);
	            fn = _util.OPS.setStrokeRGBColor;
	            break;

	          case _util.OPS.shadingFill:
	            var shadingRes = resources.get("Shading");

	            if (!shadingRes) {
	              throw new _util.FormatError("No shading resource found");
	            }

	            var shading = shadingRes.get(args[0].name);

	            if (!shading) {
	              throw new _util.FormatError("No shading object found");
	            }

	            const patternId = self.parseShading({
	              shading,
	              resources,
	              localColorSpaceCache,
	              localShadingPatternCache
	            });
	            args = [patternId];
	            fn = _util.OPS.shadingFill;
	            break;

	          case _util.OPS.setGState:
	            isValidName = args[0] instanceof _primitives.Name;
	            name = args[0].name;

	            if (isValidName) {
	              const localGStateObj = localGStateCache.getByName(name);

	              if (localGStateObj) {
	                if (localGStateObj.length > 0) {
	                  operatorList.addOp(_util.OPS.setGState, [localGStateObj]);
	                }

	                args = null;
	                continue;
	              }
	            }

	            next(new Promise(function (resolveGState, rejectGState) {
	              if (!isValidName) {
	                throw new _util.FormatError("GState must be referred to by name.");
	              }

	              const extGState = resources.get("ExtGState");

	              if (!(extGState instanceof _primitives.Dict)) {
	                throw new _util.FormatError("ExtGState should be a dictionary.");
	              }

	              const gState = extGState.get(name);

	              if (!(gState instanceof _primitives.Dict)) {
	                throw new _util.FormatError("GState should be a dictionary.");
	              }

	              self.setGState({
	                resources,
	                gState,
	                operatorList,
	                cacheKey: name,
	                task,
	                stateManager,
	                localGStateCache,
	                localColorSpaceCache
	              }).then(resolveGState, rejectGState);
	            }).catch(function (reason) {
	              if (reason instanceof _util.AbortException) {
	                return;
	              }

	              if (self.options.ignoreErrors) {
	                self.handler.send("UnsupportedFeature", {
	                  featureId: _util.UNSUPPORTED_FEATURES.errorExtGState
	                });
	                (0, _util.warn)(`getOperatorList - ignoring ExtGState: "${reason}".`);
	                return;
	              }

	              throw reason;
	            }));
	            return;

	          case _util.OPS.moveTo:
	          case _util.OPS.lineTo:
	          case _util.OPS.curveTo:
	          case _util.OPS.curveTo2:
	          case _util.OPS.curveTo3:
	          case _util.OPS.closePath:
	          case _util.OPS.rectangle:
	            self.buildPath(operatorList, fn, args, parsingText);
	            continue;

	          case _util.OPS.markPoint:
	          case _util.OPS.markPointProps:
	          case _util.OPS.beginCompat:
	          case _util.OPS.endCompat:
	            continue;

	          case _util.OPS.beginMarkedContentProps:
	            if (!(args[0] instanceof _primitives.Name)) {
	              (0, _util.warn)(`Expected name for beginMarkedContentProps arg0=${args[0]}`);
	              continue;
	            }

	            if (args[0].name === "OC") {
	              next(self.parseMarkedContentProps(args[1], resources).then(data => {
	                operatorList.addOp(_util.OPS.beginMarkedContentProps, ["OC", data]);
	              }).catch(reason => {
	                if (reason instanceof _util.AbortException) {
	                  return;
	                }

	                if (self.options.ignoreErrors) {
	                  self.handler.send("UnsupportedFeature", {
	                    featureId: _util.UNSUPPORTED_FEATURES.errorMarkedContent
	                  });
	                  (0, _util.warn)(`getOperatorList - ignoring beginMarkedContentProps: "${reason}".`);
	                  return;
	                }

	                throw reason;
	              }));
	              return;
	            }

	            args = [args[0].name, args[1] instanceof _primitives.Dict ? args[1].get("MCID") : null];
	            break;

	          case _util.OPS.beginMarkedContent:
	          case _util.OPS.endMarkedContent:
	          default:
	            if (args !== null) {
	              for (i = 0, ii = args.length; i < ii; i++) {
	                if (args[i] instanceof _primitives.Dict) {
	                  break;
	                }
	              }

	              if (i < ii) {
	                (0, _util.warn)("getOperatorList - ignoring operator: " + fn);
	                continue;
	              }
	            }

	        }

	        operatorList.addOp(fn, args);
	      }

	      if (stop) {
	        next(deferred);
	        return;
	      }

	      closePendingRestoreOPS();
	      resolve();
	    }).catch(reason => {
	      if (reason instanceof _util.AbortException) {
	        return;
	      }

	      if (this.options.ignoreErrors) {
	        this.handler.send("UnsupportedFeature", {
	          featureId: _util.UNSUPPORTED_FEATURES.errorOperatorList
	        });
	        (0, _util.warn)(`getOperatorList - ignoring errors during "${task.name}" ` + `task: "${reason}".`);
	        closePendingRestoreOPS();
	        return;
	      }

	      throw reason;
	    });
	  }

	  getTextContent({
	    stream,
	    task,
	    resources,
	    stateManager = null,
	    combineTextItems = false,
	    includeMarkedContent = false,
	    sink,
	    seenStyles = new Set(),
	    viewBox
	  }) {
	    resources = resources || _primitives.Dict.empty;
	    stateManager = stateManager || new StateManager(new TextState());
	    const NormalizedUnicodes = (0, _unicode.getNormalizedUnicodes)();
	    const textContent = {
	      items: [],
	      styles: Object.create(null)
	    };
	    const textContentItem = {
	      initialized: false,
	      str: [],
	      totalWidth: 0,
	      totalHeight: 0,
	      width: 0,
	      height: 0,
	      vertical: false,
	      prevTransform: null,
	      textAdvanceScale: 0,
	      spaceInFlowMin: 0,
	      spaceInFlowMax: 0,
	      trackingSpaceMin: Infinity,
	      negativeSpaceMax: -Infinity,
	      notASpace: -Infinity,
	      transform: null,
	      fontName: null,
	      hasEOL: false
	    };
	    const twoLastChars = [" ", " "];
	    let twoLastCharsPos = 0;

	    function saveLastChar(char) {
	      const nextPos = (twoLastCharsPos + 1) % 2;
	      const ret = twoLastChars[twoLastCharsPos] !== " " && twoLastChars[nextPos] === " ";
	      twoLastChars[twoLastCharsPos] = char;
	      twoLastCharsPos = nextPos;
	      return ret;
	    }

	    function resetLastChars() {
	      twoLastChars[0] = twoLastChars[1] = " ";
	      twoLastCharsPos = 0;
	    }

	    const TRACKING_SPACE_FACTOR = 0.1;
	    const NOT_A_SPACE_FACTOR = 0.03;
	    const NEGATIVE_SPACE_FACTOR = -0.2;
	    const SPACE_IN_FLOW_MIN_FACTOR = 0.1;
	    const SPACE_IN_FLOW_MAX_FACTOR = 0.6;
	    const self = this;
	    const xref = this.xref;
	    const showSpacedTextBuffer = [];
	    let xobjs = null;
	    const emptyXObjectCache = new _image_utils.LocalImageCache();
	    const emptyGStateCache = new _image_utils.LocalGStateCache();
	    const preprocessor = new EvaluatorPreprocessor(stream, xref, stateManager);
	    let textState;

	    function getCurrentTextTransform() {
	      const font = textState.font;
	      const tsm = [textState.fontSize * textState.textHScale, 0, 0, textState.fontSize, 0, textState.textRise];

	      if (font.isType3Font && (textState.fontSize <= 1 || font.isCharBBox) && !(0, _util.isArrayEqual)(textState.fontMatrix, _util.FONT_IDENTITY_MATRIX)) {
	        const glyphHeight = font.bbox[3] - font.bbox[1];

	        if (glyphHeight > 0) {
	          tsm[3] *= glyphHeight * textState.fontMatrix[3];
	        }
	      }

	      return _util.Util.transform(textState.ctm, _util.Util.transform(textState.textMatrix, tsm));
	    }

	    function ensureTextContentItem() {
	      if (textContentItem.initialized) {
	        return textContentItem;
	      }

	      const font = textState.font,
	            loadedName = font.loadedName;

	      if (!seenStyles.has(loadedName)) {
	        seenStyles.add(loadedName);
	        textContent.styles[loadedName] = {
	          fontFamily: font.fallbackName,
	          ascent: font.ascent,
	          descent: font.descent,
	          vertical: font.vertical
	        };
	      }

	      textContentItem.fontName = loadedName;
	      const trm = textContentItem.transform = getCurrentTextTransform();

	      if (!font.vertical) {
	        textContentItem.width = textContentItem.totalWidth = 0;
	        textContentItem.height = textContentItem.totalHeight = Math.hypot(trm[2], trm[3]);
	        textContentItem.vertical = false;
	      } else {
	        textContentItem.width = textContentItem.totalWidth = Math.hypot(trm[0], trm[1]);
	        textContentItem.height = textContentItem.totalHeight = 0;
	        textContentItem.vertical = true;
	      }

	      const scaleLineX = Math.hypot(textState.textLineMatrix[0], textState.textLineMatrix[1]);
	      const scaleCtmX = Math.hypot(textState.ctm[0], textState.ctm[1]);
	      textContentItem.textAdvanceScale = scaleCtmX * scaleLineX;
	      textContentItem.trackingSpaceMin = textState.fontSize * TRACKING_SPACE_FACTOR;
	      textContentItem.notASpace = textState.fontSize * NOT_A_SPACE_FACTOR;
	      textContentItem.negativeSpaceMax = textState.fontSize * NEGATIVE_SPACE_FACTOR;
	      textContentItem.spaceInFlowMin = textState.fontSize * SPACE_IN_FLOW_MIN_FACTOR;
	      textContentItem.spaceInFlowMax = textState.fontSize * SPACE_IN_FLOW_MAX_FACTOR;
	      textContentItem.hasEOL = false;
	      textContentItem.initialized = true;
	      return textContentItem;
	    }

	    function updateAdvanceScale() {
	      if (!textContentItem.initialized) {
	        return;
	      }

	      const scaleLineX = Math.hypot(textState.textLineMatrix[0], textState.textLineMatrix[1]);
	      const scaleCtmX = Math.hypot(textState.ctm[0], textState.ctm[1]);
	      const scaleFactor = scaleCtmX * scaleLineX;

	      if (scaleFactor === textContentItem.textAdvanceScale) {
	        return;
	      }

	      if (!textContentItem.vertical) {
	        textContentItem.totalWidth += textContentItem.width * textContentItem.textAdvanceScale;
	        textContentItem.width = 0;
	      } else {
	        textContentItem.totalHeight += textContentItem.height * textContentItem.textAdvanceScale;
	        textContentItem.height = 0;
	      }

	      textContentItem.textAdvanceScale = scaleFactor;
	    }

	    function runBidiTransform(textChunk) {
	      const text = textChunk.str.join("");
	      const bidiResult = (0, _bidi.bidi)(text, -1, textChunk.vertical);
	      return {
	        str: bidiResult.str,
	        dir: bidiResult.dir,
	        width: Math.abs(textChunk.totalWidth),
	        height: Math.abs(textChunk.totalHeight),
	        transform: textChunk.transform,
	        fontName: textChunk.fontName,
	        hasEOL: textChunk.hasEOL
	      };
	    }

	    function handleSetFont(fontName, fontRef) {
	      return self.loadFont(fontName, fontRef, resources).then(function (translated) {
	        if (!translated.font.isType3Font) {
	          return translated;
	        }

	        return translated.loadType3Data(self, resources, task).catch(function () {}).then(function () {
	          return translated;
	        });
	      }).then(function (translated) {
	        textState.font = translated.font;
	        textState.fontMatrix = translated.font.fontMatrix || _util.FONT_IDENTITY_MATRIX;
	      });
	    }

	    function applyInverseRotation(x, y, matrix) {
	      const scale = Math.hypot(matrix[0], matrix[1]);
	      return [(matrix[0] * x + matrix[1] * y) / scale, (matrix[2] * x + matrix[3] * y) / scale];
	    }

	    function compareWithLastPosition() {
	      const currentTransform = getCurrentTextTransform();
	      let posX = currentTransform[4];
	      let posY = currentTransform[5];
	      const shiftedX = posX - viewBox[0];
	      const shiftedY = posY - viewBox[1];

	      if (shiftedX < 0 || shiftedX > viewBox[2] || shiftedY < 0 || shiftedY > viewBox[3]) {
	        return false;
	      }

	      if (!combineTextItems || !textState.font || !textContentItem.prevTransform) {
	        return true;
	      }

	      let lastPosX = textContentItem.prevTransform[4];
	      let lastPosY = textContentItem.prevTransform[5];

	      if (lastPosX === posX && lastPosY === posY) {
	        return true;
	      }

	      let rotate = -1;

	      if (currentTransform[0] && currentTransform[1] === 0 && currentTransform[2] === 0) {
	        rotate = currentTransform[0] > 0 ? 0 : 180;
	      } else if (currentTransform[1] && currentTransform[0] === 0 && currentTransform[3] === 0) {
	        rotate = currentTransform[1] > 0 ? 90 : 270;
	      }

	      switch (rotate) {
	        case 0:
	          break;

	        case 90:
	          [posX, posY] = [posY, posX];
	          [lastPosX, lastPosY] = [lastPosY, lastPosX];
	          break;

	        case 180:
	          [posX, posY, lastPosX, lastPosY] = [-posX, -posY, -lastPosX, -lastPosY];
	          break;

	        case 270:
	          [posX, posY] = [-posY, -posX];
	          [lastPosX, lastPosY] = [-lastPosY, -lastPosX];
	          break;

	        default:
	          [posX, posY] = applyInverseRotation(posX, posY, currentTransform);
	          [lastPosX, lastPosY] = applyInverseRotation(lastPosX, lastPosY, textContentItem.prevTransform);
	      }

	      if (textState.font.vertical) {
	        const advanceY = (lastPosY - posY) / textContentItem.textAdvanceScale;
	        const advanceX = posX - lastPosX;
	        const textOrientation = Math.sign(textContentItem.height);

	        if (advanceY < textOrientation * textContentItem.negativeSpaceMax) {
	          if (Math.abs(advanceX) > 0.5 * textContentItem.width) {
	            appendEOL();
	            return true;
	          }

	          resetLastChars();
	          flushTextContentItem();
	          return true;
	        }

	        if (Math.abs(advanceX) > textContentItem.width) {
	          appendEOL();
	          return true;
	        }

	        if (advanceY <= textOrientation * textContentItem.notASpace) {
	          resetLastChars();
	        }

	        if (advanceY <= textOrientation * textContentItem.trackingSpaceMin) {
	          textContentItem.height += advanceY;
	        } else if (!addFakeSpaces(advanceY, textContentItem.prevTransform, textOrientation)) {
	          if (textContentItem.str.length === 0) {
	            resetLastChars();
	            textContent.items.push({
	              str: " ",
	              dir: "ltr",
	              width: 0,
	              height: Math.abs(advanceY),
	              transform: textContentItem.prevTransform,
	              fontName: textContentItem.fontName,
	              hasEOL: false
	            });
	          } else {
	            textContentItem.height += advanceY;
	          }
	        }

	        return true;
	      }

	      const advanceX = (posX - lastPosX) / textContentItem.textAdvanceScale;
	      const advanceY = posY - lastPosY;
	      const textOrientation = Math.sign(textContentItem.width);

	      if (advanceX < textOrientation * textContentItem.negativeSpaceMax) {
	        if (Math.abs(advanceY) > 0.5 * textContentItem.height) {
	          appendEOL();
	          return true;
	        }

	        resetLastChars();
	        flushTextContentItem();
	        return true;
	      }

	      if (Math.abs(advanceY) > textContentItem.height) {
	        appendEOL();
	        return true;
	      }

	      if (advanceX <= textOrientation * textContentItem.notASpace) {
	        resetLastChars();
	      }

	      if (advanceX <= textOrientation * textContentItem.trackingSpaceMin) {
	        textContentItem.width += advanceX;
	      } else if (!addFakeSpaces(advanceX, textContentItem.prevTransform, textOrientation)) {
	        if (textContentItem.str.length === 0) {
	          resetLastChars();
	          textContent.items.push({
	            str: " ",
	            dir: "ltr",
	            width: Math.abs(advanceX),
	            height: 0,
	            transform: textContentItem.prevTransform,
	            fontName: textContentItem.fontName,
	            hasEOL: false
	          });
	        } else {
	          textContentItem.width += advanceX;
	        }
	      }

	      return true;
	    }

	    function buildTextContentItem({
	      chars,
	      extraSpacing
	    }) {
	      const font = textState.font;

	      if (!chars) {
	        const charSpacing = textState.charSpacing + extraSpacing;

	        if (charSpacing) {
	          if (!font.vertical) {
	            textState.translateTextMatrix(charSpacing * textState.textHScale, 0);
	          } else {
	            textState.translateTextMatrix(0, -charSpacing);
	          }
	        }

	        return;
	      }

	      const glyphs = font.charsToGlyphs(chars);
	      const scale = textState.fontMatrix[0] * textState.fontSize;

	      for (let i = 0, ii = glyphs.length; i < ii; i++) {
	        const glyph = glyphs[i];

	        if (glyph.isInvisibleFormatMark) {
	          continue;
	        }

	        let charSpacing = textState.charSpacing + (i + 1 === ii ? extraSpacing : 0);
	        let glyphWidth = glyph.width;

	        if (font.vertical) {
	          glyphWidth = glyph.vmetric ? glyph.vmetric[0] : -glyphWidth;
	        }

	        let scaledDim = glyphWidth * scale;

	        if (glyph.isWhitespace) {
	          if (!font.vertical) {
	            charSpacing += scaledDim + textState.wordSpacing;
	            textState.translateTextMatrix(charSpacing * textState.textHScale, 0);
	          } else {
	            charSpacing += -scaledDim + textState.wordSpacing;
	            textState.translateTextMatrix(0, -charSpacing);
	          }

	          saveLastChar(" ");
	          continue;
	        }

	        if (!compareWithLastPosition()) {
	          continue;
	        }

	        const textChunk = ensureTextContentItem();

	        if (glyph.isZeroWidthDiacritic) {
	          scaledDim = 0;
	        }

	        if (!font.vertical) {
	          scaledDim *= textState.textHScale;
	          textState.translateTextMatrix(scaledDim, 0);
	          textChunk.width += scaledDim;
	        } else {
	          textState.translateTextMatrix(0, scaledDim);
	          scaledDim = Math.abs(scaledDim);
	          textChunk.height += scaledDim;
	        }

	        if (scaledDim) {
	          textChunk.prevTransform = getCurrentTextTransform();
	        }

	        let glyphUnicode = glyph.unicode;
	        glyphUnicode = NormalizedUnicodes[glyphUnicode] || glyphUnicode;
	        glyphUnicode = (0, _unicode.reverseIfRtl)(glyphUnicode);

	        if (saveLastChar(glyphUnicode)) {
	          textChunk.str.push(" ");
	        }

	        textChunk.str.push(glyphUnicode);

	        if (charSpacing) {
	          if (!font.vertical) {
	            textState.translateTextMatrix(charSpacing * textState.textHScale, 0);
	          } else {
	            textState.translateTextMatrix(0, -charSpacing);
	          }
	        }
	      }
	    }

	    function appendEOL() {
	      resetLastChars();

	      if (textContentItem.initialized) {
	        textContentItem.hasEOL = true;
	        flushTextContentItem();
	      } else {
	        textContent.items.push({
	          str: "",
	          dir: "ltr",
	          width: 0,
	          height: 0,
	          transform: getCurrentTextTransform(),
	          fontName: textState.font.loadedName,
	          hasEOL: true
	        });
	      }
	    }

	    function addFakeSpaces(width, transf, textOrientation) {
	      if (textOrientation * textContentItem.spaceInFlowMin <= width && width <= textOrientation * textContentItem.spaceInFlowMax) {
	        if (textContentItem.initialized) {
	          resetLastChars();
	          textContentItem.str.push(" ");
	        }

	        return false;
	      }

	      const fontName = textContentItem.fontName;
	      let height = 0;

	      if (textContentItem.vertical) {
	        height = width;
	        width = 0;
	      }

	      flushTextContentItem();
	      resetLastChars();
	      textContent.items.push({
	        str: " ",
	        dir: "ltr",
	        width: Math.abs(width),
	        height: Math.abs(height),
	        transform: transf || getCurrentTextTransform(),
	        fontName,
	        hasEOL: false
	      });
	      return true;
	    }

	    function flushTextContentItem() {
	      if (!textContentItem.initialized || !textContentItem.str) {
	        return;
	      }

	      if (!textContentItem.vertical) {
	        textContentItem.totalWidth += textContentItem.width * textContentItem.textAdvanceScale;
	      } else {
	        textContentItem.totalHeight += textContentItem.height * textContentItem.textAdvanceScale;
	      }

	      textContent.items.push(runBidiTransform(textContentItem));
	      textContentItem.initialized = false;
	      textContentItem.str.length = 0;
	    }

	    function enqueueChunk(batch = false) {
	      const length = textContent.items.length;

	      if (length === 0) {
	        return;
	      }

	      if (batch && length < TEXT_CHUNK_BATCH_SIZE) {
	        return;
	      }

	      sink.enqueue(textContent, length);
	      textContent.items = [];
	      textContent.styles = Object.create(null);
	    }

	    const timeSlotManager = new TimeSlotManager();
	    return new Promise(function promiseBody(resolve, reject) {
	      const next = function (promise) {
	        enqueueChunk(true);
	        Promise.all([promise, sink.ready]).then(function () {
	          try {
	            promiseBody(resolve, reject);
	          } catch (ex) {
	            reject(ex);
	          }
	        }, reject);
	      };

	      task.ensureNotTerminated();
	      timeSlotManager.reset();
	      const operation = {};
	      let stop,
	          args = [];

	      while (!(stop = timeSlotManager.check())) {
	        args.length = 0;
	        operation.args = args;

	        if (!preprocessor.read(operation)) {
	          break;
	        }

	        textState = stateManager.state;
	        const fn = operation.fn;
	        args = operation.args;

	        switch (fn | 0) {
	          case _util.OPS.setFont:
	            var fontNameArg = args[0].name,
	                fontSizeArg = args[1];

	            if (textState.font && fontNameArg === textState.fontName && fontSizeArg === textState.fontSize) {
	              break;
	            }

	            flushTextContentItem();
	            textState.fontName = fontNameArg;
	            textState.fontSize = fontSizeArg;
	            next(handleSetFont(fontNameArg, null));
	            return;

	          case _util.OPS.setTextRise:
	            textState.textRise = args[0];
	            break;

	          case _util.OPS.setHScale:
	            textState.textHScale = args[0] / 100;
	            break;

	          case _util.OPS.setLeading:
	            textState.leading = args[0];
	            break;

	          case _util.OPS.moveText:
	            textState.translateTextLineMatrix(args[0], args[1]);
	            textState.textMatrix = textState.textLineMatrix.slice();
	            break;

	          case _util.OPS.setLeadingMoveText:
	            textState.leading = -args[1];
	            textState.translateTextLineMatrix(args[0], args[1]);
	            textState.textMatrix = textState.textLineMatrix.slice();
	            break;

	          case _util.OPS.nextLine:
	            textState.carriageReturn();
	            break;

	          case _util.OPS.setTextMatrix:
	            textState.setTextMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
	            textState.setTextLineMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
	            updateAdvanceScale();
	            break;

	          case _util.OPS.setCharSpacing:
	            textState.charSpacing = args[0];
	            break;

	          case _util.OPS.setWordSpacing:
	            textState.wordSpacing = args[0];
	            break;

	          case _util.OPS.beginText:
	            textState.textMatrix = _util.IDENTITY_MATRIX.slice();
	            textState.textLineMatrix = _util.IDENTITY_MATRIX.slice();
	            break;

	          case _util.OPS.showSpacedText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            const spaceFactor = (textState.font.vertical ? 1 : -1) * textState.fontSize / 1000;
	            const elements = args[0];

	            for (let i = 0, ii = elements.length; i < ii - 1; i++) {
	              const item = elements[i];

	              if (typeof item === "string") {
	                showSpacedTextBuffer.push(item);
	              } else if (typeof item === "number" && item !== 0) {
	                const str = showSpacedTextBuffer.join("");
	                showSpacedTextBuffer.length = 0;
	                buildTextContentItem({
	                  chars: str,
	                  extraSpacing: item * spaceFactor
	                });
	              }
	            }

	            const item = elements.at(-1);

	            if (typeof item === "string") {
	              showSpacedTextBuffer.push(item);
	            }

	            if (showSpacedTextBuffer.length > 0) {
	              const str = showSpacedTextBuffer.join("");
	              showSpacedTextBuffer.length = 0;
	              buildTextContentItem({
	                chars: str,
	                extraSpacing: 0
	              });
	            }

	            break;

	          case _util.OPS.showText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            buildTextContentItem({
	              chars: args[0],
	              extraSpacing: 0
	            });
	            break;

	          case _util.OPS.nextLineShowText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            textState.carriageReturn();
	            buildTextContentItem({
	              chars: args[0],
	              extraSpacing: 0
	            });
	            break;

	          case _util.OPS.nextLineSetSpacingShowText:
	            if (!stateManager.state.font) {
	              self.ensureStateFont(stateManager.state);
	              continue;
	            }

	            textState.wordSpacing = args[0];
	            textState.charSpacing = args[1];
	            textState.carriageReturn();
	            buildTextContentItem({
	              chars: args[2],
	              extraSpacing: 0
	            });
	            break;

	          case _util.OPS.paintXObject:
	            flushTextContentItem();

	            if (!xobjs) {
	              xobjs = resources.get("XObject") || _primitives.Dict.empty;
	            }

	            var isValidName = args[0] instanceof _primitives.Name;
	            var name = args[0].name;

	            if (isValidName && emptyXObjectCache.getByName(name)) {
	              break;
	            }

	            next(new Promise(function (resolveXObject, rejectXObject) {
	              if (!isValidName) {
	                throw new _util.FormatError("XObject must be referred to by name.");
	              }

	              let xobj = xobjs.getRaw(name);

	              if (xobj instanceof _primitives.Ref) {
	                if (emptyXObjectCache.getByRef(xobj)) {
	                  resolveXObject();
	                  return;
	                }

	                const globalImage = self.globalImageCache.getData(xobj, self.pageIndex);

	                if (globalImage) {
	                  resolveXObject();
	                  return;
	                }

	                xobj = xref.fetch(xobj);
	              }

	              if (!(xobj instanceof _base_stream.BaseStream)) {
	                throw new _util.FormatError("XObject should be a stream");
	              }

	              const type = xobj.dict.get("Subtype");

	              if (!(type instanceof _primitives.Name)) {
	                throw new _util.FormatError("XObject should have a Name subtype");
	              }

	              if (type.name !== "Form") {
	                emptyXObjectCache.set(name, xobj.dict.objId, true);
	                resolveXObject();
	                return;
	              }

	              const currentState = stateManager.state.clone();
	              const xObjStateManager = new StateManager(currentState);
	              const matrix = xobj.dict.getArray("Matrix");

	              if (Array.isArray(matrix) && matrix.length === 6) {
	                xObjStateManager.transform(matrix);
	              }

	              enqueueChunk();
	              const sinkWrapper = {
	                enqueueInvoked: false,

	                enqueue(chunk, size) {
	                  this.enqueueInvoked = true;
	                  sink.enqueue(chunk, size);
	                },

	                get desiredSize() {
	                  return sink.desiredSize;
	                },

	                get ready() {
	                  return sink.ready;
	                }

	              };
	              self.getTextContent({
	                stream: xobj,
	                task,
	                resources: xobj.dict.get("Resources") || resources,
	                stateManager: xObjStateManager,
	                combineTextItems,
	                includeMarkedContent,
	                sink: sinkWrapper,
	                seenStyles,
	                viewBox
	              }).then(function () {
	                if (!sinkWrapper.enqueueInvoked) {
	                  emptyXObjectCache.set(name, xobj.dict.objId, true);
	                }

	                resolveXObject();
	              }, rejectXObject);
	            }).catch(function (reason) {
	              if (reason instanceof _util.AbortException) {
	                return;
	              }

	              if (self.options.ignoreErrors) {
	                (0, _util.warn)(`getTextContent - ignoring XObject: "${reason}".`);
	                return;
	              }

	              throw reason;
	            }));
	            return;

	          case _util.OPS.setGState:
	            isValidName = args[0] instanceof _primitives.Name;
	            name = args[0].name;

	            if (isValidName && emptyGStateCache.getByName(name)) {
	              break;
	            }

	            next(new Promise(function (resolveGState, rejectGState) {
	              if (!isValidName) {
	                throw new _util.FormatError("GState must be referred to by name.");
	              }

	              const extGState = resources.get("ExtGState");

	              if (!(extGState instanceof _primitives.Dict)) {
	                throw new _util.FormatError("ExtGState should be a dictionary.");
	              }

	              const gState = extGState.get(name);

	              if (!(gState instanceof _primitives.Dict)) {
	                throw new _util.FormatError("GState should be a dictionary.");
	              }

	              const gStateFont = gState.get("Font");

	              if (!gStateFont) {
	                emptyGStateCache.set(name, gState.objId, true);
	                resolveGState();
	                return;
	              }

	              flushTextContentItem();
	              textState.fontName = null;
	              textState.fontSize = gStateFont[1];
	              handleSetFont(null, gStateFont[0]).then(resolveGState, rejectGState);
	            }).catch(function (reason) {
	              if (reason instanceof _util.AbortException) {
	                return;
	              }

	              if (self.options.ignoreErrors) {
	                (0, _util.warn)(`getTextContent - ignoring ExtGState: "${reason}".`);
	                return;
	              }

	              throw reason;
	            }));
	            return;

	          case _util.OPS.beginMarkedContent:
	            flushTextContentItem();

	            if (includeMarkedContent) {
	              textContent.items.push({
	                type: "beginMarkedContent",
	                tag: args[0] instanceof _primitives.Name ? args[0].name : null
	              });
	            }

	            break;

	          case _util.OPS.beginMarkedContentProps:
	            flushTextContentItem();

	            if (includeMarkedContent) {
	              let mcid = null;

	              if (args[1] instanceof _primitives.Dict) {
	                mcid = args[1].get("MCID");
	              }

	              textContent.items.push({
	                type: "beginMarkedContentProps",
	                id: Number.isInteger(mcid) ? `${self.idFactory.getPageObjId()}_mcid${mcid}` : null,
	                tag: args[0] instanceof _primitives.Name ? args[0].name : null
	              });
	            }

	            break;

	          case _util.OPS.endMarkedContent:
	            flushTextContentItem();

	            if (includeMarkedContent) {
	              textContent.items.push({
	                type: "endMarkedContent"
	              });
	            }

	            break;
	        }

	        if (textContent.items.length >= sink.desiredSize) {
	          stop = true;
	          break;
	        }
	      }

	      if (stop) {
	        next(deferred);
	        return;
	      }

	      flushTextContentItem();
	      enqueueChunk();
	      resolve();
	    }).catch(reason => {
	      if (reason instanceof _util.AbortException) {
	        return;
	      }

	      if (this.options.ignoreErrors) {
	        (0, _util.warn)(`getTextContent - ignoring errors during "${task.name}" ` + `task: "${reason}".`);
	        flushTextContentItem();
	        enqueueChunk();
	        return;
	      }

	      throw reason;
	    });
	  }

	  extractDataStructures(dict, baseDict, properties) {
	    const xref = this.xref;
	    let cidToGidBytes;
	    const toUnicodePromise = this.readToUnicode(properties.toUnicode || dict.get("ToUnicode") || baseDict.get("ToUnicode"));

	    if (properties.composite) {
	      const cidSystemInfo = dict.get("CIDSystemInfo");

	      if (cidSystemInfo instanceof _primitives.Dict) {
	        properties.cidSystemInfo = {
	          registry: (0, _util.stringToPDFString)(cidSystemInfo.get("Registry")),
	          ordering: (0, _util.stringToPDFString)(cidSystemInfo.get("Ordering")),
	          supplement: cidSystemInfo.get("Supplement")
	        };
	      }

	      try {
	        const cidToGidMap = dict.get("CIDToGIDMap");

	        if (cidToGidMap instanceof _base_stream.BaseStream) {
	          cidToGidBytes = cidToGidMap.getBytes();
	        }
	      } catch (ex) {
	        if (!this.options.ignoreErrors) {
	          throw ex;
	        }

	        (0, _util.warn)(`extractDataStructures - ignoring CIDToGIDMap data: "${ex}".`);
	      }
	    }

	    const differences = [];
	    let baseEncodingName = null;
	    let encoding;

	    if (dict.has("Encoding")) {
	      encoding = dict.get("Encoding");

	      if (encoding instanceof _primitives.Dict) {
	        baseEncodingName = encoding.get("BaseEncoding");
	        baseEncodingName = baseEncodingName instanceof _primitives.Name ? baseEncodingName.name : null;

	        if (encoding.has("Differences")) {
	          const diffEncoding = encoding.get("Differences");
	          let index = 0;

	          for (let j = 0, jj = diffEncoding.length; j < jj; j++) {
	            const data = xref.fetchIfRef(diffEncoding[j]);

	            if (typeof data === "number") {
	              index = data;
	            } else if (data instanceof _primitives.Name) {
	              differences[index++] = data.name;
	            } else {
	              throw new _util.FormatError(`Invalid entry in 'Differences' array: ${data}`);
	            }
	          }
	        }
	      } else if (encoding instanceof _primitives.Name) {
	        baseEncodingName = encoding.name;
	      } else {
	        const msg = "Encoding is not a Name nor a Dict";

	        if (!this.options.ignoreErrors) {
	          throw new _util.FormatError(msg);
	        }

	        (0, _util.warn)(msg);
	      }

	      if (baseEncodingName !== "MacRomanEncoding" && baseEncodingName !== "MacExpertEncoding" && baseEncodingName !== "WinAnsiEncoding") {
	        baseEncodingName = null;
	      }
	    }

	    if (baseEncodingName) {
	      properties.defaultEncoding = (0, _encodings.getEncoding)(baseEncodingName);
	    } else {
	      const isSymbolicFont = !!(properties.flags & _fonts_utils.FontFlags.Symbolic);
	      const isNonsymbolicFont = !!(properties.flags & _fonts_utils.FontFlags.Nonsymbolic);
	      encoding = _encodings.StandardEncoding;

	      if (properties.type === "TrueType" && !isNonsymbolicFont) {
	        encoding = _encodings.WinAnsiEncoding;
	      }

	      if (isSymbolicFont) {
	        encoding = _encodings.MacRomanEncoding;

	        if (!properties.file || properties.isInternalFont) {
	          if (/Symbol/i.test(properties.name)) {
	            encoding = _encodings.SymbolSetEncoding;
	          } else if (/Dingbats|Wingdings/i.test(properties.name)) {
	            encoding = _encodings.ZapfDingbatsEncoding;
	          }
	        }
	      }

	      properties.defaultEncoding = encoding;
	    }

	    properties.differences = differences;
	    properties.baseEncodingName = baseEncodingName;
	    properties.hasEncoding = !!baseEncodingName || differences.length > 0;
	    properties.dict = dict;
	    return toUnicodePromise.then(readToUnicode => {
	      properties.toUnicode = readToUnicode;
	      return this.buildToUnicode(properties);
	    }).then(builtToUnicode => {
	      properties.toUnicode = builtToUnicode;

	      if (cidToGidBytes) {
	        properties.cidToGidMap = this.readCidToGidMap(cidToGidBytes, builtToUnicode);
	      }

	      return properties;
	    });
	  }

	  _simpleFontToUnicode(properties, forceGlyphs = false) {
	    (0, _util.assert)(!properties.composite, "Must be a simple font.");
	    const toUnicode = [];
	    const encoding = properties.defaultEncoding.slice();
	    const baseEncodingName = properties.baseEncodingName;
	    const differences = properties.differences;

	    for (const charcode in differences) {
	      const glyphName = differences[charcode];

	      if (glyphName === ".notdef") {
	        continue;
	      }

	      encoding[charcode] = glyphName;
	    }

	    const glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();

	    for (const charcode in encoding) {
	      let glyphName = encoding[charcode];

	      if (glyphName === "") {
	        continue;
	      } else if (glyphsUnicodeMap[glyphName] === undefined) {
	        let code = 0;

	        switch (glyphName[0]) {
	          case "G":
	            if (glyphName.length === 3) {
	              code = parseInt(glyphName.substring(1), 16);
	            }

	            break;

	          case "g":
	            if (glyphName.length === 5) {
	              code = parseInt(glyphName.substring(1), 16);
	            }

	            break;

	          case "C":
	          case "c":
	            if (glyphName.length >= 3 && glyphName.length <= 4) {
	              const codeStr = glyphName.substring(1);

	              if (forceGlyphs) {
	                code = parseInt(codeStr, 16);
	                break;
	              }

	              code = +codeStr;

	              if (Number.isNaN(code) && Number.isInteger(parseInt(codeStr, 16))) {
	                return this._simpleFontToUnicode(properties, true);
	              }
	            }

	            break;

	          default:
	            const unicode = (0, _unicode.getUnicodeForGlyph)(glyphName, glyphsUnicodeMap);

	            if (unicode !== -1) {
	              code = unicode;
	            }

	        }

	        if (code > 0 && code <= 0x10ffff && Number.isInteger(code)) {
	          if (baseEncodingName && code === +charcode) {
	            const baseEncoding = (0, _encodings.getEncoding)(baseEncodingName);

	            if (baseEncoding && (glyphName = baseEncoding[charcode])) {
	              toUnicode[charcode] = String.fromCharCode(glyphsUnicodeMap[glyphName]);
	              continue;
	            }
	          }

	          toUnicode[charcode] = String.fromCodePoint(code);
	        }

	        continue;
	      }

	      toUnicode[charcode] = String.fromCharCode(glyphsUnicodeMap[glyphName]);
	    }

	    return toUnicode;
	  }

	  async buildToUnicode(properties) {
	    properties.hasIncludedToUnicodeMap = !!properties.toUnicode && properties.toUnicode.length > 0;

	    if (properties.hasIncludedToUnicodeMap) {
	      if (!properties.composite && properties.hasEncoding) {
	        properties.fallbackToUnicode = this._simpleFontToUnicode(properties);
	      }

	      return properties.toUnicode;
	    }

	    if (!properties.composite) {
	      return new _to_unicode_map.ToUnicodeMap(this._simpleFontToUnicode(properties));
	    }

	    if (properties.composite && (properties.cMap.builtInCMap && !(properties.cMap instanceof _cmap.IdentityCMap) || properties.cidSystemInfo.registry === "Adobe" && (properties.cidSystemInfo.ordering === "GB1" || properties.cidSystemInfo.ordering === "CNS1" || properties.cidSystemInfo.ordering === "Japan1" || properties.cidSystemInfo.ordering === "Korea1"))) {
	      const {
	        registry,
	        ordering
	      } = properties.cidSystemInfo;

	      const ucs2CMapName = _primitives.Name.get(`${registry}-${ordering}-UCS2`);

	      const ucs2CMap = await _cmap.CMapFactory.create({
	        encoding: ucs2CMapName,
	        fetchBuiltInCMap: this._fetchBuiltInCMapBound,
	        useCMap: null
	      });
	      const toUnicode = [];
	      properties.cMap.forEach(function (charcode, cid) {
	        if (cid > 0xffff) {
	          throw new _util.FormatError("Max size of CID is 65,535");
	        }

	        const ucs2 = ucs2CMap.lookup(cid);

	        if (ucs2) {
	          toUnicode[charcode] = String.fromCharCode((ucs2.charCodeAt(0) << 8) + ucs2.charCodeAt(1));
	        }
	      });
	      return new _to_unicode_map.ToUnicodeMap(toUnicode);
	    }

	    return new _to_unicode_map.IdentityToUnicodeMap(properties.firstChar, properties.lastChar);
	  }

	  readToUnicode(cmapObj) {
	    if (!cmapObj) {
	      return Promise.resolve(null);
	    }

	    if (cmapObj instanceof _primitives.Name) {
	      return _cmap.CMapFactory.create({
	        encoding: cmapObj,
	        fetchBuiltInCMap: this._fetchBuiltInCMapBound,
	        useCMap: null
	      }).then(function (cmap) {
	        if (cmap instanceof _cmap.IdentityCMap) {
	          return new _to_unicode_map.IdentityToUnicodeMap(0, 0xffff);
	        }

	        return new _to_unicode_map.ToUnicodeMap(cmap.getMap());
	      });
	    } else if (cmapObj instanceof _base_stream.BaseStream) {
	      return _cmap.CMapFactory.create({
	        encoding: cmapObj,
	        fetchBuiltInCMap: this._fetchBuiltInCMapBound,
	        useCMap: null
	      }).then(function (cmap) {
	        if (cmap instanceof _cmap.IdentityCMap) {
	          return new _to_unicode_map.IdentityToUnicodeMap(0, 0xffff);
	        }

	        const map = new Array(cmap.length);
	        cmap.forEach(function (charCode, token) {
	          if (typeof token === "number") {
	            map[charCode] = String.fromCodePoint(token);
	            return;
	          }

	          const str = [];

	          for (let k = 0; k < token.length; k += 2) {
	            const w1 = token.charCodeAt(k) << 8 | token.charCodeAt(k + 1);

	            if ((w1 & 0xf800) !== 0xd800) {
	              str.push(w1);
	              continue;
	            }

	            k += 2;
	            const w2 = token.charCodeAt(k) << 8 | token.charCodeAt(k + 1);
	            str.push(((w1 & 0x3ff) << 10) + (w2 & 0x3ff) + 0x10000);
	          }

	          map[charCode] = String.fromCodePoint(...str);
	        });
	        return new _to_unicode_map.ToUnicodeMap(map);
	      }, reason => {
	        if (reason instanceof _util.AbortException) {
	          return null;
	        }

	        if (this.options.ignoreErrors) {
	          this.handler.send("UnsupportedFeature", {
	            featureId: _util.UNSUPPORTED_FEATURES.errorFontToUnicode
	          });
	          (0, _util.warn)(`readToUnicode - ignoring ToUnicode data: "${reason}".`);
	          return null;
	        }

	        throw reason;
	      });
	    }

	    return Promise.resolve(null);
	  }

	  readCidToGidMap(glyphsData, toUnicode) {
	    const result = [];

	    for (let j = 0, jj = glyphsData.length; j < jj; j++) {
	      const glyphID = glyphsData[j++] << 8 | glyphsData[j];
	      const code = j >> 1;

	      if (glyphID === 0 && !toUnicode.has(code)) {
	        continue;
	      }

	      result[code] = glyphID;
	    }

	    return result;
	  }

	  extractWidths(dict, descriptor, properties) {
	    const xref = this.xref;
	    let glyphsWidths = [];
	    let defaultWidth = 0;
	    const glyphsVMetrics = [];
	    let defaultVMetrics;
	    let i, ii, j, jj, start, code, widths;

	    if (properties.composite) {
	      defaultWidth = dict.has("DW") ? dict.get("DW") : 1000;
	      widths = dict.get("W");

	      if (widths) {
	        for (i = 0, ii = widths.length; i < ii; i++) {
	          start = xref.fetchIfRef(widths[i++]);
	          code = xref.fetchIfRef(widths[i]);

	          if (Array.isArray(code)) {
	            for (j = 0, jj = code.length; j < jj; j++) {
	              glyphsWidths[start++] = xref.fetchIfRef(code[j]);
	            }
	          } else {
	            const width = xref.fetchIfRef(widths[++i]);

	            for (j = start; j <= code; j++) {
	              glyphsWidths[j] = width;
	            }
	          }
	        }
	      }

	      if (properties.vertical) {
	        let vmetrics = dict.getArray("DW2") || [880, -1000];
	        defaultVMetrics = [vmetrics[1], defaultWidth * 0.5, vmetrics[0]];
	        vmetrics = dict.get("W2");

	        if (vmetrics) {
	          for (i = 0, ii = vmetrics.length; i < ii; i++) {
	            start = xref.fetchIfRef(vmetrics[i++]);
	            code = xref.fetchIfRef(vmetrics[i]);

	            if (Array.isArray(code)) {
	              for (j = 0, jj = code.length; j < jj; j++) {
	                glyphsVMetrics[start++] = [xref.fetchIfRef(code[j++]), xref.fetchIfRef(code[j++]), xref.fetchIfRef(code[j])];
	              }
	            } else {
	              const vmetric = [xref.fetchIfRef(vmetrics[++i]), xref.fetchIfRef(vmetrics[++i]), xref.fetchIfRef(vmetrics[++i])];

	              for (j = start; j <= code; j++) {
	                glyphsVMetrics[j] = vmetric;
	              }
	            }
	          }
	        }
	      }
	    } else {
	      const firstChar = properties.firstChar;
	      widths = dict.get("Widths");

	      if (widths) {
	        j = firstChar;

	        for (i = 0, ii = widths.length; i < ii; i++) {
	          glyphsWidths[j++] = xref.fetchIfRef(widths[i]);
	        }

	        defaultWidth = parseFloat(descriptor.get("MissingWidth")) || 0;
	      } else {
	        const baseFontName = dict.get("BaseFont");

	        if (baseFontName instanceof _primitives.Name) {
	          const metrics = this.getBaseFontMetrics(baseFontName.name);
	          glyphsWidths = this.buildCharCodeToWidth(metrics.widths, properties);
	          defaultWidth = metrics.defaultWidth;
	        }
	      }
	    }

	    let isMonospace = true;
	    let firstWidth = defaultWidth;

	    for (const glyph in glyphsWidths) {
	      const glyphWidth = glyphsWidths[glyph];

	      if (!glyphWidth) {
	        continue;
	      }

	      if (!firstWidth) {
	        firstWidth = glyphWidth;
	        continue;
	      }

	      if (firstWidth !== glyphWidth) {
	        isMonospace = false;
	        break;
	      }
	    }

	    if (isMonospace) {
	      properties.flags |= _fonts_utils.FontFlags.FixedPitch;
	    }

	    properties.defaultWidth = defaultWidth;
	    properties.widths = glyphsWidths;
	    properties.defaultVMetrics = defaultVMetrics;
	    properties.vmetrics = glyphsVMetrics;
	  }

	  isSerifFont(baseFontName) {
	    const fontNameWoStyle = baseFontName.split("-")[0];
	    return fontNameWoStyle in (0, _standard_fonts.getSerifFonts)() || fontNameWoStyle.search(/serif/gi) !== -1;
	  }

	  getBaseFontMetrics(name) {
	    let defaultWidth = 0;
	    let widths = Object.create(null);
	    let monospace = false;
	    const stdFontMap = (0, _standard_fonts.getStdFontMap)();
	    let lookupName = stdFontMap[name] || name;
	    const Metrics = (0, _metrics.getMetrics)();

	    if (!(lookupName in Metrics)) {
	      if (this.isSerifFont(name)) {
	        lookupName = "Times-Roman";
	      } else {
	        lookupName = "Helvetica";
	      }
	    }

	    const glyphWidths = Metrics[lookupName];

	    if (typeof glyphWidths === "number") {
	      defaultWidth = glyphWidths;
	      monospace = true;
	    } else {
	      widths = glyphWidths();
	    }

	    return {
	      defaultWidth,
	      monospace,
	      widths
	    };
	  }

	  buildCharCodeToWidth(widthsByGlyphName, properties) {
	    const widths = Object.create(null);
	    const differences = properties.differences;
	    const encoding = properties.defaultEncoding;

	    for (let charCode = 0; charCode < 256; charCode++) {
	      if (charCode in differences && widthsByGlyphName[differences[charCode]]) {
	        widths[charCode] = widthsByGlyphName[differences[charCode]];
	        continue;
	      }

	      if (charCode in encoding && widthsByGlyphName[encoding[charCode]]) {
	        widths[charCode] = widthsByGlyphName[encoding[charCode]];
	        continue;
	      }
	    }

	    return widths;
	  }

	  preEvaluateFont(dict) {
	    const baseDict = dict;
	    let type = dict.get("Subtype");

	    if (!(type instanceof _primitives.Name)) {
	      throw new _util.FormatError("invalid font Subtype");
	    }

	    let composite = false;
	    let hash, toUnicode;

	    if (type.name === "Type0") {
	      const df = dict.get("DescendantFonts");

	      if (!df) {
	        throw new _util.FormatError("Descendant fonts are not specified");
	      }

	      dict = Array.isArray(df) ? this.xref.fetchIfRef(df[0]) : df;

	      if (!(dict instanceof _primitives.Dict)) {
	        throw new _util.FormatError("Descendant font is not a dictionary.");
	      }

	      type = dict.get("Subtype");

	      if (!(type instanceof _primitives.Name)) {
	        throw new _util.FormatError("invalid font Subtype");
	      }

	      composite = true;
	    }

	    const firstChar = dict.get("FirstChar") || 0,
	          lastChar = dict.get("LastChar") || (composite ? 0xffff : 0xff);
	    const descriptor = dict.get("FontDescriptor");

	    if (descriptor) {
	      hash = new _murmurhash.MurmurHash3_64();
	      const encoding = baseDict.getRaw("Encoding");

	      if (encoding instanceof _primitives.Name) {
	        hash.update(encoding.name);
	      } else if (encoding instanceof _primitives.Ref) {
	        hash.update(encoding.toString());
	      } else if (encoding instanceof _primitives.Dict) {
	        for (const entry of encoding.getRawValues()) {
	          if (entry instanceof _primitives.Name) {
	            hash.update(entry.name);
	          } else if (entry instanceof _primitives.Ref) {
	            hash.update(entry.toString());
	          } else if (Array.isArray(entry)) {
	            const diffLength = entry.length,
	                  diffBuf = new Array(diffLength);

	            for (let j = 0; j < diffLength; j++) {
	              const diffEntry = entry[j];

	              if (diffEntry instanceof _primitives.Name) {
	                diffBuf[j] = diffEntry.name;
	              } else if (typeof diffEntry === "number" || diffEntry instanceof _primitives.Ref) {
	                diffBuf[j] = diffEntry.toString();
	              }
	            }

	            hash.update(diffBuf.join());
	          }
	        }
	      }

	      hash.update(`${firstChar}-${lastChar}`);
	      toUnicode = dict.get("ToUnicode") || baseDict.get("ToUnicode");

	      if (toUnicode instanceof _base_stream.BaseStream) {
	        const stream = toUnicode.str || toUnicode;
	        const uint8array = stream.buffer ? new Uint8Array(stream.buffer.buffer, 0, stream.bufferLength) : new Uint8Array(stream.bytes.buffer, stream.start, stream.end - stream.start);
	        hash.update(uint8array);
	      } else if (toUnicode instanceof _primitives.Name) {
	        hash.update(toUnicode.name);
	      }

	      const widths = dict.get("Widths") || baseDict.get("Widths");

	      if (Array.isArray(widths)) {
	        const widthsBuf = [];

	        for (const entry of widths) {
	          if (typeof entry === "number" || entry instanceof _primitives.Ref) {
	            widthsBuf.push(entry.toString());
	          }
	        }

	        hash.update(widthsBuf.join());
	      }

	      if (composite) {
	        hash.update("compositeFont");
	        const compositeWidths = dict.get("W") || baseDict.get("W");

	        if (Array.isArray(compositeWidths)) {
	          const widthsBuf = [];

	          for (const entry of compositeWidths) {
	            if (typeof entry === "number" || entry instanceof _primitives.Ref) {
	              widthsBuf.push(entry.toString());
	            } else if (Array.isArray(entry)) {
	              const subWidthsBuf = [];

	              for (const element of entry) {
	                if (typeof element === "number" || element instanceof _primitives.Ref) {
	                  subWidthsBuf.push(element.toString());
	                }
	              }

	              widthsBuf.push(`[${subWidthsBuf.join()}]`);
	            }
	          }

	          hash.update(widthsBuf.join());
	        }

	        const cidToGidMap = dict.getRaw("CIDToGIDMap") || baseDict.getRaw("CIDToGIDMap");

	        if (cidToGidMap instanceof _primitives.Name) {
	          hash.update(cidToGidMap.name);
	        } else if (cidToGidMap instanceof _primitives.Ref) {
	          hash.update(cidToGidMap.toString());
	        } else if (cidToGidMap instanceof _base_stream.BaseStream) {
	          hash.update(cidToGidMap.peekBytes());
	        }
	      }
	    }

	    return {
	      descriptor,
	      dict,
	      baseDict,
	      composite,
	      type: type.name,
	      firstChar,
	      lastChar,
	      toUnicode,
	      hash: hash ? hash.hexdigest() : ""
	    };
	  }

	  async translateFont({
	    descriptor,
	    dict,
	    baseDict,
	    composite,
	    type,
	    firstChar,
	    lastChar,
	    toUnicode,
	    cssFontInfo
	  }) {
	    const isType3Font = type === "Type3";
	    let properties;

	    if (!descriptor) {
	      if (isType3Font) {
	        descriptor = new _primitives.Dict(null);
	        descriptor.set("FontName", _primitives.Name.get(type));
	        descriptor.set("FontBBox", dict.getArray("FontBBox") || [0, 0, 0, 0]);
	      } else {
	        let baseFontName = dict.get("BaseFont");

	        if (!(baseFontName instanceof _primitives.Name)) {
	          throw new _util.FormatError("Base font is not specified");
	        }

	        baseFontName = baseFontName.name.replace(/[,_]/g, "-");
	        const metrics = this.getBaseFontMetrics(baseFontName);
	        const fontNameWoStyle = baseFontName.split("-")[0];
	        const flags = (this.isSerifFont(fontNameWoStyle) ? _fonts_utils.FontFlags.Serif : 0) | (metrics.monospace ? _fonts_utils.FontFlags.FixedPitch : 0) | ((0, _standard_fonts.getSymbolsFonts)()[fontNameWoStyle] ? _fonts_utils.FontFlags.Symbolic : _fonts_utils.FontFlags.Nonsymbolic);
	        properties = {
	          type,
	          name: baseFontName,
	          loadedName: baseDict.loadedName,
	          widths: metrics.widths,
	          defaultWidth: metrics.defaultWidth,
	          isSimulatedFlags: true,
	          flags,
	          firstChar,
	          lastChar,
	          toUnicode,
	          xHeight: 0,
	          capHeight: 0,
	          italicAngle: 0,
	          isType3Font
	        };
	        const widths = dict.get("Widths");
	        const standardFontName = (0, _standard_fonts.getStandardFontName)(baseFontName);
	        let file = null;

	        if (standardFontName) {
	          properties.isStandardFont = true;
	          file = await this.fetchStandardFontData(standardFontName);
	          properties.isInternalFont = !!file;
	        }

	        return this.extractDataStructures(dict, dict, properties).then(newProperties => {
	          if (widths) {
	            const glyphWidths = [];
	            let j = firstChar;

	            for (let i = 0, ii = widths.length; i < ii; i++) {
	              glyphWidths[j++] = this.xref.fetchIfRef(widths[i]);
	            }

	            newProperties.widths = glyphWidths;
	          } else {
	            newProperties.widths = this.buildCharCodeToWidth(metrics.widths, newProperties);
	          }

	          return new _fonts.Font(baseFontName, file, newProperties);
	        });
	      }
	    }

	    let fontName = descriptor.get("FontName");
	    let baseFont = dict.get("BaseFont");

	    if (typeof fontName === "string") {
	      fontName = _primitives.Name.get(fontName);
	    }

	    if (typeof baseFont === "string") {
	      baseFont = _primitives.Name.get(baseFont);
	    }

	    if (!isType3Font) {
	      const fontNameStr = fontName && fontName.name;
	      const baseFontStr = baseFont && baseFont.name;

	      if (fontNameStr !== baseFontStr) {
	        (0, _util.info)(`The FontDescriptor's FontName is "${fontNameStr}" but ` + `should be the same as the Font's BaseFont "${baseFontStr}".`);

	        if (fontNameStr && baseFontStr && baseFontStr.startsWith(fontNameStr)) {
	          fontName = baseFont;
	        }
	      }
	    }

	    fontName = fontName || baseFont;

	    if (!(fontName instanceof _primitives.Name)) {
	      throw new _util.FormatError("invalid font name");
	    }

	    let fontFile, subtype, length1, length2, length3;

	    try {
	      fontFile = descriptor.get("FontFile", "FontFile2", "FontFile3");
	    } catch (ex) {
	      if (!this.options.ignoreErrors) {
	        throw ex;
	      }

	      (0, _util.warn)(`translateFont - fetching "${fontName.name}" font file: "${ex}".`);
	      fontFile = new _stream.NullStream();
	    }

	    let isStandardFont = false;
	    let isInternalFont = false;
	    let glyphScaleFactors = null;

	    if (fontFile) {
	      if (fontFile.dict) {
	        const subtypeEntry = fontFile.dict.get("Subtype");

	        if (subtypeEntry instanceof _primitives.Name) {
	          subtype = subtypeEntry.name;
	        }

	        length1 = fontFile.dict.get("Length1");
	        length2 = fontFile.dict.get("Length2");
	        length3 = fontFile.dict.get("Length3");
	      }
	    } else if (cssFontInfo) {
	      const standardFontName = (0, _xfa_fonts.getXfaFontName)(fontName.name);

	      if (standardFontName) {
	        cssFontInfo.fontFamily = `${cssFontInfo.fontFamily}-PdfJS-XFA`;
	        cssFontInfo.metrics = standardFontName.metrics || null;
	        glyphScaleFactors = standardFontName.factors || null;
	        fontFile = await this.fetchStandardFontData(standardFontName.name);
	        isInternalFont = !!fontFile;
	        baseDict = dict = (0, _xfa_fonts.getXfaFontDict)(fontName.name);
	        composite = true;
	      }
	    } else if (!isType3Font) {
	      const standardFontName = (0, _standard_fonts.getStandardFontName)(fontName.name);

	      if (standardFontName) {
	        isStandardFont = true;
	        fontFile = await this.fetchStandardFontData(standardFontName);
	        isInternalFont = !!fontFile;
	      }
	    }

	    properties = {
	      type,
	      name: fontName.name,
	      subtype,
	      file: fontFile,
	      length1,
	      length2,
	      length3,
	      isStandardFont,
	      isInternalFont,
	      loadedName: baseDict.loadedName,
	      composite,
	      fixedPitch: false,
	      fontMatrix: dict.getArray("FontMatrix") || _util.FONT_IDENTITY_MATRIX,
	      firstChar,
	      lastChar,
	      toUnicode,
	      bbox: descriptor.getArray("FontBBox") || dict.getArray("FontBBox"),
	      ascent: descriptor.get("Ascent"),
	      descent: descriptor.get("Descent"),
	      xHeight: descriptor.get("XHeight") || 0,
	      capHeight: descriptor.get("CapHeight") || 0,
	      flags: descriptor.get("Flags"),
	      italicAngle: descriptor.get("ItalicAngle") || 0,
	      isType3Font,
	      cssFontInfo,
	      scaleFactors: glyphScaleFactors
	    };

	    if (composite) {
	      const cidEncoding = baseDict.get("Encoding");

	      if (cidEncoding instanceof _primitives.Name) {
	        properties.cidEncoding = cidEncoding.name;
	      }

	      const cMap = await _cmap.CMapFactory.create({
	        encoding: cidEncoding,
	        fetchBuiltInCMap: this._fetchBuiltInCMapBound,
	        useCMap: null
	      });
	      properties.cMap = cMap;
	      properties.vertical = properties.cMap.vertical;
	    }

	    return this.extractDataStructures(dict, baseDict, properties).then(newProperties => {
	      this.extractWidths(dict, descriptor, newProperties);
	      return new _fonts.Font(fontName.name, fontFile, newProperties);
	    });
	  }

	  static buildFontPaths(font, glyphs, handler, evaluatorOptions) {
	    function buildPath(fontChar) {
	      const glyphName = `${font.loadedName}_path_${fontChar}`;

	      try {
	        if (font.renderer.hasBuiltPath(fontChar)) {
	          return;
	        }

	        handler.send("commonobj", [glyphName, "FontPath", font.renderer.getPathJs(fontChar)]);
	      } catch (reason) {
	        if (evaluatorOptions.ignoreErrors) {
	          handler.send("UnsupportedFeature", {
	            featureId: _util.UNSUPPORTED_FEATURES.errorFontBuildPath
	          });
	          (0, _util.warn)(`buildFontPaths - ignoring ${glyphName} glyph: "${reason}".`);
	          return;
	        }

	        throw reason;
	      }
	    }

	    for (const glyph of glyphs) {
	      buildPath(glyph.fontChar);
	      const accent = glyph.accent;

	      if (accent && accent.fontChar) {
	        buildPath(accent.fontChar);
	      }
	    }
	  }

	  static get fallbackFontDict() {
	    const dict = new _primitives.Dict();
	    dict.set("BaseFont", _primitives.Name.get("PDFJS-FallbackFont"));
	    dict.set("Type", _primitives.Name.get("FallbackType"));
	    dict.set("Subtype", _primitives.Name.get("FallbackType"));
	    dict.set("Encoding", _primitives.Name.get("WinAnsiEncoding"));
	    return (0, _util.shadow)(this, "fallbackFontDict", dict);
	  }

	}

	exports.PartialEvaluator = PartialEvaluator;

	class TranslatedFont {
	  constructor({
	    loadedName,
	    font,
	    dict,
	    evaluatorOptions
	  }) {
	    this.loadedName = loadedName;
	    this.font = font;
	    this.dict = dict;
	    this._evaluatorOptions = evaluatorOptions || DefaultPartialEvaluatorOptions;
	    this.type3Loaded = null;
	    this.type3Dependencies = font.isType3Font ? new Set() : null;
	    this.sent = false;
	  }

	  send(handler) {
	    if (this.sent) {
	      return;
	    }

	    this.sent = true;
	    handler.send("commonobj", [this.loadedName, "Font", this.font.exportData(this._evaluatorOptions.fontExtraProperties)]);
	  }

	  fallback(handler) {
	    if (!this.font.data) {
	      return;
	    }

	    this.font.disableFontFace = true;
	    PartialEvaluator.buildFontPaths(this.font, this.font.glyphCacheValues, handler, this._evaluatorOptions);
	  }

	  loadType3Data(evaluator, resources, task) {
	    if (this.type3Loaded) {
	      return this.type3Loaded;
	    }

	    if (!this.font.isType3Font) {
	      throw new Error("Must be a Type3 font.");
	    }

	    const type3Evaluator = evaluator.clone({
	      ignoreErrors: false
	    });
	    type3Evaluator.parsingType3Font = true;
	    const type3FontRefs = new _primitives.RefSet(evaluator.type3FontRefs);

	    if (this.dict.objId && !type3FontRefs.has(this.dict.objId)) {
	      type3FontRefs.put(this.dict.objId);
	    }

	    type3Evaluator.type3FontRefs = type3FontRefs;
	    const translatedFont = this.font,
	          type3Dependencies = this.type3Dependencies;
	    let loadCharProcsPromise = Promise.resolve();
	    const charProcs = this.dict.get("CharProcs");
	    const fontResources = this.dict.get("Resources") || resources;
	    const charProcOperatorList = Object.create(null);

	    const fontBBox = _util.Util.normalizeRect(translatedFont.bbox || [0, 0, 0, 0]),
	          width = fontBBox[2] - fontBBox[0],
	          height = fontBBox[3] - fontBBox[1];

	    const fontBBoxSize = Math.hypot(width, height);

	    for (const key of charProcs.getKeys()) {
	      loadCharProcsPromise = loadCharProcsPromise.then(() => {
	        const glyphStream = charProcs.get(key);
	        const operatorList = new _operator_list.OperatorList();
	        return type3Evaluator.getOperatorList({
	          stream: glyphStream,
	          task,
	          resources: fontResources,
	          operatorList
	        }).then(() => {
	          if (operatorList.fnArray[0] === _util.OPS.setCharWidthAndBounds) {
	            this._removeType3ColorOperators(operatorList, fontBBoxSize);
	          }

	          charProcOperatorList[key] = operatorList.getIR();

	          for (const dependency of operatorList.dependencies) {
	            type3Dependencies.add(dependency);
	          }
	        }).catch(function (reason) {
	          (0, _util.warn)(`Type3 font resource "${key}" is not available.`);
	          const dummyOperatorList = new _operator_list.OperatorList();
	          charProcOperatorList[key] = dummyOperatorList.getIR();
	        });
	      });
	    }

	    this.type3Loaded = loadCharProcsPromise.then(() => {
	      translatedFont.charProcOperatorList = charProcOperatorList;

	      if (this._bbox) {
	        translatedFont.isCharBBox = true;
	        translatedFont.bbox = this._bbox;
	      }
	    });
	    return this.type3Loaded;
	  }

	  _removeType3ColorOperators(operatorList, fontBBoxSize = NaN) {
	    const charBBox = _util.Util.normalizeRect(operatorList.argsArray[0].slice(2)),
	          width = charBBox[2] - charBBox[0],
	          height = charBBox[3] - charBBox[1];

	    const charBBoxSize = Math.hypot(width, height);

	    if (width === 0 || height === 0) {
	      operatorList.fnArray.splice(0, 1);
	      operatorList.argsArray.splice(0, 1);
	    } else if (fontBBoxSize === 0 || Math.round(charBBoxSize / fontBBoxSize) >= 10) {
	      if (!this._bbox) {
	        this._bbox = [Infinity, Infinity, -Infinity, -Infinity];
	      }

	      this._bbox[0] = Math.min(this._bbox[0], charBBox[0]);
	      this._bbox[1] = Math.min(this._bbox[1], charBBox[1]);
	      this._bbox[2] = Math.max(this._bbox[2], charBBox[2]);
	      this._bbox[3] = Math.max(this._bbox[3], charBBox[3]);
	    }

	    let i = 0,
	        ii = operatorList.length;

	    while (i < ii) {
	      switch (operatorList.fnArray[i]) {
	        case _util.OPS.setCharWidthAndBounds:
	          break;

	        case _util.OPS.setStrokeColorSpace:
	        case _util.OPS.setFillColorSpace:
	        case _util.OPS.setStrokeColor:
	        case _util.OPS.setStrokeColorN:
	        case _util.OPS.setFillColor:
	        case _util.OPS.setFillColorN:
	        case _util.OPS.setStrokeGray:
	        case _util.OPS.setFillGray:
	        case _util.OPS.setStrokeRGBColor:
	        case _util.OPS.setFillRGBColor:
	        case _util.OPS.setStrokeCMYKColor:
	        case _util.OPS.setFillCMYKColor:
	        case _util.OPS.shadingFill:
	        case _util.OPS.setRenderingIntent:
	          operatorList.fnArray.splice(i, 1);
	          operatorList.argsArray.splice(i, 1);
	          ii--;
	          continue;

	        case _util.OPS.setGState:
	          const [gStateObj] = operatorList.argsArray[i];
	          let j = 0,
	              jj = gStateObj.length;

	          while (j < jj) {
	            const [gStateKey] = gStateObj[j];

	            switch (gStateKey) {
	              case "TR":
	              case "TR2":
	              case "HT":
	              case "BG":
	              case "BG2":
	              case "UCR":
	              case "UCR2":
	                gStateObj.splice(j, 1);
	                jj--;
	                continue;
	            }

	            j++;
	          }

	          break;
	      }

	      i++;
	    }
	  }

	}

	class StateManager {
	  constructor(initialState = new EvalState()) {
	    this.state = initialState;
	    this.stateStack = [];
	  }

	  save() {
	    const old = this.state;
	    this.stateStack.push(this.state);
	    this.state = old.clone();
	  }

	  restore() {
	    const prev = this.stateStack.pop();

	    if (prev) {
	      this.state = prev;
	    }
	  }

	  transform(args) {
	    this.state.ctm = _util.Util.transform(this.state.ctm, args);
	  }

	}

	class TextState {
	  constructor() {
	    this.ctm = new Float32Array(_util.IDENTITY_MATRIX);
	    this.fontName = null;
	    this.fontSize = 0;
	    this.font = null;
	    this.fontMatrix = _util.FONT_IDENTITY_MATRIX;
	    this.textMatrix = _util.IDENTITY_MATRIX.slice();
	    this.textLineMatrix = _util.IDENTITY_MATRIX.slice();
	    this.charSpacing = 0;
	    this.wordSpacing = 0;
	    this.leading = 0;
	    this.textHScale = 1;
	    this.textRise = 0;
	  }

	  setTextMatrix(a, b, c, d, e, f) {
	    const m = this.textMatrix;
	    m[0] = a;
	    m[1] = b;
	    m[2] = c;
	    m[3] = d;
	    m[4] = e;
	    m[5] = f;
	  }

	  setTextLineMatrix(a, b, c, d, e, f) {
	    const m = this.textLineMatrix;
	    m[0] = a;
	    m[1] = b;
	    m[2] = c;
	    m[3] = d;
	    m[4] = e;
	    m[5] = f;
	  }

	  translateTextMatrix(x, y) {
	    const m = this.textMatrix;
	    m[4] = m[0] * x + m[2] * y + m[4];
	    m[5] = m[1] * x + m[3] * y + m[5];
	  }

	  translateTextLineMatrix(x, y) {
	    const m = this.textLineMatrix;
	    m[4] = m[0] * x + m[2] * y + m[4];
	    m[5] = m[1] * x + m[3] * y + m[5];
	  }

	  carriageReturn() {
	    this.translateTextLineMatrix(0, -this.leading);
	    this.textMatrix = this.textLineMatrix.slice();
	  }

	  clone() {
	    const clone = Object.create(this);
	    clone.textMatrix = this.textMatrix.slice();
	    clone.textLineMatrix = this.textLineMatrix.slice();
	    clone.fontMatrix = this.fontMatrix.slice();
	    return clone;
	  }

	}

	class EvalState {
	  constructor() {
	    this.ctm = new Float32Array(_util.IDENTITY_MATRIX);
	    this.font = null;
	    this.textRenderingMode = _util.TextRenderingMode.FILL;
	    this.fillColorSpace = _colorspace.ColorSpace.singletons.gray;
	    this.strokeColorSpace = _colorspace.ColorSpace.singletons.gray;
	  }

	  clone() {
	    return Object.create(this);
	  }

	}

	class EvaluatorPreprocessor {
	  static get opMap() {
	    const getOPMap = (0, _core_utils.getLookupTableFactory)(function (t) {
	      t.w = {
	        id: _util.OPS.setLineWidth,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.J = {
	        id: _util.OPS.setLineCap,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.j = {
	        id: _util.OPS.setLineJoin,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.M = {
	        id: _util.OPS.setMiterLimit,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.d = {
	        id: _util.OPS.setDash,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.ri = {
	        id: _util.OPS.setRenderingIntent,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.i = {
	        id: _util.OPS.setFlatness,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.gs = {
	        id: _util.OPS.setGState,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.q = {
	        id: _util.OPS.save,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.Q = {
	        id: _util.OPS.restore,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.cm = {
	        id: _util.OPS.transform,
	        numArgs: 6,
	        variableArgs: false
	      };
	      t.m = {
	        id: _util.OPS.moveTo,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.l = {
	        id: _util.OPS.lineTo,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.c = {
	        id: _util.OPS.curveTo,
	        numArgs: 6,
	        variableArgs: false
	      };
	      t.v = {
	        id: _util.OPS.curveTo2,
	        numArgs: 4,
	        variableArgs: false
	      };
	      t.y = {
	        id: _util.OPS.curveTo3,
	        numArgs: 4,
	        variableArgs: false
	      };
	      t.h = {
	        id: _util.OPS.closePath,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.re = {
	        id: _util.OPS.rectangle,
	        numArgs: 4,
	        variableArgs: false
	      };
	      t.S = {
	        id: _util.OPS.stroke,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.s = {
	        id: _util.OPS.closeStroke,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.f = {
	        id: _util.OPS.fill,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.F = {
	        id: _util.OPS.fill,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t["f*"] = {
	        id: _util.OPS.eoFill,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.B = {
	        id: _util.OPS.fillStroke,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t["B*"] = {
	        id: _util.OPS.eoFillStroke,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.b = {
	        id: _util.OPS.closeFillStroke,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t["b*"] = {
	        id: _util.OPS.closeEOFillStroke,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.n = {
	        id: _util.OPS.endPath,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.W = {
	        id: _util.OPS.clip,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t["W*"] = {
	        id: _util.OPS.eoClip,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.BT = {
	        id: _util.OPS.beginText,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.ET = {
	        id: _util.OPS.endText,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.Tc = {
	        id: _util.OPS.setCharSpacing,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.Tw = {
	        id: _util.OPS.setWordSpacing,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.Tz = {
	        id: _util.OPS.setHScale,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.TL = {
	        id: _util.OPS.setLeading,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.Tf = {
	        id: _util.OPS.setFont,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.Tr = {
	        id: _util.OPS.setTextRenderingMode,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.Ts = {
	        id: _util.OPS.setTextRise,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.Td = {
	        id: _util.OPS.moveText,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.TD = {
	        id: _util.OPS.setLeadingMoveText,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.Tm = {
	        id: _util.OPS.setTextMatrix,
	        numArgs: 6,
	        variableArgs: false
	      };
	      t["T*"] = {
	        id: _util.OPS.nextLine,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.Tj = {
	        id: _util.OPS.showText,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.TJ = {
	        id: _util.OPS.showSpacedText,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t["'"] = {
	        id: _util.OPS.nextLineShowText,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t['"'] = {
	        id: _util.OPS.nextLineSetSpacingShowText,
	        numArgs: 3,
	        variableArgs: false
	      };
	      t.d0 = {
	        id: _util.OPS.setCharWidth,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.d1 = {
	        id: _util.OPS.setCharWidthAndBounds,
	        numArgs: 6,
	        variableArgs: false
	      };
	      t.CS = {
	        id: _util.OPS.setStrokeColorSpace,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.cs = {
	        id: _util.OPS.setFillColorSpace,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.SC = {
	        id: _util.OPS.setStrokeColor,
	        numArgs: 4,
	        variableArgs: true
	      };
	      t.SCN = {
	        id: _util.OPS.setStrokeColorN,
	        numArgs: 33,
	        variableArgs: true
	      };
	      t.sc = {
	        id: _util.OPS.setFillColor,
	        numArgs: 4,
	        variableArgs: true
	      };
	      t.scn = {
	        id: _util.OPS.setFillColorN,
	        numArgs: 33,
	        variableArgs: true
	      };
	      t.G = {
	        id: _util.OPS.setStrokeGray,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.g = {
	        id: _util.OPS.setFillGray,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.RG = {
	        id: _util.OPS.setStrokeRGBColor,
	        numArgs: 3,
	        variableArgs: false
	      };
	      t.rg = {
	        id: _util.OPS.setFillRGBColor,
	        numArgs: 3,
	        variableArgs: false
	      };
	      t.K = {
	        id: _util.OPS.setStrokeCMYKColor,
	        numArgs: 4,
	        variableArgs: false
	      };
	      t.k = {
	        id: _util.OPS.setFillCMYKColor,
	        numArgs: 4,
	        variableArgs: false
	      };
	      t.sh = {
	        id: _util.OPS.shadingFill,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.BI = {
	        id: _util.OPS.beginInlineImage,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.ID = {
	        id: _util.OPS.beginImageData,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.EI = {
	        id: _util.OPS.endInlineImage,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.Do = {
	        id: _util.OPS.paintXObject,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.MP = {
	        id: _util.OPS.markPoint,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.DP = {
	        id: _util.OPS.markPointProps,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.BMC = {
	        id: _util.OPS.beginMarkedContent,
	        numArgs: 1,
	        variableArgs: false
	      };
	      t.BDC = {
	        id: _util.OPS.beginMarkedContentProps,
	        numArgs: 2,
	        variableArgs: false
	      };
	      t.EMC = {
	        id: _util.OPS.endMarkedContent,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.BX = {
	        id: _util.OPS.beginCompat,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.EX = {
	        id: _util.OPS.endCompat,
	        numArgs: 0,
	        variableArgs: false
	      };
	      t.BM = null;
	      t.BD = null;
	      t.true = null;
	      t.fa = null;
	      t.fal = null;
	      t.fals = null;
	      t.false = null;
	      t.nu = null;
	      t.nul = null;
	      t.null = null;
	    });
	    return (0, _util.shadow)(this, "opMap", getOPMap());
	  }

	  static get MAX_INVALID_PATH_OPS() {
	    return (0, _util.shadow)(this, "MAX_INVALID_PATH_OPS", 10);
	  }

	  constructor(stream, xref, stateManager = new StateManager()) {
	    this.parser = new _parser.Parser({
	      lexer: new _parser.Lexer(stream, EvaluatorPreprocessor.opMap),
	      xref
	    });
	    this.stateManager = stateManager;
	    this.nonProcessedArgs = [];
	    this._isPathOp = false;
	    this._numInvalidPathOPS = 0;
	  }

	  get savedStatesDepth() {
	    return this.stateManager.stateStack.length;
	  }

	  read(operation) {
	    let args = operation.args;

	    while (true) {
	      const obj = this.parser.getObj();

	      if (obj instanceof _primitives.Cmd) {
	        const cmd = obj.cmd;
	        const opSpec = EvaluatorPreprocessor.opMap[cmd];

	        if (!opSpec) {
	          (0, _util.warn)(`Unknown command "${cmd}".`);
	          continue;
	        }

	        const fn = opSpec.id;
	        const numArgs = opSpec.numArgs;
	        let argsLength = args !== null ? args.length : 0;

	        if (!this._isPathOp) {
	          this._numInvalidPathOPS = 0;
	        }

	        this._isPathOp = fn >= _util.OPS.moveTo && fn <= _util.OPS.endPath;

	        if (!opSpec.variableArgs) {
	          if (argsLength !== numArgs) {
	            const nonProcessedArgs = this.nonProcessedArgs;

	            while (argsLength > numArgs) {
	              nonProcessedArgs.push(args.shift());
	              argsLength--;
	            }

	            while (argsLength < numArgs && nonProcessedArgs.length !== 0) {
	              if (args === null) {
	                args = [];
	              }

	              args.unshift(nonProcessedArgs.pop());
	              argsLength++;
	            }
	          }

	          if (argsLength < numArgs) {
	            const partialMsg = `command ${cmd}: expected ${numArgs} args, ` + `but received ${argsLength} args.`;

	            if (this._isPathOp && ++this._numInvalidPathOPS > EvaluatorPreprocessor.MAX_INVALID_PATH_OPS) {
	              throw new _util.FormatError(`Invalid ${partialMsg}`);
	            }

	            (0, _util.warn)(`Skipping ${partialMsg}`);

	            if (args !== null) {
	              args.length = 0;
	            }

	            continue;
	          }
	        } else if (argsLength > numArgs) {
	          (0, _util.info)(`Command ${cmd}: expected [0, ${numArgs}] args, ` + `but received ${argsLength} args.`);
	        }

	        this.preprocessCommand(fn, args);
	        operation.fn = fn;
	        operation.args = args;
	        return true;
	      }

	      if (obj === _primitives.EOF) {
	        return false;
	      }

	      if (obj !== null) {
	        if (args === null) {
	          args = [];
	        }

	        args.push(obj);

	        if (args.length > 33) {
	          throw new _util.FormatError("Too many arguments");
	        }
	      }
	    }
	  }

	  preprocessCommand(fn, args) {
	    switch (fn | 0) {
	      case _util.OPS.save:
	        this.stateManager.save();
	        break;

	      case _util.OPS.restore:
	        this.stateManager.restore();
	        break;

	      case _util.OPS.transform:
	        this.stateManager.transform(args);
	        break;
	    }
	  }

	}

	exports.EvaluatorPreprocessor = EvaluatorPreprocessor;

	/***/ }),
	/* 16 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.IdentityCMap = exports.CMapFactory = exports.CMap = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _base_stream = __w_pdfjs_require__(7);

	var _parser = __w_pdfjs_require__(17);

	var _core_utils = __w_pdfjs_require__(6);

	var _stream = __w_pdfjs_require__(10);

	const BUILT_IN_CMAPS = ["Adobe-GB1-UCS2", "Adobe-CNS1-UCS2", "Adobe-Japan1-UCS2", "Adobe-Korea1-UCS2", "78-EUC-H", "78-EUC-V", "78-H", "78-RKSJ-H", "78-RKSJ-V", "78-V", "78ms-RKSJ-H", "78ms-RKSJ-V", "83pv-RKSJ-H", "90ms-RKSJ-H", "90ms-RKSJ-V", "90msp-RKSJ-H", "90msp-RKSJ-V", "90pv-RKSJ-H", "90pv-RKSJ-V", "Add-H", "Add-RKSJ-H", "Add-RKSJ-V", "Add-V", "Adobe-CNS1-0", "Adobe-CNS1-1", "Adobe-CNS1-2", "Adobe-CNS1-3", "Adobe-CNS1-4", "Adobe-CNS1-5", "Adobe-CNS1-6", "Adobe-GB1-0", "Adobe-GB1-1", "Adobe-GB1-2", "Adobe-GB1-3", "Adobe-GB1-4", "Adobe-GB1-5", "Adobe-Japan1-0", "Adobe-Japan1-1", "Adobe-Japan1-2", "Adobe-Japan1-3", "Adobe-Japan1-4", "Adobe-Japan1-5", "Adobe-Japan1-6", "Adobe-Korea1-0", "Adobe-Korea1-1", "Adobe-Korea1-2", "B5-H", "B5-V", "B5pc-H", "B5pc-V", "CNS-EUC-H", "CNS-EUC-V", "CNS1-H", "CNS1-V", "CNS2-H", "CNS2-V", "ETHK-B5-H", "ETHK-B5-V", "ETen-B5-H", "ETen-B5-V", "ETenms-B5-H", "ETenms-B5-V", "EUC-H", "EUC-V", "Ext-H", "Ext-RKSJ-H", "Ext-RKSJ-V", "Ext-V", "GB-EUC-H", "GB-EUC-V", "GB-H", "GB-V", "GBK-EUC-H", "GBK-EUC-V", "GBK2K-H", "GBK2K-V", "GBKp-EUC-H", "GBKp-EUC-V", "GBT-EUC-H", "GBT-EUC-V", "GBT-H", "GBT-V", "GBTpc-EUC-H", "GBTpc-EUC-V", "GBpc-EUC-H", "GBpc-EUC-V", "H", "HKdla-B5-H", "HKdla-B5-V", "HKdlb-B5-H", "HKdlb-B5-V", "HKgccs-B5-H", "HKgccs-B5-V", "HKm314-B5-H", "HKm314-B5-V", "HKm471-B5-H", "HKm471-B5-V", "HKscs-B5-H", "HKscs-B5-V", "Hankaku", "Hiragana", "KSC-EUC-H", "KSC-EUC-V", "KSC-H", "KSC-Johab-H", "KSC-Johab-V", "KSC-V", "KSCms-UHC-H", "KSCms-UHC-HW-H", "KSCms-UHC-HW-V", "KSCms-UHC-V", "KSCpc-EUC-H", "KSCpc-EUC-V", "Katakana", "NWP-H", "NWP-V", "RKSJ-H", "RKSJ-V", "Roman", "UniCNS-UCS2-H", "UniCNS-UCS2-V", "UniCNS-UTF16-H", "UniCNS-UTF16-V", "UniCNS-UTF32-H", "UniCNS-UTF32-V", "UniCNS-UTF8-H", "UniCNS-UTF8-V", "UniGB-UCS2-H", "UniGB-UCS2-V", "UniGB-UTF16-H", "UniGB-UTF16-V", "UniGB-UTF32-H", "UniGB-UTF32-V", "UniGB-UTF8-H", "UniGB-UTF8-V", "UniJIS-UCS2-H", "UniJIS-UCS2-HW-H", "UniJIS-UCS2-HW-V", "UniJIS-UCS2-V", "UniJIS-UTF16-H", "UniJIS-UTF16-V", "UniJIS-UTF32-H", "UniJIS-UTF32-V", "UniJIS-UTF8-H", "UniJIS-UTF8-V", "UniJIS2004-UTF16-H", "UniJIS2004-UTF16-V", "UniJIS2004-UTF32-H", "UniJIS2004-UTF32-V", "UniJIS2004-UTF8-H", "UniJIS2004-UTF8-V", "UniJISPro-UCS2-HW-V", "UniJISPro-UCS2-V", "UniJISPro-UTF8-V", "UniJISX0213-UTF32-H", "UniJISX0213-UTF32-V", "UniJISX02132004-UTF32-H", "UniJISX02132004-UTF32-V", "UniKS-UCS2-H", "UniKS-UCS2-V", "UniKS-UTF16-H", "UniKS-UTF16-V", "UniKS-UTF32-H", "UniKS-UTF32-V", "UniKS-UTF8-H", "UniKS-UTF8-V", "V", "WP-Symbol"];
	const MAX_MAP_RANGE = 2 ** 24 - 1;

	class CMap {
	  constructor(builtInCMap = false) {
	    this.codespaceRanges = [[], [], [], []];
	    this.numCodespaceRanges = 0;
	    this._map = [];
	    this.name = "";
	    this.vertical = false;
	    this.useCMap = null;
	    this.builtInCMap = builtInCMap;
	  }

	  addCodespaceRange(n, low, high) {
	    this.codespaceRanges[n - 1].push(low, high);
	    this.numCodespaceRanges++;
	  }

	  mapCidRange(low, high, dstLow) {
	    if (high - low > MAX_MAP_RANGE) {
	      throw new Error("mapCidRange - ignoring data above MAX_MAP_RANGE.");
	    }

	    while (low <= high) {
	      this._map[low++] = dstLow++;
	    }
	  }

	  mapBfRange(low, high, dstLow) {
	    if (high - low > MAX_MAP_RANGE) {
	      throw new Error("mapBfRange - ignoring data above MAX_MAP_RANGE.");
	    }

	    const lastByte = dstLow.length - 1;

	    while (low <= high) {
	      this._map[low++] = dstLow;
	      const nextCharCode = dstLow.charCodeAt(lastByte) + 1;

	      if (nextCharCode > 0xff) {
	        dstLow = dstLow.substring(0, lastByte - 1) + String.fromCharCode(dstLow.charCodeAt(lastByte - 1) + 1) + "\x00";
	        continue;
	      }

	      dstLow = dstLow.substring(0, lastByte) + String.fromCharCode(nextCharCode);
	    }
	  }

	  mapBfRangeToArray(low, high, array) {
	    if (high - low > MAX_MAP_RANGE) {
	      throw new Error("mapBfRangeToArray - ignoring data above MAX_MAP_RANGE.");
	    }

	    const ii = array.length;
	    let i = 0;

	    while (low <= high && i < ii) {
	      this._map[low] = array[i++];
	      ++low;
	    }
	  }

	  mapOne(src, dst) {
	    this._map[src] = dst;
	  }

	  lookup(code) {
	    return this._map[code];
	  }

	  contains(code) {
	    return this._map[code] !== undefined;
	  }

	  forEach(callback) {
	    const map = this._map;
	    const length = map.length;

	    if (length <= 0x10000) {
	      for (let i = 0; i < length; i++) {
	        if (map[i] !== undefined) {
	          callback(i, map[i]);
	        }
	      }
	    } else {
	      for (const i in map) {
	        callback(i, map[i]);
	      }
	    }
	  }

	  charCodeOf(value) {
	    const map = this._map;

	    if (map.length <= 0x10000) {
	      return map.indexOf(value);
	    }

	    for (const charCode in map) {
	      if (map[charCode] === value) {
	        return charCode | 0;
	      }
	    }

	    return -1;
	  }

	  getMap() {
	    return this._map;
	  }

	  readCharCode(str, offset, out) {
	    let c = 0;
	    const codespaceRanges = this.codespaceRanges;

	    for (let n = 0, nn = codespaceRanges.length; n < nn; n++) {
	      c = (c << 8 | str.charCodeAt(offset + n)) >>> 0;
	      const codespaceRange = codespaceRanges[n];

	      for (let k = 0, kk = codespaceRange.length; k < kk;) {
	        const low = codespaceRange[k++];
	        const high = codespaceRange[k++];

	        if (c >= low && c <= high) {
	          out.charcode = c;
	          out.length = n + 1;
	          return;
	        }
	      }
	    }

	    out.charcode = 0;
	    out.length = 1;
	  }

	  getCharCodeLength(charCode) {
	    const codespaceRanges = this.codespaceRanges;

	    for (let n = 0, nn = codespaceRanges.length; n < nn; n++) {
	      const codespaceRange = codespaceRanges[n];

	      for (let k = 0, kk = codespaceRange.length; k < kk;) {
	        const low = codespaceRange[k++];
	        const high = codespaceRange[k++];

	        if (charCode >= low && charCode <= high) {
	          return n + 1;
	        }
	      }
	    }

	    return 1;
	  }

	  get length() {
	    return this._map.length;
	  }

	  get isIdentityCMap() {
	    if (!(this.name === "Identity-H" || this.name === "Identity-V")) {
	      return false;
	    }

	    if (this._map.length !== 0x10000) {
	      return false;
	    }

	    for (let i = 0; i < 0x10000; i++) {
	      if (this._map[i] !== i) {
	        return false;
	      }
	    }

	    return true;
	  }

	}

	exports.CMap = CMap;

	class IdentityCMap extends CMap {
	  constructor(vertical, n) {
	    super();
	    this.vertical = vertical;
	    this.addCodespaceRange(n, 0, 0xffff);
	  }

	  mapCidRange(low, high, dstLow) {
	    (0, _util.unreachable)("should not call mapCidRange");
	  }

	  mapBfRange(low, high, dstLow) {
	    (0, _util.unreachable)("should not call mapBfRange");
	  }

	  mapBfRangeToArray(low, high, array) {
	    (0, _util.unreachable)("should not call mapBfRangeToArray");
	  }

	  mapOne(src, dst) {
	    (0, _util.unreachable)("should not call mapCidOne");
	  }

	  lookup(code) {
	    return Number.isInteger(code) && code <= 0xffff ? code : undefined;
	  }

	  contains(code) {
	    return Number.isInteger(code) && code <= 0xffff;
	  }

	  forEach(callback) {
	    for (let i = 0; i <= 0xffff; i++) {
	      callback(i, i);
	    }
	  }

	  charCodeOf(value) {
	    return Number.isInteger(value) && value <= 0xffff ? value : -1;
	  }

	  getMap() {
	    const map = new Array(0x10000);

	    for (let i = 0; i <= 0xffff; i++) {
	      map[i] = i;
	    }

	    return map;
	  }

	  get length() {
	    return 0x10000;
	  }

	  get isIdentityCMap() {
	    (0, _util.unreachable)("should not access .isIdentityCMap");
	  }

	}

	exports.IdentityCMap = IdentityCMap;

	const BinaryCMapReader = function BinaryCMapReaderClosure() {
	  function hexToInt(a, size) {
	    let n = 0;

	    for (let i = 0; i <= size; i++) {
	      n = n << 8 | a[i];
	    }

	    return n >>> 0;
	  }

	  function hexToStr(a, size) {
	    if (size === 1) {
	      return String.fromCharCode(a[0], a[1]);
	    }

	    if (size === 3) {
	      return String.fromCharCode(a[0], a[1], a[2], a[3]);
	    }

	    return String.fromCharCode.apply(null, a.subarray(0, size + 1));
	  }

	  function addHex(a, b, size) {
	    let c = 0;

	    for (let i = size; i >= 0; i--) {
	      c += a[i] + b[i];
	      a[i] = c & 255;
	      c >>= 8;
	    }
	  }

	  function incHex(a, size) {
	    let c = 1;

	    for (let i = size; i >= 0 && c > 0; i--) {
	      c += a[i];
	      a[i] = c & 255;
	      c >>= 8;
	    }
	  }

	  const MAX_NUM_SIZE = 16;
	  const MAX_ENCODED_NUM_SIZE = 19;

	  class BinaryCMapStream {
	    constructor(data) {
	      this.buffer = data;
	      this.pos = 0;
	      this.end = data.length;
	      this.tmpBuf = new Uint8Array(MAX_ENCODED_NUM_SIZE);
	    }

	    readByte() {
	      if (this.pos >= this.end) {
	        return -1;
	      }

	      return this.buffer[this.pos++];
	    }

	    readNumber() {
	      let n = 0;
	      let last;

	      do {
	        const b = this.readByte();

	        if (b < 0) {
	          throw new _util.FormatError("unexpected EOF in bcmap");
	        }

	        last = !(b & 0x80);
	        n = n << 7 | b & 0x7f;
	      } while (!last);

	      return n;
	    }

	    readSigned() {
	      const n = this.readNumber();
	      return n & 1 ? ~(n >>> 1) : n >>> 1;
	    }

	    readHex(num, size) {
	      num.set(this.buffer.subarray(this.pos, this.pos + size + 1));
	      this.pos += size + 1;
	    }

	    readHexNumber(num, size) {
	      let last;
	      const stack = this.tmpBuf;
	      let sp = 0;

	      do {
	        const b = this.readByte();

	        if (b < 0) {
	          throw new _util.FormatError("unexpected EOF in bcmap");
	        }

	        last = !(b & 0x80);
	        stack[sp++] = b & 0x7f;
	      } while (!last);

	      let i = size,
	          buffer = 0,
	          bufferSize = 0;

	      while (i >= 0) {
	        while (bufferSize < 8 && stack.length > 0) {
	          buffer |= stack[--sp] << bufferSize;
	          bufferSize += 7;
	        }

	        num[i] = buffer & 255;
	        i--;
	        buffer >>= 8;
	        bufferSize -= 8;
	      }
	    }

	    readHexSigned(num, size) {
	      this.readHexNumber(num, size);
	      const sign = num[size] & 1 ? 255 : 0;
	      let c = 0;

	      for (let i = 0; i <= size; i++) {
	        c = (c & 1) << 8 | num[i];
	        num[i] = c >> 1 ^ sign;
	      }
	    }

	    readString() {
	      const len = this.readNumber();
	      let s = "";

	      for (let i = 0; i < len; i++) {
	        s += String.fromCharCode(this.readNumber());
	      }

	      return s;
	    }

	  }

	  class BinaryCMapReader {
	    async process(data, cMap, extend) {
	      const stream = new BinaryCMapStream(data);
	      const header = stream.readByte();
	      cMap.vertical = !!(header & 1);
	      let useCMap = null;
	      const start = new Uint8Array(MAX_NUM_SIZE);
	      const end = new Uint8Array(MAX_NUM_SIZE);
	      const char = new Uint8Array(MAX_NUM_SIZE);
	      const charCode = new Uint8Array(MAX_NUM_SIZE);
	      const tmp = new Uint8Array(MAX_NUM_SIZE);
	      let code;
	      let b;

	      while ((b = stream.readByte()) >= 0) {
	        const type = b >> 5;

	        if (type === 7) {
	          switch (b & 0x1f) {
	            case 0:
	              stream.readString();
	              break;

	            case 1:
	              useCMap = stream.readString();
	              break;
	          }

	          continue;
	        }

	        const sequence = !!(b & 0x10);
	        const dataSize = b & 15;

	        if (dataSize + 1 > MAX_NUM_SIZE) {
	          throw new Error("BinaryCMapReader.process: Invalid dataSize.");
	        }

	        const ucs2DataSize = 1;
	        const subitemsCount = stream.readNumber();

	        switch (type) {
	          case 0:
	            stream.readHex(start, dataSize);
	            stream.readHexNumber(end, dataSize);
	            addHex(end, start, dataSize);
	            cMap.addCodespaceRange(dataSize + 1, hexToInt(start, dataSize), hexToInt(end, dataSize));

	            for (let i = 1; i < subitemsCount; i++) {
	              incHex(end, dataSize);
	              stream.readHexNumber(start, dataSize);
	              addHex(start, end, dataSize);
	              stream.readHexNumber(end, dataSize);
	              addHex(end, start, dataSize);
	              cMap.addCodespaceRange(dataSize + 1, hexToInt(start, dataSize), hexToInt(end, dataSize));
	            }

	            break;

	          case 1:
	            stream.readHex(start, dataSize);
	            stream.readHexNumber(end, dataSize);
	            addHex(end, start, dataSize);
	            stream.readNumber();

	            for (let i = 1; i < subitemsCount; i++) {
	              incHex(end, dataSize);
	              stream.readHexNumber(start, dataSize);
	              addHex(start, end, dataSize);
	              stream.readHexNumber(end, dataSize);
	              addHex(end, start, dataSize);
	              stream.readNumber();
	            }

	            break;

	          case 2:
	            stream.readHex(char, dataSize);
	            code = stream.readNumber();
	            cMap.mapOne(hexToInt(char, dataSize), code);

	            for (let i = 1; i < subitemsCount; i++) {
	              incHex(char, dataSize);

	              if (!sequence) {
	                stream.readHexNumber(tmp, dataSize);
	                addHex(char, tmp, dataSize);
	              }

	              code = stream.readSigned() + (code + 1);
	              cMap.mapOne(hexToInt(char, dataSize), code);
	            }

	            break;

	          case 3:
	            stream.readHex(start, dataSize);
	            stream.readHexNumber(end, dataSize);
	            addHex(end, start, dataSize);
	            code = stream.readNumber();
	            cMap.mapCidRange(hexToInt(start, dataSize), hexToInt(end, dataSize), code);

	            for (let i = 1; i < subitemsCount; i++) {
	              incHex(end, dataSize);

	              if (!sequence) {
	                stream.readHexNumber(start, dataSize);
	                addHex(start, end, dataSize);
	              } else {
	                start.set(end);
	              }

	              stream.readHexNumber(end, dataSize);
	              addHex(end, start, dataSize);
	              code = stream.readNumber();
	              cMap.mapCidRange(hexToInt(start, dataSize), hexToInt(end, dataSize), code);
	            }

	            break;

	          case 4:
	            stream.readHex(char, ucs2DataSize);
	            stream.readHex(charCode, dataSize);
	            cMap.mapOne(hexToInt(char, ucs2DataSize), hexToStr(charCode, dataSize));

	            for (let i = 1; i < subitemsCount; i++) {
	              incHex(char, ucs2DataSize);

	              if (!sequence) {
	                stream.readHexNumber(tmp, ucs2DataSize);
	                addHex(char, tmp, ucs2DataSize);
	              }

	              incHex(charCode, dataSize);
	              stream.readHexSigned(tmp, dataSize);
	              addHex(charCode, tmp, dataSize);
	              cMap.mapOne(hexToInt(char, ucs2DataSize), hexToStr(charCode, dataSize));
	            }

	            break;

	          case 5:
	            stream.readHex(start, ucs2DataSize);
	            stream.readHexNumber(end, ucs2DataSize);
	            addHex(end, start, ucs2DataSize);
	            stream.readHex(charCode, dataSize);
	            cMap.mapBfRange(hexToInt(start, ucs2DataSize), hexToInt(end, ucs2DataSize), hexToStr(charCode, dataSize));

	            for (let i = 1; i < subitemsCount; i++) {
	              incHex(end, ucs2DataSize);

	              if (!sequence) {
	                stream.readHexNumber(start, ucs2DataSize);
	                addHex(start, end, ucs2DataSize);
	              } else {
	                start.set(end);
	              }

	              stream.readHexNumber(end, ucs2DataSize);
	              addHex(end, start, ucs2DataSize);
	              stream.readHex(charCode, dataSize);
	              cMap.mapBfRange(hexToInt(start, ucs2DataSize), hexToInt(end, ucs2DataSize), hexToStr(charCode, dataSize));
	            }

	            break;

	          default:
	            throw new Error(`BinaryCMapReader.process - unknown type: ${type}`);
	        }
	      }

	      if (useCMap) {
	        return extend(useCMap);
	      }

	      return cMap;
	    }

	  }

	  return BinaryCMapReader;
	}();

	const CMapFactory = function CMapFactoryClosure() {
	  function strToInt(str) {
	    let a = 0;

	    for (let i = 0; i < str.length; i++) {
	      a = a << 8 | str.charCodeAt(i);
	    }

	    return a >>> 0;
	  }

	  function expectString(obj) {
	    if (typeof obj !== "string") {
	      throw new _util.FormatError("Malformed CMap: expected string.");
	    }
	  }

	  function expectInt(obj) {
	    if (!Number.isInteger(obj)) {
	      throw new _util.FormatError("Malformed CMap: expected int.");
	    }
	  }

	  function parseBfChar(cMap, lexer) {
	    while (true) {
	      let obj = lexer.getObj();

	      if (obj === _primitives.EOF) {
	        break;
	      }

	      if ((0, _primitives.isCmd)(obj, "endbfchar")) {
	        return;
	      }

	      expectString(obj);
	      const src = strToInt(obj);
	      obj = lexer.getObj();
	      expectString(obj);
	      const dst = obj;
	      cMap.mapOne(src, dst);
	    }
	  }

	  function parseBfRange(cMap, lexer) {
	    while (true) {
	      let obj = lexer.getObj();

	      if (obj === _primitives.EOF) {
	        break;
	      }

	      if ((0, _primitives.isCmd)(obj, "endbfrange")) {
	        return;
	      }

	      expectString(obj);
	      const low = strToInt(obj);
	      obj = lexer.getObj();
	      expectString(obj);
	      const high = strToInt(obj);
	      obj = lexer.getObj();

	      if (Number.isInteger(obj) || typeof obj === "string") {
	        const dstLow = Number.isInteger(obj) ? String.fromCharCode(obj) : obj;
	        cMap.mapBfRange(low, high, dstLow);
	      } else if ((0, _primitives.isCmd)(obj, "[")) {
	        obj = lexer.getObj();
	        const array = [];

	        while (!(0, _primitives.isCmd)(obj, "]") && obj !== _primitives.EOF) {
	          array.push(obj);
	          obj = lexer.getObj();
	        }

	        cMap.mapBfRangeToArray(low, high, array);
	      } else {
	        break;
	      }
	    }

	    throw new _util.FormatError("Invalid bf range.");
	  }

	  function parseCidChar(cMap, lexer) {
	    while (true) {
	      let obj = lexer.getObj();

	      if (obj === _primitives.EOF) {
	        break;
	      }

	      if ((0, _primitives.isCmd)(obj, "endcidchar")) {
	        return;
	      }

	      expectString(obj);
	      const src = strToInt(obj);
	      obj = lexer.getObj();
	      expectInt(obj);
	      const dst = obj;
	      cMap.mapOne(src, dst);
	    }
	  }

	  function parseCidRange(cMap, lexer) {
	    while (true) {
	      let obj = lexer.getObj();

	      if (obj === _primitives.EOF) {
	        break;
	      }

	      if ((0, _primitives.isCmd)(obj, "endcidrange")) {
	        return;
	      }

	      expectString(obj);
	      const low = strToInt(obj);
	      obj = lexer.getObj();
	      expectString(obj);
	      const high = strToInt(obj);
	      obj = lexer.getObj();
	      expectInt(obj);
	      const dstLow = obj;
	      cMap.mapCidRange(low, high, dstLow);
	    }
	  }

	  function parseCodespaceRange(cMap, lexer) {
	    while (true) {
	      let obj = lexer.getObj();

	      if (obj === _primitives.EOF) {
	        break;
	      }

	      if ((0, _primitives.isCmd)(obj, "endcodespacerange")) {
	        return;
	      }

	      if (typeof obj !== "string") {
	        break;
	      }

	      const low = strToInt(obj);
	      obj = lexer.getObj();

	      if (typeof obj !== "string") {
	        break;
	      }

	      const high = strToInt(obj);
	      cMap.addCodespaceRange(obj.length, low, high);
	    }

	    throw new _util.FormatError("Invalid codespace range.");
	  }

	  function parseWMode(cMap, lexer) {
	    const obj = lexer.getObj();

	    if (Number.isInteger(obj)) {
	      cMap.vertical = !!obj;
	    }
	  }

	  function parseCMapName(cMap, lexer) {
	    const obj = lexer.getObj();

	    if (obj instanceof _primitives.Name) {
	      cMap.name = obj.name;
	    }
	  }

	  async function parseCMap(cMap, lexer, fetchBuiltInCMap, useCMap) {
	    let previous, embeddedUseCMap;

	    objLoop: while (true) {
	      try {
	        const obj = lexer.getObj();

	        if (obj === _primitives.EOF) {
	          break;
	        } else if (obj instanceof _primitives.Name) {
	          if (obj.name === "WMode") {
	            parseWMode(cMap, lexer);
	          } else if (obj.name === "CMapName") {
	            parseCMapName(cMap, lexer);
	          }

	          previous = obj;
	        } else if (obj instanceof _primitives.Cmd) {
	          switch (obj.cmd) {
	            case "endcmap":
	              break objLoop;

	            case "usecmap":
	              if (previous instanceof _primitives.Name) {
	                embeddedUseCMap = previous.name;
	              }

	              break;

	            case "begincodespacerange":
	              parseCodespaceRange(cMap, lexer);
	              break;

	            case "beginbfchar":
	              parseBfChar(cMap, lexer);
	              break;

	            case "begincidchar":
	              parseCidChar(cMap, lexer);
	              break;

	            case "beginbfrange":
	              parseBfRange(cMap, lexer);
	              break;

	            case "begincidrange":
	              parseCidRange(cMap, lexer);
	              break;
	          }
	        }
	      } catch (ex) {
	        if (ex instanceof _core_utils.MissingDataException) {
	          throw ex;
	        }

	        (0, _util.warn)("Invalid cMap data: " + ex);
	        continue;
	      }
	    }

	    if (!useCMap && embeddedUseCMap) {
	      useCMap = embeddedUseCMap;
	    }

	    if (useCMap) {
	      return extendCMap(cMap, fetchBuiltInCMap, useCMap);
	    }

	    return cMap;
	  }

	  async function extendCMap(cMap, fetchBuiltInCMap, useCMap) {
	    cMap.useCMap = await createBuiltInCMap(useCMap, fetchBuiltInCMap);

	    if (cMap.numCodespaceRanges === 0) {
	      const useCodespaceRanges = cMap.useCMap.codespaceRanges;

	      for (let i = 0; i < useCodespaceRanges.length; i++) {
	        cMap.codespaceRanges[i] = useCodespaceRanges[i].slice();
	      }

	      cMap.numCodespaceRanges = cMap.useCMap.numCodespaceRanges;
	    }

	    cMap.useCMap.forEach(function (key, value) {
	      if (!cMap.contains(key)) {
	        cMap.mapOne(key, cMap.useCMap.lookup(key));
	      }
	    });
	    return cMap;
	  }

	  async function createBuiltInCMap(name, fetchBuiltInCMap) {
	    if (name === "Identity-H") {
	      return new IdentityCMap(false, 2);
	    } else if (name === "Identity-V") {
	      return new IdentityCMap(true, 2);
	    }

	    if (!BUILT_IN_CMAPS.includes(name)) {
	      throw new Error("Unknown CMap name: " + name);
	    }

	    if (!fetchBuiltInCMap) {
	      throw new Error("Built-in CMap parameters are not provided.");
	    }

	    const {
	      cMapData,
	      compressionType
	    } = await fetchBuiltInCMap(name);
	    const cMap = new CMap(true);

	    if (compressionType === _util.CMapCompressionType.BINARY) {
	      return new BinaryCMapReader().process(cMapData, cMap, useCMap => {
	        return extendCMap(cMap, fetchBuiltInCMap, useCMap);
	      });
	    }

	    if (compressionType === _util.CMapCompressionType.NONE) {
	      const lexer = new _parser.Lexer(new _stream.Stream(cMapData));
	      return parseCMap(cMap, lexer, fetchBuiltInCMap, null);
	    }

	    throw new Error("TODO: Only BINARY/NONE CMap compression is currently supported.");
	  }

	  return {
	    async create(params) {
	      const encoding = params.encoding;
	      const fetchBuiltInCMap = params.fetchBuiltInCMap;
	      const useCMap = params.useCMap;

	      if (encoding instanceof _primitives.Name) {
	        return createBuiltInCMap(encoding.name, fetchBuiltInCMap);
	      } else if (encoding instanceof _base_stream.BaseStream) {
	        const parsedCMap = await parseCMap(new CMap(), new _parser.Lexer(encoding), fetchBuiltInCMap, useCMap);

	        if (parsedCMap.isIdentityCMap) {
	          return createBuiltInCMap(parsedCMap.name, fetchBuiltInCMap);
	        }

	        return parsedCMap;
	      }

	      throw new Error("Encoding required.");
	    }

	  };
	}();

	exports.CMapFactory = CMapFactory;

	/***/ }),
	/* 17 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Parser = exports.Linearization = exports.Lexer = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _core_utils = __w_pdfjs_require__(6);

	var _ascii_85_stream = __w_pdfjs_require__(18);

	var _ascii_hex_stream = __w_pdfjs_require__(20);

	var _ccitt_stream = __w_pdfjs_require__(21);

	var _flate_stream = __w_pdfjs_require__(23);

	var _jbig2_stream = __w_pdfjs_require__(24);

	var _jpeg_stream = __w_pdfjs_require__(27);

	var _jpx_stream = __w_pdfjs_require__(29);

	var _lzw_stream = __w_pdfjs_require__(31);

	var _stream = __w_pdfjs_require__(10);

	var _predictor_stream = __w_pdfjs_require__(32);

	var _run_length_stream = __w_pdfjs_require__(33);

	const MAX_LENGTH_TO_CACHE = 1000;
	const MAX_ADLER32_LENGTH = 5552;

	function computeAdler32(bytes) {
	  const bytesLength = bytes.length;
	  let a = 1,
	      b = 0;

	  for (let i = 0; i < bytesLength; ++i) {
	    a += bytes[i] & 0xff;
	    b += a;
	  }

	  return b % 65521 << 16 | a % 65521;
	}

	class Parser {
	  constructor({
	    lexer,
	    xref,
	    allowStreams = false,
	    recoveryMode = false
	  }) {
	    this.lexer = lexer;
	    this.xref = xref;
	    this.allowStreams = allowStreams;
	    this.recoveryMode = recoveryMode;
	    this.imageCache = Object.create(null);
	    this.refill();
	  }

	  refill() {
	    this.buf1 = this.lexer.getObj();
	    this.buf2 = this.lexer.getObj();
	  }

	  shift() {
	    if (this.buf2 instanceof _primitives.Cmd && this.buf2.cmd === "ID") {
	      this.buf1 = this.buf2;
	      this.buf2 = null;
	    } else {
	      this.buf1 = this.buf2;
	      this.buf2 = this.lexer.getObj();
	    }
	  }

	  tryShift() {
	    try {
	      this.shift();
	      return true;
	    } catch (e) {
	      if (e instanceof _core_utils.MissingDataException) {
	        throw e;
	      }

	      return false;
	    }
	  }

	  getObj(cipherTransform = null) {
	    const buf1 = this.buf1;
	    this.shift();

	    if (buf1 instanceof _primitives.Cmd) {
	      switch (buf1.cmd) {
	        case "BI":
	          return this.makeInlineImage(cipherTransform);

	        case "[":
	          const array = [];

	          while (!(0, _primitives.isCmd)(this.buf1, "]") && this.buf1 !== _primitives.EOF) {
	            array.push(this.getObj(cipherTransform));
	          }

	          if (this.buf1 === _primitives.EOF) {
	            if (this.recoveryMode) {
	              return array;
	            }

	            throw new _core_utils.ParserEOFException("End of file inside array.");
	          }

	          this.shift();
	          return array;

	        case "<<":
	          const dict = new _primitives.Dict(this.xref);

	          while (!(0, _primitives.isCmd)(this.buf1, ">>") && this.buf1 !== _primitives.EOF) {
	            if (!(this.buf1 instanceof _primitives.Name)) {
	              (0, _util.info)("Malformed dictionary: key must be a name object");
	              this.shift();
	              continue;
	            }

	            const key = this.buf1.name;
	            this.shift();

	            if (this.buf1 === _primitives.EOF) {
	              break;
	            }

	            dict.set(key, this.getObj(cipherTransform));
	          }

	          if (this.buf1 === _primitives.EOF) {
	            if (this.recoveryMode) {
	              return dict;
	            }

	            throw new _core_utils.ParserEOFException("End of file inside dictionary.");
	          }

	          if ((0, _primitives.isCmd)(this.buf2, "stream")) {
	            return this.allowStreams ? this.makeStream(dict, cipherTransform) : dict;
	          }

	          this.shift();
	          return dict;

	        default:
	          return buf1;
	      }
	    }

	    if (Number.isInteger(buf1)) {
	      if (Number.isInteger(this.buf1) && (0, _primitives.isCmd)(this.buf2, "R")) {
	        const ref = _primitives.Ref.get(buf1, this.buf1);

	        this.shift();
	        this.shift();
	        return ref;
	      }

	      return buf1;
	    }

	    if (typeof buf1 === "string") {
	      if (cipherTransform) {
	        return cipherTransform.decryptString(buf1);
	      }

	      return buf1;
	    }

	    return buf1;
	  }

	  findDefaultInlineStreamEnd(stream) {
	    const E = 0x45,
	          I = 0x49,
	          SPACE = 0x20,
	          LF = 0xa,
	          CR = 0xd,
	          NUL = 0x0;
	    const lexer = this.lexer,
	          startPos = stream.pos,
	          n = 10;
	    let state = 0,
	        ch,
	        maybeEIPos;

	    while ((ch = stream.getByte()) !== -1) {
	      if (state === 0) {
	        state = ch === E ? 1 : 0;
	      } else if (state === 1) {
	        state = ch === I ? 2 : 0;
	      } else {
	        (0, _util.assert)(state === 2, "findDefaultInlineStreamEnd - invalid state.");

	        if (ch === SPACE || ch === LF || ch === CR) {
	          maybeEIPos = stream.pos;
	          const followingBytes = stream.peekBytes(n);

	          for (let i = 0, ii = followingBytes.length; i < ii; i++) {
	            ch = followingBytes[i];

	            if (ch === NUL && followingBytes[i + 1] !== NUL) {
	              continue;
	            }

	            if (ch !== LF && ch !== CR && (ch < SPACE || ch > 0x7f)) {
	              state = 0;
	              break;
	            }
	          }

	          if (state !== 2) {
	            continue;
	          }

	          if (lexer.knownCommands) {
	            const nextObj = lexer.peekObj();

	            if (nextObj instanceof _primitives.Cmd && !lexer.knownCommands[nextObj.cmd]) {
	              state = 0;
	            }
	          } else {
	            (0, _util.warn)("findDefaultInlineStreamEnd - `lexer.knownCommands` is undefined.");
	          }

	          if (state === 2) {
	            break;
	          }
	        } else {
	          state = 0;
	        }
	      }
	    }

	    if (ch === -1) {
	      (0, _util.warn)("findDefaultInlineStreamEnd: " + "Reached the end of the stream without finding a valid EI marker");

	      if (maybeEIPos) {
	        (0, _util.warn)('... trying to recover by using the last "EI" occurrence.');
	        stream.skip(-(stream.pos - maybeEIPos));
	      }
	    }

	    let endOffset = 4;
	    stream.skip(-endOffset);
	    ch = stream.peekByte();
	    stream.skip(endOffset);

	    if (!(0, _core_utils.isWhiteSpace)(ch)) {
	      endOffset--;
	    }

	    return stream.pos - endOffset - startPos;
	  }

	  findDCTDecodeInlineStreamEnd(stream) {
	    const startPos = stream.pos;
	    let foundEOI = false,
	        b,
	        markerLength;

	    while ((b = stream.getByte()) !== -1) {
	      if (b !== 0xff) {
	        continue;
	      }

	      switch (stream.getByte()) {
	        case 0x00:
	          break;

	        case 0xff:
	          stream.skip(-1);
	          break;

	        case 0xd9:
	          foundEOI = true;
	          break;

	        case 0xc0:
	        case 0xc1:
	        case 0xc2:
	        case 0xc3:
	        case 0xc5:
	        case 0xc6:
	        case 0xc7:
	        case 0xc9:
	        case 0xca:
	        case 0xcb:
	        case 0xcd:
	        case 0xce:
	        case 0xcf:
	        case 0xc4:
	        case 0xcc:
	        case 0xda:
	        case 0xdb:
	        case 0xdc:
	        case 0xdd:
	        case 0xde:
	        case 0xdf:
	        case 0xe0:
	        case 0xe1:
	        case 0xe2:
	        case 0xe3:
	        case 0xe4:
	        case 0xe5:
	        case 0xe6:
	        case 0xe7:
	        case 0xe8:
	        case 0xe9:
	        case 0xea:
	        case 0xeb:
	        case 0xec:
	        case 0xed:
	        case 0xee:
	        case 0xef:
	        case 0xfe:
	          markerLength = stream.getUint16();

	          if (markerLength > 2) {
	            stream.skip(markerLength - 2);
	          } else {
	            stream.skip(-2);
	          }

	          break;
	      }

	      if (foundEOI) {
	        break;
	      }
	    }

	    const length = stream.pos - startPos;

	    if (b === -1) {
	      (0, _util.warn)("Inline DCTDecode image stream: " + "EOI marker not found, searching for /EI/ instead.");
	      stream.skip(-length);
	      return this.findDefaultInlineStreamEnd(stream);
	    }

	    this.inlineStreamSkipEI(stream);
	    return length;
	  }

	  findASCII85DecodeInlineStreamEnd(stream) {
	    const TILDE = 0x7e,
	          GT = 0x3e;
	    const startPos = stream.pos;
	    let ch;

	    while ((ch = stream.getByte()) !== -1) {
	      if (ch === TILDE) {
	        const tildePos = stream.pos;
	        ch = stream.peekByte();

	        while ((0, _core_utils.isWhiteSpace)(ch)) {
	          stream.skip();
	          ch = stream.peekByte();
	        }

	        if (ch === GT) {
	          stream.skip();
	          break;
	        }

	        if (stream.pos > tildePos) {
	          const maybeEI = stream.peekBytes(2);

	          if (maybeEI[0] === 0x45 && maybeEI[1] === 0x49) {
	            break;
	          }
	        }
	      }
	    }

	    const length = stream.pos - startPos;

	    if (ch === -1) {
	      (0, _util.warn)("Inline ASCII85Decode image stream: " + "EOD marker not found, searching for /EI/ instead.");
	      stream.skip(-length);
	      return this.findDefaultInlineStreamEnd(stream);
	    }

	    this.inlineStreamSkipEI(stream);
	    return length;
	  }

	  findASCIIHexDecodeInlineStreamEnd(stream) {
	    const GT = 0x3e;
	    const startPos = stream.pos;
	    let ch;

	    while ((ch = stream.getByte()) !== -1) {
	      if (ch === GT) {
	        break;
	      }
	    }

	    const length = stream.pos - startPos;

	    if (ch === -1) {
	      (0, _util.warn)("Inline ASCIIHexDecode image stream: " + "EOD marker not found, searching for /EI/ instead.");
	      stream.skip(-length);
	      return this.findDefaultInlineStreamEnd(stream);
	    }

	    this.inlineStreamSkipEI(stream);
	    return length;
	  }

	  inlineStreamSkipEI(stream) {
	    const E = 0x45,
	          I = 0x49;
	    let state = 0,
	        ch;

	    while ((ch = stream.getByte()) !== -1) {
	      if (state === 0) {
	        state = ch === E ? 1 : 0;
	      } else if (state === 1) {
	        state = ch === I ? 2 : 0;
	      } else if (state === 2) {
	        break;
	      }
	    }
	  }

	  makeInlineImage(cipherTransform) {
	    const lexer = this.lexer;
	    const stream = lexer.stream;
	    const dict = new _primitives.Dict(this.xref);
	    let dictLength;

	    while (!(0, _primitives.isCmd)(this.buf1, "ID") && this.buf1 !== _primitives.EOF) {
	      if (!(this.buf1 instanceof _primitives.Name)) {
	        throw new _util.FormatError("Dictionary key must be a name object");
	      }

	      const key = this.buf1.name;
	      this.shift();

	      if (this.buf1 === _primitives.EOF) {
	        break;
	      }

	      dict.set(key, this.getObj(cipherTransform));
	    }

	    if (lexer.beginInlineImagePos !== -1) {
	      dictLength = stream.pos - lexer.beginInlineImagePos;
	    }

	    const filter = dict.get("F", "Filter");
	    let filterName;

	    if (filter instanceof _primitives.Name) {
	      filterName = filter.name;
	    } else if (Array.isArray(filter)) {
	      const filterZero = this.xref.fetchIfRef(filter[0]);

	      if (filterZero instanceof _primitives.Name) {
	        filterName = filterZero.name;
	      }
	    }

	    const startPos = stream.pos;
	    let length;

	    switch (filterName) {
	      case "DCT":
	      case "DCTDecode":
	        length = this.findDCTDecodeInlineStreamEnd(stream);
	        break;

	      case "A85":
	      case "ASCII85Decode":
	        length = this.findASCII85DecodeInlineStreamEnd(stream);
	        break;

	      case "AHx":
	      case "ASCIIHexDecode":
	        length = this.findASCIIHexDecodeInlineStreamEnd(stream);
	        break;

	      default:
	        length = this.findDefaultInlineStreamEnd(stream);
	    }

	    let imageStream = stream.makeSubStream(startPos, length, dict);
	    let cacheKey;

	    if (length < MAX_LENGTH_TO_CACHE && dictLength < MAX_ADLER32_LENGTH) {
	      const imageBytes = imageStream.getBytes();
	      imageStream.reset();
	      const initialStreamPos = stream.pos;
	      stream.pos = lexer.beginInlineImagePos;
	      const dictBytes = stream.getBytes(dictLength);
	      stream.pos = initialStreamPos;
	      cacheKey = computeAdler32(imageBytes) + "_" + computeAdler32(dictBytes);
	      const cacheEntry = this.imageCache[cacheKey];

	      if (cacheEntry !== undefined) {
	        this.buf2 = _primitives.Cmd.get("EI");
	        this.shift();
	        cacheEntry.reset();
	        return cacheEntry;
	      }
	    }

	    if (cipherTransform) {
	      imageStream = cipherTransform.createStream(imageStream, length);
	    }

	    imageStream = this.filter(imageStream, dict, length);
	    imageStream.dict = dict;

	    if (cacheKey !== undefined) {
	      imageStream.cacheKey = `inline_${length}_${cacheKey}`;
	      this.imageCache[cacheKey] = imageStream;
	    }

	    this.buf2 = _primitives.Cmd.get("EI");
	    this.shift();
	    return imageStream;
	  }

	  _findStreamLength(startPos, signature) {
	    const {
	      stream
	    } = this.lexer;
	    stream.pos = startPos;
	    const SCAN_BLOCK_LENGTH = 2048;
	    const signatureLength = signature.length;

	    while (stream.pos < stream.end) {
	      const scanBytes = stream.peekBytes(SCAN_BLOCK_LENGTH);
	      const scanLength = scanBytes.length - signatureLength;

	      if (scanLength <= 0) {
	        break;
	      }

	      let pos = 0;

	      while (pos < scanLength) {
	        let j = 0;

	        while (j < signatureLength && scanBytes[pos + j] === signature[j]) {
	          j++;
	        }

	        if (j >= signatureLength) {
	          stream.pos += pos;
	          return stream.pos - startPos;
	        }

	        pos++;
	      }

	      stream.pos += scanLength;
	    }

	    return -1;
	  }

	  makeStream(dict, cipherTransform) {
	    const lexer = this.lexer;
	    let stream = lexer.stream;
	    lexer.skipToNextLine();
	    const startPos = stream.pos - 1;
	    let length = dict.get("Length");

	    if (!Number.isInteger(length)) {
	      (0, _util.info)(`Bad length "${length && length.toString()}" in stream.`);
	      length = 0;
	    }

	    stream.pos = startPos + length;
	    lexer.nextChar();

	    if (this.tryShift() && (0, _primitives.isCmd)(this.buf2, "endstream")) {
	      this.shift();
	    } else {
	      const ENDSTREAM_SIGNATURE = new Uint8Array([0x65, 0x6e, 0x64, 0x73, 0x74, 0x72, 0x65, 0x61, 0x6d]);

	      let actualLength = this._findStreamLength(startPos, ENDSTREAM_SIGNATURE);

	      if (actualLength < 0) {
	        const MAX_TRUNCATION = 1;

	        for (let i = 1; i <= MAX_TRUNCATION; i++) {
	          const end = ENDSTREAM_SIGNATURE.length - i;
	          const TRUNCATED_SIGNATURE = ENDSTREAM_SIGNATURE.slice(0, end);

	          const maybeLength = this._findStreamLength(startPos, TRUNCATED_SIGNATURE);

	          if (maybeLength >= 0) {
	            const lastByte = stream.peekBytes(end + 1)[end];

	            if (!(0, _core_utils.isWhiteSpace)(lastByte)) {
	              break;
	            }

	            (0, _util.info)(`Found "${(0, _util.bytesToString)(TRUNCATED_SIGNATURE)}" when ` + "searching for endstream command.");
	            actualLength = maybeLength;
	            break;
	          }
	        }

	        if (actualLength < 0) {
	          throw new _util.FormatError("Missing endstream command.");
	        }
	      }

	      length = actualLength;
	      lexer.nextChar();
	      this.shift();
	      this.shift();
	    }

	    this.shift();
	    stream = stream.makeSubStream(startPos, length, dict);

	    if (cipherTransform) {
	      stream = cipherTransform.createStream(stream, length);
	    }

	    stream = this.filter(stream, dict, length);
	    stream.dict = dict;
	    return stream;
	  }

	  filter(stream, dict, length) {
	    let filter = dict.get("F", "Filter");
	    let params = dict.get("DP", "DecodeParms");

	    if (filter instanceof _primitives.Name) {
	      if (Array.isArray(params)) {
	        (0, _util.warn)("/DecodeParms should not be an Array, when /Filter is a Name.");
	      }

	      return this.makeFilter(stream, filter.name, length, params);
	    }

	    let maybeLength = length;

	    if (Array.isArray(filter)) {
	      const filterArray = filter;
	      const paramsArray = params;

	      for (let i = 0, ii = filterArray.length; i < ii; ++i) {
	        filter = this.xref.fetchIfRef(filterArray[i]);

	        if (!(filter instanceof _primitives.Name)) {
	          throw new _util.FormatError(`Bad filter name "${filter}"`);
	        }

	        params = null;

	        if (Array.isArray(paramsArray) && i in paramsArray) {
	          params = this.xref.fetchIfRef(paramsArray[i]);
	        }

	        stream = this.makeFilter(stream, filter.name, maybeLength, params);
	        maybeLength = null;
	      }
	    }

	    return stream;
	  }

	  makeFilter(stream, name, maybeLength, params) {
	    if (maybeLength === 0) {
	      (0, _util.warn)(`Empty "${name}" stream.`);
	      return new _stream.NullStream();
	    }

	    const xrefStats = this.xref.stats;

	    try {
	      switch (name) {
	        case "Fl":
	        case "FlateDecode":
	          xrefStats.addStreamType(_util.StreamType.FLATE);

	          if (params) {
	            return new _predictor_stream.PredictorStream(new _flate_stream.FlateStream(stream, maybeLength), maybeLength, params);
	          }

	          return new _flate_stream.FlateStream(stream, maybeLength);

	        case "LZW":
	        case "LZWDecode":
	          xrefStats.addStreamType(_util.StreamType.LZW);
	          let earlyChange = 1;

	          if (params) {
	            if (params.has("EarlyChange")) {
	              earlyChange = params.get("EarlyChange");
	            }

	            return new _predictor_stream.PredictorStream(new _lzw_stream.LZWStream(stream, maybeLength, earlyChange), maybeLength, params);
	          }

	          return new _lzw_stream.LZWStream(stream, maybeLength, earlyChange);

	        case "DCT":
	        case "DCTDecode":
	          xrefStats.addStreamType(_util.StreamType.DCT);
	          return new _jpeg_stream.JpegStream(stream, maybeLength, params);

	        case "JPX":
	        case "JPXDecode":
	          xrefStats.addStreamType(_util.StreamType.JPX);
	          return new _jpx_stream.JpxStream(stream, maybeLength, params);

	        case "A85":
	        case "ASCII85Decode":
	          xrefStats.addStreamType(_util.StreamType.A85);
	          return new _ascii_85_stream.Ascii85Stream(stream, maybeLength);

	        case "AHx":
	        case "ASCIIHexDecode":
	          xrefStats.addStreamType(_util.StreamType.AHX);
	          return new _ascii_hex_stream.AsciiHexStream(stream, maybeLength);

	        case "CCF":
	        case "CCITTFaxDecode":
	          xrefStats.addStreamType(_util.StreamType.CCF);
	          return new _ccitt_stream.CCITTFaxStream(stream, maybeLength, params);

	        case "RL":
	        case "RunLengthDecode":
	          xrefStats.addStreamType(_util.StreamType.RLX);
	          return new _run_length_stream.RunLengthStream(stream, maybeLength);

	        case "JBIG2Decode":
	          xrefStats.addStreamType(_util.StreamType.JBIG);
	          return new _jbig2_stream.Jbig2Stream(stream, maybeLength, params);
	      }

	      (0, _util.warn)(`Filter "${name}" is not supported.`);
	      return stream;
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)(`Invalid stream: "${ex}"`);
	      return new _stream.NullStream();
	    }
	  }

	}

	exports.Parser = Parser;
	const specialChars = [1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 2, 0, 0, 2, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];

	function toHexDigit(ch) {
	  if (ch >= 0x30 && ch <= 0x39) {
	    return ch & 0x0f;
	  }

	  if (ch >= 0x41 && ch <= 0x46 || ch >= 0x61 && ch <= 0x66) {
	    return (ch & 0x0f) + 9;
	  }

	  return -1;
	}

	class Lexer {
	  constructor(stream, knownCommands = null) {
	    this.stream = stream;
	    this.nextChar();
	    this.strBuf = [];
	    this.knownCommands = knownCommands;
	    this._hexStringNumWarn = 0;
	    this.beginInlineImagePos = -1;
	  }

	  nextChar() {
	    return this.currentChar = this.stream.getByte();
	  }

	  peekChar() {
	    return this.stream.peekByte();
	  }

	  getNumber() {
	    let ch = this.currentChar;
	    let eNotation = false;
	    let divideBy = 0;
	    let sign = 0;

	    if (ch === 0x2d) {
	      sign = -1;
	      ch = this.nextChar();

	      if (ch === 0x2d) {
	        ch = this.nextChar();
	      }
	    } else if (ch === 0x2b) {
	      sign = 1;
	      ch = this.nextChar();
	    }

	    if (ch === 0x0a || ch === 0x0d) {
	      do {
	        ch = this.nextChar();
	      } while (ch === 0x0a || ch === 0x0d);
	    }

	    if (ch === 0x2e) {
	      divideBy = 10;
	      ch = this.nextChar();
	    }

	    if (ch < 0x30 || ch > 0x39) {
	      if ((0, _core_utils.isWhiteSpace)(ch) || ch === -1) {
	        if (divideBy === 10 && sign === 0) {
	          (0, _util.warn)("Lexer.getNumber - treating a single decimal point as zero.");
	          return 0;
	        }

	        if (divideBy === 0 && sign === -1) {
	          (0, _util.warn)("Lexer.getNumber - treating a single minus sign as zero.");
	          return 0;
	        }
	      }

	      throw new _util.FormatError(`Invalid number: ${String.fromCharCode(ch)} (charCode ${ch})`);
	    }

	    sign = sign || 1;
	    let baseValue = ch - 0x30;
	    let powerValue = 0;
	    let powerValueSign = 1;

	    while ((ch = this.nextChar()) >= 0) {
	      if (ch >= 0x30 && ch <= 0x39) {
	        const currentDigit = ch - 0x30;

	        if (eNotation) {
	          powerValue = powerValue * 10 + currentDigit;
	        } else {
	          if (divideBy !== 0) {
	            divideBy *= 10;
	          }

	          baseValue = baseValue * 10 + currentDigit;
	        }
	      } else if (ch === 0x2e) {
	        if (divideBy === 0) {
	          divideBy = 1;
	        } else {
	          break;
	        }
	      } else if (ch === 0x2d) {
	        (0, _util.warn)("Badly formatted number: minus sign in the middle");
	      } else if (ch === 0x45 || ch === 0x65) {
	        ch = this.peekChar();

	        if (ch === 0x2b || ch === 0x2d) {
	          powerValueSign = ch === 0x2d ? -1 : 1;
	          this.nextChar();
	        } else if (ch < 0x30 || ch > 0x39) {
	          break;
	        }

	        eNotation = true;
	      } else {
	        break;
	      }
	    }

	    if (divideBy !== 0) {
	      baseValue /= divideBy;
	    }

	    if (eNotation) {
	      baseValue *= 10 ** (powerValueSign * powerValue);
	    }

	    return sign * baseValue;
	  }

	  getString() {
	    let numParen = 1;
	    let done = false;
	    const strBuf = this.strBuf;
	    strBuf.length = 0;
	    let ch = this.nextChar();

	    while (true) {
	      let charBuffered = false;

	      switch (ch | 0) {
	        case -1:
	          (0, _util.warn)("Unterminated string");
	          done = true;
	          break;

	        case 0x28:
	          ++numParen;
	          strBuf.push("(");
	          break;

	        case 0x29:
	          if (--numParen === 0) {
	            this.nextChar();
	            done = true;
	          } else {
	            strBuf.push(")");
	          }

	          break;

	        case 0x5c:
	          ch = this.nextChar();

	          switch (ch) {
	            case -1:
	              (0, _util.warn)("Unterminated string");
	              done = true;
	              break;

	            case 0x6e:
	              strBuf.push("\n");
	              break;

	            case 0x72:
	              strBuf.push("\r");
	              break;

	            case 0x74:
	              strBuf.push("\t");
	              break;

	            case 0x62:
	              strBuf.push("\b");
	              break;

	            case 0x66:
	              strBuf.push("\f");
	              break;

	            case 0x5c:
	            case 0x28:
	            case 0x29:
	              strBuf.push(String.fromCharCode(ch));
	              break;

	            case 0x30:
	            case 0x31:
	            case 0x32:
	            case 0x33:
	            case 0x34:
	            case 0x35:
	            case 0x36:
	            case 0x37:
	              let x = ch & 0x0f;
	              ch = this.nextChar();
	              charBuffered = true;

	              if (ch >= 0x30 && ch <= 0x37) {
	                x = (x << 3) + (ch & 0x0f);
	                ch = this.nextChar();

	                if (ch >= 0x30 && ch <= 0x37) {
	                  charBuffered = false;
	                  x = (x << 3) + (ch & 0x0f);
	                }
	              }

	              strBuf.push(String.fromCharCode(x));
	              break;

	            case 0x0d:
	              if (this.peekChar() === 0x0a) {
	                this.nextChar();
	              }

	              break;

	            case 0x0a:
	              break;

	            default:
	              strBuf.push(String.fromCharCode(ch));
	              break;
	          }

	          break;

	        default:
	          strBuf.push(String.fromCharCode(ch));
	          break;
	      }

	      if (done) {
	        break;
	      }

	      if (!charBuffered) {
	        ch = this.nextChar();
	      }
	    }

	    return strBuf.join("");
	  }

	  getName() {
	    let ch, previousCh;
	    const strBuf = this.strBuf;
	    strBuf.length = 0;

	    while ((ch = this.nextChar()) >= 0 && !specialChars[ch]) {
	      if (ch === 0x23) {
	        ch = this.nextChar();

	        if (specialChars[ch]) {
	          (0, _util.warn)("Lexer_getName: " + "NUMBER SIGN (#) should be followed by a hexadecimal number.");
	          strBuf.push("#");
	          break;
	        }

	        const x = toHexDigit(ch);

	        if (x !== -1) {
	          previousCh = ch;
	          ch = this.nextChar();
	          const x2 = toHexDigit(ch);

	          if (x2 === -1) {
	            (0, _util.warn)(`Lexer_getName: Illegal digit (${String.fromCharCode(ch)}) ` + "in hexadecimal number.");
	            strBuf.push("#", String.fromCharCode(previousCh));

	            if (specialChars[ch]) {
	              break;
	            }

	            strBuf.push(String.fromCharCode(ch));
	            continue;
	          }

	          strBuf.push(String.fromCharCode(x << 4 | x2));
	        } else {
	          strBuf.push("#", String.fromCharCode(ch));
	        }
	      } else {
	        strBuf.push(String.fromCharCode(ch));
	      }
	    }

	    if (strBuf.length > 127) {
	      (0, _util.warn)(`Name token is longer than allowed by the spec: ${strBuf.length}`);
	    }

	    return _primitives.Name.get(strBuf.join(""));
	  }

	  _hexStringWarn(ch) {
	    const MAX_HEX_STRING_NUM_WARN = 5;

	    if (this._hexStringNumWarn++ === MAX_HEX_STRING_NUM_WARN) {
	      (0, _util.warn)("getHexString - ignoring additional invalid characters.");
	      return;
	    }

	    if (this._hexStringNumWarn > MAX_HEX_STRING_NUM_WARN) {
	      return;
	    }

	    (0, _util.warn)(`getHexString - ignoring invalid character: ${ch}`);
	  }

	  getHexString() {
	    const strBuf = this.strBuf;
	    strBuf.length = 0;
	    let ch = this.currentChar;
	    let isFirstHex = true;
	    let firstDigit, secondDigit;
	    this._hexStringNumWarn = 0;

	    while (true) {
	      if (ch < 0) {
	        (0, _util.warn)("Unterminated hex string");
	        break;
	      } else if (ch === 0x3e) {
	        this.nextChar();
	        break;
	      } else if (specialChars[ch] === 1) {
	        ch = this.nextChar();
	        continue;
	      } else {
	        if (isFirstHex) {
	          firstDigit = toHexDigit(ch);

	          if (firstDigit === -1) {
	            this._hexStringWarn(ch);

	            ch = this.nextChar();
	            continue;
	          }
	        } else {
	          secondDigit = toHexDigit(ch);

	          if (secondDigit === -1) {
	            this._hexStringWarn(ch);

	            ch = this.nextChar();
	            continue;
	          }

	          strBuf.push(String.fromCharCode(firstDigit << 4 | secondDigit));
	        }

	        isFirstHex = !isFirstHex;
	        ch = this.nextChar();
	      }
	    }

	    return strBuf.join("");
	  }

	  getObj() {
	    let comment = false;
	    let ch = this.currentChar;

	    while (true) {
	      if (ch < 0) {
	        return _primitives.EOF;
	      }

	      if (comment) {
	        if (ch === 0x0a || ch === 0x0d) {
	          comment = false;
	        }
	      } else if (ch === 0x25) {
	        comment = true;
	      } else if (specialChars[ch] !== 1) {
	        break;
	      }

	      ch = this.nextChar();
	    }

	    switch (ch | 0) {
	      case 0x30:
	      case 0x31:
	      case 0x32:
	      case 0x33:
	      case 0x34:
	      case 0x35:
	      case 0x36:
	      case 0x37:
	      case 0x38:
	      case 0x39:
	      case 0x2b:
	      case 0x2d:
	      case 0x2e:
	        return this.getNumber();

	      case 0x28:
	        return this.getString();

	      case 0x2f:
	        return this.getName();

	      case 0x5b:
	        this.nextChar();
	        return _primitives.Cmd.get("[");

	      case 0x5d:
	        this.nextChar();
	        return _primitives.Cmd.get("]");

	      case 0x3c:
	        ch = this.nextChar();

	        if (ch === 0x3c) {
	          this.nextChar();
	          return _primitives.Cmd.get("<<");
	        }

	        return this.getHexString();

	      case 0x3e:
	        ch = this.nextChar();

	        if (ch === 0x3e) {
	          this.nextChar();
	          return _primitives.Cmd.get(">>");
	        }

	        return _primitives.Cmd.get(">");

	      case 0x7b:
	        this.nextChar();
	        return _primitives.Cmd.get("{");

	      case 0x7d:
	        this.nextChar();
	        return _primitives.Cmd.get("}");

	      case 0x29:
	        this.nextChar();
	        throw new _util.FormatError(`Illegal character: ${ch}`);
	    }

	    let str = String.fromCharCode(ch);

	    if (ch < 0x20 || ch > 0x7f) {
	      const nextCh = this.peekChar();

	      if (nextCh >= 0x20 && nextCh <= 0x7f) {
	        this.nextChar();
	        return _primitives.Cmd.get(str);
	      }
	    }

	    const knownCommands = this.knownCommands;
	    let knownCommandFound = knownCommands && knownCommands[str] !== undefined;

	    while ((ch = this.nextChar()) >= 0 && !specialChars[ch]) {
	      const possibleCommand = str + String.fromCharCode(ch);

	      if (knownCommandFound && knownCommands[possibleCommand] === undefined) {
	        break;
	      }

	      if (str.length === 128) {
	        throw new _util.FormatError(`Command token too long: ${str.length}`);
	      }

	      str = possibleCommand;
	      knownCommandFound = knownCommands && knownCommands[str] !== undefined;
	    }

	    if (str === "true") {
	      return true;
	    }

	    if (str === "false") {
	      return false;
	    }

	    if (str === "null") {
	      return null;
	    }

	    if (str === "BI") {
	      this.beginInlineImagePos = this.stream.pos;
	    }

	    return _primitives.Cmd.get(str);
	  }

	  peekObj() {
	    const streamPos = this.stream.pos,
	          currentChar = this.currentChar,
	          beginInlineImagePos = this.beginInlineImagePos;
	    let nextObj;

	    try {
	      nextObj = this.getObj();
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)(`peekObj: ${ex}`);
	    }

	    this.stream.pos = streamPos;
	    this.currentChar = currentChar;
	    this.beginInlineImagePos = beginInlineImagePos;
	    return nextObj;
	  }

	  skipToNextLine() {
	    let ch = this.currentChar;

	    while (ch >= 0) {
	      if (ch === 0x0d) {
	        ch = this.nextChar();

	        if (ch === 0x0a) {
	          this.nextChar();
	        }

	        break;
	      } else if (ch === 0x0a) {
	        this.nextChar();
	        break;
	      }

	      ch = this.nextChar();
	    }
	  }

	}

	exports.Lexer = Lexer;

	class Linearization {
	  static create(stream) {
	    function getInt(linDict, name, allowZeroValue = false) {
	      const obj = linDict.get(name);

	      if (Number.isInteger(obj) && (allowZeroValue ? obj >= 0 : obj > 0)) {
	        return obj;
	      }

	      throw new Error(`The "${name}" parameter in the linearization ` + "dictionary is invalid.");
	    }

	    function getHints(linDict) {
	      const hints = linDict.get("H");
	      let hintsLength;

	      if (Array.isArray(hints) && ((hintsLength = hints.length) === 2 || hintsLength === 4)) {
	        for (let index = 0; index < hintsLength; index++) {
	          const hint = hints[index];

	          if (!(Number.isInteger(hint) && hint > 0)) {
	            throw new Error(`Hint (${index}) in the linearization dictionary is invalid.`);
	          }
	        }

	        return hints;
	      }

	      throw new Error("Hint array in the linearization dictionary is invalid.");
	    }

	    const parser = new Parser({
	      lexer: new Lexer(stream),
	      xref: null
	    });
	    const obj1 = parser.getObj();
	    const obj2 = parser.getObj();
	    const obj3 = parser.getObj();
	    const linDict = parser.getObj();
	    let obj, length;

	    if (!(Number.isInteger(obj1) && Number.isInteger(obj2) && (0, _primitives.isCmd)(obj3, "obj") && linDict instanceof _primitives.Dict && typeof (obj = linDict.get("Linearized")) === "number" && obj > 0)) {
	      return null;
	    } else if ((length = getInt(linDict, "L")) !== stream.length) {
	      throw new Error('The "L" parameter in the linearization dictionary ' + "does not equal the stream length.");
	    }

	    return {
	      length,
	      hints: getHints(linDict),
	      objectNumberFirst: getInt(linDict, "O"),
	      endFirst: getInt(linDict, "E"),
	      numPages: getInt(linDict, "N"),
	      mainXRefEntriesOffset: getInt(linDict, "T"),
	      pageFirst: linDict.has("P") ? getInt(linDict, "P", true) : 0
	    };
	  }

	}

	exports.Linearization = Linearization;

	/***/ }),
	/* 18 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Ascii85Stream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	var _core_utils = __w_pdfjs_require__(6);

	class Ascii85Stream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength) {
	    if (maybeLength) {
	      maybeLength *= 0.8;
	    }

	    super(maybeLength);
	    this.str = str;
	    this.dict = str.dict;
	    this.input = new Uint8Array(5);
	  }

	  readBlock() {
	    const TILDA_CHAR = 0x7e;
	    const Z_LOWER_CHAR = 0x7a;
	    const EOF = -1;
	    const str = this.str;
	    let c = str.getByte();

	    while ((0, _core_utils.isWhiteSpace)(c)) {
	      c = str.getByte();
	    }

	    if (c === EOF || c === TILDA_CHAR) {
	      this.eof = true;
	      return;
	    }

	    const bufferLength = this.bufferLength;
	    let buffer, i;

	    if (c === Z_LOWER_CHAR) {
	      buffer = this.ensureBuffer(bufferLength + 4);

	      for (i = 0; i < 4; ++i) {
	        buffer[bufferLength + i] = 0;
	      }

	      this.bufferLength += 4;
	    } else {
	      const input = this.input;
	      input[0] = c;

	      for (i = 1; i < 5; ++i) {
	        c = str.getByte();

	        while ((0, _core_utils.isWhiteSpace)(c)) {
	          c = str.getByte();
	        }

	        input[i] = c;

	        if (c === EOF || c === TILDA_CHAR) {
	          break;
	        }
	      }

	      buffer = this.ensureBuffer(bufferLength + i - 1);
	      this.bufferLength += i - 1;

	      if (i < 5) {
	        for (; i < 5; ++i) {
	          input[i] = 0x21 + 84;
	        }

	        this.eof = true;
	      }

	      let t = 0;

	      for (i = 0; i < 5; ++i) {
	        t = t * 85 + (input[i] - 0x21);
	      }

	      for (i = 3; i >= 0; --i) {
	        buffer[bufferLength + i] = t & 0xff;
	        t >>= 8;
	      }
	    }
	  }

	}

	exports.Ascii85Stream = Ascii85Stream;

	/***/ }),
	/* 19 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.StreamsSequenceStream = exports.DecodeStream = void 0;

	var _base_stream = __w_pdfjs_require__(7);

	var _stream = __w_pdfjs_require__(10);

	const emptyBuffer = new Uint8Array(0);

	class DecodeStream extends _base_stream.BaseStream {
	  constructor(maybeMinBufferLength) {
	    super();
	    this._rawMinBufferLength = maybeMinBufferLength || 0;
	    this.pos = 0;
	    this.bufferLength = 0;
	    this.eof = false;
	    this.buffer = emptyBuffer;
	    this.minBufferLength = 512;

	    if (maybeMinBufferLength) {
	      while (this.minBufferLength < maybeMinBufferLength) {
	        this.minBufferLength *= 2;
	      }
	    }
	  }

	  get isEmpty() {
	    while (!this.eof && this.bufferLength === 0) {
	      this.readBlock();
	    }

	    return this.bufferLength === 0;
	  }

	  ensureBuffer(requested) {
	    const buffer = this.buffer;

	    if (requested <= buffer.byteLength) {
	      return buffer;
	    }

	    let size = this.minBufferLength;

	    while (size < requested) {
	      size *= 2;
	    }

	    const buffer2 = new Uint8Array(size);
	    buffer2.set(buffer);
	    return this.buffer = buffer2;
	  }

	  getByte() {
	    const pos = this.pos;

	    while (this.bufferLength <= pos) {
	      if (this.eof) {
	        return -1;
	      }

	      this.readBlock();
	    }

	    return this.buffer[this.pos++];
	  }

	  getBytes(length) {
	    const pos = this.pos;
	    let end;

	    if (length) {
	      this.ensureBuffer(pos + length);
	      end = pos + length;

	      while (!this.eof && this.bufferLength < end) {
	        this.readBlock();
	      }

	      const bufEnd = this.bufferLength;

	      if (end > bufEnd) {
	        end = bufEnd;
	      }
	    } else {
	      while (!this.eof) {
	        this.readBlock();
	      }

	      end = this.bufferLength;
	    }

	    this.pos = end;
	    return this.buffer.subarray(pos, end);
	  }

	  reset() {
	    this.pos = 0;
	  }

	  makeSubStream(start, length, dict = null) {
	    if (length === undefined) {
	      while (!this.eof) {
	        this.readBlock();
	      }
	    } else {
	      const end = start + length;

	      while (this.bufferLength <= end && !this.eof) {
	        this.readBlock();
	      }
	    }

	    return new _stream.Stream(this.buffer, start, length, dict);
	  }

	  getBaseStreams() {
	    return this.str ? this.str.getBaseStreams() : null;
	  }

	}

	exports.DecodeStream = DecodeStream;

	class StreamsSequenceStream extends DecodeStream {
	  constructor(streams, onError = null) {
	    let maybeLength = 0;

	    for (const stream of streams) {
	      maybeLength += stream instanceof DecodeStream ? stream._rawMinBufferLength : stream.length;
	    }

	    super(maybeLength);
	    this.streams = streams;
	    this._onError = onError;
	  }

	  readBlock() {
	    const streams = this.streams;

	    if (streams.length === 0) {
	      this.eof = true;
	      return;
	    }

	    const stream = streams.shift();
	    let chunk;

	    try {
	      chunk = stream.getBytes();
	    } catch (reason) {
	      if (this._onError) {
	        this._onError(reason, stream.dict && stream.dict.objId);

	        return;
	      }

	      throw reason;
	    }

	    const bufferLength = this.bufferLength;
	    const newLength = bufferLength + chunk.length;
	    const buffer = this.ensureBuffer(newLength);
	    buffer.set(chunk, bufferLength);
	    this.bufferLength = newLength;
	  }

	  getBaseStreams() {
	    const baseStreamsBuf = [];

	    for (const stream of this.streams) {
	      const baseStreams = stream.getBaseStreams();

	      if (baseStreams) {
	        baseStreamsBuf.push(...baseStreams);
	      }
	    }

	    return baseStreamsBuf.length > 0 ? baseStreamsBuf : null;
	  }

	}

	exports.StreamsSequenceStream = StreamsSequenceStream;

	/***/ }),
	/* 20 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.AsciiHexStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	class AsciiHexStream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength) {
	    if (maybeLength) {
	      maybeLength *= 0.5;
	    }

	    super(maybeLength);
	    this.str = str;
	    this.dict = str.dict;
	    this.firstDigit = -1;
	  }

	  readBlock() {
	    const UPSTREAM_BLOCK_SIZE = 8000;
	    const bytes = this.str.getBytes(UPSTREAM_BLOCK_SIZE);

	    if (!bytes.length) {
	      this.eof = true;
	      return;
	    }

	    const maxDecodeLength = bytes.length + 1 >> 1;
	    const buffer = this.ensureBuffer(this.bufferLength + maxDecodeLength);
	    let bufferLength = this.bufferLength;
	    let firstDigit = this.firstDigit;

	    for (const ch of bytes) {
	      let digit;

	      if (ch >= 0x30 && ch <= 0x39) {
	        digit = ch & 0x0f;
	      } else if (ch >= 0x41 && ch <= 0x46 || ch >= 0x61 && ch <= 0x66) {
	        digit = (ch & 0x0f) + 9;
	      } else if (ch === 0x3e) {
	        this.eof = true;
	        break;
	      } else {
	        continue;
	      }

	      if (firstDigit < 0) {
	        firstDigit = digit;
	      } else {
	        buffer[bufferLength++] = firstDigit << 4 | digit;
	        firstDigit = -1;
	      }
	    }

	    if (firstDigit >= 0 && this.eof) {
	      buffer[bufferLength++] = firstDigit << 4;
	      firstDigit = -1;
	    }

	    this.firstDigit = firstDigit;
	    this.bufferLength = bufferLength;
	  }

	}

	exports.AsciiHexStream = AsciiHexStream;

	/***/ }),
	/* 21 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.CCITTFaxStream = void 0;

	var _ccitt = __w_pdfjs_require__(22);

	var _decode_stream = __w_pdfjs_require__(19);

	var _primitives = __w_pdfjs_require__(5);

	class CCITTFaxStream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength, params) {
	    super(maybeLength);
	    this.str = str;
	    this.dict = str.dict;

	    if (!(params instanceof _primitives.Dict)) {
	      params = _primitives.Dict.empty;
	    }

	    const source = {
	      next() {
	        return str.getByte();
	      }

	    };
	    this.ccittFaxDecoder = new _ccitt.CCITTFaxDecoder(source, {
	      K: params.get("K"),
	      EndOfLine: params.get("EndOfLine"),
	      EncodedByteAlign: params.get("EncodedByteAlign"),
	      Columns: params.get("Columns"),
	      Rows: params.get("Rows"),
	      EndOfBlock: params.get("EndOfBlock"),
	      BlackIs1: params.get("BlackIs1")
	    });
	  }

	  readBlock() {
	    while (!this.eof) {
	      const c = this.ccittFaxDecoder.readNextChar();

	      if (c === -1) {
	        this.eof = true;
	        return;
	      }

	      this.ensureBuffer(this.bufferLength + 1);
	      this.buffer[this.bufferLength++] = c;
	    }
	  }

	}

	exports.CCITTFaxStream = CCITTFaxStream;

	/***/ }),
	/* 22 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.CCITTFaxDecoder = void 0;

	var _util = __w_pdfjs_require__(2);

	const ccittEOL = -2;
	const ccittEOF = -1;
	const twoDimPass = 0;
	const twoDimHoriz = 1;
	const twoDimVert0 = 2;
	const twoDimVertR1 = 3;
	const twoDimVertL1 = 4;
	const twoDimVertR2 = 5;
	const twoDimVertL2 = 6;
	const twoDimVertR3 = 7;
	const twoDimVertL3 = 8;
	const twoDimTable = [[-1, -1], [-1, -1], [7, twoDimVertL3], [7, twoDimVertR3], [6, twoDimVertL2], [6, twoDimVertL2], [6, twoDimVertR2], [6, twoDimVertR2], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [4, twoDimPass], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimHoriz], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertL1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [3, twoDimVertR1], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0], [1, twoDimVert0]];
	const whiteTable1 = [[-1, -1], [12, ccittEOL], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [11, 1792], [11, 1792], [12, 1984], [12, 2048], [12, 2112], [12, 2176], [12, 2240], [12, 2304], [11, 1856], [11, 1856], [11, 1920], [11, 1920], [12, 2368], [12, 2432], [12, 2496], [12, 2560]];
	const whiteTable2 = [[-1, -1], [-1, -1], [-1, -1], [-1, -1], [8, 29], [8, 29], [8, 30], [8, 30], [8, 45], [8, 45], [8, 46], [8, 46], [7, 22], [7, 22], [7, 22], [7, 22], [7, 23], [7, 23], [7, 23], [7, 23], [8, 47], [8, 47], [8, 48], [8, 48], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [6, 13], [7, 20], [7, 20], [7, 20], [7, 20], [8, 33], [8, 33], [8, 34], [8, 34], [8, 35], [8, 35], [8, 36], [8, 36], [8, 37], [8, 37], [8, 38], [8, 38], [7, 19], [7, 19], [7, 19], [7, 19], [8, 31], [8, 31], [8, 32], [8, 32], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 1], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [6, 12], [8, 53], [8, 53], [8, 54], [8, 54], [7, 26], [7, 26], [7, 26], [7, 26], [8, 39], [8, 39], [8, 40], [8, 40], [8, 41], [8, 41], [8, 42], [8, 42], [8, 43], [8, 43], [8, 44], [8, 44], [7, 21], [7, 21], [7, 21], [7, 21], [7, 28], [7, 28], [7, 28], [7, 28], [8, 61], [8, 61], [8, 62], [8, 62], [8, 63], [8, 63], [8, 0], [8, 0], [8, 320], [8, 320], [8, 384], [8, 384], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 10], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [5, 11], [7, 27], [7, 27], [7, 27], [7, 27], [8, 59], [8, 59], [8, 60], [8, 60], [9, 1472], [9, 1536], [9, 1600], [9, 1728], [7, 18], [7, 18], [7, 18], [7, 18], [7, 24], [7, 24], [7, 24], [7, 24], [8, 49], [8, 49], [8, 50], [8, 50], [8, 51], [8, 51], [8, 52], [8, 52], [7, 25], [7, 25], [7, 25], [7, 25], [8, 55], [8, 55], [8, 56], [8, 56], [8, 57], [8, 57], [8, 58], [8, 58], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 192], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [6, 1664], [8, 448], [8, 448], [8, 512], [8, 512], [9, 704], [9, 768], [8, 640], [8, 640], [8, 576], [8, 576], [9, 832], [9, 896], [9, 960], [9, 1024], [9, 1088], [9, 1152], [9, 1216], [9, 1280], [9, 1344], [9, 1408], [7, 256], [7, 256], [7, 256], [7, 256], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 2], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [4, 3], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 128], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 8], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [5, 9], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 16], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [6, 17], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 4], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [4, 5], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 14], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [6, 15], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [5, 64], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 6], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7], [4, 7]];
	const blackTable1 = [[-1, -1], [-1, -1], [12, ccittEOL], [12, ccittEOL], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [-1, -1], [11, 1792], [11, 1792], [11, 1792], [11, 1792], [12, 1984], [12, 1984], [12, 2048], [12, 2048], [12, 2112], [12, 2112], [12, 2176], [12, 2176], [12, 2240], [12, 2240], [12, 2304], [12, 2304], [11, 1856], [11, 1856], [11, 1856], [11, 1856], [11, 1920], [11, 1920], [11, 1920], [11, 1920], [12, 2368], [12, 2368], [12, 2432], [12, 2432], [12, 2496], [12, 2496], [12, 2560], [12, 2560], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [10, 18], [12, 52], [12, 52], [13, 640], [13, 704], [13, 768], [13, 832], [12, 55], [12, 55], [12, 56], [12, 56], [13, 1280], [13, 1344], [13, 1408], [13, 1472], [12, 59], [12, 59], [12, 60], [12, 60], [13, 1536], [13, 1600], [11, 24], [11, 24], [11, 24], [11, 24], [11, 25], [11, 25], [11, 25], [11, 25], [13, 1664], [13, 1728], [12, 320], [12, 320], [12, 384], [12, 384], [12, 448], [12, 448], [13, 512], [13, 576], [12, 53], [12, 53], [12, 54], [12, 54], [13, 896], [13, 960], [13, 1024], [13, 1088], [13, 1152], [13, 1216], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64], [10, 64]];
	const blackTable2 = [[8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [8, 13], [11, 23], [11, 23], [12, 50], [12, 51], [12, 44], [12, 45], [12, 46], [12, 47], [12, 57], [12, 58], [12, 61], [12, 256], [10, 16], [10, 16], [10, 16], [10, 16], [10, 17], [10, 17], [10, 17], [10, 17], [12, 48], [12, 49], [12, 62], [12, 63], [12, 30], [12, 31], [12, 32], [12, 33], [12, 40], [12, 41], [11, 22], [11, 22], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [8, 14], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 10], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [7, 11], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [9, 15], [12, 128], [12, 192], [12, 26], [12, 27], [12, 28], [12, 29], [11, 19], [11, 19], [11, 20], [11, 20], [12, 34], [12, 35], [12, 36], [12, 37], [12, 38], [12, 39], [11, 21], [11, 21], [12, 42], [12, 43], [10, 0], [10, 0], [10, 0], [10, 0], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12], [7, 12]];
	const blackTable3 = [[-1, -1], [-1, -1], [-1, -1], [-1, -1], [6, 9], [6, 8], [5, 7], [5, 7], [4, 6], [4, 6], [4, 6], [4, 6], [4, 5], [4, 5], [4, 5], [4, 5], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 1], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [3, 4], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 3], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2], [2, 2]];

	class CCITTFaxDecoder {
	  constructor(source, options = {}) {
	    if (!source || typeof source.next !== "function") {
	      throw new Error('CCITTFaxDecoder - invalid "source" parameter.');
	    }

	    this.source = source;
	    this.eof = false;
	    this.encoding = options.K || 0;
	    this.eoline = options.EndOfLine || false;
	    this.byteAlign = options.EncodedByteAlign || false;
	    this.columns = options.Columns || 1728;
	    this.rows = options.Rows || 0;
	    let eoblock = options.EndOfBlock;

	    if (eoblock === null || eoblock === undefined) {
	      eoblock = true;
	    }

	    this.eoblock = eoblock;
	    this.black = options.BlackIs1 || false;
	    this.codingLine = new Uint32Array(this.columns + 1);
	    this.refLine = new Uint32Array(this.columns + 2);
	    this.codingLine[0] = this.columns;
	    this.codingPos = 0;
	    this.row = 0;
	    this.nextLine2D = this.encoding < 0;
	    this.inputBits = 0;
	    this.inputBuf = 0;
	    this.outputBits = 0;
	    this.rowsDone = false;
	    let code1;

	    while ((code1 = this._lookBits(12)) === 0) {
	      this._eatBits(1);
	    }

	    if (code1 === 1) {
	      this._eatBits(12);
	    }

	    if (this.encoding > 0) {
	      this.nextLine2D = !this._lookBits(1);

	      this._eatBits(1);
	    }
	  }

	  readNextChar() {
	    if (this.eof) {
	      return -1;
	    }

	    const refLine = this.refLine;
	    const codingLine = this.codingLine;
	    const columns = this.columns;
	    let refPos, blackPixels, bits, i;

	    if (this.outputBits === 0) {
	      if (this.rowsDone) {
	        this.eof = true;
	      }

	      if (this.eof) {
	        return -1;
	      }

	      this.err = false;
	      let code1, code2, code3;

	      if (this.nextLine2D) {
	        for (i = 0; codingLine[i] < columns; ++i) {
	          refLine[i] = codingLine[i];
	        }

	        refLine[i++] = columns;
	        refLine[i] = columns;
	        codingLine[0] = 0;
	        this.codingPos = 0;
	        refPos = 0;
	        blackPixels = 0;

	        while (codingLine[this.codingPos] < columns) {
	          code1 = this._getTwoDimCode();

	          switch (code1) {
	            case twoDimPass:
	              this._addPixels(refLine[refPos + 1], blackPixels);

	              if (refLine[refPos + 1] < columns) {
	                refPos += 2;
	              }

	              break;

	            case twoDimHoriz:
	              code1 = code2 = 0;

	              if (blackPixels) {
	                do {
	                  code1 += code3 = this._getBlackCode();
	                } while (code3 >= 64);

	                do {
	                  code2 += code3 = this._getWhiteCode();
	                } while (code3 >= 64);
	              } else {
	                do {
	                  code1 += code3 = this._getWhiteCode();
	                } while (code3 >= 64);

	                do {
	                  code2 += code3 = this._getBlackCode();
	                } while (code3 >= 64);
	              }

	              this._addPixels(codingLine[this.codingPos] + code1, blackPixels);

	              if (codingLine[this.codingPos] < columns) {
	                this._addPixels(codingLine[this.codingPos] + code2, blackPixels ^ 1);
	              }

	              while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                refPos += 2;
	              }

	              break;

	            case twoDimVertR3:
	              this._addPixels(refLine[refPos] + 3, blackPixels);

	              blackPixels ^= 1;

	              if (codingLine[this.codingPos] < columns) {
	                ++refPos;

	                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                  refPos += 2;
	                }
	              }

	              break;

	            case twoDimVertR2:
	              this._addPixels(refLine[refPos] + 2, blackPixels);

	              blackPixels ^= 1;

	              if (codingLine[this.codingPos] < columns) {
	                ++refPos;

	                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                  refPos += 2;
	                }
	              }

	              break;

	            case twoDimVertR1:
	              this._addPixels(refLine[refPos] + 1, blackPixels);

	              blackPixels ^= 1;

	              if (codingLine[this.codingPos] < columns) {
	                ++refPos;

	                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                  refPos += 2;
	                }
	              }

	              break;

	            case twoDimVert0:
	              this._addPixels(refLine[refPos], blackPixels);

	              blackPixels ^= 1;

	              if (codingLine[this.codingPos] < columns) {
	                ++refPos;

	                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                  refPos += 2;
	                }
	              }

	              break;

	            case twoDimVertL3:
	              this._addPixelsNeg(refLine[refPos] - 3, blackPixels);

	              blackPixels ^= 1;

	              if (codingLine[this.codingPos] < columns) {
	                if (refPos > 0) {
	                  --refPos;
	                } else {
	                  ++refPos;
	                }

	                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                  refPos += 2;
	                }
	              }

	              break;

	            case twoDimVertL2:
	              this._addPixelsNeg(refLine[refPos] - 2, blackPixels);

	              blackPixels ^= 1;

	              if (codingLine[this.codingPos] < columns) {
	                if (refPos > 0) {
	                  --refPos;
	                } else {
	                  ++refPos;
	                }

	                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                  refPos += 2;
	                }
	              }

	              break;

	            case twoDimVertL1:
	              this._addPixelsNeg(refLine[refPos] - 1, blackPixels);

	              blackPixels ^= 1;

	              if (codingLine[this.codingPos] < columns) {
	                if (refPos > 0) {
	                  --refPos;
	                } else {
	                  ++refPos;
	                }

	                while (refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns) {
	                  refPos += 2;
	                }
	              }

	              break;

	            case ccittEOF:
	              this._addPixels(columns, 0);

	              this.eof = true;
	              break;

	            default:
	              (0, _util.info)("bad 2d code");

	              this._addPixels(columns, 0);

	              this.err = true;
	          }
	        }
	      } else {
	        codingLine[0] = 0;
	        this.codingPos = 0;
	        blackPixels = 0;

	        while (codingLine[this.codingPos] < columns) {
	          code1 = 0;

	          if (blackPixels) {
	            do {
	              code1 += code3 = this._getBlackCode();
	            } while (code3 >= 64);
	          } else {
	            do {
	              code1 += code3 = this._getWhiteCode();
	            } while (code3 >= 64);
	          }

	          this._addPixels(codingLine[this.codingPos] + code1, blackPixels);

	          blackPixels ^= 1;
	        }
	      }

	      let gotEOL = false;

	      if (this.byteAlign) {
	        this.inputBits &= ~7;
	      }

	      if (!this.eoblock && this.row === this.rows - 1) {
	        this.rowsDone = true;
	      } else {
	        code1 = this._lookBits(12);

	        if (this.eoline) {
	          while (code1 !== ccittEOF && code1 !== 1) {
	            this._eatBits(1);

	            code1 = this._lookBits(12);
	          }
	        } else {
	          while (code1 === 0) {
	            this._eatBits(1);

	            code1 = this._lookBits(12);
	          }
	        }

	        if (code1 === 1) {
	          this._eatBits(12);

	          gotEOL = true;
	        } else if (code1 === ccittEOF) {
	          this.eof = true;
	        }
	      }

	      if (!this.eof && this.encoding > 0 && !this.rowsDone) {
	        this.nextLine2D = !this._lookBits(1);

	        this._eatBits(1);
	      }

	      if (this.eoblock && gotEOL && this.byteAlign) {
	        code1 = this._lookBits(12);

	        if (code1 === 1) {
	          this._eatBits(12);

	          if (this.encoding > 0) {
	            this._lookBits(1);

	            this._eatBits(1);
	          }

	          if (this.encoding >= 0) {
	            for (i = 0; i < 4; ++i) {
	              code1 = this._lookBits(12);

	              if (code1 !== 1) {
	                (0, _util.info)("bad rtc code: " + code1);
	              }

	              this._eatBits(12);

	              if (this.encoding > 0) {
	                this._lookBits(1);

	                this._eatBits(1);
	              }
	            }
	          }

	          this.eof = true;
	        }
	      } else if (this.err && this.eoline) {
	        while (true) {
	          code1 = this._lookBits(13);

	          if (code1 === ccittEOF) {
	            this.eof = true;
	            return -1;
	          }

	          if (code1 >> 1 === 1) {
	            break;
	          }

	          this._eatBits(1);
	        }

	        this._eatBits(12);

	        if (this.encoding > 0) {
	          this._eatBits(1);

	          this.nextLine2D = !(code1 & 1);
	        }
	      }

	      if (codingLine[0] > 0) {
	        this.outputBits = codingLine[this.codingPos = 0];
	      } else {
	        this.outputBits = codingLine[this.codingPos = 1];
	      }

	      this.row++;
	    }

	    let c;

	    if (this.outputBits >= 8) {
	      c = this.codingPos & 1 ? 0 : 0xff;
	      this.outputBits -= 8;

	      if (this.outputBits === 0 && codingLine[this.codingPos] < columns) {
	        this.codingPos++;
	        this.outputBits = codingLine[this.codingPos] - codingLine[this.codingPos - 1];
	      }
	    } else {
	      bits = 8;
	      c = 0;

	      do {
	        if (typeof this.outputBits !== "number") {
	          throw new _util.FormatError('Invalid /CCITTFaxDecode data, "outputBits" must be a number.');
	        }

	        if (this.outputBits > bits) {
	          c <<= bits;

	          if (!(this.codingPos & 1)) {
	            c |= 0xff >> 8 - bits;
	          }

	          this.outputBits -= bits;
	          bits = 0;
	        } else {
	          c <<= this.outputBits;

	          if (!(this.codingPos & 1)) {
	            c |= 0xff >> 8 - this.outputBits;
	          }

	          bits -= this.outputBits;
	          this.outputBits = 0;

	          if (codingLine[this.codingPos] < columns) {
	            this.codingPos++;
	            this.outputBits = codingLine[this.codingPos] - codingLine[this.codingPos - 1];
	          } else if (bits > 0) {
	            c <<= bits;
	            bits = 0;
	          }
	        }
	      } while (bits);
	    }

	    if (this.black) {
	      c ^= 0xff;
	    }

	    return c;
	  }

	  _addPixels(a1, blackPixels) {
	    const codingLine = this.codingLine;
	    let codingPos = this.codingPos;

	    if (a1 > codingLine[codingPos]) {
	      if (a1 > this.columns) {
	        (0, _util.info)("row is wrong length");
	        this.err = true;
	        a1 = this.columns;
	      }

	      if (codingPos & 1 ^ blackPixels) {
	        ++codingPos;
	      }

	      codingLine[codingPos] = a1;
	    }

	    this.codingPos = codingPos;
	  }

	  _addPixelsNeg(a1, blackPixels) {
	    const codingLine = this.codingLine;
	    let codingPos = this.codingPos;

	    if (a1 > codingLine[codingPos]) {
	      if (a1 > this.columns) {
	        (0, _util.info)("row is wrong length");
	        this.err = true;
	        a1 = this.columns;
	      }

	      if (codingPos & 1 ^ blackPixels) {
	        ++codingPos;
	      }

	      codingLine[codingPos] = a1;
	    } else if (a1 < codingLine[codingPos]) {
	      if (a1 < 0) {
	        (0, _util.info)("invalid code");
	        this.err = true;
	        a1 = 0;
	      }

	      while (codingPos > 0 && a1 < codingLine[codingPos - 1]) {
	        --codingPos;
	      }

	      codingLine[codingPos] = a1;
	    }

	    this.codingPos = codingPos;
	  }

	  _findTableCode(start, end, table, limit) {
	    const limitValue = limit || 0;

	    for (let i = start; i <= end; ++i) {
	      let code = this._lookBits(i);

	      if (code === ccittEOF) {
	        return [true, 1, false];
	      }

	      if (i < end) {
	        code <<= end - i;
	      }

	      if (!limitValue || code >= limitValue) {
	        const p = table[code - limitValue];

	        if (p[0] === i) {
	          this._eatBits(i);

	          return [true, p[1], true];
	        }
	      }
	    }

	    return [false, 0, false];
	  }

	  _getTwoDimCode() {
	    let code = 0;
	    let p;

	    if (this.eoblock) {
	      code = this._lookBits(7);
	      p = twoDimTable[code];

	      if (p && p[0] > 0) {
	        this._eatBits(p[0]);

	        return p[1];
	      }
	    } else {
	      const result = this._findTableCode(1, 7, twoDimTable);

	      if (result[0] && result[2]) {
	        return result[1];
	      }
	    }

	    (0, _util.info)("Bad two dim code");
	    return ccittEOF;
	  }

	  _getWhiteCode() {
	    let code = 0;
	    let p;

	    if (this.eoblock) {
	      code = this._lookBits(12);

	      if (code === ccittEOF) {
	        return 1;
	      }

	      if (code >> 5 === 0) {
	        p = whiteTable1[code];
	      } else {
	        p = whiteTable2[code >> 3];
	      }

	      if (p[0] > 0) {
	        this._eatBits(p[0]);

	        return p[1];
	      }
	    } else {
	      let result = this._findTableCode(1, 9, whiteTable2);

	      if (result[0]) {
	        return result[1];
	      }

	      result = this._findTableCode(11, 12, whiteTable1);

	      if (result[0]) {
	        return result[1];
	      }
	    }

	    (0, _util.info)("bad white code");

	    this._eatBits(1);

	    return 1;
	  }

	  _getBlackCode() {
	    let code, p;

	    if (this.eoblock) {
	      code = this._lookBits(13);

	      if (code === ccittEOF) {
	        return 1;
	      }

	      if (code >> 7 === 0) {
	        p = blackTable1[code];
	      } else if (code >> 9 === 0 && code >> 7 !== 0) {
	        p = blackTable2[(code >> 1) - 64];
	      } else {
	        p = blackTable3[code >> 7];
	      }

	      if (p[0] > 0) {
	        this._eatBits(p[0]);

	        return p[1];
	      }
	    } else {
	      let result = this._findTableCode(2, 6, blackTable3);

	      if (result[0]) {
	        return result[1];
	      }

	      result = this._findTableCode(7, 12, blackTable2, 64);

	      if (result[0]) {
	        return result[1];
	      }

	      result = this._findTableCode(10, 13, blackTable1);

	      if (result[0]) {
	        return result[1];
	      }
	    }

	    (0, _util.info)("bad black code");

	    this._eatBits(1);

	    return 1;
	  }

	  _lookBits(n) {
	    let c;

	    while (this.inputBits < n) {
	      if ((c = this.source.next()) === -1) {
	        if (this.inputBits === 0) {
	          return ccittEOF;
	        }

	        return this.inputBuf << n - this.inputBits & 0xffff >> 16 - n;
	      }

	      this.inputBuf = this.inputBuf << 8 | c;
	      this.inputBits += 8;
	    }

	    return this.inputBuf >> this.inputBits - n & 0xffff >> 16 - n;
	  }

	  _eatBits(n) {
	    if ((this.inputBits -= n) < 0) {
	      this.inputBits = 0;
	    }
	  }

	}

	exports.CCITTFaxDecoder = CCITTFaxDecoder;

	/***/ }),
	/* 23 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.FlateStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	var _util = __w_pdfjs_require__(2);

	const codeLenCodeMap = new Int32Array([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]);
	const lengthDecode = new Int32Array([0x00003, 0x00004, 0x00005, 0x00006, 0x00007, 0x00008, 0x00009, 0x0000a, 0x1000b, 0x1000d, 0x1000f, 0x10011, 0x20013, 0x20017, 0x2001b, 0x2001f, 0x30023, 0x3002b, 0x30033, 0x3003b, 0x40043, 0x40053, 0x40063, 0x40073, 0x50083, 0x500a3, 0x500c3, 0x500e3, 0x00102, 0x00102, 0x00102]);
	const distDecode = new Int32Array([0x00001, 0x00002, 0x00003, 0x00004, 0x10005, 0x10007, 0x20009, 0x2000d, 0x30011, 0x30019, 0x40021, 0x40031, 0x50041, 0x50061, 0x60081, 0x600c1, 0x70101, 0x70181, 0x80201, 0x80301, 0x90401, 0x90601, 0xa0801, 0xa0c01, 0xb1001, 0xb1801, 0xc2001, 0xc3001, 0xd4001, 0xd6001]);
	const fixedLitCodeTab = [new Int32Array([0x70100, 0x80050, 0x80010, 0x80118, 0x70110, 0x80070, 0x80030, 0x900c0, 0x70108, 0x80060, 0x80020, 0x900a0, 0x80000, 0x80080, 0x80040, 0x900e0, 0x70104, 0x80058, 0x80018, 0x90090, 0x70114, 0x80078, 0x80038, 0x900d0, 0x7010c, 0x80068, 0x80028, 0x900b0, 0x80008, 0x80088, 0x80048, 0x900f0, 0x70102, 0x80054, 0x80014, 0x8011c, 0x70112, 0x80074, 0x80034, 0x900c8, 0x7010a, 0x80064, 0x80024, 0x900a8, 0x80004, 0x80084, 0x80044, 0x900e8, 0x70106, 0x8005c, 0x8001c, 0x90098, 0x70116, 0x8007c, 0x8003c, 0x900d8, 0x7010e, 0x8006c, 0x8002c, 0x900b8, 0x8000c, 0x8008c, 0x8004c, 0x900f8, 0x70101, 0x80052, 0x80012, 0x8011a, 0x70111, 0x80072, 0x80032, 0x900c4, 0x70109, 0x80062, 0x80022, 0x900a4, 0x80002, 0x80082, 0x80042, 0x900e4, 0x70105, 0x8005a, 0x8001a, 0x90094, 0x70115, 0x8007a, 0x8003a, 0x900d4, 0x7010d, 0x8006a, 0x8002a, 0x900b4, 0x8000a, 0x8008a, 0x8004a, 0x900f4, 0x70103, 0x80056, 0x80016, 0x8011e, 0x70113, 0x80076, 0x80036, 0x900cc, 0x7010b, 0x80066, 0x80026, 0x900ac, 0x80006, 0x80086, 0x80046, 0x900ec, 0x70107, 0x8005e, 0x8001e, 0x9009c, 0x70117, 0x8007e, 0x8003e, 0x900dc, 0x7010f, 0x8006e, 0x8002e, 0x900bc, 0x8000e, 0x8008e, 0x8004e, 0x900fc, 0x70100, 0x80051, 0x80011, 0x80119, 0x70110, 0x80071, 0x80031, 0x900c2, 0x70108, 0x80061, 0x80021, 0x900a2, 0x80001, 0x80081, 0x80041, 0x900e2, 0x70104, 0x80059, 0x80019, 0x90092, 0x70114, 0x80079, 0x80039, 0x900d2, 0x7010c, 0x80069, 0x80029, 0x900b2, 0x80009, 0x80089, 0x80049, 0x900f2, 0x70102, 0x80055, 0x80015, 0x8011d, 0x70112, 0x80075, 0x80035, 0x900ca, 0x7010a, 0x80065, 0x80025, 0x900aa, 0x80005, 0x80085, 0x80045, 0x900ea, 0x70106, 0x8005d, 0x8001d, 0x9009a, 0x70116, 0x8007d, 0x8003d, 0x900da, 0x7010e, 0x8006d, 0x8002d, 0x900ba, 0x8000d, 0x8008d, 0x8004d, 0x900fa, 0x70101, 0x80053, 0x80013, 0x8011b, 0x70111, 0x80073, 0x80033, 0x900c6, 0x70109, 0x80063, 0x80023, 0x900a6, 0x80003, 0x80083, 0x80043, 0x900e6, 0x70105, 0x8005b, 0x8001b, 0x90096, 0x70115, 0x8007b, 0x8003b, 0x900d6, 0x7010d, 0x8006b, 0x8002b, 0x900b6, 0x8000b, 0x8008b, 0x8004b, 0x900f6, 0x70103, 0x80057, 0x80017, 0x8011f, 0x70113, 0x80077, 0x80037, 0x900ce, 0x7010b, 0x80067, 0x80027, 0x900ae, 0x80007, 0x80087, 0x80047, 0x900ee, 0x70107, 0x8005f, 0x8001f, 0x9009e, 0x70117, 0x8007f, 0x8003f, 0x900de, 0x7010f, 0x8006f, 0x8002f, 0x900be, 0x8000f, 0x8008f, 0x8004f, 0x900fe, 0x70100, 0x80050, 0x80010, 0x80118, 0x70110, 0x80070, 0x80030, 0x900c1, 0x70108, 0x80060, 0x80020, 0x900a1, 0x80000, 0x80080, 0x80040, 0x900e1, 0x70104, 0x80058, 0x80018, 0x90091, 0x70114, 0x80078, 0x80038, 0x900d1, 0x7010c, 0x80068, 0x80028, 0x900b1, 0x80008, 0x80088, 0x80048, 0x900f1, 0x70102, 0x80054, 0x80014, 0x8011c, 0x70112, 0x80074, 0x80034, 0x900c9, 0x7010a, 0x80064, 0x80024, 0x900a9, 0x80004, 0x80084, 0x80044, 0x900e9, 0x70106, 0x8005c, 0x8001c, 0x90099, 0x70116, 0x8007c, 0x8003c, 0x900d9, 0x7010e, 0x8006c, 0x8002c, 0x900b9, 0x8000c, 0x8008c, 0x8004c, 0x900f9, 0x70101, 0x80052, 0x80012, 0x8011a, 0x70111, 0x80072, 0x80032, 0x900c5, 0x70109, 0x80062, 0x80022, 0x900a5, 0x80002, 0x80082, 0x80042, 0x900e5, 0x70105, 0x8005a, 0x8001a, 0x90095, 0x70115, 0x8007a, 0x8003a, 0x900d5, 0x7010d, 0x8006a, 0x8002a, 0x900b5, 0x8000a, 0x8008a, 0x8004a, 0x900f5, 0x70103, 0x80056, 0x80016, 0x8011e, 0x70113, 0x80076, 0x80036, 0x900cd, 0x7010b, 0x80066, 0x80026, 0x900ad, 0x80006, 0x80086, 0x80046, 0x900ed, 0x70107, 0x8005e, 0x8001e, 0x9009d, 0x70117, 0x8007e, 0x8003e, 0x900dd, 0x7010f, 0x8006e, 0x8002e, 0x900bd, 0x8000e, 0x8008e, 0x8004e, 0x900fd, 0x70100, 0x80051, 0x80011, 0x80119, 0x70110, 0x80071, 0x80031, 0x900c3, 0x70108, 0x80061, 0x80021, 0x900a3, 0x80001, 0x80081, 0x80041, 0x900e3, 0x70104, 0x80059, 0x80019, 0x90093, 0x70114, 0x80079, 0x80039, 0x900d3, 0x7010c, 0x80069, 0x80029, 0x900b3, 0x80009, 0x80089, 0x80049, 0x900f3, 0x70102, 0x80055, 0x80015, 0x8011d, 0x70112, 0x80075, 0x80035, 0x900cb, 0x7010a, 0x80065, 0x80025, 0x900ab, 0x80005, 0x80085, 0x80045, 0x900eb, 0x70106, 0x8005d, 0x8001d, 0x9009b, 0x70116, 0x8007d, 0x8003d, 0x900db, 0x7010e, 0x8006d, 0x8002d, 0x900bb, 0x8000d, 0x8008d, 0x8004d, 0x900fb, 0x70101, 0x80053, 0x80013, 0x8011b, 0x70111, 0x80073, 0x80033, 0x900c7, 0x70109, 0x80063, 0x80023, 0x900a7, 0x80003, 0x80083, 0x80043, 0x900e7, 0x70105, 0x8005b, 0x8001b, 0x90097, 0x70115, 0x8007b, 0x8003b, 0x900d7, 0x7010d, 0x8006b, 0x8002b, 0x900b7, 0x8000b, 0x8008b, 0x8004b, 0x900f7, 0x70103, 0x80057, 0x80017, 0x8011f, 0x70113, 0x80077, 0x80037, 0x900cf, 0x7010b, 0x80067, 0x80027, 0x900af, 0x80007, 0x80087, 0x80047, 0x900ef, 0x70107, 0x8005f, 0x8001f, 0x9009f, 0x70117, 0x8007f, 0x8003f, 0x900df, 0x7010f, 0x8006f, 0x8002f, 0x900bf, 0x8000f, 0x8008f, 0x8004f, 0x900ff]), 9];
	const fixedDistCodeTab = [new Int32Array([0x50000, 0x50010, 0x50008, 0x50018, 0x50004, 0x50014, 0x5000c, 0x5001c, 0x50002, 0x50012, 0x5000a, 0x5001a, 0x50006, 0x50016, 0x5000e, 0x00000, 0x50001, 0x50011, 0x50009, 0x50019, 0x50005, 0x50015, 0x5000d, 0x5001d, 0x50003, 0x50013, 0x5000b, 0x5001b, 0x50007, 0x50017, 0x5000f, 0x00000]), 5];

	class FlateStream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength) {
	    super(maybeLength);
	    this.str = str;
	    this.dict = str.dict;
	    const cmf = str.getByte();
	    const flg = str.getByte();

	    if (cmf === -1 || flg === -1) {
	      throw new _util.FormatError(`Invalid header in flate stream: ${cmf}, ${flg}`);
	    }

	    if ((cmf & 0x0f) !== 0x08) {
	      throw new _util.FormatError(`Unknown compression method in flate stream: ${cmf}, ${flg}`);
	    }

	    if (((cmf << 8) + flg) % 31 !== 0) {
	      throw new _util.FormatError(`Bad FCHECK in flate stream: ${cmf}, ${flg}`);
	    }

	    if (flg & 0x20) {
	      throw new _util.FormatError(`FDICT bit set in flate stream: ${cmf}, ${flg}`);
	    }

	    this.codeSize = 0;
	    this.codeBuf = 0;
	  }

	  getBits(bits) {
	    const str = this.str;
	    let codeSize = this.codeSize;
	    let codeBuf = this.codeBuf;
	    let b;

	    while (codeSize < bits) {
	      if ((b = str.getByte()) === -1) {
	        throw new _util.FormatError("Bad encoding in flate stream");
	      }

	      codeBuf |= b << codeSize;
	      codeSize += 8;
	    }

	    b = codeBuf & (1 << bits) - 1;
	    this.codeBuf = codeBuf >> bits;
	    this.codeSize = codeSize -= bits;
	    return b;
	  }

	  getCode(table) {
	    const str = this.str;
	    const codes = table[0];
	    const maxLen = table[1];
	    let codeSize = this.codeSize;
	    let codeBuf = this.codeBuf;
	    let b;

	    while (codeSize < maxLen) {
	      if ((b = str.getByte()) === -1) {
	        break;
	      }

	      codeBuf |= b << codeSize;
	      codeSize += 8;
	    }

	    const code = codes[codeBuf & (1 << maxLen) - 1];
	    const codeLen = code >> 16;
	    const codeVal = code & 0xffff;

	    if (codeLen < 1 || codeSize < codeLen) {
	      throw new _util.FormatError("Bad encoding in flate stream");
	    }

	    this.codeBuf = codeBuf >> codeLen;
	    this.codeSize = codeSize - codeLen;
	    return codeVal;
	  }

	  generateHuffmanTable(lengths) {
	    const n = lengths.length;
	    let maxLen = 0;
	    let i;

	    for (i = 0; i < n; ++i) {
	      if (lengths[i] > maxLen) {
	        maxLen = lengths[i];
	      }
	    }

	    const size = 1 << maxLen;
	    const codes = new Int32Array(size);

	    for (let len = 1, code = 0, skip = 2; len <= maxLen; ++len, code <<= 1, skip <<= 1) {
	      for (let val = 0; val < n; ++val) {
	        if (lengths[val] === len) {
	          let code2 = 0;
	          let t = code;

	          for (i = 0; i < len; ++i) {
	            code2 = code2 << 1 | t & 1;
	            t >>= 1;
	          }

	          for (i = code2; i < size; i += skip) {
	            codes[i] = len << 16 | val;
	          }

	          ++code;
	        }
	      }
	    }

	    return [codes, maxLen];
	  }

	  readBlock() {
	    let buffer, len;
	    const str = this.str;
	    let hdr = this.getBits(3);

	    if (hdr & 1) {
	      this.eof = true;
	    }

	    hdr >>= 1;

	    if (hdr === 0) {
	      let b;

	      if ((b = str.getByte()) === -1) {
	        throw new _util.FormatError("Bad block header in flate stream");
	      }

	      let blockLen = b;

	      if ((b = str.getByte()) === -1) {
	        throw new _util.FormatError("Bad block header in flate stream");
	      }

	      blockLen |= b << 8;

	      if ((b = str.getByte()) === -1) {
	        throw new _util.FormatError("Bad block header in flate stream");
	      }

	      let check = b;

	      if ((b = str.getByte()) === -1) {
	        throw new _util.FormatError("Bad block header in flate stream");
	      }

	      check |= b << 8;

	      if (check !== (~blockLen & 0xffff) && (blockLen !== 0 || check !== 0)) {
	        throw new _util.FormatError("Bad uncompressed block length in flate stream");
	      }

	      this.codeBuf = 0;
	      this.codeSize = 0;
	      const bufferLength = this.bufferLength,
	            end = bufferLength + blockLen;
	      buffer = this.ensureBuffer(end);
	      this.bufferLength = end;

	      if (blockLen === 0) {
	        if (str.peekByte() === -1) {
	          this.eof = true;
	        }
	      } else {
	        const block = str.getBytes(blockLen);
	        buffer.set(block, bufferLength);

	        if (block.length < blockLen) {
	          this.eof = true;
	        }
	      }

	      return;
	    }

	    let litCodeTable;
	    let distCodeTable;

	    if (hdr === 1) {
	      litCodeTable = fixedLitCodeTab;
	      distCodeTable = fixedDistCodeTab;
	    } else if (hdr === 2) {
	      const numLitCodes = this.getBits(5) + 257;
	      const numDistCodes = this.getBits(5) + 1;
	      const numCodeLenCodes = this.getBits(4) + 4;
	      const codeLenCodeLengths = new Uint8Array(codeLenCodeMap.length);
	      let i;

	      for (i = 0; i < numCodeLenCodes; ++i) {
	        codeLenCodeLengths[codeLenCodeMap[i]] = this.getBits(3);
	      }

	      const codeLenCodeTab = this.generateHuffmanTable(codeLenCodeLengths);
	      len = 0;
	      i = 0;
	      const codes = numLitCodes + numDistCodes;
	      const codeLengths = new Uint8Array(codes);
	      let bitsLength, bitsOffset, what;

	      while (i < codes) {
	        const code = this.getCode(codeLenCodeTab);

	        if (code === 16) {
	          bitsLength = 2;
	          bitsOffset = 3;
	          what = len;
	        } else if (code === 17) {
	          bitsLength = 3;
	          bitsOffset = 3;
	          what = len = 0;
	        } else if (code === 18) {
	          bitsLength = 7;
	          bitsOffset = 11;
	          what = len = 0;
	        } else {
	          codeLengths[i++] = len = code;
	          continue;
	        }

	        let repeatLength = this.getBits(bitsLength) + bitsOffset;

	        while (repeatLength-- > 0) {
	          codeLengths[i++] = what;
	        }
	      }

	      litCodeTable = this.generateHuffmanTable(codeLengths.subarray(0, numLitCodes));
	      distCodeTable = this.generateHuffmanTable(codeLengths.subarray(numLitCodes, codes));
	    } else {
	      throw new _util.FormatError("Unknown block type in flate stream");
	    }

	    buffer = this.buffer;
	    let limit = buffer ? buffer.length : 0;
	    let pos = this.bufferLength;

	    while (true) {
	      let code1 = this.getCode(litCodeTable);

	      if (code1 < 256) {
	        if (pos + 1 >= limit) {
	          buffer = this.ensureBuffer(pos + 1);
	          limit = buffer.length;
	        }

	        buffer[pos++] = code1;
	        continue;
	      }

	      if (code1 === 256) {
	        this.bufferLength = pos;
	        return;
	      }

	      code1 -= 257;
	      code1 = lengthDecode[code1];
	      let code2 = code1 >> 16;

	      if (code2 > 0) {
	        code2 = this.getBits(code2);
	      }

	      len = (code1 & 0xffff) + code2;
	      code1 = this.getCode(distCodeTable);
	      code1 = distDecode[code1];
	      code2 = code1 >> 16;

	      if (code2 > 0) {
	        code2 = this.getBits(code2);
	      }

	      const dist = (code1 & 0xffff) + code2;

	      if (pos + len >= limit) {
	        buffer = this.ensureBuffer(pos + len);
	        limit = buffer.length;
	      }

	      for (let k = 0; k < len; ++k, ++pos) {
	        buffer[pos] = buffer[pos - dist];
	      }
	    }
	  }

	}

	exports.FlateStream = FlateStream;

	/***/ }),
	/* 24 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Jbig2Stream = void 0;

	var _base_stream = __w_pdfjs_require__(7);

	var _decode_stream = __w_pdfjs_require__(19);

	var _primitives = __w_pdfjs_require__(5);

	var _jbig = __w_pdfjs_require__(25);

	var _util = __w_pdfjs_require__(2);

	class Jbig2Stream extends _decode_stream.DecodeStream {
	  constructor(stream, maybeLength, params) {
	    super(maybeLength);
	    this.stream = stream;
	    this.dict = stream.dict;
	    this.maybeLength = maybeLength;
	    this.params = params;
	  }

	  get bytes() {
	    return (0, _util.shadow)(this, "bytes", this.stream.getBytes(this.maybeLength));
	  }

	  ensureBuffer(requested) {}

	  readBlock() {
	    if (this.eof) {
	      return;
	    }

	    const jbig2Image = new _jbig.Jbig2Image();
	    const chunks = [];

	    if (this.params instanceof _primitives.Dict) {
	      const globalsStream = this.params.get("JBIG2Globals");

	      if (globalsStream instanceof _base_stream.BaseStream) {
	        const globals = globalsStream.getBytes();
	        chunks.push({
	          data: globals,
	          start: 0,
	          end: globals.length
	        });
	      }
	    }

	    chunks.push({
	      data: this.bytes,
	      start: 0,
	      end: this.bytes.length
	    });
	    const data = jbig2Image.parseChunks(chunks);
	    const dataLength = data.length;

	    for (let i = 0; i < dataLength; i++) {
	      data[i] ^= 0xff;
	    }

	    this.buffer = data;
	    this.bufferLength = dataLength;
	    this.eof = true;
	  }

	}

	exports.Jbig2Stream = Jbig2Stream;

	/***/ }),
	/* 25 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Jbig2Image = void 0;

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	var _arithmetic_decoder = __w_pdfjs_require__(26);

	var _ccitt = __w_pdfjs_require__(22);

	class Jbig2Error extends _util.BaseException {
	  constructor(msg) {
	    super(`JBIG2 error: ${msg}`, "Jbig2Error");
	  }

	}

	class ContextCache {
	  getContexts(id) {
	    if (id in this) {
	      return this[id];
	    }

	    return this[id] = new Int8Array(1 << 16);
	  }

	}

	class DecodingContext {
	  constructor(data, start, end) {
	    this.data = data;
	    this.start = start;
	    this.end = end;
	  }

	  get decoder() {
	    const decoder = new _arithmetic_decoder.ArithmeticDecoder(this.data, this.start, this.end);
	    return (0, _util.shadow)(this, "decoder", decoder);
	  }

	  get contextCache() {
	    const cache = new ContextCache();
	    return (0, _util.shadow)(this, "contextCache", cache);
	  }

	}

	function decodeInteger(contextCache, procedure, decoder) {
	  const contexts = contextCache.getContexts(procedure);
	  let prev = 1;

	  function readBits(length) {
	    let v = 0;

	    for (let i = 0; i < length; i++) {
	      const bit = decoder.readBit(contexts, prev);
	      prev = prev < 256 ? prev << 1 | bit : (prev << 1 | bit) & 511 | 256;
	      v = v << 1 | bit;
	    }

	    return v >>> 0;
	  }

	  const sign = readBits(1);
	  const value = readBits(1) ? readBits(1) ? readBits(1) ? readBits(1) ? readBits(1) ? readBits(32) + 4436 : readBits(12) + 340 : readBits(8) + 84 : readBits(6) + 20 : readBits(4) + 4 : readBits(2);

	  if (sign === 0) {
	    return value;
	  } else if (value > 0) {
	    return -value;
	  }

	  return null;
	}

	function decodeIAID(contextCache, decoder, codeLength) {
	  const contexts = contextCache.getContexts("IAID");
	  let prev = 1;

	  for (let i = 0; i < codeLength; i++) {
	    const bit = decoder.readBit(contexts, prev);
	    prev = prev << 1 | bit;
	  }

	  if (codeLength < 31) {
	    return prev & (1 << codeLength) - 1;
	  }

	  return prev & 0x7fffffff;
	}

	const SegmentTypes = ["SymbolDictionary", null, null, null, "IntermediateTextRegion", null, "ImmediateTextRegion", "ImmediateLosslessTextRegion", null, null, null, null, null, null, null, null, "PatternDictionary", null, null, null, "IntermediateHalftoneRegion", null, "ImmediateHalftoneRegion", "ImmediateLosslessHalftoneRegion", null, null, null, null, null, null, null, null, null, null, null, null, "IntermediateGenericRegion", null, "ImmediateGenericRegion", "ImmediateLosslessGenericRegion", "IntermediateGenericRefinementRegion", null, "ImmediateGenericRefinementRegion", "ImmediateLosslessGenericRefinementRegion", null, null, null, null, "PageInformation", "EndOfPage", "EndOfStripe", "EndOfFile", "Profiles", "Tables", null, null, null, null, null, null, null, null, "Extension"];
	const CodingTemplates = [[{
	  x: -1,
	  y: -2
	}, {
	  x: 0,
	  y: -2
	}, {
	  x: 1,
	  y: -2
	}, {
	  x: -2,
	  y: -1
	}, {
	  x: -1,
	  y: -1
	}, {
	  x: 0,
	  y: -1
	}, {
	  x: 1,
	  y: -1
	}, {
	  x: 2,
	  y: -1
	}, {
	  x: -4,
	  y: 0
	}, {
	  x: -3,
	  y: 0
	}, {
	  x: -2,
	  y: 0
	}, {
	  x: -1,
	  y: 0
	}], [{
	  x: -1,
	  y: -2
	}, {
	  x: 0,
	  y: -2
	}, {
	  x: 1,
	  y: -2
	}, {
	  x: 2,
	  y: -2
	}, {
	  x: -2,
	  y: -1
	}, {
	  x: -1,
	  y: -1
	}, {
	  x: 0,
	  y: -1
	}, {
	  x: 1,
	  y: -1
	}, {
	  x: 2,
	  y: -1
	}, {
	  x: -3,
	  y: 0
	}, {
	  x: -2,
	  y: 0
	}, {
	  x: -1,
	  y: 0
	}], [{
	  x: -1,
	  y: -2
	}, {
	  x: 0,
	  y: -2
	}, {
	  x: 1,
	  y: -2
	}, {
	  x: -2,
	  y: -1
	}, {
	  x: -1,
	  y: -1
	}, {
	  x: 0,
	  y: -1
	}, {
	  x: 1,
	  y: -1
	}, {
	  x: -2,
	  y: 0
	}, {
	  x: -1,
	  y: 0
	}], [{
	  x: -3,
	  y: -1
	}, {
	  x: -2,
	  y: -1
	}, {
	  x: -1,
	  y: -1
	}, {
	  x: 0,
	  y: -1
	}, {
	  x: 1,
	  y: -1
	}, {
	  x: -4,
	  y: 0
	}, {
	  x: -3,
	  y: 0
	}, {
	  x: -2,
	  y: 0
	}, {
	  x: -1,
	  y: 0
	}]];
	const RefinementTemplates = [{
	  coding: [{
	    x: 0,
	    y: -1
	  }, {
	    x: 1,
	    y: -1
	  }, {
	    x: -1,
	    y: 0
	  }],
	  reference: [{
	    x: 0,
	    y: -1
	  }, {
	    x: 1,
	    y: -1
	  }, {
	    x: -1,
	    y: 0
	  }, {
	    x: 0,
	    y: 0
	  }, {
	    x: 1,
	    y: 0
	  }, {
	    x: -1,
	    y: 1
	  }, {
	    x: 0,
	    y: 1
	  }, {
	    x: 1,
	    y: 1
	  }]
	}, {
	  coding: [{
	    x: -1,
	    y: -1
	  }, {
	    x: 0,
	    y: -1
	  }, {
	    x: 1,
	    y: -1
	  }, {
	    x: -1,
	    y: 0
	  }],
	  reference: [{
	    x: 0,
	    y: -1
	  }, {
	    x: -1,
	    y: 0
	  }, {
	    x: 0,
	    y: 0
	  }, {
	    x: 1,
	    y: 0
	  }, {
	    x: 0,
	    y: 1
	  }, {
	    x: 1,
	    y: 1
	  }]
	}];
	const ReusedContexts = [0x9b25, 0x0795, 0x00e5, 0x0195];
	const RefinementReusedContexts = [0x0020, 0x0008];

	function decodeBitmapTemplate0(width, height, decodingContext) {
	  const decoder = decodingContext.decoder;
	  const contexts = decodingContext.contextCache.getContexts("GB");
	  const bitmap = [];
	  let contextLabel, i, j, pixel, row, row1, row2;
	  const OLD_PIXEL_MASK = 0x7bf7;

	  for (i = 0; i < height; i++) {
	    row = bitmap[i] = new Uint8Array(width);
	    row1 = i < 1 ? row : bitmap[i - 1];
	    row2 = i < 2 ? row : bitmap[i - 2];
	    contextLabel = row2[0] << 13 | row2[1] << 12 | row2[2] << 11 | row1[0] << 7 | row1[1] << 6 | row1[2] << 5 | row1[3] << 4;

	    for (j = 0; j < width; j++) {
	      row[j] = pixel = decoder.readBit(contexts, contextLabel);
	      contextLabel = (contextLabel & OLD_PIXEL_MASK) << 1 | (j + 3 < width ? row2[j + 3] << 11 : 0) | (j + 4 < width ? row1[j + 4] << 4 : 0) | pixel;
	    }
	  }

	  return bitmap;
	}

	function decodeBitmap(mmr, width, height, templateIndex, prediction, skip, at, decodingContext) {
	  if (mmr) {
	    const input = new Reader(decodingContext.data, decodingContext.start, decodingContext.end);
	    return decodeMMRBitmap(input, width, height, false);
	  }

	  if (templateIndex === 0 && !skip && !prediction && at.length === 4 && at[0].x === 3 && at[0].y === -1 && at[1].x === -3 && at[1].y === -1 && at[2].x === 2 && at[2].y === -2 && at[3].x === -2 && at[3].y === -2) {
	    return decodeBitmapTemplate0(width, height, decodingContext);
	  }

	  const useskip = !!skip;
	  const template = CodingTemplates[templateIndex].concat(at);
	  template.sort(function (a, b) {
	    return a.y - b.y || a.x - b.x;
	  });
	  const templateLength = template.length;
	  const templateX = new Int8Array(templateLength);
	  const templateY = new Int8Array(templateLength);
	  const changingTemplateEntries = [];
	  let reuseMask = 0,
	      minX = 0,
	      maxX = 0,
	      minY = 0;
	  let c, k;

	  for (k = 0; k < templateLength; k++) {
	    templateX[k] = template[k].x;
	    templateY[k] = template[k].y;
	    minX = Math.min(minX, template[k].x);
	    maxX = Math.max(maxX, template[k].x);
	    minY = Math.min(minY, template[k].y);

	    if (k < templateLength - 1 && template[k].y === template[k + 1].y && template[k].x === template[k + 1].x - 1) {
	      reuseMask |= 1 << templateLength - 1 - k;
	    } else {
	      changingTemplateEntries.push(k);
	    }
	  }

	  const changingEntriesLength = changingTemplateEntries.length;
	  const changingTemplateX = new Int8Array(changingEntriesLength);
	  const changingTemplateY = new Int8Array(changingEntriesLength);
	  const changingTemplateBit = new Uint16Array(changingEntriesLength);

	  for (c = 0; c < changingEntriesLength; c++) {
	    k = changingTemplateEntries[c];
	    changingTemplateX[c] = template[k].x;
	    changingTemplateY[c] = template[k].y;
	    changingTemplateBit[c] = 1 << templateLength - 1 - k;
	  }

	  const sbb_left = -minX;
	  const sbb_top = -minY;
	  const sbb_right = width - maxX;
	  const pseudoPixelContext = ReusedContexts[templateIndex];
	  let row = new Uint8Array(width);
	  const bitmap = [];
	  const decoder = decodingContext.decoder;
	  const contexts = decodingContext.contextCache.getContexts("GB");
	  let ltp = 0,
	      j,
	      i0,
	      j0,
	      contextLabel = 0,
	      bit,
	      shift;

	  for (let i = 0; i < height; i++) {
	    if (prediction) {
	      const sltp = decoder.readBit(contexts, pseudoPixelContext);
	      ltp ^= sltp;

	      if (ltp) {
	        bitmap.push(row);
	        continue;
	      }
	    }

	    row = new Uint8Array(row);
	    bitmap.push(row);

	    for (j = 0; j < width; j++) {
	      if (useskip && skip[i][j]) {
	        row[j] = 0;
	        continue;
	      }

	      if (j >= sbb_left && j < sbb_right && i >= sbb_top) {
	        contextLabel = contextLabel << 1 & reuseMask;

	        for (k = 0; k < changingEntriesLength; k++) {
	          i0 = i + changingTemplateY[k];
	          j0 = j + changingTemplateX[k];
	          bit = bitmap[i0][j0];

	          if (bit) {
	            bit = changingTemplateBit[k];
	            contextLabel |= bit;
	          }
	        }
	      } else {
	        contextLabel = 0;
	        shift = templateLength - 1;

	        for (k = 0; k < templateLength; k++, shift--) {
	          j0 = j + templateX[k];

	          if (j0 >= 0 && j0 < width) {
	            i0 = i + templateY[k];

	            if (i0 >= 0) {
	              bit = bitmap[i0][j0];

	              if (bit) {
	                contextLabel |= bit << shift;
	              }
	            }
	          }
	        }
	      }

	      const pixel = decoder.readBit(contexts, contextLabel);
	      row[j] = pixel;
	    }
	  }

	  return bitmap;
	}

	function decodeRefinement(width, height, templateIndex, referenceBitmap, offsetX, offsetY, prediction, at, decodingContext) {
	  let codingTemplate = RefinementTemplates[templateIndex].coding;

	  if (templateIndex === 0) {
	    codingTemplate = codingTemplate.concat([at[0]]);
	  }

	  const codingTemplateLength = codingTemplate.length;
	  const codingTemplateX = new Int32Array(codingTemplateLength);
	  const codingTemplateY = new Int32Array(codingTemplateLength);
	  let k;

	  for (k = 0; k < codingTemplateLength; k++) {
	    codingTemplateX[k] = codingTemplate[k].x;
	    codingTemplateY[k] = codingTemplate[k].y;
	  }

	  let referenceTemplate = RefinementTemplates[templateIndex].reference;

	  if (templateIndex === 0) {
	    referenceTemplate = referenceTemplate.concat([at[1]]);
	  }

	  const referenceTemplateLength = referenceTemplate.length;
	  const referenceTemplateX = new Int32Array(referenceTemplateLength);
	  const referenceTemplateY = new Int32Array(referenceTemplateLength);

	  for (k = 0; k < referenceTemplateLength; k++) {
	    referenceTemplateX[k] = referenceTemplate[k].x;
	    referenceTemplateY[k] = referenceTemplate[k].y;
	  }

	  const referenceWidth = referenceBitmap[0].length;
	  const referenceHeight = referenceBitmap.length;
	  const pseudoPixelContext = RefinementReusedContexts[templateIndex];
	  const bitmap = [];
	  const decoder = decodingContext.decoder;
	  const contexts = decodingContext.contextCache.getContexts("GR");
	  let ltp = 0;

	  for (let i = 0; i < height; i++) {
	    if (prediction) {
	      const sltp = decoder.readBit(contexts, pseudoPixelContext);
	      ltp ^= sltp;

	      if (ltp) {
	        throw new Jbig2Error("prediction is not supported");
	      }
	    }

	    const row = new Uint8Array(width);
	    bitmap.push(row);

	    for (let j = 0; j < width; j++) {
	      let i0, j0;
	      let contextLabel = 0;

	      for (k = 0; k < codingTemplateLength; k++) {
	        i0 = i + codingTemplateY[k];
	        j0 = j + codingTemplateX[k];

	        if (i0 < 0 || j0 < 0 || j0 >= width) {
	          contextLabel <<= 1;
	        } else {
	          contextLabel = contextLabel << 1 | bitmap[i0][j0];
	        }
	      }

	      for (k = 0; k < referenceTemplateLength; k++) {
	        i0 = i + referenceTemplateY[k] - offsetY;
	        j0 = j + referenceTemplateX[k] - offsetX;

	        if (i0 < 0 || i0 >= referenceHeight || j0 < 0 || j0 >= referenceWidth) {
	          contextLabel <<= 1;
	        } else {
	          contextLabel = contextLabel << 1 | referenceBitmap[i0][j0];
	        }
	      }

	      const pixel = decoder.readBit(contexts, contextLabel);
	      row[j] = pixel;
	    }
	  }

	  return bitmap;
	}

	function decodeSymbolDictionary(huffman, refinement, symbols, numberOfNewSymbols, numberOfExportedSymbols, huffmanTables, templateIndex, at, refinementTemplateIndex, refinementAt, decodingContext, huffmanInput) {
	  if (huffman && refinement) {
	    throw new Jbig2Error("symbol refinement with Huffman is not supported");
	  }

	  const newSymbols = [];
	  let currentHeight = 0;
	  let symbolCodeLength = (0, _core_utils.log2)(symbols.length + numberOfNewSymbols);
	  const decoder = decodingContext.decoder;
	  const contextCache = decodingContext.contextCache;
	  let tableB1, symbolWidths;

	  if (huffman) {
	    tableB1 = getStandardTable(1);
	    symbolWidths = [];
	    symbolCodeLength = Math.max(symbolCodeLength, 1);
	  }

	  while (newSymbols.length < numberOfNewSymbols) {
	    const deltaHeight = huffman ? huffmanTables.tableDeltaHeight.decode(huffmanInput) : decodeInteger(contextCache, "IADH", decoder);
	    currentHeight += deltaHeight;
	    let currentWidth = 0,
	        totalWidth = 0;
	    const firstSymbol = huffman ? symbolWidths.length : 0;

	    while (true) {
	      const deltaWidth = huffman ? huffmanTables.tableDeltaWidth.decode(huffmanInput) : decodeInteger(contextCache, "IADW", decoder);

	      if (deltaWidth === null) {
	        break;
	      }

	      currentWidth += deltaWidth;
	      totalWidth += currentWidth;
	      let bitmap;

	      if (refinement) {
	        const numberOfInstances = decodeInteger(contextCache, "IAAI", decoder);

	        if (numberOfInstances > 1) {
	          bitmap = decodeTextRegion(huffman, refinement, currentWidth, currentHeight, 0, numberOfInstances, 1, symbols.concat(newSymbols), symbolCodeLength, 0, 0, 1, 0, huffmanTables, refinementTemplateIndex, refinementAt, decodingContext, 0, huffmanInput);
	        } else {
	          const symbolId = decodeIAID(contextCache, decoder, symbolCodeLength);
	          const rdx = decodeInteger(contextCache, "IARDX", decoder);
	          const rdy = decodeInteger(contextCache, "IARDY", decoder);
	          const symbol = symbolId < symbols.length ? symbols[symbolId] : newSymbols[symbolId - symbols.length];
	          bitmap = decodeRefinement(currentWidth, currentHeight, refinementTemplateIndex, symbol, rdx, rdy, false, refinementAt, decodingContext);
	        }

	        newSymbols.push(bitmap);
	      } else if (huffman) {
	        symbolWidths.push(currentWidth);
	      } else {
	        bitmap = decodeBitmap(false, currentWidth, currentHeight, templateIndex, false, null, at, decodingContext);
	        newSymbols.push(bitmap);
	      }
	    }

	    if (huffman && !refinement) {
	      const bitmapSize = huffmanTables.tableBitmapSize.decode(huffmanInput);
	      huffmanInput.byteAlign();
	      let collectiveBitmap;

	      if (bitmapSize === 0) {
	        collectiveBitmap = readUncompressedBitmap(huffmanInput, totalWidth, currentHeight);
	      } else {
	        const originalEnd = huffmanInput.end;
	        const bitmapEnd = huffmanInput.position + bitmapSize;
	        huffmanInput.end = bitmapEnd;
	        collectiveBitmap = decodeMMRBitmap(huffmanInput, totalWidth, currentHeight, false);
	        huffmanInput.end = originalEnd;
	        huffmanInput.position = bitmapEnd;
	      }

	      const numberOfSymbolsDecoded = symbolWidths.length;

	      if (firstSymbol === numberOfSymbolsDecoded - 1) {
	        newSymbols.push(collectiveBitmap);
	      } else {
	        let i,
	            y,
	            xMin = 0,
	            xMax,
	            bitmapWidth,
	            symbolBitmap;

	        for (i = firstSymbol; i < numberOfSymbolsDecoded; i++) {
	          bitmapWidth = symbolWidths[i];
	          xMax = xMin + bitmapWidth;
	          symbolBitmap = [];

	          for (y = 0; y < currentHeight; y++) {
	            symbolBitmap.push(collectiveBitmap[y].subarray(xMin, xMax));
	          }

	          newSymbols.push(symbolBitmap);
	          xMin = xMax;
	        }
	      }
	    }
	  }

	  const exportedSymbols = [],
	        flags = [];
	  let currentFlag = false,
	      i,
	      ii;
	  const totalSymbolsLength = symbols.length + numberOfNewSymbols;

	  while (flags.length < totalSymbolsLength) {
	    let runLength = huffman ? tableB1.decode(huffmanInput) : decodeInteger(contextCache, "IAEX", decoder);

	    while (runLength--) {
	      flags.push(currentFlag);
	    }

	    currentFlag = !currentFlag;
	  }

	  for (i = 0, ii = symbols.length; i < ii; i++) {
	    if (flags[i]) {
	      exportedSymbols.push(symbols[i]);
	    }
	  }

	  for (let j = 0; j < numberOfNewSymbols; i++, j++) {
	    if (flags[i]) {
	      exportedSymbols.push(newSymbols[j]);
	    }
	  }

	  return exportedSymbols;
	}

	function decodeTextRegion(huffman, refinement, width, height, defaultPixelValue, numberOfSymbolInstances, stripSize, inputSymbols, symbolCodeLength, transposed, dsOffset, referenceCorner, combinationOperator, huffmanTables, refinementTemplateIndex, refinementAt, decodingContext, logStripSize, huffmanInput) {
	  if (huffman && refinement) {
	    throw new Jbig2Error("refinement with Huffman is not supported");
	  }

	  const bitmap = [];
	  let i, row;

	  for (i = 0; i < height; i++) {
	    row = new Uint8Array(width);

	    if (defaultPixelValue) {
	      for (let j = 0; j < width; j++) {
	        row[j] = defaultPixelValue;
	      }
	    }

	    bitmap.push(row);
	  }

	  const decoder = decodingContext.decoder;
	  const contextCache = decodingContext.contextCache;
	  let stripT = huffman ? -huffmanTables.tableDeltaT.decode(huffmanInput) : -decodeInteger(contextCache, "IADT", decoder);
	  let firstS = 0;
	  i = 0;

	  while (i < numberOfSymbolInstances) {
	    const deltaT = huffman ? huffmanTables.tableDeltaT.decode(huffmanInput) : decodeInteger(contextCache, "IADT", decoder);
	    stripT += deltaT;
	    const deltaFirstS = huffman ? huffmanTables.tableFirstS.decode(huffmanInput) : decodeInteger(contextCache, "IAFS", decoder);
	    firstS += deltaFirstS;
	    let currentS = firstS;

	    do {
	      let currentT = 0;

	      if (stripSize > 1) {
	        currentT = huffman ? huffmanInput.readBits(logStripSize) : decodeInteger(contextCache, "IAIT", decoder);
	      }

	      const t = stripSize * stripT + currentT;
	      const symbolId = huffman ? huffmanTables.symbolIDTable.decode(huffmanInput) : decodeIAID(contextCache, decoder, symbolCodeLength);
	      const applyRefinement = refinement && (huffman ? huffmanInput.readBit() : decodeInteger(contextCache, "IARI", decoder));
	      let symbolBitmap = inputSymbols[symbolId];
	      let symbolWidth = symbolBitmap[0].length;
	      let symbolHeight = symbolBitmap.length;

	      if (applyRefinement) {
	        const rdw = decodeInteger(contextCache, "IARDW", decoder);
	        const rdh = decodeInteger(contextCache, "IARDH", decoder);
	        const rdx = decodeInteger(contextCache, "IARDX", decoder);
	        const rdy = decodeInteger(contextCache, "IARDY", decoder);
	        symbolWidth += rdw;
	        symbolHeight += rdh;
	        symbolBitmap = decodeRefinement(symbolWidth, symbolHeight, refinementTemplateIndex, symbolBitmap, (rdw >> 1) + rdx, (rdh >> 1) + rdy, false, refinementAt, decodingContext);
	      }

	      const offsetT = t - (referenceCorner & 1 ? 0 : symbolHeight - 1);
	      const offsetS = currentS - (referenceCorner & 2 ? symbolWidth - 1 : 0);
	      let s2, t2, symbolRow;

	      if (transposed) {
	        for (s2 = 0; s2 < symbolHeight; s2++) {
	          row = bitmap[offsetS + s2];

	          if (!row) {
	            continue;
	          }

	          symbolRow = symbolBitmap[s2];
	          const maxWidth = Math.min(width - offsetT, symbolWidth);

	          switch (combinationOperator) {
	            case 0:
	              for (t2 = 0; t2 < maxWidth; t2++) {
	                row[offsetT + t2] |= symbolRow[t2];
	              }

	              break;

	            case 2:
	              for (t2 = 0; t2 < maxWidth; t2++) {
	                row[offsetT + t2] ^= symbolRow[t2];
	              }

	              break;

	            default:
	              throw new Jbig2Error(`operator ${combinationOperator} is not supported`);
	          }
	        }

	        currentS += symbolHeight - 1;
	      } else {
	        for (t2 = 0; t2 < symbolHeight; t2++) {
	          row = bitmap[offsetT + t2];

	          if (!row) {
	            continue;
	          }

	          symbolRow = symbolBitmap[t2];

	          switch (combinationOperator) {
	            case 0:
	              for (s2 = 0; s2 < symbolWidth; s2++) {
	                row[offsetS + s2] |= symbolRow[s2];
	              }

	              break;

	            case 2:
	              for (s2 = 0; s2 < symbolWidth; s2++) {
	                row[offsetS + s2] ^= symbolRow[s2];
	              }

	              break;

	            default:
	              throw new Jbig2Error(`operator ${combinationOperator} is not supported`);
	          }
	        }

	        currentS += symbolWidth - 1;
	      }

	      i++;
	      const deltaS = huffman ? huffmanTables.tableDeltaS.decode(huffmanInput) : decodeInteger(contextCache, "IADS", decoder);

	      if (deltaS === null) {
	        break;
	      }

	      currentS += deltaS + dsOffset;
	    } while (true);
	  }

	  return bitmap;
	}

	function decodePatternDictionary(mmr, patternWidth, patternHeight, maxPatternIndex, template, decodingContext) {
	  const at = [];

	  if (!mmr) {
	    at.push({
	      x: -patternWidth,
	      y: 0
	    });

	    if (template === 0) {
	      at.push({
	        x: -3,
	        y: -1
	      }, {
	        x: 2,
	        y: -2
	      }, {
	        x: -2,
	        y: -2
	      });
	    }
	  }

	  const collectiveWidth = (maxPatternIndex + 1) * patternWidth;
	  const collectiveBitmap = decodeBitmap(mmr, collectiveWidth, patternHeight, template, false, null, at, decodingContext);
	  const patterns = [];

	  for (let i = 0; i <= maxPatternIndex; i++) {
	    const patternBitmap = [];
	    const xMin = patternWidth * i;
	    const xMax = xMin + patternWidth;

	    for (let y = 0; y < patternHeight; y++) {
	      patternBitmap.push(collectiveBitmap[y].subarray(xMin, xMax));
	    }

	    patterns.push(patternBitmap);
	  }

	  return patterns;
	}

	function decodeHalftoneRegion(mmr, patterns, template, regionWidth, regionHeight, defaultPixelValue, enableSkip, combinationOperator, gridWidth, gridHeight, gridOffsetX, gridOffsetY, gridVectorX, gridVectorY, decodingContext) {
	  const skip = null;

	  if (enableSkip) {
	    throw new Jbig2Error("skip is not supported");
	  }

	  if (combinationOperator !== 0) {
	    throw new Jbig2Error(`operator "${combinationOperator}" is not supported in halftone region`);
	  }

	  const regionBitmap = [];
	  let i, j, row;

	  for (i = 0; i < regionHeight; i++) {
	    row = new Uint8Array(regionWidth);

	    if (defaultPixelValue) {
	      for (j = 0; j < regionWidth; j++) {
	        row[j] = defaultPixelValue;
	      }
	    }

	    regionBitmap.push(row);
	  }

	  const numberOfPatterns = patterns.length;
	  const pattern0 = patterns[0];
	  const patternWidth = pattern0[0].length,
	        patternHeight = pattern0.length;
	  const bitsPerValue = (0, _core_utils.log2)(numberOfPatterns);
	  const at = [];

	  if (!mmr) {
	    at.push({
	      x: template <= 1 ? 3 : 2,
	      y: -1
	    });

	    if (template === 0) {
	      at.push({
	        x: -3,
	        y: -1
	      }, {
	        x: 2,
	        y: -2
	      }, {
	        x: -2,
	        y: -2
	      });
	    }
	  }

	  const grayScaleBitPlanes = [];
	  let mmrInput, bitmap;

	  if (mmr) {
	    mmrInput = new Reader(decodingContext.data, decodingContext.start, decodingContext.end);
	  }

	  for (i = bitsPerValue - 1; i >= 0; i--) {
	    if (mmr) {
	      bitmap = decodeMMRBitmap(mmrInput, gridWidth, gridHeight, true);
	    } else {
	      bitmap = decodeBitmap(false, gridWidth, gridHeight, template, false, skip, at, decodingContext);
	    }

	    grayScaleBitPlanes[i] = bitmap;
	  }

	  let mg, ng, bit, patternIndex, patternBitmap, x, y, patternRow, regionRow;

	  for (mg = 0; mg < gridHeight; mg++) {
	    for (ng = 0; ng < gridWidth; ng++) {
	      bit = 0;
	      patternIndex = 0;

	      for (j = bitsPerValue - 1; j >= 0; j--) {
	        bit ^= grayScaleBitPlanes[j][mg][ng];
	        patternIndex |= bit << j;
	      }

	      patternBitmap = patterns[patternIndex];
	      x = gridOffsetX + mg * gridVectorY + ng * gridVectorX >> 8;
	      y = gridOffsetY + mg * gridVectorX - ng * gridVectorY >> 8;

	      if (x >= 0 && x + patternWidth <= regionWidth && y >= 0 && y + patternHeight <= regionHeight) {
	        for (i = 0; i < patternHeight; i++) {
	          regionRow = regionBitmap[y + i];
	          patternRow = patternBitmap[i];

	          for (j = 0; j < patternWidth; j++) {
	            regionRow[x + j] |= patternRow[j];
	          }
	        }
	      } else {
	        let regionX, regionY;

	        for (i = 0; i < patternHeight; i++) {
	          regionY = y + i;

	          if (regionY < 0 || regionY >= regionHeight) {
	            continue;
	          }

	          regionRow = regionBitmap[regionY];
	          patternRow = patternBitmap[i];

	          for (j = 0; j < patternWidth; j++) {
	            regionX = x + j;

	            if (regionX >= 0 && regionX < regionWidth) {
	              regionRow[regionX] |= patternRow[j];
	            }
	          }
	        }
	      }
	    }
	  }

	  return regionBitmap;
	}

	function readSegmentHeader(data, start) {
	  const segmentHeader = {};
	  segmentHeader.number = (0, _core_utils.readUint32)(data, start);
	  const flags = data[start + 4];
	  const segmentType = flags & 0x3f;

	  if (!SegmentTypes[segmentType]) {
	    throw new Jbig2Error("invalid segment type: " + segmentType);
	  }

	  segmentHeader.type = segmentType;
	  segmentHeader.typeName = SegmentTypes[segmentType];
	  segmentHeader.deferredNonRetain = !!(flags & 0x80);
	  const pageAssociationFieldSize = !!(flags & 0x40);
	  const referredFlags = data[start + 5];
	  let referredToCount = referredFlags >> 5 & 7;
	  const retainBits = [referredFlags & 31];
	  let position = start + 6;

	  if (referredFlags === 7) {
	    referredToCount = (0, _core_utils.readUint32)(data, position - 1) & 0x1fffffff;
	    position += 3;
	    let bytes = referredToCount + 7 >> 3;
	    retainBits[0] = data[position++];

	    while (--bytes > 0) {
	      retainBits.push(data[position++]);
	    }
	  } else if (referredFlags === 5 || referredFlags === 6) {
	    throw new Jbig2Error("invalid referred-to flags");
	  }

	  segmentHeader.retainBits = retainBits;
	  let referredToSegmentNumberSize = 4;

	  if (segmentHeader.number <= 256) {
	    referredToSegmentNumberSize = 1;
	  } else if (segmentHeader.number <= 65536) {
	    referredToSegmentNumberSize = 2;
	  }

	  const referredTo = [];
	  let i, ii;

	  for (i = 0; i < referredToCount; i++) {
	    let number;

	    if (referredToSegmentNumberSize === 1) {
	      number = data[position];
	    } else if (referredToSegmentNumberSize === 2) {
	      number = (0, _core_utils.readUint16)(data, position);
	    } else {
	      number = (0, _core_utils.readUint32)(data, position);
	    }

	    referredTo.push(number);
	    position += referredToSegmentNumberSize;
	  }

	  segmentHeader.referredTo = referredTo;

	  if (!pageAssociationFieldSize) {
	    segmentHeader.pageAssociation = data[position++];
	  } else {
	    segmentHeader.pageAssociation = (0, _core_utils.readUint32)(data, position);
	    position += 4;
	  }

	  segmentHeader.length = (0, _core_utils.readUint32)(data, position);
	  position += 4;

	  if (segmentHeader.length === 0xffffffff) {
	    if (segmentType === 38) {
	      const genericRegionInfo = readRegionSegmentInformation(data, position);
	      const genericRegionSegmentFlags = data[position + RegionSegmentInformationFieldLength];
	      const genericRegionMmr = !!(genericRegionSegmentFlags & 1);
	      const searchPatternLength = 6;
	      const searchPattern = new Uint8Array(searchPatternLength);

	      if (!genericRegionMmr) {
	        searchPattern[0] = 0xff;
	        searchPattern[1] = 0xac;
	      }

	      searchPattern[2] = genericRegionInfo.height >>> 24 & 0xff;
	      searchPattern[3] = genericRegionInfo.height >> 16 & 0xff;
	      searchPattern[4] = genericRegionInfo.height >> 8 & 0xff;
	      searchPattern[5] = genericRegionInfo.height & 0xff;

	      for (i = position, ii = data.length; i < ii; i++) {
	        let j = 0;

	        while (j < searchPatternLength && searchPattern[j] === data[i + j]) {
	          j++;
	        }

	        if (j === searchPatternLength) {
	          segmentHeader.length = i + searchPatternLength;
	          break;
	        }
	      }

	      if (segmentHeader.length === 0xffffffff) {
	        throw new Jbig2Error("segment end was not found");
	      }
	    } else {
	      throw new Jbig2Error("invalid unknown segment length");
	    }
	  }

	  segmentHeader.headerEnd = position;
	  return segmentHeader;
	}

	function readSegments(header, data, start, end) {
	  const segments = [];
	  let position = start;

	  while (position < end) {
	    const segmentHeader = readSegmentHeader(data, position);
	    position = segmentHeader.headerEnd;
	    const segment = {
	      header: segmentHeader,
	      data
	    };

	    if (!header.randomAccess) {
	      segment.start = position;
	      position += segmentHeader.length;
	      segment.end = position;
	    }

	    segments.push(segment);

	    if (segmentHeader.type === 51) {
	      break;
	    }
	  }

	  if (header.randomAccess) {
	    for (let i = 0, ii = segments.length; i < ii; i++) {
	      segments[i].start = position;
	      position += segments[i].header.length;
	      segments[i].end = position;
	    }
	  }

	  return segments;
	}

	function readRegionSegmentInformation(data, start) {
	  return {
	    width: (0, _core_utils.readUint32)(data, start),
	    height: (0, _core_utils.readUint32)(data, start + 4),
	    x: (0, _core_utils.readUint32)(data, start + 8),
	    y: (0, _core_utils.readUint32)(data, start + 12),
	    combinationOperator: data[start + 16] & 7
	  };
	}

	const RegionSegmentInformationFieldLength = 17;

	function processSegment(segment, visitor) {
	  const header = segment.header;
	  const data = segment.data,
	        end = segment.end;
	  let position = segment.start;
	  let args, at, i, atLength;

	  switch (header.type) {
	    case 0:
	      const dictionary = {};
	      const dictionaryFlags = (0, _core_utils.readUint16)(data, position);
	      dictionary.huffman = !!(dictionaryFlags & 1);
	      dictionary.refinement = !!(dictionaryFlags & 2);
	      dictionary.huffmanDHSelector = dictionaryFlags >> 2 & 3;
	      dictionary.huffmanDWSelector = dictionaryFlags >> 4 & 3;
	      dictionary.bitmapSizeSelector = dictionaryFlags >> 6 & 1;
	      dictionary.aggregationInstancesSelector = dictionaryFlags >> 7 & 1;
	      dictionary.bitmapCodingContextUsed = !!(dictionaryFlags & 256);
	      dictionary.bitmapCodingContextRetained = !!(dictionaryFlags & 512);
	      dictionary.template = dictionaryFlags >> 10 & 3;
	      dictionary.refinementTemplate = dictionaryFlags >> 12 & 1;
	      position += 2;

	      if (!dictionary.huffman) {
	        atLength = dictionary.template === 0 ? 4 : 1;
	        at = [];

	        for (i = 0; i < atLength; i++) {
	          at.push({
	            x: (0, _core_utils.readInt8)(data, position),
	            y: (0, _core_utils.readInt8)(data, position + 1)
	          });
	          position += 2;
	        }

	        dictionary.at = at;
	      }

	      if (dictionary.refinement && !dictionary.refinementTemplate) {
	        at = [];

	        for (i = 0; i < 2; i++) {
	          at.push({
	            x: (0, _core_utils.readInt8)(data, position),
	            y: (0, _core_utils.readInt8)(data, position + 1)
	          });
	          position += 2;
	        }

	        dictionary.refinementAt = at;
	      }

	      dictionary.numberOfExportedSymbols = (0, _core_utils.readUint32)(data, position);
	      position += 4;
	      dictionary.numberOfNewSymbols = (0, _core_utils.readUint32)(data, position);
	      position += 4;
	      args = [dictionary, header.number, header.referredTo, data, position, end];
	      break;

	    case 6:
	    case 7:
	      const textRegion = {};
	      textRegion.info = readRegionSegmentInformation(data, position);
	      position += RegionSegmentInformationFieldLength;
	      const textRegionSegmentFlags = (0, _core_utils.readUint16)(data, position);
	      position += 2;
	      textRegion.huffman = !!(textRegionSegmentFlags & 1);
	      textRegion.refinement = !!(textRegionSegmentFlags & 2);
	      textRegion.logStripSize = textRegionSegmentFlags >> 2 & 3;
	      textRegion.stripSize = 1 << textRegion.logStripSize;
	      textRegion.referenceCorner = textRegionSegmentFlags >> 4 & 3;
	      textRegion.transposed = !!(textRegionSegmentFlags & 64);
	      textRegion.combinationOperator = textRegionSegmentFlags >> 7 & 3;
	      textRegion.defaultPixelValue = textRegionSegmentFlags >> 9 & 1;
	      textRegion.dsOffset = textRegionSegmentFlags << 17 >> 27;
	      textRegion.refinementTemplate = textRegionSegmentFlags >> 15 & 1;

	      if (textRegion.huffman) {
	        const textRegionHuffmanFlags = (0, _core_utils.readUint16)(data, position);
	        position += 2;
	        textRegion.huffmanFS = textRegionHuffmanFlags & 3;
	        textRegion.huffmanDS = textRegionHuffmanFlags >> 2 & 3;
	        textRegion.huffmanDT = textRegionHuffmanFlags >> 4 & 3;
	        textRegion.huffmanRefinementDW = textRegionHuffmanFlags >> 6 & 3;
	        textRegion.huffmanRefinementDH = textRegionHuffmanFlags >> 8 & 3;
	        textRegion.huffmanRefinementDX = textRegionHuffmanFlags >> 10 & 3;
	        textRegion.huffmanRefinementDY = textRegionHuffmanFlags >> 12 & 3;
	        textRegion.huffmanRefinementSizeSelector = !!(textRegionHuffmanFlags & 0x4000);
	      }

	      if (textRegion.refinement && !textRegion.refinementTemplate) {
	        at = [];

	        for (i = 0; i < 2; i++) {
	          at.push({
	            x: (0, _core_utils.readInt8)(data, position),
	            y: (0, _core_utils.readInt8)(data, position + 1)
	          });
	          position += 2;
	        }

	        textRegion.refinementAt = at;
	      }

	      textRegion.numberOfSymbolInstances = (0, _core_utils.readUint32)(data, position);
	      position += 4;
	      args = [textRegion, header.referredTo, data, position, end];
	      break;

	    case 16:
	      const patternDictionary = {};
	      const patternDictionaryFlags = data[position++];
	      patternDictionary.mmr = !!(patternDictionaryFlags & 1);
	      patternDictionary.template = patternDictionaryFlags >> 1 & 3;
	      patternDictionary.patternWidth = data[position++];
	      patternDictionary.patternHeight = data[position++];
	      patternDictionary.maxPatternIndex = (0, _core_utils.readUint32)(data, position);
	      position += 4;
	      args = [patternDictionary, header.number, data, position, end];
	      break;

	    case 22:
	    case 23:
	      const halftoneRegion = {};
	      halftoneRegion.info = readRegionSegmentInformation(data, position);
	      position += RegionSegmentInformationFieldLength;
	      const halftoneRegionFlags = data[position++];
	      halftoneRegion.mmr = !!(halftoneRegionFlags & 1);
	      halftoneRegion.template = halftoneRegionFlags >> 1 & 3;
	      halftoneRegion.enableSkip = !!(halftoneRegionFlags & 8);
	      halftoneRegion.combinationOperator = halftoneRegionFlags >> 4 & 7;
	      halftoneRegion.defaultPixelValue = halftoneRegionFlags >> 7 & 1;
	      halftoneRegion.gridWidth = (0, _core_utils.readUint32)(data, position);
	      position += 4;
	      halftoneRegion.gridHeight = (0, _core_utils.readUint32)(data, position);
	      position += 4;
	      halftoneRegion.gridOffsetX = (0, _core_utils.readUint32)(data, position) & 0xffffffff;
	      position += 4;
	      halftoneRegion.gridOffsetY = (0, _core_utils.readUint32)(data, position) & 0xffffffff;
	      position += 4;
	      halftoneRegion.gridVectorX = (0, _core_utils.readUint16)(data, position);
	      position += 2;
	      halftoneRegion.gridVectorY = (0, _core_utils.readUint16)(data, position);
	      position += 2;
	      args = [halftoneRegion, header.referredTo, data, position, end];
	      break;

	    case 38:
	    case 39:
	      const genericRegion = {};
	      genericRegion.info = readRegionSegmentInformation(data, position);
	      position += RegionSegmentInformationFieldLength;
	      const genericRegionSegmentFlags = data[position++];
	      genericRegion.mmr = !!(genericRegionSegmentFlags & 1);
	      genericRegion.template = genericRegionSegmentFlags >> 1 & 3;
	      genericRegion.prediction = !!(genericRegionSegmentFlags & 8);

	      if (!genericRegion.mmr) {
	        atLength = genericRegion.template === 0 ? 4 : 1;
	        at = [];

	        for (i = 0; i < atLength; i++) {
	          at.push({
	            x: (0, _core_utils.readInt8)(data, position),
	            y: (0, _core_utils.readInt8)(data, position + 1)
	          });
	          position += 2;
	        }

	        genericRegion.at = at;
	      }

	      args = [genericRegion, data, position, end];
	      break;

	    case 48:
	      const pageInfo = {
	        width: (0, _core_utils.readUint32)(data, position),
	        height: (0, _core_utils.readUint32)(data, position + 4),
	        resolutionX: (0, _core_utils.readUint32)(data, position + 8),
	        resolutionY: (0, _core_utils.readUint32)(data, position + 12)
	      };

	      if (pageInfo.height === 0xffffffff) {
	        delete pageInfo.height;
	      }

	      const pageSegmentFlags = data[position + 16];
	      (0, _core_utils.readUint16)(data, position + 17);
	      pageInfo.lossless = !!(pageSegmentFlags & 1);
	      pageInfo.refinement = !!(pageSegmentFlags & 2);
	      pageInfo.defaultPixelValue = pageSegmentFlags >> 2 & 1;
	      pageInfo.combinationOperator = pageSegmentFlags >> 3 & 3;
	      pageInfo.requiresBuffer = !!(pageSegmentFlags & 32);
	      pageInfo.combinationOperatorOverride = !!(pageSegmentFlags & 64);
	      args = [pageInfo];
	      break;

	    case 49:
	      break;

	    case 50:
	      break;

	    case 51:
	      break;

	    case 53:
	      args = [header.number, data, position, end];
	      break;

	    case 62:
	      break;

	    default:
	      throw new Jbig2Error(`segment type ${header.typeName}(${header.type}) is not implemented`);
	  }

	  const callbackName = "on" + header.typeName;

	  if (callbackName in visitor) {
	    visitor[callbackName].apply(visitor, args);
	  }
	}

	function processSegments(segments, visitor) {
	  for (let i = 0, ii = segments.length; i < ii; i++) {
	    processSegment(segments[i], visitor);
	  }
	}

	function parseJbig2Chunks(chunks) {
	  const visitor = new SimpleSegmentVisitor();

	  for (let i = 0, ii = chunks.length; i < ii; i++) {
	    const chunk = chunks[i];
	    const segments = readSegments({}, chunk.data, chunk.start, chunk.end);
	    processSegments(segments, visitor);
	  }

	  return visitor.buffer;
	}

	class SimpleSegmentVisitor {
	  onPageInformation(info) {
	    this.currentPageInfo = info;
	    const rowSize = info.width + 7 >> 3;
	    const buffer = new Uint8ClampedArray(rowSize * info.height);

	    if (info.defaultPixelValue) {
	      buffer.fill(0xff);
	    }

	    this.buffer = buffer;
	  }

	  drawBitmap(regionInfo, bitmap) {
	    const pageInfo = this.currentPageInfo;
	    const width = regionInfo.width,
	          height = regionInfo.height;
	    const rowSize = pageInfo.width + 7 >> 3;
	    const combinationOperator = pageInfo.combinationOperatorOverride ? regionInfo.combinationOperator : pageInfo.combinationOperator;
	    const buffer = this.buffer;
	    const mask0 = 128 >> (regionInfo.x & 7);
	    let offset0 = regionInfo.y * rowSize + (regionInfo.x >> 3);
	    let i, j, mask, offset;

	    switch (combinationOperator) {
	      case 0:
	        for (i = 0; i < height; i++) {
	          mask = mask0;
	          offset = offset0;

	          for (j = 0; j < width; j++) {
	            if (bitmap[i][j]) {
	              buffer[offset] |= mask;
	            }

	            mask >>= 1;

	            if (!mask) {
	              mask = 128;
	              offset++;
	            }
	          }

	          offset0 += rowSize;
	        }

	        break;

	      case 2:
	        for (i = 0; i < height; i++) {
	          mask = mask0;
	          offset = offset0;

	          for (j = 0; j < width; j++) {
	            if (bitmap[i][j]) {
	              buffer[offset] ^= mask;
	            }

	            mask >>= 1;

	            if (!mask) {
	              mask = 128;
	              offset++;
	            }
	          }

	          offset0 += rowSize;
	        }

	        break;

	      default:
	        throw new Jbig2Error(`operator ${combinationOperator} is not supported`);
	    }
	  }

	  onImmediateGenericRegion(region, data, start, end) {
	    const regionInfo = region.info;
	    const decodingContext = new DecodingContext(data, start, end);
	    const bitmap = decodeBitmap(region.mmr, regionInfo.width, regionInfo.height, region.template, region.prediction, null, region.at, decodingContext);
	    this.drawBitmap(regionInfo, bitmap);
	  }

	  onImmediateLosslessGenericRegion() {
	    this.onImmediateGenericRegion(...arguments);
	  }

	  onSymbolDictionary(dictionary, currentSegment, referredSegments, data, start, end) {
	    let huffmanTables, huffmanInput;

	    if (dictionary.huffman) {
	      huffmanTables = getSymbolDictionaryHuffmanTables(dictionary, referredSegments, this.customTables);
	      huffmanInput = new Reader(data, start, end);
	    }

	    let symbols = this.symbols;

	    if (!symbols) {
	      this.symbols = symbols = {};
	    }

	    const inputSymbols = [];

	    for (const referredSegment of referredSegments) {
	      const referredSymbols = symbols[referredSegment];

	      if (referredSymbols) {
	        inputSymbols.push(...referredSymbols);
	      }
	    }

	    const decodingContext = new DecodingContext(data, start, end);
	    symbols[currentSegment] = decodeSymbolDictionary(dictionary.huffman, dictionary.refinement, inputSymbols, dictionary.numberOfNewSymbols, dictionary.numberOfExportedSymbols, huffmanTables, dictionary.template, dictionary.at, dictionary.refinementTemplate, dictionary.refinementAt, decodingContext, huffmanInput);
	  }

	  onImmediateTextRegion(region, referredSegments, data, start, end) {
	    const regionInfo = region.info;
	    let huffmanTables, huffmanInput;
	    const symbols = this.symbols;
	    const inputSymbols = [];

	    for (const referredSegment of referredSegments) {
	      const referredSymbols = symbols[referredSegment];

	      if (referredSymbols) {
	        inputSymbols.push(...referredSymbols);
	      }
	    }

	    const symbolCodeLength = (0, _core_utils.log2)(inputSymbols.length);

	    if (region.huffman) {
	      huffmanInput = new Reader(data, start, end);
	      huffmanTables = getTextRegionHuffmanTables(region, referredSegments, this.customTables, inputSymbols.length, huffmanInput);
	    }

	    const decodingContext = new DecodingContext(data, start, end);
	    const bitmap = decodeTextRegion(region.huffman, region.refinement, regionInfo.width, regionInfo.height, region.defaultPixelValue, region.numberOfSymbolInstances, region.stripSize, inputSymbols, symbolCodeLength, region.transposed, region.dsOffset, region.referenceCorner, region.combinationOperator, huffmanTables, region.refinementTemplate, region.refinementAt, decodingContext, region.logStripSize, huffmanInput);
	    this.drawBitmap(regionInfo, bitmap);
	  }

	  onImmediateLosslessTextRegion() {
	    this.onImmediateTextRegion(...arguments);
	  }

	  onPatternDictionary(dictionary, currentSegment, data, start, end) {
	    let patterns = this.patterns;

	    if (!patterns) {
	      this.patterns = patterns = {};
	    }

	    const decodingContext = new DecodingContext(data, start, end);
	    patterns[currentSegment] = decodePatternDictionary(dictionary.mmr, dictionary.patternWidth, dictionary.patternHeight, dictionary.maxPatternIndex, dictionary.template, decodingContext);
	  }

	  onImmediateHalftoneRegion(region, referredSegments, data, start, end) {
	    const patterns = this.patterns[referredSegments[0]];
	    const regionInfo = region.info;
	    const decodingContext = new DecodingContext(data, start, end);
	    const bitmap = decodeHalftoneRegion(region.mmr, patterns, region.template, regionInfo.width, regionInfo.height, region.defaultPixelValue, region.enableSkip, region.combinationOperator, region.gridWidth, region.gridHeight, region.gridOffsetX, region.gridOffsetY, region.gridVectorX, region.gridVectorY, decodingContext);
	    this.drawBitmap(regionInfo, bitmap);
	  }

	  onImmediateLosslessHalftoneRegion() {
	    this.onImmediateHalftoneRegion(...arguments);
	  }

	  onTables(currentSegment, data, start, end) {
	    let customTables = this.customTables;

	    if (!customTables) {
	      this.customTables = customTables = {};
	    }

	    customTables[currentSegment] = decodeTablesSegment(data, start, end);
	  }

	}

	class HuffmanLine {
	  constructor(lineData) {
	    if (lineData.length === 2) {
	      this.isOOB = true;
	      this.rangeLow = 0;
	      this.prefixLength = lineData[0];
	      this.rangeLength = 0;
	      this.prefixCode = lineData[1];
	      this.isLowerRange = false;
	    } else {
	      this.isOOB = false;
	      this.rangeLow = lineData[0];
	      this.prefixLength = lineData[1];
	      this.rangeLength = lineData[2];
	      this.prefixCode = lineData[3];
	      this.isLowerRange = lineData[4] === "lower";
	    }
	  }

	}

	class HuffmanTreeNode {
	  constructor(line) {
	    this.children = [];

	    if (line) {
	      this.isLeaf = true;
	      this.rangeLength = line.rangeLength;
	      this.rangeLow = line.rangeLow;
	      this.isLowerRange = line.isLowerRange;
	      this.isOOB = line.isOOB;
	    } else {
	      this.isLeaf = false;
	    }
	  }

	  buildTree(line, shift) {
	    const bit = line.prefixCode >> shift & 1;

	    if (shift <= 0) {
	      this.children[bit] = new HuffmanTreeNode(line);
	    } else {
	      let node = this.children[bit];

	      if (!node) {
	        this.children[bit] = node = new HuffmanTreeNode(null);
	      }

	      node.buildTree(line, shift - 1);
	    }
	  }

	  decodeNode(reader) {
	    if (this.isLeaf) {
	      if (this.isOOB) {
	        return null;
	      }

	      const htOffset = reader.readBits(this.rangeLength);
	      return this.rangeLow + (this.isLowerRange ? -htOffset : htOffset);
	    }

	    const node = this.children[reader.readBit()];

	    if (!node) {
	      throw new Jbig2Error("invalid Huffman data");
	    }

	    return node.decodeNode(reader);
	  }

	}

	class HuffmanTable {
	  constructor(lines, prefixCodesDone) {
	    if (!prefixCodesDone) {
	      this.assignPrefixCodes(lines);
	    }

	    this.rootNode = new HuffmanTreeNode(null);

	    for (let i = 0, ii = lines.length; i < ii; i++) {
	      const line = lines[i];

	      if (line.prefixLength > 0) {
	        this.rootNode.buildTree(line, line.prefixLength - 1);
	      }
	    }
	  }

	  decode(reader) {
	    return this.rootNode.decodeNode(reader);
	  }

	  assignPrefixCodes(lines) {
	    const linesLength = lines.length;
	    let prefixLengthMax = 0;

	    for (let i = 0; i < linesLength; i++) {
	      prefixLengthMax = Math.max(prefixLengthMax, lines[i].prefixLength);
	    }

	    const histogram = new Uint32Array(prefixLengthMax + 1);

	    for (let i = 0; i < linesLength; i++) {
	      histogram[lines[i].prefixLength]++;
	    }

	    let currentLength = 1,
	        firstCode = 0,
	        currentCode,
	        currentTemp,
	        line;
	    histogram[0] = 0;

	    while (currentLength <= prefixLengthMax) {
	      firstCode = firstCode + histogram[currentLength - 1] << 1;
	      currentCode = firstCode;
	      currentTemp = 0;

	      while (currentTemp < linesLength) {
	        line = lines[currentTemp];

	        if (line.prefixLength === currentLength) {
	          line.prefixCode = currentCode;
	          currentCode++;
	        }

	        currentTemp++;
	      }

	      currentLength++;
	    }
	  }

	}

	function decodeTablesSegment(data, start, end) {
	  const flags = data[start];
	  const lowestValue = (0, _core_utils.readUint32)(data, start + 1) & 0xffffffff;
	  const highestValue = (0, _core_utils.readUint32)(data, start + 5) & 0xffffffff;
	  const reader = new Reader(data, start + 9, end);
	  const prefixSizeBits = (flags >> 1 & 7) + 1;
	  const rangeSizeBits = (flags >> 4 & 7) + 1;
	  const lines = [];
	  let prefixLength,
	      rangeLength,
	      currentRangeLow = lowestValue;

	  do {
	    prefixLength = reader.readBits(prefixSizeBits);
	    rangeLength = reader.readBits(rangeSizeBits);
	    lines.push(new HuffmanLine([currentRangeLow, prefixLength, rangeLength, 0]));
	    currentRangeLow += 1 << rangeLength;
	  } while (currentRangeLow < highestValue);

	  prefixLength = reader.readBits(prefixSizeBits);
	  lines.push(new HuffmanLine([lowestValue - 1, prefixLength, 32, 0, "lower"]));
	  prefixLength = reader.readBits(prefixSizeBits);
	  lines.push(new HuffmanLine([highestValue, prefixLength, 32, 0]));

	  if (flags & 1) {
	    prefixLength = reader.readBits(prefixSizeBits);
	    lines.push(new HuffmanLine([prefixLength, 0]));
	  }

	  return new HuffmanTable(lines, false);
	}

	const standardTablesCache = {};

	function getStandardTable(number) {
	  let table = standardTablesCache[number];

	  if (table) {
	    return table;
	  }

	  let lines;

	  switch (number) {
	    case 1:
	      lines = [[0, 1, 4, 0x0], [16, 2, 8, 0x2], [272, 3, 16, 0x6], [65808, 3, 32, 0x7]];
	      break;

	    case 2:
	      lines = [[0, 1, 0, 0x0], [1, 2, 0, 0x2], [2, 3, 0, 0x6], [3, 4, 3, 0xe], [11, 5, 6, 0x1e], [75, 6, 32, 0x3e], [6, 0x3f]];
	      break;

	    case 3:
	      lines = [[-256, 8, 8, 0xfe], [0, 1, 0, 0x0], [1, 2, 0, 0x2], [2, 3, 0, 0x6], [3, 4, 3, 0xe], [11, 5, 6, 0x1e], [-257, 8, 32, 0xff, "lower"], [75, 7, 32, 0x7e], [6, 0x3e]];
	      break;

	    case 4:
	      lines = [[1, 1, 0, 0x0], [2, 2, 0, 0x2], [3, 3, 0, 0x6], [4, 4, 3, 0xe], [12, 5, 6, 0x1e], [76, 5, 32, 0x1f]];
	      break;

	    case 5:
	      lines = [[-255, 7, 8, 0x7e], [1, 1, 0, 0x0], [2, 2, 0, 0x2], [3, 3, 0, 0x6], [4, 4, 3, 0xe], [12, 5, 6, 0x1e], [-256, 7, 32, 0x7f, "lower"], [76, 6, 32, 0x3e]];
	      break;

	    case 6:
	      lines = [[-2048, 5, 10, 0x1c], [-1024, 4, 9, 0x8], [-512, 4, 8, 0x9], [-256, 4, 7, 0xa], [-128, 5, 6, 0x1d], [-64, 5, 5, 0x1e], [-32, 4, 5, 0xb], [0, 2, 7, 0x0], [128, 3, 7, 0x2], [256, 3, 8, 0x3], [512, 4, 9, 0xc], [1024, 4, 10, 0xd], [-2049, 6, 32, 0x3e, "lower"], [2048, 6, 32, 0x3f]];
	      break;

	    case 7:
	      lines = [[-1024, 4, 9, 0x8], [-512, 3, 8, 0x0], [-256, 4, 7, 0x9], [-128, 5, 6, 0x1a], [-64, 5, 5, 0x1b], [-32, 4, 5, 0xa], [0, 4, 5, 0xb], [32, 5, 5, 0x1c], [64, 5, 6, 0x1d], [128, 4, 7, 0xc], [256, 3, 8, 0x1], [512, 3, 9, 0x2], [1024, 3, 10, 0x3], [-1025, 5, 32, 0x1e, "lower"], [2048, 5, 32, 0x1f]];
	      break;

	    case 8:
	      lines = [[-15, 8, 3, 0xfc], [-7, 9, 1, 0x1fc], [-5, 8, 1, 0xfd], [-3, 9, 0, 0x1fd], [-2, 7, 0, 0x7c], [-1, 4, 0, 0xa], [0, 2, 1, 0x0], [2, 5, 0, 0x1a], [3, 6, 0, 0x3a], [4, 3, 4, 0x4], [20, 6, 1, 0x3b], [22, 4, 4, 0xb], [38, 4, 5, 0xc], [70, 5, 6, 0x1b], [134, 5, 7, 0x1c], [262, 6, 7, 0x3c], [390, 7, 8, 0x7d], [646, 6, 10, 0x3d], [-16, 9, 32, 0x1fe, "lower"], [1670, 9, 32, 0x1ff], [2, 0x1]];
	      break;

	    case 9:
	      lines = [[-31, 8, 4, 0xfc], [-15, 9, 2, 0x1fc], [-11, 8, 2, 0xfd], [-7, 9, 1, 0x1fd], [-5, 7, 1, 0x7c], [-3, 4, 1, 0xa], [-1, 3, 1, 0x2], [1, 3, 1, 0x3], [3, 5, 1, 0x1a], [5, 6, 1, 0x3a], [7, 3, 5, 0x4], [39, 6, 2, 0x3b], [43, 4, 5, 0xb], [75, 4, 6, 0xc], [139, 5, 7, 0x1b], [267, 5, 8, 0x1c], [523, 6, 8, 0x3c], [779, 7, 9, 0x7d], [1291, 6, 11, 0x3d], [-32, 9, 32, 0x1fe, "lower"], [3339, 9, 32, 0x1ff], [2, 0x0]];
	      break;

	    case 10:
	      lines = [[-21, 7, 4, 0x7a], [-5, 8, 0, 0xfc], [-4, 7, 0, 0x7b], [-3, 5, 0, 0x18], [-2, 2, 2, 0x0], [2, 5, 0, 0x19], [3, 6, 0, 0x36], [4, 7, 0, 0x7c], [5, 8, 0, 0xfd], [6, 2, 6, 0x1], [70, 5, 5, 0x1a], [102, 6, 5, 0x37], [134, 6, 6, 0x38], [198, 6, 7, 0x39], [326, 6, 8, 0x3a], [582, 6, 9, 0x3b], [1094, 6, 10, 0x3c], [2118, 7, 11, 0x7d], [-22, 8, 32, 0xfe, "lower"], [4166, 8, 32, 0xff], [2, 0x2]];
	      break;

	    case 11:
	      lines = [[1, 1, 0, 0x0], [2, 2, 1, 0x2], [4, 4, 0, 0xc], [5, 4, 1, 0xd], [7, 5, 1, 0x1c], [9, 5, 2, 0x1d], [13, 6, 2, 0x3c], [17, 7, 2, 0x7a], [21, 7, 3, 0x7b], [29, 7, 4, 0x7c], [45, 7, 5, 0x7d], [77, 7, 6, 0x7e], [141, 7, 32, 0x7f]];
	      break;

	    case 12:
	      lines = [[1, 1, 0, 0x0], [2, 2, 0, 0x2], [3, 3, 1, 0x6], [5, 5, 0, 0x1c], [6, 5, 1, 0x1d], [8, 6, 1, 0x3c], [10, 7, 0, 0x7a], [11, 7, 1, 0x7b], [13, 7, 2, 0x7c], [17, 7, 3, 0x7d], [25, 7, 4, 0x7e], [41, 8, 5, 0xfe], [73, 8, 32, 0xff]];
	      break;

	    case 13:
	      lines = [[1, 1, 0, 0x0], [2, 3, 0, 0x4], [3, 4, 0, 0xc], [4, 5, 0, 0x1c], [5, 4, 1, 0xd], [7, 3, 3, 0x5], [15, 6, 1, 0x3a], [17, 6, 2, 0x3b], [21, 6, 3, 0x3c], [29, 6, 4, 0x3d], [45, 6, 5, 0x3e], [77, 7, 6, 0x7e], [141, 7, 32, 0x7f]];
	      break;

	    case 14:
	      lines = [[-2, 3, 0, 0x4], [-1, 3, 0, 0x5], [0, 1, 0, 0x0], [1, 3, 0, 0x6], [2, 3, 0, 0x7]];
	      break;

	    case 15:
	      lines = [[-24, 7, 4, 0x7c], [-8, 6, 2, 0x3c], [-4, 5, 1, 0x1c], [-2, 4, 0, 0xc], [-1, 3, 0, 0x4], [0, 1, 0, 0x0], [1, 3, 0, 0x5], [2, 4, 0, 0xd], [3, 5, 1, 0x1d], [5, 6, 2, 0x3d], [9, 7, 4, 0x7d], [-25, 7, 32, 0x7e, "lower"], [25, 7, 32, 0x7f]];
	      break;

	    default:
	      throw new Jbig2Error(`standard table B.${number} does not exist`);
	  }

	  for (let i = 0, ii = lines.length; i < ii; i++) {
	    lines[i] = new HuffmanLine(lines[i]);
	  }

	  table = new HuffmanTable(lines, true);
	  standardTablesCache[number] = table;
	  return table;
	}

	class Reader {
	  constructor(data, start, end) {
	    this.data = data;
	    this.start = start;
	    this.end = end;
	    this.position = start;
	    this.shift = -1;
	    this.currentByte = 0;
	  }

	  readBit() {
	    if (this.shift < 0) {
	      if (this.position >= this.end) {
	        throw new Jbig2Error("end of data while reading bit");
	      }

	      this.currentByte = this.data[this.position++];
	      this.shift = 7;
	    }

	    const bit = this.currentByte >> this.shift & 1;
	    this.shift--;
	    return bit;
	  }

	  readBits(numBits) {
	    let result = 0,
	        i;

	    for (i = numBits - 1; i >= 0; i--) {
	      result |= this.readBit() << i;
	    }

	    return result;
	  }

	  byteAlign() {
	    this.shift = -1;
	  }

	  next() {
	    if (this.position >= this.end) {
	      return -1;
	    }

	    return this.data[this.position++];
	  }

	}

	function getCustomHuffmanTable(index, referredTo, customTables) {
	  let currentIndex = 0;

	  for (let i = 0, ii = referredTo.length; i < ii; i++) {
	    const table = customTables[referredTo[i]];

	    if (table) {
	      if (index === currentIndex) {
	        return table;
	      }

	      currentIndex++;
	    }
	  }

	  throw new Jbig2Error("can't find custom Huffman table");
	}

	function getTextRegionHuffmanTables(textRegion, referredTo, customTables, numberOfSymbols, reader) {
	  const codes = [];

	  for (let i = 0; i <= 34; i++) {
	    const codeLength = reader.readBits(4);
	    codes.push(new HuffmanLine([i, codeLength, 0, 0]));
	  }

	  const runCodesTable = new HuffmanTable(codes, false);
	  codes.length = 0;

	  for (let i = 0; i < numberOfSymbols;) {
	    const codeLength = runCodesTable.decode(reader);

	    if (codeLength >= 32) {
	      let repeatedLength, numberOfRepeats, j;

	      switch (codeLength) {
	        case 32:
	          if (i === 0) {
	            throw new Jbig2Error("no previous value in symbol ID table");
	          }

	          numberOfRepeats = reader.readBits(2) + 3;
	          repeatedLength = codes[i - 1].prefixLength;
	          break;

	        case 33:
	          numberOfRepeats = reader.readBits(3) + 3;
	          repeatedLength = 0;
	          break;

	        case 34:
	          numberOfRepeats = reader.readBits(7) + 11;
	          repeatedLength = 0;
	          break;

	        default:
	          throw new Jbig2Error("invalid code length in symbol ID table");
	      }

	      for (j = 0; j < numberOfRepeats; j++) {
	        codes.push(new HuffmanLine([i, repeatedLength, 0, 0]));
	        i++;
	      }
	    } else {
	      codes.push(new HuffmanLine([i, codeLength, 0, 0]));
	      i++;
	    }
	  }

	  reader.byteAlign();
	  const symbolIDTable = new HuffmanTable(codes, false);
	  let customIndex = 0,
	      tableFirstS,
	      tableDeltaS,
	      tableDeltaT;

	  switch (textRegion.huffmanFS) {
	    case 0:
	    case 1:
	      tableFirstS = getStandardTable(textRegion.huffmanFS + 6);
	      break;

	    case 3:
	      tableFirstS = getCustomHuffmanTable(customIndex, referredTo, customTables);
	      customIndex++;
	      break;

	    default:
	      throw new Jbig2Error("invalid Huffman FS selector");
	  }

	  switch (textRegion.huffmanDS) {
	    case 0:
	    case 1:
	    case 2:
	      tableDeltaS = getStandardTable(textRegion.huffmanDS + 8);
	      break;

	    case 3:
	      tableDeltaS = getCustomHuffmanTable(customIndex, referredTo, customTables);
	      customIndex++;
	      break;

	    default:
	      throw new Jbig2Error("invalid Huffman DS selector");
	  }

	  switch (textRegion.huffmanDT) {
	    case 0:
	    case 1:
	    case 2:
	      tableDeltaT = getStandardTable(textRegion.huffmanDT + 11);
	      break;

	    case 3:
	      tableDeltaT = getCustomHuffmanTable(customIndex, referredTo, customTables);
	      customIndex++;
	      break;

	    default:
	      throw new Jbig2Error("invalid Huffman DT selector");
	  }

	  if (textRegion.refinement) {
	    throw new Jbig2Error("refinement with Huffman is not supported");
	  }

	  return {
	    symbolIDTable,
	    tableFirstS,
	    tableDeltaS,
	    tableDeltaT
	  };
	}

	function getSymbolDictionaryHuffmanTables(dictionary, referredTo, customTables) {
	  let customIndex = 0,
	      tableDeltaHeight,
	      tableDeltaWidth;

	  switch (dictionary.huffmanDHSelector) {
	    case 0:
	    case 1:
	      tableDeltaHeight = getStandardTable(dictionary.huffmanDHSelector + 4);
	      break;

	    case 3:
	      tableDeltaHeight = getCustomHuffmanTable(customIndex, referredTo, customTables);
	      customIndex++;
	      break;

	    default:
	      throw new Jbig2Error("invalid Huffman DH selector");
	  }

	  switch (dictionary.huffmanDWSelector) {
	    case 0:
	    case 1:
	      tableDeltaWidth = getStandardTable(dictionary.huffmanDWSelector + 2);
	      break;

	    case 3:
	      tableDeltaWidth = getCustomHuffmanTable(customIndex, referredTo, customTables);
	      customIndex++;
	      break;

	    default:
	      throw new Jbig2Error("invalid Huffman DW selector");
	  }

	  let tableBitmapSize, tableAggregateInstances;

	  if (dictionary.bitmapSizeSelector) {
	    tableBitmapSize = getCustomHuffmanTable(customIndex, referredTo, customTables);
	    customIndex++;
	  } else {
	    tableBitmapSize = getStandardTable(1);
	  }

	  if (dictionary.aggregationInstancesSelector) {
	    tableAggregateInstances = getCustomHuffmanTable(customIndex, referredTo, customTables);
	  } else {
	    tableAggregateInstances = getStandardTable(1);
	  }

	  return {
	    tableDeltaHeight,
	    tableDeltaWidth,
	    tableBitmapSize,
	    tableAggregateInstances
	  };
	}

	function readUncompressedBitmap(reader, width, height) {
	  const bitmap = [];

	  for (let y = 0; y < height; y++) {
	    const row = new Uint8Array(width);
	    bitmap.push(row);

	    for (let x = 0; x < width; x++) {
	      row[x] = reader.readBit();
	    }

	    reader.byteAlign();
	  }

	  return bitmap;
	}

	function decodeMMRBitmap(input, width, height, endOfBlock) {
	  const params = {
	    K: -1,
	    Columns: width,
	    Rows: height,
	    BlackIs1: true,
	    EndOfBlock: endOfBlock
	  };
	  const decoder = new _ccitt.CCITTFaxDecoder(input, params);
	  const bitmap = [];
	  let currentByte,
	      eof = false;

	  for (let y = 0; y < height; y++) {
	    const row = new Uint8Array(width);
	    bitmap.push(row);
	    let shift = -1;

	    for (let x = 0; x < width; x++) {
	      if (shift < 0) {
	        currentByte = decoder.readNextChar();

	        if (currentByte === -1) {
	          currentByte = 0;
	          eof = true;
	        }

	        shift = 7;
	      }

	      row[x] = currentByte >> shift & 1;
	      shift--;
	    }
	  }

	  if (endOfBlock && !eof) {
	    const lookForEOFLimit = 5;

	    for (let i = 0; i < lookForEOFLimit; i++) {
	      if (decoder.readNextChar() === -1) {
	        break;
	      }
	    }
	  }

	  return bitmap;
	}

	class Jbig2Image {
	  parseChunks(chunks) {
	    return parseJbig2Chunks(chunks);
	  }

	  parse(data) {
	    throw new Error("Not implemented: Jbig2Image.parse");
	  }

	}

	exports.Jbig2Image = Jbig2Image;

	/***/ }),
	/* 26 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ArithmeticDecoder = void 0;
	const QeTable = [{
	  qe: 0x5601,
	  nmps: 1,
	  nlps: 1,
	  switchFlag: 1
	}, {
	  qe: 0x3401,
	  nmps: 2,
	  nlps: 6,
	  switchFlag: 0
	}, {
	  qe: 0x1801,
	  nmps: 3,
	  nlps: 9,
	  switchFlag: 0
	}, {
	  qe: 0x0ac1,
	  nmps: 4,
	  nlps: 12,
	  switchFlag: 0
	}, {
	  qe: 0x0521,
	  nmps: 5,
	  nlps: 29,
	  switchFlag: 0
	}, {
	  qe: 0x0221,
	  nmps: 38,
	  nlps: 33,
	  switchFlag: 0
	}, {
	  qe: 0x5601,
	  nmps: 7,
	  nlps: 6,
	  switchFlag: 1
	}, {
	  qe: 0x5401,
	  nmps: 8,
	  nlps: 14,
	  switchFlag: 0
	}, {
	  qe: 0x4801,
	  nmps: 9,
	  nlps: 14,
	  switchFlag: 0
	}, {
	  qe: 0x3801,
	  nmps: 10,
	  nlps: 14,
	  switchFlag: 0
	}, {
	  qe: 0x3001,
	  nmps: 11,
	  nlps: 17,
	  switchFlag: 0
	}, {
	  qe: 0x2401,
	  nmps: 12,
	  nlps: 18,
	  switchFlag: 0
	}, {
	  qe: 0x1c01,
	  nmps: 13,
	  nlps: 20,
	  switchFlag: 0
	}, {
	  qe: 0x1601,
	  nmps: 29,
	  nlps: 21,
	  switchFlag: 0
	}, {
	  qe: 0x5601,
	  nmps: 15,
	  nlps: 14,
	  switchFlag: 1
	}, {
	  qe: 0x5401,
	  nmps: 16,
	  nlps: 14,
	  switchFlag: 0
	}, {
	  qe: 0x5101,
	  nmps: 17,
	  nlps: 15,
	  switchFlag: 0
	}, {
	  qe: 0x4801,
	  nmps: 18,
	  nlps: 16,
	  switchFlag: 0
	}, {
	  qe: 0x3801,
	  nmps: 19,
	  nlps: 17,
	  switchFlag: 0
	}, {
	  qe: 0x3401,
	  nmps: 20,
	  nlps: 18,
	  switchFlag: 0
	}, {
	  qe: 0x3001,
	  nmps: 21,
	  nlps: 19,
	  switchFlag: 0
	}, {
	  qe: 0x2801,
	  nmps: 22,
	  nlps: 19,
	  switchFlag: 0
	}, {
	  qe: 0x2401,
	  nmps: 23,
	  nlps: 20,
	  switchFlag: 0
	}, {
	  qe: 0x2201,
	  nmps: 24,
	  nlps: 21,
	  switchFlag: 0
	}, {
	  qe: 0x1c01,
	  nmps: 25,
	  nlps: 22,
	  switchFlag: 0
	}, {
	  qe: 0x1801,
	  nmps: 26,
	  nlps: 23,
	  switchFlag: 0
	}, {
	  qe: 0x1601,
	  nmps: 27,
	  nlps: 24,
	  switchFlag: 0
	}, {
	  qe: 0x1401,
	  nmps: 28,
	  nlps: 25,
	  switchFlag: 0
	}, {
	  qe: 0x1201,
	  nmps: 29,
	  nlps: 26,
	  switchFlag: 0
	}, {
	  qe: 0x1101,
	  nmps: 30,
	  nlps: 27,
	  switchFlag: 0
	}, {
	  qe: 0x0ac1,
	  nmps: 31,
	  nlps: 28,
	  switchFlag: 0
	}, {
	  qe: 0x09c1,
	  nmps: 32,
	  nlps: 29,
	  switchFlag: 0
	}, {
	  qe: 0x08a1,
	  nmps: 33,
	  nlps: 30,
	  switchFlag: 0
	}, {
	  qe: 0x0521,
	  nmps: 34,
	  nlps: 31,
	  switchFlag: 0
	}, {
	  qe: 0x0441,
	  nmps: 35,
	  nlps: 32,
	  switchFlag: 0
	}, {
	  qe: 0x02a1,
	  nmps: 36,
	  nlps: 33,
	  switchFlag: 0
	}, {
	  qe: 0x0221,
	  nmps: 37,
	  nlps: 34,
	  switchFlag: 0
	}, {
	  qe: 0x0141,
	  nmps: 38,
	  nlps: 35,
	  switchFlag: 0
	}, {
	  qe: 0x0111,
	  nmps: 39,
	  nlps: 36,
	  switchFlag: 0
	}, {
	  qe: 0x0085,
	  nmps: 40,
	  nlps: 37,
	  switchFlag: 0
	}, {
	  qe: 0x0049,
	  nmps: 41,
	  nlps: 38,
	  switchFlag: 0
	}, {
	  qe: 0x0025,
	  nmps: 42,
	  nlps: 39,
	  switchFlag: 0
	}, {
	  qe: 0x0015,
	  nmps: 43,
	  nlps: 40,
	  switchFlag: 0
	}, {
	  qe: 0x0009,
	  nmps: 44,
	  nlps: 41,
	  switchFlag: 0
	}, {
	  qe: 0x0005,
	  nmps: 45,
	  nlps: 42,
	  switchFlag: 0
	}, {
	  qe: 0x0001,
	  nmps: 45,
	  nlps: 43,
	  switchFlag: 0
	}, {
	  qe: 0x5601,
	  nmps: 46,
	  nlps: 46,
	  switchFlag: 0
	}];

	class ArithmeticDecoder {
	  constructor(data, start, end) {
	    this.data = data;
	    this.bp = start;
	    this.dataEnd = end;
	    this.chigh = data[start];
	    this.clow = 0;
	    this.byteIn();
	    this.chigh = this.chigh << 7 & 0xffff | this.clow >> 9 & 0x7f;
	    this.clow = this.clow << 7 & 0xffff;
	    this.ct -= 7;
	    this.a = 0x8000;
	  }

	  byteIn() {
	    const data = this.data;
	    let bp = this.bp;

	    if (data[bp] === 0xff) {
	      if (data[bp + 1] > 0x8f) {
	        this.clow += 0xff00;
	        this.ct = 8;
	      } else {
	        bp++;
	        this.clow += data[bp] << 9;
	        this.ct = 7;
	        this.bp = bp;
	      }
	    } else {
	      bp++;
	      this.clow += bp < this.dataEnd ? data[bp] << 8 : 0xff00;
	      this.ct = 8;
	      this.bp = bp;
	    }

	    if (this.clow > 0xffff) {
	      this.chigh += this.clow >> 16;
	      this.clow &= 0xffff;
	    }
	  }

	  readBit(contexts, pos) {
	    let cx_index = contexts[pos] >> 1,
	        cx_mps = contexts[pos] & 1;
	    const qeTableIcx = QeTable[cx_index];
	    const qeIcx = qeTableIcx.qe;
	    let d;
	    let a = this.a - qeIcx;

	    if (this.chigh < qeIcx) {
	      if (a < qeIcx) {
	        a = qeIcx;
	        d = cx_mps;
	        cx_index = qeTableIcx.nmps;
	      } else {
	        a = qeIcx;
	        d = 1 ^ cx_mps;

	        if (qeTableIcx.switchFlag === 1) {
	          cx_mps = d;
	        }

	        cx_index = qeTableIcx.nlps;
	      }
	    } else {
	      this.chigh -= qeIcx;

	      if ((a & 0x8000) !== 0) {
	        this.a = a;
	        return cx_mps;
	      }

	      if (a < qeIcx) {
	        d = 1 ^ cx_mps;

	        if (qeTableIcx.switchFlag === 1) {
	          cx_mps = d;
	        }

	        cx_index = qeTableIcx.nlps;
	      } else {
	        d = cx_mps;
	        cx_index = qeTableIcx.nmps;
	      }
	    }

	    do {
	      if (this.ct === 0) {
	        this.byteIn();
	      }

	      a <<= 1;
	      this.chigh = this.chigh << 1 & 0xffff | this.clow >> 15 & 1;
	      this.clow = this.clow << 1 & 0xffff;
	      this.ct--;
	    } while ((a & 0x8000) === 0);

	    this.a = a;
	    contexts[pos] = cx_index << 1 | cx_mps;
	    return d;
	  }

	}

	exports.ArithmeticDecoder = ArithmeticDecoder;

	/***/ }),
	/* 27 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.JpegStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	var _primitives = __w_pdfjs_require__(5);

	var _jpg = __w_pdfjs_require__(28);

	var _util = __w_pdfjs_require__(2);

	class JpegStream extends _decode_stream.DecodeStream {
	  constructor(stream, maybeLength, params) {
	    let ch;

	    while ((ch = stream.getByte()) !== -1) {
	      if (ch === 0xff) {
	        stream.skip(-1);
	        break;
	      }
	    }

	    super(maybeLength);
	    this.stream = stream;
	    this.dict = stream.dict;
	    this.maybeLength = maybeLength;
	    this.params = params;
	  }

	  get bytes() {
	    return (0, _util.shadow)(this, "bytes", this.stream.getBytes(this.maybeLength));
	  }

	  ensureBuffer(requested) {}

	  readBlock() {
	    if (this.eof) {
	      return;
	    }

	    const jpegOptions = {
	      decodeTransform: undefined,
	      colorTransform: undefined
	    };
	    const decodeArr = this.dict.getArray("D", "Decode");

	    if (this.forceRGB && Array.isArray(decodeArr)) {
	      const bitsPerComponent = this.dict.get("BPC", "BitsPerComponent") || 8;
	      const decodeArrLength = decodeArr.length;
	      const transform = new Int32Array(decodeArrLength);
	      let transformNeeded = false;
	      const maxValue = (1 << bitsPerComponent) - 1;

	      for (let i = 0; i < decodeArrLength; i += 2) {
	        transform[i] = (decodeArr[i + 1] - decodeArr[i]) * 256 | 0;
	        transform[i + 1] = decodeArr[i] * maxValue | 0;

	        if (transform[i] !== 256 || transform[i + 1] !== 0) {
	          transformNeeded = true;
	        }
	      }

	      if (transformNeeded) {
	        jpegOptions.decodeTransform = transform;
	      }
	    }

	    if (this.params instanceof _primitives.Dict) {
	      const colorTransform = this.params.get("ColorTransform");

	      if (Number.isInteger(colorTransform)) {
	        jpegOptions.colorTransform = colorTransform;
	      }
	    }

	    const jpegImage = new _jpg.JpegImage(jpegOptions);
	    jpegImage.parse(this.bytes);
	    const data = jpegImage.getData({
	      width: this.drawWidth,
	      height: this.drawHeight,
	      forceRGB: this.forceRGB,
	      isSourcePDF: true
	    });
	    this.buffer = data;
	    this.bufferLength = data.length;
	    this.eof = true;
	  }

	}

	exports.JpegStream = JpegStream;

	/***/ }),
	/* 28 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.JpegImage = void 0;

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	class JpegError extends _util.BaseException {
	  constructor(msg) {
	    super(`JPEG error: ${msg}`, "JpegError");
	  }

	}

	class DNLMarkerError extends _util.BaseException {
	  constructor(message, scanLines) {
	    super(message, "DNLMarkerError");
	    this.scanLines = scanLines;
	  }

	}

	class EOIMarkerError extends _util.BaseException {
	  constructor(msg) {
	    super(msg, "EOIMarkerError");
	  }

	}

	const dctZigZag = new Uint8Array([0, 1, 8, 16, 9, 2, 3, 10, 17, 24, 32, 25, 18, 11, 4, 5, 12, 19, 26, 33, 40, 48, 41, 34, 27, 20, 13, 6, 7, 14, 21, 28, 35, 42, 49, 56, 57, 50, 43, 36, 29, 22, 15, 23, 30, 37, 44, 51, 58, 59, 52, 45, 38, 31, 39, 46, 53, 60, 61, 54, 47, 55, 62, 63]);
	const dctCos1 = 4017;
	const dctSin1 = 799;
	const dctCos3 = 3406;
	const dctSin3 = 2276;
	const dctCos6 = 1567;
	const dctSin6 = 3784;
	const dctSqrt2 = 5793;
	const dctSqrt1d2 = 2896;

	function buildHuffmanTable(codeLengths, values) {
	  let k = 0,
	      i,
	      j,
	      length = 16;

	  while (length > 0 && !codeLengths[length - 1]) {
	    length--;
	  }

	  const code = [{
	    children: [],
	    index: 0
	  }];
	  let p = code[0],
	      q;

	  for (i = 0; i < length; i++) {
	    for (j = 0; j < codeLengths[i]; j++) {
	      p = code.pop();
	      p.children[p.index] = values[k];

	      while (p.index > 0) {
	        p = code.pop();
	      }

	      p.index++;
	      code.push(p);

	      while (code.length <= i) {
	        code.push(q = {
	          children: [],
	          index: 0
	        });
	        p.children[p.index] = q.children;
	        p = q;
	      }

	      k++;
	    }

	    if (i + 1 < length) {
	      code.push(q = {
	        children: [],
	        index: 0
	      });
	      p.children[p.index] = q.children;
	      p = q;
	    }
	  }

	  return code[0].children;
	}

	function getBlockBufferOffset(component, row, col) {
	  return 64 * ((component.blocksPerLine + 1) * row + col);
	}

	function decodeScan(data, offset, frame, components, resetInterval, spectralStart, spectralEnd, successivePrev, successive, parseDNLMarker = false) {
	  const mcusPerLine = frame.mcusPerLine;
	  const progressive = frame.progressive;
	  const startOffset = offset;
	  let bitsData = 0,
	      bitsCount = 0;

	  function readBit() {
	    if (bitsCount > 0) {
	      bitsCount--;
	      return bitsData >> bitsCount & 1;
	    }

	    bitsData = data[offset++];

	    if (bitsData === 0xff) {
	      const nextByte = data[offset++];

	      if (nextByte) {
	        if (nextByte === 0xdc && parseDNLMarker) {
	          offset += 2;
	          const scanLines = (0, _core_utils.readUint16)(data, offset);
	          offset += 2;

	          if (scanLines > 0 && scanLines !== frame.scanLines) {
	            throw new DNLMarkerError("Found DNL marker (0xFFDC) while parsing scan data", scanLines);
	          }
	        } else if (nextByte === 0xd9) {
	          if (parseDNLMarker) {
	            const maybeScanLines = blockRow * (frame.precision === 8 ? 8 : 0);

	            if (maybeScanLines > 0 && Math.round(frame.scanLines / maybeScanLines) >= 10) {
	              throw new DNLMarkerError("Found EOI marker (0xFFD9) while parsing scan data, " + "possibly caused by incorrect `scanLines` parameter", maybeScanLines);
	            }
	          }

	          throw new EOIMarkerError("Found EOI marker (0xFFD9) while parsing scan data");
	        }

	        throw new JpegError(`unexpected marker ${(bitsData << 8 | nextByte).toString(16)}`);
	      }
	    }

	    bitsCount = 7;
	    return bitsData >>> 7;
	  }

	  function decodeHuffman(tree) {
	    let node = tree;

	    while (true) {
	      node = node[readBit()];

	      switch (typeof node) {
	        case "number":
	          return node;

	        case "object":
	          continue;
	      }

	      throw new JpegError("invalid huffman sequence");
	    }
	  }

	  function receive(length) {
	    let n = 0;

	    while (length > 0) {
	      n = n << 1 | readBit();
	      length--;
	    }

	    return n;
	  }

	  function receiveAndExtend(length) {
	    if (length === 1) {
	      return readBit() === 1 ? 1 : -1;
	    }

	    const n = receive(length);

	    if (n >= 1 << length - 1) {
	      return n;
	    }

	    return n + (-1 << length) + 1;
	  }

	  function decodeBaseline(component, blockOffset) {
	    const t = decodeHuffman(component.huffmanTableDC);
	    const diff = t === 0 ? 0 : receiveAndExtend(t);
	    component.blockData[blockOffset] = component.pred += diff;
	    let k = 1;

	    while (k < 64) {
	      const rs = decodeHuffman(component.huffmanTableAC);
	      const s = rs & 15,
	            r = rs >> 4;

	      if (s === 0) {
	        if (r < 15) {
	          break;
	        }

	        k += 16;
	        continue;
	      }

	      k += r;
	      const z = dctZigZag[k];
	      component.blockData[blockOffset + z] = receiveAndExtend(s);
	      k++;
	    }
	  }

	  function decodeDCFirst(component, blockOffset) {
	    const t = decodeHuffman(component.huffmanTableDC);
	    const diff = t === 0 ? 0 : receiveAndExtend(t) << successive;
	    component.blockData[blockOffset] = component.pred += diff;
	  }

	  function decodeDCSuccessive(component, blockOffset) {
	    component.blockData[blockOffset] |= readBit() << successive;
	  }

	  let eobrun = 0;

	  function decodeACFirst(component, blockOffset) {
	    if (eobrun > 0) {
	      eobrun--;
	      return;
	    }

	    let k = spectralStart;
	    const e = spectralEnd;

	    while (k <= e) {
	      const rs = decodeHuffman(component.huffmanTableAC);
	      const s = rs & 15,
	            r = rs >> 4;

	      if (s === 0) {
	        if (r < 15) {
	          eobrun = receive(r) + (1 << r) - 1;
	          break;
	        }

	        k += 16;
	        continue;
	      }

	      k += r;
	      const z = dctZigZag[k];
	      component.blockData[blockOffset + z] = receiveAndExtend(s) * (1 << successive);
	      k++;
	    }
	  }

	  let successiveACState = 0,
	      successiveACNextValue;

	  function decodeACSuccessive(component, blockOffset) {
	    let k = spectralStart;
	    const e = spectralEnd;
	    let r = 0;
	    let s;
	    let rs;

	    while (k <= e) {
	      const offsetZ = blockOffset + dctZigZag[k];
	      const sign = component.blockData[offsetZ] < 0 ? -1 : 1;

	      switch (successiveACState) {
	        case 0:
	          rs = decodeHuffman(component.huffmanTableAC);
	          s = rs & 15;
	          r = rs >> 4;

	          if (s === 0) {
	            if (r < 15) {
	              eobrun = receive(r) + (1 << r);
	              successiveACState = 4;
	            } else {
	              r = 16;
	              successiveACState = 1;
	            }
	          } else {
	            if (s !== 1) {
	              throw new JpegError("invalid ACn encoding");
	            }

	            successiveACNextValue = receiveAndExtend(s);
	            successiveACState = r ? 2 : 3;
	          }

	          continue;

	        case 1:
	        case 2:
	          if (component.blockData[offsetZ]) {
	            component.blockData[offsetZ] += sign * (readBit() << successive);
	          } else {
	            r--;

	            if (r === 0) {
	              successiveACState = successiveACState === 2 ? 3 : 0;
	            }
	          }

	          break;

	        case 3:
	          if (component.blockData[offsetZ]) {
	            component.blockData[offsetZ] += sign * (readBit() << successive);
	          } else {
	            component.blockData[offsetZ] = successiveACNextValue << successive;
	            successiveACState = 0;
	          }

	          break;

	        case 4:
	          if (component.blockData[offsetZ]) {
	            component.blockData[offsetZ] += sign * (readBit() << successive);
	          }

	          break;
	      }

	      k++;
	    }

	    if (successiveACState === 4) {
	      eobrun--;

	      if (eobrun === 0) {
	        successiveACState = 0;
	      }
	    }
	  }

	  let blockRow = 0;

	  function decodeMcu(component, decode, mcu, row, col) {
	    const mcuRow = mcu / mcusPerLine | 0;
	    const mcuCol = mcu % mcusPerLine;
	    blockRow = mcuRow * component.v + row;
	    const blockCol = mcuCol * component.h + col;
	    const blockOffset = getBlockBufferOffset(component, blockRow, blockCol);
	    decode(component, blockOffset);
	  }

	  function decodeBlock(component, decode, mcu) {
	    blockRow = mcu / component.blocksPerLine | 0;
	    const blockCol = mcu % component.blocksPerLine;
	    const blockOffset = getBlockBufferOffset(component, blockRow, blockCol);
	    decode(component, blockOffset);
	  }

	  const componentsLength = components.length;
	  let component, i, j, k, n;
	  let decodeFn;

	  if (progressive) {
	    if (spectralStart === 0) {
	      decodeFn = successivePrev === 0 ? decodeDCFirst : decodeDCSuccessive;
	    } else {
	      decodeFn = successivePrev === 0 ? decodeACFirst : decodeACSuccessive;
	    }
	  } else {
	    decodeFn = decodeBaseline;
	  }

	  let mcu = 0,
	      fileMarker;
	  let mcuExpected;

	  if (componentsLength === 1) {
	    mcuExpected = components[0].blocksPerLine * components[0].blocksPerColumn;
	  } else {
	    mcuExpected = mcusPerLine * frame.mcusPerColumn;
	  }

	  let h, v;

	  while (mcu <= mcuExpected) {
	    const mcuToRead = resetInterval ? Math.min(mcuExpected - mcu, resetInterval) : mcuExpected;

	    if (mcuToRead > 0) {
	      for (i = 0; i < componentsLength; i++) {
	        components[i].pred = 0;
	      }

	      eobrun = 0;

	      if (componentsLength === 1) {
	        component = components[0];

	        for (n = 0; n < mcuToRead; n++) {
	          decodeBlock(component, decodeFn, mcu);
	          mcu++;
	        }
	      } else {
	        for (n = 0; n < mcuToRead; n++) {
	          for (i = 0; i < componentsLength; i++) {
	            component = components[i];
	            h = component.h;
	            v = component.v;

	            for (j = 0; j < v; j++) {
	              for (k = 0; k < h; k++) {
	                decodeMcu(component, decodeFn, mcu, j, k);
	              }
	            }
	          }

	          mcu++;
	        }
	      }
	    }

	    bitsCount = 0;
	    fileMarker = findNextFileMarker(data, offset);

	    if (!fileMarker) {
	      break;
	    }

	    if (fileMarker.invalid) {
	      const partialMsg = mcuToRead > 0 ? "unexpected" : "excessive";
	      (0, _util.warn)(`decodeScan - ${partialMsg} MCU data, current marker is: ${fileMarker.invalid}`);
	      offset = fileMarker.offset;
	    }

	    if (fileMarker.marker >= 0xffd0 && fileMarker.marker <= 0xffd7) {
	      offset += 2;
	    } else {
	      break;
	    }
	  }

	  return offset - startOffset;
	}

	function quantizeAndInverse(component, blockBufferOffset, p) {
	  const qt = component.quantizationTable,
	        blockData = component.blockData;
	  let v0, v1, v2, v3, v4, v5, v6, v7;
	  let p0, p1, p2, p3, p4, p5, p6, p7;
	  let t;

	  if (!qt) {
	    throw new JpegError("missing required Quantization Table.");
	  }

	  for (let row = 0; row < 64; row += 8) {
	    p0 = blockData[blockBufferOffset + row];
	    p1 = blockData[blockBufferOffset + row + 1];
	    p2 = blockData[blockBufferOffset + row + 2];
	    p3 = blockData[blockBufferOffset + row + 3];
	    p4 = blockData[blockBufferOffset + row + 4];
	    p5 = blockData[blockBufferOffset + row + 5];
	    p6 = blockData[blockBufferOffset + row + 6];
	    p7 = blockData[blockBufferOffset + row + 7];
	    p0 *= qt[row];

	    if ((p1 | p2 | p3 | p4 | p5 | p6 | p7) === 0) {
	      t = dctSqrt2 * p0 + 512 >> 10;
	      p[row] = t;
	      p[row + 1] = t;
	      p[row + 2] = t;
	      p[row + 3] = t;
	      p[row + 4] = t;
	      p[row + 5] = t;
	      p[row + 6] = t;
	      p[row + 7] = t;
	      continue;
	    }

	    p1 *= qt[row + 1];
	    p2 *= qt[row + 2];
	    p3 *= qt[row + 3];
	    p4 *= qt[row + 4];
	    p5 *= qt[row + 5];
	    p6 *= qt[row + 6];
	    p7 *= qt[row + 7];
	    v0 = dctSqrt2 * p0 + 128 >> 8;
	    v1 = dctSqrt2 * p4 + 128 >> 8;
	    v2 = p2;
	    v3 = p6;
	    v4 = dctSqrt1d2 * (p1 - p7) + 128 >> 8;
	    v7 = dctSqrt1d2 * (p1 + p7) + 128 >> 8;
	    v5 = p3 << 4;
	    v6 = p5 << 4;
	    v0 = v0 + v1 + 1 >> 1;
	    v1 = v0 - v1;
	    t = v2 * dctSin6 + v3 * dctCos6 + 128 >> 8;
	    v2 = v2 * dctCos6 - v3 * dctSin6 + 128 >> 8;
	    v3 = t;
	    v4 = v4 + v6 + 1 >> 1;
	    v6 = v4 - v6;
	    v7 = v7 + v5 + 1 >> 1;
	    v5 = v7 - v5;
	    v0 = v0 + v3 + 1 >> 1;
	    v3 = v0 - v3;
	    v1 = v1 + v2 + 1 >> 1;
	    v2 = v1 - v2;
	    t = v4 * dctSin3 + v7 * dctCos3 + 2048 >> 12;
	    v4 = v4 * dctCos3 - v7 * dctSin3 + 2048 >> 12;
	    v7 = t;
	    t = v5 * dctSin1 + v6 * dctCos1 + 2048 >> 12;
	    v5 = v5 * dctCos1 - v6 * dctSin1 + 2048 >> 12;
	    v6 = t;
	    p[row] = v0 + v7;
	    p[row + 7] = v0 - v7;
	    p[row + 1] = v1 + v6;
	    p[row + 6] = v1 - v6;
	    p[row + 2] = v2 + v5;
	    p[row + 5] = v2 - v5;
	    p[row + 3] = v3 + v4;
	    p[row + 4] = v3 - v4;
	  }

	  for (let col = 0; col < 8; ++col) {
	    p0 = p[col];
	    p1 = p[col + 8];
	    p2 = p[col + 16];
	    p3 = p[col + 24];
	    p4 = p[col + 32];
	    p5 = p[col + 40];
	    p6 = p[col + 48];
	    p7 = p[col + 56];

	    if ((p1 | p2 | p3 | p4 | p5 | p6 | p7) === 0) {
	      t = dctSqrt2 * p0 + 8192 >> 14;

	      if (t < -2040) {
	        t = 0;
	      } else if (t >= 2024) {
	        t = 255;
	      } else {
	        t = t + 2056 >> 4;
	      }

	      blockData[blockBufferOffset + col] = t;
	      blockData[blockBufferOffset + col + 8] = t;
	      blockData[blockBufferOffset + col + 16] = t;
	      blockData[blockBufferOffset + col + 24] = t;
	      blockData[blockBufferOffset + col + 32] = t;
	      blockData[blockBufferOffset + col + 40] = t;
	      blockData[blockBufferOffset + col + 48] = t;
	      blockData[blockBufferOffset + col + 56] = t;
	      continue;
	    }

	    v0 = dctSqrt2 * p0 + 2048 >> 12;
	    v1 = dctSqrt2 * p4 + 2048 >> 12;
	    v2 = p2;
	    v3 = p6;
	    v4 = dctSqrt1d2 * (p1 - p7) + 2048 >> 12;
	    v7 = dctSqrt1d2 * (p1 + p7) + 2048 >> 12;
	    v5 = p3;
	    v6 = p5;
	    v0 = (v0 + v1 + 1 >> 1) + 4112;
	    v1 = v0 - v1;
	    t = v2 * dctSin6 + v3 * dctCos6 + 2048 >> 12;
	    v2 = v2 * dctCos6 - v3 * dctSin6 + 2048 >> 12;
	    v3 = t;
	    v4 = v4 + v6 + 1 >> 1;
	    v6 = v4 - v6;
	    v7 = v7 + v5 + 1 >> 1;
	    v5 = v7 - v5;
	    v0 = v0 + v3 + 1 >> 1;
	    v3 = v0 - v3;
	    v1 = v1 + v2 + 1 >> 1;
	    v2 = v1 - v2;
	    t = v4 * dctSin3 + v7 * dctCos3 + 2048 >> 12;
	    v4 = v4 * dctCos3 - v7 * dctSin3 + 2048 >> 12;
	    v7 = t;
	    t = v5 * dctSin1 + v6 * dctCos1 + 2048 >> 12;
	    v5 = v5 * dctCos1 - v6 * dctSin1 + 2048 >> 12;
	    v6 = t;
	    p0 = v0 + v7;
	    p7 = v0 - v7;
	    p1 = v1 + v6;
	    p6 = v1 - v6;
	    p2 = v2 + v5;
	    p5 = v2 - v5;
	    p3 = v3 + v4;
	    p4 = v3 - v4;

	    if (p0 < 16) {
	      p0 = 0;
	    } else if (p0 >= 4080) {
	      p0 = 255;
	    } else {
	      p0 >>= 4;
	    }

	    if (p1 < 16) {
	      p1 = 0;
	    } else if (p1 >= 4080) {
	      p1 = 255;
	    } else {
	      p1 >>= 4;
	    }

	    if (p2 < 16) {
	      p2 = 0;
	    } else if (p2 >= 4080) {
	      p2 = 255;
	    } else {
	      p2 >>= 4;
	    }

	    if (p3 < 16) {
	      p3 = 0;
	    } else if (p3 >= 4080) {
	      p3 = 255;
	    } else {
	      p3 >>= 4;
	    }

	    if (p4 < 16) {
	      p4 = 0;
	    } else if (p4 >= 4080) {
	      p4 = 255;
	    } else {
	      p4 >>= 4;
	    }

	    if (p5 < 16) {
	      p5 = 0;
	    } else if (p5 >= 4080) {
	      p5 = 255;
	    } else {
	      p5 >>= 4;
	    }

	    if (p6 < 16) {
	      p6 = 0;
	    } else if (p6 >= 4080) {
	      p6 = 255;
	    } else {
	      p6 >>= 4;
	    }

	    if (p7 < 16) {
	      p7 = 0;
	    } else if (p7 >= 4080) {
	      p7 = 255;
	    } else {
	      p7 >>= 4;
	    }

	    blockData[blockBufferOffset + col] = p0;
	    blockData[blockBufferOffset + col + 8] = p1;
	    blockData[blockBufferOffset + col + 16] = p2;
	    blockData[blockBufferOffset + col + 24] = p3;
	    blockData[blockBufferOffset + col + 32] = p4;
	    blockData[blockBufferOffset + col + 40] = p5;
	    blockData[blockBufferOffset + col + 48] = p6;
	    blockData[blockBufferOffset + col + 56] = p7;
	  }
	}

	function buildComponentData(frame, component) {
	  const blocksPerLine = component.blocksPerLine;
	  const blocksPerColumn = component.blocksPerColumn;
	  const computationBuffer = new Int16Array(64);

	  for (let blockRow = 0; blockRow < blocksPerColumn; blockRow++) {
	    for (let blockCol = 0; blockCol < blocksPerLine; blockCol++) {
	      const offset = getBlockBufferOffset(component, blockRow, blockCol);
	      quantizeAndInverse(component, offset, computationBuffer);
	    }
	  }

	  return component.blockData;
	}

	function findNextFileMarker(data, currentPos, startPos = currentPos) {
	  const maxPos = data.length - 1;
	  let newPos = startPos < currentPos ? startPos : currentPos;

	  if (currentPos >= maxPos) {
	    return null;
	  }

	  const currentMarker = (0, _core_utils.readUint16)(data, currentPos);

	  if (currentMarker >= 0xffc0 && currentMarker <= 0xfffe) {
	    return {
	      invalid: null,
	      marker: currentMarker,
	      offset: currentPos
	    };
	  }

	  let newMarker = (0, _core_utils.readUint16)(data, newPos);

	  while (!(newMarker >= 0xffc0 && newMarker <= 0xfffe)) {
	    if (++newPos >= maxPos) {
	      return null;
	    }

	    newMarker = (0, _core_utils.readUint16)(data, newPos);
	  }

	  return {
	    invalid: currentMarker.toString(16),
	    marker: newMarker,
	    offset: newPos
	  };
	}

	class JpegImage {
	  constructor({
	    decodeTransform = null,
	    colorTransform = -1
	  } = {}) {
	    this._decodeTransform = decodeTransform;
	    this._colorTransform = colorTransform;
	  }

	  parse(data, {
	    dnlScanLines = null
	  } = {}) {
	    function readDataBlock() {
	      const length = (0, _core_utils.readUint16)(data, offset);
	      offset += 2;
	      let endOffset = offset + length - 2;
	      const fileMarker = findNextFileMarker(data, endOffset, offset);

	      if (fileMarker && fileMarker.invalid) {
	        (0, _util.warn)("readDataBlock - incorrect length, current marker is: " + fileMarker.invalid);
	        endOffset = fileMarker.offset;
	      }

	      const array = data.subarray(offset, endOffset);
	      offset += array.length;
	      return array;
	    }

	    function prepareComponents(frame) {
	      const mcusPerLine = Math.ceil(frame.samplesPerLine / 8 / frame.maxH);
	      const mcusPerColumn = Math.ceil(frame.scanLines / 8 / frame.maxV);

	      for (let i = 0, ii = frame.components.length; i < ii; i++) {
	        const component = frame.components[i];
	        const blocksPerLine = Math.ceil(Math.ceil(frame.samplesPerLine / 8) * component.h / frame.maxH);
	        const blocksPerColumn = Math.ceil(Math.ceil(frame.scanLines / 8) * component.v / frame.maxV);
	        const blocksPerLineForMcu = mcusPerLine * component.h;
	        const blocksPerColumnForMcu = mcusPerColumn * component.v;
	        const blocksBufferSize = 64 * blocksPerColumnForMcu * (blocksPerLineForMcu + 1);
	        component.blockData = new Int16Array(blocksBufferSize);
	        component.blocksPerLine = blocksPerLine;
	        component.blocksPerColumn = blocksPerColumn;
	      }

	      frame.mcusPerLine = mcusPerLine;
	      frame.mcusPerColumn = mcusPerColumn;
	    }

	    let offset = 0;
	    let jfif = null;
	    let adobe = null;
	    let frame, resetInterval;
	    let numSOSMarkers = 0;
	    const quantizationTables = [];
	    const huffmanTablesAC = [],
	          huffmanTablesDC = [];
	    let fileMarker = (0, _core_utils.readUint16)(data, offset);
	    offset += 2;

	    if (fileMarker !== 0xffd8) {
	      throw new JpegError("SOI not found");
	    }

	    fileMarker = (0, _core_utils.readUint16)(data, offset);
	    offset += 2;

	    markerLoop: while (fileMarker !== 0xffd9) {
	      let i, j, l;

	      switch (fileMarker) {
	        case 0xffe0:
	        case 0xffe1:
	        case 0xffe2:
	        case 0xffe3:
	        case 0xffe4:
	        case 0xffe5:
	        case 0xffe6:
	        case 0xffe7:
	        case 0xffe8:
	        case 0xffe9:
	        case 0xffea:
	        case 0xffeb:
	        case 0xffec:
	        case 0xffed:
	        case 0xffee:
	        case 0xffef:
	        case 0xfffe:
	          const appData = readDataBlock();

	          if (fileMarker === 0xffe0) {
	            if (appData[0] === 0x4a && appData[1] === 0x46 && appData[2] === 0x49 && appData[3] === 0x46 && appData[4] === 0) {
	              jfif = {
	                version: {
	                  major: appData[5],
	                  minor: appData[6]
	                },
	                densityUnits: appData[7],
	                xDensity: appData[8] << 8 | appData[9],
	                yDensity: appData[10] << 8 | appData[11],
	                thumbWidth: appData[12],
	                thumbHeight: appData[13],
	                thumbData: appData.subarray(14, 14 + 3 * appData[12] * appData[13])
	              };
	            }
	          }

	          if (fileMarker === 0xffee) {
	            if (appData[0] === 0x41 && appData[1] === 0x64 && appData[2] === 0x6f && appData[3] === 0x62 && appData[4] === 0x65) {
	              adobe = {
	                version: appData[5] << 8 | appData[6],
	                flags0: appData[7] << 8 | appData[8],
	                flags1: appData[9] << 8 | appData[10],
	                transformCode: appData[11]
	              };
	            }
	          }

	          break;

	        case 0xffdb:
	          const quantizationTablesLength = (0, _core_utils.readUint16)(data, offset);
	          offset += 2;
	          const quantizationTablesEnd = quantizationTablesLength + offset - 2;
	          let z;

	          while (offset < quantizationTablesEnd) {
	            const quantizationTableSpec = data[offset++];
	            const tableData = new Uint16Array(64);

	            if (quantizationTableSpec >> 4 === 0) {
	              for (j = 0; j < 64; j++) {
	                z = dctZigZag[j];
	                tableData[z] = data[offset++];
	              }
	            } else if (quantizationTableSpec >> 4 === 1) {
	              for (j = 0; j < 64; j++) {
	                z = dctZigZag[j];
	                tableData[z] = (0, _core_utils.readUint16)(data, offset);
	                offset += 2;
	              }
	            } else {
	              throw new JpegError("DQT - invalid table spec");
	            }

	            quantizationTables[quantizationTableSpec & 15] = tableData;
	          }

	          break;

	        case 0xffc0:
	        case 0xffc1:
	        case 0xffc2:
	          if (frame) {
	            throw new JpegError("Only single frame JPEGs supported");
	          }

	          offset += 2;
	          frame = {};
	          frame.extended = fileMarker === 0xffc1;
	          frame.progressive = fileMarker === 0xffc2;
	          frame.precision = data[offset++];
	          const sofScanLines = (0, _core_utils.readUint16)(data, offset);
	          offset += 2;
	          frame.scanLines = dnlScanLines || sofScanLines;
	          frame.samplesPerLine = (0, _core_utils.readUint16)(data, offset);
	          offset += 2;
	          frame.components = [];
	          frame.componentIds = {};
	          const componentsCount = data[offset++];
	          let maxH = 0,
	              maxV = 0;

	          for (i = 0; i < componentsCount; i++) {
	            const componentId = data[offset];
	            const h = data[offset + 1] >> 4;
	            const v = data[offset + 1] & 15;

	            if (maxH < h) {
	              maxH = h;
	            }

	            if (maxV < v) {
	              maxV = v;
	            }

	            const qId = data[offset + 2];
	            l = frame.components.push({
	              h,
	              v,
	              quantizationId: qId,
	              quantizationTable: null
	            });
	            frame.componentIds[componentId] = l - 1;
	            offset += 3;
	          }

	          frame.maxH = maxH;
	          frame.maxV = maxV;
	          prepareComponents(frame);
	          break;

	        case 0xffc4:
	          const huffmanLength = (0, _core_utils.readUint16)(data, offset);
	          offset += 2;

	          for (i = 2; i < huffmanLength;) {
	            const huffmanTableSpec = data[offset++];
	            const codeLengths = new Uint8Array(16);
	            let codeLengthSum = 0;

	            for (j = 0; j < 16; j++, offset++) {
	              codeLengthSum += codeLengths[j] = data[offset];
	            }

	            const huffmanValues = new Uint8Array(codeLengthSum);

	            for (j = 0; j < codeLengthSum; j++, offset++) {
	              huffmanValues[j] = data[offset];
	            }

	            i += 17 + codeLengthSum;
	            (huffmanTableSpec >> 4 === 0 ? huffmanTablesDC : huffmanTablesAC)[huffmanTableSpec & 15] = buildHuffmanTable(codeLengths, huffmanValues);
	          }

	          break;

	        case 0xffdd:
	          offset += 2;
	          resetInterval = (0, _core_utils.readUint16)(data, offset);
	          offset += 2;
	          break;

	        case 0xffda:
	          const parseDNLMarker = ++numSOSMarkers === 1 && !dnlScanLines;
	          offset += 2;
	          const selectorsCount = data[offset++],
	                components = [];

	          for (i = 0; i < selectorsCount; i++) {
	            const index = data[offset++];
	            const componentIndex = frame.componentIds[index];
	            const component = frame.components[componentIndex];
	            component.index = index;
	            const tableSpec = data[offset++];
	            component.huffmanTableDC = huffmanTablesDC[tableSpec >> 4];
	            component.huffmanTableAC = huffmanTablesAC[tableSpec & 15];
	            components.push(component);
	          }

	          const spectralStart = data[offset++],
	                spectralEnd = data[offset++],
	                successiveApproximation = data[offset++];

	          try {
	            const processed = decodeScan(data, offset, frame, components, resetInterval, spectralStart, spectralEnd, successiveApproximation >> 4, successiveApproximation & 15, parseDNLMarker);
	            offset += processed;
	          } catch (ex) {
	            if (ex instanceof DNLMarkerError) {
	              (0, _util.warn)(`${ex.message} -- attempting to re-parse the JPEG image.`);
	              return this.parse(data, {
	                dnlScanLines: ex.scanLines
	              });
	            } else if (ex instanceof EOIMarkerError) {
	              (0, _util.warn)(`${ex.message} -- ignoring the rest of the image data.`);
	              break markerLoop;
	            }

	            throw ex;
	          }

	          break;

	        case 0xffdc:
	          offset += 4;
	          break;

	        case 0xffff:
	          if (data[offset] !== 0xff) {
	            offset--;
	          }

	          break;

	        default:
	          const nextFileMarker = findNextFileMarker(data, offset - 2, offset - 3);

	          if (nextFileMarker && nextFileMarker.invalid) {
	            (0, _util.warn)("JpegImage.parse - unexpected data, current marker is: " + nextFileMarker.invalid);
	            offset = nextFileMarker.offset;
	            break;
	          }

	          if (!nextFileMarker || offset >= data.length - 1) {
	            (0, _util.warn)("JpegImage.parse - reached the end of the image data " + "without finding an EOI marker (0xFFD9).");
	            break markerLoop;
	          }

	          throw new JpegError("JpegImage.parse - unknown marker: " + fileMarker.toString(16));
	      }

	      fileMarker = (0, _core_utils.readUint16)(data, offset);
	      offset += 2;
	    }

	    this.width = frame.samplesPerLine;
	    this.height = frame.scanLines;
	    this.jfif = jfif;
	    this.adobe = adobe;
	    this.components = [];

	    for (let i = 0, ii = frame.components.length; i < ii; i++) {
	      const component = frame.components[i];
	      const quantizationTable = quantizationTables[component.quantizationId];

	      if (quantizationTable) {
	        component.quantizationTable = quantizationTable;
	      }

	      this.components.push({
	        index: component.index,
	        output: buildComponentData(frame, component),
	        scaleX: component.h / frame.maxH,
	        scaleY: component.v / frame.maxV,
	        blocksPerLine: component.blocksPerLine,
	        blocksPerColumn: component.blocksPerColumn
	      });
	    }

	    this.numComponents = this.components.length;
	    return undefined;
	  }

	  _getLinearizedBlockData(width, height, isSourcePDF = false) {
	    const scaleX = this.width / width,
	          scaleY = this.height / height;
	    let component, componentScaleX, componentScaleY, blocksPerScanline;
	    let x, y, i, j, k;
	    let index;
	    let offset = 0;
	    let output;
	    const numComponents = this.components.length;
	    const dataLength = width * height * numComponents;
	    const data = new Uint8ClampedArray(dataLength);
	    const xScaleBlockOffset = new Uint32Array(width);
	    const mask3LSB = 0xfffffff8;
	    let lastComponentScaleX;

	    for (i = 0; i < numComponents; i++) {
	      component = this.components[i];
	      componentScaleX = component.scaleX * scaleX;
	      componentScaleY = component.scaleY * scaleY;
	      offset = i;
	      output = component.output;
	      blocksPerScanline = component.blocksPerLine + 1 << 3;

	      if (componentScaleX !== lastComponentScaleX) {
	        for (x = 0; x < width; x++) {
	          j = 0 | x * componentScaleX;
	          xScaleBlockOffset[x] = (j & mask3LSB) << 3 | j & 7;
	        }

	        lastComponentScaleX = componentScaleX;
	      }

	      for (y = 0; y < height; y++) {
	        j = 0 | y * componentScaleY;
	        index = blocksPerScanline * (j & mask3LSB) | (j & 7) << 3;

	        for (x = 0; x < width; x++) {
	          data[offset] = output[index + xScaleBlockOffset[x]];
	          offset += numComponents;
	        }
	      }
	    }

	    let transform = this._decodeTransform;

	    if (!isSourcePDF && numComponents === 4 && !transform) {
	      transform = new Int32Array([-256, 255, -256, 255, -256, 255, -256, 255]);
	    }

	    if (transform) {
	      for (i = 0; i < dataLength;) {
	        for (j = 0, k = 0; j < numComponents; j++, i++, k += 2) {
	          data[i] = (data[i] * transform[k] >> 8) + transform[k + 1];
	        }
	      }
	    }

	    return data;
	  }

	  get _isColorConversionNeeded() {
	    if (this.adobe) {
	      return !!this.adobe.transformCode;
	    }

	    if (this.numComponents === 3) {
	      if (this._colorTransform === 0) {
	        return false;
	      } else if (this.components[0].index === 0x52 && this.components[1].index === 0x47 && this.components[2].index === 0x42) {
	        return false;
	      }

	      return true;
	    }

	    if (this._colorTransform === 1) {
	      return true;
	    }

	    return false;
	  }

	  _convertYccToRgb(data) {
	    let Y, Cb, Cr;

	    for (let i = 0, length = data.length; i < length; i += 3) {
	      Y = data[i];
	      Cb = data[i + 1];
	      Cr = data[i + 2];
	      data[i] = Y - 179.456 + 1.402 * Cr;
	      data[i + 1] = Y + 135.459 - 0.344 * Cb - 0.714 * Cr;
	      data[i + 2] = Y - 226.816 + 1.772 * Cb;
	    }

	    return data;
	  }

	  _convertYcckToRgb(data) {
	    let Y, Cb, Cr, k;
	    let offset = 0;

	    for (let i = 0, length = data.length; i < length; i += 4) {
	      Y = data[i];
	      Cb = data[i + 1];
	      Cr = data[i + 2];
	      k = data[i + 3];
	      data[offset++] = -122.67195406894 + Cb * (-6.60635669420364e-5 * Cb + 0.000437130475926232 * Cr - 5.4080610064599e-5 * Y + 0.00048449797120281 * k - 0.154362151871126) + Cr * (-0.000957964378445773 * Cr + 0.000817076911346625 * Y - 0.00477271405408747 * k + 1.53380253221734) + Y * (0.000961250184130688 * Y - 0.00266257332283933 * k + 0.48357088451265) + k * (-0.000336197177618394 * k + 0.484791561490776);
	      data[offset++] = 107.268039397724 + Cb * (2.19927104525741e-5 * Cb - 0.000640992018297945 * Cr + 0.000659397001245577 * Y + 0.000426105652938837 * k - 0.176491792462875) + Cr * (-0.000778269941513683 * Cr + 0.00130872261408275 * Y + 0.000770482631801132 * k - 0.151051492775562) + Y * (0.00126935368114843 * Y - 0.00265090189010898 * k + 0.25802910206845) + k * (-0.000318913117588328 * k - 0.213742400323665);
	      data[offset++] = -20.810012546947 + Cb * (-0.000570115196973677 * Cb - 2.63409051004589e-5 * Cr + 0.0020741088115012 * Y - 0.00288260236853442 * k + 0.814272968359295) + Cr * (-1.53496057440975e-5 * Cr - 0.000132689043961446 * Y + 0.000560833691242812 * k - 0.195152027534049) + Y * (0.00174418132927582 * Y - 0.00255243321439347 * k + 0.116935020465145) + k * (-0.000343531996510555 * k + 0.24165260232407);
	    }

	    return data.subarray(0, offset);
	  }

	  _convertYcckToCmyk(data) {
	    let Y, Cb, Cr;

	    for (let i = 0, length = data.length; i < length; i += 4) {
	      Y = data[i];
	      Cb = data[i + 1];
	      Cr = data[i + 2];
	      data[i] = 434.456 - Y - 1.402 * Cr;
	      data[i + 1] = 119.541 - Y + 0.344 * Cb + 0.714 * Cr;
	      data[i + 2] = 481.816 - Y - 1.772 * Cb;
	    }

	    return data;
	  }

	  _convertCmykToRgb(data) {
	    let c, m, y, k;
	    let offset = 0;

	    for (let i = 0, length = data.length; i < length; i += 4) {
	      c = data[i];
	      m = data[i + 1];
	      y = data[i + 2];
	      k = data[i + 3];
	      data[offset++] = 255 + c * (-0.00006747147073602441 * c + 0.0008379262121013727 * m + 0.0002894718188643294 * y + 0.003264231057537806 * k - 1.1185611867203937) + m * (0.000026374107616089405 * m - 0.00008626949158638572 * y - 0.0002748769067499491 * k - 0.02155688794978967) + y * (-0.00003878099212869363 * y - 0.0003267808279485286 * k + 0.0686742238595345) - k * (0.0003361971776183937 * k + 0.7430659151342254);
	      data[offset++] = 255 + c * (0.00013596372813588848 * c + 0.000924537132573585 * m + 0.00010567359618683593 * y + 0.0004791864687436512 * k - 0.3109689587515875) + m * (-0.00023545346108370344 * m + 0.0002702845253534714 * y + 0.0020200308977307156 * k - 0.7488052167015494) + y * (0.00006834815998235662 * y + 0.00015168452363460973 * k - 0.09751927774728933) - k * (0.0003189131175883281 * k + 0.7364883807733168);
	      data[offset++] = 255 + c * (0.000013598650411385307 * c + 0.00012423956175490851 * m + 0.0004751985097583589 * y - 0.0000036729317476630422 * k - 0.05562186980264034) + m * (0.00016141380598724676 * m + 0.0009692239130725186 * y + 0.0007782692450036253 * k - 0.44015232367526463) + y * (5.068882914068769e-7 * y + 0.0017778369011375071 * k - 0.7591454649749609) - k * (0.0003435319965105553 * k + 0.7063770186160144);
	    }

	    return data.subarray(0, offset);
	  }

	  getData({
	    width,
	    height,
	    forceRGB = false,
	    isSourcePDF = false
	  }) {
	    if (this.numComponents > 4) {
	      throw new JpegError("Unsupported color mode");
	    }

	    const data = this._getLinearizedBlockData(width, height, isSourcePDF);

	    if (this.numComponents === 1 && forceRGB) {
	      const dataLength = data.length;
	      const rgbData = new Uint8ClampedArray(dataLength * 3);
	      let offset = 0;

	      for (let i = 0; i < dataLength; i++) {
	        const grayColor = data[i];
	        rgbData[offset++] = grayColor;
	        rgbData[offset++] = grayColor;
	        rgbData[offset++] = grayColor;
	      }

	      return rgbData;
	    } else if (this.numComponents === 3 && this._isColorConversionNeeded) {
	      return this._convertYccToRgb(data);
	    } else if (this.numComponents === 4) {
	      if (this._isColorConversionNeeded) {
	        if (forceRGB) {
	          return this._convertYcckToRgb(data);
	        }

	        return this._convertYcckToCmyk(data);
	      } else if (forceRGB) {
	        return this._convertCmykToRgb(data);
	      }
	    }

	    return data;
	  }

	}

	exports.JpegImage = JpegImage;

	/***/ }),
	/* 29 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.JpxStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	var _jpx = __w_pdfjs_require__(30);

	var _util = __w_pdfjs_require__(2);

	class JpxStream extends _decode_stream.DecodeStream {
	  constructor(stream, maybeLength, params) {
	    super(maybeLength);
	    this.stream = stream;
	    this.dict = stream.dict;
	    this.maybeLength = maybeLength;
	    this.params = params;
	  }

	  get bytes() {
	    return (0, _util.shadow)(this, "bytes", this.stream.getBytes(this.maybeLength));
	  }

	  ensureBuffer(requested) {}

	  readBlock() {
	    if (this.eof) {
	      return;
	    }

	    const jpxImage = new _jpx.JpxImage();
	    jpxImage.parse(this.bytes);
	    const width = jpxImage.width;
	    const height = jpxImage.height;
	    const componentsCount = jpxImage.componentsCount;
	    const tileCount = jpxImage.tiles.length;

	    if (tileCount === 1) {
	      this.buffer = jpxImage.tiles[0].items;
	    } else {
	      const data = new Uint8ClampedArray(width * height * componentsCount);

	      for (let k = 0; k < tileCount; k++) {
	        const tileComponents = jpxImage.tiles[k];
	        const tileWidth = tileComponents.width;
	        const tileHeight = tileComponents.height;
	        const tileLeft = tileComponents.left;
	        const tileTop = tileComponents.top;
	        const src = tileComponents.items;
	        let srcPosition = 0;
	        let dataPosition = (width * tileTop + tileLeft) * componentsCount;
	        const imgRowSize = width * componentsCount;
	        const tileRowSize = tileWidth * componentsCount;

	        for (let j = 0; j < tileHeight; j++) {
	          const rowBytes = src.subarray(srcPosition, srcPosition + tileRowSize);
	          data.set(rowBytes, dataPosition);
	          srcPosition += tileRowSize;
	          dataPosition += imgRowSize;
	        }
	      }

	      this.buffer = data;
	    }

	    this.bufferLength = this.buffer.length;
	    this.eof = true;
	  }

	}

	exports.JpxStream = JpxStream;

	/***/ }),
	/* 30 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.JpxImage = void 0;

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	var _arithmetic_decoder = __w_pdfjs_require__(26);

	class JpxError extends _util.BaseException {
	  constructor(msg) {
	    super(`JPX error: ${msg}`, "JpxError");
	  }

	}

	const SubbandsGainLog2 = {
	  LL: 0,
	  LH: 1,
	  HL: 1,
	  HH: 2
	};

	class JpxImage {
	  constructor() {
	    this.failOnCorruptedImage = false;
	  }

	  parse(data) {
	    const head = (0, _core_utils.readUint16)(data, 0);

	    if (head === 0xff4f) {
	      this.parseCodestream(data, 0, data.length);
	      return;
	    }

	    const length = data.length;
	    let position = 0;

	    while (position < length) {
	      let headerSize = 8;
	      let lbox = (0, _core_utils.readUint32)(data, position);
	      const tbox = (0, _core_utils.readUint32)(data, position + 4);
	      position += headerSize;

	      if (lbox === 1) {
	        lbox = (0, _core_utils.readUint32)(data, position) * 4294967296 + (0, _core_utils.readUint32)(data, position + 4);
	        position += 8;
	        headerSize += 8;
	      }

	      if (lbox === 0) {
	        lbox = length - position + headerSize;
	      }

	      if (lbox < headerSize) {
	        throw new JpxError("Invalid box field size");
	      }

	      const dataLength = lbox - headerSize;
	      let jumpDataLength = true;

	      switch (tbox) {
	        case 0x6a703268:
	          jumpDataLength = false;
	          break;

	        case 0x636f6c72:
	          const method = data[position];

	          if (method === 1) {
	            const colorspace = (0, _core_utils.readUint32)(data, position + 3);

	            switch (colorspace) {
	              case 16:
	              case 17:
	              case 18:
	                break;

	              default:
	                (0, _util.warn)("Unknown colorspace " + colorspace);
	                break;
	            }
	          } else if (method === 2) {
	            (0, _util.info)("ICC profile not supported");
	          }

	          break;

	        case 0x6a703263:
	          this.parseCodestream(data, position, position + dataLength);
	          break;

	        case 0x6a502020:
	          if ((0, _core_utils.readUint32)(data, position) !== 0x0d0a870a) {
	            (0, _util.warn)("Invalid JP2 signature");
	          }

	          break;

	        case 0x6a501a1a:
	        case 0x66747970:
	        case 0x72726571:
	        case 0x72657320:
	        case 0x69686472:
	          break;

	        default:
	          const headerType = String.fromCharCode(tbox >> 24 & 0xff, tbox >> 16 & 0xff, tbox >> 8 & 0xff, tbox & 0xff);
	          (0, _util.warn)(`Unsupported header type ${tbox} (${headerType}).`);
	          break;
	      }

	      if (jumpDataLength) {
	        position += dataLength;
	      }
	    }
	  }

	  parseImageProperties(stream) {
	    let newByte = stream.getByte();

	    while (newByte >= 0) {
	      const oldByte = newByte;
	      newByte = stream.getByte();
	      const code = oldByte << 8 | newByte;

	      if (code === 0xff51) {
	        stream.skip(4);
	        const Xsiz = stream.getInt32() >>> 0;
	        const Ysiz = stream.getInt32() >>> 0;
	        const XOsiz = stream.getInt32() >>> 0;
	        const YOsiz = stream.getInt32() >>> 0;
	        stream.skip(16);
	        const Csiz = stream.getUint16();
	        this.width = Xsiz - XOsiz;
	        this.height = Ysiz - YOsiz;
	        this.componentsCount = Csiz;
	        this.bitsPerComponent = 8;
	        return;
	      }
	    }

	    throw new JpxError("No size marker found in JPX stream");
	  }

	  parseCodestream(data, start, end) {
	    const context = {};
	    let doNotRecover = false;

	    try {
	      let position = start;

	      while (position + 1 < end) {
	        const code = (0, _core_utils.readUint16)(data, position);
	        position += 2;
	        let length = 0,
	            j,
	            sqcd,
	            spqcds,
	            spqcdSize,
	            scalarExpounded,
	            tile;

	        switch (code) {
	          case 0xff4f:
	            context.mainHeader = true;
	            break;

	          case 0xffd9:
	            break;

	          case 0xff51:
	            length = (0, _core_utils.readUint16)(data, position);
	            const siz = {};
	            siz.Xsiz = (0, _core_utils.readUint32)(data, position + 4);
	            siz.Ysiz = (0, _core_utils.readUint32)(data, position + 8);
	            siz.XOsiz = (0, _core_utils.readUint32)(data, position + 12);
	            siz.YOsiz = (0, _core_utils.readUint32)(data, position + 16);
	            siz.XTsiz = (0, _core_utils.readUint32)(data, position + 20);
	            siz.YTsiz = (0, _core_utils.readUint32)(data, position + 24);
	            siz.XTOsiz = (0, _core_utils.readUint32)(data, position + 28);
	            siz.YTOsiz = (0, _core_utils.readUint32)(data, position + 32);
	            const componentsCount = (0, _core_utils.readUint16)(data, position + 36);
	            siz.Csiz = componentsCount;
	            const components = [];
	            j = position + 38;

	            for (let i = 0; i < componentsCount; i++) {
	              const component = {
	                precision: (data[j] & 0x7f) + 1,
	                isSigned: !!(data[j] & 0x80),
	                XRsiz: data[j + 1],
	                YRsiz: data[j + 2]
	              };
	              j += 3;
	              calculateComponentDimensions(component, siz);
	              components.push(component);
	            }

	            context.SIZ = siz;
	            context.components = components;
	            calculateTileGrids(context, components);
	            context.QCC = [];
	            context.COC = [];
	            break;

	          case 0xff5c:
	            length = (0, _core_utils.readUint16)(data, position);
	            const qcd = {};
	            j = position + 2;
	            sqcd = data[j++];

	            switch (sqcd & 0x1f) {
	              case 0:
	                spqcdSize = 8;
	                scalarExpounded = true;
	                break;

	              case 1:
	                spqcdSize = 16;
	                scalarExpounded = false;
	                break;

	              case 2:
	                spqcdSize = 16;
	                scalarExpounded = true;
	                break;

	              default:
	                throw new Error("Invalid SQcd value " + sqcd);
	            }

	            qcd.noQuantization = spqcdSize === 8;
	            qcd.scalarExpounded = scalarExpounded;
	            qcd.guardBits = sqcd >> 5;
	            spqcds = [];

	            while (j < length + position) {
	              const spqcd = {};

	              if (spqcdSize === 8) {
	                spqcd.epsilon = data[j++] >> 3;
	                spqcd.mu = 0;
	              } else {
	                spqcd.epsilon = data[j] >> 3;
	                spqcd.mu = (data[j] & 0x7) << 8 | data[j + 1];
	                j += 2;
	              }

	              spqcds.push(spqcd);
	            }

	            qcd.SPqcds = spqcds;

	            if (context.mainHeader) {
	              context.QCD = qcd;
	            } else {
	              context.currentTile.QCD = qcd;
	              context.currentTile.QCC = [];
	            }

	            break;

	          case 0xff5d:
	            length = (0, _core_utils.readUint16)(data, position);
	            const qcc = {};
	            j = position + 2;
	            let cqcc;

	            if (context.SIZ.Csiz < 257) {
	              cqcc = data[j++];
	            } else {
	              cqcc = (0, _core_utils.readUint16)(data, j);
	              j += 2;
	            }

	            sqcd = data[j++];

	            switch (sqcd & 0x1f) {
	              case 0:
	                spqcdSize = 8;
	                scalarExpounded = true;
	                break;

	              case 1:
	                spqcdSize = 16;
	                scalarExpounded = false;
	                break;

	              case 2:
	                spqcdSize = 16;
	                scalarExpounded = true;
	                break;

	              default:
	                throw new Error("Invalid SQcd value " + sqcd);
	            }

	            qcc.noQuantization = spqcdSize === 8;
	            qcc.scalarExpounded = scalarExpounded;
	            qcc.guardBits = sqcd >> 5;
	            spqcds = [];

	            while (j < length + position) {
	              const spqcd = {};

	              if (spqcdSize === 8) {
	                spqcd.epsilon = data[j++] >> 3;
	                spqcd.mu = 0;
	              } else {
	                spqcd.epsilon = data[j] >> 3;
	                spqcd.mu = (data[j] & 0x7) << 8 | data[j + 1];
	                j += 2;
	              }

	              spqcds.push(spqcd);
	            }

	            qcc.SPqcds = spqcds;

	            if (context.mainHeader) {
	              context.QCC[cqcc] = qcc;
	            } else {
	              context.currentTile.QCC[cqcc] = qcc;
	            }

	            break;

	          case 0xff52:
	            length = (0, _core_utils.readUint16)(data, position);
	            const cod = {};
	            j = position + 2;
	            const scod = data[j++];
	            cod.entropyCoderWithCustomPrecincts = !!(scod & 1);
	            cod.sopMarkerUsed = !!(scod & 2);
	            cod.ephMarkerUsed = !!(scod & 4);
	            cod.progressionOrder = data[j++];
	            cod.layersCount = (0, _core_utils.readUint16)(data, j);
	            j += 2;
	            cod.multipleComponentTransform = data[j++];
	            cod.decompositionLevelsCount = data[j++];
	            cod.xcb = (data[j++] & 0xf) + 2;
	            cod.ycb = (data[j++] & 0xf) + 2;
	            const blockStyle = data[j++];
	            cod.selectiveArithmeticCodingBypass = !!(blockStyle & 1);
	            cod.resetContextProbabilities = !!(blockStyle & 2);
	            cod.terminationOnEachCodingPass = !!(blockStyle & 4);
	            cod.verticallyStripe = !!(blockStyle & 8);
	            cod.predictableTermination = !!(blockStyle & 16);
	            cod.segmentationSymbolUsed = !!(blockStyle & 32);
	            cod.reversibleTransformation = data[j++];

	            if (cod.entropyCoderWithCustomPrecincts) {
	              const precinctsSizes = [];

	              while (j < length + position) {
	                const precinctsSize = data[j++];
	                precinctsSizes.push({
	                  PPx: precinctsSize & 0xf,
	                  PPy: precinctsSize >> 4
	                });
	              }

	              cod.precinctsSizes = precinctsSizes;
	            }

	            const unsupported = [];

	            if (cod.selectiveArithmeticCodingBypass) {
	              unsupported.push("selectiveArithmeticCodingBypass");
	            }

	            if (cod.terminationOnEachCodingPass) {
	              unsupported.push("terminationOnEachCodingPass");
	            }

	            if (cod.verticallyStripe) {
	              unsupported.push("verticallyStripe");
	            }

	            if (cod.predictableTermination) {
	              unsupported.push("predictableTermination");
	            }

	            if (unsupported.length > 0) {
	              doNotRecover = true;
	              (0, _util.warn)(`JPX: Unsupported COD options (${unsupported.join(", ")}).`);
	            }

	            if (context.mainHeader) {
	              context.COD = cod;
	            } else {
	              context.currentTile.COD = cod;
	              context.currentTile.COC = [];
	            }

	            break;

	          case 0xff90:
	            length = (0, _core_utils.readUint16)(data, position);
	            tile = {};
	            tile.index = (0, _core_utils.readUint16)(data, position + 2);
	            tile.length = (0, _core_utils.readUint32)(data, position + 4);
	            tile.dataEnd = tile.length + position - 2;
	            tile.partIndex = data[position + 8];
	            tile.partsCount = data[position + 9];
	            context.mainHeader = false;

	            if (tile.partIndex === 0) {
	              tile.COD = context.COD;
	              tile.COC = context.COC.slice(0);
	              tile.QCD = context.QCD;
	              tile.QCC = context.QCC.slice(0);
	            }

	            context.currentTile = tile;
	            break;

	          case 0xff93:
	            tile = context.currentTile;

	            if (tile.partIndex === 0) {
	              initializeTile(context, tile.index);
	              buildPackets(context);
	            }

	            length = tile.dataEnd - position;
	            parseTilePackets(context, data, position, length);
	            break;

	          case 0xff53:
	            (0, _util.warn)("JPX: Codestream code 0xFF53 (COC) is not implemented.");

	          case 0xff55:
	          case 0xff57:
	          case 0xff58:
	          case 0xff64:
	            length = (0, _core_utils.readUint16)(data, position);
	            break;

	          default:
	            throw new Error("Unknown codestream code: " + code.toString(16));
	        }

	        position += length;
	      }
	    } catch (e) {
	      if (doNotRecover || this.failOnCorruptedImage) {
	        throw new JpxError(e.message);
	      } else {
	        (0, _util.warn)(`JPX: Trying to recover from: "${e.message}".`);
	      }
	    }

	    this.tiles = transformComponents(context);
	    this.width = context.SIZ.Xsiz - context.SIZ.XOsiz;
	    this.height = context.SIZ.Ysiz - context.SIZ.YOsiz;
	    this.componentsCount = context.SIZ.Csiz;
	  }

	}

	exports.JpxImage = JpxImage;

	function calculateComponentDimensions(component, siz) {
	  component.x0 = Math.ceil(siz.XOsiz / component.XRsiz);
	  component.x1 = Math.ceil(siz.Xsiz / component.XRsiz);
	  component.y0 = Math.ceil(siz.YOsiz / component.YRsiz);
	  component.y1 = Math.ceil(siz.Ysiz / component.YRsiz);
	  component.width = component.x1 - component.x0;
	  component.height = component.y1 - component.y0;
	}

	function calculateTileGrids(context, components) {
	  const siz = context.SIZ;
	  const tiles = [];
	  let tile;
	  const numXtiles = Math.ceil((siz.Xsiz - siz.XTOsiz) / siz.XTsiz);
	  const numYtiles = Math.ceil((siz.Ysiz - siz.YTOsiz) / siz.YTsiz);

	  for (let q = 0; q < numYtiles; q++) {
	    for (let p = 0; p < numXtiles; p++) {
	      tile = {};
	      tile.tx0 = Math.max(siz.XTOsiz + p * siz.XTsiz, siz.XOsiz);
	      tile.ty0 = Math.max(siz.YTOsiz + q * siz.YTsiz, siz.YOsiz);
	      tile.tx1 = Math.min(siz.XTOsiz + (p + 1) * siz.XTsiz, siz.Xsiz);
	      tile.ty1 = Math.min(siz.YTOsiz + (q + 1) * siz.YTsiz, siz.Ysiz);
	      tile.width = tile.tx1 - tile.tx0;
	      tile.height = tile.ty1 - tile.ty0;
	      tile.components = [];
	      tiles.push(tile);
	    }
	  }

	  context.tiles = tiles;
	  const componentsCount = siz.Csiz;

	  for (let i = 0, ii = componentsCount; i < ii; i++) {
	    const component = components[i];

	    for (let j = 0, jj = tiles.length; j < jj; j++) {
	      const tileComponent = {};
	      tile = tiles[j];
	      tileComponent.tcx0 = Math.ceil(tile.tx0 / component.XRsiz);
	      tileComponent.tcy0 = Math.ceil(tile.ty0 / component.YRsiz);
	      tileComponent.tcx1 = Math.ceil(tile.tx1 / component.XRsiz);
	      tileComponent.tcy1 = Math.ceil(tile.ty1 / component.YRsiz);
	      tileComponent.width = tileComponent.tcx1 - tileComponent.tcx0;
	      tileComponent.height = tileComponent.tcy1 - tileComponent.tcy0;
	      tile.components[i] = tileComponent;
	    }
	  }
	}

	function getBlocksDimensions(context, component, r) {
	  const codOrCoc = component.codingStyleParameters;
	  const result = {};

	  if (!codOrCoc.entropyCoderWithCustomPrecincts) {
	    result.PPx = 15;
	    result.PPy = 15;
	  } else {
	    result.PPx = codOrCoc.precinctsSizes[r].PPx;
	    result.PPy = codOrCoc.precinctsSizes[r].PPy;
	  }

	  result.xcb_ = r > 0 ? Math.min(codOrCoc.xcb, result.PPx - 1) : Math.min(codOrCoc.xcb, result.PPx);
	  result.ycb_ = r > 0 ? Math.min(codOrCoc.ycb, result.PPy - 1) : Math.min(codOrCoc.ycb, result.PPy);
	  return result;
	}

	function buildPrecincts(context, resolution, dimensions) {
	  const precinctWidth = 1 << dimensions.PPx;
	  const precinctHeight = 1 << dimensions.PPy;
	  const isZeroRes = resolution.resLevel === 0;
	  const precinctWidthInSubband = 1 << dimensions.PPx + (isZeroRes ? 0 : -1);
	  const precinctHeightInSubband = 1 << dimensions.PPy + (isZeroRes ? 0 : -1);
	  const numprecinctswide = resolution.trx1 > resolution.trx0 ? Math.ceil(resolution.trx1 / precinctWidth) - Math.floor(resolution.trx0 / precinctWidth) : 0;
	  const numprecinctshigh = resolution.try1 > resolution.try0 ? Math.ceil(resolution.try1 / precinctHeight) - Math.floor(resolution.try0 / precinctHeight) : 0;
	  const numprecincts = numprecinctswide * numprecinctshigh;
	  resolution.precinctParameters = {
	    precinctWidth,
	    precinctHeight,
	    numprecinctswide,
	    numprecinctshigh,
	    numprecincts,
	    precinctWidthInSubband,
	    precinctHeightInSubband
	  };
	}

	function buildCodeblocks(context, subband, dimensions) {
	  const xcb_ = dimensions.xcb_;
	  const ycb_ = dimensions.ycb_;
	  const codeblockWidth = 1 << xcb_;
	  const codeblockHeight = 1 << ycb_;
	  const cbx0 = subband.tbx0 >> xcb_;
	  const cby0 = subband.tby0 >> ycb_;
	  const cbx1 = subband.tbx1 + codeblockWidth - 1 >> xcb_;
	  const cby1 = subband.tby1 + codeblockHeight - 1 >> ycb_;
	  const precinctParameters = subband.resolution.precinctParameters;
	  const codeblocks = [];
	  const precincts = [];
	  let i, j, codeblock, precinctNumber;

	  for (j = cby0; j < cby1; j++) {
	    for (i = cbx0; i < cbx1; i++) {
	      codeblock = {
	        cbx: i,
	        cby: j,
	        tbx0: codeblockWidth * i,
	        tby0: codeblockHeight * j,
	        tbx1: codeblockWidth * (i + 1),
	        tby1: codeblockHeight * (j + 1)
	      };
	      codeblock.tbx0_ = Math.max(subband.tbx0, codeblock.tbx0);
	      codeblock.tby0_ = Math.max(subband.tby0, codeblock.tby0);
	      codeblock.tbx1_ = Math.min(subband.tbx1, codeblock.tbx1);
	      codeblock.tby1_ = Math.min(subband.tby1, codeblock.tby1);
	      const pi = Math.floor((codeblock.tbx0_ - subband.tbx0) / precinctParameters.precinctWidthInSubband);
	      const pj = Math.floor((codeblock.tby0_ - subband.tby0) / precinctParameters.precinctHeightInSubband);
	      precinctNumber = pi + pj * precinctParameters.numprecinctswide;
	      codeblock.precinctNumber = precinctNumber;
	      codeblock.subbandType = subband.type;
	      codeblock.Lblock = 3;

	      if (codeblock.tbx1_ <= codeblock.tbx0_ || codeblock.tby1_ <= codeblock.tby0_) {
	        continue;
	      }

	      codeblocks.push(codeblock);
	      let precinct = precincts[precinctNumber];

	      if (precinct !== undefined) {
	        if (i < precinct.cbxMin) {
	          precinct.cbxMin = i;
	        } else if (i > precinct.cbxMax) {
	          precinct.cbxMax = i;
	        }

	        if (j < precinct.cbyMin) {
	          precinct.cbxMin = j;
	        } else if (j > precinct.cbyMax) {
	          precinct.cbyMax = j;
	        }
	      } else {
	        precincts[precinctNumber] = precinct = {
	          cbxMin: i,
	          cbyMin: j,
	          cbxMax: i,
	          cbyMax: j
	        };
	      }

	      codeblock.precinct = precinct;
	    }
	  }

	  subband.codeblockParameters = {
	    codeblockWidth: xcb_,
	    codeblockHeight: ycb_,
	    numcodeblockwide: cbx1 - cbx0 + 1,
	    numcodeblockhigh: cby1 - cby0 + 1
	  };
	  subband.codeblocks = codeblocks;
	  subband.precincts = precincts;
	}

	function createPacket(resolution, precinctNumber, layerNumber) {
	  const precinctCodeblocks = [];
	  const subbands = resolution.subbands;

	  for (let i = 0, ii = subbands.length; i < ii; i++) {
	    const subband = subbands[i];
	    const codeblocks = subband.codeblocks;

	    for (let j = 0, jj = codeblocks.length; j < jj; j++) {
	      const codeblock = codeblocks[j];

	      if (codeblock.precinctNumber !== precinctNumber) {
	        continue;
	      }

	      precinctCodeblocks.push(codeblock);
	    }
	  }

	  return {
	    layerNumber,
	    codeblocks: precinctCodeblocks
	  };
	}

	function LayerResolutionComponentPositionIterator(context) {
	  const siz = context.SIZ;
	  const tileIndex = context.currentTile.index;
	  const tile = context.tiles[tileIndex];
	  const layersCount = tile.codingStyleDefaultParameters.layersCount;
	  const componentsCount = siz.Csiz;
	  let maxDecompositionLevelsCount = 0;

	  for (let q = 0; q < componentsCount; q++) {
	    maxDecompositionLevelsCount = Math.max(maxDecompositionLevelsCount, tile.components[q].codingStyleParameters.decompositionLevelsCount);
	  }

	  let l = 0,
	      r = 0,
	      i = 0,
	      k = 0;

	  this.nextPacket = function JpxImage_nextPacket() {
	    for (; l < layersCount; l++) {
	      for (; r <= maxDecompositionLevelsCount; r++) {
	        for (; i < componentsCount; i++) {
	          const component = tile.components[i];

	          if (r > component.codingStyleParameters.decompositionLevelsCount) {
	            continue;
	          }

	          const resolution = component.resolutions[r];
	          const numprecincts = resolution.precinctParameters.numprecincts;

	          for (; k < numprecincts;) {
	            const packet = createPacket(resolution, k, l);
	            k++;
	            return packet;
	          }

	          k = 0;
	        }

	        i = 0;
	      }

	      r = 0;
	    }

	    throw new JpxError("Out of packets");
	  };
	}

	function ResolutionLayerComponentPositionIterator(context) {
	  const siz = context.SIZ;
	  const tileIndex = context.currentTile.index;
	  const tile = context.tiles[tileIndex];
	  const layersCount = tile.codingStyleDefaultParameters.layersCount;
	  const componentsCount = siz.Csiz;
	  let maxDecompositionLevelsCount = 0;

	  for (let q = 0; q < componentsCount; q++) {
	    maxDecompositionLevelsCount = Math.max(maxDecompositionLevelsCount, tile.components[q].codingStyleParameters.decompositionLevelsCount);
	  }

	  let r = 0,
	      l = 0,
	      i = 0,
	      k = 0;

	  this.nextPacket = function JpxImage_nextPacket() {
	    for (; r <= maxDecompositionLevelsCount; r++) {
	      for (; l < layersCount; l++) {
	        for (; i < componentsCount; i++) {
	          const component = tile.components[i];

	          if (r > component.codingStyleParameters.decompositionLevelsCount) {
	            continue;
	          }

	          const resolution = component.resolutions[r];
	          const numprecincts = resolution.precinctParameters.numprecincts;

	          for (; k < numprecincts;) {
	            const packet = createPacket(resolution, k, l);
	            k++;
	            return packet;
	          }

	          k = 0;
	        }

	        i = 0;
	      }

	      l = 0;
	    }

	    throw new JpxError("Out of packets");
	  };
	}

	function ResolutionPositionComponentLayerIterator(context) {
	  const siz = context.SIZ;
	  const tileIndex = context.currentTile.index;
	  const tile = context.tiles[tileIndex];
	  const layersCount = tile.codingStyleDefaultParameters.layersCount;
	  const componentsCount = siz.Csiz;
	  let l, r, c, p;
	  let maxDecompositionLevelsCount = 0;

	  for (c = 0; c < componentsCount; c++) {
	    const component = tile.components[c];
	    maxDecompositionLevelsCount = Math.max(maxDecompositionLevelsCount, component.codingStyleParameters.decompositionLevelsCount);
	  }

	  const maxNumPrecinctsInLevel = new Int32Array(maxDecompositionLevelsCount + 1);

	  for (r = 0; r <= maxDecompositionLevelsCount; ++r) {
	    let maxNumPrecincts = 0;

	    for (c = 0; c < componentsCount; ++c) {
	      const resolutions = tile.components[c].resolutions;

	      if (r < resolutions.length) {
	        maxNumPrecincts = Math.max(maxNumPrecincts, resolutions[r].precinctParameters.numprecincts);
	      }
	    }

	    maxNumPrecinctsInLevel[r] = maxNumPrecincts;
	  }

	  l = 0;
	  r = 0;
	  c = 0;
	  p = 0;

	  this.nextPacket = function JpxImage_nextPacket() {
	    for (; r <= maxDecompositionLevelsCount; r++) {
	      for (; p < maxNumPrecinctsInLevel[r]; p++) {
	        for (; c < componentsCount; c++) {
	          const component = tile.components[c];

	          if (r > component.codingStyleParameters.decompositionLevelsCount) {
	            continue;
	          }

	          const resolution = component.resolutions[r];
	          const numprecincts = resolution.precinctParameters.numprecincts;

	          if (p >= numprecincts) {
	            continue;
	          }

	          for (; l < layersCount;) {
	            const packet = createPacket(resolution, p, l);
	            l++;
	            return packet;
	          }

	          l = 0;
	        }

	        c = 0;
	      }

	      p = 0;
	    }

	    throw new JpxError("Out of packets");
	  };
	}

	function PositionComponentResolutionLayerIterator(context) {
	  const siz = context.SIZ;
	  const tileIndex = context.currentTile.index;
	  const tile = context.tiles[tileIndex];
	  const layersCount = tile.codingStyleDefaultParameters.layersCount;
	  const componentsCount = siz.Csiz;
	  const precinctsSizes = getPrecinctSizesInImageScale(tile);
	  const precinctsIterationSizes = precinctsSizes;
	  let l = 0,
	      r = 0,
	      c = 0,
	      px = 0,
	      py = 0;

	  this.nextPacket = function JpxImage_nextPacket() {
	    for (; py < precinctsIterationSizes.maxNumHigh; py++) {
	      for (; px < precinctsIterationSizes.maxNumWide; px++) {
	        for (; c < componentsCount; c++) {
	          const component = tile.components[c];
	          const decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;

	          for (; r <= decompositionLevelsCount; r++) {
	            const resolution = component.resolutions[r];
	            const sizeInImageScale = precinctsSizes.components[c].resolutions[r];
	            const k = getPrecinctIndexIfExist(px, py, sizeInImageScale, precinctsIterationSizes, resolution);

	            if (k === null) {
	              continue;
	            }

	            for (; l < layersCount;) {
	              const packet = createPacket(resolution, k, l);
	              l++;
	              return packet;
	            }

	            l = 0;
	          }

	          r = 0;
	        }

	        c = 0;
	      }

	      px = 0;
	    }

	    throw new JpxError("Out of packets");
	  };
	}

	function ComponentPositionResolutionLayerIterator(context) {
	  const siz = context.SIZ;
	  const tileIndex = context.currentTile.index;
	  const tile = context.tiles[tileIndex];
	  const layersCount = tile.codingStyleDefaultParameters.layersCount;
	  const componentsCount = siz.Csiz;
	  const precinctsSizes = getPrecinctSizesInImageScale(tile);
	  let l = 0,
	      r = 0,
	      c = 0,
	      px = 0,
	      py = 0;

	  this.nextPacket = function JpxImage_nextPacket() {
	    for (; c < componentsCount; ++c) {
	      const component = tile.components[c];
	      const precinctsIterationSizes = precinctsSizes.components[c];
	      const decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;

	      for (; py < precinctsIterationSizes.maxNumHigh; py++) {
	        for (; px < precinctsIterationSizes.maxNumWide; px++) {
	          for (; r <= decompositionLevelsCount; r++) {
	            const resolution = component.resolutions[r];
	            const sizeInImageScale = precinctsIterationSizes.resolutions[r];
	            const k = getPrecinctIndexIfExist(px, py, sizeInImageScale, precinctsIterationSizes, resolution);

	            if (k === null) {
	              continue;
	            }

	            for (; l < layersCount;) {
	              const packet = createPacket(resolution, k, l);
	              l++;
	              return packet;
	            }

	            l = 0;
	          }

	          r = 0;
	        }

	        px = 0;
	      }

	      py = 0;
	    }

	    throw new JpxError("Out of packets");
	  };
	}

	function getPrecinctIndexIfExist(pxIndex, pyIndex, sizeInImageScale, precinctIterationSizes, resolution) {
	  const posX = pxIndex * precinctIterationSizes.minWidth;
	  const posY = pyIndex * precinctIterationSizes.minHeight;

	  if (posX % sizeInImageScale.width !== 0 || posY % sizeInImageScale.height !== 0) {
	    return null;
	  }

	  const startPrecinctRowIndex = posY / sizeInImageScale.width * resolution.precinctParameters.numprecinctswide;
	  return posX / sizeInImageScale.height + startPrecinctRowIndex;
	}

	function getPrecinctSizesInImageScale(tile) {
	  const componentsCount = tile.components.length;
	  let minWidth = Number.MAX_VALUE;
	  let minHeight = Number.MAX_VALUE;
	  let maxNumWide = 0;
	  let maxNumHigh = 0;
	  const sizePerComponent = new Array(componentsCount);

	  for (let c = 0; c < componentsCount; c++) {
	    const component = tile.components[c];
	    const decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;
	    const sizePerResolution = new Array(decompositionLevelsCount + 1);
	    let minWidthCurrentComponent = Number.MAX_VALUE;
	    let minHeightCurrentComponent = Number.MAX_VALUE;
	    let maxNumWideCurrentComponent = 0;
	    let maxNumHighCurrentComponent = 0;
	    let scale = 1;

	    for (let r = decompositionLevelsCount; r >= 0; --r) {
	      const resolution = component.resolutions[r];
	      const widthCurrentResolution = scale * resolution.precinctParameters.precinctWidth;
	      const heightCurrentResolution = scale * resolution.precinctParameters.precinctHeight;
	      minWidthCurrentComponent = Math.min(minWidthCurrentComponent, widthCurrentResolution);
	      minHeightCurrentComponent = Math.min(minHeightCurrentComponent, heightCurrentResolution);
	      maxNumWideCurrentComponent = Math.max(maxNumWideCurrentComponent, resolution.precinctParameters.numprecinctswide);
	      maxNumHighCurrentComponent = Math.max(maxNumHighCurrentComponent, resolution.precinctParameters.numprecinctshigh);
	      sizePerResolution[r] = {
	        width: widthCurrentResolution,
	        height: heightCurrentResolution
	      };
	      scale <<= 1;
	    }

	    minWidth = Math.min(minWidth, minWidthCurrentComponent);
	    minHeight = Math.min(minHeight, minHeightCurrentComponent);
	    maxNumWide = Math.max(maxNumWide, maxNumWideCurrentComponent);
	    maxNumHigh = Math.max(maxNumHigh, maxNumHighCurrentComponent);
	    sizePerComponent[c] = {
	      resolutions: sizePerResolution,
	      minWidth: minWidthCurrentComponent,
	      minHeight: minHeightCurrentComponent,
	      maxNumWide: maxNumWideCurrentComponent,
	      maxNumHigh: maxNumHighCurrentComponent
	    };
	  }

	  return {
	    components: sizePerComponent,
	    minWidth,
	    minHeight,
	    maxNumWide,
	    maxNumHigh
	  };
	}

	function buildPackets(context) {
	  const siz = context.SIZ;
	  const tileIndex = context.currentTile.index;
	  const tile = context.tiles[tileIndex];
	  const componentsCount = siz.Csiz;

	  for (let c = 0; c < componentsCount; c++) {
	    const component = tile.components[c];
	    const decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;
	    const resolutions = [];
	    const subbands = [];

	    for (let r = 0; r <= decompositionLevelsCount; r++) {
	      const blocksDimensions = getBlocksDimensions(context, component, r);
	      const resolution = {};
	      const scale = 1 << decompositionLevelsCount - r;
	      resolution.trx0 = Math.ceil(component.tcx0 / scale);
	      resolution.try0 = Math.ceil(component.tcy0 / scale);
	      resolution.trx1 = Math.ceil(component.tcx1 / scale);
	      resolution.try1 = Math.ceil(component.tcy1 / scale);
	      resolution.resLevel = r;
	      buildPrecincts(context, resolution, blocksDimensions);
	      resolutions.push(resolution);
	      let subband;

	      if (r === 0) {
	        subband = {};
	        subband.type = "LL";
	        subband.tbx0 = Math.ceil(component.tcx0 / scale);
	        subband.tby0 = Math.ceil(component.tcy0 / scale);
	        subband.tbx1 = Math.ceil(component.tcx1 / scale);
	        subband.tby1 = Math.ceil(component.tcy1 / scale);
	        subband.resolution = resolution;
	        buildCodeblocks(context, subband, blocksDimensions);
	        subbands.push(subband);
	        resolution.subbands = [subband];
	      } else {
	        const bscale = 1 << decompositionLevelsCount - r + 1;
	        const resolutionSubbands = [];
	        subband = {};
	        subband.type = "HL";
	        subband.tbx0 = Math.ceil(component.tcx0 / bscale - 0.5);
	        subband.tby0 = Math.ceil(component.tcy0 / bscale);
	        subband.tbx1 = Math.ceil(component.tcx1 / bscale - 0.5);
	        subband.tby1 = Math.ceil(component.tcy1 / bscale);
	        subband.resolution = resolution;
	        buildCodeblocks(context, subband, blocksDimensions);
	        subbands.push(subband);
	        resolutionSubbands.push(subband);
	        subband = {};
	        subband.type = "LH";
	        subband.tbx0 = Math.ceil(component.tcx0 / bscale);
	        subband.tby0 = Math.ceil(component.tcy0 / bscale - 0.5);
	        subband.tbx1 = Math.ceil(component.tcx1 / bscale);
	        subband.tby1 = Math.ceil(component.tcy1 / bscale - 0.5);
	        subband.resolution = resolution;
	        buildCodeblocks(context, subband, blocksDimensions);
	        subbands.push(subband);
	        resolutionSubbands.push(subband);
	        subband = {};
	        subband.type = "HH";
	        subband.tbx0 = Math.ceil(component.tcx0 / bscale - 0.5);
	        subband.tby0 = Math.ceil(component.tcy0 / bscale - 0.5);
	        subband.tbx1 = Math.ceil(component.tcx1 / bscale - 0.5);
	        subband.tby1 = Math.ceil(component.tcy1 / bscale - 0.5);
	        subband.resolution = resolution;
	        buildCodeblocks(context, subband, blocksDimensions);
	        subbands.push(subband);
	        resolutionSubbands.push(subband);
	        resolution.subbands = resolutionSubbands;
	      }
	    }

	    component.resolutions = resolutions;
	    component.subbands = subbands;
	  }

	  const progressionOrder = tile.codingStyleDefaultParameters.progressionOrder;

	  switch (progressionOrder) {
	    case 0:
	      tile.packetsIterator = new LayerResolutionComponentPositionIterator(context);
	      break;

	    case 1:
	      tile.packetsIterator = new ResolutionLayerComponentPositionIterator(context);
	      break;

	    case 2:
	      tile.packetsIterator = new ResolutionPositionComponentLayerIterator(context);
	      break;

	    case 3:
	      tile.packetsIterator = new PositionComponentResolutionLayerIterator(context);
	      break;

	    case 4:
	      tile.packetsIterator = new ComponentPositionResolutionLayerIterator(context);
	      break;

	    default:
	      throw new JpxError(`Unsupported progression order ${progressionOrder}`);
	  }
	}

	function parseTilePackets(context, data, offset, dataLength) {
	  let position = 0;
	  let buffer,
	      bufferSize = 0,
	      skipNextBit = false;

	  function readBits(count) {
	    while (bufferSize < count) {
	      const b = data[offset + position];
	      position++;

	      if (skipNextBit) {
	        buffer = buffer << 7 | b;
	        bufferSize += 7;
	        skipNextBit = false;
	      } else {
	        buffer = buffer << 8 | b;
	        bufferSize += 8;
	      }

	      if (b === 0xff) {
	        skipNextBit = true;
	      }
	    }

	    bufferSize -= count;
	    return buffer >>> bufferSize & (1 << count) - 1;
	  }

	  function skipMarkerIfEqual(value) {
	    if (data[offset + position - 1] === 0xff && data[offset + position] === value) {
	      skipBytes(1);
	      return true;
	    } else if (data[offset + position] === 0xff && data[offset + position + 1] === value) {
	      skipBytes(2);
	      return true;
	    }

	    return false;
	  }

	  function skipBytes(count) {
	    position += count;
	  }

	  function alignToByte() {
	    bufferSize = 0;

	    if (skipNextBit) {
	      position++;
	      skipNextBit = false;
	    }
	  }

	  function readCodingpasses() {
	    if (readBits(1) === 0) {
	      return 1;
	    }

	    if (readBits(1) === 0) {
	      return 2;
	    }

	    let value = readBits(2);

	    if (value < 3) {
	      return value + 3;
	    }

	    value = readBits(5);

	    if (value < 31) {
	      return value + 6;
	    }

	    value = readBits(7);
	    return value + 37;
	  }

	  const tileIndex = context.currentTile.index;
	  const tile = context.tiles[tileIndex];
	  const sopMarkerUsed = context.COD.sopMarkerUsed;
	  const ephMarkerUsed = context.COD.ephMarkerUsed;
	  const packetsIterator = tile.packetsIterator;

	  while (position < dataLength) {
	    alignToByte();

	    if (sopMarkerUsed && skipMarkerIfEqual(0x91)) {
	      skipBytes(4);
	    }

	    const packet = packetsIterator.nextPacket();

	    if (!readBits(1)) {
	      continue;
	    }

	    const layerNumber = packet.layerNumber,
	          queue = [];
	    let codeblock;

	    for (let i = 0, ii = packet.codeblocks.length; i < ii; i++) {
	      codeblock = packet.codeblocks[i];
	      let precinct = codeblock.precinct;
	      const codeblockColumn = codeblock.cbx - precinct.cbxMin;
	      const codeblockRow = codeblock.cby - precinct.cbyMin;
	      let codeblockIncluded = false;
	      let firstTimeInclusion = false;
	      let valueReady, zeroBitPlanesTree;

	      if (codeblock.included !== undefined) {
	        codeblockIncluded = !!readBits(1);
	      } else {
	        precinct = codeblock.precinct;
	        let inclusionTree;

	        if (precinct.inclusionTree !== undefined) {
	          inclusionTree = precinct.inclusionTree;
	        } else {
	          const width = precinct.cbxMax - precinct.cbxMin + 1;
	          const height = precinct.cbyMax - precinct.cbyMin + 1;
	          inclusionTree = new InclusionTree(width, height, layerNumber);
	          zeroBitPlanesTree = new TagTree(width, height);
	          precinct.inclusionTree = inclusionTree;
	          precinct.zeroBitPlanesTree = zeroBitPlanesTree;

	          for (let l = 0; l < layerNumber; l++) {
	            if (readBits(1) !== 0) {
	              throw new JpxError("Invalid tag tree");
	            }
	          }
	        }

	        if (inclusionTree.reset(codeblockColumn, codeblockRow, layerNumber)) {
	          while (true) {
	            if (readBits(1)) {
	              valueReady = !inclusionTree.nextLevel();

	              if (valueReady) {
	                codeblock.included = true;
	                codeblockIncluded = firstTimeInclusion = true;
	                break;
	              }
	            } else {
	              inclusionTree.incrementValue(layerNumber);
	              break;
	            }
	          }
	        }
	      }

	      if (!codeblockIncluded) {
	        continue;
	      }

	      if (firstTimeInclusion) {
	        zeroBitPlanesTree = precinct.zeroBitPlanesTree;
	        zeroBitPlanesTree.reset(codeblockColumn, codeblockRow);

	        while (true) {
	          if (readBits(1)) {
	            valueReady = !zeroBitPlanesTree.nextLevel();

	            if (valueReady) {
	              break;
	            }
	          } else {
	            zeroBitPlanesTree.incrementValue();
	          }
	        }

	        codeblock.zeroBitPlanes = zeroBitPlanesTree.value;
	      }

	      const codingpasses = readCodingpasses();

	      while (readBits(1)) {
	        codeblock.Lblock++;
	      }

	      const codingpassesLog2 = (0, _core_utils.log2)(codingpasses);
	      const bits = (codingpasses < 1 << codingpassesLog2 ? codingpassesLog2 - 1 : codingpassesLog2) + codeblock.Lblock;
	      const codedDataLength = readBits(bits);
	      queue.push({
	        codeblock,
	        codingpasses,
	        dataLength: codedDataLength
	      });
	    }

	    alignToByte();

	    if (ephMarkerUsed) {
	      skipMarkerIfEqual(0x92);
	    }

	    while (queue.length > 0) {
	      const packetItem = queue.shift();
	      codeblock = packetItem.codeblock;

	      if (codeblock.data === undefined) {
	        codeblock.data = [];
	      }

	      codeblock.data.push({
	        data,
	        start: offset + position,
	        end: offset + position + packetItem.dataLength,
	        codingpasses: packetItem.codingpasses
	      });
	      position += packetItem.dataLength;
	    }
	  }

	  return position;
	}

	function copyCoefficients(coefficients, levelWidth, levelHeight, subband, delta, mb, reversible, segmentationSymbolUsed, resetContextProbabilities) {
	  const x0 = subband.tbx0;
	  const y0 = subband.tby0;
	  const width = subband.tbx1 - subband.tbx0;
	  const codeblocks = subband.codeblocks;
	  const right = subband.type.charAt(0) === "H" ? 1 : 0;
	  const bottom = subband.type.charAt(1) === "H" ? levelWidth : 0;

	  for (let i = 0, ii = codeblocks.length; i < ii; ++i) {
	    const codeblock = codeblocks[i];
	    const blockWidth = codeblock.tbx1_ - codeblock.tbx0_;
	    const blockHeight = codeblock.tby1_ - codeblock.tby0_;

	    if (blockWidth === 0 || blockHeight === 0) {
	      continue;
	    }

	    if (codeblock.data === undefined) {
	      continue;
	    }

	    const bitModel = new BitModel(blockWidth, blockHeight, codeblock.subbandType, codeblock.zeroBitPlanes, mb);
	    let currentCodingpassType = 2;
	    const data = codeblock.data;
	    let totalLength = 0,
	        codingpasses = 0;
	    let j, jj, dataItem;

	    for (j = 0, jj = data.length; j < jj; j++) {
	      dataItem = data[j];
	      totalLength += dataItem.end - dataItem.start;
	      codingpasses += dataItem.codingpasses;
	    }

	    const encodedData = new Uint8Array(totalLength);
	    let position = 0;

	    for (j = 0, jj = data.length; j < jj; j++) {
	      dataItem = data[j];
	      const chunk = dataItem.data.subarray(dataItem.start, dataItem.end);
	      encodedData.set(chunk, position);
	      position += chunk.length;
	    }

	    const decoder = new _arithmetic_decoder.ArithmeticDecoder(encodedData, 0, totalLength);
	    bitModel.setDecoder(decoder);

	    for (j = 0; j < codingpasses; j++) {
	      switch (currentCodingpassType) {
	        case 0:
	          bitModel.runSignificancePropagationPass();
	          break;

	        case 1:
	          bitModel.runMagnitudeRefinementPass();
	          break;

	        case 2:
	          bitModel.runCleanupPass();

	          if (segmentationSymbolUsed) {
	            bitModel.checkSegmentationSymbol();
	          }

	          break;
	      }

	      if (resetContextProbabilities) {
	        bitModel.reset();
	      }

	      currentCodingpassType = (currentCodingpassType + 1) % 3;
	    }

	    let offset = codeblock.tbx0_ - x0 + (codeblock.tby0_ - y0) * width;
	    const sign = bitModel.coefficentsSign;
	    const magnitude = bitModel.coefficentsMagnitude;
	    const bitsDecoded = bitModel.bitsDecoded;
	    const magnitudeCorrection = reversible ? 0 : 0.5;
	    let k, n, nb;
	    position = 0;
	    const interleave = subband.type !== "LL";

	    for (j = 0; j < blockHeight; j++) {
	      const row = offset / width | 0;
	      const levelOffset = 2 * row * (levelWidth - width) + right + bottom;

	      for (k = 0; k < blockWidth; k++) {
	        n = magnitude[position];

	        if (n !== 0) {
	          n = (n + magnitudeCorrection) * delta;

	          if (sign[position] !== 0) {
	            n = -n;
	          }

	          nb = bitsDecoded[position];
	          const pos = interleave ? levelOffset + (offset << 1) : offset;

	          if (reversible && nb >= mb) {
	            coefficients[pos] = n;
	          } else {
	            coefficients[pos] = n * (1 << mb - nb);
	          }
	        }

	        offset++;
	        position++;
	      }

	      offset += width - blockWidth;
	    }
	  }
	}

	function transformTile(context, tile, c) {
	  const component = tile.components[c];
	  const codingStyleParameters = component.codingStyleParameters;
	  const quantizationParameters = component.quantizationParameters;
	  const decompositionLevelsCount = codingStyleParameters.decompositionLevelsCount;
	  const spqcds = quantizationParameters.SPqcds;
	  const scalarExpounded = quantizationParameters.scalarExpounded;
	  const guardBits = quantizationParameters.guardBits;
	  const segmentationSymbolUsed = codingStyleParameters.segmentationSymbolUsed;
	  const resetContextProbabilities = codingStyleParameters.resetContextProbabilities;
	  const precision = context.components[c].precision;
	  const reversible = codingStyleParameters.reversibleTransformation;
	  const transform = reversible ? new ReversibleTransform() : new IrreversibleTransform();
	  const subbandCoefficients = [];
	  let b = 0;

	  for (let i = 0; i <= decompositionLevelsCount; i++) {
	    const resolution = component.resolutions[i];
	    const width = resolution.trx1 - resolution.trx0;
	    const height = resolution.try1 - resolution.try0;
	    const coefficients = new Float32Array(width * height);

	    for (let j = 0, jj = resolution.subbands.length; j < jj; j++) {
	      let mu, epsilon;

	      if (!scalarExpounded) {
	        mu = spqcds[0].mu;
	        epsilon = spqcds[0].epsilon + (i > 0 ? 1 - i : 0);
	      } else {
	        mu = spqcds[b].mu;
	        epsilon = spqcds[b].epsilon;
	        b++;
	      }

	      const subband = resolution.subbands[j];
	      const gainLog2 = SubbandsGainLog2[subband.type];
	      const delta = reversible ? 1 : 2 ** (precision + gainLog2 - epsilon) * (1 + mu / 2048);
	      const mb = guardBits + epsilon - 1;
	      copyCoefficients(coefficients, width, height, subband, delta, mb, reversible, segmentationSymbolUsed, resetContextProbabilities);
	    }

	    subbandCoefficients.push({
	      width,
	      height,
	      items: coefficients
	    });
	  }

	  const result = transform.calculate(subbandCoefficients, component.tcx0, component.tcy0);
	  return {
	    left: component.tcx0,
	    top: component.tcy0,
	    width: result.width,
	    height: result.height,
	    items: result.items
	  };
	}

	function transformComponents(context) {
	  const siz = context.SIZ;
	  const components = context.components;
	  const componentsCount = siz.Csiz;
	  const resultImages = [];

	  for (let i = 0, ii = context.tiles.length; i < ii; i++) {
	    const tile = context.tiles[i];
	    const transformedTiles = [];

	    for (let c = 0; c < componentsCount; c++) {
	      transformedTiles[c] = transformTile(context, tile, c);
	    }

	    const tile0 = transformedTiles[0];
	    const out = new Uint8ClampedArray(tile0.items.length * componentsCount);
	    const result = {
	      left: tile0.left,
	      top: tile0.top,
	      width: tile0.width,
	      height: tile0.height,
	      items: out
	    };
	    let shift, offset;
	    let pos = 0,
	        j,
	        jj,
	        y0,
	        y1,
	        y2;

	    if (tile.codingStyleDefaultParameters.multipleComponentTransform) {
	      const fourComponents = componentsCount === 4;
	      const y0items = transformedTiles[0].items;
	      const y1items = transformedTiles[1].items;
	      const y2items = transformedTiles[2].items;
	      const y3items = fourComponents ? transformedTiles[3].items : null;
	      shift = components[0].precision - 8;
	      offset = (128 << shift) + 0.5;
	      const component0 = tile.components[0];
	      const alpha01 = componentsCount - 3;
	      jj = y0items.length;

	      if (!component0.codingStyleParameters.reversibleTransformation) {
	        for (j = 0; j < jj; j++, pos += alpha01) {
	          y0 = y0items[j] + offset;
	          y1 = y1items[j];
	          y2 = y2items[j];
	          out[pos++] = y0 + 1.402 * y2 >> shift;
	          out[pos++] = y0 - 0.34413 * y1 - 0.71414 * y2 >> shift;
	          out[pos++] = y0 + 1.772 * y1 >> shift;
	        }
	      } else {
	        for (j = 0; j < jj; j++, pos += alpha01) {
	          y0 = y0items[j] + offset;
	          y1 = y1items[j];
	          y2 = y2items[j];
	          const g = y0 - (y2 + y1 >> 2);
	          out[pos++] = g + y2 >> shift;
	          out[pos++] = g >> shift;
	          out[pos++] = g + y1 >> shift;
	        }
	      }

	      if (fourComponents) {
	        for (j = 0, pos = 3; j < jj; j++, pos += 4) {
	          out[pos] = y3items[j] + offset >> shift;
	        }
	      }
	    } else {
	      for (let c = 0; c < componentsCount; c++) {
	        const items = transformedTiles[c].items;
	        shift = components[c].precision - 8;
	        offset = (128 << shift) + 0.5;

	        for (pos = c, j = 0, jj = items.length; j < jj; j++) {
	          out[pos] = items[j] + offset >> shift;
	          pos += componentsCount;
	        }
	      }
	    }

	    resultImages.push(result);
	  }

	  return resultImages;
	}

	function initializeTile(context, tileIndex) {
	  const siz = context.SIZ;
	  const componentsCount = siz.Csiz;
	  const tile = context.tiles[tileIndex];

	  for (let c = 0; c < componentsCount; c++) {
	    const component = tile.components[c];
	    const qcdOrQcc = context.currentTile.QCC[c] !== undefined ? context.currentTile.QCC[c] : context.currentTile.QCD;
	    component.quantizationParameters = qcdOrQcc;
	    const codOrCoc = context.currentTile.COC[c] !== undefined ? context.currentTile.COC[c] : context.currentTile.COD;
	    component.codingStyleParameters = codOrCoc;
	  }

	  tile.codingStyleDefaultParameters = context.currentTile.COD;
	}

	class TagTree {
	  constructor(width, height) {
	    const levelsLength = (0, _core_utils.log2)(Math.max(width, height)) + 1;
	    this.levels = [];

	    for (let i = 0; i < levelsLength; i++) {
	      const level = {
	        width,
	        height,
	        items: []
	      };
	      this.levels.push(level);
	      width = Math.ceil(width / 2);
	      height = Math.ceil(height / 2);
	    }
	  }

	  reset(i, j) {
	    let currentLevel = 0,
	        value = 0,
	        level;

	    while (currentLevel < this.levels.length) {
	      level = this.levels[currentLevel];
	      const index = i + j * level.width;

	      if (level.items[index] !== undefined) {
	        value = level.items[index];
	        break;
	      }

	      level.index = index;
	      i >>= 1;
	      j >>= 1;
	      currentLevel++;
	    }

	    currentLevel--;
	    level = this.levels[currentLevel];
	    level.items[level.index] = value;
	    this.currentLevel = currentLevel;
	    delete this.value;
	  }

	  incrementValue() {
	    const level = this.levels[this.currentLevel];
	    level.items[level.index]++;
	  }

	  nextLevel() {
	    let currentLevel = this.currentLevel;
	    let level = this.levels[currentLevel];
	    const value = level.items[level.index];
	    currentLevel--;

	    if (currentLevel < 0) {
	      this.value = value;
	      return false;
	    }

	    this.currentLevel = currentLevel;
	    level = this.levels[currentLevel];
	    level.items[level.index] = value;
	    return true;
	  }

	}

	class InclusionTree {
	  constructor(width, height, defaultValue) {
	    const levelsLength = (0, _core_utils.log2)(Math.max(width, height)) + 1;
	    this.levels = [];

	    for (let i = 0; i < levelsLength; i++) {
	      const items = new Uint8Array(width * height);

	      for (let j = 0, jj = items.length; j < jj; j++) {
	        items[j] = defaultValue;
	      }

	      const level = {
	        width,
	        height,
	        items
	      };
	      this.levels.push(level);
	      width = Math.ceil(width / 2);
	      height = Math.ceil(height / 2);
	    }
	  }

	  reset(i, j, stopValue) {
	    let currentLevel = 0;

	    while (currentLevel < this.levels.length) {
	      const level = this.levels[currentLevel];
	      const index = i + j * level.width;
	      level.index = index;
	      const value = level.items[index];

	      if (value === 0xff) {
	        break;
	      }

	      if (value > stopValue) {
	        this.currentLevel = currentLevel;
	        this.propagateValues();
	        return false;
	      }

	      i >>= 1;
	      j >>= 1;
	      currentLevel++;
	    }

	    this.currentLevel = currentLevel - 1;
	    return true;
	  }

	  incrementValue(stopValue) {
	    const level = this.levels[this.currentLevel];
	    level.items[level.index] = stopValue + 1;
	    this.propagateValues();
	  }

	  propagateValues() {
	    let levelIndex = this.currentLevel;
	    let level = this.levels[levelIndex];
	    const currentValue = level.items[level.index];

	    while (--levelIndex >= 0) {
	      level = this.levels[levelIndex];
	      level.items[level.index] = currentValue;
	    }
	  }

	  nextLevel() {
	    let currentLevel = this.currentLevel;
	    let level = this.levels[currentLevel];
	    const value = level.items[level.index];
	    level.items[level.index] = 0xff;
	    currentLevel--;

	    if (currentLevel < 0) {
	      return false;
	    }

	    this.currentLevel = currentLevel;
	    level = this.levels[currentLevel];
	    level.items[level.index] = value;
	    return true;
	  }

	}

	const BitModel = function BitModelClosure() {
	  const UNIFORM_CONTEXT = 17;
	  const RUNLENGTH_CONTEXT = 18;
	  const LLAndLHContextsLabel = new Uint8Array([0, 5, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 1, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 2, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 2, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8, 0, 0, 0, 0, 0, 2, 6, 8, 0, 3, 7, 8, 0, 4, 7, 8]);
	  const HLContextLabel = new Uint8Array([0, 3, 4, 0, 5, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 1, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 2, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 2, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8, 0, 0, 0, 0, 0, 2, 3, 4, 0, 6, 7, 7, 0, 8, 8, 8]);
	  const HHContextLabel = new Uint8Array([0, 1, 2, 0, 1, 2, 2, 0, 2, 2, 2, 0, 0, 0, 0, 0, 3, 4, 5, 0, 4, 5, 5, 0, 5, 5, 5, 0, 0, 0, 0, 0, 6, 7, 7, 0, 7, 7, 7, 0, 7, 7, 7, 0, 0, 0, 0, 0, 8, 8, 8, 0, 8, 8, 8, 0, 8, 8, 8, 0, 0, 0, 0, 0, 8, 8, 8, 0, 8, 8, 8, 0, 8, 8, 8]);

	  class BitModel {
	    constructor(width, height, subband, zeroBitPlanes, mb) {
	      this.width = width;
	      this.height = height;
	      let contextLabelTable;

	      if (subband === "HH") {
	        contextLabelTable = HHContextLabel;
	      } else if (subband === "HL") {
	        contextLabelTable = HLContextLabel;
	      } else {
	        contextLabelTable = LLAndLHContextsLabel;
	      }

	      this.contextLabelTable = contextLabelTable;
	      const coefficientCount = width * height;
	      this.neighborsSignificance = new Uint8Array(coefficientCount);
	      this.coefficentsSign = new Uint8Array(coefficientCount);
	      let coefficentsMagnitude;

	      if (mb > 14) {
	        coefficentsMagnitude = new Uint32Array(coefficientCount);
	      } else if (mb > 6) {
	        coefficentsMagnitude = new Uint16Array(coefficientCount);
	      } else {
	        coefficentsMagnitude = new Uint8Array(coefficientCount);
	      }

	      this.coefficentsMagnitude = coefficentsMagnitude;
	      this.processingFlags = new Uint8Array(coefficientCount);
	      const bitsDecoded = new Uint8Array(coefficientCount);

	      if (zeroBitPlanes !== 0) {
	        for (let i = 0; i < coefficientCount; i++) {
	          bitsDecoded[i] = zeroBitPlanes;
	        }
	      }

	      this.bitsDecoded = bitsDecoded;
	      this.reset();
	    }

	    setDecoder(decoder) {
	      this.decoder = decoder;
	    }

	    reset() {
	      this.contexts = new Int8Array(19);
	      this.contexts[0] = 4 << 1 | 0;
	      this.contexts[UNIFORM_CONTEXT] = 46 << 1 | 0;
	      this.contexts[RUNLENGTH_CONTEXT] = 3 << 1 | 0;
	    }

	    setNeighborsSignificance(row, column, index) {
	      const neighborsSignificance = this.neighborsSignificance;
	      const width = this.width,
	            height = this.height;
	      const left = column > 0;
	      const right = column + 1 < width;
	      let i;

	      if (row > 0) {
	        i = index - width;

	        if (left) {
	          neighborsSignificance[i - 1] += 0x10;
	        }

	        if (right) {
	          neighborsSignificance[i + 1] += 0x10;
	        }

	        neighborsSignificance[i] += 0x04;
	      }

	      if (row + 1 < height) {
	        i = index + width;

	        if (left) {
	          neighborsSignificance[i - 1] += 0x10;
	        }

	        if (right) {
	          neighborsSignificance[i + 1] += 0x10;
	        }

	        neighborsSignificance[i] += 0x04;
	      }

	      if (left) {
	        neighborsSignificance[index - 1] += 0x01;
	      }

	      if (right) {
	        neighborsSignificance[index + 1] += 0x01;
	      }

	      neighborsSignificance[index] |= 0x80;
	    }

	    runSignificancePropagationPass() {
	      const decoder = this.decoder;
	      const width = this.width,
	            height = this.height;
	      const coefficentsMagnitude = this.coefficentsMagnitude;
	      const coefficentsSign = this.coefficentsSign;
	      const neighborsSignificance = this.neighborsSignificance;
	      const processingFlags = this.processingFlags;
	      const contexts = this.contexts;
	      const labels = this.contextLabelTable;
	      const bitsDecoded = this.bitsDecoded;
	      const processedInverseMask = ~1;
	      const processedMask = 1;
	      const firstMagnitudeBitMask = 2;

	      for (let i0 = 0; i0 < height; i0 += 4) {
	        for (let j = 0; j < width; j++) {
	          let index = i0 * width + j;

	          for (let i1 = 0; i1 < 4; i1++, index += width) {
	            const i = i0 + i1;

	            if (i >= height) {
	              break;
	            }

	            processingFlags[index] &= processedInverseMask;

	            if (coefficentsMagnitude[index] || !neighborsSignificance[index]) {
	              continue;
	            }

	            const contextLabel = labels[neighborsSignificance[index]];
	            const decision = decoder.readBit(contexts, contextLabel);

	            if (decision) {
	              const sign = this.decodeSignBit(i, j, index);
	              coefficentsSign[index] = sign;
	              coefficentsMagnitude[index] = 1;
	              this.setNeighborsSignificance(i, j, index);
	              processingFlags[index] |= firstMagnitudeBitMask;
	            }

	            bitsDecoded[index]++;
	            processingFlags[index] |= processedMask;
	          }
	        }
	      }
	    }

	    decodeSignBit(row, column, index) {
	      const width = this.width,
	            height = this.height;
	      const coefficentsMagnitude = this.coefficentsMagnitude;
	      const coefficentsSign = this.coefficentsSign;
	      let contribution, sign0, sign1, significance1;
	      let contextLabel, decoded;
	      significance1 = column > 0 && coefficentsMagnitude[index - 1] !== 0;

	      if (column + 1 < width && coefficentsMagnitude[index + 1] !== 0) {
	        sign1 = coefficentsSign[index + 1];

	        if (significance1) {
	          sign0 = coefficentsSign[index - 1];
	          contribution = 1 - sign1 - sign0;
	        } else {
	          contribution = 1 - sign1 - sign1;
	        }
	      } else if (significance1) {
	        sign0 = coefficentsSign[index - 1];
	        contribution = 1 - sign0 - sign0;
	      } else {
	        contribution = 0;
	      }

	      const horizontalContribution = 3 * contribution;
	      significance1 = row > 0 && coefficentsMagnitude[index - width] !== 0;

	      if (row + 1 < height && coefficentsMagnitude[index + width] !== 0) {
	        sign1 = coefficentsSign[index + width];

	        if (significance1) {
	          sign0 = coefficentsSign[index - width];
	          contribution = 1 - sign1 - sign0 + horizontalContribution;
	        } else {
	          contribution = 1 - sign1 - sign1 + horizontalContribution;
	        }
	      } else if (significance1) {
	        sign0 = coefficentsSign[index - width];
	        contribution = 1 - sign0 - sign0 + horizontalContribution;
	      } else {
	        contribution = horizontalContribution;
	      }

	      if (contribution >= 0) {
	        contextLabel = 9 + contribution;
	        decoded = this.decoder.readBit(this.contexts, contextLabel);
	      } else {
	        contextLabel = 9 - contribution;
	        decoded = this.decoder.readBit(this.contexts, contextLabel) ^ 1;
	      }

	      return decoded;
	    }

	    runMagnitudeRefinementPass() {
	      const decoder = this.decoder;
	      const width = this.width,
	            height = this.height;
	      const coefficentsMagnitude = this.coefficentsMagnitude;
	      const neighborsSignificance = this.neighborsSignificance;
	      const contexts = this.contexts;
	      const bitsDecoded = this.bitsDecoded;
	      const processingFlags = this.processingFlags;
	      const processedMask = 1;
	      const firstMagnitudeBitMask = 2;
	      const length = width * height;
	      const width4 = width * 4;

	      for (let index0 = 0, indexNext; index0 < length; index0 = indexNext) {
	        indexNext = Math.min(length, index0 + width4);

	        for (let j = 0; j < width; j++) {
	          for (let index = index0 + j; index < indexNext; index += width) {
	            if (!coefficentsMagnitude[index] || (processingFlags[index] & processedMask) !== 0) {
	              continue;
	            }

	            let contextLabel = 16;

	            if ((processingFlags[index] & firstMagnitudeBitMask) !== 0) {
	              processingFlags[index] ^= firstMagnitudeBitMask;
	              const significance = neighborsSignificance[index] & 127;
	              contextLabel = significance === 0 ? 15 : 14;
	            }

	            const bit = decoder.readBit(contexts, contextLabel);
	            coefficentsMagnitude[index] = coefficentsMagnitude[index] << 1 | bit;
	            bitsDecoded[index]++;
	            processingFlags[index] |= processedMask;
	          }
	        }
	      }
	    }

	    runCleanupPass() {
	      const decoder = this.decoder;
	      const width = this.width,
	            height = this.height;
	      const neighborsSignificance = this.neighborsSignificance;
	      const coefficentsMagnitude = this.coefficentsMagnitude;
	      const coefficentsSign = this.coefficentsSign;
	      const contexts = this.contexts;
	      const labels = this.contextLabelTable;
	      const bitsDecoded = this.bitsDecoded;
	      const processingFlags = this.processingFlags;
	      const processedMask = 1;
	      const firstMagnitudeBitMask = 2;
	      const oneRowDown = width;
	      const twoRowsDown = width * 2;
	      const threeRowsDown = width * 3;
	      let iNext;

	      for (let i0 = 0; i0 < height; i0 = iNext) {
	        iNext = Math.min(i0 + 4, height);
	        const indexBase = i0 * width;
	        const checkAllEmpty = i0 + 3 < height;

	        for (let j = 0; j < width; j++) {
	          const index0 = indexBase + j;
	          const allEmpty = checkAllEmpty && processingFlags[index0] === 0 && processingFlags[index0 + oneRowDown] === 0 && processingFlags[index0 + twoRowsDown] === 0 && processingFlags[index0 + threeRowsDown] === 0 && neighborsSignificance[index0] === 0 && neighborsSignificance[index0 + oneRowDown] === 0 && neighborsSignificance[index0 + twoRowsDown] === 0 && neighborsSignificance[index0 + threeRowsDown] === 0;
	          let i1 = 0,
	              index = index0;
	          let i = i0,
	              sign;

	          if (allEmpty) {
	            const hasSignificantCoefficent = decoder.readBit(contexts, RUNLENGTH_CONTEXT);

	            if (!hasSignificantCoefficent) {
	              bitsDecoded[index0]++;
	              bitsDecoded[index0 + oneRowDown]++;
	              bitsDecoded[index0 + twoRowsDown]++;
	              bitsDecoded[index0 + threeRowsDown]++;
	              continue;
	            }

	            i1 = decoder.readBit(contexts, UNIFORM_CONTEXT) << 1 | decoder.readBit(contexts, UNIFORM_CONTEXT);

	            if (i1 !== 0) {
	              i = i0 + i1;
	              index += i1 * width;
	            }

	            sign = this.decodeSignBit(i, j, index);
	            coefficentsSign[index] = sign;
	            coefficentsMagnitude[index] = 1;
	            this.setNeighborsSignificance(i, j, index);
	            processingFlags[index] |= firstMagnitudeBitMask;
	            index = index0;

	            for (let i2 = i0; i2 <= i; i2++, index += width) {
	              bitsDecoded[index]++;
	            }

	            i1++;
	          }

	          for (i = i0 + i1; i < iNext; i++, index += width) {
	            if (coefficentsMagnitude[index] || (processingFlags[index] & processedMask) !== 0) {
	              continue;
	            }

	            const contextLabel = labels[neighborsSignificance[index]];
	            const decision = decoder.readBit(contexts, contextLabel);

	            if (decision === 1) {
	              sign = this.decodeSignBit(i, j, index);
	              coefficentsSign[index] = sign;
	              coefficentsMagnitude[index] = 1;
	              this.setNeighborsSignificance(i, j, index);
	              processingFlags[index] |= firstMagnitudeBitMask;
	            }

	            bitsDecoded[index]++;
	          }
	        }
	      }
	    }

	    checkSegmentationSymbol() {
	      const decoder = this.decoder;
	      const contexts = this.contexts;
	      const symbol = decoder.readBit(contexts, UNIFORM_CONTEXT) << 3 | decoder.readBit(contexts, UNIFORM_CONTEXT) << 2 | decoder.readBit(contexts, UNIFORM_CONTEXT) << 1 | decoder.readBit(contexts, UNIFORM_CONTEXT);

	      if (symbol !== 0xa) {
	        throw new JpxError("Invalid segmentation symbol");
	      }
	    }

	  }

	  return BitModel;
	}();

	class Transform {
	  constructor() {
	    if (this.constructor === Transform) {
	      (0, _util.unreachable)("Cannot initialize Transform.");
	    }
	  }

	  calculate(subbands, u0, v0) {
	    let ll = subbands[0];

	    for (let i = 1, ii = subbands.length; i < ii; i++) {
	      ll = this.iterate(ll, subbands[i], u0, v0);
	    }

	    return ll;
	  }

	  extend(buffer, offset, size) {
	    let i1 = offset - 1,
	        j1 = offset + 1;
	    let i2 = offset + size - 2,
	        j2 = offset + size;
	    buffer[i1--] = buffer[j1++];
	    buffer[j2++] = buffer[i2--];
	    buffer[i1--] = buffer[j1++];
	    buffer[j2++] = buffer[i2--];
	    buffer[i1--] = buffer[j1++];
	    buffer[j2++] = buffer[i2--];
	    buffer[i1] = buffer[j1];
	    buffer[j2] = buffer[i2];
	  }

	  filter(x, offset, length) {
	    (0, _util.unreachable)("Abstract method `filter` called");
	  }

	  iterate(ll, hl_lh_hh, u0, v0) {
	    const llWidth = ll.width,
	          llHeight = ll.height;
	    let llItems = ll.items;
	    const width = hl_lh_hh.width;
	    const height = hl_lh_hh.height;
	    const items = hl_lh_hh.items;
	    let i, j, k, l, u, v;

	    for (k = 0, i = 0; i < llHeight; i++) {
	      l = i * 2 * width;

	      for (j = 0; j < llWidth; j++, k++, l += 2) {
	        items[l] = llItems[k];
	      }
	    }

	    llItems = ll.items = null;
	    const bufferPadding = 4;
	    const rowBuffer = new Float32Array(width + 2 * bufferPadding);

	    if (width === 1) {
	      if ((u0 & 1) !== 0) {
	        for (v = 0, k = 0; v < height; v++, k += width) {
	          items[k] *= 0.5;
	        }
	      }
	    } else {
	      for (v = 0, k = 0; v < height; v++, k += width) {
	        rowBuffer.set(items.subarray(k, k + width), bufferPadding);
	        this.extend(rowBuffer, bufferPadding, width);
	        this.filter(rowBuffer, bufferPadding, width);
	        items.set(rowBuffer.subarray(bufferPadding, bufferPadding + width), k);
	      }
	    }

	    let numBuffers = 16;
	    const colBuffers = [];

	    for (i = 0; i < numBuffers; i++) {
	      colBuffers.push(new Float32Array(height + 2 * bufferPadding));
	    }

	    let b,
	        currentBuffer = 0;
	    ll = bufferPadding + height;

	    if (height === 1) {
	      if ((v0 & 1) !== 0) {
	        for (u = 0; u < width; u++) {
	          items[u] *= 0.5;
	        }
	      }
	    } else {
	      for (u = 0; u < width; u++) {
	        if (currentBuffer === 0) {
	          numBuffers = Math.min(width - u, numBuffers);

	          for (k = u, l = bufferPadding; l < ll; k += width, l++) {
	            for (b = 0; b < numBuffers; b++) {
	              colBuffers[b][l] = items[k + b];
	            }
	          }

	          currentBuffer = numBuffers;
	        }

	        currentBuffer--;
	        const buffer = colBuffers[currentBuffer];
	        this.extend(buffer, bufferPadding, height);
	        this.filter(buffer, bufferPadding, height);

	        if (currentBuffer === 0) {
	          k = u - numBuffers + 1;

	          for (l = bufferPadding; l < ll; k += width, l++) {
	            for (b = 0; b < numBuffers; b++) {
	              items[k + b] = colBuffers[b][l];
	            }
	          }
	        }
	      }
	    }

	    return {
	      width,
	      height,
	      items
	    };
	  }

	}

	class IrreversibleTransform extends Transform {
	  filter(x, offset, length) {
	    const len = length >> 1;
	    offset |= 0;
	    let j, n, current, next;
	    const alpha = -1.586134342059924;
	    const beta = -0.052980118572961;
	    const gamma = 0.882911075530934;
	    const delta = 0.443506852043971;
	    const K = 1.230174104914001;
	    const K_ = 1 / K;
	    j = offset - 3;

	    for (n = len + 4; n--; j += 2) {
	      x[j] *= K_;
	    }

	    j = offset - 2;
	    current = delta * x[j - 1];

	    for (n = len + 3; n--; j += 2) {
	      next = delta * x[j + 1];
	      x[j] = K * x[j] - current - next;

	      if (n--) {
	        j += 2;
	        current = delta * x[j + 1];
	        x[j] = K * x[j] - current - next;
	      } else {
	        break;
	      }
	    }

	    j = offset - 1;
	    current = gamma * x[j - 1];

	    for (n = len + 2; n--; j += 2) {
	      next = gamma * x[j + 1];
	      x[j] -= current + next;

	      if (n--) {
	        j += 2;
	        current = gamma * x[j + 1];
	        x[j] -= current + next;
	      } else {
	        break;
	      }
	    }

	    j = offset;
	    current = beta * x[j - 1];

	    for (n = len + 1; n--; j += 2) {
	      next = beta * x[j + 1];
	      x[j] -= current + next;

	      if (n--) {
	        j += 2;
	        current = beta * x[j + 1];
	        x[j] -= current + next;
	      } else {
	        break;
	      }
	    }

	    if (len !== 0) {
	      j = offset + 1;
	      current = alpha * x[j - 1];

	      for (n = len; n--; j += 2) {
	        next = alpha * x[j + 1];
	        x[j] -= current + next;

	        if (n--) {
	          j += 2;
	          current = alpha * x[j + 1];
	          x[j] -= current + next;
	        } else {
	          break;
	        }
	      }
	    }
	  }

	}

	class ReversibleTransform extends Transform {
	  filter(x, offset, length) {
	    const len = length >> 1;
	    offset |= 0;
	    let j, n;

	    for (j = offset, n = len + 1; n--; j += 2) {
	      x[j] -= x[j - 1] + x[j + 1] + 2 >> 2;
	    }

	    for (j = offset + 1, n = len; n--; j += 2) {
	      x[j] += x[j - 1] + x[j + 1] >> 1;
	    }
	  }

	}

	/***/ }),
	/* 31 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.LZWStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	class LZWStream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength, earlyChange) {
	    super(maybeLength);
	    this.str = str;
	    this.dict = str.dict;
	    this.cachedData = 0;
	    this.bitsCached = 0;
	    const maxLzwDictionarySize = 4096;
	    const lzwState = {
	      earlyChange,
	      codeLength: 9,
	      nextCode: 258,
	      dictionaryValues: new Uint8Array(maxLzwDictionarySize),
	      dictionaryLengths: new Uint16Array(maxLzwDictionarySize),
	      dictionaryPrevCodes: new Uint16Array(maxLzwDictionarySize),
	      currentSequence: new Uint8Array(maxLzwDictionarySize),
	      currentSequenceLength: 0
	    };

	    for (let i = 0; i < 256; ++i) {
	      lzwState.dictionaryValues[i] = i;
	      lzwState.dictionaryLengths[i] = 1;
	    }

	    this.lzwState = lzwState;
	  }

	  readBits(n) {
	    let bitsCached = this.bitsCached;
	    let cachedData = this.cachedData;

	    while (bitsCached < n) {
	      const c = this.str.getByte();

	      if (c === -1) {
	        this.eof = true;
	        return null;
	      }

	      cachedData = cachedData << 8 | c;
	      bitsCached += 8;
	    }

	    this.bitsCached = bitsCached -= n;
	    this.cachedData = cachedData;
	    this.lastCode = null;
	    return cachedData >>> bitsCached & (1 << n) - 1;
	  }

	  readBlock() {
	    const blockSize = 512,
	          decodedSizeDelta = blockSize;
	    let estimatedDecodedSize = blockSize * 2;
	    let i, j, q;
	    const lzwState = this.lzwState;

	    if (!lzwState) {
	      return;
	    }

	    const earlyChange = lzwState.earlyChange;
	    let nextCode = lzwState.nextCode;
	    const dictionaryValues = lzwState.dictionaryValues;
	    const dictionaryLengths = lzwState.dictionaryLengths;
	    const dictionaryPrevCodes = lzwState.dictionaryPrevCodes;
	    let codeLength = lzwState.codeLength;
	    let prevCode = lzwState.prevCode;
	    const currentSequence = lzwState.currentSequence;
	    let currentSequenceLength = lzwState.currentSequenceLength;
	    let decodedLength = 0;
	    let currentBufferLength = this.bufferLength;
	    let buffer = this.ensureBuffer(this.bufferLength + estimatedDecodedSize);

	    for (i = 0; i < blockSize; i++) {
	      const code = this.readBits(codeLength);
	      const hasPrev = currentSequenceLength > 0;

	      if (code < 256) {
	        currentSequence[0] = code;
	        currentSequenceLength = 1;
	      } else if (code >= 258) {
	        if (code < nextCode) {
	          currentSequenceLength = dictionaryLengths[code];

	          for (j = currentSequenceLength - 1, q = code; j >= 0; j--) {
	            currentSequence[j] = dictionaryValues[q];
	            q = dictionaryPrevCodes[q];
	          }
	        } else {
	          currentSequence[currentSequenceLength++] = currentSequence[0];
	        }
	      } else if (code === 256) {
	        codeLength = 9;
	        nextCode = 258;
	        currentSequenceLength = 0;
	        continue;
	      } else {
	        this.eof = true;
	        delete this.lzwState;
	        break;
	      }

	      if (hasPrev) {
	        dictionaryPrevCodes[nextCode] = prevCode;
	        dictionaryLengths[nextCode] = dictionaryLengths[prevCode] + 1;
	        dictionaryValues[nextCode] = currentSequence[0];
	        nextCode++;
	        codeLength = nextCode + earlyChange & nextCode + earlyChange - 1 ? codeLength : Math.min(Math.log(nextCode + earlyChange) / 0.6931471805599453 + 1, 12) | 0;
	      }

	      prevCode = code;
	      decodedLength += currentSequenceLength;

	      if (estimatedDecodedSize < decodedLength) {
	        do {
	          estimatedDecodedSize += decodedSizeDelta;
	        } while (estimatedDecodedSize < decodedLength);

	        buffer = this.ensureBuffer(this.bufferLength + estimatedDecodedSize);
	      }

	      for (j = 0; j < currentSequenceLength; j++) {
	        buffer[currentBufferLength++] = currentSequence[j];
	      }
	    }

	    lzwState.nextCode = nextCode;
	    lzwState.codeLength = codeLength;
	    lzwState.prevCode = prevCode;
	    lzwState.currentSequenceLength = currentSequenceLength;
	    this.bufferLength = currentBufferLength;
	  }

	}

	exports.LZWStream = LZWStream;

	/***/ }),
	/* 32 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.PredictorStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	var _primitives = __w_pdfjs_require__(5);

	var _util = __w_pdfjs_require__(2);

	class PredictorStream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength, params) {
	    super(maybeLength);

	    if (!(params instanceof _primitives.Dict)) {
	      return str;
	    }

	    const predictor = this.predictor = params.get("Predictor") || 1;

	    if (predictor <= 1) {
	      return str;
	    }

	    if (predictor !== 2 && (predictor < 10 || predictor > 15)) {
	      throw new _util.FormatError(`Unsupported predictor: ${predictor}`);
	    }

	    if (predictor === 2) {
	      this.readBlock = this.readBlockTiff;
	    } else {
	      this.readBlock = this.readBlockPng;
	    }

	    this.str = str;
	    this.dict = str.dict;
	    const colors = this.colors = params.get("Colors") || 1;
	    const bits = this.bits = params.get("BPC", "BitsPerComponent") || 8;
	    const columns = this.columns = params.get("Columns") || 1;
	    this.pixBytes = colors * bits + 7 >> 3;
	    this.rowBytes = columns * colors * bits + 7 >> 3;
	    return this;
	  }

	  readBlockTiff() {
	    const rowBytes = this.rowBytes;
	    const bufferLength = this.bufferLength;
	    const buffer = this.ensureBuffer(bufferLength + rowBytes);
	    const bits = this.bits;
	    const colors = this.colors;
	    const rawBytes = this.str.getBytes(rowBytes);
	    this.eof = !rawBytes.length;

	    if (this.eof) {
	      return;
	    }

	    let inbuf = 0,
	        outbuf = 0;
	    let inbits = 0,
	        outbits = 0;
	    let pos = bufferLength;
	    let i;

	    if (bits === 1 && colors === 1) {
	      for (i = 0; i < rowBytes; ++i) {
	        let c = rawBytes[i] ^ inbuf;
	        c ^= c >> 1;
	        c ^= c >> 2;
	        c ^= c >> 4;
	        inbuf = (c & 1) << 7;
	        buffer[pos++] = c;
	      }
	    } else if (bits === 8) {
	      for (i = 0; i < colors; ++i) {
	        buffer[pos++] = rawBytes[i];
	      }

	      for (; i < rowBytes; ++i) {
	        buffer[pos] = buffer[pos - colors] + rawBytes[i];
	        pos++;
	      }
	    } else if (bits === 16) {
	      const bytesPerPixel = colors * 2;

	      for (i = 0; i < bytesPerPixel; ++i) {
	        buffer[pos++] = rawBytes[i];
	      }

	      for (; i < rowBytes; i += 2) {
	        const sum = ((rawBytes[i] & 0xff) << 8) + (rawBytes[i + 1] & 0xff) + ((buffer[pos - bytesPerPixel] & 0xff) << 8) + (buffer[pos - bytesPerPixel + 1] & 0xff);
	        buffer[pos++] = sum >> 8 & 0xff;
	        buffer[pos++] = sum & 0xff;
	      }
	    } else {
	      const compArray = new Uint8Array(colors + 1);
	      const bitMask = (1 << bits) - 1;
	      let j = 0,
	          k = bufferLength;
	      const columns = this.columns;

	      for (i = 0; i < columns; ++i) {
	        for (let kk = 0; kk < colors; ++kk) {
	          if (inbits < bits) {
	            inbuf = inbuf << 8 | rawBytes[j++] & 0xff;
	            inbits += 8;
	          }

	          compArray[kk] = compArray[kk] + (inbuf >> inbits - bits) & bitMask;
	          inbits -= bits;
	          outbuf = outbuf << bits | compArray[kk];
	          outbits += bits;

	          if (outbits >= 8) {
	            buffer[k++] = outbuf >> outbits - 8 & 0xff;
	            outbits -= 8;
	          }
	        }
	      }

	      if (outbits > 0) {
	        buffer[k++] = (outbuf << 8 - outbits) + (inbuf & (1 << 8 - outbits) - 1);
	      }
	    }

	    this.bufferLength += rowBytes;
	  }

	  readBlockPng() {
	    const rowBytes = this.rowBytes;
	    const pixBytes = this.pixBytes;
	    const predictor = this.str.getByte();
	    const rawBytes = this.str.getBytes(rowBytes);
	    this.eof = !rawBytes.length;

	    if (this.eof) {
	      return;
	    }

	    const bufferLength = this.bufferLength;
	    const buffer = this.ensureBuffer(bufferLength + rowBytes);
	    let prevRow = buffer.subarray(bufferLength - rowBytes, bufferLength);

	    if (prevRow.length === 0) {
	      prevRow = new Uint8Array(rowBytes);
	    }

	    let i,
	        j = bufferLength,
	        up,
	        c;

	    switch (predictor) {
	      case 0:
	        for (i = 0; i < rowBytes; ++i) {
	          buffer[j++] = rawBytes[i];
	        }

	        break;

	      case 1:
	        for (i = 0; i < pixBytes; ++i) {
	          buffer[j++] = rawBytes[i];
	        }

	        for (; i < rowBytes; ++i) {
	          buffer[j] = buffer[j - pixBytes] + rawBytes[i] & 0xff;
	          j++;
	        }

	        break;

	      case 2:
	        for (i = 0; i < rowBytes; ++i) {
	          buffer[j++] = prevRow[i] + rawBytes[i] & 0xff;
	        }

	        break;

	      case 3:
	        for (i = 0; i < pixBytes; ++i) {
	          buffer[j++] = (prevRow[i] >> 1) + rawBytes[i];
	        }

	        for (; i < rowBytes; ++i) {
	          buffer[j] = (prevRow[i] + buffer[j - pixBytes] >> 1) + rawBytes[i] & 0xff;
	          j++;
	        }

	        break;

	      case 4:
	        for (i = 0; i < pixBytes; ++i) {
	          up = prevRow[i];
	          c = rawBytes[i];
	          buffer[j++] = up + c;
	        }

	        for (; i < rowBytes; ++i) {
	          up = prevRow[i];
	          const upLeft = prevRow[i - pixBytes];
	          const left = buffer[j - pixBytes];
	          const p = left + up - upLeft;
	          let pa = p - left;

	          if (pa < 0) {
	            pa = -pa;
	          }

	          let pb = p - up;

	          if (pb < 0) {
	            pb = -pb;
	          }

	          let pc = p - upLeft;

	          if (pc < 0) {
	            pc = -pc;
	          }

	          c = rawBytes[i];

	          if (pa <= pb && pa <= pc) {
	            buffer[j++] = left + c;
	          } else if (pb <= pc) {
	            buffer[j++] = up + c;
	          } else {
	            buffer[j++] = upLeft + c;
	          }
	        }

	        break;

	      default:
	        throw new _util.FormatError(`Unsupported predictor: ${predictor}`);
	    }

	    this.bufferLength += rowBytes;
	  }

	}

	exports.PredictorStream = PredictorStream;

	/***/ }),
	/* 33 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.RunLengthStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	class RunLengthStream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength) {
	    super(maybeLength);
	    this.str = str;
	    this.dict = str.dict;
	  }

	  readBlock() {
	    const repeatHeader = this.str.getBytes(2);

	    if (!repeatHeader || repeatHeader.length < 2 || repeatHeader[0] === 128) {
	      this.eof = true;
	      return;
	    }

	    let buffer;
	    let bufferLength = this.bufferLength;
	    let n = repeatHeader[0];

	    if (n < 128) {
	      buffer = this.ensureBuffer(bufferLength + n + 1);
	      buffer[bufferLength++] = repeatHeader[1];

	      if (n > 0) {
	        const source = this.str.getBytes(n);
	        buffer.set(source, bufferLength);
	        bufferLength += n;
	      }
	    } else {
	      n = 257 - n;
	      const b = repeatHeader[1];
	      buffer = this.ensureBuffer(bufferLength + n + 1);

	      for (let i = 0; i < n; i++) {
	        buffer[bufferLength++] = b;
	      }
	    }

	    this.bufferLength = bufferLength;
	  }

	}

	exports.RunLengthStream = RunLengthStream;

	/***/ }),
	/* 34 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Font = exports.ErrorFont = void 0;

	var _util = __w_pdfjs_require__(2);

	var _cff_parser = __w_pdfjs_require__(35);

	var _fonts_utils = __w_pdfjs_require__(38);

	var _unicode = __w_pdfjs_require__(40);

	var _glyphlist = __w_pdfjs_require__(39);

	var _encodings = __w_pdfjs_require__(37);

	var _standard_fonts = __w_pdfjs_require__(41);

	var _to_unicode_map = __w_pdfjs_require__(42);

	var _cff_font = __w_pdfjs_require__(43);

	var _font_renderer = __w_pdfjs_require__(44);

	var _metrics = __w_pdfjs_require__(45);

	var _glyf = __w_pdfjs_require__(46);

	var _cmap = __w_pdfjs_require__(16);

	var _opentype_file_builder = __w_pdfjs_require__(47);

	var _core_utils = __w_pdfjs_require__(6);

	var _stream = __w_pdfjs_require__(10);

	var _type1_font = __w_pdfjs_require__(48);

	const PRIVATE_USE_AREAS = [[0xe000, 0xf8ff], [0x100000, 0x10fffd]];
	const PDF_GLYPH_SPACE_UNITS = 1000;
	const EXPORT_DATA_PROPERTIES = ["ascent", "bbox", "black", "bold", "charProcOperatorList", "composite", "cssFontInfo", "data", "defaultVMetrics", "defaultWidth", "descent", "fallbackName", "fontMatrix", "fontType", "isType3Font", "italic", "loadedName", "mimetype", "missingFile", "name", "remeasure", "subtype", "type", "vertical"];
	const EXPORT_DATA_EXTRA_PROPERTIES = ["cMap", "defaultEncoding", "differences", "isMonospace", "isSerifFont", "isSymbolicFont", "seacMap", "toFontChar", "toUnicode", "vmetrics", "widths"];

	function adjustWidths(properties) {
	  if (!properties.fontMatrix) {
	    return;
	  }

	  if (properties.fontMatrix[0] === _util.FONT_IDENTITY_MATRIX[0]) {
	    return;
	  }

	  const scale = 0.001 / properties.fontMatrix[0];
	  const glyphsWidths = properties.widths;

	  for (const glyph in glyphsWidths) {
	    glyphsWidths[glyph] *= scale;
	  }

	  properties.defaultWidth *= scale;
	}

	function adjustToUnicode(properties, builtInEncoding) {
	  if (properties.isInternalFont) {
	    return;
	  }

	  if (builtInEncoding === properties.defaultEncoding) {
	    return;
	  }

	  if (properties.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap) {
	    return;
	  }

	  const toUnicode = [],
	        glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();

	  for (const charCode in builtInEncoding) {
	    if (properties.hasIncludedToUnicodeMap) {
	      if (properties.toUnicode.has(charCode)) {
	        continue;
	      }
	    } else if (properties.hasEncoding) {
	      if (properties.differences.length === 0 || properties.differences[charCode] !== undefined) {
	        continue;
	      }
	    }

	    const glyphName = builtInEncoding[charCode];
	    const unicode = (0, _unicode.getUnicodeForGlyph)(glyphName, glyphsUnicodeMap);

	    if (unicode !== -1) {
	      toUnicode[charCode] = String.fromCharCode(unicode);
	    }
	  }

	  if (toUnicode.length > 0) {
	    properties.toUnicode.amend(toUnicode);
	  }
	}

	function amendFallbackToUnicode(properties) {
	  if (!properties.fallbackToUnicode) {
	    return;
	  }

	  if (properties.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap) {
	    return;
	  }

	  const toUnicode = [];

	  for (const charCode in properties.fallbackToUnicode) {
	    if (properties.toUnicode.has(charCode)) {
	      continue;
	    }

	    toUnicode[charCode] = properties.fallbackToUnicode[charCode];
	  }

	  if (toUnicode.length > 0) {
	    properties.toUnicode.amend(toUnicode);
	  }
	}

	class Glyph {
	  constructor(originalCharCode, fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont) {
	    this.originalCharCode = originalCharCode;
	    this.fontChar = fontChar;
	    this.unicode = unicode;
	    this.accent = accent;
	    this.width = width;
	    this.vmetric = vmetric;
	    this.operatorListId = operatorListId;
	    this.isSpace = isSpace;
	    this.isInFont = isInFont;
	    const category = (0, _unicode.getCharUnicodeCategory)(unicode);
	    this.isWhitespace = category.isWhitespace;
	    this.isZeroWidthDiacritic = category.isZeroWidthDiacritic;
	    this.isInvisibleFormatMark = category.isInvisibleFormatMark;
	  }

	  matchesForCache(originalCharCode, fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont) {
	    return this.originalCharCode === originalCharCode && this.fontChar === fontChar && this.unicode === unicode && this.accent === accent && this.width === width && this.vmetric === vmetric && this.operatorListId === operatorListId && this.isSpace === isSpace && this.isInFont === isInFont;
	  }

	}

	function int16(b0, b1) {
	  return (b0 << 8) + b1;
	}

	function writeSignedInt16(bytes, index, value) {
	  bytes[index + 1] = value;
	  bytes[index] = value >>> 8;
	}

	function signedInt16(b0, b1) {
	  const value = (b0 << 8) + b1;
	  return value & 1 << 15 ? value - 0x10000 : value;
	}

	function int32(b0, b1, b2, b3) {
	  return (b0 << 24) + (b1 << 16) + (b2 << 8) + b3;
	}

	function string16(value) {
	  return String.fromCharCode(value >> 8 & 0xff, value & 0xff);
	}

	function safeString16(value) {
	  if (value > 0x7fff) {
	    value = 0x7fff;
	  } else if (value < -0x8000) {
	    value = -0x8000;
	  }

	  return String.fromCharCode(value >> 8 & 0xff, value & 0xff);
	}

	function isTrueTypeFile(file) {
	  const header = file.peekBytes(4);
	  return (0, _core_utils.readUint32)(header, 0) === 0x00010000 || (0, _util.bytesToString)(header) === "true";
	}

	function isTrueTypeCollectionFile(file) {
	  const header = file.peekBytes(4);
	  return (0, _util.bytesToString)(header) === "ttcf";
	}

	function isOpenTypeFile(file) {
	  const header = file.peekBytes(4);
	  return (0, _util.bytesToString)(header) === "OTTO";
	}

	function isType1File(file) {
	  const header = file.peekBytes(2);

	  if (header[0] === 0x25 && header[1] === 0x21) {
	    return true;
	  }

	  if (header[0] === 0x80 && header[1] === 0x01) {
	    return true;
	  }

	  return false;
	}

	function isCFFFile(file) {
	  const header = file.peekBytes(4);

	  if (header[0] >= 1 && header[3] >= 1 && header[3] <= 4) {
	    return true;
	  }

	  return false;
	}

	function getFontFileType(file, {
	  type,
	  subtype,
	  composite
	}) {
	  let fileType, fileSubtype;

	  if (isTrueTypeFile(file) || isTrueTypeCollectionFile(file)) {
	    if (composite) {
	      fileType = "CIDFontType2";
	    } else {
	      fileType = "TrueType";
	    }
	  } else if (isOpenTypeFile(file)) {
	    if (composite) {
	      fileType = "CIDFontType2";
	    } else {
	      fileType = "OpenType";
	    }
	  } else if (isType1File(file)) {
	    if (composite) {
	      fileType = "CIDFontType0";
	    } else {
	      fileType = type === "MMType1" ? "MMType1" : "Type1";
	    }
	  } else if (isCFFFile(file)) {
	    if (composite) {
	      fileType = "CIDFontType0";
	      fileSubtype = "CIDFontType0C";
	    } else {
	      fileType = type === "MMType1" ? "MMType1" : "Type1";
	      fileSubtype = "Type1C";
	    }
	  } else {
	    (0, _util.warn)("getFontFileType: Unable to detect correct font file Type/Subtype.");
	    fileType = type;
	    fileSubtype = subtype;
	  }

	  return [fileType, fileSubtype];
	}

	function applyStandardFontGlyphMap(map, glyphMap) {
	  for (const charCode in glyphMap) {
	    map[+charCode] = glyphMap[charCode];
	  }
	}

	function buildToFontChar(encoding, glyphsUnicodeMap, differences) {
	  const toFontChar = [];
	  let unicode;

	  for (let i = 0, ii = encoding.length; i < ii; i++) {
	    unicode = (0, _unicode.getUnicodeForGlyph)(encoding[i], glyphsUnicodeMap);

	    if (unicode !== -1) {
	      toFontChar[i] = unicode;
	    }
	  }

	  for (const charCode in differences) {
	    unicode = (0, _unicode.getUnicodeForGlyph)(differences[charCode], glyphsUnicodeMap);

	    if (unicode !== -1) {
	      toFontChar[+charCode] = unicode;
	    }
	  }

	  return toFontChar;
	}

	function convertCidString(charCode, cid, shouldThrow = false) {
	  switch (cid.length) {
	    case 1:
	      return cid.charCodeAt(0);

	    case 2:
	      return cid.charCodeAt(0) << 8 | cid.charCodeAt(1);
	  }

	  const msg = `Unsupported CID string (charCode ${charCode}): "${cid}".`;

	  if (shouldThrow) {
	    throw new _util.FormatError(msg);
	  }

	  (0, _util.warn)(msg);
	  return cid;
	}

	function adjustMapping(charCodeToGlyphId, hasGlyph, newGlyphZeroId, toUnicode) {
	  const newMap = Object.create(null);
	  const toUnicodeExtraMap = new Map();
	  const toFontChar = [];
	  const usedGlyphIds = new Set();
	  let privateUseAreaIndex = 0;
	  const privateUseOffetStart = PRIVATE_USE_AREAS[privateUseAreaIndex][0];
	  let nextAvailableFontCharCode = privateUseOffetStart;
	  let privateUseOffetEnd = PRIVATE_USE_AREAS[privateUseAreaIndex][1];

	  for (let originalCharCode in charCodeToGlyphId) {
	    originalCharCode |= 0;
	    let glyphId = charCodeToGlyphId[originalCharCode];

	    if (!hasGlyph(glyphId)) {
	      continue;
	    }

	    if (nextAvailableFontCharCode > privateUseOffetEnd) {
	      privateUseAreaIndex++;

	      if (privateUseAreaIndex >= PRIVATE_USE_AREAS.length) {
	        (0, _util.warn)("Ran out of space in font private use area.");
	        break;
	      }

	      nextAvailableFontCharCode = PRIVATE_USE_AREAS[privateUseAreaIndex][0];
	      privateUseOffetEnd = PRIVATE_USE_AREAS[privateUseAreaIndex][1];
	    }

	    const fontCharCode = nextAvailableFontCharCode++;

	    if (glyphId === 0) {
	      glyphId = newGlyphZeroId;
	    }

	    let unicode = toUnicode.get(originalCharCode);

	    if (typeof unicode === "string") {
	      unicode = unicode.codePointAt(0);
	    }

	    if (unicode && unicode < privateUseOffetStart && !usedGlyphIds.has(glyphId)) {
	      toUnicodeExtraMap.set(unicode, glyphId);
	      usedGlyphIds.add(glyphId);
	    }

	    newMap[fontCharCode] = glyphId;
	    toFontChar[originalCharCode] = fontCharCode;
	  }

	  return {
	    toFontChar,
	    charCodeToGlyphId: newMap,
	    toUnicodeExtraMap,
	    nextAvailableFontCharCode
	  };
	}

	function getRanges(glyphs, toUnicodeExtraMap, numGlyphs) {
	  const codes = [];

	  for (const charCode in glyphs) {
	    if (glyphs[charCode] >= numGlyphs) {
	      continue;
	    }

	    codes.push({
	      fontCharCode: charCode | 0,
	      glyphId: glyphs[charCode]
	    });
	  }

	  if (toUnicodeExtraMap) {
	    for (const [unicode, glyphId] of toUnicodeExtraMap) {
	      if (glyphId >= numGlyphs) {
	        continue;
	      }

	      codes.push({
	        fontCharCode: unicode,
	        glyphId
	      });
	    }
	  }

	  if (codes.length === 0) {
	    codes.push({
	      fontCharCode: 0,
	      glyphId: 0
	    });
	  }

	  codes.sort(function fontGetRangesSort(a, b) {
	    return a.fontCharCode - b.fontCharCode;
	  });
	  const ranges = [];
	  const length = codes.length;

	  for (let n = 0; n < length;) {
	    const start = codes[n].fontCharCode;
	    const codeIndices = [codes[n].glyphId];
	    ++n;
	    let end = start;

	    while (n < length && end + 1 === codes[n].fontCharCode) {
	      codeIndices.push(codes[n].glyphId);
	      ++end;
	      ++n;

	      if (end === 0xffff) {
	        break;
	      }
	    }

	    ranges.push([start, end, codeIndices]);
	  }

	  return ranges;
	}

	function createCmapTable(glyphs, toUnicodeExtraMap, numGlyphs) {
	  const ranges = getRanges(glyphs, toUnicodeExtraMap, numGlyphs);
	  const numTables = ranges.at(-1)[1] > 0xffff ? 2 : 1;
	  let cmap = "\x00\x00" + string16(numTables) + "\x00\x03" + "\x00\x01" + (0, _util.string32)(4 + numTables * 8);
	  let i, ii, j, jj;

	  for (i = ranges.length - 1; i >= 0; --i) {
	    if (ranges[i][0] <= 0xffff) {
	      break;
	    }
	  }

	  const bmpLength = i + 1;

	  if (ranges[i][0] < 0xffff && ranges[i][1] === 0xffff) {
	    ranges[i][1] = 0xfffe;
	  }

	  const trailingRangesCount = ranges[i][1] < 0xffff ? 1 : 0;
	  const segCount = bmpLength + trailingRangesCount;

	  const searchParams = _opentype_file_builder.OpenTypeFileBuilder.getSearchParams(segCount, 2);

	  let startCount = "";
	  let endCount = "";
	  let idDeltas = "";
	  let idRangeOffsets = "";
	  let glyphsIds = "";
	  let bias = 0;
	  let range, start, end, codes;

	  for (i = 0, ii = bmpLength; i < ii; i++) {
	    range = ranges[i];
	    start = range[0];
	    end = range[1];
	    startCount += string16(start);
	    endCount += string16(end);
	    codes = range[2];
	    let contiguous = true;

	    for (j = 1, jj = codes.length; j < jj; ++j) {
	      if (codes[j] !== codes[j - 1] + 1) {
	        contiguous = false;
	        break;
	      }
	    }

	    if (!contiguous) {
	      const offset = (segCount - i) * 2 + bias * 2;
	      bias += end - start + 1;
	      idDeltas += string16(0);
	      idRangeOffsets += string16(offset);

	      for (j = 0, jj = codes.length; j < jj; ++j) {
	        glyphsIds += string16(codes[j]);
	      }
	    } else {
	      const startCode = codes[0];
	      idDeltas += string16(startCode - start & 0xffff);
	      idRangeOffsets += string16(0);
	    }
	  }

	  if (trailingRangesCount > 0) {
	    endCount += "\xFF\xFF";
	    startCount += "\xFF\xFF";
	    idDeltas += "\x00\x01";
	    idRangeOffsets += "\x00\x00";
	  }

	  const format314 = "\x00\x00" + string16(2 * segCount) + string16(searchParams.range) + string16(searchParams.entry) + string16(searchParams.rangeShift) + endCount + "\x00\x00" + startCount + idDeltas + idRangeOffsets + glyphsIds;
	  let format31012 = "";
	  let header31012 = "";

	  if (numTables > 1) {
	    cmap += "\x00\x03" + "\x00\x0A" + (0, _util.string32)(4 + numTables * 8 + 4 + format314.length);
	    format31012 = "";

	    for (i = 0, ii = ranges.length; i < ii; i++) {
	      range = ranges[i];
	      start = range[0];
	      codes = range[2];
	      let code = codes[0];

	      for (j = 1, jj = codes.length; j < jj; ++j) {
	        if (codes[j] !== codes[j - 1] + 1) {
	          end = range[0] + j - 1;
	          format31012 += (0, _util.string32)(start) + (0, _util.string32)(end) + (0, _util.string32)(code);
	          start = end + 1;
	          code = codes[j];
	        }
	      }

	      format31012 += (0, _util.string32)(start) + (0, _util.string32)(range[1]) + (0, _util.string32)(code);
	    }

	    header31012 = "\x00\x0C" + "\x00\x00" + (0, _util.string32)(format31012.length + 16) + "\x00\x00\x00\x00" + (0, _util.string32)(format31012.length / 12);
	  }

	  return cmap + "\x00\x04" + string16(format314.length + 4) + format314 + header31012 + format31012;
	}

	function validateOS2Table(os2, file) {
	  file.pos = (file.start || 0) + os2.offset;
	  const version = file.getUint16();
	  file.skip(60);
	  const selection = file.getUint16();

	  if (version < 4 && selection & 0x0300) {
	    return false;
	  }

	  const firstChar = file.getUint16();
	  const lastChar = file.getUint16();

	  if (firstChar > lastChar) {
	    return false;
	  }

	  file.skip(6);
	  const usWinAscent = file.getUint16();

	  if (usWinAscent === 0) {
	    return false;
	  }

	  os2.data[8] = os2.data[9] = 0;
	  return true;
	}

	function createOS2Table(properties, charstrings, override) {
	  override = override || {
	    unitsPerEm: 0,
	    yMax: 0,
	    yMin: 0,
	    ascent: 0,
	    descent: 0
	  };
	  let ulUnicodeRange1 = 0;
	  let ulUnicodeRange2 = 0;
	  let ulUnicodeRange3 = 0;
	  let ulUnicodeRange4 = 0;
	  let firstCharIndex = null;
	  let lastCharIndex = 0;

	  if (charstrings) {
	    for (let code in charstrings) {
	      code |= 0;

	      if (firstCharIndex > code || !firstCharIndex) {
	        firstCharIndex = code;
	      }

	      if (lastCharIndex < code) {
	        lastCharIndex = code;
	      }

	      const position = (0, _unicode.getUnicodeRangeFor)(code);

	      if (position < 32) {
	        ulUnicodeRange1 |= 1 << position;
	      } else if (position < 64) {
	        ulUnicodeRange2 |= 1 << position - 32;
	      } else if (position < 96) {
	        ulUnicodeRange3 |= 1 << position - 64;
	      } else if (position < 123) {
	        ulUnicodeRange4 |= 1 << position - 96;
	      } else {
	        throw new _util.FormatError("Unicode ranges Bits > 123 are reserved for internal usage");
	      }
	    }

	    if (lastCharIndex > 0xffff) {
	      lastCharIndex = 0xffff;
	    }
	  } else {
	    firstCharIndex = 0;
	    lastCharIndex = 255;
	  }

	  const bbox = properties.bbox || [0, 0, 0, 0];
	  const unitsPerEm = override.unitsPerEm || 1 / (properties.fontMatrix || _util.FONT_IDENTITY_MATRIX)[0];
	  const scale = properties.ascentScaled ? 1.0 : unitsPerEm / PDF_GLYPH_SPACE_UNITS;
	  const typoAscent = override.ascent || Math.round(scale * (properties.ascent || bbox[3]));
	  let typoDescent = override.descent || Math.round(scale * (properties.descent || bbox[1]));

	  if (typoDescent > 0 && properties.descent > 0 && bbox[1] < 0) {
	    typoDescent = -typoDescent;
	  }

	  const winAscent = override.yMax || typoAscent;
	  const winDescent = -override.yMin || -typoDescent;
	  return "\x00\x03" + "\x02\x24" + "\x01\xF4" + "\x00\x05" + "\x00\x00" + "\x02\x8A" + "\x02\xBB" + "\x00\x00" + "\x00\x8C" + "\x02\x8A" + "\x02\xBB" + "\x00\x00" + "\x01\xDF" + "\x00\x31" + "\x01\x02" + "\x00\x00" + "\x00\x00\x06" + String.fromCharCode(properties.fixedPitch ? 0x09 : 0x00) + "\x00\x00\x00\x00\x00\x00" + (0, _util.string32)(ulUnicodeRange1) + (0, _util.string32)(ulUnicodeRange2) + (0, _util.string32)(ulUnicodeRange3) + (0, _util.string32)(ulUnicodeRange4) + "\x2A\x32\x31\x2A" + string16(properties.italicAngle ? 1 : 0) + string16(firstCharIndex || properties.firstChar) + string16(lastCharIndex || properties.lastChar) + string16(typoAscent) + string16(typoDescent) + "\x00\x64" + string16(winAscent) + string16(winDescent) + "\x00\x00\x00\x00" + "\x00\x00\x00\x00" + string16(properties.xHeight) + string16(properties.capHeight) + string16(0) + string16(firstCharIndex || properties.firstChar) + "\x00\x03";
	}

	function createPostTable(properties) {
	  const angle = Math.floor(properties.italicAngle * 2 ** 16);
	  return "\x00\x03\x00\x00" + (0, _util.string32)(angle) + "\x00\x00" + "\x00\x00" + (0, _util.string32)(properties.fixedPitch ? 1 : 0) + "\x00\x00\x00\x00" + "\x00\x00\x00\x00" + "\x00\x00\x00\x00" + "\x00\x00\x00\x00";
	}

	function createPostscriptName(name) {
	  return name.replace(/[^\x21-\x7E]|[[\](){}<>/%]/g, "").slice(0, 63);
	}

	function createNameTable(name, proto) {
	  if (!proto) {
	    proto = [[], []];
	  }

	  const strings = [proto[0][0] || "Original licence", proto[0][1] || name, proto[0][2] || "Unknown", proto[0][3] || "uniqueID", proto[0][4] || name, proto[0][5] || "Version 0.11", proto[0][6] || createPostscriptName(name), proto[0][7] || "Unknown", proto[0][8] || "Unknown", proto[0][9] || "Unknown"];
	  const stringsUnicode = [];
	  let i, ii, j, jj, str;

	  for (i = 0, ii = strings.length; i < ii; i++) {
	    str = proto[1][i] || strings[i];
	    const strBufUnicode = [];

	    for (j = 0, jj = str.length; j < jj; j++) {
	      strBufUnicode.push(string16(str.charCodeAt(j)));
	    }

	    stringsUnicode.push(strBufUnicode.join(""));
	  }

	  const names = [strings, stringsUnicode];
	  const platforms = ["\x00\x01", "\x00\x03"];
	  const encodings = ["\x00\x00", "\x00\x01"];
	  const languages = ["\x00\x00", "\x04\x09"];
	  const namesRecordCount = strings.length * platforms.length;
	  let nameTable = "\x00\x00" + string16(namesRecordCount) + string16(namesRecordCount * 12 + 6);
	  let strOffset = 0;

	  for (i = 0, ii = platforms.length; i < ii; i++) {
	    const strs = names[i];

	    for (j = 0, jj = strs.length; j < jj; j++) {
	      str = strs[j];
	      const nameRecord = platforms[i] + encodings[i] + languages[i] + string16(j) + string16(str.length) + string16(strOffset);
	      nameTable += nameRecord;
	      strOffset += str.length;
	    }
	  }

	  nameTable += strings.join("") + stringsUnicode.join("");
	  return nameTable;
	}

	class Font {
	  constructor(name, file, properties) {
	    this.name = name;
	    this.psName = null;
	    this.mimetype = null;
	    this.disableFontFace = false;
	    this.loadedName = properties.loadedName;
	    this.isType3Font = properties.isType3Font;
	    this.missingFile = false;
	    this.cssFontInfo = properties.cssFontInfo;
	    this._charsCache = Object.create(null);
	    this._glyphCache = Object.create(null);
	    let isSerifFont = !!(properties.flags & _fonts_utils.FontFlags.Serif);

	    if (!isSerifFont && !properties.isSimulatedFlags) {
	      const baseName = name.replace(/[,_]/g, "-").split("-")[0],
	            serifFonts = (0, _standard_fonts.getSerifFonts)();

	      for (const namePart of baseName.split("+")) {
	        if (serifFonts[namePart]) {
	          isSerifFont = true;
	          break;
	        }
	      }
	    }

	    this.isSerifFont = isSerifFont;
	    this.isSymbolicFont = !!(properties.flags & _fonts_utils.FontFlags.Symbolic);
	    this.isMonospace = !!(properties.flags & _fonts_utils.FontFlags.FixedPitch);
	    let type = properties.type;
	    let subtype = properties.subtype;
	    this.type = type;
	    this.subtype = subtype;
	    let fallbackName = "sans-serif";

	    if (this.isMonospace) {
	      fallbackName = "monospace";
	    } else if (this.isSerifFont) {
	      fallbackName = "serif";
	    }

	    this.fallbackName = fallbackName;
	    this.differences = properties.differences;
	    this.widths = properties.widths;
	    this.defaultWidth = properties.defaultWidth;
	    this.composite = properties.composite;
	    this.cMap = properties.cMap;
	    this.capHeight = properties.capHeight / PDF_GLYPH_SPACE_UNITS;
	    this.ascent = properties.ascent / PDF_GLYPH_SPACE_UNITS;
	    this.descent = properties.descent / PDF_GLYPH_SPACE_UNITS;
	    this.lineHeight = this.ascent - this.descent;
	    this.fontMatrix = properties.fontMatrix;
	    this.bbox = properties.bbox;
	    this.defaultEncoding = properties.defaultEncoding;
	    this.toUnicode = properties.toUnicode;
	    this.toFontChar = [];

	    if (properties.type === "Type3") {
	      for (let charCode = 0; charCode < 256; charCode++) {
	        this.toFontChar[charCode] = this.differences[charCode] || properties.defaultEncoding[charCode];
	      }

	      this.fontType = _util.FontType.TYPE3;
	      return;
	    }

	    this.cidEncoding = properties.cidEncoding || "";
	    this.vertical = !!properties.vertical;

	    if (this.vertical) {
	      this.vmetrics = properties.vmetrics;
	      this.defaultVMetrics = properties.defaultVMetrics;
	    }

	    if (!file || file.isEmpty) {
	      if (file) {
	        (0, _util.warn)('Font file is empty in "' + name + '" (' + this.loadedName + ")");
	      }

	      this.fallbackToSystemFont(properties);
	      return;
	    }

	    [type, subtype] = getFontFileType(file, properties);

	    if (type !== this.type || subtype !== this.subtype) {
	      (0, _util.info)("Inconsistent font file Type/SubType, expected: " + `${this.type}/${this.subtype} but found: ${type}/${subtype}.`);
	    }

	    let data;

	    try {
	      switch (type) {
	        case "MMType1":
	          (0, _util.info)("MMType1 font (" + name + "), falling back to Type1.");

	        case "Type1":
	        case "CIDFontType0":
	          this.mimetype = "font/opentype";
	          const cff = subtype === "Type1C" || subtype === "CIDFontType0C" ? new _cff_font.CFFFont(file, properties) : new _type1_font.Type1Font(name, file, properties);
	          adjustWidths(properties);
	          data = this.convert(name, cff, properties);
	          break;

	        case "OpenType":
	        case "TrueType":
	        case "CIDFontType2":
	          this.mimetype = "font/opentype";
	          data = this.checkAndRepair(name, file, properties);

	          if (this.isOpenType) {
	            adjustWidths(properties);
	            type = "OpenType";
	          }

	          break;

	        default:
	          throw new _util.FormatError(`Font ${type} is not supported`);
	      }
	    } catch (e) {
	      (0, _util.warn)(e);
	      this.fallbackToSystemFont(properties);
	      return;
	    }

	    amendFallbackToUnicode(properties);
	    this.data = data;
	    this.fontType = (0, _fonts_utils.getFontType)(type, subtype, properties.isStandardFont);
	    this.fontMatrix = properties.fontMatrix;
	    this.widths = properties.widths;
	    this.defaultWidth = properties.defaultWidth;
	    this.toUnicode = properties.toUnicode;
	    this.seacMap = properties.seacMap;
	  }

	  get renderer() {
	    const renderer = _font_renderer.FontRendererFactory.create(this, _fonts_utils.SEAC_ANALYSIS_ENABLED);

	    return (0, _util.shadow)(this, "renderer", renderer);
	  }

	  exportData(extraProperties = false) {
	    const exportDataProperties = extraProperties ? [...EXPORT_DATA_PROPERTIES, ...EXPORT_DATA_EXTRA_PROPERTIES] : EXPORT_DATA_PROPERTIES;
	    const data = Object.create(null);
	    let property, value;

	    for (property of exportDataProperties) {
	      value = this[property];

	      if (value !== undefined) {
	        data[property] = value;
	      }
	    }

	    return data;
	  }

	  fallbackToSystemFont(properties) {
	    this.missingFile = true;
	    const name = this.name;
	    const type = this.type;
	    const subtype = this.subtype;
	    let fontName = (0, _fonts_utils.normalizeFontName)(name);
	    const stdFontMap = (0, _standard_fonts.getStdFontMap)(),
	          nonStdFontMap = (0, _standard_fonts.getNonStdFontMap)();
	    const isStandardFont = !!stdFontMap[fontName];
	    const isMappedToStandardFont = !!(nonStdFontMap[fontName] && stdFontMap[nonStdFontMap[fontName]]);
	    fontName = stdFontMap[fontName] || nonStdFontMap[fontName] || fontName;
	    const fontBasicMetricsMap = (0, _metrics.getFontBasicMetrics)();
	    const metrics = fontBasicMetricsMap[fontName];

	    if (metrics) {
	      if (isNaN(this.ascent)) {
	        this.ascent = metrics.ascent / PDF_GLYPH_SPACE_UNITS;
	      }

	      if (isNaN(this.descent)) {
	        this.descent = metrics.descent / PDF_GLYPH_SPACE_UNITS;
	      }

	      if (isNaN(this.capHeight)) {
	        this.capHeight = metrics.capHeight / PDF_GLYPH_SPACE_UNITS;
	      }
	    }

	    this.bold = fontName.search(/bold/gi) !== -1;
	    this.italic = fontName.search(/oblique/gi) !== -1 || fontName.search(/italic/gi) !== -1;
	    this.black = name.search(/Black/g) !== -1;
	    const isNarrow = name.search(/Narrow/g) !== -1;
	    this.remeasure = (!isStandardFont || isNarrow) && Object.keys(this.widths).length > 0;

	    if ((isStandardFont || isMappedToStandardFont) && type === "CIDFontType2" && this.cidEncoding.startsWith("Identity-")) {
	      const cidToGidMap = properties.cidToGidMap;
	      const map = [];
	      applyStandardFontGlyphMap(map, (0, _standard_fonts.getGlyphMapForStandardFonts)());

	      if (/Arial-?Black/i.test(name)) {
	        applyStandardFontGlyphMap(map, (0, _standard_fonts.getSupplementalGlyphMapForArialBlack)());
	      } else if (/Calibri/i.test(name)) {
	        applyStandardFontGlyphMap(map, (0, _standard_fonts.getSupplementalGlyphMapForCalibri)());
	      }

	      if (cidToGidMap) {
	        for (const charCode in map) {
	          const cid = map[charCode];

	          if (cidToGidMap[cid] !== undefined) {
	            map[+charCode] = cidToGidMap[cid];
	          }
	        }

	        if (cidToGidMap.length !== this.toUnicode.length && properties.hasIncludedToUnicodeMap && this.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap) {
	          this.toUnicode.forEach(function (charCode, unicodeCharCode) {
	            const cid = map[charCode];

	            if (cidToGidMap[cid] === undefined) {
	              map[+charCode] = unicodeCharCode;
	            }
	          });
	        }
	      }

	      if (!(this.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap)) {
	        this.toUnicode.forEach(function (charCode, unicodeCharCode) {
	          map[+charCode] = unicodeCharCode;
	        });
	      }

	      this.toFontChar = map;
	      this.toUnicode = new _to_unicode_map.ToUnicodeMap(map);
	    } else if (/Symbol/i.test(fontName)) {
	      this.toFontChar = buildToFontChar(_encodings.SymbolSetEncoding, (0, _glyphlist.getGlyphsUnicode)(), this.differences);
	    } else if (/Dingbats/i.test(fontName)) {
	      if (/Wingdings/i.test(name)) {
	        (0, _util.warn)("Non-embedded Wingdings font, falling back to ZapfDingbats.");
	      }

	      this.toFontChar = buildToFontChar(_encodings.ZapfDingbatsEncoding, (0, _glyphlist.getDingbatsGlyphsUnicode)(), this.differences);
	    } else if (isStandardFont) {
	      const map = buildToFontChar(this.defaultEncoding, (0, _glyphlist.getGlyphsUnicode)(), this.differences);

	      if (type === "CIDFontType2" && !this.cidEncoding.startsWith("Identity-") && !(this.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap)) {
	        this.toUnicode.forEach(function (charCode, unicodeCharCode) {
	          map[+charCode] = unicodeCharCode;
	        });
	      }

	      this.toFontChar = map;
	    } else {
	      const glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();
	      const map = [];
	      this.toUnicode.forEach((charCode, unicodeCharCode) => {
	        if (!this.composite) {
	          const glyphName = this.differences[charCode] || this.defaultEncoding[charCode];
	          const unicode = (0, _unicode.getUnicodeForGlyph)(glyphName, glyphsUnicodeMap);

	          if (unicode !== -1) {
	            unicodeCharCode = unicode;
	          }
	        }

	        map[+charCode] = unicodeCharCode;
	      });

	      if (this.composite && this.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap) {
	        if (/Verdana/i.test(name)) {
	          applyStandardFontGlyphMap(map, (0, _standard_fonts.getGlyphMapForStandardFonts)());
	        }
	      }

	      this.toFontChar = map;
	    }

	    amendFallbackToUnicode(properties);
	    this.loadedName = fontName.split("-")[0];
	    this.fontType = (0, _fonts_utils.getFontType)(type, subtype, properties.isStandardFont);
	  }

	  checkAndRepair(name, font, properties) {
	    const VALID_TABLES = ["OS/2", "cmap", "head", "hhea", "hmtx", "maxp", "name", "post", "loca", "glyf", "fpgm", "prep", "cvt ", "CFF "];

	    function readTables(file, numTables) {
	      const tables = Object.create(null);
	      tables["OS/2"] = null;
	      tables.cmap = null;
	      tables.head = null;
	      tables.hhea = null;
	      tables.hmtx = null;
	      tables.maxp = null;
	      tables.name = null;
	      tables.post = null;

	      for (let i = 0; i < numTables; i++) {
	        const table = readTableEntry(file);

	        if (!VALID_TABLES.includes(table.tag)) {
	          continue;
	        }

	        if (table.length === 0) {
	          continue;
	        }

	        tables[table.tag] = table;
	      }

	      return tables;
	    }

	    function readTableEntry(file) {
	      const tag = file.getString(4);
	      const checksum = file.getInt32() >>> 0;
	      const offset = file.getInt32() >>> 0;
	      const length = file.getInt32() >>> 0;
	      const previousPosition = file.pos;
	      file.pos = file.start || 0;
	      file.skip(offset);
	      const data = file.getBytes(length);
	      file.pos = previousPosition;

	      if (tag === "head") {
	        data[8] = data[9] = data[10] = data[11] = 0;
	        data[17] |= 0x20;
	      }

	      return {
	        tag,
	        checksum,
	        length,
	        offset,
	        data
	      };
	    }

	    function readOpenTypeHeader(ttf) {
	      return {
	        version: ttf.getString(4),
	        numTables: ttf.getUint16(),
	        searchRange: ttf.getUint16(),
	        entrySelector: ttf.getUint16(),
	        rangeShift: ttf.getUint16()
	      };
	    }

	    function readTrueTypeCollectionHeader(ttc) {
	      const ttcTag = ttc.getString(4);
	      (0, _util.assert)(ttcTag === "ttcf", "Must be a TrueType Collection font.");
	      const majorVersion = ttc.getUint16();
	      const minorVersion = ttc.getUint16();
	      const numFonts = ttc.getInt32() >>> 0;
	      const offsetTable = [];

	      for (let i = 0; i < numFonts; i++) {
	        offsetTable.push(ttc.getInt32() >>> 0);
	      }

	      const header = {
	        ttcTag,
	        majorVersion,
	        minorVersion,
	        numFonts,
	        offsetTable
	      };

	      switch (majorVersion) {
	        case 1:
	          return header;

	        case 2:
	          header.dsigTag = ttc.getInt32() >>> 0;
	          header.dsigLength = ttc.getInt32() >>> 0;
	          header.dsigOffset = ttc.getInt32() >>> 0;
	          return header;
	      }

	      throw new _util.FormatError(`Invalid TrueType Collection majorVersion: ${majorVersion}.`);
	    }

	    function readTrueTypeCollectionData(ttc, fontName) {
	      const {
	        numFonts,
	        offsetTable
	      } = readTrueTypeCollectionHeader(ttc);
	      const fontNameParts = fontName.split("+");
	      let fallbackData;

	      for (let i = 0; i < numFonts; i++) {
	        ttc.pos = (ttc.start || 0) + offsetTable[i];
	        const potentialHeader = readOpenTypeHeader(ttc);
	        const potentialTables = readTables(ttc, potentialHeader.numTables);

	        if (!potentialTables.name) {
	          throw new _util.FormatError('TrueType Collection font must contain a "name" table.');
	        }

	        const nameTable = readNameTable(potentialTables.name);

	        for (let j = 0, jj = nameTable.length; j < jj; j++) {
	          for (let k = 0, kk = nameTable[j].length; k < kk; k++) {
	            const nameEntry = nameTable[j][k] && nameTable[j][k].replace(/\s/g, "");

	            if (!nameEntry) {
	              continue;
	            }

	            if (nameEntry === fontName) {
	              return {
	                header: potentialHeader,
	                tables: potentialTables
	              };
	            }

	            if (fontNameParts.length < 2) {
	              continue;
	            }

	            for (const part of fontNameParts) {
	              if (nameEntry === part) {
	                fallbackData = {
	                  name: part,
	                  header: potentialHeader,
	                  tables: potentialTables
	                };
	              }
	            }
	          }
	        }
	      }

	      if (fallbackData) {
	        (0, _util.warn)(`TrueType Collection does not contain "${fontName}" font, ` + `falling back to "${fallbackData.name}" font instead.`);
	        return {
	          header: fallbackData.header,
	          tables: fallbackData.tables
	        };
	      }

	      throw new _util.FormatError(`TrueType Collection does not contain "${fontName}" font.`);
	    }

	    function readCmapTable(cmap, file, isSymbolicFont, hasEncoding) {
	      if (!cmap) {
	        (0, _util.warn)("No cmap table available.");
	        return {
	          platformId: -1,
	          encodingId: -1,
	          mappings: [],
	          hasShortCmap: false
	        };
	      }

	      let segment;
	      let start = (file.start || 0) + cmap.offset;
	      file.pos = start;
	      file.skip(2);
	      const numTables = file.getUint16();
	      let potentialTable;
	      let canBreak = false;

	      for (let i = 0; i < numTables; i++) {
	        const platformId = file.getUint16();
	        const encodingId = file.getUint16();
	        const offset = file.getInt32() >>> 0;
	        let useTable = false;

	        if (potentialTable && potentialTable.platformId === platformId && potentialTable.encodingId === encodingId) {
	          continue;
	        }

	        if (platformId === 0 && (encodingId === 0 || encodingId === 1 || encodingId === 3)) {
	          useTable = true;
	        } else if (platformId === 1 && encodingId === 0) {
	          useTable = true;
	        } else if (platformId === 3 && encodingId === 1 && (hasEncoding || !potentialTable)) {
	          useTable = true;

	          if (!isSymbolicFont) {
	            canBreak = true;
	          }
	        } else if (isSymbolicFont && platformId === 3 && encodingId === 0) {
	          useTable = true;
	          let correctlySorted = true;

	          if (i < numTables - 1) {
	            const nextBytes = file.peekBytes(2),
	                  nextPlatformId = int16(nextBytes[0], nextBytes[1]);

	            if (nextPlatformId < platformId) {
	              correctlySorted = false;
	            }
	          }

	          if (correctlySorted) {
	            canBreak = true;
	          }
	        }

	        if (useTable) {
	          potentialTable = {
	            platformId,
	            encodingId,
	            offset
	          };
	        }

	        if (canBreak) {
	          break;
	        }
	      }

	      if (potentialTable) {
	        file.pos = start + potentialTable.offset;
	      }

	      if (!potentialTable || file.peekByte() === -1) {
	        (0, _util.warn)("Could not find a preferred cmap table.");
	        return {
	          platformId: -1,
	          encodingId: -1,
	          mappings: [],
	          hasShortCmap: false
	        };
	      }

	      const format = file.getUint16();
	      let hasShortCmap = false;
	      const mappings = [];
	      let j, glyphId;

	      if (format === 0) {
	        file.skip(2 + 2);

	        for (j = 0; j < 256; j++) {
	          const index = file.getByte();

	          if (!index) {
	            continue;
	          }

	          mappings.push({
	            charCode: j,
	            glyphId: index
	          });
	        }

	        hasShortCmap = true;
	      } else if (format === 2) {
	        file.skip(2 + 2);
	        const subHeaderKeys = [];
	        let maxSubHeaderKey = 0;

	        for (let i = 0; i < 256; i++) {
	          const subHeaderKey = file.getUint16() >> 3;
	          subHeaderKeys.push(subHeaderKey);
	          maxSubHeaderKey = Math.max(subHeaderKey, maxSubHeaderKey);
	        }

	        const subHeaders = [];

	        for (let i = 0; i <= maxSubHeaderKey; i++) {
	          subHeaders.push({
	            firstCode: file.getUint16(),
	            entryCount: file.getUint16(),
	            idDelta: signedInt16(file.getByte(), file.getByte()),
	            idRangePos: file.pos + file.getUint16()
	          });
	        }

	        for (let i = 0; i < 256; i++) {
	          if (subHeaderKeys[i] === 0) {
	            file.pos = subHeaders[0].idRangePos + 2 * i;
	            glyphId = file.getUint16();
	            mappings.push({
	              charCode: i,
	              glyphId
	            });
	          } else {
	            const s = subHeaders[subHeaderKeys[i]];

	            for (j = 0; j < s.entryCount; j++) {
	              const charCode = (i << 8) + j + s.firstCode;
	              file.pos = s.idRangePos + 2 * j;
	              glyphId = file.getUint16();

	              if (glyphId !== 0) {
	                glyphId = (glyphId + s.idDelta) % 65536;
	              }

	              mappings.push({
	                charCode,
	                glyphId
	              });
	            }
	          }
	        }
	      } else if (format === 4) {
	        file.skip(2 + 2);
	        const segCount = file.getUint16() >> 1;
	        file.skip(6);
	        const segments = [];
	        let segIndex;

	        for (segIndex = 0; segIndex < segCount; segIndex++) {
	          segments.push({
	            end: file.getUint16()
	          });
	        }

	        file.skip(2);

	        for (segIndex = 0; segIndex < segCount; segIndex++) {
	          segments[segIndex].start = file.getUint16();
	        }

	        for (segIndex = 0; segIndex < segCount; segIndex++) {
	          segments[segIndex].delta = file.getUint16();
	        }

	        let offsetsCount = 0,
	            offsetIndex;

	        for (segIndex = 0; segIndex < segCount; segIndex++) {
	          segment = segments[segIndex];
	          const rangeOffset = file.getUint16();

	          if (!rangeOffset) {
	            segment.offsetIndex = -1;
	            continue;
	          }

	          offsetIndex = (rangeOffset >> 1) - (segCount - segIndex);
	          segment.offsetIndex = offsetIndex;
	          offsetsCount = Math.max(offsetsCount, offsetIndex + segment.end - segment.start + 1);
	        }

	        const offsets = [];

	        for (j = 0; j < offsetsCount; j++) {
	          offsets.push(file.getUint16());
	        }

	        for (segIndex = 0; segIndex < segCount; segIndex++) {
	          segment = segments[segIndex];
	          start = segment.start;
	          const end = segment.end;
	          const delta = segment.delta;
	          offsetIndex = segment.offsetIndex;

	          for (j = start; j <= end; j++) {
	            if (j === 0xffff) {
	              continue;
	            }

	            glyphId = offsetIndex < 0 ? j : offsets[offsetIndex + j - start];
	            glyphId = glyphId + delta & 0xffff;
	            mappings.push({
	              charCode: j,
	              glyphId
	            });
	          }
	        }
	      } else if (format === 6) {
	        file.skip(2 + 2);
	        const firstCode = file.getUint16();
	        const entryCount = file.getUint16();

	        for (j = 0; j < entryCount; j++) {
	          glyphId = file.getUint16();
	          const charCode = firstCode + j;
	          mappings.push({
	            charCode,
	            glyphId
	          });
	        }
	      } else if (format === 12) {
	        file.skip(2 + 4 + 4);
	        const nGroups = file.getInt32() >>> 0;

	        for (j = 0; j < nGroups; j++) {
	          const startCharCode = file.getInt32() >>> 0;
	          const endCharCode = file.getInt32() >>> 0;
	          let glyphCode = file.getInt32() >>> 0;

	          for (let charCode = startCharCode; charCode <= endCharCode; charCode++) {
	            mappings.push({
	              charCode,
	              glyphId: glyphCode++
	            });
	          }
	        }
	      } else {
	        (0, _util.warn)("cmap table has unsupported format: " + format);
	        return {
	          platformId: -1,
	          encodingId: -1,
	          mappings: [],
	          hasShortCmap: false
	        };
	      }

	      mappings.sort(function (a, b) {
	        return a.charCode - b.charCode;
	      });

	      for (let i = 1; i < mappings.length; i++) {
	        if (mappings[i - 1].charCode === mappings[i].charCode) {
	          mappings.splice(i, 1);
	          i--;
	        }
	      }

	      return {
	        platformId: potentialTable.platformId,
	        encodingId: potentialTable.encodingId,
	        mappings,
	        hasShortCmap
	      };
	    }

	    function sanitizeMetrics(file, header, metrics, headTable, numGlyphs, dupFirstEntry) {
	      if (!header) {
	        if (metrics) {
	          metrics.data = null;
	        }

	        return;
	      }

	      file.pos = (file.start || 0) + header.offset;
	      file.pos += 4;
	      file.pos += 2;
	      file.pos += 2;
	      file.pos += 2;
	      file.pos += 2;
	      file.pos += 2;
	      file.pos += 2;
	      file.pos += 2;
	      file.pos += 2;
	      file.pos += 2;
	      const caretOffset = file.getUint16();
	      file.pos += 8;
	      file.pos += 2;
	      let numOfMetrics = file.getUint16();

	      if (caretOffset !== 0) {
	        const macStyle = int16(headTable.data[44], headTable.data[45]);

	        if (!(macStyle & 2)) {
	          header.data[22] = 0;
	          header.data[23] = 0;
	        }
	      }

	      if (numOfMetrics > numGlyphs) {
	        (0, _util.info)(`The numOfMetrics (${numOfMetrics}) should not be ` + `greater than the numGlyphs (${numGlyphs}).`);
	        numOfMetrics = numGlyphs;
	        header.data[34] = (numOfMetrics & 0xff00) >> 8;
	        header.data[35] = numOfMetrics & 0x00ff;
	      }

	      const numOfSidebearings = numGlyphs - numOfMetrics;
	      const numMissing = numOfSidebearings - (metrics.length - numOfMetrics * 4 >> 1);

	      if (numMissing > 0) {
	        const entries = new Uint8Array(metrics.length + numMissing * 2);
	        entries.set(metrics.data);

	        if (dupFirstEntry) {
	          entries[metrics.length] = metrics.data[2];
	          entries[metrics.length + 1] = metrics.data[3];
	        }

	        metrics.data = entries;
	      }
	    }

	    function sanitizeGlyph(source, sourceStart, sourceEnd, dest, destStart, hintsValid) {
	      const glyphProfile = {
	        length: 0,
	        sizeOfInstructions: 0
	      };

	      if (sourceEnd - sourceStart <= 12) {
	        return glyphProfile;
	      }

	      const glyf = source.subarray(sourceStart, sourceEnd);
	      let contoursCount = signedInt16(glyf[0], glyf[1]);

	      if (contoursCount < 0) {
	        contoursCount = -1;
	        writeSignedInt16(glyf, 0, contoursCount);
	        dest.set(glyf, destStart);
	        glyphProfile.length = glyf.length;
	        return glyphProfile;
	      }

	      let i,
	          j = 10,
	          flagsCount = 0;

	      for (i = 0; i < contoursCount; i++) {
	        const endPoint = glyf[j] << 8 | glyf[j + 1];
	        flagsCount = endPoint + 1;
	        j += 2;
	      }

	      const instructionsStart = j;
	      const instructionsLength = glyf[j] << 8 | glyf[j + 1];
	      glyphProfile.sizeOfInstructions = instructionsLength;
	      j += 2 + instructionsLength;
	      const instructionsEnd = j;
	      let coordinatesLength = 0;

	      for (i = 0; i < flagsCount; i++) {
	        const flag = glyf[j++];

	        if (flag & 0xc0) {
	          glyf[j - 1] = flag & 0x3f;
	        }

	        let xLength = 2;

	        if (flag & 2) {
	          xLength = 1;
	        } else if (flag & 16) {
	          xLength = 0;
	        }

	        let yLength = 2;

	        if (flag & 4) {
	          yLength = 1;
	        } else if (flag & 32) {
	          yLength = 0;
	        }

	        const xyLength = xLength + yLength;
	        coordinatesLength += xyLength;

	        if (flag & 8) {
	          const repeat = glyf[j++];
	          i += repeat;
	          coordinatesLength += repeat * xyLength;
	        }
	      }

	      if (coordinatesLength === 0) {
	        return glyphProfile;
	      }

	      let glyphDataLength = j + coordinatesLength;

	      if (glyphDataLength > glyf.length) {
	        return glyphProfile;
	      }

	      if (!hintsValid && instructionsLength > 0) {
	        dest.set(glyf.subarray(0, instructionsStart), destStart);
	        dest.set([0, 0], destStart + instructionsStart);
	        dest.set(glyf.subarray(instructionsEnd, glyphDataLength), destStart + instructionsStart + 2);
	        glyphDataLength -= instructionsLength;

	        if (glyf.length - glyphDataLength > 3) {
	          glyphDataLength = glyphDataLength + 3 & ~3;
	        }

	        glyphProfile.length = glyphDataLength;
	        return glyphProfile;
	      }

	      if (glyf.length - glyphDataLength > 3) {
	        glyphDataLength = glyphDataLength + 3 & ~3;
	        dest.set(glyf.subarray(0, glyphDataLength), destStart);
	        glyphProfile.length = glyphDataLength;
	        return glyphProfile;
	      }

	      dest.set(glyf, destStart);
	      glyphProfile.length = glyf.length;
	      return glyphProfile;
	    }

	    function sanitizeHead(head, numGlyphs, locaLength) {
	      const data = head.data;
	      const version = int32(data[0], data[1], data[2], data[3]);

	      if (version >> 16 !== 1) {
	        (0, _util.info)("Attempting to fix invalid version in head table: " + version);
	        data[0] = 0;
	        data[1] = 1;
	        data[2] = 0;
	        data[3] = 0;
	      }

	      const indexToLocFormat = int16(data[50], data[51]);

	      if (indexToLocFormat < 0 || indexToLocFormat > 1) {
	        (0, _util.info)("Attempting to fix invalid indexToLocFormat in head table: " + indexToLocFormat);
	        const numGlyphsPlusOne = numGlyphs + 1;

	        if (locaLength === numGlyphsPlusOne << 1) {
	          data[50] = 0;
	          data[51] = 0;
	        } else if (locaLength === numGlyphsPlusOne << 2) {
	          data[50] = 0;
	          data[51] = 1;
	        } else {
	          throw new _util.FormatError("Could not fix indexToLocFormat: " + indexToLocFormat);
	        }
	      }
	    }

	    function sanitizeGlyphLocations(loca, glyf, numGlyphs, isGlyphLocationsLong, hintsValid, dupFirstEntry, maxSizeOfInstructions) {
	      let itemSize, itemDecode, itemEncode;

	      if (isGlyphLocationsLong) {
	        itemSize = 4;

	        itemDecode = function fontItemDecodeLong(data, offset) {
	          return data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3];
	        };

	        itemEncode = function fontItemEncodeLong(data, offset, value) {
	          data[offset] = value >>> 24 & 0xff;
	          data[offset + 1] = value >> 16 & 0xff;
	          data[offset + 2] = value >> 8 & 0xff;
	          data[offset + 3] = value & 0xff;
	        };
	      } else {
	        itemSize = 2;

	        itemDecode = function fontItemDecode(data, offset) {
	          return data[offset] << 9 | data[offset + 1] << 1;
	        };

	        itemEncode = function fontItemEncode(data, offset, value) {
	          data[offset] = value >> 9 & 0xff;
	          data[offset + 1] = value >> 1 & 0xff;
	        };
	      }

	      const numGlyphsOut = dupFirstEntry ? numGlyphs + 1 : numGlyphs;
	      const locaDataSize = itemSize * (1 + numGlyphsOut);
	      const locaData = new Uint8Array(locaDataSize);
	      locaData.set(loca.data.subarray(0, locaDataSize));
	      loca.data = locaData;
	      const oldGlyfData = glyf.data;
	      const oldGlyfDataLength = oldGlyfData.length;
	      const newGlyfData = new Uint8Array(oldGlyfDataLength);
	      let i, j;
	      const locaEntries = [];

	      for (i = 0, j = 0; i < numGlyphs + 1; i++, j += itemSize) {
	        let offset = itemDecode(locaData, j);

	        if (offset > oldGlyfDataLength) {
	          offset = oldGlyfDataLength;
	        }

	        locaEntries.push({
	          index: i,
	          offset,
	          endOffset: 0
	        });
	      }

	      locaEntries.sort((a, b) => {
	        return a.offset - b.offset;
	      });

	      for (i = 0; i < numGlyphs; i++) {
	        locaEntries[i].endOffset = locaEntries[i + 1].offset;
	      }

	      locaEntries.sort((a, b) => {
	        return a.index - b.index;
	      });

	      for (i = 0; i < numGlyphs; i++) {
	        const {
	          offset,
	          endOffset
	        } = locaEntries[i];

	        if (offset !== 0 || endOffset !== 0) {
	          break;
	        }

	        const nextOffset = locaEntries[i + 1].offset;

	        if (nextOffset === 0) {
	          continue;
	        }

	        locaEntries[i].endOffset = nextOffset;
	        break;
	      }

	      const missingGlyphs = Object.create(null);
	      let writeOffset = 0;
	      itemEncode(locaData, 0, writeOffset);

	      for (i = 0, j = itemSize; i < numGlyphs; i++, j += itemSize) {
	        const glyphProfile = sanitizeGlyph(oldGlyfData, locaEntries[i].offset, locaEntries[i].endOffset, newGlyfData, writeOffset, hintsValid);
	        const newLength = glyphProfile.length;

	        if (newLength === 0) {
	          missingGlyphs[i] = true;
	        }

	        if (glyphProfile.sizeOfInstructions > maxSizeOfInstructions) {
	          maxSizeOfInstructions = glyphProfile.sizeOfInstructions;
	        }

	        writeOffset += newLength;
	        itemEncode(locaData, j, writeOffset);
	      }

	      if (writeOffset === 0) {
	        const simpleGlyph = new Uint8Array([0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 0]);

	        for (i = 0, j = itemSize; i < numGlyphsOut; i++, j += itemSize) {
	          itemEncode(locaData, j, simpleGlyph.length);
	        }

	        glyf.data = simpleGlyph;
	      } else if (dupFirstEntry) {
	        const firstEntryLength = itemDecode(locaData, itemSize);

	        if (newGlyfData.length > firstEntryLength + writeOffset) {
	          glyf.data = newGlyfData.subarray(0, firstEntryLength + writeOffset);
	        } else {
	          glyf.data = new Uint8Array(firstEntryLength + writeOffset);
	          glyf.data.set(newGlyfData.subarray(0, writeOffset));
	        }

	        glyf.data.set(newGlyfData.subarray(0, firstEntryLength), writeOffset);
	        itemEncode(loca.data, locaData.length - itemSize, writeOffset + firstEntryLength);
	      } else {
	        glyf.data = newGlyfData.subarray(0, writeOffset);
	      }

	      return {
	        missingGlyphs,
	        maxSizeOfInstructions
	      };
	    }

	    function readPostScriptTable(post, propertiesObj, maxpNumGlyphs) {
	      const start = (font.start || 0) + post.offset;
	      font.pos = start;
	      const length = post.length,
	            end = start + length;
	      const version = font.getInt32();
	      font.skip(28);
	      let glyphNames;
	      let valid = true;
	      let i;

	      switch (version) {
	        case 0x00010000:
	          glyphNames = _fonts_utils.MacStandardGlyphOrdering;
	          break;

	        case 0x00020000:
	          const numGlyphs = font.getUint16();

	          if (numGlyphs !== maxpNumGlyphs) {
	            valid = false;
	            break;
	          }

	          const glyphNameIndexes = [];

	          for (i = 0; i < numGlyphs; ++i) {
	            const index = font.getUint16();

	            if (index >= 32768) {
	              valid = false;
	              break;
	            }

	            glyphNameIndexes.push(index);
	          }

	          if (!valid) {
	            break;
	          }

	          const customNames = [],
	                strBuf = [];

	          while (font.pos < end) {
	            const stringLength = font.getByte();
	            strBuf.length = stringLength;

	            for (i = 0; i < stringLength; ++i) {
	              strBuf[i] = String.fromCharCode(font.getByte());
	            }

	            customNames.push(strBuf.join(""));
	          }

	          glyphNames = [];

	          for (i = 0; i < numGlyphs; ++i) {
	            const j = glyphNameIndexes[i];

	            if (j < 258) {
	              glyphNames.push(_fonts_utils.MacStandardGlyphOrdering[j]);
	              continue;
	            }

	            glyphNames.push(customNames[j - 258]);
	          }

	          break;

	        case 0x00030000:
	          break;

	        default:
	          (0, _util.warn)("Unknown/unsupported post table version " + version);
	          valid = false;

	          if (propertiesObj.defaultEncoding) {
	            glyphNames = propertiesObj.defaultEncoding;
	          }

	          break;
	      }

	      propertiesObj.glyphNames = glyphNames;
	      return valid;
	    }

	    function readNameTable(nameTable) {
	      const start = (font.start || 0) + nameTable.offset;
	      font.pos = start;
	      const names = [[], []];
	      const length = nameTable.length,
	            end = start + length;
	      const format = font.getUint16();
	      const FORMAT_0_HEADER_LENGTH = 6;

	      if (format !== 0 || length < FORMAT_0_HEADER_LENGTH) {
	        return names;
	      }

	      const numRecords = font.getUint16();
	      const stringsStart = font.getUint16();
	      const records = [];
	      const NAME_RECORD_LENGTH = 12;
	      let i, ii;

	      for (i = 0; i < numRecords && font.pos + NAME_RECORD_LENGTH <= end; i++) {
	        const r = {
	          platform: font.getUint16(),
	          encoding: font.getUint16(),
	          language: font.getUint16(),
	          name: font.getUint16(),
	          length: font.getUint16(),
	          offset: font.getUint16()
	        };

	        if (r.platform === 1 && r.encoding === 0 && r.language === 0 || r.platform === 3 && r.encoding === 1 && r.language === 0x409) {
	          records.push(r);
	        }
	      }

	      for (i = 0, ii = records.length; i < ii; i++) {
	        const record = records[i];

	        if (record.length <= 0) {
	          continue;
	        }

	        const pos = start + stringsStart + record.offset;

	        if (pos + record.length > end) {
	          continue;
	        }

	        font.pos = pos;
	        const nameIndex = record.name;

	        if (record.encoding) {
	          let str = "";

	          for (let j = 0, jj = record.length; j < jj; j += 2) {
	            str += String.fromCharCode(font.getUint16());
	          }

	          names[1][nameIndex] = str;
	        } else {
	          names[0][nameIndex] = font.getString(record.length);
	        }
	      }

	      return names;
	    }

	    const TTOpsStackDeltas = [0, 0, 0, 0, 0, 0, 0, 0, -2, -2, -2, -2, 0, 0, -2, -5, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, -1, 0, -1, -1, -1, -1, 1, -1, -999, 0, 1, 0, -1, -2, 0, -1, -2, -1, -1, 0, -1, -1, 0, 0, -999, -999, -1, -1, -1, -1, -2, -999, -2, -2, -999, 0, -2, -2, 0, 0, -2, 0, -2, 0, 0, 0, -2, -1, -1, 1, 1, 0, 0, -1, -1, -1, -1, -1, -1, -1, 0, 0, -1, 0, -1, -1, 0, -999, -1, -1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -2, -999, -999, -999, -999, -999, -1, -1, -2, -2, 0, 0, 0, 0, -1, -1, -999, -2, -2, 0, 0, -1, -2, -2, 0, 0, 0, -1, -1, -1, -2];

	    function sanitizeTTProgram(table, ttContext) {
	      let data = table.data;
	      let i = 0,
	          j,
	          n,
	          b,
	          funcId,
	          pc,
	          lastEndf = 0,
	          lastDeff = 0;
	      const stack = [];
	      const callstack = [];
	      const functionsCalled = [];
	      let tooComplexToFollowFunctions = ttContext.tooComplexToFollowFunctions;
	      let inFDEF = false,
	          ifLevel = 0,
	          inELSE = 0;

	      for (let ii = data.length; i < ii;) {
	        const op = data[i++];

	        if (op === 0x40) {
	          n = data[i++];

	          if (inFDEF || inELSE) {
	            i += n;
	          } else {
	            for (j = 0; j < n; j++) {
	              stack.push(data[i++]);
	            }
	          }
	        } else if (op === 0x41) {
	          n = data[i++];

	          if (inFDEF || inELSE) {
	            i += n * 2;
	          } else {
	            for (j = 0; j < n; j++) {
	              b = data[i++];
	              stack.push(b << 8 | data[i++]);
	            }
	          }
	        } else if ((op & 0xf8) === 0xb0) {
	          n = op - 0xb0 + 1;

	          if (inFDEF || inELSE) {
	            i += n;
	          } else {
	            for (j = 0; j < n; j++) {
	              stack.push(data[i++]);
	            }
	          }
	        } else if ((op & 0xf8) === 0xb8) {
	          n = op - 0xb8 + 1;

	          if (inFDEF || inELSE) {
	            i += n * 2;
	          } else {
	            for (j = 0; j < n; j++) {
	              b = data[i++];
	              stack.push(b << 8 | data[i++]);
	            }
	          }
	        } else if (op === 0x2b && !tooComplexToFollowFunctions) {
	          if (!inFDEF && !inELSE) {
	            funcId = stack.at(-1);

	            if (isNaN(funcId)) {
	              (0, _util.info)("TT: CALL empty stack (or invalid entry).");
	            } else {
	              ttContext.functionsUsed[funcId] = true;

	              if (funcId in ttContext.functionsStackDeltas) {
	                const newStackLength = stack.length + ttContext.functionsStackDeltas[funcId];

	                if (newStackLength < 0) {
	                  (0, _util.warn)("TT: CALL invalid functions stack delta.");
	                  ttContext.hintsValid = false;
	                  return;
	                }

	                stack.length = newStackLength;
	              } else if (funcId in ttContext.functionsDefined && !functionsCalled.includes(funcId)) {
	                callstack.push({
	                  data,
	                  i,
	                  stackTop: stack.length - 1
	                });
	                functionsCalled.push(funcId);
	                pc = ttContext.functionsDefined[funcId];

	                if (!pc) {
	                  (0, _util.warn)("TT: CALL non-existent function");
	                  ttContext.hintsValid = false;
	                  return;
	                }

	                data = pc.data;
	                i = pc.i;
	              }
	            }
	          }
	        } else if (op === 0x2c && !tooComplexToFollowFunctions) {
	          if (inFDEF || inELSE) {
	            (0, _util.warn)("TT: nested FDEFs not allowed");
	            tooComplexToFollowFunctions = true;
	          }

	          inFDEF = true;
	          lastDeff = i;
	          funcId = stack.pop();
	          ttContext.functionsDefined[funcId] = {
	            data,
	            i
	          };
	        } else if (op === 0x2d) {
	          if (inFDEF) {
	            inFDEF = false;
	            lastEndf = i;
	          } else {
	            pc = callstack.pop();

	            if (!pc) {
	              (0, _util.warn)("TT: ENDF bad stack");
	              ttContext.hintsValid = false;
	              return;
	            }

	            funcId = functionsCalled.pop();
	            data = pc.data;
	            i = pc.i;
	            ttContext.functionsStackDeltas[funcId] = stack.length - pc.stackTop;
	          }
	        } else if (op === 0x89) {
	          if (inFDEF || inELSE) {
	            (0, _util.warn)("TT: nested IDEFs not allowed");
	            tooComplexToFollowFunctions = true;
	          }

	          inFDEF = true;
	          lastDeff = i;
	        } else if (op === 0x58) {
	          ++ifLevel;
	        } else if (op === 0x1b) {
	          inELSE = ifLevel;
	        } else if (op === 0x59) {
	          if (inELSE === ifLevel) {
	            inELSE = 0;
	          }

	          --ifLevel;
	        } else if (op === 0x1c) {
	          if (!inFDEF && !inELSE) {
	            const offset = stack.at(-1);

	            if (offset > 0) {
	              i += offset - 1;
	            }
	          }
	        }

	        if (!inFDEF && !inELSE) {
	          let stackDelta = 0;

	          if (op <= 0x8e) {
	            stackDelta = TTOpsStackDeltas[op];
	          } else if (op >= 0xc0 && op <= 0xdf) {
	            stackDelta = -1;
	          } else if (op >= 0xe0) {
	            stackDelta = -2;
	          }

	          if (op >= 0x71 && op <= 0x75) {
	            n = stack.pop();

	            if (!isNaN(n)) {
	              stackDelta = -n * 2;
	            }
	          }

	          while (stackDelta < 0 && stack.length > 0) {
	            stack.pop();
	            stackDelta++;
	          }

	          while (stackDelta > 0) {
	            stack.push(NaN);
	            stackDelta--;
	          }
	        }
	      }

	      ttContext.tooComplexToFollowFunctions = tooComplexToFollowFunctions;
	      const content = [data];

	      if (i > data.length) {
	        content.push(new Uint8Array(i - data.length));
	      }

	      if (lastDeff > lastEndf) {
	        (0, _util.warn)("TT: complementing a missing function tail");
	        content.push(new Uint8Array([0x22, 0x2d]));
	      }

	      foldTTTable(table, content);
	    }

	    function checkInvalidFunctions(ttContext, maxFunctionDefs) {
	      if (ttContext.tooComplexToFollowFunctions) {
	        return;
	      }

	      if (ttContext.functionsDefined.length > maxFunctionDefs) {
	        (0, _util.warn)("TT: more functions defined than expected");
	        ttContext.hintsValid = false;
	        return;
	      }

	      for (let j = 0, jj = ttContext.functionsUsed.length; j < jj; j++) {
	        if (j > maxFunctionDefs) {
	          (0, _util.warn)("TT: invalid function id: " + j);
	          ttContext.hintsValid = false;
	          return;
	        }

	        if (ttContext.functionsUsed[j] && !ttContext.functionsDefined[j]) {
	          (0, _util.warn)("TT: undefined function: " + j);
	          ttContext.hintsValid = false;
	          return;
	        }
	      }
	    }

	    function foldTTTable(table, content) {
	      if (content.length > 1) {
	        let newLength = 0;
	        let j, jj;

	        for (j = 0, jj = content.length; j < jj; j++) {
	          newLength += content[j].length;
	        }

	        newLength = newLength + 3 & ~3;
	        const result = new Uint8Array(newLength);
	        let pos = 0;

	        for (j = 0, jj = content.length; j < jj; j++) {
	          result.set(content[j], pos);
	          pos += content[j].length;
	        }

	        table.data = result;
	        table.length = newLength;
	      }
	    }

	    function sanitizeTTPrograms(fpgm, prep, cvt, maxFunctionDefs) {
	      const ttContext = {
	        functionsDefined: [],
	        functionsUsed: [],
	        functionsStackDeltas: [],
	        tooComplexToFollowFunctions: false,
	        hintsValid: true
	      };

	      if (fpgm) {
	        sanitizeTTProgram(fpgm, ttContext);
	      }

	      if (prep) {
	        sanitizeTTProgram(prep, ttContext);
	      }

	      if (fpgm) {
	        checkInvalidFunctions(ttContext, maxFunctionDefs);
	      }

	      if (cvt && cvt.length & 1) {
	        const cvtData = new Uint8Array(cvt.length + 1);
	        cvtData.set(cvt.data);
	        cvt.data = cvtData;
	      }

	      return ttContext.hintsValid;
	    }

	    font = new _stream.Stream(new Uint8Array(font.getBytes()));
	    let header, tables;

	    if (isTrueTypeCollectionFile(font)) {
	      const ttcData = readTrueTypeCollectionData(font, this.name);
	      header = ttcData.header;
	      tables = ttcData.tables;
	    } else {
	      header = readOpenTypeHeader(font);
	      tables = readTables(font, header.numTables);
	    }

	    let cff, cffFile;
	    const isTrueType = !tables["CFF "];

	    if (!isTrueType) {
	      const isComposite = properties.composite && ((properties.cidToGidMap || []).length > 0 || !(properties.cMap instanceof _cmap.IdentityCMap));

	      if (header.version === "OTTO" && !isComposite || !tables.head || !tables.hhea || !tables.maxp || !tables.post) {
	        cffFile = new _stream.Stream(tables["CFF "].data);
	        cff = new _cff_font.CFFFont(cffFile, properties);
	        adjustWidths(properties);
	        return this.convert(name, cff, properties);
	      }

	      delete tables.glyf;
	      delete tables.loca;
	      delete tables.fpgm;
	      delete tables.prep;
	      delete tables["cvt "];
	      this.isOpenType = true;
	    } else {
	      if (!tables.loca) {
	        throw new _util.FormatError('Required "loca" table is not found');
	      }

	      if (!tables.glyf) {
	        (0, _util.warn)('Required "glyf" table is not found -- trying to recover.');
	        tables.glyf = {
	          tag: "glyf",
	          data: new Uint8Array(0)
	        };
	      }

	      this.isOpenType = false;
	    }

	    if (!tables.maxp) {
	      throw new _util.FormatError('Required "maxp" table is not found');
	    }

	    font.pos = (font.start || 0) + tables.maxp.offset;
	    const version = font.getInt32();
	    const numGlyphs = font.getUint16();

	    if (properties.scaleFactors && properties.scaleFactors.length === numGlyphs && isTrueType) {
	      const {
	        scaleFactors
	      } = properties;
	      const isGlyphLocationsLong = int16(tables.head.data[50], tables.head.data[51]);
	      const glyphs = new _glyf.GlyfTable({
	        glyfTable: tables.glyf.data,
	        isGlyphLocationsLong,
	        locaTable: tables.loca.data,
	        numGlyphs
	      });
	      glyphs.scale(scaleFactors);
	      const {
	        glyf,
	        loca,
	        isLocationLong
	      } = glyphs.write();
	      tables.glyf.data = glyf;
	      tables.loca.data = loca;

	      if (isLocationLong !== !!isGlyphLocationsLong) {
	        tables.head.data[50] = 0;
	        tables.head.data[51] = isLocationLong ? 1 : 0;
	      }

	      const metrics = tables.hmtx.data;

	      for (let i = 0; i < numGlyphs; i++) {
	        const j = 4 * i;
	        const advanceWidth = Math.round(scaleFactors[i] * int16(metrics[j], metrics[j + 1]));
	        metrics[j] = advanceWidth >> 8 & 0xff;
	        metrics[j + 1] = advanceWidth & 0xff;
	        const lsb = Math.round(scaleFactors[i] * signedInt16(metrics[j + 2], metrics[j + 3]));
	        writeSignedInt16(metrics, j + 2, lsb);
	      }
	    }

	    let numGlyphsOut = numGlyphs + 1;
	    let dupFirstEntry = true;

	    if (numGlyphsOut > 0xffff) {
	      dupFirstEntry = false;
	      numGlyphsOut = numGlyphs;
	      (0, _util.warn)("Not enough space in glyfs to duplicate first glyph.");
	    }

	    let maxFunctionDefs = 0;
	    let maxSizeOfInstructions = 0;

	    if (version >= 0x00010000 && tables.maxp.length >= 22) {
	      font.pos += 8;
	      const maxZones = font.getUint16();

	      if (maxZones > 2) {
	        tables.maxp.data[14] = 0;
	        tables.maxp.data[15] = 2;
	      }

	      font.pos += 4;
	      maxFunctionDefs = font.getUint16();
	      font.pos += 4;
	      maxSizeOfInstructions = font.getUint16();
	    }

	    tables.maxp.data[4] = numGlyphsOut >> 8;
	    tables.maxp.data[5] = numGlyphsOut & 255;
	    const hintsValid = sanitizeTTPrograms(tables.fpgm, tables.prep, tables["cvt "], maxFunctionDefs);

	    if (!hintsValid) {
	      delete tables.fpgm;
	      delete tables.prep;
	      delete tables["cvt "];
	    }

	    sanitizeMetrics(font, tables.hhea, tables.hmtx, tables.head, numGlyphsOut, dupFirstEntry);

	    if (!tables.head) {
	      throw new _util.FormatError('Required "head" table is not found');
	    }

	    sanitizeHead(tables.head, numGlyphs, isTrueType ? tables.loca.length : 0);
	    let missingGlyphs = Object.create(null);

	    if (isTrueType) {
	      const isGlyphLocationsLong = int16(tables.head.data[50], tables.head.data[51]);
	      const glyphsInfo = sanitizeGlyphLocations(tables.loca, tables.glyf, numGlyphs, isGlyphLocationsLong, hintsValid, dupFirstEntry, maxSizeOfInstructions);
	      missingGlyphs = glyphsInfo.missingGlyphs;

	      if (version >= 0x00010000 && tables.maxp.length >= 22) {
	        tables.maxp.data[26] = glyphsInfo.maxSizeOfInstructions >> 8;
	        tables.maxp.data[27] = glyphsInfo.maxSizeOfInstructions & 255;
	      }
	    }

	    if (!tables.hhea) {
	      throw new _util.FormatError('Required "hhea" table is not found');
	    }

	    if (tables.hhea.data[10] === 0 && tables.hhea.data[11] === 0) {
	      tables.hhea.data[10] = 0xff;
	      tables.hhea.data[11] = 0xff;
	    }

	    const metricsOverride = {
	      unitsPerEm: int16(tables.head.data[18], tables.head.data[19]),
	      yMax: int16(tables.head.data[42], tables.head.data[43]),
	      yMin: signedInt16(tables.head.data[38], tables.head.data[39]),
	      ascent: signedInt16(tables.hhea.data[4], tables.hhea.data[5]),
	      descent: signedInt16(tables.hhea.data[6], tables.hhea.data[7]),
	      lineGap: signedInt16(tables.hhea.data[8], tables.hhea.data[9])
	    };
	    this.ascent = metricsOverride.ascent / metricsOverride.unitsPerEm;
	    this.descent = metricsOverride.descent / metricsOverride.unitsPerEm;
	    this.lineGap = metricsOverride.lineGap / metricsOverride.unitsPerEm;

	    if (this.cssFontInfo && this.cssFontInfo.lineHeight) {
	      this.lineHeight = this.cssFontInfo.metrics.lineHeight;
	      this.lineGap = this.cssFontInfo.metrics.lineGap;
	    } else {
	      this.lineHeight = this.ascent - this.descent + this.lineGap;
	    }

	    if (tables.post) {
	      readPostScriptTable(tables.post, properties, numGlyphs);
	    }

	    tables.post = {
	      tag: "post",
	      data: createPostTable(properties)
	    };
	    const charCodeToGlyphId = [];

	    function hasGlyph(glyphId) {
	      return !missingGlyphs[glyphId];
	    }

	    if (properties.composite) {
	      const cidToGidMap = properties.cidToGidMap || [];
	      const isCidToGidMapEmpty = cidToGidMap.length === 0;
	      properties.cMap.forEach(function (charCode, cid) {
	        if (typeof cid === "string") {
	          cid = convertCidString(charCode, cid, true);
	        }

	        if (cid > 0xffff) {
	          throw new _util.FormatError("Max size of CID is 65,535");
	        }

	        let glyphId = -1;

	        if (isCidToGidMapEmpty) {
	          glyphId = cid;
	        } else if (cidToGidMap[cid] !== undefined) {
	          glyphId = cidToGidMap[cid];
	        }

	        if (glyphId >= 0 && glyphId < numGlyphs && hasGlyph(glyphId)) {
	          charCodeToGlyphId[charCode] = glyphId;
	        }
	      });
	    } else {
	      const cmapTable = readCmapTable(tables.cmap, font, this.isSymbolicFont, properties.hasEncoding);
	      const cmapPlatformId = cmapTable.platformId;
	      const cmapEncodingId = cmapTable.encodingId;
	      const cmapMappings = cmapTable.mappings;
	      const cmapMappingsLength = cmapMappings.length;
	      let baseEncoding = [],
	          forcePostTable = false;

	      if (properties.hasEncoding && (properties.baseEncodingName === "MacRomanEncoding" || properties.baseEncodingName === "WinAnsiEncoding")) {
	        baseEncoding = (0, _encodings.getEncoding)(properties.baseEncodingName);
	      }

	      if (properties.hasEncoding && !this.isSymbolicFont && (cmapPlatformId === 3 && cmapEncodingId === 1 || cmapPlatformId === 1 && cmapEncodingId === 0)) {
	        const glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();

	        for (let charCode = 0; charCode < 256; charCode++) {
	          let glyphName;

	          if (this.differences[charCode] !== undefined) {
	            glyphName = this.differences[charCode];
	          } else if (baseEncoding.length && baseEncoding[charCode] !== "") {
	            glyphName = baseEncoding[charCode];
	          } else {
	            glyphName = _encodings.StandardEncoding[charCode];
	          }

	          if (!glyphName) {
	            continue;
	          }

	          const standardGlyphName = (0, _fonts_utils.recoverGlyphName)(glyphName, glyphsUnicodeMap);
	          let unicodeOrCharCode;

	          if (cmapPlatformId === 3 && cmapEncodingId === 1) {
	            unicodeOrCharCode = glyphsUnicodeMap[standardGlyphName];
	          } else if (cmapPlatformId === 1 && cmapEncodingId === 0) {
	            unicodeOrCharCode = _encodings.MacRomanEncoding.indexOf(standardGlyphName);
	          }

	          if (unicodeOrCharCode === undefined) {
	            if (!properties.glyphNames && properties.hasIncludedToUnicodeMap && !(this.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap)) {
	              const unicode = this.toUnicode.get(charCode);

	              if (unicode) {
	                unicodeOrCharCode = unicode.codePointAt(0);
	              }
	            }

	            if (unicodeOrCharCode === undefined) {
	              continue;
	            }
	          }

	          for (let i = 0; i < cmapMappingsLength; ++i) {
	            if (cmapMappings[i].charCode !== unicodeOrCharCode) {
	              continue;
	            }

	            charCodeToGlyphId[charCode] = cmapMappings[i].glyphId;
	            break;
	          }
	        }
	      } else if (cmapPlatformId === 0) {
	        for (let i = 0; i < cmapMappingsLength; ++i) {
	          charCodeToGlyphId[cmapMappings[i].charCode] = cmapMappings[i].glyphId;
	        }

	        forcePostTable = true;
	      } else {
	        for (let i = 0; i < cmapMappingsLength; ++i) {
	          let charCode = cmapMappings[i].charCode;

	          if (cmapPlatformId === 3 && charCode >= 0xf000 && charCode <= 0xf0ff) {
	            charCode &= 0xff;
	          }

	          charCodeToGlyphId[charCode] = cmapMappings[i].glyphId;
	        }
	      }

	      if (properties.glyphNames && (baseEncoding.length || this.differences.length)) {
	        for (let i = 0; i < 256; ++i) {
	          if (!forcePostTable && charCodeToGlyphId[i] !== undefined) {
	            continue;
	          }

	          const glyphName = this.differences[i] || baseEncoding[i];

	          if (!glyphName) {
	            continue;
	          }

	          const glyphId = properties.glyphNames.indexOf(glyphName);

	          if (glyphId > 0 && hasGlyph(glyphId)) {
	            charCodeToGlyphId[i] = glyphId;
	          }
	        }
	      }
	    }

	    if (charCodeToGlyphId.length === 0) {
	      charCodeToGlyphId[0] = 0;
	    }

	    let glyphZeroId = numGlyphsOut - 1;

	    if (!dupFirstEntry) {
	      glyphZeroId = 0;
	    }

	    if (!properties.cssFontInfo) {
	      const newMapping = adjustMapping(charCodeToGlyphId, hasGlyph, glyphZeroId, this.toUnicode);
	      this.toFontChar = newMapping.toFontChar;
	      tables.cmap = {
	        tag: "cmap",
	        data: createCmapTable(newMapping.charCodeToGlyphId, newMapping.toUnicodeExtraMap, numGlyphsOut)
	      };

	      if (!tables["OS/2"] || !validateOS2Table(tables["OS/2"], font)) {
	        tables["OS/2"] = {
	          tag: "OS/2",
	          data: createOS2Table(properties, newMapping.charCodeToGlyphId, metricsOverride)
	        };
	      }
	    }

	    if (!isTrueType) {
	      try {
	        cffFile = new _stream.Stream(tables["CFF "].data);
	        const parser = new _cff_parser.CFFParser(cffFile, properties, _fonts_utils.SEAC_ANALYSIS_ENABLED);
	        cff = parser.parse();
	        cff.duplicateFirstGlyph();
	        const compiler = new _cff_parser.CFFCompiler(cff);
	        tables["CFF "].data = compiler.compile();
	      } catch (e) {
	        (0, _util.warn)("Failed to compile font " + properties.loadedName);
	      }
	    }

	    if (!tables.name) {
	      tables.name = {
	        tag: "name",
	        data: createNameTable(this.name)
	      };
	    } else {
	      const namePrototype = readNameTable(tables.name);
	      tables.name.data = createNameTable(name, namePrototype);
	      this.psName = namePrototype[0][6] || null;
	    }

	    const builder = new _opentype_file_builder.OpenTypeFileBuilder(header.version);

	    for (const tableTag in tables) {
	      builder.addTable(tableTag, tables[tableTag].data);
	    }

	    return builder.toArray();
	  }

	  convert(fontName, font, properties) {
	    properties.fixedPitch = false;

	    if (properties.builtInEncoding) {
	      adjustToUnicode(properties, properties.builtInEncoding);
	    }

	    let glyphZeroId = 1;

	    if (font instanceof _cff_font.CFFFont) {
	      glyphZeroId = font.numGlyphs - 1;
	    }

	    const mapping = font.getGlyphMapping(properties);
	    let newMapping = null;
	    let newCharCodeToGlyphId = mapping;
	    let toUnicodeExtraMap = null;

	    if (!properties.cssFontInfo) {
	      newMapping = adjustMapping(mapping, font.hasGlyphId.bind(font), glyphZeroId, this.toUnicode);
	      this.toFontChar = newMapping.toFontChar;
	      newCharCodeToGlyphId = newMapping.charCodeToGlyphId;
	      toUnicodeExtraMap = newMapping.toUnicodeExtraMap;
	    }

	    const numGlyphs = font.numGlyphs;

	    function getCharCodes(charCodeToGlyphId, glyphId) {
	      let charCodes = null;

	      for (const charCode in charCodeToGlyphId) {
	        if (glyphId === charCodeToGlyphId[charCode]) {
	          if (!charCodes) {
	            charCodes = [];
	          }

	          charCodes.push(charCode | 0);
	        }
	      }

	      return charCodes;
	    }

	    function createCharCode(charCodeToGlyphId, glyphId) {
	      for (const charCode in charCodeToGlyphId) {
	        if (glyphId === charCodeToGlyphId[charCode]) {
	          return charCode | 0;
	        }
	      }

	      newMapping.charCodeToGlyphId[newMapping.nextAvailableFontCharCode] = glyphId;
	      return newMapping.nextAvailableFontCharCode++;
	    }

	    const seacs = font.seacs;

	    if (newMapping && _fonts_utils.SEAC_ANALYSIS_ENABLED && seacs && seacs.length) {
	      const matrix = properties.fontMatrix || _util.FONT_IDENTITY_MATRIX;
	      const charset = font.getCharset();
	      const seacMap = Object.create(null);

	      for (let glyphId in seacs) {
	        glyphId |= 0;
	        const seac = seacs[glyphId];
	        const baseGlyphName = _encodings.StandardEncoding[seac[2]];
	        const accentGlyphName = _encodings.StandardEncoding[seac[3]];
	        const baseGlyphId = charset.indexOf(baseGlyphName);
	        const accentGlyphId = charset.indexOf(accentGlyphName);

	        if (baseGlyphId < 0 || accentGlyphId < 0) {
	          continue;
	        }

	        const accentOffset = {
	          x: seac[0] * matrix[0] + seac[1] * matrix[2] + matrix[4],
	          y: seac[0] * matrix[1] + seac[1] * matrix[3] + matrix[5]
	        };
	        const charCodes = getCharCodes(mapping, glyphId);

	        if (!charCodes) {
	          continue;
	        }

	        for (let i = 0, ii = charCodes.length; i < ii; i++) {
	          const charCode = charCodes[i];
	          const charCodeToGlyphId = newMapping.charCodeToGlyphId;
	          const baseFontCharCode = createCharCode(charCodeToGlyphId, baseGlyphId);
	          const accentFontCharCode = createCharCode(charCodeToGlyphId, accentGlyphId);
	          seacMap[charCode] = {
	            baseFontCharCode,
	            accentFontCharCode,
	            accentOffset
	          };
	        }
	      }

	      properties.seacMap = seacMap;
	    }

	    const unitsPerEm = 1 / (properties.fontMatrix || _util.FONT_IDENTITY_MATRIX)[0];
	    const builder = new _opentype_file_builder.OpenTypeFileBuilder("\x4F\x54\x54\x4F");
	    builder.addTable("CFF ", font.data);
	    builder.addTable("OS/2", createOS2Table(properties, newCharCodeToGlyphId));
	    builder.addTable("cmap", createCmapTable(newCharCodeToGlyphId, toUnicodeExtraMap, numGlyphs));
	    builder.addTable("head", "\x00\x01\x00\x00" + "\x00\x00\x10\x00" + "\x00\x00\x00\x00" + "\x5F\x0F\x3C\xF5" + "\x00\x00" + safeString16(unitsPerEm) + "\x00\x00\x00\x00\x9e\x0b\x7e\x27" + "\x00\x00\x00\x00\x9e\x0b\x7e\x27" + "\x00\x00" + safeString16(properties.descent) + "\x0F\xFF" + safeString16(properties.ascent) + string16(properties.italicAngle ? 2 : 0) + "\x00\x11" + "\x00\x00" + "\x00\x00" + "\x00\x00");
	    builder.addTable("hhea", "\x00\x01\x00\x00" + safeString16(properties.ascent) + safeString16(properties.descent) + "\x00\x00" + "\xFF\xFF" + "\x00\x00" + "\x00\x00" + "\x00\x00" + safeString16(properties.capHeight) + safeString16(Math.tan(properties.italicAngle) * properties.xHeight) + "\x00\x00" + "\x00\x00" + "\x00\x00" + "\x00\x00" + "\x00\x00" + "\x00\x00" + string16(numGlyphs));
	    builder.addTable("hmtx", function fontFieldsHmtx() {
	      const charstrings = font.charstrings;
	      const cffWidths = font.cff ? font.cff.widths : null;
	      let hmtx = "\x00\x00\x00\x00";

	      for (let i = 1, ii = numGlyphs; i < ii; i++) {
	        let width = 0;

	        if (charstrings) {
	          const charstring = charstrings[i - 1];
	          width = "width" in charstring ? charstring.width : 0;
	        } else if (cffWidths) {
	          width = Math.ceil(cffWidths[i] || 0);
	        }

	        hmtx += string16(width) + string16(0);
	      }

	      return hmtx;
	    }());
	    builder.addTable("maxp", "\x00\x00\x50\x00" + string16(numGlyphs));
	    builder.addTable("name", createNameTable(fontName));
	    builder.addTable("post", createPostTable(properties));
	    return builder.toArray();
	  }

	  get spaceWidth() {
	    const possibleSpaceReplacements = ["space", "minus", "one", "i", "I"];
	    let width;

	    for (let i = 0, ii = possibleSpaceReplacements.length; i < ii; i++) {
	      const glyphName = possibleSpaceReplacements[i];

	      if (glyphName in this.widths) {
	        width = this.widths[glyphName];
	        break;
	      }

	      const glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();
	      const glyphUnicode = glyphsUnicodeMap[glyphName];
	      let charcode = 0;

	      if (this.composite && this.cMap.contains(glyphUnicode)) {
	        charcode = this.cMap.lookup(glyphUnicode);

	        if (typeof charcode === "string") {
	          charcode = convertCidString(glyphUnicode, charcode);
	        }
	      }

	      if (!charcode && this.toUnicode) {
	        charcode = this.toUnicode.charCodeOf(glyphUnicode);
	      }

	      if (charcode <= 0) {
	        charcode = glyphUnicode;
	      }

	      width = this.widths[charcode];

	      if (width) {
	        break;
	      }
	    }

	    width = width || this.defaultWidth;
	    return (0, _util.shadow)(this, "spaceWidth", width);
	  }

	  _charToGlyph(charcode, isSpace = false) {
	    let fontCharCode, width, operatorListId;
	    let widthCode = charcode;

	    if (this.cMap && this.cMap.contains(charcode)) {
	      widthCode = this.cMap.lookup(charcode);

	      if (typeof widthCode === "string") {
	        widthCode = convertCidString(charcode, widthCode);
	      }
	    }

	    width = this.widths[widthCode];

	    if (typeof width !== "number") {
	      width = this.defaultWidth;
	    }

	    const vmetric = this.vmetrics && this.vmetrics[widthCode];
	    let unicode = this.toUnicode.get(charcode) || charcode;

	    if (typeof unicode === "number") {
	      unicode = String.fromCharCode(unicode);
	    }

	    let isInFont = this.toFontChar[charcode] !== undefined;
	    fontCharCode = this.toFontChar[charcode] || charcode;

	    if (this.missingFile) {
	      const glyphName = this.differences[charcode] || this.defaultEncoding[charcode];

	      if ((glyphName === ".notdef" || glyphName === "") && this.type === "Type1") {
	        fontCharCode = 0x20;
	      }

	      fontCharCode = (0, _unicode.mapSpecialUnicodeValues)(fontCharCode);
	    }

	    if (this.isType3Font) {
	      operatorListId = fontCharCode;
	    }

	    let accent = null;

	    if (this.seacMap && this.seacMap[charcode]) {
	      isInFont = true;
	      const seac = this.seacMap[charcode];
	      fontCharCode = seac.baseFontCharCode;
	      accent = {
	        fontChar: String.fromCodePoint(seac.accentFontCharCode),
	        offset: seac.accentOffset
	      };
	    }

	    let fontChar = "";

	    if (typeof fontCharCode === "number") {
	      if (fontCharCode <= 0x10ffff) {
	        fontChar = String.fromCodePoint(fontCharCode);
	      } else {
	        (0, _util.warn)(`charToGlyph - invalid fontCharCode: ${fontCharCode}`);
	      }
	    }

	    let glyph = this._glyphCache[charcode];

	    if (!glyph || !glyph.matchesForCache(charcode, fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont)) {
	      glyph = new Glyph(charcode, fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont);
	      this._glyphCache[charcode] = glyph;
	    }

	    return glyph;
	  }

	  charsToGlyphs(chars) {
	    let glyphs = this._charsCache[chars];

	    if (glyphs) {
	      return glyphs;
	    }

	    glyphs = [];

	    if (this.cMap) {
	      const c = Object.create(null),
	            ii = chars.length;
	      let i = 0;

	      while (i < ii) {
	        this.cMap.readCharCode(chars, i, c);
	        const {
	          charcode,
	          length
	        } = c;
	        i += length;

	        const glyph = this._charToGlyph(charcode, length === 1 && chars.charCodeAt(i - 1) === 0x20);

	        glyphs.push(glyph);
	      }
	    } else {
	      for (let i = 0, ii = chars.length; i < ii; ++i) {
	        const charcode = chars.charCodeAt(i);

	        const glyph = this._charToGlyph(charcode, charcode === 0x20);

	        glyphs.push(glyph);
	      }
	    }

	    return this._charsCache[chars] = glyphs;
	  }

	  getCharPositions(chars) {
	    const positions = [];

	    if (this.cMap) {
	      const c = Object.create(null);
	      let i = 0;

	      while (i < chars.length) {
	        this.cMap.readCharCode(chars, i, c);
	        const length = c.length;
	        positions.push([i, i + length]);
	        i += length;
	      }
	    } else {
	      for (let i = 0, ii = chars.length; i < ii; ++i) {
	        positions.push([i, i + 1]);
	      }
	    }

	    return positions;
	  }

	  get glyphCacheValues() {
	    return Object.values(this._glyphCache);
	  }

	  encodeString(str) {
	    const buffers = [];
	    const currentBuf = [];

	    const hasCurrentBufErrors = () => buffers.length % 2 === 1;

	    const getCharCode = this.toUnicode instanceof _to_unicode_map.IdentityToUnicodeMap ? unicode => this.toUnicode.charCodeOf(unicode) : unicode => this.toUnicode.charCodeOf(String.fromCodePoint(unicode));

	    for (let i = 0, ii = str.length; i < ii; i++) {
	      const unicode = str.codePointAt(i);

	      if (unicode > 0xd7ff && (unicode < 0xe000 || unicode > 0xfffd)) {
	        i++;
	      }

	      if (this.toUnicode) {
	        const charCode = getCharCode(unicode);

	        if (charCode !== -1) {
	          if (hasCurrentBufErrors()) {
	            buffers.push(currentBuf.join(""));
	            currentBuf.length = 0;
	          }

	          const charCodeLength = this.cMap ? this.cMap.getCharCodeLength(charCode) : 1;

	          for (let j = charCodeLength - 1; j >= 0; j--) {
	            currentBuf.push(String.fromCharCode(charCode >> 8 * j & 0xff));
	          }

	          continue;
	        }
	      }

	      if (!hasCurrentBufErrors()) {
	        buffers.push(currentBuf.join(""));
	        currentBuf.length = 0;
	      }

	      currentBuf.push(String.fromCodePoint(unicode));
	    }

	    buffers.push(currentBuf.join(""));
	    return buffers;
	  }

	}

	exports.Font = Font;

	class ErrorFont {
	  constructor(error) {
	    this.error = error;
	    this.loadedName = "g_font_error";
	    this.missingFile = true;
	  }

	  charsToGlyphs() {
	    return [];
	  }

	  encodeString(chars) {
	    return [chars];
	  }

	  exportData(extraProperties = false) {
	    return {
	      error: this.error
	    };
	  }

	}

	exports.ErrorFont = ErrorFont;

	/***/ }),
	/* 35 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.CFFTopDict = exports.CFFStrings = exports.CFFStandardStrings = exports.CFFPrivateDict = exports.CFFParser = exports.CFFIndex = exports.CFFHeader = exports.CFFFDSelect = exports.CFFCompiler = exports.CFFCharset = exports.CFF = void 0;

	var _util = __w_pdfjs_require__(2);

	var _charsets = __w_pdfjs_require__(36);

	var _encodings = __w_pdfjs_require__(37);

	const MAX_SUBR_NESTING = 10;
	const CFFStandardStrings = [".notdef", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quoteright", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "quoteleft", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "exclamdown", "cent", "sterling", "fraction", "yen", "florin", "section", "currency", "quotesingle", "quotedblleft", "guillemotleft", "guilsinglleft", "guilsinglright", "fi", "fl", "endash", "dagger", "daggerdbl", "periodcentered", "paragraph", "bullet", "quotesinglbase", "quotedblbase", "quotedblright", "guillemotright", "ellipsis", "perthousand", "questiondown", "grave", "acute", "circumflex", "tilde", "macron", "breve", "dotaccent", "dieresis", "ring", "cedilla", "hungarumlaut", "ogonek", "caron", "emdash", "AE", "ordfeminine", "Lslash", "Oslash", "OE", "ordmasculine", "ae", "dotlessi", "lslash", "oslash", "oe", "germandbls", "onesuperior", "logicalnot", "mu", "trademark", "Eth", "onehalf", "plusminus", "Thorn", "onequarter", "divide", "brokenbar", "degree", "thorn", "threequarters", "twosuperior", "registered", "minus", "eth", "multiply", "threesuperior", "copyright", "Aacute", "Acircumflex", "Adieresis", "Agrave", "Aring", "Atilde", "Ccedilla", "Eacute", "Ecircumflex", "Edieresis", "Egrave", "Iacute", "Icircumflex", "Idieresis", "Igrave", "Ntilde", "Oacute", "Ocircumflex", "Odieresis", "Ograve", "Otilde", "Scaron", "Uacute", "Ucircumflex", "Udieresis", "Ugrave", "Yacute", "Ydieresis", "Zcaron", "aacute", "acircumflex", "adieresis", "agrave", "aring", "atilde", "ccedilla", "eacute", "ecircumflex", "edieresis", "egrave", "iacute", "icircumflex", "idieresis", "igrave", "ntilde", "oacute", "ocircumflex", "odieresis", "ograve", "otilde", "scaron", "uacute", "ucircumflex", "udieresis", "ugrave", "yacute", "ydieresis", "zcaron", "exclamsmall", "Hungarumlautsmall", "dollaroldstyle", "dollarsuperior", "ampersandsmall", "Acutesmall", "parenleftsuperior", "parenrightsuperior", "twodotenleader", "onedotenleader", "zerooldstyle", "oneoldstyle", "twooldstyle", "threeoldstyle", "fouroldstyle", "fiveoldstyle", "sixoldstyle", "sevenoldstyle", "eightoldstyle", "nineoldstyle", "commasuperior", "threequartersemdash", "periodsuperior", "questionsmall", "asuperior", "bsuperior", "centsuperior", "dsuperior", "esuperior", "isuperior", "lsuperior", "msuperior", "nsuperior", "osuperior", "rsuperior", "ssuperior", "tsuperior", "ff", "ffi", "ffl", "parenleftinferior", "parenrightinferior", "Circumflexsmall", "hyphensuperior", "Gravesmall", "Asmall", "Bsmall", "Csmall", "Dsmall", "Esmall", "Fsmall", "Gsmall", "Hsmall", "Ismall", "Jsmall", "Ksmall", "Lsmall", "Msmall", "Nsmall", "Osmall", "Psmall", "Qsmall", "Rsmall", "Ssmall", "Tsmall", "Usmall", "Vsmall", "Wsmall", "Xsmall", "Ysmall", "Zsmall", "colonmonetary", "onefitted", "rupiah", "Tildesmall", "exclamdownsmall", "centoldstyle", "Lslashsmall", "Scaronsmall", "Zcaronsmall", "Dieresissmall", "Brevesmall", "Caronsmall", "Dotaccentsmall", "Macronsmall", "figuredash", "hypheninferior", "Ogoneksmall", "Ringsmall", "Cedillasmall", "questiondownsmall", "oneeighth", "threeeighths", "fiveeighths", "seveneighths", "onethird", "twothirds", "zerosuperior", "foursuperior", "fivesuperior", "sixsuperior", "sevensuperior", "eightsuperior", "ninesuperior", "zeroinferior", "oneinferior", "twoinferior", "threeinferior", "fourinferior", "fiveinferior", "sixinferior", "seveninferior", "eightinferior", "nineinferior", "centinferior", "dollarinferior", "periodinferior", "commainferior", "Agravesmall", "Aacutesmall", "Acircumflexsmall", "Atildesmall", "Adieresissmall", "Aringsmall", "AEsmall", "Ccedillasmall", "Egravesmall", "Eacutesmall", "Ecircumflexsmall", "Edieresissmall", "Igravesmall", "Iacutesmall", "Icircumflexsmall", "Idieresissmall", "Ethsmall", "Ntildesmall", "Ogravesmall", "Oacutesmall", "Ocircumflexsmall", "Otildesmall", "Odieresissmall", "OEsmall", "Oslashsmall", "Ugravesmall", "Uacutesmall", "Ucircumflexsmall", "Udieresissmall", "Yacutesmall", "Thornsmall", "Ydieresissmall", "001.000", "001.001", "001.002", "001.003", "Black", "Bold", "Book", "Light", "Medium", "Regular", "Roman", "Semibold"];
	exports.CFFStandardStrings = CFFStandardStrings;
	const NUM_STANDARD_CFF_STRINGS = 391;
	const CharstringValidationData = [null, {
	  id: "hstem",
	  min: 2,
	  stackClearing: true,
	  stem: true
	}, null, {
	  id: "vstem",
	  min: 2,
	  stackClearing: true,
	  stem: true
	}, {
	  id: "vmoveto",
	  min: 1,
	  stackClearing: true
	}, {
	  id: "rlineto",
	  min: 2,
	  resetStack: true
	}, {
	  id: "hlineto",
	  min: 1,
	  resetStack: true
	}, {
	  id: "vlineto",
	  min: 1,
	  resetStack: true
	}, {
	  id: "rrcurveto",
	  min: 6,
	  resetStack: true
	}, null, {
	  id: "callsubr",
	  min: 1,
	  undefStack: true
	}, {
	  id: "return",
	  min: 0,
	  undefStack: true
	}, null, null, {
	  id: "endchar",
	  min: 0,
	  stackClearing: true
	}, null, null, null, {
	  id: "hstemhm",
	  min: 2,
	  stackClearing: true,
	  stem: true
	}, {
	  id: "hintmask",
	  min: 0,
	  stackClearing: true
	}, {
	  id: "cntrmask",
	  min: 0,
	  stackClearing: true
	}, {
	  id: "rmoveto",
	  min: 2,
	  stackClearing: true
	}, {
	  id: "hmoveto",
	  min: 1,
	  stackClearing: true
	}, {
	  id: "vstemhm",
	  min: 2,
	  stackClearing: true,
	  stem: true
	}, {
	  id: "rcurveline",
	  min: 8,
	  resetStack: true
	}, {
	  id: "rlinecurve",
	  min: 8,
	  resetStack: true
	}, {
	  id: "vvcurveto",
	  min: 4,
	  resetStack: true
	}, {
	  id: "hhcurveto",
	  min: 4,
	  resetStack: true
	}, null, {
	  id: "callgsubr",
	  min: 1,
	  undefStack: true
	}, {
	  id: "vhcurveto",
	  min: 4,
	  resetStack: true
	}, {
	  id: "hvcurveto",
	  min: 4,
	  resetStack: true
	}];
	const CharstringValidationData12 = [null, null, null, {
	  id: "and",
	  min: 2,
	  stackDelta: -1
	}, {
	  id: "or",
	  min: 2,
	  stackDelta: -1
	}, {
	  id: "not",
	  min: 1,
	  stackDelta: 0
	}, null, null, null, {
	  id: "abs",
	  min: 1,
	  stackDelta: 0
	}, {
	  id: "add",
	  min: 2,
	  stackDelta: -1,

	  stackFn(stack, index) {
	    stack[index - 2] = stack[index - 2] + stack[index - 1];
	  }

	}, {
	  id: "sub",
	  min: 2,
	  stackDelta: -1,

	  stackFn(stack, index) {
	    stack[index - 2] = stack[index - 2] - stack[index - 1];
	  }

	}, {
	  id: "div",
	  min: 2,
	  stackDelta: -1,

	  stackFn(stack, index) {
	    stack[index - 2] = stack[index - 2] / stack[index - 1];
	  }

	}, null, {
	  id: "neg",
	  min: 1,
	  stackDelta: 0,

	  stackFn(stack, index) {
	    stack[index - 1] = -stack[index - 1];
	  }

	}, {
	  id: "eq",
	  min: 2,
	  stackDelta: -1
	}, null, null, {
	  id: "drop",
	  min: 1,
	  stackDelta: -1
	}, null, {
	  id: "put",
	  min: 2,
	  stackDelta: -2
	}, {
	  id: "get",
	  min: 1,
	  stackDelta: 0
	}, {
	  id: "ifelse",
	  min: 4,
	  stackDelta: -3
	}, {
	  id: "random",
	  min: 0,
	  stackDelta: 1
	}, {
	  id: "mul",
	  min: 2,
	  stackDelta: -1,

	  stackFn(stack, index) {
	    stack[index - 2] = stack[index - 2] * stack[index - 1];
	  }

	}, null, {
	  id: "sqrt",
	  min: 1,
	  stackDelta: 0
	}, {
	  id: "dup",
	  min: 1,
	  stackDelta: 1
	}, {
	  id: "exch",
	  min: 2,
	  stackDelta: 0
	}, {
	  id: "index",
	  min: 2,
	  stackDelta: 0
	}, {
	  id: "roll",
	  min: 3,
	  stackDelta: -2
	}, null, null, null, {
	  id: "hflex",
	  min: 7,
	  resetStack: true
	}, {
	  id: "flex",
	  min: 13,
	  resetStack: true
	}, {
	  id: "hflex1",
	  min: 9,
	  resetStack: true
	}, {
	  id: "flex1",
	  min: 11,
	  resetStack: true
	}];

	class CFFParser {
	  constructor(file, properties, seacAnalysisEnabled) {
	    this.bytes = file.getBytes();
	    this.properties = properties;
	    this.seacAnalysisEnabled = !!seacAnalysisEnabled;
	  }

	  parse() {
	    const properties = this.properties;
	    const cff = new CFF();
	    this.cff = cff;
	    const header = this.parseHeader();
	    const nameIndex = this.parseIndex(header.endPos);
	    const topDictIndex = this.parseIndex(nameIndex.endPos);
	    const stringIndex = this.parseIndex(topDictIndex.endPos);
	    const globalSubrIndex = this.parseIndex(stringIndex.endPos);
	    const topDictParsed = this.parseDict(topDictIndex.obj.get(0));
	    const topDict = this.createDict(CFFTopDict, topDictParsed, cff.strings);
	    cff.header = header.obj;
	    cff.names = this.parseNameIndex(nameIndex.obj);
	    cff.strings = this.parseStringIndex(stringIndex.obj);
	    cff.topDict = topDict;
	    cff.globalSubrIndex = globalSubrIndex.obj;
	    this.parsePrivateDict(cff.topDict);
	    cff.isCIDFont = topDict.hasName("ROS");
	    const charStringOffset = topDict.getByName("CharStrings");
	    const charStringIndex = this.parseIndex(charStringOffset).obj;
	    const fontMatrix = topDict.getByName("FontMatrix");

	    if (fontMatrix) {
	      properties.fontMatrix = fontMatrix;
	    }

	    const fontBBox = topDict.getByName("FontBBox");

	    if (fontBBox) {
	      properties.ascent = Math.max(fontBBox[3], fontBBox[1]);
	      properties.descent = Math.min(fontBBox[1], fontBBox[3]);
	      properties.ascentScaled = true;
	    }

	    let charset, encoding;

	    if (cff.isCIDFont) {
	      const fdArrayIndex = this.parseIndex(topDict.getByName("FDArray")).obj;

	      for (let i = 0, ii = fdArrayIndex.count; i < ii; ++i) {
	        const dictRaw = fdArrayIndex.get(i);
	        const fontDict = this.createDict(CFFTopDict, this.parseDict(dictRaw), cff.strings);
	        this.parsePrivateDict(fontDict);
	        cff.fdArray.push(fontDict);
	      }

	      encoding = null;
	      charset = this.parseCharsets(topDict.getByName("charset"), charStringIndex.count, cff.strings, true);
	      cff.fdSelect = this.parseFDSelect(topDict.getByName("FDSelect"), charStringIndex.count);
	    } else {
	      charset = this.parseCharsets(topDict.getByName("charset"), charStringIndex.count, cff.strings, false);
	      encoding = this.parseEncoding(topDict.getByName("Encoding"), properties, cff.strings, charset.charset);
	    }

	    cff.charset = charset;
	    cff.encoding = encoding;
	    const charStringsAndSeacs = this.parseCharStrings({
	      charStrings: charStringIndex,
	      localSubrIndex: topDict.privateDict.subrsIndex,
	      globalSubrIndex: globalSubrIndex.obj,
	      fdSelect: cff.fdSelect,
	      fdArray: cff.fdArray,
	      privateDict: topDict.privateDict
	    });
	    cff.charStrings = charStringsAndSeacs.charStrings;
	    cff.seacs = charStringsAndSeacs.seacs;
	    cff.widths = charStringsAndSeacs.widths;
	    return cff;
	  }

	  parseHeader() {
	    let bytes = this.bytes;
	    const bytesLength = bytes.length;
	    let offset = 0;

	    while (offset < bytesLength && bytes[offset] !== 1) {
	      ++offset;
	    }

	    if (offset >= bytesLength) {
	      throw new _util.FormatError("Invalid CFF header");
	    }

	    if (offset !== 0) {
	      (0, _util.info)("cff data is shifted");
	      bytes = bytes.subarray(offset);
	      this.bytes = bytes;
	    }

	    const major = bytes[0];
	    const minor = bytes[1];
	    const hdrSize = bytes[2];
	    const offSize = bytes[3];
	    const header = new CFFHeader(major, minor, hdrSize, offSize);
	    return {
	      obj: header,
	      endPos: hdrSize
	    };
	  }

	  parseDict(dict) {
	    let pos = 0;

	    function parseOperand() {
	      let value = dict[pos++];

	      if (value === 30) {
	        return parseFloatOperand();
	      } else if (value === 28) {
	        value = dict[pos++];
	        value = (value << 24 | dict[pos++] << 16) >> 16;
	        return value;
	      } else if (value === 29) {
	        value = dict[pos++];
	        value = value << 8 | dict[pos++];
	        value = value << 8 | dict[pos++];
	        value = value << 8 | dict[pos++];
	        return value;
	      } else if (value >= 32 && value <= 246) {
	        return value - 139;
	      } else if (value >= 247 && value <= 250) {
	        return (value - 247) * 256 + dict[pos++] + 108;
	      } else if (value >= 251 && value <= 254) {
	        return -((value - 251) * 256) - dict[pos++] - 108;
	      }

	      (0, _util.warn)('CFFParser_parseDict: "' + value + '" is a reserved command.');
	      return NaN;
	    }

	    function parseFloatOperand() {
	      let str = "";
	      const eof = 15;
	      const lookup = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".", "E", "E-", null, "-"];
	      const length = dict.length;

	      while (pos < length) {
	        const b = dict[pos++];
	        const b1 = b >> 4;
	        const b2 = b & 15;

	        if (b1 === eof) {
	          break;
	        }

	        str += lookup[b1];

	        if (b2 === eof) {
	          break;
	        }

	        str += lookup[b2];
	      }

	      return parseFloat(str);
	    }

	    let operands = [];
	    const entries = [];
	    pos = 0;
	    const end = dict.length;

	    while (pos < end) {
	      let b = dict[pos];

	      if (b <= 21) {
	        if (b === 12) {
	          b = b << 8 | dict[++pos];
	        }

	        entries.push([b, operands]);
	        operands = [];
	        ++pos;
	      } else {
	        operands.push(parseOperand());
	      }
	    }

	    return entries;
	  }

	  parseIndex(pos) {
	    const cffIndex = new CFFIndex();
	    const bytes = this.bytes;
	    const count = bytes[pos++] << 8 | bytes[pos++];
	    const offsets = [];
	    let end = pos;
	    let i, ii;

	    if (count !== 0) {
	      const offsetSize = bytes[pos++];
	      const startPos = pos + (count + 1) * offsetSize - 1;

	      for (i = 0, ii = count + 1; i < ii; ++i) {
	        let offset = 0;

	        for (let j = 0; j < offsetSize; ++j) {
	          offset <<= 8;
	          offset += bytes[pos++];
	        }

	        offsets.push(startPos + offset);
	      }

	      end = offsets[count];
	    }

	    for (i = 0, ii = offsets.length - 1; i < ii; ++i) {
	      const offsetStart = offsets[i];
	      const offsetEnd = offsets[i + 1];
	      cffIndex.add(bytes.subarray(offsetStart, offsetEnd));
	    }

	    return {
	      obj: cffIndex,
	      endPos: end
	    };
	  }

	  parseNameIndex(index) {
	    const names = [];

	    for (let i = 0, ii = index.count; i < ii; ++i) {
	      const name = index.get(i);
	      names.push((0, _util.bytesToString)(name));
	    }

	    return names;
	  }

	  parseStringIndex(index) {
	    const strings = new CFFStrings();

	    for (let i = 0, ii = index.count; i < ii; ++i) {
	      const data = index.get(i);
	      strings.add((0, _util.bytesToString)(data));
	    }

	    return strings;
	  }

	  createDict(Type, dict, strings) {
	    const cffDict = new Type(strings);

	    for (let i = 0, ii = dict.length; i < ii; ++i) {
	      const pair = dict[i];
	      const key = pair[0];
	      const value = pair[1];
	      cffDict.setByKey(key, value);
	    }

	    return cffDict;
	  }

	  parseCharString(state, data, localSubrIndex, globalSubrIndex) {
	    if (!data || state.callDepth > MAX_SUBR_NESTING) {
	      return false;
	    }

	    let stackSize = state.stackSize;
	    const stack = state.stack;
	    const length = data.length;

	    for (let j = 0; j < length;) {
	      const value = data[j++];
	      let validationCommand = null;

	      if (value === 12) {
	        const q = data[j++];

	        if (q === 0) {
	          data[j - 2] = 139;
	          data[j - 1] = 22;
	          stackSize = 0;
	        } else {
	          validationCommand = CharstringValidationData12[q];
	        }
	      } else if (value === 28) {
	        stack[stackSize] = (data[j] << 24 | data[j + 1] << 16) >> 16;
	        j += 2;
	        stackSize++;
	      } else if (value === 14) {
	        if (stackSize >= 4) {
	          stackSize -= 4;

	          if (this.seacAnalysisEnabled) {
	            state.seac = stack.slice(stackSize, stackSize + 4);
	            return false;
	          }
	        }

	        validationCommand = CharstringValidationData[value];
	      } else if (value >= 32 && value <= 246) {
	        stack[stackSize] = value - 139;
	        stackSize++;
	      } else if (value >= 247 && value <= 254) {
	        stack[stackSize] = value < 251 ? (value - 247 << 8) + data[j] + 108 : -(value - 251 << 8) - data[j] - 108;
	        j++;
	        stackSize++;
	      } else if (value === 255) {
	        stack[stackSize] = (data[j] << 24 | data[j + 1] << 16 | data[j + 2] << 8 | data[j + 3]) / 65536;
	        j += 4;
	        stackSize++;
	      } else if (value === 19 || value === 20) {
	        state.hints += stackSize >> 1;
	        j += state.hints + 7 >> 3;
	        stackSize %= 2;
	        validationCommand = CharstringValidationData[value];
	      } else if (value === 10 || value === 29) {
	        let subrsIndex;

	        if (value === 10) {
	          subrsIndex = localSubrIndex;
	        } else {
	          subrsIndex = globalSubrIndex;
	        }

	        if (!subrsIndex) {
	          validationCommand = CharstringValidationData[value];
	          (0, _util.warn)("Missing subrsIndex for " + validationCommand.id);
	          return false;
	        }

	        let bias = 32768;

	        if (subrsIndex.count < 1240) {
	          bias = 107;
	        } else if (subrsIndex.count < 33900) {
	          bias = 1131;
	        }

	        const subrNumber = stack[--stackSize] + bias;

	        if (subrNumber < 0 || subrNumber >= subrsIndex.count || isNaN(subrNumber)) {
	          validationCommand = CharstringValidationData[value];
	          (0, _util.warn)("Out of bounds subrIndex for " + validationCommand.id);
	          return false;
	        }

	        state.stackSize = stackSize;
	        state.callDepth++;
	        const valid = this.parseCharString(state, subrsIndex.get(subrNumber), localSubrIndex, globalSubrIndex);

	        if (!valid) {
	          return false;
	        }

	        state.callDepth--;
	        stackSize = state.stackSize;
	        continue;
	      } else if (value === 11) {
	        state.stackSize = stackSize;
	        return true;
	      } else if (value === 0 && j === data.length) {
	        data[j - 1] = 14;
	        validationCommand = CharstringValidationData[14];
	      } else {
	        validationCommand = CharstringValidationData[value];
	      }

	      if (validationCommand) {
	        if (validationCommand.stem) {
	          state.hints += stackSize >> 1;

	          if (value === 3 || value === 23) {
	            state.hasVStems = true;
	          } else if (state.hasVStems && (value === 1 || value === 18)) {
	            (0, _util.warn)("CFF stem hints are in wrong order");
	            data[j - 1] = value === 1 ? 3 : 23;
	          }
	        }

	        if ("min" in validationCommand) {
	          if (!state.undefStack && stackSize < validationCommand.min) {
	            (0, _util.warn)("Not enough parameters for " + validationCommand.id + "; actual: " + stackSize + ", expected: " + validationCommand.min);

	            if (stackSize === 0) {
	              data[j - 1] = 14;
	              return true;
	            }

	            return false;
	          }
	        }

	        if (state.firstStackClearing && validationCommand.stackClearing) {
	          state.firstStackClearing = false;
	          stackSize -= validationCommand.min;

	          if (stackSize >= 2 && validationCommand.stem) {
	            stackSize %= 2;
	          } else if (stackSize > 1) {
	            (0, _util.warn)("Found too many parameters for stack-clearing command");
	          }

	          if (stackSize > 0) {
	            state.width = stack[stackSize - 1];
	          }
	        }

	        if ("stackDelta" in validationCommand) {
	          if ("stackFn" in validationCommand) {
	            validationCommand.stackFn(stack, stackSize);
	          }

	          stackSize += validationCommand.stackDelta;
	        } else if (validationCommand.stackClearing) {
	          stackSize = 0;
	        } else if (validationCommand.resetStack) {
	          stackSize = 0;
	          state.undefStack = false;
	        } else if (validationCommand.undefStack) {
	          stackSize = 0;
	          state.undefStack = true;
	          state.firstStackClearing = false;
	        }
	      }
	    }

	    state.stackSize = stackSize;
	    return true;
	  }

	  parseCharStrings({
	    charStrings,
	    localSubrIndex,
	    globalSubrIndex,
	    fdSelect,
	    fdArray,
	    privateDict
	  }) {
	    const seacs = [];
	    const widths = [];
	    const count = charStrings.count;

	    for (let i = 0; i < count; i++) {
	      const charstring = charStrings.get(i);
	      const state = {
	        callDepth: 0,
	        stackSize: 0,
	        stack: [],
	        undefStack: true,
	        hints: 0,
	        firstStackClearing: true,
	        seac: null,
	        width: null,
	        hasVStems: false
	      };
	      let valid = true;
	      let localSubrToUse = null;
	      let privateDictToUse = privateDict;

	      if (fdSelect && fdArray.length) {
	        const fdIndex = fdSelect.getFDIndex(i);

	        if (fdIndex === -1) {
	          (0, _util.warn)("Glyph index is not in fd select.");
	          valid = false;
	        }

	        if (fdIndex >= fdArray.length) {
	          (0, _util.warn)("Invalid fd index for glyph index.");
	          valid = false;
	        }

	        if (valid) {
	          privateDictToUse = fdArray[fdIndex].privateDict;
	          localSubrToUse = privateDictToUse.subrsIndex;
	        }
	      } else if (localSubrIndex) {
	        localSubrToUse = localSubrIndex;
	      }

	      if (valid) {
	        valid = this.parseCharString(state, charstring, localSubrToUse, globalSubrIndex);
	      }

	      if (state.width !== null) {
	        const nominalWidth = privateDictToUse.getByName("nominalWidthX");
	        widths[i] = nominalWidth + state.width;
	      } else {
	        const defaultWidth = privateDictToUse.getByName("defaultWidthX");
	        widths[i] = defaultWidth;
	      }

	      if (state.seac !== null) {
	        seacs[i] = state.seac;
	      }

	      if (!valid) {
	        charStrings.set(i, new Uint8Array([14]));
	      }
	    }

	    return {
	      charStrings,
	      seacs,
	      widths
	    };
	  }

	  emptyPrivateDictionary(parentDict) {
	    const privateDict = this.createDict(CFFPrivateDict, [], parentDict.strings);
	    parentDict.setByKey(18, [0, 0]);
	    parentDict.privateDict = privateDict;
	  }

	  parsePrivateDict(parentDict) {
	    if (!parentDict.hasName("Private")) {
	      this.emptyPrivateDictionary(parentDict);
	      return;
	    }

	    const privateOffset = parentDict.getByName("Private");

	    if (!Array.isArray(privateOffset) || privateOffset.length !== 2) {
	      parentDict.removeByName("Private");
	      return;
	    }

	    const size = privateOffset[0];
	    const offset = privateOffset[1];

	    if (size === 0 || offset >= this.bytes.length) {
	      this.emptyPrivateDictionary(parentDict);
	      return;
	    }

	    const privateDictEnd = offset + size;
	    const dictData = this.bytes.subarray(offset, privateDictEnd);
	    const dict = this.parseDict(dictData);
	    const privateDict = this.createDict(CFFPrivateDict, dict, parentDict.strings);
	    parentDict.privateDict = privateDict;

	    if (!privateDict.getByName("Subrs")) {
	      return;
	    }

	    const subrsOffset = privateDict.getByName("Subrs");
	    const relativeOffset = offset + subrsOffset;

	    if (subrsOffset === 0 || relativeOffset >= this.bytes.length) {
	      this.emptyPrivateDictionary(parentDict);
	      return;
	    }

	    const subrsIndex = this.parseIndex(relativeOffset);
	    privateDict.subrsIndex = subrsIndex.obj;
	  }

	  parseCharsets(pos, length, strings, cid) {
	    if (pos === 0) {
	      return new CFFCharset(true, CFFCharsetPredefinedTypes.ISO_ADOBE, _charsets.ISOAdobeCharset);
	    } else if (pos === 1) {
	      return new CFFCharset(true, CFFCharsetPredefinedTypes.EXPERT, _charsets.ExpertCharset);
	    } else if (pos === 2) {
	      return new CFFCharset(true, CFFCharsetPredefinedTypes.EXPERT_SUBSET, _charsets.ExpertSubsetCharset);
	    }

	    const bytes = this.bytes;
	    const start = pos;
	    const format = bytes[pos++];
	    const charset = [cid ? 0 : ".notdef"];
	    let id, count, i;
	    length -= 1;

	    switch (format) {
	      case 0:
	        for (i = 0; i < length; i++) {
	          id = bytes[pos++] << 8 | bytes[pos++];
	          charset.push(cid ? id : strings.get(id));
	        }

	        break;

	      case 1:
	        while (charset.length <= length) {
	          id = bytes[pos++] << 8 | bytes[pos++];
	          count = bytes[pos++];

	          for (i = 0; i <= count; i++) {
	            charset.push(cid ? id++ : strings.get(id++));
	          }
	        }

	        break;

	      case 2:
	        while (charset.length <= length) {
	          id = bytes[pos++] << 8 | bytes[pos++];
	          count = bytes[pos++] << 8 | bytes[pos++];

	          for (i = 0; i <= count; i++) {
	            charset.push(cid ? id++ : strings.get(id++));
	          }
	        }

	        break;

	      default:
	        throw new _util.FormatError("Unknown charset format");
	    }

	    const end = pos;
	    const raw = bytes.subarray(start, end);
	    return new CFFCharset(false, format, charset, raw);
	  }

	  parseEncoding(pos, properties, strings, charset) {
	    const encoding = Object.create(null);
	    const bytes = this.bytes;
	    let predefined = false;
	    let format, i, ii;
	    let raw = null;

	    function readSupplement() {
	      const supplementsCount = bytes[pos++];

	      for (i = 0; i < supplementsCount; i++) {
	        const code = bytes[pos++];
	        const sid = (bytes[pos++] << 8) + (bytes[pos++] & 0xff);
	        encoding[code] = charset.indexOf(strings.get(sid));
	      }
	    }

	    if (pos === 0 || pos === 1) {
	      predefined = true;
	      format = pos;
	      const baseEncoding = pos ? _encodings.ExpertEncoding : _encodings.StandardEncoding;

	      for (i = 0, ii = charset.length; i < ii; i++) {
	        const index = baseEncoding.indexOf(charset[i]);

	        if (index !== -1) {
	          encoding[index] = i;
	        }
	      }
	    } else {
	      const dataStart = pos;
	      format = bytes[pos++];

	      switch (format & 0x7f) {
	        case 0:
	          const glyphsCount = bytes[pos++];

	          for (i = 1; i <= glyphsCount; i++) {
	            encoding[bytes[pos++]] = i;
	          }

	          break;

	        case 1:
	          const rangesCount = bytes[pos++];
	          let gid = 1;

	          for (i = 0; i < rangesCount; i++) {
	            const start = bytes[pos++];
	            const left = bytes[pos++];

	            for (let j = start; j <= start + left; j++) {
	              encoding[j] = gid++;
	            }
	          }

	          break;

	        default:
	          throw new _util.FormatError(`Unknown encoding format: ${format} in CFF`);
	      }

	      const dataEnd = pos;

	      if (format & 0x80) {
	        bytes[dataStart] &= 0x7f;
	        readSupplement();
	      }

	      raw = bytes.subarray(dataStart, dataEnd);
	    }

	    format &= 0x7f;
	    return new CFFEncoding(predefined, format, encoding, raw);
	  }

	  parseFDSelect(pos, length) {
	    const bytes = this.bytes;
	    const format = bytes[pos++];
	    const fdSelect = [];
	    let i;

	    switch (format) {
	      case 0:
	        for (i = 0; i < length; ++i) {
	          const id = bytes[pos++];
	          fdSelect.push(id);
	        }

	        break;

	      case 3:
	        const rangesCount = bytes[pos++] << 8 | bytes[pos++];

	        for (i = 0; i < rangesCount; ++i) {
	          let first = bytes[pos++] << 8 | bytes[pos++];

	          if (i === 0 && first !== 0) {
	            (0, _util.warn)("parseFDSelect: The first range must have a first GID of 0" + " -- trying to recover.");
	            first = 0;
	          }

	          const fdIndex = bytes[pos++];
	          const next = bytes[pos] << 8 | bytes[pos + 1];

	          for (let j = first; j < next; ++j) {
	            fdSelect.push(fdIndex);
	          }
	        }

	        pos += 2;
	        break;

	      default:
	        throw new _util.FormatError(`parseFDSelect: Unknown format "${format}".`);
	    }

	    if (fdSelect.length !== length) {
	      throw new _util.FormatError("parseFDSelect: Invalid font data.");
	    }

	    return new CFFFDSelect(format, fdSelect);
	  }

	}

	exports.CFFParser = CFFParser;

	class CFF {
	  constructor() {
	    this.header = null;
	    this.names = [];
	    this.topDict = null;
	    this.strings = new CFFStrings();
	    this.globalSubrIndex = null;
	    this.encoding = null;
	    this.charset = null;
	    this.charStrings = null;
	    this.fdArray = [];
	    this.fdSelect = null;
	    this.isCIDFont = false;
	  }

	  duplicateFirstGlyph() {
	    if (this.charStrings.count >= 65535) {
	      (0, _util.warn)("Not enough space in charstrings to duplicate first glyph.");
	      return;
	    }

	    const glyphZero = this.charStrings.get(0);
	    this.charStrings.add(glyphZero);

	    if (this.isCIDFont) {
	      this.fdSelect.fdSelect.push(this.fdSelect.fdSelect[0]);
	    }
	  }

	  hasGlyphId(id) {
	    if (id < 0 || id >= this.charStrings.count) {
	      return false;
	    }

	    const glyph = this.charStrings.get(id);
	    return glyph.length > 0;
	  }

	}

	exports.CFF = CFF;

	class CFFHeader {
	  constructor(major, minor, hdrSize, offSize) {
	    this.major = major;
	    this.minor = minor;
	    this.hdrSize = hdrSize;
	    this.offSize = offSize;
	  }

	}

	exports.CFFHeader = CFFHeader;

	class CFFStrings {
	  constructor() {
	    this.strings = [];
	  }

	  get(index) {
	    if (index >= 0 && index <= NUM_STANDARD_CFF_STRINGS - 1) {
	      return CFFStandardStrings[index];
	    }

	    if (index - NUM_STANDARD_CFF_STRINGS <= this.strings.length) {
	      return this.strings[index - NUM_STANDARD_CFF_STRINGS];
	    }

	    return CFFStandardStrings[0];
	  }

	  getSID(str) {
	    let index = CFFStandardStrings.indexOf(str);

	    if (index !== -1) {
	      return index;
	    }

	    index = this.strings.indexOf(str);

	    if (index !== -1) {
	      return index + NUM_STANDARD_CFF_STRINGS;
	    }

	    return -1;
	  }

	  add(value) {
	    this.strings.push(value);
	  }

	  get count() {
	    return this.strings.length;
	  }

	}

	exports.CFFStrings = CFFStrings;

	class CFFIndex {
	  constructor() {
	    this.objects = [];
	    this.length = 0;
	  }

	  add(data) {
	    this.length += data.length;
	    this.objects.push(data);
	  }

	  set(index, data) {
	    this.length += data.length - this.objects[index].length;
	    this.objects[index] = data;
	  }

	  get(index) {
	    return this.objects[index];
	  }

	  get count() {
	    return this.objects.length;
	  }

	}

	exports.CFFIndex = CFFIndex;

	class CFFDict {
	  constructor(tables, strings) {
	    this.keyToNameMap = tables.keyToNameMap;
	    this.nameToKeyMap = tables.nameToKeyMap;
	    this.defaults = tables.defaults;
	    this.types = tables.types;
	    this.opcodes = tables.opcodes;
	    this.order = tables.order;
	    this.strings = strings;
	    this.values = Object.create(null);
	  }

	  setByKey(key, value) {
	    if (!(key in this.keyToNameMap)) {
	      return false;
	    }

	    const valueLength = value.length;

	    if (valueLength === 0) {
	      return true;
	    }

	    for (let i = 0; i < valueLength; i++) {
	      if (isNaN(value[i])) {
	        (0, _util.warn)('Invalid CFFDict value: "' + value + '" for key "' + key + '".');
	        return true;
	      }
	    }

	    const type = this.types[key];

	    if (type === "num" || type === "sid" || type === "offset") {
	      value = value[0];
	    }

	    this.values[key] = value;
	    return true;
	  }

	  setByName(name, value) {
	    if (!(name in this.nameToKeyMap)) {
	      throw new _util.FormatError(`Invalid dictionary name "${name}"`);
	    }

	    this.values[this.nameToKeyMap[name]] = value;
	  }

	  hasName(name) {
	    return this.nameToKeyMap[name] in this.values;
	  }

	  getByName(name) {
	    if (!(name in this.nameToKeyMap)) {
	      throw new _util.FormatError(`Invalid dictionary name ${name}"`);
	    }

	    const key = this.nameToKeyMap[name];

	    if (!(key in this.values)) {
	      return this.defaults[key];
	    }

	    return this.values[key];
	  }

	  removeByName(name) {
	    delete this.values[this.nameToKeyMap[name]];
	  }

	  static createTables(layout) {
	    const tables = {
	      keyToNameMap: {},
	      nameToKeyMap: {},
	      defaults: {},
	      types: {},
	      opcodes: {},
	      order: []
	    };

	    for (let i = 0, ii = layout.length; i < ii; ++i) {
	      const entry = layout[i];
	      const key = Array.isArray(entry[0]) ? (entry[0][0] << 8) + entry[0][1] : entry[0];
	      tables.keyToNameMap[key] = entry[1];
	      tables.nameToKeyMap[entry[1]] = key;
	      tables.types[key] = entry[2];
	      tables.defaults[key] = entry[3];
	      tables.opcodes[key] = Array.isArray(entry[0]) ? entry[0] : [entry[0]];
	      tables.order.push(key);
	    }

	    return tables;
	  }

	}

	const CFFTopDictLayout = [[[12, 30], "ROS", ["sid", "sid", "num"], null], [[12, 20], "SyntheticBase", "num", null], [0, "version", "sid", null], [1, "Notice", "sid", null], [[12, 0], "Copyright", "sid", null], [2, "FullName", "sid", null], [3, "FamilyName", "sid", null], [4, "Weight", "sid", null], [[12, 1], "isFixedPitch", "num", 0], [[12, 2], "ItalicAngle", "num", 0], [[12, 3], "UnderlinePosition", "num", -100], [[12, 4], "UnderlineThickness", "num", 50], [[12, 5], "PaintType", "num", 0], [[12, 6], "CharstringType", "num", 2], [[12, 7], "FontMatrix", ["num", "num", "num", "num", "num", "num"], [0.001, 0, 0, 0.001, 0, 0]], [13, "UniqueID", "num", null], [5, "FontBBox", ["num", "num", "num", "num"], [0, 0, 0, 0]], [[12, 8], "StrokeWidth", "num", 0], [14, "XUID", "array", null], [15, "charset", "offset", 0], [16, "Encoding", "offset", 0], [17, "CharStrings", "offset", 0], [18, "Private", ["offset", "offset"], null], [[12, 21], "PostScript", "sid", null], [[12, 22], "BaseFontName", "sid", null], [[12, 23], "BaseFontBlend", "delta", null], [[12, 31], "CIDFontVersion", "num", 0], [[12, 32], "CIDFontRevision", "num", 0], [[12, 33], "CIDFontType", "num", 0], [[12, 34], "CIDCount", "num", 8720], [[12, 35], "UIDBase", "num", null], [[12, 37], "FDSelect", "offset", null], [[12, 36], "FDArray", "offset", null], [[12, 38], "FontName", "sid", null]];

	class CFFTopDict extends CFFDict {
	  static get tables() {
	    return (0, _util.shadow)(this, "tables", this.createTables(CFFTopDictLayout));
	  }

	  constructor(strings) {
	    super(CFFTopDict.tables, strings);
	    this.privateDict = null;
	  }

	}

	exports.CFFTopDict = CFFTopDict;
	const CFFPrivateDictLayout = [[6, "BlueValues", "delta", null], [7, "OtherBlues", "delta", null], [8, "FamilyBlues", "delta", null], [9, "FamilyOtherBlues", "delta", null], [[12, 9], "BlueScale", "num", 0.039625], [[12, 10], "BlueShift", "num", 7], [[12, 11], "BlueFuzz", "num", 1], [10, "StdHW", "num", null], [11, "StdVW", "num", null], [[12, 12], "StemSnapH", "delta", null], [[12, 13], "StemSnapV", "delta", null], [[12, 14], "ForceBold", "num", 0], [[12, 17], "LanguageGroup", "num", 0], [[12, 18], "ExpansionFactor", "num", 0.06], [[12, 19], "initialRandomSeed", "num", 0], [20, "defaultWidthX", "num", 0], [21, "nominalWidthX", "num", 0], [19, "Subrs", "offset", null]];

	class CFFPrivateDict extends CFFDict {
	  static get tables() {
	    return (0, _util.shadow)(this, "tables", this.createTables(CFFPrivateDictLayout));
	  }

	  constructor(strings) {
	    super(CFFPrivateDict.tables, strings);
	    this.subrsIndex = null;
	  }

	}

	exports.CFFPrivateDict = CFFPrivateDict;
	const CFFCharsetPredefinedTypes = {
	  ISO_ADOBE: 0,
	  EXPERT: 1,
	  EXPERT_SUBSET: 2
	};

	class CFFCharset {
	  constructor(predefined, format, charset, raw) {
	    this.predefined = predefined;
	    this.format = format;
	    this.charset = charset;
	    this.raw = raw;
	  }

	}

	exports.CFFCharset = CFFCharset;

	class CFFEncoding {
	  constructor(predefined, format, encoding, raw) {
	    this.predefined = predefined;
	    this.format = format;
	    this.encoding = encoding;
	    this.raw = raw;
	  }

	}

	class CFFFDSelect {
	  constructor(format, fdSelect) {
	    this.format = format;
	    this.fdSelect = fdSelect;
	  }

	  getFDIndex(glyphIndex) {
	    if (glyphIndex < 0 || glyphIndex >= this.fdSelect.length) {
	      return -1;
	    }

	    return this.fdSelect[glyphIndex];
	  }

	}

	exports.CFFFDSelect = CFFFDSelect;

	class CFFOffsetTracker {
	  constructor() {
	    this.offsets = Object.create(null);
	  }

	  isTracking(key) {
	    return key in this.offsets;
	  }

	  track(key, location) {
	    if (key in this.offsets) {
	      throw new _util.FormatError(`Already tracking location of ${key}`);
	    }

	    this.offsets[key] = location;
	  }

	  offset(value) {
	    for (const key in this.offsets) {
	      this.offsets[key] += value;
	    }
	  }

	  setEntryLocation(key, values, output) {
	    if (!(key in this.offsets)) {
	      throw new _util.FormatError(`Not tracking location of ${key}`);
	    }

	    const data = output.data;
	    const dataOffset = this.offsets[key];
	    const size = 5;

	    for (let i = 0, ii = values.length; i < ii; ++i) {
	      const offset0 = i * size + dataOffset;
	      const offset1 = offset0 + 1;
	      const offset2 = offset0 + 2;
	      const offset3 = offset0 + 3;
	      const offset4 = offset0 + 4;

	      if (data[offset0] !== 0x1d || data[offset1] !== 0 || data[offset2] !== 0 || data[offset3] !== 0 || data[offset4] !== 0) {
	        throw new _util.FormatError("writing to an offset that is not empty");
	      }

	      const value = values[i];
	      data[offset0] = 0x1d;
	      data[offset1] = value >> 24 & 0xff;
	      data[offset2] = value >> 16 & 0xff;
	      data[offset3] = value >> 8 & 0xff;
	      data[offset4] = value & 0xff;
	    }
	  }

	}

	class CFFCompiler {
	  constructor(cff) {
	    this.cff = cff;
	  }

	  compile() {
	    const cff = this.cff;
	    const output = {
	      data: [],
	      length: 0,

	      add(data) {
	        this.data = this.data.concat(data);
	        this.length = this.data.length;
	      }

	    };
	    const header = this.compileHeader(cff.header);
	    output.add(header);
	    const nameIndex = this.compileNameIndex(cff.names);
	    output.add(nameIndex);

	    if (cff.isCIDFont) {
	      if (cff.topDict.hasName("FontMatrix")) {
	        const base = cff.topDict.getByName("FontMatrix");
	        cff.topDict.removeByName("FontMatrix");

	        for (let i = 0, ii = cff.fdArray.length; i < ii; i++) {
	          const subDict = cff.fdArray[i];
	          let matrix = base.slice(0);

	          if (subDict.hasName("FontMatrix")) {
	            matrix = _util.Util.transform(matrix, subDict.getByName("FontMatrix"));
	          }

	          subDict.setByName("FontMatrix", matrix);
	        }
	      }
	    }

	    const xuid = cff.topDict.getByName("XUID");

	    if (xuid && xuid.length > 16) {
	      cff.topDict.removeByName("XUID");
	    }

	    cff.topDict.setByName("charset", 0);
	    let compiled = this.compileTopDicts([cff.topDict], output.length, cff.isCIDFont);
	    output.add(compiled.output);
	    const topDictTracker = compiled.trackers[0];
	    const stringIndex = this.compileStringIndex(cff.strings.strings);
	    output.add(stringIndex);
	    const globalSubrIndex = this.compileIndex(cff.globalSubrIndex);
	    output.add(globalSubrIndex);

	    if (cff.encoding && cff.topDict.hasName("Encoding")) {
	      if (cff.encoding.predefined) {
	        topDictTracker.setEntryLocation("Encoding", [cff.encoding.format], output);
	      } else {
	        const encoding = this.compileEncoding(cff.encoding);
	        topDictTracker.setEntryLocation("Encoding", [output.length], output);
	        output.add(encoding);
	      }
	    }

	    const charset = this.compileCharset(cff.charset, cff.charStrings.count, cff.strings, cff.isCIDFont);
	    topDictTracker.setEntryLocation("charset", [output.length], output);
	    output.add(charset);
	    const charStrings = this.compileCharStrings(cff.charStrings);
	    topDictTracker.setEntryLocation("CharStrings", [output.length], output);
	    output.add(charStrings);

	    if (cff.isCIDFont) {
	      topDictTracker.setEntryLocation("FDSelect", [output.length], output);
	      const fdSelect = this.compileFDSelect(cff.fdSelect);
	      output.add(fdSelect);
	      compiled = this.compileTopDicts(cff.fdArray, output.length, true);
	      topDictTracker.setEntryLocation("FDArray", [output.length], output);
	      output.add(compiled.output);
	      const fontDictTrackers = compiled.trackers;
	      this.compilePrivateDicts(cff.fdArray, fontDictTrackers, output);
	    }

	    this.compilePrivateDicts([cff.topDict], [topDictTracker], output);
	    output.add([0]);
	    return output.data;
	  }

	  encodeNumber(value) {
	    if (Number.isInteger(value)) {
	      return this.encodeInteger(value);
	    }

	    return this.encodeFloat(value);
	  }

	  static get EncodeFloatRegExp() {
	    return (0, _util.shadow)(this, "EncodeFloatRegExp", /\.(\d*?)(?:9{5,20}|0{5,20})\d{0,2}(?:e(.+)|$)/);
	  }

	  encodeFloat(num) {
	    let value = num.toString();
	    const m = CFFCompiler.EncodeFloatRegExp.exec(value);

	    if (m) {
	      const epsilon = parseFloat("1e" + ((m[2] ? +m[2] : 0) + m[1].length));
	      value = (Math.round(num * epsilon) / epsilon).toString();
	    }

	    let nibbles = "";
	    let i, ii;

	    for (i = 0, ii = value.length; i < ii; ++i) {
	      const a = value[i];

	      if (a === "e") {
	        nibbles += value[++i] === "-" ? "c" : "b";
	      } else if (a === ".") {
	        nibbles += "a";
	      } else if (a === "-") {
	        nibbles += "e";
	      } else {
	        nibbles += a;
	      }
	    }

	    nibbles += nibbles.length & 1 ? "f" : "ff";
	    const out = [30];

	    for (i = 0, ii = nibbles.length; i < ii; i += 2) {
	      out.push(parseInt(nibbles.substring(i, i + 2), 16));
	    }

	    return out;
	  }

	  encodeInteger(value) {
	    let code;

	    if (value >= -107 && value <= 107) {
	      code = [value + 139];
	    } else if (value >= 108 && value <= 1131) {
	      value -= 108;
	      code = [(value >> 8) + 247, value & 0xff];
	    } else if (value >= -1131 && value <= -108) {
	      value = -value - 108;
	      code = [(value >> 8) + 251, value & 0xff];
	    } else if (value >= -32768 && value <= 32767) {
	      code = [0x1c, value >> 8 & 0xff, value & 0xff];
	    } else {
	      code = [0x1d, value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff];
	    }

	    return code;
	  }

	  compileHeader(header) {
	    return [header.major, header.minor, 4, header.offSize];
	  }

	  compileNameIndex(names) {
	    const nameIndex = new CFFIndex();

	    for (let i = 0, ii = names.length; i < ii; ++i) {
	      const name = names[i];
	      const length = Math.min(name.length, 127);
	      let sanitizedName = new Array(length);

	      for (let j = 0; j < length; j++) {
	        let char = name[j];

	        if (char < "!" || char > "~" || char === "[" || char === "]" || char === "(" || char === ")" || char === "{" || char === "}" || char === "<" || char === ">" || char === "/" || char === "%") {
	          char = "_";
	        }

	        sanitizedName[j] = char;
	      }

	      sanitizedName = sanitizedName.join("");

	      if (sanitizedName === "") {
	        sanitizedName = "Bad_Font_Name";
	      }

	      nameIndex.add((0, _util.stringToBytes)(sanitizedName));
	    }

	    return this.compileIndex(nameIndex);
	  }

	  compileTopDicts(dicts, length, removeCidKeys) {
	    const fontDictTrackers = [];
	    let fdArrayIndex = new CFFIndex();

	    for (let i = 0, ii = dicts.length; i < ii; ++i) {
	      const fontDict = dicts[i];

	      if (removeCidKeys) {
	        fontDict.removeByName("CIDFontVersion");
	        fontDict.removeByName("CIDFontRevision");
	        fontDict.removeByName("CIDFontType");
	        fontDict.removeByName("CIDCount");
	        fontDict.removeByName("UIDBase");
	      }

	      const fontDictTracker = new CFFOffsetTracker();
	      const fontDictData = this.compileDict(fontDict, fontDictTracker);
	      fontDictTrackers.push(fontDictTracker);
	      fdArrayIndex.add(fontDictData);
	      fontDictTracker.offset(length);
	    }

	    fdArrayIndex = this.compileIndex(fdArrayIndex, fontDictTrackers);
	    return {
	      trackers: fontDictTrackers,
	      output: fdArrayIndex
	    };
	  }

	  compilePrivateDicts(dicts, trackers, output) {
	    for (let i = 0, ii = dicts.length; i < ii; ++i) {
	      const fontDict = dicts[i];
	      const privateDict = fontDict.privateDict;

	      if (!privateDict || !fontDict.hasName("Private")) {
	        throw new _util.FormatError("There must be a private dictionary.");
	      }

	      const privateDictTracker = new CFFOffsetTracker();
	      const privateDictData = this.compileDict(privateDict, privateDictTracker);
	      let outputLength = output.length;
	      privateDictTracker.offset(outputLength);

	      if (!privateDictData.length) {
	        outputLength = 0;
	      }

	      trackers[i].setEntryLocation("Private", [privateDictData.length, outputLength], output);
	      output.add(privateDictData);

	      if (privateDict.subrsIndex && privateDict.hasName("Subrs")) {
	        const subrs = this.compileIndex(privateDict.subrsIndex);
	        privateDictTracker.setEntryLocation("Subrs", [privateDictData.length], output);
	        output.add(subrs);
	      }
	    }
	  }

	  compileDict(dict, offsetTracker) {
	    const out = [];

	    for (const key of dict.order) {
	      if (!(key in dict.values)) {
	        continue;
	      }

	      let values = dict.values[key];
	      let types = dict.types[key];

	      if (!Array.isArray(types)) {
	        types = [types];
	      }

	      if (!Array.isArray(values)) {
	        values = [values];
	      }

	      if (values.length === 0) {
	        continue;
	      }

	      for (let j = 0, jj = types.length; j < jj; ++j) {
	        const type = types[j];
	        const value = values[j];

	        switch (type) {
	          case "num":
	          case "sid":
	            out.push(...this.encodeNumber(value));
	            break;

	          case "offset":
	            const name = dict.keyToNameMap[key];

	            if (!offsetTracker.isTracking(name)) {
	              offsetTracker.track(name, out.length);
	            }

	            out.push(0x1d, 0, 0, 0, 0);
	            break;

	          case "array":
	          case "delta":
	            out.push(...this.encodeNumber(value));

	            for (let k = 1, kk = values.length; k < kk; ++k) {
	              out.push(...this.encodeNumber(values[k]));
	            }

	            break;

	          default:
	            throw new _util.FormatError(`Unknown data type of ${type}`);
	        }
	      }

	      out.push(...dict.opcodes[key]);
	    }

	    return out;
	  }

	  compileStringIndex(strings) {
	    const stringIndex = new CFFIndex();

	    for (let i = 0, ii = strings.length; i < ii; ++i) {
	      stringIndex.add((0, _util.stringToBytes)(strings[i]));
	    }

	    return this.compileIndex(stringIndex);
	  }

	  compileGlobalSubrIndex() {
	    const globalSubrIndex = this.cff.globalSubrIndex;
	    this.out.writeByteArray(this.compileIndex(globalSubrIndex));
	  }

	  compileCharStrings(charStrings) {
	    const charStringsIndex = new CFFIndex();

	    for (let i = 0; i < charStrings.count; i++) {
	      const glyph = charStrings.get(i);

	      if (glyph.length === 0) {
	        charStringsIndex.add(new Uint8Array([0x8b, 0x0e]));
	        continue;
	      }

	      charStringsIndex.add(glyph);
	    }

	    return this.compileIndex(charStringsIndex);
	  }

	  compileCharset(charset, numGlyphs, strings, isCIDFont) {
	    let out;
	    const numGlyphsLessNotDef = numGlyphs - 1;

	    if (isCIDFont) {
	      out = new Uint8Array([2, 0, 0, numGlyphsLessNotDef >> 8 & 0xff, numGlyphsLessNotDef & 0xff]);
	    } else {
	      const length = 1 + numGlyphsLessNotDef * 2;
	      out = new Uint8Array(length);
	      out[0] = 0;
	      let charsetIndex = 0;
	      const numCharsets = charset.charset.length;
	      let warned = false;

	      for (let i = 1; i < out.length; i += 2) {
	        let sid = 0;

	        if (charsetIndex < numCharsets) {
	          const name = charset.charset[charsetIndex++];
	          sid = strings.getSID(name);

	          if (sid === -1) {
	            sid = 0;

	            if (!warned) {
	              warned = true;
	              (0, _util.warn)(`Couldn't find ${name} in CFF strings`);
	            }
	          }
	        }

	        out[i] = sid >> 8 & 0xff;
	        out[i + 1] = sid & 0xff;
	      }
	    }

	    return this.compileTypedArray(out);
	  }

	  compileEncoding(encoding) {
	    return this.compileTypedArray(encoding.raw);
	  }

	  compileFDSelect(fdSelect) {
	    const format = fdSelect.format;
	    let out, i;

	    switch (format) {
	      case 0:
	        out = new Uint8Array(1 + fdSelect.fdSelect.length);
	        out[0] = format;

	        for (i = 0; i < fdSelect.fdSelect.length; i++) {
	          out[i + 1] = fdSelect.fdSelect[i];
	        }

	        break;

	      case 3:
	        const start = 0;
	        let lastFD = fdSelect.fdSelect[0];
	        const ranges = [format, 0, 0, start >> 8 & 0xff, start & 0xff, lastFD];

	        for (i = 1; i < fdSelect.fdSelect.length; i++) {
	          const currentFD = fdSelect.fdSelect[i];

	          if (currentFD !== lastFD) {
	            ranges.push(i >> 8 & 0xff, i & 0xff, currentFD);
	            lastFD = currentFD;
	          }
	        }

	        const numRanges = (ranges.length - 3) / 3;
	        ranges[1] = numRanges >> 8 & 0xff;
	        ranges[2] = numRanges & 0xff;
	        ranges.push(i >> 8 & 0xff, i & 0xff);
	        out = new Uint8Array(ranges);
	        break;
	    }

	    return this.compileTypedArray(out);
	  }

	  compileTypedArray(data) {
	    const out = [];

	    for (let i = 0, ii = data.length; i < ii; ++i) {
	      out[i] = data[i];
	    }

	    return out;
	  }

	  compileIndex(index, trackers = []) {
	    const objects = index.objects;
	    const count = objects.length;

	    if (count === 0) {
	      return [0, 0];
	    }

	    const data = [count >> 8 & 0xff, count & 0xff];
	    let lastOffset = 1,
	        i;

	    for (i = 0; i < count; ++i) {
	      lastOffset += objects[i].length;
	    }

	    let offsetSize;

	    if (lastOffset < 0x100) {
	      offsetSize = 1;
	    } else if (lastOffset < 0x10000) {
	      offsetSize = 2;
	    } else if (lastOffset < 0x1000000) {
	      offsetSize = 3;
	    } else {
	      offsetSize = 4;
	    }

	    data.push(offsetSize);
	    let relativeOffset = 1;

	    for (i = 0; i < count + 1; i++) {
	      if (offsetSize === 1) {
	        data.push(relativeOffset & 0xff);
	      } else if (offsetSize === 2) {
	        data.push(relativeOffset >> 8 & 0xff, relativeOffset & 0xff);
	      } else if (offsetSize === 3) {
	        data.push(relativeOffset >> 16 & 0xff, relativeOffset >> 8 & 0xff, relativeOffset & 0xff);
	      } else {
	        data.push(relativeOffset >>> 24 & 0xff, relativeOffset >> 16 & 0xff, relativeOffset >> 8 & 0xff, relativeOffset & 0xff);
	      }

	      if (objects[i]) {
	        relativeOffset += objects[i].length;
	      }
	    }

	    for (i = 0; i < count; i++) {
	      if (trackers[i]) {
	        trackers[i].offset(data.length);
	      }

	      for (let j = 0, jj = objects[i].length; j < jj; j++) {
	        data.push(objects[i][j]);
	      }
	    }

	    return data;
	  }

	}

	exports.CFFCompiler = CFFCompiler;

	/***/ }),
	/* 36 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ISOAdobeCharset = exports.ExpertSubsetCharset = exports.ExpertCharset = void 0;
	const ISOAdobeCharset = [".notdef", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quoteright", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "quoteleft", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "exclamdown", "cent", "sterling", "fraction", "yen", "florin", "section", "currency", "quotesingle", "quotedblleft", "guillemotleft", "guilsinglleft", "guilsinglright", "fi", "fl", "endash", "dagger", "daggerdbl", "periodcentered", "paragraph", "bullet", "quotesinglbase", "quotedblbase", "quotedblright", "guillemotright", "ellipsis", "perthousand", "questiondown", "grave", "acute", "circumflex", "tilde", "macron", "breve", "dotaccent", "dieresis", "ring", "cedilla", "hungarumlaut", "ogonek", "caron", "emdash", "AE", "ordfeminine", "Lslash", "Oslash", "OE", "ordmasculine", "ae", "dotlessi", "lslash", "oslash", "oe", "germandbls", "onesuperior", "logicalnot", "mu", "trademark", "Eth", "onehalf", "plusminus", "Thorn", "onequarter", "divide", "brokenbar", "degree", "thorn", "threequarters", "twosuperior", "registered", "minus", "eth", "multiply", "threesuperior", "copyright", "Aacute", "Acircumflex", "Adieresis", "Agrave", "Aring", "Atilde", "Ccedilla", "Eacute", "Ecircumflex", "Edieresis", "Egrave", "Iacute", "Icircumflex", "Idieresis", "Igrave", "Ntilde", "Oacute", "Ocircumflex", "Odieresis", "Ograve", "Otilde", "Scaron", "Uacute", "Ucircumflex", "Udieresis", "Ugrave", "Yacute", "Ydieresis", "Zcaron", "aacute", "acircumflex", "adieresis", "agrave", "aring", "atilde", "ccedilla", "eacute", "ecircumflex", "edieresis", "egrave", "iacute", "icircumflex", "idieresis", "igrave", "ntilde", "oacute", "ocircumflex", "odieresis", "ograve", "otilde", "scaron", "uacute", "ucircumflex", "udieresis", "ugrave", "yacute", "ydieresis", "zcaron"];
	exports.ISOAdobeCharset = ISOAdobeCharset;
	const ExpertCharset = [".notdef", "space", "exclamsmall", "Hungarumlautsmall", "dollaroldstyle", "dollarsuperior", "ampersandsmall", "Acutesmall", "parenleftsuperior", "parenrightsuperior", "twodotenleader", "onedotenleader", "comma", "hyphen", "period", "fraction", "zerooldstyle", "oneoldstyle", "twooldstyle", "threeoldstyle", "fouroldstyle", "fiveoldstyle", "sixoldstyle", "sevenoldstyle", "eightoldstyle", "nineoldstyle", "colon", "semicolon", "commasuperior", "threequartersemdash", "periodsuperior", "questionsmall", "asuperior", "bsuperior", "centsuperior", "dsuperior", "esuperior", "isuperior", "lsuperior", "msuperior", "nsuperior", "osuperior", "rsuperior", "ssuperior", "tsuperior", "ff", "fi", "fl", "ffi", "ffl", "parenleftinferior", "parenrightinferior", "Circumflexsmall", "hyphensuperior", "Gravesmall", "Asmall", "Bsmall", "Csmall", "Dsmall", "Esmall", "Fsmall", "Gsmall", "Hsmall", "Ismall", "Jsmall", "Ksmall", "Lsmall", "Msmall", "Nsmall", "Osmall", "Psmall", "Qsmall", "Rsmall", "Ssmall", "Tsmall", "Usmall", "Vsmall", "Wsmall", "Xsmall", "Ysmall", "Zsmall", "colonmonetary", "onefitted", "rupiah", "Tildesmall", "exclamdownsmall", "centoldstyle", "Lslashsmall", "Scaronsmall", "Zcaronsmall", "Dieresissmall", "Brevesmall", "Caronsmall", "Dotaccentsmall", "Macronsmall", "figuredash", "hypheninferior", "Ogoneksmall", "Ringsmall", "Cedillasmall", "onequarter", "onehalf", "threequarters", "questiondownsmall", "oneeighth", "threeeighths", "fiveeighths", "seveneighths", "onethird", "twothirds", "zerosuperior", "onesuperior", "twosuperior", "threesuperior", "foursuperior", "fivesuperior", "sixsuperior", "sevensuperior", "eightsuperior", "ninesuperior", "zeroinferior", "oneinferior", "twoinferior", "threeinferior", "fourinferior", "fiveinferior", "sixinferior", "seveninferior", "eightinferior", "nineinferior", "centinferior", "dollarinferior", "periodinferior", "commainferior", "Agravesmall", "Aacutesmall", "Acircumflexsmall", "Atildesmall", "Adieresissmall", "Aringsmall", "AEsmall", "Ccedillasmall", "Egravesmall", "Eacutesmall", "Ecircumflexsmall", "Edieresissmall", "Igravesmall", "Iacutesmall", "Icircumflexsmall", "Idieresissmall", "Ethsmall", "Ntildesmall", "Ogravesmall", "Oacutesmall", "Ocircumflexsmall", "Otildesmall", "Odieresissmall", "OEsmall", "Oslashsmall", "Ugravesmall", "Uacutesmall", "Ucircumflexsmall", "Udieresissmall", "Yacutesmall", "Thornsmall", "Ydieresissmall"];
	exports.ExpertCharset = ExpertCharset;
	const ExpertSubsetCharset = [".notdef", "space", "dollaroldstyle", "dollarsuperior", "parenleftsuperior", "parenrightsuperior", "twodotenleader", "onedotenleader", "comma", "hyphen", "period", "fraction", "zerooldstyle", "oneoldstyle", "twooldstyle", "threeoldstyle", "fouroldstyle", "fiveoldstyle", "sixoldstyle", "sevenoldstyle", "eightoldstyle", "nineoldstyle", "colon", "semicolon", "commasuperior", "threequartersemdash", "periodsuperior", "asuperior", "bsuperior", "centsuperior", "dsuperior", "esuperior", "isuperior", "lsuperior", "msuperior", "nsuperior", "osuperior", "rsuperior", "ssuperior", "tsuperior", "ff", "fi", "fl", "ffi", "ffl", "parenleftinferior", "parenrightinferior", "hyphensuperior", "colonmonetary", "onefitted", "rupiah", "centoldstyle", "figuredash", "hypheninferior", "onequarter", "onehalf", "threequarters", "oneeighth", "threeeighths", "fiveeighths", "seveneighths", "onethird", "twothirds", "zerosuperior", "onesuperior", "twosuperior", "threesuperior", "foursuperior", "fivesuperior", "sixsuperior", "sevensuperior", "eightsuperior", "ninesuperior", "zeroinferior", "oneinferior", "twoinferior", "threeinferior", "fourinferior", "fiveinferior", "sixinferior", "seveninferior", "eightinferior", "nineinferior", "centinferior", "dollarinferior", "periodinferior", "commainferior"];
	exports.ExpertSubsetCharset = ExpertSubsetCharset;

	/***/ }),
	/* 37 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ZapfDingbatsEncoding = exports.WinAnsiEncoding = exports.SymbolSetEncoding = exports.StandardEncoding = exports.MacRomanEncoding = exports.ExpertEncoding = void 0;
	exports.getEncoding = getEncoding;
	const ExpertEncoding = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclamsmall", "Hungarumlautsmall", "", "dollaroldstyle", "dollarsuperior", "ampersandsmall", "Acutesmall", "parenleftsuperior", "parenrightsuperior", "twodotenleader", "onedotenleader", "comma", "hyphen", "period", "fraction", "zerooldstyle", "oneoldstyle", "twooldstyle", "threeoldstyle", "fouroldstyle", "fiveoldstyle", "sixoldstyle", "sevenoldstyle", "eightoldstyle", "nineoldstyle", "colon", "semicolon", "commasuperior", "threequartersemdash", "periodsuperior", "questionsmall", "", "asuperior", "bsuperior", "centsuperior", "dsuperior", "esuperior", "", "", "", "isuperior", "", "", "lsuperior", "msuperior", "nsuperior", "osuperior", "", "", "rsuperior", "ssuperior", "tsuperior", "", "ff", "fi", "fl", "ffi", "ffl", "parenleftinferior", "", "parenrightinferior", "Circumflexsmall", "hyphensuperior", "Gravesmall", "Asmall", "Bsmall", "Csmall", "Dsmall", "Esmall", "Fsmall", "Gsmall", "Hsmall", "Ismall", "Jsmall", "Ksmall", "Lsmall", "Msmall", "Nsmall", "Osmall", "Psmall", "Qsmall", "Rsmall", "Ssmall", "Tsmall", "Usmall", "Vsmall", "Wsmall", "Xsmall", "Ysmall", "Zsmall", "colonmonetary", "onefitted", "rupiah", "Tildesmall", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "exclamdownsmall", "centoldstyle", "Lslashsmall", "", "", "Scaronsmall", "Zcaronsmall", "Dieresissmall", "Brevesmall", "Caronsmall", "", "Dotaccentsmall", "", "", "Macronsmall", "", "", "figuredash", "hypheninferior", "", "", "Ogoneksmall", "Ringsmall", "Cedillasmall", "", "", "", "onequarter", "onehalf", "threequarters", "questiondownsmall", "oneeighth", "threeeighths", "fiveeighths", "seveneighths", "onethird", "twothirds", "", "", "zerosuperior", "onesuperior", "twosuperior", "threesuperior", "foursuperior", "fivesuperior", "sixsuperior", "sevensuperior", "eightsuperior", "ninesuperior", "zeroinferior", "oneinferior", "twoinferior", "threeinferior", "fourinferior", "fiveinferior", "sixinferior", "seveninferior", "eightinferior", "nineinferior", "centinferior", "dollarinferior", "periodinferior", "commainferior", "Agravesmall", "Aacutesmall", "Acircumflexsmall", "Atildesmall", "Adieresissmall", "Aringsmall", "AEsmall", "Ccedillasmall", "Egravesmall", "Eacutesmall", "Ecircumflexsmall", "Edieresissmall", "Igravesmall", "Iacutesmall", "Icircumflexsmall", "Idieresissmall", "Ethsmall", "Ntildesmall", "Ogravesmall", "Oacutesmall", "Ocircumflexsmall", "Otildesmall", "Odieresissmall", "OEsmall", "Oslashsmall", "Ugravesmall", "Uacutesmall", "Ucircumflexsmall", "Udieresissmall", "Yacutesmall", "Thornsmall", "Ydieresissmall"];
	exports.ExpertEncoding = ExpertEncoding;
	const MacExpertEncoding = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclamsmall", "Hungarumlautsmall", "centoldstyle", "dollaroldstyle", "dollarsuperior", "ampersandsmall", "Acutesmall", "parenleftsuperior", "parenrightsuperior", "twodotenleader", "onedotenleader", "comma", "hyphen", "period", "fraction", "zerooldstyle", "oneoldstyle", "twooldstyle", "threeoldstyle", "fouroldstyle", "fiveoldstyle", "sixoldstyle", "sevenoldstyle", "eightoldstyle", "nineoldstyle", "colon", "semicolon", "", "threequartersemdash", "", "questionsmall", "", "", "", "", "Ethsmall", "", "", "onequarter", "onehalf", "threequarters", "oneeighth", "threeeighths", "fiveeighths", "seveneighths", "onethird", "twothirds", "", "", "", "", "", "", "ff", "fi", "fl", "ffi", "ffl", "parenleftinferior", "", "parenrightinferior", "Circumflexsmall", "hypheninferior", "Gravesmall", "Asmall", "Bsmall", "Csmall", "Dsmall", "Esmall", "Fsmall", "Gsmall", "Hsmall", "Ismall", "Jsmall", "Ksmall", "Lsmall", "Msmall", "Nsmall", "Osmall", "Psmall", "Qsmall", "Rsmall", "Ssmall", "Tsmall", "Usmall", "Vsmall", "Wsmall", "Xsmall", "Ysmall", "Zsmall", "colonmonetary", "onefitted", "rupiah", "Tildesmall", "", "", "asuperior", "centsuperior", "", "", "", "", "Aacutesmall", "Agravesmall", "Acircumflexsmall", "Adieresissmall", "Atildesmall", "Aringsmall", "Ccedillasmall", "Eacutesmall", "Egravesmall", "Ecircumflexsmall", "Edieresissmall", "Iacutesmall", "Igravesmall", "Icircumflexsmall", "Idieresissmall", "Ntildesmall", "Oacutesmall", "Ogravesmall", "Ocircumflexsmall", "Odieresissmall", "Otildesmall", "Uacutesmall", "Ugravesmall", "Ucircumflexsmall", "Udieresissmall", "", "eightsuperior", "fourinferior", "threeinferior", "sixinferior", "eightinferior", "seveninferior", "Scaronsmall", "", "centinferior", "twoinferior", "", "Dieresissmall", "", "Caronsmall", "osuperior", "fiveinferior", "", "commainferior", "periodinferior", "Yacutesmall", "", "dollarinferior", "", "", "Thornsmall", "", "nineinferior", "zeroinferior", "Zcaronsmall", "AEsmall", "Oslashsmall", "questiondownsmall", "oneinferior", "Lslashsmall", "", "", "", "", "", "", "Cedillasmall", "", "", "", "", "", "OEsmall", "figuredash", "hyphensuperior", "", "", "", "", "exclamdownsmall", "", "Ydieresissmall", "", "onesuperior", "twosuperior", "threesuperior", "foursuperior", "fivesuperior", "sixsuperior", "sevensuperior", "ninesuperior", "zerosuperior", "", "esuperior", "rsuperior", "tsuperior", "", "", "isuperior", "ssuperior", "dsuperior", "", "", "", "", "", "lsuperior", "Ogoneksmall", "Brevesmall", "Macronsmall", "bsuperior", "nsuperior", "msuperior", "commasuperior", "periodsuperior", "Dotaccentsmall", "Ringsmall", "", "", "", ""];
	const MacRomanEncoding = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quotesingle", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "grave", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "", "Adieresis", "Aring", "Ccedilla", "Eacute", "Ntilde", "Odieresis", "Udieresis", "aacute", "agrave", "acircumflex", "adieresis", "atilde", "aring", "ccedilla", "eacute", "egrave", "ecircumflex", "edieresis", "iacute", "igrave", "icircumflex", "idieresis", "ntilde", "oacute", "ograve", "ocircumflex", "odieresis", "otilde", "uacute", "ugrave", "ucircumflex", "udieresis", "dagger", "degree", "cent", "sterling", "section", "bullet", "paragraph", "germandbls", "registered", "copyright", "trademark", "acute", "dieresis", "notequal", "AE", "Oslash", "infinity", "plusminus", "lessequal", "greaterequal", "yen", "mu", "partialdiff", "summation", "product", "pi", "integral", "ordfeminine", "ordmasculine", "Omega", "ae", "oslash", "questiondown", "exclamdown", "logicalnot", "radical", "florin", "approxequal", "Delta", "guillemotleft", "guillemotright", "ellipsis", "space", "Agrave", "Atilde", "Otilde", "OE", "oe", "endash", "emdash", "quotedblleft", "quotedblright", "quoteleft", "quoteright", "divide", "lozenge", "ydieresis", "Ydieresis", "fraction", "currency", "guilsinglleft", "guilsinglright", "fi", "fl", "daggerdbl", "periodcentered", "quotesinglbase", "quotedblbase", "perthousand", "Acircumflex", "Ecircumflex", "Aacute", "Edieresis", "Egrave", "Iacute", "Icircumflex", "Idieresis", "Igrave", "Oacute", "Ocircumflex", "apple", "Ograve", "Uacute", "Ucircumflex", "Ugrave", "dotlessi", "circumflex", "tilde", "macron", "breve", "dotaccent", "ring", "cedilla", "hungarumlaut", "ogonek", "caron"];
	exports.MacRomanEncoding = MacRomanEncoding;
	const StandardEncoding = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quoteright", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "quoteleft", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "exclamdown", "cent", "sterling", "fraction", "yen", "florin", "section", "currency", "quotesingle", "quotedblleft", "guillemotleft", "guilsinglleft", "guilsinglright", "fi", "fl", "", "endash", "dagger", "daggerdbl", "periodcentered", "", "paragraph", "bullet", "quotesinglbase", "quotedblbase", "quotedblright", "guillemotright", "ellipsis", "perthousand", "", "questiondown", "", "grave", "acute", "circumflex", "tilde", "macron", "breve", "dotaccent", "dieresis", "", "ring", "cedilla", "", "hungarumlaut", "ogonek", "caron", "emdash", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "AE", "", "ordfeminine", "", "", "", "", "Lslash", "Oslash", "OE", "ordmasculine", "", "", "", "", "", "ae", "", "", "", "dotlessi", "", "", "lslash", "oslash", "oe", "germandbls", "", "", "", ""];
	exports.StandardEncoding = StandardEncoding;
	const WinAnsiEncoding = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quotesingle", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "grave", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "bullet", "Euro", "bullet", "quotesinglbase", "florin", "quotedblbase", "ellipsis", "dagger", "daggerdbl", "circumflex", "perthousand", "Scaron", "guilsinglleft", "OE", "bullet", "Zcaron", "bullet", "bullet", "quoteleft", "quoteright", "quotedblleft", "quotedblright", "bullet", "endash", "emdash", "tilde", "trademark", "scaron", "guilsinglright", "oe", "bullet", "zcaron", "Ydieresis", "space", "exclamdown", "cent", "sterling", "currency", "yen", "brokenbar", "section", "dieresis", "copyright", "ordfeminine", "guillemotleft", "logicalnot", "hyphen", "registered", "macron", "degree", "plusminus", "twosuperior", "threesuperior", "acute", "mu", "paragraph", "periodcentered", "cedilla", "onesuperior", "ordmasculine", "guillemotright", "onequarter", "onehalf", "threequarters", "questiondown", "Agrave", "Aacute", "Acircumflex", "Atilde", "Adieresis", "Aring", "AE", "Ccedilla", "Egrave", "Eacute", "Ecircumflex", "Edieresis", "Igrave", "Iacute", "Icircumflex", "Idieresis", "Eth", "Ntilde", "Ograve", "Oacute", "Ocircumflex", "Otilde", "Odieresis", "multiply", "Oslash", "Ugrave", "Uacute", "Ucircumflex", "Udieresis", "Yacute", "Thorn", "germandbls", "agrave", "aacute", "acircumflex", "atilde", "adieresis", "aring", "ae", "ccedilla", "egrave", "eacute", "ecircumflex", "edieresis", "igrave", "iacute", "icircumflex", "idieresis", "eth", "ntilde", "ograve", "oacute", "ocircumflex", "otilde", "odieresis", "divide", "oslash", "ugrave", "uacute", "ucircumflex", "udieresis", "yacute", "thorn", "ydieresis"];
	exports.WinAnsiEncoding = WinAnsiEncoding;
	const SymbolSetEncoding = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "exclam", "universal", "numbersign", "existential", "percent", "ampersand", "suchthat", "parenleft", "parenright", "asteriskmath", "plus", "comma", "minus", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "congruent", "Alpha", "Beta", "Chi", "Delta", "Epsilon", "Phi", "Gamma", "Eta", "Iota", "theta1", "Kappa", "Lambda", "Mu", "Nu", "Omicron", "Pi", "Theta", "Rho", "Sigma", "Tau", "Upsilon", "sigma1", "Omega", "Xi", "Psi", "Zeta", "bracketleft", "therefore", "bracketright", "perpendicular", "underscore", "radicalex", "alpha", "beta", "chi", "delta", "epsilon", "phi", "gamma", "eta", "iota", "phi1", "kappa", "lambda", "mu", "nu", "omicron", "pi", "theta", "rho", "sigma", "tau", "upsilon", "omega1", "omega", "xi", "psi", "zeta", "braceleft", "bar", "braceright", "similar", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "Euro", "Upsilon1", "minute", "lessequal", "fraction", "infinity", "florin", "club", "diamond", "heart", "spade", "arrowboth", "arrowleft", "arrowup", "arrowright", "arrowdown", "degree", "plusminus", "second", "greaterequal", "multiply", "proportional", "partialdiff", "bullet", "divide", "notequal", "equivalence", "approxequal", "ellipsis", "arrowvertex", "arrowhorizex", "carriagereturn", "aleph", "Ifraktur", "Rfraktur", "weierstrass", "circlemultiply", "circleplus", "emptyset", "intersection", "union", "propersuperset", "reflexsuperset", "notsubset", "propersubset", "reflexsubset", "element", "notelement", "angle", "gradient", "registerserif", "copyrightserif", "trademarkserif", "product", "radical", "dotmath", "logicalnot", "logicaland", "logicalor", "arrowdblboth", "arrowdblleft", "arrowdblup", "arrowdblright", "arrowdbldown", "lozenge", "angleleft", "registersans", "copyrightsans", "trademarksans", "summation", "parenlefttp", "parenleftex", "parenleftbt", "bracketlefttp", "bracketleftex", "bracketleftbt", "bracelefttp", "braceleftmid", "braceleftbt", "braceex", "", "angleright", "integral", "integraltp", "integralex", "integralbt", "parenrighttp", "parenrightex", "parenrightbt", "bracketrighttp", "bracketrightex", "bracketrightbt", "bracerighttp", "bracerightmid", "bracerightbt", ""];
	exports.SymbolSetEncoding = SymbolSetEncoding;
	const ZapfDingbatsEncoding = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "space", "a1", "a2", "a202", "a3", "a4", "a5", "a119", "a118", "a117", "a11", "a12", "a13", "a14", "a15", "a16", "a105", "a17", "a18", "a19", "a20", "a21", "a22", "a23", "a24", "a25", "a26", "a27", "a28", "a6", "a7", "a8", "a9", "a10", "a29", "a30", "a31", "a32", "a33", "a34", "a35", "a36", "a37", "a38", "a39", "a40", "a41", "a42", "a43", "a44", "a45", "a46", "a47", "a48", "a49", "a50", "a51", "a52", "a53", "a54", "a55", "a56", "a57", "a58", "a59", "a60", "a61", "a62", "a63", "a64", "a65", "a66", "a67", "a68", "a69", "a70", "a71", "a72", "a73", "a74", "a203", "a75", "a204", "a76", "a77", "a78", "a79", "a81", "a82", "a83", "a84", "a97", "a98", "a99", "a100", "", "a89", "a90", "a93", "a94", "a91", "a92", "a205", "a85", "a206", "a86", "a87", "a88", "a95", "a96", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "a101", "a102", "a103", "a104", "a106", "a107", "a108", "a112", "a111", "a110", "a109", "a120", "a121", "a122", "a123", "a124", "a125", "a126", "a127", "a128", "a129", "a130", "a131", "a132", "a133", "a134", "a135", "a136", "a137", "a138", "a139", "a140", "a141", "a142", "a143", "a144", "a145", "a146", "a147", "a148", "a149", "a150", "a151", "a152", "a153", "a154", "a155", "a156", "a157", "a158", "a159", "a160", "a161", "a163", "a164", "a196", "a165", "a192", "a166", "a167", "a168", "a169", "a170", "a171", "a172", "a173", "a162", "a174", "a175", "a176", "a177", "a178", "a179", "a193", "a180", "a199", "a181", "a200", "a182", "", "a201", "a183", "a184", "a197", "a185", "a194", "a198", "a186", "a195", "a187", "a188", "a189", "a190", "a191", ""];
	exports.ZapfDingbatsEncoding = ZapfDingbatsEncoding;

	function getEncoding(encodingName) {
	  switch (encodingName) {
	    case "WinAnsiEncoding":
	      return WinAnsiEncoding;

	    case "StandardEncoding":
	      return StandardEncoding;

	    case "MacRomanEncoding":
	      return MacRomanEncoding;

	    case "SymbolSetEncoding":
	      return SymbolSetEncoding;

	    case "ZapfDingbatsEncoding":
	      return ZapfDingbatsEncoding;

	    case "ExpertEncoding":
	      return ExpertEncoding;

	    case "MacExpertEncoding":
	      return MacExpertEncoding;

	    default:
	      return null;
	  }
	}

	/***/ }),
	/* 38 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.SEAC_ANALYSIS_ENABLED = exports.MacStandardGlyphOrdering = exports.FontFlags = void 0;
	exports.getFontType = getFontType;
	exports.normalizeFontName = normalizeFontName;
	exports.recoverGlyphName = recoverGlyphName;
	exports.type1FontGlyphMapping = type1FontGlyphMapping;

	var _util = __w_pdfjs_require__(2);

	var _encodings = __w_pdfjs_require__(37);

	var _glyphlist = __w_pdfjs_require__(39);

	var _unicode = __w_pdfjs_require__(40);

	const SEAC_ANALYSIS_ENABLED = true;
	exports.SEAC_ANALYSIS_ENABLED = SEAC_ANALYSIS_ENABLED;
	const FontFlags = {
	  FixedPitch: 1,
	  Serif: 2,
	  Symbolic: 4,
	  Script: 8,
	  Nonsymbolic: 32,
	  Italic: 64,
	  AllCap: 65536,
	  SmallCap: 131072,
	  ForceBold: 262144
	};
	exports.FontFlags = FontFlags;
	const MacStandardGlyphOrdering = [".notdef", ".null", "nonmarkingreturn", "space", "exclam", "quotedbl", "numbersign", "dollar", "percent", "ampersand", "quotesingle", "parenleft", "parenright", "asterisk", "plus", "comma", "hyphen", "period", "slash", "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "colon", "semicolon", "less", "equal", "greater", "question", "at", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "bracketleft", "backslash", "bracketright", "asciicircum", "underscore", "grave", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "braceleft", "bar", "braceright", "asciitilde", "Adieresis", "Aring", "Ccedilla", "Eacute", "Ntilde", "Odieresis", "Udieresis", "aacute", "agrave", "acircumflex", "adieresis", "atilde", "aring", "ccedilla", "eacute", "egrave", "ecircumflex", "edieresis", "iacute", "igrave", "icircumflex", "idieresis", "ntilde", "oacute", "ograve", "ocircumflex", "odieresis", "otilde", "uacute", "ugrave", "ucircumflex", "udieresis", "dagger", "degree", "cent", "sterling", "section", "bullet", "paragraph", "germandbls", "registered", "copyright", "trademark", "acute", "dieresis", "notequal", "AE", "Oslash", "infinity", "plusminus", "lessequal", "greaterequal", "yen", "mu", "partialdiff", "summation", "product", "pi", "integral", "ordfeminine", "ordmasculine", "Omega", "ae", "oslash", "questiondown", "exclamdown", "logicalnot", "radical", "florin", "approxequal", "Delta", "guillemotleft", "guillemotright", "ellipsis", "nonbreakingspace", "Agrave", "Atilde", "Otilde", "OE", "oe", "endash", "emdash", "quotedblleft", "quotedblright", "quoteleft", "quoteright", "divide", "lozenge", "ydieresis", "Ydieresis", "fraction", "currency", "guilsinglleft", "guilsinglright", "fi", "fl", "daggerdbl", "periodcentered", "quotesinglbase", "quotedblbase", "perthousand", "Acircumflex", "Ecircumflex", "Aacute", "Edieresis", "Egrave", "Iacute", "Icircumflex", "Idieresis", "Igrave", "Oacute", "Ocircumflex", "apple", "Ograve", "Uacute", "Ucircumflex", "Ugrave", "dotlessi", "circumflex", "tilde", "macron", "breve", "dotaccent", "ring", "cedilla", "hungarumlaut", "ogonek", "caron", "Lslash", "lslash", "Scaron", "scaron", "Zcaron", "zcaron", "brokenbar", "Eth", "eth", "Yacute", "yacute", "Thorn", "thorn", "minus", "multiply", "onesuperior", "twosuperior", "threesuperior", "onehalf", "onequarter", "threequarters", "franc", "Gbreve", "gbreve", "Idotaccent", "Scedilla", "scedilla", "Cacute", "cacute", "Ccaron", "ccaron", "dcroat"];
	exports.MacStandardGlyphOrdering = MacStandardGlyphOrdering;

	function getFontType(type, subtype, isStandardFont = false) {
	  switch (type) {
	    case "Type1":
	      if (isStandardFont) {
	        return _util.FontType.TYPE1STANDARD;
	      }

	      return subtype === "Type1C" ? _util.FontType.TYPE1C : _util.FontType.TYPE1;

	    case "CIDFontType0":
	      return subtype === "CIDFontType0C" ? _util.FontType.CIDFONTTYPE0C : _util.FontType.CIDFONTTYPE0;

	    case "OpenType":
	      return _util.FontType.OPENTYPE;

	    case "TrueType":
	      return _util.FontType.TRUETYPE;

	    case "CIDFontType2":
	      return _util.FontType.CIDFONTTYPE2;

	    case "MMType1":
	      return _util.FontType.MMTYPE1;

	    case "Type0":
	      return _util.FontType.TYPE0;

	    default:
	      return _util.FontType.UNKNOWN;
	  }
	}

	function recoverGlyphName(name, glyphsUnicodeMap) {
	  if (glyphsUnicodeMap[name] !== undefined) {
	    return name;
	  }

	  const unicode = (0, _unicode.getUnicodeForGlyph)(name, glyphsUnicodeMap);

	  if (unicode !== -1) {
	    for (const key in glyphsUnicodeMap) {
	      if (glyphsUnicodeMap[key] === unicode) {
	        return key;
	      }
	    }
	  }

	  (0, _util.info)("Unable to recover a standard glyph name for: " + name);
	  return name;
	}

	function type1FontGlyphMapping(properties, builtInEncoding, glyphNames) {
	  const charCodeToGlyphId = Object.create(null);
	  let glyphId, charCode, baseEncoding;
	  const isSymbolicFont = !!(properties.flags & FontFlags.Symbolic);

	  if (properties.isInternalFont) {
	    baseEncoding = builtInEncoding;

	    for (charCode = 0; charCode < baseEncoding.length; charCode++) {
	      glyphId = glyphNames.indexOf(baseEncoding[charCode]);

	      if (glyphId >= 0) {
	        charCodeToGlyphId[charCode] = glyphId;
	      } else {
	        charCodeToGlyphId[charCode] = 0;
	      }
	    }
	  } else if (properties.baseEncodingName) {
	    baseEncoding = (0, _encodings.getEncoding)(properties.baseEncodingName);

	    for (charCode = 0; charCode < baseEncoding.length; charCode++) {
	      glyphId = glyphNames.indexOf(baseEncoding[charCode]);

	      if (glyphId >= 0) {
	        charCodeToGlyphId[charCode] = glyphId;
	      } else {
	        charCodeToGlyphId[charCode] = 0;
	      }
	    }
	  } else if (isSymbolicFont) {
	    for (charCode in builtInEncoding) {
	      charCodeToGlyphId[charCode] = builtInEncoding[charCode];
	    }
	  } else {
	    baseEncoding = _encodings.StandardEncoding;

	    for (charCode = 0; charCode < baseEncoding.length; charCode++) {
	      glyphId = glyphNames.indexOf(baseEncoding[charCode]);

	      if (glyphId >= 0) {
	        charCodeToGlyphId[charCode] = glyphId;
	      } else {
	        charCodeToGlyphId[charCode] = 0;
	      }
	    }
	  }

	  const differences = properties.differences;
	  let glyphsUnicodeMap;

	  if (differences) {
	    for (charCode in differences) {
	      const glyphName = differences[charCode];
	      glyphId = glyphNames.indexOf(glyphName);

	      if (glyphId === -1) {
	        if (!glyphsUnicodeMap) {
	          glyphsUnicodeMap = (0, _glyphlist.getGlyphsUnicode)();
	        }

	        const standardGlyphName = recoverGlyphName(glyphName, glyphsUnicodeMap);

	        if (standardGlyphName !== glyphName) {
	          glyphId = glyphNames.indexOf(standardGlyphName);
	        }
	      }

	      if (glyphId >= 0) {
	        charCodeToGlyphId[charCode] = glyphId;
	      } else {
	        charCodeToGlyphId[charCode] = 0;
	      }
	    }
	  }

	  return charCodeToGlyphId;
	}

	function normalizeFontName(name) {
	  return name.replace(/[,_]/g, "-").replace(/\s/g, "");
	}

	/***/ }),
	/* 39 */
	/***/ ((__unused_webpack_module, __webpack_exports__, __w_pdfjs_require__) => {

	__w_pdfjs_require__.r(__webpack_exports__);
	/* harmony export */ __w_pdfjs_require__.d(__webpack_exports__, {
	/* harmony export */   "getDingbatsGlyphsUnicode": () => (/* binding */ getDingbatsGlyphsUnicode),
	/* harmony export */   "getGlyphsUnicode": () => (/* binding */ getGlyphsUnicode)
	/* harmony export */ });
	/* harmony import */ var _core_utils_js__WEBPACK_IMPORTED_MODULE_0__ = __w_pdfjs_require__(6);

	const getGlyphsUnicode = (0, _core_utils_js__WEBPACK_IMPORTED_MODULE_0__.getArrayLookupTableFactory)(function () {
	 return [
	  "A",
	  0x0041,
	  "AE",
	  0x00c6,
	  "AEacute",
	  0x01fc,
	  "AEmacron",
	  0x01e2,
	  "AEsmall",
	  0xf7e6,
	  "Aacute",
	  0x00c1,
	  "Aacutesmall",
	  0xf7e1,
	  "Abreve",
	  0x0102,
	  "Abreveacute",
	  0x1eae,
	  "Abrevecyrillic",
	  0x04d0,
	  "Abrevedotbelow",
	  0x1eb6,
	  "Abrevegrave",
	  0x1eb0,
	  "Abrevehookabove",
	  0x1eb2,
	  "Abrevetilde",
	  0x1eb4,
	  "Acaron",
	  0x01cd,
	  "Acircle",
	  0x24b6,
	  "Acircumflex",
	  0x00c2,
	  "Acircumflexacute",
	  0x1ea4,
	  "Acircumflexdotbelow",
	  0x1eac,
	  "Acircumflexgrave",
	  0x1ea6,
	  "Acircumflexhookabove",
	  0x1ea8,
	  "Acircumflexsmall",
	  0xf7e2,
	  "Acircumflextilde",
	  0x1eaa,
	  "Acute",
	  0xf6c9,
	  "Acutesmall",
	  0xf7b4,
	  "Acyrillic",
	  0x0410,
	  "Adblgrave",
	  0x0200,
	  "Adieresis",
	  0x00c4,
	  "Adieresiscyrillic",
	  0x04d2,
	  "Adieresismacron",
	  0x01de,
	  "Adieresissmall",
	  0xf7e4,
	  "Adotbelow",
	  0x1ea0,
	  "Adotmacron",
	  0x01e0,
	  "Agrave",
	  0x00c0,
	  "Agravesmall",
	  0xf7e0,
	  "Ahookabove",
	  0x1ea2,
	  "Aiecyrillic",
	  0x04d4,
	  "Ainvertedbreve",
	  0x0202,
	  "Alpha",
	  0x0391,
	  "Alphatonos",
	  0x0386,
	  "Amacron",
	  0x0100,
	  "Amonospace",
	  0xff21,
	  "Aogonek",
	  0x0104,
	  "Aring",
	  0x00c5,
	  "Aringacute",
	  0x01fa,
	  "Aringbelow",
	  0x1e00,
	  "Aringsmall",
	  0xf7e5,
	  "Asmall",
	  0xf761,
	  "Atilde",
	  0x00c3,
	  "Atildesmall",
	  0xf7e3,
	  "Aybarmenian",
	  0x0531,
	  "B",
	  0x0042,
	  "Bcircle",
	  0x24b7,
	  "Bdotaccent",
	  0x1e02,
	  "Bdotbelow",
	  0x1e04,
	  "Becyrillic",
	  0x0411,
	  "Benarmenian",
	  0x0532,
	  "Beta",
	  0x0392,
	  "Bhook",
	  0x0181,
	  "Blinebelow",
	  0x1e06,
	  "Bmonospace",
	  0xff22,
	  "Brevesmall",
	  0xf6f4,
	  "Bsmall",
	  0xf762,
	  "Btopbar",
	  0x0182,
	  "C",
	  0x0043,
	  "Caarmenian",
	  0x053e,
	  "Cacute",
	  0x0106,
	  "Caron",
	  0xf6ca,
	  "Caronsmall",
	  0xf6f5,
	  "Ccaron",
	  0x010c,
	  "Ccedilla",
	  0x00c7,
	  "Ccedillaacute",
	  0x1e08,
	  "Ccedillasmall",
	  0xf7e7,
	  "Ccircle",
	  0x24b8,
	  "Ccircumflex",
	  0x0108,
	  "Cdot",
	  0x010a,
	  "Cdotaccent",
	  0x010a,
	  "Cedillasmall",
	  0xf7b8,
	  "Chaarmenian",
	  0x0549,
	  "Cheabkhasiancyrillic",
	  0x04bc,
	  "Checyrillic",
	  0x0427,
	  "Chedescenderabkhasiancyrillic",
	  0x04be,
	  "Chedescendercyrillic",
	  0x04b6,
	  "Chedieresiscyrillic",
	  0x04f4,
	  "Cheharmenian",
	  0x0543,
	  "Chekhakassiancyrillic",
	  0x04cb,
	  "Cheverticalstrokecyrillic",
	  0x04b8,
	  "Chi",
	  0x03a7,
	  "Chook",
	  0x0187,
	  "Circumflexsmall",
	  0xf6f6,
	  "Cmonospace",
	  0xff23,
	  "Coarmenian",
	  0x0551,
	  "Csmall",
	  0xf763,
	  "D",
	  0x0044,
	  "DZ",
	  0x01f1,
	  "DZcaron",
	  0x01c4,
	  "Daarmenian",
	  0x0534,
	  "Dafrican",
	  0x0189,
	  "Dcaron",
	  0x010e,
	  "Dcedilla",
	  0x1e10,
	  "Dcircle",
	  0x24b9,
	  "Dcircumflexbelow",
	  0x1e12,
	  "Dcroat",
	  0x0110,
	  "Ddotaccent",
	  0x1e0a,
	  "Ddotbelow",
	  0x1e0c,
	  "Decyrillic",
	  0x0414,
	  "Deicoptic",
	  0x03ee,
	  "Delta",
	  0x2206,
	  "Deltagreek",
	  0x0394,
	  "Dhook",
	  0x018a,
	  "Dieresis",
	  0xf6cb,
	  "DieresisAcute",
	  0xf6cc,
	  "DieresisGrave",
	  0xf6cd,
	  "Dieresissmall",
	  0xf7a8,
	  "Digammagreek",
	  0x03dc,
	  "Djecyrillic",
	  0x0402,
	  "Dlinebelow",
	  0x1e0e,
	  "Dmonospace",
	  0xff24,
	  "Dotaccentsmall",
	  0xf6f7,
	  "Dslash",
	  0x0110,
	  "Dsmall",
	  0xf764,
	  "Dtopbar",
	  0x018b,
	  "Dz",
	  0x01f2,
	  "Dzcaron",
	  0x01c5,
	  "Dzeabkhasiancyrillic",
	  0x04e0,
	  "Dzecyrillic",
	  0x0405,
	  "Dzhecyrillic",
	  0x040f,
	  "E",
	  0x0045,
	  "Eacute",
	  0x00c9,
	  "Eacutesmall",
	  0xf7e9,
	  "Ebreve",
	  0x0114,
	  "Ecaron",
	  0x011a,
	  "Ecedillabreve",
	  0x1e1c,
	  "Echarmenian",
	  0x0535,
	  "Ecircle",
	  0x24ba,
	  "Ecircumflex",
	  0x00ca,
	  "Ecircumflexacute",
	  0x1ebe,
	  "Ecircumflexbelow",
	  0x1e18,
	  "Ecircumflexdotbelow",
	  0x1ec6,
	  "Ecircumflexgrave",
	  0x1ec0,
	  "Ecircumflexhookabove",
	  0x1ec2,
	  "Ecircumflexsmall",
	  0xf7ea,
	  "Ecircumflextilde",
	  0x1ec4,
	  "Ecyrillic",
	  0x0404,
	  "Edblgrave",
	  0x0204,
	  "Edieresis",
	  0x00cb,
	  "Edieresissmall",
	  0xf7eb,
	  "Edot",
	  0x0116,
	  "Edotaccent",
	  0x0116,
	  "Edotbelow",
	  0x1eb8,
	  "Efcyrillic",
	  0x0424,
	  "Egrave",
	  0x00c8,
	  "Egravesmall",
	  0xf7e8,
	  "Eharmenian",
	  0x0537,
	  "Ehookabove",
	  0x1eba,
	  "Eightroman",
	  0x2167,
	  "Einvertedbreve",
	  0x0206,
	  "Eiotifiedcyrillic",
	  0x0464,
	  "Elcyrillic",
	  0x041b,
	  "Elevenroman",
	  0x216a,
	  "Emacron",
	  0x0112,
	  "Emacronacute",
	  0x1e16,
	  "Emacrongrave",
	  0x1e14,
	  "Emcyrillic",
	  0x041c,
	  "Emonospace",
	  0xff25,
	  "Encyrillic",
	  0x041d,
	  "Endescendercyrillic",
	  0x04a2,
	  "Eng",
	  0x014a,
	  "Enghecyrillic",
	  0x04a4,
	  "Enhookcyrillic",
	  0x04c7,
	  "Eogonek",
	  0x0118,
	  "Eopen",
	  0x0190,
	  "Epsilon",
	  0x0395,
	  "Epsilontonos",
	  0x0388,
	  "Ercyrillic",
	  0x0420,
	  "Ereversed",
	  0x018e,
	  "Ereversedcyrillic",
	  0x042d,
	  "Escyrillic",
	  0x0421,
	  "Esdescendercyrillic",
	  0x04aa,
	  "Esh",
	  0x01a9,
	  "Esmall",
	  0xf765,
	  "Eta",
	  0x0397,
	  "Etarmenian",
	  0x0538,
	  "Etatonos",
	  0x0389,
	  "Eth",
	  0x00d0,
	  "Ethsmall",
	  0xf7f0,
	  "Etilde",
	  0x1ebc,
	  "Etildebelow",
	  0x1e1a,
	  "Euro",
	  0x20ac,
	  "Ezh",
	  0x01b7,
	  "Ezhcaron",
	  0x01ee,
	  "Ezhreversed",
	  0x01b8,
	  "F",
	  0x0046,
	  "Fcircle",
	  0x24bb,
	  "Fdotaccent",
	  0x1e1e,
	  "Feharmenian",
	  0x0556,
	  "Feicoptic",
	  0x03e4,
	  "Fhook",
	  0x0191,
	  "Fitacyrillic",
	  0x0472,
	  "Fiveroman",
	  0x2164,
	  "Fmonospace",
	  0xff26,
	  "Fourroman",
	  0x2163,
	  "Fsmall",
	  0xf766,
	  "G",
	  0x0047,
	  "GBsquare",
	  0x3387,
	  "Gacute",
	  0x01f4,
	  "Gamma",
	  0x0393,
	  "Gammaafrican",
	  0x0194,
	  "Gangiacoptic",
	  0x03ea,
	  "Gbreve",
	  0x011e,
	  "Gcaron",
	  0x01e6,
	  "Gcedilla",
	  0x0122,
	  "Gcircle",
	  0x24bc,
	  "Gcircumflex",
	  0x011c,
	  "Gcommaaccent",
	  0x0122,
	  "Gdot",
	  0x0120,
	  "Gdotaccent",
	  0x0120,
	  "Gecyrillic",
	  0x0413,
	  "Ghadarmenian",
	  0x0542,
	  "Ghemiddlehookcyrillic",
	  0x0494,
	  "Ghestrokecyrillic",
	  0x0492,
	  "Gheupturncyrillic",
	  0x0490,
	  "Ghook",
	  0x0193,
	  "Gimarmenian",
	  0x0533,
	  "Gjecyrillic",
	  0x0403,
	  "Gmacron",
	  0x1e20,
	  "Gmonospace",
	  0xff27,
	  "Grave",
	  0xf6ce,
	  "Gravesmall",
	  0xf760,
	  "Gsmall",
	  0xf767,
	  "Gsmallhook",
	  0x029b,
	  "Gstroke",
	  0x01e4,
	  "H",
	  0x0048,
	  "H18533",
	  0x25cf,
	  "H18543",
	  0x25aa,
	  "H18551",
	  0x25ab,
	  "H22073",
	  0x25a1,
	  "HPsquare",
	  0x33cb,
	  "Haabkhasiancyrillic",
	  0x04a8,
	  "Hadescendercyrillic",
	  0x04b2,
	  "Hardsigncyrillic",
	  0x042a,
	  "Hbar",
	  0x0126,
	  "Hbrevebelow",
	  0x1e2a,
	  "Hcedilla",
	  0x1e28,
	  "Hcircle",
	  0x24bd,
	  "Hcircumflex",
	  0x0124,
	  "Hdieresis",
	  0x1e26,
	  "Hdotaccent",
	  0x1e22,
	  "Hdotbelow",
	  0x1e24,
	  "Hmonospace",
	  0xff28,
	  "Hoarmenian",
	  0x0540,
	  "Horicoptic",
	  0x03e8,
	  "Hsmall",
	  0xf768,
	  "Hungarumlaut",
	  0xf6cf,
	  "Hungarumlautsmall",
	  0xf6f8,
	  "Hzsquare",
	  0x3390,
	  "I",
	  0x0049,
	  "IAcyrillic",
	  0x042f,
	  "IJ",
	  0x0132,
	  "IUcyrillic",
	  0x042e,
	  "Iacute",
	  0x00cd,
	  "Iacutesmall",
	  0xf7ed,
	  "Ibreve",
	  0x012c,
	  "Icaron",
	  0x01cf,
	  "Icircle",
	  0x24be,
	  "Icircumflex",
	  0x00ce,
	  "Icircumflexsmall",
	  0xf7ee,
	  "Icyrillic",
	  0x0406,
	  "Idblgrave",
	  0x0208,
	  "Idieresis",
	  0x00cf,
	  "Idieresisacute",
	  0x1e2e,
	  "Idieresiscyrillic",
	  0x04e4,
	  "Idieresissmall",
	  0xf7ef,
	  "Idot",
	  0x0130,
	  "Idotaccent",
	  0x0130,
	  "Idotbelow",
	  0x1eca,
	  "Iebrevecyrillic",
	  0x04d6,
	  "Iecyrillic",
	  0x0415,
	  "Ifraktur",
	  0x2111,
	  "Igrave",
	  0x00cc,
	  "Igravesmall",
	  0xf7ec,
	  "Ihookabove",
	  0x1ec8,
	  "Iicyrillic",
	  0x0418,
	  "Iinvertedbreve",
	  0x020a,
	  "Iishortcyrillic",
	  0x0419,
	  "Imacron",
	  0x012a,
	  "Imacroncyrillic",
	  0x04e2,
	  "Imonospace",
	  0xff29,
	  "Iniarmenian",
	  0x053b,
	  "Iocyrillic",
	  0x0401,
	  "Iogonek",
	  0x012e,
	  "Iota",
	  0x0399,
	  "Iotaafrican",
	  0x0196,
	  "Iotadieresis",
	  0x03aa,
	  "Iotatonos",
	  0x038a,
	  "Ismall",
	  0xf769,
	  "Istroke",
	  0x0197,
	  "Itilde",
	  0x0128,
	  "Itildebelow",
	  0x1e2c,
	  "Izhitsacyrillic",
	  0x0474,
	  "Izhitsadblgravecyrillic",
	  0x0476,
	  "J",
	  0x004a,
	  "Jaarmenian",
	  0x0541,
	  "Jcircle",
	  0x24bf,
	  "Jcircumflex",
	  0x0134,
	  "Jecyrillic",
	  0x0408,
	  "Jheharmenian",
	  0x054b,
	  "Jmonospace",
	  0xff2a,
	  "Jsmall",
	  0xf76a,
	  "K",
	  0x004b,
	  "KBsquare",
	  0x3385,
	  "KKsquare",
	  0x33cd,
	  "Kabashkircyrillic",
	  0x04a0,
	  "Kacute",
	  0x1e30,
	  "Kacyrillic",
	  0x041a,
	  "Kadescendercyrillic",
	  0x049a,
	  "Kahookcyrillic",
	  0x04c3,
	  "Kappa",
	  0x039a,
	  "Kastrokecyrillic",
	  0x049e,
	  "Kaverticalstrokecyrillic",
	  0x049c,
	  "Kcaron",
	  0x01e8,
	  "Kcedilla",
	  0x0136,
	  "Kcircle",
	  0x24c0,
	  "Kcommaaccent",
	  0x0136,
	  "Kdotbelow",
	  0x1e32,
	  "Keharmenian",
	  0x0554,
	  "Kenarmenian",
	  0x053f,
	  "Khacyrillic",
	  0x0425,
	  "Kheicoptic",
	  0x03e6,
	  "Khook",
	  0x0198,
	  "Kjecyrillic",
	  0x040c,
	  "Klinebelow",
	  0x1e34,
	  "Kmonospace",
	  0xff2b,
	  "Koppacyrillic",
	  0x0480,
	  "Koppagreek",
	  0x03de,
	  "Ksicyrillic",
	  0x046e,
	  "Ksmall",
	  0xf76b,
	  "L",
	  0x004c,
	  "LJ",
	  0x01c7,
	  "LL",
	  0xf6bf,
	  "Lacute",
	  0x0139,
	  "Lambda",
	  0x039b,
	  "Lcaron",
	  0x013d,
	  "Lcedilla",
	  0x013b,
	  "Lcircle",
	  0x24c1,
	  "Lcircumflexbelow",
	  0x1e3c,
	  "Lcommaaccent",
	  0x013b,
	  "Ldot",
	  0x013f,
	  "Ldotaccent",
	  0x013f,
	  "Ldotbelow",
	  0x1e36,
	  "Ldotbelowmacron",
	  0x1e38,
	  "Liwnarmenian",
	  0x053c,
	  "Lj",
	  0x01c8,
	  "Ljecyrillic",
	  0x0409,
	  "Llinebelow",
	  0x1e3a,
	  "Lmonospace",
	  0xff2c,
	  "Lslash",
	  0x0141,
	  "Lslashsmall",
	  0xf6f9,
	  "Lsmall",
	  0xf76c,
	  "M",
	  0x004d,
	  "MBsquare",
	  0x3386,
	  "Macron",
	  0xf6d0,
	  "Macronsmall",
	  0xf7af,
	  "Macute",
	  0x1e3e,
	  "Mcircle",
	  0x24c2,
	  "Mdotaccent",
	  0x1e40,
	  "Mdotbelow",
	  0x1e42,
	  "Menarmenian",
	  0x0544,
	  "Mmonospace",
	  0xff2d,
	  "Msmall",
	  0xf76d,
	  "Mturned",
	  0x019c,
	  "Mu",
	  0x039c,
	  "N",
	  0x004e,
	  "NJ",
	  0x01ca,
	  "Nacute",
	  0x0143,
	  "Ncaron",
	  0x0147,
	  "Ncedilla",
	  0x0145,
	  "Ncircle",
	  0x24c3,
	  "Ncircumflexbelow",
	  0x1e4a,
	  "Ncommaaccent",
	  0x0145,
	  "Ndotaccent",
	  0x1e44,
	  "Ndotbelow",
	  0x1e46,
	  "Nhookleft",
	  0x019d,
	  "Nineroman",
	  0x2168,
	  "Nj",
	  0x01cb,
	  "Njecyrillic",
	  0x040a,
	  "Nlinebelow",
	  0x1e48,
	  "Nmonospace",
	  0xff2e,
	  "Nowarmenian",
	  0x0546,
	  "Nsmall",
	  0xf76e,
	  "Ntilde",
	  0x00d1,
	  "Ntildesmall",
	  0xf7f1,
	  "Nu",
	  0x039d,
	  "O",
	  0x004f,
	  "OE",
	  0x0152,
	  "OEsmall",
	  0xf6fa,
	  "Oacute",
	  0x00d3,
	  "Oacutesmall",
	  0xf7f3,
	  "Obarredcyrillic",
	  0x04e8,
	  "Obarreddieresiscyrillic",
	  0x04ea,
	  "Obreve",
	  0x014e,
	  "Ocaron",
	  0x01d1,
	  "Ocenteredtilde",
	  0x019f,
	  "Ocircle",
	  0x24c4,
	  "Ocircumflex",
	  0x00d4,
	  "Ocircumflexacute",
	  0x1ed0,
	  "Ocircumflexdotbelow",
	  0x1ed8,
	  "Ocircumflexgrave",
	  0x1ed2,
	  "Ocircumflexhookabove",
	  0x1ed4,
	  "Ocircumflexsmall",
	  0xf7f4,
	  "Ocircumflextilde",
	  0x1ed6,
	  "Ocyrillic",
	  0x041e,
	  "Odblacute",
	  0x0150,
	  "Odblgrave",
	  0x020c,
	  "Odieresis",
	  0x00d6,
	  "Odieresiscyrillic",
	  0x04e6,
	  "Odieresissmall",
	  0xf7f6,
	  "Odotbelow",
	  0x1ecc,
	  "Ogoneksmall",
	  0xf6fb,
	  "Ograve",
	  0x00d2,
	  "Ogravesmall",
	  0xf7f2,
	  "Oharmenian",
	  0x0555,
	  "Ohm",
	  0x2126,
	  "Ohookabove",
	  0x1ece,
	  "Ohorn",
	  0x01a0,
	  "Ohornacute",
	  0x1eda,
	  "Ohorndotbelow",
	  0x1ee2,
	  "Ohorngrave",
	  0x1edc,
	  "Ohornhookabove",
	  0x1ede,
	  "Ohorntilde",
	  0x1ee0,
	  "Ohungarumlaut",
	  0x0150,
	  "Oi",
	  0x01a2,
	  "Oinvertedbreve",
	  0x020e,
	  "Omacron",
	  0x014c,
	  "Omacronacute",
	  0x1e52,
	  "Omacrongrave",
	  0x1e50,
	  "Omega",
	  0x2126,
	  "Omegacyrillic",
	  0x0460,
	  "Omegagreek",
	  0x03a9,
	  "Omegaroundcyrillic",
	  0x047a,
	  "Omegatitlocyrillic",
	  0x047c,
	  "Omegatonos",
	  0x038f,
	  "Omicron",
	  0x039f,
	  "Omicrontonos",
	  0x038c,
	  "Omonospace",
	  0xff2f,
	  "Oneroman",
	  0x2160,
	  "Oogonek",
	  0x01ea,
	  "Oogonekmacron",
	  0x01ec,
	  "Oopen",
	  0x0186,
	  "Oslash",
	  0x00d8,
	  "Oslashacute",
	  0x01fe,
	  "Oslashsmall",
	  0xf7f8,
	  "Osmall",
	  0xf76f,
	  "Ostrokeacute",
	  0x01fe,
	  "Otcyrillic",
	  0x047e,
	  "Otilde",
	  0x00d5,
	  "Otildeacute",
	  0x1e4c,
	  "Otildedieresis",
	  0x1e4e,
	  "Otildesmall",
	  0xf7f5,
	  "P",
	  0x0050,
	  "Pacute",
	  0x1e54,
	  "Pcircle",
	  0x24c5,
	  "Pdotaccent",
	  0x1e56,
	  "Pecyrillic",
	  0x041f,
	  "Peharmenian",
	  0x054a,
	  "Pemiddlehookcyrillic",
	  0x04a6,
	  "Phi",
	  0x03a6,
	  "Phook",
	  0x01a4,
	  "Pi",
	  0x03a0,
	  "Piwrarmenian",
	  0x0553,
	  "Pmonospace",
	  0xff30,
	  "Psi",
	  0x03a8,
	  "Psicyrillic",
	  0x0470,
	  "Psmall",
	  0xf770,
	  "Q",
	  0x0051,
	  "Qcircle",
	  0x24c6,
	  "Qmonospace",
	  0xff31,
	  "Qsmall",
	  0xf771,
	  "R",
	  0x0052,
	  "Raarmenian",
	  0x054c,
	  "Racute",
	  0x0154,
	  "Rcaron",
	  0x0158,
	  "Rcedilla",
	  0x0156,
	  "Rcircle",
	  0x24c7,
	  "Rcommaaccent",
	  0x0156,
	  "Rdblgrave",
	  0x0210,
	  "Rdotaccent",
	  0x1e58,
	  "Rdotbelow",
	  0x1e5a,
	  "Rdotbelowmacron",
	  0x1e5c,
	  "Reharmenian",
	  0x0550,
	  "Rfraktur",
	  0x211c,
	  "Rho",
	  0x03a1,
	  "Ringsmall",
	  0xf6fc,
	  "Rinvertedbreve",
	  0x0212,
	  "Rlinebelow",
	  0x1e5e,
	  "Rmonospace",
	  0xff32,
	  "Rsmall",
	  0xf772,
	  "Rsmallinverted",
	  0x0281,
	  "Rsmallinvertedsuperior",
	  0x02b6,
	  "S",
	  0x0053,
	  "SF010000",
	  0x250c,
	  "SF020000",
	  0x2514,
	  "SF030000",
	  0x2510,
	  "SF040000",
	  0x2518,
	  "SF050000",
	  0x253c,
	  "SF060000",
	  0x252c,
	  "SF070000",
	  0x2534,
	  "SF080000",
	  0x251c,
	  "SF090000",
	  0x2524,
	  "SF100000",
	  0x2500,
	  "SF110000",
	  0x2502,
	  "SF190000",
	  0x2561,
	  "SF200000",
	  0x2562,
	  "SF210000",
	  0x2556,
	  "SF220000",
	  0x2555,
	  "SF230000",
	  0x2563,
	  "SF240000",
	  0x2551,
	  "SF250000",
	  0x2557,
	  "SF260000",
	  0x255d,
	  "SF270000",
	  0x255c,
	  "SF280000",
	  0x255b,
	  "SF360000",
	  0x255e,
	  "SF370000",
	  0x255f,
	  "SF380000",
	  0x255a,
	  "SF390000",
	  0x2554,
	  "SF400000",
	  0x2569,
	  "SF410000",
	  0x2566,
	  "SF420000",
	  0x2560,
	  "SF430000",
	  0x2550,
	  "SF440000",
	  0x256c,
	  "SF450000",
	  0x2567,
	  "SF460000",
	  0x2568,
	  "SF470000",
	  0x2564,
	  "SF480000",
	  0x2565,
	  "SF490000",
	  0x2559,
	  "SF500000",
	  0x2558,
	  "SF510000",
	  0x2552,
	  "SF520000",
	  0x2553,
	  "SF530000",
	  0x256b,
	  "SF540000",
	  0x256a,
	  "Sacute",
	  0x015a,
	  "Sacutedotaccent",
	  0x1e64,
	  "Sampigreek",
	  0x03e0,
	  "Scaron",
	  0x0160,
	  "Scarondotaccent",
	  0x1e66,
	  "Scaronsmall",
	  0xf6fd,
	  "Scedilla",
	  0x015e,
	  "Schwa",
	  0x018f,
	  "Schwacyrillic",
	  0x04d8,
	  "Schwadieresiscyrillic",
	  0x04da,
	  "Scircle",
	  0x24c8,
	  "Scircumflex",
	  0x015c,
	  "Scommaaccent",
	  0x0218,
	  "Sdotaccent",
	  0x1e60,
	  "Sdotbelow",
	  0x1e62,
	  "Sdotbelowdotaccent",
	  0x1e68,
	  "Seharmenian",
	  0x054d,
	  "Sevenroman",
	  0x2166,
	  "Shaarmenian",
	  0x0547,
	  "Shacyrillic",
	  0x0428,
	  "Shchacyrillic",
	  0x0429,
	  "Sheicoptic",
	  0x03e2,
	  "Shhacyrillic",
	  0x04ba,
	  "Shimacoptic",
	  0x03ec,
	  "Sigma",
	  0x03a3,
	  "Sixroman",
	  0x2165,
	  "Smonospace",
	  0xff33,
	  "Softsigncyrillic",
	  0x042c,
	  "Ssmall",
	  0xf773,
	  "Stigmagreek",
	  0x03da,
	  "T",
	  0x0054,
	  "Tau",
	  0x03a4,
	  "Tbar",
	  0x0166,
	  "Tcaron",
	  0x0164,
	  "Tcedilla",
	  0x0162,
	  "Tcircle",
	  0x24c9,
	  "Tcircumflexbelow",
	  0x1e70,
	  "Tcommaaccent",
	  0x0162,
	  "Tdotaccent",
	  0x1e6a,
	  "Tdotbelow",
	  0x1e6c,
	  "Tecyrillic",
	  0x0422,
	  "Tedescendercyrillic",
	  0x04ac,
	  "Tenroman",
	  0x2169,
	  "Tetsecyrillic",
	  0x04b4,
	  "Theta",
	  0x0398,
	  "Thook",
	  0x01ac,
	  "Thorn",
	  0x00de,
	  "Thornsmall",
	  0xf7fe,
	  "Threeroman",
	  0x2162,
	  "Tildesmall",
	  0xf6fe,
	  "Tiwnarmenian",
	  0x054f,
	  "Tlinebelow",
	  0x1e6e,
	  "Tmonospace",
	  0xff34,
	  "Toarmenian",
	  0x0539,
	  "Tonefive",
	  0x01bc,
	  "Tonesix",
	  0x0184,
	  "Tonetwo",
	  0x01a7,
	  "Tretroflexhook",
	  0x01ae,
	  "Tsecyrillic",
	  0x0426,
	  "Tshecyrillic",
	  0x040b,
	  "Tsmall",
	  0xf774,
	  "Twelveroman",
	  0x216b,
	  "Tworoman",
	  0x2161,
	  "U",
	  0x0055,
	  "Uacute",
	  0x00da,
	  "Uacutesmall",
	  0xf7fa,
	  "Ubreve",
	  0x016c,
	  "Ucaron",
	  0x01d3,
	  "Ucircle",
	  0x24ca,
	  "Ucircumflex",
	  0x00db,
	  "Ucircumflexbelow",
	  0x1e76,
	  "Ucircumflexsmall",
	  0xf7fb,
	  "Ucyrillic",
	  0x0423,
	  "Udblacute",
	  0x0170,
	  "Udblgrave",
	  0x0214,
	  "Udieresis",
	  0x00dc,
	  "Udieresisacute",
	  0x01d7,
	  "Udieresisbelow",
	  0x1e72,
	  "Udieresiscaron",
	  0x01d9,
	  "Udieresiscyrillic",
	  0x04f0,
	  "Udieresisgrave",
	  0x01db,
	  "Udieresismacron",
	  0x01d5,
	  "Udieresissmall",
	  0xf7fc,
	  "Udotbelow",
	  0x1ee4,
	  "Ugrave",
	  0x00d9,
	  "Ugravesmall",
	  0xf7f9,
	  "Uhookabove",
	  0x1ee6,
	  "Uhorn",
	  0x01af,
	  "Uhornacute",
	  0x1ee8,
	  "Uhorndotbelow",
	  0x1ef0,
	  "Uhorngrave",
	  0x1eea,
	  "Uhornhookabove",
	  0x1eec,
	  "Uhorntilde",
	  0x1eee,
	  "Uhungarumlaut",
	  0x0170,
	  "Uhungarumlautcyrillic",
	  0x04f2,
	  "Uinvertedbreve",
	  0x0216,
	  "Ukcyrillic",
	  0x0478,
	  "Umacron",
	  0x016a,
	  "Umacroncyrillic",
	  0x04ee,
	  "Umacrondieresis",
	  0x1e7a,
	  "Umonospace",
	  0xff35,
	  "Uogonek",
	  0x0172,
	  "Upsilon",
	  0x03a5,
	  "Upsilon1",
	  0x03d2,
	  "Upsilonacutehooksymbolgreek",
	  0x03d3,
	  "Upsilonafrican",
	  0x01b1,
	  "Upsilondieresis",
	  0x03ab,
	  "Upsilondieresishooksymbolgreek",
	  0x03d4,
	  "Upsilonhooksymbol",
	  0x03d2,
	  "Upsilontonos",
	  0x038e,
	  "Uring",
	  0x016e,
	  "Ushortcyrillic",
	  0x040e,
	  "Usmall",
	  0xf775,
	  "Ustraightcyrillic",
	  0x04ae,
	  "Ustraightstrokecyrillic",
	  0x04b0,
	  "Utilde",
	  0x0168,
	  "Utildeacute",
	  0x1e78,
	  "Utildebelow",
	  0x1e74,
	  "V",
	  0x0056,
	  "Vcircle",
	  0x24cb,
	  "Vdotbelow",
	  0x1e7e,
	  "Vecyrillic",
	  0x0412,
	  "Vewarmenian",
	  0x054e,
	  "Vhook",
	  0x01b2,
	  "Vmonospace",
	  0xff36,
	  "Voarmenian",
	  0x0548,
	  "Vsmall",
	  0xf776,
	  "Vtilde",
	  0x1e7c,
	  "W",
	  0x0057,
	  "Wacute",
	  0x1e82,
	  "Wcircle",
	  0x24cc,
	  "Wcircumflex",
	  0x0174,
	  "Wdieresis",
	  0x1e84,
	  "Wdotaccent",
	  0x1e86,
	  "Wdotbelow",
	  0x1e88,
	  "Wgrave",
	  0x1e80,
	  "Wmonospace",
	  0xff37,
	  "Wsmall",
	  0xf777,
	  "X",
	  0x0058,
	  "Xcircle",
	  0x24cd,
	  "Xdieresis",
	  0x1e8c,
	  "Xdotaccent",
	  0x1e8a,
	  "Xeharmenian",
	  0x053d,
	  "Xi",
	  0x039e,
	  "Xmonospace",
	  0xff38,
	  "Xsmall",
	  0xf778,
	  "Y",
	  0x0059,
	  "Yacute",
	  0x00dd,
	  "Yacutesmall",
	  0xf7fd,
	  "Yatcyrillic",
	  0x0462,
	  "Ycircle",
	  0x24ce,
	  "Ycircumflex",
	  0x0176,
	  "Ydieresis",
	  0x0178,
	  "Ydieresissmall",
	  0xf7ff,
	  "Ydotaccent",
	  0x1e8e,
	  "Ydotbelow",
	  0x1ef4,
	  "Yericyrillic",
	  0x042b,
	  "Yerudieresiscyrillic",
	  0x04f8,
	  "Ygrave",
	  0x1ef2,
	  "Yhook",
	  0x01b3,
	  "Yhookabove",
	  0x1ef6,
	  "Yiarmenian",
	  0x0545,
	  "Yicyrillic",
	  0x0407,
	  "Yiwnarmenian",
	  0x0552,
	  "Ymonospace",
	  0xff39,
	  "Ysmall",
	  0xf779,
	  "Ytilde",
	  0x1ef8,
	  "Yusbigcyrillic",
	  0x046a,
	  "Yusbigiotifiedcyrillic",
	  0x046c,
	  "Yuslittlecyrillic",
	  0x0466,
	  "Yuslittleiotifiedcyrillic",
	  0x0468,
	  "Z",
	  0x005a,
	  "Zaarmenian",
	  0x0536,
	  "Zacute",
	  0x0179,
	  "Zcaron",
	  0x017d,
	  "Zcaronsmall",
	  0xf6ff,
	  "Zcircle",
	  0x24cf,
	  "Zcircumflex",
	  0x1e90,
	  "Zdot",
	  0x017b,
	  "Zdotaccent",
	  0x017b,
	  "Zdotbelow",
	  0x1e92,
	  "Zecyrillic",
	  0x0417,
	  "Zedescendercyrillic",
	  0x0498,
	  "Zedieresiscyrillic",
	  0x04de,
	  "Zeta",
	  0x0396,
	  "Zhearmenian",
	  0x053a,
	  "Zhebrevecyrillic",
	  0x04c1,
	  "Zhecyrillic",
	  0x0416,
	  "Zhedescendercyrillic",
	  0x0496,
	  "Zhedieresiscyrillic",
	  0x04dc,
	  "Zlinebelow",
	  0x1e94,
	  "Zmonospace",
	  0xff3a,
	  "Zsmall",
	  0xf77a,
	  "Zstroke",
	  0x01b5,
	  "a",
	  0x0061,
	  "aabengali",
	  0x0986,
	  "aacute",
	  0x00e1,
	  "aadeva",
	  0x0906,
	  "aagujarati",
	  0x0a86,
	  "aagurmukhi",
	  0x0a06,
	  "aamatragurmukhi",
	  0x0a3e,
	  "aarusquare",
	  0x3303,
	  "aavowelsignbengali",
	  0x09be,
	  "aavowelsigndeva",
	  0x093e,
	  "aavowelsigngujarati",
	  0x0abe,
	  "abbreviationmarkarmenian",
	  0x055f,
	  "abbreviationsigndeva",
	  0x0970,
	  "abengali",
	  0x0985,
	  "abopomofo",
	  0x311a,
	  "abreve",
	  0x0103,
	  "abreveacute",
	  0x1eaf,
	  "abrevecyrillic",
	  0x04d1,
	  "abrevedotbelow",
	  0x1eb7,
	  "abrevegrave",
	  0x1eb1,
	  "abrevehookabove",
	  0x1eb3,
	  "abrevetilde",
	  0x1eb5,
	  "acaron",
	  0x01ce,
	  "acircle",
	  0x24d0,
	  "acircumflex",
	  0x00e2,
	  "acircumflexacute",
	  0x1ea5,
	  "acircumflexdotbelow",
	  0x1ead,
	  "acircumflexgrave",
	  0x1ea7,
	  "acircumflexhookabove",
	  0x1ea9,
	  "acircumflextilde",
	  0x1eab,
	  "acute",
	  0x00b4,
	  "acutebelowcmb",
	  0x0317,
	  "acutecmb",
	  0x0301,
	  "acutecomb",
	  0x0301,
	  "acutedeva",
	  0x0954,
	  "acutelowmod",
	  0x02cf,
	  "acutetonecmb",
	  0x0341,
	  "acyrillic",
	  0x0430,
	  "adblgrave",
	  0x0201,
	  "addakgurmukhi",
	  0x0a71,
	  "adeva",
	  0x0905,
	  "adieresis",
	  0x00e4,
	  "adieresiscyrillic",
	  0x04d3,
	  "adieresismacron",
	  0x01df,
	  "adotbelow",
	  0x1ea1,
	  "adotmacron",
	  0x01e1,
	  "ae",
	  0x00e6,
	  "aeacute",
	  0x01fd,
	  "aekorean",
	  0x3150,
	  "aemacron",
	  0x01e3,
	  "afii00208",
	  0x2015,
	  "afii08941",
	  0x20a4,
	  "afii10017",
	  0x0410,
	  "afii10018",
	  0x0411,
	  "afii10019",
	  0x0412,
	  "afii10020",
	  0x0413,
	  "afii10021",
	  0x0414,
	  "afii10022",
	  0x0415,
	  "afii10023",
	  0x0401,
	  "afii10024",
	  0x0416,
	  "afii10025",
	  0x0417,
	  "afii10026",
	  0x0418,
	  "afii10027",
	  0x0419,
	  "afii10028",
	  0x041a,
	  "afii10029",
	  0x041b,
	  "afii10030",
	  0x041c,
	  "afii10031",
	  0x041d,
	  "afii10032",
	  0x041e,
	  "afii10033",
	  0x041f,
	  "afii10034",
	  0x0420,
	  "afii10035",
	  0x0421,
	  "afii10036",
	  0x0422,
	  "afii10037",
	  0x0423,
	  "afii10038",
	  0x0424,
	  "afii10039",
	  0x0425,
	  "afii10040",
	  0x0426,
	  "afii10041",
	  0x0427,
	  "afii10042",
	  0x0428,
	  "afii10043",
	  0x0429,
	  "afii10044",
	  0x042a,
	  "afii10045",
	  0x042b,
	  "afii10046",
	  0x042c,
	  "afii10047",
	  0x042d,
	  "afii10048",
	  0x042e,
	  "afii10049",
	  0x042f,
	  "afii10050",
	  0x0490,
	  "afii10051",
	  0x0402,
	  "afii10052",
	  0x0403,
	  "afii10053",
	  0x0404,
	  "afii10054",
	  0x0405,
	  "afii10055",
	  0x0406,
	  "afii10056",
	  0x0407,
	  "afii10057",
	  0x0408,
	  "afii10058",
	  0x0409,
	  "afii10059",
	  0x040a,
	  "afii10060",
	  0x040b,
	  "afii10061",
	  0x040c,
	  "afii10062",
	  0x040e,
	  "afii10063",
	  0xf6c4,
	  "afii10064",
	  0xf6c5,
	  "afii10065",
	  0x0430,
	  "afii10066",
	  0x0431,
	  "afii10067",
	  0x0432,
	  "afii10068",
	  0x0433,
	  "afii10069",
	  0x0434,
	  "afii10070",
	  0x0435,
	  "afii10071",
	  0x0451,
	  "afii10072",
	  0x0436,
	  "afii10073",
	  0x0437,
	  "afii10074",
	  0x0438,
	  "afii10075",
	  0x0439,
	  "afii10076",
	  0x043a,
	  "afii10077",
	  0x043b,
	  "afii10078",
	  0x043c,
	  "afii10079",
	  0x043d,
	  "afii10080",
	  0x043e,
	  "afii10081",
	  0x043f,
	  "afii10082",
	  0x0440,
	  "afii10083",
	  0x0441,
	  "afii10084",
	  0x0442,
	  "afii10085",
	  0x0443,
	  "afii10086",
	  0x0444,
	  "afii10087",
	  0x0445,
	  "afii10088",
	  0x0446,
	  "afii10089",
	  0x0447,
	  "afii10090",
	  0x0448,
	  "afii10091",
	  0x0449,
	  "afii10092",
	  0x044a,
	  "afii10093",
	  0x044b,
	  "afii10094",
	  0x044c,
	  "afii10095",
	  0x044d,
	  "afii10096",
	  0x044e,
	  "afii10097",
	  0x044f,
	  "afii10098",
	  0x0491,
	  "afii10099",
	  0x0452,
	  "afii10100",
	  0x0453,
	  "afii10101",
	  0x0454,
	  "afii10102",
	  0x0455,
	  "afii10103",
	  0x0456,
	  "afii10104",
	  0x0457,
	  "afii10105",
	  0x0458,
	  "afii10106",
	  0x0459,
	  "afii10107",
	  0x045a,
	  "afii10108",
	  0x045b,
	  "afii10109",
	  0x045c,
	  "afii10110",
	  0x045e,
	  "afii10145",
	  0x040f,
	  "afii10146",
	  0x0462,
	  "afii10147",
	  0x0472,
	  "afii10148",
	  0x0474,
	  "afii10192",
	  0xf6c6,
	  "afii10193",
	  0x045f,
	  "afii10194",
	  0x0463,
	  "afii10195",
	  0x0473,
	  "afii10196",
	  0x0475,
	  "afii10831",
	  0xf6c7,
	  "afii10832",
	  0xf6c8,
	  "afii10846",
	  0x04d9,
	  "afii299",
	  0x200e,
	  "afii300",
	  0x200f,
	  "afii301",
	  0x200d,
	  "afii57381",
	  0x066a,
	  "afii57388",
	  0x060c,
	  "afii57392",
	  0x0660,
	  "afii57393",
	  0x0661,
	  "afii57394",
	  0x0662,
	  "afii57395",
	  0x0663,
	  "afii57396",
	  0x0664,
	  "afii57397",
	  0x0665,
	  "afii57398",
	  0x0666,
	  "afii57399",
	  0x0667,
	  "afii57400",
	  0x0668,
	  "afii57401",
	  0x0669,
	  "afii57403",
	  0x061b,
	  "afii57407",
	  0x061f,
	  "afii57409",
	  0x0621,
	  "afii57410",
	  0x0622,
	  "afii57411",
	  0x0623,
	  "afii57412",
	  0x0624,
	  "afii57413",
	  0x0625,
	  "afii57414",
	  0x0626,
	  "afii57415",
	  0x0627,
	  "afii57416",
	  0x0628,
	  "afii57417",
	  0x0629,
	  "afii57418",
	  0x062a,
	  "afii57419",
	  0x062b,
	  "afii57420",
	  0x062c,
	  "afii57421",
	  0x062d,
	  "afii57422",
	  0x062e,
	  "afii57423",
	  0x062f,
	  "afii57424",
	  0x0630,
	  "afii57425",
	  0x0631,
	  "afii57426",
	  0x0632,
	  "afii57427",
	  0x0633,
	  "afii57428",
	  0x0634,
	  "afii57429",
	  0x0635,
	  "afii57430",
	  0x0636,
	  "afii57431",
	  0x0637,
	  "afii57432",
	  0x0638,
	  "afii57433",
	  0x0639,
	  "afii57434",
	  0x063a,
	  "afii57440",
	  0x0640,
	  "afii57441",
	  0x0641,
	  "afii57442",
	  0x0642,
	  "afii57443",
	  0x0643,
	  "afii57444",
	  0x0644,
	  "afii57445",
	  0x0645,
	  "afii57446",
	  0x0646,
	  "afii57448",
	  0x0648,
	  "afii57449",
	  0x0649,
	  "afii57450",
	  0x064a,
	  "afii57451",
	  0x064b,
	  "afii57452",
	  0x064c,
	  "afii57453",
	  0x064d,
	  "afii57454",
	  0x064e,
	  "afii57455",
	  0x064f,
	  "afii57456",
	  0x0650,
	  "afii57457",
	  0x0651,
	  "afii57458",
	  0x0652,
	  "afii57470",
	  0x0647,
	  "afii57505",
	  0x06a4,
	  "afii57506",
	  0x067e,
	  "afii57507",
	  0x0686,
	  "afii57508",
	  0x0698,
	  "afii57509",
	  0x06af,
	  "afii57511",
	  0x0679,
	  "afii57512",
	  0x0688,
	  "afii57513",
	  0x0691,
	  "afii57514",
	  0x06ba,
	  "afii57519",
	  0x06d2,
	  "afii57534",
	  0x06d5,
	  "afii57636",
	  0x20aa,
	  "afii57645",
	  0x05be,
	  "afii57658",
	  0x05c3,
	  "afii57664",
	  0x05d0,
	  "afii57665",
	  0x05d1,
	  "afii57666",
	  0x05d2,
	  "afii57667",
	  0x05d3,
	  "afii57668",
	  0x05d4,
	  "afii57669",
	  0x05d5,
	  "afii57670",
	  0x05d6,
	  "afii57671",
	  0x05d7,
	  "afii57672",
	  0x05d8,
	  "afii57673",
	  0x05d9,
	  "afii57674",
	  0x05da,
	  "afii57675",
	  0x05db,
	  "afii57676",
	  0x05dc,
	  "afii57677",
	  0x05dd,
	  "afii57678",
	  0x05de,
	  "afii57679",
	  0x05df,
	  "afii57680",
	  0x05e0,
	  "afii57681",
	  0x05e1,
	  "afii57682",
	  0x05e2,
	  "afii57683",
	  0x05e3,
	  "afii57684",
	  0x05e4,
	  "afii57685",
	  0x05e5,
	  "afii57686",
	  0x05e6,
	  "afii57687",
	  0x05e7,
	  "afii57688",
	  0x05e8,
	  "afii57689",
	  0x05e9,
	  "afii57690",
	  0x05ea,
	  "afii57694",
	  0xfb2a,
	  "afii57695",
	  0xfb2b,
	  "afii57700",
	  0xfb4b,
	  "afii57705",
	  0xfb1f,
	  "afii57716",
	  0x05f0,
	  "afii57717",
	  0x05f1,
	  "afii57718",
	  0x05f2,
	  "afii57723",
	  0xfb35,
	  "afii57793",
	  0x05b4,
	  "afii57794",
	  0x05b5,
	  "afii57795",
	  0x05b6,
	  "afii57796",
	  0x05bb,
	  "afii57797",
	  0x05b8,
	  "afii57798",
	  0x05b7,
	  "afii57799",
	  0x05b0,
	  "afii57800",
	  0x05b2,
	  "afii57801",
	  0x05b1,
	  "afii57802",
	  0x05b3,
	  "afii57803",
	  0x05c2,
	  "afii57804",
	  0x05c1,
	  "afii57806",
	  0x05b9,
	  "afii57807",
	  0x05bc,
	  "afii57839",
	  0x05bd,
	  "afii57841",
	  0x05bf,
	  "afii57842",
	  0x05c0,
	  "afii57929",
	  0x02bc,
	  "afii61248",
	  0x2105,
	  "afii61289",
	  0x2113,
	  "afii61352",
	  0x2116,
	  "afii61573",
	  0x202c,
	  "afii61574",
	  0x202d,
	  "afii61575",
	  0x202e,
	  "afii61664",
	  0x200c,
	  "afii63167",
	  0x066d,
	  "afii64937",
	  0x02bd,
	  "agrave",
	  0x00e0,
	  "agujarati",
	  0x0a85,
	  "agurmukhi",
	  0x0a05,
	  "ahiragana",
	  0x3042,
	  "ahookabove",
	  0x1ea3,
	  "aibengali",
	  0x0990,
	  "aibopomofo",
	  0x311e,
	  "aideva",
	  0x0910,
	  "aiecyrillic",
	  0x04d5,
	  "aigujarati",
	  0x0a90,
	  "aigurmukhi",
	  0x0a10,
	  "aimatragurmukhi",
	  0x0a48,
	  "ainarabic",
	  0x0639,
	  "ainfinalarabic",
	  0xfeca,
	  "aininitialarabic",
	  0xfecb,
	  "ainmedialarabic",
	  0xfecc,
	  "ainvertedbreve",
	  0x0203,
	  "aivowelsignbengali",
	  0x09c8,
	  "aivowelsigndeva",
	  0x0948,
	  "aivowelsigngujarati",
	  0x0ac8,
	  "akatakana",
	  0x30a2,
	  "akatakanahalfwidth",
	  0xff71,
	  "akorean",
	  0x314f,
	  "alef",
	  0x05d0,
	  "alefarabic",
	  0x0627,
	  "alefdageshhebrew",
	  0xfb30,
	  "aleffinalarabic",
	  0xfe8e,
	  "alefhamzaabovearabic",
	  0x0623,
	  "alefhamzaabovefinalarabic",
	  0xfe84,
	  "alefhamzabelowarabic",
	  0x0625,
	  "alefhamzabelowfinalarabic",
	  0xfe88,
	  "alefhebrew",
	  0x05d0,
	  "aleflamedhebrew",
	  0xfb4f,
	  "alefmaddaabovearabic",
	  0x0622,
	  "alefmaddaabovefinalarabic",
	  0xfe82,
	  "alefmaksuraarabic",
	  0x0649,
	  "alefmaksurafinalarabic",
	  0xfef0,
	  "alefmaksurainitialarabic",
	  0xfef3,
	  "alefmaksuramedialarabic",
	  0xfef4,
	  "alefpatahhebrew",
	  0xfb2e,
	  "alefqamatshebrew",
	  0xfb2f,
	  "aleph",
	  0x2135,
	  "allequal",
	  0x224c,
	  "alpha",
	  0x03b1,
	  "alphatonos",
	  0x03ac,
	  "amacron",
	  0x0101,
	  "amonospace",
	  0xff41,
	  "ampersand",
	  0x0026,
	  "ampersandmonospace",
	  0xff06,
	  "ampersandsmall",
	  0xf726,
	  "amsquare",
	  0x33c2,
	  "anbopomofo",
	  0x3122,
	  "angbopomofo",
	  0x3124,
	  "angbracketleft",
	  0x3008,
	  "angbracketright",
	  0x3009,
	  "angkhankhuthai",
	  0x0e5a,
	  "angle",
	  0x2220,
	  "anglebracketleft",
	  0x3008,
	  "anglebracketleftvertical",
	  0xfe3f,
	  "anglebracketright",
	  0x3009,
	  "anglebracketrightvertical",
	  0xfe40,
	  "angleleft",
	  0x2329,
	  "angleright",
	  0x232a,
	  "angstrom",
	  0x212b,
	  "anoteleia",
	  0x0387,
	  "anudattadeva",
	  0x0952,
	  "anusvarabengali",
	  0x0982,
	  "anusvaradeva",
	  0x0902,
	  "anusvaragujarati",
	  0x0a82,
	  "aogonek",
	  0x0105,
	  "apaatosquare",
	  0x3300,
	  "aparen",
	  0x249c,
	  "apostrophearmenian",
	  0x055a,
	  "apostrophemod",
	  0x02bc,
	  "apple",
	  0xf8ff,
	  "approaches",
	  0x2250,
	  "approxequal",
	  0x2248,
	  "approxequalorimage",
	  0x2252,
	  "approximatelyequal",
	  0x2245,
	  "araeaekorean",
	  0x318e,
	  "araeakorean",
	  0x318d,
	  "arc",
	  0x2312,
	  "arighthalfring",
	  0x1e9a,
	  "aring",
	  0x00e5,
	  "aringacute",
	  0x01fb,
	  "aringbelow",
	  0x1e01,
	  "arrowboth",
	  0x2194,
	  "arrowdashdown",
	  0x21e3,
	  "arrowdashleft",
	  0x21e0,
	  "arrowdashright",
	  0x21e2,
	  "arrowdashup",
	  0x21e1,
	  "arrowdblboth",
	  0x21d4,
	  "arrowdbldown",
	  0x21d3,
	  "arrowdblleft",
	  0x21d0,
	  "arrowdblright",
	  0x21d2,
	  "arrowdblup",
	  0x21d1,
	  "arrowdown",
	  0x2193,
	  "arrowdownleft",
	  0x2199,
	  "arrowdownright",
	  0x2198,
	  "arrowdownwhite",
	  0x21e9,
	  "arrowheaddownmod",
	  0x02c5,
	  "arrowheadleftmod",
	  0x02c2,
	  "arrowheadrightmod",
	  0x02c3,
	  "arrowheadupmod",
	  0x02c4,
	  "arrowhorizex",
	  0xf8e7,
	  "arrowleft",
	  0x2190,
	  "arrowleftdbl",
	  0x21d0,
	  "arrowleftdblstroke",
	  0x21cd,
	  "arrowleftoverright",
	  0x21c6,
	  "arrowleftwhite",
	  0x21e6,
	  "arrowright",
	  0x2192,
	  "arrowrightdblstroke",
	  0x21cf,
	  "arrowrightheavy",
	  0x279e,
	  "arrowrightoverleft",
	  0x21c4,
	  "arrowrightwhite",
	  0x21e8,
	  "arrowtableft",
	  0x21e4,
	  "arrowtabright",
	  0x21e5,
	  "arrowup",
	  0x2191,
	  "arrowupdn",
	  0x2195,
	  "arrowupdnbse",
	  0x21a8,
	  "arrowupdownbase",
	  0x21a8,
	  "arrowupleft",
	  0x2196,
	  "arrowupleftofdown",
	  0x21c5,
	  "arrowupright",
	  0x2197,
	  "arrowupwhite",
	  0x21e7,
	  "arrowvertex",
	  0xf8e6,
	  "asciicircum",
	  0x005e,
	  "asciicircummonospace",
	  0xff3e,
	  "asciitilde",
	  0x007e,
	  "asciitildemonospace",
	  0xff5e,
	  "ascript",
	  0x0251,
	  "ascriptturned",
	  0x0252,
	  "asmallhiragana",
	  0x3041,
	  "asmallkatakana",
	  0x30a1,
	  "asmallkatakanahalfwidth",
	  0xff67,
	  "asterisk",
	  0x002a,
	  "asteriskaltonearabic",
	  0x066d,
	  "asteriskarabic",
	  0x066d,
	  "asteriskmath",
	  0x2217,
	  "asteriskmonospace",
	  0xff0a,
	  "asterisksmall",
	  0xfe61,
	  "asterism",
	  0x2042,
	  "asuperior",
	  0xf6e9,
	  "asymptoticallyequal",
	  0x2243,
	  "at",
	  0x0040,
	  "atilde",
	  0x00e3,
	  "atmonospace",
	  0xff20,
	  "atsmall",
	  0xfe6b,
	  "aturned",
	  0x0250,
	  "aubengali",
	  0x0994,
	  "aubopomofo",
	  0x3120,
	  "audeva",
	  0x0914,
	  "augujarati",
	  0x0a94,
	  "augurmukhi",
	  0x0a14,
	  "aulengthmarkbengali",
	  0x09d7,
	  "aumatragurmukhi",
	  0x0a4c,
	  "auvowelsignbengali",
	  0x09cc,
	  "auvowelsigndeva",
	  0x094c,
	  "auvowelsigngujarati",
	  0x0acc,
	  "avagrahadeva",
	  0x093d,
	  "aybarmenian",
	  0x0561,
	  "ayin",
	  0x05e2,
	  "ayinaltonehebrew",
	  0xfb20,
	  "ayinhebrew",
	  0x05e2,
	  "b",
	  0x0062,
	  "babengali",
	  0x09ac,
	  "backslash",
	  0x005c,
	  "backslashmonospace",
	  0xff3c,
	  "badeva",
	  0x092c,
	  "bagujarati",
	  0x0aac,
	  "bagurmukhi",
	  0x0a2c,
	  "bahiragana",
	  0x3070,
	  "bahtthai",
	  0x0e3f,
	  "bakatakana",
	  0x30d0,
	  "bar",
	  0x007c,
	  "barmonospace",
	  0xff5c,
	  "bbopomofo",
	  0x3105,
	  "bcircle",
	  0x24d1,
	  "bdotaccent",
	  0x1e03,
	  "bdotbelow",
	  0x1e05,
	  "beamedsixteenthnotes",
	  0x266c,
	  "because",
	  0x2235,
	  "becyrillic",
	  0x0431,
	  "beharabic",
	  0x0628,
	  "behfinalarabic",
	  0xfe90,
	  "behinitialarabic",
	  0xfe91,
	  "behiragana",
	  0x3079,
	  "behmedialarabic",
	  0xfe92,
	  "behmeeminitialarabic",
	  0xfc9f,
	  "behmeemisolatedarabic",
	  0xfc08,
	  "behnoonfinalarabic",
	  0xfc6d,
	  "bekatakana",
	  0x30d9,
	  "benarmenian",
	  0x0562,
	  "bet",
	  0x05d1,
	  "beta",
	  0x03b2,
	  "betasymbolgreek",
	  0x03d0,
	  "betdagesh",
	  0xfb31,
	  "betdageshhebrew",
	  0xfb31,
	  "bethebrew",
	  0x05d1,
	  "betrafehebrew",
	  0xfb4c,
	  "bhabengali",
	  0x09ad,
	  "bhadeva",
	  0x092d,
	  "bhagujarati",
	  0x0aad,
	  "bhagurmukhi",
	  0x0a2d,
	  "bhook",
	  0x0253,
	  "bihiragana",
	  0x3073,
	  "bikatakana",
	  0x30d3,
	  "bilabialclick",
	  0x0298,
	  "bindigurmukhi",
	  0x0a02,
	  "birusquare",
	  0x3331,
	  "blackcircle",
	  0x25cf,
	  "blackdiamond",
	  0x25c6,
	  "blackdownpointingtriangle",
	  0x25bc,
	  "blackleftpointingpointer",
	  0x25c4,
	  "blackleftpointingtriangle",
	  0x25c0,
	  "blacklenticularbracketleft",
	  0x3010,
	  "blacklenticularbracketleftvertical",
	  0xfe3b,
	  "blacklenticularbracketright",
	  0x3011,
	  "blacklenticularbracketrightvertical",
	  0xfe3c,
	  "blacklowerlefttriangle",
	  0x25e3,
	  "blacklowerrighttriangle",
	  0x25e2,
	  "blackrectangle",
	  0x25ac,
	  "blackrightpointingpointer",
	  0x25ba,
	  "blackrightpointingtriangle",
	  0x25b6,
	  "blacksmallsquare",
	  0x25aa,
	  "blacksmilingface",
	  0x263b,
	  "blacksquare",
	  0x25a0,
	  "blackstar",
	  0x2605,
	  "blackupperlefttriangle",
	  0x25e4,
	  "blackupperrighttriangle",
	  0x25e5,
	  "blackuppointingsmalltriangle",
	  0x25b4,
	  "blackuppointingtriangle",
	  0x25b2,
	  "blank",
	  0x2423,
	  "blinebelow",
	  0x1e07,
	  "block",
	  0x2588,
	  "bmonospace",
	  0xff42,
	  "bobaimaithai",
	  0x0e1a,
	  "bohiragana",
	  0x307c,
	  "bokatakana",
	  0x30dc,
	  "bparen",
	  0x249d,
	  "bqsquare",
	  0x33c3,
	  "braceex",
	  0xf8f4,
	  "braceleft",
	  0x007b,
	  "braceleftbt",
	  0xf8f3,
	  "braceleftmid",
	  0xf8f2,
	  "braceleftmonospace",
	  0xff5b,
	  "braceleftsmall",
	  0xfe5b,
	  "bracelefttp",
	  0xf8f1,
	  "braceleftvertical",
	  0xfe37,
	  "braceright",
	  0x007d,
	  "bracerightbt",
	  0xf8fe,
	  "bracerightmid",
	  0xf8fd,
	  "bracerightmonospace",
	  0xff5d,
	  "bracerightsmall",
	  0xfe5c,
	  "bracerighttp",
	  0xf8fc,
	  "bracerightvertical",
	  0xfe38,
	  "bracketleft",
	  0x005b,
	  "bracketleftbt",
	  0xf8f0,
	  "bracketleftex",
	  0xf8ef,
	  "bracketleftmonospace",
	  0xff3b,
	  "bracketlefttp",
	  0xf8ee,
	  "bracketright",
	  0x005d,
	  "bracketrightbt",
	  0xf8fb,
	  "bracketrightex",
	  0xf8fa,
	  "bracketrightmonospace",
	  0xff3d,
	  "bracketrighttp",
	  0xf8f9,
	  "breve",
	  0x02d8,
	  "brevebelowcmb",
	  0x032e,
	  "brevecmb",
	  0x0306,
	  "breveinvertedbelowcmb",
	  0x032f,
	  "breveinvertedcmb",
	  0x0311,
	  "breveinverteddoublecmb",
	  0x0361,
	  "bridgebelowcmb",
	  0x032a,
	  "bridgeinvertedbelowcmb",
	  0x033a,
	  "brokenbar",
	  0x00a6,
	  "bstroke",
	  0x0180,
	  "bsuperior",
	  0xf6ea,
	  "btopbar",
	  0x0183,
	  "buhiragana",
	  0x3076,
	  "bukatakana",
	  0x30d6,
	  "bullet",
	  0x2022,
	  "bulletinverse",
	  0x25d8,
	  "bulletoperator",
	  0x2219,
	  "bullseye",
	  0x25ce,
	  "c",
	  0x0063,
	  "caarmenian",
	  0x056e,
	  "cabengali",
	  0x099a,
	  "cacute",
	  0x0107,
	  "cadeva",
	  0x091a,
	  "cagujarati",
	  0x0a9a,
	  "cagurmukhi",
	  0x0a1a,
	  "calsquare",
	  0x3388,
	  "candrabindubengali",
	  0x0981,
	  "candrabinducmb",
	  0x0310,
	  "candrabindudeva",
	  0x0901,
	  "candrabindugujarati",
	  0x0a81,
	  "capslock",
	  0x21ea,
	  "careof",
	  0x2105,
	  "caron",
	  0x02c7,
	  "caronbelowcmb",
	  0x032c,
	  "caroncmb",
	  0x030c,
	  "carriagereturn",
	  0x21b5,
	  "cbopomofo",
	  0x3118,
	  "ccaron",
	  0x010d,
	  "ccedilla",
	  0x00e7,
	  "ccedillaacute",
	  0x1e09,
	  "ccircle",
	  0x24d2,
	  "ccircumflex",
	  0x0109,
	  "ccurl",
	  0x0255,
	  "cdot",
	  0x010b,
	  "cdotaccent",
	  0x010b,
	  "cdsquare",
	  0x33c5,
	  "cedilla",
	  0x00b8,
	  "cedillacmb",
	  0x0327,
	  "cent",
	  0x00a2,
	  "centigrade",
	  0x2103,
	  "centinferior",
	  0xf6df,
	  "centmonospace",
	  0xffe0,
	  "centoldstyle",
	  0xf7a2,
	  "centsuperior",
	  0xf6e0,
	  "chaarmenian",
	  0x0579,
	  "chabengali",
	  0x099b,
	  "chadeva",
	  0x091b,
	  "chagujarati",
	  0x0a9b,
	  "chagurmukhi",
	  0x0a1b,
	  "chbopomofo",
	  0x3114,
	  "cheabkhasiancyrillic",
	  0x04bd,
	  "checkmark",
	  0x2713,
	  "checyrillic",
	  0x0447,
	  "chedescenderabkhasiancyrillic",
	  0x04bf,
	  "chedescendercyrillic",
	  0x04b7,
	  "chedieresiscyrillic",
	  0x04f5,
	  "cheharmenian",
	  0x0573,
	  "chekhakassiancyrillic",
	  0x04cc,
	  "cheverticalstrokecyrillic",
	  0x04b9,
	  "chi",
	  0x03c7,
	  "chieuchacirclekorean",
	  0x3277,
	  "chieuchaparenkorean",
	  0x3217,
	  "chieuchcirclekorean",
	  0x3269,
	  "chieuchkorean",
	  0x314a,
	  "chieuchparenkorean",
	  0x3209,
	  "chochangthai",
	  0x0e0a,
	  "chochanthai",
	  0x0e08,
	  "chochingthai",
	  0x0e09,
	  "chochoethai",
	  0x0e0c,
	  "chook",
	  0x0188,
	  "cieucacirclekorean",
	  0x3276,
	  "cieucaparenkorean",
	  0x3216,
	  "cieuccirclekorean",
	  0x3268,
	  "cieuckorean",
	  0x3148,
	  "cieucparenkorean",
	  0x3208,
	  "cieucuparenkorean",
	  0x321c,
	  "circle",
	  0x25cb,
	  "circlecopyrt",
	  0x00a9,
	  "circlemultiply",
	  0x2297,
	  "circleot",
	  0x2299,
	  "circleplus",
	  0x2295,
	  "circlepostalmark",
	  0x3036,
	  "circlewithlefthalfblack",
	  0x25d0,
	  "circlewithrighthalfblack",
	  0x25d1,
	  "circumflex",
	  0x02c6,
	  "circumflexbelowcmb",
	  0x032d,
	  "circumflexcmb",
	  0x0302,
	  "clear",
	  0x2327,
	  "clickalveolar",
	  0x01c2,
	  "clickdental",
	  0x01c0,
	  "clicklateral",
	  0x01c1,
	  "clickretroflex",
	  0x01c3,
	  "club",
	  0x2663,
	  "clubsuitblack",
	  0x2663,
	  "clubsuitwhite",
	  0x2667,
	  "cmcubedsquare",
	  0x33a4,
	  "cmonospace",
	  0xff43,
	  "cmsquaredsquare",
	  0x33a0,
	  "coarmenian",
	  0x0581,
	  "colon",
	  0x003a,
	  "colonmonetary",
	  0x20a1,
	  "colonmonospace",
	  0xff1a,
	  "colonsign",
	  0x20a1,
	  "colonsmall",
	  0xfe55,
	  "colontriangularhalfmod",
	  0x02d1,
	  "colontriangularmod",
	  0x02d0,
	  "comma",
	  0x002c,
	  "commaabovecmb",
	  0x0313,
	  "commaaboverightcmb",
	  0x0315,
	  "commaaccent",
	  0xf6c3,
	  "commaarabic",
	  0x060c,
	  "commaarmenian",
	  0x055d,
	  "commainferior",
	  0xf6e1,
	  "commamonospace",
	  0xff0c,
	  "commareversedabovecmb",
	  0x0314,
	  "commareversedmod",
	  0x02bd,
	  "commasmall",
	  0xfe50,
	  "commasuperior",
	  0xf6e2,
	  "commaturnedabovecmb",
	  0x0312,
	  "commaturnedmod",
	  0x02bb,
	  "compass",
	  0x263c,
	  "congruent",
	  0x2245,
	  "contourintegral",
	  0x222e,
	  "control",
	  0x2303,
	  "controlACK",
	  0x0006,
	  "controlBEL",
	  0x0007,
	  "controlBS",
	  0x0008,
	  "controlCAN",
	  0x0018,
	  "controlCR",
	  0x000d,
	  "controlDC1",
	  0x0011,
	  "controlDC2",
	  0x0012,
	  "controlDC3",
	  0x0013,
	  "controlDC4",
	  0x0014,
	  "controlDEL",
	  0x007f,
	  "controlDLE",
	  0x0010,
	  "controlEM",
	  0x0019,
	  "controlENQ",
	  0x0005,
	  "controlEOT",
	  0x0004,
	  "controlESC",
	  0x001b,
	  "controlETB",
	  0x0017,
	  "controlETX",
	  0x0003,
	  "controlFF",
	  0x000c,
	  "controlFS",
	  0x001c,
	  "controlGS",
	  0x001d,
	  "controlHT",
	  0x0009,
	  "controlLF",
	  0x000a,
	  "controlNAK",
	  0x0015,
	  "controlNULL",
	  0x0000,
	  "controlRS",
	  0x001e,
	  "controlSI",
	  0x000f,
	  "controlSO",
	  0x000e,
	  "controlSOT",
	  0x0002,
	  "controlSTX",
	  0x0001,
	  "controlSUB",
	  0x001a,
	  "controlSYN",
	  0x0016,
	  "controlUS",
	  0x001f,
	  "controlVT",
	  0x000b,
	  "copyright",
	  0x00a9,
	  "copyrightsans",
	  0xf8e9,
	  "copyrightserif",
	  0xf6d9,
	  "cornerbracketleft",
	  0x300c,
	  "cornerbracketlefthalfwidth",
	  0xff62,
	  "cornerbracketleftvertical",
	  0xfe41,
	  "cornerbracketright",
	  0x300d,
	  "cornerbracketrighthalfwidth",
	  0xff63,
	  "cornerbracketrightvertical",
	  0xfe42,
	  "corporationsquare",
	  0x337f,
	  "cosquare",
	  0x33c7,
	  "coverkgsquare",
	  0x33c6,
	  "cparen",
	  0x249e,
	  "cruzeiro",
	  0x20a2,
	  "cstretched",
	  0x0297,
	  "curlyand",
	  0x22cf,
	  "curlyor",
	  0x22ce,
	  "currency",
	  0x00a4,
	  "cyrBreve",
	  0xf6d1,
	  "cyrFlex",
	  0xf6d2,
	  "cyrbreve",
	  0xf6d4,
	  "cyrflex",
	  0xf6d5,
	  "d",
	  0x0064,
	  "daarmenian",
	  0x0564,
	  "dabengali",
	  0x09a6,
	  "dadarabic",
	  0x0636,
	  "dadeva",
	  0x0926,
	  "dadfinalarabic",
	  0xfebe,
	  "dadinitialarabic",
	  0xfebf,
	  "dadmedialarabic",
	  0xfec0,
	  "dagesh",
	  0x05bc,
	  "dageshhebrew",
	  0x05bc,
	  "dagger",
	  0x2020,
	  "daggerdbl",
	  0x2021,
	  "dagujarati",
	  0x0aa6,
	  "dagurmukhi",
	  0x0a26,
	  "dahiragana",
	  0x3060,
	  "dakatakana",
	  0x30c0,
	  "dalarabic",
	  0x062f,
	  "dalet",
	  0x05d3,
	  "daletdagesh",
	  0xfb33,
	  "daletdageshhebrew",
	  0xfb33,
	  "dalethebrew",
	  0x05d3,
	  "dalfinalarabic",
	  0xfeaa,
	  "dammaarabic",
	  0x064f,
	  "dammalowarabic",
	  0x064f,
	  "dammatanaltonearabic",
	  0x064c,
	  "dammatanarabic",
	  0x064c,
	  "danda",
	  0x0964,
	  "dargahebrew",
	  0x05a7,
	  "dargalefthebrew",
	  0x05a7,
	  "dasiapneumatacyrilliccmb",
	  0x0485,
	  "dblGrave",
	  0xf6d3,
	  "dblanglebracketleft",
	  0x300a,
	  "dblanglebracketleftvertical",
	  0xfe3d,
	  "dblanglebracketright",
	  0x300b,
	  "dblanglebracketrightvertical",
	  0xfe3e,
	  "dblarchinvertedbelowcmb",
	  0x032b,
	  "dblarrowleft",
	  0x21d4,
	  "dblarrowright",
	  0x21d2,
	  "dbldanda",
	  0x0965,
	  "dblgrave",
	  0xf6d6,
	  "dblgravecmb",
	  0x030f,
	  "dblintegral",
	  0x222c,
	  "dbllowline",
	  0x2017,
	  "dbllowlinecmb",
	  0x0333,
	  "dbloverlinecmb",
	  0x033f,
	  "dblprimemod",
	  0x02ba,
	  "dblverticalbar",
	  0x2016,
	  "dblverticallineabovecmb",
	  0x030e,
	  "dbopomofo",
	  0x3109,
	  "dbsquare",
	  0x33c8,
	  "dcaron",
	  0x010f,
	  "dcedilla",
	  0x1e11,
	  "dcircle",
	  0x24d3,
	  "dcircumflexbelow",
	  0x1e13,
	  "dcroat",
	  0x0111,
	  "ddabengali",
	  0x09a1,
	  "ddadeva",
	  0x0921,
	  "ddagujarati",
	  0x0aa1,
	  "ddagurmukhi",
	  0x0a21,
	  "ddalarabic",
	  0x0688,
	  "ddalfinalarabic",
	  0xfb89,
	  "dddhadeva",
	  0x095c,
	  "ddhabengali",
	  0x09a2,
	  "ddhadeva",
	  0x0922,
	  "ddhagujarati",
	  0x0aa2,
	  "ddhagurmukhi",
	  0x0a22,
	  "ddotaccent",
	  0x1e0b,
	  "ddotbelow",
	  0x1e0d,
	  "decimalseparatorarabic",
	  0x066b,
	  "decimalseparatorpersian",
	  0x066b,
	  "decyrillic",
	  0x0434,
	  "degree",
	  0x00b0,
	  "dehihebrew",
	  0x05ad,
	  "dehiragana",
	  0x3067,
	  "deicoptic",
	  0x03ef,
	  "dekatakana",
	  0x30c7,
	  "deleteleft",
	  0x232b,
	  "deleteright",
	  0x2326,
	  "delta",
	  0x03b4,
	  "deltaturned",
	  0x018d,
	  "denominatorminusonenumeratorbengali",
	  0x09f8,
	  "dezh",
	  0x02a4,
	  "dhabengali",
	  0x09a7,
	  "dhadeva",
	  0x0927,
	  "dhagujarati",
	  0x0aa7,
	  "dhagurmukhi",
	  0x0a27,
	  "dhook",
	  0x0257,
	  "dialytikatonos",
	  0x0385,
	  "dialytikatonoscmb",
	  0x0344,
	  "diamond",
	  0x2666,
	  "diamondsuitwhite",
	  0x2662,
	  "dieresis",
	  0x00a8,
	  "dieresisacute",
	  0xf6d7,
	  "dieresisbelowcmb",
	  0x0324,
	  "dieresiscmb",
	  0x0308,
	  "dieresisgrave",
	  0xf6d8,
	  "dieresistonos",
	  0x0385,
	  "dihiragana",
	  0x3062,
	  "dikatakana",
	  0x30c2,
	  "dittomark",
	  0x3003,
	  "divide",
	  0x00f7,
	  "divides",
	  0x2223,
	  "divisionslash",
	  0x2215,
	  "djecyrillic",
	  0x0452,
	  "dkshade",
	  0x2593,
	  "dlinebelow",
	  0x1e0f,
	  "dlsquare",
	  0x3397,
	  "dmacron",
	  0x0111,
	  "dmonospace",
	  0xff44,
	  "dnblock",
	  0x2584,
	  "dochadathai",
	  0x0e0e,
	  "dodekthai",
	  0x0e14,
	  "dohiragana",
	  0x3069,
	  "dokatakana",
	  0x30c9,
	  "dollar",
	  0x0024,
	  "dollarinferior",
	  0xf6e3,
	  "dollarmonospace",
	  0xff04,
	  "dollaroldstyle",
	  0xf724,
	  "dollarsmall",
	  0xfe69,
	  "dollarsuperior",
	  0xf6e4,
	  "dong",
	  0x20ab,
	  "dorusquare",
	  0x3326,
	  "dotaccent",
	  0x02d9,
	  "dotaccentcmb",
	  0x0307,
	  "dotbelowcmb",
	  0x0323,
	  "dotbelowcomb",
	  0x0323,
	  "dotkatakana",
	  0x30fb,
	  "dotlessi",
	  0x0131,
	  "dotlessj",
	  0xf6be,
	  "dotlessjstrokehook",
	  0x0284,
	  "dotmath",
	  0x22c5,
	  "dottedcircle",
	  0x25cc,
	  "doubleyodpatah",
	  0xfb1f,
	  "doubleyodpatahhebrew",
	  0xfb1f,
	  "downtackbelowcmb",
	  0x031e,
	  "downtackmod",
	  0x02d5,
	  "dparen",
	  0x249f,
	  "dsuperior",
	  0xf6eb,
	  "dtail",
	  0x0256,
	  "dtopbar",
	  0x018c,
	  "duhiragana",
	  0x3065,
	  "dukatakana",
	  0x30c5,
	  "dz",
	  0x01f3,
	  "dzaltone",
	  0x02a3,
	  "dzcaron",
	  0x01c6,
	  "dzcurl",
	  0x02a5,
	  "dzeabkhasiancyrillic",
	  0x04e1,
	  "dzecyrillic",
	  0x0455,
	  "dzhecyrillic",
	  0x045f,
	  "e",
	  0x0065,
	  "eacute",
	  0x00e9,
	  "earth",
	  0x2641,
	  "ebengali",
	  0x098f,
	  "ebopomofo",
	  0x311c,
	  "ebreve",
	  0x0115,
	  "ecandradeva",
	  0x090d,
	  "ecandragujarati",
	  0x0a8d,
	  "ecandravowelsigndeva",
	  0x0945,
	  "ecandravowelsigngujarati",
	  0x0ac5,
	  "ecaron",
	  0x011b,
	  "ecedillabreve",
	  0x1e1d,
	  "echarmenian",
	  0x0565,
	  "echyiwnarmenian",
	  0x0587,
	  "ecircle",
	  0x24d4,
	  "ecircumflex",
	  0x00ea,
	  "ecircumflexacute",
	  0x1ebf,
	  "ecircumflexbelow",
	  0x1e19,
	  "ecircumflexdotbelow",
	  0x1ec7,
	  "ecircumflexgrave",
	  0x1ec1,
	  "ecircumflexhookabove",
	  0x1ec3,
	  "ecircumflextilde",
	  0x1ec5,
	  "ecyrillic",
	  0x0454,
	  "edblgrave",
	  0x0205,
	  "edeva",
	  0x090f,
	  "edieresis",
	  0x00eb,
	  "edot",
	  0x0117,
	  "edotaccent",
	  0x0117,
	  "edotbelow",
	  0x1eb9,
	  "eegurmukhi",
	  0x0a0f,
	  "eematragurmukhi",
	  0x0a47,
	  "efcyrillic",
	  0x0444,
	  "egrave",
	  0x00e8,
	  "egujarati",
	  0x0a8f,
	  "eharmenian",
	  0x0567,
	  "ehbopomofo",
	  0x311d,
	  "ehiragana",
	  0x3048,
	  "ehookabove",
	  0x1ebb,
	  "eibopomofo",
	  0x311f,
	  "eight",
	  0x0038,
	  "eightarabic",
	  0x0668,
	  "eightbengali",
	  0x09ee,
	  "eightcircle",
	  0x2467,
	  "eightcircleinversesansserif",
	  0x2791,
	  "eightdeva",
	  0x096e,
	  "eighteencircle",
	  0x2471,
	  "eighteenparen",
	  0x2485,
	  "eighteenperiod",
	  0x2499,
	  "eightgujarati",
	  0x0aee,
	  "eightgurmukhi",
	  0x0a6e,
	  "eighthackarabic",
	  0x0668,
	  "eighthangzhou",
	  0x3028,
	  "eighthnotebeamed",
	  0x266b,
	  "eightideographicparen",
	  0x3227,
	  "eightinferior",
	  0x2088,
	  "eightmonospace",
	  0xff18,
	  "eightoldstyle",
	  0xf738,
	  "eightparen",
	  0x247b,
	  "eightperiod",
	  0x248f,
	  "eightpersian",
	  0x06f8,
	  "eightroman",
	  0x2177,
	  "eightsuperior",
	  0x2078,
	  "eightthai",
	  0x0e58,
	  "einvertedbreve",
	  0x0207,
	  "eiotifiedcyrillic",
	  0x0465,
	  "ekatakana",
	  0x30a8,
	  "ekatakanahalfwidth",
	  0xff74,
	  "ekonkargurmukhi",
	  0x0a74,
	  "ekorean",
	  0x3154,
	  "elcyrillic",
	  0x043b,
	  "element",
	  0x2208,
	  "elevencircle",
	  0x246a,
	  "elevenparen",
	  0x247e,
	  "elevenperiod",
	  0x2492,
	  "elevenroman",
	  0x217a,
	  "ellipsis",
	  0x2026,
	  "ellipsisvertical",
	  0x22ee,
	  "emacron",
	  0x0113,
	  "emacronacute",
	  0x1e17,
	  "emacrongrave",
	  0x1e15,
	  "emcyrillic",
	  0x043c,
	  "emdash",
	  0x2014,
	  "emdashvertical",
	  0xfe31,
	  "emonospace",
	  0xff45,
	  "emphasismarkarmenian",
	  0x055b,
	  "emptyset",
	  0x2205,
	  "enbopomofo",
	  0x3123,
	  "encyrillic",
	  0x043d,
	  "endash",
	  0x2013,
	  "endashvertical",
	  0xfe32,
	  "endescendercyrillic",
	  0x04a3,
	  "eng",
	  0x014b,
	  "engbopomofo",
	  0x3125,
	  "enghecyrillic",
	  0x04a5,
	  "enhookcyrillic",
	  0x04c8,
	  "enspace",
	  0x2002,
	  "eogonek",
	  0x0119,
	  "eokorean",
	  0x3153,
	  "eopen",
	  0x025b,
	  "eopenclosed",
	  0x029a,
	  "eopenreversed",
	  0x025c,
	  "eopenreversedclosed",
	  0x025e,
	  "eopenreversedhook",
	  0x025d,
	  "eparen",
	  0x24a0,
	  "epsilon",
	  0x03b5,
	  "epsilontonos",
	  0x03ad,
	  "equal",
	  0x003d,
	  "equalmonospace",
	  0xff1d,
	  "equalsmall",
	  0xfe66,
	  "equalsuperior",
	  0x207c,
	  "equivalence",
	  0x2261,
	  "erbopomofo",
	  0x3126,
	  "ercyrillic",
	  0x0440,
	  "ereversed",
	  0x0258,
	  "ereversedcyrillic",
	  0x044d,
	  "escyrillic",
	  0x0441,
	  "esdescendercyrillic",
	  0x04ab,
	  "esh",
	  0x0283,
	  "eshcurl",
	  0x0286,
	  "eshortdeva",
	  0x090e,
	  "eshortvowelsigndeva",
	  0x0946,
	  "eshreversedloop",
	  0x01aa,
	  "eshsquatreversed",
	  0x0285,
	  "esmallhiragana",
	  0x3047,
	  "esmallkatakana",
	  0x30a7,
	  "esmallkatakanahalfwidth",
	  0xff6a,
	  "estimated",
	  0x212e,
	  "esuperior",
	  0xf6ec,
	  "eta",
	  0x03b7,
	  "etarmenian",
	  0x0568,
	  "etatonos",
	  0x03ae,
	  "eth",
	  0x00f0,
	  "etilde",
	  0x1ebd,
	  "etildebelow",
	  0x1e1b,
	  "etnahtafoukhhebrew",
	  0x0591,
	  "etnahtafoukhlefthebrew",
	  0x0591,
	  "etnahtahebrew",
	  0x0591,
	  "etnahtalefthebrew",
	  0x0591,
	  "eturned",
	  0x01dd,
	  "eukorean",
	  0x3161,
	  "euro",
	  0x20ac,
	  "evowelsignbengali",
	  0x09c7,
	  "evowelsigndeva",
	  0x0947,
	  "evowelsigngujarati",
	  0x0ac7,
	  "exclam",
	  0x0021,
	  "exclamarmenian",
	  0x055c,
	  "exclamdbl",
	  0x203c,
	  "exclamdown",
	  0x00a1,
	  "exclamdownsmall",
	  0xf7a1,
	  "exclammonospace",
	  0xff01,
	  "exclamsmall",
	  0xf721,
	  "existential",
	  0x2203,
	  "ezh",
	  0x0292,
	  "ezhcaron",
	  0x01ef,
	  "ezhcurl",
	  0x0293,
	  "ezhreversed",
	  0x01b9,
	  "ezhtail",
	  0x01ba,
	  "f",
	  0x0066,
	  "fadeva",
	  0x095e,
	  "fagurmukhi",
	  0x0a5e,
	  "fahrenheit",
	  0x2109,
	  "fathaarabic",
	  0x064e,
	  "fathalowarabic",
	  0x064e,
	  "fathatanarabic",
	  0x064b,
	  "fbopomofo",
	  0x3108,
	  "fcircle",
	  0x24d5,
	  "fdotaccent",
	  0x1e1f,
	  "feharabic",
	  0x0641,
	  "feharmenian",
	  0x0586,
	  "fehfinalarabic",
	  0xfed2,
	  "fehinitialarabic",
	  0xfed3,
	  "fehmedialarabic",
	  0xfed4,
	  "feicoptic",
	  0x03e5,
	  "female",
	  0x2640,
	  "ff",
	  0xfb00,
	  "f_f",
	  0xfb00,
	  "ffi",
	  0xfb03,
	  "ffl",
	  0xfb04,
	  "fi",
	  0xfb01,
	  "fifteencircle",
	  0x246e,
	  "fifteenparen",
	  0x2482,
	  "fifteenperiod",
	  0x2496,
	  "figuredash",
	  0x2012,
	  "filledbox",
	  0x25a0,
	  "filledrect",
	  0x25ac,
	  "finalkaf",
	  0x05da,
	  "finalkafdagesh",
	  0xfb3a,
	  "finalkafdageshhebrew",
	  0xfb3a,
	  "finalkafhebrew",
	  0x05da,
	  "finalmem",
	  0x05dd,
	  "finalmemhebrew",
	  0x05dd,
	  "finalnun",
	  0x05df,
	  "finalnunhebrew",
	  0x05df,
	  "finalpe",
	  0x05e3,
	  "finalpehebrew",
	  0x05e3,
	  "finaltsadi",
	  0x05e5,
	  "finaltsadihebrew",
	  0x05e5,
	  "firsttonechinese",
	  0x02c9,
	  "fisheye",
	  0x25c9,
	  "fitacyrillic",
	  0x0473,
	  "five",
	  0x0035,
	  "fivearabic",
	  0x0665,
	  "fivebengali",
	  0x09eb,
	  "fivecircle",
	  0x2464,
	  "fivecircleinversesansserif",
	  0x278e,
	  "fivedeva",
	  0x096b,
	  "fiveeighths",
	  0x215d,
	  "fivegujarati",
	  0x0aeb,
	  "fivegurmukhi",
	  0x0a6b,
	  "fivehackarabic",
	  0x0665,
	  "fivehangzhou",
	  0x3025,
	  "fiveideographicparen",
	  0x3224,
	  "fiveinferior",
	  0x2085,
	  "fivemonospace",
	  0xff15,
	  "fiveoldstyle",
	  0xf735,
	  "fiveparen",
	  0x2478,
	  "fiveperiod",
	  0x248c,
	  "fivepersian",
	  0x06f5,
	  "fiveroman",
	  0x2174,
	  "fivesuperior",
	  0x2075,
	  "fivethai",
	  0x0e55,
	  "fl",
	  0xfb02,
	  "florin",
	  0x0192,
	  "fmonospace",
	  0xff46,
	  "fmsquare",
	  0x3399,
	  "fofanthai",
	  0x0e1f,
	  "fofathai",
	  0x0e1d,
	  "fongmanthai",
	  0x0e4f,
	  "forall",
	  0x2200,
	  "four",
	  0x0034,
	  "fourarabic",
	  0x0664,
	  "fourbengali",
	  0x09ea,
	  "fourcircle",
	  0x2463,
	  "fourcircleinversesansserif",
	  0x278d,
	  "fourdeva",
	  0x096a,
	  "fourgujarati",
	  0x0aea,
	  "fourgurmukhi",
	  0x0a6a,
	  "fourhackarabic",
	  0x0664,
	  "fourhangzhou",
	  0x3024,
	  "fourideographicparen",
	  0x3223,
	  "fourinferior",
	  0x2084,
	  "fourmonospace",
	  0xff14,
	  "fournumeratorbengali",
	  0x09f7,
	  "fouroldstyle",
	  0xf734,
	  "fourparen",
	  0x2477,
	  "fourperiod",
	  0x248b,
	  "fourpersian",
	  0x06f4,
	  "fourroman",
	  0x2173,
	  "foursuperior",
	  0x2074,
	  "fourteencircle",
	  0x246d,
	  "fourteenparen",
	  0x2481,
	  "fourteenperiod",
	  0x2495,
	  "fourthai",
	  0x0e54,
	  "fourthtonechinese",
	  0x02cb,
	  "fparen",
	  0x24a1,
	  "fraction",
	  0x2044,
	  "franc",
	  0x20a3,
	  "g",
	  0x0067,
	  "gabengali",
	  0x0997,
	  "gacute",
	  0x01f5,
	  "gadeva",
	  0x0917,
	  "gafarabic",
	  0x06af,
	  "gaffinalarabic",
	  0xfb93,
	  "gafinitialarabic",
	  0xfb94,
	  "gafmedialarabic",
	  0xfb95,
	  "gagujarati",
	  0x0a97,
	  "gagurmukhi",
	  0x0a17,
	  "gahiragana",
	  0x304c,
	  "gakatakana",
	  0x30ac,
	  "gamma",
	  0x03b3,
	  "gammalatinsmall",
	  0x0263,
	  "gammasuperior",
	  0x02e0,
	  "gangiacoptic",
	  0x03eb,
	  "gbopomofo",
	  0x310d,
	  "gbreve",
	  0x011f,
	  "gcaron",
	  0x01e7,
	  "gcedilla",
	  0x0123,
	  "gcircle",
	  0x24d6,
	  "gcircumflex",
	  0x011d,
	  "gcommaaccent",
	  0x0123,
	  "gdot",
	  0x0121,
	  "gdotaccent",
	  0x0121,
	  "gecyrillic",
	  0x0433,
	  "gehiragana",
	  0x3052,
	  "gekatakana",
	  0x30b2,
	  "geometricallyequal",
	  0x2251,
	  "gereshaccenthebrew",
	  0x059c,
	  "gereshhebrew",
	  0x05f3,
	  "gereshmuqdamhebrew",
	  0x059d,
	  "germandbls",
	  0x00df,
	  "gershayimaccenthebrew",
	  0x059e,
	  "gershayimhebrew",
	  0x05f4,
	  "getamark",
	  0x3013,
	  "ghabengali",
	  0x0998,
	  "ghadarmenian",
	  0x0572,
	  "ghadeva",
	  0x0918,
	  "ghagujarati",
	  0x0a98,
	  "ghagurmukhi",
	  0x0a18,
	  "ghainarabic",
	  0x063a,
	  "ghainfinalarabic",
	  0xfece,
	  "ghaininitialarabic",
	  0xfecf,
	  "ghainmedialarabic",
	  0xfed0,
	  "ghemiddlehookcyrillic",
	  0x0495,
	  "ghestrokecyrillic",
	  0x0493,
	  "gheupturncyrillic",
	  0x0491,
	  "ghhadeva",
	  0x095a,
	  "ghhagurmukhi",
	  0x0a5a,
	  "ghook",
	  0x0260,
	  "ghzsquare",
	  0x3393,
	  "gihiragana",
	  0x304e,
	  "gikatakana",
	  0x30ae,
	  "gimarmenian",
	  0x0563,
	  "gimel",
	  0x05d2,
	  "gimeldagesh",
	  0xfb32,
	  "gimeldageshhebrew",
	  0xfb32,
	  "gimelhebrew",
	  0x05d2,
	  "gjecyrillic",
	  0x0453,
	  "glottalinvertedstroke",
	  0x01be,
	  "glottalstop",
	  0x0294,
	  "glottalstopinverted",
	  0x0296,
	  "glottalstopmod",
	  0x02c0,
	  "glottalstopreversed",
	  0x0295,
	  "glottalstopreversedmod",
	  0x02c1,
	  "glottalstopreversedsuperior",
	  0x02e4,
	  "glottalstopstroke",
	  0x02a1,
	  "glottalstopstrokereversed",
	  0x02a2,
	  "gmacron",
	  0x1e21,
	  "gmonospace",
	  0xff47,
	  "gohiragana",
	  0x3054,
	  "gokatakana",
	  0x30b4,
	  "gparen",
	  0x24a2,
	  "gpasquare",
	  0x33ac,
	  "gradient",
	  0x2207,
	  "grave",
	  0x0060,
	  "gravebelowcmb",
	  0x0316,
	  "gravecmb",
	  0x0300,
	  "gravecomb",
	  0x0300,
	  "gravedeva",
	  0x0953,
	  "gravelowmod",
	  0x02ce,
	  "gravemonospace",
	  0xff40,
	  "gravetonecmb",
	  0x0340,
	  "greater",
	  0x003e,
	  "greaterequal",
	  0x2265,
	  "greaterequalorless",
	  0x22db,
	  "greatermonospace",
	  0xff1e,
	  "greaterorequivalent",
	  0x2273,
	  "greaterorless",
	  0x2277,
	  "greateroverequal",
	  0x2267,
	  "greatersmall",
	  0xfe65,
	  "gscript",
	  0x0261,
	  "gstroke",
	  0x01e5,
	  "guhiragana",
	  0x3050,
	  "guillemotleft",
	  0x00ab,
	  "guillemotright",
	  0x00bb,
	  "guilsinglleft",
	  0x2039,
	  "guilsinglright",
	  0x203a,
	  "gukatakana",
	  0x30b0,
	  "guramusquare",
	  0x3318,
	  "gysquare",
	  0x33c9,
	  "h",
	  0x0068,
	  "haabkhasiancyrillic",
	  0x04a9,
	  "haaltonearabic",
	  0x06c1,
	  "habengali",
	  0x09b9,
	  "hadescendercyrillic",
	  0x04b3,
	  "hadeva",
	  0x0939,
	  "hagujarati",
	  0x0ab9,
	  "hagurmukhi",
	  0x0a39,
	  "haharabic",
	  0x062d,
	  "hahfinalarabic",
	  0xfea2,
	  "hahinitialarabic",
	  0xfea3,
	  "hahiragana",
	  0x306f,
	  "hahmedialarabic",
	  0xfea4,
	  "haitusquare",
	  0x332a,
	  "hakatakana",
	  0x30cf,
	  "hakatakanahalfwidth",
	  0xff8a,
	  "halantgurmukhi",
	  0x0a4d,
	  "hamzaarabic",
	  0x0621,
	  "hamzalowarabic",
	  0x0621,
	  "hangulfiller",
	  0x3164,
	  "hardsigncyrillic",
	  0x044a,
	  "harpoonleftbarbup",
	  0x21bc,
	  "harpoonrightbarbup",
	  0x21c0,
	  "hasquare",
	  0x33ca,
	  "hatafpatah",
	  0x05b2,
	  "hatafpatah16",
	  0x05b2,
	  "hatafpatah23",
	  0x05b2,
	  "hatafpatah2f",
	  0x05b2,
	  "hatafpatahhebrew",
	  0x05b2,
	  "hatafpatahnarrowhebrew",
	  0x05b2,
	  "hatafpatahquarterhebrew",
	  0x05b2,
	  "hatafpatahwidehebrew",
	  0x05b2,
	  "hatafqamats",
	  0x05b3,
	  "hatafqamats1b",
	  0x05b3,
	  "hatafqamats28",
	  0x05b3,
	  "hatafqamats34",
	  0x05b3,
	  "hatafqamatshebrew",
	  0x05b3,
	  "hatafqamatsnarrowhebrew",
	  0x05b3,
	  "hatafqamatsquarterhebrew",
	  0x05b3,
	  "hatafqamatswidehebrew",
	  0x05b3,
	  "hatafsegol",
	  0x05b1,
	  "hatafsegol17",
	  0x05b1,
	  "hatafsegol24",
	  0x05b1,
	  "hatafsegol30",
	  0x05b1,
	  "hatafsegolhebrew",
	  0x05b1,
	  "hatafsegolnarrowhebrew",
	  0x05b1,
	  "hatafsegolquarterhebrew",
	  0x05b1,
	  "hatafsegolwidehebrew",
	  0x05b1,
	  "hbar",
	  0x0127,
	  "hbopomofo",
	  0x310f,
	  "hbrevebelow",
	  0x1e2b,
	  "hcedilla",
	  0x1e29,
	  "hcircle",
	  0x24d7,
	  "hcircumflex",
	  0x0125,
	  "hdieresis",
	  0x1e27,
	  "hdotaccent",
	  0x1e23,
	  "hdotbelow",
	  0x1e25,
	  "he",
	  0x05d4,
	  "heart",
	  0x2665,
	  "heartsuitblack",
	  0x2665,
	  "heartsuitwhite",
	  0x2661,
	  "hedagesh",
	  0xfb34,
	  "hedageshhebrew",
	  0xfb34,
	  "hehaltonearabic",
	  0x06c1,
	  "heharabic",
	  0x0647,
	  "hehebrew",
	  0x05d4,
	  "hehfinalaltonearabic",
	  0xfba7,
	  "hehfinalalttwoarabic",
	  0xfeea,
	  "hehfinalarabic",
	  0xfeea,
	  "hehhamzaabovefinalarabic",
	  0xfba5,
	  "hehhamzaaboveisolatedarabic",
	  0xfba4,
	  "hehinitialaltonearabic",
	  0xfba8,
	  "hehinitialarabic",
	  0xfeeb,
	  "hehiragana",
	  0x3078,
	  "hehmedialaltonearabic",
	  0xfba9,
	  "hehmedialarabic",
	  0xfeec,
	  "heiseierasquare",
	  0x337b,
	  "hekatakana",
	  0x30d8,
	  "hekatakanahalfwidth",
	  0xff8d,
	  "hekutaarusquare",
	  0x3336,
	  "henghook",
	  0x0267,
	  "herutusquare",
	  0x3339,
	  "het",
	  0x05d7,
	  "hethebrew",
	  0x05d7,
	  "hhook",
	  0x0266,
	  "hhooksuperior",
	  0x02b1,
	  "hieuhacirclekorean",
	  0x327b,
	  "hieuhaparenkorean",
	  0x321b,
	  "hieuhcirclekorean",
	  0x326d,
	  "hieuhkorean",
	  0x314e,
	  "hieuhparenkorean",
	  0x320d,
	  "hihiragana",
	  0x3072,
	  "hikatakana",
	  0x30d2,
	  "hikatakanahalfwidth",
	  0xff8b,
	  "hiriq",
	  0x05b4,
	  "hiriq14",
	  0x05b4,
	  "hiriq21",
	  0x05b4,
	  "hiriq2d",
	  0x05b4,
	  "hiriqhebrew",
	  0x05b4,
	  "hiriqnarrowhebrew",
	  0x05b4,
	  "hiriqquarterhebrew",
	  0x05b4,
	  "hiriqwidehebrew",
	  0x05b4,
	  "hlinebelow",
	  0x1e96,
	  "hmonospace",
	  0xff48,
	  "hoarmenian",
	  0x0570,
	  "hohipthai",
	  0x0e2b,
	  "hohiragana",
	  0x307b,
	  "hokatakana",
	  0x30db,
	  "hokatakanahalfwidth",
	  0xff8e,
	  "holam",
	  0x05b9,
	  "holam19",
	  0x05b9,
	  "holam26",
	  0x05b9,
	  "holam32",
	  0x05b9,
	  "holamhebrew",
	  0x05b9,
	  "holamnarrowhebrew",
	  0x05b9,
	  "holamquarterhebrew",
	  0x05b9,
	  "holamwidehebrew",
	  0x05b9,
	  "honokhukthai",
	  0x0e2e,
	  "hookabovecomb",
	  0x0309,
	  "hookcmb",
	  0x0309,
	  "hookpalatalizedbelowcmb",
	  0x0321,
	  "hookretroflexbelowcmb",
	  0x0322,
	  "hoonsquare",
	  0x3342,
	  "horicoptic",
	  0x03e9,
	  "horizontalbar",
	  0x2015,
	  "horncmb",
	  0x031b,
	  "hotsprings",
	  0x2668,
	  "house",
	  0x2302,
	  "hparen",
	  0x24a3,
	  "hsuperior",
	  0x02b0,
	  "hturned",
	  0x0265,
	  "huhiragana",
	  0x3075,
	  "huiitosquare",
	  0x3333,
	  "hukatakana",
	  0x30d5,
	  "hukatakanahalfwidth",
	  0xff8c,
	  "hungarumlaut",
	  0x02dd,
	  "hungarumlautcmb",
	  0x030b,
	  "hv",
	  0x0195,
	  "hyphen",
	  0x002d,
	  "hypheninferior",
	  0xf6e5,
	  "hyphenmonospace",
	  0xff0d,
	  "hyphensmall",
	  0xfe63,
	  "hyphensuperior",
	  0xf6e6,
	  "hyphentwo",
	  0x2010,
	  "i",
	  0x0069,
	  "iacute",
	  0x00ed,
	  "iacyrillic",
	  0x044f,
	  "ibengali",
	  0x0987,
	  "ibopomofo",
	  0x3127,
	  "ibreve",
	  0x012d,
	  "icaron",
	  0x01d0,
	  "icircle",
	  0x24d8,
	  "icircumflex",
	  0x00ee,
	  "icyrillic",
	  0x0456,
	  "idblgrave",
	  0x0209,
	  "ideographearthcircle",
	  0x328f,
	  "ideographfirecircle",
	  0x328b,
	  "ideographicallianceparen",
	  0x323f,
	  "ideographiccallparen",
	  0x323a,
	  "ideographiccentrecircle",
	  0x32a5,
	  "ideographicclose",
	  0x3006,
	  "ideographiccomma",
	  0x3001,
	  "ideographiccommaleft",
	  0xff64,
	  "ideographiccongratulationparen",
	  0x3237,
	  "ideographiccorrectcircle",
	  0x32a3,
	  "ideographicearthparen",
	  0x322f,
	  "ideographicenterpriseparen",
	  0x323d,
	  "ideographicexcellentcircle",
	  0x329d,
	  "ideographicfestivalparen",
	  0x3240,
	  "ideographicfinancialcircle",
	  0x3296,
	  "ideographicfinancialparen",
	  0x3236,
	  "ideographicfireparen",
	  0x322b,
	  "ideographichaveparen",
	  0x3232,
	  "ideographichighcircle",
	  0x32a4,
	  "ideographiciterationmark",
	  0x3005,
	  "ideographiclaborcircle",
	  0x3298,
	  "ideographiclaborparen",
	  0x3238,
	  "ideographicleftcircle",
	  0x32a7,
	  "ideographiclowcircle",
	  0x32a6,
	  "ideographicmedicinecircle",
	  0x32a9,
	  "ideographicmetalparen",
	  0x322e,
	  "ideographicmoonparen",
	  0x322a,
	  "ideographicnameparen",
	  0x3234,
	  "ideographicperiod",
	  0x3002,
	  "ideographicprintcircle",
	  0x329e,
	  "ideographicreachparen",
	  0x3243,
	  "ideographicrepresentparen",
	  0x3239,
	  "ideographicresourceparen",
	  0x323e,
	  "ideographicrightcircle",
	  0x32a8,
	  "ideographicsecretcircle",
	  0x3299,
	  "ideographicselfparen",
	  0x3242,
	  "ideographicsocietyparen",
	  0x3233,
	  "ideographicspace",
	  0x3000,
	  "ideographicspecialparen",
	  0x3235,
	  "ideographicstockparen",
	  0x3231,
	  "ideographicstudyparen",
	  0x323b,
	  "ideographicsunparen",
	  0x3230,
	  "ideographicsuperviseparen",
	  0x323c,
	  "ideographicwaterparen",
	  0x322c,
	  "ideographicwoodparen",
	  0x322d,
	  "ideographiczero",
	  0x3007,
	  "ideographmetalcircle",
	  0x328e,
	  "ideographmooncircle",
	  0x328a,
	  "ideographnamecircle",
	  0x3294,
	  "ideographsuncircle",
	  0x3290,
	  "ideographwatercircle",
	  0x328c,
	  "ideographwoodcircle",
	  0x328d,
	  "ideva",
	  0x0907,
	  "idieresis",
	  0x00ef,
	  "idieresisacute",
	  0x1e2f,
	  "idieresiscyrillic",
	  0x04e5,
	  "idotbelow",
	  0x1ecb,
	  "iebrevecyrillic",
	  0x04d7,
	  "iecyrillic",
	  0x0435,
	  "ieungacirclekorean",
	  0x3275,
	  "ieungaparenkorean",
	  0x3215,
	  "ieungcirclekorean",
	  0x3267,
	  "ieungkorean",
	  0x3147,
	  "ieungparenkorean",
	  0x3207,
	  "igrave",
	  0x00ec,
	  "igujarati",
	  0x0a87,
	  "igurmukhi",
	  0x0a07,
	  "ihiragana",
	  0x3044,
	  "ihookabove",
	  0x1ec9,
	  "iibengali",
	  0x0988,
	  "iicyrillic",
	  0x0438,
	  "iideva",
	  0x0908,
	  "iigujarati",
	  0x0a88,
	  "iigurmukhi",
	  0x0a08,
	  "iimatragurmukhi",
	  0x0a40,
	  "iinvertedbreve",
	  0x020b,
	  "iishortcyrillic",
	  0x0439,
	  "iivowelsignbengali",
	  0x09c0,
	  "iivowelsigndeva",
	  0x0940,
	  "iivowelsigngujarati",
	  0x0ac0,
	  "ij",
	  0x0133,
	  "ikatakana",
	  0x30a4,
	  "ikatakanahalfwidth",
	  0xff72,
	  "ikorean",
	  0x3163,
	  "ilde",
	  0x02dc,
	  "iluyhebrew",
	  0x05ac,
	  "imacron",
	  0x012b,
	  "imacroncyrillic",
	  0x04e3,
	  "imageorapproximatelyequal",
	  0x2253,
	  "imatragurmukhi",
	  0x0a3f,
	  "imonospace",
	  0xff49,
	  "increment",
	  0x2206,
	  "infinity",
	  0x221e,
	  "iniarmenian",
	  0x056b,
	  "integral",
	  0x222b,
	  "integralbottom",
	  0x2321,
	  "integralbt",
	  0x2321,
	  "integralex",
	  0xf8f5,
	  "integraltop",
	  0x2320,
	  "integraltp",
	  0x2320,
	  "intersection",
	  0x2229,
	  "intisquare",
	  0x3305,
	  "invbullet",
	  0x25d8,
	  "invcircle",
	  0x25d9,
	  "invsmileface",
	  0x263b,
	  "iocyrillic",
	  0x0451,
	  "iogonek",
	  0x012f,
	  "iota",
	  0x03b9,
	  "iotadieresis",
	  0x03ca,
	  "iotadieresistonos",
	  0x0390,
	  "iotalatin",
	  0x0269,
	  "iotatonos",
	  0x03af,
	  "iparen",
	  0x24a4,
	  "irigurmukhi",
	  0x0a72,
	  "ismallhiragana",
	  0x3043,
	  "ismallkatakana",
	  0x30a3,
	  "ismallkatakanahalfwidth",
	  0xff68,
	  "issharbengali",
	  0x09fa,
	  "istroke",
	  0x0268,
	  "isuperior",
	  0xf6ed,
	  "iterationhiragana",
	  0x309d,
	  "iterationkatakana",
	  0x30fd,
	  "itilde",
	  0x0129,
	  "itildebelow",
	  0x1e2d,
	  "iubopomofo",
	  0x3129,
	  "iucyrillic",
	  0x044e,
	  "ivowelsignbengali",
	  0x09bf,
	  "ivowelsigndeva",
	  0x093f,
	  "ivowelsigngujarati",
	  0x0abf,
	  "izhitsacyrillic",
	  0x0475,
	  "izhitsadblgravecyrillic",
	  0x0477,
	  "j",
	  0x006a,
	  "jaarmenian",
	  0x0571,
	  "jabengali",
	  0x099c,
	  "jadeva",
	  0x091c,
	  "jagujarati",
	  0x0a9c,
	  "jagurmukhi",
	  0x0a1c,
	  "jbopomofo",
	  0x3110,
	  "jcaron",
	  0x01f0,
	  "jcircle",
	  0x24d9,
	  "jcircumflex",
	  0x0135,
	  "jcrossedtail",
	  0x029d,
	  "jdotlessstroke",
	  0x025f,
	  "jecyrillic",
	  0x0458,
	  "jeemarabic",
	  0x062c,
	  "jeemfinalarabic",
	  0xfe9e,
	  "jeeminitialarabic",
	  0xfe9f,
	  "jeemmedialarabic",
	  0xfea0,
	  "jeharabic",
	  0x0698,
	  "jehfinalarabic",
	  0xfb8b,
	  "jhabengali",
	  0x099d,
	  "jhadeva",
	  0x091d,
	  "jhagujarati",
	  0x0a9d,
	  "jhagurmukhi",
	  0x0a1d,
	  "jheharmenian",
	  0x057b,
	  "jis",
	  0x3004,
	  "jmonospace",
	  0xff4a,
	  "jparen",
	  0x24a5,
	  "jsuperior",
	  0x02b2,
	  "k",
	  0x006b,
	  "kabashkircyrillic",
	  0x04a1,
	  "kabengali",
	  0x0995,
	  "kacute",
	  0x1e31,
	  "kacyrillic",
	  0x043a,
	  "kadescendercyrillic",
	  0x049b,
	  "kadeva",
	  0x0915,
	  "kaf",
	  0x05db,
	  "kafarabic",
	  0x0643,
	  "kafdagesh",
	  0xfb3b,
	  "kafdageshhebrew",
	  0xfb3b,
	  "kaffinalarabic",
	  0xfeda,
	  "kafhebrew",
	  0x05db,
	  "kafinitialarabic",
	  0xfedb,
	  "kafmedialarabic",
	  0xfedc,
	  "kafrafehebrew",
	  0xfb4d,
	  "kagujarati",
	  0x0a95,
	  "kagurmukhi",
	  0x0a15,
	  "kahiragana",
	  0x304b,
	  "kahookcyrillic",
	  0x04c4,
	  "kakatakana",
	  0x30ab,
	  "kakatakanahalfwidth",
	  0xff76,
	  "kappa",
	  0x03ba,
	  "kappasymbolgreek",
	  0x03f0,
	  "kapyeounmieumkorean",
	  0x3171,
	  "kapyeounphieuphkorean",
	  0x3184,
	  "kapyeounpieupkorean",
	  0x3178,
	  "kapyeounssangpieupkorean",
	  0x3179,
	  "karoriisquare",
	  0x330d,
	  "kashidaautoarabic",
	  0x0640,
	  "kashidaautonosidebearingarabic",
	  0x0640,
	  "kasmallkatakana",
	  0x30f5,
	  "kasquare",
	  0x3384,
	  "kasraarabic",
	  0x0650,
	  "kasratanarabic",
	  0x064d,
	  "kastrokecyrillic",
	  0x049f,
	  "katahiraprolongmarkhalfwidth",
	  0xff70,
	  "kaverticalstrokecyrillic",
	  0x049d,
	  "kbopomofo",
	  0x310e,
	  "kcalsquare",
	  0x3389,
	  "kcaron",
	  0x01e9,
	  "kcedilla",
	  0x0137,
	  "kcircle",
	  0x24da,
	  "kcommaaccent",
	  0x0137,
	  "kdotbelow",
	  0x1e33,
	  "keharmenian",
	  0x0584,
	  "kehiragana",
	  0x3051,
	  "kekatakana",
	  0x30b1,
	  "kekatakanahalfwidth",
	  0xff79,
	  "kenarmenian",
	  0x056f,
	  "kesmallkatakana",
	  0x30f6,
	  "kgreenlandic",
	  0x0138,
	  "khabengali",
	  0x0996,
	  "khacyrillic",
	  0x0445,
	  "khadeva",
	  0x0916,
	  "khagujarati",
	  0x0a96,
	  "khagurmukhi",
	  0x0a16,
	  "khaharabic",
	  0x062e,
	  "khahfinalarabic",
	  0xfea6,
	  "khahinitialarabic",
	  0xfea7,
	  "khahmedialarabic",
	  0xfea8,
	  "kheicoptic",
	  0x03e7,
	  "khhadeva",
	  0x0959,
	  "khhagurmukhi",
	  0x0a59,
	  "khieukhacirclekorean",
	  0x3278,
	  "khieukhaparenkorean",
	  0x3218,
	  "khieukhcirclekorean",
	  0x326a,
	  "khieukhkorean",
	  0x314b,
	  "khieukhparenkorean",
	  0x320a,
	  "khokhaithai",
	  0x0e02,
	  "khokhonthai",
	  0x0e05,
	  "khokhuatthai",
	  0x0e03,
	  "khokhwaithai",
	  0x0e04,
	  "khomutthai",
	  0x0e5b,
	  "khook",
	  0x0199,
	  "khorakhangthai",
	  0x0e06,
	  "khzsquare",
	  0x3391,
	  "kihiragana",
	  0x304d,
	  "kikatakana",
	  0x30ad,
	  "kikatakanahalfwidth",
	  0xff77,
	  "kiroguramusquare",
	  0x3315,
	  "kiromeetorusquare",
	  0x3316,
	  "kirosquare",
	  0x3314,
	  "kiyeokacirclekorean",
	  0x326e,
	  "kiyeokaparenkorean",
	  0x320e,
	  "kiyeokcirclekorean",
	  0x3260,
	  "kiyeokkorean",
	  0x3131,
	  "kiyeokparenkorean",
	  0x3200,
	  "kiyeoksioskorean",
	  0x3133,
	  "kjecyrillic",
	  0x045c,
	  "klinebelow",
	  0x1e35,
	  "klsquare",
	  0x3398,
	  "kmcubedsquare",
	  0x33a6,
	  "kmonospace",
	  0xff4b,
	  "kmsquaredsquare",
	  0x33a2,
	  "kohiragana",
	  0x3053,
	  "kohmsquare",
	  0x33c0,
	  "kokaithai",
	  0x0e01,
	  "kokatakana",
	  0x30b3,
	  "kokatakanahalfwidth",
	  0xff7a,
	  "kooposquare",
	  0x331e,
	  "koppacyrillic",
	  0x0481,
	  "koreanstandardsymbol",
	  0x327f,
	  "koroniscmb",
	  0x0343,
	  "kparen",
	  0x24a6,
	  "kpasquare",
	  0x33aa,
	  "ksicyrillic",
	  0x046f,
	  "ktsquare",
	  0x33cf,
	  "kturned",
	  0x029e,
	  "kuhiragana",
	  0x304f,
	  "kukatakana",
	  0x30af,
	  "kukatakanahalfwidth",
	  0xff78,
	  "kvsquare",
	  0x33b8,
	  "kwsquare",
	  0x33be,
	  "l",
	  0x006c,
	  "labengali",
	  0x09b2,
	  "lacute",
	  0x013a,
	  "ladeva",
	  0x0932,
	  "lagujarati",
	  0x0ab2,
	  "lagurmukhi",
	  0x0a32,
	  "lakkhangyaothai",
	  0x0e45,
	  "lamaleffinalarabic",
	  0xfefc,
	  "lamalefhamzaabovefinalarabic",
	  0xfef8,
	  "lamalefhamzaaboveisolatedarabic",
	  0xfef7,
	  "lamalefhamzabelowfinalarabic",
	  0xfefa,
	  "lamalefhamzabelowisolatedarabic",
	  0xfef9,
	  "lamalefisolatedarabic",
	  0xfefb,
	  "lamalefmaddaabovefinalarabic",
	  0xfef6,
	  "lamalefmaddaaboveisolatedarabic",
	  0xfef5,
	  "lamarabic",
	  0x0644,
	  "lambda",
	  0x03bb,
	  "lambdastroke",
	  0x019b,
	  "lamed",
	  0x05dc,
	  "lameddagesh",
	  0xfb3c,
	  "lameddageshhebrew",
	  0xfb3c,
	  "lamedhebrew",
	  0x05dc,
	  "lamfinalarabic",
	  0xfede,
	  "lamhahinitialarabic",
	  0xfcca,
	  "laminitialarabic",
	  0xfedf,
	  "lamjeeminitialarabic",
	  0xfcc9,
	  "lamkhahinitialarabic",
	  0xfccb,
	  "lamlamhehisolatedarabic",
	  0xfdf2,
	  "lammedialarabic",
	  0xfee0,
	  "lammeemhahinitialarabic",
	  0xfd88,
	  "lammeeminitialarabic",
	  0xfccc,
	  "largecircle",
	  0x25ef,
	  "lbar",
	  0x019a,
	  "lbelt",
	  0x026c,
	  "lbopomofo",
	  0x310c,
	  "lcaron",
	  0x013e,
	  "lcedilla",
	  0x013c,
	  "lcircle",
	  0x24db,
	  "lcircumflexbelow",
	  0x1e3d,
	  "lcommaaccent",
	  0x013c,
	  "ldot",
	  0x0140,
	  "ldotaccent",
	  0x0140,
	  "ldotbelow",
	  0x1e37,
	  "ldotbelowmacron",
	  0x1e39,
	  "leftangleabovecmb",
	  0x031a,
	  "lefttackbelowcmb",
	  0x0318,
	  "less",
	  0x003c,
	  "lessequal",
	  0x2264,
	  "lessequalorgreater",
	  0x22da,
	  "lessmonospace",
	  0xff1c,
	  "lessorequivalent",
	  0x2272,
	  "lessorgreater",
	  0x2276,
	  "lessoverequal",
	  0x2266,
	  "lesssmall",
	  0xfe64,
	  "lezh",
	  0x026e,
	  "lfblock",
	  0x258c,
	  "lhookretroflex",
	  0x026d,
	  "lira",
	  0x20a4,
	  "liwnarmenian",
	  0x056c,
	  "lj",
	  0x01c9,
	  "ljecyrillic",
	  0x0459,
	  "ll",
	  0xf6c0,
	  "lladeva",
	  0x0933,
	  "llagujarati",
	  0x0ab3,
	  "llinebelow",
	  0x1e3b,
	  "llladeva",
	  0x0934,
	  "llvocalicbengali",
	  0x09e1,
	  "llvocalicdeva",
	  0x0961,
	  "llvocalicvowelsignbengali",
	  0x09e3,
	  "llvocalicvowelsigndeva",
	  0x0963,
	  "lmiddletilde",
	  0x026b,
	  "lmonospace",
	  0xff4c,
	  "lmsquare",
	  0x33d0,
	  "lochulathai",
	  0x0e2c,
	  "logicaland",
	  0x2227,
	  "logicalnot",
	  0x00ac,
	  "logicalnotreversed",
	  0x2310,
	  "logicalor",
	  0x2228,
	  "lolingthai",
	  0x0e25,
	  "longs",
	  0x017f,
	  "lowlinecenterline",
	  0xfe4e,
	  "lowlinecmb",
	  0x0332,
	  "lowlinedashed",
	  0xfe4d,
	  "lozenge",
	  0x25ca,
	  "lparen",
	  0x24a7,
	  "lslash",
	  0x0142,
	  "lsquare",
	  0x2113,
	  "lsuperior",
	  0xf6ee,
	  "ltshade",
	  0x2591,
	  "luthai",
	  0x0e26,
	  "lvocalicbengali",
	  0x098c,
	  "lvocalicdeva",
	  0x090c,
	  "lvocalicvowelsignbengali",
	  0x09e2,
	  "lvocalicvowelsigndeva",
	  0x0962,
	  "lxsquare",
	  0x33d3,
	  "m",
	  0x006d,
	  "mabengali",
	  0x09ae,
	  "macron",
	  0x00af,
	  "macronbelowcmb",
	  0x0331,
	  "macroncmb",
	  0x0304,
	  "macronlowmod",
	  0x02cd,
	  "macronmonospace",
	  0xffe3,
	  "macute",
	  0x1e3f,
	  "madeva",
	  0x092e,
	  "magujarati",
	  0x0aae,
	  "magurmukhi",
	  0x0a2e,
	  "mahapakhhebrew",
	  0x05a4,
	  "mahapakhlefthebrew",
	  0x05a4,
	  "mahiragana",
	  0x307e,
	  "maichattawalowleftthai",
	  0xf895,
	  "maichattawalowrightthai",
	  0xf894,
	  "maichattawathai",
	  0x0e4b,
	  "maichattawaupperleftthai",
	  0xf893,
	  "maieklowleftthai",
	  0xf88c,
	  "maieklowrightthai",
	  0xf88b,
	  "maiekthai",
	  0x0e48,
	  "maiekupperleftthai",
	  0xf88a,
	  "maihanakatleftthai",
	  0xf884,
	  "maihanakatthai",
	  0x0e31,
	  "maitaikhuleftthai",
	  0xf889,
	  "maitaikhuthai",
	  0x0e47,
	  "maitholowleftthai",
	  0xf88f,
	  "maitholowrightthai",
	  0xf88e,
	  "maithothai",
	  0x0e49,
	  "maithoupperleftthai",
	  0xf88d,
	  "maitrilowleftthai",
	  0xf892,
	  "maitrilowrightthai",
	  0xf891,
	  "maitrithai",
	  0x0e4a,
	  "maitriupperleftthai",
	  0xf890,
	  "maiyamokthai",
	  0x0e46,
	  "makatakana",
	  0x30de,
	  "makatakanahalfwidth",
	  0xff8f,
	  "male",
	  0x2642,
	  "mansyonsquare",
	  0x3347,
	  "maqafhebrew",
	  0x05be,
	  "mars",
	  0x2642,
	  "masoracirclehebrew",
	  0x05af,
	  "masquare",
	  0x3383,
	  "mbopomofo",
	  0x3107,
	  "mbsquare",
	  0x33d4,
	  "mcircle",
	  0x24dc,
	  "mcubedsquare",
	  0x33a5,
	  "mdotaccent",
	  0x1e41,
	  "mdotbelow",
	  0x1e43,
	  "meemarabic",
	  0x0645,
	  "meemfinalarabic",
	  0xfee2,
	  "meeminitialarabic",
	  0xfee3,
	  "meemmedialarabic",
	  0xfee4,
	  "meemmeeminitialarabic",
	  0xfcd1,
	  "meemmeemisolatedarabic",
	  0xfc48,
	  "meetorusquare",
	  0x334d,
	  "mehiragana",
	  0x3081,
	  "meizierasquare",
	  0x337e,
	  "mekatakana",
	  0x30e1,
	  "mekatakanahalfwidth",
	  0xff92,
	  "mem",
	  0x05de,
	  "memdagesh",
	  0xfb3e,
	  "memdageshhebrew",
	  0xfb3e,
	  "memhebrew",
	  0x05de,
	  "menarmenian",
	  0x0574,
	  "merkhahebrew",
	  0x05a5,
	  "merkhakefulahebrew",
	  0x05a6,
	  "merkhakefulalefthebrew",
	  0x05a6,
	  "merkhalefthebrew",
	  0x05a5,
	  "mhook",
	  0x0271,
	  "mhzsquare",
	  0x3392,
	  "middledotkatakanahalfwidth",
	  0xff65,
	  "middot",
	  0x00b7,
	  "mieumacirclekorean",
	  0x3272,
	  "mieumaparenkorean",
	  0x3212,
	  "mieumcirclekorean",
	  0x3264,
	  "mieumkorean",
	  0x3141,
	  "mieumpansioskorean",
	  0x3170,
	  "mieumparenkorean",
	  0x3204,
	  "mieumpieupkorean",
	  0x316e,
	  "mieumsioskorean",
	  0x316f,
	  "mihiragana",
	  0x307f,
	  "mikatakana",
	  0x30df,
	  "mikatakanahalfwidth",
	  0xff90,
	  "minus",
	  0x2212,
	  "minusbelowcmb",
	  0x0320,
	  "minuscircle",
	  0x2296,
	  "minusmod",
	  0x02d7,
	  "minusplus",
	  0x2213,
	  "minute",
	  0x2032,
	  "miribaarusquare",
	  0x334a,
	  "mirisquare",
	  0x3349,
	  "mlonglegturned",
	  0x0270,
	  "mlsquare",
	  0x3396,
	  "mmcubedsquare",
	  0x33a3,
	  "mmonospace",
	  0xff4d,
	  "mmsquaredsquare",
	  0x339f,
	  "mohiragana",
	  0x3082,
	  "mohmsquare",
	  0x33c1,
	  "mokatakana",
	  0x30e2,
	  "mokatakanahalfwidth",
	  0xff93,
	  "molsquare",
	  0x33d6,
	  "momathai",
	  0x0e21,
	  "moverssquare",
	  0x33a7,
	  "moverssquaredsquare",
	  0x33a8,
	  "mparen",
	  0x24a8,
	  "mpasquare",
	  0x33ab,
	  "mssquare",
	  0x33b3,
	  "msuperior",
	  0xf6ef,
	  "mturned",
	  0x026f,
	  "mu",
	  0x00b5,
	  "mu1",
	  0x00b5,
	  "muasquare",
	  0x3382,
	  "muchgreater",
	  0x226b,
	  "muchless",
	  0x226a,
	  "mufsquare",
	  0x338c,
	  "mugreek",
	  0x03bc,
	  "mugsquare",
	  0x338d,
	  "muhiragana",
	  0x3080,
	  "mukatakana",
	  0x30e0,
	  "mukatakanahalfwidth",
	  0xff91,
	  "mulsquare",
	  0x3395,
	  "multiply",
	  0x00d7,
	  "mumsquare",
	  0x339b,
	  "munahhebrew",
	  0x05a3,
	  "munahlefthebrew",
	  0x05a3,
	  "musicalnote",
	  0x266a,
	  "musicalnotedbl",
	  0x266b,
	  "musicflatsign",
	  0x266d,
	  "musicsharpsign",
	  0x266f,
	  "mussquare",
	  0x33b2,
	  "muvsquare",
	  0x33b6,
	  "muwsquare",
	  0x33bc,
	  "mvmegasquare",
	  0x33b9,
	  "mvsquare",
	  0x33b7,
	  "mwmegasquare",
	  0x33bf,
	  "mwsquare",
	  0x33bd,
	  "n",
	  0x006e,
	  "nabengali",
	  0x09a8,
	  "nabla",
	  0x2207,
	  "nacute",
	  0x0144,
	  "nadeva",
	  0x0928,
	  "nagujarati",
	  0x0aa8,
	  "nagurmukhi",
	  0x0a28,
	  "nahiragana",
	  0x306a,
	  "nakatakana",
	  0x30ca,
	  "nakatakanahalfwidth",
	  0xff85,
	  "napostrophe",
	  0x0149,
	  "nasquare",
	  0x3381,
	  "nbopomofo",
	  0x310b,
	  "nbspace",
	  0x00a0,
	  "ncaron",
	  0x0148,
	  "ncedilla",
	  0x0146,
	  "ncircle",
	  0x24dd,
	  "ncircumflexbelow",
	  0x1e4b,
	  "ncommaaccent",
	  0x0146,
	  "ndotaccent",
	  0x1e45,
	  "ndotbelow",
	  0x1e47,
	  "nehiragana",
	  0x306d,
	  "nekatakana",
	  0x30cd,
	  "nekatakanahalfwidth",
	  0xff88,
	  "newsheqelsign",
	  0x20aa,
	  "nfsquare",
	  0x338b,
	  "ngabengali",
	  0x0999,
	  "ngadeva",
	  0x0919,
	  "ngagujarati",
	  0x0a99,
	  "ngagurmukhi",
	  0x0a19,
	  "ngonguthai",
	  0x0e07,
	  "nhiragana",
	  0x3093,
	  "nhookleft",
	  0x0272,
	  "nhookretroflex",
	  0x0273,
	  "nieunacirclekorean",
	  0x326f,
	  "nieunaparenkorean",
	  0x320f,
	  "nieuncieuckorean",
	  0x3135,
	  "nieuncirclekorean",
	  0x3261,
	  "nieunhieuhkorean",
	  0x3136,
	  "nieunkorean",
	  0x3134,
	  "nieunpansioskorean",
	  0x3168,
	  "nieunparenkorean",
	  0x3201,
	  "nieunsioskorean",
	  0x3167,
	  "nieuntikeutkorean",
	  0x3166,
	  "nihiragana",
	  0x306b,
	  "nikatakana",
	  0x30cb,
	  "nikatakanahalfwidth",
	  0xff86,
	  "nikhahitleftthai",
	  0xf899,
	  "nikhahitthai",
	  0x0e4d,
	  "nine",
	  0x0039,
	  "ninearabic",
	  0x0669,
	  "ninebengali",
	  0x09ef,
	  "ninecircle",
	  0x2468,
	  "ninecircleinversesansserif",
	  0x2792,
	  "ninedeva",
	  0x096f,
	  "ninegujarati",
	  0x0aef,
	  "ninegurmukhi",
	  0x0a6f,
	  "ninehackarabic",
	  0x0669,
	  "ninehangzhou",
	  0x3029,
	  "nineideographicparen",
	  0x3228,
	  "nineinferior",
	  0x2089,
	  "ninemonospace",
	  0xff19,
	  "nineoldstyle",
	  0xf739,
	  "nineparen",
	  0x247c,
	  "nineperiod",
	  0x2490,
	  "ninepersian",
	  0x06f9,
	  "nineroman",
	  0x2178,
	  "ninesuperior",
	  0x2079,
	  "nineteencircle",
	  0x2472,
	  "nineteenparen",
	  0x2486,
	  "nineteenperiod",
	  0x249a,
	  "ninethai",
	  0x0e59,
	  "nj",
	  0x01cc,
	  "njecyrillic",
	  0x045a,
	  "nkatakana",
	  0x30f3,
	  "nkatakanahalfwidth",
	  0xff9d,
	  "nlegrightlong",
	  0x019e,
	  "nlinebelow",
	  0x1e49,
	  "nmonospace",
	  0xff4e,
	  "nmsquare",
	  0x339a,
	  "nnabengali",
	  0x09a3,
	  "nnadeva",
	  0x0923,
	  "nnagujarati",
	  0x0aa3,
	  "nnagurmukhi",
	  0x0a23,
	  "nnnadeva",
	  0x0929,
	  "nohiragana",
	  0x306e,
	  "nokatakana",
	  0x30ce,
	  "nokatakanahalfwidth",
	  0xff89,
	  "nonbreakingspace",
	  0x00a0,
	  "nonenthai",
	  0x0e13,
	  "nonuthai",
	  0x0e19,
	  "noonarabic",
	  0x0646,
	  "noonfinalarabic",
	  0xfee6,
	  "noonghunnaarabic",
	  0x06ba,
	  "noonghunnafinalarabic",
	  0xfb9f,
	  "nooninitialarabic",
	  0xfee7,
	  "noonjeeminitialarabic",
	  0xfcd2,
	  "noonjeemisolatedarabic",
	  0xfc4b,
	  "noonmedialarabic",
	  0xfee8,
	  "noonmeeminitialarabic",
	  0xfcd5,
	  "noonmeemisolatedarabic",
	  0xfc4e,
	  "noonnoonfinalarabic",
	  0xfc8d,
	  "notcontains",
	  0x220c,
	  "notelement",
	  0x2209,
	  "notelementof",
	  0x2209,
	  "notequal",
	  0x2260,
	  "notgreater",
	  0x226f,
	  "notgreaternorequal",
	  0x2271,
	  "notgreaternorless",
	  0x2279,
	  "notidentical",
	  0x2262,
	  "notless",
	  0x226e,
	  "notlessnorequal",
	  0x2270,
	  "notparallel",
	  0x2226,
	  "notprecedes",
	  0x2280,
	  "notsubset",
	  0x2284,
	  "notsucceeds",
	  0x2281,
	  "notsuperset",
	  0x2285,
	  "nowarmenian",
	  0x0576,
	  "nparen",
	  0x24a9,
	  "nssquare",
	  0x33b1,
	  "nsuperior",
	  0x207f,
	  "ntilde",
	  0x00f1,
	  "nu",
	  0x03bd,
	  "nuhiragana",
	  0x306c,
	  "nukatakana",
	  0x30cc,
	  "nukatakanahalfwidth",
	  0xff87,
	  "nuktabengali",
	  0x09bc,
	  "nuktadeva",
	  0x093c,
	  "nuktagujarati",
	  0x0abc,
	  "nuktagurmukhi",
	  0x0a3c,
	  "numbersign",
	  0x0023,
	  "numbersignmonospace",
	  0xff03,
	  "numbersignsmall",
	  0xfe5f,
	  "numeralsigngreek",
	  0x0374,
	  "numeralsignlowergreek",
	  0x0375,
	  "numero",
	  0x2116,
	  "nun",
	  0x05e0,
	  "nundagesh",
	  0xfb40,
	  "nundageshhebrew",
	  0xfb40,
	  "nunhebrew",
	  0x05e0,
	  "nvsquare",
	  0x33b5,
	  "nwsquare",
	  0x33bb,
	  "nyabengali",
	  0x099e,
	  "nyadeva",
	  0x091e,
	  "nyagujarati",
	  0x0a9e,
	  "nyagurmukhi",
	  0x0a1e,
	  "o",
	  0x006f,
	  "oacute",
	  0x00f3,
	  "oangthai",
	  0x0e2d,
	  "obarred",
	  0x0275,
	  "obarredcyrillic",
	  0x04e9,
	  "obarreddieresiscyrillic",
	  0x04eb,
	  "obengali",
	  0x0993,
	  "obopomofo",
	  0x311b,
	  "obreve",
	  0x014f,
	  "ocandradeva",
	  0x0911,
	  "ocandragujarati",
	  0x0a91,
	  "ocandravowelsigndeva",
	  0x0949,
	  "ocandravowelsigngujarati",
	  0x0ac9,
	  "ocaron",
	  0x01d2,
	  "ocircle",
	  0x24de,
	  "ocircumflex",
	  0x00f4,
	  "ocircumflexacute",
	  0x1ed1,
	  "ocircumflexdotbelow",
	  0x1ed9,
	  "ocircumflexgrave",
	  0x1ed3,
	  "ocircumflexhookabove",
	  0x1ed5,
	  "ocircumflextilde",
	  0x1ed7,
	  "ocyrillic",
	  0x043e,
	  "odblacute",
	  0x0151,
	  "odblgrave",
	  0x020d,
	  "odeva",
	  0x0913,
	  "odieresis",
	  0x00f6,
	  "odieresiscyrillic",
	  0x04e7,
	  "odotbelow",
	  0x1ecd,
	  "oe",
	  0x0153,
	  "oekorean",
	  0x315a,
	  "ogonek",
	  0x02db,
	  "ogonekcmb",
	  0x0328,
	  "ograve",
	  0x00f2,
	  "ogujarati",
	  0x0a93,
	  "oharmenian",
	  0x0585,
	  "ohiragana",
	  0x304a,
	  "ohookabove",
	  0x1ecf,
	  "ohorn",
	  0x01a1,
	  "ohornacute",
	  0x1edb,
	  "ohorndotbelow",
	  0x1ee3,
	  "ohorngrave",
	  0x1edd,
	  "ohornhookabove",
	  0x1edf,
	  "ohorntilde",
	  0x1ee1,
	  "ohungarumlaut",
	  0x0151,
	  "oi",
	  0x01a3,
	  "oinvertedbreve",
	  0x020f,
	  "okatakana",
	  0x30aa,
	  "okatakanahalfwidth",
	  0xff75,
	  "okorean",
	  0x3157,
	  "olehebrew",
	  0x05ab,
	  "omacron",
	  0x014d,
	  "omacronacute",
	  0x1e53,
	  "omacrongrave",
	  0x1e51,
	  "omdeva",
	  0x0950,
	  "omega",
	  0x03c9,
	  "omega1",
	  0x03d6,
	  "omegacyrillic",
	  0x0461,
	  "omegalatinclosed",
	  0x0277,
	  "omegaroundcyrillic",
	  0x047b,
	  "omegatitlocyrillic",
	  0x047d,
	  "omegatonos",
	  0x03ce,
	  "omgujarati",
	  0x0ad0,
	  "omicron",
	  0x03bf,
	  "omicrontonos",
	  0x03cc,
	  "omonospace",
	  0xff4f,
	  "one",
	  0x0031,
	  "onearabic",
	  0x0661,
	  "onebengali",
	  0x09e7,
	  "onecircle",
	  0x2460,
	  "onecircleinversesansserif",
	  0x278a,
	  "onedeva",
	  0x0967,
	  "onedotenleader",
	  0x2024,
	  "oneeighth",
	  0x215b,
	  "onefitted",
	  0xf6dc,
	  "onegujarati",
	  0x0ae7,
	  "onegurmukhi",
	  0x0a67,
	  "onehackarabic",
	  0x0661,
	  "onehalf",
	  0x00bd,
	  "onehangzhou",
	  0x3021,
	  "oneideographicparen",
	  0x3220,
	  "oneinferior",
	  0x2081,
	  "onemonospace",
	  0xff11,
	  "onenumeratorbengali",
	  0x09f4,
	  "oneoldstyle",
	  0xf731,
	  "oneparen",
	  0x2474,
	  "oneperiod",
	  0x2488,
	  "onepersian",
	  0x06f1,
	  "onequarter",
	  0x00bc,
	  "oneroman",
	  0x2170,
	  "onesuperior",
	  0x00b9,
	  "onethai",
	  0x0e51,
	  "onethird",
	  0x2153,
	  "oogonek",
	  0x01eb,
	  "oogonekmacron",
	  0x01ed,
	  "oogurmukhi",
	  0x0a13,
	  "oomatragurmukhi",
	  0x0a4b,
	  "oopen",
	  0x0254,
	  "oparen",
	  0x24aa,
	  "openbullet",
	  0x25e6,
	  "option",
	  0x2325,
	  "ordfeminine",
	  0x00aa,
	  "ordmasculine",
	  0x00ba,
	  "orthogonal",
	  0x221f,
	  "oshortdeva",
	  0x0912,
	  "oshortvowelsigndeva",
	  0x094a,
	  "oslash",
	  0x00f8,
	  "oslashacute",
	  0x01ff,
	  "osmallhiragana",
	  0x3049,
	  "osmallkatakana",
	  0x30a9,
	  "osmallkatakanahalfwidth",
	  0xff6b,
	  "ostrokeacute",
	  0x01ff,
	  "osuperior",
	  0xf6f0,
	  "otcyrillic",
	  0x047f,
	  "otilde",
	  0x00f5,
	  "otildeacute",
	  0x1e4d,
	  "otildedieresis",
	  0x1e4f,
	  "oubopomofo",
	  0x3121,
	  "overline",
	  0x203e,
	  "overlinecenterline",
	  0xfe4a,
	  "overlinecmb",
	  0x0305,
	  "overlinedashed",
	  0xfe49,
	  "overlinedblwavy",
	  0xfe4c,
	  "overlinewavy",
	  0xfe4b,
	  "overscore",
	  0x00af,
	  "ovowelsignbengali",
	  0x09cb,
	  "ovowelsigndeva",
	  0x094b,
	  "ovowelsigngujarati",
	  0x0acb,
	  "p",
	  0x0070,
	  "paampssquare",
	  0x3380,
	  "paasentosquare",
	  0x332b,
	  "pabengali",
	  0x09aa,
	  "pacute",
	  0x1e55,
	  "padeva",
	  0x092a,
	  "pagedown",
	  0x21df,
	  "pageup",
	  0x21de,
	  "pagujarati",
	  0x0aaa,
	  "pagurmukhi",
	  0x0a2a,
	  "pahiragana",
	  0x3071,
	  "paiyannoithai",
	  0x0e2f,
	  "pakatakana",
	  0x30d1,
	  "palatalizationcyrilliccmb",
	  0x0484,
	  "palochkacyrillic",
	  0x04c0,
	  "pansioskorean",
	  0x317f,
	  "paragraph",
	  0x00b6,
	  "parallel",
	  0x2225,
	  "parenleft",
	  0x0028,
	  "parenleftaltonearabic",
	  0xfd3e,
	  "parenleftbt",
	  0xf8ed,
	  "parenleftex",
	  0xf8ec,
	  "parenleftinferior",
	  0x208d,
	  "parenleftmonospace",
	  0xff08,
	  "parenleftsmall",
	  0xfe59,
	  "parenleftsuperior",
	  0x207d,
	  "parenlefttp",
	  0xf8eb,
	  "parenleftvertical",
	  0xfe35,
	  "parenright",
	  0x0029,
	  "parenrightaltonearabic",
	  0xfd3f,
	  "parenrightbt",
	  0xf8f8,
	  "parenrightex",
	  0xf8f7,
	  "parenrightinferior",
	  0x208e,
	  "parenrightmonospace",
	  0xff09,
	  "parenrightsmall",
	  0xfe5a,
	  "parenrightsuperior",
	  0x207e,
	  "parenrighttp",
	  0xf8f6,
	  "parenrightvertical",
	  0xfe36,
	  "partialdiff",
	  0x2202,
	  "paseqhebrew",
	  0x05c0,
	  "pashtahebrew",
	  0x0599,
	  "pasquare",
	  0x33a9,
	  "patah",
	  0x05b7,
	  "patah11",
	  0x05b7,
	  "patah1d",
	  0x05b7,
	  "patah2a",
	  0x05b7,
	  "patahhebrew",
	  0x05b7,
	  "patahnarrowhebrew",
	  0x05b7,
	  "patahquarterhebrew",
	  0x05b7,
	  "patahwidehebrew",
	  0x05b7,
	  "pazerhebrew",
	  0x05a1,
	  "pbopomofo",
	  0x3106,
	  "pcircle",
	  0x24df,
	  "pdotaccent",
	  0x1e57,
	  "pe",
	  0x05e4,
	  "pecyrillic",
	  0x043f,
	  "pedagesh",
	  0xfb44,
	  "pedageshhebrew",
	  0xfb44,
	  "peezisquare",
	  0x333b,
	  "pefinaldageshhebrew",
	  0xfb43,
	  "peharabic",
	  0x067e,
	  "peharmenian",
	  0x057a,
	  "pehebrew",
	  0x05e4,
	  "pehfinalarabic",
	  0xfb57,
	  "pehinitialarabic",
	  0xfb58,
	  "pehiragana",
	  0x307a,
	  "pehmedialarabic",
	  0xfb59,
	  "pekatakana",
	  0x30da,
	  "pemiddlehookcyrillic",
	  0x04a7,
	  "perafehebrew",
	  0xfb4e,
	  "percent",
	  0x0025,
	  "percentarabic",
	  0x066a,
	  "percentmonospace",
	  0xff05,
	  "percentsmall",
	  0xfe6a,
	  "period",
	  0x002e,
	  "periodarmenian",
	  0x0589,
	  "periodcentered",
	  0x00b7,
	  "periodhalfwidth",
	  0xff61,
	  "periodinferior",
	  0xf6e7,
	  "periodmonospace",
	  0xff0e,
	  "periodsmall",
	  0xfe52,
	  "periodsuperior",
	  0xf6e8,
	  "perispomenigreekcmb",
	  0x0342,
	  "perpendicular",
	  0x22a5,
	  "perthousand",
	  0x2030,
	  "peseta",
	  0x20a7,
	  "pfsquare",
	  0x338a,
	  "phabengali",
	  0x09ab,
	  "phadeva",
	  0x092b,
	  "phagujarati",
	  0x0aab,
	  "phagurmukhi",
	  0x0a2b,
	  "phi",
	  0x03c6,
	  "phi1",
	  0x03d5,
	  "phieuphacirclekorean",
	  0x327a,
	  "phieuphaparenkorean",
	  0x321a,
	  "phieuphcirclekorean",
	  0x326c,
	  "phieuphkorean",
	  0x314d,
	  "phieuphparenkorean",
	  0x320c,
	  "philatin",
	  0x0278,
	  "phinthuthai",
	  0x0e3a,
	  "phisymbolgreek",
	  0x03d5,
	  "phook",
	  0x01a5,
	  "phophanthai",
	  0x0e1e,
	  "phophungthai",
	  0x0e1c,
	  "phosamphaothai",
	  0x0e20,
	  "pi",
	  0x03c0,
	  "pieupacirclekorean",
	  0x3273,
	  "pieupaparenkorean",
	  0x3213,
	  "pieupcieuckorean",
	  0x3176,
	  "pieupcirclekorean",
	  0x3265,
	  "pieupkiyeokkorean",
	  0x3172,
	  "pieupkorean",
	  0x3142,
	  "pieupparenkorean",
	  0x3205,
	  "pieupsioskiyeokkorean",
	  0x3174,
	  "pieupsioskorean",
	  0x3144,
	  "pieupsiostikeutkorean",
	  0x3175,
	  "pieupthieuthkorean",
	  0x3177,
	  "pieuptikeutkorean",
	  0x3173,
	  "pihiragana",
	  0x3074,
	  "pikatakana",
	  0x30d4,
	  "pisymbolgreek",
	  0x03d6,
	  "piwrarmenian",
	  0x0583,
	  "plus",
	  0x002b,
	  "plusbelowcmb",
	  0x031f,
	  "pluscircle",
	  0x2295,
	  "plusminus",
	  0x00b1,
	  "plusmod",
	  0x02d6,
	  "plusmonospace",
	  0xff0b,
	  "plussmall",
	  0xfe62,
	  "plussuperior",
	  0x207a,
	  "pmonospace",
	  0xff50,
	  "pmsquare",
	  0x33d8,
	  "pohiragana",
	  0x307d,
	  "pointingindexdownwhite",
	  0x261f,
	  "pointingindexleftwhite",
	  0x261c,
	  "pointingindexrightwhite",
	  0x261e,
	  "pointingindexupwhite",
	  0x261d,
	  "pokatakana",
	  0x30dd,
	  "poplathai",
	  0x0e1b,
	  "postalmark",
	  0x3012,
	  "postalmarkface",
	  0x3020,
	  "pparen",
	  0x24ab,
	  "precedes",
	  0x227a,
	  "prescription",
	  0x211e,
	  "primemod",
	  0x02b9,
	  "primereversed",
	  0x2035,
	  "product",
	  0x220f,
	  "projective",
	  0x2305,
	  "prolongedkana",
	  0x30fc,
	  "propellor",
	  0x2318,
	  "propersubset",
	  0x2282,
	  "propersuperset",
	  0x2283,
	  "proportion",
	  0x2237,
	  "proportional",
	  0x221d,
	  "psi",
	  0x03c8,
	  "psicyrillic",
	  0x0471,
	  "psilipneumatacyrilliccmb",
	  0x0486,
	  "pssquare",
	  0x33b0,
	  "puhiragana",
	  0x3077,
	  "pukatakana",
	  0x30d7,
	  "pvsquare",
	  0x33b4,
	  "pwsquare",
	  0x33ba,
	  "q",
	  0x0071,
	  "qadeva",
	  0x0958,
	  "qadmahebrew",
	  0x05a8,
	  "qafarabic",
	  0x0642,
	  "qaffinalarabic",
	  0xfed6,
	  "qafinitialarabic",
	  0xfed7,
	  "qafmedialarabic",
	  0xfed8,
	  "qamats",
	  0x05b8,
	  "qamats10",
	  0x05b8,
	  "qamats1a",
	  0x05b8,
	  "qamats1c",
	  0x05b8,
	  "qamats27",
	  0x05b8,
	  "qamats29",
	  0x05b8,
	  "qamats33",
	  0x05b8,
	  "qamatsde",
	  0x05b8,
	  "qamatshebrew",
	  0x05b8,
	  "qamatsnarrowhebrew",
	  0x05b8,
	  "qamatsqatanhebrew",
	  0x05b8,
	  "qamatsqatannarrowhebrew",
	  0x05b8,
	  "qamatsqatanquarterhebrew",
	  0x05b8,
	  "qamatsqatanwidehebrew",
	  0x05b8,
	  "qamatsquarterhebrew",
	  0x05b8,
	  "qamatswidehebrew",
	  0x05b8,
	  "qarneyparahebrew",
	  0x059f,
	  "qbopomofo",
	  0x3111,
	  "qcircle",
	  0x24e0,
	  "qhook",
	  0x02a0,
	  "qmonospace",
	  0xff51,
	  "qof",
	  0x05e7,
	  "qofdagesh",
	  0xfb47,
	  "qofdageshhebrew",
	  0xfb47,
	  "qofhebrew",
	  0x05e7,
	  "qparen",
	  0x24ac,
	  "quarternote",
	  0x2669,
	  "qubuts",
	  0x05bb,
	  "qubuts18",
	  0x05bb,
	  "qubuts25",
	  0x05bb,
	  "qubuts31",
	  0x05bb,
	  "qubutshebrew",
	  0x05bb,
	  "qubutsnarrowhebrew",
	  0x05bb,
	  "qubutsquarterhebrew",
	  0x05bb,
	  "qubutswidehebrew",
	  0x05bb,
	  "question",
	  0x003f,
	  "questionarabic",
	  0x061f,
	  "questionarmenian",
	  0x055e,
	  "questiondown",
	  0x00bf,
	  "questiondownsmall",
	  0xf7bf,
	  "questiongreek",
	  0x037e,
	  "questionmonospace",
	  0xff1f,
	  "questionsmall",
	  0xf73f,
	  "quotedbl",
	  0x0022,
	  "quotedblbase",
	  0x201e,
	  "quotedblleft",
	  0x201c,
	  "quotedblmonospace",
	  0xff02,
	  "quotedblprime",
	  0x301e,
	  "quotedblprimereversed",
	  0x301d,
	  "quotedblright",
	  0x201d,
	  "quoteleft",
	  0x2018,
	  "quoteleftreversed",
	  0x201b,
	  "quotereversed",
	  0x201b,
	  "quoteright",
	  0x2019,
	  "quoterightn",
	  0x0149,
	  "quotesinglbase",
	  0x201a,
	  "quotesingle",
	  0x0027,
	  "quotesinglemonospace",
	  0xff07,
	  "r",
	  0x0072,
	  "raarmenian",
	  0x057c,
	  "rabengali",
	  0x09b0,
	  "racute",
	  0x0155,
	  "radeva",
	  0x0930,
	  "radical",
	  0x221a,
	  "radicalex",
	  0xf8e5,
	  "radoverssquare",
	  0x33ae,
	  "radoverssquaredsquare",
	  0x33af,
	  "radsquare",
	  0x33ad,
	  "rafe",
	  0x05bf,
	  "rafehebrew",
	  0x05bf,
	  "ragujarati",
	  0x0ab0,
	  "ragurmukhi",
	  0x0a30,
	  "rahiragana",
	  0x3089,
	  "rakatakana",
	  0x30e9,
	  "rakatakanahalfwidth",
	  0xff97,
	  "ralowerdiagonalbengali",
	  0x09f1,
	  "ramiddlediagonalbengali",
	  0x09f0,
	  "ramshorn",
	  0x0264,
	  "ratio",
	  0x2236,
	  "rbopomofo",
	  0x3116,
	  "rcaron",
	  0x0159,
	  "rcedilla",
	  0x0157,
	  "rcircle",
	  0x24e1,
	  "rcommaaccent",
	  0x0157,
	  "rdblgrave",
	  0x0211,
	  "rdotaccent",
	  0x1e59,
	  "rdotbelow",
	  0x1e5b,
	  "rdotbelowmacron",
	  0x1e5d,
	  "referencemark",
	  0x203b,
	  "reflexsubset",
	  0x2286,
	  "reflexsuperset",
	  0x2287,
	  "registered",
	  0x00ae,
	  "registersans",
	  0xf8e8,
	  "registerserif",
	  0xf6da,
	  "reharabic",
	  0x0631,
	  "reharmenian",
	  0x0580,
	  "rehfinalarabic",
	  0xfeae,
	  "rehiragana",
	  0x308c,
	  "rekatakana",
	  0x30ec,
	  "rekatakanahalfwidth",
	  0xff9a,
	  "resh",
	  0x05e8,
	  "reshdageshhebrew",
	  0xfb48,
	  "reshhebrew",
	  0x05e8,
	  "reversedtilde",
	  0x223d,
	  "reviahebrew",
	  0x0597,
	  "reviamugrashhebrew",
	  0x0597,
	  "revlogicalnot",
	  0x2310,
	  "rfishhook",
	  0x027e,
	  "rfishhookreversed",
	  0x027f,
	  "rhabengali",
	  0x09dd,
	  "rhadeva",
	  0x095d,
	  "rho",
	  0x03c1,
	  "rhook",
	  0x027d,
	  "rhookturned",
	  0x027b,
	  "rhookturnedsuperior",
	  0x02b5,
	  "rhosymbolgreek",
	  0x03f1,
	  "rhotichookmod",
	  0x02de,
	  "rieulacirclekorean",
	  0x3271,
	  "rieulaparenkorean",
	  0x3211,
	  "rieulcirclekorean",
	  0x3263,
	  "rieulhieuhkorean",
	  0x3140,
	  "rieulkiyeokkorean",
	  0x313a,
	  "rieulkiyeoksioskorean",
	  0x3169,
	  "rieulkorean",
	  0x3139,
	  "rieulmieumkorean",
	  0x313b,
	  "rieulpansioskorean",
	  0x316c,
	  "rieulparenkorean",
	  0x3203,
	  "rieulphieuphkorean",
	  0x313f,
	  "rieulpieupkorean",
	  0x313c,
	  "rieulpieupsioskorean",
	  0x316b,
	  "rieulsioskorean",
	  0x313d,
	  "rieulthieuthkorean",
	  0x313e,
	  "rieultikeutkorean",
	  0x316a,
	  "rieulyeorinhieuhkorean",
	  0x316d,
	  "rightangle",
	  0x221f,
	  "righttackbelowcmb",
	  0x0319,
	  "righttriangle",
	  0x22bf,
	  "rihiragana",
	  0x308a,
	  "rikatakana",
	  0x30ea,
	  "rikatakanahalfwidth",
	  0xff98,
	  "ring",
	  0x02da,
	  "ringbelowcmb",
	  0x0325,
	  "ringcmb",
	  0x030a,
	  "ringhalfleft",
	  0x02bf,
	  "ringhalfleftarmenian",
	  0x0559,
	  "ringhalfleftbelowcmb",
	  0x031c,
	  "ringhalfleftcentered",
	  0x02d3,
	  "ringhalfright",
	  0x02be,
	  "ringhalfrightbelowcmb",
	  0x0339,
	  "ringhalfrightcentered",
	  0x02d2,
	  "rinvertedbreve",
	  0x0213,
	  "rittorusquare",
	  0x3351,
	  "rlinebelow",
	  0x1e5f,
	  "rlongleg",
	  0x027c,
	  "rlonglegturned",
	  0x027a,
	  "rmonospace",
	  0xff52,
	  "rohiragana",
	  0x308d,
	  "rokatakana",
	  0x30ed,
	  "rokatakanahalfwidth",
	  0xff9b,
	  "roruathai",
	  0x0e23,
	  "rparen",
	  0x24ad,
	  "rrabengali",
	  0x09dc,
	  "rradeva",
	  0x0931,
	  "rragurmukhi",
	  0x0a5c,
	  "rreharabic",
	  0x0691,
	  "rrehfinalarabic",
	  0xfb8d,
	  "rrvocalicbengali",
	  0x09e0,
	  "rrvocalicdeva",
	  0x0960,
	  "rrvocalicgujarati",
	  0x0ae0,
	  "rrvocalicvowelsignbengali",
	  0x09c4,
	  "rrvocalicvowelsigndeva",
	  0x0944,
	  "rrvocalicvowelsigngujarati",
	  0x0ac4,
	  "rsuperior",
	  0xf6f1,
	  "rtblock",
	  0x2590,
	  "rturned",
	  0x0279,
	  "rturnedsuperior",
	  0x02b4,
	  "ruhiragana",
	  0x308b,
	  "rukatakana",
	  0x30eb,
	  "rukatakanahalfwidth",
	  0xff99,
	  "rupeemarkbengali",
	  0x09f2,
	  "rupeesignbengali",
	  0x09f3,
	  "rupiah",
	  0xf6dd,
	  "ruthai",
	  0x0e24,
	  "rvocalicbengali",
	  0x098b,
	  "rvocalicdeva",
	  0x090b,
	  "rvocalicgujarati",
	  0x0a8b,
	  "rvocalicvowelsignbengali",
	  0x09c3,
	  "rvocalicvowelsigndeva",
	  0x0943,
	  "rvocalicvowelsigngujarati",
	  0x0ac3,
	  "s",
	  0x0073,
	  "sabengali",
	  0x09b8,
	  "sacute",
	  0x015b,
	  "sacutedotaccent",
	  0x1e65,
	  "sadarabic",
	  0x0635,
	  "sadeva",
	  0x0938,
	  "sadfinalarabic",
	  0xfeba,
	  "sadinitialarabic",
	  0xfebb,
	  "sadmedialarabic",
	  0xfebc,
	  "sagujarati",
	  0x0ab8,
	  "sagurmukhi",
	  0x0a38,
	  "sahiragana",
	  0x3055,
	  "sakatakana",
	  0x30b5,
	  "sakatakanahalfwidth",
	  0xff7b,
	  "sallallahoualayhewasallamarabic",
	  0xfdfa,
	  "samekh",
	  0x05e1,
	  "samekhdagesh",
	  0xfb41,
	  "samekhdageshhebrew",
	  0xfb41,
	  "samekhhebrew",
	  0x05e1,
	  "saraaathai",
	  0x0e32,
	  "saraaethai",
	  0x0e41,
	  "saraaimaimalaithai",
	  0x0e44,
	  "saraaimaimuanthai",
	  0x0e43,
	  "saraamthai",
	  0x0e33,
	  "saraathai",
	  0x0e30,
	  "saraethai",
	  0x0e40,
	  "saraiileftthai",
	  0xf886,
	  "saraiithai",
	  0x0e35,
	  "saraileftthai",
	  0xf885,
	  "saraithai",
	  0x0e34,
	  "saraothai",
	  0x0e42,
	  "saraueeleftthai",
	  0xf888,
	  "saraueethai",
	  0x0e37,
	  "saraueleftthai",
	  0xf887,
	  "sarauethai",
	  0x0e36,
	  "sarauthai",
	  0x0e38,
	  "sarauuthai",
	  0x0e39,
	  "sbopomofo",
	  0x3119,
	  "scaron",
	  0x0161,
	  "scarondotaccent",
	  0x1e67,
	  "scedilla",
	  0x015f,
	  "schwa",
	  0x0259,
	  "schwacyrillic",
	  0x04d9,
	  "schwadieresiscyrillic",
	  0x04db,
	  "schwahook",
	  0x025a,
	  "scircle",
	  0x24e2,
	  "scircumflex",
	  0x015d,
	  "scommaaccent",
	  0x0219,
	  "sdotaccent",
	  0x1e61,
	  "sdotbelow",
	  0x1e63,
	  "sdotbelowdotaccent",
	  0x1e69,
	  "seagullbelowcmb",
	  0x033c,
	  "second",
	  0x2033,
	  "secondtonechinese",
	  0x02ca,
	  "section",
	  0x00a7,
	  "seenarabic",
	  0x0633,
	  "seenfinalarabic",
	  0xfeb2,
	  "seeninitialarabic",
	  0xfeb3,
	  "seenmedialarabic",
	  0xfeb4,
	  "segol",
	  0x05b6,
	  "segol13",
	  0x05b6,
	  "segol1f",
	  0x05b6,
	  "segol2c",
	  0x05b6,
	  "segolhebrew",
	  0x05b6,
	  "segolnarrowhebrew",
	  0x05b6,
	  "segolquarterhebrew",
	  0x05b6,
	  "segoltahebrew",
	  0x0592,
	  "segolwidehebrew",
	  0x05b6,
	  "seharmenian",
	  0x057d,
	  "sehiragana",
	  0x305b,
	  "sekatakana",
	  0x30bb,
	  "sekatakanahalfwidth",
	  0xff7e,
	  "semicolon",
	  0x003b,
	  "semicolonarabic",
	  0x061b,
	  "semicolonmonospace",
	  0xff1b,
	  "semicolonsmall",
	  0xfe54,
	  "semivoicedmarkkana",
	  0x309c,
	  "semivoicedmarkkanahalfwidth",
	  0xff9f,
	  "sentisquare",
	  0x3322,
	  "sentosquare",
	  0x3323,
	  "seven",
	  0x0037,
	  "sevenarabic",
	  0x0667,
	  "sevenbengali",
	  0x09ed,
	  "sevencircle",
	  0x2466,
	  "sevencircleinversesansserif",
	  0x2790,
	  "sevendeva",
	  0x096d,
	  "seveneighths",
	  0x215e,
	  "sevengujarati",
	  0x0aed,
	  "sevengurmukhi",
	  0x0a6d,
	  "sevenhackarabic",
	  0x0667,
	  "sevenhangzhou",
	  0x3027,
	  "sevenideographicparen",
	  0x3226,
	  "seveninferior",
	  0x2087,
	  "sevenmonospace",
	  0xff17,
	  "sevenoldstyle",
	  0xf737,
	  "sevenparen",
	  0x247a,
	  "sevenperiod",
	  0x248e,
	  "sevenpersian",
	  0x06f7,
	  "sevenroman",
	  0x2176,
	  "sevensuperior",
	  0x2077,
	  "seventeencircle",
	  0x2470,
	  "seventeenparen",
	  0x2484,
	  "seventeenperiod",
	  0x2498,
	  "seventhai",
	  0x0e57,
	  "sfthyphen",
	  0x00ad,
	  "shaarmenian",
	  0x0577,
	  "shabengali",
	  0x09b6,
	  "shacyrillic",
	  0x0448,
	  "shaddaarabic",
	  0x0651,
	  "shaddadammaarabic",
	  0xfc61,
	  "shaddadammatanarabic",
	  0xfc5e,
	  "shaddafathaarabic",
	  0xfc60,
	  "shaddakasraarabic",
	  0xfc62,
	  "shaddakasratanarabic",
	  0xfc5f,
	  "shade",
	  0x2592,
	  "shadedark",
	  0x2593,
	  "shadelight",
	  0x2591,
	  "shademedium",
	  0x2592,
	  "shadeva",
	  0x0936,
	  "shagujarati",
	  0x0ab6,
	  "shagurmukhi",
	  0x0a36,
	  "shalshelethebrew",
	  0x0593,
	  "shbopomofo",
	  0x3115,
	  "shchacyrillic",
	  0x0449,
	  "sheenarabic",
	  0x0634,
	  "sheenfinalarabic",
	  0xfeb6,
	  "sheeninitialarabic",
	  0xfeb7,
	  "sheenmedialarabic",
	  0xfeb8,
	  "sheicoptic",
	  0x03e3,
	  "sheqel",
	  0x20aa,
	  "sheqelhebrew",
	  0x20aa,
	  "sheva",
	  0x05b0,
	  "sheva115",
	  0x05b0,
	  "sheva15",
	  0x05b0,
	  "sheva22",
	  0x05b0,
	  "sheva2e",
	  0x05b0,
	  "shevahebrew",
	  0x05b0,
	  "shevanarrowhebrew",
	  0x05b0,
	  "shevaquarterhebrew",
	  0x05b0,
	  "shevawidehebrew",
	  0x05b0,
	  "shhacyrillic",
	  0x04bb,
	  "shimacoptic",
	  0x03ed,
	  "shin",
	  0x05e9,
	  "shindagesh",
	  0xfb49,
	  "shindageshhebrew",
	  0xfb49,
	  "shindageshshindot",
	  0xfb2c,
	  "shindageshshindothebrew",
	  0xfb2c,
	  "shindageshsindot",
	  0xfb2d,
	  "shindageshsindothebrew",
	  0xfb2d,
	  "shindothebrew",
	  0x05c1,
	  "shinhebrew",
	  0x05e9,
	  "shinshindot",
	  0xfb2a,
	  "shinshindothebrew",
	  0xfb2a,
	  "shinsindot",
	  0xfb2b,
	  "shinsindothebrew",
	  0xfb2b,
	  "shook",
	  0x0282,
	  "sigma",
	  0x03c3,
	  "sigma1",
	  0x03c2,
	  "sigmafinal",
	  0x03c2,
	  "sigmalunatesymbolgreek",
	  0x03f2,
	  "sihiragana",
	  0x3057,
	  "sikatakana",
	  0x30b7,
	  "sikatakanahalfwidth",
	  0xff7c,
	  "siluqhebrew",
	  0x05bd,
	  "siluqlefthebrew",
	  0x05bd,
	  "similar",
	  0x223c,
	  "sindothebrew",
	  0x05c2,
	  "siosacirclekorean",
	  0x3274,
	  "siosaparenkorean",
	  0x3214,
	  "sioscieuckorean",
	  0x317e,
	  "sioscirclekorean",
	  0x3266,
	  "sioskiyeokkorean",
	  0x317a,
	  "sioskorean",
	  0x3145,
	  "siosnieunkorean",
	  0x317b,
	  "siosparenkorean",
	  0x3206,
	  "siospieupkorean",
	  0x317d,
	  "siostikeutkorean",
	  0x317c,
	  "six",
	  0x0036,
	  "sixarabic",
	  0x0666,
	  "sixbengali",
	  0x09ec,
	  "sixcircle",
	  0x2465,
	  "sixcircleinversesansserif",
	  0x278f,
	  "sixdeva",
	  0x096c,
	  "sixgujarati",
	  0x0aec,
	  "sixgurmukhi",
	  0x0a6c,
	  "sixhackarabic",
	  0x0666,
	  "sixhangzhou",
	  0x3026,
	  "sixideographicparen",
	  0x3225,
	  "sixinferior",
	  0x2086,
	  "sixmonospace",
	  0xff16,
	  "sixoldstyle",
	  0xf736,
	  "sixparen",
	  0x2479,
	  "sixperiod",
	  0x248d,
	  "sixpersian",
	  0x06f6,
	  "sixroman",
	  0x2175,
	  "sixsuperior",
	  0x2076,
	  "sixteencircle",
	  0x246f,
	  "sixteencurrencydenominatorbengali",
	  0x09f9,
	  "sixteenparen",
	  0x2483,
	  "sixteenperiod",
	  0x2497,
	  "sixthai",
	  0x0e56,
	  "slash",
	  0x002f,
	  "slashmonospace",
	  0xff0f,
	  "slong",
	  0x017f,
	  "slongdotaccent",
	  0x1e9b,
	  "smileface",
	  0x263a,
	  "smonospace",
	  0xff53,
	  "sofpasuqhebrew",
	  0x05c3,
	  "softhyphen",
	  0x00ad,
	  "softsigncyrillic",
	  0x044c,
	  "sohiragana",
	  0x305d,
	  "sokatakana",
	  0x30bd,
	  "sokatakanahalfwidth",
	  0xff7f,
	  "soliduslongoverlaycmb",
	  0x0338,
	  "solidusshortoverlaycmb",
	  0x0337,
	  "sorusithai",
	  0x0e29,
	  "sosalathai",
	  0x0e28,
	  "sosothai",
	  0x0e0b,
	  "sosuathai",
	  0x0e2a,
	  "space",
	  0x0020,
	  "spacehackarabic",
	  0x0020,
	  "spade",
	  0x2660,
	  "spadesuitblack",
	  0x2660,
	  "spadesuitwhite",
	  0x2664,
	  "sparen",
	  0x24ae,
	  "squarebelowcmb",
	  0x033b,
	  "squarecc",
	  0x33c4,
	  "squarecm",
	  0x339d,
	  "squarediagonalcrosshatchfill",
	  0x25a9,
	  "squarehorizontalfill",
	  0x25a4,
	  "squarekg",
	  0x338f,
	  "squarekm",
	  0x339e,
	  "squarekmcapital",
	  0x33ce,
	  "squareln",
	  0x33d1,
	  "squarelog",
	  0x33d2,
	  "squaremg",
	  0x338e,
	  "squaremil",
	  0x33d5,
	  "squaremm",
	  0x339c,
	  "squaremsquared",
	  0x33a1,
	  "squareorthogonalcrosshatchfill",
	  0x25a6,
	  "squareupperlefttolowerrightfill",
	  0x25a7,
	  "squareupperrighttolowerleftfill",
	  0x25a8,
	  "squareverticalfill",
	  0x25a5,
	  "squarewhitewithsmallblack",
	  0x25a3,
	  "srsquare",
	  0x33db,
	  "ssabengali",
	  0x09b7,
	  "ssadeva",
	  0x0937,
	  "ssagujarati",
	  0x0ab7,
	  "ssangcieuckorean",
	  0x3149,
	  "ssanghieuhkorean",
	  0x3185,
	  "ssangieungkorean",
	  0x3180,
	  "ssangkiyeokkorean",
	  0x3132,
	  "ssangnieunkorean",
	  0x3165,
	  "ssangpieupkorean",
	  0x3143,
	  "ssangsioskorean",
	  0x3146,
	  "ssangtikeutkorean",
	  0x3138,
	  "ssuperior",
	  0xf6f2,
	  "sterling",
	  0x00a3,
	  "sterlingmonospace",
	  0xffe1,
	  "strokelongoverlaycmb",
	  0x0336,
	  "strokeshortoverlaycmb",
	  0x0335,
	  "subset",
	  0x2282,
	  "subsetnotequal",
	  0x228a,
	  "subsetorequal",
	  0x2286,
	  "succeeds",
	  0x227b,
	  "suchthat",
	  0x220b,
	  "suhiragana",
	  0x3059,
	  "sukatakana",
	  0x30b9,
	  "sukatakanahalfwidth",
	  0xff7d,
	  "sukunarabic",
	  0x0652,
	  "summation",
	  0x2211,
	  "sun",
	  0x263c,
	  "superset",
	  0x2283,
	  "supersetnotequal",
	  0x228b,
	  "supersetorequal",
	  0x2287,
	  "svsquare",
	  0x33dc,
	  "syouwaerasquare",
	  0x337c,
	  "t",
	  0x0074,
	  "tabengali",
	  0x09a4,
	  "tackdown",
	  0x22a4,
	  "tackleft",
	  0x22a3,
	  "tadeva",
	  0x0924,
	  "tagujarati",
	  0x0aa4,
	  "tagurmukhi",
	  0x0a24,
	  "taharabic",
	  0x0637,
	  "tahfinalarabic",
	  0xfec2,
	  "tahinitialarabic",
	  0xfec3,
	  "tahiragana",
	  0x305f,
	  "tahmedialarabic",
	  0xfec4,
	  "taisyouerasquare",
	  0x337d,
	  "takatakana",
	  0x30bf,
	  "takatakanahalfwidth",
	  0xff80,
	  "tatweelarabic",
	  0x0640,
	  "tau",
	  0x03c4,
	  "tav",
	  0x05ea,
	  "tavdages",
	  0xfb4a,
	  "tavdagesh",
	  0xfb4a,
	  "tavdageshhebrew",
	  0xfb4a,
	  "tavhebrew",
	  0x05ea,
	  "tbar",
	  0x0167,
	  "tbopomofo",
	  0x310a,
	  "tcaron",
	  0x0165,
	  "tccurl",
	  0x02a8,
	  "tcedilla",
	  0x0163,
	  "tcheharabic",
	  0x0686,
	  "tchehfinalarabic",
	  0xfb7b,
	  "tchehinitialarabic",
	  0xfb7c,
	  "tchehmedialarabic",
	  0xfb7d,
	  "tcircle",
	  0x24e3,
	  "tcircumflexbelow",
	  0x1e71,
	  "tcommaaccent",
	  0x0163,
	  "tdieresis",
	  0x1e97,
	  "tdotaccent",
	  0x1e6b,
	  "tdotbelow",
	  0x1e6d,
	  "tecyrillic",
	  0x0442,
	  "tedescendercyrillic",
	  0x04ad,
	  "teharabic",
	  0x062a,
	  "tehfinalarabic",
	  0xfe96,
	  "tehhahinitialarabic",
	  0xfca2,
	  "tehhahisolatedarabic",
	  0xfc0c,
	  "tehinitialarabic",
	  0xfe97,
	  "tehiragana",
	  0x3066,
	  "tehjeeminitialarabic",
	  0xfca1,
	  "tehjeemisolatedarabic",
	  0xfc0b,
	  "tehmarbutaarabic",
	  0x0629,
	  "tehmarbutafinalarabic",
	  0xfe94,
	  "tehmedialarabic",
	  0xfe98,
	  "tehmeeminitialarabic",
	  0xfca4,
	  "tehmeemisolatedarabic",
	  0xfc0e,
	  "tehnoonfinalarabic",
	  0xfc73,
	  "tekatakana",
	  0x30c6,
	  "tekatakanahalfwidth",
	  0xff83,
	  "telephone",
	  0x2121,
	  "telephoneblack",
	  0x260e,
	  "telishagedolahebrew",
	  0x05a0,
	  "telishaqetanahebrew",
	  0x05a9,
	  "tencircle",
	  0x2469,
	  "tenideographicparen",
	  0x3229,
	  "tenparen",
	  0x247d,
	  "tenperiod",
	  0x2491,
	  "tenroman",
	  0x2179,
	  "tesh",
	  0x02a7,
	  "tet",
	  0x05d8,
	  "tetdagesh",
	  0xfb38,
	  "tetdageshhebrew",
	  0xfb38,
	  "tethebrew",
	  0x05d8,
	  "tetsecyrillic",
	  0x04b5,
	  "tevirhebrew",
	  0x059b,
	  "tevirlefthebrew",
	  0x059b,
	  "thabengali",
	  0x09a5,
	  "thadeva",
	  0x0925,
	  "thagujarati",
	  0x0aa5,
	  "thagurmukhi",
	  0x0a25,
	  "thalarabic",
	  0x0630,
	  "thalfinalarabic",
	  0xfeac,
	  "thanthakhatlowleftthai",
	  0xf898,
	  "thanthakhatlowrightthai",
	  0xf897,
	  "thanthakhatthai",
	  0x0e4c,
	  "thanthakhatupperleftthai",
	  0xf896,
	  "theharabic",
	  0x062b,
	  "thehfinalarabic",
	  0xfe9a,
	  "thehinitialarabic",
	  0xfe9b,
	  "thehmedialarabic",
	  0xfe9c,
	  "thereexists",
	  0x2203,
	  "therefore",
	  0x2234,
	  "theta",
	  0x03b8,
	  "theta1",
	  0x03d1,
	  "thetasymbolgreek",
	  0x03d1,
	  "thieuthacirclekorean",
	  0x3279,
	  "thieuthaparenkorean",
	  0x3219,
	  "thieuthcirclekorean",
	  0x326b,
	  "thieuthkorean",
	  0x314c,
	  "thieuthparenkorean",
	  0x320b,
	  "thirteencircle",
	  0x246c,
	  "thirteenparen",
	  0x2480,
	  "thirteenperiod",
	  0x2494,
	  "thonangmonthothai",
	  0x0e11,
	  "thook",
	  0x01ad,
	  "thophuthaothai",
	  0x0e12,
	  "thorn",
	  0x00fe,
	  "thothahanthai",
	  0x0e17,
	  "thothanthai",
	  0x0e10,
	  "thothongthai",
	  0x0e18,
	  "thothungthai",
	  0x0e16,
	  "thousandcyrillic",
	  0x0482,
	  "thousandsseparatorarabic",
	  0x066c,
	  "thousandsseparatorpersian",
	  0x066c,
	  "three",
	  0x0033,
	  "threearabic",
	  0x0663,
	  "threebengali",
	  0x09e9,
	  "threecircle",
	  0x2462,
	  "threecircleinversesansserif",
	  0x278c,
	  "threedeva",
	  0x0969,
	  "threeeighths",
	  0x215c,
	  "threegujarati",
	  0x0ae9,
	  "threegurmukhi",
	  0x0a69,
	  "threehackarabic",
	  0x0663,
	  "threehangzhou",
	  0x3023,
	  "threeideographicparen",
	  0x3222,
	  "threeinferior",
	  0x2083,
	  "threemonospace",
	  0xff13,
	  "threenumeratorbengali",
	  0x09f6,
	  "threeoldstyle",
	  0xf733,
	  "threeparen",
	  0x2476,
	  "threeperiod",
	  0x248a,
	  "threepersian",
	  0x06f3,
	  "threequarters",
	  0x00be,
	  "threequartersemdash",
	  0xf6de,
	  "threeroman",
	  0x2172,
	  "threesuperior",
	  0x00b3,
	  "threethai",
	  0x0e53,
	  "thzsquare",
	  0x3394,
	  "tihiragana",
	  0x3061,
	  "tikatakana",
	  0x30c1,
	  "tikatakanahalfwidth",
	  0xff81,
	  "tikeutacirclekorean",
	  0x3270,
	  "tikeutaparenkorean",
	  0x3210,
	  "tikeutcirclekorean",
	  0x3262,
	  "tikeutkorean",
	  0x3137,
	  "tikeutparenkorean",
	  0x3202,
	  "tilde",
	  0x02dc,
	  "tildebelowcmb",
	  0x0330,
	  "tildecmb",
	  0x0303,
	  "tildecomb",
	  0x0303,
	  "tildedoublecmb",
	  0x0360,
	  "tildeoperator",
	  0x223c,
	  "tildeoverlaycmb",
	  0x0334,
	  "tildeverticalcmb",
	  0x033e,
	  "timescircle",
	  0x2297,
	  "tipehahebrew",
	  0x0596,
	  "tipehalefthebrew",
	  0x0596,
	  "tippigurmukhi",
	  0x0a70,
	  "titlocyrilliccmb",
	  0x0483,
	  "tiwnarmenian",
	  0x057f,
	  "tlinebelow",
	  0x1e6f,
	  "tmonospace",
	  0xff54,
	  "toarmenian",
	  0x0569,
	  "tohiragana",
	  0x3068,
	  "tokatakana",
	  0x30c8,
	  "tokatakanahalfwidth",
	  0xff84,
	  "tonebarextrahighmod",
	  0x02e5,
	  "tonebarextralowmod",
	  0x02e9,
	  "tonebarhighmod",
	  0x02e6,
	  "tonebarlowmod",
	  0x02e8,
	  "tonebarmidmod",
	  0x02e7,
	  "tonefive",
	  0x01bd,
	  "tonesix",
	  0x0185,
	  "tonetwo",
	  0x01a8,
	  "tonos",
	  0x0384,
	  "tonsquare",
	  0x3327,
	  "topatakthai",
	  0x0e0f,
	  "tortoiseshellbracketleft",
	  0x3014,
	  "tortoiseshellbracketleftsmall",
	  0xfe5d,
	  "tortoiseshellbracketleftvertical",
	  0xfe39,
	  "tortoiseshellbracketright",
	  0x3015,
	  "tortoiseshellbracketrightsmall",
	  0xfe5e,
	  "tortoiseshellbracketrightvertical",
	  0xfe3a,
	  "totaothai",
	  0x0e15,
	  "tpalatalhook",
	  0x01ab,
	  "tparen",
	  0x24af,
	  "trademark",
	  0x2122,
	  "trademarksans",
	  0xf8ea,
	  "trademarkserif",
	  0xf6db,
	  "tretroflexhook",
	  0x0288,
	  "triagdn",
	  0x25bc,
	  "triaglf",
	  0x25c4,
	  "triagrt",
	  0x25ba,
	  "triagup",
	  0x25b2,
	  "ts",
	  0x02a6,
	  "tsadi",
	  0x05e6,
	  "tsadidagesh",
	  0xfb46,
	  "tsadidageshhebrew",
	  0xfb46,
	  "tsadihebrew",
	  0x05e6,
	  "tsecyrillic",
	  0x0446,
	  "tsere",
	  0x05b5,
	  "tsere12",
	  0x05b5,
	  "tsere1e",
	  0x05b5,
	  "tsere2b",
	  0x05b5,
	  "tserehebrew",
	  0x05b5,
	  "tserenarrowhebrew",
	  0x05b5,
	  "tserequarterhebrew",
	  0x05b5,
	  "tserewidehebrew",
	  0x05b5,
	  "tshecyrillic",
	  0x045b,
	  "tsuperior",
	  0xf6f3,
	  "ttabengali",
	  0x099f,
	  "ttadeva",
	  0x091f,
	  "ttagujarati",
	  0x0a9f,
	  "ttagurmukhi",
	  0x0a1f,
	  "tteharabic",
	  0x0679,
	  "ttehfinalarabic",
	  0xfb67,
	  "ttehinitialarabic",
	  0xfb68,
	  "ttehmedialarabic",
	  0xfb69,
	  "tthabengali",
	  0x09a0,
	  "tthadeva",
	  0x0920,
	  "tthagujarati",
	  0x0aa0,
	  "tthagurmukhi",
	  0x0a20,
	  "tturned",
	  0x0287,
	  "tuhiragana",
	  0x3064,
	  "tukatakana",
	  0x30c4,
	  "tukatakanahalfwidth",
	  0xff82,
	  "tusmallhiragana",
	  0x3063,
	  "tusmallkatakana",
	  0x30c3,
	  "tusmallkatakanahalfwidth",
	  0xff6f,
	  "twelvecircle",
	  0x246b,
	  "twelveparen",
	  0x247f,
	  "twelveperiod",
	  0x2493,
	  "twelveroman",
	  0x217b,
	  "twentycircle",
	  0x2473,
	  "twentyhangzhou",
	  0x5344,
	  "twentyparen",
	  0x2487,
	  "twentyperiod",
	  0x249b,
	  "two",
	  0x0032,
	  "twoarabic",
	  0x0662,
	  "twobengali",
	  0x09e8,
	  "twocircle",
	  0x2461,
	  "twocircleinversesansserif",
	  0x278b,
	  "twodeva",
	  0x0968,
	  "twodotenleader",
	  0x2025,
	  "twodotleader",
	  0x2025,
	  "twodotleadervertical",
	  0xfe30,
	  "twogujarati",
	  0x0ae8,
	  "twogurmukhi",
	  0x0a68,
	  "twohackarabic",
	  0x0662,
	  "twohangzhou",
	  0x3022,
	  "twoideographicparen",
	  0x3221,
	  "twoinferior",
	  0x2082,
	  "twomonospace",
	  0xff12,
	  "twonumeratorbengali",
	  0x09f5,
	  "twooldstyle",
	  0xf732,
	  "twoparen",
	  0x2475,
	  "twoperiod",
	  0x2489,
	  "twopersian",
	  0x06f2,
	  "tworoman",
	  0x2171,
	  "twostroke",
	  0x01bb,
	  "twosuperior",
	  0x00b2,
	  "twothai",
	  0x0e52,
	  "twothirds",
	  0x2154,
	  "u",
	  0x0075,
	  "uacute",
	  0x00fa,
	  "ubar",
	  0x0289,
	  "ubengali",
	  0x0989,
	  "ubopomofo",
	  0x3128,
	  "ubreve",
	  0x016d,
	  "ucaron",
	  0x01d4,
	  "ucircle",
	  0x24e4,
	  "ucircumflex",
	  0x00fb,
	  "ucircumflexbelow",
	  0x1e77,
	  "ucyrillic",
	  0x0443,
	  "udattadeva",
	  0x0951,
	  "udblacute",
	  0x0171,
	  "udblgrave",
	  0x0215,
	  "udeva",
	  0x0909,
	  "udieresis",
	  0x00fc,
	  "udieresisacute",
	  0x01d8,
	  "udieresisbelow",
	  0x1e73,
	  "udieresiscaron",
	  0x01da,
	  "udieresiscyrillic",
	  0x04f1,
	  "udieresisgrave",
	  0x01dc,
	  "udieresismacron",
	  0x01d6,
	  "udotbelow",
	  0x1ee5,
	  "ugrave",
	  0x00f9,
	  "ugujarati",
	  0x0a89,
	  "ugurmukhi",
	  0x0a09,
	  "uhiragana",
	  0x3046,
	  "uhookabove",
	  0x1ee7,
	  "uhorn",
	  0x01b0,
	  "uhornacute",
	  0x1ee9,
	  "uhorndotbelow",
	  0x1ef1,
	  "uhorngrave",
	  0x1eeb,
	  "uhornhookabove",
	  0x1eed,
	  "uhorntilde",
	  0x1eef,
	  "uhungarumlaut",
	  0x0171,
	  "uhungarumlautcyrillic",
	  0x04f3,
	  "uinvertedbreve",
	  0x0217,
	  "ukatakana",
	  0x30a6,
	  "ukatakanahalfwidth",
	  0xff73,
	  "ukcyrillic",
	  0x0479,
	  "ukorean",
	  0x315c,
	  "umacron",
	  0x016b,
	  "umacroncyrillic",
	  0x04ef,
	  "umacrondieresis",
	  0x1e7b,
	  "umatragurmukhi",
	  0x0a41,
	  "umonospace",
	  0xff55,
	  "underscore",
	  0x005f,
	  "underscoredbl",
	  0x2017,
	  "underscoremonospace",
	  0xff3f,
	  "underscorevertical",
	  0xfe33,
	  "underscorewavy",
	  0xfe4f,
	  "union",
	  0x222a,
	  "universal",
	  0x2200,
	  "uogonek",
	  0x0173,
	  "uparen",
	  0x24b0,
	  "upblock",
	  0x2580,
	  "upperdothebrew",
	  0x05c4,
	  "upsilon",
	  0x03c5,
	  "upsilondieresis",
	  0x03cb,
	  "upsilondieresistonos",
	  0x03b0,
	  "upsilonlatin",
	  0x028a,
	  "upsilontonos",
	  0x03cd,
	  "uptackbelowcmb",
	  0x031d,
	  "uptackmod",
	  0x02d4,
	  "uragurmukhi",
	  0x0a73,
	  "uring",
	  0x016f,
	  "ushortcyrillic",
	  0x045e,
	  "usmallhiragana",
	  0x3045,
	  "usmallkatakana",
	  0x30a5,
	  "usmallkatakanahalfwidth",
	  0xff69,
	  "ustraightcyrillic",
	  0x04af,
	  "ustraightstrokecyrillic",
	  0x04b1,
	  "utilde",
	  0x0169,
	  "utildeacute",
	  0x1e79,
	  "utildebelow",
	  0x1e75,
	  "uubengali",
	  0x098a,
	  "uudeva",
	  0x090a,
	  "uugujarati",
	  0x0a8a,
	  "uugurmukhi",
	  0x0a0a,
	  "uumatragurmukhi",
	  0x0a42,
	  "uuvowelsignbengali",
	  0x09c2,
	  "uuvowelsigndeva",
	  0x0942,
	  "uuvowelsigngujarati",
	  0x0ac2,
	  "uvowelsignbengali",
	  0x09c1,
	  "uvowelsigndeva",
	  0x0941,
	  "uvowelsigngujarati",
	  0x0ac1,
	  "v",
	  0x0076,
	  "vadeva",
	  0x0935,
	  "vagujarati",
	  0x0ab5,
	  "vagurmukhi",
	  0x0a35,
	  "vakatakana",
	  0x30f7,
	  "vav",
	  0x05d5,
	  "vavdagesh",
	  0xfb35,
	  "vavdagesh65",
	  0xfb35,
	  "vavdageshhebrew",
	  0xfb35,
	  "vavhebrew",
	  0x05d5,
	  "vavholam",
	  0xfb4b,
	  "vavholamhebrew",
	  0xfb4b,
	  "vavvavhebrew",
	  0x05f0,
	  "vavyodhebrew",
	  0x05f1,
	  "vcircle",
	  0x24e5,
	  "vdotbelow",
	  0x1e7f,
	  "vecyrillic",
	  0x0432,
	  "veharabic",
	  0x06a4,
	  "vehfinalarabic",
	  0xfb6b,
	  "vehinitialarabic",
	  0xfb6c,
	  "vehmedialarabic",
	  0xfb6d,
	  "vekatakana",
	  0x30f9,
	  "venus",
	  0x2640,
	  "verticalbar",
	  0x007c,
	  "verticallineabovecmb",
	  0x030d,
	  "verticallinebelowcmb",
	  0x0329,
	  "verticallinelowmod",
	  0x02cc,
	  "verticallinemod",
	  0x02c8,
	  "vewarmenian",
	  0x057e,
	  "vhook",
	  0x028b,
	  "vikatakana",
	  0x30f8,
	  "viramabengali",
	  0x09cd,
	  "viramadeva",
	  0x094d,
	  "viramagujarati",
	  0x0acd,
	  "visargabengali",
	  0x0983,
	  "visargadeva",
	  0x0903,
	  "visargagujarati",
	  0x0a83,
	  "vmonospace",
	  0xff56,
	  "voarmenian",
	  0x0578,
	  "voicediterationhiragana",
	  0x309e,
	  "voicediterationkatakana",
	  0x30fe,
	  "voicedmarkkana",
	  0x309b,
	  "voicedmarkkanahalfwidth",
	  0xff9e,
	  "vokatakana",
	  0x30fa,
	  "vparen",
	  0x24b1,
	  "vtilde",
	  0x1e7d,
	  "vturned",
	  0x028c,
	  "vuhiragana",
	  0x3094,
	  "vukatakana",
	  0x30f4,
	  "w",
	  0x0077,
	  "wacute",
	  0x1e83,
	  "waekorean",
	  0x3159,
	  "wahiragana",
	  0x308f,
	  "wakatakana",
	  0x30ef,
	  "wakatakanahalfwidth",
	  0xff9c,
	  "wakorean",
	  0x3158,
	  "wasmallhiragana",
	  0x308e,
	  "wasmallkatakana",
	  0x30ee,
	  "wattosquare",
	  0x3357,
	  "wavedash",
	  0x301c,
	  "wavyunderscorevertical",
	  0xfe34,
	  "wawarabic",
	  0x0648,
	  "wawfinalarabic",
	  0xfeee,
	  "wawhamzaabovearabic",
	  0x0624,
	  "wawhamzaabovefinalarabic",
	  0xfe86,
	  "wbsquare",
	  0x33dd,
	  "wcircle",
	  0x24e6,
	  "wcircumflex",
	  0x0175,
	  "wdieresis",
	  0x1e85,
	  "wdotaccent",
	  0x1e87,
	  "wdotbelow",
	  0x1e89,
	  "wehiragana",
	  0x3091,
	  "weierstrass",
	  0x2118,
	  "wekatakana",
	  0x30f1,
	  "wekorean",
	  0x315e,
	  "weokorean",
	  0x315d,
	  "wgrave",
	  0x1e81,
	  "whitebullet",
	  0x25e6,
	  "whitecircle",
	  0x25cb,
	  "whitecircleinverse",
	  0x25d9,
	  "whitecornerbracketleft",
	  0x300e,
	  "whitecornerbracketleftvertical",
	  0xfe43,
	  "whitecornerbracketright",
	  0x300f,
	  "whitecornerbracketrightvertical",
	  0xfe44,
	  "whitediamond",
	  0x25c7,
	  "whitediamondcontainingblacksmalldiamond",
	  0x25c8,
	  "whitedownpointingsmalltriangle",
	  0x25bf,
	  "whitedownpointingtriangle",
	  0x25bd,
	  "whiteleftpointingsmalltriangle",
	  0x25c3,
	  "whiteleftpointingtriangle",
	  0x25c1,
	  "whitelenticularbracketleft",
	  0x3016,
	  "whitelenticularbracketright",
	  0x3017,
	  "whiterightpointingsmalltriangle",
	  0x25b9,
	  "whiterightpointingtriangle",
	  0x25b7,
	  "whitesmallsquare",
	  0x25ab,
	  "whitesmilingface",
	  0x263a,
	  "whitesquare",
	  0x25a1,
	  "whitestar",
	  0x2606,
	  "whitetelephone",
	  0x260f,
	  "whitetortoiseshellbracketleft",
	  0x3018,
	  "whitetortoiseshellbracketright",
	  0x3019,
	  "whiteuppointingsmalltriangle",
	  0x25b5,
	  "whiteuppointingtriangle",
	  0x25b3,
	  "wihiragana",
	  0x3090,
	  "wikatakana",
	  0x30f0,
	  "wikorean",
	  0x315f,
	  "wmonospace",
	  0xff57,
	  "wohiragana",
	  0x3092,
	  "wokatakana",
	  0x30f2,
	  "wokatakanahalfwidth",
	  0xff66,
	  "won",
	  0x20a9,
	  "wonmonospace",
	  0xffe6,
	  "wowaenthai",
	  0x0e27,
	  "wparen",
	  0x24b2,
	  "wring",
	  0x1e98,
	  "wsuperior",
	  0x02b7,
	  "wturned",
	  0x028d,
	  "wynn",
	  0x01bf,
	  "x",
	  0x0078,
	  "xabovecmb",
	  0x033d,
	  "xbopomofo",
	  0x3112,
	  "xcircle",
	  0x24e7,
	  "xdieresis",
	  0x1e8d,
	  "xdotaccent",
	  0x1e8b,
	  "xeharmenian",
	  0x056d,
	  "xi",
	  0x03be,
	  "xmonospace",
	  0xff58,
	  "xparen",
	  0x24b3,
	  "xsuperior",
	  0x02e3,
	  "y",
	  0x0079,
	  "yaadosquare",
	  0x334e,
	  "yabengali",
	  0x09af,
	  "yacute",
	  0x00fd,
	  "yadeva",
	  0x092f,
	  "yaekorean",
	  0x3152,
	  "yagujarati",
	  0x0aaf,
	  "yagurmukhi",
	  0x0a2f,
	  "yahiragana",
	  0x3084,
	  "yakatakana",
	  0x30e4,
	  "yakatakanahalfwidth",
	  0xff94,
	  "yakorean",
	  0x3151,
	  "yamakkanthai",
	  0x0e4e,
	  "yasmallhiragana",
	  0x3083,
	  "yasmallkatakana",
	  0x30e3,
	  "yasmallkatakanahalfwidth",
	  0xff6c,
	  "yatcyrillic",
	  0x0463,
	  "ycircle",
	  0x24e8,
	  "ycircumflex",
	  0x0177,
	  "ydieresis",
	  0x00ff,
	  "ydotaccent",
	  0x1e8f,
	  "ydotbelow",
	  0x1ef5,
	  "yeharabic",
	  0x064a,
	  "yehbarreearabic",
	  0x06d2,
	  "yehbarreefinalarabic",
	  0xfbaf,
	  "yehfinalarabic",
	  0xfef2,
	  "yehhamzaabovearabic",
	  0x0626,
	  "yehhamzaabovefinalarabic",
	  0xfe8a,
	  "yehhamzaaboveinitialarabic",
	  0xfe8b,
	  "yehhamzaabovemedialarabic",
	  0xfe8c,
	  "yehinitialarabic",
	  0xfef3,
	  "yehmedialarabic",
	  0xfef4,
	  "yehmeeminitialarabic",
	  0xfcdd,
	  "yehmeemisolatedarabic",
	  0xfc58,
	  "yehnoonfinalarabic",
	  0xfc94,
	  "yehthreedotsbelowarabic",
	  0x06d1,
	  "yekorean",
	  0x3156,
	  "yen",
	  0x00a5,
	  "yenmonospace",
	  0xffe5,
	  "yeokorean",
	  0x3155,
	  "yeorinhieuhkorean",
	  0x3186,
	  "yerahbenyomohebrew",
	  0x05aa,
	  "yerahbenyomolefthebrew",
	  0x05aa,
	  "yericyrillic",
	  0x044b,
	  "yerudieresiscyrillic",
	  0x04f9,
	  "yesieungkorean",
	  0x3181,
	  "yesieungpansioskorean",
	  0x3183,
	  "yesieungsioskorean",
	  0x3182,
	  "yetivhebrew",
	  0x059a,
	  "ygrave",
	  0x1ef3,
	  "yhook",
	  0x01b4,
	  "yhookabove",
	  0x1ef7,
	  "yiarmenian",
	  0x0575,
	  "yicyrillic",
	  0x0457,
	  "yikorean",
	  0x3162,
	  "yinyang",
	  0x262f,
	  "yiwnarmenian",
	  0x0582,
	  "ymonospace",
	  0xff59,
	  "yod",
	  0x05d9,
	  "yoddagesh",
	  0xfb39,
	  "yoddageshhebrew",
	  0xfb39,
	  "yodhebrew",
	  0x05d9,
	  "yodyodhebrew",
	  0x05f2,
	  "yodyodpatahhebrew",
	  0xfb1f,
	  "yohiragana",
	  0x3088,
	  "yoikorean",
	  0x3189,
	  "yokatakana",
	  0x30e8,
	  "yokatakanahalfwidth",
	  0xff96,
	  "yokorean",
	  0x315b,
	  "yosmallhiragana",
	  0x3087,
	  "yosmallkatakana",
	  0x30e7,
	  "yosmallkatakanahalfwidth",
	  0xff6e,
	  "yotgreek",
	  0x03f3,
	  "yoyaekorean",
	  0x3188,
	  "yoyakorean",
	  0x3187,
	  "yoyakthai",
	  0x0e22,
	  "yoyingthai",
	  0x0e0d,
	  "yparen",
	  0x24b4,
	  "ypogegrammeni",
	  0x037a,
	  "ypogegrammenigreekcmb",
	  0x0345,
	  "yr",
	  0x01a6,
	  "yring",
	  0x1e99,
	  "ysuperior",
	  0x02b8,
	  "ytilde",
	  0x1ef9,
	  "yturned",
	  0x028e,
	  "yuhiragana",
	  0x3086,
	  "yuikorean",
	  0x318c,
	  "yukatakana",
	  0x30e6,
	  "yukatakanahalfwidth",
	  0xff95,
	  "yukorean",
	  0x3160,
	  "yusbigcyrillic",
	  0x046b,
	  "yusbigiotifiedcyrillic",
	  0x046d,
	  "yuslittlecyrillic",
	  0x0467,
	  "yuslittleiotifiedcyrillic",
	  0x0469,
	  "yusmallhiragana",
	  0x3085,
	  "yusmallkatakana",
	  0x30e5,
	  "yusmallkatakanahalfwidth",
	  0xff6d,
	  "yuyekorean",
	  0x318b,
	  "yuyeokorean",
	  0x318a,
	  "yyabengali",
	  0x09df,
	  "yyadeva",
	  0x095f,
	  "z",
	  0x007a,
	  "zaarmenian",
	  0x0566,
	  "zacute",
	  0x017a,
	  "zadeva",
	  0x095b,
	  "zagurmukhi",
	  0x0a5b,
	  "zaharabic",
	  0x0638,
	  "zahfinalarabic",
	  0xfec6,
	  "zahinitialarabic",
	  0xfec7,
	  "zahiragana",
	  0x3056,
	  "zahmedialarabic",
	  0xfec8,
	  "zainarabic",
	  0x0632,
	  "zainfinalarabic",
	  0xfeb0,
	  "zakatakana",
	  0x30b6,
	  "zaqefgadolhebrew",
	  0x0595,
	  "zaqefqatanhebrew",
	  0x0594,
	  "zarqahebrew",
	  0x0598,
	  "zayin",
	  0x05d6,
	  "zayindagesh",
	  0xfb36,
	  "zayindageshhebrew",
	  0xfb36,
	  "zayinhebrew",
	  0x05d6,
	  "zbopomofo",
	  0x3117,
	  "zcaron",
	  0x017e,
	  "zcircle",
	  0x24e9,
	  "zcircumflex",
	  0x1e91,
	  "zcurl",
	  0x0291,
	  "zdot",
	  0x017c,
	  "zdotaccent",
	  0x017c,
	  "zdotbelow",
	  0x1e93,
	  "zecyrillic",
	  0x0437,
	  "zedescendercyrillic",
	  0x0499,
	  "zedieresiscyrillic",
	  0x04df,
	  "zehiragana",
	  0x305c,
	  "zekatakana",
	  0x30bc,
	  "zero",
	  0x0030,
	  "zeroarabic",
	  0x0660,
	  "zerobengali",
	  0x09e6,
	  "zerodeva",
	  0x0966,
	  "zerogujarati",
	  0x0ae6,
	  "zerogurmukhi",
	  0x0a66,
	  "zerohackarabic",
	  0x0660,
	  "zeroinferior",
	  0x2080,
	  "zeromonospace",
	  0xff10,
	  "zerooldstyle",
	  0xf730,
	  "zeropersian",
	  0x06f0,
	  "zerosuperior",
	  0x2070,
	  "zerothai",
	  0x0e50,
	  "zerowidthjoiner",
	  0xfeff,
	  "zerowidthnonjoiner",
	  0x200c,
	  "zerowidthspace",
	  0x200b,
	  "zeta",
	  0x03b6,
	  "zhbopomofo",
	  0x3113,
	  "zhearmenian",
	  0x056a,
	  "zhebrevecyrillic",
	  0x04c2,
	  "zhecyrillic",
	  0x0436,
	  "zhedescendercyrillic",
	  0x0497,
	  "zhedieresiscyrillic",
	  0x04dd,
	  "zihiragana",
	  0x3058,
	  "zikatakana",
	  0x30b8,
	  "zinorhebrew",
	  0x05ae,
	  "zlinebelow",
	  0x1e95,
	  "zmonospace",
	  0xff5a,
	  "zohiragana",
	  0x305e,
	  "zokatakana",
	  0x30be,
	  "zparen",
	  0x24b5,
	  "zretroflexhook",
	  0x0290,
	  "zstroke",
	  0x01b6,
	  "zuhiragana",
	  0x305a,
	  "zukatakana",
	  0x30ba,
	  ".notdef",
	  0x0000,
	  "angbracketleftbig",
	  0x2329,
	  "angbracketleftBig",
	  0x2329,
	  "angbracketleftbigg",
	  0x2329,
	  "angbracketleftBigg",
	  0x2329,
	  "angbracketrightBig",
	  0x232a,
	  "angbracketrightbig",
	  0x232a,
	  "angbracketrightBigg",
	  0x232a,
	  "angbracketrightbigg",
	  0x232a,
	  "arrowhookleft",
	  0x21aa,
	  "arrowhookright",
	  0x21a9,
	  "arrowlefttophalf",
	  0x21bc,
	  "arrowleftbothalf",
	  0x21bd,
	  "arrownortheast",
	  0x2197,
	  "arrownorthwest",
	  0x2196,
	  "arrowrighttophalf",
	  0x21c0,
	  "arrowrightbothalf",
	  0x21c1,
	  "arrowsoutheast",
	  0x2198,
	  "arrowsouthwest",
	  0x2199,
	  "backslashbig",
	  0x2216,
	  "backslashBig",
	  0x2216,
	  "backslashBigg",
	  0x2216,
	  "backslashbigg",
	  0x2216,
	  "bardbl",
	  0x2016,
	  "bracehtipdownleft",
	  0xfe37,
	  "bracehtipdownright",
	  0xfe37,
	  "bracehtipupleft",
	  0xfe38,
	  "bracehtipupright",
	  0xfe38,
	  "braceleftBig",
	  0x007b,
	  "braceleftbig",
	  0x007b,
	  "braceleftbigg",
	  0x007b,
	  "braceleftBigg",
	  0x007b,
	  "bracerightBig",
	  0x007d,
	  "bracerightbig",
	  0x007d,
	  "bracerightbigg",
	  0x007d,
	  "bracerightBigg",
	  0x007d,
	  "bracketleftbig",
	  0x005b,
	  "bracketleftBig",
	  0x005b,
	  "bracketleftbigg",
	  0x005b,
	  "bracketleftBigg",
	  0x005b,
	  "bracketrightBig",
	  0x005d,
	  "bracketrightbig",
	  0x005d,
	  "bracketrightbigg",
	  0x005d,
	  "bracketrightBigg",
	  0x005d,
	  "ceilingleftbig",
	  0x2308,
	  "ceilingleftBig",
	  0x2308,
	  "ceilingleftBigg",
	  0x2308,
	  "ceilingleftbigg",
	  0x2308,
	  "ceilingrightbig",
	  0x2309,
	  "ceilingrightBig",
	  0x2309,
	  "ceilingrightbigg",
	  0x2309,
	  "ceilingrightBigg",
	  0x2309,
	  "circledotdisplay",
	  0x2299,
	  "circledottext",
	  0x2299,
	  "circlemultiplydisplay",
	  0x2297,
	  "circlemultiplytext",
	  0x2297,
	  "circleplusdisplay",
	  0x2295,
	  "circleplustext",
	  0x2295,
	  "contintegraldisplay",
	  0x222e,
	  "contintegraltext",
	  0x222e,
	  "coproductdisplay",
	  0x2210,
	  "coproducttext",
	  0x2210,
	  "floorleftBig",
	  0x230a,
	  "floorleftbig",
	  0x230a,
	  "floorleftbigg",
	  0x230a,
	  "floorleftBigg",
	  0x230a,
	  "floorrightbig",
	  0x230b,
	  "floorrightBig",
	  0x230b,
	  "floorrightBigg",
	  0x230b,
	  "floorrightbigg",
	  0x230b,
	  "hatwide",
	  0x0302,
	  "hatwider",
	  0x0302,
	  "hatwidest",
	  0x0302,
	  "intercal",
	  0x1d40,
	  "integraldisplay",
	  0x222b,
	  "integraltext",
	  0x222b,
	  "intersectiondisplay",
	  0x22c2,
	  "intersectiontext",
	  0x22c2,
	  "logicalanddisplay",
	  0x2227,
	  "logicalandtext",
	  0x2227,
	  "logicalordisplay",
	  0x2228,
	  "logicalortext",
	  0x2228,
	  "parenleftBig",
	  0x0028,
	  "parenleftbig",
	  0x0028,
	  "parenleftBigg",
	  0x0028,
	  "parenleftbigg",
	  0x0028,
	  "parenrightBig",
	  0x0029,
	  "parenrightbig",
	  0x0029,
	  "parenrightBigg",
	  0x0029,
	  "parenrightbigg",
	  0x0029,
	  "prime",
	  0x2032,
	  "productdisplay",
	  0x220f,
	  "producttext",
	  0x220f,
	  "radicalbig",
	  0x221a,
	  "radicalBig",
	  0x221a,
	  "radicalBigg",
	  0x221a,
	  "radicalbigg",
	  0x221a,
	  "radicalbt",
	  0x221a,
	  "radicaltp",
	  0x221a,
	  "radicalvertex",
	  0x221a,
	  "slashbig",
	  0x002f,
	  "slashBig",
	  0x002f,
	  "slashBigg",
	  0x002f,
	  "slashbigg",
	  0x002f,
	  "summationdisplay",
	  0x2211,
	  "summationtext",
	  0x2211,
	  "tildewide",
	  0x02dc,
	  "tildewider",
	  0x02dc,
	  "tildewidest",
	  0x02dc,
	  "uniondisplay",
	  0x22c3,
	  "unionmultidisplay",
	  0x228e,
	  "unionmultitext",
	  0x228e,
	  "unionsqdisplay",
	  0x2294,
	  "unionsqtext",
	  0x2294,
	  "uniontext",
	  0x22c3,
	  "vextenddouble",
	  0x2225,
	  "vextendsingle",
	  0x2223
	 ];
	});
	const getDingbatsGlyphsUnicode = (0, _core_utils_js__WEBPACK_IMPORTED_MODULE_0__.getArrayLookupTableFactory)(function () {
	 return [
	  "space",
	  0x0020,
	  "a1",
	  0x2701,
	  "a2",
	  0x2702,
	  "a202",
	  0x2703,
	  "a3",
	  0x2704,
	  "a4",
	  0x260e,
	  "a5",
	  0x2706,
	  "a119",
	  0x2707,
	  "a118",
	  0x2708,
	  "a117",
	  0x2709,
	  "a11",
	  0x261b,
	  "a12",
	  0x261e,
	  "a13",
	  0x270c,
	  "a14",
	  0x270d,
	  "a15",
	  0x270e,
	  "a16",
	  0x270f,
	  "a105",
	  0x2710,
	  "a17",
	  0x2711,
	  "a18",
	  0x2712,
	  "a19",
	  0x2713,
	  "a20",
	  0x2714,
	  "a21",
	  0x2715,
	  "a22",
	  0x2716,
	  "a23",
	  0x2717,
	  "a24",
	  0x2718,
	  "a25",
	  0x2719,
	  "a26",
	  0x271a,
	  "a27",
	  0x271b,
	  "a28",
	  0x271c,
	  "a6",
	  0x271d,
	  "a7",
	  0x271e,
	  "a8",
	  0x271f,
	  "a9",
	  0x2720,
	  "a10",
	  0x2721,
	  "a29",
	  0x2722,
	  "a30",
	  0x2723,
	  "a31",
	  0x2724,
	  "a32",
	  0x2725,
	  "a33",
	  0x2726,
	  "a34",
	  0x2727,
	  "a35",
	  0x2605,
	  "a36",
	  0x2729,
	  "a37",
	  0x272a,
	  "a38",
	  0x272b,
	  "a39",
	  0x272c,
	  "a40",
	  0x272d,
	  "a41",
	  0x272e,
	  "a42",
	  0x272f,
	  "a43",
	  0x2730,
	  "a44",
	  0x2731,
	  "a45",
	  0x2732,
	  "a46",
	  0x2733,
	  "a47",
	  0x2734,
	  "a48",
	  0x2735,
	  "a49",
	  0x2736,
	  "a50",
	  0x2737,
	  "a51",
	  0x2738,
	  "a52",
	  0x2739,
	  "a53",
	  0x273a,
	  "a54",
	  0x273b,
	  "a55",
	  0x273c,
	  "a56",
	  0x273d,
	  "a57",
	  0x273e,
	  "a58",
	  0x273f,
	  "a59",
	  0x2740,
	  "a60",
	  0x2741,
	  "a61",
	  0x2742,
	  "a62",
	  0x2743,
	  "a63",
	  0x2744,
	  "a64",
	  0x2745,
	  "a65",
	  0x2746,
	  "a66",
	  0x2747,
	  "a67",
	  0x2748,
	  "a68",
	  0x2749,
	  "a69",
	  0x274a,
	  "a70",
	  0x274b,
	  "a71",
	  0x25cf,
	  "a72",
	  0x274d,
	  "a73",
	  0x25a0,
	  "a74",
	  0x274f,
	  "a203",
	  0x2750,
	  "a75",
	  0x2751,
	  "a204",
	  0x2752,
	  "a76",
	  0x25b2,
	  "a77",
	  0x25bc,
	  "a78",
	  0x25c6,
	  "a79",
	  0x2756,
	  "a81",
	  0x25d7,
	  "a82",
	  0x2758,
	  "a83",
	  0x2759,
	  "a84",
	  0x275a,
	  "a97",
	  0x275b,
	  "a98",
	  0x275c,
	  "a99",
	  0x275d,
	  "a100",
	  0x275e,
	  "a101",
	  0x2761,
	  "a102",
	  0x2762,
	  "a103",
	  0x2763,
	  "a104",
	  0x2764,
	  "a106",
	  0x2765,
	  "a107",
	  0x2766,
	  "a108",
	  0x2767,
	  "a112",
	  0x2663,
	  "a111",
	  0x2666,
	  "a110",
	  0x2665,
	  "a109",
	  0x2660,
	  "a120",
	  0x2460,
	  "a121",
	  0x2461,
	  "a122",
	  0x2462,
	  "a123",
	  0x2463,
	  "a124",
	  0x2464,
	  "a125",
	  0x2465,
	  "a126",
	  0x2466,
	  "a127",
	  0x2467,
	  "a128",
	  0x2468,
	  "a129",
	  0x2469,
	  "a130",
	  0x2776,
	  "a131",
	  0x2777,
	  "a132",
	  0x2778,
	  "a133",
	  0x2779,
	  "a134",
	  0x277a,
	  "a135",
	  0x277b,
	  "a136",
	  0x277c,
	  "a137",
	  0x277d,
	  "a138",
	  0x277e,
	  "a139",
	  0x277f,
	  "a140",
	  0x2780,
	  "a141",
	  0x2781,
	  "a142",
	  0x2782,
	  "a143",
	  0x2783,
	  "a144",
	  0x2784,
	  "a145",
	  0x2785,
	  "a146",
	  0x2786,
	  "a147",
	  0x2787,
	  "a148",
	  0x2788,
	  "a149",
	  0x2789,
	  "a150",
	  0x278a,
	  "a151",
	  0x278b,
	  "a152",
	  0x278c,
	  "a153",
	  0x278d,
	  "a154",
	  0x278e,
	  "a155",
	  0x278f,
	  "a156",
	  0x2790,
	  "a157",
	  0x2791,
	  "a158",
	  0x2792,
	  "a159",
	  0x2793,
	  "a160",
	  0x2794,
	  "a161",
	  0x2192,
	  "a163",
	  0x2194,
	  "a164",
	  0x2195,
	  "a196",
	  0x2798,
	  "a165",
	  0x2799,
	  "a192",
	  0x279a,
	  "a166",
	  0x279b,
	  "a167",
	  0x279c,
	  "a168",
	  0x279d,
	  "a169",
	  0x279e,
	  "a170",
	  0x279f,
	  "a171",
	  0x27a0,
	  "a172",
	  0x27a1,
	  "a173",
	  0x27a2,
	  "a162",
	  0x27a3,
	  "a174",
	  0x27a4,
	  "a175",
	  0x27a5,
	  "a176",
	  0x27a6,
	  "a177",
	  0x27a7,
	  "a178",
	  0x27a8,
	  "a179",
	  0x27a9,
	  "a193",
	  0x27aa,
	  "a180",
	  0x27ab,
	  "a199",
	  0x27ac,
	  "a181",
	  0x27ad,
	  "a200",
	  0x27ae,
	  "a182",
	  0x27af,
	  "a201",
	  0x27b1,
	  "a183",
	  0x27b2,
	  "a184",
	  0x27b3,
	  "a197",
	  0x27b4,
	  "a185",
	  0x27b5,
	  "a194",
	  0x27b6,
	  "a198",
	  0x27b7,
	  "a186",
	  0x27b8,
	  "a195",
	  0x27b9,
	  "a187",
	  0x27ba,
	  "a188",
	  0x27bb,
	  "a189",
	  0x27bc,
	  "a190",
	  0x27bd,
	  "a191",
	  0x27be,
	  "a89",
	  0x2768,
	  "a90",
	  0x2769,
	  "a93",
	  0x276a,
	  "a94",
	  0x276b,
	  "a91",
	  0x276c,
	  "a92",
	  0x276d,
	  "a205",
	  0x276e,
	  "a85",
	  0x276f,
	  "a206",
	  0x2770,
	  "a86",
	  0x2771,
	  "a87",
	  0x2772,
	  "a88",
	  0x2773,
	  "a95",
	  0x2774,
	  "a96",
	  0x2775,
	  ".notdef",
	  0x0000
	 ];
	});


	/***/ }),
	/* 40 */
	/***/ ((__unused_webpack_module, __webpack_exports__, __w_pdfjs_require__) => {

	__w_pdfjs_require__.r(__webpack_exports__);
	/* harmony export */ __w_pdfjs_require__.d(__webpack_exports__, {
	/* harmony export */   "clearUnicodeCaches": () => (/* binding */ clearUnicodeCaches),
	/* harmony export */   "getCharUnicodeCategory": () => (/* binding */ getCharUnicodeCategory),
	/* harmony export */   "getNormalizedUnicodes": () => (/* binding */ getNormalizedUnicodes),
	/* harmony export */   "getUnicodeForGlyph": () => (/* binding */ getUnicodeForGlyph),
	/* harmony export */   "getUnicodeRangeFor": () => (/* binding */ getUnicodeRangeFor),
	/* harmony export */   "mapSpecialUnicodeValues": () => (/* binding */ mapSpecialUnicodeValues),
	/* harmony export */   "reverseIfRtl": () => (/* binding */ reverseIfRtl)
	/* harmony export */ });
	/* harmony import */ var _core_utils_js__WEBPACK_IMPORTED_MODULE_0__ = __w_pdfjs_require__(6);

	const getSpecialPUASymbols = (0, _core_utils_js__WEBPACK_IMPORTED_MODULE_0__.getLookupTableFactory)(function (t) {
	 t[63721] = 0x00a9;
	 t[63193] = 0x00a9;
	 t[63720] = 0x00ae;
	 t[63194] = 0x00ae;
	 t[63722] = 0x2122;
	 t[63195] = 0x2122;
	 t[63729] = 0x23a7;
	 t[63730] = 0x23a8;
	 t[63731] = 0x23a9;
	 t[63740] = 0x23ab;
	 t[63741] = 0x23ac;
	 t[63742] = 0x23ad;
	 t[63726] = 0x23a1;
	 t[63727] = 0x23a2;
	 t[63728] = 0x23a3;
	 t[63737] = 0x23a4;
	 t[63738] = 0x23a5;
	 t[63739] = 0x23a6;
	 t[63723] = 0x239b;
	 t[63724] = 0x239c;
	 t[63725] = 0x239d;
	 t[63734] = 0x239e;
	 t[63735] = 0x239f;
	 t[63736] = 0x23a0;
	});
	function mapSpecialUnicodeValues(code) {
	 if (code >= 0xfff0 && code <= 0xffff) {
	  return 0;
	 } else if (code >= 0xf600 && code <= 0xf8ff) {
	  return getSpecialPUASymbols()[code] || code;
	 } else if (code === 0x00ad) {
	  return 0x002d;
	 }
	 return code;
	}
	function getUnicodeForGlyph(name, glyphsUnicodeMap) {
	 let unicode = glyphsUnicodeMap[name];
	 if (unicode !== undefined) {
	  return unicode;
	 }
	 if (!name) {
	  return -1;
	 }
	 if (name[0] === "u") {
	  const nameLen = name.length;
	  let hexStr;
	  if (nameLen === 7 && name[1] === "n" && name[2] === "i") {
	   hexStr = name.substring(3);
	  } else if (nameLen >= 5 && nameLen <= 7) {
	   hexStr = name.substring(1);
	  } else {
	   return -1;
	  }
	  if (hexStr === hexStr.toUpperCase()) {
	   unicode = parseInt(hexStr, 16);
	   if (unicode >= 0) {
	    return unicode;
	   }
	  }
	 }
	 return -1;
	}
	const UnicodeRanges = [
	 {
	  begin: 0x0000,
	  end: 0x007f
	 },
	 {
	  begin: 0x0080,
	  end: 0x00ff
	 },
	 {
	  begin: 0x0100,
	  end: 0x017f
	 },
	 {
	  begin: 0x0180,
	  end: 0x024f
	 },
	 {
	  begin: 0x0250,
	  end: 0x02af
	 },
	 {
	  begin: 0x02b0,
	  end: 0x02ff
	 },
	 {
	  begin: 0x0300,
	  end: 0x036f
	 },
	 {
	  begin: 0x0370,
	  end: 0x03ff
	 },
	 {
	  begin: 0x2c80,
	  end: 0x2cff
	 },
	 {
	  begin: 0x0400,
	  end: 0x04ff
	 },
	 {
	  begin: 0x0530,
	  end: 0x058f
	 },
	 {
	  begin: 0x0590,
	  end: 0x05ff
	 },
	 {
	  begin: 0xa500,
	  end: 0xa63f
	 },
	 {
	  begin: 0x0600,
	  end: 0x06ff
	 },
	 {
	  begin: 0x07c0,
	  end: 0x07ff
	 },
	 {
	  begin: 0x0900,
	  end: 0x097f
	 },
	 {
	  begin: 0x0980,
	  end: 0x09ff
	 },
	 {
	  begin: 0x0a00,
	  end: 0x0a7f
	 },
	 {
	  begin: 0x0a80,
	  end: 0x0aff
	 },
	 {
	  begin: 0x0b00,
	  end: 0x0b7f
	 },
	 {
	  begin: 0x0b80,
	  end: 0x0bff
	 },
	 {
	  begin: 0x0c00,
	  end: 0x0c7f
	 },
	 {
	  begin: 0x0c80,
	  end: 0x0cff
	 },
	 {
	  begin: 0x0d00,
	  end: 0x0d7f
	 },
	 {
	  begin: 0x0e00,
	  end: 0x0e7f
	 },
	 {
	  begin: 0x0e80,
	  end: 0x0eff
	 },
	 {
	  begin: 0x10a0,
	  end: 0x10ff
	 },
	 {
	  begin: 0x1b00,
	  end: 0x1b7f
	 },
	 {
	  begin: 0x1100,
	  end: 0x11ff
	 },
	 {
	  begin: 0x1e00,
	  end: 0x1eff
	 },
	 {
	  begin: 0x1f00,
	  end: 0x1fff
	 },
	 {
	  begin: 0x2000,
	  end: 0x206f
	 },
	 {
	  begin: 0x2070,
	  end: 0x209f
	 },
	 {
	  begin: 0x20a0,
	  end: 0x20cf
	 },
	 {
	  begin: 0x20d0,
	  end: 0x20ff
	 },
	 {
	  begin: 0x2100,
	  end: 0x214f
	 },
	 {
	  begin: 0x2150,
	  end: 0x218f
	 },
	 {
	  begin: 0x2190,
	  end: 0x21ff
	 },
	 {
	  begin: 0x2200,
	  end: 0x22ff
	 },
	 {
	  begin: 0x2300,
	  end: 0x23ff
	 },
	 {
	  begin: 0x2400,
	  end: 0x243f
	 },
	 {
	  begin: 0x2440,
	  end: 0x245f
	 },
	 {
	  begin: 0x2460,
	  end: 0x24ff
	 },
	 {
	  begin: 0x2500,
	  end: 0x257f
	 },
	 {
	  begin: 0x2580,
	  end: 0x259f
	 },
	 {
	  begin: 0x25a0,
	  end: 0x25ff
	 },
	 {
	  begin: 0x2600,
	  end: 0x26ff
	 },
	 {
	  begin: 0x2700,
	  end: 0x27bf
	 },
	 {
	  begin: 0x3000,
	  end: 0x303f
	 },
	 {
	  begin: 0x3040,
	  end: 0x309f
	 },
	 {
	  begin: 0x30a0,
	  end: 0x30ff
	 },
	 {
	  begin: 0x3100,
	  end: 0x312f
	 },
	 {
	  begin: 0x3130,
	  end: 0x318f
	 },
	 {
	  begin: 0xa840,
	  end: 0xa87f
	 },
	 {
	  begin: 0x3200,
	  end: 0x32ff
	 },
	 {
	  begin: 0x3300,
	  end: 0x33ff
	 },
	 {
	  begin: 0xac00,
	  end: 0xd7af
	 },
	 {
	  begin: 0xd800,
	  end: 0xdfff
	 },
	 {
	  begin: 0x10900,
	  end: 0x1091f
	 },
	 {
	  begin: 0x4e00,
	  end: 0x9fff
	 },
	 {
	  begin: 0xe000,
	  end: 0xf8ff
	 },
	 {
	  begin: 0x31c0,
	  end: 0x31ef
	 },
	 {
	  begin: 0xfb00,
	  end: 0xfb4f
	 },
	 {
	  begin: 0xfb50,
	  end: 0xfdff
	 },
	 {
	  begin: 0xfe20,
	  end: 0xfe2f
	 },
	 {
	  begin: 0xfe10,
	  end: 0xfe1f
	 },
	 {
	  begin: 0xfe50,
	  end: 0xfe6f
	 },
	 {
	  begin: 0xfe70,
	  end: 0xfeff
	 },
	 {
	  begin: 0xff00,
	  end: 0xffef
	 },
	 {
	  begin: 0xfff0,
	  end: 0xffff
	 },
	 {
	  begin: 0x0f00,
	  end: 0x0fff
	 },
	 {
	  begin: 0x0700,
	  end: 0x074f
	 },
	 {
	  begin: 0x0780,
	  end: 0x07bf
	 },
	 {
	  begin: 0x0d80,
	  end: 0x0dff
	 },
	 {
	  begin: 0x1000,
	  end: 0x109f
	 },
	 {
	  begin: 0x1200,
	  end: 0x137f
	 },
	 {
	  begin: 0x13a0,
	  end: 0x13ff
	 },
	 {
	  begin: 0x1400,
	  end: 0x167f
	 },
	 {
	  begin: 0x1680,
	  end: 0x169f
	 },
	 {
	  begin: 0x16a0,
	  end: 0x16ff
	 },
	 {
	  begin: 0x1780,
	  end: 0x17ff
	 },
	 {
	  begin: 0x1800,
	  end: 0x18af
	 },
	 {
	  begin: 0x2800,
	  end: 0x28ff
	 },
	 {
	  begin: 0xa000,
	  end: 0xa48f
	 },
	 {
	  begin: 0x1700,
	  end: 0x171f
	 },
	 {
	  begin: 0x10300,
	  end: 0x1032f
	 },
	 {
	  begin: 0x10330,
	  end: 0x1034f
	 },
	 {
	  begin: 0x10400,
	  end: 0x1044f
	 },
	 {
	  begin: 0x1d000,
	  end: 0x1d0ff
	 },
	 {
	  begin: 0x1d400,
	  end: 0x1d7ff
	 },
	 {
	  begin: 0xff000,
	  end: 0xffffd
	 },
	 {
	  begin: 0xfe00,
	  end: 0xfe0f
	 },
	 {
	  begin: 0xe0000,
	  end: 0xe007f
	 },
	 {
	  begin: 0x1900,
	  end: 0x194f
	 },
	 {
	  begin: 0x1950,
	  end: 0x197f
	 },
	 {
	  begin: 0x1980,
	  end: 0x19df
	 },
	 {
	  begin: 0x1a00,
	  end: 0x1a1f
	 },
	 {
	  begin: 0x2c00,
	  end: 0x2c5f
	 },
	 {
	  begin: 0x2d30,
	  end: 0x2d7f
	 },
	 {
	  begin: 0x4dc0,
	  end: 0x4dff
	 },
	 {
	  begin: 0xa800,
	  end: 0xa82f
	 },
	 {
	  begin: 0x10000,
	  end: 0x1007f
	 },
	 {
	  begin: 0x10140,
	  end: 0x1018f
	 },
	 {
	  begin: 0x10380,
	  end: 0x1039f
	 },
	 {
	  begin: 0x103a0,
	  end: 0x103df
	 },
	 {
	  begin: 0x10450,
	  end: 0x1047f
	 },
	 {
	  begin: 0x10480,
	  end: 0x104af
	 },
	 {
	  begin: 0x10800,
	  end: 0x1083f
	 },
	 {
	  begin: 0x10a00,
	  end: 0x10a5f
	 },
	 {
	  begin: 0x1d300,
	  end: 0x1d35f
	 },
	 {
	  begin: 0x12000,
	  end: 0x123ff
	 },
	 {
	  begin: 0x1d360,
	  end: 0x1d37f
	 },
	 {
	  begin: 0x1b80,
	  end: 0x1bbf
	 },
	 {
	  begin: 0x1c00,
	  end: 0x1c4f
	 },
	 {
	  begin: 0x1c50,
	  end: 0x1c7f
	 },
	 {
	  begin: 0xa880,
	  end: 0xa8df
	 },
	 {
	  begin: 0xa900,
	  end: 0xa92f
	 },
	 {
	  begin: 0xa930,
	  end: 0xa95f
	 },
	 {
	  begin: 0xaa00,
	  end: 0xaa5f
	 },
	 {
	  begin: 0x10190,
	  end: 0x101cf
	 },
	 {
	  begin: 0x101d0,
	  end: 0x101ff
	 },
	 {
	  begin: 0x102a0,
	  end: 0x102df
	 },
	 {
	  begin: 0x1f030,
	  end: 0x1f09f
	 }
	];
	function getUnicodeRangeFor(value) {
	 for (let i = 0, ii = UnicodeRanges.length; i < ii; i++) {
	  const range = UnicodeRanges[i];
	  if (value >= range.begin && value < range.end) {
	   return i;
	  }
	 }
	 return -1;
	}
	function isRTLRangeFor(value) {
	 let range = UnicodeRanges[13];
	 if (value >= range.begin && value < range.end) {
	  return true;
	 }
	 range = UnicodeRanges[11];
	 if (value >= range.begin && value < range.end) {
	  return true;
	 }
	 return false;
	}
	const getNormalizedUnicodes = (0, _core_utils_js__WEBPACK_IMPORTED_MODULE_0__.getArrayLookupTableFactory)(function () {
	 return [
	  "\u00A8",
	  "\u0020\u0308",
	  "\u00AF",
	  "\u0020\u0304",
	  "\u00B4",
	  "\u0020\u0301",
	  "\u00B5",
	  "\u03BC",
	  "\u00B8",
	  "\u0020\u0327",
	  "\u0132",
	  "\u0049\u004A",
	  "\u0133",
	  "\u0069\u006A",
	  "\u013F",
	  "\u004C\u00B7",
	  "\u0140",
	  "\u006C\u00B7",
	  "\u0149",
	  "\u02BC\u006E",
	  "\u017F",
	  "\u0073",
	  "\u01C4",
	  "\u0044\u017D",
	  "\u01C5",
	  "\u0044\u017E",
	  "\u01C6",
	  "\u0064\u017E",
	  "\u01C7",
	  "\u004C\u004A",
	  "\u01C8",
	  "\u004C\u006A",
	  "\u01C9",
	  "\u006C\u006A",
	  "\u01CA",
	  "\u004E\u004A",
	  "\u01CB",
	  "\u004E\u006A",
	  "\u01CC",
	  "\u006E\u006A",
	  "\u01F1",
	  "\u0044\u005A",
	  "\u01F2",
	  "\u0044\u007A",
	  "\u01F3",
	  "\u0064\u007A",
	  "\u02D8",
	  "\u0020\u0306",
	  "\u02D9",
	  "\u0020\u0307",
	  "\u02DA",
	  "\u0020\u030A",
	  "\u02DB",
	  "\u0020\u0328",
	  "\u02DC",
	  "\u0020\u0303",
	  "\u02DD",
	  "\u0020\u030B",
	  "\u037A",
	  "\u0020\u0345",
	  "\u0384",
	  "\u0020\u0301",
	  "\u03D0",
	  "\u03B2",
	  "\u03D1",
	  "\u03B8",
	  "\u03D2",
	  "\u03A5",
	  "\u03D5",
	  "\u03C6",
	  "\u03D6",
	  "\u03C0",
	  "\u03F0",
	  "\u03BA",
	  "\u03F1",
	  "\u03C1",
	  "\u03F2",
	  "\u03C2",
	  "\u03F4",
	  "\u0398",
	  "\u03F5",
	  "\u03B5",
	  "\u03F9",
	  "\u03A3",
	  "\u0587",
	  "\u0565\u0582",
	  "\u0675",
	  "\u0627\u0674",
	  "\u0676",
	  "\u0648\u0674",
	  "\u0677",
	  "\u06C7\u0674",
	  "\u0678",
	  "\u064A\u0674",
	  "\u0E33",
	  "\u0E4D\u0E32",
	  "\u0EB3",
	  "\u0ECD\u0EB2",
	  "\u0EDC",
	  "\u0EAB\u0E99",
	  "\u0EDD",
	  "\u0EAB\u0EA1",
	  "\u0F77",
	  "\u0FB2\u0F81",
	  "\u0F79",
	  "\u0FB3\u0F81",
	  "\u1E9A",
	  "\u0061\u02BE",
	  "\u1FBD",
	  "\u0020\u0313",
	  "\u1FBF",
	  "\u0020\u0313",
	  "\u1FC0",
	  "\u0020\u0342",
	  "\u1FFE",
	  "\u0020\u0314",
	  "\u2002",
	  "\u0020",
	  "\u2003",
	  "\u0020",
	  "\u2004",
	  "\u0020",
	  "\u2005",
	  "\u0020",
	  "\u2006",
	  "\u0020",
	  "\u2008",
	  "\u0020",
	  "\u2009",
	  "\u0020",
	  "\u200A",
	  "\u0020",
	  "\u2017",
	  "\u0020\u0333",
	  "\u2024",
	  "\u002E",
	  "\u2025",
	  "\u002E\u002E",
	  "\u2026",
	  "\u002E\u002E\u002E",
	  "\u2033",
	  "\u2032\u2032",
	  "\u2034",
	  "\u2032\u2032\u2032",
	  "\u2036",
	  "\u2035\u2035",
	  "\u2037",
	  "\u2035\u2035\u2035",
	  "\u203C",
	  "\u0021\u0021",
	  "\u203E",
	  "\u0020\u0305",
	  "\u2047",
	  "\u003F\u003F",
	  "\u2048",
	  "\u003F\u0021",
	  "\u2049",
	  "\u0021\u003F",
	  "\u2057",
	  "\u2032\u2032\u2032\u2032",
	  "\u205F",
	  "\u0020",
	  "\u20A8",
	  "\u0052\u0073",
	  "\u2100",
	  "\u0061\u002F\u0063",
	  "\u2101",
	  "\u0061\u002F\u0073",
	  "\u2103",
	  "\u00B0\u0043",
	  "\u2105",
	  "\u0063\u002F\u006F",
	  "\u2106",
	  "\u0063\u002F\u0075",
	  "\u2107",
	  "\u0190",
	  "\u2109",
	  "\u00B0\u0046",
	  "\u2116",
	  "\u004E\u006F",
	  "\u2121",
	  "\u0054\u0045\u004C",
	  "\u2135",
	  "\u05D0",
	  "\u2136",
	  "\u05D1",
	  "\u2137",
	  "\u05D2",
	  "\u2138",
	  "\u05D3",
	  "\u213B",
	  "\u0046\u0041\u0058",
	  "\u2160",
	  "\u0049",
	  "\u2161",
	  "\u0049\u0049",
	  "\u2162",
	  "\u0049\u0049\u0049",
	  "\u2163",
	  "\u0049\u0056",
	  "\u2164",
	  "\u0056",
	  "\u2165",
	  "\u0056\u0049",
	  "\u2166",
	  "\u0056\u0049\u0049",
	  "\u2167",
	  "\u0056\u0049\u0049\u0049",
	  "\u2168",
	  "\u0049\u0058",
	  "\u2169",
	  "\u0058",
	  "\u216A",
	  "\u0058\u0049",
	  "\u216B",
	  "\u0058\u0049\u0049",
	  "\u216C",
	  "\u004C",
	  "\u216D",
	  "\u0043",
	  "\u216E",
	  "\u0044",
	  "\u216F",
	  "\u004D",
	  "\u2170",
	  "\u0069",
	  "\u2171",
	  "\u0069\u0069",
	  "\u2172",
	  "\u0069\u0069\u0069",
	  "\u2173",
	  "\u0069\u0076",
	  "\u2174",
	  "\u0076",
	  "\u2175",
	  "\u0076\u0069",
	  "\u2176",
	  "\u0076\u0069\u0069",
	  "\u2177",
	  "\u0076\u0069\u0069\u0069",
	  "\u2178",
	  "\u0069\u0078",
	  "\u2179",
	  "\u0078",
	  "\u217A",
	  "\u0078\u0069",
	  "\u217B",
	  "\u0078\u0069\u0069",
	  "\u217C",
	  "\u006C",
	  "\u217D",
	  "\u0063",
	  "\u217E",
	  "\u0064",
	  "\u217F",
	  "\u006D",
	  "\u222C",
	  "\u222B\u222B",
	  "\u222D",
	  "\u222B\u222B\u222B",
	  "\u222F",
	  "\u222E\u222E",
	  "\u2230",
	  "\u222E\u222E\u222E",
	  "\u2474",
	  "\u0028\u0031\u0029",
	  "\u2475",
	  "\u0028\u0032\u0029",
	  "\u2476",
	  "\u0028\u0033\u0029",
	  "\u2477",
	  "\u0028\u0034\u0029",
	  "\u2478",
	  "\u0028\u0035\u0029",
	  "\u2479",
	  "\u0028\u0036\u0029",
	  "\u247A",
	  "\u0028\u0037\u0029",
	  "\u247B",
	  "\u0028\u0038\u0029",
	  "\u247C",
	  "\u0028\u0039\u0029",
	  "\u247D",
	  "\u0028\u0031\u0030\u0029",
	  "\u247E",
	  "\u0028\u0031\u0031\u0029",
	  "\u247F",
	  "\u0028\u0031\u0032\u0029",
	  "\u2480",
	  "\u0028\u0031\u0033\u0029",
	  "\u2481",
	  "\u0028\u0031\u0034\u0029",
	  "\u2482",
	  "\u0028\u0031\u0035\u0029",
	  "\u2483",
	  "\u0028\u0031\u0036\u0029",
	  "\u2484",
	  "\u0028\u0031\u0037\u0029",
	  "\u2485",
	  "\u0028\u0031\u0038\u0029",
	  "\u2486",
	  "\u0028\u0031\u0039\u0029",
	  "\u2487",
	  "\u0028\u0032\u0030\u0029",
	  "\u2488",
	  "\u0031\u002E",
	  "\u2489",
	  "\u0032\u002E",
	  "\u248A",
	  "\u0033\u002E",
	  "\u248B",
	  "\u0034\u002E",
	  "\u248C",
	  "\u0035\u002E",
	  "\u248D",
	  "\u0036\u002E",
	  "\u248E",
	  "\u0037\u002E",
	  "\u248F",
	  "\u0038\u002E",
	  "\u2490",
	  "\u0039\u002E",
	  "\u2491",
	  "\u0031\u0030\u002E",
	  "\u2492",
	  "\u0031\u0031\u002E",
	  "\u2493",
	  "\u0031\u0032\u002E",
	  "\u2494",
	  "\u0031\u0033\u002E",
	  "\u2495",
	  "\u0031\u0034\u002E",
	  "\u2496",
	  "\u0031\u0035\u002E",
	  "\u2497",
	  "\u0031\u0036\u002E",
	  "\u2498",
	  "\u0031\u0037\u002E",
	  "\u2499",
	  "\u0031\u0038\u002E",
	  "\u249A",
	  "\u0031\u0039\u002E",
	  "\u249B",
	  "\u0032\u0030\u002E",
	  "\u249C",
	  "\u0028\u0061\u0029",
	  "\u249D",
	  "\u0028\u0062\u0029",
	  "\u249E",
	  "\u0028\u0063\u0029",
	  "\u249F",
	  "\u0028\u0064\u0029",
	  "\u24A0",
	  "\u0028\u0065\u0029",
	  "\u24A1",
	  "\u0028\u0066\u0029",
	  "\u24A2",
	  "\u0028\u0067\u0029",
	  "\u24A3",
	  "\u0028\u0068\u0029",
	  "\u24A4",
	  "\u0028\u0069\u0029",
	  "\u24A5",
	  "\u0028\u006A\u0029",
	  "\u24A6",
	  "\u0028\u006B\u0029",
	  "\u24A7",
	  "\u0028\u006C\u0029",
	  "\u24A8",
	  "\u0028\u006D\u0029",
	  "\u24A9",
	  "\u0028\u006E\u0029",
	  "\u24AA",
	  "\u0028\u006F\u0029",
	  "\u24AB",
	  "\u0028\u0070\u0029",
	  "\u24AC",
	  "\u0028\u0071\u0029",
	  "\u24AD",
	  "\u0028\u0072\u0029",
	  "\u24AE",
	  "\u0028\u0073\u0029",
	  "\u24AF",
	  "\u0028\u0074\u0029",
	  "\u24B0",
	  "\u0028\u0075\u0029",
	  "\u24B1",
	  "\u0028\u0076\u0029",
	  "\u24B2",
	  "\u0028\u0077\u0029",
	  "\u24B3",
	  "\u0028\u0078\u0029",
	  "\u24B4",
	  "\u0028\u0079\u0029",
	  "\u24B5",
	  "\u0028\u007A\u0029",
	  "\u2A0C",
	  "\u222B\u222B\u222B\u222B",
	  "\u2A74",
	  "\u003A\u003A\u003D",
	  "\u2A75",
	  "\u003D\u003D",
	  "\u2A76",
	  "\u003D\u003D\u003D",
	  "\u2E9F",
	  "\u6BCD",
	  "\u2EF3",
	  "\u9F9F",
	  "\u2F00",
	  "\u4E00",
	  "\u2F01",
	  "\u4E28",
	  "\u2F02",
	  "\u4E36",
	  "\u2F03",
	  "\u4E3F",
	  "\u2F04",
	  "\u4E59",
	  "\u2F05",
	  "\u4E85",
	  "\u2F06",
	  "\u4E8C",
	  "\u2F07",
	  "\u4EA0",
	  "\u2F08",
	  "\u4EBA",
	  "\u2F09",
	  "\u513F",
	  "\u2F0A",
	  "\u5165",
	  "\u2F0B",
	  "\u516B",
	  "\u2F0C",
	  "\u5182",
	  "\u2F0D",
	  "\u5196",
	  "\u2F0E",
	  "\u51AB",
	  "\u2F0F",
	  "\u51E0",
	  "\u2F10",
	  "\u51F5",
	  "\u2F11",
	  "\u5200",
	  "\u2F12",
	  "\u529B",
	  "\u2F13",
	  "\u52F9",
	  "\u2F14",
	  "\u5315",
	  "\u2F15",
	  "\u531A",
	  "\u2F16",
	  "\u5338",
	  "\u2F17",
	  "\u5341",
	  "\u2F18",
	  "\u535C",
	  "\u2F19",
	  "\u5369",
	  "\u2F1A",
	  "\u5382",
	  "\u2F1B",
	  "\u53B6",
	  "\u2F1C",
	  "\u53C8",
	  "\u2F1D",
	  "\u53E3",
	  "\u2F1E",
	  "\u56D7",
	  "\u2F1F",
	  "\u571F",
	  "\u2F20",
	  "\u58EB",
	  "\u2F21",
	  "\u5902",
	  "\u2F22",
	  "\u590A",
	  "\u2F23",
	  "\u5915",
	  "\u2F24",
	  "\u5927",
	  "\u2F25",
	  "\u5973",
	  "\u2F26",
	  "\u5B50",
	  "\u2F27",
	  "\u5B80",
	  "\u2F28",
	  "\u5BF8",
	  "\u2F29",
	  "\u5C0F",
	  "\u2F2A",
	  "\u5C22",
	  "\u2F2B",
	  "\u5C38",
	  "\u2F2C",
	  "\u5C6E",
	  "\u2F2D",
	  "\u5C71",
	  "\u2F2E",
	  "\u5DDB",
	  "\u2F2F",
	  "\u5DE5",
	  "\u2F30",
	  "\u5DF1",
	  "\u2F31",
	  "\u5DFE",
	  "\u2F32",
	  "\u5E72",
	  "\u2F33",
	  "\u5E7A",
	  "\u2F34",
	  "\u5E7F",
	  "\u2F35",
	  "\u5EF4",
	  "\u2F36",
	  "\u5EFE",
	  "\u2F37",
	  "\u5F0B",
	  "\u2F38",
	  "\u5F13",
	  "\u2F39",
	  "\u5F50",
	  "\u2F3A",
	  "\u5F61",
	  "\u2F3B",
	  "\u5F73",
	  "\u2F3C",
	  "\u5FC3",
	  "\u2F3D",
	  "\u6208",
	  "\u2F3E",
	  "\u6236",
	  "\u2F3F",
	  "\u624B",
	  "\u2F40",
	  "\u652F",
	  "\u2F41",
	  "\u6534",
	  "\u2F42",
	  "\u6587",
	  "\u2F43",
	  "\u6597",
	  "\u2F44",
	  "\u65A4",
	  "\u2F45",
	  "\u65B9",
	  "\u2F46",
	  "\u65E0",
	  "\u2F47",
	  "\u65E5",
	  "\u2F48",
	  "\u66F0",
	  "\u2F49",
	  "\u6708",
	  "\u2F4A",
	  "\u6728",
	  "\u2F4B",
	  "\u6B20",
	  "\u2F4C",
	  "\u6B62",
	  "\u2F4D",
	  "\u6B79",
	  "\u2F4E",
	  "\u6BB3",
	  "\u2F4F",
	  "\u6BCB",
	  "\u2F50",
	  "\u6BD4",
	  "\u2F51",
	  "\u6BDB",
	  "\u2F52",
	  "\u6C0F",
	  "\u2F53",
	  "\u6C14",
	  "\u2F54",
	  "\u6C34",
	  "\u2F55",
	  "\u706B",
	  "\u2F56",
	  "\u722A",
	  "\u2F57",
	  "\u7236",
	  "\u2F58",
	  "\u723B",
	  "\u2F59",
	  "\u723F",
	  "\u2F5A",
	  "\u7247",
	  "\u2F5B",
	  "\u7259",
	  "\u2F5C",
	  "\u725B",
	  "\u2F5D",
	  "\u72AC",
	  "\u2F5E",
	  "\u7384",
	  "\u2F5F",
	  "\u7389",
	  "\u2F60",
	  "\u74DC",
	  "\u2F61",
	  "\u74E6",
	  "\u2F62",
	  "\u7518",
	  "\u2F63",
	  "\u751F",
	  "\u2F64",
	  "\u7528",
	  "\u2F65",
	  "\u7530",
	  "\u2F66",
	  "\u758B",
	  "\u2F67",
	  "\u7592",
	  "\u2F68",
	  "\u7676",
	  "\u2F69",
	  "\u767D",
	  "\u2F6A",
	  "\u76AE",
	  "\u2F6B",
	  "\u76BF",
	  "\u2F6C",
	  "\u76EE",
	  "\u2F6D",
	  "\u77DB",
	  "\u2F6E",
	  "\u77E2",
	  "\u2F6F",
	  "\u77F3",
	  "\u2F70",
	  "\u793A",
	  "\u2F71",
	  "\u79B8",
	  "\u2F72",
	  "\u79BE",
	  "\u2F73",
	  "\u7A74",
	  "\u2F74",
	  "\u7ACB",
	  "\u2F75",
	  "\u7AF9",
	  "\u2F76",
	  "\u7C73",
	  "\u2F77",
	  "\u7CF8",
	  "\u2F78",
	  "\u7F36",
	  "\u2F79",
	  "\u7F51",
	  "\u2F7A",
	  "\u7F8A",
	  "\u2F7B",
	  "\u7FBD",
	  "\u2F7C",
	  "\u8001",
	  "\u2F7D",
	  "\u800C",
	  "\u2F7E",
	  "\u8012",
	  "\u2F7F",
	  "\u8033",
	  "\u2F80",
	  "\u807F",
	  "\u2F81",
	  "\u8089",
	  "\u2F82",
	  "\u81E3",
	  "\u2F83",
	  "\u81EA",
	  "\u2F84",
	  "\u81F3",
	  "\u2F85",
	  "\u81FC",
	  "\u2F86",
	  "\u820C",
	  "\u2F87",
	  "\u821B",
	  "\u2F88",
	  "\u821F",
	  "\u2F89",
	  "\u826E",
	  "\u2F8A",
	  "\u8272",
	  "\u2F8B",
	  "\u8278",
	  "\u2F8C",
	  "\u864D",
	  "\u2F8D",
	  "\u866B",
	  "\u2F8E",
	  "\u8840",
	  "\u2F8F",
	  "\u884C",
	  "\u2F90",
	  "\u8863",
	  "\u2F91",
	  "\u897E",
	  "\u2F92",
	  "\u898B",
	  "\u2F93",
	  "\u89D2",
	  "\u2F94",
	  "\u8A00",
	  "\u2F95",
	  "\u8C37",
	  "\u2F96",
	  "\u8C46",
	  "\u2F97",
	  "\u8C55",
	  "\u2F98",
	  "\u8C78",
	  "\u2F99",
	  "\u8C9D",
	  "\u2F9A",
	  "\u8D64",
	  "\u2F9B",
	  "\u8D70",
	  "\u2F9C",
	  "\u8DB3",
	  "\u2F9D",
	  "\u8EAB",
	  "\u2F9E",
	  "\u8ECA",
	  "\u2F9F",
	  "\u8F9B",
	  "\u2FA0",
	  "\u8FB0",
	  "\u2FA1",
	  "\u8FB5",
	  "\u2FA2",
	  "\u9091",
	  "\u2FA3",
	  "\u9149",
	  "\u2FA4",
	  "\u91C6",
	  "\u2FA5",
	  "\u91CC",
	  "\u2FA6",
	  "\u91D1",
	  "\u2FA7",
	  "\u9577",
	  "\u2FA8",
	  "\u9580",
	  "\u2FA9",
	  "\u961C",
	  "\u2FAA",
	  "\u96B6",
	  "\u2FAB",
	  "\u96B9",
	  "\u2FAC",
	  "\u96E8",
	  "\u2FAD",
	  "\u9751",
	  "\u2FAE",
	  "\u975E",
	  "\u2FAF",
	  "\u9762",
	  "\u2FB0",
	  "\u9769",
	  "\u2FB1",
	  "\u97CB",
	  "\u2FB2",
	  "\u97ED",
	  "\u2FB3",
	  "\u97F3",
	  "\u2FB4",
	  "\u9801",
	  "\u2FB5",
	  "\u98A8",
	  "\u2FB6",
	  "\u98DB",
	  "\u2FB7",
	  "\u98DF",
	  "\u2FB8",
	  "\u9996",
	  "\u2FB9",
	  "\u9999",
	  "\u2FBA",
	  "\u99AC",
	  "\u2FBB",
	  "\u9AA8",
	  "\u2FBC",
	  "\u9AD8",
	  "\u2FBD",
	  "\u9ADF",
	  "\u2FBE",
	  "\u9B25",
	  "\u2FBF",
	  "\u9B2F",
	  "\u2FC0",
	  "\u9B32",
	  "\u2FC1",
	  "\u9B3C",
	  "\u2FC2",
	  "\u9B5A",
	  "\u2FC3",
	  "\u9CE5",
	  "\u2FC4",
	  "\u9E75",
	  "\u2FC5",
	  "\u9E7F",
	  "\u2FC6",
	  "\u9EA5",
	  "\u2FC7",
	  "\u9EBB",
	  "\u2FC8",
	  "\u9EC3",
	  "\u2FC9",
	  "\u9ECD",
	  "\u2FCA",
	  "\u9ED1",
	  "\u2FCB",
	  "\u9EF9",
	  "\u2FCC",
	  "\u9EFD",
	  "\u2FCD",
	  "\u9F0E",
	  "\u2FCE",
	  "\u9F13",
	  "\u2FCF",
	  "\u9F20",
	  "\u2FD0",
	  "\u9F3B",
	  "\u2FD1",
	  "\u9F4A",
	  "\u2FD2",
	  "\u9F52",
	  "\u2FD3",
	  "\u9F8D",
	  "\u2FD4",
	  "\u9F9C",
	  "\u2FD5",
	  "\u9FA0",
	  "\u3036",
	  "\u3012",
	  "\u3038",
	  "\u5341",
	  "\u3039",
	  "\u5344",
	  "\u303A",
	  "\u5345",
	  "\u309B",
	  "\u0020\u3099",
	  "\u309C",
	  "\u0020\u309A",
	  "\u3131",
	  "\u1100",
	  "\u3132",
	  "\u1101",
	  "\u3133",
	  "\u11AA",
	  "\u3134",
	  "\u1102",
	  "\u3135",
	  "\u11AC",
	  "\u3136",
	  "\u11AD",
	  "\u3137",
	  "\u1103",
	  "\u3138",
	  "\u1104",
	  "\u3139",
	  "\u1105",
	  "\u313A",
	  "\u11B0",
	  "\u313B",
	  "\u11B1",
	  "\u313C",
	  "\u11B2",
	  "\u313D",
	  "\u11B3",
	  "\u313E",
	  "\u11B4",
	  "\u313F",
	  "\u11B5",
	  "\u3140",
	  "\u111A",
	  "\u3141",
	  "\u1106",
	  "\u3142",
	  "\u1107",
	  "\u3143",
	  "\u1108",
	  "\u3144",
	  "\u1121",
	  "\u3145",
	  "\u1109",
	  "\u3146",
	  "\u110A",
	  "\u3147",
	  "\u110B",
	  "\u3148",
	  "\u110C",
	  "\u3149",
	  "\u110D",
	  "\u314A",
	  "\u110E",
	  "\u314B",
	  "\u110F",
	  "\u314C",
	  "\u1110",
	  "\u314D",
	  "\u1111",
	  "\u314E",
	  "\u1112",
	  "\u314F",
	  "\u1161",
	  "\u3150",
	  "\u1162",
	  "\u3151",
	  "\u1163",
	  "\u3152",
	  "\u1164",
	  "\u3153",
	  "\u1165",
	  "\u3154",
	  "\u1166",
	  "\u3155",
	  "\u1167",
	  "\u3156",
	  "\u1168",
	  "\u3157",
	  "\u1169",
	  "\u3158",
	  "\u116A",
	  "\u3159",
	  "\u116B",
	  "\u315A",
	  "\u116C",
	  "\u315B",
	  "\u116D",
	  "\u315C",
	  "\u116E",
	  "\u315D",
	  "\u116F",
	  "\u315E",
	  "\u1170",
	  "\u315F",
	  "\u1171",
	  "\u3160",
	  "\u1172",
	  "\u3161",
	  "\u1173",
	  "\u3162",
	  "\u1174",
	  "\u3163",
	  "\u1175",
	  "\u3164",
	  "\u1160",
	  "\u3165",
	  "\u1114",
	  "\u3166",
	  "\u1115",
	  "\u3167",
	  "\u11C7",
	  "\u3168",
	  "\u11C8",
	  "\u3169",
	  "\u11CC",
	  "\u316A",
	  "\u11CE",
	  "\u316B",
	  "\u11D3",
	  "\u316C",
	  "\u11D7",
	  "\u316D",
	  "\u11D9",
	  "\u316E",
	  "\u111C",
	  "\u316F",
	  "\u11DD",
	  "\u3170",
	  "\u11DF",
	  "\u3171",
	  "\u111D",
	  "\u3172",
	  "\u111E",
	  "\u3173",
	  "\u1120",
	  "\u3174",
	  "\u1122",
	  "\u3175",
	  "\u1123",
	  "\u3176",
	  "\u1127",
	  "\u3177",
	  "\u1129",
	  "\u3178",
	  "\u112B",
	  "\u3179",
	  "\u112C",
	  "\u317A",
	  "\u112D",
	  "\u317B",
	  "\u112E",
	  "\u317C",
	  "\u112F",
	  "\u317D",
	  "\u1132",
	  "\u317E",
	  "\u1136",
	  "\u317F",
	  "\u1140",
	  "\u3180",
	  "\u1147",
	  "\u3181",
	  "\u114C",
	  "\u3182",
	  "\u11F1",
	  "\u3183",
	  "\u11F2",
	  "\u3184",
	  "\u1157",
	  "\u3185",
	  "\u1158",
	  "\u3186",
	  "\u1159",
	  "\u3187",
	  "\u1184",
	  "\u3188",
	  "\u1185",
	  "\u3189",
	  "\u1188",
	  "\u318A",
	  "\u1191",
	  "\u318B",
	  "\u1192",
	  "\u318C",
	  "\u1194",
	  "\u318D",
	  "\u119E",
	  "\u318E",
	  "\u11A1",
	  "\u3200",
	  "\u0028\u1100\u0029",
	  "\u3201",
	  "\u0028\u1102\u0029",
	  "\u3202",
	  "\u0028\u1103\u0029",
	  "\u3203",
	  "\u0028\u1105\u0029",
	  "\u3204",
	  "\u0028\u1106\u0029",
	  "\u3205",
	  "\u0028\u1107\u0029",
	  "\u3206",
	  "\u0028\u1109\u0029",
	  "\u3207",
	  "\u0028\u110B\u0029",
	  "\u3208",
	  "\u0028\u110C\u0029",
	  "\u3209",
	  "\u0028\u110E\u0029",
	  "\u320A",
	  "\u0028\u110F\u0029",
	  "\u320B",
	  "\u0028\u1110\u0029",
	  "\u320C",
	  "\u0028\u1111\u0029",
	  "\u320D",
	  "\u0028\u1112\u0029",
	  "\u320E",
	  "\u0028\u1100\u1161\u0029",
	  "\u320F",
	  "\u0028\u1102\u1161\u0029",
	  "\u3210",
	  "\u0028\u1103\u1161\u0029",
	  "\u3211",
	  "\u0028\u1105\u1161\u0029",
	  "\u3212",
	  "\u0028\u1106\u1161\u0029",
	  "\u3213",
	  "\u0028\u1107\u1161\u0029",
	  "\u3214",
	  "\u0028\u1109\u1161\u0029",
	  "\u3215",
	  "\u0028\u110B\u1161\u0029",
	  "\u3216",
	  "\u0028\u110C\u1161\u0029",
	  "\u3217",
	  "\u0028\u110E\u1161\u0029",
	  "\u3218",
	  "\u0028\u110F\u1161\u0029",
	  "\u3219",
	  "\u0028\u1110\u1161\u0029",
	  "\u321A",
	  "\u0028\u1111\u1161\u0029",
	  "\u321B",
	  "\u0028\u1112\u1161\u0029",
	  "\u321C",
	  "\u0028\u110C\u116E\u0029",
	  "\u321D",
	  "\u0028\u110B\u1169\u110C\u1165\u11AB\u0029",
	  "\u321E",
	  "\u0028\u110B\u1169\u1112\u116E\u0029",
	  "\u3220",
	  "\u0028\u4E00\u0029",
	  "\u3221",
	  "\u0028\u4E8C\u0029",
	  "\u3222",
	  "\u0028\u4E09\u0029",
	  "\u3223",
	  "\u0028\u56DB\u0029",
	  "\u3224",
	  "\u0028\u4E94\u0029",
	  "\u3225",
	  "\u0028\u516D\u0029",
	  "\u3226",
	  "\u0028\u4E03\u0029",
	  "\u3227",
	  "\u0028\u516B\u0029",
	  "\u3228",
	  "\u0028\u4E5D\u0029",
	  "\u3229",
	  "\u0028\u5341\u0029",
	  "\u322A",
	  "\u0028\u6708\u0029",
	  "\u322B",
	  "\u0028\u706B\u0029",
	  "\u322C",
	  "\u0028\u6C34\u0029",
	  "\u322D",
	  "\u0028\u6728\u0029",
	  "\u322E",
	  "\u0028\u91D1\u0029",
	  "\u322F",
	  "\u0028\u571F\u0029",
	  "\u3230",
	  "\u0028\u65E5\u0029",
	  "\u3231",
	  "\u0028\u682A\u0029",
	  "\u3232",
	  "\u0028\u6709\u0029",
	  "\u3233",
	  "\u0028\u793E\u0029",
	  "\u3234",
	  "\u0028\u540D\u0029",
	  "\u3235",
	  "\u0028\u7279\u0029",
	  "\u3236",
	  "\u0028\u8CA1\u0029",
	  "\u3237",
	  "\u0028\u795D\u0029",
	  "\u3238",
	  "\u0028\u52B4\u0029",
	  "\u3239",
	  "\u0028\u4EE3\u0029",
	  "\u323A",
	  "\u0028\u547C\u0029",
	  "\u323B",
	  "\u0028\u5B66\u0029",
	  "\u323C",
	  "\u0028\u76E3\u0029",
	  "\u323D",
	  "\u0028\u4F01\u0029",
	  "\u323E",
	  "\u0028\u8CC7\u0029",
	  "\u323F",
	  "\u0028\u5354\u0029",
	  "\u3240",
	  "\u0028\u796D\u0029",
	  "\u3241",
	  "\u0028\u4F11\u0029",
	  "\u3242",
	  "\u0028\u81EA\u0029",
	  "\u3243",
	  "\u0028\u81F3\u0029",
	  "\u32C0",
	  "\u0031\u6708",
	  "\u32C1",
	  "\u0032\u6708",
	  "\u32C2",
	  "\u0033\u6708",
	  "\u32C3",
	  "\u0034\u6708",
	  "\u32C4",
	  "\u0035\u6708",
	  "\u32C5",
	  "\u0036\u6708",
	  "\u32C6",
	  "\u0037\u6708",
	  "\u32C7",
	  "\u0038\u6708",
	  "\u32C8",
	  "\u0039\u6708",
	  "\u32C9",
	  "\u0031\u0030\u6708",
	  "\u32CA",
	  "\u0031\u0031\u6708",
	  "\u32CB",
	  "\u0031\u0032\u6708",
	  "\u3358",
	  "\u0030\u70B9",
	  "\u3359",
	  "\u0031\u70B9",
	  "\u335A",
	  "\u0032\u70B9",
	  "\u335B",
	  "\u0033\u70B9",
	  "\u335C",
	  "\u0034\u70B9",
	  "\u335D",
	  "\u0035\u70B9",
	  "\u335E",
	  "\u0036\u70B9",
	  "\u335F",
	  "\u0037\u70B9",
	  "\u3360",
	  "\u0038\u70B9",
	  "\u3361",
	  "\u0039\u70B9",
	  "\u3362",
	  "\u0031\u0030\u70B9",
	  "\u3363",
	  "\u0031\u0031\u70B9",
	  "\u3364",
	  "\u0031\u0032\u70B9",
	  "\u3365",
	  "\u0031\u0033\u70B9",
	  "\u3366",
	  "\u0031\u0034\u70B9",
	  "\u3367",
	  "\u0031\u0035\u70B9",
	  "\u3368",
	  "\u0031\u0036\u70B9",
	  "\u3369",
	  "\u0031\u0037\u70B9",
	  "\u336A",
	  "\u0031\u0038\u70B9",
	  "\u336B",
	  "\u0031\u0039\u70B9",
	  "\u336C",
	  "\u0032\u0030\u70B9",
	  "\u336D",
	  "\u0032\u0031\u70B9",
	  "\u336E",
	  "\u0032\u0032\u70B9",
	  "\u336F",
	  "\u0032\u0033\u70B9",
	  "\u3370",
	  "\u0032\u0034\u70B9",
	  "\u33E0",
	  "\u0031\u65E5",
	  "\u33E1",
	  "\u0032\u65E5",
	  "\u33E2",
	  "\u0033\u65E5",
	  "\u33E3",
	  "\u0034\u65E5",
	  "\u33E4",
	  "\u0035\u65E5",
	  "\u33E5",
	  "\u0036\u65E5",
	  "\u33E6",
	  "\u0037\u65E5",
	  "\u33E7",
	  "\u0038\u65E5",
	  "\u33E8",
	  "\u0039\u65E5",
	  "\u33E9",
	  "\u0031\u0030\u65E5",
	  "\u33EA",
	  "\u0031\u0031\u65E5",
	  "\u33EB",
	  "\u0031\u0032\u65E5",
	  "\u33EC",
	  "\u0031\u0033\u65E5",
	  "\u33ED",
	  "\u0031\u0034\u65E5",
	  "\u33EE",
	  "\u0031\u0035\u65E5",
	  "\u33EF",
	  "\u0031\u0036\u65E5",
	  "\u33F0",
	  "\u0031\u0037\u65E5",
	  "\u33F1",
	  "\u0031\u0038\u65E5",
	  "\u33F2",
	  "\u0031\u0039\u65E5",
	  "\u33F3",
	  "\u0032\u0030\u65E5",
	  "\u33F4",
	  "\u0032\u0031\u65E5",
	  "\u33F5",
	  "\u0032\u0032\u65E5",
	  "\u33F6",
	  "\u0032\u0033\u65E5",
	  "\u33F7",
	  "\u0032\u0034\u65E5",
	  "\u33F8",
	  "\u0032\u0035\u65E5",
	  "\u33F9",
	  "\u0032\u0036\u65E5",
	  "\u33FA",
	  "\u0032\u0037\u65E5",
	  "\u33FB",
	  "\u0032\u0038\u65E5",
	  "\u33FC",
	  "\u0032\u0039\u65E5",
	  "\u33FD",
	  "\u0033\u0030\u65E5",
	  "\u33FE",
	  "\u0033\u0031\u65E5",
	  "\uFB00",
	  "\u0066\u0066",
	  "\uFB01",
	  "\u0066\u0069",
	  "\uFB02",
	  "\u0066\u006C",
	  "\uFB03",
	  "\u0066\u0066\u0069",
	  "\uFB04",
	  "\u0066\u0066\u006C",
	  "\uFB05",
	  "\u017F\u0074",
	  "\uFB06",
	  "\u0073\u0074",
	  "\uFB13",
	  "\u0574\u0576",
	  "\uFB14",
	  "\u0574\u0565",
	  "\uFB15",
	  "\u0574\u056B",
	  "\uFB16",
	  "\u057E\u0576",
	  "\uFB17",
	  "\u0574\u056D",
	  "\uFB4F",
	  "\u05D0\u05DC",
	  "\uFB50",
	  "\u0671",
	  "\uFB51",
	  "\u0671",
	  "\uFB52",
	  "\u067B",
	  "\uFB53",
	  "\u067B",
	  "\uFB54",
	  "\u067B",
	  "\uFB55",
	  "\u067B",
	  "\uFB56",
	  "\u067E",
	  "\uFB57",
	  "\u067E",
	  "\uFB58",
	  "\u067E",
	  "\uFB59",
	  "\u067E",
	  "\uFB5A",
	  "\u0680",
	  "\uFB5B",
	  "\u0680",
	  "\uFB5C",
	  "\u0680",
	  "\uFB5D",
	  "\u0680",
	  "\uFB5E",
	  "\u067A",
	  "\uFB5F",
	  "\u067A",
	  "\uFB60",
	  "\u067A",
	  "\uFB61",
	  "\u067A",
	  "\uFB62",
	  "\u067F",
	  "\uFB63",
	  "\u067F",
	  "\uFB64",
	  "\u067F",
	  "\uFB65",
	  "\u067F",
	  "\uFB66",
	  "\u0679",
	  "\uFB67",
	  "\u0679",
	  "\uFB68",
	  "\u0679",
	  "\uFB69",
	  "\u0679",
	  "\uFB6A",
	  "\u06A4",
	  "\uFB6B",
	  "\u06A4",
	  "\uFB6C",
	  "\u06A4",
	  "\uFB6D",
	  "\u06A4",
	  "\uFB6E",
	  "\u06A6",
	  "\uFB6F",
	  "\u06A6",
	  "\uFB70",
	  "\u06A6",
	  "\uFB71",
	  "\u06A6",
	  "\uFB72",
	  "\u0684",
	  "\uFB73",
	  "\u0684",
	  "\uFB74",
	  "\u0684",
	  "\uFB75",
	  "\u0684",
	  "\uFB76",
	  "\u0683",
	  "\uFB77",
	  "\u0683",
	  "\uFB78",
	  "\u0683",
	  "\uFB79",
	  "\u0683",
	  "\uFB7A",
	  "\u0686",
	  "\uFB7B",
	  "\u0686",
	  "\uFB7C",
	  "\u0686",
	  "\uFB7D",
	  "\u0686",
	  "\uFB7E",
	  "\u0687",
	  "\uFB7F",
	  "\u0687",
	  "\uFB80",
	  "\u0687",
	  "\uFB81",
	  "\u0687",
	  "\uFB82",
	  "\u068D",
	  "\uFB83",
	  "\u068D",
	  "\uFB84",
	  "\u068C",
	  "\uFB85",
	  "\u068C",
	  "\uFB86",
	  "\u068E",
	  "\uFB87",
	  "\u068E",
	  "\uFB88",
	  "\u0688",
	  "\uFB89",
	  "\u0688",
	  "\uFB8A",
	  "\u0698",
	  "\uFB8B",
	  "\u0698",
	  "\uFB8C",
	  "\u0691",
	  "\uFB8D",
	  "\u0691",
	  "\uFB8E",
	  "\u06A9",
	  "\uFB8F",
	  "\u06A9",
	  "\uFB90",
	  "\u06A9",
	  "\uFB91",
	  "\u06A9",
	  "\uFB92",
	  "\u06AF",
	  "\uFB93",
	  "\u06AF",
	  "\uFB94",
	  "\u06AF",
	  "\uFB95",
	  "\u06AF",
	  "\uFB96",
	  "\u06B3",
	  "\uFB97",
	  "\u06B3",
	  "\uFB98",
	  "\u06B3",
	  "\uFB99",
	  "\u06B3",
	  "\uFB9A",
	  "\u06B1",
	  "\uFB9B",
	  "\u06B1",
	  "\uFB9C",
	  "\u06B1",
	  "\uFB9D",
	  "\u06B1",
	  "\uFB9E",
	  "\u06BA",
	  "\uFB9F",
	  "\u06BA",
	  "\uFBA0",
	  "\u06BB",
	  "\uFBA1",
	  "\u06BB",
	  "\uFBA2",
	  "\u06BB",
	  "\uFBA3",
	  "\u06BB",
	  "\uFBA4",
	  "\u06C0",
	  "\uFBA5",
	  "\u06C0",
	  "\uFBA6",
	  "\u06C1",
	  "\uFBA7",
	  "\u06C1",
	  "\uFBA8",
	  "\u06C1",
	  "\uFBA9",
	  "\u06C1",
	  "\uFBAA",
	  "\u06BE",
	  "\uFBAB",
	  "\u06BE",
	  "\uFBAC",
	  "\u06BE",
	  "\uFBAD",
	  "\u06BE",
	  "\uFBAE",
	  "\u06D2",
	  "\uFBAF",
	  "\u06D2",
	  "\uFBB0",
	  "\u06D3",
	  "\uFBB1",
	  "\u06D3",
	  "\uFBD3",
	  "\u06AD",
	  "\uFBD4",
	  "\u06AD",
	  "\uFBD5",
	  "\u06AD",
	  "\uFBD6",
	  "\u06AD",
	  "\uFBD7",
	  "\u06C7",
	  "\uFBD8",
	  "\u06C7",
	  "\uFBD9",
	  "\u06C6",
	  "\uFBDA",
	  "\u06C6",
	  "\uFBDB",
	  "\u06C8",
	  "\uFBDC",
	  "\u06C8",
	  "\uFBDD",
	  "\u0677",
	  "\uFBDE",
	  "\u06CB",
	  "\uFBDF",
	  "\u06CB",
	  "\uFBE0",
	  "\u06C5",
	  "\uFBE1",
	  "\u06C5",
	  "\uFBE2",
	  "\u06C9",
	  "\uFBE3",
	  "\u06C9",
	  "\uFBE4",
	  "\u06D0",
	  "\uFBE5",
	  "\u06D0",
	  "\uFBE6",
	  "\u06D0",
	  "\uFBE7",
	  "\u06D0",
	  "\uFBE8",
	  "\u0649",
	  "\uFBE9",
	  "\u0649",
	  "\uFBEA",
	  "\u0626\u0627",
	  "\uFBEB",
	  "\u0626\u0627",
	  "\uFBEC",
	  "\u0626\u06D5",
	  "\uFBED",
	  "\u0626\u06D5",
	  "\uFBEE",
	  "\u0626\u0648",
	  "\uFBEF",
	  "\u0626\u0648",
	  "\uFBF0",
	  "\u0626\u06C7",
	  "\uFBF1",
	  "\u0626\u06C7",
	  "\uFBF2",
	  "\u0626\u06C6",
	  "\uFBF3",
	  "\u0626\u06C6",
	  "\uFBF4",
	  "\u0626\u06C8",
	  "\uFBF5",
	  "\u0626\u06C8",
	  "\uFBF6",
	  "\u0626\u06D0",
	  "\uFBF7",
	  "\u0626\u06D0",
	  "\uFBF8",
	  "\u0626\u06D0",
	  "\uFBF9",
	  "\u0626\u0649",
	  "\uFBFA",
	  "\u0626\u0649",
	  "\uFBFB",
	  "\u0626\u0649",
	  "\uFBFC",
	  "\u06CC",
	  "\uFBFD",
	  "\u06CC",
	  "\uFBFE",
	  "\u06CC",
	  "\uFBFF",
	  "\u06CC",
	  "\uFC00",
	  "\u0626\u062C",
	  "\uFC01",
	  "\u0626\u062D",
	  "\uFC02",
	  "\u0626\u0645",
	  "\uFC03",
	  "\u0626\u0649",
	  "\uFC04",
	  "\u0626\u064A",
	  "\uFC05",
	  "\u0628\u062C",
	  "\uFC06",
	  "\u0628\u062D",
	  "\uFC07",
	  "\u0628\u062E",
	  "\uFC08",
	  "\u0628\u0645",
	  "\uFC09",
	  "\u0628\u0649",
	  "\uFC0A",
	  "\u0628\u064A",
	  "\uFC0B",
	  "\u062A\u062C",
	  "\uFC0C",
	  "\u062A\u062D",
	  "\uFC0D",
	  "\u062A\u062E",
	  "\uFC0E",
	  "\u062A\u0645",
	  "\uFC0F",
	  "\u062A\u0649",
	  "\uFC10",
	  "\u062A\u064A",
	  "\uFC11",
	  "\u062B\u062C",
	  "\uFC12",
	  "\u062B\u0645",
	  "\uFC13",
	  "\u062B\u0649",
	  "\uFC14",
	  "\u062B\u064A",
	  "\uFC15",
	  "\u062C\u062D",
	  "\uFC16",
	  "\u062C\u0645",
	  "\uFC17",
	  "\u062D\u062C",
	  "\uFC18",
	  "\u062D\u0645",
	  "\uFC19",
	  "\u062E\u062C",
	  "\uFC1A",
	  "\u062E\u062D",
	  "\uFC1B",
	  "\u062E\u0645",
	  "\uFC1C",
	  "\u0633\u062C",
	  "\uFC1D",
	  "\u0633\u062D",
	  "\uFC1E",
	  "\u0633\u062E",
	  "\uFC1F",
	  "\u0633\u0645",
	  "\uFC20",
	  "\u0635\u062D",
	  "\uFC21",
	  "\u0635\u0645",
	  "\uFC22",
	  "\u0636\u062C",
	  "\uFC23",
	  "\u0636\u062D",
	  "\uFC24",
	  "\u0636\u062E",
	  "\uFC25",
	  "\u0636\u0645",
	  "\uFC26",
	  "\u0637\u062D",
	  "\uFC27",
	  "\u0637\u0645",
	  "\uFC28",
	  "\u0638\u0645",
	  "\uFC29",
	  "\u0639\u062C",
	  "\uFC2A",
	  "\u0639\u0645",
	  "\uFC2B",
	  "\u063A\u062C",
	  "\uFC2C",
	  "\u063A\u0645",
	  "\uFC2D",
	  "\u0641\u062C",
	  "\uFC2E",
	  "\u0641\u062D",
	  "\uFC2F",
	  "\u0641\u062E",
	  "\uFC30",
	  "\u0641\u0645",
	  "\uFC31",
	  "\u0641\u0649",
	  "\uFC32",
	  "\u0641\u064A",
	  "\uFC33",
	  "\u0642\u062D",
	  "\uFC34",
	  "\u0642\u0645",
	  "\uFC35",
	  "\u0642\u0649",
	  "\uFC36",
	  "\u0642\u064A",
	  "\uFC37",
	  "\u0643\u0627",
	  "\uFC38",
	  "\u0643\u062C",
	  "\uFC39",
	  "\u0643\u062D",
	  "\uFC3A",
	  "\u0643\u062E",
	  "\uFC3B",
	  "\u0643\u0644",
	  "\uFC3C",
	  "\u0643\u0645",
	  "\uFC3D",
	  "\u0643\u0649",
	  "\uFC3E",
	  "\u0643\u064A",
	  "\uFC3F",
	  "\u0644\u062C",
	  "\uFC40",
	  "\u0644\u062D",
	  "\uFC41",
	  "\u0644\u062E",
	  "\uFC42",
	  "\u0644\u0645",
	  "\uFC43",
	  "\u0644\u0649",
	  "\uFC44",
	  "\u0644\u064A",
	  "\uFC45",
	  "\u0645\u062C",
	  "\uFC46",
	  "\u0645\u062D",
	  "\uFC47",
	  "\u0645\u062E",
	  "\uFC48",
	  "\u0645\u0645",
	  "\uFC49",
	  "\u0645\u0649",
	  "\uFC4A",
	  "\u0645\u064A",
	  "\uFC4B",
	  "\u0646\u062C",
	  "\uFC4C",
	  "\u0646\u062D",
	  "\uFC4D",
	  "\u0646\u062E",
	  "\uFC4E",
	  "\u0646\u0645",
	  "\uFC4F",
	  "\u0646\u0649",
	  "\uFC50",
	  "\u0646\u064A",
	  "\uFC51",
	  "\u0647\u062C",
	  "\uFC52",
	  "\u0647\u0645",
	  "\uFC53",
	  "\u0647\u0649",
	  "\uFC54",
	  "\u0647\u064A",
	  "\uFC55",
	  "\u064A\u062C",
	  "\uFC56",
	  "\u064A\u062D",
	  "\uFC57",
	  "\u064A\u062E",
	  "\uFC58",
	  "\u064A\u0645",
	  "\uFC59",
	  "\u064A\u0649",
	  "\uFC5A",
	  "\u064A\u064A",
	  "\uFC5B",
	  "\u0630\u0670",
	  "\uFC5C",
	  "\u0631\u0670",
	  "\uFC5D",
	  "\u0649\u0670",
	  "\uFC5E",
	  "\u0020\u064C\u0651",
	  "\uFC5F",
	  "\u0020\u064D\u0651",
	  "\uFC60",
	  "\u0020\u064E\u0651",
	  "\uFC61",
	  "\u0020\u064F\u0651",
	  "\uFC62",
	  "\u0020\u0650\u0651",
	  "\uFC63",
	  "\u0020\u0651\u0670",
	  "\uFC64",
	  "\u0626\u0631",
	  "\uFC65",
	  "\u0626\u0632",
	  "\uFC66",
	  "\u0626\u0645",
	  "\uFC67",
	  "\u0626\u0646",
	  "\uFC68",
	  "\u0626\u0649",
	  "\uFC69",
	  "\u0626\u064A",
	  "\uFC6A",
	  "\u0628\u0631",
	  "\uFC6B",
	  "\u0628\u0632",
	  "\uFC6C",
	  "\u0628\u0645",
	  "\uFC6D",
	  "\u0628\u0646",
	  "\uFC6E",
	  "\u0628\u0649",
	  "\uFC6F",
	  "\u0628\u064A",
	  "\uFC70",
	  "\u062A\u0631",
	  "\uFC71",
	  "\u062A\u0632",
	  "\uFC72",
	  "\u062A\u0645",
	  "\uFC73",
	  "\u062A\u0646",
	  "\uFC74",
	  "\u062A\u0649",
	  "\uFC75",
	  "\u062A\u064A",
	  "\uFC76",
	  "\u062B\u0631",
	  "\uFC77",
	  "\u062B\u0632",
	  "\uFC78",
	  "\u062B\u0645",
	  "\uFC79",
	  "\u062B\u0646",
	  "\uFC7A",
	  "\u062B\u0649",
	  "\uFC7B",
	  "\u062B\u064A",
	  "\uFC7C",
	  "\u0641\u0649",
	  "\uFC7D",
	  "\u0641\u064A",
	  "\uFC7E",
	  "\u0642\u0649",
	  "\uFC7F",
	  "\u0642\u064A",
	  "\uFC80",
	  "\u0643\u0627",
	  "\uFC81",
	  "\u0643\u0644",
	  "\uFC82",
	  "\u0643\u0645",
	  "\uFC83",
	  "\u0643\u0649",
	  "\uFC84",
	  "\u0643\u064A",
	  "\uFC85",
	  "\u0644\u0645",
	  "\uFC86",
	  "\u0644\u0649",
	  "\uFC87",
	  "\u0644\u064A",
	  "\uFC88",
	  "\u0645\u0627",
	  "\uFC89",
	  "\u0645\u0645",
	  "\uFC8A",
	  "\u0646\u0631",
	  "\uFC8B",
	  "\u0646\u0632",
	  "\uFC8C",
	  "\u0646\u0645",
	  "\uFC8D",
	  "\u0646\u0646",
	  "\uFC8E",
	  "\u0646\u0649",
	  "\uFC8F",
	  "\u0646\u064A",
	  "\uFC90",
	  "\u0649\u0670",
	  "\uFC91",
	  "\u064A\u0631",
	  "\uFC92",
	  "\u064A\u0632",
	  "\uFC93",
	  "\u064A\u0645",
	  "\uFC94",
	  "\u064A\u0646",
	  "\uFC95",
	  "\u064A\u0649",
	  "\uFC96",
	  "\u064A\u064A",
	  "\uFC97",
	  "\u0626\u062C",
	  "\uFC98",
	  "\u0626\u062D",
	  "\uFC99",
	  "\u0626\u062E",
	  "\uFC9A",
	  "\u0626\u0645",
	  "\uFC9B",
	  "\u0626\u0647",
	  "\uFC9C",
	  "\u0628\u062C",
	  "\uFC9D",
	  "\u0628\u062D",
	  "\uFC9E",
	  "\u0628\u062E",
	  "\uFC9F",
	  "\u0628\u0645",
	  "\uFCA0",
	  "\u0628\u0647",
	  "\uFCA1",
	  "\u062A\u062C",
	  "\uFCA2",
	  "\u062A\u062D",
	  "\uFCA3",
	  "\u062A\u062E",
	  "\uFCA4",
	  "\u062A\u0645",
	  "\uFCA5",
	  "\u062A\u0647",
	  "\uFCA6",
	  "\u062B\u0645",
	  "\uFCA7",
	  "\u062C\u062D",
	  "\uFCA8",
	  "\u062C\u0645",
	  "\uFCA9",
	  "\u062D\u062C",
	  "\uFCAA",
	  "\u062D\u0645",
	  "\uFCAB",
	  "\u062E\u062C",
	  "\uFCAC",
	  "\u062E\u0645",
	  "\uFCAD",
	  "\u0633\u062C",
	  "\uFCAE",
	  "\u0633\u062D",
	  "\uFCAF",
	  "\u0633\u062E",
	  "\uFCB0",
	  "\u0633\u0645",
	  "\uFCB1",
	  "\u0635\u062D",
	  "\uFCB2",
	  "\u0635\u062E",
	  "\uFCB3",
	  "\u0635\u0645",
	  "\uFCB4",
	  "\u0636\u062C",
	  "\uFCB5",
	  "\u0636\u062D",
	  "\uFCB6",
	  "\u0636\u062E",
	  "\uFCB7",
	  "\u0636\u0645",
	  "\uFCB8",
	  "\u0637\u062D",
	  "\uFCB9",
	  "\u0638\u0645",
	  "\uFCBA",
	  "\u0639\u062C",
	  "\uFCBB",
	  "\u0639\u0645",
	  "\uFCBC",
	  "\u063A\u062C",
	  "\uFCBD",
	  "\u063A\u0645",
	  "\uFCBE",
	  "\u0641\u062C",
	  "\uFCBF",
	  "\u0641\u062D",
	  "\uFCC0",
	  "\u0641\u062E",
	  "\uFCC1",
	  "\u0641\u0645",
	  "\uFCC2",
	  "\u0642\u062D",
	  "\uFCC3",
	  "\u0642\u0645",
	  "\uFCC4",
	  "\u0643\u062C",
	  "\uFCC5",
	  "\u0643\u062D",
	  "\uFCC6",
	  "\u0643\u062E",
	  "\uFCC7",
	  "\u0643\u0644",
	  "\uFCC8",
	  "\u0643\u0645",
	  "\uFCC9",
	  "\u0644\u062C",
	  "\uFCCA",
	  "\u0644\u062D",
	  "\uFCCB",
	  "\u0644\u062E",
	  "\uFCCC",
	  "\u0644\u0645",
	  "\uFCCD",
	  "\u0644\u0647",
	  "\uFCCE",
	  "\u0645\u062C",
	  "\uFCCF",
	  "\u0645\u062D",
	  "\uFCD0",
	  "\u0645\u062E",
	  "\uFCD1",
	  "\u0645\u0645",
	  "\uFCD2",
	  "\u0646\u062C",
	  "\uFCD3",
	  "\u0646\u062D",
	  "\uFCD4",
	  "\u0646\u062E",
	  "\uFCD5",
	  "\u0646\u0645",
	  "\uFCD6",
	  "\u0646\u0647",
	  "\uFCD7",
	  "\u0647\u062C",
	  "\uFCD8",
	  "\u0647\u0645",
	  "\uFCD9",
	  "\u0647\u0670",
	  "\uFCDA",
	  "\u064A\u062C",
	  "\uFCDB",
	  "\u064A\u062D",
	  "\uFCDC",
	  "\u064A\u062E",
	  "\uFCDD",
	  "\u064A\u0645",
	  "\uFCDE",
	  "\u064A\u0647",
	  "\uFCDF",
	  "\u0626\u0645",
	  "\uFCE0",
	  "\u0626\u0647",
	  "\uFCE1",
	  "\u0628\u0645",
	  "\uFCE2",
	  "\u0628\u0647",
	  "\uFCE3",
	  "\u062A\u0645",
	  "\uFCE4",
	  "\u062A\u0647",
	  "\uFCE5",
	  "\u062B\u0645",
	  "\uFCE6",
	  "\u062B\u0647",
	  "\uFCE7",
	  "\u0633\u0645",
	  "\uFCE8",
	  "\u0633\u0647",
	  "\uFCE9",
	  "\u0634\u0645",
	  "\uFCEA",
	  "\u0634\u0647",
	  "\uFCEB",
	  "\u0643\u0644",
	  "\uFCEC",
	  "\u0643\u0645",
	  "\uFCED",
	  "\u0644\u0645",
	  "\uFCEE",
	  "\u0646\u0645",
	  "\uFCEF",
	  "\u0646\u0647",
	  "\uFCF0",
	  "\u064A\u0645",
	  "\uFCF1",
	  "\u064A\u0647",
	  "\uFCF2",
	  "\u0640\u064E\u0651",
	  "\uFCF3",
	  "\u0640\u064F\u0651",
	  "\uFCF4",
	  "\u0640\u0650\u0651",
	  "\uFCF5",
	  "\u0637\u0649",
	  "\uFCF6",
	  "\u0637\u064A",
	  "\uFCF7",
	  "\u0639\u0649",
	  "\uFCF8",
	  "\u0639\u064A",
	  "\uFCF9",
	  "\u063A\u0649",
	  "\uFCFA",
	  "\u063A\u064A",
	  "\uFCFB",
	  "\u0633\u0649",
	  "\uFCFC",
	  "\u0633\u064A",
	  "\uFCFD",
	  "\u0634\u0649",
	  "\uFCFE",
	  "\u0634\u064A",
	  "\uFCFF",
	  "\u062D\u0649",
	  "\uFD00",
	  "\u062D\u064A",
	  "\uFD01",
	  "\u062C\u0649",
	  "\uFD02",
	  "\u062C\u064A",
	  "\uFD03",
	  "\u062E\u0649",
	  "\uFD04",
	  "\u062E\u064A",
	  "\uFD05",
	  "\u0635\u0649",
	  "\uFD06",
	  "\u0635\u064A",
	  "\uFD07",
	  "\u0636\u0649",
	  "\uFD08",
	  "\u0636\u064A",
	  "\uFD09",
	  "\u0634\u062C",
	  "\uFD0A",
	  "\u0634\u062D",
	  "\uFD0B",
	  "\u0634\u062E",
	  "\uFD0C",
	  "\u0634\u0645",
	  "\uFD0D",
	  "\u0634\u0631",
	  "\uFD0E",
	  "\u0633\u0631",
	  "\uFD0F",
	  "\u0635\u0631",
	  "\uFD10",
	  "\u0636\u0631",
	  "\uFD11",
	  "\u0637\u0649",
	  "\uFD12",
	  "\u0637\u064A",
	  "\uFD13",
	  "\u0639\u0649",
	  "\uFD14",
	  "\u0639\u064A",
	  "\uFD15",
	  "\u063A\u0649",
	  "\uFD16",
	  "\u063A\u064A",
	  "\uFD17",
	  "\u0633\u0649",
	  "\uFD18",
	  "\u0633\u064A",
	  "\uFD19",
	  "\u0634\u0649",
	  "\uFD1A",
	  "\u0634\u064A",
	  "\uFD1B",
	  "\u062D\u0649",
	  "\uFD1C",
	  "\u062D\u064A",
	  "\uFD1D",
	  "\u062C\u0649",
	  "\uFD1E",
	  "\u062C\u064A",
	  "\uFD1F",
	  "\u062E\u0649",
	  "\uFD20",
	  "\u062E\u064A",
	  "\uFD21",
	  "\u0635\u0649",
	  "\uFD22",
	  "\u0635\u064A",
	  "\uFD23",
	  "\u0636\u0649",
	  "\uFD24",
	  "\u0636\u064A",
	  "\uFD25",
	  "\u0634\u062C",
	  "\uFD26",
	  "\u0634\u062D",
	  "\uFD27",
	  "\u0634\u062E",
	  "\uFD28",
	  "\u0634\u0645",
	  "\uFD29",
	  "\u0634\u0631",
	  "\uFD2A",
	  "\u0633\u0631",
	  "\uFD2B",
	  "\u0635\u0631",
	  "\uFD2C",
	  "\u0636\u0631",
	  "\uFD2D",
	  "\u0634\u062C",
	  "\uFD2E",
	  "\u0634\u062D",
	  "\uFD2F",
	  "\u0634\u062E",
	  "\uFD30",
	  "\u0634\u0645",
	  "\uFD31",
	  "\u0633\u0647",
	  "\uFD32",
	  "\u0634\u0647",
	  "\uFD33",
	  "\u0637\u0645",
	  "\uFD34",
	  "\u0633\u062C",
	  "\uFD35",
	  "\u0633\u062D",
	  "\uFD36",
	  "\u0633\u062E",
	  "\uFD37",
	  "\u0634\u062C",
	  "\uFD38",
	  "\u0634\u062D",
	  "\uFD39",
	  "\u0634\u062E",
	  "\uFD3A",
	  "\u0637\u0645",
	  "\uFD3B",
	  "\u0638\u0645",
	  "\uFD3C",
	  "\u0627\u064B",
	  "\uFD3D",
	  "\u0627\u064B",
	  "\uFD50",
	  "\u062A\u062C\u0645",
	  "\uFD51",
	  "\u062A\u062D\u062C",
	  "\uFD52",
	  "\u062A\u062D\u062C",
	  "\uFD53",
	  "\u062A\u062D\u0645",
	  "\uFD54",
	  "\u062A\u062E\u0645",
	  "\uFD55",
	  "\u062A\u0645\u062C",
	  "\uFD56",
	  "\u062A\u0645\u062D",
	  "\uFD57",
	  "\u062A\u0645\u062E",
	  "\uFD58",
	  "\u062C\u0645\u062D",
	  "\uFD59",
	  "\u062C\u0645\u062D",
	  "\uFD5A",
	  "\u062D\u0645\u064A",
	  "\uFD5B",
	  "\u062D\u0645\u0649",
	  "\uFD5C",
	  "\u0633\u062D\u062C",
	  "\uFD5D",
	  "\u0633\u062C\u062D",
	  "\uFD5E",
	  "\u0633\u062C\u0649",
	  "\uFD5F",
	  "\u0633\u0645\u062D",
	  "\uFD60",
	  "\u0633\u0645\u062D",
	  "\uFD61",
	  "\u0633\u0645\u062C",
	  "\uFD62",
	  "\u0633\u0645\u0645",
	  "\uFD63",
	  "\u0633\u0645\u0645",
	  "\uFD64",
	  "\u0635\u062D\u062D",
	  "\uFD65",
	  "\u0635\u062D\u062D",
	  "\uFD66",
	  "\u0635\u0645\u0645",
	  "\uFD67",
	  "\u0634\u062D\u0645",
	  "\uFD68",
	  "\u0634\u062D\u0645",
	  "\uFD69",
	  "\u0634\u062C\u064A",
	  "\uFD6A",
	  "\u0634\u0645\u062E",
	  "\uFD6B",
	  "\u0634\u0645\u062E",
	  "\uFD6C",
	  "\u0634\u0645\u0645",
	  "\uFD6D",
	  "\u0634\u0645\u0645",
	  "\uFD6E",
	  "\u0636\u062D\u0649",
	  "\uFD6F",
	  "\u0636\u062E\u0645",
	  "\uFD70",
	  "\u0636\u062E\u0645",
	  "\uFD71",
	  "\u0637\u0645\u062D",
	  "\uFD72",
	  "\u0637\u0645\u062D",
	  "\uFD73",
	  "\u0637\u0645\u0645",
	  "\uFD74",
	  "\u0637\u0645\u064A",
	  "\uFD75",
	  "\u0639\u062C\u0645",
	  "\uFD76",
	  "\u0639\u0645\u0645",
	  "\uFD77",
	  "\u0639\u0645\u0645",
	  "\uFD78",
	  "\u0639\u0645\u0649",
	  "\uFD79",
	  "\u063A\u0645\u0645",
	  "\uFD7A",
	  "\u063A\u0645\u064A",
	  "\uFD7B",
	  "\u063A\u0645\u0649",
	  "\uFD7C",
	  "\u0641\u062E\u0645",
	  "\uFD7D",
	  "\u0641\u062E\u0645",
	  "\uFD7E",
	  "\u0642\u0645\u062D",
	  "\uFD7F",
	  "\u0642\u0645\u0645",
	  "\uFD80",
	  "\u0644\u062D\u0645",
	  "\uFD81",
	  "\u0644\u062D\u064A",
	  "\uFD82",
	  "\u0644\u062D\u0649",
	  "\uFD83",
	  "\u0644\u062C\u062C",
	  "\uFD84",
	  "\u0644\u062C\u062C",
	  "\uFD85",
	  "\u0644\u062E\u0645",
	  "\uFD86",
	  "\u0644\u062E\u0645",
	  "\uFD87",
	  "\u0644\u0645\u062D",
	  "\uFD88",
	  "\u0644\u0645\u062D",
	  "\uFD89",
	  "\u0645\u062D\u062C",
	  "\uFD8A",
	  "\u0645\u062D\u0645",
	  "\uFD8B",
	  "\u0645\u062D\u064A",
	  "\uFD8C",
	  "\u0645\u062C\u062D",
	  "\uFD8D",
	  "\u0645\u062C\u0645",
	  "\uFD8E",
	  "\u0645\u062E\u062C",
	  "\uFD8F",
	  "\u0645\u062E\u0645",
	  "\uFD92",
	  "\u0645\u062C\u062E",
	  "\uFD93",
	  "\u0647\u0645\u062C",
	  "\uFD94",
	  "\u0647\u0645\u0645",
	  "\uFD95",
	  "\u0646\u062D\u0645",
	  "\uFD96",
	  "\u0646\u062D\u0649",
	  "\uFD97",
	  "\u0646\u062C\u0645",
	  "\uFD98",
	  "\u0646\u062C\u0645",
	  "\uFD99",
	  "\u0646\u062C\u0649",
	  "\uFD9A",
	  "\u0646\u0645\u064A",
	  "\uFD9B",
	  "\u0646\u0645\u0649",
	  "\uFD9C",
	  "\u064A\u0645\u0645",
	  "\uFD9D",
	  "\u064A\u0645\u0645",
	  "\uFD9E",
	  "\u0628\u062E\u064A",
	  "\uFD9F",
	  "\u062A\u062C\u064A",
	  "\uFDA0",
	  "\u062A\u062C\u0649",
	  "\uFDA1",
	  "\u062A\u062E\u064A",
	  "\uFDA2",
	  "\u062A\u062E\u0649",
	  "\uFDA3",
	  "\u062A\u0645\u064A",
	  "\uFDA4",
	  "\u062A\u0645\u0649",
	  "\uFDA5",
	  "\u062C\u0645\u064A",
	  "\uFDA6",
	  "\u062C\u062D\u0649",
	  "\uFDA7",
	  "\u062C\u0645\u0649",
	  "\uFDA8",
	  "\u0633\u062E\u0649",
	  "\uFDA9",
	  "\u0635\u062D\u064A",
	  "\uFDAA",
	  "\u0634\u062D\u064A",
	  "\uFDAB",
	  "\u0636\u062D\u064A",
	  "\uFDAC",
	  "\u0644\u062C\u064A",
	  "\uFDAD",
	  "\u0644\u0645\u064A",
	  "\uFDAE",
	  "\u064A\u062D\u064A",
	  "\uFDAF",
	  "\u064A\u062C\u064A",
	  "\uFDB0",
	  "\u064A\u0645\u064A",
	  "\uFDB1",
	  "\u0645\u0645\u064A",
	  "\uFDB2",
	  "\u0642\u0645\u064A",
	  "\uFDB3",
	  "\u0646\u062D\u064A",
	  "\uFDB4",
	  "\u0642\u0645\u062D",
	  "\uFDB5",
	  "\u0644\u062D\u0645",
	  "\uFDB6",
	  "\u0639\u0645\u064A",
	  "\uFDB7",
	  "\u0643\u0645\u064A",
	  "\uFDB8",
	  "\u0646\u062C\u062D",
	  "\uFDB9",
	  "\u0645\u062E\u064A",
	  "\uFDBA",
	  "\u0644\u062C\u0645",
	  "\uFDBB",
	  "\u0643\u0645\u0645",
	  "\uFDBC",
	  "\u0644\u062C\u0645",
	  "\uFDBD",
	  "\u0646\u062C\u062D",
	  "\uFDBE",
	  "\u062C\u062D\u064A",
	  "\uFDBF",
	  "\u062D\u062C\u064A",
	  "\uFDC0",
	  "\u0645\u062C\u064A",
	  "\uFDC1",
	  "\u0641\u0645\u064A",
	  "\uFDC2",
	  "\u0628\u062D\u064A",
	  "\uFDC3",
	  "\u0643\u0645\u0645",
	  "\uFDC4",
	  "\u0639\u062C\u0645",
	  "\uFDC5",
	  "\u0635\u0645\u0645",
	  "\uFDC6",
	  "\u0633\u062E\u064A",
	  "\uFDC7",
	  "\u0646\u062C\u064A",
	  "\uFE49",
	  "\u203E",
	  "\uFE4A",
	  "\u203E",
	  "\uFE4B",
	  "\u203E",
	  "\uFE4C",
	  "\u203E",
	  "\uFE4D",
	  "\u005F",
	  "\uFE4E",
	  "\u005F",
	  "\uFE4F",
	  "\u005F",
	  "\uFE80",
	  "\u0621",
	  "\uFE81",
	  "\u0622",
	  "\uFE82",
	  "\u0622",
	  "\uFE83",
	  "\u0623",
	  "\uFE84",
	  "\u0623",
	  "\uFE85",
	  "\u0624",
	  "\uFE86",
	  "\u0624",
	  "\uFE87",
	  "\u0625",
	  "\uFE88",
	  "\u0625",
	  "\uFE89",
	  "\u0626",
	  "\uFE8A",
	  "\u0626",
	  "\uFE8B",
	  "\u0626",
	  "\uFE8C",
	  "\u0626",
	  "\uFE8D",
	  "\u0627",
	  "\uFE8E",
	  "\u0627",
	  "\uFE8F",
	  "\u0628",
	  "\uFE90",
	  "\u0628",
	  "\uFE91",
	  "\u0628",
	  "\uFE92",
	  "\u0628",
	  "\uFE93",
	  "\u0629",
	  "\uFE94",
	  "\u0629",
	  "\uFE95",
	  "\u062A",
	  "\uFE96",
	  "\u062A",
	  "\uFE97",
	  "\u062A",
	  "\uFE98",
	  "\u062A",
	  "\uFE99",
	  "\u062B",
	  "\uFE9A",
	  "\u062B",
	  "\uFE9B",
	  "\u062B",
	  "\uFE9C",
	  "\u062B",
	  "\uFE9D",
	  "\u062C",
	  "\uFE9E",
	  "\u062C",
	  "\uFE9F",
	  "\u062C",
	  "\uFEA0",
	  "\u062C",
	  "\uFEA1",
	  "\u062D",
	  "\uFEA2",
	  "\u062D",
	  "\uFEA3",
	  "\u062D",
	  "\uFEA4",
	  "\u062D",
	  "\uFEA5",
	  "\u062E",
	  "\uFEA6",
	  "\u062E",
	  "\uFEA7",
	  "\u062E",
	  "\uFEA8",
	  "\u062E",
	  "\uFEA9",
	  "\u062F",
	  "\uFEAA",
	  "\u062F",
	  "\uFEAB",
	  "\u0630",
	  "\uFEAC",
	  "\u0630",
	  "\uFEAD",
	  "\u0631",
	  "\uFEAE",
	  "\u0631",
	  "\uFEAF",
	  "\u0632",
	  "\uFEB0",
	  "\u0632",
	  "\uFEB1",
	  "\u0633",
	  "\uFEB2",
	  "\u0633",
	  "\uFEB3",
	  "\u0633",
	  "\uFEB4",
	  "\u0633",
	  "\uFEB5",
	  "\u0634",
	  "\uFEB6",
	  "\u0634",
	  "\uFEB7",
	  "\u0634",
	  "\uFEB8",
	  "\u0634",
	  "\uFEB9",
	  "\u0635",
	  "\uFEBA",
	  "\u0635",
	  "\uFEBB",
	  "\u0635",
	  "\uFEBC",
	  "\u0635",
	  "\uFEBD",
	  "\u0636",
	  "\uFEBE",
	  "\u0636",
	  "\uFEBF",
	  "\u0636",
	  "\uFEC0",
	  "\u0636",
	  "\uFEC1",
	  "\u0637",
	  "\uFEC2",
	  "\u0637",
	  "\uFEC3",
	  "\u0637",
	  "\uFEC4",
	  "\u0637",
	  "\uFEC5",
	  "\u0638",
	  "\uFEC6",
	  "\u0638",
	  "\uFEC7",
	  "\u0638",
	  "\uFEC8",
	  "\u0638",
	  "\uFEC9",
	  "\u0639",
	  "\uFECA",
	  "\u0639",
	  "\uFECB",
	  "\u0639",
	  "\uFECC",
	  "\u0639",
	  "\uFECD",
	  "\u063A",
	  "\uFECE",
	  "\u063A",
	  "\uFECF",
	  "\u063A",
	  "\uFED0",
	  "\u063A",
	  "\uFED1",
	  "\u0641",
	  "\uFED2",
	  "\u0641",
	  "\uFED3",
	  "\u0641",
	  "\uFED4",
	  "\u0641",
	  "\uFED5",
	  "\u0642",
	  "\uFED6",
	  "\u0642",
	  "\uFED7",
	  "\u0642",
	  "\uFED8",
	  "\u0642",
	  "\uFED9",
	  "\u0643",
	  "\uFEDA",
	  "\u0643",
	  "\uFEDB",
	  "\u0643",
	  "\uFEDC",
	  "\u0643",
	  "\uFEDD",
	  "\u0644",
	  "\uFEDE",
	  "\u0644",
	  "\uFEDF",
	  "\u0644",
	  "\uFEE0",
	  "\u0644",
	  "\uFEE1",
	  "\u0645",
	  "\uFEE2",
	  "\u0645",
	  "\uFEE3",
	  "\u0645",
	  "\uFEE4",
	  "\u0645",
	  "\uFEE5",
	  "\u0646",
	  "\uFEE6",
	  "\u0646",
	  "\uFEE7",
	  "\u0646",
	  "\uFEE8",
	  "\u0646",
	  "\uFEE9",
	  "\u0647",
	  "\uFEEA",
	  "\u0647",
	  "\uFEEB",
	  "\u0647",
	  "\uFEEC",
	  "\u0647",
	  "\uFEED",
	  "\u0648",
	  "\uFEEE",
	  "\u0648",
	  "\uFEEF",
	  "\u0649",
	  "\uFEF0",
	  "\u0649",
	  "\uFEF1",
	  "\u064A",
	  "\uFEF2",
	  "\u064A",
	  "\uFEF3",
	  "\u064A",
	  "\uFEF4",
	  "\u064A",
	  "\uFEF5",
	  "\u0644\u0622",
	  "\uFEF6",
	  "\u0644\u0622",
	  "\uFEF7",
	  "\u0644\u0623",
	  "\uFEF8",
	  "\u0644\u0623",
	  "\uFEF9",
	  "\u0644\u0625",
	  "\uFEFA",
	  "\u0644\u0625",
	  "\uFEFB",
	  "\u0644\u0627",
	  "\uFEFC",
	  "\u0644\u0627"
	 ];
	});
	function reverseIfRtl(chars) {
	 const charsLength = chars.length;
	 if (charsLength <= 1 || !isRTLRangeFor(chars.charCodeAt(0))) {
	  return chars;
	 }
	 const buf = [];
	 for (let ii = charsLength - 1; ii >= 0; ii--) {
	  buf.push(chars[ii]);
	 }
	 return buf.join("");
	}
	const SpecialCharRegExp = new RegExp("^(\\s)|(\\p{Mn})|(\\p{Cf})$", "u");
	const CategoryCache = new Map();
	function getCharUnicodeCategory(char) {
	 const cachedCategory = CategoryCache.get(char);
	 if (cachedCategory) {
	  return cachedCategory;
	 }
	 const groups = char.match(SpecialCharRegExp);
	 const category = {
	  isWhitespace: !!(groups && groups[1]),
	  isZeroWidthDiacritic: !!(groups && groups[2]),
	  isInvisibleFormatMark: !!(groups && groups[3])
	 };
	 CategoryCache.set(char, category);
	 return category;
	}
	function clearUnicodeCaches() {
	 CategoryCache.clear();
	}


	/***/ }),
	/* 41 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.getSerifFonts = exports.getNonStdFontMap = exports.getGlyphMapForStandardFonts = exports.getFontNameToFileMap = void 0;
	exports.getStandardFontName = getStandardFontName;
	exports.getSymbolsFonts = exports.getSupplementalGlyphMapForCalibri = exports.getSupplementalGlyphMapForArialBlack = exports.getStdFontMap = void 0;

	var _core_utils = __w_pdfjs_require__(6);

	var _fonts_utils = __w_pdfjs_require__(38);

	const getStdFontMap = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t["Times-Roman"] = "Times-Roman";
	  t.Helvetica = "Helvetica";
	  t.Courier = "Courier";
	  t.Symbol = "Symbol";
	  t["Times-Bold"] = "Times-Bold";
	  t["Helvetica-Bold"] = "Helvetica-Bold";
	  t["Courier-Bold"] = "Courier-Bold";
	  t.ZapfDingbats = "ZapfDingbats";
	  t["Times-Italic"] = "Times-Italic";
	  t["Helvetica-Oblique"] = "Helvetica-Oblique";
	  t["Courier-Oblique"] = "Courier-Oblique";
	  t["Times-BoldItalic"] = "Times-BoldItalic";
	  t["Helvetica-BoldOblique"] = "Helvetica-BoldOblique";
	  t["Courier-BoldOblique"] = "Courier-BoldOblique";
	  t.ArialNarrow = "Helvetica";
	  t["ArialNarrow-Bold"] = "Helvetica-Bold";
	  t["ArialNarrow-BoldItalic"] = "Helvetica-BoldOblique";
	  t["ArialNarrow-Italic"] = "Helvetica-Oblique";
	  t.ArialBlack = "Helvetica";
	  t["ArialBlack-Bold"] = "Helvetica-Bold";
	  t["ArialBlack-BoldItalic"] = "Helvetica-BoldOblique";
	  t["ArialBlack-Italic"] = "Helvetica-Oblique";
	  t["Arial-Black"] = "Helvetica";
	  t["Arial-Black-Bold"] = "Helvetica-Bold";
	  t["Arial-Black-BoldItalic"] = "Helvetica-BoldOblique";
	  t["Arial-Black-Italic"] = "Helvetica-Oblique";
	  t.Arial = "Helvetica";
	  t["Arial-Bold"] = "Helvetica-Bold";
	  t["Arial-BoldItalic"] = "Helvetica-BoldOblique";
	  t["Arial-Italic"] = "Helvetica-Oblique";
	  t.ArialMT = "Helvetica";
	  t["Arial-BoldItalicMT"] = "Helvetica-BoldOblique";
	  t["Arial-BoldMT"] = "Helvetica-Bold";
	  t["Arial-ItalicMT"] = "Helvetica-Oblique";
	  t.ArialUnicodeMS = "Helvetica";
	  t["ArialUnicodeMS-Bold"] = "Helvetica-Bold";
	  t["ArialUnicodeMS-BoldItalic"] = "Helvetica-BoldOblique";
	  t["ArialUnicodeMS-Italic"] = "Helvetica-Oblique";
	  t["Courier-BoldItalic"] = "Courier-BoldOblique";
	  t["Courier-Italic"] = "Courier-Oblique";
	  t.CourierNew = "Courier";
	  t["CourierNew-Bold"] = "Courier-Bold";
	  t["CourierNew-BoldItalic"] = "Courier-BoldOblique";
	  t["CourierNew-Italic"] = "Courier-Oblique";
	  t["CourierNewPS-BoldItalicMT"] = "Courier-BoldOblique";
	  t["CourierNewPS-BoldMT"] = "Courier-Bold";
	  t["CourierNewPS-ItalicMT"] = "Courier-Oblique";
	  t.CourierNewPSMT = "Courier";
	  t["Helvetica-BoldItalic"] = "Helvetica-BoldOblique";
	  t["Helvetica-Italic"] = "Helvetica-Oblique";
	  t["Symbol-Bold"] = "Symbol";
	  t["Symbol-BoldItalic"] = "Symbol";
	  t["Symbol-Italic"] = "Symbol";
	  t.TimesNewRoman = "Times-Roman";
	  t["TimesNewRoman-Bold"] = "Times-Bold";
	  t["TimesNewRoman-BoldItalic"] = "Times-BoldItalic";
	  t["TimesNewRoman-Italic"] = "Times-Italic";
	  t.TimesNewRomanPS = "Times-Roman";
	  t["TimesNewRomanPS-Bold"] = "Times-Bold";
	  t["TimesNewRomanPS-BoldItalic"] = "Times-BoldItalic";
	  t["TimesNewRomanPS-BoldItalicMT"] = "Times-BoldItalic";
	  t["TimesNewRomanPS-BoldMT"] = "Times-Bold";
	  t["TimesNewRomanPS-Italic"] = "Times-Italic";
	  t["TimesNewRomanPS-ItalicMT"] = "Times-Italic";
	  t.TimesNewRomanPSMT = "Times-Roman";
	  t["TimesNewRomanPSMT-Bold"] = "Times-Bold";
	  t["TimesNewRomanPSMT-BoldItalic"] = "Times-BoldItalic";
	  t["TimesNewRomanPSMT-Italic"] = "Times-Italic";
	});
	exports.getStdFontMap = getStdFontMap;
	const getFontNameToFileMap = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t.Courier = "FoxitFixed.pfb";
	  t["Courier-Bold"] = "FoxitFixedBold.pfb";
	  t["Courier-BoldOblique"] = "FoxitFixedBoldItalic.pfb";
	  t["Courier-Oblique"] = "FoxitFixedItalic.pfb";
	  t.Helvetica = "FoxitSans.pfb";
	  t["Helvetica-Bold"] = "FoxitSansBold.pfb";
	  t["Helvetica-BoldOblique"] = "FoxitSansBoldItalic.pfb";
	  t["Helvetica-Oblique"] = "FoxitSansItalic.pfb";
	  t["Times-Roman"] = "FoxitSerif.pfb";
	  t["Times-Bold"] = "FoxitSerifBold.pfb";
	  t["Times-BoldItalic"] = "FoxitSerifBoldItalic.pfb";
	  t["Times-Italic"] = "FoxitSerifItalic.pfb";
	  t.Symbol = "FoxitSymbol.pfb";
	  t.ZapfDingbats = "FoxitDingbats.pfb";
	  t["LiberationSans-Regular"] = "LiberationSans-Regular.ttf";
	  t["LiberationSans-Bold"] = "LiberationSans-Bold.ttf";
	  t["LiberationSans-Italic"] = "LiberationSans-Italic.ttf";
	  t["LiberationSans-BoldItalic"] = "LiberationSans-BoldItalic.ttf";
	});
	exports.getFontNameToFileMap = getFontNameToFileMap;
	const getNonStdFontMap = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t.Calibri = "Helvetica";
	  t["Calibri-Bold"] = "Helvetica-Bold";
	  t["Calibri-BoldItalic"] = "Helvetica-BoldOblique";
	  t["Calibri-Italic"] = "Helvetica-Oblique";
	  t.CenturyGothic = "Helvetica";
	  t["CenturyGothic-Bold"] = "Helvetica-Bold";
	  t["CenturyGothic-BoldItalic"] = "Helvetica-BoldOblique";
	  t["CenturyGothic-Italic"] = "Helvetica-Oblique";
	  t.ComicSansMS = "Comic Sans MS";
	  t["ComicSansMS-Bold"] = "Comic Sans MS-Bold";
	  t["ComicSansMS-BoldItalic"] = "Comic Sans MS-BoldItalic";
	  t["ComicSansMS-Italic"] = "Comic Sans MS-Italic";
	  t["ItcSymbol-Bold"] = "Helvetica-Bold";
	  t["ItcSymbol-BoldItalic"] = "Helvetica-BoldOblique";
	  t["ItcSymbol-Book"] = "Helvetica";
	  t["ItcSymbol-BookItalic"] = "Helvetica-Oblique";
	  t["ItcSymbol-Medium"] = "Helvetica";
	  t["ItcSymbol-MediumItalic"] = "Helvetica-Oblique";
	  t.LucidaConsole = "Courier";
	  t["LucidaConsole-Bold"] = "Courier-Bold";
	  t["LucidaConsole-BoldItalic"] = "Courier-BoldOblique";
	  t["LucidaConsole-Italic"] = "Courier-Oblique";
	  t["LucidaSans-Demi"] = "Helvetica-Bold";
	  t["MS-Gothic"] = "MS Gothic";
	  t["MS-Gothic-Bold"] = "MS Gothic-Bold";
	  t["MS-Gothic-BoldItalic"] = "MS Gothic-BoldItalic";
	  t["MS-Gothic-Italic"] = "MS Gothic-Italic";
	  t["MS-Mincho"] = "MS Mincho";
	  t["MS-Mincho-Bold"] = "MS Mincho-Bold";
	  t["MS-Mincho-BoldItalic"] = "MS Mincho-BoldItalic";
	  t["MS-Mincho-Italic"] = "MS Mincho-Italic";
	  t["MS-PGothic"] = "MS PGothic";
	  t["MS-PGothic-Bold"] = "MS PGothic-Bold";
	  t["MS-PGothic-BoldItalic"] = "MS PGothic-BoldItalic";
	  t["MS-PGothic-Italic"] = "MS PGothic-Italic";
	  t["MS-PMincho"] = "MS PMincho";
	  t["MS-PMincho-Bold"] = "MS PMincho-Bold";
	  t["MS-PMincho-BoldItalic"] = "MS PMincho-BoldItalic";
	  t["MS-PMincho-Italic"] = "MS PMincho-Italic";
	  t.NuptialScript = "Times-Italic";
	  t.SegoeUISymbol = "Helvetica";
	  t.Wingdings = "ZapfDingbats";
	  t["Wingdings-Regular"] = "ZapfDingbats";
	});
	exports.getNonStdFontMap = getNonStdFontMap;
	const getSerifFonts = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t["Adobe Jenson"] = true;
	  t["Adobe Text"] = true;
	  t.Albertus = true;
	  t.Aldus = true;
	  t.Alexandria = true;
	  t.Algerian = true;
	  t["American Typewriter"] = true;
	  t.Antiqua = true;
	  t.Apex = true;
	  t.Arno = true;
	  t.Aster = true;
	  t.Aurora = true;
	  t.Baskerville = true;
	  t.Bell = true;
	  t.Bembo = true;
	  t["Bembo Schoolbook"] = true;
	  t.Benguiat = true;
	  t["Berkeley Old Style"] = true;
	  t["Bernhard Modern"] = true;
	  t["Berthold City"] = true;
	  t.Bodoni = true;
	  t["Bauer Bodoni"] = true;
	  t["Book Antiqua"] = true;
	  t.Bookman = true;
	  t["Bordeaux Roman"] = true;
	  t["Californian FB"] = true;
	  t.Calisto = true;
	  t.Calvert = true;
	  t.Capitals = true;
	  t.Cambria = true;
	  t.Cartier = true;
	  t.Caslon = true;
	  t.Catull = true;
	  t.Centaur = true;
	  t["Century Old Style"] = true;
	  t["Century Schoolbook"] = true;
	  t.Chaparral = true;
	  t["Charis SIL"] = true;
	  t.Cheltenham = true;
	  t["Cholla Slab"] = true;
	  t.Clarendon = true;
	  t.Clearface = true;
	  t.Cochin = true;
	  t.Colonna = true;
	  t["Computer Modern"] = true;
	  t["Concrete Roman"] = true;
	  t.Constantia = true;
	  t["Cooper Black"] = true;
	  t.Corona = true;
	  t.Ecotype = true;
	  t.Egyptienne = true;
	  t.Elephant = true;
	  t.Excelsior = true;
	  t.Fairfield = true;
	  t["FF Scala"] = true;
	  t.Folkard = true;
	  t.Footlight = true;
	  t.FreeSerif = true;
	  t["Friz Quadrata"] = true;
	  t.Garamond = true;
	  t.Gentium = true;
	  t.Georgia = true;
	  t.Gloucester = true;
	  t["Goudy Old Style"] = true;
	  t["Goudy Schoolbook"] = true;
	  t["Goudy Pro Font"] = true;
	  t.Granjon = true;
	  t["Guardian Egyptian"] = true;
	  t.Heather = true;
	  t.Hercules = true;
	  t["High Tower Text"] = true;
	  t.Hiroshige = true;
	  t["Hoefler Text"] = true;
	  t["Humana Serif"] = true;
	  t.Imprint = true;
	  t["Ionic No. 5"] = true;
	  t.Janson = true;
	  t.Joanna = true;
	  t.Korinna = true;
	  t.Lexicon = true;
	  t.LiberationSerif = true;
	  t["Liberation Serif"] = true;
	  t["Linux Libertine"] = true;
	  t.Literaturnaya = true;
	  t.Lucida = true;
	  t["Lucida Bright"] = true;
	  t.Melior = true;
	  t.Memphis = true;
	  t.Miller = true;
	  t.Minion = true;
	  t.Modern = true;
	  t["Mona Lisa"] = true;
	  t["Mrs Eaves"] = true;
	  t["MS Serif"] = true;
	  t["Museo Slab"] = true;
	  t["New York"] = true;
	  t["Nimbus Roman"] = true;
	  t["NPS Rawlinson Roadway"] = true;
	  t.NuptialScript = true;
	  t.Palatino = true;
	  t.Perpetua = true;
	  t.Plantin = true;
	  t["Plantin Schoolbook"] = true;
	  t.Playbill = true;
	  t["Poor Richard"] = true;
	  t["Rawlinson Roadway"] = true;
	  t.Renault = true;
	  t.Requiem = true;
	  t.Rockwell = true;
	  t.Roman = true;
	  t["Rotis Serif"] = true;
	  t.Sabon = true;
	  t.Scala = true;
	  t.Seagull = true;
	  t.Sistina = true;
	  t.Souvenir = true;
	  t.STIX = true;
	  t["Stone Informal"] = true;
	  t["Stone Serif"] = true;
	  t.Sylfaen = true;
	  t.Times = true;
	  t.Trajan = true;
	  t["Trinité"] = true;
	  t["Trump Mediaeval"] = true;
	  t.Utopia = true;
	  t["Vale Type"] = true;
	  t["Bitstream Vera"] = true;
	  t["Vera Serif"] = true;
	  t.Versailles = true;
	  t.Wanted = true;
	  t.Weiss = true;
	  t["Wide Latin"] = true;
	  t.Windsor = true;
	  t.XITS = true;
	});
	exports.getSerifFonts = getSerifFonts;
	const getSymbolsFonts = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t.Dingbats = true;
	  t.Symbol = true;
	  t.ZapfDingbats = true;
	});
	exports.getSymbolsFonts = getSymbolsFonts;
	const getGlyphMapForStandardFonts = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t[2] = 10;
	  t[3] = 32;
	  t[4] = 33;
	  t[5] = 34;
	  t[6] = 35;
	  t[7] = 36;
	  t[8] = 37;
	  t[9] = 38;
	  t[10] = 39;
	  t[11] = 40;
	  t[12] = 41;
	  t[13] = 42;
	  t[14] = 43;
	  t[15] = 44;
	  t[16] = 45;
	  t[17] = 46;
	  t[18] = 47;
	  t[19] = 48;
	  t[20] = 49;
	  t[21] = 50;
	  t[22] = 51;
	  t[23] = 52;
	  t[24] = 53;
	  t[25] = 54;
	  t[26] = 55;
	  t[27] = 56;
	  t[28] = 57;
	  t[29] = 58;
	  t[30] = 894;
	  t[31] = 60;
	  t[32] = 61;
	  t[33] = 62;
	  t[34] = 63;
	  t[35] = 64;
	  t[36] = 65;
	  t[37] = 66;
	  t[38] = 67;
	  t[39] = 68;
	  t[40] = 69;
	  t[41] = 70;
	  t[42] = 71;
	  t[43] = 72;
	  t[44] = 73;
	  t[45] = 74;
	  t[46] = 75;
	  t[47] = 76;
	  t[48] = 77;
	  t[49] = 78;
	  t[50] = 79;
	  t[51] = 80;
	  t[52] = 81;
	  t[53] = 82;
	  t[54] = 83;
	  t[55] = 84;
	  t[56] = 85;
	  t[57] = 86;
	  t[58] = 87;
	  t[59] = 88;
	  t[60] = 89;
	  t[61] = 90;
	  t[62] = 91;
	  t[63] = 92;
	  t[64] = 93;
	  t[65] = 94;
	  t[66] = 95;
	  t[67] = 96;
	  t[68] = 97;
	  t[69] = 98;
	  t[70] = 99;
	  t[71] = 100;
	  t[72] = 101;
	  t[73] = 102;
	  t[74] = 103;
	  t[75] = 104;
	  t[76] = 105;
	  t[77] = 106;
	  t[78] = 107;
	  t[79] = 108;
	  t[80] = 109;
	  t[81] = 110;
	  t[82] = 111;
	  t[83] = 112;
	  t[84] = 113;
	  t[85] = 114;
	  t[86] = 115;
	  t[87] = 116;
	  t[88] = 117;
	  t[89] = 118;
	  t[90] = 119;
	  t[91] = 120;
	  t[92] = 121;
	  t[93] = 122;
	  t[94] = 123;
	  t[95] = 124;
	  t[96] = 125;
	  t[97] = 126;
	  t[98] = 196;
	  t[99] = 197;
	  t[100] = 199;
	  t[101] = 201;
	  t[102] = 209;
	  t[103] = 214;
	  t[104] = 220;
	  t[105] = 225;
	  t[106] = 224;
	  t[107] = 226;
	  t[108] = 228;
	  t[109] = 227;
	  t[110] = 229;
	  t[111] = 231;
	  t[112] = 233;
	  t[113] = 232;
	  t[114] = 234;
	  t[115] = 235;
	  t[116] = 237;
	  t[117] = 236;
	  t[118] = 238;
	  t[119] = 239;
	  t[120] = 241;
	  t[121] = 243;
	  t[122] = 242;
	  t[123] = 244;
	  t[124] = 246;
	  t[125] = 245;
	  t[126] = 250;
	  t[127] = 249;
	  t[128] = 251;
	  t[129] = 252;
	  t[130] = 8224;
	  t[131] = 176;
	  t[132] = 162;
	  t[133] = 163;
	  t[134] = 167;
	  t[135] = 8226;
	  t[136] = 182;
	  t[137] = 223;
	  t[138] = 174;
	  t[139] = 169;
	  t[140] = 8482;
	  t[141] = 180;
	  t[142] = 168;
	  t[143] = 8800;
	  t[144] = 198;
	  t[145] = 216;
	  t[146] = 8734;
	  t[147] = 177;
	  t[148] = 8804;
	  t[149] = 8805;
	  t[150] = 165;
	  t[151] = 181;
	  t[152] = 8706;
	  t[153] = 8721;
	  t[154] = 8719;
	  t[156] = 8747;
	  t[157] = 170;
	  t[158] = 186;
	  t[159] = 8486;
	  t[160] = 230;
	  t[161] = 248;
	  t[162] = 191;
	  t[163] = 161;
	  t[164] = 172;
	  t[165] = 8730;
	  t[166] = 402;
	  t[167] = 8776;
	  t[168] = 8710;
	  t[169] = 171;
	  t[170] = 187;
	  t[171] = 8230;
	  t[200] = 193;
	  t[203] = 205;
	  t[210] = 218;
	  t[223] = 711;
	  t[224] = 321;
	  t[225] = 322;
	  t[226] = 352;
	  t[227] = 353;
	  t[228] = 381;
	  t[229] = 382;
	  t[233] = 221;
	  t[234] = 253;
	  t[252] = 263;
	  t[253] = 268;
	  t[254] = 269;
	  t[258] = 258;
	  t[260] = 260;
	  t[261] = 261;
	  t[265] = 280;
	  t[266] = 281;
	  t[267] = 282;
	  t[268] = 283;
	  t[269] = 313;
	  t[275] = 323;
	  t[276] = 324;
	  t[278] = 328;
	  t[283] = 344;
	  t[284] = 345;
	  t[285] = 346;
	  t[286] = 347;
	  t[292] = 367;
	  t[295] = 377;
	  t[296] = 378;
	  t[298] = 380;
	  t[305] = 963;
	  t[306] = 964;
	  t[307] = 966;
	  t[308] = 8215;
	  t[309] = 8252;
	  t[310] = 8319;
	  t[311] = 8359;
	  t[312] = 8592;
	  t[313] = 8593;
	  t[337] = 9552;
	  t[493] = 1039;
	  t[494] = 1040;
	  t[672] = 1488;
	  t[673] = 1489;
	  t[674] = 1490;
	  t[675] = 1491;
	  t[676] = 1492;
	  t[677] = 1493;
	  t[678] = 1494;
	  t[679] = 1495;
	  t[680] = 1496;
	  t[681] = 1497;
	  t[682] = 1498;
	  t[683] = 1499;
	  t[684] = 1500;
	  t[685] = 1501;
	  t[686] = 1502;
	  t[687] = 1503;
	  t[688] = 1504;
	  t[689] = 1505;
	  t[690] = 1506;
	  t[691] = 1507;
	  t[692] = 1508;
	  t[693] = 1509;
	  t[694] = 1510;
	  t[695] = 1511;
	  t[696] = 1512;
	  t[697] = 1513;
	  t[698] = 1514;
	  t[705] = 1524;
	  t[706] = 8362;
	  t[710] = 64288;
	  t[711] = 64298;
	  t[759] = 1617;
	  t[761] = 1776;
	  t[763] = 1778;
	  t[775] = 1652;
	  t[777] = 1764;
	  t[778] = 1780;
	  t[779] = 1781;
	  t[780] = 1782;
	  t[782] = 771;
	  t[783] = 64726;
	  t[786] = 8363;
	  t[788] = 8532;
	  t[790] = 768;
	  t[791] = 769;
	  t[792] = 768;
	  t[795] = 803;
	  t[797] = 64336;
	  t[798] = 64337;
	  t[799] = 64342;
	  t[800] = 64343;
	  t[801] = 64344;
	  t[802] = 64345;
	  t[803] = 64362;
	  t[804] = 64363;
	  t[805] = 64364;
	  t[2424] = 7821;
	  t[2425] = 7822;
	  t[2426] = 7823;
	  t[2427] = 7824;
	  t[2428] = 7825;
	  t[2429] = 7826;
	  t[2430] = 7827;
	  t[2433] = 7682;
	  t[2678] = 8045;
	  t[2679] = 8046;
	  t[2830] = 1552;
	  t[2838] = 686;
	  t[2840] = 751;
	  t[2842] = 753;
	  t[2843] = 754;
	  t[2844] = 755;
	  t[2846] = 757;
	  t[2856] = 767;
	  t[2857] = 848;
	  t[2858] = 849;
	  t[2862] = 853;
	  t[2863] = 854;
	  t[2864] = 855;
	  t[2865] = 861;
	  t[2866] = 862;
	  t[2906] = 7460;
	  t[2908] = 7462;
	  t[2909] = 7463;
	  t[2910] = 7464;
	  t[2912] = 7466;
	  t[2913] = 7467;
	  t[2914] = 7468;
	  t[2916] = 7470;
	  t[2917] = 7471;
	  t[2918] = 7472;
	  t[2920] = 7474;
	  t[2921] = 7475;
	  t[2922] = 7476;
	  t[2924] = 7478;
	  t[2925] = 7479;
	  t[2926] = 7480;
	  t[2928] = 7482;
	  t[2929] = 7483;
	  t[2930] = 7484;
	  t[2932] = 7486;
	  t[2933] = 7487;
	  t[2934] = 7488;
	  t[2936] = 7490;
	  t[2937] = 7491;
	  t[2938] = 7492;
	  t[2940] = 7494;
	  t[2941] = 7495;
	  t[2942] = 7496;
	  t[2944] = 7498;
	  t[2946] = 7500;
	  t[2948] = 7502;
	  t[2950] = 7504;
	  t[2951] = 7505;
	  t[2952] = 7506;
	  t[2954] = 7508;
	  t[2955] = 7509;
	  t[2956] = 7510;
	  t[2958] = 7512;
	  t[2959] = 7513;
	  t[2960] = 7514;
	  t[2962] = 7516;
	  t[2963] = 7517;
	  t[2964] = 7518;
	  t[2966] = 7520;
	  t[2967] = 7521;
	  t[2968] = 7522;
	  t[2970] = 7524;
	  t[2971] = 7525;
	  t[2972] = 7526;
	  t[2974] = 7528;
	  t[2975] = 7529;
	  t[2976] = 7530;
	  t[2978] = 1537;
	  t[2979] = 1538;
	  t[2980] = 1539;
	  t[2982] = 1549;
	  t[2983] = 1551;
	  t[2984] = 1552;
	  t[2986] = 1554;
	  t[2987] = 1555;
	  t[2988] = 1556;
	  t[2990] = 1623;
	  t[2991] = 1624;
	  t[2995] = 1775;
	  t[2999] = 1791;
	  t[3002] = 64290;
	  t[3003] = 64291;
	  t[3004] = 64292;
	  t[3006] = 64294;
	  t[3007] = 64295;
	  t[3008] = 64296;
	  t[3011] = 1900;
	  t[3014] = 8223;
	  t[3015] = 8244;
	  t[3017] = 7532;
	  t[3018] = 7533;
	  t[3019] = 7534;
	  t[3075] = 7590;
	  t[3076] = 7591;
	  t[3079] = 7594;
	  t[3080] = 7595;
	  t[3083] = 7598;
	  t[3084] = 7599;
	  t[3087] = 7602;
	  t[3088] = 7603;
	  t[3091] = 7606;
	  t[3092] = 7607;
	  t[3095] = 7610;
	  t[3096] = 7611;
	  t[3099] = 7614;
	  t[3100] = 7615;
	  t[3103] = 7618;
	  t[3104] = 7619;
	  t[3107] = 8337;
	  t[3108] = 8338;
	  t[3116] = 1884;
	  t[3119] = 1885;
	  t[3120] = 1885;
	  t[3123] = 1886;
	  t[3124] = 1886;
	  t[3127] = 1887;
	  t[3128] = 1887;
	  t[3131] = 1888;
	  t[3132] = 1888;
	  t[3135] = 1889;
	  t[3136] = 1889;
	  t[3139] = 1890;
	  t[3140] = 1890;
	  t[3143] = 1891;
	  t[3144] = 1891;
	  t[3147] = 1892;
	  t[3148] = 1892;
	  t[3153] = 580;
	  t[3154] = 581;
	  t[3157] = 584;
	  t[3158] = 585;
	  t[3161] = 588;
	  t[3162] = 589;
	  t[3165] = 891;
	  t[3166] = 892;
	  t[3169] = 1274;
	  t[3170] = 1275;
	  t[3173] = 1278;
	  t[3174] = 1279;
	  t[3181] = 7622;
	  t[3182] = 7623;
	  t[3282] = 11799;
	  t[3316] = 578;
	  t[3379] = 42785;
	  t[3393] = 1159;
	  t[3416] = 8377;
	});
	exports.getGlyphMapForStandardFonts = getGlyphMapForStandardFonts;
	const getSupplementalGlyphMapForArialBlack = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t[227] = 322;
	  t[264] = 261;
	  t[291] = 346;
	});
	exports.getSupplementalGlyphMapForArialBlack = getSupplementalGlyphMapForArialBlack;
	const getSupplementalGlyphMapForCalibri = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t[1] = 32;
	  t[4] = 65;
	  t[6] = 193;
	  t[17] = 66;
	  t[18] = 67;
	  t[21] = 268;
	  t[24] = 68;
	  t[28] = 69;
	  t[30] = 201;
	  t[32] = 282;
	  t[38] = 70;
	  t[39] = 71;
	  t[44] = 72;
	  t[47] = 73;
	  t[49] = 205;
	  t[58] = 74;
	  t[60] = 75;
	  t[62] = 76;
	  t[68] = 77;
	  t[69] = 78;
	  t[75] = 79;
	  t[87] = 80;
	  t[89] = 81;
	  t[90] = 82;
	  t[92] = 344;
	  t[94] = 83;
	  t[97] = 352;
	  t[100] = 84;
	  t[104] = 85;
	  t[115] = 86;
	  t[116] = 87;
	  t[121] = 88;
	  t[122] = 89;
	  t[124] = 221;
	  t[127] = 90;
	  t[129] = 381;
	  t[258] = 97;
	  t[260] = 225;
	  t[268] = 261;
	  t[271] = 98;
	  t[272] = 99;
	  t[273] = 263;
	  t[275] = 269;
	  t[282] = 100;
	  t[286] = 101;
	  t[288] = 233;
	  t[290] = 283;
	  t[295] = 281;
	  t[296] = 102;
	  t[336] = 103;
	  t[346] = 104;
	  t[349] = 105;
	  t[351] = 237;
	  t[361] = 106;
	  t[364] = 107;
	  t[367] = 108;
	  t[371] = 322;
	  t[373] = 109;
	  t[374] = 110;
	  t[381] = 111;
	  t[383] = 243;
	  t[393] = 112;
	  t[395] = 113;
	  t[396] = 114;
	  t[398] = 345;
	  t[400] = 115;
	  t[401] = 347;
	  t[403] = 353;
	  t[410] = 116;
	  t[437] = 117;
	  t[448] = 118;
	  t[449] = 119;
	  t[454] = 120;
	  t[455] = 121;
	  t[457] = 253;
	  t[460] = 122;
	  t[462] = 382;
	  t[463] = 380;
	  t[853] = 44;
	  t[855] = 58;
	  t[856] = 46;
	  t[876] = 47;
	  t[878] = 45;
	  t[882] = 45;
	  t[894] = 40;
	  t[895] = 41;
	  t[896] = 91;
	  t[897] = 93;
	  t[923] = 64;
	  t[1004] = 48;
	  t[1005] = 49;
	  t[1006] = 50;
	  t[1007] = 51;
	  t[1008] = 52;
	  t[1009] = 53;
	  t[1010] = 54;
	  t[1011] = 55;
	  t[1012] = 56;
	  t[1013] = 57;
	  t[1081] = 37;
	  t[1085] = 43;
	  t[1086] = 45;
	});
	exports.getSupplementalGlyphMapForCalibri = getSupplementalGlyphMapForCalibri;

	function getStandardFontName(name) {
	  const fontName = (0, _fonts_utils.normalizeFontName)(name);
	  const stdFontMap = getStdFontMap();
	  return stdFontMap[fontName];
	}

	/***/ }),
	/* 42 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ToUnicodeMap = exports.IdentityToUnicodeMap = void 0;

	var _util = __w_pdfjs_require__(2);

	class ToUnicodeMap {
	  constructor(cmap = []) {
	    this._map = cmap;
	  }

	  get length() {
	    return this._map.length;
	  }

	  forEach(callback) {
	    for (const charCode in this._map) {
	      callback(charCode, this._map[charCode].charCodeAt(0));
	    }
	  }

	  has(i) {
	    return this._map[i] !== undefined;
	  }

	  get(i) {
	    return this._map[i];
	  }

	  charCodeOf(value) {
	    const map = this._map;

	    if (map.length <= 0x10000) {
	      return map.indexOf(value);
	    }

	    for (const charCode in map) {
	      if (map[charCode] === value) {
	        return charCode | 0;
	      }
	    }

	    return -1;
	  }

	  amend(map) {
	    for (const charCode in map) {
	      this._map[charCode] = map[charCode];
	    }
	  }

	}

	exports.ToUnicodeMap = ToUnicodeMap;

	class IdentityToUnicodeMap {
	  constructor(firstChar, lastChar) {
	    this.firstChar = firstChar;
	    this.lastChar = lastChar;
	  }

	  get length() {
	    return this.lastChar + 1 - this.firstChar;
	  }

	  forEach(callback) {
	    for (let i = this.firstChar, ii = this.lastChar; i <= ii; i++) {
	      callback(i, i);
	    }
	  }

	  has(i) {
	    return this.firstChar <= i && i <= this.lastChar;
	  }

	  get(i) {
	    if (this.firstChar <= i && i <= this.lastChar) {
	      return String.fromCharCode(i);
	    }

	    return undefined;
	  }

	  charCodeOf(v) {
	    return Number.isInteger(v) && v >= this.firstChar && v <= this.lastChar ? v : -1;
	  }

	  amend(map) {
	    (0, _util.unreachable)("Should not call amend()");
	  }

	}

	exports.IdentityToUnicodeMap = IdentityToUnicodeMap;

	/***/ }),
	/* 43 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.CFFFont = void 0;

	var _cff_parser = __w_pdfjs_require__(35);

	var _fonts_utils = __w_pdfjs_require__(38);

	var _util = __w_pdfjs_require__(2);

	class CFFFont {
	  constructor(file, properties) {
	    this.properties = properties;
	    const parser = new _cff_parser.CFFParser(file, properties, _fonts_utils.SEAC_ANALYSIS_ENABLED);
	    this.cff = parser.parse();
	    this.cff.duplicateFirstGlyph();
	    const compiler = new _cff_parser.CFFCompiler(this.cff);
	    this.seacs = this.cff.seacs;

	    try {
	      this.data = compiler.compile();
	    } catch (e) {
	      (0, _util.warn)("Failed to compile font " + properties.loadedName);
	      this.data = file;
	    }

	    this._createBuiltInEncoding();
	  }

	  get numGlyphs() {
	    return this.cff.charStrings.count;
	  }

	  getCharset() {
	    return this.cff.charset.charset;
	  }

	  getGlyphMapping() {
	    const cff = this.cff;
	    const properties = this.properties;
	    const charsets = cff.charset.charset;
	    let charCodeToGlyphId;
	    let glyphId;

	    if (properties.composite) {
	      charCodeToGlyphId = Object.create(null);
	      let charCode;

	      if (cff.isCIDFont) {
	        for (glyphId = 0; glyphId < charsets.length; glyphId++) {
	          const cid = charsets[glyphId];
	          charCode = properties.cMap.charCodeOf(cid);
	          charCodeToGlyphId[charCode] = glyphId;
	        }
	      } else {
	        for (glyphId = 0; glyphId < cff.charStrings.count; glyphId++) {
	          charCode = properties.cMap.charCodeOf(glyphId);
	          charCodeToGlyphId[charCode] = glyphId;
	        }
	      }

	      return charCodeToGlyphId;
	    }

	    let encoding = cff.encoding ? cff.encoding.encoding : null;

	    if (properties.isInternalFont) {
	      encoding = properties.defaultEncoding;
	    }

	    charCodeToGlyphId = (0, _fonts_utils.type1FontGlyphMapping)(properties, encoding, charsets);
	    return charCodeToGlyphId;
	  }

	  hasGlyphId(id) {
	    return this.cff.hasGlyphId(id);
	  }

	  _createBuiltInEncoding() {
	    const {
	      charset,
	      encoding
	    } = this.cff;

	    if (!charset || !encoding) {
	      return;
	    }

	    const charsets = charset.charset,
	          encodings = encoding.encoding;
	    const map = [];

	    for (const charCode in encodings) {
	      const glyphId = encodings[charCode];

	      if (glyphId >= 0) {
	        const glyphName = charsets[glyphId];

	        if (glyphName) {
	          map[charCode] = glyphName;
	        }
	      }
	    }

	    if (map.length > 0) {
	      this.properties.builtInEncoding = map;
	    }
	  }

	}

	exports.CFFFont = CFFFont;

	/***/ }),
	/* 44 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.FontRendererFactory = void 0;

	var _util = __w_pdfjs_require__(2);

	var _cff_parser = __w_pdfjs_require__(35);

	var _glyphlist = __w_pdfjs_require__(39);

	var _encodings = __w_pdfjs_require__(37);

	var _stream = __w_pdfjs_require__(10);

	function getUint32(data, offset) {
	  return (data[offset] << 24 | data[offset + 1] << 16 | data[offset + 2] << 8 | data[offset + 3]) >>> 0;
	}

	function getUint16(data, offset) {
	  return data[offset] << 8 | data[offset + 1];
	}

	function getInt16(data, offset) {
	  return (data[offset] << 24 | data[offset + 1] << 16) >> 16;
	}

	function getInt8(data, offset) {
	  return data[offset] << 24 >> 24;
	}

	function getFloat214(data, offset) {
	  return getInt16(data, offset) / 16384;
	}

	function getSubroutineBias(subrs) {
	  const numSubrs = subrs.length;
	  let bias = 32768;

	  if (numSubrs < 1240) {
	    bias = 107;
	  } else if (numSubrs < 33900) {
	    bias = 1131;
	  }

	  return bias;
	}

	function parseCmap(data, start, end) {
	  const offset = getUint16(data, start + 2) === 1 ? getUint32(data, start + 8) : getUint32(data, start + 16);
	  const format = getUint16(data, start + offset);
	  let ranges, p, i;

	  if (format === 4) {
	    getUint16(data, start + offset + 2);
	    const segCount = getUint16(data, start + offset + 6) >> 1;
	    p = start + offset + 14;
	    ranges = [];

	    for (i = 0; i < segCount; i++, p += 2) {
	      ranges[i] = {
	        end: getUint16(data, p)
	      };
	    }

	    p += 2;

	    for (i = 0; i < segCount; i++, p += 2) {
	      ranges[i].start = getUint16(data, p);
	    }

	    for (i = 0; i < segCount; i++, p += 2) {
	      ranges[i].idDelta = getUint16(data, p);
	    }

	    for (i = 0; i < segCount; i++, p += 2) {
	      let idOffset = getUint16(data, p);

	      if (idOffset === 0) {
	        continue;
	      }

	      ranges[i].ids = [];

	      for (let j = 0, jj = ranges[i].end - ranges[i].start + 1; j < jj; j++) {
	        ranges[i].ids[j] = getUint16(data, p + idOffset);
	        idOffset += 2;
	      }
	    }

	    return ranges;
	  } else if (format === 12) {
	    const groups = getUint32(data, start + offset + 12);
	    p = start + offset + 16;
	    ranges = [];

	    for (i = 0; i < groups; i++) {
	      start = getUint32(data, p);
	      ranges.push({
	        start,
	        end: getUint32(data, p + 4),
	        idDelta: getUint32(data, p + 8) - start
	      });
	      p += 12;
	    }

	    return ranges;
	  }

	  throw new _util.FormatError(`unsupported cmap: ${format}`);
	}

	function parseCff(data, start, end, seacAnalysisEnabled) {
	  const properties = {};
	  const parser = new _cff_parser.CFFParser(new _stream.Stream(data, start, end - start), properties, seacAnalysisEnabled);
	  const cff = parser.parse();
	  return {
	    glyphs: cff.charStrings.objects,
	    subrs: cff.topDict.privateDict && cff.topDict.privateDict.subrsIndex && cff.topDict.privateDict.subrsIndex.objects,
	    gsubrs: cff.globalSubrIndex && cff.globalSubrIndex.objects,
	    isCFFCIDFont: cff.isCIDFont,
	    fdSelect: cff.fdSelect,
	    fdArray: cff.fdArray
	  };
	}

	function parseGlyfTable(glyf, loca, isGlyphLocationsLong) {
	  let itemSize, itemDecode;

	  if (isGlyphLocationsLong) {
	    itemSize = 4;
	    itemDecode = getUint32;
	  } else {
	    itemSize = 2;

	    itemDecode = (data, offset) => 2 * getUint16(data, offset);
	  }

	  const glyphs = [];
	  let startOffset = itemDecode(loca, 0);

	  for (let j = itemSize; j < loca.length; j += itemSize) {
	    const endOffset = itemDecode(loca, j);
	    glyphs.push(glyf.subarray(startOffset, endOffset));
	    startOffset = endOffset;
	  }

	  return glyphs;
	}

	function lookupCmap(ranges, unicode) {
	  const code = unicode.codePointAt(0);
	  let gid = 0,
	      l = 0,
	      r = ranges.length - 1;

	  while (l < r) {
	    const c = l + r + 1 >> 1;

	    if (code < ranges[c].start) {
	      r = c - 1;
	    } else {
	      l = c;
	    }
	  }

	  if (ranges[l].start <= code && code <= ranges[l].end) {
	    gid = ranges[l].idDelta + (ranges[l].ids ? ranges[l].ids[code - ranges[l].start] : code) & 0xffff;
	  }

	  return {
	    charCode: code,
	    glyphId: gid
	  };
	}

	function compileGlyf(code, cmds, font) {
	  function moveTo(x, y) {
	    cmds.push({
	      cmd: "moveTo",
	      args: [x, y]
	    });
	  }

	  function lineTo(x, y) {
	    cmds.push({
	      cmd: "lineTo",
	      args: [x, y]
	    });
	  }

	  function quadraticCurveTo(xa, ya, x, y) {
	    cmds.push({
	      cmd: "quadraticCurveTo",
	      args: [xa, ya, x, y]
	    });
	  }

	  let i = 0;
	  const numberOfContours = getInt16(code, i);
	  let flags;
	  let x = 0,
	      y = 0;
	  i += 10;

	  if (numberOfContours < 0) {
	    do {
	      flags = getUint16(code, i);
	      const glyphIndex = getUint16(code, i + 2);
	      i += 4;
	      let arg1, arg2;

	      if (flags & 0x01) {
	        if (flags & 0x02) {
	          arg1 = getInt16(code, i);
	          arg2 = getInt16(code, i + 2);
	        } else {
	          arg1 = getUint16(code, i);
	          arg2 = getUint16(code, i + 2);
	        }

	        i += 4;
	      } else {
	        if (flags & 0x02) {
	          arg1 = getInt8(code, i++);
	          arg2 = getInt8(code, i++);
	        } else {
	          arg1 = code[i++];
	          arg2 = code[i++];
	        }
	      }

	      if (flags & 0x02) {
	        x = arg1;
	        y = arg2;
	      } else {
	        x = 0;
	        y = 0;
	      }

	      let scaleX = 1,
	          scaleY = 1,
	          scale01 = 0,
	          scale10 = 0;

	      if (flags & 0x08) {
	        scaleX = scaleY = getFloat214(code, i);
	        i += 2;
	      } else if (flags & 0x40) {
	        scaleX = getFloat214(code, i);
	        scaleY = getFloat214(code, i + 2);
	        i += 4;
	      } else if (flags & 0x80) {
	        scaleX = getFloat214(code, i);
	        scale01 = getFloat214(code, i + 2);
	        scale10 = getFloat214(code, i + 4);
	        scaleY = getFloat214(code, i + 6);
	        i += 8;
	      }

	      const subglyph = font.glyphs[glyphIndex];

	      if (subglyph) {
	        cmds.push({
	          cmd: "save"
	        }, {
	          cmd: "transform",
	          args: [scaleX, scale01, scale10, scaleY, x, y]
	        });

	        compileGlyf(subglyph, cmds, font);
	        cmds.push({
	          cmd: "restore"
	        });
	      }
	    } while (flags & 0x20);
	  } else {
	    const endPtsOfContours = [];
	    let j, jj;

	    for (j = 0; j < numberOfContours; j++) {
	      endPtsOfContours.push(getUint16(code, i));
	      i += 2;
	    }

	    const instructionLength = getUint16(code, i);
	    i += 2 + instructionLength;
	    const numberOfPoints = endPtsOfContours.at(-1) + 1;
	    const points = [];

	    while (points.length < numberOfPoints) {
	      flags = code[i++];
	      let repeat = 1;

	      if (flags & 0x08) {
	        repeat += code[i++];
	      }

	      while (repeat-- > 0) {
	        points.push({
	          flags
	        });
	      }
	    }

	    for (j = 0; j < numberOfPoints; j++) {
	      switch (points[j].flags & 0x12) {
	        case 0x00:
	          x += getInt16(code, i);
	          i += 2;
	          break;

	        case 0x02:
	          x -= code[i++];
	          break;

	        case 0x12:
	          x += code[i++];
	          break;
	      }

	      points[j].x = x;
	    }

	    for (j = 0; j < numberOfPoints; j++) {
	      switch (points[j].flags & 0x24) {
	        case 0x00:
	          y += getInt16(code, i);
	          i += 2;
	          break;

	        case 0x04:
	          y -= code[i++];
	          break;

	        case 0x24:
	          y += code[i++];
	          break;
	      }

	      points[j].y = y;
	    }

	    let startPoint = 0;

	    for (i = 0; i < numberOfContours; i++) {
	      const endPoint = endPtsOfContours[i];
	      const contour = points.slice(startPoint, endPoint + 1);

	      if (contour[0].flags & 1) {
	        contour.push(contour[0]);
	      } else if (contour.at(-1).flags & 1) {
	        contour.unshift(contour.at(-1));
	      } else {
	        const p = {
	          flags: 1,
	          x: (contour[0].x + contour.at(-1).x) / 2,
	          y: (contour[0].y + contour.at(-1).y) / 2
	        };
	        contour.unshift(p);
	        contour.push(p);
	      }

	      moveTo(contour[0].x, contour[0].y);

	      for (j = 1, jj = contour.length; j < jj; j++) {
	        if (contour[j].flags & 1) {
	          lineTo(contour[j].x, contour[j].y);
	        } else if (contour[j + 1].flags & 1) {
	          quadraticCurveTo(contour[j].x, contour[j].y, contour[j + 1].x, contour[j + 1].y);
	          j++;
	        } else {
	          quadraticCurveTo(contour[j].x, contour[j].y, (contour[j].x + contour[j + 1].x) / 2, (contour[j].y + contour[j + 1].y) / 2);
	        }
	      }

	      startPoint = endPoint + 1;
	    }
	  }
	}

	function compileCharString(charStringCode, cmds, font, glyphId) {
	  function moveTo(x, y) {
	    cmds.push({
	      cmd: "moveTo",
	      args: [x, y]
	    });
	  }

	  function lineTo(x, y) {
	    cmds.push({
	      cmd: "lineTo",
	      args: [x, y]
	    });
	  }

	  function bezierCurveTo(x1, y1, x2, y2, x, y) {
	    cmds.push({
	      cmd: "bezierCurveTo",
	      args: [x1, y1, x2, y2, x, y]
	    });
	  }

	  const stack = [];
	  let x = 0,
	      y = 0;
	  let stems = 0;

	  function parse(code) {
	    let i = 0;

	    while (i < code.length) {
	      let stackClean = false;
	      let v = code[i++];
	      let xa, xb, ya, yb, y1, y2, y3, n, subrCode;

	      switch (v) {
	        case 1:
	          stems += stack.length >> 1;
	          stackClean = true;
	          break;

	        case 3:
	          stems += stack.length >> 1;
	          stackClean = true;
	          break;

	        case 4:
	          y += stack.pop();
	          moveTo(x, y);
	          stackClean = true;
	          break;

	        case 5:
	          while (stack.length > 0) {
	            x += stack.shift();
	            y += stack.shift();
	            lineTo(x, y);
	          }

	          break;

	        case 6:
	          while (stack.length > 0) {
	            x += stack.shift();
	            lineTo(x, y);

	            if (stack.length === 0) {
	              break;
	            }

	            y += stack.shift();
	            lineTo(x, y);
	          }

	          break;

	        case 7:
	          while (stack.length > 0) {
	            y += stack.shift();
	            lineTo(x, y);

	            if (stack.length === 0) {
	              break;
	            }

	            x += stack.shift();
	            lineTo(x, y);
	          }

	          break;

	        case 8:
	          while (stack.length > 0) {
	            xa = x + stack.shift();
	            ya = y + stack.shift();
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            x = xb + stack.shift();
	            y = yb + stack.shift();
	            bezierCurveTo(xa, ya, xb, yb, x, y);
	          }

	          break;

	        case 10:
	          n = stack.pop();
	          subrCode = null;

	          if (font.isCFFCIDFont) {
	            const fdIndex = font.fdSelect.getFDIndex(glyphId);

	            if (fdIndex >= 0 && fdIndex < font.fdArray.length) {
	              const fontDict = font.fdArray[fdIndex];
	              let subrs;

	              if (fontDict.privateDict && fontDict.privateDict.subrsIndex) {
	                subrs = fontDict.privateDict.subrsIndex.objects;
	              }

	              if (subrs) {
	                n += getSubroutineBias(subrs);
	                subrCode = subrs[n];
	              }
	            } else {
	              (0, _util.warn)("Invalid fd index for glyph index.");
	            }
	          } else {
	            subrCode = font.subrs[n + font.subrsBias];
	          }

	          if (subrCode) {
	            parse(subrCode);
	          }

	          break;

	        case 11:
	          return;

	        case 12:
	          v = code[i++];

	          switch (v) {
	            case 34:
	              xa = x + stack.shift();
	              xb = xa + stack.shift();
	              y1 = y + stack.shift();
	              x = xb + stack.shift();
	              bezierCurveTo(xa, y, xb, y1, x, y1);
	              xa = x + stack.shift();
	              xb = xa + stack.shift();
	              x = xb + stack.shift();
	              bezierCurveTo(xa, y1, xb, y, x, y);
	              break;

	            case 35:
	              xa = x + stack.shift();
	              ya = y + stack.shift();
	              xb = xa + stack.shift();
	              yb = ya + stack.shift();
	              x = xb + stack.shift();
	              y = yb + stack.shift();
	              bezierCurveTo(xa, ya, xb, yb, x, y);
	              xa = x + stack.shift();
	              ya = y + stack.shift();
	              xb = xa + stack.shift();
	              yb = ya + stack.shift();
	              x = xb + stack.shift();
	              y = yb + stack.shift();
	              bezierCurveTo(xa, ya, xb, yb, x, y);
	              stack.pop();
	              break;

	            case 36:
	              xa = x + stack.shift();
	              y1 = y + stack.shift();
	              xb = xa + stack.shift();
	              y2 = y1 + stack.shift();
	              x = xb + stack.shift();
	              bezierCurveTo(xa, y1, xb, y2, x, y2);
	              xa = x + stack.shift();
	              xb = xa + stack.shift();
	              y3 = y2 + stack.shift();
	              x = xb + stack.shift();
	              bezierCurveTo(xa, y2, xb, y3, x, y);
	              break;

	            case 37:
	              const x0 = x,
	                    y0 = y;
	              xa = x + stack.shift();
	              ya = y + stack.shift();
	              xb = xa + stack.shift();
	              yb = ya + stack.shift();
	              x = xb + stack.shift();
	              y = yb + stack.shift();
	              bezierCurveTo(xa, ya, xb, yb, x, y);
	              xa = x + stack.shift();
	              ya = y + stack.shift();
	              xb = xa + stack.shift();
	              yb = ya + stack.shift();
	              x = xb;
	              y = yb;

	              if (Math.abs(x - x0) > Math.abs(y - y0)) {
	                x += stack.shift();
	              } else {
	                y += stack.shift();
	              }

	              bezierCurveTo(xa, ya, xb, yb, x, y);
	              break;

	            default:
	              throw new _util.FormatError(`unknown operator: 12 ${v}`);
	          }

	          break;

	        case 14:
	          if (stack.length >= 4) {
	            const achar = stack.pop();
	            const bchar = stack.pop();
	            y = stack.pop();
	            x = stack.pop();
	            cmds.push({
	              cmd: "save"
	            }, {
	              cmd: "translate",
	              args: [x, y]
	            });
	            let cmap = lookupCmap(font.cmap, String.fromCharCode(font.glyphNameMap[_encodings.StandardEncoding[achar]]));
	            compileCharString(font.glyphs[cmap.glyphId], cmds, font, cmap.glyphId);
	            cmds.push({
	              cmd: "restore"
	            });
	            cmap = lookupCmap(font.cmap, String.fromCharCode(font.glyphNameMap[_encodings.StandardEncoding[bchar]]));
	            compileCharString(font.glyphs[cmap.glyphId], cmds, font, cmap.glyphId);
	          }

	          return;

	        case 18:
	          stems += stack.length >> 1;
	          stackClean = true;
	          break;

	        case 19:
	          stems += stack.length >> 1;
	          i += stems + 7 >> 3;
	          stackClean = true;
	          break;

	        case 20:
	          stems += stack.length >> 1;
	          i += stems + 7 >> 3;
	          stackClean = true;
	          break;

	        case 21:
	          y += stack.pop();
	          x += stack.pop();
	          moveTo(x, y);
	          stackClean = true;
	          break;

	        case 22:
	          x += stack.pop();
	          moveTo(x, y);
	          stackClean = true;
	          break;

	        case 23:
	          stems += stack.length >> 1;
	          stackClean = true;
	          break;

	        case 24:
	          while (stack.length > 2) {
	            xa = x + stack.shift();
	            ya = y + stack.shift();
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            x = xb + stack.shift();
	            y = yb + stack.shift();
	            bezierCurveTo(xa, ya, xb, yb, x, y);
	          }

	          x += stack.shift();
	          y += stack.shift();
	          lineTo(x, y);
	          break;

	        case 25:
	          while (stack.length > 6) {
	            x += stack.shift();
	            y += stack.shift();
	            lineTo(x, y);
	          }

	          xa = x + stack.shift();
	          ya = y + stack.shift();
	          xb = xa + stack.shift();
	          yb = ya + stack.shift();
	          x = xb + stack.shift();
	          y = yb + stack.shift();
	          bezierCurveTo(xa, ya, xb, yb, x, y);
	          break;

	        case 26:
	          if (stack.length % 2) {
	            x += stack.shift();
	          }

	          while (stack.length > 0) {
	            xa = x;
	            ya = y + stack.shift();
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            x = xb;
	            y = yb + stack.shift();
	            bezierCurveTo(xa, ya, xb, yb, x, y);
	          }

	          break;

	        case 27:
	          if (stack.length % 2) {
	            y += stack.shift();
	          }

	          while (stack.length > 0) {
	            xa = x + stack.shift();
	            ya = y;
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            x = xb + stack.shift();
	            y = yb;
	            bezierCurveTo(xa, ya, xb, yb, x, y);
	          }

	          break;

	        case 28:
	          stack.push((code[i] << 24 | code[i + 1] << 16) >> 16);
	          i += 2;
	          break;

	        case 29:
	          n = stack.pop() + font.gsubrsBias;
	          subrCode = font.gsubrs[n];

	          if (subrCode) {
	            parse(subrCode);
	          }

	          break;

	        case 30:
	          while (stack.length > 0) {
	            xa = x;
	            ya = y + stack.shift();
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            x = xb + stack.shift();
	            y = yb + (stack.length === 1 ? stack.shift() : 0);
	            bezierCurveTo(xa, ya, xb, yb, x, y);

	            if (stack.length === 0) {
	              break;
	            }

	            xa = x + stack.shift();
	            ya = y;
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            y = yb + stack.shift();
	            x = xb + (stack.length === 1 ? stack.shift() : 0);
	            bezierCurveTo(xa, ya, xb, yb, x, y);
	          }

	          break;

	        case 31:
	          while (stack.length > 0) {
	            xa = x + stack.shift();
	            ya = y;
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            y = yb + stack.shift();
	            x = xb + (stack.length === 1 ? stack.shift() : 0);
	            bezierCurveTo(xa, ya, xb, yb, x, y);

	            if (stack.length === 0) {
	              break;
	            }

	            xa = x;
	            ya = y + stack.shift();
	            xb = xa + stack.shift();
	            yb = ya + stack.shift();
	            x = xb + stack.shift();
	            y = yb + (stack.length === 1 ? stack.shift() : 0);
	            bezierCurveTo(xa, ya, xb, yb, x, y);
	          }

	          break;

	        default:
	          if (v < 32) {
	            throw new _util.FormatError(`unknown operator: ${v}`);
	          }

	          if (v < 247) {
	            stack.push(v - 139);
	          } else if (v < 251) {
	            stack.push((v - 247) * 256 + code[i++] + 108);
	          } else if (v < 255) {
	            stack.push(-(v - 251) * 256 - code[i++] - 108);
	          } else {
	            stack.push((code[i] << 24 | code[i + 1] << 16 | code[i + 2] << 8 | code[i + 3]) / 65536);
	            i += 4;
	          }

	          break;
	      }

	      if (stackClean) {
	        stack.length = 0;
	      }
	    }
	  }

	  parse(charStringCode);
	}

	const NOOP = [];

	class CompiledFont {
	  constructor(fontMatrix) {
	    if (this.constructor === CompiledFont) {
	      (0, _util.unreachable)("Cannot initialize CompiledFont.");
	    }

	    this.fontMatrix = fontMatrix;
	    this.compiledGlyphs = Object.create(null);
	    this.compiledCharCodeToGlyphId = Object.create(null);
	  }

	  getPathJs(unicode) {
	    const {
	      charCode,
	      glyphId
	    } = lookupCmap(this.cmap, unicode);
	    let fn = this.compiledGlyphs[glyphId];

	    if (!fn) {
	      try {
	        fn = this.compileGlyph(this.glyphs[glyphId], glyphId);
	        this.compiledGlyphs[glyphId] = fn;
	      } catch (ex) {
	        this.compiledGlyphs[glyphId] = NOOP;

	        if (this.compiledCharCodeToGlyphId[charCode] === undefined) {
	          this.compiledCharCodeToGlyphId[charCode] = glyphId;
	        }

	        throw ex;
	      }
	    }

	    if (this.compiledCharCodeToGlyphId[charCode] === undefined) {
	      this.compiledCharCodeToGlyphId[charCode] = glyphId;
	    }

	    return fn;
	  }

	  compileGlyph(code, glyphId) {
	    if (!code || code.length === 0 || code[0] === 14) {
	      return NOOP;
	    }

	    let fontMatrix = this.fontMatrix;

	    if (this.isCFFCIDFont) {
	      const fdIndex = this.fdSelect.getFDIndex(glyphId);

	      if (fdIndex >= 0 && fdIndex < this.fdArray.length) {
	        const fontDict = this.fdArray[fdIndex];
	        fontMatrix = fontDict.getByName("FontMatrix") || _util.FONT_IDENTITY_MATRIX;
	      } else {
	        (0, _util.warn)("Invalid fd index for glyph index.");
	      }
	    }

	    const cmds = [{
	      cmd: "save"
	    }, {
	      cmd: "transform",
	      args: fontMatrix.slice()
	    }, {
	      cmd: "scale",
	      args: ["size", "-size"]
	    }];
	    this.compileGlyphImpl(code, cmds, glyphId);
	    cmds.push({
	      cmd: "restore"
	    });
	    return cmds;
	  }

	  compileGlyphImpl() {
	    (0, _util.unreachable)("Children classes should implement this.");
	  }

	  hasBuiltPath(unicode) {
	    const {
	      charCode,
	      glyphId
	    } = lookupCmap(this.cmap, unicode);
	    return this.compiledGlyphs[glyphId] !== undefined && this.compiledCharCodeToGlyphId[charCode] !== undefined;
	  }

	}

	class TrueTypeCompiled extends CompiledFont {
	  constructor(glyphs, cmap, fontMatrix) {
	    super(fontMatrix || [0.000488, 0, 0, 0.000488, 0, 0]);
	    this.glyphs = glyphs;
	    this.cmap = cmap;
	  }

	  compileGlyphImpl(code, cmds) {
	    compileGlyf(code, cmds, this);
	  }

	}

	class Type2Compiled extends CompiledFont {
	  constructor(cffInfo, cmap, fontMatrix, glyphNameMap) {
	    super(fontMatrix || [0.001, 0, 0, 0.001, 0, 0]);
	    this.glyphs = cffInfo.glyphs;
	    this.gsubrs = cffInfo.gsubrs || [];
	    this.subrs = cffInfo.subrs || [];
	    this.cmap = cmap;
	    this.glyphNameMap = glyphNameMap || (0, _glyphlist.getGlyphsUnicode)();
	    this.gsubrsBias = getSubroutineBias(this.gsubrs);
	    this.subrsBias = getSubroutineBias(this.subrs);
	    this.isCFFCIDFont = cffInfo.isCFFCIDFont;
	    this.fdSelect = cffInfo.fdSelect;
	    this.fdArray = cffInfo.fdArray;
	  }

	  compileGlyphImpl(code, cmds, glyphId) {
	    compileCharString(code, cmds, this, glyphId);
	  }

	}

	class FontRendererFactory {
	  static create(font, seacAnalysisEnabled) {
	    const data = new Uint8Array(font.data);
	    let cmap, glyf, loca, cff, indexToLocFormat, unitsPerEm;
	    const numTables = getUint16(data, 4);

	    for (let i = 0, p = 12; i < numTables; i++, p += 16) {
	      const tag = (0, _util.bytesToString)(data.subarray(p, p + 4));
	      const offset = getUint32(data, p + 8);
	      const length = getUint32(data, p + 12);

	      switch (tag) {
	        case "cmap":
	          cmap = parseCmap(data, offset);
	          break;

	        case "glyf":
	          glyf = data.subarray(offset, offset + length);
	          break;

	        case "loca":
	          loca = data.subarray(offset, offset + length);
	          break;

	        case "head":
	          unitsPerEm = getUint16(data, offset + 18);
	          indexToLocFormat = getUint16(data, offset + 50);
	          break;

	        case "CFF ":
	          cff = parseCff(data, offset, offset + length, seacAnalysisEnabled);
	          break;
	      }
	    }

	    if (glyf) {
	      const fontMatrix = !unitsPerEm ? font.fontMatrix : [1 / unitsPerEm, 0, 0, 1 / unitsPerEm, 0, 0];
	      return new TrueTypeCompiled(parseGlyfTable(glyf, loca, indexToLocFormat), cmap, fontMatrix);
	    }

	    return new Type2Compiled(cff, cmap, font.fontMatrix, font.glyphNameMap);
	  }

	}

	exports.FontRendererFactory = FontRendererFactory;

	/***/ }),
	/* 45 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.getMetrics = exports.getFontBasicMetrics = void 0;

	var _core_utils = __w_pdfjs_require__(6);

	const getMetrics = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t.Courier = 600;
	  t["Courier-Bold"] = 600;
	  t["Courier-BoldOblique"] = 600;
	  t["Courier-Oblique"] = 600;
	  t.Helvetica = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 278;
	    t.exclam = 278;
	    t.quotedbl = 355;
	    t.numbersign = 556;
	    t.dollar = 556;
	    t.percent = 889;
	    t.ampersand = 667;
	    t.quoteright = 222;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 389;
	    t.plus = 584;
	    t.comma = 278;
	    t.hyphen = 333;
	    t.period = 278;
	    t.slash = 278;
	    t.zero = 556;
	    t.one = 556;
	    t.two = 556;
	    t.three = 556;
	    t.four = 556;
	    t.five = 556;
	    t.six = 556;
	    t.seven = 556;
	    t.eight = 556;
	    t.nine = 556;
	    t.colon = 278;
	    t.semicolon = 278;
	    t.less = 584;
	    t.equal = 584;
	    t.greater = 584;
	    t.question = 556;
	    t.at = 1015;
	    t.A = 667;
	    t.B = 667;
	    t.C = 722;
	    t.D = 722;
	    t.E = 667;
	    t.F = 611;
	    t.G = 778;
	    t.H = 722;
	    t.I = 278;
	    t.J = 500;
	    t.K = 667;
	    t.L = 556;
	    t.M = 833;
	    t.N = 722;
	    t.O = 778;
	    t.P = 667;
	    t.Q = 778;
	    t.R = 722;
	    t.S = 667;
	    t.T = 611;
	    t.U = 722;
	    t.V = 667;
	    t.W = 944;
	    t.X = 667;
	    t.Y = 667;
	    t.Z = 611;
	    t.bracketleft = 278;
	    t.backslash = 278;
	    t.bracketright = 278;
	    t.asciicircum = 469;
	    t.underscore = 556;
	    t.quoteleft = 222;
	    t.a = 556;
	    t.b = 556;
	    t.c = 500;
	    t.d = 556;
	    t.e = 556;
	    t.f = 278;
	    t.g = 556;
	    t.h = 556;
	    t.i = 222;
	    t.j = 222;
	    t.k = 500;
	    t.l = 222;
	    t.m = 833;
	    t.n = 556;
	    t.o = 556;
	    t.p = 556;
	    t.q = 556;
	    t.r = 333;
	    t.s = 500;
	    t.t = 278;
	    t.u = 556;
	    t.v = 500;
	    t.w = 722;
	    t.x = 500;
	    t.y = 500;
	    t.z = 500;
	    t.braceleft = 334;
	    t.bar = 260;
	    t.braceright = 334;
	    t.asciitilde = 584;
	    t.exclamdown = 333;
	    t.cent = 556;
	    t.sterling = 556;
	    t.fraction = 167;
	    t.yen = 556;
	    t.florin = 556;
	    t.section = 556;
	    t.currency = 556;
	    t.quotesingle = 191;
	    t.quotedblleft = 333;
	    t.guillemotleft = 556;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 500;
	    t.fl = 500;
	    t.endash = 556;
	    t.dagger = 556;
	    t.daggerdbl = 556;
	    t.periodcentered = 278;
	    t.paragraph = 537;
	    t.bullet = 350;
	    t.quotesinglbase = 222;
	    t.quotedblbase = 333;
	    t.quotedblright = 333;
	    t.guillemotright = 556;
	    t.ellipsis = 1000;
	    t.perthousand = 1000;
	    t.questiondown = 611;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 1000;
	    t.AE = 1000;
	    t.ordfeminine = 370;
	    t.Lslash = 556;
	    t.Oslash = 778;
	    t.OE = 1000;
	    t.ordmasculine = 365;
	    t.ae = 889;
	    t.dotlessi = 278;
	    t.lslash = 222;
	    t.oslash = 611;
	    t.oe = 944;
	    t.germandbls = 611;
	    t.Idieresis = 278;
	    t.eacute = 556;
	    t.abreve = 556;
	    t.uhungarumlaut = 556;
	    t.ecaron = 556;
	    t.Ydieresis = 667;
	    t.divide = 584;
	    t.Yacute = 667;
	    t.Acircumflex = 667;
	    t.aacute = 556;
	    t.Ucircumflex = 722;
	    t.yacute = 500;
	    t.scommaaccent = 500;
	    t.ecircumflex = 556;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 556;
	    t.Uacute = 722;
	    t.uogonek = 556;
	    t.Edieresis = 667;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 737;
	    t.Emacron = 667;
	    t.ccaron = 500;
	    t.aring = 556;
	    t.Ncommaaccent = 722;
	    t.lacute = 222;
	    t.agrave = 556;
	    t.Tcommaaccent = 611;
	    t.Cacute = 722;
	    t.atilde = 556;
	    t.Edotaccent = 667;
	    t.scaron = 500;
	    t.scedilla = 500;
	    t.iacute = 278;
	    t.lozenge = 471;
	    t.Rcaron = 722;
	    t.Gcommaaccent = 778;
	    t.ucircumflex = 556;
	    t.acircumflex = 556;
	    t.Amacron = 667;
	    t.rcaron = 333;
	    t.ccedilla = 500;
	    t.Zdotaccent = 611;
	    t.Thorn = 667;
	    t.Omacron = 778;
	    t.Racute = 722;
	    t.Sacute = 667;
	    t.dcaron = 643;
	    t.Umacron = 722;
	    t.uring = 556;
	    t.threesuperior = 333;
	    t.Ograve = 778;
	    t.Agrave = 667;
	    t.Abreve = 667;
	    t.multiply = 584;
	    t.uacute = 556;
	    t.Tcaron = 611;
	    t.partialdiff = 476;
	    t.ydieresis = 500;
	    t.Nacute = 722;
	    t.icircumflex = 278;
	    t.Ecircumflex = 667;
	    t.adieresis = 556;
	    t.edieresis = 556;
	    t.cacute = 500;
	    t.nacute = 556;
	    t.umacron = 556;
	    t.Ncaron = 722;
	    t.Iacute = 278;
	    t.plusminus = 584;
	    t.brokenbar = 260;
	    t.registered = 737;
	    t.Gbreve = 778;
	    t.Idotaccent = 278;
	    t.summation = 600;
	    t.Egrave = 667;
	    t.racute = 333;
	    t.omacron = 556;
	    t.Zacute = 611;
	    t.Zcaron = 611;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 722;
	    t.lcommaaccent = 222;
	    t.tcaron = 317;
	    t.eogonek = 556;
	    t.Uogonek = 722;
	    t.Aacute = 667;
	    t.Adieresis = 667;
	    t.egrave = 556;
	    t.zacute = 500;
	    t.iogonek = 222;
	    t.Oacute = 778;
	    t.oacute = 556;
	    t.amacron = 556;
	    t.sacute = 500;
	    t.idieresis = 278;
	    t.Ocircumflex = 778;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 556;
	    t.twosuperior = 333;
	    t.Odieresis = 778;
	    t.mu = 556;
	    t.igrave = 278;
	    t.ohungarumlaut = 556;
	    t.Eogonek = 667;
	    t.dcroat = 556;
	    t.threequarters = 834;
	    t.Scedilla = 667;
	    t.lcaron = 299;
	    t.Kcommaaccent = 667;
	    t.Lacute = 556;
	    t.trademark = 1000;
	    t.edotaccent = 556;
	    t.Igrave = 278;
	    t.Imacron = 278;
	    t.Lcaron = 556;
	    t.onehalf = 834;
	    t.lessequal = 549;
	    t.ocircumflex = 556;
	    t.ntilde = 556;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 667;
	    t.emacron = 556;
	    t.gbreve = 556;
	    t.onequarter = 834;
	    t.Scaron = 667;
	    t.Scommaaccent = 667;
	    t.Ohungarumlaut = 778;
	    t.degree = 400;
	    t.ograve = 556;
	    t.Ccaron = 722;
	    t.ugrave = 556;
	    t.radical = 453;
	    t.Dcaron = 722;
	    t.rcommaaccent = 333;
	    t.Ntilde = 722;
	    t.otilde = 556;
	    t.Rcommaaccent = 722;
	    t.Lcommaaccent = 556;
	    t.Atilde = 667;
	    t.Aogonek = 667;
	    t.Aring = 667;
	    t.Otilde = 778;
	    t.zdotaccent = 500;
	    t.Ecaron = 667;
	    t.Iogonek = 278;
	    t.kcommaaccent = 500;
	    t.minus = 584;
	    t.Icircumflex = 278;
	    t.ncaron = 556;
	    t.tcommaaccent = 278;
	    t.logicalnot = 584;
	    t.odieresis = 556;
	    t.udieresis = 556;
	    t.notequal = 549;
	    t.gcommaaccent = 556;
	    t.eth = 556;
	    t.zcaron = 500;
	    t.ncommaaccent = 556;
	    t.onesuperior = 333;
	    t.imacron = 278;
	    t.Euro = 556;
	  });
	  t["Helvetica-Bold"] = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 278;
	    t.exclam = 333;
	    t.quotedbl = 474;
	    t.numbersign = 556;
	    t.dollar = 556;
	    t.percent = 889;
	    t.ampersand = 722;
	    t.quoteright = 278;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 389;
	    t.plus = 584;
	    t.comma = 278;
	    t.hyphen = 333;
	    t.period = 278;
	    t.slash = 278;
	    t.zero = 556;
	    t.one = 556;
	    t.two = 556;
	    t.three = 556;
	    t.four = 556;
	    t.five = 556;
	    t.six = 556;
	    t.seven = 556;
	    t.eight = 556;
	    t.nine = 556;
	    t.colon = 333;
	    t.semicolon = 333;
	    t.less = 584;
	    t.equal = 584;
	    t.greater = 584;
	    t.question = 611;
	    t.at = 975;
	    t.A = 722;
	    t.B = 722;
	    t.C = 722;
	    t.D = 722;
	    t.E = 667;
	    t.F = 611;
	    t.G = 778;
	    t.H = 722;
	    t.I = 278;
	    t.J = 556;
	    t.K = 722;
	    t.L = 611;
	    t.M = 833;
	    t.N = 722;
	    t.O = 778;
	    t.P = 667;
	    t.Q = 778;
	    t.R = 722;
	    t.S = 667;
	    t.T = 611;
	    t.U = 722;
	    t.V = 667;
	    t.W = 944;
	    t.X = 667;
	    t.Y = 667;
	    t.Z = 611;
	    t.bracketleft = 333;
	    t.backslash = 278;
	    t.bracketright = 333;
	    t.asciicircum = 584;
	    t.underscore = 556;
	    t.quoteleft = 278;
	    t.a = 556;
	    t.b = 611;
	    t.c = 556;
	    t.d = 611;
	    t.e = 556;
	    t.f = 333;
	    t.g = 611;
	    t.h = 611;
	    t.i = 278;
	    t.j = 278;
	    t.k = 556;
	    t.l = 278;
	    t.m = 889;
	    t.n = 611;
	    t.o = 611;
	    t.p = 611;
	    t.q = 611;
	    t.r = 389;
	    t.s = 556;
	    t.t = 333;
	    t.u = 611;
	    t.v = 556;
	    t.w = 778;
	    t.x = 556;
	    t.y = 556;
	    t.z = 500;
	    t.braceleft = 389;
	    t.bar = 280;
	    t.braceright = 389;
	    t.asciitilde = 584;
	    t.exclamdown = 333;
	    t.cent = 556;
	    t.sterling = 556;
	    t.fraction = 167;
	    t.yen = 556;
	    t.florin = 556;
	    t.section = 556;
	    t.currency = 556;
	    t.quotesingle = 238;
	    t.quotedblleft = 500;
	    t.guillemotleft = 556;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 611;
	    t.fl = 611;
	    t.endash = 556;
	    t.dagger = 556;
	    t.daggerdbl = 556;
	    t.periodcentered = 278;
	    t.paragraph = 556;
	    t.bullet = 350;
	    t.quotesinglbase = 278;
	    t.quotedblbase = 500;
	    t.quotedblright = 500;
	    t.guillemotright = 556;
	    t.ellipsis = 1000;
	    t.perthousand = 1000;
	    t.questiondown = 611;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 1000;
	    t.AE = 1000;
	    t.ordfeminine = 370;
	    t.Lslash = 611;
	    t.Oslash = 778;
	    t.OE = 1000;
	    t.ordmasculine = 365;
	    t.ae = 889;
	    t.dotlessi = 278;
	    t.lslash = 278;
	    t.oslash = 611;
	    t.oe = 944;
	    t.germandbls = 611;
	    t.Idieresis = 278;
	    t.eacute = 556;
	    t.abreve = 556;
	    t.uhungarumlaut = 611;
	    t.ecaron = 556;
	    t.Ydieresis = 667;
	    t.divide = 584;
	    t.Yacute = 667;
	    t.Acircumflex = 722;
	    t.aacute = 556;
	    t.Ucircumflex = 722;
	    t.yacute = 556;
	    t.scommaaccent = 556;
	    t.ecircumflex = 556;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 556;
	    t.Uacute = 722;
	    t.uogonek = 611;
	    t.Edieresis = 667;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 737;
	    t.Emacron = 667;
	    t.ccaron = 556;
	    t.aring = 556;
	    t.Ncommaaccent = 722;
	    t.lacute = 278;
	    t.agrave = 556;
	    t.Tcommaaccent = 611;
	    t.Cacute = 722;
	    t.atilde = 556;
	    t.Edotaccent = 667;
	    t.scaron = 556;
	    t.scedilla = 556;
	    t.iacute = 278;
	    t.lozenge = 494;
	    t.Rcaron = 722;
	    t.Gcommaaccent = 778;
	    t.ucircumflex = 611;
	    t.acircumflex = 556;
	    t.Amacron = 722;
	    t.rcaron = 389;
	    t.ccedilla = 556;
	    t.Zdotaccent = 611;
	    t.Thorn = 667;
	    t.Omacron = 778;
	    t.Racute = 722;
	    t.Sacute = 667;
	    t.dcaron = 743;
	    t.Umacron = 722;
	    t.uring = 611;
	    t.threesuperior = 333;
	    t.Ograve = 778;
	    t.Agrave = 722;
	    t.Abreve = 722;
	    t.multiply = 584;
	    t.uacute = 611;
	    t.Tcaron = 611;
	    t.partialdiff = 494;
	    t.ydieresis = 556;
	    t.Nacute = 722;
	    t.icircumflex = 278;
	    t.Ecircumflex = 667;
	    t.adieresis = 556;
	    t.edieresis = 556;
	    t.cacute = 556;
	    t.nacute = 611;
	    t.umacron = 611;
	    t.Ncaron = 722;
	    t.Iacute = 278;
	    t.plusminus = 584;
	    t.brokenbar = 280;
	    t.registered = 737;
	    t.Gbreve = 778;
	    t.Idotaccent = 278;
	    t.summation = 600;
	    t.Egrave = 667;
	    t.racute = 389;
	    t.omacron = 611;
	    t.Zacute = 611;
	    t.Zcaron = 611;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 722;
	    t.lcommaaccent = 278;
	    t.tcaron = 389;
	    t.eogonek = 556;
	    t.Uogonek = 722;
	    t.Aacute = 722;
	    t.Adieresis = 722;
	    t.egrave = 556;
	    t.zacute = 500;
	    t.iogonek = 278;
	    t.Oacute = 778;
	    t.oacute = 611;
	    t.amacron = 556;
	    t.sacute = 556;
	    t.idieresis = 278;
	    t.Ocircumflex = 778;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 611;
	    t.twosuperior = 333;
	    t.Odieresis = 778;
	    t.mu = 611;
	    t.igrave = 278;
	    t.ohungarumlaut = 611;
	    t.Eogonek = 667;
	    t.dcroat = 611;
	    t.threequarters = 834;
	    t.Scedilla = 667;
	    t.lcaron = 400;
	    t.Kcommaaccent = 722;
	    t.Lacute = 611;
	    t.trademark = 1000;
	    t.edotaccent = 556;
	    t.Igrave = 278;
	    t.Imacron = 278;
	    t.Lcaron = 611;
	    t.onehalf = 834;
	    t.lessequal = 549;
	    t.ocircumflex = 611;
	    t.ntilde = 611;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 667;
	    t.emacron = 556;
	    t.gbreve = 611;
	    t.onequarter = 834;
	    t.Scaron = 667;
	    t.Scommaaccent = 667;
	    t.Ohungarumlaut = 778;
	    t.degree = 400;
	    t.ograve = 611;
	    t.Ccaron = 722;
	    t.ugrave = 611;
	    t.radical = 549;
	    t.Dcaron = 722;
	    t.rcommaaccent = 389;
	    t.Ntilde = 722;
	    t.otilde = 611;
	    t.Rcommaaccent = 722;
	    t.Lcommaaccent = 611;
	    t.Atilde = 722;
	    t.Aogonek = 722;
	    t.Aring = 722;
	    t.Otilde = 778;
	    t.zdotaccent = 500;
	    t.Ecaron = 667;
	    t.Iogonek = 278;
	    t.kcommaaccent = 556;
	    t.minus = 584;
	    t.Icircumflex = 278;
	    t.ncaron = 611;
	    t.tcommaaccent = 333;
	    t.logicalnot = 584;
	    t.odieresis = 611;
	    t.udieresis = 611;
	    t.notequal = 549;
	    t.gcommaaccent = 611;
	    t.eth = 611;
	    t.zcaron = 500;
	    t.ncommaaccent = 611;
	    t.onesuperior = 333;
	    t.imacron = 278;
	    t.Euro = 556;
	  });
	  t["Helvetica-BoldOblique"] = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 278;
	    t.exclam = 333;
	    t.quotedbl = 474;
	    t.numbersign = 556;
	    t.dollar = 556;
	    t.percent = 889;
	    t.ampersand = 722;
	    t.quoteright = 278;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 389;
	    t.plus = 584;
	    t.comma = 278;
	    t.hyphen = 333;
	    t.period = 278;
	    t.slash = 278;
	    t.zero = 556;
	    t.one = 556;
	    t.two = 556;
	    t.three = 556;
	    t.four = 556;
	    t.five = 556;
	    t.six = 556;
	    t.seven = 556;
	    t.eight = 556;
	    t.nine = 556;
	    t.colon = 333;
	    t.semicolon = 333;
	    t.less = 584;
	    t.equal = 584;
	    t.greater = 584;
	    t.question = 611;
	    t.at = 975;
	    t.A = 722;
	    t.B = 722;
	    t.C = 722;
	    t.D = 722;
	    t.E = 667;
	    t.F = 611;
	    t.G = 778;
	    t.H = 722;
	    t.I = 278;
	    t.J = 556;
	    t.K = 722;
	    t.L = 611;
	    t.M = 833;
	    t.N = 722;
	    t.O = 778;
	    t.P = 667;
	    t.Q = 778;
	    t.R = 722;
	    t.S = 667;
	    t.T = 611;
	    t.U = 722;
	    t.V = 667;
	    t.W = 944;
	    t.X = 667;
	    t.Y = 667;
	    t.Z = 611;
	    t.bracketleft = 333;
	    t.backslash = 278;
	    t.bracketright = 333;
	    t.asciicircum = 584;
	    t.underscore = 556;
	    t.quoteleft = 278;
	    t.a = 556;
	    t.b = 611;
	    t.c = 556;
	    t.d = 611;
	    t.e = 556;
	    t.f = 333;
	    t.g = 611;
	    t.h = 611;
	    t.i = 278;
	    t.j = 278;
	    t.k = 556;
	    t.l = 278;
	    t.m = 889;
	    t.n = 611;
	    t.o = 611;
	    t.p = 611;
	    t.q = 611;
	    t.r = 389;
	    t.s = 556;
	    t.t = 333;
	    t.u = 611;
	    t.v = 556;
	    t.w = 778;
	    t.x = 556;
	    t.y = 556;
	    t.z = 500;
	    t.braceleft = 389;
	    t.bar = 280;
	    t.braceright = 389;
	    t.asciitilde = 584;
	    t.exclamdown = 333;
	    t.cent = 556;
	    t.sterling = 556;
	    t.fraction = 167;
	    t.yen = 556;
	    t.florin = 556;
	    t.section = 556;
	    t.currency = 556;
	    t.quotesingle = 238;
	    t.quotedblleft = 500;
	    t.guillemotleft = 556;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 611;
	    t.fl = 611;
	    t.endash = 556;
	    t.dagger = 556;
	    t.daggerdbl = 556;
	    t.periodcentered = 278;
	    t.paragraph = 556;
	    t.bullet = 350;
	    t.quotesinglbase = 278;
	    t.quotedblbase = 500;
	    t.quotedblright = 500;
	    t.guillemotright = 556;
	    t.ellipsis = 1000;
	    t.perthousand = 1000;
	    t.questiondown = 611;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 1000;
	    t.AE = 1000;
	    t.ordfeminine = 370;
	    t.Lslash = 611;
	    t.Oslash = 778;
	    t.OE = 1000;
	    t.ordmasculine = 365;
	    t.ae = 889;
	    t.dotlessi = 278;
	    t.lslash = 278;
	    t.oslash = 611;
	    t.oe = 944;
	    t.germandbls = 611;
	    t.Idieresis = 278;
	    t.eacute = 556;
	    t.abreve = 556;
	    t.uhungarumlaut = 611;
	    t.ecaron = 556;
	    t.Ydieresis = 667;
	    t.divide = 584;
	    t.Yacute = 667;
	    t.Acircumflex = 722;
	    t.aacute = 556;
	    t.Ucircumflex = 722;
	    t.yacute = 556;
	    t.scommaaccent = 556;
	    t.ecircumflex = 556;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 556;
	    t.Uacute = 722;
	    t.uogonek = 611;
	    t.Edieresis = 667;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 737;
	    t.Emacron = 667;
	    t.ccaron = 556;
	    t.aring = 556;
	    t.Ncommaaccent = 722;
	    t.lacute = 278;
	    t.agrave = 556;
	    t.Tcommaaccent = 611;
	    t.Cacute = 722;
	    t.atilde = 556;
	    t.Edotaccent = 667;
	    t.scaron = 556;
	    t.scedilla = 556;
	    t.iacute = 278;
	    t.lozenge = 494;
	    t.Rcaron = 722;
	    t.Gcommaaccent = 778;
	    t.ucircumflex = 611;
	    t.acircumflex = 556;
	    t.Amacron = 722;
	    t.rcaron = 389;
	    t.ccedilla = 556;
	    t.Zdotaccent = 611;
	    t.Thorn = 667;
	    t.Omacron = 778;
	    t.Racute = 722;
	    t.Sacute = 667;
	    t.dcaron = 743;
	    t.Umacron = 722;
	    t.uring = 611;
	    t.threesuperior = 333;
	    t.Ograve = 778;
	    t.Agrave = 722;
	    t.Abreve = 722;
	    t.multiply = 584;
	    t.uacute = 611;
	    t.Tcaron = 611;
	    t.partialdiff = 494;
	    t.ydieresis = 556;
	    t.Nacute = 722;
	    t.icircumflex = 278;
	    t.Ecircumflex = 667;
	    t.adieresis = 556;
	    t.edieresis = 556;
	    t.cacute = 556;
	    t.nacute = 611;
	    t.umacron = 611;
	    t.Ncaron = 722;
	    t.Iacute = 278;
	    t.plusminus = 584;
	    t.brokenbar = 280;
	    t.registered = 737;
	    t.Gbreve = 778;
	    t.Idotaccent = 278;
	    t.summation = 600;
	    t.Egrave = 667;
	    t.racute = 389;
	    t.omacron = 611;
	    t.Zacute = 611;
	    t.Zcaron = 611;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 722;
	    t.lcommaaccent = 278;
	    t.tcaron = 389;
	    t.eogonek = 556;
	    t.Uogonek = 722;
	    t.Aacute = 722;
	    t.Adieresis = 722;
	    t.egrave = 556;
	    t.zacute = 500;
	    t.iogonek = 278;
	    t.Oacute = 778;
	    t.oacute = 611;
	    t.amacron = 556;
	    t.sacute = 556;
	    t.idieresis = 278;
	    t.Ocircumflex = 778;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 611;
	    t.twosuperior = 333;
	    t.Odieresis = 778;
	    t.mu = 611;
	    t.igrave = 278;
	    t.ohungarumlaut = 611;
	    t.Eogonek = 667;
	    t.dcroat = 611;
	    t.threequarters = 834;
	    t.Scedilla = 667;
	    t.lcaron = 400;
	    t.Kcommaaccent = 722;
	    t.Lacute = 611;
	    t.trademark = 1000;
	    t.edotaccent = 556;
	    t.Igrave = 278;
	    t.Imacron = 278;
	    t.Lcaron = 611;
	    t.onehalf = 834;
	    t.lessequal = 549;
	    t.ocircumflex = 611;
	    t.ntilde = 611;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 667;
	    t.emacron = 556;
	    t.gbreve = 611;
	    t.onequarter = 834;
	    t.Scaron = 667;
	    t.Scommaaccent = 667;
	    t.Ohungarumlaut = 778;
	    t.degree = 400;
	    t.ograve = 611;
	    t.Ccaron = 722;
	    t.ugrave = 611;
	    t.radical = 549;
	    t.Dcaron = 722;
	    t.rcommaaccent = 389;
	    t.Ntilde = 722;
	    t.otilde = 611;
	    t.Rcommaaccent = 722;
	    t.Lcommaaccent = 611;
	    t.Atilde = 722;
	    t.Aogonek = 722;
	    t.Aring = 722;
	    t.Otilde = 778;
	    t.zdotaccent = 500;
	    t.Ecaron = 667;
	    t.Iogonek = 278;
	    t.kcommaaccent = 556;
	    t.minus = 584;
	    t.Icircumflex = 278;
	    t.ncaron = 611;
	    t.tcommaaccent = 333;
	    t.logicalnot = 584;
	    t.odieresis = 611;
	    t.udieresis = 611;
	    t.notequal = 549;
	    t.gcommaaccent = 611;
	    t.eth = 611;
	    t.zcaron = 500;
	    t.ncommaaccent = 611;
	    t.onesuperior = 333;
	    t.imacron = 278;
	    t.Euro = 556;
	  });
	  t["Helvetica-Oblique"] = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 278;
	    t.exclam = 278;
	    t.quotedbl = 355;
	    t.numbersign = 556;
	    t.dollar = 556;
	    t.percent = 889;
	    t.ampersand = 667;
	    t.quoteright = 222;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 389;
	    t.plus = 584;
	    t.comma = 278;
	    t.hyphen = 333;
	    t.period = 278;
	    t.slash = 278;
	    t.zero = 556;
	    t.one = 556;
	    t.two = 556;
	    t.three = 556;
	    t.four = 556;
	    t.five = 556;
	    t.six = 556;
	    t.seven = 556;
	    t.eight = 556;
	    t.nine = 556;
	    t.colon = 278;
	    t.semicolon = 278;
	    t.less = 584;
	    t.equal = 584;
	    t.greater = 584;
	    t.question = 556;
	    t.at = 1015;
	    t.A = 667;
	    t.B = 667;
	    t.C = 722;
	    t.D = 722;
	    t.E = 667;
	    t.F = 611;
	    t.G = 778;
	    t.H = 722;
	    t.I = 278;
	    t.J = 500;
	    t.K = 667;
	    t.L = 556;
	    t.M = 833;
	    t.N = 722;
	    t.O = 778;
	    t.P = 667;
	    t.Q = 778;
	    t.R = 722;
	    t.S = 667;
	    t.T = 611;
	    t.U = 722;
	    t.V = 667;
	    t.W = 944;
	    t.X = 667;
	    t.Y = 667;
	    t.Z = 611;
	    t.bracketleft = 278;
	    t.backslash = 278;
	    t.bracketright = 278;
	    t.asciicircum = 469;
	    t.underscore = 556;
	    t.quoteleft = 222;
	    t.a = 556;
	    t.b = 556;
	    t.c = 500;
	    t.d = 556;
	    t.e = 556;
	    t.f = 278;
	    t.g = 556;
	    t.h = 556;
	    t.i = 222;
	    t.j = 222;
	    t.k = 500;
	    t.l = 222;
	    t.m = 833;
	    t.n = 556;
	    t.o = 556;
	    t.p = 556;
	    t.q = 556;
	    t.r = 333;
	    t.s = 500;
	    t.t = 278;
	    t.u = 556;
	    t.v = 500;
	    t.w = 722;
	    t.x = 500;
	    t.y = 500;
	    t.z = 500;
	    t.braceleft = 334;
	    t.bar = 260;
	    t.braceright = 334;
	    t.asciitilde = 584;
	    t.exclamdown = 333;
	    t.cent = 556;
	    t.sterling = 556;
	    t.fraction = 167;
	    t.yen = 556;
	    t.florin = 556;
	    t.section = 556;
	    t.currency = 556;
	    t.quotesingle = 191;
	    t.quotedblleft = 333;
	    t.guillemotleft = 556;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 500;
	    t.fl = 500;
	    t.endash = 556;
	    t.dagger = 556;
	    t.daggerdbl = 556;
	    t.periodcentered = 278;
	    t.paragraph = 537;
	    t.bullet = 350;
	    t.quotesinglbase = 222;
	    t.quotedblbase = 333;
	    t.quotedblright = 333;
	    t.guillemotright = 556;
	    t.ellipsis = 1000;
	    t.perthousand = 1000;
	    t.questiondown = 611;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 1000;
	    t.AE = 1000;
	    t.ordfeminine = 370;
	    t.Lslash = 556;
	    t.Oslash = 778;
	    t.OE = 1000;
	    t.ordmasculine = 365;
	    t.ae = 889;
	    t.dotlessi = 278;
	    t.lslash = 222;
	    t.oslash = 611;
	    t.oe = 944;
	    t.germandbls = 611;
	    t.Idieresis = 278;
	    t.eacute = 556;
	    t.abreve = 556;
	    t.uhungarumlaut = 556;
	    t.ecaron = 556;
	    t.Ydieresis = 667;
	    t.divide = 584;
	    t.Yacute = 667;
	    t.Acircumflex = 667;
	    t.aacute = 556;
	    t.Ucircumflex = 722;
	    t.yacute = 500;
	    t.scommaaccent = 500;
	    t.ecircumflex = 556;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 556;
	    t.Uacute = 722;
	    t.uogonek = 556;
	    t.Edieresis = 667;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 737;
	    t.Emacron = 667;
	    t.ccaron = 500;
	    t.aring = 556;
	    t.Ncommaaccent = 722;
	    t.lacute = 222;
	    t.agrave = 556;
	    t.Tcommaaccent = 611;
	    t.Cacute = 722;
	    t.atilde = 556;
	    t.Edotaccent = 667;
	    t.scaron = 500;
	    t.scedilla = 500;
	    t.iacute = 278;
	    t.lozenge = 471;
	    t.Rcaron = 722;
	    t.Gcommaaccent = 778;
	    t.ucircumflex = 556;
	    t.acircumflex = 556;
	    t.Amacron = 667;
	    t.rcaron = 333;
	    t.ccedilla = 500;
	    t.Zdotaccent = 611;
	    t.Thorn = 667;
	    t.Omacron = 778;
	    t.Racute = 722;
	    t.Sacute = 667;
	    t.dcaron = 643;
	    t.Umacron = 722;
	    t.uring = 556;
	    t.threesuperior = 333;
	    t.Ograve = 778;
	    t.Agrave = 667;
	    t.Abreve = 667;
	    t.multiply = 584;
	    t.uacute = 556;
	    t.Tcaron = 611;
	    t.partialdiff = 476;
	    t.ydieresis = 500;
	    t.Nacute = 722;
	    t.icircumflex = 278;
	    t.Ecircumflex = 667;
	    t.adieresis = 556;
	    t.edieresis = 556;
	    t.cacute = 500;
	    t.nacute = 556;
	    t.umacron = 556;
	    t.Ncaron = 722;
	    t.Iacute = 278;
	    t.plusminus = 584;
	    t.brokenbar = 260;
	    t.registered = 737;
	    t.Gbreve = 778;
	    t.Idotaccent = 278;
	    t.summation = 600;
	    t.Egrave = 667;
	    t.racute = 333;
	    t.omacron = 556;
	    t.Zacute = 611;
	    t.Zcaron = 611;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 722;
	    t.lcommaaccent = 222;
	    t.tcaron = 317;
	    t.eogonek = 556;
	    t.Uogonek = 722;
	    t.Aacute = 667;
	    t.Adieresis = 667;
	    t.egrave = 556;
	    t.zacute = 500;
	    t.iogonek = 222;
	    t.Oacute = 778;
	    t.oacute = 556;
	    t.amacron = 556;
	    t.sacute = 500;
	    t.idieresis = 278;
	    t.Ocircumflex = 778;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 556;
	    t.twosuperior = 333;
	    t.Odieresis = 778;
	    t.mu = 556;
	    t.igrave = 278;
	    t.ohungarumlaut = 556;
	    t.Eogonek = 667;
	    t.dcroat = 556;
	    t.threequarters = 834;
	    t.Scedilla = 667;
	    t.lcaron = 299;
	    t.Kcommaaccent = 667;
	    t.Lacute = 556;
	    t.trademark = 1000;
	    t.edotaccent = 556;
	    t.Igrave = 278;
	    t.Imacron = 278;
	    t.Lcaron = 556;
	    t.onehalf = 834;
	    t.lessequal = 549;
	    t.ocircumflex = 556;
	    t.ntilde = 556;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 667;
	    t.emacron = 556;
	    t.gbreve = 556;
	    t.onequarter = 834;
	    t.Scaron = 667;
	    t.Scommaaccent = 667;
	    t.Ohungarumlaut = 778;
	    t.degree = 400;
	    t.ograve = 556;
	    t.Ccaron = 722;
	    t.ugrave = 556;
	    t.radical = 453;
	    t.Dcaron = 722;
	    t.rcommaaccent = 333;
	    t.Ntilde = 722;
	    t.otilde = 556;
	    t.Rcommaaccent = 722;
	    t.Lcommaaccent = 556;
	    t.Atilde = 667;
	    t.Aogonek = 667;
	    t.Aring = 667;
	    t.Otilde = 778;
	    t.zdotaccent = 500;
	    t.Ecaron = 667;
	    t.Iogonek = 278;
	    t.kcommaaccent = 500;
	    t.minus = 584;
	    t.Icircumflex = 278;
	    t.ncaron = 556;
	    t.tcommaaccent = 278;
	    t.logicalnot = 584;
	    t.odieresis = 556;
	    t.udieresis = 556;
	    t.notequal = 549;
	    t.gcommaaccent = 556;
	    t.eth = 556;
	    t.zcaron = 500;
	    t.ncommaaccent = 556;
	    t.onesuperior = 333;
	    t.imacron = 278;
	    t.Euro = 556;
	  });
	  t.Symbol = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 250;
	    t.exclam = 333;
	    t.universal = 713;
	    t.numbersign = 500;
	    t.existential = 549;
	    t.percent = 833;
	    t.ampersand = 778;
	    t.suchthat = 439;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asteriskmath = 500;
	    t.plus = 549;
	    t.comma = 250;
	    t.minus = 549;
	    t.period = 250;
	    t.slash = 278;
	    t.zero = 500;
	    t.one = 500;
	    t.two = 500;
	    t.three = 500;
	    t.four = 500;
	    t.five = 500;
	    t.six = 500;
	    t.seven = 500;
	    t.eight = 500;
	    t.nine = 500;
	    t.colon = 278;
	    t.semicolon = 278;
	    t.less = 549;
	    t.equal = 549;
	    t.greater = 549;
	    t.question = 444;
	    t.congruent = 549;
	    t.Alpha = 722;
	    t.Beta = 667;
	    t.Chi = 722;
	    t.Delta = 612;
	    t.Epsilon = 611;
	    t.Phi = 763;
	    t.Gamma = 603;
	    t.Eta = 722;
	    t.Iota = 333;
	    t.theta1 = 631;
	    t.Kappa = 722;
	    t.Lambda = 686;
	    t.Mu = 889;
	    t.Nu = 722;
	    t.Omicron = 722;
	    t.Pi = 768;
	    t.Theta = 741;
	    t.Rho = 556;
	    t.Sigma = 592;
	    t.Tau = 611;
	    t.Upsilon = 690;
	    t.sigma1 = 439;
	    t.Omega = 768;
	    t.Xi = 645;
	    t.Psi = 795;
	    t.Zeta = 611;
	    t.bracketleft = 333;
	    t.therefore = 863;
	    t.bracketright = 333;
	    t.perpendicular = 658;
	    t.underscore = 500;
	    t.radicalex = 500;
	    t.alpha = 631;
	    t.beta = 549;
	    t.chi = 549;
	    t.delta = 494;
	    t.epsilon = 439;
	    t.phi = 521;
	    t.gamma = 411;
	    t.eta = 603;
	    t.iota = 329;
	    t.phi1 = 603;
	    t.kappa = 549;
	    t.lambda = 549;
	    t.mu = 576;
	    t.nu = 521;
	    t.omicron = 549;
	    t.pi = 549;
	    t.theta = 521;
	    t.rho = 549;
	    t.sigma = 603;
	    t.tau = 439;
	    t.upsilon = 576;
	    t.omega1 = 713;
	    t.omega = 686;
	    t.xi = 493;
	    t.psi = 686;
	    t.zeta = 494;
	    t.braceleft = 480;
	    t.bar = 200;
	    t.braceright = 480;
	    t.similar = 549;
	    t.Euro = 750;
	    t.Upsilon1 = 620;
	    t.minute = 247;
	    t.lessequal = 549;
	    t.fraction = 167;
	    t.infinity = 713;
	    t.florin = 500;
	    t.club = 753;
	    t.diamond = 753;
	    t.heart = 753;
	    t.spade = 753;
	    t.arrowboth = 1042;
	    t.arrowleft = 987;
	    t.arrowup = 603;
	    t.arrowright = 987;
	    t.arrowdown = 603;
	    t.degree = 400;
	    t.plusminus = 549;
	    t.second = 411;
	    t.greaterequal = 549;
	    t.multiply = 549;
	    t.proportional = 713;
	    t.partialdiff = 494;
	    t.bullet = 460;
	    t.divide = 549;
	    t.notequal = 549;
	    t.equivalence = 549;
	    t.approxequal = 549;
	    t.ellipsis = 1000;
	    t.arrowvertex = 603;
	    t.arrowhorizex = 1000;
	    t.carriagereturn = 658;
	    t.aleph = 823;
	    t.Ifraktur = 686;
	    t.Rfraktur = 795;
	    t.weierstrass = 987;
	    t.circlemultiply = 768;
	    t.circleplus = 768;
	    t.emptyset = 823;
	    t.intersection = 768;
	    t.union = 768;
	    t.propersuperset = 713;
	    t.reflexsuperset = 713;
	    t.notsubset = 713;
	    t.propersubset = 713;
	    t.reflexsubset = 713;
	    t.element = 713;
	    t.notelement = 713;
	    t.angle = 768;
	    t.gradient = 713;
	    t.registerserif = 790;
	    t.copyrightserif = 790;
	    t.trademarkserif = 890;
	    t.product = 823;
	    t.radical = 549;
	    t.dotmath = 250;
	    t.logicalnot = 713;
	    t.logicaland = 603;
	    t.logicalor = 603;
	    t.arrowdblboth = 1042;
	    t.arrowdblleft = 987;
	    t.arrowdblup = 603;
	    t.arrowdblright = 987;
	    t.arrowdbldown = 603;
	    t.lozenge = 494;
	    t.angleleft = 329;
	    t.registersans = 790;
	    t.copyrightsans = 790;
	    t.trademarksans = 786;
	    t.summation = 713;
	    t.parenlefttp = 384;
	    t.parenleftex = 384;
	    t.parenleftbt = 384;
	    t.bracketlefttp = 384;
	    t.bracketleftex = 384;
	    t.bracketleftbt = 384;
	    t.bracelefttp = 494;
	    t.braceleftmid = 494;
	    t.braceleftbt = 494;
	    t.braceex = 494;
	    t.angleright = 329;
	    t.integral = 274;
	    t.integraltp = 686;
	    t.integralex = 686;
	    t.integralbt = 686;
	    t.parenrighttp = 384;
	    t.parenrightex = 384;
	    t.parenrightbt = 384;
	    t.bracketrighttp = 384;
	    t.bracketrightex = 384;
	    t.bracketrightbt = 384;
	    t.bracerighttp = 494;
	    t.bracerightmid = 494;
	    t.bracerightbt = 494;
	    t.apple = 790;
	  });
	  t["Times-Roman"] = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 250;
	    t.exclam = 333;
	    t.quotedbl = 408;
	    t.numbersign = 500;
	    t.dollar = 500;
	    t.percent = 833;
	    t.ampersand = 778;
	    t.quoteright = 333;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 500;
	    t.plus = 564;
	    t.comma = 250;
	    t.hyphen = 333;
	    t.period = 250;
	    t.slash = 278;
	    t.zero = 500;
	    t.one = 500;
	    t.two = 500;
	    t.three = 500;
	    t.four = 500;
	    t.five = 500;
	    t.six = 500;
	    t.seven = 500;
	    t.eight = 500;
	    t.nine = 500;
	    t.colon = 278;
	    t.semicolon = 278;
	    t.less = 564;
	    t.equal = 564;
	    t.greater = 564;
	    t.question = 444;
	    t.at = 921;
	    t.A = 722;
	    t.B = 667;
	    t.C = 667;
	    t.D = 722;
	    t.E = 611;
	    t.F = 556;
	    t.G = 722;
	    t.H = 722;
	    t.I = 333;
	    t.J = 389;
	    t.K = 722;
	    t.L = 611;
	    t.M = 889;
	    t.N = 722;
	    t.O = 722;
	    t.P = 556;
	    t.Q = 722;
	    t.R = 667;
	    t.S = 556;
	    t.T = 611;
	    t.U = 722;
	    t.V = 722;
	    t.W = 944;
	    t.X = 722;
	    t.Y = 722;
	    t.Z = 611;
	    t.bracketleft = 333;
	    t.backslash = 278;
	    t.bracketright = 333;
	    t.asciicircum = 469;
	    t.underscore = 500;
	    t.quoteleft = 333;
	    t.a = 444;
	    t.b = 500;
	    t.c = 444;
	    t.d = 500;
	    t.e = 444;
	    t.f = 333;
	    t.g = 500;
	    t.h = 500;
	    t.i = 278;
	    t.j = 278;
	    t.k = 500;
	    t.l = 278;
	    t.m = 778;
	    t.n = 500;
	    t.o = 500;
	    t.p = 500;
	    t.q = 500;
	    t.r = 333;
	    t.s = 389;
	    t.t = 278;
	    t.u = 500;
	    t.v = 500;
	    t.w = 722;
	    t.x = 500;
	    t.y = 500;
	    t.z = 444;
	    t.braceleft = 480;
	    t.bar = 200;
	    t.braceright = 480;
	    t.asciitilde = 541;
	    t.exclamdown = 333;
	    t.cent = 500;
	    t.sterling = 500;
	    t.fraction = 167;
	    t.yen = 500;
	    t.florin = 500;
	    t.section = 500;
	    t.currency = 500;
	    t.quotesingle = 180;
	    t.quotedblleft = 444;
	    t.guillemotleft = 500;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 556;
	    t.fl = 556;
	    t.endash = 500;
	    t.dagger = 500;
	    t.daggerdbl = 500;
	    t.periodcentered = 250;
	    t.paragraph = 453;
	    t.bullet = 350;
	    t.quotesinglbase = 333;
	    t.quotedblbase = 444;
	    t.quotedblright = 444;
	    t.guillemotright = 500;
	    t.ellipsis = 1000;
	    t.perthousand = 1000;
	    t.questiondown = 444;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 1000;
	    t.AE = 889;
	    t.ordfeminine = 276;
	    t.Lslash = 611;
	    t.Oslash = 722;
	    t.OE = 889;
	    t.ordmasculine = 310;
	    t.ae = 667;
	    t.dotlessi = 278;
	    t.lslash = 278;
	    t.oslash = 500;
	    t.oe = 722;
	    t.germandbls = 500;
	    t.Idieresis = 333;
	    t.eacute = 444;
	    t.abreve = 444;
	    t.uhungarumlaut = 500;
	    t.ecaron = 444;
	    t.Ydieresis = 722;
	    t.divide = 564;
	    t.Yacute = 722;
	    t.Acircumflex = 722;
	    t.aacute = 444;
	    t.Ucircumflex = 722;
	    t.yacute = 500;
	    t.scommaaccent = 389;
	    t.ecircumflex = 444;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 444;
	    t.Uacute = 722;
	    t.uogonek = 500;
	    t.Edieresis = 611;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 760;
	    t.Emacron = 611;
	    t.ccaron = 444;
	    t.aring = 444;
	    t.Ncommaaccent = 722;
	    t.lacute = 278;
	    t.agrave = 444;
	    t.Tcommaaccent = 611;
	    t.Cacute = 667;
	    t.atilde = 444;
	    t.Edotaccent = 611;
	    t.scaron = 389;
	    t.scedilla = 389;
	    t.iacute = 278;
	    t.lozenge = 471;
	    t.Rcaron = 667;
	    t.Gcommaaccent = 722;
	    t.ucircumflex = 500;
	    t.acircumflex = 444;
	    t.Amacron = 722;
	    t.rcaron = 333;
	    t.ccedilla = 444;
	    t.Zdotaccent = 611;
	    t.Thorn = 556;
	    t.Omacron = 722;
	    t.Racute = 667;
	    t.Sacute = 556;
	    t.dcaron = 588;
	    t.Umacron = 722;
	    t.uring = 500;
	    t.threesuperior = 300;
	    t.Ograve = 722;
	    t.Agrave = 722;
	    t.Abreve = 722;
	    t.multiply = 564;
	    t.uacute = 500;
	    t.Tcaron = 611;
	    t.partialdiff = 476;
	    t.ydieresis = 500;
	    t.Nacute = 722;
	    t.icircumflex = 278;
	    t.Ecircumflex = 611;
	    t.adieresis = 444;
	    t.edieresis = 444;
	    t.cacute = 444;
	    t.nacute = 500;
	    t.umacron = 500;
	    t.Ncaron = 722;
	    t.Iacute = 333;
	    t.plusminus = 564;
	    t.brokenbar = 200;
	    t.registered = 760;
	    t.Gbreve = 722;
	    t.Idotaccent = 333;
	    t.summation = 600;
	    t.Egrave = 611;
	    t.racute = 333;
	    t.omacron = 500;
	    t.Zacute = 611;
	    t.Zcaron = 611;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 667;
	    t.lcommaaccent = 278;
	    t.tcaron = 326;
	    t.eogonek = 444;
	    t.Uogonek = 722;
	    t.Aacute = 722;
	    t.Adieresis = 722;
	    t.egrave = 444;
	    t.zacute = 444;
	    t.iogonek = 278;
	    t.Oacute = 722;
	    t.oacute = 500;
	    t.amacron = 444;
	    t.sacute = 389;
	    t.idieresis = 278;
	    t.Ocircumflex = 722;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 500;
	    t.twosuperior = 300;
	    t.Odieresis = 722;
	    t.mu = 500;
	    t.igrave = 278;
	    t.ohungarumlaut = 500;
	    t.Eogonek = 611;
	    t.dcroat = 500;
	    t.threequarters = 750;
	    t.Scedilla = 556;
	    t.lcaron = 344;
	    t.Kcommaaccent = 722;
	    t.Lacute = 611;
	    t.trademark = 980;
	    t.edotaccent = 444;
	    t.Igrave = 333;
	    t.Imacron = 333;
	    t.Lcaron = 611;
	    t.onehalf = 750;
	    t.lessequal = 549;
	    t.ocircumflex = 500;
	    t.ntilde = 500;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 611;
	    t.emacron = 444;
	    t.gbreve = 500;
	    t.onequarter = 750;
	    t.Scaron = 556;
	    t.Scommaaccent = 556;
	    t.Ohungarumlaut = 722;
	    t.degree = 400;
	    t.ograve = 500;
	    t.Ccaron = 667;
	    t.ugrave = 500;
	    t.radical = 453;
	    t.Dcaron = 722;
	    t.rcommaaccent = 333;
	    t.Ntilde = 722;
	    t.otilde = 500;
	    t.Rcommaaccent = 667;
	    t.Lcommaaccent = 611;
	    t.Atilde = 722;
	    t.Aogonek = 722;
	    t.Aring = 722;
	    t.Otilde = 722;
	    t.zdotaccent = 444;
	    t.Ecaron = 611;
	    t.Iogonek = 333;
	    t.kcommaaccent = 500;
	    t.minus = 564;
	    t.Icircumflex = 333;
	    t.ncaron = 500;
	    t.tcommaaccent = 278;
	    t.logicalnot = 564;
	    t.odieresis = 500;
	    t.udieresis = 500;
	    t.notequal = 549;
	    t.gcommaaccent = 500;
	    t.eth = 500;
	    t.zcaron = 444;
	    t.ncommaaccent = 500;
	    t.onesuperior = 300;
	    t.imacron = 278;
	    t.Euro = 500;
	  });
	  t["Times-Bold"] = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 250;
	    t.exclam = 333;
	    t.quotedbl = 555;
	    t.numbersign = 500;
	    t.dollar = 500;
	    t.percent = 1000;
	    t.ampersand = 833;
	    t.quoteright = 333;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 500;
	    t.plus = 570;
	    t.comma = 250;
	    t.hyphen = 333;
	    t.period = 250;
	    t.slash = 278;
	    t.zero = 500;
	    t.one = 500;
	    t.two = 500;
	    t.three = 500;
	    t.four = 500;
	    t.five = 500;
	    t.six = 500;
	    t.seven = 500;
	    t.eight = 500;
	    t.nine = 500;
	    t.colon = 333;
	    t.semicolon = 333;
	    t.less = 570;
	    t.equal = 570;
	    t.greater = 570;
	    t.question = 500;
	    t.at = 930;
	    t.A = 722;
	    t.B = 667;
	    t.C = 722;
	    t.D = 722;
	    t.E = 667;
	    t.F = 611;
	    t.G = 778;
	    t.H = 778;
	    t.I = 389;
	    t.J = 500;
	    t.K = 778;
	    t.L = 667;
	    t.M = 944;
	    t.N = 722;
	    t.O = 778;
	    t.P = 611;
	    t.Q = 778;
	    t.R = 722;
	    t.S = 556;
	    t.T = 667;
	    t.U = 722;
	    t.V = 722;
	    t.W = 1000;
	    t.X = 722;
	    t.Y = 722;
	    t.Z = 667;
	    t.bracketleft = 333;
	    t.backslash = 278;
	    t.bracketright = 333;
	    t.asciicircum = 581;
	    t.underscore = 500;
	    t.quoteleft = 333;
	    t.a = 500;
	    t.b = 556;
	    t.c = 444;
	    t.d = 556;
	    t.e = 444;
	    t.f = 333;
	    t.g = 500;
	    t.h = 556;
	    t.i = 278;
	    t.j = 333;
	    t.k = 556;
	    t.l = 278;
	    t.m = 833;
	    t.n = 556;
	    t.o = 500;
	    t.p = 556;
	    t.q = 556;
	    t.r = 444;
	    t.s = 389;
	    t.t = 333;
	    t.u = 556;
	    t.v = 500;
	    t.w = 722;
	    t.x = 500;
	    t.y = 500;
	    t.z = 444;
	    t.braceleft = 394;
	    t.bar = 220;
	    t.braceright = 394;
	    t.asciitilde = 520;
	    t.exclamdown = 333;
	    t.cent = 500;
	    t.sterling = 500;
	    t.fraction = 167;
	    t.yen = 500;
	    t.florin = 500;
	    t.section = 500;
	    t.currency = 500;
	    t.quotesingle = 278;
	    t.quotedblleft = 500;
	    t.guillemotleft = 500;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 556;
	    t.fl = 556;
	    t.endash = 500;
	    t.dagger = 500;
	    t.daggerdbl = 500;
	    t.periodcentered = 250;
	    t.paragraph = 540;
	    t.bullet = 350;
	    t.quotesinglbase = 333;
	    t.quotedblbase = 500;
	    t.quotedblright = 500;
	    t.guillemotright = 500;
	    t.ellipsis = 1000;
	    t.perthousand = 1000;
	    t.questiondown = 500;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 1000;
	    t.AE = 1000;
	    t.ordfeminine = 300;
	    t.Lslash = 667;
	    t.Oslash = 778;
	    t.OE = 1000;
	    t.ordmasculine = 330;
	    t.ae = 722;
	    t.dotlessi = 278;
	    t.lslash = 278;
	    t.oslash = 500;
	    t.oe = 722;
	    t.germandbls = 556;
	    t.Idieresis = 389;
	    t.eacute = 444;
	    t.abreve = 500;
	    t.uhungarumlaut = 556;
	    t.ecaron = 444;
	    t.Ydieresis = 722;
	    t.divide = 570;
	    t.Yacute = 722;
	    t.Acircumflex = 722;
	    t.aacute = 500;
	    t.Ucircumflex = 722;
	    t.yacute = 500;
	    t.scommaaccent = 389;
	    t.ecircumflex = 444;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 500;
	    t.Uacute = 722;
	    t.uogonek = 556;
	    t.Edieresis = 667;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 747;
	    t.Emacron = 667;
	    t.ccaron = 444;
	    t.aring = 500;
	    t.Ncommaaccent = 722;
	    t.lacute = 278;
	    t.agrave = 500;
	    t.Tcommaaccent = 667;
	    t.Cacute = 722;
	    t.atilde = 500;
	    t.Edotaccent = 667;
	    t.scaron = 389;
	    t.scedilla = 389;
	    t.iacute = 278;
	    t.lozenge = 494;
	    t.Rcaron = 722;
	    t.Gcommaaccent = 778;
	    t.ucircumflex = 556;
	    t.acircumflex = 500;
	    t.Amacron = 722;
	    t.rcaron = 444;
	    t.ccedilla = 444;
	    t.Zdotaccent = 667;
	    t.Thorn = 611;
	    t.Omacron = 778;
	    t.Racute = 722;
	    t.Sacute = 556;
	    t.dcaron = 672;
	    t.Umacron = 722;
	    t.uring = 556;
	    t.threesuperior = 300;
	    t.Ograve = 778;
	    t.Agrave = 722;
	    t.Abreve = 722;
	    t.multiply = 570;
	    t.uacute = 556;
	    t.Tcaron = 667;
	    t.partialdiff = 494;
	    t.ydieresis = 500;
	    t.Nacute = 722;
	    t.icircumflex = 278;
	    t.Ecircumflex = 667;
	    t.adieresis = 500;
	    t.edieresis = 444;
	    t.cacute = 444;
	    t.nacute = 556;
	    t.umacron = 556;
	    t.Ncaron = 722;
	    t.Iacute = 389;
	    t.plusminus = 570;
	    t.brokenbar = 220;
	    t.registered = 747;
	    t.Gbreve = 778;
	    t.Idotaccent = 389;
	    t.summation = 600;
	    t.Egrave = 667;
	    t.racute = 444;
	    t.omacron = 500;
	    t.Zacute = 667;
	    t.Zcaron = 667;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 722;
	    t.lcommaaccent = 278;
	    t.tcaron = 416;
	    t.eogonek = 444;
	    t.Uogonek = 722;
	    t.Aacute = 722;
	    t.Adieresis = 722;
	    t.egrave = 444;
	    t.zacute = 444;
	    t.iogonek = 278;
	    t.Oacute = 778;
	    t.oacute = 500;
	    t.amacron = 500;
	    t.sacute = 389;
	    t.idieresis = 278;
	    t.Ocircumflex = 778;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 556;
	    t.twosuperior = 300;
	    t.Odieresis = 778;
	    t.mu = 556;
	    t.igrave = 278;
	    t.ohungarumlaut = 500;
	    t.Eogonek = 667;
	    t.dcroat = 556;
	    t.threequarters = 750;
	    t.Scedilla = 556;
	    t.lcaron = 394;
	    t.Kcommaaccent = 778;
	    t.Lacute = 667;
	    t.trademark = 1000;
	    t.edotaccent = 444;
	    t.Igrave = 389;
	    t.Imacron = 389;
	    t.Lcaron = 667;
	    t.onehalf = 750;
	    t.lessequal = 549;
	    t.ocircumflex = 500;
	    t.ntilde = 556;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 667;
	    t.emacron = 444;
	    t.gbreve = 500;
	    t.onequarter = 750;
	    t.Scaron = 556;
	    t.Scommaaccent = 556;
	    t.Ohungarumlaut = 778;
	    t.degree = 400;
	    t.ograve = 500;
	    t.Ccaron = 722;
	    t.ugrave = 556;
	    t.radical = 549;
	    t.Dcaron = 722;
	    t.rcommaaccent = 444;
	    t.Ntilde = 722;
	    t.otilde = 500;
	    t.Rcommaaccent = 722;
	    t.Lcommaaccent = 667;
	    t.Atilde = 722;
	    t.Aogonek = 722;
	    t.Aring = 722;
	    t.Otilde = 778;
	    t.zdotaccent = 444;
	    t.Ecaron = 667;
	    t.Iogonek = 389;
	    t.kcommaaccent = 556;
	    t.minus = 570;
	    t.Icircumflex = 389;
	    t.ncaron = 556;
	    t.tcommaaccent = 333;
	    t.logicalnot = 570;
	    t.odieresis = 500;
	    t.udieresis = 556;
	    t.notequal = 549;
	    t.gcommaaccent = 500;
	    t.eth = 500;
	    t.zcaron = 444;
	    t.ncommaaccent = 556;
	    t.onesuperior = 300;
	    t.imacron = 278;
	    t.Euro = 500;
	  });
	  t["Times-BoldItalic"] = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 250;
	    t.exclam = 389;
	    t.quotedbl = 555;
	    t.numbersign = 500;
	    t.dollar = 500;
	    t.percent = 833;
	    t.ampersand = 778;
	    t.quoteright = 333;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 500;
	    t.plus = 570;
	    t.comma = 250;
	    t.hyphen = 333;
	    t.period = 250;
	    t.slash = 278;
	    t.zero = 500;
	    t.one = 500;
	    t.two = 500;
	    t.three = 500;
	    t.four = 500;
	    t.five = 500;
	    t.six = 500;
	    t.seven = 500;
	    t.eight = 500;
	    t.nine = 500;
	    t.colon = 333;
	    t.semicolon = 333;
	    t.less = 570;
	    t.equal = 570;
	    t.greater = 570;
	    t.question = 500;
	    t.at = 832;
	    t.A = 667;
	    t.B = 667;
	    t.C = 667;
	    t.D = 722;
	    t.E = 667;
	    t.F = 667;
	    t.G = 722;
	    t.H = 778;
	    t.I = 389;
	    t.J = 500;
	    t.K = 667;
	    t.L = 611;
	    t.M = 889;
	    t.N = 722;
	    t.O = 722;
	    t.P = 611;
	    t.Q = 722;
	    t.R = 667;
	    t.S = 556;
	    t.T = 611;
	    t.U = 722;
	    t.V = 667;
	    t.W = 889;
	    t.X = 667;
	    t.Y = 611;
	    t.Z = 611;
	    t.bracketleft = 333;
	    t.backslash = 278;
	    t.bracketright = 333;
	    t.asciicircum = 570;
	    t.underscore = 500;
	    t.quoteleft = 333;
	    t.a = 500;
	    t.b = 500;
	    t.c = 444;
	    t.d = 500;
	    t.e = 444;
	    t.f = 333;
	    t.g = 500;
	    t.h = 556;
	    t.i = 278;
	    t.j = 278;
	    t.k = 500;
	    t.l = 278;
	    t.m = 778;
	    t.n = 556;
	    t.o = 500;
	    t.p = 500;
	    t.q = 500;
	    t.r = 389;
	    t.s = 389;
	    t.t = 278;
	    t.u = 556;
	    t.v = 444;
	    t.w = 667;
	    t.x = 500;
	    t.y = 444;
	    t.z = 389;
	    t.braceleft = 348;
	    t.bar = 220;
	    t.braceright = 348;
	    t.asciitilde = 570;
	    t.exclamdown = 389;
	    t.cent = 500;
	    t.sterling = 500;
	    t.fraction = 167;
	    t.yen = 500;
	    t.florin = 500;
	    t.section = 500;
	    t.currency = 500;
	    t.quotesingle = 278;
	    t.quotedblleft = 500;
	    t.guillemotleft = 500;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 556;
	    t.fl = 556;
	    t.endash = 500;
	    t.dagger = 500;
	    t.daggerdbl = 500;
	    t.periodcentered = 250;
	    t.paragraph = 500;
	    t.bullet = 350;
	    t.quotesinglbase = 333;
	    t.quotedblbase = 500;
	    t.quotedblright = 500;
	    t.guillemotright = 500;
	    t.ellipsis = 1000;
	    t.perthousand = 1000;
	    t.questiondown = 500;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 1000;
	    t.AE = 944;
	    t.ordfeminine = 266;
	    t.Lslash = 611;
	    t.Oslash = 722;
	    t.OE = 944;
	    t.ordmasculine = 300;
	    t.ae = 722;
	    t.dotlessi = 278;
	    t.lslash = 278;
	    t.oslash = 500;
	    t.oe = 722;
	    t.germandbls = 500;
	    t.Idieresis = 389;
	    t.eacute = 444;
	    t.abreve = 500;
	    t.uhungarumlaut = 556;
	    t.ecaron = 444;
	    t.Ydieresis = 611;
	    t.divide = 570;
	    t.Yacute = 611;
	    t.Acircumflex = 667;
	    t.aacute = 500;
	    t.Ucircumflex = 722;
	    t.yacute = 444;
	    t.scommaaccent = 389;
	    t.ecircumflex = 444;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 500;
	    t.Uacute = 722;
	    t.uogonek = 556;
	    t.Edieresis = 667;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 747;
	    t.Emacron = 667;
	    t.ccaron = 444;
	    t.aring = 500;
	    t.Ncommaaccent = 722;
	    t.lacute = 278;
	    t.agrave = 500;
	    t.Tcommaaccent = 611;
	    t.Cacute = 667;
	    t.atilde = 500;
	    t.Edotaccent = 667;
	    t.scaron = 389;
	    t.scedilla = 389;
	    t.iacute = 278;
	    t.lozenge = 494;
	    t.Rcaron = 667;
	    t.Gcommaaccent = 722;
	    t.ucircumflex = 556;
	    t.acircumflex = 500;
	    t.Amacron = 667;
	    t.rcaron = 389;
	    t.ccedilla = 444;
	    t.Zdotaccent = 611;
	    t.Thorn = 611;
	    t.Omacron = 722;
	    t.Racute = 667;
	    t.Sacute = 556;
	    t.dcaron = 608;
	    t.Umacron = 722;
	    t.uring = 556;
	    t.threesuperior = 300;
	    t.Ograve = 722;
	    t.Agrave = 667;
	    t.Abreve = 667;
	    t.multiply = 570;
	    t.uacute = 556;
	    t.Tcaron = 611;
	    t.partialdiff = 494;
	    t.ydieresis = 444;
	    t.Nacute = 722;
	    t.icircumflex = 278;
	    t.Ecircumflex = 667;
	    t.adieresis = 500;
	    t.edieresis = 444;
	    t.cacute = 444;
	    t.nacute = 556;
	    t.umacron = 556;
	    t.Ncaron = 722;
	    t.Iacute = 389;
	    t.plusminus = 570;
	    t.brokenbar = 220;
	    t.registered = 747;
	    t.Gbreve = 722;
	    t.Idotaccent = 389;
	    t.summation = 600;
	    t.Egrave = 667;
	    t.racute = 389;
	    t.omacron = 500;
	    t.Zacute = 611;
	    t.Zcaron = 611;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 667;
	    t.lcommaaccent = 278;
	    t.tcaron = 366;
	    t.eogonek = 444;
	    t.Uogonek = 722;
	    t.Aacute = 667;
	    t.Adieresis = 667;
	    t.egrave = 444;
	    t.zacute = 389;
	    t.iogonek = 278;
	    t.Oacute = 722;
	    t.oacute = 500;
	    t.amacron = 500;
	    t.sacute = 389;
	    t.idieresis = 278;
	    t.Ocircumflex = 722;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 500;
	    t.twosuperior = 300;
	    t.Odieresis = 722;
	    t.mu = 576;
	    t.igrave = 278;
	    t.ohungarumlaut = 500;
	    t.Eogonek = 667;
	    t.dcroat = 500;
	    t.threequarters = 750;
	    t.Scedilla = 556;
	    t.lcaron = 382;
	    t.Kcommaaccent = 667;
	    t.Lacute = 611;
	    t.trademark = 1000;
	    t.edotaccent = 444;
	    t.Igrave = 389;
	    t.Imacron = 389;
	    t.Lcaron = 611;
	    t.onehalf = 750;
	    t.lessequal = 549;
	    t.ocircumflex = 500;
	    t.ntilde = 556;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 667;
	    t.emacron = 444;
	    t.gbreve = 500;
	    t.onequarter = 750;
	    t.Scaron = 556;
	    t.Scommaaccent = 556;
	    t.Ohungarumlaut = 722;
	    t.degree = 400;
	    t.ograve = 500;
	    t.Ccaron = 667;
	    t.ugrave = 556;
	    t.radical = 549;
	    t.Dcaron = 722;
	    t.rcommaaccent = 389;
	    t.Ntilde = 722;
	    t.otilde = 500;
	    t.Rcommaaccent = 667;
	    t.Lcommaaccent = 611;
	    t.Atilde = 667;
	    t.Aogonek = 667;
	    t.Aring = 667;
	    t.Otilde = 722;
	    t.zdotaccent = 389;
	    t.Ecaron = 667;
	    t.Iogonek = 389;
	    t.kcommaaccent = 500;
	    t.minus = 606;
	    t.Icircumflex = 389;
	    t.ncaron = 556;
	    t.tcommaaccent = 278;
	    t.logicalnot = 606;
	    t.odieresis = 500;
	    t.udieresis = 556;
	    t.notequal = 549;
	    t.gcommaaccent = 500;
	    t.eth = 500;
	    t.zcaron = 389;
	    t.ncommaaccent = 556;
	    t.onesuperior = 300;
	    t.imacron = 278;
	    t.Euro = 500;
	  });
	  t["Times-Italic"] = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 250;
	    t.exclam = 333;
	    t.quotedbl = 420;
	    t.numbersign = 500;
	    t.dollar = 500;
	    t.percent = 833;
	    t.ampersand = 778;
	    t.quoteright = 333;
	    t.parenleft = 333;
	    t.parenright = 333;
	    t.asterisk = 500;
	    t.plus = 675;
	    t.comma = 250;
	    t.hyphen = 333;
	    t.period = 250;
	    t.slash = 278;
	    t.zero = 500;
	    t.one = 500;
	    t.two = 500;
	    t.three = 500;
	    t.four = 500;
	    t.five = 500;
	    t.six = 500;
	    t.seven = 500;
	    t.eight = 500;
	    t.nine = 500;
	    t.colon = 333;
	    t.semicolon = 333;
	    t.less = 675;
	    t.equal = 675;
	    t.greater = 675;
	    t.question = 500;
	    t.at = 920;
	    t.A = 611;
	    t.B = 611;
	    t.C = 667;
	    t.D = 722;
	    t.E = 611;
	    t.F = 611;
	    t.G = 722;
	    t.H = 722;
	    t.I = 333;
	    t.J = 444;
	    t.K = 667;
	    t.L = 556;
	    t.M = 833;
	    t.N = 667;
	    t.O = 722;
	    t.P = 611;
	    t.Q = 722;
	    t.R = 611;
	    t.S = 500;
	    t.T = 556;
	    t.U = 722;
	    t.V = 611;
	    t.W = 833;
	    t.X = 611;
	    t.Y = 556;
	    t.Z = 556;
	    t.bracketleft = 389;
	    t.backslash = 278;
	    t.bracketright = 389;
	    t.asciicircum = 422;
	    t.underscore = 500;
	    t.quoteleft = 333;
	    t.a = 500;
	    t.b = 500;
	    t.c = 444;
	    t.d = 500;
	    t.e = 444;
	    t.f = 278;
	    t.g = 500;
	    t.h = 500;
	    t.i = 278;
	    t.j = 278;
	    t.k = 444;
	    t.l = 278;
	    t.m = 722;
	    t.n = 500;
	    t.o = 500;
	    t.p = 500;
	    t.q = 500;
	    t.r = 389;
	    t.s = 389;
	    t.t = 278;
	    t.u = 500;
	    t.v = 444;
	    t.w = 667;
	    t.x = 444;
	    t.y = 444;
	    t.z = 389;
	    t.braceleft = 400;
	    t.bar = 275;
	    t.braceright = 400;
	    t.asciitilde = 541;
	    t.exclamdown = 389;
	    t.cent = 500;
	    t.sterling = 500;
	    t.fraction = 167;
	    t.yen = 500;
	    t.florin = 500;
	    t.section = 500;
	    t.currency = 500;
	    t.quotesingle = 214;
	    t.quotedblleft = 556;
	    t.guillemotleft = 500;
	    t.guilsinglleft = 333;
	    t.guilsinglright = 333;
	    t.fi = 500;
	    t.fl = 500;
	    t.endash = 500;
	    t.dagger = 500;
	    t.daggerdbl = 500;
	    t.periodcentered = 250;
	    t.paragraph = 523;
	    t.bullet = 350;
	    t.quotesinglbase = 333;
	    t.quotedblbase = 556;
	    t.quotedblright = 556;
	    t.guillemotright = 500;
	    t.ellipsis = 889;
	    t.perthousand = 1000;
	    t.questiondown = 500;
	    t.grave = 333;
	    t.acute = 333;
	    t.circumflex = 333;
	    t.tilde = 333;
	    t.macron = 333;
	    t.breve = 333;
	    t.dotaccent = 333;
	    t.dieresis = 333;
	    t.ring = 333;
	    t.cedilla = 333;
	    t.hungarumlaut = 333;
	    t.ogonek = 333;
	    t.caron = 333;
	    t.emdash = 889;
	    t.AE = 889;
	    t.ordfeminine = 276;
	    t.Lslash = 556;
	    t.Oslash = 722;
	    t.OE = 944;
	    t.ordmasculine = 310;
	    t.ae = 667;
	    t.dotlessi = 278;
	    t.lslash = 278;
	    t.oslash = 500;
	    t.oe = 667;
	    t.germandbls = 500;
	    t.Idieresis = 333;
	    t.eacute = 444;
	    t.abreve = 500;
	    t.uhungarumlaut = 500;
	    t.ecaron = 444;
	    t.Ydieresis = 556;
	    t.divide = 675;
	    t.Yacute = 556;
	    t.Acircumflex = 611;
	    t.aacute = 500;
	    t.Ucircumflex = 722;
	    t.yacute = 444;
	    t.scommaaccent = 389;
	    t.ecircumflex = 444;
	    t.Uring = 722;
	    t.Udieresis = 722;
	    t.aogonek = 500;
	    t.Uacute = 722;
	    t.uogonek = 500;
	    t.Edieresis = 611;
	    t.Dcroat = 722;
	    t.commaaccent = 250;
	    t.copyright = 760;
	    t.Emacron = 611;
	    t.ccaron = 444;
	    t.aring = 500;
	    t.Ncommaaccent = 667;
	    t.lacute = 278;
	    t.agrave = 500;
	    t.Tcommaaccent = 556;
	    t.Cacute = 667;
	    t.atilde = 500;
	    t.Edotaccent = 611;
	    t.scaron = 389;
	    t.scedilla = 389;
	    t.iacute = 278;
	    t.lozenge = 471;
	    t.Rcaron = 611;
	    t.Gcommaaccent = 722;
	    t.ucircumflex = 500;
	    t.acircumflex = 500;
	    t.Amacron = 611;
	    t.rcaron = 389;
	    t.ccedilla = 444;
	    t.Zdotaccent = 556;
	    t.Thorn = 611;
	    t.Omacron = 722;
	    t.Racute = 611;
	    t.Sacute = 500;
	    t.dcaron = 544;
	    t.Umacron = 722;
	    t.uring = 500;
	    t.threesuperior = 300;
	    t.Ograve = 722;
	    t.Agrave = 611;
	    t.Abreve = 611;
	    t.multiply = 675;
	    t.uacute = 500;
	    t.Tcaron = 556;
	    t.partialdiff = 476;
	    t.ydieresis = 444;
	    t.Nacute = 667;
	    t.icircumflex = 278;
	    t.Ecircumflex = 611;
	    t.adieresis = 500;
	    t.edieresis = 444;
	    t.cacute = 444;
	    t.nacute = 500;
	    t.umacron = 500;
	    t.Ncaron = 667;
	    t.Iacute = 333;
	    t.plusminus = 675;
	    t.brokenbar = 275;
	    t.registered = 760;
	    t.Gbreve = 722;
	    t.Idotaccent = 333;
	    t.summation = 600;
	    t.Egrave = 611;
	    t.racute = 389;
	    t.omacron = 500;
	    t.Zacute = 556;
	    t.Zcaron = 556;
	    t.greaterequal = 549;
	    t.Eth = 722;
	    t.Ccedilla = 667;
	    t.lcommaaccent = 278;
	    t.tcaron = 300;
	    t.eogonek = 444;
	    t.Uogonek = 722;
	    t.Aacute = 611;
	    t.Adieresis = 611;
	    t.egrave = 444;
	    t.zacute = 389;
	    t.iogonek = 278;
	    t.Oacute = 722;
	    t.oacute = 500;
	    t.amacron = 500;
	    t.sacute = 389;
	    t.idieresis = 278;
	    t.Ocircumflex = 722;
	    t.Ugrave = 722;
	    t.Delta = 612;
	    t.thorn = 500;
	    t.twosuperior = 300;
	    t.Odieresis = 722;
	    t.mu = 500;
	    t.igrave = 278;
	    t.ohungarumlaut = 500;
	    t.Eogonek = 611;
	    t.dcroat = 500;
	    t.threequarters = 750;
	    t.Scedilla = 500;
	    t.lcaron = 300;
	    t.Kcommaaccent = 667;
	    t.Lacute = 556;
	    t.trademark = 980;
	    t.edotaccent = 444;
	    t.Igrave = 333;
	    t.Imacron = 333;
	    t.Lcaron = 611;
	    t.onehalf = 750;
	    t.lessequal = 549;
	    t.ocircumflex = 500;
	    t.ntilde = 500;
	    t.Uhungarumlaut = 722;
	    t.Eacute = 611;
	    t.emacron = 444;
	    t.gbreve = 500;
	    t.onequarter = 750;
	    t.Scaron = 500;
	    t.Scommaaccent = 500;
	    t.Ohungarumlaut = 722;
	    t.degree = 400;
	    t.ograve = 500;
	    t.Ccaron = 667;
	    t.ugrave = 500;
	    t.radical = 453;
	    t.Dcaron = 722;
	    t.rcommaaccent = 389;
	    t.Ntilde = 667;
	    t.otilde = 500;
	    t.Rcommaaccent = 611;
	    t.Lcommaaccent = 556;
	    t.Atilde = 611;
	    t.Aogonek = 611;
	    t.Aring = 611;
	    t.Otilde = 722;
	    t.zdotaccent = 389;
	    t.Ecaron = 611;
	    t.Iogonek = 333;
	    t.kcommaaccent = 444;
	    t.minus = 675;
	    t.Icircumflex = 333;
	    t.ncaron = 500;
	    t.tcommaaccent = 278;
	    t.logicalnot = 675;
	    t.odieresis = 500;
	    t.udieresis = 500;
	    t.notequal = 549;
	    t.gcommaaccent = 500;
	    t.eth = 500;
	    t.zcaron = 389;
	    t.ncommaaccent = 500;
	    t.onesuperior = 300;
	    t.imacron = 278;
	    t.Euro = 500;
	  });
	  t.ZapfDingbats = (0, _core_utils.getLookupTableFactory)(function (t) {
	    t.space = 278;
	    t.a1 = 974;
	    t.a2 = 961;
	    t.a202 = 974;
	    t.a3 = 980;
	    t.a4 = 719;
	    t.a5 = 789;
	    t.a119 = 790;
	    t.a118 = 791;
	    t.a117 = 690;
	    t.a11 = 960;
	    t.a12 = 939;
	    t.a13 = 549;
	    t.a14 = 855;
	    t.a15 = 911;
	    t.a16 = 933;
	    t.a105 = 911;
	    t.a17 = 945;
	    t.a18 = 974;
	    t.a19 = 755;
	    t.a20 = 846;
	    t.a21 = 762;
	    t.a22 = 761;
	    t.a23 = 571;
	    t.a24 = 677;
	    t.a25 = 763;
	    t.a26 = 760;
	    t.a27 = 759;
	    t.a28 = 754;
	    t.a6 = 494;
	    t.a7 = 552;
	    t.a8 = 537;
	    t.a9 = 577;
	    t.a10 = 692;
	    t.a29 = 786;
	    t.a30 = 788;
	    t.a31 = 788;
	    t.a32 = 790;
	    t.a33 = 793;
	    t.a34 = 794;
	    t.a35 = 816;
	    t.a36 = 823;
	    t.a37 = 789;
	    t.a38 = 841;
	    t.a39 = 823;
	    t.a40 = 833;
	    t.a41 = 816;
	    t.a42 = 831;
	    t.a43 = 923;
	    t.a44 = 744;
	    t.a45 = 723;
	    t.a46 = 749;
	    t.a47 = 790;
	    t.a48 = 792;
	    t.a49 = 695;
	    t.a50 = 776;
	    t.a51 = 768;
	    t.a52 = 792;
	    t.a53 = 759;
	    t.a54 = 707;
	    t.a55 = 708;
	    t.a56 = 682;
	    t.a57 = 701;
	    t.a58 = 826;
	    t.a59 = 815;
	    t.a60 = 789;
	    t.a61 = 789;
	    t.a62 = 707;
	    t.a63 = 687;
	    t.a64 = 696;
	    t.a65 = 689;
	    t.a66 = 786;
	    t.a67 = 787;
	    t.a68 = 713;
	    t.a69 = 791;
	    t.a70 = 785;
	    t.a71 = 791;
	    t.a72 = 873;
	    t.a73 = 761;
	    t.a74 = 762;
	    t.a203 = 762;
	    t.a75 = 759;
	    t.a204 = 759;
	    t.a76 = 892;
	    t.a77 = 892;
	    t.a78 = 788;
	    t.a79 = 784;
	    t.a81 = 438;
	    t.a82 = 138;
	    t.a83 = 277;
	    t.a84 = 415;
	    t.a97 = 392;
	    t.a98 = 392;
	    t.a99 = 668;
	    t.a100 = 668;
	    t.a89 = 390;
	    t.a90 = 390;
	    t.a93 = 317;
	    t.a94 = 317;
	    t.a91 = 276;
	    t.a92 = 276;
	    t.a205 = 509;
	    t.a85 = 509;
	    t.a206 = 410;
	    t.a86 = 410;
	    t.a87 = 234;
	    t.a88 = 234;
	    t.a95 = 334;
	    t.a96 = 334;
	    t.a101 = 732;
	    t.a102 = 544;
	    t.a103 = 544;
	    t.a104 = 910;
	    t.a106 = 667;
	    t.a107 = 760;
	    t.a108 = 760;
	    t.a112 = 776;
	    t.a111 = 595;
	    t.a110 = 694;
	    t.a109 = 626;
	    t.a120 = 788;
	    t.a121 = 788;
	    t.a122 = 788;
	    t.a123 = 788;
	    t.a124 = 788;
	    t.a125 = 788;
	    t.a126 = 788;
	    t.a127 = 788;
	    t.a128 = 788;
	    t.a129 = 788;
	    t.a130 = 788;
	    t.a131 = 788;
	    t.a132 = 788;
	    t.a133 = 788;
	    t.a134 = 788;
	    t.a135 = 788;
	    t.a136 = 788;
	    t.a137 = 788;
	    t.a138 = 788;
	    t.a139 = 788;
	    t.a140 = 788;
	    t.a141 = 788;
	    t.a142 = 788;
	    t.a143 = 788;
	    t.a144 = 788;
	    t.a145 = 788;
	    t.a146 = 788;
	    t.a147 = 788;
	    t.a148 = 788;
	    t.a149 = 788;
	    t.a150 = 788;
	    t.a151 = 788;
	    t.a152 = 788;
	    t.a153 = 788;
	    t.a154 = 788;
	    t.a155 = 788;
	    t.a156 = 788;
	    t.a157 = 788;
	    t.a158 = 788;
	    t.a159 = 788;
	    t.a160 = 894;
	    t.a161 = 838;
	    t.a163 = 1016;
	    t.a164 = 458;
	    t.a196 = 748;
	    t.a165 = 924;
	    t.a192 = 748;
	    t.a166 = 918;
	    t.a167 = 927;
	    t.a168 = 928;
	    t.a169 = 928;
	    t.a170 = 834;
	    t.a171 = 873;
	    t.a172 = 828;
	    t.a173 = 924;
	    t.a162 = 924;
	    t.a174 = 917;
	    t.a175 = 930;
	    t.a176 = 931;
	    t.a177 = 463;
	    t.a178 = 883;
	    t.a179 = 836;
	    t.a193 = 836;
	    t.a180 = 867;
	    t.a199 = 867;
	    t.a181 = 696;
	    t.a200 = 696;
	    t.a182 = 874;
	    t.a201 = 874;
	    t.a183 = 760;
	    t.a184 = 946;
	    t.a197 = 771;
	    t.a185 = 865;
	    t.a194 = 771;
	    t.a198 = 888;
	    t.a186 = 967;
	    t.a195 = 888;
	    t.a187 = 831;
	    t.a188 = 873;
	    t.a189 = 927;
	    t.a190 = 970;
	    t.a191 = 918;
	  });
	});
	exports.getMetrics = getMetrics;
	const getFontBasicMetrics = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t.Courier = {
	    ascent: 629,
	    descent: -157,
	    capHeight: 562,
	    xHeight: -426
	  };
	  t["Courier-Bold"] = {
	    ascent: 629,
	    descent: -157,
	    capHeight: 562,
	    xHeight: 439
	  };
	  t["Courier-Oblique"] = {
	    ascent: 629,
	    descent: -157,
	    capHeight: 562,
	    xHeight: 426
	  };
	  t["Courier-BoldOblique"] = {
	    ascent: 629,
	    descent: -157,
	    capHeight: 562,
	    xHeight: 426
	  };
	  t.Helvetica = {
	    ascent: 718,
	    descent: -207,
	    capHeight: 718,
	    xHeight: 523
	  };
	  t["Helvetica-Bold"] = {
	    ascent: 718,
	    descent: -207,
	    capHeight: 718,
	    xHeight: 532
	  };
	  t["Helvetica-Oblique"] = {
	    ascent: 718,
	    descent: -207,
	    capHeight: 718,
	    xHeight: 523
	  };
	  t["Helvetica-BoldOblique"] = {
	    ascent: 718,
	    descent: -207,
	    capHeight: 718,
	    xHeight: 532
	  };
	  t["Times-Roman"] = {
	    ascent: 683,
	    descent: -217,
	    capHeight: 662,
	    xHeight: 450
	  };
	  t["Times-Bold"] = {
	    ascent: 683,
	    descent: -217,
	    capHeight: 676,
	    xHeight: 461
	  };
	  t["Times-Italic"] = {
	    ascent: 683,
	    descent: -217,
	    capHeight: 653,
	    xHeight: 441
	  };
	  t["Times-BoldItalic"] = {
	    ascent: 683,
	    descent: -217,
	    capHeight: 669,
	    xHeight: 462
	  };
	  t.Symbol = {
	    ascent: Math.NaN,
	    descent: Math.NaN,
	    capHeight: Math.NaN,
	    xHeight: Math.NaN
	  };
	  t.ZapfDingbats = {
	    ascent: Math.NaN,
	    descent: Math.NaN,
	    capHeight: Math.NaN,
	    xHeight: Math.NaN
	  };
	});
	exports.getFontBasicMetrics = getFontBasicMetrics;

	/***/ }),
	/* 46 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.GlyfTable = void 0;
	const ON_CURVE_POINT = 1 << 0;
	const X_SHORT_VECTOR = 1 << 1;
	const Y_SHORT_VECTOR = 1 << 2;
	const REPEAT_FLAG = 1 << 3;
	const X_IS_SAME_OR_POSITIVE_X_SHORT_VECTOR = 1 << 4;
	const Y_IS_SAME_OR_POSITIVE_Y_SHORT_VECTOR = 1 << 5;
	const OVERLAP_SIMPLE = 1 << 6;
	const ARG_1_AND_2_ARE_WORDS = 1 << 0;
	const ARGS_ARE_XY_VALUES = 1 << 1;
	const WE_HAVE_A_SCALE = 1 << 3;
	const MORE_COMPONENTS = 1 << 5;
	const WE_HAVE_AN_X_AND_Y_SCALE = 1 << 6;
	const WE_HAVE_A_TWO_BY_TWO = 1 << 7;
	const WE_HAVE_INSTRUCTIONS = 1 << 8;

	class GlyfTable {
	  constructor({
	    glyfTable,
	    isGlyphLocationsLong,
	    locaTable,
	    numGlyphs
	  }) {
	    this.glyphs = [];
	    const loca = new DataView(locaTable.buffer, locaTable.byteOffset, locaTable.byteLength);
	    const glyf = new DataView(glyfTable.buffer, glyfTable.byteOffset, glyfTable.byteLength);
	    const offsetSize = isGlyphLocationsLong ? 4 : 2;
	    let prev = isGlyphLocationsLong ? loca.getUint32(0) : 2 * loca.getUint16(0);
	    let pos = 0;

	    for (let i = 0; i < numGlyphs; i++) {
	      pos += offsetSize;
	      const next = isGlyphLocationsLong ? loca.getUint32(pos) : 2 * loca.getUint16(pos);

	      if (next === prev) {
	        this.glyphs.push(new Glyph({}));
	        continue;
	      }

	      const glyph = Glyph.parse(prev, glyf);
	      this.glyphs.push(glyph);
	      prev = next;
	    }
	  }

	  getSize() {
	    return this.glyphs.reduce((a, g) => {
	      const size = g.getSize();
	      return a + (size + 3 & ~3);
	    }, 0);
	  }

	  write() {
	    const totalSize = this.getSize();
	    const glyfTable = new DataView(new ArrayBuffer(totalSize));
	    const isLocationLong = totalSize > 0x1fffe;
	    const offsetSize = isLocationLong ? 4 : 2;
	    const locaTable = new DataView(new ArrayBuffer((this.glyphs.length + 1) * offsetSize));

	    if (isLocationLong) {
	      locaTable.setUint32(0, 0);
	    } else {
	      locaTable.setUint16(0, 0);
	    }

	    let pos = 0;
	    let locaIndex = 0;

	    for (const glyph of this.glyphs) {
	      pos += glyph.write(pos, glyfTable);
	      pos = pos + 3 & ~3;
	      locaIndex += offsetSize;

	      if (isLocationLong) {
	        locaTable.setUint32(locaIndex, pos);
	      } else {
	        locaTable.setUint16(locaIndex, pos >> 1);
	      }
	    }

	    return {
	      isLocationLong,
	      loca: new Uint8Array(locaTable.buffer),
	      glyf: new Uint8Array(glyfTable.buffer)
	    };
	  }

	  scale(factors) {
	    for (let i = 0, ii = this.glyphs.length; i < ii; i++) {
	      this.glyphs[i].scale(factors[i]);
	    }
	  }

	}

	exports.GlyfTable = GlyfTable;

	class Glyph {
	  constructor({
	    header = null,
	    simple = null,
	    composites = null
	  }) {
	    this.header = header;
	    this.simple = simple;
	    this.composites = composites;
	  }

	  static parse(pos, glyf) {
	    const [read, header] = GlyphHeader.parse(pos, glyf);
	    pos += read;

	    if (header.numberOfContours < 0) {
	      const composites = [];

	      while (true) {
	        const [n, composite] = CompositeGlyph.parse(pos, glyf);
	        pos += n;
	        composites.push(composite);

	        if (!(composite.flags & MORE_COMPONENTS)) {
	          break;
	        }
	      }

	      return new Glyph({
	        header,
	        composites
	      });
	    }

	    const simple = SimpleGlyph.parse(pos, glyf, header.numberOfContours);
	    return new Glyph({
	      header,
	      simple
	    });
	  }

	  getSize() {
	    if (!this.header) {
	      return 0;
	    }

	    const size = this.simple ? this.simple.getSize() : this.composites.reduce((a, c) => a + c.getSize(), 0);
	    return this.header.getSize() + size;
	  }

	  write(pos, buf) {
	    if (!this.header) {
	      return 0;
	    }

	    const spos = pos;
	    pos += this.header.write(pos, buf);

	    if (this.simple) {
	      pos += this.simple.write(pos, buf);
	    } else {
	      for (const composite of this.composites) {
	        pos += composite.write(pos, buf);
	      }
	    }

	    return pos - spos;
	  }

	  scale(factor) {
	    if (!this.header) {
	      return;
	    }

	    const xMiddle = (this.header.xMin + this.header.xMax) / 2;
	    this.header.scale(xMiddle, factor);

	    if (this.simple) {
	      this.simple.scale(xMiddle, factor);
	    } else {
	      for (const composite of this.composites) {
	        composite.scale(xMiddle, factor);
	      }
	    }
	  }

	}

	class GlyphHeader {
	  constructor({
	    numberOfContours,
	    xMin,
	    yMin,
	    xMax,
	    yMax
	  }) {
	    this.numberOfContours = numberOfContours;
	    this.xMin = xMin;
	    this.yMin = yMin;
	    this.xMax = xMax;
	    this.yMax = yMax;
	  }

	  static parse(pos, glyf) {
	    return [10, new GlyphHeader({
	      numberOfContours: glyf.getInt16(pos),
	      xMin: glyf.getInt16(pos + 2),
	      yMin: glyf.getInt16(pos + 4),
	      xMax: glyf.getInt16(pos + 6),
	      yMax: glyf.getInt16(pos + 8)
	    })];
	  }

	  getSize() {
	    return 10;
	  }

	  write(pos, buf) {
	    buf.setInt16(pos, this.numberOfContours);
	    buf.setInt16(pos + 2, this.xMin);
	    buf.setInt16(pos + 4, this.yMin);
	    buf.setInt16(pos + 6, this.xMax);
	    buf.setInt16(pos + 8, this.yMax);
	    return 10;
	  }

	  scale(x, factor) {
	    this.xMin = Math.round(x + (this.xMin - x) * factor);
	    this.xMax = Math.round(x + (this.xMax - x) * factor);
	  }

	}

	class Contour {
	  constructor({
	    flags,
	    xCoordinates,
	    yCoordinates
	  }) {
	    this.xCoordinates = xCoordinates;
	    this.yCoordinates = yCoordinates;
	    this.flags = flags;
	  }

	}

	class SimpleGlyph {
	  constructor({
	    contours,
	    instructions
	  }) {
	    this.contours = contours;
	    this.instructions = instructions;
	  }

	  static parse(pos, glyf, numberOfContours) {
	    const endPtsOfContours = [];

	    for (let i = 0; i < numberOfContours; i++) {
	      const endPt = glyf.getUint16(pos);
	      pos += 2;
	      endPtsOfContours.push(endPt);
	    }

	    const numberOfPt = endPtsOfContours[numberOfContours - 1] + 1;
	    const instructionLength = glyf.getUint16(pos);
	    pos += 2;
	    const instructions = new Uint8Array(glyf).slice(pos, pos + instructionLength);
	    pos += instructionLength;
	    const flags = [];

	    for (let i = 0; i < numberOfPt; pos++, i++) {
	      let flag = glyf.getUint8(pos);
	      flags.push(flag);

	      if (flag & REPEAT_FLAG) {
	        const count = glyf.getUint8(++pos);
	        flag ^= REPEAT_FLAG;

	        for (let m = 0; m < count; m++) {
	          flags.push(flag);
	        }

	        i += count;
	      }
	    }

	    const allXCoordinates = [];
	    let xCoordinates = [];
	    let yCoordinates = [];
	    let pointFlags = [];
	    const contours = [];
	    let endPtsOfContoursIndex = 0;
	    let lastCoordinate = 0;

	    for (let i = 0; i < numberOfPt; i++) {
	      const flag = flags[i];

	      if (flag & X_SHORT_VECTOR) {
	        const x = glyf.getUint8(pos++);
	        lastCoordinate += flag & X_IS_SAME_OR_POSITIVE_X_SHORT_VECTOR ? x : -x;
	        xCoordinates.push(lastCoordinate);
	      } else if (flag & X_IS_SAME_OR_POSITIVE_X_SHORT_VECTOR) {
	        xCoordinates.push(lastCoordinate);
	      } else {
	        lastCoordinate += glyf.getInt16(pos);
	        pos += 2;
	        xCoordinates.push(lastCoordinate);
	      }

	      if (endPtsOfContours[endPtsOfContoursIndex] === i) {
	        endPtsOfContoursIndex++;
	        allXCoordinates.push(xCoordinates);
	        xCoordinates = [];
	      }
	    }

	    lastCoordinate = 0;
	    endPtsOfContoursIndex = 0;

	    for (let i = 0; i < numberOfPt; i++) {
	      const flag = flags[i];

	      if (flag & Y_SHORT_VECTOR) {
	        const y = glyf.getUint8(pos++);
	        lastCoordinate += flag & Y_IS_SAME_OR_POSITIVE_Y_SHORT_VECTOR ? y : -y;
	        yCoordinates.push(lastCoordinate);
	      } else if (flag & Y_IS_SAME_OR_POSITIVE_Y_SHORT_VECTOR) {
	        yCoordinates.push(lastCoordinate);
	      } else {
	        lastCoordinate += glyf.getInt16(pos);
	        pos += 2;
	        yCoordinates.push(lastCoordinate);
	      }

	      pointFlags.push(flag & ON_CURVE_POINT | flag & OVERLAP_SIMPLE);

	      if (endPtsOfContours[endPtsOfContoursIndex] === i) {
	        xCoordinates = allXCoordinates[endPtsOfContoursIndex];
	        endPtsOfContoursIndex++;
	        contours.push(new Contour({
	          flags: pointFlags,
	          xCoordinates,
	          yCoordinates
	        }));
	        yCoordinates = [];
	        pointFlags = [];
	      }
	    }

	    return new SimpleGlyph({
	      contours,
	      instructions
	    });
	  }

	  getSize() {
	    let size = this.contours.length * 2 + 2 + this.instructions.length;
	    let lastX = 0;
	    let lastY = 0;

	    for (const contour of this.contours) {
	      size += contour.flags.length;

	      for (let i = 0, ii = contour.xCoordinates.length; i < ii; i++) {
	        const x = contour.xCoordinates[i];
	        const y = contour.yCoordinates[i];
	        let abs = Math.abs(x - lastX);

	        if (abs > 255) {
	          size += 2;
	        } else if (abs > 0) {
	          size += 1;
	        }

	        lastX = x;
	        abs = Math.abs(y - lastY);

	        if (abs > 255) {
	          size += 2;
	        } else if (abs > 0) {
	          size += 1;
	        }

	        lastY = y;
	      }
	    }

	    return size;
	  }

	  write(pos, buf) {
	    const spos = pos;
	    const xCoordinates = [];
	    const yCoordinates = [];
	    const flags = [];
	    let lastX = 0;
	    let lastY = 0;

	    for (const contour of this.contours) {
	      for (let i = 0, ii = contour.xCoordinates.length; i < ii; i++) {
	        let flag = contour.flags[i];
	        const x = contour.xCoordinates[i];
	        let delta = x - lastX;

	        if (delta === 0) {
	          flag |= X_IS_SAME_OR_POSITIVE_X_SHORT_VECTOR;
	          xCoordinates.push(0);
	        } else {
	          const abs = Math.abs(delta);

	          if (abs <= 255) {
	            flag |= delta >= 0 ? X_SHORT_VECTOR | X_IS_SAME_OR_POSITIVE_X_SHORT_VECTOR : X_SHORT_VECTOR;
	            xCoordinates.push(abs);
	          } else {
	            xCoordinates.push(delta);
	          }
	        }

	        lastX = x;
	        const y = contour.yCoordinates[i];
	        delta = y - lastY;

	        if (delta === 0) {
	          flag |= Y_IS_SAME_OR_POSITIVE_Y_SHORT_VECTOR;
	          yCoordinates.push(0);
	        } else {
	          const abs = Math.abs(delta);

	          if (abs <= 255) {
	            flag |= delta >= 0 ? Y_SHORT_VECTOR | Y_IS_SAME_OR_POSITIVE_Y_SHORT_VECTOR : Y_SHORT_VECTOR;
	            yCoordinates.push(abs);
	          } else {
	            yCoordinates.push(delta);
	          }
	        }

	        lastY = y;
	        flags.push(flag);
	      }

	      buf.setUint16(pos, xCoordinates.length - 1);
	      pos += 2;
	    }

	    buf.setUint16(pos, this.instructions.length);
	    pos += 2;

	    if (this.instructions.length) {
	      new Uint8Array(buf.buffer, 0, buf.buffer.byteLength).set(this.instructions, pos);
	      pos += this.instructions.length;
	    }

	    for (const flag of flags) {
	      buf.setUint8(pos++, flag);
	    }

	    for (let i = 0, ii = xCoordinates.length; i < ii; i++) {
	      const x = xCoordinates[i];
	      const flag = flags[i];

	      if (flag & X_SHORT_VECTOR) {
	        buf.setUint8(pos++, x);
	      } else if (!(flag & X_IS_SAME_OR_POSITIVE_X_SHORT_VECTOR)) {
	        buf.setInt16(pos, x);
	        pos += 2;
	      }
	    }

	    for (let i = 0, ii = yCoordinates.length; i < ii; i++) {
	      const y = yCoordinates[i];
	      const flag = flags[i];

	      if (flag & Y_SHORT_VECTOR) {
	        buf.setUint8(pos++, y);
	      } else if (!(flag & Y_IS_SAME_OR_POSITIVE_Y_SHORT_VECTOR)) {
	        buf.setInt16(pos, y);
	        pos += 2;
	      }
	    }

	    return pos - spos;
	  }

	  scale(x, factor) {
	    for (const contour of this.contours) {
	      if (contour.xCoordinates.length === 0) {
	        continue;
	      }

	      for (let i = 0, ii = contour.xCoordinates.length; i < ii; i++) {
	        contour.xCoordinates[i] = Math.round(x + (contour.xCoordinates[i] - x) * factor);
	      }
	    }
	  }

	}

	class CompositeGlyph {
	  constructor({
	    flags,
	    glyphIndex,
	    argument1,
	    argument2,
	    transf,
	    instructions
	  }) {
	    this.flags = flags;
	    this.glyphIndex = glyphIndex;
	    this.argument1 = argument1;
	    this.argument2 = argument2;
	    this.transf = transf;
	    this.instructions = instructions;
	  }

	  static parse(pos, glyf) {
	    const spos = pos;
	    const transf = [];
	    let flags = glyf.getUint16(pos);
	    const glyphIndex = glyf.getUint16(pos + 2);
	    pos += 4;
	    let argument1, argument2;

	    if (flags & ARG_1_AND_2_ARE_WORDS) {
	      if (flags & ARGS_ARE_XY_VALUES) {
	        argument1 = glyf.getInt16(pos);
	        argument2 = glyf.getInt16(pos + 2);
	      } else {
	        argument1 = glyf.getUint16(pos);
	        argument2 = glyf.getUint16(pos + 2);
	      }

	      pos += 4;
	      flags ^= ARG_1_AND_2_ARE_WORDS;
	    } else {
	      if (flags & ARGS_ARE_XY_VALUES) {
	        argument1 = glyf.getInt8(pos);
	        argument2 = glyf.getInt8(pos + 1);
	      } else {
	        argument1 = glyf.getUint8(pos);
	        argument2 = glyf.getUint8(pos + 1);
	      }

	      pos += 2;
	    }

	    if (flags & WE_HAVE_A_SCALE) {
	      transf.push(glyf.getUint16(pos));
	      pos += 2;
	    } else if (flags & WE_HAVE_AN_X_AND_Y_SCALE) {
	      transf.push(glyf.getUint16(pos), glyf.getUint16(pos + 2));
	      pos += 4;
	    } else if (flags & WE_HAVE_A_TWO_BY_TWO) {
	      transf.push(glyf.getUint16(pos), glyf.getUint16(pos + 2), glyf.getUint16(pos + 4), glyf.getUint16(pos + 6));
	      pos += 8;
	    }

	    let instructions = null;

	    if (flags & WE_HAVE_INSTRUCTIONS) {
	      const instructionLength = glyf.getUint16(pos);
	      pos += 2;
	      instructions = new Uint8Array(glyf).slice(pos, pos + instructionLength);
	      pos += instructionLength;
	    }

	    return [pos - spos, new CompositeGlyph({
	      flags,
	      glyphIndex,
	      argument1,
	      argument2,
	      transf,
	      instructions
	    })];
	  }

	  getSize() {
	    let size = 2 + 2 + this.transf.length * 2;

	    if (this.flags & WE_HAVE_INSTRUCTIONS) {
	      size += 2 + this.instructions.length;
	    }

	    size += 2;

	    if (this.flags & 2) {
	      if (!(this.argument1 >= -128 && this.argument1 <= 127 && this.argument2 >= -128 && this.argument2 <= 127)) {
	        size += 2;
	      }
	    } else {
	      if (!(this.argument1 >= 0 && this.argument1 <= 255 && this.argument2 >= 0 && this.argument2 <= 255)) {
	        size += 2;
	      }
	    }

	    return size;
	  }

	  write(pos, buf) {
	    const spos = pos;

	    if (this.flags & ARGS_ARE_XY_VALUES) {
	      if (!(this.argument1 >= -128 && this.argument1 <= 127 && this.argument2 >= -128 && this.argument2 <= 127)) {
	        this.flags |= ARG_1_AND_2_ARE_WORDS;
	      }
	    } else {
	      if (!(this.argument1 >= 0 && this.argument1 <= 255 && this.argument2 >= 0 && this.argument2 <= 255)) {
	        this.flags |= ARG_1_AND_2_ARE_WORDS;
	      }
	    }

	    buf.setUint16(pos, this.flags);
	    buf.setUint16(pos + 2, this.glyphIndex);
	    pos += 4;

	    if (this.flags & ARG_1_AND_2_ARE_WORDS) {
	      if (this.flags & ARGS_ARE_XY_VALUES) {
	        buf.setInt16(pos, this.argument1);
	        buf.setInt16(pos + 2, this.argument2);
	      } else {
	        buf.setUint16(pos, this.argument1);
	        buf.setUint16(pos + 2, this.argument2);
	      }

	      pos += 4;
	    } else {
	      buf.setUint8(pos, this.argument1);
	      buf.setUint8(pos + 1, this.argument2);
	      pos += 2;
	    }

	    if (this.flags & WE_HAVE_INSTRUCTIONS) {
	      buf.setUint16(pos, this.instructions.length);
	      pos += 2;

	      if (this.instructions.length) {
	        new Uint8Array(buf.buffer, 0, buf.buffer.byteLength).set(this.instructions, pos);
	        pos += this.instructions.length;
	      }
	    }

	    return pos - spos;
	  }

	  scale(x, factor) {}

	}

	/***/ }),
	/* 47 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.OpenTypeFileBuilder = void 0;

	var _core_utils = __w_pdfjs_require__(6);

	var _util = __w_pdfjs_require__(2);

	function writeInt16(dest, offset, num) {
	  dest[offset] = num >> 8 & 0xff;
	  dest[offset + 1] = num & 0xff;
	}

	function writeInt32(dest, offset, num) {
	  dest[offset] = num >> 24 & 0xff;
	  dest[offset + 1] = num >> 16 & 0xff;
	  dest[offset + 2] = num >> 8 & 0xff;
	  dest[offset + 3] = num & 0xff;
	}

	function writeData(dest, offset, data) {
	  if (data instanceof Uint8Array) {
	    dest.set(data, offset);
	  } else if (typeof data === "string") {
	    for (let i = 0, ii = data.length; i < ii; i++) {
	      dest[offset++] = data.charCodeAt(i) & 0xff;
	    }
	  } else {
	    for (let i = 0, ii = data.length; i < ii; i++) {
	      dest[offset++] = data[i] & 0xff;
	    }
	  }
	}

	const OTF_HEADER_SIZE = 12;
	const OTF_TABLE_ENTRY_SIZE = 16;

	class OpenTypeFileBuilder {
	  constructor(sfnt) {
	    this.sfnt = sfnt;
	    this.tables = Object.create(null);
	  }

	  static getSearchParams(entriesCount, entrySize) {
	    let maxPower2 = 1,
	        log2 = 0;

	    while ((maxPower2 ^ entriesCount) > maxPower2) {
	      maxPower2 <<= 1;
	      log2++;
	    }

	    const searchRange = maxPower2 * entrySize;
	    return {
	      range: searchRange,
	      entry: log2,
	      rangeShift: entrySize * entriesCount - searchRange
	    };
	  }

	  toArray() {
	    let sfnt = this.sfnt;
	    const tables = this.tables;
	    const tablesNames = Object.keys(tables);
	    tablesNames.sort();
	    const numTables = tablesNames.length;
	    let i, j, jj, table, tableName;
	    let offset = OTF_HEADER_SIZE + numTables * OTF_TABLE_ENTRY_SIZE;
	    const tableOffsets = [offset];

	    for (i = 0; i < numTables; i++) {
	      table = tables[tablesNames[i]];
	      const paddedLength = (table.length + 3 & ~3) >>> 0;
	      offset += paddedLength;
	      tableOffsets.push(offset);
	    }

	    const file = new Uint8Array(offset);

	    for (i = 0; i < numTables; i++) {
	      table = tables[tablesNames[i]];
	      writeData(file, tableOffsets[i], table);
	    }

	    if (sfnt === "true") {
	      sfnt = (0, _util.string32)(0x00010000);
	    }

	    file[0] = sfnt.charCodeAt(0) & 0xff;
	    file[1] = sfnt.charCodeAt(1) & 0xff;
	    file[2] = sfnt.charCodeAt(2) & 0xff;
	    file[3] = sfnt.charCodeAt(3) & 0xff;
	    writeInt16(file, 4, numTables);
	    const searchParams = OpenTypeFileBuilder.getSearchParams(numTables, 16);
	    writeInt16(file, 6, searchParams.range);
	    writeInt16(file, 8, searchParams.entry);
	    writeInt16(file, 10, searchParams.rangeShift);
	    offset = OTF_HEADER_SIZE;

	    for (i = 0; i < numTables; i++) {
	      tableName = tablesNames[i];
	      file[offset] = tableName.charCodeAt(0) & 0xff;
	      file[offset + 1] = tableName.charCodeAt(1) & 0xff;
	      file[offset + 2] = tableName.charCodeAt(2) & 0xff;
	      file[offset + 3] = tableName.charCodeAt(3) & 0xff;
	      let checksum = 0;

	      for (j = tableOffsets[i], jj = tableOffsets[i + 1]; j < jj; j += 4) {
	        const quad = (0, _core_utils.readUint32)(file, j);
	        checksum = checksum + quad >>> 0;
	      }

	      writeInt32(file, offset + 4, checksum);
	      writeInt32(file, offset + 8, tableOffsets[i]);
	      writeInt32(file, offset + 12, tables[tableName].length);
	      offset += OTF_TABLE_ENTRY_SIZE;
	    }

	    return file;
	  }

	  addTable(tag, data) {
	    if (tag in this.tables) {
	      throw new Error("Table " + tag + " already exists");
	    }

	    this.tables[tag] = data;
	  }

	}

	exports.OpenTypeFileBuilder = OpenTypeFileBuilder;

	/***/ }),
	/* 48 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Type1Font = void 0;

	var _cff_parser = __w_pdfjs_require__(35);

	var _fonts_utils = __w_pdfjs_require__(38);

	var _core_utils = __w_pdfjs_require__(6);

	var _stream = __w_pdfjs_require__(10);

	var _type1_parser = __w_pdfjs_require__(49);

	var _util = __w_pdfjs_require__(2);

	function findBlock(streamBytes, signature, startIndex) {
	  const streamBytesLength = streamBytes.length;
	  const signatureLength = signature.length;
	  const scanLength = streamBytesLength - signatureLength;
	  let i = startIndex,
	      found = false;

	  while (i < scanLength) {
	    let j = 0;

	    while (j < signatureLength && streamBytes[i + j] === signature[j]) {
	      j++;
	    }

	    if (j >= signatureLength) {
	      i += j;

	      while (i < streamBytesLength && (0, _core_utils.isWhiteSpace)(streamBytes[i])) {
	        i++;
	      }

	      found = true;
	      break;
	    }

	    i++;
	  }

	  return {
	    found,
	    length: i
	  };
	}

	function getHeaderBlock(stream, suggestedLength) {
	  const EEXEC_SIGNATURE = [0x65, 0x65, 0x78, 0x65, 0x63];
	  const streamStartPos = stream.pos;
	  let headerBytes, headerBytesLength, block;

	  try {
	    headerBytes = stream.getBytes(suggestedLength);
	    headerBytesLength = headerBytes.length;
	  } catch (ex) {}

	  if (headerBytesLength === suggestedLength) {
	    block = findBlock(headerBytes, EEXEC_SIGNATURE, suggestedLength - 2 * EEXEC_SIGNATURE.length);

	    if (block.found && block.length === suggestedLength) {
	      return {
	        stream: new _stream.Stream(headerBytes),
	        length: suggestedLength
	      };
	    }
	  }

	  (0, _util.warn)('Invalid "Length1" property in Type1 font -- trying to recover.');
	  stream.pos = streamStartPos;
	  const SCAN_BLOCK_LENGTH = 2048;
	  let actualLength;

	  while (true) {
	    const scanBytes = stream.peekBytes(SCAN_BLOCK_LENGTH);
	    block = findBlock(scanBytes, EEXEC_SIGNATURE, 0);

	    if (block.length === 0) {
	      break;
	    }

	    stream.pos += block.length;

	    if (block.found) {
	      actualLength = stream.pos - streamStartPos;
	      break;
	    }
	  }

	  stream.pos = streamStartPos;

	  if (actualLength) {
	    return {
	      stream: new _stream.Stream(stream.getBytes(actualLength)),
	      length: actualLength
	    };
	  }

	  (0, _util.warn)('Unable to recover "Length1" property in Type1 font -- using as is.');
	  return {
	    stream: new _stream.Stream(stream.getBytes(suggestedLength)),
	    length: suggestedLength
	  };
	}

	function getEexecBlock(stream, suggestedLength) {
	  const eexecBytes = stream.getBytes();
	  return {
	    stream: new _stream.Stream(eexecBytes),
	    length: eexecBytes.length
	  };
	}

	class Type1Font {
	  constructor(name, file, properties) {
	    const PFB_HEADER_SIZE = 6;
	    let headerBlockLength = properties.length1;
	    properties.length2;
	    let pfbHeader = file.peekBytes(PFB_HEADER_SIZE);
	    const pfbHeaderPresent = pfbHeader[0] === 0x80 && pfbHeader[1] === 0x01;

	    if (pfbHeaderPresent) {
	      file.skip(PFB_HEADER_SIZE);
	      headerBlockLength = pfbHeader[5] << 24 | pfbHeader[4] << 16 | pfbHeader[3] << 8 | pfbHeader[2];
	    }

	    const headerBlock = getHeaderBlock(file, headerBlockLength);
	    const headerBlockParser = new _type1_parser.Type1Parser(headerBlock.stream, false, _fonts_utils.SEAC_ANALYSIS_ENABLED);
	    headerBlockParser.extractFontHeader(properties);

	    if (pfbHeaderPresent) {
	      pfbHeader = file.getBytes(PFB_HEADER_SIZE);
	      pfbHeader[5] << 24 | pfbHeader[4] << 16 | pfbHeader[3] << 8 | pfbHeader[2];
	    }

	    const eexecBlock = getEexecBlock(file);
	    const eexecBlockParser = new _type1_parser.Type1Parser(eexecBlock.stream, true, _fonts_utils.SEAC_ANALYSIS_ENABLED);
	    const data = eexecBlockParser.extractFontProgram(properties);

	    for (const key in data.properties) {
	      properties[key] = data.properties[key];
	    }

	    const charstrings = data.charstrings;
	    const type2Charstrings = this.getType2Charstrings(charstrings);
	    const subrs = this.getType2Subrs(data.subrs);
	    this.charstrings = charstrings;
	    this.data = this.wrap(name, type2Charstrings, this.charstrings, subrs, properties);
	    this.seacs = this.getSeacs(data.charstrings);
	  }

	  get numGlyphs() {
	    return this.charstrings.length + 1;
	  }

	  getCharset() {
	    const charset = [".notdef"];

	    for (const {
	      glyphName
	    } of this.charstrings) {
	      charset.push(glyphName);
	    }

	    return charset;
	  }

	  getGlyphMapping(properties) {
	    const charstrings = this.charstrings;

	    if (properties.composite) {
	      const charCodeToGlyphId = Object.create(null);

	      for (let glyphId = 0, charstringsLen = charstrings.length; glyphId < charstringsLen; glyphId++) {
	        const charCode = properties.cMap.charCodeOf(glyphId);
	        charCodeToGlyphId[charCode] = glyphId + 1;
	      }

	      return charCodeToGlyphId;
	    }

	    const glyphNames = [".notdef"];
	    let builtInEncoding, glyphId;

	    for (glyphId = 0; glyphId < charstrings.length; glyphId++) {
	      glyphNames.push(charstrings[glyphId].glyphName);
	    }

	    const encoding = properties.builtInEncoding;

	    if (encoding) {
	      builtInEncoding = Object.create(null);

	      for (const charCode in encoding) {
	        glyphId = glyphNames.indexOf(encoding[charCode]);

	        if (glyphId >= 0) {
	          builtInEncoding[charCode] = glyphId;
	        }
	      }
	    }

	    return (0, _fonts_utils.type1FontGlyphMapping)(properties, builtInEncoding, glyphNames);
	  }

	  hasGlyphId(id) {
	    if (id < 0 || id >= this.numGlyphs) {
	      return false;
	    }

	    if (id === 0) {
	      return true;
	    }

	    const glyph = this.charstrings[id - 1];
	    return glyph.charstring.length > 0;
	  }

	  getSeacs(charstrings) {
	    const seacMap = [];

	    for (let i = 0, ii = charstrings.length; i < ii; i++) {
	      const charstring = charstrings[i];

	      if (charstring.seac) {
	        seacMap[i + 1] = charstring.seac;
	      }
	    }

	    return seacMap;
	  }

	  getType2Charstrings(type1Charstrings) {
	    const type2Charstrings = [];

	    for (let i = 0, ii = type1Charstrings.length; i < ii; i++) {
	      type2Charstrings.push(type1Charstrings[i].charstring);
	    }

	    return type2Charstrings;
	  }

	  getType2Subrs(type1Subrs) {
	    let bias = 0;
	    const count = type1Subrs.length;

	    if (count < 1133) {
	      bias = 107;
	    } else if (count < 33769) {
	      bias = 1131;
	    } else {
	      bias = 32768;
	    }

	    const type2Subrs = [];
	    let i;

	    for (i = 0; i < bias; i++) {
	      type2Subrs.push([0x0b]);
	    }

	    for (i = 0; i < count; i++) {
	      type2Subrs.push(type1Subrs[i]);
	    }

	    return type2Subrs;
	  }

	  wrap(name, glyphs, charstrings, subrs, properties) {
	    const cff = new _cff_parser.CFF();
	    cff.header = new _cff_parser.CFFHeader(1, 0, 4, 4);
	    cff.names = [name];
	    const topDict = new _cff_parser.CFFTopDict();
	    topDict.setByName("version", 391);
	    topDict.setByName("Notice", 392);
	    topDict.setByName("FullName", 393);
	    topDict.setByName("FamilyName", 394);
	    topDict.setByName("Weight", 395);
	    topDict.setByName("Encoding", null);
	    topDict.setByName("FontMatrix", properties.fontMatrix);
	    topDict.setByName("FontBBox", properties.bbox);
	    topDict.setByName("charset", null);
	    topDict.setByName("CharStrings", null);
	    topDict.setByName("Private", null);
	    cff.topDict = topDict;
	    const strings = new _cff_parser.CFFStrings();
	    strings.add("Version 0.11");
	    strings.add("See original notice");
	    strings.add(name);
	    strings.add(name);
	    strings.add("Medium");
	    cff.strings = strings;
	    cff.globalSubrIndex = new _cff_parser.CFFIndex();
	    const count = glyphs.length;
	    const charsetArray = [".notdef"];
	    let i, ii;

	    for (i = 0; i < count; i++) {
	      const glyphName = charstrings[i].glyphName;

	      const index = _cff_parser.CFFStandardStrings.indexOf(glyphName);

	      if (index === -1) {
	        strings.add(glyphName);
	      }

	      charsetArray.push(glyphName);
	    }

	    cff.charset = new _cff_parser.CFFCharset(false, 0, charsetArray);
	    const charStringsIndex = new _cff_parser.CFFIndex();
	    charStringsIndex.add([0x8b, 0x0e]);

	    for (i = 0; i < count; i++) {
	      charStringsIndex.add(glyphs[i]);
	    }

	    cff.charStrings = charStringsIndex;
	    const privateDict = new _cff_parser.CFFPrivateDict();
	    privateDict.setByName("Subrs", null);
	    const fields = ["BlueValues", "OtherBlues", "FamilyBlues", "FamilyOtherBlues", "StemSnapH", "StemSnapV", "BlueShift", "BlueFuzz", "BlueScale", "LanguageGroup", "ExpansionFactor", "ForceBold", "StdHW", "StdVW"];

	    for (i = 0, ii = fields.length; i < ii; i++) {
	      const field = fields[i];

	      if (!(field in properties.privateData)) {
	        continue;
	      }

	      const value = properties.privateData[field];

	      if (Array.isArray(value)) {
	        for (let j = value.length - 1; j > 0; j--) {
	          value[j] -= value[j - 1];
	        }
	      }

	      privateDict.setByName(field, value);
	    }

	    cff.topDict.privateDict = privateDict;
	    const subrIndex = new _cff_parser.CFFIndex();

	    for (i = 0, ii = subrs.length; i < ii; i++) {
	      subrIndex.add(subrs[i]);
	    }

	    privateDict.subrsIndex = subrIndex;
	    const compiler = new _cff_parser.CFFCompiler(cff);
	    return compiler.compile();
	  }

	}

	exports.Type1Font = Type1Font;

	/***/ }),
	/* 49 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Type1Parser = void 0;

	var _encodings = __w_pdfjs_require__(37);

	var _core_utils = __w_pdfjs_require__(6);

	var _stream = __w_pdfjs_require__(10);

	var _util = __w_pdfjs_require__(2);

	const HINTING_ENABLED = false;
	const COMMAND_MAP = {
	  hstem: [1],
	  vstem: [3],
	  vmoveto: [4],
	  rlineto: [5],
	  hlineto: [6],
	  vlineto: [7],
	  rrcurveto: [8],
	  callsubr: [10],
	  flex: [12, 35],
	  drop: [12, 18],
	  endchar: [14],
	  rmoveto: [21],
	  hmoveto: [22],
	  vhcurveto: [30],
	  hvcurveto: [31]
	};

	class Type1CharString {
	  constructor() {
	    this.width = 0;
	    this.lsb = 0;
	    this.flexing = false;
	    this.output = [];
	    this.stack = [];
	  }

	  convert(encoded, subrs, seacAnalysisEnabled) {
	    const count = encoded.length;
	    let error = false;
	    let wx, sbx, subrNumber;

	    for (let i = 0; i < count; i++) {
	      let value = encoded[i];

	      if (value < 32) {
	        if (value === 12) {
	          value = (value << 8) + encoded[++i];
	        }

	        switch (value) {
	          case 1:
	            {
	              this.stack = [];
	              break;
	            }

	          case 3:
	            {
	              this.stack = [];
	              break;
	            }

	          case 4:
	            if (this.flexing) {
	              if (this.stack.length < 1) {
	                error = true;
	                break;
	              }

	              const dy = this.stack.pop();
	              this.stack.push(0, dy);
	              break;
	            }

	            error = this.executeCommand(1, COMMAND_MAP.vmoveto);
	            break;

	          case 5:
	            error = this.executeCommand(2, COMMAND_MAP.rlineto);
	            break;

	          case 6:
	            error = this.executeCommand(1, COMMAND_MAP.hlineto);
	            break;

	          case 7:
	            error = this.executeCommand(1, COMMAND_MAP.vlineto);
	            break;

	          case 8:
	            error = this.executeCommand(6, COMMAND_MAP.rrcurveto);
	            break;

	          case 9:
	            this.stack = [];
	            break;

	          case 10:
	            if (this.stack.length < 1) {
	              error = true;
	              break;
	            }

	            subrNumber = this.stack.pop();

	            if (!subrs[subrNumber]) {
	              error = true;
	              break;
	            }

	            error = this.convert(subrs[subrNumber], subrs, seacAnalysisEnabled);
	            break;

	          case 11:
	            return error;

	          case 13:
	            if (this.stack.length < 2) {
	              error = true;
	              break;
	            }

	            wx = this.stack.pop();
	            sbx = this.stack.pop();
	            this.lsb = sbx;
	            this.width = wx;
	            this.stack.push(wx, sbx);
	            error = this.executeCommand(2, COMMAND_MAP.hmoveto);
	            break;

	          case 14:
	            this.output.push(COMMAND_MAP.endchar[0]);
	            break;

	          case 21:
	            if (this.flexing) {
	              break;
	            }

	            error = this.executeCommand(2, COMMAND_MAP.rmoveto);
	            break;

	          case 22:
	            if (this.flexing) {
	              this.stack.push(0);
	              break;
	            }

	            error = this.executeCommand(1, COMMAND_MAP.hmoveto);
	            break;

	          case 30:
	            error = this.executeCommand(4, COMMAND_MAP.vhcurveto);
	            break;

	          case 31:
	            error = this.executeCommand(4, COMMAND_MAP.hvcurveto);
	            break;

	          case (12 << 8) + 0:
	            this.stack = [];
	            break;

	          case (12 << 8) + 1:
	            {
	              this.stack = [];
	              break;
	            }

	          case (12 << 8) + 2:
	            {
	              this.stack = [];
	              break;
	            }

	          case (12 << 8) + 6:
	            if (seacAnalysisEnabled) {
	              const asb = this.stack.at(-5);
	              this.seac = this.stack.splice(-4, 4);
	              this.seac[0] += this.lsb - asb;
	              error = this.executeCommand(0, COMMAND_MAP.endchar);
	            } else {
	              error = this.executeCommand(4, COMMAND_MAP.endchar);
	            }

	            break;

	          case (12 << 8) + 7:
	            if (this.stack.length < 4) {
	              error = true;
	              break;
	            }

	            this.stack.pop();
	            wx = this.stack.pop();
	            const sby = this.stack.pop();
	            sbx = this.stack.pop();
	            this.lsb = sbx;
	            this.width = wx;
	            this.stack.push(wx, sbx, sby);
	            error = this.executeCommand(3, COMMAND_MAP.rmoveto);
	            break;

	          case (12 << 8) + 12:
	            if (this.stack.length < 2) {
	              error = true;
	              break;
	            }

	            const num2 = this.stack.pop();
	            const num1 = this.stack.pop();
	            this.stack.push(num1 / num2);
	            break;

	          case (12 << 8) + 16:
	            if (this.stack.length < 2) {
	              error = true;
	              break;
	            }

	            subrNumber = this.stack.pop();
	            const numArgs = this.stack.pop();

	            if (subrNumber === 0 && numArgs === 3) {
	              const flexArgs = this.stack.splice(this.stack.length - 17, 17);
	              this.stack.push(flexArgs[2] + flexArgs[0], flexArgs[3] + flexArgs[1], flexArgs[4], flexArgs[5], flexArgs[6], flexArgs[7], flexArgs[8], flexArgs[9], flexArgs[10], flexArgs[11], flexArgs[12], flexArgs[13], flexArgs[14]);
	              error = this.executeCommand(13, COMMAND_MAP.flex, true);
	              this.flexing = false;
	              this.stack.push(flexArgs[15], flexArgs[16]);
	            } else if (subrNumber === 1 && numArgs === 0) {
	              this.flexing = true;
	            }

	            break;

	          case (12 << 8) + 17:
	            break;

	          case (12 << 8) + 33:
	            this.stack = [];
	            break;

	          default:
	            (0, _util.warn)('Unknown type 1 charstring command of "' + value + '"');
	            break;
	        }

	        if (error) {
	          break;
	        }

	        continue;
	      } else if (value <= 246) {
	        value -= 139;
	      } else if (value <= 250) {
	        value = (value - 247) * 256 + encoded[++i] + 108;
	      } else if (value <= 254) {
	        value = -((value - 251) * 256) - encoded[++i] - 108;
	      } else {
	        value = (encoded[++i] & 0xff) << 24 | (encoded[++i] & 0xff) << 16 | (encoded[++i] & 0xff) << 8 | (encoded[++i] & 0xff) << 0;
	      }

	      this.stack.push(value);
	    }

	    return error;
	  }

	  executeCommand(howManyArgs, command, keepStack) {
	    const stackLength = this.stack.length;

	    if (howManyArgs > stackLength) {
	      return true;
	    }

	    const start = stackLength - howManyArgs;

	    for (let i = start; i < stackLength; i++) {
	      let value = this.stack[i];

	      if (Number.isInteger(value)) {
	        this.output.push(28, value >> 8 & 0xff, value & 0xff);
	      } else {
	        value = 65536 * value | 0;
	        this.output.push(255, value >> 24 & 0xff, value >> 16 & 0xff, value >> 8 & 0xff, value & 0xff);
	      }
	    }

	    this.output.push(...command);

	    if (keepStack) {
	      this.stack.splice(start, howManyArgs);
	    } else {
	      this.stack.length = 0;
	    }

	    return false;
	  }

	}

	const EEXEC_ENCRYPT_KEY = 55665;
	const CHAR_STRS_ENCRYPT_KEY = 4330;

	function isHexDigit(code) {
	  return code >= 48 && code <= 57 || code >= 65 && code <= 70 || code >= 97 && code <= 102;
	}

	function decrypt(data, key, discardNumber) {
	  if (discardNumber >= data.length) {
	    return new Uint8Array(0);
	  }

	  const c1 = 52845,
	        c2 = 22719;
	  let r = key | 0,
	      i,
	      j;

	  for (i = 0; i < discardNumber; i++) {
	    r = (data[i] + r) * c1 + c2 & (1 << 16) - 1;
	  }

	  const count = data.length - discardNumber;
	  const decrypted = new Uint8Array(count);

	  for (i = discardNumber, j = 0; j < count; i++, j++) {
	    const value = data[i];
	    decrypted[j] = value ^ r >> 8;
	    r = (value + r) * c1 + c2 & (1 << 16) - 1;
	  }

	  return decrypted;
	}

	function decryptAscii(data, key, discardNumber) {
	  const c1 = 52845,
	        c2 = 22719;
	  let r = key | 0;
	  const count = data.length,
	        maybeLength = count >>> 1;
	  const decrypted = new Uint8Array(maybeLength);
	  let i, j;

	  for (i = 0, j = 0; i < count; i++) {
	    const digit1 = data[i];

	    if (!isHexDigit(digit1)) {
	      continue;
	    }

	    i++;
	    let digit2;

	    while (i < count && !isHexDigit(digit2 = data[i])) {
	      i++;
	    }

	    if (i < count) {
	      const value = parseInt(String.fromCharCode(digit1, digit2), 16);
	      decrypted[j++] = value ^ r >> 8;
	      r = (value + r) * c1 + c2 & (1 << 16) - 1;
	    }
	  }

	  return decrypted.slice(discardNumber, j);
	}

	function isSpecial(c) {
	  return c === 0x2f || c === 0x5b || c === 0x5d || c === 0x7b || c === 0x7d || c === 0x28 || c === 0x29;
	}

	class Type1Parser {
	  constructor(stream, encrypted, seacAnalysisEnabled) {
	    if (encrypted) {
	      const data = stream.getBytes();
	      const isBinary = !((isHexDigit(data[0]) || (0, _core_utils.isWhiteSpace)(data[0])) && isHexDigit(data[1]) && isHexDigit(data[2]) && isHexDigit(data[3]) && isHexDigit(data[4]) && isHexDigit(data[5]) && isHexDigit(data[6]) && isHexDigit(data[7]));
	      stream = new _stream.Stream(isBinary ? decrypt(data, EEXEC_ENCRYPT_KEY, 4) : decryptAscii(data, EEXEC_ENCRYPT_KEY, 4));
	    }

	    this.seacAnalysisEnabled = !!seacAnalysisEnabled;
	    this.stream = stream;
	    this.nextChar();
	  }

	  readNumberArray() {
	    this.getToken();
	    const array = [];

	    while (true) {
	      const token = this.getToken();

	      if (token === null || token === "]" || token === "}") {
	        break;
	      }

	      array.push(parseFloat(token || 0));
	    }

	    return array;
	  }

	  readNumber() {
	    const token = this.getToken();
	    return parseFloat(token || 0);
	  }

	  readInt() {
	    const token = this.getToken();
	    return parseInt(token || 0, 10) | 0;
	  }

	  readBoolean() {
	    const token = this.getToken();
	    return token === "true" ? 1 : 0;
	  }

	  nextChar() {
	    return this.currentChar = this.stream.getByte();
	  }

	  prevChar() {
	    this.stream.skip(-2);
	    return this.currentChar = this.stream.getByte();
	  }

	  getToken() {
	    let comment = false;
	    let ch = this.currentChar;

	    while (true) {
	      if (ch === -1) {
	        return null;
	      }

	      if (comment) {
	        if (ch === 0x0a || ch === 0x0d) {
	          comment = false;
	        }
	      } else if (ch === 0x25) {
	        comment = true;
	      } else if (!(0, _core_utils.isWhiteSpace)(ch)) {
	        break;
	      }

	      ch = this.nextChar();
	    }

	    if (isSpecial(ch)) {
	      this.nextChar();
	      return String.fromCharCode(ch);
	    }

	    let token = "";

	    do {
	      token += String.fromCharCode(ch);
	      ch = this.nextChar();
	    } while (ch >= 0 && !(0, _core_utils.isWhiteSpace)(ch) && !isSpecial(ch));

	    return token;
	  }

	  readCharStrings(bytes, lenIV) {
	    if (lenIV === -1) {
	      return bytes;
	    }

	    return decrypt(bytes, CHAR_STRS_ENCRYPT_KEY, lenIV);
	  }

	  extractFontProgram(properties) {
	    const stream = this.stream;
	    const subrs = [],
	          charstrings = [];
	    const privateData = Object.create(null);
	    privateData.lenIV = 4;
	    const program = {
	      subrs: [],
	      charstrings: [],
	      properties: {
	        privateData
	      }
	    };
	    let token, length, data, lenIV;

	    while ((token = this.getToken()) !== null) {
	      if (token !== "/") {
	        continue;
	      }

	      token = this.getToken();

	      switch (token) {
	        case "CharStrings":
	          this.getToken();
	          this.getToken();
	          this.getToken();
	          this.getToken();

	          while (true) {
	            token = this.getToken();

	            if (token === null || token === "end") {
	              break;
	            }

	            if (token !== "/") {
	              continue;
	            }

	            const glyph = this.getToken();
	            length = this.readInt();
	            this.getToken();
	            data = length > 0 ? stream.getBytes(length) : new Uint8Array(0);
	            lenIV = program.properties.privateData.lenIV;
	            const encoded = this.readCharStrings(data, lenIV);
	            this.nextChar();
	            token = this.getToken();

	            if (token === "noaccess") {
	              this.getToken();
	            } else if (token === "/") {
	              this.prevChar();
	            }

	            charstrings.push({
	              glyph,
	              encoded
	            });
	          }

	          break;

	        case "Subrs":
	          this.readInt();
	          this.getToken();

	          while (this.getToken() === "dup") {
	            const index = this.readInt();
	            length = this.readInt();
	            this.getToken();
	            data = length > 0 ? stream.getBytes(length) : new Uint8Array(0);
	            lenIV = program.properties.privateData.lenIV;
	            const encoded = this.readCharStrings(data, lenIV);
	            this.nextChar();
	            token = this.getToken();

	            if (token === "noaccess") {
	              this.getToken();
	            }

	            subrs[index] = encoded;
	          }

	          break;

	        case "BlueValues":
	        case "OtherBlues":
	        case "FamilyBlues":
	        case "FamilyOtherBlues":
	          const blueArray = this.readNumberArray();

	          if (blueArray.length > 0 && blueArray.length % 2 === 0 && HINTING_ENABLED) {
	            program.properties.privateData[token] = blueArray;
	          }

	          break;

	        case "StemSnapH":
	        case "StemSnapV":
	          program.properties.privateData[token] = this.readNumberArray();
	          break;

	        case "StdHW":
	        case "StdVW":
	          program.properties.privateData[token] = this.readNumberArray()[0];
	          break;

	        case "BlueShift":
	        case "lenIV":
	        case "BlueFuzz":
	        case "BlueScale":
	        case "LanguageGroup":
	        case "ExpansionFactor":
	          program.properties.privateData[token] = this.readNumber();
	          break;

	        case "ForceBold":
	          program.properties.privateData[token] = this.readBoolean();
	          break;
	      }
	    }

	    for (const {
	      encoded,
	      glyph
	    } of charstrings) {
	      const charString = new Type1CharString();
	      const error = charString.convert(encoded, subrs, this.seacAnalysisEnabled);
	      let output = charString.output;

	      if (error) {
	        output = [14];
	      }

	      const charStringObject = {
	        glyphName: glyph,
	        charstring: output,
	        width: charString.width,
	        lsb: charString.lsb,
	        seac: charString.seac
	      };

	      if (glyph === ".notdef") {
	        program.charstrings.unshift(charStringObject);
	      } else {
	        program.charstrings.push(charStringObject);
	      }

	      if (properties.builtInEncoding) {
	        const index = properties.builtInEncoding.indexOf(glyph);

	        if (index > -1 && properties.widths[index] === undefined && index >= properties.firstChar && index <= properties.lastChar) {
	          properties.widths[index] = charString.width;
	        }
	      }
	    }

	    return program;
	  }

	  extractFontHeader(properties) {
	    let token;

	    while ((token = this.getToken()) !== null) {
	      if (token !== "/") {
	        continue;
	      }

	      token = this.getToken();

	      switch (token) {
	        case "FontMatrix":
	          const matrix = this.readNumberArray();
	          properties.fontMatrix = matrix;
	          break;

	        case "Encoding":
	          const encodingArg = this.getToken();
	          let encoding;

	          if (!/^\d+$/.test(encodingArg)) {
	            encoding = (0, _encodings.getEncoding)(encodingArg);
	          } else {
	            encoding = [];
	            const size = parseInt(encodingArg, 10) | 0;
	            this.getToken();

	            for (let j = 0; j < size; j++) {
	              token = this.getToken();

	              while (token !== "dup" && token !== "def") {
	                token = this.getToken();

	                if (token === null) {
	                  return;
	                }
	              }

	              if (token === "def") {
	                break;
	              }

	              const index = this.readInt();
	              this.getToken();
	              const glyph = this.getToken();
	              encoding[index] = glyph;
	              this.getToken();
	            }
	          }

	          properties.builtInEncoding = encoding;
	          break;

	        case "FontBBox":
	          const fontBBox = this.readNumberArray();
	          properties.ascent = Math.max(fontBBox[3], fontBBox[1]);
	          properties.descent = Math.min(fontBBox[1], fontBBox[3]);
	          properties.ascentScaled = true;
	          break;
	      }
	    }
	  }

	}

	exports.Type1Parser = Type1Parser;

	/***/ }),
	/* 50 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Pattern = void 0;
	exports.getTilingPatternIR = getTilingPatternIR;

	var _util = __w_pdfjs_require__(2);

	var _base_stream = __w_pdfjs_require__(7);

	var _colorspace = __w_pdfjs_require__(14);

	var _core_utils = __w_pdfjs_require__(6);

	const ShadingType = {
	  FUNCTION_BASED: 1,
	  AXIAL: 2,
	  RADIAL: 3,
	  FREE_FORM_MESH: 4,
	  LATTICE_FORM_MESH: 5,
	  COONS_PATCH_MESH: 6,
	  TENSOR_PATCH_MESH: 7
	};

	class Pattern {
	  constructor() {
	    (0, _util.unreachable)("Cannot initialize Pattern.");
	  }

	  static parseShading(shading, xref, res, handler, pdfFunctionFactory, localColorSpaceCache) {
	    const dict = shading instanceof _base_stream.BaseStream ? shading.dict : shading;
	    const type = dict.get("ShadingType");

	    try {
	      switch (type) {
	        case ShadingType.AXIAL:
	        case ShadingType.RADIAL:
	          return new RadialAxialShading(dict, xref, res, pdfFunctionFactory, localColorSpaceCache);

	        case ShadingType.FREE_FORM_MESH:
	        case ShadingType.LATTICE_FORM_MESH:
	        case ShadingType.COONS_PATCH_MESH:
	        case ShadingType.TENSOR_PATCH_MESH:
	          return new MeshShading(shading, xref, res, pdfFunctionFactory, localColorSpaceCache);

	        default:
	          throw new _util.FormatError("Unsupported ShadingType: " + type);
	      }
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      handler.send("UnsupportedFeature", {
	        featureId: _util.UNSUPPORTED_FEATURES.shadingPattern
	      });
	      (0, _util.warn)(ex);
	      return new DummyShading();
	    }
	  }

	}

	exports.Pattern = Pattern;

	class BaseShading {
	  static get SMALL_NUMBER() {
	    return (0, _util.shadow)(this, "SMALL_NUMBER", 1e-6);
	  }

	  constructor() {
	    if (this.constructor === BaseShading) {
	      (0, _util.unreachable)("Cannot initialize BaseShading.");
	    }
	  }

	  getIR() {
	    (0, _util.unreachable)("Abstract method `getIR` called.");
	  }

	}

	class RadialAxialShading extends BaseShading {
	  constructor(dict, xref, resources, pdfFunctionFactory, localColorSpaceCache) {
	    super();
	    this.coordsArr = dict.getArray("Coords");
	    this.shadingType = dict.get("ShadingType");

	    const cs = _colorspace.ColorSpace.parse({
	      cs: dict.getRaw("CS") || dict.getRaw("ColorSpace"),
	      xref,
	      resources,
	      pdfFunctionFactory,
	      localColorSpaceCache
	    });

	    const bbox = dict.getArray("BBox");

	    if (Array.isArray(bbox) && bbox.length === 4) {
	      this.bbox = _util.Util.normalizeRect(bbox);
	    } else {
	      this.bbox = null;
	    }

	    let t0 = 0.0,
	        t1 = 1.0;

	    if (dict.has("Domain")) {
	      const domainArr = dict.getArray("Domain");
	      t0 = domainArr[0];
	      t1 = domainArr[1];
	    }

	    let extendStart = false,
	        extendEnd = false;

	    if (dict.has("Extend")) {
	      const extendArr = dict.getArray("Extend");
	      extendStart = extendArr[0];
	      extendEnd = extendArr[1];
	    }

	    if (this.shadingType === ShadingType.RADIAL && (!extendStart || !extendEnd)) {
	      const [x1, y1, r1, x2, y2, r2] = this.coordsArr;
	      const distance = Math.hypot(x1 - x2, y1 - y2);

	      if (r1 <= r2 + distance && r2 <= r1 + distance) {
	        (0, _util.warn)("Unsupported radial gradient.");
	      }
	    }

	    this.extendStart = extendStart;
	    this.extendEnd = extendEnd;
	    const fnObj = dict.getRaw("Function");
	    const fn = pdfFunctionFactory.createFromArray(fnObj);
	    const NUMBER_OF_SAMPLES = 10;
	    const step = (t1 - t0) / NUMBER_OF_SAMPLES;
	    const colorStops = this.colorStops = [];

	    if (t0 >= t1 || step <= 0) {
	      (0, _util.info)("Bad shading domain.");
	      return;
	    }

	    const color = new Float32Array(cs.numComps),
	          ratio = new Float32Array(1);
	    let rgbColor;

	    for (let i = 0; i <= NUMBER_OF_SAMPLES; i++) {
	      ratio[0] = t0 + i * step;
	      fn(ratio, 0, color, 0);
	      rgbColor = cs.getRgb(color, 0);

	      const cssColor = _util.Util.makeHexColor(rgbColor[0], rgbColor[1], rgbColor[2]);

	      colorStops.push([i / NUMBER_OF_SAMPLES, cssColor]);
	    }

	    let background = "transparent";

	    if (dict.has("Background")) {
	      rgbColor = cs.getRgb(dict.get("Background"), 0);
	      background = _util.Util.makeHexColor(rgbColor[0], rgbColor[1], rgbColor[2]);
	    }

	    if (!extendStart) {
	      colorStops.unshift([0, background]);
	      colorStops[1][0] += BaseShading.SMALL_NUMBER;
	    }

	    if (!extendEnd) {
	      colorStops.at(-1)[0] -= BaseShading.SMALL_NUMBER;
	      colorStops.push([1, background]);
	    }

	    this.colorStops = colorStops;
	  }

	  getIR() {
	    const coordsArr = this.coordsArr;
	    const shadingType = this.shadingType;
	    let type, p0, p1, r0, r1;

	    if (shadingType === ShadingType.AXIAL) {
	      p0 = [coordsArr[0], coordsArr[1]];
	      p1 = [coordsArr[2], coordsArr[3]];
	      r0 = null;
	      r1 = null;
	      type = "axial";
	    } else if (shadingType === ShadingType.RADIAL) {
	      p0 = [coordsArr[0], coordsArr[1]];
	      p1 = [coordsArr[3], coordsArr[4]];
	      r0 = coordsArr[2];
	      r1 = coordsArr[5];
	      type = "radial";
	    } else {
	      (0, _util.unreachable)(`getPattern type unknown: ${shadingType}`);
	    }

	    return ["RadialAxial", type, this.bbox, this.colorStops, p0, p1, r0, r1];
	  }

	}

	class MeshStreamReader {
	  constructor(stream, context) {
	    this.stream = stream;
	    this.context = context;
	    this.buffer = 0;
	    this.bufferLength = 0;
	    const numComps = context.numComps;
	    this.tmpCompsBuf = new Float32Array(numComps);
	    const csNumComps = context.colorSpace.numComps;
	    this.tmpCsCompsBuf = context.colorFn ? new Float32Array(csNumComps) : this.tmpCompsBuf;
	  }

	  get hasData() {
	    if (this.stream.end) {
	      return this.stream.pos < this.stream.end;
	    }

	    if (this.bufferLength > 0) {
	      return true;
	    }

	    const nextByte = this.stream.getByte();

	    if (nextByte < 0) {
	      return false;
	    }

	    this.buffer = nextByte;
	    this.bufferLength = 8;
	    return true;
	  }

	  readBits(n) {
	    let buffer = this.buffer;
	    let bufferLength = this.bufferLength;

	    if (n === 32) {
	      if (bufferLength === 0) {
	        return (this.stream.getByte() << 24 | this.stream.getByte() << 16 | this.stream.getByte() << 8 | this.stream.getByte()) >>> 0;
	      }

	      buffer = buffer << 24 | this.stream.getByte() << 16 | this.stream.getByte() << 8 | this.stream.getByte();
	      const nextByte = this.stream.getByte();
	      this.buffer = nextByte & (1 << bufferLength) - 1;
	      return (buffer << 8 - bufferLength | (nextByte & 0xff) >> bufferLength) >>> 0;
	    }

	    if (n === 8 && bufferLength === 0) {
	      return this.stream.getByte();
	    }

	    while (bufferLength < n) {
	      buffer = buffer << 8 | this.stream.getByte();
	      bufferLength += 8;
	    }

	    bufferLength -= n;
	    this.bufferLength = bufferLength;
	    this.buffer = buffer & (1 << bufferLength) - 1;
	    return buffer >> bufferLength;
	  }

	  align() {
	    this.buffer = 0;
	    this.bufferLength = 0;
	  }

	  readFlag() {
	    return this.readBits(this.context.bitsPerFlag);
	  }

	  readCoordinate() {
	    const bitsPerCoordinate = this.context.bitsPerCoordinate;
	    const xi = this.readBits(bitsPerCoordinate);
	    const yi = this.readBits(bitsPerCoordinate);
	    const decode = this.context.decode;
	    const scale = bitsPerCoordinate < 32 ? 1 / ((1 << bitsPerCoordinate) - 1) : 2.3283064365386963e-10;
	    return [xi * scale * (decode[1] - decode[0]) + decode[0], yi * scale * (decode[3] - decode[2]) + decode[2]];
	  }

	  readComponents() {
	    const numComps = this.context.numComps;
	    const bitsPerComponent = this.context.bitsPerComponent;
	    const scale = bitsPerComponent < 32 ? 1 / ((1 << bitsPerComponent) - 1) : 2.3283064365386963e-10;
	    const decode = this.context.decode;
	    const components = this.tmpCompsBuf;

	    for (let i = 0, j = 4; i < numComps; i++, j += 2) {
	      const ci = this.readBits(bitsPerComponent);
	      components[i] = ci * scale * (decode[j + 1] - decode[j]) + decode[j];
	    }

	    const color = this.tmpCsCompsBuf;

	    if (this.context.colorFn) {
	      this.context.colorFn(components, 0, color, 0);
	    }

	    return this.context.colorSpace.getRgb(color, 0);
	  }

	}

	const getB = function getBClosure() {
	  function buildB(count) {
	    const lut = [];

	    for (let i = 0; i <= count; i++) {
	      const t = i / count,
	            t_ = 1 - t;
	      lut.push(new Float32Array([t_ * t_ * t_, 3 * t * t_ * t_, 3 * t * t * t_, t * t * t]));
	    }

	    return lut;
	  }

	  const cache = [];
	  return function (count) {
	    if (!cache[count]) {
	      cache[count] = buildB(count);
	    }

	    return cache[count];
	  };
	}();

	class MeshShading extends BaseShading {
	  static get MIN_SPLIT_PATCH_CHUNKS_AMOUNT() {
	    return (0, _util.shadow)(this, "MIN_SPLIT_PATCH_CHUNKS_AMOUNT", 3);
	  }

	  static get MAX_SPLIT_PATCH_CHUNKS_AMOUNT() {
	    return (0, _util.shadow)(this, "MAX_SPLIT_PATCH_CHUNKS_AMOUNT", 20);
	  }

	  static get TRIANGLE_DENSITY() {
	    return (0, _util.shadow)(this, "TRIANGLE_DENSITY", 20);
	  }

	  constructor(stream, xref, resources, pdfFunctionFactory, localColorSpaceCache) {
	    super();

	    if (!(stream instanceof _base_stream.BaseStream)) {
	      throw new _util.FormatError("Mesh data is not a stream");
	    }

	    const dict = stream.dict;
	    this.shadingType = dict.get("ShadingType");
	    const bbox = dict.getArray("BBox");

	    if (Array.isArray(bbox) && bbox.length === 4) {
	      this.bbox = _util.Util.normalizeRect(bbox);
	    } else {
	      this.bbox = null;
	    }

	    const cs = _colorspace.ColorSpace.parse({
	      cs: dict.getRaw("CS") || dict.getRaw("ColorSpace"),
	      xref,
	      resources,
	      pdfFunctionFactory,
	      localColorSpaceCache
	    });

	    this.background = dict.has("Background") ? cs.getRgb(dict.get("Background"), 0) : null;
	    const fnObj = dict.getRaw("Function");
	    const fn = fnObj ? pdfFunctionFactory.createFromArray(fnObj) : null;
	    this.coords = [];
	    this.colors = [];
	    this.figures = [];
	    const decodeContext = {
	      bitsPerCoordinate: dict.get("BitsPerCoordinate"),
	      bitsPerComponent: dict.get("BitsPerComponent"),
	      bitsPerFlag: dict.get("BitsPerFlag"),
	      decode: dict.getArray("Decode"),
	      colorFn: fn,
	      colorSpace: cs,
	      numComps: fn ? 1 : cs.numComps
	    };
	    const reader = new MeshStreamReader(stream, decodeContext);
	    let patchMesh = false;

	    switch (this.shadingType) {
	      case ShadingType.FREE_FORM_MESH:
	        this._decodeType4Shading(reader);

	        break;

	      case ShadingType.LATTICE_FORM_MESH:
	        const verticesPerRow = dict.get("VerticesPerRow") | 0;

	        if (verticesPerRow < 2) {
	          throw new _util.FormatError("Invalid VerticesPerRow");
	        }

	        this._decodeType5Shading(reader, verticesPerRow);

	        break;

	      case ShadingType.COONS_PATCH_MESH:
	        this._decodeType6Shading(reader);

	        patchMesh = true;
	        break;

	      case ShadingType.TENSOR_PATCH_MESH:
	        this._decodeType7Shading(reader);

	        patchMesh = true;
	        break;

	      default:
	        (0, _util.unreachable)("Unsupported mesh type.");
	        break;
	    }

	    if (patchMesh) {
	      this._updateBounds();

	      for (let i = 0, ii = this.figures.length; i < ii; i++) {
	        this._buildFigureFromPatch(i);
	      }
	    }

	    this._updateBounds();

	    this._packData();
	  }

	  _decodeType4Shading(reader) {
	    const coords = this.coords;
	    const colors = this.colors;
	    const ps = [];
	    let verticesLeft = 0;

	    while (reader.hasData) {
	      const f = reader.readFlag();
	      const coord = reader.readCoordinate();
	      const color = reader.readComponents();

	      if (verticesLeft === 0) {
	        if (!(0 <= f && f <= 2)) {
	          throw new _util.FormatError("Unknown type4 flag");
	        }

	        switch (f) {
	          case 0:
	            verticesLeft = 3;
	            break;

	          case 1:
	            ps.push(ps.at(-2), ps.at(-1));
	            verticesLeft = 1;
	            break;

	          case 2:
	            ps.push(ps.at(-3), ps.at(-1));
	            verticesLeft = 1;
	            break;
	        }
	      }

	      ps.push(coords.length);
	      coords.push(coord);
	      colors.push(color);
	      verticesLeft--;
	      reader.align();
	    }

	    this.figures.push({
	      type: "triangles",
	      coords: new Int32Array(ps),
	      colors: new Int32Array(ps)
	    });
	  }

	  _decodeType5Shading(reader, verticesPerRow) {
	    const coords = this.coords;
	    const colors = this.colors;
	    const ps = [];

	    while (reader.hasData) {
	      const coord = reader.readCoordinate();
	      const color = reader.readComponents();
	      ps.push(coords.length);
	      coords.push(coord);
	      colors.push(color);
	    }

	    this.figures.push({
	      type: "lattice",
	      coords: new Int32Array(ps),
	      colors: new Int32Array(ps),
	      verticesPerRow
	    });
	  }

	  _decodeType6Shading(reader) {
	    const coords = this.coords;
	    const colors = this.colors;
	    const ps = new Int32Array(16);
	    const cs = new Int32Array(4);

	    while (reader.hasData) {
	      const f = reader.readFlag();

	      if (!(0 <= f && f <= 3)) {
	        throw new _util.FormatError("Unknown type6 flag");
	      }

	      const pi = coords.length;

	      for (let i = 0, ii = f !== 0 ? 8 : 12; i < ii; i++) {
	        coords.push(reader.readCoordinate());
	      }

	      const ci = colors.length;

	      for (let i = 0, ii = f !== 0 ? 2 : 4; i < ii; i++) {
	        colors.push(reader.readComponents());
	      }

	      let tmp1, tmp2, tmp3, tmp4;

	      switch (f) {
	        case 0:
	          ps[12] = pi + 3;
	          ps[13] = pi + 4;
	          ps[14] = pi + 5;
	          ps[15] = pi + 6;
	          ps[8] = pi + 2;
	          ps[11] = pi + 7;
	          ps[4] = pi + 1;
	          ps[7] = pi + 8;
	          ps[0] = pi;
	          ps[1] = pi + 11;
	          ps[2] = pi + 10;
	          ps[3] = pi + 9;
	          cs[2] = ci + 1;
	          cs[3] = ci + 2;
	          cs[0] = ci;
	          cs[1] = ci + 3;
	          break;

	        case 1:
	          tmp1 = ps[12];
	          tmp2 = ps[13];
	          tmp3 = ps[14];
	          tmp4 = ps[15];
	          ps[12] = tmp4;
	          ps[13] = pi + 0;
	          ps[14] = pi + 1;
	          ps[15] = pi + 2;
	          ps[8] = tmp3;
	          ps[11] = pi + 3;
	          ps[4] = tmp2;
	          ps[7] = pi + 4;
	          ps[0] = tmp1;
	          ps[1] = pi + 7;
	          ps[2] = pi + 6;
	          ps[3] = pi + 5;
	          tmp1 = cs[2];
	          tmp2 = cs[3];
	          cs[2] = tmp2;
	          cs[3] = ci;
	          cs[0] = tmp1;
	          cs[1] = ci + 1;
	          break;

	        case 2:
	          tmp1 = ps[15];
	          tmp2 = ps[11];
	          ps[12] = ps[3];
	          ps[13] = pi + 0;
	          ps[14] = pi + 1;
	          ps[15] = pi + 2;
	          ps[8] = ps[7];
	          ps[11] = pi + 3;
	          ps[4] = tmp2;
	          ps[7] = pi + 4;
	          ps[0] = tmp1;
	          ps[1] = pi + 7;
	          ps[2] = pi + 6;
	          ps[3] = pi + 5;
	          tmp1 = cs[3];
	          cs[2] = cs[1];
	          cs[3] = ci;
	          cs[0] = tmp1;
	          cs[1] = ci + 1;
	          break;

	        case 3:
	          ps[12] = ps[0];
	          ps[13] = pi + 0;
	          ps[14] = pi + 1;
	          ps[15] = pi + 2;
	          ps[8] = ps[1];
	          ps[11] = pi + 3;
	          ps[4] = ps[2];
	          ps[7] = pi + 4;
	          ps[0] = ps[3];
	          ps[1] = pi + 7;
	          ps[2] = pi + 6;
	          ps[3] = pi + 5;
	          cs[2] = cs[0];
	          cs[3] = ci;
	          cs[0] = cs[1];
	          cs[1] = ci + 1;
	          break;
	      }

	      ps[5] = coords.length;
	      coords.push([(-4 * coords[ps[0]][0] - coords[ps[15]][0] + 6 * (coords[ps[4]][0] + coords[ps[1]][0]) - 2 * (coords[ps[12]][0] + coords[ps[3]][0]) + 3 * (coords[ps[13]][0] + coords[ps[7]][0])) / 9, (-4 * coords[ps[0]][1] - coords[ps[15]][1] + 6 * (coords[ps[4]][1] + coords[ps[1]][1]) - 2 * (coords[ps[12]][1] + coords[ps[3]][1]) + 3 * (coords[ps[13]][1] + coords[ps[7]][1])) / 9]);
	      ps[6] = coords.length;
	      coords.push([(-4 * coords[ps[3]][0] - coords[ps[12]][0] + 6 * (coords[ps[2]][0] + coords[ps[7]][0]) - 2 * (coords[ps[0]][0] + coords[ps[15]][0]) + 3 * (coords[ps[4]][0] + coords[ps[14]][0])) / 9, (-4 * coords[ps[3]][1] - coords[ps[12]][1] + 6 * (coords[ps[2]][1] + coords[ps[7]][1]) - 2 * (coords[ps[0]][1] + coords[ps[15]][1]) + 3 * (coords[ps[4]][1] + coords[ps[14]][1])) / 9]);
	      ps[9] = coords.length;
	      coords.push([(-4 * coords[ps[12]][0] - coords[ps[3]][0] + 6 * (coords[ps[8]][0] + coords[ps[13]][0]) - 2 * (coords[ps[0]][0] + coords[ps[15]][0]) + 3 * (coords[ps[11]][0] + coords[ps[1]][0])) / 9, (-4 * coords[ps[12]][1] - coords[ps[3]][1] + 6 * (coords[ps[8]][1] + coords[ps[13]][1]) - 2 * (coords[ps[0]][1] + coords[ps[15]][1]) + 3 * (coords[ps[11]][1] + coords[ps[1]][1])) / 9]);
	      ps[10] = coords.length;
	      coords.push([(-4 * coords[ps[15]][0] - coords[ps[0]][0] + 6 * (coords[ps[11]][0] + coords[ps[14]][0]) - 2 * (coords[ps[12]][0] + coords[ps[3]][0]) + 3 * (coords[ps[2]][0] + coords[ps[8]][0])) / 9, (-4 * coords[ps[15]][1] - coords[ps[0]][1] + 6 * (coords[ps[11]][1] + coords[ps[14]][1]) - 2 * (coords[ps[12]][1] + coords[ps[3]][1]) + 3 * (coords[ps[2]][1] + coords[ps[8]][1])) / 9]);
	      this.figures.push({
	        type: "patch",
	        coords: new Int32Array(ps),
	        colors: new Int32Array(cs)
	      });
	    }
	  }

	  _decodeType7Shading(reader) {
	    const coords = this.coords;
	    const colors = this.colors;
	    const ps = new Int32Array(16);
	    const cs = new Int32Array(4);

	    while (reader.hasData) {
	      const f = reader.readFlag();

	      if (!(0 <= f && f <= 3)) {
	        throw new _util.FormatError("Unknown type7 flag");
	      }

	      const pi = coords.length;

	      for (let i = 0, ii = f !== 0 ? 12 : 16; i < ii; i++) {
	        coords.push(reader.readCoordinate());
	      }

	      const ci = colors.length;

	      for (let i = 0, ii = f !== 0 ? 2 : 4; i < ii; i++) {
	        colors.push(reader.readComponents());
	      }

	      let tmp1, tmp2, tmp3, tmp4;

	      switch (f) {
	        case 0:
	          ps[12] = pi + 3;
	          ps[13] = pi + 4;
	          ps[14] = pi + 5;
	          ps[15] = pi + 6;
	          ps[8] = pi + 2;
	          ps[9] = pi + 13;
	          ps[10] = pi + 14;
	          ps[11] = pi + 7;
	          ps[4] = pi + 1;
	          ps[5] = pi + 12;
	          ps[6] = pi + 15;
	          ps[7] = pi + 8;
	          ps[0] = pi;
	          ps[1] = pi + 11;
	          ps[2] = pi + 10;
	          ps[3] = pi + 9;
	          cs[2] = ci + 1;
	          cs[3] = ci + 2;
	          cs[0] = ci;
	          cs[1] = ci + 3;
	          break;

	        case 1:
	          tmp1 = ps[12];
	          tmp2 = ps[13];
	          tmp3 = ps[14];
	          tmp4 = ps[15];
	          ps[12] = tmp4;
	          ps[13] = pi + 0;
	          ps[14] = pi + 1;
	          ps[15] = pi + 2;
	          ps[8] = tmp3;
	          ps[9] = pi + 9;
	          ps[10] = pi + 10;
	          ps[11] = pi + 3;
	          ps[4] = tmp2;
	          ps[5] = pi + 8;
	          ps[6] = pi + 11;
	          ps[7] = pi + 4;
	          ps[0] = tmp1;
	          ps[1] = pi + 7;
	          ps[2] = pi + 6;
	          ps[3] = pi + 5;
	          tmp1 = cs[2];
	          tmp2 = cs[3];
	          cs[2] = tmp2;
	          cs[3] = ci;
	          cs[0] = tmp1;
	          cs[1] = ci + 1;
	          break;

	        case 2:
	          tmp1 = ps[15];
	          tmp2 = ps[11];
	          ps[12] = ps[3];
	          ps[13] = pi + 0;
	          ps[14] = pi + 1;
	          ps[15] = pi + 2;
	          ps[8] = ps[7];
	          ps[9] = pi + 9;
	          ps[10] = pi + 10;
	          ps[11] = pi + 3;
	          ps[4] = tmp2;
	          ps[5] = pi + 8;
	          ps[6] = pi + 11;
	          ps[7] = pi + 4;
	          ps[0] = tmp1;
	          ps[1] = pi + 7;
	          ps[2] = pi + 6;
	          ps[3] = pi + 5;
	          tmp1 = cs[3];
	          cs[2] = cs[1];
	          cs[3] = ci;
	          cs[0] = tmp1;
	          cs[1] = ci + 1;
	          break;

	        case 3:
	          ps[12] = ps[0];
	          ps[13] = pi + 0;
	          ps[14] = pi + 1;
	          ps[15] = pi + 2;
	          ps[8] = ps[1];
	          ps[9] = pi + 9;
	          ps[10] = pi + 10;
	          ps[11] = pi + 3;
	          ps[4] = ps[2];
	          ps[5] = pi + 8;
	          ps[6] = pi + 11;
	          ps[7] = pi + 4;
	          ps[0] = ps[3];
	          ps[1] = pi + 7;
	          ps[2] = pi + 6;
	          ps[3] = pi + 5;
	          cs[2] = cs[0];
	          cs[3] = ci;
	          cs[0] = cs[1];
	          cs[1] = ci + 1;
	          break;
	      }

	      this.figures.push({
	        type: "patch",
	        coords: new Int32Array(ps),
	        colors: new Int32Array(cs)
	      });
	    }
	  }

	  _buildFigureFromPatch(index) {
	    const figure = this.figures[index];
	    (0, _util.assert)(figure.type === "patch", "Unexpected patch mesh figure");
	    const coords = this.coords,
	          colors = this.colors;
	    const pi = figure.coords;
	    const ci = figure.colors;
	    const figureMinX = Math.min(coords[pi[0]][0], coords[pi[3]][0], coords[pi[12]][0], coords[pi[15]][0]);
	    const figureMinY = Math.min(coords[pi[0]][1], coords[pi[3]][1], coords[pi[12]][1], coords[pi[15]][1]);
	    const figureMaxX = Math.max(coords[pi[0]][0], coords[pi[3]][0], coords[pi[12]][0], coords[pi[15]][0]);
	    const figureMaxY = Math.max(coords[pi[0]][1], coords[pi[3]][1], coords[pi[12]][1], coords[pi[15]][1]);
	    let splitXBy = Math.ceil((figureMaxX - figureMinX) * MeshShading.TRIANGLE_DENSITY / (this.bounds[2] - this.bounds[0]));
	    splitXBy = Math.max(MeshShading.MIN_SPLIT_PATCH_CHUNKS_AMOUNT, Math.min(MeshShading.MAX_SPLIT_PATCH_CHUNKS_AMOUNT, splitXBy));
	    let splitYBy = Math.ceil((figureMaxY - figureMinY) * MeshShading.TRIANGLE_DENSITY / (this.bounds[3] - this.bounds[1]));
	    splitYBy = Math.max(MeshShading.MIN_SPLIT_PATCH_CHUNKS_AMOUNT, Math.min(MeshShading.MAX_SPLIT_PATCH_CHUNKS_AMOUNT, splitYBy));
	    const verticesPerRow = splitXBy + 1;
	    const figureCoords = new Int32Array((splitYBy + 1) * verticesPerRow);
	    const figureColors = new Int32Array((splitYBy + 1) * verticesPerRow);
	    let k = 0;
	    const cl = new Uint8Array(3),
	          cr = new Uint8Array(3);
	    const c0 = colors[ci[0]],
	          c1 = colors[ci[1]],
	          c2 = colors[ci[2]],
	          c3 = colors[ci[3]];
	    const bRow = getB(splitYBy),
	          bCol = getB(splitXBy);

	    for (let row = 0; row <= splitYBy; row++) {
	      cl[0] = (c0[0] * (splitYBy - row) + c2[0] * row) / splitYBy | 0;
	      cl[1] = (c0[1] * (splitYBy - row) + c2[1] * row) / splitYBy | 0;
	      cl[2] = (c0[2] * (splitYBy - row) + c2[2] * row) / splitYBy | 0;
	      cr[0] = (c1[0] * (splitYBy - row) + c3[0] * row) / splitYBy | 0;
	      cr[1] = (c1[1] * (splitYBy - row) + c3[1] * row) / splitYBy | 0;
	      cr[2] = (c1[2] * (splitYBy - row) + c3[2] * row) / splitYBy | 0;

	      for (let col = 0; col <= splitXBy; col++, k++) {
	        if ((row === 0 || row === splitYBy) && (col === 0 || col === splitXBy)) {
	          continue;
	        }

	        let x = 0,
	            y = 0;
	        let q = 0;

	        for (let i = 0; i <= 3; i++) {
	          for (let j = 0; j <= 3; j++, q++) {
	            const m = bRow[row][i] * bCol[col][j];
	            x += coords[pi[q]][0] * m;
	            y += coords[pi[q]][1] * m;
	          }
	        }

	        figureCoords[k] = coords.length;
	        coords.push([x, y]);
	        figureColors[k] = colors.length;
	        const newColor = new Uint8Array(3);
	        newColor[0] = (cl[0] * (splitXBy - col) + cr[0] * col) / splitXBy | 0;
	        newColor[1] = (cl[1] * (splitXBy - col) + cr[1] * col) / splitXBy | 0;
	        newColor[2] = (cl[2] * (splitXBy - col) + cr[2] * col) / splitXBy | 0;
	        colors.push(newColor);
	      }
	    }

	    figureCoords[0] = pi[0];
	    figureColors[0] = ci[0];
	    figureCoords[splitXBy] = pi[3];
	    figureColors[splitXBy] = ci[1];
	    figureCoords[verticesPerRow * splitYBy] = pi[12];
	    figureColors[verticesPerRow * splitYBy] = ci[2];
	    figureCoords[verticesPerRow * splitYBy + splitXBy] = pi[15];
	    figureColors[verticesPerRow * splitYBy + splitXBy] = ci[3];
	    this.figures[index] = {
	      type: "lattice",
	      coords: figureCoords,
	      colors: figureColors,
	      verticesPerRow
	    };
	  }

	  _updateBounds() {
	    let minX = this.coords[0][0],
	        minY = this.coords[0][1],
	        maxX = minX,
	        maxY = minY;

	    for (let i = 1, ii = this.coords.length; i < ii; i++) {
	      const x = this.coords[i][0],
	            y = this.coords[i][1];
	      minX = minX > x ? x : minX;
	      minY = minY > y ? y : minY;
	      maxX = maxX < x ? x : maxX;
	      maxY = maxY < y ? y : maxY;
	    }

	    this.bounds = [minX, minY, maxX, maxY];
	  }

	  _packData() {
	    let i, ii, j, jj;
	    const coords = this.coords;
	    const coordsPacked = new Float32Array(coords.length * 2);

	    for (i = 0, j = 0, ii = coords.length; i < ii; i++) {
	      const xy = coords[i];
	      coordsPacked[j++] = xy[0];
	      coordsPacked[j++] = xy[1];
	    }

	    this.coords = coordsPacked;
	    const colors = this.colors;
	    const colorsPacked = new Uint8Array(colors.length * 3);

	    for (i = 0, j = 0, ii = colors.length; i < ii; i++) {
	      const c = colors[i];
	      colorsPacked[j++] = c[0];
	      colorsPacked[j++] = c[1];
	      colorsPacked[j++] = c[2];
	    }

	    this.colors = colorsPacked;
	    const figures = this.figures;

	    for (i = 0, ii = figures.length; i < ii; i++) {
	      const figure = figures[i],
	            ps = figure.coords,
	            cs = figure.colors;

	      for (j = 0, jj = ps.length; j < jj; j++) {
	        ps[j] *= 2;
	        cs[j] *= 3;
	      }
	    }
	  }

	  getIR() {
	    return ["Mesh", this.shadingType, this.coords, this.colors, this.figures, this.bounds, this.bbox, this.background];
	  }

	}

	class DummyShading extends BaseShading {
	  getIR() {
	    return ["Dummy"];
	  }

	}

	function getTilingPatternIR(operatorList, dict, color) {
	  const matrix = dict.getArray("Matrix");

	  const bbox = _util.Util.normalizeRect(dict.getArray("BBox"));

	  const xstep = dict.get("XStep");
	  const ystep = dict.get("YStep");
	  const paintType = dict.get("PaintType");
	  const tilingType = dict.get("TilingType");

	  if (bbox[2] - bbox[0] === 0 || bbox[3] - bbox[1] === 0) {
	    throw new _util.FormatError(`Invalid getTilingPatternIR /BBox array: [${bbox}].`);
	  }

	  return ["TilingPattern", color, operatorList, matrix, bbox, xstep, ystep, paintType, tilingType];
	}

	/***/ }),
	/* 51 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.getXfaFontDict = getXfaFontDict;
	exports.getXfaFontName = getXfaFontName;

	var _calibri_factors = __w_pdfjs_require__(52);

	var _primitives = __w_pdfjs_require__(5);

	var _helvetica_factors = __w_pdfjs_require__(53);

	var _liberationsans_widths = __w_pdfjs_require__(54);

	var _myriadpro_factors = __w_pdfjs_require__(55);

	var _segoeui_factors = __w_pdfjs_require__(56);

	var _core_utils = __w_pdfjs_require__(6);

	var _fonts_utils = __w_pdfjs_require__(38);

	const getXFAFontMap = (0, _core_utils.getLookupTableFactory)(function (t) {
	  t["MyriadPro-Regular"] = t["PdfJS-Fallback-Regular"] = {
	    name: "LiberationSans-Regular",
	    factors: _myriadpro_factors.MyriadProRegularFactors,
	    baseWidths: _liberationsans_widths.LiberationSansRegularWidths,
	    baseMapping: _liberationsans_widths.LiberationSansRegularMapping,
	    metrics: _myriadpro_factors.MyriadProRegularMetrics
	  };
	  t["MyriadPro-Bold"] = t["PdfJS-Fallback-Bold"] = {
	    name: "LiberationSans-Bold",
	    factors: _myriadpro_factors.MyriadProBoldFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldMapping,
	    metrics: _myriadpro_factors.MyriadProBoldMetrics
	  };
	  t["MyriadPro-It"] = t["MyriadPro-Italic"] = t["PdfJS-Fallback-Italic"] = {
	    name: "LiberationSans-Italic",
	    factors: _myriadpro_factors.MyriadProItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansItalicMapping,
	    metrics: _myriadpro_factors.MyriadProItalicMetrics
	  };
	  t["MyriadPro-BoldIt"] = t["MyriadPro-BoldItalic"] = t["PdfJS-Fallback-BoldItalic"] = {
	    name: "LiberationSans-BoldItalic",
	    factors: _myriadpro_factors.MyriadProBoldItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldItalicMapping,
	    metrics: _myriadpro_factors.MyriadProBoldItalicMetrics
	  };
	  t.ArialMT = t.Arial = t["Arial-Regular"] = {
	    name: "LiberationSans-Regular",
	    baseWidths: _liberationsans_widths.LiberationSansRegularWidths,
	    baseMapping: _liberationsans_widths.LiberationSansRegularMapping
	  };
	  t["Arial-BoldMT"] = t["Arial-Bold"] = {
	    name: "LiberationSans-Bold",
	    baseWidths: _liberationsans_widths.LiberationSansBoldWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldMapping
	  };
	  t["Arial-ItalicMT"] = t["Arial-Italic"] = {
	    name: "LiberationSans-Italic",
	    baseWidths: _liberationsans_widths.LiberationSansItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansItalicMapping
	  };
	  t["Arial-BoldItalicMT"] = t["Arial-BoldItalic"] = {
	    name: "LiberationSans-BoldItalic",
	    baseWidths: _liberationsans_widths.LiberationSansBoldItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldItalicMapping
	  };
	  t["Calibri-Regular"] = {
	    name: "LiberationSans-Regular",
	    factors: _calibri_factors.CalibriRegularFactors,
	    baseWidths: _liberationsans_widths.LiberationSansRegularWidths,
	    baseMapping: _liberationsans_widths.LiberationSansRegularMapping,
	    metrics: _calibri_factors.CalibriRegularMetrics
	  };
	  t["Calibri-Bold"] = {
	    name: "LiberationSans-Bold",
	    factors: _calibri_factors.CalibriBoldFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldMapping,
	    metrics: _calibri_factors.CalibriBoldMetrics
	  };
	  t["Calibri-Italic"] = {
	    name: "LiberationSans-Italic",
	    factors: _calibri_factors.CalibriItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansItalicMapping,
	    metrics: _calibri_factors.CalibriItalicMetrics
	  };
	  t["Calibri-BoldItalic"] = {
	    name: "LiberationSans-BoldItalic",
	    factors: _calibri_factors.CalibriBoldItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldItalicMapping,
	    metrics: _calibri_factors.CalibriBoldItalicMetrics
	  };
	  t["Segoeui-Regular"] = {
	    name: "LiberationSans-Regular",
	    factors: _segoeui_factors.SegoeuiRegularFactors,
	    baseWidths: _liberationsans_widths.LiberationSansRegularWidths,
	    baseMapping: _liberationsans_widths.LiberationSansRegularMapping,
	    metrics: _segoeui_factors.SegoeuiRegularMetrics
	  };
	  t["Segoeui-Bold"] = {
	    name: "LiberationSans-Bold",
	    factors: _segoeui_factors.SegoeuiBoldFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldMapping,
	    metrics: _segoeui_factors.SegoeuiBoldMetrics
	  };
	  t["Segoeui-Italic"] = {
	    name: "LiberationSans-Italic",
	    factors: _segoeui_factors.SegoeuiItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansItalicMapping,
	    metrics: _segoeui_factors.SegoeuiItalicMetrics
	  };
	  t["Segoeui-BoldItalic"] = {
	    name: "LiberationSans-BoldItalic",
	    factors: _segoeui_factors.SegoeuiBoldItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldItalicMapping,
	    metrics: _segoeui_factors.SegoeuiBoldItalicMetrics
	  };
	  t["Helvetica-Regular"] = t.Helvetica = {
	    name: "LiberationSans-Regular",
	    factors: _helvetica_factors.HelveticaRegularFactors,
	    baseWidths: _liberationsans_widths.LiberationSansRegularWidths,
	    baseMapping: _liberationsans_widths.LiberationSansRegularMapping,
	    metrics: _helvetica_factors.HelveticaRegularMetrics
	  };
	  t["Helvetica-Bold"] = {
	    name: "LiberationSans-Bold",
	    factors: _helvetica_factors.HelveticaBoldFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldMapping,
	    metrics: _helvetica_factors.HelveticaBoldMetrics
	  };
	  t["Helvetica-Italic"] = {
	    name: "LiberationSans-Italic",
	    factors: _helvetica_factors.HelveticaItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansItalicMapping,
	    metrics: _helvetica_factors.HelveticaItalicMetrics
	  };
	  t["Helvetica-BoldItalic"] = {
	    name: "LiberationSans-BoldItalic",
	    factors: _helvetica_factors.HelveticaBoldItalicFactors,
	    baseWidths: _liberationsans_widths.LiberationSansBoldItalicWidths,
	    baseMapping: _liberationsans_widths.LiberationSansBoldItalicMapping,
	    metrics: _helvetica_factors.HelveticaBoldItalicMetrics
	  };
	});

	function getXfaFontName(name) {
	  const fontName = (0, _fonts_utils.normalizeFontName)(name);
	  const fontMap = getXFAFontMap();
	  return fontMap[fontName];
	}

	function getXfaFontWidths(name) {
	  const info = getXfaFontName(name);

	  if (!info) {
	    return null;
	  }

	  const {
	    baseWidths,
	    baseMapping,
	    factors
	  } = info;
	  let rescaledBaseWidths;

	  if (!factors) {
	    rescaledBaseWidths = baseWidths;
	  } else {
	    rescaledBaseWidths = baseWidths.map((w, i) => w * factors[i]);
	  }

	  let currentCode = -2;
	  let currentArray;
	  const newWidths = [];

	  for (const [unicode, glyphIndex] of baseMapping.map((charUnicode, index) => [charUnicode, index]).sort(([unicode1], [unicode2]) => unicode1 - unicode2)) {
	    if (unicode === -1) {
	      continue;
	    }

	    if (unicode === currentCode + 1) {
	      currentArray.push(rescaledBaseWidths[glyphIndex]);
	      currentCode += 1;
	    } else {
	      currentCode = unicode;
	      currentArray = [rescaledBaseWidths[glyphIndex]];
	      newWidths.push(unicode, currentArray);
	    }
	  }

	  return newWidths;
	}

	function getXfaFontDict(name) {
	  const widths = getXfaFontWidths(name);
	  const dict = new _primitives.Dict(null);
	  dict.set("BaseFont", _primitives.Name.get(name));
	  dict.set("Type", _primitives.Name.get("Font"));
	  dict.set("Subtype", _primitives.Name.get("CIDFontType2"));
	  dict.set("Encoding", _primitives.Name.get("Identity-H"));
	  dict.set("CIDToGIDMap", _primitives.Name.get("Identity"));
	  dict.set("W", widths);
	  dict.set("FirstChar", widths[0]);
	  dict.set("LastChar", widths.at(-2) + widths.at(-1).length - 1);
	  const descriptor = new _primitives.Dict(null);
	  dict.set("FontDescriptor", descriptor);
	  const systemInfo = new _primitives.Dict(null);
	  systemInfo.set("Ordering", "Identity");
	  systemInfo.set("Registry", "Adobe");
	  systemInfo.set("Supplement", 0);
	  dict.set("CIDSystemInfo", systemInfo);
	  return dict;
	}

	/***/ }),
	/* 52 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.CalibriRegularMetrics = exports.CalibriRegularFactors = exports.CalibriItalicMetrics = exports.CalibriItalicFactors = exports.CalibriBoldMetrics = exports.CalibriBoldItalicMetrics = exports.CalibriBoldItalicFactors = exports.CalibriBoldFactors = void 0;
	const CalibriBoldFactors = [1.3877, 1, 1, 1, 0.97801, 0.92482, 0.89552, 0.91133, 0.81988, 0.97566, 0.98152, 0.93548, 0.93548, 1.2798, 0.85284, 0.92794, 1, 0.96134, 1.54657, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.82845, 0.82845, 0.85284, 0.85284, 0.85284, 0.75859, 0.92138, 0.83908, 0.7762, 0.73293, 0.87289, 0.73133, 0.7514, 0.81921, 0.87356, 0.95958, 0.59526, 0.75727, 0.69225, 1.04924, 0.9121, 0.86943, 0.79795, 0.88198, 0.77958, 0.70864, 0.81055, 0.90399, 0.88653, 0.96017, 0.82577, 0.77892, 0.78257, 0.97507, 1.54657, 0.97507, 0.85284, 0.89552, 0.90176, 0.88762, 0.8785, 0.75241, 0.8785, 0.90518, 0.95015, 0.77618, 0.8785, 0.88401, 0.91916, 0.86304, 0.88401, 0.91488, 0.8785, 0.8801, 0.8785, 0.8785, 0.91343, 0.7173, 1.04106, 0.8785, 0.85075, 0.95794, 0.82616, 0.85162, 0.79492, 0.88331, 1.69808, 0.88331, 0.85284, 0.97801, 0.89552, 0.91133, 0.89552, 0.91133, 1.7801, 0.89552, 1.24487, 1.13254, 1.12401, 0.96839, 0.85284, 0.68787, 0.70645, 0.85592, 0.90747, 1.01466, 1.0088, 0.90323, 1, 1.07463, 1, 0.91056, 0.75806, 1.19118, 0.96839, 0.78864, 0.82845, 0.84133, 0.75859, 0.83908, 0.83908, 0.83908, 0.83908, 0.83908, 0.83908, 0.77539, 0.73293, 0.73133, 0.73133, 0.73133, 0.73133, 0.95958, 0.95958, 0.95958, 0.95958, 0.88506, 0.9121, 0.86943, 0.86943, 0.86943, 0.86943, 0.86943, 0.85284, 0.87508, 0.90399, 0.90399, 0.90399, 0.90399, 0.77892, 0.79795, 0.90807, 0.88762, 0.88762, 0.88762, 0.88762, 0.88762, 0.88762, 0.8715, 0.75241, 0.90518, 0.90518, 0.90518, 0.90518, 0.88401, 0.88401, 0.88401, 0.88401, 0.8785, 0.8785, 0.8801, 0.8801, 0.8801, 0.8801, 0.8801, 0.90747, 0.89049, 0.8785, 0.8785, 0.8785, 0.8785, 0.85162, 0.8785, 0.85162, 0.83908, 0.88762, 0.83908, 0.88762, 0.83908, 0.88762, 0.73293, 0.75241, 0.73293, 0.75241, 0.73293, 0.75241, 0.73293, 0.75241, 0.87289, 0.83016, 0.88506, 0.93125, 0.73133, 0.90518, 0.73133, 0.90518, 0.73133, 0.90518, 0.73133, 0.90518, 0.73133, 0.90518, 0.81921, 0.77618, 0.81921, 0.77618, 0.81921, 0.77618, 1, 1, 0.87356, 0.8785, 0.91075, 0.89608, 0.95958, 0.88401, 0.95958, 0.88401, 0.95958, 0.88401, 0.95958, 0.88401, 0.95958, 0.88401, 0.76229, 0.90167, 0.59526, 0.91916, 1, 1, 0.86304, 0.69225, 0.88401, 1, 1, 0.70424, 0.79468, 0.91926, 0.88175, 0.70823, 0.94903, 0.9121, 0.8785, 1, 1, 0.9121, 0.8785, 0.87802, 0.88656, 0.8785, 0.86943, 0.8801, 0.86943, 0.8801, 0.86943, 0.8801, 0.87402, 0.89291, 0.77958, 0.91343, 1, 1, 0.77958, 0.91343, 0.70864, 0.7173, 0.70864, 0.7173, 0.70864, 0.7173, 0.70864, 0.7173, 1, 1, 0.81055, 0.75841, 0.81055, 1.06452, 0.90399, 0.8785, 0.90399, 0.8785, 0.90399, 0.8785, 0.90399, 0.8785, 0.90399, 0.8785, 0.90399, 0.8785, 0.96017, 0.95794, 0.77892, 0.85162, 0.77892, 0.78257, 0.79492, 0.78257, 0.79492, 0.78257, 0.79492, 0.9297, 0.56892, 0.83908, 0.88762, 0.77539, 0.8715, 0.87508, 0.89049, 1, 1, 0.81055, 1.04106, 1.20528, 1.20528, 1, 1.15543, 0.70674, 0.98387, 0.94721, 1.33431, 1.45894, 0.95161, 1.06303, 0.83908, 0.80352, 0.57184, 0.6965, 0.56289, 0.82001, 0.56029, 0.81235, 1.02988, 0.83908, 0.7762, 0.68156, 0.80367, 0.73133, 0.78257, 0.87356, 0.86943, 0.95958, 0.75727, 0.89019, 1.04924, 0.9121, 0.7648, 0.86943, 0.87356, 0.79795, 0.78275, 0.81055, 0.77892, 0.9762, 0.82577, 0.99819, 0.84896, 0.95958, 0.77892, 0.96108, 1.01407, 0.89049, 1.02988, 0.94211, 0.96108, 0.8936, 0.84021, 0.87842, 0.96399, 0.79109, 0.89049, 1.00813, 1.02988, 0.86077, 0.87445, 0.92099, 0.84723, 0.86513, 0.8801, 0.75638, 0.85714, 0.78216, 0.79586, 0.87965, 0.94211, 0.97747, 0.78287, 0.97926, 0.84971, 1.02988, 0.94211, 0.8801, 0.94211, 0.84971, 0.73133, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.90264, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.90518, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.90548, 1, 1, 1, 1, 1, 1, 0.96017, 0.95794, 0.96017, 0.95794, 0.96017, 0.95794, 0.77892, 0.85162, 1, 1, 0.89552, 0.90527, 1, 0.90363, 0.92794, 0.92794, 0.92794, 0.92794, 0.87012, 0.87012, 0.87012, 0.89552, 0.89552, 1.42259, 0.71143, 1.06152, 1, 1, 1.03372, 1.03372, 0.97171, 1.4956, 2.2807, 0.93835, 0.83406, 0.91133, 0.84107, 0.91133, 1, 1, 1, 0.72021, 1, 1.23108, 0.83489, 0.88525, 0.88525, 0.81499, 0.90527, 1.81055, 0.90527, 1.81055, 1.31006, 1.53711, 0.94434, 1.08696, 1, 0.95018, 0.77192, 0.85284, 0.90747, 1.17534, 0.69825, 0.9716, 1.37077, 0.90747, 0.90747, 0.85356, 0.90747, 0.90747, 1.44947, 0.85284, 0.8941, 0.8941, 0.70572, 0.8, 0.70572, 0.70572, 0.70572, 0.70572, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.99862, 0.99862, 1, 1, 1, 1, 1, 1.08004, 0.91027, 1, 1, 1, 0.99862, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.90727, 0.90727, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.CalibriBoldFactors = CalibriBoldFactors;
	const CalibriBoldMetrics = {
	  lineHeight: 1.2207,
	  lineGap: 0.2207
	};
	exports.CalibriBoldMetrics = CalibriBoldMetrics;
	const CalibriBoldItalicFactors = [1.3877, 1, 1, 1, 0.97801, 0.92482, 0.89552, 0.91133, 0.81988, 0.97566, 0.98152, 0.93548, 0.93548, 1.2798, 0.85284, 0.92794, 1, 0.96134, 1.56239, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.82845, 0.82845, 0.85284, 0.85284, 0.85284, 0.75859, 0.92138, 0.83908, 0.7762, 0.71805, 0.87289, 0.73133, 0.7514, 0.81921, 0.87356, 0.95958, 0.59526, 0.75727, 0.69225, 1.04924, 0.90872, 0.85938, 0.79795, 0.87068, 0.77958, 0.69766, 0.81055, 0.90399, 0.88653, 0.96068, 0.82577, 0.77892, 0.78257, 0.97507, 1.529, 0.97507, 0.85284, 0.89552, 0.90176, 0.94908, 0.86411, 0.74012, 0.86411, 0.88323, 0.95015, 0.86411, 0.86331, 0.88401, 0.91916, 0.86304, 0.88401, 0.9039, 0.86331, 0.86331, 0.86411, 0.86411, 0.90464, 0.70852, 1.04106, 0.86331, 0.84372, 0.95794, 0.82616, 0.84548, 0.79492, 0.88331, 1.69808, 0.88331, 0.85284, 0.97801, 0.89552, 0.91133, 0.89552, 0.91133, 1.7801, 0.89552, 1.24487, 1.13254, 1.19129, 0.96839, 0.85284, 0.68787, 0.70645, 0.85592, 0.90747, 1.01466, 1.0088, 0.90323, 1, 1.07463, 1, 0.91056, 0.75806, 1.19118, 0.96839, 0.78864, 0.82845, 0.84133, 0.75859, 0.83908, 0.83908, 0.83908, 0.83908, 0.83908, 0.83908, 0.77539, 0.71805, 0.73133, 0.73133, 0.73133, 0.73133, 0.95958, 0.95958, 0.95958, 0.95958, 0.88506, 0.90872, 0.85938, 0.85938, 0.85938, 0.85938, 0.85938, 0.85284, 0.87068, 0.90399, 0.90399, 0.90399, 0.90399, 0.77892, 0.79795, 0.90807, 0.94908, 0.94908, 0.94908, 0.94908, 0.94908, 0.94908, 0.85887, 0.74012, 0.88323, 0.88323, 0.88323, 0.88323, 0.88401, 0.88401, 0.88401, 0.88401, 0.8785, 0.86331, 0.86331, 0.86331, 0.86331, 0.86331, 0.86331, 0.90747, 0.89049, 0.86331, 0.86331, 0.86331, 0.86331, 0.84548, 0.86411, 0.84548, 0.83908, 0.94908, 0.83908, 0.94908, 0.83908, 0.94908, 0.71805, 0.74012, 0.71805, 0.74012, 0.71805, 0.74012, 0.71805, 0.74012, 0.87289, 0.79538, 0.88506, 0.92726, 0.73133, 0.88323, 0.73133, 0.88323, 0.73133, 0.88323, 0.73133, 0.88323, 0.73133, 0.88323, 0.81921, 0.86411, 0.81921, 0.86411, 0.81921, 0.86411, 1, 1, 0.87356, 0.86331, 0.91075, 0.8777, 0.95958, 0.88401, 0.95958, 0.88401, 0.95958, 0.88401, 0.95958, 0.88401, 0.95958, 0.88401, 0.76467, 0.90167, 0.59526, 0.91916, 1, 1, 0.86304, 0.69225, 0.88401, 1, 1, 0.70424, 0.77312, 0.91926, 0.88175, 0.70823, 0.94903, 0.90872, 0.86331, 1, 1, 0.90872, 0.86331, 0.86906, 0.88116, 0.86331, 0.85938, 0.86331, 0.85938, 0.86331, 0.85938, 0.86331, 0.87402, 0.86549, 0.77958, 0.90464, 1, 1, 0.77958, 0.90464, 0.69766, 0.70852, 0.69766, 0.70852, 0.69766, 0.70852, 0.69766, 0.70852, 1, 1, 0.81055, 0.75841, 0.81055, 1.06452, 0.90399, 0.86331, 0.90399, 0.86331, 0.90399, 0.86331, 0.90399, 0.86331, 0.90399, 0.86331, 0.90399, 0.86331, 0.96068, 0.95794, 0.77892, 0.84548, 0.77892, 0.78257, 0.79492, 0.78257, 0.79492, 0.78257, 0.79492, 0.9297, 0.56892, 0.83908, 0.94908, 0.77539, 0.85887, 0.87068, 0.89049, 1, 1, 0.81055, 1.04106, 1.20528, 1.20528, 1, 1.15543, 0.70088, 0.98387, 0.94721, 1.33431, 1.45894, 0.95161, 1.48387, 0.83908, 0.80352, 0.57118, 0.6965, 0.56347, 0.79179, 0.55853, 0.80346, 1.02988, 0.83908, 0.7762, 0.67174, 0.86036, 0.73133, 0.78257, 0.87356, 0.86441, 0.95958, 0.75727, 0.89019, 1.04924, 0.90872, 0.74889, 0.85938, 0.87891, 0.79795, 0.7957, 0.81055, 0.77892, 0.97447, 0.82577, 0.97466, 0.87179, 0.95958, 0.77892, 0.94252, 0.95612, 0.8753, 1.02988, 0.92733, 0.94252, 0.87411, 0.84021, 0.8728, 0.95612, 0.74081, 0.8753, 1.02189, 1.02988, 0.84814, 0.87445, 0.91822, 0.84723, 0.85668, 0.86331, 0.81344, 0.87581, 0.76422, 0.82046, 0.96057, 0.92733, 0.99375, 0.78022, 0.95452, 0.86015, 1.02988, 0.92733, 0.86331, 0.92733, 0.86015, 0.73133, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.90631, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.88323, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.85174, 1, 1, 1, 1, 1, 1, 0.96068, 0.95794, 0.96068, 0.95794, 0.96068, 0.95794, 0.77892, 0.84548, 1, 1, 0.89552, 0.90527, 1, 0.90363, 0.92794, 0.92794, 0.92794, 0.89807, 0.87012, 0.87012, 0.87012, 0.89552, 0.89552, 1.42259, 0.71094, 1.06152, 1, 1, 1.03372, 1.03372, 0.97171, 1.4956, 2.2807, 0.92972, 0.83406, 0.91133, 0.83326, 0.91133, 1, 1, 1, 0.72021, 1, 1.23108, 0.83489, 0.88525, 0.88525, 0.81499, 0.90616, 1.81055, 0.90527, 1.81055, 1.3107, 1.53711, 0.94434, 1.08696, 1, 0.95018, 0.77192, 0.85284, 0.90747, 1.17534, 0.69825, 0.9716, 1.37077, 0.90747, 0.90747, 0.85356, 0.90747, 0.90747, 1.44947, 0.85284, 0.8941, 0.8941, 0.70572, 0.8, 0.70572, 0.70572, 0.70572, 0.70572, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.99862, 0.99862, 1, 1, 1, 1, 1, 1.08004, 0.91027, 1, 1, 1, 0.99862, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.90727, 0.90727, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.CalibriBoldItalicFactors = CalibriBoldItalicFactors;
	const CalibriBoldItalicMetrics = {
	  lineHeight: 1.2207,
	  lineGap: 0.2207
	};
	exports.CalibriBoldItalicMetrics = CalibriBoldItalicMetrics;
	const CalibriItalicFactors = [1.3877, 1, 1, 1, 1.17223, 1.1293, 0.89552, 0.91133, 0.80395, 1.02269, 1.15601, 0.91056, 0.91056, 1.2798, 0.85284, 0.89807, 1, 0.90861, 1.39543, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.96309, 0.96309, 0.85284, 0.85284, 0.85284, 0.83319, 0.88071, 0.8675, 0.81552, 0.72346, 0.85193, 0.73206, 0.7522, 0.81105, 0.86275, 0.90685, 0.6377, 0.77892, 0.75593, 1.02638, 0.89249, 0.84118, 0.77452, 0.85374, 0.75186, 0.67789, 0.79776, 0.88844, 0.85066, 0.94309, 0.77818, 0.7306, 0.76659, 1.10369, 1.38313, 1.10369, 1.06139, 0.89552, 0.8739, 0.9245, 0.9245, 0.83203, 0.9245, 0.85865, 1.09842, 0.9245, 0.9245, 1.03297, 1.07692, 0.90918, 1.03297, 0.94959, 0.9245, 0.92274, 0.9245, 0.9245, 1.02933, 0.77832, 1.20562, 0.9245, 0.8916, 0.98986, 0.86621, 0.89453, 0.79004, 0.94152, 1.77256, 0.94152, 0.85284, 0.97801, 0.89552, 0.91133, 0.89552, 0.91133, 1.91729, 0.89552, 1.17889, 1.13254, 1.16359, 0.92098, 0.85284, 0.68787, 0.71353, 0.84737, 0.90747, 1.0088, 1.0044, 0.87683, 1, 1.09091, 1, 0.92229, 0.739, 1.15642, 0.92098, 0.76288, 0.80504, 0.80972, 0.75859, 0.8675, 0.8675, 0.8675, 0.8675, 0.8675, 0.8675, 0.76318, 0.72346, 0.73206, 0.73206, 0.73206, 0.73206, 0.90685, 0.90685, 0.90685, 0.90685, 0.86477, 0.89249, 0.84118, 0.84118, 0.84118, 0.84118, 0.84118, 0.85284, 0.84557, 0.88844, 0.88844, 0.88844, 0.88844, 0.7306, 0.77452, 0.86331, 0.9245, 0.9245, 0.9245, 0.9245, 0.9245, 0.9245, 0.84843, 0.83203, 0.85865, 0.85865, 0.85865, 0.85865, 0.82601, 0.82601, 0.82601, 0.82601, 0.94469, 0.9245, 0.92274, 0.92274, 0.92274, 0.92274, 0.92274, 0.90747, 0.86651, 0.9245, 0.9245, 0.9245, 0.9245, 0.89453, 0.9245, 0.89453, 0.8675, 0.9245, 0.8675, 0.9245, 0.8675, 0.9245, 0.72346, 0.83203, 0.72346, 0.83203, 0.72346, 0.83203, 0.72346, 0.83203, 0.85193, 0.8875, 0.86477, 0.99034, 0.73206, 0.85865, 0.73206, 0.85865, 0.73206, 0.85865, 0.73206, 0.85865, 0.73206, 0.85865, 0.81105, 0.9245, 0.81105, 0.9245, 0.81105, 0.9245, 1, 1, 0.86275, 0.9245, 0.90872, 0.93591, 0.90685, 0.82601, 0.90685, 0.82601, 0.90685, 0.82601, 0.90685, 1.03297, 0.90685, 0.82601, 0.77896, 1.05611, 0.6377, 1.07692, 1, 1, 0.90918, 0.75593, 1.03297, 1, 1, 0.76032, 0.9375, 0.98156, 0.93407, 0.77261, 1.11429, 0.89249, 0.9245, 1, 1, 0.89249, 0.9245, 0.92534, 0.86698, 0.9245, 0.84118, 0.92274, 0.84118, 0.92274, 0.84118, 0.92274, 0.8667, 0.86291, 0.75186, 1.02933, 1, 1, 0.75186, 1.02933, 0.67789, 0.77832, 0.67789, 0.77832, 0.67789, 0.77832, 0.67789, 0.77832, 1, 1, 0.79776, 0.97655, 0.79776, 1.23023, 0.88844, 0.9245, 0.88844, 0.9245, 0.88844, 0.9245, 0.88844, 0.9245, 0.88844, 0.9245, 0.88844, 0.9245, 0.94309, 0.98986, 0.7306, 0.89453, 0.7306, 0.76659, 0.79004, 0.76659, 0.79004, 0.76659, 0.79004, 1.09231, 0.54873, 0.8675, 0.9245, 0.76318, 0.84843, 0.84557, 0.86651, 1, 1, 0.79776, 1.20562, 1.18622, 1.18622, 1, 1.1437, 0.67009, 0.96334, 0.93695, 1.35191, 1.40909, 0.95161, 1.48387, 0.8675, 0.90861, 0.6192, 0.7363, 0.64824, 0.82411, 0.56321, 0.85696, 1.23516, 0.8675, 0.81552, 0.7286, 0.84134, 0.73206, 0.76659, 0.86275, 0.84369, 0.90685, 0.77892, 0.85871, 1.02638, 0.89249, 0.75828, 0.84118, 0.85984, 0.77452, 0.76466, 0.79776, 0.7306, 0.90782, 0.77818, 0.903, 0.87291, 0.90685, 0.7306, 0.99058, 1.03667, 0.94635, 1.23516, 0.9849, 0.99058, 0.92393, 0.8916, 0.942, 1.03667, 0.75026, 0.94635, 1.0297, 1.23516, 0.90918, 0.94048, 0.98217, 0.89746, 0.84153, 0.92274, 0.82507, 0.88832, 0.84438, 0.88178, 1.03525, 0.9849, 1.00225, 0.78086, 0.97248, 0.89404, 1.23516, 0.9849, 0.92274, 0.9849, 0.89404, 0.73206, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.89693, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.85865, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.90933, 1, 1, 1, 1, 1, 1, 0.94309, 0.98986, 0.94309, 0.98986, 0.94309, 0.98986, 0.7306, 0.89453, 1, 1, 0.89552, 0.90527, 1, 0.90186, 1.12308, 1.12308, 1.12308, 1.12308, 1.2566, 1.2566, 1.2566, 0.89552, 0.89552, 1.42259, 0.68994, 1.03809, 1, 1, 1.0176, 1.0176, 1.11523, 1.4956, 2.01462, 0.97858, 0.82616, 0.91133, 0.83437, 0.91133, 1, 1, 1, 0.70508, 1, 1.23108, 0.79801, 0.84426, 0.84426, 0.774, 0.90572, 1.81055, 0.90749, 1.81055, 1.28809, 1.55469, 0.94434, 1.07806, 1, 0.97094, 0.7589, 0.85284, 0.90747, 1.19658, 0.69825, 0.97622, 1.33512, 0.90747, 0.90747, 0.85284, 0.90747, 0.90747, 1.44947, 0.85284, 0.8941, 0.8941, 0.70572, 0.8, 0.70572, 0.70572, 0.70572, 0.70572, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.99862, 0.99862, 1, 1, 1, 1, 1, 1.0336, 0.91027, 1, 1, 1, 0.99862, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05859, 1.05859, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.CalibriItalicFactors = CalibriItalicFactors;
	const CalibriItalicMetrics = {
	  lineHeight: 1.2207,
	  lineGap: 0.2207
	};
	exports.CalibriItalicMetrics = CalibriItalicMetrics;
	const CalibriRegularFactors = [1.3877, 1, 1, 1, 1.17223, 1.1293, 0.89552, 0.91133, 0.80395, 1.02269, 1.15601, 0.91056, 0.91056, 1.2798, 0.85284, 0.89807, 1, 0.90861, 1.39016, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.91133, 0.96309, 0.96309, 0.85284, 0.85284, 0.85284, 0.83319, 0.88071, 0.8675, 0.81552, 0.73834, 0.85193, 0.73206, 0.7522, 0.81105, 0.86275, 0.90685, 0.6377, 0.77892, 0.75593, 1.02638, 0.89385, 0.85122, 0.77452, 0.86503, 0.75186, 0.68887, 0.79776, 0.88844, 0.85066, 0.94258, 0.77818, 0.7306, 0.76659, 1.10369, 1.39016, 1.10369, 1.06139, 0.89552, 0.8739, 0.86128, 0.94469, 0.8457, 0.94469, 0.89464, 1.09842, 0.84636, 0.94469, 1.03297, 1.07692, 0.90918, 1.03297, 0.95897, 0.94469, 0.9482, 0.94469, 0.94469, 1.04692, 0.78223, 1.20562, 0.94469, 0.90332, 0.98986, 0.86621, 0.90527, 0.79004, 0.94152, 1.77256, 0.94152, 0.85284, 0.97801, 0.89552, 0.91133, 0.89552, 0.91133, 1.91729, 0.89552, 1.17889, 1.13254, 1.08707, 0.92098, 0.85284, 0.68787, 0.71353, 0.84737, 0.90747, 1.0088, 1.0044, 0.87683, 1, 1.09091, 1, 0.92229, 0.739, 1.15642, 0.92098, 0.76288, 0.80504, 0.80972, 0.75859, 0.8675, 0.8675, 0.8675, 0.8675, 0.8675, 0.8675, 0.76318, 0.73834, 0.73206, 0.73206, 0.73206, 0.73206, 0.90685, 0.90685, 0.90685, 0.90685, 0.86477, 0.89385, 0.85122, 0.85122, 0.85122, 0.85122, 0.85122, 0.85284, 0.85311, 0.88844, 0.88844, 0.88844, 0.88844, 0.7306, 0.77452, 0.86331, 0.86128, 0.86128, 0.86128, 0.86128, 0.86128, 0.86128, 0.8693, 0.8457, 0.89464, 0.89464, 0.89464, 0.89464, 0.82601, 0.82601, 0.82601, 0.82601, 0.94469, 0.94469, 0.9482, 0.9482, 0.9482, 0.9482, 0.9482, 0.90747, 0.86651, 0.94469, 0.94469, 0.94469, 0.94469, 0.90527, 0.94469, 0.90527, 0.8675, 0.86128, 0.8675, 0.86128, 0.8675, 0.86128, 0.73834, 0.8457, 0.73834, 0.8457, 0.73834, 0.8457, 0.73834, 0.8457, 0.85193, 0.92454, 0.86477, 0.9921, 0.73206, 0.89464, 0.73206, 0.89464, 0.73206, 0.89464, 0.73206, 0.89464, 0.73206, 0.89464, 0.81105, 0.84636, 0.81105, 0.84636, 0.81105, 0.84636, 1, 1, 0.86275, 0.94469, 0.90872, 0.95786, 0.90685, 0.82601, 0.90685, 0.82601, 0.90685, 0.82601, 0.90685, 1.03297, 0.90685, 0.82601, 0.77741, 1.05611, 0.6377, 1.07692, 1, 1, 0.90918, 0.75593, 1.03297, 1, 1, 0.76032, 0.90452, 0.98156, 1.11842, 0.77261, 1.11429, 0.89385, 0.94469, 1, 1, 0.89385, 0.94469, 0.95877, 0.86901, 0.94469, 0.85122, 0.9482, 0.85122, 0.9482, 0.85122, 0.9482, 0.8667, 0.90016, 0.75186, 1.04692, 1, 1, 0.75186, 1.04692, 0.68887, 0.78223, 0.68887, 0.78223, 0.68887, 0.78223, 0.68887, 0.78223, 1, 1, 0.79776, 0.92188, 0.79776, 1.23023, 0.88844, 0.94469, 0.88844, 0.94469, 0.88844, 0.94469, 0.88844, 0.94469, 0.88844, 0.94469, 0.88844, 0.94469, 0.94258, 0.98986, 0.7306, 0.90527, 0.7306, 0.76659, 0.79004, 0.76659, 0.79004, 0.76659, 0.79004, 1.09231, 0.54873, 0.8675, 0.86128, 0.76318, 0.8693, 0.85311, 0.86651, 1, 1, 0.79776, 1.20562, 1.18622, 1.18622, 1, 1.1437, 0.67742, 0.96334, 0.93695, 1.35191, 1.40909, 0.95161, 1.48387, 0.86686, 0.90861, 0.62267, 0.74359, 0.65649, 0.85498, 0.56963, 0.88254, 1.23516, 0.8675, 0.81552, 0.75443, 0.84503, 0.73206, 0.76659, 0.86275, 0.85122, 0.90685, 0.77892, 0.85746, 1.02638, 0.89385, 0.75657, 0.85122, 0.86275, 0.77452, 0.74171, 0.79776, 0.7306, 0.95165, 0.77818, 0.89772, 0.88831, 0.90685, 0.7306, 0.98142, 1.02191, 0.96576, 1.23516, 0.99018, 0.98142, 0.9236, 0.89258, 0.94035, 1.02191, 0.78848, 0.96576, 0.9561, 1.23516, 0.90918, 0.92578, 0.95424, 0.89746, 0.83969, 0.9482, 0.80113, 0.89442, 0.85208, 0.86155, 0.98022, 0.99018, 1.00452, 0.81209, 0.99247, 0.89181, 1.23516, 0.99018, 0.9482, 0.99018, 0.89181, 0.73206, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.88844, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.89464, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.96766, 1, 1, 1, 1, 1, 1, 0.94258, 0.98986, 0.94258, 0.98986, 0.94258, 0.98986, 0.7306, 0.90527, 1, 1, 0.89552, 0.90527, 1, 0.90186, 1.12308, 1.12308, 1.12308, 1.12308, 1.2566, 1.2566, 1.2566, 0.89552, 0.89552, 1.42259, 0.69043, 1.03809, 1, 1, 1.0176, 1.0176, 1.11523, 1.4956, 2.01462, 0.99331, 0.82616, 0.91133, 0.84286, 0.91133, 1, 1, 1, 0.70508, 1, 1.23108, 0.79801, 0.84426, 0.84426, 0.774, 0.90527, 1.81055, 0.90527, 1.81055, 1.28809, 1.55469, 0.94434, 1.07806, 1, 0.97094, 0.7589, 0.85284, 0.90747, 1.19658, 0.69825, 0.97622, 1.33512, 0.90747, 0.90747, 0.85356, 0.90747, 0.90747, 1.44947, 0.85284, 0.8941, 0.8941, 0.70572, 0.8, 0.70572, 0.70572, 0.70572, 0.70572, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.99862, 0.99862, 1, 1, 1, 1, 1, 1.0336, 0.91027, 1, 1, 1, 0.99862, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05859, 1.05859, 1, 1, 1, 1.07185, 0.99413, 0.96334, 1.08065, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.CalibriRegularFactors = CalibriRegularFactors;
	const CalibriRegularMetrics = {
	  lineHeight: 1.2207,
	  lineGap: 0.2207
	};
	exports.CalibriRegularMetrics = CalibriRegularMetrics;

	/***/ }),
	/* 53 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.HelveticaRegularMetrics = exports.HelveticaRegularFactors = exports.HelveticaItalicMetrics = exports.HelveticaItalicFactors = exports.HelveticaBoldMetrics = exports.HelveticaBoldItalicMetrics = exports.HelveticaBoldItalicFactors = exports.HelveticaBoldFactors = void 0;
	const HelveticaBoldFactors = [0.76116, 1, 1, 1.0006, 0.99998, 0.99974, 0.99973, 0.99973, 0.99982, 0.99977, 1.00087, 0.99998, 0.99998, 0.99959, 1.00003, 1.0006, 0.99998, 1.0006, 1.0006, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99998, 1, 1.00003, 1.00003, 1.00003, 1.00026, 0.9999, 0.99977, 0.99977, 0.99977, 0.99977, 1.00001, 1.00026, 1.00022, 0.99977, 1.0006, 0.99973, 0.99977, 1.00026, 0.99999, 0.99977, 1.00022, 1.00001, 1.00022, 0.99977, 1.00001, 1.00026, 0.99977, 1.00001, 1.00016, 1.00001, 1.00001, 1.00026, 0.99998, 1.0006, 0.99998, 1.00003, 0.99973, 0.99998, 0.99973, 1.00026, 0.99973, 1.00026, 0.99973, 0.99998, 1.00026, 1.00026, 1.0006, 1.0006, 0.99973, 1.0006, 0.99982, 1.00026, 1.00026, 1.00026, 1.00026, 0.99959, 0.99973, 0.99998, 1.00026, 0.99973, 1.00022, 0.99973, 0.99973, 1, 0.99959, 1.00077, 0.99959, 1.00003, 0.99998, 0.99973, 0.99973, 0.99973, 0.99973, 1.00077, 0.99973, 0.99998, 1.00025, 0.99968, 0.99973, 1.00003, 1.00025, 0.60299, 1.00024, 1.06409, 1, 1, 0.99998, 1, 0.99973, 1.0006, 0.99998, 1, 0.99936, 0.99973, 1.00002, 1.00002, 1.00002, 1.00026, 0.99977, 0.99977, 0.99977, 0.99977, 0.99977, 0.99977, 1, 0.99977, 1.00001, 1.00001, 1.00001, 1.00001, 1.0006, 1.0006, 1.0006, 1.0006, 0.99977, 0.99977, 1.00022, 1.00022, 1.00022, 1.00022, 1.00022, 1.00003, 1.00022, 0.99977, 0.99977, 0.99977, 0.99977, 1.00001, 1.00001, 1.00026, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99982, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 1.0006, 1.0006, 1.0006, 1.0006, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 1.06409, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 0.99973, 1.00026, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 1.03374, 0.99977, 1.00026, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00022, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.00042, 0.99973, 0.99973, 1.0006, 0.99977, 0.99973, 0.99973, 1.00026, 1.0006, 1.00026, 1.0006, 1.00026, 1.03828, 1.00026, 0.99999, 1.00026, 1.0006, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.9993, 0.9998, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 1, 1.00016, 0.99977, 0.99959, 0.99977, 0.99959, 0.99977, 0.99959, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00026, 0.99998, 1.00026, 0.8121, 1.00026, 0.99998, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 1.00016, 1.00022, 1.00001, 0.99973, 1.00001, 1.00026, 1, 1.00026, 1, 1.00026, 1, 1.0006, 0.99973, 0.99977, 0.99973, 1, 0.99982, 1.00022, 1.00026, 1.00001, 0.99973, 1.00026, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 1.00034, 0.99977, 1, 0.99997, 1.00026, 1.00078, 1.00036, 0.99973, 1.00013, 1.0006, 0.99977, 0.99977, 0.99988, 0.85148, 1.00001, 1.00026, 0.99977, 1.00022, 1.0006, 0.99977, 1.00001, 0.99999, 0.99977, 1.00069, 1.00022, 0.99977, 1.00001, 0.99984, 1.00026, 1.00001, 1.00024, 1.00001, 0.9999, 1, 1.0006, 1.00001, 1.00041, 0.99962, 1.00026, 1.0006, 0.99995, 1.00041, 0.99942, 0.99973, 0.99927, 1.00082, 0.99902, 1.00026, 1.00087, 1.0006, 1.00069, 0.99973, 0.99867, 0.99973, 0.9993, 1.00026, 1.00049, 1.00056, 1, 0.99988, 0.99935, 0.99995, 0.99954, 1.00055, 0.99945, 1.00032, 1.0006, 0.99995, 1.00026, 0.99995, 1.00032, 1.00001, 1.00008, 0.99971, 1.00019, 0.9994, 1.00001, 1.0006, 1.00044, 0.99973, 1.00023, 1.00047, 1, 0.99942, 0.99561, 0.99989, 1.00035, 0.99977, 1.00035, 0.99977, 1.00019, 0.99944, 1.00001, 1.00021, 0.99926, 1.00035, 1.00035, 0.99942, 1.00048, 0.99999, 0.99977, 1.00022, 1.00035, 1.00001, 0.99977, 1.00026, 0.99989, 1.00057, 1.00001, 0.99936, 1.00052, 1.00012, 0.99996, 1.00043, 1, 1.00035, 0.9994, 0.99976, 1.00035, 0.99973, 1.00052, 1.00041, 1.00119, 1.00037, 0.99973, 1.00002, 0.99986, 1.00041, 1.00041, 0.99902, 0.9996, 1.00034, 0.99999, 1.00026, 0.99999, 1.00026, 0.99973, 1.00052, 0.99973, 1, 0.99973, 1.00041, 1.00075, 0.9994, 1.0003, 0.99999, 1, 1.00041, 0.99955, 1, 0.99915, 0.99973, 0.99973, 1.00026, 1.00119, 0.99955, 0.99973, 1.0006, 0.99911, 1.0006, 1.00026, 0.99972, 1.00026, 0.99902, 1.00041, 0.99973, 0.99999, 1, 1, 1.00038, 1.0005, 1.00016, 1.00022, 1.00016, 1.00022, 1.00016, 1.00022, 1.00001, 0.99973, 1, 1, 0.99973, 1, 1, 0.99955, 1.0006, 1.0006, 1.0006, 1.0006, 1, 1, 1, 0.99973, 0.99973, 0.99972, 1, 1, 1.00106, 0.99999, 0.99998, 0.99998, 0.99999, 0.99998, 1.66475, 1, 0.99973, 0.99973, 1.00023, 0.99973, 0.99971, 1.00047, 1.00023, 1, 0.99991, 0.99984, 1.00002, 1.00002, 1.00002, 1.00002, 1, 1, 1, 1, 1, 1, 1, 0.99972, 1, 1.20985, 1.39713, 1.00003, 1.00031, 1.00015, 1, 0.99561, 1.00027, 1.00031, 1.00031, 0.99915, 1.00031, 1.00031, 0.99999, 1.00003, 0.99999, 0.99999, 1.41144, 1.6, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.40579, 1.40579, 1.36625, 0.99999, 1, 0.99861, 0.99861, 1, 1.00026, 1.00026, 1.00026, 1.00026, 0.99972, 0.99999, 0.99999, 0.99999, 0.99999, 1.40483, 1, 0.99977, 1.00054, 1, 1, 0.99953, 0.99962, 1.00042, 0.9995, 1, 1, 1, 1, 1, 1, 1, 1, 0.99998, 0.99998, 0.99998, 0.99998, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.HelveticaBoldFactors = HelveticaBoldFactors;
	const HelveticaBoldMetrics = {
	  lineHeight: 1.2,
	  lineGap: 0.2
	};
	exports.HelveticaBoldMetrics = HelveticaBoldMetrics;
	const HelveticaBoldItalicFactors = [0.76116, 1, 1, 1.0006, 0.99998, 0.99974, 0.99973, 0.99973, 0.99982, 0.99977, 1.00087, 0.99998, 0.99998, 0.99959, 1.00003, 1.0006, 0.99998, 1.0006, 1.0006, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99998, 1, 1.00003, 1.00003, 1.00003, 1.00026, 0.9999, 0.99977, 0.99977, 0.99977, 0.99977, 1.00001, 1.00026, 1.00022, 0.99977, 1.0006, 0.99973, 0.99977, 1.00026, 0.99999, 0.99977, 1.00022, 1.00001, 1.00022, 0.99977, 1.00001, 1.00026, 0.99977, 1.00001, 1.00016, 1.00001, 1.00001, 1.00026, 0.99998, 1.0006, 0.99998, 1.00003, 0.99973, 0.99998, 0.99973, 1.00026, 0.99973, 1.00026, 0.99973, 0.99998, 1.00026, 1.00026, 1.0006, 1.0006, 0.99973, 1.0006, 0.99982, 1.00026, 1.00026, 1.00026, 1.00026, 0.99959, 0.99973, 0.99998, 1.00026, 0.99973, 1.00022, 0.99973, 0.99973, 1, 0.99959, 1.00077, 0.99959, 1.00003, 0.99998, 0.99973, 0.99973, 0.99973, 0.99973, 1.00077, 0.99973, 0.99998, 1.00025, 0.99968, 0.99973, 1.00003, 1.00025, 0.60299, 1.00024, 1.06409, 1, 1, 0.99998, 1, 0.99973, 1.0006, 0.99998, 1, 0.99936, 0.99973, 1.00002, 1.00002, 1.00002, 1.00026, 0.99977, 0.99977, 0.99977, 0.99977, 0.99977, 0.99977, 1, 0.99977, 1.00001, 1.00001, 1.00001, 1.00001, 1.0006, 1.0006, 1.0006, 1.0006, 0.99977, 0.99977, 1.00022, 1.00022, 1.00022, 1.00022, 1.00022, 1.00003, 1.00022, 0.99977, 0.99977, 0.99977, 0.99977, 1.00001, 1.00001, 1.00026, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99982, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 1.0006, 1.0006, 1.0006, 1.0006, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 1.06409, 1.00026, 1.00026, 1.00026, 1.00026, 1.00026, 0.99973, 1.00026, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 1.0044, 0.99977, 1.00026, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00022, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 0.99971, 0.99973, 0.99973, 1.0006, 0.99977, 0.99973, 0.99973, 1.00026, 1.0006, 1.00026, 1.0006, 1.00026, 1.01011, 1.00026, 0.99999, 1.00026, 1.0006, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.9993, 0.9998, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 1.00022, 1.00026, 1, 1.00016, 0.99977, 0.99959, 0.99977, 0.99959, 0.99977, 0.99959, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00026, 0.99998, 1.00026, 0.8121, 1.00026, 0.99998, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 0.99977, 1.00026, 1.00016, 1.00022, 1.00001, 0.99973, 1.00001, 1.00026, 1, 1.00026, 1, 1.00026, 1, 1.0006, 0.99973, 0.99977, 0.99973, 1, 0.99982, 1.00022, 1.00026, 1.00001, 0.99973, 1.00026, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99977, 1, 1, 1.00026, 0.99969, 0.99972, 0.99981, 0.9998, 1.0006, 0.99977, 0.99977, 1.00022, 0.91155, 1.00001, 1.00026, 0.99977, 1.00022, 1.0006, 0.99977, 1.00001, 0.99999, 0.99977, 0.99966, 1.00022, 1.00032, 1.00001, 0.99944, 1.00026, 1.00001, 0.99968, 1.00001, 1.00047, 1, 1.0006, 1.00001, 0.99981, 1.00101, 1.00026, 1.0006, 0.99948, 0.99981, 1.00064, 0.99973, 0.99942, 1.00101, 1.00061, 1.00026, 1.00069, 1.0006, 1.00014, 0.99973, 1.01322, 0.99973, 1.00065, 1.00026, 1.00012, 0.99923, 1, 1.00064, 1.00076, 0.99948, 1.00055, 1.00063, 1.00007, 0.99943, 1.0006, 0.99948, 1.00026, 0.99948, 0.99943, 1.00001, 1.00001, 1.00029, 1.00038, 1.00035, 1.00001, 1.0006, 1.0006, 0.99973, 0.99978, 1.00001, 1.00057, 0.99989, 0.99967, 0.99964, 0.99967, 0.99977, 0.99999, 0.99977, 1.00038, 0.99977, 1.00001, 0.99973, 1.00066, 0.99967, 0.99967, 1.00041, 0.99998, 0.99999, 0.99977, 1.00022, 0.99967, 1.00001, 0.99977, 1.00026, 0.99964, 1.00031, 1.00001, 0.99999, 0.99999, 1, 1.00023, 1, 1, 0.99999, 1.00035, 1.00001, 0.99999, 0.99973, 0.99977, 0.99999, 1.00058, 0.99973, 0.99973, 0.99955, 0.9995, 1.00026, 1.00026, 1.00032, 0.99989, 1.00034, 0.99999, 1.00026, 1.00026, 1.00026, 0.99973, 0.45998, 0.99973, 1.00026, 0.99973, 1.00001, 0.99999, 0.99982, 0.99994, 0.99996, 1, 1.00042, 1.00044, 1.00029, 1.00023, 0.99973, 0.99973, 1.00026, 0.99949, 1.00002, 0.99973, 1.0006, 1.0006, 1.0006, 0.99975, 1.00026, 1.00026, 1.00032, 0.98685, 0.99973, 1.00026, 1, 1, 0.99966, 1.00044, 1.00016, 1.00022, 1.00016, 1.00022, 1.00016, 1.00022, 1.00001, 0.99973, 1, 1, 0.99973, 1, 1, 0.99955, 1.0006, 1.0006, 1.0006, 1.0006, 1, 1, 1, 0.99973, 0.99973, 0.99972, 1, 1, 1.00106, 0.99999, 0.99998, 0.99998, 0.99999, 0.99998, 1.66475, 1, 0.99973, 0.99973, 1, 0.99973, 0.99971, 0.99978, 1, 1, 0.99991, 0.99984, 1.00002, 1.00002, 1.00002, 1.00002, 1.00098, 1, 1, 1, 1.00049, 1, 1, 0.99972, 1, 1.20985, 1.39713, 1.00003, 1.00031, 1.00015, 1, 0.99561, 1.00027, 1.00031, 1.00031, 0.99915, 1.00031, 1.00031, 0.99999, 1.00003, 0.99999, 0.99999, 1.41144, 1.6, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.40579, 1.40579, 1.36625, 0.99999, 1, 0.99861, 0.99861, 1, 1.00026, 1.00026, 1.00026, 1.00026, 0.99972, 0.99999, 0.99999, 0.99999, 0.99999, 1.40483, 1, 0.99977, 1.00054, 1, 1, 0.99953, 0.99962, 1.00042, 0.9995, 1, 1, 1, 1, 1, 1, 1, 1, 0.99998, 0.99998, 0.99998, 0.99998, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.HelveticaBoldItalicFactors = HelveticaBoldItalicFactors;
	const HelveticaBoldItalicMetrics = {
	  lineHeight: 1.35,
	  lineGap: 0.2
	};
	exports.HelveticaBoldItalicMetrics = HelveticaBoldItalicMetrics;
	const HelveticaItalicFactors = [0.76116, 1, 1, 1.0006, 1.0006, 1.00006, 0.99973, 0.99973, 0.99982, 1.00001, 1.00043, 0.99998, 0.99998, 0.99959, 1.00003, 1.0006, 0.99998, 1.0006, 1.0006, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 1.0006, 1, 1.00003, 1.00003, 1.00003, 0.99973, 0.99987, 1.00001, 1.00001, 0.99977, 0.99977, 1.00001, 1.00026, 1.00022, 0.99977, 1.0006, 1, 1.00001, 0.99973, 0.99999, 0.99977, 1.00022, 1.00001, 1.00022, 0.99977, 1.00001, 1.00026, 0.99977, 1.00001, 1.00016, 1.00001, 1.00001, 1.00026, 1.0006, 1.0006, 1.0006, 0.99949, 0.99973, 0.99998, 0.99973, 0.99973, 1, 0.99973, 0.99973, 1.0006, 0.99973, 0.99973, 0.99924, 0.99924, 1, 0.99924, 0.99999, 0.99973, 0.99973, 0.99973, 0.99973, 0.99998, 1, 1.0006, 0.99973, 1, 0.99977, 1, 1, 1, 1.00005, 1.0009, 1.00005, 1.00003, 0.99998, 0.99973, 0.99973, 0.99973, 0.99973, 1.0009, 0.99973, 0.99998, 1.00025, 0.99968, 0.99973, 1.00003, 1.00025, 0.60299, 1.00024, 1.06409, 1, 1, 0.99998, 1, 0.9998, 1.0006, 0.99998, 1, 0.99936, 0.99973, 1.00002, 1.00002, 1.00002, 1.00026, 1.00001, 1.00001, 1.00001, 1.00001, 1.00001, 1.00001, 1, 0.99977, 1.00001, 1.00001, 1.00001, 1.00001, 1.0006, 1.0006, 1.0006, 1.0006, 0.99977, 0.99977, 1.00022, 1.00022, 1.00022, 1.00022, 1.00022, 1.00003, 1.00022, 0.99977, 0.99977, 0.99977, 0.99977, 1.00001, 1.00001, 1.00026, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99982, 1, 0.99973, 0.99973, 0.99973, 0.99973, 1.0006, 1.0006, 1.0006, 1.0006, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 1.06409, 1.00026, 0.99973, 0.99973, 0.99973, 0.99973, 1, 0.99973, 1, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 0.99977, 1, 0.99977, 1, 0.99977, 1, 0.99977, 1, 0.99977, 1.0288, 0.99977, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 0.99924, 1.0006, 1.0006, 0.99946, 1.00034, 1, 0.99924, 1.00001, 1, 1, 0.99973, 0.99924, 0.99973, 0.99924, 0.99973, 1.06311, 0.99973, 1.00024, 0.99973, 0.99924, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 1.00041, 0.9998, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1, 1.00016, 0.99977, 0.99998, 0.99977, 0.99998, 0.99977, 0.99998, 1.00001, 1, 1.00001, 1, 1.00001, 1, 1.00001, 1, 1.00026, 1.0006, 1.00026, 0.89547, 1.00026, 1.0006, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 1.00016, 0.99977, 1.00001, 1, 1.00001, 1.00026, 1, 1.00026, 1, 1.00026, 1, 0.99924, 0.99973, 1.00001, 0.99973, 1, 0.99982, 1.00022, 1.00026, 1.00001, 1, 1.00026, 1.0006, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 1.00001, 1, 1.00054, 0.99977, 1.00084, 1.00007, 0.99973, 1.00013, 0.99924, 1.00001, 1.00001, 0.99945, 0.91221, 1.00001, 1.00026, 0.99977, 1.00022, 1.0006, 1.00001, 1.00001, 0.99999, 0.99977, 0.99933, 1.00022, 1.00054, 1.00001, 1.00065, 1.00026, 1.00001, 1.0001, 1.00001, 1.00052, 1, 1.0006, 1.00001, 0.99945, 0.99897, 0.99968, 0.99924, 1.00036, 0.99945, 0.99949, 1, 1.0006, 0.99897, 0.99918, 0.99968, 0.99911, 0.99924, 1, 0.99962, 1.01487, 1, 1.0005, 0.99973, 1.00012, 1.00043, 1, 0.99995, 0.99994, 1.00036, 0.99947, 1.00019, 1.00063, 1.00025, 0.99924, 1.00036, 0.99973, 1.00036, 1.00025, 1.00001, 1.00001, 1.00027, 1.0001, 1.00068, 1.00001, 1.0006, 1.0006, 1, 1.00008, 0.99957, 0.99972, 0.9994, 0.99954, 0.99975, 1.00051, 1.00001, 1.00019, 1.00001, 1.0001, 0.99986, 1.00001, 1.00001, 1.00038, 0.99954, 0.99954, 0.9994, 1.00066, 0.99999, 0.99977, 1.00022, 1.00054, 1.00001, 0.99977, 1.00026, 0.99975, 1.0001, 1.00001, 0.99993, 0.9995, 0.99955, 1.00016, 0.99978, 0.99974, 1.00019, 1.00022, 0.99955, 1.00053, 0.99973, 1.00089, 1.00005, 0.99967, 1.00048, 0.99973, 1.00002, 1.00034, 0.99973, 0.99973, 0.99964, 1.00006, 1.00066, 0.99947, 0.99973, 0.98894, 0.99973, 1, 0.44898, 1, 0.99946, 1, 1.00039, 1.00082, 0.99991, 0.99991, 0.99985, 1.00022, 1.00023, 1.00061, 1.00006, 0.99966, 0.99973, 0.99973, 0.99973, 1.00019, 1.0008, 1, 0.99924, 0.99924, 0.99924, 0.99983, 1.00044, 0.99973, 0.99964, 0.98332, 1, 0.99973, 1, 1, 0.99962, 0.99895, 1.00016, 0.99977, 1.00016, 0.99977, 1.00016, 0.99977, 1.00001, 1, 1, 1, 0.99973, 1, 1, 0.99955, 0.99924, 0.99924, 0.99924, 0.99924, 0.99998, 0.99998, 0.99998, 0.99973, 0.99973, 0.99972, 1, 1, 1.00267, 0.99999, 0.99998, 0.99998, 1, 0.99998, 1.66475, 1, 0.99973, 0.99973, 1.00023, 0.99973, 1.00423, 0.99925, 0.99999, 1, 0.99991, 0.99984, 1.00002, 1.00002, 1.00002, 1.00002, 1.00049, 1, 1.00245, 1, 1, 1, 1, 0.96329, 1, 1.20985, 1.39713, 1.00003, 0.8254, 1.00015, 1, 1.00035, 1.00027, 1.00031, 1.00031, 1.00003, 1.00031, 1.00031, 0.99999, 1.00003, 0.99999, 0.99999, 1.41144, 1.6, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.40579, 1.40579, 1.36625, 0.99999, 1, 0.99861, 0.99861, 1, 1.00026, 1.00026, 1.00026, 1.00026, 0.95317, 0.99999, 0.99999, 0.99999, 0.99999, 1.40483, 1, 0.99977, 1.00054, 1, 1, 0.99953, 0.99962, 1.00042, 0.9995, 1, 1, 1, 1, 1, 1, 1, 1, 0.99998, 0.99998, 0.99998, 0.99998, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.HelveticaItalicFactors = HelveticaItalicFactors;
	const HelveticaItalicMetrics = {
	  lineHeight: 1.35,
	  lineGap: 0.2
	};
	exports.HelveticaItalicMetrics = HelveticaItalicMetrics;
	const HelveticaRegularFactors = [0.76116, 1, 1, 1.0006, 1.0006, 1.00006, 0.99973, 0.99973, 0.99982, 1.00001, 1.00043, 0.99998, 0.99998, 0.99959, 1.00003, 1.0006, 0.99998, 1.0006, 1.0006, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 1.0006, 1, 1.00003, 1.00003, 1.00003, 0.99973, 0.99987, 1.00001, 1.00001, 0.99977, 0.99977, 1.00001, 1.00026, 1.00022, 0.99977, 1.0006, 1, 1.00001, 0.99973, 0.99999, 0.99977, 1.00022, 1.00001, 1.00022, 0.99977, 1.00001, 1.00026, 0.99977, 1.00001, 1.00016, 1.00001, 1.00001, 1.00026, 1.0006, 1.0006, 1.0006, 0.99949, 0.99973, 0.99998, 0.99973, 0.99973, 1, 0.99973, 0.99973, 1.0006, 0.99973, 0.99973, 0.99924, 0.99924, 1, 0.99924, 0.99999, 0.99973, 0.99973, 0.99973, 0.99973, 0.99998, 1, 1.0006, 0.99973, 1, 0.99977, 1, 1, 1, 1.00005, 1.0009, 1.00005, 1.00003, 0.99998, 0.99973, 0.99973, 0.99973, 0.99973, 1.0009, 0.99973, 0.99998, 1.00025, 0.99968, 0.99973, 1.00003, 1.00025, 0.60299, 1.00024, 1.06409, 1, 1, 0.99998, 1, 0.9998, 1.0006, 0.99998, 1, 0.99936, 0.99973, 1.00002, 1.00002, 1.00002, 1.00026, 1.00001, 1.00001, 1.00001, 1.00001, 1.00001, 1.00001, 1, 0.99977, 1.00001, 1.00001, 1.00001, 1.00001, 1.0006, 1.0006, 1.0006, 1.0006, 0.99977, 0.99977, 1.00022, 1.00022, 1.00022, 1.00022, 1.00022, 1.00003, 1.00022, 0.99977, 0.99977, 0.99977, 0.99977, 1.00001, 1.00001, 1.00026, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99982, 1, 0.99973, 0.99973, 0.99973, 0.99973, 1.0006, 1.0006, 1.0006, 1.0006, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 0.99973, 1.06409, 1.00026, 0.99973, 0.99973, 0.99973, 0.99973, 1, 0.99973, 1, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 0.99977, 1, 0.99977, 1, 0.99977, 1, 0.99977, 1, 0.99977, 1.04596, 0.99977, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00001, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 1.0006, 0.99924, 1.0006, 1.0006, 1.00019, 1.00034, 1, 0.99924, 1.00001, 1, 1, 0.99973, 0.99924, 0.99973, 0.99924, 0.99973, 1.02572, 0.99973, 1.00005, 0.99973, 0.99924, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99999, 0.9998, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1.00022, 0.99973, 1, 1.00016, 0.99977, 0.99998, 0.99977, 0.99998, 0.99977, 0.99998, 1.00001, 1, 1.00001, 1, 1.00001, 1, 1.00001, 1, 1.00026, 1.0006, 1.00026, 0.84533, 1.00026, 1.0006, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 0.99977, 0.99973, 1.00016, 0.99977, 1.00001, 1, 1.00001, 1.00026, 1, 1.00026, 1, 1.00026, 1, 0.99924, 0.99973, 1.00001, 0.99973, 1, 0.99982, 1.00022, 1.00026, 1.00001, 1, 1.00026, 1.0006, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99998, 0.99928, 1, 0.99977, 1.00013, 1.00055, 0.99947, 0.99945, 0.99941, 0.99924, 1.00001, 1.00001, 1.0004, 0.91621, 1.00001, 1.00026, 0.99977, 1.00022, 1.0006, 1.00001, 1.00005, 0.99999, 0.99977, 1.00015, 1.00022, 0.99977, 1.00001, 0.99973, 1.00026, 1.00001, 1.00019, 1.00001, 0.99946, 1, 1.0006, 1.00001, 0.99978, 1.00045, 0.99973, 0.99924, 1.00023, 0.99978, 0.99966, 1, 1.00065, 1.00045, 1.00019, 0.99973, 0.99973, 0.99924, 1, 1, 0.96499, 1, 1.00055, 0.99973, 1.00008, 1.00027, 1, 0.9997, 0.99995, 1.00023, 0.99933, 1.00019, 1.00015, 1.00031, 0.99924, 1.00023, 0.99973, 1.00023, 1.00031, 1.00001, 0.99928, 1.00029, 1.00092, 1.00035, 1.00001, 1.0006, 1.0006, 1, 0.99988, 0.99975, 1, 1.00082, 0.99561, 0.9996, 1.00035, 1.00001, 0.99962, 1.00001, 1.00092, 0.99964, 1.00001, 0.99963, 0.99999, 1.00035, 1.00035, 1.00082, 0.99962, 0.99999, 0.99977, 1.00022, 1.00035, 1.00001, 0.99977, 1.00026, 0.9996, 0.99967, 1.00001, 1.00034, 1.00074, 1.00054, 1.00053, 1.00063, 0.99971, 0.99962, 1.00035, 0.99975, 0.99977, 0.99973, 1.00043, 0.99953, 1.0007, 0.99915, 0.99973, 1.00008, 0.99892, 1.00073, 1.00073, 1.00114, 0.99915, 1.00073, 0.99955, 0.99973, 1.00092, 0.99973, 1, 0.99998, 1, 1.0003, 1, 1.00043, 1.00001, 0.99969, 1.0003, 1, 1.00035, 1.00001, 0.9995, 1, 1.00092, 0.99973, 0.99973, 0.99973, 1.0007, 0.9995, 1, 0.99924, 1.0006, 0.99924, 0.99972, 1.00062, 0.99973, 1.00114, 1.00073, 1, 0.99955, 1, 1, 1.00047, 0.99968, 1.00016, 0.99977, 1.00016, 0.99977, 1.00016, 0.99977, 1.00001, 1, 1, 1, 0.99973, 1, 1, 0.99955, 0.99924, 0.99924, 0.99924, 0.99924, 0.99998, 0.99998, 0.99998, 0.99973, 0.99973, 0.99972, 1, 1, 1.00267, 0.99999, 0.99998, 0.99998, 1, 0.99998, 1.66475, 1, 0.99973, 0.99973, 1.00023, 0.99973, 0.99971, 0.99925, 1.00023, 1, 0.99991, 0.99984, 1.00002, 1.00002, 1.00002, 1.00002, 1, 1, 1, 1, 1, 1, 1, 0.96329, 1, 1.20985, 1.39713, 1.00003, 0.8254, 1.00015, 1, 1.00035, 1.00027, 1.00031, 1.00031, 0.99915, 1.00031, 1.00031, 0.99999, 1.00003, 0.99999, 0.99999, 1.41144, 1.6, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.41144, 1.40579, 1.40579, 1.36625, 0.99999, 1, 0.99861, 0.99861, 1, 1.00026, 1.00026, 1.00026, 1.00026, 0.95317, 0.99999, 0.99999, 0.99999, 0.99999, 1.40483, 1, 0.99977, 1.00054, 1, 1, 0.99953, 0.99962, 1.00042, 0.9995, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.HelveticaRegularFactors = HelveticaRegularFactors;
	const HelveticaRegularMetrics = {
	  lineHeight: 1.2,
	  lineGap: 0.2
	};
	exports.HelveticaRegularMetrics = HelveticaRegularMetrics;

	/***/ }),
	/* 54 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.LiberationSansRegularWidths = exports.LiberationSansRegularMapping = exports.LiberationSansItalicWidths = exports.LiberationSansItalicMapping = exports.LiberationSansBoldWidths = exports.LiberationSansBoldMapping = exports.LiberationSansBoldItalicWidths = exports.LiberationSansBoldItalicMapping = void 0;
	const LiberationSansBoldWidths = [365, 0, 333, 278, 333, 474, 556, 556, 889, 722, 238, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556, 556, 556, 556, 556, 333, 333, 584, 584, 584, 611, 975, 722, 722, 722, 722, 667, 611, 778, 722, 278, 556, 722, 611, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 667, 667, 611, 333, 278, 333, 584, 556, 333, 556, 611, 556, 611, 556, 333, 611, 611, 278, 278, 556, 278, 889, 611, 611, 611, 611, 389, 556, 333, 611, 556, 778, 556, 556, 500, 389, 280, 389, 584, 333, 556, 556, 556, 556, 280, 556, 333, 737, 370, 556, 584, 737, 552, 400, 549, 333, 333, 333, 576, 556, 278, 333, 333, 365, 556, 834, 834, 834, 611, 722, 722, 722, 722, 722, 722, 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584, 778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 556, 556, 556, 556, 556, 278, 278, 278, 278, 611, 611, 611, 611, 611, 611, 611, 549, 611, 611, 611, 611, 611, 556, 611, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 719, 722, 611, 667, 556, 667, 556, 667, 556, 667, 556, 667, 556, 778, 611, 778, 611, 778, 611, 778, 611, 722, 611, 722, 611, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 785, 556, 556, 278, 722, 556, 556, 611, 278, 611, 278, 611, 385, 611, 479, 611, 278, 722, 611, 722, 611, 722, 611, 708, 723, 611, 778, 611, 778, 611, 778, 611, 1000, 944, 722, 389, 722, 389, 722, 389, 667, 556, 667, 556, 667, 556, 667, 556, 611, 333, 611, 479, 611, 333, 722, 611, 722, 611, 722, 611, 722, 611, 722, 611, 722, 611, 944, 778, 667, 556, 667, 611, 500, 611, 500, 611, 500, 278, 556, 722, 556, 1000, 889, 778, 611, 667, 556, 611, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 465, 722, 333, 853, 906, 474, 825, 927, 838, 278, 722, 722, 601, 719, 667, 611, 722, 778, 278, 722, 667, 833, 722, 644, 778, 722, 667, 600, 611, 667, 821, 667, 809, 802, 278, 667, 615, 451, 611, 278, 582, 615, 610, 556, 606, 475, 460, 611, 541, 278, 558, 556, 612, 556, 445, 611, 766, 619, 520, 684, 446, 582, 715, 576, 753, 845, 278, 582, 611, 582, 845, 667, 669, 885, 567, 711, 667, 278, 276, 556, 1094, 1062, 875, 610, 722, 622, 719, 722, 719, 722, 567, 712, 667, 904, 626, 719, 719, 610, 702, 833, 722, 778, 719, 667, 722, 611, 622, 854, 667, 730, 703, 1005, 1019, 870, 979, 719, 711, 1031, 719, 556, 618, 615, 417, 635, 556, 709, 497, 615, 615, 500, 635, 740, 604, 611, 604, 611, 556, 490, 556, 875, 556, 615, 581, 833, 844, 729, 854, 615, 552, 854, 583, 556, 556, 611, 417, 552, 556, 278, 281, 278, 969, 906, 611, 500, 615, 556, 604, 778, 611, 487, 447, 944, 778, 944, 778, 944, 778, 667, 556, 333, 333, 556, 1000, 1000, 552, 278, 278, 278, 278, 500, 500, 500, 556, 556, 350, 1000, 1000, 240, 479, 333, 333, 604, 333, 167, 396, 556, 556, 1094, 556, 885, 489, 1115, 1000, 768, 600, 834, 834, 834, 834, 1000, 500, 1000, 500, 1000, 500, 500, 494, 612, 823, 713, 584, 549, 713, 979, 722, 274, 549, 549, 583, 549, 549, 604, 584, 604, 604, 708, 625, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 729, 604, 604, 354, 354, 1000, 990, 990, 990, 990, 494, 604, 604, 604, 604, 354, 1021, 1052, 917, 750, 750, 531, 656, 594, 510, 500, 750, 750, 611, 611, 333, 333, 333, 333, 333, 333, 333, 333, 222, 222, 333, 333, 333, 333, 333, 333, 333, 333];
	exports.LiberationSansBoldWidths = LiberationSansBoldWidths;
	const LiberationSansBoldMapping = [-1, -1, -1, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255, 256, 257, 258, 259, 260, 261, 262, 263, 264, 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 283, 284, 285, 286, 287, 288, 289, 290, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332, 333, 334, 335, 336, 337, 338, 339, 340, 341, 342, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359, 360, 361, 362, 363, 364, 365, 366, 367, 368, 369, 370, 371, 372, 373, 374, 375, 376, 377, 378, 379, 380, 381, 382, 383, 402, 506, 507, 508, 509, 510, 511, 536, 537, 538, 539, 710, 711, 713, 728, 729, 730, 731, 732, 733, 900, 901, 902, 903, 904, 905, 906, 908, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1138, 1139, 1168, 1169, 7808, 7809, 7810, 7811, 7812, 7813, 7922, 7923, 8208, 8209, 8211, 8212, 8213, 8215, 8216, 8217, 8218, 8219, 8220, 8221, 8222, 8224, 8225, 8226, 8230, 8240, 8242, 8243, 8249, 8250, 8252, 8254, 8260, 8319, 8355, 8356, 8359, 8364, 8453, 8467, 8470, 8482, 8486, 8494, 8539, 8540, 8541, 8542, 8592, 8593, 8594, 8595, 8596, 8597, 8616, 8706, 8710, 8719, 8721, 8722, 8730, 8734, 8735, 8745, 8747, 8776, 8800, 8801, 8804, 8805, 8962, 8976, 8992, 8993, 9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9552, 9553, 9554, 9555, 9556, 9557, 9558, 9559, 9560, 9561, 9562, 9563, 9564, 9565, 9566, 9567, 9568, 9569, 9570, 9571, 9572, 9573, 9574, 9575, 9576, 9577, 9578, 9579, 9580, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 9632, 9633, 9642, 9643, 9644, 9650, 9658, 9660, 9668, 9674, 9675, 9679, 9688, 9689, 9702, 9786, 9787, 9788, 9792, 9794, 9824, 9827, 9829, 9830, 9834, 9835, 9836, 61441, 61442, 61445, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
	exports.LiberationSansBoldMapping = LiberationSansBoldMapping;
	const LiberationSansBoldItalicWidths = [365, 0, 333, 278, 333, 474, 556, 556, 889, 722, 238, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556, 556, 556, 556, 556, 333, 333, 584, 584, 584, 611, 975, 722, 722, 722, 722, 667, 611, 778, 722, 278, 556, 722, 611, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 667, 667, 611, 333, 278, 333, 584, 556, 333, 556, 611, 556, 611, 556, 333, 611, 611, 278, 278, 556, 278, 889, 611, 611, 611, 611, 389, 556, 333, 611, 556, 778, 556, 556, 500, 389, 280, 389, 584, 333, 556, 556, 556, 556, 280, 556, 333, 737, 370, 556, 584, 737, 552, 400, 549, 333, 333, 333, 576, 556, 278, 333, 333, 365, 556, 834, 834, 834, 611, 722, 722, 722, 722, 722, 722, 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584, 778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 556, 556, 556, 556, 556, 278, 278, 278, 278, 611, 611, 611, 611, 611, 611, 611, 549, 611, 611, 611, 611, 611, 556, 611, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 740, 722, 611, 667, 556, 667, 556, 667, 556, 667, 556, 667, 556, 778, 611, 778, 611, 778, 611, 778, 611, 722, 611, 722, 611, 278, 278, 278, 278, 278, 278, 278, 278, 278, 278, 782, 556, 556, 278, 722, 556, 556, 611, 278, 611, 278, 611, 396, 611, 479, 611, 278, 722, 611, 722, 611, 722, 611, 708, 723, 611, 778, 611, 778, 611, 778, 611, 1000, 944, 722, 389, 722, 389, 722, 389, 667, 556, 667, 556, 667, 556, 667, 556, 611, 333, 611, 479, 611, 333, 722, 611, 722, 611, 722, 611, 722, 611, 722, 611, 722, 611, 944, 778, 667, 556, 667, 611, 500, 611, 500, 611, 500, 278, 556, 722, 556, 1000, 889, 778, 611, 667, 556, 611, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 722, 333, 854, 906, 473, 844, 930, 847, 278, 722, 722, 610, 671, 667, 611, 722, 778, 278, 722, 667, 833, 722, 657, 778, 718, 667, 590, 611, 667, 822, 667, 829, 781, 278, 667, 620, 479, 611, 278, 591, 620, 621, 556, 610, 479, 492, 611, 558, 278, 566, 556, 603, 556, 450, 611, 712, 605, 532, 664, 409, 591, 704, 578, 773, 834, 278, 591, 611, 591, 834, 667, 667, 886, 614, 719, 667, 278, 278, 556, 1094, 1042, 854, 622, 719, 677, 719, 722, 708, 722, 614, 722, 667, 927, 643, 719, 719, 615, 687, 833, 722, 778, 719, 667, 722, 611, 677, 781, 667, 729, 708, 979, 989, 854, 1000, 708, 719, 1042, 729, 556, 619, 604, 534, 618, 556, 736, 510, 611, 611, 507, 622, 740, 604, 611, 611, 611, 556, 889, 556, 885, 556, 646, 583, 889, 935, 707, 854, 594, 552, 865, 589, 556, 556, 611, 469, 563, 556, 278, 278, 278, 969, 906, 611, 507, 619, 556, 611, 778, 611, 575, 467, 944, 778, 944, 778, 944, 778, 667, 556, 333, 333, 556, 1000, 1000, 552, 278, 278, 278, 278, 500, 500, 500, 556, 556, 350, 1000, 1000, 240, 479, 333, 333, 604, 333, 167, 396, 556, 556, 1104, 556, 885, 516, 1146, 1000, 768, 600, 834, 834, 834, 834, 999, 500, 1000, 500, 1000, 500, 500, 494, 612, 823, 713, 584, 549, 713, 979, 722, 274, 549, 549, 583, 549, 549, 604, 584, 604, 604, 708, 625, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 729, 604, 604, 354, 354, 1000, 990, 990, 990, 990, 494, 604, 604, 604, 604, 354, 1021, 1052, 917, 750, 750, 531, 656, 594, 510, 500, 750, 750, 611, 611, 333, 333, 333, 333, 333, 333, 333, 333, 222, 222, 333, 333, 333, 333, 333, 333, 333, 333];
	exports.LiberationSansBoldItalicWidths = LiberationSansBoldItalicWidths;
	const LiberationSansBoldItalicMapping = [-1, -1, -1, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255, 256, 257, 258, 259, 260, 261, 262, 263, 264, 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 283, 284, 285, 286, 287, 288, 289, 290, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332, 333, 334, 335, 336, 337, 338, 339, 340, 341, 342, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359, 360, 361, 362, 363, 364, 365, 366, 367, 368, 369, 370, 371, 372, 373, 374, 375, 376, 377, 378, 379, 380, 381, 382, 383, 402, 506, 507, 508, 509, 510, 511, 536, 537, 538, 539, 710, 711, 713, 728, 729, 730, 731, 732, 733, 900, 901, 902, 903, 904, 905, 906, 908, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1138, 1139, 1168, 1169, 7808, 7809, 7810, 7811, 7812, 7813, 7922, 7923, 8208, 8209, 8211, 8212, 8213, 8215, 8216, 8217, 8218, 8219, 8220, 8221, 8222, 8224, 8225, 8226, 8230, 8240, 8242, 8243, 8249, 8250, 8252, 8254, 8260, 8319, 8355, 8356, 8359, 8364, 8453, 8467, 8470, 8482, 8486, 8494, 8539, 8540, 8541, 8542, 8592, 8593, 8594, 8595, 8596, 8597, 8616, 8706, 8710, 8719, 8721, 8722, 8730, 8734, 8735, 8745, 8747, 8776, 8800, 8801, 8804, 8805, 8962, 8976, 8992, 8993, 9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9552, 9553, 9554, 9555, 9556, 9557, 9558, 9559, 9560, 9561, 9562, 9563, 9564, 9565, 9566, 9567, 9568, 9569, 9570, 9571, 9572, 9573, 9574, 9575, 9576, 9577, 9578, 9579, 9580, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 9632, 9633, 9642, 9643, 9644, 9650, 9658, 9660, 9668, 9674, 9675, 9679, 9688, 9689, 9702, 9786, 9787, 9788, 9792, 9794, 9824, 9827, 9829, 9830, 9834, 9835, 9836, 61441, 61442, 61445, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
	exports.LiberationSansBoldItalicMapping = LiberationSansBoldItalicMapping;
	const LiberationSansItalicWidths = [365, 0, 333, 278, 278, 355, 556, 556, 889, 667, 191, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556, 556, 556, 556, 556, 278, 278, 584, 584, 584, 556, 1015, 667, 667, 722, 722, 667, 611, 778, 722, 278, 500, 667, 556, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 667, 667, 611, 278, 278, 278, 469, 556, 333, 556, 556, 500, 556, 556, 278, 556, 556, 222, 222, 500, 222, 833, 556, 556, 556, 556, 333, 500, 278, 556, 500, 722, 500, 500, 500, 334, 260, 334, 584, 333, 556, 556, 556, 556, 260, 556, 333, 737, 370, 556, 584, 737, 552, 400, 549, 333, 333, 333, 576, 537, 278, 333, 333, 365, 556, 834, 834, 834, 611, 667, 667, 667, 667, 667, 667, 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584, 778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 500, 556, 556, 556, 556, 278, 278, 278, 278, 556, 556, 556, 556, 556, 556, 556, 549, 611, 556, 556, 556, 556, 500, 556, 500, 667, 556, 667, 556, 667, 556, 722, 500, 722, 500, 722, 500, 722, 500, 722, 625, 722, 556, 667, 556, 667, 556, 667, 556, 667, 556, 667, 556, 778, 556, 778, 556, 778, 556, 778, 556, 722, 556, 722, 556, 278, 278, 278, 278, 278, 278, 278, 222, 278, 278, 733, 444, 500, 222, 667, 500, 500, 556, 222, 556, 222, 556, 281, 556, 400, 556, 222, 722, 556, 722, 556, 722, 556, 615, 723, 556, 778, 556, 778, 556, 778, 556, 1000, 944, 722, 333, 722, 333, 722, 333, 667, 500, 667, 500, 667, 500, 667, 500, 611, 278, 611, 354, 611, 278, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 944, 722, 667, 500, 667, 611, 500, 611, 500, 611, 500, 222, 556, 667, 556, 1000, 889, 778, 611, 667, 500, 611, 278, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 667, 278, 789, 846, 389, 794, 865, 775, 222, 667, 667, 570, 671, 667, 611, 722, 778, 278, 667, 667, 833, 722, 648, 778, 725, 667, 600, 611, 667, 837, 667, 831, 761, 278, 667, 570, 439, 555, 222, 550, 570, 571, 500, 556, 439, 463, 555, 542, 222, 500, 492, 548, 500, 447, 556, 670, 573, 486, 603, 374, 550, 652, 546, 728, 779, 222, 550, 556, 550, 779, 667, 667, 843, 544, 708, 667, 278, 278, 500, 1066, 982, 844, 589, 715, 639, 724, 667, 651, 667, 544, 704, 667, 917, 614, 715, 715, 589, 686, 833, 722, 778, 725, 667, 722, 611, 639, 795, 667, 727, 673, 920, 923, 805, 886, 651, 694, 1022, 682, 556, 562, 522, 493, 553, 556, 688, 465, 556, 556, 472, 564, 686, 550, 556, 556, 556, 500, 833, 500, 835, 500, 572, 518, 830, 851, 621, 736, 526, 492, 752, 534, 556, 556, 556, 378, 496, 500, 222, 222, 222, 910, 828, 556, 472, 565, 500, 556, 778, 556, 492, 339, 944, 722, 944, 722, 944, 722, 667, 500, 333, 333, 556, 1000, 1000, 552, 222, 222, 222, 222, 333, 333, 333, 556, 556, 350, 1000, 1000, 188, 354, 333, 333, 500, 333, 167, 365, 556, 556, 1094, 556, 885, 323, 1083, 1000, 768, 600, 834, 834, 834, 834, 1000, 500, 998, 500, 1000, 500, 500, 494, 612, 823, 713, 584, 549, 713, 979, 719, 274, 549, 549, 584, 549, 549, 604, 584, 604, 604, 708, 625, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 729, 604, 604, 354, 354, 1000, 990, 990, 990, 990, 494, 604, 604, 604, 604, 354, 1021, 1052, 917, 750, 750, 531, 656, 594, 510, 500, 750, 750, 500, 500, 333, 333, 333, 333, 333, 333, 333, 333, 222, 222, 294, 294, 324, 324, 316, 328, 398, 285];
	exports.LiberationSansItalicWidths = LiberationSansItalicWidths;
	const LiberationSansItalicMapping = [-1, -1, -1, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255, 256, 257, 258, 259, 260, 261, 262, 263, 264, 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 283, 284, 285, 286, 287, 288, 289, 290, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332, 333, 334, 335, 336, 337, 338, 339, 340, 341, 342, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359, 360, 361, 362, 363, 364, 365, 366, 367, 368, 369, 370, 371, 372, 373, 374, 375, 376, 377, 378, 379, 380, 381, 382, 383, 402, 506, 507, 508, 509, 510, 511, 536, 537, 538, 539, 710, 711, 713, 728, 729, 730, 731, 732, 733, 900, 901, 902, 903, 904, 905, 906, 908, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1138, 1139, 1168, 1169, 7808, 7809, 7810, 7811, 7812, 7813, 7922, 7923, 8208, 8209, 8211, 8212, 8213, 8215, 8216, 8217, 8218, 8219, 8220, 8221, 8222, 8224, 8225, 8226, 8230, 8240, 8242, 8243, 8249, 8250, 8252, 8254, 8260, 8319, 8355, 8356, 8359, 8364, 8453, 8467, 8470, 8482, 8486, 8494, 8539, 8540, 8541, 8542, 8592, 8593, 8594, 8595, 8596, 8597, 8616, 8706, 8710, 8719, 8721, 8722, 8730, 8734, 8735, 8745, 8747, 8776, 8800, 8801, 8804, 8805, 8962, 8976, 8992, 8993, 9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9552, 9553, 9554, 9555, 9556, 9557, 9558, 9559, 9560, 9561, 9562, 9563, 9564, 9565, 9566, 9567, 9568, 9569, 9570, 9571, 9572, 9573, 9574, 9575, 9576, 9577, 9578, 9579, 9580, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 9632, 9633, 9642, 9643, 9644, 9650, 9658, 9660, 9668, 9674, 9675, 9679, 9688, 9689, 9702, 9786, 9787, 9788, 9792, 9794, 9824, 9827, 9829, 9830, 9834, 9835, 9836, 61441, 61442, 61445, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
	exports.LiberationSansItalicMapping = LiberationSansItalicMapping;
	const LiberationSansRegularWidths = [365, 0, 333, 278, 278, 355, 556, 556, 889, 667, 191, 333, 333, 389, 584, 278, 333, 278, 278, 556, 556, 556, 556, 556, 556, 556, 556, 556, 556, 278, 278, 584, 584, 584, 556, 1015, 667, 667, 722, 722, 667, 611, 778, 722, 278, 500, 667, 556, 833, 722, 778, 667, 778, 722, 667, 611, 722, 667, 944, 667, 667, 611, 278, 278, 278, 469, 556, 333, 556, 556, 500, 556, 556, 278, 556, 556, 222, 222, 500, 222, 833, 556, 556, 556, 556, 333, 500, 278, 556, 500, 722, 500, 500, 500, 334, 260, 334, 584, 333, 556, 556, 556, 556, 260, 556, 333, 737, 370, 556, 584, 737, 552, 400, 549, 333, 333, 333, 576, 537, 278, 333, 333, 365, 556, 834, 834, 834, 611, 667, 667, 667, 667, 667, 667, 1000, 722, 667, 667, 667, 667, 278, 278, 278, 278, 722, 722, 778, 778, 778, 778, 778, 584, 778, 722, 722, 722, 722, 667, 667, 611, 556, 556, 556, 556, 556, 556, 889, 500, 556, 556, 556, 556, 278, 278, 278, 278, 556, 556, 556, 556, 556, 556, 556, 549, 611, 556, 556, 556, 556, 500, 556, 500, 667, 556, 667, 556, 667, 556, 722, 500, 722, 500, 722, 500, 722, 500, 722, 615, 722, 556, 667, 556, 667, 556, 667, 556, 667, 556, 667, 556, 778, 556, 778, 556, 778, 556, 778, 556, 722, 556, 722, 556, 278, 278, 278, 278, 278, 278, 278, 222, 278, 278, 735, 444, 500, 222, 667, 500, 500, 556, 222, 556, 222, 556, 292, 556, 334, 556, 222, 722, 556, 722, 556, 722, 556, 604, 723, 556, 778, 556, 778, 556, 778, 556, 1000, 944, 722, 333, 722, 333, 722, 333, 667, 500, 667, 500, 667, 500, 667, 500, 611, 278, 611, 375, 611, 278, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 722, 556, 944, 722, 667, 500, 667, 611, 500, 611, 500, 611, 500, 222, 556, 667, 556, 1000, 889, 778, 611, 667, 500, 611, 278, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 333, 667, 278, 784, 838, 384, 774, 855, 752, 222, 667, 667, 551, 668, 667, 611, 722, 778, 278, 667, 668, 833, 722, 650, 778, 722, 667, 618, 611, 667, 798, 667, 835, 748, 278, 667, 578, 446, 556, 222, 547, 578, 575, 500, 557, 446, 441, 556, 556, 222, 500, 500, 576, 500, 448, 556, 690, 569, 482, 617, 395, 547, 648, 525, 713, 781, 222, 547, 556, 547, 781, 667, 667, 865, 542, 719, 667, 278, 278, 500, 1057, 1010, 854, 583, 722, 635, 719, 667, 656, 667, 542, 677, 667, 923, 604, 719, 719, 583, 656, 833, 722, 778, 719, 667, 722, 611, 635, 760, 667, 740, 667, 917, 938, 792, 885, 656, 719, 1010, 722, 556, 573, 531, 365, 583, 556, 669, 458, 559, 559, 438, 583, 688, 552, 556, 542, 556, 500, 458, 500, 823, 500, 573, 521, 802, 823, 625, 719, 521, 510, 750, 542, 556, 556, 556, 365, 510, 500, 222, 278, 222, 906, 812, 556, 438, 559, 500, 552, 778, 556, 489, 411, 944, 722, 944, 722, 944, 722, 667, 500, 333, 333, 556, 1000, 1000, 552, 222, 222, 222, 222, 333, 333, 333, 556, 556, 350, 1000, 1000, 188, 354, 333, 333, 500, 333, 167, 365, 556, 556, 1094, 556, 885, 323, 1073, 1000, 768, 600, 834, 834, 834, 834, 1000, 500, 1000, 500, 1000, 500, 500, 494, 612, 823, 713, 584, 549, 713, 979, 719, 274, 549, 549, 583, 549, 549, 604, 584, 604, 604, 708, 625, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 708, 729, 604, 604, 354, 354, 1000, 990, 990, 990, 990, 494, 604, 604, 604, 604, 354, 1021, 1052, 917, 750, 750, 531, 656, 594, 510, 500, 750, 750, 500, 500, 333, 333, 333, 333, 333, 333, 333, 333, 222, 222, 294, 294, 324, 324, 316, 328, 398, 285];
	exports.LiberationSansRegularWidths = LiberationSansRegularWidths;
	const LiberationSansRegularMapping = [-1, -1, -1, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 161, 162, 163, 164, 165, 166, 167, 168, 169, 170, 171, 172, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255, 256, 257, 258, 259, 260, 261, 262, 263, 264, 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277, 278, 279, 280, 281, 282, 283, 284, 285, 286, 287, 288, 289, 290, 291, 292, 293, 294, 295, 296, 297, 298, 299, 300, 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312, 313, 314, 315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 325, 326, 327, 328, 329, 330, 331, 332, 333, 334, 335, 336, 337, 338, 339, 340, 341, 342, 343, 344, 345, 346, 347, 348, 349, 350, 351, 352, 353, 354, 355, 356, 357, 358, 359, 360, 361, 362, 363, 364, 365, 366, 367, 368, 369, 370, 371, 372, 373, 374, 375, 376, 377, 378, 379, 380, 381, 382, 383, 402, 506, 507, 508, 509, 510, 511, 536, 537, 538, 539, 710, 711, 713, 728, 729, 730, 731, 732, 733, 900, 901, 902, 903, 904, 905, 906, 908, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1138, 1139, 1168, 1169, 7808, 7809, 7810, 7811, 7812, 7813, 7922, 7923, 8208, 8209, 8211, 8212, 8213, 8215, 8216, 8217, 8218, 8219, 8220, 8221, 8222, 8224, 8225, 8226, 8230, 8240, 8242, 8243, 8249, 8250, 8252, 8254, 8260, 8319, 8355, 8356, 8359, 8364, 8453, 8467, 8470, 8482, 8486, 8494, 8539, 8540, 8541, 8542, 8592, 8593, 8594, 8595, 8596, 8597, 8616, 8706, 8710, 8719, 8721, 8722, 8730, 8734, 8735, 8745, 8747, 8776, 8800, 8801, 8804, 8805, 8962, 8976, 8992, 8993, 9472, 9474, 9484, 9488, 9492, 9496, 9500, 9508, 9516, 9524, 9532, 9552, 9553, 9554, 9555, 9556, 9557, 9558, 9559, 9560, 9561, 9562, 9563, 9564, 9565, 9566, 9567, 9568, 9569, 9570, 9571, 9572, 9573, 9574, 9575, 9576, 9577, 9578, 9579, 9580, 9600, 9604, 9608, 9612, 9616, 9617, 9618, 9619, 9632, 9633, 9642, 9643, 9644, 9650, 9658, 9660, 9668, 9674, 9675, 9679, 9688, 9689, 9702, 9786, 9787, 9788, 9792, 9794, 9824, 9827, 9829, 9830, 9834, 9835, 9836, 61441, 61442, 61445, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1];
	exports.LiberationSansRegularMapping = LiberationSansRegularMapping;

	/***/ }),
	/* 55 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.MyriadProRegularMetrics = exports.MyriadProRegularFactors = exports.MyriadProItalicMetrics = exports.MyriadProItalicFactors = exports.MyriadProBoldMetrics = exports.MyriadProBoldItalicMetrics = exports.MyriadProBoldItalicFactors = exports.MyriadProBoldFactors = void 0;
	const MyriadProBoldFactors = [1.36898, 1, 1, 0.72706, 0.80479, 0.83734, 0.98894, 0.99793, 0.9897, 0.93884, 0.86209, 0.94292, 0.94292, 1.16661, 1.02058, 0.93582, 0.96694, 0.93582, 1.19137, 0.99793, 0.99793, 0.99793, 0.99793, 0.99793, 0.99793, 0.99793, 0.99793, 0.99793, 0.99793, 0.78076, 0.78076, 1.02058, 1.02058, 1.02058, 0.72851, 0.78966, 0.90838, 0.83637, 0.82391, 0.96376, 0.80061, 0.86275, 0.8768, 0.95407, 1.0258, 0.73901, 0.85022, 0.83655, 1.0156, 0.95546, 0.92179, 0.87107, 0.92179, 0.82114, 0.8096, 0.89713, 0.94438, 0.95353, 0.94083, 0.91905, 0.90406, 0.9446, 0.94292, 1.18777, 0.94292, 1.02058, 0.89903, 0.90088, 0.94938, 0.97898, 0.81093, 0.97571, 0.94938, 1.024, 0.9577, 0.95933, 0.98621, 1.0474, 0.97455, 0.98981, 0.9672, 0.95933, 0.9446, 0.97898, 0.97407, 0.97646, 0.78036, 1.10208, 0.95442, 0.95298, 0.97579, 0.9332, 0.94039, 0.938, 0.80687, 1.01149, 0.80687, 1.02058, 0.80479, 0.99793, 0.99793, 0.99793, 0.99793, 1.01149, 1.00872, 0.90088, 0.91882, 1.0213, 0.8361, 1.02058, 0.62295, 0.54324, 0.89022, 1.08595, 1, 1, 0.90088, 1, 0.97455, 0.93582, 0.90088, 1, 1.05686, 0.8361, 0.99642, 0.99642, 0.99642, 0.72851, 0.90838, 0.90838, 0.90838, 0.90838, 0.90838, 0.90838, 0.868, 0.82391, 0.80061, 0.80061, 0.80061, 0.80061, 1.0258, 1.0258, 1.0258, 1.0258, 0.97484, 0.95546, 0.92179, 0.92179, 0.92179, 0.92179, 0.92179, 1.02058, 0.92179, 0.94438, 0.94438, 0.94438, 0.94438, 0.90406, 0.86958, 0.98225, 0.94938, 0.94938, 0.94938, 0.94938, 0.94938, 0.94938, 0.9031, 0.81093, 0.94938, 0.94938, 0.94938, 0.94938, 0.98621, 0.98621, 0.98621, 0.98621, 0.93969, 0.95933, 0.9446, 0.9446, 0.9446, 0.9446, 0.9446, 1.08595, 0.9446, 0.95442, 0.95442, 0.95442, 0.95442, 0.94039, 0.97898, 0.94039, 0.90838, 0.94938, 0.90838, 0.94938, 0.90838, 0.94938, 0.82391, 0.81093, 0.82391, 0.81093, 0.82391, 0.81093, 0.82391, 0.81093, 0.96376, 0.84313, 0.97484, 0.97571, 0.80061, 0.94938, 0.80061, 0.94938, 0.80061, 0.94938, 0.80061, 0.94938, 0.80061, 0.94938, 0.8768, 0.9577, 0.8768, 0.9577, 0.8768, 0.9577, 1, 1, 0.95407, 0.95933, 0.97069, 0.95933, 1.0258, 0.98621, 1.0258, 0.98621, 1.0258, 0.98621, 1.0258, 0.98621, 1.0258, 0.98621, 0.887, 1.01591, 0.73901, 1.0474, 1, 1, 0.97455, 0.83655, 0.98981, 1, 1, 0.83655, 0.73977, 0.83655, 0.73903, 0.84638, 1.033, 0.95546, 0.95933, 1, 1, 0.95546, 0.95933, 0.8271, 0.95417, 0.95933, 0.92179, 0.9446, 0.92179, 0.9446, 0.92179, 0.9446, 0.936, 0.91964, 0.82114, 0.97646, 1, 1, 0.82114, 0.97646, 0.8096, 0.78036, 0.8096, 0.78036, 1, 1, 0.8096, 0.78036, 1, 1, 0.89713, 0.77452, 0.89713, 1.10208, 0.94438, 0.95442, 0.94438, 0.95442, 0.94438, 0.95442, 0.94438, 0.95442, 0.94438, 0.95442, 0.94438, 0.95442, 0.94083, 0.97579, 0.90406, 0.94039, 0.90406, 0.9446, 0.938, 0.9446, 0.938, 0.9446, 0.938, 1, 0.99793, 0.90838, 0.94938, 0.868, 0.9031, 0.92179, 0.9446, 1, 1, 0.89713, 1.10208, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90989, 0.9358, 0.91945, 0.83181, 0.75261, 0.87992, 0.82976, 0.96034, 0.83689, 0.97268, 1.0078, 0.90838, 0.83637, 0.8019, 0.90157, 0.80061, 0.9446, 0.95407, 0.92436, 1.0258, 0.85022, 0.97153, 1.0156, 0.95546, 0.89192, 0.92179, 0.92361, 0.87107, 0.96318, 0.89713, 0.93704, 0.95638, 0.91905, 0.91709, 0.92796, 1.0258, 0.93704, 0.94836, 1.0373, 0.95933, 1.0078, 0.95871, 0.94836, 0.96174, 0.92601, 0.9498, 0.98607, 0.95776, 0.95933, 1.05453, 1.0078, 0.98275, 0.9314, 0.95617, 0.91701, 1.05993, 0.9446, 0.78367, 0.9553, 1, 0.86832, 1.0128, 0.95871, 0.99394, 0.87548, 0.96361, 0.86774, 1.0078, 0.95871, 0.9446, 0.95871, 0.86774, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.94083, 0.97579, 0.94083, 0.97579, 0.94083, 0.97579, 0.90406, 0.94039, 0.96694, 1, 0.89903, 1, 1, 1, 0.93582, 0.93582, 0.93582, 1, 0.908, 0.908, 0.918, 0.94219, 0.94219, 0.96544, 1, 1.285, 1, 1, 0.81079, 0.81079, 1, 1, 0.74854, 1, 1, 1, 1, 0.99793, 1, 1, 1, 0.65, 1, 1.36145, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.17173, 1, 0.80535, 0.76169, 1.02058, 1.0732, 1.05486, 1, 1, 1.30692, 1.08595, 1.08595, 1, 1.08595, 1.08595, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.16161, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.MyriadProBoldFactors = MyriadProBoldFactors;
	const MyriadProBoldMetrics = {
	  lineHeight: 1.2,
	  lineGap: 0.2
	};
	exports.MyriadProBoldMetrics = MyriadProBoldMetrics;
	const MyriadProBoldItalicFactors = [1.36898, 1, 1, 0.66227, 0.80779, 0.81625, 0.97276, 0.97276, 0.97733, 0.92222, 0.83266, 0.94292, 0.94292, 1.16148, 1.02058, 0.93582, 0.96694, 0.93582, 1.17337, 0.97276, 0.97276, 0.97276, 0.97276, 0.97276, 0.97276, 0.97276, 0.97276, 0.97276, 0.97276, 0.78076, 0.78076, 1.02058, 1.02058, 1.02058, 0.71541, 0.76813, 0.85576, 0.80591, 0.80729, 0.94299, 0.77512, 0.83655, 0.86523, 0.92222, 0.98621, 0.71743, 0.81698, 0.79726, 0.98558, 0.92222, 0.90637, 0.83809, 0.90637, 0.80729, 0.76463, 0.86275, 0.90699, 0.91605, 0.9154, 0.85308, 0.85458, 0.90531, 0.94292, 1.21296, 0.94292, 1.02058, 0.89903, 1.18616, 0.99613, 0.91677, 0.78216, 0.91677, 0.90083, 0.98796, 0.9135, 0.92168, 0.95381, 0.98981, 0.95298, 0.95381, 0.93459, 0.92168, 0.91513, 0.92004, 0.91677, 0.95077, 0.748, 1.04502, 0.91677, 0.92061, 0.94236, 0.89544, 0.89364, 0.9, 0.80687, 0.8578, 0.80687, 1.02058, 0.80779, 0.97276, 0.97276, 0.97276, 0.97276, 0.8578, 0.99973, 1.18616, 0.91339, 1.08074, 0.82891, 1.02058, 0.55509, 0.71526, 0.89022, 1.08595, 1, 1, 1.18616, 1, 0.96736, 0.93582, 1.18616, 1, 1.04864, 0.82711, 0.99043, 0.99043, 0.99043, 0.71541, 0.85576, 0.85576, 0.85576, 0.85576, 0.85576, 0.85576, 0.845, 0.80729, 0.77512, 0.77512, 0.77512, 0.77512, 0.98621, 0.98621, 0.98621, 0.98621, 0.95961, 0.92222, 0.90637, 0.90637, 0.90637, 0.90637, 0.90637, 1.02058, 0.90251, 0.90699, 0.90699, 0.90699, 0.90699, 0.85458, 0.83659, 0.94951, 0.99613, 0.99613, 0.99613, 0.99613, 0.99613, 0.99613, 0.85811, 0.78216, 0.90083, 0.90083, 0.90083, 0.90083, 0.95381, 0.95381, 0.95381, 0.95381, 0.9135, 0.92168, 0.91513, 0.91513, 0.91513, 0.91513, 0.91513, 1.08595, 0.91677, 0.91677, 0.91677, 0.91677, 0.91677, 0.89364, 0.92332, 0.89364, 0.85576, 0.99613, 0.85576, 0.99613, 0.85576, 0.99613, 0.80729, 0.78216, 0.80729, 0.78216, 0.80729, 0.78216, 0.80729, 0.78216, 0.94299, 0.76783, 0.95961, 0.91677, 0.77512, 0.90083, 0.77512, 0.90083, 0.77512, 0.90083, 0.77512, 0.90083, 0.77512, 0.90083, 0.86523, 0.9135, 0.86523, 0.9135, 0.86523, 0.9135, 1, 1, 0.92222, 0.92168, 0.92222, 0.92168, 0.98621, 0.95381, 0.98621, 0.95381, 0.98621, 0.95381, 0.98621, 0.95381, 0.98621, 0.95381, 0.86036, 0.97096, 0.71743, 0.98981, 1, 1, 0.95298, 0.79726, 0.95381, 1, 1, 0.79726, 0.6894, 0.79726, 0.74321, 0.81691, 1.0006, 0.92222, 0.92168, 1, 1, 0.92222, 0.92168, 0.79464, 0.92098, 0.92168, 0.90637, 0.91513, 0.90637, 0.91513, 0.90637, 0.91513, 0.909, 0.87514, 0.80729, 0.95077, 1, 1, 0.80729, 0.95077, 0.76463, 0.748, 0.76463, 0.748, 1, 1, 0.76463, 0.748, 1, 1, 0.86275, 0.72651, 0.86275, 1.04502, 0.90699, 0.91677, 0.90699, 0.91677, 0.90699, 0.91677, 0.90699, 0.91677, 0.90699, 0.91677, 0.90699, 0.91677, 0.9154, 0.94236, 0.85458, 0.89364, 0.85458, 0.90531, 0.9, 0.90531, 0.9, 0.90531, 0.9, 1, 0.97276, 0.85576, 0.99613, 0.845, 0.85811, 0.90251, 0.91677, 1, 1, 0.86275, 1.04502, 1.18616, 1.18616, 1.18616, 1.18616, 1.18616, 1.18616, 1.18616, 1.18616, 1.18616, 1.00899, 1.30628, 0.85576, 0.80178, 0.66862, 0.7927, 0.69323, 0.88127, 0.72459, 0.89711, 0.95381, 0.85576, 0.80591, 0.7805, 0.94729, 0.77512, 0.90531, 0.92222, 0.90637, 0.98621, 0.81698, 0.92655, 0.98558, 0.92222, 0.85359, 0.90637, 0.90976, 0.83809, 0.94523, 0.86275, 0.83509, 0.93157, 0.85308, 0.83392, 0.92346, 0.98621, 0.83509, 0.92886, 0.91324, 0.92168, 0.95381, 0.90646, 0.92886, 0.90557, 0.86847, 0.90276, 0.91324, 0.86842, 0.92168, 0.99531, 0.95381, 0.9224, 0.85408, 0.92699, 0.86847, 1.0051, 0.91513, 0.80487, 0.93481, 1, 0.88159, 1.05214, 0.90646, 0.97355, 0.81539, 0.89398, 0.85923, 0.95381, 0.90646, 0.91513, 0.90646, 0.85923, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.9154, 0.94236, 0.9154, 0.94236, 0.9154, 0.94236, 0.85458, 0.89364, 0.96694, 1, 0.89903, 1, 1, 1, 0.91782, 0.91782, 0.91782, 1, 0.896, 0.896, 0.896, 0.9332, 0.9332, 0.95973, 1, 1.26, 1, 1, 0.80479, 0.80178, 1, 1, 0.85633, 1, 1, 1, 1, 0.97276, 1, 1, 1, 0.698, 1, 1.36145, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.14542, 1, 0.79199, 0.78694, 1.02058, 1.03493, 1.05486, 1, 1, 1.23026, 1.08595, 1.08595, 1, 1.08595, 1.08595, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.20006, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.MyriadProBoldItalicFactors = MyriadProBoldItalicFactors;
	const MyriadProBoldItalicMetrics = {
	  lineHeight: 1.2,
	  lineGap: 0.2
	};
	exports.MyriadProBoldItalicMetrics = MyriadProBoldItalicMetrics;
	const MyriadProItalicFactors = [1.36898, 1, 1, 0.65507, 0.84943, 0.85639, 0.88465, 0.88465, 0.86936, 0.88307, 0.86948, 0.85283, 0.85283, 1.06383, 1.02058, 0.75945, 0.9219, 0.75945, 1.17337, 0.88465, 0.88465, 0.88465, 0.88465, 0.88465, 0.88465, 0.88465, 0.88465, 0.88465, 0.88465, 0.75945, 0.75945, 1.02058, 1.02058, 1.02058, 0.69046, 0.70926, 0.85158, 0.77812, 0.76852, 0.89591, 0.70466, 0.76125, 0.80094, 0.86822, 0.83864, 0.728, 0.77212, 0.79475, 0.93637, 0.87514, 0.8588, 0.76013, 0.8588, 0.72421, 0.69866, 0.77598, 0.85991, 0.80811, 0.87832, 0.78112, 0.77512, 0.8562, 1.0222, 1.18417, 1.0222, 1.27014, 0.89903, 1.15012, 0.93859, 0.94399, 0.846, 0.94399, 0.81453, 1.0186, 0.94219, 0.96017, 1.03075, 1.02175, 0.912, 1.03075, 0.96998, 0.96017, 0.93859, 0.94399, 0.94399, 0.95493, 0.746, 1.12658, 0.94578, 0.91, 0.979, 0.882, 0.882, 0.83, 0.85034, 0.83537, 0.85034, 1.02058, 0.70869, 0.88465, 0.88465, 0.88465, 0.88465, 0.83537, 0.90083, 1.15012, 0.9161, 0.94565, 0.73541, 1.02058, 0.53609, 0.69353, 0.79519, 1.08595, 1, 1, 1.15012, 1, 0.91974, 0.75945, 1.15012, 1, 0.9446, 0.73361, 0.9005, 0.9005, 0.9005, 0.62864, 0.85158, 0.85158, 0.85158, 0.85158, 0.85158, 0.85158, 0.773, 0.76852, 0.70466, 0.70466, 0.70466, 0.70466, 0.83864, 0.83864, 0.83864, 0.83864, 0.90561, 0.87514, 0.8588, 0.8588, 0.8588, 0.8588, 0.8588, 1.02058, 0.85751, 0.85991, 0.85991, 0.85991, 0.85991, 0.77512, 0.76013, 0.88075, 0.93859, 0.93859, 0.93859, 0.93859, 0.93859, 0.93859, 0.8075, 0.846, 0.81453, 0.81453, 0.81453, 0.81453, 0.82424, 0.82424, 0.82424, 0.82424, 0.9278, 0.96017, 0.93859, 0.93859, 0.93859, 0.93859, 0.93859, 1.08595, 0.8562, 0.94578, 0.94578, 0.94578, 0.94578, 0.882, 0.94578, 0.882, 0.85158, 0.93859, 0.85158, 0.93859, 0.85158, 0.93859, 0.76852, 0.846, 0.76852, 0.846, 0.76852, 0.846, 0.76852, 0.846, 0.89591, 0.8544, 0.90561, 0.94399, 0.70466, 0.81453, 0.70466, 0.81453, 0.70466, 0.81453, 0.70466, 0.81453, 0.70466, 0.81453, 0.80094, 0.94219, 0.80094, 0.94219, 0.80094, 0.94219, 1, 1, 0.86822, 0.96017, 0.86822, 0.96017, 0.83864, 0.82424, 0.83864, 0.82424, 0.83864, 0.82424, 0.83864, 1.03075, 0.83864, 0.82424, 0.81402, 1.02738, 0.728, 1.02175, 1, 1, 0.912, 0.79475, 1.03075, 1, 1, 0.79475, 0.83911, 0.79475, 0.66266, 0.80553, 1.06676, 0.87514, 0.96017, 1, 1, 0.87514, 0.96017, 0.86865, 0.87396, 0.96017, 0.8588, 0.93859, 0.8588, 0.93859, 0.8588, 0.93859, 0.867, 0.84759, 0.72421, 0.95493, 1, 1, 0.72421, 0.95493, 0.69866, 0.746, 0.69866, 0.746, 1, 1, 0.69866, 0.746, 1, 1, 0.77598, 0.88417, 0.77598, 1.12658, 0.85991, 0.94578, 0.85991, 0.94578, 0.85991, 0.94578, 0.85991, 0.94578, 0.85991, 0.94578, 0.85991, 0.94578, 0.87832, 0.979, 0.77512, 0.882, 0.77512, 0.8562, 0.83, 0.8562, 0.83, 0.8562, 0.83, 1, 0.88465, 0.85158, 0.93859, 0.773, 0.8075, 0.85751, 0.8562, 1, 1, 0.77598, 1.12658, 1.15012, 1.15012, 1.15012, 1.15012, 1.15012, 1.15313, 1.15012, 1.15012, 1.15012, 1.08106, 1.03901, 0.85158, 0.77025, 0.62264, 0.7646, 0.65351, 0.86026, 0.69461, 0.89947, 1.03075, 0.85158, 0.77812, 0.76449, 0.88836, 0.70466, 0.8562, 0.86822, 0.8588, 0.83864, 0.77212, 0.85308, 0.93637, 0.87514, 0.82352, 0.8588, 0.85701, 0.76013, 0.89058, 0.77598, 0.8156, 0.82565, 0.78112, 0.77899, 0.89386, 0.83864, 0.8156, 0.9486, 0.92388, 0.96186, 1.03075, 0.91123, 0.9486, 0.93298, 0.878, 0.93942, 0.92388, 0.84596, 0.96186, 0.95119, 1.03075, 0.922, 0.88787, 0.95829, 0.88, 0.93559, 0.93859, 0.78815, 0.93758, 1, 0.89217, 1.03737, 0.91123, 0.93969, 0.77487, 0.85769, 0.86799, 1.03075, 0.91123, 0.93859, 0.91123, 0.86799, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.87832, 0.979, 0.87832, 0.979, 0.87832, 0.979, 0.77512, 0.882, 0.9219, 1, 0.89903, 1, 1, 1, 0.87321, 0.87321, 0.87321, 1, 1.027, 1.027, 1.027, 0.86847, 0.86847, 0.79121, 1, 1.124, 1, 1, 0.73572, 0.73572, 1, 1, 0.85034, 1, 1, 1, 1, 0.88465, 1, 1, 1, 0.669, 1, 1.36145, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.04828, 1, 0.74948, 0.75187, 1.02058, 0.98391, 1.02119, 1, 1, 1.06233, 1.08595, 1.08595, 1, 1.08595, 1.08595, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05233, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.MyriadProItalicFactors = MyriadProItalicFactors;
	const MyriadProItalicMetrics = {
	  lineHeight: 1.2,
	  lineGap: 0.2
	};
	exports.MyriadProItalicMetrics = MyriadProItalicMetrics;
	const MyriadProRegularFactors = [1.36898, 1, 1, 0.76305, 0.82784, 0.94935, 0.89364, 0.92241, 0.89073, 0.90706, 0.98472, 0.85283, 0.85283, 1.0664, 1.02058, 0.74505, 0.9219, 0.74505, 1.23456, 0.92241, 0.92241, 0.92241, 0.92241, 0.92241, 0.92241, 0.92241, 0.92241, 0.92241, 0.92241, 0.74505, 0.74505, 1.02058, 1.02058, 1.02058, 0.73002, 0.72601, 0.91755, 0.8126, 0.80314, 0.92222, 0.73764, 0.79726, 0.83051, 0.90284, 0.86023, 0.74, 0.8126, 0.84869, 0.96518, 0.91115, 0.8858, 0.79761, 0.8858, 0.74498, 0.73914, 0.81363, 0.89591, 0.83659, 0.89633, 0.85608, 0.8111, 0.90531, 1.0222, 1.22736, 1.0222, 1.27014, 0.89903, 0.90088, 0.86667, 1.0231, 0.896, 1.01411, 0.90083, 1.05099, 1.00512, 0.99793, 1.05326, 1.09377, 0.938, 1.06226, 1.00119, 0.99793, 0.98714, 1.0231, 1.01231, 0.98196, 0.792, 1.19137, 0.99074, 0.962, 1.01915, 0.926, 0.942, 0.856, 0.85034, 0.92006, 0.85034, 1.02058, 0.69067, 0.92241, 0.92241, 0.92241, 0.92241, 0.92006, 0.9332, 0.90088, 0.91882, 0.93484, 0.75339, 1.02058, 0.56866, 0.54324, 0.79519, 1.08595, 1, 1, 0.90088, 1, 0.95325, 0.74505, 0.90088, 1, 0.97198, 0.75339, 0.91009, 0.91009, 0.91009, 0.66466, 0.91755, 0.91755, 0.91755, 0.91755, 0.91755, 0.91755, 0.788, 0.80314, 0.73764, 0.73764, 0.73764, 0.73764, 0.86023, 0.86023, 0.86023, 0.86023, 0.92915, 0.91115, 0.8858, 0.8858, 0.8858, 0.8858, 0.8858, 1.02058, 0.8858, 0.89591, 0.89591, 0.89591, 0.89591, 0.8111, 0.79611, 0.89713, 0.86667, 0.86667, 0.86667, 0.86667, 0.86667, 0.86667, 0.86936, 0.896, 0.90083, 0.90083, 0.90083, 0.90083, 0.84224, 0.84224, 0.84224, 0.84224, 0.97276, 0.99793, 0.98714, 0.98714, 0.98714, 0.98714, 0.98714, 1.08595, 0.89876, 0.99074, 0.99074, 0.99074, 0.99074, 0.942, 1.0231, 0.942, 0.91755, 0.86667, 0.91755, 0.86667, 0.91755, 0.86667, 0.80314, 0.896, 0.80314, 0.896, 0.80314, 0.896, 0.80314, 0.896, 0.92222, 0.93372, 0.92915, 1.01411, 0.73764, 0.90083, 0.73764, 0.90083, 0.73764, 0.90083, 0.73764, 0.90083, 0.73764, 0.90083, 0.83051, 1.00512, 0.83051, 1.00512, 0.83051, 1.00512, 1, 1, 0.90284, 0.99793, 0.90976, 0.99793, 0.86023, 0.84224, 0.86023, 0.84224, 0.86023, 0.84224, 0.86023, 1.05326, 0.86023, 0.84224, 0.82873, 1.07469, 0.74, 1.09377, 1, 1, 0.938, 0.84869, 1.06226, 1, 1, 0.84869, 0.83704, 0.84869, 0.81441, 0.85588, 1.08927, 0.91115, 0.99793, 1, 1, 0.91115, 0.99793, 0.91887, 0.90991, 0.99793, 0.8858, 0.98714, 0.8858, 0.98714, 0.8858, 0.98714, 0.894, 0.91434, 0.74498, 0.98196, 1, 1, 0.74498, 0.98196, 0.73914, 0.792, 0.73914, 0.792, 1, 1, 0.73914, 0.792, 1, 1, 0.81363, 0.904, 0.81363, 1.19137, 0.89591, 0.99074, 0.89591, 0.99074, 0.89591, 0.99074, 0.89591, 0.99074, 0.89591, 0.99074, 0.89591, 0.99074, 0.89633, 1.01915, 0.8111, 0.942, 0.8111, 0.90531, 0.856, 0.90531, 0.856, 0.90531, 0.856, 1, 0.92241, 0.91755, 0.86667, 0.788, 0.86936, 0.8858, 0.89876, 1, 1, 0.81363, 1.19137, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90088, 0.90388, 1.03901, 0.92138, 0.78105, 0.7154, 0.86169, 0.80513, 0.94007, 0.82528, 0.98612, 1.06226, 0.91755, 0.8126, 0.81884, 0.92819, 0.73764, 0.90531, 0.90284, 0.8858, 0.86023, 0.8126, 0.91172, 0.96518, 0.91115, 0.83089, 0.8858, 0.87791, 0.79761, 0.89297, 0.81363, 0.88157, 0.89992, 0.85608, 0.81992, 0.94307, 0.86023, 0.88157, 0.95308, 0.98699, 0.99793, 1.06226, 0.95817, 0.95308, 0.97358, 0.928, 0.98088, 0.98699, 0.92761, 0.99793, 0.96017, 1.06226, 0.986, 0.944, 0.95978, 0.938, 0.96705, 0.98714, 0.80442, 0.98972, 1, 0.89762, 1.04552, 0.95817, 0.99007, 0.87064, 0.91879, 0.88888, 1.06226, 0.95817, 0.98714, 0.95817, 0.88888, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.89633, 1.01915, 0.89633, 1.01915, 0.89633, 1.01915, 0.8111, 0.942, 0.9219, 1, 0.89903, 1, 1, 1, 0.93173, 0.93173, 0.93173, 1, 1.06304, 1.06304, 1.06904, 0.89903, 0.89903, 0.80549, 1, 1.156, 1, 1, 0.76575, 0.76575, 1, 1, 0.72458, 1, 1, 1, 1, 0.92241, 1, 1, 1, 0.619, 1, 1.36145, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.07257, 1, 0.74705, 0.71119, 1.02058, 1.024, 1.02119, 1, 1, 1.1536, 1.08595, 1.08595, 1, 1.08595, 1.08595, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05638, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.MyriadProRegularFactors = MyriadProRegularFactors;
	const MyriadProRegularMetrics = {
	  lineHeight: 1.2,
	  lineGap: 0.2
	};
	exports.MyriadProRegularMetrics = MyriadProRegularMetrics;

	/***/ }),
	/* 56 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.SegoeuiRegularMetrics = exports.SegoeuiRegularFactors = exports.SegoeuiItalicMetrics = exports.SegoeuiItalicFactors = exports.SegoeuiBoldMetrics = exports.SegoeuiBoldItalicMetrics = exports.SegoeuiBoldItalicFactors = exports.SegoeuiBoldFactors = void 0;
	const SegoeuiBoldFactors = [1.76738, 1, 1, 0.99297, 0.9824, 1.04016, 1.06497, 1.03424, 0.97529, 1.17647, 1.23203, 1.1085, 1.1085, 1.16939, 1.2107, 0.9754, 1.21408, 0.9754, 1.59578, 1.03424, 1.03424, 1.03424, 1.03424, 1.03424, 1.03424, 1.03424, 1.03424, 1.03424, 1.03424, 0.81378, 0.81378, 1.2107, 1.2107, 1.2107, 0.71703, 0.97847, 0.97363, 0.88776, 0.8641, 1.02096, 0.79795, 0.85132, 0.914, 1.06085, 1.1406, 0.8007, 0.89858, 0.83693, 1.14889, 1.09398, 0.97489, 0.92094, 0.97489, 0.90399, 0.84041, 0.95923, 1.00135, 1, 1.06467, 0.98243, 0.90996, 0.99361, 1.1085, 1.56942, 1.1085, 1.2107, 0.74627, 0.94282, 0.96752, 1.01519, 0.86304, 1.01359, 0.97278, 1.15103, 1.01359, 0.98561, 1.02285, 1.02285, 1.00527, 1.02285, 1.0302, 0.99041, 1.0008, 1.01519, 1.01359, 1.02258, 0.79104, 1.16862, 0.99041, 0.97454, 1.02511, 0.99298, 0.96752, 0.95801, 0.94856, 1.16579, 0.94856, 1.2107, 0.9824, 1.03424, 1.03424, 1, 1.03424, 1.16579, 0.8727, 1.3871, 1.18622, 1.10818, 1.04478, 1.2107, 1.18622, 0.75155, 0.94994, 1.28826, 1.21408, 1.21408, 0.91056, 1, 0.91572, 0.9754, 0.64663, 1.18328, 1.24866, 1.04478, 1.14169, 1.15749, 1.17389, 0.71703, 0.97363, 0.97363, 0.97363, 0.97363, 0.97363, 0.97363, 0.93506, 0.8641, 0.79795, 0.79795, 0.79795, 0.79795, 1.1406, 1.1406, 1.1406, 1.1406, 1.02096, 1.09398, 0.97426, 0.97426, 0.97426, 0.97426, 0.97426, 1.2107, 0.97489, 1.00135, 1.00135, 1.00135, 1.00135, 0.90996, 0.92094, 1.02798, 0.96752, 0.96752, 0.96752, 0.96752, 0.96752, 0.96752, 0.93136, 0.86304, 0.97278, 0.97278, 0.97278, 0.97278, 1.02285, 1.02285, 1.02285, 1.02285, 0.97122, 0.99041, 1, 1, 1, 1, 1, 1.28826, 1.0008, 0.99041, 0.99041, 0.99041, 0.99041, 0.96752, 1.01519, 0.96752, 0.97363, 0.96752, 0.97363, 0.96752, 0.97363, 0.96752, 0.8641, 0.86304, 0.8641, 0.86304, 0.8641, 0.86304, 0.8641, 0.86304, 1.02096, 1.03057, 1.02096, 1.03517, 0.79795, 0.97278, 0.79795, 0.97278, 0.79795, 0.97278, 0.79795, 0.97278, 0.79795, 0.97278, 0.914, 1.01359, 0.914, 1.01359, 0.914, 1.01359, 1, 1, 1.06085, 0.98561, 1.06085, 1.00879, 1.1406, 1.02285, 1.1406, 1.02285, 1.1406, 1.02285, 1.1406, 1.02285, 1.1406, 1.02285, 0.97138, 1.08692, 0.8007, 1.02285, 1, 1, 1.00527, 0.83693, 1.02285, 1, 1, 0.83693, 0.9455, 0.83693, 0.90418, 0.83693, 1.13005, 1.09398, 0.99041, 1, 1, 1.09398, 0.99041, 0.96692, 1.09251, 0.99041, 0.97489, 1.0008, 0.97489, 1.0008, 0.97489, 1.0008, 0.93994, 0.97931, 0.90399, 1.02258, 1, 1, 0.90399, 1.02258, 0.84041, 0.79104, 0.84041, 0.79104, 0.84041, 0.79104, 0.84041, 0.79104, 1, 1, 0.95923, 1.07034, 0.95923, 1.16862, 1.00135, 0.99041, 1.00135, 0.99041, 1.00135, 0.99041, 1.00135, 0.99041, 1.00135, 0.99041, 1.00135, 0.99041, 1.06467, 1.02511, 0.90996, 0.96752, 0.90996, 0.99361, 0.95801, 0.99361, 0.95801, 0.99361, 0.95801, 1.07733, 1.03424, 0.97363, 0.96752, 0.93506, 0.93136, 0.97489, 1.0008, 1, 1, 0.95923, 1.16862, 1.15103, 1.15103, 1.01173, 1.03959, 0.75953, 0.81378, 0.79912, 1.15103, 1.21994, 0.95161, 0.87815, 1.01149, 0.81525, 0.7676, 0.98167, 1.01134, 1.02546, 0.84097, 1.03089, 1.18102, 0.97363, 0.88776, 0.85134, 0.97826, 0.79795, 0.99361, 1.06085, 0.97489, 1.1406, 0.89858, 1.0388, 1.14889, 1.09398, 0.86039, 0.97489, 1.0595, 0.92094, 0.94793, 0.95923, 0.90996, 0.99346, 0.98243, 1.02112, 0.95493, 1.1406, 0.90996, 1.03574, 1.02597, 1.0008, 1.18102, 1.06628, 1.03574, 1.0192, 1.01932, 1.00886, 0.97531, 1.0106, 1.0008, 1.13189, 1.18102, 1.02277, 0.98683, 1.0016, 0.99561, 1.07237, 1.0008, 0.90434, 0.99921, 0.93803, 0.8965, 1.23085, 1.06628, 1.04983, 0.96268, 1.0499, 0.98439, 1.18102, 1.06628, 1.0008, 1.06628, 0.98439, 0.79795, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.09466, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.97278, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.02065, 1, 1, 1, 1, 1, 1, 1.06467, 1.02511, 1.06467, 1.02511, 1.06467, 1.02511, 0.90996, 0.96752, 1, 1.21408, 0.89903, 1, 1, 0.75155, 1.04394, 1.04394, 1.04394, 1.04394, 0.98633, 0.98633, 0.98633, 0.73047, 0.73047, 1.20642, 0.91211, 1.25635, 1.222, 1.02956, 1.03372, 1.03372, 0.96039, 1.24633, 1, 1.12454, 0.93503, 1.03424, 1.19687, 1.03424, 1, 1, 1, 0.771, 1, 1, 1.15749, 1.15749, 1.15749, 1.10948, 0.86279, 0.94434, 0.86279, 0.94434, 0.86182, 1, 1, 1.16897, 1, 0.96085, 0.90137, 1.2107, 1.18416, 1.13973, 0.69825, 0.9716, 2.10339, 1.29004, 1.29004, 1.21172, 1.29004, 1.29004, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.42603, 1, 0.99862, 0.99862, 1, 0.87025, 0.87025, 0.87025, 0.87025, 1.18874, 1.42603, 1, 1.42603, 1.42603, 0.99862, 1, 1, 1, 1, 1, 1.2886, 1.04315, 1.15296, 1.34163, 1, 1, 1, 1.09193, 1.09193, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.SegoeuiBoldFactors = SegoeuiBoldFactors;
	const SegoeuiBoldMetrics = {
	  lineHeight: 1.33008,
	  lineGap: 0
	};
	exports.SegoeuiBoldMetrics = SegoeuiBoldMetrics;
	const SegoeuiBoldItalicFactors = [1.76738, 1, 1, 0.98946, 1.03959, 1.04016, 1.02809, 1.036, 0.97639, 1.10953, 1.23203, 1.11144, 1.11144, 1.16939, 1.21237, 0.9754, 1.21261, 0.9754, 1.59754, 1.036, 1.036, 1.036, 1.036, 1.036, 1.036, 1.036, 1.036, 1.036, 1.036, 0.81378, 0.81378, 1.21237, 1.21237, 1.21237, 0.73541, 0.97847, 0.97363, 0.89723, 0.87897, 1.0426, 0.79429, 0.85292, 0.91149, 1.05815, 1.1406, 0.79631, 0.90128, 0.83853, 1.04396, 1.10615, 0.97552, 0.94436, 0.97552, 0.88641, 0.80527, 0.96083, 1.00135, 1, 1.06777, 0.9817, 0.91142, 0.99361, 1.11144, 1.57293, 1.11144, 1.21237, 0.74627, 1.31818, 1.06585, 0.97042, 0.83055, 0.97042, 0.93503, 1.1261, 0.97042, 0.97922, 1.14236, 0.94552, 1.01054, 1.14236, 1.02471, 0.97922, 0.94165, 0.97042, 0.97042, 1.0276, 0.78929, 1.1261, 0.97922, 0.95874, 1.02197, 0.98507, 0.96752, 0.97168, 0.95107, 1.16579, 0.95107, 1.21237, 1.03959, 1.036, 1.036, 1, 1.036, 1.16579, 0.87357, 1.31818, 1.18754, 1.26781, 1.05356, 1.21237, 1.18622, 0.79487, 0.94994, 1.29004, 1.24047, 1.24047, 1.31818, 1, 0.91484, 0.9754, 1.31818, 1.1349, 1.24866, 1.05356, 1.13934, 1.15574, 1.17389, 0.73541, 0.97363, 0.97363, 0.97363, 0.97363, 0.97363, 0.97363, 0.94385, 0.87897, 0.79429, 0.79429, 0.79429, 0.79429, 1.1406, 1.1406, 1.1406, 1.1406, 1.0426, 1.10615, 0.97552, 0.97552, 0.97552, 0.97552, 0.97552, 1.21237, 0.97552, 1.00135, 1.00135, 1.00135, 1.00135, 0.91142, 0.94436, 0.98721, 1.06585, 1.06585, 1.06585, 1.06585, 1.06585, 1.06585, 0.96705, 0.83055, 0.93503, 0.93503, 0.93503, 0.93503, 1.14236, 1.14236, 1.14236, 1.14236, 0.93125, 0.97922, 0.94165, 0.94165, 0.94165, 0.94165, 0.94165, 1.29004, 0.94165, 0.97922, 0.97922, 0.97922, 0.97922, 0.96752, 0.97042, 0.96752, 0.97363, 1.06585, 0.97363, 1.06585, 0.97363, 1.06585, 0.87897, 0.83055, 0.87897, 0.83055, 0.87897, 0.83055, 0.87897, 0.83055, 1.0426, 1.0033, 1.0426, 0.97042, 0.79429, 0.93503, 0.79429, 0.93503, 0.79429, 0.93503, 0.79429, 0.93503, 0.79429, 0.93503, 0.91149, 0.97042, 0.91149, 0.97042, 0.91149, 0.97042, 1, 1, 1.05815, 0.97922, 1.05815, 0.97922, 1.1406, 1.14236, 1.1406, 1.14236, 1.1406, 1.14236, 1.1406, 1.14236, 1.1406, 1.14236, 0.97441, 1.04302, 0.79631, 1.01582, 1, 1, 1.01054, 0.83853, 1.14236, 1, 1, 0.83853, 1.09125, 0.83853, 0.90418, 0.83853, 1.19508, 1.10615, 0.97922, 1, 1, 1.10615, 0.97922, 1.01034, 1.10466, 0.97922, 0.97552, 0.94165, 0.97552, 0.94165, 0.97552, 0.94165, 0.91602, 0.91981, 0.88641, 1.0276, 1, 1, 0.88641, 1.0276, 0.80527, 0.78929, 0.80527, 0.78929, 0.80527, 0.78929, 0.80527, 0.78929, 1, 1, 0.96083, 1.05403, 0.95923, 1.16862, 1.00135, 0.97922, 1.00135, 0.97922, 1.00135, 0.97922, 1.00135, 0.97922, 1.00135, 0.97922, 1.00135, 0.97922, 1.06777, 1.02197, 0.91142, 0.96752, 0.91142, 0.99361, 0.97168, 0.99361, 0.97168, 0.99361, 0.97168, 1.23199, 1.036, 0.97363, 1.06585, 0.94385, 0.96705, 0.97552, 0.94165, 1, 1, 0.96083, 1.1261, 1.31818, 1.31818, 1.31818, 1.31818, 1.31818, 1.31818, 1.31818, 1.31818, 1.31818, 0.95161, 1.27126, 1.00811, 0.83284, 0.77702, 0.99137, 0.95253, 1.0347, 0.86142, 1.07205, 1.14236, 0.97363, 0.89723, 0.86869, 1.09818, 0.79429, 0.99361, 1.05815, 0.97552, 1.1406, 0.90128, 1.06662, 1.04396, 1.10615, 0.84918, 0.97552, 1.04694, 0.94436, 0.98015, 0.96083, 0.91142, 1.00356, 0.9817, 1.01945, 0.98999, 1.1406, 0.91142, 1.04961, 0.9898, 1.00639, 1.14236, 1.07514, 1.04961, 0.99607, 1.02897, 1.008, 0.9898, 0.95134, 1.00639, 1.11121, 1.14236, 1.00518, 0.97981, 1.02186, 1, 1.08578, 0.94165, 0.99314, 0.98387, 0.93028, 0.93377, 1.35125, 1.07514, 1.10687, 0.93491, 1.04232, 1.00351, 1.14236, 1.07514, 0.94165, 1.07514, 1.00351, 0.79429, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.09097, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.93503, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.96609, 1, 1, 1, 1, 1, 1, 1.06777, 1.02197, 1.06777, 1.02197, 1.06777, 1.02197, 0.91142, 0.96752, 1, 1.21261, 0.89903, 1, 1, 0.75155, 1.04745, 1.04745, 1.04745, 1.04394, 0.98633, 0.98633, 0.98633, 0.72959, 0.72959, 1.20502, 0.91406, 1.26514, 1.222, 1.02956, 1.03372, 1.03372, 0.96039, 1.24633, 1, 1.09125, 0.93327, 1.03336, 1.16541, 1.036, 1, 1, 1, 0.771, 1, 1, 1.15574, 1.15574, 1.15574, 1.15574, 0.86364, 0.94434, 0.86279, 0.94434, 0.86224, 1, 1, 1.16798, 1, 0.96085, 0.90068, 1.21237, 1.18416, 1.13904, 0.69825, 0.9716, 2.10339, 1.29004, 1.29004, 1.21339, 1.29004, 1.29004, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.42603, 1, 0.99862, 0.99862, 1, 0.87025, 0.87025, 0.87025, 0.87025, 1.18775, 1.42603, 1, 1.42603, 1.42603, 0.99862, 1, 1, 1, 1, 1, 1.2886, 1.04315, 1.15296, 1.34163, 1, 1, 1, 1.13269, 1.13269, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.SegoeuiBoldItalicFactors = SegoeuiBoldItalicFactors;
	const SegoeuiBoldItalicMetrics = {
	  lineHeight: 1.33008,
	  lineGap: 0
	};
	exports.SegoeuiBoldItalicMetrics = SegoeuiBoldItalicMetrics;
	const SegoeuiItalicFactors = [1.76738, 1, 1, 0.98946, 1.14763, 1.05365, 1.06234, 0.96927, 0.92586, 1.15373, 1.18414, 0.91349, 0.91349, 1.07403, 1.17308, 0.78383, 1.20088, 0.78383, 1.42531, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.78383, 0.78383, 1.17308, 1.17308, 1.17308, 0.77349, 0.94565, 0.94729, 0.85944, 0.88506, 0.9858, 0.74817, 0.80016, 0.88449, 0.98039, 0.95782, 0.69238, 0.89898, 0.83231, 0.98183, 1.03989, 0.96924, 0.86237, 0.96924, 0.80595, 0.74524, 0.86091, 0.95402, 0.94143, 0.98448, 0.8858, 0.83089, 0.93285, 1.0949, 1.39016, 1.0949, 1.45994, 0.74627, 1.04839, 0.97454, 0.97454, 0.87207, 0.97454, 0.87533, 1.06151, 0.97454, 1.00176, 1.16484, 1.08132, 0.98047, 1.16484, 1.02989, 1.01054, 0.96225, 0.97454, 0.97454, 1.06598, 0.79004, 1.16344, 1.00351, 0.94629, 0.9973, 0.91016, 0.96777, 0.9043, 0.91082, 0.92481, 0.91082, 1.17308, 0.95748, 0.96927, 0.96927, 1, 0.96927, 0.92481, 0.80597, 1.04839, 1.23393, 1.1781, 0.9245, 1.17308, 1.20808, 0.63218, 0.94261, 1.24822, 1.09971, 1.09971, 1.04839, 1, 0.85273, 0.78032, 1.04839, 1.09971, 1.22326, 0.9245, 1.09836, 1.13525, 1.15222, 0.70424, 0.94729, 0.94729, 0.94729, 0.94729, 0.94729, 0.94729, 0.85498, 0.88506, 0.74817, 0.74817, 0.74817, 0.74817, 0.95782, 0.95782, 0.95782, 0.95782, 0.9858, 1.03989, 0.96924, 0.96924, 0.96924, 0.96924, 0.96924, 1.17308, 0.96924, 0.95402, 0.95402, 0.95402, 0.95402, 0.83089, 0.86237, 0.88409, 0.97454, 0.97454, 0.97454, 0.97454, 0.97454, 0.97454, 0.92916, 0.87207, 0.87533, 0.87533, 0.87533, 0.87533, 0.93146, 0.93146, 0.93146, 0.93146, 0.93854, 1.01054, 0.96225, 0.96225, 0.96225, 0.96225, 0.96225, 1.24822, 0.8761, 1.00351, 1.00351, 1.00351, 1.00351, 0.96777, 0.97454, 0.96777, 0.94729, 0.97454, 0.94729, 0.97454, 0.94729, 0.97454, 0.88506, 0.87207, 0.88506, 0.87207, 0.88506, 0.87207, 0.88506, 0.87207, 0.9858, 0.95391, 0.9858, 0.97454, 0.74817, 0.87533, 0.74817, 0.87533, 0.74817, 0.87533, 0.74817, 0.87533, 0.74817, 0.87533, 0.88449, 0.97454, 0.88449, 0.97454, 0.88449, 0.97454, 1, 1, 0.98039, 1.00176, 0.98039, 1.00176, 0.95782, 0.93146, 0.95782, 0.93146, 0.95782, 0.93146, 0.95782, 1.16484, 0.95782, 0.93146, 0.84421, 1.12761, 0.69238, 1.08132, 1, 1, 0.98047, 0.83231, 1.16484, 1, 1, 0.84723, 1.04861, 0.84723, 0.78755, 0.83231, 1.23736, 1.03989, 1.01054, 1, 1, 1.03989, 1.01054, 0.9857, 1.03849, 1.01054, 0.96924, 0.96225, 0.96924, 0.96225, 0.96924, 0.96225, 0.92383, 0.90171, 0.80595, 1.06598, 1, 1, 0.80595, 1.06598, 0.74524, 0.79004, 0.74524, 0.79004, 0.74524, 0.79004, 0.74524, 0.79004, 1, 1, 0.86091, 1.02759, 0.85771, 1.16344, 0.95402, 1.00351, 0.95402, 1.00351, 0.95402, 1.00351, 0.95402, 1.00351, 0.95402, 1.00351, 0.95402, 1.00351, 0.98448, 0.9973, 0.83089, 0.96777, 0.83089, 0.93285, 0.9043, 0.93285, 0.9043, 0.93285, 0.9043, 1.31868, 0.96927, 0.94729, 0.97454, 0.85498, 0.92916, 0.96924, 0.8761, 1, 1, 0.86091, 1.16344, 1.04839, 1.04839, 1.04839, 1.04839, 1.04839, 1.04839, 1.04839, 1.04839, 1.04839, 0.81965, 0.81965, 0.94729, 0.78032, 0.71022, 0.90883, 0.84171, 0.99877, 0.77596, 1.05734, 1.2, 0.94729, 0.85944, 0.82791, 0.9607, 0.74817, 0.93285, 0.98039, 0.96924, 0.95782, 0.89898, 0.98316, 0.98183, 1.03989, 0.78614, 0.96924, 0.97642, 0.86237, 0.86075, 0.86091, 0.83089, 0.90082, 0.8858, 0.97296, 1.01284, 0.95782, 0.83089, 1.0976, 1.04, 1.03342, 1.2, 1.0675, 1.0976, 0.98205, 1.03809, 1.05097, 1.04, 0.95364, 1.03342, 1.05401, 1.2, 1.02148, 1.0119, 1.04724, 1.0127, 1.02732, 0.96225, 0.8965, 0.97783, 0.93574, 0.94818, 1.30679, 1.0675, 1.11826, 0.99821, 1.0557, 1.0326, 1.2, 1.0675, 0.96225, 1.0675, 1.0326, 0.74817, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.03754, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.87533, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.98705, 1, 1, 1, 1, 1, 1, 0.98448, 0.9973, 0.98448, 0.9973, 0.98448, 0.9973, 0.83089, 0.96777, 1, 1.20088, 0.89903, 1, 1, 0.75155, 0.94945, 0.94945, 0.94945, 0.94945, 1.12317, 1.12317, 1.12317, 0.67603, 0.67603, 1.15621, 0.73584, 1.21191, 1.22135, 1.06483, 0.94868, 0.94868, 0.95996, 1.24633, 1, 1.07497, 0.87709, 0.96927, 1.01473, 0.96927, 1, 1, 1, 0.77295, 1, 1, 1.09836, 1.09836, 1.09836, 1.01522, 0.86321, 0.94434, 0.8649, 0.94434, 0.86182, 1, 1, 1.083, 1, 0.91578, 0.86438, 1.17308, 1.18416, 1.14589, 0.69825, 0.97622, 1.96791, 1.24822, 1.24822, 1.17308, 1.24822, 1.24822, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.42603, 1, 0.99862, 0.99862, 1, 0.87025, 0.87025, 0.87025, 0.87025, 1.17984, 1.42603, 1, 1.42603, 1.42603, 0.99862, 1, 1, 1, 1, 1, 1.2886, 1.04315, 1.15296, 1.34163, 1, 1, 1, 1.10742, 1.10742, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.SegoeuiItalicFactors = SegoeuiItalicFactors;
	const SegoeuiItalicMetrics = {
	  lineHeight: 1.33008,
	  lineGap: 0
	};
	exports.SegoeuiItalicMetrics = SegoeuiItalicMetrics;
	const SegoeuiRegularFactors = [1.76738, 1, 1, 0.98594, 1.02285, 1.10454, 1.06234, 0.96927, 0.92037, 1.19985, 1.2046, 0.90616, 0.90616, 1.07152, 1.1714, 0.78032, 1.20088, 0.78032, 1.40246, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.96927, 0.78032, 0.78032, 1.1714, 1.1714, 1.1714, 0.80597, 0.94084, 0.96706, 0.85944, 0.85734, 0.97093, 0.75842, 0.79936, 0.88198, 0.9831, 0.95782, 0.71387, 0.86969, 0.84636, 1.07796, 1.03584, 0.96924, 0.83968, 0.96924, 0.82826, 0.79649, 0.85771, 0.95132, 0.93119, 0.98965, 0.88433, 0.8287, 0.93365, 1.08612, 1.3638, 1.08612, 1.45786, 0.74627, 0.80499, 0.91484, 1.05707, 0.92383, 1.05882, 0.9403, 1.12654, 1.05882, 1.01756, 1.09011, 1.09011, 0.99414, 1.09011, 1.034, 1.01756, 1.05356, 1.05707, 1.05882, 1.04399, 0.84863, 1.21968, 1.01756, 0.95801, 1.00068, 0.91797, 0.96777, 0.9043, 0.90351, 0.92105, 0.90351, 1.1714, 0.85337, 0.96927, 0.96927, 0.99912, 0.96927, 0.92105, 0.80597, 1.2434, 1.20808, 1.05937, 0.90957, 1.1714, 1.20808, 0.75155, 0.94261, 1.24644, 1.09971, 1.09971, 0.84751, 1, 0.85273, 0.78032, 0.61584, 1.05425, 1.17914, 0.90957, 1.08665, 1.11593, 1.14169, 0.73381, 0.96706, 0.96706, 0.96706, 0.96706, 0.96706, 0.96706, 0.86035, 0.85734, 0.75842, 0.75842, 0.75842, 0.75842, 0.95782, 0.95782, 0.95782, 0.95782, 0.97093, 1.03584, 0.96924, 0.96924, 0.96924, 0.96924, 0.96924, 1.1714, 0.96924, 0.95132, 0.95132, 0.95132, 0.95132, 0.8287, 0.83968, 0.89049, 0.91484, 0.91484, 0.91484, 0.91484, 0.91484, 0.91484, 0.93575, 0.92383, 0.9403, 0.9403, 0.9403, 0.9403, 0.8717, 0.8717, 0.8717, 0.8717, 1.00527, 1.01756, 1.05356, 1.05356, 1.05356, 1.05356, 1.05356, 1.24644, 0.95923, 1.01756, 1.01756, 1.01756, 1.01756, 0.96777, 1.05707, 0.96777, 0.96706, 0.91484, 0.96706, 0.91484, 0.96706, 0.91484, 0.85734, 0.92383, 0.85734, 0.92383, 0.85734, 0.92383, 0.85734, 0.92383, 0.97093, 1.0969, 0.97093, 1.05882, 0.75842, 0.9403, 0.75842, 0.9403, 0.75842, 0.9403, 0.75842, 0.9403, 0.75842, 0.9403, 0.88198, 1.05882, 0.88198, 1.05882, 0.88198, 1.05882, 1, 1, 0.9831, 1.01756, 0.9831, 1.01756, 0.95782, 0.8717, 0.95782, 0.8717, 0.95782, 0.8717, 0.95782, 1.09011, 0.95782, 0.8717, 0.84784, 1.11551, 0.71387, 1.09011, 1, 1, 0.99414, 0.84636, 1.09011, 1, 1, 0.84636, 1.0536, 0.84636, 0.94298, 0.84636, 1.23297, 1.03584, 1.01756, 1, 1, 1.03584, 1.01756, 1.00323, 1.03444, 1.01756, 0.96924, 1.05356, 0.96924, 1.05356, 0.96924, 1.05356, 0.93066, 0.98293, 0.82826, 1.04399, 1, 1, 0.82826, 1.04399, 0.79649, 0.84863, 0.79649, 0.84863, 0.79649, 0.84863, 0.79649, 0.84863, 1, 1, 0.85771, 1.17318, 0.85771, 1.21968, 0.95132, 1.01756, 0.95132, 1.01756, 0.95132, 1.01756, 0.95132, 1.01756, 0.95132, 1.01756, 0.95132, 1.01756, 0.98965, 1.00068, 0.8287, 0.96777, 0.8287, 0.93365, 0.9043, 0.93365, 0.9043, 0.93365, 0.9043, 1.08571, 0.96927, 0.96706, 0.91484, 0.86035, 0.93575, 0.96924, 0.95923, 1, 1, 0.85771, 1.21968, 1.11437, 1.11437, 0.93109, 0.91202, 0.60411, 0.84164, 0.55572, 1.01173, 0.97361, 0.81818, 0.81818, 0.96635, 0.78032, 0.72727, 0.92366, 0.98601, 1.03405, 0.77968, 1.09799, 1.2, 0.96706, 0.85944, 0.85638, 0.96491, 0.75842, 0.93365, 0.9831, 0.96924, 0.95782, 0.86969, 0.94152, 1.07796, 1.03584, 0.78437, 0.96924, 0.98715, 0.83968, 0.83491, 0.85771, 0.8287, 0.94492, 0.88433, 0.9287, 1.0098, 0.95782, 0.8287, 1.0625, 0.98248, 1.03424, 1.2, 1.01071, 1.0625, 0.95246, 1.03809, 1.04912, 0.98248, 1.00221, 1.03424, 1.05443, 1.2, 1.04785, 0.99609, 1.00169, 1.05176, 0.99346, 1.05356, 0.9087, 1.03004, 0.95542, 0.93117, 1.23362, 1.01071, 1.07831, 1.02512, 1.05205, 1.03502, 1.2, 1.01071, 1.05356, 1.01071, 1.03502, 0.75842, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.03719, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0.9403, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.04021, 1, 1, 1, 1, 1, 1, 0.98965, 1.00068, 0.98965, 1.00068, 0.98965, 1.00068, 0.8287, 0.96777, 1, 1.20088, 0.89903, 1, 1, 0.75155, 1.03077, 1.03077, 1.03077, 1.03077, 1.13196, 1.13196, 1.13196, 0.67428, 0.67428, 1.16039, 0.73291, 1.20996, 1.22135, 1.06483, 0.94868, 0.94868, 0.95996, 1.24633, 1, 1.07497, 0.87796, 0.96927, 1.01518, 0.96927, 1, 1, 1, 0.77295, 1, 1, 1.10539, 1.10539, 1.11358, 1.06967, 0.86279, 0.94434, 0.86279, 0.94434, 0.86182, 1, 1, 1.083, 1, 0.91578, 0.86507, 1.1714, 1.18416, 1.14589, 0.69825, 0.97622, 1.9697, 1.24822, 1.24822, 1.17238, 1.24822, 1.24822, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.42603, 1, 0.99862, 0.99862, 1, 0.87025, 0.87025, 0.87025, 0.87025, 1.18083, 1.42603, 1, 1.42603, 1.42603, 0.99862, 1, 1, 1, 1, 1, 1.2886, 1.04315, 1.15296, 1.34163, 1, 1, 1, 1.10938, 1.10938, 1, 1, 1, 1.05425, 1.09971, 1.09971, 1.09971, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1];
	exports.SegoeuiRegularFactors = SegoeuiRegularFactors;
	const SegoeuiRegularMetrics = {
	  lineHeight: 1.33008,
	  lineGap: 0
	};
	exports.SegoeuiRegularMetrics = SegoeuiRegularMetrics;

	/***/ }),
	/* 57 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.PostScriptEvaluator = exports.PostScriptCompiler = exports.PDFFunctionFactory = void 0;
	exports.isPDFFunction = isPDFFunction;

	var _primitives = __w_pdfjs_require__(5);

	var _util = __w_pdfjs_require__(2);

	var _ps_parser = __w_pdfjs_require__(58);

	var _base_stream = __w_pdfjs_require__(7);

	var _image_utils = __w_pdfjs_require__(59);

	class PDFFunctionFactory {
	  constructor({
	    xref,
	    isEvalSupported = true
	  }) {
	    this.xref = xref;
	    this.isEvalSupported = isEvalSupported !== false;
	  }

	  create(fn) {
	    const cachedFunction = this.getCached(fn);

	    if (cachedFunction) {
	      return cachedFunction;
	    }

	    const parsedFunction = PDFFunction.parse({
	      xref: this.xref,
	      isEvalSupported: this.isEvalSupported,
	      fn: fn instanceof _primitives.Ref ? this.xref.fetch(fn) : fn
	    });

	    this._cache(fn, parsedFunction);

	    return parsedFunction;
	  }

	  createFromArray(fnObj) {
	    const cachedFunction = this.getCached(fnObj);

	    if (cachedFunction) {
	      return cachedFunction;
	    }

	    const parsedFunction = PDFFunction.parseArray({
	      xref: this.xref,
	      isEvalSupported: this.isEvalSupported,
	      fnObj: fnObj instanceof _primitives.Ref ? this.xref.fetch(fnObj) : fnObj
	    });

	    this._cache(fnObj, parsedFunction);

	    return parsedFunction;
	  }

	  getCached(cacheKey) {
	    let fnRef;

	    if (cacheKey instanceof _primitives.Ref) {
	      fnRef = cacheKey;
	    } else if (cacheKey instanceof _primitives.Dict) {
	      fnRef = cacheKey.objId;
	    } else if (cacheKey instanceof _base_stream.BaseStream) {
	      fnRef = cacheKey.dict && cacheKey.dict.objId;
	    }

	    if (fnRef) {
	      const localFunction = this._localFunctionCache.getByRef(fnRef);

	      if (localFunction) {
	        return localFunction;
	      }
	    }

	    return null;
	  }

	  _cache(cacheKey, parsedFunction) {
	    if (!parsedFunction) {
	      throw new Error('PDFFunctionFactory._cache - expected "parsedFunction" argument.');
	    }

	    let fnRef;

	    if (cacheKey instanceof _primitives.Ref) {
	      fnRef = cacheKey;
	    } else if (cacheKey instanceof _primitives.Dict) {
	      fnRef = cacheKey.objId;
	    } else if (cacheKey instanceof _base_stream.BaseStream) {
	      fnRef = cacheKey.dict && cacheKey.dict.objId;
	    }

	    if (fnRef) {
	      this._localFunctionCache.set(null, fnRef, parsedFunction);
	    }
	  }

	  get _localFunctionCache() {
	    return (0, _util.shadow)(this, "_localFunctionCache", new _image_utils.LocalFunctionCache());
	  }

	}

	exports.PDFFunctionFactory = PDFFunctionFactory;

	function toNumberArray(arr) {
	  if (!Array.isArray(arr)) {
	    return null;
	  }

	  const length = arr.length;

	  for (let i = 0; i < length; i++) {
	    if (typeof arr[i] !== "number") {
	      const result = new Array(length);

	      for (let j = 0; j < length; j++) {
	        result[j] = +arr[j];
	      }

	      return result;
	    }
	  }

	  return arr;
	}

	class PDFFunction {
	  static getSampleArray(size, outputSize, bps, stream) {
	    let i, ii;
	    let length = 1;

	    for (i = 0, ii = size.length; i < ii; i++) {
	      length *= size[i];
	    }

	    length *= outputSize;
	    const array = new Array(length);
	    let codeSize = 0;
	    let codeBuf = 0;
	    const sampleMul = 1.0 / (2.0 ** bps - 1);
	    const strBytes = stream.getBytes((length * bps + 7) / 8);
	    let strIdx = 0;

	    for (i = 0; i < length; i++) {
	      while (codeSize < bps) {
	        codeBuf <<= 8;
	        codeBuf |= strBytes[strIdx++];
	        codeSize += 8;
	      }

	      codeSize -= bps;
	      array[i] = (codeBuf >> codeSize) * sampleMul;
	      codeBuf &= (1 << codeSize) - 1;
	    }

	    return array;
	  }

	  static parse({
	    xref,
	    isEvalSupported,
	    fn
	  }) {
	    const dict = fn.dict || fn;
	    const typeNum = dict.get("FunctionType");

	    switch (typeNum) {
	      case 0:
	        return this.constructSampled({
	          xref,
	          isEvalSupported,
	          fn,
	          dict
	        });

	      case 1:
	        break;

	      case 2:
	        return this.constructInterpolated({
	          xref,
	          isEvalSupported,
	          dict
	        });

	      case 3:
	        return this.constructStiched({
	          xref,
	          isEvalSupported,
	          dict
	        });

	      case 4:
	        return this.constructPostScript({
	          xref,
	          isEvalSupported,
	          fn,
	          dict
	        });
	    }

	    throw new _util.FormatError("Unknown type of function");
	  }

	  static parseArray({
	    xref,
	    isEvalSupported,
	    fnObj
	  }) {
	    if (!Array.isArray(fnObj)) {
	      return this.parse({
	        xref,
	        isEvalSupported,
	        fn: fnObj
	      });
	    }

	    const fnArray = [];

	    for (let j = 0, jj = fnObj.length; j < jj; j++) {
	      fnArray.push(this.parse({
	        xref,
	        isEvalSupported,
	        fn: xref.fetchIfRef(fnObj[j])
	      }));
	    }

	    return function (src, srcOffset, dest, destOffset) {
	      for (let i = 0, ii = fnArray.length; i < ii; i++) {
	        fnArray[i](src, srcOffset, dest, destOffset + i);
	      }
	    };
	  }

	  static constructSampled({
	    xref,
	    isEvalSupported,
	    fn,
	    dict
	  }) {
	    function toMultiArray(arr) {
	      const inputLength = arr.length;
	      const out = [];
	      let index = 0;

	      for (let i = 0; i < inputLength; i += 2) {
	        out[index++] = [arr[i], arr[i + 1]];
	      }

	      return out;
	    }

	    function interpolate(x, xmin, xmax, ymin, ymax) {
	      return ymin + (x - xmin) * ((ymax - ymin) / (xmax - xmin));
	    }

	    let domain = toNumberArray(dict.getArray("Domain"));
	    let range = toNumberArray(dict.getArray("Range"));

	    if (!domain || !range) {
	      throw new _util.FormatError("No domain or range");
	    }

	    const inputSize = domain.length / 2;
	    const outputSize = range.length / 2;
	    domain = toMultiArray(domain);
	    range = toMultiArray(range);
	    const size = toNumberArray(dict.getArray("Size"));
	    const bps = dict.get("BitsPerSample");
	    const order = dict.get("Order") || 1;

	    if (order !== 1) {
	      (0, _util.info)("No support for cubic spline interpolation: " + order);
	    }

	    let encode = toNumberArray(dict.getArray("Encode"));

	    if (!encode) {
	      encode = [];

	      for (let i = 0; i < inputSize; ++i) {
	        encode.push([0, size[i] - 1]);
	      }
	    } else {
	      encode = toMultiArray(encode);
	    }

	    let decode = toNumberArray(dict.getArray("Decode"));

	    if (!decode) {
	      decode = range;
	    } else {
	      decode = toMultiArray(decode);
	    }

	    const samples = this.getSampleArray(size, outputSize, bps, fn);
	    return function constructSampledFn(src, srcOffset, dest, destOffset) {
	      const cubeVertices = 1 << inputSize;
	      const cubeN = new Float64Array(cubeVertices);
	      const cubeVertex = new Uint32Array(cubeVertices);
	      let i, j;

	      for (j = 0; j < cubeVertices; j++) {
	        cubeN[j] = 1;
	      }

	      let k = outputSize,
	          pos = 1;

	      for (i = 0; i < inputSize; ++i) {
	        const domain_2i = domain[i][0];
	        const domain_2i_1 = domain[i][1];
	        const xi = Math.min(Math.max(src[srcOffset + i], domain_2i), domain_2i_1);
	        let e = interpolate(xi, domain_2i, domain_2i_1, encode[i][0], encode[i][1]);
	        const size_i = size[i];
	        e = Math.min(Math.max(e, 0), size_i - 1);
	        const e0 = e < size_i - 1 ? Math.floor(e) : e - 1;
	        const n0 = e0 + 1 - e;
	        const n1 = e - e0;
	        const offset0 = e0 * k;
	        const offset1 = offset0 + k;

	        for (j = 0; j < cubeVertices; j++) {
	          if (j & pos) {
	            cubeN[j] *= n1;
	            cubeVertex[j] += offset1;
	          } else {
	            cubeN[j] *= n0;
	            cubeVertex[j] += offset0;
	          }
	        }

	        k *= size_i;
	        pos <<= 1;
	      }

	      for (j = 0; j < outputSize; ++j) {
	        let rj = 0;

	        for (i = 0; i < cubeVertices; i++) {
	          rj += samples[cubeVertex[i] + j] * cubeN[i];
	        }

	        rj = interpolate(rj, 0, 1, decode[j][0], decode[j][1]);
	        dest[destOffset + j] = Math.min(Math.max(rj, range[j][0]), range[j][1]);
	      }
	    };
	  }

	  static constructInterpolated({
	    xref,
	    isEvalSupported,
	    dict
	  }) {
	    const c0 = toNumberArray(dict.getArray("C0")) || [0];
	    const c1 = toNumberArray(dict.getArray("C1")) || [1];
	    const n = dict.get("N");
	    const diff = [];

	    for (let i = 0, ii = c0.length; i < ii; ++i) {
	      diff.push(c1[i] - c0[i]);
	    }

	    const length = diff.length;
	    return function constructInterpolatedFn(src, srcOffset, dest, destOffset) {
	      const x = n === 1 ? src[srcOffset] : src[srcOffset] ** n;

	      for (let j = 0; j < length; ++j) {
	        dest[destOffset + j] = c0[j] + x * diff[j];
	      }
	    };
	  }

	  static constructStiched({
	    xref,
	    isEvalSupported,
	    dict
	  }) {
	    const domain = toNumberArray(dict.getArray("Domain"));

	    if (!domain) {
	      throw new _util.FormatError("No domain");
	    }

	    const inputSize = domain.length / 2;

	    if (inputSize !== 1) {
	      throw new _util.FormatError("Bad domain for stiched function");
	    }

	    const fnRefs = dict.get("Functions");
	    const fns = [];

	    for (let i = 0, ii = fnRefs.length; i < ii; ++i) {
	      fns.push(this.parse({
	        xref,
	        isEvalSupported,
	        fn: xref.fetchIfRef(fnRefs[i])
	      }));
	    }

	    const bounds = toNumberArray(dict.getArray("Bounds"));
	    const encode = toNumberArray(dict.getArray("Encode"));
	    const tmpBuf = new Float32Array(1);
	    return function constructStichedFn(src, srcOffset, dest, destOffset) {
	      const clip = function constructStichedFromIRClip(v, min, max) {
	        if (v > max) {
	          v = max;
	        } else if (v < min) {
	          v = min;
	        }

	        return v;
	      };

	      const v = clip(src[srcOffset], domain[0], domain[1]);
	      const length = bounds.length;
	      let i;

	      for (i = 0; i < length; ++i) {
	        if (v < bounds[i]) {
	          break;
	        }
	      }

	      let dmin = domain[0];

	      if (i > 0) {
	        dmin = bounds[i - 1];
	      }

	      let dmax = domain[1];

	      if (i < bounds.length) {
	        dmax = bounds[i];
	      }

	      const rmin = encode[2 * i];
	      const rmax = encode[2 * i + 1];
	      tmpBuf[0] = dmin === dmax ? rmin : rmin + (v - dmin) * (rmax - rmin) / (dmax - dmin);
	      fns[i](tmpBuf, 0, dest, destOffset);
	    };
	  }

	  static constructPostScript({
	    xref,
	    isEvalSupported,
	    fn,
	    dict
	  }) {
	    const domain = toNumberArray(dict.getArray("Domain"));
	    const range = toNumberArray(dict.getArray("Range"));

	    if (!domain) {
	      throw new _util.FormatError("No domain.");
	    }

	    if (!range) {
	      throw new _util.FormatError("No range.");
	    }

	    const lexer = new _ps_parser.PostScriptLexer(fn);
	    const parser = new _ps_parser.PostScriptParser(lexer);
	    const code = parser.parse();

	    if (isEvalSupported && _util.FeatureTest.isEvalSupported) {
	      const compiled = new PostScriptCompiler().compile(code, domain, range);

	      if (compiled) {
	        return new Function("src", "srcOffset", "dest", "destOffset", compiled);
	      }
	    }

	    (0, _util.info)("Unable to compile PS function");
	    const numOutputs = range.length >> 1;
	    const numInputs = domain.length >> 1;
	    const evaluator = new PostScriptEvaluator(code);
	    const cache = Object.create(null);
	    const MAX_CACHE_SIZE = 2048 * 4;
	    let cache_available = MAX_CACHE_SIZE;
	    const tmpBuf = new Float32Array(numInputs);
	    return function constructPostScriptFn(src, srcOffset, dest, destOffset) {
	      let i, value;
	      let key = "";
	      const input = tmpBuf;

	      for (i = 0; i < numInputs; i++) {
	        value = src[srcOffset + i];
	        input[i] = value;
	        key += value + "_";
	      }

	      const cachedValue = cache[key];

	      if (cachedValue !== undefined) {
	        dest.set(cachedValue, destOffset);
	        return;
	      }

	      const output = new Float32Array(numOutputs);
	      const stack = evaluator.execute(input);
	      const stackIndex = stack.length - numOutputs;

	      for (i = 0; i < numOutputs; i++) {
	        value = stack[stackIndex + i];
	        let bound = range[i * 2];

	        if (value < bound) {
	          value = bound;
	        } else {
	          bound = range[i * 2 + 1];

	          if (value > bound) {
	            value = bound;
	          }
	        }

	        output[i] = value;
	      }

	      if (cache_available > 0) {
	        cache_available--;
	        cache[key] = output;
	      }

	      dest.set(output, destOffset);
	    };
	  }

	}

	function isPDFFunction(v) {
	  let fnDict;

	  if (typeof v !== "object") {
	    return false;
	  } else if (v instanceof _primitives.Dict) {
	    fnDict = v;
	  } else if (v instanceof _base_stream.BaseStream) {
	    fnDict = v.dict;
	  } else {
	    return false;
	  }

	  return fnDict.has("FunctionType");
	}

	class PostScriptStack {
	  static get MAX_STACK_SIZE() {
	    return (0, _util.shadow)(this, "MAX_STACK_SIZE", 100);
	  }

	  constructor(initialStack) {
	    this.stack = !initialStack ? [] : Array.prototype.slice.call(initialStack, 0);
	  }

	  push(value) {
	    if (this.stack.length >= PostScriptStack.MAX_STACK_SIZE) {
	      throw new Error("PostScript function stack overflow.");
	    }

	    this.stack.push(value);
	  }

	  pop() {
	    if (this.stack.length <= 0) {
	      throw new Error("PostScript function stack underflow.");
	    }

	    return this.stack.pop();
	  }

	  copy(n) {
	    if (this.stack.length + n >= PostScriptStack.MAX_STACK_SIZE) {
	      throw new Error("PostScript function stack overflow.");
	    }

	    const stack = this.stack;

	    for (let i = stack.length - n, j = n - 1; j >= 0; j--, i++) {
	      stack.push(stack[i]);
	    }
	  }

	  index(n) {
	    this.push(this.stack[this.stack.length - n - 1]);
	  }

	  roll(n, p) {
	    const stack = this.stack;
	    const l = stack.length - n;
	    const r = stack.length - 1;
	    const c = l + (p - Math.floor(p / n) * n);

	    for (let i = l, j = r; i < j; i++, j--) {
	      const t = stack[i];
	      stack[i] = stack[j];
	      stack[j] = t;
	    }

	    for (let i = l, j = c - 1; i < j; i++, j--) {
	      const t = stack[i];
	      stack[i] = stack[j];
	      stack[j] = t;
	    }

	    for (let i = c, j = r; i < j; i++, j--) {
	      const t = stack[i];
	      stack[i] = stack[j];
	      stack[j] = t;
	    }
	  }

	}

	class PostScriptEvaluator {
	  constructor(operators) {
	    this.operators = operators;
	  }

	  execute(initialStack) {
	    const stack = new PostScriptStack(initialStack);
	    let counter = 0;
	    const operators = this.operators;
	    const length = operators.length;
	    let operator, a, b;

	    while (counter < length) {
	      operator = operators[counter++];

	      if (typeof operator === "number") {
	        stack.push(operator);
	        continue;
	      }

	      switch (operator) {
	        case "jz":
	          b = stack.pop();
	          a = stack.pop();

	          if (!a) {
	            counter = b;
	          }

	          break;

	        case "j":
	          a = stack.pop();
	          counter = a;
	          break;

	        case "abs":
	          a = stack.pop();
	          stack.push(Math.abs(a));
	          break;

	        case "add":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a + b);
	          break;

	        case "and":
	          b = stack.pop();
	          a = stack.pop();

	          if (typeof a === "boolean" && typeof b === "boolean") {
	            stack.push(a && b);
	          } else {
	            stack.push(a & b);
	          }

	          break;

	        case "atan":
	          a = stack.pop();
	          stack.push(Math.atan(a));
	          break;

	        case "bitshift":
	          b = stack.pop();
	          a = stack.pop();

	          if (a > 0) {
	            stack.push(a << b);
	          } else {
	            stack.push(a >> b);
	          }

	          break;

	        case "ceiling":
	          a = stack.pop();
	          stack.push(Math.ceil(a));
	          break;

	        case "copy":
	          a = stack.pop();
	          stack.copy(a);
	          break;

	        case "cos":
	          a = stack.pop();
	          stack.push(Math.cos(a));
	          break;

	        case "cvi":
	          a = stack.pop() | 0;
	          stack.push(a);
	          break;

	        case "cvr":
	          break;

	        case "div":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a / b);
	          break;

	        case "dup":
	          stack.copy(1);
	          break;

	        case "eq":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a === b);
	          break;

	        case "exch":
	          stack.roll(2, 1);
	          break;

	        case "exp":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a ** b);
	          break;

	        case "false":
	          stack.push(false);
	          break;

	        case "floor":
	          a = stack.pop();
	          stack.push(Math.floor(a));
	          break;

	        case "ge":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a >= b);
	          break;

	        case "gt":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a > b);
	          break;

	        case "idiv":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a / b | 0);
	          break;

	        case "index":
	          a = stack.pop();
	          stack.index(a);
	          break;

	        case "le":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a <= b);
	          break;

	        case "ln":
	          a = stack.pop();
	          stack.push(Math.log(a));
	          break;

	        case "log":
	          a = stack.pop();
	          stack.push(Math.log(a) / Math.LN10);
	          break;

	        case "lt":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a < b);
	          break;

	        case "mod":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a % b);
	          break;

	        case "mul":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a * b);
	          break;

	        case "ne":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a !== b);
	          break;

	        case "neg":
	          a = stack.pop();
	          stack.push(-a);
	          break;

	        case "not":
	          a = stack.pop();

	          if (typeof a === "boolean") {
	            stack.push(!a);
	          } else {
	            stack.push(~a);
	          }

	          break;

	        case "or":
	          b = stack.pop();
	          a = stack.pop();

	          if (typeof a === "boolean" && typeof b === "boolean") {
	            stack.push(a || b);
	          } else {
	            stack.push(a | b);
	          }

	          break;

	        case "pop":
	          stack.pop();
	          break;

	        case "roll":
	          b = stack.pop();
	          a = stack.pop();
	          stack.roll(a, b);
	          break;

	        case "round":
	          a = stack.pop();
	          stack.push(Math.round(a));
	          break;

	        case "sin":
	          a = stack.pop();
	          stack.push(Math.sin(a));
	          break;

	        case "sqrt":
	          a = stack.pop();
	          stack.push(Math.sqrt(a));
	          break;

	        case "sub":
	          b = stack.pop();
	          a = stack.pop();
	          stack.push(a - b);
	          break;

	        case "true":
	          stack.push(true);
	          break;

	        case "truncate":
	          a = stack.pop();
	          a = a < 0 ? Math.ceil(a) : Math.floor(a);
	          stack.push(a);
	          break;

	        case "xor":
	          b = stack.pop();
	          a = stack.pop();

	          if (typeof a === "boolean" && typeof b === "boolean") {
	            stack.push(a !== b);
	          } else {
	            stack.push(a ^ b);
	          }

	          break;

	        default:
	          throw new _util.FormatError(`Unknown operator ${operator}`);
	      }
	    }

	    return stack.stack;
	  }

	}

	exports.PostScriptEvaluator = PostScriptEvaluator;

	class AstNode {
	  constructor(type) {
	    this.type = type;
	  }

	  visit(visitor) {
	    (0, _util.unreachable)("abstract method");
	  }

	}

	class AstArgument extends AstNode {
	  constructor(index, min, max) {
	    super("args");
	    this.index = index;
	    this.min = min;
	    this.max = max;
	  }

	  visit(visitor) {
	    visitor.visitArgument(this);
	  }

	}

	class AstLiteral extends AstNode {
	  constructor(number) {
	    super("literal");
	    this.number = number;
	    this.min = number;
	    this.max = number;
	  }

	  visit(visitor) {
	    visitor.visitLiteral(this);
	  }

	}

	class AstBinaryOperation extends AstNode {
	  constructor(op, arg1, arg2, min, max) {
	    super("binary");
	    this.op = op;
	    this.arg1 = arg1;
	    this.arg2 = arg2;
	    this.min = min;
	    this.max = max;
	  }

	  visit(visitor) {
	    visitor.visitBinaryOperation(this);
	  }

	}

	class AstMin extends AstNode {
	  constructor(arg, max) {
	    super("max");
	    this.arg = arg;
	    this.min = arg.min;
	    this.max = max;
	  }

	  visit(visitor) {
	    visitor.visitMin(this);
	  }

	}

	class AstVariable extends AstNode {
	  constructor(index, min, max) {
	    super("var");
	    this.index = index;
	    this.min = min;
	    this.max = max;
	  }

	  visit(visitor) {
	    visitor.visitVariable(this);
	  }

	}

	class AstVariableDefinition extends AstNode {
	  constructor(variable, arg) {
	    super("definition");
	    this.variable = variable;
	    this.arg = arg;
	  }

	  visit(visitor) {
	    visitor.visitVariableDefinition(this);
	  }

	}

	class ExpressionBuilderVisitor {
	  constructor() {
	    this.parts = [];
	  }

	  visitArgument(arg) {
	    this.parts.push("Math.max(", arg.min, ", Math.min(", arg.max, ", src[srcOffset + ", arg.index, "]))");
	  }

	  visitVariable(variable) {
	    this.parts.push("v", variable.index);
	  }

	  visitLiteral(literal) {
	    this.parts.push(literal.number);
	  }

	  visitBinaryOperation(operation) {
	    this.parts.push("(");
	    operation.arg1.visit(this);
	    this.parts.push(" ", operation.op, " ");
	    operation.arg2.visit(this);
	    this.parts.push(")");
	  }

	  visitVariableDefinition(definition) {
	    this.parts.push("var ");
	    definition.variable.visit(this);
	    this.parts.push(" = ");
	    definition.arg.visit(this);
	    this.parts.push(";");
	  }

	  visitMin(max) {
	    this.parts.push("Math.min(");
	    max.arg.visit(this);
	    this.parts.push(", ", max.max, ")");
	  }

	  toString() {
	    return this.parts.join("");
	  }

	}

	function buildAddOperation(num1, num2) {
	  if (num2.type === "literal" && num2.number === 0) {
	    return num1;
	  }

	  if (num1.type === "literal" && num1.number === 0) {
	    return num2;
	  }

	  if (num2.type === "literal" && num1.type === "literal") {
	    return new AstLiteral(num1.number + num2.number);
	  }

	  return new AstBinaryOperation("+", num1, num2, num1.min + num2.min, num1.max + num2.max);
	}

	function buildMulOperation(num1, num2) {
	  if (num2.type === "literal") {
	    if (num2.number === 0) {
	      return new AstLiteral(0);
	    } else if (num2.number === 1) {
	      return num1;
	    } else if (num1.type === "literal") {
	      return new AstLiteral(num1.number * num2.number);
	    }
	  }

	  if (num1.type === "literal") {
	    if (num1.number === 0) {
	      return new AstLiteral(0);
	    } else if (num1.number === 1) {
	      return num2;
	    }
	  }

	  const min = Math.min(num1.min * num2.min, num1.min * num2.max, num1.max * num2.min, num1.max * num2.max);
	  const max = Math.max(num1.min * num2.min, num1.min * num2.max, num1.max * num2.min, num1.max * num2.max);
	  return new AstBinaryOperation("*", num1, num2, min, max);
	}

	function buildSubOperation(num1, num2) {
	  if (num2.type === "literal") {
	    if (num2.number === 0) {
	      return num1;
	    } else if (num1.type === "literal") {
	      return new AstLiteral(num1.number - num2.number);
	    }
	  }

	  if (num2.type === "binary" && num2.op === "-" && num1.type === "literal" && num1.number === 1 && num2.arg1.type === "literal" && num2.arg1.number === 1) {
	    return num2.arg2;
	  }

	  return new AstBinaryOperation("-", num1, num2, num1.min - num2.max, num1.max - num2.min);
	}

	function buildMinOperation(num1, max) {
	  if (num1.min >= max) {
	    return new AstLiteral(max);
	  } else if (num1.max <= max) {
	    return num1;
	  }

	  return new AstMin(num1, max);
	}

	class PostScriptCompiler {
	  compile(code, domain, range) {
	    const stack = [];
	    const instructions = [];
	    const inputSize = domain.length >> 1,
	          outputSize = range.length >> 1;
	    let lastRegister = 0;
	    let n, j;
	    let num1, num2, ast1, ast2, tmpVar, item;

	    for (let i = 0; i < inputSize; i++) {
	      stack.push(new AstArgument(i, domain[i * 2], domain[i * 2 + 1]));
	    }

	    for (let i = 0, ii = code.length; i < ii; i++) {
	      item = code[i];

	      if (typeof item === "number") {
	        stack.push(new AstLiteral(item));
	        continue;
	      }

	      switch (item) {
	        case "add":
	          if (stack.length < 2) {
	            return null;
	          }

	          num2 = stack.pop();
	          num1 = stack.pop();
	          stack.push(buildAddOperation(num1, num2));
	          break;

	        case "cvr":
	          if (stack.length < 1) {
	            return null;
	          }

	          break;

	        case "mul":
	          if (stack.length < 2) {
	            return null;
	          }

	          num2 = stack.pop();
	          num1 = stack.pop();
	          stack.push(buildMulOperation(num1, num2));
	          break;

	        case "sub":
	          if (stack.length < 2) {
	            return null;
	          }

	          num2 = stack.pop();
	          num1 = stack.pop();
	          stack.push(buildSubOperation(num1, num2));
	          break;

	        case "exch":
	          if (stack.length < 2) {
	            return null;
	          }

	          ast1 = stack.pop();
	          ast2 = stack.pop();
	          stack.push(ast1, ast2);
	          break;

	        case "pop":
	          if (stack.length < 1) {
	            return null;
	          }

	          stack.pop();
	          break;

	        case "index":
	          if (stack.length < 1) {
	            return null;
	          }

	          num1 = stack.pop();

	          if (num1.type !== "literal") {
	            return null;
	          }

	          n = num1.number;

	          if (n < 0 || !Number.isInteger(n) || stack.length < n) {
	            return null;
	          }

	          ast1 = stack[stack.length - n - 1];

	          if (ast1.type === "literal" || ast1.type === "var") {
	            stack.push(ast1);
	            break;
	          }

	          tmpVar = new AstVariable(lastRegister++, ast1.min, ast1.max);
	          stack[stack.length - n - 1] = tmpVar;
	          stack.push(tmpVar);
	          instructions.push(new AstVariableDefinition(tmpVar, ast1));
	          break;

	        case "dup":
	          if (stack.length < 1) {
	            return null;
	          }

	          if (typeof code[i + 1] === "number" && code[i + 2] === "gt" && code[i + 3] === i + 7 && code[i + 4] === "jz" && code[i + 5] === "pop" && code[i + 6] === code[i + 1]) {
	            num1 = stack.pop();
	            stack.push(buildMinOperation(num1, code[i + 1]));
	            i += 6;
	            break;
	          }

	          ast1 = stack.at(-1);

	          if (ast1.type === "literal" || ast1.type === "var") {
	            stack.push(ast1);
	            break;
	          }

	          tmpVar = new AstVariable(lastRegister++, ast1.min, ast1.max);
	          stack[stack.length - 1] = tmpVar;
	          stack.push(tmpVar);
	          instructions.push(new AstVariableDefinition(tmpVar, ast1));
	          break;

	        case "roll":
	          if (stack.length < 2) {
	            return null;
	          }

	          num2 = stack.pop();
	          num1 = stack.pop();

	          if (num2.type !== "literal" || num1.type !== "literal") {
	            return null;
	          }

	          j = num2.number;
	          n = num1.number;

	          if (n <= 0 || !Number.isInteger(n) || !Number.isInteger(j) || stack.length < n) {
	            return null;
	          }

	          j = (j % n + n) % n;

	          if (j === 0) {
	            break;
	          }

	          Array.prototype.push.apply(stack, stack.splice(stack.length - n, n - j));
	          break;

	        default:
	          return null;
	      }
	    }

	    if (stack.length !== outputSize) {
	      return null;
	    }

	    const result = [];

	    for (const instruction of instructions) {
	      const statementBuilder = new ExpressionBuilderVisitor();
	      instruction.visit(statementBuilder);
	      result.push(statementBuilder.toString());
	    }

	    for (let i = 0, ii = stack.length; i < ii; i++) {
	      const expr = stack[i],
	            statementBuilder = new ExpressionBuilderVisitor();
	      expr.visit(statementBuilder);
	      const min = range[i * 2],
	            max = range[i * 2 + 1];
	      const out = [statementBuilder.toString()];

	      if (min > expr.min) {
	        out.unshift("Math.max(", min, ", ");
	        out.push(")");
	      }

	      if (max < expr.max) {
	        out.unshift("Math.min(", max, ", ");
	        out.push(")");
	      }

	      out.unshift("dest[destOffset + ", i, "] = ");
	      out.push(";");
	      result.push(out.join(""));
	    }

	    return result.join("\n");
	  }

	}

	exports.PostScriptCompiler = PostScriptCompiler;

	/***/ }),
	/* 58 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.PostScriptParser = exports.PostScriptLexer = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _core_utils = __w_pdfjs_require__(6);

	class PostScriptParser {
	  constructor(lexer) {
	    this.lexer = lexer;
	    this.operators = [];
	    this.token = null;
	    this.prev = null;
	  }

	  nextToken() {
	    this.prev = this.token;
	    this.token = this.lexer.getToken();
	  }

	  accept(type) {
	    if (this.token.type === type) {
	      this.nextToken();
	      return true;
	    }

	    return false;
	  }

	  expect(type) {
	    if (this.accept(type)) {
	      return true;
	    }

	    throw new _util.FormatError(`Unexpected symbol: found ${this.token.type} expected ${type}.`);
	  }

	  parse() {
	    this.nextToken();
	    this.expect(PostScriptTokenTypes.LBRACE);
	    this.parseBlock();
	    this.expect(PostScriptTokenTypes.RBRACE);
	    return this.operators;
	  }

	  parseBlock() {
	    while (true) {
	      if (this.accept(PostScriptTokenTypes.NUMBER)) {
	        this.operators.push(this.prev.value);
	      } else if (this.accept(PostScriptTokenTypes.OPERATOR)) {
	        this.operators.push(this.prev.value);
	      } else if (this.accept(PostScriptTokenTypes.LBRACE)) {
	        this.parseCondition();
	      } else {
	        return;
	      }
	    }
	  }

	  parseCondition() {
	    const conditionLocation = this.operators.length;
	    this.operators.push(null, null);
	    this.parseBlock();
	    this.expect(PostScriptTokenTypes.RBRACE);

	    if (this.accept(PostScriptTokenTypes.IF)) {
	      this.operators[conditionLocation] = this.operators.length;
	      this.operators[conditionLocation + 1] = "jz";
	    } else if (this.accept(PostScriptTokenTypes.LBRACE)) {
	      const jumpLocation = this.operators.length;
	      this.operators.push(null, null);
	      const endOfTrue = this.operators.length;
	      this.parseBlock();
	      this.expect(PostScriptTokenTypes.RBRACE);
	      this.expect(PostScriptTokenTypes.IFELSE);
	      this.operators[jumpLocation] = this.operators.length;
	      this.operators[jumpLocation + 1] = "j";
	      this.operators[conditionLocation] = endOfTrue;
	      this.operators[conditionLocation + 1] = "jz";
	    } else {
	      throw new _util.FormatError("PS Function: error parsing conditional.");
	    }
	  }

	}

	exports.PostScriptParser = PostScriptParser;
	const PostScriptTokenTypes = {
	  LBRACE: 0,
	  RBRACE: 1,
	  NUMBER: 2,
	  OPERATOR: 3,
	  IF: 4,
	  IFELSE: 5
	};

	class PostScriptToken {
	  static get opCache() {
	    return (0, _util.shadow)(this, "opCache", Object.create(null));
	  }

	  constructor(type, value) {
	    this.type = type;
	    this.value = value;
	  }

	  static getOperator(op) {
	    const opValue = PostScriptToken.opCache[op];

	    if (opValue) {
	      return opValue;
	    }

	    return PostScriptToken.opCache[op] = new PostScriptToken(PostScriptTokenTypes.OPERATOR, op);
	  }

	  static get LBRACE() {
	    return (0, _util.shadow)(this, "LBRACE", new PostScriptToken(PostScriptTokenTypes.LBRACE, "{"));
	  }

	  static get RBRACE() {
	    return (0, _util.shadow)(this, "RBRACE", new PostScriptToken(PostScriptTokenTypes.RBRACE, "}"));
	  }

	  static get IF() {
	    return (0, _util.shadow)(this, "IF", new PostScriptToken(PostScriptTokenTypes.IF, "IF"));
	  }

	  static get IFELSE() {
	    return (0, _util.shadow)(this, "IFELSE", new PostScriptToken(PostScriptTokenTypes.IFELSE, "IFELSE"));
	  }

	}

	class PostScriptLexer {
	  constructor(stream) {
	    this.stream = stream;
	    this.nextChar();
	    this.strBuf = [];
	  }

	  nextChar() {
	    return this.currentChar = this.stream.getByte();
	  }

	  getToken() {
	    let comment = false;
	    let ch = this.currentChar;

	    while (true) {
	      if (ch < 0) {
	        return _primitives.EOF;
	      }

	      if (comment) {
	        if (ch === 0x0a || ch === 0x0d) {
	          comment = false;
	        }
	      } else if (ch === 0x25) {
	        comment = true;
	      } else if (!(0, _core_utils.isWhiteSpace)(ch)) {
	        break;
	      }

	      ch = this.nextChar();
	    }

	    switch (ch | 0) {
	      case 0x30:
	      case 0x31:
	      case 0x32:
	      case 0x33:
	      case 0x34:
	      case 0x35:
	      case 0x36:
	      case 0x37:
	      case 0x38:
	      case 0x39:
	      case 0x2b:
	      case 0x2d:
	      case 0x2e:
	        return new PostScriptToken(PostScriptTokenTypes.NUMBER, this.getNumber());

	      case 0x7b:
	        this.nextChar();
	        return PostScriptToken.LBRACE;

	      case 0x7d:
	        this.nextChar();
	        return PostScriptToken.RBRACE;
	    }

	    const strBuf = this.strBuf;
	    strBuf.length = 0;
	    strBuf[0] = String.fromCharCode(ch);

	    while ((ch = this.nextChar()) >= 0 && (ch >= 0x41 && ch <= 0x5a || ch >= 0x61 && ch <= 0x7a)) {
	      strBuf.push(String.fromCharCode(ch));
	    }

	    const str = strBuf.join("");

	    switch (str.toLowerCase()) {
	      case "if":
	        return PostScriptToken.IF;

	      case "ifelse":
	        return PostScriptToken.IFELSE;

	      default:
	        return PostScriptToken.getOperator(str);
	    }
	  }

	  getNumber() {
	    let ch = this.currentChar;
	    const strBuf = this.strBuf;
	    strBuf.length = 0;
	    strBuf[0] = String.fromCharCode(ch);

	    while ((ch = this.nextChar()) >= 0) {
	      if (ch >= 0x30 && ch <= 0x39 || ch === 0x2d || ch === 0x2e) {
	        strBuf.push(String.fromCharCode(ch));
	      } else {
	        break;
	      }
	    }

	    const value = parseFloat(strBuf.join(""));

	    if (isNaN(value)) {
	      throw new _util.FormatError(`Invalid floating point number: ${value}`);
	    }

	    return value;
	  }

	}

	exports.PostScriptLexer = PostScriptLexer;

	/***/ }),
	/* 59 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.LocalTilingPatternCache = exports.LocalImageCache = exports.LocalGStateCache = exports.LocalFunctionCache = exports.LocalColorSpaceCache = exports.GlobalImageCache = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	class BaseLocalCache {
	  constructor(options) {
	    if (this.constructor === BaseLocalCache) {
	      (0, _util.unreachable)("Cannot initialize BaseLocalCache.");
	    }

	    this._onlyRefs = (options && options.onlyRefs) === true;

	    if (!this._onlyRefs) {
	      this._nameRefMap = new Map();
	      this._imageMap = new Map();
	    }

	    this._imageCache = new _primitives.RefSetCache();
	  }

	  getByName(name) {
	    if (this._onlyRefs) {
	      (0, _util.unreachable)("Should not call `getByName` method.");
	    }

	    const ref = this._nameRefMap.get(name);

	    if (ref) {
	      return this.getByRef(ref);
	    }

	    return this._imageMap.get(name) || null;
	  }

	  getByRef(ref) {
	    return this._imageCache.get(ref) || null;
	  }

	  set(name, ref, data) {
	    (0, _util.unreachable)("Abstract method `set` called.");
	  }

	}

	class LocalImageCache extends BaseLocalCache {
	  set(name, ref = null, data) {
	    if (typeof name !== "string") {
	      throw new Error('LocalImageCache.set - expected "name" argument.');
	    }

	    if (ref) {
	      if (this._imageCache.has(ref)) {
	        return;
	      }

	      this._nameRefMap.set(name, ref);

	      this._imageCache.put(ref, data);

	      return;
	    }

	    if (this._imageMap.has(name)) {
	      return;
	    }

	    this._imageMap.set(name, data);
	  }

	}

	exports.LocalImageCache = LocalImageCache;

	class LocalColorSpaceCache extends BaseLocalCache {
	  set(name = null, ref = null, data) {
	    if (typeof name !== "string" && !ref) {
	      throw new Error('LocalColorSpaceCache.set - expected "name" and/or "ref" argument.');
	    }

	    if (ref) {
	      if (this._imageCache.has(ref)) {
	        return;
	      }

	      if (name !== null) {
	        this._nameRefMap.set(name, ref);
	      }

	      this._imageCache.put(ref, data);

	      return;
	    }

	    if (this._imageMap.has(name)) {
	      return;
	    }

	    this._imageMap.set(name, data);
	  }

	}

	exports.LocalColorSpaceCache = LocalColorSpaceCache;

	class LocalFunctionCache extends BaseLocalCache {
	  constructor(options) {
	    super({
	      onlyRefs: true
	    });
	  }

	  set(name = null, ref, data) {
	    if (!ref) {
	      throw new Error('LocalFunctionCache.set - expected "ref" argument.');
	    }

	    if (this._imageCache.has(ref)) {
	      return;
	    }

	    this._imageCache.put(ref, data);
	  }

	}

	exports.LocalFunctionCache = LocalFunctionCache;

	class LocalGStateCache extends BaseLocalCache {
	  set(name, ref = null, data) {
	    if (typeof name !== "string") {
	      throw new Error('LocalGStateCache.set - expected "name" argument.');
	    }

	    if (ref) {
	      if (this._imageCache.has(ref)) {
	        return;
	      }

	      this._nameRefMap.set(name, ref);

	      this._imageCache.put(ref, data);

	      return;
	    }

	    if (this._imageMap.has(name)) {
	      return;
	    }

	    this._imageMap.set(name, data);
	  }

	}

	exports.LocalGStateCache = LocalGStateCache;

	class LocalTilingPatternCache extends BaseLocalCache {
	  constructor(options) {
	    super({
	      onlyRefs: true
	    });
	  }

	  set(name = null, ref, data) {
	    if (!ref) {
	      throw new Error('LocalTilingPatternCache.set - expected "ref" argument.');
	    }

	    if (this._imageCache.has(ref)) {
	      return;
	    }

	    this._imageCache.put(ref, data);
	  }

	}

	exports.LocalTilingPatternCache = LocalTilingPatternCache;

	class GlobalImageCache {
	  static get NUM_PAGES_THRESHOLD() {
	    return (0, _util.shadow)(this, "NUM_PAGES_THRESHOLD", 2);
	  }

	  static get MIN_IMAGES_TO_CACHE() {
	    return (0, _util.shadow)(this, "MIN_IMAGES_TO_CACHE", 10);
	  }

	  static get MAX_BYTE_SIZE() {
	    return (0, _util.shadow)(this, "MAX_BYTE_SIZE", 40e6);
	  }

	  constructor() {
	    this._refCache = new _primitives.RefSetCache();
	    this._imageCache = new _primitives.RefSetCache();
	  }

	  get _byteSize() {
	    let byteSize = 0;

	    for (const imageData of this._imageCache) {
	      byteSize += imageData.byteSize;
	    }

	    return byteSize;
	  }

	  get _cacheLimitReached() {
	    if (this._imageCache.size < GlobalImageCache.MIN_IMAGES_TO_CACHE) {
	      return false;
	    }

	    if (this._byteSize < GlobalImageCache.MAX_BYTE_SIZE) {
	      return false;
	    }

	    return true;
	  }

	  shouldCache(ref, pageIndex) {
	    const pageIndexSet = this._refCache.get(ref);

	    const numPages = pageIndexSet ? pageIndexSet.size + (pageIndexSet.has(pageIndex) ? 0 : 1) : 1;

	    if (numPages < GlobalImageCache.NUM_PAGES_THRESHOLD) {
	      return false;
	    }

	    if (!this._imageCache.has(ref) && this._cacheLimitReached) {
	      return false;
	    }

	    return true;
	  }

	  addPageIndex(ref, pageIndex) {
	    let pageIndexSet = this._refCache.get(ref);

	    if (!pageIndexSet) {
	      pageIndexSet = new Set();

	      this._refCache.put(ref, pageIndexSet);
	    }

	    pageIndexSet.add(pageIndex);
	  }

	  addByteSize(ref, byteSize) {
	    const imageData = this._imageCache.get(ref);

	    if (!imageData) {
	      return;
	    }

	    if (imageData.byteSize) {
	      return;
	    }

	    imageData.byteSize = byteSize;
	  }

	  getData(ref, pageIndex) {
	    const pageIndexSet = this._refCache.get(ref);

	    if (!pageIndexSet) {
	      return null;
	    }

	    if (pageIndexSet.size < GlobalImageCache.NUM_PAGES_THRESHOLD) {
	      return null;
	    }

	    const imageData = this._imageCache.get(ref);

	    if (!imageData) {
	      return null;
	    }

	    pageIndexSet.add(pageIndex);
	    return imageData;
	  }

	  setData(ref, data) {
	    if (!this._refCache.has(ref)) {
	      throw new Error('GlobalImageCache.setData - expected "addPageIndex" to have been called.');
	    }

	    if (this._imageCache.has(ref)) {
	      return;
	    }

	    if (this._cacheLimitReached) {
	      (0, _util.warn)("GlobalImageCache.setData - cache limit reached.");
	      return;
	    }

	    this._imageCache.put(ref, data);
	  }

	  clear(onlyData = false) {
	    if (!onlyData) {
	      this._refCache.clear();
	    }

	    this._imageCache.clear();
	  }

	}

	exports.GlobalImageCache = GlobalImageCache;

	/***/ }),
	/* 60 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.bidi = bidi;

	var _util = __w_pdfjs_require__(2);

	const baseTypes = ["BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "S", "B", "S", "WS", "B", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "B", "B", "B", "S", "WS", "ON", "ON", "ET", "ET", "ET", "ON", "ON", "ON", "ON", "ON", "ES", "CS", "ES", "CS", "CS", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "CS", "ON", "ON", "ON", "ON", "ON", "ON", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "ON", "ON", "ON", "ON", "ON", "ON", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "ON", "ON", "ON", "ON", "BN", "BN", "BN", "BN", "BN", "BN", "B", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "BN", "CS", "ON", "ET", "ET", "ET", "ET", "ON", "ON", "ON", "ON", "L", "ON", "ON", "BN", "ON", "ON", "ET", "ET", "EN", "EN", "ON", "L", "ON", "ON", "ON", "EN", "L", "ON", "ON", "ON", "ON", "ON", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "ON", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "L", "ON", "L", "L", "L", "L", "L", "L", "L", "L"];
	const arabicTypes = ["AN", "AN", "AN", "AN", "AN", "AN", "ON", "ON", "AL", "ET", "ET", "AL", "CS", "AL", "ON", "ON", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "AL", "AL", "", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "AN", "AN", "AN", "AN", "AN", "AN", "AN", "AN", "AN", "AN", "ET", "AN", "AN", "AL", "AL", "AL", "NSM", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "AL", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "AN", "ON", "NSM", "NSM", "NSM", "NSM", "NSM", "NSM", "AL", "AL", "NSM", "NSM", "ON", "NSM", "NSM", "NSM", "NSM", "AL", "AL", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "EN", "AL", "AL", "AL", "AL", "AL", "AL"];

	function isOdd(i) {
	  return (i & 1) !== 0;
	}

	function isEven(i) {
	  return (i & 1) === 0;
	}

	function findUnequal(arr, start, value) {
	  let j, jj;

	  for (j = start, jj = arr.length; j < jj; ++j) {
	    if (arr[j] !== value) {
	      return j;
	    }
	  }

	  return j;
	}

	function setValues(arr, start, end, value) {
	  for (let j = start; j < end; ++j) {
	    arr[j] = value;
	  }
	}

	function reverseValues(arr, start, end) {
	  for (let i = start, j = end - 1; i < j; ++i, --j) {
	    const temp = arr[i];
	    arr[i] = arr[j];
	    arr[j] = temp;
	  }
	}

	function createBidiText(str, isLTR, vertical = false) {
	  let dir = "ltr";

	  if (vertical) {
	    dir = "ttb";
	  } else if (!isLTR) {
	    dir = "rtl";
	  }

	  return {
	    str,
	    dir
	  };
	}

	const chars = [];
	const types = [];

	function bidi(str, startLevel = -1, vertical = false) {
	  let isLTR = true;
	  const strLength = str.length;

	  if (strLength === 0 || vertical) {
	    return createBidiText(str, isLTR, vertical);
	  }

	  chars.length = strLength;
	  types.length = strLength;
	  let numBidi = 0;
	  let i, ii;

	  for (i = 0; i < strLength; ++i) {
	    chars[i] = str.charAt(i);
	    const charCode = str.charCodeAt(i);
	    let charType = "L";

	    if (charCode <= 0x00ff) {
	      charType = baseTypes[charCode];
	    } else if (0x0590 <= charCode && charCode <= 0x05f4) {
	      charType = "R";
	    } else if (0x0600 <= charCode && charCode <= 0x06ff) {
	      charType = arabicTypes[charCode & 0xff];

	      if (!charType) {
	        (0, _util.warn)("Bidi: invalid Unicode character " + charCode.toString(16));
	      }
	    } else if (0x0700 <= charCode && charCode <= 0x08ac) {
	      charType = "AL";
	    }

	    if (charType === "R" || charType === "AL" || charType === "AN") {
	      numBidi++;
	    }

	    types[i] = charType;
	  }

	  if (numBidi === 0) {
	    isLTR = true;
	    return createBidiText(str, isLTR);
	  }

	  if (startLevel === -1) {
	    if (numBidi / strLength < 0.3 && strLength > 4) {
	      isLTR = true;
	      startLevel = 0;
	    } else {
	      isLTR = false;
	      startLevel = 1;
	    }
	  }

	  const levels = [];

	  for (i = 0; i < strLength; ++i) {
	    levels[i] = startLevel;
	  }

	  const e = isOdd(startLevel) ? "R" : "L";
	  const sor = e;
	  const eor = sor;
	  let lastType = sor;

	  for (i = 0; i < strLength; ++i) {
	    if (types[i] === "NSM") {
	      types[i] = lastType;
	    } else {
	      lastType = types[i];
	    }
	  }

	  lastType = sor;
	  let t;

	  for (i = 0; i < strLength; ++i) {
	    t = types[i];

	    if (t === "EN") {
	      types[i] = lastType === "AL" ? "AN" : "EN";
	    } else if (t === "R" || t === "L" || t === "AL") {
	      lastType = t;
	    }
	  }

	  for (i = 0; i < strLength; ++i) {
	    t = types[i];

	    if (t === "AL") {
	      types[i] = "R";
	    }
	  }

	  for (i = 1; i < strLength - 1; ++i) {
	    if (types[i] === "ES" && types[i - 1] === "EN" && types[i + 1] === "EN") {
	      types[i] = "EN";
	    }

	    if (types[i] === "CS" && (types[i - 1] === "EN" || types[i - 1] === "AN") && types[i + 1] === types[i - 1]) {
	      types[i] = types[i - 1];
	    }
	  }

	  for (i = 0; i < strLength; ++i) {
	    if (types[i] === "EN") {
	      for (let j = i - 1; j >= 0; --j) {
	        if (types[j] !== "ET") {
	          break;
	        }

	        types[j] = "EN";
	      }

	      for (let j = i + 1; j < strLength; ++j) {
	        if (types[j] !== "ET") {
	          break;
	        }

	        types[j] = "EN";
	      }
	    }
	  }

	  for (i = 0; i < strLength; ++i) {
	    t = types[i];

	    if (t === "WS" || t === "ES" || t === "ET" || t === "CS") {
	      types[i] = "ON";
	    }
	  }

	  lastType = sor;

	  for (i = 0; i < strLength; ++i) {
	    t = types[i];

	    if (t === "EN") {
	      types[i] = lastType === "L" ? "L" : "EN";
	    } else if (t === "R" || t === "L") {
	      lastType = t;
	    }
	  }

	  for (i = 0; i < strLength; ++i) {
	    if (types[i] === "ON") {
	      const end = findUnequal(types, i + 1, "ON");
	      let before = sor;

	      if (i > 0) {
	        before = types[i - 1];
	      }

	      let after = eor;

	      if (end + 1 < strLength) {
	        after = types[end + 1];
	      }

	      if (before !== "L") {
	        before = "R";
	      }

	      if (after !== "L") {
	        after = "R";
	      }

	      if (before === after) {
	        setValues(types, i, end, before);
	      }

	      i = end - 1;
	    }
	  }

	  for (i = 0; i < strLength; ++i) {
	    if (types[i] === "ON") {
	      types[i] = e;
	    }
	  }

	  for (i = 0; i < strLength; ++i) {
	    t = types[i];

	    if (isEven(levels[i])) {
	      if (t === "R") {
	        levels[i] += 1;
	      } else if (t === "AN" || t === "EN") {
	        levels[i] += 2;
	      }
	    } else {
	      if (t === "L" || t === "AN" || t === "EN") {
	        levels[i] += 1;
	      }
	    }
	  }

	  let highestLevel = -1;
	  let lowestOddLevel = 99;
	  let level;

	  for (i = 0, ii = levels.length; i < ii; ++i) {
	    level = levels[i];

	    if (highestLevel < level) {
	      highestLevel = level;
	    }

	    if (lowestOddLevel > level && isOdd(level)) {
	      lowestOddLevel = level;
	    }
	  }

	  for (level = highestLevel; level >= lowestOddLevel; --level) {
	    let start = -1;

	    for (i = 0, ii = levels.length; i < ii; ++i) {
	      if (levels[i] < level) {
	        if (start >= 0) {
	          reverseValues(chars, start, i);
	          start = -1;
	        }
	      } else if (start < 0) {
	        start = i;
	      }
	    }

	    if (start >= 0) {
	      reverseValues(chars, start, levels.length);
	    }
	  }

	  for (i = 0, ii = chars.length; i < ii; ++i) {
	    const ch = chars[i];

	    if (ch === "<" || ch === ">") {
	      chars[i] = "";
	    }
	  }

	  return createBidiText(chars.join(""), isLTR);
	}

	/***/ }),
	/* 61 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.MurmurHash3_64 = void 0;

	var _util = __w_pdfjs_require__(2);

	const SEED = 0xc3d2e1f0;
	const MASK_HIGH = 0xffff0000;
	const MASK_LOW = 0xffff;

	class MurmurHash3_64 {
	  constructor(seed) {
	    this.h1 = seed ? seed & 0xffffffff : SEED;
	    this.h2 = seed ? seed & 0xffffffff : SEED;
	  }

	  update(input) {
	    let data, length;

	    if (typeof input === "string") {
	      data = new Uint8Array(input.length * 2);
	      length = 0;

	      for (let i = 0, ii = input.length; i < ii; i++) {
	        const code = input.charCodeAt(i);

	        if (code <= 0xff) {
	          data[length++] = code;
	        } else {
	          data[length++] = code >>> 8;
	          data[length++] = code & 0xff;
	        }
	      }
	    } else if ((0, _util.isArrayBuffer)(input)) {
	      data = input.slice();
	      length = data.byteLength;
	    } else {
	      throw new Error("Wrong data format in MurmurHash3_64_update. " + "Input must be a string or array.");
	    }

	    const blockCounts = length >> 2;
	    const tailLength = length - blockCounts * 4;
	    const dataUint32 = new Uint32Array(data.buffer, 0, blockCounts);
	    let k1 = 0,
	        k2 = 0;
	    let h1 = this.h1,
	        h2 = this.h2;
	    const C1 = 0xcc9e2d51,
	          C2 = 0x1b873593;
	    const C1_LOW = C1 & MASK_LOW,
	          C2_LOW = C2 & MASK_LOW;

	    for (let i = 0; i < blockCounts; i++) {
	      if (i & 1) {
	        k1 = dataUint32[i];
	        k1 = k1 * C1 & MASK_HIGH | k1 * C1_LOW & MASK_LOW;
	        k1 = k1 << 15 | k1 >>> 17;
	        k1 = k1 * C2 & MASK_HIGH | k1 * C2_LOW & MASK_LOW;
	        h1 ^= k1;
	        h1 = h1 << 13 | h1 >>> 19;
	        h1 = h1 * 5 + 0xe6546b64;
	      } else {
	        k2 = dataUint32[i];
	        k2 = k2 * C1 & MASK_HIGH | k2 * C1_LOW & MASK_LOW;
	        k2 = k2 << 15 | k2 >>> 17;
	        k2 = k2 * C2 & MASK_HIGH | k2 * C2_LOW & MASK_LOW;
	        h2 ^= k2;
	        h2 = h2 << 13 | h2 >>> 19;
	        h2 = h2 * 5 + 0xe6546b64;
	      }
	    }

	    k1 = 0;

	    switch (tailLength) {
	      case 3:
	        k1 ^= data[blockCounts * 4 + 2] << 16;

	      case 2:
	        k1 ^= data[blockCounts * 4 + 1] << 8;

	      case 1:
	        k1 ^= data[blockCounts * 4];
	        k1 = k1 * C1 & MASK_HIGH | k1 * C1_LOW & MASK_LOW;
	        k1 = k1 << 15 | k1 >>> 17;
	        k1 = k1 * C2 & MASK_HIGH | k1 * C2_LOW & MASK_LOW;

	        if (blockCounts & 1) {
	          h1 ^= k1;
	        } else {
	          h2 ^= k1;
	        }

	    }

	    this.h1 = h1;
	    this.h2 = h2;
	  }

	  hexdigest() {
	    let h1 = this.h1,
	        h2 = this.h2;
	    h1 ^= h2 >>> 1;
	    h1 = h1 * 0xed558ccd & MASK_HIGH | h1 * 0x8ccd & MASK_LOW;
	    h2 = h2 * 0xff51afd7 & MASK_HIGH | ((h2 << 16 | h1 >>> 16) * 0xafd7ed55 & MASK_HIGH) >>> 16;
	    h1 ^= h2 >>> 1;
	    h1 = h1 * 0x1a85ec53 & MASK_HIGH | h1 * 0xec53 & MASK_LOW;
	    h2 = h2 * 0xc4ceb9fe & MASK_HIGH | ((h2 << 16 | h1 >>> 16) * 0xb9fe1a85 & MASK_HIGH) >>> 16;
	    h1 ^= h2 >>> 1;
	    const hex1 = (h1 >>> 0).toString(16),
	          hex2 = (h2 >>> 0).toString(16);
	    return hex1.padStart(8, "0") + hex2.padStart(8, "0");
	  }

	}

	exports.MurmurHash3_64 = MurmurHash3_64;

	/***/ }),
	/* 62 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.OperatorList = void 0;

	var _util = __w_pdfjs_require__(2);

	function addState(parentState, pattern, checkFn, iterateFn, processFn) {
	  let state = parentState;

	  for (let i = 0, ii = pattern.length - 1; i < ii; i++) {
	    const item = pattern[i];
	    state = state[item] || (state[item] = []);
	  }

	  state[pattern.at(-1)] = {
	    checkFn,
	    iterateFn,
	    processFn
	  };
	}

	const InitialState = [];
	addState(InitialState, [_util.OPS.save, _util.OPS.transform, _util.OPS.paintInlineImageXObject, _util.OPS.restore], null, function iterateInlineImageGroup(context, i) {
	  const fnArray = context.fnArray;
	  const iFirstSave = context.iCurr - 3;
	  const pos = (i - iFirstSave) % 4;

	  switch (pos) {
	    case 0:
	      return fnArray[i] === _util.OPS.save;

	    case 1:
	      return fnArray[i] === _util.OPS.transform;

	    case 2:
	      return fnArray[i] === _util.OPS.paintInlineImageXObject;

	    case 3:
	      return fnArray[i] === _util.OPS.restore;
	  }

	  throw new Error(`iterateInlineImageGroup - invalid pos: ${pos}`);
	}, function foundInlineImageGroup(context, i) {
	  const MIN_IMAGES_IN_INLINE_IMAGES_BLOCK = 10;
	  const MAX_IMAGES_IN_INLINE_IMAGES_BLOCK = 200;
	  const MAX_WIDTH = 1000;
	  const IMAGE_PADDING = 1;
	  const fnArray = context.fnArray,
	        argsArray = context.argsArray;
	  const curr = context.iCurr;
	  const iFirstSave = curr - 3;
	  const iFirstTransform = curr - 2;
	  const iFirstPIIXO = curr - 1;
	  const count = Math.min(Math.floor((i - iFirstSave) / 4), MAX_IMAGES_IN_INLINE_IMAGES_BLOCK);

	  if (count < MIN_IMAGES_IN_INLINE_IMAGES_BLOCK) {
	    return i - (i - iFirstSave) % 4;
	  }

	  let maxX = 0;
	  const map = [];
	  let maxLineHeight = 0;
	  let currentX = IMAGE_PADDING,
	      currentY = IMAGE_PADDING;

	  for (let q = 0; q < count; q++) {
	    const transform = argsArray[iFirstTransform + (q << 2)];
	    const img = argsArray[iFirstPIIXO + (q << 2)][0];

	    if (currentX + img.width > MAX_WIDTH) {
	      maxX = Math.max(maxX, currentX);
	      currentY += maxLineHeight + 2 * IMAGE_PADDING;
	      currentX = 0;
	      maxLineHeight = 0;
	    }

	    map.push({
	      transform,
	      x: currentX,
	      y: currentY,
	      w: img.width,
	      h: img.height
	    });
	    currentX += img.width + 2 * IMAGE_PADDING;
	    maxLineHeight = Math.max(maxLineHeight, img.height);
	  }

	  const imgWidth = Math.max(maxX, currentX) + IMAGE_PADDING;
	  const imgHeight = currentY + maxLineHeight + IMAGE_PADDING;
	  const imgData = new Uint8Array(imgWidth * imgHeight * 4);
	  const imgRowSize = imgWidth << 2;

	  for (let q = 0; q < count; q++) {
	    const data = argsArray[iFirstPIIXO + (q << 2)][0].data;
	    const rowSize = map[q].w << 2;
	    let dataOffset = 0;
	    let offset = map[q].x + map[q].y * imgWidth << 2;
	    imgData.set(data.subarray(0, rowSize), offset - imgRowSize);

	    for (let k = 0, kk = map[q].h; k < kk; k++) {
	      imgData.set(data.subarray(dataOffset, dataOffset + rowSize), offset);
	      dataOffset += rowSize;
	      offset += imgRowSize;
	    }

	    imgData.set(data.subarray(dataOffset - rowSize, dataOffset), offset);

	    while (offset >= 0) {
	      data[offset - 4] = data[offset];
	      data[offset - 3] = data[offset + 1];
	      data[offset - 2] = data[offset + 2];
	      data[offset - 1] = data[offset + 3];
	      data[offset + rowSize] = data[offset + rowSize - 4];
	      data[offset + rowSize + 1] = data[offset + rowSize - 3];
	      data[offset + rowSize + 2] = data[offset + rowSize - 2];
	      data[offset + rowSize + 3] = data[offset + rowSize - 1];
	      offset -= imgRowSize;
	    }
	  }

	  fnArray.splice(iFirstSave, count * 4, _util.OPS.paintInlineImageXObjectGroup);
	  argsArray.splice(iFirstSave, count * 4, [{
	    width: imgWidth,
	    height: imgHeight,
	    kind: _util.ImageKind.RGBA_32BPP,
	    data: imgData
	  }, map]);
	  return iFirstSave + 1;
	});
	addState(InitialState, [_util.OPS.save, _util.OPS.transform, _util.OPS.paintImageMaskXObject, _util.OPS.restore], null, function iterateImageMaskGroup(context, i) {
	  const fnArray = context.fnArray;
	  const iFirstSave = context.iCurr - 3;
	  const pos = (i - iFirstSave) % 4;

	  switch (pos) {
	    case 0:
	      return fnArray[i] === _util.OPS.save;

	    case 1:
	      return fnArray[i] === _util.OPS.transform;

	    case 2:
	      return fnArray[i] === _util.OPS.paintImageMaskXObject;

	    case 3:
	      return fnArray[i] === _util.OPS.restore;
	  }

	  throw new Error(`iterateImageMaskGroup - invalid pos: ${pos}`);
	}, function foundImageMaskGroup(context, i) {
	  const MIN_IMAGES_IN_MASKS_BLOCK = 10;
	  const MAX_IMAGES_IN_MASKS_BLOCK = 100;
	  const MAX_SAME_IMAGES_IN_MASKS_BLOCK = 1000;
	  const fnArray = context.fnArray,
	        argsArray = context.argsArray;
	  const curr = context.iCurr;
	  const iFirstSave = curr - 3;
	  const iFirstTransform = curr - 2;
	  const iFirstPIMXO = curr - 1;
	  let count = Math.floor((i - iFirstSave) / 4);

	  if (count < MIN_IMAGES_IN_MASKS_BLOCK) {
	    return i - (i - iFirstSave) % 4;
	  }

	  let isSameImage = false;
	  let iTransform, transformArgs;
	  const firstPIMXOArg0 = argsArray[iFirstPIMXO][0];
	  const firstTransformArg0 = argsArray[iFirstTransform][0],
	        firstTransformArg1 = argsArray[iFirstTransform][1],
	        firstTransformArg2 = argsArray[iFirstTransform][2],
	        firstTransformArg3 = argsArray[iFirstTransform][3];

	  if (firstTransformArg1 === firstTransformArg2) {
	    isSameImage = true;
	    iTransform = iFirstTransform + 4;
	    let iPIMXO = iFirstPIMXO + 4;

	    for (let q = 1; q < count; q++, iTransform += 4, iPIMXO += 4) {
	      transformArgs = argsArray[iTransform];

	      if (argsArray[iPIMXO][0] !== firstPIMXOArg0 || transformArgs[0] !== firstTransformArg0 || transformArgs[1] !== firstTransformArg1 || transformArgs[2] !== firstTransformArg2 || transformArgs[3] !== firstTransformArg3) {
	        if (q < MIN_IMAGES_IN_MASKS_BLOCK) {
	          isSameImage = false;
	        } else {
	          count = q;
	        }

	        break;
	      }
	    }
	  }

	  if (isSameImage) {
	    count = Math.min(count, MAX_SAME_IMAGES_IN_MASKS_BLOCK);
	    const positions = new Float32Array(count * 2);
	    iTransform = iFirstTransform;

	    for (let q = 0; q < count; q++, iTransform += 4) {
	      transformArgs = argsArray[iTransform];
	      positions[q << 1] = transformArgs[4];
	      positions[(q << 1) + 1] = transformArgs[5];
	    }

	    fnArray.splice(iFirstSave, count * 4, _util.OPS.paintImageMaskXObjectRepeat);
	    argsArray.splice(iFirstSave, count * 4, [firstPIMXOArg0, firstTransformArg0, firstTransformArg1, firstTransformArg2, firstTransformArg3, positions]);
	  } else {
	    count = Math.min(count, MAX_IMAGES_IN_MASKS_BLOCK);
	    const images = [];

	    for (let q = 0; q < count; q++) {
	      transformArgs = argsArray[iFirstTransform + (q << 2)];
	      const maskParams = argsArray[iFirstPIMXO + (q << 2)][0];
	      images.push({
	        data: maskParams.data,
	        width: maskParams.width,
	        height: maskParams.height,
	        interpolate: maskParams.interpolate,
	        count: maskParams.count,
	        transform: transformArgs
	      });
	    }

	    fnArray.splice(iFirstSave, count * 4, _util.OPS.paintImageMaskXObjectGroup);
	    argsArray.splice(iFirstSave, count * 4, [images]);
	  }

	  return iFirstSave + 1;
	});
	addState(InitialState, [_util.OPS.save, _util.OPS.transform, _util.OPS.paintImageXObject, _util.OPS.restore], function (context) {
	  const argsArray = context.argsArray;
	  const iFirstTransform = context.iCurr - 2;
	  return argsArray[iFirstTransform][1] === 0 && argsArray[iFirstTransform][2] === 0;
	}, function iterateImageGroup(context, i) {
	  const fnArray = context.fnArray,
	        argsArray = context.argsArray;
	  const iFirstSave = context.iCurr - 3;
	  const pos = (i - iFirstSave) % 4;

	  switch (pos) {
	    case 0:
	      return fnArray[i] === _util.OPS.save;

	    case 1:
	      if (fnArray[i] !== _util.OPS.transform) {
	        return false;
	      }

	      const iFirstTransform = context.iCurr - 2;
	      const firstTransformArg0 = argsArray[iFirstTransform][0];
	      const firstTransformArg3 = argsArray[iFirstTransform][3];

	      if (argsArray[i][0] !== firstTransformArg0 || argsArray[i][1] !== 0 || argsArray[i][2] !== 0 || argsArray[i][3] !== firstTransformArg3) {
	        return false;
	      }

	      return true;

	    case 2:
	      if (fnArray[i] !== _util.OPS.paintImageXObject) {
	        return false;
	      }

	      const iFirstPIXO = context.iCurr - 1;
	      const firstPIXOArg0 = argsArray[iFirstPIXO][0];

	      if (argsArray[i][0] !== firstPIXOArg0) {
	        return false;
	      }

	      return true;

	    case 3:
	      return fnArray[i] === _util.OPS.restore;
	  }

	  throw new Error(`iterateImageGroup - invalid pos: ${pos}`);
	}, function (context, i) {
	  const MIN_IMAGES_IN_BLOCK = 3;
	  const MAX_IMAGES_IN_BLOCK = 1000;
	  const fnArray = context.fnArray,
	        argsArray = context.argsArray;
	  const curr = context.iCurr;
	  const iFirstSave = curr - 3;
	  const iFirstTransform = curr - 2;
	  const iFirstPIXO = curr - 1;
	  const firstPIXOArg0 = argsArray[iFirstPIXO][0];
	  const firstTransformArg0 = argsArray[iFirstTransform][0];
	  const firstTransformArg3 = argsArray[iFirstTransform][3];
	  const count = Math.min(Math.floor((i - iFirstSave) / 4), MAX_IMAGES_IN_BLOCK);

	  if (count < MIN_IMAGES_IN_BLOCK) {
	    return i - (i - iFirstSave) % 4;
	  }

	  const positions = new Float32Array(count * 2);
	  let iTransform = iFirstTransform;

	  for (let q = 0; q < count; q++, iTransform += 4) {
	    const transformArgs = argsArray[iTransform];
	    positions[q << 1] = transformArgs[4];
	    positions[(q << 1) + 1] = transformArgs[5];
	  }

	  const args = [firstPIXOArg0, firstTransformArg0, firstTransformArg3, positions];
	  fnArray.splice(iFirstSave, count * 4, _util.OPS.paintImageXObjectRepeat);
	  argsArray.splice(iFirstSave, count * 4, args);
	  return iFirstSave + 1;
	});
	addState(InitialState, [_util.OPS.beginText, _util.OPS.setFont, _util.OPS.setTextMatrix, _util.OPS.showText, _util.OPS.endText], null, function iterateShowTextGroup(context, i) {
	  const fnArray = context.fnArray,
	        argsArray = context.argsArray;
	  const iFirstSave = context.iCurr - 4;
	  const pos = (i - iFirstSave) % 5;

	  switch (pos) {
	    case 0:
	      return fnArray[i] === _util.OPS.beginText;

	    case 1:
	      return fnArray[i] === _util.OPS.setFont;

	    case 2:
	      return fnArray[i] === _util.OPS.setTextMatrix;

	    case 3:
	      if (fnArray[i] !== _util.OPS.showText) {
	        return false;
	      }

	      const iFirstSetFont = context.iCurr - 3;
	      const firstSetFontArg0 = argsArray[iFirstSetFont][0];
	      const firstSetFontArg1 = argsArray[iFirstSetFont][1];

	      if (argsArray[i][0] !== firstSetFontArg0 || argsArray[i][1] !== firstSetFontArg1) {
	        return false;
	      }

	      return true;

	    case 4:
	      return fnArray[i] === _util.OPS.endText;
	  }

	  throw new Error(`iterateShowTextGroup - invalid pos: ${pos}`);
	}, function (context, i) {
	  const MIN_CHARS_IN_BLOCK = 3;
	  const MAX_CHARS_IN_BLOCK = 1000;
	  const fnArray = context.fnArray,
	        argsArray = context.argsArray;
	  const curr = context.iCurr;
	  const iFirstBeginText = curr - 4;
	  const iFirstSetFont = curr - 3;
	  const iFirstSetTextMatrix = curr - 2;
	  const iFirstShowText = curr - 1;
	  const iFirstEndText = curr;
	  const firstSetFontArg0 = argsArray[iFirstSetFont][0];
	  const firstSetFontArg1 = argsArray[iFirstSetFont][1];
	  let count = Math.min(Math.floor((i - iFirstBeginText) / 5), MAX_CHARS_IN_BLOCK);

	  if (count < MIN_CHARS_IN_BLOCK) {
	    return i - (i - iFirstBeginText) % 5;
	  }

	  let iFirst = iFirstBeginText;

	  if (iFirstBeginText >= 4 && fnArray[iFirstBeginText - 4] === fnArray[iFirstSetFont] && fnArray[iFirstBeginText - 3] === fnArray[iFirstSetTextMatrix] && fnArray[iFirstBeginText - 2] === fnArray[iFirstShowText] && fnArray[iFirstBeginText - 1] === fnArray[iFirstEndText] && argsArray[iFirstBeginText - 4][0] === firstSetFontArg0 && argsArray[iFirstBeginText - 4][1] === firstSetFontArg1) {
	    count++;
	    iFirst -= 5;
	  }

	  let iEndText = iFirst + 4;

	  for (let q = 1; q < count; q++) {
	    fnArray.splice(iEndText, 3);
	    argsArray.splice(iEndText, 3);
	    iEndText += 2;
	  }

	  return iEndText + 1;
	});

	class NullOptimizer {
	  constructor(queue) {
	    this.queue = queue;
	  }

	  _optimize() {}

	  push(fn, args) {
	    this.queue.fnArray.push(fn);
	    this.queue.argsArray.push(args);

	    this._optimize();
	  }

	  flush() {}

	  reset() {}

	}

	class QueueOptimizer extends NullOptimizer {
	  constructor(queue) {
	    super(queue);
	    this.state = null;
	    this.context = {
	      iCurr: 0,
	      fnArray: queue.fnArray,
	      argsArray: queue.argsArray
	    };
	    this.match = null;
	    this.lastProcessed = 0;
	  }

	  _optimize() {
	    const fnArray = this.queue.fnArray;
	    let i = this.lastProcessed,
	        ii = fnArray.length;
	    let state = this.state;
	    let match = this.match;

	    if (!state && !match && i + 1 === ii && !InitialState[fnArray[i]]) {
	      this.lastProcessed = ii;
	      return;
	    }

	    const context = this.context;

	    while (i < ii) {
	      if (match) {
	        const iterate = (0, match.iterateFn)(context, i);

	        if (iterate) {
	          i++;
	          continue;
	        }

	        i = (0, match.processFn)(context, i + 1);
	        ii = fnArray.length;
	        match = null;
	        state = null;

	        if (i >= ii) {
	          break;
	        }
	      }

	      state = (state || InitialState)[fnArray[i]];

	      if (!state || Array.isArray(state)) {
	        i++;
	        continue;
	      }

	      context.iCurr = i;
	      i++;

	      if (state.checkFn && !(0, state.checkFn)(context)) {
	        state = null;
	        continue;
	      }

	      match = state;
	      state = null;
	    }

	    this.state = state;
	    this.match = match;
	    this.lastProcessed = i;
	  }

	  flush() {
	    while (this.match) {
	      const length = this.queue.fnArray.length;
	      this.lastProcessed = (0, this.match.processFn)(this.context, length);
	      this.match = null;
	      this.state = null;

	      this._optimize();
	    }
	  }

	  reset() {
	    this.state = null;
	    this.match = null;
	    this.lastProcessed = 0;
	  }

	}

	class OperatorList {
	  static get CHUNK_SIZE() {
	    return (0, _util.shadow)(this, "CHUNK_SIZE", 1000);
	  }

	  static get CHUNK_SIZE_ABOUT() {
	    return (0, _util.shadow)(this, "CHUNK_SIZE_ABOUT", this.CHUNK_SIZE - 5);
	  }

	  constructor(intent = 0, streamSink) {
	    this._streamSink = streamSink;
	    this.fnArray = [];
	    this.argsArray = [];

	    if (streamSink && !(intent & _util.RenderingIntentFlag.OPLIST)) {
	      this.optimizer = new QueueOptimizer(this);
	    } else {
	      this.optimizer = new NullOptimizer(this);
	    }

	    this.dependencies = new Set();
	    this._totalLength = 0;
	    this.weight = 0;
	    this._resolved = streamSink ? null : Promise.resolve();
	  }

	  get length() {
	    return this.argsArray.length;
	  }

	  get ready() {
	    return this._resolved || this._streamSink.ready;
	  }

	  get totalLength() {
	    return this._totalLength + this.length;
	  }

	  addOp(fn, args) {
	    this.optimizer.push(fn, args);
	    this.weight++;

	    if (this._streamSink) {
	      if (this.weight >= OperatorList.CHUNK_SIZE) {
	        this.flush();
	      } else if (this.weight >= OperatorList.CHUNK_SIZE_ABOUT && (fn === _util.OPS.restore || fn === _util.OPS.endText)) {
	        this.flush();
	      }
	    }
	  }

	  addImageOps(fn, args, optionalContent) {
	    if (optionalContent !== undefined) {
	      this.addOp(_util.OPS.beginMarkedContentProps, ["OC", optionalContent]);
	    }

	    this.addOp(fn, args);

	    if (optionalContent !== undefined) {
	      this.addOp(_util.OPS.endMarkedContent, []);
	    }
	  }

	  addDependency(dependency) {
	    if (this.dependencies.has(dependency)) {
	      return;
	    }

	    this.dependencies.add(dependency);
	    this.addOp(_util.OPS.dependency, [dependency]);
	  }

	  addDependencies(dependencies) {
	    for (const dependency of dependencies) {
	      this.addDependency(dependency);
	    }
	  }

	  addOpList(opList) {
	    if (!(opList instanceof OperatorList)) {
	      (0, _util.warn)('addOpList - ignoring invalid "opList" parameter.');
	      return;
	    }

	    for (const dependency of opList.dependencies) {
	      this.dependencies.add(dependency);
	    }

	    for (let i = 0, ii = opList.length; i < ii; i++) {
	      this.addOp(opList.fnArray[i], opList.argsArray[i]);
	    }
	  }

	  getIR() {
	    return {
	      fnArray: this.fnArray,
	      argsArray: this.argsArray,
	      length: this.length
	    };
	  }

	  get _transfers() {
	    const transfers = [];
	    const {
	      fnArray,
	      argsArray,
	      length
	    } = this;

	    for (let i = 0; i < length; i++) {
	      switch (fnArray[i]) {
	        case _util.OPS.paintInlineImageXObject:
	        case _util.OPS.paintInlineImageXObjectGroup:
	        case _util.OPS.paintImageMaskXObject:
	          const arg = argsArray[i][0];

	          if (!arg.cached && arg.data && arg.data.buffer instanceof ArrayBuffer) {
	            transfers.push(arg.data.buffer);
	          }

	          break;
	      }
	    }

	    return transfers;
	  }

	  flush(lastChunk = false, separateAnnots = null) {
	    this.optimizer.flush();
	    const length = this.length;
	    this._totalLength += length;

	    this._streamSink.enqueue({
	      fnArray: this.fnArray,
	      argsArray: this.argsArray,
	      lastChunk,
	      separateAnnots,
	      length
	    }, 1, this._transfers);

	    this.dependencies.clear();
	    this.fnArray.length = 0;
	    this.argsArray.length = 0;
	    this.weight = 0;
	    this.optimizer.reset();
	  }

	}

	exports.OperatorList = OperatorList;

	/***/ }),
	/* 63 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.PDFImage = void 0;

	var _util = __w_pdfjs_require__(2);

	var _image_utils = __w_pdfjs_require__(64);

	var _base_stream = __w_pdfjs_require__(7);

	var _colorspace = __w_pdfjs_require__(14);

	var _decode_stream = __w_pdfjs_require__(19);

	var _jpeg_stream = __w_pdfjs_require__(27);

	var _jpx = __w_pdfjs_require__(30);

	var _primitives = __w_pdfjs_require__(5);

	function decodeAndClamp(value, addend, coefficient, max) {
	  value = addend + value * coefficient;

	  if (value < 0) {
	    value = 0;
	  } else if (value > max) {
	    value = max;
	  }

	  return value;
	}

	function resizeImageMask(src, bpc, w1, h1, w2, h2) {
	  const length = w2 * h2;
	  let dest;

	  if (bpc <= 8) {
	    dest = new Uint8Array(length);
	  } else if (bpc <= 16) {
	    dest = new Uint16Array(length);
	  } else {
	    dest = new Uint32Array(length);
	  }

	  const xRatio = w1 / w2;
	  const yRatio = h1 / h2;
	  let i,
	      j,
	      py,
	      newIndex = 0,
	      oldIndex;
	  const xScaled = new Uint16Array(w2);
	  const w1Scanline = w1;

	  for (i = 0; i < w2; i++) {
	    xScaled[i] = Math.floor(i * xRatio);
	  }

	  for (i = 0; i < h2; i++) {
	    py = Math.floor(i * yRatio) * w1Scanline;

	    for (j = 0; j < w2; j++) {
	      oldIndex = py + xScaled[j];
	      dest[newIndex++] = src[oldIndex];
	    }
	  }

	  return dest;
	}

	class PDFImage {
	  constructor({
	    xref,
	    res,
	    image,
	    isInline = false,
	    smask = null,
	    mask = null,
	    isMask = false,
	    pdfFunctionFactory,
	    localColorSpaceCache
	  }) {
	    this.image = image;
	    const dict = image.dict;
	    const filter = dict.get("F", "Filter");
	    let filterName;

	    if (filter instanceof _primitives.Name) {
	      filterName = filter.name;
	    } else if (Array.isArray(filter)) {
	      const filterZero = xref.fetchIfRef(filter[0]);

	      if (filterZero instanceof _primitives.Name) {
	        filterName = filterZero.name;
	      }
	    }

	    switch (filterName) {
	      case "JPXDecode":
	        const jpxImage = new _jpx.JpxImage();
	        jpxImage.parseImageProperties(image.stream);
	        image.stream.reset();
	        image.width = jpxImage.width;
	        image.height = jpxImage.height;
	        image.bitsPerComponent = jpxImage.bitsPerComponent;
	        image.numComps = jpxImage.componentsCount;
	        break;

	      case "JBIG2Decode":
	        image.bitsPerComponent = 1;
	        image.numComps = 1;
	        break;
	    }

	    let width = dict.get("W", "Width");
	    let height = dict.get("H", "Height");

	    if (Number.isInteger(image.width) && image.width > 0 && Number.isInteger(image.height) && image.height > 0 && (image.width !== width || image.height !== height)) {
	      (0, _util.warn)("PDFImage - using the Width/Height of the image data, " + "rather than the image dictionary.");
	      width = image.width;
	      height = image.height;
	    }

	    if (width < 1 || height < 1) {
	      throw new _util.FormatError(`Invalid image width: ${width} or height: ${height}`);
	    }

	    this.width = width;
	    this.height = height;
	    this.interpolate = dict.get("I", "Interpolate");
	    this.imageMask = dict.get("IM", "ImageMask") || false;
	    this.matte = dict.get("Matte") || false;
	    let bitsPerComponent = image.bitsPerComponent;

	    if (!bitsPerComponent) {
	      bitsPerComponent = dict.get("BPC", "BitsPerComponent");

	      if (!bitsPerComponent) {
	        if (this.imageMask) {
	          bitsPerComponent = 1;
	        } else {
	          throw new _util.FormatError(`Bits per component missing in image: ${this.imageMask}`);
	        }
	      }
	    }

	    this.bpc = bitsPerComponent;

	    if (!this.imageMask) {
	      let colorSpace = dict.getRaw("CS") || dict.getRaw("ColorSpace");

	      if (!colorSpace) {
	        (0, _util.info)("JPX images (which do not require color spaces)");

	        switch (image.numComps) {
	          case 1:
	            colorSpace = _primitives.Name.get("DeviceGray");
	            break;

	          case 3:
	            colorSpace = _primitives.Name.get("DeviceRGB");
	            break;

	          case 4:
	            colorSpace = _primitives.Name.get("DeviceCMYK");
	            break;

	          default:
	            throw new Error(`JPX images with ${image.numComps} color components not supported.`);
	        }
	      }

	      this.colorSpace = _colorspace.ColorSpace.parse({
	        cs: colorSpace,
	        xref,
	        resources: isInline ? res : null,
	        pdfFunctionFactory,
	        localColorSpaceCache
	      });
	      this.numComps = this.colorSpace.numComps;
	    }

	    this.decode = dict.getArray("D", "Decode");
	    this.needsDecode = false;

	    if (this.decode && (this.colorSpace && !this.colorSpace.isDefaultDecode(this.decode, bitsPerComponent) || isMask && !_colorspace.ColorSpace.isDefaultDecode(this.decode, 1))) {
	      this.needsDecode = true;
	      const max = (1 << bitsPerComponent) - 1;
	      this.decodeCoefficients = [];
	      this.decodeAddends = [];
	      const isIndexed = this.colorSpace && this.colorSpace.name === "Indexed";

	      for (let i = 0, j = 0; i < this.decode.length; i += 2, ++j) {
	        const dmin = this.decode[i];
	        const dmax = this.decode[i + 1];
	        this.decodeCoefficients[j] = isIndexed ? (dmax - dmin) / max : dmax - dmin;
	        this.decodeAddends[j] = isIndexed ? dmin : max * dmin;
	      }
	    }

	    if (smask) {
	      this.smask = new PDFImage({
	        xref,
	        res,
	        image: smask,
	        isInline,
	        pdfFunctionFactory,
	        localColorSpaceCache
	      });
	    } else if (mask) {
	      if (mask instanceof _base_stream.BaseStream) {
	        const maskDict = mask.dict,
	              imageMask = maskDict.get("IM", "ImageMask");

	        if (!imageMask) {
	          (0, _util.warn)("Ignoring /Mask in image without /ImageMask.");
	        } else {
	          this.mask = new PDFImage({
	            xref,
	            res,
	            image: mask,
	            isInline,
	            isMask: true,
	            pdfFunctionFactory,
	            localColorSpaceCache
	          });
	        }
	      } else {
	        this.mask = mask;
	      }
	    }
	  }

	  static async buildImage({
	    xref,
	    res,
	    image,
	    isInline = false,
	    pdfFunctionFactory,
	    localColorSpaceCache
	  }) {
	    const imageData = image;
	    let smaskData = null;
	    let maskData = null;
	    const smask = image.dict.get("SMask");
	    const mask = image.dict.get("Mask");

	    if (smask) {
	      if (smask instanceof _base_stream.BaseStream) {
	        smaskData = smask;
	      } else {
	        (0, _util.warn)("Unsupported /SMask format.");
	      }
	    } else if (mask) {
	      if (mask instanceof _base_stream.BaseStream || Array.isArray(mask)) {
	        maskData = mask;
	      } else {
	        (0, _util.warn)("Unsupported /Mask format.");
	      }
	    }

	    return new PDFImage({
	      xref,
	      res,
	      image: imageData,
	      isInline,
	      smask: smaskData,
	      mask: maskData,
	      pdfFunctionFactory,
	      localColorSpaceCache
	    });
	  }

	  static createRawMask({
	    imgArray,
	    width,
	    height,
	    imageIsFromDecodeStream,
	    inverseDecode,
	    interpolate
	  }) {
	    const computedLength = (width + 7 >> 3) * height;
	    const actualLength = imgArray.byteLength;
	    const haveFullData = computedLength === actualLength;
	    let data, i;

	    if (imageIsFromDecodeStream && (!inverseDecode || haveFullData)) {
	      data = imgArray;
	    } else if (!inverseDecode) {
	      data = new Uint8Array(imgArray);
	    } else {
	      data = new Uint8Array(computedLength);
	      data.set(imgArray);
	      data.fill(0xff, actualLength);
	    }

	    if (inverseDecode) {
	      for (i = 0; i < actualLength; i++) {
	        data[i] ^= 0xff;
	      }
	    }

	    return {
	      data,
	      width,
	      height,
	      interpolate
	    };
	  }

	  static createMask({
	    imgArray,
	    width,
	    height,
	    imageIsFromDecodeStream,
	    inverseDecode,
	    interpolate
	  }) {
	    const isSingleOpaquePixel = width === 1 && height === 1 && inverseDecode === (imgArray.length === 0 || !!(imgArray[0] & 128));

	    if (isSingleOpaquePixel) {
	      return {
	        isSingleOpaquePixel
	      };
	    }

	    if (_util.FeatureTest.isOffscreenCanvasSupported) {
	      const canvas = new OffscreenCanvas(width, height);
	      const ctx = canvas.getContext("2d");
	      const imgData = ctx.createImageData(width, height);
	      (0, _image_utils.applyMaskImageData)({
	        src: imgArray,
	        dest: imgData.data,
	        width,
	        height,
	        inverseDecode
	      });
	      ctx.putImageData(imgData, 0, 0);
	      const bitmap = canvas.transferToImageBitmap();
	      return {
	        data: null,
	        width,
	        height,
	        interpolate,
	        bitmap
	      };
	    }

	    return this.createRawMask({
	      imgArray,
	      width,
	      height,
	      inverseDecode,
	      imageIsFromDecodeStream,
	      interpolate
	    });
	  }

	  get drawWidth() {
	    return Math.max(this.width, this.smask && this.smask.width || 0, this.mask && this.mask.width || 0);
	  }

	  get drawHeight() {
	    return Math.max(this.height, this.smask && this.smask.height || 0, this.mask && this.mask.height || 0);
	  }

	  decodeBuffer(buffer) {
	    const bpc = this.bpc;
	    const numComps = this.numComps;
	    const decodeAddends = this.decodeAddends;
	    const decodeCoefficients = this.decodeCoefficients;
	    const max = (1 << bpc) - 1;
	    let i, ii;

	    if (bpc === 1) {
	      for (i = 0, ii = buffer.length; i < ii; i++) {
	        buffer[i] = +!buffer[i];
	      }

	      return;
	    }

	    let index = 0;

	    for (i = 0, ii = this.width * this.height; i < ii; i++) {
	      for (let j = 0; j < numComps; j++) {
	        buffer[index] = decodeAndClamp(buffer[index], decodeAddends[j], decodeCoefficients[j], max);
	        index++;
	      }
	    }
	  }

	  getComponents(buffer) {
	    const bpc = this.bpc;

	    if (bpc === 8) {
	      return buffer;
	    }

	    const width = this.width;
	    const height = this.height;
	    const numComps = this.numComps;
	    const length = width * height * numComps;
	    let bufferPos = 0;
	    let output;

	    if (bpc <= 8) {
	      output = new Uint8Array(length);
	    } else if (bpc <= 16) {
	      output = new Uint16Array(length);
	    } else {
	      output = new Uint32Array(length);
	    }

	    const rowComps = width * numComps;
	    const max = (1 << bpc) - 1;
	    let i = 0,
	        ii,
	        buf;

	    if (bpc === 1) {
	      let mask, loop1End, loop2End;

	      for (let j = 0; j < height; j++) {
	        loop1End = i + (rowComps & ~7);
	        loop2End = i + rowComps;

	        while (i < loop1End) {
	          buf = buffer[bufferPos++];
	          output[i] = buf >> 7 & 1;
	          output[i + 1] = buf >> 6 & 1;
	          output[i + 2] = buf >> 5 & 1;
	          output[i + 3] = buf >> 4 & 1;
	          output[i + 4] = buf >> 3 & 1;
	          output[i + 5] = buf >> 2 & 1;
	          output[i + 6] = buf >> 1 & 1;
	          output[i + 7] = buf & 1;
	          i += 8;
	        }

	        if (i < loop2End) {
	          buf = buffer[bufferPos++];
	          mask = 128;

	          while (i < loop2End) {
	            output[i++] = +!!(buf & mask);
	            mask >>= 1;
	          }
	        }
	      }
	    } else {
	      let bits = 0;
	      buf = 0;

	      for (i = 0, ii = length; i < ii; ++i) {
	        if (i % rowComps === 0) {
	          buf = 0;
	          bits = 0;
	        }

	        while (bits < bpc) {
	          buf = buf << 8 | buffer[bufferPos++];
	          bits += 8;
	        }

	        const remainingBits = bits - bpc;
	        let value = buf >> remainingBits;

	        if (value < 0) {
	          value = 0;
	        } else if (value > max) {
	          value = max;
	        }

	        output[i] = value;
	        buf &= (1 << remainingBits) - 1;
	        bits = remainingBits;
	      }
	    }

	    return output;
	  }

	  fillOpacity(rgbaBuf, width, height, actualHeight, image) {
	    const smask = this.smask;
	    const mask = this.mask;
	    let alphaBuf, sw, sh, i, ii, j;

	    if (smask) {
	      sw = smask.width;
	      sh = smask.height;
	      alphaBuf = new Uint8ClampedArray(sw * sh);
	      smask.fillGrayBuffer(alphaBuf);

	      if (sw !== width || sh !== height) {
	        alphaBuf = resizeImageMask(alphaBuf, smask.bpc, sw, sh, width, height);
	      }
	    } else if (mask) {
	      if (mask instanceof PDFImage) {
	        sw = mask.width;
	        sh = mask.height;
	        alphaBuf = new Uint8ClampedArray(sw * sh);
	        mask.numComps = 1;
	        mask.fillGrayBuffer(alphaBuf);

	        for (i = 0, ii = sw * sh; i < ii; ++i) {
	          alphaBuf[i] = 255 - alphaBuf[i];
	        }

	        if (sw !== width || sh !== height) {
	          alphaBuf = resizeImageMask(alphaBuf, mask.bpc, sw, sh, width, height);
	        }
	      } else if (Array.isArray(mask)) {
	        alphaBuf = new Uint8ClampedArray(width * height);
	        const numComps = this.numComps;

	        for (i = 0, ii = width * height; i < ii; ++i) {
	          let opacity = 0;
	          const imageOffset = i * numComps;

	          for (j = 0; j < numComps; ++j) {
	            const color = image[imageOffset + j];
	            const maskOffset = j * 2;

	            if (color < mask[maskOffset] || color > mask[maskOffset + 1]) {
	              opacity = 255;
	              break;
	            }
	          }

	          alphaBuf[i] = opacity;
	        }
	      } else {
	        throw new _util.FormatError("Unknown mask format.");
	      }
	    }

	    if (alphaBuf) {
	      for (i = 0, j = 3, ii = width * actualHeight; i < ii; ++i, j += 4) {
	        rgbaBuf[j] = alphaBuf[i];
	      }
	    } else {
	      for (i = 0, j = 3, ii = width * actualHeight; i < ii; ++i, j += 4) {
	        rgbaBuf[j] = 255;
	      }
	    }
	  }

	  undoPreblend(buffer, width, height) {
	    const matte = this.smask && this.smask.matte;

	    if (!matte) {
	      return;
	    }

	    const matteRgb = this.colorSpace.getRgb(matte, 0);
	    const matteR = matteRgb[0];
	    const matteG = matteRgb[1];
	    const matteB = matteRgb[2];
	    const length = width * height * 4;

	    for (let i = 0; i < length; i += 4) {
	      const alpha = buffer[i + 3];

	      if (alpha === 0) {
	        buffer[i] = 255;
	        buffer[i + 1] = 255;
	        buffer[i + 2] = 255;
	        continue;
	      }

	      const k = 255 / alpha;
	      buffer[i] = (buffer[i] - matteR) * k + matteR;
	      buffer[i + 1] = (buffer[i + 1] - matteG) * k + matteG;
	      buffer[i + 2] = (buffer[i + 2] - matteB) * k + matteB;
	    }
	  }

	  createImageData(forceRGBA = false) {
	    const drawWidth = this.drawWidth;
	    const drawHeight = this.drawHeight;
	    const imgData = {
	      width: drawWidth,
	      height: drawHeight,
	      interpolate: this.interpolate,
	      kind: 0,
	      data: null
	    };
	    const numComps = this.numComps;
	    const originalWidth = this.width;
	    const originalHeight = this.height;
	    const bpc = this.bpc;
	    const rowBytes = originalWidth * numComps * bpc + 7 >> 3;

	    if (!forceRGBA) {
	      let kind;

	      if (this.colorSpace.name === "DeviceGray" && bpc === 1) {
	        kind = _util.ImageKind.GRAYSCALE_1BPP;
	      } else if (this.colorSpace.name === "DeviceRGB" && bpc === 8 && !this.needsDecode) {
	        kind = _util.ImageKind.RGB_24BPP;
	      }

	      if (kind && !this.smask && !this.mask && drawWidth === originalWidth && drawHeight === originalHeight) {
	        imgData.kind = kind;
	        imgData.data = this.getImageBytes(originalHeight * rowBytes, {});

	        if (this.needsDecode) {
	          (0, _util.assert)(kind === _util.ImageKind.GRAYSCALE_1BPP, "PDFImage.createImageData: The image must be grayscale.");
	          const buffer = imgData.data;

	          for (let i = 0, ii = buffer.length; i < ii; i++) {
	            buffer[i] ^= 0xff;
	          }
	        }

	        return imgData;
	      }

	      if (this.image instanceof _jpeg_stream.JpegStream && !this.smask && !this.mask) {
	        let imageLength = originalHeight * rowBytes;

	        switch (this.colorSpace.name) {
	          case "DeviceGray":
	            imageLength *= 3;

	          case "DeviceRGB":
	          case "DeviceCMYK":
	            imgData.kind = _util.ImageKind.RGB_24BPP;
	            imgData.data = this.getImageBytes(imageLength, {
	              drawWidth,
	              drawHeight,
	              forceRGB: true
	            });
	            return imgData;
	        }
	      }
	    }

	    const imgArray = this.getImageBytes(originalHeight * rowBytes, {
	      internal: true
	    });
	    const actualHeight = 0 | imgArray.length / rowBytes * drawHeight / originalHeight;
	    const comps = this.getComponents(imgArray);
	    let alpha01, maybeUndoPreblend;

	    if (!forceRGBA && !this.smask && !this.mask) {
	      imgData.kind = _util.ImageKind.RGB_24BPP;
	      imgData.data = new Uint8ClampedArray(drawWidth * drawHeight * 3);
	      alpha01 = 0;
	      maybeUndoPreblend = false;
	    } else {
	      imgData.kind = _util.ImageKind.RGBA_32BPP;
	      imgData.data = new Uint8ClampedArray(drawWidth * drawHeight * 4);
	      alpha01 = 1;
	      maybeUndoPreblend = true;
	      this.fillOpacity(imgData.data, drawWidth, drawHeight, actualHeight, comps);
	    }

	    if (this.needsDecode) {
	      this.decodeBuffer(comps);
	    }

	    this.colorSpace.fillRgb(imgData.data, originalWidth, originalHeight, drawWidth, drawHeight, actualHeight, bpc, comps, alpha01);

	    if (maybeUndoPreblend) {
	      this.undoPreblend(imgData.data, drawWidth, actualHeight);
	    }

	    return imgData;
	  }

	  fillGrayBuffer(buffer) {
	    const numComps = this.numComps;

	    if (numComps !== 1) {
	      throw new _util.FormatError(`Reading gray scale from a color image: ${numComps}`);
	    }

	    const width = this.width;
	    const height = this.height;
	    const bpc = this.bpc;
	    const rowBytes = width * numComps * bpc + 7 >> 3;
	    const imgArray = this.getImageBytes(height * rowBytes, {
	      internal: true
	    });
	    const comps = this.getComponents(imgArray);
	    let i, length;

	    if (bpc === 1) {
	      length = width * height;

	      if (this.needsDecode) {
	        for (i = 0; i < length; ++i) {
	          buffer[i] = comps[i] - 1 & 255;
	        }
	      } else {
	        for (i = 0; i < length; ++i) {
	          buffer[i] = -comps[i] & 255;
	        }
	      }

	      return;
	    }

	    if (this.needsDecode) {
	      this.decodeBuffer(comps);
	    }

	    length = width * height;
	    const scale = 255 / ((1 << bpc) - 1);

	    for (i = 0; i < length; ++i) {
	      buffer[i] = scale * comps[i];
	    }
	  }

	  getImageBytes(length, {
	    drawWidth,
	    drawHeight,
	    forceRGB = false,
	    internal = false
	  }) {
	    this.image.reset();
	    this.image.drawWidth = drawWidth || this.width;
	    this.image.drawHeight = drawHeight || this.height;
	    this.image.forceRGB = !!forceRGB;
	    const imageBytes = this.image.getBytes(length);

	    if (internal || this.image instanceof _decode_stream.DecodeStream) {
	      return imageBytes;
	    }

	    (0, _util.assert)(imageBytes instanceof Uint8Array, 'PDFImage.getImageBytes: Unsupported "imageBytes" type.');
	    return new Uint8Array(imageBytes);
	  }

	}

	exports.PDFImage = PDFImage;

	/***/ }),
	/* 64 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.applyMaskImageData = applyMaskImageData;

	var _util = __w_pdfjs_require__(2);

	function applyMaskImageData({
	  src,
	  srcPos = 0,
	  dest,
	  destPos = 0,
	  width,
	  height,
	  inverseDecode = false
	}) {
	  const opaque = _util.FeatureTest.isLittleEndian ? 0xff000000 : 0x000000ff;
	  const [zeroMapping, oneMapping] = !inverseDecode ? [opaque, 0] : [0, opaque];
	  const widthInSource = width >> 3;
	  const widthRemainder = width & 7;
	  const srcLength = src.length;
	  dest = new Uint32Array(dest.buffer);

	  for (let i = 0; i < height; i++) {
	    for (const max = srcPos + widthInSource; srcPos < max; srcPos++) {
	      const elem = srcPos < srcLength ? src[srcPos] : 255;
	      dest[destPos++] = elem & 0b10000000 ? oneMapping : zeroMapping;
	      dest[destPos++] = elem & 0b1000000 ? oneMapping : zeroMapping;
	      dest[destPos++] = elem & 0b100000 ? oneMapping : zeroMapping;
	      dest[destPos++] = elem & 0b10000 ? oneMapping : zeroMapping;
	      dest[destPos++] = elem & 0b1000 ? oneMapping : zeroMapping;
	      dest[destPos++] = elem & 0b100 ? oneMapping : zeroMapping;
	      dest[destPos++] = elem & 0b10 ? oneMapping : zeroMapping;
	      dest[destPos++] = elem & 0b1 ? oneMapping : zeroMapping;
	    }

	    if (widthRemainder === 0) {
	      continue;
	    }

	    const elem = srcPos < srcLength ? src[srcPos++] : 255;

	    for (let j = 0; j < widthRemainder; j++) {
	      dest[destPos++] = elem & 1 << 7 - j ? oneMapping : zeroMapping;
	    }
	  }

	  return {
	    srcPos,
	    destPos
	  };
	}

	/***/ }),
	/* 65 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.incrementalUpdate = incrementalUpdate;
	exports.writeDict = writeDict;
	exports.writeObject = writeObject;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _core_utils = __w_pdfjs_require__(6);

	var _xml_parser = __w_pdfjs_require__(66);

	var _base_stream = __w_pdfjs_require__(7);

	var _crypto = __w_pdfjs_require__(67);

	function writeObject(ref, obj, buffer, transform) {
	  buffer.push(`${ref.num} ${ref.gen} obj\n`);

	  if (obj instanceof _primitives.Dict) {
	    writeDict(obj, buffer, transform);
	  } else if (obj instanceof _base_stream.BaseStream) {
	    writeStream(obj, buffer, transform);
	  }

	  buffer.push("\nendobj\n");
	}

	function writeDict(dict, buffer, transform) {
	  buffer.push("<<");

	  for (const key of dict.getKeys()) {
	    buffer.push(` /${(0, _core_utils.escapePDFName)(key)} `);
	    writeValue(dict.getRaw(key), buffer, transform);
	  }

	  buffer.push(">>");
	}

	function writeStream(stream, buffer, transform) {
	  writeDict(stream.dict, buffer, transform);
	  buffer.push(" stream\n");
	  let string = stream.getString();

	  if (transform !== null) {
	    string = transform.encryptString(string);
	  }

	  buffer.push(string, "\nendstream\n");
	}

	function writeArray(array, buffer, transform) {
	  buffer.push("[");
	  let first = true;

	  for (const val of array) {
	    if (!first) {
	      buffer.push(" ");
	    } else {
	      first = false;
	    }

	    writeValue(val, buffer, transform);
	  }

	  buffer.push("]");
	}

	function writeValue(value, buffer, transform) {
	  if (value instanceof _primitives.Name) {
	    buffer.push(`/${(0, _core_utils.escapePDFName)(value.name)}`);
	  } else if (value instanceof _primitives.Ref) {
	    buffer.push(`${value.num} ${value.gen} R`);
	  } else if (Array.isArray(value)) {
	    writeArray(value, buffer, transform);
	  } else if (typeof value === "string") {
	    if (transform !== null) {
	      value = transform.encryptString(value);
	    }

	    buffer.push(`(${(0, _util.escapeString)(value)})`);
	  } else if (typeof value === "number") {
	    buffer.push((0, _core_utils.numberToString)(value));
	  } else if (typeof value === "boolean") {
	    buffer.push(value.toString());
	  } else if (value instanceof _primitives.Dict) {
	    writeDict(value, buffer, transform);
	  } else if (value instanceof _base_stream.BaseStream) {
	    writeStream(value, buffer, transform);
	  } else if (value === null) {
	    buffer.push("null");
	  } else {
	    (0, _util.warn)(`Unhandled value in writer: ${typeof value}, please file a bug.`);
	  }
	}

	function writeInt(number, size, offset, buffer) {
	  for (let i = size + offset - 1; i > offset - 1; i--) {
	    buffer[i] = number & 0xff;
	    number >>= 8;
	  }

	  return offset + size;
	}

	function writeString(string, offset, buffer) {
	  for (let i = 0, len = string.length; i < len; i++) {
	    buffer[offset + i] = string.charCodeAt(i) & 0xff;
	  }
	}

	function computeMD5(filesize, xrefInfo) {
	  const time = Math.floor(Date.now() / 1000);
	  const filename = xrefInfo.filename || "";
	  const md5Buffer = [time.toString(), filename, filesize.toString()];
	  let md5BufferLen = md5Buffer.reduce((a, str) => a + str.length, 0);

	  for (const value of Object.values(xrefInfo.info)) {
	    md5Buffer.push(value);
	    md5BufferLen += value.length;
	  }

	  const array = new Uint8Array(md5BufferLen);
	  let offset = 0;

	  for (const str of md5Buffer) {
	    writeString(str, offset, array);
	    offset += str.length;
	  }

	  return (0, _util.bytesToString)((0, _crypto.calculateMD5)(array));
	}

	function writeXFADataForAcroform(str, newRefs) {
	  const xml = new _xml_parser.SimpleXMLParser({
	    hasAttributes: true
	  }).parseFromString(str);

	  for (const {
	    xfa
	  } of newRefs) {
	    if (!xfa) {
	      continue;
	    }

	    const {
	      path,
	      value
	    } = xfa;

	    if (!path) {
	      continue;
	    }

	    const node = xml.documentElement.searchNode((0, _core_utils.parseXFAPath)(path), 0);

	    if (node) {
	      if (Array.isArray(value)) {
	        node.childNodes = value.map(val => new _xml_parser.SimpleDOMNode("value", val));
	      } else {
	        node.childNodes = [new _xml_parser.SimpleDOMNode("#text", value)];
	      }
	    } else {
	      (0, _util.warn)(`Node not found for path: ${path}`);
	    }
	  }

	  const buffer = [];
	  xml.documentElement.dump(buffer);
	  return buffer.join("");
	}

	function updateXFA({
	  xfaData,
	  xfaDatasetsRef,
	  hasXfaDatasetsEntry,
	  acroFormRef,
	  acroForm,
	  newRefs,
	  xref,
	  xrefInfo
	}) {
	  if (xref === null) {
	    return;
	  }

	  if (!hasXfaDatasetsEntry) {
	    if (!acroFormRef) {
	      (0, _util.warn)("XFA - Cannot save it");
	      return;
	    }

	    const oldXfa = acroForm.get("XFA");
	    const newXfa = oldXfa.slice();
	    newXfa.splice(2, 0, "datasets");
	    newXfa.splice(3, 0, xfaDatasetsRef);
	    acroForm.set("XFA", newXfa);
	    const encrypt = xref.encrypt;
	    let transform = null;

	    if (encrypt) {
	      transform = encrypt.createCipherTransform(acroFormRef.num, acroFormRef.gen);
	    }

	    const buffer = [`${acroFormRef.num} ${acroFormRef.gen} obj\n`];
	    writeDict(acroForm, buffer, transform);
	    buffer.push("\n");
	    acroForm.set("XFA", oldXfa);
	    newRefs.push({
	      ref: acroFormRef,
	      data: buffer.join("")
	    });
	  }

	  if (xfaData === null) {
	    const datasets = xref.fetchIfRef(xfaDatasetsRef);
	    xfaData = writeXFADataForAcroform(datasets.getString(), newRefs);
	  }

	  const encrypt = xref.encrypt;

	  if (encrypt) {
	    const transform = encrypt.createCipherTransform(xfaDatasetsRef.num, xfaDatasetsRef.gen);
	    xfaData = transform.encryptString(xfaData);
	  }

	  const data = `${xfaDatasetsRef.num} ${xfaDatasetsRef.gen} obj\n` + `<< /Type /EmbeddedFile /Length ${xfaData.length}>>\nstream\n` + xfaData + "\nendstream\nendobj\n";
	  newRefs.push({
	    ref: xfaDatasetsRef,
	    data
	  });
	}

	function incrementalUpdate({
	  originalData,
	  xrefInfo,
	  newRefs,
	  xref = null,
	  hasXfa = false,
	  xfaDatasetsRef = null,
	  hasXfaDatasetsEntry = false,
	  acroFormRef = null,
	  acroForm = null,
	  xfaData = null
	}) {
	  if (hasXfa) {
	    updateXFA({
	      xfaData,
	      xfaDatasetsRef,
	      hasXfaDatasetsEntry,
	      acroFormRef,
	      acroForm,
	      newRefs,
	      xref,
	      xrefInfo
	    });
	  }

	  const newXref = new _primitives.Dict(null);
	  const refForXrefTable = xrefInfo.newRef;
	  let buffer, baseOffset;
	  const lastByte = originalData.at(-1);

	  if (lastByte === 0x0a || lastByte === 0x0d) {
	    buffer = [];
	    baseOffset = originalData.length;
	  } else {
	    buffer = ["\n"];
	    baseOffset = originalData.length + 1;
	  }

	  newXref.set("Size", refForXrefTable.num + 1);
	  newXref.set("Prev", xrefInfo.startXRef);
	  newXref.set("Type", _primitives.Name.get("XRef"));

	  if (xrefInfo.rootRef !== null) {
	    newXref.set("Root", xrefInfo.rootRef);
	  }

	  if (xrefInfo.infoRef !== null) {
	    newXref.set("Info", xrefInfo.infoRef);
	  }

	  if (xrefInfo.encryptRef !== null) {
	    newXref.set("Encrypt", xrefInfo.encryptRef);
	  }

	  newRefs.push({
	    ref: refForXrefTable,
	    data: ""
	  });
	  newRefs = newRefs.sort((a, b) => {
	    return a.ref.num - b.ref.num;
	  });
	  const xrefTableData = [[0, 1, 0xffff]];
	  const indexes = [0, 1];
	  let maxOffset = 0;

	  for (const {
	    ref,
	    data
	  } of newRefs) {
	    maxOffset = Math.max(maxOffset, baseOffset);
	    xrefTableData.push([1, baseOffset, Math.min(ref.gen, 0xffff)]);
	    baseOffset += data.length;
	    indexes.push(ref.num, 1);
	    buffer.push(data);
	  }

	  newXref.set("Index", indexes);

	  if (Array.isArray(xrefInfo.fileIds) && xrefInfo.fileIds.length > 0) {
	    const md5 = computeMD5(baseOffset, xrefInfo);
	    newXref.set("ID", [xrefInfo.fileIds[0], md5]);
	  }

	  const offsetSize = Math.ceil(Math.log2(maxOffset) / 8);
	  const sizes = [1, offsetSize, 2];
	  const structSize = sizes[0] + sizes[1] + sizes[2];
	  const tableLength = structSize * xrefTableData.length;
	  newXref.set("W", sizes);
	  newXref.set("Length", tableLength);
	  buffer.push(`${refForXrefTable.num} ${refForXrefTable.gen} obj\n`);
	  writeDict(newXref, buffer, null);
	  buffer.push(" stream\n");
	  const bufferLen = buffer.reduce((a, str) => a + str.length, 0);
	  const footer = `\nendstream\nendobj\nstartxref\n${baseOffset}\n%%EOF\n`;
	  const array = new Uint8Array(originalData.length + bufferLen + tableLength + footer.length);
	  array.set(originalData);
	  let offset = originalData.length;

	  for (const str of buffer) {
	    writeString(str, offset, array);
	    offset += str.length;
	  }

	  for (const [type, objOffset, gen] of xrefTableData) {
	    offset = writeInt(type, sizes[0], offset, array);
	    offset = writeInt(objOffset, sizes[1], offset, array);
	    offset = writeInt(gen, sizes[2], offset, array);
	  }

	  writeString(footer, offset, array);
	  return array;
	}

	/***/ }),
	/* 66 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XMLParserErrorCode = exports.XMLParserBase = exports.SimpleXMLParser = exports.SimpleDOMNode = void 0;

	var _core_utils = __w_pdfjs_require__(6);

	const XMLParserErrorCode = {
	  NoError: 0,
	  EndOfDocument: -1,
	  UnterminatedCdat: -2,
	  UnterminatedXmlDeclaration: -3,
	  UnterminatedDoctypeDeclaration: -4,
	  UnterminatedComment: -5,
	  MalformedElement: -6,
	  OutOfMemory: -7,
	  UnterminatedAttributeValue: -8,
	  UnterminatedElement: -9,
	  ElementNeverBegun: -10
	};
	exports.XMLParserErrorCode = XMLParserErrorCode;

	function isWhitespace(s, index) {
	  const ch = s[index];
	  return ch === " " || ch === "\n" || ch === "\r" || ch === "\t";
	}

	function isWhitespaceString(s) {
	  for (let i = 0, ii = s.length; i < ii; i++) {
	    if (!isWhitespace(s, i)) {
	      return false;
	    }
	  }

	  return true;
	}

	class XMLParserBase {
	  _resolveEntities(s) {
	    return s.replace(/&([^;]+);/g, (all, entity) => {
	      if (entity.substring(0, 2) === "#x") {
	        return String.fromCodePoint(parseInt(entity.substring(2), 16));
	      } else if (entity.substring(0, 1) === "#") {
	        return String.fromCodePoint(parseInt(entity.substring(1), 10));
	      }

	      switch (entity) {
	        case "lt":
	          return "<";

	        case "gt":
	          return ">";

	        case "amp":
	          return "&";

	        case "quot":
	          return '"';

	        case "apos":
	          return "'";
	      }

	      return this.onResolveEntity(entity);
	    });
	  }

	  _parseContent(s, start) {
	    const attributes = [];
	    let pos = start;

	    function skipWs() {
	      while (pos < s.length && isWhitespace(s, pos)) {
	        ++pos;
	      }
	    }

	    while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "/") {
	      ++pos;
	    }

	    const name = s.substring(start, pos);
	    skipWs();

	    while (pos < s.length && s[pos] !== ">" && s[pos] !== "/" && s[pos] !== "?") {
	      skipWs();
	      let attrName = "",
	          attrValue = "";

	      while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== "=") {
	        attrName += s[pos];
	        ++pos;
	      }

	      skipWs();

	      if (s[pos] !== "=") {
	        return null;
	      }

	      ++pos;
	      skipWs();
	      const attrEndChar = s[pos];

	      if (attrEndChar !== '"' && attrEndChar !== "'") {
	        return null;
	      }

	      const attrEndIndex = s.indexOf(attrEndChar, ++pos);

	      if (attrEndIndex < 0) {
	        return null;
	      }

	      attrValue = s.substring(pos, attrEndIndex);
	      attributes.push({
	        name: attrName,
	        value: this._resolveEntities(attrValue)
	      });
	      pos = attrEndIndex + 1;
	      skipWs();
	    }

	    return {
	      name,
	      attributes,
	      parsed: pos - start
	    };
	  }

	  _parseProcessingInstruction(s, start) {
	    let pos = start;

	    function skipWs() {
	      while (pos < s.length && isWhitespace(s, pos)) {
	        ++pos;
	      }
	    }

	    while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "?" && s[pos] !== "/") {
	      ++pos;
	    }

	    const name = s.substring(start, pos);
	    skipWs();
	    const attrStart = pos;

	    while (pos < s.length && (s[pos] !== "?" || s[pos + 1] !== ">")) {
	      ++pos;
	    }

	    const value = s.substring(attrStart, pos);
	    return {
	      name,
	      value,
	      parsed: pos - start
	    };
	  }

	  parseXml(s) {
	    let i = 0;

	    while (i < s.length) {
	      const ch = s[i];
	      let j = i;

	      if (ch === "<") {
	        ++j;
	        const ch2 = s[j];
	        let q;

	        switch (ch2) {
	          case "/":
	            ++j;
	            q = s.indexOf(">", j);

	            if (q < 0) {
	              this.onError(XMLParserErrorCode.UnterminatedElement);
	              return;
	            }

	            this.onEndElement(s.substring(j, q));
	            j = q + 1;
	            break;

	          case "?":
	            ++j;

	            const pi = this._parseProcessingInstruction(s, j);

	            if (s.substring(j + pi.parsed, j + pi.parsed + 2) !== "?>") {
	              this.onError(XMLParserErrorCode.UnterminatedXmlDeclaration);
	              return;
	            }

	            this.onPi(pi.name, pi.value);
	            j += pi.parsed + 2;
	            break;

	          case "!":
	            if (s.substring(j + 1, j + 3) === "--") {
	              q = s.indexOf("-->", j + 3);

	              if (q < 0) {
	                this.onError(XMLParserErrorCode.UnterminatedComment);
	                return;
	              }

	              this.onComment(s.substring(j + 3, q));
	              j = q + 3;
	            } else if (s.substring(j + 1, j + 8) === "[CDATA[") {
	              q = s.indexOf("]]>", j + 8);

	              if (q < 0) {
	                this.onError(XMLParserErrorCode.UnterminatedCdat);
	                return;
	              }

	              this.onCdata(s.substring(j + 8, q));
	              j = q + 3;
	            } else if (s.substring(j + 1, j + 8) === "DOCTYPE") {
	              const q2 = s.indexOf("[", j + 8);
	              let complexDoctype = false;
	              q = s.indexOf(">", j + 8);

	              if (q < 0) {
	                this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
	                return;
	              }

	              if (q2 > 0 && q > q2) {
	                q = s.indexOf("]>", j + 8);

	                if (q < 0) {
	                  this.onError(XMLParserErrorCode.UnterminatedDoctypeDeclaration);
	                  return;
	                }

	                complexDoctype = true;
	              }

	              const doctypeContent = s.substring(j + 8, q + (complexDoctype ? 1 : 0));
	              this.onDoctype(doctypeContent);
	              j = q + (complexDoctype ? 2 : 1);
	            } else {
	              this.onError(XMLParserErrorCode.MalformedElement);
	              return;
	            }

	            break;

	          default:
	            const content = this._parseContent(s, j);

	            if (content === null) {
	              this.onError(XMLParserErrorCode.MalformedElement);
	              return;
	            }

	            let isClosed = false;

	            if (s.substring(j + content.parsed, j + content.parsed + 2) === "/>") {
	              isClosed = true;
	            } else if (s.substring(j + content.parsed, j + content.parsed + 1) !== ">") {
	              this.onError(XMLParserErrorCode.UnterminatedElement);
	              return;
	            }

	            this.onBeginElement(content.name, content.attributes, isClosed);
	            j += content.parsed + (isClosed ? 2 : 1);
	            break;
	        }
	      } else {
	        while (j < s.length && s[j] !== "<") {
	          j++;
	        }

	        const text = s.substring(i, j);
	        this.onText(this._resolveEntities(text));
	      }

	      i = j;
	    }
	  }

	  onResolveEntity(name) {
	    return `&${name};`;
	  }

	  onPi(name, value) {}

	  onComment(text) {}

	  onCdata(text) {}

	  onDoctype(doctypeContent) {}

	  onText(text) {}

	  onBeginElement(name, attributes, isEmpty) {}

	  onEndElement(name) {}

	  onError(code) {}

	}

	exports.XMLParserBase = XMLParserBase;

	class SimpleDOMNode {
	  constructor(nodeName, nodeValue) {
	    this.nodeName = nodeName;
	    this.nodeValue = nodeValue;
	    Object.defineProperty(this, "parentNode", {
	      value: null,
	      writable: true
	    });
	  }

	  get firstChild() {
	    return this.childNodes && this.childNodes[0];
	  }

	  get nextSibling() {
	    const childNodes = this.parentNode.childNodes;

	    if (!childNodes) {
	      return undefined;
	    }

	    const index = childNodes.indexOf(this);

	    if (index === -1) {
	      return undefined;
	    }

	    return childNodes[index + 1];
	  }

	  get textContent() {
	    if (!this.childNodes) {
	      return this.nodeValue || "";
	    }

	    return this.childNodes.map(function (child) {
	      return child.textContent;
	    }).join("");
	  }

	  get children() {
	    return this.childNodes || [];
	  }

	  hasChildNodes() {
	    return this.childNodes && this.childNodes.length > 0;
	  }

	  searchNode(paths, pos) {
	    if (pos >= paths.length) {
	      return this;
	    }

	    const component = paths[pos];
	    const stack = [];
	    let node = this;

	    while (true) {
	      if (component.name === node.nodeName) {
	        if (component.pos === 0) {
	          const res = node.searchNode(paths, pos + 1);

	          if (res !== null) {
	            return res;
	          }
	        } else if (stack.length === 0) {
	          return null;
	        } else {
	          const [parent] = stack.pop();
	          let siblingPos = 0;

	          for (const child of parent.childNodes) {
	            if (component.name === child.nodeName) {
	              if (siblingPos === component.pos) {
	                return child.searchNode(paths, pos + 1);
	              }

	              siblingPos++;
	            }
	          }

	          return node.searchNode(paths, pos + 1);
	        }
	      }

	      if (node.childNodes && node.childNodes.length !== 0) {
	        stack.push([node, 0]);
	        node = node.childNodes[0];
	      } else if (stack.length === 0) {
	        return null;
	      } else {
	        while (stack.length !== 0) {
	          const [parent, currentPos] = stack.pop();
	          const newPos = currentPos + 1;

	          if (newPos < parent.childNodes.length) {
	            stack.push([parent, newPos]);
	            node = parent.childNodes[newPos];
	            break;
	          }
	        }

	        if (stack.length === 0) {
	          return null;
	        }
	      }
	    }
	  }

	  dump(buffer) {
	    if (this.nodeName === "#text") {
	      buffer.push((0, _core_utils.encodeToXmlString)(this.nodeValue));
	      return;
	    }

	    buffer.push(`<${this.nodeName}`);

	    if (this.attributes) {
	      for (const attribute of this.attributes) {
	        buffer.push(` ${attribute.name}="${(0, _core_utils.encodeToXmlString)(attribute.value)}"`);
	      }
	    }

	    if (this.hasChildNodes()) {
	      buffer.push(">");

	      for (const child of this.childNodes) {
	        child.dump(buffer);
	      }

	      buffer.push(`</${this.nodeName}>`);
	    } else if (this.nodeValue) {
	      buffer.push(`>${(0, _core_utils.encodeToXmlString)(this.nodeValue)}</${this.nodeName}>`);
	    } else {
	      buffer.push("/>");
	    }
	  }

	}

	exports.SimpleDOMNode = SimpleDOMNode;

	class SimpleXMLParser extends XMLParserBase {
	  constructor({
	    hasAttributes = false,
	    lowerCaseName = false
	  }) {
	    super();
	    this._currentFragment = null;
	    this._stack = null;
	    this._errorCode = XMLParserErrorCode.NoError;
	    this._hasAttributes = hasAttributes;
	    this._lowerCaseName = lowerCaseName;
	  }

	  parseFromString(data) {
	    this._currentFragment = [];
	    this._stack = [];
	    this._errorCode = XMLParserErrorCode.NoError;
	    this.parseXml(data);

	    if (this._errorCode !== XMLParserErrorCode.NoError) {
	      return undefined;
	    }

	    const [documentElement] = this._currentFragment;

	    if (!documentElement) {
	      return undefined;
	    }

	    return {
	      documentElement
	    };
	  }

	  onText(text) {
	    if (isWhitespaceString(text)) {
	      return;
	    }

	    const node = new SimpleDOMNode("#text", text);

	    this._currentFragment.push(node);
	  }

	  onCdata(text) {
	    const node = new SimpleDOMNode("#text", text);

	    this._currentFragment.push(node);
	  }

	  onBeginElement(name, attributes, isEmpty) {
	    if (this._lowerCaseName) {
	      name = name.toLowerCase();
	    }

	    const node = new SimpleDOMNode(name);
	    node.childNodes = [];

	    if (this._hasAttributes) {
	      node.attributes = attributes;
	    }

	    this._currentFragment.push(node);

	    if (isEmpty) {
	      return;
	    }

	    this._stack.push(this._currentFragment);

	    this._currentFragment = node.childNodes;
	  }

	  onEndElement(name) {
	    this._currentFragment = this._stack.pop() || [];

	    const lastElement = this._currentFragment.at(-1);

	    if (!lastElement) {
	      return null;
	    }

	    for (let i = 0, ii = lastElement.childNodes.length; i < ii; i++) {
	      lastElement.childNodes[i].parentNode = lastElement;
	    }

	    return lastElement;
	  }

	  onError(code) {
	    this._errorCode = code;
	  }

	}

	exports.SimpleXMLParser = SimpleXMLParser;

	/***/ }),
	/* 67 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.calculateSHA256 = exports.calculateMD5 = exports.PDF20 = exports.PDF17 = exports.CipherTransformFactory = exports.ARCFourCipher = exports.AES256Cipher = exports.AES128Cipher = void 0;
	exports.calculateSHA384 = calculateSHA384;
	exports.calculateSHA512 = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _decrypt_stream = __w_pdfjs_require__(68);

	class ARCFourCipher {
	  constructor(key) {
	    this.a = 0;
	    this.b = 0;
	    const s = new Uint8Array(256);
	    const keyLength = key.length;

	    for (let i = 0; i < 256; ++i) {
	      s[i] = i;
	    }

	    for (let i = 0, j = 0; i < 256; ++i) {
	      const tmp = s[i];
	      j = j + tmp + key[i % keyLength] & 0xff;
	      s[i] = s[j];
	      s[j] = tmp;
	    }

	    this.s = s;
	  }

	  encryptBlock(data) {
	    let a = this.a,
	        b = this.b;
	    const s = this.s;
	    const n = data.length;
	    const output = new Uint8Array(n);

	    for (let i = 0; i < n; ++i) {
	      a = a + 1 & 0xff;
	      const tmp = s[a];
	      b = b + tmp & 0xff;
	      const tmp2 = s[b];
	      s[a] = tmp2;
	      s[b] = tmp;
	      output[i] = data[i] ^ s[tmp + tmp2 & 0xff];
	    }

	    this.a = a;
	    this.b = b;
	    return output;
	  }

	  decryptBlock(data) {
	    return this.encryptBlock(data);
	  }

	  encrypt(data) {
	    return this.encryptBlock(data);
	  }

	}

	exports.ARCFourCipher = ARCFourCipher;

	const calculateMD5 = function calculateMD5Closure() {
	  const r = new Uint8Array([7, 12, 17, 22, 7, 12, 17, 22, 7, 12, 17, 22, 7, 12, 17, 22, 5, 9, 14, 20, 5, 9, 14, 20, 5, 9, 14, 20, 5, 9, 14, 20, 4, 11, 16, 23, 4, 11, 16, 23, 4, 11, 16, 23, 4, 11, 16, 23, 6, 10, 15, 21, 6, 10, 15, 21, 6, 10, 15, 21, 6, 10, 15, 21]);
	  const k = new Int32Array([-680876936, -389564586, 606105819, -1044525330, -176418897, 1200080426, -1473231341, -45705983, 1770035416, -1958414417, -42063, -1990404162, 1804603682, -40341101, -1502002290, 1236535329, -165796510, -1069501632, 643717713, -373897302, -701558691, 38016083, -660478335, -405537848, 568446438, -1019803690, -187363961, 1163531501, -1444681467, -51403784, 1735328473, -1926607734, -378558, -2022574463, 1839030562, -35309556, -1530992060, 1272893353, -155497632, -1094730640, 681279174, -358537222, -722521979, 76029189, -640364487, -421815835, 530742520, -995338651, -198630844, 1126891415, -1416354905, -57434055, 1700485571, -1894986606, -1051523, -2054922799, 1873313359, -30611744, -1560198380, 1309151649, -145523070, -1120210379, 718787259, -343485551]);

	  function hash(data, offset, length) {
	    let h0 = 1732584193,
	        h1 = -271733879,
	        h2 = -1732584194,
	        h3 = 271733878;
	    const paddedLength = length + 72 & ~63;
	    const padded = new Uint8Array(paddedLength);
	    let i, j;

	    for (i = 0; i < length; ++i) {
	      padded[i] = data[offset++];
	    }

	    padded[i++] = 0x80;
	    const n = paddedLength - 8;

	    while (i < n) {
	      padded[i++] = 0;
	    }

	    padded[i++] = length << 3 & 0xff;
	    padded[i++] = length >> 5 & 0xff;
	    padded[i++] = length >> 13 & 0xff;
	    padded[i++] = length >> 21 & 0xff;
	    padded[i++] = length >>> 29 & 0xff;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    const w = new Int32Array(16);

	    for (i = 0; i < paddedLength;) {
	      for (j = 0; j < 16; ++j, i += 4) {
	        w[j] = padded[i] | padded[i + 1] << 8 | padded[i + 2] << 16 | padded[i + 3] << 24;
	      }

	      let a = h0,
	          b = h1,
	          c = h2,
	          d = h3,
	          f,
	          g;

	      for (j = 0; j < 64; ++j) {
	        if (j < 16) {
	          f = b & c | ~b & d;
	          g = j;
	        } else if (j < 32) {
	          f = d & b | ~d & c;
	          g = 5 * j + 1 & 15;
	        } else if (j < 48) {
	          f = b ^ c ^ d;
	          g = 3 * j + 5 & 15;
	        } else {
	          f = c ^ (b | ~d);
	          g = 7 * j & 15;
	        }

	        const tmp = d,
	              rotateArg = a + f + k[j] + w[g] | 0,
	              rotate = r[j];
	        d = c;
	        c = b;
	        b = b + (rotateArg << rotate | rotateArg >>> 32 - rotate) | 0;
	        a = tmp;
	      }

	      h0 = h0 + a | 0;
	      h1 = h1 + b | 0;
	      h2 = h2 + c | 0;
	      h3 = h3 + d | 0;
	    }

	    return new Uint8Array([h0 & 0xFF, h0 >> 8 & 0xFF, h0 >> 16 & 0xFF, h0 >>> 24 & 0xFF, h1 & 0xFF, h1 >> 8 & 0xFF, h1 >> 16 & 0xFF, h1 >>> 24 & 0xFF, h2 & 0xFF, h2 >> 8 & 0xFF, h2 >> 16 & 0xFF, h2 >>> 24 & 0xFF, h3 & 0xFF, h3 >> 8 & 0xFF, h3 >> 16 & 0xFF, h3 >>> 24 & 0xFF]);
	  }

	  return hash;
	}();

	exports.calculateMD5 = calculateMD5;

	class Word64 {
	  constructor(highInteger, lowInteger) {
	    this.high = highInteger | 0;
	    this.low = lowInteger | 0;
	  }

	  and(word) {
	    this.high &= word.high;
	    this.low &= word.low;
	  }

	  xor(word) {
	    this.high ^= word.high;
	    this.low ^= word.low;
	  }

	  or(word) {
	    this.high |= word.high;
	    this.low |= word.low;
	  }

	  shiftRight(places) {
	    if (places >= 32) {
	      this.low = this.high >>> places - 32 | 0;
	      this.high = 0;
	    } else {
	      this.low = this.low >>> places | this.high << 32 - places;
	      this.high = this.high >>> places | 0;
	    }
	  }

	  shiftLeft(places) {
	    if (places >= 32) {
	      this.high = this.low << places - 32;
	      this.low = 0;
	    } else {
	      this.high = this.high << places | this.low >>> 32 - places;
	      this.low <<= places;
	    }
	  }

	  rotateRight(places) {
	    let low, high;

	    if (places & 32) {
	      high = this.low;
	      low = this.high;
	    } else {
	      low = this.low;
	      high = this.high;
	    }

	    places &= 31;
	    this.low = low >>> places | high << 32 - places;
	    this.high = high >>> places | low << 32 - places;
	  }

	  not() {
	    this.high = ~this.high;
	    this.low = ~this.low;
	  }

	  add(word) {
	    const lowAdd = (this.low >>> 0) + (word.low >>> 0);
	    let highAdd = (this.high >>> 0) + (word.high >>> 0);

	    if (lowAdd > 0xffffffff) {
	      highAdd += 1;
	    }

	    this.low = lowAdd | 0;
	    this.high = highAdd | 0;
	  }

	  copyTo(bytes, offset) {
	    bytes[offset] = this.high >>> 24 & 0xff;
	    bytes[offset + 1] = this.high >> 16 & 0xff;
	    bytes[offset + 2] = this.high >> 8 & 0xff;
	    bytes[offset + 3] = this.high & 0xff;
	    bytes[offset + 4] = this.low >>> 24 & 0xff;
	    bytes[offset + 5] = this.low >> 16 & 0xff;
	    bytes[offset + 6] = this.low >> 8 & 0xff;
	    bytes[offset + 7] = this.low & 0xff;
	  }

	  assign(word) {
	    this.high = word.high;
	    this.low = word.low;
	  }

	}

	const calculateSHA256 = function calculateSHA256Closure() {
	  function rotr(x, n) {
	    return x >>> n | x << 32 - n;
	  }

	  function ch(x, y, z) {
	    return x & y ^ ~x & z;
	  }

	  function maj(x, y, z) {
	    return x & y ^ x & z ^ y & z;
	  }

	  function sigma(x) {
	    return rotr(x, 2) ^ rotr(x, 13) ^ rotr(x, 22);
	  }

	  function sigmaPrime(x) {
	    return rotr(x, 6) ^ rotr(x, 11) ^ rotr(x, 25);
	  }

	  function littleSigma(x) {
	    return rotr(x, 7) ^ rotr(x, 18) ^ x >>> 3;
	  }

	  function littleSigmaPrime(x) {
	    return rotr(x, 17) ^ rotr(x, 19) ^ x >>> 10;
	  }

	  const k = [0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5, 0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174, 0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da, 0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967, 0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85, 0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070, 0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3, 0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2];

	  function hash(data, offset, length) {
	    let h0 = 0x6a09e667,
	        h1 = 0xbb67ae85,
	        h2 = 0x3c6ef372,
	        h3 = 0xa54ff53a,
	        h4 = 0x510e527f,
	        h5 = 0x9b05688c,
	        h6 = 0x1f83d9ab,
	        h7 = 0x5be0cd19;
	    const paddedLength = Math.ceil((length + 9) / 64) * 64;
	    const padded = new Uint8Array(paddedLength);
	    let i, j;

	    for (i = 0; i < length; ++i) {
	      padded[i] = data[offset++];
	    }

	    padded[i++] = 0x80;
	    const n = paddedLength - 8;

	    while (i < n) {
	      padded[i++] = 0;
	    }

	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = length >>> 29 & 0xff;
	    padded[i++] = length >> 21 & 0xff;
	    padded[i++] = length >> 13 & 0xff;
	    padded[i++] = length >> 5 & 0xff;
	    padded[i++] = length << 3 & 0xff;
	    const w = new Uint32Array(64);

	    for (i = 0; i < paddedLength;) {
	      for (j = 0; j < 16; ++j) {
	        w[j] = padded[i] << 24 | padded[i + 1] << 16 | padded[i + 2] << 8 | padded[i + 3];
	        i += 4;
	      }

	      for (j = 16; j < 64; ++j) {
	        w[j] = littleSigmaPrime(w[j - 2]) + w[j - 7] + littleSigma(w[j - 15]) + w[j - 16] | 0;
	      }

	      let a = h0,
	          b = h1,
	          c = h2,
	          d = h3,
	          e = h4,
	          f = h5,
	          g = h6,
	          h = h7,
	          t1,
	          t2;

	      for (j = 0; j < 64; ++j) {
	        t1 = h + sigmaPrime(e) + ch(e, f, g) + k[j] + w[j];
	        t2 = sigma(a) + maj(a, b, c);
	        h = g;
	        g = f;
	        f = e;
	        e = d + t1 | 0;
	        d = c;
	        c = b;
	        b = a;
	        a = t1 + t2 | 0;
	      }

	      h0 = h0 + a | 0;
	      h1 = h1 + b | 0;
	      h2 = h2 + c | 0;
	      h3 = h3 + d | 0;
	      h4 = h4 + e | 0;
	      h5 = h5 + f | 0;
	      h6 = h6 + g | 0;
	      h7 = h7 + h | 0;
	    }

	    return new Uint8Array([h0 >> 24 & 0xFF, h0 >> 16 & 0xFF, h0 >> 8 & 0xFF, h0 & 0xFF, h1 >> 24 & 0xFF, h1 >> 16 & 0xFF, h1 >> 8 & 0xFF, h1 & 0xFF, h2 >> 24 & 0xFF, h2 >> 16 & 0xFF, h2 >> 8 & 0xFF, h2 & 0xFF, h3 >> 24 & 0xFF, h3 >> 16 & 0xFF, h3 >> 8 & 0xFF, h3 & 0xFF, h4 >> 24 & 0xFF, h4 >> 16 & 0xFF, h4 >> 8 & 0xFF, h4 & 0xFF, h5 >> 24 & 0xFF, h5 >> 16 & 0xFF, h5 >> 8 & 0xFF, h5 & 0xFF, h6 >> 24 & 0xFF, h6 >> 16 & 0xFF, h6 >> 8 & 0xFF, h6 & 0xFF, h7 >> 24 & 0xFF, h7 >> 16 & 0xFF, h7 >> 8 & 0xFF, h7 & 0xFF]);
	  }

	  return hash;
	}();

	exports.calculateSHA256 = calculateSHA256;

	const calculateSHA512 = function calculateSHA512Closure() {
	  function ch(result, x, y, z, tmp) {
	    result.assign(x);
	    result.and(y);
	    tmp.assign(x);
	    tmp.not();
	    tmp.and(z);
	    result.xor(tmp);
	  }

	  function maj(result, x, y, z, tmp) {
	    result.assign(x);
	    result.and(y);
	    tmp.assign(x);
	    tmp.and(z);
	    result.xor(tmp);
	    tmp.assign(y);
	    tmp.and(z);
	    result.xor(tmp);
	  }

	  function sigma(result, x, tmp) {
	    result.assign(x);
	    result.rotateRight(28);
	    tmp.assign(x);
	    tmp.rotateRight(34);
	    result.xor(tmp);
	    tmp.assign(x);
	    tmp.rotateRight(39);
	    result.xor(tmp);
	  }

	  function sigmaPrime(result, x, tmp) {
	    result.assign(x);
	    result.rotateRight(14);
	    tmp.assign(x);
	    tmp.rotateRight(18);
	    result.xor(tmp);
	    tmp.assign(x);
	    tmp.rotateRight(41);
	    result.xor(tmp);
	  }

	  function littleSigma(result, x, tmp) {
	    result.assign(x);
	    result.rotateRight(1);
	    tmp.assign(x);
	    tmp.rotateRight(8);
	    result.xor(tmp);
	    tmp.assign(x);
	    tmp.shiftRight(7);
	    result.xor(tmp);
	  }

	  function littleSigmaPrime(result, x, tmp) {
	    result.assign(x);
	    result.rotateRight(19);
	    tmp.assign(x);
	    tmp.rotateRight(61);
	    result.xor(tmp);
	    tmp.assign(x);
	    tmp.shiftRight(6);
	    result.xor(tmp);
	  }

	  const k = [new Word64(0x428a2f98, 0xd728ae22), new Word64(0x71374491, 0x23ef65cd), new Word64(0xb5c0fbcf, 0xec4d3b2f), new Word64(0xe9b5dba5, 0x8189dbbc), new Word64(0x3956c25b, 0xf348b538), new Word64(0x59f111f1, 0xb605d019), new Word64(0x923f82a4, 0xaf194f9b), new Word64(0xab1c5ed5, 0xda6d8118), new Word64(0xd807aa98, 0xa3030242), new Word64(0x12835b01, 0x45706fbe), new Word64(0x243185be, 0x4ee4b28c), new Word64(0x550c7dc3, 0xd5ffb4e2), new Word64(0x72be5d74, 0xf27b896f), new Word64(0x80deb1fe, 0x3b1696b1), new Word64(0x9bdc06a7, 0x25c71235), new Word64(0xc19bf174, 0xcf692694), new Word64(0xe49b69c1, 0x9ef14ad2), new Word64(0xefbe4786, 0x384f25e3), new Word64(0x0fc19dc6, 0x8b8cd5b5), new Word64(0x240ca1cc, 0x77ac9c65), new Word64(0x2de92c6f, 0x592b0275), new Word64(0x4a7484aa, 0x6ea6e483), new Word64(0x5cb0a9dc, 0xbd41fbd4), new Word64(0x76f988da, 0x831153b5), new Word64(0x983e5152, 0xee66dfab), new Word64(0xa831c66d, 0x2db43210), new Word64(0xb00327c8, 0x98fb213f), new Word64(0xbf597fc7, 0xbeef0ee4), new Word64(0xc6e00bf3, 0x3da88fc2), new Word64(0xd5a79147, 0x930aa725), new Word64(0x06ca6351, 0xe003826f), new Word64(0x14292967, 0x0a0e6e70), new Word64(0x27b70a85, 0x46d22ffc), new Word64(0x2e1b2138, 0x5c26c926), new Word64(0x4d2c6dfc, 0x5ac42aed), new Word64(0x53380d13, 0x9d95b3df), new Word64(0x650a7354, 0x8baf63de), new Word64(0x766a0abb, 0x3c77b2a8), new Word64(0x81c2c92e, 0x47edaee6), new Word64(0x92722c85, 0x1482353b), new Word64(0xa2bfe8a1, 0x4cf10364), new Word64(0xa81a664b, 0xbc423001), new Word64(0xc24b8b70, 0xd0f89791), new Word64(0xc76c51a3, 0x0654be30), new Word64(0xd192e819, 0xd6ef5218), new Word64(0xd6990624, 0x5565a910), new Word64(0xf40e3585, 0x5771202a), new Word64(0x106aa070, 0x32bbd1b8), new Word64(0x19a4c116, 0xb8d2d0c8), new Word64(0x1e376c08, 0x5141ab53), new Word64(0x2748774c, 0xdf8eeb99), new Word64(0x34b0bcb5, 0xe19b48a8), new Word64(0x391c0cb3, 0xc5c95a63), new Word64(0x4ed8aa4a, 0xe3418acb), new Word64(0x5b9cca4f, 0x7763e373), new Word64(0x682e6ff3, 0xd6b2b8a3), new Word64(0x748f82ee, 0x5defb2fc), new Word64(0x78a5636f, 0x43172f60), new Word64(0x84c87814, 0xa1f0ab72), new Word64(0x8cc70208, 0x1a6439ec), new Word64(0x90befffa, 0x23631e28), new Word64(0xa4506ceb, 0xde82bde9), new Word64(0xbef9a3f7, 0xb2c67915), new Word64(0xc67178f2, 0xe372532b), new Word64(0xca273ece, 0xea26619c), new Word64(0xd186b8c7, 0x21c0c207), new Word64(0xeada7dd6, 0xcde0eb1e), new Word64(0xf57d4f7f, 0xee6ed178), new Word64(0x06f067aa, 0x72176fba), new Word64(0x0a637dc5, 0xa2c898a6), new Word64(0x113f9804, 0xbef90dae), new Word64(0x1b710b35, 0x131c471b), new Word64(0x28db77f5, 0x23047d84), new Word64(0x32caab7b, 0x40c72493), new Word64(0x3c9ebe0a, 0x15c9bebc), new Word64(0x431d67c4, 0x9c100d4c), new Word64(0x4cc5d4be, 0xcb3e42b6), new Word64(0x597f299c, 0xfc657e2a), new Word64(0x5fcb6fab, 0x3ad6faec), new Word64(0x6c44198c, 0x4a475817)];

	  function hash(data, offset, length, mode384 = false) {
	    let h0, h1, h2, h3, h4, h5, h6, h7;

	    if (!mode384) {
	      h0 = new Word64(0x6a09e667, 0xf3bcc908);
	      h1 = new Word64(0xbb67ae85, 0x84caa73b);
	      h2 = new Word64(0x3c6ef372, 0xfe94f82b);
	      h3 = new Word64(0xa54ff53a, 0x5f1d36f1);
	      h4 = new Word64(0x510e527f, 0xade682d1);
	      h5 = new Word64(0x9b05688c, 0x2b3e6c1f);
	      h6 = new Word64(0x1f83d9ab, 0xfb41bd6b);
	      h7 = new Word64(0x5be0cd19, 0x137e2179);
	    } else {
	      h0 = new Word64(0xcbbb9d5d, 0xc1059ed8);
	      h1 = new Word64(0x629a292a, 0x367cd507);
	      h2 = new Word64(0x9159015a, 0x3070dd17);
	      h3 = new Word64(0x152fecd8, 0xf70e5939);
	      h4 = new Word64(0x67332667, 0xffc00b31);
	      h5 = new Word64(0x8eb44a87, 0x68581511);
	      h6 = new Word64(0xdb0c2e0d, 0x64f98fa7);
	      h7 = new Word64(0x47b5481d, 0xbefa4fa4);
	    }

	    const paddedLength = Math.ceil((length + 17) / 128) * 128;
	    const padded = new Uint8Array(paddedLength);
	    let i, j;

	    for (i = 0; i < length; ++i) {
	      padded[i] = data[offset++];
	    }

	    padded[i++] = 0x80;
	    const n = paddedLength - 16;

	    while (i < n) {
	      padded[i++] = 0;
	    }

	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = 0;
	    padded[i++] = length >>> 29 & 0xff;
	    padded[i++] = length >> 21 & 0xff;
	    padded[i++] = length >> 13 & 0xff;
	    padded[i++] = length >> 5 & 0xff;
	    padded[i++] = length << 3 & 0xff;
	    const w = new Array(80);

	    for (i = 0; i < 80; i++) {
	      w[i] = new Word64(0, 0);
	    }

	    let a = new Word64(0, 0),
	        b = new Word64(0, 0),
	        c = new Word64(0, 0);
	    let d = new Word64(0, 0),
	        e = new Word64(0, 0),
	        f = new Word64(0, 0);
	    let g = new Word64(0, 0),
	        h = new Word64(0, 0);
	    const t1 = new Word64(0, 0),
	          t2 = new Word64(0, 0);
	    const tmp1 = new Word64(0, 0),
	          tmp2 = new Word64(0, 0);
	    let tmp3;

	    for (i = 0; i < paddedLength;) {
	      for (j = 0; j < 16; ++j) {
	        w[j].high = padded[i] << 24 | padded[i + 1] << 16 | padded[i + 2] << 8 | padded[i + 3];
	        w[j].low = padded[i + 4] << 24 | padded[i + 5] << 16 | padded[i + 6] << 8 | padded[i + 7];
	        i += 8;
	      }

	      for (j = 16; j < 80; ++j) {
	        tmp3 = w[j];
	        littleSigmaPrime(tmp3, w[j - 2], tmp2);
	        tmp3.add(w[j - 7]);
	        littleSigma(tmp1, w[j - 15], tmp2);
	        tmp3.add(tmp1);
	        tmp3.add(w[j - 16]);
	      }

	      a.assign(h0);
	      b.assign(h1);
	      c.assign(h2);
	      d.assign(h3);
	      e.assign(h4);
	      f.assign(h5);
	      g.assign(h6);
	      h.assign(h7);

	      for (j = 0; j < 80; ++j) {
	        t1.assign(h);
	        sigmaPrime(tmp1, e, tmp2);
	        t1.add(tmp1);
	        ch(tmp1, e, f, g, tmp2);
	        t1.add(tmp1);
	        t1.add(k[j]);
	        t1.add(w[j]);
	        sigma(t2, a, tmp2);
	        maj(tmp1, a, b, c, tmp2);
	        t2.add(tmp1);
	        tmp3 = h;
	        h = g;
	        g = f;
	        f = e;
	        d.add(t1);
	        e = d;
	        d = c;
	        c = b;
	        b = a;
	        tmp3.assign(t1);
	        tmp3.add(t2);
	        a = tmp3;
	      }

	      h0.add(a);
	      h1.add(b);
	      h2.add(c);
	      h3.add(d);
	      h4.add(e);
	      h5.add(f);
	      h6.add(g);
	      h7.add(h);
	    }

	    let result;

	    if (!mode384) {
	      result = new Uint8Array(64);
	      h0.copyTo(result, 0);
	      h1.copyTo(result, 8);
	      h2.copyTo(result, 16);
	      h3.copyTo(result, 24);
	      h4.copyTo(result, 32);
	      h5.copyTo(result, 40);
	      h6.copyTo(result, 48);
	      h7.copyTo(result, 56);
	    } else {
	      result = new Uint8Array(48);
	      h0.copyTo(result, 0);
	      h1.copyTo(result, 8);
	      h2.copyTo(result, 16);
	      h3.copyTo(result, 24);
	      h4.copyTo(result, 32);
	      h5.copyTo(result, 40);
	    }

	    return result;
	  }

	  return hash;
	}();

	exports.calculateSHA512 = calculateSHA512;

	function calculateSHA384(data, offset, length) {
	  return calculateSHA512(data, offset, length, true);
	}

	class NullCipher {
	  decryptBlock(data) {
	    return data;
	  }

	  encrypt(data) {
	    return data;
	  }

	}

	class AESBaseCipher {
	  constructor() {
	    if (this.constructor === AESBaseCipher) {
	      (0, _util.unreachable)("Cannot initialize AESBaseCipher.");
	    }

	    this._s = new Uint8Array([0x63, 0x7c, 0x77, 0x7b, 0xf2, 0x6b, 0x6f, 0xc5, 0x30, 0x01, 0x67, 0x2b, 0xfe, 0xd7, 0xab, 0x76, 0xca, 0x82, 0xc9, 0x7d, 0xfa, 0x59, 0x47, 0xf0, 0xad, 0xd4, 0xa2, 0xaf, 0x9c, 0xa4, 0x72, 0xc0, 0xb7, 0xfd, 0x93, 0x26, 0x36, 0x3f, 0xf7, 0xcc, 0x34, 0xa5, 0xe5, 0xf1, 0x71, 0xd8, 0x31, 0x15, 0x04, 0xc7, 0x23, 0xc3, 0x18, 0x96, 0x05, 0x9a, 0x07, 0x12, 0x80, 0xe2, 0xeb, 0x27, 0xb2, 0x75, 0x09, 0x83, 0x2c, 0x1a, 0x1b, 0x6e, 0x5a, 0xa0, 0x52, 0x3b, 0xd6, 0xb3, 0x29, 0xe3, 0x2f, 0x84, 0x53, 0xd1, 0x00, 0xed, 0x20, 0xfc, 0xb1, 0x5b, 0x6a, 0xcb, 0xbe, 0x39, 0x4a, 0x4c, 0x58, 0xcf, 0xd0, 0xef, 0xaa, 0xfb, 0x43, 0x4d, 0x33, 0x85, 0x45, 0xf9, 0x02, 0x7f, 0x50, 0x3c, 0x9f, 0xa8, 0x51, 0xa3, 0x40, 0x8f, 0x92, 0x9d, 0x38, 0xf5, 0xbc, 0xb6, 0xda, 0x21, 0x10, 0xff, 0xf3, 0xd2, 0xcd, 0x0c, 0x13, 0xec, 0x5f, 0x97, 0x44, 0x17, 0xc4, 0xa7, 0x7e, 0x3d, 0x64, 0x5d, 0x19, 0x73, 0x60, 0x81, 0x4f, 0xdc, 0x22, 0x2a, 0x90, 0x88, 0x46, 0xee, 0xb8, 0x14, 0xde, 0x5e, 0x0b, 0xdb, 0xe0, 0x32, 0x3a, 0x0a, 0x49, 0x06, 0x24, 0x5c, 0xc2, 0xd3, 0xac, 0x62, 0x91, 0x95, 0xe4, 0x79, 0xe7, 0xc8, 0x37, 0x6d, 0x8d, 0xd5, 0x4e, 0xa9, 0x6c, 0x56, 0xf4, 0xea, 0x65, 0x7a, 0xae, 0x08, 0xba, 0x78, 0x25, 0x2e, 0x1c, 0xa6, 0xb4, 0xc6, 0xe8, 0xdd, 0x74, 0x1f, 0x4b, 0xbd, 0x8b, 0x8a, 0x70, 0x3e, 0xb5, 0x66, 0x48, 0x03, 0xf6, 0x0e, 0x61, 0x35, 0x57, 0xb9, 0x86, 0xc1, 0x1d, 0x9e, 0xe1, 0xf8, 0x98, 0x11, 0x69, 0xd9, 0x8e, 0x94, 0x9b, 0x1e, 0x87, 0xe9, 0xce, 0x55, 0x28, 0xdf, 0x8c, 0xa1, 0x89, 0x0d, 0xbf, 0xe6, 0x42, 0x68, 0x41, 0x99, 0x2d, 0x0f, 0xb0, 0x54, 0xbb, 0x16]);
	    this._inv_s = new Uint8Array([0x52, 0x09, 0x6a, 0xd5, 0x30, 0x36, 0xa5, 0x38, 0xbf, 0x40, 0xa3, 0x9e, 0x81, 0xf3, 0xd7, 0xfb, 0x7c, 0xe3, 0x39, 0x82, 0x9b, 0x2f, 0xff, 0x87, 0x34, 0x8e, 0x43, 0x44, 0xc4, 0xde, 0xe9, 0xcb, 0x54, 0x7b, 0x94, 0x32, 0xa6, 0xc2, 0x23, 0x3d, 0xee, 0x4c, 0x95, 0x0b, 0x42, 0xfa, 0xc3, 0x4e, 0x08, 0x2e, 0xa1, 0x66, 0x28, 0xd9, 0x24, 0xb2, 0x76, 0x5b, 0xa2, 0x49, 0x6d, 0x8b, 0xd1, 0x25, 0x72, 0xf8, 0xf6, 0x64, 0x86, 0x68, 0x98, 0x16, 0xd4, 0xa4, 0x5c, 0xcc, 0x5d, 0x65, 0xb6, 0x92, 0x6c, 0x70, 0x48, 0x50, 0xfd, 0xed, 0xb9, 0xda, 0x5e, 0x15, 0x46, 0x57, 0xa7, 0x8d, 0x9d, 0x84, 0x90, 0xd8, 0xab, 0x00, 0x8c, 0xbc, 0xd3, 0x0a, 0xf7, 0xe4, 0x58, 0x05, 0xb8, 0xb3, 0x45, 0x06, 0xd0, 0x2c, 0x1e, 0x8f, 0xca, 0x3f, 0x0f, 0x02, 0xc1, 0xaf, 0xbd, 0x03, 0x01, 0x13, 0x8a, 0x6b, 0x3a, 0x91, 0x11, 0x41, 0x4f, 0x67, 0xdc, 0xea, 0x97, 0xf2, 0xcf, 0xce, 0xf0, 0xb4, 0xe6, 0x73, 0x96, 0xac, 0x74, 0x22, 0xe7, 0xad, 0x35, 0x85, 0xe2, 0xf9, 0x37, 0xe8, 0x1c, 0x75, 0xdf, 0x6e, 0x47, 0xf1, 0x1a, 0x71, 0x1d, 0x29, 0xc5, 0x89, 0x6f, 0xb7, 0x62, 0x0e, 0xaa, 0x18, 0xbe, 0x1b, 0xfc, 0x56, 0x3e, 0x4b, 0xc6, 0xd2, 0x79, 0x20, 0x9a, 0xdb, 0xc0, 0xfe, 0x78, 0xcd, 0x5a, 0xf4, 0x1f, 0xdd, 0xa8, 0x33, 0x88, 0x07, 0xc7, 0x31, 0xb1, 0x12, 0x10, 0x59, 0x27, 0x80, 0xec, 0x5f, 0x60, 0x51, 0x7f, 0xa9, 0x19, 0xb5, 0x4a, 0x0d, 0x2d, 0xe5, 0x7a, 0x9f, 0x93, 0xc9, 0x9c, 0xef, 0xa0, 0xe0, 0x3b, 0x4d, 0xae, 0x2a, 0xf5, 0xb0, 0xc8, 0xeb, 0xbb, 0x3c, 0x83, 0x53, 0x99, 0x61, 0x17, 0x2b, 0x04, 0x7e, 0xba, 0x77, 0xd6, 0x26, 0xe1, 0x69, 0x14, 0x63, 0x55, 0x21, 0x0c, 0x7d]);
	    this._mix = new Uint32Array([0x00000000, 0x0e090d0b, 0x1c121a16, 0x121b171d, 0x3824342c, 0x362d3927, 0x24362e3a, 0x2a3f2331, 0x70486858, 0x7e416553, 0x6c5a724e, 0x62537f45, 0x486c5c74, 0x4665517f, 0x547e4662, 0x5a774b69, 0xe090d0b0, 0xee99ddbb, 0xfc82caa6, 0xf28bc7ad, 0xd8b4e49c, 0xd6bde997, 0xc4a6fe8a, 0xcaaff381, 0x90d8b8e8, 0x9ed1b5e3, 0x8ccaa2fe, 0x82c3aff5, 0xa8fc8cc4, 0xa6f581cf, 0xb4ee96d2, 0xbae79bd9, 0xdb3bbb7b, 0xd532b670, 0xc729a16d, 0xc920ac66, 0xe31f8f57, 0xed16825c, 0xff0d9541, 0xf104984a, 0xab73d323, 0xa57ade28, 0xb761c935, 0xb968c43e, 0x9357e70f, 0x9d5eea04, 0x8f45fd19, 0x814cf012, 0x3bab6bcb, 0x35a266c0, 0x27b971dd, 0x29b07cd6, 0x038f5fe7, 0x0d8652ec, 0x1f9d45f1, 0x119448fa, 0x4be30393, 0x45ea0e98, 0x57f11985, 0x59f8148e, 0x73c737bf, 0x7dce3ab4, 0x6fd52da9, 0x61dc20a2, 0xad766df6, 0xa37f60fd, 0xb16477e0, 0xbf6d7aeb, 0x955259da, 0x9b5b54d1, 0x894043cc, 0x87494ec7, 0xdd3e05ae, 0xd33708a5, 0xc12c1fb8, 0xcf2512b3, 0xe51a3182, 0xeb133c89, 0xf9082b94, 0xf701269f, 0x4de6bd46, 0x43efb04d, 0x51f4a750, 0x5ffdaa5b, 0x75c2896a, 0x7bcb8461, 0x69d0937c, 0x67d99e77, 0x3daed51e, 0x33a7d815, 0x21bccf08, 0x2fb5c203, 0x058ae132, 0x0b83ec39, 0x1998fb24, 0x1791f62f, 0x764dd68d, 0x7844db86, 0x6a5fcc9b, 0x6456c190, 0x4e69e2a1, 0x4060efaa, 0x527bf8b7, 0x5c72f5bc, 0x0605bed5, 0x080cb3de, 0x1a17a4c3, 0x141ea9c8, 0x3e218af9, 0x302887f2, 0x223390ef, 0x2c3a9de4, 0x96dd063d, 0x98d40b36, 0x8acf1c2b, 0x84c61120, 0xaef93211, 0xa0f03f1a, 0xb2eb2807, 0xbce2250c, 0xe6956e65, 0xe89c636e, 0xfa877473, 0xf48e7978, 0xdeb15a49, 0xd0b85742, 0xc2a3405f, 0xccaa4d54, 0x41ecdaf7, 0x4fe5d7fc, 0x5dfec0e1, 0x53f7cdea, 0x79c8eedb, 0x77c1e3d0, 0x65daf4cd, 0x6bd3f9c6, 0x31a4b2af, 0x3fadbfa4, 0x2db6a8b9, 0x23bfa5b2, 0x09808683, 0x07898b88, 0x15929c95, 0x1b9b919e, 0xa17c0a47, 0xaf75074c, 0xbd6e1051, 0xb3671d5a, 0x99583e6b, 0x97513360, 0x854a247d, 0x8b432976, 0xd134621f, 0xdf3d6f14, 0xcd267809, 0xc32f7502, 0xe9105633, 0xe7195b38, 0xf5024c25, 0xfb0b412e, 0x9ad7618c, 0x94de6c87, 0x86c57b9a, 0x88cc7691, 0xa2f355a0, 0xacfa58ab, 0xbee14fb6, 0xb0e842bd, 0xea9f09d4, 0xe49604df, 0xf68d13c2, 0xf8841ec9, 0xd2bb3df8, 0xdcb230f3, 0xcea927ee, 0xc0a02ae5, 0x7a47b13c, 0x744ebc37, 0x6655ab2a, 0x685ca621, 0x42638510, 0x4c6a881b, 0x5e719f06, 0x5078920d, 0x0a0fd964, 0x0406d46f, 0x161dc372, 0x1814ce79, 0x322bed48, 0x3c22e043, 0x2e39f75e, 0x2030fa55, 0xec9ab701, 0xe293ba0a, 0xf088ad17, 0xfe81a01c, 0xd4be832d, 0xdab78e26, 0xc8ac993b, 0xc6a59430, 0x9cd2df59, 0x92dbd252, 0x80c0c54f, 0x8ec9c844, 0xa4f6eb75, 0xaaffe67e, 0xb8e4f163, 0xb6edfc68, 0x0c0a67b1, 0x02036aba, 0x10187da7, 0x1e1170ac, 0x342e539d, 0x3a275e96, 0x283c498b, 0x26354480, 0x7c420fe9, 0x724b02e2, 0x605015ff, 0x6e5918f4, 0x44663bc5, 0x4a6f36ce, 0x587421d3, 0x567d2cd8, 0x37a10c7a, 0x39a80171, 0x2bb3166c, 0x25ba1b67, 0x0f853856, 0x018c355d, 0x13972240, 0x1d9e2f4b, 0x47e96422, 0x49e06929, 0x5bfb7e34, 0x55f2733f, 0x7fcd500e, 0x71c45d05, 0x63df4a18, 0x6dd64713, 0xd731dcca, 0xd938d1c1, 0xcb23c6dc, 0xc52acbd7, 0xef15e8e6, 0xe11ce5ed, 0xf307f2f0, 0xfd0efffb, 0xa779b492, 0xa970b999, 0xbb6bae84, 0xb562a38f, 0x9f5d80be, 0x91548db5, 0x834f9aa8, 0x8d4697a3]);
	    this._mixCol = new Uint8Array(256);

	    for (let i = 0; i < 256; i++) {
	      if (i < 128) {
	        this._mixCol[i] = i << 1;
	      } else {
	        this._mixCol[i] = i << 1 ^ 0x1b;
	      }
	    }

	    this.buffer = new Uint8Array(16);
	    this.bufferPosition = 0;
	  }

	  _expandKey(cipherKey) {
	    (0, _util.unreachable)("Cannot call `_expandKey` on the base class");
	  }

	  _decrypt(input, key) {
	    let t, u, v;
	    const state = new Uint8Array(16);
	    state.set(input);

	    for (let j = 0, k = this._keySize; j < 16; ++j, ++k) {
	      state[j] ^= key[k];
	    }

	    for (let i = this._cyclesOfRepetition - 1; i >= 1; --i) {
	      t = state[13];
	      state[13] = state[9];
	      state[9] = state[5];
	      state[5] = state[1];
	      state[1] = t;
	      t = state[14];
	      u = state[10];
	      state[14] = state[6];
	      state[10] = state[2];
	      state[6] = t;
	      state[2] = u;
	      t = state[15];
	      u = state[11];
	      v = state[7];
	      state[15] = state[3];
	      state[11] = t;
	      state[7] = u;
	      state[3] = v;

	      for (let j = 0; j < 16; ++j) {
	        state[j] = this._inv_s[state[j]];
	      }

	      for (let j = 0, k = i * 16; j < 16; ++j, ++k) {
	        state[j] ^= key[k];
	      }

	      for (let j = 0; j < 16; j += 4) {
	        const s0 = this._mix[state[j]];
	        const s1 = this._mix[state[j + 1]];
	        const s2 = this._mix[state[j + 2]];
	        const s3 = this._mix[state[j + 3]];
	        t = s0 ^ s1 >>> 8 ^ s1 << 24 ^ s2 >>> 16 ^ s2 << 16 ^ s3 >>> 24 ^ s3 << 8;
	        state[j] = t >>> 24 & 0xff;
	        state[j + 1] = t >> 16 & 0xff;
	        state[j + 2] = t >> 8 & 0xff;
	        state[j + 3] = t & 0xff;
	      }
	    }

	    t = state[13];
	    state[13] = state[9];
	    state[9] = state[5];
	    state[5] = state[1];
	    state[1] = t;
	    t = state[14];
	    u = state[10];
	    state[14] = state[6];
	    state[10] = state[2];
	    state[6] = t;
	    state[2] = u;
	    t = state[15];
	    u = state[11];
	    v = state[7];
	    state[15] = state[3];
	    state[11] = t;
	    state[7] = u;
	    state[3] = v;

	    for (let j = 0; j < 16; ++j) {
	      state[j] = this._inv_s[state[j]];
	      state[j] ^= key[j];
	    }

	    return state;
	  }

	  _encrypt(input, key) {
	    const s = this._s;
	    let t, u, v;
	    const state = new Uint8Array(16);
	    state.set(input);

	    for (let j = 0; j < 16; ++j) {
	      state[j] ^= key[j];
	    }

	    for (let i = 1; i < this._cyclesOfRepetition; i++) {
	      for (let j = 0; j < 16; ++j) {
	        state[j] = s[state[j]];
	      }

	      v = state[1];
	      state[1] = state[5];
	      state[5] = state[9];
	      state[9] = state[13];
	      state[13] = v;
	      v = state[2];
	      u = state[6];
	      state[2] = state[10];
	      state[6] = state[14];
	      state[10] = v;
	      state[14] = u;
	      v = state[3];
	      u = state[7];
	      t = state[11];
	      state[3] = state[15];
	      state[7] = v;
	      state[11] = u;
	      state[15] = t;

	      for (let j = 0; j < 16; j += 4) {
	        const s0 = state[j + 0];
	        const s1 = state[j + 1];
	        const s2 = state[j + 2];
	        const s3 = state[j + 3];
	        t = s0 ^ s1 ^ s2 ^ s3;
	        state[j + 0] ^= t ^ this._mixCol[s0 ^ s1];
	        state[j + 1] ^= t ^ this._mixCol[s1 ^ s2];
	        state[j + 2] ^= t ^ this._mixCol[s2 ^ s3];
	        state[j + 3] ^= t ^ this._mixCol[s3 ^ s0];
	      }

	      for (let j = 0, k = i * 16; j < 16; ++j, ++k) {
	        state[j] ^= key[k];
	      }
	    }

	    for (let j = 0; j < 16; ++j) {
	      state[j] = s[state[j]];
	    }

	    v = state[1];
	    state[1] = state[5];
	    state[5] = state[9];
	    state[9] = state[13];
	    state[13] = v;
	    v = state[2];
	    u = state[6];
	    state[2] = state[10];
	    state[6] = state[14];
	    state[10] = v;
	    state[14] = u;
	    v = state[3];
	    u = state[7];
	    t = state[11];
	    state[3] = state[15];
	    state[7] = v;
	    state[11] = u;
	    state[15] = t;

	    for (let j = 0, k = this._keySize; j < 16; ++j, ++k) {
	      state[j] ^= key[k];
	    }

	    return state;
	  }

	  _decryptBlock2(data, finalize) {
	    const sourceLength = data.length;
	    let buffer = this.buffer,
	        bufferLength = this.bufferPosition;
	    const result = [];
	    let iv = this.iv;

	    for (let i = 0; i < sourceLength; ++i) {
	      buffer[bufferLength] = data[i];
	      ++bufferLength;

	      if (bufferLength < 16) {
	        continue;
	      }

	      const plain = this._decrypt(buffer, this._key);

	      for (let j = 0; j < 16; ++j) {
	        plain[j] ^= iv[j];
	      }

	      iv = buffer;
	      result.push(plain);
	      buffer = new Uint8Array(16);
	      bufferLength = 0;
	    }

	    this.buffer = buffer;
	    this.bufferLength = bufferLength;
	    this.iv = iv;

	    if (result.length === 0) {
	      return new Uint8Array(0);
	    }

	    let outputLength = 16 * result.length;

	    if (finalize) {
	      const lastBlock = result.at(-1);
	      let psLen = lastBlock[15];

	      if (psLen <= 16) {
	        for (let i = 15, ii = 16 - psLen; i >= ii; --i) {
	          if (lastBlock[i] !== psLen) {
	            psLen = 0;
	            break;
	          }
	        }

	        outputLength -= psLen;
	        result[result.length - 1] = lastBlock.subarray(0, 16 - psLen);
	      }
	    }

	    const output = new Uint8Array(outputLength);

	    for (let i = 0, j = 0, ii = result.length; i < ii; ++i, j += 16) {
	      output.set(result[i], j);
	    }

	    return output;
	  }

	  decryptBlock(data, finalize, iv = null) {
	    const sourceLength = data.length;
	    const buffer = this.buffer;
	    let bufferLength = this.bufferPosition;

	    if (iv) {
	      this.iv = iv;
	    } else {
	      for (let i = 0; bufferLength < 16 && i < sourceLength; ++i, ++bufferLength) {
	        buffer[bufferLength] = data[i];
	      }

	      if (bufferLength < 16) {
	        this.bufferLength = bufferLength;
	        return new Uint8Array(0);
	      }

	      this.iv = buffer;
	      data = data.subarray(16);
	    }

	    this.buffer = new Uint8Array(16);
	    this.bufferLength = 0;
	    this.decryptBlock = this._decryptBlock2;
	    return this.decryptBlock(data, finalize);
	  }

	  encrypt(data, iv) {
	    const sourceLength = data.length;
	    let buffer = this.buffer,
	        bufferLength = this.bufferPosition;
	    const result = [];

	    if (!iv) {
	      iv = new Uint8Array(16);
	    }

	    for (let i = 0; i < sourceLength; ++i) {
	      buffer[bufferLength] = data[i];
	      ++bufferLength;

	      if (bufferLength < 16) {
	        continue;
	      }

	      for (let j = 0; j < 16; ++j) {
	        buffer[j] ^= iv[j];
	      }

	      const cipher = this._encrypt(buffer, this._key);

	      iv = cipher;
	      result.push(cipher);
	      buffer = new Uint8Array(16);
	      bufferLength = 0;
	    }

	    this.buffer = buffer;
	    this.bufferLength = bufferLength;
	    this.iv = iv;

	    if (result.length === 0) {
	      return new Uint8Array(0);
	    }

	    const outputLength = 16 * result.length;
	    const output = new Uint8Array(outputLength);

	    for (let i = 0, j = 0, ii = result.length; i < ii; ++i, j += 16) {
	      output.set(result[i], j);
	    }

	    return output;
	  }

	}

	class AES128Cipher extends AESBaseCipher {
	  constructor(key) {
	    super();
	    this._cyclesOfRepetition = 10;
	    this._keySize = 160;
	    this._rcon = new Uint8Array([0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab, 0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d, 0xfa, 0xef, 0xc5, 0x91, 0x39, 0x72, 0xe4, 0xd3, 0xbd, 0x61, 0xc2, 0x9f, 0x25, 0x4a, 0x94, 0x33, 0x66, 0xcc, 0x83, 0x1d, 0x3a, 0x74, 0xe8, 0xcb, 0x8d]);
	    this._key = this._expandKey(key);
	  }

	  _expandKey(cipherKey) {
	    const b = 176;
	    const s = this._s;
	    const rcon = this._rcon;
	    const result = new Uint8Array(b);
	    result.set(cipherKey);

	    for (let j = 16, i = 1; j < b; ++i) {
	      let t1 = result[j - 3];
	      let t2 = result[j - 2];
	      let t3 = result[j - 1];
	      let t4 = result[j - 4];
	      t1 = s[t1];
	      t2 = s[t2];
	      t3 = s[t3];
	      t4 = s[t4];
	      t1 ^= rcon[i];

	      for (let n = 0; n < 4; ++n) {
	        result[j] = t1 ^= result[j - 16];
	        j++;
	        result[j] = t2 ^= result[j - 16];
	        j++;
	        result[j] = t3 ^= result[j - 16];
	        j++;
	        result[j] = t4 ^= result[j - 16];
	        j++;
	      }
	    }

	    return result;
	  }

	}

	exports.AES128Cipher = AES128Cipher;

	class AES256Cipher extends AESBaseCipher {
	  constructor(key) {
	    super();
	    this._cyclesOfRepetition = 14;
	    this._keySize = 224;
	    this._key = this._expandKey(key);
	  }

	  _expandKey(cipherKey) {
	    const b = 240;
	    const s = this._s;
	    const result = new Uint8Array(b);
	    result.set(cipherKey);
	    let r = 1;
	    let t1, t2, t3, t4;

	    for (let j = 32, i = 1; j < b; ++i) {
	      if (j % 32 === 16) {
	        t1 = s[t1];
	        t2 = s[t2];
	        t3 = s[t3];
	        t4 = s[t4];
	      } else if (j % 32 === 0) {
	        t1 = result[j - 3];
	        t2 = result[j - 2];
	        t3 = result[j - 1];
	        t4 = result[j - 4];
	        t1 = s[t1];
	        t2 = s[t2];
	        t3 = s[t3];
	        t4 = s[t4];
	        t1 ^= r;

	        if ((r <<= 1) >= 256) {
	          r = (r ^ 0x1b) & 0xff;
	        }
	      }

	      for (let n = 0; n < 4; ++n) {
	        result[j] = t1 ^= result[j - 32];
	        j++;
	        result[j] = t2 ^= result[j - 32];
	        j++;
	        result[j] = t3 ^= result[j - 32];
	        j++;
	        result[j] = t4 ^= result[j - 32];
	        j++;
	      }
	    }

	    return result;
	  }

	}

	exports.AES256Cipher = AES256Cipher;

	class PDF17 {
	  checkOwnerPassword(password, ownerValidationSalt, userBytes, ownerPassword) {
	    const hashData = new Uint8Array(password.length + 56);
	    hashData.set(password, 0);
	    hashData.set(ownerValidationSalt, password.length);
	    hashData.set(userBytes, password.length + ownerValidationSalt.length);
	    const result = calculateSHA256(hashData, 0, hashData.length);
	    return (0, _util.isArrayEqual)(result, ownerPassword);
	  }

	  checkUserPassword(password, userValidationSalt, userPassword) {
	    const hashData = new Uint8Array(password.length + 8);
	    hashData.set(password, 0);
	    hashData.set(userValidationSalt, password.length);
	    const result = calculateSHA256(hashData, 0, hashData.length);
	    return (0, _util.isArrayEqual)(result, userPassword);
	  }

	  getOwnerKey(password, ownerKeySalt, userBytes, ownerEncryption) {
	    const hashData = new Uint8Array(password.length + 56);
	    hashData.set(password, 0);
	    hashData.set(ownerKeySalt, password.length);
	    hashData.set(userBytes, password.length + ownerKeySalt.length);
	    const key = calculateSHA256(hashData, 0, hashData.length);
	    const cipher = new AES256Cipher(key);
	    return cipher.decryptBlock(ownerEncryption, false, new Uint8Array(16));
	  }

	  getUserKey(password, userKeySalt, userEncryption) {
	    const hashData = new Uint8Array(password.length + 8);
	    hashData.set(password, 0);
	    hashData.set(userKeySalt, password.length);
	    const key = calculateSHA256(hashData, 0, hashData.length);
	    const cipher = new AES256Cipher(key);
	    return cipher.decryptBlock(userEncryption, false, new Uint8Array(16));
	  }

	}

	exports.PDF17 = PDF17;

	const PDF20 = function PDF20Closure() {
	  function calculatePDF20Hash(password, input, userBytes) {
	    let k = calculateSHA256(input, 0, input.length).subarray(0, 32);
	    let e = [0];
	    let i = 0;

	    while (i < 64 || e.at(-1) > i - 32) {
	      const combinedLength = password.length + k.length + userBytes.length,
	            combinedArray = new Uint8Array(combinedLength);
	      let writeOffset = 0;
	      combinedArray.set(password, writeOffset);
	      writeOffset += password.length;
	      combinedArray.set(k, writeOffset);
	      writeOffset += k.length;
	      combinedArray.set(userBytes, writeOffset);
	      const k1 = new Uint8Array(combinedLength * 64);

	      for (let j = 0, pos = 0; j < 64; j++, pos += combinedLength) {
	        k1.set(combinedArray, pos);
	      }

	      const cipher = new AES128Cipher(k.subarray(0, 16));
	      e = cipher.encrypt(k1, k.subarray(16, 32));
	      let remainder = 0;

	      for (let z = 0; z < 16; z++) {
	        remainder *= 256 % 3;
	        remainder %= 3;
	        remainder += (e[z] >>> 0) % 3;
	        remainder %= 3;
	      }

	      if (remainder === 0) {
	        k = calculateSHA256(e, 0, e.length);
	      } else if (remainder === 1) {
	        k = calculateSHA384(e, 0, e.length);
	      } else if (remainder === 2) {
	        k = calculateSHA512(e, 0, e.length);
	      }

	      i++;
	    }

	    return k.subarray(0, 32);
	  }

	  class PDF20 {
	    hash(password, concatBytes, userBytes) {
	      return calculatePDF20Hash(password, concatBytes, userBytes);
	    }

	    checkOwnerPassword(password, ownerValidationSalt, userBytes, ownerPassword) {
	      const hashData = new Uint8Array(password.length + 56);
	      hashData.set(password, 0);
	      hashData.set(ownerValidationSalt, password.length);
	      hashData.set(userBytes, password.length + ownerValidationSalt.length);
	      const result = calculatePDF20Hash(password, hashData, userBytes);
	      return (0, _util.isArrayEqual)(result, ownerPassword);
	    }

	    checkUserPassword(password, userValidationSalt, userPassword) {
	      const hashData = new Uint8Array(password.length + 8);
	      hashData.set(password, 0);
	      hashData.set(userValidationSalt, password.length);
	      const result = calculatePDF20Hash(password, hashData, []);
	      return (0, _util.isArrayEqual)(result, userPassword);
	    }

	    getOwnerKey(password, ownerKeySalt, userBytes, ownerEncryption) {
	      const hashData = new Uint8Array(password.length + 56);
	      hashData.set(password, 0);
	      hashData.set(ownerKeySalt, password.length);
	      hashData.set(userBytes, password.length + ownerKeySalt.length);
	      const key = calculatePDF20Hash(password, hashData, userBytes);
	      const cipher = new AES256Cipher(key);
	      return cipher.decryptBlock(ownerEncryption, false, new Uint8Array(16));
	    }

	    getUserKey(password, userKeySalt, userEncryption) {
	      const hashData = new Uint8Array(password.length + 8);
	      hashData.set(password, 0);
	      hashData.set(userKeySalt, password.length);
	      const key = calculatePDF20Hash(password, hashData, []);
	      const cipher = new AES256Cipher(key);
	      return cipher.decryptBlock(userEncryption, false, new Uint8Array(16));
	    }

	  }

	  return PDF20;
	}();

	exports.PDF20 = PDF20;

	class CipherTransform {
	  constructor(stringCipherConstructor, streamCipherConstructor) {
	    this.StringCipherConstructor = stringCipherConstructor;
	    this.StreamCipherConstructor = streamCipherConstructor;
	  }

	  createStream(stream, length) {
	    const cipher = new this.StreamCipherConstructor();
	    return new _decrypt_stream.DecryptStream(stream, length, function cipherTransformDecryptStream(data, finalize) {
	      return cipher.decryptBlock(data, finalize);
	    });
	  }

	  decryptString(s) {
	    const cipher = new this.StringCipherConstructor();
	    let data = (0, _util.stringToBytes)(s);
	    data = cipher.decryptBlock(data, true);
	    return (0, _util.bytesToString)(data);
	  }

	  encryptString(s) {
	    const cipher = new this.StringCipherConstructor();

	    if (cipher instanceof AESBaseCipher) {
	      const strLen = s.length;
	      const pad = 16 - strLen % 16;
	      s += String.fromCharCode(pad).repeat(pad);
	      const iv = new Uint8Array(16);

	      if (typeof crypto !== "undefined") {
	        crypto.getRandomValues(iv);
	      } else {
	        for (let i = 0; i < 16; i++) {
	          iv[i] = Math.floor(256 * Math.random());
	        }
	      }

	      let data = (0, _util.stringToBytes)(s);
	      data = cipher.encrypt(data, iv);
	      const buf = new Uint8Array(16 + data.length);
	      buf.set(iv);
	      buf.set(data, 16);
	      return (0, _util.bytesToString)(buf);
	    }

	    let data = (0, _util.stringToBytes)(s);
	    data = cipher.encrypt(data);
	    return (0, _util.bytesToString)(data);
	  }

	}

	const CipherTransformFactory = function CipherTransformFactoryClosure() {
	  const defaultPasswordBytes = new Uint8Array([0x28, 0xbf, 0x4e, 0x5e, 0x4e, 0x75, 0x8a, 0x41, 0x64, 0x00, 0x4e, 0x56, 0xff, 0xfa, 0x01, 0x08, 0x2e, 0x2e, 0x00, 0xb6, 0xd0, 0x68, 0x3e, 0x80, 0x2f, 0x0c, 0xa9, 0xfe, 0x64, 0x53, 0x69, 0x7a]);

	  function createEncryptionKey20(revision, password, ownerPassword, ownerValidationSalt, ownerKeySalt, uBytes, userPassword, userValidationSalt, userKeySalt, ownerEncryption, userEncryption, perms) {
	    if (password) {
	      const passwordLength = Math.min(127, password.length);
	      password = password.subarray(0, passwordLength);
	    } else {
	      password = [];
	    }

	    let pdfAlgorithm;

	    if (revision === 6) {
	      pdfAlgorithm = new PDF20();
	    } else {
	      pdfAlgorithm = new PDF17();
	    }

	    if (pdfAlgorithm.checkUserPassword(password, userValidationSalt, userPassword)) {
	      return pdfAlgorithm.getUserKey(password, userKeySalt, userEncryption);
	    } else if (password.length && pdfAlgorithm.checkOwnerPassword(password, ownerValidationSalt, uBytes, ownerPassword)) {
	      return pdfAlgorithm.getOwnerKey(password, ownerKeySalt, uBytes, ownerEncryption);
	    }

	    return null;
	  }

	  function prepareKeyData(fileId, password, ownerPassword, userPassword, flags, revision, keyLength, encryptMetadata) {
	    const hashDataSize = 40 + ownerPassword.length + fileId.length;
	    const hashData = new Uint8Array(hashDataSize);
	    let i = 0,
	        j,
	        n;

	    if (password) {
	      n = Math.min(32, password.length);

	      for (; i < n; ++i) {
	        hashData[i] = password[i];
	      }
	    }

	    j = 0;

	    while (i < 32) {
	      hashData[i++] = defaultPasswordBytes[j++];
	    }

	    for (j = 0, n = ownerPassword.length; j < n; ++j) {
	      hashData[i++] = ownerPassword[j];
	    }

	    hashData[i++] = flags & 0xff;
	    hashData[i++] = flags >> 8 & 0xff;
	    hashData[i++] = flags >> 16 & 0xff;
	    hashData[i++] = flags >>> 24 & 0xff;

	    for (j = 0, n = fileId.length; j < n; ++j) {
	      hashData[i++] = fileId[j];
	    }

	    if (revision >= 4 && !encryptMetadata) {
	      hashData[i++] = 0xff;
	      hashData[i++] = 0xff;
	      hashData[i++] = 0xff;
	      hashData[i++] = 0xff;
	    }

	    let hash = calculateMD5(hashData, 0, i);
	    const keyLengthInBytes = keyLength >> 3;

	    if (revision >= 3) {
	      for (j = 0; j < 50; ++j) {
	        hash = calculateMD5(hash, 0, keyLengthInBytes);
	      }
	    }

	    const encryptionKey = hash.subarray(0, keyLengthInBytes);
	    let cipher, checkData;

	    if (revision >= 3) {
	      for (i = 0; i < 32; ++i) {
	        hashData[i] = defaultPasswordBytes[i];
	      }

	      for (j = 0, n = fileId.length; j < n; ++j) {
	        hashData[i++] = fileId[j];
	      }

	      cipher = new ARCFourCipher(encryptionKey);
	      checkData = cipher.encryptBlock(calculateMD5(hashData, 0, i));
	      n = encryptionKey.length;
	      const derivedKey = new Uint8Array(n);

	      for (j = 1; j <= 19; ++j) {
	        for (let k = 0; k < n; ++k) {
	          derivedKey[k] = encryptionKey[k] ^ j;
	        }

	        cipher = new ARCFourCipher(derivedKey);
	        checkData = cipher.encryptBlock(checkData);
	      }

	      for (j = 0, n = checkData.length; j < n; ++j) {
	        if (userPassword[j] !== checkData[j]) {
	          return null;
	        }
	      }
	    } else {
	      cipher = new ARCFourCipher(encryptionKey);
	      checkData = cipher.encryptBlock(defaultPasswordBytes);

	      for (j = 0, n = checkData.length; j < n; ++j) {
	        if (userPassword[j] !== checkData[j]) {
	          return null;
	        }
	      }
	    }

	    return encryptionKey;
	  }

	  function decodeUserPassword(password, ownerPassword, revision, keyLength) {
	    const hashData = new Uint8Array(32);
	    let i = 0;
	    const n = Math.min(32, password.length);

	    for (; i < n; ++i) {
	      hashData[i] = password[i];
	    }

	    let j = 0;

	    while (i < 32) {
	      hashData[i++] = defaultPasswordBytes[j++];
	    }

	    let hash = calculateMD5(hashData, 0, i);
	    const keyLengthInBytes = keyLength >> 3;

	    if (revision >= 3) {
	      for (j = 0; j < 50; ++j) {
	        hash = calculateMD5(hash, 0, hash.length);
	      }
	    }

	    let cipher, userPassword;

	    if (revision >= 3) {
	      userPassword = ownerPassword;
	      const derivedKey = new Uint8Array(keyLengthInBytes);

	      for (j = 19; j >= 0; j--) {
	        for (let k = 0; k < keyLengthInBytes; ++k) {
	          derivedKey[k] = hash[k] ^ j;
	        }

	        cipher = new ARCFourCipher(derivedKey);
	        userPassword = cipher.encryptBlock(userPassword);
	      }
	    } else {
	      cipher = new ARCFourCipher(hash.subarray(0, keyLengthInBytes));
	      userPassword = cipher.encryptBlock(ownerPassword);
	    }

	    return userPassword;
	  }

	  const identityName = _primitives.Name.get("Identity");

	  function buildObjectKey(num, gen, encryptionKey, isAes = false) {
	    const key = new Uint8Array(encryptionKey.length + 9);
	    const n = encryptionKey.length;
	    let i;

	    for (i = 0; i < n; ++i) {
	      key[i] = encryptionKey[i];
	    }

	    key[i++] = num & 0xff;
	    key[i++] = num >> 8 & 0xff;
	    key[i++] = num >> 16 & 0xff;
	    key[i++] = gen & 0xff;
	    key[i++] = gen >> 8 & 0xff;

	    if (isAes) {
	      key[i++] = 0x73;
	      key[i++] = 0x41;
	      key[i++] = 0x6c;
	      key[i++] = 0x54;
	    }

	    const hash = calculateMD5(key, 0, i);
	    return hash.subarray(0, Math.min(encryptionKey.length + 5, 16));
	  }

	  function buildCipherConstructor(cf, name, num, gen, key) {
	    if (!(name instanceof _primitives.Name)) {
	      throw new _util.FormatError("Invalid crypt filter name.");
	    }

	    const cryptFilter = cf.get(name.name);
	    let cfm;

	    if (cryptFilter !== null && cryptFilter !== undefined) {
	      cfm = cryptFilter.get("CFM");
	    }

	    if (!cfm || cfm.name === "None") {
	      return function cipherTransformFactoryBuildCipherConstructorNone() {
	        return new NullCipher();
	      };
	    }

	    if (cfm.name === "V2") {
	      return function cipherTransformFactoryBuildCipherConstructorV2() {
	        return new ARCFourCipher(buildObjectKey(num, gen, key, false));
	      };
	    }

	    if (cfm.name === "AESV2") {
	      return function cipherTransformFactoryBuildCipherConstructorAESV2() {
	        return new AES128Cipher(buildObjectKey(num, gen, key, true));
	      };
	    }

	    if (cfm.name === "AESV3") {
	      return function cipherTransformFactoryBuildCipherConstructorAESV3() {
	        return new AES256Cipher(key);
	      };
	    }

	    throw new _util.FormatError("Unknown crypto method");
	  }

	  class CipherTransformFactory {
	    constructor(dict, fileId, password) {
	      const filter = dict.get("Filter");

	      if (!(0, _primitives.isName)(filter, "Standard")) {
	        throw new _util.FormatError("unknown encryption method");
	      }

	      this.filterName = filter.name;
	      this.dict = dict;
	      const algorithm = dict.get("V");

	      if (!Number.isInteger(algorithm) || algorithm !== 1 && algorithm !== 2 && algorithm !== 4 && algorithm !== 5) {
	        throw new _util.FormatError("unsupported encryption algorithm");
	      }

	      this.algorithm = algorithm;
	      let keyLength = dict.get("Length");

	      if (!keyLength) {
	        if (algorithm <= 3) {
	          keyLength = 40;
	        } else {
	          const cfDict = dict.get("CF");
	          const streamCryptoName = dict.get("StmF");

	          if (cfDict instanceof _primitives.Dict && streamCryptoName instanceof _primitives.Name) {
	            cfDict.suppressEncryption = true;
	            const handlerDict = cfDict.get(streamCryptoName.name);
	            keyLength = handlerDict && handlerDict.get("Length") || 128;

	            if (keyLength < 40) {
	              keyLength <<= 3;
	            }
	          }
	        }
	      }

	      if (!Number.isInteger(keyLength) || keyLength < 40 || keyLength % 8 !== 0) {
	        throw new _util.FormatError("invalid key length");
	      }

	      const ownerPassword = (0, _util.stringToBytes)(dict.get("O")).subarray(0, 32);
	      const userPassword = (0, _util.stringToBytes)(dict.get("U")).subarray(0, 32);
	      const flags = dict.get("P");
	      const revision = dict.get("R");
	      const encryptMetadata = (algorithm === 4 || algorithm === 5) && dict.get("EncryptMetadata") !== false;
	      this.encryptMetadata = encryptMetadata;
	      const fileIdBytes = (0, _util.stringToBytes)(fileId);
	      let passwordBytes;

	      if (password) {
	        if (revision === 6) {
	          try {
	            password = (0, _util.utf8StringToString)(password);
	          } catch (ex) {
	            (0, _util.warn)("CipherTransformFactory: " + "Unable to convert UTF8 encoded password.");
	          }
	        }

	        passwordBytes = (0, _util.stringToBytes)(password);
	      }

	      let encryptionKey;

	      if (algorithm !== 5) {
	        encryptionKey = prepareKeyData(fileIdBytes, passwordBytes, ownerPassword, userPassword, flags, revision, keyLength, encryptMetadata);
	      } else {
	        const ownerValidationSalt = (0, _util.stringToBytes)(dict.get("O")).subarray(32, 40);
	        const ownerKeySalt = (0, _util.stringToBytes)(dict.get("O")).subarray(40, 48);
	        const uBytes = (0, _util.stringToBytes)(dict.get("U")).subarray(0, 48);
	        const userValidationSalt = (0, _util.stringToBytes)(dict.get("U")).subarray(32, 40);
	        const userKeySalt = (0, _util.stringToBytes)(dict.get("U")).subarray(40, 48);
	        const ownerEncryption = (0, _util.stringToBytes)(dict.get("OE"));
	        const userEncryption = (0, _util.stringToBytes)(dict.get("UE"));
	        (0, _util.stringToBytes)(dict.get("Perms"));
	        encryptionKey = createEncryptionKey20(revision, passwordBytes, ownerPassword, ownerValidationSalt, ownerKeySalt, uBytes, userPassword, userValidationSalt, userKeySalt, ownerEncryption, userEncryption);
	      }

	      if (!encryptionKey && !password) {
	        throw new _util.PasswordException("No password given", _util.PasswordResponses.NEED_PASSWORD);
	      } else if (!encryptionKey && password) {
	        const decodedPassword = decodeUserPassword(passwordBytes, ownerPassword, revision, keyLength);
	        encryptionKey = prepareKeyData(fileIdBytes, decodedPassword, ownerPassword, userPassword, flags, revision, keyLength, encryptMetadata);
	      }

	      if (!encryptionKey) {
	        throw new _util.PasswordException("Incorrect Password", _util.PasswordResponses.INCORRECT_PASSWORD);
	      }

	      this.encryptionKey = encryptionKey;

	      if (algorithm >= 4) {
	        const cf = dict.get("CF");

	        if (cf instanceof _primitives.Dict) {
	          cf.suppressEncryption = true;
	        }

	        this.cf = cf;
	        this.stmf = dict.get("StmF") || identityName;
	        this.strf = dict.get("StrF") || identityName;
	        this.eff = dict.get("EFF") || this.stmf;
	      }
	    }

	    createCipherTransform(num, gen) {
	      if (this.algorithm === 4 || this.algorithm === 5) {
	        return new CipherTransform(buildCipherConstructor(this.cf, this.strf, num, gen, this.encryptionKey), buildCipherConstructor(this.cf, this.stmf, num, gen, this.encryptionKey));
	      }

	      const key = buildObjectKey(num, gen, this.encryptionKey, false);

	      const cipherConstructor = function buildCipherCipherConstructor() {
	        return new ARCFourCipher(key);
	      };

	      return new CipherTransform(cipherConstructor, cipherConstructor);
	    }

	  }

	  return CipherTransformFactory;
	}();

	exports.CipherTransformFactory = CipherTransformFactory;

	/***/ }),
	/* 68 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.DecryptStream = void 0;

	var _decode_stream = __w_pdfjs_require__(19);

	const chunkSize = 512;

	class DecryptStream extends _decode_stream.DecodeStream {
	  constructor(str, maybeLength, decrypt) {
	    super(maybeLength);
	    this.str = str;
	    this.dict = str.dict;
	    this.decrypt = decrypt;
	    this.nextChunk = null;
	    this.initialized = false;
	  }

	  readBlock() {
	    let chunk;

	    if (this.initialized) {
	      chunk = this.nextChunk;
	    } else {
	      chunk = this.str.getBytes(chunkSize);
	      this.initialized = true;
	    }

	    if (!chunk || chunk.length === 0) {
	      this.eof = true;
	      return;
	    }

	    this.nextChunk = this.str.getBytes(chunkSize);
	    const hasMoreData = this.nextChunk && this.nextChunk.length > 0;
	    const decrypt = this.decrypt;
	    chunk = decrypt(chunk, !hasMoreData);
	    let bufferLength = this.bufferLength;
	    const n = chunk.length,
	          buffer = this.ensureBuffer(bufferLength + n);

	    for (let i = 0; i < n; i++) {
	      buffer[bufferLength++] = chunk[i];
	    }

	    this.bufferLength = bufferLength;
	  }

	}

	exports.DecryptStream = DecryptStream;

	/***/ }),
	/* 69 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Catalog = void 0;

	var _core_utils = __w_pdfjs_require__(6);

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _name_number_tree = __w_pdfjs_require__(70);

	var _base_stream = __w_pdfjs_require__(7);

	var _cleanup_helper = __w_pdfjs_require__(71);

	var _colorspace = __w_pdfjs_require__(14);

	var _file_spec = __w_pdfjs_require__(72);

	var _image_utils = __w_pdfjs_require__(59);

	var _metadata_parser = __w_pdfjs_require__(73);

	var _struct_tree = __w_pdfjs_require__(74);

	function fetchDestination(dest) {
	  if (dest instanceof _primitives.Dict) {
	    dest = dest.get("D");
	  }

	  return Array.isArray(dest) ? dest : null;
	}

	class Catalog {
	  constructor(pdfManager, xref) {
	    this.pdfManager = pdfManager;
	    this.xref = xref;
	    this._catDict = xref.getCatalogObj();

	    if (!(this._catDict instanceof _primitives.Dict)) {
	      throw new _util.FormatError("Catalog object is not a dictionary.");
	    }

	    this.toplevelPagesDict;
	    this._actualNumPages = null;
	    this.fontCache = new _primitives.RefSetCache();
	    this.builtInCMapCache = new Map();
	    this.standardFontDataCache = new Map();
	    this.globalImageCache = new _image_utils.GlobalImageCache();
	    this.pageKidsCountCache = new _primitives.RefSetCache();
	    this.pageIndexCache = new _primitives.RefSetCache();
	    this.nonBlendModesSet = new _primitives.RefSet();
	  }

	  get version() {
	    const version = this._catDict.get("Version");

	    return (0, _util.shadow)(this, "version", version instanceof _primitives.Name ? version.name : null);
	  }

	  get lang() {
	    const lang = this._catDict.get("Lang");

	    return (0, _util.shadow)(this, "lang", typeof lang === "string" ? (0, _util.stringToPDFString)(lang) : null);
	  }

	  get needsRendering() {
	    const needsRendering = this._catDict.get("NeedsRendering");

	    return (0, _util.shadow)(this, "needsRendering", typeof needsRendering === "boolean" ? needsRendering : false);
	  }

	  get collection() {
	    let collection = null;

	    try {
	      const obj = this._catDict.get("Collection");

	      if (obj instanceof _primitives.Dict && obj.size > 0) {
	        collection = obj;
	      }
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.info)("Cannot fetch Collection entry; assuming no collection is present.");
	    }

	    return (0, _util.shadow)(this, "collection", collection);
	  }

	  get acroForm() {
	    let acroForm = null;

	    try {
	      const obj = this._catDict.get("AcroForm");

	      if (obj instanceof _primitives.Dict && obj.size > 0) {
	        acroForm = obj;
	      }
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.info)("Cannot fetch AcroForm entry; assuming no forms are present.");
	    }

	    return (0, _util.shadow)(this, "acroForm", acroForm);
	  }

	  get acroFormRef() {
	    const value = this._catDict.getRaw("AcroForm");

	    return (0, _util.shadow)(this, "acroFormRef", value instanceof _primitives.Ref ? value : null);
	  }

	  get metadata() {
	    const streamRef = this._catDict.getRaw("Metadata");

	    if (!(streamRef instanceof _primitives.Ref)) {
	      return (0, _util.shadow)(this, "metadata", null);
	    }

	    let metadata = null;

	    try {
	      const suppressEncryption = !(this.xref.encrypt && this.xref.encrypt.encryptMetadata);
	      const stream = this.xref.fetch(streamRef, suppressEncryption);

	      if (stream instanceof _base_stream.BaseStream && stream.dict instanceof _primitives.Dict) {
	        const type = stream.dict.get("Type");
	        const subtype = stream.dict.get("Subtype");

	        if ((0, _primitives.isName)(type, "Metadata") && (0, _primitives.isName)(subtype, "XML")) {
	          const data = (0, _util.stringToUTF8String)(stream.getString());

	          if (data) {
	            metadata = new _metadata_parser.MetadataParser(data).serializable;
	          }
	        }
	      }
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.info)(`Skipping invalid Metadata: "${ex}".`);
	    }

	    return (0, _util.shadow)(this, "metadata", metadata);
	  }

	  get markInfo() {
	    let markInfo = null;

	    try {
	      markInfo = this._readMarkInfo();
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)("Unable to read mark info.");
	    }

	    return (0, _util.shadow)(this, "markInfo", markInfo);
	  }

	  _readMarkInfo() {
	    const obj = this._catDict.get("MarkInfo");

	    if (!(obj instanceof _primitives.Dict)) {
	      return null;
	    }

	    const markInfo = {
	      Marked: false,
	      UserProperties: false,
	      Suspects: false
	    };

	    for (const key in markInfo) {
	      const value = obj.get(key);

	      if (typeof value === "boolean") {
	        markInfo[key] = value;
	      }
	    }

	    return markInfo;
	  }

	  get structTreeRoot() {
	    let structTree = null;

	    try {
	      structTree = this._readStructTreeRoot();
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)("Unable read to structTreeRoot info.");
	    }

	    return (0, _util.shadow)(this, "structTreeRoot", structTree);
	  }

	  _readStructTreeRoot() {
	    const obj = this._catDict.get("StructTreeRoot");

	    if (!(obj instanceof _primitives.Dict)) {
	      return null;
	    }

	    const root = new _struct_tree.StructTreeRoot(obj);
	    root.init();
	    return root;
	  }

	  get toplevelPagesDict() {
	    const pagesObj = this._catDict.get("Pages");

	    if (!(pagesObj instanceof _primitives.Dict)) {
	      throw new _util.FormatError("Invalid top-level pages dictionary.");
	    }

	    return (0, _util.shadow)(this, "toplevelPagesDict", pagesObj);
	  }

	  get documentOutline() {
	    let obj = null;

	    try {
	      obj = this._readDocumentOutline();
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)("Unable to read document outline.");
	    }

	    return (0, _util.shadow)(this, "documentOutline", obj);
	  }

	  _readDocumentOutline() {
	    let obj = this._catDict.get("Outlines");

	    if (!(obj instanceof _primitives.Dict)) {
	      return null;
	    }

	    obj = obj.getRaw("First");

	    if (!(obj instanceof _primitives.Ref)) {
	      return null;
	    }

	    const root = {
	      items: []
	    };
	    const queue = [{
	      obj,
	      parent: root
	    }];
	    const processed = new _primitives.RefSet();
	    processed.put(obj);
	    const xref = this.xref,
	          blackColor = new Uint8ClampedArray(3);

	    while (queue.length > 0) {
	      const i = queue.shift();
	      const outlineDict = xref.fetchIfRef(i.obj);

	      if (outlineDict === null) {
	        continue;
	      }

	      if (!outlineDict.has("Title")) {
	        throw new _util.FormatError("Invalid outline item encountered.");
	      }

	      const data = {
	        url: null,
	        dest: null
	      };
	      Catalog.parseDestDictionary({
	        destDict: outlineDict,
	        resultObj: data,
	        docBaseUrl: this.pdfManager.docBaseUrl
	      });
	      const title = outlineDict.get("Title");
	      const flags = outlineDict.get("F") || 0;
	      const color = outlineDict.getArray("C");
	      const count = outlineDict.get("Count");
	      let rgbColor = blackColor;

	      if (Array.isArray(color) && color.length === 3 && (color[0] !== 0 || color[1] !== 0 || color[2] !== 0)) {
	        rgbColor = _colorspace.ColorSpace.singletons.rgb.getRgb(color, 0);
	      }

	      const outlineItem = {
	        dest: data.dest,
	        url: data.url,
	        unsafeUrl: data.unsafeUrl,
	        newWindow: data.newWindow,
	        title: (0, _util.stringToPDFString)(title),
	        color: rgbColor,
	        count: Number.isInteger(count) ? count : undefined,
	        bold: !!(flags & 2),
	        italic: !!(flags & 1),
	        items: []
	      };
	      i.parent.items.push(outlineItem);
	      obj = outlineDict.getRaw("First");

	      if (obj instanceof _primitives.Ref && !processed.has(obj)) {
	        queue.push({
	          obj,
	          parent: outlineItem
	        });
	        processed.put(obj);
	      }

	      obj = outlineDict.getRaw("Next");

	      if (obj instanceof _primitives.Ref && !processed.has(obj)) {
	        queue.push({
	          obj,
	          parent: i.parent
	        });
	        processed.put(obj);
	      }
	    }

	    return root.items.length > 0 ? root.items : null;
	  }

	  get permissions() {
	    let permissions = null;

	    try {
	      permissions = this._readPermissions();
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)("Unable to read permissions.");
	    }

	    return (0, _util.shadow)(this, "permissions", permissions);
	  }

	  _readPermissions() {
	    const encrypt = this.xref.trailer.get("Encrypt");

	    if (!(encrypt instanceof _primitives.Dict)) {
	      return null;
	    }

	    let flags = encrypt.get("P");

	    if (typeof flags !== "number") {
	      return null;
	    }

	    flags += 2 ** 32;
	    const permissions = [];

	    for (const key in _util.PermissionFlag) {
	      const value = _util.PermissionFlag[key];

	      if (flags & value) {
	        permissions.push(value);
	      }
	    }

	    return permissions;
	  }

	  get optionalContentConfig() {
	    let config = null;

	    try {
	      const properties = this._catDict.get("OCProperties");

	      if (!properties) {
	        return (0, _util.shadow)(this, "optionalContentConfig", null);
	      }

	      const defaultConfig = properties.get("D");

	      if (!defaultConfig) {
	        return (0, _util.shadow)(this, "optionalContentConfig", null);
	      }

	      const groupsData = properties.get("OCGs");

	      if (!Array.isArray(groupsData)) {
	        return (0, _util.shadow)(this, "optionalContentConfig", null);
	      }

	      const groups = [];
	      const groupRefs = [];

	      for (const groupRef of groupsData) {
	        if (!(groupRef instanceof _primitives.Ref)) {
	          continue;
	        }

	        groupRefs.push(groupRef);
	        const group = this.xref.fetchIfRef(groupRef);
	        groups.push({
	          id: groupRef.toString(),
	          name: typeof group.get("Name") === "string" ? (0, _util.stringToPDFString)(group.get("Name")) : null,
	          intent: typeof group.get("Intent") === "string" ? (0, _util.stringToPDFString)(group.get("Intent")) : null
	        });
	      }

	      config = this._readOptionalContentConfig(defaultConfig, groupRefs);
	      config.groups = groups;
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)(`Unable to read optional content config: ${ex}`);
	    }

	    return (0, _util.shadow)(this, "optionalContentConfig", config);
	  }

	  _readOptionalContentConfig(config, contentGroupRefs) {
	    function parseOnOff(refs) {
	      const onParsed = [];

	      if (Array.isArray(refs)) {
	        for (const value of refs) {
	          if (!(value instanceof _primitives.Ref)) {
	            continue;
	          }

	          if (contentGroupRefs.includes(value)) {
	            onParsed.push(value.toString());
	          }
	        }
	      }

	      return onParsed;
	    }

	    function parseOrder(refs, nestedLevels = 0) {
	      if (!Array.isArray(refs)) {
	        return null;
	      }

	      const order = [];

	      for (const value of refs) {
	        if (value instanceof _primitives.Ref && contentGroupRefs.includes(value)) {
	          parsedOrderRefs.put(value);
	          order.push(value.toString());
	          continue;
	        }

	        const nestedOrder = parseNestedOrder(value, nestedLevels);

	        if (nestedOrder) {
	          order.push(nestedOrder);
	        }
	      }

	      if (nestedLevels > 0) {
	        return order;
	      }

	      const hiddenGroups = [];

	      for (const groupRef of contentGroupRefs) {
	        if (parsedOrderRefs.has(groupRef)) {
	          continue;
	        }

	        hiddenGroups.push(groupRef.toString());
	      }

	      if (hiddenGroups.length) {
	        order.push({
	          name: null,
	          order: hiddenGroups
	        });
	      }

	      return order;
	    }

	    function parseNestedOrder(ref, nestedLevels) {
	      if (++nestedLevels > MAX_NESTED_LEVELS) {
	        (0, _util.warn)("parseNestedOrder - reached MAX_NESTED_LEVELS.");
	        return null;
	      }

	      const value = xref.fetchIfRef(ref);

	      if (!Array.isArray(value)) {
	        return null;
	      }

	      const nestedName = xref.fetchIfRef(value[0]);

	      if (typeof nestedName !== "string") {
	        return null;
	      }

	      const nestedOrder = parseOrder(value.slice(1), nestedLevels);

	      if (!nestedOrder || !nestedOrder.length) {
	        return null;
	      }

	      return {
	        name: (0, _util.stringToPDFString)(nestedName),
	        order: nestedOrder
	      };
	    }

	    const xref = this.xref,
	          parsedOrderRefs = new _primitives.RefSet(),
	          MAX_NESTED_LEVELS = 10;
	    return {
	      name: typeof config.get("Name") === "string" ? (0, _util.stringToPDFString)(config.get("Name")) : null,
	      creator: typeof config.get("Creator") === "string" ? (0, _util.stringToPDFString)(config.get("Creator")) : null,
	      baseState: config.get("BaseState") instanceof _primitives.Name ? config.get("BaseState").name : null,
	      on: parseOnOff(config.get("ON")),
	      off: parseOnOff(config.get("OFF")),
	      order: parseOrder(config.get("Order")),
	      groups: null
	    };
	  }

	  setActualNumPages(num = null) {
	    this._actualNumPages = num;
	  }

	  get hasActualNumPages() {
	    return this._actualNumPages !== null;
	  }

	  get _pagesCount() {
	    const obj = this.toplevelPagesDict.get("Count");

	    if (!Number.isInteger(obj)) {
	      throw new _util.FormatError("Page count in top-level pages dictionary is not an integer.");
	    }

	    return (0, _util.shadow)(this, "_pagesCount", obj);
	  }

	  get numPages() {
	    return this.hasActualNumPages ? this._actualNumPages : this._pagesCount;
	  }

	  get destinations() {
	    const obj = this._readDests(),
	          dests = Object.create(null);

	    if (obj instanceof _name_number_tree.NameTree) {
	      for (const [key, value] of obj.getAll()) {
	        const dest = fetchDestination(value);

	        if (dest) {
	          dests[(0, _util.stringToPDFString)(key)] = dest;
	        }
	      }
	    } else if (obj instanceof _primitives.Dict) {
	      obj.forEach(function (key, value) {
	        const dest = fetchDestination(value);

	        if (dest) {
	          dests[key] = dest;
	        }
	      });
	    }

	    return (0, _util.shadow)(this, "destinations", dests);
	  }

	  getDestination(id) {
	    const obj = this._readDests();

	    if (obj instanceof _name_number_tree.NameTree) {
	      const dest = fetchDestination(obj.get(id));

	      if (dest) {
	        return dest;
	      }

	      const allDest = this.destinations[id];

	      if (allDest) {
	        (0, _util.warn)(`Found "${id}" at an incorrect position in the NameTree.`);
	        return allDest;
	      }
	    } else if (obj instanceof _primitives.Dict) {
	      const dest = fetchDestination(obj.get(id));

	      if (dest) {
	        return dest;
	      }
	    }

	    return null;
	  }

	  _readDests() {
	    const obj = this._catDict.get("Names");

	    if (obj && obj.has("Dests")) {
	      return new _name_number_tree.NameTree(obj.getRaw("Dests"), this.xref);
	    } else if (this._catDict.has("Dests")) {
	      return this._catDict.get("Dests");
	    }

	    return undefined;
	  }

	  get pageLabels() {
	    let obj = null;

	    try {
	      obj = this._readPageLabels();
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)("Unable to read page labels.");
	    }

	    return (0, _util.shadow)(this, "pageLabels", obj);
	  }

	  _readPageLabels() {
	    const obj = this._catDict.getRaw("PageLabels");

	    if (!obj) {
	      return null;
	    }

	    const pageLabels = new Array(this.numPages);
	    let style = null,
	        prefix = "";
	    const numberTree = new _name_number_tree.NumberTree(obj, this.xref);
	    const nums = numberTree.getAll();
	    let currentLabel = "",
	        currentIndex = 1;

	    for (let i = 0, ii = this.numPages; i < ii; i++) {
	      const labelDict = nums.get(i);

	      if (labelDict !== undefined) {
	        if (!(labelDict instanceof _primitives.Dict)) {
	          throw new _util.FormatError("PageLabel is not a dictionary.");
	        }

	        if (labelDict.has("Type") && !(0, _primitives.isName)(labelDict.get("Type"), "PageLabel")) {
	          throw new _util.FormatError("Invalid type in PageLabel dictionary.");
	        }

	        if (labelDict.has("S")) {
	          const s = labelDict.get("S");

	          if (!(s instanceof _primitives.Name)) {
	            throw new _util.FormatError("Invalid style in PageLabel dictionary.");
	          }

	          style = s.name;
	        } else {
	          style = null;
	        }

	        if (labelDict.has("P")) {
	          const p = labelDict.get("P");

	          if (typeof p !== "string") {
	            throw new _util.FormatError("Invalid prefix in PageLabel dictionary.");
	          }

	          prefix = (0, _util.stringToPDFString)(p);
	        } else {
	          prefix = "";
	        }

	        if (labelDict.has("St")) {
	          const st = labelDict.get("St");

	          if (!(Number.isInteger(st) && st >= 1)) {
	            throw new _util.FormatError("Invalid start in PageLabel dictionary.");
	          }

	          currentIndex = st;
	        } else {
	          currentIndex = 1;
	        }
	      }

	      switch (style) {
	        case "D":
	          currentLabel = currentIndex;
	          break;

	        case "R":
	        case "r":
	          currentLabel = (0, _core_utils.toRomanNumerals)(currentIndex, style === "r");
	          break;

	        case "A":
	        case "a":
	          const LIMIT = 26;
	          const A_UPPER_CASE = 0x41,
	                A_LOWER_CASE = 0x61;
	          const baseCharCode = style === "a" ? A_LOWER_CASE : A_UPPER_CASE;
	          const letterIndex = currentIndex - 1;
	          const character = String.fromCharCode(baseCharCode + letterIndex % LIMIT);
	          currentLabel = character.repeat(Math.floor(letterIndex / LIMIT) + 1);
	          break;

	        default:
	          if (style) {
	            throw new _util.FormatError(`Invalid style "${style}" in PageLabel dictionary.`);
	          }

	          currentLabel = "";
	      }

	      pageLabels[i] = prefix + currentLabel;
	      currentIndex++;
	    }

	    return pageLabels;
	  }

	  get pageLayout() {
	    const obj = this._catDict.get("PageLayout");

	    let pageLayout = "";

	    if (obj instanceof _primitives.Name) {
	      switch (obj.name) {
	        case "SinglePage":
	        case "OneColumn":
	        case "TwoColumnLeft":
	        case "TwoColumnRight":
	        case "TwoPageLeft":
	        case "TwoPageRight":
	          pageLayout = obj.name;
	      }
	    }

	    return (0, _util.shadow)(this, "pageLayout", pageLayout);
	  }

	  get pageMode() {
	    const obj = this._catDict.get("PageMode");

	    let pageMode = "UseNone";

	    if (obj instanceof _primitives.Name) {
	      switch (obj.name) {
	        case "UseNone":
	        case "UseOutlines":
	        case "UseThumbs":
	        case "FullScreen":
	        case "UseOC":
	        case "UseAttachments":
	          pageMode = obj.name;
	      }
	    }

	    return (0, _util.shadow)(this, "pageMode", pageMode);
	  }

	  get viewerPreferences() {
	    const obj = this._catDict.get("ViewerPreferences");

	    if (!(obj instanceof _primitives.Dict)) {
	      return (0, _util.shadow)(this, "viewerPreferences", null);
	    }

	    let prefs = null;

	    for (const key of obj.getKeys()) {
	      const value = obj.get(key);
	      let prefValue;

	      switch (key) {
	        case "HideToolbar":
	        case "HideMenubar":
	        case "HideWindowUI":
	        case "FitWindow":
	        case "CenterWindow":
	        case "DisplayDocTitle":
	        case "PickTrayByPDFSize":
	          if (typeof value === "boolean") {
	            prefValue = value;
	          }

	          break;

	        case "NonFullScreenPageMode":
	          if (value instanceof _primitives.Name) {
	            switch (value.name) {
	              case "UseNone":
	              case "UseOutlines":
	              case "UseThumbs":
	              case "UseOC":
	                prefValue = value.name;
	                break;

	              default:
	                prefValue = "UseNone";
	            }
	          }

	          break;

	        case "Direction":
	          if (value instanceof _primitives.Name) {
	            switch (value.name) {
	              case "L2R":
	              case "R2L":
	                prefValue = value.name;
	                break;

	              default:
	                prefValue = "L2R";
	            }
	          }

	          break;

	        case "ViewArea":
	        case "ViewClip":
	        case "PrintArea":
	        case "PrintClip":
	          if (value instanceof _primitives.Name) {
	            switch (value.name) {
	              case "MediaBox":
	              case "CropBox":
	              case "BleedBox":
	              case "TrimBox":
	              case "ArtBox":
	                prefValue = value.name;
	                break;

	              default:
	                prefValue = "CropBox";
	            }
	          }

	          break;

	        case "PrintScaling":
	          if (value instanceof _primitives.Name) {
	            switch (value.name) {
	              case "None":
	              case "AppDefault":
	                prefValue = value.name;
	                break;

	              default:
	                prefValue = "AppDefault";
	            }
	          }

	          break;

	        case "Duplex":
	          if (value instanceof _primitives.Name) {
	            switch (value.name) {
	              case "Simplex":
	              case "DuplexFlipShortEdge":
	              case "DuplexFlipLongEdge":
	                prefValue = value.name;
	                break;

	              default:
	                prefValue = "None";
	            }
	          }

	          break;

	        case "PrintPageRange":
	          if (Array.isArray(value) && value.length % 2 === 0) {
	            const isValid = value.every((page, i, arr) => {
	              return Number.isInteger(page) && page > 0 && (i === 0 || page >= arr[i - 1]) && page <= this.numPages;
	            });

	            if (isValid) {
	              prefValue = value;
	            }
	          }

	          break;

	        case "NumCopies":
	          if (Number.isInteger(value) && value > 0) {
	            prefValue = value;
	          }

	          break;

	        default:
	          (0, _util.warn)(`Ignoring non-standard key in ViewerPreferences: ${key}.`);
	          continue;
	      }

	      if (prefValue === undefined) {
	        (0, _util.warn)(`Bad value, for key "${key}", in ViewerPreferences: ${value}.`);
	        continue;
	      }

	      if (!prefs) {
	        prefs = Object.create(null);
	      }

	      prefs[key] = prefValue;
	    }

	    return (0, _util.shadow)(this, "viewerPreferences", prefs);
	  }

	  get openAction() {
	    const obj = this._catDict.get("OpenAction");

	    const openAction = Object.create(null);

	    if (obj instanceof _primitives.Dict) {
	      const destDict = new _primitives.Dict(this.xref);
	      destDict.set("A", obj);
	      const resultObj = {
	        url: null,
	        dest: null,
	        action: null
	      };
	      Catalog.parseDestDictionary({
	        destDict,
	        resultObj
	      });

	      if (Array.isArray(resultObj.dest)) {
	        openAction.dest = resultObj.dest;
	      } else if (resultObj.action) {
	        openAction.action = resultObj.action;
	      }
	    } else if (Array.isArray(obj)) {
	      openAction.dest = obj;
	    }

	    return (0, _util.shadow)(this, "openAction", (0, _util.objectSize)(openAction) > 0 ? openAction : null);
	  }

	  get attachments() {
	    const obj = this._catDict.get("Names");

	    let attachments = null;

	    if (obj instanceof _primitives.Dict && obj.has("EmbeddedFiles")) {
	      const nameTree = new _name_number_tree.NameTree(obj.getRaw("EmbeddedFiles"), this.xref);

	      for (const [key, value] of nameTree.getAll()) {
	        const fs = new _file_spec.FileSpec(value, this.xref);

	        if (!attachments) {
	          attachments = Object.create(null);
	        }

	        attachments[(0, _util.stringToPDFString)(key)] = fs.serializable;
	      }
	    }

	    return (0, _util.shadow)(this, "attachments", attachments);
	  }

	  get xfaImages() {
	    const obj = this._catDict.get("Names");

	    let xfaImages = null;

	    if (obj instanceof _primitives.Dict && obj.has("XFAImages")) {
	      const nameTree = new _name_number_tree.NameTree(obj.getRaw("XFAImages"), this.xref);

	      for (const [key, value] of nameTree.getAll()) {
	        if (!xfaImages) {
	          xfaImages = new _primitives.Dict(this.xref);
	        }

	        xfaImages.set((0, _util.stringToPDFString)(key), value);
	      }
	    }

	    return (0, _util.shadow)(this, "xfaImages", xfaImages);
	  }

	  _collectJavaScript() {
	    const obj = this._catDict.get("Names");

	    let javaScript = null;

	    function appendIfJavaScriptDict(name, jsDict) {
	      if (!(jsDict instanceof _primitives.Dict)) {
	        return;
	      }

	      if (!(0, _primitives.isName)(jsDict.get("S"), "JavaScript")) {
	        return;
	      }

	      let js = jsDict.get("JS");

	      if (js instanceof _base_stream.BaseStream) {
	        js = js.getString();
	      } else if (typeof js !== "string") {
	        return;
	      }

	      if (javaScript === null) {
	        javaScript = new Map();
	      }

	      js = (0, _util.stringToPDFString)(js).replace(/\u0000/g, "");
	      javaScript.set(name, js);
	    }

	    if (obj instanceof _primitives.Dict && obj.has("JavaScript")) {
	      const nameTree = new _name_number_tree.NameTree(obj.getRaw("JavaScript"), this.xref);

	      for (const [key, value] of nameTree.getAll()) {
	        appendIfJavaScriptDict((0, _util.stringToPDFString)(key), value);
	      }
	    }

	    const openAction = this._catDict.get("OpenAction");

	    if (openAction) {
	      appendIfJavaScriptDict("OpenAction", openAction);
	    }

	    return javaScript;
	  }

	  get javaScript() {
	    const javaScript = this._collectJavaScript();

	    return (0, _util.shadow)(this, "javaScript", javaScript ? [...javaScript.values()] : null);
	  }

	  get jsActions() {
	    const javaScript = this._collectJavaScript();

	    let actions = (0, _core_utils.collectActions)(this.xref, this._catDict, _util.DocumentActionEventType);

	    if (javaScript) {
	      if (!actions) {
	        actions = Object.create(null);
	      }

	      for (const [key, val] of javaScript) {
	        if (key in actions) {
	          actions[key].push(val);
	        } else {
	          actions[key] = [val];
	        }
	      }
	    }

	    return (0, _util.shadow)(this, "jsActions", actions);
	  }

	  async fontFallback(id, handler) {
	    const translatedFonts = await Promise.all(this.fontCache);

	    for (const translatedFont of translatedFonts) {
	      if (translatedFont.loadedName === id) {
	        translatedFont.fallback(handler);
	        return;
	      }
	    }
	  }

	  async cleanup(manuallyTriggered = false) {
	    (0, _cleanup_helper.clearGlobalCaches)();
	    this.globalImageCache.clear(manuallyTriggered);
	    this.pageKidsCountCache.clear();
	    this.pageIndexCache.clear();
	    this.nonBlendModesSet.clear();
	    const translatedFonts = await Promise.all(this.fontCache);

	    for (const {
	      dict
	    } of translatedFonts) {
	      delete dict.cacheKey;
	    }

	    this.fontCache.clear();
	    this.builtInCMapCache.clear();
	    this.standardFontDataCache.clear();
	  }

	  async getPageDict(pageIndex) {
	    const nodesToVisit = [this.toplevelPagesDict];
	    const visitedNodes = new _primitives.RefSet();

	    const pagesRef = this._catDict.getRaw("Pages");

	    if (pagesRef instanceof _primitives.Ref) {
	      visitedNodes.put(pagesRef);
	    }

	    const xref = this.xref,
	          pageKidsCountCache = this.pageKidsCountCache,
	          pageIndexCache = this.pageIndexCache;
	    let currentPageIndex = 0;

	    while (nodesToVisit.length) {
	      const currentNode = nodesToVisit.pop();

	      if (currentNode instanceof _primitives.Ref) {
	        const count = pageKidsCountCache.get(currentNode);

	        if (count >= 0 && currentPageIndex + count <= pageIndex) {
	          currentPageIndex += count;
	          continue;
	        }

	        if (visitedNodes.has(currentNode)) {
	          throw new _util.FormatError("Pages tree contains circular reference.");
	        }

	        visitedNodes.put(currentNode);
	        const obj = await xref.fetchAsync(currentNode);

	        if (obj instanceof _primitives.Dict) {
	          let type = obj.getRaw("Type");

	          if (type instanceof _primitives.Ref) {
	            type = await xref.fetchAsync(type);
	          }

	          if ((0, _primitives.isName)(type, "Page") || !obj.has("Kids")) {
	            if (!pageKidsCountCache.has(currentNode)) {
	              pageKidsCountCache.put(currentNode, 1);
	            }

	            if (!pageIndexCache.has(currentNode)) {
	              pageIndexCache.put(currentNode, currentPageIndex);
	            }

	            if (currentPageIndex === pageIndex) {
	              return [obj, currentNode];
	            }

	            currentPageIndex++;
	            continue;
	          }
	        }

	        nodesToVisit.push(obj);
	        continue;
	      }

	      if (!(currentNode instanceof _primitives.Dict)) {
	        throw new _util.FormatError("Page dictionary kid reference points to wrong type of object.");
	      }

	      const {
	        objId
	      } = currentNode;
	      let count = currentNode.getRaw("Count");

	      if (count instanceof _primitives.Ref) {
	        count = await xref.fetchAsync(count);
	      }

	      if (Number.isInteger(count) && count >= 0) {
	        if (objId && !pageKidsCountCache.has(objId)) {
	          pageKidsCountCache.put(objId, count);
	        }

	        if (currentPageIndex + count <= pageIndex) {
	          currentPageIndex += count;
	          continue;
	        }
	      }

	      let kids = currentNode.getRaw("Kids");

	      if (kids instanceof _primitives.Ref) {
	        kids = await xref.fetchAsync(kids);
	      }

	      if (!Array.isArray(kids)) {
	        let type = currentNode.getRaw("Type");

	        if (type instanceof _primitives.Ref) {
	          type = await xref.fetchAsync(type);
	        }

	        if ((0, _primitives.isName)(type, "Page") || !currentNode.has("Kids")) {
	          if (currentPageIndex === pageIndex) {
	            return [currentNode, null];
	          }

	          currentPageIndex++;
	          continue;
	        }

	        throw new _util.FormatError("Page dictionary kids object is not an array.");
	      }

	      for (let last = kids.length - 1; last >= 0; last--) {
	        nodesToVisit.push(kids[last]);
	      }
	    }

	    throw new Error(`Page index ${pageIndex} not found.`);
	  }

	  async getAllPageDicts(recoveryMode = false) {
	    const queue = [{
	      currentNode: this.toplevelPagesDict,
	      posInKids: 0
	    }];
	    const visitedNodes = new _primitives.RefSet();

	    const pagesRef = this._catDict.getRaw("Pages");

	    if (pagesRef instanceof _primitives.Ref) {
	      visitedNodes.put(pagesRef);
	    }

	    const map = new Map(),
	          xref = this.xref,
	          pageIndexCache = this.pageIndexCache;
	    let pageIndex = 0;

	    function addPageDict(pageDict, pageRef) {
	      if (pageRef && !pageIndexCache.has(pageRef)) {
	        pageIndexCache.put(pageRef, pageIndex);
	      }

	      map.set(pageIndex++, [pageDict, pageRef]);
	    }

	    function addPageError(error) {
	      if (error instanceof _core_utils.XRefEntryException && !recoveryMode) {
	        throw error;
	      }

	      map.set(pageIndex++, [error, null]);
	    }

	    while (queue.length > 0) {
	      const queueItem = queue.at(-1);
	      const {
	        currentNode,
	        posInKids
	      } = queueItem;
	      let kids = currentNode.getRaw("Kids");

	      if (kids instanceof _primitives.Ref) {
	        try {
	          kids = await xref.fetchAsync(kids);
	        } catch (ex) {
	          addPageError(ex);
	          break;
	        }
	      }

	      if (!Array.isArray(kids)) {
	        addPageError(new _util.FormatError("Page dictionary kids object is not an array."));
	        break;
	      }

	      if (posInKids >= kids.length) {
	        queue.pop();
	        continue;
	      }

	      const kidObj = kids[posInKids];
	      let obj;

	      if (kidObj instanceof _primitives.Ref) {
	        if (visitedNodes.has(kidObj)) {
	          addPageError(new _util.FormatError("Pages tree contains circular reference."));
	          break;
	        }

	        visitedNodes.put(kidObj);

	        try {
	          obj = await xref.fetchAsync(kidObj);
	        } catch (ex) {
	          addPageError(ex);
	          break;
	        }
	      } else {
	        obj = kidObj;
	      }

	      if (!(obj instanceof _primitives.Dict)) {
	        addPageError(new _util.FormatError("Page dictionary kid reference points to wrong type of object."));
	        break;
	      }

	      let type = obj.getRaw("Type");

	      if (type instanceof _primitives.Ref) {
	        try {
	          type = await xref.fetchAsync(type);
	        } catch (ex) {
	          addPageError(ex);
	          break;
	        }
	      }

	      if ((0, _primitives.isName)(type, "Page") || !obj.has("Kids")) {
	        addPageDict(obj, kidObj instanceof _primitives.Ref ? kidObj : null);
	      } else {
	        queue.push({
	          currentNode: obj,
	          posInKids: 0
	        });
	      }

	      queueItem.posInKids++;
	    }

	    return map;
	  }

	  getPageIndex(pageRef) {
	    const cachedPageIndex = this.pageIndexCache.get(pageRef);

	    if (cachedPageIndex !== undefined) {
	      return Promise.resolve(cachedPageIndex);
	    }

	    const xref = this.xref;

	    function pagesBeforeRef(kidRef) {
	      let total = 0,
	          parentRef;
	      return xref.fetchAsync(kidRef).then(function (node) {
	        if ((0, _primitives.isRefsEqual)(kidRef, pageRef) && !(0, _primitives.isDict)(node, "Page") && !(node instanceof _primitives.Dict && !node.has("Type") && node.has("Contents"))) {
	          throw new _util.FormatError("The reference does not point to a /Page dictionary.");
	        }

	        if (!node) {
	          return null;
	        }

	        if (!(node instanceof _primitives.Dict)) {
	          throw new _util.FormatError("Node must be a dictionary.");
	        }

	        parentRef = node.getRaw("Parent");
	        return node.getAsync("Parent");
	      }).then(function (parent) {
	        if (!parent) {
	          return null;
	        }

	        if (!(parent instanceof _primitives.Dict)) {
	          throw new _util.FormatError("Parent must be a dictionary.");
	        }

	        return parent.getAsync("Kids");
	      }).then(function (kids) {
	        if (!kids) {
	          return null;
	        }

	        const kidPromises = [];
	        let found = false;

	        for (let i = 0, ii = kids.length; i < ii; i++) {
	          const kid = kids[i];

	          if (!(kid instanceof _primitives.Ref)) {
	            throw new _util.FormatError("Kid must be a reference.");
	          }

	          if ((0, _primitives.isRefsEqual)(kid, kidRef)) {
	            found = true;
	            break;
	          }

	          kidPromises.push(xref.fetchAsync(kid).then(function (obj) {
	            if (!(obj instanceof _primitives.Dict)) {
	              throw new _util.FormatError("Kid node must be a dictionary.");
	            }

	            if (obj.has("Count")) {
	              total += obj.get("Count");
	            } else {
	              total++;
	            }
	          }));
	        }

	        if (!found) {
	          throw new _util.FormatError("Kid reference not found in parent's kids.");
	        }

	        return Promise.all(kidPromises).then(function () {
	          return [total, parentRef];
	        });
	      });
	    }

	    let total = 0;

	    const next = ref => pagesBeforeRef(ref).then(args => {
	      if (!args) {
	        this.pageIndexCache.put(pageRef, total);
	        return total;
	      }

	      const [count, parentRef] = args;
	      total += count;
	      return next(parentRef);
	    });

	    return next(pageRef);
	  }

	  get baseUrl() {
	    const uri = this._catDict.get("URI");

	    if (uri instanceof _primitives.Dict) {
	      const base = uri.get("Base");

	      if (typeof base === "string") {
	        const absoluteUrl = (0, _util.createValidAbsoluteUrl)(base, null, {
	          tryConvertEncoding: true
	        });

	        if (absoluteUrl) {
	          return (0, _util.shadow)(this, "baseUrl", absoluteUrl.href);
	        }
	      }
	    }

	    return (0, _util.shadow)(this, "baseUrl", null);
	  }

	  static parseDestDictionary(params) {
	    const destDict = params.destDict;

	    if (!(destDict instanceof _primitives.Dict)) {
	      (0, _util.warn)("parseDestDictionary: `destDict` must be a dictionary.");
	      return;
	    }

	    const resultObj = params.resultObj;

	    if (typeof resultObj !== "object") {
	      (0, _util.warn)("parseDestDictionary: `resultObj` must be an object.");
	      return;
	    }

	    const docBaseUrl = params.docBaseUrl || null;
	    let action = destDict.get("A"),
	        url,
	        dest;

	    if (!(action instanceof _primitives.Dict)) {
	      if (destDict.has("Dest")) {
	        action = destDict.get("Dest");
	      } else {
	        action = destDict.get("AA");

	        if (action instanceof _primitives.Dict) {
	          if (action.has("D")) {
	            action = action.get("D");
	          } else if (action.has("U")) {
	            action = action.get("U");
	          }
	        }
	      }
	    }

	    if (action instanceof _primitives.Dict) {
	      const actionType = action.get("S");

	      if (!(actionType instanceof _primitives.Name)) {
	        (0, _util.warn)("parseDestDictionary: Invalid type in Action dictionary.");
	        return;
	      }

	      const actionName = actionType.name;

	      switch (actionName) {
	        case "ResetForm":
	          const flags = action.get("Flags");
	          const include = ((typeof flags === "number" ? flags : 0) & 1) === 0;
	          const fields = [];
	          const refs = [];

	          for (const obj of action.get("Fields") || []) {
	            if (obj instanceof _primitives.Ref) {
	              refs.push(obj.toString());
	            } else if (typeof obj === "string") {
	              fields.push((0, _util.stringToPDFString)(obj));
	            }
	          }

	          resultObj.resetForm = {
	            fields,
	            refs,
	            include
	          };
	          break;

	        case "URI":
	          url = action.get("URI");

	          if (url instanceof _primitives.Name) {
	            url = "/" + url.name;
	          }

	          break;

	        case "GoTo":
	          dest = action.get("D");
	          break;

	        case "Launch":
	        case "GoToR":
	          const urlDict = action.get("F");

	          if (urlDict instanceof _primitives.Dict) {
	            url = urlDict.get("F") || null;
	          } else if (typeof urlDict === "string") {
	            url = urlDict;
	          }

	          let remoteDest = action.get("D");

	          if (remoteDest) {
	            if (remoteDest instanceof _primitives.Name) {
	              remoteDest = remoteDest.name;
	            }

	            if (typeof url === "string") {
	              const baseUrl = url.split("#")[0];

	              if (typeof remoteDest === "string") {
	                url = baseUrl + "#" + remoteDest;
	              } else if (Array.isArray(remoteDest)) {
	                url = baseUrl + "#" + JSON.stringify(remoteDest);
	              }
	            }
	          }

	          const newWindow = action.get("NewWindow");

	          if (typeof newWindow === "boolean") {
	            resultObj.newWindow = newWindow;
	          }

	          break;

	        case "Named":
	          const namedAction = action.get("N");

	          if (namedAction instanceof _primitives.Name) {
	            resultObj.action = namedAction.name;
	          }

	          break;

	        case "JavaScript":
	          const jsAction = action.get("JS");
	          let js;

	          if (jsAction instanceof _base_stream.BaseStream) {
	            js = jsAction.getString();
	          } else if (typeof jsAction === "string") {
	            js = jsAction;
	          }

	          const jsURL = js && (0, _core_utils.recoverJsURL)((0, _util.stringToPDFString)(js));

	          if (jsURL) {
	            url = jsURL.url;
	            resultObj.newWindow = jsURL.newWindow;
	            break;
	          }

	        default:
	          if (actionName === "JavaScript" || actionName === "SubmitForm") {
	            break;
	          }

	          (0, _util.warn)(`parseDestDictionary - unsupported action: "${actionName}".`);
	          break;
	      }
	    } else if (destDict.has("Dest")) {
	      dest = destDict.get("Dest");
	    }

	    if (typeof url === "string") {
	      const absoluteUrl = (0, _util.createValidAbsoluteUrl)(url, docBaseUrl, {
	        addDefaultProtocol: true,
	        tryConvertEncoding: true
	      });

	      if (absoluteUrl) {
	        resultObj.url = absoluteUrl.href;
	      }

	      resultObj.unsafeUrl = url;
	    }

	    if (dest) {
	      if (dest instanceof _primitives.Name) {
	        dest = dest.name;
	      }

	      if (typeof dest === "string") {
	        resultObj.dest = (0, _util.stringToPDFString)(dest);
	      } else if (Array.isArray(dest)) {
	        resultObj.dest = dest;
	      }
	    }
	  }

	}

	exports.Catalog = Catalog;

	/***/ }),
	/* 70 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.NumberTree = exports.NameTree = void 0;

	var _primitives = __w_pdfjs_require__(5);

	var _util = __w_pdfjs_require__(2);

	class NameOrNumberTree {
	  constructor(root, xref, type) {
	    if (this.constructor === NameOrNumberTree) {
	      (0, _util.unreachable)("Cannot initialize NameOrNumberTree.");
	    }

	    this.root = root;
	    this.xref = xref;
	    this._type = type;
	  }

	  getAll() {
	    const map = new Map();

	    if (!this.root) {
	      return map;
	    }

	    const xref = this.xref;
	    const processed = new _primitives.RefSet();
	    processed.put(this.root);
	    const queue = [this.root];

	    while (queue.length > 0) {
	      const obj = xref.fetchIfRef(queue.shift());

	      if (!(obj instanceof _primitives.Dict)) {
	        continue;
	      }

	      if (obj.has("Kids")) {
	        const kids = obj.get("Kids");

	        if (!Array.isArray(kids)) {
	          continue;
	        }

	        for (const kid of kids) {
	          if (processed.has(kid)) {
	            throw new _util.FormatError(`Duplicate entry in "${this._type}" tree.`);
	          }

	          queue.push(kid);
	          processed.put(kid);
	        }

	        continue;
	      }

	      const entries = obj.get(this._type);

	      if (!Array.isArray(entries)) {
	        continue;
	      }

	      for (let i = 0, ii = entries.length; i < ii; i += 2) {
	        map.set(xref.fetchIfRef(entries[i]), xref.fetchIfRef(entries[i + 1]));
	      }
	    }

	    return map;
	  }

	  get(key) {
	    if (!this.root) {
	      return null;
	    }

	    const xref = this.xref;
	    let kidsOrEntries = xref.fetchIfRef(this.root);
	    let loopCount = 0;
	    const MAX_LEVELS = 10;

	    while (kidsOrEntries.has("Kids")) {
	      if (++loopCount > MAX_LEVELS) {
	        (0, _util.warn)(`Search depth limit reached for "${this._type}" tree.`);
	        return null;
	      }

	      const kids = kidsOrEntries.get("Kids");

	      if (!Array.isArray(kids)) {
	        return null;
	      }

	      let l = 0,
	          r = kids.length - 1;

	      while (l <= r) {
	        const m = l + r >> 1;
	        const kid = xref.fetchIfRef(kids[m]);
	        const limits = kid.get("Limits");

	        if (key < xref.fetchIfRef(limits[0])) {
	          r = m - 1;
	        } else if (key > xref.fetchIfRef(limits[1])) {
	          l = m + 1;
	        } else {
	          kidsOrEntries = kid;
	          break;
	        }
	      }

	      if (l > r) {
	        return null;
	      }
	    }

	    const entries = kidsOrEntries.get(this._type);

	    if (Array.isArray(entries)) {
	      let l = 0,
	          r = entries.length - 2;

	      while (l <= r) {
	        const tmp = l + r >> 1,
	              m = tmp + (tmp & 1);
	        const currentKey = xref.fetchIfRef(entries[m]);

	        if (key < currentKey) {
	          r = m - 2;
	        } else if (key > currentKey) {
	          l = m + 2;
	        } else {
	          return xref.fetchIfRef(entries[m + 1]);
	        }
	      }
	    }

	    return null;
	  }

	}

	class NameTree extends NameOrNumberTree {
	  constructor(root, xref) {
	    super(root, xref, "Names");
	  }

	}

	exports.NameTree = NameTree;

	class NumberTree extends NameOrNumberTree {
	  constructor(root, xref) {
	    super(root, xref, "Nums");
	  }

	}

	exports.NumberTree = NumberTree;

	/***/ }),
	/* 71 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.clearGlobalCaches = clearGlobalCaches;

	var _primitives = __w_pdfjs_require__(5);

	var _unicode = __w_pdfjs_require__(40);

	function clearGlobalCaches() {
	  (0, _primitives.clearPrimitiveCaches)();
	  (0, _unicode.clearUnicodeCaches)();
	}

	/***/ }),
	/* 72 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.FileSpec = void 0;

	var _util = __w_pdfjs_require__(2);

	var _base_stream = __w_pdfjs_require__(7);

	var _primitives = __w_pdfjs_require__(5);

	function pickPlatformItem(dict) {
	  if (dict.has("UF")) {
	    return dict.get("UF");
	  } else if (dict.has("F")) {
	    return dict.get("F");
	  } else if (dict.has("Unix")) {
	    return dict.get("Unix");
	  } else if (dict.has("Mac")) {
	    return dict.get("Mac");
	  } else if (dict.has("DOS")) {
	    return dict.get("DOS");
	  }

	  return null;
	}

	class FileSpec {
	  constructor(root, xref) {
	    if (!(root instanceof _primitives.Dict)) {
	      return;
	    }

	    this.xref = xref;
	    this.root = root;

	    if (root.has("FS")) {
	      this.fs = root.get("FS");
	    }

	    this.description = root.has("Desc") ? (0, _util.stringToPDFString)(root.get("Desc")) : "";

	    if (root.has("RF")) {
	      (0, _util.warn)("Related file specifications are not supported");
	    }

	    this.contentAvailable = true;

	    if (!root.has("EF")) {
	      this.contentAvailable = false;
	      (0, _util.warn)("Non-embedded file specifications are not supported");
	    }
	  }

	  get filename() {
	    if (!this._filename && this.root) {
	      const filename = pickPlatformItem(this.root) || "unnamed";
	      this._filename = (0, _util.stringToPDFString)(filename).replace(/\\\\/g, "\\").replace(/\\\//g, "/").replace(/\\/g, "/");
	    }

	    return this._filename;
	  }

	  get content() {
	    if (!this.contentAvailable) {
	      return null;
	    }

	    if (!this.contentRef && this.root) {
	      this.contentRef = pickPlatformItem(this.root.get("EF"));
	    }

	    let content = null;

	    if (this.contentRef) {
	      const fileObj = this.xref.fetchIfRef(this.contentRef);

	      if (fileObj instanceof _base_stream.BaseStream) {
	        content = fileObj.getBytes();
	      } else {
	        (0, _util.warn)("Embedded file specification points to non-existing/invalid content");
	      }
	    } else {
	      (0, _util.warn)("Embedded file specification does not have a content");
	    }

	    return content;
	  }

	  get serializable() {
	    return {
	      filename: this.filename,
	      content: this.content
	    };
	  }

	}

	exports.FileSpec = FileSpec;

	/***/ }),
	/* 73 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.MetadataParser = void 0;

	var _xml_parser = __w_pdfjs_require__(66);

	class MetadataParser {
	  constructor(data) {
	    data = this._repair(data);
	    const parser = new _xml_parser.SimpleXMLParser({
	      lowerCaseName: true
	    });
	    const xmlDocument = parser.parseFromString(data);
	    this._metadataMap = new Map();
	    this._data = data;

	    if (xmlDocument) {
	      this._parse(xmlDocument);
	    }
	  }

	  _repair(data) {
	    return data.replace(/^[^<]+/, "").replace(/>\\376\\377([^<]+)/g, function (all, codes) {
	      const bytes = codes.replace(/\\([0-3])([0-7])([0-7])/g, function (code, d1, d2, d3) {
	        return String.fromCharCode(d1 * 64 + d2 * 8 + d3 * 1);
	      }).replace(/&(amp|apos|gt|lt|quot);/g, function (str, name) {
	        switch (name) {
	          case "amp":
	            return "&";

	          case "apos":
	            return "'";

	          case "gt":
	            return ">";

	          case "lt":
	            return "<";

	          case "quot":
	            return '"';
	        }

	        throw new Error(`_repair: ${name} isn't defined.`);
	      });
	      const charBuf = [];

	      for (let i = 0, ii = bytes.length; i < ii; i += 2) {
	        const code = bytes.charCodeAt(i) * 256 + bytes.charCodeAt(i + 1);

	        if (code >= 32 && code < 127 && code !== 60 && code !== 62 && code !== 38) {
	          charBuf.push(String.fromCharCode(code));
	        } else {
	          charBuf.push("&#x" + (0x10000 + code).toString(16).substring(1) + ";");
	        }
	      }

	      return ">" + charBuf.join("");
	    });
	  }

	  _getSequence(entry) {
	    const name = entry.nodeName;

	    if (name !== "rdf:bag" && name !== "rdf:seq" && name !== "rdf:alt") {
	      return null;
	    }

	    return entry.childNodes.filter(node => node.nodeName === "rdf:li");
	  }

	  _parseArray(entry) {
	    if (!entry.hasChildNodes()) {
	      return;
	    }

	    const [seqNode] = entry.childNodes;
	    const sequence = this._getSequence(seqNode) || [];

	    this._metadataMap.set(entry.nodeName, sequence.map(node => node.textContent.trim()));
	  }

	  _parse(xmlDocument) {
	    let rdf = xmlDocument.documentElement;

	    if (rdf.nodeName !== "rdf:rdf") {
	      rdf = rdf.firstChild;

	      while (rdf && rdf.nodeName !== "rdf:rdf") {
	        rdf = rdf.nextSibling;
	      }
	    }

	    if (!rdf || rdf.nodeName !== "rdf:rdf" || !rdf.hasChildNodes()) {
	      return;
	    }

	    for (const desc of rdf.childNodes) {
	      if (desc.nodeName !== "rdf:description") {
	        continue;
	      }

	      for (const entry of desc.childNodes) {
	        const name = entry.nodeName;

	        switch (name) {
	          case "#text":
	            continue;

	          case "dc:creator":
	          case "dc:subject":
	            this._parseArray(entry);

	            continue;
	        }

	        this._metadataMap.set(name, entry.textContent.trim());
	      }
	    }
	  }

	  get serializable() {
	    return {
	      parsedData: this._metadataMap,
	      rawData: this._data
	    };
	  }

	}

	exports.MetadataParser = MetadataParser;

	/***/ }),
	/* 74 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.StructTreeRoot = exports.StructTreePage = void 0;

	var _primitives = __w_pdfjs_require__(5);

	var _util = __w_pdfjs_require__(2);

	var _name_number_tree = __w_pdfjs_require__(70);

	const MAX_DEPTH = 40;
	const StructElementType = {
	  PAGE_CONTENT: "PAGE_CONTENT",
	  STREAM_CONTENT: "STREAM_CONTENT",
	  OBJECT: "OBJECT",
	  ELEMENT: "ELEMENT"
	};

	class StructTreeRoot {
	  constructor(rootDict) {
	    this.dict = rootDict;
	    this.roleMap = new Map();
	  }

	  init() {
	    this.readRoleMap();
	  }

	  readRoleMap() {
	    const roleMapDict = this.dict.get("RoleMap");

	    if (!(roleMapDict instanceof _primitives.Dict)) {
	      return;
	    }

	    roleMapDict.forEach((key, value) => {
	      if (!(value instanceof _primitives.Name)) {
	        return;
	      }

	      this.roleMap.set(key, value.name);
	    });
	  }

	}

	exports.StructTreeRoot = StructTreeRoot;

	class StructElementNode {
	  constructor(tree, dict) {
	    this.tree = tree;
	    this.dict = dict;
	    this.kids = [];
	    this.parseKids();
	  }

	  get role() {
	    const nameObj = this.dict.get("S");
	    const name = nameObj instanceof _primitives.Name ? nameObj.name : "";
	    const {
	      root
	    } = this.tree;

	    if (root.roleMap.has(name)) {
	      return root.roleMap.get(name);
	    }

	    return name;
	  }

	  parseKids() {
	    let pageObjId = null;
	    const objRef = this.dict.getRaw("Pg");

	    if (objRef instanceof _primitives.Ref) {
	      pageObjId = objRef.toString();
	    }

	    const kids = this.dict.get("K");

	    if (Array.isArray(kids)) {
	      for (const kid of kids) {
	        const element = this.parseKid(pageObjId, kid);

	        if (element) {
	          this.kids.push(element);
	        }
	      }
	    } else {
	      const element = this.parseKid(pageObjId, kids);

	      if (element) {
	        this.kids.push(element);
	      }
	    }
	  }

	  parseKid(pageObjId, kid) {
	    if (Number.isInteger(kid)) {
	      if (this.tree.pageDict.objId !== pageObjId) {
	        return null;
	      }

	      return new StructElement({
	        type: StructElementType.PAGE_CONTENT,
	        mcid: kid,
	        pageObjId
	      });
	    }

	    let kidDict = null;

	    if (kid instanceof _primitives.Ref) {
	      kidDict = this.dict.xref.fetch(kid);
	    } else if (kid instanceof _primitives.Dict) {
	      kidDict = kid;
	    }

	    if (!kidDict) {
	      return null;
	    }

	    const pageRef = kidDict.getRaw("Pg");

	    if (pageRef instanceof _primitives.Ref) {
	      pageObjId = pageRef.toString();
	    }

	    const type = kidDict.get("Type") instanceof _primitives.Name ? kidDict.get("Type").name : null;

	    if (type === "MCR") {
	      if (this.tree.pageDict.objId !== pageObjId) {
	        return null;
	      }

	      return new StructElement({
	        type: StructElementType.STREAM_CONTENT,
	        refObjId: kidDict.getRaw("Stm") instanceof _primitives.Ref ? kidDict.getRaw("Stm").toString() : null,
	        pageObjId,
	        mcid: kidDict.get("MCID")
	      });
	    }

	    if (type === "OBJR") {
	      if (this.tree.pageDict.objId !== pageObjId) {
	        return null;
	      }

	      return new StructElement({
	        type: StructElementType.OBJECT,
	        refObjId: kidDict.getRaw("Obj") instanceof _primitives.Ref ? kidDict.getRaw("Obj").toString() : null,
	        pageObjId
	      });
	    }

	    return new StructElement({
	      type: StructElementType.ELEMENT,
	      dict: kidDict
	    });
	  }

	}

	class StructElement {
	  constructor({
	    type,
	    dict = null,
	    mcid = null,
	    pageObjId = null,
	    refObjId = null
	  }) {
	    this.type = type;
	    this.dict = dict;
	    this.mcid = mcid;
	    this.pageObjId = pageObjId;
	    this.refObjId = refObjId;
	    this.parentNode = null;
	  }

	}

	class StructTreePage {
	  constructor(structTreeRoot, pageDict) {
	    this.root = structTreeRoot;
	    this.rootDict = structTreeRoot ? structTreeRoot.dict : null;
	    this.pageDict = pageDict;
	    this.nodes = [];
	  }

	  parse() {
	    if (!this.root || !this.rootDict) {
	      return;
	    }

	    const parentTree = this.rootDict.get("ParentTree");

	    if (!parentTree) {
	      return;
	    }

	    const id = this.pageDict.get("StructParents");

	    if (!Number.isInteger(id)) {
	      return;
	    }

	    const numberTree = new _name_number_tree.NumberTree(parentTree, this.rootDict.xref);
	    const parentArray = numberTree.get(id);

	    if (!Array.isArray(parentArray)) {
	      return;
	    }

	    const map = new Map();

	    for (const ref of parentArray) {
	      if (ref instanceof _primitives.Ref) {
	        this.addNode(this.rootDict.xref.fetch(ref), map);
	      }
	    }
	  }

	  addNode(dict, map, level = 0) {
	    if (level > MAX_DEPTH) {
	      (0, _util.warn)("StructTree MAX_DEPTH reached.");
	      return null;
	    }

	    if (map.has(dict)) {
	      return map.get(dict);
	    }

	    const element = new StructElementNode(this, dict);
	    map.set(dict, element);
	    const parent = dict.get("P");

	    if (!parent || (0, _primitives.isName)(parent.get("Type"), "StructTreeRoot")) {
	      if (!this.addTopLevelNode(dict, element)) {
	        map.delete(dict);
	      }

	      return element;
	    }

	    const parentNode = this.addNode(parent, map, level + 1);

	    if (!parentNode) {
	      return element;
	    }

	    let save = false;

	    for (const kid of parentNode.kids) {
	      if (kid.type === StructElementType.ELEMENT && kid.dict === dict) {
	        kid.parentNode = element;
	        save = true;
	      }
	    }

	    if (!save) {
	      map.delete(dict);
	    }

	    return element;
	  }

	  addTopLevelNode(dict, element) {
	    const obj = this.rootDict.get("K");

	    if (!obj) {
	      return false;
	    }

	    if (obj instanceof _primitives.Dict) {
	      if (obj.objId !== dict.objId) {
	        return false;
	      }

	      this.nodes[0] = element;
	      return true;
	    }

	    if (!Array.isArray(obj)) {
	      return true;
	    }

	    let save = false;

	    for (let i = 0; i < obj.length; i++) {
	      const kidRef = obj[i];

	      if (kidRef && kidRef.toString() === dict.objId) {
	        this.nodes[i] = element;
	        save = true;
	      }
	    }

	    return save;
	  }

	  get serializable() {
	    function nodeToSerializable(node, parent, level = 0) {
	      if (level > MAX_DEPTH) {
	        (0, _util.warn)("StructTree too deep to be fully serialized.");
	        return;
	      }

	      const obj = Object.create(null);
	      obj.role = node.role;
	      obj.children = [];
	      parent.children.push(obj);
	      const alt = node.dict.get("Alt");

	      if (typeof alt === "string") {
	        obj.alt = (0, _util.stringToPDFString)(alt);
	      }

	      const lang = node.dict.get("Lang");

	      if (typeof lang === "string") {
	        obj.lang = (0, _util.stringToPDFString)(lang);
	      }

	      for (const kid of node.kids) {
	        const kidElement = kid.type === StructElementType.ELEMENT ? kid.parentNode : null;

	        if (kidElement) {
	          nodeToSerializable(kidElement, obj, level + 1);
	          continue;
	        } else if (kid.type === StructElementType.PAGE_CONTENT || kid.type === StructElementType.STREAM_CONTENT) {
	          obj.children.push({
	            type: "content",
	            id: `page${kid.pageObjId}_mcid${kid.mcid}`
	          });
	        } else if (kid.type === StructElementType.OBJECT) {
	          obj.children.push({
	            type: "object",
	            id: kid.refObjId
	          });
	        }
	      }
	    }

	    const root = Object.create(null);
	    root.children = [];
	    root.role = "Root";

	    for (const child of this.nodes) {
	      if (!child) {
	        continue;
	      }

	      nodeToSerializable(child, root);
	    }

	    return root;
	  }

	}

	exports.StructTreePage = StructTreePage;

	/***/ }),
	/* 75 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ObjectLoader = void 0;

	var _primitives = __w_pdfjs_require__(5);

	var _base_stream = __w_pdfjs_require__(7);

	var _core_utils = __w_pdfjs_require__(6);

	var _util = __w_pdfjs_require__(2);

	function mayHaveChildren(value) {
	  return value instanceof _primitives.Ref || value instanceof _primitives.Dict || value instanceof _base_stream.BaseStream || Array.isArray(value);
	}

	function addChildren(node, nodesToVisit) {
	  if (node instanceof _primitives.Dict) {
	    node = node.getRawValues();
	  } else if (node instanceof _base_stream.BaseStream) {
	    node = node.dict.getRawValues();
	  } else if (!Array.isArray(node)) {
	    return;
	  }

	  for (const rawValue of node) {
	    if (mayHaveChildren(rawValue)) {
	      nodesToVisit.push(rawValue);
	    }
	  }
	}

	class ObjectLoader {
	  constructor(dict, keys, xref) {
	    this.dict = dict;
	    this.keys = keys;
	    this.xref = xref;
	    this.refSet = null;
	  }

	  async load() {
	    if (this.xref.stream.isDataLoaded) {
	      return undefined;
	    }

	    const {
	      keys,
	      dict
	    } = this;
	    this.refSet = new _primitives.RefSet();
	    const nodesToVisit = [];

	    for (let i = 0, ii = keys.length; i < ii; i++) {
	      const rawValue = dict.getRaw(keys[i]);

	      if (rawValue !== undefined) {
	        nodesToVisit.push(rawValue);
	      }
	    }

	    return this._walk(nodesToVisit);
	  }

	  async _walk(nodesToVisit) {
	    const nodesToRevisit = [];
	    const pendingRequests = [];

	    while (nodesToVisit.length) {
	      let currentNode = nodesToVisit.pop();

	      if (currentNode instanceof _primitives.Ref) {
	        if (this.refSet.has(currentNode)) {
	          continue;
	        }

	        try {
	          this.refSet.put(currentNode);
	          currentNode = this.xref.fetch(currentNode);
	        } catch (ex) {
	          if (!(ex instanceof _core_utils.MissingDataException)) {
	            (0, _util.warn)(`ObjectLoader._walk - requesting all data: "${ex}".`);
	            this.refSet = null;
	            const {
	              manager
	            } = this.xref.stream;
	            return manager.requestAllChunks();
	          }

	          nodesToRevisit.push(currentNode);
	          pendingRequests.push({
	            begin: ex.begin,
	            end: ex.end
	          });
	        }
	      }

	      if (currentNode instanceof _base_stream.BaseStream) {
	        const baseStreams = currentNode.getBaseStreams();

	        if (baseStreams) {
	          let foundMissingData = false;

	          for (const stream of baseStreams) {
	            if (stream.isDataLoaded) {
	              continue;
	            }

	            foundMissingData = true;
	            pendingRequests.push({
	              begin: stream.start,
	              end: stream.end
	            });
	          }

	          if (foundMissingData) {
	            nodesToRevisit.push(currentNode);
	          }
	        }
	      }

	      addChildren(currentNode, nodesToVisit);
	    }

	    if (pendingRequests.length) {
	      await this.xref.stream.manager.requestRanges(pendingRequests);

	      for (const node of nodesToRevisit) {
	        if (node instanceof _primitives.Ref) {
	          this.refSet.remove(node);
	        }
	      }

	      return this._walk(nodesToRevisit);
	    }

	    this.refSet = null;
	    return undefined;
	  }

	}

	exports.ObjectLoader = ObjectLoader;

	/***/ }),
	/* 76 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XFAFactory = void 0;

	var _xfa_object = __w_pdfjs_require__(77);

	var _bind = __w_pdfjs_require__(81);

	var _data = __w_pdfjs_require__(87);

	var _fonts = __w_pdfjs_require__(85);

	var _utils = __w_pdfjs_require__(78);

	var _util = __w_pdfjs_require__(2);

	var _parser = __w_pdfjs_require__(88);

	var _xhtml = __w_pdfjs_require__(98);

	class XFAFactory {
	  constructor(data) {
	    try {
	      this.root = new _parser.XFAParser().parse(XFAFactory._createDocument(data));
	      const binder = new _bind.Binder(this.root);
	      this.form = binder.bind();
	      this.dataHandler = new _data.DataHandler(this.root, binder.getData());
	      this.form[_xfa_object.$globalData].template = this.form;
	    } catch (e) {
	      (0, _util.warn)(`XFA - an error occurred during parsing and binding: ${e}`);
	    }
	  }

	  isValid() {
	    return this.root && this.form;
	  }

	  _createPagesHelper() {
	    const iterator = this.form[_xfa_object.$toPages]();

	    return new Promise((resolve, reject) => {
	      const nextIteration = () => {
	        try {
	          const value = iterator.next();

	          if (value.done) {
	            resolve(value.value);
	          } else {
	            setTimeout(nextIteration, 0);
	          }
	        } catch (e) {
	          reject(e);
	        }
	      };

	      setTimeout(nextIteration, 0);
	    });
	  }

	  async _createPages() {
	    try {
	      this.pages = await this._createPagesHelper();
	      this.dims = this.pages.children.map(c => {
	        const {
	          width,
	          height
	        } = c.attributes.style;
	        return [0, 0, parseInt(width), parseInt(height)];
	      });
	    } catch (e) {
	      (0, _util.warn)(`XFA - an error occurred during layout: ${e}`);
	    }
	  }

	  getBoundingBox(pageIndex) {
	    return this.dims[pageIndex];
	  }

	  async getNumPages() {
	    if (!this.pages) {
	      await this._createPages();
	    }

	    return this.dims.length;
	  }

	  setImages(images) {
	    this.form[_xfa_object.$globalData].images = images;
	  }

	  setFonts(fonts) {
	    this.form[_xfa_object.$globalData].fontFinder = new _fonts.FontFinder(fonts);
	    const missingFonts = [];

	    for (let typeface of this.form[_xfa_object.$globalData].usedTypefaces) {
	      typeface = (0, _utils.stripQuotes)(typeface);

	      const font = this.form[_xfa_object.$globalData].fontFinder.find(typeface);

	      if (!font) {
	        missingFonts.push(typeface);
	      }
	    }

	    if (missingFonts.length > 0) {
	      return missingFonts;
	    }

	    return null;
	  }

	  appendFonts(fonts, reallyMissingFonts) {
	    this.form[_xfa_object.$globalData].fontFinder.add(fonts, reallyMissingFonts);
	  }

	  async getPages() {
	    if (!this.pages) {
	      await this._createPages();
	    }

	    const pages = this.pages;
	    this.pages = null;
	    return pages;
	  }

	  serializeData(storage) {
	    return this.dataHandler.serialize(storage);
	  }

	  static _createDocument(data) {
	    if (!data["/xdp:xdp"]) {
	      return data["xdp:xdp"];
	    }

	    return Object.values(data).join("");
	  }

	  static getRichTextAsHtml(rc) {
	    if (!rc || typeof rc !== "string") {
	      return null;
	    }

	    try {
	      let root = new _parser.XFAParser(_xhtml.XhtmlNamespace, true).parse(rc);

	      if (!["body", "xhtml"].includes(root[_xfa_object.$nodeName])) {
	        const newRoot = _xhtml.XhtmlNamespace.body({});

	        newRoot[_xfa_object.$appendChild](root);

	        root = newRoot;
	      }

	      const result = root[_xfa_object.$toHTML]();

	      if (!result.success) {
	        return null;
	      }

	      const {
	        html
	      } = result;
	      const {
	        attributes
	      } = html;

	      if (attributes) {
	        if (attributes.class) {
	          attributes.class = attributes.class.filter(attr => !attr.startsWith("xfa"));
	        }

	        attributes.dir = "auto";
	      }

	      return {
	        html,
	        str: root[_xfa_object.$text]()
	      };
	    } catch (e) {
	      (0, _util.warn)(`XFA - an error occurred during parsing of rich text: ${e}`);
	    }

	    return null;
	  }

	}

	exports.XFAFactory = XFAFactory;

	/***/ }),
	/* 77 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XmlObject = exports.XFAObjectArray = exports.XFAObject = exports.XFAAttribute = exports.StringObject = exports.OptionObject = exports.Option10 = exports.Option01 = exports.IntegerObject = exports.ContentObject = exports.$uid = exports.$toStyle = exports.$toString = exports.$toPages = exports.$toHTML = exports.$text = exports.$tabIndex = exports.$setValue = exports.$setSetAttributes = exports.$setId = exports.$searchNode = exports.$root = exports.$resolvePrototypes = exports.$removeChild = exports.$pushPara = exports.$pushGlyphs = exports.$popPara = exports.$onText = exports.$onChildCheck = exports.$onChild = exports.$nsAttributes = exports.$nodeName = exports.$namespaceId = exports.$isUsable = exports.$isTransparent = exports.$isThereMoreWidth = exports.$isSplittable = exports.$isNsAgnostic = exports.$isDescendent = exports.$isDataValue = exports.$isCDATAXml = exports.$isBindable = exports.$insertAt = exports.$indexOf = exports.$ids = exports.$hasSettableValue = exports.$globalData = exports.$getTemplateRoot = exports.$getSubformParent = exports.$getRealChildrenByNameIt = exports.$getParent = exports.$getNextPage = exports.$getExtra = exports.$getDataValue = exports.$getContainedChildren = exports.$getChildrenByNameIt = exports.$getChildrenByName = exports.$getChildrenByClass = exports.$getChildren = exports.$getAvailableSpace = exports.$getAttributes = exports.$getAttributeIt = exports.$flushHTML = exports.$finalize = exports.$extra = exports.$dump = exports.$data = exports.$content = exports.$consumed = exports.$clone = exports.$cleanup = exports.$cleanPage = exports.$clean = exports.$childrenToHTML = exports.$appendChild = exports.$addHTML = exports.$acceptWhitespace = void 0;

	var _utils = __w_pdfjs_require__(78);

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	var _namespaces = __w_pdfjs_require__(79);

	var _som = __w_pdfjs_require__(80);

	const $acceptWhitespace = Symbol();
	exports.$acceptWhitespace = $acceptWhitespace;
	const $addHTML = Symbol();
	exports.$addHTML = $addHTML;
	const $appendChild = Symbol();
	exports.$appendChild = $appendChild;
	const $childrenToHTML = Symbol();
	exports.$childrenToHTML = $childrenToHTML;
	const $clean = Symbol();
	exports.$clean = $clean;
	const $cleanPage = Symbol();
	exports.$cleanPage = $cleanPage;
	const $cleanup = Symbol();
	exports.$cleanup = $cleanup;
	const $clone = Symbol();
	exports.$clone = $clone;
	const $consumed = Symbol();
	exports.$consumed = $consumed;
	const $content = Symbol("content");
	exports.$content = $content;
	const $data = Symbol("data");
	exports.$data = $data;
	const $dump = Symbol();
	exports.$dump = $dump;
	const $extra = Symbol("extra");
	exports.$extra = $extra;
	const $finalize = Symbol();
	exports.$finalize = $finalize;
	const $flushHTML = Symbol();
	exports.$flushHTML = $flushHTML;
	const $getAttributeIt = Symbol();
	exports.$getAttributeIt = $getAttributeIt;
	const $getAttributes = Symbol();
	exports.$getAttributes = $getAttributes;
	const $getAvailableSpace = Symbol();
	exports.$getAvailableSpace = $getAvailableSpace;
	const $getChildrenByClass = Symbol();
	exports.$getChildrenByClass = $getChildrenByClass;
	const $getChildrenByName = Symbol();
	exports.$getChildrenByName = $getChildrenByName;
	const $getChildrenByNameIt = Symbol();
	exports.$getChildrenByNameIt = $getChildrenByNameIt;
	const $getDataValue = Symbol();
	exports.$getDataValue = $getDataValue;
	const $getExtra = Symbol();
	exports.$getExtra = $getExtra;
	const $getRealChildrenByNameIt = Symbol();
	exports.$getRealChildrenByNameIt = $getRealChildrenByNameIt;
	const $getChildren = Symbol();
	exports.$getChildren = $getChildren;
	const $getContainedChildren = Symbol();
	exports.$getContainedChildren = $getContainedChildren;
	const $getNextPage = Symbol();
	exports.$getNextPage = $getNextPage;
	const $getSubformParent = Symbol();
	exports.$getSubformParent = $getSubformParent;
	const $getParent = Symbol();
	exports.$getParent = $getParent;
	const $getTemplateRoot = Symbol();
	exports.$getTemplateRoot = $getTemplateRoot;
	const $globalData = Symbol();
	exports.$globalData = $globalData;
	const $hasSettableValue = Symbol();
	exports.$hasSettableValue = $hasSettableValue;
	const $ids = Symbol();
	exports.$ids = $ids;
	const $indexOf = Symbol();
	exports.$indexOf = $indexOf;
	const $insertAt = Symbol();
	exports.$insertAt = $insertAt;
	const $isCDATAXml = Symbol();
	exports.$isCDATAXml = $isCDATAXml;
	const $isBindable = Symbol();
	exports.$isBindable = $isBindable;
	const $isDataValue = Symbol();
	exports.$isDataValue = $isDataValue;
	const $isDescendent = Symbol();
	exports.$isDescendent = $isDescendent;
	const $isNsAgnostic = Symbol();
	exports.$isNsAgnostic = $isNsAgnostic;
	const $isSplittable = Symbol();
	exports.$isSplittable = $isSplittable;
	const $isThereMoreWidth = Symbol();
	exports.$isThereMoreWidth = $isThereMoreWidth;
	const $isTransparent = Symbol();
	exports.$isTransparent = $isTransparent;
	const $isUsable = Symbol();
	exports.$isUsable = $isUsable;
	const $lastAttribute = Symbol();
	const $namespaceId = Symbol("namespaceId");
	exports.$namespaceId = $namespaceId;
	const $nodeName = Symbol("nodeName");
	exports.$nodeName = $nodeName;
	const $nsAttributes = Symbol();
	exports.$nsAttributes = $nsAttributes;
	const $onChild = Symbol();
	exports.$onChild = $onChild;
	const $onChildCheck = Symbol();
	exports.$onChildCheck = $onChildCheck;
	const $onText = Symbol();
	exports.$onText = $onText;
	const $pushGlyphs = Symbol();
	exports.$pushGlyphs = $pushGlyphs;
	const $popPara = Symbol();
	exports.$popPara = $popPara;
	const $pushPara = Symbol();
	exports.$pushPara = $pushPara;
	const $removeChild = Symbol();
	exports.$removeChild = $removeChild;
	const $root = Symbol("root");
	exports.$root = $root;
	const $resolvePrototypes = Symbol();
	exports.$resolvePrototypes = $resolvePrototypes;
	const $searchNode = Symbol();
	exports.$searchNode = $searchNode;
	const $setId = Symbol();
	exports.$setId = $setId;
	const $setSetAttributes = Symbol();
	exports.$setSetAttributes = $setSetAttributes;
	const $setValue = Symbol();
	exports.$setValue = $setValue;
	const $tabIndex = Symbol();
	exports.$tabIndex = $tabIndex;
	const $text = Symbol();
	exports.$text = $text;
	const $toPages = Symbol();
	exports.$toPages = $toPages;
	const $toHTML = Symbol();
	exports.$toHTML = $toHTML;
	const $toString = Symbol();
	exports.$toString = $toString;
	const $toStyle = Symbol();
	exports.$toStyle = $toStyle;
	const $uid = Symbol("uid");
	exports.$uid = $uid;

	const _applyPrototype = Symbol();

	const _attributes = Symbol();

	const _attributeNames = Symbol();

	const _children = Symbol("_children");

	const _cloneAttribute = Symbol();

	const _dataValue = Symbol();

	const _defaultValue = Symbol();

	const _filteredChildrenGenerator = Symbol();

	const _getPrototype = Symbol();

	const _getUnsetAttributes = Symbol();

	const _hasChildren = Symbol();

	const _max = Symbol();

	const _options = Symbol();

	const _parent = Symbol("parent");

	const _resolvePrototypesHelper = Symbol();

	const _setAttributes = Symbol();

	const _validator = Symbol();

	let uid = 0;
	const NS_DATASETS = _namespaces.NamespaceIds.datasets.id;

	class XFAObject {
	  constructor(nsId, name, hasChildren = false) {
	    this[$namespaceId] = nsId;
	    this[$nodeName] = name;
	    this[_hasChildren] = hasChildren;
	    this[_parent] = null;
	    this[_children] = [];
	    this[$uid] = `${name}${uid++}`;
	    this[$globalData] = null;
	  }

	  [$onChild](child) {
	    if (!this[_hasChildren] || !this[$onChildCheck](child)) {
	      return false;
	    }

	    const name = child[$nodeName];
	    const node = this[name];

	    if (node instanceof XFAObjectArray) {
	      if (node.push(child)) {
	        this[$appendChild](child);
	        return true;
	      }
	    } else {
	      if (node !== null) {
	        this[$removeChild](node);
	      }

	      this[name] = child;
	      this[$appendChild](child);
	      return true;
	    }

	    let id = "";

	    if (this.id) {
	      id = ` (id: ${this.id})`;
	    } else if (this.name) {
	      id = ` (name: ${this.name} ${this.h.value})`;
	    }

	    (0, _util.warn)(`XFA - node "${this[$nodeName]}"${id} has already enough "${name}"!`);
	    return false;
	  }

	  [$onChildCheck](child) {
	    return this.hasOwnProperty(child[$nodeName]) && child[$namespaceId] === this[$namespaceId];
	  }

	  [$isNsAgnostic]() {
	    return false;
	  }

	  [$acceptWhitespace]() {
	    return false;
	  }

	  [$isCDATAXml]() {
	    return false;
	  }

	  [$isBindable]() {
	    return false;
	  }

	  [$popPara]() {
	    if (this.para) {
	      this[$getTemplateRoot]()[$extra].paraStack.pop();
	    }
	  }

	  [$pushPara]() {
	    this[$getTemplateRoot]()[$extra].paraStack.push(this.para);
	  }

	  [$setId](ids) {
	    if (this.id && this[$namespaceId] === _namespaces.NamespaceIds.template.id) {
	      ids.set(this.id, this);
	    }
	  }

	  [$getTemplateRoot]() {
	    return this[$globalData].template;
	  }

	  [$isSplittable]() {
	    return false;
	  }

	  [$isThereMoreWidth]() {
	    return false;
	  }

	  [$appendChild](child) {
	    child[_parent] = this;

	    this[_children].push(child);

	    if (!child[$globalData] && this[$globalData]) {
	      child[$globalData] = this[$globalData];
	    }
	  }

	  [$removeChild](child) {
	    const i = this[_children].indexOf(child);

	    this[_children].splice(i, 1);
	  }

	  [$hasSettableValue]() {
	    return this.hasOwnProperty("value");
	  }

	  [$setValue](_) {}

	  [$onText](_) {}

	  [$finalize]() {}

	  [$clean](builder) {
	    delete this[_hasChildren];

	    if (this[$cleanup]) {
	      builder.clean(this[$cleanup]);
	      delete this[$cleanup];
	    }
	  }

	  [$indexOf](child) {
	    return this[_children].indexOf(child);
	  }

	  [$insertAt](i, child) {
	    child[_parent] = this;

	    this[_children].splice(i, 0, child);

	    if (!child[$globalData] && this[$globalData]) {
	      child[$globalData] = this[$globalData];
	    }
	  }

	  [$isTransparent]() {
	    return !this.name;
	  }

	  [$lastAttribute]() {
	    return "";
	  }

	  [$text]() {
	    if (this[_children].length === 0) {
	      return this[$content];
	    }

	    return this[_children].map(c => c[$text]()).join("");
	  }

	  get [_attributeNames]() {
	    const proto = Object.getPrototypeOf(this);

	    if (!proto._attributes) {
	      const attributes = proto._attributes = new Set();

	      for (const name of Object.getOwnPropertyNames(this)) {
	        if (this[name] === null || this[name] instanceof XFAObject || this[name] instanceof XFAObjectArray) {
	          break;
	        }

	        attributes.add(name);
	      }
	    }

	    return (0, _util.shadow)(this, _attributeNames, proto._attributes);
	  }

	  [$isDescendent](parent) {
	    let node = this;

	    while (node) {
	      if (node === parent) {
	        return true;
	      }

	      node = node[$getParent]();
	    }

	    return false;
	  }

	  [$getParent]() {
	    return this[_parent];
	  }

	  [$getSubformParent]() {
	    return this[$getParent]();
	  }

	  [$getChildren](name = null) {
	    if (!name) {
	      return this[_children];
	    }

	    return this[name];
	  }

	  [$dump]() {
	    const dumped = Object.create(null);

	    if (this[$content]) {
	      dumped.$content = this[$content];
	    }

	    for (const name of Object.getOwnPropertyNames(this)) {
	      const value = this[name];

	      if (value === null) {
	        continue;
	      }

	      if (value instanceof XFAObject) {
	        dumped[name] = value[$dump]();
	      } else if (value instanceof XFAObjectArray) {
	        if (!value.isEmpty()) {
	          dumped[name] = value.dump();
	        }
	      } else {
	        dumped[name] = value;
	      }
	    }

	    return dumped;
	  }

	  [$toStyle]() {
	    return null;
	  }

	  [$toHTML]() {
	    return _utils.HTMLResult.EMPTY;
	  }

	  *[$getContainedChildren]() {
	    for (const node of this[$getChildren]()) {
	      yield node;
	    }
	  }

	  *[_filteredChildrenGenerator](filter, include) {
	    for (const node of this[$getContainedChildren]()) {
	      if (!filter || include === filter.has(node[$nodeName])) {
	        const availableSpace = this[$getAvailableSpace]();
	        const res = node[$toHTML](availableSpace);

	        if (!res.success) {
	          this[$extra].failingNode = node;
	        }

	        yield res;
	      }
	    }
	  }

	  [$flushHTML]() {
	    return null;
	  }

	  [$addHTML](html, bbox) {
	    this[$extra].children.push(html);
	  }

	  [$getAvailableSpace]() {}

	  [$childrenToHTML]({
	    filter = null,
	    include = true
	  }) {
	    if (!this[$extra].generator) {
	      this[$extra].generator = this[_filteredChildrenGenerator](filter, include);
	    } else {
	      const availableSpace = this[$getAvailableSpace]();
	      const res = this[$extra].failingNode[$toHTML](availableSpace);

	      if (!res.success) {
	        return res;
	      }

	      if (res.html) {
	        this[$addHTML](res.html, res.bbox);
	      }

	      delete this[$extra].failingNode;
	    }

	    while (true) {
	      const gen = this[$extra].generator.next();

	      if (gen.done) {
	        break;
	      }

	      const res = gen.value;

	      if (!res.success) {
	        return res;
	      }

	      if (res.html) {
	        this[$addHTML](res.html, res.bbox);
	      }
	    }

	    this[$extra].generator = null;
	    return _utils.HTMLResult.EMPTY;
	  }

	  [$setSetAttributes](attributes) {
	    this[_setAttributes] = new Set(Object.keys(attributes));
	  }

	  [_getUnsetAttributes](protoAttributes) {
	    const allAttr = this[_attributeNames];
	    const setAttr = this[_setAttributes];
	    return [...protoAttributes].filter(x => allAttr.has(x) && !setAttr.has(x));
	  }

	  [$resolvePrototypes](ids, ancestors = new Set()) {
	    for (const child of this[_children]) {
	      child[_resolvePrototypesHelper](ids, ancestors);
	    }
	  }

	  [_resolvePrototypesHelper](ids, ancestors) {
	    const proto = this[_getPrototype](ids, ancestors);

	    if (proto) {
	      this[_applyPrototype](proto, ids, ancestors);
	    } else {
	      this[$resolvePrototypes](ids, ancestors);
	    }
	  }

	  [_getPrototype](ids, ancestors) {
	    const {
	      use,
	      usehref
	    } = this;

	    if (!use && !usehref) {
	      return null;
	    }

	    let proto = null;
	    let somExpression = null;
	    let id = null;
	    let ref = use;

	    if (usehref) {
	      ref = usehref;

	      if (usehref.startsWith("#som(") && usehref.endsWith(")")) {
	        somExpression = usehref.slice("#som(".length, usehref.length - 1);
	      } else if (usehref.startsWith(".#som(") && usehref.endsWith(")")) {
	        somExpression = usehref.slice(".#som(".length, usehref.length - 1);
	      } else if (usehref.startsWith("#")) {
	        id = usehref.slice(1);
	      } else if (usehref.startsWith(".#")) {
	        id = usehref.slice(2);
	      }
	    } else if (use.startsWith("#")) {
	      id = use.slice(1);
	    } else {
	      somExpression = use;
	    }

	    this.use = this.usehref = "";

	    if (id) {
	      proto = ids.get(id);
	    } else {
	      proto = (0, _som.searchNode)(ids.get($root), this, somExpression, true, false);

	      if (proto) {
	        proto = proto[0];
	      }
	    }

	    if (!proto) {
	      (0, _util.warn)(`XFA - Invalid prototype reference: ${ref}.`);
	      return null;
	    }

	    if (proto[$nodeName] !== this[$nodeName]) {
	      (0, _util.warn)(`XFA - Incompatible prototype: ${proto[$nodeName]} !== ${this[$nodeName]}.`);
	      return null;
	    }

	    if (ancestors.has(proto)) {
	      (0, _util.warn)(`XFA - Cycle detected in prototypes use.`);
	      return null;
	    }

	    ancestors.add(proto);

	    const protoProto = proto[_getPrototype](ids, ancestors);

	    if (protoProto) {
	      proto[_applyPrototype](protoProto, ids, ancestors);
	    }

	    proto[$resolvePrototypes](ids, ancestors);
	    ancestors.delete(proto);
	    return proto;
	  }

	  [_applyPrototype](proto, ids, ancestors) {
	    if (ancestors.has(proto)) {
	      (0, _util.warn)(`XFA - Cycle detected in prototypes use.`);
	      return;
	    }

	    if (!this[$content] && proto[$content]) {
	      this[$content] = proto[$content];
	    }

	    const newAncestors = new Set(ancestors);
	    newAncestors.add(proto);

	    for (const unsetAttrName of this[_getUnsetAttributes](proto[_setAttributes])) {
	      this[unsetAttrName] = proto[unsetAttrName];

	      if (this[_setAttributes]) {
	        this[_setAttributes].add(unsetAttrName);
	      }
	    }

	    for (const name of Object.getOwnPropertyNames(this)) {
	      if (this[_attributeNames].has(name)) {
	        continue;
	      }

	      const value = this[name];
	      const protoValue = proto[name];

	      if (value instanceof XFAObjectArray) {
	        for (const child of value[_children]) {
	          child[_resolvePrototypesHelper](ids, ancestors);
	        }

	        for (let i = value[_children].length, ii = protoValue[_children].length; i < ii; i++) {
	          const child = proto[_children][i][$clone]();

	          if (value.push(child)) {
	            child[_parent] = this;

	            this[_children].push(child);

	            child[_resolvePrototypesHelper](ids, ancestors);
	          } else {
	            break;
	          }
	        }

	        continue;
	      }

	      if (value !== null) {
	        value[$resolvePrototypes](ids, ancestors);

	        if (protoValue) {
	          value[_applyPrototype](protoValue, ids, ancestors);
	        }

	        continue;
	      }

	      if (protoValue !== null) {
	        const child = protoValue[$clone]();
	        child[_parent] = this;
	        this[name] = child;

	        this[_children].push(child);

	        child[_resolvePrototypesHelper](ids, ancestors);
	      }
	    }
	  }

	  static [_cloneAttribute](obj) {
	    if (Array.isArray(obj)) {
	      return obj.map(x => XFAObject[_cloneAttribute](x));
	    }

	    if (typeof obj === "object" && obj !== null) {
	      return Object.assign({}, obj);
	    }

	    return obj;
	  }

	  [$clone]() {
	    const clone = Object.create(Object.getPrototypeOf(this));

	    for (const $symbol of Object.getOwnPropertySymbols(this)) {
	      try {
	        clone[$symbol] = this[$symbol];
	      } catch (_) {
	        (0, _util.shadow)(clone, $symbol, this[$symbol]);
	      }
	    }

	    clone[$uid] = `${clone[$nodeName]}${uid++}`;
	    clone[_children] = [];

	    for (const name of Object.getOwnPropertyNames(this)) {
	      if (this[_attributeNames].has(name)) {
	        clone[name] = XFAObject[_cloneAttribute](this[name]);
	        continue;
	      }

	      const value = this[name];

	      if (value instanceof XFAObjectArray) {
	        clone[name] = new XFAObjectArray(value[_max]);
	      } else {
	        clone[name] = null;
	      }
	    }

	    for (const child of this[_children]) {
	      const name = child[$nodeName];
	      const clonedChild = child[$clone]();

	      clone[_children].push(clonedChild);

	      clonedChild[_parent] = clone;

	      if (clone[name] === null) {
	        clone[name] = clonedChild;
	      } else {
	        clone[name][_children].push(clonedChild);
	      }
	    }

	    return clone;
	  }

	  [$getChildren](name = null) {
	    if (!name) {
	      return this[_children];
	    }

	    return this[_children].filter(c => c[$nodeName] === name);
	  }

	  [$getChildrenByClass](name) {
	    return this[name];
	  }

	  [$getChildrenByName](name, allTransparent, first = true) {
	    return Array.from(this[$getChildrenByNameIt](name, allTransparent, first));
	  }

	  *[$getChildrenByNameIt](name, allTransparent, first = true) {
	    if (name === "parent") {
	      yield this[_parent];
	      return;
	    }

	    for (const child of this[_children]) {
	      if (child[$nodeName] === name) {
	        yield child;
	      }

	      if (child.name === name) {
	        yield child;
	      }

	      if (allTransparent || child[$isTransparent]()) {
	        yield* child[$getChildrenByNameIt](name, allTransparent, false);
	      }
	    }

	    if (first && this[_attributeNames].has(name)) {
	      yield new XFAAttribute(this, name, this[name]);
	    }
	  }

	}

	exports.XFAObject = XFAObject;

	class XFAObjectArray {
	  constructor(max = Infinity) {
	    this[_max] = max;
	    this[_children] = [];
	  }

	  push(child) {
	    const len = this[_children].length;

	    if (len <= this[_max]) {
	      this[_children].push(child);

	      return true;
	    }

	    (0, _util.warn)(`XFA - node "${child[$nodeName]}" accepts no more than ${this[_max]} children`);
	    return false;
	  }

	  isEmpty() {
	    return this[_children].length === 0;
	  }

	  dump() {
	    return this[_children].length === 1 ? this[_children][0][$dump]() : this[_children].map(x => x[$dump]());
	  }

	  [$clone]() {
	    const clone = new XFAObjectArray(this[_max]);
	    clone[_children] = this[_children].map(c => c[$clone]());
	    return clone;
	  }

	  get children() {
	    return this[_children];
	  }

	  clear() {
	    this[_children].length = 0;
	  }

	}

	exports.XFAObjectArray = XFAObjectArray;

	class XFAAttribute {
	  constructor(node, name, value) {
	    this[_parent] = node;
	    this[$nodeName] = name;
	    this[$content] = value;
	    this[$consumed] = false;
	    this[$uid] = `attribute${uid++}`;
	  }

	  [$getParent]() {
	    return this[_parent];
	  }

	  [$isDataValue]() {
	    return true;
	  }

	  [$getDataValue]() {
	    return this[$content].trim();
	  }

	  [$setValue](value) {
	    value = value.value || "";
	    this[$content] = value.toString();
	  }

	  [$text]() {
	    return this[$content];
	  }

	  [$isDescendent](parent) {
	    return this[_parent] === parent || this[_parent][$isDescendent](parent);
	  }

	}

	exports.XFAAttribute = XFAAttribute;

	class XmlObject extends XFAObject {
	  constructor(nsId, name, attributes = {}) {
	    super(nsId, name);
	    this[$content] = "";
	    this[_dataValue] = null;

	    if (name !== "#text") {
	      const map = new Map();
	      this[_attributes] = map;

	      for (const [attrName, value] of Object.entries(attributes)) {
	        map.set(attrName, new XFAAttribute(this, attrName, value));
	      }

	      if (attributes.hasOwnProperty($nsAttributes)) {
	        const dataNode = attributes[$nsAttributes].xfa.dataNode;

	        if (dataNode !== undefined) {
	          if (dataNode === "dataGroup") {
	            this[_dataValue] = false;
	          } else if (dataNode === "dataValue") {
	            this[_dataValue] = true;
	          }
	        }
	      }
	    }

	    this[$consumed] = false;
	  }

	  [$toString](buf) {
	    const tagName = this[$nodeName];

	    if (tagName === "#text") {
	      buf.push((0, _core_utils.encodeToXmlString)(this[$content]));
	      return;
	    }

	    const utf8TagName = (0, _util.utf8StringToString)(tagName);
	    const prefix = this[$namespaceId] === NS_DATASETS ? "xfa:" : "";
	    buf.push(`<${prefix}${utf8TagName}`);

	    for (const [name, value] of this[_attributes].entries()) {
	      const utf8Name = (0, _util.utf8StringToString)(name);
	      buf.push(` ${utf8Name}="${(0, _core_utils.encodeToXmlString)(value[$content])}"`);
	    }

	    if (this[_dataValue] !== null) {
	      if (this[_dataValue]) {
	        buf.push(` xfa:dataNode="dataValue"`);
	      } else {
	        buf.push(` xfa:dataNode="dataGroup"`);
	      }
	    }

	    if (!this[$content] && this[_children].length === 0) {
	      buf.push("/>");
	      return;
	    }

	    buf.push(">");

	    if (this[$content]) {
	      if (typeof this[$content] === "string") {
	        buf.push((0, _core_utils.encodeToXmlString)(this[$content]));
	      } else {
	        this[$content][$toString](buf);
	      }
	    } else {
	      for (const child of this[_children]) {
	        child[$toString](buf);
	      }
	    }

	    buf.push(`</${prefix}${utf8TagName}>`);
	  }

	  [$onChild](child) {
	    if (this[$content]) {
	      const node = new XmlObject(this[$namespaceId], "#text");
	      this[$appendChild](node);
	      node[$content] = this[$content];
	      this[$content] = "";
	    }

	    this[$appendChild](child);
	    return true;
	  }

	  [$onText](str) {
	    this[$content] += str;
	  }

	  [$finalize]() {
	    if (this[$content] && this[_children].length > 0) {
	      const node = new XmlObject(this[$namespaceId], "#text");
	      this[$appendChild](node);
	      node[$content] = this[$content];
	      delete this[$content];
	    }
	  }

	  [$toHTML]() {
	    if (this[$nodeName] === "#text") {
	      return _utils.HTMLResult.success({
	        name: "#text",
	        value: this[$content]
	      });
	    }

	    return _utils.HTMLResult.EMPTY;
	  }

	  [$getChildren](name = null) {
	    if (!name) {
	      return this[_children];
	    }

	    return this[_children].filter(c => c[$nodeName] === name);
	  }

	  [$getAttributes]() {
	    return this[_attributes];
	  }

	  [$getChildrenByClass](name) {
	    const value = this[_attributes].get(name);

	    if (value !== undefined) {
	      return value;
	    }

	    return this[$getChildren](name);
	  }

	  *[$getChildrenByNameIt](name, allTransparent) {
	    const value = this[_attributes].get(name);

	    if (value) {
	      yield value;
	    }

	    for (const child of this[_children]) {
	      if (child[$nodeName] === name) {
	        yield child;
	      }

	      if (allTransparent) {
	        yield* child[$getChildrenByNameIt](name, allTransparent);
	      }
	    }
	  }

	  *[$getAttributeIt](name, skipConsumed) {
	    const value = this[_attributes].get(name);

	    if (value && (!skipConsumed || !value[$consumed])) {
	      yield value;
	    }

	    for (const child of this[_children]) {
	      yield* child[$getAttributeIt](name, skipConsumed);
	    }
	  }

	  *[$getRealChildrenByNameIt](name, allTransparent, skipConsumed) {
	    for (const child of this[_children]) {
	      if (child[$nodeName] === name && (!skipConsumed || !child[$consumed])) {
	        yield child;
	      }

	      if (allTransparent) {
	        yield* child[$getRealChildrenByNameIt](name, allTransparent, skipConsumed);
	      }
	    }
	  }

	  [$isDataValue]() {
	    if (this[_dataValue] === null) {
	      return this[_children].length === 0 || this[_children][0][$namespaceId] === _namespaces.NamespaceIds.xhtml.id;
	    }

	    return this[_dataValue];
	  }

	  [$getDataValue]() {
	    if (this[_dataValue] === null) {
	      if (this[_children].length === 0) {
	        return this[$content].trim();
	      }

	      if (this[_children][0][$namespaceId] === _namespaces.NamespaceIds.xhtml.id) {
	        return this[_children][0][$text]().trim();
	      }

	      return null;
	    }

	    return this[$content].trim();
	  }

	  [$setValue](value) {
	    value = value.value || "";
	    this[$content] = value.toString();
	  }

	  [$dump](hasNS = false) {
	    const dumped = Object.create(null);

	    if (hasNS) {
	      dumped.$ns = this[$namespaceId];
	    }

	    if (this[$content]) {
	      dumped.$content = this[$content];
	    }

	    dumped.$name = this[$nodeName];
	    dumped.children = [];

	    for (const child of this[_children]) {
	      dumped.children.push(child[$dump](hasNS));
	    }

	    dumped.attributes = Object.create(null);

	    for (const [name, value] of this[_attributes]) {
	      dumped.attributes[name] = value[$content];
	    }

	    return dumped;
	  }

	}

	exports.XmlObject = XmlObject;

	class ContentObject extends XFAObject {
	  constructor(nsId, name) {
	    super(nsId, name);
	    this[$content] = "";
	  }

	  [$onText](text) {
	    this[$content] += text;
	  }

	  [$finalize]() {}

	}

	exports.ContentObject = ContentObject;

	class OptionObject extends ContentObject {
	  constructor(nsId, name, options) {
	    super(nsId, name);
	    this[_options] = options;
	  }

	  [$finalize]() {
	    this[$content] = (0, _utils.getKeyword)({
	      data: this[$content],
	      defaultValue: this[_options][0],
	      validate: k => this[_options].includes(k)
	    });
	  }

	  [$clean](builder) {
	    super[$clean](builder);
	    delete this[_options];
	  }

	}

	exports.OptionObject = OptionObject;

	class StringObject extends ContentObject {
	  [$finalize]() {
	    this[$content] = this[$content].trim();
	  }

	}

	exports.StringObject = StringObject;

	class IntegerObject extends ContentObject {
	  constructor(nsId, name, defaultValue, validator) {
	    super(nsId, name);
	    this[_defaultValue] = defaultValue;
	    this[_validator] = validator;
	  }

	  [$finalize]() {
	    this[$content] = (0, _utils.getInteger)({
	      data: this[$content],
	      defaultValue: this[_defaultValue],
	      validate: this[_validator]
	    });
	  }

	  [$clean](builder) {
	    super[$clean](builder);
	    delete this[_defaultValue];
	    delete this[_validator];
	  }

	}

	exports.IntegerObject = IntegerObject;

	class Option01 extends IntegerObject {
	  constructor(nsId, name) {
	    super(nsId, name, 0, n => n === 1);
	  }

	}

	exports.Option01 = Option01;

	class Option10 extends IntegerObject {
	  constructor(nsId, name) {
	    super(nsId, name, 1, n => n === 0);
	  }

	}

	exports.Option10 = Option10;

	/***/ }),
	/* 78 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.HTMLResult = void 0;
	exports.getBBox = getBBox;
	exports.getColor = getColor;
	exports.getFloat = getFloat;
	exports.getInteger = getInteger;
	exports.getKeyword = getKeyword;
	exports.getMeasurement = getMeasurement;
	exports.getRatio = getRatio;
	exports.getRelevant = getRelevant;
	exports.getStringOption = getStringOption;
	exports.stripQuotes = stripQuotes;

	var _util = __w_pdfjs_require__(2);

	const dimConverters = {
	  pt: x => x,
	  cm: x => x / 2.54 * 72,
	  mm: x => x / (10 * 2.54) * 72,
	  in: x => x * 72,
	  px: x => x
	};
	const measurementPattern = /([+-]?\d+\.?\d*)(.*)/;

	function stripQuotes(str) {
	  if (str.startsWith("'") || str.startsWith('"')) {
	    return str.slice(1, str.length - 1);
	  }

	  return str;
	}

	function getInteger({
	  data,
	  defaultValue,
	  validate
	}) {
	  if (!data) {
	    return defaultValue;
	  }

	  data = data.trim();
	  const n = parseInt(data, 10);

	  if (!isNaN(n) && validate(n)) {
	    return n;
	  }

	  return defaultValue;
	}

	function getFloat({
	  data,
	  defaultValue,
	  validate
	}) {
	  if (!data) {
	    return defaultValue;
	  }

	  data = data.trim();
	  const n = parseFloat(data);

	  if (!isNaN(n) && validate(n)) {
	    return n;
	  }

	  return defaultValue;
	}

	function getKeyword({
	  data,
	  defaultValue,
	  validate
	}) {
	  if (!data) {
	    return defaultValue;
	  }

	  data = data.trim();

	  if (validate(data)) {
	    return data;
	  }

	  return defaultValue;
	}

	function getStringOption(data, options) {
	  return getKeyword({
	    data,
	    defaultValue: options[0],
	    validate: k => options.includes(k)
	  });
	}

	function getMeasurement(str, def = "0") {
	  def = def || "0";

	  if (!str) {
	    return getMeasurement(def);
	  }

	  const match = str.trim().match(measurementPattern);

	  if (!match) {
	    return getMeasurement(def);
	  }

	  const [, valueStr, unit] = match;
	  const value = parseFloat(valueStr);

	  if (isNaN(value)) {
	    return getMeasurement(def);
	  }

	  if (value === 0) {
	    return 0;
	  }

	  const conv = dimConverters[unit];

	  if (conv) {
	    return conv(value);
	  }

	  return value;
	}

	function getRatio(data) {
	  if (!data) {
	    return {
	      num: 1,
	      den: 1
	    };
	  }

	  const ratio = data.trim().split(/\s*:\s*/).map(x => parseFloat(x)).filter(x => !isNaN(x));

	  if (ratio.length === 1) {
	    ratio.push(1);
	  }

	  if (ratio.length === 0) {
	    return {
	      num: 1,
	      den: 1
	    };
	  }

	  const [num, den] = ratio;
	  return {
	    num,
	    den
	  };
	}

	function getRelevant(data) {
	  if (!data) {
	    return [];
	  }

	  return data.trim().split(/\s+/).map(e => {
	    return {
	      excluded: e[0] === "-",
	      viewname: e.substring(1)
	    };
	  });
	}

	function getColor(data, def = [0, 0, 0]) {
	  let [r, g, b] = def;

	  if (!data) {
	    return {
	      r,
	      g,
	      b
	    };
	  }

	  const color = data.trim().split(/\s*,\s*/).map(c => Math.min(Math.max(0, parseInt(c.trim(), 10)), 255)).map(c => isNaN(c) ? 0 : c);

	  if (color.length < 3) {
	    return {
	      r,
	      g,
	      b
	    };
	  }

	  [r, g, b] = color;
	  return {
	    r,
	    g,
	    b
	  };
	}

	function getBBox(data) {
	  const def = -1;

	  if (!data) {
	    return {
	      x: def,
	      y: def,
	      width: def,
	      height: def
	    };
	  }

	  const bbox = data.trim().split(/\s*,\s*/).map(m => getMeasurement(m, "-1"));

	  if (bbox.length < 4 || bbox[2] < 0 || bbox[3] < 0) {
	    return {
	      x: def,
	      y: def,
	      width: def,
	      height: def
	    };
	  }

	  const [x, y, width, height] = bbox;
	  return {
	    x,
	    y,
	    width,
	    height
	  };
	}

	class HTMLResult {
	  static get FAILURE() {
	    return (0, _util.shadow)(this, "FAILURE", new HTMLResult(false, null, null, null));
	  }

	  static get EMPTY() {
	    return (0, _util.shadow)(this, "EMPTY", new HTMLResult(true, null, null, null));
	  }

	  constructor(success, html, bbox, breakNode) {
	    this.success = success;
	    this.html = html;
	    this.bbox = bbox;
	    this.breakNode = breakNode;
	  }

	  isBreak() {
	    return !!this.breakNode;
	  }

	  static breakNode(node) {
	    return new HTMLResult(false, null, null, node);
	  }

	  static success(html, bbox = null) {
	    return new HTMLResult(true, html, bbox, null);
	  }

	}

	exports.HTMLResult = HTMLResult;

	/***/ }),
	/* 79 */
	/***/ ((__unused_webpack_module, exports) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.NamespaceIds = exports.$buildXFAObject = void 0;
	const $buildXFAObject = Symbol();
	exports.$buildXFAObject = $buildXFAObject;
	const NamespaceIds = {
	  config: {
	    id: 0,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xci/")
	  },
	  connectionSet: {
	    id: 1,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xfa-connection-set/")
	  },
	  datasets: {
	    id: 2,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xfa-data/")
	  },
	  form: {
	    id: 3,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xfa-form/")
	  },
	  localeSet: {
	    id: 4,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xfa-locale-set/")
	  },
	  pdf: {
	    id: 5,
	    check: ns => ns === "http://ns.adobe.com/xdp/pdf/"
	  },
	  signature: {
	    id: 6,
	    check: ns => ns === "http://www.w3.org/2000/09/xmldsig#"
	  },
	  sourceSet: {
	    id: 7,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xfa-source-set/")
	  },
	  stylesheet: {
	    id: 8,
	    check: ns => ns === "http://www.w3.org/1999/XSL/Transform"
	  },
	  template: {
	    id: 9,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xfa-template/")
	  },
	  xdc: {
	    id: 10,
	    check: ns => ns.startsWith("http://www.xfa.org/schema/xdc/")
	  },
	  xdp: {
	    id: 11,
	    check: ns => ns === "http://ns.adobe.com/xdp/"
	  },
	  xfdf: {
	    id: 12,
	    check: ns => ns === "http://ns.adobe.com/xfdf/"
	  },
	  xhtml: {
	    id: 13,
	    check: ns => ns === "http://www.w3.org/1999/xhtml"
	  },
	  xmpmeta: {
	    id: 14,
	    check: ns => ns === "http://ns.adobe.com/xmpmeta/"
	  }
	};
	exports.NamespaceIds = NamespaceIds;

	/***/ }),
	/* 80 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.createDataNode = createDataNode;
	exports.searchNode = searchNode;

	var _xfa_object = __w_pdfjs_require__(77);

	var _namespaces = __w_pdfjs_require__(79);

	var _util = __w_pdfjs_require__(2);

	const namePattern = /^[^.[]+/;
	const indexPattern = /^[^\]]+/;
	const operators = {
	  dot: 0,
	  dotDot: 1,
	  dotHash: 2,
	  dotBracket: 3,
	  dotParen: 4
	};
	const shortcuts = new Map([["$data", (root, current) => root.datasets ? root.datasets.data : root], ["$record", (root, current) => (root.datasets ? root.datasets.data : root)[_xfa_object.$getChildren]()[0]], ["$template", (root, current) => root.template], ["$connectionSet", (root, current) => root.connectionSet], ["$form", (root, current) => root.form], ["$layout", (root, current) => root.layout], ["$host", (root, current) => root.host], ["$dataWindow", (root, current) => root.dataWindow], ["$event", (root, current) => root.event], ["!", (root, current) => root.datasets], ["$xfa", (root, current) => root], ["xfa", (root, current) => root], ["$", (root, current) => current]]);
	const somCache = new WeakMap();
	const NS_DATASETS = _namespaces.NamespaceIds.datasets.id;

	function parseIndex(index) {
	  index = index.trim();

	  if (index === "*") {
	    return Infinity;
	  }

	  return parseInt(index, 10) || 0;
	}

	function parseExpression(expr, dotDotAllowed, noExpr = true) {
	  let match = expr.match(namePattern);

	  if (!match) {
	    return null;
	  }

	  let [name] = match;
	  const parsed = [{
	    name,
	    cacheName: "." + name,
	    index: 0,
	    js: null,
	    formCalc: null,
	    operator: operators.dot
	  }];
	  let pos = name.length;

	  while (pos < expr.length) {
	    const spos = pos;
	    const char = expr.charAt(pos++);

	    if (char === "[") {
	      match = expr.slice(pos).match(indexPattern);

	      if (!match) {
	        (0, _util.warn)("XFA - Invalid index in SOM expression");
	        return null;
	      }

	      parsed.at(-1).index = parseIndex(match[0]);
	      pos += match[0].length + 1;
	      continue;
	    }

	    let operator;

	    switch (expr.charAt(pos)) {
	      case ".":
	        if (!dotDotAllowed) {
	          return null;
	        }

	        pos++;
	        operator = operators.dotDot;
	        break;

	      case "#":
	        pos++;
	        operator = operators.dotHash;
	        break;

	      case "[":
	        if (noExpr) {
	          (0, _util.warn)("XFA - SOM expression contains a FormCalc subexpression which is not supported for now.");
	          return null;
	        }

	        operator = operators.dotBracket;
	        break;

	      case "(":
	        if (noExpr) {
	          (0, _util.warn)("XFA - SOM expression contains a JavaScript subexpression which is not supported for now.");
	          return null;
	        }

	        operator = operators.dotParen;
	        break;

	      default:
	        operator = operators.dot;
	        break;
	    }

	    match = expr.slice(pos).match(namePattern);

	    if (!match) {
	      break;
	    }

	    [name] = match;
	    pos += name.length;
	    parsed.push({
	      name,
	      cacheName: expr.slice(spos, pos),
	      operator,
	      index: 0,
	      js: null,
	      formCalc: null
	    });
	  }

	  return parsed;
	}

	function searchNode(root, container, expr, dotDotAllowed = true, useCache = true) {
	  const parsed = parseExpression(expr, dotDotAllowed);

	  if (!parsed) {
	    return null;
	  }

	  const fn = shortcuts.get(parsed[0].name);
	  let i = 0;
	  let isQualified;

	  if (fn) {
	    isQualified = true;
	    root = [fn(root, container)];
	    i = 1;
	  } else {
	    isQualified = container === null;
	    root = [container || root];
	  }

	  for (let ii = parsed.length; i < ii; i++) {
	    const {
	      name,
	      cacheName,
	      operator,
	      index
	    } = parsed[i];
	    const nodes = [];

	    for (const node of root) {
	      if (!(node instanceof _xfa_object.XFAObject)) {
	        continue;
	      }

	      let children, cached;

	      if (useCache) {
	        cached = somCache.get(node);

	        if (!cached) {
	          cached = new Map();
	          somCache.set(node, cached);
	        }

	        children = cached.get(cacheName);
	      }

	      if (!children) {
	        switch (operator) {
	          case operators.dot:
	            children = node[_xfa_object.$getChildrenByName](name, false);
	            break;

	          case operators.dotDot:
	            children = node[_xfa_object.$getChildrenByName](name, true);
	            break;

	          case operators.dotHash:
	            children = node[_xfa_object.$getChildrenByClass](name);

	            if (children instanceof _xfa_object.XFAObjectArray) {
	              children = children.children;
	            } else {
	              children = [children];
	            }

	            break;
	        }

	        if (useCache) {
	          cached.set(cacheName, children);
	        }
	      }

	      if (children.length > 0) {
	        nodes.push(children);
	      }
	    }

	    if (nodes.length === 0 && !isQualified && i === 0) {
	      const parent = container[_xfa_object.$getParent]();

	      container = parent;

	      if (!container) {
	        return null;
	      }

	      i = -1;
	      root = [container];
	      continue;
	    }

	    if (isFinite(index)) {
	      root = nodes.filter(node => index < node.length).map(node => node[index]);
	    } else {
	      root = nodes.flat();
	    }
	  }

	  if (root.length === 0) {
	    return null;
	  }

	  return root;
	}

	function createNodes(root, path) {
	  let node = null;

	  for (const {
	    name,
	    index
	  } of path) {
	    for (let i = 0, ii = !isFinite(index) ? 0 : index; i <= ii; i++) {
	      const nsId = root[_xfa_object.$namespaceId] === NS_DATASETS ? -1 : root[_xfa_object.$namespaceId];
	      node = new _xfa_object.XmlObject(nsId, name);

	      root[_xfa_object.$appendChild](node);
	    }

	    root = node;
	  }

	  return node;
	}

	function createDataNode(root, container, expr) {
	  const parsed = parseExpression(expr);

	  if (!parsed) {
	    return null;
	  }

	  if (parsed.some(x => x.operator === operators.dotDot)) {
	    return null;
	  }

	  const fn = shortcuts.get(parsed[0].name);
	  let i = 0;

	  if (fn) {
	    root = fn(root, container);
	    i = 1;
	  } else {
	    root = container || root;
	  }

	  for (let ii = parsed.length; i < ii; i++) {
	    const {
	      name,
	      operator,
	      index
	    } = parsed[i];

	    if (!isFinite(index)) {
	      parsed[i].index = 0;
	      return createNodes(root, parsed.slice(i));
	    }

	    let children;

	    switch (operator) {
	      case operators.dot:
	        children = root[_xfa_object.$getChildrenByName](name, false);
	        break;

	      case operators.dotDot:
	        children = root[_xfa_object.$getChildrenByName](name, true);
	        break;

	      case operators.dotHash:
	        children = root[_xfa_object.$getChildrenByClass](name);

	        if (children instanceof _xfa_object.XFAObjectArray) {
	          children = children.children;
	        } else {
	          children = [children];
	        }

	        break;
	    }

	    if (children.length === 0) {
	      return createNodes(root, parsed.slice(i));
	    }

	    if (index < children.length) {
	      const child = children[index];

	      if (!(child instanceof _xfa_object.XFAObject)) {
	        (0, _util.warn)(`XFA - Cannot create a node.`);
	        return null;
	      }

	      root = child;
	    } else {
	      parsed[i].index = index - children.length;
	      return createNodes(root, parsed.slice(i));
	    }
	  }

	  return null;
	}

	/***/ }),
	/* 81 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Binder = void 0;

	var _xfa_object = __w_pdfjs_require__(77);

	var _template = __w_pdfjs_require__(82);

	var _som = __w_pdfjs_require__(80);

	var _namespaces = __w_pdfjs_require__(79);

	var _util = __w_pdfjs_require__(2);

	const NS_DATASETS = _namespaces.NamespaceIds.datasets.id;

	function createText(content) {
	  const node = new _template.Text({});
	  node[_xfa_object.$content] = content;
	  return node;
	}

	class Binder {
	  constructor(root) {
	    this.root = root;
	    this.datasets = root.datasets;

	    if (root.datasets && root.datasets.data) {
	      this.data = root.datasets.data;
	    } else {
	      this.data = new _xfa_object.XmlObject(_namespaces.NamespaceIds.datasets.id, "data");
	    }

	    this.emptyMerge = this.data[_xfa_object.$getChildren]().length === 0;
	    this.root.form = this.form = root.template[_xfa_object.$clone]();
	  }

	  _isConsumeData() {
	    return !this.emptyMerge && this._mergeMode;
	  }

	  _isMatchTemplate() {
	    return !this._isConsumeData();
	  }

	  bind() {
	    this._bindElement(this.form, this.data);

	    return this.form;
	  }

	  getData() {
	    return this.data;
	  }

	  _bindValue(formNode, data, picture) {
	    formNode[_xfa_object.$data] = data;

	    if (formNode[_xfa_object.$hasSettableValue]()) {
	      if (data[_xfa_object.$isDataValue]()) {
	        const value = data[_xfa_object.$getDataValue]();

	        formNode[_xfa_object.$setValue](createText(value));
	      } else if (formNode instanceof _template.Field && formNode.ui && formNode.ui.choiceList && formNode.ui.choiceList.open === "multiSelect") {
	        const value = data[_xfa_object.$getChildren]().map(child => child[_xfa_object.$content].trim()).join("\n");

	        formNode[_xfa_object.$setValue](createText(value));
	      } else if (this._isConsumeData()) {
	        (0, _util.warn)(`XFA - Nodes haven't the same type.`);
	      }
	    } else if (!data[_xfa_object.$isDataValue]() || this._isMatchTemplate()) {
	      this._bindElement(formNode, data);
	    } else {
	      (0, _util.warn)(`XFA - Nodes haven't the same type.`);
	    }
	  }

	  _findDataByNameToConsume(name, isValue, dataNode, global) {
	    if (!name) {
	      return null;
	    }

	    let generator, match;

	    for (let i = 0; i < 3; i++) {
	      generator = dataNode[_xfa_object.$getRealChildrenByNameIt](name, false, true);

	      while (true) {
	        match = generator.next().value;

	        if (!match) {
	          break;
	        }

	        if (isValue === match[_xfa_object.$isDataValue]()) {
	          return match;
	        }
	      }

	      if (dataNode[_xfa_object.$namespaceId] === _namespaces.NamespaceIds.datasets.id && dataNode[_xfa_object.$nodeName] === "data") {
	        break;
	      }

	      dataNode = dataNode[_xfa_object.$getParent]();
	    }

	    if (!global) {
	      return null;
	    }

	    generator = this.data[_xfa_object.$getRealChildrenByNameIt](name, true, false);
	    match = generator.next().value;

	    if (match) {
	      return match;
	    }

	    generator = this.data[_xfa_object.$getAttributeIt](name, true);
	    match = generator.next().value;

	    if (match && match[_xfa_object.$isDataValue]()) {
	      return match;
	    }

	    return null;
	  }

	  _setProperties(formNode, dataNode) {
	    if (!formNode.hasOwnProperty("setProperty")) {
	      return;
	    }

	    for (const {
	      ref,
	      target,
	      connection
	    } of formNode.setProperty.children) {
	      if (connection) {
	        continue;
	      }

	      if (!ref) {
	        continue;
	      }

	      const nodes = (0, _som.searchNode)(this.root, dataNode, ref, false, false);

	      if (!nodes) {
	        (0, _util.warn)(`XFA - Invalid reference: ${ref}.`);
	        continue;
	      }

	      const [node] = nodes;

	      if (!node[_xfa_object.$isDescendent](this.data)) {
	        (0, _util.warn)(`XFA - Invalid node: must be a data node.`);
	        continue;
	      }

	      const targetNodes = (0, _som.searchNode)(this.root, formNode, target, false, false);

	      if (!targetNodes) {
	        (0, _util.warn)(`XFA - Invalid target: ${target}.`);
	        continue;
	      }

	      const [targetNode] = targetNodes;

	      if (!targetNode[_xfa_object.$isDescendent](formNode)) {
	        (0, _util.warn)(`XFA - Invalid target: must be a property or subproperty.`);
	        continue;
	      }

	      const targetParent = targetNode[_xfa_object.$getParent]();

	      if (targetNode instanceof _template.SetProperty || targetParent instanceof _template.SetProperty) {
	        (0, _util.warn)(`XFA - Invalid target: cannot be a setProperty or one of its properties.`);
	        continue;
	      }

	      if (targetNode instanceof _template.BindItems || targetParent instanceof _template.BindItems) {
	        (0, _util.warn)(`XFA - Invalid target: cannot be a bindItems or one of its properties.`);
	        continue;
	      }

	      const content = node[_xfa_object.$text]();

	      const name = targetNode[_xfa_object.$nodeName];

	      if (targetNode instanceof _xfa_object.XFAAttribute) {
	        const attrs = Object.create(null);
	        attrs[name] = content;
	        const obj = Reflect.construct(Object.getPrototypeOf(targetParent).constructor, [attrs]);
	        targetParent[name] = obj[name];
	        continue;
	      }

	      if (!targetNode.hasOwnProperty(_xfa_object.$content)) {
	        (0, _util.warn)(`XFA - Invalid node to use in setProperty`);
	        continue;
	      }

	      targetNode[_xfa_object.$data] = node;
	      targetNode[_xfa_object.$content] = content;

	      targetNode[_xfa_object.$finalize]();
	    }
	  }

	  _bindItems(formNode, dataNode) {
	    if (!formNode.hasOwnProperty("items") || !formNode.hasOwnProperty("bindItems") || formNode.bindItems.isEmpty()) {
	      return;
	    }

	    for (const item of formNode.items.children) {
	      formNode[_xfa_object.$removeChild](item);
	    }

	    formNode.items.clear();
	    const labels = new _template.Items({});
	    const values = new _template.Items({});

	    formNode[_xfa_object.$appendChild](labels);

	    formNode.items.push(labels);

	    formNode[_xfa_object.$appendChild](values);

	    formNode.items.push(values);

	    for (const {
	      ref,
	      labelRef,
	      valueRef,
	      connection
	    } of formNode.bindItems.children) {
	      if (connection) {
	        continue;
	      }

	      if (!ref) {
	        continue;
	      }

	      const nodes = (0, _som.searchNode)(this.root, dataNode, ref, false, false);

	      if (!nodes) {
	        (0, _util.warn)(`XFA - Invalid reference: ${ref}.`);
	        continue;
	      }

	      for (const node of nodes) {
	        if (!node[_xfa_object.$isDescendent](this.datasets)) {
	          (0, _util.warn)(`XFA - Invalid ref (${ref}): must be a datasets child.`);
	          continue;
	        }

	        const labelNodes = (0, _som.searchNode)(this.root, node, labelRef, true, false);

	        if (!labelNodes) {
	          (0, _util.warn)(`XFA - Invalid label: ${labelRef}.`);
	          continue;
	        }

	        const [labelNode] = labelNodes;

	        if (!labelNode[_xfa_object.$isDescendent](this.datasets)) {
	          (0, _util.warn)(`XFA - Invalid label: must be a datasets child.`);
	          continue;
	        }

	        const valueNodes = (0, _som.searchNode)(this.root, node, valueRef, true, false);

	        if (!valueNodes) {
	          (0, _util.warn)(`XFA - Invalid value: ${valueRef}.`);
	          continue;
	        }

	        const [valueNode] = valueNodes;

	        if (!valueNode[_xfa_object.$isDescendent](this.datasets)) {
	          (0, _util.warn)(`XFA - Invalid value: must be a datasets child.`);
	          continue;
	        }

	        const label = createText(labelNode[_xfa_object.$text]());
	        const value = createText(valueNode[_xfa_object.$text]());

	        labels[_xfa_object.$appendChild](label);

	        labels.text.push(label);

	        values[_xfa_object.$appendChild](value);

	        values.text.push(value);
	      }
	    }
	  }

	  _bindOccurrences(formNode, matches, picture) {
	    let baseClone;

	    if (matches.length > 1) {
	      baseClone = formNode[_xfa_object.$clone]();

	      baseClone[_xfa_object.$removeChild](baseClone.occur);

	      baseClone.occur = null;
	    }

	    this._bindValue(formNode, matches[0], picture);

	    this._setProperties(formNode, matches[0]);

	    this._bindItems(formNode, matches[0]);

	    if (matches.length === 1) {
	      return;
	    }

	    const parent = formNode[_xfa_object.$getParent]();

	    const name = formNode[_xfa_object.$nodeName];

	    const pos = parent[_xfa_object.$indexOf](formNode);

	    for (let i = 1, ii = matches.length; i < ii; i++) {
	      const match = matches[i];

	      const clone = baseClone[_xfa_object.$clone]();

	      parent[name].push(clone);

	      parent[_xfa_object.$insertAt](pos + i, clone);

	      this._bindValue(clone, match, picture);

	      this._setProperties(clone, match);

	      this._bindItems(clone, match);
	    }
	  }

	  _createOccurrences(formNode) {
	    if (!this.emptyMerge) {
	      return;
	    }

	    const {
	      occur
	    } = formNode;

	    if (!occur || occur.initial <= 1) {
	      return;
	    }

	    const parent = formNode[_xfa_object.$getParent]();

	    const name = formNode[_xfa_object.$nodeName];

	    if (!(parent[name] instanceof _xfa_object.XFAObjectArray)) {
	      return;
	    }

	    let currentNumber;

	    if (formNode.name) {
	      currentNumber = parent[name].children.filter(e => e.name === formNode.name).length;
	    } else {
	      currentNumber = parent[name].children.length;
	    }

	    const pos = parent[_xfa_object.$indexOf](formNode) + 1;
	    const ii = occur.initial - currentNumber;

	    if (ii) {
	      const nodeClone = formNode[_xfa_object.$clone]();

	      nodeClone[_xfa_object.$removeChild](nodeClone.occur);

	      nodeClone.occur = null;
	      parent[name].push(nodeClone);

	      parent[_xfa_object.$insertAt](pos, nodeClone);

	      for (let i = 1; i < ii; i++) {
	        const clone = nodeClone[_xfa_object.$clone]();

	        parent[name].push(clone);

	        parent[_xfa_object.$insertAt](pos + i, clone);
	      }
	    }
	  }

	  _getOccurInfo(formNode) {
	    const {
	      name,
	      occur
	    } = formNode;

	    if (!occur || !name) {
	      return [1, 1];
	    }

	    const max = occur.max === -1 ? Infinity : occur.max;
	    return [occur.min, max];
	  }

	  _setAndBind(formNode, dataNode) {
	    this._setProperties(formNode, dataNode);

	    this._bindItems(formNode, dataNode);

	    this._bindElement(formNode, dataNode);
	  }

	  _bindElement(formNode, dataNode) {
	    const uselessNodes = [];

	    this._createOccurrences(formNode);

	    for (const child of formNode[_xfa_object.$getChildren]()) {
	      if (child[_xfa_object.$data]) {
	        continue;
	      }

	      if (this._mergeMode === undefined && child[_xfa_object.$nodeName] === "subform") {
	        this._mergeMode = child.mergeMode === "consumeData";

	        const dataChildren = dataNode[_xfa_object.$getChildren]();

	        if (dataChildren.length > 0) {
	          this._bindOccurrences(child, [dataChildren[0]], null);
	        } else if (this.emptyMerge) {
	          const nsId = dataNode[_xfa_object.$namespaceId] === NS_DATASETS ? -1 : dataNode[_xfa_object.$namespaceId];
	          const dataChild = child[_xfa_object.$data] = new _xfa_object.XmlObject(nsId, child.name || "root");

	          dataNode[_xfa_object.$appendChild](dataChild);

	          this._bindElement(child, dataChild);
	        }

	        continue;
	      }

	      if (!child[_xfa_object.$isBindable]()) {
	        continue;
	      }

	      let global = false;
	      let picture = null;
	      let ref = null;
	      let match = null;

	      if (child.bind) {
	        switch (child.bind.match) {
	          case "none":
	            this._setAndBind(child, dataNode);

	            continue;

	          case "global":
	            global = true;
	            break;

	          case "dataRef":
	            if (!child.bind.ref) {
	              (0, _util.warn)(`XFA - ref is empty in node ${child[_xfa_object.$nodeName]}.`);

	              this._setAndBind(child, dataNode);

	              continue;
	            }

	            ref = child.bind.ref;
	            break;
	        }

	        if (child.bind.picture) {
	          picture = child.bind.picture[_xfa_object.$content];
	        }
	      }

	      const [min, max] = this._getOccurInfo(child);

	      if (ref) {
	        match = (0, _som.searchNode)(this.root, dataNode, ref, true, false);

	        if (match === null) {
	          match = (0, _som.createDataNode)(this.data, dataNode, ref);

	          if (!match) {
	            continue;
	          }

	          if (this._isConsumeData()) {
	            match[_xfa_object.$consumed] = true;
	          }

	          this._setAndBind(child, match);

	          continue;
	        } else {
	          if (this._isConsumeData()) {
	            match = match.filter(node => !node[_xfa_object.$consumed]);
	          }

	          if (match.length > max) {
	            match = match.slice(0, max);
	          } else if (match.length === 0) {
	            match = null;
	          }

	          if (match && this._isConsumeData()) {
	            match.forEach(node => {
	              node[_xfa_object.$consumed] = true;
	            });
	          }
	        }
	      } else {
	        if (!child.name) {
	          this._setAndBind(child, dataNode);

	          continue;
	        }

	        if (this._isConsumeData()) {
	          const matches = [];

	          while (matches.length < max) {
	            const found = this._findDataByNameToConsume(child.name, child[_xfa_object.$hasSettableValue](), dataNode, global);

	            if (!found) {
	              break;
	            }

	            found[_xfa_object.$consumed] = true;
	            matches.push(found);
	          }

	          match = matches.length > 0 ? matches : null;
	        } else {
	          match = dataNode[_xfa_object.$getRealChildrenByNameIt](child.name, false, this.emptyMerge).next().value;

	          if (!match) {
	            if (min === 0) {
	              uselessNodes.push(child);
	              continue;
	            }

	            const nsId = dataNode[_xfa_object.$namespaceId] === NS_DATASETS ? -1 : dataNode[_xfa_object.$namespaceId];
	            match = child[_xfa_object.$data] = new _xfa_object.XmlObject(nsId, child.name);

	            if (this.emptyMerge) {
	              match[_xfa_object.$consumed] = true;
	            }

	            dataNode[_xfa_object.$appendChild](match);

	            this._setAndBind(child, match);

	            continue;
	          }

	          if (this.emptyMerge) {
	            match[_xfa_object.$consumed] = true;
	          }

	          match = [match];
	        }
	      }

	      if (match) {
	        this._bindOccurrences(child, match, picture);
	      } else if (min > 0) {
	        this._setAndBind(child, dataNode);
	      } else {
	        uselessNodes.push(child);
	      }
	    }

	    uselessNodes.forEach(node => node[_xfa_object.$getParent]()[_xfa_object.$removeChild](node));
	  }

	}

	exports.Binder = Binder;

	/***/ }),
	/* 82 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Value = exports.Text = exports.TemplateNamespace = exports.Template = exports.SetProperty = exports.Items = exports.Field = exports.BindItems = void 0;

	var _xfa_object = __w_pdfjs_require__(77);

	var _namespaces = __w_pdfjs_require__(79);

	var _layout = __w_pdfjs_require__(83);

	var _html_utils = __w_pdfjs_require__(84);

	var _utils = __w_pdfjs_require__(78);

	var _util = __w_pdfjs_require__(2);

	var _fonts = __w_pdfjs_require__(85);

	var _core_utils = __w_pdfjs_require__(6);

	var _som = __w_pdfjs_require__(80);

	const TEMPLATE_NS_ID = _namespaces.NamespaceIds.template.id;
	const SVG_NS = "http://www.w3.org/2000/svg";
	const MAX_ATTEMPTS_FOR_LRTB_LAYOUT = 2;
	const MAX_EMPTY_PAGES = 3;
	const DEFAULT_TAB_INDEX = 5000;
	const HEADING_PATTERN = /^H(\d+)$/;
	const MIMES = new Set(["image/gif", "image/jpeg", "image/jpg", "image/pjpeg", "image/png", "image/apng", "image/x-png", "image/bmp", "image/x-ms-bmp", "image/tiff", "image/tif", "application/octet-stream"]);
	const IMAGES_HEADERS = [[[0x42, 0x4d], "image/bmp"], [[0xff, 0xd8, 0xff], "image/jpeg"], [[0x49, 0x49, 0x2a, 0x00], "image/tiff"], [[0x4d, 0x4d, 0x00, 0x2a], "image/tiff"], [[0x47, 0x49, 0x46, 0x38, 0x39, 0x61], "image/gif"], [[0x89, 0x50, 0x4e, 0x47, 0x0d, 0x0a, 0x1a, 0x0a], "image/png"]];

	function getBorderDims(node) {
	  if (!node || !node.border) {
	    return {
	      w: 0,
	      h: 0
	    };
	  }

	  const borderExtra = node.border[_xfa_object.$getExtra]();

	  if (!borderExtra) {
	    return {
	      w: 0,
	      h: 0
	    };
	  }

	  return {
	    w: borderExtra.widths[0] + borderExtra.widths[2] + borderExtra.insets[0] + borderExtra.insets[2],
	    h: borderExtra.widths[1] + borderExtra.widths[3] + borderExtra.insets[1] + borderExtra.insets[3]
	  };
	}

	function hasMargin(node) {
	  return node.margin && (node.margin.topInset || node.margin.rightInset || node.margin.bottomInset || node.margin.leftInset);
	}

	function _setValue(templateNode, value) {
	  if (!templateNode.value) {
	    const nodeValue = new Value({});

	    templateNode[_xfa_object.$appendChild](nodeValue);

	    templateNode.value = nodeValue;
	  }

	  templateNode.value[_xfa_object.$setValue](value);
	}

	function* getContainedChildren(node) {
	  for (const child of node[_xfa_object.$getChildren]()) {
	    if (child instanceof SubformSet) {
	      yield* child[_xfa_object.$getContainedChildren]();
	      continue;
	    }

	    yield child;
	  }
	}

	function isRequired(node) {
	  return node.validate && node.validate.nullTest === "error";
	}

	function setTabIndex(node) {
	  while (node) {
	    if (!node.traversal) {
	      node[_xfa_object.$tabIndex] = node[_xfa_object.$getParent]()[_xfa_object.$tabIndex];
	      return;
	    }

	    if (node[_xfa_object.$tabIndex]) {
	      return;
	    }

	    let next = null;

	    for (const child of node.traversal[_xfa_object.$getChildren]()) {
	      if (child.operation === "next") {
	        next = child;
	        break;
	      }
	    }

	    if (!next || !next.ref) {
	      node[_xfa_object.$tabIndex] = node[_xfa_object.$getParent]()[_xfa_object.$tabIndex];
	      return;
	    }

	    const root = node[_xfa_object.$getTemplateRoot]();

	    node[_xfa_object.$tabIndex] = ++root[_xfa_object.$tabIndex];

	    const ref = root[_xfa_object.$searchNode](next.ref, node);

	    if (!ref) {
	      return;
	    }

	    node = ref[0];
	  }
	}

	function applyAssist(obj, attributes) {
	  const assist = obj.assist;

	  if (assist) {
	    const assistTitle = assist[_xfa_object.$toHTML]();

	    if (assistTitle) {
	      attributes.title = assistTitle;
	    }

	    const role = assist.role;
	    const match = role.match(HEADING_PATTERN);

	    if (match) {
	      const ariaRole = "heading";
	      const ariaLevel = match[1];
	      attributes.role = ariaRole;
	      attributes["aria-level"] = ariaLevel;
	    }
	  }

	  if (obj.layout === "table") {
	    attributes.role = "table";
	  } else if (obj.layout === "row") {
	    attributes.role = "row";
	  } else {
	    const parent = obj[_xfa_object.$getParent]();

	    if (parent.layout === "row") {
	      if (parent.assist && parent.assist.role === "TH") {
	        attributes.role = "columnheader";
	      } else {
	        attributes.role = "cell";
	      }
	    }
	  }
	}

	function ariaLabel(obj) {
	  if (!obj.assist) {
	    return null;
	  }

	  const assist = obj.assist;

	  if (assist.speak && assist.speak[_xfa_object.$content] !== "") {
	    return assist.speak[_xfa_object.$content];
	  }

	  if (assist.toolTip) {
	    return assist.toolTip[_xfa_object.$content];
	  }

	  return null;
	}

	function valueToHtml(value) {
	  return _utils.HTMLResult.success({
	    name: "div",
	    attributes: {
	      class: ["xfaRich"],
	      style: Object.create(null)
	    },
	    children: [{
	      name: "span",
	      attributes: {
	        style: Object.create(null)
	      },
	      value
	    }]
	  });
	}

	function setFirstUnsplittable(node) {
	  const root = node[_xfa_object.$getTemplateRoot]();

	  if (root[_xfa_object.$extra].firstUnsplittable === null) {
	    root[_xfa_object.$extra].firstUnsplittable = node;
	    root[_xfa_object.$extra].noLayoutFailure = true;
	  }
	}

	function unsetFirstUnsplittable(node) {
	  const root = node[_xfa_object.$getTemplateRoot]();

	  if (root[_xfa_object.$extra].firstUnsplittable === node) {
	    root[_xfa_object.$extra].noLayoutFailure = false;
	  }
	}

	function handleBreak(node) {
	  if (node[_xfa_object.$extra]) {
	    return false;
	  }

	  node[_xfa_object.$extra] = Object.create(null);

	  if (node.targetType === "auto") {
	    return false;
	  }

	  const root = node[_xfa_object.$getTemplateRoot]();

	  let target = null;

	  if (node.target) {
	    target = root[_xfa_object.$searchNode](node.target, node[_xfa_object.$getParent]());

	    if (!target) {
	      return false;
	    }

	    target = target[0];
	  }

	  const {
	    currentPageArea,
	    currentContentArea
	  } = root[_xfa_object.$extra];

	  if (node.targetType === "pageArea") {
	    if (!(target instanceof PageArea)) {
	      target = null;
	    }

	    if (node.startNew) {
	      node[_xfa_object.$extra].target = target || currentPageArea;
	      return true;
	    } else if (target && target !== currentPageArea) {
	      node[_xfa_object.$extra].target = target;
	      return true;
	    }

	    return false;
	  }

	  if (!(target instanceof ContentArea)) {
	    target = null;
	  }

	  const pageArea = target && target[_xfa_object.$getParent]();

	  let index;
	  let nextPageArea = pageArea;

	  if (node.startNew) {
	    if (target) {
	      const contentAreas = pageArea.contentArea.children;
	      const indexForCurrent = contentAreas.indexOf(currentContentArea);
	      const indexForTarget = contentAreas.indexOf(target);

	      if (indexForCurrent !== -1 && indexForCurrent < indexForTarget) {
	        nextPageArea = null;
	      }

	      index = indexForTarget - 1;
	    } else {
	      index = currentPageArea.contentArea.children.indexOf(currentContentArea);
	    }
	  } else if (target && target !== currentContentArea) {
	    const contentAreas = pageArea.contentArea.children;
	    index = contentAreas.indexOf(target) - 1;
	    nextPageArea = pageArea === currentPageArea ? null : pageArea;
	  } else {
	    return false;
	  }

	  node[_xfa_object.$extra].target = nextPageArea;
	  node[_xfa_object.$extra].index = index;
	  return true;
	}

	function handleOverflow(node, extraNode, space) {
	  const root = node[_xfa_object.$getTemplateRoot]();

	  const saved = root[_xfa_object.$extra].noLayoutFailure;
	  const savedMethod = extraNode[_xfa_object.$getSubformParent];

	  extraNode[_xfa_object.$getSubformParent] = () => node;

	  root[_xfa_object.$extra].noLayoutFailure = true;

	  const res = extraNode[_xfa_object.$toHTML](space);

	  node[_xfa_object.$addHTML](res.html, res.bbox);

	  root[_xfa_object.$extra].noLayoutFailure = saved;
	  extraNode[_xfa_object.$getSubformParent] = savedMethod;
	}

	class AppearanceFilter extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "appearanceFilter");
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Arc extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "arc", true);
	    this.circular = (0, _utils.getInteger)({
	      data: attributes.circular,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.hand = (0, _utils.getStringOption)(attributes.hand, ["even", "left", "right"]);
	    this.id = attributes.id || "";
	    this.startAngle = (0, _utils.getFloat)({
	      data: attributes.startAngle,
	      defaultValue: 0,
	      validate: x => true
	    });
	    this.sweepAngle = (0, _utils.getFloat)({
	      data: attributes.sweepAngle,
	      defaultValue: 360,
	      validate: x => true
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.edge = null;
	    this.fill = null;
	  }

	  [_xfa_object.$toHTML]() {
	    const edge = this.edge || new Edge({});

	    const edgeStyle = edge[_xfa_object.$toStyle]();

	    const style = Object.create(null);

	    if (this.fill && this.fill.presence === "visible") {
	      Object.assign(style, this.fill[_xfa_object.$toStyle]());
	    } else {
	      style.fill = "transparent";
	    }

	    style.strokeWidth = (0, _html_utils.measureToString)(edge.presence === "visible" ? edge.thickness : 0);
	    style.stroke = edgeStyle.color;
	    let arc;
	    const attributes = {
	      xmlns: SVG_NS,
	      style: {
	        width: "100%",
	        height: "100%",
	        overflow: "visible"
	      }
	    };

	    if (this.sweepAngle === 360) {
	      arc = {
	        name: "ellipse",
	        attributes: {
	          xmlns: SVG_NS,
	          cx: "50%",
	          cy: "50%",
	          rx: "50%",
	          ry: "50%",
	          style
	        }
	      };
	    } else {
	      const startAngle = this.startAngle * Math.PI / 180;
	      const sweepAngle = this.sweepAngle * Math.PI / 180;
	      const largeArc = this.sweepAngle > 180 ? 1 : 0;
	      const [x1, y1, x2, y2] = [50 * (1 + Math.cos(startAngle)), 50 * (1 - Math.sin(startAngle)), 50 * (1 + Math.cos(startAngle + sweepAngle)), 50 * (1 - Math.sin(startAngle + sweepAngle))];
	      arc = {
	        name: "path",
	        attributes: {
	          xmlns: SVG_NS,
	          d: `M ${x1} ${y1} A 50 50 0 ${largeArc} 0 ${x2} ${y2}`,
	          vectorEffect: "non-scaling-stroke",
	          style
	        }
	      };
	      Object.assign(attributes, {
	        viewBox: "0 0 100 100",
	        preserveAspectRatio: "none"
	      });
	    }

	    const svg = {
	      name: "svg",
	      children: [arc],
	      attributes
	    };

	    const parent = this[_xfa_object.$getParent]()[_xfa_object.$getParent]();

	    if (hasMargin(parent)) {
	      return _utils.HTMLResult.success({
	        name: "div",
	        attributes: {
	          style: {
	            display: "inline",
	            width: "100%",
	            height: "100%"
	          }
	        },
	        children: [svg]
	      });
	    }

	    svg.attributes.style.position = "absolute";
	    return _utils.HTMLResult.success(svg);
	  }

	}

	class Area extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "area", true);
	    this.colSpan = (0, _utils.getInteger)({
	      data: attributes.colSpan,
	      defaultValue: 1,
	      validate: n => n >= 1 || n === -1
	    });
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.x = (0, _utils.getMeasurement)(attributes.x, "0pt");
	    this.y = (0, _utils.getMeasurement)(attributes.y, "0pt");
	    this.desc = null;
	    this.extras = null;
	    this.area = new _xfa_object.XFAObjectArray();
	    this.draw = new _xfa_object.XFAObjectArray();
	    this.exObject = new _xfa_object.XFAObjectArray();
	    this.exclGroup = new _xfa_object.XFAObjectArray();
	    this.field = new _xfa_object.XFAObjectArray();
	    this.subform = new _xfa_object.XFAObjectArray();
	    this.subformSet = new _xfa_object.XFAObjectArray();
	  }

	  *[_xfa_object.$getContainedChildren]() {
	    yield* getContainedChildren(this);
	  }

	  [_xfa_object.$isTransparent]() {
	    return true;
	  }

	  [_xfa_object.$isBindable]() {
	    return true;
	  }

	  [_xfa_object.$addHTML](html, bbox) {
	    const [x, y, w, h] = bbox;
	    this[_xfa_object.$extra].width = Math.max(this[_xfa_object.$extra].width, x + w);
	    this[_xfa_object.$extra].height = Math.max(this[_xfa_object.$extra].height, y + h);

	    this[_xfa_object.$extra].children.push(html);
	  }

	  [_xfa_object.$getAvailableSpace]() {
	    return this[_xfa_object.$extra].availableSpace;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const style = (0, _html_utils.toStyle)(this, "position");
	    const attributes = {
	      style,
	      id: this[_xfa_object.$uid],
	      class: ["xfaArea"]
	    };

	    if ((0, _html_utils.isPrintOnly)(this)) {
	      attributes.class.push("xfaPrintOnly");
	    }

	    if (this.name) {
	      attributes.xfaName = this.name;
	    }

	    const children = [];
	    this[_xfa_object.$extra] = {
	      children,
	      width: 0,
	      height: 0,
	      availableSpace
	    };

	    const result = this[_xfa_object.$childrenToHTML]({
	      filter: new Set(["area", "draw", "field", "exclGroup", "subform", "subformSet"]),
	      include: true
	    });

	    if (!result.success) {
	      if (result.isBreak()) {
	        return result;
	      }

	      delete this[_xfa_object.$extra];
	      return _utils.HTMLResult.FAILURE;
	    }

	    style.width = (0, _html_utils.measureToString)(this[_xfa_object.$extra].width);
	    style.height = (0, _html_utils.measureToString)(this[_xfa_object.$extra].height);
	    const html = {
	      name: "div",
	      attributes,
	      children
	    };
	    const bbox = [this.x, this.y, this[_xfa_object.$extra].width, this[_xfa_object.$extra].height];
	    delete this[_xfa_object.$extra];
	    return _utils.HTMLResult.success(html, bbox);
	  }

	}

	class Assist extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "assist", true);
	    this.id = attributes.id || "";
	    this.role = attributes.role || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.speak = null;
	    this.toolTip = null;
	  }

	  [_xfa_object.$toHTML]() {
	    return this.toolTip && this.toolTip[_xfa_object.$content] ? this.toolTip[_xfa_object.$content] : null;
	  }

	}

	class Barcode extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "barcode", true);
	    this.charEncoding = (0, _utils.getKeyword)({
	      data: attributes.charEncoding ? attributes.charEncoding.toLowerCase() : "",
	      defaultValue: "",
	      validate: k => ["utf-8", "big-five", "fontspecific", "gbk", "gb-18030", "gb-2312", "ksc-5601", "none", "shift-jis", "ucs-2", "utf-16"].includes(k) || k.match(/iso-8859-\d{2}/)
	    });
	    this.checksum = (0, _utils.getStringOption)(attributes.checksum, ["none", "1mod10", "1mod10_1mod11", "2mod10", "auto"]);
	    this.dataColumnCount = (0, _utils.getInteger)({
	      data: attributes.dataColumnCount,
	      defaultValue: -1,
	      validate: x => x >= 0
	    });
	    this.dataLength = (0, _utils.getInteger)({
	      data: attributes.dataLength,
	      defaultValue: -1,
	      validate: x => x >= 0
	    });
	    this.dataPrep = (0, _utils.getStringOption)(attributes.dataPrep, ["none", "flateCompress"]);
	    this.dataRowCount = (0, _utils.getInteger)({
	      data: attributes.dataRowCount,
	      defaultValue: -1,
	      validate: x => x >= 0
	    });
	    this.endChar = attributes.endChar || "";
	    this.errorCorrectionLevel = (0, _utils.getInteger)({
	      data: attributes.errorCorrectionLevel,
	      defaultValue: -1,
	      validate: x => x >= 0 && x <= 8
	    });
	    this.id = attributes.id || "";
	    this.moduleHeight = (0, _utils.getMeasurement)(attributes.moduleHeight, "5mm");
	    this.moduleWidth = (0, _utils.getMeasurement)(attributes.moduleWidth, "0.25mm");
	    this.printCheckDigit = (0, _utils.getInteger)({
	      data: attributes.printCheckDigit,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.rowColumnRatio = (0, _utils.getRatio)(attributes.rowColumnRatio);
	    this.startChar = attributes.startChar || "";
	    this.textLocation = (0, _utils.getStringOption)(attributes.textLocation, ["below", "above", "aboveEmbedded", "belowEmbedded", "none"]);
	    this.truncate = (0, _utils.getInteger)({
	      data: attributes.truncate,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.type = (0, _utils.getStringOption)(attributes.type ? attributes.type.toLowerCase() : "", ["aztec", "codabar", "code2of5industrial", "code2of5interleaved", "code2of5matrix", "code2of5standard", "code3of9", "code3of9extended", "code11", "code49", "code93", "code128", "code128a", "code128b", "code128c", "code128sscc", "datamatrix", "ean8", "ean8add2", "ean8add5", "ean13", "ean13add2", "ean13add5", "ean13pwcd", "fim", "logmars", "maxicode", "msi", "pdf417", "pdf417macro", "plessey", "postauscust2", "postauscust3", "postausreplypaid", "postausstandard", "postukrm4scc", "postusdpbc", "postusimb", "postusstandard", "postus5zip", "qrcode", "rfid", "rss14", "rss14expanded", "rss14limited", "rss14stacked", "rss14stackedomni", "rss14truncated", "telepen", "ucc128", "ucc128random", "ucc128sscc", "upca", "upcaadd2", "upcaadd5", "upcapwcd", "upce", "upceadd2", "upceadd5", "upcean2", "upcean5", "upsmaxicode"]);
	    this.upsMode = (0, _utils.getStringOption)(attributes.upsMode, ["usCarrier", "internationalCarrier", "secureSymbol", "standardSymbol"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.wideNarrowRatio = (0, _utils.getRatio)(attributes.wideNarrowRatio);
	    this.encrypt = null;
	    this.extras = null;
	  }

	}

	class Bind extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "bind", true);
	    this.match = (0, _utils.getStringOption)(attributes.match, ["once", "dataRef", "global", "none"]);
	    this.ref = attributes.ref || "";
	    this.picture = null;
	  }

	}

	class BindItems extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "bindItems");
	    this.connection = attributes.connection || "";
	    this.labelRef = attributes.labelRef || "";
	    this.ref = attributes.ref || "";
	    this.valueRef = attributes.valueRef || "";
	  }

	}

	exports.BindItems = BindItems;

	class Bookend extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "bookend");
	    this.id = attributes.id || "";
	    this.leader = attributes.leader || "";
	    this.trailer = attributes.trailer || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class BooleanElement extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "boolean");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return valueToHtml(this[_xfa_object.$content] === 1 ? "1" : "0");
	  }

	}

	class Border extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "border", true);
	    this.break = (0, _utils.getStringOption)(attributes.break, ["close", "open"]);
	    this.hand = (0, _utils.getStringOption)(attributes.hand, ["even", "left", "right"]);
	    this.id = attributes.id || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.corner = new _xfa_object.XFAObjectArray(4);
	    this.edge = new _xfa_object.XFAObjectArray(4);
	    this.extras = null;
	    this.fill = null;
	    this.margin = null;
	  }

	  [_xfa_object.$getExtra]() {
	    if (!this[_xfa_object.$extra]) {
	      const edges = this.edge.children.slice();

	      if (edges.length < 4) {
	        const defaultEdge = edges.at(-1) || new Edge({});

	        for (let i = edges.length; i < 4; i++) {
	          edges.push(defaultEdge);
	        }
	      }

	      const widths = edges.map(edge => edge.thickness);
	      const insets = [0, 0, 0, 0];

	      if (this.margin) {
	        insets[0] = this.margin.topInset;
	        insets[1] = this.margin.rightInset;
	        insets[2] = this.margin.bottomInset;
	        insets[3] = this.margin.leftInset;
	      }

	      this[_xfa_object.$extra] = {
	        widths,
	        insets,
	        edges
	      };
	    }

	    return this[_xfa_object.$extra];
	  }

	  [_xfa_object.$toStyle]() {
	    const {
	      edges
	    } = this[_xfa_object.$getExtra]();

	    const edgeStyles = edges.map(node => {
	      const style = node[_xfa_object.$toStyle]();

	      style.color = style.color || "#000000";
	      return style;
	    });
	    const style = Object.create(null);

	    if (this.margin) {
	      Object.assign(style, this.margin[_xfa_object.$toStyle]());
	    }

	    if (this.fill && this.fill.presence === "visible") {
	      Object.assign(style, this.fill[_xfa_object.$toStyle]());
	    }

	    if (this.corner.children.some(node => node.radius !== 0)) {
	      const cornerStyles = this.corner.children.map(node => node[_xfa_object.$toStyle]());

	      if (cornerStyles.length === 2 || cornerStyles.length === 3) {
	        const last = cornerStyles.at(-1);

	        for (let i = cornerStyles.length; i < 4; i++) {
	          cornerStyles.push(last);
	        }
	      }

	      style.borderRadius = cornerStyles.map(s => s.radius).join(" ");
	    }

	    switch (this.presence) {
	      case "invisible":
	      case "hidden":
	        style.borderStyle = "";
	        break;

	      case "inactive":
	        style.borderStyle = "none";
	        break;

	      default:
	        style.borderStyle = edgeStyles.map(s => s.style).join(" ");
	        break;
	    }

	    style.borderWidth = edgeStyles.map(s => s.width).join(" ");
	    style.borderColor = edgeStyles.map(s => s.color).join(" ");
	    return style;
	  }

	}

	class Break extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "break", true);
	    this.after = (0, _utils.getStringOption)(attributes.after, ["auto", "contentArea", "pageArea", "pageEven", "pageOdd"]);
	    this.afterTarget = attributes.afterTarget || "";
	    this.before = (0, _utils.getStringOption)(attributes.before, ["auto", "contentArea", "pageArea", "pageEven", "pageOdd"]);
	    this.beforeTarget = attributes.beforeTarget || "";
	    this.bookendLeader = attributes.bookendLeader || "";
	    this.bookendTrailer = attributes.bookendTrailer || "";
	    this.id = attributes.id || "";
	    this.overflowLeader = attributes.overflowLeader || "";
	    this.overflowTarget = attributes.overflowTarget || "";
	    this.overflowTrailer = attributes.overflowTrailer || "";
	    this.startNew = (0, _utils.getInteger)({
	      data: attributes.startNew,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	  }

	}

	class BreakAfter extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "breakAfter", true);
	    this.id = attributes.id || "";
	    this.leader = attributes.leader || "";
	    this.startNew = (0, _utils.getInteger)({
	      data: attributes.startNew,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.target = attributes.target || "";
	    this.targetType = (0, _utils.getStringOption)(attributes.targetType, ["auto", "contentArea", "pageArea"]);
	    this.trailer = attributes.trailer || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.script = null;
	  }

	}

	class BreakBefore extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "breakBefore", true);
	    this.id = attributes.id || "";
	    this.leader = attributes.leader || "";
	    this.startNew = (0, _utils.getInteger)({
	      data: attributes.startNew,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.target = attributes.target || "";
	    this.targetType = (0, _utils.getStringOption)(attributes.targetType, ["auto", "contentArea", "pageArea"]);
	    this.trailer = attributes.trailer || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.script = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    this[_xfa_object.$extra] = {};
	    return _utils.HTMLResult.FAILURE;
	  }

	}

	class Button extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "button", true);
	    this.highlight = (0, _utils.getStringOption)(attributes.highlight, ["inverted", "none", "outline", "push"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const parent = this[_xfa_object.$getParent]();

	    const grandpa = parent[_xfa_object.$getParent]();

	    const htmlButton = {
	      name: "button",
	      attributes: {
	        id: this[_xfa_object.$uid],
	        class: ["xfaButton"],
	        style: {}
	      },
	      children: []
	    };

	    for (const event of grandpa.event.children) {
	      if (event.activity !== "click" || !event.script) {
	        continue;
	      }

	      const jsURL = (0, _core_utils.recoverJsURL)(event.script[_xfa_object.$content]);

	      if (!jsURL) {
	        continue;
	      }

	      const href = (0, _html_utils.fixURL)(jsURL.url);

	      if (!href) {
	        continue;
	      }

	      htmlButton.children.push({
	        name: "a",
	        attributes: {
	          id: "link" + this[_xfa_object.$uid],
	          href,
	          newWindow: jsURL.newWindow,
	          class: ["xfaLink"],
	          style: {}
	        },
	        children: []
	      });
	    }

	    return _utils.HTMLResult.success(htmlButton);
	  }

	}

	class Calculate extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "calculate", true);
	    this.id = attributes.id || "";
	    this.override = (0, _utils.getStringOption)(attributes.override, ["disabled", "error", "ignore", "warning"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.message = null;
	    this.script = null;
	  }

	}

	class Caption extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "caption", true);
	    this.id = attributes.id || "";
	    this.placement = (0, _utils.getStringOption)(attributes.placement, ["left", "bottom", "inline", "right", "top"]);
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.reserve = Math.ceil((0, _utils.getMeasurement)(attributes.reserve));
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.font = null;
	    this.margin = null;
	    this.para = null;
	    this.value = null;
	  }

	  [_xfa_object.$setValue](value) {
	    _setValue(this, value);
	  }

	  [_xfa_object.$getExtra](availableSpace) {
	    if (!this[_xfa_object.$extra]) {
	      let {
	        width,
	        height
	      } = availableSpace;

	      switch (this.placement) {
	        case "left":
	        case "right":
	        case "inline":
	          width = this.reserve <= 0 ? width : this.reserve;
	          break;

	        case "top":
	        case "bottom":
	          height = this.reserve <= 0 ? height : this.reserve;
	          break;
	      }

	      this[_xfa_object.$extra] = (0, _html_utils.layoutNode)(this, {
	        width,
	        height
	      });
	    }

	    return this[_xfa_object.$extra];
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    if (!this.value) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    this[_xfa_object.$pushPara]();

	    const value = this.value[_xfa_object.$toHTML](availableSpace).html;

	    if (!value) {
	      this[_xfa_object.$popPara]();

	      return _utils.HTMLResult.EMPTY;
	    }

	    const savedReserve = this.reserve;

	    if (this.reserve <= 0) {
	      const {
	        w,
	        h
	      } = this[_xfa_object.$getExtra](availableSpace);

	      switch (this.placement) {
	        case "left":
	        case "right":
	        case "inline":
	          this.reserve = w;
	          break;

	        case "top":
	        case "bottom":
	          this.reserve = h;
	          break;
	      }
	    }

	    const children = [];

	    if (typeof value === "string") {
	      children.push({
	        name: "#text",
	        value
	      });
	    } else {
	      children.push(value);
	    }

	    const style = (0, _html_utils.toStyle)(this, "font", "margin", "visibility");

	    switch (this.placement) {
	      case "left":
	      case "right":
	        if (this.reserve > 0) {
	          style.width = (0, _html_utils.measureToString)(this.reserve);
	        }

	        break;

	      case "top":
	      case "bottom":
	        if (this.reserve > 0) {
	          style.height = (0, _html_utils.measureToString)(this.reserve);
	        }

	        break;
	    }

	    (0, _html_utils.setPara)(this, null, value);

	    this[_xfa_object.$popPara]();

	    this.reserve = savedReserve;
	    return _utils.HTMLResult.success({
	      name: "div",
	      attributes: {
	        style,
	        class: ["xfaCaption"]
	      },
	      children
	    });
	  }

	}

	class Certificate extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "certificate");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Certificates extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "certificates", true);
	    this.credentialServerPolicy = (0, _utils.getStringOption)(attributes.credentialServerPolicy, ["optional", "required"]);
	    this.id = attributes.id || "";
	    this.url = attributes.url || "";
	    this.urlPolicy = attributes.urlPolicy || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.encryption = null;
	    this.issuers = null;
	    this.keyUsage = null;
	    this.oids = null;
	    this.signing = null;
	    this.subjectDNs = null;
	  }

	}

	class CheckButton extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "checkButton", true);
	    this.id = attributes.id || "";
	    this.mark = (0, _utils.getStringOption)(attributes.mark, ["default", "check", "circle", "cross", "diamond", "square", "star"]);
	    this.shape = (0, _utils.getStringOption)(attributes.shape, ["square", "round"]);
	    this.size = (0, _utils.getMeasurement)(attributes.size, "10pt");
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.border = null;
	    this.extras = null;
	    this.margin = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const style = (0, _html_utils.toStyle)("margin");
	    const size = (0, _html_utils.measureToString)(this.size);
	    style.width = style.height = size;
	    let type;
	    let className;
	    let groupId;

	    const field = this[_xfa_object.$getParent]()[_xfa_object.$getParent]();

	    const items = field.items.children.length && field.items.children[0][_xfa_object.$toHTML]().html || [];
	    const exportedValue = {
	      on: (items[0] !== undefined ? items[0] : "on").toString(),
	      off: (items[1] !== undefined ? items[1] : "off").toString()
	    };
	    const value = field.value && field.value[_xfa_object.$text]() || "off";
	    const checked = value === exportedValue.on || undefined;

	    const container = field[_xfa_object.$getSubformParent]();

	    const fieldId = field[_xfa_object.$uid];
	    let dataId;

	    if (container instanceof ExclGroup) {
	      groupId = container[_xfa_object.$uid];
	      type = "radio";
	      className = "xfaRadio";
	      dataId = container[_xfa_object.$data] && container[_xfa_object.$data][_xfa_object.$uid] || container[_xfa_object.$uid];
	    } else {
	      type = "checkbox";
	      className = "xfaCheckbox";
	      dataId = field[_xfa_object.$data] && field[_xfa_object.$data][_xfa_object.$uid] || field[_xfa_object.$uid];
	    }

	    const input = {
	      name: "input",
	      attributes: {
	        class: [className],
	        style,
	        fieldId,
	        dataId,
	        type,
	        checked,
	        xfaOn: exportedValue.on,
	        xfaOff: exportedValue.off,
	        "aria-label": ariaLabel(field),
	        "aria-required": false
	      }
	    };

	    if (groupId) {
	      input.attributes.name = groupId;
	    }

	    if (isRequired(field)) {
	      input.attributes["aria-required"] = true;
	      input.attributes.required = true;
	    }

	    return _utils.HTMLResult.success({
	      name: "label",
	      attributes: {
	        class: ["xfaLabel"]
	      },
	      children: [input]
	    });
	  }

	}

	class ChoiceList extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "choiceList", true);
	    this.commitOn = (0, _utils.getStringOption)(attributes.commitOn, ["select", "exit"]);
	    this.id = attributes.id || "";
	    this.open = (0, _utils.getStringOption)(attributes.open, ["userControl", "always", "multiSelect", "onEntry"]);
	    this.textEntry = (0, _utils.getInteger)({
	      data: attributes.textEntry,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.border = null;
	    this.extras = null;
	    this.margin = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const style = (0, _html_utils.toStyle)(this, "border", "margin");

	    const ui = this[_xfa_object.$getParent]();

	    const field = ui[_xfa_object.$getParent]();

	    const fontSize = field.font && field.font.size || 10;
	    const optionStyle = {
	      fontSize: `calc(${fontSize}px * var(--scale-factor))`
	    };
	    const children = [];

	    if (field.items.children.length > 0) {
	      const items = field.items;
	      let displayedIndex = 0;
	      let saveIndex = 0;

	      if (items.children.length === 2) {
	        displayedIndex = items.children[0].save;
	        saveIndex = 1 - displayedIndex;
	      }

	      const displayed = items.children[displayedIndex][_xfa_object.$toHTML]().html;

	      const values = items.children[saveIndex][_xfa_object.$toHTML]().html;

	      let selected = false;
	      const value = field.value && field.value[_xfa_object.$text]() || "";

	      for (let i = 0, ii = displayed.length; i < ii; i++) {
	        const option = {
	          name: "option",
	          attributes: {
	            value: values[i] || displayed[i],
	            style: optionStyle
	          },
	          value: displayed[i]
	        };

	        if (values[i] === value) {
	          option.attributes.selected = selected = true;
	        }

	        children.push(option);
	      }

	      if (!selected) {
	        children.splice(0, 0, {
	          name: "option",
	          attributes: {
	            hidden: true,
	            selected: true
	          },
	          value: " "
	        });
	      }
	    }

	    const selectAttributes = {
	      class: ["xfaSelect"],
	      fieldId: field[_xfa_object.$uid],
	      dataId: field[_xfa_object.$data] && field[_xfa_object.$data][_xfa_object.$uid] || field[_xfa_object.$uid],
	      style,
	      "aria-label": ariaLabel(field),
	      "aria-required": false
	    };

	    if (isRequired(field)) {
	      selectAttributes["aria-required"] = true;
	      selectAttributes.required = true;
	    }

	    if (this.open === "multiSelect") {
	      selectAttributes.multiple = true;
	    }

	    return _utils.HTMLResult.success({
	      name: "label",
	      attributes: {
	        class: ["xfaLabel"]
	      },
	      children: [{
	        name: "select",
	        children,
	        attributes: selectAttributes
	      }]
	    });
	  }

	}

	class Color extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "color", true);
	    this.cSpace = (0, _utils.getStringOption)(attributes.cSpace, ["SRGB"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.value = attributes.value ? (0, _utils.getColor)(attributes.value) : "";
	    this.extras = null;
	  }

	  [_xfa_object.$hasSettableValue]() {
	    return false;
	  }

	  [_xfa_object.$toStyle]() {
	    return this.value ? _util.Util.makeHexColor(this.value.r, this.value.g, this.value.b) : null;
	  }

	}

	class Comb extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "comb");
	    this.id = attributes.id || "";
	    this.numberOfCells = (0, _utils.getInteger)({
	      data: attributes.numberOfCells,
	      defaultValue: 0,
	      validate: x => x >= 0
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Connect extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "connect", true);
	    this.connection = attributes.connection || "";
	    this.id = attributes.id || "";
	    this.ref = attributes.ref || "";
	    this.usage = (0, _utils.getStringOption)(attributes.usage, ["exportAndImport", "exportOnly", "importOnly"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.picture = null;
	  }

	}

	class ContentArea extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "contentArea", true);
	    this.h = (0, _utils.getMeasurement)(attributes.h);
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.w = (0, _utils.getMeasurement)(attributes.w);
	    this.x = (0, _utils.getMeasurement)(attributes.x, "0pt");
	    this.y = (0, _utils.getMeasurement)(attributes.y, "0pt");
	    this.desc = null;
	    this.extras = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const left = (0, _html_utils.measureToString)(this.x);
	    const top = (0, _html_utils.measureToString)(this.y);
	    const style = {
	      left,
	      top,
	      width: (0, _html_utils.measureToString)(this.w),
	      height: (0, _html_utils.measureToString)(this.h)
	    };
	    const classNames = ["xfaContentarea"];

	    if ((0, _html_utils.isPrintOnly)(this)) {
	      classNames.push("xfaPrintOnly");
	    }

	    return _utils.HTMLResult.success({
	      name: "div",
	      children: [],
	      attributes: {
	        style,
	        class: classNames,
	        id: this[_xfa_object.$uid]
	      }
	    });
	  }

	}

	class Corner extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "corner", true);
	    this.id = attributes.id || "";
	    this.inverted = (0, _utils.getInteger)({
	      data: attributes.inverted,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.join = (0, _utils.getStringOption)(attributes.join, ["square", "round"]);
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.radius = (0, _utils.getMeasurement)(attributes.radius);
	    this.stroke = (0, _utils.getStringOption)(attributes.stroke, ["solid", "dashDot", "dashDotDot", "dashed", "dotted", "embossed", "etched", "lowered", "raised"]);
	    this.thickness = (0, _utils.getMeasurement)(attributes.thickness, "0.5pt");
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.color = null;
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle]() {
	    const style = (0, _html_utils.toStyle)(this, "visibility");
	    style.radius = (0, _html_utils.measureToString)(this.join === "square" ? 0 : this.radius);
	    return style;
	  }

	}

	class DateElement extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "date");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    const date = this[_xfa_object.$content].trim();

	    this[_xfa_object.$content] = date ? new Date(date) : null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return valueToHtml(this[_xfa_object.$content] ? this[_xfa_object.$content].toString() : "");
	  }

	}

	class DateTime extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "dateTime");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    const date = this[_xfa_object.$content].trim();

	    this[_xfa_object.$content] = date ? new Date(date) : null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return valueToHtml(this[_xfa_object.$content] ? this[_xfa_object.$content].toString() : "");
	  }

	}

	class DateTimeEdit extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "dateTimeEdit", true);
	    this.hScrollPolicy = (0, _utils.getStringOption)(attributes.hScrollPolicy, ["auto", "off", "on"]);
	    this.id = attributes.id || "";
	    this.picker = (0, _utils.getStringOption)(attributes.picker, ["host", "none"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.border = null;
	    this.comb = null;
	    this.extras = null;
	    this.margin = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const style = (0, _html_utils.toStyle)(this, "border", "font", "margin");

	    const field = this[_xfa_object.$getParent]()[_xfa_object.$getParent]();

	    const html = {
	      name: "input",
	      attributes: {
	        type: "text",
	        fieldId: field[_xfa_object.$uid],
	        dataId: field[_xfa_object.$data] && field[_xfa_object.$data][_xfa_object.$uid] || field[_xfa_object.$uid],
	        class: ["xfaTextfield"],
	        style,
	        "aria-label": ariaLabel(field),
	        "aria-required": false
	      }
	    };

	    if (isRequired(field)) {
	      html.attributes["aria-required"] = true;
	      html.attributes.required = true;
	    }

	    return _utils.HTMLResult.success({
	      name: "label",
	      attributes: {
	        class: ["xfaLabel"]
	      },
	      children: [html]
	    });
	  }

	}

	class Decimal extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "decimal");
	    this.fracDigits = (0, _utils.getInteger)({
	      data: attributes.fracDigits,
	      defaultValue: 2,
	      validate: x => true
	    });
	    this.id = attributes.id || "";
	    this.leadDigits = (0, _utils.getInteger)({
	      data: attributes.leadDigits,
	      defaultValue: -1,
	      validate: x => true
	    });
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    const number = parseFloat(this[_xfa_object.$content].trim());
	    this[_xfa_object.$content] = isNaN(number) ? null : number;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return valueToHtml(this[_xfa_object.$content] !== null ? this[_xfa_object.$content].toString() : "");
	  }

	}

	class DefaultUi extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "defaultUi", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	  }

	}

	class Desc extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "desc", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.boolean = new _xfa_object.XFAObjectArray();
	    this.date = new _xfa_object.XFAObjectArray();
	    this.dateTime = new _xfa_object.XFAObjectArray();
	    this.decimal = new _xfa_object.XFAObjectArray();
	    this.exData = new _xfa_object.XFAObjectArray();
	    this.float = new _xfa_object.XFAObjectArray();
	    this.image = new _xfa_object.XFAObjectArray();
	    this.integer = new _xfa_object.XFAObjectArray();
	    this.text = new _xfa_object.XFAObjectArray();
	    this.time = new _xfa_object.XFAObjectArray();
	  }

	}

	class DigestMethod extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "digestMethod", ["", "SHA1", "SHA256", "SHA512", "RIPEMD160"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class DigestMethods extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "digestMethods", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.digestMethod = new _xfa_object.XFAObjectArray();
	  }

	}

	class Draw extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "draw", true);
	    this.anchorType = (0, _utils.getStringOption)(attributes.anchorType, ["topLeft", "bottomCenter", "bottomLeft", "bottomRight", "middleCenter", "middleLeft", "middleRight", "topCenter", "topRight"]);
	    this.colSpan = (0, _utils.getInteger)({
	      data: attributes.colSpan,
	      defaultValue: 1,
	      validate: n => n >= 1 || n === -1
	    });
	    this.h = attributes.h ? (0, _utils.getMeasurement)(attributes.h) : "";
	    this.hAlign = (0, _utils.getStringOption)(attributes.hAlign, ["left", "center", "justify", "justifyAll", "radix", "right"]);
	    this.id = attributes.id || "";
	    this.locale = attributes.locale || "";
	    this.maxH = (0, _utils.getMeasurement)(attributes.maxH, "0pt");
	    this.maxW = (0, _utils.getMeasurement)(attributes.maxW, "0pt");
	    this.minH = (0, _utils.getMeasurement)(attributes.minH, "0pt");
	    this.minW = (0, _utils.getMeasurement)(attributes.minW, "0pt");
	    this.name = attributes.name || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.rotate = (0, _utils.getInteger)({
	      data: attributes.rotate,
	      defaultValue: 0,
	      validate: x => x % 90 === 0
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.w = attributes.w ? (0, _utils.getMeasurement)(attributes.w) : "";
	    this.x = (0, _utils.getMeasurement)(attributes.x, "0pt");
	    this.y = (0, _utils.getMeasurement)(attributes.y, "0pt");
	    this.assist = null;
	    this.border = null;
	    this.caption = null;
	    this.desc = null;
	    this.extras = null;
	    this.font = null;
	    this.keep = null;
	    this.margin = null;
	    this.para = null;
	    this.traversal = null;
	    this.ui = null;
	    this.value = null;
	    this.setProperty = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$setValue](value) {
	    _setValue(this, value);
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    setTabIndex(this);

	    if (this.presence === "hidden" || this.presence === "inactive") {
	      return _utils.HTMLResult.EMPTY;
	    }

	    (0, _html_utils.fixDimensions)(this);

	    this[_xfa_object.$pushPara]();

	    const savedW = this.w;
	    const savedH = this.h;
	    const {
	      w,
	      h,
	      isBroken
	    } = (0, _html_utils.layoutNode)(this, availableSpace);

	    if (w && this.w === "") {
	      if (isBroken && this[_xfa_object.$getSubformParent]()[_xfa_object.$isThereMoreWidth]()) {
	        this[_xfa_object.$popPara]();

	        return _utils.HTMLResult.FAILURE;
	      }

	      this.w = w;
	    }

	    if (h && this.h === "") {
	      this.h = h;
	    }

	    setFirstUnsplittable(this);

	    if (!(0, _layout.checkDimensions)(this, availableSpace)) {
	      this.w = savedW;
	      this.h = savedH;

	      this[_xfa_object.$popPara]();

	      return _utils.HTMLResult.FAILURE;
	    }

	    unsetFirstUnsplittable(this);
	    const style = (0, _html_utils.toStyle)(this, "font", "hAlign", "dimensions", "position", "presence", "rotate", "anchorType", "border", "margin");
	    (0, _html_utils.setMinMaxDimensions)(this, style);

	    if (style.margin) {
	      style.padding = style.margin;
	      delete style.margin;
	    }

	    const classNames = ["xfaDraw"];

	    if (this.font) {
	      classNames.push("xfaFont");
	    }

	    if ((0, _html_utils.isPrintOnly)(this)) {
	      classNames.push("xfaPrintOnly");
	    }

	    const attributes = {
	      style,
	      id: this[_xfa_object.$uid],
	      class: classNames
	    };

	    if (this.name) {
	      attributes.xfaName = this.name;
	    }

	    const html = {
	      name: "div",
	      attributes,
	      children: []
	    };
	    applyAssist(this, attributes);
	    const bbox = (0, _html_utils.computeBbox)(this, html, availableSpace);
	    const value = this.value ? this.value[_xfa_object.$toHTML](availableSpace).html : null;

	    if (value === null) {
	      this.w = savedW;
	      this.h = savedH;

	      this[_xfa_object.$popPara]();

	      return _utils.HTMLResult.success((0, _html_utils.createWrapper)(this, html), bbox);
	    }

	    html.children.push(value);
	    (0, _html_utils.setPara)(this, style, value);
	    this.w = savedW;
	    this.h = savedH;

	    this[_xfa_object.$popPara]();

	    return _utils.HTMLResult.success((0, _html_utils.createWrapper)(this, html), bbox);
	  }

	}

	class Edge extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "edge", true);
	    this.cap = (0, _utils.getStringOption)(attributes.cap, ["square", "butt", "round"]);
	    this.id = attributes.id || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.stroke = (0, _utils.getStringOption)(attributes.stroke, ["solid", "dashDot", "dashDotDot", "dashed", "dotted", "embossed", "etched", "lowered", "raised"]);
	    this.thickness = (0, _utils.getMeasurement)(attributes.thickness, "0.5pt");
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.color = null;
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle]() {
	    const style = (0, _html_utils.toStyle)(this, "visibility");
	    Object.assign(style, {
	      linecap: this.cap,
	      width: (0, _html_utils.measureToString)(this.thickness),
	      color: this.color ? this.color[_xfa_object.$toStyle]() : "#000000",
	      style: ""
	    });

	    if (this.presence !== "visible") {
	      style.style = "none";
	    } else {
	      switch (this.stroke) {
	        case "solid":
	          style.style = "solid";
	          break;

	        case "dashDot":
	          style.style = "dashed";
	          break;

	        case "dashDotDot":
	          style.style = "dashed";
	          break;

	        case "dashed":
	          style.style = "dashed";
	          break;

	        case "dotted":
	          style.style = "dotted";
	          break;

	        case "embossed":
	          style.style = "ridge";
	          break;

	        case "etched":
	          style.style = "groove";
	          break;

	        case "lowered":
	          style.style = "inset";
	          break;

	        case "raised":
	          style.style = "outset";
	          break;
	      }
	    }

	    return style;
	  }

	}

	class Encoding extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "encoding", ["adbe.x509.rsa_sha1", "adbe.pkcs7.detached", "adbe.pkcs7.sha1"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Encodings extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "encodings", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.encoding = new _xfa_object.XFAObjectArray();
	  }

	}

	class Encrypt extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "encrypt", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.certificate = null;
	  }

	}

	class EncryptData extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "encryptData", true);
	    this.id = attributes.id || "";
	    this.operation = (0, _utils.getStringOption)(attributes.operation, ["encrypt", "decrypt"]);
	    this.target = attributes.target || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.filter = null;
	    this.manifest = null;
	  }

	}

	class Encryption extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "encryption", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.certificate = new _xfa_object.XFAObjectArray();
	  }

	}

	class EncryptionMethod extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "encryptionMethod", ["", "AES256-CBC", "TRIPLEDES-CBC", "AES128-CBC", "AES192-CBC"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class EncryptionMethods extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "encryptionMethods", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.encryptionMethod = new _xfa_object.XFAObjectArray();
	  }

	}

	class Event extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "event", true);
	    this.activity = (0, _utils.getStringOption)(attributes.activity, ["click", "change", "docClose", "docReady", "enter", "exit", "full", "indexChange", "initialize", "mouseDown", "mouseEnter", "mouseExit", "mouseUp", "postExecute", "postOpen", "postPrint", "postSave", "postSign", "postSubmit", "preExecute", "preOpen", "prePrint", "preSave", "preSign", "preSubmit", "ready", "validationState"]);
	    this.id = attributes.id || "";
	    this.listen = (0, _utils.getStringOption)(attributes.listen, ["refOnly", "refAndDescendents"]);
	    this.name = attributes.name || "";
	    this.ref = attributes.ref || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.encryptData = null;
	    this.execute = null;
	    this.script = null;
	    this.signData = null;
	    this.submit = null;
	  }

	}

	class ExData extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "exData");
	    this.contentType = attributes.contentType || "";
	    this.href = attributes.href || "";
	    this.id = attributes.id || "";
	    this.maxLength = (0, _utils.getInteger)({
	      data: attributes.maxLength,
	      defaultValue: -1,
	      validate: x => x >= -1
	    });
	    this.name = attributes.name || "";
	    this.rid = attributes.rid || "";
	    this.transferEncoding = (0, _utils.getStringOption)(attributes.transferEncoding, ["none", "base64", "package"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$isCDATAXml]() {
	    return this.contentType === "text/html";
	  }

	  [_xfa_object.$onChild](child) {
	    if (this.contentType === "text/html" && child[_xfa_object.$namespaceId] === _namespaces.NamespaceIds.xhtml.id) {
	      this[_xfa_object.$content] = child;
	      return true;
	    }

	    if (this.contentType === "text/xml") {
	      this[_xfa_object.$content] = child;
	      return true;
	    }

	    return false;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    if (this.contentType !== "text/html" || !this[_xfa_object.$content]) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    return this[_xfa_object.$content][_xfa_object.$toHTML](availableSpace);
	  }

	}

	class ExObject extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "exObject", true);
	    this.archive = attributes.archive || "";
	    this.classId = attributes.classId || "";
	    this.codeBase = attributes.codeBase || "";
	    this.codeType = attributes.codeType || "";
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.boolean = new _xfa_object.XFAObjectArray();
	    this.date = new _xfa_object.XFAObjectArray();
	    this.dateTime = new _xfa_object.XFAObjectArray();
	    this.decimal = new _xfa_object.XFAObjectArray();
	    this.exData = new _xfa_object.XFAObjectArray();
	    this.exObject = new _xfa_object.XFAObjectArray();
	    this.float = new _xfa_object.XFAObjectArray();
	    this.image = new _xfa_object.XFAObjectArray();
	    this.integer = new _xfa_object.XFAObjectArray();
	    this.text = new _xfa_object.XFAObjectArray();
	    this.time = new _xfa_object.XFAObjectArray();
	  }

	}

	class ExclGroup extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "exclGroup", true);
	    this.access = (0, _utils.getStringOption)(attributes.access, ["open", "nonInteractive", "protected", "readOnly"]);
	    this.accessKey = attributes.accessKey || "";
	    this.anchorType = (0, _utils.getStringOption)(attributes.anchorType, ["topLeft", "bottomCenter", "bottomLeft", "bottomRight", "middleCenter", "middleLeft", "middleRight", "topCenter", "topRight"]);
	    this.colSpan = (0, _utils.getInteger)({
	      data: attributes.colSpan,
	      defaultValue: 1,
	      validate: n => n >= 1 || n === -1
	    });
	    this.h = attributes.h ? (0, _utils.getMeasurement)(attributes.h) : "";
	    this.hAlign = (0, _utils.getStringOption)(attributes.hAlign, ["left", "center", "justify", "justifyAll", "radix", "right"]);
	    this.id = attributes.id || "";
	    this.layout = (0, _utils.getStringOption)(attributes.layout, ["position", "lr-tb", "rl-row", "rl-tb", "row", "table", "tb"]);
	    this.maxH = (0, _utils.getMeasurement)(attributes.maxH, "0pt");
	    this.maxW = (0, _utils.getMeasurement)(attributes.maxW, "0pt");
	    this.minH = (0, _utils.getMeasurement)(attributes.minH, "0pt");
	    this.minW = (0, _utils.getMeasurement)(attributes.minW, "0pt");
	    this.name = attributes.name || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.w = attributes.w ? (0, _utils.getMeasurement)(attributes.w) : "";
	    this.x = (0, _utils.getMeasurement)(attributes.x, "0pt");
	    this.y = (0, _utils.getMeasurement)(attributes.y, "0pt");
	    this.assist = null;
	    this.bind = null;
	    this.border = null;
	    this.calculate = null;
	    this.caption = null;
	    this.desc = null;
	    this.extras = null;
	    this.margin = null;
	    this.para = null;
	    this.traversal = null;
	    this.validate = null;
	    this.connect = new _xfa_object.XFAObjectArray();
	    this.event = new _xfa_object.XFAObjectArray();
	    this.field = new _xfa_object.XFAObjectArray();
	    this.setProperty = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$isBindable]() {
	    return true;
	  }

	  [_xfa_object.$hasSettableValue]() {
	    return true;
	  }

	  [_xfa_object.$setValue](value) {
	    for (const field of this.field.children) {
	      if (!field.value) {
	        const nodeValue = new Value({});

	        field[_xfa_object.$appendChild](nodeValue);

	        field.value = nodeValue;
	      }

	      field.value[_xfa_object.$setValue](value);
	    }
	  }

	  [_xfa_object.$isThereMoreWidth]() {
	    return this.layout.endsWith("-tb") && this[_xfa_object.$extra].attempt === 0 && this[_xfa_object.$extra].numberInLine > 0 || this[_xfa_object.$getParent]()[_xfa_object.$isThereMoreWidth]();
	  }

	  [_xfa_object.$isSplittable]() {
	    const parent = this[_xfa_object.$getSubformParent]();

	    if (!parent[_xfa_object.$isSplittable]()) {
	      return false;
	    }

	    if (this[_xfa_object.$extra]._isSplittable !== undefined) {
	      return this[_xfa_object.$extra]._isSplittable;
	    }

	    if (this.layout === "position" || this.layout.includes("row")) {
	      this[_xfa_object.$extra]._isSplittable = false;
	      return false;
	    }

	    if (parent.layout && parent.layout.endsWith("-tb") && parent[_xfa_object.$extra].numberInLine !== 0) {
	      return false;
	    }

	    this[_xfa_object.$extra]._isSplittable = true;
	    return true;
	  }

	  [_xfa_object.$flushHTML]() {
	    return (0, _layout.flushHTML)(this);
	  }

	  [_xfa_object.$addHTML](html, bbox) {
	    (0, _layout.addHTML)(this, html, bbox);
	  }

	  [_xfa_object.$getAvailableSpace]() {
	    return (0, _layout.getAvailableSpace)(this);
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    setTabIndex(this);

	    if (this.presence === "hidden" || this.presence === "inactive" || this.h === 0 || this.w === 0) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    (0, _html_utils.fixDimensions)(this);
	    const children = [];
	    const attributes = {
	      id: this[_xfa_object.$uid],
	      class: []
	    };
	    (0, _html_utils.setAccess)(this, attributes.class);

	    if (!this[_xfa_object.$extra]) {
	      this[_xfa_object.$extra] = Object.create(null);
	    }

	    Object.assign(this[_xfa_object.$extra], {
	      children,
	      attributes,
	      attempt: 0,
	      line: null,
	      numberInLine: 0,
	      availableSpace: {
	        width: Math.min(this.w || Infinity, availableSpace.width),
	        height: Math.min(this.h || Infinity, availableSpace.height)
	      },
	      width: 0,
	      height: 0,
	      prevHeight: 0,
	      currentWidth: 0
	    });

	    const isSplittable = this[_xfa_object.$isSplittable]();

	    if (!isSplittable) {
	      setFirstUnsplittable(this);
	    }

	    if (!(0, _layout.checkDimensions)(this, availableSpace)) {
	      return _utils.HTMLResult.FAILURE;
	    }

	    const filter = new Set(["field"]);

	    if (this.layout.includes("row")) {
	      const columnWidths = this[_xfa_object.$getSubformParent]().columnWidths;

	      if (Array.isArray(columnWidths) && columnWidths.length > 0) {
	        this[_xfa_object.$extra].columnWidths = columnWidths;
	        this[_xfa_object.$extra].currentColumn = 0;
	      }
	    }

	    const style = (0, _html_utils.toStyle)(this, "anchorType", "dimensions", "position", "presence", "border", "margin", "hAlign");
	    const classNames = ["xfaExclgroup"];
	    const cl = (0, _html_utils.layoutClass)(this);

	    if (cl) {
	      classNames.push(cl);
	    }

	    if ((0, _html_utils.isPrintOnly)(this)) {
	      classNames.push("xfaPrintOnly");
	    }

	    attributes.style = style;
	    attributes.class = classNames;

	    if (this.name) {
	      attributes.xfaName = this.name;
	    }

	    this[_xfa_object.$pushPara]();

	    const isLrTb = this.layout === "lr-tb" || this.layout === "rl-tb";
	    const maxRun = isLrTb ? MAX_ATTEMPTS_FOR_LRTB_LAYOUT : 1;

	    for (; this[_xfa_object.$extra].attempt < maxRun; this[_xfa_object.$extra].attempt++) {
	      if (isLrTb && this[_xfa_object.$extra].attempt === MAX_ATTEMPTS_FOR_LRTB_LAYOUT - 1) {
	        this[_xfa_object.$extra].numberInLine = 0;
	      }

	      const result = this[_xfa_object.$childrenToHTML]({
	        filter,
	        include: true
	      });

	      if (result.success) {
	        break;
	      }

	      if (result.isBreak()) {
	        this[_xfa_object.$popPara]();

	        return result;
	      }

	      if (isLrTb && this[_xfa_object.$extra].attempt === 0 && this[_xfa_object.$extra].numberInLine === 0 && !this[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].noLayoutFailure) {
	        this[_xfa_object.$extra].attempt = maxRun;
	        break;
	      }
	    }

	    this[_xfa_object.$popPara]();

	    if (!isSplittable) {
	      unsetFirstUnsplittable(this);
	    }

	    if (this[_xfa_object.$extra].attempt === maxRun) {
	      if (!isSplittable) {
	        delete this[_xfa_object.$extra];
	      }

	      return _utils.HTMLResult.FAILURE;
	    }

	    let marginH = 0;
	    let marginV = 0;

	    if (this.margin) {
	      marginH = this.margin.leftInset + this.margin.rightInset;
	      marginV = this.margin.topInset + this.margin.bottomInset;
	    }

	    const width = Math.max(this[_xfa_object.$extra].width + marginH, this.w || 0);
	    const height = Math.max(this[_xfa_object.$extra].height + marginV, this.h || 0);
	    const bbox = [this.x, this.y, width, height];

	    if (this.w === "") {
	      style.width = (0, _html_utils.measureToString)(width);
	    }

	    if (this.h === "") {
	      style.height = (0, _html_utils.measureToString)(height);
	    }

	    const html = {
	      name: "div",
	      attributes,
	      children
	    };
	    applyAssist(this, attributes);
	    delete this[_xfa_object.$extra];
	    return _utils.HTMLResult.success((0, _html_utils.createWrapper)(this, html), bbox);
	  }

	}

	class Execute extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "execute");
	    this.connection = attributes.connection || "";
	    this.executeType = (0, _utils.getStringOption)(attributes.executeType, ["import", "remerge"]);
	    this.id = attributes.id || "";
	    this.runAt = (0, _utils.getStringOption)(attributes.runAt, ["client", "both", "server"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Extras extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "extras", true);
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.boolean = new _xfa_object.XFAObjectArray();
	    this.date = new _xfa_object.XFAObjectArray();
	    this.dateTime = new _xfa_object.XFAObjectArray();
	    this.decimal = new _xfa_object.XFAObjectArray();
	    this.exData = new _xfa_object.XFAObjectArray();
	    this.extras = new _xfa_object.XFAObjectArray();
	    this.float = new _xfa_object.XFAObjectArray();
	    this.image = new _xfa_object.XFAObjectArray();
	    this.integer = new _xfa_object.XFAObjectArray();
	    this.text = new _xfa_object.XFAObjectArray();
	    this.time = new _xfa_object.XFAObjectArray();
	  }

	}

	class Field extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "field", true);
	    this.access = (0, _utils.getStringOption)(attributes.access, ["open", "nonInteractive", "protected", "readOnly"]);
	    this.accessKey = attributes.accessKey || "";
	    this.anchorType = (0, _utils.getStringOption)(attributes.anchorType, ["topLeft", "bottomCenter", "bottomLeft", "bottomRight", "middleCenter", "middleLeft", "middleRight", "topCenter", "topRight"]);
	    this.colSpan = (0, _utils.getInteger)({
	      data: attributes.colSpan,
	      defaultValue: 1,
	      validate: n => n >= 1 || n === -1
	    });
	    this.h = attributes.h ? (0, _utils.getMeasurement)(attributes.h) : "";
	    this.hAlign = (0, _utils.getStringOption)(attributes.hAlign, ["left", "center", "justify", "justifyAll", "radix", "right"]);
	    this.id = attributes.id || "";
	    this.locale = attributes.locale || "";
	    this.maxH = (0, _utils.getMeasurement)(attributes.maxH, "0pt");
	    this.maxW = (0, _utils.getMeasurement)(attributes.maxW, "0pt");
	    this.minH = (0, _utils.getMeasurement)(attributes.minH, "0pt");
	    this.minW = (0, _utils.getMeasurement)(attributes.minW, "0pt");
	    this.name = attributes.name || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.rotate = (0, _utils.getInteger)({
	      data: attributes.rotate,
	      defaultValue: 0,
	      validate: x => x % 90 === 0
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.w = attributes.w ? (0, _utils.getMeasurement)(attributes.w) : "";
	    this.x = (0, _utils.getMeasurement)(attributes.x, "0pt");
	    this.y = (0, _utils.getMeasurement)(attributes.y, "0pt");
	    this.assist = null;
	    this.bind = null;
	    this.border = null;
	    this.calculate = null;
	    this.caption = null;
	    this.desc = null;
	    this.extras = null;
	    this.font = null;
	    this.format = null;
	    this.items = new _xfa_object.XFAObjectArray(2);
	    this.keep = null;
	    this.margin = null;
	    this.para = null;
	    this.traversal = null;
	    this.ui = null;
	    this.validate = null;
	    this.value = null;
	    this.bindItems = new _xfa_object.XFAObjectArray();
	    this.connect = new _xfa_object.XFAObjectArray();
	    this.event = new _xfa_object.XFAObjectArray();
	    this.setProperty = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$isBindable]() {
	    return true;
	  }

	  [_xfa_object.$setValue](value) {
	    _setValue(this, value);
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    setTabIndex(this);

	    if (!this.ui) {
	      this.ui = new Ui({});
	      this.ui[_xfa_object.$globalData] = this[_xfa_object.$globalData];

	      this[_xfa_object.$appendChild](this.ui);

	      let node;

	      switch (this.items.children.length) {
	        case 0:
	          node = new TextEdit({});
	          this.ui.textEdit = node;
	          break;

	        case 1:
	          node = new CheckButton({});
	          this.ui.checkButton = node;
	          break;

	        case 2:
	          node = new ChoiceList({});
	          this.ui.choiceList = node;
	          break;
	      }

	      this.ui[_xfa_object.$appendChild](node);
	    }

	    if (!this.ui || this.presence === "hidden" || this.presence === "inactive" || this.h === 0 || this.w === 0) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    if (this.caption) {
	      delete this.caption[_xfa_object.$extra];
	    }

	    this[_xfa_object.$pushPara]();

	    const caption = this.caption ? this.caption[_xfa_object.$toHTML](availableSpace).html : null;
	    const savedW = this.w;
	    const savedH = this.h;
	    let marginH = 0;
	    let marginV = 0;

	    if (this.margin) {
	      marginH = this.margin.leftInset + this.margin.rightInset;
	      marginV = this.margin.topInset + this.margin.bottomInset;
	    }

	    let borderDims = null;

	    if (this.w === "" || this.h === "") {
	      let width = null;
	      let height = null;
	      let uiW = 0;
	      let uiH = 0;

	      if (this.ui.checkButton) {
	        uiW = uiH = this.ui.checkButton.size;
	      } else {
	        const {
	          w,
	          h
	        } = (0, _html_utils.layoutNode)(this, availableSpace);

	        if (w !== null) {
	          uiW = w;
	          uiH = h;
	        } else {
	          uiH = (0, _fonts.getMetrics)(this.font, true).lineNoGap;
	        }
	      }

	      borderDims = getBorderDims(this.ui[_xfa_object.$getExtra]());
	      uiW += borderDims.w;
	      uiH += borderDims.h;

	      if (this.caption) {
	        const {
	          w,
	          h,
	          isBroken
	        } = this.caption[_xfa_object.$getExtra](availableSpace);

	        if (isBroken && this[_xfa_object.$getSubformParent]()[_xfa_object.$isThereMoreWidth]()) {
	          this[_xfa_object.$popPara]();

	          return _utils.HTMLResult.FAILURE;
	        }

	        width = w;
	        height = h;

	        switch (this.caption.placement) {
	          case "left":
	          case "right":
	          case "inline":
	            width += uiW;
	            break;

	          case "top":
	          case "bottom":
	            height += uiH;
	            break;
	        }
	      } else {
	        width = uiW;
	        height = uiH;
	      }

	      if (width && this.w === "") {
	        width += marginH;
	        this.w = Math.min(this.maxW <= 0 ? Infinity : this.maxW, this.minW + 1 < width ? width : this.minW);
	      }

	      if (height && this.h === "") {
	        height += marginV;
	        this.h = Math.min(this.maxH <= 0 ? Infinity : this.maxH, this.minH + 1 < height ? height : this.minH);
	      }
	    }

	    this[_xfa_object.$popPara]();

	    (0, _html_utils.fixDimensions)(this);
	    setFirstUnsplittable(this);

	    if (!(0, _layout.checkDimensions)(this, availableSpace)) {
	      this.w = savedW;
	      this.h = savedH;

	      this[_xfa_object.$popPara]();

	      return _utils.HTMLResult.FAILURE;
	    }

	    unsetFirstUnsplittable(this);
	    const style = (0, _html_utils.toStyle)(this, "font", "dimensions", "position", "rotate", "anchorType", "presence", "margin", "hAlign");
	    (0, _html_utils.setMinMaxDimensions)(this, style);
	    const classNames = ["xfaField"];

	    if (this.font) {
	      classNames.push("xfaFont");
	    }

	    if ((0, _html_utils.isPrintOnly)(this)) {
	      classNames.push("xfaPrintOnly");
	    }

	    const attributes = {
	      style,
	      id: this[_xfa_object.$uid],
	      class: classNames
	    };

	    if (style.margin) {
	      style.padding = style.margin;
	      delete style.margin;
	    }

	    (0, _html_utils.setAccess)(this, classNames);

	    if (this.name) {
	      attributes.xfaName = this.name;
	    }

	    const children = [];
	    const html = {
	      name: "div",
	      attributes,
	      children
	    };
	    applyAssist(this, attributes);
	    const borderStyle = this.border ? this.border[_xfa_object.$toStyle]() : null;
	    const bbox = (0, _html_utils.computeBbox)(this, html, availableSpace);

	    const ui = this.ui[_xfa_object.$toHTML]().html;

	    if (!ui) {
	      Object.assign(style, borderStyle);
	      return _utils.HTMLResult.success((0, _html_utils.createWrapper)(this, html), bbox);
	    }

	    if (this[_xfa_object.$tabIndex]) {
	      if (ui.children && ui.children[0]) {
	        ui.children[0].attributes.tabindex = this[_xfa_object.$tabIndex];
	      } else {
	        ui.attributes.tabindex = this[_xfa_object.$tabIndex];
	      }
	    }

	    if (!ui.attributes.style) {
	      ui.attributes.style = Object.create(null);
	    }

	    let aElement = null;

	    if (this.ui.button) {
	      if (ui.children.length === 1) {
	        [aElement] = ui.children.splice(0, 1);
	      }

	      Object.assign(ui.attributes.style, borderStyle);
	    } else {
	      Object.assign(style, borderStyle);
	    }

	    children.push(ui);

	    if (this.value) {
	      if (this.ui.imageEdit) {
	        ui.children.push(this.value[_xfa_object.$toHTML]().html);
	      } else if (!this.ui.button) {
	        let value = "";

	        if (this.value.exData) {
	          value = this.value.exData[_xfa_object.$text]();
	        } else if (this.value.text) {
	          value = this.value.text[_xfa_object.$getExtra]();
	        } else {
	          const htmlValue = this.value[_xfa_object.$toHTML]().html;

	          if (htmlValue !== null) {
	            value = htmlValue.children[0].value;
	          }
	        }

	        if (this.ui.textEdit && this.value.text && this.value.text.maxChars) {
	          ui.children[0].attributes.maxLength = this.value.text.maxChars;
	        }

	        if (value) {
	          if (this.ui.numericEdit) {
	            value = parseFloat(value);
	            value = isNaN(value) ? "" : value.toString();
	          }

	          if (ui.children[0].name === "textarea") {
	            ui.children[0].attributes.textContent = value;
	          } else {
	            ui.children[0].attributes.value = value;
	          }
	        }
	      }
	    }

	    if (!this.ui.imageEdit && ui.children && ui.children[0] && this.h) {
	      borderDims = borderDims || getBorderDims(this.ui[_xfa_object.$getExtra]());
	      let captionHeight = 0;

	      if (this.caption && ["top", "bottom"].includes(this.caption.placement)) {
	        captionHeight = this.caption.reserve;

	        if (captionHeight <= 0) {
	          captionHeight = this.caption[_xfa_object.$getExtra](availableSpace).h;
	        }

	        const inputHeight = this.h - captionHeight - marginV - borderDims.h;
	        ui.children[0].attributes.style.height = (0, _html_utils.measureToString)(inputHeight);
	      } else {
	        ui.children[0].attributes.style.height = "100%";
	      }
	    }

	    if (aElement) {
	      ui.children.push(aElement);
	    }

	    if (!caption) {
	      if (ui.attributes.class) {
	        ui.attributes.class.push("xfaLeft");
	      }

	      this.w = savedW;
	      this.h = savedH;
	      return _utils.HTMLResult.success((0, _html_utils.createWrapper)(this, html), bbox);
	    }

	    if (this.ui.button) {
	      if (style.padding) {
	        delete style.padding;
	      }

	      if (caption.name === "div") {
	        caption.name = "span";
	      }

	      ui.children.push(caption);
	      return _utils.HTMLResult.success(html, bbox);
	    } else if (this.ui.checkButton) {
	      caption.attributes.class[0] = "xfaCaptionForCheckButton";
	    }

	    if (!ui.attributes.class) {
	      ui.attributes.class = [];
	    }

	    ui.children.splice(0, 0, caption);

	    switch (this.caption.placement) {
	      case "left":
	        ui.attributes.class.push("xfaLeft");
	        break;

	      case "right":
	        ui.attributes.class.push("xfaRight");
	        break;

	      case "top":
	        ui.attributes.class.push("xfaTop");
	        break;

	      case "bottom":
	        ui.attributes.class.push("xfaBottom");
	        break;

	      case "inline":
	        ui.attributes.class.push("xfaLeft");
	        break;
	    }

	    this.w = savedW;
	    this.h = savedH;
	    return _utils.HTMLResult.success((0, _html_utils.createWrapper)(this, html), bbox);
	  }

	}

	exports.Field = Field;

	class Fill extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "fill", true);
	    this.id = attributes.id || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.color = null;
	    this.extras = null;
	    this.linear = null;
	    this.pattern = null;
	    this.radial = null;
	    this.solid = null;
	    this.stipple = null;
	  }

	  [_xfa_object.$toStyle]() {
	    const parent = this[_xfa_object.$getParent]();

	    const grandpa = parent[_xfa_object.$getParent]();

	    const ggrandpa = grandpa[_xfa_object.$getParent]();

	    const style = Object.create(null);
	    let propName = "color";
	    let altPropName = propName;

	    if (parent instanceof Border) {
	      propName = "background-color";
	      altPropName = "background";

	      if (ggrandpa instanceof Ui) {
	        style.backgroundColor = "white";
	      }
	    }

	    if (parent instanceof Rectangle || parent instanceof Arc) {
	      propName = altPropName = "fill";
	      style.fill = "white";
	    }

	    for (const name of Object.getOwnPropertyNames(this)) {
	      if (name === "extras" || name === "color") {
	        continue;
	      }

	      const obj = this[name];

	      if (!(obj instanceof _xfa_object.XFAObject)) {
	        continue;
	      }

	      const color = obj[_xfa_object.$toStyle](this.color);

	      if (color) {
	        style[color.startsWith("#") ? propName : altPropName] = color;
	      }

	      return style;
	    }

	    if (this.color && this.color.value) {
	      const color = this.color[_xfa_object.$toStyle]();

	      style[color.startsWith("#") ? propName : altPropName] = color;
	    }

	    return style;
	  }

	}

	class Filter extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "filter", true);
	    this.addRevocationInfo = (0, _utils.getStringOption)(attributes.addRevocationInfo, ["", "required", "optional", "none"]);
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.version = (0, _utils.getInteger)({
	      data: this.version,
	      defaultValue: 5,
	      validate: x => x >= 1 && x <= 5
	    });
	    this.appearanceFilter = null;
	    this.certificates = null;
	    this.digestMethods = null;
	    this.encodings = null;
	    this.encryptionMethods = null;
	    this.handler = null;
	    this.lockDocument = null;
	    this.mdp = null;
	    this.reasons = null;
	    this.timeStamp = null;
	  }

	}

	class Float extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "float");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    const number = parseFloat(this[_xfa_object.$content].trim());
	    this[_xfa_object.$content] = isNaN(number) ? null : number;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return valueToHtml(this[_xfa_object.$content] !== null ? this[_xfa_object.$content].toString() : "");
	  }

	}

	class Font extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "font", true);
	    this.baselineShift = (0, _utils.getMeasurement)(attributes.baselineShift);
	    this.fontHorizontalScale = (0, _utils.getFloat)({
	      data: attributes.fontHorizontalScale,
	      defaultValue: 100,
	      validate: x => x >= 0
	    });
	    this.fontVerticalScale = (0, _utils.getFloat)({
	      data: attributes.fontVerticalScale,
	      defaultValue: 100,
	      validate: x => x >= 0
	    });
	    this.id = attributes.id || "";
	    this.kerningMode = (0, _utils.getStringOption)(attributes.kerningMode, ["none", "pair"]);
	    this.letterSpacing = (0, _utils.getMeasurement)(attributes.letterSpacing, "0");
	    this.lineThrough = (0, _utils.getInteger)({
	      data: attributes.lineThrough,
	      defaultValue: 0,
	      validate: x => x === 1 || x === 2
	    });
	    this.lineThroughPeriod = (0, _utils.getStringOption)(attributes.lineThroughPeriod, ["all", "word"]);
	    this.overline = (0, _utils.getInteger)({
	      data: attributes.overline,
	      defaultValue: 0,
	      validate: x => x === 1 || x === 2
	    });
	    this.overlinePeriod = (0, _utils.getStringOption)(attributes.overlinePeriod, ["all", "word"]);
	    this.posture = (0, _utils.getStringOption)(attributes.posture, ["normal", "italic"]);
	    this.size = (0, _utils.getMeasurement)(attributes.size, "10pt");
	    this.typeface = attributes.typeface || "Courier";
	    this.underline = (0, _utils.getInteger)({
	      data: attributes.underline,
	      defaultValue: 0,
	      validate: x => x === 1 || x === 2
	    });
	    this.underlinePeriod = (0, _utils.getStringOption)(attributes.underlinePeriod, ["all", "word"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.weight = (0, _utils.getStringOption)(attributes.weight, ["normal", "bold"]);
	    this.extras = null;
	    this.fill = null;
	  }

	  [_xfa_object.$clean](builder) {
	    super[_xfa_object.$clean](builder);

	    this[_xfa_object.$globalData].usedTypefaces.add(this.typeface);
	  }

	  [_xfa_object.$toStyle]() {
	    const style = (0, _html_utils.toStyle)(this, "fill");
	    const color = style.color;

	    if (color) {
	      if (color === "#000000") {
	        delete style.color;
	      } else if (!color.startsWith("#")) {
	        style.background = color;
	        style.backgroundClip = "text";
	        style.color = "transparent";
	      }
	    }

	    if (this.baselineShift) {
	      style.verticalAlign = (0, _html_utils.measureToString)(this.baselineShift);
	    }

	    style.fontKerning = this.kerningMode === "none" ? "none" : "normal";
	    style.letterSpacing = (0, _html_utils.measureToString)(this.letterSpacing);

	    if (this.lineThrough !== 0) {
	      style.textDecoration = "line-through";

	      if (this.lineThrough === 2) {
	        style.textDecorationStyle = "double";
	      }
	    }

	    if (this.overline !== 0) {
	      style.textDecoration = "overline";

	      if (this.overline === 2) {
	        style.textDecorationStyle = "double";
	      }
	    }

	    style.fontStyle = this.posture;
	    style.fontSize = (0, _html_utils.measureToString)(0.99 * this.size);
	    (0, _html_utils.setFontFamily)(this, this, this[_xfa_object.$globalData].fontFinder, style);

	    if (this.underline !== 0) {
	      style.textDecoration = "underline";

	      if (this.underline === 2) {
	        style.textDecorationStyle = "double";
	      }
	    }

	    style.fontWeight = this.weight;
	    return style;
	  }

	}

	class Format extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "format", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.picture = null;
	  }

	}

	class Handler extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "handler");
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Hyphenation extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "hyphenation");
	    this.excludeAllCaps = (0, _utils.getInteger)({
	      data: attributes.excludeAllCaps,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.excludeInitialCap = (0, _utils.getInteger)({
	      data: attributes.excludeInitialCap,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.hyphenate = (0, _utils.getInteger)({
	      data: attributes.hyphenate,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.id = attributes.id || "";
	    this.pushCharacterCount = (0, _utils.getInteger)({
	      data: attributes.pushCharacterCount,
	      defaultValue: 3,
	      validate: x => x >= 0
	    });
	    this.remainCharacterCount = (0, _utils.getInteger)({
	      data: attributes.remainCharacterCount,
	      defaultValue: 3,
	      validate: x => x >= 0
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.wordCharacterCount = (0, _utils.getInteger)({
	      data: attributes.wordCharacterCount,
	      defaultValue: 7,
	      validate: x => x >= 0
	    });
	  }

	}

	class Image extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "image");
	    this.aspect = (0, _utils.getStringOption)(attributes.aspect, ["fit", "actual", "height", "none", "width"]);
	    this.contentType = attributes.contentType || "";
	    this.href = attributes.href || "";
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.transferEncoding = (0, _utils.getStringOption)(attributes.transferEncoding, ["base64", "none", "package"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$toHTML]() {
	    if (this.contentType && !MIMES.has(this.contentType.toLowerCase())) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    let buffer = this[_xfa_object.$globalData].images && this[_xfa_object.$globalData].images.get(this.href);

	    if (!buffer && (this.href || !this[_xfa_object.$content])) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    if (!buffer && this.transferEncoding === "base64") {
	      buffer = (0, _util.stringToBytes)(atob(this[_xfa_object.$content]));
	    }

	    if (!buffer) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    if (!this.contentType) {
	      for (const [header, type] of IMAGES_HEADERS) {
	        if (buffer.length > header.length && header.every((x, i) => x === buffer[i])) {
	          this.contentType = type;
	          break;
	        }
	      }

	      if (!this.contentType) {
	        return _utils.HTMLResult.EMPTY;
	      }
	    }

	    const blob = new Blob([buffer], {
	      type: this.contentType
	    });
	    let style;

	    switch (this.aspect) {
	      case "fit":
	      case "actual":
	        break;

	      case "height":
	        style = {
	          height: "100%",
	          objectFit: "fill"
	        };
	        break;

	      case "none":
	        style = {
	          width: "100%",
	          height: "100%",
	          objectFit: "fill"
	        };
	        break;

	      case "width":
	        style = {
	          width: "100%",
	          objectFit: "fill"
	        };
	        break;
	    }

	    const parent = this[_xfa_object.$getParent]();

	    return _utils.HTMLResult.success({
	      name: "img",
	      attributes: {
	        class: ["xfaImage"],
	        style,
	        src: URL.createObjectURL(blob),
	        alt: parent ? ariaLabel(parent[_xfa_object.$getParent]()) : null
	      }
	    });
	  }

	}

	class ImageEdit extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "imageEdit", true);
	    this.data = (0, _utils.getStringOption)(attributes.data, ["link", "embed"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.border = null;
	    this.extras = null;
	    this.margin = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    if (this.data === "embed") {
	      return _utils.HTMLResult.success({
	        name: "div",
	        children: [],
	        attributes: {}
	      });
	    }

	    return _utils.HTMLResult.EMPTY;
	  }

	}

	class Integer extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "integer");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    const number = parseInt(this[_xfa_object.$content].trim(), 10);
	    this[_xfa_object.$content] = isNaN(number) ? null : number;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return valueToHtml(this[_xfa_object.$content] !== null ? this[_xfa_object.$content].toString() : "");
	  }

	}

	class Issuers extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "issuers", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.certificate = new _xfa_object.XFAObjectArray();
	  }

	}

	class Items extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "items", true);
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.ref = attributes.ref || "";
	    this.save = (0, _utils.getInteger)({
	      data: attributes.save,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.boolean = new _xfa_object.XFAObjectArray();
	    this.date = new _xfa_object.XFAObjectArray();
	    this.dateTime = new _xfa_object.XFAObjectArray();
	    this.decimal = new _xfa_object.XFAObjectArray();
	    this.exData = new _xfa_object.XFAObjectArray();
	    this.float = new _xfa_object.XFAObjectArray();
	    this.image = new _xfa_object.XFAObjectArray();
	    this.integer = new _xfa_object.XFAObjectArray();
	    this.text = new _xfa_object.XFAObjectArray();
	    this.time = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$toHTML]() {
	    const output = [];

	    for (const child of this[_xfa_object.$getChildren]()) {
	      output.push(child[_xfa_object.$text]());
	    }

	    return _utils.HTMLResult.success(output);
	  }

	}

	exports.Items = Items;

	class Keep extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "keep", true);
	    this.id = attributes.id || "";
	    const options = ["none", "contentArea", "pageArea"];
	    this.intact = (0, _utils.getStringOption)(attributes.intact, options);
	    this.next = (0, _utils.getStringOption)(attributes.next, options);
	    this.previous = (0, _utils.getStringOption)(attributes.previous, options);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	  }

	}

	class KeyUsage extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "keyUsage");
	    const options = ["", "yes", "no"];
	    this.crlSign = (0, _utils.getStringOption)(attributes.crlSign, options);
	    this.dataEncipherment = (0, _utils.getStringOption)(attributes.dataEncipherment, options);
	    this.decipherOnly = (0, _utils.getStringOption)(attributes.decipherOnly, options);
	    this.digitalSignature = (0, _utils.getStringOption)(attributes.digitalSignature, options);
	    this.encipherOnly = (0, _utils.getStringOption)(attributes.encipherOnly, options);
	    this.id = attributes.id || "";
	    this.keyAgreement = (0, _utils.getStringOption)(attributes.keyAgreement, options);
	    this.keyCertSign = (0, _utils.getStringOption)(attributes.keyCertSign, options);
	    this.keyEncipherment = (0, _utils.getStringOption)(attributes.keyEncipherment, options);
	    this.nonRepudiation = (0, _utils.getStringOption)(attributes.nonRepudiation, options);
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Line extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "line", true);
	    this.hand = (0, _utils.getStringOption)(attributes.hand, ["even", "left", "right"]);
	    this.id = attributes.id || "";
	    this.slope = (0, _utils.getStringOption)(attributes.slope, ["\\", "/"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.edge = null;
	  }

	  [_xfa_object.$toHTML]() {
	    const parent = this[_xfa_object.$getParent]()[_xfa_object.$getParent]();

	    const edge = this.edge || new Edge({});

	    const edgeStyle = edge[_xfa_object.$toStyle]();

	    const style = Object.create(null);
	    const thickness = edge.presence === "visible" ? edge.thickness : 0;
	    style.strokeWidth = (0, _html_utils.measureToString)(thickness);
	    style.stroke = edgeStyle.color;
	    let x1, y1, x2, y2;
	    let width = "100%";
	    let height = "100%";

	    if (parent.w <= thickness) {
	      [x1, y1, x2, y2] = ["50%", 0, "50%", "100%"];
	      width = style.strokeWidth;
	    } else if (parent.h <= thickness) {
	      [x1, y1, x2, y2] = [0, "50%", "100%", "50%"];
	      height = style.strokeWidth;
	    } else {
	      if (this.slope === "\\") {
	        [x1, y1, x2, y2] = [0, 0, "100%", "100%"];
	      } else {
	        [x1, y1, x2, y2] = [0, "100%", "100%", 0];
	      }
	    }

	    const line = {
	      name: "line",
	      attributes: {
	        xmlns: SVG_NS,
	        x1,
	        y1,
	        x2,
	        y2,
	        style
	      }
	    };
	    const svg = {
	      name: "svg",
	      children: [line],
	      attributes: {
	        xmlns: SVG_NS,
	        width,
	        height,
	        style: {
	          overflow: "visible"
	        }
	      }
	    };

	    if (hasMargin(parent)) {
	      return _utils.HTMLResult.success({
	        name: "div",
	        attributes: {
	          style: {
	            display: "inline",
	            width: "100%",
	            height: "100%"
	          }
	        },
	        children: [svg]
	      });
	    }

	    svg.attributes.style.position = "absolute";
	    return _utils.HTMLResult.success(svg);
	  }

	}

	class Linear extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "linear", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["toRight", "toBottom", "toLeft", "toTop"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.color = null;
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle](startColor) {
	    startColor = startColor ? startColor[_xfa_object.$toStyle]() : "#FFFFFF";
	    const transf = this.type.replace(/([RBLT])/, " $1").toLowerCase();
	    const endColor = this.color ? this.color[_xfa_object.$toStyle]() : "#000000";
	    return `linear-gradient(${transf}, ${startColor}, ${endColor})`;
	  }

	}

	class LockDocument extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "lockDocument");
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = (0, _utils.getStringOption)(this[_xfa_object.$content], ["auto", "0", "1"]);
	  }

	}

	class Manifest extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "manifest", true);
	    this.action = (0, _utils.getStringOption)(attributes.action, ["include", "all", "exclude"]);
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.ref = new _xfa_object.XFAObjectArray();
	  }

	}

	class Margin extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "margin", true);
	    this.bottomInset = (0, _utils.getMeasurement)(attributes.bottomInset, "0");
	    this.id = attributes.id || "";
	    this.leftInset = (0, _utils.getMeasurement)(attributes.leftInset, "0");
	    this.rightInset = (0, _utils.getMeasurement)(attributes.rightInset, "0");
	    this.topInset = (0, _utils.getMeasurement)(attributes.topInset, "0");
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle]() {
	    return {
	      margin: (0, _html_utils.measureToString)(this.topInset) + " " + (0, _html_utils.measureToString)(this.rightInset) + " " + (0, _html_utils.measureToString)(this.bottomInset) + " " + (0, _html_utils.measureToString)(this.leftInset)
	    };
	  }

	}

	class Mdp extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "mdp");
	    this.id = attributes.id || "";
	    this.permissions = (0, _utils.getInteger)({
	      data: attributes.permissions,
	      defaultValue: 2,
	      validate: x => x === 1 || x === 3
	    });
	    this.signatureType = (0, _utils.getStringOption)(attributes.signatureType, ["filler", "author"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Medium extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "medium");
	    this.id = attributes.id || "";
	    this.imagingBBox = (0, _utils.getBBox)(attributes.imagingBBox);
	    this.long = (0, _utils.getMeasurement)(attributes.long);
	    this.orientation = (0, _utils.getStringOption)(attributes.orientation, ["portrait", "landscape"]);
	    this.short = (0, _utils.getMeasurement)(attributes.short);
	    this.stock = attributes.stock || "";
	    this.trayIn = (0, _utils.getStringOption)(attributes.trayIn, ["auto", "delegate", "pageFront"]);
	    this.trayOut = (0, _utils.getStringOption)(attributes.trayOut, ["auto", "delegate"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Message extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "message", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.text = new _xfa_object.XFAObjectArray();
	  }

	}

	class NumericEdit extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "numericEdit", true);
	    this.hScrollPolicy = (0, _utils.getStringOption)(attributes.hScrollPolicy, ["auto", "off", "on"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.border = null;
	    this.comb = null;
	    this.extras = null;
	    this.margin = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const style = (0, _html_utils.toStyle)(this, "border", "font", "margin");

	    const field = this[_xfa_object.$getParent]()[_xfa_object.$getParent]();

	    const html = {
	      name: "input",
	      attributes: {
	        type: "text",
	        fieldId: field[_xfa_object.$uid],
	        dataId: field[_xfa_object.$data] && field[_xfa_object.$data][_xfa_object.$uid] || field[_xfa_object.$uid],
	        class: ["xfaTextfield"],
	        style,
	        "aria-label": ariaLabel(field),
	        "aria-required": false
	      }
	    };

	    if (isRequired(field)) {
	      html.attributes["aria-required"] = true;
	      html.attributes.required = true;
	    }

	    return _utils.HTMLResult.success({
	      name: "label",
	      attributes: {
	        class: ["xfaLabel"]
	      },
	      children: [html]
	    });
	  }

	}

	class Occur extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "occur", true);
	    this.id = attributes.id || "";
	    this.initial = attributes.initial !== "" ? (0, _utils.getInteger)({
	      data: attributes.initial,
	      defaultValue: "",
	      validate: x => true
	    }) : "";
	    this.max = attributes.max !== "" ? (0, _utils.getInteger)({
	      data: attributes.max,
	      defaultValue: 1,
	      validate: x => true
	    }) : "";
	    this.min = attributes.min !== "" ? (0, _utils.getInteger)({
	      data: attributes.min,
	      defaultValue: 1,
	      validate: x => true
	    }) : "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	  }

	  [_xfa_object.$clean]() {
	    const parent = this[_xfa_object.$getParent]();

	    const originalMin = this.min;

	    if (this.min === "") {
	      this.min = parent instanceof PageArea || parent instanceof PageSet ? 0 : 1;
	    }

	    if (this.max === "") {
	      if (originalMin === "") {
	        this.max = parent instanceof PageArea || parent instanceof PageSet ? -1 : 1;
	      } else {
	        this.max = this.min;
	      }
	    }

	    if (this.max !== -1 && this.max < this.min) {
	      this.max = this.min;
	    }

	    if (this.initial === "") {
	      this.initial = parent instanceof Template ? 1 : this.min;
	    }
	  }

	}

	class Oid extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "oid");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Oids extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "oids", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.oid = new _xfa_object.XFAObjectArray();
	  }

	}

	class Overflow extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "overflow");
	    this.id = attributes.id || "";
	    this.leader = attributes.leader || "";
	    this.target = attributes.target || "";
	    this.trailer = attributes.trailer || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$getExtra]() {
	    if (!this[_xfa_object.$extra]) {
	      const parent = this[_xfa_object.$getParent]();

	      const root = this[_xfa_object.$getTemplateRoot]();

	      const target = root[_xfa_object.$searchNode](this.target, parent);

	      const leader = root[_xfa_object.$searchNode](this.leader, parent);

	      const trailer = root[_xfa_object.$searchNode](this.trailer, parent);

	      this[_xfa_object.$extra] = {
	        target: target && target[0] || null,
	        leader: leader && leader[0] || null,
	        trailer: trailer && trailer[0] || null,
	        addLeader: false,
	        addTrailer: false
	      };
	    }

	    return this[_xfa_object.$extra];
	  }

	}

	class PageArea extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "pageArea", true);
	    this.blankOrNotBlank = (0, _utils.getStringOption)(attributes.blankOrNotBlank, ["any", "blank", "notBlank"]);
	    this.id = attributes.id || "";
	    this.initialNumber = (0, _utils.getInteger)({
	      data: attributes.initialNumber,
	      defaultValue: 1,
	      validate: x => true
	    });
	    this.name = attributes.name || "";
	    this.numbered = (0, _utils.getInteger)({
	      data: attributes.numbered,
	      defaultValue: 1,
	      validate: x => true
	    });
	    this.oddOrEven = (0, _utils.getStringOption)(attributes.oddOrEven, ["any", "even", "odd"]);
	    this.pagePosition = (0, _utils.getStringOption)(attributes.pagePosition, ["any", "first", "last", "only", "rest"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.desc = null;
	    this.extras = null;
	    this.medium = null;
	    this.occur = null;
	    this.area = new _xfa_object.XFAObjectArray();
	    this.contentArea = new _xfa_object.XFAObjectArray();
	    this.draw = new _xfa_object.XFAObjectArray();
	    this.exclGroup = new _xfa_object.XFAObjectArray();
	    this.field = new _xfa_object.XFAObjectArray();
	    this.subform = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$isUsable]() {
	    if (!this[_xfa_object.$extra]) {
	      this[_xfa_object.$extra] = {
	        numberOfUse: 0
	      };
	      return true;
	    }

	    return !this.occur || this.occur.max === -1 || this[_xfa_object.$extra].numberOfUse < this.occur.max;
	  }

	  [_xfa_object.$cleanPage]() {
	    delete this[_xfa_object.$extra];
	  }

	  [_xfa_object.$getNextPage]() {
	    if (!this[_xfa_object.$extra]) {
	      this[_xfa_object.$extra] = {
	        numberOfUse: 0
	      };
	    }

	    const parent = this[_xfa_object.$getParent]();

	    if (parent.relation === "orderedOccurrence") {
	      if (this[_xfa_object.$isUsable]()) {
	        this[_xfa_object.$extra].numberOfUse += 1;
	        return this;
	      }
	    }

	    return parent[_xfa_object.$getNextPage]();
	  }

	  [_xfa_object.$getAvailableSpace]() {
	    return this[_xfa_object.$extra].space || {
	      width: 0,
	      height: 0
	    };
	  }

	  [_xfa_object.$toHTML]() {
	    if (!this[_xfa_object.$extra]) {
	      this[_xfa_object.$extra] = {
	        numberOfUse: 1
	      };
	    }

	    const children = [];
	    this[_xfa_object.$extra].children = children;
	    const style = Object.create(null);

	    if (this.medium && this.medium.short && this.medium.long) {
	      style.width = (0, _html_utils.measureToString)(this.medium.short);
	      style.height = (0, _html_utils.measureToString)(this.medium.long);
	      this[_xfa_object.$extra].space = {
	        width: this.medium.short,
	        height: this.medium.long
	      };

	      if (this.medium.orientation === "landscape") {
	        const x = style.width;
	        style.width = style.height;
	        style.height = x;
	        this[_xfa_object.$extra].space = {
	          width: this.medium.long,
	          height: this.medium.short
	        };
	      }
	    } else {
	      (0, _util.warn)("XFA - No medium specified in pageArea: please file a bug.");
	    }

	    this[_xfa_object.$childrenToHTML]({
	      filter: new Set(["area", "draw", "field", "subform"]),
	      include: true
	    });

	    this[_xfa_object.$childrenToHTML]({
	      filter: new Set(["contentArea"]),
	      include: true
	    });

	    return _utils.HTMLResult.success({
	      name: "div",
	      children,
	      attributes: {
	        class: ["xfaPage"],
	        id: this[_xfa_object.$uid],
	        style,
	        xfaName: this.name
	      }
	    });
	  }

	}

	class PageSet extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "pageSet", true);
	    this.duplexImposition = (0, _utils.getStringOption)(attributes.duplexImposition, ["longEdge", "shortEdge"]);
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.relation = (0, _utils.getStringOption)(attributes.relation, ["orderedOccurrence", "duplexPaginated", "simplexPaginated"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.occur = null;
	    this.pageArea = new _xfa_object.XFAObjectArray();
	    this.pageSet = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$cleanPage]() {
	    for (const page of this.pageArea.children) {
	      page[_xfa_object.$cleanPage]();
	    }

	    for (const page of this.pageSet.children) {
	      page[_xfa_object.$cleanPage]();
	    }
	  }

	  [_xfa_object.$isUsable]() {
	    return !this.occur || this.occur.max === -1 || this[_xfa_object.$extra].numberOfUse < this.occur.max;
	  }

	  [_xfa_object.$getNextPage]() {
	    if (!this[_xfa_object.$extra]) {
	      this[_xfa_object.$extra] = {
	        numberOfUse: 1,
	        pageIndex: -1,
	        pageSetIndex: -1
	      };
	    }

	    if (this.relation === "orderedOccurrence") {
	      if (this[_xfa_object.$extra].pageIndex + 1 < this.pageArea.children.length) {
	        this[_xfa_object.$extra].pageIndex += 1;
	        const pageArea = this.pageArea.children[this[_xfa_object.$extra].pageIndex];
	        return pageArea[_xfa_object.$getNextPage]();
	      }

	      if (this[_xfa_object.$extra].pageSetIndex + 1 < this.pageSet.children.length) {
	        this[_xfa_object.$extra].pageSetIndex += 1;
	        return this.pageSet.children[this[_xfa_object.$extra].pageSetIndex][_xfa_object.$getNextPage]();
	      }

	      if (this[_xfa_object.$isUsable]()) {
	        this[_xfa_object.$extra].numberOfUse += 1;
	        this[_xfa_object.$extra].pageIndex = -1;
	        this[_xfa_object.$extra].pageSetIndex = -1;
	        return this[_xfa_object.$getNextPage]();
	      }

	      const parent = this[_xfa_object.$getParent]();

	      if (parent instanceof PageSet) {
	        return parent[_xfa_object.$getNextPage]();
	      }

	      this[_xfa_object.$cleanPage]();

	      return this[_xfa_object.$getNextPage]();
	    }

	    const pageNumber = this[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].pageNumber;

	    const parity = pageNumber % 2 === 0 ? "even" : "odd";
	    const position = pageNumber === 0 ? "first" : "rest";
	    let page = this.pageArea.children.find(p => p.oddOrEven === parity && p.pagePosition === position);

	    if (page) {
	      return page;
	    }

	    page = this.pageArea.children.find(p => p.oddOrEven === "any" && p.pagePosition === position);

	    if (page) {
	      return page;
	    }

	    page = this.pageArea.children.find(p => p.oddOrEven === "any" && p.pagePosition === "any");

	    if (page) {
	      return page;
	    }

	    return this.pageArea.children[0];
	  }

	}

	class Para extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "para", true);
	    this.hAlign = (0, _utils.getStringOption)(attributes.hAlign, ["left", "center", "justify", "justifyAll", "radix", "right"]);
	    this.id = attributes.id || "";
	    this.lineHeight = attributes.lineHeight ? (0, _utils.getMeasurement)(attributes.lineHeight, "0pt") : "";
	    this.marginLeft = attributes.marginLeft ? (0, _utils.getMeasurement)(attributes.marginLeft, "0pt") : "";
	    this.marginRight = attributes.marginRight ? (0, _utils.getMeasurement)(attributes.marginRight, "0pt") : "";
	    this.orphans = (0, _utils.getInteger)({
	      data: attributes.orphans,
	      defaultValue: 0,
	      validate: x => x >= 0
	    });
	    this.preserve = attributes.preserve || "";
	    this.radixOffset = attributes.radixOffset ? (0, _utils.getMeasurement)(attributes.radixOffset, "0pt") : "";
	    this.spaceAbove = attributes.spaceAbove ? (0, _utils.getMeasurement)(attributes.spaceAbove, "0pt") : "";
	    this.spaceBelow = attributes.spaceBelow ? (0, _utils.getMeasurement)(attributes.spaceBelow, "0pt") : "";
	    this.tabDefault = attributes.tabDefault ? (0, _utils.getMeasurement)(this.tabDefault) : "";
	    this.tabStops = (attributes.tabStops || "").trim().split(/\s+/).map((x, i) => i % 2 === 1 ? (0, _utils.getMeasurement)(x) : x);
	    this.textIndent = attributes.textIndent ? (0, _utils.getMeasurement)(attributes.textIndent, "0pt") : "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.vAlign = (0, _utils.getStringOption)(attributes.vAlign, ["top", "bottom", "middle"]);
	    this.widows = (0, _utils.getInteger)({
	      data: attributes.widows,
	      defaultValue: 0,
	      validate: x => x >= 0
	    });
	    this.hyphenation = null;
	  }

	  [_xfa_object.$toStyle]() {
	    const style = (0, _html_utils.toStyle)(this, "hAlign");

	    if (this.marginLeft !== "") {
	      style.paddingLeft = (0, _html_utils.measureToString)(this.marginLeft);
	    }

	    if (this.marginRight !== "") {
	      style.paddingight = (0, _html_utils.measureToString)(this.marginRight);
	    }

	    if (this.spaceAbove !== "") {
	      style.paddingTop = (0, _html_utils.measureToString)(this.spaceAbove);
	    }

	    if (this.spaceBelow !== "") {
	      style.paddingBottom = (0, _html_utils.measureToString)(this.spaceBelow);
	    }

	    if (this.textIndent !== "") {
	      style.textIndent = (0, _html_utils.measureToString)(this.textIndent);
	      (0, _html_utils.fixTextIndent)(style);
	    }

	    if (this.lineHeight > 0) {
	      style.lineHeight = (0, _html_utils.measureToString)(this.lineHeight);
	    }

	    if (this.tabDefault !== "") {
	      style.tabSize = (0, _html_utils.measureToString)(this.tabDefault);
	    }

	    if (this.tabStops.length > 0) ;

	    if (this.hyphenatation) {
	      Object.assign(style, this.hyphenatation[_xfa_object.$toStyle]());
	    }

	    return style;
	  }

	}

	class PasswordEdit extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "passwordEdit", true);
	    this.hScrollPolicy = (0, _utils.getStringOption)(attributes.hScrollPolicy, ["auto", "off", "on"]);
	    this.id = attributes.id || "";
	    this.passwordChar = attributes.passwordChar || "*";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.border = null;
	    this.extras = null;
	    this.margin = null;
	  }

	}

	class Pattern extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "pattern", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["crossHatch", "crossDiagonal", "diagonalLeft", "diagonalRight", "horizontal", "vertical"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.color = null;
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle](startColor) {
	    startColor = startColor ? startColor[_xfa_object.$toStyle]() : "#FFFFFF";
	    const endColor = this.color ? this.color[_xfa_object.$toStyle]() : "#000000";
	    const width = 5;
	    const cmd = "repeating-linear-gradient";
	    const colors = `${startColor},${startColor} ${width}px,${endColor} ${width}px,${endColor} ${2 * width}px`;

	    switch (this.type) {
	      case "crossHatch":
	        return `${cmd}(to top,${colors}) ${cmd}(to right,${colors})`;

	      case "crossDiagonal":
	        return `${cmd}(45deg,${colors}) ${cmd}(-45deg,${colors})`;

	      case "diagonalLeft":
	        return `${cmd}(45deg,${colors})`;

	      case "diagonalRight":
	        return `${cmd}(-45deg,${colors})`;

	      case "horizontal":
	        return `${cmd}(to top,${colors})`;

	      case "vertical":
	        return `${cmd}(to right,${colors})`;
	    }

	    return "";
	  }

	}

	class Picture extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "picture");
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Proto extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "proto", true);
	    this.appearanceFilter = new _xfa_object.XFAObjectArray();
	    this.arc = new _xfa_object.XFAObjectArray();
	    this.area = new _xfa_object.XFAObjectArray();
	    this.assist = new _xfa_object.XFAObjectArray();
	    this.barcode = new _xfa_object.XFAObjectArray();
	    this.bindItems = new _xfa_object.XFAObjectArray();
	    this.bookend = new _xfa_object.XFAObjectArray();
	    this.boolean = new _xfa_object.XFAObjectArray();
	    this.border = new _xfa_object.XFAObjectArray();
	    this.break = new _xfa_object.XFAObjectArray();
	    this.breakAfter = new _xfa_object.XFAObjectArray();
	    this.breakBefore = new _xfa_object.XFAObjectArray();
	    this.button = new _xfa_object.XFAObjectArray();
	    this.calculate = new _xfa_object.XFAObjectArray();
	    this.caption = new _xfa_object.XFAObjectArray();
	    this.certificate = new _xfa_object.XFAObjectArray();
	    this.certificates = new _xfa_object.XFAObjectArray();
	    this.checkButton = new _xfa_object.XFAObjectArray();
	    this.choiceList = new _xfa_object.XFAObjectArray();
	    this.color = new _xfa_object.XFAObjectArray();
	    this.comb = new _xfa_object.XFAObjectArray();
	    this.connect = new _xfa_object.XFAObjectArray();
	    this.contentArea = new _xfa_object.XFAObjectArray();
	    this.corner = new _xfa_object.XFAObjectArray();
	    this.date = new _xfa_object.XFAObjectArray();
	    this.dateTime = new _xfa_object.XFAObjectArray();
	    this.dateTimeEdit = new _xfa_object.XFAObjectArray();
	    this.decimal = new _xfa_object.XFAObjectArray();
	    this.defaultUi = new _xfa_object.XFAObjectArray();
	    this.desc = new _xfa_object.XFAObjectArray();
	    this.digestMethod = new _xfa_object.XFAObjectArray();
	    this.digestMethods = new _xfa_object.XFAObjectArray();
	    this.draw = new _xfa_object.XFAObjectArray();
	    this.edge = new _xfa_object.XFAObjectArray();
	    this.encoding = new _xfa_object.XFAObjectArray();
	    this.encodings = new _xfa_object.XFAObjectArray();
	    this.encrypt = new _xfa_object.XFAObjectArray();
	    this.encryptData = new _xfa_object.XFAObjectArray();
	    this.encryption = new _xfa_object.XFAObjectArray();
	    this.encryptionMethod = new _xfa_object.XFAObjectArray();
	    this.encryptionMethods = new _xfa_object.XFAObjectArray();
	    this.event = new _xfa_object.XFAObjectArray();
	    this.exData = new _xfa_object.XFAObjectArray();
	    this.exObject = new _xfa_object.XFAObjectArray();
	    this.exclGroup = new _xfa_object.XFAObjectArray();
	    this.execute = new _xfa_object.XFAObjectArray();
	    this.extras = new _xfa_object.XFAObjectArray();
	    this.field = new _xfa_object.XFAObjectArray();
	    this.fill = new _xfa_object.XFAObjectArray();
	    this.filter = new _xfa_object.XFAObjectArray();
	    this.float = new _xfa_object.XFAObjectArray();
	    this.font = new _xfa_object.XFAObjectArray();
	    this.format = new _xfa_object.XFAObjectArray();
	    this.handler = new _xfa_object.XFAObjectArray();
	    this.hyphenation = new _xfa_object.XFAObjectArray();
	    this.image = new _xfa_object.XFAObjectArray();
	    this.imageEdit = new _xfa_object.XFAObjectArray();
	    this.integer = new _xfa_object.XFAObjectArray();
	    this.issuers = new _xfa_object.XFAObjectArray();
	    this.items = new _xfa_object.XFAObjectArray();
	    this.keep = new _xfa_object.XFAObjectArray();
	    this.keyUsage = new _xfa_object.XFAObjectArray();
	    this.line = new _xfa_object.XFAObjectArray();
	    this.linear = new _xfa_object.XFAObjectArray();
	    this.lockDocument = new _xfa_object.XFAObjectArray();
	    this.manifest = new _xfa_object.XFAObjectArray();
	    this.margin = new _xfa_object.XFAObjectArray();
	    this.mdp = new _xfa_object.XFAObjectArray();
	    this.medium = new _xfa_object.XFAObjectArray();
	    this.message = new _xfa_object.XFAObjectArray();
	    this.numericEdit = new _xfa_object.XFAObjectArray();
	    this.occur = new _xfa_object.XFAObjectArray();
	    this.oid = new _xfa_object.XFAObjectArray();
	    this.oids = new _xfa_object.XFAObjectArray();
	    this.overflow = new _xfa_object.XFAObjectArray();
	    this.pageArea = new _xfa_object.XFAObjectArray();
	    this.pageSet = new _xfa_object.XFAObjectArray();
	    this.para = new _xfa_object.XFAObjectArray();
	    this.passwordEdit = new _xfa_object.XFAObjectArray();
	    this.pattern = new _xfa_object.XFAObjectArray();
	    this.picture = new _xfa_object.XFAObjectArray();
	    this.radial = new _xfa_object.XFAObjectArray();
	    this.reason = new _xfa_object.XFAObjectArray();
	    this.reasons = new _xfa_object.XFAObjectArray();
	    this.rectangle = new _xfa_object.XFAObjectArray();
	    this.ref = new _xfa_object.XFAObjectArray();
	    this.script = new _xfa_object.XFAObjectArray();
	    this.setProperty = new _xfa_object.XFAObjectArray();
	    this.signData = new _xfa_object.XFAObjectArray();
	    this.signature = new _xfa_object.XFAObjectArray();
	    this.signing = new _xfa_object.XFAObjectArray();
	    this.solid = new _xfa_object.XFAObjectArray();
	    this.speak = new _xfa_object.XFAObjectArray();
	    this.stipple = new _xfa_object.XFAObjectArray();
	    this.subform = new _xfa_object.XFAObjectArray();
	    this.subformSet = new _xfa_object.XFAObjectArray();
	    this.subjectDN = new _xfa_object.XFAObjectArray();
	    this.subjectDNs = new _xfa_object.XFAObjectArray();
	    this.submit = new _xfa_object.XFAObjectArray();
	    this.text = new _xfa_object.XFAObjectArray();
	    this.textEdit = new _xfa_object.XFAObjectArray();
	    this.time = new _xfa_object.XFAObjectArray();
	    this.timeStamp = new _xfa_object.XFAObjectArray();
	    this.toolTip = new _xfa_object.XFAObjectArray();
	    this.traversal = new _xfa_object.XFAObjectArray();
	    this.traverse = new _xfa_object.XFAObjectArray();
	    this.ui = new _xfa_object.XFAObjectArray();
	    this.validate = new _xfa_object.XFAObjectArray();
	    this.value = new _xfa_object.XFAObjectArray();
	    this.variables = new _xfa_object.XFAObjectArray();
	  }

	}

	class Radial extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "radial", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["toEdge", "toCenter"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.color = null;
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle](startColor) {
	    startColor = startColor ? startColor[_xfa_object.$toStyle]() : "#FFFFFF";
	    const endColor = this.color ? this.color[_xfa_object.$toStyle]() : "#000000";
	    const colors = this.type === "toEdge" ? `${startColor},${endColor}` : `${endColor},${startColor}`;
	    return `radial-gradient(circle at center, ${colors})`;
	  }

	}

	class Reason extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "reason");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Reasons extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "reasons", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.reason = new _xfa_object.XFAObjectArray();
	  }

	}

	class Rectangle extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "rectangle", true);
	    this.hand = (0, _utils.getStringOption)(attributes.hand, ["even", "left", "right"]);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.corner = new _xfa_object.XFAObjectArray(4);
	    this.edge = new _xfa_object.XFAObjectArray(4);
	    this.fill = null;
	  }

	  [_xfa_object.$toHTML]() {
	    const edge = this.edge.children.length ? this.edge.children[0] : new Edge({});

	    const edgeStyle = edge[_xfa_object.$toStyle]();

	    const style = Object.create(null);

	    if (this.fill && this.fill.presence === "visible") {
	      Object.assign(style, this.fill[_xfa_object.$toStyle]());
	    } else {
	      style.fill = "transparent";
	    }

	    style.strokeWidth = (0, _html_utils.measureToString)(edge.presence === "visible" ? edge.thickness : 0);
	    style.stroke = edgeStyle.color;
	    const corner = this.corner.children.length ? this.corner.children[0] : new Corner({});

	    const cornerStyle = corner[_xfa_object.$toStyle]();

	    const rect = {
	      name: "rect",
	      attributes: {
	        xmlns: SVG_NS,
	        width: "100%",
	        height: "100%",
	        x: 0,
	        y: 0,
	        rx: cornerStyle.radius,
	        ry: cornerStyle.radius,
	        style
	      }
	    };
	    const svg = {
	      name: "svg",
	      children: [rect],
	      attributes: {
	        xmlns: SVG_NS,
	        style: {
	          overflow: "visible"
	        },
	        width: "100%",
	        height: "100%"
	      }
	    };

	    const parent = this[_xfa_object.$getParent]()[_xfa_object.$getParent]();

	    if (hasMargin(parent)) {
	      return _utils.HTMLResult.success({
	        name: "div",
	        attributes: {
	          style: {
	            display: "inline",
	            width: "100%",
	            height: "100%"
	          }
	        },
	        children: [svg]
	      });
	    }

	    svg.attributes.style.position = "absolute";
	    return _utils.HTMLResult.success(svg);
	  }

	}

	class RefElement extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "ref");
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Script extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "script");
	    this.binding = attributes.binding || "";
	    this.contentType = attributes.contentType || "";
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.runAt = (0, _utils.getStringOption)(attributes.runAt, ["client", "both", "server"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class SetProperty extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "setProperty");
	    this.connection = attributes.connection || "";
	    this.ref = attributes.ref || "";
	    this.target = attributes.target || "";
	  }

	}

	exports.SetProperty = SetProperty;

	class SignData extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "signData", true);
	    this.id = attributes.id || "";
	    this.operation = (0, _utils.getStringOption)(attributes.operation, ["sign", "clear", "verify"]);
	    this.ref = attributes.ref || "";
	    this.target = attributes.target || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.filter = null;
	    this.manifest = null;
	  }

	}

	class Signature extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "signature", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["PDF1.3", "PDF1.6"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.border = null;
	    this.extras = null;
	    this.filter = null;
	    this.manifest = null;
	    this.margin = null;
	  }

	}

	class Signing extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "signing", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.certificate = new _xfa_object.XFAObjectArray();
	  }

	}

	class Solid extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "solid", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle](startColor) {
	    return startColor ? startColor[_xfa_object.$toStyle]() : "#FFFFFF";
	  }

	}

	class Speak extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "speak");
	    this.disable = (0, _utils.getInteger)({
	      data: attributes.disable,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.id = attributes.id || "";
	    this.priority = (0, _utils.getStringOption)(attributes.priority, ["custom", "caption", "name", "toolTip"]);
	    this.rid = attributes.rid || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Stipple extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "stipple", true);
	    this.id = attributes.id || "";
	    this.rate = (0, _utils.getInteger)({
	      data: attributes.rate,
	      defaultValue: 50,
	      validate: x => x >= 0 && x <= 100
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.color = null;
	    this.extras = null;
	  }

	  [_xfa_object.$toStyle](bgColor) {
	    const alpha = this.rate / 100;
	    return _util.Util.makeHexColor(Math.round(bgColor.value.r * (1 - alpha) + this.value.r * alpha), Math.round(bgColor.value.g * (1 - alpha) + this.value.g * alpha), Math.round(bgColor.value.b * (1 - alpha) + this.value.b * alpha));
	  }

	}

	class Subform extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "subform", true);
	    this.access = (0, _utils.getStringOption)(attributes.access, ["open", "nonInteractive", "protected", "readOnly"]);
	    this.allowMacro = (0, _utils.getInteger)({
	      data: attributes.allowMacro,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.anchorType = (0, _utils.getStringOption)(attributes.anchorType, ["topLeft", "bottomCenter", "bottomLeft", "bottomRight", "middleCenter", "middleLeft", "middleRight", "topCenter", "topRight"]);
	    this.colSpan = (0, _utils.getInteger)({
	      data: attributes.colSpan,
	      defaultValue: 1,
	      validate: n => n >= 1 || n === -1
	    });
	    this.columnWidths = (attributes.columnWidths || "").trim().split(/\s+/).map(x => x === "-1" ? -1 : (0, _utils.getMeasurement)(x));
	    this.h = attributes.h ? (0, _utils.getMeasurement)(attributes.h) : "";
	    this.hAlign = (0, _utils.getStringOption)(attributes.hAlign, ["left", "center", "justify", "justifyAll", "radix", "right"]);
	    this.id = attributes.id || "";
	    this.layout = (0, _utils.getStringOption)(attributes.layout, ["position", "lr-tb", "rl-row", "rl-tb", "row", "table", "tb"]);
	    this.locale = attributes.locale || "";
	    this.maxH = (0, _utils.getMeasurement)(attributes.maxH, "0pt");
	    this.maxW = (0, _utils.getMeasurement)(attributes.maxW, "0pt");
	    this.mergeMode = (0, _utils.getStringOption)(attributes.mergeMode, ["consumeData", "matchTemplate"]);
	    this.minH = (0, _utils.getMeasurement)(attributes.minH, "0pt");
	    this.minW = (0, _utils.getMeasurement)(attributes.minW, "0pt");
	    this.name = attributes.name || "";
	    this.presence = (0, _utils.getStringOption)(attributes.presence, ["visible", "hidden", "inactive", "invisible"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.restoreState = (0, _utils.getStringOption)(attributes.restoreState, ["manual", "auto"]);
	    this.scope = (0, _utils.getStringOption)(attributes.scope, ["name", "none"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.w = attributes.w ? (0, _utils.getMeasurement)(attributes.w) : "";
	    this.x = (0, _utils.getMeasurement)(attributes.x, "0pt");
	    this.y = (0, _utils.getMeasurement)(attributes.y, "0pt");
	    this.assist = null;
	    this.bind = null;
	    this.bookend = null;
	    this.border = null;
	    this.break = null;
	    this.calculate = null;
	    this.desc = null;
	    this.extras = null;
	    this.keep = null;
	    this.margin = null;
	    this.occur = null;
	    this.overflow = null;
	    this.pageSet = null;
	    this.para = null;
	    this.traversal = null;
	    this.validate = null;
	    this.variables = null;
	    this.area = new _xfa_object.XFAObjectArray();
	    this.breakAfter = new _xfa_object.XFAObjectArray();
	    this.breakBefore = new _xfa_object.XFAObjectArray();
	    this.connect = new _xfa_object.XFAObjectArray();
	    this.draw = new _xfa_object.XFAObjectArray();
	    this.event = new _xfa_object.XFAObjectArray();
	    this.exObject = new _xfa_object.XFAObjectArray();
	    this.exclGroup = new _xfa_object.XFAObjectArray();
	    this.field = new _xfa_object.XFAObjectArray();
	    this.proto = new _xfa_object.XFAObjectArray();
	    this.setProperty = new _xfa_object.XFAObjectArray();
	    this.subform = new _xfa_object.XFAObjectArray();
	    this.subformSet = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$getSubformParent]() {
	    const parent = this[_xfa_object.$getParent]();

	    if (parent instanceof SubformSet) {
	      return parent[_xfa_object.$getSubformParent]();
	    }

	    return parent;
	  }

	  [_xfa_object.$isBindable]() {
	    return true;
	  }

	  [_xfa_object.$isThereMoreWidth]() {
	    return this.layout.endsWith("-tb") && this[_xfa_object.$extra].attempt === 0 && this[_xfa_object.$extra].numberInLine > 0 || this[_xfa_object.$getParent]()[_xfa_object.$isThereMoreWidth]();
	  }

	  *[_xfa_object.$getContainedChildren]() {
	    yield* getContainedChildren(this);
	  }

	  [_xfa_object.$flushHTML]() {
	    return (0, _layout.flushHTML)(this);
	  }

	  [_xfa_object.$addHTML](html, bbox) {
	    (0, _layout.addHTML)(this, html, bbox);
	  }

	  [_xfa_object.$getAvailableSpace]() {
	    return (0, _layout.getAvailableSpace)(this);
	  }

	  [_xfa_object.$isSplittable]() {
	    const parent = this[_xfa_object.$getSubformParent]();

	    if (!parent[_xfa_object.$isSplittable]()) {
	      return false;
	    }

	    if (this[_xfa_object.$extra]._isSplittable !== undefined) {
	      return this[_xfa_object.$extra]._isSplittable;
	    }

	    if (this.layout === "position" || this.layout.includes("row")) {
	      this[_xfa_object.$extra]._isSplittable = false;
	      return false;
	    }

	    if (this.keep && this.keep.intact !== "none") {
	      this[_xfa_object.$extra]._isSplittable = false;
	      return false;
	    }

	    if (parent.layout && parent.layout.endsWith("-tb") && parent[_xfa_object.$extra].numberInLine !== 0) {
	      return false;
	    }

	    this[_xfa_object.$extra]._isSplittable = true;
	    return true;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    setTabIndex(this);

	    if (this.break) {
	      if (this.break.after !== "auto" || this.break.afterTarget !== "") {
	        const node = new BreakAfter({
	          targetType: this.break.after,
	          target: this.break.afterTarget,
	          startNew: this.break.startNew.toString()
	        });
	        node[_xfa_object.$globalData] = this[_xfa_object.$globalData];

	        this[_xfa_object.$appendChild](node);

	        this.breakAfter.push(node);
	      }

	      if (this.break.before !== "auto" || this.break.beforeTarget !== "") {
	        const node = new BreakBefore({
	          targetType: this.break.before,
	          target: this.break.beforeTarget,
	          startNew: this.break.startNew.toString()
	        });
	        node[_xfa_object.$globalData] = this[_xfa_object.$globalData];

	        this[_xfa_object.$appendChild](node);

	        this.breakBefore.push(node);
	      }

	      if (this.break.overflowTarget !== "") {
	        const node = new Overflow({
	          target: this.break.overflowTarget,
	          leader: this.break.overflowLeader,
	          trailer: this.break.overflowTrailer
	        });
	        node[_xfa_object.$globalData] = this[_xfa_object.$globalData];

	        this[_xfa_object.$appendChild](node);

	        this.overflow.push(node);
	      }

	      this[_xfa_object.$removeChild](this.break);

	      this.break = null;
	    }

	    if (this.presence === "hidden" || this.presence === "inactive") {
	      return _utils.HTMLResult.EMPTY;
	    }

	    if (this.breakBefore.children.length > 1 || this.breakAfter.children.length > 1) {
	      (0, _util.warn)("XFA - Several breakBefore or breakAfter in subforms: please file a bug.");
	    }

	    if (this.breakBefore.children.length >= 1) {
	      const breakBefore = this.breakBefore.children[0];

	      if (handleBreak(breakBefore)) {
	        return _utils.HTMLResult.breakNode(breakBefore);
	      }
	    }

	    if (this[_xfa_object.$extra] && this[_xfa_object.$extra].afterBreakAfter) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    (0, _html_utils.fixDimensions)(this);
	    const children = [];
	    const attributes = {
	      id: this[_xfa_object.$uid],
	      class: []
	    };
	    (0, _html_utils.setAccess)(this, attributes.class);

	    if (!this[_xfa_object.$extra]) {
	      this[_xfa_object.$extra] = Object.create(null);
	    }

	    Object.assign(this[_xfa_object.$extra], {
	      children,
	      line: null,
	      attributes,
	      attempt: 0,
	      numberInLine: 0,
	      availableSpace: {
	        width: Math.min(this.w || Infinity, availableSpace.width),
	        height: Math.min(this.h || Infinity, availableSpace.height)
	      },
	      width: 0,
	      height: 0,
	      prevHeight: 0,
	      currentWidth: 0
	    });

	    const root = this[_xfa_object.$getTemplateRoot]();

	    const savedNoLayoutFailure = root[_xfa_object.$extra].noLayoutFailure;

	    const isSplittable = this[_xfa_object.$isSplittable]();

	    if (!isSplittable) {
	      setFirstUnsplittable(this);
	    }

	    if (!(0, _layout.checkDimensions)(this, availableSpace)) {
	      return _utils.HTMLResult.FAILURE;
	    }

	    const filter = new Set(["area", "draw", "exclGroup", "field", "subform", "subformSet"]);

	    if (this.layout.includes("row")) {
	      const columnWidths = this[_xfa_object.$getSubformParent]().columnWidths;

	      if (Array.isArray(columnWidths) && columnWidths.length > 0) {
	        this[_xfa_object.$extra].columnWidths = columnWidths;
	        this[_xfa_object.$extra].currentColumn = 0;
	      }
	    }

	    const style = (0, _html_utils.toStyle)(this, "anchorType", "dimensions", "position", "presence", "border", "margin", "hAlign");
	    const classNames = ["xfaSubform"];
	    const cl = (0, _html_utils.layoutClass)(this);

	    if (cl) {
	      classNames.push(cl);
	    }

	    attributes.style = style;
	    attributes.class = classNames;

	    if (this.name) {
	      attributes.xfaName = this.name;
	    }

	    if (this.overflow) {
	      const overflowExtra = this.overflow[_xfa_object.$getExtra]();

	      if (overflowExtra.addLeader) {
	        overflowExtra.addLeader = false;
	        handleOverflow(this, overflowExtra.leader, availableSpace);
	      }
	    }

	    this[_xfa_object.$pushPara]();

	    const isLrTb = this.layout === "lr-tb" || this.layout === "rl-tb";
	    const maxRun = isLrTb ? MAX_ATTEMPTS_FOR_LRTB_LAYOUT : 1;

	    for (; this[_xfa_object.$extra].attempt < maxRun; this[_xfa_object.$extra].attempt++) {
	      if (isLrTb && this[_xfa_object.$extra].attempt === MAX_ATTEMPTS_FOR_LRTB_LAYOUT - 1) {
	        this[_xfa_object.$extra].numberInLine = 0;
	      }

	      const result = this[_xfa_object.$childrenToHTML]({
	        filter,
	        include: true
	      });

	      if (result.success) {
	        break;
	      }

	      if (result.isBreak()) {
	        this[_xfa_object.$popPara]();

	        return result;
	      }

	      if (isLrTb && this[_xfa_object.$extra].attempt === 0 && this[_xfa_object.$extra].numberInLine === 0 && !root[_xfa_object.$extra].noLayoutFailure) {
	        this[_xfa_object.$extra].attempt = maxRun;
	        break;
	      }
	    }

	    this[_xfa_object.$popPara]();

	    if (!isSplittable) {
	      unsetFirstUnsplittable(this);
	    }

	    root[_xfa_object.$extra].noLayoutFailure = savedNoLayoutFailure;

	    if (this[_xfa_object.$extra].attempt === maxRun) {
	      if (this.overflow) {
	        this[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].overflowNode = this.overflow;
	      }

	      if (!isSplittable) {
	        delete this[_xfa_object.$extra];
	      }

	      return _utils.HTMLResult.FAILURE;
	    }

	    if (this.overflow) {
	      const overflowExtra = this.overflow[_xfa_object.$getExtra]();

	      if (overflowExtra.addTrailer) {
	        overflowExtra.addTrailer = false;
	        handleOverflow(this, overflowExtra.trailer, availableSpace);
	      }
	    }

	    let marginH = 0;
	    let marginV = 0;

	    if (this.margin) {
	      marginH = this.margin.leftInset + this.margin.rightInset;
	      marginV = this.margin.topInset + this.margin.bottomInset;
	    }

	    const width = Math.max(this[_xfa_object.$extra].width + marginH, this.w || 0);
	    const height = Math.max(this[_xfa_object.$extra].height + marginV, this.h || 0);
	    const bbox = [this.x, this.y, width, height];

	    if (this.w === "") {
	      style.width = (0, _html_utils.measureToString)(width);
	    }

	    if (this.h === "") {
	      style.height = (0, _html_utils.measureToString)(height);
	    }

	    if ((style.width === "0px" || style.height === "0px") && children.length === 0) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    const html = {
	      name: "div",
	      attributes,
	      children
	    };
	    applyAssist(this, attributes);

	    const result = _utils.HTMLResult.success((0, _html_utils.createWrapper)(this, html), bbox);

	    if (this.breakAfter.children.length >= 1) {
	      const breakAfter = this.breakAfter.children[0];

	      if (handleBreak(breakAfter)) {
	        this[_xfa_object.$extra].afterBreakAfter = result;
	        return _utils.HTMLResult.breakNode(breakAfter);
	      }
	    }

	    delete this[_xfa_object.$extra];
	    return result;
	  }

	}

	class SubformSet extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "subformSet", true);
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.relation = (0, _utils.getStringOption)(attributes.relation, ["ordered", "choice", "unordered"]);
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.bookend = null;
	    this.break = null;
	    this.desc = null;
	    this.extras = null;
	    this.occur = null;
	    this.overflow = null;
	    this.breakAfter = new _xfa_object.XFAObjectArray();
	    this.breakBefore = new _xfa_object.XFAObjectArray();
	    this.subform = new _xfa_object.XFAObjectArray();
	    this.subformSet = new _xfa_object.XFAObjectArray();
	  }

	  *[_xfa_object.$getContainedChildren]() {
	    yield* getContainedChildren(this);
	  }

	  [_xfa_object.$getSubformParent]() {
	    let parent = this[_xfa_object.$getParent]();

	    while (!(parent instanceof Subform)) {
	      parent = parent[_xfa_object.$getParent]();
	    }

	    return parent;
	  }

	  [_xfa_object.$isBindable]() {
	    return true;
	  }

	}

	class SubjectDN extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "subjectDN");
	    this.delimiter = attributes.delimiter || ",";
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = new Map(this[_xfa_object.$content].split(this.delimiter).map(kv => {
	      kv = kv.split("=", 2);
	      kv[0] = kv[0].trim();
	      return kv;
	    }));
	  }

	}

	class SubjectDNs extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "subjectDNs", true);
	    this.id = attributes.id || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.subjectDN = new _xfa_object.XFAObjectArray();
	  }

	}

	class Submit extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "submit", true);
	    this.embedPDF = (0, _utils.getInteger)({
	      data: attributes.embedPDF,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.format = (0, _utils.getStringOption)(attributes.format, ["xdp", "formdata", "pdf", "urlencoded", "xfd", "xml"]);
	    this.id = attributes.id || "";
	    this.target = attributes.target || "";
	    this.textEncoding = (0, _utils.getKeyword)({
	      data: attributes.textEncoding ? attributes.textEncoding.toLowerCase() : "",
	      defaultValue: "",
	      validate: k => ["utf-8", "big-five", "fontspecific", "gbk", "gb-18030", "gb-2312", "ksc-5601", "none", "shift-jis", "ucs-2", "utf-16"].includes(k) || k.match(/iso-8859-\d{2}/)
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.xdpContent = attributes.xdpContent || "";
	    this.encrypt = null;
	    this.encryptData = new _xfa_object.XFAObjectArray();
	    this.signData = new _xfa_object.XFAObjectArray();
	  }

	}

	class Template extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "template", true);
	    this.baseProfile = (0, _utils.getStringOption)(attributes.baseProfile, ["full", "interactiveForms"]);
	    this.extras = null;
	    this.subform = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$finalize]() {
	    if (this.subform.children.length === 0) {
	      (0, _util.warn)("XFA - No subforms in template node.");
	    }

	    if (this.subform.children.length >= 2) {
	      (0, _util.warn)("XFA - Several subforms in template node: please file a bug.");
	    }

	    this[_xfa_object.$tabIndex] = DEFAULT_TAB_INDEX;
	  }

	  [_xfa_object.$isSplittable]() {
	    return true;
	  }

	  [_xfa_object.$searchNode](expr, container) {
	    if (expr.startsWith("#")) {
	      return [this[_xfa_object.$ids].get(expr.slice(1))];
	    }

	    return (0, _som.searchNode)(this, container, expr, true, true);
	  }

	  *[_xfa_object.$toPages]() {
	    if (!this.subform.children.length) {
	      return _utils.HTMLResult.success({
	        name: "div",
	        children: []
	      });
	    }

	    this[_xfa_object.$extra] = {
	      overflowNode: null,
	      firstUnsplittable: null,
	      currentContentArea: null,
	      currentPageArea: null,
	      noLayoutFailure: false,
	      pageNumber: 1,
	      pagePosition: "first",
	      oddOrEven: "odd",
	      blankOrNotBlank: "nonBlank",
	      paraStack: []
	    };
	    const root = this.subform.children[0];

	    root.pageSet[_xfa_object.$cleanPage]();

	    const pageAreas = root.pageSet.pageArea.children;
	    const mainHtml = {
	      name: "div",
	      children: []
	    };
	    let pageArea = null;
	    let breakBefore = null;
	    let breakBeforeTarget = null;

	    if (root.breakBefore.children.length >= 1) {
	      breakBefore = root.breakBefore.children[0];
	      breakBeforeTarget = breakBefore.target;
	    } else if (root.subform.children.length >= 1 && root.subform.children[0].breakBefore.children.length >= 1) {
	      breakBefore = root.subform.children[0].breakBefore.children[0];
	      breakBeforeTarget = breakBefore.target;
	    } else if (root.break && root.break.beforeTarget) {
	      breakBefore = root.break;
	      breakBeforeTarget = breakBefore.beforeTarget;
	    } else if (root.subform.children.length >= 1 && root.subform.children[0].break && root.subform.children[0].break.beforeTarget) {
	      breakBefore = root.subform.children[0].break;
	      breakBeforeTarget = breakBefore.beforeTarget;
	    }

	    if (breakBefore) {
	      const target = this[_xfa_object.$searchNode](breakBeforeTarget, breakBefore[_xfa_object.$getParent]());

	      if (target instanceof PageArea) {
	        pageArea = target;
	        breakBefore[_xfa_object.$extra] = {};
	      }
	    }

	    if (!pageArea) {
	      pageArea = pageAreas[0];
	    }

	    pageArea[_xfa_object.$extra] = {
	      numberOfUse: 1
	    };

	    const pageAreaParent = pageArea[_xfa_object.$getParent]();

	    pageAreaParent[_xfa_object.$extra] = {
	      numberOfUse: 1,
	      pageIndex: pageAreaParent.pageArea.children.indexOf(pageArea),
	      pageSetIndex: 0
	    };
	    let targetPageArea;
	    let leader = null;
	    let trailer = null;
	    let hasSomething = true;
	    let hasSomethingCounter = 0;
	    let startIndex = 0;

	    while (true) {
	      if (!hasSomething) {
	        mainHtml.children.pop();

	        if (++hasSomethingCounter === MAX_EMPTY_PAGES) {
	          (0, _util.warn)("XFA - Something goes wrong: please file a bug.");
	          return mainHtml;
	        }
	      } else {
	        hasSomethingCounter = 0;
	      }

	      targetPageArea = null;
	      this[_xfa_object.$extra].currentPageArea = pageArea;

	      const page = pageArea[_xfa_object.$toHTML]().html;

	      mainHtml.children.push(page);

	      if (leader) {
	        this[_xfa_object.$extra].noLayoutFailure = true;
	        page.children.push(leader[_xfa_object.$toHTML](pageArea[_xfa_object.$extra].space).html);
	        leader = null;
	      }

	      if (trailer) {
	        this[_xfa_object.$extra].noLayoutFailure = true;
	        page.children.push(trailer[_xfa_object.$toHTML](pageArea[_xfa_object.$extra].space).html);
	        trailer = null;
	      }

	      const contentAreas = pageArea.contentArea.children;
	      const htmlContentAreas = page.children.filter(node => node.attributes.class.includes("xfaContentarea"));
	      hasSomething = false;
	      this[_xfa_object.$extra].firstUnsplittable = null;
	      this[_xfa_object.$extra].noLayoutFailure = false;

	      const flush = index => {
	        const html = root[_xfa_object.$flushHTML]();

	        if (html) {
	          hasSomething = hasSomething || html.children && html.children.length !== 0;
	          htmlContentAreas[index].children.push(html);
	        }
	      };

	      for (let i = startIndex, ii = contentAreas.length; i < ii; i++) {
	        const contentArea = this[_xfa_object.$extra].currentContentArea = contentAreas[i];
	        const space = {
	          width: contentArea.w,
	          height: contentArea.h
	        };
	        startIndex = 0;

	        if (leader) {
	          htmlContentAreas[i].children.push(leader[_xfa_object.$toHTML](space).html);
	          leader = null;
	        }

	        if (trailer) {
	          htmlContentAreas[i].children.push(trailer[_xfa_object.$toHTML](space).html);
	          trailer = null;
	        }

	        const html = root[_xfa_object.$toHTML](space);

	        if (html.success) {
	          if (html.html) {
	            hasSomething = hasSomething || html.html.children && html.html.children.length !== 0;
	            htmlContentAreas[i].children.push(html.html);
	          } else if (!hasSomething && mainHtml.children.length > 1) {
	            mainHtml.children.pop();
	          }

	          return mainHtml;
	        }

	        if (html.isBreak()) {
	          const node = html.breakNode;
	          flush(i);

	          if (node.targetType === "auto") {
	            continue;
	          }

	          if (node.leader) {
	            leader = this[_xfa_object.$searchNode](node.leader, node[_xfa_object.$getParent]());
	            leader = leader ? leader[0] : null;
	          }

	          if (node.trailer) {
	            trailer = this[_xfa_object.$searchNode](node.trailer, node[_xfa_object.$getParent]());
	            trailer = trailer ? trailer[0] : null;
	          }

	          if (node.targetType === "pageArea") {
	            targetPageArea = node[_xfa_object.$extra].target;
	            i = Infinity;
	          } else if (!node[_xfa_object.$extra].target) {
	            i = node[_xfa_object.$extra].index;
	          } else {
	            targetPageArea = node[_xfa_object.$extra].target;
	            startIndex = node[_xfa_object.$extra].index + 1;
	            i = Infinity;
	          }

	          continue;
	        }

	        if (this[_xfa_object.$extra].overflowNode) {
	          const node = this[_xfa_object.$extra].overflowNode;
	          this[_xfa_object.$extra].overflowNode = null;

	          const overflowExtra = node[_xfa_object.$getExtra]();

	          const target = overflowExtra.target;
	          overflowExtra.addLeader = overflowExtra.leader !== null;
	          overflowExtra.addTrailer = overflowExtra.trailer !== null;
	          flush(i);
	          const currentIndex = i;
	          i = Infinity;

	          if (target instanceof PageArea) {
	            targetPageArea = target;
	          } else if (target instanceof ContentArea) {
	            const index = contentAreas.indexOf(target);

	            if (index !== -1) {
	              if (index > currentIndex) {
	                i = index - 1;
	              } else {
	                startIndex = index;
	              }
	            } else {
	              targetPageArea = target[_xfa_object.$getParent]();
	              startIndex = targetPageArea.contentArea.children.indexOf(target);
	            }
	          }

	          continue;
	        }

	        flush(i);
	      }

	      this[_xfa_object.$extra].pageNumber += 1;

	      if (targetPageArea) {
	        if (targetPageArea[_xfa_object.$isUsable]()) {
	          targetPageArea[_xfa_object.$extra].numberOfUse += 1;
	        } else {
	          targetPageArea = null;
	        }
	      }

	      pageArea = targetPageArea || pageArea[_xfa_object.$getNextPage]();
	      yield null;
	    }
	  }

	}

	exports.Template = Template;

	class Text extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "text");
	    this.id = attributes.id || "";
	    this.maxChars = (0, _utils.getInteger)({
	      data: attributes.maxChars,
	      defaultValue: 0,
	      validate: x => x >= 0
	    });
	    this.name = attributes.name || "";
	    this.rid = attributes.rid || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$acceptWhitespace]() {
	    return true;
	  }

	  [_xfa_object.$onChild](child) {
	    if (child[_xfa_object.$namespaceId] === _namespaces.NamespaceIds.xhtml.id) {
	      this[_xfa_object.$content] = child;
	      return true;
	    }

	    (0, _util.warn)(`XFA - Invalid content in Text: ${child[_xfa_object.$nodeName]}.`);
	    return false;
	  }

	  [_xfa_object.$onText](str) {
	    if (this[_xfa_object.$content] instanceof _xfa_object.XFAObject) {
	      return;
	    }

	    super[_xfa_object.$onText](str);
	  }

	  [_xfa_object.$finalize]() {
	    if (typeof this[_xfa_object.$content] === "string") {
	      this[_xfa_object.$content] = this[_xfa_object.$content].replace(/\r\n/g, "\n");
	    }
	  }

	  [_xfa_object.$getExtra]() {
	    if (typeof this[_xfa_object.$content] === "string") {
	      return this[_xfa_object.$content].split(/[\u2029\u2028\n]/).reduce((acc, line) => {
	        if (line) {
	          acc.push(line);
	        }

	        return acc;
	      }, []).join("\n");
	    }

	    return this[_xfa_object.$content][_xfa_object.$text]();
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    if (typeof this[_xfa_object.$content] === "string") {
	      const html = valueToHtml(this[_xfa_object.$content]).html;

	      if (this[_xfa_object.$content].includes("\u2029")) {
	        html.name = "div";
	        html.children = [];

	        this[_xfa_object.$content].split("\u2029").map(para => para.split(/[\u2028\n]/).reduce((acc, line) => {
	          acc.push({
	            name: "span",
	            value: line
	          }, {
	            name: "br"
	          });
	          return acc;
	        }, [])).forEach(lines => {
	          html.children.push({
	            name: "p",
	            children: lines
	          });
	        });
	      } else if (/[\u2028\n]/.test(this[_xfa_object.$content])) {
	        html.name = "div";
	        html.children = [];

	        this[_xfa_object.$content].split(/[\u2028\n]/).forEach(line => {
	          html.children.push({
	            name: "span",
	            value: line
	          }, {
	            name: "br"
	          });
	        });
	      }

	      return _utils.HTMLResult.success(html);
	    }

	    return this[_xfa_object.$content][_xfa_object.$toHTML](availableSpace);
	  }

	}

	exports.Text = Text;

	class TextEdit extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "textEdit", true);
	    this.allowRichText = (0, _utils.getInteger)({
	      data: attributes.allowRichText,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.hScrollPolicy = (0, _utils.getStringOption)(attributes.hScrollPolicy, ["auto", "off", "on"]);
	    this.id = attributes.id || "";
	    this.multiLine = (0, _utils.getInteger)({
	      data: attributes.multiLine,
	      defaultValue: "",
	      validate: x => x === 0 || x === 1
	    });
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.vScrollPolicy = (0, _utils.getStringOption)(attributes.vScrollPolicy, ["auto", "off", "on"]);
	    this.border = null;
	    this.comb = null;
	    this.extras = null;
	    this.margin = null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const style = (0, _html_utils.toStyle)(this, "border", "font", "margin");
	    let html;

	    const field = this[_xfa_object.$getParent]()[_xfa_object.$getParent]();

	    if (this.multiLine === "") {
	      this.multiLine = field instanceof Draw ? 1 : 0;
	    }

	    if (this.multiLine === 1) {
	      html = {
	        name: "textarea",
	        attributes: {
	          dataId: field[_xfa_object.$data] && field[_xfa_object.$data][_xfa_object.$uid] || field[_xfa_object.$uid],
	          fieldId: field[_xfa_object.$uid],
	          class: ["xfaTextfield"],
	          style,
	          "aria-label": ariaLabel(field),
	          "aria-required": false
	        }
	      };
	    } else {
	      html = {
	        name: "input",
	        attributes: {
	          type: "text",
	          dataId: field[_xfa_object.$data] && field[_xfa_object.$data][_xfa_object.$uid] || field[_xfa_object.$uid],
	          fieldId: field[_xfa_object.$uid],
	          class: ["xfaTextfield"],
	          style,
	          "aria-label": ariaLabel(field),
	          "aria-required": false
	        }
	      };
	    }

	    if (isRequired(field)) {
	      html.attributes["aria-required"] = true;
	      html.attributes.required = true;
	    }

	    return _utils.HTMLResult.success({
	      name: "label",
	      attributes: {
	        class: ["xfaLabel"]
	      },
	      children: [html]
	    });
	  }

	}

	class Time extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "time");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	  [_xfa_object.$finalize]() {
	    const date = this[_xfa_object.$content].trim();

	    this[_xfa_object.$content] = date ? new Date(date) : null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return valueToHtml(this[_xfa_object.$content] ? this[_xfa_object.$content].toString() : "");
	  }

	}

	class TimeStamp extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "timeStamp");
	    this.id = attributes.id || "";
	    this.server = attributes.server || "";
	    this.type = (0, _utils.getStringOption)(attributes.type, ["optional", "required"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class ToolTip extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "toolTip");
	    this.id = attributes.id || "";
	    this.rid = attributes.rid || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Traversal extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "traversal", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.traverse = new _xfa_object.XFAObjectArray();
	  }

	}

	class Traverse extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "traverse", true);
	    this.id = attributes.id || "";
	    this.operation = (0, _utils.getStringOption)(attributes.operation, ["next", "back", "down", "first", "left", "right", "up"]);
	    this.ref = attributes.ref || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.script = null;
	  }

	  get name() {
	    return this.operation;
	  }

	  [_xfa_object.$isTransparent]() {
	    return false;
	  }

	}

	class Ui extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "ui", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.picture = null;
	    this.barcode = null;
	    this.button = null;
	    this.checkButton = null;
	    this.choiceList = null;
	    this.dateTimeEdit = null;
	    this.defaultUi = null;
	    this.imageEdit = null;
	    this.numericEdit = null;
	    this.passwordEdit = null;
	    this.signature = null;
	    this.textEdit = null;
	  }

	  [_xfa_object.$getExtra]() {
	    if (this[_xfa_object.$extra] === undefined) {
	      for (const name of Object.getOwnPropertyNames(this)) {
	        if (name === "extras" || name === "picture") {
	          continue;
	        }

	        const obj = this[name];

	        if (!(obj instanceof _xfa_object.XFAObject)) {
	          continue;
	        }

	        this[_xfa_object.$extra] = obj;
	        return obj;
	      }

	      this[_xfa_object.$extra] = null;
	    }

	    return this[_xfa_object.$extra];
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const obj = this[_xfa_object.$getExtra]();

	    if (obj) {
	      return obj[_xfa_object.$toHTML](availableSpace);
	    }

	    return _utils.HTMLResult.EMPTY;
	  }

	}

	class Validate extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "validate", true);
	    this.formatTest = (0, _utils.getStringOption)(attributes.formatTest, ["warning", "disabled", "error"]);
	    this.id = attributes.id || "";
	    this.nullTest = (0, _utils.getStringOption)(attributes.nullTest, ["disabled", "error", "warning"]);
	    this.scriptTest = (0, _utils.getStringOption)(attributes.scriptTest, ["error", "disabled", "warning"]);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.extras = null;
	    this.message = null;
	    this.picture = null;
	    this.script = null;
	  }

	}

	class Value extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "value", true);
	    this.id = attributes.id || "";
	    this.override = (0, _utils.getInteger)({
	      data: attributes.override,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.relevant = (0, _utils.getRelevant)(attributes.relevant);
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.arc = null;
	    this.boolean = null;
	    this.date = null;
	    this.dateTime = null;
	    this.decimal = null;
	    this.exData = null;
	    this.float = null;
	    this.image = null;
	    this.integer = null;
	    this.line = null;
	    this.rectangle = null;
	    this.text = null;
	    this.time = null;
	  }

	  [_xfa_object.$setValue](value) {
	    const parent = this[_xfa_object.$getParent]();

	    if (parent instanceof Field) {
	      if (parent.ui && parent.ui.imageEdit) {
	        if (!this.image) {
	          this.image = new Image({});

	          this[_xfa_object.$appendChild](this.image);
	        }

	        this.image[_xfa_object.$content] = value[_xfa_object.$content];
	        return;
	      }
	    }

	    const valueName = value[_xfa_object.$nodeName];

	    if (this[valueName] !== null) {
	      this[valueName][_xfa_object.$content] = value[_xfa_object.$content];
	      return;
	    }

	    for (const name of Object.getOwnPropertyNames(this)) {
	      const obj = this[name];

	      if (obj instanceof _xfa_object.XFAObject) {
	        this[name] = null;

	        this[_xfa_object.$removeChild](obj);
	      }
	    }

	    this[value[_xfa_object.$nodeName]] = value;

	    this[_xfa_object.$appendChild](value);
	  }

	  [_xfa_object.$text]() {
	    if (this.exData) {
	      if (typeof this.exData[_xfa_object.$content] === "string") {
	        return this.exData[_xfa_object.$content].trim();
	      }

	      return this.exData[_xfa_object.$content][_xfa_object.$text]().trim();
	    }

	    for (const name of Object.getOwnPropertyNames(this)) {
	      if (name === "image") {
	        continue;
	      }

	      const obj = this[name];

	      if (obj instanceof _xfa_object.XFAObject) {
	        return (obj[_xfa_object.$content] || "").toString().trim();
	      }
	    }

	    return null;
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    for (const name of Object.getOwnPropertyNames(this)) {
	      const obj = this[name];

	      if (!(obj instanceof _xfa_object.XFAObject)) {
	        continue;
	      }

	      return obj[_xfa_object.$toHTML](availableSpace);
	    }

	    return _utils.HTMLResult.EMPTY;
	  }

	}

	exports.Value = Value;

	class Variables extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(TEMPLATE_NS_ID, "variables", true);
	    this.id = attributes.id || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	    this.boolean = new _xfa_object.XFAObjectArray();
	    this.date = new _xfa_object.XFAObjectArray();
	    this.dateTime = new _xfa_object.XFAObjectArray();
	    this.decimal = new _xfa_object.XFAObjectArray();
	    this.exData = new _xfa_object.XFAObjectArray();
	    this.float = new _xfa_object.XFAObjectArray();
	    this.image = new _xfa_object.XFAObjectArray();
	    this.integer = new _xfa_object.XFAObjectArray();
	    this.manifest = new _xfa_object.XFAObjectArray();
	    this.script = new _xfa_object.XFAObjectArray();
	    this.text = new _xfa_object.XFAObjectArray();
	    this.time = new _xfa_object.XFAObjectArray();
	  }

	  [_xfa_object.$isTransparent]() {
	    return true;
	  }

	}

	class TemplateNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (TemplateNamespace.hasOwnProperty(name)) {
	      const node = TemplateNamespace[name](attributes);

	      node[_xfa_object.$setSetAttributes](attributes);

	      return node;
	    }

	    return undefined;
	  }

	  static appearanceFilter(attrs) {
	    return new AppearanceFilter(attrs);
	  }

	  static arc(attrs) {
	    return new Arc(attrs);
	  }

	  static area(attrs) {
	    return new Area(attrs);
	  }

	  static assist(attrs) {
	    return new Assist(attrs);
	  }

	  static barcode(attrs) {
	    return new Barcode(attrs);
	  }

	  static bind(attrs) {
	    return new Bind(attrs);
	  }

	  static bindItems(attrs) {
	    return new BindItems(attrs);
	  }

	  static bookend(attrs) {
	    return new Bookend(attrs);
	  }

	  static boolean(attrs) {
	    return new BooleanElement(attrs);
	  }

	  static border(attrs) {
	    return new Border(attrs);
	  }

	  static break(attrs) {
	    return new Break(attrs);
	  }

	  static breakAfter(attrs) {
	    return new BreakAfter(attrs);
	  }

	  static breakBefore(attrs) {
	    return new BreakBefore(attrs);
	  }

	  static button(attrs) {
	    return new Button(attrs);
	  }

	  static calculate(attrs) {
	    return new Calculate(attrs);
	  }

	  static caption(attrs) {
	    return new Caption(attrs);
	  }

	  static certificate(attrs) {
	    return new Certificate(attrs);
	  }

	  static certificates(attrs) {
	    return new Certificates(attrs);
	  }

	  static checkButton(attrs) {
	    return new CheckButton(attrs);
	  }

	  static choiceList(attrs) {
	    return new ChoiceList(attrs);
	  }

	  static color(attrs) {
	    return new Color(attrs);
	  }

	  static comb(attrs) {
	    return new Comb(attrs);
	  }

	  static connect(attrs) {
	    return new Connect(attrs);
	  }

	  static contentArea(attrs) {
	    return new ContentArea(attrs);
	  }

	  static corner(attrs) {
	    return new Corner(attrs);
	  }

	  static date(attrs) {
	    return new DateElement(attrs);
	  }

	  static dateTime(attrs) {
	    return new DateTime(attrs);
	  }

	  static dateTimeEdit(attrs) {
	    return new DateTimeEdit(attrs);
	  }

	  static decimal(attrs) {
	    return new Decimal(attrs);
	  }

	  static defaultUi(attrs) {
	    return new DefaultUi(attrs);
	  }

	  static desc(attrs) {
	    return new Desc(attrs);
	  }

	  static digestMethod(attrs) {
	    return new DigestMethod(attrs);
	  }

	  static digestMethods(attrs) {
	    return new DigestMethods(attrs);
	  }

	  static draw(attrs) {
	    return new Draw(attrs);
	  }

	  static edge(attrs) {
	    return new Edge(attrs);
	  }

	  static encoding(attrs) {
	    return new Encoding(attrs);
	  }

	  static encodings(attrs) {
	    return new Encodings(attrs);
	  }

	  static encrypt(attrs) {
	    return new Encrypt(attrs);
	  }

	  static encryptData(attrs) {
	    return new EncryptData(attrs);
	  }

	  static encryption(attrs) {
	    return new Encryption(attrs);
	  }

	  static encryptionMethod(attrs) {
	    return new EncryptionMethod(attrs);
	  }

	  static encryptionMethods(attrs) {
	    return new EncryptionMethods(attrs);
	  }

	  static event(attrs) {
	    return new Event(attrs);
	  }

	  static exData(attrs) {
	    return new ExData(attrs);
	  }

	  static exObject(attrs) {
	    return new ExObject(attrs);
	  }

	  static exclGroup(attrs) {
	    return new ExclGroup(attrs);
	  }

	  static execute(attrs) {
	    return new Execute(attrs);
	  }

	  static extras(attrs) {
	    return new Extras(attrs);
	  }

	  static field(attrs) {
	    return new Field(attrs);
	  }

	  static fill(attrs) {
	    return new Fill(attrs);
	  }

	  static filter(attrs) {
	    return new Filter(attrs);
	  }

	  static float(attrs) {
	    return new Float(attrs);
	  }

	  static font(attrs) {
	    return new Font(attrs);
	  }

	  static format(attrs) {
	    return new Format(attrs);
	  }

	  static handler(attrs) {
	    return new Handler(attrs);
	  }

	  static hyphenation(attrs) {
	    return new Hyphenation(attrs);
	  }

	  static image(attrs) {
	    return new Image(attrs);
	  }

	  static imageEdit(attrs) {
	    return new ImageEdit(attrs);
	  }

	  static integer(attrs) {
	    return new Integer(attrs);
	  }

	  static issuers(attrs) {
	    return new Issuers(attrs);
	  }

	  static items(attrs) {
	    return new Items(attrs);
	  }

	  static keep(attrs) {
	    return new Keep(attrs);
	  }

	  static keyUsage(attrs) {
	    return new KeyUsage(attrs);
	  }

	  static line(attrs) {
	    return new Line(attrs);
	  }

	  static linear(attrs) {
	    return new Linear(attrs);
	  }

	  static lockDocument(attrs) {
	    return new LockDocument(attrs);
	  }

	  static manifest(attrs) {
	    return new Manifest(attrs);
	  }

	  static margin(attrs) {
	    return new Margin(attrs);
	  }

	  static mdp(attrs) {
	    return new Mdp(attrs);
	  }

	  static medium(attrs) {
	    return new Medium(attrs);
	  }

	  static message(attrs) {
	    return new Message(attrs);
	  }

	  static numericEdit(attrs) {
	    return new NumericEdit(attrs);
	  }

	  static occur(attrs) {
	    return new Occur(attrs);
	  }

	  static oid(attrs) {
	    return new Oid(attrs);
	  }

	  static oids(attrs) {
	    return new Oids(attrs);
	  }

	  static overflow(attrs) {
	    return new Overflow(attrs);
	  }

	  static pageArea(attrs) {
	    return new PageArea(attrs);
	  }

	  static pageSet(attrs) {
	    return new PageSet(attrs);
	  }

	  static para(attrs) {
	    return new Para(attrs);
	  }

	  static passwordEdit(attrs) {
	    return new PasswordEdit(attrs);
	  }

	  static pattern(attrs) {
	    return new Pattern(attrs);
	  }

	  static picture(attrs) {
	    return new Picture(attrs);
	  }

	  static proto(attrs) {
	    return new Proto(attrs);
	  }

	  static radial(attrs) {
	    return new Radial(attrs);
	  }

	  static reason(attrs) {
	    return new Reason(attrs);
	  }

	  static reasons(attrs) {
	    return new Reasons(attrs);
	  }

	  static rectangle(attrs) {
	    return new Rectangle(attrs);
	  }

	  static ref(attrs) {
	    return new RefElement(attrs);
	  }

	  static script(attrs) {
	    return new Script(attrs);
	  }

	  static setProperty(attrs) {
	    return new SetProperty(attrs);
	  }

	  static signData(attrs) {
	    return new SignData(attrs);
	  }

	  static signature(attrs) {
	    return new Signature(attrs);
	  }

	  static signing(attrs) {
	    return new Signing(attrs);
	  }

	  static solid(attrs) {
	    return new Solid(attrs);
	  }

	  static speak(attrs) {
	    return new Speak(attrs);
	  }

	  static stipple(attrs) {
	    return new Stipple(attrs);
	  }

	  static subform(attrs) {
	    return new Subform(attrs);
	  }

	  static subformSet(attrs) {
	    return new SubformSet(attrs);
	  }

	  static subjectDN(attrs) {
	    return new SubjectDN(attrs);
	  }

	  static subjectDNs(attrs) {
	    return new SubjectDNs(attrs);
	  }

	  static submit(attrs) {
	    return new Submit(attrs);
	  }

	  static template(attrs) {
	    return new Template(attrs);
	  }

	  static text(attrs) {
	    return new Text(attrs);
	  }

	  static textEdit(attrs) {
	    return new TextEdit(attrs);
	  }

	  static time(attrs) {
	    return new Time(attrs);
	  }

	  static timeStamp(attrs) {
	    return new TimeStamp(attrs);
	  }

	  static toolTip(attrs) {
	    return new ToolTip(attrs);
	  }

	  static traversal(attrs) {
	    return new Traversal(attrs);
	  }

	  static traverse(attrs) {
	    return new Traverse(attrs);
	  }

	  static ui(attrs) {
	    return new Ui(attrs);
	  }

	  static validate(attrs) {
	    return new Validate(attrs);
	  }

	  static value(attrs) {
	    return new Value(attrs);
	  }

	  static variables(attrs) {
	    return new Variables(attrs);
	  }

	}

	exports.TemplateNamespace = TemplateNamespace;

	/***/ }),
	/* 83 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.addHTML = addHTML;
	exports.checkDimensions = checkDimensions;
	exports.flushHTML = flushHTML;
	exports.getAvailableSpace = getAvailableSpace;

	var _xfa_object = __w_pdfjs_require__(77);

	var _html_utils = __w_pdfjs_require__(84);

	function createLine(node, children) {
	  return {
	    name: "div",
	    attributes: {
	      class: [node.layout === "lr-tb" ? "xfaLr" : "xfaRl"]
	    },
	    children
	  };
	}

	function flushHTML(node) {
	  if (!node[_xfa_object.$extra]) {
	    return null;
	  }

	  const attributes = node[_xfa_object.$extra].attributes;
	  const html = {
	    name: "div",
	    attributes,
	    children: node[_xfa_object.$extra].children
	  };

	  if (node[_xfa_object.$extra].failingNode) {
	    const htmlFromFailing = node[_xfa_object.$extra].failingNode[_xfa_object.$flushHTML]();

	    if (htmlFromFailing) {
	      if (node.layout.endsWith("-tb")) {
	        html.children.push(createLine(node, [htmlFromFailing]));
	      } else {
	        html.children.push(htmlFromFailing);
	      }
	    }
	  }

	  if (html.children.length === 0) {
	    return null;
	  }

	  return html;
	}

	function addHTML(node, html, bbox) {
	  const extra = node[_xfa_object.$extra];
	  const availableSpace = extra.availableSpace;
	  const [x, y, w, h] = bbox;

	  switch (node.layout) {
	    case "position":
	      {
	        extra.width = Math.max(extra.width, x + w);
	        extra.height = Math.max(extra.height, y + h);
	        extra.children.push(html);
	        break;
	      }

	    case "lr-tb":
	    case "rl-tb":
	      if (!extra.line || extra.attempt === 1) {
	        extra.line = createLine(node, []);
	        extra.children.push(extra.line);
	        extra.numberInLine = 0;
	      }

	      extra.numberInLine += 1;
	      extra.line.children.push(html);

	      if (extra.attempt === 0) {
	        extra.currentWidth += w;
	        extra.height = Math.max(extra.height, extra.prevHeight + h);
	      } else {
	        extra.currentWidth = w;
	        extra.prevHeight = extra.height;
	        extra.height += h;
	        extra.attempt = 0;
	      }

	      extra.width = Math.max(extra.width, extra.currentWidth);
	      break;

	    case "rl-row":
	    case "row":
	      {
	        extra.children.push(html);
	        extra.width += w;
	        extra.height = Math.max(extra.height, h);
	        const height = (0, _html_utils.measureToString)(extra.height);

	        for (const child of extra.children) {
	          child.attributes.style.height = height;
	        }

	        break;
	      }

	    case "table":
	      {
	        extra.width = Math.min(availableSpace.width, Math.max(extra.width, w));
	        extra.height += h;
	        extra.children.push(html);
	        break;
	      }

	    case "tb":
	      {
	        extra.width = Math.min(availableSpace.width, Math.max(extra.width, w));
	        extra.height += h;
	        extra.children.push(html);
	        break;
	      }
	  }
	}

	function getAvailableSpace(node) {
	  const availableSpace = node[_xfa_object.$extra].availableSpace;
	  const marginV = node.margin ? node.margin.topInset + node.margin.bottomInset : 0;
	  const marginH = node.margin ? node.margin.leftInset + node.margin.rightInset : 0;

	  switch (node.layout) {
	    case "lr-tb":
	    case "rl-tb":
	      if (node[_xfa_object.$extra].attempt === 0) {
	        return {
	          width: availableSpace.width - marginH - node[_xfa_object.$extra].currentWidth,
	          height: availableSpace.height - marginV - node[_xfa_object.$extra].prevHeight
	        };
	      }

	      return {
	        width: availableSpace.width - marginH,
	        height: availableSpace.height - marginV - node[_xfa_object.$extra].height
	      };

	    case "rl-row":
	    case "row":
	      const width = node[_xfa_object.$extra].columnWidths.slice(node[_xfa_object.$extra].currentColumn).reduce((a, x) => a + x);

	      return {
	        width,
	        height: availableSpace.height - marginH
	      };

	    case "table":
	    case "tb":
	      return {
	        width: availableSpace.width - marginH,
	        height: availableSpace.height - marginV - node[_xfa_object.$extra].height
	      };

	    case "position":
	    default:
	      return availableSpace;
	  }
	}

	function getTransformedBBox(node) {
	  let w = node.w === "" ? NaN : node.w;
	  let h = node.h === "" ? NaN : node.h;
	  let [centerX, centerY] = [0, 0];

	  switch (node.anchorType || "") {
	    case "bottomCenter":
	      [centerX, centerY] = [w / 2, h];
	      break;

	    case "bottomLeft":
	      [centerX, centerY] = [0, h];
	      break;

	    case "bottomRight":
	      [centerX, centerY] = [w, h];
	      break;

	    case "middleCenter":
	      [centerX, centerY] = [w / 2, h / 2];
	      break;

	    case "middleLeft":
	      [centerX, centerY] = [0, h / 2];
	      break;

	    case "middleRight":
	      [centerX, centerY] = [w, h / 2];
	      break;

	    case "topCenter":
	      [centerX, centerY] = [w / 2, 0];
	      break;

	    case "topRight":
	      [centerX, centerY] = [w, 0];
	      break;
	  }

	  let x, y;

	  switch (node.rotate || 0) {
	    case 0:
	      [x, y] = [-centerX, -centerY];
	      break;

	    case 90:
	      [x, y] = [-centerY, centerX];
	      [w, h] = [h, -w];
	      break;

	    case 180:
	      [x, y] = [centerX, centerY];
	      [w, h] = [-w, -h];
	      break;

	    case 270:
	      [x, y] = [centerY, -centerX];
	      [w, h] = [-h, w];
	      break;
	  }

	  return [node.x + x + Math.min(0, w), node.y + y + Math.min(0, h), Math.abs(w), Math.abs(h)];
	}

	function checkDimensions(node, space) {
	  if (node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].firstUnsplittable === null) {
	    return true;
	  }

	  if (node.w === 0 || node.h === 0) {
	    return true;
	  }

	  const ERROR = 2;

	  const parent = node[_xfa_object.$getSubformParent]();

	  const attempt = parent[_xfa_object.$extra] && parent[_xfa_object.$extra].attempt || 0;
	  const [, y, w, h] = getTransformedBBox(node);

	  switch (parent.layout) {
	    case "lr-tb":
	    case "rl-tb":
	      if (attempt === 0) {
	        if (!node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].noLayoutFailure) {
	          if (node.h !== "" && Math.round(h - space.height) > ERROR) {
	            return false;
	          }

	          if (node.w !== "") {
	            if (Math.round(w - space.width) <= ERROR) {
	              return true;
	            }

	            if (parent[_xfa_object.$extra].numberInLine === 0) {
	              return space.height > ERROR;
	            }

	            return false;
	          }

	          return space.width > ERROR;
	        }

	        if (node.w !== "") {
	          return Math.round(w - space.width) <= ERROR;
	        }

	        return space.width > ERROR;
	      }

	      if (node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].noLayoutFailure) {
	        return true;
	      }

	      if (node.h !== "" && Math.round(h - space.height) > ERROR) {
	        return false;
	      }

	      if (node.w === "" || Math.round(w - space.width) <= ERROR) {
	        return space.height > ERROR;
	      }

	      if (parent[_xfa_object.$isThereMoreWidth]()) {
	        return false;
	      }

	      return space.height > ERROR;

	    case "table":
	    case "tb":
	      if (node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].noLayoutFailure) {
	        return true;
	      }

	      if (node.h !== "" && !node[_xfa_object.$isSplittable]()) {
	        return Math.round(h - space.height) <= ERROR;
	      }

	      if (node.w === "" || Math.round(w - space.width) <= ERROR) {
	        return space.height > ERROR;
	      }

	      if (parent[_xfa_object.$isThereMoreWidth]()) {
	        return false;
	      }

	      return space.height > ERROR;

	    case "position":
	      if (node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].noLayoutFailure) {
	        return true;
	      }

	      if (node.h === "" || Math.round(h + y - space.height) <= ERROR) {
	        return true;
	      }

	      const area = node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].currentContentArea;

	      return h + y > area.h;

	    case "rl-row":
	    case "row":
	      if (node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].noLayoutFailure) {
	        return true;
	      }

	      if (node.h !== "") {
	        return Math.round(h - space.height) <= ERROR;
	      }

	      return true;

	    default:
	      return true;
	  }
	}

	/***/ }),
	/* 84 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.computeBbox = computeBbox;
	exports.createWrapper = createWrapper;
	exports.fixDimensions = fixDimensions;
	exports.fixTextIndent = fixTextIndent;
	exports.fixURL = fixURL;
	exports.isPrintOnly = isPrintOnly;
	exports.layoutClass = layoutClass;
	exports.layoutNode = layoutNode;
	exports.measureToString = measureToString;
	exports.setAccess = setAccess;
	exports.setFontFamily = setFontFamily;
	exports.setMinMaxDimensions = setMinMaxDimensions;
	exports.setPara = setPara;
	exports.toStyle = toStyle;

	var _xfa_object = __w_pdfjs_require__(77);

	var _util = __w_pdfjs_require__(2);

	var _utils = __w_pdfjs_require__(78);

	var _fonts = __w_pdfjs_require__(85);

	var _text = __w_pdfjs_require__(86);

	function measureToString(m) {
	  if (typeof m === "string") {
	    return "0px";
	  }

	  return Number.isInteger(m) ? `${m}px` : `${m.toFixed(2)}px`;
	}

	const converters = {
	  anchorType(node, style) {
	    const parent = node[_xfa_object.$getSubformParent]();

	    if (!parent || parent.layout && parent.layout !== "position") {
	      return;
	    }

	    if (!("transform" in style)) {
	      style.transform = "";
	    }

	    switch (node.anchorType) {
	      case "bottomCenter":
	        style.transform += "translate(-50%, -100%)";
	        break;

	      case "bottomLeft":
	        style.transform += "translate(0,-100%)";
	        break;

	      case "bottomRight":
	        style.transform += "translate(-100%,-100%)";
	        break;

	      case "middleCenter":
	        style.transform += "translate(-50%,-50%)";
	        break;

	      case "middleLeft":
	        style.transform += "translate(0,-50%)";
	        break;

	      case "middleRight":
	        style.transform += "translate(-100%,-50%)";
	        break;

	      case "topCenter":
	        style.transform += "translate(-50%,0)";
	        break;

	      case "topRight":
	        style.transform += "translate(-100%,0)";
	        break;
	    }
	  },

	  dimensions(node, style) {
	    const parent = node[_xfa_object.$getSubformParent]();

	    let width = node.w;
	    const height = node.h;

	    if (parent.layout && parent.layout.includes("row")) {
	      const extra = parent[_xfa_object.$extra];
	      const colSpan = node.colSpan;
	      let w;

	      if (colSpan === -1) {
	        w = extra.columnWidths.slice(extra.currentColumn).reduce((a, x) => a + x, 0);
	        extra.currentColumn = 0;
	      } else {
	        w = extra.columnWidths.slice(extra.currentColumn, extra.currentColumn + colSpan).reduce((a, x) => a + x, 0);
	        extra.currentColumn = (extra.currentColumn + node.colSpan) % extra.columnWidths.length;
	      }

	      if (!isNaN(w)) {
	        width = node.w = w;
	      }
	    }

	    if (width !== "") {
	      style.width = measureToString(width);
	    } else {
	      style.width = "auto";
	    }

	    if (height !== "") {
	      style.height = measureToString(height);
	    } else {
	      style.height = "auto";
	    }
	  },

	  position(node, style) {
	    const parent = node[_xfa_object.$getSubformParent]();

	    if (parent && parent.layout && parent.layout !== "position") {
	      return;
	    }

	    style.position = "absolute";
	    style.left = measureToString(node.x);
	    style.top = measureToString(node.y);
	  },

	  rotate(node, style) {
	    if (node.rotate) {
	      if (!("transform" in style)) {
	        style.transform = "";
	      }

	      style.transform += `rotate(-${node.rotate}deg)`;
	      style.transformOrigin = "top left";
	    }
	  },

	  presence(node, style) {
	    switch (node.presence) {
	      case "invisible":
	        style.visibility = "hidden";
	        break;

	      case "hidden":
	      case "inactive":
	        style.display = "none";
	        break;
	    }
	  },

	  hAlign(node, style) {
	    if (node[_xfa_object.$nodeName] === "para") {
	      switch (node.hAlign) {
	        case "justifyAll":
	          style.textAlign = "justify-all";
	          break;

	        case "radix":
	          style.textAlign = "left";
	          break;

	        default:
	          style.textAlign = node.hAlign;
	      }
	    } else {
	      switch (node.hAlign) {
	        case "left":
	          style.alignSelf = "start";
	          break;

	        case "center":
	          style.alignSelf = "center";
	          break;

	        case "right":
	          style.alignSelf = "end";
	          break;
	      }
	    }
	  },

	  margin(node, style) {
	    if (node.margin) {
	      style.margin = node.margin[_xfa_object.$toStyle]().margin;
	    }
	  }

	};

	function setMinMaxDimensions(node, style) {
	  const parent = node[_xfa_object.$getSubformParent]();

	  if (parent.layout === "position") {
	    if (node.minW > 0) {
	      style.minWidth = measureToString(node.minW);
	    }

	    if (node.maxW > 0) {
	      style.maxWidth = measureToString(node.maxW);
	    }

	    if (node.minH > 0) {
	      style.minHeight = measureToString(node.minH);
	    }

	    if (node.maxH > 0) {
	      style.maxHeight = measureToString(node.maxH);
	    }
	  }
	}

	function layoutText(text, xfaFont, margin, lineHeight, fontFinder, width) {
	  const measure = new _text.TextMeasure(xfaFont, margin, lineHeight, fontFinder);

	  if (typeof text === "string") {
	    measure.addString(text);
	  } else {
	    text[_xfa_object.$pushGlyphs](measure);
	  }

	  return measure.compute(width);
	}

	function layoutNode(node, availableSpace) {
	  let height = null;
	  let width = null;
	  let isBroken = false;

	  if ((!node.w || !node.h) && node.value) {
	    let marginH = 0;
	    let marginV = 0;

	    if (node.margin) {
	      marginH = node.margin.leftInset + node.margin.rightInset;
	      marginV = node.margin.topInset + node.margin.bottomInset;
	    }

	    let lineHeight = null;
	    let margin = null;

	    if (node.para) {
	      margin = Object.create(null);
	      lineHeight = node.para.lineHeight === "" ? null : node.para.lineHeight;
	      margin.top = node.para.spaceAbove === "" ? 0 : node.para.spaceAbove;
	      margin.bottom = node.para.spaceBelow === "" ? 0 : node.para.spaceBelow;
	      margin.left = node.para.marginLeft === "" ? 0 : node.para.marginLeft;
	      margin.right = node.para.marginRight === "" ? 0 : node.para.marginRight;
	    }

	    let font = node.font;

	    if (!font) {
	      const root = node[_xfa_object.$getTemplateRoot]();

	      let parent = node[_xfa_object.$getParent]();

	      while (parent && parent !== root) {
	        if (parent.font) {
	          font = parent.font;
	          break;
	        }

	        parent = parent[_xfa_object.$getParent]();
	      }
	    }

	    const maxWidth = (node.w || availableSpace.width) - marginH;
	    const fontFinder = node[_xfa_object.$globalData].fontFinder;

	    if (node.value.exData && node.value.exData[_xfa_object.$content] && node.value.exData.contentType === "text/html") {
	      const res = layoutText(node.value.exData[_xfa_object.$content], font, margin, lineHeight, fontFinder, maxWidth);
	      width = res.width;
	      height = res.height;
	      isBroken = res.isBroken;
	    } else {
	      const text = node.value[_xfa_object.$text]();

	      if (text) {
	        const res = layoutText(text, font, margin, lineHeight, fontFinder, maxWidth);
	        width = res.width;
	        height = res.height;
	        isBroken = res.isBroken;
	      }
	    }

	    if (width !== null && !node.w) {
	      width += marginH;
	    }

	    if (height !== null && !node.h) {
	      height += marginV;
	    }
	  }

	  return {
	    w: width,
	    h: height,
	    isBroken
	  };
	}

	function computeBbox(node, html, availableSpace) {
	  let bbox;

	  if (node.w !== "" && node.h !== "") {
	    bbox = [node.x, node.y, node.w, node.h];
	  } else {
	    if (!availableSpace) {
	      return null;
	    }

	    let width = node.w;

	    if (width === "") {
	      if (node.maxW === 0) {
	        const parent = node[_xfa_object.$getSubformParent]();

	        if (parent.layout === "position" && parent.w !== "") {
	          width = 0;
	        } else {
	          width = node.minW;
	        }
	      } else {
	        width = Math.min(node.maxW, availableSpace.width);
	      }

	      html.attributes.style.width = measureToString(width);
	    }

	    let height = node.h;

	    if (height === "") {
	      if (node.maxH === 0) {
	        const parent = node[_xfa_object.$getSubformParent]();

	        if (parent.layout === "position" && parent.h !== "") {
	          height = 0;
	        } else {
	          height = node.minH;
	        }
	      } else {
	        height = Math.min(node.maxH, availableSpace.height);
	      }

	      html.attributes.style.height = measureToString(height);
	    }

	    bbox = [node.x, node.y, width, height];
	  }

	  return bbox;
	}

	function fixDimensions(node) {
	  const parent = node[_xfa_object.$getSubformParent]();

	  if (parent.layout && parent.layout.includes("row")) {
	    const extra = parent[_xfa_object.$extra];
	    const colSpan = node.colSpan;
	    let width;

	    if (colSpan === -1) {
	      width = extra.columnWidths.slice(extra.currentColumn).reduce((a, w) => a + w, 0);
	    } else {
	      width = extra.columnWidths.slice(extra.currentColumn, extra.currentColumn + colSpan).reduce((a, w) => a + w, 0);
	    }

	    if (!isNaN(width)) {
	      node.w = width;
	    }
	  }

	  if (parent.layout && parent.layout !== "position") {
	    node.x = node.y = 0;
	  }

	  if (node.layout === "table") {
	    if (node.w === "" && Array.isArray(node.columnWidths)) {
	      node.w = node.columnWidths.reduce((a, x) => a + x, 0);
	    }
	  }
	}

	function layoutClass(node) {
	  switch (node.layout) {
	    case "position":
	      return "xfaPosition";

	    case "lr-tb":
	      return "xfaLrTb";

	    case "rl-row":
	      return "xfaRlRow";

	    case "rl-tb":
	      return "xfaRlTb";

	    case "row":
	      return "xfaRow";

	    case "table":
	      return "xfaTable";

	    case "tb":
	      return "xfaTb";

	    default:
	      return "xfaPosition";
	  }
	}

	function toStyle(node, ...names) {
	  const style = Object.create(null);

	  for (const name of names) {
	    const value = node[name];

	    if (value === null) {
	      continue;
	    }

	    if (converters.hasOwnProperty(name)) {
	      converters[name](node, style);
	      continue;
	    }

	    if (value instanceof _xfa_object.XFAObject) {
	      const newStyle = value[_xfa_object.$toStyle]();

	      if (newStyle) {
	        Object.assign(style, newStyle);
	      } else {
	        (0, _util.warn)(`(DEBUG) - XFA - style for ${name} not implemented yet`);
	      }
	    }
	  }

	  return style;
	}

	function createWrapper(node, html) {
	  const {
	    attributes
	  } = html;
	  const {
	    style
	  } = attributes;
	  const wrapper = {
	    name: "div",
	    attributes: {
	      class: ["xfaWrapper"],
	      style: Object.create(null)
	    },
	    children: []
	  };
	  attributes.class.push("xfaWrapped");

	  if (node.border) {
	    const {
	      widths,
	      insets
	    } = node.border[_xfa_object.$extra];
	    let width, height;
	    let top = insets[0];
	    let left = insets[3];
	    const insetsH = insets[0] + insets[2];
	    const insetsW = insets[1] + insets[3];

	    switch (node.border.hand) {
	      case "even":
	        top -= widths[0] / 2;
	        left -= widths[3] / 2;
	        width = `calc(100% + ${(widths[1] + widths[3]) / 2 - insetsW}px)`;
	        height = `calc(100% + ${(widths[0] + widths[2]) / 2 - insetsH}px)`;
	        break;

	      case "left":
	        top -= widths[0];
	        left -= widths[3];
	        width = `calc(100% + ${widths[1] + widths[3] - insetsW}px)`;
	        height = `calc(100% + ${widths[0] + widths[2] - insetsH}px)`;
	        break;

	      case "right":
	        width = insetsW ? `calc(100% - ${insetsW}px)` : "100%";
	        height = insetsH ? `calc(100% - ${insetsH}px)` : "100%";
	        break;
	    }

	    const classNames = ["xfaBorder"];

	    if (isPrintOnly(node.border)) {
	      classNames.push("xfaPrintOnly");
	    }

	    const border = {
	      name: "div",
	      attributes: {
	        class: classNames,
	        style: {
	          top: `${top}px`,
	          left: `${left}px`,
	          width,
	          height
	        }
	      },
	      children: []
	    };

	    for (const key of ["border", "borderWidth", "borderColor", "borderRadius", "borderStyle"]) {
	      if (style[key] !== undefined) {
	        border.attributes.style[key] = style[key];
	        delete style[key];
	      }
	    }

	    wrapper.children.push(border, html);
	  } else {
	    wrapper.children.push(html);
	  }

	  for (const key of ["background", "backgroundClip", "top", "left", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "transform", "transformOrigin", "visibility"]) {
	    if (style[key] !== undefined) {
	      wrapper.attributes.style[key] = style[key];
	      delete style[key];
	    }
	  }

	  if (style.position === "absolute") {
	    wrapper.attributes.style.position = "absolute";
	  } else {
	    wrapper.attributes.style.position = "relative";
	  }

	  delete style.position;

	  if (style.alignSelf) {
	    wrapper.attributes.style.alignSelf = style.alignSelf;
	    delete style.alignSelf;
	  }

	  return wrapper;
	}

	function fixTextIndent(styles) {
	  const indent = (0, _utils.getMeasurement)(styles.textIndent, "0px");

	  if (indent >= 0) {
	    return;
	  }

	  const align = styles.textAlign === "right" ? "right" : "left";
	  const name = "padding" + (align === "left" ? "Left" : "Right");
	  const padding = (0, _utils.getMeasurement)(styles[name], "0px");
	  styles[name] = `${padding - indent}px`;
	}

	function setAccess(node, classNames) {
	  switch (node.access) {
	    case "nonInteractive":
	      classNames.push("xfaNonInteractive");
	      break;

	    case "readOnly":
	      classNames.push("xfaReadOnly");
	      break;

	    case "protected":
	      classNames.push("xfaDisabled");
	      break;
	  }
	}

	function isPrintOnly(node) {
	  return node.relevant.length > 0 && !node.relevant[0].excluded && node.relevant[0].viewname === "print";
	}

	function getCurrentPara(node) {
	  const stack = node[_xfa_object.$getTemplateRoot]()[_xfa_object.$extra].paraStack;

	  return stack.length ? stack.at(-1) : null;
	}

	function setPara(node, nodeStyle, value) {
	  if (value.attributes.class && value.attributes.class.includes("xfaRich")) {
	    if (nodeStyle) {
	      if (node.h === "") {
	        nodeStyle.height = "auto";
	      }

	      if (node.w === "") {
	        nodeStyle.width = "auto";
	      }
	    }

	    const para = getCurrentPara(node);

	    if (para) {
	      const valueStyle = value.attributes.style;
	      valueStyle.display = "flex";
	      valueStyle.flexDirection = "column";

	      switch (para.vAlign) {
	        case "top":
	          valueStyle.justifyContent = "start";
	          break;

	        case "bottom":
	          valueStyle.justifyContent = "end";
	          break;

	        case "middle":
	          valueStyle.justifyContent = "center";
	          break;
	      }

	      const paraStyle = para[_xfa_object.$toStyle]();

	      for (const [key, val] of Object.entries(paraStyle)) {
	        if (!(key in valueStyle)) {
	          valueStyle[key] = val;
	        }
	      }
	    }
	  }
	}

	function setFontFamily(xfaFont, node, fontFinder, style) {
	  if (!fontFinder) {
	    delete style.fontFamily;
	    return;
	  }

	  const name = (0, _utils.stripQuotes)(xfaFont.typeface);
	  style.fontFamily = `"${name}"`;
	  const typeface = fontFinder.find(name);

	  if (typeface) {
	    const {
	      fontFamily
	    } = typeface.regular.cssFontInfo;

	    if (fontFamily !== name) {
	      style.fontFamily = `"${fontFamily}"`;
	    }

	    const para = getCurrentPara(node);

	    if (para && para.lineHeight !== "") {
	      return;
	    }

	    if (style.lineHeight) {
	      return;
	    }

	    const pdfFont = (0, _fonts.selectFont)(xfaFont, typeface);

	    if (pdfFont) {
	      style.lineHeight = Math.max(1.2, pdfFont.lineHeight);
	    }
	  }
	}

	function fixURL(str) {
	  const absoluteUrl = (0, _util.createValidAbsoluteUrl)(str, null, {
	    addDefaultProtocol: true,
	    tryConvertEncoding: true
	  });
	  return absoluteUrl ? absoluteUrl.href : null;
	}

	/***/ }),
	/* 85 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.FontFinder = void 0;
	exports.getMetrics = getMetrics;
	exports.selectFont = selectFont;

	var _xfa_object = __w_pdfjs_require__(77);

	var _utils = __w_pdfjs_require__(78);

	var _util = __w_pdfjs_require__(2);

	class FontFinder {
	  constructor(pdfFonts) {
	    this.fonts = new Map();
	    this.cache = new Map();
	    this.warned = new Set();
	    this.defaultFont = null;
	    this.add(pdfFonts);
	  }

	  add(pdfFonts, reallyMissingFonts = null) {
	    for (const pdfFont of pdfFonts) {
	      this.addPdfFont(pdfFont);
	    }

	    for (const pdfFont of this.fonts.values()) {
	      if (!pdfFont.regular) {
	        pdfFont.regular = pdfFont.italic || pdfFont.bold || pdfFont.bolditalic;
	      }
	    }

	    if (!reallyMissingFonts || reallyMissingFonts.size === 0) {
	      return;
	    }

	    const myriad = this.fonts.get("PdfJS-Fallback-PdfJS-XFA");

	    for (const missing of reallyMissingFonts) {
	      this.fonts.set(missing, myriad);
	    }
	  }

	  addPdfFont(pdfFont) {
	    const cssFontInfo = pdfFont.cssFontInfo;
	    const name = cssFontInfo.fontFamily;
	    let font = this.fonts.get(name);

	    if (!font) {
	      font = Object.create(null);
	      this.fonts.set(name, font);

	      if (!this.defaultFont) {
	        this.defaultFont = font;
	      }
	    }

	    let property = "";
	    const fontWeight = parseFloat(cssFontInfo.fontWeight);

	    if (parseFloat(cssFontInfo.italicAngle) !== 0) {
	      property = fontWeight >= 700 ? "bolditalic" : "italic";
	    } else if (fontWeight >= 700) {
	      property = "bold";
	    }

	    if (!property) {
	      if (pdfFont.name.includes("Bold") || pdfFont.psName && pdfFont.psName.includes("Bold")) {
	        property = "bold";
	      }

	      if (pdfFont.name.includes("Italic") || pdfFont.name.endsWith("It") || pdfFont.psName && (pdfFont.psName.includes("Italic") || pdfFont.psName.endsWith("It"))) {
	        property += "italic";
	      }
	    }

	    if (!property) {
	      property = "regular";
	    }

	    font[property] = pdfFont;
	  }

	  getDefault() {
	    return this.defaultFont;
	  }

	  find(fontName, mustWarn = true) {
	    let font = this.fonts.get(fontName) || this.cache.get(fontName);

	    if (font) {
	      return font;
	    }

	    const pattern = /,|-|_| |bolditalic|bold|italic|regular|it/gi;
	    let name = fontName.replace(pattern, "");
	    font = this.fonts.get(name);

	    if (font) {
	      this.cache.set(fontName, font);
	      return font;
	    }

	    name = name.toLowerCase();
	    const maybe = [];

	    for (const [family, pdfFont] of this.fonts.entries()) {
	      if (family.replace(pattern, "").toLowerCase().startsWith(name)) {
	        maybe.push(pdfFont);
	      }
	    }

	    if (maybe.length === 0) {
	      for (const [, pdfFont] of this.fonts.entries()) {
	        if (pdfFont.regular.name && pdfFont.regular.name.replace(pattern, "").toLowerCase().startsWith(name)) {
	          maybe.push(pdfFont);
	        }
	      }
	    }

	    if (maybe.length === 0) {
	      name = name.replace(/psmt|mt/gi, "");

	      for (const [family, pdfFont] of this.fonts.entries()) {
	        if (family.replace(pattern, "").toLowerCase().startsWith(name)) {
	          maybe.push(pdfFont);
	        }
	      }
	    }

	    if (maybe.length === 0) {
	      for (const pdfFont of this.fonts.values()) {
	        if (pdfFont.regular.name && pdfFont.regular.name.replace(pattern, "").toLowerCase().startsWith(name)) {
	          maybe.push(pdfFont);
	        }
	      }
	    }

	    if (maybe.length >= 1) {
	      if (maybe.length !== 1 && mustWarn) {
	        (0, _util.warn)(`XFA - Too many choices to guess the correct font: ${fontName}`);
	      }

	      this.cache.set(fontName, maybe[0]);
	      return maybe[0];
	    }

	    if (mustWarn && !this.warned.has(fontName)) {
	      this.warned.add(fontName);
	      (0, _util.warn)(`XFA - Cannot find the font: ${fontName}`);
	    }

	    return null;
	  }

	}

	exports.FontFinder = FontFinder;

	function selectFont(xfaFont, typeface) {
	  if (xfaFont.posture === "italic") {
	    if (xfaFont.weight === "bold") {
	      return typeface.bolditalic;
	    }

	    return typeface.italic;
	  } else if (xfaFont.weight === "bold") {
	    return typeface.bold;
	  }

	  return typeface.regular;
	}

	function getMetrics(xfaFont, real = false) {
	  let pdfFont = null;

	  if (xfaFont) {
	    const name = (0, _utils.stripQuotes)(xfaFont.typeface);

	    const typeface = xfaFont[_xfa_object.$globalData].fontFinder.find(name);

	    pdfFont = selectFont(xfaFont, typeface);
	  }

	  if (!pdfFont) {
	    return {
	      lineHeight: 12,
	      lineGap: 2,
	      lineNoGap: 10
	    };
	  }

	  const size = xfaFont.size || 10;
	  const lineHeight = pdfFont.lineHeight ? Math.max(real ? 0 : 1.2, pdfFont.lineHeight) : 1.2;
	  const lineGap = pdfFont.lineGap === undefined ? 0.2 : pdfFont.lineGap;
	  return {
	    lineHeight: lineHeight * size,
	    lineGap: lineGap * size,
	    lineNoGap: Math.max(1, lineHeight - lineGap) * size
	  };
	}

	/***/ }),
	/* 86 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.TextMeasure = void 0;

	var _fonts = __w_pdfjs_require__(85);

	const WIDTH_FACTOR = 1.02;

	class FontInfo {
	  constructor(xfaFont, margin, lineHeight, fontFinder) {
	    this.lineHeight = lineHeight;
	    this.paraMargin = margin || {
	      top: 0,
	      bottom: 0,
	      left: 0,
	      right: 0
	    };

	    if (!xfaFont) {
	      [this.pdfFont, this.xfaFont] = this.defaultFont(fontFinder);
	      return;
	    }

	    this.xfaFont = {
	      typeface: xfaFont.typeface,
	      posture: xfaFont.posture,
	      weight: xfaFont.weight,
	      size: xfaFont.size,
	      letterSpacing: xfaFont.letterSpacing
	    };
	    const typeface = fontFinder.find(xfaFont.typeface);

	    if (!typeface) {
	      [this.pdfFont, this.xfaFont] = this.defaultFont(fontFinder);
	      return;
	    }

	    this.pdfFont = (0, _fonts.selectFont)(xfaFont, typeface);

	    if (!this.pdfFont) {
	      [this.pdfFont, this.xfaFont] = this.defaultFont(fontFinder);
	    }
	  }

	  defaultFont(fontFinder) {
	    const font = fontFinder.find("Helvetica", false) || fontFinder.find("Myriad Pro", false) || fontFinder.find("Arial", false) || fontFinder.getDefault();

	    if (font && font.regular) {
	      const pdfFont = font.regular;
	      const info = pdfFont.cssFontInfo;
	      const xfaFont = {
	        typeface: info.fontFamily,
	        posture: "normal",
	        weight: "normal",
	        size: 10,
	        letterSpacing: 0
	      };
	      return [pdfFont, xfaFont];
	    }

	    const xfaFont = {
	      typeface: "Courier",
	      posture: "normal",
	      weight: "normal",
	      size: 10,
	      letterSpacing: 0
	    };
	    return [null, xfaFont];
	  }

	}

	class FontSelector {
	  constructor(defaultXfaFont, defaultParaMargin, defaultLineHeight, fontFinder) {
	    this.fontFinder = fontFinder;
	    this.stack = [new FontInfo(defaultXfaFont, defaultParaMargin, defaultLineHeight, fontFinder)];
	  }

	  pushData(xfaFont, margin, lineHeight) {
	    const lastFont = this.stack.at(-1);

	    for (const name of ["typeface", "posture", "weight", "size", "letterSpacing"]) {
	      if (!xfaFont[name]) {
	        xfaFont[name] = lastFont.xfaFont[name];
	      }
	    }

	    for (const name of ["top", "bottom", "left", "right"]) {
	      if (isNaN(margin[name])) {
	        margin[name] = lastFont.paraMargin[name];
	      }
	    }

	    const fontInfo = new FontInfo(xfaFont, margin, lineHeight || lastFont.lineHeight, this.fontFinder);

	    if (!fontInfo.pdfFont) {
	      fontInfo.pdfFont = lastFont.pdfFont;
	    }

	    this.stack.push(fontInfo);
	  }

	  popFont() {
	    this.stack.pop();
	  }

	  topFont() {
	    return this.stack.at(-1);
	  }

	}

	class TextMeasure {
	  constructor(defaultXfaFont, defaultParaMargin, defaultLineHeight, fonts) {
	    this.glyphs = [];
	    this.fontSelector = new FontSelector(defaultXfaFont, defaultParaMargin, defaultLineHeight, fonts);
	    this.extraHeight = 0;
	  }

	  pushData(xfaFont, margin, lineHeight) {
	    this.fontSelector.pushData(xfaFont, margin, lineHeight);
	  }

	  popFont(xfaFont) {
	    return this.fontSelector.popFont();
	  }

	  addPara() {
	    const lastFont = this.fontSelector.topFont();
	    this.extraHeight += lastFont.paraMargin.top + lastFont.paraMargin.bottom;
	  }

	  addString(str) {
	    if (!str) {
	      return;
	    }

	    const lastFont = this.fontSelector.topFont();
	    const fontSize = lastFont.xfaFont.size;

	    if (lastFont.pdfFont) {
	      const letterSpacing = lastFont.xfaFont.letterSpacing;
	      const pdfFont = lastFont.pdfFont;
	      const fontLineHeight = pdfFont.lineHeight || 1.2;
	      const lineHeight = lastFont.lineHeight || Math.max(1.2, fontLineHeight) * fontSize;
	      const lineGap = pdfFont.lineGap === undefined ? 0.2 : pdfFont.lineGap;
	      const noGap = fontLineHeight - lineGap;
	      const firstLineHeight = Math.max(1, noGap) * fontSize;
	      const scale = fontSize / 1000;
	      const fallbackWidth = pdfFont.defaultWidth || pdfFont.charsToGlyphs(" ")[0].width;

	      for (const line of str.split(/[\u2029\n]/)) {
	        const encodedLine = pdfFont.encodeString(line).join("");
	        const glyphs = pdfFont.charsToGlyphs(encodedLine);

	        for (const glyph of glyphs) {
	          const width = glyph.width || fallbackWidth;
	          this.glyphs.push([width * scale + letterSpacing, lineHeight, firstLineHeight, glyph.unicode, false]);
	        }

	        this.glyphs.push([0, 0, 0, "\n", true]);
	      }

	      this.glyphs.pop();
	      return;
	    }

	    for (const line of str.split(/[\u2029\n]/)) {
	      for (const char of line.split("")) {
	        this.glyphs.push([fontSize, 1.2 * fontSize, fontSize, char, false]);
	      }

	      this.glyphs.push([0, 0, 0, "\n", true]);
	    }

	    this.glyphs.pop();
	  }

	  compute(maxWidth) {
	    let lastSpacePos = -1,
	        lastSpaceWidth = 0,
	        width = 0,
	        height = 0,
	        currentLineWidth = 0,
	        currentLineHeight = 0;
	    let isBroken = false;
	    let isFirstLine = true;

	    for (let i = 0, ii = this.glyphs.length; i < ii; i++) {
	      const [glyphWidth, lineHeight, firstLineHeight, char, isEOL] = this.glyphs[i];
	      const isSpace = char === " ";
	      const glyphHeight = isFirstLine ? firstLineHeight : lineHeight;

	      if (isEOL) {
	        width = Math.max(width, currentLineWidth);
	        currentLineWidth = 0;
	        height += currentLineHeight;
	        currentLineHeight = glyphHeight;
	        lastSpacePos = -1;
	        lastSpaceWidth = 0;
	        isFirstLine = false;
	        continue;
	      }

	      if (isSpace) {
	        if (currentLineWidth + glyphWidth > maxWidth) {
	          width = Math.max(width, currentLineWidth);
	          currentLineWidth = 0;
	          height += currentLineHeight;
	          currentLineHeight = glyphHeight;
	          lastSpacePos = -1;
	          lastSpaceWidth = 0;
	          isBroken = true;
	          isFirstLine = false;
	        } else {
	          currentLineHeight = Math.max(glyphHeight, currentLineHeight);
	          lastSpaceWidth = currentLineWidth;
	          currentLineWidth += glyphWidth;
	          lastSpacePos = i;
	        }

	        continue;
	      }

	      if (currentLineWidth + glyphWidth > maxWidth) {
	        height += currentLineHeight;
	        currentLineHeight = glyphHeight;

	        if (lastSpacePos !== -1) {
	          i = lastSpacePos;
	          width = Math.max(width, lastSpaceWidth);
	          currentLineWidth = 0;
	          lastSpacePos = -1;
	          lastSpaceWidth = 0;
	        } else {
	          width = Math.max(width, currentLineWidth);
	          currentLineWidth = glyphWidth;
	        }

	        isBroken = true;
	        isFirstLine = false;
	        continue;
	      }

	      currentLineWidth += glyphWidth;
	      currentLineHeight = Math.max(glyphHeight, currentLineHeight);
	    }

	    width = Math.max(width, currentLineWidth);
	    height += currentLineHeight + this.extraHeight;
	    return {
	      width: WIDTH_FACTOR * width,
	      height,
	      isBroken
	    };
	  }

	}

	exports.TextMeasure = TextMeasure;

	/***/ }),
	/* 87 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.DataHandler = void 0;

	var _xfa_object = __w_pdfjs_require__(77);

	class DataHandler {
	  constructor(root, data) {
	    this.data = data;
	    this.dataset = root.datasets || null;
	  }

	  serialize(storage) {
	    const stack = [[-1, this.data[_xfa_object.$getChildren]()]];

	    while (stack.length > 0) {
	      const last = stack.at(-1);
	      const [i, children] = last;

	      if (i + 1 === children.length) {
	        stack.pop();
	        continue;
	      }

	      const child = children[++last[0]];
	      const storageEntry = storage.get(child[_xfa_object.$uid]);

	      if (storageEntry) {
	        child[_xfa_object.$setValue](storageEntry);
	      } else {
	        const attributes = child[_xfa_object.$getAttributes]();

	        for (const value of attributes.values()) {
	          const entry = storage.get(value[_xfa_object.$uid]);

	          if (entry) {
	            value[_xfa_object.$setValue](entry);

	            break;
	          }
	        }
	      }

	      const nodes = child[_xfa_object.$getChildren]();

	      if (nodes.length > 0) {
	        stack.push([-1, nodes]);
	      }
	    }

	    const buf = [`<xfa:datasets xmlns:xfa="http://www.xfa.org/schema/xfa-data/1.0/">`];

	    if (this.dataset) {
	      for (const child of this.dataset[_xfa_object.$getChildren]()) {
	        if (child[_xfa_object.$nodeName] !== "data") {
	          child[_xfa_object.$toString](buf);
	        }
	      }
	    }

	    this.data[_xfa_object.$toString](buf);

	    buf.push("</xfa:datasets>");
	    return buf.join("");
	  }

	}

	exports.DataHandler = DataHandler;

	/***/ }),
	/* 88 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XFAParser = void 0;

	var _xfa_object = __w_pdfjs_require__(77);

	var _xml_parser = __w_pdfjs_require__(66);

	var _builder = __w_pdfjs_require__(89);

	var _util = __w_pdfjs_require__(2);

	class XFAParser extends _xml_parser.XMLParserBase {
	  constructor(rootNameSpace = null, richText = false) {
	    super();
	    this._builder = new _builder.Builder(rootNameSpace);
	    this._stack = [];
	    this._globalData = {
	      usedTypefaces: new Set()
	    };
	    this._ids = new Map();
	    this._current = this._builder.buildRoot(this._ids);
	    this._errorCode = _xml_parser.XMLParserErrorCode.NoError;
	    this._whiteRegex = /^\s+$/;
	    this._nbsps = /\xa0+/g;
	    this._richText = richText;
	  }

	  parse(data) {
	    this.parseXml(data);

	    if (this._errorCode !== _xml_parser.XMLParserErrorCode.NoError) {
	      return undefined;
	    }

	    this._current[_xfa_object.$finalize]();

	    return this._current.element;
	  }

	  onText(text) {
	    text = text.replace(this._nbsps, match => match.slice(1) + " ");

	    if (this._richText || this._current[_xfa_object.$acceptWhitespace]()) {
	      this._current[_xfa_object.$onText](text, this._richText);

	      return;
	    }

	    if (this._whiteRegex.test(text)) {
	      return;
	    }

	    this._current[_xfa_object.$onText](text.trim());
	  }

	  onCdata(text) {
	    this._current[_xfa_object.$onText](text);
	  }

	  _mkAttributes(attributes, tagName) {
	    let namespace = null;
	    let prefixes = null;
	    const attributeObj = Object.create({});

	    for (const {
	      name,
	      value
	    } of attributes) {
	      if (name === "xmlns") {
	        if (!namespace) {
	          namespace = value;
	        } else {
	          (0, _util.warn)(`XFA - multiple namespace definition in <${tagName}>`);
	        }
	      } else if (name.startsWith("xmlns:")) {
	        const prefix = name.substring("xmlns:".length);

	        if (!prefixes) {
	          prefixes = [];
	        }

	        prefixes.push({
	          prefix,
	          value
	        });
	      } else {
	        const i = name.indexOf(":");

	        if (i === -1) {
	          attributeObj[name] = value;
	        } else {
	          let nsAttrs = attributeObj[_xfa_object.$nsAttributes];

	          if (!nsAttrs) {
	            nsAttrs = attributeObj[_xfa_object.$nsAttributes] = Object.create(null);
	          }

	          const [ns, attrName] = [name.slice(0, i), name.slice(i + 1)];
	          let attrs = nsAttrs[ns];

	          if (!attrs) {
	            attrs = nsAttrs[ns] = Object.create(null);
	          }

	          attrs[attrName] = value;
	        }
	      }
	    }

	    return [namespace, prefixes, attributeObj];
	  }

	  _getNameAndPrefix(name, nsAgnostic) {
	    const i = name.indexOf(":");

	    if (i === -1) {
	      return [name, null];
	    }

	    return [name.substring(i + 1), nsAgnostic ? "" : name.substring(0, i)];
	  }

	  onBeginElement(tagName, attributes, isEmpty) {
	    const [namespace, prefixes, attributesObj] = this._mkAttributes(attributes, tagName);

	    const [name, nsPrefix] = this._getNameAndPrefix(tagName, this._builder.isNsAgnostic());

	    const node = this._builder.build({
	      nsPrefix,
	      name,
	      attributes: attributesObj,
	      namespace,
	      prefixes
	    });

	    node[_xfa_object.$globalData] = this._globalData;

	    if (isEmpty) {
	      node[_xfa_object.$finalize]();

	      if (this._current[_xfa_object.$onChild](node)) {
	        node[_xfa_object.$setId](this._ids);
	      }

	      node[_xfa_object.$clean](this._builder);

	      return;
	    }

	    this._stack.push(this._current);

	    this._current = node;
	  }

	  onEndElement(name) {
	    const node = this._current;

	    if (node[_xfa_object.$isCDATAXml]() && typeof node[_xfa_object.$content] === "string") {
	      const parser = new XFAParser();
	      parser._globalData = this._globalData;
	      const root = parser.parse(node[_xfa_object.$content]);
	      node[_xfa_object.$content] = null;

	      node[_xfa_object.$onChild](root);
	    }

	    node[_xfa_object.$finalize]();

	    this._current = this._stack.pop();

	    if (this._current[_xfa_object.$onChild](node)) {
	      node[_xfa_object.$setId](this._ids);
	    }

	    node[_xfa_object.$clean](this._builder);
	  }

	  onError(code) {
	    this._errorCode = code;
	  }

	}

	exports.XFAParser = XFAParser;

	/***/ }),
	/* 89 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.Builder = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	var _setup = __w_pdfjs_require__(90);

	var _template = __w_pdfjs_require__(82);

	var _unknown = __w_pdfjs_require__(99);

	var _util = __w_pdfjs_require__(2);

	class Root extends _xfa_object.XFAObject {
	  constructor(ids) {
	    super(-1, "root", Object.create(null));
	    this.element = null;
	    this[_xfa_object.$ids] = ids;
	  }

	  [_xfa_object.$onChild](child) {
	    this.element = child;
	    return true;
	  }

	  [_xfa_object.$finalize]() {
	    super[_xfa_object.$finalize]();

	    if (this.element.template instanceof _template.Template) {
	      this[_xfa_object.$ids].set(_xfa_object.$root, this.element);

	      this.element.template[_xfa_object.$resolvePrototypes](this[_xfa_object.$ids]);

	      this.element.template[_xfa_object.$ids] = this[_xfa_object.$ids];
	    }
	  }

	}

	class Empty extends _xfa_object.XFAObject {
	  constructor() {
	    super(-1, "", Object.create(null));
	  }

	  [_xfa_object.$onChild](_) {
	    return false;
	  }

	}

	class Builder {
	  constructor(rootNameSpace = null) {
	    this._namespaceStack = [];
	    this._nsAgnosticLevel = 0;
	    this._namespacePrefixes = new Map();
	    this._namespaces = new Map();
	    this._nextNsId = Math.max(...Object.values(_namespaces.NamespaceIds).map(({
	      id
	    }) => id));
	    this._currentNamespace = rootNameSpace || new _unknown.UnknownNamespace(++this._nextNsId);
	  }

	  buildRoot(ids) {
	    return new Root(ids);
	  }

	  build({
	    nsPrefix,
	    name,
	    attributes,
	    namespace,
	    prefixes
	  }) {
	    const hasNamespaceDef = namespace !== null;

	    if (hasNamespaceDef) {
	      this._namespaceStack.push(this._currentNamespace);

	      this._currentNamespace = this._searchNamespace(namespace);
	    }

	    if (prefixes) {
	      this._addNamespacePrefix(prefixes);
	    }

	    if (attributes.hasOwnProperty(_xfa_object.$nsAttributes)) {
	      const dataTemplate = _setup.NamespaceSetUp.datasets;
	      const nsAttrs = attributes[_xfa_object.$nsAttributes];
	      let xfaAttrs = null;

	      for (const [ns, attrs] of Object.entries(nsAttrs)) {
	        const nsToUse = this._getNamespaceToUse(ns);

	        if (nsToUse === dataTemplate) {
	          xfaAttrs = {
	            xfa: attrs
	          };
	          break;
	        }
	      }

	      if (xfaAttrs) {
	        attributes[_xfa_object.$nsAttributes] = xfaAttrs;
	      } else {
	        delete attributes[_xfa_object.$nsAttributes];
	      }
	    }

	    const namespaceToUse = this._getNamespaceToUse(nsPrefix);

	    const node = namespaceToUse && namespaceToUse[_namespaces.$buildXFAObject](name, attributes) || new Empty();

	    if (node[_xfa_object.$isNsAgnostic]()) {
	      this._nsAgnosticLevel++;
	    }

	    if (hasNamespaceDef || prefixes || node[_xfa_object.$isNsAgnostic]()) {
	      node[_xfa_object.$cleanup] = {
	        hasNamespace: hasNamespaceDef,
	        prefixes,
	        nsAgnostic: node[_xfa_object.$isNsAgnostic]()
	      };
	    }

	    return node;
	  }

	  isNsAgnostic() {
	    return this._nsAgnosticLevel > 0;
	  }

	  _searchNamespace(nsName) {
	    let ns = this._namespaces.get(nsName);

	    if (ns) {
	      return ns;
	    }

	    for (const [name, {
	      check
	    }] of Object.entries(_namespaces.NamespaceIds)) {
	      if (check(nsName)) {
	        ns = _setup.NamespaceSetUp[name];

	        if (ns) {
	          this._namespaces.set(nsName, ns);

	          return ns;
	        }

	        break;
	      }
	    }

	    ns = new _unknown.UnknownNamespace(++this._nextNsId);

	    this._namespaces.set(nsName, ns);

	    return ns;
	  }

	  _addNamespacePrefix(prefixes) {
	    for (const {
	      prefix,
	      value
	    } of prefixes) {
	      const namespace = this._searchNamespace(value);

	      let prefixStack = this._namespacePrefixes.get(prefix);

	      if (!prefixStack) {
	        prefixStack = [];

	        this._namespacePrefixes.set(prefix, prefixStack);
	      }

	      prefixStack.push(namespace);
	    }
	  }

	  _getNamespaceToUse(prefix) {
	    if (!prefix) {
	      return this._currentNamespace;
	    }

	    const prefixStack = this._namespacePrefixes.get(prefix);

	    if (prefixStack && prefixStack.length > 0) {
	      return prefixStack.at(-1);
	    }

	    (0, _util.warn)(`Unknown namespace prefix: ${prefix}.`);
	    return null;
	  }

	  clean(data) {
	    const {
	      hasNamespace,
	      prefixes,
	      nsAgnostic
	    } = data;

	    if (hasNamespace) {
	      this._currentNamespace = this._namespaceStack.pop();
	    }

	    if (prefixes) {
	      prefixes.forEach(({
	        prefix
	      }) => {
	        this._namespacePrefixes.get(prefix).pop();
	      });
	    }

	    if (nsAgnostic) {
	      this._nsAgnosticLevel--;
	    }
	  }

	}

	exports.Builder = Builder;

	/***/ }),
	/* 90 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.NamespaceSetUp = void 0;

	var _config = __w_pdfjs_require__(91);

	var _connection_set = __w_pdfjs_require__(92);

	var _datasets = __w_pdfjs_require__(93);

	var _locale_set = __w_pdfjs_require__(94);

	var _signature = __w_pdfjs_require__(95);

	var _stylesheet = __w_pdfjs_require__(96);

	var _template = __w_pdfjs_require__(82);

	var _xdp = __w_pdfjs_require__(97);

	var _xhtml = __w_pdfjs_require__(98);

	const NamespaceSetUp = {
	  config: _config.ConfigNamespace,
	  connection: _connection_set.ConnectionSetNamespace,
	  datasets: _datasets.DatasetsNamespace,
	  localeSet: _locale_set.LocaleSetNamespace,
	  signature: _signature.SignatureNamespace,
	  stylesheet: _stylesheet.StylesheetNamespace,
	  template: _template.TemplateNamespace,
	  xdp: _xdp.XdpNamespace,
	  xhtml: _xhtml.XhtmlNamespace
	};
	exports.NamespaceSetUp = NamespaceSetUp;

	/***/ }),
	/* 91 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ConfigNamespace = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	var _utils = __w_pdfjs_require__(78);

	var _util = __w_pdfjs_require__(2);

	const CONFIG_NS_ID = _namespaces.NamespaceIds.config.id;

	class Acrobat extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "acrobat", true);
	    this.acrobat7 = null;
	    this.autoSave = null;
	    this.common = null;
	    this.validate = null;
	    this.validateApprovalSignatures = null;
	    this.submitUrl = new _xfa_object.XFAObjectArray();
	  }

	}

	class Acrobat7 extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "acrobat7", true);
	    this.dynamicRender = null;
	  }

	}

	class ADBE_JSConsole extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "ADBE_JSConsole", ["delegate", "Enable", "Disable"]);
	  }

	}

	class ADBE_JSDebugger extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "ADBE_JSDebugger", ["delegate", "Enable", "Disable"]);
	  }

	}

	class AddSilentPrint extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "addSilentPrint");
	  }

	}

	class AddViewerPreferences extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "addViewerPreferences");
	  }

	}

	class AdjustData extends _xfa_object.Option10 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "adjustData");
	  }

	}

	class AdobeExtensionLevel extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "adobeExtensionLevel", 0, n => n >= 1 && n <= 8);
	  }

	}

	class Agent extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "agent", true);
	    this.name = attributes.name ? attributes.name.trim() : "";
	    this.common = new _xfa_object.XFAObjectArray();
	  }

	}

	class AlwaysEmbed extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "alwaysEmbed");
	  }

	}

	class Amd extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "amd");
	  }

	}

	class Area extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "area");
	    this.level = (0, _utils.getInteger)({
	      data: attributes.level,
	      defaultValue: 0,
	      validate: n => n >= 1 && n <= 3
	    });
	    this.name = (0, _utils.getStringOption)(attributes.name, ["", "barcode", "coreinit", "deviceDriver", "font", "general", "layout", "merge", "script", "signature", "sourceSet", "templateCache"]);
	  }

	}

	class Attributes extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "attributes", ["preserve", "delegate", "ignore"]);
	  }

	}

	class AutoSave extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "autoSave", ["disabled", "enabled"]);
	  }

	}

	class Base extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "base");
	  }

	}

	class BatchOutput extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "batchOutput");
	    this.format = (0, _utils.getStringOption)(attributes.format, ["none", "concat", "zip", "zipCompress"]);
	  }

	}

	class BehaviorOverride extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "behaviorOverride");
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = new Map(this[_xfa_object.$content].trim().split(/\s+/).filter(x => x.includes(":")).map(x => x.split(":", 2)));
	  }

	}

	class Cache extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "cache", true);
	    this.templateCache = null;
	  }

	}

	class Change extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "change");
	  }

	}

	class Common extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "common", true);
	    this.data = null;
	    this.locale = null;
	    this.localeSet = null;
	    this.messaging = null;
	    this.suppressBanner = null;
	    this.template = null;
	    this.validationMessaging = null;
	    this.versionControl = null;
	    this.log = new _xfa_object.XFAObjectArray();
	  }

	}

	class Compress extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "compress");
	    this.scope = (0, _utils.getStringOption)(attributes.scope, ["imageOnly", "document"]);
	  }

	}

	class CompressLogicalStructure extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "compressLogicalStructure");
	  }

	}

	class CompressObjectStream extends _xfa_object.Option10 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "compressObjectStream");
	  }

	}

	class Compression extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "compression", true);
	    this.compressLogicalStructure = null;
	    this.compressObjectStream = null;
	    this.level = null;
	    this.type = null;
	  }

	}

	class Config extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "config", true);
	    this.acrobat = null;
	    this.present = null;
	    this.trace = null;
	    this.agent = new _xfa_object.XFAObjectArray();
	  }

	}

	class Conformance extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "conformance", ["A", "B"]);
	  }

	}

	class ContentCopy extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "contentCopy");
	  }

	}

	class Copies extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "copies", 1, n => n >= 1);
	  }

	}

	class Creator extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "creator");
	  }

	}

	class CurrentPage extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "currentPage", 0, n => n >= 0);
	  }

	}

	class Data extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "data", true);
	    this.adjustData = null;
	    this.attributes = null;
	    this.incrementalLoad = null;
	    this.outputXSL = null;
	    this.range = null;
	    this.record = null;
	    this.startNode = null;
	    this.uri = null;
	    this.window = null;
	    this.xsl = null;
	    this.excludeNS = new _xfa_object.XFAObjectArray();
	    this.transform = new _xfa_object.XFAObjectArray();
	  }

	}

	class Debug extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "debug", true);
	    this.uri = null;
	  }

	}

	class DefaultTypeface extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "defaultTypeface");
	    this.writingScript = (0, _utils.getStringOption)(attributes.writingScript, ["*", "Arabic", "Cyrillic", "EastEuropeanRoman", "Greek", "Hebrew", "Japanese", "Korean", "Roman", "SimplifiedChinese", "Thai", "TraditionalChinese", "Vietnamese"]);
	  }

	}

	class Destination extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "destination", ["pdf", "pcl", "ps", "webClient", "zpl"]);
	  }

	}

	class DocumentAssembly extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "documentAssembly");
	  }

	}

	class Driver extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "driver", true);
	    this.name = attributes.name ? attributes.name.trim() : "";
	    this.fontInfo = null;
	    this.xdc = null;
	  }

	}

	class DuplexOption extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "duplexOption", ["simplex", "duplexFlipLongEdge", "duplexFlipShortEdge"]);
	  }

	}

	class DynamicRender extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "dynamicRender", ["forbidden", "required"]);
	  }

	}

	class Embed extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "embed");
	  }

	}

	class Encrypt extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "encrypt");
	  }

	}

	class Encryption extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "encryption", true);
	    this.encrypt = null;
	    this.encryptionLevel = null;
	    this.permissions = null;
	  }

	}

	class EncryptionLevel extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "encryptionLevel", ["40bit", "128bit"]);
	  }

	}

	class Enforce extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "enforce");
	  }

	}

	class Equate extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "equate");
	    this.force = (0, _utils.getInteger)({
	      data: attributes.force,
	      defaultValue: 1,
	      validate: n => n === 0
	    });
	    this.from = attributes.from || "";
	    this.to = attributes.to || "";
	  }

	}

	class EquateRange extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "equateRange");
	    this.from = attributes.from || "";
	    this.to = attributes.to || "";
	    this._unicodeRange = attributes.unicodeRange || "";
	  }

	  get unicodeRange() {
	    const ranges = [];
	    const unicodeRegex = /U\+([0-9a-fA-F]+)/;
	    const unicodeRange = this._unicodeRange;

	    for (let range of unicodeRange.split(",").map(x => x.trim()).filter(x => !!x)) {
	      range = range.split("-", 2).map(x => {
	        const found = x.match(unicodeRegex);

	        if (!found) {
	          return 0;
	        }

	        return parseInt(found[1], 16);
	      });

	      if (range.length === 1) {
	        range.push(range[0]);
	      }

	      ranges.push(range);
	    }

	    return (0, _util.shadow)(this, "unicodeRange", ranges);
	  }

	}

	class Exclude extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "exclude");
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = this[_xfa_object.$content].trim().split(/\s+/).filter(x => x && ["calculate", "close", "enter", "exit", "initialize", "ready", "validate"].includes(x));
	  }

	}

	class ExcludeNS extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "excludeNS");
	  }

	}

	class FlipLabel extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "flipLabel", ["usePrinterSetting", "on", "off"]);
	  }

	}

	class FontInfo extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "fontInfo", true);
	    this.embed = null;
	    this.map = null;
	    this.subsetBelow = null;
	    this.alwaysEmbed = new _xfa_object.XFAObjectArray();
	    this.defaultTypeface = new _xfa_object.XFAObjectArray();
	    this.neverEmbed = new _xfa_object.XFAObjectArray();
	  }

	}

	class FormFieldFilling extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "formFieldFilling");
	  }

	}

	class GroupParent extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "groupParent");
	  }

	}

	class IfEmpty extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "ifEmpty", ["dataValue", "dataGroup", "ignore", "remove"]);
	  }

	}

	class IncludeXDPContent extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "includeXDPContent");
	  }

	}

	class IncrementalLoad extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "incrementalLoad", ["none", "forwardOnly"]);
	  }

	}

	class IncrementalMerge extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "incrementalMerge");
	  }

	}

	class Interactive extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "interactive");
	  }

	}

	class Jog extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "jog", ["usePrinterSetting", "none", "pageSet"]);
	  }

	}

	class LabelPrinter extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "labelPrinter", true);
	    this.name = (0, _utils.getStringOption)(attributes.name, ["zpl", "dpl", "ipl", "tcpl"]);
	    this.batchOutput = null;
	    this.flipLabel = null;
	    this.fontInfo = null;
	    this.xdc = null;
	  }

	}

	class Layout extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "layout", ["paginate", "panel"]);
	  }

	}

	class Level extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "level", 0, n => n > 0);
	  }

	}

	class Linearized extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "linearized");
	  }

	}

	class Locale extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "locale");
	  }

	}

	class LocaleSet extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "localeSet");
	  }

	}

	class Log extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "log", true);
	    this.mode = null;
	    this.threshold = null;
	    this.to = null;
	    this.uri = null;
	  }

	}

	class MapElement extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "map", true);
	    this.equate = new _xfa_object.XFAObjectArray();
	    this.equateRange = new _xfa_object.XFAObjectArray();
	  }

	}

	class MediumInfo extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "mediumInfo", true);
	    this.map = null;
	  }

	}

	class Message extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "message", true);
	    this.msgId = null;
	    this.severity = null;
	  }

	}

	class Messaging extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "messaging", true);
	    this.message = new _xfa_object.XFAObjectArray();
	  }

	}

	class Mode extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "mode", ["append", "overwrite"]);
	  }

	}

	class ModifyAnnots extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "modifyAnnots");
	  }

	}

	class MsgId extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "msgId", 1, n => n >= 1);
	  }

	}

	class NameAttr extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "nameAttr");
	  }

	}

	class NeverEmbed extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "neverEmbed");
	  }

	}

	class NumberOfCopies extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "numberOfCopies", null, n => n >= 2 && n <= 5);
	  }

	}

	class OpenAction extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "openAction", true);
	    this.destination = null;
	  }

	}

	class Output extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "output", true);
	    this.to = null;
	    this.type = null;
	    this.uri = null;
	  }

	}

	class OutputBin extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "outputBin");
	  }

	}

	class OutputXSL extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "outputXSL", true);
	    this.uri = null;
	  }

	}

	class Overprint extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "overprint", ["none", "both", "draw", "field"]);
	  }

	}

	class Packets extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "packets");
	  }

	  [_xfa_object.$finalize]() {
	    if (this[_xfa_object.$content] === "*") {
	      return;
	    }

	    this[_xfa_object.$content] = this[_xfa_object.$content].trim().split(/\s+/).filter(x => ["config", "datasets", "template", "xfdf", "xslt"].includes(x));
	  }

	}

	class PageOffset extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "pageOffset");
	    this.x = (0, _utils.getInteger)({
	      data: attributes.x,
	      defaultValue: "useXDCSetting",
	      validate: n => true
	    });
	    this.y = (0, _utils.getInteger)({
	      data: attributes.y,
	      defaultValue: "useXDCSetting",
	      validate: n => true
	    });
	  }

	}

	class PageRange extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "pageRange");
	  }

	  [_xfa_object.$finalize]() {
	    const numbers = this[_xfa_object.$content].trim().split(/\s+/).map(x => parseInt(x, 10));

	    const ranges = [];

	    for (let i = 0, ii = numbers.length; i < ii; i += 2) {
	      ranges.push(numbers.slice(i, i + 2));
	    }

	    this[_xfa_object.$content] = ranges;
	  }

	}

	class Pagination extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "pagination", ["simplex", "duplexShortEdge", "duplexLongEdge"]);
	  }

	}

	class PaginationOverride extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "paginationOverride", ["none", "forceDuplex", "forceDuplexLongEdge", "forceDuplexShortEdge", "forceSimplex"]);
	  }

	}

	class Part extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "part", 1, n => false);
	  }

	}

	class Pcl extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "pcl", true);
	    this.name = attributes.name || "";
	    this.batchOutput = null;
	    this.fontInfo = null;
	    this.jog = null;
	    this.mediumInfo = null;
	    this.outputBin = null;
	    this.pageOffset = null;
	    this.staple = null;
	    this.xdc = null;
	  }

	}

	class Pdf extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "pdf", true);
	    this.name = attributes.name || "";
	    this.adobeExtensionLevel = null;
	    this.batchOutput = null;
	    this.compression = null;
	    this.creator = null;
	    this.encryption = null;
	    this.fontInfo = null;
	    this.interactive = null;
	    this.linearized = null;
	    this.openAction = null;
	    this.pdfa = null;
	    this.producer = null;
	    this.renderPolicy = null;
	    this.scriptModel = null;
	    this.silentPrint = null;
	    this.submitFormat = null;
	    this.tagged = null;
	    this.version = null;
	    this.viewerPreferences = null;
	    this.xdc = null;
	  }

	}

	class Pdfa extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "pdfa", true);
	    this.amd = null;
	    this.conformance = null;
	    this.includeXDPContent = null;
	    this.part = null;
	  }

	}

	class Permissions extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "permissions", true);
	    this.accessibleContent = null;
	    this.change = null;
	    this.contentCopy = null;
	    this.documentAssembly = null;
	    this.formFieldFilling = null;
	    this.modifyAnnots = null;
	    this.plaintextMetadata = null;
	    this.print = null;
	    this.printHighQuality = null;
	  }

	}

	class PickTrayByPDFSize extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "pickTrayByPDFSize");
	  }

	}

	class Picture extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "picture");
	  }

	}

	class PlaintextMetadata extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "plaintextMetadata");
	  }

	}

	class Presence extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "presence", ["preserve", "dissolve", "dissolveStructure", "ignore", "remove"]);
	  }

	}

	class Present extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "present", true);
	    this.behaviorOverride = null;
	    this.cache = null;
	    this.common = null;
	    this.copies = null;
	    this.destination = null;
	    this.incrementalMerge = null;
	    this.layout = null;
	    this.output = null;
	    this.overprint = null;
	    this.pagination = null;
	    this.paginationOverride = null;
	    this.script = null;
	    this.validate = null;
	    this.xdp = null;
	    this.driver = new _xfa_object.XFAObjectArray();
	    this.labelPrinter = new _xfa_object.XFAObjectArray();
	    this.pcl = new _xfa_object.XFAObjectArray();
	    this.pdf = new _xfa_object.XFAObjectArray();
	    this.ps = new _xfa_object.XFAObjectArray();
	    this.submitUrl = new _xfa_object.XFAObjectArray();
	    this.webClient = new _xfa_object.XFAObjectArray();
	    this.zpl = new _xfa_object.XFAObjectArray();
	  }

	}

	class Print extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "print");
	  }

	}

	class PrintHighQuality extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "printHighQuality");
	  }

	}

	class PrintScaling extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "printScaling", ["appdefault", "noScaling"]);
	  }

	}

	class PrinterName extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "printerName");
	  }

	}

	class Producer extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "producer");
	  }

	}

	class Ps extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "ps", true);
	    this.name = attributes.name || "";
	    this.batchOutput = null;
	    this.fontInfo = null;
	    this.jog = null;
	    this.mediumInfo = null;
	    this.outputBin = null;
	    this.staple = null;
	    this.xdc = null;
	  }

	}

	class Range extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "range");
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = this[_xfa_object.$content].trim().split(/\s*,\s*/, 2).map(range => range.split("-").map(x => parseInt(x.trim(), 10))).filter(range => range.every(x => !isNaN(x))).map(range => {
	      if (range.length === 1) {
	        range.push(range[0]);
	      }

	      return range;
	    });
	  }

	}

	class Record extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "record");
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = this[_xfa_object.$content].trim();
	    const n = parseInt(this[_xfa_object.$content], 10);

	    if (!isNaN(n) && n >= 0) {
	      this[_xfa_object.$content] = n;
	    }
	  }

	}

	class Relevant extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "relevant");
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = this[_xfa_object.$content].trim().split(/\s+/);
	  }

	}

	class Rename extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "rename");
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = this[_xfa_object.$content].trim();

	    if (this[_xfa_object.$content].toLowerCase().startsWith("xml") || this[_xfa_object.$content].match(new RegExp("[\\p{L}_][\\p{L}\\d._\\p{M}-]*", "u"))) {
	      (0, _util.warn)("XFA - Rename: invalid XFA name");
	    }
	  }

	}

	class RenderPolicy extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "renderPolicy", ["server", "client"]);
	  }

	}

	class RunScripts extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "runScripts", ["both", "client", "none", "server"]);
	  }

	}

	class Script extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "script", true);
	    this.currentPage = null;
	    this.exclude = null;
	    this.runScripts = null;
	  }

	}

	class ScriptModel extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "scriptModel", ["XFA", "none"]);
	  }

	}

	class Severity extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "severity", ["ignore", "error", "information", "trace", "warning"]);
	  }

	}

	class SilentPrint extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "silentPrint", true);
	    this.addSilentPrint = null;
	    this.printerName = null;
	  }

	}

	class Staple extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "staple");
	    this.mode = (0, _utils.getStringOption)(attributes.mode, ["usePrinterSetting", "on", "off"]);
	  }

	}

	class StartNode extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "startNode");
	  }

	}

	class StartPage extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "startPage", 0, n => true);
	  }

	}

	class SubmitFormat extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "submitFormat", ["html", "delegate", "fdf", "xml", "pdf"]);
	  }

	}

	class SubmitUrl extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "submitUrl");
	  }

	}

	class SubsetBelow extends _xfa_object.IntegerObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "subsetBelow", 100, n => n >= 0 && n <= 100);
	  }

	}

	class SuppressBanner extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "suppressBanner");
	  }

	}

	class Tagged extends _xfa_object.Option01 {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "tagged");
	  }

	}

	class Template extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "template", true);
	    this.base = null;
	    this.relevant = null;
	    this.startPage = null;
	    this.uri = null;
	    this.xsl = null;
	  }

	}

	class Threshold extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "threshold", ["trace", "error", "information", "warning"]);
	  }

	}

	class To extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "to", ["null", "memory", "stderr", "stdout", "system", "uri"]);
	  }

	}

	class TemplateCache extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "templateCache");
	    this.maxEntries = (0, _utils.getInteger)({
	      data: attributes.maxEntries,
	      defaultValue: 5,
	      validate: n => n >= 0
	    });
	  }

	}

	class Trace extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "trace", true);
	    this.area = new _xfa_object.XFAObjectArray();
	  }

	}

	class Transform extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "transform", true);
	    this.groupParent = null;
	    this.ifEmpty = null;
	    this.nameAttr = null;
	    this.picture = null;
	    this.presence = null;
	    this.rename = null;
	    this.whitespace = null;
	  }

	}

	class Type extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "type", ["none", "ascii85", "asciiHex", "ccittfax", "flate", "lzw", "runLength", "native", "xdp", "mergedXDP"]);
	  }

	}

	class Uri extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "uri");
	  }

	}

	class Validate extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "validate", ["preSubmit", "prePrint", "preExecute", "preSave"]);
	  }

	}

	class ValidateApprovalSignatures extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "validateApprovalSignatures");
	  }

	  [_xfa_object.$finalize]() {
	    this[_xfa_object.$content] = this[_xfa_object.$content].trim().split(/\s+/).filter(x => ["docReady", "postSign"].includes(x));
	  }

	}

	class ValidationMessaging extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "validationMessaging", ["allMessagesIndividually", "allMessagesTogether", "firstMessageOnly", "noMessages"]);
	  }

	}

	class Version extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "version", ["1.7", "1.6", "1.5", "1.4", "1.3", "1.2"]);
	  }

	}

	class VersionControl extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "VersionControl");
	    this.outputBelow = (0, _utils.getStringOption)(attributes.outputBelow, ["warn", "error", "update"]);
	    this.sourceAbove = (0, _utils.getStringOption)(attributes.sourceAbove, ["warn", "error"]);
	    this.sourceBelow = (0, _utils.getStringOption)(attributes.sourceBelow, ["update", "maintain"]);
	  }

	}

	class ViewerPreferences extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "viewerPreferences", true);
	    this.ADBE_JSConsole = null;
	    this.ADBE_JSDebugger = null;
	    this.addViewerPreferences = null;
	    this.duplexOption = null;
	    this.enforce = null;
	    this.numberOfCopies = null;
	    this.pageRange = null;
	    this.pickTrayByPDFSize = null;
	    this.printScaling = null;
	  }

	}

	class WebClient extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "webClient", true);
	    this.name = attributes.name ? attributes.name.trim() : "";
	    this.fontInfo = null;
	    this.xdc = null;
	  }

	}

	class Whitespace extends _xfa_object.OptionObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "whitespace", ["preserve", "ltrim", "normalize", "rtrim", "trim"]);
	  }

	}

	class Window extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "window");
	  }

	  [_xfa_object.$finalize]() {
	    const pair = this[_xfa_object.$content].trim().split(/\s*,\s*/, 2).map(x => parseInt(x, 10));

	    if (pair.some(x => isNaN(x))) {
	      this[_xfa_object.$content] = [0, 0];
	      return;
	    }

	    if (pair.length === 1) {
	      pair.push(pair[0]);
	    }

	    this[_xfa_object.$content] = pair;
	  }

	}

	class Xdc extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "xdc", true);
	    this.uri = new _xfa_object.XFAObjectArray();
	    this.xsl = new _xfa_object.XFAObjectArray();
	  }

	}

	class Xdp extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "xdp", true);
	    this.packets = null;
	  }

	}

	class Xsl extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "xsl", true);
	    this.debug = null;
	    this.uri = null;
	  }

	}

	class Zpl extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONFIG_NS_ID, "zpl", true);
	    this.name = attributes.name ? attributes.name.trim() : "";
	    this.batchOutput = null;
	    this.flipLabel = null;
	    this.fontInfo = null;
	    this.xdc = null;
	  }

	}

	class ConfigNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (ConfigNamespace.hasOwnProperty(name)) {
	      return ConfigNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static acrobat(attrs) {
	    return new Acrobat(attrs);
	  }

	  static acrobat7(attrs) {
	    return new Acrobat7(attrs);
	  }

	  static ADBE_JSConsole(attrs) {
	    return new ADBE_JSConsole(attrs);
	  }

	  static ADBE_JSDebugger(attrs) {
	    return new ADBE_JSDebugger(attrs);
	  }

	  static addSilentPrint(attrs) {
	    return new AddSilentPrint(attrs);
	  }

	  static addViewerPreferences(attrs) {
	    return new AddViewerPreferences(attrs);
	  }

	  static adjustData(attrs) {
	    return new AdjustData(attrs);
	  }

	  static adobeExtensionLevel(attrs) {
	    return new AdobeExtensionLevel(attrs);
	  }

	  static agent(attrs) {
	    return new Agent(attrs);
	  }

	  static alwaysEmbed(attrs) {
	    return new AlwaysEmbed(attrs);
	  }

	  static amd(attrs) {
	    return new Amd(attrs);
	  }

	  static area(attrs) {
	    return new Area(attrs);
	  }

	  static attributes(attrs) {
	    return new Attributes(attrs);
	  }

	  static autoSave(attrs) {
	    return new AutoSave(attrs);
	  }

	  static base(attrs) {
	    return new Base(attrs);
	  }

	  static batchOutput(attrs) {
	    return new BatchOutput(attrs);
	  }

	  static behaviorOverride(attrs) {
	    return new BehaviorOverride(attrs);
	  }

	  static cache(attrs) {
	    return new Cache(attrs);
	  }

	  static change(attrs) {
	    return new Change(attrs);
	  }

	  static common(attrs) {
	    return new Common(attrs);
	  }

	  static compress(attrs) {
	    return new Compress(attrs);
	  }

	  static compressLogicalStructure(attrs) {
	    return new CompressLogicalStructure(attrs);
	  }

	  static compressObjectStream(attrs) {
	    return new CompressObjectStream(attrs);
	  }

	  static compression(attrs) {
	    return new Compression(attrs);
	  }

	  static config(attrs) {
	    return new Config(attrs);
	  }

	  static conformance(attrs) {
	    return new Conformance(attrs);
	  }

	  static contentCopy(attrs) {
	    return new ContentCopy(attrs);
	  }

	  static copies(attrs) {
	    return new Copies(attrs);
	  }

	  static creator(attrs) {
	    return new Creator(attrs);
	  }

	  static currentPage(attrs) {
	    return new CurrentPage(attrs);
	  }

	  static data(attrs) {
	    return new Data(attrs);
	  }

	  static debug(attrs) {
	    return new Debug(attrs);
	  }

	  static defaultTypeface(attrs) {
	    return new DefaultTypeface(attrs);
	  }

	  static destination(attrs) {
	    return new Destination(attrs);
	  }

	  static documentAssembly(attrs) {
	    return new DocumentAssembly(attrs);
	  }

	  static driver(attrs) {
	    return new Driver(attrs);
	  }

	  static duplexOption(attrs) {
	    return new DuplexOption(attrs);
	  }

	  static dynamicRender(attrs) {
	    return new DynamicRender(attrs);
	  }

	  static embed(attrs) {
	    return new Embed(attrs);
	  }

	  static encrypt(attrs) {
	    return new Encrypt(attrs);
	  }

	  static encryption(attrs) {
	    return new Encryption(attrs);
	  }

	  static encryptionLevel(attrs) {
	    return new EncryptionLevel(attrs);
	  }

	  static enforce(attrs) {
	    return new Enforce(attrs);
	  }

	  static equate(attrs) {
	    return new Equate(attrs);
	  }

	  static equateRange(attrs) {
	    return new EquateRange(attrs);
	  }

	  static exclude(attrs) {
	    return new Exclude(attrs);
	  }

	  static excludeNS(attrs) {
	    return new ExcludeNS(attrs);
	  }

	  static flipLabel(attrs) {
	    return new FlipLabel(attrs);
	  }

	  static fontInfo(attrs) {
	    return new FontInfo(attrs);
	  }

	  static formFieldFilling(attrs) {
	    return new FormFieldFilling(attrs);
	  }

	  static groupParent(attrs) {
	    return new GroupParent(attrs);
	  }

	  static ifEmpty(attrs) {
	    return new IfEmpty(attrs);
	  }

	  static includeXDPContent(attrs) {
	    return new IncludeXDPContent(attrs);
	  }

	  static incrementalLoad(attrs) {
	    return new IncrementalLoad(attrs);
	  }

	  static incrementalMerge(attrs) {
	    return new IncrementalMerge(attrs);
	  }

	  static interactive(attrs) {
	    return new Interactive(attrs);
	  }

	  static jog(attrs) {
	    return new Jog(attrs);
	  }

	  static labelPrinter(attrs) {
	    return new LabelPrinter(attrs);
	  }

	  static layout(attrs) {
	    return new Layout(attrs);
	  }

	  static level(attrs) {
	    return new Level(attrs);
	  }

	  static linearized(attrs) {
	    return new Linearized(attrs);
	  }

	  static locale(attrs) {
	    return new Locale(attrs);
	  }

	  static localeSet(attrs) {
	    return new LocaleSet(attrs);
	  }

	  static log(attrs) {
	    return new Log(attrs);
	  }

	  static map(attrs) {
	    return new MapElement(attrs);
	  }

	  static mediumInfo(attrs) {
	    return new MediumInfo(attrs);
	  }

	  static message(attrs) {
	    return new Message(attrs);
	  }

	  static messaging(attrs) {
	    return new Messaging(attrs);
	  }

	  static mode(attrs) {
	    return new Mode(attrs);
	  }

	  static modifyAnnots(attrs) {
	    return new ModifyAnnots(attrs);
	  }

	  static msgId(attrs) {
	    return new MsgId(attrs);
	  }

	  static nameAttr(attrs) {
	    return new NameAttr(attrs);
	  }

	  static neverEmbed(attrs) {
	    return new NeverEmbed(attrs);
	  }

	  static numberOfCopies(attrs) {
	    return new NumberOfCopies(attrs);
	  }

	  static openAction(attrs) {
	    return new OpenAction(attrs);
	  }

	  static output(attrs) {
	    return new Output(attrs);
	  }

	  static outputBin(attrs) {
	    return new OutputBin(attrs);
	  }

	  static outputXSL(attrs) {
	    return new OutputXSL(attrs);
	  }

	  static overprint(attrs) {
	    return new Overprint(attrs);
	  }

	  static packets(attrs) {
	    return new Packets(attrs);
	  }

	  static pageOffset(attrs) {
	    return new PageOffset(attrs);
	  }

	  static pageRange(attrs) {
	    return new PageRange(attrs);
	  }

	  static pagination(attrs) {
	    return new Pagination(attrs);
	  }

	  static paginationOverride(attrs) {
	    return new PaginationOverride(attrs);
	  }

	  static part(attrs) {
	    return new Part(attrs);
	  }

	  static pcl(attrs) {
	    return new Pcl(attrs);
	  }

	  static pdf(attrs) {
	    return new Pdf(attrs);
	  }

	  static pdfa(attrs) {
	    return new Pdfa(attrs);
	  }

	  static permissions(attrs) {
	    return new Permissions(attrs);
	  }

	  static pickTrayByPDFSize(attrs) {
	    return new PickTrayByPDFSize(attrs);
	  }

	  static picture(attrs) {
	    return new Picture(attrs);
	  }

	  static plaintextMetadata(attrs) {
	    return new PlaintextMetadata(attrs);
	  }

	  static presence(attrs) {
	    return new Presence(attrs);
	  }

	  static present(attrs) {
	    return new Present(attrs);
	  }

	  static print(attrs) {
	    return new Print(attrs);
	  }

	  static printHighQuality(attrs) {
	    return new PrintHighQuality(attrs);
	  }

	  static printScaling(attrs) {
	    return new PrintScaling(attrs);
	  }

	  static printerName(attrs) {
	    return new PrinterName(attrs);
	  }

	  static producer(attrs) {
	    return new Producer(attrs);
	  }

	  static ps(attrs) {
	    return new Ps(attrs);
	  }

	  static range(attrs) {
	    return new Range(attrs);
	  }

	  static record(attrs) {
	    return new Record(attrs);
	  }

	  static relevant(attrs) {
	    return new Relevant(attrs);
	  }

	  static rename(attrs) {
	    return new Rename(attrs);
	  }

	  static renderPolicy(attrs) {
	    return new RenderPolicy(attrs);
	  }

	  static runScripts(attrs) {
	    return new RunScripts(attrs);
	  }

	  static script(attrs) {
	    return new Script(attrs);
	  }

	  static scriptModel(attrs) {
	    return new ScriptModel(attrs);
	  }

	  static severity(attrs) {
	    return new Severity(attrs);
	  }

	  static silentPrint(attrs) {
	    return new SilentPrint(attrs);
	  }

	  static staple(attrs) {
	    return new Staple(attrs);
	  }

	  static startNode(attrs) {
	    return new StartNode(attrs);
	  }

	  static startPage(attrs) {
	    return new StartPage(attrs);
	  }

	  static submitFormat(attrs) {
	    return new SubmitFormat(attrs);
	  }

	  static submitUrl(attrs) {
	    return new SubmitUrl(attrs);
	  }

	  static subsetBelow(attrs) {
	    return new SubsetBelow(attrs);
	  }

	  static suppressBanner(attrs) {
	    return new SuppressBanner(attrs);
	  }

	  static tagged(attrs) {
	    return new Tagged(attrs);
	  }

	  static template(attrs) {
	    return new Template(attrs);
	  }

	  static templateCache(attrs) {
	    return new TemplateCache(attrs);
	  }

	  static threshold(attrs) {
	    return new Threshold(attrs);
	  }

	  static to(attrs) {
	    return new To(attrs);
	  }

	  static trace(attrs) {
	    return new Trace(attrs);
	  }

	  static transform(attrs) {
	    return new Transform(attrs);
	  }

	  static type(attrs) {
	    return new Type(attrs);
	  }

	  static uri(attrs) {
	    return new Uri(attrs);
	  }

	  static validate(attrs) {
	    return new Validate(attrs);
	  }

	  static validateApprovalSignatures(attrs) {
	    return new ValidateApprovalSignatures(attrs);
	  }

	  static validationMessaging(attrs) {
	    return new ValidationMessaging(attrs);
	  }

	  static version(attrs) {
	    return new Version(attrs);
	  }

	  static versionControl(attrs) {
	    return new VersionControl(attrs);
	  }

	  static viewerPreferences(attrs) {
	    return new ViewerPreferences(attrs);
	  }

	  static webClient(attrs) {
	    return new WebClient(attrs);
	  }

	  static whitespace(attrs) {
	    return new Whitespace(attrs);
	  }

	  static window(attrs) {
	    return new Window(attrs);
	  }

	  static xdc(attrs) {
	    return new Xdc(attrs);
	  }

	  static xdp(attrs) {
	    return new Xdp(attrs);
	  }

	  static xsl(attrs) {
	    return new Xsl(attrs);
	  }

	  static zpl(attrs) {
	    return new Zpl(attrs);
	  }

	}

	exports.ConfigNamespace = ConfigNamespace;

	/***/ }),
	/* 92 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.ConnectionSetNamespace = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	const CONNECTION_SET_NS_ID = _namespaces.NamespaceIds.connectionSet.id;

	class ConnectionSet extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "connectionSet", true);
	    this.wsdlConnection = new _xfa_object.XFAObjectArray();
	    this.xmlConnection = new _xfa_object.XFAObjectArray();
	    this.xsdConnection = new _xfa_object.XFAObjectArray();
	  }

	}

	class EffectiveInputPolicy extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "effectiveInputPolicy");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class EffectiveOutputPolicy extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "effectiveOutputPolicy");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Operation extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "operation");
	    this.id = attributes.id || "";
	    this.input = attributes.input || "";
	    this.name = attributes.name || "";
	    this.output = attributes.output || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class RootElement extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "rootElement");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class SoapAction extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "soapAction");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class SoapAddress extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "soapAddress");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class Uri extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "uri");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class WsdlAddress extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "wsdlAddress");
	    this.id = attributes.id || "";
	    this.name = attributes.name || "";
	    this.use = attributes.use || "";
	    this.usehref = attributes.usehref || "";
	  }

	}

	class WsdlConnection extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "wsdlConnection", true);
	    this.dataDescription = attributes.dataDescription || "";
	    this.name = attributes.name || "";
	    this.effectiveInputPolicy = null;
	    this.effectiveOutputPolicy = null;
	    this.operation = null;
	    this.soapAction = null;
	    this.soapAddress = null;
	    this.wsdlAddress = null;
	  }

	}

	class XmlConnection extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "xmlConnection", true);
	    this.dataDescription = attributes.dataDescription || "";
	    this.name = attributes.name || "";
	    this.uri = null;
	  }

	}

	class XsdConnection extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(CONNECTION_SET_NS_ID, "xsdConnection", true);
	    this.dataDescription = attributes.dataDescription || "";
	    this.name = attributes.name || "";
	    this.rootElement = null;
	    this.uri = null;
	  }

	}

	class ConnectionSetNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (ConnectionSetNamespace.hasOwnProperty(name)) {
	      return ConnectionSetNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static connectionSet(attrs) {
	    return new ConnectionSet(attrs);
	  }

	  static effectiveInputPolicy(attrs) {
	    return new EffectiveInputPolicy(attrs);
	  }

	  static effectiveOutputPolicy(attrs) {
	    return new EffectiveOutputPolicy(attrs);
	  }

	  static operation(attrs) {
	    return new Operation(attrs);
	  }

	  static rootElement(attrs) {
	    return new RootElement(attrs);
	  }

	  static soapAction(attrs) {
	    return new SoapAction(attrs);
	  }

	  static soapAddress(attrs) {
	    return new SoapAddress(attrs);
	  }

	  static uri(attrs) {
	    return new Uri(attrs);
	  }

	  static wsdlAddress(attrs) {
	    return new WsdlAddress(attrs);
	  }

	  static wsdlConnection(attrs) {
	    return new WsdlConnection(attrs);
	  }

	  static xmlConnection(attrs) {
	    return new XmlConnection(attrs);
	  }

	  static xsdConnection(attrs) {
	    return new XsdConnection(attrs);
	  }

	}

	exports.ConnectionSetNamespace = ConnectionSetNamespace;

	/***/ }),
	/* 93 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.DatasetsNamespace = void 0;

	var _xfa_object = __w_pdfjs_require__(77);

	var _namespaces = __w_pdfjs_require__(79);

	const DATASETS_NS_ID = _namespaces.NamespaceIds.datasets.id;

	class Data extends _xfa_object.XmlObject {
	  constructor(attributes) {
	    super(DATASETS_NS_ID, "data", attributes);
	  }

	  [_xfa_object.$isNsAgnostic]() {
	    return true;
	  }

	}

	class Datasets extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(DATASETS_NS_ID, "datasets", true);
	    this.data = null;
	    this.Signature = null;
	  }

	  [_xfa_object.$onChild](child) {
	    const name = child[_xfa_object.$nodeName];

	    if (name === "data" && child[_xfa_object.$namespaceId] === DATASETS_NS_ID || name === "Signature" && child[_xfa_object.$namespaceId] === _namespaces.NamespaceIds.signature.id) {
	      this[name] = child;
	    }

	    this[_xfa_object.$appendChild](child);
	  }

	}

	class DatasetsNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (DatasetsNamespace.hasOwnProperty(name)) {
	      return DatasetsNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static datasets(attributes) {
	    return new Datasets(attributes);
	  }

	  static data(attributes) {
	    return new Data(attributes);
	  }

	}

	exports.DatasetsNamespace = DatasetsNamespace;

	/***/ }),
	/* 94 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.LocaleSetNamespace = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	var _utils = __w_pdfjs_require__(78);

	const LOCALE_SET_NS_ID = _namespaces.NamespaceIds.localeSet.id;

	class CalendarSymbols extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "calendarSymbols", true);
	    this.name = "gregorian";
	    this.dayNames = new _xfa_object.XFAObjectArray(2);
	    this.eraNames = null;
	    this.meridiemNames = null;
	    this.monthNames = new _xfa_object.XFAObjectArray(2);
	  }

	}

	class CurrencySymbol extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "currencySymbol");
	    this.name = (0, _utils.getStringOption)(attributes.name, ["symbol", "isoname", "decimal"]);
	  }

	}

	class CurrencySymbols extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "currencySymbols", true);
	    this.currencySymbol = new _xfa_object.XFAObjectArray(3);
	  }

	}

	class DatePattern extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "datePattern");
	    this.name = (0, _utils.getStringOption)(attributes.name, ["full", "long", "med", "short"]);
	  }

	}

	class DatePatterns extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "datePatterns", true);
	    this.datePattern = new _xfa_object.XFAObjectArray(4);
	  }

	}

	class DateTimeSymbols extends _xfa_object.ContentObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "dateTimeSymbols");
	  }

	}

	class Day extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "day");
	  }

	}

	class DayNames extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "dayNames", true);
	    this.abbr = (0, _utils.getInteger)({
	      data: attributes.abbr,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.day = new _xfa_object.XFAObjectArray(7);
	  }

	}

	class Era extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "era");
	  }

	}

	class EraNames extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "eraNames", true);
	    this.era = new _xfa_object.XFAObjectArray(2);
	  }

	}

	class Locale extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "locale", true);
	    this.desc = attributes.desc || "";
	    this.name = "isoname";
	    this.calendarSymbols = null;
	    this.currencySymbols = null;
	    this.datePatterns = null;
	    this.dateTimeSymbols = null;
	    this.numberPatterns = null;
	    this.numberSymbols = null;
	    this.timePatterns = null;
	    this.typeFaces = null;
	  }

	}

	class LocaleSet extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "localeSet", true);
	    this.locale = new _xfa_object.XFAObjectArray();
	  }

	}

	class Meridiem extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "meridiem");
	  }

	}

	class MeridiemNames extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "meridiemNames", true);
	    this.meridiem = new _xfa_object.XFAObjectArray(2);
	  }

	}

	class Month extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "month");
	  }

	}

	class MonthNames extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "monthNames", true);
	    this.abbr = (0, _utils.getInteger)({
	      data: attributes.abbr,
	      defaultValue: 0,
	      validate: x => x === 1
	    });
	    this.month = new _xfa_object.XFAObjectArray(12);
	  }

	}

	class NumberPattern extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "numberPattern");
	    this.name = (0, _utils.getStringOption)(attributes.name, ["full", "long", "med", "short"]);
	  }

	}

	class NumberPatterns extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "numberPatterns", true);
	    this.numberPattern = new _xfa_object.XFAObjectArray(4);
	  }

	}

	class NumberSymbol extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "numberSymbol");
	    this.name = (0, _utils.getStringOption)(attributes.name, ["decimal", "grouping", "percent", "minus", "zero"]);
	  }

	}

	class NumberSymbols extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "numberSymbols", true);
	    this.numberSymbol = new _xfa_object.XFAObjectArray(5);
	  }

	}

	class TimePattern extends _xfa_object.StringObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "timePattern");
	    this.name = (0, _utils.getStringOption)(attributes.name, ["full", "long", "med", "short"]);
	  }

	}

	class TimePatterns extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "timePatterns", true);
	    this.timePattern = new _xfa_object.XFAObjectArray(4);
	  }

	}

	class TypeFace extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "typeFace", true);
	    this.name = attributes.name | "";
	  }

	}

	class TypeFaces extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(LOCALE_SET_NS_ID, "typeFaces", true);
	    this.typeFace = new _xfa_object.XFAObjectArray();
	  }

	}

	class LocaleSetNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (LocaleSetNamespace.hasOwnProperty(name)) {
	      return LocaleSetNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static calendarSymbols(attrs) {
	    return new CalendarSymbols(attrs);
	  }

	  static currencySymbol(attrs) {
	    return new CurrencySymbol(attrs);
	  }

	  static currencySymbols(attrs) {
	    return new CurrencySymbols(attrs);
	  }

	  static datePattern(attrs) {
	    return new DatePattern(attrs);
	  }

	  static datePatterns(attrs) {
	    return new DatePatterns(attrs);
	  }

	  static dateTimeSymbols(attrs) {
	    return new DateTimeSymbols(attrs);
	  }

	  static day(attrs) {
	    return new Day(attrs);
	  }

	  static dayNames(attrs) {
	    return new DayNames(attrs);
	  }

	  static era(attrs) {
	    return new Era(attrs);
	  }

	  static eraNames(attrs) {
	    return new EraNames(attrs);
	  }

	  static locale(attrs) {
	    return new Locale(attrs);
	  }

	  static localeSet(attrs) {
	    return new LocaleSet(attrs);
	  }

	  static meridiem(attrs) {
	    return new Meridiem(attrs);
	  }

	  static meridiemNames(attrs) {
	    return new MeridiemNames(attrs);
	  }

	  static month(attrs) {
	    return new Month(attrs);
	  }

	  static monthNames(attrs) {
	    return new MonthNames(attrs);
	  }

	  static numberPattern(attrs) {
	    return new NumberPattern(attrs);
	  }

	  static numberPatterns(attrs) {
	    return new NumberPatterns(attrs);
	  }

	  static numberSymbol(attrs) {
	    return new NumberSymbol(attrs);
	  }

	  static numberSymbols(attrs) {
	    return new NumberSymbols(attrs);
	  }

	  static timePattern(attrs) {
	    return new TimePattern(attrs);
	  }

	  static timePatterns(attrs) {
	    return new TimePatterns(attrs);
	  }

	  static typeFace(attrs) {
	    return new TypeFace(attrs);
	  }

	  static typeFaces(attrs) {
	    return new TypeFaces(attrs);
	  }

	}

	exports.LocaleSetNamespace = LocaleSetNamespace;

	/***/ }),
	/* 95 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.SignatureNamespace = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	const SIGNATURE_NS_ID = _namespaces.NamespaceIds.signature.id;

	class Signature extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(SIGNATURE_NS_ID, "signature", true);
	  }

	}

	class SignatureNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (SignatureNamespace.hasOwnProperty(name)) {
	      return SignatureNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static signature(attributes) {
	    return new Signature(attributes);
	  }

	}

	exports.SignatureNamespace = SignatureNamespace;

	/***/ }),
	/* 96 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.StylesheetNamespace = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	const STYLESHEET_NS_ID = _namespaces.NamespaceIds.stylesheet.id;

	class Stylesheet extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(STYLESHEET_NS_ID, "stylesheet", true);
	  }

	}

	class StylesheetNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (StylesheetNamespace.hasOwnProperty(name)) {
	      return StylesheetNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static stylesheet(attributes) {
	    return new Stylesheet(attributes);
	  }

	}

	exports.StylesheetNamespace = StylesheetNamespace;

	/***/ }),
	/* 97 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XdpNamespace = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	const XDP_NS_ID = _namespaces.NamespaceIds.xdp.id;

	class Xdp extends _xfa_object.XFAObject {
	  constructor(attributes) {
	    super(XDP_NS_ID, "xdp", true);
	    this.uuid = attributes.uuid || "";
	    this.timeStamp = attributes.timeStamp || "";
	    this.config = null;
	    this.connectionSet = null;
	    this.datasets = null;
	    this.localeSet = null;
	    this.stylesheet = new _xfa_object.XFAObjectArray();
	    this.template = null;
	  }

	  [_xfa_object.$onChildCheck](child) {
	    const ns = _namespaces.NamespaceIds[child[_xfa_object.$nodeName]];
	    return ns && child[_xfa_object.$namespaceId] === ns.id;
	  }

	}

	class XdpNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (XdpNamespace.hasOwnProperty(name)) {
	      return XdpNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static xdp(attributes) {
	    return new Xdp(attributes);
	  }

	}

	exports.XdpNamespace = XdpNamespace;

	/***/ }),
	/* 98 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XhtmlNamespace = void 0;

	var _xfa_object = __w_pdfjs_require__(77);

	var _namespaces = __w_pdfjs_require__(79);

	var _html_utils = __w_pdfjs_require__(84);

	var _utils = __w_pdfjs_require__(78);

	const XHTML_NS_ID = _namespaces.NamespaceIds.xhtml.id;
	const $richText = Symbol();
	const VALID_STYLES = new Set(["color", "font", "font-family", "font-size", "font-stretch", "font-style", "font-weight", "margin", "margin-bottom", "margin-left", "margin-right", "margin-top", "letter-spacing", "line-height", "orphans", "page-break-after", "page-break-before", "page-break-inside", "tab-interval", "tab-stop", "text-align", "text-decoration", "text-indent", "vertical-align", "widows", "kerning-mode", "xfa-font-horizontal-scale", "xfa-font-vertical-scale", "xfa-spacerun", "xfa-tab-stops"]);
	const StyleMapping = new Map([["page-break-after", "breakAfter"], ["page-break-before", "breakBefore"], ["page-break-inside", "breakInside"], ["kerning-mode", value => value === "none" ? "none" : "normal"], ["xfa-font-horizontal-scale", value => `scaleX(${Math.max(0, Math.min(parseInt(value) / 100)).toFixed(2)})`], ["xfa-font-vertical-scale", value => `scaleY(${Math.max(0, Math.min(parseInt(value) / 100)).toFixed(2)})`], ["xfa-spacerun", ""], ["xfa-tab-stops", ""], ["font-size", (value, original) => {
	  value = original.fontSize = (0, _utils.getMeasurement)(value);
	  return (0, _html_utils.measureToString)(0.99 * value);
	}], ["letter-spacing", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["line-height", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["margin", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["margin-bottom", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["margin-left", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["margin-right", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["margin-top", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["text-indent", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))], ["font-family", value => value], ["vertical-align", value => (0, _html_utils.measureToString)((0, _utils.getMeasurement)(value))]]);
	const spacesRegExp = /\s+/g;
	const crlfRegExp = /[\r\n]+/g;
	const crlfForRichTextRegExp = /\r\n?/g;

	function mapStyle(styleStr, node, richText) {
	  const style = Object.create(null);

	  if (!styleStr) {
	    return style;
	  }

	  const original = Object.create(null);

	  for (const [key, value] of styleStr.split(";").map(s => s.split(":", 2))) {
	    const mapping = StyleMapping.get(key);

	    if (mapping === "") {
	      continue;
	    }

	    let newValue = value;

	    if (mapping) {
	      if (typeof mapping === "string") {
	        newValue = mapping;
	      } else {
	        newValue = mapping(value, original);
	      }
	    }

	    if (key.endsWith("scale")) {
	      if (style.transform) {
	        style.transform = `${style[key]} ${newValue}`;
	      } else {
	        style.transform = newValue;
	      }
	    } else {
	      style[key.replaceAll(/-([a-zA-Z])/g, (_, x) => x.toUpperCase())] = newValue;
	    }
	  }

	  if (style.fontFamily) {
	    (0, _html_utils.setFontFamily)({
	      typeface: style.fontFamily,
	      weight: style.fontWeight || "normal",
	      posture: style.fontStyle || "normal",
	      size: original.fontSize || 0
	    }, node, node[_xfa_object.$globalData].fontFinder, style);
	  }

	  if (richText && style.verticalAlign && style.verticalAlign !== "0px" && style.fontSize) {
	    const SUB_SUPER_SCRIPT_FACTOR = 0.583;
	    const VERTICAL_FACTOR = 0.333;
	    const fontSize = (0, _utils.getMeasurement)(style.fontSize);
	    style.fontSize = (0, _html_utils.measureToString)(fontSize * SUB_SUPER_SCRIPT_FACTOR);
	    style.verticalAlign = (0, _html_utils.measureToString)(Math.sign((0, _utils.getMeasurement)(style.verticalAlign)) * fontSize * VERTICAL_FACTOR);
	  }

	  if (richText && style.fontSize) {
	    style.fontSize = `calc(${style.fontSize} * var(--scale-factor))`;
	  }

	  (0, _html_utils.fixTextIndent)(style);
	  return style;
	}

	function checkStyle(node) {
	  if (!node.style) {
	    return "";
	  }

	  return node.style.trim().split(/\s*;\s*/).filter(s => !!s).map(s => s.split(/\s*:\s*/, 2)).filter(([key, value]) => {
	    if (key === "font-family") {
	      node[_xfa_object.$globalData].usedTypefaces.add(value);
	    }

	    return VALID_STYLES.has(key);
	  }).map(kv => kv.join(":")).join(";");
	}

	const NoWhites = new Set(["body", "html"]);

	class XhtmlObject extends _xfa_object.XmlObject {
	  constructor(attributes, name) {
	    super(XHTML_NS_ID, name);
	    this[$richText] = false;
	    this.style = attributes.style || "";
	  }

	  [_xfa_object.$clean](builder) {
	    super[_xfa_object.$clean](builder);

	    this.style = checkStyle(this);
	  }

	  [_xfa_object.$acceptWhitespace]() {
	    return !NoWhites.has(this[_xfa_object.$nodeName]);
	  }

	  [_xfa_object.$onText](str, richText = false) {
	    if (!richText) {
	      str = str.replace(crlfRegExp, "");

	      if (!this.style.includes("xfa-spacerun:yes")) {
	        str = str.replace(spacesRegExp, " ");
	      }
	    } else {
	      this[$richText] = true;
	    }

	    if (str) {
	      this[_xfa_object.$content] += str;
	    }
	  }

	  [_xfa_object.$pushGlyphs](measure, mustPop = true) {
	    const xfaFont = Object.create(null);
	    const margin = {
	      top: NaN,
	      bottom: NaN,
	      left: NaN,
	      right: NaN
	    };
	    let lineHeight = null;

	    for (const [key, value] of this.style.split(";").map(s => s.split(":", 2))) {
	      switch (key) {
	        case "font-family":
	          xfaFont.typeface = (0, _utils.stripQuotes)(value);
	          break;

	        case "font-size":
	          xfaFont.size = (0, _utils.getMeasurement)(value);
	          break;

	        case "font-weight":
	          xfaFont.weight = value;
	          break;

	        case "font-style":
	          xfaFont.posture = value;
	          break;

	        case "letter-spacing":
	          xfaFont.letterSpacing = (0, _utils.getMeasurement)(value);
	          break;

	        case "margin":
	          const values = value.split(/ \t/).map(x => (0, _utils.getMeasurement)(x));

	          switch (values.length) {
	            case 1:
	              margin.top = margin.bottom = margin.left = margin.right = values[0];
	              break;

	            case 2:
	              margin.top = margin.bottom = values[0];
	              margin.left = margin.right = values[1];
	              break;

	            case 3:
	              margin.top = values[0];
	              margin.bottom = values[2];
	              margin.left = margin.right = values[1];
	              break;

	            case 4:
	              margin.top = values[0];
	              margin.left = values[1];
	              margin.bottom = values[2];
	              margin.right = values[3];
	              break;
	          }

	          break;

	        case "margin-top":
	          margin.top = (0, _utils.getMeasurement)(value);
	          break;

	        case "margin-bottom":
	          margin.bottom = (0, _utils.getMeasurement)(value);
	          break;

	        case "margin-left":
	          margin.left = (0, _utils.getMeasurement)(value);
	          break;

	        case "margin-right":
	          margin.right = (0, _utils.getMeasurement)(value);
	          break;

	        case "line-height":
	          lineHeight = (0, _utils.getMeasurement)(value);
	          break;
	      }
	    }

	    measure.pushData(xfaFont, margin, lineHeight);

	    if (this[_xfa_object.$content]) {
	      measure.addString(this[_xfa_object.$content]);
	    } else {
	      for (const child of this[_xfa_object.$getChildren]()) {
	        if (child[_xfa_object.$nodeName] === "#text") {
	          measure.addString(child[_xfa_object.$content]);
	          continue;
	        }

	        child[_xfa_object.$pushGlyphs](measure);
	      }
	    }

	    if (mustPop) {
	      measure.popFont();
	    }
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const children = [];
	    this[_xfa_object.$extra] = {
	      children
	    };

	    this[_xfa_object.$childrenToHTML]({});

	    if (children.length === 0 && !this[_xfa_object.$content]) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    let value;

	    if (this[$richText]) {
	      value = this[_xfa_object.$content] ? this[_xfa_object.$content].replace(crlfForRichTextRegExp, "\n") : undefined;
	    } else {
	      value = this[_xfa_object.$content] || undefined;
	    }

	    return _utils.HTMLResult.success({
	      name: this[_xfa_object.$nodeName],
	      attributes: {
	        href: this.href,
	        style: mapStyle(this.style, this, this[$richText])
	      },
	      children,
	      value
	    });
	  }

	}

	class A extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "a");
	    this.href = (0, _html_utils.fixURL)(attributes.href) || "";
	  }

	}

	class B extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "b");
	  }

	  [_xfa_object.$pushGlyphs](measure) {
	    measure.pushFont({
	      weight: "bold"
	    });

	    super[_xfa_object.$pushGlyphs](measure);

	    measure.popFont();
	  }

	}

	class Body extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "body");
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const res = super[_xfa_object.$toHTML](availableSpace);

	    const {
	      html
	    } = res;

	    if (!html) {
	      return _utils.HTMLResult.EMPTY;
	    }

	    html.name = "div";
	    html.attributes.class = ["xfaRich"];
	    return res;
	  }

	}

	class Br extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "br");
	  }

	  [_xfa_object.$text]() {
	    return "\n";
	  }

	  [_xfa_object.$pushGlyphs](measure) {
	    measure.addString("\n");
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    return _utils.HTMLResult.success({
	      name: "br"
	    });
	  }

	}

	class Html extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "html");
	  }

	  [_xfa_object.$toHTML](availableSpace) {
	    const children = [];
	    this[_xfa_object.$extra] = {
	      children
	    };

	    this[_xfa_object.$childrenToHTML]({});

	    if (children.length === 0) {
	      return _utils.HTMLResult.success({
	        name: "div",
	        attributes: {
	          class: ["xfaRich"],
	          style: {}
	        },
	        value: this[_xfa_object.$content] || ""
	      });
	    }

	    if (children.length === 1) {
	      const child = children[0];

	      if (child.attributes && child.attributes.class.includes("xfaRich")) {
	        return _utils.HTMLResult.success(child);
	      }
	    }

	    return _utils.HTMLResult.success({
	      name: "div",
	      attributes: {
	        class: ["xfaRich"],
	        style: {}
	      },
	      children
	    });
	  }

	}

	class I extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "i");
	  }

	  [_xfa_object.$pushGlyphs](measure) {
	    measure.pushFont({
	      posture: "italic"
	    });

	    super[_xfa_object.$pushGlyphs](measure);

	    measure.popFont();
	  }

	}

	class Li extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "li");
	  }

	}

	class Ol extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "ol");
	  }

	}

	class P extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "p");
	  }

	  [_xfa_object.$pushGlyphs](measure) {
	    super[_xfa_object.$pushGlyphs](measure, false);

	    measure.addString("\n");
	    measure.addPara();
	    measure.popFont();
	  }

	  [_xfa_object.$text]() {
	    const siblings = this[_xfa_object.$getParent]()[_xfa_object.$getChildren]();

	    if (siblings.at(-1) === this) {
	      return super[_xfa_object.$text]();
	    }

	    return super[_xfa_object.$text]() + "\n";
	  }

	}

	class Span extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "span");
	  }

	}

	class Sub extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "sub");
	  }

	}

	class Sup extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "sup");
	  }

	}

	class Ul extends XhtmlObject {
	  constructor(attributes) {
	    super(attributes, "ul");
	  }

	}

	class XhtmlNamespace {
	  static [_namespaces.$buildXFAObject](name, attributes) {
	    if (XhtmlNamespace.hasOwnProperty(name)) {
	      return XhtmlNamespace[name](attributes);
	    }

	    return undefined;
	  }

	  static a(attributes) {
	    return new A(attributes);
	  }

	  static b(attributes) {
	    return new B(attributes);
	  }

	  static body(attributes) {
	    return new Body(attributes);
	  }

	  static br(attributes) {
	    return new Br(attributes);
	  }

	  static html(attributes) {
	    return new Html(attributes);
	  }

	  static i(attributes) {
	    return new I(attributes);
	  }

	  static li(attributes) {
	    return new Li(attributes);
	  }

	  static ol(attributes) {
	    return new Ol(attributes);
	  }

	  static p(attributes) {
	    return new P(attributes);
	  }

	  static span(attributes) {
	    return new Span(attributes);
	  }

	  static sub(attributes) {
	    return new Sub(attributes);
	  }

	  static sup(attributes) {
	    return new Sup(attributes);
	  }

	  static ul(attributes) {
	    return new Ul(attributes);
	  }

	}

	exports.XhtmlNamespace = XhtmlNamespace;

	/***/ }),
	/* 99 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.UnknownNamespace = void 0;

	var _namespaces = __w_pdfjs_require__(79);

	var _xfa_object = __w_pdfjs_require__(77);

	class UnknownNamespace {
	  constructor(nsId) {
	    this.namespaceId = nsId;
	  }

	  [_namespaces.$buildXFAObject](name, attributes) {
	    return new _xfa_object.XmlObject(this.namespaceId, name, attributes);
	  }

	}

	exports.UnknownNamespace = UnknownNamespace;

	/***/ }),
	/* 100 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.DatasetReader = void 0;

	var _util = __w_pdfjs_require__(2);

	var _core_utils = __w_pdfjs_require__(6);

	var _xml_parser = __w_pdfjs_require__(66);

	function decodeString(str) {
	  try {
	    return (0, _util.stringToUTF8String)(str);
	  } catch (ex) {
	    (0, _util.warn)(`UTF-8 decoding failed: "${ex}".`);
	    return str;
	  }
	}

	class DatasetXMLParser extends _xml_parser.SimpleXMLParser {
	  constructor(options) {
	    super(options);
	    this.node = null;
	  }

	  onEndElement(name) {
	    const node = super.onEndElement(name);

	    if (node && name === "xfa:datasets") {
	      this.node = node;
	      throw new Error("Aborting DatasetXMLParser.");
	    }
	  }

	}

	class DatasetReader {
	  constructor(data) {
	    if (data.datasets) {
	      this.node = new _xml_parser.SimpleXMLParser({
	        hasAttributes: true
	      }).parseFromString(data.datasets).documentElement;
	    } else {
	      const parser = new DatasetXMLParser({
	        hasAttributes: true
	      });

	      try {
	        parser.parseFromString(data["xdp:xdp"]);
	      } catch (_) {}

	      this.node = parser.node;
	    }
	  }

	  getValue(path) {
	    if (!this.node || !path) {
	      return "";
	    }

	    const node = this.node.searchNode((0, _core_utils.parseXFAPath)(path), 0);

	    if (!node) {
	      return "";
	    }

	    const first = node.firstChild;

	    if (first && first.nodeName === "value") {
	      return node.children.map(child => decodeString(child.textContent));
	    }

	    return decodeString(node.textContent);
	  }

	}

	exports.DatasetReader = DatasetReader;

	/***/ }),
	/* 101 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.XRef = void 0;

	var _util = __w_pdfjs_require__(2);

	var _primitives = __w_pdfjs_require__(5);

	var _core_utils = __w_pdfjs_require__(6);

	var _parser = __w_pdfjs_require__(17);

	var _base_stream = __w_pdfjs_require__(7);

	var _crypto = __w_pdfjs_require__(67);

	class XRef {
	  constructor(stream, pdfManager) {
	    this.stream = stream;
	    this.pdfManager = pdfManager;
	    this.entries = [];
	    this.xrefstms = Object.create(null);
	    this._cacheMap = new Map();
	    this._pendingRefs = new _primitives.RefSet();
	    this.stats = new _core_utils.DocStats(pdfManager.msgHandler);
	    this._newRefNum = null;
	  }

	  getNewRef() {
	    if (this._newRefNum === null) {
	      this._newRefNum = this.entries.length || 1;
	    }

	    return _primitives.Ref.get(this._newRefNum++, 0);
	  }

	  resetNewRef() {
	    this._newRefNum = null;
	  }

	  setStartXRef(startXRef) {
	    this.startXRefQueue = [startXRef];
	  }

	  parse(recoveryMode = false) {
	    let trailerDict;

	    if (!recoveryMode) {
	      trailerDict = this.readXRef();
	    } else {
	      (0, _util.warn)("Indexing all PDF objects");
	      trailerDict = this.indexObjects();
	    }

	    trailerDict.assignXref(this);
	    this.trailer = trailerDict;
	    let encrypt;

	    try {
	      encrypt = trailerDict.get("Encrypt");
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)(`XRef.parse - Invalid "Encrypt" reference: "${ex}".`);
	    }

	    if (encrypt instanceof _primitives.Dict) {
	      const ids = trailerDict.get("ID");
	      const fileId = ids && ids.length ? ids[0] : "";
	      encrypt.suppressEncryption = true;
	      this.encrypt = new _crypto.CipherTransformFactory(encrypt, fileId, this.pdfManager.password);
	    }

	    let root;

	    try {
	      root = trailerDict.get("Root");
	    } catch (ex) {
	      if (ex instanceof _core_utils.MissingDataException) {
	        throw ex;
	      }

	      (0, _util.warn)(`XRef.parse - Invalid "Root" reference: "${ex}".`);
	    }

	    if (root instanceof _primitives.Dict) {
	      try {
	        const pages = root.get("Pages");

	        if (pages instanceof _primitives.Dict) {
	          this.root = root;
	          return;
	        }
	      } catch (ex) {
	        if (ex instanceof _core_utils.MissingDataException) {
	          throw ex;
	        }

	        (0, _util.warn)(`XRef.parse - Invalid "Pages" reference: "${ex}".`);
	      }
	    }

	    if (!recoveryMode) {
	      throw new _core_utils.XRefParseException();
	    }

	    throw new _util.InvalidPDFException("Invalid Root reference.");
	  }

	  processXRefTable(parser) {
	    if (!("tableState" in this)) {
	      this.tableState = {
	        entryNum: 0,
	        streamPos: parser.lexer.stream.pos,
	        parserBuf1: parser.buf1,
	        parserBuf2: parser.buf2
	      };
	    }

	    const obj = this.readXRefTable(parser);

	    if (!(0, _primitives.isCmd)(obj, "trailer")) {
	      throw new _util.FormatError("Invalid XRef table: could not find trailer dictionary");
	    }

	    let dict = parser.getObj();

	    if (!(dict instanceof _primitives.Dict) && dict.dict) {
	      dict = dict.dict;
	    }

	    if (!(dict instanceof _primitives.Dict)) {
	      throw new _util.FormatError("Invalid XRef table: could not parse trailer dictionary");
	    }

	    delete this.tableState;
	    return dict;
	  }

	  readXRefTable(parser) {
	    const stream = parser.lexer.stream;
	    const tableState = this.tableState;
	    stream.pos = tableState.streamPos;
	    parser.buf1 = tableState.parserBuf1;
	    parser.buf2 = tableState.parserBuf2;
	    let obj;

	    while (true) {
	      if (!("firstEntryNum" in tableState) || !("entryCount" in tableState)) {
	        if ((0, _primitives.isCmd)(obj = parser.getObj(), "trailer")) {
	          break;
	        }

	        tableState.firstEntryNum = obj;
	        tableState.entryCount = parser.getObj();
	      }

	      let first = tableState.firstEntryNum;
	      const count = tableState.entryCount;

	      if (!Number.isInteger(first) || !Number.isInteger(count)) {
	        throw new _util.FormatError("Invalid XRef table: wrong types in subsection header");
	      }

	      for (let i = tableState.entryNum; i < count; i++) {
	        tableState.streamPos = stream.pos;
	        tableState.entryNum = i;
	        tableState.parserBuf1 = parser.buf1;
	        tableState.parserBuf2 = parser.buf2;
	        const entry = {};
	        entry.offset = parser.getObj();
	        entry.gen = parser.getObj();
	        const type = parser.getObj();

	        if (type instanceof _primitives.Cmd) {
	          switch (type.cmd) {
	            case "f":
	              entry.free = true;
	              break;

	            case "n":
	              entry.uncompressed = true;
	              break;
	          }
	        }

	        if (!Number.isInteger(entry.offset) || !Number.isInteger(entry.gen) || !(entry.free || entry.uncompressed)) {
	          throw new _util.FormatError(`Invalid entry in XRef subsection: ${first}, ${count}`);
	        }

	        if (i === 0 && entry.free && first === 1) {
	          first = 0;
	        }

	        if (!this.entries[i + first]) {
	          this.entries[i + first] = entry;
	        }
	      }

	      tableState.entryNum = 0;
	      tableState.streamPos = stream.pos;
	      tableState.parserBuf1 = parser.buf1;
	      tableState.parserBuf2 = parser.buf2;
	      delete tableState.firstEntryNum;
	      delete tableState.entryCount;
	    }

	    if (this.entries[0] && !this.entries[0].free) {
	      throw new _util.FormatError("Invalid XRef table: unexpected first object");
	    }

	    return obj;
	  }

	  processXRefStream(stream) {
	    if (!("streamState" in this)) {
	      const streamParameters = stream.dict;
	      const byteWidths = streamParameters.get("W");
	      let range = streamParameters.get("Index");

	      if (!range) {
	        range = [0, streamParameters.get("Size")];
	      }

	      this.streamState = {
	        entryRanges: range,
	        byteWidths,
	        entryNum: 0,
	        streamPos: stream.pos
	      };
	    }

	    this.readXRefStream(stream);
	    delete this.streamState;
	    return stream.dict;
	  }

	  readXRefStream(stream) {
	    const streamState = this.streamState;
	    stream.pos = streamState.streamPos;
	    const [typeFieldWidth, offsetFieldWidth, generationFieldWidth] = streamState.byteWidths;
	    const entryRanges = streamState.entryRanges;

	    while (entryRanges.length > 0) {
	      const [first, n] = entryRanges;

	      if (!Number.isInteger(first) || !Number.isInteger(n)) {
	        throw new _util.FormatError(`Invalid XRef range fields: ${first}, ${n}`);
	      }

	      if (!Number.isInteger(typeFieldWidth) || !Number.isInteger(offsetFieldWidth) || !Number.isInteger(generationFieldWidth)) {
	        throw new _util.FormatError(`Invalid XRef entry fields length: ${first}, ${n}`);
	      }

	      for (let i = streamState.entryNum; i < n; ++i) {
	        streamState.entryNum = i;
	        streamState.streamPos = stream.pos;
	        let type = 0,
	            offset = 0,
	            generation = 0;

	        for (let j = 0; j < typeFieldWidth; ++j) {
	          const typeByte = stream.getByte();

	          if (typeByte === -1) {
	            throw new _util.FormatError("Invalid XRef byteWidths 'type'.");
	          }

	          type = type << 8 | typeByte;
	        }

	        if (typeFieldWidth === 0) {
	          type = 1;
	        }

	        for (let j = 0; j < offsetFieldWidth; ++j) {
	          const offsetByte = stream.getByte();

	          if (offsetByte === -1) {
	            throw new _util.FormatError("Invalid XRef byteWidths 'offset'.");
	          }

	          offset = offset << 8 | offsetByte;
	        }

	        for (let j = 0; j < generationFieldWidth; ++j) {
	          const generationByte = stream.getByte();

	          if (generationByte === -1) {
	            throw new _util.FormatError("Invalid XRef byteWidths 'generation'.");
	          }

	          generation = generation << 8 | generationByte;
	        }

	        const entry = {};
	        entry.offset = offset;
	        entry.gen = generation;

	        switch (type) {
	          case 0:
	            entry.free = true;
	            break;

	          case 1:
	            entry.uncompressed = true;
	            break;

	          case 2:
	            break;

	          default:
	            throw new _util.FormatError(`Invalid XRef entry type: ${type}`);
	        }

	        if (!this.entries[first + i]) {
	          this.entries[first + i] = entry;
	        }
	      }

	      streamState.entryNum = 0;
	      streamState.streamPos = stream.pos;
	      entryRanges.splice(0, 2);
	    }
	  }

	  indexObjects() {
	    const TAB = 0x9,
	          LF = 0xa,
	          CR = 0xd,
	          SPACE = 0x20;
	    const PERCENT = 0x25,
	          LT = 0x3c;

	    function readToken(data, offset) {
	      let token = "",
	          ch = data[offset];

	      while (ch !== LF && ch !== CR && ch !== LT) {
	        if (++offset >= data.length) {
	          break;
	        }

	        token += String.fromCharCode(ch);
	        ch = data[offset];
	      }

	      return token;
	    }

	    function skipUntil(data, offset, what) {
	      const length = what.length,
	            dataLength = data.length;
	      let skipped = 0;

	      while (offset < dataLength) {
	        let i = 0;

	        while (i < length && data[offset + i] === what[i]) {
	          ++i;
	        }

	        if (i >= length) {
	          break;
	        }

	        offset++;
	        skipped++;
	      }

	      return skipped;
	    }

	    const objRegExp = /^(\d+)\s+(\d+)\s+obj\b/;
	    const endobjRegExp = /\bendobj[\b\s]$/;
	    const nestedObjRegExp = /\s+(\d+\s+\d+\s+obj[\b\s<])$/;
	    const CHECK_CONTENT_LENGTH = 25;
	    const trailerBytes = new Uint8Array([116, 114, 97, 105, 108, 101, 114]);
	    const startxrefBytes = new Uint8Array([115, 116, 97, 114, 116, 120, 114, 101, 102]);
	    const objBytes = new Uint8Array([111, 98, 106]);
	    const xrefBytes = new Uint8Array([47, 88, 82, 101, 102]);
	    this.entries.length = 0;

	    this._cacheMap.clear();

	    const stream = this.stream;
	    stream.pos = 0;
	    const buffer = stream.getBytes(),
	          length = buffer.length;
	    let position = stream.start;
	    const trailers = [],
	          xrefStms = [];

	    while (position < length) {
	      let ch = buffer[position];

	      if (ch === TAB || ch === LF || ch === CR || ch === SPACE) {
	        ++position;
	        continue;
	      }

	      if (ch === PERCENT) {
	        do {
	          ++position;

	          if (position >= length) {
	            break;
	          }

	          ch = buffer[position];
	        } while (ch !== LF && ch !== CR);

	        continue;
	      }

	      const token = readToken(buffer, position);
	      let m;

	      if (token.startsWith("xref") && (token.length === 4 || /\s/.test(token[4]))) {
	        position += skipUntil(buffer, position, trailerBytes);
	        trailers.push(position);
	        position += skipUntil(buffer, position, startxrefBytes);
	      } else if (m = objRegExp.exec(token)) {
	        const num = m[1] | 0,
	              gen = m[2] | 0;
	        let contentLength,
	            startPos = position + token.length,
	            updateEntries = false;

	        if (!this.entries[num]) {
	          updateEntries = true;
	        } else if (this.entries[num].gen === gen) {
	          try {
	            const parser = new _parser.Parser({
	              lexer: new _parser.Lexer(stream.makeSubStream(startPos))
	            });
	            parser.getObj();
	            updateEntries = true;
	          } catch (ex) {
	            if (ex instanceof _core_utils.ParserEOFException) {
	              (0, _util.warn)(`indexObjects -- checking object (${token}): "${ex}".`);
	            } else {
	              updateEntries = true;
	            }
	          }
	        }

	        if (updateEntries) {
	          this.entries[num] = {
	            offset: position - stream.start,
	            gen,
	            uncompressed: true
	          };
	        }

	        while (startPos < buffer.length) {
	          const endPos = startPos + skipUntil(buffer, startPos, objBytes) + 4;
	          contentLength = endPos - position;
	          const checkPos = Math.max(endPos - CHECK_CONTENT_LENGTH, startPos);
	          const tokenStr = (0, _util.bytesToString)(buffer.subarray(checkPos, endPos));

	          if (endobjRegExp.test(tokenStr)) {
	            break;
	          } else {
	            const objToken = nestedObjRegExp.exec(tokenStr);

	            if (objToken && objToken[1]) {
	              (0, _util.warn)('indexObjects: Found new "obj" inside of another "obj", ' + 'caused by missing "endobj" -- trying to recover.');
	              contentLength -= objToken[1].length;
	              break;
	            }
	          }

	          startPos = endPos;
	        }

	        const content = buffer.subarray(position, position + contentLength);
	        const xrefTagOffset = skipUntil(content, 0, xrefBytes);

	        if (xrefTagOffset < contentLength && content[xrefTagOffset + 5] < 64) {
	          xrefStms.push(position - stream.start);
	          this.xrefstms[position - stream.start] = 1;
	        }

	        position += contentLength;
	      } else if (token.startsWith("trailer") && (token.length === 7 || /\s/.test(token[7]))) {
	        trailers.push(position);
	        position += skipUntil(buffer, position, startxrefBytes);
	      } else {
	        position += token.length + 1;
	      }
	    }

	    for (let i = 0, ii = xrefStms.length; i < ii; ++i) {
	      this.startXRefQueue.push(xrefStms[i]);
	      this.readXRef(true);
	    }

	    let trailerDict;

	    for (let i = 0, ii = trailers.length; i < ii; ++i) {
	      stream.pos = trailers[i];
	      const parser = new _parser.Parser({
	        lexer: new _parser.Lexer(stream),
	        xref: this,
	        allowStreams: true,
	        recoveryMode: true
	      });
	      const obj = parser.getObj();

	      if (!(0, _primitives.isCmd)(obj, "trailer")) {
	        continue;
	      }

	      const dict = parser.getObj();

	      if (!(dict instanceof _primitives.Dict)) {
	        continue;
	      }

	      try {
	        const rootDict = dict.get("Root");

	        if (!(rootDict instanceof _primitives.Dict)) {
	          continue;
	        }

	        const pagesDict = rootDict.get("Pages");

	        if (!(pagesDict instanceof _primitives.Dict)) {
	          continue;
	        }

	        const pagesCount = pagesDict.get("Count");

	        if (!Number.isInteger(pagesCount)) {
	          continue;
	        }
	      } catch (ex) {
	        continue;
	      }

	      if (dict.has("ID")) {
	        return dict;
	      }

	      trailerDict = dict;
	    }

	    if (trailerDict) {
	      return trailerDict;
	    }

	    if (this.topDict) {
	      return this.topDict;
	    }

	    throw new _util.InvalidPDFException("Invalid PDF structure.");
	  }

	  readXRef(recoveryMode = false) {
	    const stream = this.stream;
	    const startXRefParsedCache = new Set();

	    try {
	      while (this.startXRefQueue.length) {
	        const startXRef = this.startXRefQueue[0];

	        if (startXRefParsedCache.has(startXRef)) {
	          (0, _util.warn)("readXRef - skipping XRef table since it was already parsed.");
	          this.startXRefQueue.shift();
	          continue;
	        }

	        startXRefParsedCache.add(startXRef);
	        stream.pos = startXRef + stream.start;
	        const parser = new _parser.Parser({
	          lexer: new _parser.Lexer(stream),
	          xref: this,
	          allowStreams: true
	        });
	        let obj = parser.getObj();
	        let dict;

	        if ((0, _primitives.isCmd)(obj, "xref")) {
	          dict = this.processXRefTable(parser);

	          if (!this.topDict) {
	            this.topDict = dict;
	          }

	          obj = dict.get("XRefStm");

	          if (Number.isInteger(obj)) {
	            const pos = obj;

	            if (!(pos in this.xrefstms)) {
	              this.xrefstms[pos] = 1;
	              this.startXRefQueue.push(pos);
	            }
	          }
	        } else if (Number.isInteger(obj)) {
	          if (!Number.isInteger(parser.getObj()) || !(0, _primitives.isCmd)(parser.getObj(), "obj") || !((obj = parser.getObj()) instanceof _base_stream.BaseStream)) {
	            throw new _util.FormatError("Invalid XRef stream");
	          }

	          dict = this.processXRefStream(obj);

	          if (!this.topDict) {
	            this.topDict = dict;
	          }

	          if (!dict) {
	            throw new _util.FormatError("Failed to read XRef stream");
	          }
	        } else {
	          throw new _util.FormatError("Invalid XRef stream header");
	        }

	        obj = dict.get("Prev");

	        if (Number.isInteger(obj)) {
	          this.startXRefQueue.push(obj);
	        } else if (obj instanceof _primitives.Ref) {
	          this.startXRefQueue.push(obj.num);
	        }

	        this.startXRefQueue.shift();
	      }

	      return this.topDict;
	    } catch (e) {
	      if (e instanceof _core_utils.MissingDataException) {
	        throw e;
	      }

	      (0, _util.info)("(while reading XRef): " + e);
	      this.startXRefQueue.shift();
	    }

	    if (recoveryMode) {
	      return undefined;
	    }

	    throw new _core_utils.XRefParseException();
	  }

	  getEntry(i) {
	    const xrefEntry = this.entries[i];

	    if (xrefEntry && !xrefEntry.free && xrefEntry.offset) {
	      return xrefEntry;
	    }

	    return null;
	  }

	  fetchIfRef(obj, suppressEncryption = false) {
	    if (obj instanceof _primitives.Ref) {
	      return this.fetch(obj, suppressEncryption);
	    }

	    return obj;
	  }

	  fetch(ref, suppressEncryption = false) {
	    if (!(ref instanceof _primitives.Ref)) {
	      throw new Error("ref object is not a reference");
	    }

	    const num = ref.num;

	    const cacheEntry = this._cacheMap.get(num);

	    if (cacheEntry !== undefined) {
	      if (cacheEntry instanceof _primitives.Dict && !cacheEntry.objId) {
	        cacheEntry.objId = ref.toString();
	      }

	      return cacheEntry;
	    }

	    let xrefEntry = this.getEntry(num);

	    if (xrefEntry === null) {
	      this._cacheMap.set(num, xrefEntry);

	      return xrefEntry;
	    }

	    if (this._pendingRefs.has(ref)) {
	      this._pendingRefs.remove(ref);

	      (0, _util.warn)(`Ignoring circular reference: ${ref}.`);
	      return _primitives.CIRCULAR_REF;
	    }

	    this._pendingRefs.put(ref);

	    try {
	      if (xrefEntry.uncompressed) {
	        xrefEntry = this.fetchUncompressed(ref, xrefEntry, suppressEncryption);
	      } else {
	        xrefEntry = this.fetchCompressed(ref, xrefEntry, suppressEncryption);
	      }

	      this._pendingRefs.remove(ref);
	    } catch (ex) {
	      this._pendingRefs.remove(ref);

	      throw ex;
	    }

	    if (xrefEntry instanceof _primitives.Dict) {
	      xrefEntry.objId = ref.toString();
	    } else if (xrefEntry instanceof _base_stream.BaseStream) {
	      xrefEntry.dict.objId = ref.toString();
	    }

	    return xrefEntry;
	  }

	  fetchUncompressed(ref, xrefEntry, suppressEncryption = false) {
	    const gen = ref.gen;
	    let num = ref.num;

	    if (xrefEntry.gen !== gen) {
	      throw new _core_utils.XRefEntryException(`Inconsistent generation in XRef: ${ref}`);
	    }

	    const stream = this.stream.makeSubStream(xrefEntry.offset + this.stream.start);
	    const parser = new _parser.Parser({
	      lexer: new _parser.Lexer(stream),
	      xref: this,
	      allowStreams: true
	    });
	    const obj1 = parser.getObj();
	    const obj2 = parser.getObj();
	    const obj3 = parser.getObj();

	    if (obj1 !== num || obj2 !== gen || !(obj3 instanceof _primitives.Cmd)) {
	      throw new _core_utils.XRefEntryException(`Bad (uncompressed) XRef entry: ${ref}`);
	    }

	    if (obj3.cmd !== "obj") {
	      if (obj3.cmd.startsWith("obj")) {
	        num = parseInt(obj3.cmd.substring(3), 10);

	        if (!Number.isNaN(num)) {
	          return num;
	        }
	      }

	      throw new _core_utils.XRefEntryException(`Bad (uncompressed) XRef entry: ${ref}`);
	    }

	    if (this.encrypt && !suppressEncryption) {
	      xrefEntry = parser.getObj(this.encrypt.createCipherTransform(num, gen));
	    } else {
	      xrefEntry = parser.getObj();
	    }

	    if (!(xrefEntry instanceof _base_stream.BaseStream)) {
	      this._cacheMap.set(num, xrefEntry);
	    }

	    return xrefEntry;
	  }

	  fetchCompressed(ref, xrefEntry, suppressEncryption = false) {
	    const tableOffset = xrefEntry.offset;
	    const stream = this.fetch(_primitives.Ref.get(tableOffset, 0));

	    if (!(stream instanceof _base_stream.BaseStream)) {
	      throw new _util.FormatError("bad ObjStm stream");
	    }

	    const first = stream.dict.get("First");
	    const n = stream.dict.get("N");

	    if (!Number.isInteger(first) || !Number.isInteger(n)) {
	      throw new _util.FormatError("invalid first and n parameters for ObjStm stream");
	    }

	    let parser = new _parser.Parser({
	      lexer: new _parser.Lexer(stream),
	      xref: this,
	      allowStreams: true
	    });
	    const nums = new Array(n);
	    const offsets = new Array(n);

	    for (let i = 0; i < n; ++i) {
	      const num = parser.getObj();

	      if (!Number.isInteger(num)) {
	        throw new _util.FormatError(`invalid object number in the ObjStm stream: ${num}`);
	      }

	      const offset = parser.getObj();

	      if (!Number.isInteger(offset)) {
	        throw new _util.FormatError(`invalid object offset in the ObjStm stream: ${offset}`);
	      }

	      nums[i] = num;
	      offsets[i] = offset;
	    }

	    const start = (stream.start || 0) + first;
	    const entries = new Array(n);

	    for (let i = 0; i < n; ++i) {
	      const length = i < n - 1 ? offsets[i + 1] - offsets[i] : undefined;

	      if (length < 0) {
	        throw new _util.FormatError("Invalid offset in the ObjStm stream.");
	      }

	      parser = new _parser.Parser({
	        lexer: new _parser.Lexer(stream.makeSubStream(start + offsets[i], length, stream.dict)),
	        xref: this,
	        allowStreams: true
	      });
	      const obj = parser.getObj();
	      entries[i] = obj;

	      if (obj instanceof _base_stream.BaseStream) {
	        continue;
	      }

	      const num = nums[i],
	            entry = this.entries[num];

	      if (entry && entry.offset === tableOffset && entry.gen === i) {
	        this._cacheMap.set(num, obj);
	      }
	    }

	    xrefEntry = entries[xrefEntry.gen];

	    if (xrefEntry === undefined) {
	      throw new _core_utils.XRefEntryException(`Bad (compressed) XRef entry: ${ref}`);
	    }

	    return xrefEntry;
	  }

	  async fetchIfRefAsync(obj, suppressEncryption) {
	    if (obj instanceof _primitives.Ref) {
	      return this.fetchAsync(obj, suppressEncryption);
	    }

	    return obj;
	  }

	  async fetchAsync(ref, suppressEncryption) {
	    try {
	      return this.fetch(ref, suppressEncryption);
	    } catch (ex) {
	      if (!(ex instanceof _core_utils.MissingDataException)) {
	        throw ex;
	      }

	      await this.pdfManager.requestRange(ex.begin, ex.end);
	      return this.fetchAsync(ref, suppressEncryption);
	    }
	  }

	  getCatalogObj() {
	    return this.root;
	  }

	}

	exports.XRef = XRef;

	/***/ }),
	/* 102 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.MessageHandler = void 0;

	var _util = __w_pdfjs_require__(2);

	const CallbackKind = {
	  UNKNOWN: 0,
	  DATA: 1,
	  ERROR: 2
	};
	const StreamKind = {
	  UNKNOWN: 0,
	  CANCEL: 1,
	  CANCEL_COMPLETE: 2,
	  CLOSE: 3,
	  ENQUEUE: 4,
	  ERROR: 5,
	  PULL: 6,
	  PULL_COMPLETE: 7,
	  START_COMPLETE: 8
	};

	function wrapReason(reason) {
	  if (!(reason instanceof Error || typeof reason === "object" && reason !== null)) {
	    (0, _util.unreachable)('wrapReason: Expected "reason" to be a (possibly cloned) Error.');
	  }

	  switch (reason.name) {
	    case "AbortException":
	      return new _util.AbortException(reason.message);

	    case "MissingPDFException":
	      return new _util.MissingPDFException(reason.message);

	    case "PasswordException":
	      return new _util.PasswordException(reason.message, reason.code);

	    case "UnexpectedResponseException":
	      return new _util.UnexpectedResponseException(reason.message, reason.status);

	    case "UnknownErrorException":
	      return new _util.UnknownErrorException(reason.message, reason.details);

	    default:
	      return new _util.UnknownErrorException(reason.message, reason.toString());
	  }
	}

	class MessageHandler {
	  constructor(sourceName, targetName, comObj) {
	    this.sourceName = sourceName;
	    this.targetName = targetName;
	    this.comObj = comObj;
	    this.callbackId = 1;
	    this.streamId = 1;
	    this.streamSinks = Object.create(null);
	    this.streamControllers = Object.create(null);
	    this.callbackCapabilities = Object.create(null);
	    this.actionHandler = Object.create(null);

	    this._onComObjOnMessage = event => {
	      const data = event.data;

	      if (data.targetName !== this.sourceName) {
	        return;
	      }

	      if (data.stream) {
	        this._processStreamMessage(data);

	        return;
	      }

	      if (data.callback) {
	        const callbackId = data.callbackId;
	        const capability = this.callbackCapabilities[callbackId];

	        if (!capability) {
	          throw new Error(`Cannot resolve callback ${callbackId}`);
	        }

	        delete this.callbackCapabilities[callbackId];

	        if (data.callback === CallbackKind.DATA) {
	          capability.resolve(data.data);
	        } else if (data.callback === CallbackKind.ERROR) {
	          capability.reject(wrapReason(data.reason));
	        } else {
	          throw new Error("Unexpected callback case");
	        }

	        return;
	      }

	      const action = this.actionHandler[data.action];

	      if (!action) {
	        throw new Error(`Unknown action from worker: ${data.action}`);
	      }

	      if (data.callbackId) {
	        const cbSourceName = this.sourceName;
	        const cbTargetName = data.sourceName;
	        new Promise(function (resolve) {
	          resolve(action(data.data));
	        }).then(function (result) {
	          comObj.postMessage({
	            sourceName: cbSourceName,
	            targetName: cbTargetName,
	            callback: CallbackKind.DATA,
	            callbackId: data.callbackId,
	            data: result
	          });
	        }, function (reason) {
	          comObj.postMessage({
	            sourceName: cbSourceName,
	            targetName: cbTargetName,
	            callback: CallbackKind.ERROR,
	            callbackId: data.callbackId,
	            reason: wrapReason(reason)
	          });
	        });
	        return;
	      }

	      if (data.streamId) {
	        this._createStreamSink(data);

	        return;
	      }

	      action(data.data);
	    };

	    comObj.addEventListener("message", this._onComObjOnMessage);
	  }

	  on(actionName, handler) {
	    const ah = this.actionHandler;

	    if (ah[actionName]) {
	      throw new Error(`There is already an actionName called "${actionName}"`);
	    }

	    ah[actionName] = handler;
	  }

	  send(actionName, data, transfers) {
	    this.comObj.postMessage({
	      sourceName: this.sourceName,
	      targetName: this.targetName,
	      action: actionName,
	      data
	    }, transfers);
	  }

	  sendWithPromise(actionName, data, transfers) {
	    const callbackId = this.callbackId++;
	    const capability = (0, _util.createPromiseCapability)();
	    this.callbackCapabilities[callbackId] = capability;

	    try {
	      this.comObj.postMessage({
	        sourceName: this.sourceName,
	        targetName: this.targetName,
	        action: actionName,
	        callbackId,
	        data
	      }, transfers);
	    } catch (ex) {
	      capability.reject(ex);
	    }

	    return capability.promise;
	  }

	  sendWithStream(actionName, data, queueingStrategy, transfers) {
	    const streamId = this.streamId++,
	          sourceName = this.sourceName,
	          targetName = this.targetName,
	          comObj = this.comObj;
	    return new ReadableStream({
	      start: controller => {
	        const startCapability = (0, _util.createPromiseCapability)();
	        this.streamControllers[streamId] = {
	          controller,
	          startCall: startCapability,
	          pullCall: null,
	          cancelCall: null,
	          isClosed: false
	        };
	        comObj.postMessage({
	          sourceName,
	          targetName,
	          action: actionName,
	          streamId,
	          data,
	          desiredSize: controller.desiredSize
	        }, transfers);
	        return startCapability.promise;
	      },
	      pull: controller => {
	        const pullCapability = (0, _util.createPromiseCapability)();
	        this.streamControllers[streamId].pullCall = pullCapability;
	        comObj.postMessage({
	          sourceName,
	          targetName,
	          stream: StreamKind.PULL,
	          streamId,
	          desiredSize: controller.desiredSize
	        });
	        return pullCapability.promise;
	      },
	      cancel: reason => {
	        (0, _util.assert)(reason instanceof Error, "cancel must have a valid reason");
	        const cancelCapability = (0, _util.createPromiseCapability)();
	        this.streamControllers[streamId].cancelCall = cancelCapability;
	        this.streamControllers[streamId].isClosed = true;
	        comObj.postMessage({
	          sourceName,
	          targetName,
	          stream: StreamKind.CANCEL,
	          streamId,
	          reason: wrapReason(reason)
	        });
	        return cancelCapability.promise;
	      }
	    }, queueingStrategy);
	  }

	  _createStreamSink(data) {
	    const streamId = data.streamId,
	          sourceName = this.sourceName,
	          targetName = data.sourceName,
	          comObj = this.comObj;
	    const self = this,
	          action = this.actionHandler[data.action];
	    const streamSink = {
	      enqueue(chunk, size = 1, transfers) {
	        if (this.isCancelled) {
	          return;
	        }

	        const lastDesiredSize = this.desiredSize;
	        this.desiredSize -= size;

	        if (lastDesiredSize > 0 && this.desiredSize <= 0) {
	          this.sinkCapability = (0, _util.createPromiseCapability)();
	          this.ready = this.sinkCapability.promise;
	        }

	        comObj.postMessage({
	          sourceName,
	          targetName,
	          stream: StreamKind.ENQUEUE,
	          streamId,
	          chunk
	        }, transfers);
	      },

	      close() {
	        if (this.isCancelled) {
	          return;
	        }

	        this.isCancelled = true;
	        comObj.postMessage({
	          sourceName,
	          targetName,
	          stream: StreamKind.CLOSE,
	          streamId
	        });
	        delete self.streamSinks[streamId];
	      },

	      error(reason) {
	        (0, _util.assert)(reason instanceof Error, "error must have a valid reason");

	        if (this.isCancelled) {
	          return;
	        }

	        this.isCancelled = true;
	        comObj.postMessage({
	          sourceName,
	          targetName,
	          stream: StreamKind.ERROR,
	          streamId,
	          reason: wrapReason(reason)
	        });
	      },

	      sinkCapability: (0, _util.createPromiseCapability)(),
	      onPull: null,
	      onCancel: null,
	      isCancelled: false,
	      desiredSize: data.desiredSize,
	      ready: null
	    };
	    streamSink.sinkCapability.resolve();
	    streamSink.ready = streamSink.sinkCapability.promise;
	    this.streamSinks[streamId] = streamSink;
	    new Promise(function (resolve) {
	      resolve(action(data.data, streamSink));
	    }).then(function () {
	      comObj.postMessage({
	        sourceName,
	        targetName,
	        stream: StreamKind.START_COMPLETE,
	        streamId,
	        success: true
	      });
	    }, function (reason) {
	      comObj.postMessage({
	        sourceName,
	        targetName,
	        stream: StreamKind.START_COMPLETE,
	        streamId,
	        reason: wrapReason(reason)
	      });
	    });
	  }

	  _processStreamMessage(data) {
	    const streamId = data.streamId,
	          sourceName = this.sourceName,
	          targetName = data.sourceName,
	          comObj = this.comObj;
	    const streamController = this.streamControllers[streamId],
	          streamSink = this.streamSinks[streamId];

	    switch (data.stream) {
	      case StreamKind.START_COMPLETE:
	        if (data.success) {
	          streamController.startCall.resolve();
	        } else {
	          streamController.startCall.reject(wrapReason(data.reason));
	        }

	        break;

	      case StreamKind.PULL_COMPLETE:
	        if (data.success) {
	          streamController.pullCall.resolve();
	        } else {
	          streamController.pullCall.reject(wrapReason(data.reason));
	        }

	        break;

	      case StreamKind.PULL:
	        if (!streamSink) {
	          comObj.postMessage({
	            sourceName,
	            targetName,
	            stream: StreamKind.PULL_COMPLETE,
	            streamId,
	            success: true
	          });
	          break;
	        }

	        if (streamSink.desiredSize <= 0 && data.desiredSize > 0) {
	          streamSink.sinkCapability.resolve();
	        }

	        streamSink.desiredSize = data.desiredSize;
	        new Promise(function (resolve) {
	          resolve(streamSink.onPull && streamSink.onPull());
	        }).then(function () {
	          comObj.postMessage({
	            sourceName,
	            targetName,
	            stream: StreamKind.PULL_COMPLETE,
	            streamId,
	            success: true
	          });
	        }, function (reason) {
	          comObj.postMessage({
	            sourceName,
	            targetName,
	            stream: StreamKind.PULL_COMPLETE,
	            streamId,
	            reason: wrapReason(reason)
	          });
	        });
	        break;

	      case StreamKind.ENQUEUE:
	        (0, _util.assert)(streamController, "enqueue should have stream controller");

	        if (streamController.isClosed) {
	          break;
	        }

	        streamController.controller.enqueue(data.chunk);
	        break;

	      case StreamKind.CLOSE:
	        (0, _util.assert)(streamController, "close should have stream controller");

	        if (streamController.isClosed) {
	          break;
	        }

	        streamController.isClosed = true;
	        streamController.controller.close();

	        this._deleteStreamController(streamController, streamId);

	        break;

	      case StreamKind.ERROR:
	        (0, _util.assert)(streamController, "error should have stream controller");
	        streamController.controller.error(wrapReason(data.reason));

	        this._deleteStreamController(streamController, streamId);

	        break;

	      case StreamKind.CANCEL_COMPLETE:
	        if (data.success) {
	          streamController.cancelCall.resolve();
	        } else {
	          streamController.cancelCall.reject(wrapReason(data.reason));
	        }

	        this._deleteStreamController(streamController, streamId);

	        break;

	      case StreamKind.CANCEL:
	        if (!streamSink) {
	          break;
	        }

	        new Promise(function (resolve) {
	          resolve(streamSink.onCancel && streamSink.onCancel(wrapReason(data.reason)));
	        }).then(function () {
	          comObj.postMessage({
	            sourceName,
	            targetName,
	            stream: StreamKind.CANCEL_COMPLETE,
	            streamId,
	            success: true
	          });
	        }, function (reason) {
	          comObj.postMessage({
	            sourceName,
	            targetName,
	            stream: StreamKind.CANCEL_COMPLETE,
	            streamId,
	            reason: wrapReason(reason)
	          });
	        });
	        streamSink.sinkCapability.reject(wrapReason(data.reason));
	        streamSink.isCancelled = true;
	        delete this.streamSinks[streamId];
	        break;

	      default:
	        throw new Error("Unexpected stream case");
	    }
	  }

	  async _deleteStreamController(streamController, streamId) {
	    await Promise.allSettled([streamController.startCall && streamController.startCall.promise, streamController.pullCall && streamController.pullCall.promise, streamController.cancelCall && streamController.cancelCall.promise]);
	    delete this.streamControllers[streamId];
	  }

	  destroy() {
	    this.comObj.removeEventListener("message", this._onComObjOnMessage);
	  }

	}

	exports.MessageHandler = MessageHandler;

	/***/ }),
	/* 103 */
	/***/ ((__unused_webpack_module, exports, __w_pdfjs_require__) => {



	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	exports.PDFWorkerStream = void 0;

	var _util = __w_pdfjs_require__(2);

	class PDFWorkerStream {
	  constructor(msgHandler) {
	    this._msgHandler = msgHandler;
	    this._contentLength = null;
	    this._fullRequestReader = null;
	    this._rangeRequestReaders = [];
	  }

	  getFullReader() {
	    (0, _util.assert)(!this._fullRequestReader, "PDFWorkerStream.getFullReader can only be called once.");
	    this._fullRequestReader = new PDFWorkerStreamReader(this._msgHandler);
	    return this._fullRequestReader;
	  }

	  getRangeReader(begin, end) {
	    const reader = new PDFWorkerStreamRangeReader(begin, end, this._msgHandler);

	    this._rangeRequestReaders.push(reader);

	    return reader;
	  }

	  cancelAllRequests(reason) {
	    if (this._fullRequestReader) {
	      this._fullRequestReader.cancel(reason);
	    }

	    for (const reader of this._rangeRequestReaders.slice(0)) {
	      reader.cancel(reason);
	    }
	  }

	}

	exports.PDFWorkerStream = PDFWorkerStream;

	class PDFWorkerStreamReader {
	  constructor(msgHandler) {
	    this._msgHandler = msgHandler;
	    this.onProgress = null;
	    this._contentLength = null;
	    this._isRangeSupported = false;
	    this._isStreamingSupported = false;

	    const readableStream = this._msgHandler.sendWithStream("GetReader");

	    this._reader = readableStream.getReader();
	    this._headersReady = this._msgHandler.sendWithPromise("ReaderHeadersReady").then(data => {
	      this._isStreamingSupported = data.isStreamingSupported;
	      this._isRangeSupported = data.isRangeSupported;
	      this._contentLength = data.contentLength;
	    });
	  }

	  get headersReady() {
	    return this._headersReady;
	  }

	  get contentLength() {
	    return this._contentLength;
	  }

	  get isStreamingSupported() {
	    return this._isStreamingSupported;
	  }

	  get isRangeSupported() {
	    return this._isRangeSupported;
	  }

	  async read() {
	    const {
	      value,
	      done
	    } = await this._reader.read();

	    if (done) {
	      return {
	        value: undefined,
	        done: true
	      };
	    }

	    return {
	      value: value.buffer,
	      done: false
	    };
	  }

	  cancel(reason) {
	    this._reader.cancel(reason);
	  }

	}

	class PDFWorkerStreamRangeReader {
	  constructor(begin, end, msgHandler) {
	    this._msgHandler = msgHandler;
	    this.onProgress = null;

	    const readableStream = this._msgHandler.sendWithStream("GetRangeReader", {
	      begin,
	      end
	    });

	    this._reader = readableStream.getReader();
	  }

	  get isStreamingSupported() {
	    return false;
	  }

	  async read() {
	    const {
	      value,
	      done
	    } = await this._reader.read();

	    if (done) {
	      return {
	        value: undefined,
	        done: true
	      };
	    }

	    return {
	      value: value.buffer,
	      done: false
	    };
	  }

	  cancel(reason) {
	    this._reader.cancel(reason);
	  }

	}

	/***/ })
	/******/ 	]);
	/************************************************************************/
	/******/ 	// The module cache
	/******/ 	var __webpack_module_cache__ = {};
	/******/ 	
	/******/ 	// The require function
	/******/ 	function __w_pdfjs_require__(moduleId) {
	/******/ 		// Check if module is in cache
	/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
	/******/ 		if (cachedModule !== undefined) {
	/******/ 			return cachedModule.exports;
	/******/ 		}
	/******/ 		// Create a new module (and put it into the cache)
	/******/ 		var module = __webpack_module_cache__[moduleId] = {
	/******/ 			// no module.id needed
	/******/ 			// no module.loaded needed
	/******/ 			exports: {}
	/******/ 		};
	/******/ 	
	/******/ 		// Execute the module function
	/******/ 		__webpack_modules__[moduleId](module, module.exports, __w_pdfjs_require__);
	/******/ 	
	/******/ 		// Return the exports of the module
	/******/ 		return module.exports;
	/******/ 	}
	/******/ 	
	/************************************************************************/
	/******/ 	/* webpack/runtime/define property getters */
	/******/ 	(() => {
	/******/ 		// define getter functions for harmony exports
	/******/ 		__w_pdfjs_require__.d = (exports, definition) => {
	/******/ 			for(var key in definition) {
	/******/ 				if(__w_pdfjs_require__.o(definition, key) && !__w_pdfjs_require__.o(exports, key)) {
	/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
	/******/ 				}
	/******/ 			}
	/******/ 		};
	/******/ 	})();
	/******/ 	
	/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
	/******/ 	(() => {
	/******/ 		__w_pdfjs_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop));
	/******/ 	})();
	/******/ 	
	/******/ 	/* webpack/runtime/make namespace object */
	/******/ 	(() => {
	/******/ 		// define __esModule on exports
	/******/ 		__w_pdfjs_require__.r = (exports) => {
	/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
	/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
	/******/ 			}
	/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
	/******/ 		};
	/******/ 	})();
	/******/ 	
	/************************************************************************/
	var __webpack_exports__ = {};
	// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
	(() => {
	var exports = __webpack_exports__;


	Object.defineProperty(exports, "__esModule", ({
	  value: true
	}));
	Object.defineProperty(exports, "WorkerMessageHandler", ({
	  enumerable: true,
	  get: function () {
	    return _worker.WorkerMessageHandler;
	  }
	}));

	var _worker = __w_pdfjs_require__(1);
	})();

	/******/ 	return __webpack_exports__;
	/******/ })()
	;
	});
	
} (pdf_worker));

/**
 * PDF.js worker entry file.
 *
 * This file is identical to Mozilla's pdf.worker.entry.js, with one exception being placed inside
 * this bundle, not theirs.
 */

(typeof window !== 'undefined' ? window : {}).pdfjsWorker = pdf_workerExports;

// Sets pdf worker. Since we're using rollup, the worker needs to be
// manually set, otherwise it won't get bundled.
reactPdf.pdfjs.GlobalWorkerOptions.workerSrc = pdf_worker_entry;
function PdfPreview(_ref) {
  var url = _ref.url,
    isLoading = _ref.isLoading,
    width = _ref.width,
    height = _ref.height;
  // Prevents pdf from reloading on every re-render.
  var file = React.useMemo(function () {
    return {
      url: url
    };
  }, [isLoading, url]);
  if (isLoading) {
    return /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
      variant: "rectangular",
      width: width,
      height: height
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(StyledDocument, {
    file: file
  }, /*#__PURE__*/React__namespace.default.createElement(reactPdf.Page, {
    pageNumber: 1,
    renderTextLayer: false,
    renderAnnotationLayer: false,
    width: width,
    height: height
    // Svg provides smooth resizing
    ,
    renderMode: "svg"
  }));
}
PdfPreview.propTypes = {
  url: propTypesExports.string,
  isLoading: propTypesExports.bool,
  width: propTypesExports.number,
  height: propTypesExports.number
};
var StyledDocument = styled__default.default(reactPdf.Document)({
  alignSelf: "flex-start"
});

function PdfInputPreview(_ref) {
  var pdf = _ref.pdf,
    DescriptionComponent = _ref.DescriptionComponent,
    className = _ref.className;
  var _getLocalUrlOrAttachm = getLocalUrlOrAttachmentId(pdf),
    attachmentId = _getLocalUrlOrAttachm.attachmentId,
    localUrl = _getLocalUrlOrAttachm.localUrl;
  var _useUtils = useUtils(),
    useAttachmentImage = _useUtils.useAttachmentImage;
  var _useAttachmentImage = useAttachmentImage({
      attachmentId: attachmentId
    }),
    remoteUrl = _useAttachmentImage.remoteUrl;
  return /*#__PURE__*/React__namespace.default.createElement(Container$u, {
    "data-testid": TEST_IDS.PDF_INPUT_PREVIEW,
    variant: "none",
    className: className
  }, attachmentId || localUrl ? /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(PdfPreview, {
    url: localUrl || remoteUrl,
    width: 150
  }), /*#__PURE__*/React__namespace.default.createElement(UploadIcon, null)) : /*#__PURE__*/React__namespace.default.createElement(DescriptionComponent, null));
}
PdfInputPreview.propTypes = {
  pdf: propTypesExports.string,
  DescriptionComponent: propTypesExports.elementType,
  className: propTypesExports.string
};
var Container$u = styled__default.default(material.Card)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    position: "relative",
    display: "inline-flex",
    alignItems: "center",
    width: "auto",
    height: "7rem",
    backgroundColor: theme.palette.background["default"],
    border: "none",
    borderRadius: theme.borderRadius.sm
  };
});

function UploadPdfPreviewDescription() {
  return /*#__PURE__*/React__namespace.default.createElement(UploadFilePreviewDescription, {
    description: "Upload PDF"
  });
}

function UploadPdfPreview(_ref) {
  var value = _ref.value,
    id = _ref.id,
    className = _ref.className;
  return /*#__PURE__*/React__namespace.default.createElement("label", {
    htmlFor: id
  }, /*#__PURE__*/React__namespace.default.createElement(PdfInputPreview, {
    pdf: value,
    DescriptionComponent: UploadPdfPreviewDescription,
    className: className
  }));
}
UploadPdfPreview.propTypes = {
  value: propTypesExports.string,
  className: propTypesExports.string,
  id: propTypesExports.string
};

function getCommonStyles(theme) {
  return {
    input: {
      "& .MuiInput-input": {
        backgroundColor: theme.palette.contentBlocks.background,
        padding: "10px 10px 10px 0"
      }
    }
  };
}
var ImageInputFormControl = styled__default.default(FormControl$1)({
  img: {
    height: "100%",
    width: "auto"
  }
});
styled__default.default(UploadImagePreview)(function (_ref) {
  var theme = _ref.theme;
  return {
    backgroundColor: theme.palette.contentBlocks.background
  };
});
var ContentBlockImagePreviewDescription = styled__default.default(UploadImagePreviewDescription)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    backgroundColor: theme.palette.contentBlocks.background
  };
});
var ContentBlockPdfPreview = styled__default.default(UploadPdfPreview)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    backgroundColor: theme.palette.contentBlocks.background
  };
});

var _excluded$P = ["onChange", "onBlur", "value", "validationMessage", "style"];
var PLAYER_HEIGHT = "250px";
var DEFAULT_STYLE = {
  marginBottom: "1rem"
};
function VideoInput$1(_ref) {
  var onChange = _ref.onChange,
    onBlur = _ref.onBlur,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    _ref$style = _ref.style,
    style = _ref$style === void 0 ? DEFAULT_STYLE : _ref$style,
    props = _objectWithoutProperties(_ref, _excluded$P);
  var theme = useTheme$1();
  var commonStyles = getCommonStyles(theme);
  return /*#__PURE__*/React__namespace.default.createElement(material.Box, null, /*#__PURE__*/React__namespace.default.createElement(FormTextInput, _extends$2({
    variant: CONTENT_BLOCK_INPUT_VARIANT,
    onChange: onChange,
    onBlur: onBlur,
    value: value,
    label: "Video link",
    sx: commonStyles.input
  }, props)), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    validationMessage: validationMessage
  }), value && /*#__PURE__*/React__namespace.default.createElement(PlayerContainer, {
    "data-testid": TEST_IDS.VIDEO_PREVIEW
  }, /*#__PURE__*/React__namespace.default.createElement(ReactPlayer__default.default, {
    url: value,
    height: PLAYER_HEIGHT,
    width: "100%",
    style: style
  })));
}
VideoInput$1.propTypes = {
  onChange: propTypesExports.func.isRequired,
  onBlur: propTypesExports.func,
  value: propTypesExports.string,
  marginBottom: propTypesExports.string,
  validationMessage: propTypesExports.string,
  style: propTypesExports.object
};
var PlayerContainer = styled__default.default(material.Box)(function () {
  return {
    marginTop: "1rem"
  };
});

var FormsContext = /*#__PURE__*/React.createContext();
var useForms = function useForms() {
  return React.useContext(FormsContext);
};
function FormsProvider(_ref) {
  var children = _ref.children,
    companyId = _ref.companyId,
    useGetForms = _ref.useGetForms,
    useCreateForm = _ref.useCreateForm,
    useUpdateForm = _ref.useUpdateForm;
  var values = React.useMemo(function () {
    return {
      companyId: companyId,
      useGetForms: useGetForms,
      useCreateForm: useCreateForm,
      useUpdateForm: useUpdateForm
    };
  }, [companyId, useGetForms, useCreateForm, useUpdateForm]);
  return /*#__PURE__*/React__namespace.default.createElement(FormsContext.Provider, {
    value: values
  }, children);
}
FormsProvider.propTypes = {
  children: propTypesExports.any,
  companyId: propTypesExports.string,
  useGetForms: propTypesExports.func.isRequired,
  useCreateForm: propTypesExports.func.isRequired,
  useUpdateForm: propTypesExports.func.isRequired
};

var FormSubmissionsContext = /*#__PURE__*/React.createContext();
var useFormSubmissions = function useFormSubmissions() {
  return React.useContext(FormSubmissionsContext);
};
function FormSubmissionsProvider(_ref) {
  var children = _ref.children,
    companyId = _ref.companyId,
    useGetFormSubmissions = _ref.useGetFormSubmissions,
    useGetOwnFormSubmissions = _ref.useGetOwnFormSubmissions,
    useCreateFormSubmission = _ref.useCreateFormSubmission,
    useDeleteFormSubmission = _ref.useDeleteFormSubmission,
    useUploadAttachment = _ref.useUploadAttachment;
  var values = React.useMemo(function () {
    return {
      companyId: companyId,
      useGetFormSubmissions: useGetFormSubmissions,
      useGetOwnFormSubmissions: useGetOwnFormSubmissions,
      useCreateFormSubmission: useCreateFormSubmission,
      useDeleteFormSubmission: useDeleteFormSubmission,
      useUploadAttachment: useUploadAttachment
    };
  }, [companyId, useGetFormSubmissions, useGetOwnFormSubmissions, useCreateFormSubmission, useDeleteFormSubmission, useUploadAttachment]);
  return /*#__PURE__*/React__namespace.default.createElement(FormSubmissionsContext.Provider, {
    value: values
  }, children);
}
FormSubmissionsProvider.propTypes = {
  children: propTypesExports.any,
  companyId: propTypesExports.string,
  useGetFormSubmissions: propTypesExports.func.isRequired,
  useGetOwnFormSubmissions: propTypesExports.func.isRequired,
  useCreateFormSubmission: propTypesExports.func.isRequired,
  useDeleteFormSubmission: propTypesExports.func.isRequired,
  useUploadAttachment: propTypesExports.func.isRequired
};

var Close = {};

var _interopRequireDefault$F = interopRequireDefaultExports;
Object.defineProperty(Close, "__esModule", {
  value: true
});
var default_1$F = Close.default = void 0;
var _createSvgIcon$F = _interopRequireDefault$F(requireCreateSvgIcon());
var _jsxRuntime$F = requireJsxRuntime();
var _default$F = (0, _createSvgIcon$F.default)( /*#__PURE__*/(0, _jsxRuntime$F.jsx)("path", {
  d: "M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z"
}), 'Close');
default_1$F = Close.default = _default$F;

function getIconButtonUtilityClass(slot) {
  return generateUtilityClass('MuiIconButton', slot);
}
const iconButtonClasses = generateUtilityClasses('MuiIconButton', ['root', 'disabled', 'colorInherit', 'colorPrimary', 'colorSecondary', 'colorError', 'colorInfo', 'colorSuccess', 'colorWarning', 'edgeStart', 'edgeEnd', 'sizeSmall', 'sizeMedium', 'sizeLarge']);
var iconButtonClasses$1 = iconButtonClasses;

const _excluded$O = ["edge", "children", "className", "color", "disabled", "disableFocusRipple", "size"];
const useUtilityClasses$q = ownerState => {
  const {
    classes,
    disabled,
    color,
    edge,
    size
  } = ownerState;
  const slots = {
    root: ['root', disabled && 'disabled', color !== 'default' && `color${capitalize(color)}`, edge && `edge${capitalize(edge)}`, `size${capitalize(size)}`]
  };
  return composeClasses(slots, getIconButtonUtilityClass, classes);
};
const IconButtonRoot = styled$1(ButtonBase$1, {
  name: 'MuiIconButton',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.color !== 'default' && styles[`color${capitalize(ownerState.color)}`], ownerState.edge && styles[`edge${capitalize(ownerState.edge)}`], styles[`size${capitalize(ownerState.size)}`]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  textAlign: 'center',
  flex: '0 0 auto',
  fontSize: theme.typography.pxToRem(24),
  padding: 8,
  borderRadius: '50%',
  overflow: 'visible',
  // Explicitly set the default value to solve a bug on IE11.
  color: (theme.vars || theme).palette.action.active,
  transition: theme.transitions.create('background-color', {
    duration: theme.transitions.duration.shortest
  })
}, !ownerState.disableRipple && {
  '&:hover': {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette.action.activeChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(theme.palette.action.active, theme.palette.action.hoverOpacity),
    // Reset on touch devices, it doesn't add specificity
    '@media (hover: none)': {
      backgroundColor: 'transparent'
    }
  }
}, ownerState.edge === 'start' && {
  marginLeft: ownerState.size === 'small' ? -3 : -12
}, ownerState.edge === 'end' && {
  marginRight: ownerState.size === 'small' ? -3 : -12
}), ({
  theme,
  ownerState
}) => {
  var _palette;
  const palette = (_palette = (theme.vars || theme).palette) == null ? void 0 : _palette[ownerState.color];
  return _extends$1({}, ownerState.color === 'inherit' && {
    color: 'inherit'
  }, ownerState.color !== 'inherit' && ownerState.color !== 'default' && _extends$1({
    color: palette == null ? void 0 : palette.main
  }, !ownerState.disableRipple && {
    '&:hover': _extends$1({}, palette && {
      backgroundColor: theme.vars ? `rgba(${palette.mainChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(palette.main, theme.palette.action.hoverOpacity)
    }, {
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        backgroundColor: 'transparent'
      }
    })
  }), ownerState.size === 'small' && {
    padding: 5,
    fontSize: theme.typography.pxToRem(18)
  }, ownerState.size === 'large' && {
    padding: 12,
    fontSize: theme.typography.pxToRem(28)
  }, {
    [`&.${iconButtonClasses$1.disabled}`]: {
      backgroundColor: 'transparent',
      color: (theme.vars || theme).palette.action.disabled
    }
  });
});

/**
 * Refer to the [Icons](/material-ui/icons/) section of the documentation
 * regarding the available icon options.
 */
const IconButton$1 = /*#__PURE__*/React__namespace.forwardRef(function IconButton(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiIconButton'
  });
  const {
      edge = false,
      children,
      className,
      color = 'default',
      disabled = false,
      disableFocusRipple = false,
      size = 'medium'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$O);
  const ownerState = _extends$1({}, props, {
    edge,
    color,
    disabled,
    disableFocusRipple,
    size
  });
  const classes = useUtilityClasses$q(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(IconButtonRoot, _extends$1({
    className: clsx(classes.root, className),
    centerRipple: true,
    focusRipple: !disableFocusRipple,
    disabled: disabled,
    ref: ref,
    ownerState: ownerState
  }, other, {
    children: children
  }));
});
browser$1.env.NODE_ENV !== "production" ? IconButton$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The icon to display.
   */
  children: chainPropTypes(propTypesExports.node, props => {
    const found = React__namespace.Children.toArray(props.children).some(child => /*#__PURE__*/React__namespace.isValidElement(child) && child.props.onClick);
    if (found) {
      return new Error(['MUI: You are providing an onClick event listener to a child of a button element.', 'Prefer applying it to the IconButton directly.', 'This guarantees that the whole <button> will be responsive to click events.'].join('\n'));
    }
    return null;
  }),
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'default'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['inherit', 'default', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the  keyboard focus ripple is disabled.
   * @default false
   */
  disableFocusRipple: propTypesExports.bool,
  /**
   * If `true`, the ripple effect is disabled.
   *
   * ⚠️ Without a ripple there is no styling for :focus-visible by default. Be sure
   * to highlight the element by applying separate styles with the `.Mui-focusVisible` class.
   * @default false
   */
  disableRipple: propTypesExports.bool,
  /**
   * If given, uses a negative margin to counteract the padding on one
   * side (this is often helpful for aligning the left or right
   * side of the icon with content above or below, without ruining the border
   * size and shape).
   * @default false
   */
  edge: propTypesExports.oneOf(['end', 'start', false]),
  /**
   * The size of the component.
   * `small` is equivalent to the dense button styling.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['small', 'medium', 'large']), propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var IconButton$2 = IconButton$1;

var useSnackBar = useSnackbar;
var SnackbarCloseButton = function SnackbarCloseButton(_ref) {
  var key = _ref.key;
  var _useSnackbarOG = notistack.useSnackbar(),
    closeSnackbar = _useSnackbarOG.closeSnackbar;
  return /*#__PURE__*/React__namespace.default.createElement(IconButton$2, {
    "data-testid": TEST_IDS.SNACKBAR_CLOSE_BUTTON,
    color: "inherit",
    onClick: function onClick() {
      return closeSnackbar(key);
    }
  }, /*#__PURE__*/React__namespace.default.createElement(default_1$F, null));
};
function SnackBarProvider(_ref2) {
  var children = _ref2.children,
    _ref2$marginTop = _ref2.marginTop,
    marginTop = _ref2$marginTop === void 0 ? 0 : _ref2$marginTop;
  return /*#__PURE__*/React__namespace.default.createElement(StyledSnackbarProvider, {
    marginTop: marginTop,
    action: function action(snackbarKey) {
      return /*#__PURE__*/React__namespace.default.createElement(SnackbarCloseButton, {
        snackbarKey: snackbarKey
      });
    },
    hideIconVariant: true,
    preventDuplicate: true,
    anchorOrigin: {
      vertical: "top",
      horizontal: "right"
    }
  }, children);
}
function useSnackbar() {
  var snackbar = notistack.useSnackbar();
  var enqueueSnackbar = snackbar.enqueueSnackbar;
  var showError = function showError(_ref3) {
    var error = _ref3.error;
    enqueueSnackbar("ERROR: ".concat(error.message), {
      variant: "error"
    });
  };
  var showWarning = function showWarning(_ref4) {
    var message = _ref4.message;
    enqueueSnackbar("WARNING: ".concat(message), {
      variant: "warning"
    });
  };
  var showSuccess = function showSuccess(_ref5) {
    var message = _ref5.message;
    enqueueSnackbar("SUCCESS: ".concat(message), {
      variant: "success"
    });
  };
  return {
    snackbar: snackbar,
    showError: showError,
    showWarning: showWarning,
    showSuccess: showSuccess
  };
}
SnackbarCloseButton.propTypes = {
  key: propTypesExports.string
};
SnackBarProvider.propTypes = {
  children: propTypesExports.any,
  marginTop: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string])
};

// this styling is to allow for custom variants https://github.com/iamhosseindhv/notistack/issues/440#issuecomment-955632581
var StyledSnackbarProvider = material.styled(notistack.SnackbarProvider)(function (_ref6) {
  var marginTop = _ref6.marginTop;
  return "&.SnackbarItem-variantError {\n        border-left: 5px solid;\n        border-left-color: red;\n        background-color: rgb(49, 49, 49);\n    }\n    &.SnackbarItem-variantSuccess {\n        border-left: 5px solid;\n        border-left-color: green;\n        background-color: rgb(49, 49, 49);\n    }\n    &.SnackbarItem-variantWarning {\n        border-left: 5px solid;\n        border-left-color: orange;\n        background-color: rgb(49, 49, 49);\n    }\n    &.SnackbarItem-variantInfo {\n        border-left: 5px solid;\n        border-left-color: blue;\n        background-color: rgb(49, 49, 49);\n    }\n    margin-top: ".concat(marginTop, "px;\n    max-width: 500px;\n    overflow: hidden;\n");
});

const html = (theme, enableColorScheme) => _extends$1({
  WebkitFontSmoothing: 'antialiased',
  // Antialiasing.
  MozOsxFontSmoothing: 'grayscale',
  // Antialiasing.
  // Change from `box-sizing: content-box` so that `width`
  // is not affected by `padding` or `border`.
  boxSizing: 'border-box',
  // Fix font resize problem in iOS
  WebkitTextSizeAdjust: '100%'
}, enableColorScheme && !theme.vars && {
  colorScheme: theme.palette.mode
});
const body = theme => _extends$1({
  color: (theme.vars || theme).palette.text.primary
}, theme.typography.body1, {
  backgroundColor: (theme.vars || theme).palette.background.default,
  '@media print': {
    // Save printer ink.
    backgroundColor: (theme.vars || theme).palette.common.white
  }
});
const styles$1 = (theme, enableColorScheme = false) => {
  var _theme$components, _theme$components$Mui;
  const colorSchemeStyles = {};
  if (enableColorScheme && theme.colorSchemes) {
    Object.entries(theme.colorSchemes).forEach(([key, scheme]) => {
      var _scheme$palette;
      colorSchemeStyles[theme.getColorSchemeSelector(key).replace(/\s*&/, '')] = {
        colorScheme: (_scheme$palette = scheme.palette) == null ? void 0 : _scheme$palette.mode
      };
    });
  }
  let defaultStyles = _extends$1({
    html: html(theme, enableColorScheme),
    '*, *::before, *::after': {
      boxSizing: 'inherit'
    },
    'strong, b': {
      fontWeight: theme.typography.fontWeightBold
    },
    body: _extends$1({
      margin: 0
    }, body(theme), {
      // Add support for document.body.requestFullScreen().
      // Other elements, if background transparent, are not supported.
      '&::backdrop': {
        backgroundColor: (theme.vars || theme).palette.background.default
      }
    })
  }, colorSchemeStyles);
  const themeOverrides = (_theme$components = theme.components) == null ? void 0 : (_theme$components$Mui = _theme$components.MuiCssBaseline) == null ? void 0 : _theme$components$Mui.styleOverrides;
  if (themeOverrides) {
    defaultStyles = [defaultStyles, themeOverrides];
  }
  return defaultStyles;
};

/**
 * Kickstart an elegant, consistent, and simple baseline to build upon.
 */
function CssBaseline(inProps) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiCssBaseline'
  });
  const {
    children,
    enableColorScheme = false
  } = props;
  return /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
    children: [/*#__PURE__*/jsxRuntimeExports.jsx(GlobalStyles, {
      styles: theme => styles$1(theme, enableColorScheme)
    }), children]
  });
}
browser$1.env.NODE_ENV !== "production" ? CssBaseline.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * You can wrap a node.
   */
  children: propTypesExports.node,
  /**
   * Enable `color-scheme` CSS property to use `theme.palette.mode`.
   * For more details, check out https://developer.mozilla.org/en-US/docs/Web/CSS/color-scheme
   * For browser support, check out https://caniuse.com/?search=color-scheme
   * @default false
   */
  enableColorScheme: propTypesExports.bool
} : void 0;

/**
 * @deprecated Not used internally. Use `MediaQueryListEvent` from lib.dom.d.ts instead.
 */

function useMediaQueryOld(query, defaultMatches, matchMedia, ssrMatchMedia, noSsr) {
  const [match, setMatch] = React__namespace.useState(() => {
    if (noSsr && matchMedia) {
      return matchMedia(query).matches;
    }
    if (ssrMatchMedia) {
      return ssrMatchMedia(query).matches;
    }

    // Once the component is mounted, we rely on the
    // event listeners to return the correct matches value.
    return defaultMatches;
  });
  useEnhancedEffect$1(() => {
    let active = true;
    if (!matchMedia) {
      return undefined;
    }
    const queryList = matchMedia(query);
    const updateMatch = () => {
      // Workaround Safari wrong implementation of matchMedia
      // TODO can we remove it?
      // https://github.com/mui/material-ui/pull/17315#issuecomment-528286677
      if (active) {
        setMatch(queryList.matches);
      }
    };
    updateMatch();
    // TODO: Use `addEventListener` once support for Safari < 14 is dropped
    queryList.addListener(updateMatch);
    return () => {
      active = false;
      queryList.removeListener(updateMatch);
    };
  }, [query, matchMedia]);
  return match;
}

// eslint-disable-next-line no-useless-concat -- Workaround for https://github.com/webpack/webpack/issues/14814
const maybeReactUseSyncExternalStore = React__namespace['useSyncExternalStore' + ''];
function useMediaQueryNew(query, defaultMatches, matchMedia, ssrMatchMedia, noSsr) {
  const getDefaultSnapshot = React__namespace.useCallback(() => defaultMatches, [defaultMatches]);
  const getServerSnapshot = React__namespace.useMemo(() => {
    if (noSsr && matchMedia) {
      return () => matchMedia(query).matches;
    }
    if (ssrMatchMedia !== null) {
      const {
        matches
      } = ssrMatchMedia(query);
      return () => matches;
    }
    return getDefaultSnapshot;
  }, [getDefaultSnapshot, query, ssrMatchMedia, noSsr, matchMedia]);
  const [getSnapshot, subscribe] = React__namespace.useMemo(() => {
    if (matchMedia === null) {
      return [getDefaultSnapshot, () => () => {}];
    }
    const mediaQueryList = matchMedia(query);
    return [() => mediaQueryList.matches, notify => {
      // TODO: Use `addEventListener` once support for Safari < 14 is dropped
      mediaQueryList.addListener(notify);
      return () => {
        mediaQueryList.removeListener(notify);
      };
    }];
  }, [getDefaultSnapshot, matchMedia, query]);
  const match = maybeReactUseSyncExternalStore(subscribe, getSnapshot, getServerSnapshot);
  return match;
}
function useMediaQuery(queryInput, options = {}) {
  const theme = useTheme$3();
  // Wait for jsdom to support the match media feature.
  // All the browsers MUI support have this built-in.
  // This defensive check is here for simplicity.
  // Most of the time, the match media logic isn't central to people tests.
  const supportMatchMedia = typeof window !== 'undefined' && typeof window.matchMedia !== 'undefined';
  const {
    defaultMatches = false,
    matchMedia = supportMatchMedia ? window.matchMedia : null,
    ssrMatchMedia = null,
    noSsr = false
  } = getThemeProps({
    name: 'MuiUseMediaQuery',
    props: options,
    theme
  });
  if (browser$1.env.NODE_ENV !== 'production') {
    if (typeof queryInput === 'function' && theme === null) {
      console.error(['MUI: The `query` argument provided is invalid.', 'You are providing a function without a theme in the context.', 'One of the parent elements needs to use a ThemeProvider.'].join('\n'));
    }
  }
  let query = typeof queryInput === 'function' ? queryInput(theme) : queryInput;
  query = query.replace(/^@media( ?)/m, '');

  // TODO: Drop `useMediaQueryOld` and use  `use-sync-external-store` shim in `useMediaQueryNew` once the package is stable
  const useMediaQueryImplementation = maybeReactUseSyncExternalStore !== undefined ? useMediaQueryNew : useMediaQueryOld;
  const match = useMediaQueryImplementation(query, defaultMatches, matchMedia, ssrMatchMedia, noSsr);
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useDebugValue({
      query,
      match
    });
  }
  return match;
}

/* eslint max-lines: ["error", {"max": 300}] */
var DARK = "dark";
var LIGHT = "light";
var THEME_MODES = {
  DARK: DARK,
  LIGHT: LIGHT
};
var SUCCESS = "#7DD420";
var PRIMARY = "#4A90E2";
var SECONDARY = "#2A3A4A";
var TERTIARY = "#8B60FC";
var LINK = "#E33A29";
var SECONDARY_ALT = "#374B5F";
var WARNING = "#FC9B00";
var ERROR = "#DF0909";
var ERROR_LIGHT = "#FF5F59";
var ALT_TEXT = "#FFFFFF";
var TEXT = SECONDARY;
var SECONDARY_TEXT = "#A9A9A9";
var TEXT_TERTIARY = "#BABABA";
var BACKGROUND = "#FAFAFA";
var BLACK = "#000000";
var ALT_BACKGROUND = BLACK;
var SECONDARY_BACKGROUND = "#FFFFFF";
var SECONDARY_ALT_BACKGROUND = "#1D1D1D";
var CARD_SECONDARY_BACKGROUND = "#F2F2F2";
var CARD_SECONDARY_BACKGROUND_ALT = "#333333";
var MODAL_SIDE_ALT_BACKGROUND = "#212121";
var TERTIARY_BACKGROUND = "#EAEAEA70";
var DIVIDER = "#EAEAEA";
var SECONDARY_DIVIDER = "#EAEAEA10";
var PILLS_DIVIDER_DARK = "#EAEAEA20";
var PILLS_DIVIDER_LIGHT = "#A8A8A8";
var CONTENT_BLOCKS_BACKGROUND_DARK_MODE = "#272727";
var SIDEBAR_LABEL = "#FFFFFF80";
var BORDER = "#ACACAC";
var ICON_GREY = "#ACACAC";
var TEXT_GREY = "#ACACAC";
var ALT_BORDER = "#535353";
var WHITE = "#FFFFFF";
var DISABLED = "#E5E5E5";
var ICON = "#858585";
var NAV_ICON = "#666";
var YELLOW = "#FFE248";
var RED = "#E33A29";
var BLUE = "#4A90E2";
var ICON_BACKGROUND = "rgb(227, 58, 41, 0.15)";
var PILL_BACKGROUND_DARK = "#4A4A4A";
var PILL_BACKGROUND_LIGHT = "#EAEAEA";
var HIGHLIGHT = "#FC9B0020";
var FONT = "SF Pro, Roboto";
var BOLD_WEIGHT = "600";

// TAG COLORS
var TAG_RED = "#E04646";
var TAG_ORANGE = "#EF9E54";
var TAG_YELLOW = "#E4CE00";
var TAG_GREEN = "#51D321";
var TAG_BLUE = "#549EE1";
var TAG_PURPLE = "#8165EE";
var TAG_PINK = "#E36CED";
var TAG_GREY = "#A8A8A8";
var BOX_SHADOW = "1px 0 10px 0 rgba(0,0,0,0.04)";
var BOX_SHADOW_DARKER = "2px 2px 5px 0 rgba(0,0,0,0.2)";
var customTheme = function customTheme(prefersDarkMode) {
  var DEFAULT_BACKGROUND = prefersDarkMode ? ALT_BACKGROUND : BACKGROUND;
  return {
    components: {
      MuiPaper: {
        // removes background image transparency thats defaulted in mui dark mode
        // https://mui.com/material-ui/react-paper/#elevation
        styleOverrides: {
          root: {
            backgroundImage: "unset"
          }
        }
      }
    },
    palette: {
      mode: prefersDarkMode ? DARK : LIGHT,
      isDarkMode: prefersDarkMode,
      text: {
        primary: prefersDarkMode ? ALT_TEXT : TEXT,
        secondary: SECONDARY_TEXT,
        light: ALT_TEXT,
        dark: TEXT,
        inversePrimary: prefersDarkMode ? TEXT : ALT_TEXT,
        tertiary: TEXT_TERTIARY,
        tags: ALT_TEXT,
        grey: TEXT_GREY
      },
      background: {
        "default": DEFAULT_BACKGROUND,
        paper: DEFAULT_BACKGROUND
      },
      primary: {
        main: PRIMARY
      },
      secondary: {
        main: prefersDarkMode ? ALT_TEXT : SECONDARY,
        alt: SECONDARY
      },
      error: {
        main: prefersDarkMode ? ERROR_LIGHT : ERROR
      },
      success: {
        main: SUCCESS
      },
      colors: {
        metric: {
          primary: SUCCESS,
          secondary: WARNING,
          tertiary: TERTIARY
        },
        label: {
          primary: SUCCESS,
          secondary: TERTIARY,
          tertiary: WARNING
        },
        sidebar: {
          background: prefersDarkMode ? SECONDARY_ALT_BACKGROUND : SECONDARY,
          label: SIDEBAR_LABEL
        },
        border: {
          primary: prefersDarkMode ? ALT_BORDER : BORDER
        },
        slider: {
          inactive: DISABLED
        },
        board: {
          column: prefersDarkMode ? DEFAULT_BACKGROUND : TERTIARY_BACKGROUND
        },
        icon: {
          primary: ICON,
          neutral: WHITE,
          neutralContrast: BLACK,
          neutralAlt: ICON_GREY,
          background: ICON_BACKGROUND,
          nav: NAV_ICON
        },
        input: {
          background: prefersDarkMode ? SECONDARY_ALT_BACKGROUND : DEFAULT_BACKGROUND
        },
        contentBlockInput: {
          background: prefersDarkMode ? SECONDARY_ALT_BACKGROUND : WHITE
        },
        link: {
          primary: LINK
        },
        stars: {
          primary: YELLOW
        },
        chips: {
          primary: RED,
          secondary: BLUE,
          tertiary: WHITE,
          background: SECONDARY_ALT
        },
        modal: {
          sideBarBackground: prefersDarkMode ? MODAL_SIDE_ALT_BACKGROUND : DEFAULT_BACKGROUND
        },
        tags: {
          red: TAG_RED,
          orange: TAG_ORANGE,
          yellow: TAG_YELLOW,
          green: TAG_GREEN,
          blue: TAG_BLUE,
          purple: TAG_PURPLE,
          pink: TAG_PINK,
          grey: TAG_GREY
        },
        highlightChange: HIGHLIGHT
      },
      card: {
        background: prefersDarkMode ? SECONDARY_ALT_BACKGROUND : SECONDARY_BACKGROUND,
        secondaryBackground: prefersDarkMode ? CARD_SECONDARY_BACKGROUND_ALT : CARD_SECONDARY_BACKGROUND,
        backgroundDark: SECONDARY_ALT_BACKGROUND,
        backgroundLight: SECONDARY_BACKGROUND,
        divider: prefersDarkMode ? SECONDARY_DIVIDER : DIVIDER
      },
      contentBlocks: {
        background: prefersDarkMode ? CONTENT_BLOCKS_BACKGROUND_DARK_MODE : BACKGROUND,
        // Using this color to match as best we can the Mui card background that the corresponding pills have
        pillBackground: prefersDarkMode ? PILL_BACKGROUND_DARK : PILL_BACKGROUND_LIGHT
      }
    },
    typography: {
      fontFamily: FONT,
      bold: BOLD_WEIGHT,
      body1: {
        fontSize: 16
      },
      body2: {
        fontSize: 14,
        iconFontSize: 20
      },
      body3: {
        fontSize: 12,
        fontWeight: BOLD_WEIGHT
      },
      subtitle1: {
        fontSize: 13,
        fontWeight: BOLD_WEIGHT
      },
      subtitle2: {
        fontSize: 11
      },
      h1: {
        fontSize: 50,
        fontWeight: BOLD_WEIGHT
      },
      h2: {
        fontSize: 40,
        fontWeight: BOLD_WEIGHT
      },
      h3: {
        fontSize: 30,
        fontWeight: BOLD_WEIGHT
      },
      h4: {
        fontSize: 22,
        fontWeight: BOLD_WEIGHT
      },
      h5: {
        fontSize: 18,
        fontWeight: BOLD_WEIGHT
      },
      h6: {
        fontSize: 16,
        fontWeight: BOLD_WEIGHT
      },
      button: {
        fontWeight: BOLD_WEIGHT
      }
    },
    borderRadius: {
      sm: 6,
      md: 16,
      lg: 24
    },
    boxShadow: {
      "default": BOX_SHADOW,
      darker: BOX_SHADOW_DARKER
    },
    breakpoints: {
      values: {
        xs: 0,
        sm: 600,
        md: 900,
        // Offset by one to line up with stream lib's
        // breapoints (uses opposite direction).
        streamMd: 961,
        lg: 1200,
        xl: 1536
      }
    },
    contentWidths: {
      md: 800,
      lg: 1200
    },
    borders: {
      pillDivider: prefersDarkMode ? "1px solid ".concat(PILLS_DIVIDER_DARK) : "1px solid ".concat(PILLS_DIVIDER_LIGHT)
    }
  };
};

var useTheme = function useTheme() {
  return useTheme$1();
};
function ThemeProvider(_ref) {
  var children = _ref.children;
  var prefersDarkMode = useMediaQuery("(prefers-color-scheme: dark)");
  var theme = React.useMemo(function () {
    return createTheme(customTheme(prefersDarkMode));
  }, [prefersDarkMode]);
  return /*#__PURE__*/React__namespace.default.createElement(ThemeProvider$1, {
    theme: theme
  }, /*#__PURE__*/React__namespace.default.createElement(CssBaseline, null), children);
}
ThemeProvider.propTypes = {
  children: propTypesExports.any
};

function LibWebCommonProviders(_ref) {
  var children = _ref.children,
    util = _ref.util,
    snackBar = _ref.snackBar;
  return /*#__PURE__*/React__namespace.default.createElement(ThemeProvider, null, /*#__PURE__*/React__namespace.default.createElement(reactRouterDom.BrowserRouter, null, /*#__PURE__*/React__namespace.default.createElement(UtilProvider, util, /*#__PURE__*/React__namespace.default.createElement(SnackBarProvider, snackBar, children))));
}
LibWebCommonProviders.propTypes = {
  children: propTypesExports.any,
  util: propTypesExports.PropTypes.shape({
    logError: propTypesExports.func.isRequired,
    useAttachmentImage: propTypesExports.func.isRequired
  }).isRequired,
  snackBar: propTypesExports.PropTypes.shape({
    marginTop: propTypesExports.number
  })
};

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

var useLatest = (function (val) {
  var ref = React.useRef(val);
  ref.current = val;
  return ref;
});

var _debounce = (function (fn, delay) {
  var timer; // eslint-disable-next-line func-names

  return function () {
    var _this = this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    if (timer !== null) {
      clearTimeout(timer);
      timer = null;
    }

    timer = setTimeout(function () {
      return fn.apply(_this, args);
    }, delay);
  };
});

var loadApiErr = "💡 use-places-autocomplete: Google Maps Places API library must be loaded. See: https://github.com/wellyshen/use-places-autocomplete#load-the-library";

var usePlacesAutocomplete = function usePlacesAutocomplete(_temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      requestOptions = _ref.requestOptions,
      _ref$debounce = _ref.debounce,
      debounce = _ref$debounce === void 0 ? 200 : _ref$debounce,
      _ref$cache = _ref.cache,
      cache = _ref$cache === void 0 ? 24 * 60 * 60 : _ref$cache,
      _ref$cacheKey = _ref.cacheKey,
      cacheKey = _ref$cacheKey === void 0 ? "upa" : _ref$cacheKey,
      googleMaps = _ref.googleMaps,
      callbackName = _ref.callbackName,
      _ref$defaultValue = _ref.defaultValue,
      defaultValue = _ref$defaultValue === void 0 ? "" : _ref$defaultValue,
      _ref$initOnMount = _ref.initOnMount,
      initOnMount = _ref$initOnMount === void 0 ? true : _ref$initOnMount;

  var _useState = React.useState(false),
      ready = _useState[0],
      setReady = _useState[1];

  var _useState2 = React.useState(defaultValue),
      value = _useState2[0],
      setVal = _useState2[1];

  var _useState3 = React.useState({
    loading: false,
    status: "",
    data: []
  }),
      suggestions = _useState3[0],
      setSuggestions = _useState3[1];

  var asRef = React.useRef();
  var requestOptionsRef = useLatest(requestOptions);
  var googleMapsRef = useLatest(googleMaps);
  var init = React.useCallback(function () {
    var _google$maps;

    if (asRef.current) return;
    var _window = window,
        google = _window.google;
    var gMaps = googleMapsRef.current;
    var placesLib = (gMaps == null ? void 0 : gMaps.places) || (google == null ? void 0 : (_google$maps = google.maps) == null ? void 0 : _google$maps.places);

    if (!placesLib) {
      console.error(loadApiErr);
      return;
    }

    asRef.current = new placesLib.AutocompleteService();
    setReady(true);
  }, [googleMapsRef]);
  var clearSuggestions = React.useCallback(function () {
    setSuggestions({
      loading: false,
      status: "",
      data: []
    });
  }, []);
  var clearCache = React.useCallback(function (key) {
    if (key === void 0) {
      key = cacheKey;
    }

    try {
      sessionStorage.removeItem(key);
    } catch (error) {// Skip exception
    }
  }, [cacheKey]); // eslint-disable-next-line react-hooks/exhaustive-deps

  var fetchPredictions = React.useCallback(_debounce(function (val) {
    var _asRef$current;

    if (!val) {
      clearSuggestions();
      return;
    }

    setSuggestions(function (prevState) {
      return _extends({}, prevState, {
        loading: true
      });
    });
    var cachedData = {};

    try {
      cachedData = JSON.parse(sessionStorage.getItem(cacheKey) || "{}");
    } catch (error) {// Skip exception
    }

    if (cache) {
      cachedData = Object.keys(cachedData).reduce(function (acc, key) {
        if (cachedData[key].maxAge - Date.now() >= 0) acc[key] = cachedData[key];
        return acc;
      }, {});

      if (cachedData[val]) {
        setSuggestions({
          loading: false,
          status: "OK",
          data: cachedData[val].data
        });
        return;
      }
    }

    (_asRef$current = asRef.current) == null ? void 0 : _asRef$current.getPlacePredictions(_extends({}, requestOptionsRef.current, {
      input: val
    }), function (data, status) {
      setSuggestions({
        loading: false,
        status: status,
        data: data || []
      });

      if (cache && status === "OK") {
        cachedData[val] = {
          data: data,
          maxAge: Date.now() + cache * 1000
        };

        try {
          sessionStorage.setItem(cacheKey, JSON.stringify(cachedData));
        } catch (error) {// Skip exception
        }
      }
    });
  }, debounce), [cache, cacheKey, clearSuggestions, requestOptionsRef]);
  var setValue = React.useCallback(function (val, shouldFetchData) {
    if (shouldFetchData === void 0) {
      shouldFetchData = true;
    }

    setVal(val);
    if (asRef.current && shouldFetchData) fetchPredictions(val);
  }, [fetchPredictions]);
  React.useEffect(function () {
    if (!initOnMount) return function () {
      return null;
    };
    var _window2 = window,
        google = _window2.google;

    if (!googleMapsRef.current && !(google != null && google.maps) && callbackName) {
      window[callbackName] = init;
    } else {
      init();
    }

    return function () {
      // @ts-ignore
      if (window[callbackName]) delete window[callbackName];
    };
  }, [callbackName, googleMapsRef, init, initOnMount]);
  return {
    ready: ready,
    value: value,
    suggestions: suggestions,
    setValue: setValue,
    clearSuggestions: clearSuggestions,
    clearCache: clearCache,
    init: init
  };
};

/* eslint-disable compat/compat */
var geocodeErr = "💡 use-places-autocomplete: Please provide an address when using getGeocode() with the componentRestrictions.";
var getGeocode = function getGeocode(args) {
  var geocoder = new window.google.maps.Geocoder();
  return new Promise(function (resolve, reject) {
    geocoder.geocode(args, function (results, status) {
      if (status !== "OK") reject(status);

      if (!args.address && args.componentRestrictions) {
        console.error(geocodeErr);
        resolve(results);
      }

      resolve(results);
    });
  });
};
var getLatLng = function getLatLng(result) {
  var _result$geometry$loca = result.geometry.location,
      lat = _result$geometry$loca.lat,
      lng = _result$geometry$loca.lng;
  return {
    lat: lat(),
    lng: lng()
  };
};
var getZipCode = function getZipCode(result, useShortName) {
  var foundZip = result.address_components.find(function (_ref) {
    var types = _ref.types;
    return types.includes("postal_code");
  });
  if (!foundZip) return undefined;
  return useShortName ? foundZip.short_name : foundZip.long_name;
};
var getDetailsErr = "💡 use-places-autocomplete: Please provide a place Id when using getDetails() either as a string or as part of an Autocomplete Prediction.";
var getDetails = function getDetails(args) {
  var PlacesService = new window.google.maps.places.PlacesService(document.createElement("div"));

  if (!args.placeId) {
    console.error(getDetailsErr);
    return Promise.reject(getDetailsErr);
  }

  return new Promise(function (resolve, reject) {
    PlacesService.getDetails(args, function (results, status) {
      if (status !== "OK") reject(status);
      resolve(results);
    });
  });
};

function getAutoCompleteAddressMockData() {
  var mainOptionText = "501 Crawford Street";
  var secondaryOptionText = "Houston, TX, USA";
  var formattedOptionText = "".concat(mainOptionText, ", ").concat(secondaryOptionText);
  return {
    address: {
      line_1: mainOptionText,
      city: "Houston",
      state: "TX",
      zip: "77002",
      latitude: 29.7572867,
      longitude: -95.3552587,
      url: "https://example.com"
    },
    mainOptionText: mainOptionText,
    secondaryOptionText: secondaryOptionText,
    formattedOptionText: formattedOptionText
  };
}

var noop = function noop() {};
function mergeSearchParams(_ref) {
  var key = _ref.key,
    value = _ref.value,
    location = _ref.location;
  var merged = _objectSpread2(_objectSpread2({}, location), {}, _defineProperty({}, key, value));
  var updatedQueryString = queryString__default.default.stringify(merged);
  return "?".concat(updatedQueryString);
}
function removeSearchParam(_ref2) {
  var key = _ref2.key,
    location = _ref2.location;
  var updatedLocation = libCommon.omit(location, [key]);
  return queryString__default.default.stringify(updatedLocation);
}

function getAddress() {
  return _getAddress.apply(this, arguments);
}
function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
    var _ref3,
      description,
      placeId,
      results,
      zip,
      _yield$getLatLng,
      lat,
      lng,
      _yield$getDetails,
      url,
      addressParts,
      _args = arguments;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          _ref3 = _args.length > 0 && _args[0] !== undefined ? _args[0] : {}, description = _ref3.description, placeId = _ref3.placeId;
          _context.prev = 1;
          _context.next = 4;
          return getGeocode({
            address: description
          });
        case 4:
          results = _context.sent;
          _context.next = 7;
          return getZipCode(results[0], false);
        case 7:
          zip = _context.sent;
          _context.next = 10;
          return getLatLng(results[0]);
        case 10:
          _yield$getLatLng = _context.sent;
          lat = _yield$getLatLng.lat;
          lng = _yield$getLatLng.lng;
          _context.next = 15;
          return getDetails({
            placeId: placeId
          });
        case 15:
          _yield$getDetails = _context.sent;
          url = _yield$getDetails.url;
          addressParts = _toConsumableArray(results[0].formatted_address.split(", "));
          return _context.abrupt("return", mapAddressPartsToAddress({
            addressParts: addressParts,
            zip: zip,
            lat: lat,
            lng: lng,
            url: url
          }));
        case 21:
          _context.prev = 21;
          _context.t0 = _context["catch"](1);
          if (!(_context.t0.message === FORM_ERROR.FULL_ADDRESS)) {
            _context.next = 25;
            break;
          }
          throw _context.t0;
        case 25:
          throw new Error(FORM_ERROR.GOOGLE_PLACES);
        case 26:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[1, 21]]);
  }));
  return _getAddress.apply(this, arguments);
}
function getAddressMock() {
  return _getAddressMock.apply(this, arguments);
}
function _getAddressMock() {
  _getAddressMock = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
    var _getAutoCompleteAddre2, address, formattedOptionText, addressParts;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          _getAutoCompleteAddre2 = getAutoCompleteAddressMockData(), address = _getAutoCompleteAddre2.address, formattedOptionText = _getAutoCompleteAddre2.formattedOptionText;
          addressParts = _toConsumableArray(formattedOptionText.split(", "));
          return _context2.abrupt("return", mapAddressPartsToAddress({
            addressParts: addressParts,
            zip: address.zip,
            lat: address.latitude,
            lng: address.longitude,
            url: address.url
          }));
        case 3:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return _getAddressMock.apply(this, arguments);
}
function mapAddressPartsToAddress(_ref) {
  var addressParts = _ref.addressParts,
    zip = _ref.zip,
    lat = _ref.lat,
    lng = _ref.lng,
    url = _ref.url;
  var adjustedAddressParts = validateAndAdjustAddressParts(addressParts);
  return {
    line_1: adjustedAddressParts[0],
    city: adjustedAddressParts[1],
    state: adjustedAddressParts[2].slice(0, 2),
    zip: zip,
    latitude: lat,
    longitude: lng,
    url: url
  };
}
function validateAndAdjustAddressParts(addressParts) {
  // Throw error if address doesn't have at least city/state.
  if (addressParts.length < 3) {
    throw new Error(FORM_ERROR.FULL_ADDRESS);
  }

  // Some addresses have a "premise" before the street address. If there are
  // more than 4 parts, remove the premise so the array starts with the street address.
  if (addressParts.length > 4) {
    return addressParts.slice(1);
  }

  // For city/state only addresses, add null as first item to represent line_1.
  if (addressParts.length === 3) {
    return [null].concat(_toConsumableArray(addressParts));
  }
  return addressParts;
}
function usePlacesAutocompleteMock() {
  var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref2$setValue = _ref2.setValue,
    setValue = _ref2$setValue === void 0 ? noop : _ref2$setValue,
    _ref2$clearSuggestion = _ref2.clearSuggestions,
    clearSuggestions = _ref2$clearSuggestion === void 0 ? noop : _ref2$clearSuggestion;
  var _getAutoCompleteAddre = getAutoCompleteAddressMockData(),
    mainOptionText = _getAutoCompleteAddre.mainOptionText,
    secondaryOptionText = _getAutoCompleteAddre.secondaryOptionText,
    formattedOptionText = _getAutoCompleteAddre.formattedOptionText;
  return {
    ready: true,
    value: formattedOptionText,
    suggestions: {
      status: "OK",
      data: [{
        description: formattedOptionText,
        place_id: uuid.v4(),
        structured_formatting: {
          main_text: mainOptionText,
          secondary_text: secondaryOptionText
        },
        types: ["street_address", "geocode"]
      }]
    },
    setValue: setValue,
    clearSuggestions: clearSuggestions
  };
}

var mockUser = {
  id: uuid.v4(),
  first_name: "kevin",
  last_name: "c"
};
function MockedLibWebCommonProviders(_ref) {
  var children = _ref.children,
    util = _ref.util;
  // define mocks inside here else when the lib is required in a non test env jest won't be defined
  var useAttachmentImageMock = function useAttachmentImageMock() {
    var refetch = jest.fn();
    var remoteUrl = IMAGE_URL;
    var isLoading = true;
    var didFailLoadingImage = false;
    return {
      remoteUrl: remoteUrl,
      isLoading: isLoading,
      didFailLoadingImage: didFailLoadingImage,
      refetch: refetch
    };
  };
  var defaultUtil = {
    logError: jest.fn(),
    useAttachmentImage: useAttachmentImageMock,
    getAddress: getAddressMock,
    usePlacesAutocomplete: usePlacesAutocompleteMock,
    useDownloadAttachmentsZip: jest.fn().mockReturnValue(function () {}),
    useCurrentUser: jest.fn().mockReturnValue({
      isLoading: false,
      user: mockUser
    })
  };
  var mergedUtil = _objectSpread2(_objectSpread2({}, defaultUtil), util);
  return /*#__PURE__*/React__namespace.default.createElement(LibWebCommonProviders, {
    util: mergedUtil
  }, children);
}
MockedLibWebCommonProviders.propTypes = {
  children: propTypesExports.node,
  util: propTypesExports.shape({
    logError: propTypesExports.func,
    useAttachmentImage: propTypesExports.func,
    getAddress: propTypesExports.func,
    usePlacesAutocomplete: propTypesExports.func,
    useCurrentUser: propTypesExports.func
  })
};

var Person = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M12 12c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4zm0 2c-2.67 0-8 1.34-8 4v2h16v-2c0-2.66-5.33-4-8-4z"
}), 'Person');

function getAvatarUtilityClass(slot) {
  return generateUtilityClass('MuiAvatar', slot);
}
generateUtilityClasses('MuiAvatar', ['root', 'colorDefault', 'circular', 'rounded', 'square', 'img', 'fallback']);

const _excluded$N = ["alt", "children", "className", "component", "imgProps", "sizes", "src", "srcSet", "variant"];
const useUtilityClasses$p = ownerState => {
  const {
    classes,
    variant,
    colorDefault
  } = ownerState;
  const slots = {
    root: ['root', variant, colorDefault && 'colorDefault'],
    img: ['img'],
    fallback: ['fallback']
  };
  return composeClasses(slots, getAvatarUtilityClass, classes);
};
const AvatarRoot = styled$1('div', {
  name: 'MuiAvatar',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[ownerState.variant], ownerState.colorDefault && styles.colorDefault];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  position: 'relative',
  display: 'flex',
  alignItems: 'center',
  justifyContent: 'center',
  flexShrink: 0,
  width: 40,
  height: 40,
  fontFamily: theme.typography.fontFamily,
  fontSize: theme.typography.pxToRem(20),
  lineHeight: 1,
  borderRadius: '50%',
  overflow: 'hidden',
  userSelect: 'none'
}, ownerState.variant === 'rounded' && {
  borderRadius: (theme.vars || theme).shape.borderRadius
}, ownerState.variant === 'square' && {
  borderRadius: 0
}, ownerState.colorDefault && _extends$1({
  color: (theme.vars || theme).palette.background.default
}, theme.vars ? {
  backgroundColor: theme.vars.palette.Avatar.defaultBg
} : {
  backgroundColor: theme.palette.mode === 'light' ? theme.palette.grey[400] : theme.palette.grey[600]
})));
const AvatarImg = styled$1('img', {
  name: 'MuiAvatar',
  slot: 'Img',
  overridesResolver: (props, styles) => styles.img
})({
  width: '100%',
  height: '100%',
  textAlign: 'center',
  // Handle non-square image. The property isn't supported by IE11.
  objectFit: 'cover',
  // Hide alt text.
  color: 'transparent',
  // Hide the image broken icon, only works on Chrome.
  textIndent: 10000
});
const AvatarFallback = styled$1(Person, {
  name: 'MuiAvatar',
  slot: 'Fallback',
  overridesResolver: (props, styles) => styles.fallback
})({
  width: '75%',
  height: '75%'
});
function useLoaded({
  crossOrigin,
  referrerPolicy,
  src,
  srcSet
}) {
  const [loaded, setLoaded] = React__namespace.useState(false);
  React__namespace.useEffect(() => {
    if (!src && !srcSet) {
      return undefined;
    }
    setLoaded(false);
    let active = true;
    const image = new Image();
    image.onload = () => {
      if (!active) {
        return;
      }
      setLoaded('loaded');
    };
    image.onerror = () => {
      if (!active) {
        return;
      }
      setLoaded('error');
    };
    image.crossOrigin = crossOrigin;
    image.referrerPolicy = referrerPolicy;
    image.src = src;
    if (srcSet) {
      image.srcset = srcSet;
    }
    return () => {
      active = false;
    };
  }, [crossOrigin, referrerPolicy, src, srcSet]);
  return loaded;
}
const Avatar$1 = /*#__PURE__*/React__namespace.forwardRef(function Avatar(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiAvatar'
  });
  const {
      alt,
      children: childrenProp,
      className,
      component = 'div',
      imgProps,
      sizes,
      src,
      srcSet,
      variant = 'circular'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$N);
  let children = null;

  // Use a hook instead of onError on the img element to support server-side rendering.
  const loaded = useLoaded(_extends$1({}, imgProps, {
    src,
    srcSet
  }));
  const hasImg = src || srcSet;
  const hasImgNotFailing = hasImg && loaded !== 'error';
  const ownerState = _extends$1({}, props, {
    colorDefault: !hasImgNotFailing,
    component,
    variant
  });
  const classes = useUtilityClasses$p(ownerState);
  if (hasImgNotFailing) {
    children = /*#__PURE__*/jsxRuntimeExports.jsx(AvatarImg, _extends$1({
      alt: alt,
      src: src,
      srcSet: srcSet,
      sizes: sizes,
      ownerState: ownerState,
      className: classes.img
    }, imgProps));
  } else if (childrenProp != null) {
    children = childrenProp;
  } else if (hasImg && alt) {
    children = alt[0];
  } else {
    children = /*#__PURE__*/jsxRuntimeExports.jsx(AvatarFallback, {
      ownerState: ownerState,
      className: classes.fallback
    });
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(AvatarRoot, _extends$1({
    as: component,
    ownerState: ownerState,
    className: clsx(classes.root, className),
    ref: ref
  }, other, {
    children: children
  }));
});
browser$1.env.NODE_ENV !== "production" ? Avatar$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Used in combination with `src` or `srcSet` to
   * provide an alt attribute for the rendered `img` element.
   */
  alt: propTypesExports.string,
  /**
   * Used to render icon or text elements inside the Avatar if `src` is not set.
   * This can be an element, or just a string.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/img#attributes) applied to the `img` element if the component is used to display an image.
   * It can be used to listen for the loading error event.
   */
  imgProps: propTypesExports.object,
  /**
   * The `sizes` attribute for the `img` element.
   */
  sizes: propTypesExports.string,
  /**
   * The `src` attribute for the `img` element.
   */
  src: propTypesExports.string,
  /**
   * The `srcSet` attribute for the `img` element.
   * Use this attribute for responsive image display.
   */
  srcSet: propTypesExports.string,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The shape of the avatar.
   * @default 'circular'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['circular', 'rounded', 'square']), propTypesExports.string])
} : void 0;
var Avatar$2 = Avatar$1;

var _excluded$M = ["w", "h", "imageUrl", "name"];
function BasicAvatar(_ref) {
  var w = _ref.w,
    h = _ref.h,
    imageUrl = _ref.imageUrl,
    name = _ref.name,
    props = _objectWithoutProperties(_ref, _excluded$M);
  var size = {
    width: w,
    height: h
  };
  var avatarProps = _objectSpread2({
    name: name,
    src: imageUrl,
    sx: size
  }, props);
  if (!imageUrl && name) {
    var initials = getFirstAndLastInitials(name);
    return /*#__PURE__*/React__namespace.createElement(Avatar$2, avatarProps, initials);
  }
  return /*#__PURE__*/React__namespace.createElement(Avatar$2, avatarProps);
}
BasicAvatar.propTypes = {
  w: propTypesExports.number,
  h: propTypesExports.number,
  imageUrl: propTypesExports.string,
  name: propTypesExports.string
};
function getFirstAndLastInitials(name) {
  if (!name) return "";
  var initialsArray = name.split(" ").map(function (part) {
    return (part[0] || "").toUpperCase();
  });
  var firstInitial = initialsArray[0];
  var lastInitial = initialsArray[initialsArray.length - 1];
  return initialsArray.length > 1 ? "".concat(firstInitial).concat(lastInitial) : firstInitial;
}

var _excluded$L = ["size", "attachmentId", "name"];
function Avatar(_ref) {
  var size = _ref.size,
    attachmentId = _ref.attachmentId,
    name = _ref.name,
    props = _objectWithoutProperties(_ref, _excluded$L);
  var _useUtils = useUtils(),
    useAttachmentImage = _useUtils.useAttachmentImage;
  var _useAttachmentImage = useAttachmentImage({
      attachmentId: attachmentId,
      variant: IMAGE_VARIANTS.THUMBNAIL
    }),
    remoteUrl = _useAttachmentImage.remoteUrl;
  return /*#__PURE__*/React__namespace.default.createElement(BasicAvatar, _extends$2({}, props, {
    w: size,
    h: size,
    imageUrl: remoteUrl,
    name: name
  }));
}
Avatar.propTypes = {
  size: propTypesExports.number,
  attachmentId: propTypesExports.string,
  name: propTypesExports.string
};

var delayExports = {};
var delay$1 = {
  get exports(){ return delayExports; },
  set exports(v){ delayExports = v; },
};

// From https://github.com/sindresorhus/random-int/blob/c37741b56f76b9160b0b63dae4e9c64875128146/index.js#L13-L15
const randomInteger = (minimum, maximum) => Math.floor((Math.random() * (maximum - minimum + 1)) + minimum);

const createAbortError = () => {
	const error = new Error('Delay aborted');
	error.name = 'AbortError';
	return error;
};

const createDelay = ({clearTimeout: defaultClear, setTimeout: set, willResolve}) => (ms, {value, signal} = {}) => {
	if (signal && signal.aborted) {
		return Promise.reject(createAbortError());
	}

	let timeoutId;
	let settle;
	let rejectFn;
	const clear = defaultClear || clearTimeout;

	const signalListener = () => {
		clear(timeoutId);
		rejectFn(createAbortError());
	};

	const cleanup = () => {
		if (signal) {
			signal.removeEventListener('abort', signalListener);
		}
	};

	const delayPromise = new Promise((resolve, reject) => {
		settle = () => {
			cleanup();
			if (willResolve) {
				resolve(value);
			} else {
				reject(value);
			}
		};

		rejectFn = reject;
		timeoutId = (set || setTimeout)(settle, ms);
	});

	if (signal) {
		signal.addEventListener('abort', signalListener, {once: true});
	}

	delayPromise.clear = () => {
		clear(timeoutId);
		timeoutId = null;
		settle();
	};

	return delayPromise;
};

const createWithTimers = clearAndSet => {
	const delay = createDelay({...clearAndSet, willResolve: true});
	delay.reject = createDelay({...clearAndSet, willResolve: false});
	delay.range = (minimum, maximum, options) => delay(randomInteger(minimum, maximum), options);
	return delay;
};

const delay = createWithTimers();
delay.createWithTimers = createWithTimers;

delay$1.exports = delay;
// TODO: Remove this for the next major release
delayExports.default = delay;

function useScreenSize() {
  var _useTheme = useTheme$1(),
    breakpoints = _useTheme.breakpoints;
  var isSmScreen = useMediaQuery(breakpoints.down("sm"));
  var isMdScreen = useMediaQuery(breakpoints.down("md"));
  var isStreamMdScreen = useMediaQuery(breakpoints.down("streamMd"));
  var isLargeScreen = useMediaQuery(breakpoints.up("md"));
  return {
    isSmScreen: isSmScreen,
    isMdScreen: isMdScreen,
    isStreamMdScreen: isStreamMdScreen,
    isLargeScreen: isLargeScreen
  };
}
function useLocationQuery() {
  var _useLocation = reactRouterDom.useLocation(),
    search = _useLocation.search;
  return queryString__default.default.parse(search);
}

var SCROLL_BEHAVIOR = "smooth";
var DELAY_MS = 2000;
function useScrollParams() {
  var _useLocationQuery = useLocationQuery(),
    scrollToEntityId = _useLocationQuery.sti,
    scrollToEntityType = _useLocationQuery.stt;
  return {
    scrollToEntityId: scrollToEntityId,
    scrollToEntityType: scrollToEntityType
  };
}
function useScrollToEntity(_ref) {
  var onScrollToPostSuccess = _ref.onScrollToPostSuccess,
    entityId = _ref.entityId,
    entityType = _ref.entityType,
    ref = _ref.ref;
  var _useScrollParams = useScrollParams(),
    scrollToEntityId = _useScrollParams.scrollToEntityId,
    scrollToEntityType = _useScrollParams.scrollToEntityType;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isScrollTargetActive = _useState2[0],
    setIsScrollTargetActive = _useState2[1];
  React.useEffect(function () {
    // Scroll to this entity if it matches the query param and track success
    if (entityId === scrollToEntityId && entityType === scrollToEntityType) {
      var _ref$current;
      (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.scrollIntoView({
        behavior: SCROLL_BEHAVIOR
      });
      onScrollToPostSuccess();
      setTimedHasScrolled(setIsScrollTargetActive);
    }
  }, []);
  return {
    isScrollTargetActive: isScrollTargetActive
  };
}
function setTimedHasScrolled(_x) {
  return _setTimedHasScrolled.apply(this, arguments);
}
function _setTimedHasScrolled() {
  _setTimedHasScrolled = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(setIsScrollTargetActive) {
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          setIsScrollTargetActive(true);
          _context.next = 3;
          return delayExports(DELAY_MS);
        case 3:
          setIsScrollTargetActive(false);
        case 4:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _setTimedHasScrolled.apply(this, arguments);
}
function useCheckIfHasScrollTarget(_ref2) {
  var entities = _ref2.entities,
    entityType = _ref2.entityType,
    onScrollToPostFailure = _ref2.onScrollToPostFailure;
  var _useScrollParams2 = useScrollParams(),
    scrollToEntityId = _useScrollParams2.scrollToEntityId,
    scrollToEntityType = _useScrollParams2.scrollToEntityType;
  React.useEffect(function () {
    checkIfHasScrollTarget({
      entities: entities,
      entityType: entityType,
      onScrollToPostFailure: onScrollToPostFailure,
      scrollToEntityId: scrollToEntityId,
      scrollToEntityType: scrollToEntityType
    });
  }, [entities, entityType]);
}
function checkIfHasScrollTarget(_ref3) {
  var entities = _ref3.entities,
    entityType = _ref3.entityType,
    scrollToEntityId = _ref3.scrollToEntityId,
    scrollToEntityType = _ref3.scrollToEntityType,
    onScrollToPostFailure = _ref3.onScrollToPostFailure;
  // If we have a queryEntityId for an entity and entities are loaded, check to see if the queryEntityId occurs in the first page of data. If it does not, track failure.
  if (!(entities !== null && entities !== void 0 && entities.length) || !scrollToEntityId || scrollToEntityType !== entityType) {
    return;
  }
  var hasEntity = entities.some(function (entity) {
    return entity.id === scrollToEntityId;
  });
  if (!hasEntity) {
    onScrollToPostFailure();
  }
}

var BulletinPostsContext = /*#__PURE__*/React.createContext();
var useBulletinPosts = function useBulletinPosts() {
  return React.useContext(BulletinPostsContext);
};
function BulletinBoardProvider(_ref) {
  var children = _ref.children,
    entityId = _ref.entityId,
    entityType = _ref.entityType,
    title = _ref.title,
    shouldAllowMutations = _ref.shouldAllowMutations,
    shouldShowBulletinPostViews = _ref.shouldShowBulletinPostViews,
    useBulletinPostCrud = _ref.useBulletinPostCrud,
    useBulletinPostUserViews = _ref.useBulletinPostUserViews,
    _ref$onScrollToPostFa = _ref.onScrollToPostFailure,
    onScrollToPostFailure = _ref$onScrollToPostFa === void 0 ? noop : _ref$onScrollToPostFa,
    _ref$onScrollToPostSu = _ref.onScrollToPostSuccess,
    onScrollToPostSuccess = _ref$onScrollToPostSu === void 0 ? noop : _ref$onScrollToPostSu;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isResendInvitationDisabled = _useState2[0],
    setIsResendInvitationDisabled = _useState2[1];
  var _useBulletinPostCrud = useBulletinPostCrud(entityId),
    error = _useBulletinPostCrud.error,
    total = _useBulletinPostCrud.total,
    bulletinPosts = _useBulletinPostCrud.bulletinPosts,
    isMutationLoading = _useBulletinPostCrud.isMutationLoading,
    isLoading = _useBulletinPostCrud.isLoading,
    getMoreBulletinPosts = _useBulletinPostCrud.getMoreBulletinPosts,
    resendNotifications = _useBulletinPostCrud.resendNotifications,
    createBulletinPost = _useBulletinPostCrud.createBulletinPost,
    updateBulletinPost = _useBulletinPostCrud.updateBulletinPost,
    archiveBulletinPost = _useBulletinPostCrud.archiveBulletinPost;
  return /*#__PURE__*/React__namespace.default.createElement(BulletinPostsContext.Provider, {
    value: {
      entityId: entityId,
      entityType: entityType,
      title: title,
      shouldAllowMutations: shouldAllowMutations,
      shouldShowBulletinPostViews: shouldShowBulletinPostViews,
      useBulletinPostUserViews: useBulletinPostUserViews,
      onScrollToPostFailure: onScrollToPostFailure,
      onScrollToPostSuccess: onScrollToPostSuccess,
      error: error,
      total: total,
      bulletinPosts: bulletinPosts,
      isMutationLoading: isMutationLoading,
      isLoading: isLoading,
      getMoreBulletinPosts: getMoreBulletinPosts,
      resendNotifications: resendNotifications,
      createBulletinPost: createBulletinPost,
      updateBulletinPost: updateBulletinPost,
      archiveBulletinPost: archiveBulletinPost,
      isResendInvitationDisabled: isResendInvitationDisabled,
      setIsResendInvitationDisabled: setIsResendInvitationDisabled
    }
  }, children);
}
BulletinBoardProvider.propTypes = {
  children: propTypesExports.any.isRequired,
  entityId: propTypesExports.string.isRequired,
  entityType: propTypesExports.string.isRequired,
  title: propTypesExports.string.isRequired,
  shouldAllowMutations: propTypesExports.bool,
  shouldShowBulletinPostViews: propTypesExports.bool,
  useBulletinPostCrud: propTypesExports.func.isRequired,
  useBulletinPostUserViews: propTypesExports.func,
  onScrollToPostSuccess: propTypesExports.func,
  onScrollToPostFailure: propTypesExports.func
};

// todo: move to common
function getFullName(user) {
  if (!user) return "";
  return "".concat(user.first_name, " ").concat(user.last_name);
}

var MoreVert = {};

var _interopRequireDefault$E = interopRequireDefaultExports;
Object.defineProperty(MoreVert, "__esModule", {
  value: true
});
var default_1$E = MoreVert.default = void 0;
var _createSvgIcon$E = _interopRequireDefault$E(requireCreateSvgIcon());
var _jsxRuntime$E = requireJsxRuntime();
var _default$E = (0, _createSvgIcon$E.default)( /*#__PURE__*/(0, _jsxRuntime$E.jsx)("path", {
  d: "M12 8c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
}), 'MoreVert');
default_1$E = MoreVert.default = _default$E;

var Send = {};

var _interopRequireDefault$D = interopRequireDefaultExports;
Object.defineProperty(Send, "__esModule", {
  value: true
});
var default_1$D = Send.default = void 0;
var _createSvgIcon$D = _interopRequireDefault$D(requireCreateSvgIcon());
var _jsxRuntime$D = requireJsxRuntime();
var _default$D = (0, _createSvgIcon$D.default)( /*#__PURE__*/(0, _jsxRuntime$D.jsx)("path", {
  d: "M2.01 21 23 12 2.01 3 2 10l15 2-15 2z"
}), 'Send');
default_1$D = Send.default = _default$D;

var _excluded$K = ["item"];
var AVATAR_SIZE = 28;
function BulletinPostDetailsUserViewsListItem(_ref) {
  var user = _ref.item,
    props = _objectWithoutProperties(_ref, _excluded$K);
  var fullName = getFullName(user);
  var styles = getStyles$b();
  return /*#__PURE__*/React__namespace.default.createElement(ItemContainer, props, /*#__PURE__*/React__namespace.default.createElement(Avatar, {
    style: styles.avatar,
    size: AVATAR_SIZE,
    attachmentId: user.photo_url,
    name: fullName
  }), /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    style: styles.text,
    key: user.id,
    height: BULLETIN_DETAIL_USER_ITEM_HEIGHT
  }, fullName));
}
BulletinPostDetailsUserViewsListItem.propTypes = {
  item: propTypesExports.object.isRequired
};
function getStyles$b() {
  return {
    avatar: {
      fontSize: ".9rem"
    },
    text: {
      display: "flex",
      alignItems: "center"
    }
  };
}
var ItemContainer = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    flexDirection: "row",
    gap: "1rem",
    alignItems: "center"
  };
});

var Search$1 = {};

var _interopRequireDefault$C = interopRequireDefaultExports;
Object.defineProperty(Search$1, "__esModule", {
  value: true
});
var default_1$C = Search$1.default = void 0;
var _createSvgIcon$C = _interopRequireDefault$C(requireCreateSvgIcon());
var _jsxRuntime$C = requireJsxRuntime();
var _default$C = (0, _createSvgIcon$C.default)( /*#__PURE__*/(0, _jsxRuntime$C.jsx)("path", {
  d: "M15.5 14h-.79l-.28-.27C15.41 12.59 16 11.11 16 9.5 16 5.91 13.09 3 9.5 3S3 5.91 3 9.5 5.91 16 9.5 16c1.61 0 3.09-.59 4.23-1.57l.27.28v.79l5 4.99L20.49 19l-4.99-5zm-6 0C7.01 14 5 11.99 5 9.5S7.01 5 9.5 5 14 7.01 14 9.5 11.99 14 9.5 14z"
}), 'Search');
default_1$C = Search$1.default = _default$C;

var INPUT_PROPS = {
  "aria-label": "search",
  "data-testid": TEST_IDS.SEARCH
};
function SearchBar(_ref) {
  var _onChange = _ref.onChange,
    searchKeyword = _ref.searchKeyword,
    _ref$shouldShowSearch = _ref.shouldShowSearchBarOnSmallScreen,
    shouldShowSearchBarOnSmallScreen = _ref$shouldShowSearch === void 0 ? false : _ref$shouldShowSearch,
    className = _ref.className,
    isDisabled = _ref.isDisabled;
  var _useScreenSize = useScreenSize(),
    isSmScreen = _useScreenSize.isSmScreen;

  // https://gitlab.com/revved/boomnation/lib-web-common/-/issues/194
  if (!shouldShowSearchBarOnSmallScreen && isSmScreen) {
    return /*#__PURE__*/React__namespace.default.createElement(StyledSearchIcon, {
      color: "primary"
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(Search, {
    className: className
  }, /*#__PURE__*/React__namespace.default.createElement(SearchIconWrapper, null, /*#__PURE__*/React__namespace.default.createElement(default_1$C, null)), /*#__PURE__*/React__namespace.default.createElement(StyledInputBase, {
    placeholder: "Search\u2026",
    inputProps: INPUT_PROPS,
    onChange: function onChange(event) {
      return onInputChange({
        onChange: _onChange,
        event: event
      });
    },
    defaultValue: searchKeyword || "",
    disabled: isDisabled,
    "data-testid": TEST_IDS.SEARCH_INPUT
  }));
}
SearchBar.propTypes = {
  onChange: propTypesExports.func,
  searchKeyword: propTypesExports.string,
  shouldShowSearchBarOnSmallScreen: propTypesExports.bool,
  className: propTypesExports.string,
  isDisabled: propTypesExports.bool
};
function onInputChange(_ref2) {
  var onChange = _ref2.onChange,
    event = _ref2.event;
  // return null if user removes search input instead of empty string
  var searchInput = event.target.value.length > 0 ? event.target.value : null;
  onChange(searchInput);
}
var Search = styled__default.default(Box$1)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    position: "relative",
    borderRadius: theme.borderRadius.lg,
    backgroundColor: theme.palette.card.background,
    color: theme.palette.text.primary,
    border: "1px solid ".concat(theme.palette.colors.border.primary),
    marginRight: theme.spacing(1),
    marginLeft: theme.spacing(1),
    width: "100%"
  };
});
var StyledSearchIcon = styled__default.default(default_1$C)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    color: theme.palette.colors.border.primary
  };
});
var SearchIconWrapper = styled__default.default(Box$1)(function (_ref5) {
  var theme = _ref5.theme;
  return {
    padding: theme.spacing(0, 2),
    height: "100%",
    position: "absolute",
    pointerEvents: "none",
    display: "flex",
    alignItems: "center",
    justifyContent: "center",
    color: theme.palette.colors.border.primary
  };
});
var StyledInputBase = styled__default.default(InputBase$1)(function (_ref6) {
  var theme = _ref6.theme;
  return {
    width: "100%",
    color: theme.palette.text.primary,
    "& .MuiInputBase-input": {
      paddingLeft: "calc(1em + ".concat(theme.spacing(4), ")"),
      paddingRight: theme.spacing(1)
    }
  };
});

var _excluded$J = ["data", "index", "RowComponent"];
var VirtualizedListRow = /*#__PURE__*/React.memo(VirtualizedListRow$1, reactWindow.areEqual);
function VirtualizedListRow$1(_ref) {
  var data = _ref.data,
    index = _ref.index,
    RowComponent = _ref.RowComponent,
    props = _objectWithoutProperties(_ref, _excluded$J);
  return /*#__PURE__*/React__namespace.default.createElement(RowComponent, _extends$2({
    item: data[index]
  }, props));
}
VirtualizedListRow$1.propTypes = {
  data: propTypesExports.array,
  index: propTypesExports.number,
  RowComponent: propTypesExports.elementType
};

// virtualized list to render only components on screen
// must spread props from List into RowComponent
// https://github.com/bvaughn/react-window#why-is-my-list-blank-when-i-scroll
function VirtualizedList(_ref) {
  var itemSize = _ref.itemSize,
    _ref$overscanCount = _ref.overscanCount,
    overscanCount = _ref$overscanCount === void 0 ? 5 : _ref$overscanCount,
    items = _ref.items,
    RowComponent = _ref.RowComponent;
  return /*#__PURE__*/React__namespace.default.createElement(AutoSizer__default.default, null, function (_ref2) {
    var height = _ref2.height,
      width = _ref2.width;
    return /*#__PURE__*/React__namespace.default.createElement(reactWindow.FixedSizeList, {
      height: height,
      itemCount: items.length,
      itemSize: itemSize,
      itemData: items,
      width: width,
      overscanCount: overscanCount
    }, function (props) {
      return /*#__PURE__*/React__namespace.default.createElement(VirtualizedListRow, _extends$2({}, props, {
        RowComponent: RowComponent
      }));
    });
  });
}
VirtualizedList.propTypes = {
  itemSize: propTypesExports.number.isRequired,
  items: propTypesExports.array.isRequired,
  overscanCount: propTypesExports.number,
  RowComponent: propTypesExports.elementType
};

function BulletinPostDetailsUserSearchList(_ref) {
  var users = _ref.users,
    emptyStateMessage = _ref.emptyStateMessage;
  var _useState = React.useState(users),
    _useState2 = _slicedToArray(_useState, 2),
    foundUsers = _useState2[0],
    setFoundUsers = _useState2[1];
  var areThereNoFoundUsers = foundUsers.length === 0;
  var _useState3 = React.useState(emptyStateMessage),
    _useState4 = _slicedToArray(_useState3, 2),
    noUsersMessage = _useState4[0],
    setNoUsersMessage = _useState4[1];
  var isSearchDisabled = !users.length;
  var _useBulletinPosts = useBulletinPosts(),
    setIsResendInvitationDisabled = _useBulletinPosts.setIsResendInvitationDisabled;
  React.useEffect(function () {
    handleResendInvitationDisabled({
      areThereNoFoundUsers: areThereNoFoundUsers,
      users: users,
      foundUsers: foundUsers,
      setIsResendInvitationDisabled: setIsResendInvitationDisabled
    });

    // if we have users but no found users after a search, show no users found empty state
    if (users.length && areThereNoFoundUsers) {
      setNoUsersMessage(BULLETIN_POST_VIEWS_EMPTY_STATE.NO_USERS_FOUND);
    }
  }, [foundUsers, areThereNoFoundUsers]);
  return /*#__PURE__*/React__namespace.default.createElement(Box$3, null, /*#__PURE__*/React__namespace.default.createElement(StyledSearch, {
    shouldShowSearchBarOnSmallScreen: true,
    onChange: function onChange(searchValue) {
      return searchUsersByName({
        searchValue: searchValue,
        setFoundUsers: setFoundUsers,
        users: users
      });
    },
    isDisabled: isSearchDisabled
  }), /*#__PURE__*/React__namespace.default.createElement(UsersContainer, null, areThereNoFoundUsers ? /*#__PURE__*/React__namespace.default.createElement(EmptyContainer, null, /*#__PURE__*/React__namespace.default.createElement(StyledTypography, null, noUsersMessage)) : /*#__PURE__*/React__namespace.default.createElement(VirtualizedList, {
    items: foundUsers,
    itemSize: BULLETIN_DETAIL_USER_ITEM_HEIGHT,
    RowComponent: BulletinPostDetailsUserViewsListItem
  })));
}
BulletinPostDetailsUserSearchList.propTypes = {
  users: propTypesExports.array,
  emptyStateMessage: propTypesExports.string.isRequired
};
var UsersContainer = styled__default.default(Box$3)(function (_ref2) {
  var theme = _ref2.theme;
  return _defineProperty({
    height: 150,
    marginTop: theme.spacing(2),
    marginBottom: theme.spacing(1)
  }, theme.breakpoints.down("sm"), {
    height: "60vh"
  });
});
var StyledSearch = styled__default.default(SearchBar)(function () {
  return {
    marginLeft: 0,
    maxHeight: 32
  };
});
var EmptyContainer = styled__default.default(Box$3)({
  height: "100%",
  display: "flex",
  justifyContent: "center",
  alignItems: "center"
});
var StyledTypography = styled__default.default(Typography$1)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    color: theme.palette.text.secondary
  };
});
function searchUsersByName(_ref5) {
  var searchValue = _ref5.searchValue,
    setFoundUsers = _ref5.setFoundUsers,
    users = _ref5.users;
  var formattedSearchValue = searchValue === null || searchValue === void 0 ? void 0 : searchValue.toLowerCase();
  var matchedUsers = users.filter(function (user) {
    var name = getFullName(user);
    return name.toLowerCase().includes(formattedSearchValue);
  });
  var searchResults = searchValue ? matchedUsers : users;
  setFoundUsers(searchResults);
}
function handleResendInvitationDisabled(_ref6) {
  var areThereNoFoundUsers = _ref6.areThereNoFoundUsers,
    users = _ref6.users,
    foundUsers = _ref6.foundUsers,
    setIsResendInvitationDisabled = _ref6.setIsResendInvitationDisabled;
  // if we have searched for a user, disable the resend invitation button
  if (foundUsers.length !== users.length) {
    setIsResendInvitationDisabled(true);
  }

  // if we searched for a user, then deleted the search, enable the resend invitation button
  if (foundUsers.length === users.length && !areThereNoFoundUsers) {
    setIsResendInvitationDisabled(false);
  }
}

function getCircularProgressUtilityClass(slot) {
  return generateUtilityClass('MuiCircularProgress', slot);
}
generateUtilityClasses('MuiCircularProgress', ['root', 'determinate', 'indeterminate', 'colorPrimary', 'colorSecondary', 'svg', 'circle', 'circleDeterminate', 'circleIndeterminate', 'circleDisableShrink']);

const _excluded$I = ["className", "color", "disableShrink", "size", "style", "thickness", "value", "variant"];
let _ = t => t,
  _t,
  _t2,
  _t3,
  _t4;
const SIZE = 44;
const circularRotateKeyframe = react.keyframes(_t || (_t = _`
  0% {
    transform: rotate(0deg);
  }

  100% {
    transform: rotate(360deg);
  }
`));
const circularDashKeyframe = react.keyframes(_t2 || (_t2 = _`
  0% {
    stroke-dasharray: 1px, 200px;
    stroke-dashoffset: 0;
  }

  50% {
    stroke-dasharray: 100px, 200px;
    stroke-dashoffset: -15px;
  }

  100% {
    stroke-dasharray: 100px, 200px;
    stroke-dashoffset: -125px;
  }
`));
const useUtilityClasses$o = ownerState => {
  const {
    classes,
    variant,
    color,
    disableShrink
  } = ownerState;
  const slots = {
    root: ['root', variant, `color${capitalize(color)}`],
    svg: ['svg'],
    circle: ['circle', `circle${capitalize(variant)}`, disableShrink && 'circleDisableShrink']
  };
  return composeClasses(slots, getCircularProgressUtilityClass, classes);
};
const CircularProgressRoot = styled$1('span', {
  name: 'MuiCircularProgress',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[ownerState.variant], styles[`color${capitalize(ownerState.color)}`]];
  }
})(({
  ownerState,
  theme
}) => _extends$1({
  display: 'inline-block'
}, ownerState.variant === 'determinate' && {
  transition: theme.transitions.create('transform')
}, ownerState.color !== 'inherit' && {
  color: (theme.vars || theme).palette[ownerState.color].main
}), ({
  ownerState
}) => ownerState.variant === 'indeterminate' && react.css(_t3 || (_t3 = _`
      animation: ${0} 1.4s linear infinite;
    `), circularRotateKeyframe));
const CircularProgressSVG = styled$1('svg', {
  name: 'MuiCircularProgress',
  slot: 'Svg',
  overridesResolver: (props, styles) => styles.svg
})({
  display: 'block' // Keeps the progress centered
});

const CircularProgressCircle = styled$1('circle', {
  name: 'MuiCircularProgress',
  slot: 'Circle',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.circle, styles[`circle${capitalize(ownerState.variant)}`], ownerState.disableShrink && styles.circleDisableShrink];
  }
})(({
  ownerState,
  theme
}) => _extends$1({
  stroke: 'currentColor'
}, ownerState.variant === 'determinate' && {
  transition: theme.transitions.create('stroke-dashoffset')
}, ownerState.variant === 'indeterminate' && {
  // Some default value that looks fine waiting for the animation to kicks in.
  strokeDasharray: '80px, 200px',
  strokeDashoffset: 0 // Add the unit to fix a Edge 16 and below bug.
}), ({
  ownerState
}) => ownerState.variant === 'indeterminate' && !ownerState.disableShrink && react.css(_t4 || (_t4 = _`
      animation: ${0} 1.4s ease-in-out infinite;
    `), circularDashKeyframe));

/**
 * ## ARIA
 *
 * If the progress bar is describing the loading progress of a particular region of a page,
 * you should use `aria-describedby` to point to the progress bar, and set the `aria-busy`
 * attribute to `true` on that region until it has finished loading.
 */
const CircularProgress = /*#__PURE__*/React__namespace.forwardRef(function CircularProgress(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiCircularProgress'
  });
  const {
      className,
      color = 'primary',
      disableShrink = false,
      size = 40,
      style,
      thickness = 3.6,
      value = 0,
      variant = 'indeterminate'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$I);
  const ownerState = _extends$1({}, props, {
    color,
    disableShrink,
    size,
    thickness,
    value,
    variant
  });
  const classes = useUtilityClasses$o(ownerState);
  const circleStyle = {};
  const rootStyle = {};
  const rootProps = {};
  if (variant === 'determinate') {
    const circumference = 2 * Math.PI * ((SIZE - thickness) / 2);
    circleStyle.strokeDasharray = circumference.toFixed(3);
    rootProps['aria-valuenow'] = Math.round(value);
    circleStyle.strokeDashoffset = `${((100 - value) / 100 * circumference).toFixed(3)}px`;
    rootStyle.transform = 'rotate(-90deg)';
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(CircularProgressRoot, _extends$1({
    className: clsx(classes.root, className),
    style: _extends$1({
      width: size,
      height: size
    }, rootStyle, style),
    ownerState: ownerState,
    ref: ref,
    role: "progressbar"
  }, rootProps, other, {
    children: /*#__PURE__*/jsxRuntimeExports.jsx(CircularProgressSVG, {
      className: classes.svg,
      ownerState: ownerState,
      viewBox: `${SIZE / 2} ${SIZE / 2} ${SIZE} ${SIZE}`,
      children: /*#__PURE__*/jsxRuntimeExports.jsx(CircularProgressCircle, {
        className: classes.circle,
        style: circleStyle,
        ownerState: ownerState,
        cx: SIZE,
        cy: SIZE,
        r: (SIZE - thickness) / 2,
        fill: "none",
        strokeWidth: thickness
      })
    })
  }));
});
browser$1.env.NODE_ENV !== "production" ? CircularProgress.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'primary'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['inherit', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * If `true`, the shrink animation is disabled.
   * This only works if variant is `indeterminate`.
   * @default false
   */
  disableShrink: chainPropTypes(propTypesExports.bool, props => {
    if (props.disableShrink && props.variant && props.variant !== 'indeterminate') {
      return new Error('MUI: You have provided the `disableShrink` prop ' + 'with a variant other than `indeterminate`. This will have no effect.');
    }
    return null;
  }),
  /**
   * The size of the component.
   * If using a number, the pixel unit is assumed.
   * If using a string, you need to provide the CSS unit, e.g '3rem'.
   * @default 40
   */
  size: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * @ignore
   */
  style: propTypesExports.object,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The thickness of the circle.
   * @default 3.6
   */
  thickness: propTypesExports.number,
  /**
   * The value of the progress indicator for the determinate variant.
   * Value between 0 and 100.
   * @default 0
   */
  value: propTypesExports.number,
  /**
   * The variant to use.
   * Use indeterminate when there is no progress value.
   * @default 'indeterminate'
   */
  variant: propTypesExports.oneOf(['determinate', 'indeterminate'])
} : void 0;
var CircularProgress$1 = CircularProgress;

function getLoadingButtonUtilityClass(slot) {
  return generateUtilityClass('MuiLoadingButton', slot);
}
const loadingButtonClasses = generateUtilityClasses('MuiLoadingButton', ['root', 'loading', 'loadingIndicator', 'loadingIndicatorCenter', 'loadingIndicatorStart', 'loadingIndicatorEnd', 'endIconLoadingEnd', 'startIconLoadingStart']);
var loadingButtonClasses$1 = loadingButtonClasses;

const _excluded$H = ["children", "disabled", "id", "loading", "loadingIndicator", "loadingPosition", "variant"];
const useUtilityClasses$n = ownerState => {
  const {
    loading,
    loadingPosition,
    classes
  } = ownerState;
  const slots = {
    root: ['root', loading && 'loading'],
    startIcon: [loading && `startIconLoading${capitalize(loadingPosition)}`],
    endIcon: [loading && `endIconLoading${capitalize(loadingPosition)}`],
    loadingIndicator: ['loadingIndicator', loading && `loadingIndicator${capitalize(loadingPosition)}`]
  };
  const composedClasses = composeClasses(slots, getLoadingButtonUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};

// TODO use `import { rootShouldForwardProp } from '../styles/styled';` once move to core
const rootShouldForwardProp = prop => prop !== 'ownerState' && prop !== 'theme' && prop !== 'sx' && prop !== 'as' && prop !== 'classes';
const LoadingButtonRoot = styled$1(Button$2, {
  shouldForwardProp: prop => rootShouldForwardProp(prop) || prop === 'classes',
  name: 'MuiLoadingButton',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    return [styles.root, styles.startIconLoadingStart && {
      [`& .${loadingButtonClasses$1.startIconLoadingStart}`]: styles.startIconLoadingStart
    }, styles.endIconLoadingEnd && {
      [`& .${loadingButtonClasses$1.endIconLoadingEnd}`]: styles.endIconLoadingEnd
    }];
  }
})(({
  ownerState,
  theme
}) => _extends$1({
  [`& .${loadingButtonClasses$1.startIconLoadingStart}, & .${loadingButtonClasses$1.endIconLoadingEnd}`]: {
    transition: theme.transitions.create(['opacity'], {
      duration: theme.transitions.duration.short
    }),
    opacity: 0
  }
}, ownerState.loadingPosition === 'center' && {
  transition: theme.transitions.create(['background-color', 'box-shadow', 'border-color'], {
    duration: theme.transitions.duration.short
  }),
  [`&.${loadingButtonClasses$1.loading}`]: {
    color: 'transparent'
  }
}, ownerState.loadingPosition === 'start' && ownerState.fullWidth && {
  [`& .${loadingButtonClasses$1.startIconLoadingStart}, & .${loadingButtonClasses$1.endIconLoadingEnd}`]: {
    transition: theme.transitions.create(['opacity'], {
      duration: theme.transitions.duration.short
    }),
    opacity: 0,
    marginRight: -8
  }
}, ownerState.loadingPosition === 'end' && ownerState.fullWidth && {
  [`& .${loadingButtonClasses$1.startIconLoadingStart}, & .${loadingButtonClasses$1.endIconLoadingEnd}`]: {
    transition: theme.transitions.create(['opacity'], {
      duration: theme.transitions.duration.short
    }),
    opacity: 0,
    marginLeft: -8
  }
}));
const LoadingButtonLoadingIndicator = styled$1('div', {
  name: 'MuiLoadingButton',
  slot: 'LoadingIndicator',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.loadingIndicator, styles[`loadingIndicator${capitalize(ownerState.loadingPosition)}`]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  position: 'absolute',
  visibility: 'visible',
  display: 'flex'
}, ownerState.loadingPosition === 'start' && (ownerState.variant === 'outlined' || ownerState.variant === 'contained') && {
  left: ownerState.size === 'small' ? 10 : 14
}, ownerState.loadingPosition === 'start' && ownerState.variant === 'text' && {
  left: 6
}, ownerState.loadingPosition === 'center' && {
  left: '50%',
  transform: 'translate(-50%)',
  color: (theme.vars || theme).palette.action.disabled
}, ownerState.loadingPosition === 'end' && (ownerState.variant === 'outlined' || ownerState.variant === 'contained') && {
  right: ownerState.size === 'small' ? 10 : 14
}, ownerState.loadingPosition === 'end' && ownerState.variant === 'text' && {
  right: 6
}, ownerState.loadingPosition === 'start' && ownerState.fullWidth && {
  position: 'relative',
  left: -10
}, ownerState.loadingPosition === 'end' && ownerState.fullWidth && {
  position: 'relative',
  right: -10
}));
const LoadingButton = /*#__PURE__*/React__namespace.forwardRef(function LoadingButton(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiLoadingButton'
  });
  const {
      children,
      disabled = false,
      id: idProp,
      loading = false,
      loadingIndicator: loadingIndicatorProp,
      loadingPosition = 'center',
      variant = 'text'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$H);
  const id = useId(idProp);
  const loadingIndicator = loadingIndicatorProp != null ? loadingIndicatorProp : /*#__PURE__*/jsxRuntimeExports.jsx(CircularProgress$1, {
    "aria-labelledby": id,
    color: "inherit",
    size: 16
  });
  const ownerState = _extends$1({}, props, {
    disabled,
    loading,
    loadingIndicator,
    loadingPosition,
    variant
  });
  const classes = useUtilityClasses$n(ownerState);
  const loadingButtonLoadingIndicator = loading ? /*#__PURE__*/jsxRuntimeExports.jsx(LoadingButtonLoadingIndicator, {
    className: classes.loadingIndicator,
    ownerState: ownerState,
    children: loadingIndicator
  }) : null;
  return /*#__PURE__*/jsxRuntimeExports.jsxs(LoadingButtonRoot, _extends$1({
    disabled: disabled || loading,
    id: id,
    ref: ref
  }, other, {
    variant: variant,
    classes: classes,
    ownerState: ownerState,
    children: [ownerState.loadingPosition === 'end' ? children : loadingButtonLoadingIndicator, ownerState.loadingPosition === 'end' ? loadingButtonLoadingIndicator : children]
  }));
});
browser$1.env.NODE_ENV !== "production" ? LoadingButton.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * @ignore
   */
  id: propTypesExports.string,
  /**
   * If `true`, the loading indicator is shown.
   * @default false
   */
  loading: propTypesExports.bool,
  /**
   * Element placed before the children if the button is in loading state.
   * The node should contain an element with `role="progressbar"` with an accessible name.
   * By default we render a `CircularProgress` that is labelled by the button itself.
   * @default <CircularProgress color="inherit" size={16} />
   */
  loadingIndicator: propTypesExports.node,
  /**
   * The loading indicator can be positioned on the start, end, or the center of the button.
   * @default 'center'
   */
  loadingPosition: chainPropTypes(propTypesExports.oneOf(['start', 'end', 'center']), props => {
    if (props.loadingPosition === 'start' && !props.startIcon) {
      return new Error(`MUI: The loadingPosition="start" should be used in combination with startIcon.`);
    }
    if (props.loadingPosition === 'end' && !props.endIcon) {
      return new Error(`MUI: The loadingPosition="end" should be used in combination with endIcon.`);
    }
    return null;
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The variant to use.
   * @default 'text'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['contained', 'outlined', 'text']), propTypesExports.string])
} : void 0;
var LoadingButton$1 = LoadingButton;

function Button(props) {
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$b, props, props.children);
}
Button.propTypes = {
  children: propTypesExports.string
};
var StyledButton$b = styled__default.default(LoadingButton$1)(function (_ref) {
  var _ref2;
  var theme = _ref.theme,
    padding = _ref.padding;
  return _ref2 = {
    borderRadius: theme.borderRadius.lg
  }, _defineProperty(_ref2, theme.breakpoints.down("md"), {
    padding: padding || "2px 25px"
  }), _defineProperty(_ref2, theme.breakpoints.up("md"), {
    padding: padding || "2px 45px",
    fontSize: theme.typography.h5.fontSize
  }), _defineProperty(_ref2, "fontWeight", theme.typography.bold), _ref2;
});

function CloseButton(_ref) {
  var className = _ref.className,
    isInModal = _ref.isInModal,
    onClick = _ref.onClick,
    _ref$color = _ref.color,
    color = _ref$color === void 0 ? "secondary" : _ref$color,
    style = _ref.style;
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$a, {
    "data-testid": TEST_IDS.CLOSE_BUTTON,
    className: className,
    variant: "text",
    color: color,
    onClick: onClick,
    isInModal: isInModal,
    style: style
  }, /*#__PURE__*/React__namespace.default.createElement(default_1$F, null));
}
CloseButton.propTypes = {
  className: propTypesExports.string,
  isInModal: propTypesExports.bool,
  onClick: propTypesExports.func.isRequired,
  color: propTypesExports.string,
  style: propTypesExports.object
};
var StyledButton$a = styled__default.default(IconButton$2, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref2) {
  var isInModal = _ref2.isInModal;
  return _objectSpread2({
    padding: 2,
    margin: 0
  }, isInModal && {
    position: "sticky",
    top: 0,
    left: "100%"
  });
});

var MODAL_PADDING = "16px";
var MODAL_SMALL_PADDING = "10px 20px 20px";
var UNFORWARDED_PROPS = ["fullScreenOnMobile", "noPadding"];
function Modal(_ref) {
  var className = _ref.className,
    isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    children = _ref.children,
    title = _ref.title,
    onCancelClick = _ref.onCancelClick,
    buttons = _ref.buttons,
    buttonGap = _ref.buttonGap,
    padding = _ref.padding,
    _ref$CloseButtonCompo = _ref.CloseButtonComponent,
    CloseButtonComponent = _ref$CloseButtonCompo === void 0 ? CloseButton : _ref$CloseButtonCompo,
    noPadding = _ref.noPadding,
    _ref$width = _ref.width,
    width = _ref$width === void 0 ? "50%" : _ref$width,
    hideCloseButton = _ref.hideCloseButton,
    _ref$fullScreenOnMobi = _ref.fullScreenOnMobile,
    fullScreenOnMobile = _ref$fullScreenOnMobi === void 0 ? true : _ref$fullScreenOnMobi;
  return /*#__PURE__*/React__namespace.default.createElement(ModalOG, {
    open: isOpen,
    onClose: onClose,
    "data-testid": TEST_IDS.MODAL
  }, /*#__PURE__*/React__namespace.default.createElement(StyledModal$2, {
    className: className,
    fullScreenOnMobile: fullScreenOnMobile,
    width: width,
    padding: padding,
    noPadding: noPadding
  }, /*#__PURE__*/React__namespace.default.createElement(ModalHeader, null, title && /*#__PURE__*/React__namespace.default.createElement(Title$6, {
    variant: "h4"
  }, title), !hideCloseButton && /*#__PURE__*/React__namespace.default.createElement(CloseButtonComponent, {
    isInModal: true,
    onClick: onCancelClick || onClose
  })), /*#__PURE__*/React__namespace.default.createElement(ModalContent$3, {
    "data-testid": TEST_IDS.MODAL_CONTENT
  }, children, buttons && /*#__PURE__*/React__namespace.default.createElement(ButtonRow, {
    buttonGap: buttonGap
  }, buttons.map(function (button, idx) {
    return /*#__PURE__*/React__namespace.default.createElement(Button, {
      key: "modal_button_".concat(idx),
      loading: button.isLoading,
      disabled: button.isDisabled,
      variant: button.variant,
      onClick: button.onClick,
      "data-testid": button.testId
    }, button.label);
  })))));
}
Modal.propTypes = {
  className: propTypesExports.string,
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  children: propTypesExports.node.isRequired,
  title: propTypesExports.string,
  width: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  padding: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  noPadding: propTypesExports.bool,
  hideCloseButton: propTypesExports.bool,
  buttons: propTypesExports.arrayOf(propTypesExports.shape({
    label: propTypesExports.string,
    onClick: propTypesExports.func,
    variant: propTypesExports.string,
    testId: propTypesExports.string
  })),
  buttonGap: propTypesExports.number,
  CloseButtonComponent: propTypesExports.oneOfType([propTypesExports.element, propTypesExports.func]),
  fullScreenOnMobile: propTypesExports.bool,
  onCancelClick: propTypesExports.func
};
var StyledModal$2 = styled__default.default(Box$1, {
  shouldForwardProp: shouldForwardProp$2
})(function (_ref2) {
  var _objectSpread2$1;
  var theme = _ref2.theme,
    noPadding = _ref2.noPadding,
    _ref2$padding = _ref2.padding,
    padding = _ref2$padding === void 0 ? MODAL_PADDING : _ref2$padding,
    fullScreenOnMobile = _ref2.fullScreenOnMobile;
  return _objectSpread2((_objectSpread2$1 = {
    padding: noPadding ? 0 : padding
  }, _defineProperty(_objectSpread2$1, theme.breakpoints.down("sm"), {
    padding: noPadding ? 0 : MODAL_SMALL_PADDING
  }), _defineProperty(_objectSpread2$1, "outline", "none"), _defineProperty(_objectSpread2$1, "position", "absolute"), _defineProperty(_objectSpread2$1, "top", "50%"), _defineProperty(_objectSpread2$1, "left", "50%"), _defineProperty(_objectSpread2$1, "transform", "translate(-50%, -50%)"), _defineProperty(_objectSpread2$1, "minWidth", 300), _defineProperty(_objectSpread2$1, "minHeight", 50), _defineProperty(_objectSpread2$1, "maxWidth", "calc(100vw - 20px)"), _defineProperty(_objectSpread2$1, "maxHeight", "calc(100vh - 20px)"), _defineProperty(_objectSpread2$1, "overflowY", "auto"), _defineProperty(_objectSpread2$1, "backgroundColor", theme.palette.card.background), _defineProperty(_objectSpread2$1, "borderRadius", theme.borderRadius.lg), _objectSpread2$1), fullScreenOnMobile && _defineProperty({}, theme.breakpoints.down("sm"), {
    maxWidth: "100vw",
    maxHeight: "100vh",
    top: 0,
    left: 0,
    width: "100%",
    height: "100%",
    transform: "none",
    borderRadius: 0
  }));
});
var ModalHeader = styled__default.default(Box$1)({
  display: "flex",
  flexDirection: "row",
  justifyContent: "space-between",
  alignItems: "center"
});
var ModalContent$3 = styled__default.default(Box$1)(function () {
  return {
    position: "relative",
    height: "100%"
  };
});
var ButtonRow = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref4) {
  var buttonGap = _ref4.buttonGap;
  return {
    marginTop: 20,
    display: "flex",
    flexDirection: "row",
    justifyContent: buttonGap ? "center" : "space-evenly",
    gap: buttonGap
  };
});
var Title$6 = styled__default.default(Typography$1)({
  marginLeft: "5px"
});
function shouldForwardProp$2(prop) {
  return UNFORWARDED_PROPS.indexOf(prop) === -1;
}

function ConfirmationModal(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    message = _ref.message,
    renderContent = _ref.renderContent,
    _ref$confirmationButt = _ref.confirmationButtonLabel,
    confirmationButtonLabel = _ref$confirmationButt === void 0 ? "Yes" : _ref$confirmationButt,
    onConfirmation = _ref.onConfirmation,
    isLoading = _ref.isLoading,
    _ref$showWarning = _ref.showWarning,
    showWarning = _ref$showWarning === void 0 ? false : _ref$showWarning,
    hideCloseButton = _ref.hideCloseButton,
    modalWidth = _ref.modalWidth;
  var buttonConfigs = getButtonConfigs({
    confirmationButtonLabel: confirmationButtonLabel,
    onConfirmation: onConfirmation,
    onClose: onClose,
    isLoading: isLoading
  });
  var warning = "This action cannot be undone, would you like to continue?";
  return /*#__PURE__*/React__namespace.default.createElement(Modal, {
    isOpen: isOpen,
    onClose: onClose,
    buttons: buttonConfigs,
    padding: "50px 60px",
    buttonGap: 10,
    hideCloseButton: hideCloseButton,
    width: modalWidth
  }, /*#__PURE__*/React__namespace.default.createElement(ModalContent$2, {
    "data-testid": TEST_IDS.CONFIRMATION_MODAL
  }, message && /*#__PURE__*/React__namespace.default.createElement(ModalMessage, {
    variant: "h4"
  }, message), renderContent && renderContent(), showWarning && /*#__PURE__*/React__namespace.default.createElement(Warning, null, warning)));
}
ConfirmationModal.propTypes = {
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  message: propTypesExports.string,
  renderContent: propTypesExports.func,
  confirmationButtonLabel: propTypesExports.string,
  onConfirmation: propTypesExports.func.isRequired,
  isLoading: propTypesExports.bool,
  showWarning: propTypesExports.bool,
  hideCloseButton: propTypesExports.bool,
  modalWidth: propTypesExports.string
};
var ModalContent$2 = styled__default.default(Box$1)({
  maxWidth: "90%",
  paddingLeft: "10%",
  textAlign: "center",
  marginBottom: "20px"
});
var ModalMessage = styled__default.default(Typography$1)({
  fontSize: "20px",
  lineHeight: "28px"
});
var Warning = styled__default.default(Typography$1)({
  marginTop: "30px"
});
function getButtonConfigs(_ref2) {
  var confirmationButtonLabel = _ref2.confirmationButtonLabel,
    onConfirmation = _ref2.onConfirmation,
    onClose = _ref2.onClose,
    isLoading = _ref2.isLoading;
  return [{
    label: "Cancel",
    variant: "outlined",
    onClick: function onClick() {
      return onClose();
    }
  }, {
    label: confirmationButtonLabel,
    variant: "contained",
    isLoading: isLoading,
    onClick: function onClick() {
      return onConfirmation();
    },
    testId: TEST_IDS.CONFIRMATION_MODAL_BUTTON
  }];
}

var MODAL_WIDTH = "min-content";
var CONFIMATION_BUTTON_LABEL = "Remind";
var CONFIRMATION_MESSAGE = "All users will be sent a notification";
function BulletinPostDetailsUserViewsList(_ref) {
  var bulletinPostId = _ref.bulletinPostId,
    users = _ref.users,
    isMutationLoading = _ref.isMutationLoading,
    onResendNotificationsClick = _ref.onResendNotificationsClick,
    resendButtonTitle = _ref.resendButtonTitle,
    confirmationMessage = _ref.confirmationMessage,
    emptyStateMessage = _ref.emptyStateMessage;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isResendModalConfirmationOpen = _useState2[0],
    setIsResendModalConfirmationOpen = _useState2[1];
  var _useBulletinPosts = useBulletinPosts(),
    setIsResendInvitationDisabled = _useBulletinPosts.setIsResendInvitationDisabled,
    isResendInvitationDisabled = _useBulletinPosts.isResendInvitationDisabled;
  React.useEffect(function () {
    if (!users.length) setIsResendInvitationDisabled(true);
  }, []);
  var userIds = users.map(function (user) {
    return user.id;
  });
  return /*#__PURE__*/React__namespace.default.createElement(Column$1, null, /*#__PURE__*/React__namespace.default.createElement(BulletinPostDetailsUserSearchList, {
    users: users,
    emptyStateMessage: emptyStateMessage
  }), /*#__PURE__*/React__namespace.default.createElement(StyledButton$9, {
    disabled: isResendInvitationDisabled,
    isLoading: isMutationLoading,
    onClick: function onClick() {
      return setIsResendModalConfirmationOpen(true);
    },
    startIcon: /*#__PURE__*/React__namespace.default.createElement(default_1$D, null),
    "data-testid": TEST_IDS.RESEND_BUTTON
  }, resendButtonTitle), /*#__PURE__*/React__namespace.default.createElement(ConfirmationModal, {
    isOpen: isResendModalConfirmationOpen,
    onClose: function onClose() {
      return setIsResendModalConfirmationOpen(false);
    },
    message: confirmationMessage,
    confirmationButtonLabel: CONFIMATION_BUTTON_LABEL,
    onConfirmation: function onConfirmation() {
      return onResendNotificationsClick({
        bulletinPostId: bulletinPostId,
        userIds: userIds,
        onCompleted: function onCompleted() {
          return setIsResendModalConfirmationOpen(false);
        }
      });
    },
    isLoading: isMutationLoading,
    renderContent: function renderContent() {
      return /*#__PURE__*/React__namespace.default.createElement(Box$3, {
        m: 2
      }, CONFIRMATION_MESSAGE);
    },
    hideCloseButton: true,
    modalWidth: MODAL_WIDTH
  }));
}
BulletinPostDetailsUserViewsList.propTypes = {
  bulletinPostId: propTypesExports.string,
  users: propTypesExports.array,
  isMutationLoading: propTypesExports.bool,
  onResendNotificationsClick: propTypesExports.func,
  resendButtonTitle: propTypesExports.string,
  confirmationMessage: propTypesExports.string,
  emptyStateMessage: propTypesExports.string.isRequired
};
var Column$1 = styled__default.default(Box$3)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: "flex",
    flexDirection: "column",
    paddingTop: theme.spacing(1),
    marginBottom: theme.spacing(2),
    margin: theme.spacing(1),
    borderBottom: "1px solid ".concat(theme.palette.card.divider)
  };
});
var StyledButton$9 = styled__default.default(Button, {
  shouldForwardProp: isPropValid__default.default
})(function () {
  return {
    textTransform: "none"
  };
});

/**
 * @ignore - internal component.
 */
const GridContext = /*#__PURE__*/React__namespace.createContext();
if (browser$1.env.NODE_ENV !== 'production') {
  GridContext.displayName = 'GridContext';
}
var GridContext$1 = GridContext;

function getGridUtilityClass(slot) {
  return generateUtilityClass('MuiGrid', slot);
}
const SPACINGS = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
const DIRECTIONS = ['column-reverse', 'column', 'row-reverse', 'row'];
const WRAPS = ['nowrap', 'wrap-reverse', 'wrap'];
const GRID_SIZES = ['auto', true, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12];
const gridClasses = generateUtilityClasses('MuiGrid', ['root', 'container', 'item', 'zeroMinWidth',
// spacings
...SPACINGS.map(spacing => `spacing-xs-${spacing}`),
// direction values
...DIRECTIONS.map(direction => `direction-xs-${direction}`),
// wrap values
...WRAPS.map(wrap => `wrap-xs-${wrap}`),
// grid sizes for all breakpoints
...GRID_SIZES.map(size => `grid-xs-${size}`), ...GRID_SIZES.map(size => `grid-sm-${size}`), ...GRID_SIZES.map(size => `grid-md-${size}`), ...GRID_SIZES.map(size => `grid-lg-${size}`), ...GRID_SIZES.map(size => `grid-xl-${size}`)]);

const _excluded$G = ["className", "columns", "columnSpacing", "component", "container", "direction", "item", "rowSpacing", "spacing", "wrap", "zeroMinWidth"];
function getOffset(val) {
  const parse = parseFloat(val);
  return `${parse}${String(val).replace(String(parse), '') || 'px'}`;
}
function generateGrid({
  theme,
  ownerState
}) {
  let size;
  return theme.breakpoints.keys.reduce((globalStyles, breakpoint) => {
    // Use side effect over immutability for better performance.
    let styles = {};
    if (ownerState[breakpoint]) {
      size = ownerState[breakpoint];
    }
    if (!size) {
      return globalStyles;
    }
    if (size === true) {
      // For the auto layouting
      styles = {
        flexBasis: 0,
        flexGrow: 1,
        maxWidth: '100%'
      };
    } else if (size === 'auto') {
      styles = {
        flexBasis: 'auto',
        flexGrow: 0,
        flexShrink: 0,
        maxWidth: 'none',
        width: 'auto'
      };
    } else {
      const columnsBreakpointValues = resolveBreakpointValues({
        values: ownerState.columns,
        breakpoints: theme.breakpoints.values
      });
      const columnValue = typeof columnsBreakpointValues === 'object' ? columnsBreakpointValues[breakpoint] : columnsBreakpointValues;
      if (columnValue === undefined || columnValue === null) {
        return globalStyles;
      }
      // Keep 7 significant numbers.
      const width = `${Math.round(size / columnValue * 10e7) / 10e5}%`;
      let more = {};
      if (ownerState.container && ownerState.item && ownerState.columnSpacing !== 0) {
        const themeSpacing = theme.spacing(ownerState.columnSpacing);
        if (themeSpacing !== '0px') {
          const fullWidth = `calc(${width} + ${getOffset(themeSpacing)})`;
          more = {
            flexBasis: fullWidth,
            maxWidth: fullWidth
          };
        }
      }

      // Close to the bootstrap implementation:
      // https://github.com/twbs/bootstrap/blob/8fccaa2439e97ec72a4b7dc42ccc1f649790adb0/scss/mixins/_grid.scss#L41
      styles = _extends$1({
        flexBasis: width,
        flexGrow: 0,
        maxWidth: width
      }, more);
    }

    // No need for a media query for the first size.
    if (theme.breakpoints.values[breakpoint] === 0) {
      Object.assign(globalStyles, styles);
    } else {
      globalStyles[theme.breakpoints.up(breakpoint)] = styles;
    }
    return globalStyles;
  }, {});
}
function generateDirection({
  theme,
  ownerState
}) {
  const directionValues = resolveBreakpointValues({
    values: ownerState.direction,
    breakpoints: theme.breakpoints.values
  });
  return handleBreakpoints({
    theme
  }, directionValues, propValue => {
    const output = {
      flexDirection: propValue
    };
    if (propValue.indexOf('column') === 0) {
      output[`& > .${gridClasses.item}`] = {
        maxWidth: 'none'
      };
    }
    return output;
  });
}

/**
 * Extracts zero value breakpoint keys before a non-zero value breakpoint key.
 * @example { xs: 0, sm: 0, md: 2, lg: 0, xl: 0 } or [0, 0, 2, 0, 0]
 * @returns [xs, sm]
 */
function extractZeroValueBreakpointKeys({
  breakpoints,
  values
}) {
  let nonZeroKey = '';
  Object.keys(values).forEach(key => {
    if (nonZeroKey !== '') {
      return;
    }
    if (values[key] !== 0) {
      nonZeroKey = key;
    }
  });
  const sortedBreakpointKeysByValue = Object.keys(breakpoints).sort((a, b) => {
    return breakpoints[a] - breakpoints[b];
  });
  return sortedBreakpointKeysByValue.slice(0, sortedBreakpointKeysByValue.indexOf(nonZeroKey));
}
function generateRowGap({
  theme,
  ownerState
}) {
  const {
    container,
    rowSpacing
  } = ownerState;
  let styles = {};
  if (container && rowSpacing !== 0) {
    const rowSpacingValues = resolveBreakpointValues({
      values: rowSpacing,
      breakpoints: theme.breakpoints.values
    });
    let zeroValueBreakpointKeys;
    if (typeof rowSpacingValues === 'object') {
      zeroValueBreakpointKeys = extractZeroValueBreakpointKeys({
        breakpoints: theme.breakpoints.values,
        values: rowSpacingValues
      });
    }
    styles = handleBreakpoints({
      theme
    }, rowSpacingValues, (propValue, breakpoint) => {
      var _zeroValueBreakpointK;
      const themeSpacing = theme.spacing(propValue);
      if (themeSpacing !== '0px') {
        return {
          marginTop: `-${getOffset(themeSpacing)}`,
          [`& > .${gridClasses.item}`]: {
            paddingTop: getOffset(themeSpacing)
          }
        };
      }
      if ((_zeroValueBreakpointK = zeroValueBreakpointKeys) != null && _zeroValueBreakpointK.includes(breakpoint)) {
        return {};
      }
      return {
        marginTop: 0,
        [`& > .${gridClasses.item}`]: {
          paddingTop: 0
        }
      };
    });
  }
  return styles;
}
function generateColumnGap({
  theme,
  ownerState
}) {
  const {
    container,
    columnSpacing
  } = ownerState;
  let styles = {};
  if (container && columnSpacing !== 0) {
    const columnSpacingValues = resolveBreakpointValues({
      values: columnSpacing,
      breakpoints: theme.breakpoints.values
    });
    let zeroValueBreakpointKeys;
    if (typeof columnSpacingValues === 'object') {
      zeroValueBreakpointKeys = extractZeroValueBreakpointKeys({
        breakpoints: theme.breakpoints.values,
        values: columnSpacingValues
      });
    }
    styles = handleBreakpoints({
      theme
    }, columnSpacingValues, (propValue, breakpoint) => {
      var _zeroValueBreakpointK2;
      const themeSpacing = theme.spacing(propValue);
      if (themeSpacing !== '0px') {
        return {
          width: `calc(100% + ${getOffset(themeSpacing)})`,
          marginLeft: `-${getOffset(themeSpacing)}`,
          [`& > .${gridClasses.item}`]: {
            paddingLeft: getOffset(themeSpacing)
          }
        };
      }
      if ((_zeroValueBreakpointK2 = zeroValueBreakpointKeys) != null && _zeroValueBreakpointK2.includes(breakpoint)) {
        return {};
      }
      return {
        width: '100%',
        marginLeft: 0,
        [`& > .${gridClasses.item}`]: {
          paddingLeft: 0
        }
      };
    });
  }
  return styles;
}
function resolveSpacingStyles(spacing, breakpoints, styles = {}) {
  // undefined/null or `spacing` <= 0
  if (!spacing || spacing <= 0) {
    return [];
  }
  // in case of string/number `spacing`
  if (typeof spacing === 'string' && !Number.isNaN(Number(spacing)) || typeof spacing === 'number') {
    return [styles[`spacing-xs-${String(spacing)}`]];
  }
  // in case of object `spacing`
  const spacingStyles = [];
  breakpoints.forEach(breakpoint => {
    const value = spacing[breakpoint];
    if (Number(value) > 0) {
      spacingStyles.push(styles[`spacing-${breakpoint}-${String(value)}`]);
    }
  });
  return spacingStyles;
}

// Default CSS values
// flex: '0 1 auto',
// flexDirection: 'row',
// alignItems: 'flex-start',
// flexWrap: 'nowrap',
// justifyContent: 'flex-start',
const GridRoot = styled$1('div', {
  name: 'MuiGrid',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    const {
      container,
      direction,
      item,
      spacing,
      wrap,
      zeroMinWidth,
      breakpoints
    } = ownerState;
    let spacingStyles = [];

    // in case of grid item
    if (container) {
      spacingStyles = resolveSpacingStyles(spacing, breakpoints, styles);
    }
    const breakpointsStyles = [];
    breakpoints.forEach(breakpoint => {
      const value = ownerState[breakpoint];
      if (value) {
        breakpointsStyles.push(styles[`grid-${breakpoint}-${String(value)}`]);
      }
    });
    return [styles.root, container && styles.container, item && styles.item, zeroMinWidth && styles.zeroMinWidth, ...spacingStyles, direction !== 'row' && styles[`direction-xs-${String(direction)}`], wrap !== 'wrap' && styles[`wrap-xs-${String(wrap)}`], ...breakpointsStyles];
  }
})(({
  ownerState
}) => _extends$1({
  boxSizing: 'border-box'
}, ownerState.container && {
  display: 'flex',
  flexWrap: 'wrap',
  width: '100%'
}, ownerState.item && {
  margin: 0 // For instance, it's useful when used with a `figure` element.
}, ownerState.zeroMinWidth && {
  minWidth: 0
}, ownerState.wrap !== 'wrap' && {
  flexWrap: ownerState.wrap
}), generateDirection, generateRowGap, generateColumnGap, generateGrid);
function resolveSpacingClasses(spacing, breakpoints) {
  // undefined/null or `spacing` <= 0
  if (!spacing || spacing <= 0) {
    return [];
  }
  // in case of string/number `spacing`
  if (typeof spacing === 'string' && !Number.isNaN(Number(spacing)) || typeof spacing === 'number') {
    return [`spacing-xs-${String(spacing)}`];
  }
  // in case of object `spacing`
  const classes = [];
  breakpoints.forEach(breakpoint => {
    const value = spacing[breakpoint];
    if (Number(value) > 0) {
      const className = `spacing-${breakpoint}-${String(value)}`;
      classes.push(className);
    }
  });
  return classes;
}
const useUtilityClasses$m = ownerState => {
  const {
    classes,
    container,
    direction,
    item,
    spacing,
    wrap,
    zeroMinWidth,
    breakpoints
  } = ownerState;
  let spacingClasses = [];

  // in case of grid item
  if (container) {
    spacingClasses = resolveSpacingClasses(spacing, breakpoints);
  }
  const breakpointsClasses = [];
  breakpoints.forEach(breakpoint => {
    const value = ownerState[breakpoint];
    if (value) {
      breakpointsClasses.push(`grid-${breakpoint}-${String(value)}`);
    }
  });
  const slots = {
    root: ['root', container && 'container', item && 'item', zeroMinWidth && 'zeroMinWidth', ...spacingClasses, direction !== 'row' && `direction-xs-${String(direction)}`, wrap !== 'wrap' && `wrap-xs-${String(wrap)}`, ...breakpointsClasses]
  };
  return composeClasses(slots, getGridUtilityClass, classes);
};
const Grid = /*#__PURE__*/React__namespace.forwardRef(function Grid(inProps, ref) {
  const themeProps = useThemeProps({
    props: inProps,
    name: 'MuiGrid'
  });
  const {
    breakpoints
  } = useTheme$1();
  const props = extendSxProp(themeProps);
  const {
      className,
      columns: columnsProp,
      columnSpacing: columnSpacingProp,
      component = 'div',
      container = false,
      direction = 'row',
      item = false,
      rowSpacing: rowSpacingProp,
      spacing = 0,
      wrap = 'wrap',
      zeroMinWidth = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$G);
  const rowSpacing = rowSpacingProp || spacing;
  const columnSpacing = columnSpacingProp || spacing;
  const columnsContext = React__namespace.useContext(GridContext$1);

  // columns set with default breakpoint unit of 12
  const columns = container ? columnsProp || 12 : columnsContext;
  const breakpointsValues = {};
  const otherFiltered = _extends$1({}, other);
  breakpoints.keys.forEach(breakpoint => {
    if (other[breakpoint] != null) {
      breakpointsValues[breakpoint] = other[breakpoint];
      delete otherFiltered[breakpoint];
    }
  });
  const ownerState = _extends$1({}, props, {
    columns,
    container,
    direction,
    item,
    rowSpacing,
    columnSpacing,
    wrap,
    zeroMinWidth,
    spacing
  }, breakpointsValues, {
    breakpoints: breakpoints.keys
  });
  const classes = useUtilityClasses$m(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(GridContext$1.Provider, {
    value: columns,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(GridRoot, _extends$1({
      ownerState: ownerState,
      className: clsx(classes.root, className),
      as: component,
      ref: ref
    }, otherFiltered))
  });
});
browser$1.env.NODE_ENV !== "production" ? Grid.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The number of columns.
   * @default 12
   */
  columns: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.number), propTypesExports.number, propTypesExports.object]),
  /**
   * Defines the horizontal space between the type `item` components.
   * It overrides the value of the `spacing` prop.
   */
  columnSpacing: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string])), propTypesExports.number, propTypesExports.object, propTypesExports.string]),
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, the component will have the flex *container* behavior.
   * You should be wrapping *items* with a *container*.
   * @default false
   */
  container: propTypesExports.bool,
  /**
   * Defines the `flex-direction` style property.
   * It is applied for all screen sizes.
   * @default 'row'
   */
  direction: propTypesExports.oneOfType([propTypesExports.oneOf(['column-reverse', 'column', 'row-reverse', 'row']), propTypesExports.arrayOf(propTypesExports.oneOf(['column-reverse', 'column', 'row-reverse', 'row'])), propTypesExports.object]),
  /**
   * If `true`, the component will have the flex *item* behavior.
   * You should be wrapping *items* with a *container*.
   * @default false
   */
  item: propTypesExports.bool,
  /**
   * If a number, it sets the number of columns the grid item uses.
   * It can't be greater than the total number of columns of the container (12 by default).
   * If 'auto', the grid item's width matches its content.
   * If false, the prop is ignored.
   * If true, the grid item's width grows to use the space available in the grid container.
   * The value is applied for the `lg` breakpoint and wider screens if not overridden.
   * @default false
   */
  lg: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.bool]),
  /**
   * If a number, it sets the number of columns the grid item uses.
   * It can't be greater than the total number of columns of the container (12 by default).
   * If 'auto', the grid item's width matches its content.
   * If false, the prop is ignored.
   * If true, the grid item's width grows to use the space available in the grid container.
   * The value is applied for the `md` breakpoint and wider screens if not overridden.
   * @default false
   */
  md: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.bool]),
  /**
   * Defines the vertical space between the type `item` components.
   * It overrides the value of the `spacing` prop.
   */
  rowSpacing: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string])), propTypesExports.number, propTypesExports.object, propTypesExports.string]),
  /**
   * If a number, it sets the number of columns the grid item uses.
   * It can't be greater than the total number of columns of the container (12 by default).
   * If 'auto', the grid item's width matches its content.
   * If false, the prop is ignored.
   * If true, the grid item's width grows to use the space available in the grid container.
   * The value is applied for the `sm` breakpoint and wider screens if not overridden.
   * @default false
   */
  sm: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.bool]),
  /**
   * Defines the space between the type `item` components.
   * It can only be used on a type `container` component.
   * @default 0
   */
  spacing: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string])), propTypesExports.number, propTypesExports.object, propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Defines the `flex-wrap` style property.
   * It's applied for all screen sizes.
   * @default 'wrap'
   */
  wrap: propTypesExports.oneOf(['nowrap', 'wrap-reverse', 'wrap']),
  /**
   * If a number, it sets the number of columns the grid item uses.
   * It can't be greater than the total number of columns of the container (12 by default).
   * If 'auto', the grid item's width matches its content.
   * If false, the prop is ignored.
   * If true, the grid item's width grows to use the space available in the grid container.
   * The value is applied for the `xl` breakpoint and wider screens if not overridden.
   * @default false
   */
  xl: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.bool]),
  /**
   * If a number, it sets the number of columns the grid item uses.
   * It can't be greater than the total number of columns of the container (12 by default).
   * If 'auto', the grid item's width matches its content.
   * If false, the prop is ignored.
   * If true, the grid item's width grows to use the space available in the grid container.
   * The value is applied for all the screen sizes with the lowest priority.
   * @default false
   */
  xs: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.bool]),
  /**
   * If `true`, it sets `min-width: 0` on the item.
   * Refer to the limitations section of the documentation to better understand the use case.
   * @default false
   */
  zeroMinWidth: propTypesExports.bool
} : void 0;
if (browser$1.env.NODE_ENV !== 'production') {
  const requireProp = requirePropFactory('Grid', Grid);
  // eslint-disable-next-line no-useless-concat
  Grid['propTypes' + ''] = _extends$1({}, Grid.propTypes, {
    direction: requireProp('container'),
    lg: requireProp('item'),
    md: requireProp('item'),
    sm: requireProp('item'),
    spacing: requireProp('container'),
    wrap: requireProp('container'),
    xs: requireProp('item'),
    zeroMinWidth: requireProp('item')
  });
}
var Grid$1 = Grid;

var DEFAULT_HEIGHT = 125;
function SkeletonList(_ref) {
  var count = _ref.count,
    isLoading = _ref.isLoading,
    _ref$itemHeight = _ref.itemHeight,
    itemHeight = _ref$itemHeight === void 0 ? DEFAULT_HEIGHT : _ref$itemHeight,
    itemWidth = _ref.itemWidth,
    gridItemConfig = _ref.gridItemConfig,
    SkeletonComponent = _ref.SkeletonComponent;
  if (!isLoading) return null;
  return _toConsumableArray(Array(count)).map(function (_, skeletonIndx) {
    if (gridItemConfig) {
      // if it is a grid config, skeletons are wrapped in a grid item
      return /*#__PURE__*/React__namespace.default.createElement(Grid$1, _extends$2({
        item: true
      }, gridItemConfig, {
        key: "skeleton-".concat(skeletonIndx)
      }), /*#__PURE__*/React__namespace.default.createElement(SkeletonListItem, {
        height: itemHeight,
        width: "100%"
      }));
    }
    return SkeletonComponent ? /*#__PURE__*/React__namespace.default.createElement(SkeletonComponent, {
      key: skeletonIndx
    }) : /*#__PURE__*/React__namespace.default.createElement(SkeletonListItem, {
      key: skeletonIndx,
      height: itemHeight,
      width: itemWidth
    });
  });
}
function SkeletonListItem(_ref2) {
  var height = _ref2.height,
    width = _ref2.width;
  return /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    height: height,
    width: width
  });
}
SkeletonList.propTypes = {
  // gridItemConfig will be any Grid MUI props
  gridItemConfig: propTypesExports.object,
  isLoading: propTypesExports.bool,
  SkeletonComponent: propTypesExports.func,
  itemHeight: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  itemWidth: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  count: propTypesExports.number
};
SkeletonListItem.propTypes = {
  height: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  width: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string])
};

function BulletinPostDetailsUserViewsSkeleton() {
  return /*#__PURE__*/React__namespace.default.createElement(SkeletonContainer$1, null, /*#__PURE__*/React__namespace.default.createElement(TabTitleRowContainer, null, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: 125,
    height: 35,
    isRounded: true,
    variant: "rectangular"
  }), /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: 125,
    height: 35,
    isRounded: true,
    variant: "rectangular"
  })), /*#__PURE__*/React__namespace.default.createElement(Box$3, {
    mb: 1
  }, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    variant: "rectangular",
    height: 35,
    isRounded: true
  })), /*#__PURE__*/React__namespace.default.createElement(SkeletonList, {
    count: 5,
    SkeletonComponent: function SkeletonComponent() {
      return /*#__PURE__*/React__namespace.default.createElement(NameSkeleton, null);
    },
    isLoading: true
  }), /*#__PURE__*/React__namespace.default.createElement(SkeletonButtonContainer, null, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    variant: "rectangular",
    width: "50%",
    height: 35,
    isRounded: true
  })));
}
var SkeletonContainer$1 = styled__default.default(Box$3)({
  display: "flex",
  flexDirection: "column",
  marginTop: 10,
  marginBottom: 10
});
var TabTitleRowContainer = styled__default.default(Box$3)(function () {
  return {
    height: 60,
    display: "flex",
    flexDirection: "row",
    alignItems: "center",
    gap: 10,
    paddingLeft: 10,
    paddingBottom: 5,
    marginBottom: 10
  };
});
var SkeletonButtonContainer = styled__default.default(Box$3)(function (_ref) {
  var theme = _ref.theme;
  return {
    marginTop: 10,
    paddingBottom: 15,
    display: "flex",
    alignItems: "center",
    justifyContent: "center",
    borderBottom: "1px solid ".concat(theme.palette.divider)
  };
});
var NameSkeleton = styled__default.default(Skeleton)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    borderRadius: theme.borderRadius.sm,
    height: 45,
    width: "30%"
  };
});

function getTabUtilityClass(slot) {
  return generateUtilityClass('MuiTab', slot);
}
const tabClasses = generateUtilityClasses('MuiTab', ['root', 'labelIcon', 'textColorInherit', 'textColorPrimary', 'textColorSecondary', 'selected', 'disabled', 'fullWidth', 'wrapped', 'iconWrapper']);
var tabClasses$1 = tabClasses;

const _excluded$F = ["className", "disabled", "disableFocusRipple", "fullWidth", "icon", "iconPosition", "indicator", "label", "onChange", "onClick", "onFocus", "selected", "selectionFollowsFocus", "textColor", "value", "wrapped"];
const useUtilityClasses$l = ownerState => {
  const {
    classes,
    textColor,
    fullWidth,
    wrapped,
    icon,
    label,
    selected,
    disabled
  } = ownerState;
  const slots = {
    root: ['root', icon && label && 'labelIcon', `textColor${capitalize(textColor)}`, fullWidth && 'fullWidth', wrapped && 'wrapped', selected && 'selected', disabled && 'disabled'],
    iconWrapper: ['iconWrapper']
  };
  return composeClasses(slots, getTabUtilityClass, classes);
};
const TabRoot = styled$1(ButtonBase$1, {
  name: 'MuiTab',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.label && ownerState.icon && styles.labelIcon, styles[`textColor${capitalize(ownerState.textColor)}`], ownerState.fullWidth && styles.fullWidth, ownerState.wrapped && styles.wrapped];
  }
})(({
  theme,
  ownerState
}) => _extends$1({}, theme.typography.button, {
  maxWidth: 360,
  minWidth: 90,
  position: 'relative',
  minHeight: 48,
  flexShrink: 0,
  padding: '12px 16px',
  overflow: 'hidden',
  whiteSpace: 'normal',
  textAlign: 'center'
}, ownerState.label && {
  flexDirection: ownerState.iconPosition === 'top' || ownerState.iconPosition === 'bottom' ? 'column' : 'row'
}, {
  lineHeight: 1.25
}, ownerState.icon && ownerState.label && {
  minHeight: 72,
  paddingTop: 9,
  paddingBottom: 9,
  [`& > .${tabClasses$1.iconWrapper}`]: _extends$1({}, ownerState.iconPosition === 'top' && {
    marginBottom: 6
  }, ownerState.iconPosition === 'bottom' && {
    marginTop: 6
  }, ownerState.iconPosition === 'start' && {
    marginRight: theme.spacing(1)
  }, ownerState.iconPosition === 'end' && {
    marginLeft: theme.spacing(1)
  })
}, ownerState.textColor === 'inherit' && {
  color: 'inherit',
  opacity: 0.6,
  // same opacity as theme.palette.text.secondary
  [`&.${tabClasses$1.selected}`]: {
    opacity: 1
  },
  [`&.${tabClasses$1.disabled}`]: {
    opacity: (theme.vars || theme).palette.action.disabledOpacity
  }
}, ownerState.textColor === 'primary' && {
  color: (theme.vars || theme).palette.text.secondary,
  [`&.${tabClasses$1.selected}`]: {
    color: (theme.vars || theme).palette.primary.main
  },
  [`&.${tabClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.text.disabled
  }
}, ownerState.textColor === 'secondary' && {
  color: (theme.vars || theme).palette.text.secondary,
  [`&.${tabClasses$1.selected}`]: {
    color: (theme.vars || theme).palette.secondary.main
  },
  [`&.${tabClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.text.disabled
  }
}, ownerState.fullWidth && {
  flexShrink: 1,
  flexGrow: 1,
  flexBasis: 0,
  maxWidth: 'none'
}, ownerState.wrapped && {
  fontSize: theme.typography.pxToRem(12)
}));
const Tab$1 = /*#__PURE__*/React__namespace.forwardRef(function Tab(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTab'
  });
  const {
      className,
      disabled = false,
      disableFocusRipple = false,
      // eslint-disable-next-line react/prop-types
      fullWidth,
      icon: iconProp,
      iconPosition = 'top',
      // eslint-disable-next-line react/prop-types
      indicator,
      label,
      onChange,
      onClick,
      onFocus,
      // eslint-disable-next-line react/prop-types
      selected,
      // eslint-disable-next-line react/prop-types
      selectionFollowsFocus,
      // eslint-disable-next-line react/prop-types
      textColor = 'inherit',
      value,
      wrapped = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$F);
  const ownerState = _extends$1({}, props, {
    disabled,
    disableFocusRipple,
    selected,
    icon: !!iconProp,
    iconPosition,
    label: !!label,
    fullWidth,
    textColor,
    wrapped
  });
  const classes = useUtilityClasses$l(ownerState);
  const icon = iconProp && label && /*#__PURE__*/React__namespace.isValidElement(iconProp) ? /*#__PURE__*/React__namespace.cloneElement(iconProp, {
    className: clsx(classes.iconWrapper, iconProp.props.className)
  }) : iconProp;
  const handleClick = event => {
    if (!selected && onChange) {
      onChange(event, value);
    }
    if (onClick) {
      onClick(event);
    }
  };
  const handleFocus = event => {
    if (selectionFollowsFocus && !selected && onChange) {
      onChange(event, value);
    }
    if (onFocus) {
      onFocus(event);
    }
  };
  return /*#__PURE__*/jsxRuntimeExports.jsxs(TabRoot, _extends$1({
    focusRipple: !disableFocusRipple,
    className: clsx(classes.root, className),
    ref: ref,
    role: "tab",
    "aria-selected": selected,
    disabled: disabled,
    onClick: handleClick,
    onFocus: handleFocus,
    ownerState: ownerState,
    tabIndex: selected ? 0 : -1
  }, other, {
    children: [iconPosition === 'top' || iconPosition === 'start' ? /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
      children: [icon, label]
    }) : /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
      children: [label, icon]
    }), indicator]
  }));
});
browser$1.env.NODE_ENV !== "production" ? Tab$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * This prop isn't supported.
   * Use the `component` prop if you need to change the children structure.
   */
  children: unsupportedProp,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the  keyboard focus ripple is disabled.
   * @default false
   */
  disableFocusRipple: propTypesExports.bool,
  /**
   * If `true`, the ripple effect is disabled.
   *
   * ⚠️ Without a ripple there is no styling for :focus-visible by default. Be sure
   * to highlight the element by applying separate styles with the `.Mui-focusVisible` class.
   * @default false
   */
  disableRipple: propTypesExports.bool,
  /**
   * The icon to display.
   */
  icon: propTypesExports.oneOfType([propTypesExports.element, propTypesExports.string]),
  /**
   * The position of the icon relative to the label.
   * @default 'top'
   */
  iconPosition: propTypesExports.oneOf(['bottom', 'end', 'start', 'top']),
  /**
   * The label element.
   */
  label: propTypesExports.node,
  /**
   * @ignore
   */
  onChange: propTypesExports.func,
  /**
   * @ignore
   */
  onClick: propTypesExports.func,
  /**
   * @ignore
   */
  onFocus: propTypesExports.func,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * You can provide your own value. Otherwise, we fallback to the child position index.
   */
  value: propTypesExports.any,
  /**
   * Tab labels appear in a single row.
   * They can use a second line if needed.
   * @default false
   */
  wrapped: propTypesExports.bool
} : void 0;
var TabOg = Tab$1;

function easeInOutSin(time) {
  return (1 + Math.sin(Math.PI * time - Math.PI / 2)) / 2;
}
function animate(property, element, to, options = {}, cb = () => {}) {
  const {
    ease = easeInOutSin,
    duration = 300 // standard
  } = options;
  let start = null;
  const from = element[property];
  let cancelled = false;
  const cancel = () => {
    cancelled = true;
  };
  const step = timestamp => {
    if (cancelled) {
      cb(new Error('Animation cancelled'));
      return;
    }
    if (start === null) {
      start = timestamp;
    }
    const time = Math.min(1, (timestamp - start) / duration);
    element[property] = ease(time) * (to - from) + from;
    if (time >= 1) {
      requestAnimationFrame(() => {
        cb(null);
      });
      return;
    }
    requestAnimationFrame(step);
  };
  if (from === to) {
    cb(new Error('Element already at target position'));
    return cancel;
  }
  requestAnimationFrame(step);
  return cancel;
}

const _excluded$E = ["onChange"];
const styles = {
  width: 99,
  height: 99,
  position: 'absolute',
  top: -9999,
  overflow: 'scroll'
};

/**
 * @ignore - internal component.
 * The component originates from https://github.com/STORIS/react-scrollbar-size.
 * It has been moved into the core in order to minimize the bundle size.
 */
function ScrollbarSize(props) {
  const {
      onChange
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$E);
  const scrollbarHeight = React__namespace.useRef();
  const nodeRef = React__namespace.useRef(null);
  const setMeasurements = () => {
    scrollbarHeight.current = nodeRef.current.offsetHeight - nodeRef.current.clientHeight;
  };
  React__namespace.useEffect(() => {
    const handleResize = debounce$1(() => {
      const prevHeight = scrollbarHeight.current;
      setMeasurements();
      if (prevHeight !== scrollbarHeight.current) {
        onChange(scrollbarHeight.current);
      }
    });
    const containerWindow = ownerWindow(nodeRef.current);
    containerWindow.addEventListener('resize', handleResize);
    return () => {
      handleResize.clear();
      containerWindow.removeEventListener('resize', handleResize);
    };
  }, [onChange]);
  React__namespace.useEffect(() => {
    setMeasurements();
    onChange(scrollbarHeight.current);
  }, [onChange]);
  return /*#__PURE__*/jsxRuntimeExports.jsx("div", _extends$1({
    style: styles,
    ref: nodeRef
  }, other));
}
browser$1.env.NODE_ENV !== "production" ? ScrollbarSize.propTypes = {
  onChange: propTypesExports.func.isRequired
} : void 0;

var KeyboardArrowLeft = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M15.41 16.09l-4.58-4.59 4.58-4.59L14 5.5l-6 6 6 6z"
}), 'KeyboardArrowLeft');

var KeyboardArrowRight = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M8.59 16.34l4.58-4.59-4.58-4.59L10 5.75l6 6-6 6z"
}), 'KeyboardArrowRight');

function getTabScrollButtonUtilityClass(slot) {
  return generateUtilityClass('MuiTabScrollButton', slot);
}
const tabScrollButtonClasses = generateUtilityClasses('MuiTabScrollButton', ['root', 'vertical', 'horizontal', 'disabled']);
var tabScrollButtonClasses$1 = tabScrollButtonClasses;

var _KeyboardArrowLeft$1, _KeyboardArrowRight$1;
const _excluded$D = ["className", "direction", "orientation", "disabled"];
const useUtilityClasses$k = ownerState => {
  const {
    classes,
    orientation,
    disabled
  } = ownerState;
  const slots = {
    root: ['root', orientation, disabled && 'disabled']
  };
  return composeClasses(slots, getTabScrollButtonUtilityClass, classes);
};
const TabScrollButtonRoot = styled$1(ButtonBase$1, {
  name: 'MuiTabScrollButton',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.orientation && styles[ownerState.orientation]];
  }
})(({
  ownerState
}) => _extends$1({
  width: 40,
  flexShrink: 0,
  opacity: 0.8,
  [`&.${tabScrollButtonClasses$1.disabled}`]: {
    opacity: 0
  }
}, ownerState.orientation === 'vertical' && {
  width: '100%',
  height: 40,
  '& svg': {
    transform: `rotate(${ownerState.isRtl ? -90 : 90}deg)`
  }
}));
const TabScrollButton = /*#__PURE__*/React__namespace.forwardRef(function TabScrollButton(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTabScrollButton'
  });
  const {
      className,
      direction
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$D);
  const theme = useTheme$1();
  const isRtl = theme.direction === 'rtl';
  const ownerState = _extends$1({
    isRtl
  }, props);
  const classes = useUtilityClasses$k(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(TabScrollButtonRoot, _extends$1({
    component: "div",
    className: clsx(classes.root, className),
    ref: ref,
    role: null,
    ownerState: ownerState,
    tabIndex: null
  }, other, {
    children: direction === 'left' ? _KeyboardArrowLeft$1 || (_KeyboardArrowLeft$1 = /*#__PURE__*/jsxRuntimeExports.jsx(KeyboardArrowLeft, {
      fontSize: "small"
    })) : _KeyboardArrowRight$1 || (_KeyboardArrowRight$1 = /*#__PURE__*/jsxRuntimeExports.jsx(KeyboardArrowRight, {
      fontSize: "small"
    }))
  }));
});
browser$1.env.NODE_ENV !== "production" ? TabScrollButton.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The direction the button should indicate.
   */
  direction: propTypesExports.oneOf(['left', 'right']).isRequired,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * The component orientation (layout flow direction).
   */
  orientation: propTypesExports.oneOf(['horizontal', 'vertical']).isRequired,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TabScrollButton$1 = TabScrollButton;

function getTabsUtilityClass(slot) {
  return generateUtilityClass('MuiTabs', slot);
}
const tabsClasses = generateUtilityClasses('MuiTabs', ['root', 'vertical', 'flexContainer', 'flexContainerVertical', 'centered', 'scroller', 'fixed', 'scrollableX', 'scrollableY', 'hideScrollbar', 'scrollButtons', 'scrollButtonsHideMobile', 'indicator']);
var tabsClasses$1 = tabsClasses;

const _excluded$C = ["aria-label", "aria-labelledby", "action", "centered", "children", "className", "component", "allowScrollButtonsMobile", "indicatorColor", "onChange", "orientation", "ScrollButtonComponent", "scrollButtons", "selectionFollowsFocus", "TabIndicatorProps", "TabScrollButtonProps", "textColor", "value", "variant", "visibleScrollbar"];
const nextItem = (list, item) => {
  if (list === item) {
    return list.firstChild;
  }
  if (item && item.nextElementSibling) {
    return item.nextElementSibling;
  }
  return list.firstChild;
};
const previousItem = (list, item) => {
  if (list === item) {
    return list.lastChild;
  }
  if (item && item.previousElementSibling) {
    return item.previousElementSibling;
  }
  return list.lastChild;
};
const moveFocus = (list, currentFocus, traversalFunction) => {
  let wrappedOnce = false;
  let nextFocus = traversalFunction(list, currentFocus);
  while (nextFocus) {
    // Prevent infinite loop.
    if (nextFocus === list.firstChild) {
      if (wrappedOnce) {
        return;
      }
      wrappedOnce = true;
    }

    // Same logic as useAutocomplete.js
    const nextFocusDisabled = nextFocus.disabled || nextFocus.getAttribute('aria-disabled') === 'true';
    if (!nextFocus.hasAttribute('tabindex') || nextFocusDisabled) {
      // Move to the next element.
      nextFocus = traversalFunction(list, nextFocus);
    } else {
      nextFocus.focus();
      return;
    }
  }
};
const useUtilityClasses$j = ownerState => {
  const {
    vertical,
    fixed,
    hideScrollbar,
    scrollableX,
    scrollableY,
    centered,
    scrollButtonsHideMobile,
    classes
  } = ownerState;
  const slots = {
    root: ['root', vertical && 'vertical'],
    scroller: ['scroller', fixed && 'fixed', hideScrollbar && 'hideScrollbar', scrollableX && 'scrollableX', scrollableY && 'scrollableY'],
    flexContainer: ['flexContainer', vertical && 'flexContainerVertical', centered && 'centered'],
    indicator: ['indicator'],
    scrollButtons: ['scrollButtons', scrollButtonsHideMobile && 'scrollButtonsHideMobile'],
    scrollableX: [scrollableX && 'scrollableX'],
    hideScrollbar: [hideScrollbar && 'hideScrollbar']
  };
  return composeClasses(slots, getTabsUtilityClass, classes);
};
const TabsRoot = styled$1('div', {
  name: 'MuiTabs',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [{
      [`& .${tabsClasses$1.scrollButtons}`]: styles.scrollButtons
    }, {
      [`& .${tabsClasses$1.scrollButtons}`]: ownerState.scrollButtonsHideMobile && styles.scrollButtonsHideMobile
    }, styles.root, ownerState.vertical && styles.vertical];
  }
})(({
  ownerState,
  theme
}) => _extends$1({
  overflow: 'hidden',
  minHeight: 48,
  // Add iOS momentum scrolling for iOS < 13.0
  WebkitOverflowScrolling: 'touch',
  display: 'flex'
}, ownerState.vertical && {
  flexDirection: 'column'
}, ownerState.scrollButtonsHideMobile && {
  [`& .${tabsClasses$1.scrollButtons}`]: {
    [theme.breakpoints.down('sm')]: {
      display: 'none'
    }
  }
}));
const TabsScroller = styled$1('div', {
  name: 'MuiTabs',
  slot: 'Scroller',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.scroller, ownerState.fixed && styles.fixed, ownerState.hideScrollbar && styles.hideScrollbar, ownerState.scrollableX && styles.scrollableX, ownerState.scrollableY && styles.scrollableY];
  }
})(({
  ownerState
}) => _extends$1({
  position: 'relative',
  display: 'inline-block',
  flex: '1 1 auto',
  whiteSpace: 'nowrap'
}, ownerState.fixed && {
  overflowX: 'hidden',
  width: '100%'
}, ownerState.hideScrollbar && {
  // Hide dimensionless scrollbar on macOS
  scrollbarWidth: 'none',
  // Firefox
  '&::-webkit-scrollbar': {
    display: 'none' // Safari + Chrome
  }
}, ownerState.scrollableX && {
  overflowX: 'auto',
  overflowY: 'hidden'
}, ownerState.scrollableY && {
  overflowY: 'auto',
  overflowX: 'hidden'
}));
const FlexContainer = styled$1('div', {
  name: 'MuiTabs',
  slot: 'FlexContainer',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.flexContainer, ownerState.vertical && styles.flexContainerVertical, ownerState.centered && styles.centered];
  }
})(({
  ownerState
}) => _extends$1({
  display: 'flex'
}, ownerState.vertical && {
  flexDirection: 'column'
}, ownerState.centered && {
  justifyContent: 'center'
}));
const TabsIndicator = styled$1('span', {
  name: 'MuiTabs',
  slot: 'Indicator',
  overridesResolver: (props, styles) => styles.indicator
})(({
  ownerState,
  theme
}) => _extends$1({
  position: 'absolute',
  height: 2,
  bottom: 0,
  width: '100%',
  transition: theme.transitions.create()
}, ownerState.indicatorColor === 'primary' && {
  backgroundColor: (theme.vars || theme).palette.primary.main
}, ownerState.indicatorColor === 'secondary' && {
  backgroundColor: (theme.vars || theme).palette.secondary.main
}, ownerState.vertical && {
  height: '100%',
  width: 2,
  right: 0
}));
const TabsScrollbarSize = styled$1(ScrollbarSize, {
  name: 'MuiTabs',
  slot: 'ScrollbarSize'
})({
  overflowX: 'auto',
  overflowY: 'hidden',
  // Hide dimensionless scrollbar on macOS
  scrollbarWidth: 'none',
  // Firefox
  '&::-webkit-scrollbar': {
    display: 'none' // Safari + Chrome
  }
});

const defaultIndicatorStyle = {};
let warnedOnceTabPresent = false;
const Tabs$1 = /*#__PURE__*/React__namespace.forwardRef(function Tabs(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTabs'
  });
  const theme = useTheme$1();
  const isRtl = theme.direction === 'rtl';
  const {
      'aria-label': ariaLabel,
      'aria-labelledby': ariaLabelledBy,
      action,
      centered = false,
      children: childrenProp,
      className,
      component = 'div',
      allowScrollButtonsMobile = false,
      indicatorColor = 'primary',
      onChange,
      orientation = 'horizontal',
      ScrollButtonComponent = TabScrollButton$1,
      scrollButtons = 'auto',
      selectionFollowsFocus,
      TabIndicatorProps = {},
      TabScrollButtonProps = {},
      textColor = 'primary',
      value,
      variant = 'standard',
      visibleScrollbar = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$C);
  const scrollable = variant === 'scrollable';
  const vertical = orientation === 'vertical';
  const scrollStart = vertical ? 'scrollTop' : 'scrollLeft';
  const start = vertical ? 'top' : 'left';
  const end = vertical ? 'bottom' : 'right';
  const clientSize = vertical ? 'clientHeight' : 'clientWidth';
  const size = vertical ? 'height' : 'width';
  const ownerState = _extends$1({}, props, {
    component,
    allowScrollButtonsMobile,
    indicatorColor,
    orientation,
    vertical,
    scrollButtons,
    textColor,
    variant,
    visibleScrollbar,
    fixed: !scrollable,
    hideScrollbar: scrollable && !visibleScrollbar,
    scrollableX: scrollable && !vertical,
    scrollableY: scrollable && vertical,
    centered: centered && !scrollable,
    scrollButtonsHideMobile: !allowScrollButtonsMobile
  });
  const classes = useUtilityClasses$j(ownerState);
  if (browser$1.env.NODE_ENV !== 'production') {
    if (centered && scrollable) {
      console.error('MUI: You can not use the `centered={true}` and `variant="scrollable"` properties ' + 'at the same time on a `Tabs` component.');
    }
  }
  const [mounted, setMounted] = React__namespace.useState(false);
  const [indicatorStyle, setIndicatorStyle] = React__namespace.useState(defaultIndicatorStyle);
  const [displayScroll, setDisplayScroll] = React__namespace.useState({
    start: false,
    end: false
  });
  const [scrollerStyle, setScrollerStyle] = React__namespace.useState({
    overflow: 'hidden',
    scrollbarWidth: 0
  });
  const valueToIndex = new Map();
  const tabsRef = React__namespace.useRef(null);
  const tabListRef = React__namespace.useRef(null);
  const getTabsMeta = () => {
    const tabsNode = tabsRef.current;
    let tabsMeta;
    if (tabsNode) {
      const rect = tabsNode.getBoundingClientRect();
      // create a new object with ClientRect class props + scrollLeft
      tabsMeta = {
        clientWidth: tabsNode.clientWidth,
        scrollLeft: tabsNode.scrollLeft,
        scrollTop: tabsNode.scrollTop,
        scrollLeftNormalized: getNormalizedScrollLeft(tabsNode, theme.direction),
        scrollWidth: tabsNode.scrollWidth,
        top: rect.top,
        bottom: rect.bottom,
        left: rect.left,
        right: rect.right
      };
    }
    let tabMeta;
    if (tabsNode && value !== false) {
      const children = tabListRef.current.children;
      if (children.length > 0) {
        const tab = children[valueToIndex.get(value)];
        if (browser$1.env.NODE_ENV !== 'production') {
          if (!tab) {
            console.error([`MUI: The \`value\` provided to the Tabs component is invalid.`, `None of the Tabs' children match with "${value}".`, valueToIndex.keys ? `You can provide one of the following values: ${Array.from(valueToIndex.keys()).join(', ')}.` : null].join('\n'));
          }
        }
        tabMeta = tab ? tab.getBoundingClientRect() : null;
        if (browser$1.env.NODE_ENV !== 'production') {
          if (browser$1.env.NODE_ENV !== 'test' && !warnedOnceTabPresent && tabMeta && tabMeta.width === 0 && tabMeta.height === 0 &&
          // if the whole Tabs component is hidden, don't warn
          tabsMeta.clientWidth !== 0) {
            tabsMeta = null;
            console.error(['MUI: The `value` provided to the Tabs component is invalid.', `The Tab with this \`value\` ("${value}") is not part of the document layout.`, "Make sure the tab item is present in the document or that it's not `display: none`."].join('\n'));
            warnedOnceTabPresent = true;
          }
        }
      }
    }
    return {
      tabsMeta,
      tabMeta
    };
  };
  const updateIndicatorState = useEventCallback(() => {
    const {
      tabsMeta,
      tabMeta
    } = getTabsMeta();
    let startValue = 0;
    let startIndicator;
    if (vertical) {
      startIndicator = 'top';
      if (tabMeta && tabsMeta) {
        startValue = tabMeta.top - tabsMeta.top + tabsMeta.scrollTop;
      }
    } else {
      startIndicator = isRtl ? 'right' : 'left';
      if (tabMeta && tabsMeta) {
        const correction = isRtl ? tabsMeta.scrollLeftNormalized + tabsMeta.clientWidth - tabsMeta.scrollWidth : tabsMeta.scrollLeft;
        startValue = (isRtl ? -1 : 1) * (tabMeta[startIndicator] - tabsMeta[startIndicator] + correction);
      }
    }
    const newIndicatorStyle = {
      [startIndicator]: startValue,
      // May be wrong until the font is loaded.
      [size]: tabMeta ? tabMeta[size] : 0
    };

    // IE11 support, replace with Number.isNaN
    // eslint-disable-next-line no-restricted-globals
    if (isNaN(indicatorStyle[startIndicator]) || isNaN(indicatorStyle[size])) {
      setIndicatorStyle(newIndicatorStyle);
    } else {
      const dStart = Math.abs(indicatorStyle[startIndicator] - newIndicatorStyle[startIndicator]);
      const dSize = Math.abs(indicatorStyle[size] - newIndicatorStyle[size]);
      if (dStart >= 1 || dSize >= 1) {
        setIndicatorStyle(newIndicatorStyle);
      }
    }
  });
  const scroll = (scrollValue, {
    animation = true
  } = {}) => {
    if (animation) {
      animate(scrollStart, tabsRef.current, scrollValue, {
        duration: theme.transitions.duration.standard
      });
    } else {
      tabsRef.current[scrollStart] = scrollValue;
    }
  };
  const moveTabsScroll = delta => {
    let scrollValue = tabsRef.current[scrollStart];
    if (vertical) {
      scrollValue += delta;
    } else {
      scrollValue += delta * (isRtl ? -1 : 1);
      // Fix for Edge
      scrollValue *= isRtl && detectScrollType() === 'reverse' ? -1 : 1;
    }
    scroll(scrollValue);
  };
  const getScrollSize = () => {
    const containerSize = tabsRef.current[clientSize];
    let totalSize = 0;
    const children = Array.from(tabListRef.current.children);
    for (let i = 0; i < children.length; i += 1) {
      const tab = children[i];
      if (totalSize + tab[clientSize] > containerSize) {
        // If the first item is longer than the container size, then only scroll
        // by the container size.
        if (i === 0) {
          totalSize = containerSize;
        }
        break;
      }
      totalSize += tab[clientSize];
    }
    return totalSize;
  };
  const handleStartScrollClick = () => {
    moveTabsScroll(-1 * getScrollSize());
  };
  const handleEndScrollClick = () => {
    moveTabsScroll(getScrollSize());
  };

  // TODO Remove <ScrollbarSize /> as browser support for hidding the scrollbar
  // with CSS improves.
  const handleScrollbarSizeChange = React__namespace.useCallback(scrollbarWidth => {
    setScrollerStyle({
      overflow: null,
      scrollbarWidth
    });
  }, []);
  const getConditionalElements = () => {
    const conditionalElements = {};
    conditionalElements.scrollbarSizeListener = scrollable ? /*#__PURE__*/jsxRuntimeExports.jsx(TabsScrollbarSize, {
      onChange: handleScrollbarSizeChange,
      className: clsx(classes.scrollableX, classes.hideScrollbar)
    }) : null;
    const scrollButtonsActive = displayScroll.start || displayScroll.end;
    const showScrollButtons = scrollable && (scrollButtons === 'auto' && scrollButtonsActive || scrollButtons === true);
    conditionalElements.scrollButtonStart = showScrollButtons ? /*#__PURE__*/jsxRuntimeExports.jsx(ScrollButtonComponent, _extends$1({
      orientation: orientation,
      direction: isRtl ? 'right' : 'left',
      onClick: handleStartScrollClick,
      disabled: !displayScroll.start
    }, TabScrollButtonProps, {
      className: clsx(classes.scrollButtons, TabScrollButtonProps.className)
    })) : null;
    conditionalElements.scrollButtonEnd = showScrollButtons ? /*#__PURE__*/jsxRuntimeExports.jsx(ScrollButtonComponent, _extends$1({
      orientation: orientation,
      direction: isRtl ? 'left' : 'right',
      onClick: handleEndScrollClick,
      disabled: !displayScroll.end
    }, TabScrollButtonProps, {
      className: clsx(classes.scrollButtons, TabScrollButtonProps.className)
    })) : null;
    return conditionalElements;
  };
  const scrollSelectedIntoView = useEventCallback(animation => {
    const {
      tabsMeta,
      tabMeta
    } = getTabsMeta();
    if (!tabMeta || !tabsMeta) {
      return;
    }
    if (tabMeta[start] < tabsMeta[start]) {
      // left side of button is out of view
      const nextScrollStart = tabsMeta[scrollStart] + (tabMeta[start] - tabsMeta[start]);
      scroll(nextScrollStart, {
        animation
      });
    } else if (tabMeta[end] > tabsMeta[end]) {
      // right side of button is out of view
      const nextScrollStart = tabsMeta[scrollStart] + (tabMeta[end] - tabsMeta[end]);
      scroll(nextScrollStart, {
        animation
      });
    }
  });
  const updateScrollButtonState = useEventCallback(() => {
    if (scrollable && scrollButtons !== false) {
      const {
        scrollTop,
        scrollHeight,
        clientHeight,
        scrollWidth,
        clientWidth
      } = tabsRef.current;
      let showStartScroll;
      let showEndScroll;
      if (vertical) {
        showStartScroll = scrollTop > 1;
        showEndScroll = scrollTop < scrollHeight - clientHeight - 1;
      } else {
        const scrollLeft = getNormalizedScrollLeft(tabsRef.current, theme.direction);
        // use 1 for the potential rounding error with browser zooms.
        showStartScroll = isRtl ? scrollLeft < scrollWidth - clientWidth - 1 : scrollLeft > 1;
        showEndScroll = !isRtl ? scrollLeft < scrollWidth - clientWidth - 1 : scrollLeft > 1;
      }
      if (showStartScroll !== displayScroll.start || showEndScroll !== displayScroll.end) {
        setDisplayScroll({
          start: showStartScroll,
          end: showEndScroll
        });
      }
    }
  });
  React__namespace.useEffect(() => {
    const handleResize = debounce$1(() => {
      // If the Tabs component is replaced by Suspense with a fallback, the last
      // ResizeObserver's handler that runs because of the change in the layout is trying to
      // access a dom node that is no longer there (as the fallback component is being shown instead).
      // See https://github.com/mui/material-ui/issues/33276
      // TODO: Add tests that will ensure the component is not failing when
      // replaced by Suspense with a fallback, once React is updated to version 18
      if (tabsRef.current) {
        updateIndicatorState();
        updateScrollButtonState();
      }
    });
    const win = ownerWindow(tabsRef.current);
    win.addEventListener('resize', handleResize);
    let resizeObserver;
    if (typeof ResizeObserver !== 'undefined') {
      resizeObserver = new ResizeObserver(handleResize);
      Array.from(tabListRef.current.children).forEach(child => {
        resizeObserver.observe(child);
      });
    }
    return () => {
      handleResize.clear();
      win.removeEventListener('resize', handleResize);
      if (resizeObserver) {
        resizeObserver.disconnect();
      }
    };
  }, [updateIndicatorState, updateScrollButtonState]);
  const handleTabsScroll = React__namespace.useMemo(() => debounce$1(() => {
    updateScrollButtonState();
  }), [updateScrollButtonState]);
  React__namespace.useEffect(() => {
    return () => {
      handleTabsScroll.clear();
    };
  }, [handleTabsScroll]);
  React__namespace.useEffect(() => {
    setMounted(true);
  }, []);
  React__namespace.useEffect(() => {
    updateIndicatorState();
    updateScrollButtonState();
  });
  React__namespace.useEffect(() => {
    // Don't animate on the first render.
    scrollSelectedIntoView(defaultIndicatorStyle !== indicatorStyle);
  }, [scrollSelectedIntoView, indicatorStyle]);
  React__namespace.useImperativeHandle(action, () => ({
    updateIndicator: updateIndicatorState,
    updateScrollButtons: updateScrollButtonState
  }), [updateIndicatorState, updateScrollButtonState]);
  const indicator = /*#__PURE__*/jsxRuntimeExports.jsx(TabsIndicator, _extends$1({}, TabIndicatorProps, {
    className: clsx(classes.indicator, TabIndicatorProps.className),
    ownerState: ownerState,
    style: _extends$1({}, indicatorStyle, TabIndicatorProps.style)
  }));
  let childIndex = 0;
  const children = React__namespace.Children.map(childrenProp, child => {
    if (! /*#__PURE__*/React__namespace.isValidElement(child)) {
      return null;
    }
    if (browser$1.env.NODE_ENV !== 'production') {
      if (reactIsExports.isFragment(child)) {
        console.error(["MUI: The Tabs component doesn't accept a Fragment as a child.", 'Consider providing an array instead.'].join('\n'));
      }
    }
    const childValue = child.props.value === undefined ? childIndex : child.props.value;
    valueToIndex.set(childValue, childIndex);
    const selected = childValue === value;
    childIndex += 1;
    return /*#__PURE__*/React__namespace.cloneElement(child, _extends$1({
      fullWidth: variant === 'fullWidth',
      indicator: selected && !mounted && indicator,
      selected,
      selectionFollowsFocus,
      onChange,
      textColor,
      value: childValue
    }, childIndex === 1 && value === false && !child.props.tabIndex ? {
      tabIndex: 0
    } : {}));
  });
  const handleKeyDown = event => {
    const list = tabListRef.current;
    const currentFocus = ownerDocument(list).activeElement;
    // Keyboard navigation assumes that [role="tab"] are siblings
    // though we might warn in the future about nested, interactive elements
    // as a a11y violation
    const role = currentFocus.getAttribute('role');
    if (role !== 'tab') {
      return;
    }
    let previousItemKey = orientation === 'horizontal' ? 'ArrowLeft' : 'ArrowUp';
    let nextItemKey = orientation === 'horizontal' ? 'ArrowRight' : 'ArrowDown';
    if (orientation === 'horizontal' && isRtl) {
      // swap previousItemKey with nextItemKey
      previousItemKey = 'ArrowRight';
      nextItemKey = 'ArrowLeft';
    }
    switch (event.key) {
      case previousItemKey:
        event.preventDefault();
        moveFocus(list, currentFocus, previousItem);
        break;
      case nextItemKey:
        event.preventDefault();
        moveFocus(list, currentFocus, nextItem);
        break;
      case 'Home':
        event.preventDefault();
        moveFocus(list, null, nextItem);
        break;
      case 'End':
        event.preventDefault();
        moveFocus(list, null, previousItem);
        break;
    }
  };
  const conditionalElements = getConditionalElements();
  return /*#__PURE__*/jsxRuntimeExports.jsxs(TabsRoot, _extends$1({
    className: clsx(classes.root, className),
    ownerState: ownerState,
    ref: ref,
    as: component
  }, other, {
    children: [conditionalElements.scrollButtonStart, conditionalElements.scrollbarSizeListener, /*#__PURE__*/jsxRuntimeExports.jsxs(TabsScroller, {
      className: classes.scroller,
      ownerState: ownerState,
      style: {
        overflow: scrollerStyle.overflow,
        [vertical ? `margin${isRtl ? 'Left' : 'Right'}` : 'marginBottom']: visibleScrollbar ? undefined : -scrollerStyle.scrollbarWidth
      },
      ref: tabsRef,
      onScroll: handleTabsScroll,
      children: [/*#__PURE__*/jsxRuntimeExports.jsx(FlexContainer, {
        "aria-label": ariaLabel,
        "aria-labelledby": ariaLabelledBy,
        "aria-orientation": orientation === 'vertical' ? 'vertical' : null,
        className: classes.flexContainer,
        ownerState: ownerState,
        onKeyDown: handleKeyDown,
        ref: tabListRef,
        role: "tablist",
        children: children
      }), mounted && indicator]
    }), conditionalElements.scrollButtonEnd]
  }));
});
browser$1.env.NODE_ENV !== "production" ? Tabs$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Callback fired when the component mounts.
   * This is useful when you want to trigger an action programmatically.
   * It supports two actions: `updateIndicator()` and `updateScrollButtons()`
   *
   * @param {object} actions This object contains all possible actions
   * that can be triggered programmatically.
   */
  action: refType$1,
  /**
   * If `true`, the scroll buttons aren't forced hidden on mobile.
   * By default the scroll buttons are hidden on mobile and takes precedence over `scrollButtons`.
   * @default false
   */
  allowScrollButtonsMobile: propTypesExports.bool,
  /**
   * The label for the Tabs as a string.
   */
  'aria-label': propTypesExports.string,
  /**
   * An id or list of ids separated by a space that label the Tabs.
   */
  'aria-labelledby': propTypesExports.string,
  /**
   * If `true`, the tabs are centered.
   * This prop is intended for large views.
   * @default false
   */
  centered: propTypesExports.bool,
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * Determines the color of the indicator.
   * @default 'primary'
   */
  indicatorColor: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['primary', 'secondary']), propTypesExports.string]),
  /**
   * Callback fired when the value changes.
   *
   * @param {React.SyntheticEvent} event The event source of the callback. **Warning**: This is a generic event not a change event.
   * @param {any} value We default to the index of the child (number)
   */
  onChange: propTypesExports.func,
  /**
   * The component orientation (layout flow direction).
   * @default 'horizontal'
   */
  orientation: propTypesExports.oneOf(['horizontal', 'vertical']),
  /**
   * The component used to render the scroll buttons.
   * @default TabScrollButton
   */
  ScrollButtonComponent: propTypesExports.elementType,
  /**
   * Determine behavior of scroll buttons when tabs are set to scroll:
   *
   * - `auto` will only present them when not all the items are visible.
   * - `true` will always present them.
   * - `false` will never present them.
   *
   * By default the scroll buttons are hidden on mobile.
   * This behavior can be disabled with `allowScrollButtonsMobile`.
   * @default 'auto'
   */
  scrollButtons: propTypesExports /* @typescript-to-proptypes-ignore */.oneOf(['auto', false, true]),
  /**
   * If `true` the selected tab changes on focus. Otherwise it only
   * changes on activation.
   */
  selectionFollowsFocus: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Props applied to the tab indicator element.
   * @default  {}
   */
  TabIndicatorProps: propTypesExports.object,
  /**
   * Props applied to the [`TabScrollButton`](/material-ui/api/tab-scroll-button/) element.
   * @default {}
   */
  TabScrollButtonProps: propTypesExports.object,
  /**
   * Determines the color of the `Tab`.
   * @default 'primary'
   */
  textColor: propTypesExports.oneOf(['inherit', 'primary', 'secondary']),
  /**
   * The value of the currently selected `Tab`.
   * If you don't want any selected `Tab`, you can set this prop to `false`.
   */
  value: propTypesExports.any,
  /**
   * Determines additional display behavior of the tabs:
   *
   *  - `scrollable` will invoke scrolling properties and allow for horizontally
   *  scrolling (or swiping) of the tab bar.
   *  -`fullWidth` will make the tabs grow to use all the available space,
   *  which should be used for small views, like on mobile.
   *  - `standard` will render the default state.
   * @default 'standard'
   */
  variant: propTypesExports.oneOf(['fullWidth', 'scrollable', 'standard']),
  /**
   * If `true`, the scrollbar is visible. It can be useful when displaying
   * a long vertical list of tabs.
   * @default false
   */
  visibleScrollbar: propTypesExports.bool
} : void 0;
var TabsOg = Tabs$1;

var TabsHeader$1 = styled__default.default(TabsOg)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: "flex",
    marginBottom: "0.5rem",
    flex: 1,
    borderBottom: "1px solid ".concat(theme.palette.card.divider)
  };
});
var Tab = styled__default.default(TabOg, {
  shouldForwardProp: function shouldForwardProp(prop) {
    return prop !== "narrow";
  }
})(function (_ref2) {
  var theme = _ref2.theme,
    narrow = _ref2.narrow;
  return {
    padding: 25,
    flexGrow: narrow ? 0 : 1,
    height: "4rem",
    alignSelf: "center",
    fontFamily: theme.typography.h5.fontFamily,
    textTransform: "capitalize",
    fontSize: theme.typography.h5.fontSize,
    "&[aria-selected=true]": {
      color: theme.palette.primary.main
    }
  };
});

var TabsContext = /*#__PURE__*/React.createContext();
var useTabs = function useTabs() {
  return React.useContext(TabsContext);
};
function TabsProvider(_ref) {
  var tabs = _ref.tabs,
    prefix = _ref.prefix,
    narrowTabs = _ref.narrowTabs,
    shouldDisableTabs = _ref.shouldDisableTabs,
    shouldHideTabsHeader = _ref.shouldHideTabsHeader,
    shouldClearQueryOnUnmount = _ref.shouldClearQueryOnUnmount,
    currentTabIndexOverride = _ref.currentTabIndexOverride,
    children = _ref.children;
  var history = reactRouterDom.useHistory();
  var location = useLocationQuery();
  var queryStringKey = getQueryStringKey(prefix);
  var currentTab = getCurrentTab({
    tabs: tabs,
    queryStringKey: queryStringKey,
    currentTabIndexOverride: currentTabIndexOverride,
    location: location
  });
  var getTabQueryString = function getTabQueryString(tab) {
    return mergeSearchParams({
      key: queryStringKey,
      value: tab,
      location: location
    });
  };
  var removeTabFromQueryString = function removeTabFromQueryString() {
    removeTabSearchParam({
      shouldClearQueryOnUnmount: shouldClearQueryOnUnmount,
      queryStringKey: queryStringKey,
      location: location,
      history: history
    });
  };
  return /*#__PURE__*/React__namespace.default.createElement(TabsContext.Provider, {
    value: {
      tabs: tabs,
      getTabQueryString: getTabQueryString,
      removeTabFromQueryString: removeTabFromQueryString,
      currentTab: currentTab,
      narrowTabs: narrowTabs,
      shouldDisableTabs: shouldDisableTabs,
      shouldHideTabsHeader: shouldHideTabsHeader
    }
  }, children);
}
function getCurrentTab(_ref2) {
  var tabs = _ref2.tabs,
    queryStringKey = _ref2.queryStringKey,
    currentTabIndexOverride = _ref2.currentTabIndexOverride,
    location = _ref2.location;
  if (tabs[currentTabIndexOverride]) {
    return tabs[currentTabIndexOverride];
  }
  var currentTab = location[queryStringKey];
  return currentTab || tabs[0];
}
function getQueryStringKey(prefix) {
  return "".concat(prefix, "tab");
}
function removeTabSearchParam(_ref3) {
  var shouldClearQueryOnUnmount = _ref3.shouldClearQueryOnUnmount,
    queryStringKey = _ref3.queryStringKey,
    location = _ref3.location,
    history = _ref3.history;
  if (!shouldClearQueryOnUnmount) return;
  var queryString = removeSearchParam({
    key: queryStringKey,
    location: location
  });
  history.replace({
    search: queryString
  });
}
TabsProvider.propTypes = {
  prefix: propTypesExports.string,
  tabs: propTypesExports.arrayOf(propTypesExports.string),
  narrowTabs: propTypesExports.bool,
  shouldDisableTabs: propTypesExports.bool,
  shouldHideTabsHeader: propTypesExports.bool,
  shouldClearQueryOnUnmount: propTypesExports.bool,
  currentTabIndexOverride: propTypesExports.number,
  children: propTypesExports.any.isRequired
};

var TABS_VARIANT = "scrollable";
function TabsHeader(_ref) {
  var className = _ref.className;
  var _useTabs = useTabs(),
    getTabQueryString = _useTabs.getTabQueryString,
    removeTabFromQueryString = _useTabs.removeTabFromQueryString,
    currentTab = _useTabs.currentTab,
    tabs = _useTabs.tabs,
    narrowTabs = _useTabs.narrowTabs,
    shouldDisableTabs = _useTabs.shouldDisableTabs,
    shouldHideTabsHeader = _useTabs.shouldHideTabsHeader;
  var onUnmount = function onUnmount() {
    return removeTabFromQueryString();
  };
  React.useEffect(function () {
    return onUnmount;
  }, []);
  if (shouldDisableTabs || shouldHideTabsHeader) return null;
  return /*#__PURE__*/React__namespace.default.createElement(TabsHeader$1, {
    className: className,
    variant: TABS_VARIANT,
    value: currentTab
  }, tabs.map(function (tab) {
    return /*#__PURE__*/React__namespace.default.createElement(Tab, {
      narrow: narrowTabs,
      key: tab,
      component: reactRouterDom.Link,
      "data-testid": "tab-".concat(tab),
      label: tab,
      value: tab,
      to: function to(location) {
        return _objectSpread2(_objectSpread2({}, location), {}, {
          search: getTabQueryString(tab)
        });
      }
    });
  }));
}
TabsHeader.propTypes = {
  className: propTypesExports.string
};

// currentTabIndexOverride: optional but if provided it will set the current tab ignoring any query string tab names. This is useful for components like the company payment form which we force navigate to when a customer hasn't set that up or it expired. This prevents the querystring from being a way around tab selection in that case.
// prefix: it must be unique and not overlapping for each tab within a heirarchy of nested Tabs else prefixes will match for multiple tab groups and shit with break
// shouldClearQueryOnUnmount: the FormSubmissionEditorModal relies on keeping the query string param after unmount so we can return to the desired tab when deleting a submission. That's why I made this optional. Any page that has multiple items for which a set of tabs can be shown probably needs this set to true
function Tabs(_ref) {
  var _ref$prefix = _ref.prefix,
    prefix = _ref$prefix === void 0 ? TABS_DEFAULT_PREFIX : _ref$prefix,
    tabs = _ref.tabs,
    children = _ref.children,
    shouldDisableTabs = _ref.shouldDisableTabs,
    shouldHideTabsHeader = _ref.shouldHideTabsHeader,
    shouldClearQueryOnUnmount = _ref.shouldClearQueryOnUnmount,
    narrowTabs = _ref.narrowTabs,
    currentTabIndexOverride = _ref.currentTabIndexOverride;
  return /*#__PURE__*/React__namespace.default.createElement(TabsProvider, {
    tabs: tabs,
    prefix: prefix,
    narrowTabs: narrowTabs,
    shouldDisableTabs: shouldDisableTabs,
    shouldHideTabsHeader: shouldHideTabsHeader,
    shouldClearQueryOnUnmount: shouldClearQueryOnUnmount,
    currentTabIndexOverride: currentTabIndexOverride
  }, /*#__PURE__*/React__namespace.default.createElement(TabsHeader, null), libCommon.compact(children).map(function (child, idx) {
    return /*#__PURE__*/React__namespace.default.createElement(TabPanel, {
      tab: tabs[idx],
      key: tabs[idx]
    }, child);
  }));
}
Tabs.propTypes = {
  prefix: propTypesExports.string,
  tabs: propTypesExports.arrayOf(propTypesExports.string),
  children: propTypesExports.arrayOf(propTypesExports.any),
  shouldDisableTabs: propTypesExports.bool,
  shouldHideTabsHeader: propTypesExports.bool,
  shouldClearQueryOnUnmount: propTypesExports.bool,
  narrowTabs: propTypesExports.bool,
  currentTabIndexOverride: propTypesExports.number
};

// Tab panel

function TabPanel(_ref2) {
  var children = _ref2.children,
    tab = _ref2.tab;
  var _useTabs = useTabs(),
    currentTab = _useTabs.currentTab,
    shouldDisableTabs = _useTabs.shouldDisableTabs;
  var shouldShowTabPanel = currentTab === tab || shouldDisableTabs;
  return shouldShowTabPanel ? children : null;
}
TabPanel.propTypes = {
  children: propTypesExports.any,
  tab: propTypesExports.string
};

var _excluded$B = ["key"];
var UNOPENED_USERS_KEY = "unopened_users";
var OPENED_USERS_KEY = "opened_users";
var TAB_PREFIX = "resend_";
function BulletinPostDetailsUserViews(_ref) {
  var bulletinPostId = _ref.bulletinPostId;
  var _useBulletinPosts = useBulletinPosts(),
    useBulletinPostUserViews = _useBulletinPosts.useBulletinPostUserViews,
    isMutationLoading = _useBulletinPosts.isMutationLoading,
    resendNotifications = _useBulletinPosts.resendNotifications,
    entityId = _useBulletinPosts.entityId,
    entityType = _useBulletinPosts.entityType;
  var _useBulletinPostUserV = useBulletinPostUserViews({
      bulletinPostId: bulletinPostId,
      entityId: entityId,
      entityType: entityType
    }),
    isLoading = _useBulletinPostUserV.isLoading,
    error = _useBulletinPostUserV.error,
    users = _useBulletinPostUserV.users;
  if (isLoading) return /*#__PURE__*/React__namespace.default.createElement(BulletinPostDetailsUserViewsSkeleton, null);
  if (error) return /*#__PURE__*/React__namespace.default.createElement(ErrorMessage, {
    error: error
  });
  var userViewsConfigs = getUserViewsConfigs({
    bulletinPostId: bulletinPostId,
    users: users,
    resendNotifications: resendNotifications,
    isMutationLoading: isMutationLoading
  });
  return /*#__PURE__*/React__namespace.default.createElement(Column, null, /*#__PURE__*/React__namespace.default.createElement(Tabs, {
    prefix: TAB_PREFIX,
    tabs: getTabs(users),
    narrowTabs: true,
    shouldClearQueryOnUnmount: true
  }, userViewsConfigs.map(function (_ref2) {
    var key = _ref2.key,
      userViewConfig = _objectWithoutProperties(_ref2, _excluded$B);
    return /*#__PURE__*/React__namespace.default.createElement(BulletinPostDetailsUserViewsList, _extends$2({
      key: key
    }, userViewConfig));
  })));
}
BulletinPostDetailsUserViews.propTypes = {
  bulletinPostId: propTypesExports.string
};
var Column = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "column"
  };
});
function getTabs(users) {
  var totalUnviewed = users.unviewed.length;
  var totalViewed = users.viewed.length;
  return ["Unopened (".concat(totalUnviewed, ")"), "Opened (".concat(totalViewed, ")")];
}
function getUserViewsConfigs(_ref3) {
  var bulletinPostId = _ref3.bulletinPostId,
    users = _ref3.users,
    resendNotifications = _ref3.resendNotifications,
    isMutationLoading = _ref3.isMutationLoading;
  var sharedConfig = {
    onResendNotificationsClick: resendNotifications,
    isMutationLoading: isMutationLoading
  };
  return [_objectSpread2(_objectSpread2({
    key: UNOPENED_USERS_KEY,
    bulletinPostId: bulletinPostId,
    users: users.unviewed,
    emptyStateMessage: BULLETIN_POST_VIEWS_EMPTY_STATE.UNVIEWED
  }, sharedConfig), getUserListProps()), _objectSpread2(_objectSpread2({
    key: OPENED_USERS_KEY,
    bulletinPostId: bulletinPostId,
    users: users.viewed,
    emptyStateMessage: BULLETIN_POST_VIEWS_EMPTY_STATE.VIEWED
  }, sharedConfig), getUserListProps({
    isUsersThatViewed: true
  }))];
}
function getUserListProps() {
  var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    isUsersThatViewed = _ref4.isUsersThatViewed;
  var usersType = isUsersThatViewed ? "opened" : "unopened";
  var resendButtonTitle = "Remind ".concat(usersType);
  var confirmationMessage = "Are you sure you want to remind all ".concat(usersType, "?");
  return {
    resendButtonTitle: resendButtonTitle,
    confirmationMessage: confirmationMessage
  };
}

function BulletinPostDetailsModal(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    post = _ref.post;
  return /*#__PURE__*/React__namespace.default.createElement(Modal, {
    isOpen: isOpen,
    onClose: onClose
  }, /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "h5"
  }, "Post Views"), /*#__PURE__*/React__namespace.default.createElement(ModalContent$1, null, /*#__PURE__*/React__namespace.default.createElement(PostBox, null, post.content), /*#__PURE__*/React__namespace.default.createElement(BulletinPostDetailsUserViews, {
    bulletinPostId: post.id
  }), /*#__PURE__*/React__namespace.default.createElement(ButtonContainer$3, null, /*#__PURE__*/React__namespace.default.createElement(Button, {
    variant: "contained",
    onClick: onClose
  }, "Done"))));
}
BulletinPostDetailsModal.propTypes = {
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  post: propTypesExports.object
};
var ModalContent$1 = styled__default.default(Box$3)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: "flex",
    flexDirection: "column",
    width: "100%",
    paddingTop: theme.spacing(2)
  };
});
var PostBox = styled__default.default(Box$3)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    backgroundColor: theme.palette.background.paper,
    borderRadius: theme.borderRadius.sm,
    padding: theme.spacing(3)
  };
});
var ButtonContainer$3 = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    justifyContent: "flex-end",
    variant: "contained"
  };
});

var VisibilityOutlined = {};

var _interopRequireDefault$B = interopRequireDefaultExports;
Object.defineProperty(VisibilityOutlined, "__esModule", {
  value: true
});
var default_1$B = VisibilityOutlined.default = void 0;
var _createSvgIcon$B = _interopRequireDefault$B(requireCreateSvgIcon());
var _jsxRuntime$B = requireJsxRuntime();
var _default$B = (0, _createSvgIcon$B.default)( /*#__PURE__*/(0, _jsxRuntime$B.jsx)("path", {
  d: "M12 6c3.79 0 7.17 2.13 8.82 5.5C19.17 14.87 15.79 17 12 17s-7.17-2.13-8.82-5.5C4.83 8.13 8.21 6 12 6m0-2C7 4 2.73 7.11 1 11.5 2.73 15.89 7 19 12 19s9.27-3.11 11-7.5C21.27 7.11 17 4 12 4zm0 5c1.38 0 2.5 1.12 2.5 2.5S13.38 14 12 14s-2.5-1.12-2.5-2.5S10.62 9 12 9m0-2c-2.48 0-4.5 2.02-4.5 4.5S9.52 16 12 16s4.5-2.02 4.5-4.5S14.48 7 12 7z"
}), 'VisibilityOutlined');
default_1$B = VisibilityOutlined.default = _default$B;

function BulletinPostViewCounts(_ref) {
  var post = _ref.post,
    onClick = _ref.onClick;
  var views = post.views,
    totalPossibleViews = post.total_possible_views;

  // If we are rendering this component but have to view data it's loading
  var isLoading = libCommon.isUndefined(views);
  var hasNoPossibleViews = totalPossibleViews === 0;
  if (isLoading) return /*#__PURE__*/React__namespace.default.createElement(ViewsSkeleton, {
    variant: "rectangular"
  });
  return /*#__PURE__*/React__namespace.default.createElement(ViewsContainer, {
    isClickable: hasNoPossibleViews,
    "data-testid": TEST_IDS.BULLETIN_POST_VIEWS,
    onClick: hasNoPossibleViews ? null : onClick
  }, /*#__PURE__*/React__namespace.default.createElement(ViewsIcon, {
    disabled: hasNoPossibleViews
  }), /*#__PURE__*/React__namespace.default.createElement(TotalViews, {
    disabled: hasNoPossibleViews
  }, views, "/", totalPossibleViews));
}
BulletinPostViewCounts.propTypes = {
  post: propTypesExports.shape({
    views: propTypesExports.number,
    total_possible_views: propTypesExports.number
  }),
  onClick: propTypesExports.func.isRequired
};
var ViewsContainer = styled__default.default(Box$1, {
  shouldForwardProp: shouldForwardProp$1
})(function (_ref2) {
  var isClickable = _ref2.isClickable;
  return {
    display: "flex",
    gap: "0.5rem",
    cursor: isClickable ? "default" : "pointer",
    marginTop: "1rem"
  };
});
var ViewsSkeleton = styled__default.default(Skeleton)(function () {
  return {
    width: 60,
    height: 25,
    borderRadius: 8,
    marginTop: "1rem"
  };
});
var TotalViews = styled__default.default(Typography$1, {
  shouldForwardProp: shouldForwardProp$1
})(function (_ref3) {
  var theme = _ref3.theme,
    disabled = _ref3.disabled;
  return {
    color: disabled ? theme.palette.text.grey : theme.palette.primary.main,
    fontSize: theme.typography.body2.fontSize
  };
});
var ViewsIcon = styled__default.default(default_1$B, {
  shouldForwardProp: shouldForwardProp$1
})(function (_ref4) {
  var theme = _ref4.theme,
    disabled = _ref4.disabled;
  return {
    color: disabled ? theme.palette.colors.icon.neutralAlt : theme.palette.primary.main,
    fontSize: theme.typography.body2.iconFontSize
  };
});
function shouldForwardProp$1(prop) {
  return prop !== "isClickable";
}

function BulletinPostViews(_ref) {
  var post = _ref.post;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isModalOpen = _useState2[0],
    setIsModalOpen = _useState2[1];
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(BulletinPostViewCounts, {
    post: post,
    onClick: function onClick() {
      return setIsModalOpen(true);
    }
  }), /*#__PURE__*/React__namespace.default.createElement(BulletinPostDetailsModal, {
    isOpen: isModalOpen,
    onClose: function onClose() {
      return setIsModalOpen(false);
    },
    post: post
  }));
}
BulletinPostViews.propTypes = {
  post: propTypesExports.shape({
    id: propTypesExports.string.isRequired,
    content: propTypesExports.string.isRequired
  })
};

function getSwitchBaseUtilityClass(slot) {
  return generateUtilityClass('PrivateSwitchBase', slot);
}
generateUtilityClasses('PrivateSwitchBase', ['root', 'checked', 'disabled', 'input', 'edgeStart', 'edgeEnd']);

const _excluded$A = ["autoFocus", "checked", "checkedIcon", "className", "defaultChecked", "disabled", "disableFocusRipple", "edge", "icon", "id", "inputProps", "inputRef", "name", "onBlur", "onChange", "onFocus", "readOnly", "required", "tabIndex", "type", "value"];
const useUtilityClasses$i = ownerState => {
  const {
    classes,
    checked,
    disabled,
    edge
  } = ownerState;
  const slots = {
    root: ['root', checked && 'checked', disabled && 'disabled', edge && `edge${capitalize(edge)}`],
    input: ['input']
  };
  return composeClasses(slots, getSwitchBaseUtilityClass, classes);
};
const SwitchBaseRoot = styled$1(ButtonBase$1)(({
  ownerState
}) => _extends$1({
  padding: 9,
  borderRadius: '50%'
}, ownerState.edge === 'start' && {
  marginLeft: ownerState.size === 'small' ? -3 : -12
}, ownerState.edge === 'end' && {
  marginRight: ownerState.size === 'small' ? -3 : -12
}));
const SwitchBaseInput = styled$1('input')({
  cursor: 'inherit',
  position: 'absolute',
  opacity: 0,
  width: '100%',
  height: '100%',
  top: 0,
  left: 0,
  margin: 0,
  padding: 0,
  zIndex: 1
});

/**
 * @ignore - internal component.
 */
const SwitchBase = /*#__PURE__*/React__namespace.forwardRef(function SwitchBase(props, ref) {
  const {
      autoFocus,
      checked: checkedProp,
      checkedIcon,
      className,
      defaultChecked,
      disabled: disabledProp,
      disableFocusRipple = false,
      edge = false,
      icon,
      id,
      inputProps,
      inputRef,
      name,
      onBlur,
      onChange,
      onFocus,
      readOnly,
      required = false,
      tabIndex,
      type,
      value
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$A);
  const [checked, setCheckedState] = useControlled({
    controlled: checkedProp,
    default: Boolean(defaultChecked),
    name: 'SwitchBase',
    state: 'checked'
  });
  const muiFormControl = useFormControl();
  const handleFocus = event => {
    if (onFocus) {
      onFocus(event);
    }
    if (muiFormControl && muiFormControl.onFocus) {
      muiFormControl.onFocus(event);
    }
  };
  const handleBlur = event => {
    if (onBlur) {
      onBlur(event);
    }
    if (muiFormControl && muiFormControl.onBlur) {
      muiFormControl.onBlur(event);
    }
  };
  const handleInputChange = event => {
    // Workaround for https://github.com/facebook/react/issues/9023
    if (event.nativeEvent.defaultPrevented) {
      return;
    }
    const newChecked = event.target.checked;
    setCheckedState(newChecked);
    if (onChange) {
      // TODO v6: remove the second argument.
      onChange(event, newChecked);
    }
  };
  let disabled = disabledProp;
  if (muiFormControl) {
    if (typeof disabled === 'undefined') {
      disabled = muiFormControl.disabled;
    }
  }
  const hasLabelFor = type === 'checkbox' || type === 'radio';
  const ownerState = _extends$1({}, props, {
    checked,
    disabled,
    disableFocusRipple,
    edge
  });
  const classes = useUtilityClasses$i(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(SwitchBaseRoot, _extends$1({
    component: "span",
    className: clsx(classes.root, className),
    centerRipple: true,
    focusRipple: !disableFocusRipple,
    disabled: disabled,
    tabIndex: null,
    role: undefined,
    onFocus: handleFocus,
    onBlur: handleBlur,
    ownerState: ownerState,
    ref: ref
  }, other, {
    children: [/*#__PURE__*/jsxRuntimeExports.jsx(SwitchBaseInput, _extends$1({
      autoFocus: autoFocus,
      checked: checkedProp,
      defaultChecked: defaultChecked,
      className: classes.input,
      disabled: disabled,
      id: hasLabelFor ? id : undefined,
      name: name,
      onChange: handleInputChange,
      readOnly: readOnly,
      ref: inputRef,
      required: required,
      ownerState: ownerState,
      tabIndex: tabIndex,
      type: type
    }, type === 'checkbox' && value === undefined ? {} : {
      value
    }, inputProps)), checked ? checkedIcon : icon]
  }));
});

// NB: If changed, please update Checkbox, Switch and Radio
// so that the API documentation is updated.
browser$1.env.NODE_ENV !== "production" ? SwitchBase.propTypes = {
  /**
   * If `true`, the `input` element is focused during the first mount.
   */
  autoFocus: propTypesExports.bool,
  /**
   * If `true`, the component is checked.
   */
  checked: propTypesExports.bool,
  /**
   * The icon to display when the component is checked.
   */
  checkedIcon: propTypesExports.node.isRequired,
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * @ignore
   */
  defaultChecked: propTypesExports.bool,
  /**
   * If `true`, the component is disabled.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the  keyboard focus ripple is disabled.
   * @default false
   */
  disableFocusRipple: propTypesExports.bool,
  /**
   * If given, uses a negative margin to counteract the padding on one
   * side (this is often helpful for aligning the left or right
   * side of the icon with content above or below, without ruining the border
   * size and shape).
   * @default false
   */
  edge: propTypesExports.oneOf(['end', 'start', false]),
  /**
   * The icon to display when the component is unchecked.
   */
  icon: propTypesExports.node.isRequired,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /*
   * @ignore
   */
  name: propTypesExports.string,
  /**
   * @ignore
   */
  onBlur: propTypesExports.func,
  /**
   * Callback fired when the state is changed.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new checked state by accessing `event.target.checked` (boolean).
   */
  onChange: propTypesExports.func,
  /**
   * @ignore
   */
  onFocus: propTypesExports.func,
  /**
   * It prevents the user from changing the value of the field
   * (not from interacting with the field).
   */
  readOnly: propTypesExports.bool,
  /**
   * If `true`, the `input` element is required.
   */
  required: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.object,
  /**
   * @ignore
   */
  tabIndex: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * The input component prop `type`.
   */
  type: propTypesExports.string.isRequired,
  /**
   * The value of the component.
   */
  value: propTypesExports.any
} : void 0;
var SwitchBase$1 = SwitchBase;

var CheckBoxOutlineBlankIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M19 5v14H5V5h14m0-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2z"
}), 'CheckBoxOutlineBlank');

var CheckBoxIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M19 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.11 0 2-.9 2-2V5c0-1.1-.89-2-2-2zm-9 14l-5-5 1.41-1.41L10 14.17l7.59-7.59L19 8l-9 9z"
}), 'CheckBox');

var IndeterminateCheckBoxIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm-2 10H7v-2h10v2z"
}), 'IndeterminateCheckBox');

function getCheckboxUtilityClass(slot) {
  return generateUtilityClass('MuiCheckbox', slot);
}
const checkboxClasses = generateUtilityClasses('MuiCheckbox', ['root', 'checked', 'disabled', 'indeterminate', 'colorPrimary', 'colorSecondary']);
var checkboxClasses$1 = checkboxClasses;

const _excluded$z = ["checkedIcon", "color", "icon", "indeterminate", "indeterminateIcon", "inputProps", "size", "className"];
const useUtilityClasses$h = ownerState => {
  const {
    classes,
    indeterminate,
    color
  } = ownerState;
  const slots = {
    root: ['root', indeterminate && 'indeterminate', `color${capitalize(color)}`]
  };
  const composedClasses = composeClasses(slots, getCheckboxUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};
const CheckboxRoot = styled$1(SwitchBase$1, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiCheckbox',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.indeterminate && styles.indeterminate, ownerState.color !== 'default' && styles[`color${capitalize(ownerState.color)}`]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  color: (theme.vars || theme).palette.text.secondary
}, !ownerState.disableRipple && {
  '&:hover': {
    backgroundColor: theme.vars ? `rgba(${ownerState.color === 'default' ? theme.vars.palette.action.activeChannel : theme.vars.palette.primary.mainChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(ownerState.color === 'default' ? theme.palette.action.active : theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
    // Reset on touch devices, it doesn't add specificity
    '@media (hover: none)': {
      backgroundColor: 'transparent'
    }
  }
}, ownerState.color !== 'default' && {
  [`&.${checkboxClasses$1.checked}, &.${checkboxClasses$1.indeterminate}`]: {
    color: (theme.vars || theme).palette[ownerState.color].main
  },
  [`&.${checkboxClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.action.disabled
  }
}));
const defaultCheckedIcon$1 = /*#__PURE__*/jsxRuntimeExports.jsx(CheckBoxIcon, {});
const defaultIcon$1 = /*#__PURE__*/jsxRuntimeExports.jsx(CheckBoxOutlineBlankIcon, {});
const defaultIndeterminateIcon = /*#__PURE__*/jsxRuntimeExports.jsx(IndeterminateCheckBoxIcon, {});
const Checkbox = /*#__PURE__*/React__namespace.forwardRef(function Checkbox(inProps, ref) {
  var _icon$props$fontSize, _indeterminateIcon$pr;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiCheckbox'
  });
  const {
      checkedIcon = defaultCheckedIcon$1,
      color = 'primary',
      icon: iconProp = defaultIcon$1,
      indeterminate = false,
      indeterminateIcon: indeterminateIconProp = defaultIndeterminateIcon,
      inputProps,
      size = 'medium',
      className
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$z);
  const icon = indeterminate ? indeterminateIconProp : iconProp;
  const indeterminateIcon = indeterminate ? indeterminateIconProp : checkedIcon;
  const ownerState = _extends$1({}, props, {
    color,
    indeterminate,
    size
  });
  const classes = useUtilityClasses$h(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(CheckboxRoot, _extends$1({
    type: "checkbox",
    inputProps: _extends$1({
      'data-indeterminate': indeterminate
    }, inputProps),
    icon: /*#__PURE__*/React__namespace.cloneElement(icon, {
      fontSize: (_icon$props$fontSize = icon.props.fontSize) != null ? _icon$props$fontSize : size
    }),
    checkedIcon: /*#__PURE__*/React__namespace.cloneElement(indeterminateIcon, {
      fontSize: (_indeterminateIcon$pr = indeterminateIcon.props.fontSize) != null ? _indeterminateIcon$pr : size
    }),
    ownerState: ownerState,
    ref: ref,
    className: clsx(classes.root, className)
  }, other, {
    classes: classes
  }));
});
browser$1.env.NODE_ENV !== "production" ? Checkbox.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, the component is checked.
   */
  checked: propTypesExports.bool,
  /**
   * The icon to display when the component is checked.
   * @default <CheckBoxIcon />
   */
  checkedIcon: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'primary'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['default', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * The default checked state. Use when the component is not controlled.
   */
  defaultChecked: propTypesExports.bool,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the ripple effect is disabled.
   * @default false
   */
  disableRipple: propTypesExports.bool,
  /**
   * The icon to display when the component is unchecked.
   * @default <CheckBoxOutlineBlankIcon />
   */
  icon: propTypesExports.node,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * If `true`, the component appears indeterminate.
   * This does not set the native input element to indeterminate due
   * to inconsistent behavior across browsers.
   * However, we set a `data-indeterminate` attribute on the `input`.
   * @default false
   */
  indeterminate: propTypesExports.bool,
  /**
   * The icon to display when the component is indeterminate.
   * @default <IndeterminateCheckBoxIcon />
   */
  indeterminateIcon: propTypesExports.node,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * Callback fired when the state is changed.
   *
   * @param {React.ChangeEvent<HTMLInputElement>} event The event source of the callback.
   * You can pull out the new checked state by accessing `event.target.checked` (boolean).
   */
  onChange: propTypesExports.func,
  /**
   * If `true`, the `input` element is required.
   * @default false
   */
  required: propTypesExports.bool,
  /**
   * The size of the component.
   * `small` is equivalent to the dense checkbox styling.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The value of the component. The DOM API casts this to a string.
   * The browser uses "on" as the default value.
   */
  value: propTypesExports.any
} : void 0;
var Checkbox$1 = Checkbox;

function getFormControlLabelUtilityClasses(slot) {
  return generateUtilityClass('MuiFormControlLabel', slot);
}
const formControlLabelClasses = generateUtilityClasses('MuiFormControlLabel', ['root', 'labelPlacementStart', 'labelPlacementTop', 'labelPlacementBottom', 'disabled', 'label', 'error']);
var formControlLabelClasses$1 = formControlLabelClasses;

const _excluded$y = ["checked", "className", "componentsProps", "control", "disabled", "disableTypography", "inputRef", "label", "labelPlacement", "name", "onChange", "slotProps", "value"];
const useUtilityClasses$g = ownerState => {
  const {
    classes,
    disabled,
    labelPlacement,
    error
  } = ownerState;
  const slots = {
    root: ['root', disabled && 'disabled', `labelPlacement${capitalize(labelPlacement)}`, error && 'error'],
    label: ['label', disabled && 'disabled']
  };
  return composeClasses(slots, getFormControlLabelUtilityClasses, classes);
};
const FormControlLabelRoot = styled$1('label', {
  name: 'MuiFormControlLabel',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [{
      [`& .${formControlLabelClasses$1.label}`]: styles.label
    }, styles.root, styles[`labelPlacement${capitalize(ownerState.labelPlacement)}`]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  display: 'inline-flex',
  alignItems: 'center',
  cursor: 'pointer',
  // For correct alignment with the text.
  verticalAlign: 'middle',
  WebkitTapHighlightColor: 'transparent',
  marginLeft: -11,
  marginRight: 16,
  // used for row presentation of radio/checkbox
  [`&.${formControlLabelClasses$1.disabled}`]: {
    cursor: 'default'
  }
}, ownerState.labelPlacement === 'start' && {
  flexDirection: 'row-reverse',
  marginLeft: 16,
  // used for row presentation of radio/checkbox
  marginRight: -11
}, ownerState.labelPlacement === 'top' && {
  flexDirection: 'column-reverse',
  marginLeft: 16
}, ownerState.labelPlacement === 'bottom' && {
  flexDirection: 'column',
  marginLeft: 16
}, {
  [`& .${formControlLabelClasses$1.label}`]: {
    [`&.${formControlLabelClasses$1.disabled}`]: {
      color: (theme.vars || theme).palette.text.disabled
    }
  }
}));

/**
 * Drop-in replacement of the `Radio`, `Switch` and `Checkbox` component.
 * Use this component if you want to display an extra label.
 */
const FormControlLabel = /*#__PURE__*/React__namespace.forwardRef(function FormControlLabel(inProps, ref) {
  var _slotProps$typography;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiFormControlLabel'
  });
  const {
      className,
      componentsProps = {},
      control,
      disabled: disabledProp,
      disableTypography,
      label: labelProp,
      labelPlacement = 'end',
      slotProps = {}
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$y);
  const muiFormControl = useFormControl();
  let disabled = disabledProp;
  if (typeof disabled === 'undefined' && typeof control.props.disabled !== 'undefined') {
    disabled = control.props.disabled;
  }
  if (typeof disabled === 'undefined' && muiFormControl) {
    disabled = muiFormControl.disabled;
  }
  const controlProps = {
    disabled
  };
  ['checked', 'name', 'onChange', 'value', 'inputRef'].forEach(key => {
    if (typeof control.props[key] === 'undefined' && typeof props[key] !== 'undefined') {
      controlProps[key] = props[key];
    }
  });
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['error']
  });
  const ownerState = _extends$1({}, props, {
    disabled,
    labelPlacement,
    error: fcs.error
  });
  const classes = useUtilityClasses$g(ownerState);
  const typographySlotProps = (_slotProps$typography = slotProps.typography) != null ? _slotProps$typography : componentsProps.typography;
  let label = labelProp;
  if (label != null && label.type !== Typography$1 && !disableTypography) {
    label = /*#__PURE__*/jsxRuntimeExports.jsx(Typography$1, _extends$1({
      component: "span"
    }, typographySlotProps, {
      className: clsx(classes.label, typographySlotProps == null ? void 0 : typographySlotProps.className),
      children: label
    }));
  }
  return /*#__PURE__*/jsxRuntimeExports.jsxs(FormControlLabelRoot, _extends$1({
    className: clsx(classes.root, className),
    ownerState: ownerState,
    ref: ref
  }, other, {
    children: [/*#__PURE__*/React__namespace.cloneElement(control, controlProps), label]
  }));
});
browser$1.env.NODE_ENV !== "production" ? FormControlLabel.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, the component appears selected.
   */
  checked: propTypesExports.bool,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The props used for each slot inside.
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    typography: propTypesExports.object
  }),
  /**
   * A control element. For instance, it can be a `Radio`, a `Switch` or a `Checkbox`.
   */
  control: propTypesExports.element.isRequired,
  /**
   * If `true`, the control is disabled.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the label is rendered as it is passed without an additional typography node.
   */
  disableTypography: propTypesExports.bool,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * A text or an element to be used in an enclosing label element.
   */
  label: propTypesExports.node,
  /**
   * The position of the label.
   * @default 'end'
   */
  labelPlacement: propTypesExports.oneOf(['bottom', 'end', 'start', 'top']),
  /**
   * @ignore
   */
  name: propTypesExports.string,
  /**
   * Callback fired when the state is changed.
   *
   * @param {React.SyntheticEvent} event The event source of the callback.
   * You can pull out the new checked state by accessing `event.target.checked` (boolean).
   */
  onChange: propTypesExports.func,
  /**
   * The props used for each slot inside.
   * @default {}
   */
  slotProps: propTypesExports.shape({
    typography: propTypesExports.object
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The value of the component.
   */
  value: propTypesExports.any
} : void 0;
var FormControlLabel$1 = FormControlLabel;

function getFormGroupUtilityClass(slot) {
  return generateUtilityClass('MuiFormGroup', slot);
}
generateUtilityClasses('MuiFormGroup', ['root', 'row', 'error']);

const _excluded$x = ["className", "row"];
const useUtilityClasses$f = ownerState => {
  const {
    classes,
    row,
    error
  } = ownerState;
  const slots = {
    root: ['root', row && 'row', error && 'error']
  };
  return composeClasses(slots, getFormGroupUtilityClass, classes);
};
const FormGroupRoot = styled$1('div', {
  name: 'MuiFormGroup',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.row && styles.row];
  }
})(({
  ownerState
}) => _extends$1({
  display: 'flex',
  flexDirection: 'column',
  flexWrap: 'wrap'
}, ownerState.row && {
  flexDirection: 'row'
}));

/**
 * `FormGroup` wraps controls such as `Checkbox` and `Switch`.
 * It provides compact row layout.
 * For the `Radio`, you should be using the `RadioGroup` component instead of this one.
 */
const FormGroup = /*#__PURE__*/React__namespace.forwardRef(function FormGroup(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiFormGroup'
  });
  const {
      className,
      row = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$x);
  const muiFormControl = useFormControl();
  const fcs = formControlState({
    props,
    muiFormControl,
    states: ['error']
  });
  const ownerState = _extends$1({}, props, {
    row,
    error: fcs.error
  });
  const classes = useUtilityClasses$f(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(FormGroupRoot, _extends$1({
    className: clsx(classes.root, className),
    ownerState: ownerState,
    ref: ref
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? FormGroup.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * Display group of elements in a compact row.
   * @default false
   */
  row: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var FormGroup$1 = FormGroup;

const _excluded$w = ["components", "componentsProps", "slots", "slotProps"];
const PopperRoot = styled$1(PopperUnstyled$1, {
  name: 'MuiPopper',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({});

/**
 *
 * Demos:
 *
 * - [Autocomplete](https://mui.com/material-ui/react-autocomplete/)
 * - [Menu](https://mui.com/material-ui/react-menu/)
 * - [Popper](https://mui.com/material-ui/react-popper/)
 *
 * API:
 *
 * - [Popper API](https://mui.com/material-ui/api/popper/)
 */
const Popper = /*#__PURE__*/React__namespace.forwardRef(function Popper(inProps, ref) {
  var _slots$root;
  const theme = useTheme$3();
  const props = useThemeProps({
    props: inProps,
    name: 'MuiPopper'
  });
  const {
      components,
      componentsProps,
      slots,
      slotProps
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$w);
  const RootComponent = (_slots$root = slots == null ? void 0 : slots.root) != null ? _slots$root : components == null ? void 0 : components.Root;
  return /*#__PURE__*/jsxRuntimeExports.jsx(PopperRoot, _extends$1({
    direction: theme == null ? void 0 : theme.direction,
    slots: {
      root: RootComponent
    },
    slotProps: slotProps != null ? slotProps : componentsProps
  }, other, {
    ref: ref
  }));
});
browser$1.env.NODE_ENV !== "production" ? Popper.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------
  /**
   * An HTML element, [virtualElement](https://popper.js.org/docs/v2/virtual-elements/),
   * or a function that returns either.
   * It's used to set the position of the popper.
   * The return value will passed as the reference object of the Popper instance.
   */
  anchorEl: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.object, propTypesExports.func]),
  /**
   * Popper render function or node.
   */
  children: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.node, propTypesExports.func]),
  /**
   * @ignore
   */
  component: propTypesExports /* @typescript-to-proptypes-ignore */.elementType,
  /**
   * The components used for each slot inside the Popper.
   * Either a string to use a HTML element or a component.
   * @default {}
   */
  components: propTypesExports.shape({
    Root: propTypesExports.elementType
  }),
  /**
   * The props used for each slot inside the Popper.
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    root: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object])
  }),
  /**
   * An HTML element or function that returns one.
   * The `container` will have the portal children appended to it.
   *
   * By default, it uses the body of the top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([HTMLElementType, propTypesExports.func]),
  /**
   * The `children` will be under the DOM hierarchy of the parent component.
   * @default false
   */
  disablePortal: propTypesExports.bool,
  /**
   * Always keep the children in the DOM.
   * This prop can be useful in SEO situation or
   * when you want to maximize the responsiveness of the Popper.
   * @default false
   */
  keepMounted: propTypesExports.bool,
  /**
   * Popper.js is based on a "plugin-like" architecture,
   * most of its features are fully encapsulated "modifiers".
   *
   * A modifier is a function that is called each time Popper.js needs to
   * compute the position of the popper.
   * For this reason, modifiers should be very performant to avoid bottlenecks.
   * To learn how to create a modifier, [read the modifiers documentation](https://popper.js.org/docs/v2/modifiers/).
   */
  modifiers: propTypesExports.arrayOf(propTypesExports.shape({
    data: propTypesExports.object,
    effect: propTypesExports.func,
    enabled: propTypesExports.bool,
    fn: propTypesExports.func,
    name: propTypesExports.any,
    options: propTypesExports.object,
    phase: propTypesExports.oneOf(['afterMain', 'afterRead', 'afterWrite', 'beforeMain', 'beforeRead', 'beforeWrite', 'main', 'read', 'write']),
    requires: propTypesExports.arrayOf(propTypesExports.string),
    requiresIfExists: propTypesExports.arrayOf(propTypesExports.string)
  })),
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool.isRequired,
  /**
   * @ignore
   */
  ownerState: propTypesExports.any,
  /**
   * Popper placement.
   * @default 'bottom'
   */
  placement: propTypesExports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),
  /**
   * Options provided to the [`Popper.js`](https://popper.js.org/docs/v2/constructors/#options) instance.
   * @default {}
   */
  popperOptions: propTypesExports.shape({
    modifiers: propTypesExports.array,
    onFirstUpdate: propTypesExports.func,
    placement: propTypesExports.oneOf(['auto-end', 'auto-start', 'auto', 'bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),
    strategy: propTypesExports.oneOf(['absolute', 'fixed'])
  }),
  /**
   * A ref that points to the used popper instance.
   */
  popperRef: refType$1,
  /**
   * The props used for each slot inside the Popper.
   * @default {}
   */
  slotProps: propTypesExports.shape({
    root: propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object])
  }),
  /**
   * The components used for each slot inside the Popper.
   * Either a string to use a HTML element or a component.
   * @default {}
   */
  slots: propTypesExports.shape({
    root: propTypesExports.elementType
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Help supporting a react-transition-group/Transition component.
   * @default false
   */
  transition: propTypesExports.bool
} : void 0;
var Popper$1 = Popper;

function getTooltipUtilityClass(slot) {
  return generateUtilityClass('MuiTooltip', slot);
}
const tooltipClasses = generateUtilityClasses('MuiTooltip', ['popper', 'popperInteractive', 'popperArrow', 'popperClose', 'tooltip', 'tooltipArrow', 'touch', 'tooltipPlacementLeft', 'tooltipPlacementRight', 'tooltipPlacementTop', 'tooltipPlacementBottom', 'arrow']);
var tooltipClasses$1 = tooltipClasses;

const _excluded$v = ["arrow", "children", "classes", "components", "componentsProps", "describeChild", "disableFocusListener", "disableHoverListener", "disableInteractive", "disableTouchListener", "enterDelay", "enterNextDelay", "enterTouchDelay", "followCursor", "id", "leaveDelay", "leaveTouchDelay", "onClose", "onOpen", "open", "placement", "PopperComponent", "PopperProps", "slotProps", "slots", "title", "TransitionComponent", "TransitionProps"];
function round(value) {
  return Math.round(value * 1e5) / 1e5;
}
const useUtilityClasses$e = ownerState => {
  const {
    classes,
    disableInteractive,
    arrow,
    touch,
    placement
  } = ownerState;
  const slots = {
    popper: ['popper', !disableInteractive && 'popperInteractive', arrow && 'popperArrow'],
    tooltip: ['tooltip', arrow && 'tooltipArrow', touch && 'touch', `tooltipPlacement${capitalize(placement.split('-')[0])}`],
    arrow: ['arrow']
  };
  return composeClasses(slots, getTooltipUtilityClass, classes);
};
const TooltipPopper = styled$1(Popper$1, {
  name: 'MuiTooltip',
  slot: 'Popper',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.popper, !ownerState.disableInteractive && styles.popperInteractive, ownerState.arrow && styles.popperArrow, !ownerState.open && styles.popperClose];
  }
})(({
  theme,
  ownerState,
  open
}) => _extends$1({
  zIndex: (theme.vars || theme).zIndex.tooltip,
  pointerEvents: 'none'
}, !ownerState.disableInteractive && {
  pointerEvents: 'auto'
}, !open && {
  pointerEvents: 'none'
}, ownerState.arrow && {
  [`&[data-popper-placement*="bottom"] .${tooltipClasses$1.arrow}`]: {
    top: 0,
    marginTop: '-0.71em',
    '&::before': {
      transformOrigin: '0 100%'
    }
  },
  [`&[data-popper-placement*="top"] .${tooltipClasses$1.arrow}`]: {
    bottom: 0,
    marginBottom: '-0.71em',
    '&::before': {
      transformOrigin: '100% 0'
    }
  },
  [`&[data-popper-placement*="right"] .${tooltipClasses$1.arrow}`]: _extends$1({}, !ownerState.isRtl ? {
    left: 0,
    marginLeft: '-0.71em'
  } : {
    right: 0,
    marginRight: '-0.71em'
  }, {
    height: '1em',
    width: '0.71em',
    '&::before': {
      transformOrigin: '100% 100%'
    }
  }),
  [`&[data-popper-placement*="left"] .${tooltipClasses$1.arrow}`]: _extends$1({}, !ownerState.isRtl ? {
    right: 0,
    marginRight: '-0.71em'
  } : {
    left: 0,
    marginLeft: '-0.71em'
  }, {
    height: '1em',
    width: '0.71em',
    '&::before': {
      transformOrigin: '0 0'
    }
  })
}));
const TooltipTooltip = styled$1('div', {
  name: 'MuiTooltip',
  slot: 'Tooltip',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.tooltip, ownerState.touch && styles.touch, ownerState.arrow && styles.tooltipArrow, styles[`tooltipPlacement${capitalize(ownerState.placement.split('-')[0])}`]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  backgroundColor: theme.vars ? theme.vars.palette.Tooltip.bg : alpha(theme.palette.grey[700], 0.92),
  borderRadius: (theme.vars || theme).shape.borderRadius,
  color: (theme.vars || theme).palette.common.white,
  fontFamily: theme.typography.fontFamily,
  padding: '4px 8px',
  fontSize: theme.typography.pxToRem(11),
  maxWidth: 300,
  margin: 2,
  wordWrap: 'break-word',
  fontWeight: theme.typography.fontWeightMedium
}, ownerState.arrow && {
  position: 'relative',
  margin: 0
}, ownerState.touch && {
  padding: '8px 16px',
  fontSize: theme.typography.pxToRem(14),
  lineHeight: `${round(16 / 14)}em`,
  fontWeight: theme.typography.fontWeightRegular
}, {
  [`.${tooltipClasses$1.popper}[data-popper-placement*="left"] &`]: _extends$1({
    transformOrigin: 'right center'
  }, !ownerState.isRtl ? _extends$1({
    marginRight: '14px'
  }, ownerState.touch && {
    marginRight: '24px'
  }) : _extends$1({
    marginLeft: '14px'
  }, ownerState.touch && {
    marginLeft: '24px'
  })),
  [`.${tooltipClasses$1.popper}[data-popper-placement*="right"] &`]: _extends$1({
    transformOrigin: 'left center'
  }, !ownerState.isRtl ? _extends$1({
    marginLeft: '14px'
  }, ownerState.touch && {
    marginLeft: '24px'
  }) : _extends$1({
    marginRight: '14px'
  }, ownerState.touch && {
    marginRight: '24px'
  })),
  [`.${tooltipClasses$1.popper}[data-popper-placement*="top"] &`]: _extends$1({
    transformOrigin: 'center bottom',
    marginBottom: '14px'
  }, ownerState.touch && {
    marginBottom: '24px'
  }),
  [`.${tooltipClasses$1.popper}[data-popper-placement*="bottom"] &`]: _extends$1({
    transformOrigin: 'center top',
    marginTop: '14px'
  }, ownerState.touch && {
    marginTop: '24px'
  })
}));
const TooltipArrow = styled$1('span', {
  name: 'MuiTooltip',
  slot: 'Arrow',
  overridesResolver: (props, styles) => styles.arrow
})(({
  theme
}) => ({
  overflow: 'hidden',
  position: 'absolute',
  width: '1em',
  height: '0.71em' /* = width / sqrt(2) = (length of the hypotenuse) */,
  boxSizing: 'border-box',
  color: theme.vars ? theme.vars.palette.Tooltip.bg : alpha(theme.palette.grey[700], 0.9),
  '&::before': {
    content: '""',
    margin: 'auto',
    display: 'block',
    width: '100%',
    height: '100%',
    backgroundColor: 'currentColor',
    transform: 'rotate(45deg)'
  }
}));
let hystersisOpen = false;
let hystersisTimer = null;
let cursorPosition = {
  x: 0,
  y: 0
};
function composeEventHandler(handler, eventHandler) {
  return event => {
    if (eventHandler) {
      eventHandler(event);
    }
    handler(event);
  };
}

// TODO v6: Remove PopperComponent, PopperProps, TransitionComponent and TransitionProps.
const Tooltip = /*#__PURE__*/React__namespace.forwardRef(function Tooltip(inProps, ref) {
  var _ref, _slots$popper, _ref2, _ref3, _slots$transition, _ref4, _slots$tooltip, _ref5, _slots$arrow, _slotProps$popper, _ref6, _slotProps$popper2, _slotProps$transition, _slotProps$tooltip, _ref7, _slotProps$tooltip2, _slotProps$arrow, _ref8, _slotProps$arrow2;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTooltip'
  });
  const {
      arrow = false,
      children,
      components = {},
      componentsProps = {},
      describeChild = false,
      disableFocusListener = false,
      disableHoverListener = false,
      disableInteractive: disableInteractiveProp = false,
      disableTouchListener = false,
      enterDelay = 100,
      enterNextDelay = 0,
      enterTouchDelay = 700,
      followCursor = false,
      id: idProp,
      leaveDelay = 0,
      leaveTouchDelay = 1500,
      onClose,
      onOpen,
      open: openProp,
      placement = 'bottom',
      PopperComponent: PopperComponentProp,
      PopperProps = {},
      slotProps = {},
      slots = {},
      title,
      TransitionComponent: TransitionComponentProp = Grow$1,
      TransitionProps
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$v);
  const theme = useTheme$1();
  const isRtl = theme.direction === 'rtl';
  const [childNode, setChildNode] = React__namespace.useState();
  const [arrowRef, setArrowRef] = React__namespace.useState(null);
  const ignoreNonTouchEvents = React__namespace.useRef(false);
  const disableInteractive = disableInteractiveProp || followCursor;
  const closeTimer = React__namespace.useRef();
  const enterTimer = React__namespace.useRef();
  const leaveTimer = React__namespace.useRef();
  const touchTimer = React__namespace.useRef();
  const [openState, setOpenState] = useControlled({
    controlled: openProp,
    default: false,
    name: 'Tooltip',
    state: 'open'
  });
  let open = openState;
  if (browser$1.env.NODE_ENV !== 'production') {
    // eslint-disable-next-line react-hooks/rules-of-hooks
    const {
      current: isControlled
    } = React__namespace.useRef(openProp !== undefined);

    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useEffect(() => {
      if (childNode && childNode.disabled && !isControlled && title !== '' && childNode.tagName.toLowerCase() === 'button') {
        console.error(['MUI: You are providing a disabled `button` child to the Tooltip component.', 'A disabled element does not fire events.', "Tooltip needs to listen to the child element's events to display the title.", '', 'Add a simple wrapper element, such as a `span`.'].join('\n'));
      }
    }, [title, childNode, isControlled]);
  }
  const id = useId(idProp);
  const prevUserSelect = React__namespace.useRef();
  const stopTouchInteraction = React__namespace.useCallback(() => {
    if (prevUserSelect.current !== undefined) {
      document.body.style.WebkitUserSelect = prevUserSelect.current;
      prevUserSelect.current = undefined;
    }
    clearTimeout(touchTimer.current);
  }, []);
  React__namespace.useEffect(() => {
    return () => {
      clearTimeout(closeTimer.current);
      clearTimeout(enterTimer.current);
      clearTimeout(leaveTimer.current);
      stopTouchInteraction();
    };
  }, [stopTouchInteraction]);
  const handleOpen = event => {
    clearTimeout(hystersisTimer);
    hystersisOpen = true;

    // The mouseover event will trigger for every nested element in the tooltip.
    // We can skip rerendering when the tooltip is already open.
    // We are using the mouseover event instead of the mouseenter event to fix a hide/show issue.
    setOpenState(true);
    if (onOpen && !open) {
      onOpen(event);
    }
  };
  const handleClose = useEventCallback(
  /**
   * @param {React.SyntheticEvent | Event} event
   */
  event => {
    clearTimeout(hystersisTimer);
    hystersisTimer = setTimeout(() => {
      hystersisOpen = false;
    }, 800 + leaveDelay);
    setOpenState(false);
    if (onClose && open) {
      onClose(event);
    }
    clearTimeout(closeTimer.current);
    closeTimer.current = setTimeout(() => {
      ignoreNonTouchEvents.current = false;
    }, theme.transitions.duration.shortest);
  });
  const handleEnter = event => {
    if (ignoreNonTouchEvents.current && event.type !== 'touchstart') {
      return;
    }

    // Remove the title ahead of time.
    // We don't want to wait for the next render commit.
    // We would risk displaying two tooltips at the same time (native + this one).
    if (childNode) {
      childNode.removeAttribute('title');
    }
    clearTimeout(enterTimer.current);
    clearTimeout(leaveTimer.current);
    if (enterDelay || hystersisOpen && enterNextDelay) {
      enterTimer.current = setTimeout(() => {
        handleOpen(event);
      }, hystersisOpen ? enterNextDelay : enterDelay);
    } else {
      handleOpen(event);
    }
  };
  const handleLeave = event => {
    clearTimeout(enterTimer.current);
    clearTimeout(leaveTimer.current);
    leaveTimer.current = setTimeout(() => {
      handleClose(event);
    }, leaveDelay);
  };
  const {
    isFocusVisibleRef,
    onBlur: handleBlurVisible,
    onFocus: handleFocusVisible,
    ref: focusVisibleRef
  } = useIsFocusVisible();
  // We don't necessarily care about the focusVisible state (which is safe to access via ref anyway).
  // We just need to re-render the Tooltip if the focus-visible state changes.
  const [, setChildIsFocusVisible] = React__namespace.useState(false);
  const handleBlur = event => {
    handleBlurVisible(event);
    if (isFocusVisibleRef.current === false) {
      setChildIsFocusVisible(false);
      handleLeave(event);
    }
  };
  const handleFocus = event => {
    // Workaround for https://github.com/facebook/react/issues/7769
    // The autoFocus of React might trigger the event before the componentDidMount.
    // We need to account for this eventuality.
    if (!childNode) {
      setChildNode(event.currentTarget);
    }
    handleFocusVisible(event);
    if (isFocusVisibleRef.current === true) {
      setChildIsFocusVisible(true);
      handleEnter(event);
    }
  };
  const detectTouchStart = event => {
    ignoreNonTouchEvents.current = true;
    const childrenProps = children.props;
    if (childrenProps.onTouchStart) {
      childrenProps.onTouchStart(event);
    }
  };
  const handleMouseOver = handleEnter;
  const handleMouseLeave = handleLeave;
  const handleTouchStart = event => {
    detectTouchStart(event);
    clearTimeout(leaveTimer.current);
    clearTimeout(closeTimer.current);
    stopTouchInteraction();
    prevUserSelect.current = document.body.style.WebkitUserSelect;
    // Prevent iOS text selection on long-tap.
    document.body.style.WebkitUserSelect = 'none';
    touchTimer.current = setTimeout(() => {
      document.body.style.WebkitUserSelect = prevUserSelect.current;
      handleEnter(event);
    }, enterTouchDelay);
  };
  const handleTouchEnd = event => {
    if (children.props.onTouchEnd) {
      children.props.onTouchEnd(event);
    }
    stopTouchInteraction();
    clearTimeout(leaveTimer.current);
    leaveTimer.current = setTimeout(() => {
      handleClose(event);
    }, leaveTouchDelay);
  };
  React__namespace.useEffect(() => {
    if (!open) {
      return undefined;
    }

    /**
     * @param {KeyboardEvent} nativeEvent
     */
    function handleKeyDown(nativeEvent) {
      // IE11, Edge (prior to using Bink?) use 'Esc'
      if (nativeEvent.key === 'Escape' || nativeEvent.key === 'Esc') {
        handleClose(nativeEvent);
      }
    }
    document.addEventListener('keydown', handleKeyDown);
    return () => {
      document.removeEventListener('keydown', handleKeyDown);
    };
  }, [handleClose, open]);
  const handleRef = useForkRef(children.ref, focusVisibleRef, setChildNode, ref);

  // There is no point in displaying an empty tooltip.
  if (!title && title !== 0) {
    open = false;
  }
  const popperRef = React__namespace.useRef();
  const handleMouseMove = event => {
    const childrenProps = children.props;
    if (childrenProps.onMouseMove) {
      childrenProps.onMouseMove(event);
    }
    cursorPosition = {
      x: event.clientX,
      y: event.clientY
    };
    if (popperRef.current) {
      popperRef.current.update();
    }
  };
  const nameOrDescProps = {};
  const titleIsString = typeof title === 'string';
  if (describeChild) {
    nameOrDescProps.title = !open && titleIsString && !disableHoverListener ? title : null;
    nameOrDescProps['aria-describedby'] = open ? id : null;
  } else {
    nameOrDescProps['aria-label'] = titleIsString ? title : null;
    nameOrDescProps['aria-labelledby'] = open && !titleIsString ? id : null;
  }
  const childrenProps = _extends$1({}, nameOrDescProps, other, children.props, {
    className: clsx(other.className, children.props.className),
    onTouchStart: detectTouchStart,
    ref: handleRef
  }, followCursor ? {
    onMouseMove: handleMouseMove
  } : {});
  if (browser$1.env.NODE_ENV !== 'production') {
    childrenProps['data-mui-internal-clone-element'] = true;

    // eslint-disable-next-line react-hooks/rules-of-hooks
    React__namespace.useEffect(() => {
      if (childNode && !childNode.getAttribute('data-mui-internal-clone-element')) {
        console.error(['MUI: The `children` component of the Tooltip is not forwarding its props correctly.', 'Please make sure that props are spread on the same element that the ref is applied to.'].join('\n'));
      }
    }, [childNode]);
  }
  const interactiveWrapperListeners = {};
  if (!disableTouchListener) {
    childrenProps.onTouchStart = handleTouchStart;
    childrenProps.onTouchEnd = handleTouchEnd;
  }
  if (!disableHoverListener) {
    childrenProps.onMouseOver = composeEventHandler(handleMouseOver, childrenProps.onMouseOver);
    childrenProps.onMouseLeave = composeEventHandler(handleMouseLeave, childrenProps.onMouseLeave);
    if (!disableInteractive) {
      interactiveWrapperListeners.onMouseOver = handleMouseOver;
      interactiveWrapperListeners.onMouseLeave = handleMouseLeave;
    }
  }
  if (!disableFocusListener) {
    childrenProps.onFocus = composeEventHandler(handleFocus, childrenProps.onFocus);
    childrenProps.onBlur = composeEventHandler(handleBlur, childrenProps.onBlur);
    if (!disableInteractive) {
      interactiveWrapperListeners.onFocus = handleFocus;
      interactiveWrapperListeners.onBlur = handleBlur;
    }
  }
  if (browser$1.env.NODE_ENV !== 'production') {
    if (children.props.title) {
      console.error(['MUI: You have provided a `title` prop to the child of <Tooltip />.', `Remove this title prop \`${children.props.title}\` or the Tooltip component.`].join('\n'));
    }
  }
  const popperOptions = React__namespace.useMemo(() => {
    var _PopperProps$popperOp;
    let tooltipModifiers = [{
      name: 'arrow',
      enabled: Boolean(arrowRef),
      options: {
        element: arrowRef,
        padding: 4
      }
    }];
    if ((_PopperProps$popperOp = PopperProps.popperOptions) != null && _PopperProps$popperOp.modifiers) {
      tooltipModifiers = tooltipModifiers.concat(PopperProps.popperOptions.modifiers);
    }
    return _extends$1({}, PopperProps.popperOptions, {
      modifiers: tooltipModifiers
    });
  }, [arrowRef, PopperProps]);
  const ownerState = _extends$1({}, props, {
    isRtl,
    arrow,
    disableInteractive,
    placement,
    PopperComponentProp,
    touch: ignoreNonTouchEvents.current
  });
  const classes = useUtilityClasses$e(ownerState);
  const PopperComponent = (_ref = (_slots$popper = slots.popper) != null ? _slots$popper : components.Popper) != null ? _ref : TooltipPopper;
  const TransitionComponent = (_ref2 = (_ref3 = (_slots$transition = slots.transition) != null ? _slots$transition : components.Transition) != null ? _ref3 : TransitionComponentProp) != null ? _ref2 : Grow$1;
  const TooltipComponent = (_ref4 = (_slots$tooltip = slots.tooltip) != null ? _slots$tooltip : components.Tooltip) != null ? _ref4 : TooltipTooltip;
  const ArrowComponent = (_ref5 = (_slots$arrow = slots.arrow) != null ? _slots$arrow : components.Arrow) != null ? _ref5 : TooltipArrow;
  const popperProps = appendOwnerState(PopperComponent, _extends$1({}, PopperProps, (_slotProps$popper = slotProps.popper) != null ? _slotProps$popper : componentsProps.popper, {
    className: clsx(classes.popper, PopperProps == null ? void 0 : PopperProps.className, (_ref6 = (_slotProps$popper2 = slotProps.popper) != null ? _slotProps$popper2 : componentsProps.popper) == null ? void 0 : _ref6.className)
  }), ownerState);
  const transitionProps = appendOwnerState(TransitionComponent, _extends$1({}, TransitionProps, (_slotProps$transition = slotProps.transition) != null ? _slotProps$transition : componentsProps.transition), ownerState);
  const tooltipProps = appendOwnerState(TooltipComponent, _extends$1({}, (_slotProps$tooltip = slotProps.tooltip) != null ? _slotProps$tooltip : componentsProps.tooltip, {
    className: clsx(classes.tooltip, (_ref7 = (_slotProps$tooltip2 = slotProps.tooltip) != null ? _slotProps$tooltip2 : componentsProps.tooltip) == null ? void 0 : _ref7.className)
  }), ownerState);
  const tooltipArrowProps = appendOwnerState(ArrowComponent, _extends$1({}, (_slotProps$arrow = slotProps.arrow) != null ? _slotProps$arrow : componentsProps.arrow, {
    className: clsx(classes.arrow, (_ref8 = (_slotProps$arrow2 = slotProps.arrow) != null ? _slotProps$arrow2 : componentsProps.arrow) == null ? void 0 : _ref8.className)
  }), ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(React__namespace.Fragment, {
    children: [/*#__PURE__*/React__namespace.cloneElement(children, childrenProps), /*#__PURE__*/jsxRuntimeExports.jsx(PopperComponent, _extends$1({
      as: PopperComponentProp != null ? PopperComponentProp : Popper$1,
      placement: placement,
      anchorEl: followCursor ? {
        getBoundingClientRect: () => ({
          top: cursorPosition.y,
          left: cursorPosition.x,
          right: cursorPosition.x,
          bottom: cursorPosition.y,
          width: 0,
          height: 0
        })
      } : childNode,
      popperRef: popperRef,
      open: childNode ? open : false,
      id: id,
      transition: true
    }, interactiveWrapperListeners, popperProps, {
      popperOptions: popperOptions,
      children: ({
        TransitionProps: TransitionPropsInner
      }) => /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
        timeout: theme.transitions.duration.shorter
      }, TransitionPropsInner, transitionProps, {
        children: /*#__PURE__*/jsxRuntimeExports.jsxs(TooltipComponent, _extends$1({}, tooltipProps, {
          children: [title, arrow ? /*#__PURE__*/jsxRuntimeExports.jsx(ArrowComponent, _extends$1({}, tooltipArrowProps, {
            ref: setArrowRef
          })) : null]
        }))
      }))
    }))]
  });
});
browser$1.env.NODE_ENV !== "production" ? Tooltip.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, adds an arrow to the tooltip.
   * @default false
   */
  arrow: propTypesExports.bool,
  /**
   * Tooltip reference element.
   */
  children: elementAcceptingRef$1.isRequired,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `slots` prop.
   * It's recommended to use the `slots` prop instead.
   *
   * @default {}
   */
  components: propTypesExports.shape({
    Arrow: propTypesExports.elementType,
    Popper: propTypesExports.elementType,
    Tooltip: propTypesExports.elementType,
    Transition: propTypesExports.elementType
  }),
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `slotProps` prop.
   * It's recommended to use the `slotProps` prop instead, as `componentsProps` will be deprecated in the future.
   *
   * @default {}
   */
  componentsProps: propTypesExports.shape({
    arrow: propTypesExports.object,
    popper: propTypesExports.object,
    tooltip: propTypesExports.object,
    transition: propTypesExports.object
  }),
  /**
   * Set to `true` if the `title` acts as an accessible description.
   * By default the `title` acts as an accessible label for the child.
   * @default false
   */
  describeChild: propTypesExports.bool,
  /**
   * Do not respond to focus-visible events.
   * @default false
   */
  disableFocusListener: propTypesExports.bool,
  /**
   * Do not respond to hover events.
   * @default false
   */
  disableHoverListener: propTypesExports.bool,
  /**
   * Makes a tooltip not interactive, i.e. it will close when the user
   * hovers over the tooltip before the `leaveDelay` is expired.
   * @default false
   */
  disableInteractive: propTypesExports.bool,
  /**
   * Do not respond to long press touch events.
   * @default false
   */
  disableTouchListener: propTypesExports.bool,
  /**
   * The number of milliseconds to wait before showing the tooltip.
   * This prop won't impact the enter touch delay (`enterTouchDelay`).
   * @default 100
   */
  enterDelay: propTypesExports.number,
  /**
   * The number of milliseconds to wait before showing the tooltip when one was already recently opened.
   * @default 0
   */
  enterNextDelay: propTypesExports.number,
  /**
   * The number of milliseconds a user must touch the element before showing the tooltip.
   * @default 700
   */
  enterTouchDelay: propTypesExports.number,
  /**
   * If `true`, the tooltip follow the cursor over the wrapped element.
   * @default false
   */
  followCursor: propTypesExports.bool,
  /**
   * This prop is used to help implement the accessibility logic.
   * If you don't provide this prop. It falls back to a randomly generated id.
   */
  id: propTypesExports.string,
  /**
   * The number of milliseconds to wait before hiding the tooltip.
   * This prop won't impact the leave touch delay (`leaveTouchDelay`).
   * @default 0
   */
  leaveDelay: propTypesExports.number,
  /**
   * The number of milliseconds after the user stops touching an element before hiding the tooltip.
   * @default 1500
   */
  leaveTouchDelay: propTypesExports.number,
  /**
   * Callback fired when the component requests to be closed.
   *
   * @param {React.SyntheticEvent} event The event source of the callback.
   */
  onClose: propTypesExports.func,
  /**
   * Callback fired when the component requests to be open.
   *
   * @param {React.SyntheticEvent} event The event source of the callback.
   */
  onOpen: propTypesExports.func,
  /**
   * If `true`, the component is shown.
   */
  open: propTypesExports.bool,
  /**
   * Tooltip placement.
   * @default 'bottom'
   */
  placement: propTypesExports.oneOf(['bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),
  /**
   * The component used for the popper.
   * @default Popper
   */
  PopperComponent: propTypesExports.elementType,
  /**
   * Props applied to the [`Popper`](/material-ui/api/popper/) element.
   * @default {}
   */
  PopperProps: propTypesExports.object,
  /**
   * The extra props for the slot components.
   * You can override the existing props or add new ones.
   *
   * This prop is an alias for the `componentsProps` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slotProps: propTypesExports.shape({
    arrow: propTypesExports.object,
    popper: propTypesExports.object,
    tooltip: propTypesExports.object,
    transition: propTypesExports.object
  }),
  /**
   * The components used for each slot inside.
   *
   * This prop is an alias for the `components` prop, which will be deprecated in the future.
   *
   * @default {}
   */
  slots: propTypesExports.shape({
    arrow: propTypesExports.elementType,
    popper: propTypesExports.elementType,
    tooltip: propTypesExports.elementType,
    transition: propTypesExports.elementType
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Tooltip title. Zero-length titles string, undefined, null and false are never displayed.
   */
  title: propTypesExports.node,
  /**
   * The component used for the transition.
   * [Follow this guide](/material-ui/transitions/#transitioncomponent-prop) to learn more about the requirements for this component.
   * @default Grow
   */
  TransitionComponent: propTypesExports.elementType,
  /**
   * Props applied to the transition element.
   * By default, the element is based on this [`Transition`](http://reactcommunity.org/react-transition-group/transition/) component.
   */
  TransitionProps: propTypesExports.object
} : void 0;
var Tooltip$1 = Tooltip;

var _excluded$u = ["tooltip", "label", "id", "value", "validationMessage", "onChange", "containerStyle"];
function CheckBox(_ref) {
  var _ref$tooltip = _ref.tooltip,
    tooltip = _ref$tooltip === void 0 ? "" : _ref$tooltip,
    label = _ref.label,
    id = _ref.id,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    _onChange = _ref.onChange,
    _ref$containerStyle = _ref.containerStyle,
    containerStyle = _ref$containerStyle === void 0 ? {} : _ref$containerStyle,
    props = _objectWithoutProperties(_ref, _excluded$u);
  return /*#__PURE__*/React__namespace.default.createElement(FormGroup$1, {
    "data-testid": TEST_IDS.CHECKBOX
  }, /*#__PURE__*/React__namespace.default.createElement(Tooltip$1, {
    title: tooltip
  }, /*#__PURE__*/React__namespace.default.createElement(StyledFormControlLabel, {
    style: containerStyle,
    control: /*#__PURE__*/React__namespace.default.createElement(Checkbox$1, _extends$2({}, props, {
      "aria-label": id,
      onChange: function onChange(event) {
        return _onChange(event.target.checked);
      },
      inputProps: {
        "aria-label": "controlled"
      },
      value: value || false,
      checked: value || false
    })),
    label: label
  })), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    id: id,
    validationMessage: validationMessage
  }));
}
CheckBox.propTypes = {
  tooltip: propTypesExports.string,
  label: propTypesExports.string,
  id: propTypesExports.string,
  onChange: propTypesExports.func,
  value: propTypesExports.bool,
  validationMessage: propTypesExports.string,
  containerStyle: propTypesExports.object
};
var StyledFormControlLabel = styled__default.default(FormControlLabel$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    marginLeft: 1,
    alignSelf: "flex-start",
    "& .MuiFormControlLabel-label": {
      fontSize: theme.typography.subtitle1.fontSize
    }
  };
});

function UserAvatarSkeleton() {
  return /*#__PURE__*/React__namespace.default.createElement(Container$t, {
    "data-testid": TEST_IDS.USER_AVATAR_SKELETON
  }, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: 40,
    height: 65,
    isRounded: true
  }), /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: 130,
    height: 30
  }));
}
var Container$t = styled__default.default(material.Box)(function () {
  return {
    display: "flex",
    alignItems: "center",
    gap: "0.5rem"
  };
});

function BulletinPostTitle(_ref) {
  var children = _ref.children;
  var _useUtils = useUtils(),
    useCurrentUser = _useUtils.useCurrentUser;
  var _useCurrentUser = useCurrentUser(),
    user = _useCurrentUser.user,
    isLoading = _useCurrentUser.isLoading;
  var name = getFullName(user);
  return /*#__PURE__*/React__namespace.default.createElement(material.Box, null, /*#__PURE__*/React__namespace.default.createElement(Title$5, null, children), isLoading ? /*#__PURE__*/React__namespace.default.createElement(UserAvatarSkeleton, null) : /*#__PURE__*/React__namespace.default.createElement(UserInfoContainer, null, /*#__PURE__*/React__namespace.default.createElement(Avatar, {
    attachmentId: user === null || user === void 0 ? void 0 : user.photo_url,
    name: name
  }), /*#__PURE__*/React__namespace.default.createElement(Name, null, name)));
}
BulletinPostTitle.propTypes = {
  children: propTypesExports.node
};
var Title$5 = styled__default.default(material.Typography)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    fontSize: 20,
    paddingBottom: "0.5rem",
    borderBottom: "1px solid",
    borderColor: theme.palette.card.divider
  };
});
var Name = styled__default.default(material.Typography)(function () {
  return {
    fontSize: 15
  };
});
var UserInfoContainer = styled__default.default(material.Box)(function () {
  return {
    display: "flex",
    alignItems: "center",
    marginTop: "1rem",
    gap: "0.5rem"
  };
});

var o=function(o,n,a){return void 0===n&&(n={}),void 0===a&&(a={}),function(s,i,c){try{return Promise.resolve(function(t,r){try{var u=(n.context&&"development"===process.env.NODE_ENV&&console.warn("You should not used the yup options context. Please, use the 'useForm' context object instead"),Promise.resolve(o["sync"===a.mode?"validateSync":"validate"](s,Object.assign({abortEarly:!1},n,{context:i}))).then(function(t){return c.shouldUseNativeValidation&&resolvers.validateFieldsNatively({},c),{values:a.rawValues?s:t,errors:{}}}));}catch(e){return r(e)}return u&&u.then?u.then(void 0,r):u}(0,function(e){if(!e.inner)throw e;return {values:{},errors:resolvers.toNestError((o=e,n=!c.shouldUseNativeValidation&&"all"===c.criteriaMode,(o.inner||[]).reduce(function(e,t){if(e[t.path]||(e[t.path]={message:t.message,type:t.type}),n){var o=e[t.path].types,a=o&&o[t.type];e[t.path]=reactHookForm.appendErrors(t.path,n,e,t.type,a?[].concat(a,t.message):t.message);}return e},{})),c)};var o,n;}))}catch(e){return Promise.reject(e)}}};

var anchorOrigin$1 = {
  vertical: "bottom",
  horizontal: "center"
};
var transformOrigin$1 = {
  vertical: "top",
  horizontal: "center"
};
function ActionableButton(_ref) {
  var _buttonEl$current;
  var actionsParams = _ref.actionsParams,
    actions = _ref.actions,
    isLoading = _ref.isLoading,
    icon = _ref.icon,
    isSmall = _ref.isSmall,
    title = _ref.title,
    variant = _ref.variant,
    className = _ref.className;
  var buttonEl = React.useRef(null);
  var _useState = React.useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    anchorEl = _useState2[0],
    setAnchorEl = _useState2[1];
  var isOpen = Boolean(anchorEl);
  var buttonWidth = buttonEl === null || buttonEl === void 0 ? void 0 : (_buttonEl$current = buttonEl.current) === null || _buttonEl$current === void 0 ? void 0 : _buttonEl$current.clientWidth;
  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };
  var handleClose = function handleClose() {
    setAnchorEl(null);
  };
  var handleActionClick = function handleActionClick(action) {
    handleClose();
    action.onClick(actionsParams);
  };
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(StyledMenuButton, {
    className: className,
    "data-testid": TEST_IDS.ACTIONABLE_BUTTON,
    ref: buttonEl,
    variant: getVariant({
      variant: variant,
      isSmall: isSmall
    }),
    color: isSmall ? "secondary" : "primary",
    endIcon: !isSmall && icon,
    size: isSmall ? "small" : "large",
    loading: isLoading,
    onClick: handleClick
  }, isSmall ? icon : title), /*#__PURE__*/React__namespace.default.createElement(StyledActionMenu, {
    anchorEl: anchorEl,
    open: isOpen,
    onClose: handleClose,
    anchorOrigin: anchorOrigin$1,
    transformOrigin: transformOrigin$1,
    width: buttonWidth
  }, actions.map(function (action, idx) {
    return /*#__PURE__*/React__namespace.default.createElement(MenuItem$1, {
      key: "".concat(action.name).concat(idx),
      dense: true,
      onClick: function onClick() {
        return handleActionClick(action);
      }
    }, action.name ? action.name : action.getName(actionsParams));
  })));
}
ActionableButton.propTypes = {
  actionsParams: propTypesExports.object,
  // any object. Passed to action.onClick and action.getName
  actions: propTypesExports.arrayOf(propTypesExports.shape({
    name: propTypesExports.string,
    getName: propTypesExports.func,
    onClick: propTypesExports.func
  })).isRequired,
  icon: propTypesExports.node,
  isLoading: propTypesExports.bool,
  isSmall: propTypesExports.bool,
  title: propTypesExports.string,
  variant: propTypesExports.string,
  className: propTypesExports.string
};
var StyledMenuButton = styled__default.default(LoadingButton$1)(function (_ref2) {
  var _ref3;
  var theme = _ref2.theme,
    size = _ref2.size;
  return _objectSpread2({
    textTransform: "none",
    minWidth: 0
  }, size !== "small" && (_ref3 = {
    borderRadius: theme.borderRadius.lg
  }, _defineProperty(_ref3, theme.breakpoints.down("md"), {
    padding: "3px 25px"
  }), _defineProperty(_ref3, theme.breakpoints.up("md"), {
    padding: "5px 45px",
    fontSize: theme.typography.h5.fontSize
  }), _ref3));
});
var StyledActionMenu = styled__default.default(Menu$1)(function (_ref4) {
  var width = _ref4.width;
  return {
    "& .MuiMenu-list": {
      padding: 3,
      minWidth: width
    }
  };
});
function getVariant(_ref5) {
  var variant = _ref5.variant,
    isSmall = _ref5.isSmall;
  if (variant) return variant;
  return isSmall ? "text" : "contained";
}

function SectionHeader(_ref) {
  var children = _ref.children,
    hideHeaderBorder = _ref.hideHeaderBorder;
  return /*#__PURE__*/React__namespace.default.createElement(StyledSectionHeader, {
    hideHeaderBorder: hideHeaderBorder
  }, children);
}
SectionHeader.propTypes = {
  children: propTypesExports.node.isRequired,
  hideHeaderBorder: propTypesExports.bool
};
var StyledSectionHeader = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme,
    hideHeaderBorder = _ref2.hideHeaderBorder;
  return _defineProperty({
    borderBottom: hideHeaderBorder ? "none" : "1px solid ".concat(theme.palette.card.divider),
    paddingLeft: theme.spacing(2),
    width: "100%",
    display: "flex",
    flexDirection: "row",
    alignItems: "center"
  }, theme.breakpoints.down("sm"), {
    flexDirection: "column"
  });
});

function PageSectionHeader(_ref) {
  var title = _ref.title,
    headerContent = _ref.headerContent,
    hideHeaderBorder = _ref.hideHeaderBorder,
    id = _ref.id,
    buttonIsLoading = _ref.buttonIsLoading,
    buttonText = _ref.buttonText,
    buttonIcon = _ref.buttonIcon,
    buttonAction = _ref.buttonAction,
    buttonActionConfigs = _ref.buttonActionConfigs,
    buttonActionParams = _ref.buttonActionParams;
  // if no title is passed, child component uses own custom header using SectionHeader
  if (!title) return null;
  return /*#__PURE__*/React__namespace.default.createElement(SectionHeader, {
    hideHeaderBorder: hideHeaderBorder
  }, /*#__PURE__*/React__namespace.default.createElement(FlexGrowBox, null, /*#__PURE__*/React__namespace.default.createElement(SectionTitle$1, {
    variant: "h4"
  }, title), /*#__PURE__*/React__namespace.default.createElement(Box$1, null, headerContent)), !buttonText && buttonIcon && /*#__PURE__*/React__namespace.default.createElement(StyledIconButton$1, {
    "data-testid": TEST_IDS.PAGE_SECTION_HEADER_DEFAULT_BUTTON,
    color: "secondary",
    onClick: function onClick() {
      return buttonAction();
    }
  }, buttonIcon), buttonText && /*#__PURE__*/React__namespace.default.createElement(ButtonBox$2, null, /*#__PURE__*/React__namespace.default.createElement(ActionableButton, {
    actionsParams: buttonActionParams,
    title: buttonText,
    icon: buttonIcon,
    actions: buttonActionConfigs,
    isLoading: buttonIsLoading,
    id: id
  })));
}
PageSectionHeader.propTypes = {
  title: propTypesExports.string,
  hideHeaderBorder: propTypesExports.bool,
  headerContent: propTypesExports.node,
  id: propTypesExports.string,
  buttonIsLoading: propTypesExports.bool,
  buttonText: propTypesExports.string,
  buttonIcon: propTypesExports.node,
  buttonAction: propTypesExports.func,
  buttonActionConfigs: propTypesExports.array,
  buttonActionParams: propTypesExports.object
};
var ButtonBox$2 = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return _defineProperty({
    marginRight: theme.spacing(1)
  }, theme.breakpoints.down("sm"), {
    margin: "15px 0px"
  });
});
var SectionTitle$1 = styled__default.default(Typography$1)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    margin: theme.spacing(1)
  };
});
var FlexGrowBox = styled__default.default(Box$1)(function (_ref5) {
  var theme = _ref5.theme;
  return _defineProperty({
    flexGrow: 1,
    display: "flex",
    flexDirection: "row",
    alignItems: "center"
  }, theme.breakpoints.down("sm"), {
    flexDirection: "column"
  });
});
var StyledIconButton$1 = styled__default.default(IconButton$2)({
  marginRight: 10
});

function PageSection(_ref) {
  var className = _ref.className,
    refetch = _ref.refetch,
    isLoading = _ref.isLoading,
    error = _ref.error,
    title = _ref.title,
    headerContent = _ref.headerContent,
    id = _ref.id,
    buttonIsLoading = _ref.buttonIsLoading,
    buttonText = _ref.buttonText,
    buttonIcon = _ref.buttonIcon,
    buttonAction = _ref.buttonAction,
    buttonActionConfigs = _ref.buttonActionConfigs,
    buttonActionParams = _ref.buttonActionParams,
    noPadding = _ref.noPadding,
    noMarginTop = _ref.noMarginTop,
    noMarginBottom = _ref.noMarginBottom,
    hideHeaderBorder = _ref.hideHeaderBorder,
    _ref$isBackgroundVisi = _ref.isBackgroundVisible,
    isBackgroundVisible = _ref$isBackgroundVisi === void 0 ? true : _ref$isBackgroundVisi,
    width = _ref.width,
    _ref$isScrollable = _ref.isScrollable,
    isScrollable = _ref$isScrollable === void 0 ? true : _ref$isScrollable,
    children = _ref.children;
  if (isLoading) {
    return /*#__PURE__*/React__namespace.default.createElement(SectionContainer, {
      className: className,
      width: width,
      noMarginTop: noMarginTop
    }, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
      variant: "rectangular",
      height: 250,
      isRounded: true
    }));
  }
  return /*#__PURE__*/React__namespace.default.createElement(SectionContainer, {
    className: className,
    width: width,
    isBackgroundVisible: isBackgroundVisible,
    noMarginTop: noMarginTop
  }, error ? /*#__PURE__*/React__namespace.default.createElement(ErrorMessage, {
    error: error,
    onButtonClick: refetch
  }) : /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(PageSectionHeader, {
    title: title,
    headerContent: headerContent,
    id: id,
    hideHeaderBorder: hideHeaderBorder,
    buttonIsLoading: buttonIsLoading,
    buttonText: buttonText,
    buttonIcon: buttonIcon,
    buttonAction: buttonAction,
    buttonActionConfigs: buttonActionConfigs,
    buttonActionParams: buttonActionParams
  }), /*#__PURE__*/React__namespace.default.createElement(SectionContent, {
    noPadding: noPadding,
    noMarginBottom: noMarginBottom,
    isScrollable: isScrollable
  }, children)));
}
PageSection.propTypes = {
  className: propTypesExports.string,
  error: propTypesExports.object,
  isLoading: propTypesExports.bool,
  title: propTypesExports.string,
  headerContent: propTypesExports.node,
  children: propTypesExports.node,
  id: propTypesExports.string,
  buttonIsLoading: propTypesExports.bool,
  buttonText: propTypesExports.string,
  buttonIcon: propTypesExports.node,
  buttonAction: propTypesExports.func,
  buttonActionConfigs: propTypesExports.array,
  buttonActionParams: propTypesExports.object,
  refetch: propTypesExports.func,
  noPadding: propTypesExports.bool,
  noMarginTop: propTypesExports.bool,
  noMarginBottom: propTypesExports.bool,
  hideHeaderBorder: propTypesExports.bool,
  isBackgroundVisible: propTypesExports.bool,
  isScrollable: propTypesExports.bool,
  width: propTypesExports.string
};
var SectionContainer = styled__default.default(Paper$1, {
  shouldForwardProp: function shouldForwardProp(prop) {
    return prop !== "isBackgroundVisible" && prop !== "noMarginTop";
  }
})(function (_ref2) {
  var theme = _ref2.theme,
    width = _ref2.width,
    isBackgroundVisible = _ref2.isBackgroundVisible,
    noMarginTop = _ref2.noMarginTop;
  return {
    width: width || "100%",
    marginTop: noMarginTop ? "0px" : "20px",
    backgroundColor: isBackgroundVisible ? theme.palette.card.background : "transparent",
    borderRadius: theme.borderRadius.lg,
    boxShadow: isBackgroundVisible ? theme.boxShadow : null,
    flex: 1
  };
});
var SectionContent = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref3) {
  var theme = _ref3.theme,
    noPadding = _ref3.noPadding,
    noMarginBottom = _ref3.noMarginBottom,
    isScrollable = _ref3.isScrollable;
  return {
    padding: noPadding ? 0 : theme.spacing(2),
    marginBottom: !noMarginBottom && 20,
    overflow: isScrollable ? "auto" : "unset"
  };
});

var _excluded$t = ["title", "subtitle", "label", "description", "path", "referencePath", "Component", "onChange", "id", "getComponentProps", "AddButtonComponent", "getAddButtonComponentProps"];
var VALIDATION_MODES = {
  ON_BLUR: "onBlur",
  ON_SUBMIT: "onSubmit",
  ON_CHANGE: "onChange"
};
function Form$1(_ref) {
  var name = _ref.name,
    _ref$nameColor = _ref.nameColor,
    nameColor = _ref$nameColor === void 0 ? "primary" : _ref$nameColor,
    initialValues = _ref.initialValues,
    isLoading = _ref.isLoading,
    sections = _ref.sections,
    isColumn = _ref.isColumn,
    isCentered = _ref.isCentered,
    validationSchema = _ref.validationSchema,
    _ref$validationMode = _ref.validationMode,
    validationMode = _ref$validationMode === void 0 ? VALIDATION_MODES.ON_BLUR : _ref$validationMode,
    onSubmit = _ref.onSubmit,
    onSecondarySubmit = _ref.onSecondarySubmit,
    onCancel = _ref.onCancel,
    _ref$ButtonComponent = _ref.ButtonComponent,
    ButtonComponent = _ref$ButtonComponent === void 0 ? Button : _ref$ButtonComponent,
    _ref$isButtonCentered = _ref.isButtonCentered,
    isButtonCentered = _ref$isButtonCentered === void 0 ? false : _ref$isButtonCentered,
    submitButtonLabel = _ref.submitButtonLabel,
    secondarySubmitButtonLabel = _ref.secondarySubmitButtonLabel,
    NameComponent = _ref.NameComponent,
    cancelButtonLabel = _ref.cancelButtonLabel,
    bypassValidationOnSecondarySubmit = _ref.bypassValidationOnSecondarySubmit;
  var configs = getFormConfig$3({
    initialValues: initialValues,
    validationSchema: validationSchema,
    validationMode: validationMode
  });
  var _useForm = reactHookForm.useForm(configs),
    control = _useForm.control,
    handleSubmit = _useForm.handleSubmit,
    formState = _useForm.formState,
    watch = _useForm.watch,
    setValue = _useForm.setValue,
    getValues = _useForm.getValues;
  var isSubmitting = formState.isSubmitting,
    errors = formState.errors;
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(FormContainer$1, {
    isColumn: isColumn,
    isCentered: isCentered
  }, name && getNameComponent({
    name: name,
    NameComponent: NameComponent,
    nameColor: nameColor
  }), sections.map(function (section, idx) {
    var FormSectionComponent =
    // eslint-disable-next-line no-use-before-define
    (section === null || section === void 0 ? void 0 : section.FormSectionComponent) || FormSection;
    return /*#__PURE__*/React__namespace.default.createElement(FormSectionComponent, {
      key: "".concat(section.title, "-").concat(idx),
      title: section.title,
      width: section.width,
      noPadding: section.noPadding,
      noTopMargin: section.noTopMargin,
      hideHeaderBorder: section.hideHeaderBorder,
      isBackgroundVisible: section.isBackgroundVisible,
      isScrollable: section.isScrollable
    }, section.subsections.map(function (_ref2) {
      var title = _ref2.title,
        subtitle = _ref2.subtitle,
        label = _ref2.label,
        description = _ref2.description,
        path = _ref2.path,
        referencePath = _ref2.referencePath,
        Component = _ref2.Component,
        onSubsectionChange = _ref2.onChange,
        id = _ref2.id,
        getComponentProps = _ref2.getComponentProps,
        AddButtonComponent = _ref2.AddButtonComponent,
        getAddButtonComponentProps = _ref2.getAddButtonComponentProps,
        config = _objectWithoutProperties(_ref2, _excluded$t);
      var addBottomMargin = config.addBottomMargin;
      var isHidden = getIsHidden({
        config: config,
        values: watch(referencePath)
      });
      var isHalfWidth = getIsHalfWidth({
        config: config
      });
      var isQuarterWidth = config.isQuarterWidth,
        isSixthWidth = config.isSixthWidth;
      var componentProps = getComponentProps ? getComponentProps(watch(referencePath)) : {};
      var validationMessage = getErrorMessage({
        errors: errors,
        path: path
      });
      if (isHidden) return null;
      return /*#__PURE__*/React__namespace.default.createElement(InputWidth, {
        key: "".concat(title, "-").concat(path),
        isHalfWidth: isHalfWidth,
        isQuarterWidth: isQuarterWidth,
        isSixthWidth: isSixthWidth,
        addBottomMargin: addBottomMargin
      }, /*#__PURE__*/React__namespace.default.createElement(reactHookForm.Controller, {
        name: path,
        control: control,
        render: function render(_ref3) {
          var _ref3$field = _ref3.field,
            value = _ref3$field.value,
            _onChange = _ref3$field.onChange,
            onBlur = _ref3$field.onBlur;
          return /*#__PURE__*/React__namespace.default.createElement(Component, _extends$2({}, componentProps, {
            id: id,
            title: title,
            subtitle: subtitle,
            description: description,
            label: label,
            value: value,
            onChange: function onChange(newValue) {
              return handleOnChange$3({
                newValue: newValue,
                setValue: setValue,
                onChange: _onChange,
                onSubsectionChange: onSubsectionChange
              });
            },
            onBlur: onBlur,
            validationMessage: validationMessage
          }));
        }
      }), AddButtonComponent && /*#__PURE__*/React__namespace.default.createElement(AddButtonComponent, getAddButtonComponentProps()));
    }));
  })), onSecondarySubmit && /*#__PURE__*/React__namespace.default.createElement(ButtonBox$1, {
    isButtonCentered: isButtonCentered
  }, /*#__PURE__*/React__namespace.default.createElement(SecondarySubmitButton, {
    "data-testid": FORM_INPUTS.SECONDARY_BUTTON,
    onClick: function onClick() {
      return bypassValidationOnSecondarySubmit ? onSecondarySubmit(getValues()) : handleSubmit(onSecondarySubmit);
    }
  }, secondarySubmitButtonLabel)), /*#__PURE__*/React__namespace.default.createElement(ButtonBox$1, {
    isButtonCentered: isButtonCentered
  }, onCancel && /*#__PURE__*/React__namespace.default.createElement(CancelButton, {
    loading: isLoading || isSubmitting,
    variant: "outlined",
    onClick: onCancel
  }, cancelButtonLabel), /*#__PURE__*/React__namespace.default.createElement(ButtonComponent, {
    "data-testid": FORM_INPUTS.BUTTON,
    loading: isLoading || isSubmitting,
    onClick: handleSubmit(onSubmit),
    variant: "contained"
  }, submitButtonLabel)));
}
Form$1.propTypes = {
  name: propTypesExports.string,
  nameColor: propTypesExports.string,
  isColumn: propTypesExports.bool,
  isCentered: propTypesExports.bool,
  NameComponent: propTypesExports.elementType,
  initialValues: propTypesExports.shape({}),
  sections: propTypesExports.arrayOf(propTypesExports.shape({
    title: propTypesExports.string,
    subsections: propTypesExports.arrayOf(propTypesExports.shape({
      title: propTypesExports.string,
      path: propTypesExports.string,
      onChange: propTypesExports.func,
      Component: propTypesExports.elementType,
      AddButtonComponent: propTypesExports.elementType,
      isHalfWidth: propTypesExports.oneOfType([propTypesExports.bool, propTypesExports.func]),
      isHidden: propTypesExports.oneOfType([propTypesExports.bool, propTypesExports.func])
    }))
  })).isRequired,
  isLoading: propTypesExports.bool,
  validationSchema: propTypesExports.shape({}),
  validationMode: propTypesExports.string,
  ButtonComponent: propTypesExports.func,
  isButtonCentered: propTypesExports.bool,
  onSubmit: propTypesExports.func.isRequired,
  onSecondarySubmit: propTypesExports.func,
  onCancel: propTypesExports.func,
  submitButtonLabel: propTypesExports.string,
  secondarySubmitButtonLabel: propTypesExports.string,
  cancelButtonLabel: propTypesExports.string,
  bypassValidationOnSecondarySubmit: propTypesExports.bool
};
function getFormConfig$3(_ref4) {
  var initialValues = _ref4.initialValues,
    validationSchema = _ref4.validationSchema,
    validationMode = _ref4.validationMode;
  return _objectSpread2(_objectSpread2({
    defaultValues: initialValues
  }, validationSchema && {
    resolver: o(validationSchema)
  }), {}, {
    mode: validationMode,
    reValidateMode: validationMode
  });
}
function getIsHidden(_ref5) {
  var config = _ref5.config,
    values = _ref5.values;
  var isHidden = config.isHidden;
  return getConfigValue({
    valueOrFunction: isHidden,
    values: values
  });
}
function getIsHalfWidth(_ref6) {
  var config = _ref6.config,
    values = _ref6.values;
  var isHalfWidth = config.isHalfWidth;
  return getConfigValue({
    valueOrFunction: isHalfWidth,
    values: values
  });
}

// isHidden and isHalfWidth can be a bool or function that returns a
// bool. Function gets called with form values.
function getConfigValue(_ref7) {
  var valueOrFunction = _ref7.valueOrFunction,
    values = _ref7.values;
  if (libCommon.isFunction(valueOrFunction)) {
    return valueOrFunction(values);
  }
  return valueOrFunction;
}

// exporting for tests
function getErrorMessage(_ref8) {
  var errors = _ref8.errors,
    path = _ref8.path;
  var allErrors = libCommon.get(errors, path);
  if (!allErrors) return undefined;

  // return error if single error
  if (allErrors.message) return getMessageOrObject(allErrors);

  // only return single error if object shape has errors
  if (!Array.isArray(allErrors)) {
    return getMessageOrObject(Object.values(allErrors)[0]);
  }

  // only return a single error at a time if array of errors
  var filteredErrors = allErrors.filter(function (error) {
    return error;
  });
  return getMessageOrObject(filteredErrors[0]);
}
function getMessageOrObject(error) {
  return error.message ? error.message : error;
}
function getNameComponent(_ref9) {
  var NameComponent = _ref9.NameComponent,
    name = _ref9.name,
    nameColor = _ref9.nameColor;
  return NameComponent ? /*#__PURE__*/React__namespace.default.createElement(NameComponent, null, name) : /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "h3",
    color: nameColor
  }, name);
}
function handleOnChange$3(_ref10) {
  var newValue = _ref10.newValue,
    setValue = _ref10.setValue,
    onChange = _ref10.onChange,
    onSubsectionChange = _ref10.onSubsectionChange;
  onChange(newValue);
  if (onSubsectionChange) {
    onSubsectionChange({
      newValue: newValue,
      setValue: setValue
    });
  }
}
var FormContainer$1 = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref11) {
  var isColumn = _ref11.isColumn,
    isCentered = _ref11.isCentered;
  return _objectSpread2({
    width: "100%"
  }, isColumn && {
    display: "flex",
    flexDirection: "row",
    justifyContent: isCentered ? "center" : "space-between",
    gap: "20px"
  });
});
var FormSection = styled__default.default(PageSection)(function (_ref12) {
  var width = _ref12.width;
  return _objectSpread2(_objectSpread2({}, width && {
    paddingRight: 10
  }), {}, {
    flexDirection: "row",
    justifyContent: "space-between",
    flexWrap: "wrap"
  });
});
var InputWidth = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref13) {
  var isHalfWidth = _ref13.isHalfWidth,
    isQuarterWidth = _ref13.isQuarterWidth,
    isSixthWidth = _ref13.isSixthWidth,
    addBottomMargin = _ref13.addBottomMargin;
  return _objectSpread2(_objectSpread2(_objectSpread2({
    width: isHalfWidth ? "50%" : "100%",
    marginBottom: addBottomMargin ? "30px" : "0px"
  }, isQuarterWidth && {
    width: "25%"
  }), isSixthWidth && {
    width: "16.66%"
  }), {}, {
    padding: (isHalfWidth || isQuarterWidth || isSixthWidth) && "0px 15px 0px 0px",
    display: (isHalfWidth || isQuarterWidth || isSixthWidth) && "inline-flex"
  });
});
var ButtonBox$1 = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref14) {
  var isButtonCentered = _ref14.isButtonCentered;
  return {
    display: "flex",
    justifyContent: isButtonCentered ? "center" : "flex-end",
    flexDirection: "row",
    marginTop: 20,
    marginBottom: 20
  };
});
var CancelButton = styled__default.default(Button)(function (_ref15) {
  var theme = _ref15.theme;
  return {
    marginRight: theme.spacing(2)
  };
});
var SecondarySubmitButton = styled__default.default(Button)(function (_ref16) {
  var theme = _ref16.theme;
  return {
    color: theme.palette.text.primary,
    textTransform: "none",
    borderRadius: theme.borderRadius.sm,
    padding: "2px 8px !important",
    marginTop: "12px"
  };
});

var FORM_TEXT_INPUT_ROWS = 7;
function CreateOrUpdateBulletinModalForm(_ref) {
  var title = _ref.title,
    contentLabel = _ref.contentLabel,
    submitButtonLabel = _ref.submitButtonLabel,
    _ref$content = _ref.content,
    content = _ref$content === void 0 ? "" : _ref$content,
    onChange = _ref.onChange,
    isMutationLoading = _ref.isMutationLoading;
  return /*#__PURE__*/React__namespace.default.createElement(Form$1, {
    isCentered: true,
    name: title,
    nameColor: "text",
    initialValues: getInitialValues$3({
      content: content
    }),
    validationSchema: getValidationSchema(),
    validationMode: VALIDATION_MODES.ON_CHANGE,
    sections: getFormSections({
      contentLabel: contentLabel
    }),
    onSubmit: onChange,
    isLoading: isMutationLoading,
    submitButtonLabel: submitButtonLabel,
    NameComponent: BulletinPostTitle
  });
}
CreateOrUpdateBulletinModalForm.propTypes = {
  onChange: propTypesExports.func.isRequired,
  title: propTypesExports.string,
  contentLabel: propTypesExports.string.isRequired,
  submitButtonLabel: propTypesExports.string.isRequired,
  isMutationLoading: propTypesExports.bool,
  content: propTypesExports.string
};
var StyledBox = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    margin: "".concat(theme.spacing(2), " 0 0")
  };
});
function getInitialValues$3(_ref3) {
  var content = _ref3.content;
  return {
    content: content,
    shouldNotify: true
  };
}
function getValidationSchema() {
  return yup__namespace.object().shape({
    content: yup__namespace.string().max(LIMITS.MAX_CONTENT_LENGTH).required(),
    shouldNotify: yup__namespace.bool()["default"](true)
  });
}
function getFormSections(_ref4) {
  var contentLabel = _ref4.contentLabel;
  var styles = getStyles$a();
  return [{
    FormSectionComponent: StyledBox,
    subsections: [{
      label: contentLabel,
      path: "content",
      id: "content",
      Component: FormTextInput,
      getComponentProps: function getComponentProps() {
        return {
          multiline: true,
          rows: FORM_TEXT_INPUT_ROWS
        };
      }
    }, {
      label: BULLETIN_NOTIFICATION_CHECKBOX_LABEL,
      path: "shouldNotify",
      id: "should_notify",
      Component: CheckBox,
      getComponentProps: function getComponentProps() {
        return {
          tooltip: BULLETIN_NOTIFICATION_CHECKBOX_TOOLTIP,
          containerStyle: styles.checkboxContainerStyle
        };
      }
    }]
  }];
}
function getStyles$a() {
  return {
    checkboxContainerStyle: {
      alignSelf: "start",
      marginLeft: -10
    }
  };
}

function CreateOrUpdateBulletinModal(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    title = _ref.title,
    inputLabel = _ref.inputLabel,
    id = _ref.id,
    _ref$content = _ref.content,
    content = _ref$content === void 0 ? "" : _ref$content,
    buttonLabel = _ref.buttonLabel,
    isEditModal = _ref.isEditModal;
  var _useBulletinPosts = useBulletinPosts(),
    updateBulletinPost = _useBulletinPosts.updateBulletinPost,
    isMutationLoading = _useBulletinPosts.isMutationLoading,
    createBulletinPost = _useBulletinPosts.createBulletinPost;
  var mutation = isEditModal ? updateBulletinPost : createBulletinPost;
  return /*#__PURE__*/React__namespace.default.createElement(Modal, {
    width: "45%",
    isOpen: isOpen,
    onClose: onClose
  }, /*#__PURE__*/React__namespace.default.createElement(ModalContent, {
    "data-testid": TEST_IDS.BULLETIN_POST_MODAL
  }, /*#__PURE__*/React__namespace.default.createElement(CreateOrUpdateBulletinModalForm, {
    title: title,
    contentLabel: inputLabel,
    submitButtonLabel: buttonLabel,
    content: content,
    isMutationLoading: isMutationLoading,
    onChange: function onChange(values) {
      return mutation(_objectSpread2(_objectSpread2({
        id: id
      }, values), {}, {
        onCompleted: onClose
      }));
    }
  })));
}
CreateOrUpdateBulletinModal.propTypes = {
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  title: propTypesExports.string,
  inputLabel: propTypesExports.string.isRequired,
  buttonLabel: propTypesExports.string.isRequired,
  id: propTypesExports.string,
  content: propTypesExports.string,
  isEditModal: propTypesExports.bool
};
var ModalContent = styled__default.default(Box$3)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: "flex",
    flexDirection: "column",
    width: "100%",
    paddingTop: 0,
    paddingLeft: theme.spacing(2),
    paddingRight: theme.spacing(2),
    paddingBottom: 0
  };
});

function BulletinPostActions(_ref) {
  var post = _ref.post;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isEditModalOpen = _useState2[0],
    setIsEditModalOpen = _useState2[1];
  var _useState3 = React.useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    isDeleteModalOpen = _useState4[0],
    setIsDeleteModalOpen = _useState4[1];
  var actions = getActions$1({
    setIsEditModalOpen: setIsEditModalOpen,
    setIsDeleteModalOpen: setIsDeleteModalOpen,
    postId: post.id
  });
  var _useBulletinPosts = useBulletinPosts(),
    shouldShowBulletinPostViews = _useBulletinPosts.shouldShowBulletinPostViews,
    isMutationLoading = _useBulletinPosts.isMutationLoading,
    archiveBulletinPost = _useBulletinPosts.archiveBulletinPost;
  return /*#__PURE__*/React__namespace.default.createElement(Container$s, null, /*#__PURE__*/React__namespace.default.createElement(ActionableButton, {
    icon: /*#__PURE__*/React__namespace.default.createElement(default_1$E, null),
    actions: actions,
    actionsParams: post,
    id: post.id,
    isSmall: true
  }), shouldShowBulletinPostViews && /*#__PURE__*/React__namespace.default.createElement(BulletinPostViews, {
    post: post
  }), /*#__PURE__*/React__namespace.default.createElement(CreateOrUpdateBulletinModal, {
    isOpen: isEditModalOpen,
    onClose: function onClose() {
      return setIsEditModalOpen(!isEditModalOpen);
    },
    title: "Edit Post",
    content: post.content,
    inputLabel: "Edit bulletin post",
    buttonLabel: "Edit",
    id: post.id,
    isEditModal: true
  }), /*#__PURE__*/React__namespace.default.createElement(ConfirmationModal, {
    isOpen: isDeleteModalOpen,
    onClose: function onClose() {
      return setIsDeleteModalOpen(!isDeleteModalOpen);
    },
    confirmationButtonLabel: "Delete",
    message: "Are you sure you want to delete this post?",
    onConfirmation: function onConfirmation() {
      return handleDeletePost({
        onDeletePostClick: archiveBulletinPost,
        post: post,
        setIsDeleteModalOpen: setIsDeleteModalOpen,
        isDeleteModalOpen: isDeleteModalOpen
      });
    },
    isLoading: isMutationLoading
  }));
}
function getActions$1(_ref2) {
  var setIsEditModalOpen = _ref2.setIsEditModalOpen,
    setIsDeleteModalOpen = _ref2.setIsDeleteModalOpen;
  return [{
    name: "Edit",
    onClick: function onClick() {
      return setIsEditModalOpen(true);
    }
  }, {
    name: "Delete",
    onClick: function onClick() {
      return setIsDeleteModalOpen(true);
    }
  }];
}
var Container$s = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "column",
    justifyContent: "space-between",
    alignItems: "flex-end"
  };
});
function handleDeletePost(_ref3) {
  var onDeletePostClick = _ref3.onDeletePostClick,
    post = _ref3.post,
    setIsDeleteModalOpen = _ref3.setIsDeleteModalOpen,
    isDeleteModalOpen = _ref3.isDeleteModalOpen;
  onDeletePostClick(post.id, function () {
    return setIsDeleteModalOpen(!isDeleteModalOpen);
  });
}
BulletinPostActions.propTypes = {
  post: propTypesExports.shape({
    id: propTypesExports.string,
    content: propTypesExports.string.isRequired,
    is_pinned: propTypesExports.bool.isRequired
  })
};

var PushPin = {};

var _interopRequireDefault$A = interopRequireDefaultExports;
Object.defineProperty(PushPin, "__esModule", {
  value: true
});
var default_1$A = PushPin.default = void 0;
var _createSvgIcon$A = _interopRequireDefault$A(requireCreateSvgIcon());
var _jsxRuntime$A = requireJsxRuntime();
var _default$A = (0, _createSvgIcon$A.default)( /*#__PURE__*/(0, _jsxRuntime$A.jsx)("path", {
  fillRule: "evenodd",
  d: "M16 9V4h1c.55 0 1-.45 1-1s-.45-1-1-1H7c-.55 0-1 .45-1 1s.45 1 1 1h1v5c0 1.66-1.34 3-3 3v2h5.97v7l1 1 1-1v-7H19v-2c-1.66 0-3-1.34-3-3z"
}), 'PushPin');
default_1$A = PushPin.default = _default$A;

function PinnedPostHeader() {
  return /*#__PURE__*/React__namespace.default.createElement(Container$r, null, /*#__PURE__*/React__namespace.default.createElement(StyledPushPinIcon, null), /*#__PURE__*/React__namespace.default.createElement(PinnedPostLabel, null, PINNED_POST_LABEL));
}
var Container$r = styled__default.default(material.Box)(function () {
  return {
    display: "flex",
    alignItems: "center"
  };
});
var StyledPushPinIcon = styled__default.default(default_1$A)(function (_ref) {
  var theme = _ref.theme;
  return {
    color: theme.palette.text.secondary,
    fontSize: 12,
    marginRight: theme.spacing(0.5)
  };
});
var PinnedPostLabel = styled__default.default(material.Typography)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    color: theme.palette.text.secondary,
    fontSize: theme.typography.body3.fontSize,
    fontWeight: theme.typography.body3.fontWeight
  };
});

function BulletinPostItem(_ref) {
  var post = _ref.post;
  var createdAt = post.created_at,
    author = post.author,
    content = post.content,
    isPostPinned = post.is_pinned;
  var date = libCommon.getElapsedTimeFromTimestamp(createdAt);
  var name = getFullName(author);
  var bulletinPostRef = React.useRef();
  var _useBulletinPosts = useBulletinPosts(),
    onScrollToPostSuccess = _useBulletinPosts.onScrollToPostSuccess,
    shouldAllowMutations = _useBulletinPosts.shouldAllowMutations;
  var _useScrollToEntity = useScrollToEntity({
      onScrollToPostSuccess: onScrollToPostSuccess,
      entityType: ENTITY_TYPES.BULLETIN_POSTS,
      entityId: post.id,
      ref: bulletinPostRef
    }),
    isScrollTargetActive = _useScrollToEntity.isScrollTargetActive;
  return /*#__PURE__*/React__namespace.default.createElement(Container$q, {
    ref: bulletinPostRef,
    isScrollTargetActive: isScrollTargetActive
  }, /*#__PURE__*/React__namespace.default.createElement(PostContainer, null, /*#__PURE__*/React__namespace.default.createElement(StyledAvatar$2, {
    attachmentId: author.photo_url,
    name: name,
    isPostPinned: isPostPinned
  }), /*#__PURE__*/React__namespace.default.createElement(DetailsContainer, null, isPostPinned && /*#__PURE__*/React__namespace.default.createElement(PinnedPostHeader, null), /*#__PURE__*/React__namespace.default.createElement(TitleContainer, null, /*#__PURE__*/React__namespace.default.createElement(AuthorName, null, author.first_name, " ", author.last_name), /*#__PURE__*/React__namespace.default.createElement(PostDate, null, date)), /*#__PURE__*/React__namespace.default.createElement(Content, null, content))), shouldAllowMutations && /*#__PURE__*/React__namespace.default.createElement(PostActionColumn, null, /*#__PURE__*/React__namespace.default.createElement(BulletinPostActions, {
    post: post
  })));
}
BulletinPostItem.propTypes = {
  post: propTypesExports.shape({
    id: propTypesExports.string.isRequired,
    content: propTypesExports.string.isRequired,
    author: propTypesExports.shape({
      photo_url: propTypesExports.string,
      first_name: propTypesExports.string,
      last_name: propTypesExports.string
    }),
    is_pinned: propTypesExports.bool,
    created_at: propTypesExports.number
  })
};
var Container$q = styled__default.default(Box$3, {
  shouldForwardProp: shouldForwardProp
})(function (_ref2) {
  var theme = _ref2.theme,
    isScrollTargetActive = _ref2.isScrollTargetActive;
  return _objectSpread2({
    display: "flex",
    padding: "0.5rem 1rem",
    justifyContent: "space-between",
    borderBottom: "1px solid ".concat(theme.palette.card.divider)
  }, isScrollTargetActive && {
    backgroundColor: theme.palette.colors.highlightChange
  });
});
var StyledAvatar$2 = styled__default.default(Avatar, {
  shouldForwardProp: function shouldForwardProp(prop) {
    return prop !== "isPostPinned";
  }
})(function (_ref3) {
  var isPostPinned = _ref3.isPostPinned;
  return {
    marginTop: isPostPinned ? 15 : 0
  };
});
var PostContainer = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "row",
    gap: "1rem",
    wordBreak: "break-word"
  };
});
var DetailsContainer = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "column"
  };
});
var AuthorName = styled__default.default(material.Typography)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    fontWeight: theme.typography.h6.fontWeight,
    fontSize: theme.typography.h6.fontSize
  };
});
var PostDate = styled__default.default(material.Typography)(function (_ref5) {
  var theme = _ref5.theme;
  return {
    fontSize: 12,
    color: theme.palette.text.secondary
  };
});
var Content = styled__default.default(material.Typography)(function (_ref6) {
  var theme = _ref6.theme;
  return {
    color: theme.palette.text.primary
  };
});
var TitleContainer = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "row",
    alignItems: "center",
    gap: "0.5rem"
  };
});
var PostActionColumn = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "column",
    alignItems: "center",
    justifyContent: "space-between"
  };
});
function shouldForwardProp(prop) {
  return prop !== "isScrollTargetActive";
}

function BulletinPostsEmptyState() {
  return /*#__PURE__*/React__namespace.default.createElement(MessageContainer, null, /*#__PURE__*/React__namespace.default.createElement(EmptyStateMessage, null, "Your posts will appear here"));
}
var MessageContainer = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    flexDirection: "column",
    justifyContent: "center",
    minHeight: "10rem"
  };
});
var EmptyStateMessage = styled__default.default(Typography$1)(function (_ref) {
  var theme = _ref.theme;
  return {
    alignSelf: "center",
    fontSize: theme.typography.h5.fontSize,
    color: theme.palette.text.secondary
  };
});

function BulletinPostList(_ref) {
  var posts = _ref.posts;
  if (!posts.length) return /*#__PURE__*/React__namespace.default.createElement(BulletinPostsEmptyState, null);
  return /*#__PURE__*/React__namespace.default.createElement(Box$3, null, posts.map(function (post) {
    return /*#__PURE__*/React__namespace.default.createElement(BulletinPostItem, {
      post: post,
      key: post.id
    });
  }));
}
BulletinPostList.propTypes = {
  posts: propTypesExports.array
};

var AddCircleOutline = {};

var _interopRequireDefault$z = interopRequireDefaultExports;
Object.defineProperty(AddCircleOutline, "__esModule", {
  value: true
});
var default_1$z = AddCircleOutline.default = void 0;
var _createSvgIcon$z = _interopRequireDefault$z(requireCreateSvgIcon());
var _jsxRuntime$z = requireJsxRuntime();
var _default$z = (0, _createSvgIcon$z.default)( /*#__PURE__*/(0, _jsxRuntime$z.jsx)("path", {
  d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
}), 'AddCircleOutline');
default_1$z = AddCircleOutline.default = _default$z;

var iconSize = {
  fontSize: 28
};
function AddButton(_ref) {
  var onClick = _ref.onClick,
    style = _ref.style,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled;
  var styles = getStyle({
    style: style
  });
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$8, {
    "data-testid": TEST_IDS.ADD_BUTTON,
    variant: "text",
    color: "info",
    onClick: onClick,
    disabled: disabled
  }, /*#__PURE__*/React__namespace.default.createElement(default_1$z, {
    sx: styles
  }));
}
AddButton.propTypes = {
  onClick: propTypesExports.func,
  disabled: propTypesExports.bool,
  style: propTypesExports.object
};
var StyledButton$8 = styled__default.default(IconButton$2)({
  minWidth: 0,
  padding: 5
});
function getStyle(_ref2) {
  var style = _ref2.style;
  return _objectSpread2(_objectSpread2({}, iconSize), style);
}

function BulletinPostsHeader() {
  var styles = getStyles$9();
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isModalOpen = _useState2[0],
    setIsModalOpen = _useState2[1];
  var _useBulletinPosts = useBulletinPosts(),
    isMutationLoading = _useBulletinPosts.isMutationLoading,
    shouldAllowMutations = _useBulletinPosts.shouldAllowMutations,
    title = _useBulletinPosts.title;
  return /*#__PURE__*/React__namespace.default.createElement(Container$p, null, /*#__PURE__*/React__namespace.default.createElement(Title$4, null, title), shouldAllowMutations && /*#__PURE__*/React__namespace.default.createElement(AddButton, {
    sx: styles.addButton,
    onClick: function onClick() {
      return setIsModalOpen(!isModalOpen);
    },
    disabled: isMutationLoading
  }), /*#__PURE__*/React__namespace.default.createElement(CreateOrUpdateBulletinModal, {
    isOpen: isModalOpen,
    onClose: function onClose() {
      return setIsModalOpen(!isModalOpen);
    },
    title: "Create a post",
    inputLabel: "What do you want to announce?",
    buttonLabel: "Post"
  }));
}
var Container$p = styled__default.default(Box$3)(function (_ref) {
  var theme = _ref.theme;
  return {
    padding: "2px 2px 2px 6px",
    height: "3rem",
    display: "flex",
    alignItems: "center",
    borderBottom: "1px solid ".concat(theme.palette.card.divider)
  };
});
var Title$4 = styled__default.default(material.Typography)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    fontSize: theme.typography.h4.fontSize,
    color: theme.palette.text.primary,
    fontWeight: theme.typography.h4.fontWeight,
    marginLeft: "1rem"
  };
});
function getStyles$9() {
  return {
    addButton: {
      fontSize: "20px"
    }
  };
}

function BulletinPostsShowMore() {
  var _useBulletinPosts = useBulletinPosts(),
    getMoreBulletinPosts = _useBulletinPosts.getMoreBulletinPosts;
  return /*#__PURE__*/React__namespace.default.createElement(ShowMoreContainer, null, /*#__PURE__*/React__namespace.default.createElement(ShowMoreContent, {
    onClick: getMoreBulletinPosts
  }, SHOW_MORE));
}
var ShowMoreContainer = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    justifyContent: "center",
    alignItems: "center",
    height: "3rem"
  };
});
var ShowMoreContent = styled__default.default(material.Typography)(function (_ref) {
  var theme = _ref.theme;
  return {
    fontSize: 14,
    fontWeight: theme.typography.h6.fontWeight,
    color: theme.palette.text.secondary,
    cursor: "pointer"
  };
});

function BulletinPostItemSkeleton() {
  return /*#__PURE__*/React__namespace.default.createElement(Container$o, null, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: "10%",
    isRounded: true
  }), /*#__PURE__*/React__namespace.default.createElement(Box$3, null, /*#__PURE__*/React__namespace.default.createElement(TitleSkeletonContainer, null, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: "50%"
  }), /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: "20%"
  })), /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: 200
  })), /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    width: "5%"
  }));
}
var Container$o = styled__default.default(Box$3)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: "flex",
    padding: "0.5rem",
    justifyContent: "space-between",
    borderBottom: "1px solid ".concat(theme.palette.card.divider)
  };
});
var TitleSkeletonContainer = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "row",
    alignItems: "center",
    gap: "0.5rem"
  };
});

function BulletinPostListSkeleton(_ref) {
  var _ref$count = _ref.count,
    count = _ref$count === void 0 ? 10 : _ref$count;
  return /*#__PURE__*/React__namespace.default.createElement(Box$3, {
    "data-testid": TEST_IDS.BULLETIN_POSTS_LIST_SKELETON
  }, /*#__PURE__*/React__namespace.default.createElement(SkeletonList, {
    count: count,
    SkeletonComponent: BulletinPostItemSkeleton,
    isLoading: true
  }));
}
BulletinPostListSkeleton.propTypes = {
  count: propTypesExports.number
};

function BulletinPostsHeaderSkeleton() {
  return /*#__PURE__*/React__namespace.default.createElement(SkeletonContainer, {
    "data-testid": TEST_IDS.BULLETIN_POSTS_HEADER_SKELETON
  }, /*#__PURE__*/React__namespace.default.createElement(TitleSkeleton, null), /*#__PURE__*/React__namespace.default.createElement(IconSkeleton, null));
}
var SkeletonContainer = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    gap: "0.5rem",
    marginLeft: "1rem"
  };
});
var TitleSkeleton = styled__default.default(Skeleton)(function () {
  return {
    borderRadius: "12px",
    width: "8rem",
    height: "2.5rem"
  };
});
var IconSkeleton = styled__default.default(Skeleton)(function () {
  return {
    borderRadius: "20px",
    width: "1.3rem"
  };
});

function BulletinSkeleton() {
  return /*#__PURE__*/React__namespace.default.createElement(BulletinPostsContainer$1, {
    variant: "outlined"
  }, /*#__PURE__*/React__namespace.default.createElement(HeaderContainer, null, /*#__PURE__*/React__namespace.default.createElement(BulletinPostsHeaderSkeleton, null)), /*#__PURE__*/React__namespace.default.createElement(BulletinPostListSkeleton, null));
}
var BulletinPostsContainer$1 = styled__default.default(material.Card)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: "flex",
    flexDirection: "column",
    borderColor: theme.palette.colors.border.secondary,
    backgroundColor: theme.palette.card.background,
    width: "20rem",
    borderRadius: 15,
    minHeight: "40rem"
  };
});
var HeaderContainer = styled__default.default(material.Box)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    padding: "2px 2px 2px 6px",
    height: "3rem",
    display: "flex",
    alignItems: "center",
    borderBottom: "1px solid ".concat(theme.palette.card.divider)
  };
});

var DEFAULT_MAX_HEIGHT = "40rem";
var DEFAULT_CONTAINER_WIDTH = "100%";
function BulletinPosts(_ref) {
  var _ref$containerWidth = _ref.containerWidth,
    containerWidth = _ref$containerWidth === void 0 ? DEFAULT_CONTAINER_WIDTH : _ref$containerWidth,
    _ref$maxHeight = _ref.maxHeight,
    maxHeight = _ref$maxHeight === void 0 ? DEFAULT_MAX_HEIGHT : _ref$maxHeight;
  var _useBulletinPosts = useBulletinPosts(),
    totalPosts = _useBulletinPosts.total,
    isQueryLoading = _useBulletinPosts.isLoading,
    error = _useBulletinPosts.error,
    bulletinPosts = _useBulletinPosts.bulletinPosts,
    onScrollToPostFailure = _useBulletinPosts.onScrollToPostFailure;
  useCheckIfHasScrollTarget({
    entities: bulletinPosts,
    onScrollToPostFailure: onScrollToPostFailure,
    entityType: ENTITY_TYPES.BULLETIN_POSTS
  });
  if (isQueryLoading) return /*#__PURE__*/React__namespace.default.createElement(BulletinSkeleton, null);
  if (error) return /*#__PURE__*/React__namespace.default.createElement(ErrorMessage, {
    error: error
  });
  var shouldShowMore = bulletinPosts.length !== totalPosts;
  return /*#__PURE__*/React__namespace.default.createElement(BulletinPostsContainer, {
    variant: "outlined",
    width: containerWidth
  }, /*#__PURE__*/React__namespace.default.createElement(BulletinPostsHeader, null), /*#__PURE__*/React__namespace.default.createElement(BulletinListContainer, {
    maxHeight: maxHeight
  }, /*#__PURE__*/React__namespace.default.createElement(BulletinPostList, {
    posts: bulletinPosts
  }), shouldShowMore && /*#__PURE__*/React__namespace.default.createElement(BulletinPostsShowMore, null)));
}
BulletinPosts.propTypes = {
  containerWidth: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  maxHeight: propTypesExports.string,
  onScrollToPostFailure: propTypesExports.func
};
var BulletinPostsContainer = styled__default.default(material.Card, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref2) {
  var theme = _ref2.theme,
    width = _ref2.width;
  return {
    display: "flex",
    flexDirection: "column",
    borderColor: theme.palette.colors.border.secondary,
    backgroundColor: theme.palette.card.background,
    width: width,
    borderRadius: theme.borderRadius.lg
  };
});
var BulletinListContainer = styled__default.default(material.Box, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref3) {
  var maxHeight = _ref3.maxHeight;
  return {
    maxHeight: maxHeight,
    overflow: "scroll"
  };
});

function BulletinBoard(_ref) {
  var maxHeight = _ref.maxHeight;
  return /*#__PURE__*/React__namespace.default.createElement(BulletinPosts, {
    containerWidth: "100%",
    maxHeight: maxHeight
  });
}
BulletinBoard.propTypes = {
  maxHeight: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.number])
};

var _BUTTONS_ALIGNMENT_TO;
var BUTTONS_ALIGNMENT = {
  LEFT: "left",
  CENTER: "center",
  RIGHT: "right"
};
var BUTTONS_ALIGNMENT_TO_JUSTIFY_CONTENT = (_BUTTONS_ALIGNMENT_TO = {}, _defineProperty(_BUTTONS_ALIGNMENT_TO, BUTTONS_ALIGNMENT.LEFT, "flex-start"), _defineProperty(_BUTTONS_ALIGNMENT_TO, BUTTONS_ALIGNMENT.CENTER, "center"), _defineProperty(_BUTTONS_ALIGNMENT_TO, BUTTONS_ALIGNMENT.RIGHT, "flex-end"), _BUTTONS_ALIGNMENT_TO);
function CancelAndSaveButtons(_ref) {
  var _ref$saveButtonLabel = _ref.saveButtonLabel,
    saveButtonLabel = _ref$saveButtonLabel === void 0 ? "Save" : _ref$saveButtonLabel,
    _ref$cancelButtonLabe = _ref.cancelButtonLabel,
    cancelButtonLabel = _ref$cancelButtonLabe === void 0 ? "Cancel" : _ref$cancelButtonLabe,
    onSaveClick = _ref.onSaveClick,
    onCancelClick = _ref.onCancelClick,
    isLoading = _ref.isLoading,
    _ref$alignment = _ref.alignment,
    alignment = _ref$alignment === void 0 ? BUTTONS_ALIGNMENT.RIGHT : _ref$alignment,
    _ref$showCancelButton = _ref.showCancelButton,
    showCancelButton = _ref$showCancelButton === void 0 ? true : _ref$showCancelButton;
  return /*#__PURE__*/React__namespace.default.createElement(ButtonsContainer, {
    alignment: alignment
  }, showCancelButton && /*#__PURE__*/React__namespace.default.createElement(Button, {
    variant: "outlined",
    onClick: function onClick() {
      return onCancelClick();
    }
  }, cancelButtonLabel), /*#__PURE__*/React__namespace.default.createElement(Button, {
    variant: "contained",
    onClick: function onClick() {
      return onSaveClick();
    },
    loading: isLoading
  }, saveButtonLabel));
}
CancelAndSaveButtons.propTypes = {
  saveButtonLabel: propTypesExports.string,
  cancelButtonLabel: propTypesExports.string,
  onSaveClick: propTypesExports.func.isRequired,
  onCancelClick: propTypesExports.func.isRequired,
  isLoading: propTypesExports.bool,
  alignment: propTypesExports.string,
  showCancelButton: propTypesExports.bool
};
var ButtonsContainer = styled__default.default(Box$1)(function (_ref2) {
  var alignment = _ref2.alignment;
  return {
    display: "flex",
    justifyContent: BUTTONS_ALIGNMENT_TO_JUSTIFY_CONTENT[alignment],
    gap: 20,
    padding: "20px 0"
  };
});

var Circle$1 = {};

var _interopRequireDefault$y = interopRequireDefaultExports;
Object.defineProperty(Circle$1, "__esModule", {
  value: true
});
var default_1$y = Circle$1.default = void 0;
var _createSvgIcon$y = _interopRequireDefault$y(requireCreateSvgIcon());
var _jsxRuntime$y = requireJsxRuntime();
var _default$y = (0, _createSvgIcon$y.default)( /*#__PURE__*/(0, _jsxRuntime$y.jsx)("path", {
  d: "M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2z"
}), 'Circle');
default_1$y = Circle$1.default = _default$y;

function CircledButtonIcon(_ref) {
  var IconComponent = _ref.IconComponent,
    onClick = _ref.onClick;
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$7, {
    variant: "text",
    color: "secondary",
    onClick: onClick,
    "data-testid": TEST_IDS.CIRCLED_BUTTON_ICON
  }, /*#__PURE__*/React__namespace.default.createElement(BackgroundIcon, null), /*#__PURE__*/React__namespace.default.createElement(IconComponent, null));
}
CircledButtonIcon.propTypes = {
  IconComponent: propTypesExports.any.isRequired,
  onClick: propTypesExports.func.isRequired
};
var BackgroundIcon = styled__default.default(default_1$y)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    color: theme.palette.colors.icon.neutral,
    position: "absolute",
    fontSize: 45,
    opacity: 0.2
  };
});
var StyledButton$7 = styled__default.default(IconButton$2)(function () {
  return {
    padding: 2,
    position: "sticky",
    marginRight: "25px",
    left: "100%",
    top: 24,
    zIndex: 1
  };
});

var Download = {};

var _interopRequireDefault$x = interopRequireDefaultExports;
Object.defineProperty(Download, "__esModule", {
  value: true
});
var default_1$x = Download.default = void 0;
var _createSvgIcon$x = _interopRequireDefault$x(requireCreateSvgIcon());
var _jsxRuntime$x = requireJsxRuntime();
var _default$x = (0, _createSvgIcon$x.default)( /*#__PURE__*/(0, _jsxRuntime$x.jsx)("path", {
  d: "M5 20h14v-2H5v2zM19 9h-4V3H9v6H5l7 7 7-7z"
}), 'Download');
default_1$x = Download.default = _default$x;

var _excluded$s = ["Icon", "onClick", "color", "isLoading", "tooltip"];

// Icon inherits fontSize so it can be controlled via the button styling.
function IconButton(_ref) {
  var Icon = _ref.Icon,
    _onClick = _ref.onClick,
    _ref$color = _ref.color,
    color = _ref$color === void 0 ? "primary" : _ref$color,
    isLoading = _ref.isLoading,
    tooltip = _ref.tooltip,
    props = _objectWithoutProperties(_ref, _excluded$s);
  return /*#__PURE__*/React__namespace.default.createElement(Tooltip$1, {
    title: tooltip,
    placement: "top"
  }, /*#__PURE__*/React__namespace.default.createElement(StyledIconButton, _extends$2({}, props, {
    onClick: function onClick() {
      return _onClick();
    },
    color: color,
    disabled: isLoading
  }), isLoading ? /*#__PURE__*/React__namespace.default.createElement(Spinner, {
    color: color
  }) : /*#__PURE__*/React__namespace.default.createElement(Icon, {
    fontSize: "inherit"
  })));
}
IconButton.propTypes = {
  Icon: propTypesExports.elementType,
  onClick: propTypesExports.func,
  color: propTypesExports.string,
  isLoading: propTypesExports.bool,
  tooltip: propTypesExports.string
};
var StyledIconButton = styled__default.default(IconButton$2)({
  fontSize: "28px"
});
var Spinner = styled__default.default(CircularProgress$1)({
  width: "28px !important",
  height: "28px !important"
});

function DownloadButton(_ref) {
  var onClick = _ref.onClick,
    color = _ref.color;
  return /*#__PURE__*/React__namespace.default.createElement(IconButton, {
    "data-testid": TEST_IDS.DOWNLOAD_BUTTON,
    onClick: onClick,
    color: color,
    Icon: default_1$x
  });
}
DownloadButton.propTypes = {
  onClick: propTypesExports.func,
  color: propTypesExports.string
};

var _excluded$r = ["label", "Icon", "onClick"];
function IconTextButton(_ref) {
  var label = _ref.label,
    Icon = _ref.Icon,
    onClick = _ref.onClick,
    props = _objectWithoutProperties(_ref, _excluded$r);
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$6, _extends$2({}, props, {
    onClick: onClick,
    startIcon: /*#__PURE__*/React__namespace.default.createElement(Icon, null)
  }), label);
}
IconTextButton.propTypes = {
  label: propTypesExports.string.isRequired,
  Icon: propTypesExports.object.isRequired,
  onClick: propTypesExports.func.isRequired
};
var StyledButton$6 = styled__default.default(Button$2)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    borderRadius: theme.borderRadius.lg,
    padding: "2px 10px",
    textTransform: "none",
    fontSize: theme.typography.h6.fontSize
  };
});

var _excluded$q = ["total", "completed", "loadingLabel", "children"];
function ProgressSubmitButton(_ref) {
  var total = _ref.total,
    completed = _ref.completed,
    _ref$loadingLabel = _ref.loadingLabel,
    loadingLabel = _ref$loadingLabel === void 0 ? "Uploading files..." : _ref$loadingLabel,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded$q);
  var progress = getProgress({
    completed: completed,
    total: total
  });
  return /*#__PURE__*/React__namespace.default.createElement(Button, _extends$2({}, props, {
    variant: "contained",
    loadingIndicator: /*#__PURE__*/React__namespace.default.createElement(LoadingContainer, null, /*#__PURE__*/React__namespace.default.createElement(CircularProgress$1, {
      color: "secondary",
      variant: "determinate",
      value: progress,
      size: 20
    }), /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
      ml: 1,
      variant: "subtitle2",
      color: "secondary"
    }, loadingLabel))
  }), children);
}
ProgressSubmitButton.propTypes = {
  total: propTypesExports.number,
  completed: propTypesExports.number,
  children: propTypesExports.node,
  loadingLabel: propTypesExports.string
};
function getProgress(_ref2) {
  var completed = _ref2.completed,
    total = _ref2.total;
  // any 0 value we should show initial progress of 1
  if (!completed || !total) return 1;
  var percentUploaded = completed / total * 100;
  return Math.round(percentUploaded);
}
var LoadingContainer = styled__default.default(Box$1)({
  alignItems: "center",
  display: "flex",
  flexDirection: "row"
});

var RemoveCircleOutline = {};

var _interopRequireDefault$w = interopRequireDefaultExports;
Object.defineProperty(RemoveCircleOutline, "__esModule", {
  value: true
});
var default_1$w = RemoveCircleOutline.default = void 0;
var _createSvgIcon$w = _interopRequireDefault$w(requireCreateSvgIcon());
var _jsxRuntime$w = requireJsxRuntime();
var _default$w = (0, _createSvgIcon$w.default)( /*#__PURE__*/(0, _jsxRuntime$w.jsx)("path", {
  d: "M7 11v2h10v-2H7zm5-9C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
}), 'RemoveCircleOutline');
default_1$w = RemoveCircleOutline.default = _default$w;

function RemoveButton(_ref) {
  var onClick = _ref.onClick;
  return /*#__PURE__*/React__namespace.default.createElement(SyledButton, {
    "data-testid": TEST_IDS.REMOVE_BUTTON,
    variant: "text",
    color: "error",
    onClick: onClick
  }, /*#__PURE__*/React__namespace.default.createElement(default_1$w, null));
}
RemoveButton.propTypes = {
  onClick: propTypesExports.func.isRequired
};
var SyledButton = styled__default.default(IconButton$2)({
  minWidth: 0,
  padding: 5
});

function ToggleButton(_ref) {
  var isExpanded = _ref.isExpanded,
    onClick = _ref.onClick;
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$5, {
    color: "primary",
    variant: "text",
    size: "small",
    onClick: onClick,
    "data-testid": TEST_IDS.COLLAPSIBLE_TEXT_TOGGLE_BUTTON
  }, isExpanded ? SHOW_LESS : SHOW_MORE);
}
ToggleButton.propTypes = {
  isExpanded: propTypesExports.bool.isRequired,
  onClick: propTypesExports.func.isRequired
};
var StyledButton$5 = styled__default.default(Button$2)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    fontSize: theme.typography.subtitle2.fontSize
  };
});

// Based on https://github.com/cameronDz/more-less-medium-app/blob/master/src/App.js
function CollapsibleText(_ref) {
  var text = _ref.text,
    _ref$TextComponent = _ref.TextComponent,
    TextComponent = _ref$TextComponent === void 0 ? Typography$1 : _ref$TextComponent,
    _ref$defaultHeight = _ref.defaultHeight,
    defaultHeight = _ref$defaultHeight === void 0 ? 30 : _ref$defaultHeight;
  var textDisplayRef = React.useRef(null);
  var _useState = React.useState({
      min: defaultHeight,
      max: defaultHeight,
      current: defaultHeight
    }),
    _useState2 = _slicedToArray(_useState, 2),
    heights = _useState2[0],
    setHeights = _useState2[1];
  var _useState3 = React.useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    isExpanded = _useState4[0],
    setIsExpanded = _useState4[1];
  var _useState5 = React.useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    isOverflowing = _useState6[0],
    setIsOverflowing = _useState6[1];
  React.useEffect(function () {
    setStateBasedOnRenderedText({
      defaultHeight: defaultHeight,
      textDisplayRef: textDisplayRef,
      setIsOverflowing: setIsOverflowing,
      setHeights: setHeights
    });
  }, [text, defaultHeight]);
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(CollapsibleContainer, {
    ref: textDisplayRef,
    isExpanded: isExpanded,
    height: heights.current,
    "data-testid": TEST_IDS.COLLAPSIBLE_TEXT_CONTAINER
  }, /*#__PURE__*/React__namespace.default.createElement(TextComponent, null, text)), isOverflowing && /*#__PURE__*/React__namespace.default.createElement(ToggleButton, {
    isExpanded: isExpanded,
    onClick: function onClick() {
      return handleOnClick$2({
        heights: heights,
        setHeights: setHeights,
        isExpanded: isExpanded,
        setIsExpanded: setIsExpanded
      });
    }
  }));
}
CollapsibleText.propTypes = {
  text: propTypesExports.string,
  defaultHeight: propTypesExports.number,
  TextComponent: propTypesExports.elementType
};
function handleOnClick$2(_ref2) {
  var heights = _ref2.heights,
    setHeights = _ref2.setHeights,
    isExpanded = _ref2.isExpanded,
    setIsExpanded = _ref2.setIsExpanded;
  setHeights(function (existingValue) {
    return _objectSpread2(_objectSpread2({}, existingValue), {}, {
      current: isExpanded ? heights.min : heights.max
    });
  });
  setIsExpanded(function (prev) {
    return !prev;
  });
}
function setStateBasedOnRenderedText(_ref3) {
  var _textDisplayRef$curre, _textDisplayRef$curre2;
  var defaultHeight = _ref3.defaultHeight,
    textDisplayRef = _ref3.textDisplayRef,
    setIsOverflowing = _ref3.setIsOverflowing,
    setHeights = _ref3.setHeights;
  var clientHeight = (textDisplayRef === null || textDisplayRef === void 0 ? void 0 : (_textDisplayRef$curre = textDisplayRef.current) === null || _textDisplayRef$curre === void 0 ? void 0 : _textDisplayRef$curre.clientHeight) || defaultHeight;
  var scrollHeight = (textDisplayRef === null || textDisplayRef === void 0 ? void 0 : (_textDisplayRef$curre2 = textDisplayRef.current) === null || _textDisplayRef$curre2 === void 0 ? void 0 : _textDisplayRef$curre2.scrollHeight) || defaultHeight;
  if (clientHeight !== scrollHeight) {
    setIsOverflowing(true);
    setHeights({
      max: scrollHeight,
      min: clientHeight,
      current: clientHeight
    });
  }
}
var CollapsibleContainer = styled__default.default(Box$1, {
  shouldForwardProp: function shouldForwardProp(prop) {
    return prop !== "isExpanded";
  }
})(function (_ref4) {
  var isExpanded = _ref4.isExpanded;
  return _objectSpread2({
    lineHeight: "18px",
    overflow: "hidden",
    transition: "height 0.5s ease-in-out"
  }, isExpanded ? {
    animation: "mask-expanding 0.5s",
    maskImage: "linear-gradient(black 100%, transparent)"
  } : {
    animation: "mask-collapsing 0.5s",
    maskImage: "linear-gradient(black 50%, transparent)"
  });
});

var Description$2 = {};

var _interopRequireDefault$v = interopRequireDefaultExports;
Object.defineProperty(Description$2, "__esModule", {
  value: true
});
var default_1$v = Description$2.default = void 0;
var _createSvgIcon$v = _interopRequireDefault$v(requireCreateSvgIcon());
var _jsxRuntime$v = requireJsxRuntime();
var _default$v = (0, _createSvgIcon$v.default)( /*#__PURE__*/(0, _jsxRuntime$v.jsx)("path", {
  d: "M14 2H6c-1.1 0-1.99.9-1.99 2L4 20c0 1.1.89 2 1.99 2H18c1.1 0 2-.9 2-2V8l-6-6zm2 16H8v-2h8v2zm0-4H8v-2h8v2zm-3-5V3.5L18.5 9H13z"
}), 'Description');
default_1$v = Description$2.default = _default$v;

var FileCopy = {};

var _interopRequireDefault$u = interopRequireDefaultExports;
Object.defineProperty(FileCopy, "__esModule", {
  value: true
});
var default_1$u = FileCopy.default = void 0;
var _createSvgIcon$u = _interopRequireDefault$u(requireCreateSvgIcon());
var _jsxRuntime$u = requireJsxRuntime();
var _default$u = (0, _createSvgIcon$u.default)( /*#__PURE__*/(0, _jsxRuntime$u.jsx)("path", {
  d: "M16 1H4c-1.1 0-2 .9-2 2v14h2V3h12V1zm-1 4 6 6v10c0 1.1-.9 2-2 2H7.99C6.89 23 6 22.1 6 21l.01-14c0-1.1.89-2 1.99-2h7zm-1 7h5.5L14 6.5V12z"
}), 'FileCopy');
default_1$u = FileCopy.default = _default$u;

var Flag = {};

var _interopRequireDefault$t = interopRequireDefaultExports;
Object.defineProperty(Flag, "__esModule", {
  value: true
});
var default_1$t = Flag.default = void 0;
var _createSvgIcon$t = _interopRequireDefault$t(requireCreateSvgIcon());
var _jsxRuntime$t = requireJsxRuntime();
var _default$t = (0, _createSvgIcon$t.default)( /*#__PURE__*/(0, _jsxRuntime$t.jsx)("path", {
  d: "M14.4 6 14 4H5v17h2v-7h5.6l.4 2h7V6z"
}), 'Flag');
default_1$t = Flag.default = _default$t;

var Image$2 = {};

var _interopRequireDefault$s = interopRequireDefaultExports;
Object.defineProperty(Image$2, "__esModule", {
  value: true
});
var default_1$s = Image$2.default = void 0;
var _createSvgIcon$s = _interopRequireDefault$s(requireCreateSvgIcon());
var _jsxRuntime$s = requireJsxRuntime();
var _default$s = (0, _createSvgIcon$s.default)( /*#__PURE__*/(0, _jsxRuntime$s.jsx)("path", {
  d: "M21 19V5c0-1.1-.9-2-2-2H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2zM8.5 13.5l2.5 3.01L14.5 12l4.5 6H5l3.5-4.5z"
}), 'Image');
default_1$s = Image$2.default = _default$s;

var Phone = {};

var _interopRequireDefault$r = interopRequireDefaultExports;
Object.defineProperty(Phone, "__esModule", {
  value: true
});
var default_1$r = Phone.default = void 0;
var _createSvgIcon$r = _interopRequireDefault$r(requireCreateSvgIcon());
var _jsxRuntime$r = requireJsxRuntime();
var _default$r = (0, _createSvgIcon$r.default)( /*#__PURE__*/(0, _jsxRuntime$r.jsx)("path", {
  d: "M6.62 10.79c1.44 2.83 3.76 5.14 6.59 6.59l2.2-2.2c.27-.27.67-.36 1.02-.24 1.12.37 2.33.57 3.57.57.55 0 1 .45 1 1V20c0 .55-.45 1-1 1-9.39 0-17-7.61-17-17 0-.55.45-1 1-1h3.5c.55 0 1 .45 1 1 0 1.25.2 2.45.57 3.57.11.35.03.74-.25 1.02l-2.2 2.2z"
}), 'Phone');
default_1$r = Phone.default = _default$r;

var Place = {};

var _interopRequireDefault$q = interopRequireDefaultExports;
Object.defineProperty(Place, "__esModule", {
  value: true
});
var default_1$q = Place.default = void 0;
var _createSvgIcon$q = _interopRequireDefault$q(requireCreateSvgIcon());
var _jsxRuntime$q = requireJsxRuntime();
var _default$q = (0, _createSvgIcon$q.default)( /*#__PURE__*/(0, _jsxRuntime$q.jsx)("path", {
  d: "M12 2C8.13 2 5 5.13 5 9c0 5.25 7 13 7 13s7-7.75 7-13c0-3.87-3.13-7-7-7zm0 9.5c-1.38 0-2.5-1.12-2.5-2.5s1.12-2.5 2.5-2.5 2.5 1.12 2.5 2.5-1.12 2.5-2.5 2.5z"
}), 'Place');
default_1$q = Place.default = _default$q;

var Sell = {};

var _interopRequireDefault$p = interopRequireDefaultExports;
Object.defineProperty(Sell, "__esModule", {
  value: true
});
var default_1$p = Sell.default = void 0;
var _createSvgIcon$p = _interopRequireDefault$p(requireCreateSvgIcon());
var _jsxRuntime$p = requireJsxRuntime();
var _default$p = (0, _createSvgIcon$p.default)( /*#__PURE__*/(0, _jsxRuntime$p.jsx)("path", {
  d: "m21.41 11.41-8.83-8.83c-.37-.37-.88-.58-1.41-.58H4c-1.1 0-2 .9-2 2v7.17c0 .53.21 1.04.59 1.41l8.83 8.83c.78.78 2.05.78 2.83 0l7.17-7.17c.78-.78.78-2.04-.01-2.83zM6.5 8C5.67 8 5 7.33 5 6.5S5.67 5 6.5 5 8 5.67 8 6.5 7.33 8 6.5 8z"
}), 'Sell');
default_1$p = Sell.default = _default$p;

var ShortText = {};

var _interopRequireDefault$o = interopRequireDefaultExports;
Object.defineProperty(ShortText, "__esModule", {
  value: true
});
var default_1$o = ShortText.default = void 0;
var _createSvgIcon$o = _interopRequireDefault$o(requireCreateSvgIcon());
var _jsxRuntime$o = requireJsxRuntime();
var _default$o = (0, _createSvgIcon$o.default)( /*#__PURE__*/(0, _jsxRuntime$o.jsx)("path", {
  d: "M4 9h16v2H4V9zm0 4h10v2H4v-2z"
}), 'ShortText');
default_1$o = ShortText.default = _default$o;

var SmartDisplay = {};

var _interopRequireDefault$n = interopRequireDefaultExports;
Object.defineProperty(SmartDisplay, "__esModule", {
  value: true
});
var default_1$n = SmartDisplay.default = void 0;
var _createSvgIcon$n = _interopRequireDefault$n(requireCreateSvgIcon());
var _jsxRuntime$n = requireJsxRuntime();
var _default$n = (0, _createSvgIcon$n.default)( /*#__PURE__*/(0, _jsxRuntime$n.jsx)("path", {
  d: "M20 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zM9.5 16.5v-9l7 4.5-7 4.5z"
}), 'SmartDisplay');
default_1$n = SmartDisplay.default = _default$n;

var _CONTENT_BLOCK_DROPDO;
var CONTENT_BLOCK_DROPDOWN_OPTIONS_BY_TYPE = (_CONTENT_BLOCK_DROPDO = {}, _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.ADDRESS, {
  label: "Address",
  value: CONTENT_BLOCK_TYPES.ADDRESS,
  Icon: default_1$q
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.BANNER, {
  label: "Banner",
  value: CONTENT_BLOCK_TYPES.BANNER,
  Icon: default_1$t
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.CONTACT, {
  label: "Contact",
  value: CONTENT_BLOCK_TYPES.CONTACT,
  Icon: default_1$r
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.IMAGE, {
  label: "Image",
  value: CONTENT_BLOCK_TYPES.IMAGE,
  Icon: default_1$s
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.TAGS, {
  label: "Tags",
  value: CONTENT_BLOCK_TYPES.TAGS,
  Icon: default_1$p
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.TEXT, {
  label: "Text",
  value: CONTENT_BLOCK_TYPES.TEXT,
  Icon: default_1$o
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.VIDEO, {
  label: "Video",
  value: CONTENT_BLOCK_TYPES.VIDEO,
  Icon: default_1$n
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.PDF, {
  label: "PDF",
  value: CONTENT_BLOCK_TYPES.PDF,
  Icon: default_1$u
}), _defineProperty(_CONTENT_BLOCK_DROPDO, CONTENT_BLOCK_TYPES.FORM, {
  label: "Form",
  value: CONTENT_BLOCK_TYPES.FORM,
  Icon: default_1$v
}), _CONTENT_BLOCK_DROPDO);
function getBlockInitialValueByType() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : CONTENT_BLOCK_TYPES.TEXT;
  return {
    type: type,
    title: null,
    content: null,
    url: null,
    pills: [],
    url_list: []
  };
}
function getDropDownOptionsForContentBlockType() {
  return Object.values(CONTENT_BLOCK_DROPDOWN_OPTIONS_BY_TYPE);
}
function getTitleRowId(_ref) {
  var sectionIndex = _ref.sectionIndex;
  return "section_title_".concat(sectionIndex);
}
function getInputComponentId(_ref2) {
  var sectionIndex = _ref2.sectionIndex,
    blockIndex = _ref2.blockIndex;
  return "content_section_".concat(sectionIndex, "_block_").concat(blockIndex);
}
function getDropdownInputContainerId(_ref3) {
  var sectionIndex = _ref3.sectionIndex,
    blockIndex = _ref3.blockIndex;
  return "dropdown_section_".concat(sectionIndex, "_block_").concat(blockIndex);
}
function getSectionRowId(_ref4) {
  var sectionIndex = _ref4.sectionIndex;
  return "section_".concat(sectionIndex);
}
function removeEmptySectionsAndBlocks(sections) {
  return sections.reduce(function (sectionsArray, section) {
    var blocksWithValues = filterEmptyBlocks(section.blocks);
    var sectionWithoutEmptyBlocks = _objectSpread2(_objectSpread2({}, section), {}, {
      blocks: blocksWithValues
    });
    if (isEmptySection(sectionWithoutEmptyBlocks)) return sectionsArray;
    return [].concat(_toConsumableArray(sectionsArray), [sectionWithoutEmptyBlocks]);
  }, []);
}
function isEmptySection(section) {
  var _section$blocks;
  return !section.title && !((_section$blocks = section.blocks) !== null && _section$blocks !== void 0 && _section$blocks.length);
}
function filterEmptyBlocks(blocks) {
  if (!blocks) return [];
  return blocks.filter(function (block) {
    var _block$url_list, _block$pills;
    var isBlockEmpty = !block.title && !block.content && !block.url && !((_block$url_list = block.url_list) !== null && _block$url_list !== void 0 && _block$url_list.length) && !((_block$pills = block.pills) !== null && _block$pills !== void 0 && _block$pills.length);
    return !isBlockEmpty;
  });
}
function convertImageBlockUrlToUrlList(block) {
  var _block$url_list2;
  if (block.type !== CONTENT_BLOCK_TYPES.IMAGE) {
    return null;
  }
  if ((_block$url_list2 = block.url_list) !== null && _block$url_list2 !== void 0 && _block$url_list2.length) return {
    url: null
  };

  // needs to set url to null to prevent bad data from being passed
  return {
    url_list: block.url ? [block.url] : [],
    url: null
  };
}

var nameValidator = yup__namespace.string().max(CONTENT_BLOCK_VALIDATION_LIMITS.NAME.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.NAME.MAX).required(CONTENT_BLOCK_VALIDATION_MESSAGES.NAME.REQUIRED);
var urlValidator = yup__namespace.string().matches(urlRegex__default.default({
  exact: true,
  strict: false
}), CONTENT_BLOCK_VALIDATION_MESSAGES.URL.MATCHES).max(CONTENT_BLOCK_VALIDATION_LIMITS.URL.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.URL.MAX);
var urlListValidator = yup__namespace.array().max(CONTENT_BLOCK_VALIDATION_LIMITS.URL_LIST.MAX);
var commonPillsValidators = {
  color: yup__namespace.string()["default"](TAG_RED)
};
var addressValidator = yup__namespace.object(_objectSpread2(_objectSpread2({}, commonPillsValidators), {}, {
  icon: yup__namespace.string()["default"](CONTENT_BLOCK_ICONS.CAR),
  content: yup__namespace.string().max(CONTENT_BLOCK_VALIDATION_LIMITS.PILL_CONTENT.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.PILL_CONTENT.MAX).required(CONTENT_BLOCK_VALIDATION_MESSAGES.PILL_CONTENT.REQUIRED),
  url: urlValidator.required(CONTENT_BLOCK_VALIDATION_MESSAGES.PILL_URL.REQUIRED)
}));
var contactValidator = yup__namespace.object(_objectSpread2(_objectSpread2({}, commonPillsValidators), {}, {
  icon: yup__namespace.string()["default"](CONTENT_BLOCK_ICONS.PHONE),
  content: yup__namespace.string().max(CONTENT_BLOCK_VALIDATION_LIMITS.PILL_CONTENT.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.PILL_CONTENT.MAX).required(CONTENT_BLOCK_VALIDATION_MESSAGES.PILL_CONTENT.REQUIRED),
  url: yup__namespace.string().phone("US", CONTENT_BLOCK_VALIDATION_MESSAGES.PHONE.MATCHES).required(CONTENT_BLOCK_VALIDATION_MESSAGES.PHONE.REQUIRED)
}));
var tagsValidator = yup__namespace.object(_objectSpread2({
  content: yup__namespace.string().max(CONTENT_BLOCK_VALIDATION_LIMITS.TAG_CONTENT.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.TAG_CONTENT.MAX).required(CONTENT_BLOCK_VALIDATION_MESSAGES.TAG_CONTENT.REQUIRED)
}, commonPillsValidators));
var blockValidator = yup__namespace.object({
  type: yup__namespace.string().required(CONTENT_BLOCK_VALIDATION_MESSAGES.TYPE.REQUIRED),
  title: yup__namespace.string().max(CONTENT_BLOCK_VALIDATION_LIMITS.BLOCK_TITLE.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.BLOCK_TITLE.MAX).nullable(),
  content: yup__namespace.string().max(CONTENT_BLOCK_VALIDATION_LIMITS.BLOCK_CONTENT.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.BLOCK_CONTENT.MAX).nullable(),
  pills: yup__namespace.array().when("type", {
    is: CONTENT_BLOCK_TYPES.ADDRESS,
    then: function then(schema) {
      return schema.of(addressValidator);
    }
  }).when("type", {
    is: CONTENT_BLOCK_TYPES.CONTACT,
    then: function then(schema) {
      return schema.of(contactValidator);
    }
  }).when("type", {
    is: CONTENT_BLOCK_TYPES.TAGS,
    then: function then(schema) {
      return schema.of(tagsValidator);
    }
  }),
  url: yup__namespace.mixed().when("type", {
    is: function is(type) {
      return CONTENT_BLOCKS_WITH_ID_IN_URL.includes(type);
    },
    then: function then(schema) {
      return schema.nullable();
    },
    otherwise: urlValidator.nullable()
  }),
  url_list: urlListValidator.nullable()
});
var blocksValidator = yup__namespace.array().of(blockValidator);
var sectionValidator = yup__namespace.object({
  title: yup__namespace.string().max(CONTENT_BLOCK_VALIDATION_LIMITS.SECTION_TITLE.MAX, CONTENT_BLOCK_VALIDATION_MESSAGES.SECTION_TITLE.MAX).nullable(),
  blocks: blocksValidator
}).required();
var sectionsValidator = yup__namespace.array().of(sectionValidator).required();
function getContentBlocksSchema() {
  return yup__namespace.object().shape({
    name: nameValidator,
    sections: sectionsValidator
  });
}
function getPillsSchema(type) {
  switch (type) {
    case CONTENT_BLOCK_TYPES.CONTACT:
      return contactValidator;
    case CONTENT_BLOCK_TYPES.ADDRESS:
      return addressValidator;
    default:
      return tagsValidator;
  }
}

var SECTIONS = "sections";
var ContentBlockFormContext = /*#__PURE__*/React.createContext();
var useContentBlockForm = function useContentBlockForm() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex;
  var context = React.useContext(ContentBlockFormContext);
  var hasSectionIndex = libCommon.isNumber(sectionIndex);
  var hasBlockIndex = libCommon.isNumber(blockIndex);
  var getSection = context.getSection,
    getSectionBlock = context.getSectionBlock,
    getValues = context.getValues;
  return _objectSpread2(_objectSpread2(_objectSpread2({
    sections: getValues(SECTIONS)
  }, hasSectionIndex && {
    section: getSection(sectionIndex)
  }), hasSectionIndex && hasBlockIndex && {
    block: getSectionBlock({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex
    })
  }), context);
};
function ContentBlockFormProvider(_ref2) {
  var name = _ref2.name,
    sections = _ref2.sections,
    children = _ref2.children;
  var configs = getFormConfig$2({
    initialValues: getInitialValues$2({
      name: name,
      sections: sections
    }),
    validationSchema: getContentBlocksSchema(),
    validationMode: "onBlur",
    // We pass structuredClone to avoid RHF returning file objects as undefined
    utilities: {
      clone: global.structuredClone
    }
  });
  var _useForm = reactHookForm.useForm(configs),
    control = _useForm.control,
    handleSubmit = _useForm.handleSubmit,
    formState = _useForm.formState,
    watch = _useForm.watch,
    reset = _useForm.reset,
    trigger = _useForm.trigger,
    getFieldState = _useForm.getFieldState,
    getValues = _useForm.getValues,
    setValue = _useForm.setValue;
  var isSubmitting = formState.isSubmitting,
    errors = formState.errors;
  var _useFieldArray = reactHookForm.useFieldArray({
      control: control,
      name: SECTIONS
    }),
    append = _useFieldArray.append,
    remove = _useFieldArray.remove,
    move = _useFieldArray.move,
    update = _useFieldArray.update;
  var appendSection = function appendSection() {
    var newSection = {
      id: uuid.v4(),
      title: null,
      blocks: [_objectSpread2({
        id: uuid.v4()
      }, getBlockInitialValueByType(CONTENT_BLOCK_TYPES.TEXT))]
    };
    append(newSection);
  };
  var removeSection = function removeSection(index) {
    remove(index);
  };
  var moveSections = function moveSections(_ref3) {
    var fromIndex = _ref3.fromIndex,
      toIndex = _ref3.toIndex;
    move(fromIndex, toIndex);
  };
  var getSection = function getSection(index) {
    var allSections = getValues(SECTIONS);
    return allSections[index];
  };
  var getSections = function getSections() {
    return getValues(SECTIONS);
  };
  var getSectionBlock = function getSectionBlock(_ref4) {
    var sectionIndex = _ref4.sectionIndex,
      blockIndex = _ref4.blockIndex;
    var section = getSection(sectionIndex);
    return section === null || section === void 0 ? void 0 : section.blocks[blockIndex];
  };
  var addBlockToSection = function addBlockToSection(_ref5) {
    var sectionIndex = _ref5.sectionIndex,
      newBlock = _ref5.newBlock;
    var section = getSection(sectionIndex);
    section.blocks.push(_objectSpread2({
      id: uuid.v4()
    }, newBlock));
    update(sectionIndex, section);
  };
  var replaceBlockInSection = function replaceBlockInSection(_ref6) {
    var sectionIndex = _ref6.sectionIndex,
      blockIndex = _ref6.blockIndex,
      newBlock = _ref6.newBlock;
    var section = getSection(sectionIndex);
    section.blocks[blockIndex] = _objectSpread2({
      id: uuid.v4()
    }, newBlock);
    update(sectionIndex, section);
  };
  var removeBlockFromSection = function removeBlockFromSection(_ref7) {
    var sectionIndex = _ref7.sectionIndex,
      blockIndex = _ref7.blockIndex;
    var section = getSection(sectionIndex);
    section.blocks.splice(blockIndex, 1);
    update(sectionIndex, section);
  };
  var moveBlockInSection = function moveBlockInSection(_ref8) {
    var sectionIndex = _ref8.sectionIndex,
      fromIndex = _ref8.fromIndex,
      toIndex = _ref8.toIndex;
    var section = getSection(sectionIndex);
    section.blocks = libCommon.moveItemInArray({
      array: section.blocks,
      item: section.blocks[fromIndex],
      position: toIndex
    });
    update(sectionIndex, section);
  };
  return /*#__PURE__*/React__namespace.default.createElement(ContentBlockFormContext.Provider, {
    value: {
      control: control,
      handleSubmit: handleSubmit,
      isSubmitting: isSubmitting,
      errors: errors,
      watch: watch,
      reset: reset,
      trigger: trigger,
      getFieldState: getFieldState,
      getValues: getValues,
      appendSection: appendSection,
      removeSection: removeSection,
      moveSections: moveSections,
      getSections: getSections,
      getSection: getSection,
      getSectionBlock: getSectionBlock,
      addBlockToSection: addBlockToSection,
      replaceBlockInSection: replaceBlockInSection,
      removeBlockFromSection: removeBlockFromSection,
      moveBlockInSection: moveBlockInSection,
      setValue: setValue
    }
  }, children);
}
ContentBlockFormProvider.propTypes = {
  name: propTypesExports.string,
  sections: propTypesExports.array.isRequired,
  children: propTypesExports.any.isRequired
};
function getFormConfig$2(_ref9) {
  var initialValues = _ref9.initialValues,
    validationSchema = _ref9.validationSchema,
    validationMode = _ref9.validationMode;
  return _objectSpread2(_objectSpread2({
    defaultValues: initialValues
  }, validationSchema && {
    resolver: o(validationSchema)
  }), {}, {
    mode: validationMode,
    reValidateMode: validationMode
  });
}
function getInitialValues$2(_ref10) {
  var name = _ref10.name,
    _ref10$sections = _ref10.sections,
    sections = _ref10$sections === void 0 ? [] : _ref10$sections;
  // Set uuids if not present so that we can reliably update with react-form-hook
  var decoratedSections = sections.map(function (section) {
    return _objectSpread2(_objectSpread2({}, section), {}, {
      id: section.id || uuid.v4(),
      blocks: section === null || section === void 0 ? void 0 : section.blocks.map(function (block) {
        var _block$pills;
        return _objectSpread2(_objectSpread2({}, block), {}, {
          pills: (_block$pills = block.pills) === null || _block$pills === void 0 ? void 0 : _block$pills.map(function (pill) {
            return _objectSpread2(_objectSpread2({}, pill), {}, {
              id: pill.id || uuid.v4()
            });
          }),
          id: block.id || uuid.v4()
        }, convertImageBlockUrlToUrlList(block));
      })
    });
  });
  return {
    name: name,
    sections: decoratedSections
  };
}

var ContentBlockEditContainer = styled__default.default(Box$1)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: "flex",
    flexDirection: "column",
    width: "100%",
    margin: "20px 0px",
    borderRadius: theme.borderRadius.lg,
    backgroundColor: theme.palette.card.background,
    boxShadow: theme.boxShadow.darker
  };
});

function ContentBlockNameInput(_ref) {
  var props = _extends$2({}, (_objectDestructuringEmpty(_ref), _ref));
  var theme = useTheme$1();
  var styles = getStyles$8(theme);
  return /*#__PURE__*/React__namespace.default.createElement(NameContainer, null, /*#__PURE__*/React__namespace.default.createElement(FormTextInput, _extends$2({
    "data-testid": TEST_IDS.CONTENT_BLOCK_NAME_INPUT,
    variant: CONTENT_BLOCK_INPUT_VARIANT,
    sx: styles
  }, props)));
}
function getStyles$8(theme) {
  return {
    "& .MuiInput-input": {
      backgroundColor: theme.palette.colors.contentBlockInput.background,
      padding: "10px"
    }
  };
}
var NameContainer = styled__default.default(ContentBlockEditContainer)(function () {
  return {
    padding: "20px",
    minHeight: "70px",
    justifyContent: "center"
  };
});

var Add = {};

var _interopRequireDefault$m = interopRequireDefaultExports;
Object.defineProperty(Add, "__esModule", {
  value: true
});
var default_1$m = Add.default = void 0;
var _createSvgIcon$m = _interopRequireDefault$m(requireCreateSvgIcon());
var _jsxRuntime$m = requireJsxRuntime();
var _default$m = (0, _createSvgIcon$m.default)( /*#__PURE__*/(0, _jsxRuntime$m.jsx)("path", {
  d: "M19 13h-6v6h-2v-6H5v-2h6V5h2v6h6v2z"
}), 'Add');
default_1$m = Add.default = _default$m;

var DragIndicator = {};

var _interopRequireDefault$l = interopRequireDefaultExports;
Object.defineProperty(DragIndicator, "__esModule", {
  value: true
});
var default_1$l = DragIndicator.default = void 0;
var _createSvgIcon$l = _interopRequireDefault$l(requireCreateSvgIcon());
var _jsxRuntime$l = requireJsxRuntime();
var _default$l = (0, _createSvgIcon$l.default)( /*#__PURE__*/(0, _jsxRuntime$l.jsx)("path", {
  d: "M11 18c0 1.1-.9 2-2 2s-2-.9-2-2 .9-2 2-2 2 .9 2 2zm-2-8c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0-6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm6 4c1.1 0 2-.9 2-2s-.9-2-2-2-2 .9-2 2 .9 2 2 2zm0 2c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2zm0 6c-1.1 0-2 .9-2 2s.9 2 2 2 2-.9 2-2-.9-2-2-2z"
}), 'DragIndicator');
default_1$l = DragIndicator.default = _default$l;

function useMakeInputPath() {
  var _useSnackBar = useSnackBar(),
    showError = _useSnackBar.showError;
  var _useUtils = useUtils(),
    logError = _useUtils.logError;
  return function (_ref) {
    var sectionIndex = _ref.sectionIndex,
      blockIndex = _ref.blockIndex,
      prop = _ref.prop;
    return makeInputPath({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex,
      prop: prop,
      showError: showError,
      logError: logError
    });
  };
}

// Exported for tests
// Takes a sectionIndex, blockIndex and prop and constructs a path that
// react-hook-form can use to control the input.
// Sample input: sectionIndex: 0, blockIndex: 1, prop: "name"
// Output: "sections.0.blocks.1.name"
// That value can then be passed to RFH Controller as 'path' in ControlledInput.js
// All permutations of inputs are valid EXCEPT a blockIndex being provided and no section index.
// Given our data structure this has no meaning. Hence the check at the beginning and return of
// an empty value
function makeInputPath(_ref2) {
  var sectionIndex = _ref2.sectionIndex,
    blockIndex = _ref2.blockIndex,
    prop = _ref2.prop,
    showError = _ref2.showError,
    logError = _ref2.logError;
  // sectionIndex and blockIndex should always be numbers. This condition is makling sure blockIndex is never present without sectionIndex. Since (null => 0) evals to true I opted for the isNumber check
  if (libCommon.isNumber(blockIndex) && !libCommon.isNumber(sectionIndex)) {
    var error = new Error(INVALID_INPUT_PATH);
    showError({
      error: error
    });
    logError({
      error: error
    });
    return "";
  }
  var sectionPart = libCommon.isNumber(sectionIndex) ? ["sections", sectionIndex] : [];
  var blockPart = libCommon.isNumber(blockIndex) ? ["blocks", blockIndex] : [];
  var propPart = prop ? [prop] : [];
  var parts = [].concat(sectionPart, blockPart, propPart);
  var path = parts.join(".");
  return path;
}

var _excluded$p = ["path", "contextHook", "Component"];
function ControlledInput(_ref) {
  var path = _ref.path,
    _ref$contextHook = _ref.contextHook,
    contextHook = _ref$contextHook === void 0 ? useContentBlockForm : _ref$contextHook,
    Component = _ref.Component,
    props = _objectWithoutProperties(_ref, _excluded$p);
  var _contextHook = contextHook(),
    control = _contextHook.control;
  return /*#__PURE__*/React__namespace.default.createElement(reactHookForm.Controller, {
    name: path,
    control: control,
    render: function render(_ref2) {
      var field = _ref2.field,
        fieldState = _ref2.fieldState;
      var value = field.value,
        onChange = field.onChange,
        onBlur = field.onBlur;
      var validationMessage = getValidationMessage(fieldState === null || fieldState === void 0 ? void 0 : fieldState.error);
      return /*#__PURE__*/React__namespace.default.createElement(Component, _extends$2({
        value: value,
        onChange: onChange,
        onBlur: onBlur,
        validationMessage: validationMessage,
        path: path
      }, props));
    }
  });
}

// exported for tests
// Handles the 3 cases of the shape error can have from yup
// - [{message: "error"}]
// - { message: "error" }
// - { title: {message: "error"} }
function getValidationMessage(error) {
  if (!error) {
    return "";
  }
  if (Array.isArray(error)) {
    // We only get a message for the first error with a value in the array
    // This is based on the assumption that grouped fields like tags/contacts/address
    // will present the error on a case by case basis rather than all at once at the end.
    var filteredErrors = error.filter(function (err) {
      return !!err;
    });
    return parseErrorMessageFromObject(filteredErrors[0]);
  }
  return parseErrorMessageFromObject(error);
}
function parseErrorMessageFromObject(error) {
  if (!error) {
    return "";
  }
  if (error.message) return error.message;

  // If error.message doesn't exist it should be nested under a prop
  // as with { content: { message: "something is wrong", url: "other error" } }
  // So we return the error of the first nested prop below
  var values = Object.values(error);
  return values[0].message;
}
ControlledInput.propTypes = {
  path: propTypesExports.string.isRequired,
  contextHook: propTypesExports.func,
  Component: propTypesExports.any.isRequired
};

var _excluded$o = ["id", "sectionIndex", "blockIndex", "TextComponent", "prop"];
function TextInput(_ref) {
  var id = _ref.id,
    sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    _ref$TextComponent = _ref.TextComponent,
    TextComponent = _ref$TextComponent === void 0 ? MarkdownEditorInput : _ref$TextComponent,
    _ref$prop = _ref.prop,
    prop = _ref$prop === void 0 ? CONTENT_BLOCK_INPUT_PATH_PROPS.CONTENT : _ref$prop,
    props = _objectWithoutProperties(_ref, _excluded$o);
  var makeInputPath = useMakeInputPath();
  var path = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: prop
  });
  return /*#__PURE__*/React__namespace.default.createElement(material.Box, null, /*#__PURE__*/React__namespace.default.createElement(ControlledInput, _extends$2({
    path: path,
    Component: TextComponent,
    id: id,
    charLimit: LIMITS.MAX_CONTENT_LENGTH,
    isCompact: true,
    showToolbarOnFocus: true
  }, props)));
}
TextInput.propTypes = {
  id: propTypesExports.string,
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired,
  TextComponent: propTypesExports.elementType,
  prop: propTypesExports.string
};

function MultiImageUploadPreview(_ref) {
  var _ref$value = _ref.value,
    value = _ref$value === void 0 ? [] : _ref$value,
    id = _ref.id,
    onChange = _ref.onChange;
  return /*#__PURE__*/React__namespace.default.createElement(MultiImageDisplay, null, value.map(function (image) {
    var _getLocalUrlOrAttachm = getLocalUrlOrAttachmentId(image),
      attachmentId = _getLocalUrlOrAttachm.attachmentId,
      localUrl = _getLocalUrlOrAttachm.localUrl;
    return /*#__PURE__*/React__namespace.default.createElement(AttachmentPreview, {
      key: (image === null || image === void 0 ? void 0 : image.name) || image,
      attachmentId: attachmentId,
      localUrl: localUrl,
      PreviewIcon: CloseButton,
      iconProps: {
        onClick: function onClick() {
          return handleDelete({
            onChange: onChange,
            images: value,
            image: image
          });
        }
      }
    });
  }), /*#__PURE__*/React__namespace.default.createElement(StyledLabel$1, {
    htmlFor: id
  }, /*#__PURE__*/React__namespace.default.createElement(ContentBlockImagePreviewDescription, null)));
}
function handleDelete(_ref2) {
  var onChange = _ref2.onChange,
    images = _ref2.images,
    image = _ref2.image;
  var updatedImages = images.filter(function (formImage) {
    return formImage !== image;
  });
  onChange(updatedImages);
}
var StyledLabel$1 = styled__default.default.label({
  alignSelf: "center"
});
var MultiImageDisplay = styled__default.default(Box$1)({
  display: "flex",
  flexWrap: "wrap",
  gap: "10px",
  minHeight: "200px"
});
MultiImageUploadPreview.propTypes = {
  value: propTypesExports.any,
  id: propTypesExports.string,
  onChange: propTypesExports.func
};

var ACCEPT = "image/*";
function MultiImageUploadInput(_ref) {
  var id = _ref.id,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    onChange = _ref.onChange,
    title = _ref.title,
    ContainerComponent = _ref.ContainerComponent;
  return /*#__PURE__*/React__namespace.default.createElement(FileUploadInput, {
    id: id,
    title: title,
    value: value,
    validationMessage: validationMessage,
    onChange: onChange,
    accept: ACCEPT,
    ContainerComponent: ContainerComponent,
    EmptyComponent: MultiImageUploadPreview,
    testId: TEST_IDS.IMAGE_UPLOAD_INPUT,
    isMultiple: true
  });
}
MultiImageUploadInput.propTypes = {
  id: propTypesExports.string.isRequired,
  value: propTypesExports.any,
  onChange: propTypesExports.func.isRequired,
  validationMessage: propTypesExports.string,
  title: propTypesExports.string,
  ContainerComponent: propTypesExports.elementType
};

function UrlInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    id = _ref.id;
  var makeInputPath = useMakeInputPath();
  var path = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: CONTENT_BLOCK_INPUT_PATH_PROPS.URL_LIST
  });
  return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, {
    path: path,
    Component: MultiImageUploadInput,
    id: id,
    ContainerComponent: ImageInputFormControl
  });
}
UrlInput.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired,
  id: propTypesExports.string
};

function VideoInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex;
  var makeInputPath = useMakeInputPath();
  var path = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: CONTENT_BLOCK_INPUT_PATH_PROPS.URL
  });
  return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, {
    path: path,
    Component: VideoInput$1
  });
}
VideoInput.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired
};

function AttachmentInput(_ref) {
  var type = _ref.type,
    sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    id = _ref.id;
  var labels = getLabels({
    type: type
  });
  var theme = useTheme$1();
  var styles = getStyles$7({
    theme: theme
  });
  var commonProps = {
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    id: id
  };
  var AttachmentComponent = getAttachmentComponent({
    type: type
  });
  return /*#__PURE__*/React__namespace.default.createElement(material.Box, null, /*#__PURE__*/React__namespace.default.createElement(TextInput, _extends$2({}, commonProps, {
    id: "".concat(id, "-title"),
    prop: "title",
    TextComponent: FormTextInput,
    label: labels.title,
    variant: CONTENT_BLOCK_INPUT_VARIANT,
    backgroundColor: styles.textInput.backgroundColor,
    style: styles.textInput
  })), /*#__PURE__*/React__namespace.default.createElement(TextInput, _extends$2({}, commonProps, {
    id: "".concat(id, "-caption"),
    TextComponent: FormTextInput,
    label: labels.caption,
    variant: CONTENT_BLOCK_INPUT_VARIANT,
    style: styles.textInput,
    backgroundColor: styles.textInput.backgroundColor
  })), /*#__PURE__*/React__namespace.default.createElement(AttachmentComponent, _extends$2({}, commonProps, {
    id: "".concat(id, "-url")
  })));
}
AttachmentInput.propTypes = {
  type: propTypesExports.string.isRequired,
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired,
  id: propTypesExports.string
};
function getLabels(_ref2) {
  var type = _ref2.type;
  var isImage = type === CONTENT_BLOCK_TYPES.IMAGE;
  return {
    title: isImage ? CONTENT_BLOCK_ATTACHMENT_LABELS.IMAGE_TITLE : CONTENT_BLOCK_ATTACHMENT_LABELS.VIDEO_TITLE,
    caption: isImage ? CONTENT_BLOCK_ATTACHMENT_LABELS.IMAGE_CAPTION : CONTENT_BLOCK_ATTACHMENT_LABELS.VIDEO_CAPTION
  };
}
function getAttachmentComponent(_ref3) {
  var type = _ref3.type;
  return type === CONTENT_BLOCK_TYPES.IMAGE ? UrlInput : VideoInput;
}
function getStyles$7(_ref4) {
  var theme = _ref4.theme;
  return {
    textInput: {
      marginBottom: "1.5rem",
      backgroundColor: theme.palette.contentBlocks.background
    }
  };
}

var ArrowForwardIos = {};

var _interopRequireDefault$k = interopRequireDefaultExports;
Object.defineProperty(ArrowForwardIos, "__esModule", {
  value: true
});
var default_1$k = ArrowForwardIos.default = void 0;
var _createSvgIcon$k = _interopRequireDefault$k(requireCreateSvgIcon());
var _jsxRuntime$k = requireJsxRuntime();
var _default$k = (0, _createSvgIcon$k.default)( /*#__PURE__*/(0, _jsxRuntime$k.jsx)("path", {
  d: "M6.23 20.23 8 22l10-10L8 2 6.23 3.77 14.46 12z"
}), 'ArrowForwardIos');
default_1$k = ArrowForwardIos.default = _default$k;

function Banner(_ref) {
  var title = _ref.title,
    content = _ref.content,
    url = _ref.url,
    sx = _ref.sx;
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$4, {
    href: url,
    target: "_blank",
    variant: "outlined",
    "data-testid": TEST_IDS.BANNER,
    sx: sx
  }, /*#__PURE__*/React__namespace.default.createElement(TextContainer$2, null, /*#__PURE__*/React__namespace.default.createElement(Title$3, null, title), /*#__PURE__*/React__namespace.default.createElement(BodyText, null, content)), /*#__PURE__*/React__namespace.default.createElement(StyledAvatar$1, {
    variant: "rounded"
  }, /*#__PURE__*/React__namespace.default.createElement(StyledArrowIcon, {
    sx: {
      fill: "white"
    }
  })));
}
var StyledButton$4 = styled__default.default(Button$2)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    minHeight: 70,
    display: "flex",
    justifyContent: "space-between",
    textTransform: "none",
    width: "100%",
    gap: theme.spacing(1)
  };
});
var StyledAvatar$1 = styled__default.default(Avatar$2)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    backgroundColor: theme.palette.primary.main,
    color: theme.palette.text.primary,
    width: 24,
    height: 24,
    padding: "2px"
  };
});
var BodyText = styled__default.default(Typography$1)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    color: theme.palette.text.primary,
    fontSize: 14
  };
});
var Title$3 = styled__default.default(Typography$1)(function (_ref5) {
  var theme = _ref5.theme;
  return {
    color: theme.palette.primary.main,
    fontSize: theme.typography.h5.fontSize
  };
});
var TextContainer$2 = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    flexDirection: "column",
    justifyContent: "space-between",
    height: "100%",
    maxWidth: "100%",
    gap: 5
  };
});
var StyledArrowIcon = styled__default.default(default_1$k)(function (_ref6) {
  var theme = _ref6.theme;
  return {
    padding: theme.spacing(0.5)
  };
});
Banner.propTypes = {
  url: propTypesExports.string,
  title: propTypesExports.string,
  content: propTypesExports.string,
  sx: propTypesExports.object
};

var _excluded$n = ["key"];
function BannerInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    title = _ref.title,
    content = _ref.content,
    url = _ref.url;
  var theme = useTheme$1();
  var makeInputPath = useMakeInputPath();
  var inputConfigs = getInputConfigs({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    theme: theme,
    makeInputPath: makeInputPath
  });
  var shouldShowBannerPreview = title || content || url;
  var styles = getStyles$6();
  return /*#__PURE__*/React__namespace.default.createElement(material.Box, null, inputConfigs.map(function (_ref2) {
    var key = _ref2.key,
      configs = _objectWithoutProperties(_ref2, _excluded$n);
    return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, _extends$2({
      key: key,
      Component: FormTextInput
    }, configs));
  }), shouldShowBannerPreview && /*#__PURE__*/React__namespace.default.createElement(Banner, {
    title: title,
    content: content,
    url: url,
    sx: styles.banner
  }));
}
function getStyles$6() {
  return {
    banner: {
      marginTop: "10px"
    }
  };
}
function getInputConfigs(_ref3) {
  var sectionIndex = _ref3.sectionIndex,
    blockIndex = _ref3.blockIndex,
    theme = _ref3.theme,
    makeInputPath = _ref3.makeInputPath;
  var variant = CONTENT_BLOCK_INPUT_VARIANT;
  var _getCommonStyles = getCommonStyles(theme),
    input = _getCommonStyles.input;
  var titlePath = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: CONTENT_BLOCK_INPUT_PATH_PROPS.TITLE
  });
  var contentPath = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: CONTENT_BLOCK_INPUT_PATH_PROPS.CONTENT
  });
  var urlPath = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: CONTENT_BLOCK_INPUT_PATH_PROPS.URL
  });
  var commonProps = {
    variant: variant,
    sx: input
  };
  return [_objectSpread2({
    key: getKey({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex,
      prop: "subject"
    }),
    path: titlePath,
    label: "Subject",
    "aria-label": "subject"
  }, commonProps), _objectSpread2({
    key: getKey({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex,
      prop: "content"
    }),
    path: contentPath,
    label: "Content",
    "aria-label": "content"
  }, commonProps), _objectSpread2({
    key: getKey({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex,
      prop: "url"
    }),
    path: urlPath,
    label: "Url",
    "aria-label": "url"
  }, commonProps)];
}
function getKey(_ref4) {
  var sectionIndex = _ref4.sectionIndex,
    blockIndex = _ref4.blockIndex,
    prop = _ref4.prop;
  var keyPrefix = "section_".concat(sectionIndex, "_block_").concat(blockIndex, "_banner_input_");
  return "".concat(keyPrefix).concat(prop);
}
BannerInput.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired,
  title: propTypesExports.string,
  content: propTypesExports.string,
  url: propTypesExports.string
};

var CollapsibleContext = /*#__PURE__*/React.createContext();
var useCollapse = function useCollapse() {
  return React.useContext(CollapsibleContext);
};

// do not nest within other collapse providers
// should only have one CollapsibleExpandButton and DynamicCollapsibleBox as children
function CollapsibleProvider(_ref) {
  var children = _ref.children,
    _ref$isOpenInitially = _ref.isOpenInitially,
    isOpenInitially = _ref$isOpenInitially === void 0 ? false : _ref$isOpenInitially;
  var _useState = React.useState(isOpenInitially),
    _useState2 = _slicedToArray(_useState, 2),
    isCollapsed = _useState2[0],
    setIsCollapse = _useState2[1];
  var toggleCollapse = function toggleCollapse() {
    return setIsCollapse(!isCollapsed);
  };
  return /*#__PURE__*/React__namespace.default.createElement(CollapsibleContext.Provider, {
    value: {
      isCollapsed: isCollapsed,
      toggleCollapse: toggleCollapse
    }
  }, children);
}
CollapsibleProvider.propTypes = {
  children: propTypesExports.any,
  isOpenInitially: propTypesExports.bool
};

var ExpandMore = {};

var _interopRequireDefault$j = interopRequireDefaultExports;
Object.defineProperty(ExpandMore, "__esModule", {
  value: true
});
var default_1$j = ExpandMore.default = void 0;
var _createSvgIcon$j = _interopRequireDefault$j(requireCreateSvgIcon());
var _jsxRuntime$j = requireJsxRuntime();
var _default$j = (0, _createSvgIcon$j.default)( /*#__PURE__*/(0, _jsxRuntime$j.jsx)("path", {
  d: "M16.59 8.59 12 13.17 7.41 8.59 6 10l6 6 6-6z"
}), 'ExpandMore');
default_1$j = ExpandMore.default = _default$j;

function CollapsibleExpandButton() {
  var _useCollapse = useCollapse(),
    isCollapsed = _useCollapse.isCollapsed,
    toggleCollapse = _useCollapse.toggleCollapse;
  return /*#__PURE__*/React__namespace.default.createElement(CollapsibleButton, {
    expand: isCollapsed,
    onClick: toggleCollapse
  }, /*#__PURE__*/React__namespace.default.createElement(default_1$j, null));
}
var CollapsibleButton = styled__default.default(function (props) {
  var iconButtonProps = libCommon.omit(props, ["expand"]);
  return /*#__PURE__*/React__namespace.default.createElement(IconButton$2, iconButtonProps);
})(function (_ref) {
  var theme = _ref.theme,
    expand = _ref.expand;
  return _defineProperty({
    color: theme.palette.text.primary,
    transform: !expand ? "rotate(0deg)" : "rotate(180deg)",
    marginLeft: "auto",
    transition: theme.transitions.create("transform", {
      duration: theme.transitions.duration.shortest
    })
  }, theme.breakpoints.down("sm"), {
    padding: 1
  });
});

function getCollapseUtilityClass(slot) {
  return generateUtilityClass('MuiCollapse', slot);
}
generateUtilityClasses('MuiCollapse', ['root', 'horizontal', 'vertical', 'entered', 'hidden', 'wrapper', 'wrapperInner']);

const _excluded$m = ["addEndListener", "children", "className", "collapsedSize", "component", "easing", "in", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "orientation", "style", "timeout", "TransitionComponent"];
const useUtilityClasses$d = ownerState => {
  const {
    orientation,
    classes
  } = ownerState;
  const slots = {
    root: ['root', `${orientation}`],
    entered: ['entered'],
    hidden: ['hidden'],
    wrapper: ['wrapper', `${orientation}`],
    wrapperInner: ['wrapperInner', `${orientation}`]
  };
  return composeClasses(slots, getCollapseUtilityClass, classes);
};
const CollapseRoot = styled$1('div', {
  name: 'MuiCollapse',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[ownerState.orientation], ownerState.state === 'entered' && styles.entered, ownerState.state === 'exited' && !ownerState.in && ownerState.collapsedSize === '0px' && styles.hidden];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  height: 0,
  overflow: 'hidden',
  transition: theme.transitions.create('height')
}, ownerState.orientation === 'horizontal' && {
  height: 'auto',
  width: 0,
  transition: theme.transitions.create('width')
}, ownerState.state === 'entered' && _extends$1({
  height: 'auto',
  overflow: 'visible'
}, ownerState.orientation === 'horizontal' && {
  width: 'auto'
}), ownerState.state === 'exited' && !ownerState.in && ownerState.collapsedSize === '0px' && {
  visibility: 'hidden'
}));
const CollapseWrapper = styled$1('div', {
  name: 'MuiCollapse',
  slot: 'Wrapper',
  overridesResolver: (props, styles) => styles.wrapper
})(({
  ownerState
}) => _extends$1({
  // Hack to get children with a negative margin to not falsify the height computation.
  display: 'flex',
  width: '100%'
}, ownerState.orientation === 'horizontal' && {
  width: 'auto',
  height: '100%'
}));
const CollapseWrapperInner = styled$1('div', {
  name: 'MuiCollapse',
  slot: 'WrapperInner',
  overridesResolver: (props, styles) => styles.wrapperInner
})(({
  ownerState
}) => _extends$1({
  width: '100%'
}, ownerState.orientation === 'horizontal' && {
  width: 'auto',
  height: '100%'
}));

/**
 * The Collapse transition is used by the
 * [Vertical Stepper](/material-ui/react-stepper/#vertical-stepper) StepContent component.
 * It uses [react-transition-group](https://github.com/reactjs/react-transition-group) internally.
 */
const Collapse = /*#__PURE__*/React__namespace.forwardRef(function Collapse(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiCollapse'
  });
  const {
      addEndListener,
      children,
      className,
      collapsedSize: collapsedSizeProp = '0px',
      component,
      easing,
      in: inProp,
      onEnter,
      onEntered,
      onEntering,
      onExit,
      onExited,
      onExiting,
      orientation = 'vertical',
      style,
      timeout = duration.standard,
      // eslint-disable-next-line react/prop-types
      TransitionComponent = Transition$1
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$m);
  const ownerState = _extends$1({}, props, {
    orientation,
    collapsedSize: collapsedSizeProp
  });
  const classes = useUtilityClasses$d(ownerState);
  const theme = useTheme$1();
  const timer = React__namespace.useRef();
  const wrapperRef = React__namespace.useRef(null);
  const autoTransitionDuration = React__namespace.useRef();
  const collapsedSize = typeof collapsedSizeProp === 'number' ? `${collapsedSizeProp}px` : collapsedSizeProp;
  const isHorizontal = orientation === 'horizontal';
  const size = isHorizontal ? 'width' : 'height';
  React__namespace.useEffect(() => {
    return () => {
      clearTimeout(timer.current);
    };
  }, []);
  const nodeRef = React__namespace.useRef(null);
  const handleRef = useForkRef(ref, nodeRef);
  const normalizedTransitionCallback = callback => maybeIsAppearing => {
    if (callback) {
      const node = nodeRef.current;

      // onEnterXxx and onExitXxx callbacks have a different arguments.length value.
      if (maybeIsAppearing === undefined) {
        callback(node);
      } else {
        callback(node, maybeIsAppearing);
      }
    }
  };
  const getWrapperSize = () => wrapperRef.current ? wrapperRef.current[isHorizontal ? 'clientWidth' : 'clientHeight'] : 0;
  const handleEnter = normalizedTransitionCallback((node, isAppearing) => {
    if (wrapperRef.current && isHorizontal) {
      // Set absolute position to get the size of collapsed content
      wrapperRef.current.style.position = 'absolute';
    }
    node.style[size] = collapsedSize;
    if (onEnter) {
      onEnter(node, isAppearing);
    }
  });
  const handleEntering = normalizedTransitionCallback((node, isAppearing) => {
    const wrapperSize = getWrapperSize();
    if (wrapperRef.current && isHorizontal) {
      // After the size is read reset the position back to default
      wrapperRef.current.style.position = '';
    }
    const {
      duration: transitionDuration,
      easing: transitionTimingFunction
    } = getTransitionProps({
      style,
      timeout,
      easing
    }, {
      mode: 'enter'
    });
    if (timeout === 'auto') {
      const duration2 = theme.transitions.getAutoHeightDuration(wrapperSize);
      node.style.transitionDuration = `${duration2}ms`;
      autoTransitionDuration.current = duration2;
    } else {
      node.style.transitionDuration = typeof transitionDuration === 'string' ? transitionDuration : `${transitionDuration}ms`;
    }
    node.style[size] = `${wrapperSize}px`;
    node.style.transitionTimingFunction = transitionTimingFunction;
    if (onEntering) {
      onEntering(node, isAppearing);
    }
  });
  const handleEntered = normalizedTransitionCallback((node, isAppearing) => {
    node.style[size] = 'auto';
    if (onEntered) {
      onEntered(node, isAppearing);
    }
  });
  const handleExit = normalizedTransitionCallback(node => {
    node.style[size] = `${getWrapperSize()}px`;
    if (onExit) {
      onExit(node);
    }
  });
  const handleExited = normalizedTransitionCallback(onExited);
  const handleExiting = normalizedTransitionCallback(node => {
    const wrapperSize = getWrapperSize();
    const {
      duration: transitionDuration,
      easing: transitionTimingFunction
    } = getTransitionProps({
      style,
      timeout,
      easing
    }, {
      mode: 'exit'
    });
    if (timeout === 'auto') {
      // TODO: rename getAutoHeightDuration to something more generic (width support)
      // Actually it just calculates animation duration based on size
      const duration2 = theme.transitions.getAutoHeightDuration(wrapperSize);
      node.style.transitionDuration = `${duration2}ms`;
      autoTransitionDuration.current = duration2;
    } else {
      node.style.transitionDuration = typeof transitionDuration === 'string' ? transitionDuration : `${transitionDuration}ms`;
    }
    node.style[size] = collapsedSize;
    node.style.transitionTimingFunction = transitionTimingFunction;
    if (onExiting) {
      onExiting(node);
    }
  });
  const handleAddEndListener = next => {
    if (timeout === 'auto') {
      timer.current = setTimeout(next, autoTransitionDuration.current || 0);
    }
    if (addEndListener) {
      // Old call signature before `react-transition-group` implemented `nodeRef`
      addEndListener(nodeRef.current, next);
    }
  };
  return /*#__PURE__*/jsxRuntimeExports.jsx(TransitionComponent, _extends$1({
    in: inProp,
    onEnter: handleEnter,
    onEntered: handleEntered,
    onEntering: handleEntering,
    onExit: handleExit,
    onExited: handleExited,
    onExiting: handleExiting,
    addEndListener: handleAddEndListener,
    nodeRef: nodeRef,
    timeout: timeout === 'auto' ? null : timeout
  }, other, {
    children: (state, childProps) => /*#__PURE__*/jsxRuntimeExports.jsx(CollapseRoot, _extends$1({
      as: component,
      className: clsx(classes.root, className, {
        'entered': classes.entered,
        'exited': !inProp && collapsedSize === '0px' && classes.hidden
      }[state]),
      style: _extends$1({
        [isHorizontal ? 'minWidth' : 'minHeight']: collapsedSize
      }, style),
      ownerState: _extends$1({}, ownerState, {
        state
      }),
      ref: handleRef
    }, childProps, {
      children: /*#__PURE__*/jsxRuntimeExports.jsx(CollapseWrapper, {
        ownerState: _extends$1({}, ownerState, {
          state
        }),
        className: classes.wrapper,
        ref: wrapperRef,
        children: /*#__PURE__*/jsxRuntimeExports.jsx(CollapseWrapperInner, {
          ownerState: _extends$1({}, ownerState, {
            state
          }),
          className: classes.wrapperInner,
          children: children
        })
      })
    }))
  }));
});
browser$1.env.NODE_ENV !== "production" ? Collapse.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Add a custom transition end trigger. Called with the transitioning DOM
   * node and a done callback. Allows for more fine grained transition end
   * logic. Note: Timeouts are still used as a fallback if provided.
   */
  addEndListener: propTypesExports.func,
  /**
   * The content node to be collapsed.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The width (horizontal) or height (vertical) of the container when collapsed.
   * @default '0px'
   */
  collapsedSize: propTypesExports.oneOfType([propTypesExports.number, propTypesExports.string]),
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: elementTypeAcceptingRef$1,
  /**
   * The transition timing function.
   * You may specify a single easing or a object containing enter and exit values.
   */
  easing: propTypesExports.oneOfType([propTypesExports.shape({
    enter: propTypesExports.string,
    exit: propTypesExports.string
  }), propTypesExports.string]),
  /**
   * If `true`, the component will transition in.
   */
  in: propTypesExports.bool,
  /**
   * @ignore
   */
  onEnter: propTypesExports.func,
  /**
   * @ignore
   */
  onEntered: propTypesExports.func,
  /**
   * @ignore
   */
  onEntering: propTypesExports.func,
  /**
   * @ignore
   */
  onExit: propTypesExports.func,
  /**
   * @ignore
   */
  onExited: propTypesExports.func,
  /**
   * @ignore
   */
  onExiting: propTypesExports.func,
  /**
   * The transition orientation.
   * @default 'vertical'
   */
  orientation: propTypesExports.oneOf(['horizontal', 'vertical']),
  /**
   * @ignore
   */
  style: propTypesExports.object,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The duration for the transition, in milliseconds.
   * You may specify a single timeout for all transitions, or individually with an object.
   *
   * Set to 'auto' to automatically calculate transition time based on height.
   * @default duration.standard
   */
  timeout: propTypesExports.oneOfType([propTypesExports.oneOf(['auto']), propTypesExports.number, propTypesExports.shape({
    appear: propTypesExports.number,
    enter: propTypesExports.number,
    exit: propTypesExports.number
  })])
} : void 0;
Collapse.muiSupportAuto = true;
var Collapse$1 = Collapse;

function DynamicCollapsibleBox(_ref) {
  var isCollapsible = _ref.isCollapsible,
    children = _ref.children;
  var _useCollapse = useCollapse(),
    isCollapsed = _useCollapse.isCollapsed;
  var SectionBox = isCollapsible ? Collapse$1 : Box$1;
  return /*#__PURE__*/React__namespace.default.createElement(SectionBox, getProps$1({
    isCollapsible: isCollapsible,
    isCollapsed: isCollapsed
  }), children);
}
DynamicCollapsibleBox.propTypes = {
  error: propTypesExports.object,
  isCollapsed: propTypesExports.bool,
  children: propTypesExports.node.isRequired,
  isCollapsible: propTypesExports.bool
};

// only set props if it is a collapsible component
function getProps$1(_ref2) {
  var isCollapsible = _ref2.isCollapsible,
    isCollapsed = _ref2.isCollapsed;
  return _objectSpread2({}, isCollapsible && {
    "in": isCollapsed,
    unmountOnExit: true
  });
}

function DropDownInput(_ref) {
  var id = _ref.id,
    label = _ref.label,
    value = _ref.value,
    _onChange = _ref.onChange,
    dropdownOptions = _ref.dropdownOptions,
    size = _ref.size,
    title = _ref.title,
    isDisabled = _ref.isDisabled;
  var _useState = React.useState(value || label),
    _useState2 = _slicedToArray(_useState, 2),
    selection = _useState2[0],
    setSelection = _useState2[1];
  React.useEffect(function () {
    setSelection(value || label);
  }, [label, value]);
  return /*#__PURE__*/React__namespace.default.createElement(FormControl$1, {
    fullWidth: true
  }, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), /*#__PURE__*/React__namespace.default.createElement(Select$1, {
    displayEmpty: true,
    id: id,
    value: selection,
    "aria-label": id || label,
    onChange: function onChange(event) {
      setSelection(event.target.value);
      _onChange(event.target.value);
    },
    size: size,
    disabled: isDisabled
  }, dropdownOptions.map(function (option) {
    return getDropdownItem(option);
  })));
}
function getDropdownItem(option) {
  var Icon = option.Icon,
    label = option.label,
    value = option.value;
  var key = "dropdown_option_".concat(value);
  return /*#__PURE__*/React__namespace.default.createElement(MenuItem$1, {
    id: key,
    key: key,
    value: value || label
  }, /*#__PURE__*/React__namespace.default.createElement(DropdownItemContainer, null, Icon && /*#__PURE__*/React__namespace.default.createElement(Icon, null), label));
}
var DropdownItemContainer = styled__default.default(Box$1)({
  display: "flex",
  flexDirection: "row",
  gap: "10px"
});
DropDownInput.propTypes = {
  label: propTypesExports.string,
  value: propTypesExports.string,
  id: propTypesExports.string,
  onChange: propTypesExports.func.isRequired,
  dropdownOptions: propTypesExports.arrayOf(propTypesExports.shape({
    Icon: propTypesExports.object,
    value: propTypesExports.string,
    label: propTypesExports.string
  })).isRequired,
  size: propTypesExports.string,
  title: propTypesExports.string,
  isDisabled: propTypesExports.bool
};

function CheckBoxWithFormControlLabel(_ref) {
  var label = _ref.label,
    isChecked = _ref.isChecked,
    onChange = _ref.onChange,
    isDisabled = _ref.isDisabled;
  return /*#__PURE__*/React__namespace.default.createElement(FormControlLabel$1, {
    label: label,
    control: /*#__PURE__*/React__namespace.default.createElement(Checkbox$1, {
      onChange: onChange,
      checked: isChecked,
      disabled: isDisabled
    })
  });
}
CheckBoxWithFormControlLabel.propTypes = {
  label: propTypesExports.string,
  isChecked: propTypesExports.bool,
  onChange: propTypesExports.func.isRequired,
  isDisabled: propTypesExports.bool
};

function MultiCheckBoxInput(_ref) {
  var title = _ref.title,
    value = _ref.value,
    options = _ref.options,
    _onChange = _ref.onChange,
    validationMessage = _ref.validationMessage,
    isDisabled = _ref.isDisabled;
  return /*#__PURE__*/React__namespace.default.createElement(FormControl$1, {
    fullWidth: true
  }, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), options.map(function (option) {
    return /*#__PURE__*/React__namespace.default.createElement(CheckBoxWithFormControlLabel, {
      key: option,
      label: option,
      isChecked: value === null || value === void 0 ? void 0 : value.includes(option),
      onChange: function onChange(event) {
        return handleOnChange$2({
          event: event,
          value: value,
          option: option,
          onChange: _onChange
        });
      },
      isDisabled: isDisabled
    });
  }), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    validationMessage: validationMessage
  }));
}
MultiCheckBoxInput.propTypes = {
  title: propTypesExports.string,
  value: propTypesExports.arrayOf(propTypesExports.string),
  onChange: propTypesExports.func.isRequired,
  options: propTypesExports.arrayOf(propTypesExports.string).isRequired,
  validationMessage: propTypesExports.string,
  isDisabled: propTypesExports.bool
};
function handleOnChange$2(_ref2) {
  var event = _ref2.event,
    value = _ref2.value,
    option = _ref2.option,
    onChange = _ref2.onChange;
  var isChecked = event.target.checked;
  var newValue = isChecked ? [].concat(_toConsumableArray(value), [option]) : value.filter(function (val) {
    return val !== option;
  });
  onChange(newValue);
}

var RadioButtonUncheckedIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
}), 'RadioButtonUnchecked');

var RadioButtonCheckedIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M8.465 8.465C9.37 7.56 10.62 7 12 7C14.76 7 17 9.24 17 12C17 13.38 16.44 14.63 15.535 15.535C14.63 16.44 13.38 17 12 17C9.24 17 7 14.76 7 12C7 10.62 7.56 9.37 8.465 8.465Z"
}), 'RadioButtonChecked');

const RadioButtonIconRoot = styled$1('span')({
  position: 'relative',
  display: 'flex'
});
const RadioButtonIconBackground = styled$1(RadioButtonUncheckedIcon)({
  // Scale applied to prevent dot misalignment in Safari
  transform: 'scale(1)'
});
const RadioButtonIconDot = styled$1(RadioButtonCheckedIcon)(({
  theme,
  ownerState
}) => _extends$1({
  left: 0,
  position: 'absolute',
  transform: 'scale(0)',
  transition: theme.transitions.create('transform', {
    easing: theme.transitions.easing.easeIn,
    duration: theme.transitions.duration.shortest
  })
}, ownerState.checked && {
  transform: 'scale(1)',
  transition: theme.transitions.create('transform', {
    easing: theme.transitions.easing.easeOut,
    duration: theme.transitions.duration.shortest
  })
}));

/**
 * @ignore - internal component.
 */
function RadioButtonIcon(props) {
  const {
    checked = false,
    classes = {},
    fontSize
  } = props;
  const ownerState = _extends$1({}, props, {
    checked
  });
  return /*#__PURE__*/jsxRuntimeExports.jsxs(RadioButtonIconRoot, {
    className: classes.root,
    ownerState: ownerState,
    children: [/*#__PURE__*/jsxRuntimeExports.jsx(RadioButtonIconBackground, {
      fontSize: fontSize,
      className: classes.background,
      ownerState: ownerState
    }), /*#__PURE__*/jsxRuntimeExports.jsx(RadioButtonIconDot, {
      fontSize: fontSize,
      className: classes.dot,
      ownerState: ownerState
    })]
  });
}
browser$1.env.NODE_ENV !== "production" ? RadioButtonIcon.propTypes = {
  /**
   * If `true`, the component is checked.
   */
  checked: propTypesExports.bool,
  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypesExports.object,
  /**
   * The size of the component.
   * `small` is equivalent to the dense radio styling.
   */
  fontSize: propTypesExports.oneOf(['small', 'medium'])
} : void 0;

/**
 * @ignore - internal component.
 */
const RadioGroupContext = /*#__PURE__*/React__namespace.createContext(undefined);
if (browser$1.env.NODE_ENV !== 'production') {
  RadioGroupContext.displayName = 'RadioGroupContext';
}
var RadioGroupContext$1 = RadioGroupContext;

function useRadioGroup() {
  return React__namespace.useContext(RadioGroupContext$1);
}

function getRadioUtilityClass(slot) {
  return generateUtilityClass('MuiRadio', slot);
}
const radioClasses = generateUtilityClasses('MuiRadio', ['root', 'checked', 'disabled', 'colorPrimary', 'colorSecondary']);
var radioClasses$1 = radioClasses;

const _excluded$l = ["checked", "checkedIcon", "color", "icon", "name", "onChange", "size", "className"];
const useUtilityClasses$c = ownerState => {
  const {
    classes,
    color
  } = ownerState;
  const slots = {
    root: ['root', `color${capitalize(color)}`]
  };
  return _extends$1({}, classes, composeClasses(slots, getRadioUtilityClass, classes));
};
const RadioRoot = styled$1(SwitchBase$1, {
  shouldForwardProp: prop => rootShouldForwardProp$1(prop) || prop === 'classes',
  name: 'MuiRadio',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[`color${capitalize(ownerState.color)}`]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  color: (theme.vars || theme).palette.text.secondary
}, !ownerState.disableRipple && {
  '&:hover': {
    backgroundColor: theme.vars ? `rgba(${ownerState.color === 'default' ? theme.vars.palette.action.activeChannel : theme.vars.palette[ownerState.color].mainChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(ownerState.color === 'default' ? theme.palette.action.active : theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
    // Reset on touch devices, it doesn't add specificity
    '@media (hover: none)': {
      backgroundColor: 'transparent'
    }
  }
}, ownerState.color !== 'default' && {
  [`&.${radioClasses$1.checked}`]: {
    color: (theme.vars || theme).palette[ownerState.color].main
  }
}, {
  [`&.${radioClasses$1.disabled}`]: {
    color: (theme.vars || theme).palette.action.disabled
  }
}));
function areEqualValues(a, b) {
  if (typeof b === 'object' && b !== null) {
    return a === b;
  }

  // The value could be a number, the DOM will stringify it anyway.
  return String(a) === String(b);
}
const defaultCheckedIcon = /*#__PURE__*/jsxRuntimeExports.jsx(RadioButtonIcon, {
  checked: true
});
const defaultIcon = /*#__PURE__*/jsxRuntimeExports.jsx(RadioButtonIcon, {});
const Radio = /*#__PURE__*/React__namespace.forwardRef(function Radio(inProps, ref) {
  var _defaultIcon$props$fo, _defaultCheckedIcon$p;
  const props = useThemeProps({
    props: inProps,
    name: 'MuiRadio'
  });
  const {
      checked: checkedProp,
      checkedIcon = defaultCheckedIcon,
      color = 'primary',
      icon = defaultIcon,
      name: nameProp,
      onChange: onChangeProp,
      size = 'medium',
      className
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$l);
  const ownerState = _extends$1({}, props, {
    color,
    size
  });
  const classes = useUtilityClasses$c(ownerState);
  const radioGroup = useRadioGroup();
  let checked = checkedProp;
  const onChange = createChainedFunction(onChangeProp, radioGroup && radioGroup.onChange);
  let name = nameProp;
  if (radioGroup) {
    if (typeof checked === 'undefined') {
      checked = areEqualValues(radioGroup.value, props.value);
    }
    if (typeof name === 'undefined') {
      name = radioGroup.name;
    }
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(RadioRoot, _extends$1({
    type: "radio",
    icon: /*#__PURE__*/React__namespace.cloneElement(icon, {
      fontSize: (_defaultIcon$props$fo = defaultIcon.props.fontSize) != null ? _defaultIcon$props$fo : size
    }),
    checkedIcon: /*#__PURE__*/React__namespace.cloneElement(checkedIcon, {
      fontSize: (_defaultCheckedIcon$p = defaultCheckedIcon.props.fontSize) != null ? _defaultCheckedIcon$p : size
    }),
    ownerState: ownerState,
    classes: classes,
    name: name,
    checked: checked,
    onChange: onChange,
    ref: ref,
    className: clsx(classes.root, className)
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? Radio.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, the component is checked.
   */
  checked: propTypesExports.bool,
  /**
   * The icon to display when the component is checked.
   * @default <RadioButtonIcon checked />
   */
  checkedIcon: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'primary'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['default', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * If `true`, the component is disabled.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the ripple effect is disabled.
   * @default false
   */
  disableRipple: propTypesExports.bool,
  /**
   * The icon to display when the component is unchecked.
   * @default <RadioButtonIcon />
   */
  icon: propTypesExports.node,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * Name attribute of the `input` element.
   */
  name: propTypesExports.string,
  /**
   * Callback fired when the state is changed.
   *
   * @param {React.ChangeEvent<HTMLInputElement>} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   * You can pull out the new checked state by accessing `event.target.checked` (boolean).
   */
  onChange: propTypesExports.func,
  /**
   * If `true`, the `input` element is required.
   * @default false
   */
  required: propTypesExports.bool,
  /**
   * The size of the component.
   * `small` is equivalent to the dense radio styling.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The value of the component. The DOM API casts this to a string.
   */
  value: propTypesExports.any
} : void 0;
var Radio$1 = Radio;

const _excluded$k = ["actions", "children", "defaultValue", "name", "onChange", "value"];
const RadioGroup = /*#__PURE__*/React__namespace.forwardRef(function RadioGroup(props, ref) {
  const {
      // private
      // eslint-disable-next-line react/prop-types
      actions,
      children,
      defaultValue,
      name: nameProp,
      onChange,
      value: valueProp
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$k);
  const rootRef = React__namespace.useRef(null);
  const [value, setValueState] = useControlled({
    controlled: valueProp,
    default: defaultValue,
    name: 'RadioGroup'
  });
  React__namespace.useImperativeHandle(actions, () => ({
    focus: () => {
      let input = rootRef.current.querySelector('input:not(:disabled):checked');
      if (!input) {
        input = rootRef.current.querySelector('input:not(:disabled)');
      }
      if (input) {
        input.focus();
      }
    }
  }), []);
  const handleRef = useForkRef(ref, rootRef);
  const name = useId(nameProp);
  const contextValue = React__namespace.useMemo(() => ({
    name,
    onChange(event) {
      setValueState(event.target.value);
      if (onChange) {
        onChange(event, event.target.value);
      }
    },
    value
  }), [name, onChange, setValueState, value]);
  return /*#__PURE__*/jsxRuntimeExports.jsx(RadioGroupContext$1.Provider, {
    value: contextValue,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(FormGroup$1, _extends$1({
      role: "radiogroup",
      ref: handleRef
    }, other, {
      children: children
    }))
  });
});
browser$1.env.NODE_ENV !== "production" ? RadioGroup.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypesExports.any,
  /**
   * The name used to reference the value of the control.
   * If you don't provide this prop, it falls back to a randomly generated name.
   */
  name: propTypesExports.string,
  /**
   * Callback fired when a radio button is selected.
   *
   * @param {React.ChangeEvent<HTMLInputElement>} event The event source of the callback.
   * @param {string} value The value of the selected radio button.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypesExports.func,
  /**
   * Value of the selected radio button. The DOM API casts this to a string.
   */
  value: propTypesExports.any
} : void 0;
var RadioGroup$1 = RadioGroup;

function RadioInput(_ref) {
  var title = _ref.title,
    value = _ref.value,
    options = _ref.options,
    _onChange = _ref.onChange,
    validationMessage = _ref.validationMessage,
    isDisabled = _ref.isDisabled;
  return /*#__PURE__*/React__namespace.default.createElement(FormControl$1, {
    fullWidth: true
  }, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), /*#__PURE__*/React__namespace.default.createElement(RadioGroup$1, {
    value: value,
    onChange: function onChange(event) {
      return _onChange(event.target.value);
    }
  }, options.map(function (option) {
    return /*#__PURE__*/React__namespace.default.createElement(FormControlLabel$1, {
      key: option,
      value: option,
      control: /*#__PURE__*/React__namespace.default.createElement(Radio$1, null),
      label: option,
      disabled: isDisabled
    });
  })), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    validationMessage: validationMessage
  }));
}
RadioInput.propTypes = {
  title: propTypesExports.string,
  value: propTypesExports.string,
  onChange: propTypesExports.func.isRequired,
  options: propTypesExports.arrayOf(propTypesExports.string).isRequired,
  validationMessage: propTypesExports.string,
  isDisabled: propTypesExports.bool
};

function ClearButton(_ref) {
  var onClick = _ref.onClick,
    isHidden = _ref.isHidden;
  if (isHidden) return null;
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$3, {
    onClick: onClick
  }, "Clear");
}
ClearButton.propTypes = {
  onClick: propTypesExports.func.isRequired,
  isHidden: propTypesExports.bool
};
var StyledButton$3 = styled__default.default(Button)({
  position: "absolute",
  bottom: "20px",
  right: "10px",
  padding: "2px !important",
  fontSize: "16px !important",
  textTransform: "none"
});

var SignatureCanvas = /*#__PURE__*/React.forwardRef(function SignatureCanvas(_ref, ref) {
  var value = _ref.value,
    dimensions = _ref.dimensions,
    onChange = _ref.onChange,
    shouldRenderAsImage = _ref.shouldRenderAsImage;
  // When the ref gets set, load the value into the signature canvas.
  // fromDataURL needs to be called with the dimensions so it loads propertly.
  React.useEffect(function () {
    // Don't load value into canvas if the ref hasn't been set yet, there's
    // no value, or shouldRenderAsImage is true (which means it's an attachment url).
    if (!ref.current || !value || shouldRenderAsImage) return;
    ref.current.fromDataURL(value, dimensions);
  }, [ref.current]);
  if (shouldRenderAsImage) {
    return /*#__PURE__*/React__namespace.default.createElement(AttachmentPreview, {
      attachmentId: value,
      style: _objectSpread2({
        maxHeight: "100%"
      }, dimensions),
      skeletonProps: dimensions
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(SignatureCanvasOg__default.default, {
    ref: ref,
    canvasProps: {
      width: dimensions.width,
      height: dimensions.height,
      clearOnResize: false
    },
    onEnd: function onEnd() {
      return onChange(ref.current.toDataURL());
    }
  });
});
SignatureCanvas.propTypes = {
  value: propTypesExports.string,
  dimensions: propTypesExports.shape({
    width: propTypesExports.number,
    height: propTypesExports.number
  }),
  onChange: propTypesExports.func.isRequired,
  isDisabled: propTypesExports.bool,
  shouldRenderAsImage: propTypesExports.bool
};

// The canvas requires set dimensions (doesn't handle percentages).
// So, the canvas size will adjust based on the dimensions of it's container.
function SignatureInput(_ref) {
  var value = _ref.value,
    title = _ref.title,
    onChange = _ref.onChange,
    validationMessage = _ref.validationMessage,
    isDisabled = _ref.isDisabled;
  var _useState = React.useState({
      width: 0,
      height: 0
    }),
    _useState2 = _slicedToArray(_useState, 2),
    dimensions = _useState2[0],
    setDimensions = _useState2[1];
  var canvasRef = React.useRef();
  var isUploadedAttachment = uuid.validate(value);
  return /*#__PURE__*/React__namespace.default.createElement(FormControl$1, {
    fullWidth: true
  }, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), /*#__PURE__*/React__namespace.default.createElement(Measure__default.default, {
    bounds: true,
    onResize: function onResize(rect) {
      return setDimensions(rect.bounds);
    }
  }, function (_ref2) {
    var measureRef = _ref2.measureRef;
    return /*#__PURE__*/React__namespace.default.createElement(SignatureContainer, {
      "data-testid": TEST_IDS.SIGNATURE_CONTAINER,
      ref: measureRef,
      isDisabled: isDisabled
    }, /*#__PURE__*/React__namespace.default.createElement(SignatureCanvas, {
      ref: canvasRef,
      value: value,
      dimensions: dimensions,
      onChange: onChange,
      shouldRenderAsImage: isUploadedAttachment
    }), /*#__PURE__*/React__namespace.default.createElement(Line, null), /*#__PURE__*/React__namespace.default.createElement(ClearButton, {
      isHidden: isDisabled,
      onClick: function onClick() {
        var _canvasRef$current;
        (_canvasRef$current = canvasRef.current) === null || _canvasRef$current === void 0 ? void 0 : _canvasRef$current.clear();
        onChange(null);
      }
    }, "Clear"));
  }), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    validationMessage: validationMessage
  }), /*#__PURE__*/React__namespace.default.createElement(Note$1, null, "Draw your signature above"));
}
SignatureInput.propTypes = {
  value: propTypesExports.string,
  title: propTypesExports.string,
  onChange: propTypesExports.func.isRequired,
  validationMessage: propTypesExports.string,
  isDisabled: propTypesExports.bool
};
var SignatureContainer = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref3) {
  var theme = _ref3.theme,
    isDisabled = _ref3.isDisabled;
  return {
    display: "flex",
    justifyContent: "stretch",
    border: "1px solid ".concat(theme.palette.divider),
    height: "160px",
    maxWidth: "600px",
    position: "relative",
    pointerEvents: isDisabled ? "none" : "auto",
    backgroundColor: theme.palette.card.backgroundLight
  };
});
var Line = styled__default.default(Box$1)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    borderBottom: "1px solid ".concat(theme.palette.divider),
    borderBottomStyle: "dashed",
    pointerEvents: "none",
    position: "absolute",
    bottom: "20px",
    left: "20px",
    width: "calc(100% - 40px)"
  };
});
var Note$1 = styled__default.default(Typography$1)(function (_ref5) {
  var theme = _ref5.theme;
  return {
    color: theme.palette.text.secondary,
    textAlign: "center",
    marginTop: "15px",
    // Needs to match SignatureContainer so they line up on different screen sizes.
    maxWidth: "600px"
  };
});

var BorderColorOutlined = {};

var _interopRequireDefault$i = interopRequireDefaultExports;
Object.defineProperty(BorderColorOutlined, "__esModule", {
  value: true
});
var default_1$i = BorderColorOutlined.default = void 0;
var _createSvgIcon$i = _interopRequireDefault$i(requireCreateSvgIcon());
var _jsxRuntime$i = requireJsxRuntime();
var _default$i = (0, _createSvgIcon$i.default)( /*#__PURE__*/(0, _jsxRuntime$i.jsx)("path", {
  d: "m16.81 8.94-3.75-3.75L4 14.25V18h3.75l9.06-9.06zM6 16v-.92l7.06-7.06.92.92L6.92 16H6zm13.71-9.96c.39-.39.39-1.02 0-1.41l-2.34-2.34c-.2-.2-.45-.29-.71-.29-.25 0-.51.1-.7.29l-1.83 1.83 3.75 3.75 1.83-1.83zM2 20h20v4H2z"
}), 'BorderColorOutlined');
default_1$i = BorderColorOutlined.default = _default$i;

var CheckBoxOutlined = {};

var _interopRequireDefault$h = interopRequireDefaultExports;
Object.defineProperty(CheckBoxOutlined, "__esModule", {
  value: true
});
var default_1$h = CheckBoxOutlined.default = void 0;
var _createSvgIcon$h = _interopRequireDefault$h(requireCreateSvgIcon());
var _jsxRuntime$h = requireJsxRuntime();
var _default$h = (0, _createSvgIcon$h.default)( /*#__PURE__*/(0, _jsxRuntime$h.jsx)("path", {
  d: "M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 16H5V5h14v14zM17.99 9l-1.41-1.42-6.59 6.59-2.58-2.57-1.42 1.41 4 3.99z"
}), 'CheckBoxOutlined');
default_1$h = CheckBoxOutlined.default = _default$h;

var ExpandCircleDownOutlined = {};

var _interopRequireDefault$g = interopRequireDefaultExports;
Object.defineProperty(ExpandCircleDownOutlined, "__esModule", {
  value: true
});
var default_1$g = ExpandCircleDownOutlined.default = void 0;
var _createSvgIcon$g = _interopRequireDefault$g(requireCreateSvgIcon());
var _jsxRuntime$g = requireJsxRuntime();
var _default$g = (0, _createSvgIcon$g.default)( /*#__PURE__*/(0, _jsxRuntime$g.jsx)("path", {
  d: "M15.08 9.59 12 12.67 8.92 9.59 7.5 11l4.5 4.5 4.5-4.5-1.42-1.41zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
}), 'ExpandCircleDownOutlined');
default_1$g = ExpandCircleDownOutlined.default = _default$g;

var Notes = {};

var _interopRequireDefault$f = interopRequireDefaultExports;
Object.defineProperty(Notes, "__esModule", {
  value: true
});
var default_1$f = Notes.default = void 0;
var _createSvgIcon$f = _interopRequireDefault$f(requireCreateSvgIcon());
var _jsxRuntime$f = requireJsxRuntime();
var _default$f = (0, _createSvgIcon$f.default)( /*#__PURE__*/(0, _jsxRuntime$f.jsx)("path", {
  d: "M3 18h12v-2H3v2zM3 6v2h18V6H3zm0 7h18v-2H3v2z"
}), 'Notes');
default_1$f = Notes.default = _default$f;

var RadioButtonChecked = {};

var _interopRequireDefault$e = interopRequireDefaultExports;
Object.defineProperty(RadioButtonChecked, "__esModule", {
  value: true
});
var default_1$e = RadioButtonChecked.default = void 0;
var _createSvgIcon$e = _interopRequireDefault$e(requireCreateSvgIcon());
var _jsxRuntime$e = requireJsxRuntime();
var _default$e = (0, _createSvgIcon$e.default)( /*#__PURE__*/(0, _jsxRuntime$e.jsx)("path", {
  d: "M12 7c-2.76 0-5 2.24-5 5s2.24 5 5 5 5-2.24 5-5-2.24-5-5-5zm0-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
}), 'RadioButtonChecked');
default_1$e = RadioButtonChecked.default = _default$e;

var _FORM_BUILDER_FIELD_L, _FORM_BUILDER_FIELD_D;
var FORM_BUILDER_FIELD_LABELS_BY_TYPE = (_FORM_BUILDER_FIELD_L = {}, _defineProperty(_FORM_BUILDER_FIELD_L, FORM_BUILDER_FIELD_TYPES.SHORT_ANSWER, "Short Answer"), _defineProperty(_FORM_BUILDER_FIELD_L, FORM_BUILDER_FIELD_TYPES.PARAGRAPH, "Paragraph"), _defineProperty(_FORM_BUILDER_FIELD_L, FORM_BUILDER_FIELD_TYPES.DROPDOWN, "Dropdown"), _defineProperty(_FORM_BUILDER_FIELD_L, FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE, "Multiple Choice"), _defineProperty(_FORM_BUILDER_FIELD_L, FORM_BUILDER_FIELD_TYPES.CHECKBOXES, "Checkboxes"), _defineProperty(_FORM_BUILDER_FIELD_L, FORM_BUILDER_FIELD_TYPES.SIGNATURE, "Signature"), _FORM_BUILDER_FIELD_L);
var FORM_BUILDER_FIELD_DROPDOWN_OPTIONS_BY_TYPE = (_FORM_BUILDER_FIELD_D = {}, _defineProperty(_FORM_BUILDER_FIELD_D, FORM_BUILDER_FIELD_TYPES.SHORT_ANSWER, {
  label: FORM_BUILDER_FIELD_LABELS_BY_TYPE.SHORT_ANSWER,
  value: FORM_BUILDER_FIELD_TYPES.SHORT_ANSWER,
  Icon: default_1$o
}), _defineProperty(_FORM_BUILDER_FIELD_D, FORM_BUILDER_FIELD_TYPES.PARAGRAPH, {
  label: FORM_BUILDER_FIELD_LABELS_BY_TYPE.PARAGRAPH,
  value: FORM_BUILDER_FIELD_TYPES.PARAGRAPH,
  Icon: default_1$f
}), _defineProperty(_FORM_BUILDER_FIELD_D, FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE, {
  label: FORM_BUILDER_FIELD_LABELS_BY_TYPE.MULTIPLE_CHOICE,
  value: FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE,
  Icon: default_1$e
}), _defineProperty(_FORM_BUILDER_FIELD_D, FORM_BUILDER_FIELD_TYPES.DROPDOWN, {
  label: FORM_BUILDER_FIELD_LABELS_BY_TYPE.DROPDOWN,
  value: FORM_BUILDER_FIELD_TYPES.DROPDOWN,
  Icon: default_1$g
}), _defineProperty(_FORM_BUILDER_FIELD_D, FORM_BUILDER_FIELD_TYPES.CHECKBOXES, {
  label: FORM_BUILDER_FIELD_LABELS_BY_TYPE.CHECKBOXES,
  value: FORM_BUILDER_FIELD_TYPES.CHECKBOXES,
  Icon: default_1$h
}), _defineProperty(_FORM_BUILDER_FIELD_D, FORM_BUILDER_FIELD_TYPES.SIGNATURE, {
  label: FORM_BUILDER_FIELD_LABELS_BY_TYPE.SIGNATURE,
  value: FORM_BUILDER_FIELD_TYPES.SIGNATURE,
  Icon: default_1$i
}), _FORM_BUILDER_FIELD_D);
function getDropdownOptionsForFieldByType() {
  return Object.values(FORM_BUILDER_FIELD_DROPDOWN_OPTIONS_BY_TYPE);
}
function getInputPath(_ref) {
  var fieldIndex = _ref.fieldIndex,
    optionIndex = _ref.optionIndex,
    property = _ref.property;
  var fieldPath = libCommon.isNil(fieldIndex) ? null : "fields.".concat(fieldIndex);
  var optionPath = libCommon.isNil(optionIndex) ? null : "options.".concat(optionIndex);
  var paths = [fieldPath, optionPath, property].filter(Boolean);
  return paths.join(".");
}
function formatFormFieldsForApi(fields) {
  return fields.map(function (field) {
    return libCommon.omit(field, ["validator"]);
  });
}

function getInputLabelByFieldType(fieldType) {
  return FORM_BUILDER_FIELD_LABELS_BY_TYPE[fieldType];
}
function getInputComponent$2(fieldType) {
  switch (fieldType) {
    case FORM_BUILDER_FIELD_TYPES.DROPDOWN:
      return DropDownInput;
    case FORM_BUILDER_FIELD_TYPES.CHECKBOXES:
      return MultiCheckBoxInput;
    case FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE:
      return RadioInput;
    case FORM_BUILDER_FIELD_TYPES.SIGNATURE:
      return SignatureInput;
    default:
      return FormTextInput;
  }
}
function getInputComponentProps(field) {
  var commonProps = {
    title: field.title,
    label: getInputLabelByFieldType(field.type)
  };
  switch (field.type) {
    case FORM_BUILDER_FIELD_TYPES.DROPDOWN:
      return _objectSpread2(_objectSpread2({}, commonProps), {}, {
        dropdownOptions: mapFieldOptionsToDropdownOptions(field.options),
        size: "small"
      });
    case FORM_BUILDER_FIELD_TYPES.CHECKBOXES:
    case FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE:
      return _objectSpread2(_objectSpread2({}, commonProps), {}, {
        options: mapFieldOptionsToString(field.options)
      });
    case FORM_BUILDER_FIELD_TYPES.PARAGRAPH:
      return _objectSpread2(_objectSpread2({}, commonProps), {}, {
        multiline: true,
        rows: 3
      });
    case FORM_BUILDER_FIELD_TYPES.SIGNATURE:
    default:
      return commonProps;
  }
}
function mapFieldOptionsToDropdownOptions(options) {
  return options.map(function (_ref) {
    var value = _ref.value;
    return {
      label: value,
      value: value
    };
  });
}
function mapFieldOptionsToString(options) {
  return options.map(function (_ref2) {
    var value = _ref2.value;
    return value;
  });
}

// Currently, we are not supporting form sections on the front end,
// however, the backend is setup for them. So, we are just storing all
// fields in a single section and treating sections like they don't exist in the UI.
function getFormFields(form) {
  return form.sections[0].fields;
}

function FormSubmissionViewFields(_ref) {
  var form = _ref.form,
    submission = _ref.submission;
  var formFields = form.sections[0].fields;
  return /*#__PURE__*/React__namespace.default.createElement(Container$n, null, formFields.map(function (field) {
    var Component = getInputComponent$2(field.type);
    var componentProps = getInputComponentProps(field);
    var value = getFieldValueFromSubmission({
      submission: submission,
      field: field
    });
    return /*#__PURE__*/React__namespace.default.createElement(Component, _extends$2({
      key: field.id
    }, componentProps, {
      value: value
      // Noop to prevent proptype warnings.
      ,
      onChange: noop,
      isDisabled: true
    }));
  }));
}
FormSubmissionViewFields.propTypes = {
  form: propTypesExports.shape({
    sections: propTypesExports.arrayOf(propTypesExports.shape({
      fields: propTypesExports.array
    }))
  }).isRequired,
  submission: propTypesExports.shape({
    answers: propTypesExports.arrayOf(propTypesExports.shape({
      field_id: propTypesExports.string,
      answer: propTypesExports.oneOfType([propTypesExports.string, propTypesExports.arrayOf(propTypesExports.string)])
    }))
  })
};
var Container$n = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    padding: "10px",
    "& .Mui-disabled": {
      color: theme.palette.text.secondary,
      WebkitTextFillColor: theme.palette.text.primary
    }
  };
});
function getFieldValueFromSubmission(_ref3) {
  var _submission$answers;
  var submission = _ref3.submission,
    field = _ref3.field;
  var foundAnswer = submission === null || submission === void 0 ? void 0 : (_submission$answers = submission.answers) === null || _submission$answers === void 0 ? void 0 : _submission$answers.find(function (answer) {
    return answer.field_id === field.id;
  });
  return foundAnswer === null || foundAnswer === void 0 ? void 0 : foundAnswer.answer;
}

function FormBuilderInputPreview(_ref) {
  var form = _ref.form,
    onEditClick = _ref.onEditClick,
    onDeleteClick = _ref.onDeleteClick;
  return /*#__PURE__*/React__namespace.default.createElement(Container$m, null, /*#__PURE__*/React__namespace.default.createElement(FormInputContainer, null, /*#__PURE__*/React__namespace.default.createElement(Title$2, null, form.title), /*#__PURE__*/React__namespace.default.createElement(CollapsibleExpandButton, null), /*#__PURE__*/React__namespace.default.createElement(ActionableButton, {
    isSmall: true,
    icon: /*#__PURE__*/React__namespace.default.createElement(default_1$E, null),
    actions: getActionConfigs$1({
      onEditClick: onEditClick,
      onDeleteClick: onDeleteClick
    })
  })), /*#__PURE__*/React__namespace.default.createElement(DynamicCollapsibleBox, {
    isCollapsible: true
  }, /*#__PURE__*/React__namespace.default.createElement(CollapsibleContent, null, /*#__PURE__*/React__namespace.default.createElement(FormSubmissionViewFields, {
    form: form
  }))));
}
FormBuilderInputPreview.propTypes = {
  form: propTypesExports.shape({
    title: propTypesExports.string
  }),
  onEditClick: propTypesExports.func.isRequired,
  onDeleteClick: propTypesExports.func.isRequired
};
var Container$m = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    backgroundColor: theme.palette.card.background,
    padding: "6px 12px",
    borderRadius: theme.borderRadius.sm
  };
});
var FormInputContainer = styled__default.default(Box$1)({
  display: "flex",
  flexDirection: "row",
  alignItems: "center",
  width: "100%"
});
var CollapsibleContent = styled__default.default(Box$1)({
  padding: "0 8px 12px 8px"
});
var Title$2 = styled__default.default(Typography$1)({
  flex: 1,
  marginLeft: "8px"
});
function getActionConfigs$1(_ref3) {
  var onEditClick = _ref3.onEditClick,
    onDeleteClick = _ref3.onDeleteClick;
  return [{
    name: "Edit",
    onClick: onEditClick
  }, {
    name: "Remove",
    onClick: onDeleteClick
  }];
}

var WarningAmber = {};

var _interopRequireDefault$d = interopRequireDefaultExports;
Object.defineProperty(WarningAmber, "__esModule", {
  value: true
});
var default_1$d = WarningAmber.default = void 0;
var _createSvgIcon$d = _interopRequireDefault$d(requireCreateSvgIcon());
var _jsxRuntime$d = requireJsxRuntime();
var _default$d = (0, _createSvgIcon$d.default)([/*#__PURE__*/(0, _jsxRuntime$d.jsx)("path", {
  d: "M12 5.99 19.53 19H4.47L12 5.99M12 2 1 21h22L12 2z"
}, "0"), /*#__PURE__*/(0, _jsxRuntime$d.jsx)("path", {
  d: "M13 16h-2v2h2zm0-6h-2v5h2z"
}, "1")], 'WarningAmber');
default_1$d = WarningAmber.default = _default$d;

var _excluded$j = ["textConfigs"];
function RichTypography(_ref) {
  var textConfigs = _ref.textConfigs,
    props = _objectWithoutProperties(_ref, _excluded$j);
  return /*#__PURE__*/React__namespace.default.createElement(Typography$1, props, textConfigs.map(function (config, idx) {
    return /*#__PURE__*/React__namespace.default.createElement(Typography$1, _extends$2({
      key: "rich_text_".concat(idx),
      variant: !config.variant ? "inherit" : config.variant,
      display: !config.display ? "inline" : config.display
    }, config), config.text);
  }));
}
RichTypography.propTypes = {
  textConfigs: propTypesExports.arrayOf(propTypesExports.shape({
    text: propTypesExports.string.isRequired
  }))
};

function FormBuilderEditWarning(_ref) {
  var show = _ref.show;
  if (!show) return null;
  return /*#__PURE__*/React__namespace.default.createElement(Container$l, {
    "data-testid": TEST_IDS.EDIT_FORM_WARNING
  }, /*#__PURE__*/React__namespace.default.createElement(StyledWarningIcon, null), /*#__PURE__*/React__namespace.default.createElement(RichTypography, {
    textConfigs: getTextConfigs()
  }));
}
FormBuilderEditWarning.propTypes = {
  show: propTypesExports.bool
};
var Container$l = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: "flex",
    alignItems: "center",
    gap: 10,
    backgroundColor: "".concat(theme.palette.warning.light, "25"),
    padding: "10px 15px",
    borderRadius: theme.borderRadius.sm,
    margin: "15px auto"
  };
});
var StyledWarningIcon = styled__default.default(default_1$d)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    color: theme.palette.warning.light
  };
});
function getTextConfigs() {
  return [{
    text: "Changes made to an existing form will be "
  }, {
    text: "applied everywhere",
    variant: "h6"
  }, {
    text: " the form is linked."
  }];
}

function getFormValidationSchema$1() {
  return yup__namespace.object().shape({
    title: yup__namespace.string().max(FORM_BUILDER_VALIDATION_LIMITS.TITLE.MAX, FORM_BUILDER_VALIDATION_MESSAGES.TITLE.MAX).nullable().required(FORM_BUILDER_VALIDATION_MESSAGES.TITLE.REQUIRED),
    fields: yup__namespace.array().of(getFieldValidationSchema$1()),
    max_submission_count: yup__namespace["boolean"]().required(),
    are_submissions_public: yup__namespace["boolean"]().required()
  });
}
function getFieldValidationSchema$1() {
  return yup__namespace.object().shape({
    type: yup__namespace.string().required(FORM_BUILDER_VALIDATION_MESSAGES.FIELD_TYPE.REQUIRED),
    sub_type: yup__namespace.string().nullable(),
    title: yup__namespace.string().max(FORM_BUILDER_VALIDATION_LIMITS.FIELD_TITLE.MAX, FORM_BUILDER_VALIDATION_MESSAGES.FIELD_TITLE.MAX).nullable().required(FORM_BUILDER_VALIDATION_MESSAGES.FIELD_TITLE.REQUIRED),
    is_required: yup__namespace["boolean"]().required(),
    options: getFieldOptionsSchema()
  });
}
function getFieldOptionsSchema() {
  return yup__namespace.array().of(getFieldOptionSchema()).when("type", {
    is: function is(type) {
      return FORM_BUILDER_FIELD_TYPES_WITH_OPTIONS.includes(type);
    },
    then: function then(schema) {
      return schema.min(FORM_BUILDER_VALIDATION_LIMITS.FIELD_OPTIONS.MIN, FORM_BUILDER_VALIDATION_MESSAGES.FIELD_OPTIONS.MIN);
    }
  });
}
function getFieldOptionSchema() {
  return yup__namespace.object({
    id: yup__namespace.string().required(),
    value: yup__namespace.string().max(FORM_BUILDER_VALIDATION_LIMITS.FIELD_OPTION.MAX, FORM_BUILDER_VALIDATION_MESSAGES.FIELD_OPTION.MAX).required(FORM_BUILDER_VALIDATION_MESSAGES.FIELD_OPTION.REQUIRED)
  });
}

var FIELDS = "fields";
var FormBuilderContext = /*#__PURE__*/React.createContext();
function useFormBuilder() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    fieldIndex = _ref.fieldIndex;
  var context = React.useContext(FormBuilderContext);
  var getField = context.getField,
    getValues = context.getValues;
  return _objectSpread2(_objectSpread2({
    fields: getValues(FIELDS)
  }, libCommon.isNumber(fieldIndex) && {
    field: getField(fieldIndex)
  }), context);
}
function FormBuilderProvider(_ref2) {
  var form = _ref2.form,
    children = _ref2.children;
  var configs = getFormConfig$1({
    initialValues: getInitialValues$1(form),
    validationSchema: getFormValidationSchema$1(),
    validationMode: "onBlur"
  });
  var _useForm = reactHookForm.useForm(configs),
    control = _useForm.control,
    handleSubmit = _useForm.handleSubmit,
    formState = _useForm.formState,
    watch = _useForm.watch,
    getValues = _useForm.getValues,
    setValue = _useForm.setValue;
  var _useFieldArray = reactHookForm.useFieldArray({
      control: control,
      name: FIELDS
    }),
    append = _useFieldArray.append,
    remove = _useFieldArray.remove,
    move = _useFieldArray.move;
  var isSubmitting = formState.isSubmitting,
    errors = formState.errors;
  var getFields = function getFields() {
    return getValues(FIELDS);
  };
  var getField = function getField(index) {
    return getFields()[index];
  };
  var moveField = function moveField(_ref3) {
    var fromIndex = _ref3.fromIndex,
      toIndex = _ref3.toIndex;
    return move(fromIndex, toIndex);
  };
  var appendField = function appendField() {
    return append(getInitialFieldValue());
  };
  var removeField = function removeField(fieldIndex) {
    return remove(fieldIndex);
  };
  var changeFieldType = function changeFieldType(_ref4) {
    var fieldIndex = _ref4.fieldIndex,
      type = _ref4.type;
    return handleFieldTypeChange({
      fieldIndex: fieldIndex,
      type: type,
      getField: getField,
      setValue: setValue
    });
  };
  var value = React.useMemo(function () {
    return {
      control: control,
      handleSubmit: handleSubmit,
      isSubmitting: isSubmitting,
      errors: errors,
      watch: watch,
      getValues: getValues,
      appendField: appendField,
      removeField: removeField,
      changeFieldType: changeFieldType,
      moveField: moveField,
      getField: getField,
      getFields: getFields,
      formBeingEdited: form,
      isEditing: Boolean(form === null || form === void 0 ? void 0 : form.id)
    };
  }, [form, formState]);
  return /*#__PURE__*/React__namespace.default.createElement(FormBuilderContext.Provider, {
    value: value
  }, children);
}
var fieldPropType = propTypesExports.shape({
  id: propTypesExports.string,
  type: propTypesExports.string,
  sub_type: propTypesExports.string,
  title: propTypesExports.string,
  is_required: propTypesExports.bool,
  options: propTypesExports.arrayOf(propTypesExports.shape({
    id: propTypesExports.string,
    value: propTypesExports.string
  }))
});
FormBuilderProvider.propTypes = {
  form: propTypesExports.shape({
    id: propTypesExports.string,
    title: propTypesExports.string,
    section: propTypesExports.shape({
      id: propTypesExports.string,
      title: propTypesExports.string,
      fields: propTypesExports.arrayOf(fieldPropType)
    }),
    max_submission_count: propTypesExports.number,
    are_submissions_public: propTypesExports.bool
  }),
  children: propTypesExports.any.isRequired
};
function getFormConfig$1(_ref5) {
  var initialValues = _ref5.initialValues,
    validationSchema = _ref5.validationSchema,
    validationMode = _ref5.validationMode;
  return {
    defaultValues: initialValues,
    resolver: o(validationSchema),
    mode: validationMode,
    reValidateMode: validationMode
  };
}

/*
    The backend is setup to handle fields being grouped by sections. However, for now,
    we're just ignoring sections on the front ends by using the first section to store
    all of the fields. We're also just using max_submission_count to limit to one or no limit.
*/
function getInitialValues$1(form) {
  var _form$sections, _form$sections$;
  return {
    id: (form === null || form === void 0 ? void 0 : form.id) || null,
    title: (form === null || form === void 0 ? void 0 : form.title) || null,
    fields: (form === null || form === void 0 ? void 0 : (_form$sections = form.sections) === null || _form$sections === void 0 ? void 0 : (_form$sections$ = _form$sections[0]) === null || _form$sections$ === void 0 ? void 0 : _form$sections$.fields) || [],
    // Controlled via a toggle switch, so it needs to be converted to a boolean.
    // We're using null for no limit, and 1 to limit to one submission.
    max_submission_count: Boolean(form === null || form === void 0 ? void 0 : form.max_submission_count),
    are_submissions_public: (form === null || form === void 0 ? void 0 : form.are_submissions_public) || false
  };
}
function getInitialFieldValue() {
  return {
    id: uuid.v4(),
    type: FORM_BUILDER_FIELD_TYPES.SHORT_ANSWER,
    sub_type: null,
    title: null,
    is_required: false,
    options: []
  };
}
function handleFieldTypeChange(_ref6) {
  var fieldIndex = _ref6.fieldIndex,
    type = _ref6.type,
    getField = _ref6.getField,
    setValue = _ref6.setValue;
  var options = getNewOptionsAfterFieldTypeChange({
    type: type,
    fieldIndex: fieldIndex,
    getField: getField
  });
  setValue(getInputPath({
    fieldIndex: fieldIndex,
    property: "type"
  }), type);
  setValue(getInputPath({
    fieldIndex: fieldIndex,
    property: "options"
  }), options);
}
function getNewOptionsAfterFieldTypeChange(_ref7) {
  var type = _ref7.type,
    fieldIndex = _ref7.fieldIndex,
    getField = _ref7.getField;
  if (!FORM_BUILDER_FIELD_TYPES_WITH_OPTIONS.includes(type)) return [];
  var field = getField(fieldIndex);
  var hasOptions = Boolean(field.options.length);
  return hasOptions ? field.options : [{
    id: uuid.v4(),
    value: ""
  }];
}

function DraggableContent(_ref) {
  var providedDrag = _ref.providedDrag,
    shouldUseCustomDragHandle = _ref.shouldUseCustomDragHandle,
    getItemProps = _ref.getItemProps,
    index = _ref.index,
    ItemComponent = _ref.ItemComponent,
    item = _ref.item,
    _ref$containerMarginB = _ref.containerMarginBottom,
    containerMarginBottom = _ref$containerMarginB === void 0 ? 1 : _ref$containerMarginB;
  return /*#__PURE__*/React__namespace.default.createElement(Box$1, _extends$2({
    ref: providedDrag.innerRef
  }, providedDrag.draggableProps, getDragHandlePropsForContainer({
    shouldUseCustomDragHandle: shouldUseCustomDragHandle,
    dragHandleProps: providedDrag.dragHandleProps
  }), {
    mb: containerMarginBottom
  }), /*#__PURE__*/React__namespace.default.createElement(ItemComponent, getItemProps({
    itemIndex: index,
    dragHandleProps: getDragHandlePropsForCustomHandle({
      shouldUseCustomDragHandle: shouldUseCustomDragHandle,
      dragHandleProps: providedDrag.dragHandleProps
    }),
    item: item
  })));
}
DraggableContent.propTypes = {
  providedDrag: propTypesExports.object.isRequired,
  index: propTypesExports.number.isRequired,
  ItemComponent: propTypesExports.any.isRequired,
  getItemProps: propTypesExports.func.isRequired,
  shouldUseCustomDragHandle: propTypesExports.bool,
  item: propTypesExports.object,
  containerMarginBottom: propTypesExports.number
};
function getDragHandlePropsForContainer(_ref2) {
  var shouldUseCustomDragHandle = _ref2.shouldUseCustomDragHandle,
    dragHandleProps = _ref2.dragHandleProps;
  if (shouldUseCustomDragHandle) return {};
  return dragHandleProps;
}
function getDragHandlePropsForCustomHandle(_ref3) {
  var shouldUseCustomDragHandle = _ref3.shouldUseCustomDragHandle,
    dragHandleProps = _ref3.dragHandleProps;
  if (shouldUseCustomDragHandle) return dragHandleProps;
  return {};
}

function DraggableItem(_ref) {
  var item = _ref.item,
    index = _ref.index,
    ItemComponent = _ref.ItemComponent,
    getItemProps = _ref.getItemProps,
    shouldUseCustomDragHandle = _ref.shouldUseCustomDragHandle;
  return /*#__PURE__*/React__namespace.default.createElement(reactBeautifulDnd.Draggable, {
    draggableId: item.id,
    index: index
  }, function (providedDrag) {
    return /*#__PURE__*/React__namespace.default.createElement(DraggableContent, {
      item: item,
      providedDrag: providedDrag,
      shouldUseCustomDragHandle: shouldUseCustomDragHandle,
      getItemProps: getItemProps,
      index: index,
      ItemComponent: ItemComponent
    });
  });
}
DraggableItem.propTypes = {
  item: propTypesExports.object,
  index: propTypesExports.number.isRequired,
  ItemComponent: propTypesExports.any.isRequired,
  getItemProps: propTypesExports.func.isRequired,
  shouldUseCustomDragHandle: propTypesExports.bool
};

function DroppableContainer(_ref) {
  var items = _ref.items,
    ItemComponent = _ref.ItemComponent,
    getItemProps = _ref.getItemProps,
    shouldUseCustomDragHandle = _ref.shouldUseCustomDragHandle,
    droppableId = _ref.droppableId;
  return /*#__PURE__*/React__namespace.default.createElement(reactBeautifulDnd.Droppable, {
    droppableId: droppableId
  }, function (providedDrop) {
    return /*#__PURE__*/React__namespace.default.createElement(Box$1, _extends$2({
      ref: providedDrop.innerRef
    }, providedDrop.droppableProps), items.map(function (item, index) {
      return /*#__PURE__*/React__namespace.default.createElement(DraggableItem, {
        key: item.id,
        item: item,
        index: index,
        ItemComponent: ItemComponent,
        getItemProps: getItemProps,
        shouldUseCustomDragHandle: shouldUseCustomDragHandle
      });
    }), providedDrop.placeholder);
  });
}
DroppableContainer.propTypes = {
  items: propTypesExports.arrayOf(propTypesExports.shape({
    id: propTypesExports.string.isRequired
  })).isRequired,
  droppableId: propTypesExports.string.isRequired,
  ItemComponent: propTypesExports.any.isRequired,
  getItemProps: propTypesExports.func.isRequired,
  shouldUseCustomDragHandle: propTypesExports.bool
};

function DragAndDropContainer(_ref) {
  var items = _ref.items,
    moveItem = _ref.moveItem,
    ItemComponent = _ref.ItemComponent,
    getItemProps = _ref.getItemProps,
    _ref$shouldUseCustomD = _ref.shouldUseCustomDragHandle,
    shouldUseCustomDragHandle = _ref$shouldUseCustomD === void 0 ? false : _ref$shouldUseCustomD,
    droppableId = _ref.droppableId;
  return /*#__PURE__*/React__namespace.default.createElement(reactBeautifulDnd.DragDropContext, {
    onDragEnd: function onDragEnd(result) {
      return _onDragEnd({
        result: result,
        moveItem: moveItem
      });
    }
  }, /*#__PURE__*/React__namespace.default.createElement(DroppableContainer, {
    droppableId: droppableId,
    items: items,
    ItemComponent: ItemComponent,
    getItemProps: getItemProps,
    shouldUseCustomDragHandle: shouldUseCustomDragHandle
  }));
}
DragAndDropContainer.propTypes = {
  items: propTypesExports.arrayOf(propTypesExports.shape({
    id: propTypesExports.string.isRequired
  })).isRequired,
  droppableId: propTypesExports.string.isRequired,
  moveItem: propTypesExports.func.isRequired,
  ItemComponent: propTypesExports.any.isRequired,
  getItemProps: propTypesExports.func.isRequired,
  shouldUseCustomDragHandle: propTypesExports.bool
};

// exported for tests
function _onDragEnd(_ref2) {
  var result = _ref2.result,
    moveItem = _ref2.moveItem;
  var source = result.source,
    destination = result.destination,
    draggableId = result.draggableId;

  // dropped outside the list
  if (!destination) return;
  moveItem({
    fromIndex: source.index,
    toIndex: destination.index,
    id: draggableId
  });
}

var ContentBlockInputContainer = styled__default.default(Box$1)({
  flex: 14,
  padding: "10px"
});
var DropDownInputContainer = styled__default.default(Box$1)({
  flex: 2,
  padding: "10px",
  display: "flex",
  flexDirection: "column",
  flexWrap: "wrap",
  justifyContent: "center"
});
var RemoveBlockButtonContainer = styled__default.default(Box$1)({
  padding: "10px",
  display: "flex",
  flexDirection: "column",
  flexWrap: "wrap",
  justifyContent: "center"
});
var BlockRow = styled__default.default(Box$1)(function (_ref) {
  var theme = _ref.theme;
  return _defineProperty({
    display: "flex",
    flex: 1,
    justifyContent: "center",
    backgroundColor: theme.palette.contentBlocks.background,
    borderRadius: "8px",
    margin: "8px",
    maxWidth: "100%",
    alignItems: "center"
  }, theme.breakpoints.down("md"), {
    flexDirection: "column"
  });
});

function DraggableSectionHeader(_ref) {
  var dragHandleProps = _ref.dragHandleProps,
    actions = _ref.actions;
  var styles = getStyles$5();
  return /*#__PURE__*/React__namespace.default.createElement(IconRow, null, /*#__PURE__*/React__namespace.default.createElement(Box$1, _extends$2({
    sx: styles.dragIconContainer
  }, dragHandleProps, {
    "data-testid": TEST_IDS.SECTION_INPUT_DRAG_HANDLE
  }), /*#__PURE__*/React__namespace.default.createElement(default_1$l, {
    sx: styles.dragIcon
  })), /*#__PURE__*/React__namespace.default.createElement(Box$1, {
    sx: styles.dropDownButton
  }, /*#__PURE__*/React__namespace.default.createElement(ActionableButton, {
    id: "section_actions_dropdown",
    isSmall: true,
    icon: /*#__PURE__*/React__namespace.default.createElement(default_1$E, null),
    actions: actions
  })));
}
DraggableSectionHeader.propTypes = {
  dragHandleProps: propTypesExports.object,
  actions: propTypesExports.arrayOf(propTypesExports.shape({
    name: propTypesExports.string.isRequired,
    onClick: propTypesExports.func.isRequired
  }))
};
var IconRow = styled__default.default(Box$1)({
  display: "flex",
  flex: 1,
  flexDirection: "row",
  alignItems: "center",
  justifyContent: "center"
});
function getStyles$5() {
  return {
    dragIconContainer: {
      marginLeft: "49%"
    },
    dragIcon: {
      transform: "rotate(90deg)"
    },
    dropDownButton: {
      marginLeft: "auto"
    }
  };
}

function FormBuilderFieldNote(_ref) {
  var note = _ref.note;
  return /*#__PURE__*/React__namespace.default.createElement(Note, null, note);
}
FormBuilderFieldNote.propTypes = {
  note: propTypesExports.string.isRequired
};
var Note = styled__default.default(Typography$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    color: theme.palette.text.secondary,
    fontStyle: "italic",
    margin: "10px 0"
  };
});

function FormBuilderFieldOptionBullet(_ref) {
  var fieldType = _ref.fieldType,
    number = _ref.number;
  if (fieldType === FORM_BUILDER_FIELD_TYPES.CHECKBOXES) {
    return /*#__PURE__*/React__namespace.default.createElement(Square, null);
  }
  if (fieldType === FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE) {
    return /*#__PURE__*/React__namespace.default.createElement(Circle, null);
  }
  return /*#__PURE__*/React__namespace.default.createElement(Typography$1, null, "".concat(number, "."));
}
FormBuilderFieldOptionBullet.propTypes = {
  fieldType: propTypesExports.string.isRequired,
  number: propTypesExports.number
};
var Square = styled__default.default(Box$1)({
  border: "1px solid currentColor",
  width: "20px",
  height: "20px",
  flexShrink: 0,
  flexGrow: 0
});
var Circle = styled__default.default(Square)({
  borderRadius: "50%"
});

function FormBuilderFieldOptionTextInput(_ref) {
  var label = _ref.label,
    fieldIndex = _ref.fieldIndex,
    optionIndex = _ref.optionIndex;
  return /*#__PURE__*/React__namespace.default.createElement(StyledControlledInput, {
    path: getInputPath({
      fieldIndex: fieldIndex,
      optionIndex: optionIndex,
      property: "value"
    }),
    Component: FormTextInput,
    contextHook: useFormBuilder,
    variant: CONTENT_BLOCK_INPUT_VARIANT,
    label: label
  });
}
FormBuilderFieldOptionTextInput.propTypes = {
  label: propTypesExports.string.isRequired,
  fieldIndex: propTypesExports.number.isRequired,
  optionIndex: propTypesExports.number.isRequired
};
var StyledControlledInput = styled__default.default(ControlledInput)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    "& .MuiInput-input": {
      backgroundColor: theme.palette.colors.contentBlockInput.background,
      padding: "5px"
    },
    width: "100%",
    marginBottom: "5px"
  };
});

function FormBuilderFieldOptionsInputCore(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange,
    fieldType = _ref.fieldType,
    fieldIndex = _ref.fieldIndex;
  // Options is the value of this input. Referring to the field options being edited.
  var _useState = React.useState(value),
    _useState2 = _slicedToArray(_useState, 2),
    options = _useState2[0],
    setOptions = _useState2[1];

  // Call onChange when options change.
  React.useEffect(function () {
    onChange(options);
  }, [options]);
  return /*#__PURE__*/React__namespace.default.createElement(Box$1, null, options.map(function (_ref2, index) {
    var id = _ref2.id;
    return /*#__PURE__*/React__namespace.default.createElement(OptionContainer, {
      key: id
    }, /*#__PURE__*/React__namespace.default.createElement(FormBuilderFieldOptionBullet, {
      fieldType: fieldType,
      number: addOne(index)
    }), /*#__PURE__*/React__namespace.default.createElement(FormBuilderFieldOptionTextInput, {
      label: "Option ".concat(addOne(index)),
      fieldIndex: fieldIndex,
      optionIndex: index
    }), options.length > 1 && /*#__PURE__*/React__namespace.default.createElement(RemoveOptionButton, {
      onClick: function onClick() {
        return handleRemoveOption({
          id: id,
          setOptions: setOptions
        });
      }
    }));
  }), /*#__PURE__*/React__namespace.default.createElement(OptionContainer, null, /*#__PURE__*/React__namespace.default.createElement(FormBuilderFieldOptionBullet, {
    fieldType: fieldType,
    number: addOne(options.length)
  }), /*#__PURE__*/React__namespace.default.createElement(AddOptionButton, {
    onClick: function onClick() {
      return handleAddOption({
        setOptions: setOptions
      });
    }
  }, "Add option")));
}
FormBuilderFieldOptionsInputCore.propTypes = {
  value: propTypesExports.arrayOf(propTypesExports.shape({
    id: propTypesExports.string,
    value: propTypesExports.string
  })),
  onChange: propTypesExports.func.isRequired,
  fieldType: propTypesExports.string.isRequired,
  fieldIndex: propTypesExports.number.isRequired
};
var OptionContainer = styled__default.default(Box$1)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    display: "flex",
    alignItems: "center",
    gap: 12,
    color: theme.palette.text.secondary
  };
});
var AddOptionButton = styled__default.default(Button$2)({
  padding: "4px 5px !important",
  textTransform: "none",
  fontWeight: "normal",
  fontSize: "inherit"
});
var RemoveOptionButton = styled__default.default(CloseButton)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    color: theme.palette.colors.icon.primary,
    padding: 2
  };
});
function handleAddOption(_ref5) {
  var setOptions = _ref5.setOptions;
  setOptions(function (curOptions) {
    return [].concat(_toConsumableArray(curOptions), [{
      id: uuid.v4(),
      value: ""
    }]);
  });
}
function handleRemoveOption(_ref6) {
  var id = _ref6.id,
    setOptions = _ref6.setOptions;
  setOptions(function (curOptions) {
    return curOptions.filter(function (option) {
      return option.id !== id;
    });
  });
}
function addOne(num) {
  return num + 1;
}

function FormBuilderFieldOptionsInput(_ref) {
  var fieldIndex = _ref.fieldIndex,
    fieldType = _ref.fieldType;
  return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, {
    path: getInputPath({
      fieldIndex: fieldIndex,
      property: "options"
    }),
    Component: FormBuilderFieldOptionsInputCore,
    contextHook: useFormBuilder,
    fieldType: fieldType,
    fieldIndex: fieldIndex
  });
}
FormBuilderFieldOptionsInput.propTypes = {
  fieldIndex: propTypesExports.number.isRequired,
  fieldType: propTypesExports.string.isRequired
};

var SIGNATURE_FIELD_NOTE = "Respondents will be shown a box to draw their signature.";
function FormBuilderFieldPreviewAndOptions(_ref) {
  var fieldIndex = _ref.fieldIndex;
  var _useFormBuilder = useFormBuilder(),
    watch = _useFormBuilder.watch;
  var type = watch(getInputPath({
    fieldIndex: fieldIndex,
    property: "type"
  }));
  var InputComponent = getInputComponent$1(type);
  var inputProps = getInputProps$1({
    type: type,
    fieldIndex: fieldIndex
  });
  return /*#__PURE__*/React__namespace.default.createElement(InputComponent, inputProps);
}
FormBuilderFieldPreviewAndOptions.propTypes = {
  fieldIndex: propTypesExports.number.isRequired
};
function getInputComponent$1(type) {
  switch (type) {
    case FORM_BUILDER_FIELD_TYPES.SIGNATURE:
      return FormBuilderFieldNote;
    case FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE:
    case FORM_BUILDER_FIELD_TYPES.CHECKBOXES:
    case FORM_BUILDER_FIELD_TYPES.DROPDOWN:
      return FormBuilderFieldOptionsInput;
    case FORM_BUILDER_FIELD_TYPES.SHORT_ANSWER:
    case FORM_BUILDER_FIELD_TYPES.PARAGRAPH:
    default:
      return FormTextInput;
  }
}
function getInputProps$1(_ref2) {
  var type = _ref2.type,
    fieldIndex = _ref2.fieldIndex;
  var label = FORM_BUILDER_FIELD_LABELS_BY_TYPE[type];
  var commonProps = {
    label: label,
    isDisabled: true
  };
  switch (type) {
    case FORM_BUILDER_FIELD_TYPES.SIGNATURE:
      return {
        note: SIGNATURE_FIELD_NOTE
      };
    case FORM_BUILDER_FIELD_TYPES.MULTIPLE_CHOICE:
    case FORM_BUILDER_FIELD_TYPES.CHECKBOXES:
    case FORM_BUILDER_FIELD_TYPES.DROPDOWN:
      return {
        fieldIndex: fieldIndex,
        fieldType: type
      };
    case FORM_BUILDER_FIELD_TYPES.PARAGRAPH:
      return _objectSpread2(_objectSpread2({}, commonProps), {}, {
        multiline: true,
        rows: 3
      });
    case FORM_BUILDER_FIELD_TYPES.SHORT_ANSWER:
    default:
      return commonProps;
  }
}

function FormBuilderFieldTypeSelector(_ref) {
  var fieldIndex = _ref.fieldIndex;
  var _useFormBuilder = useFormBuilder({
      fieldIndex: fieldIndex
    }),
    changeFieldType = _useFormBuilder.changeFieldType,
    field = _useFormBuilder.field;
  return /*#__PURE__*/React__namespace.default.createElement(DropDownInputContainer, null, /*#__PURE__*/React__namespace.default.createElement(DropDownInput, {
    value: field.type,
    onChange: function onChange(newType) {
      return changeFieldType({
        fieldIndex: fieldIndex,
        type: newType
      });
    },
    dropdownOptions: getDropdownOptionsForFieldByType()
  }));
}
FormBuilderFieldTypeSelector.propTypes = {
  fieldIndex: propTypesExports.number.isRequired
};

function getSwitchUtilityClass(slot) {
  return generateUtilityClass('MuiSwitch', slot);
}
const switchClasses = generateUtilityClasses('MuiSwitch', ['root', 'edgeStart', 'edgeEnd', 'switchBase', 'colorPrimary', 'colorSecondary', 'sizeSmall', 'sizeMedium', 'checked', 'disabled', 'input', 'thumb', 'track']);
var switchClasses$1 = switchClasses;

const _excluded$i = ["className", "color", "edge", "size", "sx"];
const useUtilityClasses$b = ownerState => {
  const {
    classes,
    edge,
    size,
    color,
    checked,
    disabled
  } = ownerState;
  const slots = {
    root: ['root', edge && `edge${capitalize(edge)}`, `size${capitalize(size)}`],
    switchBase: ['switchBase', `color${capitalize(color)}`, checked && 'checked', disabled && 'disabled'],
    thumb: ['thumb'],
    track: ['track'],
    input: ['input']
  };
  const composedClasses = composeClasses(slots, getSwitchUtilityClass, classes);
  return _extends$1({}, classes, composedClasses);
};
const SwitchRoot = styled$1('span', {
  name: 'MuiSwitch',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.edge && styles[`edge${capitalize(ownerState.edge)}`], styles[`size${capitalize(ownerState.size)}`]];
  }
})(({
  ownerState
}) => _extends$1({
  display: 'inline-flex',
  width: 34 + 12 * 2,
  height: 14 + 12 * 2,
  overflow: 'hidden',
  padding: 12,
  boxSizing: 'border-box',
  position: 'relative',
  flexShrink: 0,
  zIndex: 0,
  // Reset the stacking context.
  verticalAlign: 'middle',
  // For correct alignment with the text.
  '@media print': {
    colorAdjust: 'exact'
  }
}, ownerState.edge === 'start' && {
  marginLeft: -8
}, ownerState.edge === 'end' && {
  marginRight: -8
}, ownerState.size === 'small' && {
  width: 40,
  height: 24,
  padding: 7,
  [`& .${switchClasses$1.thumb}`]: {
    width: 16,
    height: 16
  },
  [`& .${switchClasses$1.switchBase}`]: {
    padding: 4,
    [`&.${switchClasses$1.checked}`]: {
      transform: 'translateX(16px)'
    }
  }
}));
const SwitchSwitchBase = styled$1(SwitchBase$1, {
  name: 'MuiSwitch',
  slot: 'SwitchBase',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.switchBase, {
      [`& .${switchClasses$1.input}`]: styles.input
    }, ownerState.color !== 'default' && styles[`color${capitalize(ownerState.color)}`]];
  }
})(({
  theme
}) => ({
  position: 'absolute',
  top: 0,
  left: 0,
  zIndex: 1,
  // Render above the focus ripple.
  color: theme.vars ? theme.vars.palette.Switch.defaultColor : `${theme.palette.mode === 'light' ? theme.palette.common.white : theme.palette.grey[300]}`,
  transition: theme.transitions.create(['left', 'transform'], {
    duration: theme.transitions.duration.shortest
  }),
  [`&.${switchClasses$1.checked}`]: {
    transform: 'translateX(20px)'
  },
  [`&.${switchClasses$1.disabled}`]: {
    color: theme.vars ? theme.vars.palette.Switch.defaultDisabledColor : `${theme.palette.mode === 'light' ? theme.palette.grey[100] : theme.palette.grey[600]}`
  },
  [`&.${switchClasses$1.checked} + .${switchClasses$1.track}`]: {
    opacity: 0.5
  },
  [`&.${switchClasses$1.disabled} + .${switchClasses$1.track}`]: {
    opacity: theme.vars ? theme.vars.opacity.switchTrackDisabled : `${theme.palette.mode === 'light' ? 0.12 : 0.2}`
  },
  [`& .${switchClasses$1.input}`]: {
    left: '-100%',
    width: '300%'
  }
}), ({
  theme,
  ownerState
}) => _extends$1({
  '&:hover': {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette.action.activeChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(theme.palette.action.active, theme.palette.action.hoverOpacity),
    // Reset on touch devices, it doesn't add specificity
    '@media (hover: none)': {
      backgroundColor: 'transparent'
    }
  }
}, ownerState.color !== 'default' && {
  [`&.${switchClasses$1.checked}`]: {
    color: (theme.vars || theme).palette[ownerState.color].main,
    '&:hover': {
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette[ownerState.color].mainChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity),
      '@media (hover: none)': {
        backgroundColor: 'transparent'
      }
    },
    [`&.${switchClasses$1.disabled}`]: {
      color: theme.vars ? theme.vars.palette.Switch[`${ownerState.color}DisabledColor`] : `${theme.palette.mode === 'light' ? lighten(theme.palette[ownerState.color].main, 0.62) : darken(theme.palette[ownerState.color].main, 0.55)}`
    }
  },
  [`&.${switchClasses$1.checked} + .${switchClasses$1.track}`]: {
    backgroundColor: (theme.vars || theme).palette[ownerState.color].main
  }
}));
const SwitchTrack = styled$1('span', {
  name: 'MuiSwitch',
  slot: 'Track',
  overridesResolver: (props, styles) => styles.track
})(({
  theme
}) => ({
  height: '100%',
  width: '100%',
  borderRadius: 14 / 2,
  zIndex: -1,
  transition: theme.transitions.create(['opacity', 'background-color'], {
    duration: theme.transitions.duration.shortest
  }),
  backgroundColor: theme.vars ? theme.vars.palette.common.onBackground : `${theme.palette.mode === 'light' ? theme.palette.common.black : theme.palette.common.white}`,
  opacity: theme.vars ? theme.vars.opacity.switchTrack : `${theme.palette.mode === 'light' ? 0.38 : 0.3}`
}));
const SwitchThumb = styled$1('span', {
  name: 'MuiSwitch',
  slot: 'Thumb',
  overridesResolver: (props, styles) => styles.thumb
})(({
  theme
}) => ({
  boxShadow: (theme.vars || theme).shadows[1],
  backgroundColor: 'currentColor',
  width: 20,
  height: 20,
  borderRadius: '50%'
}));
const Switch = /*#__PURE__*/React__namespace.forwardRef(function Switch(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiSwitch'
  });
  const {
      className,
      color = 'primary',
      edge = false,
      size = 'medium',
      sx
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$i);
  const ownerState = _extends$1({}, props, {
    color,
    edge,
    size
  });
  const classes = useUtilityClasses$b(ownerState);
  const icon = /*#__PURE__*/jsxRuntimeExports.jsx(SwitchThumb, {
    className: classes.thumb,
    ownerState: ownerState
  });
  return /*#__PURE__*/jsxRuntimeExports.jsxs(SwitchRoot, {
    className: clsx(classes.root, className),
    sx: sx,
    ownerState: ownerState,
    children: [/*#__PURE__*/jsxRuntimeExports.jsx(SwitchSwitchBase, _extends$1({
      type: "checkbox",
      icon: icon,
      checkedIcon: icon,
      ref: ref,
      ownerState: ownerState
    }, other, {
      classes: _extends$1({}, classes, {
        root: classes.switchBase
      })
    })), /*#__PURE__*/jsxRuntimeExports.jsx(SwitchTrack, {
      className: classes.track,
      ownerState: ownerState
    })]
  });
});
browser$1.env.NODE_ENV !== "production" ? Switch.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, the component is checked.
   */
  checked: propTypesExports.bool,
  /**
   * The icon to display when the component is checked.
   */
  checkedIcon: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'primary'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['default', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * The default checked state. Use when the component is not controlled.
   */
  defaultChecked: propTypesExports.bool,
  /**
   * If `true`, the component is disabled.
   */
  disabled: propTypesExports.bool,
  /**
   * If `true`, the ripple effect is disabled.
   * @default false
   */
  disableRipple: propTypesExports.bool,
  /**
   * If given, uses a negative margin to counteract the padding on one
   * side (this is often helpful for aligning the left or right
   * side of the icon with content above or below, without ruining the border
   * size and shape).
   * @default false
   */
  edge: propTypesExports.oneOf(['end', 'start', false]),
  /**
   * The icon to display when the component is unchecked.
   */
  icon: propTypesExports.node,
  /**
   * The id of the `input` element.
   */
  id: propTypesExports.string,
  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   */
  inputProps: propTypesExports.object,
  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType$1,
  /**
   * Callback fired when the state is changed.
   *
   * @param {React.ChangeEvent<HTMLInputElement>} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   * You can pull out the new checked state by accessing `event.target.checked` (boolean).
   */
  onChange: propTypesExports.func,
  /**
   * If `true`, the `input` element is required.
   * @default false
   */
  required: propTypesExports.bool,
  /**
   * The size of the component.
   * `small` is equivalent to the dense switch styling.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The value of the component. The DOM API casts this to a string.
   * The browser uses "on" as the default value.
   */
  value: propTypesExports.any
} : void 0;
var Switch$1 = Switch;

function SwitchInput(_ref) {
  var label = _ref.label,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    _onChange = _ref.onChange,
    _ref$labelPlacement = _ref.labelPlacement,
    labelPlacement = _ref$labelPlacement === void 0 ? MUI_LABEL_PLACEMENT.START : _ref$labelPlacement;
  return /*#__PURE__*/React__namespace.default.createElement(FormGroup$1, null, /*#__PURE__*/React__namespace.default.createElement(FormControlLabel$1, {
    control: /*#__PURE__*/React__namespace.default.createElement(Switch$1, {
      "data-testid": TEST_IDS.SWITCH
    }),
    label: label,
    checked: value,
    onChange: function onChange(event) {
      return _onChange(event.target.checked);
    },
    labelPlacement: labelPlacement
  }), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    validationMessage: validationMessage
  }));
}
SwitchInput.propTypes = {
  label: propTypesExports.string,
  value: propTypesExports.bool,
  validationMessage: propTypesExports.string,
  onChange: propTypesExports.func,
  labelPlacement: propTypesExports.string
};

function FormBuilderRequiredSwitch(_ref) {
  var fieldIndex = _ref.fieldIndex;
  return /*#__PURE__*/React__namespace.default.createElement(Container$k, null, /*#__PURE__*/React__namespace.default.createElement(ControlledInput, {
    path: getInputPath({
      fieldIndex: fieldIndex,
      property: "is_required"
    }),
    Component: SwitchInput,
    contextHook: useFormBuilder,
    label: "Required"
  }));
}
FormBuilderRequiredSwitch.propTypes = {
  fieldIndex: propTypesExports.number.isRequired
};
var Container$k = styled__default.default(Box$1)({
  display: "flex",
  justifyContent: "flex-end",
  width: "100%",
  paddingRight: "10px"
});

function TitleInput(_ref) {
  var id = _ref.id,
    label = _ref.label,
    path = _ref.path,
    contextHook = _ref.contextHook;
  var theme = useTheme$1();
  var styles = getStyles$4(theme);
  var props = getInputProps({
    id: id,
    label: label,
    styles: styles
  });
  return /*#__PURE__*/React__namespace.default.createElement(TitleRowContainer, null, /*#__PURE__*/React__namespace.default.createElement(ControlledInput, _extends$2({
    path: path,
    Component: FormTextInput,
    contextHook: contextHook
  }, props)));
}
TitleInput.propTypes = {
  id: propTypesExports.string,
  label: propTypesExports.string,
  path: propTypesExports.string,
  contextHook: propTypesExports.func
};
function getInputProps(_ref2) {
  var id = _ref2.id,
    label = _ref2.label,
    styles = _ref2.styles;
  return {
    id: id,
    variant: CONTENT_BLOCK_INPUT_VARIANT,
    label: label,
    sx: styles.titleInput
  };
}
function getStyles$4(_ref3) {
  var palette = _ref3.palette;
  return {
    titleInput: {
      "& .MuiInput-input": {
        backgroundColor: palette.colors.contentBlockInput.background,
        padding: "10px"
      },
      width: "100%"
    }
  };
}
var TitleRowContainer = styled__default.default(Box$1)({
  display: "flex",
  flex: 1,
  flexDirection: "row",
  flexWrap: "wrap",
  paddingBottom: "10px"
});

function FormBuilderTitleInput(_ref) {
  var fieldIndex = _ref.fieldIndex,
    _ref$label = _ref.label,
    label = _ref$label === void 0 ? "Title" : _ref$label;
  return /*#__PURE__*/React__namespace.default.createElement(TitleInput, {
    path: getInputPath({
      fieldIndex: fieldIndex,
      property: "title"
    }),
    label: label,
    contextHook: useFormBuilder
  });
}
FormBuilderTitleInput.propTypes = {
  fieldIndex: propTypesExports.number,
  label: propTypesExports.string
};

function FormBuilderFormField(_ref) {
  var fieldIndex = _ref.fieldIndex,
    dragHandleProps = _ref.dragHandleProps;
  var _useFormBuilder = useFormBuilder(),
    removeField = _useFormBuilder.removeField;
  var sectionActionConfigs = getActionConfigs({
    fieldIndex: fieldIndex,
    removeField: removeField
  });
  return /*#__PURE__*/React__namespace.default.createElement(Container$j, null, /*#__PURE__*/React__namespace.default.createElement(DraggableSectionHeader, {
    dragHandleProps: dragHandleProps,
    actions: sectionActionConfigs
  }), /*#__PURE__*/React__namespace.default.createElement(ContentContainer, null, /*#__PURE__*/React__namespace.default.createElement(TitleAndPreviewContainer, null, /*#__PURE__*/React__namespace.default.createElement(FormBuilderTitleInput, {
    fieldIndex: fieldIndex,
    label: "Question"
  }), /*#__PURE__*/React__namespace.default.createElement(FormBuilderFieldPreviewAndOptions, {
    fieldIndex: fieldIndex
  })), /*#__PURE__*/React__namespace.default.createElement(FormBuilderFieldTypeSelector, {
    fieldIndex: fieldIndex
  }), /*#__PURE__*/React__namespace.default.createElement(RemoveButton, {
    onClick: function onClick() {
      return removeField(fieldIndex);
    }
  })), /*#__PURE__*/React__namespace.default.createElement(FormBuilderRequiredSwitch, {
    fieldIndex: fieldIndex
  }));
}
FormBuilderFormField.propTypes = {
  fieldIndex: propTypesExports.number,
  dragHandleProps: propTypesExports.object
};
var Container$j = styled__default.default(ContentBlockEditContainer)({
  flex: 1,
  padding: "15px 25px"
});
var ContentContainer = styled__default.default(BlockRow)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    backgroundColor: theme.palette.card.background,
    alignItems: "center"
  };
});
var TitleAndPreviewContainer = styled__default.default(Box$1)(function (_ref3) {
  var theme = _ref3.theme;
  return _defineProperty({
    flex: 8,
    marginRight: "40px"
  }, theme.breakpoints.down("md"), {
    marginRight: "0"
  });
});
function getActionConfigs(_ref5) {
  var removeField = _ref5.removeField,
    fieldIndex = _ref5.fieldIndex;
  return [{
    name: "Delete Question",
    onClick: function onClick() {
      return removeField(fieldIndex);
    }
  }];
}

function FormBuilderFormFields() {
  var _useFormBuilder = useFormBuilder(),
    fields = _useFormBuilder.fields,
    appendField = _useFormBuilder.appendField,
    moveField = _useFormBuilder.moveField;
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(DragAndDropContainer, {
    items: fields,
    moveItem: moveField,
    ItemComponent: FormBuilderFormField,
    getItemProps: getFieldProps,
    shouldUseCustomDragHandle: true,
    droppableId: FIELDS_DROPPABLE_ID
  }), /*#__PURE__*/React__namespace.default.createElement(ButtonContainer$2, null, /*#__PURE__*/React__namespace.default.createElement(IconTextButton, {
    "data-testid": TEST_IDS.ADD_FIELD_BUTTON,
    onClick: function onClick() {
      return appendField();
    },
    label: "Add question",
    Icon: default_1$m
  })));
}
function getFieldProps(_ref) {
  var itemIndex = _ref.itemIndex,
    dragHandleProps = _ref.dragHandleProps;
  return {
    fieldIndex: itemIndex,
    dragHandleProps: dragHandleProps
  };
}
var ButtonContainer$2 = styled__default.default(Box$1)({
  display: "flex",
  justifyContent: "center",
  marginTop: "20px"
});

function FormBuilderQuestions() {
  return /*#__PURE__*/React__namespace.default.createElement(Container$i, null, /*#__PURE__*/React__namespace.default.createElement(FormTitleContainer, null, /*#__PURE__*/React__namespace.default.createElement(FormBuilderTitleInput, null)), /*#__PURE__*/React__namespace.default.createElement(FormBuilderFormFields, null));
}
var FormTitleContainer = styled__default.default(ContentBlockEditContainer)({
  padding: "15px 25px"
});
var Container$i = styled__default.default(Box$1)(function (_ref) {
  var theme = _ref.theme;
  return {
    padding: "2px 20px 20px 20px",
    marginTop: "10px",
    borderRadius: theme.borderRadius.lg,
    backgroundColor: theme.palette.background["default"],
    flex: 1,
    overflow: "auto"
  };
});

function FormBuilderSetting(_ref) {
  var title = _ref.title,
    description = _ref.description,
    value = _ref.value,
    onChange = _ref.onChange;
  return /*#__PURE__*/React__namespace.default.createElement(Container$h, null, /*#__PURE__*/React__namespace.default.createElement(TextContainer$1, null, /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "h6"
  }, title), /*#__PURE__*/React__namespace.default.createElement(Description$1, null, description)), /*#__PURE__*/React__namespace.default.createElement(SwitchInput, {
    value: value,
    onChange: onChange
  }));
}
FormBuilderSetting.propTypes = {
  title: propTypesExports.string,
  description: propTypesExports.string,
  value: propTypesExports.bool,
  onChange: propTypesExports.func.isRequired
};
var Container$h = styled__default.default(Box$1)({
  display: "flex",
  alignItems: "center",
  padding: "10px 0"
});
var TextContainer$1 = styled__default.default(Box$1)({
  flex: 1
});
var Description$1 = styled__default.default(Typography$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    color: theme.palette.text.secondary
  };
});

var FORM_BUILDER_SETTINGS_KEYS = {
  MAX_SUBMISSION_COUNT: "max_submission_count",
  ARE_SUBMISSIONS_PUBLIC: "are_submissions_public"
};
function FormBuilderSettings() {
  return /*#__PURE__*/React__namespace.default.createElement(Container$g, null, getSettingsConfigs().map(function (_ref) {
    var path = _ref.path,
      title = _ref.title,
      description = _ref.description;
    return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, {
      key: path,
      path: path,
      Component: FormBuilderSetting,
      contextHook: useFormBuilder,
      title: title,
      description: description
    });
  }));
}
var Container$g = styled__default.default(Box$1)({
  padding: "2px 20px 20px 20px",
  marginTop: "20px",
  flex: 1
});
function getSettingsConfigs() {
  return [{
    path: FORM_BUILDER_SETTINGS_KEYS.MAX_SUBMISSION_COUNT,
    title: "Limit to 1 submission",
    description: "Respondents will only be able to submit one response to this form"
  }, {
    path: FORM_BUILDER_SETTINGS_KEYS.ARE_SUBMISSIONS_PUBLIC,
    title: "Allow respondents to view all submissions",
    description: "Respondents will be able to view all form submissions in addition to their own"
  }];
}

function FormBuilderTabsHeader() {
  return /*#__PURE__*/React__namespace.default.createElement(Container$f, null, /*#__PURE__*/React__namespace.default.createElement(StyledTabsHeader, null));
}
var Container$f = styled__default.default(Box$1)(function (_ref) {
  var theme = _ref.theme;
  return _defineProperty({
    flexShrink: 0,
    marginTop: "-15px"
  }, theme.breakpoints.down("sm"), {
    marginTop: "-25px"
  });
});
var StyledTabsHeader = styled__default.default(TabsHeader)({
  flex: 0,
  flexShrink: 0
});

function FormBuilderForm(_ref) {
  var onCompleted = _ref.onCompleted,
    onBackClick = _ref.onBackClick;
  var _useForms = useForms(),
    useCreateForm = _useForms.useCreateForm,
    useUpdateForm = _useForms.useUpdateForm,
    companyId = _useForms.companyId;
  var _useTabs = useTabs(),
    currentTab = _useTabs.currentTab;
  var _useFormBuilder = useFormBuilder(),
    isFormSubmitting = _useFormBuilder.isSubmitting,
    handleSubmit = _useFormBuilder.handleSubmit,
    formBeingEdited = _useFormBuilder.formBeingEdited,
    isEditing = _useFormBuilder.isEditing;
  var _useCreateForm = useCreateForm({
      companyId: companyId,
      onCompleted: onCompleted
    }),
    createForm = _useCreateForm.createForm,
    isLoadingCreate = _useCreateForm.isLoading;
  var _useUpdateForm = useUpdateForm({
      onCompleted: onCompleted
    }),
    updateForm = _useUpdateForm.updateForm,
    isLoadingUpdate = _useUpdateForm.isLoading;
  var isLoading = isLoadingCreate || isLoadingUpdate;
  return /*#__PURE__*/React__namespace.default.createElement(Container$e, null, /*#__PURE__*/React__namespace.default.createElement(FormBuilderTabsHeader, null), /*#__PURE__*/React__namespace.default.createElement(FormBuilderEditWarning, {
    show: isEditing
  }), renderCurrentTab(currentTab), /*#__PURE__*/React__namespace.default.createElement(CancelAndSaveButtons, {
    cancelButtonLabel: "Back",
    onSaveClick: handleSubmit(function (values) {
      return handleFormSubmission({
        values: values,
        createForm: createForm,
        updateForm: updateForm,
        formBeingEdited: formBeingEdited
      });
    }),
    onCancelClick: onBackClick,
    isLoading: isLoading || isFormSubmitting,
    showCancelButton: !isEditing
  }));
}
var Container$e = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return _defineProperty({
    display: "flex",
    flexDirection: "column",
    height: "calc(100vh - ".concat(FORM_BUILDER_MODAL_HEIGHT_OFFSET, ")"),
    padding: "0 20px"
  }, theme.breakpoints.down("sm"), {
    padding: "0",
    height: "calc(100vh - 65px)"
  });
});
FormBuilderForm.propTypes = {
  onCompleted: propTypesExports.func.isRequired,
  onBackClick: propTypesExports.func.isRequired
};

// Adds all fields to a section before calling onSubmit. This will change
// when we start supporting form sections on the frontend.
function handleFormSubmission(_ref4) {
  var _formBeingEdited$sect, _formBeingEdited$sect2;
  var values = _ref4.values,
    createForm = _ref4.createForm,
    updateForm = _ref4.updateForm,
    formBeingEdited = _ref4.formBeingEdited;
  var sectionId = (formBeingEdited === null || formBeingEdited === void 0 ? void 0 : (_formBeingEdited$sect = formBeingEdited.sections) === null || _formBeingEdited$sect === void 0 ? void 0 : (_formBeingEdited$sect2 = _formBeingEdited$sect[0]) === null || _formBeingEdited$sect2 === void 0 ? void 0 : _formBeingEdited$sect2.id) || uuid.v4();
  // This is converted to a boolean for the toggle switch input in the form.
  // Needs to be converted back to null or 1 before sending to the api.
  var maxSubmissionCount = values.max_submission_count ? 1 : null;
  var formattedFields = formatFormFieldsForApi(values.fields);
  var formattedValues = _objectSpread2(_objectSpread2({}, libCommon.omit(values, ["fields", "id"])), {}, {
    sections: [{
      id: sectionId,
      title: "",
      fields: formattedFields
    }],
    max_submission_count: maxSubmissionCount
  });
  if (formBeingEdited !== null && formBeingEdited !== void 0 && formBeingEdited.id) {
    updateForm({
      id: formBeingEdited.id,
      update: formattedValues
    });
    return;
  }
  createForm({
    form: formattedValues
  });
}
function renderCurrentTab(currentTab) {
  switch (currentTab) {
    case FORM_BUILDER_TAB_NAMES.SETTINGS:
      return /*#__PURE__*/React__namespace.default.createElement(FormBuilderSettings, null);
    case FORM_BUILDER_TAB_NAMES.QUESTIONS:
    default:
      return /*#__PURE__*/React__namespace.default.createElement(FormBuilderQuestions, null);
  }
}

function FormBuilder(_ref) {
  var form = _ref.form,
    onCompleted = _ref.onCompleted,
    onBackClick = _ref.onBackClick;
  var tabs = Object.values(FORM_BUILDER_TAB_NAMES);
  return /*#__PURE__*/React__namespace.default.createElement(FormBuilderProvider, {
    form: form
  }, /*#__PURE__*/React__namespace.default.createElement(TabsProvider, {
    prefix: TAB_PREFIXES.FORM_BUILDER,
    tabs: tabs,
    narrowTabs: true
  }, /*#__PURE__*/React__namespace.default.createElement(FormBuilderForm, {
    onCompleted: onCompleted,
    onBackClick: onBackClick
  })));
}
FormBuilder.propTypes = {
  form: propTypesExports.object,
  onCompleted: propTypesExports.func.isRequired,
  onBackClick: propTypesExports.func.isRequired
};

/**
 * @ignore - internal component.
 */
const TableContext$1 = /*#__PURE__*/React__namespace.createContext();
if (browser$1.env.NODE_ENV !== 'production') {
  TableContext$1.displayName = 'TableContext';
}
var TableContext$2 = TableContext$1;

function getTableUtilityClass(slot) {
  return generateUtilityClass('MuiTable', slot);
}
generateUtilityClasses('MuiTable', ['root', 'stickyHeader']);

const _excluded$h = ["className", "component", "padding", "size", "stickyHeader"];
const useUtilityClasses$a = ownerState => {
  const {
    classes,
    stickyHeader
  } = ownerState;
  const slots = {
    root: ['root', stickyHeader && 'stickyHeader']
  };
  return composeClasses(slots, getTableUtilityClass, classes);
};
const TableRoot = styled$1('table', {
  name: 'MuiTable',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.stickyHeader && styles.stickyHeader];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  display: 'table',
  width: '100%',
  borderCollapse: 'collapse',
  borderSpacing: 0,
  '& caption': _extends$1({}, theme.typography.body2, {
    padding: theme.spacing(2),
    color: (theme.vars || theme).palette.text.secondary,
    textAlign: 'left',
    captionSide: 'bottom'
  })
}, ownerState.stickyHeader && {
  borderCollapse: 'separate'
}));
const defaultComponent$3 = 'table';
const Table$1 = /*#__PURE__*/React__namespace.forwardRef(function Table(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTable'
  });
  const {
      className,
      component = defaultComponent$3,
      padding = 'normal',
      size = 'medium',
      stickyHeader = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$h);
  const ownerState = _extends$1({}, props, {
    component,
    padding,
    size,
    stickyHeader
  });
  const classes = useUtilityClasses$a(ownerState);
  const table = React__namespace.useMemo(() => ({
    padding,
    size,
    stickyHeader
  }), [padding, size, stickyHeader]);
  return /*#__PURE__*/jsxRuntimeExports.jsx(TableContext$2.Provider, {
    value: table,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(TableRoot, _extends$1({
      as: component,
      role: component === defaultComponent$3 ? null : 'table',
      ref: ref,
      className: clsx(classes.root, className),
      ownerState: ownerState
    }, other))
  });
});
browser$1.env.NODE_ENV !== "production" ? Table$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the table, normally `TableHead` and `TableBody`.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * Allows TableCells to inherit padding of the Table.
   * @default 'normal'
   */
  padding: propTypesExports.oneOf(['checkbox', 'none', 'normal']),
  /**
   * Allows TableCells to inherit size of the Table.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * Set the header sticky.
   *
   * ⚠️ It doesn't work with IE11.
   * @default false
   */
  stickyHeader: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TableOG = Table$1;

function getTableContainerUtilityClass(slot) {
  return generateUtilityClass('MuiTableContainer', slot);
}
generateUtilityClasses('MuiTableContainer', ['root']);

const _excluded$g = ["className", "component"];
const useUtilityClasses$9 = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root']
  };
  return composeClasses(slots, getTableContainerUtilityClass, classes);
};
const TableContainerRoot = styled$1('div', {
  name: 'MuiTableContainer',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({
  width: '100%',
  overflowX: 'auto'
});
const TableContainer$2 = /*#__PURE__*/React__namespace.forwardRef(function TableContainer(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTableContainer'
  });
  const {
      className,
      component = 'div'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$g);
  const ownerState = _extends$1({}, props, {
    component
  });
  const classes = useUtilityClasses$9(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(TableContainerRoot, _extends$1({
    ref: ref,
    as: component,
    className: clsx(classes.root, className),
    ownerState: ownerState
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? TableContainer$2.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component, normally `Table`.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TableContainerOG = TableContainer$2;

/**
 * @ignore - internal component.
 */
const Tablelvl2Context = /*#__PURE__*/React__namespace.createContext();
if (browser$1.env.NODE_ENV !== 'production') {
  Tablelvl2Context.displayName = 'Tablelvl2Context';
}
var Tablelvl2Context$1 = Tablelvl2Context;

function getTableBodyUtilityClass(slot) {
  return generateUtilityClass('MuiTableBody', slot);
}
generateUtilityClasses('MuiTableBody', ['root']);

const _excluded$f = ["className", "component"];
const useUtilityClasses$8 = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root']
  };
  return composeClasses(slots, getTableBodyUtilityClass, classes);
};
const TableBodyRoot = styled$1('tbody', {
  name: 'MuiTableBody',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({
  display: 'table-row-group'
});
const tablelvl2$1 = {
  variant: 'body'
};
const defaultComponent$2 = 'tbody';
const TableBody$1 = /*#__PURE__*/React__namespace.forwardRef(function TableBody(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTableBody'
  });
  const {
      className,
      component = defaultComponent$2
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$f);
  const ownerState = _extends$1({}, props, {
    component
  });
  const classes = useUtilityClasses$8(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(Tablelvl2Context$1.Provider, {
    value: tablelvl2$1,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(TableBodyRoot, _extends$1({
      className: clsx(classes.root, className),
      as: component,
      ref: ref,
      role: component === defaultComponent$2 ? null : 'rowgroup',
      ownerState: ownerState
    }, other))
  });
});
browser$1.env.NODE_ENV !== "production" ? TableBody$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component, normally `TableRow`.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TableBodyOG = TableBody$1;

function getTableCellUtilityClass(slot) {
  return generateUtilityClass('MuiTableCell', slot);
}
const tableCellClasses = generateUtilityClasses('MuiTableCell', ['root', 'head', 'body', 'footer', 'sizeSmall', 'sizeMedium', 'paddingCheckbox', 'paddingNone', 'alignLeft', 'alignCenter', 'alignRight', 'alignJustify', 'stickyHeader']);
var tableCellClasses$1 = tableCellClasses;

const _excluded$e = ["align", "className", "component", "padding", "scope", "size", "sortDirection", "variant"];
const useUtilityClasses$7 = ownerState => {
  const {
    classes,
    variant,
    align,
    padding,
    size,
    stickyHeader
  } = ownerState;
  const slots = {
    root: ['root', variant, stickyHeader && 'stickyHeader', align !== 'inherit' && `align${capitalize(align)}`, padding !== 'normal' && `padding${capitalize(padding)}`, `size${capitalize(size)}`]
  };
  return composeClasses(slots, getTableCellUtilityClass, classes);
};
const TableCellRoot = styled$1('td', {
  name: 'MuiTableCell',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, styles[ownerState.variant], styles[`size${capitalize(ownerState.size)}`], ownerState.padding !== 'normal' && styles[`padding${capitalize(ownerState.padding)}`], ownerState.align !== 'inherit' && styles[`align${capitalize(ownerState.align)}`], ownerState.stickyHeader && styles.stickyHeader];
  }
})(({
  theme,
  ownerState
}) => _extends$1({}, theme.typography.body2, {
  display: 'table-cell',
  verticalAlign: 'inherit',
  // Workaround for a rendering bug with spanned columns in Chrome 62.0.
  // Removes the alpha (sets it to 1), and lightens or darkens the theme color.
  borderBottom: theme.vars ? `1px solid ${theme.vars.palette.TableCell.border}` : `1px solid
    ${theme.palette.mode === 'light' ? lighten(alpha(theme.palette.divider, 1), 0.88) : darken(alpha(theme.palette.divider, 1), 0.68)}`,
  textAlign: 'left',
  padding: 16
}, ownerState.variant === 'head' && {
  color: (theme.vars || theme).palette.text.primary,
  lineHeight: theme.typography.pxToRem(24),
  fontWeight: theme.typography.fontWeightMedium
}, ownerState.variant === 'body' && {
  color: (theme.vars || theme).palette.text.primary
}, ownerState.variant === 'footer' && {
  color: (theme.vars || theme).palette.text.secondary,
  lineHeight: theme.typography.pxToRem(21),
  fontSize: theme.typography.pxToRem(12)
}, ownerState.size === 'small' && {
  padding: '6px 16px',
  [`&.${tableCellClasses$1.paddingCheckbox}`]: {
    width: 24,
    // prevent the checkbox column from growing
    padding: '0 12px 0 16px',
    '& > *': {
      padding: 0
    }
  }
}, ownerState.padding === 'checkbox' && {
  width: 48,
  // prevent the checkbox column from growing
  padding: '0 0 0 4px'
}, ownerState.padding === 'none' && {
  padding: 0
}, ownerState.align === 'left' && {
  textAlign: 'left'
}, ownerState.align === 'center' && {
  textAlign: 'center'
}, ownerState.align === 'right' && {
  textAlign: 'right',
  flexDirection: 'row-reverse'
}, ownerState.align === 'justify' && {
  textAlign: 'justify'
}, ownerState.stickyHeader && {
  position: 'sticky',
  top: 0,
  zIndex: 2,
  backgroundColor: (theme.vars || theme).palette.background.default
}));

/**
 * The component renders a `<th>` element when the parent context is a header
 * or otherwise a `<td>` element.
 */
const TableCell$1 = /*#__PURE__*/React__namespace.forwardRef(function TableCell(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTableCell'
  });
  const {
      align = 'inherit',
      className,
      component: componentProp,
      padding: paddingProp,
      scope: scopeProp,
      size: sizeProp,
      sortDirection,
      variant: variantProp
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$e);
  const table = React__namespace.useContext(TableContext$2);
  const tablelvl2 = React__namespace.useContext(Tablelvl2Context$1);
  const isHeadCell = tablelvl2 && tablelvl2.variant === 'head';
  let component;
  if (componentProp) {
    component = componentProp;
  } else {
    component = isHeadCell ? 'th' : 'td';
  }
  let scope = scopeProp;
  // scope is not a valid attribute for <td/> elements.
  // source: https://html.spec.whatwg.org/multipage/tables.html#the-td-element
  if (component === 'td') {
    scope = undefined;
  } else if (!scope && isHeadCell) {
    scope = 'col';
  }
  const variant = variantProp || tablelvl2 && tablelvl2.variant;
  const ownerState = _extends$1({}, props, {
    align,
    component,
    padding: paddingProp || (table && table.padding ? table.padding : 'normal'),
    size: sizeProp || (table && table.size ? table.size : 'medium'),
    sortDirection,
    stickyHeader: variant === 'head' && table && table.stickyHeader,
    variant
  });
  const classes = useUtilityClasses$7(ownerState);
  let ariaSort = null;
  if (sortDirection) {
    ariaSort = sortDirection === 'asc' ? 'ascending' : 'descending';
  }
  return /*#__PURE__*/jsxRuntimeExports.jsx(TableCellRoot, _extends$1({
    as: component,
    ref: ref,
    className: clsx(classes.root, className),
    "aria-sort": ariaSort,
    scope: scope,
    ownerState: ownerState
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? TableCell$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Set the text-align on the table cell content.
   *
   * Monetary or generally number fields **should be right aligned** as that allows
   * you to add them up quickly in your head without having to worry about decimals.
   * @default 'inherit'
   */
  align: propTypesExports.oneOf(['center', 'inherit', 'justify', 'left', 'right']),
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * Sets the padding applied to the cell.
   * The prop defaults to the value (`'default'`) inherited from the parent Table component.
   */
  padding: propTypesExports.oneOf(['checkbox', 'none', 'normal']),
  /**
   * Set scope attribute.
   */
  scope: propTypesExports.string,
  /**
   * Specify the size of the cell.
   * The prop defaults to the value (`'medium'`) inherited from the parent Table component.
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * Set aria-sort direction.
   */
  sortDirection: propTypesExports.oneOf(['asc', 'desc', false]),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * Specify the cell type.
   * The prop defaults to the value inherited from the parent TableHead, TableBody, or TableFooter components.
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['body', 'footer', 'head']), propTypesExports.string])
} : void 0;
var TableCell$2 = TableCell$1;

function getTableRowUtilityClass(slot) {
  return generateUtilityClass('MuiTableRow', slot);
}
const tableRowClasses = generateUtilityClasses('MuiTableRow', ['root', 'selected', 'hover', 'head', 'footer']);
var tableRowClasses$1 = tableRowClasses;

const _excluded$d = ["className", "component", "hover", "selected"];
const useUtilityClasses$6 = ownerState => {
  const {
    classes,
    selected,
    hover,
    head,
    footer
  } = ownerState;
  const slots = {
    root: ['root', selected && 'selected', hover && 'hover', head && 'head', footer && 'footer']
  };
  return composeClasses(slots, getTableRowUtilityClass, classes);
};
const TableRowRoot = styled$1('tr', {
  name: 'MuiTableRow',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.head && styles.head, ownerState.footer && styles.footer];
  }
})(({
  theme
}) => ({
  color: 'inherit',
  display: 'table-row',
  verticalAlign: 'middle',
  // We disable the focus ring for mouse, touch and keyboard users.
  outline: 0,
  [`&.${tableRowClasses$1.hover}:hover`]: {
    backgroundColor: (theme.vars || theme).palette.action.hover
  },
  [`&.${tableRowClasses$1.selected}`]: {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette.primary.mainChannel} / ${theme.vars.palette.action.selectedOpacity})` : alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity),
    '&:hover': {
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette.primary.mainChannel} / calc(${theme.vars.palette.action.selectedOpacity} + ${theme.vars.palette.action.hoverOpacity}))` : alpha(theme.palette.primary.main, theme.palette.action.selectedOpacity + theme.palette.action.hoverOpacity)
    }
  }
}));
const defaultComponent$1 = 'tr';
/**
 * Will automatically set dynamic row height
 * based on the material table element parent (head, body, etc).
 */
const TableRow$1 = /*#__PURE__*/React__namespace.forwardRef(function TableRow(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTableRow'
  });
  const {
      className,
      component = defaultComponent$1,
      hover = false,
      selected = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$d);
  const tablelvl2 = React__namespace.useContext(Tablelvl2Context$1);
  const ownerState = _extends$1({}, props, {
    component,
    hover,
    selected,
    head: tablelvl2 && tablelvl2.variant === 'head',
    footer: tablelvl2 && tablelvl2.variant === 'footer'
  });
  const classes = useUtilityClasses$6(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(TableRowRoot, _extends$1({
    as: component,
    ref: ref,
    className: clsx(classes.root, className),
    role: component === defaultComponent$1 ? null : 'row',
    ownerState: ownerState
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? TableRow$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * Should be valid <tr> children such as `TableCell`.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, the table row will shade on hover.
   * @default false
   */
  hover: propTypesExports.bool,
  /**
   * If `true`, the table row will have the selected shading.
   * @default false
   */
  selected: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TableRow$2 = TableRow$1;

var TableContext = /*#__PURE__*/React.createContext();
function TableProvider(_ref) {
  var initSortOrder = _ref.initSortOrder,
    initSortBy = _ref.initSortBy,
    initPage = _ref.initPage,
    initRowsPerPage = _ref.initRowsPerPage,
    initSearchKeyword = _ref.initSearchKeyword,
    rows = _ref.rows,
    actions = _ref.actions,
    total = _ref.total,
    keyBy = _ref.keyBy,
    allowBulkActions = _ref.allowBulkActions,
    bulkActionButtonConfigs = _ref.bulkActionButtonConfigs,
    onTableArgsChange = _ref.onTableArgsChange,
    children = _ref.children;
  var tableState = useTableState({
    initSortOrder: initSortOrder,
    initSortBy: initSortBy,
    initPage: initPage,
    initSearchKeyword: initSearchKeyword,
    initRowsPerPage: initRowsPerPage
  });
  return /*#__PURE__*/React__namespace.default.createElement(TableContext.Provider, {
    value: _objectSpread2({
      rows: rows,
      actions: actions,
      total: total,
      keyBy: keyBy,
      allowBulkActions: allowBulkActions,
      bulkActionButtonConfigs: bulkActionButtonConfigs,
      onTableArgsChange: onTableArgsChange
    }, tableState)
  }, children);
}
function useBulkTableActions() {
  var _useContext = React.useContext(TableContext),
    rows = _useContext.rows,
    keyBy = _useContext.keyBy,
    allowBulkActions = _useContext.allowBulkActions,
    bulkActionButtonConfigs = _useContext.bulkActionButtonConfigs,
    setSelectedRows = _useContext.setSelectedRows,
    selectedRows = _useContext.selectedRows,
    selectedBulkAction = _useContext.selectedBulkAction,
    setSelectedBulkAction = _useContext.setSelectedBulkAction;
  var onSelectedRowChange = function onSelectedRowChange(_ref2) {
    var isSelected = _ref2.isSelected,
      row = _ref2.row;
    return handleSelectedRowChange({
      isSelected: isSelected,
      row: row,
      setSelectedRows: setSelectedRows,
      keyBy: keyBy
    });
  };
  var onSelectAllChange = function onSelectAllChange(isSelected) {
    return setSelectedRows(isSelected ? rows : []);
  };
  var clearSelectedRows = function clearSelectedRows() {
    return setSelectedRows([]);
  };
  var checkIfRowIsSelected = function checkIfRowIsSelected(row) {
    return isRowSelected({
      row: row,
      selectedRows: selectedRows,
      keyBy: keyBy
    });
  };
  var hasSelectedRows = (selectedRows === null || selectedRows === void 0 ? void 0 : selectedRows.length) > 0;
  var isSelectAllSelected = selectedRows.length === (rows === null || rows === void 0 ? void 0 : rows.length);
  return {
    allowBulkActions: allowBulkActions,
    bulkActionButtonConfigs: bulkActionButtonConfigs,
    onSelectedRowChange: onSelectedRowChange,
    onSelectAllChange: onSelectAllChange,
    selectedRows: selectedRows,
    clearSelectedRows: clearSelectedRows,
    selectedBulkAction: selectedBulkAction,
    setSelectedBulkAction: setSelectedBulkAction,
    hasSelectedRows: hasSelectedRows,
    isSelectAllSelected: isSelectAllSelected,
    checkIfRowIsSelected: checkIfRowIsSelected
  };
}
function useTable() {
  var _useContext2 = React.useContext(TableContext),
    orderByDir = _useContext2.orderByDir,
    setOrder = _useContext2.setOrder,
    orderBy = _useContext2.orderBy,
    setOrderBy = _useContext2.setOrderBy,
    page = _useContext2.page,
    setPage = _useContext2.setPage,
    rowsPerPage = _useContext2.rowsPerPage,
    setRowsPerPage = _useContext2.setRowsPerPage,
    searchKeyword = _useContext2.searchKeyword,
    setSearchKeyword = _useContext2.setSearchKeyword,
    rows = _useContext2.rows,
    actions = _useContext2.actions,
    total = _useContext2.total,
    onTableArgsChange = _useContext2.onTableArgsChange;
  var sortedBy = {
    by: orderBy,
    order: orderByDir
  };
  var hasActions = !!(actions !== null && actions !== void 0 && actions.length);
  return {
    orderByDir: orderByDir,
    setOrder: setOrder,
    orderBy: orderBy,
    setOrderBy: setOrderBy,
    page: page,
    setPage: setPage,
    rowsPerPage: rowsPerPage,
    setRowsPerPage: setRowsPerPage,
    searchKeyword: searchKeyword,
    setSearchKeyword: setSearchKeyword,
    sortedBy: sortedBy,
    rows: rows,
    actions: actions,
    hasActions: hasActions,
    total: total,
    onTableArgsChange: onTableArgsChange
  };
}

// Initializes table state. Only to be used by provider.
function useTableState(_ref3) {
  var initSortOrder = _ref3.initSortOrder,
    initSortBy = _ref3.initSortBy,
    initPage = _ref3.initPage,
    initSearchKeyword = _ref3.initSearchKeyword,
    _ref3$initRowsPerPage = _ref3.initRowsPerPage,
    initRowsPerPage = _ref3$initRowsPerPage === void 0 ? 10 : _ref3$initRowsPerPage;
  var _useState = React.useState(initSortOrder),
    _useState2 = _slicedToArray(_useState, 2),
    orderByDir = _useState2[0],
    setOrder = _useState2[1];
  var _useState3 = React.useState(initSortBy),
    _useState4 = _slicedToArray(_useState3, 2),
    orderBy = _useState4[0],
    setOrderBy = _useState4[1];
  var _useState5 = React.useState(initPage),
    _useState6 = _slicedToArray(_useState5, 2),
    page = _useState6[0],
    setPage = _useState6[1];
  var _useState7 = React.useState(initRowsPerPage),
    _useState8 = _slicedToArray(_useState7, 2),
    rowsPerPage = _useState8[0],
    setRowsPerPage = _useState8[1];
  var _useState9 = React.useState(initSearchKeyword),
    _useState10 = _slicedToArray(_useState9, 2),
    searchKeyword = _useState10[0],
    setSearchKeyword = _useState10[1];
  var _useState11 = React.useState([]),
    _useState12 = _slicedToArray(_useState11, 2),
    selectedRows = _useState12[0],
    setSelectedRows = _useState12[1];
  return {
    selectedRows: selectedRows,
    setSelectedRows: setSelectedRows,
    orderByDir: orderByDir,
    setOrder: setOrder,
    orderBy: orderBy,
    setOrderBy: setOrderBy,
    page: page,
    setPage: setPage,
    rowsPerPage: rowsPerPage,
    setRowsPerPage: setRowsPerPage,
    searchKeyword: searchKeyword,
    setSearchKeyword: setSearchKeyword
  };
}
TableProvider.propTypes = {
  initSortOrder: propTypesExports.string,
  initSortBy: propTypesExports.string,
  initPage: propTypesExports.number,
  initSearchKeyword: propTypesExports.string,
  initRowsPerPage: propTypesExports.number,
  rows: propTypesExports.array,
  actions: propTypesExports.array,
  total: propTypesExports.number,
  keyBy: propTypesExports.string,
  allowBulkActions: propTypesExports.bool,
  bulkActionButtonConfigs: propTypesExports.array,
  onTableArgsChange: propTypesExports.func,
  children: propTypesExports.any
};
function handleSelectedRowChange(_ref4) {
  var isSelected = _ref4.isSelected,
    row = _ref4.row,
    setSelectedRows = _ref4.setSelectedRows,
    keyBy = _ref4.keyBy;
  if (isSelected) {
    setSelectedRows(function (curRows) {
      return [].concat(_toConsumableArray(curRows), [row]);
    });
    return;
  }
  setSelectedRows(function (rows) {
    return removeRowFromRows({
      rows: rows,
      rowToRemove: row,
      keyBy: keyBy
    });
  });
}
function removeRowFromRows(_ref5) {
  var rows = _ref5.rows,
    rowToRemove = _ref5.rowToRemove,
    keyBy = _ref5.keyBy;
  return rows.filter(function (curRow) {
    return !areRowsEqual({
      rowA: curRow,
      rowB: rowToRemove,
      keyBy: keyBy
    });
  });
}
function isRowSelected(_ref6) {
  var row = _ref6.row,
    selectedRows = _ref6.selectedRows,
    keyBy = _ref6.keyBy;
  return !!selectedRows.find(function (curRow) {
    return areRowsEqual({
      rowA: curRow,
      rowB: row,
      keyBy: keyBy
    });
  });
}
function areRowsEqual(_ref7) {
  var rowA = _ref7.rowA,
    rowB = _ref7.rowB,
    keyBy = _ref7.keyBy;
  if (!keyBy) return rowA === rowB;
  return rowA[keyBy] === rowB[keyBy];
}

var KeyboardArrowDown = {};

var _interopRequireDefault$c = interopRequireDefaultExports;
Object.defineProperty(KeyboardArrowDown, "__esModule", {
  value: true
});
var default_1$c = KeyboardArrowDown.default = void 0;
var _createSvgIcon$c = _interopRequireDefault$c(requireCreateSvgIcon());
var _jsxRuntime$c = requireJsxRuntime();
var _default$c = (0, _createSvgIcon$c.default)( /*#__PURE__*/(0, _jsxRuntime$c.jsx)("path", {
  d: "M7.41 8.59 12 13.17l4.59-4.58L18 10l-6 6-6-6 1.41-1.41z"
}), 'KeyboardArrowDown');
default_1$c = KeyboardArrowDown.default = _default$c;

function TableCell(_ref) {
  var isFirstCell = _ref.isFirstCell,
    isLastCell = _ref.isLastCell,
    children = _ref.children,
    id = _ref.id,
    onRowClick = _ref.onRowClick,
    textAlign = _ref.textAlign,
    row = _ref.row;
  return /*#__PURE__*/React__namespace.default.createElement(StyledTableCell$3, _extends$2({
    textAlign: textAlign,
    isFirstCell: isFirstCell,
    isLastCell: isLastCell,
    "data-testid": isFirstCell && TABLES.FIRST_CELL,
    isClickable: onRowClick
  }, onRowClick && {
    onClick: function onClick() {
      return onRowClick({
        route: id,
        row: row
      });
    }
  }), children);
}
TableCell.propTypes = {
  isFirstCell: propTypesExports.bool,
  isLastCell: propTypesExports.bool,
  children: propTypesExports.node,
  id: propTypesExports.string,
  onRowClick: propTypesExports.func,
  textAlign: propTypesExports.string,
  row: propTypesExports.object
};
var StyledTableCell$3 = styled__default.default(TableCell$2, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref2) {
  var theme = _ref2.theme,
    isClickable = _ref2.isClickable,
    textAlign = _ref2.textAlign,
    isFirstCell = _ref2.isFirstCell,
    isLastCell = _ref2.isLastCell;
  return _defineProperty({
    textAlign: textAlign,
    paddingLeft: isFirstCell && "30px",
    paddingRight: isLastCell && "30px",
    fontSize: theme.typography.body1.fontSize,
    borderColor: theme.palette.card.divider,
    ":hover": {
      cursor: isClickable && "pointer"
    }
  }, theme.breakpoints.down("sm"), {
    fontSize: theme.typography.body2.fontSize
  });
});

var ArrowDropDown = {};

var _interopRequireDefault$b = interopRequireDefaultExports;
Object.defineProperty(ArrowDropDown, "__esModule", {
  value: true
});
var default_1$b = ArrowDropDown.default = void 0;
var _createSvgIcon$b = _interopRequireDefault$b(requireCreateSvgIcon());
var _jsxRuntime$b = requireJsxRuntime();
var _default$b = (0, _createSvgIcon$b.default)( /*#__PURE__*/(0, _jsxRuntime$b.jsx)("path", {
  d: "m7 10 5 5 5-5z"
}), 'ArrowDropDown');
default_1$b = ArrowDropDown.default = _default$b;

function TableCheckboxCell(_ref) {
  var value = _ref.value,
    _onChange = _ref.onChange,
    isSelectAll = _ref.isSelectAll;
  return /*#__PURE__*/React__namespace.default.createElement(StyledTableCell$2, null, /*#__PURE__*/React__namespace.default.createElement(Checkbox$1, {
    inputProps: {
      "data-testid": isSelectAll ? TEST_IDS.TABLE_SELECT_ALL_ROWS : TEST_IDS.TABLE_SELECT_ROW
    },
    checked: value,
    onChange: function onChange(event) {
      return _onChange(event.target.checked);
    }
  }), isSelectAll && /*#__PURE__*/React__namespace.default.createElement(StyledArrow, null));
}
TableCheckboxCell.propTypes = {
  value: propTypesExports.bool,
  onChange: propTypesExports.func,
  isSelectAll: propTypesExports.bool
};
var StyledTableCell$2 = styled__default.default(TableCell$2)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    position: "relative",
    padding: "0 0 0 20px",
    width: "40px",
    borderColor: theme.palette.card.divider,
    zIndex: "3"
  };
});
var StyledArrow = styled__default.default(default_1$b)({
  position: "absolute",
  right: "-14px",
  top: "16px"
});

function TableRow(_ref) {
  var row = _ref.row,
    cellConfigs = _ref.cellConfigs,
    onRowClick = _ref.onRowClick;
  var _useTable = useTable(),
    actions = _useTable.actions;
  var _useBulkTableActions = useBulkTableActions(),
    allowBulkActions = _useBulkTableActions.allowBulkActions,
    onSelectedRowChange = _useBulkTableActions.onSelectedRowChange,
    checkIfRowIsSelected = _useBulkTableActions.checkIfRowIsSelected;
  return /*#__PURE__*/React__namespace.default.createElement(TableRow$2, {
    "data-testid": TABLES.TABLE_ROW,
    hover: true,
    tabIndex: -1
  }, allowBulkActions && /*#__PURE__*/React__namespace.default.createElement(TableCheckboxCell, {
    value: checkIfRowIsSelected(row),
    onChange: function onChange(newIsSelected) {
      return onSelectedRowChange({
        isSelected: newIsSelected,
        row: row
      });
    }
  }), cellConfigs === null || cellConfigs === void 0 ? void 0 : cellConfigs.map(function (_ref2, i) {
    var formatValue = _ref2.formatValue,
      path = _ref2.path,
      Component = _ref2.Component,
      componentProps = _ref2.componentProps;
    var cellValue = getCellValue({
      row: row,
      path: path,
      formatValue: formatValue
    });
    return /*#__PURE__*/React__namespace.default.createElement(TableCell, {
      isFirstCell: i === 0,
      key: path,
      id: row.id,
      onRowClick: onRowClick,
      row: row
    }, !Component ? cellValue : /*#__PURE__*/React__namespace.default.createElement(Component, _extends$2({
      rowValues: row
    }, componentProps)));
  }), actions && /*#__PURE__*/React__namespace.default.createElement(TableCell, {
    textAlign: "right",
    isLastCell: true
  }, /*#__PURE__*/React__namespace.default.createElement(ActionableButton, {
    actionsParams: row,
    id: row.id,
    actions: actions,
    isSmall: true,
    icon: /*#__PURE__*/React__namespace.default.createElement(default_1$c, null)
  })));
}
TableRow.propTypes = {
  row: propTypesExports.object,
  cellConfigs: propTypesExports.array,
  onRowClick: propTypesExports.func
};
function getCellValue(_ref3) {
  var row = _ref3.row,
    path = _ref3.path,
    formatValue = _ref3.formatValue;
  return formatValue ? formatValue(row) : libCommon.get(row, path);
}

var NUMBER_OF_ROWS = 5;
var NUMBER_OF_CELLS = 5;
function TableSkeleton() {
  return /*#__PURE__*/React__namespace.default.createElement(material.TableBody, {
    "data-testid": TEST_IDS.TABLE_SKELETON
  }, libCommon.getArrayOfCount(NUMBER_OF_ROWS).map(function (row) {
    return /*#__PURE__*/React__namespace.default.createElement(material.TableRow, {
      key: "row_".concat(row)
    }, libCommon.getArrayOfCount(NUMBER_OF_CELLS).map(function (cell) {
      return /*#__PURE__*/React__namespace.default.createElement(material.TableCell, {
        key: "".concat(row, "_").concat(cell)
      }, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
        variant: "rectangular",
        isRounded: true
      }));
    }));
  }));
}

var SHORT_TABLE_HEIGHT$1 = 400;
function TableBody(_ref) {
  var isShortend = _ref.isShortend,
    keyBy = _ref.keyBy,
    isLoading = _ref.isLoading,
    cellConfigs = _ref.cellConfigs,
    mobileList = _ref.mobileList,
    onRowClick = _ref.onRowClick;
  var _useTable = useTable(),
    rows = _useTable.rows,
    rowsPerPage = _useTable.rowsPerPage,
    actions = _useTable.actions,
    page = _useTable.page,
    total = _useTable.total;
  var _useScreenSize = useScreenSize(),
    isSmScreen = _useScreenSize.isSmScreen;

  // Avoid a layout jump when reaching the last page with empty rows.
  var emptyRowsCount = getEmptyRowsCount({
    page: page,
    rowsPerPage: rowsPerPage,
    total: total
  });
  if (isLoading) return /*#__PURE__*/React__namespace.default.createElement(TableSkeleton, null);
  return /*#__PURE__*/React__namespace.default.createElement(TableBodyOG, null, !rows ? /*#__PURE__*/React__namespace.default.createElement(EmptyRows, {
    emptyRows: rowsPerPage,
    isShortend: isShortend
  }, /*#__PURE__*/React__namespace.default.createElement(TableCell$2, {
    align: "center",
    colSpan: 7,
    "data-testId": TEST_IDS.EMPTY_ROW_TABLE_CELL
  })) : /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, isSmScreen && mobileList ? /*#__PURE__*/React.cloneElement(mobileList, {
    rows: rows,
    actions: actions,
    isInTable: true
  }) : rows === null || rows === void 0 ? void 0 : rows.map(function (row, index) {
    return /*#__PURE__*/React__namespace.default.createElement(TableRow, {
      key: keyBy ? row[keyBy] : index,
      row: row,
      cellConfigs: cellConfigs,
      onRowClick: onRowClick
    });
  }), emptyRowsCount > 0 && /*#__PURE__*/React__namespace.default.createElement(EmptyRows, {
    emptyRows: emptyRowsCount,
    isShortend: isShortend,
    "aria-label": TABLES.EMPTY_ROWS
  }, /*#__PURE__*/React__namespace.default.createElement(TableCell$2, {
    colSpan: 7
  }))));
}
TableBody.propTypes = {
  isShortend: propTypesExports.bool,
  keyBy: propTypesExports.string,
  cellConfigs: propTypesExports.array,
  mobileList: propTypesExports.node,
  isLoading: propTypesExports.bool,
  onRowClick: propTypesExports.func
};
var EmptyRows = styled__default.default(TableRow$2, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref2) {
  var emptyRows = _ref2.emptyRows,
    isShortend = _ref2.isShortend;
  return {
    height: isShortend ? SHORT_TABLE_HEIGHT$1 : emptyRows * 53
  };
});
function getEmptyRowsCount(_ref3) {
  var page = _ref3.page,
    rowsPerPage = _ref3.rowsPerPage,
    total = _ref3.total;
  return page > 0 ? Math.max(0, (1 + page) * rowsPerPage - total) : 0;
}

function TableContainer$1(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React__namespace.default.createElement(Box$1, null, /*#__PURE__*/React__namespace.default.createElement(TablePaperCard, null, children));
}
TableContainer$1.propTypes = {
  children: propTypesExports.node
};
var TablePaperCard = styled__default.default(Paper$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    width: "100%",
    marginTop: 20,
    backgroundColor: theme.palette.card.background,
    borderRadius: theme.borderRadius.lg,
    boxShadow: theme.boxShadow,
    overflow: "hidden"
  };
});

function TableError(_ref) {
  var onRetry = _ref.onRetry,
    error = _ref.error;
  var _useTable = useTable(),
    page = _useTable.page,
    rowsPerPage = _useTable.rowsPerPage,
    searchKeyword = _useTable.searchKeyword,
    sortedBy = _useTable.sortedBy,
    onTableArgsChange = _useTable.onTableArgsChange;
  return /*#__PURE__*/React__namespace.default.createElement(Box$1, {
    "data-testid": TABLES.ERROR
  }, /*#__PURE__*/React__namespace.default.createElement(ErrorMessage, {
    error: error,
    onButtonClick: function onButtonClick() {
      return handleRetry({
        onRetry: onRetry,
        onTableArgsChange: onTableArgsChange,
        rowsPerPage: rowsPerPage,
        page: page,
        sortedBy: sortedBy,
        searchKeyword: searchKeyword
      });
    }
  }));
}
TableError.propTypes = {
  onRetry: propTypesExports.func,
  error: propTypesExports.object
};
function handleRetry(_ref2) {
  var onRetry = _ref2.onRetry,
    onTableArgsChange = _ref2.onTableArgsChange,
    rowsPerPage = _ref2.rowsPerPage,
    page = _ref2.page,
    sortedBy = _ref2.sortedBy,
    searchKeyword = _ref2.searchKeyword;
  if (onRetry) {
    onRetry();
    return;
  }
  onTableArgsChange({
    rowsPerPage: rowsPerPage,
    page: page,
    sortedBy: sortedBy,
    searchKeyword: searchKeyword
  });
}

function getToolbarUtilityClass(slot) {
  return generateUtilityClass('MuiToolbar', slot);
}
generateUtilityClasses('MuiToolbar', ['root', 'gutters', 'regular', 'dense']);

const _excluded$c = ["className", "component", "disableGutters", "variant"];
const useUtilityClasses$5 = ownerState => {
  const {
    classes,
    disableGutters,
    variant
  } = ownerState;
  const slots = {
    root: ['root', !disableGutters && 'gutters', variant]
  };
  return composeClasses(slots, getToolbarUtilityClass, classes);
};
const ToolbarRoot = styled$1('div', {
  name: 'MuiToolbar',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, !ownerState.disableGutters && styles.gutters, styles[ownerState.variant]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  position: 'relative',
  display: 'flex',
  alignItems: 'center'
}, !ownerState.disableGutters && {
  paddingLeft: theme.spacing(2),
  paddingRight: theme.spacing(2),
  [theme.breakpoints.up('sm')]: {
    paddingLeft: theme.spacing(3),
    paddingRight: theme.spacing(3)
  }
}, ownerState.variant === 'dense' && {
  minHeight: 48
}), ({
  theme,
  ownerState
}) => ownerState.variant === 'regular' && theme.mixins.toolbar);
const Toolbar = /*#__PURE__*/React__namespace.forwardRef(function Toolbar(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiToolbar'
  });
  const {
      className,
      component = 'div',
      disableGutters = false,
      variant = 'regular'
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$c);
  const ownerState = _extends$1({}, props, {
    component,
    disableGutters,
    variant
  });
  const classes = useUtilityClasses$5(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(ToolbarRoot, _extends$1({
    as: component,
    className: clsx(classes.root, className),
    ref: ref,
    ownerState: ownerState
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? Toolbar.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The Toolbar children, usually a mixture of `IconButton`, `Button` and `Typography`.
   * The Toolbar is a flex container, allowing flex item properites to be used to lay out the children.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * If `true`, disables gutter padding.
   * @default false
   */
  disableGutters: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * The variant to use.
   * @default 'regular'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['dense', 'regular']), propTypesExports.string])
} : void 0;
var Toolbar$1 = Toolbar;

function TableBulkActionButton(_ref) {
  var Icon = _ref.Icon,
    label = _ref.label,
    _onClick = _ref.onClick,
    isLoading = _ref.isLoading;
  var _useBulkTableActions = useBulkTableActions(),
    selectedRows = _useBulkTableActions.selectedRows;
  if (Icon) {
    return /*#__PURE__*/React__namespace.default.createElement(IconButton, {
      "data-testid": TEST_IDS.TABLE_BULK_ACTION_BUTTON,
      Icon: Icon,
      onClick: function onClick() {
        return _onClick(selectedRows);
      },
      color: "inherit",
      isLoading: isLoading,
      tooltip: label
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(TextButton, {
    "data-testid": TEST_IDS.TABLE_BULK_ACTION_BUTTON,
    variant: "contained",
    onClick: function onClick() {
      return _onClick(selectedRows);
    },
    isLoading: isLoading
  }, label);
}
TableBulkActionButton.propTypes = {
  Icon: propTypesExports.elementType,
  label: propTypesExports.string,
  onClick: propTypesExports.func.isRequired,
  isLoading: propTypesExports.bool
};
var TextButton = styled__default.default(Button)({
  textTransform: "none",
  margin: "0 8px"
});

function TableBulkActionsHeader() {
  var _useBulkTableActions = useBulkTableActions(),
    selectedRows = _useBulkTableActions.selectedRows,
    clearSelectedRows = _useBulkTableActions.clearSelectedRows,
    bulkActionButtonConfigs = _useBulkTableActions.bulkActionButtonConfigs;
  return /*#__PURE__*/React__namespace.default.createElement(StyledToolbar, {
    "data-testid": TEST_IDS.TABLE_BULK_ACTIONS_HEADER
  }, /*#__PURE__*/React__namespace.default.createElement(SelectedLabel, null, "".concat(selectedRows.length, " selected")), /*#__PURE__*/React__namespace.default.createElement(BulkActionButtons, null, bulkActionButtonConfigs === null || bulkActionButtonConfigs === void 0 ? void 0 : bulkActionButtonConfigs.map(function (_ref, idx) {
    var Icon = _ref.Icon,
      label = _ref.label,
      _onClick = _ref.onClick,
      isLoading = _ref.isLoading;
    return /*#__PURE__*/React__namespace.default.createElement(TableBulkActionButton, {
      key: "bulk-action-button-".concat(idx),
      Icon: Icon,
      label: label,
      onClick: function onClick() {
        return _onClick(selectedRows);
      },
      isLoading: isLoading
    });
  })), /*#__PURE__*/React__namespace.default.createElement(StyledCloseButton, {
    onClick: clearSelectedRows,
    color: "inherit"
  }));
}
var StyledToolbar = styled__default.default(Toolbar$1)(function (_ref2) {
  var theme = _ref2.theme;
  return _defineProperty({
    position: "relative",
    width: "100%",
    display: "flex",
    alignItems: "center",
    borderBottom: "1px solid ".concat(theme.palette.card.divider),
    backgroundColor: theme.palette.secondary.alt,
    color: theme.palette.text.light,
    "& .Mui-disabled": {
      color: "".concat(theme.palette.text.secondary, " !important")
    }
  }, theme.breakpoints.down("sm"), {
    flexDirection: "column",
    alignItems: "flex-start",
    justifyContent: "center",
    gap: 5,
    padding: "10px 24px"
  });
});
var BulkActionButtons = styled__default.default(Box$1)(function (_ref4) {
  var theme = _ref4.theme;
  return _defineProperty({
    display: "flex",
    alignItems: "center",
    flex: 1
  }, theme.breakpoints.down("sm"), {
    width: "100%",
    justifyContent: "center"
  });
});
var SelectedLabel = styled__default.default(Typography$1)(function (_ref6) {
  var theme = _ref6.theme;
  return _defineProperty({
    marginRight: "20px",
    color: theme.palette.text.secondary
  }, theme.breakpoints.down("sm"), {
    padding: "8px 0 0"
  });
});
var StyledCloseButton = styled__default.default(CloseButton)({
  position: "absolute",
  top: 16,
  right: 16
});

function TableHeader(_ref) {
  var headerTitle = _ref.headerTitle,
    addEntry = _ref.addEntry,
    isSearchable = _ref.isSearchable,
    renderAdditionalContent = _ref.renderAdditionalContent,
    onDownloadClick = _ref.onDownloadClick;
  var _useBulkTableActions = useBulkTableActions(),
    hasSelectedRows = _useBulkTableActions.hasSelectedRows,
    allowBulkActions = _useBulkTableActions.allowBulkActions,
    clearSelectedRows = _useBulkTableActions.clearSelectedRows;
  var _useTable = useTable(),
    searchKeyword = _useTable.searchKeyword,
    setSearchKeyword = _useTable.setSearchKeyword,
    rowsPerPage = _useTable.rowsPerPage,
    page = _useTable.page,
    sortedBy = _useTable.sortedBy,
    setPage = _useTable.setPage,
    onTableArgsChange = _useTable.onTableArgsChange;
  if (hasSelectedRows && allowBulkActions) {
    return /*#__PURE__*/React__namespace.default.createElement(TableBulkActionsHeader, null);
  }
  return /*#__PURE__*/React__namespace.default.createElement(TableToolbar, null, /*#__PURE__*/React__namespace.default.createElement(HeaderBox$1, null, /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "h4"
  }, headerTitle), addEntry && /*#__PURE__*/React__namespace.default.createElement(AddButton, {
    onClick: addEntry
  }), renderAdditionalContent && renderAdditionalContent()), isSearchable && /*#__PURE__*/React__namespace.default.createElement(SearchBox, null, /*#__PURE__*/React__namespace.default.createElement(SearchBar, {
    onChange: function onChange(newSearchKeyword) {
      return handleSearchKeywordChange({
        newSearchKeyword: newSearchKeyword,
        rowsPerPage: rowsPerPage,
        page: page,
        sortedBy: sortedBy,
        setPage: setPage,
        setSearchKeyword: setSearchKeyword,
        clearSelectedRows: clearSelectedRows,
        onTableArgsChange: onTableArgsChange
      });
    },
    searchKeyword: searchKeyword
  })), onDownloadClick && /*#__PURE__*/React__namespace.default.createElement(DownloadButton, {
    onClick: onDownloadClick
  }));
}
TableHeader.propTypes = {
  headerTitle: propTypesExports.string,
  addEntry: propTypesExports.func,
  isSearchable: propTypesExports.bool,
  renderAdditionalContent: propTypesExports.func,
  onDownloadClick: propTypesExports.func
};
var HeaderBox$1 = styled__default.default(Box$1)({
  width: "100%",
  display: "flex",
  alignItems: "center"
});
var SearchBox = styled__default.default(Box$1)({
  width: "60%",
  display: "flex",
  justifyContent: "flex-end"
});
var TableToolbar = styled__default.default(Toolbar$1)(function (_ref2) {
  var theme = _ref2.theme,
    isDark = _ref2.isDark;
  return {
    alignItems: "center",
    borderBottom: "1px solid ".concat(theme.palette.card.divider),
    backgroundColor: isDark ? theme.palette.secondary.alt : "transparent",
    color: isDark ? theme.palette.text.light : theme.palette.text.primary
  };
});
function handleSearchKeywordChange(_ref3) {
  var newSearchKeyword = _ref3.newSearchKeyword,
    rowsPerPage = _ref3.rowsPerPage,
    sortedBy = _ref3.sortedBy,
    setPage = _ref3.setPage,
    setSearchKeyword = _ref3.setSearchKeyword,
    clearSelectedRows = _ref3.clearSelectedRows,
    onTableArgsChange = _ref3.onTableArgsChange;
  setSearchKeyword(newSearchKeyword);
  setPage(0);
  clearSelectedRows();
  onTableArgsChange({
    rowsPerPage: rowsPerPage,
    page: 0,
    sortedBy: sortedBy,
    searchKeyword: newSearchKeyword
  });
}

var LastPageIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M5.59 7.41L10.18 12l-4.59 4.59L7 18l6-6-6-6zM16 6h2v12h-2z"
}), 'LastPage');

var FirstPageIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M18.41 16.59L13.82 12l4.59-4.59L17 6l-6 6 6 6zM6 6h2v12H6z"
}), 'FirstPage');

var _LastPageIcon, _FirstPageIcon, _KeyboardArrowRight, _KeyboardArrowLeft, _KeyboardArrowLeft2, _KeyboardArrowRight2, _FirstPageIcon2, _LastPageIcon2;
const _excluded$b = ["backIconButtonProps", "count", "getItemAriaLabel", "nextIconButtonProps", "onPageChange", "page", "rowsPerPage", "showFirstButton", "showLastButton"];
const TablePaginationActions = /*#__PURE__*/React__namespace.forwardRef(function TablePaginationActions(props, ref) {
  const {
      backIconButtonProps,
      count,
      getItemAriaLabel,
      nextIconButtonProps,
      onPageChange,
      page,
      rowsPerPage,
      showFirstButton,
      showLastButton
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$b);
  const theme = useTheme$1();
  const handleFirstPageButtonClick = event => {
    onPageChange(event, 0);
  };
  const handleBackButtonClick = event => {
    onPageChange(event, page - 1);
  };
  const handleNextButtonClick = event => {
    onPageChange(event, page + 1);
  };
  const handleLastPageButtonClick = event => {
    onPageChange(event, Math.max(0, Math.ceil(count / rowsPerPage) - 1));
  };
  return /*#__PURE__*/jsxRuntimeExports.jsxs("div", _extends$1({
    ref: ref
  }, other, {
    children: [showFirstButton && /*#__PURE__*/jsxRuntimeExports.jsx(IconButton$2, {
      onClick: handleFirstPageButtonClick,
      disabled: page === 0,
      "aria-label": getItemAriaLabel('first', page),
      title: getItemAriaLabel('first', page),
      children: theme.direction === 'rtl' ? _LastPageIcon || (_LastPageIcon = /*#__PURE__*/jsxRuntimeExports.jsx(LastPageIcon, {})) : _FirstPageIcon || (_FirstPageIcon = /*#__PURE__*/jsxRuntimeExports.jsx(FirstPageIcon, {}))
    }), /*#__PURE__*/jsxRuntimeExports.jsx(IconButton$2, _extends$1({
      onClick: handleBackButtonClick,
      disabled: page === 0,
      color: "inherit",
      "aria-label": getItemAriaLabel('previous', page),
      title: getItemAriaLabel('previous', page)
    }, backIconButtonProps, {
      children: theme.direction === 'rtl' ? _KeyboardArrowRight || (_KeyboardArrowRight = /*#__PURE__*/jsxRuntimeExports.jsx(KeyboardArrowRight, {})) : _KeyboardArrowLeft || (_KeyboardArrowLeft = /*#__PURE__*/jsxRuntimeExports.jsx(KeyboardArrowLeft, {}))
    })), /*#__PURE__*/jsxRuntimeExports.jsx(IconButton$2, _extends$1({
      onClick: handleNextButtonClick,
      disabled: count !== -1 ? page >= Math.ceil(count / rowsPerPage) - 1 : false,
      color: "inherit",
      "aria-label": getItemAriaLabel('next', page),
      title: getItemAriaLabel('next', page)
    }, nextIconButtonProps, {
      children: theme.direction === 'rtl' ? _KeyboardArrowLeft2 || (_KeyboardArrowLeft2 = /*#__PURE__*/jsxRuntimeExports.jsx(KeyboardArrowLeft, {})) : _KeyboardArrowRight2 || (_KeyboardArrowRight2 = /*#__PURE__*/jsxRuntimeExports.jsx(KeyboardArrowRight, {}))
    })), showLastButton && /*#__PURE__*/jsxRuntimeExports.jsx(IconButton$2, {
      onClick: handleLastPageButtonClick,
      disabled: page >= Math.ceil(count / rowsPerPage) - 1,
      "aria-label": getItemAriaLabel('last', page),
      title: getItemAriaLabel('last', page),
      children: theme.direction === 'rtl' ? _FirstPageIcon2 || (_FirstPageIcon2 = /*#__PURE__*/jsxRuntimeExports.jsx(FirstPageIcon, {})) : _LastPageIcon2 || (_LastPageIcon2 = /*#__PURE__*/jsxRuntimeExports.jsx(LastPageIcon, {}))
    })]
  }));
});
browser$1.env.NODE_ENV !== "production" ? TablePaginationActions.propTypes = {
  /**
   * Props applied to the back arrow [`IconButton`](/material-ui/api/icon-button/) element.
   */
  backIconButtonProps: propTypesExports.object,
  /**
   * The total number of rows.
   */
  count: propTypesExports.number.isRequired,
  /**
   * Accepts a function which returns a string value that provides a user-friendly name for the current page.
   *
   * For localization purposes, you can use the provided [translations](/material-ui/guides/localization/).
   *
   * @param {string} type The link or button type to format ('page' | 'first' | 'last' | 'next' | 'previous'). Defaults to 'page'.
   * @param {number} page The page number to format.
   * @returns {string}
   */
  getItemAriaLabel: propTypesExports.func.isRequired,
  /**
   * Props applied to the next arrow [`IconButton`](/material-ui/api/icon-button/) element.
   */
  nextIconButtonProps: propTypesExports.object,
  /**
   * Callback fired when the page is changed.
   *
   * @param {object} event The event source of the callback.
   * @param {number} page The page selected.
   */
  onPageChange: propTypesExports.func.isRequired,
  /**
   * The zero-based index of the current page.
   */
  page: propTypesExports.number.isRequired,
  /**
   * The number of rows per page.
   */
  rowsPerPage: propTypesExports.number.isRequired,
  /**
   * If `true`, show the first-page button.
   */
  showFirstButton: propTypesExports.bool.isRequired,
  /**
   * If `true`, show the last-page button.
   */
  showLastButton: propTypesExports.bool.isRequired
} : void 0;
var TablePaginationActions$1 = TablePaginationActions;

function getTablePaginationUtilityClass(slot) {
  return generateUtilityClass('MuiTablePagination', slot);
}
const tablePaginationClasses = generateUtilityClasses('MuiTablePagination', ['root', 'toolbar', 'spacer', 'selectLabel', 'selectRoot', 'select', 'selectIcon', 'input', 'menuItem', 'displayedRows', 'actions']);
var tablePaginationClasses$1 = tablePaginationClasses;

var _InputBase;
const _excluded$a = ["ActionsComponent", "backIconButtonProps", "className", "colSpan", "component", "count", "getItemAriaLabel", "labelDisplayedRows", "labelRowsPerPage", "nextIconButtonProps", "onPageChange", "onRowsPerPageChange", "page", "rowsPerPage", "rowsPerPageOptions", "SelectProps", "showFirstButton", "showLastButton"];
const TablePaginationRoot = styled$1(TableCell$2, {
  name: 'MuiTablePagination',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})(({
  theme
}) => ({
  overflow: 'auto',
  color: (theme.vars || theme).palette.text.primary,
  fontSize: theme.typography.pxToRem(14),
  // Increase the specificity to override TableCell.
  '&:last-child': {
    padding: 0
  }
}));
const TablePaginationToolbar = styled$1(Toolbar$1, {
  name: 'MuiTablePagination',
  slot: 'Toolbar',
  overridesResolver: (props, styles) => _extends$1({
    [`& .${tablePaginationClasses$1.actions}`]: styles.actions
  }, styles.toolbar)
})(({
  theme
}) => ({
  minHeight: 52,
  paddingRight: 2,
  [`${theme.breakpoints.up('xs')} and (orientation: landscape)`]: {
    minHeight: 52
  },
  [theme.breakpoints.up('sm')]: {
    minHeight: 52,
    paddingRight: 2
  },
  [`& .${tablePaginationClasses$1.actions}`]: {
    flexShrink: 0,
    marginLeft: 20
  }
}));
const TablePaginationSpacer = styled$1('div', {
  name: 'MuiTablePagination',
  slot: 'Spacer',
  overridesResolver: (props, styles) => styles.spacer
})({
  flex: '1 1 100%'
});
const TablePaginationSelectLabel = styled$1('p', {
  name: 'MuiTablePagination',
  slot: 'SelectLabel',
  overridesResolver: (props, styles) => styles.selectLabel
})(({
  theme
}) => _extends$1({}, theme.typography.body2, {
  flexShrink: 0
}));
const TablePaginationSelect = styled$1(Select$1, {
  name: 'MuiTablePagination',
  slot: 'Select',
  overridesResolver: (props, styles) => _extends$1({
    [`& .${tablePaginationClasses$1.selectIcon}`]: styles.selectIcon,
    [`& .${tablePaginationClasses$1.select}`]: styles.select
  }, styles.input, styles.selectRoot)
})({
  color: 'inherit',
  fontSize: 'inherit',
  flexShrink: 0,
  marginRight: 32,
  marginLeft: 8,
  [`& .${tablePaginationClasses$1.select}`]: {
    paddingLeft: 8,
    paddingRight: 24,
    textAlign: 'right',
    textAlignLast: 'right' // Align <select> on Chrome.
  }
});

const TablePaginationMenuItem = styled$1(MenuItem$1, {
  name: 'MuiTablePagination',
  slot: 'MenuItem',
  overridesResolver: (props, styles) => styles.menuItem
})({});
const TablePaginationDisplayedRows = styled$1('p', {
  name: 'MuiTablePagination',
  slot: 'DisplayedRows',
  overridesResolver: (props, styles) => styles.displayedRows
})(({
  theme
}) => _extends$1({}, theme.typography.body2, {
  flexShrink: 0
}));
function defaultLabelDisplayedRows({
  from,
  to,
  count
}) {
  return `${from}–${to} of ${count !== -1 ? count : `more than ${to}`}`;
}
function defaultGetAriaLabel(type) {
  return `Go to ${type} page`;
}
const useUtilityClasses$4 = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root'],
    toolbar: ['toolbar'],
    spacer: ['spacer'],
    selectLabel: ['selectLabel'],
    select: ['select'],
    input: ['input'],
    selectIcon: ['selectIcon'],
    menuItem: ['menuItem'],
    displayedRows: ['displayedRows'],
    actions: ['actions']
  };
  return composeClasses(slots, getTablePaginationUtilityClass, classes);
};

/**
 * A `TableCell` based component for placing inside `TableFooter` for pagination.
 */
const TablePagination$1 = /*#__PURE__*/React__namespace.forwardRef(function TablePagination(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTablePagination'
  });
  const {
      ActionsComponent = TablePaginationActions$1,
      backIconButtonProps,
      className,
      colSpan: colSpanProp,
      component = TableCell$2,
      count,
      getItemAriaLabel = defaultGetAriaLabel,
      labelDisplayedRows = defaultLabelDisplayedRows,
      labelRowsPerPage = 'Rows per page:',
      nextIconButtonProps,
      onPageChange,
      onRowsPerPageChange,
      page,
      rowsPerPage,
      rowsPerPageOptions = [10, 25, 50, 100],
      SelectProps = {},
      showFirstButton = false,
      showLastButton = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$a);
  const ownerState = props;
  const classes = useUtilityClasses$4(ownerState);
  const MenuItemComponent = SelectProps.native ? 'option' : TablePaginationMenuItem;
  let colSpan;
  if (component === TableCell$2 || component === 'td') {
    colSpan = colSpanProp || 1000; // col-span over everything
  }

  const selectId = useId(SelectProps.id);
  const labelId = useId(SelectProps.labelId);
  const getLabelDisplayedRowsTo = () => {
    if (count === -1) {
      return (page + 1) * rowsPerPage;
    }
    return rowsPerPage === -1 ? count : Math.min(count, (page + 1) * rowsPerPage);
  };
  return /*#__PURE__*/jsxRuntimeExports.jsx(TablePaginationRoot, _extends$1({
    colSpan: colSpan,
    ref: ref,
    as: component,
    ownerState: ownerState,
    className: clsx(classes.root, className)
  }, other, {
    children: /*#__PURE__*/jsxRuntimeExports.jsxs(TablePaginationToolbar, {
      className: classes.toolbar,
      children: [/*#__PURE__*/jsxRuntimeExports.jsx(TablePaginationSpacer, {
        className: classes.spacer
      }), rowsPerPageOptions.length > 1 && /*#__PURE__*/jsxRuntimeExports.jsx(TablePaginationSelectLabel, {
        className: classes.selectLabel,
        id: labelId,
        children: labelRowsPerPage
      }), rowsPerPageOptions.length > 1 && /*#__PURE__*/jsxRuntimeExports.jsx(TablePaginationSelect, _extends$1({
        variant: "standard"
      }, !SelectProps.variant && {
        input: _InputBase || (_InputBase = /*#__PURE__*/jsxRuntimeExports.jsx(InputBase$1, {}))
      }, {
        value: rowsPerPage,
        onChange: onRowsPerPageChange,
        id: selectId,
        labelId: labelId
      }, SelectProps, {
        classes: _extends$1({}, SelectProps.classes, {
          // TODO v5 remove `classes.input`
          root: clsx(classes.input, classes.selectRoot, (SelectProps.classes || {}).root),
          select: clsx(classes.select, (SelectProps.classes || {}).select),
          // TODO v5 remove `selectIcon`
          icon: clsx(classes.selectIcon, (SelectProps.classes || {}).icon)
        }),
        children: rowsPerPageOptions.map(rowsPerPageOption => /*#__PURE__*/React.createElement(MenuItemComponent, _extends$1({}, !isHostComponent(MenuItemComponent) && {
          ownerState
        }, {
          className: classes.menuItem,
          key: rowsPerPageOption.label ? rowsPerPageOption.label : rowsPerPageOption,
          value: rowsPerPageOption.value ? rowsPerPageOption.value : rowsPerPageOption
        }), rowsPerPageOption.label ? rowsPerPageOption.label : rowsPerPageOption))
      })), /*#__PURE__*/jsxRuntimeExports.jsx(TablePaginationDisplayedRows, {
        className: classes.displayedRows,
        children: labelDisplayedRows({
          from: count === 0 ? 0 : page * rowsPerPage + 1,
          to: getLabelDisplayedRowsTo(),
          count: count === -1 ? -1 : count,
          page
        })
      }), /*#__PURE__*/jsxRuntimeExports.jsx(ActionsComponent, {
        className: classes.actions,
        backIconButtonProps: backIconButtonProps,
        count: count,
        nextIconButtonProps: nextIconButtonProps,
        onPageChange: onPageChange,
        page: page,
        rowsPerPage: rowsPerPage,
        showFirstButton: showFirstButton,
        showLastButton: showLastButton,
        getItemAriaLabel: getItemAriaLabel
      })]
    })
  }));
});
browser$1.env.NODE_ENV !== "production" ? TablePagination$1.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The component used for displaying the actions.
   * Either a string to use a HTML element or a component.
   * @default TablePaginationActions
   */
  ActionsComponent: propTypesExports.elementType,
  /**
   * Props applied to the back arrow [`IconButton`](/material-ui/api/icon-button/) component.
   */
  backIconButtonProps: propTypesExports.object,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * @ignore
   */
  colSpan: propTypesExports.number,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The total number of rows.
   *
   * To enable server side pagination for an unknown number of items, provide -1.
   */
  count: integerPropType.isRequired,
  /**
   * Accepts a function which returns a string value that provides a user-friendly name for the current page.
   * This is important for screen reader users.
   *
   * For localization purposes, you can use the provided [translations](/material-ui/guides/localization/).
   * @param {string} type The link or button type to format ('first' | 'last' | 'next' | 'previous').
   * @returns {string}
   * @default function defaultGetAriaLabel(type) {
   *   return `Go to ${type} page`;
   * }
   */
  getItemAriaLabel: propTypesExports.func,
  /**
   * Customize the displayed rows label. Invoked with a `{ from, to, count, page }`
   * object.
   *
   * For localization purposes, you can use the provided [translations](/material-ui/guides/localization/).
   * @default function defaultLabelDisplayedRows({ from, to, count }) {
   *   return `${from}–${to} of ${count !== -1 ? count : `more than ${to}`}`;
   * }
   */
  labelDisplayedRows: propTypesExports.func,
  /**
   * Customize the rows per page label.
   *
   * For localization purposes, you can use the provided [translations](/material-ui/guides/localization/).
   * @default 'Rows per page:'
   */
  labelRowsPerPage: propTypesExports.node,
  /**
   * Props applied to the next arrow [`IconButton`](/material-ui/api/icon-button/) element.
   */
  nextIconButtonProps: propTypesExports.object,
  /**
   * Callback fired when the page is changed.
   *
   * @param {React.MouseEvent<HTMLButtonElement> | null} event The event source of the callback.
   * @param {number} page The page selected.
   */
  onPageChange: propTypesExports.func.isRequired,
  /**
   * Callback fired when the number of rows per page is changed.
   *
   * @param {React.ChangeEvent<HTMLTextAreaElement | HTMLInputElement>} event The event source of the callback.
   */
  onRowsPerPageChange: propTypesExports.func,
  /**
   * The zero-based index of the current page.
   */
  page: chainPropTypes(integerPropType.isRequired, props => {
    const {
      count,
      page,
      rowsPerPage
    } = props;
    if (count === -1) {
      return null;
    }
    const newLastPage = Math.max(0, Math.ceil(count / rowsPerPage) - 1);
    if (page < 0 || page > newLastPage) {
      return new Error('MUI: The page prop of a TablePagination is out of range ' + `(0 to ${newLastPage}, but page is ${page}).`);
    }
    return null;
  }),
  /**
   * The number of rows per page.
   *
   * Set -1 to display all the rows.
   */
  rowsPerPage: integerPropType.isRequired,
  /**
   * Customizes the options of the rows per page select field. If less than two options are
   * available, no select field will be displayed.
   * Use -1 for the value with a custom label to show all the rows.
   * @default [10, 25, 50, 100]
   */
  rowsPerPageOptions: propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.number, propTypesExports.shape({
    label: propTypesExports.string.isRequired,
    value: propTypesExports.number.isRequired
  })]).isRequired),
  /**
   * Props applied to the rows per page [`Select`](/material-ui/api/select/) element.
   * @default {}
   */
  SelectProps: propTypesExports.object,
  /**
   * If `true`, show the first-page button.
   * @default false
   */
  showFirstButton: propTypesExports.bool,
  /**
   * If `true`, show the last-page button.
   * @default false
   */
  showLastButton: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TablePaginationOG = TablePagination$1;

function TablePagination(_ref) {
  var total = _ref.total,
    rowsPerPageOptions = _ref.rowsPerPageOptions,
    hide = _ref.hide;
  var _useBulkTableActions = useBulkTableActions(),
    clearSelectedRows = _useBulkTableActions.clearSelectedRows;
  var _useTable = useTable(),
    page = _useTable.page,
    setPage = _useTable.setPage,
    rowsPerPage = _useTable.rowsPerPage,
    setRowsPerPage = _useTable.setRowsPerPage,
    searchKeyword = _useTable.searchKeyword,
    sortedBy = _useTable.sortedBy,
    onTableArgsChange = _useTable.onTableArgsChange;
  if (hide) return null;
  return /*#__PURE__*/React__namespace.default.createElement(TablePaginationOG, {
    rowsPerPageOptions: rowsPerPageOptions,
    labelRowsPerPage: "Rows per page:",
    labelDisplayedRows: translateLabelDisplayedRows,
    component: "div",
    count: total || 0,
    rowsPerPage: rowsPerPage,
    page: page,
    SelectProps: {
      "data-testid": TEST_IDS.TABLE_ROWS_PER_PAGE_SELECT
    },
    onPageChange: function onPageChange(event, newPage) {
      return changePage({
        onTableArgsChange: onTableArgsChange,
        newPage: newPage,
        rowsPerPage: rowsPerPage,
        sortedBy: sortedBy,
        searchKeyword: searchKeyword,
        setPage: setPage,
        clearSelectedRows: clearSelectedRows
      });
    },
    onRowsPerPageChange: function onRowsPerPageChange(event) {
      return changeRowsPerPage({
        onTableArgsChange: onTableArgsChange,
        event: event,
        sortedBy: sortedBy,
        searchKeyword: searchKeyword,
        setRowsPerPage: setRowsPerPage,
        setPage: setPage,
        clearSelectedRows: clearSelectedRows
      });
    }
  });
}
TablePagination.propTypes = {
  total: propTypesExports.number,
  rowsPerPageOptions: propTypesExports.arrayOf(propTypesExports.number),
  hide: propTypesExports.bool
};
function changeRowsPerPage(_x) {
  return _changeRowsPerPage.apply(this, arguments);
}
function _changeRowsPerPage() {
  _changeRowsPerPage = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref2) {
    var onTableArgsChange, event, sortedBy, searchKeyword, setRowsPerPage, setPage, clearSelectedRows, newRowsPerPage;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          onTableArgsChange = _ref2.onTableArgsChange, event = _ref2.event, sortedBy = _ref2.sortedBy, searchKeyword = _ref2.searchKeyword, setRowsPerPage = _ref2.setRowsPerPage, setPage = _ref2.setPage, clearSelectedRows = _ref2.clearSelectedRows;
          newRowsPerPage = event.target.value;
          setRowsPerPage(newRowsPerPage);
          setPage(0);
          clearSelectedRows();
          onTableArgsChange({
            rowsPerPage: newRowsPerPage,
            page: 0,
            sortedBy: sortedBy,
            searchKeyword: searchKeyword
          });
        case 6:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _changeRowsPerPage.apply(this, arguments);
}
function changePage(_x2) {
  return _changePage.apply(this, arguments);
}
function _changePage() {
  _changePage = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref3) {
    var onTableArgsChange, newPage, rowsPerPage, sortedBy, searchKeyword, setPage, clearSelectedRows;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          onTableArgsChange = _ref3.onTableArgsChange, newPage = _ref3.newPage, rowsPerPage = _ref3.rowsPerPage, sortedBy = _ref3.sortedBy, searchKeyword = _ref3.searchKeyword, setPage = _ref3.setPage, clearSelectedRows = _ref3.clearSelectedRows;
          setPage(newPage);
          clearSelectedRows();
          onTableArgsChange({
            rowsPerPage: rowsPerPage,
            page: newPage,
            sortedBy: sortedBy,
            searchKeyword: searchKeyword
          });
        case 4:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return _changePage.apply(this, arguments);
}
function translateLabelDisplayedRows(_ref4) {
  var from = _ref4.from,
    to = _ref4.to,
    count = _ref4.count;
  return "".concat(from, "-").concat(to, " of ").concat(count !== -1 ? count : "more than ".concat(to));
}

function getTableHeadUtilityClass(slot) {
  return generateUtilityClass('MuiTableHead', slot);
}
generateUtilityClasses('MuiTableHead', ['root']);

const _excluded$9 = ["className", "component"];
const useUtilityClasses$3 = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root']
  };
  return composeClasses(slots, getTableHeadUtilityClass, classes);
};
const TableHeadRoot = styled$1('thead', {
  name: 'MuiTableHead',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})({
  display: 'table-header-group'
});
const tablelvl2 = {
  variant: 'head'
};
const defaultComponent = 'thead';
const TableHead = /*#__PURE__*/React__namespace.forwardRef(function TableHead(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTableHead'
  });
  const {
      className,
      component = defaultComponent
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$9);
  const ownerState = _extends$1({}, props, {
    component
  });
  const classes = useUtilityClasses$3(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(Tablelvl2Context$1.Provider, {
    value: tablelvl2,
    children: /*#__PURE__*/jsxRuntimeExports.jsx(TableHeadRoot, _extends$1({
      as: component,
      className: clsx(classes.root, className),
      ref: ref,
      role: component === defaultComponent ? null : 'rowgroup',
      ownerState: ownerState
    }, other))
  });
});
browser$1.env.NODE_ENV !== "production" ? TableHead.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component, normally `TableRow`.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TableHead$1 = TableHead;

var ArrowDownwardIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M20 12l-1.41-1.41L13 16.17V4h-2v12.17l-5.58-5.59L4 12l8 8 8-8z"
}), 'ArrowDownward');

function getTableSortLabelUtilityClass(slot) {
  return generateUtilityClass('MuiTableSortLabel', slot);
}
const tableSortLabelClasses = generateUtilityClasses('MuiTableSortLabel', ['root', 'active', 'icon', 'iconDirectionDesc', 'iconDirectionAsc']);
var tableSortLabelClasses$1 = tableSortLabelClasses;

const _excluded$8 = ["active", "children", "className", "direction", "hideSortIcon", "IconComponent"];
const useUtilityClasses$2 = ownerState => {
  const {
    classes,
    direction,
    active
  } = ownerState;
  const slots = {
    root: ['root', active && 'active'],
    icon: ['icon', `iconDirection${capitalize(direction)}`]
  };
  return composeClasses(slots, getTableSortLabelUtilityClass, classes);
};
const TableSortLabelRoot = styled$1(ButtonBase$1, {
  name: 'MuiTableSortLabel',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.root, ownerState.active && styles.active];
  }
})(({
  theme
}) => ({
  cursor: 'pointer',
  display: 'inline-flex',
  justifyContent: 'flex-start',
  flexDirection: 'inherit',
  alignItems: 'center',
  '&:focus': {
    color: (theme.vars || theme).palette.text.secondary
  },
  '&:hover': {
    color: (theme.vars || theme).palette.text.secondary,
    [`& .${tableSortLabelClasses$1.icon}`]: {
      opacity: 0.5
    }
  },
  [`&.${tableSortLabelClasses$1.active}`]: {
    color: (theme.vars || theme).palette.text.primary,
    [`& .${tableSortLabelClasses$1.icon}`]: {
      opacity: 1,
      color: (theme.vars || theme).palette.text.secondary
    }
  }
}));
const TableSortLabelIcon = styled$1('span', {
  name: 'MuiTableSortLabel',
  slot: 'Icon',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    return [styles.icon, styles[`iconDirection${capitalize(ownerState.direction)}`]];
  }
})(({
  theme,
  ownerState
}) => _extends$1({
  fontSize: 18,
  marginRight: 4,
  marginLeft: 4,
  opacity: 0,
  transition: theme.transitions.create(['opacity', 'transform'], {
    duration: theme.transitions.duration.shorter
  }),
  userSelect: 'none'
}, ownerState.direction === 'desc' && {
  transform: 'rotate(0deg)'
}, ownerState.direction === 'asc' && {
  transform: 'rotate(180deg)'
}));

/**
 * A button based label for placing inside `TableCell` for column sorting.
 */
const TableSortLabel = /*#__PURE__*/React__namespace.forwardRef(function TableSortLabel(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiTableSortLabel'
  });
  const {
      active = false,
      children,
      className,
      direction = 'asc',
      hideSortIcon = false,
      IconComponent = ArrowDownwardIcon
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$8);
  const ownerState = _extends$1({}, props, {
    active,
    direction,
    hideSortIcon,
    IconComponent
  });
  const classes = useUtilityClasses$2(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsxs(TableSortLabelRoot, _extends$1({
    className: clsx(classes.root, className),
    component: "span",
    disableRipple: true,
    ownerState: ownerState,
    ref: ref
  }, other, {
    children: [children, hideSortIcon && !active ? null : /*#__PURE__*/jsxRuntimeExports.jsx(TableSortLabelIcon, {
      as: IconComponent,
      className: clsx(classes.icon),
      ownerState: ownerState
    })]
  }));
});
browser$1.env.NODE_ENV !== "production" ? TableSortLabel.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * If `true`, the label will have the active styling (should be true for the sorted column).
   * @default false
   */
  active: propTypesExports.bool,
  /**
   * Label contents, the arrow will be appended automatically.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * The current sort direction.
   * @default 'asc'
   */
  direction: propTypesExports.oneOf(['asc', 'desc']),
  /**
   * Hide sort icon when active is false.
   * @default false
   */
  hideSortIcon: propTypesExports.bool,
  /**
   * Sort icon to use.
   * @default ArrowDownwardIcon
   */
  IconComponent: propTypesExports.elementType,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var TableSortLabel$1 = TableSortLabel;

function TableRowHeaderCell(_ref) {
  var isFirstCell = _ref.isFirstCell,
    headerCell = _ref.headerCell;
  var _useBulkTableActions = useBulkTableActions(),
    clearSelectedRows = _useBulkTableActions.clearSelectedRows;
  var _useTable = useTable(),
    orderByDir = _useTable.orderByDir,
    setOrder = _useTable.setOrder,
    orderBy = _useTable.orderBy,
    setOrderBy = _useTable.setOrderBy,
    rowsPerPage = _useTable.rowsPerPage,
    page = _useTable.page,
    searchKeyword = _useTable.searchKeyword,
    onTableArgsChange = _useTable.onTableArgsChange;
  var isCurrentOrderBy = orderBy === headerCell.id;
  var sortLabel = getSortLabel({
    orderByDir: orderByDir
  });
  return /*#__PURE__*/React__namespace.createElement(StyledTableCell$1, {
    isFirstCell: isFirstCell,
    align: "left",
    padding: "normal",
    sortDirection: isCurrentOrderBy ? orderByDir : false
  }, /*#__PURE__*/React__namespace.createElement(StyledLabel, {
    active: isCurrentOrderBy,
    direction: isCurrentOrderBy ? orderByDir : SORT.ASC,
    "data-testid": headerCell.testId,
    onClick: function onClick() {
      return handleRequestSort({
        newOrderBy: headerCell.id,
        orderBy: orderBy,
        orderByDir: orderByDir,
        setOrder: setOrder,
        setOrderBy: setOrderBy,
        rowsPerPage: rowsPerPage,
        page: page,
        searchKeyword: searchKeyword,
        clearSelectedRows: clearSelectedRows,
        onTableArgsChange: onTableArgsChange
      });
    },
    IconComponent: default_1$b,
    headerCell: headerCell,
    disabled: headerCell.shouldNotSort
  }, /*#__PURE__*/React__namespace.createElement(TableRowHeaderLabel, null, headerCell.label), isCurrentOrderBy && /*#__PURE__*/React__namespace.createElement(Box$1, {
    component: "span",
    sx: visuallyHidden$1
  }, sortLabel)));
}
TableRowHeaderCell.propTypes = {
  isFirstCell: propTypesExports.bool,
  headerCell: propTypesExports.object
};
var TableRowHeaderLabel = styled__default.default(Typography$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    color: theme.palette.text.secondary,
    fontSize: theme.typography.body2.fontSize
  };
});
var StyledTableCell$1 = styled__default.default(TableCell$2, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref3) {
  var theme = _ref3.theme,
    isFirstCell = _ref3.isFirstCell;
  return {
    paddingLeft: isFirstCell && 30,
    borderColor: theme.palette.card.divider
  };
});
var StyledLabel = styled__default.default(TableSortLabel$1, {
  shouldForwardProp: function shouldForwardProp(prop) {
    return prop !== "headerCell";
  }
})({
  ".MuiTableSortLabel-icon": {
    height: 25,
    width: 25
  }
});
function handleRequestSort(_ref4) {
  var newOrderBy = _ref4.newOrderBy,
    orderBy = _ref4.orderBy,
    orderByDir = _ref4.orderByDir,
    setOrder = _ref4.setOrder,
    setOrderBy = _ref4.setOrderBy,
    rowsPerPage = _ref4.rowsPerPage,
    page = _ref4.page,
    searchKeyword = _ref4.searchKeyword,
    clearSelectedRows = _ref4.clearSelectedRows,
    onTableArgsChange = _ref4.onTableArgsChange;
  var isAsc = orderBy === newOrderBy && orderByDir === SORT.ASC;
  var newOrderByDir = isAsc ? SORT.DESC : SORT.ASC;
  var sortedBy = {
    by: newOrderBy,
    order: newOrderByDir
  };
  setOrder(newOrderByDir);
  setOrderBy(newOrderBy);
  clearSelectedRows();
  onTableArgsChange({
    rowsPerPage: rowsPerPage,
    page: page,
    sortedBy: sortedBy,
    searchKeyword: searchKeyword
  });
}
function getSortLabel(_ref5) {
  var orderByDir = _ref5.orderByDir;
  return orderByDir === SORT.DESC ? "sorted descending" : "sorted ascending";
}

function TableRowHeader(_ref) {
  var headerCells = _ref.headerCells,
    hasMobileList = _ref.hasMobileList;
  var _useScreenSize = useScreenSize(),
    isSmScreen = _useScreenSize.isSmScreen;
  var _useTable = useTable(),
    hasActions = _useTable.hasActions;
  var _useBulkTableActions = useBulkTableActions(),
    allowBulkActions = _useBulkTableActions.allowBulkActions,
    onSelectAllChange = _useBulkTableActions.onSelectAllChange,
    isSelectAllSelected = _useBulkTableActions.isSelectAllSelected;

  // Hide table row header if mobileList provided to table for small screens
  if (hasMobileList && isSmScreen) return null;
  return /*#__PURE__*/React__namespace.createElement(StyledTableHead, null, /*#__PURE__*/React__namespace.createElement(TableRow$2, null, allowBulkActions && /*#__PURE__*/React__namespace.createElement(TableCheckboxCell, {
    value: isSelectAllSelected,
    onChange: onSelectAllChange,
    isSelectAll: true
  }), headerCells === null || headerCells === void 0 ? void 0 : headerCells.map(function (headerCell, i) {
    return /*#__PURE__*/React__namespace.createElement(TableRowHeaderCell, {
      key: headerCell.id,
      isFirstCell: i === 0,
      headerCell: headerCell
    });
  }), hasActions && /*#__PURE__*/React__namespace.createElement(StyledTableCell, {
    align: "right",
    padding: "normal"
  }, /*#__PURE__*/React__namespace.createElement(ActionRowHeaderLabel, {
    hasActionHeader: true
  }, "Action"))));
}
TableRowHeader.propTypes = {
  headerCells: propTypesExports.array,
  hasMobileList: propTypesExports.bool
};
var StyledTableHead = styled__default.default(TableHead$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    // backgroundImage linear-gradient allows sticky header be same color as card in dark mode
    "& .MuiTableCell-head": {
      backgroundColor: theme.palette.card.background
    }
  };
});
var ActionRowHeaderLabel = styled__default.default(Typography$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref3) {
  var theme = _ref3.theme;
  return {
    color: theme.palette.text.secondary,
    fontSize: theme.typography.body2.fontSize,
    marginLeft: theme.spacing(1)
  };
});
var StyledTableCell = styled__default.default(TableCell$2)(function (_ref4) {
  var theme = _ref4.theme;
  return {
    paddingRight: "30px",
    borderColor: theme.palette.card.divider
  };
});

var SHORT_TABLE_HEIGHT = 400;
function TableContent(_ref) {
  var onRetry = _ref.onRetry,
    error = _ref.error,
    isLoading = _ref.isLoading,
    isSearchable = _ref.isSearchable,
    addEntry = _ref.addEntry,
    title = _ref.title,
    emptyTitle = _ref.emptyTitle,
    headerCells = _ref.headerCells,
    isShortend = _ref.isShortend,
    cellConfigs = _ref.cellConfigs,
    mobileList = _ref.mobileList,
    keyBy = _ref.keyBy,
    hideTablePagination = _ref.hideTablePagination,
    onRowClick = _ref.onRowClick,
    renderAdditionalHeaderContent = _ref.renderAdditionalHeaderContent,
    onDownloadClick = _ref.onDownloadClick,
    rowsPerPageOptions = _ref.rowsPerPageOptions;
  var _useTable = useTable(),
    page = _useTable.page,
    rowsPerPage = _useTable.rowsPerPage,
    searchKeyword = _useTable.searchKeyword,
    sortedBy = _useTable.sortedBy,
    total = _useTable.total,
    onTableArgsChange = _useTable.onTableArgsChange;

  // Call onTableArgsChange on mount to initialize external state.
  React.useEffect(function () {
    onTableArgsChange({
      rowsPerPage: rowsPerPage,
      page: page,
      sortedBy: sortedBy,
      searchKeyword: searchKeyword
    });
  }, []);
  if (error) {
    return /*#__PURE__*/React__namespace.default.createElement(TableError, {
      onRetry: onRetry,
      error: error
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(TableContainer$1, {
    "data-testid": TABLES.BASIC
  }, /*#__PURE__*/React__namespace.default.createElement(TableHeader, {
    headerTitle: total !== 0 ? title : emptyTitle,
    addEntry: addEntry,
    isSearchable: isSearchable,
    renderAdditionalContent: renderAdditionalHeaderContent,
    onDownloadClick: onDownloadClick
  }), /*#__PURE__*/React__namespace.default.createElement(StyledTableContainer, {
    isShortend: isShortend
  }, /*#__PURE__*/React__namespace.default.createElement(TableOG, {
    stickyHeader: true
  }, /*#__PURE__*/React__namespace.default.createElement(TableRowHeader, {
    headerCells: headerCells,
    hasMobileList: !!mobileList
  }), /*#__PURE__*/React__namespace.default.createElement(TableBody, {
    isShortend: isShortend,
    keyBy: keyBy,
    isLoading: isLoading,
    cellConfigs: cellConfigs,
    mobileList: mobileList,
    onRowClick: onRowClick
  }))), /*#__PURE__*/React__namespace.default.createElement(TablePagination, {
    total: total,
    hide: hideTablePagination,
    rowsPerPageOptions: rowsPerPageOptions
  }));
}
TableContent.propTypes = {
  onRetry: propTypesExports.func,
  error: propTypesExports.object,
  isLoading: propTypesExports.bool,
  total: propTypesExports.number,
  isSearchable: propTypesExports.bool,
  addEntry: propTypesExports.func,
  title: propTypesExports.string,
  emptyTitle: propTypesExports.string,
  headerCells: propTypesExports.array,
  isShortend: propTypesExports.bool,
  cellConfigs: propTypesExports.array,
  mobileList: propTypesExports.node,
  keyBy: propTypesExports.string,
  hideTablePagination: propTypesExports.bool,
  onRowClick: propTypesExports.func,
  renderAdditionalHeaderContent: propTypesExports.func,
  onDownloadClick: propTypesExports.func,
  rowsPerPageOptions: propTypesExports.arrayOf(propTypesExports.number)
};
var StyledTableContainer = styled__default.default(TableContainerOG, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref2) {
  var isShortend = _ref2.isShortend;
  return {
    maxHeight: isShortend && SHORT_TABLE_HEIGHT
  };
});

function Table(_ref) {
  var onTableArgsChange = _ref.onTableArgsChange,
    onRetry = _ref.onRetry,
    error = _ref.error,
    isLoading = _ref.isLoading,
    total = _ref.total,
    isSearchable = _ref.isSearchable,
    addEntry = _ref.addEntry,
    title = _ref.title,
    emptyTitle = _ref.emptyTitle,
    headerCells = _ref.headerCells,
    isShortend = _ref.isShortend,
    rows = _ref.rows,
    cellConfigs = _ref.cellConfigs,
    mobileList = _ref.mobileList,
    keyBy = _ref.keyBy,
    actions = _ref.actions,
    hideTablePagination = _ref.hideTablePagination,
    onRowClick = _ref.onRowClick,
    renderAdditionalHeaderContent = _ref.renderAdditionalHeaderContent,
    onDownloadClick = _ref.onDownloadClick,
    _ref$initSortOrder = _ref.initSortOrder,
    initSortOrder = _ref$initSortOrder === void 0 ? DEFAULT_SORT.order : _ref$initSortOrder,
    _ref$initSortBy = _ref.initSortBy,
    initSortBy = _ref$initSortBy === void 0 ? DEFAULT_SORT.by : _ref$initSortBy,
    _ref$initPage = _ref.initPage,
    initPage = _ref$initPage === void 0 ? 0 : _ref$initPage,
    initRowsPerPage = _ref.initRowsPerPage,
    _ref$initSearchKeywor = _ref.initSearchKeyword,
    initSearchKeyword = _ref$initSearchKeywor === void 0 ? null : _ref$initSearchKeywor,
    _ref$rowsPerPageOptio = _ref.rowsPerPageOptions,
    rowsPerPageOptions = _ref$rowsPerPageOptio === void 0 ? [] : _ref$rowsPerPageOptio,
    allowBulkActions = _ref.allowBulkActions,
    bulkActionButtonConfigs = _ref.bulkActionButtonConfigs;
  return /*#__PURE__*/React__namespace.default.createElement(TableProvider, {
    initSortOrder: initSortOrder,
    initSortBy: initSortBy,
    initPage: initPage,
    initSearchKeyword: initSearchKeyword,
    initRowsPerPage: initRowsPerPage,
    rows: rows,
    actions: actions,
    total: total,
    keyBy: keyBy,
    allowBulkActions: allowBulkActions,
    bulkActionButtonConfigs: bulkActionButtonConfigs,
    onTableArgsChange: onTableArgsChange
  }, /*#__PURE__*/React__namespace.default.createElement(TableContent, {
    onRetry: onRetry,
    error: error,
    isLoading: isLoading,
    isSearchable: isSearchable,
    addEntry: addEntry,
    title: title,
    emptyTitle: emptyTitle,
    headerCells: headerCells,
    isShortend: isShortend,
    cellConfigs: cellConfigs,
    mobileList: mobileList,
    keyBy: keyBy,
    hideTablePagination: hideTablePagination,
    onRowClick: onRowClick,
    renderAdditionalHeaderContent: renderAdditionalHeaderContent,
    onDownloadClick: onDownloadClick,
    initSearchKeyword: initSearchKeyword,
    rowsPerPageOptions: rowsPerPageOptions
  }));
}
Table.propTypes = {
  onTableArgsChange: propTypesExports.func,
  onRetry: propTypesExports.func,
  error: propTypesExports.object,
  isLoading: propTypesExports.bool,
  total: propTypesExports.number,
  isSearchable: propTypesExports.bool,
  addEntry: propTypesExports.func,
  title: propTypesExports.string,
  emptyTitle: propTypesExports.string,
  headerCells: propTypesExports.array,
  isShortend: propTypesExports.bool,
  rows: propTypesExports.array,
  cellConfigs: propTypesExports.array,
  mobileList: propTypesExports.node,
  keyBy: propTypesExports.string,
  actions: propTypesExports.array,
  hideTablePagination: propTypesExports.bool,
  onRowClick: propTypesExports.func,
  initSortOrder: propTypesExports.string,
  initSortBy: propTypesExports.string,
  renderAdditionalHeaderContent: propTypesExports.func,
  onDownloadClick: propTypesExports.func,
  initPage: propTypesExports.number,
  initSearchKeyword: propTypesExports.string,
  initRowsPerPage: propTypesExports.number,
  rowsPerPageOptions: propTypesExports.arrayOf(propTypesExports.number),
  allowBulkActions: propTypesExports.bool,
  bulkActionButtonConfigs: propTypesExports.arrayOf(propTypesExports.shape({
    Icon: propTypesExports.elementType,
    label: propTypesExports.string,
    onClick: propTypesExports.func.isRequired,
    isLoading: propTypesExports.bool
  }))
};

function FormsTable(_ref) {
  var onFormClick = _ref.onFormClick;
  var _useState = React.useState({}),
    _useState2 = _slicedToArray(_useState, 2),
    formsQueryArgs = _useState2[0],
    setFormsQueryArgs = _useState2[1];
  var _useForms = useForms(),
    useGetForms = _useForms.useGetForms,
    companyId = _useForms.companyId;
  var _useGetForms = useGetForms(_objectSpread2({
      companyId: companyId
    }, formsQueryArgs)),
    forms = _useGetForms.forms,
    isLoading = _useGetForms.isLoading,
    error = _useGetForms.error,
    refetch = _useGetForms.refetch,
    total = _useGetForms.total;
  var title = total ? "".concat(total, " Forms") : "";
  return /*#__PURE__*/React__namespace.default.createElement(Table, {
    onTableArgsChange: setFormsQueryArgs,
    onRetry: refetch,
    error: error,
    isLoading: isLoading,
    total: total,
    isSearchable: true,
    title: title,
    emptyTitle: "No Forms",
    rows: forms,
    cellConfigs: getCellConfigs$1(),
    onRowClick: function onRowClick(_ref2) {
      var row = _ref2.row;
      return onFormClick(row);
    }
  });
}
FormsTable.propTypes = {
  onFormClick: propTypesExports.func.isRequired
};
function getCellConfigs$1() {
  return [{
    path: "title"
  }];
}

function FormBuilderExistingFormSelector(_ref) {
  var onFormSelected = _ref.onFormSelected,
    onBackClick = _ref.onBackClick;
  return /*#__PURE__*/React__namespace.default.createElement(Container$d, null, /*#__PURE__*/React__namespace.default.createElement(TableContainer, null, /*#__PURE__*/React__namespace.default.createElement(FormsTable, {
    onFormClick: onFormSelected
  })), /*#__PURE__*/React__namespace.default.createElement(ButtonContainer$1, null, /*#__PURE__*/React__namespace.default.createElement(Button, {
    variant: "outlined",
    onClick: function onClick() {
      return onBackClick();
    }
  }, "Back")));
}
FormBuilderExistingFormSelector.propTypes = {
  onFormSelected: propTypesExports.func.isRequired,
  onBackClick: propTypesExports.func.isRequired
};
var Container$d = styled__default.default(Box$1)({
  height: "calc(100vh - ".concat(FORM_BUILDER_MODAL_HEIGHT_OFFSET, ")"),
  display: "flex",
  flexDirection: "column",
  justifyContent: "space-between",
  alignItems: "stretch",
  padding: "0 20px 20px"
});
var TableContainer = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    borderRadius: theme.borderRadius.lg,
    padding: "0 20px 20px",
    flex: 1,
    backgroundColor: theme.palette.background["default"],
    overflowY: "auto"
  };
});
var ButtonContainer$1 = styled__default.default(Box$1)({
  textAlign: "right",
  marginTop: "20px"
});

var AddRounded = {};

var _interopRequireDefault$a = interopRequireDefaultExports;
Object.defineProperty(AddRounded, "__esModule", {
  value: true
});
var default_1$a = AddRounded.default = void 0;
var _createSvgIcon$a = _interopRequireDefault$a(requireCreateSvgIcon());
var _jsxRuntime$a = requireJsxRuntime();
var _default$a = (0, _createSvgIcon$a.default)( /*#__PURE__*/(0, _jsxRuntime$a.jsx)("path", {
  d: "M18 13h-5v5c0 .55-.45 1-1 1s-1-.45-1-1v-5H6c-.55 0-1-.45-1-1s.45-1 1-1h5V6c0-.55.45-1 1-1s1 .45 1 1v5h5c.55 0 1 .45 1 1s-.45 1-1 1z"
}), 'AddRounded');
default_1$a = AddRounded.default = _default$a;

function getCardUtilityClass(slot) {
  return generateUtilityClass('MuiCard', slot);
}
generateUtilityClasses('MuiCard', ['root']);

const _excluded$7 = ["className", "raised"];
const useUtilityClasses$1 = ownerState => {
  const {
    classes
  } = ownerState;
  const slots = {
    root: ['root']
  };
  return composeClasses(slots, getCardUtilityClass, classes);
};
const CardRoot = styled$1(Paper$1, {
  name: 'MuiCard',
  slot: 'Root',
  overridesResolver: (props, styles) => styles.root
})(() => {
  return {
    overflow: 'hidden'
  };
});
const Card = /*#__PURE__*/React__namespace.forwardRef(function Card(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiCard'
  });
  const {
      className,
      raised = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$7);
  const ownerState = _extends$1({}, props, {
    raised
  });
  const classes = useUtilityClasses$1(ownerState);
  return /*#__PURE__*/jsxRuntimeExports.jsx(CardRoot, _extends$1({
    className: clsx(classes.root, className),
    elevation: raised ? 8 : undefined,
    ref: ref,
    ownerState: ownerState
  }, other));
});
browser$1.env.NODE_ENV !== "production" ? Card.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The content of the component.
   */
  children: propTypesExports.node,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * If `true`, the card will use raised styling.
   * @default false
   */
  raised: chainPropTypes(propTypesExports.bool, props => {
    if (props.raised && props.variant === 'outlined') {
      return new Error('MUI: Combining `raised={true}` with `variant="outlined"` has no effect.');
    }
    return null;
  }),
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object])
} : void 0;
var Card$1 = Card;

function OptionCard(_ref) {
  var Icon = _ref.Icon,
    title = _ref.title,
    description = _ref.description,
    _onClick = _ref.onClick;
  return /*#__PURE__*/React__namespace.default.createElement(CardContainer, null, /*#__PURE__*/React__namespace.default.createElement(Icon, {
    sx: {
      fontSize: 50
    }
  }), /*#__PURE__*/React__namespace.default.createElement(Title$1, {
    variant: "h5"
  }, title), /*#__PURE__*/React__namespace.default.createElement(Description, {
    variant: "subtitle2"
  }, description), /*#__PURE__*/React__namespace.default.createElement(ChooseButton, {
    variant: "outlined",
    onClick: function onClick() {
      return _onClick();
    }
  }, "Choose"));
}
OptionCard.propTypes = {
  Icon: propTypesExports.elementType.isRequired,
  title: propTypesExports.string,
  description: propTypesExports.string,
  onClick: propTypesExports.func.isRequired
};
var CardContainer = styled__default.default(Card$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: "flex",
    flexDirection: "column",
    maxWidth: "250px",
    alignSelf: "stretch",
    padding: "20px",
    backgroundColor: theme.palette.card.background,
    borderRadius: theme.borderRadius.sm,
    flex: 1
  };
});
var Title$1 = styled__default.default(Typography$1)({
  margin: "15px 0 10px 0"
});
var Description = styled__default.default(Typography$1)({
  flex: 1,
  alignSelf: "flex-start",
  marginBottom: "30px",
  fontSize: "13px"
});
var ChooseButton = styled__default.default(Button)(function (_ref3) {
  var theme = _ref3.theme;
  return {
    borderRadius: theme.borderRadius.sm,
    textTransform: "none",
    alignSelf: "flex-start",
    fontWeight: "normal",
    padding: "4px 20px !important"
  };
});

function OptionCardsSelector(_ref) {
  var className = _ref.className,
    options = _ref.options;
  return /*#__PURE__*/React__namespace.default.createElement(Container$c, {
    className: className
  }, options.map(function (option) {
    return /*#__PURE__*/React__namespace.default.createElement(OptionCard, _extends$2({
      key: option.title
    }, option));
  }));
}
OptionCardsSelector.propTypes = {
  className: propTypesExports.string,
  options: propTypesExports.arrayOf(propTypesExports.shape({
    Icon: propTypesExports.elementType.isRequired,
    title: propTypesExports.string,
    description: propTypesExports.string,
    onClick: propTypesExports.func.isRequired
  })).isRequired
};
var Container$c = styled__default.default(Box$1)({
  width: "100%",
  display: "flex",
  justifyContent: "center",
  alignItems: "center",
  flexWrap: "wrap",
  gap: 20
});

function FormBuilderWelcome(_ref) {
  var onOptionSelected = _ref.onOptionSelected;
  var options = getOptions({
    onOptionSelected: onOptionSelected
  });
  return /*#__PURE__*/React__namespace.default.createElement(Container$b, null, /*#__PURE__*/React__namespace.default.createElement(StyledOptionsSelector, {
    options: options
  }));
}
FormBuilderWelcome.propTypes = {
  onOptionSelected: propTypesExports.func.isRequired
};
var Container$b = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return _defineProperty({
    height: "calc(100vh - ".concat(FORM_BUILDER_MODAL_HEIGHT_OFFSET, ")"),
    backgroundColor: theme.palette.background["default"],
    display: "flex",
    flexDirection: "column",
    justifyContent: "center",
    alignItems: "center",
    borderRadius: theme.borderRadius.lg
  }, theme.breakpoints.down("sm"), {
    height: "calc(100vh - 80px)"
  });
});
var StyledOptionsSelector = styled__default.default(OptionCardsSelector)({
  padding: "20px"
});
function getOptions(_ref4) {
  var onOptionSelected = _ref4.onOptionSelected;
  return [{
    Icon: default_1$a,
    title: "Start from scratch",
    description: "Start building your custom form.",
    onClick: function onClick() {
      return onOptionSelected({
        step: FORM_BUILDER_MODAL_STEP_NAMES.FORM_BUILDER,
        form: null
      });
    }
  }, {
    Icon: default_1$v,
    title: "Connect existing form",
    description: "Collect and connect submissions across multiple cards and projects.",
    onClick: function onClick() {
      return onOptionSelected({
        step: FORM_BUILDER_MODAL_STEP_NAMES.SELECT_FORM
      });
    }
  }];
}

function CreateOrSelectFormFlow(_ref) {
  var currentStep = _ref.currentStep,
    onCurrentStepChange = _ref.onCurrentStepChange,
    form = _ref.form,
    onCompleted = _ref.onCompleted;
  var goToSelectOptionStep = function goToSelectOptionStep() {
    return onCurrentStepChange({
      step: FORM_BUILDER_MODAL_STEP_NAMES.SELECT_OPTION
    });
  };
  if (currentStep === FORM_BUILDER_MODAL_STEP_NAMES.FORM_BUILDER) {
    return /*#__PURE__*/React__namespace.default.createElement(FormBuilder, {
      form: form,
      onCompleted: onCompleted,
      onBackClick: goToSelectOptionStep
    });
  }
  if (currentStep === FORM_BUILDER_MODAL_STEP_NAMES.SELECT_FORM) {
    return /*#__PURE__*/React__namespace.default.createElement(FormBuilderExistingFormSelector, {
      onFormSelected: onCompleted,
      onBackClick: goToSelectOptionStep
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(FormBuilderWelcome, {
    onOptionSelected: onCurrentStepChange
  });
}
CreateOrSelectFormFlow.propTypes = {
  currentStep: propTypesExports.string.isRequired,
  onCurrentStepChange: propTypesExports.func.isRequired,
  form: propTypesExports.object,
  onCompleted: propTypesExports.func.isRequired
};

function FormBuilderModal(_ref) {
  var isOpen = _ref.isOpen,
    _onClose = _ref.onClose,
    initialForm = _ref.form,
    onFormSelected = _ref.onFormSelected;
  var startingStep = initialForm ? FORM_BUILDER_MODAL_STEP_NAMES.FORM_BUILDER : FORM_BUILDER_MODAL_STEP_NAMES.SELECT_OPTION;
  var title = initialForm ? "Edit form" : "Create a form";
  var _useState = React.useState(startingStep),
    _useState2 = _slicedToArray(_useState, 2),
    currentStep = _useState2[0],
    setCurrentStep = _useState2[1];
  var _useState3 = React.useState(initialForm),
    _useState4 = _slicedToArray(_useState3, 2),
    selectedForm = _useState4[0],
    setSelectedForm = _useState4[1];
  React.useEffect(function () {
    setCurrentStep(startingStep);
    setSelectedForm(initialForm);
  }, [startingStep, initialForm]);
  return /*#__PURE__*/React__namespace.default.createElement(StyledModal$1, {
    width: "95%",
    isOpen: isOpen,
    onClose: function onClose() {
      _onClose();
      setCurrentStep(startingStep);
    }
  }, /*#__PURE__*/React__namespace.default.createElement(Title, {
    variant: "h4"
  }, title), /*#__PURE__*/React__namespace.default.createElement(CreateOrSelectFormFlow, {
    currentStep: currentStep,
    onCurrentStepChange: function onCurrentStepChange(_ref2) {
      var step = _ref2.step,
        form = _ref2.form;
      return handleCurrentStepChange({
        step: step,
        form: form,
        setCurrentStep: setCurrentStep,
        setSelectedForm: setSelectedForm
      });
    },
    form: selectedForm,
    onCompleted: function onCompleted(form) {
      onFormSelected(form);
      _onClose();
    }
  }));
}
FormBuilderModal.propTypes = {
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  form: propTypesExports.object,
  onFormSelected: propTypesExports.func.isRequired
};
var StyledModal$1 = styled__default.default(Modal)({
  maxWidth: "900px"
});
var Title = styled__default.default(Typography$1)(function (_ref3) {
  var theme = _ref3.theme;
  return _defineProperty({
    margin: "-15px 20px 20px"
  }, theme.breakpoints.down("sm"), {
    margin: "-25px 20px 20px"
  });
});
function handleCurrentStepChange(_ref5) {
  var step = _ref5.step,
    form = _ref5.form,
    setCurrentStep = _ref5.setCurrentStep,
    setSelectedForm = _ref5.setSelectedForm;
  if (step === FORM_BUILDER_MODAL_STEP_NAMES.FORM_BUILDER) {
    setSelectedForm(form);
  }
  setCurrentStep(step);
}

function FormBuilderInput(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange,
    validationMessage = _ref.validationMessage;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isModalOpen = _useState2[0],
    setIsModalOpen = _useState2[1];
  var form = value === null || value === void 0 ? void 0 : value.form;
  return /*#__PURE__*/React__namespace.default.createElement(CollapsibleProvider, null, /*#__PURE__*/React__namespace.default.createElement(Container$a, null, form ? /*#__PURE__*/React__namespace.default.createElement(FormBuilderInputPreview, {
    form: form,
    onEditClick: function onEditClick() {
      return setIsModalOpen(true);
    },
    onDeleteClick: function onDeleteClick() {
      return onChange(_objectSpread2(_objectSpread2({}, value), {}, {
        url: null,
        form: null
      }));
    }
  }) : /*#__PURE__*/React__namespace.default.createElement(AddFormButton, {
    onClick: function onClick() {
      return setIsModalOpen(true);
    },
    label: "Add a form",
    Icon: default_1$z
  }), /*#__PURE__*/React__namespace.default.createElement(ErrorMessageContainer, null, /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    validationMessage: validationMessage
  }))), /*#__PURE__*/React__namespace.default.createElement(FormBuilderModal, {
    form: form,
    isOpen: isModalOpen,
    onClose: function onClose() {
      return setIsModalOpen(false);
    },
    onFormSelected: function onFormSelected(newForm) {
      return onChange(_objectSpread2(_objectSpread2({}, value), {}, {
        url: newForm.id,
        form: newForm
      }));
    }
  }));
}
FormBuilderInput.propTypes = {
  value: propTypesExports.shape({
    url: propTypesExports.string,
    form: propTypesExports.object
  }),
  onChange: propTypesExports.func,
  validationMessage: propTypesExports.string
};
var Container$a = styled__default.default(Box$1)({
  display: "flex",
  flexDirection: "column",
  justifyContent: "center",
  width: "100%"
});
var AddFormButton = styled__default.default(IconTextButton)({
  alignSelf: "flex-start"
});
var ErrorMessageContainer = styled__default.default(Box$1)({
  margin: "0 10px"
});

var _excluded$6 = ["id", "sectionIndex", "blockIndex"];
function FormInput(_ref) {
  var id = _ref.id,
    sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    props = _objectWithoutProperties(_ref, _excluded$6);
  var makeInputPath = useMakeInputPath();
  var path = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex
  });
  return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, _extends$2({
    id: id,
    path: path,
    Component: FormBuilderInput
  }, props));
}
FormInput.propTypes = {
  id: propTypesExports.string,
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired
};

function PdfUploadInput(_ref) {
  var id = _ref.id,
    value = _ref.value,
    validationMessage = _ref.validationMessage,
    onChange = _ref.onChange,
    title = _ref.title,
    ContainerComponent = _ref.ContainerComponent,
    _ref$EmptyComponent = _ref.EmptyComponent,
    EmptyComponent = _ref$EmptyComponent === void 0 ? UploadPdfPreview : _ref$EmptyComponent;
  return /*#__PURE__*/React__namespace.default.createElement(FileUploadInput, {
    id: id,
    title: title,
    value: value,
    validationMessage: validationMessage,
    onChange: onChange,
    accept: "application/pdf",
    ContainerComponent: ContainerComponent,
    EmptyComponent: EmptyComponent,
    testId: TEST_IDS.PDF_UPLOAD_INPUT
  });
}
PdfUploadInput.propTypes = {
  id: propTypesExports.string.isRequired,
  value: propTypesExports.any,
  onChange: propTypesExports.func.isRequired,
  validationMessage: propTypesExports.string,
  title: propTypesExports.string,
  ContainerComponent: propTypesExports.elementType,
  EmptyComponent: propTypesExports.elementType
};

function PdfInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    id = _ref.id;
  var makeInputPath = useMakeInputPath();
  var path = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: "url"
  });
  return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, {
    path: path,
    Component: PdfUploadInput,
    id: id,
    EmptyComponent: ContentBlockPdfPreview
  });
}
PdfInput.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired,
  id: propTypesExports.string
};

var InputRow = styled__default.default(Box$1)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: "flex",
    flexDirection: "row",
    alignItems: "center",
    paddingBottom: 10,
    borderBottom: "1px solid ".concat(theme.palette.card.divider),
    flexWrap: "wrap"
  };
});

var Check = {};

var _interopRequireDefault$9 = interopRequireDefaultExports;
Object.defineProperty(Check, "__esModule", {
  value: true
});
var default_1$9 = Check.default = void 0;
var _createSvgIcon$9 = _interopRequireDefault$9(requireCreateSvgIcon());
var _jsxRuntime$9 = requireJsxRuntime();
var _default$9 = (0, _createSvgIcon$9.default)( /*#__PURE__*/(0, _jsxRuntime$9.jsx)("path", {
  d: "M9 16.17 4.83 12l-1.42 1.41L9 19 21 7l-1.41-1.41z"
}), 'Check');
default_1$9 = Check.default = _default$9;

var DriveEta = {};

var _interopRequireDefault$8 = interopRequireDefaultExports;
Object.defineProperty(DriveEta, "__esModule", {
  value: true
});
var default_1$8 = DriveEta.default = void 0;
var _createSvgIcon$8 = _interopRequireDefault$8(requireCreateSvgIcon());
var _jsxRuntime$8 = requireJsxRuntime();
var _default$8 = (0, _createSvgIcon$8.default)( /*#__PURE__*/(0, _jsxRuntime$8.jsx)("path", {
  d: "M18.92 5.01C18.72 4.42 18.16 4 17.5 4h-11c-.66 0-1.21.42-1.42 1.01L3 11v8c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h12v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-8l-2.08-5.99zM6.5 15c-.83 0-1.5-.67-1.5-1.5S5.67 12 6.5 12s1.5.67 1.5 1.5S7.33 15 6.5 15zm11 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM5 10l1.5-4.5h11L19 10H5z"
}), 'DriveEta');
default_1$8 = DriveEta.default = _default$8;

var _excluded$5 = ["type"];
function PillIcon(_ref) {
  var type = _ref.type,
    props = _objectWithoutProperties(_ref, _excluded$5);
  var Icon = getIcon$1(type);
  return /*#__PURE__*/React__namespace.default.createElement(Icon, props);
}
PillIcon.propTypes = {
  type: propTypesExports.oneOf(Object.values(CONTENT_BLOCK_TYPES)).isRequired
};
function getIcon$1(type) {
  switch (type) {
    case CONTENT_BLOCK_TYPES.ADDRESS:
      return default_1$8;
    case CONTENT_BLOCK_TYPES.CONTACT:
      return default_1$r;
    default:
      return default_1$9;
  }
}

function PillAvatar(_ref) {
  var type = _ref.type,
    color = _ref.color;
  var theme = useTheme$1();
  return /*#__PURE__*/React__namespace.default.createElement(StyledAvatar, {
    bgcolor: color
  }, /*#__PURE__*/React__namespace.default.createElement(PillIcon, _extends$2({
    type: type
  }, getPillIconOverrides(theme))));
}
PillAvatar.propTypes = {
  type: propTypesExports.oneOf(Object.values(CONTENT_BLOCK_TYPES)).isRequired,
  color: propTypesExports.string.isRequired
};
function getPillIconOverrides(theme) {
  var ICON_SIZE = 18;
  return {
    sx: {
      color: theme.palette.text.light,
      width: ICON_SIZE,
      height: ICON_SIZE
    }
  };
}
var StyledAvatar = styled__default.default(Avatar$2)(function (_ref2) {
  var bgcolor = _ref2.bgcolor;
  return {
    backgroundColor: bgcolor,
    width: "24px",
    height: "24px",
    marginLeft: "5px"
  };
});

var PillsContext = /*#__PURE__*/React.createContext();
var usePills = function usePills() {
  return React.useContext(PillsContext);
};
function PillsProvider(_ref) {
  var pills = _ref.pills,
    setPills = _ref.setPills,
    setLocalError = _ref.setLocalError,
    hasError = _ref.hasError,
    type = _ref.type,
    localError = _ref.localError,
    icon = _ref.icon,
    children = _ref.children;
  var title = type === CONTENT_BLOCK_TYPES.TAGS ? "Text" : "Name";
  var secondaryTitle = type === CONTENT_BLOCK_TYPES.ADDRESS ? ADDRESS_PILL_URL_NAME : CONTACT_PILL_URL_NAME;
  var hasAnyError = hasError || !!localError;
  return /*#__PURE__*/React__namespace.default.createElement(PillsContext.Provider, {
    value: {
      pills: pills,
      setPills: setPills,
      setLocalError: setLocalError,
      hasError: hasError,
      title: title,
      secondaryTitle: secondaryTitle,
      type: type,
      localError: localError,
      icon: icon,
      hasAnyError: hasAnyError
    }
  }, children);
}
PillsProvider.propTypes = {
  pills: propTypesExports.arrayOf(propTypesExports.shape({
    id: propTypesExports.string,
    color: propTypesExports.string,
    content: propTypesExports.string,
    url: propTypesExports.string,
    icon: propTypesExports.string
  })),
  setPills: propTypesExports.func.isRequired,
  setLocalError: propTypesExports.func.isRequired,
  hasError: propTypesExports.bool,
  title: propTypesExports.string,
  type: propTypesExports.string,
  localError: propTypesExports.string,
  secondaryTitle: propTypesExports.string,
  icon: propTypesExports.string,
  children: propTypesExports.any.isRequired
};

var PillContext = /*#__PURE__*/React.createContext();
var usePill = function usePill() {
  return React.useContext(PillContext);
};
function PillProvider(_ref) {
  var index = _ref.index,
    _ref$pill = _ref.pill,
    pill = _ref$pill === void 0 ? {} : _ref$pill,
    _ref$shouldToggleOutO = _ref.shouldToggleOutOfEditMode,
    shouldToggleOutOfEditMode = _ref$shouldToggleOutO === void 0 ? false : _ref$shouldToggleOutO,
    children = _ref.children;
  var _usePills = usePills(),
    type = _usePills.type,
    icon = _usePills.icon,
    setPills = _usePills.setPills;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isInEditMode = _useState2[0],
    setIsInEditMode = _useState2[1];
  var _useState3 = React.useState(pill.content || ""),
    _useState4 = _slicedToArray(_useState3, 2),
    content = _useState4[0],
    setContent = _useState4[1];
  var _useState5 = React.useState(pill.url || ""),
    _useState6 = _slicedToArray(_useState5, 2),
    url = _useState6[0],
    setUrl = _useState6[1];
  var _useState7 = React.useState(pill.color),
    _useState8 = _slicedToArray(_useState7, 2),
    color = _useState8[0],
    setColor = _useState8[1];
  var buttonLabel = isInEditMode ? SAVE : ADD;
  var setPillsAndResetValues = getSetPillsAndResetValues({
    type: type,
    index: index,
    content: content,
    url: url,
    color: color,
    icon: icon,
    setPills: setPills,
    setContent: setContent,
    setUrl: setUrl,
    setIsInEditMode: setIsInEditMode,
    shouldToggleOutOfEditMode: shouldToggleOutOfEditMode
  });
  return /*#__PURE__*/React__namespace.default.createElement(PillContext.Provider, {
    value: {
      buttonLabel: buttonLabel,
      isInEditMode: isInEditMode,
      setIsInEditMode: setIsInEditMode,
      content: content,
      url: url,
      color: color,
      setContent: setContent,
      setUrl: setUrl,
      setColor: setColor,
      index: index,
      pill: pill,
      setPillsAndResetValues: setPillsAndResetValues,
      shouldToggleOutOfEditMode: shouldToggleOutOfEditMode
    }
  }, children);
}
PillProvider.propTypes = {
  index: propTypesExports.number,
  pill: propTypesExports.shape({
    id: propTypesExports.string,
    color: propTypesExports.string,
    content: propTypesExports.string,
    url: propTypesExports.string,
    icon: propTypesExports.string
  }),
  shouldToggleOutOfEditMode: propTypesExports.bool,
  children: propTypesExports.any.isRequired
};

// Exported for tests
function getSetPillsAndResetValues(_ref2) {
  var type = _ref2.type,
    index = _ref2.index,
    content = _ref2.content,
    url = _ref2.url,
    color = _ref2.color,
    icon = _ref2.icon,
    setPills = _ref2.setPills,
    setContent = _ref2.setContent,
    setUrl = _ref2.setUrl,
    setIsInEditMode = _ref2.setIsInEditMode,
    shouldToggleOutOfEditMode = _ref2.shouldToggleOutOfEditMode;
  return function () {
    var isTag = type === CONTENT_BLOCK_TYPES.TAGS;
    var hasValues = hasInputValues({
      url: url,
      content: content,
      isTag: isTag
    });
    if (!hasValues) {
      return;
    }
    updatePillsState({
      setPills: setPills,
      index: index,
      color: color,
      content: content,
      isTag: isTag,
      url: url,
      icon: icon
    });
    resetInput({
      setContent: setContent,
      setUrl: setUrl,
      isTag: isTag
    });
    if (!shouldToggleOutOfEditMode) {
      setIsInEditMode(false);
    }
  };
}
function hasInputValues(_ref3) {
  var isTag = _ref3.isTag,
    content = _ref3.content,
    url = _ref3.url;
  // Tags should have content
  if (isTag && content) return true;

  // All other types should have content and url
  return content && url;
}
function updatePillsState(_ref4) {
  var setPills = _ref4.setPills,
    index = _ref4.index,
    color = _ref4.color,
    content = _ref4.content,
    isTag = _ref4.isTag,
    url = _ref4.url,
    icon = _ref4.icon;
  var newPill = getNewPill({
    color: color,
    content: content,
    url: url,
    icon: icon,
    isTag: isTag
  });
  setPills(function (currentPills) {
    var currentPillsCopy = _toConsumableArray(currentPills);
    // index will be present when we are editing an existing pill and need to ensure it maintains it's position in the array. For new pills index will not be present and we append the new pill to the end of the array
    if (libCommon.isNumber(index)) {
      currentPillsCopy.splice(index, 1, newPill);
      return currentPillsCopy;
    }
    return [].concat(_toConsumableArray(currentPills), [newPill]);
  });
}
function getNewPill(_ref5) {
  var color = _ref5.color,
    content = _ref5.content,
    url = _ref5.url,
    icon = _ref5.icon,
    isTag = _ref5.isTag;
  return _objectSpread2({
    id: uuid.v4(),
    color: color,
    content: content
  }, !isTag && {
    url: url,
    icon: icon
  });
}
function resetInput(_ref6) {
  var setContent = _ref6.setContent,
    setUrl = _ref6.setUrl,
    isTag = _ref6.isTag;
  setContent("");
  if (!isTag) {
    setUrl("");
  }
}

var _excluded$4 = ["style", "containerStyle", "maxCharsToAutosize", "includeBorderLeft", "inputRef"];
var CHARS_TO_PIXELS_MULTIPLIER = 5.8;
function TextAutosizeInput(_ref) {
  var _ref$style = _ref.style,
    style = _ref$style === void 0 ? {} : _ref$style,
    _ref$containerStyle = _ref.containerStyle,
    containerStyle = _ref$containerStyle === void 0 ? {} : _ref$containerStyle,
    _ref$maxCharsToAutosi = _ref.maxCharsToAutosize,
    maxCharsToAutosize = _ref$maxCharsToAutosi === void 0 ? 20 : _ref$maxCharsToAutosi,
    includeBorderLeft = _ref.includeBorderLeft,
    inputRef = _ref.inputRef,
    props = _objectWithoutProperties(_ref, _excluded$4);
  var theme = useTheme$1();
  return /*#__PURE__*/React__namespace.default.createElement(AutosizeInput__default.default, _extends$2({}, props, {
    ref: inputRef,
    inputStyle: getInputStyle({
      theme: theme,
      style: style,
      maxCharsToAutosize: maxCharsToAutosize,
      includeBorderLeft: includeBorderLeft
    }),
    style: getContainerStyle(containerStyle)
  }));
}
TextAutosizeInput.propTypes = {
  style: propTypesExports.object,
  containerStyle: propTypesExports.object,
  maxCharsToAutosize: propTypesExports.number,
  includeBorderLeft: propTypesExports.bool,
  inputRef: propTypesExports.ref
};
function getInputStyle(_ref2) {
  var theme = _ref2.theme,
    style = _ref2.style,
    maxCharsToAutosize = _ref2.maxCharsToAutosize,
    includeBorderLeft = _ref2.includeBorderLeft;
  return _objectSpread2(_objectSpread2({
    backgroundColor: theme.palette.contentBlocks.pillBackground,
    color: theme.palette.text.primary,
    fontSize: theme.typography.body1.fontSize,
    padding: "0px 10px 0px 5px",
    border: 0,
    // maxWidth based on the inputMaxChars accepted for the input
    maxWidth: maxCharsToAutosize * CHARS_TO_PIXELS_MULTIPLIER,
    marginHorizontal: 10,
    outline: "none",
    opacity: theme.palette.isDarkMode ? 1 : 0.8
  }, includeBorderLeft && {
    borderLeft: theme.borders.pillDivider
  }), style);
}
function getContainerStyle(containerStyle) {
  return _objectSpread2({
    height: "100%",
    display: "flex"
  }, containerStyle);
}

var _excluded$3 = ["value", "title", "placeholder", "validationMessage", "onChange"];
function AddressFormUrlInput(_ref) {
  var url = _ref.value,
    title = _ref.title,
    placeholder = _ref.placeholder,
    validationMessage = _ref.validationMessage,
    onChange = _ref.onChange,
    props = _objectWithoutProperties(_ref, _excluded$3);
  var _useUtils = useUtils(),
    usePlacesAutocomplete = _useUtils.usePlacesAutocomplete,
    getAddress = _useUtils.getAddress;
  var inputRef = React.useRef();
  var _usePlacesAutocomplet = usePlacesAutocomplete(),
    ready = _usePlacesAutocomplet.ready,
    value = _usePlacesAutocomplet.value,
    _usePlacesAutocomplet2 = _usePlacesAutocomplet.suggestions,
    status = _usePlacesAutocomplet2.status,
    data = _usePlacesAutocomplet2.data,
    setValue = _usePlacesAutocomplet.setValue,
    clearSuggestions = _usePlacesAutocomplet.clearSuggestions;
  var shouldShowMenu = status === OK;
  var handleInput = function handleInput(e) {
    var newValue = e.target.value || "";
    // If the user entered a url directly skip url detection and use that
    if (startsWithProtocol(newValue)) {
      handleOnChange$1({
        onChange: onChange,
        value: newValue
      });
      // When user selects a place, we can replace the keyword without request data from API
      // by setting the second parameter to "false"
      // https://github.com/wellyshen/use-places-autocomplete#return-object
      setValue(newValue, false);
      return;
    }

    // If the value is being unset update the form state
    if (newValue === "") {
      handleOnChange$1({
        onChange: onChange,
        value: newValue
      });
    }

    // Use usePlacesAutocomplete to get the url based on the current text value
    setValue(newValue);
  };
  React.useEffect(function () {
    if (!url) {
      // Clear the value if url is unset so we stay synced with form state
      setValue("");
    }
  }, [url]);
  var handleSelect = function handleSelect(googleData) {
    return function () {
      // focus on input so onBlur error will show once user clicks away from input
      inputRef.current.focus();
      mapGoogleDataToUrlAndFireOnChange({
        googleData: googleData,
        setValue: setValue,
        clearSuggestions: clearSuggestions,
        onChange: onChange,
        getAddress: getAddress
      });
    };
  };
  return /*#__PURE__*/React__namespace.default.createElement(AddressInputContent, _extends$2({
    value: value || url,
    title: title,
    label: placeholder,
    validationMessage: validationMessage,
    shouldShowMenu: shouldShowMenu,
    inputRef: inputRef,
    data: data,
    ready: ready,
    handleSelect: handleSelect,
    handleInput: handleInput,
    TextComponent: TextAutosizeInput
  }, props));
}
function mapGoogleDataToUrlAndFireOnChange(_x) {
  return _mapGoogleDataToUrlAndFireOnChange.apply(this, arguments);
} // TODO: Move to lib-common: https://gitlab.com/revved/boomnation/lib-common/-/issues/5
function _mapGoogleDataToUrlAndFireOnChange() {
  _mapGoogleDataToUrlAndFireOnChange = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref2) {
    var googleData, setValue, clearSuggestions, onChange, getAddress, description, placeId, _yield$getAddress, url;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          googleData = _ref2.googleData, setValue = _ref2.setValue, clearSuggestions = _ref2.clearSuggestions, onChange = _ref2.onChange, getAddress = _ref2.getAddress;
          setValue(googleData.description, false);
          clearSuggestions();
          _context.prev = 3;
          description = googleData.description, placeId = googleData.place_id;
          _context.next = 7;
          return getAddress({
            description: description,
            placeId: placeId
          });
        case 7:
          _yield$getAddress = _context.sent;
          url = _yield$getAddress.url;
          handleOnChange$1({
            onChange: onChange,
            value: url
          });
          _context.next = 15;
          break;
        case 12:
          _context.prev = 12;
          _context.t0 = _context["catch"](3);
          handleOnChange$1({
            onChange: onChange,
            value: ""
          });
        case 15:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[3, 12]]);
  }));
  return _mapGoogleDataToUrlAndFireOnChange.apply(this, arguments);
}
function startsWithProtocol(value) {
  return value.startsWith("http");
}
function handleOnChange$1(_ref3) {
  var onChange = _ref3.onChange,
    value = _ref3.value;
  onChange({
    target: {
      value: value
    }
  });
}
AddressFormUrlInput.propTypes = {
  value: propTypesExports.string,
  title: propTypesExports.string,
  placeholder: propTypesExports.string,
  onChange: propTypesExports.func,
  validationMessage: propTypesExports.any
};

var CancelIcon = createSvgIcon( /*#__PURE__*/jsxRuntimeExports.jsx("path", {
  d: "M12 2C6.47 2 2 6.47 2 12s4.47 10 10 10 10-4.47 10-10S17.53 2 12 2zm5 13.59L15.59 17 12 13.41 8.41 17 7 15.59 10.59 12 7 8.41 8.41 7 12 10.59 15.59 7 17 8.41 13.41 12 17 15.59z"
}), 'Cancel');

function getChipUtilityClass(slot) {
  return generateUtilityClass('MuiChip', slot);
}
const chipClasses = generateUtilityClasses('MuiChip', ['root', 'sizeSmall', 'sizeMedium', 'colorError', 'colorInfo', 'colorPrimary', 'colorSecondary', 'colorSuccess', 'colorWarning', 'disabled', 'clickable', 'clickableColorPrimary', 'clickableColorSecondary', 'deletable', 'deletableColorPrimary', 'deletableColorSecondary', 'outlined', 'filled', 'outlinedPrimary', 'outlinedSecondary', 'filledPrimary', 'filledSecondary', 'avatar', 'avatarSmall', 'avatarMedium', 'avatarColorPrimary', 'avatarColorSecondary', 'icon', 'iconSmall', 'iconMedium', 'iconColorPrimary', 'iconColorSecondary', 'label', 'labelSmall', 'labelMedium', 'deleteIcon', 'deleteIconSmall', 'deleteIconMedium', 'deleteIconColorPrimary', 'deleteIconColorSecondary', 'deleteIconOutlinedColorPrimary', 'deleteIconOutlinedColorSecondary', 'deleteIconFilledColorPrimary', 'deleteIconFilledColorSecondary', 'focusVisible']);
var chipClasses$1 = chipClasses;

const _excluded$2 = ["avatar", "className", "clickable", "color", "component", "deleteIcon", "disabled", "icon", "label", "onClick", "onDelete", "onKeyDown", "onKeyUp", "size", "variant", "tabIndex", "skipFocusWhenDisabled"];
const useUtilityClasses = ownerState => {
  const {
    classes,
    disabled,
    size,
    color,
    iconColor,
    onDelete,
    clickable,
    variant
  } = ownerState;
  const slots = {
    root: ['root', variant, disabled && 'disabled', `size${capitalize(size)}`, `color${capitalize(color)}`, clickable && 'clickable', clickable && `clickableColor${capitalize(color)}`, onDelete && 'deletable', onDelete && `deletableColor${capitalize(color)}`, `${variant}${capitalize(color)}`],
    label: ['label', `label${capitalize(size)}`],
    avatar: ['avatar', `avatar${capitalize(size)}`, `avatarColor${capitalize(color)}`],
    icon: ['icon', `icon${capitalize(size)}`, `iconColor${capitalize(iconColor)}`],
    deleteIcon: ['deleteIcon', `deleteIcon${capitalize(size)}`, `deleteIconColor${capitalize(color)}`, `deleteIcon${capitalize(variant)}Color${capitalize(color)}`]
  };
  return composeClasses(slots, getChipUtilityClass, classes);
};
const ChipRoot = styled$1('div', {
  name: 'MuiChip',
  slot: 'Root',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    const {
      color,
      iconColor,
      clickable,
      onDelete,
      size,
      variant
    } = ownerState;
    return [{
      [`& .${chipClasses$1.avatar}`]: styles.avatar
    }, {
      [`& .${chipClasses$1.avatar}`]: styles[`avatar${capitalize(size)}`]
    }, {
      [`& .${chipClasses$1.avatar}`]: styles[`avatarColor${capitalize(color)}`]
    }, {
      [`& .${chipClasses$1.icon}`]: styles.icon
    }, {
      [`& .${chipClasses$1.icon}`]: styles[`icon${capitalize(size)}`]
    }, {
      [`& .${chipClasses$1.icon}`]: styles[`iconColor${capitalize(iconColor)}`]
    }, {
      [`& .${chipClasses$1.deleteIcon}`]: styles.deleteIcon
    }, {
      [`& .${chipClasses$1.deleteIcon}`]: styles[`deleteIcon${capitalize(size)}`]
    }, {
      [`& .${chipClasses$1.deleteIcon}`]: styles[`deleteIconColor${capitalize(color)}`]
    }, {
      [`& .${chipClasses$1.deleteIcon}`]: styles[`deleteIcon${capitalize(variant)}Color${capitalize(color)}`]
    }, styles.root, styles[`size${capitalize(size)}`], styles[`color${capitalize(color)}`], clickable && styles.clickable, clickable && color !== 'default' && styles[`clickableColor${capitalize(color)})`], onDelete && styles.deletable, onDelete && color !== 'default' && styles[`deletableColor${capitalize(color)}`], styles[variant], styles[`${variant}${capitalize(color)}`]];
  }
})(({
  theme,
  ownerState
}) => {
  const deleteIconColor = alpha(theme.palette.text.primary, 0.26);
  const textColor = theme.palette.mode === 'light' ? theme.palette.grey[700] : theme.palette.grey[300];
  return _extends$1({
    maxWidth: '100%',
    fontFamily: theme.typography.fontFamily,
    fontSize: theme.typography.pxToRem(13),
    display: 'inline-flex',
    alignItems: 'center',
    justifyContent: 'center',
    height: 32,
    color: (theme.vars || theme).palette.text.primary,
    backgroundColor: (theme.vars || theme).palette.action.selected,
    borderRadius: 32 / 2,
    whiteSpace: 'nowrap',
    transition: theme.transitions.create(['background-color', 'box-shadow']),
    // label will inherit this from root, then `clickable` class overrides this for both
    cursor: 'default',
    // We disable the focus ring for mouse, touch and keyboard users.
    outline: 0,
    textDecoration: 'none',
    border: 0,
    // Remove `button` border
    padding: 0,
    // Remove `button` padding
    verticalAlign: 'middle',
    boxSizing: 'border-box',
    [`&.${chipClasses$1.disabled}`]: {
      opacity: (theme.vars || theme).palette.action.disabledOpacity,
      pointerEvents: 'none'
    },
    [`& .${chipClasses$1.avatar}`]: {
      marginLeft: 5,
      marginRight: -6,
      width: 24,
      height: 24,
      color: theme.vars ? theme.vars.palette.Chip.defaultAvatarColor : textColor,
      fontSize: theme.typography.pxToRem(12)
    },
    [`& .${chipClasses$1.avatarColorPrimary}`]: {
      color: (theme.vars || theme).palette.primary.contrastText,
      backgroundColor: (theme.vars || theme).palette.primary.dark
    },
    [`& .${chipClasses$1.avatarColorSecondary}`]: {
      color: (theme.vars || theme).palette.secondary.contrastText,
      backgroundColor: (theme.vars || theme).palette.secondary.dark
    },
    [`& .${chipClasses$1.avatarSmall}`]: {
      marginLeft: 4,
      marginRight: -4,
      width: 18,
      height: 18,
      fontSize: theme.typography.pxToRem(10)
    },
    [`& .${chipClasses$1.icon}`]: _extends$1({
      marginLeft: 5,
      marginRight: -6
    }, ownerState.size === 'small' && {
      fontSize: 18,
      marginLeft: 4,
      marginRight: -4
    }, ownerState.iconColor === ownerState.color && _extends$1({
      color: theme.vars ? theme.vars.palette.Chip.defaultIconColor : textColor
    }, ownerState.color !== 'default' && {
      color: 'inherit'
    })),
    [`& .${chipClasses$1.deleteIcon}`]: _extends$1({
      WebkitTapHighlightColor: 'transparent',
      color: theme.vars ? `rgba(${theme.vars.palette.text.primaryChannel} / 0.26)` : deleteIconColor,
      fontSize: 22,
      cursor: 'pointer',
      margin: '0 5px 0 -6px',
      '&:hover': {
        color: theme.vars ? `rgba(${theme.vars.palette.text.primaryChannel} / 0.4)` : alpha(deleteIconColor, 0.4)
      }
    }, ownerState.size === 'small' && {
      fontSize: 16,
      marginRight: 4,
      marginLeft: -4
    }, ownerState.color !== 'default' && {
      color: theme.vars ? `rgba(${theme.vars.palette[ownerState.color].contrastTextChannel} / 0.7)` : alpha(theme.palette[ownerState.color].contrastText, 0.7),
      '&:hover, &:active': {
        color: (theme.vars || theme).palette[ownerState.color].contrastText
      }
    })
  }, ownerState.size === 'small' && {
    height: 24
  }, ownerState.color !== 'default' && {
    backgroundColor: (theme.vars || theme).palette[ownerState.color].main,
    color: (theme.vars || theme).palette[ownerState.color].contrastText
  }, ownerState.onDelete && {
    [`&.${chipClasses$1.focusVisible}`]: {
      backgroundColor: theme.vars ? `rgba(${theme.vars.palette.action.selectedChannel} / calc(${theme.vars.palette.action.selectedOpacity} + ${theme.vars.palette.action.focusOpacity}))` : alpha(theme.palette.action.selected, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
    }
  }, ownerState.onDelete && ownerState.color !== 'default' && {
    [`&.${chipClasses$1.focusVisible}`]: {
      backgroundColor: (theme.vars || theme).palette[ownerState.color].dark
    }
  });
}, ({
  theme,
  ownerState
}) => _extends$1({}, ownerState.clickable && {
  userSelect: 'none',
  WebkitTapHighlightColor: 'transparent',
  cursor: 'pointer',
  '&:hover': {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette.action.selectedChannel} / calc(${theme.vars.palette.action.selectedOpacity} + ${theme.vars.palette.action.hoverOpacity}))` : alpha(theme.palette.action.selected, theme.palette.action.selectedOpacity + theme.palette.action.hoverOpacity)
  },
  [`&.${chipClasses$1.focusVisible}`]: {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette.action.selectedChannel} / calc(${theme.vars.palette.action.selectedOpacity} + ${theme.vars.palette.action.focusOpacity}))` : alpha(theme.palette.action.selected, theme.palette.action.selectedOpacity + theme.palette.action.focusOpacity)
  },
  '&:active': {
    boxShadow: (theme.vars || theme).shadows[1]
  }
}, ownerState.clickable && ownerState.color !== 'default' && {
  [`&:hover, &.${chipClasses$1.focusVisible}`]: {
    backgroundColor: (theme.vars || theme).palette[ownerState.color].dark
  }
}), ({
  theme,
  ownerState
}) => _extends$1({}, ownerState.variant === 'outlined' && {
  backgroundColor: 'transparent',
  border: theme.vars ? `1px solid ${theme.vars.palette.Chip.defaultBorder}` : `1px solid ${theme.palette.mode === 'light' ? theme.palette.grey[400] : theme.palette.grey[700]}`,
  [`&.${chipClasses$1.clickable}:hover`]: {
    backgroundColor: (theme.vars || theme).palette.action.hover
  },
  [`&.${chipClasses$1.focusVisible}`]: {
    backgroundColor: (theme.vars || theme).palette.action.focus
  },
  [`& .${chipClasses$1.avatar}`]: {
    marginLeft: 4
  },
  [`& .${chipClasses$1.avatarSmall}`]: {
    marginLeft: 2
  },
  [`& .${chipClasses$1.icon}`]: {
    marginLeft: 4
  },
  [`& .${chipClasses$1.iconSmall}`]: {
    marginLeft: 2
  },
  [`& .${chipClasses$1.deleteIcon}`]: {
    marginRight: 5
  },
  [`& .${chipClasses$1.deleteIconSmall}`]: {
    marginRight: 3
  }
}, ownerState.variant === 'outlined' && ownerState.color !== 'default' && {
  color: (theme.vars || theme).palette[ownerState.color].main,
  border: `1px solid ${theme.vars ? `rgba(${theme.vars.palette[ownerState.color].mainChannel} / 0.7)` : alpha(theme.palette[ownerState.color].main, 0.7)}`,
  [`&.${chipClasses$1.clickable}:hover`]: {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette[ownerState.color].mainChannel} / ${theme.vars.palette.action.hoverOpacity})` : alpha(theme.palette[ownerState.color].main, theme.palette.action.hoverOpacity)
  },
  [`&.${chipClasses$1.focusVisible}`]: {
    backgroundColor: theme.vars ? `rgba(${theme.vars.palette[ownerState.color].mainChannel} / ${theme.vars.palette.action.focusOpacity})` : alpha(theme.palette[ownerState.color].main, theme.palette.action.focusOpacity)
  },
  [`& .${chipClasses$1.deleteIcon}`]: {
    color: theme.vars ? `rgba(${theme.vars.palette[ownerState.color].mainChannel} / 0.7)` : alpha(theme.palette[ownerState.color].main, 0.7),
    '&:hover, &:active': {
      color: (theme.vars || theme).palette[ownerState.color].main
    }
  }
}));
const ChipLabel = styled$1('span', {
  name: 'MuiChip',
  slot: 'Label',
  overridesResolver: (props, styles) => {
    const {
      ownerState
    } = props;
    const {
      size
    } = ownerState;
    return [styles.label, styles[`label${capitalize(size)}`]];
  }
})(({
  ownerState
}) => _extends$1({
  overflow: 'hidden',
  textOverflow: 'ellipsis',
  paddingLeft: 12,
  paddingRight: 12,
  whiteSpace: 'nowrap'
}, ownerState.size === 'small' && {
  paddingLeft: 8,
  paddingRight: 8
}));
function isDeleteKeyboardEvent(keyboardEvent) {
  return keyboardEvent.key === 'Backspace' || keyboardEvent.key === 'Delete';
}

/**
 * Chips represent complex entities in small blocks, such as a contact.
 */
const Chip = /*#__PURE__*/React__namespace.forwardRef(function Chip(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiChip'
  });
  const {
      avatar: avatarProp,
      className,
      clickable: clickableProp,
      color = 'default',
      component: ComponentProp,
      deleteIcon: deleteIconProp,
      disabled = false,
      icon: iconProp,
      label,
      onClick,
      onDelete,
      onKeyDown,
      onKeyUp,
      size = 'medium',
      variant = 'filled',
      tabIndex,
      skipFocusWhenDisabled = false
    } = props,
    other = _objectWithoutPropertiesLoose(props, _excluded$2);
  const chipRef = React__namespace.useRef(null);
  const handleRef = useForkRef(chipRef, ref);
  const handleDeleteIconClick = event => {
    // Stop the event from bubbling up to the `Chip`
    event.stopPropagation();
    if (onDelete) {
      onDelete(event);
    }
  };
  const handleKeyDown = event => {
    // Ignore events from children of `Chip`.
    if (event.currentTarget === event.target && isDeleteKeyboardEvent(event)) {
      // Will be handled in keyUp, otherwise some browsers
      // might init navigation
      event.preventDefault();
    }
    if (onKeyDown) {
      onKeyDown(event);
    }
  };
  const handleKeyUp = event => {
    // Ignore events from children of `Chip`.
    if (event.currentTarget === event.target) {
      if (onDelete && isDeleteKeyboardEvent(event)) {
        onDelete(event);
      } else if (event.key === 'Escape' && chipRef.current) {
        chipRef.current.blur();
      }
    }
    if (onKeyUp) {
      onKeyUp(event);
    }
  };
  const clickable = clickableProp !== false && onClick ? true : clickableProp;
  const component = clickable || onDelete ? ButtonBase$1 : ComponentProp || 'div';
  const ownerState = _extends$1({}, props, {
    component,
    disabled,
    size,
    color,
    iconColor: /*#__PURE__*/React__namespace.isValidElement(iconProp) ? iconProp.props.color || color : color,
    onDelete: !!onDelete,
    clickable,
    variant
  });
  const classes = useUtilityClasses(ownerState);
  const moreProps = component === ButtonBase$1 ? _extends$1({
    component: ComponentProp || 'div',
    focusVisibleClassName: classes.focusVisible
  }, onDelete && {
    disableRipple: true
  }) : {};
  let deleteIcon = null;
  if (onDelete) {
    deleteIcon = deleteIconProp && /*#__PURE__*/React__namespace.isValidElement(deleteIconProp) ? /*#__PURE__*/React__namespace.cloneElement(deleteIconProp, {
      className: clsx(deleteIconProp.props.className, classes.deleteIcon),
      onClick: handleDeleteIconClick
    }) : /*#__PURE__*/jsxRuntimeExports.jsx(CancelIcon, {
      className: clsx(classes.deleteIcon),
      onClick: handleDeleteIconClick
    });
  }
  let avatar = null;
  if (avatarProp && /*#__PURE__*/React__namespace.isValidElement(avatarProp)) {
    avatar = /*#__PURE__*/React__namespace.cloneElement(avatarProp, {
      className: clsx(classes.avatar, avatarProp.props.className)
    });
  }
  let icon = null;
  if (iconProp && /*#__PURE__*/React__namespace.isValidElement(iconProp)) {
    icon = /*#__PURE__*/React__namespace.cloneElement(iconProp, {
      className: clsx(classes.icon, iconProp.props.className)
    });
  }
  if (browser$1.env.NODE_ENV !== 'production') {
    if (avatar && icon) {
      console.error('MUI: The Chip component can not handle the avatar ' + 'and the icon prop at the same time. Pick one.');
    }
  }
  return /*#__PURE__*/jsxRuntimeExports.jsxs(ChipRoot, _extends$1({
    as: component,
    className: clsx(classes.root, className),
    disabled: clickable && disabled ? true : undefined,
    onClick: onClick,
    onKeyDown: handleKeyDown,
    onKeyUp: handleKeyUp,
    ref: handleRef,
    tabIndex: skipFocusWhenDisabled && disabled ? -1 : tabIndex,
    ownerState: ownerState
  }, moreProps, other, {
    children: [avatar || icon, /*#__PURE__*/jsxRuntimeExports.jsx(ChipLabel, {
      className: clsx(classes.label),
      ownerState: ownerState,
      children: label
    }), deleteIcon]
  }));
});
browser$1.env.NODE_ENV !== "production" ? Chip.propTypes /* remove-proptypes */ = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------
  /**
   * The Avatar element to display.
   */
  avatar: propTypesExports.element,
  /**
   * This prop isn't supported.
   * Use the `component` prop if you need to change the children structure.
   */
  children: unsupportedProp,
  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypesExports.object,
  /**
   * @ignore
   */
  className: propTypesExports.string,
  /**
   * If `true`, the chip will appear clickable, and will raise when pressed,
   * even if the onClick prop is not defined.
   * If `false`, the chip will not appear clickable, even if onClick prop is defined.
   * This can be used, for example,
   * along with the component prop to indicate an anchor Chip is clickable.
   * Note: this controls the UI and does not affect the onClick event.
   */
  clickable: propTypesExports.bool,
  /**
   * The color of the component.
   * It supports both default and custom theme colors, which can be added as shown in the
   * [palette customization guide](https://mui.com/material-ui/customization/palette/#adding-new-colors).
   * @default 'default'
   */
  color: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['default', 'primary', 'secondary', 'error', 'info', 'success', 'warning']), propTypesExports.string]),
  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: propTypesExports.elementType,
  /**
   * Override the default delete icon element. Shown only if `onDelete` is set.
   */
  deleteIcon: propTypesExports.element,
  /**
   * If `true`, the component is disabled.
   * @default false
   */
  disabled: propTypesExports.bool,
  /**
   * Icon element.
   */
  icon: propTypesExports.element,
  /**
   * The content of the component.
   */
  label: propTypesExports.node,
  /**
   * @ignore
   */
  onClick: propTypesExports.func,
  /**
   * Callback fired when the delete icon is clicked.
   * If set, the delete icon will be shown.
   */
  onDelete: propTypesExports.func,
  /**
   * @ignore
   */
  onKeyDown: propTypesExports.func,
  /**
   * @ignore
   */
  onKeyUp: propTypesExports.func,
  /**
   * The size of the component.
   * @default 'medium'
   */
  size: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['medium', 'small']), propTypesExports.string]),
  /**
   * If `true`, allows the disabled chip to escape focus.
   * If `false`, allows the disabled chip to receive focus.
   * @default false
   */
  skipFocusWhenDisabled: propTypesExports.bool,
  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypesExports.oneOfType([propTypesExports.arrayOf(propTypesExports.oneOfType([propTypesExports.func, propTypesExports.object, propTypesExports.bool])), propTypesExports.func, propTypesExports.object]),
  /**
   * @ignore
   */
  tabIndex: propTypesExports.number,
  /**
   * The variant to use.
   * @default 'filled'
   */
  variant: propTypesExports /* @typescript-to-proptypes-ignore */.oneOfType([propTypesExports.oneOf(['filled', 'outlined']), propTypesExports.string])
} : void 0;
var Chip$1 = Chip;

var _excluded$1 = ["text", "color", "onDelete"];
function Pill(_ref) {
  var text = _ref.text,
    color = _ref.color,
    onDelete = _ref.onDelete,
    props = _objectWithoutProperties(_ref, _excluded$1);
  return /*#__PURE__*/React__namespace.default.createElement(Chip$1, _extends$2({}, props, {
    sx: {
      fontSize: 14,
      backgroundColor: color
    },
    label: text,
    onDelete: onDelete
  }));
}
Pill.propTypes = {
  text: propTypesExports.string,
  color: propTypesExports.string,
  onDelete: propTypesExports.func
};

var ADDRESS_URL_INPUT_MAX_CHARS = 50;
var PillInputContainer = styled__default.default(Box$1)(function (_ref) {
  var theme = _ref.theme;
  return {
    display: "flex",
    flexDirection: "row",
    alignItems: "center",
    backgroundColor: theme.palette.contentBlocks.pillBackground,
    borderRadius: 25,
    height: "32px",
    margin: "2px 5px 5px 0"
  };
});
var StyledPill = styled__default.default(Pill)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    margin: "2px 5px 5px 0",
    color: theme.palette.card.divider,
    "& .MuiChip-label": {
      color: theme.palette.text.primary
    }
  };
});
function PhoneUrlInput(props) {
  return /*#__PURE__*/React__namespace.default.createElement(TextAutosizeInput, _extends$2({}, props, {
    includeBorderLeft: true
  }));
}
function AddressUrlInput(props) {
  return /*#__PURE__*/React__namespace.default.createElement(AddressFormUrlInput, _extends$2({}, props, {
    includeBorderLeft: true,
    maxCharsToAutosize: ADDRESS_URL_INPUT_MAX_CHARS
  }));
}

function PillDisplay() {
  var _usePills = usePills(),
    setPills = _usePills.setPills,
    type = _usePills.type;
  var _usePill = usePill(),
    index = _usePill.index,
    pill = _usePill.pill;
  if (type === CONTENT_BLOCK_TYPES.TAGS) {
    return /*#__PURE__*/React__namespace.default.createElement(StyledTagPill, {
      text: pill.content,
      color: pill.color,
      onDelete: function onDelete() {
        return onDeletePillClick({
          setPills: setPills,
          index: index
        });
      },
      "data-testid": TEST_IDS.TAG_INPUT_PILL
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(StyledPill, {
    avatar: /*#__PURE__*/React__namespace.default.createElement(PillAvatar, {
      type: type,
      color: pill.color
    }),
    text: pill.content,
    onDelete: function onDelete() {
      return onDeletePillClick({
        setPills: setPills,
        index: index
      });
    },
    "data-testid": TEST_IDS.PILL_INPUT_PILL
  });
}
function onDeletePillClick(_ref) {
  var setPills = _ref.setPills,
    index = _ref.index;
  setPills(function (prevState) {
    return _toConsumableArray(prevState).filter(function (_, idx) {
      return index !== idx;
    });
  });
}
var StyledTagPill = styled__default.default(StyledPill)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    "& .MuiChip-label": {
      color: theme.palette.text.light
    }
  };
});

function validatePill(_x) {
  return _validatePill.apply(this, arguments);
}
function _validatePill() {
  _validatePill = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref) {
    var content, url, setLocalError, schema;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          content = _ref.content, url = _ref.url, setLocalError = _ref.setLocalError, schema = _ref.schema;
          _context.prev = 1;
          _context.next = 4;
          return schema.validate({
            content: content,
            url: url
          });
        case 4:
          setLocalError(null);
          _context.next = 10;
          break;
        case 7:
          _context.prev = 7;
          _context.t0 = _context["catch"](1);
          // Local error gets passed to InputErrorMessage which can handle a string or object error
          setLocalError((_context.t0 === null || _context.t0 === void 0 ? void 0 : _context.t0.message) || "Invalid value");
        case 10:
        case "end":
          return _context.stop();
      }
    }, _callee, null, [[1, 7]]);
  }));
  return _validatePill.apply(this, arguments);
}
function onKeyPress(_x2) {
  return _onKeyPress.apply(this, arguments);
}
function _onKeyPress() {
  _onKeyPress = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref2) {
    var event, content, url, setLocalError, schema, setPillsAndResetValues;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          event = _ref2.event, content = _ref2.content, url = _ref2.url, setLocalError = _ref2.setLocalError, schema = _ref2.schema, setPillsAndResetValues = _ref2.setPillsAndResetValues;
          if (!(event.key !== USER_INPUT.ENTER)) {
            _context2.next = 3;
            break;
          }
          return _context2.abrupt("return");
        case 3:
          _context2.next = 5;
          return validatePill({
            content: content,
            url: url,
            setLocalError: setLocalError,
            schema: schema
          });
        case 5:
          setPillsAndResetValues();
        case 6:
        case "end":
          return _context2.stop();
      }
    }, _callee2);
  }));
  return _onKeyPress.apply(this, arguments);
}
function handleOnChange(_x3) {
  return _handleOnChange.apply(this, arguments);
}
function _handleOnChange() {
  _handleOnChange = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(_ref3) {
    var setValue, prop, values, setLocalError, schema;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          setValue = _ref3.setValue, prop = _ref3.prop, values = _ref3.values, setLocalError = _ref3.setLocalError, schema = _ref3.schema;
          setValue(values[prop]);
          _context3.next = 4;
          return validatePill(_objectSpread2(_objectSpread2({}, values), {}, {
            setLocalError: setLocalError,
            schema: schema
          }));
        case 4:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return _handleOnChange.apply(this, arguments);
}

function PillNameInput(_ref) {
  var onBlur = _ref.onBlur;
  var _usePills = usePills(),
    setLocalError = _usePills.setLocalError,
    title = _usePills.title,
    type = _usePills.type;
  var _usePill = usePill(),
    content = _usePill.content,
    url = _usePill.url,
    setContent = _usePill.setContent,
    setPillsAndResetValues = _usePill.setPillsAndResetValues;
  var schema = getPillsSchema(type);
  var keyPressParams = {
    content: content,
    url: url,
    setLocalError: setLocalError,
    schema: schema,
    setPillsAndResetValues: setPillsAndResetValues
  };
  return /*#__PURE__*/React__namespace.default.createElement(TextAutosizeInput, {
    inputMaxChars: CONTENT_BLOCK_VALIDATION_LIMITS.PILL_CONTENT.MAX,
    placeholder: title,
    variant: "standard",
    value: content,
    onBlur: onBlur,
    onChange: function onChange(_ref2) {
      var target = _ref2.target;
      return handleOnChange({
        setValue: setContent,
        prop: "content",
        values: {
          content: target.value,
          url: url
        },
        setLocalError: setLocalError,
        schema: schema
      });
    },
    onKeyPress: function onKeyPress$1(event) {
      return onKeyPress(_objectSpread2({
        event: event
      }, keyPressParams));
    },
    InputProps: {
      disableUnderline: true
    }
  });
}
PillNameInput.propTypes = {
  onBlur: propTypesExports.func
};

function PillUrlInput() {
  var _usePills = usePills(),
    setLocalError = _usePills.setLocalError,
    type = _usePills.type,
    secondaryTitle = _usePills.secondaryTitle;
  var _usePill = usePill(),
    content = _usePill.content,
    url = _usePill.url,
    setUrl = _usePill.setUrl,
    setPillsAndResetValues = _usePill.setPillsAndResetValues;
  var UrlComponent = getInputComponent(type);
  var schema = getPillsSchema(type);
  var keyPressParams = {
    content: content,
    url: url,
    setLocalError: setLocalError,
    schema: schema,
    setPillsAndResetValues: setPillsAndResetValues
  };
  return /*#__PURE__*/React__namespace.default.createElement(UrlComponent, {
    placeholder: secondaryTitle,
    variant: "standard",
    value: url,
    onChange: function onChange(_ref) {
      var target = _ref.target;
      return handleOnChange({
        setValue: setUrl,
        prop: "url",
        values: {
          content: content,
          url: target.value
        },
        setLocalError: setLocalError,
        schema: schema
      });
    },
    onKeyPress: function onKeyPress$1(event) {
      return onKeyPress(_objectSpread2({
        event: event
      }, keyPressParams));
    },
    InputProps: {
      disableUnderline: true
    }
  });
}
function getInputComponent(type) {
  if (type === CONTENT_BLOCK_TYPES.ADDRESS) {
    return AddressUrlInput;
  }
  return PhoneUrlInput;
}

function PillButton(_ref) {
  var isDisabled = _ref.isDisabled,
    onClick = _ref.onClick,
    _ref$label = _ref.label,
    label = _ref$label === void 0 ? ADD : _ref$label;
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$2, {
    "data-testid": TEST_IDS.PILL_BUTTON,
    variant: "contained",
    disabled: isDisabled,
    size: "small",
    onClick: onClick
  }, label);
}
PillButton.propTypes = {
  isDisabled: propTypesExports.bool.isRequired,
  onClick: propTypesExports.func.isRequired,
  label: propTypesExports.string
};
var StyledButton$2 = styled__default.default(Button)({
  // height of 28 is 4px less than pill height giving a padding of 2
  height: "28px",
  // This is the min width allowed by Mui
  width: "90px",
  marginRight: "2px"
});

var FormatBold = {};

var _interopRequireDefault$7 = interopRequireDefaultExports;
Object.defineProperty(FormatBold, "__esModule", {
  value: true
});
var default_1$7 = FormatBold.default = void 0;
var _createSvgIcon$7 = _interopRequireDefault$7(requireCreateSvgIcon());
var _jsxRuntime$7 = requireJsxRuntime();
var _default$7 = (0, _createSvgIcon$7.default)( /*#__PURE__*/(0, _jsxRuntime$7.jsx)("path", {
  d: "M15.6 10.79c.97-.67 1.65-1.77 1.65-2.79 0-2.26-1.75-4-4-4H7v14h7.04c2.09 0 3.71-1.7 3.71-3.79 0-1.52-.86-2.82-2.15-3.42zM10 6.5h3c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5h-3v-3zm3.5 9H10v-3h3.5c.83 0 1.5.67 1.5 1.5s-.67 1.5-1.5 1.5z"
}), 'FormatBold');
default_1$7 = FormatBold.default = _default$7;

var anchorOrigin = {
  vertical: "bottom",
  horizontal: "right"
};
var transformOrigin = {
  vertical: "top",
  horizontal: "right"
};
function ColorPicker(_ref) {
  var onColorChange = _ref.onColorChange,
    value = _ref.value;
  var theme = useTheme$1();
  var colorOptions = Object.values(theme.palette.colors.tags);
  var _useState = React.useState(value || colorOptions[0]),
    _useState2 = _slicedToArray(_useState, 2),
    color = _useState2[0],
    setColor = _useState2[1];
  var _useState3 = React.useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    anchorEl = _useState4[0],
    setAnchorEl = _useState4[1];
  var isOpen = Boolean(anchorEl);
  var handleClick = function handleClick(event) {
    setAnchorEl(event.currentTarget);
  };
  var handleClose = function handleClose() {
    setAnchorEl(null);
  };
  React.useEffect(function () {
    onColorChange(color);
  }, [color]);
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(ColorPickerButton, {
    onClick: handleClick,
    background: color,
    "data-testid": TEST_IDS.COLOR_PICKER_BUTTON
  }, /*#__PURE__*/React__namespace.default.createElement(default_1$b, null)), /*#__PURE__*/React__namespace.default.createElement(StyledMenu, {
    anchorEl: anchorEl,
    open: isOpen,
    onClose: handleClose,
    anchorOrigin: anchorOrigin,
    transformOrigin: transformOrigin
  }, colorOptions.map(function (colorOption) {
    return /*#__PURE__*/React__namespace.default.createElement(ColorPickerButton, {
      key: colorOption,
      "data-testid": TEST_IDS.COLOR_PICKER_ITEM_BUTTON,
      background: colorOption,
      padding: 3,
      onClick: function onClick() {
        return handleColorSelect({
          setColor: setColor,
          handleClose: handleClose,
          colorOption: colorOption
        });
      }
    }, /*#__PURE__*/React__namespace.default.createElement(default_1$7, {
      fontSize: "small"
    }));
  })));
}
ColorPicker.propTypes = {
  value: propTypesExports.string,
  onColorChange: propTypesExports.func.isRequired
};
function handleColorSelect(_ref2) {
  var setColor = _ref2.setColor,
    handleClose = _ref2.handleClose,
    colorOption = _ref2.colorOption;
  setColor(colorOption);
  handleClose();
}
var ColorPickerButton = styled__default.default(IconButton$2)(function (_ref3) {
  var theme = _ref3.theme,
    background = _ref3.background,
    _ref3$padding = _ref3.padding,
    padding = _ref3$padding === void 0 ? 0 : _ref3$padding;
  return {
    marginLeft: theme.spacing(1),
    padding: padding,
    color: theme.palette.text.light,
    backgroundColor: background,
    margin: 3,
    "&:hover": {
      backgroundColor: background,
      opacity: 0.8
    }
  };
});
var StyledMenu = styled__default.default(Menu$1)({
  "& .MuiMenu-list": {
    padding: 5
  }
});

function PillInput(_ref) {
  var onBlur = _ref.onBlur;
  var _usePills = usePills(),
    type = _usePills.type,
    hasAnyError = _usePills.hasAnyError;
  var _usePill = usePill(),
    buttonLabel = _usePill.buttonLabel,
    content = _usePill.content,
    url = _usePill.url,
    color = _usePill.color,
    setColor = _usePill.setColor,
    setPillsAndResetValues = _usePill.setPillsAndResetValues;
  var hasValues = hasRequiredValues({
    url: url,
    content: content,
    type: type
  });
  var isContactOrAddressPill = type === CONTENT_BLOCK_TYPES.CONTACT || type === CONTENT_BLOCK_TYPES.ADDRESS;
  return /*#__PURE__*/React__namespace.default.createElement(PillInputContainer, null, /*#__PURE__*/React__namespace.default.createElement(ColorPicker, {
    value: color,
    onColorChange: setColor
  }), /*#__PURE__*/React__namespace.default.createElement(PillNameInput, {
    onBlur: onBlur
  }), isContactOrAddressPill && /*#__PURE__*/React__namespace.default.createElement(PillUrlInput, null), /*#__PURE__*/React__namespace.default.createElement(PillButton, {
    label: buttonLabel,
    isDisabled: hasAnyError || !hasValues,
    onClick: setPillsAndResetValues
  }));
}
PillInput.propTypes = {
  onBlur: propTypesExports.func
};
function hasRequiredValues(_ref2) {
  var url = _ref2.url,
    content = _ref2.content,
    type = _ref2.type;
  if (type === CONTENT_BLOCK_TYPES.TAGS) {
    return !!content;
  }
  return !!url && !!content;
}

function EditablePill(_ref) {
  var onBlur = _ref.onBlur;
  var _usePill = usePill(),
    isInEditMode = _usePill.isInEditMode,
    setIsInEditMode = _usePill.setIsInEditMode;
  return /*#__PURE__*/React__namespace.default.createElement(Box$1, {
    onClick: function onClick() {
      return handleOnClick$1({
        isInEditMode: isInEditMode,
        setIsInEditMode: setIsInEditMode
      });
    }
  }, isInEditMode ? /*#__PURE__*/React__namespace.default.createElement(PillInput, {
    onBlur: onBlur
  }) : /*#__PURE__*/React__namespace.default.createElement(PillDisplay, null));
}
EditablePill.propTypes = {
  onBlur: propTypesExports.func
};
function handleOnClick$1(_ref2) {
  var isInEditMode = _ref2.isInEditMode,
    setIsInEditMode = _ref2.setIsInEditMode;
  if (isInEditMode) return;
  setIsInEditMode(!isInEditMode);
}

function EditablePills(_ref) {
  var onBlur = _ref.onBlur;
  var _usePills = usePills(),
    pills = _usePills.pills;
  return pills.map(function (pill, index) {
    return /*#__PURE__*/React__namespace.default.createElement(PillProvider, {
      key: pill.id,
      pill: pill,
      index: index,
      shouldToggleOutOfEditMode: true
    }, /*#__PURE__*/React__namespace.default.createElement(EditablePill, {
      onBlur: onBlur
    }));
  });
}
EditablePills.propTypes = {
  onBlur: propTypesExports.func
};

// This component and it's children handle both pills (address and contact) as well as tags which are essentially a special type of pill
function PillsInput(_ref) {
  var type = _ref.type,
    id = _ref.id,
    value = _ref.value,
    onChange = _ref.onChange,
    onBlur = _ref.onBlur,
    validationMessage = _ref.validationMessage,
    icon = _ref.icon;
  var _useState = React.useState(value || []),
    _useState2 = _slicedToArray(_useState, 2),
    pills = _useState2[0],
    setPills = _useState2[1];
  var _useState3 = React.useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    localError = _useState4[0],
    setLocalError = _useState4[1];
  var hasError = !!validationMessage;

  // any local changes to pills, run form input onChange
  React.useEffect(function () {
    onChange(pills);
  }, [pills]);
  return /*#__PURE__*/React__namespace.default.createElement(PillsProvider, {
    setLocalError: setLocalError,
    pills: pills,
    setPills: setPills,
    hasError: hasError,
    type: type,
    localError: localError,
    icon: icon
  }, /*#__PURE__*/React__namespace.default.createElement(PillsColumn, null, /*#__PURE__*/React__namespace.default.createElement(InputRow, null, /*#__PURE__*/React__namespace.default.createElement(EditablePills, {
    onBlur: onBlur
  }), /*#__PURE__*/React__namespace.default.createElement(PillProvider, null, /*#__PURE__*/React__namespace.default.createElement(PillInput, {
    onBlur: onBlur
  }))), /*#__PURE__*/React__namespace.default.createElement(InputErrorMessage, {
    id: id,
    validationMessage: validationMessage || localError
  })));
}
PillsInput.propTypes = {
  id: propTypesExports.string,
  type: propTypesExports.string.isRequired,
  onChange: propTypesExports.func,
  onBlur: propTypesExports.func,
  value: propTypesExports.arrayOf(propTypesExports.shape({
    id: propTypesExports.string,
    color: propTypesExports.string,
    content: propTypesExports.string,
    url: propTypesExports.string,
    icon: propTypesExports.string
  })),
  validationMessage: propTypesExports.string,
  icon: propTypesExports.string,
  secondaryTitle: propTypesExports.string
};
var PillsColumn = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    flexDirection: "column"
  };
});

var _excluded = ["sectionIndex", "blockIndex", "type"];
function PillsTagsInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    type = _ref.type,
    props = _objectWithoutProperties(_ref, _excluded);
  var makeInputPath = useMakeInputPath();
  var path = makeInputPath({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    prop: CONTENT_BLOCK_INPUT_PATH_PROPS.PILLS
  });
  return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, _extends$2({
    path: path,
    Component: PillsInput
  }, getProps({
    props: props,
    type: type
  })));
}
PillsTagsInput.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired,
  type: propTypesExports.oneOf(Object.values(CONTENT_BLOCK_TYPES)).isRequired
};
function getProps(_ref2) {
  var type = _ref2.type,
    props = _ref2.props;
  return _objectSpread2(_objectSpread2({}, props), {}, {
    type: type
  });
}

function ContentBlockInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex;
  var id = React.useMemo(function () {
    return getInputComponentId({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex
    });
  }, [sectionIndex, blockIndex]);
  var _useContentBlockForm = useContentBlockForm({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex
    }),
    block = _useContentBlockForm.block;
  var InputComponent = getContentBlockInputComponent({
    type: block.type
  });
  return /*#__PURE__*/React__namespace.default.createElement(InputComponent, _extends$2({
    id: id,
    sectionIndex: sectionIndex,
    blockIndex: blockIndex
  }, block));
}

// exported for tests
function getContentBlockInputComponent(_ref2) {
  var type = _ref2.type;
  switch (type) {
    case CONTENT_BLOCK_TYPES.ADDRESS:
      return PillsTagsInput;
    case CONTENT_BLOCK_TYPES.BANNER:
      return BannerInput;
    case CONTENT_BLOCK_TYPES.CONTACT:
      return PillsTagsInput;
    case CONTENT_BLOCK_TYPES.IMAGE:
      return AttachmentInput;
    case CONTENT_BLOCK_TYPES.TAGS:
      return PillsTagsInput;
    case CONTENT_BLOCK_TYPES.TEXT:
      return TextInput;
    case CONTENT_BLOCK_TYPES.VIDEO:
      return AttachmentInput;
    case CONTENT_BLOCK_TYPES.PDF:
      return PdfInput;
    case CONTENT_BLOCK_TYPES.FORM:
      return FormInput;
    default:
      return null;
  }
}
ContentBlockInput.propTypes = {
  blockIndex: propTypesExports.number.isRequired,
  sectionIndex: propTypesExports.number.isRequired
};

function ContentBlockRowDropDownInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex;
  var id = React.useMemo(function () {
    return getDropdownInputContainerId({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex
    });
  }, [sectionIndex, blockIndex]);
  var dropdownOptions = getDropDownOptionsForContentBlockType();
  var _useContentBlockForm = useContentBlockForm({
      sectionIndex: sectionIndex,
      blockIndex: blockIndex
    }),
    block = _useContentBlockForm.block,
    replaceBlockInSection = _useContentBlockForm.replaceBlockInSection;
  var type = block.type;
  var currentDropDownType = CONTENT_BLOCK_DROPDOWN_OPTIONS_BY_TYPE[type];
  var currentContentBlockInputType = currentDropDownType || dropdownOptions[0];
  return /*#__PURE__*/React__namespace.default.createElement(DropDownInputContainer, null, /*#__PURE__*/React__namespace.default.createElement(DropDownInput, {
    id: id,
    label: currentContentBlockInputType.value,
    dropdownOptions: dropdownOptions,
    onChange: function onChange(newType) {
      handleNewBlockSelected({
        sectionIndex: sectionIndex,
        blockIndex: blockIndex,
        type: newType,
        replaceBlockInSection: replaceBlockInSection
      });
    }
  }));
}
ContentBlockRowDropDownInput.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired
};
function handleNewBlockSelected(_ref2) {
  var type = _ref2.type,
    replaceBlockInSection = _ref2.replaceBlockInSection,
    sectionIndex = _ref2.sectionIndex,
    blockIndex = _ref2.blockIndex;
  var newBlock = getBlockInitialValueByType(type);
  replaceBlockInSection({
    sectionIndex: sectionIndex,
    blockIndex: blockIndex,
    newBlock: newBlock
  });
}

function ContentBlockRow(_ref) {
  var sectionIndex = _ref.sectionIndex,
    blockIndex = _ref.blockIndex,
    dragHandleProps = _ref.dragHandleProps;
  var _useContentBlockForm = useContentBlockForm(),
    removeBlockFromSection = _useContentBlockForm.removeBlockFromSection;
  return /*#__PURE__*/React__namespace.default.createElement(BlockRow, null, /*#__PURE__*/React__namespace.default.createElement(ContentBlockInputContainer, null, /*#__PURE__*/React__namespace.default.createElement(BlockAndHandleRow, null, /*#__PURE__*/React__namespace.default.createElement(Box$1, _extends$2({}, dragHandleProps, {
    mr: 1,
    "data-testid": TEST_IDS.BLOCK_DRAG_HANDLE
  }), /*#__PURE__*/React__namespace.default.createElement(StyledDragIndicator, null)), /*#__PURE__*/React__namespace.default.createElement(ContentBlockInput, {
    sectionIndex: sectionIndex,
    blockIndex: blockIndex
  }))), /*#__PURE__*/React__namespace.default.createElement(ContentBlockRowDropDownInput, {
    sectionIndex: sectionIndex,
    blockIndex: blockIndex
  }), /*#__PURE__*/React__namespace.default.createElement(RemoveBlockButtonContainer, null, /*#__PURE__*/React__namespace.default.createElement(RemoveButton, {
    onClick: function onClick() {
      return removeBlockFromSection({
        sectionIndex: sectionIndex,
        blockIndex: blockIndex
      });
    }
  })));
}
ContentBlockRow.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  blockIndex: propTypesExports.number.isRequired,
  dragHandleProps: propTypesExports.object.isRequired
};
var BlockAndHandleRow = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    flexDirection: "row",
    alignItems: "center"
  };
});

// The default display: inline-block causes the icon to
// not be vertically centered.
var StyledDragIndicator = styled__default.default(default_1$l)({
  display: "block"
});

function BlocksRow(_ref) {
  var sectionIndex = _ref.sectionIndex;
  var _useContentBlockForm = useContentBlockForm({
      sectionIndex: sectionIndex
    }),
    section = _useContentBlockForm.section,
    addBlockToSection = _useContentBlockForm.addBlockToSection,
    moveBlockInSection = _useContentBlockForm.moveBlockInSection;
  return /*#__PURE__*/React__namespace.default.createElement(BlocksColumn, null, /*#__PURE__*/React__namespace.default.createElement(DragAndDropContainer, {
    items: section.blocks,
    moveItem: function moveItem(values) {
      moveBlockInSection(_objectSpread2({
        sectionIndex: sectionIndex
      }, values));
    },
    ItemComponent: ContentBlockRow,
    getItemProps: function getItemProps(values) {
      return _getItemProps(_objectSpread2({
        sectionIndex: sectionIndex
      }, values));
    },
    shouldUseCustomDragHandle: true,
    droppableId: BLOCKS_DROPPABLE_ID
  }), /*#__PURE__*/React__namespace.default.createElement(AddBlockButtonRow, null, /*#__PURE__*/React__namespace.default.createElement(AddButton, {
    onClick: function onClick() {
      return addBlock({
        addBlockToSection: addBlockToSection,
        sectionIndex: sectionIndex
      });
    }
  })));
}
BlocksRow.propTypes = {
  sectionIndex: propTypesExports.number.isRequired
};
var AddBlockButtonRow = styled__default.default(Box$1)({
  flex: 1,
  display: "flex",
  justifyContent: "center"
});
var BlocksColumn = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    flex: 1,
    flexDirection: "column",
    flexWrap: "wrap"
  };
});
function addBlock(_ref2) {
  var addBlockToSection = _ref2.addBlockToSection,
    sectionIndex = _ref2.sectionIndex;
  var newBlock = getBlockInitialValueByType();
  addBlockToSection({
    sectionIndex: sectionIndex,
    newBlock: newBlock
  });
}
function _getItemProps(_ref3) {
  var sectionIndex = _ref3.sectionIndex,
    itemIndex = _ref3.itemIndex,
    dragHandleProps = _ref3.dragHandleProps;
  return {
    sectionIndex: sectionIndex,
    blockIndex: itemIndex,
    dragHandleProps: dragHandleProps
  };
}

function TitleRow(_ref) {
  var sectionIndex = _ref.sectionIndex;
  var makeInputPath = useMakeInputPath();
  var id = React.useMemo(function () {
    return getTitleRowId({
      sectionIndex: sectionIndex
    });
  }, [sectionIndex]);
  var _useContentBlockForm = useContentBlockForm({
      sectionIndex: sectionIndex
    }),
    section = _useContentBlockForm.section;
  var path = makeInputPath({
    sectionIndex: sectionIndex,
    prop: CONTENT_BLOCK_INPUT_PATH_PROPS.TITLE
  });
  return /*#__PURE__*/React__namespace.default.createElement(TitleInput, {
    id: id,
    label: section.title,
    path: path
  });
}
TitleRow.propTypes = {
  sectionIndex: propTypesExports.number.isRequired
};

function TopRow(_ref) {
  var sectionIndex = _ref.sectionIndex,
    dragHandleProps = _ref.dragHandleProps;
  var _useContentBlockForm = useContentBlockForm(),
    removeSection = _useContentBlockForm.removeSection;
  var sectionActionConfigs = getSectionActionConfigs({
    sectionIndex: sectionIndex,
    removeSection: removeSection
  });
  return /*#__PURE__*/React__namespace.default.createElement(DraggableSectionHeader, {
    dragHandleProps: dragHandleProps,
    actions: sectionActionConfigs
  });
}
TopRow.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  dragHandleProps: propTypesExports.object
};
function getSectionActionConfigs(_ref2) {
  var removeSection = _ref2.removeSection,
    sectionIndex = _ref2.sectionIndex;
  return [{
    name: "Delete Section",
    onClick: function onClick() {
      removeSection(sectionIndex);
    }
  }];
}

function ContentSectionInput(_ref) {
  var sectionIndex = _ref.sectionIndex,
    dragHandleProps = _ref.dragHandleProps;
  var id = React.useMemo(function () {
    return getSectionRowId({
      sectionIndex: sectionIndex
    });
  }, [sectionIndex]);
  return /*#__PURE__*/React__namespace.default.createElement(SectionRow$1, {
    id: id
  }, /*#__PURE__*/React__namespace.default.createElement(TopRow, {
    sectionIndex: sectionIndex,
    dragHandleProps: dragHandleProps
  }), /*#__PURE__*/React__namespace.default.createElement(TitleRow, {
    sectionIndex: sectionIndex
  }), /*#__PURE__*/React__namespace.default.createElement(BlocksRow, {
    sectionIndex: sectionIndex
  }));
}
ContentSectionInput.propTypes = {
  sectionIndex: propTypesExports.number.isRequired,
  dragHandleProps: propTypesExports.object
};
var SectionRow$1 = styled__default.default(Box$1)({
  display: "flex",
  flex: 1,
  flexDirection: "column",
  padding: "0 25px",
  margin: "5px 0px"
});

function ContentBlockSection(_ref) {
  var sectionIndex = _ref.sectionIndex,
    dragHandleProps = _ref.dragHandleProps;
  return /*#__PURE__*/React__namespace.default.createElement(ContentBlockEditContainer, null, /*#__PURE__*/React__namespace.default.createElement(ContentSectionInput, {
    sectionIndex: sectionIndex,
    dragHandleProps: dragHandleProps
  }));
}
ContentBlockSection.propTypes = {
  sectionIndex: propTypesExports.number,
  dragHandleProps: propTypesExports.object
};

function ContentSectionsInput() {
  var styles = getStyles$3();
  var _useContentBlockForm = useContentBlockForm(),
    sections = _useContentBlockForm.sections,
    appendSection = _useContentBlockForm.appendSection,
    moveSections = _useContentBlockForm.moveSections;
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(DragAndDropContainer, {
    items: sections,
    moveItem: moveSections,
    ItemComponent: ContentBlockSection,
    getItemProps: getSectionProps$1,
    shouldUseCustomDragHandle: true,
    droppableId: SECTIONS_DROPPABLE_ID
  }), /*#__PURE__*/React__namespace.default.createElement(ButtonCenter, null, /*#__PURE__*/React__namespace.default.createElement(IconTextButton, {
    "data-testid": TEST_IDS.ADD_SECTION_BUTTON,
    onClick: function onClick() {
      return appendSection();
    },
    label: "Add section",
    Icon: default_1$m,
    sx: styles.addFieldButton
  })));
}
function getSectionProps$1(_ref) {
  var itemIndex = _ref.itemIndex,
    dragHandleProps = _ref.dragHandleProps;
  return {
    sectionIndex: itemIndex,
    dragHandleProps: dragHandleProps
  };
}
function getStyles$3() {
  return {
    nameInput: {
      padding: "0.75rem"
    },
    addFieldButton: {
      margin: "20px 0px 10px 0px"
    },
    submitButton: {
      margin: "30px 0px 5px 0px"
    }
  };
}
var ButtonCenter = styled__default.default(Box$1)({
  display: "flex",
  justifyContent: "center"
});

function ContentBlockEditor(_ref) {
  var submitButtonLabel = _ref.submitButtonLabel,
    onSubmit = _ref.onSubmit,
    isSubmitting = _ref.isSubmitting,
    totalUploads = _ref.totalUploads,
    totalSuccessfulUploads = _ref.totalSuccessfulUploads;
  var _useContentBlockForm = useContentBlockForm(),
    isFormSubmitting = _useContentBlockForm.isSubmitting,
    handleSubmit = _useContentBlockForm.handleSubmit;
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(FormContainer, null, /*#__PURE__*/React__namespace.default.createElement(ControlledInput, {
    path: "name",
    Component: ContentBlockNameInput,
    label: "Card Title"
  }), /*#__PURE__*/React__namespace.default.createElement(ContentSectionsInput, null)), /*#__PURE__*/React__namespace.default.createElement(ButtonBox, null, /*#__PURE__*/React__namespace.default.createElement(ProgressSubmitButton, {
    "data-testid": TEST_IDS.CONTENT_BLOCK_FORM_SUBMIT_BUTTON,
    loading: isSubmitting || isFormSubmitting,
    onClick: handleSubmit(onSubmit),
    total: totalUploads,
    completed: totalSuccessfulUploads
  }, submitButtonLabel)));
}
ContentBlockEditor.propTypes = {
  submitButtonLabel: propTypesExports.string.isRequired,
  onSubmit: propTypesExports.func.isRequired,
  isSubmitting: propTypesExports.bool,
  ButtonComponent: propTypesExports.node,
  totalUploads: propTypesExports.number,
  totalSuccessfulUploads: propTypesExports.number
};
var FormContainer = styled__default.default(material.Box)({
  width: "100%"
});
var ButtonBox = styled__default.default(material.Box)({
  display: "flex",
  justifyContent: "center",
  flexDirection: "row",
  marginTop: 20,
  marginBottom: 20
});

function ContentBlockForm(_ref) {
  var name = _ref.name,
    sections = _ref.sections,
    submitButtonLabel = _ref.submitButtonLabel,
    _onSubmit = _ref.onSubmit,
    isSubmitting = _ref.isSubmitting,
    totalUploads = _ref.totalUploads,
    totalSuccessfulUploads = _ref.totalSuccessfulUploads;
  return /*#__PURE__*/React__namespace.default.createElement(ContentBlockFormProvider, {
    name: name,
    sections: sections
  }, /*#__PURE__*/React__namespace.default.createElement(ContentBlockEditor, {
    submitButtonLabel: submitButtonLabel,
    isSubmitting: isSubmitting,
    onSubmit: function onSubmit(data) {
      return handleOnSubmit({
        data: data,
        onSubmit: _onSubmit,
        sections: sections
      });
    },
    totalUploads: totalUploads,
    totalSuccessfulUploads: totalSuccessfulUploads
  }));
}
function handleOnSubmit(_ref2) {
  var data = _ref2.data,
    onSubmit = _ref2.onSubmit;
  var formattedData = {
    name: data.name,
    sections: removeEmptySectionsAndBlocks(data.sections)
  };
  onSubmit(formattedData);
}
ContentBlockForm.propTypes = {
  name: propTypesExports.string,
  submitButtonLabel: propTypesExports.string.isRequired,
  sections: propTypesExports.array.isRequired,
  onSubmit: propTypesExports.func.isRequired,
  isSubmitting: propTypesExports.bool,
  totalUploads: propTypesExports.number,
  totalSuccessfulUploads: propTypesExports.number
};

function getFormValidationSchema(form) {
  var fields = getFormFields(form);
  return yup__namespace.object(generateSchemaFromFields(fields));
}
function generateSchemaFromFields(fields) {
  return fields.reduce(function (schema, field) {
    return _objectSpread2(_objectSpread2({}, schema), {}, _defineProperty({}, field.id, getFieldValidationSchema(field)));
  }, {});
}
function getFieldValidationSchema(field) {
  var fieldSchema = getBaseFieldSchema({
    field: field
  });
  return addRequiredIfNeeded({
    field: field,
    schema: fieldSchema
  });
}
function getBaseFieldSchema(_ref) {
  var field = _ref.field;
  switch (field.type) {
    case FORM_BUILDER_FIELD_TYPES.CHECKBOXES:
      return yup__namespace.array().of(yup__namespace.string());
    case FORM_BUILDER_FIELD_TYPES.SIGNATURE:
      return yup__namespace.mixed();
    default:
      return yup__namespace.string();
  }
}
function addRequiredIfNeeded(_ref2) {
  var field = _ref2.field,
    schema = _ref2.schema;
  if (!field.is_required) return schema;
  var requiredMessage = getRequiredMessage(field);

  // If the field has an array value, we're using a minimum length of 1 for required.
  // To make sure we don't consider an empty array as a valid value.
  // Otherwise, we can just use a normal required.
  return FORM_BUILDER_FIELD_TYPES_WITH_ARRAY_VALUES.includes(field.type) ? schema.min(1, requiredMessage) : schema.required(requiredMessage);
}
function getRequiredMessage(field) {
  return "".concat(field.title, " is required");
}

var FormBuilderViewContext = /*#__PURE__*/React.createContext();
var useFormSubmissionEditor = function useFormSubmissionEditor() {
  return React.useContext(FormBuilderViewContext);
};
function FormSubmissionEditorProvider(_ref) {
  var form = _ref.form,
    children = _ref.children;
  var configs = getFormConfig({
    initialValues: getInitialValues(form),
    validationSchema: getFormValidationSchema(form),
    validationMode: "onBlur"
  });
  var _useForm = reactHookForm.useForm(configs),
    control = _useForm.control,
    handleSubmit = _useForm.handleSubmit,
    formState = _useForm.formState,
    watch = _useForm.watch,
    getValues = _useForm.getValues;
  var isSubmitting = formState.isSubmitting,
    errors = formState.errors;
  var value = React.useMemo(function () {
    return {
      control: control,
      handleSubmit: handleSubmit,
      isSubmitting: isSubmitting,
      errors: errors,
      watch: watch,
      getValues: getValues,
      form: form
    };
  }, [form, formState]);
  return /*#__PURE__*/React__namespace.default.createElement(FormBuilderViewContext.Provider, {
    value: value
  }, children);
}
FormSubmissionEditorProvider.propTypes = {
  form: propTypesExports.shape({
    id: propTypesExports.string,
    section: propTypesExports.shape({
      fields: propTypesExports.arrayOf(propTypesExports.shape({
        id: propTypesExports.string,
        type: propTypesExports.string,
        title: propTypesExports.string,
        is_required: propTypesExports.bool,
        options: propTypesExports.arrayOf(propTypesExports.shape({
          id: propTypesExports.string,
          value: propTypesExports.string
        }))
      }))
    })
  }),
  children: propTypesExports.any.isRequired
};
function getFormConfig(_ref2) {
  var initialValues = _ref2.initialValues,
    validationSchema = _ref2.validationSchema,
    validationMode = _ref2.validationMode;
  return {
    defaultValues: initialValues,
    resolver: o(validationSchema),
    mode: validationMode,
    reValidateMode: validationMode
  };
}

// We're ignoring sections on the front end for now. All fields are in the first section.
// Reduces form fields to an obect keyed by field id. Answers will be stored in for state
// like this: { field_id: answer } and then mapped to answers after: [{ field_id, answer }]
function getInitialValues(form) {
  var fields = getFormFields(form);
  return fields.reduce(function (initialValues, field) {
    return _objectSpread2(_objectSpread2({}, initialValues), {}, _defineProperty({}, field.id, getFieldInitialValue(field)));
  }, {});
}
function getFieldInitialValue(field) {
  var _field$options, _field$options$;
  switch (field.type) {
    case FORM_BUILDER_FIELD_TYPES.CHECKBOXES:
      return [];
    case FORM_BUILDER_FIELD_TYPES.SIGNATURE:
      return null;
    case FORM_BUILDER_FIELD_TYPES.DROPDOWN:
      return (_field$options = field.options) === null || _field$options === void 0 ? void 0 : (_field$options$ = _field$options[0]) === null || _field$options$ === void 0 ? void 0 : _field$options$.value;
    default:
      return "";
  }
}

function getPermissionsForCompanyAttachment(companyId) {
  return [{
    access_type: CDN_ACCESS_TYPES.READ,
    granted_entity_type: CDN_GRANTED_ENTITY_TYPES.COMPANY,
    granted_entity_id: companyId
  }];
}

function FormSubmissionEditorFormInput(_ref) {
  var field = _ref.field;
  return /*#__PURE__*/React__namespace.default.createElement(ControlledInput, _extends$2({
    key: field.id,
    path: field.id,
    Component: getInputComponent$2(field.type),
    contextHook: useFormSubmissionEditor
  }, getInputComponentProps(field)));
}
FormSubmissionEditorFormInput.propTypes = {
  field: propTypesExports.shape({
    id: propTypesExports.string,
    title: propTypesExports.string,
    type: propTypesExports.string
  })
};

function FormSubmissionEditorForm(_ref) {
  var onCompleted = _ref.onCompleted;
  var _useFormSubmissionEdi = useFormSubmissionEditor(),
    isSubmitting = _useFormSubmissionEdi.isSubmitting,
    handleSubmit = _useFormSubmissionEdi.handleSubmit,
    form = _useFormSubmissionEdi.form;
  var formFields = getFormFields(form);
  var _useHandleFormSubmiss = useHandleFormSubmission({
      form: form,
      formFields: formFields,
      onCompleted: onCompleted
    }),
    handleFormSubmission = _useHandleFormSubmiss.handleFormSubmission,
    isLoading = _useHandleFormSubmiss.isLoading;
  return /*#__PURE__*/React__namespace.default.createElement(Container$9, null, formFields.map(function (field) {
    return /*#__PURE__*/React__namespace.default.createElement(FormSubmissionEditorFormInput, {
      key: field.id,
      field: field
    });
  }), /*#__PURE__*/React__namespace.default.createElement(ButtonContainer, null, /*#__PURE__*/React__namespace.default.createElement(Button, {
    variant: "contained",
    onClick: handleSubmit(handleFormSubmission),
    loading: isLoading || isSubmitting
  }, "Submit")));
}
FormSubmissionEditorForm.propTypes = {
  onCompleted: propTypesExports.func.isRequired
};
var Container$9 = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return _defineProperty({
    display: "flex",
    flexDirection: "column",
    gap: 10,
    padding: "0 20px"
  }, theme.breakpoints.down("sm"), {
    padding: "0"
  });
});
var ButtonContainer = styled__default.default(Box$1)({
  display: "flex",
  justifyContent: "flex-end",
  padding: "20px 0"
});
function useHandleFormSubmission(_ref4) {
  var form = _ref4.form,
    formFields = _ref4.formFields,
    onCompleted = _ref4.onCompleted;
  var _useSnackBar = useSnackBar(),
    showError = _useSnackBar.showError;
  var _useFormSubmissions = useFormSubmissions(),
    companyId = _useFormSubmissions.companyId,
    useCreateFormSubmission = _useFormSubmissions.useCreateFormSubmission,
    useUploadAttachment = _useFormSubmissions.useUploadAttachment;
  var _useCreateFormSubmiss = useCreateFormSubmission({
      onCompleted: onCompleted
    }),
    createFormSubmission = _useCreateFormSubmiss.createFormSubmission,
    isLoading = _useCreateFormSubmiss.isLoading;
  var uploadAttachment = useUploadAttachment();
  var handleFormSubmission = function handleFormSubmission(values) {
    return handleFormSubmissionCore({
      values: values,
      createFormSubmission: createFormSubmission,
      uploadAttachment: uploadAttachment,
      formFields: formFields,
      showError: showError,
      form: form,
      companyId: companyId
    });
  };
  return {
    handleFormSubmission: handleFormSubmission,
    isLoading: isLoading
  };
}

// Values are keyed by field id.
function handleFormSubmissionCore(_x) {
  return _handleFormSubmissionCore.apply(this, arguments);
}
function _handleFormSubmissionCore() {
  _handleFormSubmissionCore = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref5) {
    var values, createFormSubmission, uploadAttachment, formFields, showError, form, companyId, fieldIds, answers, uploadedAnswers;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          values = _ref5.values, createFormSubmission = _ref5.createFormSubmission, uploadAttachment = _ref5.uploadAttachment, formFields = _ref5.formFields, showError = _ref5.showError, form = _ref5.form, companyId = _ref5.companyId;
          fieldIds = Object.keys(values);
          answers = fieldIds.map(function (fieldId) {
            return {
              field_id: fieldId,
              answer: values[fieldId]
            };
          });
          _context.next = 5;
          return uploadAnswersAttachments({
            answers: answers,
            uploadAttachment: uploadAttachment,
            formFields: formFields,
            showError: showError,
            companyId: companyId
          });
        case 5:
          uploadedAnswers = _context.sent;
          if (uploadedAnswers) {
            _context.next = 8;
            break;
          }
          return _context.abrupt("return");
        case 8:
          createFormSubmission({
            formId: form.id,
            answers: uploadedAnswers
          });
        case 9:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _handleFormSubmissionCore.apply(this, arguments);
}
function uploadAnswersAttachments(_x2) {
  return _uploadAnswersAttachments.apply(this, arguments);
}
function _uploadAnswersAttachments() {
  _uploadAnswersAttachments = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2(_ref6) {
    var answers, uploadAttachment, formFields, showError, companyId, uploadedAnswers;
    return _regeneratorRuntime().wrap(function _callee2$(_context2) {
      while (1) switch (_context2.prev = _context2.next) {
        case 0:
          answers = _ref6.answers, uploadAttachment = _ref6.uploadAttachment, formFields = _ref6.formFields, showError = _ref6.showError, companyId = _ref6.companyId;
          _context2.prev = 1;
          _context2.next = 4;
          return uploadAnswersAttachmentsCore({
            answers: answers,
            uploadAttachment: uploadAttachment,
            formFields: formFields,
            companyId: companyId
          });
        case 4:
          uploadedAnswers = _context2.sent;
          return _context2.abrupt("return", uploadedAnswers);
        case 8:
          _context2.prev = 8;
          _context2.t0 = _context2["catch"](1);
          // Error will be logged by upload attachment hook.
          showError({
            error: new Error(SIGNATURE_UPLOAD_ERROR)
          });
          return _context2.abrupt("return", null);
        case 12:
        case "end":
          return _context2.stop();
      }
    }, _callee2, null, [[1, 8]]);
  }));
  return _uploadAnswersAttachments.apply(this, arguments);
}
function uploadAnswersAttachmentsCore(_x3) {
  return _uploadAnswersAttachmentsCore.apply(this, arguments);
}
function _uploadAnswersAttachmentsCore() {
  _uploadAnswersAttachmentsCore = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3(_ref7) {
    var answers, uploadAttachment, formFields, companyId, promises, uploadedAnswers;
    return _regeneratorRuntime().wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          answers = _ref7.answers, uploadAttachment = _ref7.uploadAttachment, formFields = _ref7.formFields, companyId = _ref7.companyId;
          promises = answers.map(function (answer) {
            return uploadSignatureAttachmentForAnswerIfNeeded({
              answer: answer,
              uploadAttachment: uploadAttachment,
              formFields: formFields,
              companyId: companyId
            });
          }); // eslint-disable-next-line promise/no-native
          _context3.next = 4;
          return Promise.all(promises);
        case 4:
          uploadedAnswers = _context3.sent;
          return _context3.abrupt("return", uploadedAnswers);
        case 6:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return _uploadAnswersAttachmentsCore.apply(this, arguments);
}
function uploadSignatureAttachmentForAnswerIfNeeded(_x4) {
  return _uploadSignatureAttachmentForAnswerIfNeeded.apply(this, arguments);
} // Converts objectUrl to blob using fetch, so it can be read by FileReader in uploadAttachment.
// Returns null if there's no objectUrl. This prevents uploading an empty blob for empty signatures.
function _uploadSignatureAttachmentForAnswerIfNeeded() {
  _uploadSignatureAttachmentForAnswerIfNeeded = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee4(_ref8) {
    var answer, uploadAttachment, formFields, companyId, attachmentId;
    return _regeneratorRuntime().wrap(function _callee4$(_context4) {
      while (1) switch (_context4.prev = _context4.next) {
        case 0:
          answer = _ref8.answer, uploadAttachment = _ref8.uploadAttachment, formFields = _ref8.formFields, companyId = _ref8.companyId;
          if (isSignatureFieldAnswer({
            answer: answer,
            formFields: formFields
          })) {
            _context4.next = 3;
            break;
          }
          return _context4.abrupt("return", answer);
        case 3:
          _context4.next = 5;
          return uploadSignatureAttachment({
            objectUrl: answer.answer,
            uploadAttachment: uploadAttachment,
            companyId: companyId
          });
        case 5:
          attachmentId = _context4.sent;
          return _context4.abrupt("return", _objectSpread2(_objectSpread2({}, answer), {}, {
            answer: attachmentId
          }));
        case 7:
        case "end":
          return _context4.stop();
      }
    }, _callee4);
  }));
  return _uploadSignatureAttachmentForAnswerIfNeeded.apply(this, arguments);
}
function uploadSignatureAttachment(_x5) {
  return _uploadSignatureAttachment.apply(this, arguments);
}
function _uploadSignatureAttachment() {
  _uploadSignatureAttachment = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee5(_ref9) {
    var objectUrl, uploadAttachment, companyId, response, blob, uploadedAttachment;
    return _regeneratorRuntime().wrap(function _callee5$(_context5) {
      while (1) switch (_context5.prev = _context5.next) {
        case 0:
          objectUrl = _ref9.objectUrl, uploadAttachment = _ref9.uploadAttachment, companyId = _ref9.companyId;
          if (objectUrl) {
            _context5.next = 3;
            break;
          }
          return _context5.abrupt("return", null);
        case 3:
          _context5.next = 5;
          return fetch(objectUrl);
        case 5:
          response = _context5.sent;
          _context5.next = 8;
          return response.blob();
        case 8:
          blob = _context5.sent;
          _context5.next = 11;
          return uploadAttachment({
            attachment: blob,
            permissions: getPermissionsForCompanyAttachment(companyId)
          });
        case 11:
          uploadedAttachment = _context5.sent;
          return _context5.abrupt("return", uploadedAttachment.id);
        case 13:
        case "end":
          return _context5.stop();
      }
    }, _callee5);
  }));
  return _uploadSignatureAttachment.apply(this, arguments);
}
function isSignatureFieldAnswer(_ref10) {
  var answer = _ref10.answer,
    formFields = _ref10.formFields;
  var answerField = formFields.find(function (field) {
    return field.id === answer.field_id;
  });
  return answerField.type === FORM_BUILDER_FIELD_TYPES.SIGNATURE;
}

function requiredArgs(required, args) {
  if (args.length < required) {
    throw new TypeError(required + ' argument' + (required > 1 ? 's' : '') + ' required, but only ' + args.length + ' present');
  }
}

function _typeof$1(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof$1 = function _typeof(obj) { return typeof obj; }; } else { _typeof$1 = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof$1(obj); }
/**
 * @name isDate
 * @category Common Helpers
 * @summary Is the given value a date?
 *
 * @description
 * Returns true if the given value is an instance of Date. The function works for dates transferred across iframes.
 *
 * @param {*} value - the value to check
 * @returns {boolean} true if the given value is a date
 * @throws {TypeError} 1 arguments required
 *
 * @example
 * // For a valid date:
 * const result = isDate(new Date())
 * //=> true
 *
 * @example
 * // For an invalid date:
 * const result = isDate(new Date(NaN))
 * //=> true
 *
 * @example
 * // For some value:
 * const result = isDate('2014-02-31')
 * //=> false
 *
 * @example
 * // For an object:
 * const result = isDate({})
 * //=> false
 */

function isDate(value) {
  requiredArgs(1, arguments);
  return value instanceof Date || _typeof$1(value) === 'object' && Object.prototype.toString.call(value) === '[object Date]';
}

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }
/**
 * @name toDate
 * @category Common Helpers
 * @summary Convert the given argument to an instance of Date.
 *
 * @description
 * Convert the given argument to an instance of Date.
 *
 * If the argument is an instance of Date, the function returns its clone.
 *
 * If the argument is a number, it is treated as a timestamp.
 *
 * If the argument is none of the above, the function returns Invalid Date.
 *
 * **Note**: *all* Date arguments passed to any *date-fns* function is processed by `toDate`.
 *
 * @param {Date|Number} argument - the value to convert
 * @returns {Date} the parsed date in the local time zone
 * @throws {TypeError} 1 argument required
 *
 * @example
 * // Clone the date:
 * const result = toDate(new Date(2014, 1, 11, 11, 30, 30))
 * //=> Tue Feb 11 2014 11:30:30
 *
 * @example
 * // Convert the timestamp to date:
 * const result = toDate(1392098430000)
 * //=> Tue Feb 11 2014 11:30:30
 */

function toDate(argument) {
  requiredArgs(1, arguments);
  var argStr = Object.prototype.toString.call(argument); // Clone the date

  if (argument instanceof Date || _typeof(argument) === 'object' && argStr === '[object Date]') {
    // Prevent the date to lose the milliseconds when passed to new Date() in IE10
    return new Date(argument.getTime());
  } else if (typeof argument === 'number' || argStr === '[object Number]') {
    return new Date(argument);
  } else {
    if ((typeof argument === 'string' || argStr === '[object String]') && typeof console !== 'undefined') {
      // eslint-disable-next-line no-console
      console.warn("Starting with v2.0.0-beta.1 date-fns doesn't accept strings as date arguments. Please use `parseISO` to parse strings. See: https://github.com/date-fns/date-fns/blob/master/docs/upgradeGuide.md#string-arguments"); // eslint-disable-next-line no-console

      console.warn(new Error().stack);
    }

    return new Date(NaN);
  }
}

/**
 * @name isValid
 * @category Common Helpers
 * @summary Is the given date valid?
 *
 * @description
 * Returns false if argument is Invalid Date and true otherwise.
 * Argument is converted to Date using `toDate`. See [toDate]{@link https://date-fns.org/docs/toDate}
 * Invalid Date is a Date, whose time value is NaN.
 *
 * Time value of Date: http://es5.github.io/#x15.9.1.1
 *
 * @param {*} date - the date to check
 * @returns {Boolean} the date is valid
 * @throws {TypeError} 1 argument required
 *
 * @example
 * // For the valid date:
 * const result = isValid(new Date(2014, 1, 31))
 * //=> true
 *
 * @example
 * // For the value, convertable into a date:
 * const result = isValid(1393804800000)
 * //=> true
 *
 * @example
 * // For the invalid date:
 * const result = isValid(new Date(''))
 * //=> false
 */

function isValid(dirtyDate) {
  requiredArgs(1, arguments);

  if (!isDate(dirtyDate) && typeof dirtyDate !== 'number') {
    return false;
  }

  var date = toDate(dirtyDate);
  return !isNaN(Number(date));
}

function toInteger(dirtyNumber) {
  if (dirtyNumber === null || dirtyNumber === true || dirtyNumber === false) {
    return NaN;
  }

  var number = Number(dirtyNumber);

  if (isNaN(number)) {
    return number;
  }

  return number < 0 ? Math.ceil(number) : Math.floor(number);
}

/**
 * @name addMilliseconds
 * @category Millisecond Helpers
 * @summary Add the specified number of milliseconds to the given date.
 *
 * @description
 * Add the specified number of milliseconds to the given date.
 *
 * @param {Date|Number} date - the date to be changed
 * @param {Number} amount - the amount of milliseconds to be added. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
 * @returns {Date} the new date with the milliseconds added
 * @throws {TypeError} 2 arguments required
 *
 * @example
 * // Add 750 milliseconds to 10 July 2014 12:45:30.000:
 * const result = addMilliseconds(new Date(2014, 6, 10, 12, 45, 30, 0), 750)
 * //=> Thu Jul 10 2014 12:45:30.750
 */

function addMilliseconds(dirtyDate, dirtyAmount) {
  requiredArgs(2, arguments);
  var timestamp = toDate(dirtyDate).getTime();
  var amount = toInteger(dirtyAmount);
  return new Date(timestamp + amount);
}

/**
 * @name subMilliseconds
 * @category Millisecond Helpers
 * @summary Subtract the specified number of milliseconds from the given date.
 *
 * @description
 * Subtract the specified number of milliseconds from the given date.
 *
 * @param {Date|Number} date - the date to be changed
 * @param {Number} amount - the amount of milliseconds to be subtracted. Positive decimals will be rounded using `Math.floor`, decimals less than zero will be rounded using `Math.ceil`.
 * @returns {Date} the new date with the milliseconds subtracted
 * @throws {TypeError} 2 arguments required
 *
 * @example
 * // Subtract 750 milliseconds from 10 July 2014 12:45:30.000:
 * const result = subMilliseconds(new Date(2014, 6, 10, 12, 45, 30, 0), 750)
 * //=> Thu Jul 10 2014 12:45:29.250
 */

function subMilliseconds(dirtyDate, dirtyAmount) {
  requiredArgs(2, arguments);
  var amount = toInteger(dirtyAmount);
  return addMilliseconds(dirtyDate, -amount);
}

var MILLISECONDS_IN_DAY = 86400000;
function getUTCDayOfYear(dirtyDate) {
  requiredArgs(1, arguments);
  var date = toDate(dirtyDate);
  var timestamp = date.getTime();
  date.setUTCMonth(0, 1);
  date.setUTCHours(0, 0, 0, 0);
  var startOfYearTimestamp = date.getTime();
  var difference = timestamp - startOfYearTimestamp;
  return Math.floor(difference / MILLISECONDS_IN_DAY) + 1;
}

function startOfUTCISOWeek(dirtyDate) {
  requiredArgs(1, arguments);
  var weekStartsOn = 1;
  var date = toDate(dirtyDate);
  var day = date.getUTCDay();
  var diff = (day < weekStartsOn ? 7 : 0) + day - weekStartsOn;
  date.setUTCDate(date.getUTCDate() - diff);
  date.setUTCHours(0, 0, 0, 0);
  return date;
}

function getUTCISOWeekYear(dirtyDate) {
  requiredArgs(1, arguments);
  var date = toDate(dirtyDate);
  var year = date.getUTCFullYear();
  var fourthOfJanuaryOfNextYear = new Date(0);
  fourthOfJanuaryOfNextYear.setUTCFullYear(year + 1, 0, 4);
  fourthOfJanuaryOfNextYear.setUTCHours(0, 0, 0, 0);
  var startOfNextYear = startOfUTCISOWeek(fourthOfJanuaryOfNextYear);
  var fourthOfJanuaryOfThisYear = new Date(0);
  fourthOfJanuaryOfThisYear.setUTCFullYear(year, 0, 4);
  fourthOfJanuaryOfThisYear.setUTCHours(0, 0, 0, 0);
  var startOfThisYear = startOfUTCISOWeek(fourthOfJanuaryOfThisYear);

  if (date.getTime() >= startOfNextYear.getTime()) {
    return year + 1;
  } else if (date.getTime() >= startOfThisYear.getTime()) {
    return year;
  } else {
    return year - 1;
  }
}

function startOfUTCISOWeekYear(dirtyDate) {
  requiredArgs(1, arguments);
  var year = getUTCISOWeekYear(dirtyDate);
  var fourthOfJanuary = new Date(0);
  fourthOfJanuary.setUTCFullYear(year, 0, 4);
  fourthOfJanuary.setUTCHours(0, 0, 0, 0);
  var date = startOfUTCISOWeek(fourthOfJanuary);
  return date;
}

var MILLISECONDS_IN_WEEK$1 = 604800000;
function getUTCISOWeek(dirtyDate) {
  requiredArgs(1, arguments);
  var date = toDate(dirtyDate);
  var diff = startOfUTCISOWeek(date).getTime() - startOfUTCISOWeekYear(date).getTime(); // Round the number of days to the nearest integer
  // because the number of milliseconds in a week is not constant
  // (e.g. it's different in the week of the daylight saving time clock shift)

  return Math.round(diff / MILLISECONDS_IN_WEEK$1) + 1;
}

var defaultOptions = {};
function getDefaultOptions() {
  return defaultOptions;
}

function startOfUTCWeek(dirtyDate, options) {
  var _ref, _ref2, _ref3, _options$weekStartsOn, _options$locale, _options$locale$optio, _defaultOptions$local, _defaultOptions$local2;

  requiredArgs(1, arguments);
  var defaultOptions = getDefaultOptions();
  var weekStartsOn = toInteger((_ref = (_ref2 = (_ref3 = (_options$weekStartsOn = options === null || options === void 0 ? void 0 : options.weekStartsOn) !== null && _options$weekStartsOn !== void 0 ? _options$weekStartsOn : options === null || options === void 0 ? void 0 : (_options$locale = options.locale) === null || _options$locale === void 0 ? void 0 : (_options$locale$optio = _options$locale.options) === null || _options$locale$optio === void 0 ? void 0 : _options$locale$optio.weekStartsOn) !== null && _ref3 !== void 0 ? _ref3 : defaultOptions.weekStartsOn) !== null && _ref2 !== void 0 ? _ref2 : (_defaultOptions$local = defaultOptions.locale) === null || _defaultOptions$local === void 0 ? void 0 : (_defaultOptions$local2 = _defaultOptions$local.options) === null || _defaultOptions$local2 === void 0 ? void 0 : _defaultOptions$local2.weekStartsOn) !== null && _ref !== void 0 ? _ref : 0); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

  if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
    throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
  }

  var date = toDate(dirtyDate);
  var day = date.getUTCDay();
  var diff = (day < weekStartsOn ? 7 : 0) + day - weekStartsOn;
  date.setUTCDate(date.getUTCDate() - diff);
  date.setUTCHours(0, 0, 0, 0);
  return date;
}

function getUTCWeekYear(dirtyDate, options) {
  var _ref, _ref2, _ref3, _options$firstWeekCon, _options$locale, _options$locale$optio, _defaultOptions$local, _defaultOptions$local2;

  requiredArgs(1, arguments);
  var date = toDate(dirtyDate);
  var year = date.getUTCFullYear();
  var defaultOptions = getDefaultOptions();
  var firstWeekContainsDate = toInteger((_ref = (_ref2 = (_ref3 = (_options$firstWeekCon = options === null || options === void 0 ? void 0 : options.firstWeekContainsDate) !== null && _options$firstWeekCon !== void 0 ? _options$firstWeekCon : options === null || options === void 0 ? void 0 : (_options$locale = options.locale) === null || _options$locale === void 0 ? void 0 : (_options$locale$optio = _options$locale.options) === null || _options$locale$optio === void 0 ? void 0 : _options$locale$optio.firstWeekContainsDate) !== null && _ref3 !== void 0 ? _ref3 : defaultOptions.firstWeekContainsDate) !== null && _ref2 !== void 0 ? _ref2 : (_defaultOptions$local = defaultOptions.locale) === null || _defaultOptions$local === void 0 ? void 0 : (_defaultOptions$local2 = _defaultOptions$local.options) === null || _defaultOptions$local2 === void 0 ? void 0 : _defaultOptions$local2.firstWeekContainsDate) !== null && _ref !== void 0 ? _ref : 1); // Test if weekStartsOn is between 1 and 7 _and_ is not NaN

  if (!(firstWeekContainsDate >= 1 && firstWeekContainsDate <= 7)) {
    throw new RangeError('firstWeekContainsDate must be between 1 and 7 inclusively');
  }

  var firstWeekOfNextYear = new Date(0);
  firstWeekOfNextYear.setUTCFullYear(year + 1, 0, firstWeekContainsDate);
  firstWeekOfNextYear.setUTCHours(0, 0, 0, 0);
  var startOfNextYear = startOfUTCWeek(firstWeekOfNextYear, options);
  var firstWeekOfThisYear = new Date(0);
  firstWeekOfThisYear.setUTCFullYear(year, 0, firstWeekContainsDate);
  firstWeekOfThisYear.setUTCHours(0, 0, 0, 0);
  var startOfThisYear = startOfUTCWeek(firstWeekOfThisYear, options);

  if (date.getTime() >= startOfNextYear.getTime()) {
    return year + 1;
  } else if (date.getTime() >= startOfThisYear.getTime()) {
    return year;
  } else {
    return year - 1;
  }
}

function startOfUTCWeekYear(dirtyDate, options) {
  var _ref, _ref2, _ref3, _options$firstWeekCon, _options$locale, _options$locale$optio, _defaultOptions$local, _defaultOptions$local2;

  requiredArgs(1, arguments);
  var defaultOptions = getDefaultOptions();
  var firstWeekContainsDate = toInteger((_ref = (_ref2 = (_ref3 = (_options$firstWeekCon = options === null || options === void 0 ? void 0 : options.firstWeekContainsDate) !== null && _options$firstWeekCon !== void 0 ? _options$firstWeekCon : options === null || options === void 0 ? void 0 : (_options$locale = options.locale) === null || _options$locale === void 0 ? void 0 : (_options$locale$optio = _options$locale.options) === null || _options$locale$optio === void 0 ? void 0 : _options$locale$optio.firstWeekContainsDate) !== null && _ref3 !== void 0 ? _ref3 : defaultOptions.firstWeekContainsDate) !== null && _ref2 !== void 0 ? _ref2 : (_defaultOptions$local = defaultOptions.locale) === null || _defaultOptions$local === void 0 ? void 0 : (_defaultOptions$local2 = _defaultOptions$local.options) === null || _defaultOptions$local2 === void 0 ? void 0 : _defaultOptions$local2.firstWeekContainsDate) !== null && _ref !== void 0 ? _ref : 1);
  var year = getUTCWeekYear(dirtyDate, options);
  var firstWeek = new Date(0);
  firstWeek.setUTCFullYear(year, 0, firstWeekContainsDate);
  firstWeek.setUTCHours(0, 0, 0, 0);
  var date = startOfUTCWeek(firstWeek, options);
  return date;
}

var MILLISECONDS_IN_WEEK = 604800000;
function getUTCWeek(dirtyDate, options) {
  requiredArgs(1, arguments);
  var date = toDate(dirtyDate);
  var diff = startOfUTCWeek(date, options).getTime() - startOfUTCWeekYear(date, options).getTime(); // Round the number of days to the nearest integer
  // because the number of milliseconds in a week is not constant
  // (e.g. it's different in the week of the daylight saving time clock shift)

  return Math.round(diff / MILLISECONDS_IN_WEEK) + 1;
}

function addLeadingZeros(number, targetLength) {
  var sign = number < 0 ? '-' : '';
  var output = Math.abs(number).toString();

  while (output.length < targetLength) {
    output = '0' + output;
  }

  return sign + output;
}

/*
 * |     | Unit                           |     | Unit                           |
 * |-----|--------------------------------|-----|--------------------------------|
 * |  a  | AM, PM                         |  A* |                                |
 * |  d  | Day of month                   |  D  |                                |
 * |  h  | Hour [1-12]                    |  H  | Hour [0-23]                    |
 * |  m  | Minute                         |  M  | Month                          |
 * |  s  | Second                         |  S  | Fraction of second             |
 * |  y  | Year (abs)                     |  Y  |                                |
 *
 * Letters marked by * are not implemented but reserved by Unicode standard.
 */

var formatters$2 = {
  // Year
  y: function y(date, token) {
    // From http://www.unicode.org/reports/tr35/tr35-31/tr35-dates.html#Date_Format_tokens
    // | Year     |     y | yy |   yyy |  yyyy | yyyyy |
    // |----------|-------|----|-------|-------|-------|
    // | AD 1     |     1 | 01 |   001 |  0001 | 00001 |
    // | AD 12    |    12 | 12 |   012 |  0012 | 00012 |
    // | AD 123   |   123 | 23 |   123 |  0123 | 00123 |
    // | AD 1234  |  1234 | 34 |  1234 |  1234 | 01234 |
    // | AD 12345 | 12345 | 45 | 12345 | 12345 | 12345 |
    var signedYear = date.getUTCFullYear(); // Returns 1 for 1 BC (which is year 0 in JavaScript)

    var year = signedYear > 0 ? signedYear : 1 - signedYear;
    return addLeadingZeros(token === 'yy' ? year % 100 : year, token.length);
  },
  // Month
  M: function M(date, token) {
    var month = date.getUTCMonth();
    return token === 'M' ? String(month + 1) : addLeadingZeros(month + 1, 2);
  },
  // Day of the month
  d: function d(date, token) {
    return addLeadingZeros(date.getUTCDate(), token.length);
  },
  // AM or PM
  a: function a(date, token) {
    var dayPeriodEnumValue = date.getUTCHours() / 12 >= 1 ? 'pm' : 'am';

    switch (token) {
      case 'a':
      case 'aa':
        return dayPeriodEnumValue.toUpperCase();

      case 'aaa':
        return dayPeriodEnumValue;

      case 'aaaaa':
        return dayPeriodEnumValue[0];

      case 'aaaa':
      default:
        return dayPeriodEnumValue === 'am' ? 'a.m.' : 'p.m.';
    }
  },
  // Hour [1-12]
  h: function h(date, token) {
    return addLeadingZeros(date.getUTCHours() % 12 || 12, token.length);
  },
  // Hour [0-23]
  H: function H(date, token) {
    return addLeadingZeros(date.getUTCHours(), token.length);
  },
  // Minute
  m: function m(date, token) {
    return addLeadingZeros(date.getUTCMinutes(), token.length);
  },
  // Second
  s: function s(date, token) {
    return addLeadingZeros(date.getUTCSeconds(), token.length);
  },
  // Fraction of second
  S: function S(date, token) {
    var numberOfDigits = token.length;
    var milliseconds = date.getUTCMilliseconds();
    var fractionalSeconds = Math.floor(milliseconds * Math.pow(10, numberOfDigits - 3));
    return addLeadingZeros(fractionalSeconds, token.length);
  }
};
var lightFormatters = formatters$2;

var dayPeriodEnum = {
  am: 'am',
  pm: 'pm',
  midnight: 'midnight',
  noon: 'noon',
  morning: 'morning',
  afternoon: 'afternoon',
  evening: 'evening',
  night: 'night'
};

/*
 * |     | Unit                           |     | Unit                           |
 * |-----|--------------------------------|-----|--------------------------------|
 * |  a  | AM, PM                         |  A* | Milliseconds in day            |
 * |  b  | AM, PM, noon, midnight         |  B  | Flexible day period            |
 * |  c  | Stand-alone local day of week  |  C* | Localized hour w/ day period   |
 * |  d  | Day of month                   |  D  | Day of year                    |
 * |  e  | Local day of week              |  E  | Day of week                    |
 * |  f  |                                |  F* | Day of week in month           |
 * |  g* | Modified Julian day            |  G  | Era                            |
 * |  h  | Hour [1-12]                    |  H  | Hour [0-23]                    |
 * |  i! | ISO day of week                |  I! | ISO week of year               |
 * |  j* | Localized hour w/ day period   |  J* | Localized hour w/o day period  |
 * |  k  | Hour [1-24]                    |  K  | Hour [0-11]                    |
 * |  l* | (deprecated)                   |  L  | Stand-alone month              |
 * |  m  | Minute                         |  M  | Month                          |
 * |  n  |                                |  N  |                                |
 * |  o! | Ordinal number modifier        |  O  | Timezone (GMT)                 |
 * |  p! | Long localized time            |  P! | Long localized date            |
 * |  q  | Stand-alone quarter            |  Q  | Quarter                        |
 * |  r* | Related Gregorian year         |  R! | ISO week-numbering year        |
 * |  s  | Second                         |  S  | Fraction of second             |
 * |  t! | Seconds timestamp              |  T! | Milliseconds timestamp         |
 * |  u  | Extended year                  |  U* | Cyclic year                    |
 * |  v* | Timezone (generic non-locat.)  |  V* | Timezone (location)            |
 * |  w  | Local week of year             |  W* | Week of month                  |
 * |  x  | Timezone (ISO-8601 w/o Z)      |  X  | Timezone (ISO-8601)            |
 * |  y  | Year (abs)                     |  Y  | Local week-numbering year      |
 * |  z  | Timezone (specific non-locat.) |  Z* | Timezone (aliases)             |
 *
 * Letters marked by * are not implemented but reserved by Unicode standard.
 *
 * Letters marked by ! are non-standard, but implemented by date-fns:
 * - `o` modifies the previous token to turn it into an ordinal (see `format` docs)
 * - `i` is ISO day of week. For `i` and `ii` is returns numeric ISO week days,
 *   i.e. 7 for Sunday, 1 for Monday, etc.
 * - `I` is ISO week of year, as opposed to `w` which is local week of year.
 * - `R` is ISO week-numbering year, as opposed to `Y` which is local week-numbering year.
 *   `R` is supposed to be used in conjunction with `I` and `i`
 *   for universal ISO week-numbering date, whereas
 *   `Y` is supposed to be used in conjunction with `w` and `e`
 *   for week-numbering date specific to the locale.
 * - `P` is long localized date format
 * - `p` is long localized time format
 */
var formatters = {
  // Era
  G: function G(date, token, localize) {
    var era = date.getUTCFullYear() > 0 ? 1 : 0;

    switch (token) {
      // AD, BC
      case 'G':
      case 'GG':
      case 'GGG':
        return localize.era(era, {
          width: 'abbreviated'
        });
      // A, B

      case 'GGGGG':
        return localize.era(era, {
          width: 'narrow'
        });
      // Anno Domini, Before Christ

      case 'GGGG':
      default:
        return localize.era(era, {
          width: 'wide'
        });
    }
  },
  // Year
  y: function y(date, token, localize) {
    // Ordinal number
    if (token === 'yo') {
      var signedYear = date.getUTCFullYear(); // Returns 1 for 1 BC (which is year 0 in JavaScript)

      var year = signedYear > 0 ? signedYear : 1 - signedYear;
      return localize.ordinalNumber(year, {
        unit: 'year'
      });
    }

    return lightFormatters.y(date, token);
  },
  // Local week-numbering year
  Y: function Y(date, token, localize, options) {
    var signedWeekYear = getUTCWeekYear(date, options); // Returns 1 for 1 BC (which is year 0 in JavaScript)

    var weekYear = signedWeekYear > 0 ? signedWeekYear : 1 - signedWeekYear; // Two digit year

    if (token === 'YY') {
      var twoDigitYear = weekYear % 100;
      return addLeadingZeros(twoDigitYear, 2);
    } // Ordinal number


    if (token === 'Yo') {
      return localize.ordinalNumber(weekYear, {
        unit: 'year'
      });
    } // Padding


    return addLeadingZeros(weekYear, token.length);
  },
  // ISO week-numbering year
  R: function R(date, token) {
    var isoWeekYear = getUTCISOWeekYear(date); // Padding

    return addLeadingZeros(isoWeekYear, token.length);
  },
  // Extended year. This is a single number designating the year of this calendar system.
  // The main difference between `y` and `u` localizers are B.C. years:
  // | Year | `y` | `u` |
  // |------|-----|-----|
  // | AC 1 |   1 |   1 |
  // | BC 1 |   1 |   0 |
  // | BC 2 |   2 |  -1 |
  // Also `yy` always returns the last two digits of a year,
  // while `uu` pads single digit years to 2 characters and returns other years unchanged.
  u: function u(date, token) {
    var year = date.getUTCFullYear();
    return addLeadingZeros(year, token.length);
  },
  // Quarter
  Q: function Q(date, token, localize) {
    var quarter = Math.ceil((date.getUTCMonth() + 1) / 3);

    switch (token) {
      // 1, 2, 3, 4
      case 'Q':
        return String(quarter);
      // 01, 02, 03, 04

      case 'QQ':
        return addLeadingZeros(quarter, 2);
      // 1st, 2nd, 3rd, 4th

      case 'Qo':
        return localize.ordinalNumber(quarter, {
          unit: 'quarter'
        });
      // Q1, Q2, Q3, Q4

      case 'QQQ':
        return localize.quarter(quarter, {
          width: 'abbreviated',
          context: 'formatting'
        });
      // 1, 2, 3, 4 (narrow quarter; could be not numerical)

      case 'QQQQQ':
        return localize.quarter(quarter, {
          width: 'narrow',
          context: 'formatting'
        });
      // 1st quarter, 2nd quarter, ...

      case 'QQQQ':
      default:
        return localize.quarter(quarter, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // Stand-alone quarter
  q: function q(date, token, localize) {
    var quarter = Math.ceil((date.getUTCMonth() + 1) / 3);

    switch (token) {
      // 1, 2, 3, 4
      case 'q':
        return String(quarter);
      // 01, 02, 03, 04

      case 'qq':
        return addLeadingZeros(quarter, 2);
      // 1st, 2nd, 3rd, 4th

      case 'qo':
        return localize.ordinalNumber(quarter, {
          unit: 'quarter'
        });
      // Q1, Q2, Q3, Q4

      case 'qqq':
        return localize.quarter(quarter, {
          width: 'abbreviated',
          context: 'standalone'
        });
      // 1, 2, 3, 4 (narrow quarter; could be not numerical)

      case 'qqqqq':
        return localize.quarter(quarter, {
          width: 'narrow',
          context: 'standalone'
        });
      // 1st quarter, 2nd quarter, ...

      case 'qqqq':
      default:
        return localize.quarter(quarter, {
          width: 'wide',
          context: 'standalone'
        });
    }
  },
  // Month
  M: function M(date, token, localize) {
    var month = date.getUTCMonth();

    switch (token) {
      case 'M':
      case 'MM':
        return lightFormatters.M(date, token);
      // 1st, 2nd, ..., 12th

      case 'Mo':
        return localize.ordinalNumber(month + 1, {
          unit: 'month'
        });
      // Jan, Feb, ..., Dec

      case 'MMM':
        return localize.month(month, {
          width: 'abbreviated',
          context: 'formatting'
        });
      // J, F, ..., D

      case 'MMMMM':
        return localize.month(month, {
          width: 'narrow',
          context: 'formatting'
        });
      // January, February, ..., December

      case 'MMMM':
      default:
        return localize.month(month, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // Stand-alone month
  L: function L(date, token, localize) {
    var month = date.getUTCMonth();

    switch (token) {
      // 1, 2, ..., 12
      case 'L':
        return String(month + 1);
      // 01, 02, ..., 12

      case 'LL':
        return addLeadingZeros(month + 1, 2);
      // 1st, 2nd, ..., 12th

      case 'Lo':
        return localize.ordinalNumber(month + 1, {
          unit: 'month'
        });
      // Jan, Feb, ..., Dec

      case 'LLL':
        return localize.month(month, {
          width: 'abbreviated',
          context: 'standalone'
        });
      // J, F, ..., D

      case 'LLLLL':
        return localize.month(month, {
          width: 'narrow',
          context: 'standalone'
        });
      // January, February, ..., December

      case 'LLLL':
      default:
        return localize.month(month, {
          width: 'wide',
          context: 'standalone'
        });
    }
  },
  // Local week of year
  w: function w(date, token, localize, options) {
    var week = getUTCWeek(date, options);

    if (token === 'wo') {
      return localize.ordinalNumber(week, {
        unit: 'week'
      });
    }

    return addLeadingZeros(week, token.length);
  },
  // ISO week of year
  I: function I(date, token, localize) {
    var isoWeek = getUTCISOWeek(date);

    if (token === 'Io') {
      return localize.ordinalNumber(isoWeek, {
        unit: 'week'
      });
    }

    return addLeadingZeros(isoWeek, token.length);
  },
  // Day of the month
  d: function d(date, token, localize) {
    if (token === 'do') {
      return localize.ordinalNumber(date.getUTCDate(), {
        unit: 'date'
      });
    }

    return lightFormatters.d(date, token);
  },
  // Day of year
  D: function D(date, token, localize) {
    var dayOfYear = getUTCDayOfYear(date);

    if (token === 'Do') {
      return localize.ordinalNumber(dayOfYear, {
        unit: 'dayOfYear'
      });
    }

    return addLeadingZeros(dayOfYear, token.length);
  },
  // Day of week
  E: function E(date, token, localize) {
    var dayOfWeek = date.getUTCDay();

    switch (token) {
      // Tue
      case 'E':
      case 'EE':
      case 'EEE':
        return localize.day(dayOfWeek, {
          width: 'abbreviated',
          context: 'formatting'
        });
      // T

      case 'EEEEE':
        return localize.day(dayOfWeek, {
          width: 'narrow',
          context: 'formatting'
        });
      // Tu

      case 'EEEEEE':
        return localize.day(dayOfWeek, {
          width: 'short',
          context: 'formatting'
        });
      // Tuesday

      case 'EEEE':
      default:
        return localize.day(dayOfWeek, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // Local day of week
  e: function e(date, token, localize, options) {
    var dayOfWeek = date.getUTCDay();
    var localDayOfWeek = (dayOfWeek - options.weekStartsOn + 8) % 7 || 7;

    switch (token) {
      // Numerical value (Nth day of week with current locale or weekStartsOn)
      case 'e':
        return String(localDayOfWeek);
      // Padded numerical value

      case 'ee':
        return addLeadingZeros(localDayOfWeek, 2);
      // 1st, 2nd, ..., 7th

      case 'eo':
        return localize.ordinalNumber(localDayOfWeek, {
          unit: 'day'
        });

      case 'eee':
        return localize.day(dayOfWeek, {
          width: 'abbreviated',
          context: 'formatting'
        });
      // T

      case 'eeeee':
        return localize.day(dayOfWeek, {
          width: 'narrow',
          context: 'formatting'
        });
      // Tu

      case 'eeeeee':
        return localize.day(dayOfWeek, {
          width: 'short',
          context: 'formatting'
        });
      // Tuesday

      case 'eeee':
      default:
        return localize.day(dayOfWeek, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // Stand-alone local day of week
  c: function c(date, token, localize, options) {
    var dayOfWeek = date.getUTCDay();
    var localDayOfWeek = (dayOfWeek - options.weekStartsOn + 8) % 7 || 7;

    switch (token) {
      // Numerical value (same as in `e`)
      case 'c':
        return String(localDayOfWeek);
      // Padded numerical value

      case 'cc':
        return addLeadingZeros(localDayOfWeek, token.length);
      // 1st, 2nd, ..., 7th

      case 'co':
        return localize.ordinalNumber(localDayOfWeek, {
          unit: 'day'
        });

      case 'ccc':
        return localize.day(dayOfWeek, {
          width: 'abbreviated',
          context: 'standalone'
        });
      // T

      case 'ccccc':
        return localize.day(dayOfWeek, {
          width: 'narrow',
          context: 'standalone'
        });
      // Tu

      case 'cccccc':
        return localize.day(dayOfWeek, {
          width: 'short',
          context: 'standalone'
        });
      // Tuesday

      case 'cccc':
      default:
        return localize.day(dayOfWeek, {
          width: 'wide',
          context: 'standalone'
        });
    }
  },
  // ISO day of week
  i: function i(date, token, localize) {
    var dayOfWeek = date.getUTCDay();
    var isoDayOfWeek = dayOfWeek === 0 ? 7 : dayOfWeek;

    switch (token) {
      // 2
      case 'i':
        return String(isoDayOfWeek);
      // 02

      case 'ii':
        return addLeadingZeros(isoDayOfWeek, token.length);
      // 2nd

      case 'io':
        return localize.ordinalNumber(isoDayOfWeek, {
          unit: 'day'
        });
      // Tue

      case 'iii':
        return localize.day(dayOfWeek, {
          width: 'abbreviated',
          context: 'formatting'
        });
      // T

      case 'iiiii':
        return localize.day(dayOfWeek, {
          width: 'narrow',
          context: 'formatting'
        });
      // Tu

      case 'iiiiii':
        return localize.day(dayOfWeek, {
          width: 'short',
          context: 'formatting'
        });
      // Tuesday

      case 'iiii':
      default:
        return localize.day(dayOfWeek, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // AM or PM
  a: function a(date, token, localize) {
    var hours = date.getUTCHours();
    var dayPeriodEnumValue = hours / 12 >= 1 ? 'pm' : 'am';

    switch (token) {
      case 'a':
      case 'aa':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'abbreviated',
          context: 'formatting'
        });

      case 'aaa':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'abbreviated',
          context: 'formatting'
        }).toLowerCase();

      case 'aaaaa':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'narrow',
          context: 'formatting'
        });

      case 'aaaa':
      default:
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // AM, PM, midnight, noon
  b: function b(date, token, localize) {
    var hours = date.getUTCHours();
    var dayPeriodEnumValue;

    if (hours === 12) {
      dayPeriodEnumValue = dayPeriodEnum.noon;
    } else if (hours === 0) {
      dayPeriodEnumValue = dayPeriodEnum.midnight;
    } else {
      dayPeriodEnumValue = hours / 12 >= 1 ? 'pm' : 'am';
    }

    switch (token) {
      case 'b':
      case 'bb':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'abbreviated',
          context: 'formatting'
        });

      case 'bbb':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'abbreviated',
          context: 'formatting'
        }).toLowerCase();

      case 'bbbbb':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'narrow',
          context: 'formatting'
        });

      case 'bbbb':
      default:
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // in the morning, in the afternoon, in the evening, at night
  B: function B(date, token, localize) {
    var hours = date.getUTCHours();
    var dayPeriodEnumValue;

    if (hours >= 17) {
      dayPeriodEnumValue = dayPeriodEnum.evening;
    } else if (hours >= 12) {
      dayPeriodEnumValue = dayPeriodEnum.afternoon;
    } else if (hours >= 4) {
      dayPeriodEnumValue = dayPeriodEnum.morning;
    } else {
      dayPeriodEnumValue = dayPeriodEnum.night;
    }

    switch (token) {
      case 'B':
      case 'BB':
      case 'BBB':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'abbreviated',
          context: 'formatting'
        });

      case 'BBBBB':
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'narrow',
          context: 'formatting'
        });

      case 'BBBB':
      default:
        return localize.dayPeriod(dayPeriodEnumValue, {
          width: 'wide',
          context: 'formatting'
        });
    }
  },
  // Hour [1-12]
  h: function h(date, token, localize) {
    if (token === 'ho') {
      var hours = date.getUTCHours() % 12;
      if (hours === 0) hours = 12;
      return localize.ordinalNumber(hours, {
        unit: 'hour'
      });
    }

    return lightFormatters.h(date, token);
  },
  // Hour [0-23]
  H: function H(date, token, localize) {
    if (token === 'Ho') {
      return localize.ordinalNumber(date.getUTCHours(), {
        unit: 'hour'
      });
    }

    return lightFormatters.H(date, token);
  },
  // Hour [0-11]
  K: function K(date, token, localize) {
    var hours = date.getUTCHours() % 12;

    if (token === 'Ko') {
      return localize.ordinalNumber(hours, {
        unit: 'hour'
      });
    }

    return addLeadingZeros(hours, token.length);
  },
  // Hour [1-24]
  k: function k(date, token, localize) {
    var hours = date.getUTCHours();
    if (hours === 0) hours = 24;

    if (token === 'ko') {
      return localize.ordinalNumber(hours, {
        unit: 'hour'
      });
    }

    return addLeadingZeros(hours, token.length);
  },
  // Minute
  m: function m(date, token, localize) {
    if (token === 'mo') {
      return localize.ordinalNumber(date.getUTCMinutes(), {
        unit: 'minute'
      });
    }

    return lightFormatters.m(date, token);
  },
  // Second
  s: function s(date, token, localize) {
    if (token === 'so') {
      return localize.ordinalNumber(date.getUTCSeconds(), {
        unit: 'second'
      });
    }

    return lightFormatters.s(date, token);
  },
  // Fraction of second
  S: function S(date, token) {
    return lightFormatters.S(date, token);
  },
  // Timezone (ISO-8601. If offset is 0, output is always `'Z'`)
  X: function X(date, token, _localize, options) {
    var originalDate = options._originalDate || date;
    var timezoneOffset = originalDate.getTimezoneOffset();

    if (timezoneOffset === 0) {
      return 'Z';
    }

    switch (token) {
      // Hours and optional minutes
      case 'X':
        return formatTimezoneWithOptionalMinutes(timezoneOffset);
      // Hours, minutes and optional seconds without `:` delimiter
      // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
      // so this token always has the same output as `XX`

      case 'XXXX':
      case 'XX':
        // Hours and minutes without `:` delimiter
        return formatTimezone(timezoneOffset);
      // Hours, minutes and optional seconds with `:` delimiter
      // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
      // so this token always has the same output as `XXX`

      case 'XXXXX':
      case 'XXX': // Hours and minutes with `:` delimiter

      default:
        return formatTimezone(timezoneOffset, ':');
    }
  },
  // Timezone (ISO-8601. If offset is 0, output is `'+00:00'` or equivalent)
  x: function x(date, token, _localize, options) {
    var originalDate = options._originalDate || date;
    var timezoneOffset = originalDate.getTimezoneOffset();

    switch (token) {
      // Hours and optional minutes
      case 'x':
        return formatTimezoneWithOptionalMinutes(timezoneOffset);
      // Hours, minutes and optional seconds without `:` delimiter
      // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
      // so this token always has the same output as `xx`

      case 'xxxx':
      case 'xx':
        // Hours and minutes without `:` delimiter
        return formatTimezone(timezoneOffset);
      // Hours, minutes and optional seconds with `:` delimiter
      // Note: neither ISO-8601 nor JavaScript supports seconds in timezone offsets
      // so this token always has the same output as `xxx`

      case 'xxxxx':
      case 'xxx': // Hours and minutes with `:` delimiter

      default:
        return formatTimezone(timezoneOffset, ':');
    }
  },
  // Timezone (GMT)
  O: function O(date, token, _localize, options) {
    var originalDate = options._originalDate || date;
    var timezoneOffset = originalDate.getTimezoneOffset();

    switch (token) {
      // Short
      case 'O':
      case 'OO':
      case 'OOO':
        return 'GMT' + formatTimezoneShort(timezoneOffset, ':');
      // Long

      case 'OOOO':
      default:
        return 'GMT' + formatTimezone(timezoneOffset, ':');
    }
  },
  // Timezone (specific non-location)
  z: function z(date, token, _localize, options) {
    var originalDate = options._originalDate || date;
    var timezoneOffset = originalDate.getTimezoneOffset();

    switch (token) {
      // Short
      case 'z':
      case 'zz':
      case 'zzz':
        return 'GMT' + formatTimezoneShort(timezoneOffset, ':');
      // Long

      case 'zzzz':
      default:
        return 'GMT' + formatTimezone(timezoneOffset, ':');
    }
  },
  // Seconds timestamp
  t: function t(date, token, _localize, options) {
    var originalDate = options._originalDate || date;
    var timestamp = Math.floor(originalDate.getTime() / 1000);
    return addLeadingZeros(timestamp, token.length);
  },
  // Milliseconds timestamp
  T: function T(date, token, _localize, options) {
    var originalDate = options._originalDate || date;
    var timestamp = originalDate.getTime();
    return addLeadingZeros(timestamp, token.length);
  }
};

function formatTimezoneShort(offset, dirtyDelimiter) {
  var sign = offset > 0 ? '-' : '+';
  var absOffset = Math.abs(offset);
  var hours = Math.floor(absOffset / 60);
  var minutes = absOffset % 60;

  if (minutes === 0) {
    return sign + String(hours);
  }

  var delimiter = dirtyDelimiter || '';
  return sign + String(hours) + delimiter + addLeadingZeros(minutes, 2);
}

function formatTimezoneWithOptionalMinutes(offset, dirtyDelimiter) {
  if (offset % 60 === 0) {
    var sign = offset > 0 ? '-' : '+';
    return sign + addLeadingZeros(Math.abs(offset) / 60, 2);
  }

  return formatTimezone(offset, dirtyDelimiter);
}

function formatTimezone(offset, dirtyDelimiter) {
  var delimiter = dirtyDelimiter || '';
  var sign = offset > 0 ? '-' : '+';
  var absOffset = Math.abs(offset);
  var hours = addLeadingZeros(Math.floor(absOffset / 60), 2);
  var minutes = addLeadingZeros(absOffset % 60, 2);
  return sign + hours + delimiter + minutes;
}

var formatters$1 = formatters;

var dateLongFormatter = function dateLongFormatter(pattern, formatLong) {
  switch (pattern) {
    case 'P':
      return formatLong.date({
        width: 'short'
      });

    case 'PP':
      return formatLong.date({
        width: 'medium'
      });

    case 'PPP':
      return formatLong.date({
        width: 'long'
      });

    case 'PPPP':
    default:
      return formatLong.date({
        width: 'full'
      });
  }
};

var timeLongFormatter = function timeLongFormatter(pattern, formatLong) {
  switch (pattern) {
    case 'p':
      return formatLong.time({
        width: 'short'
      });

    case 'pp':
      return formatLong.time({
        width: 'medium'
      });

    case 'ppp':
      return formatLong.time({
        width: 'long'
      });

    case 'pppp':
    default:
      return formatLong.time({
        width: 'full'
      });
  }
};

var dateTimeLongFormatter = function dateTimeLongFormatter(pattern, formatLong) {
  var matchResult = pattern.match(/(P+)(p+)?/) || [];
  var datePattern = matchResult[1];
  var timePattern = matchResult[2];

  if (!timePattern) {
    return dateLongFormatter(pattern, formatLong);
  }

  var dateTimeFormat;

  switch (datePattern) {
    case 'P':
      dateTimeFormat = formatLong.dateTime({
        width: 'short'
      });
      break;

    case 'PP':
      dateTimeFormat = formatLong.dateTime({
        width: 'medium'
      });
      break;

    case 'PPP':
      dateTimeFormat = formatLong.dateTime({
        width: 'long'
      });
      break;

    case 'PPPP':
    default:
      dateTimeFormat = formatLong.dateTime({
        width: 'full'
      });
      break;
  }

  return dateTimeFormat.replace('{{date}}', dateLongFormatter(datePattern, formatLong)).replace('{{time}}', timeLongFormatter(timePattern, formatLong));
};

var longFormatters = {
  p: timeLongFormatter,
  P: dateTimeLongFormatter
};
var longFormatters$1 = longFormatters;

/**
 * Google Chrome as of 67.0.3396.87 introduced timezones with offset that includes seconds.
 * They usually appear for dates that denote time before the timezones were introduced
 * (e.g. for 'Europe/Prague' timezone the offset is GMT+00:57:44 before 1 October 1891
 * and GMT+01:00:00 after that date)
 *
 * Date#getTimezoneOffset returns the offset in minutes and would return 57 for the example above,
 * which would lead to incorrect calculations.
 *
 * This function returns the timezone offset in milliseconds that takes seconds in account.
 */
function getTimezoneOffsetInMilliseconds(date) {
  var utcDate = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds()));
  utcDate.setUTCFullYear(date.getFullYear());
  return date.getTime() - utcDate.getTime();
}

var protectedDayOfYearTokens = ['D', 'DD'];
var protectedWeekYearTokens = ['YY', 'YYYY'];
function isProtectedDayOfYearToken(token) {
  return protectedDayOfYearTokens.indexOf(token) !== -1;
}
function isProtectedWeekYearToken(token) {
  return protectedWeekYearTokens.indexOf(token) !== -1;
}
function throwProtectedError(token, format, input) {
  if (token === 'YYYY') {
    throw new RangeError("Use `yyyy` instead of `YYYY` (in `".concat(format, "`) for formatting years to the input `").concat(input, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  } else if (token === 'YY') {
    throw new RangeError("Use `yy` instead of `YY` (in `".concat(format, "`) for formatting years to the input `").concat(input, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  } else if (token === 'D') {
    throw new RangeError("Use `d` instead of `D` (in `".concat(format, "`) for formatting days of the month to the input `").concat(input, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  } else if (token === 'DD') {
    throw new RangeError("Use `dd` instead of `DD` (in `".concat(format, "`) for formatting days of the month to the input `").concat(input, "`; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md"));
  }
}

var formatDistanceLocale = {
  lessThanXSeconds: {
    one: 'less than a second',
    other: 'less than {{count}} seconds'
  },
  xSeconds: {
    one: '1 second',
    other: '{{count}} seconds'
  },
  halfAMinute: 'half a minute',
  lessThanXMinutes: {
    one: 'less than a minute',
    other: 'less than {{count}} minutes'
  },
  xMinutes: {
    one: '1 minute',
    other: '{{count}} minutes'
  },
  aboutXHours: {
    one: 'about 1 hour',
    other: 'about {{count}} hours'
  },
  xHours: {
    one: '1 hour',
    other: '{{count}} hours'
  },
  xDays: {
    one: '1 day',
    other: '{{count}} days'
  },
  aboutXWeeks: {
    one: 'about 1 week',
    other: 'about {{count}} weeks'
  },
  xWeeks: {
    one: '1 week',
    other: '{{count}} weeks'
  },
  aboutXMonths: {
    one: 'about 1 month',
    other: 'about {{count}} months'
  },
  xMonths: {
    one: '1 month',
    other: '{{count}} months'
  },
  aboutXYears: {
    one: 'about 1 year',
    other: 'about {{count}} years'
  },
  xYears: {
    one: '1 year',
    other: '{{count}} years'
  },
  overXYears: {
    one: 'over 1 year',
    other: 'over {{count}} years'
  },
  almostXYears: {
    one: 'almost 1 year',
    other: 'almost {{count}} years'
  }
};

var formatDistance = function formatDistance(token, count, options) {
  var result;
  var tokenValue = formatDistanceLocale[token];

  if (typeof tokenValue === 'string') {
    result = tokenValue;
  } else if (count === 1) {
    result = tokenValue.one;
  } else {
    result = tokenValue.other.replace('{{count}}', count.toString());
  }

  if (options !== null && options !== void 0 && options.addSuffix) {
    if (options.comparison && options.comparison > 0) {
      return 'in ' + result;
    } else {
      return result + ' ago';
    }
  }

  return result;
};

var formatDistance$1 = formatDistance;

function buildFormatLongFn(args) {
  return function () {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    // TODO: Remove String()
    var width = options.width ? String(options.width) : args.defaultWidth;
    var format = args.formats[width] || args.formats[args.defaultWidth];
    return format;
  };
}

var dateFormats = {
  full: 'EEEE, MMMM do, y',
  long: 'MMMM do, y',
  medium: 'MMM d, y',
  short: 'MM/dd/yyyy'
};
var timeFormats = {
  full: 'h:mm:ss a zzzz',
  long: 'h:mm:ss a z',
  medium: 'h:mm:ss a',
  short: 'h:mm a'
};
var dateTimeFormats = {
  full: "{{date}} 'at' {{time}}",
  long: "{{date}} 'at' {{time}}",
  medium: '{{date}}, {{time}}',
  short: '{{date}}, {{time}}'
};
var formatLong = {
  date: buildFormatLongFn({
    formats: dateFormats,
    defaultWidth: 'full'
  }),
  time: buildFormatLongFn({
    formats: timeFormats,
    defaultWidth: 'full'
  }),
  dateTime: buildFormatLongFn({
    formats: dateTimeFormats,
    defaultWidth: 'full'
  })
};
var formatLong$1 = formatLong;

var formatRelativeLocale = {
  lastWeek: "'last' eeee 'at' p",
  yesterday: "'yesterday at' p",
  today: "'today at' p",
  tomorrow: "'tomorrow at' p",
  nextWeek: "eeee 'at' p",
  other: 'P'
};

var formatRelative = function formatRelative(token, _date, _baseDate, _options) {
  return formatRelativeLocale[token];
};

var formatRelative$1 = formatRelative;

function buildLocalizeFn(args) {
  return function (dirtyIndex, options) {
    var context = options !== null && options !== void 0 && options.context ? String(options.context) : 'standalone';
    var valuesArray;

    if (context === 'formatting' && args.formattingValues) {
      var defaultWidth = args.defaultFormattingWidth || args.defaultWidth;
      var width = options !== null && options !== void 0 && options.width ? String(options.width) : defaultWidth;
      valuesArray = args.formattingValues[width] || args.formattingValues[defaultWidth];
    } else {
      var _defaultWidth = args.defaultWidth;

      var _width = options !== null && options !== void 0 && options.width ? String(options.width) : args.defaultWidth;

      valuesArray = args.values[_width] || args.values[_defaultWidth];
    }

    var index = args.argumentCallback ? args.argumentCallback(dirtyIndex) : dirtyIndex; // @ts-ignore: For some reason TypeScript just don't want to match it, no matter how hard we try. I challenge you to try to remove it!

    return valuesArray[index];
  };
}

var eraValues = {
  narrow: ['B', 'A'],
  abbreviated: ['BC', 'AD'],
  wide: ['Before Christ', 'Anno Domini']
};
var quarterValues = {
  narrow: ['1', '2', '3', '4'],
  abbreviated: ['Q1', 'Q2', 'Q3', 'Q4'],
  wide: ['1st quarter', '2nd quarter', '3rd quarter', '4th quarter']
}; // Note: in English, the names of days of the week and months are capitalized.
// If you are making a new locale based on this one, check if the same is true for the language you're working on.
// Generally, formatted dates should look like they are in the middle of a sentence,
// e.g. in Spanish language the weekdays and months should be in the lowercase.

var monthValues = {
  narrow: ['J', 'F', 'M', 'A', 'M', 'J', 'J', 'A', 'S', 'O', 'N', 'D'],
  abbreviated: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
  wide: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
};
var dayValues = {
  narrow: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
  short: ['Su', 'Mo', 'Tu', 'We', 'Th', 'Fr', 'Sa'],
  abbreviated: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
  wide: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday']
};
var dayPeriodValues = {
  narrow: {
    am: 'a',
    pm: 'p',
    midnight: 'mi',
    noon: 'n',
    morning: 'morning',
    afternoon: 'afternoon',
    evening: 'evening',
    night: 'night'
  },
  abbreviated: {
    am: 'AM',
    pm: 'PM',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'morning',
    afternoon: 'afternoon',
    evening: 'evening',
    night: 'night'
  },
  wide: {
    am: 'a.m.',
    pm: 'p.m.',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'morning',
    afternoon: 'afternoon',
    evening: 'evening',
    night: 'night'
  }
};
var formattingDayPeriodValues = {
  narrow: {
    am: 'a',
    pm: 'p',
    midnight: 'mi',
    noon: 'n',
    morning: 'in the morning',
    afternoon: 'in the afternoon',
    evening: 'in the evening',
    night: 'at night'
  },
  abbreviated: {
    am: 'AM',
    pm: 'PM',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'in the morning',
    afternoon: 'in the afternoon',
    evening: 'in the evening',
    night: 'at night'
  },
  wide: {
    am: 'a.m.',
    pm: 'p.m.',
    midnight: 'midnight',
    noon: 'noon',
    morning: 'in the morning',
    afternoon: 'in the afternoon',
    evening: 'in the evening',
    night: 'at night'
  }
};

var ordinalNumber = function ordinalNumber(dirtyNumber, _options) {
  var number = Number(dirtyNumber); // If ordinal numbers depend on context, for example,
  // if they are different for different grammatical genders,
  // use `options.unit`.
  //
  // `unit` can be 'year', 'quarter', 'month', 'week', 'date', 'dayOfYear',
  // 'day', 'hour', 'minute', 'second'.

  var rem100 = number % 100;

  if (rem100 > 20 || rem100 < 10) {
    switch (rem100 % 10) {
      case 1:
        return number + 'st';

      case 2:
        return number + 'nd';

      case 3:
        return number + 'rd';
    }
  }

  return number + 'th';
};

var localize = {
  ordinalNumber: ordinalNumber,
  era: buildLocalizeFn({
    values: eraValues,
    defaultWidth: 'wide'
  }),
  quarter: buildLocalizeFn({
    values: quarterValues,
    defaultWidth: 'wide',
    argumentCallback: function argumentCallback(quarter) {
      return quarter - 1;
    }
  }),
  month: buildLocalizeFn({
    values: monthValues,
    defaultWidth: 'wide'
  }),
  day: buildLocalizeFn({
    values: dayValues,
    defaultWidth: 'wide'
  }),
  dayPeriod: buildLocalizeFn({
    values: dayPeriodValues,
    defaultWidth: 'wide',
    formattingValues: formattingDayPeriodValues,
    defaultFormattingWidth: 'wide'
  })
};
var localize$1 = localize;

function buildMatchFn(args) {
  return function (string) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var width = options.width;
    var matchPattern = width && args.matchPatterns[width] || args.matchPatterns[args.defaultMatchWidth];
    var matchResult = string.match(matchPattern);

    if (!matchResult) {
      return null;
    }

    var matchedString = matchResult[0];
    var parsePatterns = width && args.parsePatterns[width] || args.parsePatterns[args.defaultParseWidth];
    var key = Array.isArray(parsePatterns) ? findIndex(parsePatterns, function (pattern) {
      return pattern.test(matchedString);
    }) : findKey(parsePatterns, function (pattern) {
      return pattern.test(matchedString);
    });
    var value;
    value = args.valueCallback ? args.valueCallback(key) : key;
    value = options.valueCallback ? options.valueCallback(value) : value;
    var rest = string.slice(matchedString.length);
    return {
      value: value,
      rest: rest
    };
  };
}

function findKey(object, predicate) {
  for (var key in object) {
    if (object.hasOwnProperty(key) && predicate(object[key])) {
      return key;
    }
  }

  return undefined;
}

function findIndex(array, predicate) {
  for (var key = 0; key < array.length; key++) {
    if (predicate(array[key])) {
      return key;
    }
  }

  return undefined;
}

function buildMatchPatternFn(args) {
  return function (string) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var matchResult = string.match(args.matchPattern);
    if (!matchResult) return null;
    var matchedString = matchResult[0];
    var parseResult = string.match(args.parsePattern);
    if (!parseResult) return null;
    var value = args.valueCallback ? args.valueCallback(parseResult[0]) : parseResult[0];
    value = options.valueCallback ? options.valueCallback(value) : value;
    var rest = string.slice(matchedString.length);
    return {
      value: value,
      rest: rest
    };
  };
}

var matchOrdinalNumberPattern = /^(\d+)(th|st|nd|rd)?/i;
var parseOrdinalNumberPattern = /\d+/i;
var matchEraPatterns = {
  narrow: /^(b|a)/i,
  abbreviated: /^(b\.?\s?c\.?|b\.?\s?c\.?\s?e\.?|a\.?\s?d\.?|c\.?\s?e\.?)/i,
  wide: /^(before christ|before common era|anno domini|common era)/i
};
var parseEraPatterns = {
  any: [/^b/i, /^(a|c)/i]
};
var matchQuarterPatterns = {
  narrow: /^[1234]/i,
  abbreviated: /^q[1234]/i,
  wide: /^[1234](th|st|nd|rd)? quarter/i
};
var parseQuarterPatterns = {
  any: [/1/i, /2/i, /3/i, /4/i]
};
var matchMonthPatterns = {
  narrow: /^[jfmasond]/i,
  abbreviated: /^(jan|feb|mar|apr|may|jun|jul|aug|sep|oct|nov|dec)/i,
  wide: /^(january|february|march|april|may|june|july|august|september|october|november|december)/i
};
var parseMonthPatterns = {
  narrow: [/^j/i, /^f/i, /^m/i, /^a/i, /^m/i, /^j/i, /^j/i, /^a/i, /^s/i, /^o/i, /^n/i, /^d/i],
  any: [/^ja/i, /^f/i, /^mar/i, /^ap/i, /^may/i, /^jun/i, /^jul/i, /^au/i, /^s/i, /^o/i, /^n/i, /^d/i]
};
var matchDayPatterns = {
  narrow: /^[smtwf]/i,
  short: /^(su|mo|tu|we|th|fr|sa)/i,
  abbreviated: /^(sun|mon|tue|wed|thu|fri|sat)/i,
  wide: /^(sunday|monday|tuesday|wednesday|thursday|friday|saturday)/i
};
var parseDayPatterns = {
  narrow: [/^s/i, /^m/i, /^t/i, /^w/i, /^t/i, /^f/i, /^s/i],
  any: [/^su/i, /^m/i, /^tu/i, /^w/i, /^th/i, /^f/i, /^sa/i]
};
var matchDayPeriodPatterns = {
  narrow: /^(a|p|mi|n|(in the|at) (morning|afternoon|evening|night))/i,
  any: /^([ap]\.?\s?m\.?|midnight|noon|(in the|at) (morning|afternoon|evening|night))/i
};
var parseDayPeriodPatterns = {
  any: {
    am: /^a/i,
    pm: /^p/i,
    midnight: /^mi/i,
    noon: /^no/i,
    morning: /morning/i,
    afternoon: /afternoon/i,
    evening: /evening/i,
    night: /night/i
  }
};
var match = {
  ordinalNumber: buildMatchPatternFn({
    matchPattern: matchOrdinalNumberPattern,
    parsePattern: parseOrdinalNumberPattern,
    valueCallback: function valueCallback(value) {
      return parseInt(value, 10);
    }
  }),
  era: buildMatchFn({
    matchPatterns: matchEraPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseEraPatterns,
    defaultParseWidth: 'any'
  }),
  quarter: buildMatchFn({
    matchPatterns: matchQuarterPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseQuarterPatterns,
    defaultParseWidth: 'any',
    valueCallback: function valueCallback(index) {
      return index + 1;
    }
  }),
  month: buildMatchFn({
    matchPatterns: matchMonthPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseMonthPatterns,
    defaultParseWidth: 'any'
  }),
  day: buildMatchFn({
    matchPatterns: matchDayPatterns,
    defaultMatchWidth: 'wide',
    parsePatterns: parseDayPatterns,
    defaultParseWidth: 'any'
  }),
  dayPeriod: buildMatchFn({
    matchPatterns: matchDayPeriodPatterns,
    defaultMatchWidth: 'any',
    parsePatterns: parseDayPeriodPatterns,
    defaultParseWidth: 'any'
  })
};
var match$1 = match;

/**
 * @type {Locale}
 * @category Locales
 * @summary English locale (United States).
 * @language English
 * @iso-639-2 eng
 * @author Sasha Koss [@kossnocorp]{@link https://github.com/kossnocorp}
 * @author Lesha Koss [@leshakoss]{@link https://github.com/leshakoss}
 */
var locale = {
  code: 'en-US',
  formatDistance: formatDistance$1,
  formatLong: formatLong$1,
  formatRelative: formatRelative$1,
  localize: localize$1,
  match: match$1,
  options: {
    weekStartsOn: 0
    /* Sunday */
    ,
    firstWeekContainsDate: 1
  }
};
var defaultLocale = locale;

// - [yYQqMLwIdDecihHKkms]o matches any available ordinal number token
//   (one of the certain letters followed by `o`)
// - (\w)\1* matches any sequences of the same letter
// - '' matches two quote characters in a row
// - '(''|[^'])+('|$) matches anything surrounded by two quote characters ('),
//   except a single quote symbol, which ends the sequence.
//   Two quote characters do not end the sequence.
//   If there is no matching single quote
//   then the sequence will continue until the end of the string.
// - . matches any single character unmatched by previous parts of the RegExps

var formattingTokensRegExp = /[yYQqMLwIdDecihHKkms]o|(\w)\1*|''|'(''|[^'])+('|$)|./g; // This RegExp catches symbols escaped by quotes, and also
// sequences of symbols P, p, and the combinations like `PPPPPPPppppp`

var longFormattingTokensRegExp = /P+p+|P+|p+|''|'(''|[^'])+('|$)|./g;
var escapedStringRegExp = /^'([^]*?)'?$/;
var doubleQuoteRegExp = /''/g;
var unescapedLatinCharacterRegExp = /[a-zA-Z]/;
/**
 * @name format
 * @category Common Helpers
 * @summary Format the date.
 *
 * @description
 * Return the formatted date string in the given format. The result may vary by locale.
 *
 * > ⚠️ Please note that the `format` tokens differ from Moment.js and other libraries.
 * > See: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 *
 * The characters wrapped between two single quotes characters (') are escaped.
 * Two single quotes in a row, whether inside or outside a quoted sequence, represent a 'real' single quote.
 * (see the last example)
 *
 * Format of the string is based on Unicode Technical Standard #35:
 * https://www.unicode.org/reports/tr35/tr35-dates.html#Date_Field_Symbol_Table
 * with a few additions (see note 7 below the table).
 *
 * Accepted patterns:
 * | Unit                            | Pattern | Result examples                   | Notes |
 * |---------------------------------|---------|-----------------------------------|-------|
 * | Era                             | G..GGG  | AD, BC                            |       |
 * |                                 | GGGG    | Anno Domini, Before Christ        | 2     |
 * |                                 | GGGGG   | A, B                              |       |
 * | Calendar year                   | y       | 44, 1, 1900, 2017                 | 5     |
 * |                                 | yo      | 44th, 1st, 0th, 17th              | 5,7   |
 * |                                 | yy      | 44, 01, 00, 17                    | 5     |
 * |                                 | yyy     | 044, 001, 1900, 2017              | 5     |
 * |                                 | yyyy    | 0044, 0001, 1900, 2017            | 5     |
 * |                                 | yyyyy   | ...                               | 3,5   |
 * | Local week-numbering year       | Y       | 44, 1, 1900, 2017                 | 5     |
 * |                                 | Yo      | 44th, 1st, 1900th, 2017th         | 5,7   |
 * |                                 | YY      | 44, 01, 00, 17                    | 5,8   |
 * |                                 | YYY     | 044, 001, 1900, 2017              | 5     |
 * |                                 | YYYY    | 0044, 0001, 1900, 2017            | 5,8   |
 * |                                 | YYYYY   | ...                               | 3,5   |
 * | ISO week-numbering year         | R       | -43, 0, 1, 1900, 2017             | 5,7   |
 * |                                 | RR      | -43, 00, 01, 1900, 2017           | 5,7   |
 * |                                 | RRR     | -043, 000, 001, 1900, 2017        | 5,7   |
 * |                                 | RRRR    | -0043, 0000, 0001, 1900, 2017     | 5,7   |
 * |                                 | RRRRR   | ...                               | 3,5,7 |
 * | Extended year                   | u       | -43, 0, 1, 1900, 2017             | 5     |
 * |                                 | uu      | -43, 01, 1900, 2017               | 5     |
 * |                                 | uuu     | -043, 001, 1900, 2017             | 5     |
 * |                                 | uuuu    | -0043, 0001, 1900, 2017           | 5     |
 * |                                 | uuuuu   | ...                               | 3,5   |
 * | Quarter (formatting)            | Q       | 1, 2, 3, 4                        |       |
 * |                                 | Qo      | 1st, 2nd, 3rd, 4th                | 7     |
 * |                                 | QQ      | 01, 02, 03, 04                    |       |
 * |                                 | QQQ     | Q1, Q2, Q3, Q4                    |       |
 * |                                 | QQQQ    | 1st quarter, 2nd quarter, ...     | 2     |
 * |                                 | QQQQQ   | 1, 2, 3, 4                        | 4     |
 * | Quarter (stand-alone)           | q       | 1, 2, 3, 4                        |       |
 * |                                 | qo      | 1st, 2nd, 3rd, 4th                | 7     |
 * |                                 | qq      | 01, 02, 03, 04                    |       |
 * |                                 | qqq     | Q1, Q2, Q3, Q4                    |       |
 * |                                 | qqqq    | 1st quarter, 2nd quarter, ...     | 2     |
 * |                                 | qqqqq   | 1, 2, 3, 4                        | 4     |
 * | Month (formatting)              | M       | 1, 2, ..., 12                     |       |
 * |                                 | Mo      | 1st, 2nd, ..., 12th               | 7     |
 * |                                 | MM      | 01, 02, ..., 12                   |       |
 * |                                 | MMM     | Jan, Feb, ..., Dec                |       |
 * |                                 | MMMM    | January, February, ..., December  | 2     |
 * |                                 | MMMMM   | J, F, ..., D                      |       |
 * | Month (stand-alone)             | L       | 1, 2, ..., 12                     |       |
 * |                                 | Lo      | 1st, 2nd, ..., 12th               | 7     |
 * |                                 | LL      | 01, 02, ..., 12                   |       |
 * |                                 | LLL     | Jan, Feb, ..., Dec                |       |
 * |                                 | LLLL    | January, February, ..., December  | 2     |
 * |                                 | LLLLL   | J, F, ..., D                      |       |
 * | Local week of year              | w       | 1, 2, ..., 53                     |       |
 * |                                 | wo      | 1st, 2nd, ..., 53th               | 7     |
 * |                                 | ww      | 01, 02, ..., 53                   |       |
 * | ISO week of year                | I       | 1, 2, ..., 53                     | 7     |
 * |                                 | Io      | 1st, 2nd, ..., 53th               | 7     |
 * |                                 | II      | 01, 02, ..., 53                   | 7     |
 * | Day of month                    | d       | 1, 2, ..., 31                     |       |
 * |                                 | do      | 1st, 2nd, ..., 31st               | 7     |
 * |                                 | dd      | 01, 02, ..., 31                   |       |
 * | Day of year                     | D       | 1, 2, ..., 365, 366               | 9     |
 * |                                 | Do      | 1st, 2nd, ..., 365th, 366th       | 7     |
 * |                                 | DD      | 01, 02, ..., 365, 366             | 9     |
 * |                                 | DDD     | 001, 002, ..., 365, 366           |       |
 * |                                 | DDDD    | ...                               | 3     |
 * | Day of week (formatting)        | E..EEE  | Mon, Tue, Wed, ..., Sun           |       |
 * |                                 | EEEE    | Monday, Tuesday, ..., Sunday      | 2     |
 * |                                 | EEEEE   | M, T, W, T, F, S, S               |       |
 * |                                 | EEEEEE  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
 * | ISO day of week (formatting)    | i       | 1, 2, 3, ..., 7                   | 7     |
 * |                                 | io      | 1st, 2nd, ..., 7th                | 7     |
 * |                                 | ii      | 01, 02, ..., 07                   | 7     |
 * |                                 | iii     | Mon, Tue, Wed, ..., Sun           | 7     |
 * |                                 | iiii    | Monday, Tuesday, ..., Sunday      | 2,7   |
 * |                                 | iiiii   | M, T, W, T, F, S, S               | 7     |
 * |                                 | iiiiii  | Mo, Tu, We, Th, Fr, Sa, Su        | 7     |
 * | Local day of week (formatting)  | e       | 2, 3, 4, ..., 1                   |       |
 * |                                 | eo      | 2nd, 3rd, ..., 1st                | 7     |
 * |                                 | ee      | 02, 03, ..., 01                   |       |
 * |                                 | eee     | Mon, Tue, Wed, ..., Sun           |       |
 * |                                 | eeee    | Monday, Tuesday, ..., Sunday      | 2     |
 * |                                 | eeeee   | M, T, W, T, F, S, S               |       |
 * |                                 | eeeeee  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
 * | Local day of week (stand-alone) | c       | 2, 3, 4, ..., 1                   |       |
 * |                                 | co      | 2nd, 3rd, ..., 1st                | 7     |
 * |                                 | cc      | 02, 03, ..., 01                   |       |
 * |                                 | ccc     | Mon, Tue, Wed, ..., Sun           |       |
 * |                                 | cccc    | Monday, Tuesday, ..., Sunday      | 2     |
 * |                                 | ccccc   | M, T, W, T, F, S, S               |       |
 * |                                 | cccccc  | Mo, Tu, We, Th, Fr, Sa, Su        |       |
 * | AM, PM                          | a..aa   | AM, PM                            |       |
 * |                                 | aaa     | am, pm                            |       |
 * |                                 | aaaa    | a.m., p.m.                        | 2     |
 * |                                 | aaaaa   | a, p                              |       |
 * | AM, PM, noon, midnight          | b..bb   | AM, PM, noon, midnight            |       |
 * |                                 | bbb     | am, pm, noon, midnight            |       |
 * |                                 | bbbb    | a.m., p.m., noon, midnight        | 2     |
 * |                                 | bbbbb   | a, p, n, mi                       |       |
 * | Flexible day period             | B..BBB  | at night, in the morning, ...     |       |
 * |                                 | BBBB    | at night, in the morning, ...     | 2     |
 * |                                 | BBBBB   | at night, in the morning, ...     |       |
 * | Hour [1-12]                     | h       | 1, 2, ..., 11, 12                 |       |
 * |                                 | ho      | 1st, 2nd, ..., 11th, 12th         | 7     |
 * |                                 | hh      | 01, 02, ..., 11, 12               |       |
 * | Hour [0-23]                     | H       | 0, 1, 2, ..., 23                  |       |
 * |                                 | Ho      | 0th, 1st, 2nd, ..., 23rd          | 7     |
 * |                                 | HH      | 00, 01, 02, ..., 23               |       |
 * | Hour [0-11]                     | K       | 1, 2, ..., 11, 0                  |       |
 * |                                 | Ko      | 1st, 2nd, ..., 11th, 0th          | 7     |
 * |                                 | KK      | 01, 02, ..., 11, 00               |       |
 * | Hour [1-24]                     | k       | 24, 1, 2, ..., 23                 |       |
 * |                                 | ko      | 24th, 1st, 2nd, ..., 23rd         | 7     |
 * |                                 | kk      | 24, 01, 02, ..., 23               |       |
 * | Minute                          | m       | 0, 1, ..., 59                     |       |
 * |                                 | mo      | 0th, 1st, ..., 59th               | 7     |
 * |                                 | mm      | 00, 01, ..., 59                   |       |
 * | Second                          | s       | 0, 1, ..., 59                     |       |
 * |                                 | so      | 0th, 1st, ..., 59th               | 7     |
 * |                                 | ss      | 00, 01, ..., 59                   |       |
 * | Fraction of second              | S       | 0, 1, ..., 9                      |       |
 * |                                 | SS      | 00, 01, ..., 99                   |       |
 * |                                 | SSS     | 000, 001, ..., 999                |       |
 * |                                 | SSSS    | ...                               | 3     |
 * | Timezone (ISO-8601 w/ Z)        | X       | -08, +0530, Z                     |       |
 * |                                 | XX      | -0800, +0530, Z                   |       |
 * |                                 | XXX     | -08:00, +05:30, Z                 |       |
 * |                                 | XXXX    | -0800, +0530, Z, +123456          | 2     |
 * |                                 | XXXXX   | -08:00, +05:30, Z, +12:34:56      |       |
 * | Timezone (ISO-8601 w/o Z)       | x       | -08, +0530, +00                   |       |
 * |                                 | xx      | -0800, +0530, +0000               |       |
 * |                                 | xxx     | -08:00, +05:30, +00:00            | 2     |
 * |                                 | xxxx    | -0800, +0530, +0000, +123456      |       |
 * |                                 | xxxxx   | -08:00, +05:30, +00:00, +12:34:56 |       |
 * | Timezone (GMT)                  | O...OOO | GMT-8, GMT+5:30, GMT+0            |       |
 * |                                 | OOOO    | GMT-08:00, GMT+05:30, GMT+00:00   | 2     |
 * | Timezone (specific non-locat.)  | z...zzz | GMT-8, GMT+5:30, GMT+0            | 6     |
 * |                                 | zzzz    | GMT-08:00, GMT+05:30, GMT+00:00   | 2,6   |
 * | Seconds timestamp               | t       | 512969520                         | 7     |
 * |                                 | tt      | ...                               | 3,7   |
 * | Milliseconds timestamp          | T       | 512969520900                      | 7     |
 * |                                 | TT      | ...                               | 3,7   |
 * | Long localized date             | P       | 04/29/1453                        | 7     |
 * |                                 | PP      | Apr 29, 1453                      | 7     |
 * |                                 | PPP     | April 29th, 1453                  | 7     |
 * |                                 | PPPP    | Friday, April 29th, 1453          | 2,7   |
 * | Long localized time             | p       | 12:00 AM                          | 7     |
 * |                                 | pp      | 12:00:00 AM                       | 7     |
 * |                                 | ppp     | 12:00:00 AM GMT+2                 | 7     |
 * |                                 | pppp    | 12:00:00 AM GMT+02:00             | 2,7   |
 * | Combination of date and time    | Pp      | 04/29/1453, 12:00 AM              | 7     |
 * |                                 | PPpp    | Apr 29, 1453, 12:00:00 AM         | 7     |
 * |                                 | PPPppp  | April 29th, 1453 at ...           | 7     |
 * |                                 | PPPPpppp| Friday, April 29th, 1453 at ...   | 2,7   |
 * Notes:
 * 1. "Formatting" units (e.g. formatting quarter) in the default en-US locale
 *    are the same as "stand-alone" units, but are different in some languages.
 *    "Formatting" units are declined according to the rules of the language
 *    in the context of a date. "Stand-alone" units are always nominative singular:
 *
 *    `format(new Date(2017, 10, 6), 'do LLLL', {locale: cs}) //=> '6. listopad'`
 *
 *    `format(new Date(2017, 10, 6), 'do MMMM', {locale: cs}) //=> '6. listopadu'`
 *
 * 2. Any sequence of the identical letters is a pattern, unless it is escaped by
 *    the single quote characters (see below).
 *    If the sequence is longer than listed in table (e.g. `EEEEEEEEEEE`)
 *    the output will be the same as default pattern for this unit, usually
 *    the longest one (in case of ISO weekdays, `EEEE`). Default patterns for units
 *    are marked with "2" in the last column of the table.
 *
 *    `format(new Date(2017, 10, 6), 'MMM') //=> 'Nov'`
 *
 *    `format(new Date(2017, 10, 6), 'MMMM') //=> 'November'`
 *
 *    `format(new Date(2017, 10, 6), 'MMMMM') //=> 'N'`
 *
 *    `format(new Date(2017, 10, 6), 'MMMMMM') //=> 'November'`
 *
 *    `format(new Date(2017, 10, 6), 'MMMMMMM') //=> 'November'`
 *
 * 3. Some patterns could be unlimited length (such as `yyyyyyyy`).
 *    The output will be padded with zeros to match the length of the pattern.
 *
 *    `format(new Date(2017, 10, 6), 'yyyyyyyy') //=> '00002017'`
 *
 * 4. `QQQQQ` and `qqqqq` could be not strictly numerical in some locales.
 *    These tokens represent the shortest form of the quarter.
 *
 * 5. The main difference between `y` and `u` patterns are B.C. years:
 *
 *    | Year | `y` | `u` |
 *    |------|-----|-----|
 *    | AC 1 |   1 |   1 |
 *    | BC 1 |   1 |   0 |
 *    | BC 2 |   2 |  -1 |
 *
 *    Also `yy` always returns the last two digits of a year,
 *    while `uu` pads single digit years to 2 characters and returns other years unchanged:
 *
 *    | Year | `yy` | `uu` |
 *    |------|------|------|
 *    | 1    |   01 |   01 |
 *    | 14   |   14 |   14 |
 *    | 376  |   76 |  376 |
 *    | 1453 |   53 | 1453 |
 *
 *    The same difference is true for local and ISO week-numbering years (`Y` and `R`),
 *    except local week-numbering years are dependent on `options.weekStartsOn`
 *    and `options.firstWeekContainsDate` (compare [getISOWeekYear]{@link https://date-fns.org/docs/getISOWeekYear}
 *    and [getWeekYear]{@link https://date-fns.org/docs/getWeekYear}).
 *
 * 6. Specific non-location timezones are currently unavailable in `date-fns`,
 *    so right now these tokens fall back to GMT timezones.
 *
 * 7. These patterns are not in the Unicode Technical Standard #35:
 *    - `i`: ISO day of week
 *    - `I`: ISO week of year
 *    - `R`: ISO week-numbering year
 *    - `t`: seconds timestamp
 *    - `T`: milliseconds timestamp
 *    - `o`: ordinal number modifier
 *    - `P`: long localized date
 *    - `p`: long localized time
 *
 * 8. `YY` and `YYYY` tokens represent week-numbering years but they are often confused with years.
 *    You should enable `options.useAdditionalWeekYearTokens` to use them. See: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 *
 * 9. `D` and `DD` tokens represent days of the year but they are often confused with days of the month.
 *    You should enable `options.useAdditionalDayOfYearTokens` to use them. See: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 *
 * @param {Date|Number} date - the original date
 * @param {String} format - the string of tokens
 * @param {Object} [options] - an object with options.
 * @param {Locale} [options.locale=defaultLocale] - the locale object. See [Locale]{@link https://date-fns.org/docs/Locale}
 * @param {0|1|2|3|4|5|6} [options.weekStartsOn=0] - the index of the first day of the week (0 - Sunday)
 * @param {Number} [options.firstWeekContainsDate=1] - the day of January, which is
 * @param {Boolean} [options.useAdditionalWeekYearTokens=false] - if true, allows usage of the week-numbering year tokens `YY` and `YYYY`;
 *   see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 * @param {Boolean} [options.useAdditionalDayOfYearTokens=false] - if true, allows usage of the day of year tokens `D` and `DD`;
 *   see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 * @returns {String} the formatted date string
 * @throws {TypeError} 2 arguments required
 * @throws {RangeError} `date` must not be Invalid Date
 * @throws {RangeError} `options.locale` must contain `localize` property
 * @throws {RangeError} `options.locale` must contain `formatLong` property
 * @throws {RangeError} `options.weekStartsOn` must be between 0 and 6
 * @throws {RangeError} `options.firstWeekContainsDate` must be between 1 and 7
 * @throws {RangeError} use `yyyy` instead of `YYYY` for formatting years using [format provided] to the input [input provided]; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 * @throws {RangeError} use `yy` instead of `YY` for formatting years using [format provided] to the input [input provided]; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 * @throws {RangeError} use `d` instead of `D` for formatting days of the month using [format provided] to the input [input provided]; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 * @throws {RangeError} use `dd` instead of `DD` for formatting days of the month using [format provided] to the input [input provided]; see: https://github.com/date-fns/date-fns/blob/master/docs/unicodeTokens.md
 * @throws {RangeError} format string contains an unescaped latin alphabet character
 *
 * @example
 * // Represent 11 February 2014 in middle-endian format:
 * const result = format(new Date(2014, 1, 11), 'MM/dd/yyyy')
 * //=> '02/11/2014'
 *
 * @example
 * // Represent 2 July 2014 in Esperanto:
 * import { eoLocale } from 'date-fns/locale/eo'
 * const result = format(new Date(2014, 6, 2), "do 'de' MMMM yyyy", {
 *   locale: eoLocale
 * })
 * //=> '2-a de julio 2014'
 *
 * @example
 * // Escape string by single quote characters:
 * const result = format(new Date(2014, 6, 2, 15), "h 'o''clock'")
 * //=> "3 o'clock"
 */

function format(dirtyDate, dirtyFormatStr, options) {
  var _ref, _options$locale, _ref2, _ref3, _ref4, _options$firstWeekCon, _options$locale2, _options$locale2$opti, _defaultOptions$local, _defaultOptions$local2, _ref5, _ref6, _ref7, _options$weekStartsOn, _options$locale3, _options$locale3$opti, _defaultOptions$local3, _defaultOptions$local4;

  requiredArgs(2, arguments);
  var formatStr = String(dirtyFormatStr);
  var defaultOptions = getDefaultOptions();
  var locale = (_ref = (_options$locale = options === null || options === void 0 ? void 0 : options.locale) !== null && _options$locale !== void 0 ? _options$locale : defaultOptions.locale) !== null && _ref !== void 0 ? _ref : defaultLocale;
  var firstWeekContainsDate = toInteger((_ref2 = (_ref3 = (_ref4 = (_options$firstWeekCon = options === null || options === void 0 ? void 0 : options.firstWeekContainsDate) !== null && _options$firstWeekCon !== void 0 ? _options$firstWeekCon : options === null || options === void 0 ? void 0 : (_options$locale2 = options.locale) === null || _options$locale2 === void 0 ? void 0 : (_options$locale2$opti = _options$locale2.options) === null || _options$locale2$opti === void 0 ? void 0 : _options$locale2$opti.firstWeekContainsDate) !== null && _ref4 !== void 0 ? _ref4 : defaultOptions.firstWeekContainsDate) !== null && _ref3 !== void 0 ? _ref3 : (_defaultOptions$local = defaultOptions.locale) === null || _defaultOptions$local === void 0 ? void 0 : (_defaultOptions$local2 = _defaultOptions$local.options) === null || _defaultOptions$local2 === void 0 ? void 0 : _defaultOptions$local2.firstWeekContainsDate) !== null && _ref2 !== void 0 ? _ref2 : 1); // Test if weekStartsOn is between 1 and 7 _and_ is not NaN

  if (!(firstWeekContainsDate >= 1 && firstWeekContainsDate <= 7)) {
    throw new RangeError('firstWeekContainsDate must be between 1 and 7 inclusively');
  }

  var weekStartsOn = toInteger((_ref5 = (_ref6 = (_ref7 = (_options$weekStartsOn = options === null || options === void 0 ? void 0 : options.weekStartsOn) !== null && _options$weekStartsOn !== void 0 ? _options$weekStartsOn : options === null || options === void 0 ? void 0 : (_options$locale3 = options.locale) === null || _options$locale3 === void 0 ? void 0 : (_options$locale3$opti = _options$locale3.options) === null || _options$locale3$opti === void 0 ? void 0 : _options$locale3$opti.weekStartsOn) !== null && _ref7 !== void 0 ? _ref7 : defaultOptions.weekStartsOn) !== null && _ref6 !== void 0 ? _ref6 : (_defaultOptions$local3 = defaultOptions.locale) === null || _defaultOptions$local3 === void 0 ? void 0 : (_defaultOptions$local4 = _defaultOptions$local3.options) === null || _defaultOptions$local4 === void 0 ? void 0 : _defaultOptions$local4.weekStartsOn) !== null && _ref5 !== void 0 ? _ref5 : 0); // Test if weekStartsOn is between 0 and 6 _and_ is not NaN

  if (!(weekStartsOn >= 0 && weekStartsOn <= 6)) {
    throw new RangeError('weekStartsOn must be between 0 and 6 inclusively');
  }

  if (!locale.localize) {
    throw new RangeError('locale must contain localize property');
  }

  if (!locale.formatLong) {
    throw new RangeError('locale must contain formatLong property');
  }

  var originalDate = toDate(dirtyDate);

  if (!isValid(originalDate)) {
    throw new RangeError('Invalid time value');
  } // Convert the date in system timezone to the same date in UTC+00:00 timezone.
  // This ensures that when UTC functions will be implemented, locales will be compatible with them.
  // See an issue about UTC functions: https://github.com/date-fns/date-fns/issues/376


  var timezoneOffset = getTimezoneOffsetInMilliseconds(originalDate);
  var utcDate = subMilliseconds(originalDate, timezoneOffset);
  var formatterOptions = {
    firstWeekContainsDate: firstWeekContainsDate,
    weekStartsOn: weekStartsOn,
    locale: locale,
    _originalDate: originalDate
  };
  var result = formatStr.match(longFormattingTokensRegExp).map(function (substring) {
    var firstCharacter = substring[0];

    if (firstCharacter === 'p' || firstCharacter === 'P') {
      var longFormatter = longFormatters$1[firstCharacter];
      return longFormatter(substring, locale.formatLong);
    }

    return substring;
  }).join('').match(formattingTokensRegExp).map(function (substring) {
    // Replace two single quote characters with one single quote character
    if (substring === "''") {
      return "'";
    }

    var firstCharacter = substring[0];

    if (firstCharacter === "'") {
      return cleanEscapedString(substring);
    }

    var formatter = formatters$1[firstCharacter];

    if (formatter) {
      if (!(options !== null && options !== void 0 && options.useAdditionalWeekYearTokens) && isProtectedWeekYearToken(substring)) {
        throwProtectedError(substring, dirtyFormatStr, String(dirtyDate));
      }

      if (!(options !== null && options !== void 0 && options.useAdditionalDayOfYearTokens) && isProtectedDayOfYearToken(substring)) {
        throwProtectedError(substring, dirtyFormatStr, String(dirtyDate));
      }

      return formatter(utcDate, substring, locale.localize, formatterOptions);
    }

    if (firstCharacter.match(unescapedLatinCharacterRegExp)) {
      throw new RangeError('Format string contains an unescaped latin alphabet character `' + firstCharacter + '`');
    }

    return substring;
  }).join('');
  return result;
}

function cleanEscapedString(input) {
  var matched = input.match(escapedStringRegExp);

  if (!matched) {
    return input;
  }

  return matched[1].replace(doubleQuoteRegExp, "'");
}

/**
 * @name fromUnixTime
 * @category Timestamp Helpers
 * @summary Create a date from a Unix timestamp.
 *
 * @description
 * Create a date from a Unix timestamp (in seconds). Decimal values will be discarded.
 *
 * @param {Number} unixTime - the given Unix timestamp (in seconds)
 * @returns {Date} the date
 * @throws {TypeError} 1 argument required
 *
 * @example
 * // Create the date 29 February 2012 11:45:05:
 * const result = fromUnixTime(1330515905)
 * //=> Wed Feb 29 2012 11:45:05
 */

function fromUnixTime(dirtyUnixTime) {
  requiredArgs(1, arguments);
  var unixTime = toInteger(dirtyUnixTime);
  return toDate(unixTime * 1000);
}

function formatTimestampToDateTime(ts) {
  if (!ts) return "";
  return format(fromUnixTime(ts), "P, p");
}

function FormSubmissionsTableShared(_ref) {
  var submissions = _ref.submissions,
    total = _ref.total,
    onTableArgsChange = _ref.onTableArgsChange,
    isLoading = _ref.isLoading,
    error = _ref.error,
    onRetry = _ref.onRetry,
    actions = _ref.actions,
    _onRowClick = _ref.onRowClick;
  var title = total ? "".concat(total, " Submissions") : "";
  return /*#__PURE__*/React__namespace.default.createElement(Container$8, null, /*#__PURE__*/React__namespace.default.createElement(Table, {
    onTableArgsChange: onTableArgsChange,
    onRetry: onRetry,
    error: error,
    isLoading: isLoading,
    total: total,
    isSearchable: false,
    title: title,
    emptyTitle: "No Submissions",
    rows: submissions,
    headerCells: getHeaderCellConfigs(),
    cellConfigs: getCellConfigs(),
    onRowClick: function onRowClick(_ref2) {
      var row = _ref2.row;
      return _onRowClick(row);
    },
    actions: actions
  }));
}
FormSubmissionsTableShared.propTypes = {
  submissions: propTypesExports.array,
  total: propTypesExports.number,
  onTableArgsChange: propTypesExports.func.isRequired,
  isLoading: propTypesExports.bool,
  error: propTypesExports.object,
  onRetry: propTypesExports.func.isRequired,
  actions: propTypesExports.array,
  onRowClick: propTypesExports.func.isRequired
};
var Container$8 = styled__default.default(Box$1)({
  minHeight: "300px"
});
function getHeaderCellConfigs() {
  return [{
    id: "author.first_name",
    label: "Submitted By",
    shouldNotSort: true
  }, {
    id: "created_at",
    label: "Submitted At"
  }];
}
function getCellConfigs() {
  return [{
    path: "author",
    formatValue: function formatValue(row) {
      return getFullName(row.author);
    }
  }, {
    path: "created_at",
    formatValue: function formatValue(row) {
      return formatTimestampToDateTime(row.created_at);
    }
  }];
}

function FormSubmissionsTable(_ref) {
  var formId = _ref.formId,
    onRowClick = _ref.onRowClick;
  var _useState = React.useState({}),
    _useState2 = _slicedToArray(_useState, 2),
    submissionsQueryArgs = _useState2[0],
    setSubmissionsQueryArgs = _useState2[1];
  var _useFormSubmissions = useFormSubmissions(),
    useGetFormSubmissions = _useFormSubmissions.useGetFormSubmissions;
  var _useGetFormSubmission = useGetFormSubmissions(_objectSpread2({
      formId: formId
    }, submissionsQueryArgs)),
    submissions = _useGetFormSubmission.submissions,
    isLoading = _useGetFormSubmission.isLoading,
    error = _useGetFormSubmission.error,
    refetch = _useGetFormSubmission.refetch,
    total = _useGetFormSubmission.total;
  return /*#__PURE__*/React__namespace.default.createElement(FormSubmissionsTableShared, {
    submissions: submissions,
    total: total,
    onTableArgsChange: setSubmissionsQueryArgs,
    isLoading: isLoading,
    error: error,
    onRetry: refetch,
    onRowClick: onRowClick
  });
}
FormSubmissionsTable.propTypes = {
  formId: propTypesExports.string.isRequired,
  onRowClick: propTypesExports.func.isRequired
};

var ArrowBackIos = {};

var _interopRequireDefault$6 = interopRequireDefaultExports;
Object.defineProperty(ArrowBackIos, "__esModule", {
  value: true
});
var default_1$6 = ArrowBackIos.default = void 0;
var _createSvgIcon$6 = _interopRequireDefault$6(requireCreateSvgIcon());
var _jsxRuntime$6 = requireJsxRuntime();
var _default$6 = (0, _createSvgIcon$6.default)( /*#__PURE__*/(0, _jsxRuntime$6.jsx)("path", {
  d: "M11.67 3.87 9.9 2.1 0 12l9.9 9.9 1.77-1.77L3.54 12z"
}), 'ArrowBackIos');
default_1$6 = ArrowBackIos.default = _default$6;

function DeleteButton(_ref) {
  var onClick = _ref.onClick,
    isHidden = _ref.isHidden;
  if (isHidden) return null;
  return /*#__PURE__*/React__namespace.default.createElement(StyledButton$1, {
    onClick: onClick
  }, "Delete");
}
DeleteButton.propTypes = {
  onClick: propTypesExports.func.isRequired,
  isHidden: propTypesExports.bool
};
var StyledButton$1 = styled__default.default(Button)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    textTransform: "none",
    fontWeight: "normal",
    padding: "2px !important",
    color: theme.palette.error.main
  };
});

function DeleteFormSubmissionConfirmationModal(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    onCompleted = _ref.onCompleted,
    submissionToDelete = _ref.submissionToDelete;
  var _useFormSubmissions = useFormSubmissions(),
    useDeleteFormSubmission = _useFormSubmissions.useDeleteFormSubmission;
  var _useDeleteFormSubmiss = useDeleteFormSubmission({
      onCompleted: onCompleted
    }),
    deleteFormSubmission = _useDeleteFormSubmiss.deleteFormSubmission,
    isLoading = _useDeleteFormSubmiss.isLoading;
  return /*#__PURE__*/React__namespace.default.createElement(ConfirmationModal, {
    isOpen: isOpen,
    onClose: onClose,
    confirmationButtonLabel: "Delete",
    message: "Are you sure you want to delete this submission?",
    onConfirmation: function onConfirmation() {
      return deleteFormSubmission({
        id: submissionToDelete.id
      });
    },
    isLoading: isLoading
  });
}
DeleteFormSubmissionConfirmationModal.propTypes = {
  isOpen: propTypesExports.bool,
  onClose: propTypesExports.func.isRequired,
  onCompleted: propTypesExports.func.isRequired,
  submissionToDelete: propTypesExports.shape({
    id: propTypesExports.string.isRequired
  })
};

function FormSubmissionView(_ref) {
  var formSubmission = _ref.formSubmission,
    form = _ref.form,
    onBackClick = _ref.onBackClick;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isModalOpen = _useState2[0],
    setIsModalOpen = _useState2[1];
  var _useUtils = useUtils(),
    useCurrentUser = _useUtils.useCurrentUser;
  var _useCurrentUser = useCurrentUser(),
    user = _useCurrentUser.user;
  var shouldHideDeleteButton = formSubmission.author.id !== (user === null || user === void 0 ? void 0 : user.id);
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(Header$2, {
    "data-testid": TEST_IDS.FORM_SUBMISSION_VIEW
  }, /*#__PURE__*/React__namespace.default.createElement(IconButton$2, {
    "data-testid": TEST_IDS.BACK_BUTTON,
    onClick: onBackClick
  }, /*#__PURE__*/React__namespace.default.createElement(default_1$6, null)), /*#__PURE__*/React__namespace.default.createElement(DeleteButton, {
    onClick: function onClick() {
      return setIsModalOpen(true);
    },
    isHidden: shouldHideDeleteButton
  }, "Delete")), /*#__PURE__*/React__namespace.default.createElement(FormSubmissionViewFields, {
    form: form,
    submission: formSubmission
  }), /*#__PURE__*/React__namespace.default.createElement(DeleteFormSubmissionConfirmationModal, {
    isOpen: isModalOpen,
    onClose: function onClose() {
      return setIsModalOpen(false);
    },
    onCompleted: onBackClick,
    submissionToDelete: formSubmission
  }));
}
FormSubmissionView.propTypes = {
  formSubmission: propTypesExports.object.isRequired,
  form: propTypesExports.object.isRequired,
  onBackClick: propTypesExports.func.isRequired
};
var Header$2 = styled__default.default(Box$1)({
  display: "flex",
  alignItems: "center",
  justifyContent: "space-between"
});

function OwnFormSubmissionsTable(_ref) {
  var formId = _ref.formId,
    onRowClick = _ref.onRowClick;
  var _useState = React.useState({}),
    _useState2 = _slicedToArray(_useState, 2),
    submissionsQueryArgs = _useState2[0],
    setSubmissionsQueryArgs = _useState2[1];
  var _useState3 = React.useState(null),
    _useState4 = _slicedToArray(_useState3, 2),
    submissionToDelete = _useState4[0],
    setSubmissionToDelete = _useState4[1];
  var _useFormSubmissions = useFormSubmissions(),
    useGetOwnFormSubmissions = _useFormSubmissions.useGetOwnFormSubmissions;
  var _useGetOwnFormSubmiss = useGetOwnFormSubmissions(_objectSpread2({
      formId: formId
    }, submissionsQueryArgs)),
    submissions = _useGetOwnFormSubmiss.submissions,
    isLoading = _useGetOwnFormSubmiss.isLoading,
    error = _useGetOwnFormSubmiss.error,
    refetch = _useGetOwnFormSubmiss.refetch,
    total = _useGetOwnFormSubmiss.total;
  var closeConfirmationModal = function closeConfirmationModal() {
    return setSubmissionToDelete(null);
  };
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(FormSubmissionsTableShared, {
    submissions: submissions,
    total: total,
    onTableArgsChange: setSubmissionsQueryArgs,
    isLoading: isLoading,
    error: error,
    onRetry: refetch,
    actions: getTableActions({
      setSubmissionToDelete: setSubmissionToDelete
    }),
    onRowClick: onRowClick
  }), /*#__PURE__*/React__namespace.default.createElement(DeleteFormSubmissionConfirmationModal, {
    isOpen: Boolean(submissionToDelete),
    onClose: closeConfirmationModal,
    onCompleted: closeConfirmationModal,
    submissionToDelete: submissionToDelete
  }));
}
OwnFormSubmissionsTable.propTypes = {
  formId: propTypesExports.string.isRequired,
  onRowClick: propTypesExports.func.isRequired
};
function getTableActions(_ref2) {
  var setSubmissionToDelete = _ref2.setSubmissionToDelete;
  return [{
    name: "Delete",
    onClick: setSubmissionToDelete
  }];
}

var TAB_NAMES = {
  FORM: "Form",
  MY_SUBMISSIONS: "My Submissions",
  MY_SUBMISSION: "My Submission",
  SUBMISSIONS: "Submissions",
  SELECTED_SUBMISSION: "Selected Submission"
};
var SUBMISSION_VIEW_TAB_INDEX = 3;

// When there's a selectedSubmission, we hide the tabs header and override the
// index to show the submission view. In any other scenario, we're not rendering
// the selected submission tab.
function FormSubmissionEditorTabs(_ref) {
  var form = _ref.form,
    selectedSubmission = _ref.selectedSubmission,
    onSubmissionCompleted = _ref.onSubmissionCompleted,
    onSubmissionClick = _ref.onSubmissionClick,
    onBackClick = _ref.onBackClick;
  var formId = form === null || form === void 0 ? void 0 : form.id;
  var shouldShowSubmissionView = Boolean(selectedSubmission);
  var shouldShowSubmissionsTab = form === null || form === void 0 ? void 0 : form.are_submissions_public;
  var currentTabIndexOverride = shouldShowSubmissionView ? SUBMISSION_VIEW_TAB_INDEX : null;
  var tabs = getTabNames({
    form: form,
    shouldShowSubmissionsTab: shouldShowSubmissionsTab,
    shouldShowSubmissionView: shouldShowSubmissionView
  });
  return /*#__PURE__*/React__namespace.default.createElement(Tabs, {
    prefix: TAB_PREFIXES.SUBMISSION_EDITOR,
    tabs: tabs,
    shouldHideTabsHeader: shouldShowSubmissionView,
    currentTabIndexOverride: currentTabIndexOverride,
    narrowTabs: true,
    shouldClearQueryOnUnmount: true
  }, /*#__PURE__*/React__namespace.default.createElement(FormSubmissionEditorForm, {
    onCompleted: onSubmissionCompleted
  }), /*#__PURE__*/React__namespace.default.createElement(OwnFormSubmissionsTable, {
    formId: formId,
    onRowClick: onSubmissionClick
  }), shouldShowSubmissionsTab && /*#__PURE__*/React__namespace.default.createElement(FormSubmissionsTable, {
    formId: formId,
    onRowClick: onSubmissionClick
  }), shouldShowSubmissionView && /*#__PURE__*/React__namespace.default.createElement(FormSubmissionView, {
    formSubmission: selectedSubmission,
    form: form,
    onBackClick: onBackClick
  }));
}
FormSubmissionEditorTabs.propTypes = {
  form: propTypesExports.object,
  selectedSubmission: propTypesExports.object,
  onSubmissionCompleted: propTypesExports.func.isRequired,
  onSubmissionClick: propTypesExports.func.isRequired,
  onBackClick: propTypesExports.func.isRequired
};
function getTabNames(_ref2) {
  var form = _ref2.form,
    shouldShowSubmissionsTab = _ref2.shouldShowSubmissionsTab,
    shouldShowSubmissionView = _ref2.shouldShowSubmissionView;
  var isLimitOne = form.max_submission_count === 1;
  var mySubmissionTabName = isLimitOne ? TAB_NAMES.MY_SUBMISSION : TAB_NAMES.MY_SUBMISSIONS;
  var tabNames = [TAB_NAMES.FORM, mySubmissionTabName];
  if (shouldShowSubmissionsTab) {
    tabNames.push(TAB_NAMES.SUBMISSIONS);
  }
  if (shouldShowSubmissionView) {
    tabNames.push(TAB_NAMES.SELECTED_SUBMISSION);
  }
  return tabNames;
}

function FormSubmissionEditorModal(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    form = _ref.form,
    onCompleted = _ref.onCompleted;
  var _useState = React.useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    selectedSubmission = _useState2[0],
    setSelectedSubmission = _useState2[1];
  return /*#__PURE__*/React__namespace.default.createElement(StyledModal, {
    width: "95%",
    isOpen: isOpen,
    onClose: onClose,
    hideCloseButton: Boolean(selectedSubmission),
    title: selectedSubmission ? null : form.title
  }, /*#__PURE__*/React__namespace.default.createElement(FormSubmissionEditorProvider, {
    form: form
  }, /*#__PURE__*/React__namespace.default.createElement(FormSubmissionEditorTabs, {
    form: form,
    selectedSubmission: selectedSubmission,
    onSubmissionCompleted: function onSubmissionCompleted() {
      onCompleted === null || onCompleted === void 0 ? void 0 : onCompleted();
      onClose();
    },
    onSubmissionClick: setSelectedSubmission,
    onBackClick: function onBackClick() {
      return setSelectedSubmission(null);
    }
  })));
}
FormSubmissionEditorModal.propTypes = {
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  form: propTypesExports.object,
  onCompleted: propTypesExports.func
};
var StyledModal = styled__default.default(Modal)({
  maxWidth: "600px"
});

function Form(_ref) {
  var form = _ref.form;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isModalOpen = _useState2[0],
    setIsModalOpen = _useState2[1];
  var closeModal = function closeModal() {
    return setIsModalOpen(false);
  };
  return /*#__PURE__*/React__namespace.default.createElement(Container$7, {
    "data-testid": TEST_IDS.FORM_CONTENT_BLOCK_VIEW
  }, /*#__PURE__*/React__namespace.default.createElement(FormTitle, null, /*#__PURE__*/React__namespace.default.createElement(default_1$v, null), /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "h5"
  }, form.title)), /*#__PURE__*/React__namespace.default.createElement(StyledButton, {
    onClick: function onClick() {
      return setIsModalOpen(true);
    },
    variant: "contained",
    size: "small"
  }, "Open"), /*#__PURE__*/React__namespace.default.createElement(FormSubmissionEditorModal, {
    isOpen: isModalOpen,
    onClose: closeModal,
    onCompleted: closeModal,
    form: form
  }));
}
Form.propTypes = {
  form: propTypesExports.shape({
    title: propTypesExports.string
  })
};
var Container$7 = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    backgroundColor: theme.palette.contentBlocks.background,
    borderRadius: "5px",
    display: "flex",
    justifyContent: "space-between",
    alignItems: "center",
    padding: "20px"
  };
});
var FormTitle = styled__default.default(Typography$1)({
  display: "flex",
  flexDirection: "row",
  gap: "5px"
});
var StyledButton = styled__default.default(Button)({
  fontSize: "16px !important"
});

function ExpandableImageContainer(_ref) {
  var title = _ref.title,
    caption = _ref.caption,
    children = _ref.children;
  return /*#__PURE__*/React__namespace.default.createElement(Container$6, null, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), /*#__PURE__*/React__namespace.default.createElement(ImageContainer, null, children), caption && /*#__PURE__*/React__namespace.default.createElement(InputCaption$1, null, caption));
}
ExpandableImageContainer.propTypes = {
  title: propTypesExports.string,
  caption: propTypesExports.string,
  ModalComponent: propTypesExports.elementType,
  children: propTypesExports.any
};
var Container$6 = styled__default.default(Box$1)({
  display: "flex",
  flexDirection: "column",
  width: "100%"
});
var ImageContainer = styled__default.default(Box$1)(function () {
  return {
    maxHeight: "250px",
    alignSelf: "flex-start",
    overflow: "hidden",
    width: "100%"
  };
});
var InputCaption$1 = styled__default.default(material.Typography)(function () {
  return {
    marginTop: "1rem",
    marginLeft: "0.5rem"
  };
});

function isPdfMime(mime) {
  return mime === "application/pdf";
}

var CloseOutlined = {};

var _interopRequireDefault$5 = interopRequireDefaultExports;
Object.defineProperty(CloseOutlined, "__esModule", {
  value: true
});
var default_1$5 = CloseOutlined.default = void 0;
var _createSvgIcon$5 = _interopRequireDefault$5(requireCreateSvgIcon());
var _jsxRuntime$5 = requireJsxRuntime();
var _default$5 = (0, _createSvgIcon$5.default)( /*#__PURE__*/(0, _jsxRuntime$5.jsx)("path", {
  d: "M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41z"
}), 'CloseOutlined');
default_1$5 = CloseOutlined.default = _default$5;

function AttachmentModalCloseButton(_ref) {
  var onClick = _ref.onClick;
  var StyledCloseIcon = getStyledCloseIcon();
  return /*#__PURE__*/React__namespace.default.createElement(CircledButtonIcon, {
    onClick: onClick,
    IconComponent: StyledCloseIcon
  });
}
AttachmentModalCloseButton.propTypes = {
  onClick: propTypesExports.func.isRequired
};
function getStyledCloseIcon() {
  return styled__default.default(default_1$5)(function (_ref2) {
    var theme = _ref2.theme;
    return {
      color: theme.palette.colors.icon.neutralContrast
    };
  });
}

function DownloadAttachmentButton(_ref) {
  var _ref$title = _ref.title,
    title = _ref$title === void 0 ? "Download" : _ref$title,
    fileName = _ref.fileName,
    _ref$variant = _ref.variant,
    variant = _ref$variant === void 0 ? "outlined" : _ref$variant,
    downloadUrl = _ref.downloadUrl,
    _onClick = _ref.onClick,
    type = _ref.type;
  // allow to override the default download file name
  var downloadFileName = fileName || getDownloadFileName(type);
  var isDisabled = !_onClick && !downloadUrl;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isLoading = _useState2[0],
    setIsLoading = _useState2[1];
  return /*#__PURE__*/React__namespace.default.createElement(Button, {
    href: downloadUrl,
    download: downloadFileName,
    variant: variant,
    startIcon: /*#__PURE__*/React__namespace.default.createElement(default_1$x, null),
    disabled: isDisabled,
    loading: isLoading,
    onClick: function onClick() {
      return handleOnClick({
        onClick: _onClick,
        setIsLoading: setIsLoading
      });
    }
  }, title);
}
function handleOnClick(_x) {
  return _handleOnClick.apply(this, arguments);
}
function _handleOnClick() {
  _handleOnClick = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee(_ref2) {
    var onClick, setIsLoading;
    return _regeneratorRuntime().wrap(function _callee$(_context) {
      while (1) switch (_context.prev = _context.next) {
        case 0:
          onClick = _ref2.onClick, setIsLoading = _ref2.setIsLoading;
          setIsLoading(true);
          _context.next = 4;
          return onClick();
        case 4:
          setIsLoading(false);
        case 5:
        case "end":
          return _context.stop();
      }
    }, _callee);
  }));
  return _handleOnClick.apply(this, arguments);
}
function getDownloadFileName(type) {
  switch (type) {
    case DOWNLOAD_FILE_TYPES.IMAGE:
      return "image";
    case DOWNLOAD_FILE_TYPES.MULTI_IMAGE:
      return "images";
    case DOWNLOAD_FILE_TYPES.PDF:
    default:
      return "document";
  }
}
DownloadAttachmentButton.propTypes = {
  title: propTypesExports.string,
  downloadUrl: propTypesExports.string,
  fileName: propTypesExports.string,
  isPdf: propTypesExports.bool,
  onClick: propTypesExports.func,
  isLoading: propTypesExports.bool,
  variant: propTypesExports.string,
  type: propTypesExports.string
};

function MeasureWidth(_ref) {
  var onChange = _ref.onChange;
  return /*#__PURE__*/React__namespace.default.createElement(Measure__default.default, {
    bounds: true,
    onResize: function onResize(contentRect) {
      return onChange(contentRect.bounds.width);
    }
  }, function (_ref2) {
    var measureRef = _ref2.measureRef;
    return /*#__PURE__*/React__namespace.default.createElement(ZeroHeightBox, {
      ref: measureRef
    });
  });
}
MeasureWidth.propTypes = {
  onChange: propTypesExports.func
};
var ZeroHeightBox = styled__default.default(Box$1)({
  height: "0",
  width: "100%"
});

// Sets pdf worker. Since we're using rollup, the worker needs to be
// manually set, otherwise it won't get bundled.
reactPdf.pdfjs.GlobalWorkerOptions.workerSrc = pdf_worker_entry;
function Pdf$1(_ref) {
  var attachmentId = _ref.attachmentId,
    onLoad = _ref.onLoad;
  var _useState = React.useState(0),
    _useState2 = _slicedToArray(_useState, 2),
    width = _useState2[0],
    setWidth = _useState2[1];
  var _useState3 = React.useState(0),
    _useState4 = _slicedToArray(_useState3, 2),
    numberOfPages = _useState4[0],
    setNumberOfPages = _useState4[1];
  var _useUtils = useUtils(),
    useAttachmentImage = _useUtils.useAttachmentImage;
  var _useAttachmentImage = useAttachmentImage({
      attachmentId: attachmentId,
      onLoad: onLoad
    }),
    remoteUrl = _useAttachmentImage.remoteUrl,
    isLoading = _useAttachmentImage.isLoading;

  // Prevents pdf from reloading on every re-render.
  var file = React.useMemo(function () {
    return {
      url: remoteUrl
    };
  }, [isLoading]);
  var skeleton = /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    variant: "rectangular",
    width: "100%",
    height: "300px"
  });
  if (isLoading) return skeleton;
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(MeasureWidth, {
    onChange: setWidth
  }), /*#__PURE__*/React__namespace.default.createElement(reactPdf.Document, {
    file: file,
    onLoadSuccess: function onLoadSuccess(_ref2) {
      var numPages = _ref2.numPages;
      return setNumberOfPages(numPages);
    },
    loading: skeleton
  }, libCommon.getArrayOfCount(numberOfPages).map(function (idx) {
    return /*#__PURE__*/React__namespace.default.createElement(reactPdf.Page, {
      key: "pdf-page-".concat(idx),
      pageNumber: idx + 1,
      renderTextLayer: false,
      renderAnnotationLayer: false,
      width: width
      // Svg provides smooth resizing
      ,
      renderMode: "svg"
    });
  })));
}
Pdf$1.propTypes = {
  attachmentId: propTypesExports.string,
  onLoad: propTypesExports.func
};

function AttachmentPreviewModal(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    name = _ref.name,
    description = _ref.description,
    attachmentId = _ref.attachmentId,
    attachmentMime = _ref.attachmentMime,
    isPdfExternal = _ref.isPdf,
    style = _ref.style;
  var _useState = React.useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    downloadUrl = _useState2[0],
    setDownloadUrl = _useState2[1];
  var isPdf = isPdfMime(attachmentMime) || isPdfExternal;
  var shouldShowTitles = name || description;
  var downloadType = getDownloadType(isPdf);
  return /*#__PURE__*/React__namespace.default.createElement(Modal, {
    isOpen: isOpen,
    onClose: onClose,
    CloseButtonComponent: AttachmentModalCloseButton
  }, /*#__PURE__*/React__namespace.default.createElement(Header$1, null, shouldShowTitles && /*#__PURE__*/React__namespace.default.createElement(Box$1, null, name && /*#__PURE__*/React__namespace.default.createElement(Typography$1, {
    variant: "h4"
  }, name), description && /*#__PURE__*/React__namespace.default.createElement(Typography$1, null, description)), /*#__PURE__*/React__namespace.default.createElement(DownloadAttachmentButton, {
    downloadUrl: downloadUrl,
    fileName: name,
    type: downloadType
  })), isPdf ? /*#__PURE__*/React__namespace.default.createElement(Pdf$1, {
    attachmentId: attachmentId,
    onLoad: setDownloadUrl
  }) : /*#__PURE__*/React__namespace.default.createElement(StyledAttachmentPreview$1, {
    attachmentId: attachmentId,
    style: style,
    onLoad: setDownloadUrl
  }));
}
function getDownloadType(isPdf) {
  return isPdf ? DOWNLOAD_FILE_TYPES.PDF : DOWNLOAD_FILE_TYPES.IMAGE;
}
AttachmentPreviewModal.propTypes = {
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  name: propTypesExports.string,
  description: propTypesExports.string,
  attachmentId: propTypesExports.string.isRequired,
  attachmentMime: propTypesExports.string,
  isPdf: propTypesExports.bool,
  style: propTypesExports.object
};
var StyledAttachmentPreview$1 = styled__default.default(AttachmentPreview)({
  objectFit: "contain",
  width: "100%"
});
var Header$1 = styled__default.default(Box$1)(function (_ref2) {
  var _ref3;
  var theme = _ref2.theme;
  return _ref3 = {
    display: "flex",
    alignItems: "center",
    marginBottom: "20px",
    marginLeft: "20px",
    gap: 30
  }, _defineProperty(_ref3, theme.breakpoints.down("md"), {
    flexDirection: "column",
    alignItems: "flex-start",
    gap: 10
  }), _defineProperty(_ref3, theme.breakpoints.down("sm"), {
    textAlign: "center",
    alignItems: "center",
    marginLeft: "0"
  }), _ref3;
});

function ExpandableImage(_ref) {
  var attachmentId = _ref.attachmentId,
    title = _ref.title,
    caption = _ref.caption;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isModalOpen = _useState2[0],
    setIsModalOpen = _useState2[1];
  var styles = getStyles$2();
  return /*#__PURE__*/React__namespace.default.createElement(ExpandableImageContainer, {
    title: title,
    caption: caption
  }, /*#__PURE__*/React__namespace.default.createElement(StyledAttachmentPreview, {
    attachmentId: attachmentId,
    PreviewIcon: ExpandIcon,
    onClick: function onClick() {
      return setIsModalOpen(true);
    },
    containerStyle: styles.container
  }), /*#__PURE__*/React__namespace.default.createElement(AttachmentPreviewModal, {
    isOpen: isModalOpen,
    onClose: function onClose() {
      return setIsModalOpen(false);
    },
    attachmentId: attachmentId,
    style: styles.image
  }));
}
ExpandableImage.propTypes = {
  attachmentId: propTypesExports.string,
  title: propTypesExports.string,
  caption: propTypesExports.string
};
var StyledAttachmentPreview = styled__default.default(AttachmentPreview)({
  objectFit: "contain",
  width: "100%",
  display: "inline-block",
  maxHeight: "unset"
});
function getStyles$2() {
  return {
    image: {
      width: "100%"
    },
    skeleton: {
      width: 250,
      height: 200
    },
    container: {
      width: "100%"
    }
  };
}

var GridViewRounded = {};

var _interopRequireDefault$4 = interopRequireDefaultExports;
Object.defineProperty(GridViewRounded, "__esModule", {
  value: true
});
var default_1$4 = GridViewRounded.default = void 0;
var _createSvgIcon$4 = _interopRequireDefault$4(requireCreateSvgIcon());
var _jsxRuntime$4 = requireJsxRuntime();
var _default$4 = (0, _createSvgIcon$4.default)( /*#__PURE__*/(0, _jsxRuntime$4.jsx)("path", {
  d: "M5 11h4c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2H5c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2zm0 10h4c1.1 0 2-.9 2-2v-4c0-1.1-.9-2-2-2H5c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2zm8-16v4c0 1.1.9 2 2 2h4c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2h-4c-1.1 0-2 .9-2 2zm2 16h4c1.1 0 2-.9 2-2v-4c0-1.1-.9-2-2-2h-4c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2z"
}), 'GridViewRounded');
default_1$4 = GridViewRounded.default = _default$4;

var DOWNLOAD_BUTTON_LABEL = "Download all";
function MultiAttachmentPreviewModal(_ref) {
  var isOpen = _ref.isOpen,
    onClose = _ref.onClose,
    attachmentIdList = _ref.attachmentIdList,
    style = _ref.style;
  var _useUtils = useUtils(),
    useDownloadAttachmentsZip = _useUtils.useDownloadAttachmentsZip;
  var downloadZip = useDownloadAttachmentsZip({
    attachmentIdList: attachmentIdList
  });
  return /*#__PURE__*/React__namespace.default.createElement(Modal, {
    isOpen: isOpen,
    onClose: onClose,
    CloseButtonComponent: AttachmentModalCloseButton
  }, /*#__PURE__*/React__namespace.default.createElement(Header, null, /*#__PURE__*/React__namespace.default.createElement(DownloadAttachmentButton, {
    type: DOWNLOAD_FILE_TYPES.MULTI_IMAGE,
    title: DOWNLOAD_BUTTON_LABEL,
    onClick: downloadZip
  })), /*#__PURE__*/React__namespace.default.createElement(Container$5, null, attachmentIdList.map(function (attachmentId) {
    return /*#__PURE__*/React__namespace.default.createElement(ExpandableImage, {
      key: attachmentId,
      attachmentId: attachmentId,
      style: style,
      shouldShowExpandIcon: true
    });
  })));
}
MultiAttachmentPreviewModal.propTypes = {
  isOpen: propTypesExports.bool.isRequired,
  onClose: propTypesExports.func.isRequired,
  style: propTypesExports.object,
  attachmentIdList: propTypesExports.array
};
var Container$5 = styled__default.default(Box$1)(function (_ref2) {
  var theme = _ref2.theme;
  return _defineProperty({
    display: "grid",
    gridTemplateColumns: "1fr 1fr",
    gridGap: "20px",
    padding: "20px"
  }, theme.breakpoints.down("md"), {
    gridTemplateColumns: "1fr"
  });
});
var Header = styled__default.default(Box$1)({
  display: "flex",
  alignItems: "center",
  marginBottom: "20px",
  marginLeft: "20px"
});

var IMAGES_TO_DISPLAY = 4;
var SKELETON_PROPS = {
  width: "100%",
  height: "100%"
};
function ExpandableImageStack(_ref) {
  var attachmentIdList = _ref.attachmentIdList,
    title = _ref.title,
    caption = _ref.caption;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isImageDetailsModalOpen = _useState2[0],
    setIsImageDetailsModalOpen = _useState2[1];
  var styles = getStyles$1();
  if (!(attachmentIdList !== null && attachmentIdList !== void 0 && attachmentIdList.length)) return null;
  var viewableattachmentIdList = attachmentIdList.slice(0, IMAGES_TO_DISPLAY);
  var imagesLabel = getImagesLabel(attachmentIdList);
  var openDetailsModal = function openDetailsModal() {
    return setIsImageDetailsModalOpen(true);
  };
  return /*#__PURE__*/React__namespace.default.createElement(ExpandableImageContainer, {
    title: title,
    caption: caption,
    attachmentId: "test",
    isOpen: isImageDetailsModalOpen,
    style: styles.image
  }, /*#__PURE__*/React__namespace.default.createElement(IconTextButton, {
    label: imagesLabel,
    onClick: openDetailsModal,
    Icon: default_1$4
  }), /*#__PURE__*/React__namespace.default.createElement(StackedImageContainer, null, viewableattachmentIdList.map(function (attachmentId, idx) {
    var containerStyle = getPreviewContainerStyle({
      idx: idx,
      arrayLength: attachmentIdList.length
    });
    return /*#__PURE__*/React__namespace.default.createElement(StyledAttachmentImage, {
      key: attachmentId,
      attachmentId: attachmentId,
      containerStyle: containerStyle,
      PreviewIcon: idx === 0 ? ExpandIcon : null,
      onClick: openDetailsModal,
      skeletonProps: SKELETON_PROPS
    });
  })), /*#__PURE__*/React__namespace.default.createElement(MultiAttachmentPreviewModal, {
    isOpen: isImageDetailsModalOpen,
    onClose: function onClose() {
      return setIsImageDetailsModalOpen(false);
    },
    attachmentIdList: attachmentIdList,
    style: styles.image
  }));
}
ExpandableImageStack.propTypes = {
  attachmentIdList: propTypesExports.array,
  title: propTypesExports.string,
  caption: propTypesExports.string
};
var StackedImageContainer = styled__default.default(Box$1)({
  height: "200px",
  position: "relative"
});
function getImagesLabel(attachmentIdList) {
  return "".concat(attachmentIdList.length, " images");
}
function getPreviewContainerStyle(_ref2) {
  var idx = _ref2.idx,
    arrayLength = _ref2.arrayLength;
  return _objectSpread2({
    width: "80%",
    height: "100%",
    borderRadius: "10px",
    objectFit: "cover",
    position: "relative",
    // order the images in the stack
    zIndex: arrayLength - idx
  }, idx > 0 && {
    position: "absolute",
    top: "50%",
    // move each image slightly to the right of the first image
    left: "".concat(6 * idx, "%"),
    // center veritically
    // scale each image down by 10% to create a background affect
    transform: "translate(0, -50%) scale(".concat(1 - idx / 10, ")"),
    // make each image darker to simulate them being farther away
    filter: "brightness(".concat(100 - idx * 25, "%)")
  });
}
var StyledAttachmentImage = styled__default.default(AttachmentPreview)({
  width: "100%",
  height: "100%",
  objectFit: "cover"
});
function getStyles$1() {
  return {
    image: {
      maxWidth: "100%"
    }
  };
}

function Image$1(_ref) {
  var attachmentId = _ref.attachmentId,
    attachmentIdList = _ref.attachmentIdList,
    title = _ref.title,
    caption = _ref.caption;
  var commonProps = {
    title: title,
    caption: caption
  };
  if (attachmentId || (attachmentIdList === null || attachmentIdList === void 0 ? void 0 : attachmentIdList.length) === 1) {
    return /*#__PURE__*/React__namespace.default.createElement(ExpandableImage, _extends$2({
      attachmentId: attachmentId || attachmentIdList[0]
    }, commonProps));
  }
  return /*#__PURE__*/React__namespace.default.createElement(ExpandableImageStack, _extends$2({
    attachmentIdList: attachmentIdList
  }, commonProps));
}
Image$1.propTypes = {
  attachmentId: propTypesExports.string,
  attachmentIdList: propTypesExports.arrayOf(propTypesExports.string),
  title: propTypesExports.string,
  caption: propTypesExports.string
};

var Visibility = {};

var _interopRequireDefault$3 = interopRequireDefaultExports;
Object.defineProperty(Visibility, "__esModule", {
  value: true
});
var default_1$3 = Visibility.default = void 0;
var _createSvgIcon$3 = _interopRequireDefault$3(requireCreateSvgIcon());
var _jsxRuntime$3 = requireJsxRuntime();
var _default$3 = (0, _createSvgIcon$3.default)( /*#__PURE__*/(0, _jsxRuntime$3.jsx)("path", {
  d: "M12 4.5C7 4.5 2.73 7.61 1 12c1.73 4.39 6 7.5 11 7.5s9.27-3.11 11-7.5c-1.73-4.39-6-7.5-11-7.5zM12 17c-2.76 0-5-2.24-5-5s2.24-5 5-5 5 2.24 5 5-2.24 5-5 5zm0-8c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"
}), 'Visibility');
default_1$3 = Visibility.default = _default$3;

function Pdf(_ref) {
  var attachmentId = _ref.attachmentId;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isModalOpen = _useState2[0],
    setIsModalOpen = _useState2[1];
  var _useUtils = useUtils(),
    useAttachmentImage = _useUtils.useAttachmentImage;
  var _useAttachmentImage = useAttachmentImage({
      attachmentId: attachmentId
    }),
    remoteUrl = _useAttachmentImage.remoteUrl,
    isLoading = _useAttachmentImage.isLoading;
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(Container$4, {
    "data-testid": TEST_IDS.PDF_CONTENT_BLOCK,
    onClick: function onClick() {
      return setIsModalOpen(true);
    }
  }, /*#__PURE__*/React__namespace.default.createElement(PdfPreview, {
    url: remoteUrl,
    isLoading: isLoading,
    width: 240,
    height: 180
  }), /*#__PURE__*/React__namespace.default.createElement(ViewIcon, null)), /*#__PURE__*/React__namespace.default.createElement(AttachmentPreviewModal, {
    isOpen: isModalOpen,
    onClose: function onClose() {
      return setIsModalOpen(false);
    },
    attachmentId: attachmentId,
    isPdf: true
  }));
}
Pdf.propTypes = {
  attachmentId: propTypesExports.string
};
var Container$4 = styled__default.default(Box$1)({
  position: "relative",
  maxHeight: "180px",
  overflow: "hidden",
  alignSelf: "flex-start",
  cursor: "pointer"
});
var ViewIcon = styled__default.default(default_1$3)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    position: "absolute",
    top: "10px",
    right: "10px",
    color: theme.palette.colors.icon.neutral,
    backgroundColor: theme.palette.colors.icon.neutralContrast,
    borderRadius: "50%",
    padding: "4px",
    fontSize: "25px"
  };
});

var DirectionsCar = {};

var _interopRequireDefault$2 = interopRequireDefaultExports;
Object.defineProperty(DirectionsCar, "__esModule", {
  value: true
});
var default_1$2 = DirectionsCar.default = void 0;
var _createSvgIcon$2 = _interopRequireDefault$2(requireCreateSvgIcon());
var _jsxRuntime$2 = requireJsxRuntime();
var _default$2 = (0, _createSvgIcon$2.default)( /*#__PURE__*/(0, _jsxRuntime$2.jsx)("path", {
  d: "M18.92 6.01C18.72 5.42 18.16 5 17.5 5h-11c-.66 0-1.21.42-1.42 1.01L3 12v8c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-1h12v1c0 .55.45 1 1 1h1c.55 0 1-.45 1-1v-8l-2.08-5.99zM6.5 16c-.83 0-1.5-.67-1.5-1.5S5.67 13 6.5 13s1.5.67 1.5 1.5S7.33 16 6.5 16zm11 0c-.83 0-1.5-.67-1.5-1.5s.67-1.5 1.5-1.5 1.5.67 1.5 1.5-.67 1.5-1.5 1.5zM5 11l1.5-4.5h11L19 11H5z"
}), 'DirectionsCar');
default_1$2 = DirectionsCar.default = _default$2;

var LocalPhone = {};

var _interopRequireDefault$1 = interopRequireDefaultExports;
Object.defineProperty(LocalPhone, "__esModule", {
  value: true
});
var default_1$1 = LocalPhone.default = void 0;
var _createSvgIcon$1 = _interopRequireDefault$1(requireCreateSvgIcon());
var _jsxRuntime$1 = requireJsxRuntime();
var _default$1 = (0, _createSvgIcon$1.default)( /*#__PURE__*/(0, _jsxRuntime$1.jsx)("path", {
  d: "M6.62 10.79c1.44 2.83 3.76 5.14 6.59 6.59l2.2-2.2c.27-.27.67-.36 1.02-.24 1.12.37 2.33.57 3.57.57.55 0 1 .45 1 1V20c0 .55-.45 1-1 1-9.39 0-17-7.61-17-17 0-.55.45-1 1-1h3.5c.55 0 1 .45 1 1 0 1.25.2 2.45.57 3.57.11.35.03.74-.25 1.02l-2.2 2.2z"
}), 'LocalPhone');
default_1$1 = LocalPhone.default = _default$1;

var ICON_FILL_COLOR = "white";
function Url(_ref) {
  var icon = _ref.icon,
    link = _ref.link,
    content = _ref.content,
    color = _ref.color,
    isPhoneUrl = _ref.isPhoneUrl;
  var avatarStyle = {
    margin: 0,
    width: "32px",
    height: "32px"
  };
  var additionalProps = getAdditionalProps({
    isPhoneUrl: isPhoneUrl
  });
  return /*#__PURE__*/React__namespace.default.createElement(Chip$1, _extends$2({
    avatar: getIcon({
      icon: icon,
      color: color
    }),
    href: getFormattedLink({
      isPhoneUrl: isPhoneUrl,
      link: link
    }),
    target: "_blank",
    component: "a",
    clickable: true,
    label: content,
    sx: {
      width: "fit-content",
      "& .MuiChip-avatar": avatarStyle,
      margin: "3px",
      fontSize: 14
    },
    "data-testid": TEST_IDS.URL
  }, additionalProps));
}
Url.propTypes = {
  icon: propTypesExports.string,
  link: propTypesExports.string,
  content: propTypesExports.string,
  color: propTypesExports.string,
  isPhoneUrl: propTypesExports.bool
};

// exported for tests
function getFormattedLink(_ref2) {
  var link = _ref2.link,
    isPhoneUrl = _ref2.isPhoneUrl;
  if (isPhoneUrl) return "tel:".concat(link);
  if (!link.startsWith("http")) return "https://".concat(link);
  return link;
}

// exported for tests
function getAdditionalProps(_ref3) {
  var isPhoneUrl = _ref3.isPhoneUrl;
  return _objectSpread2({}, isPhoneUrl && {
    target: "_self"
  });
}
function getIcon(_ref4) {
  var icon = _ref4.icon,
    color = _ref4.color;
  // sx fill is necessary to change icons color
  var iconMap = {
    phone: /*#__PURE__*/React__namespace.default.createElement(Avatar$2, {
      sx: {
        bgcolor: color || green$1[500]
      }
    }, /*#__PURE__*/React__namespace.default.createElement(default_1$1, {
      sx: {
        fill: ICON_FILL_COLOR
      },
      "data-testid": TEST_IDS.URL_ICON
    })),
    car: /*#__PURE__*/React__namespace.default.createElement(Avatar$2, {
      sx: {
        bgcolor: color || blue$1[500]
      }
    }, /*#__PURE__*/React__namespace.default.createElement(default_1$2, {
      sx: {
        fill: ICON_FILL_COLOR
      }
    }))
  };
  return iconMap[icon];
}

function Pills(_ref) {
  var pills = _ref.pills,
    isUrlPill = _ref.isUrlPill,
    isPhoneUrl = _ref.isPhoneUrl;
  var theme = useTheme$1();
  return /*#__PURE__*/React__namespace.default.createElement(PillsContainer$1, null, pills.map(function (pill, idx) {
    return isUrlPill ? /*#__PURE__*/React__namespace.default.createElement(Url, {
      key: "pill_".concat(idx),
      isPhoneUrl: isPhoneUrl,
      link: pill.url,
      content: pill.content,
      icon: pill.icon,
      color: pill.color
    }) : /*#__PURE__*/React__namespace.default.createElement(Chip$1, {
      sx: getTagStyles({
        color: pill.color,
        theme: theme
      }),
      key: "tag_".concat(idx),
      label: pill.content,
      "data-testid": TEST_IDS.PILLS
    });
  }));
}
Pills.propTypes = {
  pills: propTypesExports.arrayOf(propTypesExports.shape({
    text: propTypesExports.string,
    color: propTypesExports.string,
    url: propTypesExports.string,
    icon: propTypesExports.string
  })),
  isUrlPill: propTypesExports.bool,
  isPhoneUrl: propTypesExports.bool
};
function getTagStyles(_ref2) {
  var color = _ref2.color,
    theme = _ref2.theme;
  return {
    fontSize: 14,
    backgroundColor: color,
    color: theme.palette.text.tags
  };
}
var PillsContainer$1 = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    gap: "5px",
    flexWrap: "wrap"
  };
});

function Markdown(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React__namespace.default.createElement(StyledMarkdown, {
    linkTarget: "_blank",
    remarkPlugins: [remarkBreaks__default.default, remarkGfm__default.default]
  }, children);
}
Markdown.propTypes = {
  children: propTypesExports.node.isRequired
};
var StyledMarkdown = styled__default.default(ReactMarkdown__default.default)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    "& a": {
      color: theme.palette.primary.main
    }
  };
});

function Text(_ref) {
  var content = _ref.content;
  return /*#__PURE__*/React__namespace.default.createElement(TextContainer, {
    "data-testid": TEST_IDS.TEXT
  }, /*#__PURE__*/React__namespace.default.createElement(Markdown, null, content));
}
Text.propTypes = {
  content: propTypesExports.string
};
var TextContainer = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    gap: "5px"
  };
});

function Video(_ref) {
  var url = _ref.url,
    title = _ref.title,
    caption = _ref.caption;
  return /*#__PURE__*/React__namespace.default.createElement(Box$1, null, title && /*#__PURE__*/React__namespace.default.createElement(InputTitle, null, title), /*#__PURE__*/React__namespace.default.createElement(VideoContainer, {
    "data-testid": TEST_IDS.VIDEO
  }, /*#__PURE__*/React__namespace.default.createElement(ReactPlayer__default.default, {
    url: url,
    controls: true,
    width: "100%",
    height: "200px"
  })), caption && /*#__PURE__*/React__namespace.default.createElement(InputCaption, null, caption));
}
Video.propTypes = {
  url: propTypesExports.string,
  title: propTypesExports.string,
  caption: propTypesExports.string
};
var VideoContainer = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    gap: "5px"
  };
});
var InputCaption = styled__default.default(material.Typography)(function () {
  return {
    marginTop: "1rem"
  };
});

function ContentBlockView(_ref) {
  var type = _ref.type,
    title = _ref.title,
    content = _ref.content,
    url = _ref.url,
    icon = _ref.icon,
    color = _ref.color,
    pills = _ref.pills,
    urlList = _ref.url_list,
    form = _ref.form;
  var ContentBlockComponent = getContentBlockComponent({
    type: type,
    title: title,
    content: content,
    url: url,
    icon: icon,
    color: color,
    pills: pills,
    urlList: urlList,
    form: form
  });
  return /*#__PURE__*/React__namespace.default.createElement(Container$3, null, ContentBlockComponent);
}
ContentBlockView.propTypes = {
  type: propTypesExports.oneOf(Object.values(CONTENT_BLOCK_TYPES)).isRequired,
  title: propTypesExports.string,
  content: propTypesExports.string,
  url: propTypesExports.string,
  url_list: propTypesExports.array,
  icon: propTypesExports.oneOf(Object.values(CONTENT_BLOCK_ICONS)),
  color: propTypesExports.string,
  pills: propTypesExports.arrayOf(propTypesExports.shape({
    content: propTypesExports.string.isRequired
  })),
  form: propTypesExports.object
};
var Container$3 = styled__default.default(Box$1)({
  display: "flex",
  flexDirection: "column",
  margin: "10px 0"
});

// exported for tests
function getContentBlockComponent(_ref2) {
  var type = _ref2.type,
    title = _ref2.title,
    content = _ref2.content,
    url = _ref2.url,
    urlList = _ref2.urlList,
    pills = _ref2.pills,
    form = _ref2.form;
  switch (type) {
    case CONTENT_BLOCK_TYPES.BANNER:
      return /*#__PURE__*/React__namespace.default.createElement(Banner, {
        title: title,
        content: content,
        url: url
      });
    case CONTENT_BLOCK_TYPES.TEXT:
      return /*#__PURE__*/React__namespace.default.createElement(Text, {
        content: content
      });
    case CONTENT_BLOCK_TYPES.TAGS:
      return /*#__PURE__*/React__namespace.default.createElement(Pills, {
        pills: pills
      });
    case CONTENT_BLOCK_TYPES.ADDRESS:
      return /*#__PURE__*/React__namespace.default.createElement(Pills, {
        pills: pills,
        isUrlPill: true
      });
    case CONTENT_BLOCK_TYPES.CONTACT:
      return /*#__PURE__*/React__namespace.default.createElement(Pills, {
        pills: pills,
        isUrlPill: true,
        isPhoneUrl: true
      });
    case CONTENT_BLOCK_TYPES.VIDEO:
      return /*#__PURE__*/React__namespace.default.createElement(Video, {
        url: url,
        title: title,
        caption: content
      });
    case CONTENT_BLOCK_TYPES.IMAGE:
      return /*#__PURE__*/React__namespace.default.createElement(Image$1, {
        attachmentId: url,
        attachmentIdList: urlList,
        title: title,
        caption: content
      });
    case CONTENT_BLOCK_TYPES.PDF:
      return /*#__PURE__*/React__namespace.default.createElement(Pdf, {
        attachmentId: url
      });
    case CONTENT_BLOCK_TYPES.FORM:
      return /*#__PURE__*/React__namespace.default.createElement(Form, {
        form: form
      });
    default:
      return null;
  }
}

function ContentSection(_ref) {
  var title = _ref.title,
    blocks = _ref.blocks;
  return /*#__PURE__*/React__namespace.default.createElement(Container$2, null, /*#__PURE__*/React__namespace.default.createElement(SectionTitle, null, title), blocks.map(function (block, idx) {
    return /*#__PURE__*/React__namespace.default.createElement(ContentBlockView, _extends$2({}, block, {
      key: "content_block_".concat(idx)
    }));
  }));
}
ContentSection.propTypes = {
  title: propTypesExports.string,
  blocks: propTypesExports.array
};
var SectionTitle = styled__default.default(Typography$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    color: theme.palette.text.primary,
    margin: 0,
    fontSize: theme.typography.h5.fontSize,
    fontWeight: theme.typography.h5.fontWeight
  };
});
var Container$2 = styled__default.default(Box$1)(function (_ref3) {
  var _ref4;
  var theme = _ref3.theme;
  return _ref4 = {
    display: "flex",
    flexDirection: "column",
    breakInside: "avoid",
    padding: "10px 20px",
    margin: "10px 0px"
  }, _defineProperty(_ref4, theme.breakpoints.down("md"), {
    height: "100%",
    width: "100%",
    padding: "10px 10px",
    margin: "5px 0px"
  }), _defineProperty(_ref4, "borderRadius", theme.borderRadius.lg), _defineProperty(_ref4, "backgroundColor", theme.palette.card.background), _defineProperty(_ref4, "boxShadow", theme.boxShadow), _ref4;
});

function ContentSectionsMenu(_ref) {
  var menuConfigs = _ref.menuConfigs,
    isLoading = _ref.isLoading;
  var _useState = React.useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isConfirmationModalOpen = _useState2[0],
    setIsConfirmationModalOpen = _useState2[1];
  var onEditClick = menuConfigs.onEditClick,
    onDeleteClick = menuConfigs.onDeleteClick,
    contentName = menuConfigs.contentName,
    contentBlockId = menuConfigs.contentBlockId;
  var modalMessage = "Are you sure you want to delete card ".concat(contentName);
  return /*#__PURE__*/React__namespace.default.createElement(React__namespace.default.Fragment, null, /*#__PURE__*/React__namespace.default.createElement(ActionableButton, {
    isSmall: true,
    icon: /*#__PURE__*/React__namespace.default.createElement(default_1$E, null),
    isLoading: isLoading,
    actions: getActions({
      onEditClick: onEditClick,
      setIsConfirmationModalOpen: setIsConfirmationModalOpen
    })
  }), /*#__PURE__*/React__namespace.default.createElement(ConfirmationModal, {
    isLoading: isLoading,
    isOpen: isConfirmationModalOpen,
    onClose: function onClose() {
      return setIsConfirmationModalOpen(false);
    },
    message: modalMessage,
    onConfirmation: function onConfirmation() {
      return onDeleteClick({
        id: contentBlockId,
        onCompleted: function onCompleted() {
          return setIsConfirmationModalOpen(false);
        }
      });
    },
    confirmationButtonLabel: "Delete"
  }));
}
ContentSectionsMenu.propTypes = {
  isLoading: propTypesExports.bool,
  menuConfigs: propTypesExports.object
};
function getActions(_ref2) {
  var onEditClick = _ref2.onEditClick,
    setIsConfirmationModalOpen = _ref2.setIsConfirmationModalOpen;
  return [{
    name: "Edit",
    onClick: onEditClick
  }, {
    name: "Delete",
    onClick: function onClick() {
      return setIsConfirmationModalOpen(true);
    }
  }];
}

function ContentSectionSkeleton(_ref) {
  var _ref$pillCount = _ref.pillCount,
    pillCount = _ref$pillCount === void 0 ? 9 : _ref$pillCount;
  var styles = getStyles();
  return /*#__PURE__*/React__namespace.default.createElement(Container$1, null, /*#__PURE__*/React__namespace.default.createElement(SectionColumn, null, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    style: styles.sectionTitle,
    isRounded: true
  }), /*#__PURE__*/React__namespace.default.createElement(SectionRow, null, /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    style: styles.banner,
    isRounded: true
  }), /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    style: styles.banner,
    isRounded: true
  })), /*#__PURE__*/React__namespace.default.createElement(SectionRow, null, /*#__PURE__*/React__namespace.default.createElement(PillsContainer, null, /*#__PURE__*/React__namespace.default.createElement(SkeletonList, {
    count: pillCount,
    SkeletonComponent: function SkeletonComponent() {
      return /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
        style: styles.pill,
        isRounded: true
      });
    },
    isLoading: true
  })), /*#__PURE__*/React__namespace.default.createElement(Skeleton, {
    style: styles.banner,
    isRounded: true
  }))));
}
ContentSectionSkeleton.propTypes = {
  pillCount: propTypesExports.number
};
function getStyles() {
  return {
    sectionTitle: {
      width: "35%",
      height: "5rem",
      marginLeft: "1rem"
    },
    banner: {
      width: "50%",
      minHeight: "7rem",
      marginLeft: "1rem",
      marginRight: "1rem"
    },
    pill: {
      width: "15%",
      height: "40px",
      margin: "0 5px"
    },
    image: {
      width: "50%",
      minHeight: "12rem",
      marginLeft: "1rem",
      marginRight: "1rem"
    }
  };
}
var Container$1 = styled__default.default(Box$1)(function () {
  return {
    display: "flex"
  };
});
var SectionColumn = styled__default.default(Box$1)(function () {
  return {
    flex: 1,
    flexDirection: "column"
  };
});
var SectionRow = styled__default.default(Box$1)(function () {
  return {
    display: "flex",
    flexDirection: "row"
  };
});
var PillsContainer = styled__default.default(Box$1)(function () {
  return {
    width: "50%",
    display: "flex",
    flexDirection: "row",
    flexWrap: "wrap",
    marginLeft: "1rem",
    marginRight: "1rem"
  };
});

function ContentSectionsSkeleton(_ref) {
  var _ref$sectionCount = _ref.sectionCount,
    sectionCount = _ref$sectionCount === void 0 ? 2 : _ref$sectionCount,
    pillCount = _ref.pillCount;
  return /*#__PURE__*/React__namespace.default.createElement(Box$1, {
    "data-testid": TEST_IDS.CONTENT_SECTIONS_SKELETON
  }, _toConsumableArray(Array(sectionCount)).map(function (_, skeletonIndx) {
    return /*#__PURE__*/React__namespace.default.createElement(ContentSectionsSkeletonContainer, {
      key: skeletonIndx
    }, /*#__PURE__*/React__namespace.default.createElement(ContentSectionSkeleton, {
      pillCount: pillCount
    }));
  }));
}
ContentSectionsSkeleton.propTypes = {
  sectionCount: propTypesExports.number,
  pillCount: propTypesExports.number
};
var ContentSectionsSkeletonContainer = styled__default.default(Card$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: "flex",
    flexDirection: "column",
    borderColor: theme.palette.colors.border.secondary,
    backgroundColor: theme.palette.card.background,
    width: "100%",
    borderRadius: 15,
    minHeight: "20rem",
    marginBottom: "3rem"
  };
});

function ContentSections(_ref) {
  var data = _ref.data,
    menuConfigs = _ref.menuConfigs,
    isCollapsible = _ref.isCollapsible,
    _ref$isOpenInitially = _ref.isOpenInitially,
    isOpenInitially = _ref$isOpenInitially === void 0 ? false : _ref$isOpenInitially,
    error = _ref.error,
    isLoading = _ref.isLoading,
    sectionSkeletonCount = _ref.sectionSkeletonCount,
    dragHandleProps = _ref.dragHandleProps,
    shouldShowDragIcon = _ref.shouldShowDragIcon;
  var hasHandle = !!dragHandleProps;
  if (isLoading) {
    return /*#__PURE__*/React__namespace.default.createElement(ContentSectionsSkeleton, {
      sectionCount: sectionSkeletonCount
    });
  }
  if (error) return /*#__PURE__*/React__namespace.default.createElement(ErrorMessage, {
    error: error
  });
  return /*#__PURE__*/React__namespace.default.createElement(CollapsibleProvider, {
    isOpenInitially: isOpenInitially
  }, /*#__PURE__*/React__namespace.default.createElement(Container, null, /*#__PURE__*/React__namespace.default.createElement(HeaderBox, {
    hasHandle: hasHandle
  }, /*#__PURE__*/React__namespace.default.createElement(HeaderTitle, {
    variant: "h4"
  }, data.name), /*#__PURE__*/React__namespace.default.createElement(ActionsBox, {
    hasHandle: hasHandle
  }, dragHandleProps && /*#__PURE__*/React__namespace.default.createElement(DragBox, _extends$2({}, dragHandleProps, {
    "data-testid": TEST_IDS.CONTENT_SECTIONS_DRAG_HANDLE
  }), shouldShowDragIcon && /*#__PURE__*/React__namespace.default.createElement(default_1$l, null)), /*#__PURE__*/React__namespace.default.createElement(Box$1, null, !!menuConfigs && /*#__PURE__*/React__namespace.default.createElement(ContentSectionsMenu, {
    isLoading: isLoading,
    menuConfigs: menuConfigs
  }), isCollapsible && /*#__PURE__*/React__namespace.default.createElement(CollapsibleExpandButton, null)))), /*#__PURE__*/React__namespace.default.createElement(DynamicCollapsibleBox, {
    isCollapsible: isCollapsible
  }, /*#__PURE__*/React__namespace.default.createElement(ContentSectionsContainer, null, data.sections.map(function (section, idx) {
    return /*#__PURE__*/React__namespace.default.createElement(ContentSection, _extends$2({}, section, {
      key: "content_section_".concat(idx)
    }));
  })))));
}

// TODO: add and pass down userAttachmentImageHook and clear errors in storybook https://gitlab.com/revved/boomnation/lib-web-common/-/issues/50
ContentSections.propTypes = {
  data: propTypesExports.shape({
    name: propTypesExports.string,
    sections: propTypesExports.array
  }),
  menuConfigs: propTypesExports.shape({
    onEditClick: propTypesExports.func.isRequired,
    onDeleteClick: propTypesExports.func.isRequired,
    contentName: propTypesExports.string.isRequired,
    contentBlockId: propTypesExports.string.isRequired
  }),
  error: propTypesExports.object,
  isLoading: propTypesExports.bool,
  skeletonHeight: propTypesExports.oneOf([propTypesExports.string, propTypesExports.number]),
  sectionSkeletonCount: propTypesExports.number,
  isCollapsible: propTypesExports.bool,
  isOpenInitially: propTypesExports.bool,
  dragHandleProps: propTypesExports.object,
  shouldShowDragIcon: propTypesExports.bool
};
var Container = styled__default.default(Paper$1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    display: "flex",
    flexDirection: "column",
    width: "100%",
    borderRadius: theme.borderRadius.lg,
    backgroundColor: theme.palette.card.background,
    boxShadow: theme.boxShadow
  };
});
var ContentSectionsContainer = styled__default.default(Box$1)(function (_ref3) {
  var theme = _ref3.theme;
  return _defineProperty({
    columns: 2,
    width: "100%",
    borderRadius: theme.borderRadius.lg,
    backgroundColor: theme.palette.card.background,
    boxShadow: theme.boxShadow
  }, theme.breakpoints.down("md"), {
    columns: 1
  });
});
var HeaderBox = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref5) {
  var _ref6;
  var theme = _ref5.theme,
    hasHandle = _ref5.hasHandle;
  return _ref6 = {
    width: "100%",
    display: "flex",
    padding: "10px 20px",
    margin: "10px 0px",
    alignItems: "center"
  }, _defineProperty(_ref6, theme.breakpoints.down("md"), {
    padding: "10px 10px",
    margin: "5px 0px"
  }), _defineProperty(_ref6, theme.breakpoints.down("sm"), {
    flexDirection: hasHandle ? "column-reverse" : "row",
    justifyContent: "space-between"
  }), _defineProperty(_ref6, "borderRadius", theme.borderRadius.lg), _defineProperty(_ref6, "backgroundColor", theme.palette.card.background), _defineProperty(_ref6, "boxShadow", theme.boxShadow), _ref6;
});
var ActionsBox = styled__default.default(Box$1, {
  shouldForwardProp: isPropValid__default.default
})(function (_ref7) {
  var theme = _ref7.theme,
    hasHandle = _ref7.hasHandle;
  return _defineProperty({
    display: "flex",
    flexDirection: "row",
    width: "50%",
    justifyContent: hasHandle ? "space-between" : "flex-end"
  }, theme.breakpoints.down("sm"), {
    width: hasHandle ? "100%" : "50%"
  });
});
var HeaderTitle = styled__default.default(Typography$1)(function (_ref9) {
  var theme = _ref9.theme;
  return _defineProperty({
    width: "50%"
  }, theme.breakpoints.down("sm"), {
    width: "auto"
  });
});
var DragBox = styled__default.default(Box$1)({
  transform: "rotate(90deg)",
  margin: 0
});

function ContentSectionsGroup(_ref) {
  var contentBlocks = _ref.contentBlocks,
    entityId = _ref.entityId,
    entityType = _ref.entityType,
    companyId = _ref.companyId,
    updateContentBlockPosition = _ref.updateContentBlockPosition,
    goToEditContentBlock = _ref.goToEditContentBlock,
    deleteContentBlock = _ref.deleteContentBlock,
    hasMenuConfigs = _ref.hasMenuConfigs,
    isLoading = _ref.isLoading,
    _ref$sectionSkeletonC = _ref.sectionSkeletonCount,
    sectionSkeletonCount = _ref$sectionSkeletonC === void 0 ? 2 : _ref$sectionSkeletonC;
  var _useState = React.useState(contentBlocks),
    _useState2 = _slicedToArray(_useState, 2),
    sections = _useState2[0],
    setSections = _useState2[1];
  React.useEffect(function () {
    // if changes to cache occur, update
    if (contentBlocks !== sections) {
      setSections(contentBlocks);
    }
  }, [contentBlocks]);
  if (isLoading) {
    return /*#__PURE__*/React__namespace.default.createElement(ContentSectionsSkeleton, {
      sectionCount: sectionSkeletonCount
    });
  }
  return /*#__PURE__*/React__namespace.default.createElement(DragAndDropContainer, {
    items: sections,
    moveItem: function moveItem(values) {
      _moveItem(_objectSpread2({
        entityId: entityId,
        entityType: entityType,
        updateContentBlockPosition: updateContentBlockPosition,
        setSections: setSections
      }, values));
    },
    ItemComponent: ContentSections,
    getItemProps: function getItemProps(values) {
      return getSectionProps(_objectSpread2({
        entityId: entityId,
        entityType: entityType,
        companyId: companyId,
        hasMenuConfigs: hasMenuConfigs,
        goToEditContentBlock: goToEditContentBlock,
        deleteContentBlock: deleteContentBlock,
        isLoading: isLoading,
        sections: sections,
        sectionSkeletonCount: sectionSkeletonCount
      }, values));
    },
    shouldUseCustomDragHandle: true,
    droppableId: CONTENT_SECTIONS_DROPPABLE_ID
  });
}
ContentSectionsGroup.propTypes = {
  contentBlocks: propTypesExports.arrayOf(propTypesExports.object).isRequired,
  entityId: propTypesExports.string.isRequired,
  entityType: propTypesExports.string.isRequired,
  companyId: propTypesExports.string,
  updateContentBlockPosition: propTypesExports.func,
  goToEditContentBlock: propTypesExports.func,
  deleteContentBlock: propTypesExports.func,
  hasMenuConfigs: propTypesExports.bool,
  isLoading: propTypesExports.bool,
  sectionSkeletonCount: propTypesExports.number
};
function getSectionProps(_ref2) {
  var entityId = _ref2.entityId,
    entityType = _ref2.entityType,
    companyId = _ref2.companyId,
    hasMenuConfigs = _ref2.hasMenuConfigs,
    goToEditContentBlock = _ref2.goToEditContentBlock,
    deleteContentBlock = _ref2.deleteContentBlock,
    isLoading = _ref2.isLoading,
    sections = _ref2.sections,
    item = _ref2.item,
    dragHandleProps = _ref2.dragHandleProps,
    sectionSkeletonCount = _ref2.sectionSkeletonCount;
  // first item in list initally open
  var isOpenInitially = sections[0].id === item.id;
  return _objectSpread2(_objectSpread2({
    data: item,
    menuConfigs: hasMenuConfigs && getCardMenuConfigs({
      entityId: entityId,
      entityType: entityType,
      companyId: companyId,
      goToEditContentBlock: goToEditContentBlock,
      deleteContentBlock: deleteContentBlock,
      name: item.name,
      contentBlockId: item.id
    }),
    isCollapsible: true,
    isOpenInitially: isOpenInitially,
    sectionSkeletonCount: sectionSkeletonCount,
    isLoading: isLoading
  }, sections.length > 1 && {
    shouldShowDragIcon: true
  }), {}, {
    dragHandleProps: dragHandleProps
  });
}
function getCardMenuConfigs(_ref3) {
  var entityId = _ref3.entityId,
    entityType = _ref3.entityType,
    companyId = _ref3.companyId,
    goToEditContentBlock = _ref3.goToEditContentBlock,
    contentBlockId = _ref3.contentBlockId,
    deleteContentBlock = _ref3.deleteContentBlock,
    name = _ref3.name;
  return {
    onEditClick: function onEditClick() {
      return goToEditContentBlock({
        contentBlockId: contentBlockId,
        entityId: entityId,
        entityType: entityType,
        companyId: companyId
      });
    },
    onDeleteClick: deleteContentBlock,
    contentName: name,
    contentBlockId: contentBlockId
  };
}
function _moveItem(_ref4) {
  var entityId = _ref4.entityId,
    entityType = _ref4.entityType,
    id = _ref4.id,
    toIndex = _ref4.toIndex,
    fromIndex = _ref4.fromIndex,
    updateContentBlockPosition = _ref4.updateContentBlockPosition,
    setSections = _ref4.setSections;
  setSections(function (sections) {
    return libCommon.moveItemInArray({
      array: sections,
      item: sections[fromIndex],
      position: toIndex
    });
  });
  updateContentBlockPosition({
    entityId: entityId,
    entityType: entityType,
    id: id,
    position: toIndex,
    onError: function onError() {
      return onUpdatePositionError({
        setSections: setSections,
        id: id,
        toIndex: toIndex,
        fromIndex: fromIndex
      });
    }
  });
}

// revert sections back
function onUpdatePositionError(_ref5) {
  var setSections = _ref5.setSections,
    toIndex = _ref5.toIndex,
    fromIndex = _ref5.fromIndex;
  setSections(function (sections) {
    return libCommon.moveItemInArray({
      array: sections,
      item: sections[toIndex],
      position: fromIndex
    });
  });
}

var AddCircleOutlineOutlined = {};

var _interopRequireDefault = interopRequireDefaultExports;
Object.defineProperty(AddCircleOutlineOutlined, "__esModule", {
  value: true
});
var default_1 = AddCircleOutlineOutlined.default = void 0;
var _createSvgIcon = _interopRequireDefault(requireCreateSvgIcon());
var _jsxRuntime = requireJsxRuntime();
var _default = (0, _createSvgIcon.default)( /*#__PURE__*/(0, _jsxRuntime.jsx)("path", {
  d: "M13 7h-2v4H7v2h4v4h2v-4h4v-2h-4V7zm-1-5C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z"
}), 'AddCircleOutlineOutlined');
default_1 = AddCircleOutlineOutlined.default = _default;

var DESCRIPTION = "Add a Cover Image";
function CoverImageInputDescription() {
  return /*#__PURE__*/React__namespace.default.createElement(DescriptionContainer, null, /*#__PURE__*/React__namespace.default.createElement(AddIcon, null), /*#__PURE__*/React__namespace.default.createElement(TextDescription, null, DESCRIPTION));
}
var DescriptionContainer = styled__default.default(Box$3)(function () {
  return {
    display: "flex",
    flexDirection: "row",
    gap: "1rem",
    marginLeft: "2rem"
  };
});
var TextDescription = styled__default.default(material.Typography)(function (_ref) {
  var theme = _ref.theme;
  return {
    alignSelf: "center",
    color: theme.palette.text.secondary
  };
});
var AddIcon = styled__default.default(default_1)(function (_ref2) {
  var theme = _ref2.theme;
  return {
    fontSize: "40px",
    color: theme.palette.primary.main
  };
});

function CoverImageInputPreview(_ref) {
  var image = _ref.image;
  return /*#__PURE__*/React__namespace.default.createElement(ImageInputPreview, {
    image: image,
    DescriptionComponent: CoverImageInputDescription
  });
}
CoverImageInputPreview.propTypes = {
  image: propTypesExports.string
};

function MobileTabs(_ref) {
  var tabs = _ref.tabs,
    children = _ref.children;
  var _useScreenSize = useScreenSize(),
    isSmScreen = _useScreenSize.isSmScreen;
  return /*#__PURE__*/React__namespace.default.createElement(Tabs, {
    tabs: tabs,
    shouldDisableTabs: !isSmScreen
  }, children);
}
MobileTabs.propTypes = {
  tabs: propTypesExports.arrayOf(propTypesExports.string),
  children: propTypesExports.arrayOf(propTypesExports.any)
};

exports.ATTACHMENT_CONTENT_BLOCK_TYPES = ATTACHMENT_CONTENT_BLOCK_TYPES;
exports.ActionableButton = ActionableButton;
exports.AddButton = AddButton;
exports.AddressFormTextInput = AddressFormTextInput;
exports.AttachmentPreview = AttachmentPreview;
exports.AttachmentPreviewModal = AttachmentPreviewModal;
exports.Avatar = Avatar;
exports.BulletinBoard = BulletinBoard;
exports.BulletinBoardProvider = BulletinBoardProvider;
exports.Button = Button;
exports.CONTENT_BLOCK_TYPES = CONTENT_BLOCK_TYPES;
exports.CancelAndSaveButtons = CancelAndSaveButtons;
exports.CircledButtonIcon = CircledButtonIcon;
exports.CloseButton = CloseButton;
exports.CollapsibleText = CollapsibleText;
exports.ConfirmationModal = ConfirmationModal;
exports.ContentBlockForm = ContentBlockForm;
exports.ContentSections = ContentSections;
exports.ContentSectionsGroup = ContentSectionsGroup;
exports.ContentSectionsSkeleton = ContentSectionsSkeleton;
exports.CoverImageInputPreview = CoverImageInputPreview;
exports.DownloadButton = DownloadButton;
exports.ErrorMessage = ErrorMessage;
exports.FORM_ERROR = FORM_ERROR;
exports.FORM_INPUTS = FORM_INPUTS;
exports.FORM_VALIDATION_MODES = VALIDATION_MODES;
exports.Form = Form$1;
exports.FormSubmissionsProvider = FormSubmissionsProvider;
exports.FormTextInput = FormTextInput;
exports.FormsProvider = FormsProvider;
exports.FormsTable = FormsTable;
exports.FullWidthFormControl = FullWidthFormControl;
exports.IconTextButton = IconTextButton;
exports.ImageUploadInput = ImageUploadInput;
exports.InputErrorMessage = InputErrorMessage;
exports.LibWebCommonProviders = LibWebCommonProviders;
exports.MODAL_PADDING = MODAL_PADDING;
exports.MarkdownEditorInput = MarkdownEditorInput;
exports.MeasureWidth = MeasureWidth;
exports.MobileTabs = MobileTabs;
exports.MockedLibWebCommonProviders = MockedLibWebCommonProviders;
exports.Modal = Modal;
exports.PageSection = PageSection;
exports.Pdf = Pdf$1;
exports.PdfPreview = PdfPreview;
exports.Pill = Pill;
exports.ProgressSubmitButton = ProgressSubmitButton;
exports.RemoveButton = RemoveButton;
exports.RichTypography = RichTypography;
exports.SearchBar = SearchBar;
exports.SectionHeader = SectionHeader;
exports.Skeleton = Skeleton;
exports.SkeletonList = SkeletonList;
exports.StyledTextField = StyledTextField;
exports.THEME_MODES = THEME_MODES;
exports.Tab = Tab;
exports.Table = Table;
exports.Tabs = Tabs;
exports.TabsHeader = TabsHeader$1;
exports.ThemeProvider = ThemeProvider;
exports.UploadCameraIcon = UploadCameraIcon;
exports.VideoInput = VideoInput$1;
exports.VirtualizedList = VirtualizedList;
exports.cleanMarkdownString = cleanMarkdownString;
exports.convertEditorStateToMarkDown = convertEditorStateToMarkDown;
exports.getAddress = getAddress;
exports.getAddressMock = getAddressMock;
exports.getAutoCompleteAddressMockData = getAutoCompleteAddressMockData;
exports.usePlacesAutocomplete = usePlacesAutocomplete;
exports.usePlacesAutocompleteMock = usePlacesAutocompleteMock;
exports.useSnackBar = useSnackBar;
exports.useTheme = useTheme;
//# sourceMappingURL=index.js.map
